<?php // -*- coding:utf-8 -*-
// (c) Copyright 2002-2010 by authors of the Tiki Wiki/CMS/Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.
// $Id: get_strings.php 43650 2012-10-24 16:09:26Z changi67 $
// Parameters:

// lang=xx    : only translates language 'xx',
//              if not given all languages are translated

// comments   : generate all comments (equal to close&module)

// close      : look for similar strings that are already translated and
//              generate a comment if a 'match' is made

// module     : generate comments that describe in which .php and/or .tpl
//              module(s) a certain string was found (useful for checking
//              translations in context)

// patch      : looks for the file 'language.patch' in the same directory
//              as the corresponding language.php and overrides any strings
//              in language.php - good if a user does not agree with
//              some translations or if only changes are sent to the maintainer

// spelling   : generates a file 'spellcheck_me.txt' that contains the
//              words used in the translation. It is then easy to check this
//              file for spelling errors (corrections must be done in
//              'language.php, however)

// groupwrite : Sets the generated files permissions to allow the generated
//              language.php also be group writable. This is good for
//              translators if they do not have root access to tiki but
//              are in the same group as the webserver. Please remember
//              to have write access removed when translation is finished
//              for security reasons. (Run script again without this
//              parameter)

// Examples:
// http://www.neonchart.com/get_strings.php?lang=sv
// Will translate language 'sv' and (almost) avoiding comment generation

// http://www.neonchart.com/get_strings.php?lang=sv&comments
// Will translate language 'sv' and generate all possible comments.
// This is the most usefull mode when working on a translation.

// http://www.neonchart.com/get_strings.php?lang=sv&nohelp&nosections
// These options will only provide the minimal amout of comments.
// Usefull mode when preparing a translation for distribution.

// http://www.neonchart.com/get_strings.php?nohelp&nosections
// Prepare all languages for release


// ### Note for translators about translation of text ending with punctuation
// ###
// ### The current list of concerned punctuation can be found in 'lib/init/tra.php'
// ### On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// ### For clarity, we explain here only for colons: ':' but it is the same for the rest
// ###
// ### Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// ###
// ### Technical justification:
// ### If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// ### then Tiki tries to translate 'Login' and ':' separately.
// ### This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// ### and it still allows to translate ":" as "&nbsp;:" for languages that
// ### need it (like french)

$lang=Array(
// ### Start of unused words
// ### Please remove manually!
// ### N.B. Legitimate strings may be marked// ### as unused!
// ### Please see http://tiki.org/UnusedWords for further info
"-1d" => "-1d",
"+1d" => "+1d",
"-1m" => "-1m",
"+1m" => "+1m",
"-7d" => "-7d",
"+7d" => "+7d",
"a" => "a",
"Access HTML dump" => "Access HTML dump",
"Activs" => "Activitats",
"act status" => "Estat d'act.",
"Add all your site users to this newsletter (broadcast)" => "Afegeix tots els usuaris del teu lloc web a aquest butlletí (publicació)",
"Add Calendar Item" => "Afegeix un ítem al Calendari",
"Added users" => "Usuaris afegits",
"Add New Group" => "Afegeix un Nou Grup",
"Add or edit a category" => "Add or edit a category",
"Add or edit a task" => "Afegeix o edita una tasca",
"Add scaled images size X x Y" => "Afegeix imatges a escala tamany X x Y",
"Add users" => "Afegeix usuaris",
"admin charts tpl" => "administrar plantilla per a llistes ",
"Admin chat" => "Admin xat",
"Admin content" => "Administrar blocs de contingut",
"Admin content templates" => "Admin content templates",
"admin content templates tpl" => "administrar plantilla per als continguts de les plantilles",
"Admin Cookies" => "adminsitrar galetes",
"Admin Dirertory Sites" => "Admin Dirertory Sites",
"admin Drawings" => "administració de Dibuixos",
"AdminDSN" => "AdministrarDSN",
"admin DynamicContent" => "administrar Contigut dinàmic",
"admin ExternalWiki" => "administrar WikiExtern",
"admin featured links tpl" => "administra plantilla per a enllaços destacats",
"admin forums tpl" => "administra plantilla per a fòrums",
"admin groups tpl" => "administra plantilla per a grups",
"admin hotwords tpl" => "administra plantilla per a paraules clau ",
"Admin HTML page dynamic zones" => "Administra seccions dinàmiques",
"admin HtmlPages" => "administra les PàginesHtml",
"admin HtmlPages tpl" => "administra la plantilla per a pàginesHtml ",
"admin mailin tpl" => "admin mailin tpl",
"Admin->Modules" => "Administrar->mòduls",
"admin modules tpl" => "admin mòduls tpl",
"admin newsletters tpl" => "administrar plantilla per a butlletins",
"admin notifications tpl" => "xxx",
"admin polls tpl" => "administrar plantilla per a consultes",
"admin RSSmodules tpl" => "administrar plantilla per a mòdulsRSS ",
"Admin structures" => "Administrar estructures",
"admin structures tpl" => "administrar plantilla per a estructures",
"admin surveys tpl" => "administrar plantilla per a enquestes",
"admin topics tpl" => "administrar plantilla per a temes",
"admin users tpl" => "administrar plantilla per a usuaris",
"Allowed HTML:" => "HTML permès:",
"Allow smileys" => "Empra emoticons",
"Allow viewing HTML mails" => "Permet veure correus-e HTML",
"Allow viwing HTML mails?" => "Permetre visualitzar correus HTML?",
"Allow wiki markup" => "Permet sintaxi wiki",
"All pages" => "Totes les pàgines",
"All tasks" => "Totes les tasques",
"A new password has been sent " => "Una nova contrasenya ha estat enviada ",
"Anonymous users can edit pages" => "Usuaris anònims poden editar pàgines",
"Anonymous users cannot edit pages" => "Cal estar registrat per a accedir a aquesta pàgina",
"Append CSS file to feed urls" => "Adjunta arxiu CSS per a capturar url's",
"Archived page:" => "Pàgina arxivada:",
"Are you sure you want to delete this attachment?" => "Segur que vols eliminar aquest arxiu adjunt?",
"Are you sure you want to delete this calendar?" => "Segur que vols eliminar aquest calendari?",
"Are you sure you want to delete this category?" => "Segur que vols eliminar aquest categoria?",
"Are you sure you want to delete this channel?" => "Segur que vols eliminar aquest canal?",
"Are you sure you want to delete this comment?" => "Segur que vols eliminar aquest comentari?",
"Are you sure you want to delete this contact?" => "Segur que vols eliminar aquest contacte?",
"Are you sure you want to delete this cookie?" => "Segur que vols eliminar aquest galeta?",
"Are you sure you want to delete this copyright?" => "Segur que vols eliminar aquest copyright?",
"Are you sure you want to delete this directory?" => "Segur que vols eliminar aquest directori?",
"Are you sure you want to delete this drawing?" => "Segur que vols eliminar aquest dibuix?",
"Are you sure you want to delete this dsn?" => "Segur que vols eliminar aquest dsn?",
"Are you sure you want to delete this external wiki?" => "Segur que vols eliminar aquest wiki extern?",
"Are you sure you want to delete this file?" => "Segur que vols eliminar aquest arxiu?",
"Are you sure you want to delete this forum?" => "Segur que vols eliminar aquest fòrum?",
"Are you sure you want to delete this group?" => "Segur que vols eliminar aquest grup?",
"Are you sure you want to delete this hotword?" => "Segur que vols eliminar aquesta paraula calenta?",
"Are you sure you want to delete this HTML page?" => "Segur que vols eliminar aquesta pàgina HTML?",
"Are you sure you want to delete this menu?" => "Segur que vols eliminar aquest menu?",
"Are you sure you want to delete this repository?" => "Segur que vols esborrar aquest dipòsit?",
"Are you sure you want to delete this rule?" => "Segur que vols eliminar aquesta regla?",
"Are you sure you want to delete this template?" => "Segur que vols eliminar aquesta plantilla?",
"Are you sure you want to delete this tracker?" => "Segur que vols eliminar aquest formulari?",
"Articles listing configuration" => "Articles listing configuration",
"assgn" => "assignació",
"assigned" => "assignat",
"Assign Group (Active)" => "Assignar Grup(Actiu)",
"assign group" => "assigna grup",
"Assign permissions to thispage" => "Assigna permisos a aquesta pàgina",
"Assign permissions to this page" => "Assignar permisos a aquesta pàgina",
"assign_perms" => "assign_perms",
" at " => " un ",
"Automatic Page Breaks" => "Canvi de Pàgina Automàtic",
"Availible scales" => "Availible scales",
"Average posts pero weblog" => "Mitjana de publicacions per bitàcola web",
">Block description: " => ">Descripció del bloc:",
"Blog settings" => "Configuració de les bitàcoles",
"b" => "n",
"Bookmakrs" => "Adreces d'interès",
"browse by" => "browse by",
"Bye bye from " => "Adéu de part de ",
"by %s" => "by %s",
"Cache wiki pages" => "Cache wiki pages",
"Calendars Panel" => "Panell de Calendaris",
"Cannot get file from URL" => "No es pot obtenir l'arxiu a partir de la URL",
"categorize" => "categoritza",
"Category: wiki, tracker, etc." => "Category: wiki, tracker, etc.",
"center" => "centra",
"change email" => "canvia el correu-e",
"Change your email" => "Canvia el teu correu-e",
"chars" => "cars",
"ChatAdmin" => "Administració del Xat",
"ChatAdmin tpl" => "plantilla per a Administració del Xat",
"checked" => "marcat",
"choose" => "choose",
"Click here to configure this menu" => "Fes clic aquí per configurar aquest menú",
"Click here to create a new backup" => "Punxa aquí per crear una còpia de seguretat nova",
"Click here to delete this attachment" => "Clica aquí per eliminar aquest arxiu adjunt",
"Click here to delete this channel" => "Fes clic aquí per esborrar aquest canal",
"Click here to delete this comment" => "Clica aquí per editar aquest comentari",
"Click here to delete this contact" => "Clica aquí per eliminar aquest contacte",
"Click here to delete this cookie" => "Fes clic aquí per esborrar aquesta galeta (cookie)",
"Click here to delete this copyright" => "Fes clic aquí per esborrar aquest copyright",
"Click here to delete this drawing" => "Fes clic aquí per esborrar aquest dibuix",
"Click here to delete this menu" => "Fes clic aquí per esborrar aquest menú",
"Click here to delete this repository" => "Punxa aquí per esborrar aquest dipòsit",
"Click here to delete this rule" => "Fes clic aquí per esborrar aquesta norma",
"Click here to delete this template" => "Fes clic aquí per esborrar aquesta plantilla",
"Click here to delete this tracker" => "Fes clic aquí per esborrar aquest formulari",
"Click here to edit this comment" => "Clica aquí per editar aquest comentari",
"Click here to edit this menu" => "Clica aquí per editar aquest menú",
"Click here to unassign this module" => "Clica aquí per desassignar aquest mòdul",
"Click the :: option on the menu for more options." => "Fes clic a l'opció :: del menú per a més opcions.",
"Click to enlarge" => "Click to enlarge",
"cms" => "cms",
"CMS settings" => "Configuració dels CMS",
"Cms" => "Sgc (Cms)",
"column" => "columna",
"Comm" => "Comm",
"compose message tpl" => "plantilla per a escriu un missatge",
"Configure modules" => "Configura mòduls",
"Configure this page" => "Configura aquesta pàgina",
"content templates" => "plantilles de contingut",
"Control by category" => "Control per categoria",
"Control by Object" => "Control per Objecte",
"Crea page:" => "Crea la pàgina:",
"Create a tag for the current wiki" => "Crear una marca per al wiki actual",
"Create/edit extwiki" => "Crea/edita wiki extern",
"Create/edit Faq" => "Crea/edita Puf",
"Create/edit Forums" => "Crea/edita fòrums",
"Create/edit HTML pages" => "Crea/edita pàgines  HTML",
"Create/edit Menus" => "Crea/edita menús",
"Create/edit RSS module" => "Crea/edita mòdul RSS",
"Create/edit surveys" => "Crea/edita enquestes",
"Create/edit templates" => "Crea/edita plantilles",
"Create HTML dump" => "Crea un buidat HTML",
"create new empty structure" => "crea una estructura nova buida",
"Create New Survey:" => "Crear nova Enquesta:",
"Create or edit a file gallery using this form" => "Crea o edita una galeria emprant aquest formulari",
"Create or edit a gallery using this form" => "Crea o edita una galeria fent servir aquest formulari",
"creates an editable drawing named foo" => "crea un dibuix editable anomenat foo",
"Create structure from tree" => "Crea estructura des de l'arbre",
"create tag" => "crear marca",
"Create TAR dump" => "Create TAR dump",
"Creating backups may take a long time. If the process is not completed you will" => "Creating backups may take a long time. If the process is not completed you will",
"Creating backups may take a long time. If the process is not completed you willsee a blank screen. If so you " => "Creating backups may take a long time. If the process is not completed you willsee a blank screen. If so you ",
"creation date" => "data de creació",
"Current page:" => "Pàgina actual:",
"Current version" => "Versió actual",
"current_version" => "versió actual",
"days (0=all)" => "dies (0=tots)",
"dcs" => "dcs",
"deep" => "profund",
"Delete item from category?" => "esborrar item des de categoria?",
"Describe topics in listing" => "Descriu els tòpics en el llistat",
"Diff:" => "Dif:",
"Diff of %s." => "Dif de %s.",
"Directory (include trailing slash)" => "Directori (inclou  la barra del final)",
"dispay" => "mostra",
"Displays a snippet of code.\nSet optional paramater -+ln+- to 1 if you need line numbering feature." => "Displays a snippet of code.\nSet optional paramater -+ln+- to 1 if you need line numbering feature.",
"Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done)." => "Mostra text/codi preformatat; no es dóna processat Wiki dins d'aquestes seccions (igual que amb np), i l'espaiat és fixe (no s'inserten salts de línia automàtics entre les paraules).",
"Download last TAR dump" => "Download last TAR dump",
"drawings" => "dibuixos",
"(Dropdown options : list of items separated with commas)" => "(Llista d'opcions : llista d'ítems separats amb comes)",
"dynamic colapsed" => "dinàmic colapsat",
"Edit desc" => "Editar desc",
"Edit drawings &amp; pictures" => "Edit drawings &amp; pictures",
"Editing tracker item" => "Editant l'ítem del formulari",
"Edit or add category" => "Editar o afegir categories",
"Edit Submissions" => "Edita les Col·laboracions",
"Edit succesful!" => "Edició satisfactòria!",
"Edit this group:" => "Edita aquest grup:",
"Edit this HTML page" => "Edita aquesta pàgina en format HTML",
"Edit tpl" => "plantilla per a editar ",
"Email Encoding" => "Codificació correu-e",
"Enable watch by default for author" => "Habilita avís per defecte per a l'autor",
"Enable watches when I am the editor" => "Habilita avisos quan sóc l'editor",
"Enlarge area width" => "fes més gran l'amplada",
"Events Panel" => "Panell d'Esdeveniments",
"ExtWikis" => "ExtWikis",
"FAQ Answers" => "Respostes de les PUFs",
"FAQ comments" => "Comentaris en les PUFs",
"FAQ Questions" => "Preguntes d'Ús Freqüent (PUFs)",
"FAQs settings" => "Funcionalitats de les Preguntes d'Ús Freqüent (PUFs)",
"feat" => "caract",
"features" => "característiques",
"file galleries" => "galeries d'arxius",
"file galleries tpl" => "plantilla per a galeria d'arxius",
"File gals" => "Gals d'arxius",
"file gls" => "gals de fitxers",
"For more information, please see <a href=\"{\$helpurl}WikiSyntax\">WikiSyntax</a>" => "Per a més informació, si us plau vegi les normes de <a href=\"{\$helpurl}WikiSyntax\">Sintaxi Wiki</a>.",
"For more information, please see <a\nhref=\"http://www.tiki.org/tiki-index.php?page=WikiSyntax\">WikiSyntax</a>\non <a href=\"http://www.tiki.org\">Tikiwiki.org</a>." => "Per a més informació, si us plau veure  <a\nhref=\"http://www.tiki.org/tiki-index.php?page=WikiSyntax\">WikiSyntax</a>\non <a href=\"http://www.tiki.org\">Tikiwiki.org</a>.",
"Forum settings" => "Forum settings",
"forum topic" => "tema del fòrum",
"Forward messages to this forum to this email" => "Forward messages to this forum to this email",
"frms" => "fòrums",
"from the list" => "de la llista",
"general" => "general",
"Go to your <a href=\"tiki-friends.php\">friendship network</a> to accept or refuse this request" => "Go to your <a href=\"tiki-friends.php\">friendship network</a> to accept or refuse this request",
"gral" => "gral",
"h1" => "t1",
"h2" => "t2",
"h3" => "t3",
"half a second" => "mig segon",
"HasImg" => "TeImatge",
"heading2" => "titular2",
"heading3" => "titular3",
"heading" => "heading",
"Height of inner Heading" => "Alçada de l'encapçalament",
"Height of mid Heading" => "Alçada del mig de l'encapçalament",
"Height of top Heading" => "Alçada de la part superior de l'encapçalament",
"Hide comments" => "Ocultar comentaris",
"hide from display" => "evita que es mostri",
"Hide Panels" => "Oculta els Panells",
"Hide Post Form" => "Ocultar el formulari",
"Hide suggested questions" => "Oculta",
"History of" => "Historial de",
"horizontal ruler" => "Línia horitzontal",
"Hotwords in new window" => "Paraules calentes en una nova finestra",
"hotwords" => "paraules calentes",
"i" => "c",
"idle" => "autista",
">I forgot my password" => ">He oblidat la meva contrasenya",
"If you change the calendar selection, please refresh to get the appropriated list in Category, Location and people (if applicable to the calendar you choose)." => "If you change the calendar selection, please refresh to get the appropriated list in Category, Location and people (if applicable to the calendar you choose).",
"image galleries" => "galeries d'imatges",
"Image gals" => "Gals d'imatges",
"(Image options : xSize,ySize indicated in pixels)" => "(Opcions d'Imatge  : xTamany,yTamany indicats en píxels)",
"img gls" => "gals d'imtg",
"img" => "img",
"img nc" => "img nc",
"In blog listing show user as" => "Al diari, l'usuari llistat és",
"Index page" => "Pàgina índex",
"Information:" => "Informació:",
"In parent page" => "In parent page",
"Insert articles into a wikipage" => "Inserta articles a una pàgina wiki",
"Ins" => "Ins",
"Invalid password.  You current password is required to change your email address." => "Contrasenya incorrecte.  La teva Contrasenya és necessària per canviar la teva adreça de correu.",
"JoinCapitalizedWords" => "AjuntarParaulesEnMajuscules",
"Klick to enlarge" => "Klick to enlarge",
"last_login" => "darrera connexió",
"last modification time" => "last modification time",
"last modified on %s" => "last modified on %s",
"Layout options" => "Opcions de format",
"LDAP Group Atribute" => "LDAP Group Atribute",
"Like pages" => "Pàgines similars",
"link_description" => "descripció de l'enllaç",
"Links/Commands" => "Enllaços/Comandaments",
"links" => "enllaços",
"List Calendars" => "Llista calendaris",
"list_pages" => "llistar pàgines",
"{literal}{CODE()}some code{CODE} {/literal} will render \"some code\" as program code. This plugin has other options; see <a href=\"{\$helpurl}PluginCode\">PluginCode</a>." => "{literal}{CODE()}tros de codi{CODE} {/literal} inerpretarà el \"tros de codi\" com a codi de programa. Aquest plugin té altres opcions; mira <a href=\"{\$helpurl}PluginCode\">PluginCode</a>.",
"Mailin accounts" => "Mailin accounts",
"Maked as deleted" => "Marcada com esborrada",
"mark as done" => "marca com a feta",
"Mark as Flagged" => "Marca com Senyalat",
"messages tpl" => "missatges tpl",
"Moderator" => "Moderador",
" modified" => "modificada",
"modules" => "mòduls",
"More info about" => "Més informació sobre",
"mot" => "mot",
"Mus enter a name to add a site" => "Mus enter a name to add a site",
"my galleries" => "les meves galeries",
"MyTikiDoc" => "El meu TikiDoc",
"name of wiki page" => "nom de la pàgina wiki",
"Navigation Panel" => "Navigation Panel",
"New article submitted at " => "Article nou enviat a ",
"New message arrived from " => "Ha arribat un missatge de ",
"Newss from" => "Newss from",
" new topic:" => " nou tema:",
"Next version" => "Propera versió",
"\n for rows" => "\n for rows",
"No file" => "Cap arxiu",
"No image uploaded" => "No s'ha pujat la imatge",
"No indivual permissions global permissions apply" => "No hi ha permisos individuals - manen els globals",
"No indivual permissions global permissions to all pages apply" => " No hi ha permisos individuals. Manen els permisos globlals",
"No scales availible" => "No scales availible",
"No such forum" => "No such forum",
"note: those parameters are exclusive" => "avis: aquells paràmetres són exclusius",
"Not rated yet" => "Not rated yet",
"objs" => "objs",
"Old versions" => "Versions anteriors",
"Only an admin can remove a thread." => "Només un administrador pot esborrar un enviament permament.",
"open tasks" => "obre les tasques",
"op" => "op",
"Options (separated by commas used in dropdowns only)" => "Options (separated by commas used in dropdowns only)",
"Options (sepparated by commas used in dropdowns only)" => "Opcions (separades per comes emprades només en menús desplegables)",
"or use square brackets for an" => "o emprar corxets per a",
"pageviews" => "vista de pàgina",
"parent" => "pare",
"password for this account is" => "la contrasenya per a aquest compte és",
"Path to where the dumped files are (relative to tiki basedir with trailing slahs ex: dump/)" => "Path to where the dumped files are (relative to tiki basedir with trailing slahs ex: dump/)",
"Path to where the dumped files are" => "Ruta a on es troben els fitxers del buidat",
"You do not have permission to browse this gallery" => "No tens autorització per accedir a la galeria",
"Permission denied you cant view this section" => "Permís denegat per veure aquesta secció",
"perm" => "perm",
"Perm" => "Permís",
"Php error reporting level for non-admin:" => "Nivell d'informació sobre errors per a no administradors:",
"PHPOpenTracker" => "PHPOpenTracker",
"Please also see" => "Si us plau, veieu també",
"Please follow the steps below to have your password properly reset:\n\n1. Click the following link to confirm you wish to reset your password:\n{\$mail_machine}?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\n2. Click the following link to go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else.\nhttp://{\$mail_machine}/tiki-change_password.php?user={\$mail_user}&oldpass={\$mail_pass}\n\nAlternatively, go to {\$mail_site} and login using your username and temporary password:\n Username:   {\$mail_user}\n Temporary password:  {\$mail_pass}\n\n3. Done! You should be logged in." => "Segueix, si us plau, els passos de sota per fer que la teva contrasenya es canvii adequadament:\n\n1. Punxa sobre el següent enllaç per confirmar que vols que es posi una nova contrasenya:\n{\$mail_machine}?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\n2. Punxa en el següent enllaç per anar a la finestra on hauràs d'introduir una nova contrasenya \"permanent\". Si su plau, escull una contrasenya que nonomés tu sàpigues, i no la comparteixis amb ningú més.\nhttp://{\$mail_machine}/tiki-change_password.php?user={\$mail_user}&oldpass={\$mail_pass}\n\nAlternativament, ves a {\$mail_site} i connecta't emprant el teu nom com a persona usuària i la contrasenya temporal:\n Nom de persona usuària:   {\$mail_user}\n Contrasenya temporal:  {\$mail_pass}\n\n3. Fet! Hauries d'estar connectat.",
"polls" => "consultes",
"Poll settings" => "Configuració de la Consulta",
"Posted comments" => "Comentaris publicats",
"Prevents parsing data" => "Evita analitar dades",
"Prevent users from voting same item more than one time" => "Prevent users from voting same item more than one time",
"printable" => "imprimible",
"Programmed versions" => "Versions programades",
"Publisher" => "Publicat per",
"Publish/Event Date" => "Publish/Event Date",
"Quiz time limit excedeed quiz cannot be computed" => "Has excedit el temps màxim",
"Ranking" => "Rànquing",
"ranking" => "rànquing",
"Reduce area width" => "Reduir l'amplada de l'àrea",
"References" => "Referències",
"Remind passwords by email" => "Recorda mots de pas per correu-e",
"remove bookmark" => "elimina adreça d'interès",
">Remove Zones (you lose entered info for the banner)" => ">Eliminar zones (perds la informació en el banner)",
"Renders a graph" => "Renders a graph",
"Reply to parent comment" => "Respondre al comentari pare",
"reply to this" => "respondre",
"report this post" => "reportar aquesta publicació",
"requested a reminder of the password for the" => "s'ha solicitat un recordatori de la paraula clau per el",
"Restore the wiki" => "Recuperar el wiki",
"Restoring a backup destoys all the data in your Tiki database. All your tables will be replaced with the " => "La recuperació d'una còpia de seguretat  destrueix totes les dades en la ",
"Restoring a backup destoys all the data in your Tiki database." => "Restoring a backup destoys all the data in your Tiki database.",
"Return to messages" => "Tornar als missatges",
"Reuse question" => "Empra de nou la pregunta",
"Rollback_page" => "Restableix pàgina",
"rotate left" => "rotate left",
"rss" => "rss",
"running" => "engegat",
"save a custom copy" => "guardar una còpia personalitzada",
"search category" => "categoria de cerca",
"Search : " => "Cerca : ",
"Send Objects" => "Enviar Objectes",
"Server time zone" => "Zona horària del servidor",
"Set feeds" => "Especifica alimentacions",
"Set home forum" => "Especifica fòrum inicial",
"Set prefs" => "Especif prefs",
"shoutbox" => "quadre d'avisos",
"ShoutBox" => "QuadredAvisos",
"Show chart for the last " => "Mostra gràfica per als darrers... ",
"Show comments" => "Mostrar comentaris",
"Show Post Form" => "Mostrar formulari per publicar",
"Show status when listing tracker items?" => "Mostra l'estatus quan es llistin els ítems del formulari?",
"Show suggested questions/suggest a question" => "Mostra preguntes suggerides/suggerir pregunta",
"since this is your registered email address we inform that the" => "ja que aquesta es la seva adreça email registrada, li informem que ",
"smileys" => "emoticons",
"someone from" => "algú des de",
"stat" => "estadística",
"strict" => "estricte",
"sub categories" => "subcategories",
"subs" => "subs",
"suggested" => "suggerides",
"system gallery" => "galeria del sistema",
"tbheight" => "alçada taula",
"tbl" => "tbl",
"TextFormattingRules" => "Regles de formateig de text",
"Textheight" => "Alçada del text",
"Thanks for your subscription. You will receive an email soon to confirm your subscription." => "Thanks for your subscription. You will receive an email soon to confirm your subscription.",
"Thankyou for installing Tikiwiki" => "Thankyou for installing Tikiwiki",
"The cord" => "El fil",
"The following file was succesfully uploaded" => "El següent arxiu ha estat pujat satisfactòriament",
"The following image was succesfully edited" => "La següent imatge ja ha estat editada satisfactòriament",
"The following image was succesfully uploaded" => "La següent imatge s'ha rebut satisfactòriament",
"The new page content is:" => "El nou contingut de la pàgina és:",
"The passwords didn't match" => "Els mots de pas no coincideixen",
"The passwords dont match" => "Els mots de pas no coincideixen",
"There are inddividual permissions set for this blog" => "Aquesta bitàcola té especificats permisos individuals",
"There are inddividual permissions set for this file gallery" => "Hi ha permisos individuals especificats per a aquesta galeria",
"There are inddividual permissions set for this forum" => "Hi ha permisos personalitzats per aquest fòrum",
"There are inddividual permissions set for this gallery" => "Hi ha permisos individuals per aquesta galeria",
"There are inddividual permissions set for this tracker" => "Hi ha permisos individuals fixats per a aquest formulari",
"There is an error in the plugin data" => "There is an error in the plugin data",
"The SandBox is a page where you can practice your editing skills, use the preview feature" => "The SandBox is a page where you can practice your editing skills, use the preview feature",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appeareance of the page, no versions are stored for this page." => "El LLocdeProves és una pàgina on pots practicar les teves habilitats d'edició, empra l'opció de previsualització per previsualitzar l'aspecte de la pàgina, no es desa cap versió per aquesta pàgina.",
"the space beetween nodes\n" => "the space beetween nodes\n",
"The user has choosen to make his information private" => "The user has choosen to make his information private",
"this post was reported" => "aquesta publicació ha estat notificada",
"Threads can be voted" => "Els fils poden ser votats",
"tiki admin external wikis tpl" => "plantilla de wikis externs per l'admin del tiki",
"tiki admin quicktags tpl" => "plantilla de barres d'eines (quicktags) per l'admin del tiki",
"Tiki Calendars" => "Tiki Calendars",
"Tiki forums" => "Tiki forums",
"Tiki RSS Feed Error Message" => "Missatge d'error d'alimentació RSS del Tiki",
"Tiki ShoutBox" => "Quadre d'avisos del Tiki",
"time" => "temps",
"Time Zone Map" => "Mapa de Zona Horària",
"Time Zone" => "Zona Horària",
"Title_bar" => "Barra de títol",
"today" => "avui",
"to insert a random tagline" => "per insertar una línea de marcador a l'atzar",
"Top Files" => "Arxius principals",
"topics in this forum" => "tòpics en aquest fòrum",
"topic:" => "tòpic:",
"trckrs" => "trckrs",
"ul" => "sl",
"unchecked" => "no marcat",
"Unexistant gallery" => "Galeria inexistent",
"Unexistant link" => "Enllaç inexistent",
"Unexistant user" => "Usuari inexistent",
"Unexistant version" => "Versió inexistent",
"Unflagg" => "Deixa de marcar amb la bandera",
"Upload succesful!" => "Pujada satisfactòria!",
"Upload was not successful (maybe a duplicate file)" => "La pujada no s'ha realitzat amb èxit (potser és un fitxer duplicat)",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory" => "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory",
"Use dbl click to edit pages" => "Empra doble click per editar pàgines",
"use filename" => "empra nom de fitxer",
"UseImg" => "UsaImatge",
"Use (:name:) for smileys" => "Empra (:nom:) per a emoticons",
"user bookmarks" => "Enllaços d'interès de l'usuari",
"userfiles" => "fitxersdusuari",
"user preferences" => "preferències de l'usuari",
"User preferences screen" => "Preferències de l'usuari",
"Users can save pages to notepad" => "Users can save pages to notepad",
"Users can subscribe any email addresss" => "Els usuaris poden subscriure qualsevol adreça de correu-e",
"Users can vote only one item from this chart per period" => "Users can vote only one item from this chart per period",
"User versions" => "Versions de l'usuari",
"use square brackets for an" => "empra corxets per a un/a",
"version %s" => "version %s",
"versions" => "versions",
"view info" => "veure info",
"Warn on edit" => "Avisa en ser editat",
"WebMail accounts" => "WebMail accounts",
"webmail" => "correuweb",
"Webmail Doc tpl" => "Plantilla de document Webmail",
"Welcome to " => "Benvingut/da a ",
"Wiki comments settings" => "Especificacions de comentaris del Wiki",
"Wiki Import dump" => "Importa buidat del Wiki",
"wiki link" => "enllaç del wiki",
"Wiki page list configuration" => "Configuració de llista de pàgines Wiki",
"Wiki Page Names" => "Noms de les Pàgines del Wiki",
"with role" => "with role",
"xx" => "xx",
"xxx" => "xxx",
"You are not permitted to edit someone else\\'s post!" => "No tens permís per editar la publicació d'algú altre!",
"You can edit the page following this link:" => "Pots editar la pàgina seguint aquest enllaç:",
"You can include the image in an HTML or Tiki page using" => "Pots incloure aquesta imatge en una pàgina HTML o Tiki emprant",
"You can include the image in an HTML/Tiki page using" => "Pots incloure aquesta imatge en una pàgina HTML/Tiki emprant",
"You cant download files" => "No pots baixar arxius",
"You cant use the same password again" => "Pots emprar la mateixa contrasenya un altre cop",
"You can view the page following this link:" => "Pots veure la pàgina seguint aquest enllaç:",
"You do not have permission to use this feature." => "No tens permís per emprar aquesta característica.",
"You dont have permissions to edit banners" => "No té permís per editar banners",
"You dont have permission to delete the mapfile" => "No tens permís per esborrar fitxer del mapa",
"You dont have permission to edit messages" => "No tens autorització per editar imatges",
"You dont have permission to edit this banner" => "No té permís per editar aquest banner",
"You dont have permission to read the mapfile" => "No tens permís per llegir el fitxer del mapa",
"You dont have permission to read the template" => "No té permís per llegir la plantilla",
"You dont have permission to use this feature" => "No tens permís per emprar aquesta característica",
"You dont have permission to view other users data" => "No té permís per veure dades d'altres usuaris",
"You dont have permission to write the style sheet" => "No tens permís per escriure al full d'estil",
"You dont have permission to write the template" => "No té permís per escriure la plantilla",
"You dont have permission to write to the mapfile" => "No tens permís per escriure al fitxer del mapa",
"You have to provide a name to the file" => "Has de posar un nom al fitxer",
"You have to provide a name to the image" => "Has de proporcionar un nom a la imatge",
"You have to type a searchword" => "Has de teclejar una paraula de cerca",
"You need to supply information for : " => "Has de facilitar informació per a : ",
"You reivied this task, please read and execute it" => "Has rebut aquesta tasca, si us plau llegeix-la i executa-la",
"Your Tiki account information for" => "La teva informació de compte de Tiki per a",
"You should first ask that a calendar is created, so you can create events attached to it." => "Primer hauries de demanar que es crei un calendari, de forma que puguis afegir esdeveniments en ell.",
"TikiTabs" => "TikiPestanyes (Tabs)",
"Please" => "Si us plau",
"log in" => "entrar",
"to access full functionalities" => "per accedir a totes les funcionalitats",
"Use Quote plugin for quoting" => "Empra el plugin de Cita (QUOTE) per citar",
"Use {literal}{{/literal}ed id=name} or {literal}{{/literal}ted id=name} to insert dynamic zones" => "Utilitzeu {literal}{{/literal}ed id=name} o {literal}{{/literal}ted id=name} per inserir zones dinàmiques",
"Emphasis" => "Èmfasi",
"italics" => "cursives",
"both" => "ambdós",
"make_headings" => "fa títols",
"underlines text" => "subratlla text",
"Simple box" => "Requadre simple",
"Will display using the indicated HTML color" => "Es mostrarà usant el color HTML indicat",
"Will display the text centered" => "Mostra el text centrat",
"Insert Module Output" => "Inserta la sortida del Mòdul",
"{literal}{MODULE(module=>some_module)}text{MODULE}{/literal}  can be used to insert the output of module \"some_module\" into your Wiki page. See <a href=\"{\$helpurl}PluginModule\">PluginModule</a> for more information. " => "{literal}{MODULE(module=>algun mòdul)}text{MODULE}{/literal}  pot ser emprat per insertar la sortida del mòdul \"algun mòdul\" a la teva pàgina Wiki. Mira <a href=\"{\$helpurl}PluginModule\">PluginModule</a> per més informació. ",
"Rendering Program Code" => "Interpreta Codi de Programa",
"New blog post: {\$mail_title}: {\$title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Nova entrada a la bitàcola: {\$mail_title}: {\$title} per {\$mail_user} el {\$mail_date|tiki_short_datetime}",
"Jukebox" => "Jukebox",
"Jukebox preference" => "Jukebox preference",
"Admin sections" => "Administra seccions",
"Remove Category" => "Elimina categoria",
"New group" => "Nou grup",
"Add group" => "Afegeix el grup",
"Remove group" => "Elimina el grup",
"Add user" => "Afegeix l'usuari/a",
"Borrar" => "Esborrar",
"Workspace Types" => "Tipus d'Espais de Treball",
"Admin Workspaces" => "Admin Espais de Treball",
"Assign aulawiki_myworkspaces" => "Assigna aulawiki_myworkspaces",
"to AulaWiki.css" => "a AulaWiki.css",
"Define the <a class='link' href=\"./aulawiki-roles.php\">workspace roles</a> and permission levels." => "Defineix els <a class='link' href=\"./aulawiki-roles.php\">rols dels espais de treball</a> i els nivells de permisos.",
"Define the <a class='link' href=\"./aulawiki-workspace_types.php\">workspace types</a> , use MenuID 100 or <a class='link' href=\"./tiki-admin_menus.php\">define your own menu</a>. Assign <img src='img/icons/change.gif' border='0' alt='Workspace type resources' title='Workspace type resources' /> default resources and <img src='img/icons/mo.png' border='0' alt='Assigned modules' title='Assigned modules' /> desktop modules." => "Defineix els <a class='link' href=\"./aulawiki-workspace_types.php\">Tipus d'Espais de Treball</a> , empra el MenuID 100 o <a class='link' href=\"./tiki-admin_menus.php\">defineix el teu propi menú</a>. Assigna els <img src='img/icons/change.gif' border='0' alt='recursos del Tipus d\\'Espai de Treball' title='recursos del Tipus d\\'Espai de Treball' /> recursos per defecte i els <img src='img/icons/mo.png' border='0' alt='Mòduls assignats' title='Mòduls assignats' /> mòduls de l'escriptori.",
" line " => " línia ",
"permission." => "permís.",
"Error: Invalid" => "Error: Invàlid",
"Error: Call to hw_page_fetch_by_id failed!" => "Error: ha fallat la crida a la recuperació de la pàgina per id!",
"no description" => "sense descripció",
"Updated" => "Actualitzat",
"Renders a graph, with linked pages navigation visually figured.\n" => "Produeix un gràfic, amb navegació de mode visual per les pàgines enllaçades.\n",
"the number of hops the graph follows\n" => "segueix el nombre de salts de la pàgina\n",
"the title of the map\n" => "el títol del mapa\n",
"the space between nodes\n" => "l'espai entre nodes\n",
"Left to Right, the direction of graph\n" => "D'esquerra a dreta, la direcció del graph\n",
"the background color, use #rrvvbb color types.\n" => "el color de fons, fer servir els tipus #rrvvbb.\n",
"nothing there, unlimited size. use 5,3 type sizes in inches\n" => "aquí no hi ha res, tamany il·limitat. Feu servir tamanys de font 5,3 pulgades\n",
"the font size in pts presumably\n" => "la mida de la font en pts presumiblement\n",
"the name of the font used for labels\n" => "el nom de la font emprada per les etiquetes\n",
"the shape of a node. can be " => "la forma d'un node. pot ser ",
"plaintext ellipse circle egg triangle box diamond trapezium parallelogram house hexagon octagon\n" => "texsenzill el·lipse cercle ou triangle rectangle rombe trapezi  paral·lelogram casa hexàgon octàgon\n",
"style for drawing nodes.\n" => "estil per dibuixar nodes.\n",
"color of the border\n" => "color de la vora\n",
"background color of the node\n" => "color de fons del node\n",
"sortof relative width ??\n" => "un tipus d'amplada relatiu ??\n",
"same mystery as above\n" => "el mateix misteri que a dalt\n",
"color for links (called edges here)\n" => "color per a enllaços (anomenats vores aquí)\n",
"shape of the arrow that come with the link\n" => "forma de la fletxa que ve amb l'enllaç\n",
"Assignments Administration" => "Administració de deures",
"Period" => "Període",
"Grade Weight" => "Ponderacions de les avaluacions",
"Exam" => "Examen",
"Exercise" => "Exercici",
"New Assignment" => "Deures nous",
"Permission levels" => "Nivells de permisos",
"Studies" => "Estudis",
"Gradebook" => "Quadern d'avaluacions",
"Select period" => "Selecciona període",
"Save grades" => "Desa avaluacions",
"Allow Anonymous" => "Permet als Anònims",
"Allow Registered" => "Permet als registrats",
"Workspace resources" => "Estructures de l'Espai de Treball",
"User workspace" => "Espais de treball dels Usuaris",
"Remove all" => "Esborra tot/s",
"User Workspaces" => "Espais de treball dels usuaris",
"Assignment details" => "Detalls dels deures",
"Grade" => "Avalua",
"Save Grades" => "Desa Avaluacions",
"Grade for" => "Avalua a",
"Personal Learning Folder" => "ePortfolio Personal de l'usuari/a",
"The page {\$mail_page} was changed by {\$mail_user} at\n{\$mail_date|tiki_short_datetime}" => "La pàgina {\$mail_page} va ser canviada per {\$mail_user} el\n{\$mail_date|tiki_short_datetime}",
"You can view the page by following this link:\n    {\$mail_machine}/tiki-index.php?page={\$mail_page|escape:\"url\"}" => "Pots veure la pàgina si segueixes aquest enllaç:\n    {\$mail_machine}/tiki-index.php?page={\$mail_page|escape:\"url\"}",
"You can edit the page by following this link:\n    {\$mail_machine}/tiki-editpage.php?page={\$mail_page|escape:\"url\"}" => "Pots editar la pàgina seguint aquest enllaç:\n    {\$mail_machine}/tiki-editpage.php?page={\$mail_page|escape:\"url\"}",
"You can view a diff back to the previous version by following\nthis link:\n    {\$mail_machine}/tiki-pagehistory.php?page={\$mail_page|escape:\"url\"}&diff2={\$mail_last_version}" => "Pots veure un diff a la versió prèvia seguint\naquest enllaç:\n    {\$mail_machine}/tiki-pagehistory.php?page={\$mail_page|escape:\"url\"}&diff2={\$mail_last_version}",
"Confirmation required" => "Confirmació requerida",
"Wiki quick help" => "Ajuda ràpida Wiki",
"Quicklinks" => "Enllaços ràpids",
"Go \n                    back" => "Tornar \n                    Enrera",
"Return to home \n                    page" => "Tornar a la pàgina d'inici \n                    pàgina",
"MyTiki (click!)" => "El meu Tiki (fes clic!)",
"Admin (click!)" => "Admin (fes clic!)",
"Grade Paper" => "Avalua treball escrit",
"Comparing versions" => "Comparant versions",
"Actual_version" => "Versió actual",
"Diff to version" => "Diferent de la versió",
"Grading Queue " => "Cua d'Avaluacions ",
"Edit Assignment" => "Edit deures",
"list assignments" => "llista els deures",
"create assignment" => "crea deures",
"Import pages from a PHPWiki Dump" => "Importa pàgines des d'un buidat de PHPWiki",
"Path to where the dumped files are (relative to tiki basedir with trailing slash ex: dump/)" => "Ruta dels arxius a resumir (relatiu al directori tiki, amb barra ex: dump/)",
"ver" => "versió",
"sort order" => "criteri d'ordenació",
"Edit selection" => "Edita la selecció",
"Error: This page is being edited by another user." => "Error: aquesta pàgina està essent editada per un altra persona usuària.",
"updated by the phpwiki import process" => "actualitzat pel procés d'importació de phpwiki",
"created from phpwiki import" => "creada des de phpwiki import",
"Security check failed!" => "Verificació de seguretat fallida!",
"MenuID" => "MenuID",
"missing tracker ID for plugin TRACKER" => "manca l'ID del formulari per al connector TRACKER",
"Workspace not selected" => "No s'ha seleccionat cap Espai de Treball",
"Resource type not selected" => "Tipus de recurs no seleccionat",
"Permission denied you cannot create new resources" => "Permís denegat, no podeu crear recursos nous",
"Name requiered" => "Es requereix el nom",
"Permission denied, you cannot admin the workspace" => "Permís denegat, no podeu administrar l'Espai de Treball",
"Tip: hold down CTRL to select multiple categories" => "Pista: manteniu apretat CTRL per selecciar multiples categories",
"Tip: uncheck the above checkbox to uncategorize this page/object" => "Pista: desselecciona el quadre de verificació de sobre per descategoritzar aquesta pàgina/objecte",
"usernames separated with ;" => "noms d'usuaris separats per ;",
"reply to" => "respon a",
"AulaWiki Assistant" => "Assitent de l'AulaWiki",
"Welcome to AulaWiki" => "Benvinguts/des a AulaWiki!",
"First configuration steps" => "Primers passos de configuració",
"module" => "mòdul",
"to the users that you want to use AulaWiki workspaces" => "a les persones usuàries que vols que emprin els espais de treball d'AulaWiki",
"Change theme" => "Canvia l'estil de tema",
"to workspaces.css" => "a workspaces.css",
"Define the <a class='link' href=\"./tiki-workspaces_roles.php\">workspace roles</a> and permission levels." => "Defineix els <a class='link' href=\"./tiki-workspaces_roles.php\">rols de l'espai de treball</a> i els nivells de permisos.",
"Define the <a class='link' href=\"./tiki-workspaces_types.php\">workspace types</a> , use MenuID 100 or <a class='link' href=\"./tiki-admin_menus.php\">define your own menu</a>. Assign <img src='img/icons/change.gif' border='0' alt='Workspace type resources' title='Workspace type resources' /> default resources and <img src='img/icons/mo.png' border='0' alt='Assigned modules' title='Assigned modules' /> desktop modules." => "Defineix els <a class='link' href=\"./tiki-workspaces_types.php\">tipus d'espais de treball</a> , empra el MenuID 100 o <a class='link' href=\"./tiki-admin_menus.php\">defineix el teu propi menú</a>. Assigna <img src='img/icons/change.gif' border='0' alt='Workspace type resources' title='Workspace type resources' /> els recursos per defecte i <img src='img/icons/mo.png' border='0' alt='Assigned modules' title='Assigned modules' /> els mòduls visibles al seu escriptori.",
"Create a workspace" => "Crea un espai de treball",
"of the previosly defined type" => "del Tipus definit prèviament",
"Assign workspace users and groups" => "Assigna usuaris i grups als Espais de Treball",
"Admin the workspace resources" => "Administra els recursos dels Espais de Treball",
"View the workspace desktop" => "Visualitza l'escriptori de l'Espai de Treball",
"Break module" => "Mòdul de fi de columnes",
"Workspace Calendar" => "Calendari de l'Espai de Treball",
"List events" => "Llista esdeveniments",
"Child Workspaces" => "Espais de treball fills",
"Inactive workspace" => "Espai de treball inactiu",
"Clipboard" => "Portaretalls",
"Empty clipboard" => "Buida el portaretalls",
"Workspace History" => "Història de l'Espai de Treball",
"prev posts" => "publicacions prèvies",
"next posts" => "publicacions següents",
"prev files" => "arxius previs",
"next files" => "arxius següents",
"prev images" => "imatges prèvies",
"next images" => "imatges següents",
"My Workspaces" => "Els meus Espais de Treball",
"Current workspace:" => "Espai de treball actual:",
"Active workspace" => "Espai de treball actiu",
"My workspaces:" => "Els meus espais de treball:",
"Resources" => "Recursos",
"Object type:" => "Tipus d'objecte:",
"are you sure to remove object " => "segur que vols eliminar l'objecte ",
"UserGroups" => "Grups d'Usuaris",
"Group Name:" => "Nom de Grup:",
"are you sure to remove group " => "segur que vols eliminar el grup ",
"are you sure to remove user from group " => "segur que vols eliminar a l'usuari del grup ",
"View Structure" => "Visualitza estructura",
"Workspace Members" => "Membres de l'Espai de Treball",
"offline users" => "usuaris no-connectats",
"Site Calendar" => "Calendari del Lloc",
"Please see the <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://doc.tiki.org/tiki-index.php?page=Features\">evaluation of each feature</a> on Tiki's developer site." => "Consulta l'<a class=\"rbox-link\" target=\"tikihelp\" href=\"http://doc.tiki.org/tiki-index.php?page=Features\">avaluació de cada funcionalitat</a> al lloc Tiki sobre desenvolupament.",
"Create a group for each user <br />(with the same\nname as the user)" => "Crear un grup per a cada usuari/a <br />(amb the mateix\nnom que l'usuari/a)",
"Field is public? (for use thru trackerlist plugin)" => "El camp és públic? (per ser emprat a través del connector trackerlist)",
"Note: if you want to use images please save the post first and you\nwill be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor\nor use the image URL to include images using the WYSIWYG editor" => "Nota: si vols fer servir imatges guarda el post primer\ni a les hores edita/envia les imatges. Fes servir el &lt;img&gt; snippet per incloure les imatges al area de texte\no s'ha de fer servir l'URL de la imatge amb l'editor WYSIWYG",
"use ...page... to separate pages" => "utilitzeu...pàgina...per separar les pàgines",
"Welcome to the installation & upgrade script!" => "Benvinguts/des al procés d'instal·lació & actualitació!",
"Your database has been configured and Tiki is ready to run, if\n    \t\tthis is your first install your admin password is 'admin'. You can\n    \t\tnow log in into Tiki as 'admin' - 'admin' and start configuring\n    \t\tthe application" => "La teva base de dades ha estat configurada i Tiki està llest per fer-se servir; si \n    \t\taquesta és la teva primera instal·lació, la teva contrasenya d'usuari administrador (admin) és 'admin'. Pots \n    \t\tara ja connectar-te a Tiki com 'admin' - 'admin' i començar a configurar \n    \t\tla aplicació",
"Workspaces Administration" => "Administració de l'Espai de Treball",
"Hide workspace" => "Oculta l'espai de treball",
"Assigned modules" => "Mòduls Assignats",
"Users/Groups" => "Usuaris/Grups",
"Desktop" => "Escriptori",
"Workspace path:" => "Ruta a l'Espai de Treball:",
"Admin resource" => "Administra recurs",
"Roles Administration" => "Administració de Rols",
"Workspace Types Administration" => "Administració del Tipus d'Espai de Treball",
"Allow private user zone" => "Permet zona privada de persona usuària",
"Workspace Types Resources" => "Recursos del Tipus d'Espai de Treball",
"Workspace type name" => "Nom del tipus de l'Espai de Treball",
"Resource name" => "Nom de recurs",
"Resource description" => "Descripció del recurs",
"Resource type" => "Tipus de recurs",
"Invalid variable value : " => "Invàlid valor de variable: ",
"Code in use, please select a different code" => "Aquest codi ja s'utilitza, si us plau seleccioneu-ne un altre diferent",
"Code not selected" => "Codi no seleccionat",
"Workspace not found" => "No s'ha trobat l'Espai de Treball",
"Closed Workspace" => "Espai de treball tancat",
"Resource name not selected" => "No s'ha seleccionat el nom del recurs",
"Resource not found" => "No s'ha trobat el recurs",
"Role name not selected" => "No s'ha seleccionat cap nom de rol",
"Role name in use, please select a different name" => "Aquest nom de rol ja és emprat, selecciona un nom diferent, si us plau",
"Workspace type not found" => "No s'ha trobat l'Espai de Treball",
"Workspace type not selected" => "No s'ha seleccionat cap tipus d'espai de treball",
"Module not set" => "No s'ha especificat el mòdul",
"perms" => "perms",
"similar" => "similar",
"loc" => "loc",
"cat" => "cat",
"prio" => "prio",
"coms" => "coms",
"ppd" => "ppd",
"admin groups template" => "administra plantilla de grups",
"uploaded by" => "pujat/da per",
"not specified" => "no especificat",
"There was a problem with your upload." => "Hi ha hagut un problema amb la teva pujada.",
"The file you are trying to upload is too big." => "El fitxer que s'està intentant pujar es massa gran.",
"The file you are trying to upload was only partially uploaded." => "El fitxer que s'està pujant nomès s'ha transferit parcialment.",
"You must select a file for upload." => "Has de seleccionar un fitxer per pujar.",
"%s is an empty archive file" => "%s és un arxiu buit",
"Invalid remote file on url %s" => "Arxiu remot invàlid a la url %s",
"Project Group for " => "Grup del projecte per ",
"Project Admin Group for " => "Grup d'admins del projecte per ",
"%A %d of %B, %Y[%H:%M:%S %Z]" => "%A %d de %B, %Y[%H:%M:%S %Z]",
"%a %d of %b, %Y" => "%a %d de %b, %Y",
"%a %d of %b, %Y[%H:%M %Z]" => "%a %d de %b, %Y[%H:%M %Z]",
"delete" => "elimina",
"post" => "publicar",
"stop monitoring this blog" => "desubscriu-te a aquesta bitàcola",
"posts" => "publicacions",
"visits" => "visites",
"show categories" => "mostra categories",
"author" => "autor",
"user level" => "nivell d'usuari/a",
"send email to user" => "enviar email a usuari",
"score" => "puntuació",
"delete selected" => "esborrar seleccionats",
"move" => "moure",
"Posted messages" => "Missatges publicats",
"set" => "especifica",
"replies" => "respostes",
"new reply" => "resposta nova",
"cancel" => "cancel·la",
"up" => "amunt",
"down" => "avall",
"stop monitoring this map" => "deixa de seguir aquest  mapa",
"create" => "crear",
"save" => "guardar",
"send" => "envia",
"Hide module contents" => "Amaga contingut del mòdul",
"signed" => "signat",
"Last visitors" => "Últims visitants",
"register" => "registra't",
"standard" => "estàndar",
"secure" => "segur",
"stay in ssl mode" => "roman en mode segur (ssl)",
"go" => "ves-hi",
"use" => "empra",
"cached" => "captat en memòria cau",
"refresh" => "refresc",
"print" => "imprimir",
"create pdf" => "crea un pdf",
"monitor this page" => "vigila aquesta pàgina",
"stop monitoring this page" => "deixa de vigilar aquesta pàgina",
"backlinks" => "retroenllaços",
"last modification:" => "última modificació:",
"rename" => "reanomenar",
"unlock" => "desbloquejar",
"lock" => "bloquejar",
"history" => "historial",
"undo" => "desfès",
"slides" => "diapos",
"export" => "exporta",
"discuss" => "debat",
"add comment" => "afegeix un comentari",
"attach file" => "adjuntar arxiu",
"translation" => "traducció",
"last modification" => "Última modificació",
"attachments" => "arxius adjunts",
"stats" => "estadistiques",
"last changes" => "darreres modificacions",
"list pages" => "llista pàgines",
"back to homepage" => "tornar a inici",
"logout" => "desconnecta't",
"cancel edit" => "cancel·la edició",
"No attachments for this page" => "No hi ha adjuncions per a aquesta pàgina",
"Skip to navigation" => "Saltar a navegació",
"switch" => "canvi",
"view blog" => "visualitza bitàcola",
"list blogs" => "llista bitàcoles",
"save and exit" => "guardar i sortir",
"reads" => "lectures",
"view comments" => "visualitza comentaris",
"Click here to create it" => "Cliqueu aquí per crear-ho",
"wiki help" => "ajuda wiki",
"Personal portfolio" => "ePortfolio Personal de l'usuari/a",
"General preferences" => "Preferències generals",
"Other preferences" => "Altres preferències",
"flag" => "bandera",
"HomePage" => "PaginaInicial",
"Edit information" => "Edita la informació",
"Change information" => "Canvia la informació",
"Best language" => "Millor idioma",
"Workspaces" => "Espais de treball",
"System Features" => "Característiques del sistema",
"Signal System" => "Sistema de senyal",
"Enable cache images to all galleries" => "Habilita posar les imatges en memòria cau per a totes les galeries",
"Images cache directory" => "Directori per la memòria cau de les imatges",
"images" => "imatges",
"PHP error reporting level for non-admin:" => "Nivell d'informació sobre errors per a no administradors:",
"Server name (for absolute URIs)" => "Nom del servidor (per URIs absolutes)",
"HTTPS Server" => "Servidor HTTPS (segur)",
"Wiki_Tiki_Title" => "Títol del Wiki",
"path" => "ruta",
"Admin->Features" => "Admin->Funcionalitats",
"must be turned on and notification is sent to the admin's" => "han de ser activats/des i la notificació és enviada a la bústia de missatges Tiki de l'administrador",
"inter-user message inbox" => "bústia d'entrada de missatges inter-usuaris",
"Validate email address (may not work)" => "Valida adreces de correu-e (pot no funcionar)",
"Require HTTP Basic authentication" => "Requereix autenticació bàsica HTTP",
"HTTP server name" => "Nom del servidor HTTP",
"HTTP URL prefix" => "Prefix de les URL d'HTTP",
"HTTPS server name" => "Nom del servidor HTTPS",
"HTTPS URL prefix" => "Prefix de les URL d'HTTPS",
"Only for users" => "Només per a usuaris/es",
"Users and admins" => "Usuaris i admins",
"Full Text Search" => "Cerca a text complet",
"Don't forget: to use feature you will need to enable it on" => "No t'oblidis: per emprar la funcionalitat necessitaràs habilitar-la a",
"Site breadcrumbs" => "Rastres en el lloc",
"Site search bar" => "Barra de cerca del lloc",
"Site logo" => "Logo del lloc",
"Site logo source" => "Font del logo del lloc",
"Site ads and banners" => "Anuncis i pancartes del lloc",
"Site Menu" => "Menú del lloc",
"Note: This feature also requires phplayers to be turned on in Admin->Features" => "Nota: Aquesta funcionalitat també requereix que els menús per capes phplayers siguin activats a Admin->Funcionalitats",
"Manage attachment preferences" => "Gestiona les preferències dels adjunts",
"HTML in Wiki Pages" => "HTML en Planes Wiki",
"Wiki syntax used when a page contains HTML" => "Sintaxi Wiki emprada quan una pàgina contè HTML",
"full" => "sencer",
"partial" => "parcial",
"Enable Feature" => "Activa la Característica",
"Wiki attachments preferences" => "Preferències dels adjunts al Wiki",
"Admin Action Log" => "Administra el Registre d'Accions",
"admin banning tpl" => "administrar plantilla per a prohibició",
"lang" => "idm",
"permissions" => "permisos",
"admin categories" => "administrar categories",
"admin categories tpl" => "administrar plantilla per a categories",
"create new" => "crear nou",
"edit chart" => "edita chart",
"update" => "actualitza",
"admin content templates" => "administrar contingut de les plantilles",
"use in cms" => "fes servir en el cms",
"use in wiki" => "fes servir en el wiki",
"use in newsletters" => "empra en butlletins",
"use in HTML pages" => "fes servir en pàgines HTML",
"last modif" => "darrera modificació",
"sections" => "seccions",
"admin FortuneCookie" => "administrar Galeta de la Sort",
"admin FortuneCookie tpl" => "administrar plantilla per a la Galeta de la Sort",
"upload" => "puja",
"admin Drawings tpl" => "administrar plantilla per a Dibuixos",
"admin External Wikis" => "admin Wikis Externs",
"extwiki" => "wikiext",
"Edit existing forums" => "Edita fòrums existents",
"topics" => "temes",
"age" => "edat",
"last post" => "darrer missatge",
"Assign Permissions (Active)" => "Assignar permisos (Actiu)",
"Click here to delete this forum" => "Fes clic aquí per esborrar aquest fòrum",
"admin hotwords" => "administrar paraules calentes",
"admin hotwords template" => "administra la plantilla de paraules calentes",
"admin HTML page dynamic zones" => "administrar zones dinàmiques de la pàgina HTML",
"list repositories" => "llista dipòsits",
"new repository" => "nou dipòsit",
"view repository" => "visualitza dipòsit",
"view this repository" => "veure aquest dipòsit",
"new rule" => "nova regla",
"admin featured links" => "administra d'enllaços destacats",
"position" => "posició",
"admin Webmail" => "administrar Correu-Web",
"admin mailin template" => "administrar plantilla per a butlletins",
"section" => "secció",
"sorted section" => "secció ordenada",
"admin menu builder" => "Constructor de menús d'administració",
"options" => "opcions",
"admin modules" => "administració de mòduls",
"assign module" => "assigna mòdul",
"left modules" => "mòduls a l'esquerra",
"right modules" => "mòduls ala dreta",
"edit/create" => "editar/crear",
"clear cache" => "esborra memòria cau",
"\n<b>Note 1</b>: if you allow your users to configure modules then assigned\nmodules won't be reflected in the screen until you configure them\nfrom MyTiki->modules.<br />\n<b>Note 2</b>: If you assign modules to groups make sure that you\nhave turned off the option 'display modules to all groups always'\nfrom Admin->General\n" => "\n<b>Nota 1</b>: si permeteu als usuaris configurar els mòduls,  els mòduls\nassignats no es veurena a la pantalla fins que no els configureu\ndes de ElMeuTiki->mòdulss.<br />\n<b>Nota 2</b>: Si assigneu mòduls a grups, assegureu-vos de tenir\ndesconnectada l'opció 'mostra sempre els mòduls a tots els grups'\nde Admin->General\n",
"assign" => "assignar",
"left" => "esquerra",
"right" => "dreta",
"order" => "ordre",
"parameters" => "paràmetres",
"create/edit" => "crea/edita",
"use poll" => "empra consultes",
"use gallery" => "empra galeria",
"use dynamic  content" => "usa contingut dinàmic",
"use rss module" => "empra mòdul RSS",
"use menu" => "empra menú",
"use phplayermenu" => "empra phplayermenu",
"use banner zone" => "usa zones de banners",
"structure" => "estructura",
"list newsletters" => "llista butlletins",
"admin newsletters" => "administra butlletins",
"send newsletters" => "envia butlletins",
"editions" => "edicions",
"drafts" => "esborranys",
"last sent" => "últims enviats",
"admin Email Notifications" => "administra les notificacions de correu electrònic",
"use admin email" => "fes servir el correu-e de l'admin",
"event" => "aconteixement",
"admin polls" => "administrar consultes",
"admin QuickTags" => "administrar Barres d'eines",
"label" => "etiqueta",
"admin RSS Modules" => "administrar mòduls RSS",
"export pages" => "exportar pàgines",
"dump tree" => "baixa't l'arbre",
"create webhelp" => "crear ajudaweb",
"view webhelp" => "visualitza ajutweb",
"tree" => "arbre",
"create new structure" => "crear nova estructura",
"survey stats" => "estadístiques d'enquestes",
"edit this survey" => "edita aquesta enquesta",
"admin surveys" => "administra enquestes",
"list surveys" => "llista enquestes",
"questions" => "preguntes",
"If your Tiki is acting weird, 1st thing to try it to clear your cache below. Also very important to clear your cache after an upgrade (by FTP/SSH if need be)." => "Si el teu Tiki està actuant de forma rara, la primera cosa a provar és netejar la memòria cau de sota. També és molt important netejar la teva memòria cau després d'una actualització (per FTP/SSH si és necessari).",
"files" => "arxius",
"advanced feature" => "funcionalitat avançada",
"admin Trackers tpl" => "admin plantilles de formularis",
"Edit fields for tracker" => "Edita els camps del formulari",
"The tracker needs a text field named Subject" => "El formulari necessita un camp de text anomenat Tema",
"tracker_{\$trackerId}.csv" => "formulari {\$trackerId}.csv",
"Import file" => "Importa arxiu",
"admin groups" => "administració de grups",
"assign permissions" => "assigna permisos",
"remove from group" => "elimina del grup",
"admin users" => "administrar usuaris",
"edit account settings" => "edita els paràmetres del compte",
"edit included group" => "edita el grup inclòs",
"remove users and their userpages" => "elimina els usuaris i les seves pàgines d'usuari",
"assign to groups" => "assigna a grups",
"edit article tpl" => "edita plantilla per a article",
"Assign user" => "Assignar usuari",
"Available groups" => "Grups disponibles",
"assign perms to this group" => "assigna permisos a aquest grup",
"admin backups" => "administra les còpies de seguretat",
"admin admin tpl" => "admin plantilla admin",
"Use of this feature is NOT recommended. Please use phpMyAdmin or mysqldump instead." => "Es recomana NO EMPRAR aquesta funcionalitat. Si us plau, empreu phpMyAdmin o mysqldump en el seu lloc.",
"List of available backups" => "Llista de còpies de seguretat disponibles",
"Restoring a backup" => "Recupera una còpia de seguretat",
"Warning!" => "Atenció!",
"Restoring a backup destoys all the data in your Tiki database. All your tables will be replaced with the information in the backup." => "La restitució d'una còpia de seguretat destruirà totes les dades de la teva base de dades del Tiki. Totes les teves taules seran reemplaçades amb la informació de la còpia de seguretat.",
"Click here to confirm restoring" => "Punxa aquí per confirmar la recuperació de la còpia de seguretat",
"Create new backup" => "Crea una còpia de seguretat nova",
"Creating backups may take a long time. If the process is not completed you will see a blank screen. If so you need to increment the maximum script execution time from your php.ini file" => "La creació de còpies de seguretat pot durar molt temps. Si el procés no es pot completar veuràs una pantalla blanca. Si passa això necessitaràs incrementar el temps màxim d'execució de macro al teu fitxer php.ini",
"Your image gallery storage is set to \"{\$gal_use_dir}\", you will need to backup this using FTP or SCP." => "El magatzem de la teva galeria d'imatges està fixat a \"{\$gal_use_dir}\", necessitaràs fer-ne còpies de seguretat emprant FTP o SCP.",
"Your file gallery storage is set to \"{\$fgal_use_dir}\", you will need to backup this using FTP or SCP." => "El magatzem de la teva galeria de fitxers està fixat a \"{\$gal_use_dir}\", necessitaràs fer-ne còpies de seguretat emprant FTP o SCP.",
"If any of your forums have attachments stored in the directory you will need to backup these using FTP or SCP." => "Si qualsevol dels teus fòrums porta adjunts al seu directori necessitaràs fer-ne còpia de seguretat a través d' FTP o SCP.",
"Upload a backup" => "Puja una còpia de seguretat",
"Upload backup" => "Puja còpia de seguretat",
"edit gallery" => "edita la Galeria",
"rebuild thumbnails" => "reconstrueix miniatures",
"upload image" => "Pujar imatge",
"list gallery" => "llista la galeria",
"original size" => "tamany original",
"return to gallery" => "torna a la galeria",
"edit image" => "edita dibuix",
"smaller" => "més petit",
"bigger" => "més gran",
"prev image" => "imatge prèvia",
"popup window" => "finestra emergent",
"next image" => "propera imatge",
"stop" => "atura",
"imagescale" => "escala de la imatge",
"or create a new category" => "o crear una nova categoria",
"or create a new location" => "o crear una nova localització",
"comma separated usernames" => "nom d'usuari separat per comes",
"comma separated username:role" => "separat per comes nom d'usuari:funció",
"with roles" => "amb els rols",
"Chair" => "Cadira",
"Optional" => "Opcional",
"permission" => "permís",
"remove from this category &amp; all its children" => "elimina d'aquesta categoria &amp; i totes les seves filles",
"remove from this category only" => "elimina només aquesta categoria",
"remove page" => "eliminar pàgina",
"admin directory tpl" => "administrar plantilla per a directori de categories",
"browse" => "examina",
"related" => "relacionat",
"validate" => "valida",
"add a site" => "afegiu un lloc",
"add a category" => "afegeix una categoria",
"search" => "cerca",
"edit template" => "edita plantilla",
"list articles" => "llista d'articles",
"view articles" => "visualitza articles",
"create zone" => "crear zona",
"save the banner" => "desar el banner",
"edit blog tpl" => "edita plantilla per a bitàcola",
"Allow trackback pings" => "Permet trackback pings",
"try" => "prova",
"display" => "pantalla",
"admin quicktags" => "admin barres d'eines",
"create new block" => "crear un nou bloc",
"list quizzes" => "fes llista de qüestionaris",
"quiz stats" => "estadístiques de tests",
"edit this quiz" => "edita aquest test",
"admin quizzes" => "administrar qüestionaris",
"admin quizzes tpl" => "administrar plantilla per a qüestionaris",
"results" => "resultats",
"create page" => "crear pàgina",
"edit submissions tpl" => "edita plantilla per a submissions",
"list submissions" => "llista de submissions",
"add to the set" => "afegeix al conjunt",
"Search " => "Cerca ",
"replace" => "reemplaça",
"Admin ephemerides" => "Administrar efemèrides",
"admin Ephemerides tpl" => "administrar plantilla per a Efemèrides ",
"All ephemerides" => "Totes les efemèrides",
"list sheets" => "llista fulls",
"new question" => "pregunta nova",
"approve" => "aprova",
"configure listing" => "configura llistat",
"topic" => "tòpic",
"save and approve" => "desa i aprova",
"new topic" => "nou tema",
"reject" => "rebutja",
"accept" => " accepta",
"refuse" => "rebutja",
"add new" => "afegeix nou/va",
"add role" => "afegeix funció",
"new minor" => "nou menor",
"new major" => "nou major",
"admin processes" => "administració de processos",
"admin activities" => "administració d'activitats",
"admin roles" => "administració de rols",
"edit this process" => "edita aquest procés",
"monitor" => "vigilància",
"send instance" => "enviar instància",
"create new gallery" => "crear una nova galeria",
"result" => "resultat",
"reload" => "recarrega",
"Note: This install script may be potentially harmful so we strongly\n    \t\trecommend you to disable the script and then proceed into Tiki. If\n    \t\tyou decide to reuse later, just follow the instructions in\n\t\ttiki-install.php to restore" => "Nota: Aquesta seqüència (script) d'instal·lació pot ser potencial perillós si es deixa accesible a tothom, així que recomanem encoratjadament \n    \t\t que la desactivis abans de pasar a connectar-te a Tiki. Si\n    \t\tdecideixes tornar-la a fer servir més endavant, només cal que segueixis les instruccions a\n\t\ttiki-install.php per restaurar-la",
"Tiki has detected your PHP memory limit at only 8 Megs" => "Tiki ha detectat que el teu limit de memòria per a PHP es troba en només  8 MB",
"edit repository" => "edita dipòsit",
"source" => "font",
"list articles tpl" => "plantilla per a llista d'articles",
"edit new article" => "edita nou article",
"admin Banners" => "administració de Banners",
"admin Banners tpl" => "administrar plantilla per a Pancartes",
"create new blog" => "crear una nova bitàcola",
"admin cache" => "administrar caxé",
"admin cache tpl" => "administrar plantilla per a caxé ",
"admin DynamicContent tpl" => "administrar plantilla de Contigut dinàmic ",
"list faqs tpl" => "llistat de preguntes més freqüents",
"upload file" => "puja arxiu",
"Edit a file using this form" => "Edita un arxiu utilitzant aquest formulari",
"delete selected files" => "esborra els arxius seleccionats",
"browse gallery" => "fulleja galeria",
"Flash binary (.sqf or .dcr)" => "Arxiu Flash (.sqf or .dcr)",
"list posts tpl" => "plantilla per a llista d'enviaments",
"edit blog" => "Edita bitàcola",
"edit new submission" => "edita la nova col·laboració",
"admin live support tpl" => "xxx",
"set as operator" => "definit com a operador",
"add topic" => "afegiu-hi un tema",
"install" => "instal·la'l",
"wiki create" => "crea wiki",
"wiki overwrite" => "sobrescriu wiki",
"back" => "enrera",
"Assign permissions to page" => "Assignar permisos a la pàgina",
"Current permissions for this page" => "permisos actuals per a aquesta pàgina",
"remove from this page" => "Esborrar d'aquesta  pàgina",
"remove from this structure" => "Esborrar d'aquesta estructura",
"No individual permissions; category or global permissions apply" => "Cap permís local (individual); s'aplicaran els permisos de la categoria o els globals",
"this page" => "aquesta pàgina",
"this structure" => "aquesta estructura",
"Current permissions for categories that this page belongs to" => "Permisos actuals per categories a les quals pertany aquesta pàgina",
"Send email notifications when this page changes to" => "Envia notificacions email quan aquesta pàgina canvii a",
"add email" => "afegeix una adreça de correu-e",
"Notifications" => "Notificacions",
"clear stats" => "esborrar estadístiques",
"Edit received page" => "Edita pàgina rebuda",
"admin Referer stats" => "administrar estadístiques dels Referents",
"admin Referer stats tpl" => "administrar plantilla per a estadístiques dels Referents",
"last" => "darrer/a",
"send me my password" => "envia'm la meva contrasenya",
"searched" => "cercat",
"galleries" => "galeries",
"blog posts" => "publicacions a bitàcoles",
"wiki pages" => "pàgines wiki",
"admin send objects tpl" => "administrar plantilla per a enviar objectes",
"site" => "lloc",
"clear" => "neteja",
"add article" => "afegeix article",
"create new sheet" => "crea un nou full",
"admin Tiki Shoutbox" => "admin quadre d'avisos del Tiki",
"admin Tiki Shoutbox tpl" => "administrar plantilla per a Tiki Shoutbox",
"send answers" => "envia respostes",
"move to right column" => "moure ala columna dreta",
"unassign" => "desassigna",
"move to left column" => "moure a la columna esquerra",
"remove folder" => "elimina carpeta",
"refresh cache" => "refresca memòria cau",
"use google map locator" => "empra el localitzador dels mapes de google",
"admin mode" => "mode administrador",
"trash" => "paperera",
"empty trash" => "buida paperea",
"remove from trash" => "elimina de la paperera",
"edit user files" => "edita els arxius de l'usuari",
"no comments" => "sense comentaris",
"edit items" => "edita items",
"list charts" => "llista de gràfiques",
"last chart" => "Darrera llista",
"view faq" => "visualitza puf",
"view faq tpl" => "visualitza plantilla de puf",
"admin menus tpl" => "administrar plantilla per a menús",
"add suggestion" => "afegeix un suggeriment",
"monitor this forum" => "Segueix aquest fòrum",
"stop monitoring this forum" => "deixa de seguir aquest fòrum",
"delete selected topics" => "esborrar temes seleccionats",
"stop monitoring this topic" => "deixa de seguir aquest tòpic",
"Comments below your current threshold" => "Comentaris sota mínim llindar actual",
"list attachments" => "llista adjunts",
"remove image" => "elimina imatge",
"add contacts" => "afegeix contactes",
"DATE-of" => "de",
"You cannot edit this page because it is a user personal page" => "No pots editar aquesta pàgina, ja que és una pàgina personal d'un usuari",
"Permission denied you cannot assign permissions for this page" => "No tens autorització per assignar permisos en aquesta pàgina",
"Cannot read file" => "No es pot llegir l'arxiu",
"Permission denied you cannot upload files" => "Permís denegat, no podeu pujar fitxers",
"cannot process upload" => "no s'ha pogut processar la pujada",
"Your email address has been removed from the list of addresses monitoring this tracker" => "La teva adreça de correu-e ha estat eliminada de la llista d'adreces subscrites a aquest formulari",
"Your email address has been added to the list of addresses monitoring this tracker" => "La teva adreça de correu-e ha estat afegida a la llista d'adreces subscrites a aquest formulari",
"Cancel monitoring" => "Deixa de vigilar-ho",
"Your email address has been removed from the list of addresses monitoring this item" => "La teva adreça de correu-e ha estat eliminada de la llista d'adreces subscrites a aquest item",
"Your email address has been added to the list of addresses monitoring this item" => "La teva adreça de correu-e ha estat afegida a la llista d'adreces subscrites a aquest item",
"pdf" => "pdf",
"categories" => "categories",
"UTC" => "UTC",
"Ratio" => "Ratio",
"proc" => "proc",
"pos" => "pos",
"emot" => "emot",
"pop" => "pop",
"new image uploaded by" => "nova imatge pujada per",
"new subscriptions" => "subscripcions noves",
"new item in tracker" => "nova entrada al formulari",
"tikiwiki logo" => "logo tikiwiki",
"show" => "mostrar",
"hide" => "oculta",
"Table Of Contents" => "Taula de continguts",
"field is not numeric" => "el camp no és numèric",
"message" => "missatge",
"Include an article" => "Inclou un article",
"select all" => "selecciona-ho tot",
"All fields must be from the same tracker" => "Tots els camps han de ser del mateix formulari",
"missing fields list" => "manca llista de camps",
"no such file" => "Aquest fitxer no hi és",
"downloads" => "descàrregues",
"download" => "descarregar",
"hide categories" => "oculta categories",
"Admin categories" => "Administra categories",
"reply" => "respon",
"monitor this topic" => "Segueix aquest tema",
"active perms" => "activar permisos",
"Dls" => "Descàrr..",
"move selected files" => "mou els arxius seleccionats",
"Thank you for you registration." => "Gràcies pel seu registre.",
"from\nthe mapfile:" => "des del\n mapfile:",
"compare" => "comparar",
"diff" => "dif",
"older version" => "versió més vella",
"Click the :: options in the Menu for more options." => "Clica les opcions :: en el Menú per a més opcions.",
"Please, also see" => "Si us plau, mira també",
"for more setup details." => "per a més opcions.",
"Note 1:" => "Nota 1:",
"You can remove this module in" => "Pots eliminar aquest mòdul a",
"Note 2:" => "Nota 2:",
"Create pdf" => "Crea un pdf",
"List pages where I am a creator" => "Llista pàgines on en sóc creador",
"by creator" => "pel creador/a",
"List pages where I am a modificator" => "Llista pàgines on en sóc modificador",
"by modificator" => "pel modificador/a",
"at tracker" => "al formulari",
"check / uncheck all" => "marcar / desmarcar tot",
"Tiki sections and features" => "Seccions del Tiki i Funcionalitats",
"tiki.org help" => "ajuda en tiki.org",
"Site Logo and Identity" => "Logo del lloc i Identitat",
"Storing files in a directory" => "Guarda arxius en un directori",
"please read" => "Si us plau, llegiu-ho",
"yes" => "si",
"Click here for more details." => "Fes clic aquí per a més detalls.",
"Best Language" => "Millor idioma",
"Tiki preferences value field in db is set to be max. 250 characters long by default until now. That applies for the custom code content too. Check this field if you want to update your preferences database table to support more than 250 chars (although it was tested and works fine with mysql, it's recommended to backup your data manually before any database update)" => "El valor del camp de les preferències Tiki a la base de dades està fixat en com a màxim 250 caracters de llarg (per defecte fins ara). Això té validesa també sobre sobre el contingut del codi adaptat. Marca aquesta casella si vols actualitzar la taula de preferències de la teva base dades per permetre més de 250 caracters (malgrat ha estat provat i funciona bé amb mysql, és recomanable fer una còpia de seguretat de la base de dades manualment abans de qualsevol actualització de la base de dades)",
"Users &amp; groups" => "Usuaris &amp; grups",
"This page is to configure settings of RSS feeds generated/exported by Tiki. To read/import RSS feeds, look for \"RSS Modules\" on the application menu, or" => "Aquesta pàgina és per configurar els paràmetres de les alimentacions RSS generades/exportades per Tiki. Per llegir/importar alimenacions RSS, cerca \"Mòduls RSS\"  en el menú principal de l'aplicació, o",
"<b>Feed</b>" => "<b>Alimentació</b>",
"<b>enable/disable</b>" => "<b>habilita/deshabilita</b>",
"<b>Max number of items</b>" => "<b>Quantitat màxima d'ítems</b>",
"Feed for Articles" => "Alimentació per als articles",
"Feed for Weblogs" => "Alimentació per a les bitàcoles web",
"Feed for Image Galleries" => "Alimentació per a les galeries d'imatges",
"Feed for File Galleries" => "Alimentació per a les galeries d'arxius",
"Feed for the Wiki" => "Alimentació per al Wiki",
"Feed for individual Image Galleries" => "Alimentacío per a galeries d'imatges individuals",
"Feed for individual File Galleries" => "Alimentació de galeria d'arxius individuals",
"Feed for individual weblogs" => "Alimentació per a bitàcoles web individuals",
"Feed for individual forums" => "Alimentació per fòrums individuals",
"Feed for mapfiles" => "Contigut per als mapfiles",
"Feed for individual tracker items" => "Alimentació RSS per ítems individuals de formularis",
"Feed for tracker items" => "Alimentació RSS per a ítems de formularis",
"Feed for upcoming calendar events" => "Alimentació RSS per propers esdeveniments del calendari",
"Prefix breadcrumbs with 'Location:' label?" => "Posa un prefix al Rastre amb l'etiqueta 'Lloc:'?",
"Site Search" => "Cerca del lloc",
"Change style only" => "Canvia només l'estil de tema (estètica)",
"WARNING : Old and New trackers cannot coexist. Trackers created with new library\nwill not work with old library and conversely" => "AVÍS : Formularis vells i nous no poden coexistir. Els Formularis creats amb la nova llibreria\nno funcionaran amb la vella llibreria i viceversa",
"PDF generation" => "generació de PDF",
"Statistic" => "Estadístiques",
"Edit Existing Forums" => "Edita Fòrums existents",
"configure repositories" => "configura dipòsits",
"configure this repository" => "configurar aquest dipòsit",
"copy rules" => "copiar regles",
"subscriptions" => "subscripcions",
"Tip: hold down CTRL to select multiple" => "Pista: menté apretada la tecla CTRL per a seleccions múltiples",
"activate" => "activa",
"fields" => "camps",
"active permissions" => "permisos actius",
"filename" => "nom de l'arxiu",
"filesize" => "mida de l'arxiu",
"filetype" => "tipus d'arxiu",
"longdesc" => "descripció llarga",
"Import/Export CSV Data" => "Importa/Exporta dades en format CSV",
"Add a new group" => "Afegir un grup nou",
"List all members" => "Llista tots els membres",
"Add a new user" => "Afegeix un nou usuari",
"manage group assignments" => "gestiona les assignacions a grups",
"set default groups" => "especifica els grups per defecte",
"Popup Window" => "Finestra emergent",
"details" => "detalls",
"Welcome to the Tiki Chat Rooms" => "Benvinguts/des a les sales de Xat del Tiki",
"Please select a chat channel" => "Si us plau, seleccioneu un canal de xat",
"enter chat room" => "entrar a la sala de xat",
"There are no channels setup, please contact a site admin" => "No existeix cap canal configurat, si us plau, contacte a l'admin del lloc",
"Chatroom" => "Sala de xat",
"Active Channels" => "Canals actius",
"Users in this channel" => "Usuaris en aquest canal",
"Channel Information" => "Informació del canal",
"Channel" => "Canal",
"Use :nickname:message for private messages" => "Empra :sobrenom:missatge per missatges privats",
"Use [URL|description] or [URL] for links" => "Empra [URL|descripció] ó [URL] per a enllaços",
"Use (:smileyname:) for smileys" => "Empra (:nom_d_emotico:) per emoticons",
"Create PDF" => "Crear PDF",
"PDF Settings" => "Configuració de PDF",
"Select Wiki Pages" => "Seleccionar les Pàgines Wiki",
"Use ...page... to separate pages in a multi-page article" => "Empra ...page... per separar pàgines en un article multi-pàgina",
"answer" => "resposta",
"Use this section to set the language of the version you are currently working on." => "Empra aquesta secció per especificar l'idioma de la versió en la qual estàs treballant actualment.",
"Set of Translations" => "Conjunt de Tranduccions",
"Translation of:" => "Traducció de:",
"Enter the name of the page for which the current page is the translation." => "Introdueix el nom de la pàgina per a la cual aquesta és la traducció.",
"Add to the Set" => "Afegeix al conjunt",
"graph" => "gràfica",
"icon" => "icona",
"Available File Galleries" => "Galeries d'arxius disponibles",
"configure forum" => "configura el fòrum",
"start" => "començar",
"end" => "fi",
"roles" => "rols",
"Add role" => "Afegeix funció",
"active process" => "procés actiu",
"invalid" => "invàlida",
"invalid process" => "procés no vàlid",
"valid process" => "procés vàlid",
"activities" => "activitats",
"aborted" => "abortat/da",
"value" => "valor",
"exceptions" => "excepcions",
"Please enter your database connection info" => "Si us plau, introdueix la informació de connexió a la base de dades",
"The type of database you intend to use" => "El tipus de base de dades que tens intenció d'emprar",
"Hostname or IP for your MySQL database, example: localhost if running in the same machine as tiki" => "Nom d'allotjament (Hostname) o adreça IP de la teva base de dades MySQL; exemple: localhost si s'executa en la mateixa màquina que Tiki",
"If you use SQLite, insert the path and filename to your database file" => "Si empres SQLite, introdueix la ruta i nom d'arxiu de l'arxiu de la teva base de dades",
"Database password" => "Contrasenya de la base de dades",
"The name of the database where tiki will create tables. You can create the database using mysqladmin, or PHPMyAdmin or ask your\nhosting service to create a MySQL database.  Normally Tiki tables won't conflict with other product names" => "El nom de la base de dades on Tiki crearà les taules. Pots crear la base de dades emprant mysqladmin, o PHPMyAdmin o demanant-ho al teu \nservei d'allotjament web per que et creïn la base de dades MySQL.  Normalment, les taules de Tiki no entren en conflicte amb els noms de les taules d'altres aplicacions",
"If you use Oracle, you can put your TNS Name here and leave hostname empty\nor you override tnsnames.ora and put your SID here and fill your hostname:port above" => "Si empres Oracle, pots posar el teu Nom TNS aquí i deixar el hostname buit\no sobreescriure  tnsnames.ora i posar el teu SID aquí i omplir el teu hostname:port més amunt",
"Create database (clean install) with profile" => "Crea la base de dades (instal·lació neta) amb perfil",
"Descriptions of the available profiles" => "Descripcions dels perfils disponibles",
"backup your database" => "fes una còpia de seguretat de la teva base de dades",
"with mysqldump or phpmyadmin before you proceed" => "amb mysqldump o phpmyadmin abans de continuar",
"For database update from 1.8 or later" => "Per a actualitzacions de la base de dades des de 1.8 o posterior",
"If you upgrade from 1.8.x you <b>MUST</b> run tiki_1.8to1.9 and don't need an additional script" => "Si actualitzes des de 1.8.x, <b>NECESSITES</b> executar tiki_1.8to1.9 i no necessites cap seqüència (script) addicional",
"If you upgrade from a previous 1.9.x version, use tiki_1.8to1.9, too. (ex.: 1.9.2 to 1.9.5)" => "Si actualitzes des d'una versió prèvia 1.9.x, empra tiki_1.8to1.9, també. (ex.: 1.9.2 a 1.9.5)",
"For database update from 1.7.x, please visit <a target=\"help\" href=\"http://tiki.org/UpgradeTo18\">Tiki database 1.7.x to 1.8x instructions" => "Per actualitzacions de la base de dades des de 1.7.x, si us plau consulta les <a target=\"help\" href=\"http://tiki.org/UpgradeTo18\">instruccions per passar de la base dades de Tiki 1.7.x a 1.8.x",
"For information about tiki-secdb_*.sql files, please see <a target=\"help\" href=\"http://tiki.org/AdminSecurity\">http://tiki.org/AdminSecurity" => "Per informació sobre els arxius tiki-secdb_*.sql , pots consultar <a target=\"help\" href=\"http://tiki.org/AdminSecurity\">http://tiki.org/AdminSecurity",
"Please enter your admin password to continue" => "Si us plau, introdueix la teva contrasenya d'usuari administrador (admin) per continuar",
"Print operations executed successfully" => "Llistat d'operacions executades amb èxit",
"Print operations failed" => "Llistat d'operacions que han tingut algun problema",
"READ THE FOLLOWING NOTES BEFORE ENTERING TIKI USING THE LINKS BELOW!" => "LLEGEIX LES NOTES SEGÜENTS ABANS D'ENTRAR A TIKI AMB ELS ENLLAÇOS DE SOTA!",
"Make sure tiki gets more than 8 MB of memory for script execution. \nSee file php.ini, the relevant key is memory_limit. Use something like memory_limit = 16M and restart your \nwebserver. Too little memory will cause blank pages!" => "Assegura't que tiki disposa de més de 8 MB de memòria per a l'execució de seqüències (scripts). \nMira a l'arxiu php.ini, la clau rellevant és memory_limit. Empra quelcom de l'estil memory_limit = 16M i re-inicia el teu \nservidor web. Massa poca memòria provocarà pàgines en blanc!",
"If this is a first time installation, go to tiki-admin.php after login to start configuring your new Tiki installation" => "Si aquesta és una instal·lació inicial, ves a tiki-admin.php després de connectar-te i comença a configurar la teva nova instal·lació Tiki",
"If you did a Tiki upgrade, make sure to clean the caches (templates_c/) manually or by using the feature on admin / system" => "Si has fet una actualització de Tiki, assegura't de netejar les memòries cau (templates_c/) manualment o a través d'emprar la funcionalitat a Admin > Administrador de sistema",
"Now you may proceed by clicking one of these links" => "Ara ja pots continuar punxant en algun d'aquests enllaços",
"Click here to disable the install script and proceed into tiki" => "Punxa aquí per desactivar la seqüència (script) d'instal·lació i procedir a entrar a Tiki",
"Click here to proceed into tiki without disabling the script" => "Punxa aquí per procedir a entrar a Tiki sense deshabilitar la seqüència (script)",
"do not use your Back button in your browser!" => "no empris el botó Enrera del teu navegador!",
"rollback" => "restableix",
"Listing Gallery" => "Contingut de la galeria",
"Gallery Files" => "Galeries de fitxers",
"rollback to this version" => "restableix aquesta versió",
"Print Wiki Pages" => "Imprimir pàgines del Wiki",
"add page" => "afegeix pàgina",
"add structure" => "afegeix estructura",
"click to navigate" => "fes clic per navegar",
"Total threads" => "Quantitat de missatges",
"Average threads per topic" => "Mitjana de missatges per tema",
"You can include the file in an HTML/Tiki page using" => "Podeu incloure l'arxiu en una pàgina Tiki/html emprant",
"Now enter the file URL" => "Introdueix ara la URL de l'arxiu",
" or upload a local file from your disk" => "o puja l'arxiu des del teu disc",
"received" => "rebut/da",
"submitted" => "enviat/da",
"shared" => "compartit/da",
"accepted by task user and creator" => "acceptada per l'usuari de la tasca i creador",
"accepted user and creator" => "ususari i creador acceptat",
"not accepted by one user" => "no acceptada per un/a usuari/a",
"not accepted user" => "usuari no acceptat",
"waiting for me" => "esperant-me a mi",
"waiting for other user" => "esperant a un altre/a usuari/a",
"move into trash" => "mou a la paperera",
"waiting / not started" => "en espera / no iniciada",
"waiting" => "esperant",
"shared for group" => "compartida per al group",
"accepted by user" => "acceptada per l'usuari/a",
"no / rejected" => "no / rebutjada",
"accepted by creator" => "acceptada pel creador",
"priority" => "prioritat",
"select one" => "selecciona un/a",
"undo trash" => "desfés paperera",
"show:" => "mostra:",
"all shared tasks" => "totes les tasques compartides",
"previous chart" => "chart anterior",
"next chart" => "diagrama següent",
"avg" => "mtj",
"post new comment" => "publicar missatge nou",
"Post New Comment" => "Publicar missatge nou",
"HTML tags are not allowed inside comments" => "No s'admeten etiquetes html als comentaris",
"moderator actions" => "accions del moderador",
"move selected topics" => "moure temes seleccionats",
"unlock selected topics" => "desbloqueja tòpics seleccionats",
"lock selected topics" => "bloqueja temes escollits",
"merge" => "escapçar",
"merge selected topics" => "Escapçar els temes escollits",
"reported messages:" => "missatges reportats:",
"queued messages:" => "missatges a la cua:",
"account" => "compte",
"Projects" => "Projectes",
"Projects configuration" => "Configuració dels projectes",
"Site Identity features" => "Paràmetres de la Identitat del Lloc",
"Click here to delete this category" => "Fes clic aquí per esborrar aquesta categoria",
"Group doesnt exist" => "Aquest grup no existeix",
"User doesnt exist" => "Aquest usuari no existeix",
"Event without Name" => "Event sense nom",
"No channel indicated" => "No s'ha indicat cap canal",
"No nickname indicated" => "No s'ha indicat cap sobrenom",
"Please create a directory named \$map_path to hold your map files." => "Si us plau, creeu un directori anomenat \$map_path per incloure els vostres fitxers map.",
"Permision denied" => "Permís denegat",
"Selected category" => "Categoria seleccionada",
"Active group" => "Grup actiu",
"Create object" => "Crea l'objecte",
"sql queries" => "crides sql",
"Request failed for %s" => "La petició per %s ha fallat",
"Insert a Mediawiki/Wikipedia-type contents link box on a wiki page, using maketoc." => "Inserta un requadre amb enllaços de taula de continguts del tipus Mediawiki/Wikipedia en una pàgina Wiki, emprant maketoc.",
"Inserts a Mediawiki/Wikipedia-look thumbnail with caption that links to a full-size image." => "Inserta un contacte estil Mediawiki/Wikipedia amb un peu de figura que enllaça a la imatge sencera.",
"Insert a Tikipedia-look box on wiki page" => "Inserta una caixa estil Tikipedia en una pàgina Wiki",
"group not found" => "No s'ha trobat el grup",
"group already exist" => "El grup ja existeix",
"user not found" => "usuari no trobat",
"the main workspace group cant be removed" => "el grup principal de l'espai de treball no pot ser eliminat",
"Not a portfolio workspace" => "No és un espai de treball de tipus portfolio",
"Assignment not found" => "No s'ha trobat l'assignació de deures",
"Page not found\".\" \".\$page));\r\n\t}\r\n}else{\r\n\t\$smarty->assign('error_msg', tra(\"Param name not found" => "Plana no trobada\".\" \".\$page));\r\n\t}\r\n}else{\r\n\t\$smarty->assign('error_msg', tra(\"Param name not found",
"Owner not set" => "No s'ha especificat el propietari",
"Anonymous and Registered group can't be added" => "No es poden afegir els grups Anonymous i Registered",
"Page not found\".\" \".\$page));\n\t}\n}elseif (!\$exit_module){\n\t\$smarty->assign('error_msg', tra(\"Param name not found" => "Plana no trobada\".\" \".\$page));\n\t}\n}elseif (!\$exit_module){\n\t\$smarty->assign('error_msg', tra(\"Param name not found",
"Param name not found" => "No s'ha trobat nom de parametre",
"are you sure to remove the assigment" => "Segur que vols eliminar aquesta assignació de deures?",
"Cuaderno de Problemas de" => "Quadern de problemes de",
"Subject Administration" => "Administració d'assignatures",
"Workspace type" => "Tipus d'espai de treball",
"Hide workspace on the list of user assigned workspaces" => "Amaga espai de treball de la llista d'espais de treball assignats a un usuari",
"Personal workspace" => "És un espai de treball personal?",
"Save Zone" => "Guarda Zona",
"Title Style" => "Estil de Títol (si no saps què és, deixa-ho en blanc)",
"Data Style" => "Estil de dades (si no saps què és, deixa-ho en blanc)",
"Module params" => "Paràmetres del mòdul (si no saps què és, deixa-ho en blanc)",
"Remove zone" => "Elimina zona",
"Create zone" => "Crea zona",
"No zones defined, please create a first zone to start" => "No s'han definit zones, si us plau, crea primer una zonaper començar",
"No modules assigned to the zone, please assign a first module" => "No s'han assignat mòduls a la zona, si us plau, assigna un primer mòdul",
"Permission group" => "Grup de permisos",
"Premissions" => "Permisos",
"Delete from structure" => "Esborra de l'estructura",
"Workspace type roles" => "rols per a un tipus d'espai de treball",
"Workspace type resources" => "Recursos per a un Tipus d'espai de treball",
"Workspace Type Roles" => "Rols per a un Tipus d'espai de treball",
"Role name" => "Nom de Rol",
"Role description" => "Descripció de Rol",
"Permission Group" => "Grup de permisos",
"Contact email" => "Mail de contacte",
"Population" => "Població",
"Transaction" => "Transacció",
"Examine" => "Examina",
"Unregister" => "No registrat",
"as well as assign or edit many others." => "així com assignar o editar molts/es altres/as.",
"The menu module installed by default is named" => "El mòdul de menú instal·lat per defecte s'anomena",
"it is a \"custom module\" which includes menu ID " => "és un \"mòdul customitzat\" que inclou el menú per té per ID ",
"That menu is stored in database and it can be edited from " => "Aquell menú es guarda a la base de dades i pot ser editat des de ",
"Do not mix this with the original <em>application_menu</em> module" => "No barregeu això amb el mòdul original <em>application_menu</em>",
"created by" => "creat per",
"toolbox" => "caixa d'eines",
"slideshow backward" => "endavant passi de diapositives",
"by the " => "per el/la ",
"phpLayers Menus" => "Menús en capes de php (phpLayers)",
"Back links" => "Retroenllaços",
"You have to \ncreate a gallery first!" => "Primer cal \ncrear una galeria!",
"Amount of transactions" => "Quantitat de transaccions",
"Approval?" => "Aprovació?",
"Approved?" => "Aprovat/da?",
"Balance" => "Balanç",
"balance" => "balanç",
"Blogroll" => "Llista de blocs",
"Create a new Currency" => "Crea una nova moneda",
"Currencies Admin" => "Administrador de monedes",
"Currency Provider Unique Name" => "Nom únic del proveïdor de moneda",
"DNS check failed for %s" => "La comprovació de DNS ha fallat per %s",
"Domain for list of CC service providers" => "Domini per la llista de proveïdors de serveis CC",
"Edit currency" => "Edita moneda",
"Examine Currency" => "Examina la moneda",
"last transaction date" => "última data de transacció",
"Last transaction" => "Última transacció",
"List Currencies" => "Llista les monedes",
"Listed?" => "Llistat?",
"Listed publicly" => "Llistat públicament",
"Logs" => "Registres",
"Modify a Currency" => "Modifica una moneda",
"My Currencies" => "Les meves monedes",
"New Transaction with" => "Nova transacció amb",
"Number of transactions" => "Nombre de transaccions",
"out" => "fora",
"Page not found\".\" \".\$page));\n\t}\n}else{\n\t\$smarty->assign('error_msg', tra(\"Param name not found" => "Pàgina no trobada\".\" \".\$page));\n\t}\n}o{\n\t\$smarty->assign('error_msg', tra(\"Nom de paràmetre no trobat",
"Pending Registration" => "Registre pendent",
"Permission denied you cannot create assignments" => "Permís denegat, no pots crear assignacions",
"Permission denied you cannot edit assignments" => "Permís denegat, no pots editar assignacions",
"Permission denied you cannot remove assignments" => "Permís denegat, no pots eliminar assignacions",
"record" => "registre",
"Register Owner" => "Propietari del registre",
"Requires approval" => "Necessita aprovació",
"Reregister" => "Reregistre",
"revert" => "inverteix",
"Revert Transaction" => "Inverteix la transacció",
"Sorry, the currency \$currency is not available." => "Disculpa, la moneda \$currency no es troba disponible.",
"Sorry, you are not registered into currency \$currency." => "Disculpa, no t'has enregistrat encara per a la moneda \$currency. Enregistra't-hi primer'",
"That one can be heavily customized to match style used but it can be currently done only by editing mod-application_menu.tpl file \"manually\"" => "Aquesta pot ser molt adaptada per encaixar amb l'estil emprat però això només es pot fer a través d'editar manualment l'arxiu 'mod-application_menu.tpl''",
"{\$thelist[i].age|duration} ago" => "fa {\$thelist[i].age|duration}",
"total volume" => "volum total",
"transactions" => "transaccions",
"Your message has been queued for approval, the message will be posted after\r\na moderator approves it." => "El teu missatge està pendent d'aprovació, s'enviarà quan el moderador l'aprovi.",
"IMAP/POP3 BaseDSN" => "IMAP/POP3 BaseDSN",
"participants" => "participants",
"perso" => "perso",
"dsn" => "dsn",
"vertical" => "vertical",
"Tikiwiki CMS/Groupware" => "Tikiwiki CMS/Groupware",
"zoom" => "zoom",
"adm" => "adm",
"P" => "P",
"F" => "F",
"pre" => "pre",
"Another post with the same title and content already exists" => "Ja hi ha una altra publicació amb el mateix títol i contingut",
"Textarea options: quicktags,width,height,max,listmax - Use Quicktags is 1 or 0, widthis indicated in chars, height is indicated in lines, max is the maximum number of characters that can be saved, listmax isthe maximum number of characters that are displayed in list mode." => "Opcions d'Àrea de Text: marques_ràpides,amplada,alçada,max,llist_max - Utilització: marques_ràpides pot ser 1 (mostrar-les) o 0 (no mostrar-les), l'amplada s'indica en caracters, l'alçada s'indica en línies, max és el número màxim de caracters que poden ser guardats, llist_max és el número màxim de caracters que són mostrats en el mode de llista.",
"User Selector: use options for automatic field feeding : you can use 1 for author login or 2 for modificator login." => "Selector d'usuari: empra opcions per a alimentació automàtica del camp: pots emprar 1 per al nom d'usuari/a de l'autor/a o 2 per al nom d'usuari/a de la persona modificadora.",
"Category options: parentId" => "Opcions de categories options: parentId (Id del pare dels ítems de la categoria a incloure)",
"Item Link options: trackerId,fieldId,linkToItem links to item from trackerId which fieldId matches the content of that field. linkToItem 1|0 to create a link to the item in view mode and listing" => "Opcions d'enllaç de l'ítem: IdFormulari,IdCamp,enllaç_a_Item enllaça a l'ítem de l'IdFormulari en el qual l'IdCamp coincideix amb el contingut d'aquell camp. enllaç_a_Item pot ser 1 ó 0 per crear, o no, l'enllaç a l'ítem en el mode de visualització i llistat",
"~np~{~/np~ARTICLES(max=>3,topic=>topicName,type=>type,categId=>Category parent ID)}{ARTICLES} Insert articles into a wikipage" => "~np~{~/np~ARTICLES(max=>3,topic=>NomdelTopic,type=>tipus,categId=>ID de categoria pare/mare)}{ARTICLES} Inserta els articles a una pàgina Wiki",
"no such attachment on this page" => "no hi ha aquest adjunt en aquesta pàgina",
"num is optional and is the order number of the attachment in the list. If not provided, a list of all attachments is displayed.  Inline makes the comment be the text of the link." => "num és opcional i és el número d'ordre de l'adjunt a la llista. Si no s'especifica, es mostra una llista de tots els adjunts.  Enlinia fa que el comentari sigui el text de l'enllaç.",
"~np~{~/np~EVENTS(calendarid=>id1+id2,maxdays=>365,max=>-1,datetime=>0|1,desc=>0|1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=>id1+id2,maxdays=>365,max=>-1,datetime=>0|1,desc=>0|1)}{EVENTS} Inserta el resultat de l'alimentació rss en una pàgina Wiki",
"~np~{~/np~RSS(id=>feedId+feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId+feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Inserta el resultat d'una o vàries alimentacions rss en una pàgina Wiki",
"move %s in %s" => "mou %s a %s",
"Please notify the admin that the \"sender email\" option in the General configuration section has not been set.  An internal Tiki message has been sent to the admin to validate your registration request.  An email should arrive shortly after you have been validated, with information on how to login for the first time into this site" => "Si us plau, notifica a l'administrador que la opció del \"correu-e de l'enviador\" a la secció de configuració General no ha estat especificada.  S'ha enviat un missatge intern Tiki a l'administrador per validar la teva petició de registre.  T'hauria d'arribar un correu-e just després de que s'hagi validat la teva petició, amb informació sobre com connectar-te per primera vegada en aquest lloc",
"TikiWiki Assistant" => "Assitent Tikiwiki",
"Thank you for installing TikiWiki CMS/Groupware" => "Gràcies per instal·lar TikiWiki CMS/Groupware",
"Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"TikiWiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Llegeix la <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Documentació de TikiWiki\" target=\"_blank\">documentació de la configuració</a>",
"To learn more, visit: <a href=\"http://www.tiki.org\" title=\"The TikiWiki Community\" target=\"_blank\">http://www.tiki.org</a>" => "Per aprendre més, visita: <a href=\"http://www.tiki.org\" title=\"La Comunitat TikiWiki\" target=\"_blank\">http://www.tiki.org</a>",
"TikiWiki Documentation" => "Documentació de TikiWiki",
"For help, visit <a href=\"http://doc.tiki.org\" title=\"TikiWiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "Per ajuda, visita <a href=\"http://doc.tiki.org\" title=\"Documentació de TikiWiki\" target=\"_blank\">http://doc.tiki.org</a>",
"Confirm your action" => "Confirma la teva acció",
"Please, confirm your action" => "Si us plau, confirma la teva acció",
"Use categories to regroup various Tiki objects." => "Utilitza les categories per agrupar diversos objectes tiki.",
"Report PHP errors only for admin" => "Informe dels errors de PHP tan sols per l'administrador",
"Automatic (uses HTTPS variable)" => "Automàtic (utilitza una variable HTTPS)",
"Help system" => "Sistema d'Ajuda",
"Auth Type" => "Tipus d'autenticació",
"IMAP/POP3/LDAP Host" => "Servidor IMAP/POP3/LDAP",
"IMAP/POP3/LDAP Port" => "Port IMAP/POP3/LDAP",
"Configure InterTiki here" => "Configura l'InterTiki aquí",
"<b>Item</b>" => "<b>Ítem</b>",
"<b>Value</b>" => "<b>Valor</b>",
"Hint: If you remove your login module, use tiki-login_scr.php to be able to login!" => "Consell: si treus el teu mòdul de registre, utilitza tiki-login_scr.php per poder iniciar la sessió!",
"Caching time :" => "Temps de memòria cau :",
"Only enable caching if all syndicated content is public (visible to everyone) or private documents might leak out. Cache ignores existing permissions." => "Només permet carregar-ho a la memòria cau si tot el contingut sindicat és públic (visible per a tothom) o si els documents privats s'han filtrat. La memòria cau ignora els permisos existents.",
"This text can be used as a variable" => "Es pot emprar aquest text com a variable",
"Here you can (as an admin) place a piece of custom XHTML and/or Smarty code. Be careful and properly close all the tags before you choose to publish ! (Javascript, applets and object tags are stripped out.)" => "Aquí pots (com admin) posar un tros de codi adaptat XHTML i/o Smarty. Sigués curos i tanca adequadament totes les etiquetes abans que no escullis publicar-ho! (Les etiquetes de Javascript, applets i d'objectes són estripades.)",
"While classic trackers are mature, mirror table trackers are an experimental feature. Many bugs have been reported when using plugins, etc.  <b>Do NOT use mirror trackers unless you know what you are doing</b> and are ready to participate to development and debugging. Mirror trackers could even eventually be discontinued from Tiki." => "Així com els formularis clàssics are madurs, els formularis amb taules mirall són una funcionalitat experimental. S'ha descrit molts errors en emprar connectors de formularis amb ells, etc. <b>NO empris taules mirall a no ser que sàpigues què estàs fent</b> i estiguis preparat a participar en el seu desenvolupament i depuració d'errors. Formularis amb taules mirall podrien ser descontinuats de Tiki.",
"Moved to:" => "Mogut/s a:",
"A new version of TikiWiki, <b>{\$tiki_release}</b>, is available.  You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">http://tiki.org/Download</a>." => "Hi ha disponible una nova versió de Tikiwiki: <b>{\$tiki_release}</b>. Estàs funcionanat actualment amb la versió <b>{\$tiki_version}</b>. Si us plau, visita <a href=\"http://tiki.org/Download\">http://tiki.org/Download</a>.",
"Click and scroll up to the top of the page" => "Clica i puja la barra de desplaçament fins a dalt de la pàgina",
"subscription" => "subscripció",
"admin charts template" => "administra plantilla de sondejos (charts)",
"Managing content templates" => "Gestiona les plantilles de continguts",
"admin content templates template" => "administra plantilla de plantilles de contingut",
"use in events" => "empra en els esdeveniment",
"Manage FortuneCookie" => "Gestiona la FortuneCookie",
"admin forums template" => "administra la plantilla dels fòrums",
"online" => "en línia",
"admin Html Pages" => "administra pàgines Html",
"admin Html Pages template" => "administra plantilla de les pàgines Html",
"Use {literal}{/literal}ed id=name} or {literal}{/literal}ted id=name} to insert dynamic zones" => "Utilitza {literal}{/literal}ed id=name} o {literal}{/literal}ted id=name} per inserir zones dinàmiques",
"admin featured links template" => "administra plantilla d'enllaços destacats",
"Help with Mail-in accounts" => "Ajuda amb els comptes correu-dins",
"admin menus template" => "administra plantilla dels menus",
"admin modules template" => "administra plantilla de mòduls",
"\n<b>Note 1</b>: if you allow your users to configure modules then assigned\nmodules won't be reflected in the screen until you configure them\nfrom MyTiki->modules.<br />\n<b>Note 2</b>: If you assign modules to groups make sure that you\nhave turned off the option 'display modules to all groups always'\nfrom <a href=\"tiki-admin.php?page=module\">Admin->Modules</a>\n" => "\n<b>Nota 1</b>: si permets als teus usuaris de configurar mòduls llavors els mòduls\nassignats no es veuran a la pantalla fins que els configuris des de\nElMeuTiki->mòduls.<br />\n<b>Nota 2</b>: Si assignes mòduls a grups, assegura't que hagis desactivat\nla opció 'mostra els mòduls sempre a tots els grups'\ndes de <a href=\"tiki-admin.php?page=module\">Admin->Mòduls</a>\n",
"Hint: For the vertical menu to work properly with all browsers, make sure to add <b>overflow=y</b> to the module parameters when you assign it." => "Consell: per tal que el menú vertical funcioni correctament amb tots els navegadors, assegura't d'afegir <b>overflow=y</b> als paràmetres de mòdul quan els assignis.",
"Admin calendar" => "Administra calendari",
"Newsletters Help" => "Ajuda per a butlletins",
"admin newsletters template" => "administra la plantilla dels butlletins",
"send newsletter" => "envia el butlletí",
"archives" => "arxius",
"admin notifications template" => "administra la plantilla de les notificacions",
"admin polls template" => "administra la plantilla de les consultes",
"configure polls" => "configura les consultes",
"admin RSSmodules template" => "administra la plantilla dels moduls RSS",
"To aggregate several RSS feeds, use {literal}{rss id=x+y+z}{/literal}. <b>\"show publish date\" must be checked.<b/>" => "Per agregar diverses alimentacions RSS, empra {literal}{rss id=x+y+z}{/literal}. Ha d'estar seleccionar <b>\"mostra la data de publicació\".<b/>",
"edit tpl" => "edita tpl",
"Manage Banned Words in Shoutbox" => "Gestiona les Paraules Prohibides en el Requadre d'Avisos",
"admin shoutbox words template" => "administra plantilla de paraules del quadre d'avisos",
"admin structures template" => "adminstra la plantilla de les estructures",
"Help with Surveys" => "Ajuda amb les Enquestes",
"admin topics template" => "administra la plantilla dels temes",
"Show tracker ID" => "Mostra ID del formulari",
"with leading zeroes?" => "amb zeros per davant?",
"hyphenated?" => "amb guions?",
"admin users template" => "administra la plantilla d'ususaris",
"Warning: Are you sure you want to rename the \"admin\" user? It's better to add a new user and to assign this new user to the \"Admins\" group" => "Avís: estàs segur que vols canviar el nom de l'usuari \"admin\"? És millor afegir un nou usuari i assignar-lo al grup \"Admins\"",
"Help for Backups" => "Ajuda per fer còpies de seguretat",
"remove file extension from image name" => "elimina l'extensió de l'arxiu del nom de la imatge",
"convert sub directories to sub galleries" => "converteix els subdirectoris en subgaleries",
"eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named screenshots will be created" => "ex. per \"misc/screenshots/digicam0001.jpg\" es crearà una galeria anomenada screenshots",
"use sub directory names as description" => "utilitza el nom del subdirectori com a descripció",
"eg. from \"misc/screenshots/digicam0001.jpg\" a description misc/screenshots will be created" => "ex. per \"misc/screenshots/digicam0001.jpg\" es posarà com a descripció misc/screenshots",
"Tikiwiki developers" => "desenvolupadors de Tikiwiki",
"admin the category system" => "administra el sistema de categories",
"admin category" => "administra la categoria",
"list galleries" => "llista les galeries",
"monitor this gallery" => "Vigila aquesta galeria",
"stop monitoring this gallery" => "Deixa de vigilar aquesta galeria",
"hit" => "cop",
"slideshow forward" => "endarrera passi de diapositives",
"add item" => "afegeix ítem",
"change focus" => "Canvia focus",
"quarter" => "trimestre",
"semester" => "semestre",
"calendar view" => "vista de calendari",
"list view" => "vista de llista",
"Subscription List" => "Llista de subscripció",
"Format: mm/dd/yyyy hh:mm<br />..." => "Format: mm/dd/aaaa hh:mm<br />...",
"See strtotime php function" => "Consulta la funció php strtotime",
"Format: mm/dd/yyy hh:mm<br />..." => "Format: mm/dd/aaa hh:mm<br />...",
"save_to" => "guarda a",
"admin directory categories tpl" => "administra categories de directori tpl",
"Your time" => "El teu temps",
"Editing and Creating Blogs" => "Edicó i creació de blocs",
"For more information, please see <a href=\"{\$helpurl}Wiki+Syntax\">Wiki Syntax</a>" => "Per obtenir més informació, consulteu la <a href=\"{\$helpurl}Wiki+Syntax\">Sintaxi Wiki</a>",
"edit quiz questions" => "edita les preguntes del qüestionari",
"edit quiz questions tpl" => "edita la plantilla de les preguntes del qüestionari",
"save only in the theme:" => "desa només al tema:",
"Edit Translation:" => "Edita la Traducció:",
"edit translations" => "edita les traduccions",
"edit translations template" => "edita la plantilla de traduccions",
"Select the article for which the current article is the translation." => "Selecciona l'article del què l'article actual és la traducció.",
"<b>File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>.</b>" => "<b>L'arxiu ha de ser un arxiu SQL i existir en <i>\$tikiroot/temp</i> o en <i>\$tikiroot/img/wiki_up</i>.</b>",
"rebuild cache" => "reconstrueix la memòria cau",
"You need to set a <a href=\"tiki-admin.php?page=gmap\">Google Maps API key</a>" => "Has de configurar una <a href=\"tiki-admin.php?page=gmap\">clau de Google Maps API</a>",
"Welcome to the installation &amp; upgrade script!" => "Benvinguts/des al procés d'instal·lació &amp; actualitació!",
"Descriptions of the \navailable profiles" => "Descripcions dels \nperfils disponibles",
"For database update from 1.7.x, please visit <a target=\"help\" href=\"http://doc.tiki.org/Upgrade+1.7+to+1.8\">Tiki database 1.7.x to 1.8x instructions" => "Per actualitzar bases de dades des de 1.7.x, si us plau, consulta <a target=\"help\" href=\"http://doc.tiki.org/Upgrade+1.7+to+1.8\">les instruccions per bases de dades Tiki de la 1.7.x a la 1.8.x",
"For information about tiki-secdb_*.sql files, please see <a target=\"help\" \nhref=\"http://doc.tiki.org/Security+Admin\">http://doc.tiki.org/Security+Admin" => "Per informació sobre els arxius tiki-secdb_*.sql, mira si us plau <a target=\"help\" \nhref=\"http://doc.tiki.org/Security+Admin\">http://doc.tiki.org/Security+Admin",
"sql queries have successfully been executed." => "consultes sql s'han executat satisfactòriament.",
"Help for managing cache" => "Ajuda per gestionar la memòria cau",
"How to Use FAQs" => "Com emprar les PUF's",
"Blog Help" => "Ajuda de les Bitàcoles",
"list quizzes tpl" => "plantilla de llista de qüestionaris",
"edit quiz stats tpl" => "edita la plantilla de les estadístiques del qüestionari",
"actions" => "accions",
"take survey" => "omple l'enquesta",
"Trackers Help" => "Ajuda dels Formularis",
"list trackers tpl" => "plantilla de la llista de formularis",
"To display the objects you created or contributed to to:" => "Visualització dels objectes on has participat:",
"entire site" => "Lloc sencer",
"first" => "primer",
"clean" => "neteja",
"You can also <a class=\"rbox-link\" href=\"tiki-admin.php?page=theme\">change the default theme</a>." => "També pots <a class=\"rbox-link\" href=\"tiki-admin.php?page=theme\">canviar el tema per defecte</a>.",
"red" => "roig",
"use start date and time" => "utilitza la data i l'hora d'inici",
"use end date and time" => "utilitza data i hora finals",
"permanency" => "permanència",
"How to Use FAQs " => "Com emprar PUF's ",
"monitor this forum topic and thread" => "subscriu-te a aquest tòpic del fòrum i al fil de discussió sencer (les seves respostes)",
"stop monitoring this forum topic and thread" => "deixa d'estar subscrit/a a aquest tòpic del fòrum i al fil de discussió sencer (les seves respostes)",
"stop monitor" => "deixa d'estar subscrit/a",
"{\$tracker_info.name} - Tracker item" => "{\$tracker_info.name} - Element del formulari",
"{\$tracker_info.name} - Item" => "{\$tracker_info.name} - Element",
"Help on Administration Home" => "Ajuda sobre l'Inici d'Administració",
"You do not have permission to admin the calendars." => "No tens permís per administrar els calendaris.",
"Created account %s <%s>." => "Compte %s <%s> creada.",
"New %s created with %s %s (%s)." => "Nou/va %s creat/da amb %s %s (%s).",
"Site No validated yet" => "Lloc encara no validat",
"No permission to view the page" => "No tens permís per veure aquesta pàgina",
"This feature is disabled: feature_forums" => "Aquesta funcionalitat està desactivada: feature_forums",
"Please create a directory to hold your map files:" => "Si us plau, crea un directori per contenir els teus arxius de mapes:",
"An error occurred." => "Ha ocorregut un error.",
"You do not have permission to edit messages" => "No teniu permís per editar missatges",
"Permission denied you cannot remove trackbacks" => "Permís denegat, no pots eliminar els retroenllaços",
"Select tags in the list or put them separated by spaces." => "Selecciona etiquetes de la llista o afegeix-les separades per espais.",
"Remove Tags" => "Elimina etiquetes",
"The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, or ask your\nhosting provider.  Normally Tiki tables won't conflict with other product names" => "La base de dades ha d'existir prèviament. Pots crear la base de dades emprant mysqladmin, PHPMyAdmin, o demana al teu \nproveïdor d'internet.  Normalment les taules de Tiki no entraran en conflicte amb els noms d'altres productes",
"Com" => "Com",
"Vers" => "Vers",
"Browse category" => "Navega per la categoria",
"1 File attached" => "1 Arxiu adjunt",
"Use in CMS" => "Fes servir en el cms",
"Use in Wiki" => "Fes servir en el wiki",
"Use in newsletters" => "Empra en fulls de notícies",
"Use in HTML pages" => "Fes servir en pàgines HTML",
"Refresh rate (if dynamic) [secs]" => "Temps de refresc (si és dinàmic) [seg]",
"Create Zone" => "Crear zona",
"use square brackets for an external link: [URL] or [URL|link_description] or [URL|description|nocache]  (that last form prevents the local Wiki from caching the page; please use that form for large pages!)." => "empra corxets per a un enllaç extern: [URL] o [URL|descripció de l'enllaç] o [URL|descripció|nocache]  (aquest darrer evita que el Wiki local guardi una còpia temporal de la pàgina en memòria cau page; empri-ho, si us plau, per pàgines grans!).",
"Last ver" => "Darrera ver",
"A new major release branch is also available." => "Hi ha també disponible una nova branca major.",
"Your database has been configured and Tikiwiki is ready to run! {if isset(\$smarty.post.scratch)}If this is your first install, your admin password is <strong>admin</strong>.{/if} You can now log in into Tikiwiki as user <strong>admin</strong> and start configuring the application." => "La teva base de dades ha estat configurada i Tikiwiki està llest per funcionar! {if isset(\$smarty.post.scratch)}Si és la teva primera instal·lació, la teva contrasenya d'usuari admin (administrador) és <strong>admin</strong>.{/if} Ara pots connectar-te a Tikiwiki com a usuari <strong>admin</strong> i començar a configurar l'aplicació.",
"You have completed the TikiWiki {if isset(.post.scratch)}installation{else}upgrade{/if}. Use one of these links to continue" => "Has completat la {if isset(.post.scratch)}instal·lació{else}actualització{/if} de TikiWiki. Empra una d'aquests enllaços per continuar",
"You have completed the TikiWiki {if isset(\$smarty.post.scratch)}installation{else}upgrade{/if}. Use one of these links to continue" => "Has completat {if isset(\$smarty.post.scratch)}la instal·lació{else}l'actualització{/if} de TikiWiki. Empra algun dels següents enllaços per continuar",
"Republic_of_Montenegro" => "Montenegro",
"Republic_of_Serbia" => "Sèrbia",
"Include all post in a blog" => "Inclou totes les publicacions en una bitàcola",
"attach" => "adjunció",
"monitor this blog" => "subscriu-te a aquesta bitàcola",
"browse category" => "navega per la categoria",
"Edit this file gallery:" => "edita aquest galeria d'arxius:",
"Other users can upload files to this gallery" => "Altres usuaris poden pujar arxius a aquesta galeria",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else.\n{\$mail_machine}/tiki-remind_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nDone! You should be logged in." => "Si us plau, punxa en l'enllaç següent per confirmar que desitges canviar la teva contrasenya i ves a la pantalla on hauràs d'introduir una nova contrasenya \"permanent\". Si us plau, escull una contrasenya que només tu coneguis, i no la comparteixis amb ningú més.\n{\$mail_machine}/tiki-remind_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nFet! Hauries d'estar connectat ja.",
"usernames separated with ," => "noms d'usuaris separats per ,",
"Last Page Changes" => "Darrers canvis a Pàgines",
"Site Language: " => "Idioma del Lloc: ",
"Site Language :" => "Idioma del Lloc :",
"1 file attached" => "1 arxiu adjunt",
"IP not displayed in history" => "IP no mostrada en l'historial",
"Edit or add poll options" => "Editar o afegir opcions a la consulta",
"Create/edit Polls" => "Crea o edita consultes",
"Rss channels" => "Canals Rss",
"show pubdate" => "mostrar data de publicació",
"Edit tracker fields" => "Edita els camps del formulari",
"visible by admin only" => "visible només per admins",
"The group will have all the permissions of the included groups" => "El grup tindrà tots els permisos dels grups inclosos",
"To use a relative link, use ex." => "Per emprar un enllaç relatiu, empra per ex.",
"watch only this category" => "vigila només aquesta categoria",
"watch this category and their descendants" => "vigila aquesta categoria i les seves descendents",
"stop watching only this category" => "deixa de vigilar només aquesta categoria",
"stop watching this category and their descendants" => "deixa de vigilar aquesta categoria i les seves descendents",
"Add or edit a site" => "Afegiu-hi o editeu un lloc web",
"Delete selected" => "Elimina seleccionats",
"browse image" => "Explorar imatge",
"translate" => "tradueix",
"Create or edit content" => "Crea o edita contingut",
"Edit FAQ questions" => "Edita preguntes PUF",
"Closing the window will reload your main browser" => "En tancar la finestra se't recarregarà la finestra principal del teu navegador",
"Create or edit content block" => "Crear o edita contingut d'un bloc",
"To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://mods.tiki.org\">mods</a>." => "Per aprendre més sobre <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://mods.tiki.org\">Mods</a>.",
"Apache has the right to write in your file tree, which enables the installation, removal or \nupgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \n\"./setup.sh\" for example)." => "Apache te el permís per escriure en el teu arbre d'arxiu, el que habilita la instal·lació, esborrat o \nactualització de paquets. Quan hagis acabat amb aquestes operacions, pensa en modificar els permisos de nou per tornar a un estat segur (a través d'emprar \n\"./setup.sh\" per exemple).",
"To install, remove or upgrade packages you need to give the apache user the right\nto write files in your web tree (you can use \"./setup.sh open\" to set it up). After installation you need to remove that\npermission (using \"./setup.sh\")." => "Per instal·lar, esborrar o actualitzar paquets necessites donar-li a l'usuari apache el permís \nper escriure arxius a l'arbre web d'arxius (pots emprar \"./setup.sh open\" per fer-ho). Després de la instal·lació, cal que eliminis aquests \npermisos (emprant \"./setup.sh\").",
"Add or edit a news server" => "Afegeix o edita un nou servidor",
"Add or edit folder" => "Afegeix o edita carpeta",
"Add or edit a URL" => "Afegeix o edita URL",
"A new (and temporary) password and your IP address has been sent " => "S'ha enviat una nova (i temporal) contrasenya i la teva adreça IP d'internet en un correu-e ",
"Textarea options: quicktags,width,height,max,listmax - Use Quicktags is 1 or 0, width is indicated in chars, height is indicated in lines, max is the maximum number of characters that can be saved, listmax is the maximum number of characters that are displayed in list mode." => "Opcions d'Àrea de Text: marques_ràpides,amplada,alçada,max,llist_max - Utilització: marques_ràpides pot ser 1 (mostrar-les) o 0 (no mostrar-les), l'amplada s'indica en caràcters, l'alçada s'indica en línies, max és el número màxim de caracters que poden ser guardats, llist_max és el número màxim de caracters que són mostrats en el mode de llista.",
"A user can assign himself in groups" => "Un usuari es pot assignar all mateix a grups",
"Major" => "Major",
"Site-wide" => "Arreu del lloc",
"Technical" => "Tècniques",
"UI enhancement" => "Millores d'IU",
"Major Features" => "Funcionalitats Majors",
"Minor Features" => "Funcionalitats Menors",
"Site-wide Features" => "Funcionalitats emprables arreu del Lloc",
"Save the page, but do not send notifications." => "Desa la pàgina, però no enviïs notificacions.",
"Tracker items for" => "Items de formulari per",
"error" => "error",
"Country Selector options: 1|2 where 1 show only country name and 2 show only country flag. By default show both country name and flag" => "Opcions del selector de país: 1|2 on 1 mostra tan sols el nom del país i 2 mostra només la bandera. Per defecte es mostra el nom i la bandera del país",
"Zoom out x4" => "Disminuir zoom x4",
"Zoom out x3" => "Disminuir zoom x3",
"Zoom in x3" => "Augmentar zoom x3",
"Zoom in x4" => "Augmentar zoom x4",
"Language :" => "Idioma :",
"This page is up to date with the reference language:" => "Aquesta pàgina està actualitzada respecte l'idioma de referència:",
"This page and all its translations are up to date." => "Aquesta pàgina i les seves traduccions estan actualitzades.",
"cache" => "memòria cau",
"add" => "afegeix",
"del" => "esb",
"Use Quote plugin rather than &ldquo;>&rdquo; for quoting" => "Empra el plugin de Cita (QUOTE) més que no pas &ldquo;>&rdquo; per citar",
"with checked" => "amb comprovats/des o seleccionats/des",
"To use menus in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>, <a class=\"rbox-link\" href=\"tiki-admin.php?page=siteid\">Site identity</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu. To use <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes:" => "Per emprar menus en un <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">mòdul</a>, <a class=\"rbox-link\" href=\"tiki-admin.php?page=siteid\">Identitat del Lloc</a> o plantilla, empra {literal}{menu id=x}{/literal}, on x és l'ID del menú. Per emprar <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a> (menús per capes), pots emprar alguna de les tres sintaxis següents:",
"Create/edit newsletters" => "Crea/edita butlletins",
"Use Admin Email" => "Fes servir el correu-e de l'admin",
"Admin tracker" => "Administra formulari",
"Edit this tracker" => "Edita aquest formulari",
"View this tracker items" => "Visualitza els ítems d'aquest formulari",
"Import/export trackers fields" => "Importa/exporta els camps dels formularis",
"Edit this tracker fields" => "Edita els camps d'aquest formulari",
"Edit tracker" => "Edita el formulari",
"Create trackers" => "Crea formularis",
"Import/export" => "Importa/exporta",
"Duplicate tracker" => "Duplica el formulari",
"Create/edit trackers" => "Crea/edita formularis",
"No individual permissions global permissions apply" => "No hi ha permisos individuals, s'aplicaràn els permisos globals",
"Edit item" => "Edita ítem",
"click here to send us an email" => "fes clic aquí per enviar-nos un correu electrònic",
"sites" => "llocs",
"cool sites" => "llocs fantàstics",
"this quiz stats" => "estadistiques d'aquest test",
"You can\n    \t\tnow log in into Tikiwiki as user <strong>admin</strong> and start configuring\n    \t\tthe application." => "Pots\n    \t\tara connectar-te a  Tikiwiki com a usuari <strong>admin</strong> i començar a configurar\n    \t\tl'aplicació.",
"subscribe" => "subscriue-me",
"Sent edition" => "Edició enviada",
"Subscribe to newsletter" => "Subscriure a butlletí",
"Hold down CTRL to select multiple" => "Manté premuda la tecla CTRL per fer seleccions múltiples",
"lowercase only" => "només minúscules",
"Save as draft" => "Desa-ho com a esborrany",
"You can include the file in an Wiki page using" => "Pots incloure l'arxiu en una pàgina Wiki emprant",
"You can include the file in an HTML page using" => "Pots incloure l'arxiu en una pàgina HTML emprant",
"Edit fields" => "Edita els camps",
"View item" => "Visualitza ítem",
"Add a comment" => "Afegeix un comentari",
"I have refused your friendship request!" => "He rebutjat la teva petició d'inclusió a la meva xarxa d'amistat!",
"clip" => "clip",
"cc" => "cc",
"Isle_of_Man" => "Illa_de_Man",
"Phillippines" => "Filipines",
"sender" => "remitent",
"subject" => "tema",
"date" => "data",
"flagged" => "senyalat",
"mark" => "marca",
"find replied message" => "busca missatges contestats",
"Click" => "Fes clic",
"posted by" => "enviat per",
"email this post" => "envia per correu electrònic aquest enviament",
"Tag name" => "Nom de l'Etiqueta",
"Category for staging pages" => "Categoria per les pàgines per revisar",
"Category for approved pages" => "Categoria per les pàgines aprovades",
"Category for pages out of sync" => "Categoria per les pàgines desincronitzades",
"Replace freetags with that of staging pages on approval" => "Reemplaça les etiquetes lliures amb les de les pàgines per revisar en ser aprovades",
"Anonymous editors must input anti-bot code" => "Editors Anonymous han d'escriure un codi anti-robot",
"Show page title" => "Mostra el títol de la pàgina",
"Show page ID" => "Mostra ID de pàgina",
"Users can lock pages (if perm)" => "Els usuaris poden bloquejar pàgines (si tenen perm)",
"Use WikiWords" => "Empra ParaulesWiki",
"Use Wiki paragraph formatting" => "Empra formatatge Wiki de paràgrafs",
"But still create line breaks within paragraphs" => "Però encara crea salts de línia entre paràgrafs",
"Use external link icons" => "Empra icones per als enllaços externs",
"User's Page" => "Plana de l'usuari",
"Import Page" => "Importa la Plana",
"When viewing a page, if it doesn't exist and has one like page, automatic redirection to this like page" => "Quan es vol mostrar una pàgina, si no existeix i té una pàgina similar, fes redireccionament automàtic a aquesta pàgina similar",
"Show/hide heading icon displayed before the heading" => "Mostra abans de l'encapçalament la icona per Mostrar/Amagar el contingut sota l'encapçalament",
"Print Page" => "Imprimeix pàgina",
"Maximum number of versions for history" => "Quantitat màxima de versions en l'historial",
"Never delete versions younger than days" => "Mai eliminar versions prèvies a dies",
"Diff style" => "Estil de diferències",
"Watch minor" => "Vigila canvis menors",
"This will work well (or not!) depending on your theme. To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tiki.org\">themes</a>" => "Això funcionarà bé (o no!) depenent del teu Tema (d'estil, estètica, de la web). Per aprendre més sobre <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tiki.org\">Temes</a>",
"Old vers" => "Versions antigues",
"Add or edit event" => "Afegeix o edita un esdeveniment",
"merge selected notes into" => "fusiona les notes seleccionades en",
"Faq Stats" => "Estadistiques de PUFs",
"Report to the Webmaster" => "Avisa al mestre del Web",
"Edit User Files" => "Edita els arxius de l'usuari",
"Your message has been queued for approval, the message will be posted after\na moderator approves it." => "El teu missatge ha estat posat en cua pendent d'aprovació, el missatge serà publicat després\nque un moderador l'aprovi.",
"Webmail Doc" => "Document Webmail",
"Webmail Doc template" => "Plantilla de document de correu web",
"settings" => "especificacions",
"mailbox" => "bustia de correu",
"compose" => "composa",
"contacts" => "contactes",
"back to mailbox" => "torna a bustia de correu",
"full headers" => "capçaleres senceres",
"normal headers" => "capçaleres normals",
"reply all" => "respon a tots",
"forward" => "reenvia",
"select from address book" => "selecciona del llibre d'adreces",
"item found" => "registre trobat",
"items found" => "registres trobats",
"can't open mypage" => "can't open mypage",
"Image (url)" => "Imatge (url)",
"Are you sure you want to delete this entry ?" => "Segur que vols esborrar aquesta entrada ?",
"Permission assigned to the group" => "Permís assignat al grup",
"Permission assigned to the group through a category" => "Permís assignat al grup a través de la categoria",
"Current permissions" => "PErmisos actuals",
"Read &amp; write" => "Lectura &amp; Escriptura",
"No specific permission" => "No hi ha cap permís específic",
"Apply permissions" => "Aplica permisos",
"Additional permissions" => "Permisos addicionals",
"Add Groups" => "Afegeix Grups",
"Add Users" => "Afegeix Usuaris",
"Add to List" => "Afegeix a la Llista",
"Share Page" => "Comparteix pàgina",
"name already exists" => "ja existeix el nom",
"Then rerun the installer using tiki_1.9to1.10." => "Llavors torna a executar l'instal·lador emprant tiki_1.9to1.10.",
"A wildcard pattern of originating pages to be ignored.<br />" => "Un patró de comodí per pàgines originàries a ser ignorades.<br />",
"The character, by which ignored patterns are separated.<br />" => "El caràcter, pel qual patrons ignorats són separats.<br />",
"Whether to include external wikis in the list.<br />" => "Si incloure wikis externs a la llista.<br />",
"Collect either originating or wanted pages in a cell and display them in the second column.<br />" => "Recopila tant les pàgines originals com les buscades en una cel·la i les mostra a la segona columna.<br />",
"Multiple collected items are separated in distinct table rows, or by comma or line break in one cell.<br />" => "Diversos elements recopilats estan separats en diferents files de la taula, o bé per una coma o per un salt de línia en una mateixa cel·la.<br />",
"Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex.<br />" => "Filtra la llista de pàgines que vols segons page_regex o un filtre personalitzat. El valor per defecte és site's __current__ page_regex.<br />",
"A custom filter for wanted pages to be listed (only used when level=>custom).<br />" => "Un filtre personalitzat de les pàgines que es volen llistar (només s'utilitza quan el nivell=>personalitzat).<br />",
"Use context menus for actions (icons) (only in file galleries yet):" => "Empra menús contextuals per accions (icones) (només a galeries d'arxius, per ara):",
"Use context menus for actions (text) (only in file galleries yet):" => "Empra menús contextuals per accions (text) (només a galeries d'arxius, per ara):",
"Installation Script" => "Seqüència d'Instal·lació",
"This install script may be potentially harmful. We recommend that you disable the script before entering Tiki. To restore the script for reuse, follow the instructions in tiki-install.php." => "Aquest arxiu de seqüència d'instal·lació pot ser perillós potencialment. Et recomanem que el dehabilitis abans d'entrar a Tiki. Per restaurar-lo per emprar-lo de nou, segueix les instruccions que trobaràs a l'arxiu tiki-install.php.",
"You have completed the TikiWiki installation" => "Has completat la instal·lació de TikiWiki",
"You have completed the TikiWiki upgrade" => "Has completat l'actualtizació de TikiWiki",
"Use one of these links to continue" => "Empra un d'aquests enllaços per continuar",
"Disable the installation script and enter TikiWiki" => "Deshabilita la seqüència d'instal·lació i entra a Tikiwiki",
"Enter TikiWiki <em>without</em> disabling the installation script" => "Entra a TikiWiki <em>sense</em> deshabilitar la seqüència d'instal·lació",
"Paramaters" => "Paràmetres",
"To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\"> module</a>." => "Per utilitzar aquests enllaços cal assignar el <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">mòdul</a> enllaços_destacats.",
"bad type name" => "el nom del tipus és incorrecte",
"Can edit categorized items" => "Pot editar ítems classificats",
"component class not found" => "no s'ha trobat la classe de l'element",
"component name is invalid" => "el nom de l'element no és vàlid",
"Name is empty" => "El nom és buit",
"Parameter not found :" => "No s'ha trobat el paràmetre:",
"This is the default text<br />---(version 3)-----------------------------<br />This is version 3 info<br />---(version 2)-----------------------------<br />This is version 2 info<br />---(version 1)-----------------------------<br />This is version 1 info" => "Aquest és el text per defecte<br />---(versió 3)-----------------------------<br />Això és informació de la versió 3<br />---(versió 2)-----------------------------<br />Això és informació de la versió 2<br />---(versió 1)-----------------------------<br />Això és informació de la versió 1",
"type class not found" => "no s'ha trobat la classe del tipus",
"window not found" => "no s'ha trobat la finestra",
"You are not the owner of this page" => "No ets el propietari d'aquesta pàgina",
"You cannot have more than one windows of this type." => "No pots tenir més d'una finestra d'aquest tipus.",
"You do not have permission to view this part of content" => "No tens permisos per veure aquesta part del contingut",
"hist" => "hist",
"Text options: 1,size,prepend,append,max with size in chars, prepend will be displayed before the field append will be displayed just after, max is the maximum number of characters that can be saved, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Opcions de Text: 1,mida,prefix,sufix,max amb la mida en caracters, prefix serà mostrat abans del camp, sufix serà mostrat just després, max és el número màxim de caracters que poden ser guardats, i si es posa un 1 inicial es fa que el següent camp es mostri en la mateixa fila del formulari. Si s'indica només 1, vol dir també que el següent camp serà mostrat a la mateixa fila.",
"Checkbox options: put 1 if you need that next field is on the same row." => "Opcions de requadres de verificació: posa un 1 si necessites que el següent camp sigui a la mateixa línia.",
"Numeric options: 1,size,prepend,append with size in chars, prepend will be displayed before the field append will be displayed just after, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Opcions numèriques: 1,mida,prefix,sufix amb la mida en caracters, el prefix serà mostrat abans del camp, el sufix serà mostrat just després, i si és posa un número 1 inicial es fa que el següent camp sigui en la mateixa línia. Si s'indica només 1, vol dir també que el següent camp serà mostrat a la mateixa fila.",
"Dropdown options: list of items separated with commas." => "Llista d'opcions: llista d'ítems separats per comes.",
"Default value is specified by having the value indicated twice consecutively" => "El valor per defecte s'indica posant el valor dos cops consecutius",
"Radio buttons options: list of items separated with commas." => "Opcions de botons Radio: llista d'items separats per comes.",
"User Selector options: automatic field feeding,email - feeding=1 for author login or feeding=2 for modificator login - email=1 to send an email to the user if the tracker is modified" => "Opcions del selector d'usuari: alimenatació automàtica del camp,correu-e - alimenatació=1 per al nom de l'usuari creador o alimentació=2 per al nom del modificador - correu-e=1 per enviar un correu-e a l'usuari si el formulari es modificat",
"Group Selector: use options for automatic field feeding : you can use 1 for group of creation and 2 for group where modification come from. The default group has to be set, or the first group that come is chosen for a user, or the default group is Registered." => "Selector de grup: empra les opcions per a alimentació automàtica dels camps: pots emprar 1 per al grup de d'on va venir la creació creació i 2 per al grup d'on va venir la modificació. El grup per defecte ha d'estar especificat, o el primer grup que ve és l'agafat per a un usuari, o el grup per defecte és Registered.",
"IP Selector: use options for automatic field feeding : you can use 1 for author IP or 2 for modificator IP." => "Selector d'adreça IP: empra les següents opcions per a l'alimentació automàtica del camp: pots emprar 1 per a la IP de l'autor, i per a l'adreça del modificador.",
"Date Time options: date_time,year0,year1 where date_time=d|dt(default), d displays only date, year0 is the first year, year1 the last" => "Opcions de data i hora: data_hora,any0,any1 on data_hora=d|dt(per defecte), d mostra només la data, any0 és el primer any, any1 és el darrer",
"Jscalendar options: date_time where date_time=d|dt(default), d displays only date" => "Opcions del Jscalendar: data_hora on data_hora=d|dt(per defecte), d mostra només la data",
"Image options: xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale indicated in pixels." => "Opcions d'imatges: MidaLlista_eixX,MidaLlista_eixY,MidaDetalls_eixX,MidaDetalls_eixY,EscalaLimitPujada són indicades en pixels.",
"Action options: Label,post,tiki-index.php,page:fieldname,highlight=test" => "Opcions d'accións: Etiqueta,post,tiki-index.php,page:nomdelcamp,highlight=test",
"Static text options: Wikisyntax,listmax - Use Wikisyntax is 1 or 0, listmax is the maximum number of characters that are displayed in list mode." => "Opcions de text estàtic: SintaxiWiki,maxlist - Empra SintaxiWiki pot ser 1 (si) )o 0 (no), maxlist és el nombre màxim de caràcters que es mostraran en el mode de llista.",
"Category options: parentId,d|m|radio|checkbox(default),1|0(default) to have a select all button, d for dropdown, m for multiple drop down" => "Opcions de categoria: IdMare,d|m|radio|checkbox(per defecte),1|0(per defecte) per tenir un botó de selecciona-ho tot, IdMare per indicar l'identificador numèric de la categoria mare que conté les categories filles que es volen mostrar com a seleccionables, d per desplegable, m per multiples desplegables",
"Item Link options: trackerId,fieldId,linkToItem,displayedfieldslist links to item from trackerId which fieldId matches the content of that field. linkToItem 1|0 to create a link to the item in view mode and listing.  Display displayedfieldslist(separate with |) instead of the target item" => "Opcions d'enllaç de l'ítem: IdFormulari,IdCamp,enllaç_a_Item,llista_de_camps_mostrats enllaça a l'ítem de l'IdFormulari en el qual l'IdCamp coincideix amb el contingut d'aquell camp. enllaç_a_Item pot ser 1 ó 0 per crear, o no, l'enllaç a l'ítem en el mode de visualització i llistat.  Mostra llista_de_camps_mostrats(separa amb |) enlloc de l'ítem diana",
"Items list options: trackerId,fieldIdThere, fieldIdHere, displayFieldIdThere, linkToItems displays the list of displayFieldIdThere from item in tracker trackerId where fieldIdThere matches fieldIdHere. linkToItems 1|0 to create a link to items in view mode and listing" => "Opcions de la llista d'Ítems: IdFormulari,IdCampAllà, IdCampAquí, IdCampMostratAllà, enllaç_a_Camps mostra la llista de IdCampMostratAllà dels ítems en el formulari IdFormulari on l'IdCampAllà coincideix amb l'IdCampAquí. enllaç_a_Camps 1 ó 0 per crear (o no) un enllaç als ítems en el mode de visualització i llistats",
"dynamic items list options: trackerId, filterFieldIdThere, filterFieldIdHere, listFieldIdThere, statusThere insert the list of listFieldIdThere from item in tracker trackerId where filterFieldIdThere matches filterFieldIdHere where status is statusThere." => "Opcions de la llista d'ítems dinàmica: IdFormulari, IdDeCampDeFiltratAllà, IdDeCampDeFiltratAquí, IdDelCampDeLlistaAllà, estatusAllà inserta la llista de IdDelCampDeLlistaAllà de l'ítem en el formulari IdFormulari on IdDeCampDeFiltratAllà coincideix amb IdDeCampDeFiltratAquí on l'estatus és estatusAllà.",
"Email address options: 0|1|2 where 0 puts the address as plain text, 1 does a hex encoded mailto link (more difficult for web spiders to pick it up and spam) and 2 does the normal href mailto." => "Opcions de l'adreça de correu electrònic: 0|1|2 on 0 posa l'adreça com a text pla, 1 fa un enllaç mailto codificat hex (més difícil que web spiders recullin el mail i enviïn correu brossa) i 2 fa el href mailto normal.",
" 0|1|2|3|4|5 0,xsize,ysize. First record :0 for URL in file gal of MP3 only, 1 for URL of FLV in file gal video only , 2 for URL of MP3 or Video in file gal, 3 donwload MP3 only, 4 donwload FLV video only, 5 download FLV or MP3 (default is 0). Second record : X size of flash applet(default is 200) , Y size of flash applet (default is 100) " => " 0|1|2|3|4|5 0,mida_x,mida_y. Primer registre : 0 per URL a una galedia d'arxius de només MP3, 1 per URL de FLV a una galeria d'arxius de nomes vídeo, 2 per URL de MP3 o Video en galeria d'arxius, 3 descarerga només MP3, 4 descarrega només vídeo FLV, 5 descarrega FLV o MP3 (per defecte és 0). Segon registre : mida X de l'applet de flash (per defecte és 200) , mida Y de l'applet de flash (per defecte és 100) ",
"Sequential auto-increment number:initial_value,prepend,append,itemId: initial_value default is 1, prepend will be displayed before the field, append will be displayed just after, itemId will use the item Id" => "Número auto-incrementat seqüencialment: valor_inicial,prefix,sufix,IdItem: valor_inicial per defecte és 1, el prefix serà mostrat abans del camp, el sufix serà mostrat just després, l'IdItem emprarà l'ID de l'Ítem",
"Allow registered user to subscribe to an item. They can add a number of friends." => "Per als usuaris registrats de subscriure's a un ítem. Poden afegir un nombre d'amics.",
"Use Google Maps." => "Empra Mapes de Google.",
"Formula for computation, using # for indicating fields and +,*,/,- and parenthesis for operations." => "Formula per al càlcul, emprant # per indicar camps i +,*,/,- i parèntesis per a les operacions.",
"~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc)}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>NomDelTòpic, topicId=>id, type=>tipus, categId=>ID de la categoria mare, lang=>en, sort=>NomDeColuma_asc|NomDeColuma_desc)}{ARTICLES}~/np~",
"Formula" => "Fórmula",
"No formula specified." => "No s'ha especificat cap fórmula.",
"Impossible to render the graphic." => "No ha estat possible generar el gràfic.",
"View graphic" => "Visualitza el gràfic",
"new submissions" => "noves propostes d'articles'",
"new sites" => "nous llocs",
"new calendar events" => "nous esdeventiments al calendari",
"Message Broadcast" => "Émisió de Missatges",
"applicable for this item" => "aplicable per a aquest item",
"click to show/hide" => "clica per mostrar/amagar",
"Are you sure you want to remove this module?" => "Segur que vols eliminar aquest mòdul?",
"database queries used" => "consultes emprades a la base de dades",
"Last Modification:" => "última modificació:",
"For" => "Per a",
"{\$atts_cnt} files attached" => "{\$atts_cnt} arxius adjunts",
"pass" => "contrasenya",
"Page generated in" => "Pàgina generada en",
"sent" => "enviat",
"Homework" => "Deures",
"Assignments" => "Deures",
"{|} Files Attached" => "{|} arxius adjunts",
"Favorites" => "Favorits",
"Member list" => "Llista de membres",
"Back to Homepage" => "Tornar a inici",
"Edit Summary" => "Resum de l'edició",
"Minor" => "Menor",
"RSS Trackers" => "Alimentacions RSS per a Formularis",
"Show/Hide Left Modules" => "Mostra/Amaga els mòduls de l'esquerra",
"Show/Hide Right Modules" => "Mostra/Amaga els mòduls de la dreta",
"Last update from CVS" => "Darrera actualització des de CVS",
"Translate in" => "Tradueix a",
"babelfish it" => "tradueix-ho amb babelfish",
"Welcome to" => "Benvingut a",
"Feature documentation links" => "Enllaços de documentació de les funcionalitats",
"Help System (Feature documentation links)" => "Sistema d'Ajuda (Enllaços de documentació de les funcionalitats)",
"Technical Features" => "Funcionalitats tècniques",
"Content Features" => "Funcionalitats de contingut",
"Contact Us (Anonymous)" => "contacta'ns (Anònim/a)",
"Freetags rock!" => "Les etiquetes lliures molen!",
"Preference syntax" => "Sintaxi de preferències",
"Prevent automatic/robot registration" => "Prevenir registre automàtic/robots",
"Required for all the following features" => "Requerit per totes les funcionalitats següents",
"Site Logo" => "Logo del Lloc",
"Admin Groups Template" => "Admin groups template",
"Help on Banning System" => "Ajuda en el sistema de pancartes",
"Admin banning tpl" => "Administrar plantilla per a prohibició",
"Create/edit Calendars" => "Crear/edita calendaris",
"Admin Categories tpl" => "Administrar plantilla per a categories",
"charts" => "gràfics",
"Chat Administration" => "Administració del Xat",
"Chat Admin" => "Administrar Xat",
"Chat Admin tpl" => "Administrador de xat tpl",
"Create/edit channel" => "Crea o edita canal",
"Half a second" => "Un segon",
"Chat channels" => "canals del Xat",
"Help on Drawings" => "Ajuda sobre els Dibuixos",
"tiki-admin_dsn tpl" => "plantilla tiki-admin_dsn",
"Admin Hotwords Template" => "Administra la plantilla de paraules calentes",
"Tiki integrator" => "integrador Tiki",
"Admin Featured Links" => "Administració d'enllaços especialas",
"Admin Webmail" => "Administrar Correu-Web",
"Admin Mailing Template" => "Administrar plantilla per a butlletins",
"Admin Menu Builder" => "Constructor de menús d'administració",
"Assign Module" => "Assigna mòdul",
"subscribed" => "subscrit",
"Admin Polls Template" => "Administra la Plantilla de les Consultes",
"Configure Polls" => "Configura Consultes",
"tiki admin quicktags template" => "administrador tiki de plantilles de marques d'inserció ràpida",
"Score System" => "Sistema de puntuacions",
"security admin" => "Administració de Seguretat",
"security admin tpl" => "plantilla d'administració de seguretat",
"Edit survey questions" => "Edita preguntes de l'enquesta",
"administer surveys template" => "administra la plantilla de les enquestes",
"system admin" => "administrador de sistema",
"system admin tpl" => "administrador de sistema tpl",
"Admin Tracker" => "Administra formulari",
"User must already exist." => "L'usuari ha d'existir prèviament.",
"To create users and assign them to groups, got to admin->users" => "Per crear usuaris i assignar-los a grups, ves a admin->usuaris",
"Warning: changing the username will require the user to change his password and will mess with slave intertiki sites that use this one as master" => "Avís: canviar el nom d'usuari requerirà a l'usuari canviar-se la contrasenya i es liarà amb els llocs intertiki esclaus que utilitzen aquest com a mestre",
"Warning: changing the username will require the user to change his password" => "Avís: canviar el nom d'usuari requerirà a l'usuari canviar-se la contrasenya",
"Again" => "Un altre cop",
"User must change his password at first login" => "L'usuari ha de canviar la seva contrasenya en connectar-se per primera vegada",
"Approve page changes in staging" => "Aprova els canvis de la pàgina per revisar",
"Article Types tpl" => "plantilla per a Tipus d'article",
"Assign permissions to group" => "Assignar permisos al grup",
"Edit Article Tpl" => "Edita plantilla per a article",
"Browsing Gallery" => "Fullejant Galeria",
"Config Calendars" => "Configura els Calendaris",
"Admin Directory tpl" => "Administrar plantilla per a directori de categories",
"Admin Directory Related" => "Administració de directori relacionat",
"directory admin related tpl" => "plantilla per a directori relatiu a l'administració",
"Admin Directory Sites" => "Admin del Directori de Llocs",
"Admin Directory Sites tpl" => "Admin del Directori de Llocs tpl",
"Validate Sites" => "Valida Llocs",
"directory validate sites tpl" => "plantilla per a validar les dades del directori",
"Edit Article" => "Edita Article",
"Edit Blog Tpl" => "Edita plantilla per a bitàcola",
"Show Plugins Help" => "Mostra l'ajuda dels Plugins",
"Will display using the indicated HTML color or color name" => "Mostrarà utilitzant el color HTML o el nom del color (en anglès)",
"Show Text Formatting Rules" => "Mostra les Regles de Formateig de Text",
"Program dynamic content for block" => "Programar el contingut dinàmic per al bloc",
"Admin quizzes" => "Administrar qüestionaris",
"Admin Quizzes tpl" => "Administrar plantilla per a qüestionaris",
"Help on Articles" => "Ajuda amb els Articles",
"Edit Submissions Tpl" => "Edita plantilla per a submissions",
"EditTemplates" => "Editaplantilles",
"EditTemplates tpl" => "plantilla per a Editaplantilles",
"Edit Translations" => "Edita Traduccions",
"Edit Translations Template" => "Edita la plantilla de Traduccions",
"Message queue for" => "Cua de missatges per a ",
"back to forum" => "torna al fòrum",
"Reported messages for" => "Missatge reportat per",
"friends tpl" => "plantilla ambics",
"galleries tpl" => "Plantilla per a les Galeries",
"ImportingPagesPhpWikiPageAdmin" => "AdminImportantPàginesPhpWikiPage",
"tiki-import_phpwiki tpl" => "plantilla tiki-import_phpwiki",
"Backup your database with mysqldump, phpmyadmin, or other before upgrading." => "Fes una còpia de seguretat de la teva base de dades amb mysqldump, phpmyadmin, o altres abans d'actualitzar.",
"Update database using script" => "Actualitza la teva base de dades emprant la seqüència (script)",
"No scripts available." => "Cap arxiu de seqüències (script) disponible.",
"To upgrade from" => "Per actualitzar des de",
"Use this script" => "Empra aquesta arxiu de seqüències (script)",
"See <a target=\"help\" class=\"link\" href=\"http://doc.tiki.org/Upgrade+1.7+to+1.8\">Tiki database 1.7.x to 1.8x instructions" => "Consulta les <a target=\"help\" class=\"link\" href=\"http://doc.tiki.org/Upgrade+1.7+to+1.8\">instruccions de bases de dades Tiki 1.7.x a 1.8.x",
"For information about <strong>tiki-secdb_*.sql</strong> files, please see <a target=\"help\" class=\"link\" href=\"http://doc.tiki.org/Security+Admin\">http://doc.tiki.org/Security+Admin" => "Per informació sobre els arxius <strong>tiki-secdb_*.sql</strong>, si us plau consulta <a target=\"help\" class=\"link\" href=\"http://doc.tiki.org/Security+Admin\">http://doc.tiki.org/Security+Admin",
"TikiWiki requires <strong>at least</strong> 16MB of PHP memory for script execution. Use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 16M) and restart your webserver" => "TikiWiki necessita <strong>com a mínim</strong> 16MB de memòria PHP per a l'execució del programa. Empra la clau <strong>memory_limit</strong> al teu arxiu <strong>php.ini </strong> (per exemple: memory_limit = 16M) i reinicia el teu servidor web",
"List Articles Tpl" => "Plantilla per a llista d'articles",
"Admin Cache" => "Administrar caxé",
"Admin Cache tpl" => "Administrar plantilla per a caxé ",
"Orphan" => "Òrfan/ena",
"Help on Dynamic Content" => "Ajuda sobre contingut dinàmic",
"List FAQs Tpl" => "Llistat de preguntes més freqüents",
"games tpl" => "plantilla (tpl) de jocs",
"List Posts Tpl" => "Plantilla per a llista d'enviaments",
"Admin Live Support tpl" => "Xxx",
"back to admin" => "tornar a administració",
"User Calendar" => "Calendari de l'usuari",
"User Calendar Doc tpl" => "Plantilla de document d'usuari/a",
"User Calendar Doc" => "Document de calendari d'usuari/a",
"User Calendar Preferences Doc tpl" => "Plantilla de document de preferències de calendari de l'usuari/a",
"my tiki tpl" => "Plantilla per al meu tiki",
"Subscribe to This Newsletter" => "Subscriu",
"Stats for quiz" => "Estadistiques per test",
"received articles tpl" => "articles rebuts tpl",
"Help on Communication Center" => "Ajuda al centre de comunicació",
"received pages tpl" => "pàgines rebudes tpl",
"return to wikipage" => "torna a la pàgina wiki",
"Rename page" => "Renombrar la pàgina",
"to_version" => "a la versió",
"search stats tpl" => "estadístiques de cerca tpl",
"Admin Send Objects tpl" => "Administrar plantilla per a enviar objectes",
"sheets tpl" => "plantilla (tpl) de fulls",
"Stats for survey" => "Estadístiques per enquesta",
"system logs" => "registres del sistema",
"system logs tpl" => "Plantilla dels registres del sistema",
"Theme Control Center: categories" => "Centre de Control de Theme: categories",
"ThemeControl" => "ControldeTheme",
"ThemeControl tpl" => "Plantilla de ControldeTemes",
"ThemeControl Objects" => "Objectes de ControldeTemes",
"theme control objects tpl" => "plantilla d'objectes de control de temes",
"Theme Control Center: sections" => "Centre de control de temes: seccions",
"theme control sections tpl" => "plantilla de seccions de control de temes",
"File Title" => "Títol de l'arxiu",
"Unzip all zip files" => "Descomprimeix tots els arxius zip",
"Author if not the file creator" => "Autor si no ets el creador de l'arxiu",
"Image Gallery tpl" => "Plantilla per a Galeria d'images",
"User Assigned Modules" => "Mòduls assignats a l'usuari/a",
"User Assigned Modules tpl" => "Plantilla de mòduls assignats a l'usuari/a",
"User Bookmarks tpl" => "Preferits/Adreces d'interès tpl",
"UserPreferences tpl" => "Plantilla de Preferències d'Usuari (UserPreferences)",
"User Tasks tpl" => "Plantilla de tasques d'usuari/a",
"User Watches tpl" => "Plantilla (tpl) dels avisos de l'usuari/a",
"Watch language wiki page creations" => "Vigila les creacions de pàgines Wiki en l'idioma",
"Add watch" => "Vigila-ho",
"View FAQ Tpl" => "Visualitza plantilla de puf",
"Admin Menus tpl" => "Administrar plantilla per a menús",
"IRC log" => "Registre IRC",
"Edit mail account" => "Edita la compte de correu electrònic",
"Add new mail account" => "Afegeix un nou compte de correu",
"User accounts" => "Comptes d'usuari",
"View All" => "Visualitza Tots",
"Msg" => "Msstg",
"Can't parse remote HTML page" => "No es pot analitzar la pàgina HTML remota",
"Permission denied you cannot remove pages" => "Permís denegat, no podeu eliminar pàgines",
"Delete those pages:" => "Esborra aquestes pàgines:",
"Swffix" => "Swffix",
"Geourl" => "Geourl",
"meta robots" => "meta robots",
"MultiTiki setup" => "MultiTiki setup",
"\$title" => "\$title",
"Cannot write to this file" => "No es pot escriure a aquest arxiu",
"Your post has not been posted" => "L'enviament no ha estat publicat",
"Missing title or body when trying to post a comment" => "Manca títol o cos quan en intentar publicar un comentari",
"Antarctica" => "Antàrtida",
"\\n for rows" => "\\n per arxius",
"Use this thread to discuss the %s page." => "Empra aquest fil per discutir la pàgina %s .",
"Newsletter subscription information at " => "Butlletí d'informació de subscripció a ",
"Changes" => "Canvis",
"Hold down CTRL to select multiple categories" => "Prem la tecla CTRL per seleccionar múltiples categories",
"categorize this object" => "categoritza aquest objecte",
"Uncheck the above checkbox to uncategorize this page/object" => "Desmarca la casella de sobre per descategoritzar aquesta pàgina/objecte",
"Your account request have been stored and will be activated by the admin as soon as possible." => "La teva petició de compte ha estat arxivada i serà activada per la persona administradora tan aviat com li sigui possible.",
"New article post: {\$mail_title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Publicació d'un nou article: {\$mail_title} per {\$mail_user} el dia {\$mail_date|tiki_short_datetime}",
"New article post at %s" => "Nova publicació d'article a %s",
"Syntax highlighting" => "sintaxi resaltada",
"Mini calendar" => "Mini calendari",
"User list" => "Llista d'usuaris",
"Received pages" => "Pàgines rebudes",
"Browse directory" => "Explorar directori",
"List quizzes" => "Llista de Qüestionaris",
"List trackers" => "Llista formularis",
"To learn more, visit: <a href=\"http://www.tiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://www.tiki.org</a>" => "Per aprendre més, visita: <a href=\"http://www.tiki.org\" title=\"La Comunitat de Tikiwiki\" target=\"_blank\">http://www.tiki.org</a>",
"I forgot my pass" => "He oblidat la meva contrasenya",
"Click to see the ratings" => "Cliqueu per veure les valoracions",
"Note: if you want to use images please save the post first and you\n\twill be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor\n\tor use the image URL to include images using the WYSIWYG editor. " => "Nota: si vols emprar imatges, desa la publicació primer i podràs\n\tllavors editar/publicar imatges. Empra el codi &lt;img&gt; per incloure imatges pujades l'editor de l'àrea de text \n\to fer servir la URL de la imatge per incloure imatges emprant l'editor WYSIWYG. ",
"Send trackback pings to:" => "Enviar pings de seguiment a:",
"(comma separated list of URIs)" => "(coma llista separada d' URIs)",
"Use categories to regroup various Tiki objects" => "Empra categories per reagrupar varis objectes de Tiki",
"Link to" => "Enllaça a",
"User identity features" => "Funcionalitats de la identitat dels usuaris",
"Users sort order" => "Ordenació dels usuaris",
"Tikiwiki version" => "Versió de Tikiwiki",
"Use URI as Home Page" => "Fes servir URL com a pàgina incial",
"OS" => "Sistema operatiu",
"Log Mail in Tiki Logs:" => "Registra l'enviament de correu-e al Registre de Tiki:",
"Log SQL:" => "Registra SQL:",
"Default charset for sending mail:" => "Jocs de caracters per defecte per enviar correus-e:",
"Mail end of line:" => "Final de línia del correu-e:",
"Disallow access to the site (except for those with permission)" => "No permetre accès a la web (excepte aquells amb permís)",
"Message to display when site is closed" => "Missatge a mostrar quan una web és tancada",
"Disallow access when load is above the threshold (except for those with permission)" => "No permetre accès quan la càrrega encara no s'ha completat (excepte aquells amb permís)",
"Max average server load threshold in the last minute" => "Rendiment màxim de la càrrega del servidor en el darrer minut",
"Message to display when server is too busy" => "Missatge a mostrar quan el servidor està massa ocupat",
"Use cache for external images" => "Fer servir la memòria cau per a les imatges externes",
"Use gzipped output" => "Empra sortida comprimida amb gzip",
"output compression is active." => "compressió de sortida és activa.",
"compression is handled by" => "la compressió és controlada per",
"Sender Email" => "Correu-e de l'enviador",
"Allow anonymous users to \"Contact Us\"" => "Permet que els usuaris anònims vagin a \"Contacta'ns\"",
"contact feature disabled" => "Possibilitat de contacte deshabilitada",
"Session lifetime in minutes" => "Temps de vida de sessió en minuts",
"Proxy Host" => "Servidor Proxy",
"Please expect not found help-pages with the default-URL." => "Si us plau, és normal no trobar totes les pàgines d'ajuda amb la URL per defecte.",
"Any help with the documentation is welcome." => "Qualsevol ajuda amb la documentació és benvinguda.",
"Release check" => "Comprovació d'alliberament",
"Release checks are made when you browse admin main page only" => "Les comprovacions d'alliberaments de noves versions són efectuats només quan navegues la pàgina principal d'administració",
"Force immediate check" => "Força una comprovació immediata",
"When possible, show the real user name instead of login:" => "Quan sigui possible, mostra el nom real de l'usuari enlloc del nom de connexió:",
"Locations separator" => "Separador de Localitzacions",
"Choices separator" => "Separador d'opcions",
"User registration and login" => "Registre de l'usuari i connexió",
"Use WebServer authentication for Tiki" => "Empra autenticació del ServidorWeb per a Tiki",
"... but need admin validation" => "... però es necessita validació de la persona admin",
"Create a group for each user <br />(with the same name as the user)" => "Crea un grup per a cada usuari <br />(amb el mateix nom que l'usuari)",
"Use tracker for more user information" => "Empra els formularis per més informació dels usuaris",
"Use tracker for more group information" => "Empra els formularis per més informació dels grups",
"Request passcode to register" => "Sol·licita codi de pas per a registrar-se",
"Php GD library required" => "Llibreria Php GD requerida",
"Use login as email" => "Empra nom de connexió com a correu-e",
"Validate users by email" => "Valida usuaris per correu-e",
"Validate user email server" => "Valida el servidor de correu-e de l'usuari",
"Remind passwords by email (if \"Store plaintext passwords\" is activated.) Else, Reset passwords by email" => "Recorda contrasenyes per correu-e (si \"Desar contrasenyes en txt pur\" està activada.) Si no, re-assigna'n un de nou per correu-e",
"Store plaintext passwords" => "Desa contrasenyes en text pur",
"Crypt passwords method" => "Mètode de Xifrat de contrasenyes",
"Reg users can change password" => "Usuaris enregistrats poden canviar la seva contrasenya",
"Reg users can change language" => "Els usuaris registrats poden canviar l'idioma",
"Restrict available languages" => "Restringeix idiomes disponibles",
"Available languages:" => "Idiomes disponibles:",
"Minimum username length" => "Longitud mínima de nom d'usuari",
"Maximum username length" => "Longitud màxima de nom d'usuari",
"Force lowercase username" => "Força emprar nom d'usuari en minúscules",
"Force to use chars and nums in passwords" => "Força a emprar caracters i números en contrasenyes",
"Minimum password length" => "Mida mínima de contrasenya",
"Password invalid after days" => "Contrasenya invàlida després de dies",
"-1 for never" => "-1 per a mai",
"Re-validate user by email after days" => "Re-valida els usuaris per correu-e després del número de dies",
"Re-validate user by email after unsuccessful logins" => "Re-valida els usuaris per correu-e després del nombre d'intents de connexió sense èxit",
"Remember me feature" => "Característica per enrecordar-me",
"Remember me name" => "Nom per enrecordar-me",
"Remember me domain" => "Domini per enrecordar-me",
"Remember me path" => "Ruta per enrecordar-me",
"Protect against CSRF with a confirmation step" => "Protegir contra CSRF amb un pas de confirmació",
"Highlight Group" => "Destaca Grup",
"User can choose beyond these groups at registration time" => "L'usuari pot escollir entre aquests grups al moment d'enregistrar-se",
"Specify the fields that will be asked in admin->groups" => "Especifica els camps que seran demanats a admin->grups",
"Displays user's contribution in the user information page" => "Mostra la contribució d'una persona usuària en la pàgina seva d'informació personal",
"Displays UserTracker information in user information page. Format: trackerId, fieldId1, fieldId2, …" => "Mostra la informació del Formulari de l'Usuari a la pàgina d'informació de l'Usuari. Format: trackerId, fieldId1, fieldId2, …",
"Deactivate login autocomplete (do not remember login and password)" => "Desactiva autocompletat de les dades de connexió (no recordis nom d'usuari ni contrasenya)",
"Create user if not in Tiki?" => "Crear usuari/a si no hi és al Tiki?",
"Create user if not in Auth?" => "Crear usuari/a si no és un Autor?",
"Just use Tiki auth for admin?" => "Només fes servir autor de Tiki per a administració?",
"LDAP URL<br />(if set, this will override the Host and Port below)" => "URL LDAP<br />(si s'especifica, sobreescriurà el nom de servidor i port de sota)",
"LDAP Host" => "Servidor LDAP",
"LDAP Scope" => "Objectiu LDAP",
"LDAP Base DN" => "DN Base LDAP",
"LDAP User DN" => "LDAP usuari/a DN",
"LDAP User Attribute" => "LDAP Atribut d'usuari/a",
"LDAP User OC" => "LDAP usuari/a OC",
"LDAP Group DN" => "LDAP Grup DN",
"LDAP Group Attribute" => "LDAP Atribut de Grup",
"LDAP Group OC" => "LDAP Grup OC",
"LDAP Member Attribute" => "LDAP Atribut de Membre",
"LDAP Member Is DN" => "LDAP Membre és DN",
"LDAP Admin User" => "LDAP Administra Usuari",
"LDAP Admin Pwd" => "LDAP Administra Contrasenya",
"CAS server hostname" => "nom del servidor CAS",
"CAS server port" => "port del servidor CAS",
"CAS server path" => "ruta del servidor CAS",
"Change CAS preferences" => "Canvia preferències de CAS",
"Users Defaults" => "Per defecte per als nous usuaris",
"Change users defaults" => "Canvia els valors per defecte per als nous usuaris",
"Note: This feature also requires PHPLayers to be turned on in " => "Nota: Aquesta funcionalitat també requereix que PHPLayers estigui activat a ",
"Meta Keywords" => "Meta Paraules clau",
"Meta Description" => "Meta Descripció",
"Meta Author" => "Meta Autor",
"revisit after" => "revisita després de",
"Allow Smileys" => "Permetre Emoticones",
"Use File Galleries for images inclusion" => "Empra les Galeries d'arxius per la inclusió d'imatges",
"Hotwords in New Windows" => "Paraules calentes en finestres noves",
"Trackers attachments preferences" => "Preferències dels adjunts dels Formularis",
"Trackers attachments" => "Adjunts dels formularis",
"To add/edit wiki pages easily, add the module quick_edit via \"Modules\" on the application menu, or" => "Per afegir/editar pàgines wiki fàcilment, afegeix el mòdul d'edició ràpida (quick_edit) via \"Mòduls\" en el menú principal de l'aplicació, o",
"Create a Tag for the Current Wiki" => "Crea una Etiqueta per al Wiki actual",
"Restore the Wiki" => "Restaura el Wiki",
"restore" => "recuperar",
"Remove a Tag" => "Elimina l'Etiqueta",
"Wiki Comments Settings" => "Paràmetres dels Comentaris Wiki",
"Wiki Administration" => "Administració Wiki",
"Wiki Home Page" => "Pàgina Inicial del Wiki",
"Wiki Discussion" => "Discussió Wiki",
"Wiki Link Format" => "Format d'enllaç Wiki",
"Controls recognition of Wiki links using the two parenthesis Wiki link syntax <i>((page name))</i>." => "Controls de reconeixement dels enllaços Wiki usant la sintaxi de dos parèntesis <i>((nom de la pàgina ))</i>.",
"Wiki Page Staging and Approval" => "Pàgines Wiki per Revisar i Aprovar",
"Wiki Page List Configuration" => "Configuració de la llista de pàgines Wiki",
"Wiki Features" => "Funcionalitats del Wiki",
"Wiki History" => "Historial del Wiki",
"History only for data, description, comment change" => "Historial només per a canvi de dades, de descripció i de comentari",
"Wiki Watch" => "Avisos del Wiki",
"More Links" => "Més enllaços",
"browse the category system" => "navega el sistema de categories",
"Admin Charts" => "Administrar llistes",
"Add new rule" => "Afegir regla",
"EMail notifications" => "Notificacions de correu electrònic",
"Edit this RSS module:" => "edita aquest mòdul RSS:",
"Create new RSS module" => "Crear un nou mòdul RSS",
"Tikiwiki settings" => "Paràmetres de Tikiwiki",
"Create/edit questions for survey" => "Crear/edita preguntes per a enquesta",
"Wiki textaera" => "Àrea de Text del Wiki",
"Active?" => "Actiu?",
"Create Trackers" => "Crea formularis",
"Create/Edit Trackers" => "Crea/edita formularis",
"tracker name must be unique, field names must be unique \nfor a tracker and they must be valid in SQL" => "el nom del formulari ha de ser únic, els noms dels camps han de ser únics \nper a un formulari i han de ser vàlids en SQL (sense espais ni caràcters especials)",
"or list of fields separated by comma" => "o llista de camps separats per comes",
"Create item" => "Crea l'ítem",
"Warning: since this tiki site is in slave mode, all user information you enter manually will be automatically overriden by other site's data, including users permissions" => "Avís: com que aquest lloc tiki és en mode esclau, tota la informació d'usuari que introdueixis manualment se sobreescriurà automàticament amb dades d'altres llocs web, inclosos els permisos d'usuari",
"Assign to Groups" => "Assigna a grups",
"show help" => "mostra ajuda",
"Delete this type" => "Elimina aquest tipus",
"level configuration" => "configuració de nivells",
"Browse gallery" => "Fulleja galeria",
"Upload from disk" => "Pujar des del disc local",
"Browse file gallery" => "Navega per la Galeria d'Arxius",
"Directory batch" => "Directori per pujada en bloc",
"Browsing Image" => "Fullejant imatge",
"Duplicate to" => "Duplica a",
"Again please" => "Un altre cop si us plau",
"Admin category relationships" => "Administrar relacions de categoria",
"Validate links" => "Valida enllaços",
"File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model." => "Arxius amb noms pujats per -{\$user} són modificables, altres, només són duplicables i són fets servir com a model.",
"Im- Export Languages" => "Importar/Exportar Idiomes",
"disable" => "desactiva",
"Reset view to site-wide default" => "Torna a configurar la vista a la que hi ha per defecte a aquest lloc",
"To add a new virtual host" => "Per afegir un nou allotjament virtual",
"Please enter your database connection information" => "Si us plau, introdueix la informació de connexió a la teva base de dades",
"Enter the hostname or IP for your database. Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Introdueix el nom de l'allotjament o IP de la teva base de dades. Empra <strong>localhost</strong> si la base de dades s'executa al mateix ordinador que Tiki",
"Database name" => "Nom de la Base de dades",
"Database User" => "Usuari de la base de dades",
"Enter the database user with administrator permission for the Database" => "Introdueix l'usuari de la base de dades amb permisos d'administració per a la Base de dades",
"Enter the password for the database user" => "Introdueix la contrasenya per a l'usuari de la base de dades",
"Welcome to the installation{if \$tikidb_created} &amp; upgrade{/if} script!" => "Benvinguts al procés d'instal·lació{if \$tikidb_created} &amp; actualització{/if}!",
"Reinstall database." => "Reinstal·la la base de dades.",
"No profiles available." => "Cap perfil disponible.",
"Do nothing and enter Tiki" => "No facis res més que entrar a Tiki",
"Reset database connection settings" => "Torna a especificar els paràmetres de connexió a la base de dades",
"Important Information" => "Informació Important",
"Please read the following notes before entering Tikiwiki." => "Si us plau, llegeix les següents notes abans d'entrar a Tikiwiki.",
"Tiki has not detected your PHP memory_limit. This probably means you have no set limit (all is well)" => "Tiki no ha detectat la teva configuració PHP per al paràmetre memory_limit. Això vol dir probablement que no hi ha posat cap límit (tot està bé)",
"Entering TikiWiki" => "Entrant a TikiWiki",
"Do not use your browser's Back button." => "No empris el botó d'endarrere del teu navegador.",
"Create a file gallery" => "Crear una galeria d'arxius",
"Support tickets" => "Tiquets de suport",
"(Only .gif images, and aproximately 45px x 45px)" => "(En alguns servidors, només imatges .gif, i aproximadament 45px x 45px)",
"Return to HomePage" => "Torna a la PaginaInicial",
"{icon _id=information.png style=\"vertical-align:middle\"} Content may be out of date" => "{icon _id=information.png style=\"vertical-align:middle\"} El contingut pot estar desfasat",
"Stats for this survey Questions " => "Estadístiques per a les preguntes d'aquesta enquesta",
"SysLog" => "Registre del sistema (SysLog)",
"watched events" => "esdeveniments vigilats",
"1 suggestion" => "1 suggeriment",
"suggestions" => "suggeriments",
"Another post with the same title and content already exists." => "Ja existeix una publicació amb el mateix títol i contingut.",
"Please change your title or content then click Post." => "Si us plau, canvia el teu títol o contingut i clica de nou a Publicar.",
"Format : x,y,zoom - You can use Google Map Locator in the item view script." => "Format : x,y,zoom - Pots emprar el localitzador de mapes de Google quan visualitzis la fitxa de l'item.",
"fields marked with a * are mandatory" => "Els camps marcats amb un asterisc * són obligatoris",
"Show Filters" => "Mostra filtres",
"Minor Edit" => "Edició Menor",
"The \"Snarf Wikiplugin\" is installed. It can be used by wiki editors to include pages from the local network and via regex replacement create any html." => "El connector \"Snarf Wikiplugin\" està instal·lat. Pot ser emprat fàcilment per editors Wiki per incloure pàgines des de la xarxa local i via reemplaçament d'expressions regulars crear qualsevol html.",
"The \"Regex Wikiplugin\" is installed. It can be used by wiki editors to create any html via regex replacement." => "El connector \"Regex Wikiplugin\" està instal·lat. Pot ser emprat per editors Wiki per crear qualsevol html via reemplaçament a través d'expressions regulars.",
"The \"Lsdir Wikiplugin\" is installed. It can be used by wiki editors to view the contents of any directory." => "S'ha instal·lat el \"Lsdir Wikiplugin\". El poden utilitzar els editors de wiki per veure el contingut de qualsevol directori.",
"The \"Bloglist Wikiplugin\" is installed. It can be used by wiki editors to disclose private blog posts." => "Està instal·lat el connector \"Bloglist Wikiplugin\". Pot ser emprat per editors Wiki per mostrar publicacions privades de bitàcoles.",
"You can not download files" => "No pots descarregar fitxers",
"cannot be found" => "no es pot trobar",
"You are not yet validated" => "Encara no estàs validat",
"Invalid password.  Your current password is required to change administrative information" => "Contrasenya invàlida. Es requereix la teva contrasenya actual per canviar informació administrativa",
"Please wait 2 minutes between posts" => "Si us plau, esperi 2 minuts entre missatges",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else.\n{\$mail_machine}/tiki-change_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nDone! You should be logged in." => "Si us plau, clica al següent enllaç per confirmar el teu desig de re-especificar la teva contrasenya i anar a la pantalla on hauràs d'introduir una contrasenya nova i \"permanent\". Si us plau, escull una contrasenya que només sàpigues tu, i no la comparteixis amb ningú més.\n{\$mail_machine}/tiki-change_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nFet! Hauries d'estar a dins.",
"Wiki page %s changed" => "La pàgina Wiki %s ha canviat",
"Blog features" => "Funcionalitats de les Bitàcoles",
"Blog level comments" => "Comentaris a nivell de Bitàacola",
"Post level comments" => "Comentaris a nivell de publicació",
"Trackbacks Pings" => "Pings Trackbacks",
"Post level trackback pings" => "Trackback pings a nivell de publicació",
"Spellchecking" => "Comprovació ortogràfica",
"Blogs have a custom heading" => "Les bitàcoles tenen una capçalera adpatable",
"Default ordering for blog listing" => "Ordenació predeterminada per a la llista de bitàcoles",
"Blog listing configuration (when listing available blogs)" => "Configuració del llisat de bitàcoles (quan es llistin les bitàcoles disponibles)",
"Last modification time" => "Data de la Darrera modificació",
"Blog comments settings" => "Configuració de comentaris de les bitàcoles",
"Group calendar sticky popup" => "Emergent enganxós del calendari de grup",
"Group calendar item view tab" => "Pestanya de visualització de l'ítem del calendari de grup",
"Calendar manual selection of time/date" => "Selecció manual de hora/dia per al Calendari",
"First year in the dropdown, either year number, or relative to current year (+/- N)" => "Primer any al desplegable, o número d'any, o relatiu a l'any actual (+/- N)",
"if no jscalendar" => "si no es fa servir el Calendari en javascript (jscalendar)",
"Last year in the dropdown, either year number, or relative to current year (+/- N)" => "Darrer any al desplegable, o número d'any, o relatiu a l'any actual (+/- N)",
"Show Category Path" => "Mostrar camins de les categories",
"Exclude These Category IDs from Path (comma delimited)" => "Exclou aquests IDs de categories de la Ruta (separats per comes)",
"Show Category Objects" => "Mostrar objectes de les categories",
"Search may show forbidden results. Much better performance though." => "Les cerques poden mostrar resultats prohibits. Tot i això, es generen uns millors resultats.",
"Categories browse uses PhpLayers" => "La navegació de categories empra la funcionalitat de capes de php (PhpLayers)",
"The feature must be activated" => "La funcionalitat ha de ser activada",
"CMS features" => "Funcionalitats del CMS",
"Use templates" => "Empra plantilles",
"Print article" => "Imprimeix article",
"Can specify notification emails when creating an article" => "Pot especificar correus-e de notificació quan es crea un article",
"Settings for page articles home" => "Paràmetres de l'inici de la pàgina d'articles",
"Maximum number of articles in home" => "Quantitat màxima d'articles a l'inici ?",
"Article comments settings" => "Configuració dels comentaris d'articles",
"Fields to display on page" => "camps que es mostraran dins la pàgina",
"Expire Date" => "Expira la Data",
"To add/remove file galleries, go to \"File Galleries\" on the application menu, or" => "Per afegir/eliminar galeries d'arxius, ves a \"Galeries d'Arxius\" en el menú de principal l'aplicació, o",
"File author" => "Autor de l'arxiu",
"For not registered author" => "Per a autors no registrats",
"Uploaded filenames cannot match regex" => "Els arxius penjats no han de coincidir amb aquesta regex",
"File galleries comments settings" => "Configuració dels comentaris de les galeries d'arxius",
"File galleries search indexing" => "Indexat de cerca de galeries d'arxius",
"Leave command blank to delete handler" => "Deixa l'ordre en blanc per esborrar el gestor",
"Use %1 for where internal file name should be substituted (example: \"strings %1\" to convert the document to text using the unix strings command)" => "Empra %1 per al cas en que nom d'arxius interns haurien de ser substituïts  (exemple: \"strings %1\" per convertir el document a text emprant la comanda de Unix 'strings')",
"Enable auto indexing on file upload or change" => "Habilita l'auto indexat en pujar l'arxiu o canviar-lo",
"System command" => "Comanda del Sistema",
"Home Forum" => "Fòrum inicial",
"Forums features" => "Funcionalitats dels Fòrums",
"Forum quick jumps" => "Dreceres del Fòrum",
"Ordering for forums in the forum listing" => "Ordre dels fòrums a la llista de fòrums",
"Forum listing configuration" => "Configuració del llistant de Fòrums",
"Default thread style" => "Estil per defecte del fil",
"Default thread sort mode" => "Mode d'ordenació per defecte del fil",
"Freetag Browsing" => "Navegació per les etiquetes lliures",
"Show Tag Cloud" => "Mostra Núvol d'Etiquetes",
"Random tag cloud colors (separated by comma)" => "Colors a l'atzar dels núvols d'etiquetes (separats per comes)",
"Handle multilingual freetags" => "Gestiona les etiquetes lliure multiidioma",
"I18n setup" => "Configuració de I18n ",
"Default Language" => "Idioma per defecte",
"Available languages (Ctrl+Click to select multiple languages):" => "Idiomes disponibles (Fes Ctrl+Click per seleccionar-ne múltiples):",
"Show Babelfish Translation URLs" => "Mostrar URLs de traducció de Babelfish",
"Show Babelfish Translation Logo" => "Mostrar Logo de traducció de Babelfish",
"Allow Anonymous Poll Voting" => "Permet consultes anònimes",
"Parse the result (can be slow)" => "Interpreta el resultat (pot ser lent)",
"Database Search using MySQL 'Full-Text' Feature" => "Cerca a la base de dades emprant la funcionalitat de 'Text-complet' de MySQL",
"Activate MySQL Full-Text feature" => "Activa la funcionalitat de Text-complet de MySQL",
"Activate MySQL 'Full-Text' feature" => "Activa la funcionalitat de 'Text-complet' de MySQL",
"Performance issues" => "Opcions de funcionament",
"Database Independent Full Text Search or Tiki Search" => "Cerca per Text-complet independentment de la base de dades o Cerca pròpia del Tiki",
"This is activated by default if MySQL 'Full-Text' feature is not activated above" => "Això s'activa per defecte si la funcionalitat de 'Text-complet' de MySQL no s'ha activat més amunt",
"Search features" => "Funcionalitats de cerca",
"SearchStats" => "Estadístiques de cerca",
"Settings for searching content" => "Paràmetres de cerca de continguts",
"Search refresh mode" => "Mode de refresc de la cerca",
"Search refresh rate" => "Ritme de refresc de busqueda",
"0 for no refresh" => "0 per cap refresc",
"Number of lines" => "Nombre de línies",
"this survey stats" => "estadistiques d'aquesta enquesta",
"To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tiki.org\">themes</a>." => "Per aprendre més sobre <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tiki.org\">Temes</a> (d'estil, estètica).",
"You have {\$unread} unread private messages" => "Tens {\$unread} missatges privats sense llegir",
"unread private messages" => "missatges privats no llegits",
"Textarea options: quicktags,width,height,max,listmax,wordmax - Use Quicktags is 1 or 0, width is indicated in chars, height is indicated in lines, max is the maximum number of characters that can be saved, listmax is the maximum number of characters that are displayed in list mode, wordmax>0 alert if word count exceeded, wordmax<0 display word count." => "Opcions d'àrea de text: quicktags,width,height,max,listmax,wordmax - Utilització. Quicktags és 1 o 0, width s'indica en caràcters, height s'indica en línies, max és el nombre màxim de caràcters que es poden gravar, listmax és el nombre màxim de caràcters que es visualitzen en el mode llista, wordmax>0 avisa si se supera el recompte de paraules, wordmax<0 visualitza el recompte de paraules.",
"Country Selector options: name/flag, sortorder - name/flag is 0,1 or 2 where 1 shows only country name, 2 shows only country flag, 0 shows both (default). sortorder is 0 or 1 where 0 sorts according to translated text (default) and 1 sorts according to english country names even if country names are translated" => "Opcions de selector de país: nom/bandera, el criteri d'ordenació segons nom/bandera és 0,1 o 2, on 1 mostra només el nom del país, 2 mostra només la bandera del país, 0 mostra ambdues coses (per defecte). El criteri d'ordenació és 0 o 1, on 0 ordena segons el text traduït (per defecte) i 1 ordena segons els noms de país en anglès encara que estiguin traduïts",
"listview=nst, n to see name/t to see type/s to see type/u to see user in list mode" => "listview=nst, n per veure nom/t per veure tipus/s per veure tipos/u per veure usuari en el mode llista",
"blogId is mandatory" => "blogId és obligatori",
"Includes blog posts listing into a wiki page" => "Inclou un llistat de publicacions del bloc en una pàgina wiki",
"Tiki is unable to connect to the database " => "Tiki no pot connectar a la base de dades ",
"Tiki was unable to retrieve login data from the database " => "Tiki no ha pogut obtenir les dades de connexió de la base de dades ",
"Is your database up and running" => "Està ben instal·lada i funcionant la teva base de dades?",
"Are your database login credentials correct" => "Són correctes les teves credencials de connexió",
"Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Vas completar <a href='tiki-install.php' >l'instal·lador",
"Please see <a href=\"http://doc.tiki.org/\">the documentation</a> for more information" => "Si us plau, consulta <a href=\"http://doc.tiki.org/\">la documentació</a> per a més informació",
"Sample plugin" => "connector (Plugin) de prova",
"Font family to use" => "Familia de fonts a emprar",
"As defined by CSS" => "Com es troba definit per CSS",
"Flash player not available" => "El reproductor Flash player no està disponible",
"__WARNING__: Plugin disabled \$plugin" => "__ATENCIÓ__: El Connector (Plugin) \$plugin està deshabilitat",
"Image alignment. Possible values: left, right, center" => "Alineació de la imatge. Possibles valors: esquerra, dreta, centre",
"Image annotations changed" => "Les anotacions de la imatge han canviat",
"Displays an image and enables users to define zones to highlight information on the image" => "Mostra una imatge i permet als usuaris definir zones per ressaltar informació a la imatge",
"Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool" => "Mostra un gràfic a partir d'un Full de càlcul Tiki. Aquest connector pot ser generat per l'eina de gràfics dels FullsTiki",
"Chart caption" => "Títol del gràfic",
"List of colors to use" => "Llistat de colors a emprar",
"List of styles to use" => "Llista d'estils a emprar",
"Labels for the series or values in the legend" => "Etiquetes per les sèries o valors a la llegenda",
"Code snippet label" => "Etiqueta del tros de codi",
"Name of the drawing to display" => "Niom del dibuix a mostrar",
"Renders an equation written in LaTeX syntax as an image" => "Mostra com a imatge una equació escrita en sintaxi LaTeX",
"Includes the list of events from a calendar in the page" => "Inclou una llista d'esdeveniments d'un calendari a la pàgina",
"Displays a label. On click, the block of content will fade in and fade out" => "Mostra una etiqueta. En clicar-hi, el bloc de contingut es mostrarà gradualment o s'esvairà gradualment",
"One item per line starting with anything followed by \")\"" => "Un ítem per línia començant per quelcom seguit de  \")\"",
"One row per line, cells separated by ~|~" => "Una fila per línia, cel·les separades per ~|~",
"Complete URL to the movie to include" => "URL completa de la pel·lícula a incloure",
"Since your last visit.." => "Desde la teva darrera visita..",
"To learn more, visit: <a href=\"http://tiki.org\" title=\"The TikiWiki Community\" target=\"_blank\">http://tiki.org</a>" => "Per aprendre més, visita: <a href=\"http://tiki.org\" title=\"La Comunitat TikiWiki\" target=\"_blank\">http://tiki.org</a>",
"Select from available options.." => "Selecciona de la llista d'opcions disponibles..",
"Change the style used to display differences to be translated" => "Canvia l'estil emprat per mostrar les diferències que s'han de traduir",
"Switch to WYSIWYG editor" => "Canvia a editor WYSIWYG (visual)",
"Welcome to the TikiWiki installation and upgrade script" => "Benvinguts a l'instal·lador i actualitzador de TikiWiki",
"Select your language" => "Selecciona el teu idioma",
"Please read the following license agreement" => "Si us plau, llegeix el següent acord de llicència",
"Tiki was able to send a test message to info@tiki.org" => "Tiki ha pogut enviar un missatge de prova a info@tiki.org",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Revisa els paràmetres del correu en l'arxiu <strong>php.ini</strong> del teu sistema (per exemple: confirma que la ruta <strong>sendmail_path</strong> és correcta)",
"Enter the host name or IP for your database" => "Introdueix el nom de l'hoste o IP per a la teva base de dades",
"No Internet Connection has been found" => "No s'ha trobat cap connexió a Internet",
"The default installation profile will be used" => "S'emprarà el perfil d'instal·lació per defecte",
"You can now log in into Tikiwiki as user <strong>admin</strong> and start configuring the application" => "Ara pots entrar a Tikiwiki com a usuari <strong>admin</strong> i començar a configurar l'apliacció",
"Database was left unchanged" => "S'ha deixat la base de dades sense canvis",
"Your database has been configured and Tikiwiki is ready to run" => "La teva base de dades ha estat configurada i Tikiwiki està llest per funcionar",
"TikiWiki is an opensource project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>develop Tiki</a>" => "TikiWiki és un projecte de programari lliure: <em>pots</em> <a href='http://info.tiki.org/Join+the+Community' target='_blank'>ajuntar-te amb altres de la Comunitat</a> i ajudar  <a href='http://info.tiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>a desenvolupar Tiki</a>",
"hr" => "hr",
"The text in RED is" => "El text en vermell és",
"Old:" => "Antic:",
"New:" => "Nou:",
"Show Categories" => "Mostra categories",
"Hide Categories" => "Oculta categories",
"MyTiki Home" => "Inici ElmeuTiki",
"My Files" => "Els meus arxius",
"FriendsMenu" => "MenúAmics",
"Send Pages" => "Enviar pàgines",
"Received Articles" => "Articles rebuts",
"Admin Posts" => "Administra missatges",
"Submit a New Link" => "Enviar un nou enllaç",
"Admin Directory" => "Administrar directori",
"Layer Management" => "Controlant capes",
"Ephemerides Admin" => "Administrar efemèrides",
"Charts Admin" => "Administrador de sondejos (charts)",
"Debugger console" => "Consol·la Depuradora",
"This is" => "Això és",
"by the" => "pel",
"Tiki community" => "Comunitat del Tiki",
"Copyright Management" => "Control de Copyright",
"License Page" => "Pàgina de Llicència",
"Submit Notice" => "Enviar Avis",
"Enable Feature for Wiki" => "Habilita funcions per al Wiki",
"Enable Feature for Articles" => "Habilita funcions per a articles",
"Enable Feature for Blogues" => "Habilita funcions per a blocs",
"Enable Feature for Faqs" => "Habilita funcions per a pmf",
"Right &amp; left boxes" => "Els mòduls són els Requadres a la dreta &amp; esquerra amb contingut prefabricat a dins. (No s'han de confondre amb els 'Mods' o paquets externs addicionals que es poden instal·lar com a complements al teu tiki)",
"Administer modules" => "Administra mòduls",
"Show Module Controls" => "Mostrar Controls de Mòdul",
"Users can Configure Modules" => "Els usuaris poden configurar mòduls",
"Users can Shade Modules" => "Els usuaris poden ocultar mòduls",
"module decides" => "decisió a nivell de mòdul",
"seconds (0 = cache inactive)" => "segons (0 = memòria cau inactiva)",
"Enable now." => "Habilita-ho ara.",
"bold" => "negreta",
"italic" => "cursiva",
"underline" => "subratllat",
"Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"./setup.sh\" for example)." => "Apache té el permís d'escriure al teu arbre d'arxius, el que permet la instal·lació, esborrat o actualització de paquets. Quan hagis acabat amb aquestes operacions, pensa en arreglar aquests permisos de nou a un estat segur (a travś de \"./setup.sh\" per exemple).",
"To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"./setup.sh open\" to set it up). After installation you need to remove that permission (using \"./setup.sh\")." => "Per instal·lar, eliminar o actualitar paquets necessites donar a l'usuari apache el dret per escriure arxius en el teu arbre web (pots emprar \"./setup.sh open\" per configurar-ho com es necessita). Després de la instal·lació, necessites eliminar aquests permisos (emprant \"./setup.sh\").",
"GalMenu" => "GalMenu",
"ForMenu" => "ForMenu",
"Enter a database user with administrator permission for the Database" => "Enter a database user with administrator permission for the Database",
"TikiWiki" => "TikiWiki",
"(unchanged)" => "(sense canvis)",
"Remaining:" => "Queda:",
"you or someone registered this email address at" => "tu o alguna persona ha registrat aquesta adreça de correu-e a",
"Your Tiki information registration" => "El teu registre d'informació de Tiki",
"Your registration" => "El teu registre d'informació de Tiki",
"left/right" => "esquerra/dreta",
"Unassign module" => "Mòdul no assignat",
"home" => "inici",
"chat" => "xat",
"contact us" => "contacta'ns",
"debugger console" => "consol·la depuradora",
"MyMenu" => "Elmeumenú",
"User menu" => "Menú de l'usuari",
"WikiMenu" => "MenuWiki",
"dump" => "buidat",
"rankings" => "posicions",
"orphan pages" => "pàgines òrfenes",
"sandbox" => "llocdeproves",
"received pages" => "pàgines rebudes",
"structures" => "estructures",
"Articles Home" => "Inici dels articles",
"Send articles" => "Envia articles",
"Create/Edit Blog" => "Crea/Edita bitàcoles",
"DirMenu" => "DirMenú",
"Browse Directory" => "Explorar directori",
"FileGalMenu" => "MenuGalArx",
"Admin FAQs" => "Administrar PUFs",
"Edit mapfiles" => "edita mapa d'arxius",
"QuizMenu" => "Menú del test",
"Admin quiz" => "Administrar test",
"TrkMenu" => "MenuTrk",
"Admin trackers" => "Administra formularis",
"Send newsletters" => "Envia butlletins",
"Send events" => "Envia events",
"Admin events" => "Administra events",
"EphMenu" => "Menú d'efemèrides",
"Ephemerides" => "Efemèrides",
"ChartMenu" => "MenúdeGràfics",
"AdmMenu" => "Menúd'Adm",
"Admin home" => "Admin Inici",
"Backups" => "Còpies de seguretat",
"External wikis" => "Wikis externs",
"Mods Admin" => "Administració de Mods",
"UsrMenu" => "MenúUsr",
"Click here to manage your personal menu" => "Cliqueu aquí per configurar-vos el vostre menú personal",
"Quick edit a Wiki page" => "Edició ràpida de pàgina Wiki",
"Language: " => "Idioma: ",
"Sort posts by:" => "Ordena correus per",
"read more" => "llegiu-ne més",
"For more information, please see <a href=\"{\$prefs.helpurl}Wiki Page Editor\">Wiki Page Editor</a>" => "Per més informació, si us plau consulta l'<a href=\"{\$prefs.helpurl}Wiki Page Editor\">Editor de Pàgines Wiki</a>",
"Quicktag" => "Marca ràpida",
"Use this script to install a new TikiWiki database or upgrade your existing database to release" => "Empra aquesta utilitat per instal·lar una nova base de dades de TikiWiki o actualitzar la teva base de dades existent a l'alliberament",
"For more information about TikiWiki, please visit" => "Per més informació sobre TikiWiki, si us plau visita",
"TikiWiki is software distributed under the LGPL license" => "Tiki és programari distribuït sota la llicència LGPL",
"This installer will perform some basic checks automatically" => "Aquest instal·lador realitzarà algunes comprovacions bàsiques automàticament",
"Tiki has not detected your PHP memory_limit" => "Tiki no ha detectat el teu  memory_limit de PHP",
"This probably means you have no set limit (all is well)" => "Això probablement vol dir que no tens límit específicat (tot està bé)",
"alert" => "alerta",
"Tiki has detected your PHP memory limit at" => "Tiki ha detectat que tens el limit de memòria de PHP a",
"TikiWiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "TikiWiki requireix <strong>com a mínim</strong> 32MB de memòria PHP per a executar-se correctament en totes les seves funcionalitats",
"Allocating too little memory will cause TikiWiki to display blank pages" => "Reservar massa poca memòria per cada aplicació PHP farà que TikiWiki mostri pàgines en blanc",
"To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver" => "Per canviar el límit de memòria, empra el paràmetre  <strong>memory_limit</strong> al teu arxiu <strong>php.ini </strong> al servidor (per exemple: memory_limit = 32M) i re-inicia el servidor web",
"Tiki has detected your PHP memory_limit at" => "Tiki ha detectat el paràmetre de PHP memory_limit del teu servidor web en",
"TikiWiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "TikiWiki empra la funció <strong>mail</strong> de PHP per enviar notificacions de correu-e i missatges",
"To test your system configuration, TikiWiki will attempt to send a test message to info@tiki.org" => "Per comprovar la teva configuració del sistema, TikiWiki provarà d'enviar un missatge de prova a info@tiki.org",
"Tiki was not able to send a test message" => "Tiki no ha pogut enviar cap missatge de prova",
"Review your mail log for details" => "Revisa el registre del correu-e del servidor per més detalls",
"If your host requires SMTP authentication, additional configuration may be necessary" => "Si el teu hoste requereix autenticació SMTP, pot ser necessària una mica més de configuració addicional",
"Tiki detected" => "Tiki ha detectat",
"Tiki was not able to detect the GD library" => "Tiki no ha pogut detectar la llibreria GD",
"TikiWiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "TikiWiki empra la llibreria GD per processar imatges per a la galeria d'imatges i el suport CAPTCHA",
"TikiWiki requires an active database connection" => "TikiWiki requireix una connexió activa a base de dades",
"You must create the database and user <em>before</em> completing this page" => "Has de crear la base de dades i el seu usuari <em>abans</em> de completar aquesta pàgina",
"Tiki cannot find a database connection" => "Tiki no pot trobar cap connexió amb la base de dades",
"This is normal for a new installation" => "Això és normal per a una instal·lació nova",
"Tiki found an existing database connection in your local.php file" => "Tiki ha trobat que ja existeix una connexió a base dades en el teu arxiu local.php",
"Use this page to create a new database connection" => "Empra aquesta pàgina per crear una nova connexió a base de dades",
"Enter your database connection information" => "Introdueix la informació de la teva connexió a base de dades",
"Database type" => "Tipus de Base de dades",
"Select the type of database to use with Tiki" => "Escull tipus de base de dades a emprar amb Tiki",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Empra <strong>localhost</strong> si la base de dades s'està executant a la mateixa màquina que el Tiki",
"For SQLite, enter the path and filename to your database file" => "Per a SQLite, introdueix la ruta i nom d'arxiu de la teva base de dades",
"The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names" => "La base de dades ha d'existir. Pots crear la base de dades emprant mysqladmin, PHPMyAdmin, cPanel, o demanar-ho al proveïdor de l'hoste.  Les taules de Tiki normalment no creen cap conflicte amb altres programaris instal·lats a la mateixa base de dades",
"For Oracle" => "Per Oracle",
"Enter your TNS Name here and leave Host empty" => "Introdueix el teu nom TNS aquí i deixa l'allotjament buit",
"Override tnsnames.ora and put your SID here and enter your hostname:port in the Host field" => "Sobreescriu tnsnames.ora , posa el teu SID aquí i introdueix el teu nomdallotjament:port al camp Allotjament",
"Select the installation" => "Selecciona la instal·lació",
"(or upgrade)" => "(o actualització)",
"script to use" => "arxiu de seqüències a emprar",
"This script will populate {if \$tikidb_created}(or upgrade){/if} the database" => "Aquesta utilitat omplirà {if \$tikidb_created}(o actualitzarà){/if} la base de dades",
"Profiles can be used to pre-configure your site with specific features and settings" => "Es pot emprar la funcionalitat 'Perfils' per pre-configurar el teu lloc amb funcionalitats i paràmetres de configuració específics",
"Visit <a href=\"http://profiles.tiki.org\" target=\"_blank\">http://profiles.tiki.org</a> for more information" => "Visita <a href=\"http://profiles.tiki.org\" target=\"_blank\">http://profiles.tiki.org</a> per a més informació",
"This will destroy your current database" => "Això destruirà la teva base de dades actual",
"Create a new database (clean install) with profile" => "Crea una nova base de dades (instal·lació neta) amb el perfil",
"This site has an admin account configured" => "Aquest lloc té un compte d'administrador configurat",
"Please login with your admin password to continue" => "Si us plau, connecta't amb la teva contrasenya d'administrador per continuar",
"Pass" => "Contrasenya",
"Review the" => "Revisa l'",
"Your database has been configured and Tikiwiki is ready to run!" => "La teva base de dades ha estat configurada i Tikiwiki està llest per funcionar!",
"operations executed successfully" => "operacions executades amb èxit",
"SQL queries" => "Consultes SQL",
"Operations failed" => "Operacions que no han tingut èxit",
"Display details" => "Mostra detalls",
"Go back and run another install/upgrade script" => "Torna enrera i executa una altra seqüència d'instal·lació / actualització",
"To secure your TikiWiki installation - and if you are using Apache web server - you should rename the <span style=\"font-weight: bold\">_htaccess</span> file to <span style=\"font-weight: bold\">.htaccess</span> (this file is in the main directory)" => "Per a fer més segura a teva instal·lació de TikiWiki - i si empres el servidor web Apache - hauries de reanomenar l'arxiu <span style=\"font-weight: bold\">_htaccess</span> a <span style=\"font-weight: bold\">.htaccess</span> (aquest arxiu es troba al directori principal)",
"Complete these fields to configure common, general settings for your site" => "Completa aquests camps per configurar paràmetres comuns i generals del teu lloc",
"The information you enter here can be changed later" => "La informació que introdueixis aquí la podràs canviar més endavant",
"Refer to the <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Consulta la <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentació</a> per informació completa sobre aquests i altres paràmetres de configuració",
"This will appear in the browser title bar" => "Això apareixerà en la barra de títol del navegador",
"Email sent by your site will use this address" => "Els correus-e enviats pel teu lloc empraran aquesta adreça de sortida",
"HTTPS login" => "Connexió segura HTTPS",
"Admin email" => "Correu-e de l'admin",
"This is the email address for your administrator account" => "Aquesta és l'adreça de correu-e del teu compte d'administrador/a",
"Enter Your TikiWiki" => "Entra al teu TikiWiki",
"The installation is complete" => "S'ha acabat el procés d'instal·lació",
"If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "Si aquesta és una instal·lació inicial, ves a <strong>tiki-admin.php</strong> després de connectar-te per tal de començar a configurar la teva nova instal·lació Tiki",
"Enter TikiWiki and Lock Installer" => "Entra a TikiWiki i bloqueja l'Instal·lador",
"Enter TikiWiki Without Locking Installer" => "Entra a TikiWiki SENSE Bloquejar l'Instal·lador",
"To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "Per afegir un nou allotjament virtual executa l'arxiu setup.sh amb el nom del domini del nou allotjament com a últim paràmetre",
"Are you upgrading an existing Tiki site" => "Estàs actualitzant un lloc Tiki existent",
"Go directly to the <strong>Install/Upgrade Profile</strong> step" => "Ves directament al pas <strong>Perfil d'Instal·lació / Actualització</strong>",
"Restart the installer" => "Reinicia l'instal·lador",
"Reset the" => "Reconfigura el/la",
"Install/Upgrade Profile" => "Instal·lació / Actualització de Perfils",
"TikiWiki Web Site" => "Lloc Web TikiWiki",
"The following error message was returned" => "S'ha retornat el següent missatge d'error",
"Things to check" => "Coses a comprovar",
"This is an approximation based on your server memory limit" => "Això és una aproximació basada en el limit de memòria del teu servidor",
"Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using TikiWiki with an incorrect database version usually causes errors" => "La teva base de dades requereix una actualització per coincidir amb la versió actual de Tikiwiki. Si us plau, dirigeix-te a <a href=\"tiki-install.php\">l'instal·lador</a>. Emprar Tiki amb una versió de base de dades normalment provoca errors",
"Displays various information about the client" => "Mostra informació variada sobre el navegador del visitant",
"Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin" => "Crea un enllaç a una àncora dins d'una pàgina. Es poden crear àncores emprant el connector ANAME",
"Anchor link label" => "Etiqueta de l'àncora",
"The anchor name as defined in the ANAME plugin" => "El nom de l'àncora tal i com es defineix en el connector ANAME",
"The name of the wiki page containing the anchor" => "El nom de la pàgina Wiki que conté l'àncora",
"Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin" => "Inserta una àncora a la pàgina Wiki. Es pot enllaçar a àncores emprant el connector ALINK",
"The name of the anchor" => "El nom de l'àncora",
"Autogenerated content. Leave blank initially" => "Contingut autogenerat. Deixa inicialment en blanc",
"Absolute URL to the image or relative path from tikiwiki root" => "URL absoluta a la imatge o ruta relativa de de l'arrel de Tikiwiki",
"Includes an article\\'s content within the page" => "Inclou el contingut d'un article dins de la pàgina",
"The article field to display. Default field is Heading" => "El camp de l'article a mostrar. El camp per omissió és la Capçalera",
"The article to display. If no value is provided, most recent article will be used" => "Article a mostrar. Si no es dóna cap valor, s'emprarà l'article més recent",
"Inserts a list of articles in the page" => "Inclou una llista d'articles dins de la pàgina",
"The number of articles to display in the list" => "La llista d'articles a mostrar de la llista",
"The ID of the category to list from" => "L'ID de la categoria des de la qual llistar el seu contingut",
"The article language to list" => "The article language to list",
"The column and order of the sort in columnName_asc or columnName_desc format" => "La columna a ordenar i tipus d'ordenació, de forma similar a NomDeColumna_asc o NomDeColumna_desc",
"Whether to not report when there are no articles" => "Si no s'ha d'informar quan ni hi hagin articles",
"Whether to only show the title of the articles" => "Si només s'ha de mostrar el títol dels articles",
"The wiki page the avatar will link to" => "La pàgina wiki a la que apuntarà l'avatar",
"List all pages linking to the specified page" => "Llista totes les pàgines que enllaçen a la pàgina especificada",
"The page links will point to. Default value is the current page" => "A on apuntaran els enllaços de la pàgina. El valor per omissió és a la mateixa pàgina",
"Use BLOGLIST to include posts from a blog" => "Empra BLOGLIST per incloure publicacions des d'una bitàcola",
"Maximum number of entries to list" => "Número màxim d'entrades a llistar",
"As defined by CSS, name or Hex code" => "Tal i com es defineix pel CSS, nom o codi Hex",
"In pixels or percentage. Default value is 100%" => "En pixels o percentatge. El valor per omissió és 100%",
"for box with width less than 100%, make text wrap around the box" => "per a caixes amb amplada inferior al 100%, fes que el text envolti la caixa",
"Apply custom CSS class to the box" => "Aplica classe CSS particular a la caixa",
"List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "Llista d'IDs de categories separades per signes +. exemple: 1+2+3. Per omissió s'empra la categoria de la pàgina actual",
"String used to separate the categories in the path. Default character is >" => "Cadena emprada per separar les categories en la ruta. El caràcter per omissió és >",
"Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Ombrejat de sintaxi a emprar. Pot ser que no es pugui emprar amb números de línia. Disponible: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
"0|1, may not be used with colors" => "0|1, és possible que no es pugui emprar amb colors",
"0|1, parse wiki syntax within the code snippet" => "0|1, interpreta la sintaxi wiki dins del connector de codi",
"Includes content from the dynamic content system" => "Inclou contingut des del sistema de contingut dinàmic",
"Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Forma de mostrar el copyright a dins. Pot contenir ~title~ (títol), ~year~ (any) i ~authors~ (autors)",
"Displays a countdown from now until the specified date" => "Mostra un compte enrera des d'ara i fins la data especificada",
"Text to append to the countdown" => "Text a afegir al compte enrera",
"Target date. Multiple formats accepted" => "Data objectiu. S'accepten múltiples formats",
"The name of a DSN connection defined by the Wiki administrator" => "El nom d'una connexió a DSN definida per l'administrador del Wiki",
"0|1, parse wiki syntax within the report" => "0|1, interpreta la sintaxi wiki amb l'informe",
"0|1, display the parsed report definition" => "0|1, mostra la definició de l'informe interpretat",
"No DSN connection string found" => "No s'ha trobat text de connexió al DSN",
"left|right, for box with width less than 100%, make text wrap around the box" => "left|right, per a caixes amb amplada inferior al 100%, fes que el text envolti a la caixa",
"Welcome to the Tiki installation and upgrade script" => "Benvinguts/des a l'Instal·lador i actualitzador de Tiki",
"Tiki is software distributed under the LGPL license" => "Tiki és programari distribuït sota la llicència LGPL",
"Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "Tiki requereix <strong>al menys</strong> 32MB de memòria PHP per a les execucions d'arxius php",
"Allocating too little memory will cause Tiki to display blank pages" => "Permetre massa poca memòria provocarà que Tiki mostri pàgines en blanc en algunes funcionalitats",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki empra la funció PHP <strong>mail</strong> per enviar notificacions per correu-e i missatges",
"To test your system configuration, Tiki will attempt to send a test message to info@tiki.org" => "Per provar la teva configuració, Tiki provarà d'enviar un misatge de prova a info@tiki.org",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki empra la llibreria GD per processar imatges a les galeries d'imatges i per al suport al CAPTCHA (imatges de verificació anti-robots)",
"Tiki requires an active database connection" => "Tiki requireix una connexió activa a base de dades",
"Use this page to create a new database connection, or use the <a href=\"http://doc.tiki.org/Manual+Installation\" title=\"manual installation\">manual installation process</a>" => "Empra aquesta pàgina per crear una nova connexió a base de dades, o empra el <a href=\"http://doc.tiki.org/Manual+Installation\" title=\"manual installation\">procés d'instal·lació manual</a>",
"Select the installation (or upgrade) profile to use. This profile will populate (or upgrade) the database" => "Selecciona el perfil que vols emprar d'instal·lació (o actualització). Aquest perfil s'instal·larà a (o actualitzarà) la base de dades",
"Select the installation profile to use. This profile will populate the database" => "Selecciona el perfil d'instal·lació que vols emprar. Aquest perfil s'instal·larà a la base de dades",
"See the documentation for <a target=\"_blank\" href=\"http://profiles.tiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Description of available profiles.\">descriptions of the available profiles" => "Mira la documentació per a les <a target=\"_blank\" href=\"http://profiles.tiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Descripció de perfils disponibles.\">descripcions dels perfils disponibles",
"The installer could not connect to the Profiles repository" => "L'instal·lador no s'ha pogut connectar al dipòsit de Perfils",
"Your database has been configured and Tiki is ready to run" => "La teva base de dades ha estat configurada i Tiki està llest per funcionar",
"You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "Ara pots connectar-te al teu Tiki com a usuari <strong>admin</strong> i començar a configurar l'aplicació",
"Upgrade operations executed successfully" => "Operacions d'actualització executades amb èxit",
"Installation operations executed successfully" => "Operacions d'instal·lació executades amb èxit",
"To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>" => "Per habilitar aquest arxiu, simplement reanomena l'arxiu <strong>_htaccess</strong> (que es troba al directori principal de la teva instal·lació de Tiki) a <strong>.htaccess</strong>",
"Tiki is an opensource project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki és un projecte de programari lliure, pel que <em>pots</em> <a href='http://info.tiki.org/Join+the+Community' target='_blank'>ajuntar-te amb la resta de la comunitat</a> i ajudar <a href='http://info.tiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>a desenvolupar i documentar Tiki</a>",
"Adding a new host" => "Afegint un nou hoste",
"Go directly to the <strong>Install/Upgrade</strong> step" => "Ves directament al pas d'<strong>Instal·lació / Actualització</strong> ",
"The cache is used by" => "La memòria cau és emprada per",
"You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "També pots emprar {literal}{content label=x}{/literal}, on x és l'etiqueta del bloc de contingut",
"Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Manca una dependència. Pots obtenir l'arxiu' <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> i pujar-lo a dins de la carpeta files/ al servidor",
"Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>" => "Els \"mods\" de Tiki són funcionalitats adicionals no incloses en l'alliberament public de Tiki. Aprèn més a <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>",
"Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache té permís per escriure en el teu arbre d'arxius, el que permet la instal·lació, esborrat o actualització de paquets. Quan hagis acabat amb aquestes operacions, pensa en tornar a deixar els permissos en un estat segur (emprant \"sh setup.sh\" per exemple)",
"To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "Per instal·lar, eliminar o actualitzar paquets necessites donar-li a l'usuari apache el dret a escriure arxius en el teu arbre de directoris (pots fer-ho emprant \"sh setup.sh open\" per configurar-ho així temporalment). Després de la instal·lació necessites eliminar aquests permisos (emprant \"sh setup.sh\")",
"No mods found" => "No s'han trobat mods",
"Object Watches" => "Subscripcions a l'objecte",
"Watching Groups" => "Grups subscrits",
"After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "Després de la validació dels arguments per un editor, es va denegar l'execució del connector. Aquesta ús del connector serà eventualment eliminat o corregit",
"This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "Aquest ús del connector ha estat afegit o midificat recentment. Fins que un edior del lloc en validi els paràmetres, la seva execució no és possible",
"You are allowed to" => "T'està permés de",
"This plugin does not contain any arguments" => "Aquest connector no conté arguments",
"This plugin's body is empty" => "El cos del connector és buit",
"Items found" => "Ítems trobats",
"Plugins pending validation are added to this list the first time they are encountered. Only their <em>signature</em> is preserved. Some of the plugins listed here may no longer be in use in the page originally using them. In this case, it's safe to clear them from this list. They will be added back next time they are encountered. Plugins can be approved or rejected from the page containing them" => "S'afegeixen a aquesta llista els usos de connectors que requereixen validació la primera vegada que es troben. Només es preserva la seva <em>signatura</em>. Alguns dels connectors mostrats aquí poden no trobar-se en ús a la pàgina original que els emprava. En aquest cas, és segur netejar-los d'aquesta llista. Seran afegits automàticament la propera vegada que siguin trobats. Es pot aprovar o denegar l'ús dels connectors des de la pàgina que els conté",
"No plugin pending approval" => "No hi ha cap ús de connectors esperant aprovació",
"Not your password" => "No la teva contrasenya",
"Generate a\tpassword" => "Genera una \tcontrasenya",
"Enter your username or email" => "Introdueix el teu nom d'usuari o correu-e",
"Enter your email" => "Introdueix el teu correu-e",
"A leading plus sign indicates that this word must be present in every object returned" => "Un signe més al davant indica que aquesta paraula ha de ser present en cada objecte retornat",
"A leading minus sign indicates that this word must not be present in any row returned" => "Un signe menys al davant indica que aquesta paraula no ha de ser present en cap fila retornada",
"By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher" => "Per omissió (quan no s'especifiqui ni signe més ni signe menys) la paraula és opcional, però l'objecte que la la contingui serà puntuat més a munt",
"These two operators are used to change a word's contribution to the relevance value that is assigned to a row" => "Aquests dos operadors s'empren per canviar la contribució de cada paraula al valor de rellevància que s'assigna a cada fila",
"Parentheses are used to group words into subexpressions" => "Els parèntesis s'empren per agrupar paraules en subexpressions",
"A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator" => "Una tilde per davant actua d'operador de negació, causant que la contribució de la paraula a la rellevància de l'objecte sigui negativa. És útil per indicar paraules que només generen soroll. Un operador que conté aquesta paraula serà marcat més baix que els altres, però no serà exclòs, com ho faria si s'emprès l'operador - ",
"An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended" => "Un asterisc és l'operador de truncat. A diferència dels altres operadors, hauria de ser afegit al final de la paraula, i no al principi",
"The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed" => "La frase, que sigui envoltada per cometes dobles &quot;, troba només objectes que continguin aquesta frase literalment, tal qual s'ha escrit",
"Date Search" => "Cerca per dates",
"System Admin" => "Admin Sistema (cau)",
"PHP version" => "Versió de PHP",
"0|1, Enable word wrapping on the code to avoid breaking the layout" => "0|1, Activa en trencament automàtic de línies en el codi per evitar trencat la disposició en pantalla",
"One entry per line. Each line is in \"Term: Definition\" format" => "Una entrada per línia. Cada línia és en el format \"Terme: Definició\"",
"Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large" => "Percentatge d'increment respecte la mida normal. 100 produeix la mida normal. 200 produeix una imatge el doble de gran",
"Wiki syntax containing the text to display" => "Sintaxi wiki que conté el text a mostrar",
"Heading row of the table, same format as the body section" => "Fila de la Capçalera de la taula, en el mateix format que la secció del cos",
"CSS class to apply to the heading row" => "Classe CSS a aplicar a la fila de la capçalera",
"Displays a file attachment or a list of them" => "Mostra un arxiu adjunt o una llista d'ells",
"List files in a file gallery (with a category) or in a category or a file gallery od this category" => "Llista els arxius en una galeria d'arxius (amb una categoria) o en una categoria o una galeria d'arxius d'aquesta categoria",
"Displays a list of files" => "Mostra una llista d'arxius",
"Download box for a file on ftp server" => "Requadre de descàrrega per a un arxiu a un servidor ftp",
"To test your system configuration, Tiki will attempt to send a test message to you" => "Per tal de provar la configuració del teu sistema, Tiki provarà d'enviar-te un missatge de correu-e de prova",
"Test email" => "Test email",
"Email address to send test to" => "Adreça de correu-e a on enviar el correu-e de prova",
"Use this page to create a new database connection, or use the <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Empra aquesta pàgina per crear una nova connexió a base de dades, o empra el <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">procés d'instal·lació manual</a>",
"Misc" => "Misc",
"Displays an miniquiz" => "Mostra un miniqüestionari",
"underscores" => "guions baixos",
"colons" => "dos punts",
"some text" => "algun text ",
"equals" => "igual",
"One carat" => "Un carat",
"Creates a box with the data" => "Crea una caixa amb les dades",
"creates a title bar" => "crea una barra de títol",
"make headings" => "fes estils de títol",
"make autonumbered headings" => "fa estils de títol autonumerats",
"creates a table" => "crea una taula",
"makes a horizontal rule" => "fa una línia horitzontal",
"page|desc" => "pàg|desc",
"displays an image" => "mostra una imatge",
"imalign, height, width, desc, link, rel, title, usemap, class and align are optional" => "imalign, height, width, desc, link, rel, title, usemap, class i align són opcionals",
"Non cacheable images" => "Imatges sense memòria cau",
"height width desc link and align are optional" => "height width desc link i align són opcionals",
"Wiki File Attachments" => "Arxius adjunts del Wiki",
"Creates a link to the named file.  If page is not given, the file must be attached to the current page.  If desc is not given, the file name is used for the link text, unless showdesc is used, which makes the file description be used for the link text.  If image=1 is given, the attachment is treated as an image and is displayed directly on the page; no link is generated." => "Crea un enllaç a l'anomenat arxiu.  Si no es dóna la pàgina, l'arxiu ha de ser adjuntat a la pàgina actual.  Si no es dóna desc, s'empra el nom de l'arxiu per al text de l'enllaç, a menys que s'empri showdesc, que fa que s'empri la descripció de l'arxiu per al text de l'enllaç. Si es dóna image=1, l'adjunt és tractat com una imatge i mostrada directament a la pàgina; no es genera cap enllaç.",
"displays rss feed with id=n maximum=m items" => "mostra l'alimentació per rss amb id=n, essent n nombre màxim dóelements",
"Will be replaced by the actual value of the dynamic content block with id=n" => "Serà substituït pel valor del bloc de contingut dinàamb id=n",
"\"~pp~ data ~/pp~\" Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  \"~pre~ data ~/pre~\" also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text." => "\"~pp~ dades ~/pp~\" Mostra text/codi preformatat; no es processa la sintaxi wiki dins d'aquestes seccions (com amb np), i l'espaiat és fixe (no es fa ajustat d'amplada de frases).  \"~pre~ dades ~/pre~\" també mostra text preformatat amb espaiat fixe, però es processa el format Wiki de dins del text.",
"\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" escriuen una taula de continguts per a la pàgina en qüestió basades en estructures (toc) o ! capçaleres-estils de títol de qualsevol ordre (maketoc)",
"Update '{\$page}' based on '{\$source_page}'" => "Actualitza '{\$page}' basant-te en '{\$source_page}'",
"Customer Extranet" => "Extranet de Client",
"Tiki \"mods\" are undergoing refubishment." => "Els \"mods\" de Tiki estan en procés de reformes.",
"You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "Probablement trobaràs que alguns mods mostrats com a compatibles amb versions antigues de Tiki fruncionaran amb versions posteriors de Tiki amb poques o cap modificació",
"If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "Si vols actualitzar des d'una versió prèvia de Tiki, assegura't d'haver llegit i entès les <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">instruccions d'Actualització</a>",
"Label displayed on the left side of the gauge" => "l'Etiqueta mostrada a l'esquerra de la barra de nivell",
"Bar width in pixels" => "Amplada de la barra en píxels",
"Width in pixels allocated to the label" => "Amplada en píxels destinada a l'etiqueta",
"true|false, if true then a percentage of the maximum is displayed" => "cert|fals, si és cert llavors es mostra un percentatge del màxim",
"true|false, if the numeric value is displayed" => "cert|fals, si el valor numèric és mostrat",
"Bar height in pixels" => "Alçada de la barra en píxels",
"Add the tracking code for Google Analytics" => "Afegir el codi de rastreig per a l'Analítica de Google",
"The account number for the site" => "El número de compte pel lloc",
"Leave this empty" => "Deixa-ho en blanc",
"Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large" => "Mida del marc, usa-ho en comptes d'amplada i alçada, faran servir exactament les mides de les presentacions de Google. Pot ser  petit|mig|gran",
"Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "Text Wiki a mostrar si es compleixen les condicions. El cos pot contenir {ELSE}. El text de després del marcador serà mostrat als usuaris que no compleixin la condició",
"0|1, parse wiki syntax within the html code" => "0|1, interpreta la sintaxi wiki dins del html codi",
"Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "ID Numèric d'una imatge en una Galeria d'Arxius (o llista separada per comes). \"fileId\", \"id\" o \"src\" requerits",
"Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "ID Numèric d'una imatge en una Galeria d'Imatges (o llista separada per comes). \"fileId\", \"id\" o \"src\" requerits",
"Full URL to the image to display. \"fileId\", \"id\" or \"src\" required" => "URL sencera a la imatge a mostrar. \"fileId\", \"id\" o \"src\" requerits",
"PostgeSQL 7.2+" => "PostgeSQL 7.2+",
"Oracle" => "Oracle",
"Sybase" => "Sybase",
"SQLLite" => "SQLLite",
"MSSQL" => "MSSQL",
"crypt-md5" => "crypt-md5",
"crypt-des" => "crypt-des",
"Admins" => "Admins",
"Mootools" => "Mootools",
"Unix" => "Unix",
"Ver" => "Ver",
"Subcategories" => "Subcategories",
"Language of newly translated page" => "Language of newly translated page",
"Int" => "Int",
"Manual" => "Manual",
"inter" => "inter",
"val" => "val",
"ver:" => "ver:",
"Proc" => "Proc",
"auto" => "auto",
"int" => "int",
"Inst Status" => "Inst Status",
"/" => "/",
"\$name" => "\$name",
"Focus:" => "Focus:",
"eek" => "eek",
"lol" => "lol",
"razz" => "razz",
"santa" => "santa",
"Dif" => "Dif",
"Text_Wiki libraries need to be installed. Please see http://dev.tiki.org/MediaWiki+to+TikiWiki+converter" => "Cal instal·lar les llibreries Text_Wiki. Si us plau, consulta http://dev.tiki.org/MediaWiki+to+TikiWiki+converter",
"This instance of activity is already complete" => "Aquesta instància d'activitat ja és completa",
"Fatal error: cannot execute automatic activity \$activityId" => "Error crític: no es pot executar l'activitat automàtica  \$activityId",
"Fatal error: setting next activity to an unexisting activity" => "Error crític: dirigint propera activitat a una activitat inexistent",
"Fatal error: nextActivity does not match any candidate in autorouting switch activity" => "Error crític: nextActivity no coincideix amb el canvi programat d'activitat",
"Fatal error: non-deterministic decision for autorouting activity" => "Error crític: Decisió no determinant per a autodirigir l'activitat",
"Fatal error: trying to send an instance to an activity but no transition found" => "Error crític: intentant enviar una instància a una activitat però sense transició trobada",
"Cannot add transition only split activities can have more than one outbound transition" => "No es pot afegir una transició, només les activitats partides poden tenir més d'una transició externa",
"Circular reference found some activity has a transition leading to itself" => "referència Circular trobada , alguna activitat té una transició cap a sí mateixa",
"Process does not have a start activity" => "El procés no te cap activitat inicial",
"Process does not have exactly one end activity" => "El procés no te exactament cap activitat final",
"End activity is not reachable from start activity" => "Finalitzar l'activitat no és possible des del començament de l'activitat",
"is interactive but has no role assigned" => "és interactiu però no té funció assignada",
"is non-interactive and non-autorouted but has no role assigned" => "no és interactiu ni tampoc autodirigit ni té funció assignada",
"is standalone but has transitions" => "està en solitari però té transicions",
"Role" => "Rol",
"is not mapped" => "no està mapejat",
"Activity '.\$res['name'].' is standalone and is using the \$instance object" => "L'activitat '.\$res['name'].' està per separat i està fent servir l'objecte \$instance",
"Activity '.\$res['name'].' is interactive so it must use the \$instance->complete() method" => "L'activitat '.\$res['name'].' és interactiva ja que fa servir el mètode \$instance->complete()",
"Activity '.\$res['name'].' is non-interactive so it must not use the \$instance->complete() method" => "L'activitat '.\$res['name'].' no és interactiva ja que no fa servir el mètode \$instance->complete()",
"Activity '.\$res['name'].' is switch so it must use \$instance->setNextActivity(\$actname) method" => "L'activitat '.\$res['name'].' està canviant i farà servir el mètode \$instance->setNextActivity(\$actname)",
"Process %d has been activated" => "El procés %d s'ha activat",
"Process %d has been deactivated" => "El procés %d s'ha desactivat",
"Process %s %s imported" => "Importat el proces %s %s",
"Process %s removed" => "El procés %s s'ha borrat",
"Process %s has been updated" => "El procés %s s'ha actualitzat",
"Process %s has been created" => "El procés %s s'ha creat",
"newest" => "el més nou",
"oldest" => "el més antic",
"on left side" => "a l'esquerra",
"on center" => "al centre",
"on right side" => "a la dreta",
"Any 2 versions" => "Qualsevol parell de 2 versions",
"latin" => "llatí",
"english" => "anglès",
"2 hours" => "2 hores",
"10 hours" => "10 hores",
"20 hours" => "20 hores",
"1 day" => "1 dia",
"1 week" => "1 setmana",
"1 month" => "1 mes",
"1 year" => "1 any",
"Just Tiki" => "Només Tiki",
"Tiki and PEAR::Auth" => "Tiki i PEAR::Auth",
"OpenID and Tiki" => "OpenID i Tiki",
"choose a group ..." => "escull un grup ...",
"Never use transition css" => "No empris mai css de transició",
"Use @version:x.x specified in theme css or none if not specified" => "Empra @versio:x.x especificada en el css del tema d'estil o cap si no se n'ha especificat",
"Use @version:x.x specified in theme css or 1.9 if not specified" => "Empra @versio:x.x especificada en el css del tema d'estil o 1.9 si no se n'ha especificat",
"Use @version:x.x specified in theme css or 2.0 if not specified" => "Empra @versio:x.x especificada en el css del tema d'estil o 2.0 si no se n'ha especificat",
"No forums" => "No hi ha fòrums",
"%s enabled" => "%s activat",
"\$feature is turned on" => "\$feature es troba activada",
"%s disabled" => "%s desactivat",
"\$feature is turned off" => "\$feature es troba desactivada",
"\$feature set to nothing" => "\$feature posada a res",
"Charts" => "Gràfics (en desús - no recomanat)",
"Forums last topics" => "Fòrums: darrers temes",
"You need either JQuery or MooTools enabled for this feature" => "Necessites o bé JQuery o MooTools habilitats per a aquesta funcionalitat",
"An error occured in a database query!" => "Ha hagut un error en una petició de la base de dades!",
"games" => "jocs",
"You are not allowed to upload this type of file." => "No tens permisos per penjar aquest tipus de fitxer.",
"You must select a file." => "Has de seleccionar un arxiu.",
"Altering database table failed" => "Ha fallat l'alteració de la taula de la base de dades",
"Insert a division block on wiki page" => "Inserta un bloc de divisió en una pàgina Wiki",
"Draw" => "Dibuixa",
"Displays drawings in the wiki page" => "Mostra dibuixos a la pàgina wiki",
"drawing not found" => "esboç no trobat",
"Name parameter missing" => "Manca el paràmetre nom (name)",
"heads and cells separated by ~|~" => "capçaleres i cel·les separades per     ~|~",
"list topics with links to the articles" => "llista de temes amb enllaços als articles",
"Please provide an Id" => "Si us plau, proveïu una Id",
"Autovalidate suggestions" => "Autovalida els suggeriments",
"Can abort a process instance" => "Pot interrompre una instància de procés",
"Can admin charts" => "Pot administrar sondejos (charts)",
"Can admin drawings" => "Pot administrar dibuixos",
"Can admin games" => "Pot administrar jocs",
"Can admin workflow processes" => "Pot administrar processos de flux de treball",
"Can edit drawings" => "Pot editar dibuixos",
"Can execute workflow activities" => "Pot executar activitats de flux de treball",
"Can rate wiki pages" => "Pot participar a la valoració de pàgines wiki",
"Can play games" => "Pot jugar",
"Can suggest items" => "Pot suggerir ítems",
"Can use the newsreader" => "Pot utilitzar el lector de missatges",
"Can view categories" => "Pot visualitzar categories",
"Can view categorized items" => "Pot visualitzar ítems classificats",
"Can view charts" => "Pot visualitzar sondejos (charts)",
"Can vote" => "Pot votar",
"Quicktags" => "Barres d'eines",
"any file" => "qualsevol arxiu",
"podcast (audio)" => "podcast (àudio)",
"podcast (video)" => "podcast (vídeo)",
"This Gallery is Public" => "Aquesta galeria és pública",
"The files can be locked at download:" => "Els fitxers es poden bloquejar i descarregar:",
"Listing configuration" => "Llistant configuració",
"Perhaps you were looking for:" => "Potser estaves cercant:",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together." => "Posa etiquetes separades per espais. Per etiquetes amb més d'una paraula, posa les paraules juntes sense emprar espais.",
"You are about to leave this page. If you have made any changes without Saving, your changes will be lost.  Are you sure you want to exit this page?" => "Estàs a punt de marxa d'aquestya pàgina. Si has fet canvis sense guardar-los, es perdran els teus canvis.  Segur que vols deixar aquesta pàgina?",
"Loading" => "Carregant",
"Tiki User Account Activated" => "Compte d'usuari Tiki activat",
"best regards" => "records",
"your Tikiwiki" => "el teu Tikiwiki",
"Tiki User Registration Request" => "Petició de Registre d'Usuari",
"Tiki email notification" => "Notificació de correu-e del Tiki",
"Someone coming from IP Address" => "Algú des de l'adreça IP d'internet",
"Your Tiki account information for %s" => "La informació del teu compte Tiki per %s",
"New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Nova entrada a la bitàcola: {\$mail_title}, \"{\$mail_post_title}\", per {\$mail_user} a {\$mail_date|tiki_short_datetime}",
"QuickTags" => "Barres d'eines",
"Last blog comments" => "Últim comentari de la bitàcola",
"Recently visited pages" => "Pàgines recentment visitades",
"Last `\$module_rows` Sites" => "darreres `\$module_rows` webs",
"Last Sites" => "Darrers Llocs",
"Directory Stats" => "Estadístiques del Directori",
"Sites to validate" => "Llocs per validar",
"Visited links" => "Enllaços visitats",
"Top \$module_rows Sites" => "\$module_rows llocs més visitats",
"Top Sites" => "Els llocs més visitats",
"Top `\$module_rows` topics" => "`\$module_rows` tòpics més freqüents",
"Last `\$module_rows` forum posts" => "Darrers `\$module_rows` enviaments del fòrum",
"Last `\$module_rows` forum topics" => "Darrers `\$module_rows` temes del fòrum",
"Folksonomy" => "Folcsonomia",
"More Like This" => "Més com aquesta",
"Last `\$module_rows` actions" => "Últimes `\$module_rows` accions",
"Last `\$module_rows` articles" => "Darrers `\$module_rows` articles",
"Last articles" => "Els últims articles",
"Last `\$module_rows` blog posts" => "Darrers`\$module_rows` enviaments a la bitàcola",
"Last `\$module_rows` Created blogs" => "Darreres `\$module_rows` bitàcoles creades",
"Last `\$module_rows` Created FAQs" => "Darreres `\$module_rows` PMF creades",
"Last `\$module_rows` Created Quizzes" => "Darrers `\$module_rows` qüestionaris creats",
"Last `\$module_rows` modified file galleries" => "darreres `\$module_rows`  galeries d'arxiu modificades",
"Last `\$module_rows` Files" => "Darrers `\$module_rows` Arxius",
"Last `\$module_rows` galleries" => "Darreres`\$module_rows` galeries",
"Last galleries" => "Darreres galeries",
"Last `\$module_rows` Images" => "Últimes `\$module_rows` imatges",
"Last `\$module_rows` modified events" => "Últims `\$module_rows` events modificats",
"Last `\$module_rows` changes" => "Darrers `\$module_rows` canvis",
"Last `\$module_rows` Modified Items" => "Darrers `\$module_rows` Ítems modificats",
"Last `\$module_rows` Modified blogs" => "Darreres `\$module_rows` bitàcoles modificades",
"Last `\$module_rows` submissions" => "darreres `\$module_rows` submissions",
"Last `\$module_rows` Modified Comments" => "Últims `\$module_rows` comentaris modificats",
"Last Modified Comments" => "Últims comentaris modificats",
"Last `\$module_rows` Items" => "Darrers `\$module_rows` Items",
"Menu" => "Menú",
"New Messages" => "Nous missatges",
"New Message" => "Nou missatge",
"Random Images" => "Imatges aleatòries",
"Top `\$module_rows` articles" => "`\$module_rows` articles més llegits",
"Top `\$module_rows` File Galleries" => "`\$module_rows` Galeries de fitxers més emprades",
"Top `\$module_rows` files" => "`\$module_rows` fitxers més emprats",
"Top `\$module_rows` Forum Posters" => "`\$module_rows` publicadors més actius dels fòrums",
"Top `\$module_rows` games" => "`\$module_rows` jocs més emprats",
"Top games" => "Jocs principals",
"Top `\$module_rows` galleries" => "`\$module_rows` galleries més actives",
"Top `\$module_rows` Images" => "`\$module_rows` images més visitades",
"Top `\$module_rows` Objects" => "`\$module_rows` Objectes més Actius",
"Top `\$module_rows` Pages" => "`\$module_rows` Planes més actives",
"Top `\$module_rows` Quizzes" => "`\$module_rows` qüestionaris més actius",
"Most `\$module_rows` visited blogs" => "Les `\$module_rows` bitàcoles més visitats",
"Top `\$module_rows` Visited FAQs" => "`\$module_rows` PUF's més visitades",
"Up-to-date-ness" => "Nivell d'actualització",
"Better translations" => "Traduccions millors",
"Equivalent translations" => "Traduccions equivalents",
"Translations that need improvement" => "Traduccions que necessiten millores",
"Upcoming `\$module_rows` events" => "Properes `\$module_rows` esdeveniments",
"The Next Event" => "El Següent Esdeveniment",
"No Upcoming Events" => "Cap esdeveniment per venir",
"Whats related" => "Qué hi ha relacionat",
"Last `\$module_rows` wiki comments" => "darrers `\$module_rows` wiki comentaris",
"on page" => "a la pàgina",
"show structures" => "mostrar estructures",
"hide structures" => "amaga estructures",
"My workflow" => "El meu flux de treball",
"Number of columns per page when listing categories" => "Nombre de columnes per pàgina en llistar les categories",
"enable cool sites" => "habilita llocs guais",
"Action log setting" => "Configuració del registre d'accions",
"Featured Help" => "Ajuda oferta",
"Copyright System" => "Sistema de Copyright",
"Copyright system" => "Sistema de Copyright",
"User interface enhancement features" => "Funcionalitats de millores de la interfície de l'usuari",
"JsCalendar" => "JsCalendari",
"JavaScript popup date selector" => "Selector de dates emergent de JavaScript",
"PhpLayers Dynamic menus" => "Menús dinàmics a capes Php",
"Allow users to activate fullscreen mode" => "Permet als usuaris activar el mode de pantalla completa",
"Experimental Features" => "Funcionalitats Experimentals",
"HTML Purifier (Content is cleaned to XHTML 1.1 Strict on each save)" => "Purificador d'HTML (El contingut és netejat a XHTML 1.1 Strict cada cop que es desa)",
"Drawings" => "Dibuixos",
"Friendship" => "Amistat",
"Games" => "Jocs",
"Administration Features" => "Prestacions de l'Administració",
"Banning System" => "Sistema de Prohibició",
"Action Calendar" => "Calendari d'Accions",
"Tiki action calendar" => "Calendari d'accions del Tiki",
"User Features" => "Funcionalitats de l'usuari/a",
"Newsreader" => "Lector de noticies",
"Workflow" => "Fluxdetreball",
"Workflow engine" => "Motor del Fluxdetreball",
"Tiki version" => "Versió de Tiki",
"Windows" => "Finestres",
"Unknown/Other" => "Desconegut/Altres",
"(standard)" => "(estàndard)",
"(some Unix MTA)" => "(alguns MTA Unix)",
"Tikiwiki.org help" => "Ajuda en Tikiwiki.org",
"Store session data in database" => "Guardar informació de sessió a la base de dades",
"Default timezone" => "Zona horària per defecte",
"New password" => "Nova contrasenya",
"Google Map setup" => "Paràmetres dels Mapes de Google",
"You need to request a Google Maps Key for this web site. You can easily generate a key for your domain at :" => "Necessites demanar una Clau de Mapes de Google per a aquest lloc. La pots generar fàcilment a :",
"Google Map Key" => "Clau del Mapa de Google",
"Show pages in user's preferred language" => "Mostra la pàgines en l'idioma preferit de l'usuari",
"Intertiki exchange feature" => "Funció d'intercanvi Intertiki",
"Text Area" => "Àrea de Text",
"PEAR::Auth" => "PEAR::Autor",
"General Layout" => "Disposició General",
"Reg users can change theme" => " Els usuaris registrats poden canviar el tema",
"Slideshows theme" => "Tema dels passis de diapositives",
"Use transition style sheet from version" => "Empra el full d'estil de transició de la versió",
"Template Viewing" => "Vista de Plantilles",
"Site logo source (image path)" => "Font del logo del lloc (ruta de la imatge)",
"Site logo background color" => "Color del rerafons del logo",
"Site logo alignment" => "Alineació del logo del lloc",
"Site logo title (on mouse over)" => "Títol del logo del lloc (en passa el ratolí per sobre)",
"Site Search Bar" => "Barra de Cerca del Lloc",
"Site Login Bar" => "Barra de Connexió al Lloc",
"Site Breadcrumbs" => "Rastres en el Lloc",
"at top of page" => "a la part superior de la pàgina",
"at top of center column" => "a la part superior de la columna central",
"Prefix breadcrumbs with 'Location : '" => "Prefix de les molles de pa amb 'Lloc : '",
"entire location" => "lloc sencer",
"page name" => "nom de pàgina",
"Left blank to use the default sender email" => "Deixa-ho en blanc per emprar el correu-e per defecte de l'enviador",
"Other options" => "Altres opcions",
"installed" => "instal·lat",
"Use this page to configure the RSS feeds generated by Tiki. To syndicate RSS feeds from other sites, use the <strong>Admin</strong> &gt; <strong>RSS Modules</strong> menu option, or" => "Empra aquesta pàgina per configurar les alimentacions RSS generades per Tiki. Per sindicar les alimentacions RSS d'altres llocs, empra l'opció del menú <strong>Admin</strong> &gt; <strong>Mòduls RSS</strong>, o",
"hits" => "cops",
"Individual cache" => "Caxé Individual",
"Regex search and replace" => "Cerca i reemplaça amb Regex",
"Toolbar content" => "Contingut de la barra d'eines",
"A new version of Tikiwiki, <b>{\$tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">http://tiki.org/Download</a>." => "La nova versió de Tikiwiki, <b>{\$tiki_release}</b>, ja està disponible. Estàs fent servir actualment la versió <b>{\$tiki_version}</b>. Si us plau, visita <a href=\"http://tiki.org/Download\">http://tiki.org/Download</a>.",
"Perms inherited from closest parent if possible or from global perms" => "Permisos heredats des de la categoria mare més propera si és possible o des dels permisos globals",
"Assign permissions automatically" => "Assigna permisos automàticament",
"recommended for best performance" => "recomanat per a un òptim rendiment",
"image gal" => "Galeria d'images",
"file gal" => "galeria d'arxius",
"Admin chart items" => "Administrar ítems de la llista",
"Edit Chart" => "Edita chart",
"Chart items" => "Gràfic d'items",
"No items defined yet" => "Encara no s'ha definit cap item",
"Add or edit a chart" => "Afegeix o edita una llista",
"Users can vote for only one item from this chart per period" => "Els usuaris poden votar només per un ítem d'aquest gràfic per període",
"Prevent users from voting for the same item more than once" => "Prevenir als usuaris de votar pel mateix item més d'una vegada",
"Users can suggest new items" => "Els usuaris poden suggerir nous ítems",
"Auto validate user suggestions" => "Auto validar suggeriment de l'usuari",
"Ranking shows" => "Ranking per mostres",
"All items" => "Tots els ítems",
"Top 10 items" => "Els 10 ítems més amunt",
"Top 20 items" => "Els 20 ítems més amunt",
"Top 40 items" => "Els 40 ítems més amunt",
"Top 50 items" => "Els 50 ítems més amunt",
"Top 100 items" => "Els 100 ítems més amunt",
"Top 250 items" => "Els 250 ítems més amunt",
"Voting system" => "Sistema de votació",
"Vote items" => "Vota ítems",
"Rank 1..5" => "Puntuació 1..5",
"Rank 1..10" => "Puntuació 1..10",
"Ranking frequency" => "Ranking per freqüència",
"Realtime" => "Temps real",
"Each 5 minutes" => "Cada 5 minuts",
"Show Average" => "Mostrar Promig",
"Show Votes" => "Mostrar Vots",
"Use Cookies for unregistered users" => "Empra Cookies per a usuaris no registrats",
"Users can vote again after" => "Els usuaris poden votar de nou després",
"Anytime" => "a qualsevol hora",
"Ranks" => "Puntuacions",
"No charts defined yet" => "Encara no s'ha definit cap chart",
"Admin drawings" => "Admin dibuixos",
"To create a drawing in a Wiki page, use {literal}{draw name=foo}{/literal}, where foo is the name of the drawing. After saving, click on the drawing link." => "Per crear un dibuix en una pàgina Wiki, empra {literal}{draw name=foo}{/literal}, on foo és el nom del dibuix. Després de guardar-ho, fes clic sobre l'enllaç del dibuix.",
"Available drawings" => "Dibuixos disponibles",
"no display" => "no mostrar",
"List Forums" => "Llista Fòrums",
"Available polls" => "Consultes disponibles",
"Random image from" => "Imatge a l'atzar de",
"Dynamic content blocks" => "Blocs de contingut dinàmic",
"phpLayersMenus" => "Menus de Capes php",
"Banner zones" => "Zones de banners",
"Group users" => "Usuaris del grup",
"Admin Quicktags" => "Administrar Barres d'eines",
"Create/Edit QuickTags" => "Crear/edita Barres d'eines",
"Insert (use 'text' for figuring the selection)" => "Insertar (usa 'text' per a figurar la selecció)",
"Path to the tag icon" => "Ruta a la icona d'etiqueta",
"Admin RSS Modules" => "Administrar mòduls RSS",
"This page is to configure settings of RSS feeds read/imported by Tiki. To generate/export RSS feeds, look for \"RSS feeds\" on the admin panel, or" => "Aquesta pàgina és per configurar els paràmetres de les alimentacions RSS llegides/importades per Tiki. Per generar/exportar alimenacions RSS, cerca \"Alimentacions RSS\"  en el menú principal de l'aplicació, o",
"To use RSS feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the RSS feed." => "Per emprar alimentacions RSS en un area de text (pàgina Wiki, etc), un <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">mòdul</a> o una plantilla, empra {literal}{rss id=x}{/literal}, on x és l'ID de l'alimentació RSS.",
"show feed title" => "mostrar titol del feed",
"show publish date" => "mostrar data de publicació",
"Note: You have to import security data via installation process (<a href=\"tiki-install.php\">tiki-install.php</a>). Import the *secdb* update files in your database." => "Nota: Has d'importar les dades de seguretat a través del sistema d'instal·lació (<a href=\"tiki-install.php\">tiki-install.php</a>). Importa els arxis d'actualització *secdb* a la teva base de dades.",
"Templates compiler" => "Compilador de plantilles",
"Compile" => "Compilar",
"Member of the default group of creator can modify items?" => "Els membres del grup per defecte del creador poden modificar els ítems?",
"Default category assigned to uncategorized objects edited by a user with this default group" => "Categoria per defecte assignada a objectes no categoritzats editats per un usuari amb aquest grup per defecte",
"Group Theme" => "Tema (d'estètica) per al Grup",
"Members List" => "Llista de membres",
"Updated users" => "Usuaris Actualitzats",
"Rejected users" => "usuaris rebutjats",
"Edit Account Settings" => "Edita els paràmetres del compte",
"Set the default group of the selected users to" => "Especifica que el grup per defecte dels usuaris seleccionats sigui",
"Old password" => "Contrasenya antiga",
"Parent category" => "Categoria inicial",
"Most visited sub-categories" => "Sub-Categories més visitades",
"Category description" => "descripció de la Categoria",
"Random sub-categories" => "Subcategories al atzar",
"Allow sites in this category" => "Permetre webs en aquesta categoria",
"Show number of sites in this category" => "Mostrar nombre de llocs dins aquesta categoria",
"Admin related categories" => "Administració de categories relacionades",
"Add a related category" => "Afegeix una categoria relacionada",
"Related categories" => "Categories relacionades",
"Add a Category" => "Afegeix una categoria",
"in current category" => "a la categoria actual",
"Total categories" => "Categories totals",
"Creates an indentation for each plus(useful in list to continue at the same level)" => "Crea un sagnat de text per a cada més (útil en llistes per continuar amb la numeració més avall)",
"creates the editable drawing foo" => "crea el dibuix editable foo",
"table" => "taula",
"table new" => "taula nova",
"external link" => "un enllaç extern",
"wiki link'" => "enllaç wiki'",
"heading1" => "titular1",
"title bar" => "barra de títol",
"box" => "caixa",
"rss feed" => "alimentació rss",
"dynamic content" => "contingut dinàmic",
"tagline" => "linea de marcador",
"center text" => "centra text",
"colored text" => "text en color",
"dynamic variable" => "variable dinàmica",
"New wms Metadata" => "Noves Metadades wms",
"New Class" => "Nova Clase",
"New Projection" => "Nova projecció",
"New Query" => "Nova consulta",
"New Scalebar" => "Nova Barra d'escala",
"New Layer" => "Nova capa",
"New Label" => "Nova etiqueta",
"New Reference" => "Nova referència",
"New Legend" => "Nova Llegenda",
"New Web" => "Nova Web",
"New Outputformat" => "Nou format de sortida",
"New Mapfile" => "Nou Arxiudemapa",
"quote" => "cita",
"special chars" => "caracters especials",
"special characters" => "caràcters especials",
"Questions per page" => "Preguntes per pàgina",
"Name of newly translated page" => "Nom de la pàgina novament traduïda",
"Add existing page as a translation of this page" => "Afegeix una pàgina existent com la traducció d'aquesta pàgina",
"Your edit session will expire in 1 minute. You must PREVIEW or SAVE your work now, to avoid losing your edits." => "La teva sessió d'edició caducarà en 1 minut. Has de PREVISUALITZAR o DESAR la teva feina ara, per evitar perdre les teves edicions.",
"This edit session will expire in {\$edittimeout} minutes" => "Aquesta sessió d'edició caducarà en {\$edittimeout} minuts",
"If you want the saved version instead of the autosaved one" => "Si preferixes la versió desada enlloc de l'autodesada",
"Activity completed" => "Activitat completada",
"Admin process activities" => "Administrar processament d'activitats",
"To learn more about the <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://workflow.tiki.org\">Galaxia workflow engine</a>" => "Per aprendre més sobre el <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://workflow.tiki.org\">Motor de Flux de treball</a>",
"Add or edit an activity" => "Afegeix o edita una activitat",
"activity" => "activitat",
"split" => "dividir",
"join" => "entra",
"standalone" => "autònom",
"interactive" => "interactiu",
"auto routed" => "auto dirigit",
"Expiration Time" => "Temps d'expiració",
"Years" => "Anys",
"Months" => "Mesos",
"Add transitions" => "Afegir transicions",
"Add transition from:" => "Afegir transició des de:",
"Add transition to:" => "Afegirx transició a:",
"No roles associated to this activity" => "No hi ha cap rol associat a aquesta activitat",
"Add Role" => "Afegeix Rol",
"Add New" => "Afegeix nou/va",
"Process activities" => "Activitats de procés",
"Routing" => "Enrutament",
"Interactive" => "Interactiu",
"Automatic" => "Automàtic",
"Auto routed" => "Auto dirigit",
"route" => "enrutar",
"(no roles)" => "(sense funcions)",
"No activities defined yet" => "Encara no s'ha definit cap activitat",
"Process Transitions" => "Processar Transicions",
"List of transitions" => "Llista de transicions",
"Origin" => "Origen",
"No transitions defined yet" => "Encara no s'ha definit cap transició",
"Add a transition" => "Afegeix una transició",
"Process Graph" => "Gràfic de procès",
"Galaxia Admin Graph" => "Administra Gràfic de Galaxia",
"Galaxia Admin Graph tpl" => "Plantilla (tpl) d'administració de Gràfic de Galaxia",
"This process is invalid" => "Aquest procés és invàlid",
"Process Graph for" => "Gràfic de procès per a",
"No process graph is available. Either the process still contains errors, the graph is not generated yet, or <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a> is not properly installed." => "El gràfic de procés no està disponible. O bé el procés encara conté errors, o el gràfic encara no s'ha generat, o bé no s'ha instal·lat correctament <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a>.",
"List of processes" => "Llista de processos",
"Inactive" => "Inactiu",
"Active Process" => "Procés actiu",
"Invalid Process" => "Procés no vàlid",
"Valid Process" => "Procés vàlid",
"Activities" => "Activitats",
"New Minor" => "Nou menor",
"New Major" => "Nou major",
"No processes defined yet" => "Encara no s'ha definit cap procés",
"Admin instance" => "Administrar instància",
"Process:" => "Procés:",
"Instance" => "Instància",
"Workitems" => "Itemsdefeina",
"exception" => "excepció",
"completed" => "completat",
"Send all to" => "Enviar-ho tot a",
"Don't move" => "No ho moguis",
"Act status" => "Estat de l'acte",
"Ended" => "Finalitzat",
"Not Defined" => "No definit",
"Not Interactive" => "Not interactiu",
"Not Ended" => "No finalitzat",
"Property" => "Propietat",
"Add property" => "Afegeix propietat",
"run instance" => "executar instància",
"Executed" => "Executat",
"erase" => "esborra",
"Admin processes" => "Administrar processos",
"Galaxia Admin Processes" => "Administració de la Galàxia",
"Galaxia Admin Processes tpl" => "Plantilla per a l'Administració de la Galàxia",
"Add or edit a process" => "Afegeix o edita un procés",
"Process Name" => "Nom del Procés",
"is active?" => "és actiu?",
"Or upload a process using this form" => "O publica un procés utilitzant aquest formulari",
"Admin process roles" => "Administrar processament de funcions",
"Add or edit a role" => "Afegeix o edita una funció",
"Process roles" => "Processar rols",
"No roles defined yet" => "Encara no hi ha cap rol definit",
"Map users to roles" => "Assigna rols als usuaris",
"map" => "mapa",
"Map groups to roles" => "Mapeja els grups cap als rols",
"Operation" => "Operació",
"No roles are defined yet so no roles can be mapped" => "Enacara no heu definit cap rol i per tant no es poden assignar als usuaris",
"List of mappings" => "Llista de mappings",
"No mappings defined yet" => "Encara no hi ha cap mapping definit",
"Admin process sources" => "Administrar processament de fonts",
"select source" => "trieu font",
"Shared code" => "Codi compartit",
"Set next user" => "Determineu el proper usuari",
"Get property" => "Obtingueu propietat",
"Set property" => "Determineu propietat",
"Process form" => "Formulari de procés",
"Set Next act" => "Configurar el següent acte",
"If:SetNextact" => "Si:SetNextact",
"Switch construct" => "Construcció de canvi",
"Map process roles" => "Mapa de rols de procés",
"Admin Processes" => "Administració de processos",
"Admin Activities" => "Administració d'activitats",
"Admin Roles" => "Administració de rols",
"Edit this Process" => "Edita aquest procés",
"Monitor Activities" => "Segueix activitats",
"Galaxia Monitor Activities" => "activitats del Monitor de la Galàxia Activities",
"Galaxia Monitor Activities tpl" => "Plantilla per a les activitats del Monitor de la Galàxia",
"List of activities" => "Llista d'activitats",
"routing" => "enrutament",
"Instances" => "Instàncies",
"run" => "executar",
"run activity" => "executar activitat",
"Enter the name of this instance" => "Introdueix el nom d'aquesta instància",
"The name is not valid. Please, enter the name again" => "El nom no és vàlid. Torna a introduir el nom",
"monitor processes" => "monitor processos",
"monitor activities" => "monitor activitats",
"monitor instances" => "monitoritza instàncies",
"monitor workitems" => "monitoritza ítems de treball",
"Monitor Instances" => "Segueix instàncies",
"Galaxia Monitor Instances" => "Instàncies de Monitor de Galaxia",
"Galaxia Monitor Instances tpl" => "Plantilla per a les Instàncies del Monitor de la Galàxia",
"List of instances" => "Llista d'instàncies",
"Not ended" => "No finalitzat",
"No instances created yet" => "Encara no s'han creat instàncies",
"Monitor Processes" => "Segueix processos",
"Galaxia Monitor Processes" => "Processos del Monitor de la Galàxia",
"Galaxia Monitor Processes tpl" => "Plantilla per als Processos del Monitor de la Galàxia",
"processes" => "processos",
"being run" => "estar funcionant",
"Exceptions" => "Excepcions",
"Monitor workitems" => "Monitoritza ítems de treball",
"List of workitems" => "Llista d'ítems de treball",
"instance" => "instància",
"Instance Id" => "Identificador de la instància",
"Instance Name" => "Nom de la instància",
"Instance Status" => "Estat de la instància",
"Elapsed time" => "Temps transcorregut",
"My activities" => "Les meves activitats",
"Current Activity" => "Activitat actual",
"Assigned To" => "Assignat a",
"exception instance" => "instància d'excepció",
"exceptions instance" => "instància d'excepcions",
"Send Instance" => "Enviar instància",
"abort instance" => "abortar instància",
"grab instance" => "agafar instància",
"release instance" => "lliberar instancia",
"No activities found" => "No s'han trobat activitats",
"My instances" => "Les meves instàncies",
"No instances found" => "No s'han trobat instàncies",
"User Activities" => "Activitats de l'Usuari/a",
"Galaxia User Activities" => "Activitats dels Usuaris/es de la Galàxia",
"Galaxia User Activities tpl" => "Plantilla per a les Activitats dels Usuaris/es de la Galàxia",
"process" => "procés",
"No processes defined or activated yet" => "Encara no hi ha processos definits o activats",
"user processes" => "processos d'usuari/a",
"user activities" => "activitats de l'usuari/a",
"user instances" => "instàncies d'usuari/a",
"User Instances" => "Instàncies d'usuari/a",
"Galaxia User Instances" => "Instàncies dels Usuaris/es de la Galàxia",
"Galaxia User Instances tpl" => "Plantilla per a les instàncies dels Usuaris/es de la Galàxia",
"Not defined" => "No definit",
"No instances defined yet" => "Encara no s'ha definit cap instància",
"User Processes" => "Processos d'usuari/a",
"Galaxia User Processes" => "Processos dels Usuaris/es de la Galàxia",
"Galaxia User Processes tpl" => "Plantilla per als Processos dels Usuaris/es de la Galàxia",
"Browsing Workitem" => "Explorant Ítem de Treball",
"Workitem information" => "Informació de l'Itemdefeina",
"Install &amp; Update Profile" => "Perfil d'Instal·lació &amp; Actualització",
"Bare-bones default install" => "Instal·lació per omissió Mínima (Bare-bones)",
"Personal Blog and Profile" => "Bitàcola i Perfil Personal",
"Small Organization Web Presence" => "Presència Web d'Organització Petita",
"Company Intranet" => "Intranet d'Empresa/Entitat",
"Collaborative community" => "Comunitat col·laborativa",
"Use cache for external pages" => "Fer servir la memòria cau per a les pàgines externes",
"All games are from" => "Tots els jocs són de",
"visit the site for more games and fun" => "visita el lloc per a més jocs i diversió",
"Upload a game" => "Puja un joc ",
"Upload a new game" => "Penjar un joc nou",
"Flash binary (.swf or .dcr)" => "Binaris de Flash (.swf o .dcr)",
"Thumbnail (if the game is foo.swf the thumbnail must be named foo.swf.gif or foo.swf.png or foo.swf.jpg)" => "Thumbnail (si el joc es diu foo.swf la imatge ha de ser foo.swf.gif ó foo.swf.jpg ó foo.swf.png)",
"Edit game" => "Edita joc",
"Played" => "Jugat",
"If you can't see the game then you need a flash plugin for your browser" => "Si no pots veure el joc, és que necessites un plugin flash per al teu navegador",
"Accepted requests" => "Sol·licituds acceptades",
"since" => "des de",
"This is an experimental feature" => "Aquesta és una funcionalitat experimental",
"Not Enabled" => "No habilitat/da",
"My Contacts" => "Els meus contactes",
"My Wiki Pages" => "Les meves pàgines Wiki",
"My Galleries" => "Les meves galeries",
"My Tracker Items" => "Els meus ítems de formularis",
"Assigned items" => "Ítems Assignats",
"My Messages" => "Els meus missatges",
"My Tasks" => "Les meves tasques",
"Select news group" => "Selecciona un grup de notícies",
"Back to servers" => "tornar a servidors",
"Msgs" => "Mstgs",
"News from" => "Notícies desde",
"Back to groups" => "tornar a grups",
"Save position" => "Guardar la posició",
"Reading article from" => "Llegint l'article de",
"Back to list of articles" => "tornar a llista d'articles",
"Newsgroup" => "Grup de discussió",
"Configure news servers" => "Configura els servidors de notícies",
"Configure Newsreader" => "Configura lector de notícies",
"configure newsreader server tpl" => "plantilla per a configurar el servidor del lector de notícies",
"Select a news server to browse" => "Seleccionar un servidor de noticies per examinar",
"server" => "servidor",
"Read the news" => "Llegeix les notícies",
"News server" => "Servidor de notícies",
"Watch" => "Subscriu-te",
"View Permissions" => "Mostra els permisos",
"To edit global permissions <a class=\"rbox-link\" href=\"tiki-admingroups.php\">click here</a>." => "Per editar els permisos globals <a class=\"rbox-link\" href=\"tiki-admingroups.php\">clica aquí</a>.",
"Current permissions for this object" => "Permisos actuals per aquest objecte",
"Current permissions for categories that this object belongs to" => "Permisos actuals per a les categories a les quals pertany aquest objecte",
"These permissions do not apply. Special permissions apply." => "No s'apliquen aquests permisos. S'apliquen permisos especials.",
"No category permissions; global permissions apply" => "No hi ha permisos de categoria; s'aplicaran els permisos globals",
"No category permissions; special permissions apply" => "No hi ha permisos a nivell de categoria; S'apliquen permisos especials",
"and also to all pages of the sub-structure:" => "i també a totes les pàgines de la sub-estructura:",
"Perms Help" => "Ajuda dels permios",
"Preview of version" => "Previsualitzacióde la versió",
"Source of version" => "Codi font de la versió",
"Updated from" => "Actualitza des de",
"Used to update" => "Emprat per actualitzar",
"Last seen in wiki page <a href=\"%0\">%1</a>" => "La darrera vegada s'ha 'vist en la pàgina wiki <a href=\"%0\">%1</a>",
"Seen in unknown object" => "Vist en objecte desconegut",
"Clear checked items" => "Neteja els ítems marcats",
"To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "Per requerir un codi de pas, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\tcontacta a les persones administradores del sistema{if \$prefs.feature_contact eq 'y'}</a>{/if}",
"NOTE: Make sure to whitelist this domain to prevent registration emails being canned by your spam filter!" => "NOTA: Assegura't de posar aquest domini a la llista blanca per prevenir que els correus-e de registre siguin filtrats i eliminats automàticament pel teu filter de correu brossa (spam)!",
"Replicate" => "Replica",
"Slave" => "Esclau",
"Master" => "Mestre",
"Operations" => "Operacions",
"Operations Log" => "Registre d'operacions",
"Data HTML" => "Dades HTML",
"Data Txt" => "Dades Txt",
"Tiki Shoutbox" => "Quadre d'avisos del Tiki",
"Click to Navigate" => "Fes clic per navegar",
"big grin" => "gran grin",
"cry" => "plorar",
"evil" => "dimoni",
"mr green" => "sr green",
"redface" => "avergonyit",
"rolleyes" => "rodaulls",
"smile" => "somriure",
"surprised" => "sorprès",
"twisted" => "girat",
"arrow" => "fletxa",
"Note: Maximum image size is limited to" => "Nota: tamany màxim de l'imatge limitat a",
"Current folder" => "Carpeta actual",
"This user is your friend" => "Aquest usuari és el teu amic",
"Your personal Wiki Page" => "La teva pàgina personal al Wiki",
"Your personal tracker information" => "Informació del teu formulari personal",
"Your preferred language" => "El teu idioma preferit",
"Other languages you can read (select on the left to add to the list on the right)" => "Altres idiomes que pots llegir (selecciona a l'esquerra per afegir a la llista de la dreta - l'ordre importa)",
"Confirm new password" => "Confirma contrasenya nova",
"Current password (required)" => "Contrasenya actual (requerida)",
"Edit Items" => "Edita items",
"List Charts" => "Llista de gràfiques",
"Last Chart" => "Darrera llista",
"Previous Chart" => "Chart anterior",
"Chart created" => "Gràfic creada",
"Next Chart" => "Diagrama següent",
"Permanency" => "Permanència",
"chg" => "canvi",
"Avg" => "Mtj",
"info/vote" => "info/vot",
"Next chart will be generated on" => "El proper chart es generarà a",
"View or vote items not listed in the chart" => "Visualitza o vota ítems no listats en el gràfic",
"Select something to vote on" => "Selecionar quelcom per votar",
"Item information" => "informació de l'Ítem",
"Best Position" => "Millor Posició",
"Vote this item" => "Vota aquest ítem",
"Highest" => "El més alt",
"Number of voices" => "Nombre de veus",
"RSS settings" => "Paràmetres de les Alimentacions per RSS",
"Current version is up to date : <b>%s</b>" => "La versió actual és la més actualitzada : <b>%s</b>",
"No chart indicated" => "No s'ha indicat cap chart",
"No category indicated" => "Cap categoria indicada",
"Permission denied; you cannot assign permissions for this category" => "Permís denegat; no teniu assignats permisos per aquesta categoria",
"Last sites of directory \".\$rc[\"name\"].\" ." => "Darreres webs del directori \".\$rc[\"name\"].\" .",
"Translation in progress." => "Traducció en curs.",
"No process indicated" => "No s'ha indicat cap procés",
"Role name cannot be empty" => "El nom del rol no pot quedar buit",
"Activity name cannot be empty" => "El nom de l'activitat no pot quedar buit",
"Activity name already exists" => "El nom de l'activitat ja existeix",
"indicates if the process is active. Invalid processes cant be active" => "Indica si el procès és actiu. Els processos invàlids no poden ser activats",
"No instance indicated" => "No s'ha indicat cap instància",
"No activity indicated" => "No s'ha indicat cap activitat",
"The process name already exists" => "El nom del procés ja existeix",
"Process already exists" => "El procés ja existeix",
"Invalid source path" => "Ruta d'origen invàlida",
"A start activity requires a name for the instance" => "L'inici de l'activitat requereix un nom per a la instància",
"You cant execute this activity" => "No pots realitzar aquesta activitat",
"You couldn't abort a instance" => "No podeu abortar una instància",
"You couldn't exception a instance" => "No pots exceptuar una instància",
"No title indicated" => "No s'ha indicat cap títol",
"No comment indicated" => "No s'ha indicat cap comentari",
"No date indicated" => "No s'ha indicat cap data",
"The game file must have .swf or .dcr extension" => "El fitxer del joc ha de tenir l'extenció .swf o .dcr",
"The thumbnail name must be" => "El nom de la miniatura ha de ser...",
"Please supply both files" => "Aporta els dos arxius, si us plau",
"No server indicated" => "No s'ha indicat cap servidor",
"Cannot connect to" => "No es pot connectar a",
"Missing information to read news (server,port,username,password,group) required" => "Falta informació per a llegir les notícies (servidor, port, usuari, contrasenya, grup) requerits/des",
"Cannot get messages" => "No es poden obtenir missatges",
"mail adress" => "adreça de correu electrònic",
"A password and your IP address reminder email has been sent " => "S'ha enviat un recordatori de contrasenya i la teva adreça IP d'internet en un correu-e",
"changed '%s' from '%s' to '%s'" => "canviat '%s' de '%s' a '%s'",
" (experimental - possible successor to img in 4.0)" => " (experimental - successor possible a img en 4.0)",
"Tiki Calendar" => "Calendari del Tiki",
"Admin Menu" => "Admin menú",
"RSS Modules" => "mòduls RSS",
"Import PHPWiki Dump" => "Importar PHPWiki Dump",
"Current events" => "Esdeveniments actuals",
"Last `\$module_rows` visitors" => "Últims `\$module_rows` visitants",
"No avatar." => "Cap avatar.",
"Tiki Logo" => "Logo del Tiki",
"RSS Feeds" => "Alimentacions RSS",
"User informations" => "Informacions d'ususari",
"Group informations" => "Informacions de grup",
"You need to activate user and/or group trackers" => "Necessites activar el formulari d'usuari i/o de grup",
"Email This Post" => "envia per correu electrònic aquest enviament",
"RSS feeds" => "Alimentació per RSS",
"Use titles in blog posts" => "Empra títols en publicacions de bitàcoles",
"Send blog post" => "Envia la publicació a la bitàcola",
"A link to this post was sent to the following addresses:" => "Heu enviat un enllaç a aquest enviament a les adreces següents:",
"Send post to this addresses" => "Envia un eviament a aquestes adreces",
"List of email addresses separated by commas" => "Llista d'adreces electròniques separades per comes",
"Compose Message" => "Escriu un Missatge",
"If you want people to be able to reply to you, you have to check <a href='tiki-user_preferences.php'>Allow messages from other users</a>" => "Si voleu que la gent pugui contestar-vos heu de comprovar <a href='tiki-user_preferences.php'>Permetre missatges d'altres usuaris</a>",
"Separate multiple usernames with a comma (&nbsp;,&nbsp;)." => "Separa múltiples noms d'usuaris amb una coma (&nbsp;,&nbsp;).",
"%s <b>%s</b> successfully deleted." => "%s <b>%s</b> s'ha eliminat amb èxit.",
"%s <b>%s</b> assigned to %s <b>%s</b>." => "%s <b>%s</b> assignat a %s <b>%s</b>.",
"%s <b>%s</b> removed from %s <b>%s</b>." => "%s <b>%s</b> eliminat de %s <b>%s</b>.",
"group <b>%s</b> set as the default group of user <b>%s</b>." => "grup <b>%s</b> establert com a grup per defecte de l'usuari <b>%s</b>.",
"Post recommendation at" => "Enviar recomanació a",
"Prevent flooding" => "Prevenir edicions simultànies",
"Minimum time between posts" => "Temps mínim entre publicacions",
"Moderator user" => "Usuari moderador",
"Moderator group" => "Grup moderador",
"Send this forums posts to this email" => "Enviar post d'aquest fòrum a aquest correu-e",
"Prune unreplied messages after" => "Eliminar missatges sense resposta després de ",
"Prune old messages after" => "Eliminar missatges antics després de",
"POP3 server" => "servidor POP3",
"Max attachment size (bytes)" => "Tamany Màxim d'adjunts (en octets)",
"Default ordering for topics" => "Ordre per defecte per a temes",
"Topics per page" => "Temes per pàgina",
"Default ordering for threads" => "Ordre per defecte per a missatges",
"Local" => "Local",
"articles" => "articles",
"avatar" => "avatar",
"Important" => "Important",
"Permission denied. You cannot view pages" => "No tens autorització per veure pàgines",
"The copyright management feature is not enabled." => "La opció de gestió de copyright no està activada.",
"MySQL Improved (mysqli). Requires MySQL 4.1+" => "Controlador de MySQL Millorat (mysqli). Requereix MySQL 4.1+",
"Chinese" => "Xinès",
"Serbian" => "Serbi",
"Users can opt-out internal messages" => "Els usuaris poden escollir no rebre missatges interns",
"Multimedia" => "Multimèdia",
"Shadowbox" => "Shadowbox (permet efectes gràfics moderns en imatges)",
"Wiki top articles" => "Articles Wiki més actius",
"Wrong registration code" => "Codi de registrament erroni",
"Username cannot contain whitespace" => "El nou nom d'usuari ha de ser introduït sense espais en blanc",
"Invalid email address. You must enter a valid email address" => "Adreça d'email Invàlida. Introdueix-ne una altra",
"More info about \$other_user" => "Més informació sobre l'usuari \$other_",
"(idle for \$idletime seconds)" => "(inactiu durant \$idletime segons)",
"__WARNING__: No such module \$plugin!" => "__ATENCIÓ__: No existeix el mòdul \$plugin!",
"Upload was not successful. Duplicate file content ?" => "La càrrega no s'ha realitzat correctament. Vols duplicar el contingut de l'arxiu?",
"Field is not a link to mp3 in the gallery" => "El camp no és un enllaç a mp3 de la galeria",
"Field is not a link to FLV in the gallery" => "El camp no és un enllaç a FLV de la galeria",
"Field is not a link to FLV or MP3 in the gallery" => "El camp no és un enllaç a FLV o mp3 de la galeria",
"multimedia" => "multimèdia",
"You do not have permission to use this DSN" => "No tens permís per emprar aquest DSN",
"Calendar ID" => "ID del Calendari",
"Image Source" => "Font d'Imatge",
"complete" => "complet/a",
"Picture" => "Foto",
"You need to specify a RSS Id" => "Has d'especificar un identificador RSS",
"RSS Id incorrect:" => "Identificador RSS incorrecte:",
"~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Inserta la sortida d'alimentacions rss a una pàgina wiki",
"Missing url parameter for SNARF plugin." => "Falta el paràmetre url pel connector SNARF.",
"row1col1" => "fila1col1",
"row1col2" => "fila1col2",
"row2col1" => "fila2col1",
"row2col2" => "fila2col2",
"Displays the thumbnail for an image" => "Mostra el contacte d'una imatge",
"Message will be sent to: " => "El missatge s'enviarà a: ",
"Page translation" => "Traducció de la pàgina",
"theme" => "tema",
"Please login" => "Connecta't, si us plau",
"Tags This Page Has" => "Etiquetes que té aquesta pàgina",
"Logged in as" => "Connectat com a",
"Login as admin" => "Connecteu-vos com a administrador",
"Login as" => "Connecta't com a",
"Stay in SSL mode" => "Roman en mode segur (ssl)",
"OpenID Login" => "Connexió OpenID",
"Search Wiki PageName" => "Cerca NomdePàgina Wiki",
"Changes that need to be reproduced are highlighted below." => "Es destaquen més avall els canvis que han de ser reproduïts",
"Change password" => "Canvia la contrasenya",
"Tiki and HTTP Auth" => "Auth Tiki i HTTP",
"Duration:" => "Duració",
"Host:" => "Allotjament:",
"You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/." => "També et cal pujar el <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/.",
"Available styles:" => "Estils disponibles:",
"logged as" => "connectat com",
"always" => "sempre",
"user decides" => "l'usuari decideix",
"Users can Flip Columns" => "Els usuaris poden amagar temporalment les columnes",
"Use page description:" => "Empra descripció de pàgines:",
"Max. number of links around the current item:" => "Màx. nombre d'enllaços sobre l'ítem actual:",
"Max. number of links after the first or before the last item:" => "Màx. nombre d'enllaços després del primer ítem o abans del darrer:",
"Favicon icon file name:" => "Nom d'icona Favicon:",
"Favicon icon MIME type:" => "Tipus MIME d'icona Favicon:",
"Feature is disabled." => "La funcionalitat està deshabilitada.",
"Feed for forums" => "Alimentació per fòrums",
"Caching time:" => "Temps en memòria cau (caché):",
"Not Installed" => "No instal·lat",
"like pages" => "pàgines similars",
"Use Ctrl+Click to select multiple pages." => "Empra Ctrl+Click per seleccionar múltiples pàgines.",
"Fix UTF-8 Errors in Tables" => "Repara errors UTF-8 a les Taules",
"Warning: Make a backup of your Database before using this function!" => "Alerta: Feu una copia de seguretat de la vostra base de dades abans d'utilitzar aquesta funció!",
"Warning: If you try to convert large tables, raise the maximum execution time in your php.ini!" => "Avís: si vols convertir taules grans, augmenta al màxim el temps d'execució al teu php.ini!",
"This function converts ISO-8859-1 encoded strings in your tables to UTF-8" => "Aquesta funció converteix a UTF-8 les cadenes codificades en ISO-8859-1 a les teves taules",
"This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1" => "Això pot ser necessari si vas crear contingut amb Tiki &lt; 1.8.4 i els paràmetres del conjunt de caracters per defecte en apache estaven posats a ISO-8859-1",
"UTF-8 Errors fixed" => "Errors UTF-8 reparats",
"Investigate" => "Investiga",
"Fix it" => "Repara-la",
"Includes" => "Inclou",
"Only directly included" => "Només inclosos directament",
"Tip: Hold down CTRL to select multiple" => "Pista: menté apretada la tecla CTRL per a seleccions múltiples",
"List of types" => "Llista de tipus",
"Assign Perms to this Group" => "Assigna permisos a aquest grup",
"Save and Exit" => "Guardar i sortir",
"Watch Only This Category" => "Vigila Només Aquesta Categoria",
"Watch This Category and Their Descendants" => "Vigila Aquesta Categoria i les Seves Descendents",
"Stop Watching Only This Category" => "Deixa de Vigilar Només Aquesta Categoria",
"Stop Watching This Category and Their Descendants" => "Deixa de Vigilar Aquesta Categoria i les Seves Descendents",
"Assign permissions to category" => "Assigna permisos a la categoria",
"Current permissions for this category" => "Permisos actuals per a aquesta categoria",
"Remove from this Category Only" => "Elimina només aquesta categoria",
"Remove from this Category &amp; all its Children" => "Elimina d'aquesta categoria &amp; i totes les seves filles",
"Assign permissions" => "Assignar permisos",
"to group" => "per al grup",
"this category &amp; all its children" => "aquesta categoria &amp; totes les seves filles",
"this category only" => "aquesta categoria només",
"Assigning permissions for <b>all children</b> is recommended for best performance." => "Es recomana, per a un òptim funcionament, assignar permisos per a <b>totes les filles</b>.",
"You can browse the generated WebHelp here" => "Pots navegar aquí l'AjutWeb generat",
"Allow other user to post in this blog" => "Permetre a altres usuaris de publicar en aquest diari interactiu",
"Manage existing translations of this page" => "Gestiona les traduccions existents d'aquesta pàgina",
"Monitor this page" => "Segueix aquesta pàgina",
"Upload picture" => "Puja foto",
"Regex search " => "Cerca per l'expressió regular ",
"Replace with" => "Substitueix a",
"Import page" => "Pàgina d'importació",
"License" => "Llicència",
"My Footnotes" => "Les meves notes al peu de pàgina",
"Use rating" => "Empra valoració",
"or use" => "o empra",
"an existing poll" => "una consulta existent",
"Translation request" => "Petició de traducció",
"Secure Login" => "Connexió segura",
"Install Profile" => "Instal·la el Perfil",
"Added:" => "Afegit:",
"Removed:" => "Suprimit:",
"Your registration code:" => "El vostre codi de registre:",
"Registration code" => "Codi de registre",
"Add Pages" => "Afegeix pàgines",
"Passcode to register" => "Codi de pas per registrar-se",
"Repeat password" => "Repetiu la contrasenya",
"Select your group" => "Selecciona el teu grup",
"Remove page" => "Eliminar pàgina",
"Approve changes." => "Aprova els canvis.",
"Change administrative info" => "Canvia la informació administrativa",
"Editing" => "Editant",
"Editing posts" => "Editant publicacions",
"Merge into topic" => "Encabir dins el tema",
"Permission denied you cannot view the Tiki calendar" => "Permís denegat, no pots veure el calendari del Tiki",
"Your admin password has been changed" => "La teva contrasenya d'admin ha estat canviada",
"You cannot have a blank password" => "No pots deixar la contrasenya en blanc",
"No Errors detected" => "No s'ha detectat cap error",
"Permission denied you cannot view backlinks for this page" => "No estàs autoritzat a veure els retroenllaços d'aquesta pàgina",
"Permission denied you cannot use the batch directory loading" => "Permís denegat, no pots utilitzar la càrrega de directoris",
"Permission denied you can not view this section" => "Permís denegat, no podeu veure aquesta secció",
"ERROR: you must include a subject or a message at least" => "ERROR: has de incloure un títol o un missatge almenys",
"This feature has been disabled" => "Aquesta secció ha estat deshabilitada",
"You do not have permissions to edit banners" => "No teniu permís per editar banners",
"Permission denied you cannot create or edit blogs" => "Permís denegat per crear o editar bitàcoles",
"Permission denied you cannot edit images" => "No tens autorització per editar imatges",
"Permission denied you cannot send submissions" => "Permís denegat per enviar col·laboracions",
"You must be logged in to use this feature" => "Has d'estar connectat per emprar aquesta funcionalitat",
"Permission denied. You cannot view pages like this page" => "No tens autorització per veure pàgines com aquesta",
"You cannot admin blogs" => "No té permís per administrar bitàcoles",
"Permission denied you cannot remove submissions" => "Permís denegat per eliminar col·laboracions",
"Permission denied you cannot approve submissions" => "Permís denegat per aprovar col·laboracions",
"You do not have permissions to view the layers" => "No tens permís per veure les capes",
"You do not have permissions to delete a file" => "No tens permís per esborrar un fitxer",
"You do not have permissions to create a directory" => "No tens permís per crear un directori",
"You do not have permissions to delete a directory" => "No tens permís per esborrar un directori",
"You do not have permissions to create an index file" => "No tens permís per crear un fitxer d'índex",
"Must be logged to use this feature" => "Has d'haver entrat per a fer servir aquesta prestació",
"Permission denied you cannot browse this page history" => "No tens autorització per accedir a l'historial d'aquesta pàgina",
"You don't have permission to edit quizzes." => "No teniu permís per editar qüestionaris.",
"Permission denied you cannot remove versions from this page" => "No tens autorització per eliminar versions d'aquesta pàgina",
"Permission denied you cannot rename this page" => "Permís denegat, no podeu canviar el nom d'aquesta pàgina",
"Permission denied you cannot rollback this page" => "No tens autorització per restablir una versió anterior d'aquesta pàgina",
"You are not logged in and no user indicated" => "No has entrat al sistema i no has indicat cap usuari",
"Permission denied you cannot remove the post" => "No té permís per eliminar aquesta publicació",
"Character Count" => "Nombre de caràcters",
"Search Box" => "Cerca",
"The following list of changes has been applied" => "S'ha aplicat la següent llista de canvis",
"Creation date (desc)" => "Data de creació (desc)",
"Create new file gallery" => "Crea una nova galeria d'arxius",
"duplicate" => "duplicat",
"Edit blog" => "Edita bitàcola",
"Default y from map center" => "Coordenada y per defecte per al centre del mapa",
"disabled" => "desabilitat",
"enabled" => "habilitat",
"Contact us" => "Contacta'ns",
"Create new forum" => "Crear un nou fòrum",
"CSS file" => "arxiu CSS",
"Create blog" => "Crea bitàcola",
"Create new structure" => "Crear nova estructura",
"name (desc)" => "nom (desc)",
"name (asc)" => "nom (asc)",
"hits (desc)" => "visites (desc)",
"hits (asc)" => "visites (asc)",
"creation date (desc)" => "data de creació (desc)",
"creation date (asc)" => "data de creació (asc)",
"last updated (desc)" => "última modificació (desc)",
"last updated (asc)" => "última modificació (asc)",
"Max impressions" => "Impressions màximes",
"Show the banner only between these dates" => "Mostrar el banner només en aquestes dates",
"From date" => "Des de la data",
"To date" => "Fins la data",
"Show the banner only in this hours" => "Mostrar el banner només a aquestes hores",
"Show the banner only on" => "Mostrar el banner sempre on",
"Mon" => "Dl",
"Tue" => "Dm",
"Wed" => "Dc",
"Thu" => "Dj",
"Fri" => "Dv",
"Sat" => "Ds",
"Sun" => "Dg",
"Movie Size" => "Mida del vídeo",
"FlashPlugin min version" => "Versió min del connector FlashPlugin",
"Dynamic content system" => "Sistema de contingut dinàmic",
"all versions" => "totes les versions",
"Add Structure Pages" => "Afegeix pàgines de l'estructura",
"Create new Sheet" => "Crea un nou full",
"Create page" => "Crea pàgina",
"Edit task" => "Edita tasca",
"wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker" => "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker",
"Permission to all (not just any) of an object's categories is required for access" => "Per poder accedir a un objecte, cal tenir permís per a totes les categories a les que està associat (i no pas a qualsevol d'elles)",
"List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img" => "Llista els tipus d'objectes a incloure en la llista, separats per signes més. exemple: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img",
"BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic" => "Grafic de barres apilades|Gràfic de múltiples barres|Gràfic de múltiples línies|Gràfic de formatgets",
"No arguments indicated" => "Cap argument indicat",
"preview" => "vista prèvia",
"Your help is needed! Please visit <a href=\"http://dev.tiki.org/tiki-index.php?page=Mods\">dev.tiki.org</a> to find out more." => "Es necessita la teva ajuda! Si us plau, visita <a href=\"http://dev.tiki.org/tiki-index.php?page=Mods\">dev.tiki.org</a> per saber-ne mes.",
"These permissions override any global permissions or category permissions affecting this object." => "Aquests permisos manen per sobre de qualssevol permisos globals o permisos de categories que afectin a aquest objecte.",
"Create a new Tikiwiki account from OpenID" => "Crea un nou compte Tikiwiki a partir del meu OpenID",
"Passcode to register (not your user password)" => "Codi per registrar-te (no la teva contrasenya)",
"Started" => "Iniciat",
"Days online" => "Díes en línia",
"Best day" => "Millor dia",
"Worst day" => "Pitjor dia",
"Activity=" => "Activitat",
"TikiWiki Profiles" => "Perfils de TikiWiki",
"TikiWiki Project Web Site" => "Web del Projecte TikiWiki",
"List Movies" => "Llista de Pel·lícules",
"Choose a movie" => "Escull una películ·la",
"Please select some actions to view." => "Si us plau, selecciona algunes accions per ser visualitzades.",
"viewed" => "vist",
"The TikiWiki Community" => "La comunitat TikiWiki",
"You must PREVIEW or SAVE your work now, to avoid losing your edits" => "Has de PREVISUALITZAR o DESAR ara el teu treball, per tal d'evitar perdre els teus canvis",
"You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page" => "Ets a punt de marxar d`aquesta pàgina. Es perdran els canvis des de la teva darrera visita. Segur que vols marxar d`aquesta pàgina",
"Maximum size" => "Mida màxima",
"Please note that the preview does not keep the attached file which you will have to choose before posting" => "Si us plau, tingues present que en previsualitzar no es manté l'arxiu adjunt i l'hauràs de seleccionar abans de publicar definitivament",
"Your comment will have to be approved by the moderator before it is displayed" => "El teu comentari haurà de ser aprovat per un moderador abans de que sigui mostrat",
"System error" => "Error del sistema",
"has posted a reply to a thread you're watching. \nYou can view the thread and reply at the following URL" => "ha publicat una reposta a un fil de debat al que estàs subscrit. \nPots veure el fil i la resposta a la següent adreça d'internet (URL)",
"Reply notification" => "Notificació de resposta",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Si us plau, clica en el següent enllaç per confirmar que vols canviar la teva contrasenya i anar a la pantalla on hauràs d'introduir una contrasenya nova. Si us plau, escull una contrasenya que només sàpigues tu, i no la comparteixis amb altres persones",
"URI" => "URI",
"You have mistyped the anti-bot verification code; please try again." => "T'has confòs en teclejar el codi de verificació anti-robots; prova-ho de nou, si us plau.",
"Tiki Link - Insert internal link" => "Enllaç tiki - insereix un enllaç intern",
"Select a Wiki page to link to:" => "Selecciona una pàgina wiki per enllaçar:",
"find" => " troba",
"prev" => "ant",
"next" => "prop",
"Default RDF version" => "versió RDF per defecte",
"Webmaster" => "Mestre Web",
"... and is displayed by default" => "... i es mostra per defecte",
"Content is partially parsed" => "El contingut es processat parcialment",
"Toolbar skin" => "Estètica de la barra d'eines",
"Feed provided by %s. Click to visit." => "Canal d'informació proporcionat per %s. Fes clic per visitar-lo.",
"Your edit session will expire in" => "La teva sessió d'edició caducarà en",
"phplayers are not available on this site" => "phplayers no estan disponibles en aquesta web",
"sec" => "s",
"Add Row" => "Afegeix Fil·la",
"Add Multi-Rows" => "Afegeix Múltiples Fil·les",
"Delete Row" => "Esborra Fil·la",
"Add Column" => "Afegeix Columna",
"Delete Column" => "Esborra Columna",
"Add Multi-Columns" => "Afegeix Múltiples Columnes",
"User-Agent Info" => "Informació sobre el User-Agent",
"Creates an annotation block for an image." => "Crea un bloc d'anotacions per a una imatge.",
"No pages links to" => "Cap pàgina apunta a",
"Shows ID" => "Mostra ID",
"Shows Icon" => "Mostra Icona",
"Shows Name" => "Mostra Nom",
"Shows Filename" => "Mostra Nom de l'arxiu",
"Shows Size" => "Mostra Mida",
"Shows Description" => "Mostra Descripció",
"Shows Creation Date" => "Mostra la Data de Creació",
"Shows Hits" => "Mostra Cops",
"Shows Locked by" => "Mostra Per qui està bloquejat",
"Shows Modification Date" => "Mostra la Data de Modificació",
"Shows Author" => "Mostra Autor",
"Shows Creator" => "Mostra Creador",
"Shows Parent Gallery Name" => "Mostra el nom de la Galeria Mare",
"Shows Number of Files" => "Mostra el número d'Arxius",
"Shows the slideshow of a gallery" => "Mostra el passi de diapositives de la galeria",
"Include literal HTML" => "Inclou un literal HTML",
"Anti-Bot verification code" => "Codi de verificació anti-robots",
"Random Image" => "Imatge aleatòria",
"Comment on the selected post" => "Comenta la publicació seleccionada",
"Enter your name" => "Introdueix el teu nom",
"Hi {\$mail_user} has sent you this link:" => "Hola.En/Na {\$mail_user} t'ha enviat aquest enllaç:",
"A new article was submitted by {\$mail_user} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "Un nou article ha estat enviat per {\$mail_user} a {\$mail_site} el {\$mail_date|tiki_short_datetime}",
"New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}:" => "Nova publicació al fòrum <{\$mail_forum|truncate:20:\"...\"}> per {\$mail_author}:",
"The map {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "El mapa {\$mail_page} ha estat canviat per {\$mail_user} el {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "La pàgina {\$mail_page} ha estat creada per {\$mail_user} el {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "La pàgina {\$mail_page} va ser canviada per {\$mail_user} el {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was commented by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "La pàgina {\$mail_page} va ser comentada per {\$mail_user} el {\$mail_date|tiki_short_datetime}",
"Insert/Edit an internal wiki link" => "Inserta/Edita un enllaç wiki inter",
"Wiki Link insert" => "Inserció d\\'enllaç Wiki",
"Please make a selection of text in order to create a link" => "Fes una selecció de text per crear un enllaç",
"Insert an image" => "Inserta una imatge",
"Tiki Image - Insert an image" => "Imatge de Tiki - Inserta una imatge",
"Switch to normal (wiki) editor" => "Canvia a editor normal (wiki)",
"referenced by" => "citat per",
"references" => "referències",
"View Comments" => "Visualitza comentaris",
"Trackback pings" => "Pings de retrorastreig",
"Blog name" => "Nom de la Bitàcola",
"Enlarge area height" => "fes més gran l'alçada",
"Reduce area height" => "Reduir l'alçada de l'àrea",
"Date and Time Formats" => "Data i Formats de Temps",
"Trackers with mirror tables" => "Formularis amb taules mirall",
"Use trackers with mirror tables" => "Empra formularis amb taules mirall",
"Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki" => "Els valors són guardats en una taula dedicada per a cada formulari; així pots manipular les dades fàcilment fora de Tikiwiki",
"Validate choice" => "Valida l'elecció",
"Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>" => "Wysiwyg vol dir El Que Veus És El Que Obtens (What You See Is What You Get), és a dir, un editor visual de text amb format, i és gestionat a Tikiwiki per <a href=\"http://fckeditor.net\">FCKeditor</a>",
"Custom Categories" => "Personalitzar Categories",
"Use wysiwyg editor" => "Empra editor wysiwyg",
"Use normal editor" => "Empra editor normal",
"Admin external wikis" => "Administrar wikis externs",
"tiki admin external wikis template" => "administrador tiki de plantilles de wikis externs",
"There are individual permissions set for this forum" => "Existeixen permisos fixats individualment per a aquest fòrum",
"Add a subscription newsletters" => "Afegeix un butlletí de subscripcions",
"Articles (subs)" => "Articles (colabs)",
"Tbl vis" => "Vis Tbl",
"isMain" => "esPrincipal",
"Use \"explicit\" names in the mirror table" => "Empra noms \"explícits\" a la taula mirall",
"Upload image for this post" => "Puja una imatge per a aquesta publicació",
"Spellcheck" => "Comprovació ortogràfica",
"You can include the image in a tiki page using one of these lines" => "Pots incloure la imatge en una pàgina de Tiki emprant alguna d'aquestes línies",
"Current heading" => "Actual encapçalament",
"Number of posts to show" => "Nombre de publicacions per mostrar",
"Other Options" => "Altres opcions",
"You can include the image in an HTML page using one of these lines" => "Pots incloure la imatge en una pàgina HTML emprant una d'aquestes línies",
"Edit or ex/import Languages" => "Edita o exporta/importa Idiomes",
"Edit and create Languages" => "Edita i crear Idiomes",
"Edit and create languages" => "Edita i crear idiomes",
"Create Language" => "Crear Idioma",
"Shortname" => "Nom curt",
"Longname" => "Nom llarg",
"Edit Section:" => "Edita la secció",
"View object" => "Mostra l'objecte",
"<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer." => "<strong>Previsualitza</strong> o <strong>Desa</strong> la teva feina per reiniciar el comptador de la sessió d'edició.",
"Case Insensitivity" => "Insensible a majúscules/minúscules",
"Im- Export languages" => "Im- Exportar idiomes",
"Select the language to Import" => "Selecionar l'idioma que es vol Importar",
"Modify String in Source Language" => "Modifica la cadena de text en l'idioma Oigien",
"Original String" => "Cadena de text original",
"New String" => "Nova cadena de text",
"TikiWiki CMS/Groupware Project" => "Projecte TikiWiki CMS/Groupware",
"Powered by TikiWiki" => "Potenciat per TikiWiki",
"Interactive translator" => "Traductor Interactiu",
"has been updated" => "ha estat actualitzat/da",
"Close this window" => "Tanca aquesta finestra",
"Clicking 'Close this window' will reload the main window from where it was opened" => "En clicar sobre 'Tanca aquesta finestra' s'actualitzarà la finestra principal des d'on s'havia obert",
"Tikiwiki Mods" => "Mods de Tikiwiki",
"Sum" => "Suma",
"on:" => "a:",
"On:" => "A:",
"Viewing blog post" => "Visualitzant la publicació de la bitàcola",
"Return to blog" => "Retorna a la bitàcola",
"Register this site at tiki.org" => "Registra aquest lloc a tiki.org",
"On this page you can make your tiki site known to tiki.org. It will get shown there in a list of known tiki sites." => "En aquesta pàgina pots donar a conèixer el teu lloc tiki a tiki.org per tal que consti al llistat de llocs tiki coneguts",
"public" => "públic",
"This page is being edited by" => "Aquesta pàgina està essent editada per ",
"Proceed at your own peril" => "Procedir al teu propi risc",
"Insert Row" => "Inserta Fila",
"Insert Column" => "Inserta Columna",
"Remove Row" => "Elimina Fila",
"Remove Column" => "Elimina Columna",
"Merge Cells" => "Fusiona Cel·les",
"Restore Cells" => "Restaura Cel·les",
"Copy Calculation" => "Copia càlcul",
"Format Cell" => "Formata Cel·la",
"Items list" => "Llista d'ítems",
"A new major release branch is available." => "Hi ha disponible una nova branca major.",
"You cannot mix old and new trackers" => "No pots barrejar formularis vells i nous",
"Permission denied you cannot post" => "Permís denegat per publicar",
"Tiki RSS feed for blog: " => "Alimentació RSS del Tiki per a la bitàcola: ",
"Shortname must be 2 Characters" => "Nom curt (2 caràcters)",
"You must provide a longname" => "Has de proporcionar un nom llarg",
"Language created" => "Idioma creat",
"Not enable for this type of object" => "No està habilitat per aquest tipus d'objecte",
"Access Denied" => "Accés Denegat",
"This Tikiwiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more." => "Aquest lloc Tikiwiki està preparat per l'accés a través de molts aparells mòbils, e.g. telèfons WAP, PDA, aparells i-mode and molts més.",
"Cannot rename page maybe new page already exists" => "No es pot reanomenar pàgina, potser la pàgina ja existeix",
"A SheetId is required." => "Cal un SheetId.",
"Quick Admin" => "Admin. ràpida",
"Check this box if you really want to delete your account" => "Marca aquesta casella si realment vols esborrar el teu compte",
"Reports are disabled, only standard reporting is available" => "Els informes estan desactivats, només és disponible l'enviament de missatges estàndard",
"Sites you are watching" => "Llocs i pàgines que estàs vigilant",
"Documents interns" => "Documents interns",
"Documents" => "Documents",
"Removed version" => "Versió eliminada",
"Renamed" => "Reanomenat",
"feature" => "funcionalitat",
"Posted" => "Publicat",
"file" => "arxiu",
"trackeritem" => "ítem del tracker",
"You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The " => "Necessites marcar el requadre de verificació corresponent a cada tipus d'acció sobre la qual puguis estar interessat en que hi hagi algun informe posterior. Per veure un informe d'alguns tipus d'accions, selecciona les caselles de verificació d'aquests",
"Level from which errors should be reported" => "Nivell al qual s'hauria d'informar dels errors",
"Once checked, click on any string to translate it" => "Un cop seleccionada, clica sobre qualsevol cadena de text per traduir-la",
"Changes will be applied on next page load only" => "S'aplicaran els canvis un cop carreguis la pàgina de nou",
"New article post" => "Nova publicació d'article",
"Edited article post" => "Publicació d'article editada",
"Deleted article post" => "Publicació d'article esborrada",
"This search feature and the <a href=\"tiki-edit_perspective.php\">perspectives GUI</a> need <a href=\"http://dev.tiki.org/Dynamic+Preferences\">dev.tiki.org/Dynamic+Preferences</a>. If you search for something and it's not appearing, please help improve keywords/descriptions" => "Aquesta funcionalitat de cerca i la <a href=\"tiki-edit_perspective.php\">interfície gràfica de gestió de Perspectives</a> necessiten les preferències dinàmiques (<a href=\"http://dev.tiki.org/Dynamic+Preferences\">dev.tiki.org/Dynamic+Preferences</a>). Si cerques alguna cosa i no apareix, si us plau, ajuda a millorar les paraules clau i descripcions de les preferències",
"No preferences were found for your search query" => "No s'han trobat preferències per a la teva cerca",
"Preference name" => "Nom de la preferència",
"Sample" => "Mostra",
"Change the <strong>Admin</strong> password" => "Canvia la contrasenya de l'usuari administrador (<strong>Admin</strong>)",
"Cannot open/write this file" => "No puc obrir/desar aquest arxiu",
"Custom translation will not be saved. Ask your administration to change the permission" => "No es poden desar les traduccions a mida. Demana a la persona administradora del lloc que canviï el permís",
"Before installing Tiki, <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Abans d'instal·lar Tiki, <a href=\"http://doc.tiki.org/tiki-index.php?page=Requirements&bl=y\" target=\"_blank\">revisa la documentació</a> i confirma que el teu sistema té els requeriments mínims necessaris",
"Tiki can create images" => "Tiki pot crear imatges",
"Tiki was not able to create a sample image. Please check your GD library configuration" => "Tiki no ha pogut crear una imatge de prova. Si us plau, comprova la configuració de la llibreria GD",
"Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "No s'ha pogut esecificar el paràmetre max_execution_time per a PHP. És possible que hi et trobis amb problemes quan creis o actualitzis la base de dades emprant aquest instal·lador en un sistema lent. Això es manifestar a través d'una pàgina en blanc",
"This install will populate (or upgrade) the database" => "Aquesta instal·lació omplirà (o actualitzarà) la base de dades",
"A new install will populate the database" => "S'omplirà la base de dades amb una instal·lació nova",
"Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "Empra sota el teu propi risc. Si les dades a la base de dades contenen actualment dades convertides inadequadament, aquest procés pot fer que les coses empitjorin. Aquest procés és adequat per a instal·lacions noves. Requereix el privilegi ALTER sobre la base de dades",
"Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "Els permisos de categories han estat modificats substancialment des de la versió 3. Si has estat emprant permisos de categories, tingues en compte que és possible que no funcionin adequadament després d'actualitzar a Tiki 4 o versions posteriors, i serà necessari que els reconfiguris manualment",
"Please log in with your admin password to continue" => "Si us plau, connecta't amb la teva contrasenya de persona administradora (admin) per tal de continuar",
"PHP error reporting level" => "Nivell d'informes d'error de PHP",
"Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will" => "T'has trobat amb problemes amb la teva actualització? El teu compte d'admin ha perdut els seus privilegis? Això pot ocórrer si has actualitzat des d'una versió molt antiga de Tiki.</p>\n\t\t\t<p>Podem arregar-lo! Fer-ho realitzarà les següents acccions",
"Tiki is an open source project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki és un projecte de codi lliure/fonts obertes: <em>tu</em> també pots <a href='http://info.tiki.org/Join+the+Community' target='_blank'>ajuntar-te amb la comunitat</a> i ajudar <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>a desenvolupar Tiki</a>",
"Are you sure you want to attempt to fix the encoding of your entire database" => "Segur que vols intentar solucionar la codificació de la teva base de dades sencera",
"Upgrading and running into encoding issues" => "Actualitant i trobant-te amb incidències de codificació",
"We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "Podem intentar solucionar-ho, però <strong>assegura't que tens còpies de seguretat, i que pots restaurar-les</strong>",
"Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "Uups. Has d'assegurar-te que el conjunt de caràcters del client està forçat a UTF-8. Re-especifica la connexió a la base de dades per poder continuar",
"No media entries found" => "No s'han trobat entrades de mèdia",
"to upload" => "per pujar",
"Modified By" => "Modificat per",
"However, some page aliases fitting the query were found (see Aliases section above)" => "De totes formes, es van trobar alguns alias de pàgines que encaixen en la cerca (mira la secció d'Alias més amunt)",
"Change to" => "Canvia a",
"Week containing" => "Setmana que contingui",
"Month containing" => "Mes que contingui",
"Removal of your email address failed" => "No s'ha pogut treure la teva adreça de correu-e",
"Subscription failed" => "La subscripció ha fallat",
"Changes to groups watching this {\$objectType}" => "Canvis en grups subscrits a aquest/a {\$objectType}",
"These changes to group watches" => "Aquests canvis a subscripcions de grups",
"were made to these descendants" => "han estat fets a aquests descendents",
"Groups watching this {\$objectType}" => "Grups seguint aquest/a {\$objectType}",
"Make sure to whitelist this domain to prevent registration emails being canned by your spam filter" => "Assegura't de posar a la llista blanca d'adreces conegudes a aquest domini per prevenir que els correus-e de registre vagin a parar a la teva carpeta de correu no desitjat (spam)",
"{\$where|escape}" => "{\$where|escape}",
"Article Clip (read only)" => "Retall d'article (només de lectura)",
"To include the article clipping into your newsletter, cut and paste it into the contents" => "Per a incloure retalls d'articles al teu butlletí, talla i enganxa-ho en els continguts del butlletí",
"If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending" => "Si s'ha activat l'autoretallat, també pots introduir \"~~~articleclip~~~\" que serà reemplaçat amb el darrer \tretall quan s'enviï",
"if not" => "si no",
"Save your changes" => "Desa els canvis",
"Save any changes and send to all subscribers" => "Desa qualsevol canvi i envia a totes les persones subscriptores",
"The link was sent via e-Mail to the following addresses" => "S'ha enviat l'enllaç via correu-e a les adreces següens",
"I found an interesting page that I thought you would like" => "He trobat una pàgina interessant que he pensat que et podria agradar",
"Separate multiple email addresses with a comma" => "Separa múltiples adreces de correu-e amb comes",
"You do not have the permission to send messages or you did not allow other users to send you messages" => "No tens permís per enviar missatges o no permets a altres usuaris que t'enviïn missatges",
"Separate multiple recipients with a comma" => "Separa múltiples destinataris amb comes",
"There is no forum where you can post a message" => "No hi ha cap fòrum on puguis publicar un missatge",
"Tracker was modified at" => "El formulari va ser modificat a",
"No Additionnal Sort" => "Cap ordenació addicional",
"Development Notice" => "Avís de desenvolupament",
"Experimental Conversion" => "Conversió experimental",
"You have mistyped the anti-bot verification code. Please try again" => "Hos comès alguna errada en el codi de verificació antirobots. Prova-ho de nou, si us plau",
"Incorrect. Try again" => "No és correcte, Prova de nou",
"Plugin argument(s) missing" => "Manca argument(s) del connector (plugin)",
"The upload has not been done" => "La pujada no s'ha pogut efectuar",
"Title to display at the top of the box" => "Títol que es vol mostrar a sobre de la caixa",
"Users can shade module" => "Els usuaris poden amagar el mòdul",
"If set to \"y\", the module will not number list items" => "Si es posa en \"y\", el mòdul no numerarà la llista d'ítems",
"Number of rows, or items, to display" => "Nombre de files o ítems a mostrar",
"Default: 10" => "Per omissió: 10",
"No registries specified in admin/payment/cclite" => "No s'han especificat xarxes (registries) a admin > pagaments > cclite",
"Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc" => "Ordena pel nom del camp en anglès de la base de dades, ascendent o descendent. Exemples: fileId_asc o name_desc",
"You attempted to create the following page" => "Has intentat crear la següent pàgina",
"The message has been sent to" => "S'ha enviat el missatge a",
"The message will be sent to" => "S'enviarà el missatge a",
"Ex" => "Ex.",
"Delete events older than" => "Esborra esdeveniments més vells que",
"Your account has been validated" => "S'ha validat el teu compte",
"You have to choose a password to use this account" => "Has d'escollir una contrasenya per a emprar aquest compte",
"Please choose the language for this page" => "Si us plau, escull l'idioma d'aquesta pàgina",
"I have refused your friendship request" => "He rebutjat la teva petició d'amistat",
"I have canceled my friendship request" => "He cancel·lat la teva petició d'amistat",
"Page saved (version %d)" => "Pàgina desada (versió %d)",
"This blog has no posts" => "Aquest bloc no té publicacions",
"Plugin modified by editor" => "El plugin ha estat modificat per l'editor",
"User Levels" => "Nivells d'Usuari",
"Custom code" => "Codi adaptat",
"Automatically creates a link to the appropriate SourceForge object" => "Automaticament crea un enllaç a l'object SourceForge apropriat",
"Display youtube video in a wiki page" => "Visualitza un vídeo youtube en una pàgina wiki",
"Provides a widget for users to vote on a proposal and view the current decision" => "Proporciona un widget per a que els usuaris puguin votar sobre propostes i veure la decisió actual",
"The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "La llista de vots emesos. Un vot per línia. Ó bé 0, +1 ó -1 seguits per un nom d'usuari",
"Short description of the proposal to vote on. Will be displayed above the result table" => "Breu descripció de la proposta sobre la que es vol votar. Es mostrarà a sobre de la taula de resultats",
"Subscribe text, containing %s as the placeholder for the group name" => "Text per a la subscripció, contenint %s com a indicador d'on es col·locarà el nom del grup",
"Unsubscribe text, containing %s as the placeholder for the group name" => "Text per a desubscriure's,contenint %s com a indicador d'on es col·locarà el nom del grup",
"Subscribe button label, containing %s as the placeholder for the group name" => "Etiqueta del botó de subscripció, contenint %s com a indicador d'on es col·locarà el nom del grup",
"Unsubscribe button label, containing %s as the placeholder for the group name" => "Etiqueta del botó de de-subscripció, contenint %s com a indicador d'on es col·locarà el nom del grup",
"Users from group" => "Usuaris del grup",
"You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "Has d'especificar el <a href=\"tiki-admin.php?page=general\">Correu-e de l'enviador</a> abans de crear notificacions de correu-e",
"left|right" => "left|right",
"on|off" => "on|off",
"Numeric" => "Numeric",
"0|1" => "0|1",
"ftp" => "ftp",
"1|0" => "1|0",
"Articles displayed" => "Articles mostrats",
"Topics expression" => "Expressió de tòpics",
"Topic ID expression" => "Expressió de l'ID del tòpic",
"Type expression" => "Expressió de tipus",
"Title only" => "Només títol",
"Start date" => "Data d'inici",
"Inline" => "Enlínia",
"Number" => "Número",
"Show icon" => "Mostra icona",
"Displays a link that allows to go back in the browser history" => "Mostra un enllaç que permet retornar a la història del navegador",
"Displayed information" => "Informació mostrada",
"Numeric value" => "Valor numèric",
"fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle" => "NomDecamp_asc|NomDeCamp_desc, camps vàlids: type, created, name, hits, shuffle",
"Display top category" => "Mostra la categoria superior de totes",
"yes|no, default to no" => "yes|no, per omissió és no",
"Line numbers" => "Números de línia",
"Right to left" => "Dreta a esquerra",
"File gallery ID" => "ID de la Galeria d'Arxius",
"Image gallery ID" => "ID de la Galeria d'Imatges",
"Filter on fileIds in a file gallery" => "Selecciona només aquests id d'arxius (fileIds) d'una galeria d'arxius",
"Filter on fileIds in a file gallery. Separate each fileId with \\':\\'" => "elecciona només aquests id d'arxius (fileIds) d'una galeria d'arxius. Separa cada id amb \\':\\'",
"Show all thumbs" => "Mostra tots els contactes",
"Parse descriptions" => "Interpreta la sintaxi de les descripcions",
"Also known as fortune cookies or taglines" => "També conegut com a galetes de Fortuna o Línies etiquetades",
"Wiki DSN name" => "Nom de DSN Wiki",
"left|right|center|justify" => "esquerra|dreta|centre|justifica",
"Maximum days" => "Dies màxims",
"Maximum Rows" => "Files màximes",
"Datetime" => "Datahora",
"Use div" => "Empra div",
"Use div instead of ol" => "Empra div enlloc de llista ordenada 'ol'",
"Heading row" => "Fila de la capçalera",
"name_asc" => "nom_asc",
"Default width: 425" => "Amplada per omissió: 425",
"Default height: 350" => "Alçada per omissió: 350",
"Ftp Server Name" => "Nom del servidor Ftp",
"Ftp User name" => "Nom de l'usuari Ftp",
"Ftp password" => "Contrasenya Ftp",
"Download button label" => "Etiqueta del botó de Descàrrega",
"current value (REQUIRED)" => "valor actual (REQUERIT)",
"Account number" => "Número de compte",
"Name of iframe" => "Nom de l'iframe",
"editLink" => "Enllaçd'Edició",
"groups" => "grups",
"name" => "nom",
"Displays a list of plugins available in this wiki." => "Proporciona una llista de plugins sobre aquest wiki.",
"0|1, switch the text display from left to right to right to left" => "0|1, canvia la forma de mostrar text des de 'd'esquerra a dreta', cap a 'de dreta a esquerra'",
"0|1, display the content as is instead of escaping HTML special chars" => "0|1, mostra el contingut com està enlloc d'escapar (deixar d'interpretar) els caràcters especials HTML",
"Included group, group users and emails will be refreshed at each newsletter sending" => "Els grups inclosos, els usuaris del grup i els correus electrònics s'actualitzaran a cada butlletí enviat",
"Mark other translations as out of date" => "Marca les altres traduccions com a desfasades",
"Tracker Item:" => "Registre del formulari:",
"Administrator, can manage users groups and permissions, Hotwords and all the weblog features" => "Administrador, pot gestionar grups d'usuaris i permisos, paraules calentes i totes les característiques de bloc",
"Can admin attachments to wiki pages" => "Pot administrar fitxers adjunts a pàgines wiki",
"Can admin rss modules" => "Pot administrar mòduls rss",
"Can report msgs to moderator" => "Pot informar de missatges al moderador",
"Can validate submited links" => "Pot validar els enllaços tramesos",
"Can view Tikiwiki tools calendar" => "Pot visualitzar les eines Tikiwiki del calendari",
"Can view trackers closed items" => "Pot visualitzar registres de formulari tancats",
"Can view trackers pending items" => "Pot visualitzar registres de formulari pendents",
"Submited articles automatically approved" => "Els articles tramesos s'aproven automàticament",
"Submited links are valid" => "Els enllaços tramesos són vàlids",
"Create/edit dsn" => "Crea/edita dsn",
"Are you sure you want to delete this note" => "Estàs segur/a que vols esborrar aquesta nota?",
" But the login failed, so check the Username and Password" => "Però el login ha fallat, si us plau revisa el nom d'usuari i la contrassenya",
"Notice: this variable may not be empty" => "Avís: pot ser que aquesta variable no estigui buida",
"Permission denied you cannot assign permissions for this object" => "Permís denegat: no pots assignar permisos per a aquest objecte",
"Permission denied you cannot remove this sheet" => "Permís denegat: no pots eliminar aquest full",
"Permission denied you cannot view the source of this page" => "Permís denegat: no pots veure el codi font d'aquesta pàgina",
"Permission denied: you cannot view this blog post while it is marked private" => "Permís denegat: no pots veure aquesta publicació del blog mentre estigui marcat com a privat",
"Please create a directory named '.\$prefs['map_path'].' to hold your map files" => "Si us plau crea un directori anomenat '.\$prefs['map_path'].' per guardar els teus arxius .map",
" The connection failed, so check the server names" => "La connexió ha fallat, si us plau revisa els noms de servidor",
"The connection was OK" => "La conexiò està bé",
"You are about to delete a TikiTest file, do you want to continue " => "Estàs a punt d'esborrar un arxiu del TikiTest. Vols continuar?",
"You must suggest a question; please try again" => "Has de suggerir una pregunta; si us plau torna-ho a provar",
"more changes of the same type.." => "més canvis del mateix tipus.",
"Nothing has happened" => "No ha succeït res",
"Changes in detail" => "Canvis en detall",
"New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}" => "Nou estatus per a l'itemID {\$mail_itemId} {\$mail_item_desc} per al formulari {\$mail_trackerName}",
"Last attempt" => "Darrer intent",
"An administrator of the site below has added you as a new user" => "Una persona administratora del lloc web t'ha afegit com a usuari/a nou/va",
"If you want to confirm your membership in this site, click on the following link to login for the first time" => "Si vols confirmar que vols ser membre d'aquest lloc web, clica al següent enllaç per entrar per primera vegada",
"Your authentication credentials are" => "Les teves credencials d'autenticació són",
"Welcome on the site" => "Benvingut al lloc",
"New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "Nou tòpic de fòrum a <{\$mail_forum|truncate:20:\"...\"}> per {\$mail_author|username}",
"New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "Nova publicació al fòrum <{\$mail_forum|truncate:20:\"...\"}> per {\$mail_author|username}",
"The page {\$mail_page} was deleted but used to be here" => "La pàgina {\$mail_page} ha estat esborrada però solia ser aquí",
"The old page content follows below" => "L'anterior contingut de la pàgina es mostra a continuació a sota",
"The user will be able to reply to you directly via email" => "La persona usuària podrà respondre't directament via correu-e",
"You will be sent a copy of this email" => "Se t'enviarà una còpia d'aquest correu-e",
"You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0" => "Estàs rebent correus-e de notificació de canvis de forma agrupada en un resum periòdic. Si vols, en canvi, rebre els correus-e d'avís individualment i tot just es publiquin, canvia les teves preferències a %0",
"0" => "The SandBox is a page where you can practice your editing skills, use the preview featureto preview the gina, no es guarden versions d'aquesta pàgina",
"%0 added or updated event %1" => "%0 ha afegit o actualitzat l'esdeveniment %1",
"%0 added or updated tracker item %1 on tracker %2" => "%0 ha afegit o actualitzat l'ítem  %1 del formulari %2",
"%0 added or updated tracker item id %1 on tracker %2" => "%0 ha afegit o actualitzat l'ítem id %1 del formulari %2",
"%0 added a new comment to %1 on tracker %2" => "%0 ha afegit un nou comentari a %1 al formulari %2",
"%0 added a new comment to item id %1 on tracker %2" => "%0 ha afegit un nou comentari a l'item id %1 en el formulari %2",
"added the %0 %1 to the category %2" => "ha afegit el/la %0 %1 a la categoria %2",
"removed the %0 %1 from the category %2" => "ha eliminat el/la %0 %1 de la categoria %2",
"TikiSheet" => "FullsTiki",
"Add or edit a rule" => "Afegeix o edita una norma",
"AuthorName" => "NomAutor",
"Edit this sheet:" => "Edita aquest full:",
"Class Name" => "Nom de Classe",
"Header Rows" => "Files de Capçalera",
"Footer Rows" => "Files de Peu de pàgina",
"Wiki Parse Values" => "Processa valors i sintaxi Wiki",
"Parent SheetId" => "SheetId parental",
"You can access the sheet using the following URL" => "Pots accedir a aquest full emprant la següent URL",
// ### end of unused words

// ### start of untranslated words
// ### uncomment value pairs as you translate
// "Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information" => "Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information",
// "Uploaded by" => "Uploaded by",
// "Last Modified by" => "Last Modified by",
// "Last download" => "Last download",
// "Aland_Islands" => "Aland_Islands",
// "American_Samoa" => "American_Samoa",
// "Bosnia_and_Herzegovina" => "Bosnia_and_Herzegovina",
// "Bouvet_Island" => "Bouvet_Island",
// "British_Indian_Ocean_Territory" => "British_Indian_Ocean_Territory",
// "British_Virgin_Islands" => "British_Virgin_Islands",
// "Burkina_Faso" => "Burkina_Faso",
// "Cape_Verde" => "Cape_Verde",
// "Catalan_Countries" => "Catalan_Countries",
// "Cayman_Islands" => "Cayman_Islands",
// "Central_African_Republic" => "Central_African_Republic",
// "Christmas_Island" => "Christmas_Island",
// "Cocos_Islands" => "Cocos_Islands",
// "Congo_Democratic" => "Congo_Democratic",
// "Cook_Islands" => "Cook_Islands",
// "Costa_Rica" => "Costa_Rica",
// "Czech_Republic" => "Czech_Republic",
// "Dominican_Republic" => "Dominican_Republic",
// "El_Salvador" => "El_Salvador",
// "Equatorial_Guinea" => "Equatorial_Guinea",
// "Falkland_Islands" => "Falkland_Islands",
// "Faroe_Islands" => "Faroe_Islands",
// "Federated_States_of_Micronesia" => "Federated_States_of_Micronesia",
// "French_Guiana" => "French_Guiana",
// "French_Polynesia" => "French_Polynesia",
// "French_Southern_Territories" => "French_Southern_Territories",
// "Guinea_Bissau" => "Guinea_Bissau",
// "Heard_Island_and_McDonald_Islands" => "Heard_Island_and_McDonald_Islands",
// "Hong_Kong" => "Hong_Kong",
// "Ivory_Coast" => "Ivory_Coast",
// "Marshall_Islands" => "Marshall_Islands",
// "Netherlands_Antilles" => "Netherlands_Antilles",
// "New_Caledonia" => "New_Caledonia",
// "New_Zealand" => "New_Zealand",
// "Norfolk_Island" => "Norfolk_Island",
// "North_Korea" => "North_Korea",
// "Northern_Mariana_Islands" => "Northern_Mariana_Islands",
// "Papua_New_Guinea" => "Papua_New_Guinea",
// "Puerto_Rico" => "Puerto_Rico",
// "Republic_of_Macedonia" => "Republic_of_Macedonia",
// "Russian_Federation" => "Russian_Federation",
// "Saint_Helena" => "Saint_Helena",
// "Saint_Kitts_and_Nevis" => "Saint_Kitts_and_Nevis",
// "Saint_Lucia" => "Saint_Lucia",
// "Saint_Pierre_and_Miquelon" => "Saint_Pierre_and_Miquelon",
// "San_Marino" => "San_Marino",
// "Sao_Tome_and_Principe" => "Sao_Tome_and_Principe",
// "Saudi_Arabia" => "Saudi_Arabia",
// "Sierra_Leone" => "Sierra_Leone",
// "Solomon_Islands" => "Solomon_Islands",
// "South_Africa" => "South_Africa",
// "South_Georgia_and_South_Sandwich_Islands" => "South_Georgia_and_South_Sandwich_Islands",
// "South_Korea" => "South_Korea",
// "Sri_Lanka" => "Sri_Lanka",
// "St_Vincent_Grenadines" => "St_Vincent_Grenadines",
// "Svalbard_and_Jan_Mayen" => "Svalbard_and_Jan_Mayen",
// "Trinidad_Tobago" => "Trinidad_Tobago",
// "Turks_and_Caicos_Islands" => "Turks_and_Caicos_Islands",
// "US_Virgin_Islands" => "US_Virgin_Islands",
// "United_Arab_Emirates" => "United_Arab_Emirates",
// "United_Kingdom" => "United_Kingdom",
// "United_Kingdom_-_England_and_Wales" => "United_Kingdom_-_England_and_Wales",
// "United_Kingdom_-_Northern_Ireland" => "United_Kingdom_-_Northern_Ireland",
// "United_Kingdom_-_Scotland" => "United_Kingdom_-_Scotland",
// "United_States" => "United_States",
// "United_States_Minor_Outlying_Islands" => "United_States_Minor_Outlying_Islands",
// "Viet_Nam" => "Viet_Nam",
// "Wallis_and_Futuna" => "Wallis_and_Futuna",
// "Western_Sahara" => "Western_Sahara",
// "the former Yugoslav Republic of Macedonia" => "the former Yugoslav Republic of Macedonia",
// "the_former_Yugoslav_Republic_of_Macedonia" => "the_former_Yugoslav_Republic_of_Macedonia",
// "Tiki Installer" => "Tiki Installer",
// "MySQL Improved (mysqli)" => "MySQL Improved (mysqli)",
// "No database name specified" => "No database name specified",
// "Welsh" => "Welsh",
// "Slovene" => "Slovene",
// "Frisian Netherlands" => "Frisian Netherlands",
// "Indonesian" => "Indonesian",
// "Icelandic" => "Icelandic",
// "Inuktitut" => "Inuktitut",
// "Lithuanian" => "Lithuanian",
// "Norwegian Nynorsk" => "Norwegian Nynorsk",
// "Romanian" => "Romanian",
// "Romansh" => "Romansh",
// "Sinhala" => "Sinhala",
// "Albanian" => "Albanian",
// "Turkish" => "Turkish",
// "Vietnamese" => "Vietnamese",
// "anonymous" => "anonymous",
// "Expecting \"(\"" => "Expecting \"(\"",
// "Unexpected \"%0\"" => "Unexpected \"%0\"",
// "Expecting \")\"" => "Expecting \")\"",
// "%0 near \"%1\"" => "%0 near \"%1\"",
// "No formula provided" => "No formula provided",
// "Variable not found \"%0\"" => "Variable not found \"%0\"",
// "Unknown operation \"%0\"" => "Unknown operation \"%0\"",
// "Internal error" => "Internal error",
// "User error" => "User error",
// "Plugin <strong>%0</strong> cannot be executed" => "Plugin <strong>%0</strong> cannot be executed",
// "Number of files transferred to the database" => "Number of files transferred to the database",
// "Number of files transferred to the file system" => "Number of files transferred to the file system",
// "Cannot read to this file" => "Cannot read to this file",
// "Old File deleted" => "Old File deleted",
// "The uploaded file exceeds the upload_max_filesize directive in php.ini" => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
// "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
// "The uploaded file was only partially uploaded. Please try again" => "The uploaded file was only partially uploaded. Please try again",
// "No file was uploaded" => "No file was uploaded",
// "Missing a temporary folder" => "Missing a temporary folder",
// "Failed to write file to disk" => "Failed to write file to disk",
// "File upload stopped by extension" => "File upload stopped by extension",
// "Number of page revisions to import (0 for all revisions)" => "Number of page revisions to import (0 for all revisions)",
// "What to do with page names that already exists in TikiWiki" => "What to do with page names that already exists in TikiWiki",
// "Do not import" => "Do not import",
// "Override" => "Override",
// "Append software name as prefix to the page name" => "Append software name as prefix to the page name",
// "<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "<a href=\"tiki-importer.php\">Click here</a> to finish the import process",
// "\$countParsedData pages parsed. Starting to insert those pages into Tiki" => "\$countParsedData pages parsed. Starting to insert those pages into Tiki",
// "Page \${page['name']} sucessfully imported" => "Page \${page['name']} sucessfully imported",
// "Page \${page['name']} NOT imported (there was already a page with the same name)" => "Page \${page['name']} NOT imported (there was already a page with the same name)",
// "Import images and attachments (see documentation for more information)" => "Import images and attachments (see documentation for more information)",
// "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php",
// "Invalid file mime type" => "Invalid file mime type",
// "XML file does not validate against the Mediawiki XML schema" => "XML file does not validate against the Mediawiki XML schema",
// "Mediawiki XML file version \$xmlVersion is not supported" => "Mediawiki XML file version \$xmlVersion is not supported",
// "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments",
// "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) does no exist. Fix the problem or try to import without the attachments" => "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) does no exist. Fix the problem or try to import without the attachments",
// "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) is not writable. Fix the problem or try to import without attachments" => "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) is not writable. Fix the problem or try to import without attachments",
// "Parsing pages" => "Parsing pages",
// "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment" => "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment",
// "Importing attachments" => "Importing attachments",
// "NOT importing file \$fileName as there is already a file with the same name in the destination directory (\$this->attachmentsDestDir)" => "NOT importing file \$fileName as there is already a file with the same name in the destination directory (\$this->attachmentsDestDir)",
// "File \$fileName successfully imported" => "File \$fileName successfully imported",
// "Unable to download file \$fileName. File not found" => "Unable to download file \$fileName. File not found",
// "Error while parsing revision \$i of the page \"\${data['name']}\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)" => "Error while parsing revision \$i of the page \"\${data['name']}\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)",
// "Page \"\${data['name']}\" successfully parsed with \$countRevisions revisions (from a total of \$totalRevisions revisions)" => "Page \"\${data['name']}\" successfully parsed with \$countRevisions revisions (from a total of \$totalRevisions revisions)",
// "Page \"\${data['name']}\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "Page \"\${data['name']}\" is NOT going to be imported. It was not possible to parse any of the page revisions",
// "Admin ' . \$str));\n\n\n\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-list" => "Admin ' . \$str));\n\n\n\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-list",
// "List ' . \$str));\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-view" => "List ' . \$str));\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-view",
// "View ' . \$str));\n\n\n\t\t\t\t} else { // still not set? guess...\n\t\t\t\t\t\$str = str_replace(array('tiki-" => "View ' . \$str));\n\n\n\t\t\t\t} else { // still not set? guess...\n\t\t\t\t\t\$str = str_replace(array('tiki-",
// "ERROR: unable to write to lang/%s/language.php" => "ERROR: unable to write to lang/%s/language.php",
// "The file lang/\$this->lang/language.php is not well formated. Run get_strings.php?lang=\$this->lang and then try to export the translations again" => "The file lang/\$this->lang/language.php is not well formated. Run get_strings.php?lang=\$this->lang and then try to export the translations again",
// "Invalid \"from\" date received" => "Invalid \"from\" date received",
// "Invalid \"to\" date received" => "Invalid \"to\" date received",
// "Sorry, \"from\" date must precede \"to\" date" => "Sorry, \"from\" date must precede \"to\" date",
// "Sorry, no data available for the future" => "Sorry, no data available for the future",
// "Only display the module if in one of the listed perspective IDs. Semi-colon separated" => "Only display the module if in one of the listed perspective IDs. Semi-colon separated",
// "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons",
// "Module only applicable for the specified sections. Multiple values can be separated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be separated by semi-colons",
// "Page filter" => "Page filter",
// "Module only applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be separated by semi-colons",
// "Module not applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be separated by semi-colons",
// "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module",
// "Contributor" => "Contributor",
// "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module",
// "Payment sent but verification not currently available. (Work in progress)" => "Payment sent but verification not currently available. (Work in progress)",
// "Cart Check-Out" => "Cart Check-Out",
// "Cclite error" => "Cclite error",
// "Use \"xajax\" library to \"ajaxify\" most Tiki pages" => "Use \"xajax\" library to \"ajaxify\" most Tiki pages",
// "Ajax auto-save" => "Ajax auto-save",
// "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing" => "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing",
// "Users can opt-out of internal messages" => "Users can opt-out of internal messages",
// "Article ordering" => "Article ordering",
// "Default sort mode for the articles on the article listing" => "Default sort mode for the articles on the article listing",
// "Title of articles home page" => "Title of articles home page",
// "Author Rating" => "Author Rating",
// "Trailer position" => "Trailer position",
// "Between heading and body" => "Between heading and body",
// "Header text position" => "Header text position",
// "Requires a smaller image for list view" => "Requires a smaller image for list view",
// "Next image" => "Next image",
// "Below image" => "Below image",
// "Default number per page" => "Default number per page",
// "Default Ordering" => "Default Ordering",
// "Paginate articles" => "Paginate articles",
// "Divide articles into multiple pages with pagebreak markers" => "Divide articles into multiple pages with pagebreak markers",
// "User ratings on articles" => "User ratings on articles",
// "Allows users to rate the articles" => "Allows users to rate the articles",
// "Article rating options" => "Article rating options",
// "List of options available for the rating of articles" => "List of options available for the rating of articles",
// "Default article image width" => "Default article image width",
// "0 for original image size" => "0 for original image size",
// "Default article image height" => "Default article image height",
// "Custom attributes for article types" => "Custom attributes for article types",
// "Allow additional custom fields for article types" => "Allow additional custom fields for article types",
// "Your ShareThis publisher identifier (optional)" => "Your ShareThis publisher identifier (optional)",
// "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database" => "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database",
// "Tiki and OpenID" => "Tiki and OpenID",
// "Tiki and LDAP" => "Tiki and LDAP",
// "phpBB" => "phpBB",
// "Token Access" => "Token Access",
// "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service" => "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service",
// "Token Access Max Timeout" => "Token Access Max Timeout",
// "The maximum duration for which the generated tokens will be valid" => "The maximum duration for which the generated tokens will be valid",
// "Token Access Max Hits" => "Token Access Max Hits",
// "The maximum amount of times a token can be used before it expires" => "The maximum amount of times a token can be used before it expires",
// "Share access rights with friends when using Tell a friend" => "Share access rights with friends when using Tell a friend",
// "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site",
// "Share access rights with friends when using Share" => "Share access rights with friends when using Share",
// "Allow users to share their access rights on the current page with a friend when sending the link by email/twitter/facebook. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email/twitter/facebook. Lifespan of the links is defined by the site",
// "Create user if not in Tiki" => "Create user if not in Tiki",
// "Use Tiki authentication for Admin login" => "Use Tiki authentication for Admin login",
// "phpBB Version" => "phpBB Version",
// "phpBB Database Hostname" => "phpBB Database Hostname",
// "phpBB Database Username" => "phpBB Database Username",
// "phpBB Database Password" => "phpBB Database Password",
// "phpBB Database Name" => "phpBB Database Name",
// "phpBB Table Prefix" => "phpBB Table Prefix",
// "Use Tiki authentication for users created in tiki" => "Use Tiki authentication for users created in tiki",
// "Host" => "Host",
// "Write LDAP debug Information in Tiki Logs" => "Write LDAP debug Information in Tiki Logs",
// "Use SSL (ldaps)" => "Use SSL (ldaps)",
// "Use TLS" => "Use TLS",
// "LDAP Bind Type" => "LDAP Bind Type",
// "Default: Anonymous Bind" => "Default: Anonymous Bind",
// "Full: userattr=username,UserDN,BaseDN" => "Full: userattr=username,UserDN,BaseDN",
// "OpenLDAP: cn=username,BaseDN" => "OpenLDAP: cn=username,BaseDN",
// "Active Directory (username@domain)" => "Active Directory (username@domain)",
// "Plain Username" => "Plain Username",
// "Search scope" => "Search scope",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "LDAP version" => "LDAP version",
// "Base DN" => "Base DN",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Group DN" => "Group DN",
// "Group attribute" => "Group attribute",
// "Group description attribute" => "Group description attribute",
// "Group OC" => "Group OC",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "Group attribute in group entry" => "Group attribute in group entry",
// "(Leave this empty if the group name is already given in the user attribute)" => "(Leave this empty if the group name is already given in the user attribute)",
// "Admin user" => "Admin user",
// "Admin password" => "Admin password",
// "Disable Tiki users who doesn't have a phpBB login. (They could have been deleted)" => "Disable Tiki users who doesn't have a phpBB login. (They could have been deleted)",
// "Available languages" => "Available languages",
// "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset" => "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset",
// "Available styles" => "Available styles",
// "BigBlueButton" => "BigBlueButton",
// "Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "Integration with the BigBlueButton collaboration server for web conference and screen sharing",
// "BigBlueButton server location" => "BigBlueButton server location",
// "Full URL to the BigBlueButton installation" => "Full URL to the BigBlueButton installation",
// "http://host.example.com/" => "http://host.example.com/",
// "BigBlueButton server salt" => "BigBlueButton server salt",
// "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic" => "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic",
// "Default ordering" => "Default ordering",
// "Blogues" => "Blogues",
// "Custom Site Footer Content" => "Custom Site Footer Content",
// "Module (box) shadow start" => "Module (box) shadow start",
// "Module (box) shadow end" => "Module (box) shadow end",
// "Days to display in the Calendar" => "Days to display in the Calendar",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
// "First year in the dropdown" => "First year in the dropdown",
// "Enter a year or use +/- N to specify a year relative to the current year" => "Enter a year or use +/- N to specify a year relative to the current year",
// "Last year in the dropdown" => "Last year in the dropdown",
// "Sticky popup" => "Sticky popup",
// "Item view tab" => "Item view tab",
// "Show Add to Google Calendar icon" => "Show Add to Google Calendar icon",
// "Word length of the captcha image" => "Word length of the captcha image",
// "Default" => "Default",
// "Width of the captcha image in pixels" => "Width of the captcha image in pixels",
// "Level of noise of the captcha image" => "Level of noise of the captcha image",
// "Choose a smaller number for less noise and easier reading" => "Choose a smaller number for less noise and easier reading",
// "Use LDAP information when creating user in Tiki" => "Use LDAP information when creating user in Tiki",
// "Try automatically to connect SSO" => "Try automatically to connect SSO",
// "Force CAS logout when the user logout from tiki" => "Force CAS logout when the user logout from tiki",
// "Show Alternate Login Method in Header" => "Show Alternate Login Method in Header",
// "Hostname" => "Hostname",
// "Hostname of the CAS server" => "Hostname of the CAS server",
// "Port of the CAS server" => "Port of the CAS server",
// "Path for the CAS server" => "Path for the CAS server",
// "CAS Extra Parameter" => "CAS Extra Parameter",
// "Extra Parameter to pass to the CAS Server" => "Extra Parameter to pass to the CAS Server",
// "CAS Authentication Verification Timeout" => "CAS Authentication Verification Timeout",
// "Verify authentication with the CAS server every N seconds. Null value means never reverify" => "Verify authentication with the CAS server every N seconds. Null value means never reverify",
// "2 minutes" => "2 minutes",
// "Categories used in templates (TPL)" => "Categories used in templates (TPL)",
// "Permits to show alternate content depending on category of current object" => "Permits to show alternate content depending on category of current object",
// "Category Jail" => "Category Jail",
// "Limits the visibility of objects to those in these categories. Used mainly for creating workspaces from perspectives" => "Limits the visibility of objects to those in these categories. Used mainly for creating workspaces from perspectives",
// "Category Defaults" => "Category Defaults",
// "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default" => "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default",
// "One per line. ex:1,4,6,7/4" => "One per line. ex:1,4,6,7/4",
// "Synchronize multilingual categories" => "Synchronize multilingual categories",
// "Make sure that the categories on the translations are synchronized when modified on any version" => "Make sure that the categories on the translations are synchronized when modified on any version",
// "Only those specified" => "Only those specified",
// "All but those specified" => "All but those specified",
// "Synchronized categories" => "Synchronized categories",
// "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)" => "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)",
// "Automatically geocode items when categorized in" => "Automatically geocode items when categorized in",
// "Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "Automatically geocode items based on category name when categorized in the sub-categories of this category ID",
// "Replace existing geocode if any" => "Replace existing geocode if any",
// "When automatically geocoding items based on category name, replace existing geocode if any" => "When automatically geocoding items based on category name, replace existing geocode if any",
// "Use approximate geocode location" => "Use approximate geocode location",
// "When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "When automatically geocoding items based on category name, use randomly approximated location instead of precise location",
// "Exclude these categories" => "Exclude these categories",
// "Separate category IDs with a comma (,)" => "Separate category IDs with a comma (,)",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
// "Users can change site language" => "Users can change site language",
// "Allow users to change the language of the menus and labels" => "Allow users to change the language of the menus and labels",
// "Users can change their password" => "Users can change their password",
// "Disable title for comments" => "Disable title for comments",
// "Hide the title field on comments and their replies" => "Hide the title field on comments and their replies",
// "Email field" => "Email field",
// "Email field for comments (only for anonymous users)" => "Email field for comments (only for anonymous users)",
// "Website field" => "Website field",
// "Website field for comments (only for anonymous users)" => "Website field for comments (only for anonymous users)",
// "Use vote system for comments" => "Use vote system for comments",
// "Allows users with permission tiki_p_vote_comments to vote comments" => "Allows users with permission tiki_p_vote_comments to vote comments",
// "Allow anonymous visitors to use the \"Contact Us\" feature" => "Allow anonymous visitors to use the \"Contact Us\" feature",
// "Cookie name" => "Cookie name",
// "Domain" => "Domain",
// "Include pageviews by the Admin when reporting stats" => "Include pageviews by the Admin when reporting stats",
// "Enable daily reports for new users" => "Enable daily reports for new users",
// "Default charset for sending mail" => "Default charset for sending mail",
// "Default diff style" => "Default diff style",
// "Default number of rows for comment box" => "Default number of rows for comment box",
// "Forum reply" => "Forum reply",
// "Default Editor" => "Default Editor",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
// "Max. number of links around the current item" => "Max. number of links around the current item",
// "Max. number of links after the first or before the last item" => "Max. number of links after the first or before the last item",
// "Show the country flag" => "Show the country flag",
// "Enable cool sites" => "Enable cool sites",
// "Number of columns per page when listing directory categories" => "Number of columns per page when listing directory categories",
// "6" => "6",
// "Method to Open Directory Links" => "Method to Open Directory Links",
// "Re-validate user by email after" => "Re-validate user by email after",
// "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators" => "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators",
// "Collaboratively authored documents with history of changes" => "Collaboratively authored documents with history of changes",
// "Online diaries or journals" => "Online diaries or journals",
// "Collections of graphic images for viewing or downloading (photo album)" => "Collections of graphic images for viewing or downloading (photo album)",
// "You can use file galleries instead" => "You can use file galleries instead",
// "Machine Translation (by Google Translate)" => "Machine Translation (by Google Translate)",
// "Uses Google Translate to translate the content of wiki pages to other languages" => "Uses Google Translate to translate the content of wiki pages to other languages",
// "Experimental. This feature is still under development" => "Experimental. This feature is still under development",
// "Database & form generator" => "Database & form generator",
// "Online discussions on a variety of topics. Threaded or flat" => "Online discussions on a variety of topics. Threaded or flat",
// "Computer files, videos or software for downloading. With check-in & check-out (lock)" => "Computer files, videos or software for downloading. With check-in & check-out (lock)",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
// "Brief list of votable options; appears in module (left or right column)" => "Brief list of votable options; appears in module (left or right column)",
// "Content mailed to registered users" => "Content mailed to registered users",
// "Events calendar with public, private and group channels" => "Events calendar with public, private and group channels",
// "Insert, track, and manage advertising banners" => "Insert, track, and manage advertising banners",
// "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions" => "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions",
// "Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score is a game to motivate participants to increase their contribution by comparing to other users",
// "Tiki-indexed Search" => "Tiki-indexed Search",
// "Enables searching for content on the website, using Tiki-managed index" => "Enables searching for content on the website, using Tiki-managed index",
// "Unless you have a reason to, you should use MySQL Full-Text Search feature instead" => "Unless you have a reason to, you should use MySQL Full-Text Search feature instead",
// "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns" => "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns",
// "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis" => "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis",
// "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports" => "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports",
// "Enables internationalization features and multilingual support for then entire site" => "Enables internationalization features and multilingual support for then entire site",
// "Frequently asked questions and answers" => "Frequently asked questions and answers",
// "You can use wiki pages instead" => "You can use wiki pages instead",
// "Questionnaire with multiple choice or open ended question" => "Questionnaire with multiple choice or open ended question",
// "User-submitted Web links" => "User-submitted Web links",
// "Timed questionnaire with recorded scores" => "Timed questionnaire with recorded scores",
// "Simple menu system which can optionally add an external web page in an iframe" => "Simple menu system which can optionally add an external web page in an iframe",
// "The Copyright Management System (or ©MS) is a way of licensing your content" => "The Copyright Management System (or ©MS) is a way of licensing your content",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
// "Navigable, interactive maps with user-selectable layers" => "Navigable, interactive maps with user-selectable layers",
// "Requires mapserver" => "Requires mapserver",
// "Interactive use of Google Maps" => "Interactive use of Google Maps",
// "One-on-one chatting with customer" => "One-on-one chatting with customer",
// "Add a link \"Email this page\" in all the pages" => "Add a link \"Email this page\" in all the pages",
// "Share" => "Share",
// "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums" => "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums",
// "be careful when allowing to anonymous to activate the antibot feature" => "be careful when allowing to anonymous to activate the antibot feature",
// "HTML pages" => "HTML pages",
// "Static and dynamic HTML content" => "Static and dynamic HTML content",
// "HTML can be used in wiki pages. This is a separate feature" => "HTML can be used in wiki pages. This is a separate feature",
// "Basic form from visitor to admin" => "Basic form from visitor to admin",
// "Minichat" => "Minichat",
// "Real-time group text chatting" => "Real-time group text chatting",
// "Comments Moderation" => "Comments Moderation",
// "An admin must validate a comment before it is visible" => "An admin must validate a comment before it is visible",
// "Comments Locking" => "Comments Locking",
// "Comments can be closed (no new comments)" => "Comments can be closed (no new comments)",
// "Allow logged in users to pretend to be anonymous when posting a commment" => "Allow logged in users to pretend to be anonymous when posting a commment",
// "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally" => "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally",
// "Display page description" => "Display page description",
// "Display the page description below the heading when viewing the page" => "Display the page description below the heading when viewing the page",
// "Display page name as page title" => "Display page name as page title",
// "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header" => "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header",
// "Display page ID" => "Display page ID",
// "Display the internal page ID when viewing the page" => "Display the internal page ID when viewing the page",
// "Individual wiki cache" => "Individual wiki cache",
// "Allow users to change the duration of the cache on a per-page basis" => "Allow users to change the duration of the cache on a per-page basis",
// "JS Calendar" => "JS Calendar",
// "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled" => "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled",
// "Will eventually be removed from Tiki. Use CSS menus instead" => "Will eventually be removed from Tiki. Use CSS menus instead",
// "Output should be HTML Purified" => "Output should be HTML Purified",
// "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS" => "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS",
// "Full Screen" => "Full Screen",
// "CSS Menus" => "CSS Menus",
// "CSS Menus (suckerfish)" => "CSS Menus (suckerfish)",
// "Shadowbox / ColorBox" => "Shadowbox / ColorBox",
// "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>" => "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>",
// "Quick Permission Assignment" => "Quick Permission Assignment",
// "Quickperms allow to define classes of privileges and grant them to roles on objects" => "Quickperms allow to define classes of privileges and grant them to roles on objects",
// "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature" => "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature",
// "Outputs a WAP and VoiceXML version" => "Outputs a WAP and VoiceXML version",
// "Visualize relationships between wiki pages, in a 3D applet" => "Visualize relationships between wiki pages, in a 3D applet",
// "Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "Allows several Tiki sites (slaves) to get authentication from a master Tiki site",
// "Populate wiki pages and articles by email" => "Populate wiki pages and articles by email",
// "Mindmap" => "Mindmap",
// "Print Indexed" => "Print Indexed",
// "SpreadSheet" => "SpreadSheet",
// "Datasheets with calculations and charts" => "Datasheets with calculations and charts",
// "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor" => "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor",
// "Save draft" => "Save draft",
// "Experimental (Requires AJAX)" => "Experimental (Requires AJAX)",
// "Kaltura" => "Kaltura",
// "Collaborative video editing" => "Collaborative video editing",
// "Users can identify other users as their friends" => "Users can identify other users as their friends",
// "Neglected feature" => "Neglected feature",
// "Deny access to specific users based on username, IP, and date/time range" => "Deny access to specific users based on username, IP, and date/time range",
// "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)",
// "Action calendar" => "Action calendar",
// "Record domain name of sites that send visitors to this Tiki" => "Record domain name of sites that send visitors to this Tiki",
// "On error, goto the HomePage as configured in Admin->General" => "On error, goto the HomePage as configured in Admin->General",
// "Send/receive wiki pages and articles between Tiki-powered sites" => "Send/receive wiki pages and articles between Tiki-powered sites",
// "Group Watches" => "Group Watches",
// "User Watches Languages" => "User Watches Languages",
// "Watch language-specific changes within a category" => "Watch language-specific changes within a category",
// "Menu User Levels" => "Menu User Levels",
// "Allows to control the menu options that can be seen by a user" => "Allows to control the menu options that can be seen by a user",
// "Group Alert" => "Group Alert",
// "TikiTests" => "TikiTests",
// "Permits recording and playback of functional tests" => "Permits recording and playback of functional tests",
// "Check for updates automatically" => "Check for updates automatically",
// "Tiki will check for updates when you access the main Administration page" => "Tiki will check for updates when you access the main Administration page",
// "Use PEAR::Date library" => "Use PEAR::Date library",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
// "Lookup the user\\'s preferred language through browser preferences" => "Lookup the user\\'s preferred language through browser preferences",
// "Show pages in user\\'s preferred language" => "Show pages in user\\'s preferred language",
// "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page" => "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page",
// "Changing the page language also changes the site language" => "Changing the page language also changes the site language",
// "Translation assistant" => "Translation assistant",
// "Track translation operations between pages" => "Track translation operations between pages",
// "Urgent translation notifications" => "Urgent translation notifications",
// "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users" => "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users",
// "Only allow urgent translation from site language" => "Only allow urgent translation from site language",
// "Use the site language as a master language and prevent translations from sending critical updates" => "Use the site language as a master language and prevent translations from sending critical updates",
// "Incomplete translation notice" => "Incomplete translation notice",
// "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete" => "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete",
// "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures" => "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures",
// "Display all languages in a single page" => "Display all languages in a single page",
// "List all languages as a language option in the page language drop list to see all languages at once" => "List all languages as a language option in the page language drop list to see all languages at once",
// "GZip output" => "GZip output",
// "Compress your pages on-the-fly, if the requesting browser supports this" => "Compress your pages on-the-fly, if the requesting browser supports this",
// "Translation URLs" => "Translation URLs",
// "Show clickable URLs to translate the page to another language using Babel Fish website" => "Show clickable URLs to translate the page to another language using Babel Fish website",
// "Translation icons" => "Translation icons",
// "Show clickable icons to translate the page to another language using Babelfish website" => "Show clickable icons to translate the page to another language using Babelfish website",
// "Also known as emoticons" => "Also known as emoticons",
// "Bloc of content which can be reused and programmed (timed)" => "Bloc of content which can be reused and programmed (timed)",
// "Use File Galleries to store pictures" => "Use File Galleries to store pictures",
// "If disabled, pictures will be stored in ../img/wiki_up/.. instead" => "If disabled, pictures will be stored in ../img/wiki_up/.. instead",
// "External link icon" => "External link icon",
// "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon" => "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon",
// "Add \"rel=nofollow\" on external links" => "Add \"rel=nofollow\" on external links",
// "Semantic links" => "Semantic links",
// "Going beyond Backlinks, allows to define some semantic relationships between wiki pages" => "Going beyond Backlinks, allows to define some semantic relationships between wiki pages",
// "Web Services" => "Web Services",
// "Can consume webservices in JSON or YAML" => "Can consume webservices in JSON or YAML",
// "Breadcrumbs" => "Breadcrumbs",
// "Attempts to show you where you are" => "Attempts to show you where you are",
// "Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonymous editors must enter anti-bot code (CAPTCHA)",
// "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)",
// "Anonymous voting" => "Anonymous voting",
// "Allow re-voting" => "Allow re-voting",
// "Comments for polls" => "Comments for polls",
// "Comments for FAQs" => "Comments for FAQs",
// "If you are using Apache, you can rename _htaccess to .htaccess to get Short URLs" => "If you are using Apache, you can rename _htaccess to .htaccess to get Short URLs",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the sefurl" => "Display blog title in the sefurl",
// "Redirect tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "Redirect tiki-view_tracker.php?itemId=yyy to Prefixyyy page",
// "This redirection uses the wiki prefix alias feature" => "This redirection uses the wiki prefix alias feature",
// "Show module controls" => "Show module controls",
// "Perspectives" => "Perspectives",
// "Permits to override preferences" => "Permits to override preferences",
// "Permits find and replace of content in the edit box" => "Permits find and replace of content in the edit box",
// "Comments for articles" => "Comments for articles",
// "Pre-defined content for a wiki page" => "Pre-defined content for a wiki page",
// "Specify notification emails when creating articles" => "Specify notification emails when creating articles",
// "ShareThis buttons" => "ShareThis buttons",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
// "Show category tree, above wiki pages" => "Show category tree, above wiki pages",
// "Show category objects" => "Show category objects",
// "Show objects sharing the same category, below wiki pages" => "Show objects sharing the same category, below wiki pages",
// "Use PHPLayers for category browser" => "Use PHPLayers for category browser",
// "Will improve performance, but may show forbidden results" => "Will improve performance, but may show forbidden results",
// "MySQL Full-Text Search" => "MySQL Full-Text Search",
// "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated" => "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated",
// "Object filter" => "Object filter",
// "Pertinence" => "Pertinence",
// "Last modified date" => "Last modified date",
// "Custom blog headings" => "Custom blog headings",
// "Publish dates can be modified" => "Publish dates can be modified",
// "Comments on blog posts" => "Comments on blog posts",
// "File Gallery Comments" => "File Gallery Comments",
// "Batch uploading" => "Batch uploading",
// "Topic archiving" => "Topic archiving",
// "Quick jumps" => "Quick jumps",
// "Replies are empty" => "Replies are empty",
// "If disabled, replies will quote the original post" => "If disabled, replies will quote the original post",
// "First post of a thread can have an empty body" => "First post of a thread can have an empty body",
// "Will be a thread title" => "Will be a thread title",
// "Forum name search" => "Forum name search",
// "When listing forums" => "When listing forums",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Tiki-indexed search" => "Tiki-indexed search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Store password as plain text" => "Store password as plain text",
// "Encryption method" => "Encryption method",
// "Assign different themes to different sections, categories, and objects" => "Assign different themes to different sections, categories, and objects",
// "Custom Doctype" => "Custom Doctype",
// "Use custom !DOCTYPE" => "Use custom !DOCTYPE",
// "Custom Doctype Content" => "Custom Doctype Content",
// "Use to generate the Tiki layout with custom &lt;!DOCTYPE&gt; specified" => "Use to generate the Tiki layout with custom &lt;!DOCTYPE&gt; specified",
// "Custom HTML <head> Content" => "Custom HTML <head> Content",
// "Use to include custom &lt;meta&gt; or &lt;link&gt; tags" => "Use to include custom &lt;meta&gt; or &lt;link&gt; tags",
// "Add BASE tag in the page HEAD" => "Add BASE tag in the page HEAD",
// "The &lt;base&gt; tag specifies a default address for all links on a page" => "The &lt;base&gt; tag specifies a default address for all links on a page",
// "Site Logo and Title" => "Site Logo and Title",
// "Search Bar" => "Search Bar",
// "Login Bar" => "Login Bar",
// "Top Bar Custom Code" => "Top Bar Custom Code",
// "Display current Tiki version" => "Display current Tiki version",
// "Site menu custom code" => "Site menu custom code",
// "Secondary site menu custom code" => "Secondary site menu custom code",
// "Needs either CSS Menus or PHPLayers" => "Needs either CSS Menus or PHPLayers",
// "Custom Center Column Header" => "Custom Center Column Header",
// "Controls visibility of the left column of modules" => "Controls visibility of the left column of modules",
// "side bar" => "side bar",
// "Only if module" => "Only if module",
// "User Decides" => "User Decides",
// "Right Column" => "Right Column",
// "Controls visibility of the right column of modules" => "Controls visibility of the right column of modules",
// "Prefix breadcrumbs with \"Location : \"" => "Prefix breadcrumbs with \"Location : \"",
// "Top of page" => "Top of page",
// "Top of center column" => "Top of center column",
// "Entire location" => "Entire location",
// "Custom End of <body> Code" => "Custom End of <body> Code",
// "Indicate various debug-related information in the footer of the site (Execution time, Memory usage, etc.)" => "Indicate various debug-related information in the footer of the site (Execution time, Memory usage, etc.)",
// "Bottom bar (RSS)" => "Bottom bar (RSS)",
// "Leave blank to use the default sender email" => "Leave blank to use the default sender email",
// "Add a link at the bottom if set, otherwise add a link at the top" => "Add a link at the bottom if set, otherwise add a link at the top",
// "Shadow layer" => "Shadow layer",
// "Additional layers for shadows, rounded corners or other decorative styling" => "Additional layers for shadows, rounded corners or other decorative styling",
// "Tooltips" => "Tooltips",
// "Make tooltips such as this appear in a custom style. Use CSS to change their appearance" => "Make tooltips such as this appear in a custom style. Use CSS to change their appearance",
// "Autocomplete" => "Autocomplete",
// "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc" => "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc",
// "Superfish" => "Superfish",
// "Adds animation effects to CSS \"Suckerfish\" menus" => "Adds animation effects to CSS \"Suckerfish\" menus",
// "Reflection" => "Reflection",
// "Allows images to have a reflection effect below them. See the admin icons above for an example" => "Allows images to have a reflection effect below them. See the admin icons above for an example",
// "JQuery UI" => "JQuery UI",
// "Include jQuery UI library. Enables many user interface features" => "Include jQuery UI library. Enables many user interface features",
// "JQuery UI Theme" => "JQuery UI Theme",
// "jQuery UI Theme. Used in spreadsheet, for example" => "jQuery UI Theme. Used in spreadsheet, for example",
// "Validation" => "Validation",
// "Provides various validation possibilities like in Trackers" => "Provides various validation possibilities like in Trackers",
// "JQuery JQS5" => "JQuery JQS5",
// "jQuery Simple Standards-Based Slide Show System" => "jQuery Simple Standards-Based Slide Show System",
// "JQuery Infinite Carousel" => "JQuery Infinite Carousel",
// "Image \"carousel\" plugin (coming soon)" => "Image \"carousel\" plugin (coming soon)",
// "JQuery Sortable Tables" => "JQuery Sortable Tables",
// "Sort in fancytable plugin" => "Sort in fancytable plugin",
// "JQuery Media" => "JQuery Media",
// "Media player" => "Media player",
// "Correct PNG images alpha transparency in IE6 (experimental)" => "Correct PNG images alpha transparency in IE6 (experimental)",
// "Tiki will warn users who attempt to edit a page that another user is currenly editing" => "Tiki will warn users who attempt to edit a page that another user is currenly editing",
// "Create private notes for a page that are visible only by the author" => "Create private notes for a page that are visible only by the author",
// "Log bytes changes (+/-) in action logs" => "Log bytes changes (+/-) in action logs",
// "May impact performance" => "May impact performance",
// "A special wiki page for testing. Users can edit, but not save the Sandbox" => "A special wiki page for testing. Users can edit, but not save the Sandbox",
// "Comments below wiki pages" => "Comments below wiki pages",
// "Allow users (with permission) to post threaded comments to a page" => "Allow users (with permission) to post threaded comments to a page",
// "Allow users to upload images (pictures) to a page" => "Allow users to upload images (pictures) to a page",
// "WikiWords" => "WikiWords",
// "Automatically convert words with UpPeR and LoWeR-case letters into wiki links" => "Automatically convert words with UpPeR and LoWeR-case letters into wiki links",
// "Display IP address" => "Display IP address",
// "History all instead of only page data, description, and change comment" => "History all instead of only page data, description, and change comment",
// "View page contributions by author" => "View page contributions by author",
// "Visualize the contributions of different authors made to a wiki page" => "Visualize the contributions of different authors made to a wiki page",
// "Include a link on each page to a forum topic" => "Include a link on each page to a forum topic",
// "View source" => "View source",
// "Similar (like pages)" => "Similar (like pages)",
// "Import pages" => "Import pages",
// "A personal page for the user to manage" => "A personal page for the user to manage",
// "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty" => "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty",
// "Users can lock pages" => "Users can lock pages",
// "This feature is experimental" => "This feature is experimental",
// "Allows wiki pages to be staged (drafted) before they are approved (published)" => "Allows wiki pages to be staged (drafted) before they are approved (published)",
// "Pages not in structure" => "Pages not in structure",
// "Allow users to upload (attach) files to a page" => "Allow users to upload (attach) files to a page",
// "Display show/hide icon displayed before headings" => "Display show/hide icon displayed before headings",
// "Metrics Dashboard" => "Metrics Dashboard",
// "Generate automated statistics from configured database queries" => "Generate automated statistics from configured database queries",
// "Wiki argument variables" => "Wiki argument variables",
// "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}",
// "Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirm that the Admin account has a valid email address or you will not be permitted to login",
// "Users can choose to stay in SSL mode after an HTTPS login" => "Users can choose to stay in SSL mode after an HTTPS login",
// "Users can switch between secured or standard mode at login" => "Users can switch between secured or standard mode at login",
// "Wiki paragraph formatting" => "Wiki paragraph formatting",
// "...but still create line breaks within paragraphs" => "...but still create line breaks within paragraphs",
// "Tiki will automatically convert http:// and email addresses into links" => "Tiki will automatically convert http:// and email addresses into links",
// "Open Hotwords in new window" => "Open Hotwords in new window",
// "Use Quote plugin rather than \">\" for quoting" => "Use Quote plugin rather than \">\" for quoting",
// "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator" => "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator",
// "Users can choose to show their gender" => "Users can choose to show their gender",
// "Real name" => "Real name",
// "Picture (avatar)" => "Picture (avatar)",
// "Manual selection of time/date" => "Manual selection of time/date",
// "WebDAV access to Tiki" => "WebDAV access to Tiki",
// "Allow to access File Galleries with WebDAV" => "Allow to access File Galleries with WebDAV",
// "use tiki-webdav.php as the URI of the WebDAV repository" => "use tiki-webdav.php as the URI of the WebDAV repository",
// "Fixed width" => "Fixed width",
// "Constrains the site display to 990px wide" => "Constrains the site display to 990px wide",
// "You can modify at styles/layout/layout.css - selector #fixedwidth" => "You can modify at styles/layout/layout.css - selector #fixedwidth",
// "Social networks" => "Social networks",
// "Integration with different social networks like Twitter or Facebook" => "Integration with different social networks like Twitter or Facebook",
// "Group Transition" => "Group Transition",
// "Enables transitions for users between different groups. Transitions will create a user approval workflow" => "Enables transitions for users between different groups. Transitions will create a user approval workflow",
// "Category Transition" => "Category Transition",
// "Enables transitions on objects between different categories. Transitions will create a document workflow" => "Enables transitions on objects between different categories. Transitions will create a document workflow",
// "Ustream Watershed" => "Ustream Watershed",
// "Integration to Ustream Watershed live video streaming" => "Integration to Ustream Watershed live video streaming",
// "Tiki User Credits" => "Tiki User Credits",
// "Invite users" => "Invite users",
// "Allow users to invite new users by mail to register on this tiki" => "Allow users to invite new users by mail to register on this tiki",
// "Load Balancer" => "Load Balancer",
// "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server" => "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server",
// "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications" => "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications",
// "Show user's contribution on the user information page" => "Show user's contribution on the user information page",
// "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'" => "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'",
// "Require file author's name for anonymous uploads" => "Require file author's name for anonymous uploads",
// "Add a Powered by Tiki link on your site's footer" => "Add a Powered by Tiki link on your site's footer",
// "Redirect to similar wiki page" => "Redirect to similar wiki page",
// "If a requested page doesn't exist, redirect to a similarly named page" => "If a requested page doesn't exist, redirect to a similarly named page",
// "User's page" => "User's page",
// "Show user's information on mouseover" => "Show user's information on mouseover",
// "Requires user's information to be public" => "Requires user's information to be public",
// "Default feed format" => "Default feed format",
// "ATOM 1.0" => "ATOM 1.0",
// "RSS 2.0" => "RSS 2.0",
// "Feed author name" => "Feed author name",
// "This field is mandatory unless both feed author email and homepage are empty" => "This field is mandatory unless both feed author email and homepage are empty",
// "Feeed author email" => "Feeed author email",
// "Feed author homepage" => "Feed author homepage",
// "Feed editor email" => "Feed editor email",
// "Email address for person responsible for editorial content" => "Email address for person responsible for editorial content",
// "Feed webmaster email" => "Feed webmaster email",
// "Email address for person responsible for technical issues relating to channel" => "Email address for person responsible for technical issues relating to channel",
// "Image path" => "Image path",
// "Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "Specifies a GIF, JPEG or PNG image that can be displayed with the feed",
// "RSS basic Authentication" => "RSS basic Authentication",
// "Propose basic http authentication if the user has no permission to see the feed" => "Propose basic http authentication if the user has no permission to see the feed",
// "Caching time" => "Caching time",
// "Use 0 for no caching" => "Use 0 for no caching",
// "RSS feeds for articles" => "RSS feeds for articles",
// "RSS feeds for blogs" => "RSS feeds for blogs",
// "Individual Blogs" => "Individual Blogs",
// "RSS feed for individual blogs" => "RSS feed for individual blogs",
// "RSS feed for image galleries" => "RSS feed for image galleries",
// "Individual Image galleries" => "Individual Image galleries",
// "RSS feed for individual image galleries" => "RSS feed for individual image galleries",
// "RSS feed for file galleries" => "RSS feed for file galleries",
// "Individual file galleries" => "Individual file galleries",
// "RSS feed for individual file galleries" => "RSS feed for individual file galleries",
// "RSS feed for wiki" => "RSS feed for wiki",
// "RSS feed for forums" => "RSS feed for forums",
// "Individual Forums" => "Individual Forums",
// "RSS feed for individual forums" => "RSS feed for individual forums",
// "RSS feed for trackers" => "RSS feed for trackers",
// "Individual trackers items" => "Individual trackers items",
// "RSS feed for individual trackers items" => "RSS feed for individual trackers items",
// "RSS feed for calendar events" => "RSS feed for calendar events",
// "RSS feed for directories" => "RSS feed for directories",
// "RSS feed for maps" => "RSS feed for maps",
// "RSS feed for shoutbox" => "RSS feed for shoutbox",
// "Show Author" => "Show Author",
// "Homepage URL" => "Homepage URL",
// "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used",
// "Article RSS Description" => "Article RSS Description",
// "Description to be published as part of the RSS feed for articles" => "Description to be published as part of the RSS feed for articles",
// "Blogs RSS Description" => "Blogs RSS Description",
// "Description to be published as part of the RSS feed for blogs" => "Description to be published as part of the RSS feed for blogs",
// "Blog RSS Description" => "Blog RSS Description",
// "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used" => "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used",
// "Image galleries RSS Description" => "Image galleries RSS Description",
// "Description to be published as part of the RSS feed for image galleries" => "Description to be published as part of the RSS feed for image galleries",
// "Individual image galleries RSS Description" => "Individual image galleries RSS Description",
// "Description to be published as part of the RSS feed for individual image galleries" => "Description to be published as part of the RSS feed for individual image galleries",
// "File galleries RSS Description" => "File galleries RSS Description",
// "Description to be published as part of the RSS feed for file galleries" => "Description to be published as part of the RSS feed for file galleries",
// "Individual file galleries RSS Description" => "Individual file galleries RSS Description",
// "Description to be published as part of the RSS feed for individual file galleries" => "Description to be published as part of the RSS feed for individual file galleries",
// "Wiki pages RSS Description" => "Wiki pages RSS Description",
// "Description to be published as part of the RSS feed for wiki pages" => "Description to be published as part of the RSS feed for wiki pages",
// "Forums RSS Description" => "Forums RSS Description",
// "Description to be published as part of the RSS feed for forums" => "Description to be published as part of the RSS feed for forums",
// "Individual forums RSS Description" => "Individual forums RSS Description",
// "Description to be published as part of the RSS feed for individual forums" => "Description to be published as part of the RSS feed for individual forums",
// "Trackers RSS Description" => "Trackers RSS Description",
// "Description to be published as part of the RSS feed for trackers" => "Description to be published as part of the RSS feed for trackers",
// "Individual trackers RSS Description" => "Individual trackers RSS Description",
// "Description to be published as part of the RSS feed for individual trackers" => "Description to be published as part of the RSS feed for individual trackers",
// "Calendar events RSS Description" => "Calendar events RSS Description",
// "Description to be published as part of the RSS feed for calendar events" => "Description to be published as part of the RSS feed for calendar events",
// "Directories RSS Description" => "Directories RSS Description",
// "Description to be published as part of the RSS feed for directories" => "Description to be published as part of the RSS feed for directories",
// "Maps RSS Description" => "Maps RSS Description",
// "Description to be published as part of the RSS feed for maps" => "Description to be published as part of the RSS feed for maps",
// "Shoutbox RSS Description" => "Shoutbox RSS Description",
// "Description to be published as part of the RSS feed for shoutbox messages" => "Description to be published as part of the RSS feed for shoutbox messages",
// "Podcast directory" => "Podcast directory",
// "Required for podcasts" => "Required for podcasts",
// "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols",
// "The server must be able to read the directory" => "The server must be able to read the directory",
// "Prevent download if score becomes negative" => "Prevent download if score becomes negative",
// "Allow download limit per file" => "Allow download limit per file",
// "Must match" => "Must match",
// "Cannot match" => "Cannot match",
// "Quota for all the files and archives" => "Quota for all the files and archives",
// "(0 for unlimited)" => "(0 for unlimited)",
// "Quota can be defined for each file gallery" => "Quota can be defined for each file gallery",
// "Default quota for each new gallery" => "Default quota for each new gallery",
// "Show quota bar in the list page" => "Show quota bar in the list page",
// "Store in database" => "Store in database",
// "Store in directory" => "Store in directory",
// "Include the search box on the current gallery files just after the find div" => "Include the search box on the current gallery files just after the find div",
// "Include a search box on file galleries" => "Include a search box on file galleries",
// "Automatic deletion of old files" => "Automatic deletion of old files",
// "The user will have an option when uploading a file to specify the time after which the file is deleted" => "The user will have an option when uploading a file to specify the time after which the file is deleted",
// "Deletion emails notification" => "Deletion emails notification",
// "These emails will receive a copy of each deleted file. Emails are separated with comma" => "These emails will receive a copy of each deleted file. Emails are separated with comma",
// "Keep fileId for archives" => "Keep fileId for archives",
// "Keep always the same fileId when replacing a file with archive" => "Keep always the same fileId when replacing a file with archive",
// "Show thumbnail actions" => "Show thumbnail actions",
// "Show the checkbox and wrench icon for file actions menu when not displaying details" => "Show the checkbox and wrench icon for file actions menu when not displaying details",
// "Max thumbnail size" => "Max thumbnail size",
// "Maximum width or height for image thumbnails" => "Maximum width or height for image thumbnails",
// "In pixels" => "In pixels",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "Display thread configuration bar only when number of posts exceed" => "Display thread configuration bar only when number of posts exceed",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Default style" => "Default style",
// "Default sort mode" => "Default sort mode",
// "Description length" => "Description length",
// "Hide titles for forum threads" => "Hide titles for forum threads",
// "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display" => "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display",
// "Do not prefix messages titles by 'Re: '" => "Do not prefix messages titles by 'Re: '",
// "Multilingual tags" => "Multilingual tags",
// "Permits translation management of tags" => "Permits translation management of tags",
// "Show tag cloud" => "Show tag cloud",
// "Maximum number of tags in cloud" => "Maximum number of tags in cloud",
// "Show freetags in middle column" => "Show freetags in middle column",
// "Preload freetag random tag" => "Preload freetag random tag",
// "Number of Tags to show in Tag Suggestions" => "Number of Tags to show in Tag Suggestions",
// "Valid characters pattern" => "Valid characters pattern",
// "Lowercase tags only" => "Lowercase tags only",
// "Enable freetags 3D browser" => "Enable freetags 3D browser",
// "3D autoload" => "3D autoload",
// "Include \"Generate Password\" option on registration form" => "Include \"Generate Password\" option on registration form",
// "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes" => "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes",
// "Label visible in the browser\\'s title bar on all pages. Also appears in search engines" => "Label visible in the browser\\'s title bar on all pages. Also appears in search engines",
// "Validate new user registrations by email" => "Validate new user registrations by email",
// "Upon registration, the new user will receive an email containing a link to confirm validity" => "Upon registration, the new user will receive an email containing a link to confirm validity",
// "Landing page used for the wiki when no page is specified. The page will be created if it does not exist" => "Landing page used for the wiki when no page is specified. The page will be created if it does not exist",
// "Users can be sent to different pages upon login, depending on their default group" => "Users can be sent to different pages upon login, depending on their default group",
// "Default language" => "Default language",
// "Site language used when no other language is specified by the user" => "Site language used when no other language is specified by the user",
// "Cache external pages" => "Cache external pages",
// "Cache external images" => "Cache external images",
// "Tiki requires full read and write access to this directory" => "Tiki requires full read and write access to this directory",
// "The default help system may not be complete. You can help with the Tiki documentation" => "The default help system may not be complete. You can help with the Tiki documentation",
// "License page" => "License page",
// "Submit notice" => "Submit notice",
// "[-180 180]" => "[-180 180]",
// "[0 360]" => "[0 360]",
// "Hide anonymous-only modules from Admins" => "Hide anonymous-only modules from Admins",
// "Maximum number of articles on articles home page" => "Maximum number of articles on articles home page",
// "Site Ads and Banners Content" => "Site Ads and Banners Content",
// "URL to go to when clicking on a username" => "URL to go to when clicking on a username",
// "Use %user% for login name and %userId% for userId)" => "Use %user% for login name and %userId% for userId)",
// "Remind/forgot password" => "Remind/forgot password",
// "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user" => "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user",
// "If passwords <em>are stored</em> as plain text, the password will be emailed to the user" => "If passwords <em>are stored</em> as plain text, the password will be emailed to the user",
// "Each group can have its theme" => "Each group can have its theme",
// "Custom Site Header Content" => "Custom Site Header Content",
// "Site title" => "Site title",
// "Maximum number of versions" => "Maximum number of versions",
// "0 for unlimited versions" => "0 for unlimited versions",
// "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "Require validation by Admin" => "Require validation by Admin",
// "The administrator will receive an email for each new user registration, and must validate the user before the user can login" => "The administrator will receive an email for each new user registration, and must validate the user before the user can login",
// "Require passcode to register" => "Require passcode to register",
// "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only" => "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only",
// "Passcode" => "Passcode",
// "Alphanumeric code requierd to complete the registration" => "Alphanumeric code requierd to complete the registration",
// "Use tracker to collect more user information" => "Use tracker to collect more user information",
// "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user" => "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user",
// "Use the \"Admin Groups\" page to select which tracker and fields to display" => "Use the \"Admin Groups\" page to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Create a new group for each user" => "Create a new group for each user",
// "Use different URL as homepage" => "Use different URL as homepage",
// "Use URL Index" => "Use URL Index",
// "Use a Tiki feature homepage or another homepage" => "Use a Tiki feature homepage or another homepage",
// "Use Tiki feature as homepage" => "Use Tiki feature as homepage",
// "Select the Tiki feature to use as the site homepage. Only enabled features are listed" => "Select the Tiki feature to use as the site homepage. Only enabled features are listed",
// "Disable JavaScript" => "Disable JavaScript",
// "Disable JavaScript for testing purpose even if the browser allows it" => "Disable JavaScript for testing purpose even if the browser allows it",
// "Partner ID" => "Partner ID",
// "Kaltura Partner ID" => "Kaltura Partner ID",
// "User secret" => "User secret",
// "Kaltura partner setting user secret" => "Kaltura partner setting user secret",
// "Admin secret" => "Admin secret",
// "Kaltura partner setting admin secret" => "Kaltura partner setting admin secret",
// "KDP UI Configuration ID" => "KDP UI Configuration ID",
// "Kaltura Dynamic Player (KDP) user interface configuration ID" => "Kaltura Dynamic Player (KDP) user interface configuration ID",
// "KDP Widget ID" => "KDP Widget ID",
// "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account" => "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account",
// "KCW UI Configuration ID" => "KCW UI Configuration ID",
// "Kaltura Configuration Wizard (KCW) user interface configuration ID" => "Kaltura Configuration Wizard (KCW) user interface configuration ID",
// "Kaltura Simple Editor UI Configuration ID" => "Kaltura Simple Editor UI Configuration ID",
// "Kaltura Advanced Editor UI Configuration ID" => "Kaltura Advanced Editor UI Configuration ID",
// "Kaltura \"User\"" => "Kaltura \"User\"",
// "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries" => "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries",
// "Kaltura Service URL" => "Kaltura Service URL",
// "e.g. http://www.kaltura.com/" => "e.g. http://www.kaltura.com/",
// "Set blogs homepage first" => "Set blogs homepage first",
// "Set Image gal homepage first" => "Set Image gal homepage first",
// "Set Forum homepage first" => "Set Forum homepage first",
// "Validate user's email server" => "Validate user's email server",
// "The group will be named identical to the user's username" => "The group will be named identical to the user's username",
// "If you don't know better, use '_yourPartnerID'" => "If you don't know better, use '_yourPartnerID'",
// "You could use your server name for this. e.g. \$url_host" => "You could use your server name for this. e.g. \$url_host",
// "Google Maps API Key" => "Google Maps API Key",
// "Default y for map center" => "Default y for map center",
// "village size" => "village size",
// "Show map mode buttons in articles list" => "Show map mode buttons in articles list",
// "Show map mode buttons in page list" => "Show map mode buttons in page list",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
// "Custom CSS" => "Custom CSS",
// "Includes a custom block of CSS inline in all pages" => "Includes a custom block of CSS inline in all pages",
// "Custom JavaScript" => "Custom JavaScript",
// "Includes a custom block of inline JavaScript in all pages" => "Includes a custom block of inline JavaScript in all pages",
// "Highlight group" => "Highlight group",
// "Home File Gallery (main file gallery)" => "Home File Gallery (main file gallery)",
// "No image gallery available (create one first)" => "No image gallery available (create one first)",
// "No file gallery available (create one first)" => "No file gallery available (create one first)",
// "No forum available (create one first)" => "No forum available (create one first)",
// "No blog available (create one first)" => "No blog available (create one first)",
// "Use HTTPS when building user-specific links" => "Use HTTPS when building user-specific links",
// "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
// "Use HTTPS login" => "Use HTTPS login",
// "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server" => "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server",
// "CSS selectors to be fixed" => "CSS selectors to be fixed",
// "Separate multiple elements with a comma (,)" => "Separate multiple elements with a comma (,)",
// "HTMLDomElements to be fixed" => "HTMLDomElements to be fixed",
// "Use CDN for JavaScript" => "Use CDN for JavaScript",
// "Obtain jQuery and jQuery UI libraries through a content delivery network" => "Obtain jQuery and jQuery UI libraries through a content delivery network",
// "Google" => "Google",
// "Slide" => "Slide",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Effect for modules" => "Effect for modules",
// "Effect for tabs" => "Effect for tabs",
// "Speed" => "Speed",
// "Fast" => "Fast",
// "Slow" => "Slow",
// "Never delete versions younger than" => "Never delete versions younger than",
// "Use the database to store the translated strings and allow using interactive translation" => "Use the database to store the translated strings and allow using interactive translation",
// "Language inclusion threshold" => "Language inclusion threshold",
// "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages",
// "Create user if not in LDAP" => "Create user if not in LDAP",
// "Maximum average server load threshold in the last minute" => "Maximum average server load threshold in the last minute",
// "Log mail in Tiki logs" => "Log mail in Tiki logs",
// "Use only for development, not in production because these warnings are added to emails as well, and visible to the users" => "Use only for development, not in production because these warnings are added to emails as well, and visible to the users",
// "You need to clear your Tiki template cache for this change to take effect" => "You need to clear your Tiki template cache for this change to take effect",
// "Log SQL" => "Log SQL",
// "Log SQL queries" => "Log SQL queries",
// "Log queries using more than (seconds)" => "Log queries using more than (seconds)",
// "This may impact performance" => "This may impact performance",
// "Use email as username" => "Use email as username",
// "Instead of creating new usernames, use the user\\'s email address for authentication" => "Instead of creating new usernames, use the user\\'s email address for authentication",
// "Obscure email when using email as username if possible (coverage will not be complete)" => "Obscure email when using email as username if possible (coverage will not be complete)",
// "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead" => "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead",
// "%A %d of %B, %Y %H:%M:%S %Z" => "%A %d of %B, %Y %H:%M:%S %Z",
// "Force lowercase" => "Force lowercase",
// "Mail end of line" => "Mail end of line",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
// "Maximum length" => "Maximum length",
// "Memcache" => "Memcache",
// "Enable connection to memcached servers to store temporary information" => "Enable connection to memcached servers to store temporary information",
// "Requires the PHP memcache extension" => "Requires the PHP memcache extension",
// "Memcache compression" => "Memcache compression",
// "Enable compression for memcache storage" => "Enable compression for memcache storage",
// "Memcache servers" => "Memcache servers",
// "Server list which may be accessed. For each server, the address, port and weight must be specified" => "Server list which may be accessed. For each server, the address, port and weight must be specified",
// "One per line. address:port (weight)" => "One per line. address:port (weight)",
// "Memcache key prefix" => "Memcache key prefix",
// "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts" => "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts",
// "Memcache expiration" => "Memcache expiration",
// "Duration for which the data will be kept" => "Duration for which the data will be kept",
// "Cache wiki data in memcache" => "Cache wiki data in memcache",
// "Cache wiki output in memcache" => "Cache wiki output in memcache",
// "Cache forum output in memcache" => "Cache forum output in memcache",
// "Menu icons" => "Menu icons",
// "Allows to define icons for menu entries" => "Allows to define icons for menu entries",
// "Default path for the icons" => "Default path for the icons",
// "Allow HTML in link text and do not escape the url in menu items (Please note: this might be insecure if you allow more people to edit menus)" => "Allow HTML in link text and do not escape the url in menu items (Please note: this might be insecure if you allow more people to edit menus)",
// "If enabled, menu item names treated as HTML item content and they are not escaped (do not replace HTML special characters), this allows the use of HTML in menu items to insert images for example, and menu item urls are not escaped which allows the use of permissable href tags. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing" => "If enabled, menu item names treated as HTML item content and they are not escaped (do not replace HTML special characters), this allows the use of HTML in menu items to insert images for example, and menu item urls are not escaped which allows the use of permissable href tags. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing",
// "Keywords" => "Keywords",
// "Include freetags" => "Include freetags",
// "Use thread title instead" => "Use thread title instead",
// "Use image title instead" => "Use image title instead",
// "Use individual page description for Wiki pages instead" => "Use individual page description for Wiki pages instead",
// "Meta robots" => "Meta robots",
// "Revisit after" => "Revisit after",
// "Show past metrics results" => "Show past metrics results",
// "In the metrics dashboard, identify if the previously collected metrics should be displayed" => "In the metrics dashboard, identify if the previously collected metrics should be displayed",
// "Past metrics count" => "Past metrics count",
// "Amount of past results to display" => "Amount of past results to display",
// "No metric trend value" => "No metric trend value",
// "Value to display when no trend is available for the metric" => "Value to display when no trend is available for the metric",
// "Metric trend prefix" => "Metric trend prefix",
// "Portion of text to display before the metric trend value" => "Portion of text to display before the metric trend value",
// "Metric trend suffix" => "Metric trend suffix",
// "Portion of text to display after the metric trend value" => "Portion of text to display after the metric trend value",
// "Metric name length" => "Metric name length",
// "Metric tab name length" => "Metric tab name length",
// "Cache metrics output" => "Cache metrics output",
// "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended" => "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
// "Minimum length" => "Minimum length",
// "\"More Like This\" algorithm" => "\"More Like This\" algorithm",
// "Basic" => "Basic",
// "Weighted" => "Weighted",
// "Minimum amount of tags in common" => "Minimum amount of tags in common",
// "7" => "7",
// "8" => "8",
// "9" => "9",
// "10" => "10",
// "Multi-domain" => "Multi-domain",
// "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance" => "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance",
// "Multi-domain Configuration" => "Multi-domain Configuration",
// "Comma-separated values mapping the domain name to the perspective ID" => "Comma-separated values mapping the domain name to the perspective ID",
// "One domain per line. Comma separated with perspective ID. Ex.: tiki.org,1" => "One domain per line. Comma separated with perspective ID. Ex.: tiki.org,1",
// "Wiki buttons" => "Wiki buttons",
// "Page description, icons, backlinks, .." => "Page description, icons, backlinks, ..",
// "Top " => "Top ",
// "Neither" => "Neither",
// "A page can occur multiple times in a structure" => "A page can occur multiple times in a structure",
// "Hide pagination when there is only one page" => "Hide pagination when there is only one page",
// "Require characters and numerals" => "Require characters and numerals",
// "For improved security, require users to include a mix of characters and numerals in passwords" => "For improved security, require users to include a mix of characters and numerals in passwords",
// "Password expires after" => "Password expires after",
// "Payment" => "Payment",
// "Feature to manage and track payment requests" => "Feature to manage and track payment requests",
// "Payment System" => "Payment System",
// "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits",
// "PayPal: see PayPal.com - Cclite: Community currency" => "PayPal: see PayPal.com - Cclite: Community currency",
// "PayPal" => "PayPal",
// "Cclite" => "Cclite",
// "Paypal Business ID" => "Paypal Business ID",
// "Enable payments through paypal" => "Enable payments through paypal",
// "Paypal Environment" => "Paypal Environment",
// "Used to switch between the paypal sandbox, used for testing and development and the live environment" => "Used to switch between the paypal sandbox, used for testing and development and the live environment",
// "Production" => "Production",
// "Paypal Instant Payment Notification (IPN)" => "Paypal Instant Payment Notification (IPN)",
// "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server" => "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server",
// "Currency" => "Currency",
// "Currency used when entering payments" => "Currency used when entering payments",
// "Default acceptable payment delay" => "Default acceptable payment delay",
// "Amount of days before the payment requests becomes overdue. This can be changed per payment request" => "Amount of days before the payment requests becomes overdue. This can be changed per payment request",
// "Cclite Registries" => "Cclite Registries",
// "Registries in Cclite. Use comma to separate. e.g. \"dogtown, chelsea, dalston, etc\"" => "Registries in Cclite. Use comma to separate. e.g. \"dogtown, chelsea, dalston, etc\"",
// "Registry names in Cclite" => "Registry names in Cclite",
// "Cclite Registry Currencies" => "Cclite Registry Currencies",
// "Currencies in Cclite. Use comma to separate. e.g. \"woof, ducket, ducket, etc\"" => "Currencies in Cclite. Use comma to separate. e.g. \"woof, ducket, ducket, etc\"",
// "Each registry in Cclite can have it\\'s own currency. Must be one per registry. (case sensitive)" => "Each registry in Cclite can have it\\'s own currency. Must be one per registry. (case sensitive)",
// "Cclite Server URL" => "Cclite Server URL",
// "Full URL of the repository" => "Full URL of the repository",
// "e.g. https://cclite.yourdomain.org/cclite/" => "e.g. https://cclite.yourdomain.org/cclite/",
// "Cclite Merchant Key" => "Cclite Merchant Key",
// "Corresponds with Merchant Key setting in Cclite" => "Corresponds with Merchant Key setting in Cclite",
// "Cclite Merchant User" => "Cclite Merchant User",
// "User name in Cclite representing \"the management\". Defaults to \"manager\"" => "User name in Cclite representing \"the management\". Defaults to \"manager\"",
// "Cclite Enable Payments" => "Cclite Enable Payments",
// "Test or Live operation" => "Test or Live operation",
// "Live" => "Live",
// "Hashing Algorithm" => "Hashing Algorithm",
// "Encryption type" => "Encryption type",
// "SHA1" => "SHA1",
// "SHA256" => "SHA256",
// "SHA512" => "SHA512",
// "Cclite Payment Notification" => "Cclite Payment Notification",
// "TODO" => "TODO",
// "Wiki page containing the instruction to send manual payment like check" => "Wiki page containing the instruction to send manual payment like check",
// "Prefix to the invoice" => "Prefix to the invoice",
// "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice" => "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice",
// "Types of credit to use" => "Types of credit to use",
// "This is a list of the types of Tiki user credits to accept to pay with, separated by " => "This is a list of the types of Tiki user credits to accept to pay with, separated by ",
// "Exchange rate for types of credit to use" => "Exchange rate for types of credit to use",
// "This is a corresponding list of amount of credits equivalent to 1 of the payment currency, separated by " => "This is a corresponding list of amount of credits equivalent to 1 of the payment currency, separated by ",
// "Send to URL" => "Send to URL",
// "On permission denied, display login module (for Anonymous)" => "On permission denied, display login module (for Anonymous)",
// "Multiple polls per object" => "Multiple polls per object",
// "When used with the rating features, allow multiple polls to be attached to a single object" => "When used with the rating features, allow multiple polls to be attached to a single object",
// "PDF from URL" => "PDF from URL",
// "Using extenal tools, generate PDF document from web URLs" => "Using extenal tools, generate PDF document from web URLs",
// "Webkit (wkhtmltopdf)" => "Webkit (wkhtmltopdf)",
// "Webservice" => "Webservice",
// "Webservice URL" => "Webservice URL",
// "URL to a service taking a URL as the query string and returns a PDF document" => "URL to a service taking a URL as the query string and returns a PDF document",
// "Webkit path" => "Webkit path",
// "Full path to the wkhtmltopdf executable to generate the PDF document with" => "Full path to the wkhtmltopdf executable to generate the PDF document with",
// "Proxy host - without http:// or similar, just the host name" => "Proxy host - without http:// or similar, just the host name",
// "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page" => "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page",
// "Advanced Rating" => "Advanced Rating",
// "Rating system allowing for options and calculation method to be configured" => "Rating system allowing for options and calculation method to be configured",
// "Rating recalculation mode" => "Rating recalculation mode",
// "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time" => "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time",
// "Recalculate on vote" => "Recalculate on vote",
// "Randomly recalculate oldest ratings (on load)" => "Randomly recalculate oldest ratings (on load)",
// "Randomly recalculate oldest ratings (on vote)" => "Randomly recalculate oldest ratings (on vote)",
// "Cron job (must be set manually)" => "Cron job (must be set manually)",
// "Recalculation odds (1 in X)" => "Recalculation odds (1 in X)",
// "Dice roll performed on every request. When successful, will recalculate a certain number of votes" => "Dice roll performed on every request. When successful, will recalculate a certain number of votes",
// "Recalculation count" => "Recalculation count",
// "How many ratings should be recalculated when odds strike" => "How many ratings should be recalculated when odds strike",
// "Use ReCaptcha" => "Use ReCaptcha",
// "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA" => "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA",
// "You will need to register at [http://www.google.com/recaptcha]" => "You will need to register at [http://www.google.com/recaptcha]",
// "Public Key" => "Public Key",
// "ReCaptcha public key" => "ReCaptcha public key",
// "Private Key" => "Private Key",
// "ReCaptcha private key" => "ReCaptcha private key",
// "Keep track of the unsuccessful attemps to translate strings" => "Keep track of the unsuccessful attemps to translate strings",
// "Limit the languages made available on the site" => "Limit the languages made available on the site",
// "Refresh mode" => "Refresh mode",
// "Random" => "Random",
// "Use 0 for no refresh" => "Use 0 for no refresh",
// "Parse the results" => "Parse the results",
// "Default where" => "Default where",
// "When object filter is not on, limit to search one type of object" => "When object filter is not on, limit to search one type of object",
// "Restrict search language by default" => "Restrict search language by default",
// "If enabled, only search content in the interface language, by default" => "If enabled, only search content in the interface language, by default",
// "Autocomplete on page names" => "Autocomplete on page names",
// "Parse wiki syntax in comments in all sections apart from Forums" => "Parse wiki syntax in comments in all sections apart from Forums",
// "Use \"Accept wiki syntax\" for forums in admin forums page" => "Use \"Accept wiki syntax\" for forums in admin forums page",
// "Email address that will be used as the sender for outgoing emails" => "Email address that will be used as the sender for outgoing emails",
// "Timezone" => "Timezone",
// "Indicates the default time zone to use for the server" => "Indicates the default time zone to use for the server",
// "Session storage location" => "Session storage location",
// "Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Select where the session information should be stored. Memcache sessions require memcache to be configured",
// "Default (from php.ini)" => "Default (from php.ini)",
// "Session lifetime" => "Session lifetime",
// "Value provided in minutes" => "Value provided in minutes",
// "Silent session" => "Silent session",
// "Do not automatically start sessions" => "Do not automatically start sessions",
// "Session cookie name" => "Session cookie name",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
// "Protect all sessions" => "Protect all sessions",
// "Always redirect to HTTPS to prevent session hijack through network sniffing" => "Always redirect to HTTPS to prevent session hijack through network sniffing",
// "Default group" => "Default group",
// "Create with default group" => "Create with default group",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Shipping Service" => "Shipping Service",
// "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)",
// "FedEx API" => "FedEx API",
// "Enable shipping rate calculation through FedEx APIs" => "Enable shipping rate calculation through FedEx APIs",
// "FedEx Key" => "FedEx Key",
// "Developer Key" => "Developer Key",
// "FedEx Password" => "FedEx Password",
// "FedEx Meter Number" => "FedEx Meter Number",
// "FedEx Account Number" => "FedEx Account Number",
// "UPS API" => "UPS API",
// "Enable shipping rate calculation using the UPS carrier" => "Enable shipping rate calculation using the UPS carrier",
// "UPS Username" => "UPS Username",
// "UPS credentials" => "UPS credentials",
// "UPS Password" => "UPS Password",
// "UPS Access Key" => "UPS Access Key",
// "%Y-%m-%d" => "%Y-%m-%d",
// "%H:%M" => "%H:%M",
// "%Y-%m-%d %H:%M" => "%Y-%m-%d %H:%M",
// "Display available translations" => "Display available translations",
// "Close site (except for those with permission)" => "Close site (except for those with permission)",
// "Message to display" => "Message to display",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Choices" => "Choices",
// "Site title location" => "Site title location",
// "Location of the site title in the browser title bar relative to the current page\\'s descriptor" => "Location of the site title in the browser title bar relative to the current page\\'s descriptor",
// "Browser title display mode" => "Browser title display mode",
// "When breadcrumbs are used, method in which the browser title should be displayed" => "When breadcrumbs are used, method in which the browser title should be displayed",
// "Most specific first" => "Most specific first",
// "Least specific first (site)" => "Least specific first (site)",
// "Current only" => "Current only",
// "Favicon icon file name" => "Favicon icon file name",
// "Favicon icon MIME type" => "Favicon icon MIME type",
// "Logo source (image path)" => "Logo source (image path)",
// "Logo background color" => "Logo background color",
// "Logo background style" => "Logo background style",
// "Logo alignment" => "Logo alignment",
// "Logo title (on mouse over)" => "Logo title (on mouse over)",
// "Slideshow theme" => "Slideshow theme",
// "Include smarty notices in PHP error report" => "Include smarty notices in PHP error report",
// "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur" => "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur",
// "Smarty Security" => "Smarty Security",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "You should leave this on unless you know what you are doing" => "You should leave this on unless you know what you are doing",
// "Smarty Compilation" => "Smarty Compilation",
// "Indicates when the template cache should be refreshed" => "Indicates when the template cache should be refreshed",
// "Never check (performance)" => "Never check (performance)",
// "Always (development, slow)" => "Always (development, slow)",
// "Consumer key" => "Consumer key",
// "Consumer key generated by registering your site as application at twitter" => "Consumer key generated by registering your site as application at twitter",
// "Consumer secret" => "Consumer secret",
// "Consumer secret generated by registering your site as an application at twitter" => "Consumer secret generated by registering your site as an application at twitter",
// "API key" => "API key",
// "API key generated by registering your site as application at facebook" => "API key generated by registering your site as application at facebook",
// "Application secret" => "Application secret",
// "Application secret generated by registering your site as an application at facebook" => "Application secret generated by registering your site as an application at facebook",
// "Application ID" => "Application ID",
// "Application id generated by registering your site as an application at facebook" => "Application id generated by registering your site as an application at facebook",
// "bit.ly Login" => "bit.ly Login",
// "Site wide login (username) for bit.ly" => "Site wide login (username) for bit.ly",
// "bit.ly Key" => "bit.ly Key",
// "Site wide API key for bit.ly" => "Site wide API key for bit.ly",
// "Use site-wide account" => "Use site-wide account",
// "When setting this option to yes, only the site wide account will be used for all users" => "When setting this option to yes, only the site wide account will be used for all users",
// "Theme options" => "Theme options",
// "Style options" => "Style options",
// "Minify JavaScript" => "Minify JavaScript",
// "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS" => "Minify CSS",
// "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS into a single file" => "Minify CSS into a single file",
// "In addition to reducing the size of the CSS, reduce the number of included files" => "In addition to reducing the size of the CSS, reduce the number of included files",
// "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"" => "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"",
// "Skip date for same day" => "Skip date for same day",
// "When displaying short date and time, skip date for today. Only time will be displayed" => "When displaying short date and time, skip date for today. Only time will be displayed",
// "Cache-Control header" => "Cache-Control header",
// "Custom HTTP header to use when a session is active" => "Custom HTTP header to use when a session is active",
// "Example: no-cache, pre-check=0, post-check=0" => "Example: no-cache, pre-check=0, post-check=0",
// "Cache-Control header (no session)" => "Cache-Control header (no session)",
// "Custom HTTP header to use when no session is active" => "Custom HTTP header to use when no session is active",
// "Content Delivery Network" => "Content Delivery Network",
// "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance" => "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance",
// "Prefix to include before the static files, for example: http://cdn.example.com" => "Prefix to include before the static files, for example: http://cdn.example.com",
// "Content Delivery Network (in SSL)" => "Content Delivery Network (in SSL)",
// "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode" => "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode",
// "Prefix to include before the static files, for example: https://cdn.example.com" => "Prefix to include before the static files, for example: https://cdn.example.com",
// "Domain prefix handling" => "Domain prefix handling",
// "Strip or automatically add the www. prefix on domain names to unify URLs" => "Strip or automatically add the www. prefix on domain names to unify URLs",
// "Leave as-is" => "Leave as-is",
// "Remove the www" => "Remove the www",
// "Add the www" => "Add the www",
// "Domain redirects" => "Domain redirects",
// "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org" => "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org",
// "One entry per line. Comma separated list: old, new" => "One entry per line. Comma separated list: old, new",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "URL a user is redirected to after account validation" => "URL a user is redirected to after account validation",
// "URL an anonymous is redirected when page not found" => "URL an anonymous is redirected when page not found",
// "Close site when server load is above the threshold  (except for those with permission)" => "Close site when server load is above the threshold  (except for those with permission)",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Show user\\'s real name instead of login (when possible)" => "Show user\\'s real name instead of login (when possible)",
// "Display UserTracker information on the user information page" => "Display UserTracker information on the user information page",
// "Use the format: trackerId, fieldId1, fieldId2, .." => "Use the format: trackerId, fieldId1, fieldId2, ..",
// "Users can shade modules" => "Users can shade modules",
// "Allows users to hide/show modules" => "Allows users to hide/show modules",
// "Module decides" => "Module decides",
// "Store full-size copy of avatar in file gallery" => "Store full-size copy of avatar in file gallery",
// "File gallery to store full-size copy of avatar in" => "File gallery to store full-size copy of avatar in",
// "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit",
// "Display who viewed my stuff on the user information page" => "Display who viewed my stuff on the user information page",
// "You will need to activate tracking of views for various items in the action log for this to work" => "You will need to activate tracking of views for various items in the action log for this to work",
// "Number of days to consider who viewed my stuff" => "Number of days to consider who viewed my stuff",
// "Number of days before current time to consider when showing who viewed my stuff" => "Number of days before current time to consider when showing who viewed my stuff",
// "Show to others who viewed my stuff on the user information page" => "Show to others who viewed my stuff on the user information page",
// "Show to others who viewed my stuff on the user information page. Admins can always see this information" => "Show to others who viewed my stuff on the user information page. Admins can always see this information",
// "Maximum number of users to show in drop down lists" => "Maximum number of users to show in drop down lists",
// "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box" => "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box",
// "Use pretty trackers for registration form" => "Use pretty trackers for registration form",
// "Registration pretty tracker template" => "Registration pretty tracker template",
// "Use wiki page name or template file with .tpl extension" => "Use wiki page name or template file with .tpl extension",
// "User tracker IDs to sync prefs from" => "User tracker IDs to sync prefs from",
// "Enter the IDs separated by commas of trackers to sync user prefs from" => "Enter the IDs separated by commas of trackers to sync user prefs from",
// "Tracker field IDs to sync Real Name pref from" => "Tracker field IDs to sync Real Name pref from",
// "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4" => "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4",
// "Synchronize long/lat/zoom to google maps field" => "Synchronize long/lat/zoom to google maps field",
// "Synchronize user geolocation prefs to main google maps field" => "Synchronize user geolocation prefs to main google maps field",
// "Synchronize categories of user tracker item to user groups" => "Synchronize categories of user tracker item to user groups",
// "Will add the user tracker item to the category of the same name as the user groups and vice versa" => "Will add the user tracker item to the category of the same name as the user groups and vice versa",
// "Put user in group only if categorized within" => "Put user in group only if categorized within",
// "Show user\\'s real name instead of login in autocomplete selector in trackers feature" => "Show user\\'s real name instead of login in autocomplete selector in trackers feature",
// "Use user\\'s real name instead of login in autocomplete selector in trackers feature" => "Use user\\'s real name instead of login in autocomplete selector in trackers feature",
// "Show user\\'s real name instead of login in autocomplete selector in messaging feature" => "Show user\\'s real name instead of login in autocomplete selector in messaging feature",
// "Use user\\'s real name instead of login in autocomplete selector in messaging feature" => "Use user\\'s real name instead of login in autocomplete selector in messaging feature",
// "Username pattern" => "Username pattern",
// "Serve avatar images statically" => "Serve avatar images statically",
// "When enabled, feature checks and permission checks will be skipped" => "When enabled, feature checks and permission checks will be skipped",
// "Use site default to show times" => "Use site default to show times",
// "Detect user timezone (if browser allows). Otherwise use site default" => "Detect user timezone (if browser allows). Otherwise use site default",
// "Use new diff any version interface" => "Use new diff any version interface",
// "20" => "20",
// "30" => "30",
// "40" => "40",
// "50" => "50",
// "Notify sender when reading mail" => "Notify sender when reading mail",
// "Auto-archive read messages after" => "Auto-archive read messages after",
// "60" => "60",
// "Character set for mail" => "Character set for mail",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
// "Display by default" => "Display by default",
// "Path (if stored in directory)" => "Path (if stored in directory)",
// "15" => "15",
// "Log errors to Tiki log" => "Log errors to Tiki log",
// "Errors will be logged to the Tiki log" => "Errors will be logged to the Tiki log",
// "Tracker ID of Channel tracker" => "Tracker ID of Channel tracker",
// "There must be a tracker to store info of each channel you create" => "There must be a tracker to store info of each channel you create",
// "Field ID of BrandId" => "Field ID of BrandId",
// "The Channel tracker must have a text field for the Watershed BrandId" => "The Channel tracker must have a text field for the Watershed BrandId",
// "Field ID of ChannelCode" => "Field ID of ChannelCode",
// "The Channel tracker must have a text field for the Watershed ChannelCode" => "The Channel tracker must have a text field for the Watershed ChannelCode",
// "Tracker ID of Archive tracker" => "Tracker ID of Archive tracker",
// "There must be a tracker to store Archive info" => "There must be a tracker to store Archive info",
// "Field ID of videoId" => "Field ID of videoId",
// "The Archive tracker must have a text field for the videoId of each archive" => "The Archive tracker must have a text field for the videoId of each archive",
// "Field ID of BrandId for Archive" => "Field ID of BrandId for Archive",
// "The Archive tracker must have a text field for the BrandId of each archive" => "The Archive tracker must have a text field for the BrandId of each archive",
// "Field ID of ChannelCode for Archive" => "Field ID of ChannelCode for Archive",
// "The Archive tracker must have a text field for the ChannelCode of each archive" => "The Archive tracker must have a text field for the ChannelCode of each archive",
// "Field ID of rtmpURL for Archive (url field type)" => "Field ID of rtmpURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the RTMP URL to access the archive" => "The Archive tracker must have a url field for storing the RTMP URL to access the archive",
// "Field ID of flvURL for Archive (url field type)" => "Field ID of flvURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the FLV URL to access the archive" => "The Archive tracker must have a url field for storing the FLV URL to access the archive",
// "Field ID of Date string for Archive" => "Field ID of Date string for Archive",
// "The Archive tracker can have a text field for storing the time the recording completed" => "The Archive tracker can have a text field for storing the time the recording completed",
// "Field ID of Duration for Archive" => "Field ID of Duration for Archive",
// "The Archive tracker can have a text field for storing the duration of the recording" => "The Archive tracker can have a text field for storing the duration of the recording",
// "Field ID of Filesize for Archive" => "Field ID of Filesize for Archive",
// "The Archive tracker can have a text field for storing the filesize of the recording" => "The Archive tracker can have a text field for storing the filesize of the recording",
// "Field ID of Title for Archive" => "Field ID of Title for Archive",
// "The Archive tracker could have a text field for storing the title of the recording" => "The Archive tracker could have a text field for storing the title of the recording",
// "Field ID of Description for Archive (textarea field type)" => "Field ID of Description for Archive (textarea field type)",
// "The Archive tracker could have a textarea field for storing the description of the recording" => "The Archive tracker could have a textarea field for storing the description of the recording",
// "Field ID of Tags for Archive (freetags field type)" => "Field ID of Tags for Archive (freetags field type)",
// "The Archive tracker could have a freetags field for storing the tags of the recording" => "The Archive tracker could have a freetags field for storing the tags of the recording",
// "Flash Media Encoder shared secret" => "Flash Media Encoder shared secret",
// "Shared key for authenticating Flash Media Encoder" => "Shared key for authenticating Flash Media Encoder",
// "500Kb" => "500Kb",
// "1Mb" => "1Mb",
// "1.5Mb" => "1.5Mb",
// "2Mb" => "2Mb",
// "2.5Mb" => "2.5Mb",
// "3Mb" => "3Mb",
// "Include a flag by each e-mail to quickly flag/un-flag them" => "Include a flag by each e-mail to quickly flag/un-flag them",
// "Wiki link format" => "Wiki link format",
// "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))" => "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))",
// "Strict will only be basic characters like a-z and 0-9. If you have accented or special characters in page names, you should not use strict" => "Strict will only be basic characters like a-z and 0-9. If you have accented or special characters in page names, you should not use strict",
// "Relaxed" => "Relaxed",
// "Strict" => "Strict",
// "Display page version" => "Display page version",
// "Display the page version information when viewing the page" => "Display the page version information when viewing the page",
// "Display page name above page" => "Display page name above page",
// "Display page name above page instead of inside page" => "Display page name above page instead of inside page",
// "Page name display stripper" => "Page name display stripper",
// "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed" => "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed",
// "Wiki author list style" => "Wiki author list style",
// "Changes the list format used to display the authors of the page" => "Changes the list format used to display the authors of the page",
// "Creator & Author" => "Creator & Author",
// "none (disabled)" => "none (disabled)",
// "Specify wiki author list style per page" => "Specify wiki author list style per page",
// "Allows to modify the style in which the author list is displayed on a per-page basis" => "Allows to modify the style in which the author list is displayed on a per-page basis",
// "Wiki action bar location" => "Wiki action bar location",
// "Buttons: Save, Preview, Cancel, .." => "Buttons: Save, Preview, Cancel, ..",
// "Wiki navigation bar location" => "Wiki navigation bar location",
// "When using the ...page... page break wiki syntax" => "When using the ...page... page break wiki syntax",
// "Wiki top line location" => "Wiki top line location",
// "Enable page cache globally for wiki pages" => "Enable page cache globally for wiki pages",
// "Allow comments per wiki page" => "Allow comments per wiki page",
// "Enable control for comments on wiki pages individually" => "Enable control for comments on wiki pages individually",
// "Enable (default On)" => "Enable (default On)",
// "Enable (default Off)" => "Enable (default Off)",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "Permits editing of a plugin, via a popup form, without needing to edit the whole page" => "Permits editing of a plugin, via a popup form, without needing to edit the whole page",
// "Requires JavaScript" => "Requires JavaScript",
// "Prevent special characters in page names" => "Prevent special characters in page names",
// "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters" => "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters",
// "Page ranking reload probability" => "Page ranking reload probability",
// "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking" => "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking",
// "Encourage contribution to wiki pages by anonymous" => "Encourage contribution to wiki pages by anonymous",
// "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register" => "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register",
// "Warn before page lock timeout" => "Warn before page lock timeout",
// "Provide a JavaScript alert before the user\\'s lock on a page times out" => "Provide a JavaScript alert before the user\\'s lock on a page times out",
// "Global snippets of text that can be included in wiki pages and edited in place" => "Global snippets of text that can be included in wiki pages and edited in place",
// "Single (%varname%)" => "Single (%varname%)",
// "Double (%%varname%%)" => "Double (%%varname%%)",
// "Multilingual dynamic variables" => "Multilingual dynamic variables",
// "Make dynamic variable content language specific" => "Make dynamic variable content language specific",
// "Edit section" => "Edit section",
// "Edit section level" => "Edit section level",
// "Toggle display of section and plugin edit icons" => "Toggle display of section and plugin edit icons",
// "Allow minor edits" => "Allow minor edits",
// "Slideshows" => "Slideshows",
// "Watch minor edits" => "Watch minor edits",
// "Page ID" => "Page ID",
// "Name length" => "Name length",
// "Edit comments" => "Edit comments",
// "Edit Comment length" => "Edit Comment length",
// "Sort Direction" => "Sort Direction",
// "Forum for discussion" => "Forum for discussion",
// "Allow to manage keywords on a per-page basis" => "Allow to manage keywords on a per-page basis",
// "Similar pages only listed in same language" => "Similar pages only listed in same language",
// "When listing similar pages, such as in missing page 404, only display pages in the same language as the request" => "When listing similar pages, such as in missing page 404, only display pages in the same language as the request",
// "Mandatory edit summary on wiki pages" => "Mandatory edit summary on wiki pages",
// "Reject save attempts not providing an edit summary to describe the changes made" => "Reject save attempts not providing an edit summary to describe the changes made",
// "Structure navigation bar location" => "Structure navigation bar location",
// "Displays Next/Back buttons, breadcrumbs, and form to add a new page" => "Displays Next/Back buttons, breadcrumbs, and form to add a new page",
// "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation" => "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation",
// "Simple wiki ratings" => "Simple wiki ratings",
// "Enable users to rate articles based on a simple numeric scale" => "Enable users to rate articles based on a simple numeric scale",
// "Wiki rating options" => "Wiki rating options",
// "List of options available for the rating of wiki pages" => "List of options available for the rating of wiki pages",
// "Redirect pages using these prefix alias semantic links" => "Redirect pages using these prefix alias semantic links",
// "Comma separated list of prefixes of which pages will be redirected to page with semantic link" => "Comma separated list of prefixes of which pages will be redirected to page with semantic link",
// "Force bounce of editing of approved pages to staging" => "Force bounce of editing of approved pages to staging",
// "Replace freetags with that of staging pages, on approval" => "Replace freetags with that of staging pages, on approval",
// "Staging" => "Staging",
// "Approved" => "Approved",
// "(mandatory for feature to work)" => "(mandatory for feature to work)",
// "Out-of-sync" => "Out-of-sync",
// "Plugin %0" => "Plugin %0",
// "Global cache time for the plugin snarf in seconds" => "Global cache time for the plugin snarf in seconds",
// "Default cache time for the plugin snarf" => "Default cache time for the plugin snarf",
// "0 for no cache" => "0 for no cache",
// "Inline plugin %0" => "Inline plugin %0",
// "Wysiwyg Editor is displayed by default" => "Wysiwyg Editor is displayed by default",
// "This allows a mixture of wiki and html. All wiki syntax is parsed" => "This allows a mixture of wiki and html. All wiki syntax is parsed",
// "Content is partially wiki parsed" => "Content is partially wiki parsed",
// "This also allows a mixture of wiki and html. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)" => "This also allows a mixture of wiki and html. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)",
// "Wysiwyg editor skin" => "Wysiwyg editor skin",
// "Kama (Default)" => "Kama (Default)",
// "Office 2003" => "Office 2003",
// "V2 (FCKEditor appearance)" => "V2 (FCKEditor appearance)",
// "Use Wiki syntax in WYSIWYG" => "Use Wiki syntax in WYSIWYG",
// "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead " => "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead ",
// "Font names" => "Font names",
// "List of font names separated by" => "List of font names separated by",
// "SMTP Server" => "SMTP Server",
// "SSL" => "SSL",
// "TLS" => "TLS",
// "Mail Sender" => "Mail Sender",
// "Sendmail" => "Sendmail",
// "SMTP" => "SMTP",
// "Authentication" => "Authentication",
// "Mail server authentication" => "Mail server authentication",
// "LOGIN" => "LOGIN",
// "PLAIN" => "PLAIN",
// "CRAM-MD5" => "CRAM-MD5",
// "Nothing was changed, please check profile for errors" => "Nothing was changed, please check profile for errors",
// "An error occurred: " => "An error occurred: ",
// "Applying profile" => "Applying profile",
// "Added (or modified)" => "Added (or modified)",
// "Preference set" => "Preference set",
// "Group changed (or modified)" => "Group changed (or modified)",
// "Modified permission %s for %s" => "Modified permission %s for %s",
// "Modified permission %s on %s/%s for %s" => "Modified permission %s on %s/%s for %s",
// "User %0 was added to %1" => "User %0 was added to %1",
// "File gallery does not exist" => "File gallery does not exist",
// "File gallery already exists" => "File gallery already exists",
// "Calendar does not exist" => "Calendar does not exist",
// "Calendar already exists" => "Calendar already exists",
// "Syntax error: " => "Syntax error: ",
// "Circular reference" => "Circular reference",
// "No name" => "No name",
// "Bad object" => "Bad object",
// "Permissions' object must have a field 'type' and 'id'" => "Permissions' object must have a field 'type' and 'id'",
// "Needs a 'type' and 'data' field" => "Needs a 'type' and 'data' field",
// "Expecting three arguments for article-info" => "Expecting three arguments for article-info",
// "Unsupported property. Supported properties are: ' . implode( " => "Unsupported property. Supported properties are: ' . implode( ",
// "Articles feature not enabled" => "Articles feature not enabled",
// "Unexpected values: %0" => "Unexpected values: %0",
// "Invalid property" => "Invalid property",
// "Object must be provided and contain two arguments: type and object" => "Object must be provided and contain two arguments: type and object",
// "Invalid range" => "Invalid range",
// "Invalid revote period" => "Invalid revote period",
// "Expecting \"keep\" to be \"latest\" or \"oldest\"" => "Expecting \"keep\" to be \"latest\" or \"oldest\"",
// "Unknown variables referenced: %0" => "Unknown variables referenced: %0",
// "Username is required" => "Username is required",
// "This invitation does not exist or is deprecated or wrong email" => "This invitation does not exist or is deprecated or wrong email",
// "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category" => "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category",
// "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category" => "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category",
// "The fields title and description are mandatory to generate a feed" => "The fields title and description are mandatory to generate a feed",
// "To fix this error go to Admin -> Feeds" => "To fix this error go to Admin -> Feeds",
// "Please contact the site administrator and ask him to fix this error" => "Please contact the site administrator and ask him to fix this error",
// "If you set feed author email or url you have to set feed author name" => "If you set feed author email or url you have to set feed author name",
// "Feed logo" => "Feed logo",
// "You must choose an option" => "You must choose an option",
// "Last files uploaded to this file gallery. " => "Last files uploaded to this file gallery. ",
// "Last posts to this forum. " => "Last posts to this forum. ",
// "Last images uploaded to this image gallery. " => "Last images uploaded to this image gallery. ",
// "Last shoutbox messages" => "Last shoutbox messages",
// "Tiki RSS feed for shoutbox messages" => "Tiki RSS feed for shoutbox messages",
// "Last items published on this tracker" => "Last items published on this tracker",
// "UPS_CODE_' . \$xp->query( 'Service/Code" => "UPS_CODE_' . \$xp->query( 'Service/Code",
// "Click for Help" => "Click for Help",
// "You are not in group of friends to have the content of this block displayed for you" => "You are not in group of friends to have the content of this block displayed for you",
// "Smarty block.display.php: Missing error param" => "Smarty block.display.php: Missing error param",
// "tip" => "tip",
// "warning" => "warning",
// "confirm" => "confirm",
// "note" => "note",
// "errors" => "errors",
// "information" => "information",
// "Tab View" => "Tab View",
// "This edit session will expire in" => "This edit session will expire in",
// "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer" => "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer",
// "There is an autosaved version of this content, to use it instead of this saved one" => "There is an autosaved version of this content, to use it instead of this saved one",
// "If you want the saved version instead of this autosaved draft" => "If you want the saved version instead of this autosaved draft",
// "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />" => "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />",
// "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this" => "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this",
// "Ckeditor Development Notice" => "Ckeditor Development Notice",
// "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile" => "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile",
// "Admin page" => "Admin page",
// "Plugin name not specified" => "Plugin name not specified",
// "Hour" => "Hour",
// "Minute" => "Minute",
// "Month beginning" => "Month beginning",
// "Week beginning" => "Week beginning",
// "Data (change %)" => "Data (change %)",
// "No object information provided" => "No object information provided",
// "No rules to display object %1 of type %0" => "No rules to display object %1 of type %0",
// "Relation not found" => "Relation not found",
// "Currency in payment (%0) does not match the currency for that registry (%1)" => "Currency in payment (%0) does not match the currency for that registry (%1)",
// "This invoice does not exist or is in limited access" => "This invoice does not exist or is in limited access",
// "PHPLayersMenus are not enabled on this site" => "PHPLayersMenus are not enabled on this site",
// "Preference name not specified" => "Preference name not specified",
// " (found in " => " (found in ",
// "(not found in an admin panel)" => "(not found in an admin panel)",
// "Preference %0 is not defined" => "Preference %0 is not defined",
// "No object information provided for rating" => "No object information provided for rating",
// "An error occured" => "An error occured",
// "No rows found" => "No rows found",
// "Number of items in _checkboxColumnIndex doesn not match items in _checkbox" => "Number of items in _checkboxColumnIndex doesn not match items in _checkbox",
// "Number of items in _checkboxTitles doesn not match items in _checkbox" => "Number of items in _checkboxTitles doesn not match items in _checkbox",
// "Toggle sections" => "Toggle sections",
// "Show only selected" => "Show only selected",
// "You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "You might want to also set the tiki_p_modify_object_categories permission under the tiki section",
// "years" => "years",
// "More info about %0 (idle for %1)" => "More info about %0 (idle for %1)",
// " seconds" => " seconds",
// "Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission denied: the specified wiki page cannot be used as Smarty template resource",
// "Days with the most pageviews" => "Days with the most pageviews",
// "Day with the most pageviews" => "Day with the most pageviews",
// "Days with the least pageviews" => "Days with the least pageviews",
// "Day with the least pageviews" => "Day with the least pageviews",
// "No pageviews yet" => "No pageviews yet",
// "n/a" => "n/a",
// "Unknown conversion" => "Unknown conversion",
// "Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator" => "Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator",
// "Plugin <strong>%0</strong> does not exist" => "Plugin <strong>%0</strong> does not exist",
// "(external link)" => "(external link)",
// "smiling" => "smiling",
// "grinning" => "grinning",
// "crying" => "crying",
// "frightened" => "frightened",
// "evil stuff" => "evil stuff",
// "exclamation mark " => "exclamation mark ",
// "frowning" => "frowning",
// "light bulb" => "light bulb",
// "idea " => "idea ",
// "LOL" => "LOL",
// "laughing out loud " => "laughing out loud ",
// "mr. green laughing" => "mr. green laughing",
// "The file was uploaded with success" => "The file was uploaded with success",
// "No file was uploaded. Was a file selected " => "No file was uploaded. Was a file selected ",
// "A temporary folder is missing" => "A temporary folder is missing",
// "Unknown error" => "Unknown error",
// "Bold" => "Bold",
// "pics/icons/text_bold.png" => "pics/icons/text_bold.png",
// "Italic" => "Italic",
// "pics/icons/text_italic.png" => "pics/icons/text_italic.png",
// "Underline" => "Underline",
// "pics/icons/text_underline.png" => "pics/icons/text_underline.png",
// "Strikethrough" => "Strikethrough",
// "pics/icons/text_strikethrough.png" => "pics/icons/text_strikethrough.png",
// "Non-parsed (Wiki syntax does not apply)" => "Non-parsed (Wiki syntax does not apply)",
// "pics/icons/noparse.png" => "pics/icons/noparse.png",
// "Align Center" => "Align Center",
// "pics/icons/text_align_center.png" => "pics/icons/text_align_center.png",
// "Horizontal Bar" => "Horizontal Bar",
// "pics/icons/page.png" => "pics/icons/page.png",
// "Page Break" => "Page Break",
// "pics/icons/page_break.png" => "pics/icons/page_break.png",
// "pics/icons/box.png" => "pics/icons/box.png",
// "pics/icons/email.png" => "pics/icons/email.png",
// "pics/icons/book.png" => "pics/icons/book.png",
// "pics/icons/text_list_bullets.png" => "pics/icons/text_list_bullets.png",
// "pics/icons/text_list_numbers.png" => "pics/icons/text_list_numbers.png",
// "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif" => "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif",
// "img/smiles/icon_smile.gif" => "img/smiles/icon_smile.gif",
// "pics/icons/palette.png" => "pics/icons/palette.png",
// "pics/icons/palette_bg.png" => "pics/icons/palette_bg.png",
// "pics/icons/page_link.png" => "pics/icons/page_link.png",
// "pics/icons/world_link.png" => "pics/icons/world_link.png",
// "pics/icons/table.png" => "pics/icons/table.png",
// "pics/icons/find.png" => "pics/icons/find.png",
// "pics/icons/text_replace.png" => "pics/icons/text_replace.png",
// "Wysiwyg Help" => "Wysiwyg Help",
// "pics/icons/pictures.png" => "pics/icons/pictures.png",
// "pics/icons/pencil_go.png" => "pics/icons/pencil_go.png",
// "pics/icons/disk.png" => "pics/icons/disk.png",
// "Add Row After Selection Or To End If No Selection" => "Add Row After Selection Or To End If No Selection",
// "pics/icons/sheet_row_add.png" => "pics/icons/sheet_row_add.png",
// "Add Multiple Rows After Selection Or To End If No Selection" => "Add Multiple Rows After Selection Or To End If No Selection",
// "pics/icons/sheet_row_add_multi.png" => "pics/icons/sheet_row_add_multi.png",
// "Add Row Before Selection Or To End If No Selection" => "Add Row Before Selection Or To End If No Selection",
// "Delete Selected Row" => "Delete Selected Row",
// "pics/icons/sheet_row_delete.png" => "pics/icons/sheet_row_delete.png",
// "Add Column After Selection Or To End If No Selection" => "Add Column After Selection Or To End If No Selection",
// "pics/icons/sheet_col_add.png" => "pics/icons/sheet_col_add.png",
// "Delete Selected Column" => "Delete Selected Column",
// "pics/icons/sheet_col_delete.png" => "pics/icons/sheet_col_delete.png",
// "Add Multiple Columns After Selection Or To End If No Selection" => "Add Multiple Columns After Selection Or To End If No Selection",
// "pics/icons/sheet_col_add_multi.png" => "pics/icons/sheet_col_add_multi.png",
// "Add Column Before Selection Or To End If No Selection" => "Add Column Before Selection Or To End If No Selection",
// "pics/icons/sheet_get_range.png" => "pics/icons/sheet_get_range.png",
// "pics/icons/arrow_refresh.png" => "pics/icons/arrow_refresh.png",
// "pics/icons/close.png" => "pics/icons/close.png",
// "Admin Toolbars" => "Admin Toolbars",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax,distinct</strong>\n\t\t\t\t<dt>Example: 0,80,5,200,30\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd><strong>[distinct]</strong> is y or n. y = all values of the field must be different\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax,distinct</strong>\n\t\t\t\t<dt>Example: 0,80,5,200,30\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd><strong>[distinct]</strong> is y or n. y = all values of the field must be different\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,decimals,dec_point,thousands</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[decimals]</strong> sets the number of decimal places;\n\t\t\t\t<dd><strong>[dec_point]</strong> sets the separator for the decimal point (decimals must also be set). Use c for comma and s for space;\n\t\t\t\t<dd><strong>[thousands]</strong> sets the thousands separator. Use c for comma and s for space. Setting only commas will result in no decimals \n\t\t\t\t\t\t\t\t\t\t\t\t\tand commas as the thousands seprator;<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,decimals,dec_point,thousands</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[decimals]</strong> sets the number of decimal places;\n\t\t\t\t<dd><strong>[dec_point]</strong> sets the separator for the decimal point (decimals must also be set). Use c for comma and s for space;\n\t\t\t\t<dd><strong>[thousands]</strong> sets the thousands separator. Use c for comma and s for space. Setting only commas will result in no decimals \n\t\t\t\t\t\t\t\t\t\t\t\t\tand commas as the thousands seprator;<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "currency amount" => "currency amount",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,locale,symbol,first</strong>\n\t\t\t\t<dt>Example: 0,60,,per item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[locale]</strong> set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1 (default=en_US);\n\t\t\t\t<dd><strong>[currency]</strong> The 3-letter ISO 4217 currency code indicating the currency to use (default=USD);\n\t\t\t\t<dd><strong>[symbol]</strong> i for international symbol, n for local (default=n);\n\t\t\t\t<dd><strong>[all_symbol]</strong> set to 1 to show symbol for every item (default only shows currency symbol on first item in a list) ;\n\t\t\t\t<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,locale,symbol,first</strong>\n\t\t\t\t<dt>Example: 0,60,,per item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[locale]</strong> set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1 (default=en_US);\n\t\t\t\t<dd><strong>[currency]</strong> The 3-letter ISO 4217 currency code indicating the currency to use (default=USD);\n\t\t\t\t<dd><strong>[symbol]</strong> i for international symbol, n for local (default=n);\n\t\t\t\t<dd><strong>[all_symbol]</strong> set to 1 to show symbol for every item (default only shows currency symbol on first item in a list) ;\n\t\t\t\t<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriage return\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriage return\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>",
// "page selector" => "page selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong> will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd><strong>[link]</strong> will not display the link to the page if equals to n \n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong> will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd><strong>[link]</strong> will not display the link to the page if equals to n \n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>when set to \"empty\" will allow selection of empty date but default to current date\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>when set to \"empty\" will allow selection of empty date but default to current date\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: will display the field name as a html header h2;\n\t\t\t\t<dt>Usage: <strong>level</strong>\n\t\t\t\t<dt>Example: 2\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[level]</strong> level of the html header (default 2)\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: will display the field name as a html header h2;\n\t\t\t\t<dt>Usage: <strong>level</strong>\n\t\t\t\t<dt>Example: 2\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[level]</strong> level of the html header (default 2)\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall,descendants</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd><strong>[descendants]</strong> All descendant categories (not just first level children) will be included if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall,descendants</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd><strong>[descendants]</strong> All descendant categories (not just first level children) will be included if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,0,6|8,opc,PageName\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd><strong>[linkPage]</strong> is the name of the wiki page to link to with trackerlist plugin in it; \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,0,6|8,opc,PageName\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd><strong>[linkPage]</strong> is the name of the wiki page to link to with trackerlist plugin in it; \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t<dt>Usage: <strong>use_as_item_location,bubble_fieldId,icon</strong>\n\t\t\t\t<dt>Example: y,23|24,img/icons2/icn_members.gif\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[use_as_item_location]</strong> if set to y, this google map field will be used as item location and object geo attributes are set when field value is changed.\n\t\t\t\t<dd><strong>[bubble_fieldid]</strong> is the fieldId(s) (separated by |) that contains the text that will be displayed in the bubble of the map marker. The first field will be used as the link.\n\t\t\t\t<dd><strong>[icon]</strong> is the url of the default icon to use for markers of items on the map.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t<dt>Usage: <strong>use_as_item_location,bubble_fieldId,icon</strong>\n\t\t\t\t<dt>Example: y,23|24,img/icons2/icn_members.gif\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[use_as_item_location]</strong> if set to y, this google map field will be used as item location and object geo attributes are set when field value is changed.\n\t\t\t\t<dd><strong>[bubble_fieldid]</strong> is the fieldId(s) (separated by |) that contains the text that will be displayed in the bubble of the map marker. The first field will be used as the link.\n\t\t\t\t<dd><strong>[icon]</strong> is the url of the default icon to use for markers of items on the map.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email, other values possible: language;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email, other values possible: language;\n\t\t\t\t</dl>",
// "user groups" => "user groups",
// "<dl>\n\t\t\t\t<dt>Function: Allows to display the user groups.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows to display the user groups.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "freetags" => "freetags",
// "<dl>\n\t\t\t\t<dt>Function: Allows freetags to be shown or added for tracker item\n\t\t\t\t<dt>Usage: <strong>size</strong>\n\t\t\t\t<dt>Example: 80,n,n\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[hidehelp]</strong> if y, do not show help text when entering tags;\n\t\t\t\t<dd><strong>[hidesuggest]</strong> if y, do not show suggested tags when entering tags;  \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows freetags to be shown or added for tracker item\n\t\t\t\t<dt>Usage: <strong>size</strong>\n\t\t\t\t<dt>Example: 80,n,n\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[hidehelp]</strong> if y, do not show help text when entering tags;\n\t\t\t\t<dd><strong>[hidesuggest]</strong> if y, do not show suggested tags when entering tags;  \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "in group" => "in group",
// "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Display stars\n\t\t\t\t<dt>Usage: <strong>list options (positive increasing numbers</strong>\n\t\t\t\t<dt>Example: 1,2,3,4\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Like the rating\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Display stars\n\t\t\t\t<dt>Usage: <strong>list options (positive increasing numbers</strong>\n\t\t\t\t<dt>Example: 1,2,3,4\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Like the rating\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)",
// "Edit field: (Incorrect validation parameter)" => "Edit field: (Incorrect validation parameter)",
// "Invalid character combination for username" => "Invalid character combination for username",
// "here" => "here",
// "Could not establish Kaltura session. Try again" => "Could not establish Kaltura session. Try again",
// "You need to set your Kaltura account details: " => "You need to set your Kaltura account details: ",
// "Successfully stored archive in tracker" => "Successfully stored archive in tracker",
// "Failed to stored archive in tracker" => "Failed to stored archive in tracker",
// "Cannot connect with web service" => "Cannot connect with web service",
// "No permission to broadcast to channel" => "No permission to broadcast to channel",
// "Broadcaster successfully authenticated" => "Broadcaster successfully authenticated",
// "No permission to broadcast to any channel" => "No permission to broadcast to any channel",
// "Successfully logged in mobile broadcaster" => "Successfully logged in mobile broadcaster",
// "No viewable channels available for mobile" => "No viewable channels available for mobile",
// "Failed to log in mobile broadcaster" => "Failed to log in mobile broadcaster",
// "Successfully logged in FME" => "Successfully logged in FME",
// "Failed to log in FME" => "Failed to log in FME",
// "No permission to view channel" => "No permission to view channel",
// "Viewer successfully authenticated" => "Viewer successfully authenticated",
// "No permission to view any channel" => "No permission to view any channel",
// "Mailbox uninitialised??" => "Mailbox uninitialised??",
// "No mail body found" => "No mail body found",
// "Add to cart" => "Add to cart",
// "PluginAddToCart" => "PluginAddToCart",
// "Adds a product to the virtual cart. The cart can be manipulated using the cart module" => "Adds a product to the virtual cart. The cart can be manipulated using the cart module",
// "Product code" => "Product code",
// "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in",
// "Label for the product in the cart" => "Label for the product in the cart",
// "Price" => "Price",
// "The price to charge for the item" => "The price to charge for the item",
// "URL of the product\\'s information. The URL may be relative or absolute (begin with http://)" => "URL of the product\\'s information. The URL may be relative or absolute (begin with http://)",
// "Button label" => "Button label",
// "Text for the submit button. default: \"Add to cart\"" => "Text for the submit button. default: \"Add to cart\"",
// "A session must be active to use the cart" => "A session must be active to use the cart",
// "%0 (%1) was added to your cart" => "%0 (%1) was added to your cart",
// "Create an icon for a user to add an event to Google Calendar" => "Create an icon for a user to add an event to Google Calendar",
// "Add Event to Google Calendar" => "Add Event to Google Calendar",
// "PluginAddToGoogleCal" => "PluginAddToGoogleCal",
// "Creates an icon for a user to add an event to a Google Calendar" => "Creates an icon for a user to add an event to a Google Calendar",
// "Calendar item ID" => "Calendar item ID",
// "The item ID of the calendar to add to Google calendar" => "The item ID of the calendar to add to Google calendar",
// "A calendar item ID number" => "A calendar item ID number",
// "Icon Style" => "Icon Style",
// "Choose the icon style" => "Choose the icon style",
// "Either 1, 2 or 3" => "Either 1, 2 or 3",
// "One" => "One",
// "Two" => "Two",
// "Three" => "Three",
// "User Agent Info" => "User Agent Info",
// "PluginAgentinfo" => "PluginAgentinfo",
// "Display\\'s the visitor\\'s IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "Display\\'s the visitor\\'s IP address (IP or default), browser information (BROWSER), or server software (SVRSW)",
// "IP address" => "IP address",
// "Server software" => "Server software",
// "Browser" => "Browser",
// "PluginAlink" => "PluginAlink",
// "Page Name" => "Page Name",
// "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used",
// "PluginAname" => "PluginAname",
// "PluginAnnotation" => "PluginAnnotation",
// "Absolute URL to the image or relative path from tiki root" => "Absolute URL to the image or relative path from tiki root",
// "Image width in pixels" => "Image width in pixels",
// "Image height in pixels" => "Image height in pixels",
// "Image alignment. Possible values: left, right, center. Default is left" => "Image alignment. Possible values: left, right, center. Default is left",
// "Archive Builder" => "Archive Builder",
// "PluginArchiveBuilder" => "PluginArchiveBuilder",
// "Builds a zip archive containing the specified data from tikiwiki" => "Builds a zip archive containing the specified data from tikiwiki",
// "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435",
// "Archive Name" => "Archive Name",
// "Upon download, the name of the file that will be provided" => "Upon download, the name of the file that will be provided",
// "Missing extension zip" => "Missing extension zip",
// "Incorrect parameter" => "Incorrect parameter",
// "Download archive" => "Download archive",
// "PluginArticle" => "PluginArticle",
// "PluginArticles" => "PluginArticles",
// "Use Pagination" => "Use Pagination",
// "Activate pagination when articles listing are long. Default is n" => "Activate pagination when articles listing are long. Default is n",
// "Maximum Displayed" => "Maximum Displayed",
// "The number of articles to display in the list (no max set by default)" => "The number of articles to display in the list (no max set by default)",
// "If Pagination is set to y (Yes), this will determine the amount of artilces per page" => "If Pagination is set to y (Yes), this will determine the amount of artilces per page",
// "Topic Name Filter" => "Topic Name Filter",
// "Filter the list of aricles by their topic. Example: " => "Filter the list of aricles by their topic. Example: ",
// "Topic ID Filter" => "Topic ID Filter",
// "Filter the list of aricles by their topic ID. Example: " => "Filter the list of aricles by their topic ID. Example: ",
// "Type Filter" => "Type Filter",
// "Filter the list of aricles by their types. Example: " => "Filter the list of aricles by their types. Example: ",
// "The ID of the category that articles need to be in to be listed" => "The ID of the category that articles need to be in to be listed",
// "List only articles in this language" => "List only articles in this language",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Use random to have random items" => "Use random to have random items",
// "Whether to not report when there are no articles (no reporting by default)" => "Whether to not report when there are no articles (no reporting by default)",
// "Title Only" => "Title Only",
// "Whether to only show the title of the articles (not set to title only by default)" => "Whether to only show the title of the articles (not set to title only by default)",
// "Body Only" => "Body Only",
// "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)" => "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)",
// "Starting Article" => "Starting Article",
// "The article number that the list should start with (starts with first article by default)" => "The article number that the list should start with (starts with first article by default)",
// "This will not work if Pagination is used" => "This will not work if Pagination is used",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Override Dates" => "Override Dates",
// "Whether to obey article type\\'s \"show before publish\" and \"show after expiry\" settings (not obeyed by default)" => "Whether to obey article type\\'s \"show before publish\" and \"show after expiry\" settings (not obeyed by default)",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "Large First Image" => "Large First Image",
// "If set to y (Yes), the first image will be displayed with the dimension used to view of the article" => "If set to y (Yes), the first image will be displayed with the dimension used to view of the article",
// "Additional URL Param to the link to read article" => "Additional URL Param to the link to read article",
// "Show actions (buttons and links)" => "Show actions (buttons and links)",
// "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do",
// "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~",
// "PluginAttach" => "PluginAttach",
// "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment",
// "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page",
// "Show Description" => "Show Description",
// "Shows the description as the link text instead of the file name (not used by default)" => "Shows the description as the link text instead of the file name (not used by default)",
// "Makes the list of attachments a bulleted list (not set by default)" => "Makes the list of attachments a bulleted list (not set by default)",
// "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)",
// "Custom Label" => "Custom Label",
// "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed" => "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)",
// "Order Number" => "Order Number",
// "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. \n\t\t\t\t\t\t\t\t\t\tEither name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. \n\t\t\t\t\t\t\t\t\t\tEither name, file, id or num can be used to identify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment",
// "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)",
// "File Type Icon" => "File Type Icon",
// "A file type icon is displayed in front of the attachment link when this is set to 1" => "A file type icon is displayed in front of the attachment link when this is set to 1",
// "Attributes" => "Attributes",
// "PluginAttributes" => "PluginAttributes",
// "Allows for generic attributes to be assigned to the current object. Attributes are provided as parameters. For tiki.geo.lat, {attributes tiki_geo_lat=...}. Removing the plugin or values in it will not remove the attributes" => "Allows for generic attributes to be assigned to the current object. Attributes are provided as parameters. For tiki.geo.lat, {attributes tiki_geo_lat=...}. Removing the plugin or values in it will not remove the attributes",
// "PluginAuthor" => "PluginAuthor",
// "Color codes parts of the page like \\'Track changes\\' in Office programs" => "Color codes parts of the page like \\'Track changes\\' in Office programs",
// "User Name" => "User Name",
// "User name of the user who wrote the text" => "User name of the user who wrote the text",
// "Deleted by User" => "Deleted by User",
// "User name of the user who deleted the text" => "User name of the user who deleted the text",
// "Make Visible" => "Make Visible",
// "Show popup with author/deleted by" => "Show popup with author/deleted by",
// "Generate a popup with names of author(s) (default: no)" => "Generate a popup with names of author(s) (default: no)",
// "deleted by" => "deleted by",
// "Shows which author created/deleted which text" => "Shows which author created/deleted which text",
// "Should this author's contribution be visible (default: no)" => "Should this author's contribution be visible (default: no)",
// "PluginAvatar" => "PluginAvatar",
// "The wiki page the avatar will link to. If empty and the user\\'s information is public, \n\t\t\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user\\'s user information page" => "The wiki page the avatar will link to. If empty and the user\\'s information is public, \n\t\t\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user\\'s user information page",
// "Align the avatar on the page" => "Align the avatar on the page",
// "PluginBack" => "PluginBack",
// "Displays a link that goes back one page in the browser history" => "Displays a link that goes back one page in the browser history",
// "PluginBacklinks" => "PluginBacklinks",
// "Displayed Information" => "Displayed Information",
// "With or without self-link (default is without)" => "With or without self-link (default is without)",
// "Header" => "Header",
// "With or without header (default is with header)" => "With or without header (default is with header)",
// "With header" => "With header",
// "Without header" => "Without header",
// "No pages link to" => "No pages link to",
// "PluginBanner" => "PluginBanner",
// "Name of the zone created in Admin > Banners" => "Name of the zone created in Admin > Banners",
// "Determines the browser behavior once the banner is clicked" => "Determines the browser behavior once the banner is clicked",
// "Blank" => "Blank",
// "PluginBigBlueButton" => "PluginBigBlueButton",
// "Allows to join a BigBlueButton meeting" => "Allows to join a BigBlueButton meeting",
// "Meeting" => "Meeting",
// "MeetingID provided by BigBlueButton" => "MeetingID provided by BigBlueButton",
// "Anonymous prefix" => "Anonymous prefix",
// "Unregistered users will get this token prepended to their name" => "Unregistered users will get this token prepended to their name",
// "Welcome Message" => "Welcome Message",
// "A message to be provided when someone enters the room" => "A message to be provided when someone enters the room",
// "Dial Number" => "Dial Number",
// "The phone-in support number to join from traditional phones" => "The phone-in support number to join from traditional phones",
// "Voice Bridge" => "Voice Bridge",
// "Code to enter for phone attendees to join the room" => "Code to enter for phone attendees to join the room",
// "Logout URL" => "Logout URL",
// "URL to which the user will be redirected when logging out from BigBlueButton" => "URL to which the user will be redirected when logging out from BigBlueButton",
// "Maximum Participants" => "Maximum Participants",
// "Limit to the amount of simultaneous participants in the room. Support for this parameter depends on the BigBlueButton server" => "Limit to the amount of simultaneous participants in the room. Support for this parameter depends on the BigBlueButton server",
// "Bliptv" => "Bliptv",
// "PluginBliptv" => "PluginBliptv",
// "Display a Blip.tv video" => "Display a Blip.tv video",
// "Blip.tv embed URL. Please note that this url needs to be the src param in the EMBED code, and not the video URL as in other equivalent video plugins. Example: http://blip.tv/play/AYGd_GAC (instead of http://blip.tv/file/2568201/) " => "Blip.tv embed URL. Please note that this url needs to be the src param in the EMBED code, and not the video URL as in other equivalent video plugins. Example: http://blip.tv/play/AYGd_GAC (instead of http://blip.tv/file/2568201/) ",
// "Width in pixels (default is 425" => "Width in pixels (default is 425",
// "Height in pixels (default is 350)" => "Height in pixels (default is 350)",
// "PluginBlogList" => "PluginBlogList",
// "The ID number of the blog on the site you wish to list posts from" => "The ID number of the blog on the site you wish to list posts from",
// "Maximum Items" => "Maximum Items",
// "Maximum number of entries to list (no maximum set by default)" => "Maximum number of entries to list (no maximum set by default)",
// "Only display posts created by this user (all posts listed by default)" => "Only display posts created by this user (all posts listed by default)",
// "Simple List" => "Simple List",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
// "Latest date to select posts from" => "Latest date to select posts from",
// "Container Class" => "Container Class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "PluginBox" => "PluginBox",
// "Aligns the text within the box (left aligned by default)" => "Aligns the text within the box (left aligned by default)",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
// "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)" => "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)",
// "Button" => "Button",
// "PluginButton" => "PluginButton",
// "Produces a link with the shape of a button, reusing the button smarty function and requiring no validation of that plugin" => "Produces a link with the shape of a button, reusing the button smarty function and requiring no validation of that plugin",
// "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it" => "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it",
// "Label for the button" => "Label for the button",
// "lib/smarty_tiki/function.button.php is missing or unreadable" => "lib/smarty_tiki/function.button.php is missing or unreadable",
// "PluginCalendar" => "PluginCalendar",
// "Includes a calendar and/or a list of calendar events" => "Includes a calendar and/or a list of calendar events",
// "Calendar IDs" => "Calendar IDs",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")",
// "Example values" => "Example values",
// "Not set by default" => "Not set by default",
// "View Type" => "View Type",
// "Determines how to show events" => "Determines how to show events",
// "Possible values" => "Possible values",
// "\"table\" shows events in a calendar" => "\"table\" shows events in a calendar",
// "Default value" => "Default value",
// "View Time Span" => "View Time Span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar",
// "Default is month" => "Default is month",
// "Navigation Bar" => "Navigation Bar",
// "Decide or not to show the navigation bar (not shown by default)" => "Decide or not to show the navigation bar (not shown by default)",
// "PluginCategory" => "PluginCategory",
// "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img" => "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img",
// "Sort ascending or descending based on various attributes (sorted ascending by name by default)" => "Sort ascending or descending based on various attributes (sorted ascending by name by default)",
// "'), 'value' => '" => "'), 'value' => '",
// "Created Ascending" => "Created Ascending",
// "Created Descending" => "Created Descending",
// "Hits Ascending" => "Hits Ascending",
// "Hits Descending" => "Hits Descending",
// "Item ID Ascending" => "Item ID Ascending",
// "Item ID Descending" => "Item ID Descending",
// "Name Ascending" => "Name Ascending",
// "Name Descending" => "Name Descending",
// "Type Ascending" => "Type Ascending",
// "Type Descending" => "Type Descending",
// "Whether multiple categories will be listed on different lines (default is to split them)" => "Whether multiple categories will be listed on different lines (default is to split them)",
// "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)" => "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)",
// "With Sub-categories" => "With Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list sub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list sub-category objects)",
// "Show descriptions (not shown by default)" => "Show descriptions (not shown by default)",
// "Show Name" => "Show Name",
// "Show object names (shown by default)" => "Show object names (shown by default)",
// "Show type" => "Show type",
// "Show type (shown by default)" => "Show type (shown by default)",
// "One Per Line" => "One Per Line",
// "Show one object per line (multiple per line shown by default)" => "Show one object per line (multiple per line shown by default)",
// "Show Child Links" => "Show Child Links",
// "Show children category links (shown by default)" => "Show children category links (shown by default)",
// "Show Top Link" => "Show Top Link",
// "Show top category link (shown by default)" => "Show top category link (shown by default)",
// "Max Records" => "Max Records",
// "Maximum number of objects to list (default is 50)" => "Maximum number of objects to list (default is 50)",
// "Show Title" => "Show Title",
// "Show title text above category object lists (shown by default)" => "Show title text above category object lists (shown by default)",
// "PluginCatOrphans" => "PluginCatOrphans",
// "Display wiki pages that have not been categorized" => "Display wiki pages that have not been categorized",
// "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)" => "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)",
// "Max" => "Max",
// "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records" => "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start (default is no offset)" => "Result number at which the listing should start (default is no offset)",
// "PluginCatPath" => "PluginCatPath",
// "Display Top Category" => "Display Top Category",
// "Show the top category as part of the path name (not shown by default)" => "Show the top category as part of the path name (not shown by default)",
// "PluginCclite" => "PluginCclite",
// "General purpose cclite utility plugin" => "General purpose cclite utility plugin",
// "Mode of operation - summary or recent. Default: summary" => "Mode of operation - summary or recent. Default: summary",
// "Account summary" => "Account summary",
// "Recent transactions" => "Recent transactions",
// "Registry" => "Registry",
// "Registry to query. Default: site preference (or first in list when more than one)" => "Registry to query. Default: site preference (or first in list when more than one)",
// "You need to be logged in to view this information" => "You need to be logged in to view this information",
// "PluginCenter" => "PluginCenter",
// "BarStackGraphic | MultibarGraphic | MultilineGraphic | PieChartGraphic" => "BarStackGraphic | MultibarGraphic | MultilineGraphic | PieChartGraphic",
// "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors" => "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors",
// "PluginCode" => "PluginCode",
// "Enable word wrapping on the code to avoid breaking the layout. May not be used with line numbers if Geshi version 1.0.8.9+" => "Enable word wrapping on the code to avoid breaking the layout. May not be used with line numbers if Geshi version 1.0.8.9+",
// "Syntax highlighting to use. GeSHi - Generic Syntax Highlighter must be installed for languages other than php. Without GeSHi, the php tag must be included at the \n\t\t\t\t\t\t\t\t\tbeginning of the displayed code for the highlighting to work. May not be used with line numbers if Geshi version < 1.0.8.9. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Syntax highlighting to use. GeSHi - Generic Syntax Highlighter must be installed for languages other than php. Without GeSHi, the php tag must be included at the \n\t\t\t\t\t\t\t\t\tbeginning of the displayed code for the highlighting to work. May not be used with line numbers if Geshi version < 1.0.8.9. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "Line Numbers" => "Line Numbers",
// "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed" => "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed",
// "Parse wiki syntax within the code snippet (not parsed by default)" => "Parse wiki syntax within the code snippet (not parsed by default)",
// "Right to Left" => "Right to Left",
// "Switch the text display from left to right to right to left  (left to right by default)" => "Switch the text display from left to right to right to left  (left to right by default)",
// "When set to 1 (Yes), HTML will still be processed (presented as is by default)" => "When set to 1 (Yes), HTML will still be processed (presented as is by default)",
// "Show HTML" => "Show HTML",
// "Interpret HTML" => "Interpret HTML",
// "Copy To Clipboard" => "Copy To Clipboard",
// "Copy the contents of the code box to the clipboard  (not copied to clipboard by default)" => "Copy the contents of the code box to the clipboard  (not copied to clipboard by default)",
// "PluginColorBox" => "PluginColorBox",
// "File Gallery ID" => "File Gallery ID",
// "ID number of the file gallery that contains the images to be displayed" => "ID number of the file gallery that contains the images to be displayed",
// "Image Gallery ID" => "Image Gallery ID",
// "ID number of the image gallery that contains the images to be displayed" => "ID number of the image gallery that contains the images to be displayed",
// "File ID Filter" => "File ID Filter",
// "Filter on fileIds in a file gallery to only show those images. Separate each fileId with \\':\\'" => "Filter on fileIds in a file gallery to only show those images. Separate each fileId with \\':\\'",
// "Show File Title" => "Show File Title",
// "Show File Name" => "Show File Name",
// "Show All Thumbs" => "Show All Thumbs",
// "Show thumbnails of all the images in the gallery" => "Show thumbnails of all the images in the gallery",
// "Parse Descriptions" => "Parse Descriptions",
// "PluginContent" => "PluginContent",
// "Dynamic content ID. The value can be obtained in the listing" => "Dynamic content ID. The value can be obtained in the listing",
// "Content Label" => "Content Label",
// "Label of the dynamic content to display" => "Label of the dynamic content to display",
// "PluginCookie" => "PluginCookie",
// "Display a rotating set of taglines or quotes (also known as fortune cookies)" => "Display a rotating set of taglines or quotes (also known as fortune cookies)",
// "PluginCopyright" => "PluginCopyright",
// "PluginCountdown" => "PluginCountdown",
// "Set to off to only show days, otherwise hours, minutes and seconds are also shown (all are shown by default)" => "Set to off to only show days, otherwise hours, minutes and seconds are also shown (all are shown by default)",
// "Off" => "Off",
// "Items to Show" => "Items to Show",
// "Select: d=days, h=hours, m=minutes, s=seconds. Enter multiple values as: dhms. If blank, all items are shown" => "Select: d=days, h=hours, m=minutes, s=seconds. Enter multiple values as: dhms. If blank, all items are shown",
// "Days & Hours" => "Days & Hours",
// "Days, Hours & Minutes" => "Days, Hours & Minutes",
// "Days, Hours, Minutes & Seconds" => "Days, Hours, Minutes & Seconds",
// "Hours & Minutes" => "Hours & Minutes",
// "Hours, Minutes & Seconds" => "Hours, Minutes & Seconds",
// "Minutes & Seconds" => "Minutes & Seconds",
// "Seconds" => "Seconds",
// "Show time since event" => "Show time since event",
// "If y, will display amount of time since the event (default). If n will simply display that the event is over" => "If y, will display amount of time since the event (default). If n will simply display that the event is over",
// "since " => "since ",
// "until " => "until ",
// " is over" => " is over",
// "Data Channel" => "Data Channel",
// "PluginDataChannel" => "PluginDataChannel",
// "Displays a form to trigger data channels" => "Displays a form to trigger data channels",
// "List of fields to display. One field per line. Comma delimited: fieldname,label" => "List of fields to display. One field per line. Comma delimited: fieldname,label",
// "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"" => "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"",
// "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel" => "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel",
// "Channel Name" => "Channel Name",
// "Name of the channel as registered by the administrator" => "Name of the channel as registered by the administrator",
// "Return URL" => "Return URL",
// "URL to go to after data channel has run. Defaults to current page" => "URL to go to after data channel has run. Defaults to current page",
// "Do not use returnURI but instead return true quietly" => "Do not use returnURI but instead return true quietly",
// "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context" => "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context",
// "Button Label" => "Button Label",
// "Label for the submit button. Default: \"Go\"" => "Label for the submit button. Default: \"Go\"",
// "CSS class for this form" => "CSS class for this form",
// "Empty Caches" => "Empty Caches",
// "Which caches to empty. Default \"Clear all Tiki caches\"" => "Which caches to empty. Default \"Clear all Tiki caches\"",
// "Clear all Tiki caches" => "Clear all Tiki caches",
// "./templates_c/" => "./templates_c/",
// "./modules/cache/" => "./modules/cache/",
// "./temp/cache/" => "./temp/cache/",
// "./temp/public/" => "./temp/public/",
// "Price to execute the datachannel (%0)" => "Price to execute the datachannel (%0)",
// "Payment Label" => "Payment Label",
// "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)",
// "Multiple Values" => "Multiple Values",
// "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)",
// "Datachannel" => "Datachannel",
// "PluginDBReport" => "PluginDBReport",
// "Run a database report. This plugin only works with adodb. It does not work with PDO" => "Run a database report. This plugin only works with adodb. It does not work with PDO",
// "Wiki DSN Name" => "Wiki DSN Name",
// "Parse wiki syntax within the report (not parsed by default)" => "Parse wiki syntax within the report (not parsed by default)",
// "Display the parsed report definition (not displayed by default)" => "Display the parsed report definition (not displayed by default)",
// "PluginDiv" => "PluginDiv",
// "Insert a division block, span, blockquote or other text formatting on wiki page" => "Insert a division block, span, blockquote or other text formatting on wiki page",
// "Indicate the type of HTML tag to use (default is div)" => "Indicate the type of HTML tag to use (default is div)",
// "Span" => "Span",
// "Teletype" => "Teletype",
// "Paragraph" => "Paragraph",
// "Block quote" => "Block quote",
// "In pixels or percentage. Default is original size" => "In pixels or percentage. Default is original size",
// "Aligns the text within the element" => "Aligns the text within the element",
// "Justify" => "Justify",
// "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
// "Items are not allowed to wrap around the side(s) this parameter is set to" => "Items are not allowed to wrap around the side(s) this parameter is set to",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "HTML ID" => "HTML ID",
// "Sets the div\\'s id attribute, as defined by HTML" => "Sets the div\\'s id attribute, as defined by HTML",
// "PluginDL" => "PluginDL",
// "PluginEquation" => "PluginEquation",
// "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large" => "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large",
// "PluginEvents" => "PluginEvents",
// "Display upcoming events from calendars" => "Display upcoming events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)" => "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)",
// "Maximum Days" => "Maximum Days",
// "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days" => "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days",
// "Maximum Events" => "Maximum Events",
// "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)" => "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)",
// "Show Time" => "Show Time",
// "Show the time along with the date (shown by default)" => "Show the time along with the date (shown by default)",
// "Show the description of the event (shown by default)" => "Show the description of the event (shown by default)",
// "PluginFade" => "PluginFade",
// "PluginFancyList" => "PluginFancyList",
// "Use Div" => "Use Div",
// "Use the HTML tag div instead of the HTML tag for lists (ol)" => "Use the HTML tag div instead of the HTML tag for lists (ol)",
// "PluginFancyTable" => "PluginFancyTable",
// "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases" => "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases",
// "Heading Row" => "Heading Row",
// "Header rows of the table. Use >> to separate multiple rows" => "Header rows of the table. Use >> to separate multiple rows",
// "Header Horizontal Align" => "Header Horizontal Align",
// "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify" => "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify",
// "Header Vertical Align" => "Header Vertical Align",
// "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline" => "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline",
// "Column Sort" => "Column Sort",
// "Indicate whether columns are sortable or not (not sortable by default)" => "Indicate whether columns are sortable or not (not sortable by default)",
// "Pre-sorted Columns" => "Pre-sorted Columns",
// "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]" => "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]",
// "Column Widths" => "Column Widths",
// "Column widths followed by px for pixels or % for percentages. Each column separated by |" => "Column widths followed by px for pixels or % for percentages. Each column separated by |",
// "Cell Horizontal Align" => "Cell Horizontal Align",
// "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify" => "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify",
// "Cell Vertical Align" => "Cell Vertical Align",
// "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline" => "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline",
// "heads and cells separated by |" => "heads and cells separated by |",
// "PluginFile" => "PluginFile",
// "Displays a link to a file (either from the file gallery or an attachment to a wiki page) and can display an image attachment. For more than one file from file galleries, or more optional information shown from the files, use the plugin FILES instead" => "Displays a link to a file (either from the file gallery or an attachment to a wiki page) and can display an image attachment. For more than one file from file galleries, or more optional information shown from the files, use the plugin FILES instead",
// "Label for the link to the file" => "Label for the link to the file",
// "Indicate whether the file is in a file gallery or is a wiki page attachment" => "Indicate whether the file is in a file gallery or is a wiki page attachment",
// "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used" => "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used",
// "Custom Description" => "Custom Description",
// "Custom text that will be used for the link instead of the file name or file description" => "Custom text that will be used for the link instead of the file name or file description",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty",
// "Attachment Description" => "Attachment Description",
// "Show the attachment description as the link label instead of the attachment file name" => "Show the attachment description as the link label instead of the attachment file name",
// "Indicates that this attachment is an image, and should be displayed inline using the img tag" => "Indicates that this attachment is an image, and should be displayed inline using the img tag",
// "File ID of a file in a file gallery or an archive" => "File ID of a file in a file gallery or an archive",
// "Example value" => "Example value",
// "For an archive file, the archive created just before this date will be linked to" => "For an archive file, the archive created just before this date will be linked to",
// "Show Icon" => "Show Icon",
// "Show an icon version of the file or file type with the link to the file" => "Show an icon version of the file or file type with the link to the file",
// "File Gallery File/Archive" => "File Gallery File/Archive",
// "Wiki Page Attachment" => "Wiki Page Attachment",
// "The date has not been set" => "The date has not been set",
// "Incorrect date format" => "Incorrect date format",
// "No such file" => "No such file",
// "Wiki attachments are disabled" => "Wiki attachments are disabled",
// "PluginFiles" => "PluginFiles",
// "Displays a list of files from a file gallery" => "Displays a list of files from a file gallery",
// "To list only files contained in this file gallery" => "To list only files contained in this file gallery",
// "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon",
// "To list only specified files, enter their file IDs separated by colon" => "To list only specified files, enter their file IDs separated by colon",
// "Order ascending or descending based on any field in the file gallery table. Default is name_asc" => "Order ascending or descending based on any field in the file gallery table. Default is name_asc",
// "Show Action" => "Show Action",
// "Show a column with icons for the various actions the user can take with each file (not shown by default)" => "Show a column with icons for the various actions the user can take with each file (not shown by default)",
// "Show Find" => "Show Find",
// "Show a search box above the list (not shown by default)" => "Show a search box above the list (not shown by default)",
// "Show the title of the file gallery (shown by default)" => "Show the title of the file gallery (shown by default)",
// "Show ID" => "Show ID",
// "Show the ID number of each file (shown by default)" => "Show the ID number of each file (shown by default)",
// "Show an icon for each file depicting the file type" => "Show an icon for each file depicting the file type",
// "Show the name given to the file upon upload into the file gallery (shown by default)" => "Show the name given to the file upon upload into the file gallery (shown by default)",
// "Show Filename" => "Show Filename",
// "Show each file\\'s filename (shown by default)" => "Show each file\\'s filename (shown by default)",
// "Show Size" => "Show Size",
// "Show the size of each file in kilobytes (shown by default)" => "Show the size of each file in kilobytes (shown by default)",
// "Show the description of the file given upon upload into the file gallery (shown by default)" => "Show the description of the file given upon upload into the file gallery (shown by default)",
// "Show Creation Date" => "Show Creation Date",
// "Show the date each file was created (not shown by default)" => "Show the date each file was created (not shown by default)",
// "Show Last Modification Date" => "Show Last Modification Date",
// "Show the date each file was last modified (shown by default)" => "Show the date each file was last modified (shown by default)",
// "Show Hits" => "Show Hits",
// "Show the number of hits each file has received (not shown by default)" => "Show the number of hits each file has received (not shown by default)",
// "Show Locked By" => "Show Locked By",
// "For locked files, show the user name of the user who locked it (not shown by default)" => "For locked files, show the user name of the user who locked it (not shown by default)",
// "Show the user name of the user who is the author of the file (not shown by default)" => "Show the user name of the user who is the author of the file (not shown by default)",
// "Show Creator" => "Show Creator",
// "Show the user name of the user who is the creator of the file (not shown by default)" => "Show the user name of the user who is the creator of the file (not shown by default)",
// "Show Parent Gallery Name" => "Show Parent Gallery Name",
// "Show the name of the parent gallery" => "Show the name of the parent gallery",
// "Show File Count" => "Show File Count",
// "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)",
// "Show Slideshow" => "Show Slideshow",
// "Show a link that produces a pop-up slide show when clicked (not set by default)" => "Show a link that produces a pop-up slide show when clicked (not set by default)",
// "Show Comment" => "Show Comment",
// "Show comments for each file (not shown by default)" => "Show comments for each file (not shown by default)",
// "Show Last Editor" => "Show Last Editor",
// "Show the user name of the user who last modified the file (shown by default)" => "Show the user name of the user who last modified the file (shown by default)",
// "Show only files created by this user" => "Show only files created by this user",
// "Show Upload" => "Show Upload",
// "Show a simple upload form to the gallery (not shown by default)" => "Show a simple upload form to the gallery (not shown by default)",
// "PluginFlash" => "PluginFlash",
// "Flash Type" => "Flash Type",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo",
// "Select an option" => "Select an option",
// "Blip.tv" => "Blip.tv",
// "File Gallery Podcast" => "File Gallery Podcast",
// "Vimeo" => "Vimeo",
// "Youtube" => "Youtube",
// "Complete URL to the movie to include. e.g. files/test.swf" => "Complete URL to the movie to include. e.g. files/test.swf",
// "File Gallery Podcast ID" => "File Gallery Podcast ID",
// "Id of a file from a podcast gallery - will work only with podcast gallery" => "Id of a file from a podcast gallery - will work only with podcast gallery",
// "Youtube URL" => "Youtube URL",
// "Entire URL to the YouTube video. Example: http://www.youtube.com/watch?v=1i2ZnU4iR24" => "Entire URL to the YouTube video. Example: http://www.youtube.com/watch?v=1i2ZnU4iR24",
// "Vimeo URL" => "Vimeo URL",
// "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966" => "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966",
// "Blip.tv URL" => "Blip.tv URL",
// "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC" => "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC",
// "Width of movie in pixels (default is 425)" => "Width of movie in pixels (default is 425)",
// "Height of movie in pixels (default is 350)" => "Height of movie in pixels (default is 350)",
// "Medium" => "Medium",
// "Invalid URL" => "Invalid URL",
// "PluginFootnote" => "PluginFootnote",
// "Sameas" => "Sameas",
// "Tag to existing footnote" => "Tag to existing footnote",
// "CheckDuplicate" => "CheckDuplicate",
// "Check for duplicate footnotes" => "Check for duplicate footnotes",
// "PluginFootnoteArea" => "PluginFootnoteArea",
// "Freetagged" => "Freetagged",
// "PluginFreetagged" => "PluginFreetagged",
// "Find similarly tagged objects" => "Find similarly tagged objects",
// "Tags to find similar to" => "Tags to find similar to",
// "Leave blank to use the object\\'s own tags" => "Leave blank to use the object\\'s own tags",
// "Type of objects to extract. Set to All to find all types" => "Type of objects to extract. Set to All to find all types",
// "Same" => "Same",
// "Offset" => "Offset",
// "Start record" => "Start record",
// "Default -1 (all)" => "Default -1 (all)",
// "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)" => "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)",
// "Comments Locked Ascending" => "Comments Locked Ascending",
// "Comments Locked Descending" => "Comments Locked Descending",
// "Description Ascending" => "Description Ascending",
// "Description Descending" => "Description Descending",
// "Href Ascending" => "Href Ascending",
// "Href Descending" => "Href Descending",
// "Object ID Ascending" => "Object ID Ascending",
// "Object ID Descending" => "Object ID Descending",
// "Show objects with names or descriptions similar to the text entered here" => "Show objects with names or descriptions similar to the text entered here",
// "Broaden" => "Broaden",
// "n|y" => "n|y",
// "Header Level" => "Header Level",
// "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags" => "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags",
// "Show Titles Only" => "Show Titles Only",
// "Choose whether to show titles only (not shown by default)" => "Choose whether to show titles only (not shown by default)",
// "Maximum Image Size" => "Maximum Image Size",
// "Height or width in pixels. Default = 0 (no maximum)" => "Height or width in pixels. Default = 0 (no maximum)",
// "FTP" => "FTP",
// "PluginFTP" => "PluginFTP",
// "Download box for a file on an FTP server" => "Download box for a file on an FTP server",
// "Server Name" => "Server Name",
// "Name of the server where the FTP account is housed. Example: " => "Name of the server where the FTP account is housed. Example: ",
// "User name needed to access the FTP account" => "User name needed to access the FTP account",
// "Password needed to access the FTP account" => "Password needed to access the FTP account",
// "Download Button Label" => "Download Button Label",
// "Label for the FTP download button" => "Label for the FTP download button",
// "PluginGauge" => "PluginGauge",
// "Current value to be represented by the gauge" => "Current value to be represented by the gauge",
// "Main color of the gauge. Use HTML color codes or names" => "Main color of the gauge. Use HTML color codes or names",
// "Background color of the gauge. Use HTML color codes or names" => "Background color of the gauge. Use HTML color codes or names",
// "Set to true (Yes) to display a percentage of the maximum" => "Set to true (Yes) to display a percentage of the maximum",
// "Set to false (No) to hide the numeric value (shown by default)" => "Set to false (No) to hide the numeric value (shown by default)",
// "PluginGoogleAnalytics" => "PluginGoogleAnalytics",
// "Account Number" => "Account Number",
// "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY" => "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY",
// "Google Doc" => "Google Doc",
// "PluginGoogleDoc" => "PluginGoogleDoc",
// "Document" => "Document",
// "Presentation" => "Presentation",
// "Name of iframe. Default is \"Frame\" + the key" => "Name of iframe. Default is \"Frame\" + the key",
// "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly",
// "Small" => "Small",
// "Large" => "Large",
// "Width in pixels or %" => "Width in pixels or %",
// "Height in pixels or %" => "Height in pixels or %",
// "Middle" => "Middle",
// "Choose whether to show a border around the iframe" => "Choose whether to show a border around the iframe",
// "Margin height in pixels" => "Margin height in pixels",
// "Margin width in pixels" => "Margin width in pixels",
// "Choose whether to add a scroll bar" => "Choose whether to add a scroll bar",
// "Auto" => "Auto",
// "Edit Link" => "Edit Link",
// "Choose whether to show an edit link and set its location" => "Choose whether to show an edit link and set its location",
// "googlemap" => "googlemap",
// "PluginGoogleMap" => "PluginGoogleMap",
// "Displays a Google map" => "Displays a Google map",
// "Type of items to show on google map" => "Type of items to show on google map",
// "Locator" => "Locator",
// "Object List" => "Object List",
// "Tracker Field" => "Tracker Field",
// "Display Mode" => "Display Mode",
// "Map display mode" => "Map display mode",
// "Satellite" => "Satellite",
// "Hybrid" => "Hybrid",
// "API Key" => "API Key",
// "Google maps key, if not set in user preferences" => "Google maps key, if not set in user preferences",
// "Map ID" => "Map ID",
// "Id suffix of Google map div to avoid conflicts with other maps on same page" => "Id suffix of Google map div to avoid conflicts with other maps on same page",
// "Show Border" => "Show Border",
// "Choose whether to show a frame border around the map (no border shown by default)" => "Choose whether to show a frame border around the map (no border shown by default)",
// "Default Center Longitude" => "Default Center Longitude",
// "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature" => "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature",
// "Default Center Latitude" => "Default Center Latitude",
// "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature" => "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature",
// "Default Zoom" => "Default Zoom",
// "Use an integer between 0 and 19 to set a default zoom level for the map. Default is the default set in the Gmap feature" => "Use an integer between 0 and 19 to set a default zoom level for the map. Default is the default set in the Gmap feature",
// "Save View" => "Save View",
// "Allow user to set current map view as default view for himself only" => "Allow user to set current map view as default view for himself only",
// "Item Type" => "Item Type",
// "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified" => "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified",
// "Item ID" => "Item ID",
// "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified" => "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified",
// "Hide If No Markers" => "Hide If No Markers",
// "Hide map if there are no markers to be shown. Default is to show the map" => "Hide map if there are no markers to be shown. Default is to show the map",
// "Visibility Toggle" => "Visibility Toggle",
// "Add ability to toggle visibility. No toggle by default" => "Add ability to toggle visibility. No toggle by default",
// "Start Hidden" => "Start Hidden",
// "Choose whether to keep the map hidden initially. Default is to show the map initially" => "Choose whether to keep the map hidden initially. Default is to show the map initially",
// "Auto Zoom" => "Auto Zoom",
// "Use an integer between 0 and 19 to auto zoom to this level on address find" => "Use an integer between 0 and 19 to auto zoom to this level on address find",
// "Show Controls" => "Show Controls",
// "Show map controls (shown by default)" => "Show map controls (shown by default)",
// "Tracker Field ID" => "Tracker Field ID",
// "Field ID of tracker field if type is trackerfield or locator and locateitemtype is trackeritem" => "Field ID of tracker field if type is trackerfield or locator and locateitemtype is trackeritem",
// "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms" => "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms",
// "In Form" => "In Form",
// "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML" => "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML",
// "Google Maps API key not set" => "Google Maps API key not set",
// "No such user" => "No such user",
// "No such object" => "No such object",
// "Not logged in" => "Not logged in",
// "Error: Invalid Lon. and Lat. values" => "Error: Invalid Lon. and Lat. values",
// "Map view saved as default for " => "Map view saved as default for ",
// "You can only set your own location" => "You can only set your own location",
// "Please select a point to set both Lon. and Lat" => "Please select a point to set both Lon. and Lat",
// "User location saved for " => "User location saved for ",
// "You cannot edit this object or no such object" => "You cannot edit this object or no such object",
// "Location saved for object" => "Location saved for object",
// "Error saving location" => "Error saving location",
// "PluginGroup" => "PluginGroup",
// "Allowed User Friends" => "Allowed User Friends",
// "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo" => "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo",
// "Display wiki text if user is in one of listed groups or group of friends" => "Display wiki text if user is in one of listed groups or group of friends",
// "Group List" => "Group List",
// "PluginGroupList" => "PluginGroupList",
// "List all groups or just groups that include a certain group" => "List all groups or just groups that include a certain group",
// "Group Name" => "Group Name",
// "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed",
// "Group Home Page" => "Group Home Page",
// "Link the group name to the group home page, if there is one (not linked by default)" => "Link the group name to the group home page, if there is one (not linked by default)",
// "Recursively List Groups" => "Recursively List Groups",
// "Recurse on the included groups (default is not to recurse)" => "Recurse on the included groups (default is not to recurse)",
// "GroupMailCore" => "GroupMailCore",
// "PluginGroupMailCore" => "PluginGroupMailCore",
// "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile" => "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile",
// "From Email" => "From Email",
// "Email address to report" => "Email address to report",
// "Tracker Id" => "Tracker Id",
// "Id of GroupMail Logs tracker (set up in alias by profile)" => "Id of GroupMail Logs tracker (set up in alias by profile)",
// "From Field Id" => "From Field Id",
// "Id of GroupMail Logs tracker field (usually set up in alias by profile)" => "Id of GroupMail Logs tracker field (usually set up in alias by profile)",
// "Operator Field Id" => "Operator Field Id",
// "Subject Field Id" => "Subject Field Id",
// "Message Field Id" => "Message Field Id",
// "Content Field Id" => "Content Field Id",
// "Account Field Id" => "Account Field Id",
// "Datetime Field Id" => "Datetime Field Id",
// "Displays GroupMail functions on a wiki page" => "Displays GroupMail functions on a wiki page",
// "Group Stats" => "Group Stats",
// "PluginGroupStat" => "PluginGroupStat",
// "Displays the percentage of total users that are members of groups" => "Displays the percentage of total users that are members of groups",
// "Groups separated by :. If empty, all groups will be listed" => "Groups separated by :. If empty, all groups will be listed",
// "Show Percentage" => "Show Percentage",
// "Show the percentage of total users that are members of each group (percentages are shown by default)" => "Show the percentage of total users that are members of each group (percentages are shown by default)",
// "Show Bar" => "Show Bar",
// "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)",
// "PluginHTML" => "PluginHTML",
// "Parse wiki syntax within the html code" => "Parse wiki syntax within the html code",
// "PluginIframe" => "PluginIframe",
// "Frame title" => "Frame title",
// "Align the ifram on the page" => "Align the ifram on the page",
// "Frame Border" => "Frame Border",
// "PluginImg" => "PluginImg",
// "Display images" => "Display images",
// "Image source" => "Image source",
// "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required" => "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required",
// "Numeric ID of an image in an Image Gallery (or list separated by commas or |)" => "Numeric ID of an image in an Image Gallery (or list separated by commas or |)",
// "Numeric ID of an image in a File Gallery (or list separated by commas or |)" => "Numeric ID of an image in a File Gallery (or list separated by commas or |)",
// "Numeric ID of a File Gallery. Displays a random image from that gallery" => "Numeric ID of a File Gallery. Displays a random image from that gallery",
// "Attachment ID" => "Attachment ID",
// "Numeric ID of an image attached to a wiki page (or list separated by commas or |)" => "Numeric ID of an image attached to a wiki page (or list separated by commas or |)",
// "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments",
// "Full size image appears when thumbnail is clicked" => "Full size image appears when thumbnail is clicked",
// "Mouseover" => "Mouseover",
// "Full size image will pop up while cursor is over the thumbnail (and disappear when not)" => "Full size image will pop up while cursor is over the thumbnail (and disappear when not)",
// "Mouseover (Sticky)" => "Mouseover (Sticky)",
// "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup" => "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup",
// "Popup" => "Popup",
// "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked" => "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked",
// "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery",
// "Browse Popup" => "Browse Popup",
// "Same as \"browse\" except that the page opens in a new window or tab" => "Same as \"browse\" except that the page opens in a new window or tab",
// "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked" => "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked",
// "Enlarge button" => "Enlarge button",
// "Button for enlarging image" => "Button for enlarging image",
// "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting" => "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting",
// "Link relation" => "Link relation",
// "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation" => "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation",
// "Image map" => "Image map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
// "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
// "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
// "Maximum image size" => "Maximum image size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings",
// "Align image" => "Align image",
// "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box" => "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box",
// "Image style" => "Image style",
// "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects",
// "Align image block" => "Align image block",
// "Aligns the box containing the image" => "Aligns the box containing the image",
// "Image block style" => "Image block style",
// "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects",
// "Description style" => "Description style",
// "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects" => "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects",
// "Wrapping control" => "Wrapping control",
// "Control how other items wrap around the image" => "Control how other items wrap around the image",
// "CSS class to apply to the image" => "CSS class to apply to the image",
// "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description" => "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description",
// "Link title" => "Link title",
// "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title" => "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title",
// "Alternate text" => "Alternate text",
// "Alternate text that displays when image does not load. Set to \"Image\" by default" => "Alternate text that displays when image does not load. Set to \"Image\" by default",
// "Default config settings" => "Default config settings",
// "Default configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "Mandatory admin setting" => "Mandatory admin setting",
// "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "File is not an image" => "File is not an image",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "Enlarge" => "Enlarge",
// "''No image specified. Either the fileId, randomGalleryId, attId, id, or src parameter must be specified.''" => "''No image specified. Either the fileId, randomGalleryId, attId, id, or src parameter must be specified.''",
// "''Use one and only one of the following parameters: fileId, randomGalleryId, attId, id, or src.''" => "''Use one and only one of the following parameters: fileId, randomGalleryId, attId, id, or src.''",
// "PluginInclude" => "PluginInclude",
// "Include a page\\'s content" => "Include a page\\'s content",
// "Wiki page name to include" => "Wiki page name to include",
// "When only a portion of the page should be included, specify the marker from which inclusion should start" => "When only a portion of the page should be included, specify the marker from which inclusion should start",
// "When only a portion of the page should be included, specify the marker at which inclusion should end" => "When only a portion of the page should be included, specify the marker at which inclusion should end",
// "Nopage Text" => "Nopage Text",
// "Text to show when no page is found" => "Text to show when no page is found",
// "Page Denied Text" => "Page Denied Text",
// "Text to show when the page exists but is denied to the user" => "Text to show when the page exists but is denied to the user",
// "Invite" => "Invite",
// "PluginInvite" => "PluginInvite",
// "Invite an email in groups" => "Invite an email in groups",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Including Group" => "Including Group",
// "Will list only the groups that include this group" => "Will list only the groups that include this group",
// "Dropdown list will show this group by default" => "Dropdown list will show this group by default",
// "Dropdown list will show the group related to this item ID (in group selector or creator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or creator field) by default",
// "Jabber" => "Jabber",
// "PluginJabber" => "PluginJabber",
// "Applet height in pixels" => "Applet height in pixels",
// "Applet width in pixels" => "Applet width in pixels",
// "XML Host Name" => "XML Host Name",
// "Web site where XML is hosted. Default is jabber.org" => "Web site where XML is hosted. Default is jabber.org",
// "Default Color" => "Default Color",
// "Set default color. Default is 255,255,255" => "Set default color. Default is 255,255,255",
// "jQuery" => "jQuery",
// "PluginJQ" => "PluginJQ",
// "Inserts JavaScript code. By default this is only executed after jQuery determines that the DOM is fully loaded" => "Inserts JavaScript code. By default this is only executed after jQuery determines that the DOM is fully loaded",
// "JavaScript code" => "JavaScript code",
// "Not On Ready" => "Not On Ready",
// "No JavaScript" => "No JavaScript",
// "Optional markup for when JavaScript is off" => "Optional markup for when JavaScript is off",
// "Insert JQuery javascript code" => "Insert JQuery javascript code",
// "jquery code e.g. \$(\"img\\" => "jquery code e.g. \$(\"img\\",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "Javascript" => "Javascript",
// "PluginJS" => "PluginJS",
// "Insert a javascript file and/or some javascript code" => "Insert a javascript file and/or some javascript code",
// "javascript code" => "javascript code",
// "Javascript filename" => "Javascript filename",
// "Insert a javascript file or/and some javascript code" => "Insert a javascript file or/and some javascript code",
// "Kaltura video" => "Kaltura video",
// "PluginKaltura" => "PluginKaltura",
// "Displays a KALTURA video on the wiki page" => "Displays a KALTURA video on the wiki page",
// "Kaltura Entry ID" => "Kaltura Entry ID",
// "Kaltura entry ID of the video to be displayed" => "Kaltura entry ID of the video to be displayed",
// "PluginLang" => "PluginLang",
// "Displays the text only if the language matches" => "Displays the text only if the language matches",
// "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "PluginLastMod" => "PluginLastMod",
// "The Last Mod plugin displays the last modification time of the named wiki page, or the current page if no name given" => "The Last Mod plugin displays the last modification time of the named wiki page, or the current page if no name given",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "PluginListpages" => "PluginListpages",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Limit number of items displayed in the list. Default is to display all" => "Limit number of items displayed in the list. Default is to display all",
// "Initial" => "Initial",
// "txt" => "txt",
// "Show Name Only" => "Show Name Only",
// "Show only the page names" => "Show only the page names",
// "Category filter" => "Category filter",
// "If set to a category identifier, restrict the pages displayed to those in the specified category" => "If set to a category identifier, restrict the pages displayed to those in the specified category",
// "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories" => "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories",
// "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories" => "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories",
// "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories" => "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories",
// "Structure Head" => "Structure Head",
// "Filter by structure head" => "Filter by structure head",
// "Show Page Alias" => "Show Page Alias",
// "Show page alias in the list" => "Show page alias in the list",
// "Only pages with names similar the text entered for this parameter will be listed" => "Only pages with names similar the text entered for this parameter will be listed",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Exact Match" => "Exact Match",
// "Page name and text entered for the filter parameter must match exactly to be listed" => "Page name and text entered for the filter parameter must match exactly to be listed",
// "Only Orphan Pages" => "Only Orphan Pages",
// "Only list orphan pages" => "Only list orphan pages",
// "For List Pages" => "For List Pages",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: " => "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: ",
// "Length" => "Length",
// "Number of characters to display" => "Number of characters to display",
// "List Directory" => "List Directory",
// "PluginLsDir" => "PluginLsDir",
// "Full path to the server-local directory. Default is the document root" => "Full path to the server-local directory. Default is the document root",
// "URL Prefix" => "URL Prefix",
// "Make the file name a link to the file by adding the url path preceding the file name. Example: http://yoursite.com/tiki/" => "Make the file name a link to the file by adding the url path preceding the file name. Example: http://yoursite.com/tiki/",
// "Set the sort order of the file list" => "Set the sort order of the file list",
// "File Size" => "File Size",
// "Last Access" => "Last Access",
// "Last Metadata Change" => "Last Metadata Change",
// "Only list files with filenames that contain this filter. Example: \".jpg\"" => "Only list files with filenames that contain this filter. Example: \".jpg\"",
// "Limit" => "Limit",
// "Maximum amount of files to display. Default is no limit" => "Maximum amount of files to display. Default is no limit",
// "PluginMail" => "PluginMail",
// "Directly mail other users or groups" => "Directly mail other users or groups",
// "Limit the group to the groups including this group" => "Limit the group to the groups including this group",
// "Show Group Dropdown" => "Show Group Dropdown",
// "Show a dropdown list of groups (not shown by default)" => "Show a dropdown list of groups (not shown by default)",
// "Show User Dropdown" => "Show User Dropdown",
// "Show a dropdown list of users (not shown by default)" => "Show a dropdown list of users (not shown by default)",
// "User Autocomplete" => "User Autocomplete",
// "Show an autocomplete box on user name" => "Show an autocomplete box on user name",
// "Real Name Dropdown" => "Real Name Dropdown",
// "Show a dropdown list of user real names (not shown by default)" => "Show a dropdown list of user real names (not shown by default)",
// "PluginMap" => "PluginMap",
// "Map File" => "Map File",
// "Map file identifier" => "Map file identifier",
// "Extents" => "Extents",
// "Size of the map" => "Size of the map",
// "Width of the map" => "Width of the map",
// "Height of the map" => "Height of the map",
// "Mayan Calendars Info" => "Mayan Calendars Info",
// "PluginMCalendarInfo" => "PluginMCalendarInfo",
// "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count" => "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count",
// "You must use the variable substitution" => "You must use the variable substitution",
// "LongCount: " => "LongCount: ",
// "Tzolkin: " => "Tzolkin: ",
// "Haab: " => "Haab: ",
// "Misc: " => "Misc: ",
// "Example: template " => "Example: template ",
// "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
// "Default template: " => "Default template: ",
// "Gregorian date" => "Gregorian date",
// "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date" => "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date",
// "Mayan Calendars" => "Mayan Calendars",
// " is not a valid date format. should be dd.mm.yyyy" => " is not a valid date format. should be dd.mm.yyyy",
// "Inline Flash mp3 and flv Player" => "Inline Flash mp3 and flv Player",
// "Mediaplayer" => "Mediaplayer",
// "PluginMediaplayer" => "PluginMediaplayer",
// "Simple mp3 or flv Player" => "Simple mp3 or flv Player",
// "Allow Fullscreen" => "Allow Fullscreen",
// "Allow fullscreen mode" => "Allow fullscreen mode",
// "MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "Complete URL to the media to include" => "Complete URL to the media to include",
// "One of" => "One of",
// "Flash Window Mode" => "Flash Window Mode",
// "Sets the Window Mode property of the Flash movie. Transparent lets what\\'s behind the movie show through and allows the movie to be covered \n\t\t\t\t\t\t\t\t\t\t Opaque hides what\\'s behind the movie and Window plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what\\'s behind the movie show through and allows the movie to be covered \n\t\t\t\t\t\t\t\t\t\t Opaque hides what\\'s behind the movie and Window plays the movie in its own window. Default value: ",
// "Opaque" => "Opaque",
// "Window" => "Window",
// "Member List" => "Member List",
// "PluginMemberList" => "PluginMemberList",
// "Lists the members of selected groups and allows to add or remove members if permissions are granted" => "Lists the members of selected groups and allows to add or remove members if permissions are granted",
// "List of groups to handle through the interface. Colon separated" => "List of groups to handle through the interface. Colon separated",
// "Member Payment" => "Member Payment",
// "PluginMemberPayment" => "PluginMemberPayment",
// "Receive payments from a member and extend the length of the membership to a group" => "Receive payments from a member and extend the length of the membership to a group",
// "Name of the group for which the subscription should be added or extended" => "Name of the group for which the subscription should be added or extended",
// "Price per period (%0)" => "Price per period (%0)",
// "Current User Member" => "Current User Member",
// "Membership only for the current user" => "Membership only for the current user",
// "Input Title" => "Input Title",
// "Title of the input form" => "Title of the input form",
// "Use %0 for the group name" => "Use %0 for the group name",
// "Supports wiki syntax" => "Supports wiki syntax",
// "How Title" => "How Title",
// "Use %0 for the group name, %4 for the number of days or %5 for the number of years" => "Use %0 for the group name, %4 for the number of days or %5 for the number of years",
// "Membership to %0 for %1 (x%2)" => "Membership to %0 for %1 (x%2)",
// "Membership to %0 for %1 users (x%2)" => "Membership to %0 for %1 users (x%2)",
// "The group " => "The group ",
// " does not have a membership term" => " does not have a membership term",
// " Go to " => " Go to ",
// "Admin > Groups" => "Admin > Groups",
// " to specify a term for this group by automatically unassigning users after a certain number of days" => " to specify a term for this group by automatically unassigning users after a certain number of days",
// " does not exist" => " does not exist",
// "Mini Quiz" => "Mini Quiz",
// "PluginMiniQuiz" => "PluginMiniQuiz",
// "Displays a miniquiz" => "Displays a miniquiz",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Tracker ID" => "Tracker ID",
// "Numeric value representing the miniquiz tracker ID" => "Numeric value representing the miniquiz tracker ID",
// "Insert Module" => "Insert Module",
// "PluginModule" => "PluginModule",
// "Displays a module inline in a wiki page. More parameters can be added, not supported by User Interface" => "Displays a module inline in a wiki page. More parameters can be added, not supported by User Interface",
// "Module name as known in Tiki" => "Module name as known in Tiki",
// "Align the module to the left or right on the page allowing other elements to align against it" => "Align the module to the left or right on the page allowing other elements to align against it",
// "Decoration" => "Decoration",
// "Show box decorations (default is to show them)" => "Show box decorations (default is to show them)",
// "Add ability to show/hide the content of the module (default is the site admin setting for modules)" => "Add ability to show/hide the content of the module (default is the site admin setting for modules)",
// "Parse wiki syntax (default is to parse)" => "Parse wiki syntax (default is to parse)",
// "Show/hide module title (default is to show the title)" => "Show/hide module title (default is to show the title)",
// "Show title" => "Show title",
// "Hide title" => "Hide title",
// "Monospace" => "Monospace",
// "PluginMono" => "PluginMono",
// "Font name as known in browsers" => "Font name as known in browsers",
// "PluginMouseover" => "PluginMouseover",
// "Create a mouseover feature on some text" => "Create a mouseover feature on some text",
// "Mouseover text if param label exists. Page text if text param exists" => "Mouseover text if param label exists. Page text if text param exists",
// "Text displayed on the page. The body is the mouseover content" => "Text displayed on the page. The body is the mouseover content",
// "Destination link when mouseover text is clicked. Use http:// for external links" => "Destination link when mouseover text is clicked. Use http:// for external links",
// "DEPRECATED" => "DEPRECATED",
// "Text displayed on the mouseover. The body contains the text of the page" => "Text displayed on the mouseover. The body contains the text of the page",
// "Mouseover box width. Default: 400px" => "Mouseover box width. Default: 400px",
// "Mouseover box height. Default: 200px" => "Mouseover box height. Default: 200px",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5" => "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5",
// "Offset Y" => "Offset Y",
// "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0" => "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0",
// "Parse Body" => "Parse Body",
// "Parse the body of the plugin as wiki content (parsed by default)" => "Parse the body of the plugin as wiki content (parsed by default)",
// "Parse Label" => "Parse Label",
// "Parse the label as wiki content (parsed by default)" => "Parse the label as wiki content (parsed by default)",
// "CSS class to apply" => "CSS class to apply",
// "Background color to apply to the popup" => "Background color to apply to the popup",
// "Text Color" => "Text Color",
// "Color to apply to the text in the popup" => "Color to apply to the text in the popup",
// "When enabled, popup stays visible until it is clicked" => "When enabled, popup stays visible until it is clicked",
// "Padding" => "Padding",
// "Padding size in pixels" => "Padding size in pixels",
// "Effect" => "Effect",
// "Set the type of show/hide animation that will be used" => "Set the type of show/hide animation that will be used",
// "Effect Speed" => "Effect Speed",
// "Set the speed of the animation" => "Set the speed of the animation",
// "Close Delay" => "Close Delay",
// "Number of seconds before popup closes" => "Number of seconds before popup closes",
// "No label specified" => "No label specified",
// "MWTable" => "MWTable",
// "PluginMWTable" => "PluginMWTable",
// "Displays a table using MediaWiki syntax (experimental - may change in future versions)" => "Displays a table using MediaWiki syntax (experimental - may change in future versions)",
// "Fancy" => "Fancy",
// "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)" => "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)",
// "True" => "True",
// "False" => "False",
// "Wiki Classes" => "Wiki Classes",
// "Determines whether wiki style classes will be used for the table and cells (used by default)" => "Determines whether wiki style classes will be used for the table and cells (used by default)",
// "Displays the data using (sort of) MediaWiki syntax" => "Displays the data using (sort of) MediaWiki syntax",
// "MySpace" => "MySpace",
// "PluginMySpace" => "PluginMySpace",
// "MySpace Page" => "MySpace Page",
// "MySpace page name" => "MySpace page name",
// "Object Hits" => "Object Hits",
// "PluginObjectHits" => "PluginObjectHits",
// "For a wiki page, the page name, for other object types: ID number + ? + object title" => "For a wiki page, the page name, for other object types: ID number + ? + object title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"" => "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"",
// "Show the number of hits over the past number of days indicated. Default is to show all hits" => "Show the number of hits over the past number of days indicated. Default is to show all hits",
// "Display a payment request\\'s details based on the user\\'s privileges and the state of the payment. The payment details may include the payment options" => "Display a payment request\\'s details based on the user\\'s privileges and the state of the payment. The payment details may include the payment options",
// "Payment Request Number" => "Payment Request Number",
// "Unique identifier of the payment request" => "Unique identifier of the payment request",
// "PluginPerm" => "PluginPerm",
// "Display wiki text if and only if the user has at least one of a set of permissions (or none, if using notperms)" => "Display wiki text if and only if the user has at least one of a set of permissions (or none, if using notperms)",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met",
// "Possible Permissions" => "Possible Permissions",
// "Pipe separated list of permissions, one of which is needed to view the default text" => "Pipe separated list of permissions, one of which is needed to view the default text",
// "Forbidden Permissions" => "Forbidden Permissions",
// "Pipe separated list of permissions, any of which will cause the default text not to show" => "Pipe separated list of permissions, any of which will cause the default text not to show",
// "Display wiki text if user has one of listed permissions" => "Display wiki text if user has one of listed permissions",
// "Displays a list of plugins available in this wiki" => "Displays a list of plugins available in this wiki",
// "The module or plugin parameter must be set, but not both" => "The module or plugin parameter must be set, but not both",
// "^Plugin Manager error: " => "^Plugin Manager error: ",
// " not found" => " not found",
// "Plugin manager error: " => "Plugin manager error: ",
// "Introduced in Tiki version" => "Introduced in Tiki version",
// "Accepted Values" => "Accepted Values",
// "any string except for HTML and PHP tags" => "any string except for HTML and PHP tags",
// "Since" => "Since",
// "no parameters" => "no parameters",
// "Preferences required" => "Preferences required",
// "Required parameters are in</em> <b>bold</b>" => "Required parameters are in</em> <b>bold</b>",
// "Plugin Manager" => "Plugin Manager",
// "PluginPluginManager" => "PluginPluginManager",
// "Displays a list of plugins or modules available in this wiki" => "Displays a list of plugins or modules available in this wiki",
// "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none" => "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none",
// "One or more of: description | parameters | paraminfo" => "One or more of: description | parameters | paraminfo",
// "Description & Parameters" => "Description & Parameters",
// "Description & Parameter Info" => "Description & Parameter Info",
// "Parameters & Parameter Info" => "Parameters & Parameter Info",
// "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter" => "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter",
// "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter" => "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter",
// "Single Title" => "Single Title",
// "Set placement of plugin name and description when displaying information for only one plugin" => "Set placement of plugin name and description when displaying information for only one plugin",
// "Title Heading" => "Title Heading",
// "Sets the heading size for the title, e.g., h2" => "Sets the heading size for the title, e.g., h2",
// "Start with this plugin record number (must be an integer 1 or greater)" => "Start with this plugin record number (must be an integer 1 or greater)",
// "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater",
// "PluginPoll" => "PluginPoll",
// "Numeric value representing the poll ID" => "Numeric value representing the poll ID",
// "Show poll title (shown by default)" => "Show poll title (shown by default)",
// "Profile application" => "Profile application",
// "Adds controls required to apply a profile" => "Adds controls required to apply a profile",
// "PluginProfile" => "PluginProfile",
// "Profile repository domain. Default value is profiles.tiki.org" => "Profile repository domain. Default value is profiles.tiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile to be applied" => "Name of the profile to be applied",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "PluginProposal" => "PluginProposal",
// "Quote" => "Quote",
// "PluginQuote" => "PluginQuote",
// "Quoted text" => "Quoted text",
// "Reply To" => "Reply To",
// "Name of the quoted person" => "Name of the quoted person",
// "RandomInclude" => "RandomInclude",
// "PluginRandomInclude" => "PluginRandomInclude",
// "Include a random page\\'s content" => "Include a random page\\'s content",
// "Include a random page" => "Include a random page",
// "Random Dynamic Content" => "Random Dynamic Content",
// "PluginRcontent" => "PluginRcontent",
// "Includes random content from the dynamic content system" => "Includes random content from the dynamic content system",
// "Numeric value representing the content ID" => "Numeric value representing the content ID",
// "User List (showing Real Name)" => "User List (showing Real Name)",
// "PluginRealNameList" => "PluginRealNameList",
// " (experimental, should be merged with UserList in Tiki5)" => " (experimental, should be merged with UserList in Tiki5)",
// "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included",
// "String to use between elements of the list if table layout is not used" => "String to use between elements of the list if table layout is not used",
// "Maximum" => "Maximum",
// "Result limit" => "Result limit",
// "Set to sort in ascending or descending order (unsorted by default" => "Set to sort in ascending or descending order (unsorted by default",
// "Layout" => "Layout",
// "Set to table to show results in a table (not shown in a table by default)" => "Set to table to show results in a table (not shown in a table by default)",
// "Make the listed names links to various types of user information" => "Make the listed names links to various types of user information",
// "User Page" => "User Page",
// "Exclude" => "Exclude",
// "Exclude certain test or admin names from the list" => "Exclude certain test or admin names from the list",
// "admin-test" => "admin-test",
// "test" => "test",
// "test-admin" => "test-admin",
// "Displays a list of users showing their real name" => "Displays a list of users showing their real name",
// "Displays a list of registered users showing their Real Names" => "Displays a list of registered users showing their Real Names",
// "Redirect" => "Redirect",
// "PluginRedirect" => "PluginRedirect",
// "Redirect the user to a wiki page or generic URL" => "Redirect the user to a wiki page or generic URL",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page",
// "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. ",
// "REDIRECT plugin: redirect loop detected" => "REDIRECT plugin: redirect loop detected",
// "Regular Expression" => "Regular Expression",
// "PluginRegex" => "PluginRegex",
// "Takes regex expressions and parses the content between REGEX tags and replaces the text" => "Takes regex expressions and parses the content between REGEX tags and replaces the text",
// "Each line of content is evaluated separately" => "Each line of content is evaluated separately",
// "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text" => "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text",
// "Remarks Box" => "Remarks Box",
// "PluginRemarksBox" => "PluginRemarksBox",
// "Select type of remarksbox, which determines what icon and style will be displayed" => "Select type of remarksbox, which determines what icon and style will be displayed",
// "Confirm" => "Confirm",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Highlight" => "Highlight",
// "Use the highlight class for formatting (not used by default)" => "Use the highlight class for formatting (not used by default)",
// "Custom Icon" => "Custom Icon",
// "Enter a Tiki icon file name (with or without extension) or path to display a custom icon" => "Enter a Tiki icon file name (with or without extension) or path to display a custom icon",
// "Show a close button (not shown by default)" => "Show a close button (not shown by default)",
// "Width (e.g. 100% or 250px - default \"\")" => "Width (e.g. 100% or 250px - default \"\")",
// "RSS Feed" => "RSS Feed",
// "PluginRSS" => "PluginRSS",
// "Inserts an RSS feed output" => "Inserts an RSS feed output",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: feedId:feedId2" => "List of feed IDs separated by colons. ex: feedId:feedId2",
// "Result Count" => "Result Count",
// "Number of results displayed" => "Number of results displayed",
// "Show date of each item (not shown by default)" => "Show date of each item (not shown by default)",
// "Show feed descriptions (not shown by default)" => "Show feed descriptions (not shown by default)",
// "Show authors (not shown by default)" => "Show authors (not shown by default)",
// "Url to a favicon to put before each entry" => "Url to a favicon to put before each entry",
// "Show the title of the feed (shown by default)" => "Show the title of the feed (shown by default)",
// "Scroll" => "Scroll",
// "PluginScroll" => "PluginScroll",
// "'),\n\t\t'prefs' => array('wikiplugin_scroll" => "'),\n\t\t'prefs' => array('wikiplugin_scroll",
// "Width in pixels. Example: 600px" => "Width in pixels. Example: 600px",
// "Number of pixels followed by \"px\". Example: 600px" => "Number of pixels followed by \"px\". Example: 600px",
// "Height in pixels. Example: 450px" => "Height in pixels. Example: 450px",
// "Number of pixels followed by \"px\". Example: 450px" => "Number of pixels followed by \"px\". Example: 450px",
// "Scroll speed in number of seconds (default is 8 seconds)" => "Scroll speed in number of seconds (default is 8 seconds)",
// "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests" => "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests",
// "SourceForge" => "SourceForge",
// "PluginSF" => "PluginSF",
// "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests) with the title of the item as the link text" => "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests) with the title of the item as the link text",
// "Group ID" => "Group ID",
// "SourceForge project ID (shows as group_id in the url of a tracker item" => "SourceForge project ID (shows as group_id in the url of a tracker item",
// "SourceForge tracker ID (shows as atid in the url of a tracker item" => "SourceForge tracker ID (shows as atid in the url of a tracker item",
// "SourceForge item ID (shows as aid in the url of a tracker item" => "SourceForge item ID (shows as aid in the url of a tracker item",
// "First part of link tooltip identifying the type of tracker item (bog, feature request, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bog, feature request, patch or support request)",
// "Sharethis" => "Sharethis",
// "Display a social networking tool" => "Display a social networking tool",
// "Send Services" => "Send Services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "Aim" => "Aim",
// "Aim \$ Email" => "Aim \$ Email",
// "Aim \$ Sms" => "Aim \$ Sms",
// "Email \$ Sms" => "Email \$ Sms",
// "Button Style" => "Button Style",
// "Set button style: horizontal, vertical or rotate" => "Set button style: horizontal, vertical or rotate",
// "Rotate" => "Rotate",
// "Rotate Image" => "Rotate Image",
// "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Multiple Icons" => "Multiple Icons",
// "Enter list: email | facebook | twitter | sharethis, depending on which icons you\\'d like" => "Enter list: email | facebook | twitter | sharethis, depending on which icons you\\'d like",
// "First Services Shown" => "First Services Shown",
// "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Button Text" => "Button Text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header Title" => "Header Title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header Background" => "Header Background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header Text Color" => "Header Text Color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded Elements" => "Embedded Elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Sheet" => "Sheet",
// "Display data from a TikiSheet" => "Display data from a TikiSheet",
// "Internal ID of the TikiSheet.  Either id or url MUST be used" => "Internal ID of the TikiSheet.  Either id or url MUST be used",
// "Sheet Url Location" => "Sheet Url Location",
// "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used" => "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used",
// "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)" => "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)",
// "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"" => "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"",
// "Height in pixels or percentage. Default value is complete spreadsheet height" => "Height in pixels or percentage. Default value is complete spreadsheet height",
// "Editable" => "Editable",
// "Show edit button. Default \\'y\\' depending on user\\'s permissions" => "Show edit button. Default \\'y\\' depending on user\\'s permissions",
// "Show subsheets" => "Show subsheets",
// "y/n. Show multi-sheets. Default \\'y\\'" => "y/n. Show multi-sheets. Default \\'y\\'",
// "Range" => "Range",
// "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"" => "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"",
// "Apply custom CSS class to the containing div" => "Apply custom CSS class to the containing div",
// "New sheet in page: " => "New sheet in page: ",
// "Incomplete call to plugin: No target sheet" => "Incomplete call to plugin: No target sheet",
// "Show Pages" => "Show Pages",
// "PluginShowPages" => "PluginShowPages",
// "Search criteria" => "Search criteria",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "Display page name and/or description. Both displayed by default" => "Display page name and/or description. Both displayed by default",
// "Name & Description" => "Name & Description",
// "Skype" => "Skype",
// "PluginSkype" => "PluginSkype",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Set whether to call or chat. Default is chat" => "Set whether to call or chat. Default is chat",
// "Call" => "Call",
// "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles" => "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles",
// "Slideshow notes - Separate with \"/////\"" => "Slideshow notes - Separate with \"/////\"",
// "The side on which you would like to display text if there are images that are resized or present" => "The side on which you would like to display text if there are images that are resized or present",
// "Tiki jQuery UI Theme" => "Tiki jQuery UI Theme",
// "Background Url Location" => "Background Url Location",
// "URL of the background image to use in your slideshow, overrides backgroundcolor" => "URL of the background image to use in your slideshow, overrides backgroundcolor",
// "Valid url" => "Valid url",
// "Background color to use in your slideshow, default " => "Background color to use in your slideshow, default ",
// "Any valid CSS class" => "Any valid CSS class",
// "Header font color" => "Header font color",
// "Apply a color to the headers of your slideshow" => "Apply a color to the headers of your slideshow",
// "Any html color" => "Any html color",
// "Header background color" => "Header background color",
// "Slide font color" => "Slide font color",
// "Apply a color to the slides of your slideshow" => "Apply a color to the slides of your slideshow",
// "Line Item highlight color" => "Line Item highlight color",
// "Apply a color to the line item when mouse over" => "Apply a color to the line item when mouse over",
// "Slide Seconds" => "Slide Seconds",
// "How many seconds a slide will be open while playing" => "How many seconds a slide will be open while playing",
// "Second count" => "Second count",
// "Text Side" => "Text Side",
// "Smarty function" => "Smarty function",
// "PluginSmarty" => "PluginSmarty",
// "Provides access to the tiki smarty functions like button" => "Provides access to the tiki smarty functions like button",
// "Smarty Function" => "Smarty Function",
// "The name of the smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php" => "The name of the smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php",
// "Snarf" => "Snarf",
// "PluginSnarf" => "PluginSnarf",
// "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified" => "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified",
// "Full URL to the page to include" => "Full URL to the page to include",
// "Regular Expression Pattern" => "Regular Expression Pattern",
// "PCRE-compliant regular expression pattern to find the parts you want changed" => "PCRE-compliant regular expression pattern to find the parts you want changed",
// "Regular Expression Replacement" => "Regular Expression Replacement",
// "PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "PCRE-compliant regular expression replacement syntax showing what the content should be changed to",
// "Enable/disable word wrapping of snippets of code (enabled by default)" => "Enable/disable word wrapping of snippets of code (enabled by default)",
// "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)" => "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)",
// "Switch the text display from left to right to right to left" => "Switch the text display from left to right to right to left",
// "HTML Content" => "HTML Content",
// "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)" => "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)",
// "Cache Url" => "Cache Url",
// "Cache time in minutes. Default is to use site preference, Set to 0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to 0 for no cache",
// "Text to click on to fetch the url via ajax" => "Text to click on to fetch the url via ajax",
// "PluginSort" => "PluginSort",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
// "Set the sort order of lines of content (default is ascending)" => "Set the sort order of lines of content (default is ascending)",
// "Reverse" => "Reverse",
// "Shuffle" => "Shuffle",
// "PluginSplit" => "PluginSplit",
// "Join Columns" => "Join Columns",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute for the columns" => "Generate the width attribute for the columns",
// "Column Sizes" => "Column Sizes",
// "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)" => "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
// "Line" => "Line",
// "Display edit icon for each section" => "Display edit icon for each section",
// "Custom Class" => "Custom Class",
// "Add a class to customize the design" => "Add a class to customize the design",
// "SQL" => "SQL",
// "PluginSQL" => "PluginSQL",
// "Run an SQL query on a database" => "Run an SQL query on a database",
// "The SQL query goes in the body. Example: SELECT column1, column2 FROM table" => "The SQL query goes in the body. Example: SELECT column1, column2 FROM table",
// "DSN Name" => "DSN Name",
// "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php" => "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php",
// "Could not obtain valid DSN connection" => "Could not obtain valid DSN connection",
// "Stat" => "Stat",
// "PluginStat" => "PluginStat",
// "Displays statistics for articles, wiki pages and tracker items" => "Displays statistics for articles, wiki pages and tracker items",
// "Object Type" => "Object Type",
// "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons" => "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons",
// "Article & Tracker Item" => "Article & Tracker Item",
// "Article & Tracker Item & Wiki" => "Article & Tracker Item & Wiki",
// "Article & Wiki" => "Article & Wiki",
// "Article & Wiki & Tracker Item" => "Article & Wiki & Tracker Item",
// "Tracker Item" => "Tracker Item",
// "Tracker Item & Article" => "Tracker Item & Article",
// "Tracker Item & Article & Wiki" => "Tracker Item & Article & Wiki",
// "Tracker Item & Wiki" => "Tracker Item & Wiki",
// "Tracker Item & Wiki & Article" => "Tracker Item & Wiki & Article",
// "Wiki & Article" => "Wiki & Article",
// "Wiki & Article & Tracker Item" => "Wiki & Article & Tracker Item",
// "Wiki & Tracker Item" => "Wiki & Tracker Item",
// "Wiki & Tracker Item & Article" => "Wiki & Tracker Item & Article",
// "Parent ID" => "Parent ID",
// "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)",
// "Last 24 Hours" => "Last 24 Hours",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Added and Viewed" => "Added and Viewed",
// "Viewed & Added" => "Viewed & Added",
// "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last 7 Days" => "Last 7 Days",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Week" => "This Week",
// "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Month" => "Last Month",
// "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Month" => "This Month",
// "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Year" => "Last Year",
// "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Year" => "This Year",
// "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Incorrect parameter: " => "Incorrect parameter: ",
// "Subscript" => "Subscript",
// "PluginSub" => "PluginSub",
// "Subscribe Group" => "Subscribe Group",
// "PluginSubscribeGroup" => "PluginSubscribeGroup",
// "text displyed before the button" => "text displyed before the button",
// "Group name to subscribe to or unsubscribe from" => "Group name to subscribe to or unsubscribe from",
// "PluginSubscribeGroups" => "PluginSubscribeGroups",
// "Text shown in the dropdown box. Default: \"Subscribe to a group\"" => "Text shown in the dropdown box. Default: \"Subscribe to a group\"",
// "Show Subscribe Box" => "Show Subscribe Box",
// "Show the subscribe drop down box (shown by default). Will not show if there are no other groups the user may register for" => "Show the subscribe drop down box (shown by default). Will not show if there are no other groups the user may register for",
// "Show Default" => "Show Default",
// "Shows which group is the user\\'s default group (if any) and allows the user to change his default group" => "Shows which group is the user\\'s default group (if any) and allows the user to change his default group",
// "Group Description" => "Group Description",
// "Show the description of the group (not shown by default)" => "Show the description of the group (not shown by default)",
// "Colon separated list of groups. By default the list of groups available to the user" => "Colon separated list of groups. By default the list of groups available to the user",
// "All groups including this group will be listed" => "All groups including this group will be listed",
// "Default URL" => "Default URL",
// "Page user will be directed to after clicking on icon to change default group" => "Page user will be directed to after clicking on icon to change default group",
// "You do not have permission to subscribe to groups" => "You do not have permission to subscribe to groups",
// "Subscribe newsletter" => "Subscribe newsletter",
// "PluginSubscribeNewsletter" => "PluginSubscribeNewsletter",
// "A button to subscribe to a newsletter available for a user if not already in" => "A button to subscribe to a newsletter available for a user if not already in",
// "Invitation message" => "Invitation message",
// "Newsletter ID" => "Newsletter ID",
// "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to" => "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to",
// "Confirmation Message" => "Confirmation Message",
// "Confirmation message after posting form. The plugin body is then the button label" => "Confirmation message after posting form. The plugin body is then the button label",
// "Button label. The plugin body is then the confirmation message" => "Button label. The plugin body is then the confirmation message",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
// "Already subscribed" => "Already subscribed",
// "Superscript" => "Superscript",
// "PluginSup" => "PluginSup",
// "Displays text in superscript (exponent)" => "Displays text in superscript (exponent)",
// "PluginSurvey" => "PluginSurvey",
// "Displays a survey" => "Displays a survey",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Tabs" => "Tabs",
// "PluginTabs" => "PluginTabs",
// "Display page content in a set of tabs" => "Display page content in a set of tabs",
// "Tabs content separated by /////" => "Tabs content separated by /////",
// "Tabset Name" => "Tabset Name",
// "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs" => "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs",
// "Tab Titles" => "Tab Titles",
// "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3" => "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3",
// "Displays a set of tabs" => "Displays a set of tabs",
// "No tab title specified. At least one has to be set to make the tabs appear" => "No tab title specified. At least one has to be set to make the tabs appear",
// "PluginTag" => "PluginTag",
// "Displays the text between an html tag" => "Displays the text between an html tag",
// "Any valid HTML tag, span by default" => "Any valid HTML tag, span by default",
// "CSS Style" => "CSS Style",
// "Equivalent to the style attribute of an HTML tag" => "Equivalent to the style attribute of an HTML tag",
// "Title Search" => "Title Search",
// "PluginTitleSearch" => "PluginTitleSearch",
// "Search wiki page titles" => "Search wiki page titles",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "Also show page hits or user" => "Also show page hits or user",
// "Pipe-separated list of page names to exclude from results" => "Pipe-separated list of page names to exclude from results",
// "Set to 1 (Yes) to have no header for the search results" => "Set to 1 (Yes) to have no header for the search results",
// "Table of Contents (Structure)" => "Table of Contents (Structure)",
// "PluginTOC" => "PluginTOC",
// "Displays the table of contents for the current structure\\'s subtree as part of the page content" => "Displays the table of contents for the current structure\\'s subtree as part of the page content",
// "Maximum Depth" => "Maximum Depth",
// "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)" => "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)",
// "By default, structure for the current page will be displayed. Alternate structure may be provided" => "By default, structure for the current page will be displayed. Alternate structure may be provided",
// "Order items in ascending or descending order (deafult is ascending)" => "Order items in ascending or descending order (deafult is ascending)",
// "Show the page description instead of the page name" => "Show the page description instead of the page name",
// "Show Numbering" => "Show Numbering",
// "Display the section numbers or not" => "Display the section numbers or not",
// "Apply the \"plain\" or \"fancy\" style" => "Apply the \"plain\" or \"fancy\" style",
// "By default, the table of contents for the current page will be displayed. Alternate page may be provided" => "By default, the table of contents for the current page will be displayed. Alternate page may be provided",
// "Top Friends" => "Top Friends",
// "PluginTopFriends" => "PluginTopFriends",
// "Maximum result count" => "Maximum result count",
// "Set whether public or not" => "Set whether public or not",
// "PluginTR" => "PluginTR",
// "Translate a string using Tiki translation table" => "Translate a string using Tiki translation table",
// "string" => "string",
// "PluginTracker" => "PluginTracker",
// "Numeric value representing the tracker ID" => "Numeric value representing the tracker ID",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5",
// "Label on the submit button. Default is \"Save\"" => "Label on the submit button. Default is \"Save\"",
// "Display the title of the tracker (not shown by default)" => "Display the title of the tracker (not shown by default)",
// "Show the tracker\\'s description (not shown by default)" => "Show the tracker\\'s description (not shown by default)",
// "Mark Mandatory" => "Mark Mandatory",
// "Indicate mandatory fields with an asterisk (shown by default)" => "Indicate mandatory fields with an asterisk (shown by default)",
// "Show Status" => "Show Status",
// "Show the status of the items (not shown by default)" => "Show the status of the items (not shown by default)",
// "Embedded" => "Embedded",
// "To send an email once the tracker item has been created. Format: from" => "To send an email once the tracker item has been created. Format: from",
// "Email format" => "Email format",
// "Text or html setting" => "Text or html setting",
// "URL the user is sent to after the form is submitted" => "URL the user is sent to after the form is submitted",
// "Url Target" => "Url Target",
// "Set the target parameter for the url (determines whether target will open in a new pge, etc" => "Set the target parameter for the url (determines whether target will open in a new pge, etc",
// "Self" => "Self",
// "Values" => "Values",
// "Colon-separated list of default values.for the fields. First value corresponds to first field, second value to second field, etc" => "Colon-separated list of default values.for the fields. First value corresponds to first field, second value to second field, etc",
// "Overwrite current field values of the item with the input values" => "Overwrite current field values of the item with the input values",
// "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default" => "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default",
// "Label for the preview button. Default" => "Label for the preview button. Default",
// "Label for the reset button, to return all fields to their default values" => "Label for the reset button, to return all fields to their default values",
// "Status of the item used in combination with" => "Status of the item used in combination with",
// "ItemId" => "ItemId",
// "ItemId allowing for editing an item" => "ItemId allowing for editing an item",
// "Ignore ItemId" => "Ignore ItemId",
// "Do not filter on the parameter itemId if in the url" => "Do not filter on the parameter itemId if in the url",
// "Template File" => "Template File",
// "Name of the template used to display the tracker items" => "Name of the template used to display the tracker items",
// "Name of the wiki page containing the template to display the tracker items" => "Name of the wiki page containing the template to display the tracker items",
// "New Status" => "New Status",
// "Default status applied to newly created items" => "Default status applied to newly created items",
// "Pending" => "Pending",
// "Specify the width in pixels or percentage of the first column (the labels) in the tracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the tracker form",
// "Autosave fields" => "Autosave fields",
// "Colon-separated list of field IDs to be automatically filled with values" => "Colon-separated list of field IDs to be automatically filled with values",
// "Autosavevalue" => "Autosavevalue",
// "Colon-separated values corresponding to autosavefields" => "Colon-separated values corresponding to autosavefields",
// "Registration Fields" => "Registration Fields",
// "Add registration fields such as Username and Password" => "Add registration fields such as Username and Password",
// "Output To Wiki" => "Output To Wiki",
// "Output result to a new wiki page with the name taken from the input for the specified fieldId" => "Output result to a new wiki page with the name taken from the input for the specified fieldId",
// "Discard After Output" => "Discard After Output",
// "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created" => "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created",
// "Template Page" => "Template Page",
// "Name of the wiki page containing the template to format the output to wiki page" => "Name of the wiki page containing the template to format the output to wiki page",
// "Embed the tracker in a form tag" => "Embed the tracker in a form tag",
// "If set to Yes, the tracker is contained in a <form> tag and has action buttons" => "If set to Yes, the tracker is contained in a <form> tag and has action buttons",
// "The page to output the results to already exists. Try another name" => "The page to output the results to already exists. Try another name",
// "The page to output the results to contains the following prohibited characters: \$page_badchars_display. Try another name" => "The page to output the results to contains the following prohibited characters: \$page_badchars_display. Try another name",
// "Invalid email" => "Invalid email",
// "Passwords do not match" => "Passwords do not match",
// "Tracker Comments" => "Tracker Comments",
// "Displays the number of tracker comments" => "Displays the number of tracker comments",
// "Item Count" => "Item Count",
// "Determines whether the number of items will be shown (not shown by default)" => "Determines whether the number of items will be shown (not shown by default)",
// "Enter a user name to select the items of the current user" => "Enter a user name to select the items of the current user",
// "a user name" => "a user name",
// "Comments found" => "Comments found",
// "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / \n\t\t\t\t\t\t\t\t and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown;\n\t\t\t\t\t\t\t\t c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= -\n\t\t\t\t\t\t\t\t greater than, less than, greater than or equal, less than or equal. Example" => "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / \n\t\t\t\t\t\t\t\t and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown;\n\t\t\t\t\t\t\t\t c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= -\n\t\t\t\t\t\t\t\t greater than, less than, greater than or equal, less than or equal. Example",
// "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)" => "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)",
// "Display List" => "Display List",
// "Show the full list (before filtering) initially (filtered list shown by default)" => "Show the full list (before filtering) initially (filtered list shown by default)",
// "Displays all the filters on the same line (not shown on same line by default)" => "Displays all the filters on the same line (not shown on same line by default)",
// "No Toggle" => "No Toggle",
// "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle" => "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle",
// "Export CSV" => "Export CSV",
// "Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "Label for an export button. Leave blank to show the usual \"Filter\" button instead",
// "Google Map Buttons" => "Google Map Buttons",
// "Display Mapview and Listview buttons" => "Display Mapview and Listview buttons",
// "Tracker Filter" => "Tracker Filter",
// "PluginTrackerFilter" => "PluginTrackerFilter",
// "notice" => "notice",
// "Tracker Item Field" => "Tracker Item Field",
// "PluginTrackerItemField" => "PluginTrackerItemField",
// "Wiki text containing an {ELSE} marker" => "Wiki text containing an {ELSE} marker",
// "Numeric value representing the item ID. Default is the user tracker item for the current user" => "Numeric value representing the item ID. Default is the user tracker item for the current user",
// "Field ID" => "Field ID",
// "Numeric value representing the field ID displayed or tested" => "Numeric value representing the field ID displayed or tested",
// "Colon separated list of field IDs. Default is all fields" => "Colon separated list of field IDs. Default is all fields",
// "Status of the tracker item" => "Status of the tracker item",
// "Open & Pending" => "Open & Pending",
// "Open & Closed" => "Open & Closed",
// "Pending & Closed" => "Pending & Closed",
// "Open, Pending & Closed" => "Open, Pending & Closed",
// "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter" => "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter",
// "Value to compare against" => "Value to compare against",
// "Tracker List" => "Tracker List",
// "PluginTrackerList" => "PluginTrackerList",
// "Notice" => "Notice",
// "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5",
// "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7" => "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7",
// "Sticky Popup" => "Sticky Popup",
// "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)",
// "Show Links" => "Show Links",
// "Show links to each tracker item (not shown by default)" => "Show links to each tracker item (not shown by default)",
// "Show Item Count" => "Show Item Count",
// "Show the number of items found (not shown by default)" => "Show the number of items found (not shown by default)",
// "Show Initials" => "Show Initials",
// "Show an alphabetical index by first letter to assist in navigation (not shown by default)" => "Show an alphabetical index by first letter to assist in navigation (not shown by default)",
// "Creation date display is based on tracker settings unless overriden here" => "Creation date display is based on tracker settings unless overriden here",
// "Last Modification Date" => "Last Modification Date",
// "Last modification date display is based on tracker settings unless overriden here" => "Last modification date display is based on tracker settings unless overriden here",
// "Show Field Name" => "Show Field Name",
// "Use the field names as column titles (used by default)" => "Use the field names as column titles (used by default)",
// "Show Item Rank" => "Show Item Rank",
// "Show item ranks (not shown by default)" => "Show item ranks (not shown by default)",
// "Status Filter" => "Status Filter",
// "Only show items matching certain status filters (only items with open status shown by default)" => "Only show items matching certain status filters (only items with open status shown by default)",
// "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: " => "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: ",
// "(replacing fieldId with the field ID number)" => "(replacing fieldId with the field ID number)",
// "Sort Choice" => "Sort Choice",
// "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first" => "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first",
// "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set" => "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set",
// "Offset of first item. Default is no offset" => "Offset of first item. Default is no offset",
// "Show Pagination" => "Show Pagination",
// "Determines whether pagination will be shown (shown by default)" => "Determines whether pagination will be shown (shown by default)",
// "Filter Field" => "Filter Field",
// "Colon separated list of fields to allow filtering on" => "Colon separated list of fields to allow filtering on",
// "Filter Value" => "Filter Value",
// "Filter value of the filterfield. For better performance, use exactvalue instead" => "Filter value of the filterfield. For better performance, use exactvalue instead",
// "Exact Value" => "Exact Value",
// "Exact value of the filter" => "Exact value of the filter",
// "Checkbox" => "Checkbox",
// "Adds a checkbox on each line to be able to do an action" => "Adds a checkbox on each line to be able to do an action",
// "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown" => "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown",
// "goIfOne" => "goIfOne",
// "Go directly to tiki-view_tracker_item.php if only one item is found" => "Go directly to tiki-view_tracker_item.php if only one item is found",
// "Show a \\'more\\' button that links to tiki-view_tracker.php (not shown by default)" => "Show a \\'more\\' button that links to tiki-view_tracker.php (not shown by default)",
// "More URL" => "More URL",
// "More link pointing to specified URL instead of default tracker item link" => "More link pointing to specified URL instead of default tracker item link",
// "Display only the items of the current user or the current page name" => "Display only the items of the current user or the current page name",
// "Use content of the tpl file as template to display the item" => "Use content of the tpl file as template to display the item",
// "Wiki Page" => "Wiki Page",
// "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "Template file in a Wiki page" => "Template file in a Wiki page",
// "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "View User" => "View User",
// "Will display the items of the specified user" => "Will display the items of the specified user",
// "Item ID separated with " => "Item ID separated with ",
// "To restrict the list to these item IDs" => "To restrict the list to these item IDs",
// "Ignore the itemId url parameter when filtering list (not ignored by default)" => "Ignore the itemId url parameter when filtering list (not ignored by default)",
// "The link that will be on each main field" => "The link that will be on each main field",
// "Left Deliminator" => "Left Deliminator",
// "Smarty left delimiter for Latex generation" => "Smarty left delimiter for Latex generation",
// "Right Deliminator" => "Right Deliminator",
// "Smarty right delimiter for Latex generation" => "Smarty right delimiter for Latex generation",
// "List Mode" => "List Mode",
// "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outpits without any HTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outpits without any HTML formatting",
// "Comma Separated Values" => "Comma Separated Values",
// "Export Button" => "Export Button",
// "Show an export button (not shown by default)" => "Show an export button (not shown by default)",
// "Compute" => "Compute",
// "Sum or average all the values of a field and displays it at the bottom of the table" => "Sum or average all the values of a field and displays it at the bottom of the table",
// "fieldId" => "fieldId",
// "Silent" => "Silent",
// "Show nothing if no items found (the table header and a \\'No records found\\' message is shown by default)" => "Show nothing if no items found (the table header and a \\'No records found\\' message is shown by default)",
// "Show Delete" => "Show Delete",
// "Show a delete option (not shown by default)" => "Show a delete option (not shown by default)",
// "Show Watch Button" => "Show Watch Button",
// "Show a watch button (not shown by default)" => "Show a watch button (not shown by default)",
// "Show Feed Button" => "Show Feed Button",
// "Show an RSS feed button (not shown by default)" => "Show an RSS feed button (not shown by default)",
// "Show Google Map" => "Show Google Map",
// "Show Google Map of results (not shown by default)" => "Show Google Map of results (not shown by default)",
// "Google Map Icon" => "Google Map Icon",
// "Url of default icon to use for markers on the map" => "Url of default icon to use for markers on the map",
// "Calendar Field IDs" => "Calendar Field IDs",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end",
// "Calendar View Mode" => "Calendar View Mode",
// "Calendar view type time span (default is month)" => "Calendar view type time span (default is month)",
// "Bimester" => "Bimester",
// "Trimester" => "Trimester",
// "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default" => "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default",
// "Beginning of Month" => "Beginning of Month",
// "Set whether calendar will begin at the beginning of the month (does by default)" => "Set whether calendar will begin at the beginning of the month (does by default)",
// "Show calendar navigation bar (shown by default)" => "Show calendar navigation bar (shown by default)",
// "Partial" => "Partial",
// "Calendar Title" => "Calendar Title",
// "Enter a title to display a calendar title (not set by default)" => "Enter a title to display a calendar title (not set by default)",
// "Calendar Delta" => "Calendar Delta",
// "Set the calendar delta that will be shown (not set by default)" => "Set the calendar delta that will be shown (not set by default)",
// "Plus Month" => "Plus Month",
// "Minus Month" => "Minus Month",
// "Plus Bimester" => "Plus Bimester",
// "Minus Bimester" => "Minus Bimester",
// "Display Spreadsheet" => "Display Spreadsheet",
// "Display tracker as a spreadsheet (not used by default)" => "Display tracker as a spreadsheet (not used by default)",
// "Force Compile" => "Force Compile",
// "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)",
// "Period quantity" => "Period quantity",
// "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)" => "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)",
// "Period unit" => "Period unit",
// "Time unit used with \"Period quantity\"" => "Time unit used with \"Period quantity\"",
// "Tracker Prefill" => "Tracker Prefill",
// "PluginTrackerPrefill" => "PluginTrackerPrefill",
// "Tracker Page Name" => "Tracker Page Name",
// "URL Parameters" => "URL Parameters",
// "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q" => "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q",
// "Field 1" => "Field 1",
// "Field ID for the first field" => "Field ID for the first field",
// "Value 1" => "Value 1",
// "Content that should be used to prefill the field" => "Content that should be used to prefill the field",
// "Field 2" => "Field 2",
// "Field ID for the second field" => "Field ID for the second field",
// "Value 2" => "Value 2",
// "Field 3" => "Field 3",
// "Field ID for the third field" => "Field ID for the third field",
// "Value 3" => "Value 3",
// "Field 4" => "Field 4",
// "Field ID for the fourth field" => "Field ID for the fourth field",
// "Value 4" => "Value 4",
// "Field 5" => "Field 5",
// "Field ID for the fifth field" => "Field ID for the fifth field",
// "Value 5" => "Value 5",
// "Tracker Stats" => "Tracker Stats",
// "PluginTrackerStat" => "PluginTrackerStat",
// "Choose whether to show the percentage of the vote each option received (not shown by default)" => "Choose whether to show the percentage of the vote each option received (not shown by default)",
// "Choose whether to show a bar representing the number of votes each option received (not shown by default)" => "Choose whether to show a bar representing the number of votes each option received (not shown by default)",
// "Only show items matching certain status filters" => "Only show items matching certain status filters",
// "Show Link" => "Show Link",
// "Show link to tiki-view_tracker" => "Show link to tiki-view_tracker",
// "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)" => "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)",
// "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"" => "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"",
// "invalid status" => "invalid status",
// "Tracker Timeline" => "Tracker Timeline",
// "PluginTrackerTimeline" => "PluginTrackerTimeline",
// "Timeline view of a tracker, can be used to display event schedules or gantt charts" => "Timeline view of a tracker, can be used to display event schedules or gantt charts",
// "Title Field" => "Title Field",
// "Tracker Field ID containing the item title" => "Tracker Field ID containing the item title",
// "Summary Field" => "Summary Field",
// "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Primary Scale Unit" => "Primary Scale Unit",
// "Unit of time to use for the primary scale (default to hour)" => "Unit of time to use for the primary scale (default to hour)",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "Unit of time to use for the secondary scale (default to empty)" => "Unit of time to use for the secondary scale (default to empty)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link" => "Convert the group name to a link",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Trade" => "Trade",
// "PluginTrade" => "PluginTrade",
// "Send or receive payments from one member to another. (for cclite only so far, experimental)" => "Send or receive payments from one member to another. (for cclite only so far, experimental)",
// "Currency depends on the selected registry" => "Currency depends on the selected registry",
// "Registry to trade in. Default: site preference (or first in list when more than one)" => "Registry to trade in. Default: site preference (or first in list when more than one)",
// "Currency to trade in. Default: Cclite currency preference for registry set above" => "Currency to trade in. Default: Cclite currency preference for registry set above",
// "Other User" => "Other User",
// "Name of the user to recieve or send the payment" => "Name of the user to recieve or send the payment",
// "Leave empty to display an input box" => "Leave empty to display an input box",
// "Offered or wanted item" => "Offered or wanted item",
// "Offered" => "Offered",
// "Wanted" => "Wanted",
// "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted",
// "The user " => "The user ",
// " needs to validate their account" => " needs to validate their account",
// "Transclusion" => "Transclusion",
// "PluginTransclusion" => "PluginTransclusion",
// "Includes the content of a wiki page and replaces values in the body of the included page. All additional parameters will be replaced. For example %%%title%%% will be replaced with the parameter title in the plugin" => "Includes the content of a wiki page and replaces values in the body of the included page. All additional parameters will be replaced. For example %%%title%%% will be replaced with the parameter title in the plugin",
// "Name of the wiki page to use as a template for the values" => "Name of the wiki page to use as a template for the values",
// "Permission Denied" => "Permission Denied",
// "Attempt to include a page that cannot be viewed" => "Attempt to include a page that cannot be viewed",
// "Page not found" => "Page not found",
// "Page named \"%0\" does not exist at this time" => "Page named \"%0\" does not exist at this time",
// "Translated" => "Translated",
// "PluginTranslated" => "PluginTranslated",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, ex: fr" => "Two letter language code of the language, ex: fr",
// "Country name, ex: France" => "Country name, ex: France",
// "User Count" => "User Count",
// "PluginUserCount" => "PluginUserCount",
// "Displays the number of users that are registered or within a group" => "Displays the number of users that are registered or within a group",
// "Userlink function" => "Userlink function",
// "PluginUserlink" => "PluginUserlink",
// "Makes a link to the user information page" => "Makes a link to the user information page",
// "User account name" => "User account name",
// "User account name (which can be an email address)" => "User account name (which can be an email address)",
// "Display a list of registered users" => "Display a list of registered users",
// "Login Filter" => "Login Filter",
// "Separator to use between users in the list. Default: comma" => "Separator to use between users in the list. Default: comma",
// "User info" => "User info",
// "User page" => "User page",
// "User pref" => "User pref",
// "Display the user\\'s real name (when available) instead of login name" => "Display the user\\'s real name (when available) instead of login name",
// "Filter on a group" => "Filter on a group",
// "Userpref" => "Userpref",
// "Display wiki text if user has a pref set to a value" => "Display wiki text if user has a pref set to a value",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
// "Navigation" => "Navigation",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default" => "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default",
// "Default Label" => "Default Label",
// "Specifies version label to show when displaying the page for the first time. Default label is \\'Default\\'" => "Specifies version label to show when displaying the page for the first time. Default label is \\'Default\\'",
// "Display a Vimeo video" => "Display a Vimeo video",
// "Quality of the video" => "Quality of the video",
// "Full screen" => "Full screen",
// "Expand to full screen" => "Expand to full screen",
// "PluginVote" => "PluginVote",
// "Show Stats" => "Show Stats",
// "Choose whether to show the voting results (shown by default)" => "Choose whether to show the voting results (shown by default)",
// "Show Stats After" => "Show Stats After",
// "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not shown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not shown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set by default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set by default)",
// "Wanted Pages" => "Wanted Pages",
// "Lists \\'\\'wanted\\'\\' wiki pages" => "Lists \\'\\'wanted\\'\\' wiki pages",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)",
// "Ignore" => "Ignore",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "Split By" => "Split By",
// "The character by which ignored patterns are separated" => "The character by which ignored patterns are separated",
// "Skip Extension" => "Skip Extension",
// "Whether to include external wikis in the list (not included by default)" => "Whether to include external wikis in the list (not included by default)",
// "Collect" => "Collect",
// "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column",
// "Switch on debug output with details about the items (debug not on by default)" => "Switch on debug output with details about the items (debug not on by default)",
// "Memory Saver" => "Memory Saver",
// "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell",
// "Comma" => "Comma",
// "Separate Row" => "Separate Row",
// "Level" => "Level",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site\\'s __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site\\'s __current__ page_regex",
// "Custom" => "Custom",
// "Full" => "Full",
// "non-valid custom regex" => "non-valid custom regex",
// "Switch-on debug output with details about the items" => "Switch-on debug output with details about the items",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex",
// "A custom filter for wanted pages to be listed (only used when level=>custom)" => "A custom filter for wanted pages to be listed (only used when level=>custom)",
// "Watershed" => "Watershed",
// "Viewer for UStream Watershed Embed" => "Viewer for UStream Watershed Embed",
// "Specify archive, broadcaster, chat or viewer" => "Specify archive, broadcaster, chat or viewer",
// "Broadcaster" => "Broadcaster",
// "Viewer" => "Viewer",
// "Channel code" => "Channel code",
// "Specify the channel code to search in the tracker for a channel to use" => "Specify the channel code to search in the tracker for a channel to use",
// "Brand ID" => "Brand ID",
// "Specify the brand id to search in the tracker for a channel to use" => "Specify the brand id to search in the tracker for a channel to use",
// "Brand prefix" => "Brand prefix",
// "Copy the prefix from the chat embed, e.g. Name-of-Brand-" => "Copy the prefix from the chat embed, e.g. Name-of-Brand-",
// "Video ID" => "Video ID",
// "Video ID of archive which can be found in the tracker" => "Video ID of archive which can be found in the tracker",
// "Locale" => "Locale",
// "Locale specified in viewer embed, default is en_US" => "Locale specified in viewer embed, default is en_US",
// "More than one channel found for specified criteria. Please be more specific" => "More than one channel found for specified criteria. Please be more specific",
// "No videoId specified for archive" => "No videoId specified for archive",
// "Web Service" => "Web Service",
// "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface" => "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "Service Name" => "Service Name",
// "Registered service name" => "Registered service name",
// "Template Name" => "Template Name",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Unknown Template" => "Unknown Template",
// "Unknown Service" => "Unknown Service",
// "Missing parameters" => "Missing parameters",
// "Display youtube video" => "Display youtube video",
// "Movie" => "Movie",
// "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)" => "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)",
// "Quality of the video. Default is high" => "Quality of the video. Default is high",
// "Show related videos (shown by default)" => "Show related videos (shown by default)",
// "Background" => "Background",
// "Toolbar background color. Use an HTML color code. Example: ffffff" => "Toolbar background color. Use an HTML color code. Example: ffffff",
// "HTML color code, e.g. ffffff" => "HTML color code, e.g. ffffff",
// "Borders" => "Borders",
// "Toolbar border colors. Use an HTML color code. Example: ffffff" => "Toolbar border colors. Use an HTML color code. Example: ffffff",
// "Plugin YouTube error: the movie parameter is empty" => "Plugin YouTube error: the movie parameter is empty",
// "Missing parameter movie to the Youtube plugin" => "Missing parameter movie to the Youtube plugin",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
// "rollback version " => "rollback version ",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
// "User %s does not have the permission" => "User %s does not have the permission",
// "An error occurred, please check your mail settings and try again" => "An error occurred, please check your mail settings and try again",
// "ERROR: " => "ERROR: ",
// "ERROR: Invalid tab_id received. Numeric format expected, got \$tab_id" => "ERROR: Invalid tab_id received. Numeric format expected, got \$tab_id",
// "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page",
// "Item types filter" => "Item types filter",
// "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes",
// "Possible item type values" => "Possible item type values",
// "Find similar content based on FreeTags" => "Find similar content based on FreeTags",
// "Similar Content Filter" => "Similar Content Filter",
// "Display only similar content of type specified" => "Display only similar content of type specified",
// "Default: \"All Content Type\"" => "Default: \"All Content Type\"",
// "Options: \"article, wiki page, blog post\"" => "Options: \"article, wiki page, blog post\"",
// "Broaden FreeTag Search" => "Broaden FreeTag Search",
// "Find similar content that contains one of the Tags or All of the Tags" => "Find similar content that contains one of the Tags or All of the Tags",
// "Default: \"n - needs to contain all of the Tags\"" => "Default: \"n - needs to contain all of the Tags\"",
// "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"",
// "Google AdSense" => "Google AdSense",
// "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code",
// "Advertisement channel, as optionally provided by Google" => "Advertisement channel, as optionally provided by Google",
// "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
// "Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Global banner format as provided by Google. For example: \"display=468*60_as\"",
// "Background color, as optionally provided by Google" => "Background color, as optionally provided by Google",
// "Border color, as optionally provided by Google" => "Border color, as optionally provided by Google",
// "Link color, as optionally provided by Google" => "Link color, as optionally provided by Google",
// "Text color, as optionally provided by Google" => "Text color, as optionally provided by Google",
// "URL color, as optionally provided by Google" => "URL color, as optionally provided by Google",
// "Article archives" => "Article archives",
// "Shows links to the published articles for each month" => "Shows links to the published articles for each month",
// "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles",
// "Default: \"n\"" => "Default: \"n\"",
// "If set to a category identifier, only consider the articles in the specified category" => "If set to a category identifier, only consider the articles in the specified category",
// "Example value: 13" => "Example value: 13",
// "Topic filter (by names)" => "Topic filter (by names)",
// "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Topic filter (by identifiers)" => "Topic filter (by identifiers)",
// "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values: 13, !13, 1+3, !1+5+7" => "Example values: 13, !13, 1+3, !1+5+7",
// "Types filter" => "Types filter",
// "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered",
// "Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Example values: Event, !Event, Event+Review, !Event+Classified+Article",
// "Language filter" => "Language filter",
// "If set to a language code, only consider the articles in the specified language" => "If set to a language code, only consider the articles in the specified language",
// "Lists all article topics with links to their articles" => "Lists all article topics with links to their articles",
// "Lists the specified number of published articles in the specified order" => "Lists the specified number of published articles in the specified order",
// "Show publication time" => "Show publication time",
// "If set to \"y\", article publication times are shown" => "If set to \"y\", article publication times are shown",
// "Show creation time" => "Show creation time",
// "If set to \"y\", article creation times are shown" => "If set to \"y\", article creation times are shown",
// "Show rating selector" => "Show rating selector",
// "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating",
// "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image" => "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image",
// "If set to a category identifier, only lists the articles in the specified category" => "If set to a category identifier, only lists the articles in the specified category",
// "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed",
// "If set to a language code, only lists the articles in the specified language" => "If set to a language code, only lists the articles in the specified language",
// "Specifies how the articles should be sorted" => "Specifies how the articles should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date",
// "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead",
// "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles",
// "Absolute URL" => "Absolute URL",
// "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example",
// "TikiWiki assistant" => "TikiWiki assistant",
// "Displays an assistant to guide new Tiki admins" => "Displays an assistant to guide new Tiki admins",
// "Last blog post comments" => "Last blog post comments",
// "Displays the specified number of the blog post comments most recently added" => "Displays the specified number of the blog post comments most recently added",
// "No date" => "No date",
// "If set to \"y\", the date of comments is not displayed in the module box" => "If set to \"y\", the date of comments is not displayed in the module box",
// "Verbose tooltips" => "Verbose tooltips",
// "If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "If set to \"y\", blog post title is only visible as a tooltip and not displayed",
// "Options: \"y,n\"" => "Options: \"y,n\"",
// "Last visited pages" => "Last visited pages",
// "Displays the last Wiki pages visited by the user" => "Displays the last Wiki pages visited by the user",
// "Maximum number of characters in page names allowed before truncating" => "Maximum number of characters in page names allowed before truncating",
// "Includes a calendar or a list of calendar events" => "Includes a calendar or a list of calendar events",
// "Calendars filter" => "Calendars filter",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")",
// "Displayed month (relative)" => "Displayed month (relative)",
// "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span" => "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span",
// "View type" => "View type",
// "Calendar view type time span" => "Calendar view type time span",
// "Show action" => "Show action",
// "Viewmode when clicking on a day" => "Viewmode when clicking on a day",
// "Put a link on all the days , not only those with event" => "Put a link on all the days , not only those with event",
// "View navigation bar" => "View navigation bar",
// "Cart" => "Cart",
// "Displays the content of the cart, allows to modify quantities and proceed to payment" => "Displays the content of the cart, allows to modify quantities and proceed to payment",
// "The quantities in your cart were updated" => "The quantities in your cart were updated",
// "The order was recorded and is now awaiting payment. Reference number is %0" => "The order was recorded and is now awaiting payment. Reference number is %0",
// "Displays links to categories as a tree" => "Displays links to categories as a tree",
// "Object type filter" => "Object type filter",
// "Object type filter to apply when accessing a linked category. Example values" => "Object type filter to apply when accessing a linked category. Example values",
// "Deep" => "Deep",
// "Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Show subcategories objects when accessing a linked category. Possible values: on (default), off",
// "PHP Layers menu style" => "PHP Layers menu style",
// "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree" => "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree",
// "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)" => "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)",
// "Show these categories and their children" => "Show these categories and their children",
// "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6",
// "Category Transitions" => "Category Transitions",
// "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules" => "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules",
// "Change Category" => "Change Category",
// "Enables to categorize an object" => "Enables to categorize an object",
// "Category identifier" => "Category identifier",
// "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier",
// "Note that the root category is not displayed" => "Note that the root category is not displayed",
// "Defaults to 0 (root)" => "Defaults to 0 (root)",
// "No top" => "No top",
// "In non-detailed view, disallow uncategorizing. Example value: 1" => "In non-detailed view, disallow uncategorizing. Example value: 1",
// "Display path" => "Display path",
// "Instead of category names, diplay their path in the category tree starting from the category root defined" => "Instead of category names, diplay their path in the category tree starting from the category root defined",
// "Example value: 1" => "Example value: 1",
// "Multiple categories" => "Multiple categories",
// "If set to \"n\", only allows categorizing in one category (from those displayed)" => "If set to \"n\", only allows categorizing in one category (from those displayed)",
// "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize",
// "Shy" => "Shy",
// "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default" => "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default",
// "Detailed" => "Detailed",
// "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list",
// "If set to \"n\", the detailed list of categories will not offer to unassign a category" => "If set to \"n\", the detailed list of categories will not offer to unassign a category",
// "If set to \"y\", allow to assign new categories" => "If set to \"y\", allow to assign new categories",
// "Example values: y, n" => "Example values: y, n",
// "Default value: y" => "Default value: y",
// "Default value: n" => "Default value: n",
// "Image URL not in category" => "Image URL not in category",
// "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category",
// "Image URL in category" => "Image URL in category",
// "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category",
// "Categorize %s" => "Categorize %s",
// "Displays the number of pages received (via Communications)" => "Displays the number of pages received (via Communications)",
// "Shows the credits a user has" => "Shows the credits a user has",
// "Last directory sites" => "Last directory sites",
// "Displays the specified number of the directory sites most recently added" => "Displays the specified number of the directory sites most recently added",
// "Directory category identifier" => "Directory category identifier",
// "If set to a directory category identifier, only displays the sites in the specified directory category" => "If set to a directory category identifier, only displays the sites in the specified directory category",
// "If set to \"y\", displays a button labelled \"More\" that links to the directory" => "If set to \"y\", displays a button labelled \"More\" that links to the directory",
// "If set to \"y\", the description of the directory site appears" => "If set to \"y\", the description of the directory site appears",
// "Maximum length of description" => "Maximum length of description",
// "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)",
// "Default: blank" => "Default: blank",
// "Directory statistics" => "Directory statistics",
// "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links",
// "Top directory sites" => "Top directory sites",
// "Displays the specified number of the directory sites from most visited to least visited" => "Displays the specified number of the directory sites from most visited to least visited",
// "Displays the site\\'s first featured links" => "Displays the site\\'s first featured links",
// "Displays links to file galleries" => "Displays links to file galleries",
// "Best rated topics" => "Best rated topics",
// "Displays the specified number of the forum topics with the best ratings" => "Displays the specified number of the forum topics with the best ratings",
// "Displays the latest forum posts" => "Displays the latest forum posts",
// "If set to \"y\", only displays topics" => "If set to \"y\", only displays topics",
// "List of forum IDs" => "List of forum IDs",
// "Post only from this forum" => "Post only from this forum",
// "Displays the specified number of the forums with the most comments" => "Displays the specified number of the forums with the most comments",
// "Displays the specified number of the forum topics with the most reads" => "Displays the specified number of the forum topics with the most reads",
// "Displays the specified number of the forums with the most visits" => "Displays the specified number of the forums with the most visits",
// "Shows current freetags and enables to add and remove some if permissions allow" => "Shows current freetags and enables to add and remove some if permissions allow",
// "Freetags Wiki" => "Freetags Wiki",
// "Displays current freetags on wiki pages and enables to add tags if permissions allow" => "Displays current freetags on wiki pages and enables to add tags if permissions allow",
// "Freetags similar content" => "Freetags similar content",
// "Shows content with multiple freetags in common" => "Shows content with multiple freetags in common",
// "Type of objects to extract" => "Type of objects to extract",
// "Similar pages" => "Similar pages",
// "Shows the most popular freetags. More popularity is indicated by a larger font" => "Shows the most popular freetags. More popularity is indicated by a larger font",
// "Display type" => "Display type",
// "If set to \"cloud\", links are displayed as a cloud" => "If set to \"cloud\", links are displayed as a cloud",
// "Default: \"list\"" => "Default: \"list\"",
// "Maximum elements" => "Maximum elements",
// "If set to a number, limits the number of tags displayed" => "If set to a number, limits the number of tags displayed",
// "User preferred tags" => "User preferred tags",
// "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font" => "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font",
// "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site",
// "Groups emulation" => "Groups emulation",
// "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site" => "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site",
// "Emulate Groups" => "Emulate Groups",
// "Displays the specified number of last actions" => "Displays the specified number of last actions",
// "Show user" => "Show user",
// "If set to \"y\", user names are displayed in the module box" => "If set to \"y\", user names are displayed in the module box",
// "Show date" => "Show date",
// "If set to \"y\", action dates are displayed in the module box" => "If set to \"y\", action dates are displayed in the module box",
// "Maximum number of characters in action descriptions before truncating" => "Maximum number of characters in action descriptions before truncating",
// "Lists the specified number of blogs posts from newest to oldest" => "Lists the specified number of blogs posts from newest to oldest",
// "If set to \"y\", the date of posts is not displayed in the module box" => "If set to \"y\", the date of posts is not displayed in the module box",
// "Blog identifier" => "Blog identifier",
// "If set to a blog identifier, restricts the blog posts to those in the identified blog" => "If set to a blog identifier, restricts the blog posts to those in the identified blog",
// "Last category objects" => "Last category objects",
// "Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Lists the specified number of objects of the given type in the given category, starting from the most recently created",
// "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed",
// "Maximum number of characters in object names allowed before truncating" => "Maximum number of characters in object names allowed before truncating",
// "Type of the objects to list. Example values" => "Type of the objects to list. Example values",
// "Displays the specified number of blogs from newest to oldest" => "Displays the specified number of blogs from newest to oldest",
// "Displays the specified number of FAQs from newest to oldest" => "Displays the specified number of FAQs from newest to oldest",
// "Displays the specified number of quizzes from newest to oldest" => "Displays the specified number of quizzes from newest to oldest",
// "Displays the specified number of file galleries, starting from the most recently modified" => "Displays the specified number of file galleries, starting from the most recently modified",
// "List the specified number of files, starting from the most recently added" => "List the specified number of files, starting from the most recently added",
// "Gallery identifiers" => "Gallery identifiers",
// "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers",
// "Example value: 13, 2:13, 1:2:3:5:6" => "Example value: 13, 2:13, 1:2:3:5:6",
// "Last modified image galleries" => "Last modified image galleries",
// "Displays the specified number of image galleries, starting from the most recently modified" => "Displays the specified number of image galleries, starting from the most recently modified",
// "List the specified number of images, starting from the most recently added" => "List the specified number of images, starting from the most recently added",
// "Gallery identifier" => "Gallery identifier",
// "If set to an image gallery identifier, restricts the images to those in the identified gallery" => "If set to an image gallery identifier, restricts the images to those in the identified gallery",
// "Link content" => "Link content",
// "Display the links as image names or thumbnails" => "Display the links as image names or thumbnails",
// "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"",
// "Displays the specified number of calendar events, starting from the most recently modified" => "Displays the specified number of calendar events, starting from the most recently modified",
// "Calendar identifier" => "Calendar identifier",
// "If set to a calendar identifier, restricts the events to those in the identified calendar" => "If set to a calendar identifier, restricts the events to those in the identified calendar",
// "Maximum number of characters in event names allowed before truncating" => "Maximum number of characters in event names allowed before truncating",
// "If set to \"y\", it will hide date" => "If set to \"y\", it will hide date",
// "Don't show date" => "Don't show date",
// "Lists the specified number of pages, starting from the most recently modified" => "Lists the specified number of pages, starting from the most recently modified",
// "Link target" => "Link target",
// "Target URL of the \"...more\" link at the bottom of the module" => "Target URL of the \"...more\" link at the bottom of the module",
// "Displays the specified number of blogs, starting from the most recently modified" => "Displays the specified number of blogs, starting from the most recently modified",
// "Last Podcasts" => "Last Podcasts",
// "Displays Podcasts" => "Displays Podcasts",
// "File galleries IDs" => "File galleries IDs",
// "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned",
// "Width of mediaplayer in pixels. Default is 190" => "Width of mediaplayer in pixels. Default is 190",
// "Height of mediaplayer in pixels. Default is 20" => "Height of mediaplayer in pixels. Default is 20",
// "mediaplayer" => "mediaplayer",
// "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)",
// "Bottom Link URL" => "Bottom Link URL",
// "URL for a link at bottom of module" => "URL for a link at bottom of module",
// "Bottom Link URL Text" => "Bottom Link URL Text",
// "Text for link if Bottom Link URL is set. Default is \"More Podcasts\"" => "Text for link if Bottom Link URL is set. Default is \"More Podcasts\"",
// "Verbose" => "Verbose",
// "Display description of podcast below player if \"y\", and on title mouseover if \"n\". Default is \"y\"" => "Display description of podcast below player if \"y\", and on title mouseover if \"n\". Default is \"y\"",
// "Lists the specified number of article submissions from newest to oldest" => "Lists the specified number of article submissions from newest to oldest",
// "Last tracker comments" => "Last tracker comments",
// "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted",
// "Tracker identifier" => "Tracker identifier",
// "If set to a tracker identifier, only displays the comments on the given tracker" => "If set to a tracker identifier, only displays the comments on the given tracker",
// "Item identifier" => "Item identifier",
// "If set to an item identifier, only displays the comments on the given item" => "If set to an item identifier, only displays the comments on the given item",
// "Last tracker items" => "Last tracker items",
// "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required",
// "Identifier of the tracker from which items are listed" => "Identifier of the tracker from which items are listed",
// "Field identifier" => "Field identifier",
// "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored",
// "Field name" => "Field name",
// "Name of the field from which values are listed" => "Name of the field from which values are listed",
// "Example value: age" => "Example value: age",
// "Specifies how the items should be sorted" => "Specifies how the items should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date",
// "Status filter" => "Status filter",
// "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values",
// "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set",
// "You do not have permission to view this tracker" => "You do not have permission to view this tracker",
// "Last Validated FAQs Questions" => "Last Validated FAQs Questions",
// "Displays the specified number of validated questions FAQs from newest to oldest" => "Displays the specified number of validated questions FAQs from newest to oldest",
// "Faq identifier" => "Faq identifier",
// "If set to a faq identifier, restricts the chosen questions to those in the identified faq" => "If set to a faq identifier, restricts the chosen questions to those in the identified faq",
// "Displays information about the specified number of users in decreasing order of last login time" => "Displays information about the specified number of users in decreasing order of last login time",
// "Show avatars" => "Show avatars",
// "If set to \"y\", show user avatars" => "If set to \"y\", show user avatars",
// "Maximum number of characters in user names allowed before truncating" => "Maximum number of characters in user names allowed before truncating",
// "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console",
// "Login box" => "Login box",
// "Input size" => "Input size",
// "Number of characters for username and password input fields" => "Number of characters for username and password input fields",
// "Logo" => "Logo",
// "Site logo, title and subtitle" => "Site logo, title and subtitle",
// "Menu page" => "Menu page",
// "Displays a Wiki page" => "Displays a Wiki page",
// "Page to display in the menu. Example value: HomePage" => "Page to display in the menu. Example value: HomePage",
// "Menu structure" => "Menu structure",
// "Displays a structure" => "Displays a structure",
// "Structure to display in the menu" => "Structure to display in the menu",
// "Unread inter-user messages" => "Unread inter-user messages",
// "Displays to users their number of new inter-user messages and a link to their message box" => "Displays to users their number of new inter-user messages and a link to their message box",
// "Show If Empty" => "Show If Empty",
// "Show the module when there are no messages waiting. y|n " => "Show the module when there are no messages waiting. y|n ",
// "Default=y" => "Default=y",
// "Small live chat box" => "Small live chat box",
// "Channels" => "Channels",
// "List of chat channels. Channel names are separated by a comma (\",\")" => "List of chat channels. Channel names are separated by a comma (\",\")",
// "By default, a single channel named \"default\" exists" => "By default, a single channel named \"default\" exists",
// "Months links" => "Months links",
// "Links to the objects of a given type for the current month and those preceding it" => "Links to the objects of a given type for the current month and those preceding it",
// "Type of objects to link to" => "Type of objects to link to",
// "\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" for blog posts, \"cms\" for published articles",
// "Object identifier" => "Object identifier",
// "Identifier of an object with children to link to" => "Identifier of an object with children to link to",
// "This is required for the blog Object type" => "This is required for the blog Object type",
// "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3",
// "List by month" => "List by month",
// "Most commented" => "Most commented",
// "Displays the most commented objects of a certain type" => "Displays the most commented objects of a certain type",
// "Type of objects to consider" => "Type of objects to consider",
// "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)",
// "Object language filter" => "Object language filter",
// "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language",
// "Displays the number of article submissions waiting examination and a link to the list" => "Displays the number of article submissions waiting examination and a link to the list",
// "Displays the specified number of old articles (which do not show on articles home page anymore)" => "Displays the specified number of old articles (which do not show on articles home page anymore)",
// "Enables to change current perspective" => "Enables to change current perspective",
// "Quick Edit" => "Quick Edit",
// "Enables to quickly create or edit Wiki pages" => "Enables to quickly create or edit Wiki pages",
// "Template identifier" => "Template identifier",
// "If set to a template identifier, the specified template is used for creating new Wiki pages" => "If set to a template identifier, the specified template is used for creating new Wiki pages",
// "If set, send the form to the given location (relative to Tiki\\'s root) for processing" => "If set, send the form to the given location (relative to Tiki\\'s root) for processing",
// "SUBMIT label" => "SUBMIT label",
// "The label on the button to submit the form" => "The label on the button to submit the form",
// "INPUT SIZE" => "INPUT SIZE",
// "Size attribute (horizontal, in characters) of the text input fields for page names and description. The size of the other fields is relative to the module width" => "Size attribute (horizontal, in characters) of the text input fields for page names and description. The size of the other fields is relative to the module width",
// "Optional heading to display at the top of the module\\'s content" => "Optional heading to display at the top of the module\\'s content",
// "If set to a category identifier, pages created through the module are automatically categorized only in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized only in the specified category",
// "Category to preselect" => "Category to preselect",
// "If set, pages created through the module have this category prechecked to be categorized in" => "If set, pages created through the module have this category prechecked to be categorized in",
// "Tip to be shown" => "Tip to be shown",
// "Custom text to be shown as a tip at the top of the edit page" => "Custom text to be shown as a tip at the top of the edit page",
// "Title of tip to be shown" => "Title of tip to be shown",
// "Custom title to be shown for the tip at the top of the edit page" => "Custom title to be shown for the tip at the top of the edit page",
// "Custom header template" => "Custom header template",
// "Wiki page to be used as a template to show content on top of edit page" => "Wiki page to be used as a template to show content on top of edit page",
// "input field for copy/paste" => "input field for copy/paste",
// "If set to 1 , a text area for copy/paste page content is shown" => "If set to 1 , a text area for copy/paste page content is shown",
// "show description field" => "show description field",
// "If set to 1, a text field to enter the page description is shown (requires feature_wiki_description)" => "If set to 1, a text field to enter the page description is shown (requires feature_wiki_description)",
// "choose category" => "choose category",
// "If set to 1, this allows the user to choose a category instead of preselecting one" => "If set to 1, this allows the user to choose a category instead of preselecting one",
// "Random image" => "Random image",
// "Displays a random image" => "Displays a random image",
// "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery",
// "Show link" => "Show link",
// "If set to \"n\", the image thumbnail does not link to the image" => "If set to \"n\", the image thumbnail does not link to the image",
// "Default: \"y\"" => "Default: \"y\"",
// "Show name" => "Show name",
// "If set to \"y\", the name of the image is displayed" => "If set to \"y\", the name of the image is displayed",
// "If set to \"y\", the description of the image is displayed" => "If set to \"y\", the description of the image is displayed",
// "Displays the specified number of random wiki pages" => "Displays the specified number of random wiki pages",
// "New user registrationmore tiki-re" => "New user registrationmore tiki-re",
// "Feeds List" => "Feeds List",
// "List of feeds available on this site" => "List of feeds available on this site",
// "Multi-purpose search module (go or edit page by name and/or search site)" => "Multi-purpose search module (go or edit page by name and/or search site)",
// "Legacy Mode" => "Legacy Mode",
// "Setting to emulate previous behaviour" => "Setting to emulate previous behaviour",
// " (\"search\"=search_box, \"page\"=search_wiki_page, \"quick\"=quick_edit)" => " (\"search\"=search_box, \"page\"=search_wiki_page, \"quick\"=quick_edit)",
// "If set to \"y\" the search performed is a \"Tiki search\"" => "If set to \"y\" the search performed is a \"Tiki search\"",
// " (full text search)" => " (full text search)",
// "Show Search Filter" => "Show Search Filter",
// "If set to \"y\" shows a dropdown of sections to search" => "If set to \"y\" shows a dropdown of sections to search",
// " (no object filter)" => " (no object filter)",
// "Use autocomplete" => "Use autocomplete",
// "If set to \"y\" input uses autocomplete for pagenames if applicable" => "If set to \"y\" input uses autocomplete for pagenames if applicable",
// " (use autocomplete)" => " (use autocomplete)",
// "Use advanced (boolean) search (full text search only)" => "Use advanced (boolean) search (full text search only)",
// " (use advanced search)" => " (use advanced search)",
// "Advanced search checkbox" => "Advanced search checkbox",
// "Show advanced search checkbox (full text search only)" => "Show advanced search checkbox (full text search only)",
// " (advanced search checkbox off)" => " (advanced search checkbox off)",
// "Advanced search help" => "Advanced search help",
// "Show advanced search help icon (full text search only)" => "Show advanced search help icon (full text search only)",
// " (advanced search help off)" => " (advanced search help off)",
// "Show Search Button" => "Show Search Button",
// "Show search button" => "Show search button",
// " (do show search button)" => " (do show search button)",
// "Show Go Button" => "Show Go Button",
// "Show go to page button" => "Show go to page button",
// " (do show go button)" => " (do show go button)",
// "Show Edit Button" => "Show Edit Button",
// "Show edit button" => "Show edit button",
// " (do show edit button)" => " (do show edit button)",
// "Default Button" => "Default Button",
// "Action to perform on entering <return>" => "Action to perform on entering <return>",
// " (search|go|edit)" => " (search|go|edit)",
// "Edit Submit Label" => "Edit Submit Label",
// "Size attribute (horizontal, in characters) of the text input field" => "Size attribute (horizontal, in characters) of the text input field",
// "Size of the Search Filter dropdown list" => "Size of the Search Filter dropdown list",
// "Edit Template identifier" => "Edit Template identifier",
// "If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized in the specified category",
// "Search is disabled" => "Search is disabled",
// "Search Wiki Page" => "Search Wiki Page",
// "If set, send the form to the given location (relative to Tiki's root) for processing" => "If set, send the form to the given location (relative to Tiki's root) for processing",
// "Optional heading to display at the top of the module's content" => "Optional heading to display at the top of the module's content",
// "Titles" => "Titles",
// "Small search form (for wiki, articles, blogs, etc.)" => "Small search form (for wiki, articles, blogs, etc.)",
// "If set to \"y\", the search performed is a \"Tiki search\"" => "If set to \"y\", the search performed is a \"Tiki search\"",
// "Search for a wiki page by name" => "Search for a wiki page by name",
// "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages" => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages",
// "Tooltip" => "Tooltip",
// "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content",
// "Label on the button to post a message" => "Label on the button to post a message",
// "Wait label" => "Wait label",
// "Label on the button to post a message when the message is being posted if AJAX is enabled" => "Label on the button to post a message when the message is being posted if AJAX is enabled",
// "Maximum messages shown" => "Maximum messages shown",
// "Number of messages to display" => "Number of messages to display",
// "Tweet" => "Tweet",
// "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via twitter" => "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via twitter",
// "Facebook" => "Facebook",
// "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his facebook wall" => "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his facebook wall",
// "Please wait.." => "Please wait..",
// "Since last visit (simple)" => "Since last visit (simple)",
// "Displays to logged in users the number of new or updated objects since their last login date and time" => "Displays to logged in users the number of new or updated objects since their last login date and time",
// "Since last visit" => "Since last visit",
// "Displays to logged in users new or updated objects since a point in time, by default their last login date and time" => "Displays to logged in users new or updated objects since a point in time, by default their last login date and time",
// "Show users" => "Show users",
// "If set to \"n\", do not show new users" => "If set to \"n\", do not show new users",
// "Show trackers" => "Show trackers",
// "If set to \"n\", do not show tracker changes" => "If set to \"n\", do not show tracker changes",
// "Calendar focus" => "Calendar focus",
// "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar",
// "Show date as a calendar link" => "Show date as a calendar link",
// "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)" => "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)",
// "Fold sections by default" => "Fold sections by default",
// "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)",
// "Use Jquery presentation" => "Use Jquery presentation",
// "If set to \"y\", it will use jquery to show the result" => "If set to \"y\", it will use jquery to show the result",
// " (archived)" => " (archived)",
// "updated tracker items" => "updated tracker items",
// "Switch Language" => "Switch Language",
// "Displays a language picker to change the language of the site" => "Displays a language picker to change the language of the site",
// "Display mode" => "Display mode",
// "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist",
// "Prefix" => "Prefix",
// "Changes the default displayed prefix from \\\"Site Language:\\\"" => "Changes the default displayed prefix from \\\"Site Language:\\\"",
// "Switch theme" => "Switch theme",
// "Enables to quickly change the theme" => "Enables to quickly change the theme",
// "Terminology" => "Terminology",
// "Support for multilingual terminology" => "Support for multilingual terminology",
// "Root category" => "Root category",
// "All terms will automatically be put in that category. " => "All terms will automatically be put in that category. ",
// "Note that the category must already exist. " => "Note that the category must already exist. ",
// "Defaults to \\'Term\\'" => "Defaults to \\'Term\\'",
// "Tiki Tests" => "Tiki Tests",
// "Tiki test suite helper" => "Tiki test suite helper",
// "Displays the specified number of blogs with links to them, from the most active one to the least" => "Displays the specified number of blogs with links to them, from the most active one to the least",
// "Blog activity measurement can be more or less accurate" => "Blog activity measurement can be more or less accurate",
// "Lists the specified number of articles with links to them, from the most visited one to the least" => "Lists the specified number of articles with links to them, from the most visited one to the least",
// "Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Displays the specified number of file galleries with links to them, starting with the one with most hits",
// "Displays the specified number of files with links to them, starting with the one with most hits" => "Displays the specified number of files with links to them, starting with the one with most hits",
// "Displays the specified number of users who posted to forums, starting with the one having most posts" => "Displays the specified number of users who posted to forums, starting with the one having most posts",
// "Top image galleries" => "Top image galleries",
// "Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Displays the specified number of image galleries with links to them, starting with the one with most hits",
// "Displays the specified number of images with links to them, from the most visited one to the least" => "Displays the specified number of images with links to them, from the most visited one to the least",
// "Displays the specified number of objects, starting with the one having the most hits" => "Displays the specified number of objects, starting with the one having the most hits",
// "Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Displays the specified number of wiki pages with links to them, starting with the one having the most hits",
// "Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Displays the specified number of quizzes with links to them, starting with the one having the most hits",
// "Displays the specified number of blogs with links to them, from the most visited one to the least" => "Displays the specified number of blogs with links to them, from the most visited one to the least",
// "Show Last Post" => "Show Last Post",
// "Displays the specified number of FAQs with links to them, from the most visited one to the least" => "Displays the specified number of FAQs with links to them, from the most visited one to the least",
// "Trackerhelp" => "Trackerhelp",
// "Display the fieldId of a tracker" => "Display the fieldId of a tracker",
// "Textarea rows" => "Textarea rows",
// "Textarea cols" => "Textarea cols",
// "Max fields" => "Max fields",
// "Tracker Help" => "Tracker Help",
// "Translate Updates" => "Translate Updates",
// "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed",
// "Reference language" => "Reference language",
// "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed",
// "Show language" => "Show language",
// "If \"y\" the page language will be shown instead of the page name" => "If \"y\" the page language will be shown instead of the page name",
// "Default = \"y\"" => "Default = \"y\"",
// "Lists the specified number of calendar events, ordered by their start date" => "Lists the specified number of calendar events, ordered by their start date",
// "Maximum days in the future" => "Maximum days in the future",
// "Maximum distance to event start dates in days (looking forward)" => "Maximum distance to event start dates in days (looking forward)",
// "Maximum days in the past" => "Maximum days in the past",
// "Maximum distance to event end dates in days (looking backward)" => "Maximum distance to event end dates in days (looking backward)",
// "cellpadding" => "cellpadding",
// "cellspacing" => "cellspacing",
// "If set to \"y\", event descriptions are displayed" => "If set to \"y\", event descriptions are displayed",
// "Show end date and time" => "Show end date and time",
// "If set to \"y\", event end dates and times are displayed, when appropriate" => "If set to \"y\", event end dates and times are displayed, when appropriate",
// "Use custom calendar background colors" => "Use custom calendar background colors",
// "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)" => "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)",
// "Show information in tooltips" => "Show information in tooltips",
// "If set to \"n\", event tooltips will not display event information" => "If set to \"n\", event tooltips will not display event information",
// "Date format" => "Date format",
// "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
// "site preference for short date format followed by site preference for short time format" => "site preference for short date format followed by site preference for short time format",
// "If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "If set to an integer, event names are allowed that number of characters as a maximum before being truncated",
// "Displays to registered users their blogs" => "Displays to registered users their blogs",
// "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed",
// "User image galleries" => "User image galleries",
// "Displays to registered users their image galleries" => "Displays to registered users their image galleries",
// "Displays to registered users the specified number of wiki pages which they were the last to edit" => "Displays to registered users the specified number of wiki pages which they were the last to edit",
// "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations",
// "Lists the public user tasks of a chosen group, with links to tasks" => "Lists the public user tasks of a chosen group, with links to tasks",
// "User-Group Tracker" => "User-Group Tracker",
// "User and Group tracker links" => "User and Group tracker links",
// "Displays the specified number of users and their score, starting from the one with the highest score" => "Displays the specified number of users and their score, starting from the one with the highest score",
// "Webmail Inbox" => "Webmail Inbox",
// "Displays Webmail Inbox" => "Displays Webmail Inbox",
// "Account Id" => "Account Id",
// "Webmail account identifier (if not set uses user\\'s current account)" => "Webmail account identifier (if not set uses user\\'s current account)",
// "GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Group (e.g. \"Help Team\")",
// "GroupMail: Tracker Id (to store GroupMail activity)" => "GroupMail: Tracker Id (to store GroupMail activity)",
// "GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: From Field (Id of field in tracker to store email From header)",
// "GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id of field in tracker to store email Subject header)",
// "GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Message Field (Id of field in tracker to store email message identifier)",
// "GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Content Field (Id of field in tracker to store email message body content)",
// "GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: Account Field (Id of field in tracker to store Webmail account name)",
// "DateTime Field Id" => "DateTime Field Id",
// "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)",
// "GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Operator Field (Id of field in tracker to store operator name (username))",
// "Maximum number of characters in subjects allowed before truncating" => "Maximum number of characters in subjects allowed before truncating",
// "Webmail error" => "Webmail error",
// "No accounts set up (or no current account set)" => "No accounts set up (or no current account set)",
// "What is related" => "What is related",
// "Lists objects which share a category with the viewed object" => "Lists objects which share a category with the viewed object",
// "Displays information about users currently logged in" => "Displays information about users currently logged in",
// "Content to display" => "Content to display",
// "Display the number of users logged in, the list of users logged in, or both" => "Display the number of users logged in, the list of users logged in, or both",
// "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"",
// "Cluster mode" => "Cluster mode",
// "If set to \"1\", separate users based on which host/server they logged on" => "If set to \"1\", separate users based on which host/server they logged on",
// "Last comments" => "Last comments",
// "Lists the specified number of comments starting from the most recently posted" => "Lists the specified number of comments starting from the most recently posted",
// "More in tooltips" => "More in tooltips",
// "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip" => "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip",
// "Type of the objects from which comments will be listed. Possible values" => "Type of the objects from which comments will be listed. Possible values",
// "Last article comments" => "Last article comments",
// "YouTube" => "YouTube",
// "Displays YouTube videos and/or a link to a YouTube user\\'s page" => "Displays YouTube videos and/or a link to a YouTube user\\'s page",
// "Video identifiers" => "Video identifiers",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
// "YouTube user identifier" => "YouTube user identifier",
// "If set to a YouTube user identifier, display a link to the videos of this user" => "If set to a YouTube user identifier, display a link to the videos of this user",
// "Width of each video in pixels" => "Width of each video in pixels",
// "Height of each video in pixels" => "Height of each video in pixels",
// "Videos on YouTube" => "Videos on YouTube",
// "No Playlist found" => "No Playlist found",
// "No Playlist ID was provided" => "No Playlist ID was provided",
// "Can browse the calendar" => "Can browse the calendar",
// "Can add own user to the participants" => "Can add own user to the participants",
// "Can add guest to the participants" => "Can add guest to the participants",
// "Can view Tiki tools calendar" => "Can view Tiki tools calendar",
// "Can admin the articles" => "Can admin the articles",
// "Can read article headings" => "Can read article headings",
// "Submitted articles automatically approved" => "Submitted articles automatically approved",
// "Can rate articles" => "Can rate articles",
// "Submitted links are valid" => "Submitted links are valid",
// "Can validate submitted links" => "Can validate submitted links",
// "Administrator, can manage users groups and permissions, and all features" => "Administrator, can manage users groups and permissions, and all features",
// "Can ban users or ips" => "Can ban users or ips",
// "Can admin integrator repositories and rules" => "Can admin integrator repositories and rules",
// "Can admin external feeds" => "Can admin external feeds",
// "Can create new css suffixed with -user" => "Can create new css suffixed with -user",
// "Can share a page (email, twitter, facebook, message, forums)" => "Can share a page (email, twitter, facebook, message, forums)",
// "Can view action log" => "Can view action log",
// "Can view action log for users of his own groups" => "Can view action log for users of his own groups",
// "Can view referrer stats" => "Can view referrer stats",
// "Can view in module and feed the blog posts" => "Can view in module and feed the blog posts",
// "Can view in module and feed the blog" => "Can view in module and feed the blog",
// "Can use Directory Batch Load" => "Can use Directory Batch Load",
// "Can report posts to moderator" => "Can report posts to moderator",
// "Can admin freetags" => "Can admin freetags",
// "Can assign perms to image gallery" => "Can assign perms to image gallery",
// "Can browse freetags" => "Can browse freetags",
// "Can view the archive of a newsletters" => "Can view the archive of a newsletters",
// "Can list newsletters" => "Can list newsletters",
// "Can view poll voters" => "Can view poll voters",
// "Can admin toolbars" => "Can admin toolbars",
// "Can admin shoutbox (Edit/remove messages)" => "Can admin shoutbox (Edit/remove messages)",
// "Can post messages in shoutbox" => "Can post messages in shoutbox",
// "Can view shoutbox" => "Can view shoutbox",
// "Can view tracker items comments" => "Can view tracker items comments",
// "Can change pending tracker items" => "Can change pending tracker items",
// "Can change closed tracker items" => "Can change closed tracker items",
// "Can re-vote a rating for tracker items" => "Can re-vote a rating for tracker items",
// "Can view closed trackers items" => "Can view closed trackers items",
// "Can view pending trackers items" => "Can view pending trackers items",
// "Can export tracker items" => "Can export tracker items",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
// "Can rollback pages" => "Can rollback pages",
// "Can use the page as a tracker template" => "Can use the page as a tracker template",
// "Can view in module and feed the wiki pages reference" => "Can view in module and feed the wiki pages reference",
// "Can admin attachments on wiki pages" => "Can admin attachments on wiki pages",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
// "Can view similar wiki pages" => "Can view similar wiki pages",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay the TikiTests" => "Can replay the TikiTests",
// "Can cache user bookmarks" => "Can cache user bookmarks",
// "Admin live support system" => "Admin live support system",
// "Can use live support system" => "Can use live support system",
// "Can create new mapfile" => "Can create new mapfile",
// "Can delete mapfiles" => "Can delete mapfiles",
// "Can edit mapfiles" => "Can edit mapfiles",
// "Can view mapfiles" => "Can view mapfiles",
// "Can view contents of mapfiles" => "Can view contents of mapfiles",
// "Can use group webmail" => "Can use group webmail",
// "Can admin group webmail accounts" => "Can admin group webmail accounts",
// "Can use personal webmail accounts" => "Can use personal webmail accounts",
// "Can admin personal webmail accounts" => "Can admin personal webmail accounts",
// "Can view unapproved plugin details" => "Can view unapproved plugin details",
// "Can execute unapproved plugin" => "Can execute unapproved plugin",
// "Can approve plugin execution" => "Can approve plugin execution",
// "Trust all user inputs including plugins (no security checks)" => "Trust all user inputs including plugins (no security checks)",
// "View page backlinks" => "View page backlinks",
// "Can admin mail notifications" => "Can admin mail notifications",
// "Can invite user to my groups" => "Can invite user to my groups",
// "Can delete his/her own account" => "Can delete his/her own account",
// "Can use the importer" => "Can use the importer",
// "Can see the category in a listing" => "Can see the category in a listing",
// "Can change the categories of the object" => "Can change the categories of the object",
// "Can add objects to the category" => "Can add objects to the category",
// "Can remove objects from the category" => "Can remove objects from the category",
// "Can create new categories" => "Can create new categories",
// "Can view the perspective" => "Can view the perspective",
// "Can edit the perspective" => "Can edit the perspective",
// "Can create a perspective" => "Can create a perspective",
// "Can admin perspectives" => "Can admin perspectives",
// "Can view the group" => "Can view the group",
// "Can view the group members" => "Can view the group members",
// "Can add group members" => "Can add group members",
// "Can remove group members" => "Can remove group members",
// "Can join or leave the group" => "Can join or leave the group",
// "Can trigger the transition between two states" => "Can trigger the transition between two states",
// "Can admin kaltura feature" => "Can admin kaltura feature",
// "Can upload video on kaltura server" => "Can upload video on kaltura server",
// "Can edit information of kaltura entry" => "Can edit information of kaltura entry",
// "Can create kaltura remix video" => "Can create kaltura remix video",
// "Can delete kaltura entry" => "Can delete kaltura entry",
// "Can download kaltura entry" => "Can download kaltura entry",
// "Can list kaltura entries" => "Can list kaltura entries",
// "Can view kaltura entry" => "Can view kaltura entry",
// "Can execute arbitrary queries on a given DSN" => "Can execute arbitrary queries on a given DSN",
// "Can administer payments" => "Can administer payments",
// "Can view payment requests and details" => "Can view payment requests and details",
// "Can enter manual payments" => "Can enter manual payments",
// "Can request a payment" => "Can request a payment",
// "User can administer modules" => "User can administer modules",
// "Can save a .CSV backup of entire trackers" => "Can save a .CSV backup of entire trackers",
// "Can join a meeting" => "Can join a meeting",
// "Can moderate a meeting" => "Can moderate a meeting",
// "Can create a meeting" => "Can create a meeting",
// "user can use social network integration" => "user can use social network integration",
// "user can register this site with social networks" => "user can register this site with social networks",
// "Can view contributions to a page" => "Can view contributions to a page",
// "Can invite users by email, and include them in groups" => "Can invite users by email, and include them in groups",
// "tiki release" => "tiki release",
// "feature version checks" => "feature version checks",
// "tiki needs upgrade" => "tiki needs upgrade",
// "tiki version last check" => "tiki version last check",
// "tiki version check frequency" => "tiki version check frequency",
// "lastUpdatePrefs" => "lastUpdatePrefs",
// "tiki domain prefix" => "tiki domain prefix",
// "tiki domain redirects" => "tiki domain redirects",
// "feature print indexed" => "feature print indexed",
// "groups are emulated" => "groups are emulated",
// "feature webdav" => "feature webdav",
// "feature wiki" => "feature wiki",
// "default wiki diff style" => "default wiki diff style",
// "feature backlinks" => "feature backlinks",
// "backlinks name len" => "backlinks name len",
// "feature dump" => "feature dump",
// "feature history" => "feature history",
// "feature page contribution" => "feature page contribution",
// "feature lastChanges" => "feature lastChanges",
// "feature likePages" => "feature likePages",
// "feature listPages" => "feature listPages",
// "feature listorphanPages" => "feature listorphanPages",
// "feature listorphanStructure" => "feature listorphanStructure",
// "feature page title" => "feature page title",
// "wiki page name above" => "wiki page name above",
// "feature sandbox" => "feature sandbox",
// "feature warn on edit" => "feature warn on edit",
// "feature wiki 1like redirection" => "feature wiki 1like redirection",
// "feature wiki allowhtml" => "feature wiki allowhtml",
// "feature wiki argvariable" => "feature wiki argvariable",
// "feature wiki attachments" => "feature wiki attachments",
// "feature wiki comments" => "feature wiki comments",
// "feature wiki description" => "feature wiki description",
// "feature wiki discuss" => "feature wiki discuss",
// "feature wiki export" => "feature wiki export",
// "feature wiki structure" => "feature wiki structure",
// "feature wiki import page" => "feature wiki import page",
// "feature wiki footnotes" => "feature wiki footnotes",
// "feature wiki icache" => "feature wiki icache",
// "feature wiki import html" => "feature wiki import html",
// "feature wiki mindmap" => "feature wiki mindmap",
// "feature wiki monosp" => "feature wiki monosp",
// "feature wiki multiprint" => "feature wiki multiprint",
// "feature wiki notepad" => "feature wiki notepad",
// "feature wiki make structure" => "feature wiki make structure",
// "feature wiki open as structure" => "feature wiki open as structure",
// "feature wiki pageid" => "feature wiki pageid",
// "feature wiki paragraph formatting" => "feature wiki paragraph formatting",
// "feature wiki paragraph formatting add br" => "feature wiki paragraph formatting add br",
// "feature wiki pictures" => "feature wiki pictures",
// "feature wiki plurals" => "feature wiki plurals",
// "feature wiki print" => "feature wiki print",
// "feature wiki protect email" => "feature wiki protect email",
// "feature wiki rankings" => "feature wiki rankings",
// "feature wiki ratings" => "feature wiki ratings",
// "wiki simple ratings" => "wiki simple ratings",
// "wiki simple ratings options" => "wiki simple ratings options",
// "feature wiki replace" => "feature wiki replace",
// "feature wiki show hide before" => "feature wiki show hide before",
// "feature wiki tables" => "feature wiki tables",
// "feature wiki templates" => "feature wiki templates",
// "feature wiki undo" => "feature wiki undo",
// "feature wiki userpage" => "feature wiki userpage",
// "feature wiki userpage prefix" => "feature wiki userpage prefix",
// "feature wiki usrlock" => "feature wiki usrlock",
// "feature wiki feedback polls" => "feature wiki feedback polls",
// "feature wiki save draft" => "feature wiki save draft",
// "feature wikiwords" => "feature wikiwords",
// "feature wikiwords usedash" => "feature wikiwords usedash",
// "feature wiki pagealias" => "feature wiki pagealias",
// "mailin autocheck" => "mailin autocheck",
// "mailin autocheckFreq" => "mailin autocheckFreq",
// "mailin autocheckLast" => "mailin autocheckLast",
// "page bar position" => "page bar position",
// "warn on edit time" => "warn on edit time",
// "wikiHomePage" => "wikiHomePage",
// "wikiLicensePage" => "wikiLicensePage",
// "wikiSubmitNotice" => "wikiSubmitNotice",
// "wiki authors style" => "wiki authors style",
// "wiki authors style by page" => "wiki authors style by page",
// "wiki show version" => "wiki show version",
// "wiki bot bar" => "wiki bot bar",
// "wiki cache" => "wiki cache",
// "wiki comments default ordering" => "wiki comments default ordering",
// "wiki comments displayed default" => "wiki comments displayed default",
// "wiki comments per page" => "wiki comments per page",
// "wiki comments allow per page" => "wiki comments allow per page",
// "wiki creator admin" => "wiki creator admin",
// "wiki feature copyrights" => "wiki feature copyrights",
// "wiki forum id" => "wiki forum id",
// "wiki left column" => "wiki left column",
// "wiki list backlinks" => "wiki list backlinks",
// "wiki list comment" => "wiki list comment",
// "wiki list comment len" => "wiki list comment len",
// "wiki list description" => "wiki list description",
// "wiki list description len" => "wiki list description len",
// "wiki list creator" => "wiki list creator",
// "wiki list hits" => "wiki list hits",
// "wiki list lastmodif" => "wiki list lastmodif",
// "wiki list lastver" => "wiki list lastver",
// "wiki list links" => "wiki list links",
// "wiki list name" => "wiki list name",
// "wiki list name len" => "wiki list name len",
// "wiki list size" => "wiki list size",
// "wiki list status" => "wiki list status",
// "wiki list user" => "wiki list user",
// "wiki list versions" => "wiki list versions",
// "wiki list language" => "wiki list language",
// "wiki list categories" => "wiki list categories",
// "wiki list categories path" => "wiki list categories path",
// "wiki list id" => "wiki list id",
// "wiki list sortorder" => "wiki list sortorder",
// "wiki list sortdirection" => "wiki list sortdirection",
// "wiki pagealias tokens" => "wiki pagealias tokens",
// "wiki prefixalias tokens" => "wiki prefixalias tokens",
// "wiki page regex" => "wiki page regex",
// "wiki page separator" => "wiki page separator",
// "wiki page navigation bar" => "wiki page navigation bar",
// "wiki actions bar" => "wiki actions bar",
// "wiki pagename strip" => "wiki pagename strip",
// "wiki right column" => "wiki right column",
// "wiki structure bar position" => "wiki structure bar position",
// "wiki top bar" => "wiki top bar",
// "wiki topline position" => "wiki topline position",
// "wiki uses slides" => "wiki uses slides",
// "wiki watch author" => "wiki watch author",
// "wiki watch comments" => "wiki watch comments",
// "wiki watch editor" => "wiki watch editor",
// "wiki watch minor" => "wiki watch minor",
// "feature wiki history full" => "feature wiki history full",
// "feature wiki categorize structure" => "feature wiki categorize structure",
// "feature wiki watch structure" => "feature wiki watch structure",
// "feature wikiapproval" => "feature wikiapproval",
// "wikiapproval prefix" => "wikiapproval prefix",
// "wikiapproval hideprefix" => "wikiapproval hideprefix",
// "wikiapproval delete staging" => "wikiapproval delete staging",
// "wikiapproval master group" => "wikiapproval master group",
// "wikiapproval staging category" => "wikiapproval staging category",
// "wikiapproval approved category" => "wikiapproval approved category",
// "wikiapproval outofsync category" => "wikiapproval outofsync category",
// "wikiapproval block editapproved" => "wikiapproval block editapproved",
// "wikiapproval sync categories" => "wikiapproval sync categories",
// "wikiapproval update freetags" => "wikiapproval update freetags",
// "wikiapproval combine freetags" => "wikiapproval combine freetags",
// "wiki edit section" => "wiki edit section",
// "wiki edit section level" => "wiki edit section level",
// "wiki edit icons toggle" => "wiki edit icons toggle",
// "wiki edit plugin" => "wiki edit plugin",
// "wiki validate plugin" => "wiki validate plugin",
// "wiki edit minor" => "wiki edit minor",
// "wiki badchar prevent" => "wiki badchar prevent",
// "wiki backlinks name len" => "wiki backlinks name len",
// "wiki ranking reload probability" => "wiki ranking reload probability",
// "wiki encourage contribution" => "wiki encourage contribution",
// "wiki timeout warning" => "wiki timeout warning",
// "wiki dynvar style" => "wiki dynvar style",
// "wiki dynvar multilingual" => "wiki dynvar multilingual",
// "wiki keywords" => "wiki keywords",
// "wiki likepages samelang only" => "wiki likepages samelang only",
// "wiki mandatory edit summary" => "wiki mandatory edit summary",
// "wikiplugin addtocart" => "wikiplugin addtocart",
// "wikiplugin addtogooglecal" => "wikiplugin addtogooglecal",
// "wikiplugin agentinfo" => "wikiplugin agentinfo",
// "wikiplugin alink" => "wikiplugin alink",
// "wikiplugin aname" => "wikiplugin aname",
// "wikiplugin annotation" => "wikiplugin annotation",
// "wikiplugin archivebuilder" => "wikiplugin archivebuilder",
// "wikiplugin article" => "wikiplugin article",
// "wikiplugin articles" => "wikiplugin articles",
// "wikiplugin attach" => "wikiplugin attach",
// "wikiplugin attributes" => "wikiplugin attributes",
// "wikiplugin author" => "wikiplugin author",
// "wikiplugin avatar" => "wikiplugin avatar",
// "wikiplugin back" => "wikiplugin back",
// "wikiplugin backlinks" => "wikiplugin backlinks",
// "wikiplugin banner" => "wikiplugin banner",
// "wikiplugin bigbluebutton" => "wikiplugin bigbluebutton",
// "wikiplugin bliptv" => "wikiplugin bliptv",
// "wikiplugin bloglist" => "wikiplugin bloglist",
// "wikiplugin box" => "wikiplugin box",
// "wikiplugin button" => "wikiplugin button",
// "wikiplugin calendar" => "wikiplugin calendar",
// "wikiplugin category" => "wikiplugin category",
// "wikiplugin catorphans" => "wikiplugin catorphans",
// "wikiplugin cclite" => "wikiplugin cclite",
// "wikiplugin catpath" => "wikiplugin catpath",
// "wikiplugin center" => "wikiplugin center",
// "wikiplugin chart" => "wikiplugin chart",
// "wikiplugin code" => "wikiplugin code",
// "wikiplugin colorbox" => "wikiplugin colorbox",
// "wikiplugin content" => "wikiplugin content",
// "wikiplugin cookie" => "wikiplugin cookie",
// "wikiplugin copyright" => "wikiplugin copyright",
// "wikiplugin countdown" => "wikiplugin countdown",
// "wikiplugin datachannel" => "wikiplugin datachannel",
// "wikiplugin dbreport" => "wikiplugin dbreport",
// "wikiplugin div" => "wikiplugin div",
// "wikiplugin dl" => "wikiplugin dl",
// "wikiplugin draw" => "wikiplugin draw",
// "wikiplugin equation" => "wikiplugin equation",
// "wikiplugin events" => "wikiplugin events",
// "wikiplugin fade" => "wikiplugin fade",
// "wikiplugin fancylist" => "wikiplugin fancylist",
// "wikiplugin fancytable" => "wikiplugin fancytable",
// "wikiplugin file" => "wikiplugin file",
// "wikiplugin files" => "wikiplugin files",
// "wikiplugin flash" => "wikiplugin flash",
// "wikiplugin footnote" => "wikiplugin footnote",
// "wikiplugin footnotearea" => "wikiplugin footnotearea",
// "wikiplugin freetagged" => "wikiplugin freetagged",
// "wikiplugin ftp" => "wikiplugin ftp",
// "wikiplugin gauge" => "wikiplugin gauge",
// "wikiplugin googleanalytics" => "wikiplugin googleanalytics",
// "wikiplugin googledoc" => "wikiplugin googledoc",
// "wikiplugin googlemap" => "wikiplugin googlemap",
// "wikiplugin group" => "wikiplugin group",
// "wikiplugin grouplist" => "wikiplugin grouplist",
// "wikiplugin groupmailcore" => "wikiplugin groupmailcore",
// "wikiplugin groupstat" => "wikiplugin groupstat",
// "wikiplugin html" => "wikiplugin html",
// "wikiplugin iframe" => "wikiplugin iframe",
// "wikiplugin img" => "wikiplugin img",
// "wikiplugin image" => "wikiplugin image",
// "wikiplugin include" => "wikiplugin include",
// "wikiplugin randominclude" => "wikiplugin randominclude",
// "wikiplugin invite" => "wikiplugin invite",
// "wikiplugin jabber" => "wikiplugin jabber",
// "wikiplugin js" => "wikiplugin js",
// "wikiplugin jq" => "wikiplugin jq",
// "wikiplugin lang" => "wikiplugin lang",
// "wikiplugin lastmod" => "wikiplugin lastmod",
// "wikiplugin listpages" => "wikiplugin listpages",
// "wikiplugin lsdir" => "wikiplugin lsdir",
// "wikiplugin mail" => "wikiplugin mail",
// "wikiplugin map" => "wikiplugin map",
// "wikiplugin mcalendar" => "wikiplugin mcalendar",
// "wikiplugin mediaplayer" => "wikiplugin mediaplayer",
// "wikiplugin memberlist" => "wikiplugin memberlist",
// "wikiplugin memberpayment" => "wikiplugin memberpayment",
// "wikiplugin miniquiz" => "wikiplugin miniquiz",
// "wikiplugin module" => "wikiplugin module",
// "wikiplugin mono" => "wikiplugin mono",
// "wikiplugin mouseover" => "wikiplugin mouseover",
// "wikiplugin mwtable" => "wikiplugin mwtable",
// "wikiplugin myspace" => "wikiplugin myspace",
// "wikiplugin objecthits" => "wikiplugin objecthits",
// "wikiplugin payment" => "wikiplugin payment",
// "wikiplugin perm" => "wikiplugin perm",
// "wikiplugin picture" => "wikiplugin picture",
// "wikiplugin pluginmanager" => "wikiplugin pluginmanager",
// "wikiplugin poll" => "wikiplugin poll",
// "wikiplugin profile" => "wikiplugin profile",
// "wikiplugin proposal" => "wikiplugin proposal",
// "wikiplugin quote" => "wikiplugin quote",
// "wikiplugin rcontent" => "wikiplugin rcontent",
// "wikiplugin realnamelist" => "wikiplugin realnamelist",
// "wikiplugin redirect" => "wikiplugin redirect",
// "wikiplugin regex" => "wikiplugin regex",
// "wikiplugin remarksbox" => "wikiplugin remarksbox",
// "wikiplugin rss" => "wikiplugin rss",
// "wikiplugin scroll" => "wikiplugin scroll",
// "wikiplugin sf" => "wikiplugin sf",
// "wikiplugin share" => "wikiplugin share",
// "wikiplugin sharethis" => "wikiplugin sharethis",
// "wikiplugin sheet" => "wikiplugin sheet",
// "wikiplugin showpages" => "wikiplugin showpages",
// "wikiplugin skype" => "wikiplugin skype",
// "wikiplugin smarty" => "wikiplugin smarty",
// "wikiplugin snarf" => "wikiplugin snarf",
// "wikiplugin snarf cache" => "wikiplugin snarf cache",
// "wikiplugin sort" => "wikiplugin sort",
// "wikiplugin split" => "wikiplugin split",
// "wikiplugin sql" => "wikiplugin sql",
// "wikiplugin stat" => "wikiplugin stat",
// "wikiplugin sub" => "wikiplugin sub",
// "wikiplugin subscribegroup" => "wikiplugin subscribegroup",
// "wikiplugin subscribegroups" => "wikiplugin subscribegroups",
// "wikiplugin subscribenewsletter" => "wikiplugin subscribenewsletter",
// "wikiplugin sup" => "wikiplugin sup",
// "wikiplugin survey" => "wikiplugin survey",
// "wikiplugin tag" => "wikiplugin tag",
// "wikiplugin tabs" => "wikiplugin tabs",
// "wikiplugin thumb" => "wikiplugin thumb",
// "wikiplugin titlesearch" => "wikiplugin titlesearch",
// "wikiplugin toc" => "wikiplugin toc",
// "wikiplugin topfriends" => "wikiplugin topfriends",
// "wikiplugin trackercomments" => "wikiplugin trackercomments",
// "wikiplugin trackerfilter" => "wikiplugin trackerfilter",
// "wikiplugin trackeritemfield" => "wikiplugin trackeritemfield",
// "wikiplugin trackerlist" => "wikiplugin trackerlist",
// "wikiplugin trackertimeline" => "wikiplugin trackertimeline",
// "wikiplugin tracker" => "wikiplugin tracker",
// "wikiplugin trackerprefill" => "wikiplugin trackerprefill",
// "wikiplugin trackerstat" => "wikiplugin trackerstat",
// "wikiplugin trade" => "wikiplugin trade",
// "wikiplugin transclude" => "wikiplugin transclude",
// "wikiplugin translated" => "wikiplugin translated",
// "wikiplugin tr" => "wikiplugin tr",
// "wikiplugin usercount" => "wikiplugin usercount",
// "wikiplugin userlink" => "wikiplugin userlink",
// "wikiplugin userlist" => "wikiplugin userlist",
// "wikiplugin userpref" => "wikiplugin userpref",
// "wikiplugin versions" => "wikiplugin versions",
// "wikiplugin vimeo" => "wikiplugin vimeo",
// "wikiplugin vote" => "wikiplugin vote",
// "wikiplugin watershed" => "wikiplugin watershed",
// "wikiplugin wantedpages" => "wikiplugin wantedpages",
// "wikiplugin webservice" => "wikiplugin webservice",
// "wikiplugin youtube" => "wikiplugin youtube",
// "wikiplugininline addtocart" => "wikiplugininline addtocart",
// "wikiplugininline addtogooglecal" => "wikiplugininline addtogooglecal",
// "wikiplugininline agentinfo" => "wikiplugininline agentinfo",
// "wikiplugininline alink" => "wikiplugininline alink",
// "wikiplugininline aname" => "wikiplugininline aname",
// "wikiplugininline annotation" => "wikiplugininline annotation",
// "wikiplugininline archivebuilder" => "wikiplugininline archivebuilder",
// "wikiplugininline article" => "wikiplugininline article",
// "wikiplugininline articles" => "wikiplugininline articles",
// "wikiplugininline attach" => "wikiplugininline attach",
// "wikiplugininline attributes" => "wikiplugininline attributes",
// "wikiplugininline avatar" => "wikiplugininline avatar",
// "wikiplugininline back" => "wikiplugininline back",
// "wikiplugininline backlinks" => "wikiplugininline backlinks",
// "wikiplugininline banner" => "wikiplugininline banner",
// "wikiplugininline bigbluebutton" => "wikiplugininline bigbluebutton",
// "wikiplugininline bliptv" => "wikiplugininline bliptv",
// "wikiplugininline bloglist" => "wikiplugininline bloglist",
// "wikiplugininline box" => "wikiplugininline box",
// "wikiplugininline button" => "wikiplugininline button",
// "wikiplugininline calendar" => "wikiplugininline calendar",
// "wikiplugininline category" => "wikiplugininline category",
// "wikiplugininline catorphans" => "wikiplugininline catorphans",
// "wikiplugininline catpath" => "wikiplugininline catpath",
// "wikiplugininline cclite" => "wikiplugininline cclite",
// "wikiplugininline center" => "wikiplugininline center",
// "wikiplugininline chart" => "wikiplugininline chart",
// "wikiplugininline code" => "wikiplugininline code",
// "wikiplugininline colorbox" => "wikiplugininline colorbox",
// "wikiplugininline content" => "wikiplugininline content",
// "wikiplugininline cookie" => "wikiplugininline cookie",
// "wikiplugininline copyright" => "wikiplugininline copyright",
// "wikiplugininline countdown" => "wikiplugininline countdown",
// "wikiplugininline datachannel" => "wikiplugininline datachannel",
// "wikiplugininline dbreport" => "wikiplugininline dbreport",
// "wikiplugininline div" => "wikiplugininline div",
// "wikiplugininline dl" => "wikiplugininline dl",
// "wikiplugininline draw" => "wikiplugininline draw",
// "wikiplugininline equation" => "wikiplugininline equation",
// "wikiplugininline events" => "wikiplugininline events",
// "wikiplugininline fade" => "wikiplugininline fade",
// "wikiplugininline fancylist" => "wikiplugininline fancylist",
// "wikiplugininline fancytable" => "wikiplugininline fancytable",
// "wikiplugininline file" => "wikiplugininline file",
// "wikiplugininline files" => "wikiplugininline files",
// "wikiplugininline flash" => "wikiplugininline flash",
// "wikiplugininline footnote" => "wikiplugininline footnote",
// "wikiplugininline footnotearea" => "wikiplugininline footnotearea",
// "wikiplugininline freetagged" => "wikiplugininline freetagged",
// "wikiplugininline ftp" => "wikiplugininline ftp",
// "wikiplugininline gauge" => "wikiplugininline gauge",
// "wikiplugininline googleanalytics" => "wikiplugininline googleanalytics",
// "wikiplugininline googledoc" => "wikiplugininline googledoc",
// "wikiplugininline googlemap" => "wikiplugininline googlemap",
// "wikiplugininline group" => "wikiplugininline group",
// "wikiplugininline grouplist" => "wikiplugininline grouplist",
// "wikiplugininline groupmailcore" => "wikiplugininline groupmailcore",
// "wikiplugininline groupstat" => "wikiplugininline groupstat",
// "wikiplugininline html" => "wikiplugininline html",
// "wikiplugininline iframe" => "wikiplugininline iframe",
// "wikiplugininline img" => "wikiplugininline img",
// "wikiplugininline image" => "wikiplugininline image",
// "wikiplugininline include" => "wikiplugininline include",
// "wikiplugininline invite" => "wikiplugininline invite",
// "wikiplugininline jabber" => "wikiplugininline jabber",
// "wikiplugininline js" => "wikiplugininline js",
// "wikiplugininline jq" => "wikiplugininline jq",
// "wikiplugininline lang" => "wikiplugininline lang",
// "wikiplugininline lastmod" => "wikiplugininline lastmod",
// "wikiplugininline listpages" => "wikiplugininline listpages",
// "wikiplugininline lsdir" => "wikiplugininline lsdir",
// "wikiplugininline mail" => "wikiplugininline mail",
// "wikiplugininline map" => "wikiplugininline map",
// "wikiplugininline mcalendar" => "wikiplugininline mcalendar",
// "wikiplugininline mediaplayer" => "wikiplugininline mediaplayer",
// "wikiplugininline memberlist" => "wikiplugininline memberlist",
// "wikiplugininline memberpayment" => "wikiplugininline memberpayment",
// "wikiplugininline miniquiz" => "wikiplugininline miniquiz",
// "wikiplugininline module" => "wikiplugininline module",
// "wikiplugininline mono" => "wikiplugininline mono",
// "wikiplugininline mouseover" => "wikiplugininline mouseover",
// "wikiplugininline mwtable" => "wikiplugininline mwtable",
// "wikiplugininline myspace" => "wikiplugininline myspace",
// "wikiplugininline objecthits" => "wikiplugininline objecthits",
// "wikiplugininline payment" => "wikiplugininline payment",
// "wikiplugininline perm" => "wikiplugininline perm",
// "wikiplugininline picture" => "wikiplugininline picture",
// "wikiplugininline pluginmanager" => "wikiplugininline pluginmanager",
// "wikiplugininline poll" => "wikiplugininline poll",
// "wikiplugininline profile" => "wikiplugininline profile",
// "wikiplugininline proposal" => "wikiplugininline proposal",
// "wikiplugininline quote" => "wikiplugininline quote",
// "wikiplugininline rcontent" => "wikiplugininline rcontent",
// "wikiplugininline randominclude" => "wikiplugininline randominclude",
// "wikiplugininline realnamelist" => "wikiplugininline realnamelist",
// "wikiplugininline redirect" => "wikiplugininline redirect",
// "wikiplugininline regex" => "wikiplugininline regex",
// "wikiplugininline remarksbox" => "wikiplugininline remarksbox",
// "wikiplugininline rss" => "wikiplugininline rss",
// "wikiplugininline scroll" => "wikiplugininline scroll",
// "wikiplugininline sf" => "wikiplugininline sf",
// "wikiplugininline share" => "wikiplugininline share",
// "wikiplugininline sharethis" => "wikiplugininline sharethis",
// "wikiplugininline sheet" => "wikiplugininline sheet",
// "wikiplugininline showpages" => "wikiplugininline showpages",
// "wikiplugininline skype" => "wikiplugininline skype",
// "wikiplugininline smarty" => "wikiplugininline smarty",
// "wikiplugininline snarf" => "wikiplugininline snarf",
// "wikiplugininline sort" => "wikiplugininline sort",
// "wikiplugininline split" => "wikiplugininline split",
// "wikiplugininline sql" => "wikiplugininline sql",
// "wikiplugininline stat" => "wikiplugininline stat",
// "wikiplugininline sub" => "wikiplugininline sub",
// "wikiplugininline subscribegroup" => "wikiplugininline subscribegroup",
// "wikiplugininline subscribegroups" => "wikiplugininline subscribegroups",
// "wikiplugininline subscribenewsletter" => "wikiplugininline subscribenewsletter",
// "wikiplugininline sup" => "wikiplugininline sup",
// "wikiplugininline survey" => "wikiplugininline survey",
// "wikiplugininline tag" => "wikiplugininline tag",
// "wikiplugininline tabs" => "wikiplugininline tabs",
// "wikiplugininline thumb" => "wikiplugininline thumb",
// "wikiplugininline titlesearch" => "wikiplugininline titlesearch",
// "wikiplugininline toc" => "wikiplugininline toc",
// "wikiplugininline topfriends" => "wikiplugininline topfriends",
// "wikiplugininline trackercomments" => "wikiplugininline trackercomments",
// "wikiplugininline trackerfilter" => "wikiplugininline trackerfilter",
// "wikiplugininline trackeritemfield" => "wikiplugininline trackeritemfield",
// "wikiplugininline trackerlist" => "wikiplugininline trackerlist",
// "wikiplugininline trackertimeline" => "wikiplugininline trackertimeline",
// "wikiplugininline tracker" => "wikiplugininline tracker",
// "wikiplugininline trackerprefill" => "wikiplugininline trackerprefill",
// "wikiplugininline trackerstat" => "wikiplugininline trackerstat",
// "wikiplugininline trade" => "wikiplugininline trade",
// "wikiplugininline transclude" => "wikiplugininline transclude",
// "wikiplugininline translated" => "wikiplugininline translated",
// "wikiplugininline tr" => "wikiplugininline tr",
// "wikiplugininline usercount" => "wikiplugininline usercount",
// "wikiplugininline userlink" => "wikiplugininline userlink",
// "wikiplugininline userlist" => "wikiplugininline userlist",
// "wikiplugininline userpref" => "wikiplugininline userpref",
// "wikiplugininline versions" => "wikiplugininline versions",
// "wikiplugininline vimeo" => "wikiplugininline vimeo",
// "wikiplugininline vote" => "wikiplugininline vote",
// "wikiplugininline watershed" => "wikiplugininline watershed",
// "wikiplugininline wantedpages" => "wikiplugininline wantedpages",
// "wikiplugininline webservice" => "wikiplugininline webservice",
// "wikiplugininline youtube" => "wikiplugininline youtube",
// "wikiplugininline author" => "wikiplugininline author",
// "webservice consume defaultcache" => "webservice consume defaultcache",
// "feature webservices" => "feature webservices",
// "feature semantic" => "feature semantic",
// "feature wysiwyg" => "feature wysiwyg",
// "wysiwyg optional" => "wysiwyg optional",
// "wysiwyg default" => "wysiwyg default",
// "wysiwyg memo" => "wysiwyg memo",
// "wysiwyg wiki parsed" => "wysiwyg wiki parsed",
// "wysiwyg wiki semi parsed" => "wysiwyg wiki semi parsed",
// "wysiwyg toolbar skin" => "wysiwyg toolbar skin",
// "wysiwyg htmltowiki" => "wysiwyg htmltowiki",
// "wysiwyg fonts" => "wysiwyg fonts",
// "wiki feature 3d" => "wiki feature 3d",
// "wiki 3d width" => "wiki 3d width",
// "wiki 3d height" => "wiki 3d height",
// "wiki 3d navigation depth" => "wiki 3d navigation depth",
// "wiki 3d feed animation interval" => "wiki 3d feed animation interval",
// "wiki 3d existing page color" => "wiki 3d existing page color",
// "wiki 3d missing page color" => "wiki 3d missing page color",
// "feature blogs" => "feature blogs",
// "blog list order" => "blog list order",
// "home blog" => "home blog",
// "feature blog rankings" => "feature blog rankings",
// "blog comments default ordering" => "blog comments default ordering",
// "blog comments per page" => "blog comments per page",
// "feature blogposts comments" => "feature blogposts comments",
// "blog list user" => "blog list user",
// "blog list title" => "blog list title",
// "blog list title len" => "blog list title len",
// "blog list description" => "blog list description",
// "blog list created" => "blog list created",
// "blog list lastmodif" => "blog list lastmodif",
// "blog list posts" => "blog list posts",
// "blog list visits" => "blog list visits",
// "blog list activity" => "blog list activity",
// "feature blog mandatory category" => "feature blog mandatory category",
// "feature blog heading" => "feature blog heading",
// "feature blog edit publish date" => "feature blog edit publish date",
// "feature blog sharethis" => "feature blog sharethis",
// "blog sharethis publisher" => "blog sharethis publisher",
// "feature file galleries" => "feature file galleries",
// "home file gallery" => "home file gallery",
// "fgal root id" => "fgal root id",
// "fgal use db" => "fgal use db",
// "fgal batch dir" => "fgal batch dir",
// "fgal match regex" => "fgal match regex",
// "fgal nmatch regex" => "fgal nmatch regex",
// "fgal use dir" => "fgal use dir",
// "fgal podcast dir" => "fgal podcast dir",
// "feature file galleries comments" => "feature file galleries comments",
// "file galleries comments default ordering" => "file galleries comments default ordering",
// "file galleries comments per page" => "file galleries comments per page",
// "feature file galleries batch" => "feature file galleries batch",
// "feature file galleries rankings" => "feature file galleries rankings",
// "fgal enable auto indexing" => "fgal enable auto indexing",
// "fgal asynchronous indexing" => "fgal asynchronous indexing",
// "fgal allow duplicates" => "fgal allow duplicates",
// "fgal sort mode" => "fgal sort mode",
// "feature file galleries author" => "feature file galleries author",
// "fgal list id" => "fgal list id",
// "fgal list type" => "fgal list type",
// "fgal list name" => "fgal list name",
// "fgal list description" => "fgal list description",
// "fgal list size" => "fgal list size",
// "fgal list created" => "fgal list created",
// "fgal list lastModif" => "fgal list lastModif",
// "fgal list creator" => "fgal list creator",
// "fgal list author" => "fgal list author",
// "fgal list last user" => "fgal list last user",
// "fgal list comment" => "fgal list comment",
// "fgal list files" => "fgal list files",
// "fgal list hits" => "fgal list hits",
// "fgal list lastDownload" => "fgal list lastDownload",
// "fgal list lockedby" => "fgal list lockedby",
// "fgal show path" => "fgal show path",
// "fgal show explorer" => "fgal show explorer",
// "fgal show slideshow" => "fgal show slideshow",
// "fgal default view" => "fgal default view",
// "fgal limit hits per file" => "fgal limit hits per file",
// "fgal prevent negative score" => "fgal prevent negative score",
// "fgal quota" => "fgal quota",
// "fgal quota per fgal" => "fgal quota per fgal",
// "fgal quota default" => "fgal quota default",
// "fgal quota show" => "fgal quota show",
// "fgal list backlinks" => "fgal list backlinks",
// "fgal search in content" => "fgal search in content",
// "fgal search" => "fgal search",
// "fgal delete after" => "fgal delete after",
// "fgal delete after email" => "fgal delete after email",
// "fgal list id admin" => "fgal list id admin",
// "fgal list type admin" => "fgal list type admin",
// "fgal list name admin" => "fgal list name admin",
// "fgal list description admin" => "fgal list description admin",
// "fgal list size admin" => "fgal list size admin",
// "fgal list created admin" => "fgal list created admin",
// "fgal list lastModif admin" => "fgal list lastModif admin",
// "fgal list creator admin" => "fgal list creator admin",
// "fgal list author admin" => "fgal list author admin",
// "fgal list last user admin" => "fgal list last user admin",
// "fgal list comment admin" => "fgal list comment admin",
// "fgal list files admin" => "fgal list files admin",
// "fgal list hits admin" => "fgal list hits admin",
// "fgal list lastDownload admin" => "fgal list lastDownload admin",
// "fgal list lockedby admin" => "fgal list lockedby admin",
// "fgal list backlinks admin" => "fgal list backlinks admin",
// "fgal keep fileId" => "fgal keep fileId",
// "fgal show thumbactions" => "fgal show thumbactions",
// "fgal thumb max size" => "fgal thumb max size",
// "feature galleries" => "feature galleries",
// "feature gal batch" => "feature gal batch",
// "feature gal slideshow" => "feature gal slideshow",
// "home gallery" => "home gallery",
// "gal use db" => "gal use db",
// "gal use lib" => "gal use lib",
// "gal match regex" => "gal match regex",
// "gal nmatch regex" => "gal nmatch regex",
// "gal use dir" => "gal use dir",
// "gal batch dir" => "gal batch dir",
// "feature gal rankings" => "feature gal rankings",
// "feature image galleries comments" => "feature image galleries comments",
// "image galleries comments default order" => "image galleries comments default order",
// "image galleries comments per page" => "image galleries comments per page",
// "gal list name" => "gal list name",
// "gal list parent" => "gal list parent",
// "gal list description" => "gal list description",
// "gal list created" => "gal list created",
// "gal list lastmodif" => "gal list lastmodif",
// "gal list user" => "gal list user",
// "gal list imgs" => "gal list imgs",
// "gal list visits" => "gal list visits",
// "feature image gallery mandatory category" => "feature image gallery mandatory category",
// "preset galleries info" => "preset galleries info",
// "gal image mouseover" => "gal image mouseover",
// "feature forums" => "feature forums",
// "home forum" => "home forum",
// "feature forum rankings" => "feature forum rankings",
// "feature forum parse" => "feature forum parse",
// "feature forum topics archiving" => "feature forum topics archiving",
// "feature forum replyempty" => "feature forum replyempty",
// "feature forum quickjump" => "feature forum quickjump",
// "feature forums allow thread titles" => "feature forums allow thread titles",
// "feature forum content search" => "feature forum content search",
// "feature forums name search" => "feature forums name search",
// "forums ordering" => "forums ordering",
// "forum list topics" => "forum list topics",
// "forum list posts" => "forum list posts",
// "forum list ppd" => "forum list ppd",
// "forum list lastpost" => "forum list lastpost",
// "forum list visits" => "forum list visits",
// "forum list desc" => "forum list desc",
// "forum list description len" => "forum list description len",
// "feature forum local search" => "feature forum local search",
// "feature forum local tiki search" => "feature forum local tiki search",
// "forum thread defaults by forum" => "forum thread defaults by forum",
// "forum thread user settings" => "forum thread user settings",
// "forum thread user settings threshold" => "forum thread user settings threshold",
// "forum thread user settings keep" => "forum thread user settings keep",
// "forum comments per page" => "forum comments per page",
// "forum comments no title prefix" => "forum comments no title prefix",
// "forum thread style" => "forum thread style",
// "forum thread sort mode" => "forum thread sort mode",
// "forum match regex" => "forum match regex",
// "forum reply notitle" => "forum reply notitle",
// "feature articles" => "feature articles",
// "feature submissions" => "feature submissions",
// "feature cms rankings" => "feature cms rankings",
// "feature cms print" => "feature cms print",
// "feature cms emails" => "feature cms emails",
// "feature cms sharethis" => "feature cms sharethis",
// "art sort mode" => "art sort mode",
// "art list title" => "art list title",
// "art list title len" => "art list title len",
// "art list id" => "art list id",
// "art list topic" => "art list topic",
// "art list date" => "art list date",
// "art list author" => "art list author",
// "art list rating" => "art list rating",
// "art list reads" => "art list reads",
// "art list size" => "art list size",
// "art list expire" => "art list expire",
// "art list img" => "art list img",
// "art list type" => "art list type",
// "art list visible" => "art list visible",
// "art view type" => "art view type",
// "art view title" => "art view title",
// "art view topic" => "art view topic",
// "art view date" => "art view date",
// "art view author" => "art view author",
// "art view reads" => "art view reads",
// "art view size" => "art view size",
// "art view img" => "art view img",
// "art list lang" => "art list lang",
// "art trailer pos" => "art trailer pos",
// "art header text pos" => "art header text pos",
// "feature article comments" => "feature article comments",
// "article comments default ordering" => "article comments default ordering",
// "article comments per page" => "article comments per page",
// "article paginate" => "article paginate",
// "article user rating" => "article user rating",
// "article user rating options" => "article user rating options",
// "article image size x" => "article image size x",
// "article image size y" => "article image size y",
// "article custom attributes" => "article custom attributes",
// "article sharethis publisher" => "article sharethis publisher",
// "feature cms templates" => "feature cms templates",
// "cms bot bar" => "cms bot bar",
// "cms left column" => "cms left column",
// "cms right column" => "cms right column",
// "cms top bar" => "cms top bar",
// "art home title" => "art home title",
// "feature trackers" => "feature trackers",
// "t use db" => "t use db",
// "t use dir" => "t use dir",
// "groupTracker" => "groupTracker",
// "userTracker" => "userTracker",
// "trackerCreatorGroupName" => "trackerCreatorGroupName",
// "user selector threshold" => "user selector threshold",
// "user selector realnames tracker" => "user selector realnames tracker",
// "user selector realnames messu" => "user selector realnames messu",
// "feature userlevels" => "feature userlevels",
// "userlevels" => "userlevels",
// "userbreadCrumb" => "userbreadCrumb",
// "user assigned modules" => "user assigned modules",
// "user flip modules" => "user flip modules",
// "user show realnames" => "user show realnames",
// "user store file gallery picture" => "user store file gallery picture",
// "user picture gallery id" => "user picture gallery id",
// "user who viewed my stuff" => "user who viewed my stuff",
// "user who viewed my stuff days" => "user who viewed my stuff days",
// "user who viewed my stuff show others" => "user who viewed my stuff show others",
// "user register prettytracker" => "user register prettytracker",
// "user register prettytracker tpl" => "user register prettytracker tpl",
// "user trackersync trackers" => "user trackersync trackers",
// "user trackersync realname" => "user trackersync realname",
// "user trackersync geo" => "user trackersync geo",
// "user trackersync groups" => "user trackersync groups",
// "user trackersync parentgroup" => "user trackersync parentgroup",
// "feature mytiki" => "feature mytiki",
// "feature userPreferences" => "feature userPreferences",
// "feature user bookmarks" => "feature user bookmarks",
// "feature tasks" => "feature tasks",
// "w use db" => "w use db",
// "w use dir" => "w use dir",
// "w displayed default" => "w displayed default",
// "uf use db" => "uf use db",
// "uf use dir" => "uf use dir",
// "userfiles quota" => "userfiles quota",
// "feature usermenu" => "feature usermenu",
// "feature minical" => "feature minical",
// "feature notepad" => "feature notepad",
// "feature userfiles" => "feature userfiles",
// "feature community gender" => "feature community gender",
// "feature community mouseover" => "feature community mouseover",
// "feature community mouseover name" => "feature community mouseover name",
// "feature community mouseover gender" => "feature community mouseover gender",
// "feature community mouseover picture" => "feature community mouseover picture",
// "feature community mouseover friends" => "feature community mouseover friends",
// "feature community mouseover score" => "feature community mouseover score",
// "feature community mouseover country" => "feature community mouseover country",
// "feature community mouseover email" => "feature community mouseover email",
// "feature community mouseover lastlogin" => "feature community mouseover lastlogin",
// "feature community mouseover distance" => "feature community mouseover distance",
// "feature community list name" => "feature community list name",
// "feature community list score" => "feature community list score",
// "feature community list country" => "feature community list country",
// "feature community list distance" => "feature community list distance",
// "feature community friends permission" => "feature community friends permission",
// "feature community friends permission dep" => "feature community friends permission dep",
// "change language" => "change language",
// "change theme" => "change theme",
// "login is email" => "login is email",
// "login is email obscure" => "login is email obscure",
// "validateUsers" => "validateUsers",
// "validateEmail" => "validateEmail",
// "forgotPass" => "forgotPass",
// "available languages" => "available languages",
// "available styles" => "available styles",
// "lowercase username" => "lowercase username",
// "username pattern" => "username pattern",
// "max username length" => "max username length",
// "min username length" => "min username length",
// "users serve avatar static" => "users serve avatar static",
// "users prefs allowMsgs" => "users prefs allowMsgs",
// "users prefs country" => "users prefs country",
// "users prefs diff versions" => "users prefs diff versions",
// "users prefs display timezone" => "users prefs display timezone",
// "users prefs email is public" => "users prefs email is public",
// "users prefs homePage" => "users prefs homePage",
// "users prefs lat" => "users prefs lat",
// "users prefs lon" => "users prefs lon",
// "users prefs mess archiveAfter" => "users prefs mess archiveAfter",
// "users prefs mess maxRecords" => "users prefs mess maxRecords",
// "users prefs mess sendReadStatus" => "users prefs mess sendReadStatus",
// "users prefs minPrio" => "users prefs minPrio",
// "users prefs mytiki blogs" => "users prefs mytiki blogs",
// "users prefs mytiki articles" => "users prefs mytiki articles",
// "users prefs mytiki gals" => "users prefs mytiki gals",
// "users prefs mytiki items" => "users prefs mytiki items",
// "users prefs mytiki msgs" => "users prefs mytiki msgs",
// "users prefs mytiki pages" => "users prefs mytiki pages",
// "users prefs mytiki tasks" => "users prefs mytiki tasks",
// "users prefs mytiki forum topics" => "users prefs mytiki forum topics",
// "users prefs mytiki forum replies" => "users prefs mytiki forum replies",
// "users prefs realName" => "users prefs realName",
// "users prefs gender" => "users prefs gender",
// "users prefs show mouseover user info" => "users prefs show mouseover user info",
// "users prefs tasks maxRecords" => "users prefs tasks maxRecords",
// "users prefs user dbl" => "users prefs user dbl",
// "users prefs user information" => "users prefs user information",
// "users prefs userbreadCrumb" => "users prefs userbreadCrumb",
// "users prefs mailCharset" => "users prefs mailCharset",
// "users prefs mailCurrentAccount" => "users prefs mailCurrentAccount",
// "validateRegistration" => "validateRegistration",
// "validator emails" => "validator emails",
// "url after validation" => "url after validation",
// "urlOnUsername" => "urlOnUsername",
// "feature messages" => "feature messages",
// "messu mailbox size" => "messu mailbox size",
// "messu archive size" => "messu archive size",
// "messu sent size" => "messu sent size",
// "allowmsg by default" => "allowmsg by default",
// "allowmsg is optional" => "allowmsg is optional",
// "feature freetags" => "feature freetags",
// "freetags browse show cloud" => "freetags browse show cloud",
// "freetags cloud colors" => "freetags cloud colors",
// "freetags preload random search" => "freetags preload random search",
// "freetags browse amount tags in cloud" => "freetags browse amount tags in cloud",
// "freetags browse amount tags suggestion" => "freetags browse amount tags suggestion",
// "freetags normalized valid chars" => "freetags normalized valid chars",
// "freetags lowercase only" => "freetags lowercase only",
// "freetags feature 3d" => "freetags feature 3d",
// "freetags 3d width" => "freetags 3d width",
// "freetags 3d height" => "freetags 3d height",
// "freetags 3d navigation depth" => "freetags 3d navigation depth",
// "freetags 3d feed animation interval" => "freetags 3d feed animation interval",
// "freetags 3d existing page color" => "freetags 3d existing page color",
// "freetags 3d missing page color" => "freetags 3d missing page color",
// "freetags 3d autoload" => "freetags 3d autoload",
// "freetags 3d camera distance" => "freetags 3d camera distance",
// "freetags 3d elastic constant" => "freetags 3d elastic constant",
// "freetags 3d eletrostatic constant" => "freetags 3d eletrostatic constant",
// "freetags 3d fov" => "freetags 3d fov",
// "freetags 3d friction constant" => "freetags 3d friction constant",
// "freetags 3d node charge" => "freetags 3d node charge",
// "freetags 3d node mass" => "freetags 3d node mass",
// "freetags 3d node size" => "freetags 3d node size",
// "freetags 3d spring size" => "freetags 3d spring size",
// "freetags 3d text size" => "freetags 3d text size",
// "freetags 3d adjust camera" => "freetags 3d adjust camera",
// "freetags multilingual" => "freetags multilingual",
// "morelikethis algorithm" => "morelikethis algorithm",
// "morelikethis basic mincommon" => "morelikethis basic mincommon",
// "freetags show middle" => "freetags show middle",
// "feature search stats" => "feature search stats",
// "feature search" => "feature search",
// "feature search fulltext" => "feature search fulltext",
// "feature search show forbidden obj" => "feature search show forbidden obj",
// "feature search show forbidden cat" => "feature search show forbidden cat",
// "feature search show object filter" => "feature search show object filter",
// "feature search show search box" => "feature search show search box",
// "feature search show visit count" => "feature search show visit count",
// "feature search show pertinence" => "feature search show pertinence",
// "feature search show object type" => "feature search show object type",
// "feature search show last modification" => "feature search show last modification",
// "search refresh index mode" => "search refresh index mode",
// "search parsed snippet" => "search parsed snippet",
// "search default where" => "search default where",
// "search default interface language" => "search default interface language",
// "search autocomplete" => "search autocomplete",
// "feature webmail" => "feature webmail",
// "webmail max attachment" => "webmail max attachment",
// "webmail view html" => "webmail view html",
// "webmail quick flags" => "webmail quick flags",
// "feature contacts" => "feature contacts",
// "feature faqs" => "feature faqs",
// "feature faq comments" => "feature faq comments",
// "faq comments per page" => "faq comments per page",
// "faq comments default ordering" => "faq comments default ordering",
// "faq prefix" => "faq prefix",
// "feature quizzes" => "feature quizzes",
// "feature polls" => "feature polls",
// "feature poll comments" => "feature poll comments",
// "feature poll anonymous" => "feature poll anonymous",
// "poll comments default ordering" => "poll comments default ordering",
// "poll comments per page" => "poll comments per page",
// "poll list categories" => "poll list categories",
// "poll list objects" => "poll list objects",
// "poll multiple per object" => "poll multiple per object",
// "feature poll revote" => "feature poll revote",
// "feature surveys" => "feature surveys",
// "feature featuredLinks" => "feature featuredLinks",
// "feature directory" => "feature directory",
// "directory columns" => "directory columns",
// "directory links per page" => "directory links per page",
// "directory open links" => "directory open links",
// "directory validate urls" => "directory validate urls",
// "directory cool sites" => "directory cool sites",
// "directory country flag" => "directory country flag",
// "feature calendar" => "feature calendar",
// "feature default calendars" => "feature default calendars",
// "calendar sticky popup" => "calendar sticky popup",
// "default calendars" => "default calendars",
// "calendar view mode" => "calendar view mode",
// "calendar view tab" => "calendar view tab",
// "calendar firstDayofWeek" => "calendar firstDayofWeek",
// "calendar timespan" => "calendar timespan",
// "feature jscalendar" => "feature jscalendar",
// "feature action calendar" => "feature action calendar",
// "calendar start year" => "calendar start year",
// "calendar end year" => "calendar end year",
// "calendar list begins focus" => "calendar list begins focus",
// "feature cal manual time" => "feature cal manual time",
// "calendar view days" => "calendar view days",
// "calendar addtogooglecal" => "calendar addtogooglecal",
// "server timezone" => "server timezone",
// "long date format" => "long date format",
// "long time format" => "long time format",
// "short date format" => "short date format",
// "short time format" => "short time format",
// "display field order" => "display field order",
// "tiki same day time only" => "tiki same day time only",
// "feed basic auth" => "feed basic auth",
// "feed cache time" => "feed cache time",
// "feed default version" => "feed default version",
// "feed atom author name" => "feed atom author name",
// "feed atom author email" => "feed atom author email",
// "feed atom author url" => "feed atom author url",
// "feed img" => "feed img",
// "feed rss editor email" => "feed rss editor email",
// "feed rss webmaster email" => "feed rss webmaster email",
// "feed language" => "feed language",
// "feed articles" => "feed articles",
// "feed articles desc" => "feed articles desc",
// "feed articles homepage" => "feed articles homepage",
// "feed articles max" => "feed articles max",
// "feed articles showAuthor" => "feed articles showAuthor",
// "feed articles title" => "feed articles title",
// "feed blog" => "feed blog",
// "feed blog desc" => "feed blog desc",
// "feed blog homepage" => "feed blog homepage",
// "feed blog max" => "feed blog max",
// "feed blog showAuthor" => "feed blog showAuthor",
// "feed blog title" => "feed blog title",
// "feed blogs" => "feed blogs",
// "feed blogs desc" => "feed blogs desc",
// "feed blogs homepage" => "feed blogs homepage",
// "feed blogs max" => "feed blogs max",
// "feed blogs showAuthor" => "feed blogs showAuthor",
// "feed blogs title" => "feed blogs title",
// "feed calendar" => "feed calendar",
// "feed calendar desc" => "feed calendar desc",
// "feed calendar homepage" => "feed calendar homepage",
// "feed calendar max" => "feed calendar max",
// "feed calendar showAuthor" => "feed calendar showAuthor",
// "feed calendar title" => "feed calendar title",
// "feed directories" => "feed directories",
// "feed directories desc" => "feed directories desc",
// "feed directories homepage" => "feed directories homepage",
// "feed directories max" => "feed directories max",
// "feed directories showAuthor" => "feed directories showAuthor",
// "feed directories title" => "feed directories title",
// "feed file galleries" => "feed file galleries",
// "feed file galleries desc" => "feed file galleries desc",
// "feed file galleries homepage" => "feed file galleries homepage",
// "feed file galleries max" => "feed file galleries max",
// "feed file galleries showAuthor" => "feed file galleries showAuthor",
// "feed file galleries title" => "feed file galleries title",
// "feed file gallery" => "feed file gallery",
// "feed file gallery desc" => "feed file gallery desc",
// "feed file gallery homepage" => "feed file gallery homepage",
// "feed file gallery max" => "feed file gallery max",
// "feed file gallery showAuthor" => "feed file gallery showAuthor",
// "feed file gallery title" => "feed file gallery title",
// "feed forum" => "feed forum",
// "feed forum desc" => "feed forum desc",
// "feed forum homepage" => "feed forum homepage",
// "feed forum max" => "feed forum max",
// "feed forum showAuthor" => "feed forum showAuthor",
// "feed forum title" => "feed forum title",
// "feed forums max" => "feed forums max",
// "feed forums" => "feed forums",
// "feed forums desc" => "feed forums desc",
// "feed forums showAuthor" => "feed forums showAuthor",
// "feed forums title" => "feed forums title",
// "feed image galleries" => "feed image galleries",
// "feed image galleries desc" => "feed image galleries desc",
// "feed image galleries homepage" => "feed image galleries homepage",
// "feed image galleries max" => "feed image galleries max",
// "feed image galleries showAuthor" => "feed image galleries showAuthor",
// "feed image galleries title" => "feed image galleries title",
// "feed image gallery" => "feed image gallery",
// "feed image gallery desc" => "feed image gallery desc",
// "feed image gallery homepage" => "feed image gallery homepage",
// "feed image gallery max" => "feed image gallery max",
// "feed image gallery showAuthor" => "feed image gallery showAuthor",
// "feed image gallery title" => "feed image gallery title",
// "feed maps" => "feed maps",
// "feed maps desc" => "feed maps desc",
// "feed maps homepage" => "feed maps homepage",
// "feed maps max" => "feed maps max",
// "feed maps showAuthor" => "feed maps showAuthor",
// "feed maps title" => "feed maps title",
// "feed shoutbox" => "feed shoutbox",
// "feed shoutbox desc" => "feed shoutbox desc",
// "feed shoutbox homepage" => "feed shoutbox homepage",
// "feed shoutbox max" => "feed shoutbox max",
// "feed shoutbox showAuthor" => "feed shoutbox showAuthor",
// "feed shoutbox title" => "feed shoutbox title",
// "feed tracker" => "feed tracker",
// "feed tracker desc" => "feed tracker desc",
// "feed tracker homepage" => "feed tracker homepage",
// "feed tracker max" => "feed tracker max",
// "feed tracker showAuthor" => "feed tracker showAuthor",
// "feed tracker title" => "feed tracker title",
// "feed trackers" => "feed trackers",
// "feed trackers desc" => "feed trackers desc",
// "feed trackers homepage" => "feed trackers homepage",
// "feed trackers max" => "feed trackers max",
// "feed trackers showAuthor" => "feed trackers showAuthor",
// "feed trackers title" => "feed trackers title",
// "feed wiki" => "feed wiki",
// "feed wiki desc" => "feed wiki desc",
// "feed wiki homepage" => "feed wiki homepage",
// "feed wiki max" => "feed wiki max",
// "feed wiki showAuthor" => "feed wiki showAuthor",
// "feed wiki title" => "feed wiki title",
// "max rss mapfiles" => "max rss mapfiles",
// "rss mapfiles" => "rss mapfiles",
// "title rss mapfiles" => "title rss mapfiles",
// "feature maps" => "feature maps",
// "map path" => "map path",
// "default map" => "default map",
// "map help" => "map help",
// "map comments" => "map comments",
// "gdaltindex" => "gdaltindex",
// "ogr2ogr" => "ogr2ogr",
// "mapzone" => "mapzone",
// "feature gmap" => "feature gmap",
// "gmap defaultx" => "gmap defaultx",
// "gmap defaulty" => "gmap defaulty",
// "gmap defaultz" => "gmap defaultz",
// "gmap key" => "gmap key",
// "gmap article list" => "gmap article list",
// "gmap page list" => "gmap page list",
// "allowRegister" => "allowRegister",
// "eponymousGroups" => "eponymousGroups",
// "useRegisterPasscode" => "useRegisterPasscode",
// "registerPasscode" => "registerPasscode",
// "rememberme" => "rememberme",
// "remembertime" => "remembertime",
// "feature clear passwords" => "feature clear passwords",
// "feature crypt passwords" => "feature crypt passwords",
// "feature challenge" => "feature challenge",
// "min user length" => "min user length",
// "min pass length" => "min pass length",
// "pass chr num" => "pass chr num",
// "pass due" => "pass due",
// "email due" => "email due",
// "unsuccessful logins" => "unsuccessful logins",
// "generate password" => "generate password",
// "auth method" => "auth method",
// "auth pear" => "auth pear",
// "auth ldap url" => "auth ldap url",
// "auth pear host" => "auth pear host",
// "auth pear port" => "auth pear port",
// "auth ldap scope" => "auth ldap scope",
// "auth ldap basedn" => "auth ldap basedn",
// "auth ldap userdn" => "auth ldap userdn",
// "auth ldap userattr" => "auth ldap userattr",
// "auth ldap useroc" => "auth ldap useroc",
// "auth ldap groupdn" => "auth ldap groupdn",
// "auth ldap groupattr" => "auth ldap groupattr",
// "auth ldap groupnameatr" => "auth ldap groupnameatr",
// "auth ldap groupdescatr" => "auth ldap groupdescatr",
// "auth ldap usergroupattr" => "auth ldap usergroupattr",
// "auth ldap groupgroupattr" => "auth ldap groupgroupattr",
// "auth ldap groupoc" => "auth ldap groupoc",
// "auth ldap memberattr" => "auth ldap memberattr",
// "auth ldap memberisdn" => "auth ldap memberisdn",
// "auth ldap adminuser" => "auth ldap adminuser",
// "auth ldap adminpass" => "auth ldap adminpass",
// "auth ldap version" => "auth ldap version",
// "auth ldap nameattr" => "auth ldap nameattr",
// "auth ldap countryattr" => "auth ldap countryattr",
// "auth ldap emailattr" => "auth ldap emailattr",
// "ldap create user tiki" => "ldap create user tiki",
// "ldap create user ldap" => "ldap create user ldap",
// "ldap skip admin" => "ldap skip admin",
// "auth ldap permit tiki users" => "auth ldap permit tiki users",
// "auth ldap debug" => "auth ldap debug",
// "auth ldap ssl" => "auth ldap ssl",
// "auth ldap starttls" => "auth ldap starttls",
// "auth ldap type" => "auth ldap type",
// "auth ldap syncuserattr" => "auth ldap syncuserattr",
// "auth ldap syncgroupattr" => "auth ldap syncgroupattr",
// "auth phpbb version" => "auth phpbb version",
// "auth phpbb skip admin" => "auth phpbb skip admin",
// "auth phpbb create tiki" => "auth phpbb create tiki",
// "auth phpbb dbhost" => "auth phpbb dbhost",
// "auth phpbb dbport" => "auth phpbb dbport",
// "auth phpbb disable tikionly" => "auth phpbb disable tikionly",
// "auth phpbb dbuser" => "auth phpbb dbuser",
// "auth phpbb dbpasswd" => "auth phpbb dbpasswd",
// "auth phpbb dbname" => "auth phpbb dbname",
// "auth phpbb dbtype" => "auth phpbb dbtype",
// "auth phpbb table prefix" => "auth phpbb table prefix",
// "auth ws create tiki" => "auth ws create tiki",
// "https login" => "https login",
// "https external links for users" => "https external links for users",
// "feature show stay in ssl mode" => "feature show stay in ssl mode",
// "feature switch ssl mode" => "feature switch ssl mode",
// "https port" => "https port",
// "http port" => "http port",
// "login url" => "login url",
// "login scr" => "login scr",
// "register url" => "register url",
// "error url" => "error url",
// "highlight group" => "highlight group",
// "cookie path" => "cookie path",
// "cookie domain" => "cookie domain",
// "cookie name" => "cookie name",
// "user tracker infos" => "user tracker infos",
// "desactive login autocomplete" => "desactive login autocomplete",
// "permission denied login box" => "permission denied login box",
// "permission denied url" => "permission denied url",
// "feature loadbalancer" => "feature loadbalancer",
// "feature intertiki" => "feature intertiki",
// "feature intertiki server" => "feature intertiki server",
// "feature intertiki slavemode" => "feature intertiki slavemode",
// "interlist" => "interlist",
// "feature intertiki mymaster" => "feature intertiki mymaster",
// "feature intertiki import preferences" => "feature intertiki import preferences",
// "feature intertiki import groups" => "feature intertiki import groups",
// "known hosts" => "known hosts",
// "tiki key" => "tiki key",
// "intertiki logfile" => "intertiki logfile",
// "intertiki errfile" => "intertiki errfile",
// "feature intertiki sharedcookie" => "feature intertiki sharedcookie",
// "search lru length" => "search lru length",
// "search lru purge rate" => "search lru purge rate",
// "search max syllwords" => "search max syllwords",
// "search min wordlength" => "search min wordlength",
// "search refresh rate" => "search refresh rate",
// "search syll age" => "search syll age",
// "feature categories" => "feature categories",
// "feature categoryobjects" => "feature categoryobjects",
// "feature categorypath" => "feature categorypath",
// "feature category use phplayers" => "feature category use phplayers",
// "categorypath excluded" => "categorypath excluded",
// "categories used in tpl" => "categories used in tpl",
// "category jail" => "category jail",
// "category defaults" => "category defaults",
// "category i18n sync" => "category i18n sync",
// "category i18n synced" => "category i18n synced",
// "category i18n unsynced" => "category i18n unsynced",
// "category autogeocode within" => "category autogeocode within",
// "category autogeocode replace" => "category autogeocode replace",
// "category autogeocode fudge" => "category autogeocode fudge",
// "expanded category jail" => "expanded category jail",
// "expanded category jail key" => "expanded category jail key",
// "ws container" => "ws container",
// "feature html pages" => "feature html pages",
// "feature filegals manager" => "feature filegals manager",
// "feature contact" => "feature contact",
// "contact user" => "contact user",
// "contact anon" => "contact anon",
// "mail crlf" => "mail crlf",
// "feature detect language" => "feature detect language",
// "feature homePage if bl missing" => "feature homePage if bl missing",
// "record untranslated" => "record untranslated",
// "feature best language" => "feature best language",
// "feature translation" => "feature translation",
// "feature urgent translation" => "feature urgent translation",
// "feature urgent translation master only" => "feature urgent translation master only",
// "feature translation incomplete notice" => "feature translation incomplete notice",
// "lang use db" => "lang use db",
// "language" => "language",
// "restrict language" => "restrict language",
// "feature babelfish" => "feature babelfish",
// "feature babelfish logo" => "feature babelfish logo",
// "quantify changes" => "quantify changes",
// "feature sync language" => "feature sync language",
// "show available translations" => "show available translations",
// "language inclusion threshold" => "language inclusion threshold",
// "metatag keywords" => "metatag keywords",
// "metatag threadtitle" => "metatag threadtitle",
// "metatag imagetitle" => "metatag imagetitle",
// "metatag freetags" => "metatag freetags",
// "metatag description" => "metatag description",
// "metatag pagedesc" => "metatag pagedesc",
// "metatag author" => "metatag author",
// "metatag geoposition" => "metatag geoposition",
// "metatag georegion" => "metatag georegion",
// "metatag geoplacename" => "metatag geoplacename",
// "metatag robots" => "metatag robots",
// "metatag revisitafter" => "metatag revisitafter",
// "head extra js" => "head extra js",
// "keep versions" => "keep versions",
// "feature custom home" => "feature custom home",
// "site crumb seper" => "site crumb seper",
// "site nav seper" => "site nav seper",
// "feature sitemycode" => "feature sitemycode",
// "sitemycode" => "sitemycode",
// "sitemycode publish" => "sitemycode publish",
// "feature sitelogo" => "feature sitelogo",
// "sitelogo bgcolor" => "sitelogo bgcolor",
// "sitelogo bgstyle" => "sitelogo bgstyle",
// "sitelogo align" => "sitelogo align",
// "sitelogo title" => "sitelogo title",
// "sitelogo src" => "sitelogo src",
// "sitelogo alt" => "sitelogo alt",
// "feature siteloc" => "feature siteloc",
// "feature sitenav" => "feature sitenav",
// "sitenav" => "sitenav",
// "feature sitead" => "feature sitead",
// "sitead" => "sitead",
// "sitead publish" => "sitead publish",
// "feature breadcrumbs" => "feature breadcrumbs",
// "feature siteloclabel" => "feature siteloclabel",
// "feature sitesearch" => "feature sitesearch",
// "feature site login" => "feature site login",
// "feature sitemenu" => "feature sitemenu",
// "feature sitemenu custom code" => "feature sitemenu custom code",
// "feature secondary sitemenu custom code" => "feature secondary sitemenu custom code",
// "feature topbar version" => "feature topbar version",
// "feature topbar id menu" => "feature topbar id menu",
// "feature topbar custom code" => "feature topbar custom code",
// "feature sitetitle" => "feature sitetitle",
// "feature sitedesc" => "feature sitedesc",
// "feature bot logo" => "feature bot logo",
// "feature endbody code" => "feature endbody code",
// "feature custom doctype" => "feature custom doctype",
// "feature custom doctype content" => "feature custom doctype content",
// "feature custom html head content" => "feature custom html head content",
// "feature fixed width" => "feature fixed width",
// "feature html head base tag" => "feature html head base tag",
// "feature left column" => "feature left column",
// "feature right column" => "feature right column",
// "feature top bar" => "feature top bar",
// "feature bot bar" => "feature bot bar",
// "feature bot bar icons" => "feature bot bar icons",
// "feature bot bar debug" => "feature bot bar debug",
// "feature bot bar rss" => "feature bot bar rss",
// "feature bot bar power by tw" => "feature bot bar power by tw",
// "maxRecords" => "maxRecords",
// "maxArticles" => "maxArticles",
// "maxVersions" => "maxVersions",
// "feature view tpl" => "feature view tpl",
// "slide style" => "slide style",
// "site favicon" => "site favicon",
// "site favicon type" => "site favicon type",
// "style" => "style",
// "style option" => "style option",
// "use context menu icon" => "use context menu icon",
// "use context menu text" => "use context menu text",
// "feature site report" => "feature site report",
// "feature site send link" => "feature site send link",
// "feature layoutshadows" => "feature layoutshadows",
// "main shadow start" => "main shadow start",
// "main shadow end" => "main shadow end",
// "header shadow start" => "header shadow start",
// "header shadow end" => "header shadow end",
// "middle shadow start" => "middle shadow start",
// "middle shadow end" => "middle shadow end",
// "center shadow start" => "center shadow start",
// "center shadow end" => "center shadow end",
// "footer shadow start" => "footer shadow start",
// "footer shadow end" => "footer shadow end",
// "box shadow start" => "box shadow start",
// "box shadow end" => "box shadow end",
// "feature custom center column header" => "feature custom center column header",
// "header custom css" => "header custom css",
// "header custom js" => "header custom js",
// "feature mods provider" => "feature mods provider",
// "mods dir" => "mods dir",
// "mods server" => "mods server",
// "feature experimental" => "feature experimental",
// "feature actionlog" => "feature actionlog",
// "feature actionlog bytes" => "feature actionlog bytes",
// "browsertitle" => "browsertitle",
// "site title location" => "site title location",
// "site title breadcrumb" => "site title breadcrumb",
// "tmpDir" => "tmpDir",
// "feature tell a friend" => "feature tell a friend",
// "feature share" => "feature share",
// "feature copyright" => "feature copyright",
// "feature smileys" => "feature smileys",
// "popupLinks" => "popupLinks",
// "feature autolinks" => "feature autolinks",
// "default rows textarea wiki" => "default rows textarea wiki",
// "default rows textarea comment" => "default rows textarea comment",
// "default rows textarea forum" => "default rows textarea forum",
// "default rows textarea forumthread" => "default rows textarea forumthread",
// "section comments parse" => "section comments parse",
// "toolbar global" => "toolbar global",
// "toolbar global comments" => "toolbar global comments",
// "toolbar sheet" => "toolbar sheet",
// "direct pagination" => "direct pagination",
// "nextprev pagination" => "nextprev pagination",
// "pagination firstlast" => "pagination firstlast",
// "pagination hide if one page" => "pagination hide if one page",
// "pagination icons" => "pagination icons",
// "pagination fastmove links" => "pagination fastmove links",
// "direct pagination max middle links" => "direct pagination max middle links",
// "direct pagination max ending links" => "direct pagination max ending links",
// "feature kaltura" => "feature kaltura",
// "wikiplugin kaltura" => "wikiplugin kaltura",
// "wikiplugininline kaltura" => "wikiplugininline kaltura",
// "default kaltura editor" => "default kaltura editor",
// "partnerId" => "partnerId",
// "secret" => "secret",
// "adminSecret" => "adminSecret",
// "kdpUIConf" => "kdpUIConf",
// "kdpWidget" => "kdpWidget",
// "kcwUIConf" => "kcwUIConf",
// "kseUIConf" => "kseUIConf",
// "kaeUIConf" => "kaeUIConf",
// "kuser" => "kuser",
// "kServiceUrl" => "kServiceUrl",
// "bigbluebutton feature" => "bigbluebutton feature",
// "bigbluebutton server location" => "bigbluebutton server location",
// "bigbluebutton server salt" => "bigbluebutton server salt",
// "shipping service" => "shipping service",
// "shipping fedex enable" => "shipping fedex enable",
// "shipping fedex key" => "shipping fedex key",
// "shipping fedex password" => "shipping fedex password",
// "shipping fedex meter" => "shipping fedex meter",
// "shipping fedex account" => "shipping fedex account",
// "shipping ups enable" => "shipping ups enable",
// "shipping ups username" => "shipping ups username",
// "shipping ups password" => "shipping ups password",
// "shipping ups license" => "shipping ups license",
// "recaptcha enabled" => "recaptcha enabled",
// "recaptcha pubkey" => "recaptcha pubkey",
// "recaptcha privkey" => "recaptcha privkey",
// "captcha wordLen" => "captcha wordLen",
// "captcha width" => "captcha width",
// "captcha noise" => "captcha noise",
// "anonCanEdit" => "anonCanEdit",
// "cacheimages" => "cacheimages",
// "cachepages" => "cachepages",
// "count admin pvs" => "count admin pvs",
// "default mail charset" => "default mail charset",
// "error reporting adminonly" => "error reporting adminonly",
// "error reporting level" => "error reporting level",
// "smarty notice reporting" => "smarty notice reporting",
// "smarty security" => "smarty security",
// "smarty compilation" => "smarty compilation",
// "feature htmlpurifier output" => "feature htmlpurifier output",
// "feature ajax" => "feature ajax",
// "ajax autosave" => "ajax autosave",
// "ajax xajax" => "ajax xajax",
// "feature antibot" => "feature antibot",
// "feature banners" => "feature banners",
// "feature banning" => "feature banning",
// "feature comm" => "feature comm",
// "feature contribution" => "feature contribution",
// "feature contribution display in comment" => "feature contribution display in comment",
// "feature contribution mandatory" => "feature contribution mandatory",
// "feature contribution mandatory blog" => "feature contribution mandatory blog",
// "feature contribution mandatory comment" => "feature contribution mandatory comment",
// "feature contribution mandatory forum" => "feature contribution mandatory forum",
// "feature credits" => "feature credits",
// "feature debug console" => "feature debug console",
// "feature debugger console" => "feature debugger console",
// "feature display my to others" => "feature display my to others",
// "feature dynamic content" => "feature dynamic content",
// "feature edit templates" => "feature edit templates",
// "feature editcss" => "feature editcss",
// "feature events" => "feature events",
// "feature friends" => "feature friends",
// "feature fullscreen" => "feature fullscreen",
// "feature help" => "feature help",
// "feature hotwords" => "feature hotwords",
// "feature hotwords nw" => "feature hotwords nw",
// "feature integrator" => "feature integrator",
// "feature live support" => "feature live support",
// "feature mailin" => "feature mailin",
// "feature menusfolderstyle" => "feature menusfolderstyle",
// "feature mobile" => "feature mobile",
// "feature modulecontrols" => "feature modulecontrols",
// "feature morcego" => "feature morcego",
// "feature multilingual" => "feature multilingual",
// "feature multilingual one page" => "feature multilingual one page",
// "feature multilingual structures" => "feature multilingual structures",
// "feature machine translation" => "feature machine translation",
// "feature newsletters" => "feature newsletters",
// "feature obzip" => "feature obzip",
// "feature perspective" => "feature perspective",
// "feature phplayers" => "feature phplayers",
// "feature cssmenus" => "feature cssmenus",
// "menus item names raw" => "menus item names raw",
// "feature projects" => "feature projects",
// "feature ranking" => "feature ranking",
// "feature redirect on error" => "feature redirect on error",
// "url anonymous page not found" => "url anonymous page not found",
// "feature referer highlight" => "feature referer highlight",
// "feature referer stats" => "feature referer stats",
// "feature score" => "feature score",
// "feature sheet" => "feature sheet",
// "feature shoutbox" => "feature shoutbox",
// "feature source" => "feature source",
// "feature stats" => "feature stats",
// "feature tabs" => "feature tabs",
// "feature theme control" => "feature theme control",
// "feature ticketlib" => "feature ticketlib",
// "feature ticketlib2" => "feature ticketlib2",
// "feature top banner" => "feature top banner",
// "feature usability" => "feature usability",
// "feature use quoteplugin" => "feature use quoteplugin",
// "feature use three colon centertag" => "feature use three colon centertag",
// "feature user watches" => "feature user watches",
// "feature group watches" => "feature group watches",
// "feature user watches translations" => "feature user watches translations",
// "feature user watches languages" => "feature user watches languages",
// "feature daily report watches" => "feature daily report watches",
// "feature quick object perms" => "feature quick object perms",
// "feature xmlrpc" => "feature xmlrpc",
// "feature watershed" => "feature watershed",
// "helpurl" => "helpurl",
// "layout section" => "layout section",
// "limitedGoGroupHome" => "limitedGoGroupHome",
// "minical reminders" => "minical reminders",
// "modallgroups" => "modallgroups",
// "modseparateanon" => "modseparateanon",
// "modhideanonadmin" => "modhideanonadmin",
// "php docroot" => "php docroot",
// "proxy host" => "proxy host",
// "proxy port" => "proxy port",
// "ip can be checked" => "ip can be checked",
// "feature site report email" => "feature site report email",
// "session storage" => "session storage",
// "session lifetime" => "session lifetime",
// "session silent" => "session silent",
// "session cookie name" => "session cookie name",
// "session protected" => "session protected",
// "shoutbox autolink" => "shoutbox autolink",
// "show comzone" => "show comzone",
// "tikiIndex" => "tikiIndex",
// "urlIndex" => "urlIndex",
// "useGroupHome" => "useGroupHome",
// "useGroupTheme" => "useGroupTheme",
// "useUrlIndex" => "useUrlIndex",
// "use proxy" => "use proxy",
// "user list order" => "user list order",
// "webserverauth" => "webserverauth",
// "feature purifier" => "feature purifier",
// "feature shadowbox" => "feature shadowbox",
// "log sql" => "log sql",
// "log sql perf min" => "log sql perf min",
// "log mail" => "log mail",
// "log tpl" => "log tpl",
// "disableJavascript" => "disableJavascript",
// "feature socialnetworks" => "feature socialnetworks",
// "socialnetworks twitter consumer key" => "socialnetworks twitter consumer key",
// "socialnetworks twitter consumer secret" => "socialnetworks twitter consumer secret",
// "socialnetworks facebook api key" => "socialnetworks facebook api key",
// "socialnetworks facebook application secr" => "socialnetworks facebook application secr",
// "socialnetworks facebook application id" => "socialnetworks facebook application id",
// "socialnetworks bitly login" => "socialnetworks bitly login",
// "socialnetworks bitly key" => "socialnetworks bitly key",
// "socialnetworks bitly sitewide" => "socialnetworks bitly sitewide",
// "case patched" => "case patched",
// "site closed" => "site closed",
// "site closed msg" => "site closed msg",
// "use load threshold" => "use load threshold",
// "load threshold" => "load threshold",
// "site busy msg" => "site busy msg",
// "bot logo code" => "bot logo code",
// "feature create webhelp" => "feature create webhelp",
// "page n times in a structure" => "page n times in a structure",
// "feature forums search" => "feature forums search",
// "feature wiki ext icon" => "feature wiki ext icon",
// "feature wiki ext rel nofollow" => "feature wiki ext rel nofollow",
// "feature wiki mandatory category" => "feature wiki mandatory category",
// "feature intertiki imported groups" => "feature intertiki imported groups",
// "feature wiki history ip" => "feature wiki history ip",
// "pam create user tiki" => "pam create user tiki",
// "pam service" => "pam service",
// "pam skip admin" => "pam skip admin",
// "shib affiliation" => "shib affiliation",
// "shib create user tiki" => "shib create user tiki",
// "shib group" => "shib group",
// "shib skip admin" => "shib skip admin",
// "shib usegroup" => "shib usegroup",
// "wiki 3d camera distance" => "wiki 3d camera distance",
// "wiki 3d elastic constant" => "wiki 3d elastic constant",
// "wiki 3d eletrostatic constant" => "wiki 3d eletrostatic constant",
// "wiki 3d fov" => "wiki 3d fov",
// "wiki 3d friction constant" => "wiki 3d friction constant",
// "wiki 3d node charge" => "wiki 3d node charge",
// "wiki 3d node mass" => "wiki 3d node mass",
// "wiki 3d node size" => "wiki 3d node size",
// "wiki 3d spring size" => "wiki 3d spring size",
// "wiki 3d text size" => "wiki 3d text size",
// "articles feature copyrights" => "articles feature copyrights",
// "blogues feature copyrights" => "blogues feature copyrights",
// "faqs feature copyrights" => "faqs feature copyrights",
// "feature contributor wiki" => "feature contributor wiki",
// "https login required" => "https login required",
// "maxRowsGalleries" => "maxRowsGalleries",
// "replimaster" => "replimaster",
// "rowImagesGalleries" => "rowImagesGalleries",
// "scaleSizeGalleries" => "scaleSizeGalleries",
// "thumbSizeXGalleries" => "thumbSizeXGalleries",
// "thumbSizeYGalleries" => "thumbSizeYGalleries",
// "wiki 3d adjust camera" => "wiki 3d adjust camera",
// "wiki 3d autoload" => "wiki 3d autoload",
// "javascript enabled" => "javascript enabled",
// "javascript cdn" => "javascript cdn",
// "feature template zoom" => "feature template zoom",
// "menus items icons" => "menus items icons",
// "menus items icons path" => "menus items icons path",
// "feature iepngfix" => "feature iepngfix",
// "iepngfix selectors" => "iepngfix selectors",
// "iepngfix elements" => "iepngfix elements",
// "feature invite" => "feature invite",
// "feature jquery" => "feature jquery",
// "jquery effect" => "jquery effect",
// "jquery effect direction" => "jquery effect direction",
// "jquery effect speed" => "jquery effect speed",
// "jquery effect tabs" => "jquery effect tabs",
// "jquery effect tabs direction" => "jquery effect tabs direction",
// "jquery effect tabs speed" => "jquery effect tabs speed",
// "feature jquery ui" => "feature jquery ui",
// "feature jquery ui theme" => "feature jquery ui theme",
// "feature jquery tooltips" => "feature jquery tooltips",
// "feature jquery autocomplete" => "feature jquery autocomplete",
// "feature jquery superfish" => "feature jquery superfish",
// "feature jquery reflection" => "feature jquery reflection",
// "feature jquery jqs5" => "feature jquery jqs5",
// "feature jquery tablesorter" => "feature jquery tablesorter",
// "feature jquery carousel" => "feature jquery carousel",
// "feature jquery validation" => "feature jquery validation",
// "feature jquery media" => "feature jquery media",
// "feature sefurl" => "feature sefurl",
// "feature sefurl filter" => "feature sefurl filter",
// "feature sefurl paths" => "feature sefurl paths",
// "feature sefurl title article" => "feature sefurl title article",
// "feature sefurl title blog" => "feature sefurl title blog",
// "feature sefurl tracker prefixalias" => "feature sefurl tracker prefixalias",
// "feature tikitests" => "feature tikitests",
// "profile sources" => "profile sources",
// "profile channels" => "profile channels",
// "feature minichat" => "feature minichat",
// "memcache enabled" => "memcache enabled",
// "memcache compress" => "memcache compress",
// "memcache servers" => "memcache servers",
// "memcache expiration" => "memcache expiration",
// "memcache prefix" => "memcache prefix",
// "memcache wiki data" => "memcache wiki data",
// "memcache wiki output" => "memcache wiki output",
// "memcache forum output" => "memcache forum output",
// "feature pear date" => "feature pear date",
// "feature bidi" => "feature bidi",
// "feature lastup" => "feature lastup",
// "feature groupalert" => "feature groupalert",
// "zend mail handler" => "zend mail handler",
// "zend mail smtp server" => "zend mail smtp server",
// "zend mail smtp auth" => "zend mail smtp auth",
// "zend mail smtp user" => "zend mail smtp user",
// "zend mail smtp pass" => "zend mail smtp pass",
// "zend mail smtp port" => "zend mail smtp port",
// "zend mail smtp security" => "zend mail smtp security",
// "feature group transition" => "feature group transition",
// "feature category transition" => "feature category transition",
// "terminology profile installed" => "terminology profile installed",
// "multidomain active" => "multidomain active",
// "multidomain config" => "multidomain config",
// "tiki minify javascript" => "tiki minify javascript",
// "tiki minify css" => "tiki minify css",
// "tiki minify css single file" => "tiki minify css single file",
// "tiki cachecontrol session" => "tiki cachecontrol session",
// "tiki cachecontrol nosession" => "tiki cachecontrol nosession",
// "tiki cdn" => "tiki cdn",
// "tiki cdn ssl" => "tiki cdn ssl",
// "auth token access" => "auth token access",
// "auth token access maxtimeout" => "auth token access maxtimeout",
// "auth token access maxhits" => "auth token access maxhits",
// "auth token tellafriend" => "auth token tellafriend",
// "auth token share" => "auth token share",
// "print pdf from url" => "print pdf from url",
// "print pdf webkit path" => "print pdf webkit path",
// "print pdf webservice url" => "print pdf webservice url",
// "feature metrics dashboard" => "feature metrics dashboard",
// "metrics trend prefix" => "metrics trend prefix",
// "metrics trend suffix" => "metrics trend suffix",
// "metrics trend novalue" => "metrics trend novalue",
// "metrics pastresults count" => "metrics pastresults count",
// "metrics metric name length" => "metrics metric name length",
// "metrics tab name length" => "metrics tab name length",
// "metrics cache output" => "metrics cache output",
// "payment feature" => "payment feature",
// "payment system" => "payment system",
// "payment currency" => "payment currency",
// "payment default delay" => "payment default delay",
// "payment paypal business" => "payment paypal business",
// "payment paypal environment" => "payment paypal environment",
// "payment paypal ipn" => "payment paypal ipn",
// "payment cclite registries" => "payment cclite registries",
// "payment cclite currencies" => "payment cclite currencies",
// "payment cclite gateway" => "payment cclite gateway",
// "payment cclite merchant key" => "payment cclite merchant key",
// "payment cclite merchant user" => "payment cclite merchant user",
// "payment cclite mode" => "payment cclite mode",
// "payment cclite notify" => "payment cclite notify",
// "payment cclite hashing algorithm" => "payment cclite hashing algorithm",
// "payment manual" => "payment manual",
// "payment invoice prefix" => "payment invoice prefix",
// "rating advanced" => "rating advanced",
// "rating recalculation" => "rating recalculation",
// "rating recalculation odd" => "rating recalculation odd",
// "rating recalculation count" => "rating recalculation count",
// "cas create user tiki" => "cas create user tiki",
// "cas create user tiki ldap" => "cas create user tiki ldap",
// "cas autologin" => "cas autologin",
// "cas skip admin" => "cas skip admin",
// "cas show alternate login" => "cas show alternate login",
// "cas version" => "cas version",
// "cas hostname" => "cas hostname",
// "cas port" => "cas port",
// "cas path" => "cas path",
// "cas extra param" => "cas extra param",
// "cas authentication timeout" => "cas authentication timeout",
// "cas force logout" => "cas force logout",
// "feature comments post as anonymous" => "feature comments post as anonymous",
// "feature comments moderation" => "feature comments moderation",
// "feature comments locking" => "feature comments locking",
// "comments notitle" => "comments notitle",
// "comments field email" => "comments field email",
// "comments field website" => "comments field website",
// "comments vote" => "comments vote",
// "allowMsgs" => "allowMsgs",
// "diff versions" => "diff versions",
// "display timezone" => "display timezone",
// "email is public" => "email is public",
// "homePage" => "homePage",
// "lat" => "lat",
// "lon" => "lon",
// "mess archiveAfter" => "mess archiveAfter",
// "mess maxRecords" => "mess maxRecords",
// "mess sendReadStatus" => "mess sendReadStatus",
// "minPrio" => "minPrio",
// "mytiki blogs" => "mytiki blogs",
// "mytiki articles" => "mytiki articles",
// "mytiki gals" => "mytiki gals",
// "mytiki items" => "mytiki items",
// "mytiki msgs" => "mytiki msgs",
// "mytiki pages" => "mytiki pages",
// "mytiki tasks" => "mytiki tasks",
// "mytiki forum topics" => "mytiki forum topics",
// "mytiki forum replies" => "mytiki forum replies",
// "realName" => "realName",
// "gender" => "gender",
// "show mouseover user info" => "show mouseover user info",
// "tasks maxRecords" => "tasks maxRecords",
// "user dbl" => "user dbl",
// "user information" => "user information",
// "mailCharset" => "mailCharset",
// "mailCurrentAccount" => "mailCurrentAccount",
// "Non Advanced Search or Natural Search" => "Non Advanced Search or Natural Search",
// "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. ",
// "Advanced Search or Boolean Search" => "Advanced Search or Boolean Search",
// "Default search behavior" => "Default search behavior",
// "By default, all search terms are <em>optional</em>" => "By default, all search terms are <em>optional</em>",
// "It behaves like an OR logic" => "It behaves like an OR logic",
// "Objects that contain the more terms are rated higher in the results and will appear first in their type" => "Objects that contain the more terms are rated higher in the results and will appear first in their type",
// "For example, <strong>wiki forum</strong> will find" => "For example, <strong>wiki forum</strong> will find",
// "objects that include both terms" => "objects that include both terms",
// "objects that include the term <strong>wiki</strong>" => "objects that include the term <strong>wiki</strong>",
// "objects that include the term <strong>forum</strong>" => "objects that include the term <strong>forum</strong>",
// "Requiring terms" => "Requiring terms",
// "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results" => "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results",
// "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first" => "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first",
// "Excluding terms" => "Excluding terms",
// "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results" => "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results",
// "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value" => "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value",
// "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>",
// "Grouping terms" => "Grouping terms",
// "Use parenthesis ( ) to group terms into subexpressions" => "Use parenthesis ( ) to group terms into subexpressions",
// "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
// "Finding phrases" => "Finding phrases",
// "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed" => "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed",
// "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. ",
// "Using wildcards" => "Using wildcards",
// "Add an asterisk ( * ) after a term to find objects that include the root word" => "Add an asterisk ( * ) after a term to find objects that include the root word",
// "For example, <strong>run*</strong> will find" => "For example, <strong>run*</strong> will find",
// "objects that include the term <strong>run</strong>" => "objects that include the term <strong>run</strong>",
// "objects that include the term <strong>runner</strong>" => "objects that include the term <strong>runner</strong>",
// "objects that include the term <strong>running</strong>" => "objects that include the term <strong>running</strong>",
// "Reducing a term's value" => "Reducing a term's value",
// "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results",
// "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms" => "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms",
// "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>" => "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>",
// "Changing relevance value" => "Changing relevance value",
// "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object" => "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object",
// "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher" => "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher",
// "ShareThis via AIM, social bookmarking and networking sites, etc" => "ShareThis via AIM, social bookmarking and networking sites, etc",
// "Published " => "Published ",
// "Previous post" => "Previous post",
// "Next post" => "Next post",
// "Read more" => "Read more",
// "Related content" => "Related content",
// "Leave a comment" => "Leave a comment",
// "Parent Gallery" => "Parent Gallery",
// "Click Here to Insert in Wiki Syntax" => "Click Here to Insert in Wiki Syntax",
// "{\$comments_cant} comment" => "{\$comments_cant} comment",
// "{\$comments_cant} comments" => "{\$comments_cant} comments",
// "Comments Locked" => "Comments Locked",
// "Comments are locked" => "Comments are locked",
// "Reply to the selected comment" => "Reply to the selected comment",
// "(your email address will not be published)" => "(your email address will not be published)",
// "Website" => "Website",
// "Rate this Article (10=best, 0=worse)" => "Rate this Article (10=best, 0=worse)",
// "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue",
// "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation" => "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation",
// "The query was" => "The query was",
// "The built query was likely" => "The built query was likely",
// "Stacktrace" => "Stacktrace",
// "Tiki is unable to connect to the database" => "Tiki is unable to connect to the database",
// "An error occured while performing the request" => "An error occured while performing the request",
// "File gallery" => "File gallery",
// "Duplicate permissions" => "Duplicate permissions",
// "Any file" => "Any file",
// "Podcast (audio)" => "Podcast (audio)",
// "Podcast (video)" => "Podcast (video)",
// "Gallery is visible to non-admin users" => "Gallery is visible to non-admin users",
// "Gallery is public" => "Gallery is public",
// "Any user with permission (not only the gallery owner) can upload files" => "Any user with permission (not only the gallery owner) can upload files",
// "Perms of the backlinks are checked to view a file" => "Perms of the backlinks are checked to view a file",
// "Files can be locked at download" => "Files can be locked at download",
// "Quota" => "Quota",
// "Used" => "Used",
// "Min" => "Min",
// "Group of users alerted when file gallery is modified" => "Group of users alerted when file gallery is modified",
// "Allows to select each user for small groups" => "Allows to select each user for small groups",
// "Maximum width for images in gallery" => "Maximum width for images in gallery",
// "If an image is wider than this, it will be resized" => "If an image is wider than this, it will be resized",
// "Attention: In this case, the original image will be lost" => "Attention: In this case, the original image will be lost",
// "Maximum height for images in gallery" => "Maximum height for images in gallery",
// "If an image is higher than this, it will be resized" => "If an image is higher than this, it will be resized",
// "Wiki markup to enter when image selected from \"file gallery manager\"" => "Wiki markup to enter when image selected from \"file gallery manager\"",
// "The default is " => "The default is ",
// "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%",
// "Max rows per page" => "Max rows per page",
// "Select which items to display when listing galleries" => "Select which items to display when listing galleries",
// "Change them here" => "Change them here",
// "Share a link to this file" => "Share a link to this file",
// "Email a link to this file" => "Email a link to this file",
// "The checkbox is disabled because this preference is disabled globally" => "The checkbox is disabled because this preference is disabled globally",
// "Please, enable the preference globally first" => "Please, enable the preference globally first",
// "You can ask your site Admin to enable the preference" => "You can ask your site Admin to enable the preference",
// "Start the Slideshow" => "Start the Slideshow",
// "Pause the Slideshow" => "Pause the Slideshow",
// "and all the sub-objects" => "and all the sub-objects",
// "not in" => "not in",
// "Orphans" => "Orphans",
// "Clear Filter" => "Clear Filter",
// "Map View" => "Map View",
// "Folksonomy Language" => "Folksonomy Language",
// "Untag" => "Untag",
// "Are you sure you want to reset the default gallery list table settings" => "Are you sure you want to reset the default gallery list table settings",
// "Reset to default gallery list table settings" => "Reset to default gallery list table settings",
// "Download the zip" => "Download the zip",
// "No Additional Sort" => "No Additional Sort",
// "Hi {\$mail_user|username} has sent you this link" => "Hi {\$mail_user|username} has sent you this link",
// "Remove file" => "Remove file",
// "GalleryId" => "GalleryId",
// "FileId" => "FileId",
// "You are invited by" => "You are invited by",
// "You join this group" => "You join this group",
// "Join me on %s" => "Join me on %s",
// "Assign to a group" => "Assign to a group",
// "View user's data" => "View user's data",
// "Best regards" => "Best regards",
// "Zoom out" => "Zoom out",
// "Zoom in" => "Zoom in",
// "from the mapfile" => "from the mapfile",
// "Toggle Vertically" => "Toggle Vertically",
// "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tiki.org</a>" => "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tiki.org</a>",
// "Untitled" => "Untitled",
// "Unit cost" => "Unit cost",
// "Qty" => "Qty",
// "Check-out" => "Check-out",
// "Your cart is empty" => "Your cart is empty",
// "Missing %0 of the following categories" => "Missing %0 of the following categories",
// "%0 extra of the following categories" => "%0 extra of the following categories",
// "Unknown comparison" => "Unknown comparison",
// "Impossible condition, %0 of" => "Impossible condition, %0 of",
// "Assign into category" => "Assign into category",
// "Unassign category" => "Unassign category",
// "All Groups" => "All Groups",
// "Your Groups" => "Your Groups",
// "Emulated Groups" => "Emulated Groups",
// "Switch to Groups" => "Switch to Groups",
// "Simulate" => "Simulate",
// "Last `\$module_rows` Podcasts" => "Last `\$module_rows` Podcasts",
// "This is likely not a podcast file" => "This is likely not a podcast file",
// "The path to a podcast player is required" => "The path to a podcast player is required",
// "No avatar" => "No avatar",
// "Enter user name and click 'Switch'.<br />Useful for testing permissions" => "Enter user name and click 'Switch'.<br />Useful for testing permissions",
// "Log in through CAS" => "Log in through CAS",
// "Log in as admin" => "Log in as admin",
// "Log in through Shibboleth" => "Log in through Shibboleth",
// "Log in as" => "Log in as",
// "CapsLock is on" => "CapsLock is on",
// "OpenID Log in" => "OpenID Log in",
// "What is OpenID" => "What is OpenID",
// "Stay on this page" => "Stay on this page",
// "Edit perspectives" => "Edit perspectives",
// "Description (used for metatags)" => "Description (used for metatags)",
// "Paste content here" => "Paste content here",
// "Wiki feed" => "Wiki feed",
// "Feed" => "Feed",
// "Blogs feed" => "Blogs feed",
// "Articles feed" => "Articles feed",
// "Image Galleries feed" => "Image Galleries feed",
// "File Galleries feed" => "File Galleries feed",
// "Forums feed" => "Forums feed",
// "Maps feed" => "Maps feed",
// "Search Help" => "Search Help",
// "Search for text throughout the site" => "Search for text throughout the site",
// "Go directly to a page, or search in page titles if exact match is not found" => "Go directly to a page, or search in page titles if exact match is not found",
// "Edit existing page or create a new one" => "Edit existing page or create a new one",
// "Page Relations" => "Page Relations",
// "Are you sure you want to delete this shout" => "Are you sure you want to delete this shout",
// "Tweet with twitter" => "Tweet with twitter",
// "Post on my facebook wall" => "Post on my facebook wall",
// "Shout date" => "Shout date",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
// "Multiple" => "Multiple",
// "including" => "including",
// "`\$module_params.prefix`" => "`\$module_params.prefix`",
// "Find term" => "Find term",
// "If not found, you will be given a chance to create it" => "If not found, you will be given a chance to create it",
// "TikiTests Menu" => "TikiTests Menu",
// "List Tests" => "List Tests",
// "Create Test" => "Create Test",
// "Posted to" => "Posted to",
// "(Read More)" => "(Read More)",
// "Tracker name" => "Tracker name",
// "Incoming" => "Incoming",
// "To <strong>continue translating</strong>, select the language to translate from" => "To <strong>continue translating</strong>, select the language to translate from",
// "Outgoing" => "Outgoing",
// "Group information" => "Group information",
// "Webmail inbox" => "Webmail inbox",
// "Refresh (non-ajax)" => "Refresh (non-ajax)",
// "TAKE" => "TAKE",
// "View contact" => "View contact",
// "User does not accept messages" => "User does not accept messages",
// "More Videos" => "More Videos",
// "Session" => "Session",
// "Old Session" => "Old Session",
// "Old Version" => "Old Version",
// "New Session" => "New Session",
// "New Version" => "New Version",
// "Use Ctrl+Click to select multiple options" => "Use Ctrl+Click to select multiple options",
// "You need to set" => "You need to set",
// "Reset to default" => "Reset to default",
// "{\$customfields[ir].label}" => "{\$customfields[ir].label}",
// "Lowercase only" => "Lowercase only",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "Download Log File" => "Download Log File",
// "absE" => "absE",
// "Module errors" => "Module errors",
// "The following modules could not be loaded" => "The following modules could not be loaded",
// "Preference was not set" => "Preference was not set",
// "Login through Shibboleth" => "Login through Shibboleth",
// "Designed originally by" => "Designed originally by",
// "Note: The search index needs rebuilding, this will take a few minutes" => "Note: The search index needs rebuilding, this will take a few minutes",
// "Your database requires an update to match the current Tiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors" => "Your database requires an update to match the current Tiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors",
// "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>" => "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>",
// "External Pages Cache" => "External Pages Cache",
// "External Wikis" => "External Wikis",
// "Please select some actions to be reported" => "Please select some actions to be reported",
// "Users and Groups" => "Users and Groups",
// "kb" => "kb",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "See Statistics" => "See Statistics",
// "Pagination" => "Pagination",
// "contributor" => "contributor",
// "Edit Action" => "Edit Action",
// "Save Action" => "Save Action",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volumen per category" => "Volumen per category",
// "Volumn per category and per user" => "Volumn per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Total number of users" => "Total number of users",
// "Number of actions per object" => "Number of actions per object",
// "Total number of objects" => "Total number of objects",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volume per the users'group and per contribution" => "Volume per the users'group and per contribution",
// "Volume per group and per contribution" => "Volume per group and per contribution",
// "Volume per user and per contribution" => "Volume per user and per contribution",
// "Volume per users' contribution and time" => "Volume per users' contribution and time",
// "Volumn per contribution and time" => "Volumn per contribution and time",
// "How" => "How",
// "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occured since the action type has been set to recorded" => "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occured since the action type has been set to recorded",
// "Add or edit rules" => "Add or edit rules",
// "Multiple IP regex matching" => "Multiple IP regex matching",
// "Create Calendar" => "Create Calendar",
// "Perso" => "Perso",
// "Custom Classifications" => "Custom Classifications",
// "Days to display" => "Days to display",
// "Create/Edit category" => "Create/Edit category",
// "Remove from this Category" => "Remove from this Category",
// "Moving objects between categories" => "Moving objects between categories",
// "Unassign all objects from this category" => "Unassign all objects from this category",
// "Move all the objects from this category to this one" => "Move all the objects from this category to this one",
// "Assign all objects of this category to this one" => "Assign all objects of this category to this one",
// "File gal" => "File gal",
// "Use the Administration page of each enabled feature to allow the use of content templates" => "Use the Administration page of each enabled feature to allow the use of content templates",
// "Name field is mandatory" => "Name field is mandatory",
// "Use in" => "Use in",
// "No features are configured to use templates" => "No features are configured to use templates",
// "Template Type" => "Template Type",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
// "Contributions are mandatory in blogs" => "Contributions are mandatory in blogs",
// "Manage Credits" => "Manage Credits",
// "(YYYY-MM-DD HH:MM:SS)" => "(YYYY-MM-DD HH:MM:SS)",
// "(level credits always 0)" => "(level credits always 0)",
// "Delete Checked" => "Delete Checked",
// "User Credits Expiry Summary (Plans)" => "User Credits Expiry Summary (Plans)",
// "User Plan" => "User Plan",
// "Start of Latest Plan" => "Start of Latest Plan",
// "Start of Next Plan" => "Start of Next Plan",
// "Expiry" => "Expiry",
// "Use User Credits" => "Use User Credits",
// "Amount" => "Amount",
// "Restore User Level Credits" => "Restore User Level Credits",
// "Restore" => "Restore",
// "Historical Usage Report" => "Historical Usage Report",
// "Usage Date" => "Usage Date",
// "Amount Used" => "Amount Used",
// "Manage Credit Types" => "Manage Credit Types",
// "Display Text" => "Display Text",
// "Unit Text" => "Unit Text",
// "Is Static Level Credit" => "Is Static Level Credit",
// "Display Bar Length Scaling Divisor" => "Display Bar Length Scaling Divisor",
// "Purge Expired and Used Credits (All Users)" => "Purge Expired and Used Credits (All Users)",
// "Purge" => "Purge",
// "Create/edit DSN" => "Create/edit DSN",
// "Local (Tiki database)" => "Local (Tiki database)",
// "See db/local.php" => "See db/local.php",
// "Admin External Wikis" => "Admin External Wikis",
// "View this forum" => "View this forum",
// ".." => "..",
// "Create/Edit Forums" => "Create/Edit Forums",
// "Only allow replies to the first message (flat forum)" => "Only allow replies to the first message (flat forum)",
// "Last post title" => "Last post title",
// "Last post avatar" => "Last post avatar",
// "Author avatar" => "Author avatar",
// "Online" => "Online",
// "Shows number of attachments of the all thread in forum list" => "Shows number of attachments of the all thread in forum list",
// "Set topics preferences" => "Set topics preferences",
// "Show topics preferences" => "Show topics preferences",
// "hide topics preferences" => "hide topics preferences",
// "Set thread preferences" => "Set thread preferences",
// "Show threads preferences" => "Show threads preferences",
// "hide threads preferences" => "hide threads preferences",
// "Default style for threads" => "Default style for threads",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
// "Admin dynamic zones" => "Admin dynamic zones",
// "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones",
// "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users",
// "Global site configuration, date formats, admin password etc" => "Global site configuration, date formats, admin password etc",
// "Switches for major features" => "Switches for major features",
// "User registration, remember me cookie settings and authentication methods" => "User registration, remember me cookie settings and authentication methods",
// "User specific features and settings" => "User specific features and settings",
// "Repository configuration, browse and apply profiles" => "Repository configuration, browse and apply profiles",
// "Look &amp; Feel" => "Look &amp; Feel",
// "Theme selection, layout settings and UI effect controls" => "Theme selection, layout settings and UI effect controls",
// "Module appearance settings" => "Module appearance settings",
// "Information to include in the header of each page" => "Information to include in the header of each page",
// "Server performance settings" => "Server performance settings",
// "Comments settings" => "Comments settings",
// "Defaults and configuration for file galleries" => "Defaults and configuration for file galleries",
// "Settings for blogs" => "Settings for blogs",
// "Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Defaults and configuration for image galleries (will be phased out in favour of file galleries)",
// "Settings and features for articles" => "Settings and features for articles",
// "Settings and features for forums" => "Settings and features for forums",
// "Settings and features for trackers" => "Settings and features for trackers",
// "Settings and features for polls" => "Settings and features for polls",
// "Settings and features for calendars" => "Settings and features for calendars",
// "Settings and features for categories" => "Settings and features for categories",
// "Values of actions for users rank score" => "Values of actions for users rank score",
// "Settings and features for freetags" => "Settings and features for freetags",
// "Search configuration" => "Search configuration",
// "Settings and features for FAQs" => "Settings and features for FAQs",
// "Settings and features for directory of links" => "Settings and features for directory of links",
// "Settings and features for maps" => "Settings and features for maps",
// "Defaults and API key for Google Maps" => "Defaults and API key for Google Maps",
// "Site-wide copyright information" => "Site-wide copyright information",
// "Message settings" => "Message settings",
// "User files settings" => "User files settings",
// "Webmail settings" => "Webmail settings",
// "Options for WYSIWYG editor" => "Options for WYSIWYG editor",
// "?" => "?",
// "Set up links between Tiki servers" => "Set up links between Tiki servers",
// "Manage semantic wiki links" => "Manage semantic wiki links",
// "Webservices" => "Webservices",
// "Register and manage web services" => "Register and manage web services",
// "Sef URL" => "Sef URL",
// "Search Engine Friendly URLs" => "Search Engine Friendly URLs",
// "Video" => "Video",
// "Video integration configuration" => "Video integration configuration",
// "Configure social networks integration" => "Configure social networks integration",
// "Sharing on social networks" => "Sharing on social networks",
// "Blogs Listings" => "Blogs Listings",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
// "General settings" => "General settings",
// "Default calendars to display" => "Default calendars to display",
// "All calendars" => "All calendars",
// "A subset of available calendars" => "A subset of available calendars",
// "Create calendar" => "Create calendar",
// "JS calendar" => "JS calendar",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
// "With PHPlayers, watch icons are only visible for the top category" => "With PHPlayers, watch icons are only visible for the top category",
// "Admin topics" => "Admin topics",
// "Admin types" => "Admin types",
// "Article properties" => "Article properties",
// "Give only one value (width or height) to keep the image proportions" => "Give only one value (width or height) to keep the image proportions",
// "File format: title,authorName,heading,body,lang,user" => "File format: title,authorName,heading,body,lang,user",
// "Articles Listing" => "Articles Listing",
// "Select which items to display when listing articles" => "Select which items to display when listing articles",
// "Article View" => "Article View",
// "List comments" => "List comments",
// "Site-wide features" => "Site-wide features",
// "Display options" => "Display options",
// "Inline comments" => "Inline comments",
// "The feature below must be activated for this feature to work" => "The feature below must be activated for this feature to work",
// "Using comments in various features" => "Using comments in various features",
// "User features" => "User features",
// "Default user preferences" => "Default user preferences",
// "User messages" => "User messages",
// "Select which items to display when listing users" => "Select which items to display when listing users",
// "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU",
// "Join the community" => "Join the community",
// "Promote your site" => "Promote your site",
// "To submit your site to Tiki.org" => "To submit your site to Tiki.org",
// "Submit site" => "Submit site",
// "Help Tiki spread" => "Help Tiki spread",
// "Help improve Tiki" => "Help improve Tiki",
// "To submit a feature request or to report a bug" => "To submit a feature request or to report a bug",
// "Click here to go to our development site" => "Click here to go to our development site",
// "Enable copyright management for" => "Enable copyright management for",
// "Global features" => "Global features",
// "Main feature" => "Main feature",
// "Additional" => "Additional",
// "Interface" => "Interface",
// "AJAX" => "AJAX",
// "jQuery plugins and add-ons" => "jQuery plugins and add-ons",
// "Programmer" => "Programmer",
// "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application" => "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application",
// "Getting there.." => "Getting there..",
// "Most of these features are hoped to make it into the \"new\" section for Tiki 6" => "Most of these features are hoped to make it into the \"new\" section for Tiki 6",
// "Fresh out of the oven" => "Fresh out of the oven",
// "Seem ok but.." => "Seem ok but..",
// "These features are not reported to be broken, but they are not actively developed and/or widely used" => "These features are not reported to be broken, but they are not actively developed and/or widely used",
// "Will be phased out" => "Will be phased out",
// "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology" => "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology",
// "To create or remove file galleries, select" => "To create or remove file galleries, select",
// "from the application menu" => "from the application menu",
// "Move files from database to directory" => "Move files from database to directory",
// "Move files from directory to database" => "Move files from directory to database",
// "Manage comment settings" => "Manage comment settings",
// "Score is disabled" => "Score is disabled",
// "A cron job must be set up in order to delete the files" => "A cron job must be set up in order to delete the files",
// "Upload Regex" => "Upload Regex",
// "Gallery Listings" => "Gallery Listings",
// "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries",
// "Select which items to display when listing galleries: " => "Select which items to display when listing galleries: ",
// "Admin Gallery Listings" => "Admin Gallery Listings",
// "Select which items to display when admin galleries: " => "Select which items to display when admin galleries: ",
// "Search Indexing" => "Search Indexing",
// "Automatically index files on upload or change" => "Automatically index files on upload or change",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "Missing Handlers" => "Missing Handlers",
// "System Command" => "System Command",
// "Threads" => "Threads",
// "Forums Listing" => "Forums Listing",
// "Select which items to display when listing forums" => "Select which items to display when listing forums",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
// "Random tag cloud colors" => "Random tag cloud colors",
// "Separate colors with a comma (,)" => "Separate colors with a comma (,)",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all characters" => "Accept all characters",
// "Cleanup unused tags" => "Cleanup unused tags",
// "3D Tag Browser Configuration" => "3D Tag Browser Configuration",
// "Graph appearance" => "Graph appearance",
// "Camera settings" => "Camera settings",
// "Physics engine" => "Physics engine",
// "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below" => "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below",
// "Display image information in a mouseover box" => "Display image information in a mouseover box",
// "yes, and don't display that information under the image" => "yes, and don't display that information under the image",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
// "Pixels Default" => "Pixels Default",
// "Default scale size" => "Default scale size",
// "Release Check" => "Release Check",
// "Check for updates now" => "Check for updates now",
// "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences" => "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences",
// "These values will be stored in plain text in the database" => "These values will be stored in plain text in the database",
// "Email to send a test mail" => "Email to send a test mail",
// "Create and edit menus " => "Create and edit menus ",
// "Redirects" => "Redirects",
// "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details" => "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details",
// "Map mode in listings" => "Map mode in listings",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Assign users to group function of email pattern" => "Assign users to group function of email pattern",
// "You must change the Authentication Method to LDAP for these changes to take effect" => "You must change the Authentication Method to LDAP for these changes to take effect",
// "LDAP Bind settings" => "LDAP Bind settings",
// "LDAP User" => "LDAP User",
// "LDAP Group" => "LDAP Group",
// "LDAP Group Member - if group membership can be found in group attributes" => "LDAP Group Member - if group membership can be found in group attributes",
// "LDAP User Group - if group membership can be found in user attributes" => "LDAP User Group - if group membership can be found in user attributes",
// "LDAP Admin" => "LDAP Admin",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "Shibboleth Authentication " => "Shibboleth Authentication ",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "CAS" => "CAS",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "CAS Server" => "CAS Server",
// "CAS Server Name" => "CAS Server Name",
// "CAS Server Port" => "CAS Server Port",
// "CAS Server Path" => "CAS Server Path",
// "phpBB User Database Authentication " => "phpBB User Database Authentication ",
// "You must change the Authentication Method to phpBB for these changes to take effect" => "You must change the Authentication Method to phpBB for these changes to take effect",
// "You must turn Users can register off for phpBB Authentication to function properly" => "You must turn Users can register off for phpBB Authentication to function properly",
// "MySql only (for now)" => "MySql only (for now)",
// "Web Server Authentication " => "Web Server Authentication ",
// "You must change the Authentication Method to Web Server for these changes to take effect" => "You must change the Authentication Method to Web Server for these changes to take effect",
// "The \"users can change theme\" feature will override the theme displayed" => "The \"users can change theme\" feature will override the theme displayed",
// "Theme not saved yet - click \"Apply\"" => "Theme not saved yet - click \"Apply\"",
// "Theme Screenshot" => "Theme Screenshot",
// "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for <em>all</em> users" => "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for <em>all</em> users",
// "UI Effects" => "UI Effects",
// "Standard UI effects" => "Standard UI effects",
// "Tab UI effects" => "Tab UI effects",
// "Experimental: CSS assistant (work in progress - click the x to remove)" => "Experimental: CSS assistant (work in progress - click the x to remove)",
// "Favicon" => "Favicon",
// "Context Menus" => "Context Menus",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
// "Separators" => "Separators",
// "Meta tags" => "Meta tags",
// "Geo URL" => "Geo URL",
// "Configure metrics" => "Configure metrics",
// "Show past results" => "Show past results",
// "Past results count" => "Past results count",
// "&quot;Modules&quot; are the boxes of content in the right &amp; left columns" => "&quot;Modules&quot; are the boxes of content in the right &amp; left columns",
// "Admin &gt; Modules" => "Admin &gt; Modules",
// "from the menu to create and edit modules" => "from the menu to create and edit modules",
// "Hint: If you lose your login module, use tiki-login_scr.php to be able to login" => "Hint: If you lose your login module, use tiki-login_scr.php to be able to login",
// "Payments" => "Payments",
// "Choose payment system" => "Choose payment system",
// "You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "You can use only one payment method: PayPal or Cclite or Tiki User Credits",
// "PayPal is working at the moment. See PayPal.com" => "PayPal is working at the moment. See PayPal.com",
// "Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite: Community currency accounting for local exchange trading systems (LETS). See ",
// "sourceforge.net" => "sourceforge.net",
// "Tiki User Credits: Requires this other feature to be configured" => "Tiki User Credits: Requires this other feature to be configured",
// "Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite is for creating and managing alternative or complementary trading currencies and groups",
// "Work in progress for Tiki 6" => "Work in progress for Tiki 6",
// "Shipping" => "Shipping",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "Bytecode Cache" => "Bytecode Cache",
// "Using <strong>%0</strong>.These stats affect all PHP applications running on the server" => "Using <strong>%0</strong>.These stats affect all PHP applications running on the server",
// "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache",
// "Available" => "Available",
// "Miss" => "Miss",
// "Cache Hits" => "Cache Hits",
// "Few hits recorded. Statistics may not be representative" => "Few hits recorded. Statistics may not be representative",
// "Low hit ratio. %0 may be misconfigured and not used" => "Low hit ratio. %0 may be misconfigured and not used",
// "Little memory available. Thrashing likely to occur" => "Little memory available. Thrashing likely to occur",
// "Small amount of memory allocated to %0. Verify the configuration" => "Small amount of memory allocated to %0. Verify the configuration",
// "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates" => "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates",
// "<em>%0</em> should not be disabled due to authentication on XCache" => "<em>%0</em> should not be disabled due to authentication on XCache",
// "Bytecode cache is not used. Using a bytecode cache (APC, XCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (APC, XCache) is highly recommended for production environments",
// "Major slow down" => "Major slow down",
// "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>",
// "Sessions" => "Sessions",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Changing this feature will immediately log you out when you save this preference" => "Changing this feature will immediately log you out when you save this preference",
// "Loading profile" => "Loading profile",
// "Are you sure you want to apply the profile" => "Are you sure you want to apply the profile",
// "Are you sure you want to re-apply the profile" => "Are you sure you want to re-apply the profile",
// "Sending" => "Sending",
// "Tiki Profiles" => "Tiki Profiles",
// "Apply Profiles" => "Apply Profiles",
// "A Friendly Warning" => "A Friendly Warning",
// "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles",
// "Option 1: Quick Filter" => "Option 1: Quick Filter",
// "Option 2: Manual Filter" => "Option 2: Manual Filter",
// "Filter the list of profiles" => "Filter the list of profiles",
// "Repository" => "Repository",
// "applied" => "applied",
// "Profile repository" => "Profile repository",
// "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again" => "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again",
// "Repositories" => "Repositories",
// "Repository URLs" => "Repository URLs",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data Channels" => "Data Channels",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. " => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. ",
// "More information" => "More information",
// "Profile tester" => "Profile tester",
// "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below",
// "This will run the profile and make potentially unrecoverable changes in your database" => "This will run the profile and make potentially unrecoverable changes in your database",
// "Test Profile Name" => "Test Profile Name",
// "Global configuration" => "Global configuration",
// "Cache duration" => "Cache duration",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or",
// "External feeds" => "External feeds",
// "Feed for articles" => "Feed for articles",
// "Feed for blogs" => "Feed for blogs",
// "Feed for individual blogs" => "Feed for individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Feed for individual image galleries" => "Feed for individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Feed for maps" => "Feed for maps",
// "Feed for shoutbox" => "Feed for shoutbox",
// "Search type" => "Search type",
// "Specify the Tiki search settings" => "Specify the Tiki search settings",
// "The Tiki search indexes must be refreshed if you turn the Tiki search on" => "The Tiki search indexes must be refreshed if you turn the Tiki search on",
// "Refresh all search index now" => "Refresh all search index now",
// "Enabling these options will improve performance, but may show forbidden results" => "Enabling these options will improve performance, but may show forbidden results",
// "Search Results" => "Search Results",
// "Select the items to display on the search results page" => "Select the items to display on the search results page",
// "Select the information to display for each result" => "Select the information to display for each result",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "General Security" => "General Security",
// "HTTPS (SSL) and other login preferences" => "HTTPS (SSL) and other login preferences",
// "CSRF Security" => "CSRF Security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "Spam protection" => "Spam protection",
// "Captcha" => "Captcha",
// "Tokens" => "Tokens",
// "Clipperz online password management" => "Clipperz online password management",
// "Tiki doesn't offer a built-in password management feature" => "Tiki doesn't offer a built-in password management feature",
// "Learn more about Clipperz" => "Learn more about Clipperz",
// "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file" => "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file",
// "If you need to keep an existing (non Tiki) .htaccess file, just add Tiki directives to it" => "If you need to keep an existing (non Tiki) .htaccess file, just add Tiki directives to it",
// "When you upgrade (ex.: from Tiki4 to Tiki5), make sure to use the new _htaccess file" => "When you upgrade (ex.: from Tiki4 to Tiki5), make sure to use the new _htaccess file",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Known Types" => "Known Types",
// "Token" => "Token",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "New Types" => "New Types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "Activate the feature" => "Activate the feature",
// "Twitter Settings" => "Twitter Settings",
// "To use Twitter integration, you must register this site as an application at" => "To use Twitter integration, you must register this site as an application at",
// "and allow write access for the application" => "and allow write access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL",
// "Facebook Settings" => "Facebook Settings",
// "To use Facebook integration, you must register this site as an application at" => "To use Facebook integration, you must register this site as an application at",
// "and allow extended access for the application" => "and allow extended access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain",
// "bit.ly Settings" => "bit.ly Settings",
// "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics",
// "to sign up for an account" => "to sign up for an account",
// "to retrieve the API key" => "to retrieve the API key",
// "Default size" => "Default size",
// "External links and images" => "External links and images",
// "External links will be identified with" => "External links will be identified with",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Check disabled plugins used in wiki pages" => "Check disabled plugins used in wiki pages",
// "Disabled used plugins" => "Disabled used plugins",
// "Edit plugin icons" => "Edit plugin icons",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
// "About plugin aliases" => "About plugin aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Available Alias" => "Available Alias",
// "Enable Plugins" => "Enable Plugins",
// "Delete Plugins" => "Delete Plugins",
// "Click on the plugin name to edit it" => "Click on the plugin name to edit it",
// "Click on the + icon to add a new one" => "Click on the + icon to add a new one",
// "General Information" => "General Information",
// "Plugin Name" => "Plugin Name",
// "Base Plugin" => "Base Plugin",
// "Body Label" => "Body Label",
// "Dependencies" => "Dependencies",
// "Inline (No Plugin Edit UI)" => "Inline (No Plugin Edit UI)",
// "Simple Plugin Arguments" => "Simple Plugin Arguments",
// "Argument" => "Argument",
// "New Argument" => "New Argument",
// "Plugin Parameter Documentation" => "Plugin Parameter Documentation",
// "Safe" => "Safe",
// "Plugin Body" => "Plugin Body",
// "Ignore User Input" => "Ignore User Input",
// "Default Content" => "Default Content",
// "Encoding" => "Encoding",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Default Value" => "Default Value",
// "Composed Plugin Arguments" => "Composed Plugin Arguments",
// "Pattern" => "Pattern",
// "Tracker attachment preferences" => "Tracker attachment preferences",
// "Tracker attachments" => "Tracker attachments",
// "Switch storage" => "Switch storage",
// "No records" => "No records",
// "Kaltura Registration" => "Kaltura Registration",
// "To get a Kaltura Partner ID" => "To get a Kaltura Partner ID",
// "Setup your own instance of Kaltura Community Edition (CE)" => "Setup your own instance of Kaltura Community Edition (CE)",
// "get an account via Kaltura.com" => "get an account via Kaltura.com",
// "List Media Entries" => "List Media Entries",
// "List Remix Entries" => "List Remix Entries",
// "Add New Media" => "Add New Media",
// "Kaltura / Tiki config" => "Kaltura / Tiki config",
// "Kaltura Partner Settings" => "Kaltura Partner Settings",
// "Kaltura Dynamic Player" => "Kaltura Dynamic Player",
// "Kaltura Contribution Wizard" => "Kaltura Contribution Wizard",
// "Kaltura Remix Editors" => "Kaltura Remix Editors",
// "Ustream Watershed Registration" => "Ustream Watershed Registration",
// "If you don't have a Watershed account, " => "If you don't have a Watershed account, ",
// "you can find out more about it here" => "you can find out more about it here",
// "Configuration within Watershed" => "Configuration within Watershed",
// "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock" => "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock",
// "Watershed Wiki plugins" => "Watershed Wiki plugins",
// "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat" => "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat",
// "Basic tracker settings" => "Basic tracker settings",
// "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"" => "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"",
// "Archive settings" => "Archive settings",
// "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)" => "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)",
// "Archive settings (optional)" => "Archive settings (optional)",
// "Flash Media Encoder" => "Flash Media Encoder",
// "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication" => "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication",
// "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used",
// "Lookup" => "Lookup",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Output" => "Output",
// "Register Template" => "Register Template",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
// "Page display" => "Page display",
// "Page version" => "Page version",
// "Allow override per page" => "Allow override per page",
// "Minor edits do not flag new content for translation and do not send watch notifications (unless \"Watch minor edits\" is enabled)" => "Minor edits do not flag new content for translation and do not send watch notifications (unless \"Watch minor edits\" is enabled)",
// "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled" => "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled",
// "Manage attachments" => "Manage attachments",
// "If you change storage, it is better to move all the files for easy backup.." => "If you change storage, it is better to move all the files for easy backup..",
// "Tag for current wiki" => "Tag for current wiki",
// "Restore wiki to tag" => "Restore wiki to tag",
// "Wiki watch" => "Wiki watch",
// "Staging &amp; Approval" => "Staging &amp; Approval",
// "Freetags are disabled" => "Freetags are disabled",
// "Page Listings" => "Page Listings",
// "Configuration" => "Configuration",
// "Select which items to display when listing pages" => "Select which items to display when listing pages",
// "Mass search and replace" => "Mass search and replace",
// "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>",
// "Page links" => "Page links",
// "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature" => "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature",
// "Related features" => "Related features",
// "Admin keywords" => "Admin keywords",
// "Keywords have been updated" => "Keywords have been updated",
// "Updating keywords has failed. Page probably doesn't exist" => "Updating keywords has failed. Page probably doesn't exist",
// "Edit page keywords" => "Edit page keywords",
// "Current Page Keywords" => "Current Page Keywords",
// "Search by page" => "Search by page",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
// "Manage menu" => "Manage menu",
// "For wiki page, use ((PageName))" => "For wiki page, use ((PageName))",
// "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "Import/export menu" => "Import/export menu",
// "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'",
// "Create/Edit Menu" => "Create/Edit Menu",
// "Icons" => "Icons",
// "Folder Icon" => "Folder Icon",
// "Path and filename of closed folder icon" => "Path and filename of closed folder icon",
// "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder",
// "In the same directory, include an icon for the opened folder" => "In the same directory, include an icon for the opened folder",
// "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>",
// "For example, the default icon is: pics/icons/folder.png" => "For example, the default icon is: pics/icons/folder.png",
// "The name of the \"open folder\" icon is: pics/icons/ofolder.png" => "The name of the \"open folder\" icon is: pics/icons/ofolder.png",
// "Configure icons for menu entries" => "Configure icons for menu entries",
// "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu",
// "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes" => "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes",
// "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tiki.org\">themes</a>" => "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tiki.org\">themes</a>",
// "To use a menu in a tiki format" => "To use a menu in a tiki format",
// "To use menu in a css/suckerfish format" => "To use menu in a css/suckerfish format",
// "To customize the menu's CSS id (#)" => "To customize the menu's CSS id (#)",
// "Admin Metrics" => "Admin Metrics",
// "Admin Metrics Template" => "Admin Metrics Template",
// "Metrics" => "Metrics",
// "Assign Metrics" => "Assign Metrics",
// "Assigned Metrics" => "Assigned Metrics",
// "Edit/Create Metrics" => "Edit/Create Metrics",
// "Edit/Create Tab" => "Edit/Create Tab",
// "Data Type" => "Data Type",
// "Metric Name" => "Metric Name",
// "Tab Name" => "Tab Name",
// "Assign metric" => "Assign metric",
// "Edit this assigned metric" => "Edit this assigned metric",
// "Tab for metric" => "Tab for metric",
// "Create new metric" => "Create new metric",
// "Edit this metric" => "Edit this metric",
// "Hints" => "Hints",
// "For list-based metrics, include the \"LIMIT #\" in your query" => "For list-based metrics, include the \"LIMIT #\" in your query",
// "Name (must be unique)" => "Name (must be unique)",
// "Create new tab" => "Create new tab",
// "Edit this tab" => "Edit this tab",
// "Weight (must be integer)" => "Weight (must be integer)",
// "The following required parameters are missing" => "The following required parameters are missing",
// "Assign/Edit modules" => "Assign/Edit modules",
// "Move Up" => "Move Up",
// "Move Down" => "Move Down",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "The" => "The",
// "Display Modules to All Groups" => "Display Modules to All Groups",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
// "Module Options" => "Module Options",
// "Default Tiki menus" => "Default Tiki menus",
// "CSS menus" => "CSS menus",
// "Use CSS menu" => "Use CSS menu",
// "PHP Layers menus" => "PHP Layers menus",
// "To use a default Tiki menu" => "To use a default Tiki menu",
// "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes" => "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes",
// "To use a <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">PHP Layers menu</a>, use one of these syntaxes (Note: PHP Layers menus are being replaced by CSS menus and may have only basic styling in newer themes.)" => "To use a <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">PHP Layers menu</a>, use one of these syntaxes (Note: PHP Layers menus are being replaced by CSS menus and may have only basic styling in newer themes.)",
// "Unsubscribed" => "Unsubscribed",
// "Including group, group users and emails will be refreshed at each newsletter sending" => "Including group, group users and emails will be refreshed at each newsletter sending",
// "Preload Admin Account" => "Preload Admin Account",
// "User / Group" => "User / Group",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Add Option" => "Add Option",
// "Leave box empty for deleting an option" => "Leave box empty for deleting an option",
// "Votes older than these days are no more considered" => "Votes older than these days are no more considered",
// "0 for no limit" => "0 for no limit",
// "This menu shows only Polls with 'status': \"template\"" => "This menu shows only Polls with 'status': \"template\"",
// "Admin External Feeds" => "Admin External Feeds",
// "Tips" => "Tips",
// "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
// "Article Generator" => "Article Generator",
// "The article generator will create a new article for every item read in the RSS feed" => "The article generator will create a new article for every item read in the RSS feed",
// "Use Article Submission System" => "Use Article Submission System",
// "Publish in the future" => "Publish in the future",
// "-1 to use original publishing date from the feed" => "-1 to use original publishing date from the feed",
// "Configure" => "Configure",
// "Edit this feed" => "Edit this feed",
// "Create new external feed" => "Create new external feed",
// "Show Date" => "Show Date",
// "View feed" => "View feed",
// "PHP functions" => "PHP functions",
// "Function" => "Function",
// "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini" => "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini",
// "Tiki settings" => "Tiki settings",
// "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors",
// "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
// "Security checks" => "Security checks",
// "Check file permissions" => "Check file permissions",
// "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments" => "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments",
// "See end of table for detailed explanations" => "See end of table for detailed explanations",
// "owner" => "owner",
// "special" => "special",
// "other" => "other",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
// "XML Zip Import" => "XML Zip Import",
// "View structure" => "View structure",
// "Delete with the pages" => "Delete with the pages",
// "Create New structure" => "Create New structure",
// "Add a New Question" => "Add a New Question",
// "This survey stats" => "This survey stats",
// "Edit Survey Question" => "Edit Survey Question",
// "Add a New Question to this survey" => "Add a New Question to this survey",
// "Multiple choices of thumbnails from a file gallery" => "Multiple choices of thumbnails from a file gallery",
// "Wiki textarea" => "Wiki textarea",
// "Answer is mandatory" => "Answer is mandatory",
// "Number of required answers (for multiple choices)" => "Number of required answers (for multiple choices)",
// "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4",
// "For the 'wiki textarea' type, options are: rows,columns. Example: 10,60" => "For the 'wiki textarea' type, options are: rows,columns. Example: 10,60",
// "Create Survey" => "Create Survey",
// "Create/Edit Surveys" => "Create/Edit Surveys",
// "Tiki Cache/System Admin" => "Tiki Cache/System Admin",
// "Directory to exterminate" => "Directory to exterminate",
// "Directories to save" => "Directories to save",
// "Full Path to the Zip File" => "Full Path to the Zip File",
// "Generate a zip of those directories" => "Generate a zip of those directories",
// "A zip has been written to {\$zipPath}" => "A zip has been written to {\$zipPath}",
// "Directory is not writeable" => "Directory is not writeable",
// "View mode" => "View mode",
// "Wiki and WYSIWYG" => "Wiki and WYSIWYG",
// "Wiki only" => "Wiki only",
// "WYSIWYG only" => "WYSIWYG only",
// "Load" => "Load",
// "Reset to Global" => "Reset to Global",
// "Reset to defaults" => "Reset to defaults",
// "Auto Reloading" => "Auto Reloading",
// "Row" => "Row",
// "Formatting Tools" => "Formatting Tools",
// "Plugin Tools" => "Plugin Tools",
// "Edit tool" => "Edit tool",
// "Wysiwyg Token" => "Wysiwyg Token",
// "Plugin name" => "Plugin name",
// "Custom Tools" => "Custom Tools",
// "Add a new custom tool" => "Add a new custom tool",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
// "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools" => "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools",
// "Delete all custom tools" => "Delete all custom tools",
// "Warning: There is no undo" => "Warning: There is no undo",
// "Position of field in list" => "Position of field in list",
// "Is mandatory/required" => "Is mandatory/required",
// "Req" => "Req",
// "Main" => "Main",
// "Multi-lingual" => "Multi-lingual",
// "Is column searchable" => "Is column searchable",
// "Descr" => "Descr",
// "Validation parameter" => "Validation parameter",
// "Validation error message" => "Validation error message",
// "Important note" => "Important note",
// "The first field in the tracker to have column links to edit/view item (i.e. isMain) will be what is shown as the name of the item in category and search listings" => "The first field in the tracker to have column links to edit/view item (i.e. isMain) will be what is shown as the name of the item in category and search listings",
// "Visible by" => "Visible by",
// "Editable by" => "Editable by",
// "Description text is wiki-parsed" => "Description text is wiki-parsed",
// "Error message" => "Error message",
// "Check the box to re-import in this tracker and change the fields" => "Check the box to re-import in this tracker and change the fields",
// "Uncheck the box to import in another database" => "Uncheck the box to import in another database",
// "Create Tracker" => "Create Tracker",
// "Create/Edit Tracker" => "Create/Edit Tracker",
// "Create a group for each item" => "Create a group for each item",
// "Groups will include" => "Groups will include",
// "Creator is assigned to the group" => "Creator is assigned to the group",
// "and it becomes his default group" => "and it becomes his default group",
// "and it becomes the new item group creator" => "and it becomes the new item group creator",
// "But copy the default group in this fiedlId before updating the group" => "But copy the default group in this fiedlId before updating the group",
// "User can take ownership of item created by anonymous" => "User can take ownership of item created by anonymous",
// "Member of the creator group can modify items" => "Member of the creator group can modify items",
// "Identify creation user in tracker item" => "Identify creation user in tracker item",
// "Identify lastModif user in tracker item" => "Identify lastModif user in tracker item",
// "and display last comment user/date" => "and display last comment user/date",
// "Group of users alerted when tracker is modified" => "Group of users alerted when tracker is modified",
// "Wiki page to display an item" => "Wiki page to display an item",
// "wiki:pageName for a wiki page or tpl:tplName for a template" => "wiki:pageName for a wiki page or tpl:tplName for a template",
// "Status changes list" => "Status changes list",
// "Delay" => "Delay",
// "Notification" => "Notification",
// "Delete todo" => "Delete todo",
// "Status changes" => "Status changes",
// "After creation" => "After creation",
// "After last modification" => "After last modification",
// "Warn creator of an upcoming status change" => "Warn creator of an upcoming status change",
// "before" => "before",
// "Mail subject text" => "Mail subject text",
// "Mail body ressource" => "Mail body ressource",
// "wiki:pageName for a wiki page or tplName.tpl for a template" => "wiki:pageName for a wiki page or tplName.tpl for a template",
// "Date Format" => "Date Format",
// "timestamp" => "timestamp",
// "Add as new items" => "Add as new items",
// "The order of the fields does not matter, but you need to add a header with the field names" => "The order of the fields does not matter, but you need to add a header with the field names",
// "Add \" -- \" to the end of the fields in the header that you would like to import" => "Add \" -- \" to the end of the fields in the header that you would like to import",
// "Auto-incremented itemid fields shall be included with no matter what values" => "Auto-incremented itemid fields shall be included with no matter what values",
// "Subset Selection" => "Subset Selection",
// "Category Selection" => "Category Selection",
// "Group Selection" => "Group Selection",
// "Type in a group name and click \"enter\"" => "Type in a group name and click \"enter\"",
// "Once you have selected at least two, click" => "Once you have selected at least two, click",
// "and then, click the \"New/Edit\" tab which will appear above" => "and then, click the \"New/Edit\" tab which will appear above",
// "Draw Transition Diagram" => "Draw Transition Diagram",
// "Guards" => "Guards",
// "preserved" => "preserved",
// "Assign permissions for transition" => "Assign permissions for transition",
// "No transitions" => "No transitions",
// "New / Edit" => "New / Edit",
// "Edit <em>%0</em>" => "Edit <em>%0</em>",
// "New transition" => "New transition",
// "Upon trigger, preserve the initial state" => "Upon trigger, preserve the initial state",
// "Count" => "Count",
// "No guards on this transition" => "No guards on this transition",
// "New Guard" => "New Guard",
// "Exactly" => "Exactly",
// "At Least" => "At Least",
// "At Most" => "At Most",
// "States" => "States",
// "Manage permissions" => "Manage permissions",
// "Invitation List" => "Invitation List",
// "Inherits Permissions from" => "Inherits Permissions from",
// "Inherit permissions directly from following groups" => "Inherit permissions directly from following groups",
// "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)" => "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)",
// "Group Homepage or Url" => "Group Homepage or Url",
// "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)" => "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)",
// "Users are automatically unassigned from the group after" => "Users are automatically unassigned from the group after",
// "0 or empty for never" => "0 or empty for never",
// "Users are automatically assigned at registration in the group if their emails match the pattern" => "Users are automatically assigned at registration in the group if their emails match the pattern",
// "Example: " => "Example: ",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
// "Create Item" => "Create Item",
// "Choose a field .." => "Choose a field ..",
// "Expire" => "Expire",
// "Add to group" => "Add to group",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
// "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login",
// "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login",
// "OpenID" => "OpenID",
// "N" => "N",
// "ago" => "ago",
// "Need to validate email" => "Need to validate email",
// "Assign to group" => "Assign to group",
// "Edit Group" => "Edit Group",
// "Validate user" => "Validate user",
// "Confirm user email" => "Confirm user email",
// "Send a wiki page by Email" => "Send a wiki page by Email",
// "Template wiki page" => "Template wiki page",
// "Assign user to Groups" => "Assign user to Groups",
// "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)" => "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "Tikiwiki is configured to delegate the password managment to LDAP" => "Tikiwiki is configured to delegate the password managment to LDAP",
// "Repeat Password" => "Repeat Password",
// "User must change password at next login" => "User must change password at next login",
// "Send an email to the user in order to allow him to validate his account" => "Send an email to the user in order to allow him to validate his account",
// "Last Login" => "Last Login",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "CSV file layout" => "CSV file layout",
// "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\"group1,group2\",group1" => "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\"group1,group2\",group1",
// "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
// "Overwrite but keep the previous login if the login exists in another case" => "Overwrite but keep the previous login if the login exists in another case",
// "Don't overwrite" => "Don't overwrite",
// "Overwrite groups" => "Overwrite groups",
// "Create groups" => "Create groups",
// "User must change password at first login" => "User must change password at first login",
// "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
// "Page has been approved" => "Page has been approved",
// "New attachments" => "New attachments",
// "Old attachments" => "Old attachments",
// "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems" => "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems",
// "Click this button to try it now" => "Click this button to try it now",
// "Global object permissions" => "Global object permissions",
// "Level configuration" => "Level configuration",
// "Assign User {\$assign_user|escape} to Groups" => "Assign User {\$assign_user|escape} to Groups",
// "Assign User to Group" => "Assign User to Group",
// "Remove File Extension from Image Name" => "Remove File Extension from Image Name",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Please do not use this feature to upload data into the database" => "Please do not use this feature to upload data into the database",
// "Available Files" => "Available Files",
// "Select a File Gallery" => "Select a File Gallery",
// "Process files" => "Process files",
// "New Post" => "New Post",
// "View post" => "View post",
// "Excerpt" => "Excerpt",
// "Tiki Wiki CMS Groupware" => "Tiki Wiki CMS Groupware",
// "Admin Category" => "Admin Category",
// "Admin the Category System" => "Admin the Category System",
// "No result found" => "No result found",
// "result found" => "result found",
// "You can view this gallery's configured image (first, random, etc.) in your browser using" => "You can view this gallery's configured image (first, random, etc.) in your browser using",
// "You can include the gallery's image in an HTML page using" => "You can include the gallery's image in an HTML page using",
// "You can include the image in a tiki page using" => "You can include the image in a tiki page using",
// "Include the image in a tiki page using the following syntax" => "Include the image in a tiki page using the following syntax",
// "To include the image in an HTML page" => "To include the image in an HTML page",
// "To link to this page from another tiki page" => "To link to this page from another tiki page",
// "Export Calendars" => "Export Calendars",
// "Click to export calendars" => "Click to export calendars",
// "Export calendars" => "Export calendars",
// "advanced parameters" => "advanced parameters",
// "Export as iCal" => "Export as iCal",
// "Export as CSV" => "Export as CSV",
// "Export event" => "Export event",
// "Delete event" => "Delete event",
// "Classification" => "Classification",
// "View this Week" => "View this Week",
// "View this Day" => "View this Day",
// "o" => "o",
// "Edit/Delete event" => "Edit/Delete event",
// "Recurrence" => "Recurrence",
// "This event depends on a recurrence rule" => "This event depends on a recurrence rule",
// "This event is not recurrent" => "This event is not recurrent",
// "On a weekly basis" => "On a weekly basis",
// "Each" => "Each",
// "of the week" => "of the week",
// "On a monthly basis" => "On a monthly basis",
// "of the month" => "of the month",
// "On a yearly basis" => "On a yearly basis",
// "Starting on" => "Starting on",
// "ending by" => "ending by",
// "ending after" => "ending after",
// "events" => "events",
// "Start period" => "Start period",
// "End after" => "End after",
// "occurrences" => "occurrences",
// "End before" => "End before",
// "Event is repeated" => "Event is repeated",
// "every" => "every",
// "of every month" => "of every month",
// "on each" => "on each",
// "Events cannot end before they start" => "Events cannot end before they start",
// "No description" => "No description",
// "Choose users to alert" => "Choose users to alert",
// "Withdraw me from the list of participants" => "Withdraw me from the list of participants",
// "Add me to the list of participants" => "Add me to the list of participants",
// "Format" => "Format",
// "Participant names separated by comma" => "Participant names separated by comma",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
// "Update this event only" => "Update this event only",
// "Update every unchanged events of this recurrence rule" => "Update every unchanged events of this recurrence rule",
// "Update every events of this recurrence rule" => "Update every events of this recurrence rule",
// "Delete Recurrent events" => "Delete Recurrent events",
// "Column names on the first line" => "Column names on the first line",
// "%0 column name can be used instead of %1" => "%0 column name can be used instead of %1",
// "See" => "See",
// "%d/%m" => "%d/%m",
// "Advanced parameters for iCal export" => "Advanced parameters for iCal export",
// "Calendars to be exported" => "Calendars to be exported",
// "Export calendars iCal" => "Export calendars iCal",
// "Export calendars CSV" => "Export calendars CSV",
// "Quick Create Multilanguage Pages" => "Quick Create Multilanguage Pages",
// "Following pages were created, as translations of each other" => "Following pages were created, as translations of each other",
// "Following pages were not created" => "Following pages were not created",
// "Enter the names of a new page page in various languages" => "Enter the names of a new page page in various languages",
// "Preferred languages" => "Preferred languages",
// "Other languages" => "Other languages",
// "Create pages" => "Create pages",
// "View generated WebHelp" => "View generated WebHelp",
// "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>",
// "The following site was added, but may require validation by the admin before appearing on the lists" => "The following site was added, but may require validation by the admin before appearing on the lists",
// "Edit a site" => "Edit a site",
// "Directory Categories" => "Directory Categories",
// "Parent directory category" => "Parent directory category",
// "Add a Directory Category" => "Add a Directory Category",
// "Most visited directory sub-categories" => "Most visited directory sub-categories",
// "Directory Category description" => "Directory Category description",
// "Random directory sub-categories" => "Random directory sub-categories",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
// "Directory Subcategories" => "Directory Subcategories",
// "Admin related directory categories" => "Admin related directory categories",
// "Add a related directory category" => "Add a related directory category",
// "Directory Category" => "Directory Category",
// "Related directory categories" => "Related directory categories",
// "Perform action with selected" => "Perform action with selected",
// "in current directory category" => "in current directory category",
// "Hits (desc)" => "Hits (desc)",
// "Hits (asc)" => "Hits (asc)",
// "Last updated (desc)" => "Last updated (desc)",
// "Last updated (asc)" => "Last updated (asc)",
// "Total directory categories" => "Total directory categories",
// "Discounts" => "Discounts",
// "Max time the discount can be used in the first phase of payment" => "Max time the discount can be used in the first phase of payment",
// "-1 for illimited" => "-1 for illimited",
// "Translation of this page is incomplete" => "Translation of this page is incomplete",
// "To add <strong>new content</strong> to the page" => "To add <strong>new content</strong> to the page",
// "use the editor" => "use the editor",
// "If not the topic image" => "If not the topic image",
// "If different than the uploaded image" => "If different than the uploaded image",
// "List mode" => "List mode",
// "If different than in view mode" => "If different than in view mode",
// "If not the topic name" => "If not the topic name",
// "Allow full HTML" => "Allow full HTML",
// "for this edit session" => "for this edit session",
// "Emails to be notified (separated with commas)" => "Emails to be notified (separated with commas)",
// "-1 for unlimited" => "-1 for unlimited",
// "Max impressions for a user" => "Max impressions for a user",
// "Max clicks" => "Max clicks",
// "Or, create a new zone" => "Or, create a new zone",
// "ex" => "ex",
// "Allow other users to post in this blog" => "Allow other users to post in this blog",
// "If others post to blog, Author should always be Owner" => "If others post to blog, Author should always be Owner",
// "Display Options" => "Display Options",
// "Number of posts to show per page" => "Number of posts to show per page",
// "Display blog title in posts list page" => "Display blog title in posts list page",
// "Display blog title in post page" => "Display blog title in post page",
// "Display blog description" => "Display blog description",
// "Display breadcrumbs" => "Display breadcrumbs",
// "Display author in blog posts" => "Display author in blog posts",
// "Display published date in blog posts" => "Display published date in blog posts",
// "Show post related content" => "Show post related content",
// "The checkbox is disabled because feature_freetags is disabled globally" => "The checkbox is disabled because feature_freetags is disabled globally",
// "Maximum number of related posts to display" => "Maximum number of related posts to display",
// "Use post excerpt" => "Use post excerpt",
// "Heading preview" => "Heading preview",
// "Blog post heading" => "Blog post heading",
// "The file will be saved in" => "The file will be saved in",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "The syntax system used for creating pages in Tiki" => "The syntax system used for creating pages in Tiki",
// "2 dashes" => "2 dashes",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename" => "Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename",
// "Monospace font" => "Monospace font",
// "Code sample" => "Code sample",
// "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew" => "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew",
// "More help here" => "More help here",
// "Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki plugins extend the function of wiki syntax with more specialized commands",
// "Activate/deactivate plugins" => "Activate/deactivate plugins",
// "Spreadsheet Help" => "Spreadsheet Help",
// "jQuery.sheet spreadsheets" => "jQuery.sheet spreadsheets",
// "What is jQuery.sheet" => "What is jQuery.sheet",
// "jQuery.sheet gives you all sorts of possibilities when it comes to giving your web application a spreadsheet style interface with MS Excel style calculations" => "jQuery.sheet gives you all sorts of possibilities when it comes to giving your web application a spreadsheet style interface with MS Excel style calculations",
// "jQuery.sheet manages the sheet creation, viewing, and editing processes.  It can even be used like a datagrid, without calculations.\nFor a complete list of all the MS Excel style functions that jQuery.sheet supports, see below" => "jQuery.sheet manages the sheet creation, viewing, and editing processes.  It can even be used like a datagrid, without calculations.\nFor a complete list of all the MS Excel style functions that jQuery.sheet supports, see below",
// "Wysiwyg Editor" => "Wysiwyg Editor",
// "More help on wysiwyg editing" => "More help on wysiwyg editing",
// "The WYSIWYG editor in Tiki 6+ is\n\t<a href=\"http://ckeditor.com\">CKEditor</a>,\n\tthe new version of FCKEditor (used in Tiki since version 2.0)" => "The WYSIWYG editor in Tiki 6+ is\n\t<a href=\"http://ckeditor.com\">CKEditor</a>,\n\tthe new version of FCKEditor (used in Tiki since version 2.0)",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar",
// "<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent" => "<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent",
// "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin",
// "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred" => "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred",
// "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 6.0) drag and drop of plugins in WYSIWYG does not work" => "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 6.0) drag and drop of plugins in WYSIWYG does not work",
// "<strong>Admins:</strong><br />\n\t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>.\n\t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br />\n\t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>.\n\t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
// "Edit or export/import languages" => "Edit or export/import languages",
// "No translations in the database. First import a language, translate strings using interactive translation or enable \"Record untranslated strings\" in Admin -> i18n" => "No translations in the database. First import a language, translate strings using interactive translation or enable \"Record untranslated strings\" in Admin -> i18n",
// "Export languages" => "Export languages",
// "If you click \"Download database translations\", you will download a file with all the translations in the database" => "If you click \"Download database translations\", you will download a file with all the translations in the database",
// "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database" => "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database",
// "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory" => "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory",
// "Download database translations" => "Download database translations",
// "Write to language.php" => "Write to language.php",
// "Import languages" => "Import languages",
// "Select the language to import" => "Select the language to import",
// "Beware that when importing a language, all translations in the database for that language are deleted" => "Beware that when importing a language, all translations in the database for that language are deleted",
// "Return to default perspective" => "Return to default perspective",
// "Switch to" => "Switch to",
// "Configurations" => "Configurations",
// "Hint" => "Hint",
// "Search for configurations below and drag them in to the configuration section above" => "Search for configurations below and drag them in to the configuration section above",
// "Edit quiz results" => "Edit quiz results",
// "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering" => "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering",
// "This would cause you problems (e.g. menus can stop collapsing/expanding)" => "This would cause you problems (e.g. menus can stop collapsing/expanding)",
// "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)" => "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)",
// "Maybe You just want to modify the top of your Tiki site" => "Maybe You just want to modify the top of your Tiki site",
// "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface" => "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface",
// "View Article" => "View Article",
// "Translate updates made on this page or one of its translations" => "Translate updates made on this page or one of its translations",
// "Translate this page to a new language" => "Translate this page to a new language",
// "Attach or detach existing translations of this page" => "Attach or detach existing translations of this page",
// "Select language to translate to" => "Select language to translate to",
// "Unspecified" => "Unspecified",
// "Enter the page title" => "Enter the page title",
// "Below, assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Below, assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)",
// "\"The page already exists. It was selected in the list below.\"" => "\"The page already exists. It was selected in the list below.\"",
// "Attach or detach existing translations of this article" => "Attach or detach existing translations of this article",
// "Mark existing article as a translation of this one" => "Mark existing article as a translation of this one",
// "Update '{\$page|escape}'" => "Update '{\$page|escape}'",
// "This is a new staging page that has not been approved before" => "This is a new staging page that has not been approved before",
// "An edit summary is mandatory" => "An edit summary is mandatory",
// "Translate from" => "Translate from",
// "Changes that need to be translated are highlighted below" => "Changes that need to be translated are highlighted below",
// "Select the style used to display differences to be translated" => "Select the style used to display differences to be translated",
// "html" => "html",
// "text full" => "text full",
// "Invalid page name" => "Invalid page name",
// "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>",
// "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>",
// "Translate to" => "Translate to",
// "Reproduce the changes highlighted on the left using the editor below" => "Reproduce the changes highlighted on the left using the editor below",
// "Edit comment: Enter some text to describe the changes you are currently making" => "Edit comment: Enter some text to describe the changes you are currently making",
// "Categorization has been preset for this edit" => "Categorization has been preset for this edit",
// "Allow comments on this page" => "Allow comments on this page",
// "Authors' style" => "Authors' style",
// "Admin wiki preferences" => "Admin wiki preferences",
// "Export to file" => "Export to file",
// "Export Tracker Items" => "Export Tracker Items",
// "Delimitors" => "Delimitors",
// "Carriage Return inside Field Value" => "Carriage Return inside Field Value",
// "Parse as Wiki Text" => "Parse as Wiki Text",
// "itemId" => "itemId",
// "These fields" => "These fields",
// "Number of records" => "Number of records",
// "Zip export with attachments" => "Zip export with attachments",
// "Zip Export" => "Zip Export",
// "Dump All Tracker Items" => "Dump All Tracker Items",
// "Edit FAQ question" => "Edit FAQ question",
// "Add FAQ question" => "Add FAQ question",
// "Be careful to set the right permissions on the files you link to" => "Be careful to set the right permissions on the files you link to",
// "Get Forum List" => "Get Forum List",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "Proceed" => "Proceed",
// "Message queue for forum" => "Message queue for forum",
// "Back to forum" => "Back to forum",
// "Reported messages for forum" => "Reported messages for forum",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Cancel friendship request" => "Cancel friendship request",
// "enter address" => "enter address",
// "Find address" => "Find address",
// "Reset view to default" => "Reset view to default",
// "Center map to saved point" => "Center map to saved point",
// "Reset view to site default" => "Reset view to site default",
// "Clone" => "Clone",
// "Toggle Full Screen" => "Toggle Full Screen",
// "Date Selection" => "Date Selection",
// "Edit Date" => "Edit Date",
// "View Spreadsheet" => "View Spreadsheet",
// "Clone Spreadsheet" => "Clone Spreadsheet",
// "Roll Back Spreadsheet" => "Roll Back Spreadsheet",
// "Roll-Back" => "Roll-Back",
// "Ical import / Export" => "Ical import / Export",
// "Select The calendar to export" => "Select The calendar to export",
// "Calendar Import" => "Calendar Import",
// "ICal File" => "ICal File",
// "Name of the zip file on the server" => "Name of the zip file on the server",
// "If you are NOT running a new Tiki installation, make a backup of your database before using this importer" => "If you are NOT running a new Tiki installation, make a backup of your database before using this importer",
// "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode",
// "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)" => "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)",
// "Select the software to import from" => "Select the software to import from",
// "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button",
// "Congratulations! You have successful imported your data to Tikiwiki" => "Congratulations! You have successful imported your data to Tikiwiki",
// "pages imported from a total of" => "pages imported from a total of",
// "You can see the list of wiki pages in your site" => "You can see the list of wiki pages in your site",
// "Importer log" => "Importer log",
// "Character Set Conversion" => "Character Set Conversion",
// "To do so enter the name of the main admin account in the field below" => "To do so enter the name of the main admin account in the field below",
// "Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "Check this box if you have a lot of disabled accounts after an upgrade to tiki4",
// "List of accounts that will be enabled" => "List of accounts that will be enabled",
// "Invitation" => "Invitation",
// "Invitations list" => "Invitations list",
// "The mail has been sent to: " => "The mail has been sent to: ",
// "You are about to send an invitation to theses people, please confirm" => "You are about to send an invitation to theses people, please confirm",
// "Ok" => "Ok",
// "Fill this box with the list of e-mails you want to invite " => "Fill this box with the list of e-mails you want to invite ",
// "Format of the list above " => "Format of the list above ",
// "CSV Style: One line per invitation, with the format: lastname,firstname,email" => "CSV Style: One line per invitation, with the format: lastname,firstname,email",
// "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)",
// "Type here the e-mail subject you'll want to be sent to them " => "Type here the e-mail subject you'll want to be sent to them ",
// "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) ",
// "Type here the content that the user will see when he'll click on the link from the mail " => "Type here the content that the user will see when he'll click on the link from the mail ",
// "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special " => "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special ",
// "Upload to Kaltura" => "Upload to Kaltura",
// "Upload Successful" => "Upload Successful",
// "You have successfully added {\$count} new entry/entries" => "You have successfully added {\$count} new entry/entries",
// "Add more media" => "Add more media",
// "Change Details" => "Change Details",
// "Remix" => "Remix",
// "Kaltura Video" => "Kaltura Video",
// "Media Entries" => "Media Entries",
// "Advanced Editor" => "Advanced Editor",
// "Simple Editor" => "Simple Editor",
// "Video Title" => "Video Title",
// "Embed code" => "Embed code",
// "Views" => "Views",
// "Plays" => "Plays",
// "No action specified" => "No action specified",
// "Last 2 days" => "Last 2 days",
// "Last 3 days" => "Last 3 days",
// "Last 5 days" => "Last 5 days",
// "Last week" => "Last week",
// "Last 2 weeks" => "Last 2 weeks",
// "Last month" => "Last month",
// "IsPublished" => "IsPublished",
// "Select Duplicates" => "Select Duplicates",
// "List all comments" => "List all comments",
// "More info" => "More info",
// "Ban" => "Ban",
// "Delete & Ban" => "Delete & Ban",
// "Create/Edit content block" => "Create/Edit content block",
// "Admin View" => "Admin View",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "Inviter" => "Inviter",
// "Only successful invitations" => "Only successful invitations",
// "Only pending invitations" => "Only pending invitations",
// "Number of invitations" => "Number of invitations",
// "Kaltura Remix Entries" => "Kaltura Remix Entries",
// "Kaltura Media Entries" => "Kaltura Media Entries",
// "Loads" => "Loads",
// "List Remixes" => "List Remixes",
// "Browse Media Entries" => "Browse Media Entries",
// "Browse Remixes" => "Browse Remixes",
// "Create Remix" => "Create Remix",
// "Please select some media entries to use" => "Please select some media entries to use",
// "Remix Video" => "Remix Video",
// "Additional Info" => "Additional Info",
// "Media Id" => "Media Id",
// "Wiki plugin code" => "Wiki plugin code",
// "No mix entries found" => "No mix entries found",
// "to create a new mix" => "to create a new mix",
// "Mix Entries" => "Mix Entries",
// "Playlist Type" => "Playlist Type",
// "No playlists found. " => "No playlists found. ",
// "Click here " => "Click here ",
// "to create a playlist" => "to create a playlist",
// "Object Permissions List" => "Object Permissions List",
// "Manage Permissions" => "Manage Permissions",
// "\$type" => "\$type",
// "global permissions" => "global permissions",
// "object permissions" => "object permissions",
// "category permissions" => "category permissions",
// "If an object is not listed in the section below, then only the global perms are on" => "If an object is not listed in the section below, then only the global perms are on",
// "If an object is not listed in this section, then only the global perms are on" => "If an object is not listed in this section, then only the global perms are on",
// "{\$special.reason|escape}: {\$special.objectName}" => "{\$special.reason|escape}: {\$special.objectName}",
// "Blog: %0" => "Blog: %0",
// "New Blog Post" => "New Blog Post",
// "Post Title" => "Post Title",
// "List Wiki Pages" => "List Wiki Pages",
// "Page aliases found" => "Page aliases found",
// "Xml Zip" => "Xml Zip",
// "You do not have any mailin accounts set up" => "You do not have any mailin accounts set up",
// "Click here to go to mailin admin" => "Click here to go to mailin admin",
// "Tiki Mods" => "Tiki Mods",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more",
// "Assign global permissions" => "Assign global permissions",
// "Currently editing Global permissions" => "Currently editing Global permissions",
// "This object's direct permissions override any global permissions or category permissions affecting this object" => "This object's direct permissions override any global permissions or category permissions affecting this object",
// "This category's direct permissions override any global permissions affecting objects in it" => "This category's direct permissions override any global permissions affecting objects in it",
// "To edit global permissions" => "To edit global permissions",
// "No permissions yet applied to this object but category permissions affect this object and are displayed below" => "No permissions yet applied to this object but category permissions affect this object and are displayed below",
// "To edit category permissions" => "To edit category permissions",
// "No direct permissions yet applied to this object. Global permissions apply" => "No direct permissions yet applied to this object. Global permissions apply",
// "Currently inherited permissions displayed" => "Currently inherited permissions displayed",
// "Assign permissions to this category" => "Assign permissions to this category",
// "Delete category permissions" => "Delete category permissions",
// "Delete object permissions" => "Delete object permissions",
// "Reset Perms" => "Reset Perms",
// "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions",
// "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions",
// "Permissions Clipboard" => "Permissions Clipboard",
// "Copy the permissions set here" => "Copy the permissions set here",
// "Paste copied permissions from " => "Paste copied permissions from ",
// "Assign or remove permissions on <em>all</em> child categories" => "Assign or remove permissions on <em>all</em> child categories",
// "Are you sure you want to effect all child categories?\\nThere is no undo" => "Are you sure you want to effect all child categories?\\nThere is no undo",
// "Assign or remove permissions on all pages of the sub-structure" => "Assign or remove permissions on all pages of the sub-structure",
// "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo" => "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo",
// "You must select at least one feature" => "You must select at least one feature",
// "Previous version of assign permissions page can still be found" => "Previous version of assign permissions page can still be found",
// "View Differences" => "View Differences",
// "Permissions added" => "Permissions added",
// "Permissions removed" => "Permissions removed",
// "Select groups" => "Select groups",
// "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for",
// "These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab" => "These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab",
// "Select only groups that have a perm with the object" => "Select only groups that have a perm with the object",
// "Select all" => "Select all",
// "Select features" => "Select features",
// "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for",
// "Show permissions for disabled features" => "Show permissions for disabled features",
// "Feature name" => "Feature name",
// "Quick Permissions" => "Quick Permissions",
// "Assign Quick-Permissions to this object" => "Assign Quick-Permissions to this object",
// "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)" => "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)",
// "<em>Quick permissions</em> should be considered as an experimental feature" => "<em>Quick permissions</em> should be considered as an experimental feature",
// "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably" => "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably",
// "There is also no undo - <strong>Use with care!</strong>" => "There is also no undo - <strong>Use with care!</strong>",
// "Contributions by author" => "Contributions by author",
// "Contributions to" => "Contributions to",
// "current version" => "current version",
// "Words" => "Words",
// "Whitespaces" => "Whitespaces",
// "Characters" => "Characters",
// "Printable characters" => "Printable characters",
// "Deleted" => "Deleted",
// "Page changes" => "Page changes",
// "Original wiki text" => "Original wiki text",
// "Parsed Text (HTML)" => "Parsed Text (HTML)",
// "Output text only (No HTML tags)" => "Output text only (No HTML tags)",
// "Show statistics" => "Show statistics",
// "Visualize page changes" => "Visualize page changes",
// "Show popups" => "Show popups",
// "Escape HTML / Wiki syntax in page changes" => "Escape HTML / Wiki syntax in page changes",
// "Show contributions" => "Show contributions",
// "Show Edit Sessions" => "Show Edit Sessions",
// "Show All Versions" => "Show All Versions",
// "Enable pagination" => "Enable pagination",
// "per page" => "per page",
// "Payment Date" => "Payment Date",
// "Payment Type" => "Payment Type",
// "Payer" => "Payer",
// "View payment info" => "View payment info",
// "Invoice" => "Invoice",
// "Assign permissions for payments" => "Assign permissions for payments",
// "Cancel this payment request" => "Cancel this payment request",
// "Request Date" => "Request Date",
// "View payment request" => "View payment request",
// "Paypal" => "Paypal",
// "Transaction ID" => "Transaction ID",
// "Payment made by <em>%0, %1</em> (%2)" => "Payment made by <em>%0, %1</em> (%2)",
// "{\$wp_member_title}" => "{\$wp_member_title}",
// "Paid amount" => "Paid amount",
// "Initial amount" => "Initial amount",
// "Amount remaining" => "Amount remaining",
// "Payment request was sent on %0 and is due by %1" => "Payment request was sent on %0 and is due by %1",
// "Pay with Paypal" => "Pay with Paypal",
// "Refresh page" => "Refresh page",
// "Payment info" => "Payment info",
// "Trade with Cclite" => "Trade with Cclite",
// "Payment problem" => "Payment problem",
// "Pay with Tiki User Credits" => "Pay with Tiki User Credits",
// "Credit type" => "Credit type",
// "Credits left" => "Credits left",
// "Amount to pay" => "Amount to pay",
// "Pay using" => "Pay using",
// "Manual payment entry" => "Manual payment entry",
// "Enter payment" => "Enter payment",
// "using" => "using",
// "Payment information" => "Payment information",
// "Outstanding" => "Outstanding",
// "Overdue" => "Overdue",
// "Past" => "Past",
// "Request" => "Request",
// "Detail" => "Detail",
// "Payable within" => "Payable within",
// "File (only .gif, .jpg and .png images)" => "File (only .gif, .jpg and .png images)",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "When you upgrade from an old version, you may need to reparse all the pages" => "When you upgrade from an old version, you may need to reparse all the pages",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
// "Popup preview" => "Popup preview",
// "Close preview" => "Close preview",
// "You do not have permission to read complete articles" => "You do not have permission to read complete articles",
// "Available Pages" => "Available Pages",
// "All pages selected" => "All pages selected",
// "No pages selected" => "No pages selected",
// "Rank" => "Rank",
// "This Article is currently not published and only visible by Editors" => "This Article is currently not published and only visible by Editors",
// "List all articles of this same topic" => "List all articles of this same topic",
// "Prefix the checked" => "Prefix the checked",
// "Postfix the checked" => "Postfix the checked",
// "Register this site at Tiki.org" => "Register this site at Tiki.org",
// "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites",
// "Use this name anyway" => "Use this name anyway",
// "This feature currently searches and replaces within wiki pages only" => "This feature currently searches and replaces within wiki pages only",
// "Max number of pages at a time" => "Max number of pages at a time",
// "Number of surrounding chars to preview" => "Number of surrounding chars to preview",
// "Replace selected" => "Replace selected",
// "Reply to" => "Reply to",
// "Sender email not set" => "Sender email not set",
// "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need",
// "password-protected" => "password-protected",
// "Configure this sheet" => "Configure this sheet",
// "Join with Spreadsheet" => "Join with Spreadsheet",
// "page: %0/%1" => "page: %0/%1",
// "This text was automatically translated by Google Translate from the following page: " => "This text was automatically translated by Google Translate from the following page: ",
// "First Slide" => "First Slide",
// "Previous Slide" => "Previous Slide",
// "Previous Point" => "Previous Point",
// "Next Point" => "Next Point",
// "Next Slide" => "Next Slide",
// "Last Slide" => "Last Slide",
// "Jump To Slide" => "Jump To Slide",
// "Play" => "Play",
// "Pause" => "Pause",
// "Toggle Loop" => "Toggle Loop",
// "Exit" => "Exit",
// "Change Theme" => "Change Theme",
// "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application" => "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application",
// "twitter authorisation" => "twitter authorisation",
// "to manage your authorisations at twitter" => "to manage your authorisations at twitter",
// "this site with twitter.com to use twitter integration of this site" => "this site with twitter.com to use twitter integration of this site",
// "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first" => "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first",
// "facebook authorisation" => "facebook authorisation",
// "to manage your authorisations at facebook" => "to manage your authorisations at facebook",
// "this site with facebook.com to use twitter integration of this site" => "this site with facebook.com to use twitter integration of this site",
// "The site admin has set up a global account which will be used for this site" => "The site admin has set up a global account which will be used for this site",
// "You will not see the latest queries" => "You will not see the latest queries",
// "Date of first pageview" => "Date of first pageview",
// "Days since first pageview" => "Days since first pageview",
// "Average number of replies per topic" => "Average number of replies per topic",
// "FAQ Stats" => "FAQ Stats",
// "Most viewed objects in period" => "Most viewed objects in period",
// "Tiki Logs" => "Tiki Logs",
// "Export through Action Log" => "Export through Action Log",
// "Friend's email" => "Friend's email",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Log out" => "Use Current Session/Log out",
// "Recorded Links" => "Recorded Links",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "Delete this link" => "Delete this link",
// "TikiTests List" => "TikiTests List",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
// "Tracker Item History" => "Tracker Item History",
// "View Tracker Item" => "View Tracker Item",
// "Advanced mode" => "Advanced mode",
// "Simple mode" => "Simple mode",
// "Retry" => "Retry",
// "The following files have been successfully uploaded" => "The following files have been successfully uploaded",
// "Or using as a thumbnail with ShadowBox" => "Or using as a thumbnail with ShadowBox",
// "You can link to the file from an HTML page using" => "You can link to the file from an HTML page using",
// "File title" => "File title",
// "File description" => "File description",
// "Unzip zip files" => "Unzip zip files",
// "File can be deleted after" => "File can be deleted after",
// "Creator of file, if different from the 'Uploaded by' user" => "Creator of file, if different from the 'Uploaded by' user",
// "Maximum number of downloads" => "Maximum number of downloads",
// "Add File" => "Add File",
// "Maximum file size is around" => "Maximum file size is around",
// "Uploading file.." => "Uploading file..",
// "No File to Upload.." => "No File to Upload..",
// " Syntax tips" => " Syntax tips",
// "Link to file from a Wiki page" => "Link to file from a Wiki page",
// "In addition, for image files" => "In addition, for image files",
// "To display in a Wiki page" => "To display in a Wiki page",
// "Display thumbnail that enlarges" => "Display thumbnail that enlarges",
// "No gallery available" => "No gallery available",
// "The column is disabled" => "The column is disabled",
// "a folder" => "a folder",
// "a bookmark" => "a bookmark",
// "User Contacts Preferences" => "User Contacts Preferences",
// "{if \$prefs.menus_item_names_raw eq 'n'}{\$chdata.name|escape}{else}{\$chdata.name}{/if}" => "{if \$prefs.menus_item_names_raw eq 'n'}{\$chdata.name|escape}{else}{\$chdata.name}{/if}",
// "(non public)" => "(non public)",
// "This user is your friend " => "This user is your friend ",
// "The user requested friendship with you" => "The user requested friendship with you",
// "Accept friendship from this user" => "Accept friendship from this user",
// "Refuse friendship from this user" => "Refuse friendship from this user",
// "Currently waiting for user approval" => "Currently waiting for user approval",
// "Cancel friendship request towards this user" => "Cancel friendship request towards this user",
// "has not contributed to any content yet" => "has not contributed to any content yet",
// "Who Looks At His Stuff" => "Who Looks At His Stuff",
// "User's personal tracker information" => "User's personal tracker information",
// "Preferred language" => "Preferred language",
// "Longitude" => "Longitude",
// "Latitude" => "Latitude",
// "Map zoom" => "Map zoom",
// "Are you really sure you want to delete the account %0" => "Are you really sure you want to delete the account %0",
// "Check this box if you really want to delete the account" => "Check this box if you really want to delete the account",
// "Delete the account" => "Delete the account",
// "User Watches and preferences" => "User Watches and preferences",
// "You need to set your email to receive email notifications" => "You need to set your email to receive email notifications",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
// "Category change in a language" => "Category change in a language",
// "Used space" => "Used space",
// "up to" => "up to",
// "no limit for admin" => "no limit for admin",
// "No articles yet" => "No articles yet",
// "Add an article" => "Add an article",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
// "Manage Message Queue" => "Manage Message Queue",
// "Manage Reported Messages" => "Manage Reported Messages",
// "Group Monitor Topics of this Forum" => "Group Monitor Topics of this Forum",
// "Group Monitor Topics and Threads of this Forum" => "Group Monitor Topics and Threads of this Forum",
// "Atts" => "Atts",
// "Forum Lock" => "Forum Lock",
// "Filter Posts" => "Filter Posts",
// "Posts Filtering" => "Posts Filtering",
// "Last post date" => "Last post date",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
// "Posts with no replies" => "Posts with no replies",
// "Topic List" => "Topic List",
// "Save current spreadsheet" => "Save current spreadsheet",
// "Cancel editing current spreadsheet" => "Cancel editing current spreadsheet",
// "List Spreadsheets" => "List Spreadsheets",
// "Already being edited by" => "Already being edited by",
// "No parse" => "No parse",
// "What would you like to add" => "What would you like to add",
// "New spreadsheet" => "New spreadsheet",
// "Existing spreadsheet" => "Existing spreadsheet",
// "Tracker as a spreadsheet" => "Tracker as a spreadsheet",
// "Spreadsheet from file gallery" => "Spreadsheet from file gallery",
// "Edit/Delete" => "Edit/Delete",
// "Move to another tracker" => "Move to another tracker",
// "Back to Items list" => "Back to Items list",
// "Back to Items List" => "Back to Items List",
// "Open Tiki WebDAV as WebFolder" => "Open Tiki WebDAV as WebFolder",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "This is the active account" => "This is the active account",
// "IMAP" => "IMAP",
// "Mbox" => "Mbox",
// "Maildir" => "Maildir",
// "POP3" => "POP3",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Incoming servers (used in this order)" => "Incoming servers (used in this order)",
// "IMAP server" => "IMAP server",
// "Mbox filepath" => "Mbox filepath",
// "Maildir mail directory" => "Maildir mail directory",
// "Use SSL" => "Use SSL",
// "Outgoing server" => "Outgoing server",
// "From email" => "From email",
// "Uses current in preferences if empty" => "Uses current in preferences if empty",
// "No email set" => "No email set",
// "Account details" => "Account details",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Show Unread" => "Show Unread",
// "Show Flagged" => "Show Flagged",
// "Auto refresh set for every \$autoRefresh seconds" => "Auto refresh set for every \$autoRefresh seconds",
// "Refresh now" => "Refresh now",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
// "Part" => "Part",
// "There is a staging page (not yet approved) for this page" => "There is a staging page (not yet approved) for this page",
// "View edit icons" => "View edit icons",
// "Page is NOT being monitored. Click icon to START monitoring" => "Page is NOT being monitored. Click icon to START monitoring",
// "Page IS being monitored. Click icon to STOP monitoring" => "Page IS being monitored. Click icon to STOP monitoring",
// "Group Monitor on Structure" => "Group Monitor on Structure",
// "Hold \"Ctrl\" in order to select multiple values" => "Hold \"Ctrl\" in order to select multiple values",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Character Limit Exceeded" => "Character Limit Exceeded",
// "Word Count" => "Word Count",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19",
// "You can use" => "You can use",
// "Number of votes" => "Number of votes",
// "Your rating" => "Your rating",
// "You did not vote yet" => "You did not vote yet",
// "My rating" => "My rating",
// "Click to vote for this value" => "Click to vote for this value",
// "Clik to delete your vote" => "Clik to delete your vote",
// "Google Maps is not enabled" => "Google Maps is not enabled",
// "Freetags is not enabled" => "Freetags is not enabled",
// "The main text of this page is available in the following languages" => "The main text of this page is available in the following languages",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
// "Current attendees" => "Current attendees",
// "No attendees at this time" => "No attendees at this time",
// "Last time we checked, the room you requested did not exist" => "Last time we checked, the room you requested did not exist",
// "Toggle location map" => "Toggle location map",
// "Lon" => "Lon",
// "Lat" => "Lat",
// "saving.." => "saving..",
// "Save current map view as user default" => "Save current map view as user default",
// "Save as user location" => "Save as user location",
// "Save as object location" => "Save as object location",
// "Email address the person you want to invite" => "Email address the person you want to invite",
// "Set in these groups" => "Set in these groups",
// "Email sent to" => "Email sent to",
// "Send to users" => "Send to users",
// "Send to" => "Send to",
// "Email separated by comma" => "Email separated by comma",
// "Send to groups" => "Send to groups",
// "Send Mail" => "Send Mail",
// "Check to remove" => "Check to remove",
// "Join myself" => "Join myself",
// "Leave myself" => "Leave myself",
// "%0 year" => "%0 year",
// "%0 years" => "%0 years",
// "%0 days" => "%0 days",
// "Cost for one period" => "Cost for one period",
// "Membership to %0 for %1 year at %2&nbsp;%3" => "Membership to %0 for %1 year at %2&nbsp;%3",
// "Membership to %0 for %1 years at %2&nbsp;%3" => "Membership to %0 for %1 years at %2&nbsp;%3",
// "Membership to %0 for %1 days at %2&nbsp;%3" => "Membership to %0 for %1 days at %2&nbsp;%3",
// "separated by |" => "separated by |",
// "Number of periods" => "Number of periods",
// "Re-Apply" => "Re-Apply",
// "Undecided" => "Undecided",
// "Last Day" => "Last Day",
// "Last Week" => "Last Week",
// "Your default group" => "Your default group",
// "Change default group" => "Change default group",
// "Subscribe to the newsletter" => "Subscribe to the newsletter",
// "Please login first" => "Please login first",
// "Page last modified on %0 by %1" => "Page last modified on %0 by %1",
// "Created by %0" => "Created by %0",
// "Last Modification: %0 by %1" => "Last Modification: %0 by %1",
// "Creator &amp; Last Editor" => "Creator &amp; Last Editor",
// "Save the page, but do not count it as new content to be translated" => "Save the page, but do not count it as new content to be translated",
// "%0 enabled" => "%0 enabled",
// "%0 disabled" => "%0 disabled",
// "%0 set" => "%0 set",
// "%0 unset" => "%0 unset",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "Current version is up to date : <b>%0</b>" => "Current version is up to date : <b>%0</b>",
// "A new %0 major release branch is available" => "A new %0 major release branch is available",
// "Feeds settings" => "Feeds settings",
// "Configure Site Ads and Banners" => "Configure Site Ads and Banners",
// "Settings for video streaming integration" => "Settings for video streaming integration",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "silver" => "silver",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Multiple IP Banning" => "Multiple IP Banning",
// "Access from your localization was forbidden due to excessive spamming" => "Access from your localization was forbidden due to excessive spamming",
// "Delete comments then set banning rules" => "Delete comments then set banning rules",
// "Are you sure you want to unassign the objects of this category: " => "Are you sure you want to unassign the objects of this category: ",
// "Click here to delete the category" => "Click here to delete the category",
// "No display" => "No display",
// "You must specify a directory" => "You must specify a directory",
// "Test Image" => "Test Image",
// "Tiki Email Test" => "Tiki Email Test",
// "Tiki Test email from" => "Tiki Test email from",
// "Unable to send mail" => "Unable to send mail",
// "Test mail sent to" => "Test mail sent to",
// "%d user-group assignments" => "%d user-group assignments",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
// "New configuration created (id %0)" => "New configuration created (id %0)",
// "Configuration updated" => "Configuration updated",
// "Are you sure you want to modify this menu" => "Are you sure you want to modify this menu",
// "Are you sure you want to create a new menu" => "Are you sure you want to create a new menu",
// "metric_remove must be a numeric value" => "metric_remove must be a numeric value",
// "tab_remove must be a numeric value" => "tab_remove must be a numeric value",
// "assign_remove must be a numeric value" => "assign_remove must be a numeric value",
// "metric_edit must be a numeric value" => "metric_edit must be a numeric value",
// "tab_edit must be a numeric value" => "tab_edit must be a numeric value",
// "Memcache is disabled for metrics" => "Memcache is disabled for metrics",
// "tab_clearcache must be a numeric value" => "tab_clearcache must be a numeric value",
// "assign_metric must be a numeric value" => "assign_metric must be a numeric value",
// "assign_metric_edit must be a numeric value" => "assign_metric_edit must be a numeric value",
// "Assign: Invalid metric value" => "Assign: Invalid metric value",
// "Assign: Invalid tab value" => "Assign: Invalid tab value",
// "Cannot create or update metric: You need to specify a name for the metric" => "Cannot create or update metric: You need to specify a name for the metric",
// "Cannot create or update metric: Metric name must be under \" . \$prefs['metrics_metric_name_length'] . \" characters in length" => "Cannot create or update metric: Metric name must be under \" . \$prefs['metrics_metric_name_length'] . \" characters in length",
// "Cannot create or update metric: You need to specify a range for the metric" => "Cannot create or update metric: You need to specify a range for the metric",
// "Cannot create or update metric: You need to specify a data type for the metric" => "Cannot create or update metric: You need to specify a data type for the metric",
// "Cannot create or update metric: You need to specify a query for the metric" => "Cannot create or update metric: You need to specify a query for the metric",
// "Cannot create or update tab: You need to specify a name for the tab" => "Cannot create or update tab: You need to specify a name for the tab",
// "Cannot create or update tab: Tab name must be under \" . \$prefs['metrics_tab_name_length'] . \" characters in length" => "Cannot create or update tab: Tab name must be under \" . \$prefs['metrics_tab_name_length'] . \" characters in length",
// "Cannot create or update tab: You need to specify an integer range for the tab order" => "Cannot create or update tab: You need to specify an integer range for the tab order",
// "Cannot create or update tab: Tab content cannot be empty" => "Cannot create or update tab: Tab content cannot be empty",
// "Newsletter does not exist" => "Newsletter does not exist",
// "Error importing from wiki page: " => "Error importing from wiki page: ",
// "Error opening uploaded file" => "Error opening uploaded file",
// "A comment in a wiki page is posted or edited" => "A comment in a wiki page is posted or edited",
// "off" => "off",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Global" => "Global",
// "Are you sure you want to delete all your custom tools" => "Are you sure you want to delete all your custom tools",
// "Are you sure you want to delete this custom tool" => "Are you sure you want to delete this custom tool",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Are you sure you want to remove this topic AND all the articles related" => "Are you sure you want to remove this topic AND all the articles related",
// "Tracker does not allow attachments" => "Tracker does not allow attachments",
// "Are you sure you want to create a new group" => "Are you sure you want to create a new group",
// "Are you sure you want to add this user?" => "Are you sure you want to add this user?",
// "Remove group: " => "Remove group: ",
// "Group name can not be empty" => "Group name can not be empty",
// "Are you sure you want to add this new user" => "Are you sure you want to add this new user",
// "Are you sure you want to delete this user" => "Are you sure you want to delete this user",
// "Are you sure you want to remove this user from this group" => "Are you sure you want to remove this user from this group",
// "Are you sure you want to reset email due for this user" => "Are you sure you want to reset email due for this user",
// "Are you sure you want to delete these users" => "Are you sure you want to delete these users",
// "Are you sure you want to add this user to these groups" => "Are you sure you want to add this user to these groups",
// "Are you sure you want to remove this user from these groups" => "Are you sure you want to remove this user from these groups",
// "Are you sure you want to set the default groups for these users" => "Are you sure you want to set the default groups for these users",
// "Are you sure you want to send a wiki page as an email to these users" => "Are you sure you want to send a wiki page as an email to these users",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
// "Could not create user" => "Could not create user",
// "User does not exist on master" => "User does not exist on master",
// "Email validation requested but email address not set" => "Email validation requested but email address not set",
// "Password not set" => "Password not set",
// "Deleted account %s" => "Deleted account %s",
// "%s %s assigned to %s %s" => "%s %s assigned to %s %s",
// "group %s set as the default group of user %s" => "group %s set as the default group of user %s",
// "Are you sure you want to modify this user's data" => "Are you sure you want to modify this user's data",
// "Please go back and try again" => "Please go back and try again",
// "approved by " => "approved by ",
// "Staging page cannot be found" => "Staging page cannot be found",
// "Failed to add attribute" => "Failed to add attribute",
// "Unassign perm %s from group %s" => "Unassign perm %s from group %s",
// "File Galleries Admin Panel" => "File Galleries Admin Panel",
// "File %s removed from Batch directory" => "File %s removed from Batch directory",
// "Impossible to remove file %s from Batch directory" => "Impossible to remove file %s from Batch directory",
// "Incorrect directory chosen for batch upload of files" => "Incorrect directory chosen for batch upload of files",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field" => "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field",
// "TikiHelp WebHelp generation engine. Generating WebHelp using" => "TikiHelp WebHelp generation engine. Generating WebHelp using",
// "Eliminating previous files" => "Eliminating previous files",
// "Index: <strong>\$name</strong>" => "Index: <strong>\$name</strong>",
// "Directory: <strong>\$dir</strong>" => "Directory: <strong>\$dir</strong>",
// "Creating directory structure in <strong>\$base</strong>" => "Creating directory structure in <strong>\$base</strong>",
// "Last sites of directory \" . \$rc[\"name\"] . \" " => "Last sites of directory \" . \$rc[\"name\"] . \" ",
// "Discount code already exists" => "Discount code already exists",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Wrote %d new strings and updated %d to lang/%s/language.php" => "Wrote %d new strings and updated %d to lang/%s/language.php",
// "Imported" => "Imported",
// "Edit Perspectives" => "Edit Perspectives",
// "Describe the change you made" => "Describe the change you made",
// "Page name is" => "Page name is",
// "Can not open the file" => "Can not open the file",
// "Problem zip initialisation" => "Problem zip initialisation",
// "Problem zip" => "Problem zip",
// "Another user is currently exporting that tracker, please try again later" => "Another user is currently exporting that tracker, please try again later",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
// "Last replied forum topics" => "Last replied forum topics",
// "Not supported yet" => "Not supported yet",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
// "Operations executed successfully" => "Operations executed successfully",
// "Invalid software name" => "Invalid software name",
// "You have requested that this page be machine translated" => "You have requested that this page be machine translated",
// "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it",
// "Kaltura Upload" => "Kaltura Upload",
// "Communication error" => "Communication error",
// "Invalid response provided by the Kaltura server. Please retry" => "Invalid response provided by the Kaltura server. Please retry",
// "Are you sure you want to permanently remove article id %0" => "Are you sure you want to permanently remove article id %0",
// "Are you sure you want to permanently remove %0 articles" => "Are you sure you want to permanently remove %0 articles",
// "You do not have permission to view the comments for this blog" => "You do not have permission to view the comments for this blog",
// "Delete comments" => "Delete comments",
// "Approved Status" => "Approved Status",
// "Queued" => "Queued",
// "The file is already locked by %s" => "The file is already locked by %s",
// "WARNING: The file is used in" => "WARNING: The file is used in",
// "Remove file: " => "Remove file: ",
// "Quota too big" => "Quota too big",
// "Quota too small" => "Quota too small",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload your file" => "Please re-upload your file",
// "Cannot read the file" => "Cannot read the file",
// "Not modified since" => "Not modified since",
// "Not downloaded since" => "Not downloaded since",
// "Error importing" => "Error importing",
// "Error converting" => "Error converting",
// "Importing" => "Importing",
// "Processing" => "Processing",
// "Ready" => "Ready",
// "Pending moderation" => "Pending moderation",
// "Blocked" => "Blocked",
// "Invalid action" => "Invalid action",
// "Are you sure you want to permanently remove submited article id %0" => "Are you sure you want to permanently remove submited article id %0",
// "Are you sure you want to permanently remove %0 submited articles" => "Are you sure you want to permanently remove %0 submited articles",
// "Are you sure you want to approve %0 submited articles" => "Are you sure you want to approve %0 submited articles",
// "Are you sure you want to remove the %0 selected pages" => "Are you sure you want to remove the %0 selected pages",
// "Are you sure you want to print the %0 selected pages" => "Are you sure you want to print the %0 selected pages",
// "Are you sure you want to unlock the %0 selected pages" => "Are you sure you want to unlock the %0 selected pages",
// "Are you sure you want to lock the %0 selected pages" => "Are you sure you want to lock the %0 selected pages",
// "Are you sure you want to download a zip of the %0 selected pages" => "Are you sure you want to download a zip of the %0 selected pages",
// "Username field cannot be empty. Please go back and try again" => "Username field cannot be empty. Please go back and try again",
// "Resend" => "Resend",
// "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email",
// "Verification cancelled" => "Verification cancelled",
// "Authentication error; probably not a valid OpenID" => "Authentication error; probably not a valid OpenID",
// "Could not redirect to server: " => "Could not redirect to server: ",
// "OpenID authentication failed: " => "OpenID authentication failed: ",
// "You must first setup MapServer" => "You must first setup MapServer",
// "invalid mapfile name" => "invalid mapfile name",
// "An error as occured with the mapfile" => "An error as occured with the mapfile",
// "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files" => "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files",
// " to " => " to ",
// "No page provided" => "No page provided",
// "This Tiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more" => "This Tiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more",
// "Note not found" => "Note not found",
// "Object Permissions" => "Object Permissions",
// "Are you sure you want to remove the direct permissions from this object" => "Are you sure you want to remove the direct permissions from this object",
// "You do not have permission to assign permissions for this object" => "You do not have permission to assign permissions for this object",
// "Manual payment entered" => "Manual payment entered",
// "You do not have permission to enter payment" => "You do not have permission to enter payment",
// "New payment requested" => "New payment requested",
// "Cancel payment %0" => "Cancel payment %0",
// "Payment canceled" => "Payment canceled",
// "Missing object list type argument" => "Missing object list type argument",
// "You are already logged in" => "You are already logged in",
// "Missing User Name" => "Missing User Name",
// "User Already Exists" => "User Already Exists",
// "Valid User Name" => "Valid User Name",
// "Missing Email" => "Missing Email",
// "Valid Email" => "Valid Email",
// "Please provide a username or email" => "Please provide a username or email",
// "This match was not case sensitive" => "This match was not case sensitive",
// "No items selected" => "No items selected",
// "Page cannot be found: " => "Page cannot be found: ",
// "Page has changed since preview: " => "Page has changed since preview: ",
// "Page not updated due to error in replacing: " => "Page not updated due to error in replacing: ",
// "Page updated: " => "Page updated: ",
// "A problem occured during file uploading" => "A problem occured during file uploading",
// "File which was causing trouble was at rank" => "File which was causing trouble was at rank",
// "The error was" => "The error was",
// "Error: You can\\'t send the same newsletter by refreshing this frame content" => "Error: You can\\'t send the same newsletter by refreshing this frame content",
// "Newsletter successfully sent to %s users" => "Newsletter successfully sent to %s users",
// "There was %s errors" => "There was %s errors",
// "Your link was sent" => "Your link was sent",
// "Your email is mandatory" => "Your email is mandatory",
// "Permission to post in forum denied" => "Permission to post in forum denied",
// "No text given for tweet" => "No text given for tweet",
// "Error sending tweet" => "Error sending tweet",
// "Error sending mail to" => "Error sending mail to",
// "Spreadsheet - " => "Spreadsheet - ",
// "Are you sure you want to delete this spreadsheet" => "Are you sure you want to delete this spreadsheet",
// "Permission denied. You cannot view this page" => "Permission denied. You cannot view this page",
// "Send a link to a friend " => "Send a link to a friend ",
// "You must lock the file before editing it" => "You must lock the file before editing it",
// "Batch file processed" => "Batch file processed",
// "Cannot resize the file" => "Cannot resize the file",
// "Cannot write the file" => "Cannot write the file",
// "Image was reduced: %s x %s -> %s x %s" => "Image was reduced: %s x %s -> %s x %s",
// "Check that these paths exist and are writable by the web server" => "Check that these paths exist and are writable by the web server",
// "Incorrect file extension" => "Incorrect file extension",
// "If you really want to delete you're account, you must check the checkbox" => "If you really want to delete you're account, you must check the checkbox",
// "This script can only be called by the server" => "This script can only be called by the server",
// "Remove the notification email" => "Remove the notification email",
// "Category watch: %0, Language: %1" => "Category watch: %0, Language: %1",
// "Post not found" => "Post not found",
// "You do not have permission to view this blog post while it is marked as private" => "You do not have permission to view this blog post while it is marked as private",
// "Spreadsheet truncated" => "Spreadsheet truncated",
// "Files are read only at this time" => "Files are read only at this time",
// "Are you sure you want to clone this spreadsheet" => "Are you sure you want to clone this spreadsheet",
// "Clone Error" => "Clone Error",
// "Are you sure you want to rollback this spreadsheet" => "Are you sure you want to rollback this spreadsheet",
// "Rollback Error" => "Rollback Error",
// "Create tracker item" => "Create tracker item",
// "You don't have a personal tracker item yet. Click here to make one" => "You don't have a personal tracker item yet. Click here to make one",
// "There was a problem connecting to that account" => "There was a problem connecting to that account",
// "There was a problem deleting that mail" => "There was a problem deleting that mail",
// "Mail ID" => "Mail ID",
// "There was a problem while trying to delete these mails" => "There was a problem while trying to delete these mails",
// "There was a problem while trying to delete that mail" => "There was a problem while trying to delete that mail",
// "Are you sure you want to delete this account" => "Are you sure you want to delete this account",
// "Taking" => "Taking",
// "Putting back" => "Putting back",
// "Checking" => "Checking",
// ### end of untranslated words
// ###

// ###
// ### start of possibly untranslated words
// ###

"Re:" => "Re:",
"ID" => "ID",
"Explorer" => "Explorer",
"Andorra" => "Andorra",
"Angola" => "Angola",
"Anguilla" => "Anguilla",
"Antigua" => "Antigua",
"Argentina" => "Argentina",
"Aruba" => "Aruba",
"Bahrain" => "Bahrain",
"Barbados" => "Barbados",
"Belize" => "Belize",
"Bermuda" => "Bermuda",
"Bhutan" => "Bhutan",
"Botswana" => "Botswana",
"Brunei" => "Brunei",
"Burundi" => "Burundi",
"Congo" => "Congo",
"Cuba" => "Cuba",
"Djibouti" => "Djibouti",
"Dominica" => "Dominica",
"Eritrea" => "Eritrea",
"Fiji" => "Fiji",
"Gabon" => "Gabon",
"Ghana" => "Ghana",
"Gibraltar" => "Gibraltar",
"Grenada" => "Grenada",
"Guam" => "Guam",
"Guatemala" => "Guatemala",
"Guernsey" => "Guernsey",
"Guinea" => "Guinea",
"Guyana" => "Guyana",
"Iran" => "Iran",
"Iraq" => "Iraq",
"Israel" => "Israel",
"Jamaica" => "Jamaica",
"Kenya" => "Kenya",
"Kiribati" => "Kiribati",
"Kuwait" => "Kuwait",
"Laos" => "Laos",
"Lesotho" => "Lesotho",
"Liechtenstein" => "Liechtenstein",
"Luxemburg" => "Luxemburg",
"Madagascar" => "Madagascar",
"Malawi" => "Malawi",
"Malaysia" => "Malaysia",
"Maldives" => "Maldives",
"Mali" => "Mali",
"Malta" => "Malta",
"Mayotte" => "Mayotte",
"Montenegro" => "Montenegro",
"Montserrat" => "Montserrat",
"Myanmar" => "Myanmar",
"Nauru" => "Nauru",
"Nepal" => "Nepal",
"Nicaragua" => "Nicaragua",
"Niue" => "Niue",
"Oman" => "Oman",
"Pakistan" => "Pakistan",
"Palau" => "Palau",
"Pitcairn" => "Pitcairn",
"Portugal" => "Portugal",
"Reunion" => "Reunion",
"Romania" => "Romania",
"Rwanda" => "Rwanda",
"Samoa" => "Samoa",
"Senegal" => "Senegal",
"Seychelles" => "Seychelles",
"Sudan" => "Sudan",
"Surinam" => "Surinam",
"Taiwan" => "Taiwan",
"Timor-Leste" => "Timor-Leste",
"Togo" => "Togo",
"Tokelau" => "Tokelau",
"Tonga" => "Tonga",
"Turkmenistan" => "Turkmenistan",
"Tuvalu" => "Tuvalu",
"Uganda" => "Uganda",
"Uzbekistan" => "Uzbekistan",
"Vanuatu" => "Vanuatu",
"Wales" => "Wales",
"Zimbabwe" => "Zimbabwe",
"Farsi" => "Farsi",
"Wiki" => "Wiki",
"Articles" => "Articles",
"article" => "article",
"Error" => "Error",
"Ajax Xajax" => "Ajax Xajax",
"Visible" => "Visible",
"Id" => "Id",
"Tiki" => "Tiki",
"Shibboleth" => "Shibboleth",
"3" => "3",
"Port" => "Port",
"utf-8" => "utf-8",
"iso-8859-1" => "iso-8859-1",
"Simple" => "Simple",
"1" => "1",
"2" => "2",
"4" => "4",
"5" => "5",
"Copyright" => "Copyright",
"Ajax" => "Ajax",
"Intertiki" => "Intertiki",
"XMLRPC API" => "XMLRPC API",
"Test" => "Test",
"Normal" => "Normal",
"Vertical" => "Vertical",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
"Versions" => "Versions",
"Categories" => "Categories",
"Article" => "Article",
"km" => "km",
"No" => "No",
"pvs" => "pvs",
"Foo" => "Foo",
"text" => "text",
"wiki" => "wiki",
"arts" => "arts",
"url" => "url",
"auto-increment" => "auto-increment",
"Info" => "Info",
"~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~" => "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~",
"Avatar" => "Avatar",
"Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~" => "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~",
"Url" => "Url",
"Mode" => "Mode",
"Colors" => "Colors",
"colorbox" => "colorbox",
"DBReport" => "DBReport",
"Div" => "Div",
"Pre" => "Pre",
"Events" => "Events",
"Color" => "Color",
"googledoc" => "googledoc",
"HTML" => "HTML",
"Iframe" => "Iframe",
"iframe" => "iframe",
"Transparent" => "Transparent",
"Font" => "Font",
"Subscribe Groups" => "Subscribe Groups",
", " => ", ",
"If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address",
"Copyrights" => "Copyrights",
"Total" => "Total",
"Perms" => "Perms",
"Pan" => "Pan",
"Ip" => "Ip",
"ERROR" => "ERROR",
"CC" => "CC",
"BCC" => "BCC",
"Update" => "Update",
"Categories:" => "Categories:",
"[-]" => "[-]",
"phpinfo" => "phpinfo",
"Mods" => "Mods",
"DSN" => "DSN",
"IP" => "IP",
"x" => "x",
"Loc" => "Loc",
"Participants" => "Participants",
"Cat" => "Cat",
"Prio" => "Prio",
"Coms" => "Coms",
"General" => "General",
"InterTiki" => "InterTiki",
"port" => "port",
"LDAP" => "LDAP",
"PAM" => "PAM",
"Robots" => "Robots",
"Quota (Mb)" => "Quota (Mb)",
"article-put" => "article-put",
"wiki-get" => "wiki-get",
"wiki-put" => "wiki-put",
"wiki-append" => "wiki-append",
"mn" => "mn",
"URL:" => "URL:",
"PDF" => "PDF",
"Pos" => "Pos",
"UTF-8" => "UTF-8",
"ISO-8859-1" => "ISO-8859-1",
"bcc" => "bcc",
"Desc" => "Desc",
"RSS" => "RSS",
"Change Focus" => "Change Focus",
"+" => "+",
"D" => "D",
"M" => "M",
"%m/%d" => "%m/%d",
"editor" => "editor",
"col" => "col",
"Original" => "Original",
"%" => "%",
"Change Language" => "Change Language",
"idea" => "idea",
"neutral" => "neutral",
"Universal" => "Universal",
"Errors:" => "Errors:",
"MultiTiki" => "MultiTiki",
"Editor" => "Editor",
"v" => "v",
"Client" => "Client",
"Impressions" => "Impressions",
"Vers." => "Vers.",
"Prefs" => "Prefs",
"h" => "h",
"min" => "min",
"Notes" => "Notes",
"quota" => "quota",
"Similar" => "Similar",
"Avatar:" => "Avatar:",
"P/F" => "P/F",
"tiki.org" => "tiki.org",
"octets" => "octets",
"Tweet via Twitter" => "Tweet via Twitter",
"Params" => "Params",
"#" => "#",
"Emot" => "Emot",
"pts" => "pts",
"normal" => "normal",
"Cc" => "Cc",
"Approve changes" => "Approve changes",
"Zoom" => "Zoom",
"Error:" => "Error:",
"%H:%M %Z" => "%H:%M %Z",
"id" => "id",
"tiki-mobile.php" => "tiki-mobile.php",
"Error: " => "Error: ",
"no" => "no",
"unicode" => "unicode",
// ###
// ### end of possibly untranslated words
// ###

"This forum is flat and doesn't allow replies to other replies" => "Aquest fòrum és pla i no permet respostes a altres respostes",
"This script cannot be called directly" => "No es pot cridar a aquesta rutina directament",
"Copyright management" => "Gestió de Copyright",
"No page indicated" => "No s'ha indicat cap pàgina",
"You must supply all the information, including title and year." => "Has de facilitar tota la informació, incloent títol i any.",
"You do not have permission to use this feature" => "Permís denegat per accedir a aquesta secció",
"This feature is for admins only" => "Aquesta funcionalitat és només per administradors/es",
"Type" => "Tipus",
"Name" => "Nom",
"Description" => "Descripció",
"Size" => "Mida",
"Created" => "Creada",
"Uploaded" => "Carregat",
"Last Modified" => "Darrera modificació",
"Creator" => "Creador",
"Comment" => "Comentari",
"Files" => "Arxius",
"Hits" => "Cops",
"Locked by" => "Bloquejat per",
"Backlinks" => "Retroenllaços",
"Path" => "Ruta",
"Slideshow" => "Passi de diapositives",
"Default View" => "Visualització per omissió",
"Register" => "Registre",
"Afghanistan" => "Afganistan",
"Aland Islands" => "Illes_Aland",
"Albania" => "Albània",
"Algeria" => "Algèria",
"American Samoa" => "Samoa_Americana",
"Armenia" => "Armènia",
"Australia" => "Austràlia",
"Austria" => "Àustria",
"Azerbaijan" => "Azerbaitjan",
"Bahamas" => "Bahames",
"Bangladesh" => "Bangla_Desh",
"Belarus" => "Bielorússia",
"Belgium" => "Bèlgica",
"Benin" => "Benín",
"Bolivia" => "Bolívia",
"Bosnia and Herzegovina" => "Bosnia_i_Herzegovina",
"Bouvet Island" => "Illa_Bouvet",
"Brazil" => "Brasil",
"British Indian Ocean Territory" => "Territori_Britànic_de_l'Oceà_Índic",
"British Virgin Islands" => "Illes_Verge_Britàniques",
"Bulgaria" => "Bulgària",
"Burkina Faso" => "Burkina_Faso",
"Cambodia" => "Cambodja",
"Cameroon" => "Camerun",
"Canada" => "Canadà",
"Cape Verde" => "Cap_Verd",
"Catalan Countries" => "Països_Catalans",
"Cayman Islands" => "Illes_Caiman",
"Central African Republic" => "República_Centreafricana",
"Chad" => "Txad",
"Chile" => "Xile",
"China" => "Xina",
"Christmas Island" => "Illa_Christmas",
"Cocos Islands" => "Illes_Cocos",
"Colombia" => "Colòmbia",
"Comoros" => "Comores",
"Congo Democratic" => "Congo,_Repúlica_Democràtica",
"Cook Islands" => "Illes_Cook",
"Costa Rica" => "Costa_Rica",
"Croatia" => "Croàcia",
"Cyprus" => "Xipre",
"Czech Republic" => "República_Txeca",
"Denmark" => "Dinamarca",
"Dominican Republic" => "República_Dominicana",
"Ecuador" => "Equador",
"Egypt" => "Egipte",
"El Salvador" => "El_Salvador",
"Equatorial Guinea" => "Guinea_Equatorial",
"Estonia" => "Estònia",
"Ethiopia" => "Etiòpia",
"Europe" => "Europa",
"Falkland Islands" => "Illes_Malvines_(Falkland)",
"Faroe Islands" => "Illes_Fèroe",
"Federated States of Micronesia" => "Micronèsia,_Estats_Federats_de",
"Finland" => "Finlàndia",
"France" => "França",
"French Guiana" => "Guaiana_Francesa",
"French Polynesia" => "Polinèsia_Francesa",
"French Southern Territories" => "Territoris_Francesos_del_Sud",
"Gambia" => "Gàmbia",
"Georgia" => "Geòrgia",
"Germany" => "Alemanya",
"Greece" => "Grècia",
"Greenland" => "Groenlàndia",
"Guadeloupe" => "Guadalupe",
"Guinea Bissau" => "Guinea_Bissau",
"Haiti" => "Haití",
"Heard Island and McDonald Islands" => "Illa_Heard_i_Illes_McDonald",
"Honduras" => "Hondures",
"Hong Kong" => "Hong_Kong",
"Hungary" => "Hongria",
"Iceland" => "Islàndia",
"India" => "Índia",
"Indonesia" => "Indonèsia",
"Ireland" => "Irlanda",
"Isle of Man" => "Illa de Man",
"Italy" => "Itàlia",
"Ivory Coast" => "Costa d'Ivori",
"Japan" => "Japó",
"Jersey" => "Jersei",
"Jordan" => "Jordània",
"Kazakstan" => "Kazakhstan",
"Kyrgyzstan" => "Kirguizistan",
"Latvia" => "Letònia",
"Lebanon" => "Líban",
"Liberia" => "Libèria",
"Libya" => "Líbia",
"Lithuania" => "Lituània",
"Macao" => "Macau",
"Macedonia" => "Macedònia",
"Marshall Islands" => "Illes_Marshall",
"Martinique" => "Martinica",
"Mauritania" => "Mauritània",
"Mauritius" => "Maurici",
"Mexico" => "Mèxic",
"Moldova" => "Moldàvia",
"Monaco" => "Mònaco",
"Mongolia" => "Mongòlia",
"Morocco" => "Marroc",
"Mozambique" => "Moçambic",
"Namibia" => "Namíbia",
"Netherlands Antilles" => "Antilles_Holandeses",
"Netherlands" => "Països_Baixos",
"New Caledonia" => "Nova_Caledònia",
"New Zealand" => "Nova_Zelanda",
"Niger" => "Níger",
"Nigeria" => "Nigèria",
"None" => "Cap",
"Norfolk Island" => "Illa_Norfolk",
"North Korea" => "Corea_del_Nord",
"Northern Mariana Islands" => "Illes_Marianes_del_Nord",
"Norway" => "Noruega",
"Other" => "Altre/a",
"Palestine" => "Palestina",
"Panama" => "Panamà",
"Papua New Guinea" => "Papua_Nova_Guinea",
"Paraguay" => "Paraguai",
"Peru" => "Perú",
"Philippines" => "Filipines",
"Poland" => "Polònia",
"Puerto Rico" => "Puerto_Rico",
"Quatar" => "Qatar",
"Republic of Macedonia" => "Macedònia",
"Russia" => "Rússia",
"Russian Federation" => "Rússia",
"Saint Helena" => "Saint_Helena",
"Saint Kitts and Nevis" => "Saint_Christopher_i_Nevis",
"Saint Lucia" => "Saint_Lucia",
"Saint Pierre and Miquelon" => "Saint_Pierre_i_Miquelon",
"San Marino" => "San_Marino",
"Sao Tome and Principe" => "Sao_Tome_i_Príncipe",
"Saudi Arabia" => "Aràbia_Saudita",
"Serbia" => "Sèrbia",
"Sierra Leone" => "Sierra_Leone",
"Singapore" => "Singapur",
"Slovakia" => "Eslovàquia",
"Slovenia" => "Eslovènia",
"Solomon Islands" => "Illes_Solomó",
"Somalia" => "Somàlia",
"South Africa" => "Sud-àfrica",
"South Georgia and South Sandwich Islands" => "Illes_Geòrgia_del_Sud_i_Sandwich_del_Sud",
"South Korea" => "Corea_del_Sud",
"Spain" => "Espanya",
"Sri Lanka" => "Sri_Lanka",
"St Vincent Grenadines" => "St._Vincent_i_les_Grenadines",
"Svalbard and Jan Mayen" => "Svalbard_i_Jan_Mayen",
"Swaziland" => "Swazilàndia",
"Sweden" => "Suècia",
"Switzerland" => "Suïssa",
"Syria" => "Síria",
"Tajikistan" => "Tadjikistan",
"Tanzania" => "Tanzània",
"Thailand" => "Tailàndia",
"Trinidad Tobago" => "Trinitat_i_Tobago",
"Tunisia" => "Tunísia",
"Turkey" => "Turquia",
"Turks and Caicos Islands" => "Illes_Turks_i_Caicos",
"US Virgin Islands" => "Illes_Verge_Americanes",
"Ukraine" => "Ucraïna",
"United Arab Emirates" => "Unió_dels_Emirats_Àrabs",
"United Kingdom" => "Regne_Unit",
"United Nations Organization" => "Organització de les Nacions Unides",
"United States Minor Outlying Islands" => "Illes_Perifèriques_Menors_dels_EUA",
"United States" => "Estats_Units_(EUA)",
"United_Nations_Organization" => "Organització_de_les_Nacions_Unides",
"Uruguay" => "Uruguai",
"Vatican" => "Vaticà",
"Venezuela" => "Veneçuela",
"Viet Nam" => "Vietnam",
"Wallis and Futuna" => "Wallis_i_Futuna",
"Western Sahara" => "Sàhara_Occidental",
"World" => "Món",
"Yemen" => "Iemen",
"Yugoslavia" => "Iugoslàvia",
"Zambia" => "Zàmbia",
"MySQL classic (mysql)" => "MySQL clàssic (mysql)",
"Email address not valid, test mail not sent" => "Adreça de correu-e invàlida, no s'ha pogut enviar el correu-e de prova",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "Adreça de correu-e buida i la casella de verificació de \"copia\" no ha estat seleccionada, no s'ha enviat el correu-e de prova",
"Test mail from Tiki installer " => "Correu-e de prova des de l'instal·lador de Tiki ",
"Congratulations!\n\nYour server can send emails.\n\n" => "Felicitats!\n\nEl teu servidor pot enviar correus-e.\n\n",
"Arabic" => "Àrab",
"Catalan" => "Català",
"Simplified Chinese" => "Xinès Simplificat",
"Czech" => "Txec",
"Danish" => "Danès",
"German" => "Alemany",
"English" => "Anglès",
"English British" => "Anglès Britànic",
"Spanish" => "Castellà",
"Greek" => "Grec",
"Finnish" => "Finès",
"Fijian" => "Fijià",
"French" => "Francès",
"Galician" => "Gallec",
"Hebrew" => "Hebreu",
"Croatian" => "Croat",
"Italian" => "Italià",
"Japanese" => "Japonès",
"Korean" => "Coreà",
"Hungarian" => "Hongarès",
"Dutch" => "Dels Països Baixos",
"Norwegian" => "Noruec",
"Polish" => "Polonès",
"Português" => "Portuguès",
"Brazilian Portuguese" => "Portuguès-Brasiler",
"Russian" => "Rus",
"Pijin Solomon" => "Pidgin de les illes Salomó",
"Slovak" => "Eslovac",
"Serbian Latin" => "Serbi Llatí",
"Swedish" => "Suec",
"Tuvaluan" => "Tuvaluà",
"Traditional Chinese" => "Xinés traditional",
"Ukrainian" => "Ukranià",
"Permission denied" => "Permís denegat",
"Template %s not registered" => "Plantilla %s no registrada",
"The file is not a CSV file or has not a correct syntax" => "El fitxer no és del tipus CSV file o no té una sintaxi correcta",
"Error line: %d" => "Línia amb error: %d",
"Blog cannot be found" => "No es pot trobar la bitàcola",
"locked" => "bloquejat",
"locked by" => "bloquejat per",
"Administration:" => "Administració:",
"All day" => "Tot el dia",
"First day of week: Sunday (its ID is 0) - translators you need to localize this string!" => "1",
"Sunday" => "Diumenge",
"Su" => "Du",
"Monday" => "dilluns",
"Tuesday" => "Dimarts",
"Wednesday" => "Dimecres",
"Thursday" => "Dijous",
"Friday" => "divendres",
"Saturday" => "Dissabte",
"Mo" => "Dl",
"Tu" => "Dt",
"We" => "Dc",
"Th" => "Dj",
"Fr" => "Dv",
"Sa" => "Ds",
"in" => "a",
"continued" => "continuat",
"New Image Uploaded by" => "Nova imatge pujada per",
"New Subscriptions" => "Subscripcions noves",
"New Item in Tracker" => "Nova entrada al formulari",
"tracker" => "formulari",
"by" => "per",
"Image Gallery" => "Galeria d'imatges",
"Blogs" => "Bitàcoles",
"Forums" => "Fòrums",
"Directory" => "Directori",
"File Gallery" => "Galeria d'arxius",
"FAQs" => "PUFs",
"Quizzes" => "Qüestionaris",
"Trackers" => "Formularis",
"Survey" => "Enquesta",
"Newsletter" => "Butlletins",
"Empty captcha value" => "Valor buit anti-robots",
"Failed to validate captcha" => "Error en intentar validar el codi antirobots",
"Captcha ID field is missing" => "Manca el camp ID antirobots (captcha)",
"Get a visual challenge" => "Demana un desafiament visual",
"Get an audio challenge" => "Demana un desafiament auditiu",
"Get a new challenge" => "Demana un nou desafiament",
"Type the two words" => "Escriu les dues paraules",
"Type what you hear" => "Escriu el que et dirà la web",
"Help" => "Ajuda",
"Play sound again" => "Reprodueix el so de nou",
"Download sound as MP3" => "Descarrega el so com a MP3",
"blog" => "bitàcola",
"directory" => "directori",
"faq" => "pmf",
"file gallery" => "galeria d'arxius",
"forum" => "fòrum",
"image gallery" => "galeria d'imatges",
"newsletter" => "butlletí",
"poll" => "consultes",
"quiz" => "qüestionari",
"survey" => "enquesta",
"wiki page" => "pàgina wiki",
"image" => "imatge",
"calendar" => "calendari",
"Invalid filename (using filters for filenames)" => "Nom d'arxiu Invàlid (usant filtres per a noms d'arxius)",
"Cannot upload this file - maximum upload size exceeded" => "No es pot pujar aquest arxiu , supera el límit màxim de mida",
"(not registered)" => "(no registrat)",
"Anonymous" => "Anònim/a",
"Please wait %d seconds between posts" => "Si us plau, espera %d segons entre publicacions",
"Wrong password. Cannot post comment" => "Contrasenya errònia. No pots publicar el comentari",
"A contribution is mandatory" => "És necessari especificar algun tipus de contribució",
"You have to enter a title and text" => "Has d'introduir un títol i text",
"Invalid Email" => "Correu-e invàlid",
"Your message has been queued for approval and will be posted after a moderator approves it." => "El teu missatge ha estat posat a la qua de moderació per ser aprovat; es publicarà el missatge quan un moderador l'aprovi.",
"This forum is locked" => "Aquest fòrum està bloquejat",
"This thread is locked" => "Aquest fil de discussió està bloquejat",
"Those comments are locked" => "Aquests comentaris estan bloquejats",
"Create page:" => "Crea pàgina:",
"Set" => "Configurar",
"Plugin disabled" => "Connector (plugin) desactivat",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::applica: manca de coincidència del contador de línies: %s != %s",
"WikiDiff::_check: failed" => "WikiDiff::_check: error",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: la seqüència d'edició no és óptima",
"WikiDiff Okay: LCS = %s" => "WikiDiff Ok: LCS = %s",
"Line:" => "Línia:",
"Lines:" => "Línies:",
"Cannot open this file:" => "No puc obrir aquest arxiu:",
"File Galleries" => "Galeries d'arxius",
"Reason: The global quota has been reached" => "Raó: S'ha arribat al maxim de quota permès",
"Reason: The quota has been reached in \"%s\"" => "Raó: S'ha arribat al maxim de quota permès en \"%s\"",
"File gallery quota exceeded" => "S'ha excedit la quota de la galeria d'arxius",
"This is the value of your server's PHP '%s' setting" => "Aquest és el valor de la configuració PHP '%s' del teu servidor",
"You are alerted by the server " => "Estàs alertat pel servidor ",
"You can check the modifications at : " => "Pots comprovar les modificacions a : ",
"You are alerted of a change on " => "Està alertat de canvis sobre ",
"Wiki Home" => "Inici del Wiki",
"Home" => "Inici",
"Blog" => "Bitàcola",
"previous page" => "pàgina anterior",
"next page" => "pàgina següent",
"posted on" => "publicat el",
"Continue" => "Continúa",
"By:" => "Per",
"Read" => "Llegeix",
"List articles" => "Llistar articles",
"Last post" => "Darrer enviament",
"Invalid imagename (using filters for filenames)" => "Invàlid nom d'imatge (usant filtres per a noms d'arxius)",
"Errors detected" => "Errors detectats",
"Upload was not successful" => "La pujada no s'ha realitzat amb èxit",
"No image yet, sorry." => "Ho sento, encara no hi ha cap imatge.",
"unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "directori de destinació desconegut. Configura'l a <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
"unlink failed" => "no s'ha pogut treure l'enllaç",
"Contributions" => "Contribucions",
"Query point:" => "Punt de la consulta:",
"layer:" => "capa:",
"Record:" => "Registre:",
"This feature is disabled" => "Aquesta característica està deshabilitada",
"No valid ogr2ogr executable" => "No hi ha cap executable ogr2ogr vàlid",
"Could not create \$tdo.mif in data directory" => "No s'ha pogut crear \$tdo.mif en el directori de dades",
"Could not create \$tdo.mid in data directory" => "No s'ha pogut crear \$tdo.mid en el directori de dades",
"unknown" => "desconegut",
"User Map Generated in:" => "Mapa d'usuaris generat a:",
"Image Map Generated in:" => "Mapa d'imatges generat a:",
"You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it." => "Només pots utilitzar optionId = 0 per crear una nova opció, o optionId igual a una id que ja pertanyi al menú per actualitzar-la.",
"menu" => "menú",
"NONE" => "CAP",
"for month of" => "per al més de",
"for" => "per a",
"for week of" => "per a la setmana de",
"Integer (i)" => "Sencer / Interger (i)",
"Percentage (%)" => "Percentatge (%)",
"Float (f)" => "Flotant / Float (f)",
"List (L)" => "Llista (L)",
"Daily (+)" => "Diari (+)",
"Monthly and weekly (@)" => "Menusal i setmanal (@)",
"Weekly (-)" => "Setmanal (-)",
"File %s not found" => "No s'ha trobat l'arxiu %s ",
"File %s is not a valid archive" => "L'arxiu %s no és un arxiu vàlid",
"Impossible to open %s : %s" => "Impossible obrir %s : %s",
"The content retrieved at %s is not a list of mods" => "El contingut recuperat a %s no és una llista de mods",
"Can't chdir to '%s'" => "No es pot chdir a '%s'",
"%s impossible to remove" => "No es pot eliminar %s",
"Description not available" => "No hi ha descripció disponible",
"Module Title" => "Títol del mòdul",
"No box" => "Sense caixa",
"Show only the content" => "Mostra només el contingut",
"Decorations" => "Decoracions",
"Show module decorations" => "Mostra les decoracions dels mòduls",
"No title" => "Cap títol",
"Show module title" => "Mostra el títol del mòdul",
"Perspective" => "Perspectiva",
"Language" => "Llenguatge",
"Section" => "Secció",
"No Page" => "Cap pàgina",
"Theme" => "Tema",
"Flip" => "Permet amagar-lo",
"No numbers" => "Sense números",
"Rows" => "Files",
"Newsletter subscription information at" => "La informació de subscripció a butlletins es troba a",
"OK" => "D'acord",
"invalid email" => "email no vàlid",
"Sending to" => "Enviant-ho a",
"section edit" => "secció edició",
"Product" => "Producte",
"Quantity" => "Quantitat",
"Unit Price" => "PReu unitari",
"Cclite payment initiated on %0" => "Pagament via cclite iniciat el %0",
"Connection to cclite server %0 failed for %1<br />\"%2\"" => "La connexió al servidor de cclite %0 ha fallat per %1<br />\"%2\"",
"Tiki credits payment done on %0 for \$amount (using \$creditType)" => "El pagament amb crèdits de Tiki s'ha efectuat el %0 per \$amount (emprant \$creditType)",
"Users accept internal messages by default" => "Els usuaris poden acceptar missatges interns per defecte",
"Newest first" => "Primer els més nous",
"ascending" => "ascendent",
"descending" => "descendent",
"Topic" => "Tema",
"Title" => "Títol",
"Title length" => "Longitud del Títol",
"Publication date" => "Data de publicació",
"Expiration date" => "Data de caducitat",
"User" => "Usuari",
"Author" => "Autor",
"Reads" => "Lectures",
"Images" => "Imatges",
"Top" => "Dalt",
"Oldest first" => "Els més antic primer",
"Points" => "Punts",
"Authentication method" => "Mètode d'Autentificació",
"Tiki and PAM" => "Tiki i PAM",
"CAS (Central Authentication Service)" => "CAS (Servei Central d'Autenticació)",
"Web Server" => "Servidor Web",
"All" => "Tots",
"Creation Date (desc)" => "Data de creació (desc)",
"Last modification date (desc)" => "Data de l'última modificació (desc)",
"Blog title (asc)" => "Títol de la bitàcola (asc)",
"Number of posts (desc)" => "Nombre de publicacions (desc)",
"Visits (desc)" => "Visites (desc)",
"Activity (desc)" => "Activitat (desc)",
"Creation date" => "Data de creació",
"Last modified" => "Darrers canvis",
"Disabled" => "Deshabilitades",
"Plain text" => "Correu-e en text senzill",
"Link to user information" => "Enllaç a la informació d'usuari",
"User avatar" => "Avatar de l'usuari/a",
"Posts" => "Publicacions",
"Visits" => "Visites",
"Activity" => "Activitat",
"Default view mode" => "Mode de vista per defecte",
"Day" => "Dia",
"Week" => "Setmana",
"Month" => "Mes",
"Quarter" => "Quadrimestre",
"Semester" => "Semestre",
"Year" => "Any",
"First day of the week" => "Primer dia de la setmana",
"Depends user language" => "Depèn de l'idioma de l'usuari",
"Split hours in periods of" => "Divideix hores en períodes de",
"1 minute" => "1 minut",
"5 minutes" => "5 minuts",
"10 minutes" => "10 minuts",
"15 minutes" => "15 minuts",
"30 minutes" => "30 minuts",
"CAS server version" => "versió del servidor CAS",
"none" => "cap",
"Version 1.0" => "Versió 1.0",
"Version 2.0" => "Versió 2.0",
"Never" => "Mai",
"1 hour" => "1 hora",
"Users can change theme" => " Els usuaris registrats poden canviar el tema",
"Contact user" => "Usuari de contacte",
"Count admin pageviews" => "Compta visualitzacions de pàgines per l'admin",
"default mapfile" => "arxiudemapa per defecte",
"Only with last version" => "Només amb la darrera versió",
"HTML diff" => "Diferències en HTML",
"Side-by-side diff" => "Diferències costat-a-costat",
"Side-by-side diff by characters" => "Diferències costat a costat per caràcters",
"Inline diff" => "Diferències en línia",
"Inline diff by characters" => "Diff en línia per caràcters",
"Full side-by-side diff" => "Diferències en tot costat-a-costat",
"Full side-by-side diff by characters" => "Diff costat-a-costat sencer per caràcters",
"Full inline diff" => "Diff en línia sencer",
"Full inline diff by characters" => "Diff en línia sencer per caràcters",
"Unified diff" => "Diferències unificades",
"Side-by-side view" => "Vista costat-a-costat",
"rows" => "línies",
"Forum" => "Fòrum",
"Advanced" => "Avançat",
"Use direct pagination links" => "Empra enllaços directes de paginació",
"Show Country Flag" => "Mostra la bandera del país",
"Validate URLs" => "Validació de URLs",
"Links per page" => "Enllaços per pàgina",
"Method to open directory links" => "Mètode per obrir el directori d'enllaços",
"replace current window" => "susbtitueix la finestra actual",
"new window" => "nova finestra",
"inline frame" => "marc en línia",
"Fields display order" => "Ordenació per mostrar els camps",
"days" => "dies",
"Use \"-1\" for never" => "Empra \"-1\" per a mai",
"PHP errors visible to admin only" => "Errors PHP visibles només a admins",
"PHP Error reporting level" => "Nivell d'informes d'errors PHP",
"No error reporting" => "Sense informes d'errors",
"Report all PHP errors except strict" => "Informa de tots els errors PHP menys els de regles estrictes",
"Report all PHP errors" => "Informar de tots els errors de PHP",
"Report all PHP errors except notices" => "Informa de tots els errors PHP menys els d'avisos",
"According to PHP configuration" => "Segons la configuració del PHP",
"Default number of comments per page" => "Nombre per defecte de comentaris per pàgina",
"Comments default ordering" => "Ordre per defecte dels comentaris",
"Question and Answer prefix on Answers" => "Prefix de pregunta i resposta a les respostes",
"Q and A" => "P i R",
"Question ID" => "Identificador de pregunta",
"Faqs" => "Pufs (faqs)",
"Force and limit categorization to within subtree of" => "Força i limita la categorització a dins del subarbre de",
"Polls" => "Consultes",
"Newsletters" => "Butlletins",
"Calendar" => "Calendari",
"Banners" => "Pancartes",
"Category" => "Categoria",
"Score" => "Puntuació",
"Freetags" => "Etiquetes lliures",
"Action Log" => "Registre d'accions",
"Contribution" => "Contribucions (tipus)",
"Multilingual" => "Multilingualitat",
"FAQ" => "PUF",
"Surveys" => "Enquestes",
"Featured links" => "enllaços suggerits",
"Shoutbox" => "Quadre d'avisos",
"Maps" => "Mapes",
"Google Maps" => "Mapes de Google",
"Live support system" => "Sistema de suport en directe",
"Tell a Friend" => "Digues-li a les teves amistats",
"Contact Us" => "Contacta'ns",
"PHPLayers" => "CapesPHP",
"HTML Purifier" => "Purificador d'HTML",
"Mobile" => "Mòbil",
"Morcego 3D browser" => "Navegador 3D Morcego",
"Webmail" => "CorreuWeb",
"Mail-in" => "Correu-in",
"Wysiwyg editor" => "Editor Wysiwyg",
"Friendship Network" => "Xarxa d'amistats",
"Banning system" => "Sistema de prohibició",
"Stats" => "Estadístiques",
"Referer Stats" => "Estadístiques de referenciadors",
"Redirect On Error" => "Redirigeix en trobar Errors",
"Communications (send/receive objects)" => "Comunicacions (enviar/rebre objectes)",
"Custom Home" => "Personalitzar Inici",
"Mini Calendar" => "Mini Calendari",
"User Preferences Screen" => "Pantalla de preferències d'usuari/a",
"User Notepad" => "Bloc de notes de l'usuari",
"User Bookmarks" => "Adreces d'interès de l'usuari",
"User Contacts" => "Contactes d'usuari",
"User Watches" => "Avisos d'usuari/a",
"Daily Reports for User Watches" => "Informes diaris per a notificacions d'usuari",
"User Watches Translations" => "L'usuari vigila les traduccions",
"User Menu" => "Menú d'Usuari ",
"User Tasks" => "Tasques d'usuari",
"User Messages" => "Missatges d'usuari",
"User Files" => "Arxius d'Usuari",
"Integrator" => "Integrador",
"Debugger Console" => "Consol·la Depuradora",
"Protect against CSRF with a ticket" => "Protegir contra CSRF amb un tiquet",
"Detect browser language" => "Detecta l'idioma del navegador",
"Multilingual structures" => "Estructures Multilíngües",
"Help System" => "Ajuda del Sistema",
"Smileys" => "Emoticons",
"Dynamic Content System" => "sistema contingut Dinàmic",
"Display menus as folders" => "Mostra menús com a carpetes",
"Protect email against spam" => "Protegeix el correu-e contra el correu brossa",
"Activate" => "Activa",
"Search engine friendly url" => "URLs amigables als cercadors",
"Search and replace" => "Cerca i reemplaça",
"Submissions" => "Col·laboracions",
"Rankings" => "Posicions",
"Content Templates" => "Plantilles de contingut",
"Print" => "Multi-Impressió",
"Category Path" => "Ruta a la categoria",
"Ignore category viewing restrictions" => "Ignora les restriccions de visualització de categories",
"List pages" => "Llistar pàgines",
"Last changes" => "Últimes modificacions",
"Orphan pages" => "Pàgines òrfenes",
"Referer Search Highlighting" => "Ressaltat dels referenciadors de les cerques",
"Search stats" => "Estadístiques de les cerques",
"Ignore individual object permissions" => "Ignora els permisos individuals dels objectes",
"Search box" => "Cerca",
"Object type" => "Tipus d'objecte",
"Accept wiki syntax" => "Aceptar sintaxi-wiki",
"tikihash (old)" => "tikihash (vell)",
"Edit CSS" => "Edita CSS",
"Theme Control" => "Control de Temes",
"Tiki Template Viewing" => "Visualització de plantilles del Tiki",
"Edit Templates" => "edita plantilles",
"Custom Site Header" => "Capçalera del Lloc Adaptada",
"Site menu bar" => "Barra del menú del lloc",
"Menu ID" => "ID del Menu",
"Top Bar" => "Barra de Dalt",
"Left column" => "Columna esquerra",
"Always" => "Sempre",
"Site location bar" => "Barra de localització del lloc",
"Larger font for" => "Font més gran per a",
"Page name" => "Nom de la pàgina",
"Use page description" => "Empra descripció de la pàgina",
"Custom Site Footer" => "Barra al peu Adaptada del Lloc",
"Bottom bar" => "Barra al peu",
"Bottom bar icons" => "Icones de la barra al peu",
"Bottom bar debug" => "Barra del peu de depuració",
"Webmaster Report" => "Informa al Mestre de la Web",
"Webmaster Email" => "Correu-e del Mestre de la Web",
"Email this page" => "Envia aquesta pàgina per Correu-e",
"Use Tabs" => "Empra tabuladors",
"Content templates" => "Plantilles de contingut",
"Warn on edit conflict" => "Conflicte d'avís en editar",
"Undo" => "Desfès",
"Footnotes" => "Notes al peu",
"Allow HTML" => "Permetre HTML",
"Sandbox" => "LlocdeProves",
"Pictures" => "Fotos",
"Export" => "Exporta",
"Link plural WikiWords to their singular forms" => "Enllaç plural a les WikiParaules als seus formularis particulars",
"Accept dashes and underscores in WikiWords" => "Accepta guions normals (-) i guions baixos (_) en ParaulesWiki",
"History" => "Historial",
"Discuss pages on forums" => "Pàgines de Debat als fòrums",
"Rating" => "Puntuació",
"Structures" => "Estructures",
"Open page as structure" => "Obre la pàgina com una estructura",
"Make structure from page" => "Fes estructura a partir de la pàgina",
"Categorize structure pages together" => "Categoritza les pàgines de l'estructura totes juntes",
"Create webhelp from structure" => "Crea ajuda web a partir de l'estructura",
"Import HTML" => "Importar HTML",
"UserPage prefix" => "Prefix per a la PlanaUsuari",
"MultiPrint" => "MultiImpressió",
"Use wiki page staging and approval" => "Empra les pàgines Wiki en mode de pendents de revisió i aprovació",
"Attachments" => "Afegits",
"Dumps" => "Buidats",
"Use challenge/response authentication" => "Empra autenticació de repte/resposta",
"Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines." => "Com la funcionalitat de formatació de paràgrafs Wiki està activada, tots els grups de línies que no estiguin en blanc són agrupades en paràgrafs.  Les línies poden ser de qualseovl longitud, i seran formatades juntes amb la següent línia.  Els paràgrafs es separen amb línies en blanc.",
"Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "Com la funcionalitat de formatació de paràgrafs Wiki està desactivada, cada línia es mostrarà tal i com l'escriguis. Això vol dir que si vols que els paràgrafs es formatin correctament, un paràgraf ha d'estar tot ell en una sola línia.",
"Automonospaced text" => "Text Automonoespaiat",
"Tables syntax" => "Sintaxi de taules",
"|| for rows" => "|| per files",
"<return> for rows" => "\n for rows",
"AutoLinks" => "Autoenllaços",
"Hotwords" => "Paraules calentes",
"Gender" => "Gènere",
"Number of friends" => "Nombre d'amics/gues",
"Country" => "País",
"E-mail" => "Correu electrònic",
"Last login" => "Última connexió",
"Distance" => "Distància",
"Display 'MyTiki' in the application menu" => "Mostra 'ElMeuTiki' al menú de l'aplicació",
"seconds" => "segons",
"Image galleries" => "Galeries d'imatges",
"File galleries" => "Galeries d'arxius",
"Calendar events" => "Esdeveniments del Calendari",
"Directories" => "Directoris",
"Maximum number of items to display" => "Màximu nombre d'ítems per mostrar",
"The server must be able to read/write the directory." => "El servidor ha de poder llegir/escriure el directori.",
"The directory can be outside the web space." => "El directori pot ser fora de l'espai web.",
"Allow same file to be uploaded more than once" => "Permet que es pugui pujar el mateix arxiu més d'un cop",
"Yes, even in the same gallery" => "Sí, fins i tot a la mateixa galeria",
"Only in different galleries" => "Només en galeries diferents",
"Mb" => "MegaOctets (Mb)",
"Storage" => "Emmagatzematge",
"Uploaded filenames must match regex" => "Els arxius penjats han de coincidir amb aquesta regex ",
"Plain" => "Senzill",
"Threaded" => "Per fils de discussió",
"Headers Only" => "Només capçaleres",
"Title (desc)" => "Títol (desc)",
"Title (asc)" => "Títol (asc)",
"Topics" => "Temes",
"Posts per day" => "Publicacions per dia",
"Creation Date (asc)" => "Data de creació (asc)",
"Topics (desc)" => "Temes (desc)",
"Threads (desc)" => "Missatges (desc)",
"Last post (desc)" => "Últim post (desc)",
"Name (desc)" => "Nom (desc)",
"Name (asc)" => "Nom (asc)",
"Browser width" => "Amplada del navegador",
"Browser height" => "Alçada del navegador",
"Navigation depth" => "Profunditat de navegació",
"Node size" => "Mida del node",
"Text size" => "Mida del text",
"Spring (connection) size" => "Mida (de la connexió) de la molla",
"Existing page node color" => "Color de node d'una pàgina existent",
"Missing page node color" => "Falta color del node de pàgina",
"Camera distance adjusted relative to nearest node" => "La distància a la càmera s'ajusta en funció del node més proper",
"Camera distance" => "Distància a la càmera",
"Field of view" => "Camp de vista",
"Feed animation interval (milisecs)" => "Interval d'animació del canal (milisegons)",
"Friction constant" => "Constant de fricció",
"Elastic constant" => "Constant elàstica",
"Eletrostatic constant" => "Constant electrostàtica",
"Node mass" => "Massa del node",
"Node charge" => "Càrrega del node",
"Browser title" => "Títol (finestra del navegador)",
"Home page" => "Pàgina Principal",
"Use group homepages" => "Empra pàgines d'inici de grup",
"Go to group homepage only if login from default homepage" => "Ves a la pàgina de grup només si la connexió es fa des de la pàgina inicial per defecte",
"Temporary directory" => "Directori temporal",
"Help URL" => "URL d'Ajuda",
"Open external links in new window" => "Obrir enllaços externs en una finestra nova",
"Full path to gdaltindex" => "Ruta sencera al gdaltindex",
"Full path to ogr2ogr" => "Camí complet a ogr2ogr",
"Map Zone" => "Zona del Mapa",
"Display modules to all groups always" => "Mostra sempre els mòduls a tots els grups",
"Hide anonymous-only modules from registered users" => "Amaga els mòduls per a anònims dels usuaris registrats",
"Subtitle" => "Subtítol",
"Maximum number of records in listings" => "Quantitat màxima de registres en llistats",
"Users can register" => "Els usuaris es poden registrar",
"Remember me" => "Recorda'm",
"Duration" => "Durada",
"minutes" => "minuts",
"hour" => "hora",
"hours" => "hores",
"day" => "dia",
"week" => "setmana",
"month" => "mes",
"year" => "any",
"Custom home" => "Inici personalitzat",
"User's choice" => "Elecció de l'usuari",
"Default x for map center" => "Coordenada x per defecte per al centre del mapa",
"Default zoom level" => "Nivell de zoom per defecte",
"whole earth" => "tota la Terra",
"country size" => "mida de país",
"city size" => "mida de ciutat",
"max zoom" => "zoom màxim",
"Home Blog (main blog)" => "Bitàcola Inicial (principal)",
"Home Forum (main forum)" => "Fòrum Inicial (principal)",
"Home Gallery (main gallery)" => "Galeria principal",
"HTTP port" => "Port HTTP",
"HTTPS port" => "Port HTTPS",
"Allow secure (https) login" => "Permet connexió segura (https)",
"Encourage secure (https) login" => "Anima a emprar connexió segura (https)",
"Consider we are always in HTTPS, but do not check" => "Considera que som sempre en HTTPS, però no comprovis",
"Require secure (https) login" => "Requereix connexió segura (https)",
"Fade" => "Esvaeix",
"Direction" => "Direcció",
"Horizontal" => "Horitzontal",
"Left" => "Cap a l'esquerra",
"Right" => "Cap a la dreta",
"Up" => "Cap a dalt",
"Down" => "Cap avall",
"Use database for translation" => "Empra base de dades per a la traducció",
"Layout per section" => "Format per secció",
"Smarty Template usage indicator" => "Indicador d'ús de Plantilles Smarty",
"Add HTML comment at start and end of each Smarty template (TPL)" => "Afegeix comentaris HTML a l'inici i final de cada plantilla Smarty (TPL)",
"Long date format" => "Format llarg de data",
"Long time format" => "Format llarg d'hora",
"%A %d of %B, %Y" => "%A %d de %B, %Y",
"CRLF (standard)" => "CRLF (estàndard)",
"LF (some Unix MTA)" => "LF (alguns MTA Unix)",
"full path to mapfiles" => "ruta sencera als mapfiles",
"Wiki Page for Help" => "Plana Wiki d'Ajuda",
"Wiki Page for Comments" => "Plana Wiki per Comentaris",
"Maximum mailbox size (messages, 0=unlimited)" => "Mida màxima de la bústia de correu-e (missatges, 0=sense límit)",
"Maximum mail archive size (messages, 0=unlimited)" => "Mida màxima dels arxius de correu-e (missatges, 0=sense límit)",
"Maximum sent box size (messages, 0=unlimited)" => "Mida màxima de la bústia de sortida (missatges, 0=sense límit)",
"geo.position" => "geo.posició",
"geo.region" => "geo.regió",
"geo.placename" => "geo.nomdellloc",
"Use relative (next / previous) pagination links" => "Empra enllaços relatius de paginació (següent / previ)",
"Bottom" => "Fons",
"Display fast move links (by 10 percent of the total number of pages) " => "Mostra enllaços per moure's ràpid (per 10 per cent del nombre total de pàgines) ",
"Use Icons" => "Empra Icones",
"Display 'First' and 'Last' links" => "Mostra Enllaços 'Primer/a' i 'Darrer/a'",
"PAM service" => "Servei PAM",
"Currently unused" => "No utilitzat actualment",
"Email address" => "Adreça de correu-e",
"Wiki page" => "Plana Wiki",
"Show categories" => "Mostra categories",
"Show objects" => "Mostra objectes",
"Host name" => "Nom de l'hoste",
"Proxy port" => "Port del Proxy",
"Quantify change size" => "Quantifica la mida del canvi",
"Record untranslated strings" => "Registre no traduït",
"Restrict supported languages" => "Restringeix els idiomes suportats",
"Refresh rate" => "Temps de refresc",
"Minimum length of search word" => "Llargada mínima de mot a cercar",
"Max. number of words containing a syllable" => "Nombre màxim de mots que continguin una síl·laba",
"Max. age in hours of syllable search cache" => "Temps màxim (en hores) de la recerca al caxé",
"LRU list purging rate" => "Valoració de la purga de llista LRU",
"LRU list length" => "llargada de llista LRU",
"Entire site" => "Lloc complet",
"Wiki Pages" => "Pàgines del wiki",
"Sender email" => "correu-e de l'enviador",
"Database" => "Base de Dades",
"Short date format" => "Format curt de data",
"Short time format" => "Format curt d'hora",
"After" => "Després de",
"Before" => "Abans de",
"image/png" => "imatge/png",
"image/bmp" => "imatge/bmp",
"image/x-icon" => "imatge/x-icon",
"Publish" => "Publica",
"Center" => "Centra",
"Alt. description (e.g. for text browsers)" => "Descripció alt. (p.e. per navegadors basats en text)",
"Modified" => "Modificat",
"Check frequency" => "Freqüència de comprovació",
"Each day" => "Cada dia",
"Each week" => "Cada setmana",
"Each month" => "Cada mes",
"Account validated successfully." => "Compte validat satisfactòriament.",
"Use proxy" => "Empra proxy",
"Users can configure modules" => "Els usuaris poden configurar mòduls",
"Sort Order" => "Ordenació",
"Score ascending" => "Ascendent per puntuació",
"Score descending" => "Descendent per puntuació",
"Name ascending" => "Ascendent per Nom de l'Usuari",
"Name descending" => "Descendent per Nom de l'Usuari",
"Login ascending" => "Ascendent per Nom de Connexió d'usuari",
"Login descending" => "Descendent per Nom de Connexió d'usuari",
"Displayed time zone" => "Zona horària mostrada",
"Number of visited pages to remember" => "Quantitat de pàgines visitades a recordar",
"User information" => "Informació d'usuari/a",
"Private" => "Privat",
"Public" => "Públic",
"Use double-click to edit pages" => "Empra doble-clic per editar pàgines",
"Tasks per page" => "Tasques per pàgina",
"Messages per page" => "Missatge per pàgina",
"Allow messages from other users" => "Permetre missatges d'altres usuaris",
"Send me an email for messages with priority equal or greater than" => "Envia'm un email per els missatges amb prioritat més gran o igual que",
"My pages" => "Les meves pàgines",
"My blogs" => "Les meves bitàcoles",
"My galleries" => "Les meves galeries",
"My messages" => "Els meus missatges",
"My tasks" => "Les meves tasques",
"My forum topics" => "Els meus tòpics de fòrums",
"My forum replies" => "Les meves respostes de fòrums",
"My items" => "Els meus ítems",
"Show user's info on mouseover" => "Mostra la informació de l'usuari en passar el punter del ratolí per sobre",
"Edit idle timeout" => "edita temps de desconnexió",
"Allow viewing HTML mails?" => "Permetre veure correus en HTML?",
"Maximum size for each attachment" => "Mida màxima per cada afegit",
"Unlimited" => "Il·limitat",
"LastModif" => "Última modificació",
"Last editor" => "Darrer editor",
"Complete" => "Complet",
"Business style" => "Estil de Negocis",
"Collaborative style" => "Estil col·laboratiu",
"Page last modified on" => "Darrera modificació de la pàgina el",
"Both" => "Ambdues coses",
"Cache wiki pages (global)" => "Posar les pàgines wiki en memòria cau (global)",
"no cache" => "Sense memòria cau",
"minute" => "minut",
"Disable" => "Deshabilita",
"Dynamic variables" => "variables Dinàmiques",
"Page creators are admin of their pages" => "Els creadors de pàgines en son els adminsitradors",
"Create watch for author on page creation" => "L'autor vigila la pàgina en crear-la",
"Enable watches on comments" => "Permet vigilar comentaris",
"Enable watch events when I am the editor" => "Permet vigilar canvis quan sóc l'editor",
"Last modification date" => "Data de la darrera modificació",
"Last modified by" => "Darrera modicicació per",
"Version" => "Versió",
"Status" => "estat",
"Links" => "Enllaços",
"Categories path" => "Ruta de les categories",
"Default sort order" => "Ordre d'ordenació per defecte",
"Descending" => "Descendent",
"Ascending" => "Ascendent",
"Enable wiki 3D browser" => "Activa el navegador Wiki 3D",
"Load page on navigation" => "Carrega la pàgina en navegar per ella",
"Delete staging pages at approval" => "Esborra les pàgines per revisar en aprovar-les",
"Unique page name prefix to indicate staging copy" => "Prefix únic per al nom de les pàgines per indicar que és una còpia per revisar",
"Hide page name prefix" => "Amaga el prefix del nom de la pàgina",
"Categorize approved pages with categories of staging copy on approval" => "Categoritza les pàgines aprovades amb les categories de la còpia per revisar en ser aprovades",
"Add new freetags of approved copy (into tags field) when editing staging pages" => "Afegeix noves etiquetes lliures de les còpies aprovades (en el camp d'etiquetes) quan s'estigui editant còpies per revisar",
"If not in the group, edit is always redirected to the staging page edit" => "Si no és al grup, l'edició és sempre redireccionada a l'edició de la pàgina per revisar",
"Wysiwyg Editor is optional" => "L'editor Wysiwyg és opcional",
"Reopen with the same editor" => "Reobre amb el mateix editor",
"Content is parsed like wiki page" => "El contingut és processat com una pàgina Wiki",
"Username" => "Nom d'usuari",
"Password" => "Contrasenya",
"Security" => "Seguretat",
"Created by profile installer" => "Creat per l'instal·lador de perfils",
"Page updated by profile installer" => "Pàgina actualitzada per l'instal·lador de perfils",
"Page cannot be found" => "No s'ha pogut trobar la pàgina",
"Wiki top pages" => "Planes Wiki més actives",
"Most relevant pages" => "Pàgines més rellevants",
"Relevance" => "Rellevancia",
"Wiki last pages" => "Darreres pàgines Wiki",
"Forums last posts" => "Fòrums: darrers enviaments",
"Topic date" => "Data de tòpic",
"Forums most read topics" => "Temes més llegits dels Fòrums",
"Forums best topics" => "Fòrums: millors temes",
"Forums most visited forums" => "Fòrums més visitats",
"Forums with most posts" => "Fòrums amb més escrits",
"Wiki top galleries" => "Galeries d'imatges Wiki més actives",
"Wiki top file galleries" => "Galeries de fitxers Wiki més actives",
"Wiki top images" => "Imatges Wiki més visitades",
"Wiki top files" => "Fitxers Wiki més vists",
"Downloads" => "Descàrregues",
"Wiki last images" => "Darreres imatges Wiki",
"Upload date" => "Data de pujada",
"Wiki last files" => "Darrers fitxers Wiki",
"Top articles" => "Articles més llegits",
"Most visited blogs" => "Bitàcoles més visitades",
"Most active blogs" => "Bitàcoles s més actives",
"Blogs last posts" => "Darrers enviaments a la Bitàcola",
"Post date" => "Data de publicació",
"Wiki top authors" => "Autors Wiki més actius",
"Pages" => "Pàgines",
"Top article authors" => "Els autors d'articles més actius",
"Registered" => "Enregistrats/des",
"You must choose a group" => "Has d'escollir un grup",
"You will receive an email with information to login for the first time into this site" => "Rebràs un correu-e amb informació per entrar per primera vegada en aquest lloc",
"Password is required" => "Contrasenya requerida",
"The passwords don't match" => "Les contrasenyes no coincideixen",
"User already exists" => "Aquest usuari ja existeix",
"Invalid username" => "El nom de l'usuari no és vàlid",
"Username is too long" => "El nom de l'usuari és massa llarg",
"Username cannot contain uppercase letters" => "El nom d'usuari no pot contenir majúscules",
"Username must be at least" => "El nom d'usuari ha de ser com a mínim de ",
"characters long" => "caràcters de llarg com a mínim",
"Username cannot contain more than" => "El nom d'usuari no pot contenir més de ",
"characters" => "caràcters",
"Wrong passcode. You need to know the passcode to register at this site" => "Codi de registre no vàlid. Necessites saber el codi de registre per donar-te d'alta en aquest lloc web",
"uploaded the file" => "ha pujat l'arxiu",
"change" => "canvi",
"changes" => "canvis",
"No changes" => "Sense canvis",
"Yesterday" => "Ahir",
"Today" => "Avui",
"and" => "i",
"changed the picture gallery" => "ha canviat la galeria de fotos",
"uploaded the picture" => "ha pujat la foto",
"onto" => "sobre",
"removed the picture" => "ha eliminat la foto",
"from" => "des de",
"edited the wikipage" => "ha editat la pàgina wiki",
"this history" => "aquests canvis",
"all history" => "canvis fins avui",
"edited the file gallery" => "ha editat la galeria d'arxius",
"removed the file" => "ha eliminat aquest arxiu",
"created the subcategory" => "ha creat la subcategoria",
"removed the subcategory" => "ha eliminat la subcategoria",
"edited the category" => "ha editat la categoria",
"removed the article" => "ha eliminat l'article",
"created the article" => "ha creaat l'article",
"edited the article" => "ha editat l'article",
"replied to the blog" => "ha respost a la bitàcola",
"created the topic" => "ha creat el tòpic",
"at forum" => "al fòrum",
"replied" => "ha respost",
"to the topic" => "al tòpic",
"Login" => "Connecta't",
"See other users' profiles" => "Mira el perfil dels altres usuaris",
"Have your profile seen" => "Tingues el teu perfil visible",
"Make friends" => "Fes amistats",
"Receive message" => "Rep missatge",
"Send message" => "Envia missatge",
"Read an article" => "Llegeix un article",
"Publish an article" => "Publica un article",
"Have your article read" => "Tingues el teu article llegit",
"Create New File Gallery" => "Crea una Nova Galería d'Arxius",
"Upload new file to gallery" => "Puja un arxiu nou a la galeria",
"Download other user's file" => "Descarrega l'arxiu d'altres usuaris",
"Have your file downloaded" => "Tingues el teu arxiu descarregat",
"Create a new image gallery" => "Crea una nova galeria d'imatges",
"Upload new image to gallery" => "Puja una nova imatge a la galeria",
"See other users' galleries" => "Mira la galaeria d'altres usuaris",
"See other users' images" => "Mira la imatge d'altres usuaris",
"Have your gallery seen by other users" => "Tingues la teva galeria vista per altres usuaris",
"Have your image seen" => "Tingues la teva imatge vista",
"Create new blog" => "Crea una bitàcola nova",
"Post in a blog" => "Publica en una bitàcola",
"Read other users' blogs" => "Llegeix la bitàcola d'altres usuaris",
"Have your blog read" => "Tingues la teva bitàcola llegida",
"Create a new wiki page" => "Crea una nova pàgina wiki",
"Edit an existing page" => "Edita una pàgina existent",
"Attach file" => "Adjuntar arxiu",
"Wiki Comment" => "Comentari Wiki",
"Calendar item" => "Ítem del Calendari",
"Gallery" => "Galeria",
"Image" => "Imatge",
"Blog post" => "Publicació de Bitàcola",
"Tracker item" => "Item del formulari",
"Tracker" => "Formulari",
"Unknown" => "Desconegut/da",
"Trackeritem" => "Ítemdeformulari",
"Directory category" => "Directori de la categoria",
"For you to vote, cookies must be allowed" => "Les galetes haurien de tenir dret al vot",
"This poll is closed." => "Consulta tancada.",
"Last articles." => "Els últims articles.",
"Tiki RSS feed for articles" => "Alimentació RSS del Tiki per a articles",
"Last posts to weblogs." => "Darrers enviaments a les bitàcoles.",
"Tiki RSS feed for weblogs" => "Alimentació RSS del Tiki per a bitàcoles web",
"Upcoming events." => "Propers aconteixements.",
"Tiki RSS feed for calendars" => "Alimentacions RSS de Tiki per als calendariss",
"Last sites." => "Darreres webs.",
"Tiki RSS feed for directory sites" => "Alimentació RSS del Tiki per a llocs del directori",
"Last files uploaded to the file galleries." => "Darrers arxius pujats a les galeries d'arxius.",
"Tiki RSS feed for file galleries" => "Alimentació RSS del Tiki per a galeries de fitxers",
"Tiki RSS feed for the file gallery: " => "Alimentació RSS del Tiki per a la galeria de fitxers: ",
"Tiki RSS feed for forum: " => "Alimentació RSS del Tiki per al fòrum: ",
"Last topics in forums." => "Darrers Temes als fòrums.",
"Tiki RSS feed for forums" => "Alimentació RSS del Tiki per a fòrums",
"Last images uploaded to the image galleries." => "darreres imatges pujades a les galeries d'imatges.",
"Tiki RSS feed for image galleries" => "Alimentació RSS del Tiki per a galeries d'imatges",
"Tiki RSS feed for the image gallery: " => "Alimentació RSS del Tiki per a la galeria d'imatges: ",
"Tiki RSS feed for individual trackers: " => "Alimentació RSS del Tiki per a formularis individuals: ",
"Last modifications to the Wiki." => "Darreres modificacions al Wiki.",
"Tiki RSS feed for the wiki pages" => "Alimentació RSS del Tiki per a pàgines wiki",
"_HOMEPAGE_CONTENT_" => "{GROUP(groups=Admins)}\n! Gràcies per instal·lar Tiki.\n\nLa Comunitat de Tiki en conjunt voldria donar-te les gràcies i ajudar-te amb la teva introducció a Tiki.\n\n! Com començar\nTiki té més de 1000 funcionalitats i ajustaments.\n\nAixò li permet crear llocs web des de molt simples fins a molt complexos.\n\nEntenem que un programari amb tantes característiques pot semblar aclaparador al principi. Aquesta és la raó per la que t'oferim dues maneres diferents per __Posar-te en marxa__ amb Tiki.\n\n{DIV(width=\"48%\",float=\"right\")}\n-= Configuració Manual emprant el Panell d'Administració =-\n! [tiki-admin.php|Posa't en marxa emprant el Panell d'Administració]\n__Qui hauria d'emprar això__\n* Estàs familiaritzat amb panells d'administració de programes\n* T'agrada explorar i jugar amb moltes opcions\n* Ja coneixes Tiki\n\n\n{DIV}{DIV(width=\"48%\",float=\"left\")}\n-= Ajust fàcil emprant Perfils =-\n!! [tiki-admin.php?profile=&categories%5B%5D=7.x&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|Posa't en marxa emprant Perfils]\n__Qui hauria d'emprar això__\n* Vols començar ràpidament\n* No tens ganes d'aprendre el Panell d'Administració immediatament\n* Vols provar de forma ràpida algunes funcionalitats de Tiki\n\n!! Perfils destacats\n\n__Comunitat Col·laborativa__ ([tiki-admin.php?profile=&categories%5B%5D=7.x&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|instal·la el perfil ara])\nConfiguració per ajudar a entusiastes i experts en les vostres matèries a treballar conjuntament per construir una Base de Coneixement\n* Edició de Wiki\n* Espais personals per als membres\n* Fòrums\n* Bitàcoles\n\n__Bitàcola i perfil personal__ ([tiki-admin.php?profile=&categories%5B%5D=7.x&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|instal·la el perfil ara])\nConfiguració amb moltes funcionalitats guais per ajudar-te a ser part de la Web Social i establir-te una presència notable a la Blogosfera\n* Bitàcola (Conjunt complert de característiques relacionades amb la bitàcola)\n* Galeria d'Imatges\n* Calendari\n* Integració RSS\n* Registre de vídeos\n\n__Intranet d'Empresa__ ([tiki-admin.php?profile=&categories%5B%5D=7.x&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|instal·la el perfil ara])\nConfiguració per a una intranet d'Empresa d'un negoci típic de mida mitjana (PIME).\n* Articles de Notícies de l'Empresa\n* Bloc Executiu\n* Gestió d'arxius i repositoris\n* Wiki col·laboratiu\n\n__Presència Web d'una Organització Petita__ ([tiki-admin.php?profile=&categories%5B%5D=7.x&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|instal·la el perfil ara])\nConfiguració per a la presència web d'una entitat sense ànim de lucre, ONG o petita empresa típica.\n* Notícies de l'entitat i actualitzacions\n* Destacar els Productes i Serveis de l'entitat\n* Galeria d'arxius (ideal per a un kit per als mitjans de comunicació)\n* Formulari de Contacte{DIV}\n\n{ELSE}\n\n! Felicitats\nAquesta és la pàgina Inicial per omissió per al teu Tiki. Si veus aquesta pàgina, la teva instal·lació s'ha realitzat correctament.\n\nPots canviar aquesta pàgina després de connectar-te. Si us plau, revisa la [http://doc.tiki.org/wiki+syntax|sintaxi wiki] per als detalls d'edició.\n\n!!{img src=pics/icons/star.png alt=\"Star\"} Posa't en marxa.\n\nPer començar la configuració del teu lloc:\n{FANCYLIST()}\n1) Inicia la sessió com a usuari __admin__ amb contrasenya __admin__.\n2) Canvia la contrasenya d'administrador.\n3) Habilita funcionalitats específiques de Tiki.\n4) Configura les funcionalitats.\n{FANCYLIST}\n\n\n!!{img src=pics/icons/help.png alt=\"Help\"} Necessites ajuda?\nPer a més informació:\n* [http://info.tiki.org/Learn+More|Més informació sobre TikiWiki].\n* [http://info.tiki.org/Help+Others|Obtenir ajuda], inclosos la [http://doc.tiki.org|documentació oficial] i els [http://www.tiki.org/forums|fòrums de suport].\n* [http://info.tiki.org/Join+the+community| Uneix-te a la comunitat TikiWiki].\n{GROUP}",
"new" => "nou",
"sheet" => "full de càlcul",
"Saved" => "Desat",
"Save failed" => "No s'ha pogut desar",
"Link" => "Enllaç",
"<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- connector smarty jq inactiu: feature_jquery desactivada -->",
"No records to display" => "No hi ha cap registre per mostrar",
"Fast Next" => "Següent ràpid",
"Fast Prev" => "Previsualització ràpida",
"Prev" => "Previ",
"Next" => "Següent",
"First {\$params['itemname']}" => "Primer {\$params['itemname']}",
"Last {\$params['itemname']}" => "Últim {\$params['itemname']}",
"Next {\$params['itemname']}" => "Següent {\$params['itemname']}",
"Prev {\$params['itemname']}" => "Previ {\$params['itemname']}",
"comment" => "comentari",
"No Tabs" => "Sense pestanyes",
"Tip" => "Pista",
"click here" => "cliqueu aquí",
"AutoSave" => "AutoDesa",
"Your edit session has expired" => "Ha caducat la teva sessió d'edició",
"Help page:" => "Pàgina d'ajuda:",
"View tpl:" => "Visualitza tpl:",
"Edit Template" => "Edita plantilla",
"Admin Feature" => "Administra Funcionalitat",
"Hide" => "Oculta",
"help" => "ajuda",
"Interactive Translation" => "Traducció interactiva",
"Click here to go to Edit Languages" => "Clica aquí per anar a Editar Idiomes",
"Save translations" => "Desa les traduccions",
"Cancel" => "Cancel·lar",
"The text is" => "El text és",
"character(s) too long - please edit it." => "caràcter(s) massa llarg - si us plau edita-ho.",
"Date Selector" => "Selector de Data",
"Select All" => "Selecciona-ho tot",
"Invert Sort" => "Inverteix l'ordre",
"second" => "segon",
"months" => "mesos",
"weeks" => "setmanes",
"done" => "fet",
"Text cut here" => "Tall del text aquí",
"Task" => "Tasca",
"Priority" => "Prioritat",
"Start date:" => "Data d'inici:",
"End date:" => "Data de fi:",
"Friend" => "Amic",
"Last seen on" => "Vista per darrera vegada el",
"(idle for %s seconds)" => "(inactiu durant %s segons)",
"User information - Click for more info" => "Informació de l'usuari - Punxa per més informació",
"Yes" => "Si",
"Use this tree to copy the structure" => "Empra aquest arbre per copiar l'estructura",
"created from structure" => "creat des d'estructura",
"Table of contents" => "Taula de continguts (índex)",
"You have to make %d choice(s) for the question" => "Has de fer %d elecció(ons) per a la pregunta",
"You have to make at least %d choice(s) for the question" => "Has de fer al menys %d elecció(ons) per a la pregunta",
"You have to make less than %d choice(s) for the question" => "Has de fer menys de %d eleccions per a la pregunta",
"You have to choose at least %d choice(s) for the question" => "Has d'escollir al menys %d elecció(ons) per a la pregunta",
"Face" => "Cara",
"Sea Surfing (CSRF) detected. Operation blocked." => "Sea Surfing (CSRF) detectat. Operació bloquejada.",
"unknown error" => "error desconegut",
"You are not logged in" => "No està connectat",
"Page '%0' cannot be found" => "No es pot trobar la pàgina '%0'",
"You do not have permission to view this section" => "Permís denegat per accedir a aquesta secció",
"For the security of your password direct access to the feed is only available via https" => "Per la seguretat de la teva contrasenya, l'accés directe a l'alimentació només és troba disponible via https",
"Help link" => "Enllaç d'ajuda",
"You are banned from" => "Estàs exclós des de",
"img-g" => "g-img",
"file-g" => "g-arx",
"faqs" => "pufs",
"quizzes" => "qüestionaris",
"blogs" => "bitàcoles",
"forums" => "fòrums",
"Plugin execution pending approval" => "Execució del connector esperant aprovació",
"Edit Plugin" => "Edita el Connector (Plugin)",
"Click to edit dynamic variable" => "Punxa per editar variable dinàmica",
"Update variables" => "Actualitza variables",
"Edit Section" => "Edita la secció",
"index" => "índex",
"Show" => "Mostra",
"sad" => "trist",
"confused" => "confós",
"cool" => "guai",
"mad" => "boig",
"The file you are trying upload was only partially uploaded." => "L'arxiu que proves de penjar només s'ha carregat parcialment.",
"%d points" => "%d punts",
"Removed" => "Eliminat/da",
"at" => "a",
"Unknown language" => "Llenguatge desconegut",
"Click here to confirm your action" => "Fes clic aquí per confirmar la teva acció",
"Box" => "Caixa",
"Email" => "Correu-e",
"Heading" => "Capçalera",
"Title bar" => "Barra de títol",
"Unordered List" => "Llista Desordenada",
"Ordered List" => "Llista Ordenada",
"Special Characters" => "Caràcters especials",
"Foreground color" => "Color del davant",
"Background Color" => "Color de Fons",
"Wiki Link" => "Enllaç Wiki",
"External Link" => "Enllaç Extern",
"Table Builder" => "Constructor de taules",
"Find Text" => "Cerca Text",
"Text Replace" => "Cerca i reemplaça text",
"Full Screen Edit" => "Edició a pantalla completa",
"Wiki Help" => "Ajuda del Wiki",
"Choose or upload images" => "Escull o puja imatges",
"Switch Editor (wiki or WYSIWYG)" => "Canvia d'Editor (wiki o WYSIWYG)",
"Save Sheet" => "Desa el Full",
"Get Cell Range" => "Aconsegueix el rang de les cel·les",
"Find" => "Cerca",
"Refresh Calculations" => "Refresca els càlculs",
"Finish Editing" => "Acaba l'edició",
"Item Modification" => "Modificació de l'ítem",
"Item" => "Ïtem",
"Item creation" => "Creació de l'ítem",
"Subject" => "Tema",
"Tracker was modified at " => "El formulari va ser modificat el ",
"View the tracker item at:" => "Visualitza l'ítem del formulari a:",
"Field is not numeric" => "El camp no és numèric",
"text field" => "camp de text",
"half column" => "mitja columna",
"size" => "mida",
"prepend" => "prefix",
"append" => "sufix",
"max" => "màx",
"textarea" => "areadetext",
"checkbox" => "requadre de verificació",
"numeric field" => "camp numèric",
"drop down" => "desplegable",
"drop down with other textfield" => "desplegable amb un altre camp de text",
"radio buttons" => "botons radio",
"user selector" => "selector de l'usuari",
"group selector" => "selector del grup",
"IP selector" => "Selector d'adreça IP",
"country selector" => "selector de país",
"date and time" => "data i hora",
"jscalendar" => "jscalendari",
"action" => "acció",
"header" => "capçalera",
"static text" => "text estàtic",
"category" => "categoria",
"item link" => "enllaç als ítems (desplegable)",
"items list" => "llista d'ítems",
"dynamic items list" => "Llista dinàmica d'ítems",
"email" => "correu-e",
"user subscription" => "subscripció d'usuari",
"system" => "sistema",
"computed field" => "camp calculat",
"user preference" => "preferència de l'usuari",
"attachment" => "adjunt",
"stars" => "estels",
"open" => "obert",
"pending" => "pendent",
"closed" => "tancat",
"Message" => "Missatge",
"No extra information for that attached file. " => "No hi ha informació extra per aquest fitxer adjunt. ",
"child categories" => "categories infantils",
"objects in category" => "objectes dins la categoria",
"(AT)" => "(ARROBA)",
"(DOT)" => "(PUNT)",
"The administrator has not yet validated your account. Please wait." => "L'administrator no ha validat el teu compte encara. Si us plau, espera.",
"You must validate your account first. An email has been sent to you" => "Primer has de validar el teu compte. Se t'ha enviat un correu-e",
"Password should be at least" => "El password hauria de ser com a mínim",
"Password must contain both letters and numbers" => "La contrasenya ha de contenir tant lletres com números",
"The registration mail can't be sent. Contact the administrator" => "No es pot enviar el mail de registre. Contacteu amb l'administrador",
"The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "No es pot enviar el correu-e de registre de noves altes per que no hi ha especificada cap adreça de correu-e, i la funcionalitat està desactivada",
"The user email confirmation can't be sent. Contact the administrator" => "No es pot enviar el correu-e de confirmació de l'usuari. Contacta l'administrador",
"Personal Phone" => "Telèfon personal",
"Personal Mobile" => "Mòbil personal",
"Personal Fax" => "Fax personal",
"Work Phone" => "Telèfon de la feina",
"Work Mobile" => "Mòbil de la feina",
"Work Fax" => "Fax de la feina",
"Company" => "Empresa",
"Organization" => "Organització",
"Department" => "Departament",
"Division" => "Divisió",
"Job Title" => "Càrrec",
"Street Address" => "Adreça",
"City" => "Població",
"State" => "Estat",
"Zip Code" => "Codi postal",
"No subject" => "No hi ha cap assumpte",
"Location" => "Localització",
"Displays browser client info" => "Mostra informació del navegador de l'usuari",
"Anchor Link" => "Enllaç àncora",
"Anchor Name" => "Nom de l'Àncora",
"Creates a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which specifies the location and name of the anchor" => "Posa un enllaç a una àncora en una pàgina wiki. Per ser emprada en conjunció amb el plugin ANAME, que especifica el lloc i nom de l'ancora",
"linktext" => "text d'enllaç",
"Creates an anchor in a wiki page. Use in conjunction with the ALINK plugin, which specifies a link to the anchor" => "Posa una àncora en una pàgina wiki. Per ser emprada en conjunció amb el plugin ALINK, que especifica l'enllaç a l'ancora",
"Image Annotation" => "Annotació d'Imatges",
"Width" => "Amplada",
"Height" => "Alçada",
"Alignment" => "Alineació",
"Save changes to annotations" => "Desa els canvis a les anotacions",
"Field" => "Camp",
"Article ID" => "ID de l'article",
"Includes an article" => "Inclou un article",
"Id is optional. If not given, last article is used. Default field is heading." => "L'Id és opcional. Si s'omet, es fa servir el darrer article. El camp per defecte és la capçalera.",
"Article List" => "Llista d'Articles",
"Category ID" => "ID de categoria",
"Sort order" => "Ordenació",
"Quiet" => "Silenciós",
"Start Date" => "Data d'inici",
"End date" => "Data de finalització",
"Includes articles listing into a wiki page" => "Inclou un listat d'articles a una pàgina wiki",
"Attachment" => "Adjunt",
"Displays an attachment or a list of them" => "Mostra un adjunt o una llista d'adjunts",
"File" => "Fitxer",
"Same as name" => "Igual que el nom",
"Page" => "Pàgina",
"Bullets" => "Vinyetes",
"Page \"%0\" does not exist" => "La pàgina \"%0\" no existeix",
"No such attachment on this page" => "Aquest fitxer adjunt no és en aquesta pàgina",
"Gives the name of the attached file to link to" => "Dóna el nom del fitxer adjunt per enllaçar-hi",
"Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages" => "Dóna el nom d'una altra pàgina on hi ha l'arxiu adjunt. S'enllaça amb l'arxiu d'aquesta pàgina en lloc de l'altre. Només funciona amb pàgines wiki",
"Shows the description as the link text instead of the file name" => "Mostra la descripció com a text de l'enllaç en lloc del nom de l'arxiu",
"Makes the list of attachments a bulleted list" => "Converteix la llista de fitxers adjunts en una llista de pics",
"Says that this file is an image, and should be displayed inline using the img tag" => "Diu que aquest arxiu és una imatge, i s'ha de visualitzar inserit amb l'etiqueta img",
"Makes the text between the {ATTACH} tags the link text instead of the file name or description" => "Ho encaixa entre les etiquetes {ATTACH} com a enllaç de text en lloc del nom del fitxer o la descripció",
"Shows all attachments from the whole wiki" => "Mostra tots els fitxers adjunts de tot el wiki",
"Gives the number, in the list of attachments, of the attachment to link to" => "Dóna el número del fitxer adjunt de la llista amb el qual s'ha d'enllaçar",
"Gives the actual id of the attachment to link in. You probably should never use this" => "Dóna l'identificador real del fitxer adjunt amb què s'enllaça. Probablement no ho hauràs d'utilitzar mai",
"Puts the number of downloads in the alt comment" => "Inclou el nombre de descàrregues en el comentari alternatiu",
"Shows a file icon" => "Mostra una icona de fitxer",
"Displays the user Avatar" => "Mostra l'Avatar de l'usuari/a",
"username" => "usuari",
"Float" => "Flota",
"Back" => "Enrera",
"Insert back link on wiki page" => "Inserta els retro-enllaços a la pàgina wiki",
"Pipe separated list of fields to display. ex: hits|user" => "Lista de camps separada per barres verticalsa mostrar. exexmple: hits|user",
"Excluded pages" => "Pàgines excloses",
"Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Llista de pàgines separada per barres verticals a excloure del llistat. exemple: HomePage|Sandbox",
"Include Self" => "Inclou-re's a si mateix",
"List all pages that link to specific pages" => "Llista totes les pàgines que apunten a pàgines específiques",
"One page links to" => "Una pàgina apunta a",
"pages link to" => "pàgines que apunten a",
"Banner" => "Pancarta (Banner)",
"Insert a banner" => "Inserta una pancarta (banner)",
"Zone" => "Zona",
"Target" => "Destí",
"Display" => "Mostra",
"missing parameter" => "manca paràmetre",
"URL" => "URL (Localitzador de Recurs Universal)",
"Blog List" => "Llista de bitàcoles",
"Blog ID" => "ID de la bitàcola",
"End Date" => "Data final",
"Use BLOGLIST to include posts from a blog. Syntax is" => "Empra BLOGLIST per incloure publicacions d'una bitàcola. La Sintaxi és",
"where Id is the blog Id and Items is the max number of posts to display" => "on l'Id és l'Id de la bitàcola i Items és el nombre màxim de publicacions a mostrar",
"Insert theme-styled box on wiki page" => "Insertar Formulari amb aspecte a la pàgina wiki",
"Box title" => "Títol de la caixa",
"Displayed above the content" => "Mostrat sobre el contingut",
"Background color" => "Color del rerafons",
"Box width" => "Amplada de la caixa",
"Text Alignment" => "Alineació del text",
"Float Position" => "Posició flotant",
"Clear" => "Neteja",
"CSS Class" => "Classe CSS",
"Label" => "Etiqueta",
"Incorrect param" => "Paràmetre Incorrecte",
"List" => "Llista",
"Table" => "Taula",
"Insert list of items with the current/given category in the wiki page" => "Insertar llista d'ítems per a la categoria actual on és la pàgina wiki",
"Category IDs" => "IDs de les Categories",
"Types" => "Tipus",
"Split" => "Separa",
"And" => "I",
"Categories are disabled" => "Les Categories han estat deshabilitades",
"Category Orphans" => "Orfans de categoria",
"Object" => "Objecte",
"Display Tiki objects that have not been categorized" => "Mostra objectes Tiki que no hagin estat categoritzats",
"Insert the full category path for each category that this wiki page belongs to" => "Insertar la ruta de la categoria completa per a cada categoria a la que aquesta pàgina wiki pertany",
"Separator" => "Separador",
"Centers the plugin content in the wiki page" => "Centra el contingut connectat a la wikipàgina",
"Chart" => "Gràfic",
"Sheet ID" => "ID del Full",
"Data sheet ID" => "ID del Full de dades",
"Chart Type" => "Tipus de gràfic",
"Chart Width" => "Amplada de gràfic",
"Chart Height" => "Alçada del gràfic",
"Value series" => "Sèries de valors",
"Required for pie charts" => "Requerit per gràfics de formatgets",
"Independant series" => "Sèrie independent",
"Required for types other than pie chart" => "Requerit per a tipus diferents dels gràfics de formatgets",
"Dependant series" => "Sèrie dependent",
"Styles" => "Estils",
"Labels" => "Etiquetes",
"title" => "títol",
"Chart as PDF" => "Sondeig (chart) com a PDF",
"Chart as PostScript" => "Sondeig (chart) com a PostScript",
"Code" => "Codi",
"Displays a snippet of code" => "Mostra un de codi",
"Caption" => "Capçalera",
"Word Wrap" => "Doblega línies llargues",
"Wiki Syntax" => "Sintaxi Wiki",
"Content is HTML" => "El contigut és HTML",
"code" => "codi",
"note: colors and ln are exclusive" => "nota: colors i ln són exclusius",
"Display all the images of a file gallery in a colorbox popup" => "Mostra totes les imatges de la galeria d'arxius en un requadre emergent semitransparent (colorbox)",
"Thumb" => "Contactes",
"Display as a thumbnail (y) or full size (n)" => "Mostra com a contacte/en petit (y) o a mida completa (n)",
"Sort Mode" => "Mode d'ordenació",
"Show file title" => "Mostra el títol de l'arxiu",
"Show file name" => "Mostra el nom de l'arxiu",
"Wiki parse the file descriptions" => "Interpreta la sintaxi wiki de les descripcions dels arxius",
"Dynamic Content" => "Contingut dinàmic",
"Content ID" => "ID del contingut",
"Cookie" => "Galeta",
"Insert copyright notices" => "Insertar avisos de drets d'autor",
"Countdown" => "Compte enrera",
"Locate Time" => "Localització del Temps",
"On" => "Actiu",
"Days" => "Dies",
"Hours" => "Hores",
"Minutes" => "Minuts",
"Example" => "Exemple",
"Class" => "Classe",
"All user prefs sessions" => "Totes les sessions de preferències d'usuaris",
"Debug" => "Debug (Neteja d'errors)",
"report definition" => "definició d'informe",
"Full DSN" => "DSN sencer",
"A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "Una text sencer de connexió a DSN (Data Source Name). exemple: mysql://usuari:contrasenya@servidor/basededades",
"Missing db or dsn parameter" => "Manca base de dades o paràmetre dsn",
"Run a database report" => "Executa un informe sobre una base de dades",
"Definition List" => "Llista de definició",
"Creates a definition list" => "Cre una llista de definició",
"term" => "terme",
"definition" => "definició",
"one definition per line" => "una definició per línia",
"Equation" => "Equació",
"equation" => "equació",
"Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size" => "Renderitza una equació escrita en sintaxi LaTeX com a png. La mida del paràmetre opcional per defecte és 100 i correspon al tant per cent de la mida normal, per exemple, size=200 indica que una equació fa dues vegades la mida normal",
"~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insereix una sortida de canal rss en una pàgina wiki",
"Upcoming events" => "Propers esdeveniments",
"Label to display on first display" => "Etiqueta a mostrar en la primera visualització",
"Unspecified label" => "Etiqueta no especificada",
"Fancy List" => "Llista maca",
"Creates a fancy-looking list" => "Crea una llista d'aparència més maca",
"CSS class for the fancylist" => "Classe CSS de la llista maca",
"num" => "núm",
"item text" => "text de l'ítem",
"one item per line" => "un ítem per línia",
"Fancy Table" => "Taula maca",
"Displays the data using the Tikiwiki odd/even table style" => "Mostra les dades usant el sistema de taules odd/even del Tikiwiki",
"Heading CSS Class" => "Classe CSS Capçalera",
"cells" => "cel·les",
"File ID" => "ID de l'arxiu",
"Date" => "Data",
"Flash video" => "Vídeo Flash",
"Displays a Flash (.swf) file in the wiki page" => "Mostra un arxiu flaix (SWF) dins la pàgina wiki",
"Movie URL" => "URL del vídeo",
"Quality" => "Qualitat",
"Flash video quality. Default value: high" => "Qualitat del vídeo Flash. Valor per defecte: high",
"High" => "Alt",
"Low" => "Baix",
"Missing parameter movie to the plugin flash" => "Manca el paràmetre movie per al plugin flash",
"Inserts a superscripted footnote number next to text and takes in footnote as parameter" => "Inserta un superíndex de nota al peu, al costat del text, i pren el contingut de la nota al peu com a paràmetre",
"Footnote" => "Nota al peu",
"The footnote" => "La nota al peu",
"Footnotearea" => "Àrea amb les notes al peu",
"Inserts a section for collected footnotes in the wiki page" => "Inserta una secció per a les notes al peu recollides dins de la pàgia wiki",
"Blog Posts" => "Publicacions de bitàcoles",
"all" => "tots",
"Search the titles of all pages in this wiki" => "Buscar els títols de totes les pàgines del wiki",
"file name" => "nom de l'arxiu",
"missing parameters" => "paràmetres que manquen",
"Connection failed" => "La connexió ha fallat",
"failed" => "sense èxit",
"Gauge" => "Barra de nivell",
"Displays a graphical gauge" => "Mostra una barra de nivell gràfic",
"description" => "descripció",
"Value" => "Valor",
"Maximum Value" => "Valor Màxim",
"Maximum possible value. Default: 100" => "Valor màxim possible. Per defecte: 100",
"Label Width" => "Amplada de l'etiqueta",
"Display Percentage" => "Percentatge de Pantalla",
"Display Value" => "Valor de Pantalla",
"Displays a graphical GAUGE" => "Mostra un gràfic GAUGE",
"Google Analytics" => "Analítica de Google",
"Missing parameter" => "Manca algun paràmetre",
"Displays a Google document" => "Mostra un document de Google",
"Type of Google document" => "Tipus de document de Google",
"Spreadsheet" => "Full de càlcul",
"key" => "clau",
"Google doc key - for example: pXsHENf1bGGY92X1iEeJJI" => "Clau del document de Google - per exemple pXsHENf1bGGY92X1iEeJJI",
"Margin Height" => "Alçada de Marge",
"Margin Width" => "Amplada de Marge",
"Scrolling" => "Desplaçament",
"Required parameter \"type\" missing" => "Manca el paràmetre \"tipus\" requerit",
"Required parameter \"key\" missing" => "Manca el paràmetre \"clau\" requerit",
"The user has chosen to make his information private" => "L'usuari ha escollit convertir la seva informació en privada",
"Group" => "Grup",
"Display wiki text if user is in one of listed groups" => "Mostra el text wiki si l'usuari es troba en algun dels grups llistats",
"Allowed Groups" => "Grups Permesos",
"Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "Lista separada per barres verticals dels grups permesos per veure el bloc. ex: Admins|Desenvolupadors",
"Denied Groups" => "Grups Denegats",
"Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "Llista separada per barres verticals dels grups denegats per veure el bloc. ex: Gestors|Anònims",
"Groups" => "Grups",
"Include literal HTML in a Wiki page" => "Inclou literal HTML en un Wiki pàgina",
"HTML code" => "codi HTML",
"Wiki syntax" => "Sintaxi Wiki",
"Displays an iframe" => "Mostra un iframe",
"Pixels or %" => "Píxels o %",
"Image ID" => "Imatge ID",
"Gallery ID" => "ID de la Galleria",
"Thumbnail" => "Miniatura",
"Browse" => "Visitar",
"Download" => "Descarregar",
"Image height" => "Alçada de la imatge",
"Image width" => "Amplada d'Imatge",
"Include" => "Inclou",
"Start" => "Començament",
"Stop" => "Atura",
"Include a page" => "Incloure una pàgina",
"Default Group" => "grup per defecte",
"Following mandatory fields are missing" => "Manquen els camps obligatoris següents",
"Runs a Java applet to access a local Jabber service" => "Executa un applet Java per accedir a un servidor Jabber local",
"Displays the text only if the language matchs" => "Mostra el text només si l'idioma concorda",
"Last Modification" => "Última modificació",
"The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given" => "El connector last_mod se substitueix per l'hora de l'última modificació de la pàgina wiki que s'ha indicat, o per la pàgina actual si no s'ha donat cap nom",
"List Pages" => "Llista pàgines",
"List wiki pages." => "Llista pàgines wiki.",
"Sort" => "Ordena",
"or" => "o",
"Lists files in a directory" => "Llista arxius en un directori",
"File Name" => "Nom d'arxiu",
"Filter" => "Filtra",
"could not be opened because it doesn't exist or permission was denied" => "no es pot obrir perquè no hi és o s'ha denegat el permís",
"Mail" => "Correu",
"Map" => "Mapa",
"Displays a map" => "Mostra un mapa",
"Feature disabled" => "Característica deshabilitada",
"Template" => "Plantilla",
"Style" => "Estil",
"Module Name" => "Nom del mòdul",
"Parse" => "Interpreta",
"Please choose a module" => "Si us plau, trieu un mòdul",
"to be used as argument" => "per ser emprat com a argument",
"Displays a module inline in a wiki page" => "Mostra un mòdul en línia dins la pàgina",
"Sorry, no such module" => "Perdó, aquest mòdul no existeix",
"Displays the data using a monospace font" => "Mostra les dades usant una font monoespaiada",
"Text" => "Texte",
"Sticky" => "Enganxós",
"data" => "dades",
"Displays a MySpace Flash mp3 playlist in the wiki page" => "Mostra una llista de reproducció mp3 de myspace tipus SWF a la pàgina wiki",
"Displays object hit info by object and days" => "Mostra informació de les visualitzacions de l'objecte per objecte i dies",
"Permissions" => "permisos",
"Information" => "Informació",
"Plugin" => "Connector (Plugin)",
"Module" => "Mòdul",
"Poll" => "Consulta",
"Displays the output of a poll, fields are indicated with numeric ids." => "Mostra la sortida d'una Consulta, els camps estan indicats amb ids numèrics.",
"missing poll ID for plugin POLL" => "falta l'ID del sondeig pel connector POLL",
"Proposal" => "Proposta",
"Accept proposal" => "Accepta la proposta",
"Still undecided" => "Indecís encara",
"Reject proposal" => "Rebutja la proposta",
"wrote:" => "va escriure:",
"Quote:" => "Cita:",
"Quote text by surrounding the text with a box, like the [QUOTE] BBCode" => "Cita text a través d'envoltar-lo d'un requadre, com el de [QUOTE] BBCode",
"User Information" => "Informació de l'usuari",
"User Preferences" => "Preferències de l'usuari",
"admin" => "administrar",
"Preferences" => "Preferències",
"Redirects you to another wiki page" => "Redirecciona a una altra pàgina Wiki",
"Takes regex expressions and parses the content between the REGEX tags and replaces the text." => "Pren expressions regulars i interpreta el contingut entre etiquetes REGEX i reemplaça el text.",
"one data per line" => "una dada per línea",
"Displays a comment, tip, note or warning box" => "Mostra un comentari, consell, nota o quadre d'avís",
"remarks text" => "text de comentaris",
"Errors" => "Error",
"Note" => "Nota",
"Warning" => "Avís",
"Close" => "Tanca",
"Icon" => "Icona",
"Pop-up" => "Finestra emergent",
"Sheet Heading" => "Capçalera del full",
"Create New Sheet" => "Crea un nou full",
"Edit Sheet" => "Edita Full",
"List wiki pages" => "Llista les pàgines Wiki",
"Clickable Skype link" => "Enllaç clicable de Skype",
"Action" => "Acció",
"Chat" => "Xat",
"The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace." => "El connector SNARF  es reemplaça a si mateix pel cos html d'una URL. Es pot fer un reemplaçament arbitrari en aquest contingut emprant expressions regulars regex i regexres, la darrera emprada com a segon argument a preg_replace.",
"This data is put in a CODE caption." => "Aquestes dades es posen en un requadre de tipus CODI.",
"Sorts the plugin content in the wiki page" => "Ordena el contingut del plugin dins la pàgina wiki",
"Order" => "Ordre",
"Split a page into rows and columns" => "Divideix una pàgina en files i columnes",
"First" => "Primer",
"Column" => "Columna",
"Edit" => "Editar",
"Missing db param" => "Falta paràmetre de la bd",
"Run a sql query" => "Executa una consulta sql",
"sql query" => "consulta sql",
"Added" => "Afegit",
"Viewed" => "Visualitzat",
"Displays text in subscript." => "Mostra text en subíndex.",
"Subscribe or unsubscribe to a group" => "Subscriu-te o desubscriu-te a un grup",
"Subscribe Text" => "Text per a la subscripció",
"Subscribe" => "Subscriu",
"Unsubscribe Text" => "Text per a desubscriure's",
"Unsubscribe" => "De-subscriu-me",
"Subscribe Action" => "Acció de Subscriure's",
"Unsubscribe Action" => "Acció de de-subscriure's",
"Displays text in superscript." => "Mostra el text com a superíndex.",
"Tag" => "Marcador",
"Tag Name" => "Nom de marca",
"Displays text between HTML tags" => "Mostra text entre etiquetes html",
"No Header" => "Sense capçalera",
"No pages found for title search" => "No s'ha trobat cap pàgina per la cerca de títols",
"One page found for title search" => "Una pàgina ha estat trobada a la cerca per al títol",
"pages found for title search" => "pàgines trobades pel títol de la cerca",
"Structure ID" => "ID de l'Estructura",
"List top-scoring users" => "Llista dels usuaris amb més punts",
"Translate" => "Tradueix",
"Translate a string" => "Tradueix una cadena",
"Fields" => "Camps",
"to" => "a",
"template" => "plantilla",
"Parent" => "Pare",
"Overwrite" => "Reescriure",
"Preview" => "Vista prèvia",
"Reset" => "Reespecifica",
"reset" => "reiniciar",
"View" => "Visualitza",
"Open" => "Obert",
"Closed" => "Tancat",
"Incorrect fieldId:" => "Identificador de camp incorrecte:",
"Displays an input form for tracker submit" => "Mostra un formulari html d'enviament de dades per a un formulari Tiki (tracker)",
"You do not have permission to insert an item" => "No tens permís per insertar ítems",
"You do not have permission to modify an item" => "No tens permisos per modificar un element",
"Fields marked with a * are mandatory." => "Els camps marcats amb un asterisc (*) són obligatoris.",
"Filters" => "Filtres",
"Filters the items of a tracker, fields are indicated with numeric ids." => "Filtra els ítems d'un formulari, els camps són indicats amb els seus ids. numèrics",
"tracker field type not processed yet" => "algun tipus emprat de camp de formulari no ha estat processat encara",
"Wiki text" => "Text wiki",
"Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)." => "Visualitza el valor d'un camp d'un element de formulari o el text wiki si el valor del camp està configurat o té un valor (si no s'ha especificat itemId, utilitza itemId de la url o el formulari d'usuari).",
"Displays the output of a tracker content, fields are indicated with numeric ids." => "Mostra la sortida del contingut d'un formulari; els camps són indicats amb ids. numèrics",
"More" => "Més",
"incorrect filterfield" => "camp de filtrat (filterfield) incorrecte",
"Error in tracker ID" => "Error a l'ID del formulari",
"No field indicated" => "No s'ha indicat cap camp",
"Displays a button to link to a page with a tracker plugin with prefilled tracker fields." => "Visualitza un botó per enllaçar a una pàgina amb un connector de formulari que ja té els camps de formulari pre-emplenats.",
"Displays some stat of a tracker content, fields are indicated with numeric ids." => "Visualitza estadístiques del contingut d'un formulari, els camps s'indiquen amb identificadors numèrics.",
"incorrect fieldId" => "Identificador de camp incorrecte",
"Links to a translated content" => "Enllaços a contingut traduït",
"Flag" => "Bandera",
"Group name" => "Nom del Grup",
"Displays the number of registered users" => "Mostra el número d'usuaris registrats",
"User List" => "Llistat d'usuaris",
"Real Name" => "Nom real",
"users" => "usuaris",
"Displays a list of registered users" => "Mostra una llista dels usuaris registrats",
"Split the text in parts visible only under some conditions" => "Divideix el text en parts només visibles sota determinades condicions",
"This is the default text" => "Aquest és el text per defecte",
"(version 3)" => "(versió 3)",
"This is version 3 info" => "Això és informació de la versió 3",
"(version 2)" => "(versió 2)",
"This is version 2 info" => "Això és informació de la versió 2",
"(version 1)" => "(versió 1)",
"This is version 1 info" => "Això és informació de la versió 1",
"Width in pixels" => "Amplada en pixels",
"Height in pixels" => "Alçada en pixels",
"Vote" => "Votar",
"From" => "Des de",
"To" => "A",
"Line break" => "Salt de línia",
"ignored" => "ignorat",
"External Wiki" => "Wiki Extern",
"dash-WikiWord" => "guio-ParaulaWiki",
"WikiWord" => "ParaulaWiki",
"not in level" => "no al nivell",
"valid" => "vàlid",
"End of debug output." => "Final de la sortida de depuració.",
"Wanted Page" => "Pàgina buscada",
"Referenced By Page" => "Referenciat per la pàgina",
"Lists ''wanted'' Wiki pages: " => "Llista les pàgines Wiki ''buscades'': ",
"Page-Pattern" => "Patró de pàgina",
"Custom-Level-Regex" => "Nivell-adaptat-Regex",
"^Parameters: key=>value,...\n" => "^Paràmetres: clau=>valor,...\n",
"__key__ | __default__ | __comments__\n" => "__clau__ | __defecte__ | __comentaris__\n",
"empty string" => "tros de text (cadena) buit/da",
"A wildcard pattern of originating pages to be ignored." => "Un patró comodí de pàgines d'origen que s'ignoraran.",
"(refer to PHP function fnmatch() for details)\n" => "(consulta la funció PHP fnmatch() per més detalls)\n",
"The character, by which ignored patterns are separated." => "El caràcter amb el qual se separen els patrons que s'ignoren.",
"possible values: characters\n" => "valors possibles: caràcters\n",
"Whether to include external wikis in the list." => "Si incloure (o no) wikis externs a la llista.",
"possible values: " => "valors possibles: ",
"Collect either originating or wanted pages in a cell and display them in the second column." => "Aplega tant les pàgines d'origen com les pàgines cercades en una cel·la i visualitza-les a la segona columna.",
"Archive" => "Arxiu",
"Related" => "Relacionat",
"Cannot create aliased page" => "No es pot crear una pàgina que ja està emulada a través d'un alias",
"That page is an alias for the following pages" => "Aquesta pàgina és un alias per a les següents pàgines",
"If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this" => "Si realment vols crear la pàgina, primer has d'editar cadascuna de les pàgines de més amunt, i eliminar l'enllaç de tipus alias que contenen. Aquest enllaç hauria de semblar quelcom com",
"Removed version \$version" => "Versió \$version eliminada",
"Changed actual version to \$version" => "La versió actual s'ha canviat a \$version",
"No version indicated" => "No s'ha indicat cap versió",
"Plugin " => "Connector (plugin) ",
"Page locked" => "Pàgina bloquejada",
"Page unlocked" => "Pàgina desbloquejada",
"Removed last version" => "Úlitma versió eliminada",
"ERROR: Either the subject or body must be non-empty" => "ERROR: El títol o el cos no han d'estar buits",
"ERROR: No valid users to send the message" => "ERROR: No hi ha usuaris válids per enviar el missatge",
"User %s does not want to receive messages" => "La persona usuària %s no vol rebre missatges",
"Invalid user" => "Invàlid usuari",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "La bústia Enviats és plena. Arxiveu o esborreu alguns missatges enviats si voleu enviar més missatges.",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Heu de poder rebre missatges per tal d'enviar-ne. Aneu a preferències de l'usuari i activa 'Permetre missatges d'altres usuaris'",
"User %s can not receive messages, mailbox is full" => "L'usuari %s no pot rebre missatges, la bústia de correu és plena",
"User %s can not receive messages" => "L'usuari %s no pot rebre missatges",
"Invalid user: %s" => "Usuari no vàlid: %s",
"Message has been sent to: " => "S'ha enviat el missatge a: ",
"Archive is full. Delete some messages from archive first." => "L'arxiu és ple. Esborreu primer alguns missatges de l'arxiu.",
"No more messages" => "No hi ha mes missatges",
"Similar Content" => "Contingut similar",
"Article Topics" => "Temes de l'article",
"Categorize" => "Categoritzar",
"Unassign" => "Desassigna",
"Assign" => "Assigna",
"Categorize %s in %s" => "Classifica %s en %s",
"Received objects" => "Objectes rebuts",
"Show description" => "Mostrar descripció",
"Last forum posts" => "Darrers enviaments al fòrum",
"Topics only" => "Només tòpics",
"Most commented forums" => "Fòrums amb més comentaris",
"Most read topics" => "temes més llegits",
"Most visited forums" => "Fòrums més visitats",
"Freetags editor" => "Editor de marques lliures",
"Most popular tags" => "Marcadors més populars",
"My preferred tags" => "Els meus marcadors preferits",
"Google Search" => "Cerca en el Google",
"Last actions" => "Últimes accions",
"Last blog posts" => "Darreres publicacions a les bitàcoles",
"no object here yet" => "encara no hi ha cap objecte aquí",
"Last Created blogs" => "Últimes bitàcoles creades",
"Last Created FAQs" => "Últimes PUFs creades",
"Last Created Quizzes" => "Darrers qüestionaris creats",
"Last modified file galleries" => "Galeria de darrers arxius modificats",
"Last Files" => "Últims arxius",
"Last Images" => "Darreres imatges",
"Last modified events" => "Últims events modificats",
"Last Modified blogs" => "Últimes bitàcoles modificades",
"width" => "amplada",
"height" => "alçada",
"Last submissions" => "Últimes col·laboracions",
"Last Items" => "Últims Punts",
"Last Modified Items" => "Últims Punts modificats",
"Last Visitors" => "Últims visitants",
"Live support" => "Suport Directe",
"Structure" => "Estructura",
"Messages" => "Missatges",
"Waiting Submissions" => "Col·laboracions en espera",
"Old articles" => "Articles antics",
"Create/Edit" => "Crea/edita",
"Quick Edit a Wiki Page" => "Crea/Edita pàgina Wiki",
"Random Pages" => "Pàgines a l'atzar",
"New user registration" => "Registre d'usuari nou",
"Search" => "Cercar",
"Advanced search" => "Cerca advançada",
"Go" => "Ves-hi",
"Post" => "Publicar",
"Since your last visit" => "Des de la teva última visita",
"Changes since" => "Canvis des de",
"new comments" => "comentaris nous",
"new posts" => "noves publicacions",
"wiki pages changed" => "pàgines del wiki modificades",
"new articles" => "articles nous",
"new FAQs" => "Noves FAQs",
"new blogs" => "bitàcoles noves",
"new blog posts" => "noves entrades a la bitàcola",
"new image galleries" => "noves galeries d'imatge",
"new images" => "imatges noves",
"new file galleries" => "noves galeries de fitxers",
"new files" => "arxius nous",
"new polls" => "consultes noves",
"new users" => "usuaris/es nous/ves",
"new tracker items" => "nous ítems del formulari",
"Most Active blogs" => "Bitàcoles més actives",
"Top File Galleries" => "Galeria d'arxius principals",
"Top files" => "Els fitxers més emprats",
"Top Forum Posters" => "Els publicadors de Fòrums més actius",
"Top Images" => "Imatges per dalt",
"Top Objects" => "Objects més actius",
"Top Pages" => "Pàgines per dalt",
"Top Quizzes" => "Qüestionaris principals",
"Top Visited FAQs" => "PUFs més visitades",
"User Blogs" => "Bitàcoles de l'usuari",
"User bookmarks" => "Adreces d'interès de l'usuari",
"User Pages" => "Pàgines de l'usuari",
"My Pages" => "Les meves pàgines",
"User tasks" => "Tasca d'usuari/a",
"The task title must have at least 3 characters" => "El títol de la tasca ha de tenir com a mínim 3 caràcters",
"Public tasks" => "Tasques públiques",
"Top users" => "Usuaris més actius",
"Online users" => "Usuaris en línia",
"Last wiki comments" => "Darrers wiki comentaris",
"Invalid server key" => "Clau del servidor invàlida",
"Invalid username or password" => "Usuari o contrasenya  no vàlids",
"Cookie not found" => "No s'ha trobat la galeta",
"Can create/admin calendars" => "Pot crear/administrar calendaris",
"Can add events in the calendar" => "Pot afegir esdeveniments al calendari",
"Can change events in the calendar" => "Pot canviar esdeveniments del calendari",
"Can view events details" => "Pot visualitzar informació dels esdeveniments",
"Administrator, can create channels remove channels etc" => "Administrador, pot crear canals, eliminar canals, etc.",
"Can use the chat system" => "Pot utilitzar el sistema de xat",
"Can approve submissions" => "Pot aprovar trameses",
"Can admin article topics" => "Pot administrar temes d'articles",
"Can admin article types" => "Pot administrar tipus d'articles",
"Can edit articles" => "Pot editar articles",
"Can edit submissions" => "Pot editar trameses",
"Can read articles" => "Pot llegir articles",
"Can remove articles" => "Pot esborrar articles",
"Can remove submissions" => "Pot esborrar trameses",
"Can submit articles" => "Pot trametre articles",
"Can read a topic (Applies only to individual topic perms)" => "Pot llegir un tema (només per als casos amb permisos individuals per a temes)",
"Can admin contributions" => "Pot administrar contribucions",
"Can admin the directory" => "Pot administrar el directori",
"Can admin directory categories" => "Pot administrar categories de directoris",
"Can admin directory sites" => "Pot administrar enllaços",
"Can submit sites to the directory" => "Pot trametre llocs web al directori",
"Can use the directory" => "Pot utilitzar el directori",
"Can admin faqs" => "Pot administrar pmf",
"Can suggest faq questions" => "Pot suggerir preguntes pmf",
"Can view faqs" => "Pot visualitzar pmf",
"Can admin users" => "Pot administrar usuaris",
"Can access site when closed" => "Pot accedir al lloc web quan està tancat",
"Administrator, can admin banners" => "Administrador, pot administrar bàners",
"Can admin the dynamic content system" => "Pot administrar el sistema de contingut dinàmic",
"Can admin mail-in accounts" => "Pot administrar comptes de correu-dins",
"Can edit object permissions" => "Pot editar permisos d'objectes",
"Can clean cache" => "Pot esborrar la memòria cau",
"Can remove association between two pages in a translation set" => "Pot eliminar l'associació entre dues pàgines en un conjunt de traducció",
"Can admin cookies" => "Pot administrar galetes",
"Can edit translations and create new languages" => "Pot editar traduccions i crear nous llenguatges",
"Can edit menu" => "Pot editar menús",
"Can edit menu option" => "Pot editar opcions de menú",
"Can edit site templates" => "Pot editar plantilles de lloc web",
"Can search" => "Pot buscar",
"Can report a link to the webmaster" => "Pot informar d'un enllaç a l'administrador",
"Can subscribe to groups" => "Pot subscriure a grups",
"Can send a link to a friend" => "Pot enviar un enllaç a un amic",
"Can use HTML in pages" => "Pot utilitzar HTML a les pàgines",
"Can view integrated repositories" => "Pot visualitzar repositoris integrats",
"Can view site stats" => "Pot visualitzar estadístiques",
"Can view site templates" => "Pot visualitzar plantilles de llocs web",
"Can admin blogs" => "Pot administrar blogs",
"Can assign perms to blog" => "Pot assignar permisos a blocs",
"Can post to a blog" => "Pot publicar en un bloc",
"Can create a blog" => "Pot crear un blog",
"Can read blogs" => "Pot llegir blocs",
"Can admin file galleries" => "Pot administrar galeries d'arxius",
"Can assign perms to file gallery" => "Pot assignar permisos a galeries d'arxius",
"Can upload zip files with files" => "Pot penjar arxius zip amb arxius",
"Can create file galleries" => "Pot crear galeries d'arxius",
"Can download files" => "Pot descarregar arxius",
"Can edit a gallery file" => "Pot editar un arxiu de la galeria",
"Can list file galleries" => "Pot llistar galeries d'arxius",
"Can upload files" => "Pot penjar arxius",
"Can view file galleries explorer" => "Pot visualitzar l'explorador de galeries d'arxius",
"Can view file galleries path" => "Pot visualitzar el camí de les galeries d'arxius",
"Can view file galleries" => "Pot visualitzar galeries d'arxius",
"Can admin forums" => "Pot administrar fòrums",
"Can attach to forum posts" => "Pot adjuntar a publicacions del fòrum",
"Auto approve forum posts" => "Auto aprova les publicacions dels fòrums",
"Can edit own forum posts" => "Pot editar les seves publicacions del fòrum",
"Can post in forums" => "Pot publicar als fòrums",
"Can start threads in forums" => "Pot iniciar fils de discussió als fòrums",
"Can read forums" => "Pot llegir fòrums",
"Can vote comments in forums" => "Pot votar comentaris de fòrums",
"Can admin Image Galleries" => "Pot administrar galeries d'imatges",
"Can upload zip files with images" => "Pot penjar arxius zip amb imatges",
"Can create image galleries" => "Pot crear galeries d'imatges",
"Can tag objects" => "Pot etiquetar objectes",
"Can list image galleries" => "Pot llistar galeries d'imatges",
"Can unassign tags from an object" => "Pot desassignar etiquetes d'un objecte",
"Can upload images" => "Pot penjar imatges",
"Can view image galleries" => "Pot visualitzar galeries d'imatges",
"Can admin newsletters" => "Pot administrar butlletins",
"Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Pot subscriure molts correus-e alhora (requereix tiki_p_subscribe email)",
"Can send newsletters" => "Pot enviar butlletins",
"Can subscribe any email to newsletters" => "Pot subscriure els correus-e als butlletins",
"Can subscribe to newsletters" => "Pot subscriure a butlletins",
"Can admin polls" => "Pot administrar consultes",
"Can view poll results" => "Pot veure resultats de les consultes",
"Can vote polls" => "Pot votar a les consultes",
"Can admin quizzes" => "Pot administrar concursos",
"Can take quizzes" => "Pot participar a concursos",
"Can view quiz stats" => "Pot visualitzar estadístiques dels concursos",
"Can view user quiz results" => "Pot visualitzar resultats dels usuaris en els concursos",
"Can admin sheet" => "Pot administrar fulls",
"Can create and edit sheets" => "Pot crear i editar fulls",
"Can view sheet" => "Pot visualitzar un full",
"Can view sheet history" => "Pot visualitzar l'historial de fulls",
"Can admin surveys" => "Pot administrar enquestes",
"Can take surveys" => "Pot fer enquestes",
"Can view survey stats" => "Pot visualitzar estadístiques d'enquestes",
"Can admin trackers" => "Pot administrar formularis",
"Can attach files to tracker items" => "Pot adjuntar fitxers a elements de formulari",
"Can insert comments for tracker items" => "Pot inserir comentaris per a registres de formulari",
"Can create new items for trackers" => "Pot crear nous registres per a formularis",
"Can list trackers" => "Pot llistar formularis",
"Can change tracker items" => "Pot canviar registres de formulari",
"Can view rating result for tracker items" => "Pot visualitzar el resultat de la valoració de registres de formulari",
"Can vote a rating for tracker items" => "Pot votar per a una valoració de registres de formularis",
"Can view trackers" => "Pot visualitzar formularis",
"Can watch tracker" => "Pot vigilar formulari",
"Can admin the wiki" => "Pot administrar el wiki",
"Can assign perms to wiki pages" => "Pot assignar permisos a pàgines wiki",
"Can edit pages" => "Pot editar pàgines",
"Can edit copyright notices" => "Pot editar avisos de copyright",
"Can edit dynamic variables" => "Pot editar variables dinàmiques",
"Can create and edit structures" => "Pot crear i editar estructures",
"Can lock pages" => "Pot bloquejar pàgines",
"Can save as minor edit" => "Pot guardar com a edició menor",
"Can remove" => "Pot esborrar",
"Can rename pages" => "Pot canviar noms de pàgines",
"Can upload pictures to wiki pages" => "Pot penjar imatges en pàgines wiki",
"Can view page/pages" => "Pot visualitzar pàgina/es",
"Can watch structure" => "Pot vigilar estructura",
"Can add and change ratings on wiki pages" => "Pot afegir i canviar valoracions a les pàgines wiki",
"Can attach files to wiki pages" => "Pot adjuntar fitxers a pàgines wiki",
"Can view wiki attachments and download" => "Pot visualitzar fitxers wiki adjunts i descarregar-los",
"Can view wiki comments" => "Pot visualitzar comentaris wiki",
"Can view wiki history" => "Pot visualitzar historials wiki",
"Can view rating of wiki pages" => "Pot visualitzar la valoració de pàgines wiki",
"Can view source of wiki pages" => "Pot visualitzar l'origen de les pàgines wiki",
"Can admin received articles" => "Pot administrar articles rebuts",
"Can admin received pages" => "Pot administrar pàgines rebudes",
"Can send articles to other sites" => "Pot enviar articles a altres llocs web",
"Can send articles to this site" => "Pot enviar articles a aquest lloc web",
"Can send pages to this site" => "Pot enviar pàgines a aquest lloc web",
"Can send pages to other sites" => "Pot enviar pàgines a altres llocs web",
"Can configure modules" => "Pot configurar mòduls",
"Can create user bookmarks" => "Pot crear adreces d'interès d'usuari",
"Can use the mini event calendar" => "Pot utilitzar el minicalendari d'esdeveniments",
"Can use the notepad" => "Pot utilitzar el bloc de notes",
"Can admin public tasks" => "Pot administrar tasques públiques",
"Can use tasks" => "Pot utilitzar tasques",
"Can receive tasks from other users" => "Pot rebre tasques d'altres usuaris",
"Can send tasks to other users" => "Pot enviar tasques a altres usuaris",
"Can upload personal files" => "Pot penjar arxius personals",
"Can create items in personal menu" => "Pot crear elements al menú personal",
"Can broadcast messages to all user" => "Pot difondre missatges a tots els usuaris",
"Can broadcast messages to groups" => "Pot difondre missatges a grups",
"Can use the messaging system" => "Pot utilitzar el sistema de missatgeria",
"Can admin comments" => "Pot administrar comentaris",
"Can edit all comments" => "Pot editar tots els comentaris",
"Can post new comments" => "Pot publicar nous comentaris",
"Can read comments" => "Pot llegir comentaris",
"Can delete comments" => "Pot esborrar comentaris",
"Can vote comments" => "Pot votar comentaris",
"Can admin content templates" => "Pot administrar plantilles de contingut",
"Can edit content templates" => "Pot editar plantilles de contingut",
"Can use content templates" => "Pot utilitzar plantilles de contingut",
"Can edit HTML pages" => "Pot editar pàgines HTML",
"Can view HTML pages" => "Pot visualitzar pàgines HTML",
"Can list registered users" => "Pot llistar usuaris registrats",
"Can use webmail" => "Pot utilitzar el correu web",
"Can admin categories" => "Pot administrar categories",
"change password" => "canvia la contrasenya",
"sender email" => "Correu-e de l'enviador",
"country" => "país",
"Anti-Bot verification code image" => "Imatge del codi de verificació anti-robots",
"Enter the code you see above" => "Introdueix el codi que veus més amunt",
"Try another code" => "Prova amb un altre codi",
"bytes" => "octets",
"Share page" => "Comparteix la pàgina",
"Share this page" => "Comparteix aquesta pàgina",
"Share This" => "Comparteix això",
"Send a link" => "Envia un enllaç",
"Translation" => "Traducció",
"Remove" => "Elimina",
"List of attached files" => "Llista de fitxers adjunts",
"desc" => "descripció",
"uploaded" => "pujat/s",
"Delete" => "Esborra",
"Upload file" => "Pujar un arxiu",
"Attach" => "Adjunció",
"Attach a file to this item" => "Afegeix un fitxer a aquest ítem",
"more info" => "més informació",
"No attachments for this item" => "No hi ha afegits per a aquest ítem",
"debug" => "depurador",
"Fatal error" => "Error fatal",
"Save to notepad" => "Guardar al bloc de notes",
"on" => "en",
"More..." => "Més...",
"pages" => "pàgines",
"First page" => "Primera pàgina",
"Previous page" => "Pàgina anterior",
"page" => "pàgina",
"Next page" => "Pàgina següent",
"Last page" => "Última pàgina",
"Permalink" => "Enllaç de Permanència",
"comments" => "comentaris",
"Actions" => "Accions",
"Properties" => "Propietats",
"No records found" => "No es trobaren registres",
"Select Categories" => "Selecciona Categories",
"Admin Categories" => "Administrar categories",
"Select/deselect all categories" => "Selecciona/deselecciona totes les categories",
"No categories defined" => "No hi ha categories definides",
"Browse Category" => "Navega per les categories",
"Posted by" => "Publicat per",
"posts:" => "publicacions:",
"User Level" => "Nivell d'usuari/a",
"private message" => "missatge privat",
"Send eMail to User" => "Enviar email a usuari",
"user online" => "usuari/a en línia",
"user offline" => "usuari/a fora de línia",
"top of page" => "dalt de la pàgina",
"Reply" => "Respon",
"Approve" => "Aprovar",
"Reject" => "Rebutja",
"Report this post" => "Informa d'aquesta publicacó",
"Monitor this Topic" => "Segueix aquest tema",
"Stop Monitoring this Topic" => "Deixa de seguir aquest tòpic",
"Group Monitor" => "Subscriu a grups sencers d'usuaris",
"Watched by categories" => "Vigilat per categories",
"Moderator actions" => "Accions del moderador",
"reported:" => "reportat:",
"queued:" => "a la cua:",
"Move to topic:" => "Moure al tema:",
"Move" => "Moure",
"Delete Selected" => "Esborrar seleccionats",
"Unlock" => "Desbloquejar",
"Lock" => "Bloquejar",
"Threshold" => "Llindar mínim",
"Replies" => "Respostes",
"below your current threshold" => "sota el teu llindar actual",
"New Reply" => "Resposta nova",
"Editing reply" => "Editant la resposta",
"Reply to the selected post" => "Respon a la publicació seleccionada",
"Post new message" => "Publica un nou missatge",
"Editing comment" => "Editant missatge",
"Post new comment" => "Publicar comentari nou",
"Add Comment" => "Afegeix un comentari",
"Send me an e-mail when someone replies" => "Envia'm un correu-e quan algú respongui",
"Reply to parent post" => "Respon a la publicació original",
"Post new reply" => "Publica una resposta nova",
"Post as Anonymous" => "Publica-ho anònimament",
"Posting replies" => "Publicant respostes",
"Posting comments" => "Publicant comentaris",
"1 comment" => "1 comentari",
"Comments" => "Comentaris",
"Go back" => "Tornar Enrera",
"Return to home page" => "Torna a la pàgina d'inici",
"Type of contribution:" => "Tipus de contribució:",
"Contributors" => "Contribuïdors",
"Authors" => "Autors",
"Add" => "Afegeix",
"Tiki Debugger Console" => "Consola del depurador del Tiki",
"Current URL" => "Actual URL",
"Command" => "Comanda",
"exec" => "executa",
"Type <code>help</code> to get list of available commands" => "Escriu <code>help</code> (ajuda) per obtenir una llista de les comandes disponibles",
"Syntax" => "Sintaxi",
"Page generation debugging log" => "Pagina generadora del registre de depuració",
"Features state" => "Estat de les característiques",
"features matched" => "característiques coincidents",
"Watchlist" => "Llista de coses vigilades",
"Duplicate File Gallery" => "Duplica la galeria d'arxius",
"Duplicate categories" => "Duplica les categories",
"Duplicate" => "Duplica",
"There are individual permissions set for this file gallery" => "Existeixen permisos fixats individualment per a aquesta galeria de fitxers",
"Save" => "Guardar",
"View inserted gallery" => "Visualitza la galeria inserida",
"System" => "Sistema",
"Maximum number of archives for each file" => "Nombre màxim d'arxius per a cada fitxer",
"Use" => "Ús",
"unlimited" => "sense límit",
"Parent gallery" => "Galeria mare",
"Owner of the gallery" => "Propietari de la galeria",
"Display Properties" => "Visualitza les propietats",
"Max description display size" => "Tamany màxim de la mostra de descripció",
"Please log in" => "Si us plau, Connecta't",
"Perhaps you are looking for:" => "Potser estaves cercant:",
"There are no wiki pages similar to '{\$page}'" => "No hi ha pàgines wiki similars a '{\$page}'",
"Go to Log in Page" => "Ves a la Pàgina per Connectar-te",
"Create this page" => "Crear aquest pàgina",
"(page will be orphaned)" => "(la pàgina es quedarà òrfena)",
"Close Window" => "Tanca Finestra",
"Go to" => "Ves a",
"Private Gallery" => "Galeria privada",
"Active Perms" => "Activar permisos",
"Open as WebFolder" => "Obre com a CarpetaWeb (webdav)",
"Archives" => "Arxius",
"Upload New Version" => "Puja una nova versió",
"Replace" => "Reemplaçar",
"Download and lock" => "Descarrega i bloqueja",
"Open in WebDAV" => "Obre a través de WebDAV",
"Name-filename" => "Nom-nom del fitxer",
"Filename only" => "Només el nom del fitxer",
"Show as a column" => "Mostra-ho com una columna",
"Show in popup box" => "Mostra en requadre emergent",
"Show an icon in a column" => "Mostra una icona en una columna",
"Exact&nbsp;match" => "Ocurrència&nbsp;exacta",
"any type" => "qualsevol tipus",
"all topic" => "tots els tòpics",
"any language" => "qualsevol idioma",
"any category" => "qualsevol categoria",
"Multiple select" => "Selecció múltiple",
"in:" => "en:",
"Number of displayed rows" => "Nombre de columnes mostrades",
"List View" => "Vista de Llista",
"Show php error messages" => "Mostra missatges d'error php",
"Folksonomy Tags" => "Marcadors de folcsonomia",
"Tags" => "Marques",
"Translate tags" => "Tradueix etiquetes",
"Images Galleries" => "Galeries d'Imatges",
"RSS Wiki" => "RSS del Wiki",
"RSS Blogs" => "RSS de les Bitàcoles",
"RSS Articles" => "RSS dels Articles",
"RSS Image Galleries" => "RSS de les Galeries d'Imatges",
"RSS File Galleries" => "RSS de les Galeries d'Arxius",
"RSS Forums" => "RSS dels Fòrums",
"RSS Maps" => "RSS dels Mapes",
"RSS Directories" => "RSS dels Directoris",
"RSS Calendars" => "RSS dels Calendaris",
"Show Tree" => "Mostra l'Arbre",
"Hide Tree" => "Amaga l'Arbre",
"Perform action with checked:" => "Amb els seleccionats, realitza l'acció:",
"Move Selected Files" => "Mou els arxius seleccionats",
"Are you sure you want to delete the selected files?" => "Segur que vols esborrar els següents arxius?",
"Assign Permissions" => "Assignar permisos",
"Move to" => "Mou a",
"Filename" => "Nom d'arxiu",
"Other Sorts" => "Altres ordenacions",
"No information" => "No hi ha informació",
"Blog post:" => "Publicació de bitàcola:",
"at:" => "a:",
"Somebody or you tried to subscribe this email address at our site:" => "Algú o vostè ha intentat subscriure la seva adreça email al nostre lloc:",
"To the newsletter:" => "Als butlletins de notícies:",
"Description:" => " Descripció",
"In order to confirm your subscription you must access the following URL:" => "Per poder confirmar la teva subscripció hauries d'accedir a l'adreça (URL) següent:",
"To validate your account and login to the site, please click on the following link:" => "Per validar el teu compte i connectar-te al lloc, clica a l'enllaç següent, si us plau:",
"The administrator approved your account." => "L'administrador ha aprovat el teu compte.",
"Confirm your email at %s" => "Confirma el teu correu-e a %s",
"Name:" => "Nom:",
"Author:" => "Autor:",
"User:" => "Usuari/a:",
"A new message was posted to forum" => "Un nou missatge ha estat escrit al fòrum",
"New topic:" => "Tòpic nou:",
"An anonymous user" => "Un usuaria anònim",
"You sent a request with the subject:" => "Has enviat una petició amb el tema:",
"Use the subject to indicate the operation to apply:" => "Utilitza l'assumpte per indicar quina operació s'ha d'aplicar:",
"GET:WikiName to get a wiki page" => "GET:NomWiki per obtenir una pàgina wiki",
"PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:NomWiki per actualitzar/crear una pàgina wiki (empra el cos per a les dades de la pàgina)",
"APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:NomWiki per afegir dades a una  pàgina Wiki (utilitza el cos per a les dades que vols afegir)",
"PREPEND:WikiName to append the data at the top" => "PREPEND:NomWiki per afegir les dades a sobre de tot",
"Tiki mail-in instructions" => "Intruccions de correu-dins del Tiki",
"Tiki mail-in auto-reply." => "Resposta automàtica del correu-dins de tiki.",
"Page not found:" => "Pàgina no trobada:",
"Hi," => "Hola,",
"A new message was posted to you at {\$mail_machine}" => "Un nou missatge ha estat escrit per a tu per {\$mail_machine}",
"New message arrived from %s" => "T'ha arribat un missatge nou de %s",
"Hi" => "Hola",
"Your account registration request for {\$mail_site} was validated by the site admin and your account is active now." => "El teu registre de nou compte de Tiki per al lloc {\$mail_site} ha estat validat per la persona administradora del lloc i ara el teu compte ja és actiu.",
"To login with your username and password, please follow this link:" => "Per connectar-te amb el teu nom d'usuari i contrasenya, segueix aquest enllaç, si us plau:",
"Enjoy the site!" => "Disfruta del lloc!",
"User Account Activated" => "Compte d'usuari Tiki activat",
"{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> ha demanat una nova contrassenya a {\$mail_site}, però primer has de validar el seu compte",
"has requested an account on" => "ha demanat un compte a",
"Group:" => "Grup:",
"To validate that account, please follow the link:" => "Per validar aquest compte, segueix aquest enllaç, si us plau:",
"User Tracker" => "Formulari d'usuaris",
"User Registration Request" => "Petició de Registre d'Usuari",
"Go to your friendship network to accept or refuse this request" => "Ves a la teva xarxa d'amistat per acceptar o rebutjar aquesta petició",
"You're invited to join my network of friends!" => "Estàs convidat/da a unir-te a la meva xarxa d'amistats!",
"The user" => "L'usuari/a",
"registered at your site" => "registrat al seu lloc",
"Bye bye!" => "Adéu!",
"This email address has been removed to the list of subscriptors of:" => "Aquesta adreça de correu-e ha estat esborrada de la llista de subscriptors de:",
"Newsletter:" => "Butlletí:",
"Bye bye from %s at %s" => "Fins aviat, de %s en %s",
"You can unsubscribe from this newsletter following this link" => "Pots desubscriure't d'aquest butlletí seguint aquest enllaç",
"Welcome to our newsletter!" => "Benvingut/da al nostre butlletí!",
"This email address has been added to the list of subscriptors of:" => "Aquesta adreça de correu-e ha estat afegida a la llista de subscriptors de:",
"You can always cancel your subscription using:" => "Sempre pots cancel.lar la teva subscripció emprant:",
"Welcome to %s at %s" => "Benvingut/da %s  %s",
"Email notification" => "Notificació de correu-e del Tiki",
"Someone" => "Alguna persona",
"requested a reminder of the password for your account" => "ha demanat un recordatori de la contrasenya del teu compte",
"requested password reset for your account" => "ha demanat que es posi una nova contrasenya per al teu compte",
"Since this is your registered email address we inform that the password for this account is" => "Com aquesta és la teva adreça registrada de correu-e, t'informem que la nova contrasenya per a aquest compte és",
"Important: Username & password are CaSe SenSitiVe" => "Important: el nom com a persona usuària i la contrasenya són sensibles a les Majúscules i minúscules",
"Important: The old password remains active if you don't click the link above." => "Important: La teva antiga contrasenya roman activa si no punxes sobre l'enllaç de més amunt.",
"Your account information for %s" => "La informació del teu compte Tiki per %s",
"Report for" => "Informe per a",
"Last Report sent on" => "Darrer informe enviat el",
"Look at this link:" => "Mira aquest enllaç:",
"A friend sends you a link from: " => "Un amic t'envia un enllaç des de: ",
"A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "{\$mail_user|username} ha enviat un nou article a {\$mail_site} el {\$mail_date|tiki_short_datetime}",
"You can edit the submission following this link:" => "Pots editar l'enviament seguint aquest enllaç:",
"Title:" => "Títol:",
"Heading:" => "Encapçalament:",
"Body:" => "Cos:",
"New article submitted at %s" => "Nou article enviat a %s",
"ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}" => "S'ha esborrat l'itemID {\$mail_itemId} {\$mail_item_desc} al formulari {\$mail_trackerName}",
"Download the file at:" => "Descarrega l'arxiu a:",
"item" => "ítem",
"was modified at" => "va ser modificat el",
"Please visit this link before login again:" => "Si us plau, visita aquest enllaç abans de connectar-te de nou:",
"Confirm your account at %s" => "Confirma el teu compte a %s",
"Your personal access to" => "El teu accés personal a",
"You or someone registered this email address at" => "tu o alguna persona ha registrat aquesta adreça de correu-e a",
"If you want to be a registered user in this site you will have to use the following link to login for the first time:" => "Si vols ser un usuari registrat en aquesta web hauràs de seguir aquest enllaç la primera vegada:",
"Your registration confirmation" => "El teu registre d'informació de Tiki",
"Your account request has been stored and will be activated by the admin as soon as possible." => "La teva petició de compte ha estat arxivada i serà activada per la persona administradora tan aviat com li sigui possible.",
"You'll receive email notification once your account is activated." => "Rebràs notificació per correu-e un cop ja s'hagi activat el teu compte.",
"Please do not attempt to login until you receive the email notification." => "Si us plau, no intentis connectar-te fins que rebis la notificació per correu-e.",
"{\$mail_action} article post" => "{\$mail_action} article publicat",
"{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} per {\$mail_user|username} el",
"View the article at:" => "Visualitza l'article a:",
"If you don't want to receive these notifications follow this link:" => "Si no vols rebre aquestes notificacions segueix aquest enllaç:",
"{\$mail_action} article post at" => "Publicació d'article {\$mail_action} a",
"New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "Nova publicació a la bitàcola: {\$mail_title}, \"{\$mail_post_title}\", per {\$mail_user|username} el {\$mail_date|tiki_short_datetime}",
"View the blog at:" => "Visualitza la bitàcola a:",
"New blog post at %s" => "Nova publicació a la bitàcola %s",
"View item calendar at:" => "Mostra l'entrada del calendari a:",
"Modified calendar item" => "Entrada del calendari modificada",
"New calendar item" => "Nova entrada al calendari",
"changed" => "modificat",
"A new category was created in" => "S'ha creat una nova categoria a",
"Created by" => "Creat por",
"created" => "creat",
"A category was removed in" => "S'ha eliminat una categoria a",
"Removed by" => "Eliminat per",
"removed" => "eliminat/da",
"A category was updated" => "S'ha actualitzat una categoria",
"Updated by" => "Actualitzat per",
"Old" => "Vell/a",
"New" => "Nou",
"updated" => "Actualitzat",
"File Gallery %s changed" => "La galeria d'arxius %s ha canviat",
"A file was removed from the file gallery" => "Es va eliminar un arxiu de la galeria d'arxius",
"A new file was posted to file gallery" => "S'ha pujat un nou arxiu a la galeria d'arxius",
"File Description" => "Descripció de l'arxiu",
"Image Gallery {\$galleryName} changed" => "Ha canviat la galeria d'imatges {\$galleryName}",
"A new file was posted to image gallery" => "Un nou arxiu s'ha publicat a la galeria d'imatges",
"The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "El mapa {\$mail_page} ha estat canviat per {\$mail_user|username} el {\$mail_date|tiki_short_datetime}",
"You can view the updated map following this link:" => "Pots veure el mapa actualitzat seguint aquest enllaç:",
"You can edit the map following this link:" => "Pots editar el mapa seguint aquest enllaç:",
"An object was added to category" => "S'ha afegit un nou objecte a la categoria",
"Added by" => "Afegit per",
"An object was removed from category" => "S'ha eliminat un nou objecte a la categoria",
"A page has been added to your watched sub-structure:" => "S'ha afegit una pàgina a la subestructura que estàs vigilant:",
"A page has been removed from your watched sub-structure:" => "S'ha afegit una pàgina a la subestructura que estàs vigilant:",
"A page has been promoted out your watched sub-structure:" => "S'ha mogut una pàgina fora de la subestructura que estàs vigilant:",
"A page has been demoted to your watched structure:" => "S'ha mogut una pàgina a la subestructura que estàs vigilant:",
"Structure modified" => "Estructura modificada",
"A new file have been attached to page" => "S'ha adjuntat un nou arxiu a la pàgina",
"File name" => "Nom de l'arxiu",
"New attachment on %s, page" => "Adjunt nou a la pàgina %s,",
"The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "La pàgina {\$mail_page} ha estat creada per {\$mail_user|username} el {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "La pàgina {\$mail_page} ha estat esborrada per  {\$mail_user|username} el {\$mail_date|tiki_short_datetime}",
"A file was attached to {\$mail_page}" => "S'ha afegit un nou arxiu a {\$mail_page}",
"The page {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "La pàgina {\$mail_page} ha estat canviada per {\$mail_user|username} el {\$mail_date|tiki_short_datetime}",
"Comment:" => "Comentari:",
"You can view the page by following this link:" => "Pots veure la pàgina si segueixes aquest enllaç:",
"You can view a diff back to the previous version by following this link:" => "Pots veure els canvis respecte la versió anterior si segueixes aquest enllaç:",
"The changes in this version follow below, followed after by the current full page text." => "Els canvis en aquesta versió són a sota, seguides després per la versió sencera actual del text de la pàgina.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Línies: {\$oldd} canviades per +Línies: {\$newd}",
"The new page content follows below." => "El nou contingut de la pàgina segueix a sota.",
"Wiki page %s created by {\$mail_user|username}" => "La pàgina %s ha estat creada per {\$mail_user|username}",
"Wiki page %s deleted by {\$mail_user|username}" => "La pàgina %s ha estat esborrada per {\$mail_user|username}",
"A file was attached to %s" => "S'ha adjuntat un arxiu a %s",
"Wiki page %s changed by {\$mail_user|username}" => "Pàgina wiki %s canviada per {\$mail_user|username}",
"The page {\$mail_page} was commented by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "La pàgina {\$mail_page} ha estat comentada per {\$mail_user|username} el {\$mail_date|tiki_short_datetime}",
"Wiki page %s was commented on by" => "La pàgina Wiki %s ha estat comentada per",
"an anonymous user" => "un usuari anònim",
"Wiki page renamed" => "La pàgina Wiki ha estat reanomenada",
"Old name" => "Nom vell",
"New name" => "Nou nom",
"Thank you for your registration." => "Gràcies per registrar-te.",
"You may log in now." => "Ara pots connectar-te.",
"click on the map to zoom or pan, do not drag" => "fes clic a sobre del mapa per ampliar o allunyar, no arrosseguisr",
"Query Results" => "Resultats de la consulta",
"Querying" => "Consultant",
"Scroll Up" => "Desplaça cap a munt",
"Scroll Down" => "Desplaça cap a baix",
"Scale" => "Escala",
"Query" => "Consulta",
"Redraw" => "Redibuixar",
"select zoom/pan/query and image size" => "seleccionar zoom/pan/consulta i tamany d'imatge",
"View the Map Only" => "Veure només el mapa",
"Reset Map" => "Reinicia el mapa",
"Click on the map or click redraw" => "Fes clic a sobre del mapa o fes clic a redibuixar",
"Overview" => "Vista Esquema",
"Legend" => "Llegenda",
"Layer Manager" => "Control de Capa",
"Layer" => "Capa",
"Download Layer" => "Capa de Descàrrega",
"This layer has been set by the maps administrator to not be downloadable" => "Aquesta capa ha estat configurada per l'administrador del mapa perquè no sigui descarregable",
"you have requested to download the layer:" => "has demanat descarregar la capa:",
"Here are the files to download, do not forget to rename them:" => "Aquí hi ha els fitxers a descarregar-se, no t'oblidis de renombrar-los:",
"Mapfiles" => "Fitxers de mapa",
"Mapfile" => "Fitxer de mapa",
"Available mapfiles" => "Permés mapa d'arxius",
"hits last 7 days" => "visites dels últims set dies",
"monitor this map" => "Segueix aquest mapa",
"Stop Monitoring this Map" => "Deixa de seguir aquest  mapa",
"Create a new mapfile" => "Crear un nou mapa de l'arxiu",
"Create" => "Crear",
"Mapfile listing" => "Llista de Mapfiles",
"Reload" => "Recarrega",
"You can view this map in your browser using" => "Pots veure aquest mapa en el teu navegador emprant",
"Zoom out x2" => "Disminuir zoom x2",
"Zoom in x2" => "Augmentar zoom x2",
"Mapfile History" => "Historial de fitxers de mapa",
"of" => "de",
"Compare" => "Comparar",
"Comparing version {\$old.version} with version {\$new.version}" => "Comparant la versió {\$old.version} amb la versió {\$new.version}",
"Version:" => "Versió:",
"Current" => "Actual",
"Versions are identical" => "Les versions són idèntiques",
"Legend:" => "Llegenda:",
"v=view" => "v=visualització",
"c=compare" => "c=compara",
"d=diff" => "d=dif",
"Diff" => "Dif",
"Older Version" => "Versió més vella",
"back to" => "torna a",
"Upload From Disk:" => "Puja des de Disc:",
"Upload Files" => "Puja fitxers",
"Bytes maximum" => "Octets màxim",
"Create Directory:" => "Crear Directori:",
"index file (.shp):" => "arxiu índex (.shp):",
"files to index (regexp):" => "arxius a indexar (regexp):",
"Message Archive" => "Arxiu de missatges",
"messages" => "missatges",
"Archive is full!" => "L'arxiu és ple!",
"Unread" => "No llegit",
"Flagged" => "Senyalat",
"Unflagged" => "Desmarcat",
"Containing" => "Contingut",
"Sender" => "remitent",
"No messages to display" => "No hi ha cap missatge per mostrar",
"Broadcast message" => "Difondre un missatge",
"Confirmation" => "Confirmació",
"Please Confirm" => "Si us plau, confirma-ho",
"All users" => "Tots els usuaris",
"Lowest" => "El més baix",
"Very High" => "Molt Alt",
"Send" => "Envia",
"Compose message" => "Escriu un missatge",
"If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences." => "Si vols que la gent et pugui respondre, habilita l'opció <a href='tiki-user_preferences.php'>Permet missatges d'altres usuaris</a> a les teves preferències.",
"Invalid" => "Invàlid",
"Multiple addresses can be separated with semicolons (\\\";\\\")" => "Es poden separar múltiples adreces per punt i coma (\\\";\\\")",
"or commas (\\\",\\\")" => "o coma (\\\",\\\")",
"Reply-to my email" => "Respon-me al meu correu-e",
"Send me a copy" => "Envia'm una còpia",
"No messages to download" => "No hi ha missatges per descarregar",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "La bústia de correu és plena! Esborra o arxiva alguns missatges si vols rebre'n més.",
"is reply to" => "és resposta a",
"Find replied message" => "busca missatges contestats",
"Mark as read" => "Marca com llegit",
"Mark as unread" => "Marca com no llegit",
"Mark as flagged" => "Marca com a senyalat",
"Mark as unflagged" => "Marca com no senyalat",
"Mark" => "marca",
"Mailbox" => "Bústia",
"Compose" => "Redacta",
"Broadcast" => "Difon",
"Sent" => "Enviat",
"Auto-archive age for read messages:" => "Edat d'autoarxivament per als missatges llegits:",
"Read message" => "Llegeix missatge",
"Return to mailbox" => "Retorna a la bústia de correu",
"replyall" => "respondre tot",
"Unflag" => "Desmarca",
"Flag this message" => "Marca aquest missatge",
"From:" => "de part de:",
"Return to archive" => "Torna a l'arxiu",
"Return to outbox" => "Torna a la bústia de sortida",
"Sent Messages" => "Missatges enviats",
"Replied" => "Respost",
"Not replied" => "No repost",
"move to archive" => "mou a l'arxiu",
"receiver" => "receptor",
"'name' parameter for tikimodule missed" => "'nom del paràmetre pel mòdul tiki no trobat",
"Move module up" => "Pujar mòdul",
"Move module down" => "Baixar mòdul",
"Move module to opposite side" => "Moure mòdul al costat oposat",
"opp side" => "banda contrària",
"Unassign this module" => "Desassigna aquest mòdul",
"Are you sure you want to unassign this module?" => "Segur que vols desassignar aquest mòdul?",
"Toggle module contents" => "Intercanvia el contingut del mòdul",
"toggle" => "intercanvia",
"Display type unknown, you have to enter the banner type" => "Tipus de pantalla desconegut, has d'introduir el tipus de pancarta",
"You forgot your Google ad_client number !" => "Heu oblidat el vostre número de Google ad_client!",
"Thank you for installing Tikiwiki" => "Gràcies per instal·lar Tikiwiki",
"To configure your Tiki" => "Per configurar el teu Tiki",
"Select" => "Seleccionar",
"Admin Home" => "Admin Inici",
"Admin" => "Administrar",
"from the menu" => "des del menú",
"Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Llegeix la <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Documentació de Tikiwiki\" target=\"_blank\">documentatió de configuració</a>",
"Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Mira els <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">videos de demostració",
"To remove this module" => "Per eliminar aquest mòdul",
"Admin Modules" => "Administració de Mòduls",
"Modules" => "Mòduls",
"and remove the assistant module" => "i eliminar el mòdul de l'assistent",
"You can also add other modules" => "Pots afegir també altres mòduls",
"To customize the menu" => "Per adaptar el menú",
"Admin Menus" => "Administració de Menús",
"Menus" => "Menús",
"and edit menu ID 42" => "i edita el menú ID 42",
"Or, create your own menu and add it to a module" => "O, crea el teu propi menú i afegeix-ho com a mòdul",
"To begin configuring Tiki, please" => "Per començar a configurar Tiki, si us plau",
"login" => "connecta't",
"as admin" => "com l'Administrador",
"The Tikiwiki Community" => "La Comunitat Tikiwiki",
"Tikiwiki Documentation" => "Documentació de Tikiwiki",
"For help, visit <a href=\"http://doc.tiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "Per ajuda, visita <a href=\"http://doc.tiki.org\" title=\"Documentació de Tikiwiki\" target=\"_blank\">http://doc.tiki.org</a>",
"Published on" => "Publicat el",
"private" => "privat",
"on blogpost" => "a blogpost",
"Add event" => "Afegeix esdeveniment",
"Apply" => "Aplica",
"Pages:" => "Pàgines:",
"empty" => "buit",
"low" => "baixa",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Posa marques separades per espais. Per a marques amb més d'una paraula, no empris espais i posa les paraules juntes o bé envolta-les per dobles cometes",
"Add tags" => "Afegeix etiquetes",
"List everything tagged" => "Llista tot el que estigui etiquetat",
"insert original" => "inserta l'original",
"insert thumbnail" => "insert el contacte",
"more" => "més",
"You" => "Tu",
"Open operator console" => "Obre la consola d'operador",
"Log in" => "Connecta't",
"Log out" => "Desconnecta't",
"Switch User" => "Canvia't per l'Usuari",
"Switch" => "Canvi",
"Switch user" => "Canvia usuari",
"Invalid password" => "Contrasenya invàlida",
"Email:" => "Correu-e:",
"Click here to register" => "Fes clic aquí per registrar-te",
"Click here if you've forgotten your password" => "Fes clic aquí si has oblidat la teva contrasenya",
"I forgot my password" => "He oblidat la meva contrasenya",
"Click here to login using the default security protocol" => "Fes clic aquí per entrar usant el protocol de seguretat per defecte",
"Standard" => "Estàndar",
"Click here to login using a secure protocol" => "Fes clic aquí per entrar usant un protocol segur",
"Secure" => "Segur",
"local account" => "compte local",
"You have" => "Teniu",
"new messages" => "nous missatges",
"new message" => "nou missatge",
"You have 0 new messages" => "No teniu cap missatge nou",
"We have" => "Tenim",
"submissions waiting to be examined" => "col·laboracions esperant ser examinades",
"Image Galleries" => "Galeries d'imatges",
"Calendars" => "Calendaris",
"Entire Site" => "Lloc complet",
"Image Gals" => "Imatges Gals",
"Read More" => "Llegeix més",
"Since your last visit on" => "Des de la teva última visita el...",
"New Images" => "Imatges noves",
"Wiki Pages Changed" => "Pàgines del wiki modificades",
"New Files" => "Arxius nous",
"New Comments" => "Comentaris nous",
"New Tracker Items" => "Nous ítems del formulari",
"New Calendar Events" => "Nous Esdeveniments al Calendari",
"New Users" => "Usuaris/es nous/ves",
"click to edit" => "fes clic per editar",
"Nothing has changed" => "Res no ha canviat",
"Users" => "Usuaris",
"Site Language:" => "Idioma del Lloc: ",
"Site default" => "El que hi ha per defecte a aquest lloc",
"Top galleries" => "Galeries per dalt",
"There are no translations of this page." => "No hi ha traduccions d'aquesta pàgina.",
"update from it" => "actualitza-ho des d'ella",
"None match your" => "Cap encaixa amb els teus",
"Set your preferred languages." => "Especifica el teu idioma preferit.",
"preferred languages" => "idiomes preferits",
"view" => "veure",
"update it" => "actualitza des d'ella",
"click to view" => "punxa per veure",
"Add Event" => "Afegeix Esdeveniment",
"Bookmarks" => "Adreces d'interès",
"Cache" => "Memòria cau",
"Done" => "fet",
"Del" => "Esb",
"select" => "selecciona",
"Logout" => "Desconnecta't",
"Refresh" => "Refrescar",
"online users" => "usuaris en línia",
"online user" => "usuari en línia",
"on host" => "al servidor",
"Send a message to" => "Envia un missatge a",
"Send a message" => "Envieu un missatge",
"No individual permissions, category permissions apply" => "No hi ha permisos individuals; s'apliquen els permisos de categoria",
"There are individual permissions set for this tracker" => "Hi ha permisos individuals per a aquest formulari",
"No individual permissions. Global permissions apply." => "No hi ha permisos individuals, s'aplicaràn els permisos globals",
"vote" => "vota",
"Requires" => "Requireix",
"Rate" => "Qualificació",
"A valid email is mandatory to register" => "Cal una adreça de correu-e vàlida per enregistrar-te",
"Use your email as login" => "Empra el teu correu-e com a nom per connectar-te",
"Minimum {\$prefs.min_username_length} characters long" => "Com a mínim calen {\$prefs.min_username_length} caràcters de longitud",
"Minimum {\$prefs.min_pass_length} characters long" => "Com a mínim calen {\$prefs.min_pass_length} caràcters de longitud",
"Generate a password" => "Generar una contrasenya",
"Send Newsletter" => "Envia el Butlletí",
"To edit the copyright notices" => "Per editar els avisos de Copyright",
"Click Here" => "Cliqueu aquí",
"The content on this page is licensed under the terms of the" => "El contingut d'aquesta pàgina està sota llicència amb els termes de",
"Design by" => "Dissenyat per",
"Jump to Content" => "Salta al Contingut",
"Fullscreen" => "Pantalla Sencera",
"Cancel Fullscreen" => "Cancel·la Pantalla Sencera",
"Show/Hide Left Menus" => "Mostra/Amaga menús de l'esquerra",
"Show/Hide Right Menus" => "Mostra/Amaga menús de la dreta",
"Report to Webmaster" => "Informa als administradors web",
"Powered by" => "Basat en",
"Made with" => "Fet amb",
"powered by" => "potenciat per",
"Wiki RSS" => "Alimentacions RSS per al Wiki",
"RSS feed" => "Alimentació RSS",
"Blogs RSS" => "Alimentacions RSS per a Bitàcoles",
"Articles RSS" => "Alimentacions RSS per a Articles",
"Image Galleries RSS" => "Alimentació RSS de Galeries d'imatges",
"File Galleries RSS" => "Alimentacions RSS per a Galeries d'Arxius",
"Forums RSS" => "Alimentacions RSS per a Fòrums",
"Maps RSS" => "Alimentacions RSS per a Mapes",
"The Tiki Community" => "La Comunitat de Tiki",
"Last update from SVN" => "Darrera actualització a partir de SVN",
"Execution time" => "Temps d'execució",
"secs" => "segs",
"Memory usage" => "Memòria d'ús",
"database queries used in " => "crides a la base de dades a ",
"Server load" => "Càrrega del servidor",
"Login through CAS" => "Connexió a través de CAS",
"Show/Hide Left Column" => "Mostra/Amaga Menús de l'esquerra",
"Show/Hide Right Column" => "Mostra/Amaga Menús de la dreta",
"Do not group by item" => "No agrupis per ítem",
"Group by item" => "Agrupa per ítem",
"Calendar View" => "Vista de Calendari",
"Tiki Action Calendar" => "Calendari d'accions del Tiki",
"Tools Calendars" => "Eines de Calendaris",
"Check / Uncheck All" => "Marcar / desmarcar tot",
"Configuration search" => "Cerca als panells de configuració",
"Search error" => "Error de cerca",
"Preferences Search Results" => "Resultats de la Cerca de Preferències",
"Change" => "Canvia",
"No results" => "Sense resultats",
"Database Version Problem" => "Hi ha un problema amb la versió de la base de dades",
"Enabled" => "Permès",
"Changed" => "Canviat",
"Preference" => "Preferència",
"Crosslinks to other features and settings" => "Enllaços creuats a altres funcionalitats i especificacions",
"Other sections" => "Altres seccions",
"Shoutbox Words" => "Paraules del Requadre d'Avisos",
"Live Support" => "Suport en directe",
"Administration features" => "Administració de Funcionalitats",
"TikiCache/System" => "TikiCache/Sistema",
"SysLogs" => "Registres del systema",
"Banning" => "Prohibició",
"Edit Languages" => "Edita els Idiomes",
"Transitions" => "Transicions",
"Transversal features" => "Funcionalitats transversals",
"which apply to more than one section" => "que s'apliquen a més d'una secció",
"Mail Notifications" => "Notificacions per correu",
"Navigation features" => "Funcionaliats de navegació",
"Look & feel" => "Aparença",
"themes" => "temes",
"Text area features" => "Funcionalitats de l'àrea de text",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "funcionalitats que pots emprar en totes les arees de text, com pàgines wiki, bitàcoles, articles, fòrums, etc",
"Cookies" => "Galetes",
"Toolbars" => "Barres d'eines",
"Stats &amp; banners" => "Estadístiques &amp; i pancartes",
"Search Stats" => "Estadística de cerca",
"Report" => "Informes",
"Start:" => "Inici:",
"End:" => "Final:",
"Category:" => "Categoria:",
"Units" => "Unitats",
"Contibution Time" => "Unitats de freqüència per als informes de contribucions",
"Records:" => "Registres:",
"contribution" => "tipus de contribució",
"Statistics" => "Estadístiques",
"Weeks" => "Setmanes",
"Settings" => "Configuració",
"Setting" => "Configuració",
"Wiki page actions except viewed will always be recorded but can be not reported." => "Les accions en pàgines wiki (excepte les de visualització) sempre es registren però es pot selecionar que no es mostrin als informes.",
"Recorded" => "Registrat",
"Reported" => "Mostrat a l'informe",
"Rule title" => "Titol de la regla",
"Username regex matching" => "Apaarellament de regex de nom d'usuari",
"IP regex matching" => "IP comprovació",
"Banned from sections" => "Expulsat de les seccions",
"Rule activated by dates" => "Regla activada per dates",
"Rule active from" => "Regla activa desde",
"Rule active until" => "Regla activa fins",
"Custom message to the user" => "Personalitzar missatge a l'usuari/a",
"Rules" => "Regles",
"User/IP" => "Usuari/a-IP",
"Sections" => "Seccions",
"Admin Calendars" => "Administrar Calendaris",
"View Calendars" => "Mostra els Calendaris",
"Import" => "Importa",
"List of Calendars" => "Llista de calendaris",
"Lang" => "Idm",
"Subscription" => "Subscripció",
"View Calendar" => "Visualitza el Calendari",
"Create / Edit Calendar" => "Crea / Edita el Calendari",
"Create/Edit Calendars" => "Crea/Edita calendaris",
"Custom Locations" => "Personalitzar Llocs",
"Custom Participants" => "Participants customitzats",
"Custom Languages" => "Personalitzar Idiomes",
"Custom URL" => "URL personalitzada",
"Custom Subscription List" => "Llista de subscripcions customitzada",
"Custom Priorities" => "Personalitzar Prioritats",
"Personal Calendar" => "Calendari personal",
"Start of day" => "Inici del dia",
"End of day" => "Final del dia",
"Standard Colors" => "Colors estàndard",
"Green" => "Verd",
"Blue" => "Blau",
"Purple" => "Violeta",
"Red" => "Vermell",
"Orange" => "Taronja",
"Yellow" => "Groc",
"Let me select my own colors" => "Deixa'm escollir els meus propis colors",
"Custom foreground color" => "Color de davant personalitzat",
"Custom background color" => "Color del fons personalitzat",
"Default event status" => "Estatus de l'esdeveniment per omissió",
"Show in calendar view" => "Mostra a la vista de calendari",
"Group of users alerted when calendar event is modified" => "Grup d'usuaris a avisar quan un esdeveniment del calendari sigui modificat",
"Browse the category system" => "Navega pel sistema de categories",
"Current category" => "Categoria actual",
"Current Category ID:" => "Category Actual amb ID:",
"Child categories" => "Subcategories",
"Edit permissions for this category" => "Edita els permisos per a aquesta categoria",
"Edit this category:" => "edita aquesta categoria:",
"Create New" => "Crear nou",
"Add new category" => "Afegeix una nova categoria",
"Batch upload" => "Puja al rerafons",
"Batch upload (CSV file)" => "Pujada en bloc (arxiu CSV)",
"Objects in category" => "Objectes en la categoria",
"No records found." => "No s'han trobat registres.",
"Add objects to category" => "Afegir objectes a la categoria",
"Admin templates" => "Admin plantilles",
"Edit this template:" => "Edita aquesta plantilla:",
"Create new template" => "Crea una nova plantilla",
"CMS" => "SGC (CMS)",
"HTML Pages" => "Pàgines HTML",
"Text area" => "Àrea de Text",
"Templates" => "Plantilles",
"Admin Contributions" => "Administrar Tipus de Contribucions",
"Edit the contribution:" => "Edita el tipus de contribució:",
"Contributions are mandatory in wiki pages" => "És obligatori especificar tipus de contribucions en les pàgines wiki",
"Contributions are mandatory in forums" => "És obligatori especificar tipus de contribucions en els fòrums",
"Contributions are mandatory in comments" => "És obligatori especificar tipus de contribucions en els comentaris",
"Contributions are displayed in the comment/post" => "Es mostren els tipus de contributions en els comentaris/publicacions",
"Create a new contribution" => "Crea un nou tipus de contribució",
"List of contributions" => "Llista de tipus de contribucions",
"Admin cookies" => "Administrar cookies",
"To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}." => "Per utilitzar una galeta en una àrea de text (pàgina wiki, etc.), un mòdul <a class=\"rbox-link\" href=\"tiki-admin_modules.php\"> </a> o una plantilla, utilitza {literal}{cookie}{/literal}.",
"Create/edit cookies" => "Crear/editar galetes",
"Upload Cookies from textfile" => "Puja Galetes des d'un arxiu de text ",
"Upload from disk:" => "Puja des del disc",
"Upload" => "Puja",
"Remove all cookies" => "Esborrar totes les cookies",
"cookie" => "galeta",
"Creation Date" => "Data de creació",
"Expiration Date" => "Data de caducitat",
"all types" => "tots els tipus",
"filter" => "filtra",
"Admin DSN" => "Administrar dsn",
"Use Admin DSN to define the database to be used by the SQL plugin." => "Empra Admin DSN per definir la base de dades a ser emprada pel connector 'SQL plugin'.",
"Create/Edit External Wiki" => "Crea/Edita un Wiki External",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (empra \$page per ser reemplaçat pel nom de la pàgina a l'exemple d'URL: http://www.example.com/tiki-index.php?page=\$page)",
"ExtWiki" => "Wikiext",
"Admin Forums" => "Administrar fòrums",
"Create New Forum" => "Crear un Nou Fòrum",
"Duplicate Forum" => "Duplica el Fòrum",
"Import forums" => "Importa fòrums",
"List forums" => "Llista de fòrums",
"Age" => "Edat",
"PPD" => "Ppd",
"Edit this Forum:" => "edita aquest fòrum:",
"Create new" => "Crea nou",
"Password protected" => "Contrasenya protegida",
"Forum password" => "Contrasenya del Fòrum",
"Topic list configuration" => "Configuració de la llista de tòpics",
"Posts can be rated" => "Les publicacions poden ser puntuades",
"Display last post titles" => "Mostra darrers títols enviats",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Missatges reenviats a aquest fòrum per a aquesta adreça d'e-mail , en un format que pot ser emprat per a retornar a la primera adreça d'e-mail",
"Send mails even when the post is generated by inbound mail" => "Envia correus-e encara que un correu d'entrada hagi generat la publicació",
"Append a reply link to outbound mails" => "Afegeix un enllaç de resposta als correus enviats",
"Originating e-mail address for mails from this forum" => "Originant adreça d'e-mail  per a correus des de aquest fòrum",
"Add messages from this email to the forum" => "Afegeix missatges d'aquest correu-e al fòrum",
"Use topic smileys" => "Empra emoticons",
"Show topic summary" => "Mostra el resum del tòpic",
"User information display" => "Mostra de la informació de l'usuari/a",
"eMail" => "Correu-e",
"Approval type" => "Tipus d'Aprovació",
"Store attachments in:" => "Guardar adjunts a:",
"Duplicate perms" => "Duplica els permisos",
"Admin Hotwords" => "Admin paraules calentes",
"Add Hotword" => "Afegeix una paraula clau",
"Word" => "Paraula",
"Admin HTML pages" => "Administra pàginas HTML",
"Edit this page" => "edita aquesta pàgina",
"View page" => "Visualitza la pàgina",
"Edit zone" => "Edita zona",
"Content" => "Contingut",
"Dynamic zones" => "Zones dinàmiques",
"zone" => "zona",
"content" => "contingut",
"Mass update" => "Actualització massiva",
"Create new HTML page" => "Crea una nova pàgina HTML",
"Edit this HTML page:" => "Edita aquesta pàgina HTML:",
"Apply template" => "Aplica plantilla",
"Dynamic" => "Dinàmic",
"Static" => "Estàtic",
"Last Modif" => "Darrera modificació",
"Cancel Edit" => "Cancel·la edició",
"Change preferences" => "Canviar preferències",
"Site Ads and Banners" => "Anuncis i pancartes del lloc",
"Features" => "Funcionalitats",
"Community" => "Comunitat",
"Profiles" => "Perfils",
"i18n" => "i18n (Internacionalització i idiomes)",
"Internationalization and localization - mulitlingual features" => "Funcionalitat multilíngües d'internationalització (i18n) i localizació (l10n)",
"Editing and Plugins" => "Edició i connectors (Plugins)",
"Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Aspectes relacionats amb l'edició de text aplicables a molts àrees. Activació de connectors (plugins) i gestió dels alias de connectors",
"Meta Tags" => "Meta Etiquetes",
"Performance" => "Rendiment",
"Site security settings" => "Aspectes de configuració del lloc",
"Feeds" => "Alimentacions",
"Web feeds" => "Alimentacions Web",
"Connect" => "Connecta",
"Wiki page settings and features" => "Configuració i funcionalitats de pàgines Wiki",
"User files" => "Fitxers de l'usuari",
"To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "Per afegir/eliminar bitàcoles, ves a \"Crea/Edita bitàcola\" dins de \"Bitàcoles\" en el menú principal de l'aplicació, o",
"General Settings" => "Configuracions Generals",
"To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "Per afegir/eliminar calendaris, cerca \"Calendari\" dins de \"Admin\" en el menú principal de l'aplicació, o",
"Change settings" => "Canvia els paràmetres",
"Browse categories" => "Navega per les categories",
"Administer categories" => "Administra categories",
"Plugins" => "Connectors (Plugins)",
"Look under \"Articles\" on the application menu for links to" => "Cerca dins de \"Articles\", en el menú principal de l'aplicació, per enllaços a",
"Import CSV file" => "Importeu un fitxer CSV",
"List Articles" => "Llista d'Articles",
"General Preferences" => "Preferències Generals",
"Permission" => "Permís",
"Admin Groups" => "Administració de grups",
"Admin Users" => "Administrar usuaris",
"Users Default Preferences" => "Preferències per defecte per als nous usuaris",
"My Tiki" => "El meu Tiki",
"Copyright allows to determine a copyright for all the objects of tikiwiki" => "El copyright permet determinar un copyright per a tots els objectes del tikiwiki",
"To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "Per configurar el teu directori, troba \"Admin directori\" dins de \"Directori\" en el menú principal de l'aplicació, o",
"To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "Per afegir/eliminar PUFs, cerca \"Admin FAQs\" dins de \"PUFs\" en el menú principal de l'aplicació, o",
"Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site." => "Si us plau, consulta l'<a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>avaluació de cada funcionalitat</a> al lloc web de documentació de Tiki.",
"Watches" => "Avisos",
"Experimental" => "Experimentals",
"Logging and Reporting" => "Registres i informes",
"Visible to admin only" => "Visible només a l'admin",
"Include Smarty notices" => "Inclous avisos d'Smarty",
"Custom Code" => "Codi Adaptat",
"Feedback" => "Retroalimentació",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Si decideixes guaradr arxius en un directori, t'has assegurar que l'usuari no pot accedir directament el directori.",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Tens dues opcions per aconseguir això:<br /><ul><li>Empra un directori fora de la teva carpeta arrel de documents web; assegura't que els teus arxius mphp poden llegir i esciure a aquest directori</li><li>Empra un directori dins la carpeta arrel de documents web i empra .htaccess per prevenir que l'usuari pugui llistar el contingut d'aquest directori</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Per configurar la ruta al directori empra rutes estil UNIX; per exemple arxius/ o c:/foo/arxius o /www/arxius/",
"Enable now" => "Habilita-ho ara mateix",
"MIME Type" => "Tipus MIME",
"Reindex all files for search" => "Reindexa tots els arxius per a la cerca",
"To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "Per afegir/eliminar fòrums, cerca \"Admin fòrums\" dins de \"Fòrums\" en el menú de principal l'aplicació, o",
"Searches" => "Cerques",
"Tag Management" => "Gestió d'Etiquetes",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Per afegir/eliminar galeries d'imatges, ves a \"Galeries d'Imatges\" en el menú de principal l'aplicació, o",
"You can upload images of a size of " => "Pots pujar imatges fins la mida de ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Altera les variables de l'arxiu php.ini file_uploads, upload_max_filesize, post_max_size i database variables (max_allowed_packet for mysql) per canviar aquest valor",
"Home Gallery" => "Galeria inicial",
"Galleries features" => "Preferència de galeries",
"Uses Slideshow" => "Empra Pasi de diapos",
"Use database to store images" => "Empra la base de dades per desar les imatges",
"Use a directory to store images" => " Empra el directori per desar les imatges",
"Directory path" => "Ruta cap al directori",
"Library to use for processing images" => "Llibreria per a fer servir per a processament d'imatges",
"Uploaded image names must match regex" => "Els noms de les imatges penjades han de coincidir amb el regex",
"Uploaded image names cannot match regex" => "Els noms de les imatges penjades no han de coincidir amb el regex",
"Directory Batch Loading" => "Directori per Pujades en Bloc",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "Si habilites el Directori per Pujades en Bloc, necessites configurar un directori llegible per la web (fora del teu espai web és millor). Llavors posa a punt una manera per pujar les teves imatges en aquest directori, sigui via scp, sftp, ssh, ftp, o altres protocols",
"Enable directory batch loading" => "Habilita la carrega en bloc al directori",
"Batch loading directory" => "Directori per càrregues en bloc",
"Max Rows per page" => "Files màx. per pàgina",
"Images per row" => "Imatges per fila",
"Thumbnails size X" => "Mida x per a miniatures",
"Thumbnails size Y" => "Mida Y per a miniatures",
"pixels" => "píxels",
"Set features" => "Fixar Funcionalitats",
"Exterminator" => "Exterminador",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Treure imatges de la galeria del sistema, no emprades en pàgines wiki, galeries o publicacions de les bitàcoles",
"Mover" => "Translocador",
"Move images from database storage to filesystem storage" => "Moure les imatges des de l'emmagatzematge en base de dades a l'emmagatzematge en el sistema d'arxius",
"Move images from filesystem storage to database storage" => "Moure les imatges des de l'emmagatzematge en el sistema d'arxius a l'emmagatzematge en base de dades",
"All galleries" => "Totes les galeries",
"System Gallery" => "Galeria del sistema",
"Move images from old filesystem store to new directory" => "Moure les imatges des de l'emmagatzematge en sistema d'arxius vell al nou directori",
"Moved" => "Moguts/des",
"Gallery listing configuration" => "Configuració de llistat de galeries",
"Change configuration" => "Canvia la configuració",
"Image galleries comments settings" => "Configuració dels comentaris de les galeries d'imatges",
"Reset or upgrade your database" => "Torna a especificar o actualitza la teva base de dades",
"Site Identity" => "Identitat del Lloc",
"Server" => "Servidor",
"Contact" => "Contacte",
"Miscellaneous" => "Miscel·lània",
"Home Page" => "Pàgina Inicial",
"Site Access" => "Accés al lloc",
"Date and Time" => "Data i Hora",
"Date and Time Format Help" => "ajuda Data i Format de Temps",
"Change admin password" => "Canviar contrasenya de l'administrador",
"User administration" => "Administració d'usuaris",
"Defaults" => "Per omissió",
"Internationalization" => "Internacionalització (I18n)",
"Edit or export/import Languages" => "Edita o exporta/importa Idiomes",
"Babelfish links" => "Enllaços de Babelfish",
"Customized String Translation" => "Traducció de cadenes de text a mida",
"Syntax error" => "Error de Sintaxi",
"ok" => "d'acord",
"The file has been saved" => "S'ha desat l'arxiu",
"Intertiki client" => "Client InterTiki",
"Tiki Unique key" => "Clau Tiki Única",
"InterTiki Slave mode" => "Mode esclau de l'InterTiki",
"Warning: overrides manually registered local users" => "Avís: sobreescriu manualment els usuaris locals registrats",
"as master" => "com a mestre",
"Import user preferences" => "Importa les preferències d'usuari",
"Import user groups" => "Importa els grups d'usuari",
"Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Limita la importació de grups (llista separada per comes de grups importats, deixa en blanc per evitar la limitació)",
"InterTiki Server" => "Servidor InterTiki",
"host" => "servidor",
"Add new server" => "Afegeix nou servidor",
"Intertiki server" => "Servidor Intertiki",
"Intertiki Server enabled" => "Servidor Intertiki disponible",
"Access Log file" => "Arxiu de registre d'accessos",
"Errors Log file" => "Fitxer de registre d'errors",
"Known hosts" => "Servidors coneguts",
"Key" => "Clau",
"Enable/disable Tiki features in " => "Habilita/deshabilita funcionalitats de Tiki en ",
", but configure them elsewhere" => ", però configura-les en un altres lloc",
"Look & Feel" => "Aparença",
"Wysiwyg" => "Wysiwyg (Editor Visual)",
"Video streaming integration" => "Integració d'streaming de Vídeo",
"Social Networks" => "Xarxes Socials",
"Registration" => "Registre",
"Requires PHP GD library" => "Requereix la llibreria PHP GD",
"Restrict available themes" => "Restringeix els temes d'estètica disponibles",
"View Templates" => "Visualitza les plantilles",
"General Layout options" => "Opcions generals de format",
"Site Report Bar" => "Barra d'Informes del Lloc",
"Pagination links" => "Enllaços de Paginació",
"Admin layout per section" => "Administra formats per seccions",
"Examples" => "Exemples",
"Generate User Map" => "Genera Mapa d'usuaris",
"Memory" => "Memòria",
"Hit" => "Cop",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Per afegir/eliminar consultes, cerca \"Consultes\" dins d'\"Admin\" en el menú principal de l'aplicació, o",
"Waiting" => "Esperant",
"Profile" => "Perfil",
"Last update" => "Última actualització",
"Specification" => "Especificació",
"Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public." => "Permetre guardar una còpia en memoria cau manarà per sobre dels permisos existents - tot el contingut serà públic. Habilita aquesta opció <strong>només</strong> si el teu contingut sindicat hauria de ser públic.",
"Feed for directories" => "Contingut per als directoris",
"You can see users rank by score in the module users_rank, for that go to" => "Pots veure un ranking d'usuaris per puntuació en el mòdul de ranking d'usuaris (users_rank); si t'interessa, ves a",
"Admin modules" => "Admin moòuls",
"Expiration" => "Caducitat",
"can be seen on page" => "pot ser vist a la pàgina",
"in Admin menu" => "al menú d'Administració",
"Refresh wiki search index now" => "Refresca l'index de cerca wiki ara",
"Refresh trackers search index now" => "Refresca ara l'índex de cerca de formularis",
"Refresh tracker search index now" => "Refresca ara l'índex de cerca de formulari",
"Refresh files search index now" => "Refresca l'índex de cerca ara mateix",
"Please also see:" => "Si us plau, mira també:",
"Search results" => "Resultats de la cerca",
"Text area (that apply throughout many features)" => "Àrea de text (que té aplicació a través de moltes funcions)",
"Enable" => "Habilita",
"Plugin Aliases" => "Aliases de connectors (Plugins)",
"Required" => "Requerit",
"Parameters" => "Paràmetres",
"To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or" => "Per configurar els teus formularis, busca \"Administra formularis\" sota \"Formularis\" en el menú de l'aplicació, o",
"Use database to store files" => "Empra la base de dades per desar arxius",
"Use a directory to store files" => "Empra un directori per desar arxius",
"dls" => "baixades",
"Change all to db" => "Canvia-ho tot a base de dades",
"Change all to file" => "Canvia-ho tot a arxius",
"Use database to store userfiles" => "Utilitza una base de dades per emmagatzemar les dades dels usuaris",
"Use a directory to store userfiles" => "Utilitza un directori per emmagatzemar les dades dels usuaris",
"List authors" => "Llista autors",
"Remove a tag" => "Elimina una etiqueta",
"Generate dump" => "Generar volcat",
"Download last dump" => "Baixar darrer volcat",
"Remove unused pictures" => "Elimina fotos no emprades",
"Export Wiki Pages" => "Exporta Pàgines del Wiki",
"Wiki 3D Browser Configuration" => "Configuració del Navegador Wiki 3D",
"Tools" => "Eines",
"Wiki attachments" => "Adjuncions del Wiki",
"Wysiwyg Editor Features" => "Funcionalitat d'Edició Wysiwyg",
"An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature." => "Una manera fàcil d'integrar contingut d'un altre lloc web al Tiki és a través d'enllaços emmarcats utilitzant la funcionalitat Tiki <a class=\"rbox-link\" href=\"tiki-admin_links.php\">enllaços destacats</a>.",
"Edit Repository:" => "Edita Dipòsit:",
"Create New Repository" => "Crea Nou Dipòsit",
"List Repositories" => "Llista dipòsits",
"New Repository" => "Nou dipòsit",
"View Repository" => "Visualitza dipòsit",
"Human-readable repository name" => "Nom de dipòsit en format llegible",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Ruta al dipòsit (sistemes de fitxers locals: adreça web relativa/absoluta, remots: prefixada amb 'http://')",
"File name of start page" => "Nom de l'arxiu de la pàgina de començament",
"Start page" => "Pàgina d'inici",
"CSS file to load when browse this repository" => "Fitxer CSS per carregar quan es navegui per aquest dipòsit",
"CSS File" => "Arxiu CSS",
"Is repository visible to users" => "Dipòsit visible per a les persones usuàries?",
"Can files from repository be cached" => "Es poden posar en memòria cau els fitxers del dipòsit?",
"Cacheable" => "Captable en memòria cau",
"Are files from repository can be cached" => "Es poden posar en memòria cau els fitxers del dipòsit?",
"Clear all cached pages of this repository" => "Neteja totes les pàgines en memòria cau d'aquest dipòsit?",
"Clear cache" => "Neteja memòria cau",
"Seconds count 'till cached page will be expired" => "Segons que resten fins que la pàgina quedi expirada",
"Cache expiration" => "Expiració de la memòria cau",
"Human-readable text description of repository" => "Text de descriptió en format llegible del dipòsit",
"Available Repositories" => "Dipòsits disponibles",
"Edit rules" => "edita normes",
"Edit Rules for Repository:" => "Editar Regles pel Dipòsit:",
"Configure Repositories" => "Configura dipòsits",
"Configure this Repository" => "Configurar aquest dipòsit",
"View this Repository" => "Veure aquest dipòsit",
"New Rule" => "Nova regla",
"Copy Rules" => "Copiar regles",
"view/hide copy rules dialog" => "veure/amagar diàleg de copies de regles",
"Source repository" => "Eines del dipòsit",
"Copy" => "Copiar",
"According this order rules will be applied ('0' or empty = auto)" => "Segons aquest ordre de regles, s'aplicarà ('0' o buit = auto)",
"Rule order" => "Ordre de regles",
"Text to search for" => "Text a cercar per",
"Text to replace" => "Texte a reemplaçar",
"Is this regular expression or simple search/replacer" => "És aquesta una expressió regular  o una simple paraula de recerca",
"Regex" => "Expresió Regular",
"Is case sensitive (for simple replacer)" => "És sensible a les majúscules (per a poder sobreescriure)",
"Case sensitive" => "Sensible a Majúscules",
"subset of chars: imsxeADSXUu, which is regex modifiers" => "subconjunt de caràcters:  imsxeADSXUu, els quals son modificadors d'expresions regulars",
"Regex modifiers" => "Modificadors d'expresions regulars",
"Human-readable text description of rule" => "Norma escrita de forma llegible",
"Check to enable this rule" => "marcar per a habilitar aquesta norma",
"Preview options" => "Previsualitzar opcions",
"Apply all rules or just this to generate preview" => "Aplica totes les normes o només per a generar aquesta vista prèvia",
"Apply all rules" => "Aplica totes les normes",
"View source code after rules applied" => "Visualitza el codi font després que s'apliquin les regles",
"Code preview" => "vista prèvia del Codi",
"Generate HTML preview" => "Generar vista prèvia",
"HTML preview" => "Vista prèvia en HTML",
"Test file from repository to generate preview for (empty = configured start page)" => "Fitxer test del dipòsit per generar previsualització per (buit = pàgina d'inici configurada)",
"Preview Results" => "Previsualitzar resultats",
"Rules List" => "Llista de Regles",
"Case" => "Cas",
"Configure/Options" => "Configura/Opcions",
"No pages found" => "No s'han trobat pàgines",
"Admin layout" => "Administrar colocació dels elements",
"Theme control" => "Control de temes",
"layout options" => "opcions de format",
"Right column" => "Columna dreta",
"Top bar" => "Barra d'encapçalament",
"Generate positions by hits" => "Genera posicions per cops",
"List of featured links" => "Llista d'enllaços destacats",
"Position" => "Posició",
"Add Featured Link" => "Afegeix un enllaç",
"Edit this Featured Link:" => "Edita aquest Enllaç Especial:",
"Create new Featured Link" => "Crea un nou Enllaç Especial",
"disables the link" => "deshabilita l'enllaç",
"Link type" => "Tipus d'enllaç",
"replace current page" => "reemplaçar la pàgina actual",
"framed" => "en un marc",
"open new window" => "obrir una finestra nova",
"Mail-in accounts" => "Comptes de Correu-in",
"Account" => "Compte",
"Add new Mail-in account" => "Afegeix un nou compte de Correu-dins",
"Edit Mail-in account" => "Edita el compte de correu-dins",
"Account name" => "Nom del compte",
"POP server" => "Servidor POP",
"SMTP server" => "Servidor SMTP",
"SMTP requires authentication" => "SMTP requereix autenticació",
"Article Topic" => "Tema de l'article",
"Admin Topics" => "Admin temes",
"Article Type" => "Tipus de l'article",
"Admin Types" => "Administrar tipus",
"Active" => "Actiu/va",
"Allow anonymous access" => "Permetre accès anònim",
"Allow attachments" => "Permetre adjunts",
"Discard to the end from" => "Descarta fins al final des de",
"Check Mail-in accounts" => "comprovar comptes de Mail",
"Check automatically" => "comprovar automàticament",
"Frequency" => "Freqüència",
"List menus" => "Llista menús",
"Edit this menu" => "Edita menú",
"Edit menu options" => "Edita opcions de menú",
"Show Quick Urls" => "Mostra Urls Ràpides",
"Some useful URLs" => "Algunes URLS útils",
"Hide Quick Urls" => "Amaga Urls Ràpides",
"option" => "opció",
"section level 0" => "secció de nivell 0",
"section level 1" => "secció de nivell 1",
"section level 2" => "secció de nivell 2",
"section level 3" => "secció de nivell 3",
"sorted section level 0" => "secció ordenada de nivell 0",
"separator" => "separador",
"Choose" => "Escull",
"Home Blog" => "Bitàcola Inicial",
"Home Image Gal" => "Galeria d'imatges Inicial",
"Home Image Gallery" => "Galeria d'imatges Inicial",
"Home File Gal" => "Galeria d'arxius Inicial",
"Home File Gallery" => "Galeria d'arxius Inicial",
"User preferences" => "Preferències de l'usuari",
"User prefs" => "Prefs de l'usuari",
"List galleries" => "Llista les galeries",
"List image galleries" => "Llista galeries d'imatges",
"Upload image" => "Pujar imatge",
"Gallery Rankings" => "Posicions de galeries",
"Browse a gallery" => "Fulleja una galeria",
"Articles home" => "Inici d'articles",
"All articles" => "Tots els articles",
"Submit" => "Envia",
"List Blogs" => "Llista bitàcoles",
"Create Blog" => "Crea Bitàcola",
"View a forum" => "Visualitza fòrum",
"View a thread" => "Visualitza missatge",
"View a FAQ" => "Veure una PUF",
"Take a quiz" => "Resol un test",
"Quiz stats" => "Estadístiques dels Tests",
"Stats for a Quiz" => "Estadístiques per un Test",
"Preview menu" => "Previsualitza menú",
"Menu options" => "Opcions del menú",
"Export CSV data" => "Exporta dades CSV",
"Import CSV data" => "Importa dades CSV",
"Options" => "Opcions",
"Active Permissions" => "Permisos actius",
"Edit this Menu:" => "Edita aquest menú:",
"Create new Menu" => "Crea un nou menú",
"dynamic collapsed" => "col·lapsat dinàmic",
"dynamic extended" => "dinàmic extès",
"fixed" => "fixat",
"View template" => "Visualitza plantilla",
"Weight" => "Pes",
"Clear Cache" => "Esborra memòria cau",
"Assigned Modules" => "Mòduls assignats",
"Left Modules" => "Mòduls a l'esquerra",
"Move to Right Column" => "Moure ala columna dreta",
"Right Modules" => "Mòduls a la dreta",
"Move to Left Column" => "Moure a la columna esquerra",
"Assign new module" => "Assigna un nou mòdul",
"Edit this assigned module:" => "Edita el mòdul asignat:",
"Cache Time" => "Temps en memòria cau",
"required" => "requerit",
"Visibility" => "Visibilitat",
"Displayed now for all eligible users even with personal assigned modules" => "Mostrat ara per a tots els usuaris/es escollits inclós amb mòduls personalment assignats.",
"Displayed for the eligible users with no personal assigned modules" => "Mostrat per als usuaris/es escollits sense mòduls personalment no assignats",
"Displayed now, can't be unassigned" => "Mostrat ara, no es pot estar sense assignar",
"Not displayed until a user chooses it" => "No mostrat fins que l'usuari l'esculli",
"User Modules" => "Mòduls de l'usuari",
"Create new user module" => "Crea un nou mòdul d'usuari",
"Edit this user module:" => "Edita aquest mòdul d'usuari:",
"Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site." => "Crea el teu nou mòdul personalitzat a continuació. Assegura't de previsualitzar-lo primer i que tot és correcte abans d'<a href=\"#assign\">assignar-lo</a>. Pots emprar html si vols a més. No obstant això, si utilizes la sintaxi wiki o un codi Smarty de manera incorrecta, pot ser que tu mateix t'expulsis del lloc web.",
"Must be wiki parsed" => "Interpreta el format Wiki",
"Objects that can be included" => "Objectes que es poden incloure",
"Random active poll" => "Consulta activa aleatòria",
"Random current poll" => "Consulta actual aleatòria",
"Use Poll" => "Empra la consulta",
"Use Gallery" => "Empra galeria",
"Use Dynamic Content" => "Usa contingut dinàmic",
"Use RSS Module" => "Empra mòdul RSS",
"Use Menu" => "Empra menú",
"Use phplayermenu" => "Empra phplayermenu",
"Use Banner Zone" => "Usa zones de banners",
"Structures:" => "Estructures:",
"Use Wiki Structure" => "Empra Estructura Wiki",
"Data" => "Dades",
"Admin newsletter subscriptions" => "Administrar subscripcions al butlletí",
"List Newsletters" => "Llista fulls de notícies",
"Edit Newsletter" => "Edita el Butlletí",
"Admin Newsletters" => "Administra fulls de notícies",
"Send Newsletters" => "Envia Butlletins",
"Subscriptions" => "Subscripcions",
"Wiki Page Name" => "Nom de pàgina wiki",
"Validate Addresses" => "Valida les adreces",
"Add To List" => "Afegeix-ne a la llista",
"Valid" => "Vàlid",
"Subscribed" => "subscrit",
"Add subscribers" => "Afegeix subscriptors",
"You can add several email addresses by separating them with commas." => "Podeu afegir varies adreces de correu electrònic separant-les amb comes.",
"Add email:" => "Afegeix email:",
"Add user:" => "Afegeix usuari:",
"Group subscription also subscribes included groups" => "La subscripció al grup també subscriu als grups inclosos",
"Don't send confirmation mail" => "No enviis un correu electrònic de confirmació",
"The user email will be refreshed at each newsletter sending" => "El correu-e de l'usuari s'actualitzarà cada vegada que s'envii un butlletí",
"Import emails from file" => "Importa correus-e des d'un arxiu",
"txt file, one e-mail per line" => "arxiu txt, amb un correu-e a cada línia",
"Don't send confirmation mails" => "No enviïs correus-e de confirmació",
"Import emails from wiki page" => "Importa correus-e des d'una pàgina wiki",
"Wiki page, one e-mail per line" => "Pàgina wiki, un correu-e a cada línia",
"Subscribe group" => "Subscriu el grup",
"Use subscribers of another newsletter" => "Empra subscriptors d'un altre butlletí",
"Use emails from wiki page" => "Empra correus-e des de pàgina wiki",
"Emails on a wiki page which will be added at each newsletter sending, one e-mail per line" => "Correus-e a una pàgina wiki que seran afegits cada vegada que s'enviï un nou butlletí, amb un correu-e a cada línia",
"Don't subscribe emails" => "No subscriguis correus-e",
"Export Subscriber Emails" => "Exporta els correus-e dels subscriptors",
"Admin newsletters" => "Administrar butlletins",
"Create Newsletter" => "Crea un Butlletí",
"Editions" => "Edicions",
"Drafts" => "Esborranys",
"Last Sent" => "últims enviats",
"Create/Edit Newsletters" => "Crea/edita butlletins",
"There are individual permissions set for this newsletter" => "Hi ha permisos individuals fixats per a aquest butlletí",
"Users can subscribe/unsubscribe to this list" => "Els usuaris es poden subscriure/desubscriure a la llista d'aquest butlletí",
"Users can subscribe any email address" => "Els usuaris poden subscriure qualsevol adreça de correu-e",
"Add unsubscribe instructions to each newsletter" => "Afegir instruccions de desubscripció a cada butlletí",
"Validate email addresses" => "Valida adreces de correu-e",
"Allow customized text message to be sent with the html version" => "Permet que s'hi pugui posar un missatge de text senzill personalitzat amb l'enviament de la versió en html",
"Allow clipping of articles into newsletter" => "Permet el retallat d'articles a dins d'un butlletí",
"Automatically clip articles into newsletter" => "Retalla automàticament els articles a dins del butlletí",
"Clip articles published in the past number of days" => "Retalla els articles publicats en el darrer número de dies",
"Article types to clip" => "Tipus d'articles a retallar",
"Mail notifications" => "Notificacions per correu-e",
"Add notification" => "Afegeix notificació",
"Alert" => "Alerta",
"Event" => "Aconeteixement",
"List polls" => "Llista consultes",
"Edit this poll" => "Edita consulta",
"Preview poll" => "Previsualitza consultes",
"Add poll option" => "Afegix opció per a la consulta",
"Edit poll option" => "Edita l'opció de la consulta",
"Poll options" => "Opcions de la consulta",
"Votes" => "Vots",
"Admin Polls" => "Administrar consultes",
"Set last poll as current" => "Posar l'última consulta com actual",
"Close all polls but last" => "Tanca totes les consultes menys la darrera",
"Activate all polls" => "Activar totes les consultes",
"Create poll" => "Crea una consulta",
"Edit poll" => "Edita la consulta",
"active" => "actiu/va",
"current" => "actual",
"object" => "objecte",
"PublishDate" => "DatadePublicació",
"Objects" => "Objectes",
"Results" => "Resultats",
"Add poll to pages" => "Afegeix consulta a pàgines",
"Wiki pages" => "Planes Wiki",
"Lock the pages" => "Bloqueja les pàgines",
"Content for the feed" => "Contingut per a l'alimentació",
"Security Admin" => "Admin Seguretat ",
"To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>." => "Per <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">informar de qualsevol incidència relacionada amb la seguretat</a>.",
"PHP settings" => "Paràmetres de PHP",
"PHP variable" => "Variable PHP",
"Risk Factor" => "Factor de Risc",
"Explanation" => "Explicació",
"Tiki variable" => "Variable de Tiki",
"Check all tiki files" => "Comprova tots els arxius de tiki",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Tingues present que això pot prendre's una estona molt llarga. Seria convenient comprovar el paràmetre del temps màxim d'execució (max_execution_time) a l'arxiu php.ini.",
"File checks" => "Comprovacions d'arxius",
"type" => "tipus",
"user" => "usuari",
"group" => "grup",
"sticky" => "enganxós",
"Admin Shoutbox Words" => "Administra quadre d'avisos",
"Add Banned Word" => "Afegeix una paraula prohibida",
"Are you sure you want to delete this word?" => "Segur que voleu eliminar aquesta paraula?",
"The structure" => "L'Estructura",
"has just been created." => "ha estat creada ara mateix.",
"You will remove structure" => "Esborraràs lestructura",
"Destroy the structure leaving the wiki pages" => "Destrueix l'estructura deixant les pàgines wiki",
"Destroy the structure and remove the pages" => "Destrueix l'estructura i esborra les pàgines",
"Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict:" => "Pren nota que les pàgines següents formen part també d'una altra estructura. Assegura't que els permisos d'accés (si n'hi ha) no entren en conflicte:",
"The following pages have automatically been categorized with the same categories as the structure:" => "Les pàgines següents han estat categoritzades automàticament amb les mateixes categories que l'estructura:",
"The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent:" => "Les pàgines següents estan assignades a categories però l'estrucura no en té assignada cap. És possible que vulguis descategoritzar-les per ser consistent:",
"The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent:" => "Les següents pàgines es troben en categories a les quals l'estructura no es troba assignada. És possible qeu vulguis recategoritzar-les a fi i efecte de ser consistent:",
"Edit structure" => "Edita l'estructura",
"Export Pages" => "Exportar pàgines",
"Dump Tree" => "Baixa't l'arbre",
"Create WebHelp" => "Crear AjudaWeb",
"View WebHelp" => "Visualitza ajutweb",
"XML Zip" => "Zip XML",
"Perform action with checked" => "Als selecionats, realitza l'acció",
"Alias" => "Àlies",
"Tree" => "Arbre",
"Use single spaces to indent structure levels" => "Empra espais simples per indentar nivells d'estructura",
"Create New Structure" => "Crear nova estructura",
"List surveys" => "Llista enquestes",
"Survey Stats" => "Estadístiques d'enquestes",
"Edit this Survey" => "Edita aquesta enquesta",
"Admin Surveys" => "Administra enquestes",
"Question" => "Pregunta",
"One choice" => "Una opció",
"Multiple choices" => "Múltiples opcions",
"Short text" => "Text curt",
"Rate (1..5)" => "Valor (1..5)",
"Rate (1..10)" => "Valor (1..10)",
"For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "Per qüestions amb múltiples respostes escriu les respostes en el camp següent separades per comes. Exemple: un, dos, alguns, molts",
"For a rate, you can give the maximum value." => "Per a una valoració, pots donar el valor màxim.",
"Options (if apply)" => "Opcions (si és el cas)",
"Questions" => "Preguntes",
"Admin surveys" => "Administrar enquestes",
"List Surveys" => "Llista Enquestes",
"Edit this Survey:" => "edita aquesta Enquesta:",
"Create New Survey" => "Crea Nova Enquesta",
"There are individual permissions set for this survey" => "Hi ha permisos individuals fixats per a aquesta enquesta",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "Si el teu Tiki està actuant de forma rara, la primera cosa a provar és netejar la memòria cau de sota. També és molt important netejar la teva memòria cau després d'una actualització (per FTP/SSH si és necessari).",
"Exterminator of cached content" => "Exterminador de contingut en memòria cau",
"Empty" => "Buit",
"Create a new topic" => "Crea un nou element",
"Topic Name" => "Nom d'element",
"Upload Image" => "Pujarimatge",
"List of topics" => "Llista d'elements",
"topic image" => "imatge del tema",
"Inactive - Click to Activate" => "Inactiu/va - Clica per Activar",
"Deactivate" => "Desactiva",
"Active - Click to Deactivate" => "Actiu/va - Clica per Deactivar",
"Remove with articles" => "Esborrar amb els articles",
"List Trackers" => "Llista Formularis",
"Admin Trackers" => "Administra formularis",
"Edit This Tracker" => "Edita aquest formulari",
"View This Tracker's Items" => "Visualitza els ítems d'aquest formulari",
"Tracker fields" => "Camps de formulari",
"Is column visible when listing tracker items?" => "És visible la columna quan es llisten els ítems dels formulari?",
"Column links to edit/view item?" => "Enllaços de columna per editar/veure ítem?",
"Field is public? (viewed in trackerlist plugin)" => "El camp és públic? (visible a través del connector/plugin trackerlist)",
"Hidden" => "Ocult",
"Mandatory" => "Obligatori",
"Searchable" => "Cercable",
"New tracker field" => "Nou camp del Formulari",
"Edit tracker field" => "Edita el camp del formulari",
"Select list items that will be displayed:" => "Selecciona la llista d'ítems que es mostraran:",
"Field is mandatory?" => "El camp és obligatori?",
"Multilingual content" => "Contingut Multilingüe",
"Column is searchable?" => "La columna és cercable?",
"Field is hidden?" => "El camp és ocult?",
"not hidden" => "no ocult",
"visible to admin only" => "visible només a l'administrador",
"editable by admin only" => "editable només per admins",
"visible by creator &amp; admin only" => "visible només pel creador &amp; admin",
"The option creator needs a field of type user selector and option 1" => "La opció creador necessita un camp del tipus selecció d'usuari amb l'opció 1",
"Import/Export Trackers Fields" => "Importa/exporta els camps dels formularis",
"Export fieldId also" => "Exporta també els fieldId",
"Edit This Tracker's Fields" => "Edita els camps d'aquest formulari",
"Found" => "Trobat",
"trackers" => "formularis",
"Items" => "Ítems",
"with" => "amb",
"Edit Tracker" => "Edita el formulari",
"Auto create corresponding categories" => "Auto crea les categories corresponents",
"Show status" => "Mostra l'estat",
"Default status displayed in list mode" => "Mostrar l'estat per defecte en el mode de llista",
"Show status to tracker admin only" => "Mostra l'estat només als admins. dels formulari",
"Send copies of all activity in this tracker to this e-mail address" => "Envia còpies de tota l'activitat en aquest formulari a aquesta adreça de correu-e",
"Use simplified e-mail format" => "Empra el format de correu-e simplificat",
"The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "El formulari emprarà el camp de text anomenat Subject si hi ha algun com a subject i emprarà el correu-e de l'usuari com a enviador, o per a usuaris anònims, el camp de correu-e si existeix",
"New items are created with status" => "Els nous ítems són creats amb estat",
"Authoritative status for modified items" => "Estat per força per als ítems modificats",
"No change" => "Cap canvi",
"Item creator can modify his items?" => "El creador de l'ítem pot modificar els seus ítems?",
"The tracker needs a user field with the option 1" => "El formulari necessita un camp d'usuari amb l'opció 1",
"Only one item per user or IP" => "Només un ítem per usuari o IP",
"The tracker needs a user or IP field with the option 1" => "El formulari necessita un camp d'usuari o IP amb l'opció 1",
"The tracker needs a group field with the option 1" => "El formulari necessita un camp de grup amb l'opció 1",
"Show creation date when listing tracker items?" => "Mostra la data de creació quan es llistin els ítems del formulari?",
"Format if not the default short one:" => "Format en cas de no voler el curt per defecte:",
"Show creation date when viewing tracker item?" => "Mostra la data de creació quan es visualitzi un element de formulari?",
"Show lastModif date when listing tracker items?" => "Mostra la data de UltimaModif quan es llistin els ítems del formulari?",
"Show lastModif date when viewing tracker item?" => "Mostra data de la darrera modificació quan es visualitzi  un element de formulari?",
"What field is used for default sort?" => "Quin camp serà emprat per a l'ordenació per defecte?",
"What is default sort order in list?" => "Quin és l'ordre per defecte en el llistat?",
"Tracker items allow ratings?" => "Els ítems del formulari permeten valoracions?",
"with values" => "amb els valors",
"and display rating results in listing?" => "i mostrar els resultats de les valoracions en el llistat?",
"Tracker items allow comments?" => "Els ítems del formulari permeten comentaris?",
"and display comments in listing?" => "i mostrar els comentaris en el llistat?",
"Tracker items allow attachments?" => "Els ítems del formulari permeten afegits?",
"and display attachments in listing?" => "i mostrar els adjunts en el llistat?",
"Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)" => "Opcions per mostrar els adjunts (Empra números per ordenar els ítems, 0 no serà mostrat, i valors negatius es mostren en finestres emergents)",
"Filesize" => "Mida de l'arxiu",
"Filetype" => "Tipus d'arxiu",
"LongDesc" => "Descripció llarga",
"Items can be created only during a certain time" => "Es poden crear ítems només durant un cert temps",
"After:" => "Després:",
"Before:" => "Abans:",
"Do not show empty fields in item view?" => "No mostris els camps buits en la vista d'ítem?",
"Show these fields (ID comma separated) in a popup on item link when listing tracker items?" => "Mostra aquests arxius (ID separats per comes) en un requadre emergent sobre l'enllaç de l'ítem quan es llistin els elements del formulari?",
"Import/Export" => "Importa/Exporta",
"Import/export trackers" => "Importa/exporta formularis",
"Charset encoding" => "Codificació de Caràcters",
"Duplicate Tracker" => "Duplica el formulari",
"Members" => "Membres",
"Admin groups" => "Administra grups",
"Admin users" => "Administra usuaris",
"Add new group" => "Afegeix un nou grup",
"List of existing groups" => "Llista de grups existents",
"Homepage" => "Pàgina inicial",
"User Choice" => "elecció de l'usuari",
"Group Homepage" => "Pàgina del Grup",
"Edit group" => "Edita el grup",
"Add a New Group" => "Afegir un grup nou",
"Use wiki page name or full URL" => "Empra pàgina Wiki o URL sencera",
"Use site default" => "Fes servir el que hi ha per defecte al lloc",
"Group Information Tracker" => "Formulari per a la informació del Grup",
"choose a group tracker ..." => "escull un formulari de grup ...",
"choose a field ..." => "escull un camp ...",
"Users Information Tracker" => "Formulari per a la informació dels Usuaris",
"choose a users tracker ..." => "escull un formulari d'usuaris ...",
"Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Camps del Formulari d'Informació d'Usuaris que es demanaran en el moment de Regisstre<br />(IdsDeCamps separats amb :)",
"User can assign to the group himself" => "L'usuari es pot afegir ell mateix al grup",
"Group tracker item : {\$groupitemid}" => "Item del formulari de Grup : {\$groupitemid}",
"Edit Item" => "Edita ítem",
"Group tracker item not found" => "No s'ha trobat l'ítem del formulari de Grup",
"Remove from Group" => "Elimina del grup",
"users in group" => "usuaris en el grup",
"Download CSV export" => "Descarrega't exportació en format CSV",
"Charset encoding:" => "Codificació de caràcters:",
"Assign users to group:" => "Assigna usuaris al grup:",
"CSV File" => "Arxiu CSV",
"Add a New User" => "Afegeix un nou usuari",
"Reason" => "Raó",
"More Criteria" => "Més Criteris",
"Group (direct)" => "Grup (directe)",
"to groups" => "als grups",
"Edit Included Group" => "Edita el grup inclòs",
"default" => "per defecte",
"Remove Users and their Userpages" => "Elimina els usuaris i les seves pàgines d'usuari",
"Manage Group Assignments" => "Gestiona les assignacions a grups",
"Set Default Groups" => "Especifica els grups per defecte",
"Assign selected to" => "Assigna els seleccionats a",
"Remove selected from" => "Elimina els escollits de",
"the following groups:" => "els següents grups:",
"Edit user" => "Editeu l'usuari",
"Use the email as username" => "Empra correu-e com a nom d'usuari",
"No password is required" => "No cal contrasenya",
"You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "Cal establir <a href=\"tiki-admin.php?page=general\">correu electrònic emissor</a>",
"User tracker item : {\$usersitemid}" => "Ítem del formulari de l'usuari : {\$usersitemid}",
"Batch upload (CSV file):" => "Càrrega de lots (arxiu CSV):",
"Loading..." => "Carregant...",
"Changes from the following versions under staging have been merged into the approved version" => "Els canvis de les següents versions per revisar han estat fusionats amb la versió aprovada",
"Source" => "Codi font",
"Admin Article Types" => "Administrar Tipus d'Article",
"Show Help" => "Mostra Ajuda",
"Article type" => "Tipus d'article",
"Shows up in the drop down list of article types" => "Es mostra en la llista desplegable de tipus d'articles",
"Allow ratings by the author" => "Permet valoracions per l'autor",
"Show before publish date" => "Mostrar avans de la data de publicació",
"non-admins can view before the publish date" => "els no administradors poden veure-ho abans de la data de publicació",
"Show after expire date" => "Mostrar despres de la data expirada",
"non-admins can view after the expire date" => "els no-administradors poden veure-ho després de la data d'expiració",
"Heading only" => "Encapçalament només",
"No article body, heading only" => "Sense cos de l'article, tan sols encapçalament",
"Allow comments for this type" => "Permet comentaris per aquest tipus",
"Comment Can Rate Article" => "un Comentari permet valorar l'Article",
"Allow comments to include a rating value" => "Permet que els comentaris incloguin una valoració numèrica",
"Show image" => "Mostrar imatge",
"Show topic or own image" => "Mostra el tema o la imatge pròpia",
"Show avatar" => "Mostrar avatar",
"Show author's avatar" => "Mostra l'avatar de l'autor",
"Show author" => "Mostrar autor",
"Show author name" => "Mostra el nom de l'autor",
"Show publish date" => "Mostrar data de publicació",
"Show expire date" => "Mostrar data d'expiració",
"Show reads" => "Mostrar lectures",
"Show the number of times the article was read" => "Mostra el nombre de vegades que s'ha llegit l'article",
"Show size" => "Mostrar tamany",
"Show the size of the article" => "Mostra la mida de l'article",
"Show topline" => "Mostra línea superior",
"Show a small title over the title" => "Mostra un  títol petit sobre el títol",
"Show subtitle" => "Mostra subtítol",
"Show the subtitle" => "Mostra el subtítol",
"Show source" => "Mostra font",
"Show link to source after article body" => "Mostra l'enllaç a la font després del cos de l'article",
"Show Image Caption" => "Mostra la llegenda de la imatge",
"Show a legend under the image" => "Mostra una llegenda sota la imatge",
"Show Language" => "Mostra idioma",
"Show the language" => "Mostra l'idioma",
"Creator can edit" => "El creador pot editar-ho",
"The person who submits an article of this type can edit it" => "Qui envia un atricle d'aquest tipus pot editar-lo",
"Actions on this article type" => "Accions amb aquest tipus d'article",
"List of article types" => "Llista de tipus d'articles",
"view articles with this type" => "mostra els articles d'aquest tipus",
"Review" => "Revisió",
"Classified" => "Classificat",
"Show lang" => "Mostra idioma",
"Custom attribute" => "Atribut a mida",
"Create a new type" => "Crear un nou tipus",
"Group Information" => "Informació del grup",
"level" => "nivell",
"inherited from" => "heredat de",
"inherited" => "heredat",
"Advanced feature" => "Funcionalitat avançada",
"Create level" => "Crea nivell",
"all permissions in level" => "tots els permisos en el nivell",
"backlinks to" => "retroenllaços cap a",
"No backlinks to this page" => "No hi ha retroenllaços a aquesta pàgina",
"Directory batch upload" => "Càrrega de lots de directoris",
"Browse Gallery" => "Fulleja galeria",
"Upload From Disk" => "Pujar des del disc local",
"available images" => "imatges disponibles",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "ex. per \"digicam0001.jpg\" s'utilitzarà digicam0001 pel camp nom",
"Select a Gallery" => "Selecciona una Galeria",
"Process" => "Procés",
"Browse File Gallery" => "Navega per la Galeria d'Arxius",
"Edit Post" => "Edita publicació",
"View Blog" => "Visualitza bitàcola",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Avís: Recorda que això és només una previsualització, i que no ha estat gravat encara!",
"Trash" => "Brossa",
"Mark entry as private:" => "Marca la publicació com a privada:",
"Publish Date" => "Data de publicació",
"Browse in" => "Navega per",
"Trackers Items" => "Ítems dels Formularis",
"Sheets" => "Fulls",
"Find:" => "Troba:",
"in the current category - and its subcategories: " => "a la categoria actual - i les seves subcategories: ",
"Hide subcategories objects" => "Amaga els objectes de les subcategories",
"Show subcategories objects" => "Mostra els objectes de les subcategories",
"Upper level" => "Nivell de Pujada",
"Browse related tags" => "Navega per les etiquetes relacionades",
"Network of Tags related to" => "Xarxa d'etiquetes relacionades a ",
"With all selected tags" => "Amb totes les etiquetes seleccionades",
"With one selected tag" => "Amb una etiqueta seleccionada",
"With last selected tag" => "Amb l'última etiqueta seleccionada",
"More Popular Tags" => "Etiquetes més populars",
"Sort:" => "Ordena:",
"Alphabetically" => "Alfabèticament",
"By Size" => "Per mida",
"Cloud" => "Núvol",
"results found" => "resultats trobats",
"List Galleries" => "Llista les Galeries",
"Edit Gallery" => "Edita la Galeria",
"Rebuild Thumbnails" => "Reconstrueix miniatures",
"Directory Batch" => "Directori per pujada en bloc",
"List Gallery" => "Llista la galeria",
"All Images" => "Totes les imatges",
"Monitor this Gallery" => "Vigila aquesta Galeria",
"Stop Monitoring this Gallery" => "Deixa de vigilar aquesta Galeria",
"Sort Images by" => "Ordena la imatge per",
"subgallery" => "subgaleria",
"Subgallery" => "Subgaleria",
"Original Size" => "Tamany original",
"rotate right" => "voltar a la dreta",
"rotate" => "voltar",
"Details" => "Detalls",
"popup" => "emergent",
"Return to Gallery" => "Torna a la galeria",
"Edit Image" => "Editar la imatge",
"First Image" => "Primera imatge",
"Prev Image" => "Imatge prèvia",
"Smaller" => "Més petit",
"Bigger" => "Més gran",
"Popup window" => "Finestra emergent",
"Next Image" => "Propera imatge",
"Slideshow Forward" => "Endavant el Passi de diapositives",
"Last Image" => "La última imatge",
"Cyclic" => "Cíclic",
"Click to zoom" => "Fes clic per ampliar",
"Image Name" => "Nom de la imatge",
"Image size" => "Mida de la imatge",
"Image Scale" => "Escala de la imatge",
"Latitude (WGS84/decimal degrees)" => "Latitud (WGS84/graus decimals)",
"Longitude (WGS84/decimal degrees)" => "Longitud (WGS84/graus decimals)",
"Move image" => "Moure la imatge",
"Stop Monitoring this Page" => "Deixa de vigilar-ho",
"Monitor this Page" => "Vigila-ho",
"Edit Calendar" => "Edita el Calendari",
"Visible Calendars" => "Calendaris Visibles",
"Click to select visible calendars" => "Clica per seleccionar calendaris visibles",
"Group Calendars" => "Calendaris de Grup",
"Edit event" => "Edita esdeveniment",
"View event" => "Visualitza esdeveniment",
"Tentative" => "Tentativa",
"Confirmed" => "Confirmat",
"Cancelled" => "Cancel·lat",
"Calendar Item" => "Ítem del Calendari",
"New event" => "Nou esdeveniment",
"Edit Calendar Item" => "edita l'item del calendari",
"New Calendar Item" => "Nova Cita al Calendari",
"January" => "Gener",
"February" => "Febrer",
"March" => "Març",
"April" => "Abril",
"May" => "Maig",
"June" => "Juny",
"July" => "Juliol",
"August" => "Agost",
"September" => "Setembre",
"October" => "Octubre",
"November" => "Novembre",
"December" => "Desembre",
"times" => "vegades",
"End" => "Fi",
"Date and time of end" => "Dia i hora de finalització",
"or new" => "o nou/va",
"Organized by" => "Organitzat per",
"Roles" => "Rols",
"chair" => "presideix",
"default role" => "rol per defecte",
"required participant" => "participant requerit",
"optional participant" => "participant opcional",
"non participant" => "no participant",
"Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in:" => "Posa la llista de participants separats per comes. Els rols han de ser posats en un prefix separats per dos punts com a:",
"role:login_or_email,login_or_email" => "rol:nom_d_usuari_o_correu-e,nom_d_usuari_o_correu-e",
"Calendar import" => "Importa calendari",
"Calendar has been updated" => "El calendari ha estat actualitzat",
"import" => "importa",
"W" => "S",
"Change password enforced" => "Força a canviar contrasenya",
"Change your password" => "Canvia la contrasenya",
"Choose language" => "Escull l'idioma",
"Send a message to us" => "Envia'ns un missatge",
"Contact us by email" => "contacta'ns via correu-e",
"Click here to send us an email" => "Fes clic aquí per enviar-nos un correu electrònic",
"Send another message" => "Envia un altre missatge",
"Contacts" => "Contactes",
"Group View" => "Vista agrupada",
"Create/edit contacts" => "Crea/edita contactes",
"First Name" => "Primer nom",
"Publish this contact to groups" => "Publica aquest contact a grups",
"Last Name" => "Darrer Nom",
"Nickname" => "Sobrenom",
"page already exists" => "la pàgina ja existeix",
"No structure" => "Cap estructura",
"Top page" => "La pàgina més activa",
"Add a new site" => "Afegeix una nova web",
"You cannot add sites until Directory Categories are setup." => "No pots afegir enllaços fins que es configurin les categories d'enllaços.",
"Please contact the Site Administrator" => "Si us plau, contacteu amb l'administrador del portal",
"Site added" => "Lloc afegit",
"Add a Site" => "Afegiu un lloc",
"Directory Administration" => "Administració del Directori",
"There are" => "Hi ha/n",
"invalid sites" => "web Invàlida",
"valid sites" => "llocs vàlids",
"Users have visited" => "Els usuaris han visitat",
"sites from the directory" => "llocs desde el directori",
"Users have searched" => "Els usuaris han cercat",
"times from the directory" => "vegades del directori",
"Sites" => "Llocs",
"Validate" => "Valida",
"Admin directory categories" => "Administrar directori de categories",
"Add a directory category" => "Afegeix una categoria directori",
"Edit this directory category" => "edita aquest directori de categoria",
"Children type" => "tipus infantil",
"Maximum number of children to show" => "Nombre màxim de nens a mostrar",
"Editor group" => "Editor de grup",
"cType" => "cTipus",
"allow" => "permetre",
"count" => "compte",
"relate" => "relacionar",
"Mutual" => "Mutu",
"Admin sites" => "Administració de llocs web",
"Is valid" => "És vàlid",
"New Sites" => "Nous llocs",
"Cool Sites" => "Llocs fantàstics",
"any" => "qualsevol",
"in entire directory" => "a tot el directori",
"Sort by" => "Ordenat per",
"sort" => "ordenar",
"Last updated" => "Actualitzat per darrera vegada el",
"Total links" => "Enllaços totals",
"Links to validate" => "Enllaços per validar",
"Searches performed" => "Cerca enllestida",
"Total links visited" => "Nombre d'enllaços visitats",
"Directory ranking" => "llista de Directoris",
"Validate sites" => "Valida llocs",
"Edit article" => "Editar article",
"View Articles" => "Visualitza articles",
"One of the email addresses you typed is invalid" => "Una de les adreces de correu electrònic que heu escrit és invàlida",
"Topline" => "Línia superior",
"Author Name" => "Nom de l'autor",
"Own Image" => "Imatge pròpia",
"Article image" => "Imatge de l'article",
"Use own image" => "Empra imatge pròpia",
"Float text around image" => "text flotant al voltant de la imatge",
"Image caption" => "Requadre de la imatge",
"Published" => "Publicada",
"Cancel the edit, you will lose your changes." => "Cancel·la l'edició, perdràs els teus canvis.",
"Edit or create banners" => "Edita o crea blocs de publicitat",
"List banners" => "Llista butlletins",
"URL to link the banner" => "URL on enllaça el banner",
"Use dates" => "Utilitza dates",
"Select ONE method for the banner" => "Seleccioneu UN mètode per al banner",
"Use HTML" => "Utilitza HTML",
"Use image" => "Utilitza imatge",
"Image:" => "Imatge:",
"Current Image" => "Imatge actual",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "Emprar la imatge generada per la URL (la imatge serà manada a la URL per cada impressió)",
"Use Flash" => "Empra Flash",
"Pixels" => "Píxels",
"Use text" => "Utilitzar text",
"Save the Banner" => "Desar el banner",
"Remove Zones (you lose entered info for the banner)" => "Esborrar Zones (es perdrà l'informació entrada per el banner)",
"A category is mandatory" => "Una categoria és obligatòria",
"There are individual permissions set for this blog" => "Existeixen permisos fixats individualment per a aquesta bitàcola",
"Allow search" => "Permetre cerca",
"Allow comments" => "Permetre comentaris",
"Show user avatar" => "Mostra l'avatar de l'usuari",
"Blog heading" => "Encapçalament",
"Edit Style Sheet" => "edita Full d'Estil",
"Style Sheet" => "Fulla d'Estil",
"choose a stylesheet" => "escull un full d'estil",
"Try" => "Prova",
"For more information, please see" => "Per a més informació, si us plau consulta",
"Wiki Page Editor" => "l'Editor de pàgines Wiki",
"Bold text" => "Text en negreta",
"Italic text" => "Text en cursiva",
"single quotes" => "Apòstrofs",
"Underlined text" => "Text subratllat",
"Colored text" => "Text en colors",
"Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background." => "Es mostrarà amb el codi HTML o nom en anglès del color indicat. El color del nom en anglès pot contenir dos colors separats per una coma. En aquest cas, el primer color seria el color de la lletra i el segon el color del fons",
"Deleted text" => "Text esborrat",
"Headings" => "Capçaleres (o Títols)",
"Show/Hide" => "Mostra/Amaga",
"show/hide heading section. + (shown) or - (hidden) by default" => "mostra/amaga la secció de la capçalera. + (mostrat) o - (amaga) per defecte",
"Autonumbered Headings" => "Estils de títol autonumerats",
"Horizontal rule" => "Regla horitzontal",
"Text box" => "Requadre de text",
"Box content" => "Contingut de la caixa",
"Centered text" => "Text centrat",
"Inserts an editable variable" => "Inserta una variable editable",
"External links" => "Enllaços externs",
"use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)." => "empra claudators per a un enllaç extern: [URL], [URL|descripció_de_l_enllaç],[URL|descripció_de_l_enllaç|relació] o [URL|descripció_de_l_enllaç|relació|nocache] (aquest darrer evita que el Wiki local desi una còpia de la pàgina enllaçada a la memòria cau; es pot emprar la relació per insertar l'atribut rel per a l'enllaç - útil , p.e., per als efectes visuals amb la funcionalitat shadowbox).",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Per a un Wiki extern, empri NomWikiExtern:NomPlana o ((Nom Wiki Extern: Nom Plana))",
"Square Brackets" => "Corxets",
"Use [[foo] to show [foo]." => "Empra [[foo] per mostrar [foo].",
"Wiki References" => "Referències del Wiki",
"JoinCapitalizedWords or use" => "AjuntarParaulesEnMajúscula o usar",
"page|description" => "pàg|desc",
"for wiki references" => "per referències del wiki",
"page|#anchor" => "pàgina|#àncora",
"page|#anchor|desc" => "pàgina|#àncora|descripció",
"for wiki heading/anchor references" => "per a referències a estils de títol wiki/àncora",
"SomeName" => "AlgunNom",
"prevents referencing" => "impedeix referenciar",
"Lists" => "Llistes",
"for bullet lists" => "per a llistes de punts",
"for numbered lists" => "per a llistes numerades",
"for definiton lists" => "per a llistes de definicions",
"Indentation" => "Sagnat",
"Creates an indentation for each plus (useful in list to continue at the same level)" => "Crea un sagnat de text per a cada més (útil en llistes per continuar amb la numeració més avall)",
"Tables" => "Taules",
"row" => "fila",
"(very useful especially in tables)" => "(molt útil especialment en les taules)",
"Multi-page pages" => "Pàgines múltiples",
"to separate pages" => "per separar pàgines",
"Non parsed sections" => "Seccions no analitzades",
"Prevents wiki parsing of the enclosed data." => "Evita interpretar el codi wiki de les dades incloses.",
"Preformated sections" => "Seccions preformatades",
"~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text." => "~pp~ data ~/pp~ Mostra text/codi preformatat; no es fa cap processat de sintaxi Wiki dins d'aquestes seccions (com amb np), i l'espaiat és fixe (no es fa cap plegament de línies llarges).  ~pre~ data ~/pre~ també mostra text preformatat amb espaiat fix, però es si que es processa la sintaxi wiki en el text..",
"~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar." => "~tc~ Comentari Tiki ~/tc~ fa un comentari a Tiki.  Serà eliminat completament del text mostrat, però es desarà en l'arxiu per a referències futures i és visible pels editors de les pàgines.  ~hc~ Comentari HTML ~/hc~ fa un comentari HTML.  Serà  insertat com a comentari en l'HTML produït; aquests no es mostraran en navegadors web, però poden ser vistos en mostrar el codi font de la pàgina del navegador o formes similar.",
"Block Preformatting" => "Preformatat de Block",
"Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that." => "Sagna (inserta espais al principi per alinear el paràgraf més a la dreta) el text amb qualsevol nombre d'espais per convertir-lo en un bloc monoespaiat que encara segŭeix altres instruccions de format Wiki. Serà sagnat amb el mateix nombre d'espais que has emprat. Nota que d'aquesta forma no es preseva ni l'espaiat exacte ni els salts de línia; empra ~pp~...~/pp~ per això.",
"Special characters" => "Caràcters especials",
"hard space" => "espai rigid (no permet que es trenqui la línia)",
"numeric between ~ for html numeric characters entity" => "numeric entre ~ per a entitats html de caràcters numèrics",
"Plugin Help" => "Ajuda de Plugins",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;" => "Fixa't que els arguments dels connectors (plugins) es poden envoltar de cometes dobles (&quot;); això permet que continguin , o = o &gt;",
"No description available" => "No hi ha disponible cap descripció",
"Browse Images" => "Explorar Imatges",
"Edit successful!" => "Edició feta amb èxit!",
"The following image was successfully edited" => "La imatge següent ha estat editada amb èxit",
"Image Description" => "Descripció de la imatge",
"Upload from disk to change the image:" => "Puja des del disc per canviar la imatge:",
"Save and Go Next" => "Desa i ves al següent",
"Toggle interactive translation off" => "Desactiva la traducció interactiva",
"Toggle interactive translation on" => "Activa la traducció interactiva",
"Edit languages" => "Edita els idiomes",
"Select the language to edit" => "Selecionar l'idioma que es vol editar",
"Add a translation" => "Afegeix una traducció",
"Edit translations" => "edita traduccions",
"Translate recorded" => "Traducció gravada",
"reset table" => "reiniciar la taula",
"Select the language to Export" => "Selecionar l'idioma que es vol Exportar",
"Create New Block" => "Crear un nou bloc",
"Return to block listing" => "Torna a la llista de blocs",
"Block description: " => "Descripció del bloc",
"You are editing block:" => "Estàs editant el bloc:",
"Publishing date" => "Data de publicació",
"Publishing Date" => "Data de Publicació",
"Edit question options" => "edita opcions de pregunta",
"List Quizzes" => "Fes llista dels qüestionaris",
"Quiz Stats" => "Estadístiques de Tests",
"This Quiz Stats" => "Estadistiques d'aquest test",
"Edit this Quiz" => "Edita aquest test",
"Admin Quizzes" => "Administrar qüestionaris",
"Create/edit options for question" => "Crear/edita opcions per a una pregunta",
"Option" => "Opció",
"points" => "punts",
"Quiz" => "Test",
"canRepeat" => "potRepetir",
"timeLimit" => "tempsLimit",
"Create/edit quizzes" => "Crea/edita qüestionaris",
"There are individual permissions set for this quiz" => "Hi ha permisos individuals per a aquest Test",
"Quiz can be repeated" => "El test pot repetir-se",
"Store quiz results" => "Desar resultats d'aquest test",
"Immediate feedback" => "Retroalimentació immediata",
"Show correct answers" => "Mostra les respostes correctes",
"Shuffle questions" => "Qüestions barrejades",
"Shuffle answers" => "Respostes barrejades",
"Quiz is time limited" => "El test té un temps limitat",
"Maximum time" => "Temps màxim",
"Passing Percentage" => "Percentatge d'aprovació'",
"Edit quiz questions" => "edita preguntes del test",
"Create/edit questions for quiz" => "Crear/edita preguntes per a test",
"Question Type" => "Tipus de pregunta",
"Import questions from text" => "Importa preguntes des de text",
"Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character." => "Instruccions: Escriviu o enganxeu les preguntes amb respostes múltiples per escollir a sota. Una línia per la pregunta, després comenceu les opcions de resposta a les línies següents. Separeu les preguntes adicionals amb una línia en blanc. Indiqueu la resposta correcta començant la línia amb el caràcter \"*\" (sense les cometes).",
"Input" => "Entrada",
"maxScore" => "maxResultat",
"From Points" => "Des de punts",
"To Points" => "Fins a punts",
"Answer" => "Resposta",
"Modify Structure" => "Modifica l'estructura",
"You will remove" => "Eliminaràs",
"and its subpages from the structure, now you have two options:" => "i amb les seves subpàgines de l'estructura, ara tens dues opcions:",
"and its subpages from the structure" => "i les seves subpàgines de l'estructura",
"Remove only from structure" => "Esborrar nomès de l'estructura",
"Remove from structure and remove page too" => "Esborrar de l'estructura i també borrar la pàgina",
"The page already exists. The page that has been added to the structure is the existing one." => "La pàgina ja existeix. La pàgina que s'ha afegit a l'estructura és l'existent.",
"The following pages added have automatically been categorized with the same categories as the structure:" => "Les pàgines següents afegides han estat automàticament categoritzades amb les mateixes categories que l'estructura:",
"Structure Layout" => "Disseny de l'estructura",
"Monitor the Sub-Structure" => "Vigila la Sub-Estructura",
"Stop Monitoring the Sub-Structure" => "Deixa de vigilar la Sub-Estructura",
"Promote" => "Promocionar",
"Demote" => "Demot",
"Previous" => "Anterior",
"Current Node" => "Actual Node",
"Page alias" => "Àlies Pàgina",
"Move in this structure" => "Mou en aquesta estructura",
"Move to another structure" => "Mou a una altra estructura",
"at the beginning" => "al principi",
"at the end" => "al final",
"Add pages to current node" => "Afegeix pàgines al nòdul actual",
"After page" => "Pàgina Següent",
"Create Page" => "Crear pàgina",
"Use pre-existing page" => "Empra pàgina pre-existent",
"Categorize all pages in structure together" => "Categoritza totes les pàgines de l'estructura juntes",
"Remove existing categories from ALL pages before recategorizing" => "Elimina les categories existents de TOTES les pàgines abans de recategoritzar",
"Submit article" => "Enviar col·laboracions",
"List Submissions" => "Llista d'enviaments",
"Use ...page... to separate pages in a multi-page post" => "Empra ...page... per separar pàgines en una publicació multi-pàgina",
"<b>*</b>=optional" => "<b>*</b>=opcional",
"<b>Topline</b>=small line above Title" => "<b>Línia superior</b>=línia petita sobre el Títol",
"<b>Subtitle</b>=small line below Title" => "<b>Subtítol</b>=linia petita sota el Títol",
"<b>Source</b>=URL to article source" => "<b>Font</b>=URL a la font de l'article",
"Own image size x" => "Dimensió x d'imatge pròpia",
"Own image size y" => "Dimensió y d'imatge pròpia",
"Submit Article" => "Envia un Article",
"Auto-Approve Article" => "Autoaprova l'Article",
"Edit templates" => "Editar plantilles",
"Template listing" => "Llistat de plantilles",
"Available templates" => "Plantilles Permesses",
"Save Only in the Theme:" => "Desa només en el Tema:",
"Delete the copy in the theme:" => "Esborra la còpia en el tema:",
"Edit a topic" => "Edita un tema",
"Add Notification Email" => "Afegeix Correu-e per Notificacions",
"Admin notifications" => "Administra les notificacions",
"Translate:" => "Tradueix:",
"View Page" => "Visualitza pàgina",
"You must specify the object language" => "Has d'especificar l'idioma de l'objecte",
"The object doesn't exist" => "L'objecte no existeix",
"The object doesn't have a language" => "L'objecte no té un idioma",
"The object has already a translation for this language" => "L'objecte ja té una traducció per a aquest idioma",
"The object is already in the set of translations" => "L'objecte ja hi és en el conjunt de la traducció",
"Change language for this page" => "Canvia l'idioma per a aquesta pàgina",
"Create translation" => "Crea la traducció",
"\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"T'has oblidat d'especificar l'idioma de la traducció. si us plau, escull un idioma de la llista.\"",
"detach" => "separa",
"No language is assigned to this page." => "No hi ha cap idioma assignat a aquesta pàgina.",
"Please select a language before performing translation." => "Si us plau, selecciona un idioma abans de fer la traducció.",
"Set Current Page's Language" => "Especifica l'idioma de la pàgina actual",
"Preview your changes." => "Previsualitza els teus canvis.",
"You are editing the staging copy of the approved version of this page. Changes will be merged in after approval." => "Estàs editant la còpia per revisar d'una versió aprovada d'aquesta pàgina. Es fusionaran els canvis després de l'aprovació.",
"The current staging copy may contain changes that have yet to be approved." => "La còpia per revisar actual pot contenir canvis que encara han de ser aprovats.",
"View changes since last approval." => "Mostra els canvis des de la darrera aprovació.",
"You are editing the approved copy of this page." => "Estàs editant la còpia aprovada d'aquesta pàgina.",
"There are currently changes in the staging copy that have yet to be approved." => "Hi ha canvis a la còpia per revisar que encara han de ser aprovats.",
"Are you sure you do not want to edit" => "Segur que no vols editar",
"the staging copy" => "la còpia per revisar",
"instead?" => "en el seu lloc?",
"Draft written on" => "Esborrany desat el",
"Warning: new versions of this page have been made after this draft" => "Avís: s'han fet noves versions d'aquesta pàgina després d'aquest esborrany",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "El LlocdeProves (SandBox) és una pàgina on pots practicar les teves habilitats d'edició, emprar la opció de previsualització per previsualitzar l'aspecte de la pàgina, i no es guarda cap versió per a aquesta pàgina.",
"No comment" => "Cap comentari",
"All Versions" => "totes les versions",
"Edit wiki page" => "Edita la pàgina wiki",
"Change diff styles" => "Canvia l'estil de diff",
"Edit page" => "Edita la pàgina",
"Describe the change you made:" => "Descriu el canvi que has fet:",
"Add another image" => "Afegeix una altra imatge",
"Categories will be inherited from the structure top page" => "S'heredaran les categories de la pàgina inicial de l'estructura",
"Admin Content Templates" => "Administrar contingut de les plantilles",
"Lock this page" => "Bloqueja aquesta pàgina",
"Try to convert HTML to wiki" => "Prova de convertir HTML a wiki",
"export all versions" => "exporta totes les versions",
"Year:" => "Any:",
"Authors:" => "Autors:",
"Manage structures" => "Gestioneu estructures",
"There is no available poll template." => "No hi ha cap plantilla de consulta disponible.",
"You should ask an admin to create them." => "Haurieu de preguntar a l'administrador per crear-ho.",
"Send urgent translation request." => "Envia una petició de traducció urgent.",
"List Sheets" => "Llista fulls",
"Graph" => "Grafica",
"Autodetect" => "Autodetecta",
"status" => "estatus",
"lastModif" => "UltimaModif",
"Fields visible in items list" => "Camps visibles a la llista d'ítems",
"Fields searchable or visible in items list" => "Camps cercables o visibles a la llista d'ítems",
"Fields visible in an item view" => "Camps visibles en la vista d'ítem",
"All fields" => "Tots els camps",
"items" => "ítems",
"Dump" => "Volcat",
"Admin FAQ" => "Administració de PMF",
"List FAQs" => "Fer llista de PUFs",
"View FAQ" => "Veure PUF",
"Edit this FAQ" => "Edita aquesta PUF",
"New Question" => "Pregunta nova",
"Use a question from another FAQ" => "Empra pregunta d'una altra PUF",
"FAQ questions" => "Preguntes d'Ús Freqüent (PUFs)",
"Suggested questions" => "Preguntes suggerides",
"No suggested questions" => "No hi ha cap suggeriment",
"File Archive" => "Arxiva el fitxer",
"Upload File" => "Puja l'arxiu",
"View tpl" => "Visualitza plantilla",
"File Galleries tpl" => "Galeries d'arxius tpl",
"Edit template" => "Edita Plantilles",
"You can access the file gallery using the following URL" => "Pots accedir a la galeria d'arxius emprant la URL",
"Size (width x height)" => "Mida (amplada x alçada)",
"Forum Importer" => "Importador de Fòrums",
"Admin forums" => "Admin fòrums",
"Import from a Local SQL File" => "Importa a partir d'arxiu SQL Local",
"Forum Type" => "Tipus de Fòrum",
"DB Prefix" => "Prefix de DB",
"Local SQL Filename on Server (path will be stripped)" => "Arxiu SQL local al servidor (la ruta serà estripada)",
"Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Ha d'estar a tikiroot/{\$tmpdir} o a tikiroot/img/wiki_up",
"Verification" => "Verificació",
"File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred." => "No s'ha especificat l'arxiu, o no va ser possible trobar-lo en cap dels dos llocs.  Si us plau, posar l'arxiu en algun dels dos directoris i torna Enrere. Si l'arxiu hi és en ambdos llocs, el lloc \$tikiroot/{\$filecheck} serà escollit preferentment.",
"Go Back" => "Torna enrere",
"Select a Forum You Wish to Move (ONE at a time!)" => "Selecciona un Fòrum que vulguis moure (UN cada cop!)",
"Which Forum Do You Wish to Import this Into?" => "A quin fòrum vols importar això?",
"Edit queued message" => "edita missatge en cua",
"make this a thread of" => "fes aixó un missatge permanent de",
"None, this is a thread message" => "Cap, aquest és un missatge fil",
"summary" => "resum",
"Announce" => "Anunci",
"Hot" => "Calent",
"Locked" => "Bloquejat",
"no feeling" => "sense sentiment",
"frown" => "front",
"exclaim" => "Exclamació",
"question" => "pregunta",
"happy" => "feliç",
"wink" => "parpadejar",
"Save and Approve" => "Desa i aprova",
"convert to topic" => "converteix a tema",
"List of messages" => "Llista de missatges",
"Topic:" => "Tema:",
"New Topic" => "Nou tema",
"no summary" => "sense resum",
"No messages queued yet" => "Encara no hi ha missatges a la cua",
"Search by name" => "Cerca pel nom",
"Search in content" => "Cerca al contingut",
"Last Post" => "Darrer missatge",
"Configure Forum" => "Configura el fòrum",
"Reported by" => "Reportat per",
"Tag translation" => "Etiqueta traducció",
"Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag." => "Fixa't que les etiquetes que han estat creades a pàgines sense idioma assignat romandran \n\tuniversals (és a dir, amb la mateixa etiqueta a tots els idiomes) fins que s'especifiqui un idioma per a l'etiqueta.",
"Until then, they cannot be translated." => "Fins llavors, no poden ser traduïdes.",
"Show checkboxes to clear language information on tags" => "Mostra caselles de verificació per netejar la informació d'idioma a les etiquetes",
"There are no tags on this page in your preferred languages" => "No hi ha etiquetes en aquesta pàgina per als teus idiomes preferits",
"Set language" => "Especifica idioma",
"Show the following languages" => "Mostra els següents idiomes",
"Pending requests" => "Peticions pendents",
"Request Time" => "Data de petició",
"Accept" => "Accepta",
"Refuse" => "Rebutja",
"Waiting requests" => "Esperant peticions",
"Your friends" => "Les teves amistats",
"break friendship" => "trenca amistat",
"Galleries" => "Galeries",
"Create New Gallery" => "Crear una nova galeria",
"Create a gallery" => "Crear una galeria",
"Edit this gallery:" => "edita aquesta galeria:",
"There are individual permissions set for this gallery" => "Existeixen permisos fixats individualment per a aquesta galeria",
"Gallery is visible to non-admin users?" => "Galeria visible per usuaris no autoritzats",
"Geographic" => "Geogràfic",
"Fields to show during browsing the gallery" => "Camps que es mostren quan es navega per la galeria",
"XY-Size" => "mida-XY",
"Gallery Image" => "Imatge de la galeria",
"Available scales" => "Permesses escales",
"Global default" => "Per defecte Global",
"Bounding box" => "Requadre delimitador",
"default scale" => "escala per defecte",
"No scales available" => "No hi ha cap escala disponible",
"Original image is default scale" => "La imatge original és a l'escala per defecte",
"Add scaled images with bounding box of square size" => "Afegeix imatges escalades amb requadre delimitador quadrat",
"Other users can upload images to this gallery" => "Permetre a altres usuaris afegir imatges en aquesta galeria",
"You can access the gallery using the following URL" => "Pots accedir a la galeria emprant la URL",
"Available Galleries" => "Galeries disponibles",
"Choose a filter" => "Escull un filtre",
"Imgs" => "Imtgs",
"Make Map" => "Fes el Mapa",
"Google Map Locator" => "Localitzador als Mapes de Google",
"Back to preferences" => "Torna a preferències",
"Save clicked point" => "Guarda el punt on he clicat",
"Save current view as default" => "Guarda la visualització actual com a la visualització per defecte",
"Users Map" => "Mapa d'Usuaris",
"Select Graphic Type" => "Selecciona Tipus de Gràfic",
"Pie Chart" => "Gràfic de Pastís",
"Multiline" => "Multilínia",
"Multibar" => "Multibarra",
"Bar Stack" => "Barres apilades",
"Landscape" => "Apaisat",
"Portrait" => "Vertical",
"Independant Scale" => "Escala independent",
"Horizontal Scale" => "Escala horitzontal",
"Vertical Scale" => "Escala vertical",
"Series" => "Sèries",
"Wiki plug-in" => "Connector Wiki (plug-in)",
"Rollback" => "Restableix",
"Import From File" => "Importa des d'un arxiu",
"Grab Wiki Tables" => "Agafa les Taules Wiki",
"Import pages from a Structured Text Dump" => "Importa pàgines d'una descarrega de text estructurada",
"Name of the dump file (it has to be in dump/)" => "Nom de l'arxiu de descàrrega (ha d'estar a dump/)",
"Overwrite existing pages if the name is the same" => "Sobreescriu pàgines existents si el nom és el mateix",
"Previously remove existing page versions" => "Treu primer les versions existents de la pàgina",
"excerpt" => "extracte",
"Result" => "Resultat",
"body" => "cos",
"Or" => "O",
"Tiki installer" => "Instal·lador de Tiki",
"Welcome" => "Benvinguts",
"Use this script to install a new Tiki database or upgrade your existing database to release" => "Empra aquesta utilitat per instal·lar una nova base de dades o actualitzar la teva base de dades existent a la versió",
"For the latest information about this release, please read the" => "Per a la darrera informació sobre aquest alliberament, si us plau, llegeix les",
"Release Notes" => "Notes d'alliberament",
"For complete documentation, please visit" => "Per a la documentació completa, si us plau visita",
"For more information about Tiki, please visit" => "Per més informació sobre Tiki, si us plau visita",
"Read the License" => "Llegeix la Llicència",
" <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>" => " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/deed.ca\" target=\"_blank\">Aquí tens un resum llegible per humans de la llicència de sota, incloent moltes traduccions.</a>",
"Review the System Requirements" => "Revisa els requeriments del Sistema",
"Success" => "Èxit",
"Copy test mail to " => "Copia el correu-e de prova a ",
"Send Test Message" => "Envia missatge de prova",
"Tiki was able to send a test message to" => "Tiki ha pogut enviar el missatge de prova a ",
"Image Processing" => "Processat d'imatges",
"Set the Database Connection" => "Especifica la connexió a la base de dades",
"Use Existing Connection" => "Empra la connexió existent",
"Modify database connection" => "Modifca la connexió a la base de dades",
"Database information" => "Informació de la Base de dades",
"Select the type of database to use with Tiki." => "Selecciona el tipus de base de dades per emprar amb Tiki.",
"Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension." => "Aquí només es mostren les bases de dades suportades per la teva instal·lació PHP. Si la teva base de dades no està a la llista, prova d'instal·lar l'extensió de PHP apropiada.",
"Enter the name of the database that Tiki will use." => "Introdueix el nom de la base de dades que emprarà Tiki.",
"Database user" => "Usuari de la Base de dades",
"User name:" => "Nom d'usuari:",
"Character set" => "Conjunt de caràcters",
"Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "Altament recomanat per a instal·lacions noves. De totes formes, si estàs actualitzant o migrant una base de dades prèvia de Tiki, es recomana que treguis la selecció d'aquesta casella de sota",
"Always force connection to use UTF-8" => "Força sempre a que s'utilitzi el conjunt de caràcters UTF-8 per a la connexió a la base de dades",
"Install &amp; Upgrade" => "Instal·lacions &amp; Actualitzacions",
"Install" => "Instal·lació",
"Encoding Issue" => "Qüestió de la codificació",
"<p>Your database encoding is <strong>not</strong> in UTF-8.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8</em>.</p>" => "<p>La codificació (conjunt de caràcters) de la teva base de dades  <strong>no</strong> es troba en UTF-8.</p><p>La codificació actual és <em>%0</em>. Els idiomes que estaran disponibles per al contingut d'aquest lloc seran limitats. Si tens intenció d'emprar idiomes que no estan coberts pel conjunt de caràcters, hauries de re-crear o modificar la base de dades de forma que la codificació per omissió sigui <em>utf8</em>.</p>",
"Convert database and tables to UTF-8" => "Converteix la base de dades i taules a UTF-8",
"Reinstall the database" => "Reinstal·la la base de dades",
"Reinstall" => "Reinstal·la-ho",
"Upgrade" => "Actualització",
"Warning: Category Permissions Will Not Be Upgraded" => "Avís: Els permisos de categories no seran actualitzats automàticament",
"Automatically upgrade your existing database to v" => "Actualitza automàticament la teva base de dades existent a la v",
"Review the Upgrade" => "Revisa l'Actualització",
"Review the Installation" => "Revisa la Instal·lació",
"Upgrade complete" => "Actualització completa",
"Installation complete" => "Instal·lació completa",
"If this is your first install, your admin password is <strong>admin</strong>." => "Si és la teva primera instal·lació, la teva contrasenya d'administrador <strong>admin</strong>.",
"Failed" => "No  han tingut èxit",
"During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages." => "Durant una actualització, és normal tenir missatges d'error SQL de l'estil <strong>La taula ja existeix</strong>.",
".htaccess File" => "Arxiu .htaccess",
"We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "Recomanem habilitar l'arxiu <strong>.htaccess</strong> per al teu Tiki",
"This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "Això et permetrà emprar les  SEFURLs (adreces d'internet amigables als cercadors) i ajudar a millorar la seguretat del teu lloc",
"Configure General Settings" => "Configuracions Generals",
"Secure Log in" => "Connexió Segura",
"Report all errors except notices" => "Informar de tots els errors excepte les notificacions",
"Visible to Admin only" => "Visibles només a persones administradores",
"Administrator" => "Administrador/a",
"Upgrade fix" => "Reparació per a actualitzacions (opcional)",
"Create the <em>Admins</em> group, if missing" => "Es crearà el grup <em>Admins</em>, si no hi és present",
"Grant <em>tiki_p_admin</em> to the group, if missing" => "Es donarà el permís <em>tiki_p_admin</em> al grup, si hi manca",
"Add the administrator account to the group, if missing" => "S'afegirà el compte d'administrador (admin) al grup, si no hi és",
"Enter Your Tiki" => "Entra al teu Tiki",
"Installation" => "Instal·lació",
"If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu." => "Si això és una actualització, neteja la memòria cau (cache) de Tiki manualment (el directori <strong>templates_c</strong>) o a través d'emprar l'opció del menú d'administració <strong>Admin &gt; Sistema</strong>.",
"Enter Tiki and Lock Installer" => "Entra a Tiki i bloqueja l'Instal·lador",
"Recommended" => "Recomanat",
"Enter Tiki Without Locking Installer" => "Entra a Tiki SENSE bloquejar l'Instal·lador",
"You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "Ja pots accedir ara al lloc amb normalitat. Informa de qualsevol incidència o problemes que detectis (si és el cas) als fòrums comunitaris o al formulari de registre d'errors",
"Previous table encoding" => "Codificació anterior de les taules",
"Please select" => "Si us plau, selecciona una",
"Dangerous: Fix double encoding" => "Perillós: Arregla la codificació doble",
"MultiTiki Setup" => "Instal·lació MultiTiki",
"Default Installation" => "Instal·lació per omissió",
"DB OK" => "BD OK",
"No DB" => "Cap BD",
"Install/Upgrade" => "Instal·lació / Actualització",
"Database Connection" => "Connexió a la Base de dades",
"Reset the Database Connection" => "Re-especifica la connexió a la Base de dades",
"Configure the General Settings" => "Configura els paràmetres generals",
"Tiki Icon" => "Icona de Tiki",
"Tiki Project Web Site" => "Lloc Web del Projecte Tiki",
"Documentation" => "Documentació",
"Support Forums" => "Fòrums de Suport",
"Powered by Tiki Wiki CMS Groupware" => "Potenciat per Tiki Wiki CMS Groupware",
"Clear cached version and refresh cache" => "Neteja versió captada i actualitza memòria cau",
"configure rules" => "configura normes",
"Edit Repository" => "Edita dipòsit",
"Last Changes" => "Últimes modificacions",
"Search by Date" => "Cerca per data",
"LastChanges" => "DarrersCanvis",
"Pages like" => "Pàgines similars",
"Edit New Article" => "Edita nou article",
"View Submissions" => "Veure col·laboracions",
"ExpireDate" => "DataExpiració",
"Img" => "Imatge",
"To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone." => "Per utilitzar un banner en un <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">mòdul</a> o una plantilla, utilitzeu {literal}{banner zone=ABC}{/literal}, on ABC és el nom de la zona.",
"Create banner" => "Crea una banner",
"Method" => "Mètode",
"Use Dates?" => "Utilitzar dates?",
"Max Impressions" => "Impressions màx",
"Max Clicks" => "Clics Max.",
"Clicks" => "Clics",
"Create New Blog" => "Crear una nova bitàcola",
"Approval" => "Aprova-ho",
"Rejected" => "Rebutjat",
"To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block." => "Per utilitzar blocs de continguts en una àrea de text (Pàgina wiki, etc), un <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">mòdul</a> o una plantilla, utilitzeu {literal}{content id=x}{/literal}, on x és l'ID del bloc de continguts.",
"Available content blocks" => "Blocs disponibles",
"Current Value" => "Valor actual",
"Current ver" => "Versió actual",
"Next ver" => "Propera versió",
"Future vers" => "Vers. futura",
"Program" => "Programar",
"Edit content block" => "Edita bloc de contingut",
"Create content block" => "Crea bloc de contingut",
"Available FAQs" => "PMF disponibles",
"Edit/Create" => "Edita/Crea",
"Edit this FAQ:" => "Editeu aquesta PMF:",
"Create new FAQ" => "Creeu una nova PMF",
"Create New FAQ:" => "Creeu una nova PMF:",
"Users can suggest questions" => "Els usuaris poden suggerir preguntes",
"Create a File Gallery" => "Crear una galeria d'arxius",
"SlideShow" => "Passi de diapositives",
"Keep gallery window open" => "Manté la finestra de la galeria oberta",
"Your comment" => "El teu comentari",
"optional" => "opcional",
"Modifications" => "Modificacions",
"Gallery Images" => "Galeries d'imatges",
"Media Type" => "Tipus de media",
"More Information" => "Més informació",
"No entries" => "Sense entrades",
"Click here" => "Clic aquí",
"Blog Title" => "Títol de la Bitàcola",
"Edit New Submission" => "Edita la nova col·laboració",
"Survey stats" => "Estadístiques de l'enquesta",
"Take Survey" => "Omple l'enquesta",
"users registered" => "usuaris enregistrats",
"like" => "com",
"Distance (km)" => "Distància (km)",
"Create a Wiki Page" => "Crea una pàgina Wiki",
"Insert name of the page you wish to create" => "Inserta el nom de la pàgina que vols crear",
"Last mod" => "Darrera mod",
"Last modification" => "Darrera modificació",
"Page creator" => "Creador de la pàgina",
"Last author" => "Darrer autor",
"Last version" => "Darrera versió",
"Last ver." => "Darr. ver.",
"Status of the page" => "Estatus de la pàgian",
"Links to other items in page" => "enllaça a altres ítems a la pàgina",
"Links to this page in other pages" => "Enllaós a aquesta pàgina en altres pàgines",
"Backl." => "Retroenll.",
"Page size" => "Mida de pàgina",
"Lang." => "Idiom.",
"unlocked" => "desbloquejat/da",
" {if \$find ne ''}and {/if}starting with" => " {if \$find ne ''}i {/if}començant amb",
"Open client window" => "Obre la finestra de client",
"Generate HTML" => "Genera HTML",
"Transcripts" => "Transcripcions",
"Online operators" => "Operadors connectats",
"Operator" => "Operador",
"transcripts" => "transcripcions",
"offline" => "fora de línia",
"Offline operators" => "Operadors desconnectats",
"Add an operator to the system" => "Afegiu un operador al sistema",
"Operators must be tiki users" => "Els operadors han de ser usuaris del tiki",
"Set as Operator" => "Definit com a operador",
"Chat started" => "Xat iniciat",
"Operator:" => "Operador:",
"Live support:User window" => "Suport Directe:finestra de l'usuari/a",
"Request live support" => "Demanar soport en directe",
"Request support" => "Demanar suport",
"Open a support ticket instead" => "Obrir una butlleta de suport",
"Your request is being processed" => "La teva petició està essent processada",
"cancel request and exit" => "Cancel·lar petició i sortir",
"cancel request and leave a message" => "Cancel·lar petició i deixar un missatge",
"Live support:Console" => "Suport Directe:Consol·la",
"be online" => "estar connectat",
"be offline" => "estar desconnectat",
"Support requests" => "Peticións d'ajuda",
"Requested" => "Sol·licitat",
"Join" => "Uneix",
"Support chat transcripts" => "Suport de transcripcions de chat",
"Back to admin" => "Torna a admin",
"operator" => "operador",
"started" => "començat",
"reason" => "raó",
"msgs" => "mstgs",
"Transcript" => "Transcripció",
"For security purposes we must periodically validate your email address to allow continued access to this site." => "Per qüestions de seguretat hem de validar periòdicament la teva adreça de correu-e per permetre l'acés continuat en aquest lloc.",
"A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site." => "Se t'ha enviat un correu-e de validació. Si us plau, obre'l i segueix les instruccions per obtenir de nou accés al lloc.",
"Thank you" => "Gràcies",
"Mail-in feature" => "Prestació Correu-in",
"Daily" => "Diari",
"Weekly" => "Setmanal",
"Remove old events" => "Elimina els esdeveniments antics",
"duration" => "durada",
"mins" => "minuts",
"Edit Event" => "Edita Esdeveniment",
"Mini Calendar: Preferences" => "Mini Calendari: Preferències",
"Calendar Interval in daily view" => "Vista diària dels intervals del calendari",
"Start hour for days" => "Hora d'inici per als dies",
"End hour for days" => "Hora d'acabament per als dies",
"Reminders" => "Recordatoris",
"no reminders" => "sense recordatoris",
"Or enter path or URL" => "O entreu-hi el camí o la URL",
"Add Topic" => "Afegiu-hi un tema",
"Mods Configuration" => "Configuració de Mods",
"Update remote index" => "Actualitza índex remot",
"Rebuild local list" => "Reconstrueix la lista local",
"Republish all" => "Republica'ls tots",
"Publish all" => "Publica'ls tots",
"Unpublish all" => "Despublica'ls tots",
"Attention" => "Atenció",
"for version" => "per a la versió",
"All versions" => "Totes les versions",
"or later" => "o posterior",
"Display only this type" => "Mostra només aquest tipus",
"Unpublish" => "Despublica",
"Republish" => "Republica",
"licence" => "llicència",
"Tikiwiki Mods Configuration" => "Configuració de Mods de Tikiwiki",
"Mods Install/uninstall" => "Instal·lació/Desinstal·lació de Mods",
"Enable Mods providing" => "Habilita el proveïemnt de Mods",
"Mods local directory" => "Directori local de Mods",
"Mods remote server" => "Directori remot de Mods",
"Package Config" => "Configuració de Paquets",
"y" => "s",
"User Galleries" => "Galeries de l'usuari/a",
"My Articles" => "Els meus Articles",
"User Articles" => "Articles de l'usuari",
"My User Items" => "Els meus ítems d'usuari",
"User Items" => "Ítems d'usuari",
"Comments:" => "Comentaris:",
"Unread Messages" => "Missatges no llegits",
"Tasks" => "Tasques",
"User forum topics" => "Tòpics de l'usuari als fòrums",
"Forum topics" => "Tòpics del Fòrum",
"Date of post" => "Data de publicació",
"User forum replies" => "Respostes de l'usuari al fòrum",
"Forum replies" => "Respostes al Fòrum",
"To display the objects you created or contributed to:" => "Per mostrar els objectes en els que participes:",
"MyTiki" => "ElmeuTiki",
"MyInfo" => "Les meves informacions",
"Contacts Preferences" => "Preferències dels contactes",
"Notepad" => "Bloc de notes",
"MyFiles" => "Elsmeusarxius",
"My Watches" => "Els meus avisos",
"Sent editions" => "Edicions enviades",
"Sent Edition" => "Edició Enviada",
"HTML version" => "Versió en HTML",
"Text version" => "Versió en Text senzill",
"The newsletter was sent to {\$sent} email addresses" => "El butlletí ha estat enviat a {\$sent} adreces de correu-e",
"Delete errors" => "Esborra errors",
"Not sent" => "No s'ha enviat",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Gràcies per la vostra subscripció. Aviat rebreu un missatge  com a confirmació de la vostra subscripció. No rebreu cap butlletí fins que confirmeu la subscripció.",
"Your email address was removed from the list of subscriptors." => "La teva adreça de correu-e ha estat eliminada de la llista de subscriptors.",
"Subscription confirmed!" => "Subscripció confirmada!",
"Subscribe to Newsletter" => "Subscriure a butlletí",
"Subscribe to this Newsletter" => "Subscriu",
"Available Newsletters" => "Butlletins disponibles",
"Write a note" => "Escriu una nota",
"No notes yet" => "Encara no hi ha notes",
"Merge selected notes into" => "fusiona les notes seleccionades en",
"Reading note:" => "Nota de lectura:",
"List notes" => "Llista de notes",
"Write note" => "Escriu nota",
"Wiki Create" => "Crea wiki",
"Wiki Overwrite" => "Sobrescriu wiki",
"This Category" => "Aquesta Categoria",
"All Descendants" => "Tots els descendents",
"Assign permissions to " => "Assignar permisos a ",
"Edit Permissions" => "Edita els permisos",
"Assign permissions to this object" => "Assigna permisos a aquest objecte",
"Paste" => "Enganxa",
"Your OpenID identity is valid" => "La teva identitat OpenID és vàlida",
"Your identity gives you access to multiple user accounts." => "La teva identitat et dona accés a múltiples comptes d'usuari.",
"Select account" => "Selecciona compte",
"Orphan Pages" => "Pàgines òrfenes",
"Browser not supported" => "Explorador no suportat",
"Rename" => "Reanomenar",
"Make Structure" => "Fes Estructura",
"Slides" => "Diapos",
"Discuss" => "Debat",
"Attach File" => "Adjuntar arxiu",
"1 File Attached" => "1 arxiu adjunt",
"{\$atts|@count} files attached" => "{\$atts|@count} arxius adjunts",
"version" => "versió",
"(current)" => "(actual)",
"Rollback to this version" => "Restableix aquesta versió",
"s=source" => "s=codi font",
"b=rollback" => "b=restableix",
"Edit Comment" => "Edita el comentari",
"Update Translation" => "Actualitza traducció",
"Hide translation history" => "Amaga l'historial de la traducció",
"Show translation history" => "Mostra l'historial de la traducció",
"Pick your avatar" => "Escull el teu avatar",
"Your current avatar" => "El teu avatar actual",
"no avatar" => "cap avatar",
"Pick avatar from the library" => "Trieu avatar de la biblioteca",
"Pick user Avatar" => "Escull l'Avatar de l'usuari",
"Hide all" => "Amaga-ho tot",
"icons" => "icones",
"Show all" => "Mostra-ho tot",
"Avatar Image" => "Imatge Avatar",
"random" => "aleatori",
"Upload your own avatar" => "Puja el teu propi avatar",
"File (only .gif, .jpg and .png images approximately 45px × 45px)" => "Arxiu (només imatges .gif, .jpg i .png d'aproximadament 45px × 45px)",
"Plugin execution was denied" => "S'ha denegat l'execució del connector",
"View arguments" => "Veure els arguments",
"Execute the plugin in preview mode (may be dangerous)" => "Executar el connector en mode de previsualització (pot ser perillós)",
"Approve the plugin for public execution" => "Aprovar l'ús del connector per a execució pública",
"View Details" => "Mostra detalls",
"Body" => "Cos",
"Insert" => "Insertar",
"Plugin Approval" => "Aprovació d'Ús de Connectors",
"View Results" => "Visualitza resultats",
"Vote poll" => "Participa en la consulta",
"Other Polls" => "Altres Consultes",
"Poll Results" => "Resultats de la Consulta",
"Top Voted Polls" => "Consultes amb més participació",
"Edit Poll" => "Edita el Sondeig",
"Find the poll" => "Troba el sondeig",
"Number of top voted polls to show" => "Nombre a mostrar de consultes amb més participació",
"Vote range displayed" => "Rang de consulta mostrat",
"List Votes" => "Llista Vots",
"votes" => "vots",
"Average:" => "Mitjana:",
"Topic image" => "Imatge del tòpic",
"The original document is available at" => "El document original està disponible en",
"Print multiple pages" => "Imprimir múltiples pàgines",
"Selected Structures" => "Estructures seleccionades",
"Add Structure" => "Afegeix estructura",
"No structures" => "Cap estructura",
"No pages" => "Cap pàgina",
"Add Page" => "Afegeix pàgina",
"Remove Page" => "Eliminar pàgina",
"Selected Pages" => "Planes Seleccionades",
"Add Pages from Structures" => "Afegeix pàgines des d'Estructures",
"Edit quiz" => "Edita el qüestionari",
"Current Version" => "Versió actual",
"General Options" => "Opcions generals",
"Publication Date" => "Data de publicació",
"at " => "a ",
"Use " => "Empra ",
"randomly selected questions." => "preguntes seleccionades a l'atzar.",
"Test-time Options" => "Opcions de test amb temps limitat",
"Limit questions displayed per page to " => "Limita les preguntes mostrades per pàgina a ",
"&nbsp question(s)." => "&nbsp pregunta/es.",
"Impose a time limit of " => "Imposa un temps limit de ",
"Allow students to store partial results and return to quiz." => "Permet als estudiants guardar els resultats parcials i tornar al qüestionari.",
"Allow students to retake this quiz " => "Permet als estudiants repetir aquest qüestionari ",
"Grading and Feedback" => "Avaluació i retroalimentació",
"Grading method " => "Mètode d'avaluació ",
"Show students their score " => "Mostra als estudiants la seva puntuació ",
"Show students the correct answers " => "Mostra als estudiants les respostes correctes",
"Publish statistics " => "Publica les estadístiques ",
"Extra Options" => "Opcions extres",
"Solicit additional questions from students" => "Solicita preguntes addicionals dels estudiants",
"Link quiz to forum named: " => "Enllaça la pregunta al fòrum anomenat: ",
"Prologue:" => "Pròleg:",
"Epilogue:" => "Epíleg:",
"Quiz result stats" => "Estadístiques dels resultats dels Tests",
"Time" => "Temps",
"User answers" => "Respostes de l'usuari/a",
"Stats for quizzes" => "Estadistiques de qüestionaris",
"taken" => "pres/os",
"Av score" => "Resultat mitjà",
"Av time" => "Temps mitjà",
"Clear Stats" => "Esborrar estadístiques",
"time taken" => "temps emprat",
"Passed" => "Aprovat",
"Stats for this quiz Questions " => "Estadístiques per a les preguntes d'aquest test",
"Average" => "Mitjana",
"Top 10" => "10 per dalt",
"Top 20" => "20 per dalt",
"Top 50" => "50 per dalt",
"Top 100" => "100 per dalt",
"expires:" => "expira:",
"star" => "estrella",
"half star" => "mitja estrella",
"Received articles" => "Articles rebuts",
"Edit received article" => "Edita article rebut",
"Use Image" => "Empra imatge",
"Image x size" => "Mida x de la imatge",
"Image y size" => "Mida y de la imatge",
"Image name" => "Nom de la imatge",
"Accept Article" => "Accepta Article",
"Site" => "Lloc",
"Received Pages" => "Pàgines Rebudes",
"Edit Received Page" => "Edita la Pàgina Rebuda",
"The highlight pages already exist." => "Les pàgines ressaltades ja existeixen.",
"Please, change the name if you want the page to be uploaded." => "Si us plau, canvia el nom si vols que es pugi la pàgina.",
"Received Structures" => "Estructures rebudes",
"Referer stats" => "Estadístiques de referenciadors",
"Last" => "Darrer",
"However, no account is associated to the OpenID identifier." => "Ara bé, no hi ha cap compte associat a l'identificador OpenID.",
"Your email could not be validated; make sure you email is correct and click register below." => "La vostra adreça de correu no ha esta validada; assegureu-vos que l'adreça és correcta i cliqueu el botó inferior de registre.",
"Register as a new user" => "Registrar-se com a usuari nou",
"If you use an email filter, be sure to add %0 to your accepted list" => "Si empres un filter de correu-e, assegura't d'afegir %0 a la llista dels acceptats",
"Associate OpenID with an existing Tikiwiki account" => "Associa l'OpenID amb un compte de Tiki existent",
"Tiki site registered" => "Llocs Tiki registrats",
"The following site was added and validation by admin may be needed before appearing on the lists" => "El lloc web següent s'hi ha afegit i potser necessitarà ser validat per l'administrador abans d'aparèixer a les llistes",
"You don't have permission to use this feature." => "No tens permís per emprar aquesta característica. Prova (re)connectar-te primer, enregistrant-te abans si no ho has fet encara",
"Please register." => "Si us plau, registreu-vos.",
"Read this first!" => "Llegeix això abans de començar!",
"Registering is voluntary." => "Registrar-se és voluntari.",
"Registering does not give you any benefits except one more link to your site." => "Registrar-se no et dona cap més avantatge que un enllaç més cap al teu lloc.",
"You don't get any emails, we don't sell the data about your site." => "No aconseguiràs adreces d'e-correus, no venem les dades dels llocs.",
"Registering is just for us to get an overview of Tiki's usage." => "El registre només és per fer-nos una idea de l'ús que es fa de Tiki.",
"If your site is private or inside your intranet, you should not register!" => "Si el teu lloc és privat o està en una (intranet/xarxa interna), no et registris!",
"Information about your site" => "Informació del teu lloc",
"Send me my Password" => "Envia'm la meva contrasenya",
"Request Password Reset" => "Demana un canvi de contrasenya",
"Last Version" => "última versió",
"Back to page" => "Retorna a la pàgina",
"You are about to remove the page" => "Esteu a punt d'eliminar la pàgina",
"permanently" => "permanentment",
"Remove all versions of this page" => "Elimina totes les versions d'aquesta pàgina",
"Rollback page" => "Restableix versió",
"to version" => "a la versió",
"Searched" => "Cercat",
"Search in" => "Buscar a",
"Simple search" => "Cerca simple",
"No pages matched the search criteria" => "Cap pàgina ha encaixat en el criteri de cerca",
"Advanced Search Help" => "Ajuda de la cerca avançada",
"All dates" => "Totes les dades",
"Calendar Items" => "Ítems del Calendari",
"This newsletter will be sent to {\$subscribers} email addresses." => "Aquest butlletí serà enviat a {\$subscribers} adreces de correu-e.",
"Recipients" => "Destinataris",
"Validated" => "Validats/des",
"Is user" => "És usuari/a",
"Sending Newsletter" => "Enviament del Butlletí",
"Prepare a newsletter to be sent" => "Prepara un butlletí per ser enviat",
"Apply content template" => "Aplica la plantilla de contingut",
"Clip Now" => "Inclou retalls ara",
"Clip Articles" => "Inclou retalls d'articles",
"Attached Files" => "Arxius adjunts",
"remove" => "eliminar",
"To add a file, click here" => "Per a afegir un arxiu, clica aquí",
"Reply To Email" => "Respon al Correu-e",
"Save as Draft" => "Desa-ho com a esborrany",
"Send objects" => "Envia objectes",
"Transmission results" => "Resultats de la transmissió",
"Send Wiki Pages" => "Envia pàgines del Wiki",
"Send a structure" => "Envia una estructura",
"Send Articles" => "Envia articles",
"Add Article" => "Afegeix article",
"Send objects to this site" => "Envia objectes a aquest lloc",
"Ex: http://tiki.org or localhost" => "Ex: http://tiki.org o localhost",
"Report this page" => "Informa d'aquesta pàgina",
"Page shared" => "Pàgina compartida",
"The link was sent via Twitter" => "S'ha enviat l'enllaç via Twitter",
"The link was posted on your facebook wall" => "S'ha publicat l'enllaç al teu mur de facebook",
"The link was sent as message to" => "S'ha enviat l'enllaç com a missatge a",
"The link was published in a" => "S'ha publicat l'enllaç en un/a",
"Short link" => "Enllaç curt",
"Have a look at this page" => "Fes una ullada a aquesta pàgina",
"Your message" => "El teu missatge",
"e-Mail" => "correu-e",
"Send via e-Mail" => "Envia per correu-e",
"Recipient(s)" => "Destinatari(s)",
"Your name" => "El teu nom",
"Your email" => "El teu correu-e",
"Authorize with twitter first" => "Autoritza primer amb twitter",
"Have a look at " => "Fes una ullada a ",
"Put on my facebook wall" => "Posa en el meu mur de facebook",
"Authorize with facebook first" => "Autoritza primer amb facebook",
"Link text" => "Text de l'enllaç",
"This will be the title for the URL" => "Aquesta serà el títol per a la URL",
"Like this post" => "m'agrada aquesta publicació",
"Post on forum" => "Publica a un fòrum",
"Share access rights" => "Comparteix els permisos d'accés",
"Spreadsheets" => "Fulls de càlcul",
"Available Sheets" => "Fulls disponibles",
"Create a sheet" => "Crea un full",
"There are individual permissions set for this sheet" => "Hi ha permisos individuals fixats per a aquest full",
"Makes this sheet a \"child\" sheet of a multi-sheet set" => "Converteix aquest full en un \"fill\" d'un multi-full de càlcul(llibre de càlcul)",
"Change shoutbox general settings" => "canvia les opcions generals del diàleg",
"auto-link urls" => "auto-enllaç urls",
"Post or edit a message" => "Editar o enviar missatge",
"Location : " => "Lloc : ",
"Content may be out of date" => "Aquest contingut pot estar desfasat",
"An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages:" => "S'ha enviat una petició urgent de traducció. Fins que la pàgina no estigui actualitzada, pots veure una versió corregida a les pàgines següents:",
"Last edited by" => "Editat per darrera vegada per",
"based on work by" => "basat en treball fet per",
"Contributors to this page" => "Contribuïdors a aquesta pàgina",
"Accounts" => "Comptes",
"Save changes" => "Desa els canvis",
"Clean" => "Neteja",
"Most viewed objects" => "Objectes més visualitzats",
"Most viewed objects in the last 7 days" => "Objectes més visualitzats en els darrers 7 dies",
"Site Stats" => "Estadístiques del lloc",
"Total pageviews" => "Visualitzacions de pàgines en total",
"Average pageviews per day" => "Mitjana de visualització de pàgines per dia",
"Wiki Stats" => "Estadístiques del Wiki",
"Size of Wiki Pages" => "Mida de les pàgines del Wiki",
"Average page length" => "Mida mitjana de les pàgines",
"Average versions per page" => "Mitjana de versions per pàgina",
"Visits to wiki pages" => "Visites a pàgines del wiki",
"Average links per page" => "Quantitat mitjana d'enllaços per pàgina",
"Image galleries Stats" => "Estadístiques de galeries d'imatges",
"Average images per gallery" => "Mitjana d'imatges per galeria",
"Total size of images" => "Mida total de les imatges",
"Average image size" => "Mida mitjana d'imatge",
"Visits to image galleries" => "Visites a galeries d'imatges",
"File galleries Stats" => "Estadístiques de galeries d'arxius",
"Average files per gallery" => "Mitjana d'arxius per galeria",
"Total size of files" => "Mida total dels arxius",
"Average file size" => "Mida mitjana d'arxiu",
"Visits to file galleries" => "Visites a les galeries d'arxius",
"CMS Stats" => "Estadístiques del CMS",
"Total reads" => "Quantitat de notes llegides",
"Average reads per article" => "Mitjana de lectures per article",
"Total articles size" => "Mida total dels articles",
"Average article size" => "Mida mitajana d'un article",
"Forum Stats" => "Estadístiques de fòrums",
"Total topics" => "Quantitat de temes",
"Average topics per forums" => "Quantitat mitjana de temes per fòrum",
"Total replies" => "Respostes totals",
"Visits to forums" => "Visites als fòrums",
"Blog Stats" => "Estadístiques de les Bitàcoles web",
"Weblogs" => "Bitàcoles Web",
"Total posts" => "Publicacions totals",
"Average posts per weblog" => "Mitjana enviaments per bitàcola web",
"Total size of blog posts" => "Mida total de les publicacions per bitàcola web",
"Average posts size" => "Mida mitjana d'una publicació",
"Visits to weblogs" => "Visites a les bitàcoles web",
"Poll Stats" => "Estadístiques de consultes",
"Total votes" => "Vots totals",
"Average votes per poll" => "Mitjana de vots per consulta",
"Total questions" => "Preguntes en total",
"Average questions per FAQ" => "Mitjana de preguntes per PUF",
"User Stats" => "Estadístiques d'usuaris",
"Average bookmarks per user" => "Mitjana d'enllaços d'interès per usuari",
"Average questions per quiz" => "Mitjana de preguntes per Test",
"Quizzes taken" => "Qüestionaris presos",
"Average quiz score" => "Puntuació mitjana de tests",
"Average time per quiz" => "Temps mitjà per test",
"Usage chart" => "Gràfica d'ús",
"Usage chart image" => "Emprar imatge de gràfic",
"Daily Usage" => "Ús diari",
"Stats for surveys" => "Estadístiques per enquestes",
"Last taken" => "Darrer pres",
"Clean logs older than" => "Esborra els registres més antics de",
"Time Left" => "Temps Restant",
"Send Answers" => "Envia respostes",
"Thank you for your submission" => "Gràcies pel teu enviament",
"Send a link to a friend" => "Envia un enllaç a un amic/ga",
"Your email was sent" => "El teu correu-e ha estat enviat",
"The link was sent to the following addresses:" => "S'ha enviat l'enllaç a les següents adreces:",
"Config" => "Configuració",
"Failure" => "Fallada",
"Theme is selected as follows" => "Theme se selecciona de la manera següent",
"If a theme is assigned to the individual object that theme is used." => "Si assigneu un theme a un objecte individual, aquest theme sera l'utilitzat.",
"If not then if a theme is assigned to the object's category that theme is used" => "Si no és així, si assigneu un theme a una categoria d'objecte, aquest tema serà l'utilitzat",
"If not then a theme for the section is used" => "Si no és així, s'utilitzarà un theme per a la secció",
"If none of the above was selected the user theme is used" => "Si no trieu cap de les opcions anteriors, s'utilitzarà el theme de l'usuari",
"Finally if the user didn't select a theme the default theme is used" => "Finalment, si l'usuari no ha seleccionat cap theme, s'utilitzarà el theme per defecte",
"Control by Objects" => "Control per objectes",
"Control by Sections" => "Control per Seccions",
"Assign themes to categories" => "Assigna themes a categories",
"Assigned categories" => "Categories assignades",
"Theme Control Center: Objects" => "Centre de control de temes: Objectes",
"Control by Categories" => "Control per Categories",
"Assign themes to objects" => "Assignar aspectes als objectes",
"Assigned objects" => "Objectes Assignats",
"Assign themes to sections" => "Assignar aspectes a les seccions",
"Assigned sections" => "Seccions Assignades",
"Edit File:" => "Edita Fitxer:",
"The following file was successfully uploaded" => "El següent fitxer s'ha pujat correctament",
"You can download this file using" => "Podeu baixar l'arxiu emprant",
"You can link to the file from a Wiki page using" => "Pots incloure l'arxiu en una pàgina Wiki emprant",
"You can display an image in a Wiki page using" => "Pots incloure l'arxiu en una pàgina HTML emprant",
"You locked the file" => "Has bloquejat l'arxiu",
"The file is locked by {\$fileInfo.lockedby}" => "L'arxiu està bloquejat per {\$fileInfo.lockedby}",
"required field for podcasts" => "els podcasts requereixen aquest camp",
"Batch Upload Results" => "Pujada en bloc: Resultats",
"Upload successful!" => "Pujada amb èxit!",
"The following image was successfully uploaded" => "La següent imatge s'ha pujat correctament",
"Image ID thumb" => "Diapositiva de la Imatge ID",
"You can view this image in your browser using" => "Podeu visualitzar aquesta imatge en el vostre cercador emprant",
"You can include the image in an Wiki page using" => "Pots incloure la imatge a una pàgina wiki emprant",
"or use filename" => "o utilitza el nom del fitxer",
"Now enter the image URL" => "Introduïu ara la URL de la imatge",
"or upload a local image from your disk" => "o puja una imatge local des del teu disc",
"Batch Upload" => "Puja al rerafons",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Miniatures (opcional, impedeix que es generin contactes pel sistema)",
"You have to create a gallery first!" => "Has de crear una galeria primer!",
"User assigned modules" => "Mòduls assignats per l'usuari",
"Restore defaults" => "Recupera predeterminats",
"act" => "acte",
"Assign module" => "Assigna mòdul",
"top" => "més actius/ves",
"Folders" => "Carpetes",
"Folder in" => "En la carpeta",
"Remove Folder" => "Elimina carpeta",
"Refresh Cache" => "Refresca memòria cau",
"Admin folders and bookmarks" => "Administració de carpetes i adreces d'interès",
"Manage Fields" => "Gestiona els camps",
"Send me a message" => "Envia'm un missatge",
"Basic Data" => "Dades bàsiques",
"Assign Group" => "Assignar Grup",
"Change user preferences" => "Canvia les preferències de l'usuari",
"User Icon" => "Icona d'usuari",
"Users HomePage" => "Plana inicials dels usuaris",
"Personal Wiki Page" => "Pàgina Wiki Personal",
"Request friendship from this user" => "Demana l'amistat d'aquest usuari",
"Additional Information" => "Informació adicional",
"User Contribution" => "Contribucions d'usuari",
"has contributed to the following content" => "ha contribuït al següent contingut",
"Forum comments" => "Comentaris del Fòrum",
"Who Looks At Stuff?" => "Qui mira les coses?",
"Who Looks At Your Stuff?" => "Qui mira les meves coses?",
"Send Me A Message" => "Envia'm un missatge",
"Send me a message !" => "Envia'm un missatge !",
"The following message will be sent to user" => "El següent missatge serà enviat a l'usuari",
"Message Body" => "Cos del missatge",
"Toggle" => "Commuta",
"Toggle options" => "Opcions de commutació",
"Personal Information" => "Informació Personal",
"Male" => "Home",
"Female" => "Dona",
"Use Google Map locator" => "Empra el localitzador dels mapes de google",
"View extra information" => "Visualitza informació extra",
"Is email public? (uses scrambling to prevent spam)" => "És públic aquest correu-e ? (per a provenir spam)",
"Unavailable - please set your e-mail below" => "No disponible - si us plau, posa el teu correu-e a sota",
"Does your mail reader need a special charset" => "Necessita el teu programa lector de correu-e un conjunt de caracters especial",
"Can you read more languages?" => "Pots llegir més idiomes?",
"Select language..." => "Selecciona l'idioma...",
"Detect user timezone if browser allows, otherwise site default" => "Detecta la zona horària de l'usuari si el navegador ho permet, d'altra forma, per defecte del lloc",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "Mostra requadre d'informació en passar el ratolí per sobre per a cada usuari que permet que la seva informació sigui pública",
"Notify sender when reading his mail" => "Avisa l'autor quan llegiu el seu missatge",
"Auto-archive read messages after x days" => "Auto-arxiva missatges llegits després de x dies",
"never" => "mai",
"My user items" => "Els meus ítems d'usuari",
"My level" => "El meu nivell",
"Account Information" => "Informació del compte",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Deixa els camps \"Contrasenya nova\" i \"Confirma contrasenya nova\" en blanc per mantenir la contrasenya actual",
"Account Deletion" => "Esborrat del compte",
"Delete my account" => "Esborra el meu compte",
"New task" => "Tasca nova",
"Task list" => "Llista de tasques",
"Admin mode off" => "Mode Administrador inactiu",
"Admin mode on" => "Mode Administrador activat",
"Task help" => "Ajuda de tasques",
"Empty Trash" => "Buida paperea",
"Received task" => "Tasca rebuda",
"You received this task, please read and execute it" => "Heu rebut aquesta tasca, si us plau, llegiu-la i executeu-la",
"Send task" => "Envia tasca",
"You send this task to a other user" => "Envies aquesta tasca a un altre usuari/a",
"Shared task" => "Tasca compartida",
"This task is public to a special group" => "Aquesta tasca és pública a un grup especial",
"Accepted by Task User and Creator" => "Acceptada per l'usuari de la tasca i creador",
"Accepted User and Creator" => "Ususari i creador acceptat",
"Task is accepted by user and creator" => "La tasca ha estat acceptada per l'usuari/a i creador/a",
"Not Accepted by One User" => "No acceptada per un/a usuari/a",
"Not Accepted User" => "Usuari no acceptat",
"Task is rejected by one user" => "La tasca ha estat rebutjada per un/a usuari/a",
"Waiting for Me" => "Esperant-me a mi",
"Task is not accepted by you, read the task and accept or reject it" => "La tasca no ha estat acceptada per tu, llegeix-la i accepta-la o rebutja-la",
"Waiting for Other User" => "Esperant a un altre/a usuari/a",
"Task is not accepted/rejected by other user" => "La tasca no ha estat acceptada/rebutjada per un altre usuari",
"Admin Mode" => "Mode administrador",
"Edit Task" => "Edita la tasca",
"NOT accept" => "NO acceptis",
"Remove from Trash" => "Elimina de la paperera",
"Move into Trash" => "Mou a la paperera",
"Task saved" => "Tasca guardada",
"View Task" => "Mostra la tasca",
"Open a new task" => "Obre una nova tasca",
"taskId" => "IdTasca",
"Task user" => "Usuari de la tasca",
"Only the creator can delete this task" => "Només el creador pot esborrar aquesta tasca",
"Use start date and time" => "Empra data i hora d'inici",
"Use end date and time" => "Empra data i hora de finalització",
"Open / In Process" => "Oberta / en procés",
"Waiting / Not Started" => "En espera / no iniciada",
"Percentage completed" => "Percentatge completat",
"Shared for Group" => "Compartida per al group",
"Accepted by User" => "Acceptada per l'usuari/a",
"No / Rejected" => "No / rebutjada",
"Accepted by Creator" => "Acceptada pel creador",
"This message will be send to users if you are makeing changes of assigned tasks" => "Aquest missatge serà enviat als usuaris si fas canvis a tasques assignades",
"Send message with changes" => "Envia missatge amb canvis",
"Modified by" => "Modificada per",
"Marked as deleted" => "Marcat com a eliminat",
"Inform task user by email" => "Informa a l'usuari de la tasca per correu-e",
"You can only view this task" => "Pots veure només aquesta tasca",
"Completed" => "Completada",
"%m/%d/%Y [%H:%M]" => "%d/%m/%Y [%H:%M]",
"No tasks entered" => "No hi ha cap tasca",
"Select One" => "Selecciona un/a",
"Undo Trash" => "Desfés paperera",
"Show:" => "Mostra:",
"Received" => "Rebut/da",
"Submitted" => "Enviat/da",
"Shared" => "Compartit/da",
"All Shared Tasks" => "Totes les tasques compartides",
"Status:" => "Estat:",
"completed (100%)" => "completat/da (100%)",
"Created by:" => "Creat per:",
"Report Preferences" => "Preferències dels informes",
"Use reports to summarise notifications about objects you are watching." => "Empra resums periòdics de notificacions de canvis als objectes que estàs seguint",
"Use reports" => "Empra resums periòdics",
"Interval in which you want to get the reports" => "Interval per al qual vols rebre els resums periòdics",
"Monthly" => "Mensual",
"Short report" => "Informe breu",
"Detailed report" => "Informe detallat",
"HTML-Email" => "Correu-e en HTML",
"Send me an email also if nothing happened" => "Envia'm un correu-e també si no passa res",
"My watches" => "Els meus seguiments",
"Use \"watches\" to monitor wiki pages or other objects." => "Fes servir els \"seguiments\" per vigilar pàgines wiki o altres objectes.",
"Watch new items by clicking the {icon _id=eye} button on specific pages." => "Vigila nous ítems en clicar al botó de l'ull {icon _id=eye} de pàgines específiques.",
"Add Watch" => "Afegeix avís",
"Select event type" => "Selecciona tipus d'esdeveniment",
"All watched events" => "Tots els esdeveniments vigilats",
"A user submits an article" => "Un usuari envia una col·laboració",
"A user edited an article" => "Un usuari edita un article",
"A user deleted an article" => "Un usuari esborra un article",
"A user submits a blog post" => "Un usuari envia una publicació de blog",
"A user posts a forum thread" => "Una persona usuària publica un fil de discussió del fòrum",
"A user posts a forum topic" => "Una persona usuària publica un topic del fòrum",
"A user edited a wiki page" => "Un usuari edita una pàgina wiki",
"A user created a wiki page in a language" => "Un usuari ha creat una pàgina a l'idioma",
"A user edits an article" => "Un usuari edita un article",
"A user deletes an article" => "Un usuari esborra un article",
"May need to refresh twice to see changes" => "Es necessita actualitzar dos cops per tal de veure els canvis",
"Add top level bookmarks to menu" => "Afegeix els millors favorits al menú",
"Add or edit an item" => "Afegeix o edita un ítem",
"New Window" => "Nova finestra",
"replace window" => "reemplaçar la finestra",
"User_versions_for" => "Versions de l'usuari per a",
"Banner stats" => "Pancarta: estadístiques",
"Create new banner" => "Crea un nou banner",
"Banner Information" => "Informació de la Pancarta",
"Click ratio" => "Taxa de clicks",
"Weekdays" => "Dies de la setmana",
"mon" => "dl",
"tue" => "dm",
"wed" => "dc",
"thu" => "dj",
"fri" => "dv",
"sat" => "ds",
"sun" => "dg",
"Banner raw data" => "Dades en brut del bànner",
"Edit Blog" => "Edita bitàcola",
"Monitor this Blog" => "Subscriu-te a aquesta bitàcola",
"Stop Monitoring this Blog" => "Desubscriu-te a aquesta bitàcola",
"Cached" => "Carregat en memòria cau",
"This is a cached version of the page." => "Aquesta és una versió en memòria cau de la pàgina",
"Click here to view the Google cache of the page instead." => "Cliqueu aquí per veure la memòria cau Google de la pàgina.",
"Answers" => "Respostes",
"Add Suggestion" => "Afegeix un suggeriment",
"Forum List" => "Llista de fòrums",
"Edit Forum" => "Editar fòrum",
"Monitor Topics of this Forum" => "Vigila els Tòpics d'aquest Fòrum",
"Stop Monitoring Topics of this Forum" => "Deixa de vigilar els Tòpics d'aquest Fòrum",
"Monitor Topics and Threads of this Forum" => "Vigila Tòpics i respostes d'aquest fòrum",
"Stop Monitoring Topics and Threads of this Forum" => "Deixa de vigilar Tòpics i respostes d'aquest fòrum",
"Post New" => "Publica un nou",
"Summary" => "Resum",
"Watch for replies" => "Vigila per correu-e les respostes",
"Send me an e-mail when someone replies to my topic" => "Envia'm un missatge de correu-e quan algú respongui al meu tòpic",
"Don't send me any e-mails" => "No m'enviïs missatges de correu-e",
"for links" => "per a enllaços",
"HTML tags are not allowed inside posts" => "No són permeses les etiquetes HTML dins les publicacions",
"Moderator Actions" => "Accions del moderador",
"Move Selected Topics" => "Moure temes seleccionats",
"Unlock Selected Topics" => "Desbloqueja tòpics seleccionats",
"Lock Selected Topics" => "Bloqueja temes escollits",
"Delete Selected Topics" => "Esborrar temes seleccionats",
"Merge" => "Escapçar",
"Merge Selected Topics" => "Escapçar els temes escollits",
"Reported Messages:" => "Missatges reportats:",
"Queued Messages:" => "Missatges a la cua:",
"Unarchive" => "Desarxiva",
"No topics yet" => "Encara no hi ha cap tema",
"posts in this forum" => "publicacions en aquest fòrum",
"All posts" => "Tots els escrits",
"Last hour" => "La última hora",
"Last 24 hours" => "Les últimes 24 hores",
"Last 48 hours" => "Les últimes 48 hores",
"Show archived posts" => "Mostra publicacions arxivades",
"announce" => "anunci",
"hot" => "calent",
"Archived" => "Arxivada/des",
"The post has been reported and will be reviewed by a moderator." => "S'ha informat de la publicació i serà revisada per un moderador.",
"prev topic" => "tòpic ant",
"next topic" => "tema següent",
"Print this page only" => "Imprimeix només aquesta pàgina",
"Print all pages" => "Imprimeix totes les pàgines",
"Show posts" => "Mostrar publicacions",
"Jump to forum" => "Saltar al fòrum",
"Tiki Sheet" => "Full Tiki",
"Monitor" => "Vigilància",
"Stop Monitor" => "Deixa de vigilar per correu-e",
"Insert New Item" => "Inserta un nou ítem",
"Edit Fields" => "Edita els camps",
"Tracker Items" => "Punts del formulari",
"atts" => "adjunts",
"List Attachments" => "Llista els Deures",
"View inserted item" => "Mostra el registre insertat",
"Insert new item" => "Inserta un nou ítem",
"View Item" => "Visualitza ítem",
"Filter Tracker Items" => "Filtra registres del formulari",
"Add a Comment" => "Afegeix un comentari",
"Special Operations" => "Operacions especials",
"close" => "tanca",
"Show All" => "Mostrar Tot",
"Clip" => "clip",
"Back To Mailbox" => "torna a bustia de correu",
"Full Headers" => "capçaleres senceres",
"Normal Headers" => "capçaleres normals",
"Reply To All" => "respon a tots",
"Forward" => "reenvia",
"Select from address book" => "selecciona del llibre d'adreces",
"Use HTML mail" => "Empra correu HTML",
"The following addresses are not in your address book" => "La següent adreça no es troba en el teu llibre d'adreces",
"Add Contacts" => "Afegeix contactes",
"Attachment 1" => "Afegit 1",
"Attachment 2" => "Afegit 2",
"Attachment 3" => "Afegit 3",
"Address book" => "Llibre d'adreces",
"This is the staging copy of" => "Aquesta és la pàgina per revisar de",
"the approved version of this page." => "la versió aprovada d'aquesta pàgina.",
"Viewing of changes since last approval is possible only after first approval." => "La visualització dels canvis des de la darrera aprovació només és possible després de la primera aprovació.",
"Latest changes will be synchronized after approval." => "Els darrers canvis es sincronitzaran després de l'aprovació.",
"This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time." => "Aquesta és una nova pàgina per revisar que no ha estat aprovada encara. Edita-la i mou-la a la categoria per pàgines aprovades per aprovar-la la primera vegada.",
"TOC" => "Índex",
"Parent page" => "Pàgina filial",
"Child" => "Filla",
"page id" => "id de pàgina",
"3d browser" => "navegador 3d",
"Following fields are incorrect" => "Els camps següents són incorrectes",
"Remove Image" => "Elimina imatge",
"Other:" => "Altre/a:",
"You have ever subscribed" => "Ja t'havies subscrit abans",
"You have not yet subscribed" => "Encara no t'has subscrit",
"friends" => "amics",
"Human Translations" => "Traduccions per humans",
"Machine Translations" => "Traduccions automàtiques",
"Use this thread to discuss the page:" => "Utilitza aquest fòrum per parlar de la pàgina:",
"list" => "llista",
"Message sent to" => "Missatge enviat a",
"Subscribe to a group" => "Subscriu-te a un grup",
"Any" => "Qualsevol",
"Toggle display" => "Intercanvia com es mostra",
"Close:" => "Tanca:",
"as Creator &amp; Last Editor" => "com Creador &amp; Darrer Editor",
"no (disabled)" => "no (desactivat)",
"Save the page as a partial translation." => "Desa la pàgina com a traducció parcial.",
"Partial Translation" => "Traducció Parcial",
"Save the page as a completed translation." => "Desa la pàgina com a traducció completa.",
"Complete Translation" => "Traducció Completa",
"Save the page, but do not send notifications and do not count it as new content to be translated." => "Desa la pàgina, però no enviïs notificacions <br/>i no ho comptis com a nou contingut<br/> per ser traduït",
"Save Minor Edit" => "Edició Menor",
"Save the page." => "Desa la pàgina.",
"Save the page as a draft." => "Desa la pàgina com a esborrany.",
"Save Draft" => "Desa esborrany",
"Administration" => "Administració",
"Enable/disable Tiki features here, but configure them elsewhere" => "Habilita/deshabilita funcionalitats de Tiki aquí, però configura-les en un altre lloc",
"General preferences and settings" => "Preferències i característiques generals",
"User registration, login and authentication" => "Registre d'usuaris, connexió i autenticació",
"Wiki settings" => "Configuració del Wiki",
"Wiki Attachments" => "Adjunts al Wiki",
"Article/CMS settings" => "Paràmetres per als Articles/CMS",
"Poll comments settings" => "Configuració dels comentaris de vots",
"Configuration options for all blogs on your site" => "Opcions de configuració per a totes les bitàcoles en el teu lloc",
"Forums settings" => "Configuració de fòrums",
"FAQ comments settings" => "Paràmetres dels comentaris de les PUF",
"Trackers settings" => "Paràmetres dels formularis",
"Directory settings" => "Paràmetres del Directori (d'enllaços)",
"Maps configuration" => "Configuració dels Mapes",
"Meta Tags settings" => "Paràmetres de les Meta Etiquetes",
"Search settings" => "Paràmetres de cerca",
"Score settings" => "Paràmetres del sistema de Puntuació",
"Community settings" => "Paràmetres de la Comunitat",
"Calendar settings" => "Paràmetres del Calendari",
"Intertiki settings" => "Paràmetres de l'Intertiki",
"Freetags settings" => "Configuració de les Etiquetes Lliures",
"Customize look and feel of your Tiki" => "Adapta l'aparença del teu Tiki",
"Help on \$admintitle Config" => "Ajuda sobre la configuració de \$admintitle ",
"You can not create a category with a name already existing at this level" => "No es pot crear una categoria amb un nom que ja existeix en aquest nivell",
"The file does not have the required header:" => "L'arxiu no té l'encapçalamet requerit:",
"Category can`t be parent of itself" => "La categoria no pot ser mare de si mateixa",
"Upload failed" => "Ha fallat la pujada",
"All posted" => "Tots els enviaments",
"Queue anonymous posts" => "Encua les publicacions anònimes",
"Queue all posts" => "Encua totes les publicacions",
"No attachments" => "Cap adjunt",
"Everybody can attach" => "Tots poden adjuntar",
"Only users with attach permission" => "Només usuaris/es amb permís per a adjuntar ",
"Moderators and admin can attach" => "Els Moderadors i administradors poden adjuntar",
"Date (desc)" => "Data (desc)",
"Date (asc)" => "Data (asc)",
"Score (desc)" => "Punts (desc)",
"Replies (desc)" => "Respostes (desc)",
"Reads (desc)" => "Lectures (desc)",
"You have to provide a hotword and a URL" => "Has de proveïr una paraula calenta i una URL",
"Owner" => "Propietari",
"moved %d images, %d errors occured." => "mogudes: %d imatges; han ocorregut %d errors.",
"a timeout occured. Hit the reload button to move the rest" => "ha ocorregut una desconnexió. Prem el botó Actualitza per moure la resta",
"Detected, Version:" => "Detectat/da, Versió:",
"Not detected." => "No detectat/da.",
"All Fields except gdaltindex must be filled" => "Tots els camps excepte gdaltindex han de ser omplerts",
"No valid gdaltindex executable" => "No hi ha cap gdaltindex vàlid executable",
"Tag already exists" => "El marcador ja existeix",
"Tag not found" => "No s'ha trobat el marcador",
"Repository name can't be an empty" => "El nom de dipòsit no pot quedar buit",
"Requested action is not supported on repository" => "L'acció demanada no és suportada al dipòsit",
"No repository" => "Cap dipòsit",
"Search is mandatory field" => "Buscar es camp obligatori",
"File not found " => "No s'ha trobat el fitxer ",
"Requested action in not supported on repository" => "L'acció demanada no és suportada al dipòsit",
"Non-existent link" => "Aquest enllaç no existeix",
"Mail-in account %s incorrect" => "Compte %s de Correu-dins incorrecta",
"Mail-in account %s saved" => "Compte %s de Correu-dins desada",
"Frequency should be a positive integer!" => "la Freqüència hauria de ser un integrador positiu",
"Mail-in accounts set to be checked every %s minutes" => "S'ha especificat que es comprovin cada %s minuts els comptes de Correu-dins",
"Automatic Mail-in accounts checking disabled" => "Està desactivada la comprovació de comptes correu-dins automàtica",
"No menu indicated" => "No s'indica cap menú",
"Cannot create or update module: You need to specify a name to the module" => "No es pot crear o actualitzar el mòdul: cal especificar el nom del mòdul",
"Cannot create or update module: You cannot leave the data field empty" => "No es pot crear o actualitzar el mòdul: no es pot deixar buit el camp data",
"No newsletter indicated" => "No s'ha indicat cap butlletí",
"A user registers" => "Un usuari es registra",
"Any wiki page is changed" => "No s'ha modificat cap pàgina wiki",
"Any wiki page is changed, even minor changes" => "Qualsevol pàgina wiki canvia, inclosos els canvis menors",
"PHP error" => "error de PHP",
"You need to provide a username or an email" => "Ha d'indicar un nom d'usuari o un correu-e",
"No poll indicated" => "No s'indica cap consulta",
"unsafe" => "insegur",
"register_globals should be off by default. See the php manual for details." => "el paràmetre register_globals hauria d'estar com a desactivat (off) per defecte. Mira el manual de php per més detalls.",
"safe" => "segur",
"risky" => "arriscat",
"session.use_trans_sid should be off by default. See the php manual for details." => "el paràmetre session.use_trans_sid hauria d'estar com a desactivat (off) per defecte. Mira el manual de php per més detalls.",
"upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "Probablement upload_tmp_dir és al teu directori Tikiwiki. Hi ha el risc que algú pugui carregar un arxiu qualsevol en aquest directori i accedir-hi a través d'un navegador web",
"cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config." => "no es pot comprovar si el upload_tmp_dir és accessible a través d'un navegador web. Per assegurar-te'n has de comprovar la configuració del teu servidor web.",
"setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them" => "especificar la opció xbithack és insegur. Depenent de la gestió d'arxius del teu servidor web i de la configuració del teu tiki, un atacant podria pujar arxius de seqüències de comandes a la galeria d'arxius i executar-los",
"allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off." => "el paràmetre allow_url_fopen podria ser emprat per carregar dades remotes o arxius de seqüències d'instruccions. Si no utilitzes la funcionalitat bitàcola, la pots desactivar.",
"The Path to store files in the filegallery should be outside the tiki root directory" => "El camí per emmagatzemar arxius a la galeria d'arxius ha d'estar fora del directori arrel de tiki",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "El camí per emmagatzemar arxius a la galeria d'imatges ha d'estar fora del directori arrel de tiki",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "La funcionalitat \"Edita Plantilles\" està activada. No permetis emprar aquesta funcionalitat a ningú amb qui no confiïs. Pot ser emprada fàcilment per injectar codi php.",
"Path disclosure" => "Desglossament del camí",
"Path disclosure through error message" => "Desglossament del camí mitjançant un missatge d'error",
"SQL injection" => "Injecció SQL",
"SQL injection by authenticated user" => "Injecció SQL per un usuari autenticat",
"SQL injection by authenticated user with special privileges" => "Injecció SQL per un usuari autenticat amb privilegis especials",
"SQL injection without authentication" => "Injecció SQL sense autenticació",
"PHP command injection" => "Injecció de comanda PHP",
"PHP command injection by authenticated user" => "Injecció de comanda PHP per usuari autenticat",
"PHP command injection by authenticated user with special privileges" => "Injecció de comanda PHP per usuari autenticat amb privilegis especials",
"PHP command injection without authentication" => "Injecció de comanda PHP sense autenticació",
"File upload" => "Arxiu pujat",
"File is not readable. Unable to check." => "L'arxiu no es pot llegir. No es pot comprovar.",
"This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous." => "Aquest no és un arxiu de Tikiwiki. Comproveu si aquest arxiu ha estat pujat i si és perillós.",
"This is a modified File. Cannot check version. Check if it is dangerous." => "Aquest és un arxiu modificat. No es pot comprovar la versió. Comprova si és perillós.",
"This file is from another Tikiwiki version: " => "Aquest arxiu és d'una altra versió de Tikiwiki: ",
"You have to provide a word" => "Cal que poseu una paraula",
"You do not have permission to view this page." => "No tens autorització per veure aquesta pàgina",
"You do not have permission to edit this page." => "No teniu autorització per a editar aquesta pàgina",
"You must specify a page name, it will be created if it doesn't exist." => "Has d'especificar un nom de pàgina, serà creada si no existeix.",
"page not added (Exists)" => "pàgina no afegida (ja existeix)",
"No survey indicated" => "No s'ha indicat cap enquesta",
"No tracker indicated" => "No s'ha indicat cap formulari",
"You don't have permission to use this feature" => "No tens permís per emprar aquesta funcionalitat",
"Group already exists" => "Aquest grup ja existeix",
"User doesn't exist" => "Aquest usuari no existeix",
"Invalid or unknown email" => "Correu-e invàlid o desconegut",
"No records were found. Check the file please!" => "No s'ha trobat cap registre. Revisa el fitxer si us plau!",
"User login or email is required" => "És necessari un nom o correu-e de l'usuari",
"User login is required" => "Es requereix l'entrada de l'usuari/a",
"Email is required" => "Es requereix correu-e",
"User is duplicated" => "Usuari/a duplicat/da",
"Created account %s <%s>" => "S'ha creat el compte %s <%s>",
"Assigned %s in group %s" => "Assignat %s al grup %s",
"The passwords do not match" => "Les contrasenyes no coincideixen",
"User %s already exists" => "L'usuari %s ja existeix",
"User login contains invalid characters" => "El nom d'usuari per connectar-te conté caràcters invàlids",
"New %s created with %s %s." => "Nou/va %s creat/a amb %s %s.",
"Impossible to create new %s with %s %s." => "No ha estat possible de crear cap nou/va %s amb %s %s.",
"%s %s successfully deleted." => "S'ha eliminat %s %s amb èxit.",
"%s %s removed from %s %s." => "S'ha eliminat %s %s de %s %s.",
"Login contains invalid characters" => "El nom per la connexió conté caràcters invàlids",
"%s changed from %s to %s" => "Ha canviat %s de %s a %s",
"Impossible to change %s from %s to %s" => "Impossible canviar %s de %s a %s",
"%s modified successfully." => "S'ha modificat %s amb èxit.",
"password" => "la contrasenya",
"%s modification failed." => "la modificació de %s ha fallat.",
"This function is only for staging pages" => "Aquesta funció és només per pàgines per revisar",
"You do not have permission to approve staging pages" => "Permís denegat: no pots aprovar pàgines pendents de revisió",
"Approved page was last saved after most recent staging edit" => "La pàgina aprovada va ser gravada després de l'edició per revisar més recent",
"rss feed disabled" => "alimentació rss desactivada",
"Unknown group" => "Grup desconegut",
"Group doesn't exist" => "Aquest grup no existeix",
"You have to indicate a group" => "Cal indicar un grup",
"This group is invalid" => "Aquest grup és invàlid",
"The page cannot be found" => "No s'ha pogut trobar la pàgina",
"Image Galleries Admin Panel" => "Panell d'administració de les galeries d'imatges",
"Could not read image %s." => "No es pot llegir la imatge %s.",
"Image %s upload failed." => "La pujada de la imatge %s ha fallat.",
"Image %s uploaded successfully." => "La imatge %s ha pujat correctament.",
"Image %s removed from Batch directory." => "La imatge %s ha estat eliminada del directori de lots.",
"Impossible to remove image %s from Batch directory." => "És impossible eliminar la imatge %s del directori de lots.",
"Incorrect directory chosen for batch upload of images." => "S'ha escollit un directori incorrecte per a la càrrega de lots d'imatges.",
"Please setup that dir on " => "Si us plau, configureu aquest directori a ",
"Please contact the website administrator." => "Si us plau, contacta l'administrador de lloc web.",
"Invalid directory name" => "Nom de directori Invàlid",
"Could not read file %s." => "No s'ha pogut llegir l'arxiu %s.",
"Could not write to file %s." => "No s'ha pogut escriure a l'arxiu %s.",
"File %s upload failed." => "No s'ha pogut pujar l'arxiu %s.",
"Upload was successful" => "Pujada amb èxit",
"It isn't possible to post in any blog. You may need to create a blog first." => "No podeu publicar sense crear primer una bitàcola",
"You do not have permission to edit this post" => "Permís denegat per editar aquesta publicació",
"Top visited blogs" => "Les bitàcoles més visitades",
"Last posts" => "Darrers enviaments",
"Top active blogs" => "Les bitàcoles més actives",
"No blogId specified" => "No s'ha especificat cap bitàcola",
"TOP" => "MÉS ACTIUS/VES",
"Stop watching this category" => "Deixa de seguir aquesta categoria",
"Watch this category" => "Segueix aquesta categoria",
"Nothing tagged yet" => "No hi ha res etiquetat encara",
"You must clear your browser cache." => "Has d'esborrar la memòria cau (cache) del teu navegador.",
"You do not have permission to access this gallery" => "No estàs autoritzat/da a accedir a aquesta galeria",
"No gallery indicated" => "No s'ha indicat cap galeria",
"You do not have permission to remove images from this gallery" => "No tens autorització per suprimir imatges d'aquesta galeria",
"You do not have permission to rebuild thumbnails in this gallery" => "Permís denegat, no podeu refer miniatures en aquesta galeria",
"You do not have permission to rotate images in this gallery" => "Permís denegat, no podeu rotar les imatges d'aquesta galeria",
"No image indicated" => "No s'ha indicat cap imatge",
"picture not found" => "no s'ha trobat la imatge",
"You do not have permission to move images from this gallery" => "No estàs autoritzat/da a moure imatges d'aquesta galeria",
"You do not have permission to view the calendar" => "Permís denegat, no podeu veure el calendari",
"You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>" => "Necessites <a href=\"tiki-admin_calendars.php\">crear un calendari</a>",
"There\\'s no such date as" => "Aquesta data no existeix",
"Calendar event : " => "Esdeveniment del Calendari : ",
"event without name" => "Event sense nom",
"You do not have permission to view this page" => "Permís denegat: no pots veure aquesta pàgina",
"Invalid username or activation code. Maybe this code has already been used." => "Nom d'usuari o codi d'activació invàlids. Potser ja s'ha fet servir aquest codi d'activació.",
"Your email could not be validated; make sure you email is correct" => "No s'ha pogut validar el teu correu-e; assegura't que el teu correu-e és correcte",
"You can not use the same password again" => "No pots emprar la mateixa contrasenya de nou",
"Invalid old password" => "Contrasenya antiga invàlida",
"Top authors" => "Els autors més actius",
"Problem. Try to log in again to receive new confirmation instructions." => "Problema. Prova de connectar-te de nou per rebre noves intruccions de confirmació.",
"You need to change chmod 'whelp' manually to 777" => "Necessites canviar via chmod 'whelp' manualment a 777",
"Must enter a name to add a site. " => "Has d'afegir un nom per afegir un nou lloc. ",
"Must enter a url to add a site. " => "Has d'afegir una url per afegir un nou lloc. ",
"URL already added to the directory. Duplicate site? " => "L'URL ja ha estat afegida al directori. Lloc duplicat? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "No es pot accedir a l'URL (URL errònia or el lloc està fora de línea i no pot ser afegit al directori). ",
"Must select a category. " => "Has de seleccionar una categoria. ",
"Must enter a name to add a site" => "Has d'escriure un nom per a la web a afegir",
"Must enter a url to add a site" => "Has d'escriure una dreça URL per a afegir una web",
"URL already added to the directory. Duplicate site?" => "L'URL ja ha estat afegida al directori. Lloc duplicat?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "No es pot accedir a l'URL (URL errònia or el lloc està fora de línea i no pot ser afegit al directori)",
"Must select a category" => "Has d'escollir una categoria",
"No site indicated" => "No s'ha indicat cap lloc",
"No parent specified" => "No s'ha especificat cap pare",
"Error : The file %s doesn't exist." => "Error: El fitxer %s no existeix.",
"Invalid email:" => "Correu Invàlid:",
"Article not found" => "Article no trobat",
"You do not have permission to edit this article" => "No té permís per editar l'article",
"The language can't be changed as its set of translations has already this language" => "No es pot canviar a aquest idioma per que el conjunt de traduccions ja té aquest idioma",
"Banner not found" => "No s'ha trobat banner",
"You do not have permission to edit this banner" => "No teniu permís per editar aquest banner",
"You do not have permission to edit this blog" => "Permís denegat per editar aquesta bitàcola",
"You do not have permission to write the style sheet" => "No teniu permís per escriure al full d'estil",
"Invalid request to edit an image" => "La petició per editar la imatge no és vàlida",
"You have permission to edit images but not in this gallery" => "No estàs autoritzat per editar imatges en aquesta galeria",
"Failed to edit the image" => "s'ha produït un error en editar la imatge",
"No content id indicated" => "Cap id de contingut especificat",
"No question indicated" => "No s'ha indicat cap pregunta",
"No quiz indicated" => "No has indicat cap test",
"No structure indicated" => "No s'ha indicat cap estructura",
"Invalid structure_id or page_ref_id" => "Estructura Invàlida o referència invàlida",
"You do not have permission to edit submissions" => "Permís denegat per editar col·laboracions",
"You have to create a topic first" => "Has de crear un tòpic primer",
"You do not have permission to do that" => "No teniu permís per fer això",
"You do not have permission to write the template:" => "No teniu permís per escriure la plantilla:",
"You do not have permission to read the template" => "No teniu permís per llegir la plantilla",
"No topic id specified" => "No s'ha especificat cap id de tema",
"Invalid topic id specified" => "Tema Invàlid",
"No object indicated" => "No s'ha indicat cap objecte",
"Page is a staging copy. Translation must begin from the approved copy." => "La pàgina és una còpia per revisar. La traducció ha de començar des de la còpia aprovada.",
"No type indicated" => "No s'ha indicat cap tipus",
"Override lock and carry on with edit" => "Ignora el bloqueig i continua per editar",
"Page is currently being edited" => "La pàgina està essent editada en aquest moment",
"page imported" => "pàgina importada",
"created from import" => "creada des de l'importació",
"This page is being edited by " => "Aquesta pàgina està essent editada per ",
"Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. " => "Si us plau, comprova amb l'usuari abans de d'editar la pàgina,\n\t\t\td'altra forma es guardaran els canvis en dues versions separades a l'historial i\n\t\t\thaureu de fusionar-los manualment després. ",
"Can't import remote HTML page" => "No es pot importar la pàgina HTML remota",
"The SandBox is disabled" => "El LlocdeProves està deshabilitat",
"Cannot edit page because it is locked" => "No es pot editar la pàgina perquè està bloquejada",
"Page already exists. Go back and choose a different name." => "La pàgina ja existeix. Ves enrere i escull un nom diferent.",
"The translation set already contains a page in this language." => "El conjunt de traducció ja conté una pàgina en aquest idioma.",
"No questions group indicated" => "No s'ha indicat cap grup de preguntes",
"You do not have permission to edit this file" => "Permís denegat, no podeu editar aquest fitxer",
"You do not have permission to remove files from this gallery" => "Permís denegat, no podeu eliminar arxius dóaquesta galeria",
"Top visited file galleries" => "Les galeries de fitxers més visitades",
"Most downloaded files" => "Arxius més descarregats",
"Last files" => "Els últims fitxers",
"No galleryId specified" => "No s'ha especificat el galleryId",
"Form error - no import method selected for some reason." => "Error de formulari html - no s'ha seleccionat cap mètode d'importació per alguna raó.",
"Form error - no server-side filename entered for selected import method." => "Error de formulari html - no s'ha introduït cap nom d'arxiu al costat del servidor per al mètode d'importaicó seleccionat.",
"No forum indicated" => "No s'ha indicat cap fòrum",
"Last forum topics" => "Últims temes en fòrums",
"Top topics" => "Temes principals",
"Forum posts" => "Escrits del Fòrum",
"No forumId specified" => "No s'ha especificat el fòrumId",
"Accepted friendship request from %s" => "Petició d'inclusió a la xarxa d'amistat de %s acceptada",
"Refused friendship request from %s" => "Petició d'inclusió a la xarxa d'amistat de %s rebutjada",
"Broke friendship with %s" => "Elimina de la teva xarxa d'amistat a %s",
"I have broken our friendship!" => "He trencat la teva inclusió a la meva xarxa d'amistat en aquesta web!",
"Friendship request sent to %s" => "Petició d'inclusió a la seva xarxa d'amistat enviada a %s",
"You're already friend of %s" => "Ja ets amic/ga de %s",
"I have accepted your friendship request!" => "He acceptat la teva petició d'inclusió a la meva xarxa d'amistat!",
"first uploaded image" => "primera imatge pujada",
"last uploaded image" => "última imatge pujada",
"first image" => "primera imatge",
"last image" => "La última imatge",
"random image" => "imatge aleatòria",
"You do not have permission to create galleries and so you cannot edit them" => "Permís denegat, no podeu crear galeries ni editar-les",
"You do not have permission to edit this gallery" => "Permís denegat, no podeu editar aquesta galeria",
"You do not have permission to remove this gallery" => "Permís denagat, no podeu eliminar aquesta galeria",
"You do not have permission to make the map of this gallery" => "Permís denegat, no pots fer el mapa d'aquesta galeria",
"Top images" => "Les imatges més emprades",
"Last images" => "Les últimes imatges",
"Back to item" => "Torna a l'ítem",
"No valid renderer found. GD or PDFLib required." => "No s'ha trobat un renderitzador vàlid. Es requereix un GD o PDFLib.",
"No sheet specified." => "No s'ha especificat cap full.",
"You must select a renderer." => "Has de seleccionar un renderitzador.",
"Invalid Series for current graphic." => "Sèrie no vàlida per al gràfic actual.",
"overwriting old page" => "Reescriure la pàgina antiga",
"updated from structured text import" => "actualitzat amb la importació de text estructurada",
"page created" => "pàgina creada",
"created from structured text import" => "creat a partir de la importació de text estructurat",
"No name indicated for wiki page" => "No s'ha indicat cap nom per la pàgina wiki",
"There is more than one item in the tracker with this title" => "Hi ha més d'un ítem al tracker (base de dades) amb aquest títol",
"There are no items in the tracker with this title" => "No hi ha cap ítem al tracker amb aquest títol",
"No repository given" => "Cap dipòsit indicat",
"This invitation does not exist or is deprecated" => "Aquesta invitació no existeix o està caducada",
"Congratulations! You are now part of this invitation group(s)" => "Felicitats! Ara ja ets part d'aquest grup(s) convidat(s)",
"You do not have permission to remove articles" => "No té permís per eliminar l'article",
"You do not have permission to remove banners" => "No té autorització per eliminar banners",
"You do not have permission to remove this blog" => "Permís denegat per traslladar aquesta bitàcola",
"Non-existent gallery" => "Aquesta galeria no existeix",
"You have permission to upload files but not to this file gallery" => "Premís denegat, no podeu pujar fitxers a aquesta galeria",
"Could not upload the file" => "No pot pujar l'arxiu",
"Could not find the file requested" => "L'arxiu demanat no es troba",
"Upload was not successful. Duplicate file content" => "La pujada ha fallat. Duplica el contingut de l'arxiu",
"File update was successful" => "L'actualització de l'arxiu ha tingut èxit",
"You do not have permission to upload files so you cannot edit them" => "Permís denegat, no podeu pujar fitxers i per tant no podeu editar-los",
"This gallery does not exist" => "Aquesta galeria no existeix",
"You have to enable cookies to be able to login to this site" => "Has d'habilitar les galetes 'cookies' per que puguis entrar en aquest lloc",
"Unable to contact remote server." => "No es pot contactar amb el servidor remot.",
"XMLRPC Error: " => "Error XMLRPC: ",
"Unable to create login" => "Incapaç de crear el compte (login)",
"More than %d unsuccessful login attempts have been made." => "S'han produït més de %d intents de connexió sense èxit.",
"An email has been sent to you with the instructions to follow." => "Se t'ha enviat un correu-e amb instruccions a seguir.",
"Your default nickname is already in use. A new one has to be selected." => "El teu nom d'usuari per defecte ja està en ús. Has d'escollir-ne un altre.",
"The selected account is not associated with your identity." => "El compte seleccionat no està associat amb la teva identitat.",
"unknown action" => "acció no coneguda",
"Authentication method is not OpenID" => "El mètode d'autenticació no és OpenID",
"Account disabled" => "Compte desactivat",
"You must use the right case for your user name" => "Has d'emprar exactament les majúscules i minúscules del teu nom d'usuari",
"Tiki mail-in auto-reply" => "Autoresposta de correu-dins del Tiki",
"Sorry, you can't use this feature." => "Disculpa, no pots fer servir aquesta funcionalitat.",
"edit" => "editar",
"Maps feature is not correctly setup : Maps path is missing." => "L'opció de mapes no està correctament configurada: la ruta dels Mapes falta.",
"mapfile name incorrect" => "Nom de mapfile incorrecte",
"This mapfile already exists" => "Aquest fitxer de mapa ja existeix",
"You do not have permission to write to the mapfile" => "No tens permisos per escriure en el fitxer de mapes",
"You do not have permission to delete the mapfile" => "No tens permisos per esborrar el fitxer de mapes",
"I could not make a copy" => "No es pot fer una copia",
"You do not have permission to read the mapfile" => "No tens permisos per llegir el fitxer de mapes",
"map edit" => "Editar  arxiu .map",
"You dont have permission to do that" => "No tens permís per fer això",
"Tiki RSS feed for maps" => "Alimentació RSS del Tiki per als mapes",
"List of maps available." => "Llista de mapes existents.",
"File not found" => "No s'ha trobat el fitxer",
"The Directory is not empty" => "El directori no està buit",
"Invalid file name" => "Nom d'arxiu Invàlid",
"Invalid files to index" => "Invàlids arxius a indexar",
"I do not know where is gdaltindex. Set correctly the Map feature" => "No sé on està el gdaltindex. Configura correctament el Mapa",
"I could not create the index file" => "No puc crear el fitxer d'index",
"Welcome at Hawiki" => "Benvingut/da a Hawiki",
"You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site:" => "Pots navegar pel lloc en el teu aparell mòbil a través de dirigir el navegador del teu aparell a la següent URL d'aquest lloc:",
"About" => "Sobre",
"You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "Has d'executar setup.sh :<br />./setup.sh \$APACHEUSER all<br />Usuaris freqüents de l'Apache són www-data, apache o nobody",
"Your PHP installation does not have zlib enabled." => "La teva instal·lació PHP no té zlib activat.",
"You must log in to use this feature" => "Heu d'estar connecta't per emprar aquesta característica",
"You do not have permission to view other users data" => "No tens permís per veure les dades de les altres persones usuàries",
"You must be logged in to subscribe to newsletters" => "Has d'estar connectat per subscriure't a un butlletí",
"No note indicated" => "No s'ha indicat cap nota",
"merged note:" => "nota escapçada:",
"File is too big" => "El fitxer es massa gran",
"No item indicated" => "No s'ha indicat cap ítem",
"created from notepad" => "creada des del bloc de notes",
"Page already exists" => "la pàgina ja existeix",
"Not enough information to display this page" => "No hi ha suficient informació per mostrar aquesta pàgina",
"No article indicated" => "No s'indica un article",
"Article is not published yet" => "L'article no ha estat publicat",
"No post indicated" => "No s'ha indicat cap publicació",
"Blog not found" => "No es troba la bitàcola",
"Index" => "Índex",
"Index (' . \$code . " => "Índex (' . \$code . ",
"No pages indicated" => "No s'han indicat les pàgines",
"Pageviews" => "Visualitzacions de pàgines",
"No result indicated" => "No hi ha cap resultat indicat",
"This is not a valid mail adress" => "Aquesta no és un adressa de correu electrònic vàlida",
"Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Si us plau, introdueix un/a %s vàlid/a. Sense espais, més de %d caràcters i que contingui %s",
"Invalid or unknown username" => "El nom de l'usuari es invàlid o desconegut",
"Unable to send mail. User has not configured email" => "No es pot enviar el mail. L'usuari no té el correu electrònic configurat",
"Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password." => "Si us plau, contacta a l'Administrador si no reps el correu-e, o si hi ha algun problema en canviar-te la contrasenya.",
"The mail can't be sent. Contact the administrator" => "El missatge no es pot enviar. Contacta l'administrador",
"A password reminder email has been sent " => "Un correu-e recordatori de contrasenya ha estat enviat ",
"An email with a link to reset your password has been sent " => "S'ha enviat el correu-e amb l'enllaç per canviar la teva contrasenya ",
"to the email" => "al correu-e",
"to the registered email address for" => "a l'adreça de correu-e registrada per a",
"last version" => "última versió",
"You cannot rename staging pages. Please rename the approved page instead." => "No pots reanomenar pàgines per revisar. En el seu lloc, reanomena la pàgina aprovada, si us plau.",
"Cannot rename page because the new name begins with reserved prefix" => "No es pot reanomenar la pàgina perquè el nom nou comença amb un prefix reservat",
"Cannot rename page because maybe new staging page name already exists" => "No pots reanomenar la pàgina per que potser ja existeix aquest nou nom de pàgina per revisar",
"Non-existent version" => "Aquesta versió no existeix",
"Error Message" => "Missatge d'error",
"Tiki RSS Feed Error Message: \$errmsg" => "Missatge d'error de l'alimentador RSS de Tiki: \$errmsg",
"No newsletters available." => "No hi ha cap butlletí disponible.",
"successfully sent" => "enviat amb èxit",
"not sent" => "no enviat",
"Notice: invalid variable value:" => "Avís: valor de variable no vàlid:",
"Report to the webmaster" => "Informa al mestre Web",
"You do not have permission to edit messages \$owner" => "No tens permís per editar missatges \$owner",
"Page must be defined inside a structure to use this feature" => "La Pàgina ha d'estar definida dins una estructura per a fer servir aquesta prestació",
"Clean the sql logs" => "Esborra els log de sql",
"You cannot take this quiz twice" => "No pots accedir a aquest test dues vegades",
"Quiz time limit exceeded quiz cannot be computed" => "S'ha excedit el temps límit del qüestionari i no pot ser completat",
"You cannot take this survey twice" => "No pots fer aquesta enquesta dues vegades",
"Please create a category first" => "Si us plau, primer creeu una categoria",
"Tracker item:" => "Registre del formulari:",
"No trackerId specified" => "No s'ha especificat cap trackerId",
"No permission to upload zipped file packages" => "No hi ha permisos per baixar-se paquets de fitxers enzipats",
"Error processing zipped image package" => "Error al processar la imatge comprimida amb zip",
"No permission to upload zipped image packages" => "No hi ha permisos per pujar paquets d'imatges enzipades",
"The uploaded file ist not recognized as a image" => "El fitxer pujat no és reconegut com a imatge",
"You do not have permission to upload images" => "No tens autorització per pujar imatges",
"You have permission to upload images but not to this gallery" => "Tens autorització per penjar imatges, malgrat no en aquesta categoria",
"Cannot get image from URL" => "No s'ha pogut aconseguir la imatge des de la URL",
"That is not an image (or you have php < 4.0.5)" => "Això no es una imatge (o be te php < 4.0.5)",
"Usage" => "Ús",
"No url indicated" => "No s'ha indicat cap url",
"Unknown user" => "Usuari desconegut",
"Password has been changed" => "S'ha canviat la contrasenya",
"Invalid password. Your current password is required to change administrative information" => "Contrassenya incorrecta. La teva contrassenya actual és necessària per canviar la informació administrativa",
"Email is set to %s" => "El correu-e ha estat canviar a %s",
"The passwords did not match" => "Les contrasenyes no coincideixen",
"was moved into trash" => "va ser mogut/da a la paperera",
"trashed by" => "llençat a la paperera per",
"open / in process" => "oberta / en procés",
"Public for group" => "Pública per al grup",
"Rights by creator" => "Drets per creador",
"END" => "FI",
"Percentage" => "Percentatge",
"Task accepted by creator" => "Tasca acceptada pel creador",
"Task accepted by task user" => "Tasca acceptada per l'usuari de la tasca",
"Task NOT accepted by creator" => "Tasca NO acceptada pel creador",
"Task NOT accepted by task user" => "Tasca NO acceptada per l'usuari de la tasca",
"Sorry this task does not exist or you have no rights to view this task" => "Disculpeu, aquesta tasca no existeix o no teniu permís per veure-la",
"Task entries:" => "Entrades de tasques:",
"Changes:" => "Canvis:",
"Info message" => "Missatge d'info",
"NEW Task" => "Tasca NOVA",
"Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks!" => "Disculpeu, no tens autorització per enviar tasques a altres usuaris o l'usuari no té autorització per rebre'n!",
"Changes on Task" => "Canvis a la tasca",
"You received a new task" => "Heu rebut una tasca nova",
"The priority is" => "La prioritat és",
"very low" => "molt baixa",
"high" => "alta",
"very high" => "molt alta",
"You've to start your work at least on" => "Heu de començar la vostra feina com a mínim el",
"You've to finish your work on" => "Heu de finalizar la vostra feina el",
"Login and click the link below" => "Connecta't i punxa en l'enllaç de sota",
"Please read the task and work on it!" => "Si us plau, llegiu la tasca i treballeu-hi!",
"Sorry, there was an error while trying to write data into the database" => "Disculpeu, hi ha hagut un error mentre s'intentava escriure informació a la base de dades",
"A new page is created in a language" => "S'està creant una pàgina nova en un llenguatge",
"Language watch" => "Vigila l'idioma",
"Cannot upload this file not enough quota" => "No es pot pujar aquest arxiu , no hi ha espai suficient",
"No user indicated" => "No s'ha indicat usuari",
"Non-existent user" => "Aquest usuari no existeix",
"No banner indicated" => "No s'ha indicat cap banner",
"No blog indicated" => "No s'indica cap bitàcola",
"No cache information available" => "No hi ha informació disponible a la memòria cau",
"No faq indicated" => "no s'ha indicat cap PUF",
"You are not permitted to remove someone else\\'s post!" => "No tens permís per eliminar la publicació d'algú altre!",
"Incorrect thread" => "Fil de discussió incorrecte",
"No thread indicated" => "No s'ha indicat cap tema",
"That tracker don't use extras." => "Aquell formulari no empra extres.",
"Tiki WebDAV access" => "Accés a Tiki a través de WebDAV",
"Aborted" => "Abortat/da",
"Top pages" => "Les pàgines més actives",
"Last pages" => "Les últimes pàgines",
"Tidy Extension not present" => "No s'ha trobat una extensió tidy",
"The TikiTests Replay File is Empty" => "L'arxiu per tornar a fer el TikiTest està buit",
"The TikiTests Replay File has an error" => "L'arxiu per tornar a fer el TikiTest conté un error",
"Error deleting the file" => "Error al esborrar l'arxiu",
"TikiTest List" => "Llista de TikiTest",
"TikiTest Record" => "Registre del TikiTest",
"You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "Cal una extensió pecl HTTP o Curl per tornar a fer el TikiTest",
"The TikiTest Replay File is Empty" => "L'arxiu per tornar a fer el TikiTest està buit",
"TikiTest Replay" => "Tornar a fer el TikiTest",
"The page is empty" => "La pàgina està buida",
"You do not have permissions to view the maps" => "No tens permís per veure els mapes",
"###end###"=>"###end###");
