<?php // -*- coding:utf-8 -*-
// (c) Copyright 2002-2010 by authors of the Tiki Wiki/CMS/Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.
// $Id: get_strings.php 43650 2012-10-24 16:09:26Z changi67 $
// Parameters:

// lang=xx    : only translates language 'xx',
//              if not given all languages are translated

// comments   : generate all comments (equal to close&module)

// close      : look for similar strings that are already translated and
//              generate a comment if a 'match' is made

// module     : generate comments that describe in which .php and/or .tpl
//              module(s) a certain string was found (useful for checking
//              translations in context)

// patch      : looks for the file 'language.patch' in the same directory
//              as the corresponding language.php and overrides any strings
//              in language.php - good if a user does not agree with
//              some translations or if only changes are sent to the maintainer

// spelling   : generates a file 'spellcheck_me.txt' that contains the
//              words used in the translation. It is then easy to check this
//              file for spelling errors (corrections must be done in
//              'language.php, however)

// groupwrite : Sets the generated files permissions to allow the generated
//              language.php also be group writable. This is good for
//              translators if they do not have root access to tiki but
//              are in the same group as the webserver. Please remember
//              to have write access removed when translation is finished
//              for security reasons. (Run script again without this
//              parameter)

// Examples:
// http://www.neonchart.com/get_strings.php?lang=sv
// Will translate language 'sv' and (almost) avoiding comment generation

// http://www.neonchart.com/get_strings.php?lang=sv&comments
// Will translate language 'sv' and generate all possible comments.
// This is the most usefull mode when working on a translation.

// http://www.neonchart.com/get_strings.php?lang=sv&nohelp&nosections
// These options will only provide the minimal amout of comments.
// Usefull mode when preparing a translation for distribution.

// http://www.neonchart.com/get_strings.php?nohelp&nosections
// Prepare all languages for release


// ### Note for translators about translation of text ending with punctuation
// ###
// ### The current list of concerned punctuation can be found in 'lib/init/tra.php'
// ### On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// ### For clarity, we explain here only for colons: ':' but it is the same for the rest
// ###
// ### Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// ###
// ### Technical justification:
// ### If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// ### then Tiki tries to translate 'Login' and ':' separately.
// ### This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// ### and it still allows to translate ":" as "&nbsp;:" for languages that
// ### need it (like french)

$lang=Array(
// ### Start of unused words
// ### Please remove manually!
// ### N.B. Legitimate strings may be marked// ### as unused!
// ### Please see http://tiki.org/UnusedWords for further info
"Tip: hold down CTRL to select multiple categories" => "Tipp: Strg halten um mehrere Kategorien auszuwählen",
"Tip: uncheck the above checkbox to uncategorize this page/object" => "Tipp: Die Checkbox oben deaktivieren um die Kategorien dieser Seite/dieses Objekts zu entfernen",
"from\r\nthe mapfile:" => "aus\r\nder Kartendatei:",
"reply to" => "Antwort an",
"WARNING : Old and New trackers cannot coexist. Trackers created with new library\r\nwill not work with old library and conversely" => "WARNUNG: Alte und Neue Tracker können nicht parallel existieren. Tracker die mit der neuen Bibliothek erstellt wurden funktionieren nicht mit der alten Bibliothek und andersherum.",
"Field is public? (for use thru trackerlist plugin)" => "Feld öffentlich? (für Nutzung über das TrackerList-PlugIn)",
"use ...page... to separate pages" => "Benutze ...page... um Seiten in mehrere zu untergliedern",
"cms" => "Artikel",
"Your message has been queued for approval, the message will be posted after\r\na moderator approves it." => "Deine Nachricht wurde zur Freigabe überreicht. Sie wird angezeigt, sobald sie ein Moderator freigegeben hat.",
"comm" => "Schnittstellen",
"community" => "Gemeinschaft",
"content templates" => "Inhaltsvorlagen",
"drawings" => "Zeichnungen",
"html pages" => "HTML-Seiten",
"image galleries" => "Bildergalerien",
"maps" => "Karten",
"messu" => "Nachrichten",
"newsletters" => "Rundbriefe",
"shoutbox" => "Shoutbox",
"tiki" => "Tiki",
"support" => "Onlinesupport",
"surveys" => "Umfragen",
"workflow" => "Workflow",
"webmail" => "Webmail",
"Removed version" => "Version gelöscht",
"Renamed" => "Umbenannt",
"Updated" => "Aktualisiert",
"Posted" => "Eingestellt",
"Downloaded" => "Heruntergeladen",
"Admin Mods" => "Mods verwalten",
"File %s uploaded successfully." => "Datei %s erfolgreich hochgeladen.",
"usernames separated with ;" => "Benutzernamen, getrennt mit Semikolon (;)",
"uploaded by" => "hochgeladen von",
"not specified" => "nicht definiert",
"The file you are trying to upload is too big." => "Die Datei, die Du hochladen möchtest, ist zu groß.",
"Invalid remote file on url %s" => "Ungütige Datei unter %s",
"%A %d of %B, %Y[%H:%M:%S %Z]" => "%A, %d. %B %Y[%H:%M:%S %Z]",
"%a %d of %b, %Y" => "%a, %d. %b %Y",
"%a %d of %b, %Y[%H:%M %Z]" => "%a. %d. %b %Y[%H:%M %Z]",
"delete" => "löschen",
"post" => "Eintrag",
"stop monitoring this blog" => "diesen Blog nicht mehr beobachten",
"posts" => "Einträge",
"visits" => "Besuche",
"show categories" => "Kategorien zeigen",
"author" => "Autor",
"user level" => "Benutzerlevel",
"send email to user" => "Email an Benutzer schicken",
"score" => "Bewertung",
"delete selected" => "markierte löschen",
"move" => "verschieben",
"Posted messages" => "gepostete Beiträge",
"set" => "Ok",
"replies" => "Antworten",
"new reply" => "neue Antwort",
"cancel" => "abbrechen",
"up" => "rauf",
"down" => "runter",
"add" => "hinzufügen",
"stop monitoring this map" => "diese Karte nicht mehr beobachten",
"create" => "hinzufügen",
"save" => "speichern",
"send" => "verschicken",
"Hide module contents" => "Modul auf-/zuklappen",
"Last visitors" => "Letzte Besucher",
"register" => "Registrieren",
"standard" => "Standard",
"secure" => "sicher",
"stay in ssl mode" => "In SSL-Modus bleiben",
"go" => "los",
"cache" => "Cache",
"use" => "benutzen",
"cached" => "gecached",
"refresh" => "aktualisieren",
"print" => "drucken",
"create pdf" => "PDF erstellen",
"monitor this page" => "diese Seite beobachten",
"stop monitoring this page" => "diese Seite nicht mehr beobachten",
"backlinks" => "Verweise",
"rename" => "umbenennen",
"unlock" => "entsperren",
"lock" => "sperren",
"perms" => "Berecht.",
"history" => "Historie",
"similar" => "ähnlich",
"undo" => "rückgängig",
"slides" => "Dias",
"export" => "exportieren",
"discuss" => "diskutieren",
"add comment" => "kommentieren",
"attach file" => "Datei anhängen",
"translation" => "Übersetzung",
"last modification" => "letzte Änderung",
"attachments" => "Anhänge",
"stats" => "Statistiken",
"last changes" => "zuletzt geändert",
"list pages" => "Seiten auflisten",
"back to homepage" => "Zurück zur Startseite",
"cancel edit" => "Bearbeitung verwerfen",
"No attachments for this page" => "Keine Anhänge für diese Seite",
"view blog" => "Blog betrachten",
"list blogs" => "Blogs auflisten",
"save and exit" => "Speichern und verlassen",
"reads" => "Zugriffe",
"view comments" => "Kommentare ansehen",
"Click here to create it" => "Zum Anlegen hier klicken",
"wiki help" => "Wikihilfe",
"General preferences" => "Allgemeine Einstellungen",
"Other preferences" => "Sonstige Einstellungen",
"flag" => "Kennzeichen",
"Change information" => "Einstellungen übernehmen",
"Best language" => "Beste Sprache",
"PodCast directory (must be web accessable):" => "PodCast Verzeichnis (muß per Browser erreichbar sein):",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload filed in that dir, either by scp, ftp, or other protocols" => "Wenn 'Batch-Upload aus Verzeichnis' aktiviert wird muß ein vom Webserver lesbares Verzeichnis benutzt werden (am besten außerhalb des Webspace). Dorthin müssen die Dateien dann mit scp, ftp o.ä. übertragen werden.",
"Enable cache images to all galleries" => "Bildercache für alle Galerien aktivieren",
"Images cache directory" => "Bildercache-Verzeichnis",
"images" => "Bilder",
"Report PHP errors only for admin" => "Alle PHP Fehler nur für Admin ausgeben",
"Server name (for absolute URIs)" => "Servername (für absolute URIs)",
"Automatic (uses HTTPS variable)" => "Automatisch (benutzt HTTPS Variable)",
"Wiki_Tiki_Title" => "Wiki_Tiki_Titel",
"path" => "Pfad",
"Admin->Features" => "Verwalten->Funktionen",
"must be turned on and notification is sent to the admin's" => "muß aktiviert sein, Nachrichten an Admin geht an seine",
"inter-user message inbox" => "Tiki Mailbox",
"Validate email address (may not work)" => "Emailadresse überprüfen (funktioniert evtl. nicht)",
"Require HTTP Basic authentication" => "HTTP-Basic-Authentifizierung notwendig",
"HTTP server name" => "HTTP-Servername",
"HTTP URL prefix" => "HTTP-URL-Präfix",
"HTTPS server name" => "HTTPS-Servername",
"HTTPS URL prefix" => "HTTPS-URL-Präfix",
"Only for users" => "Nur für Benutzer",
"Users and admins" => "Benutzer und Admins",
"Full Text Search" => "Volltextsuche",
"Database independant search or Tiki search" => "Unabhängige Datenbanksuche oder Tiki Suche",
"Don't forget: to use feature you will need to enable it on" => "Hinweis: Um diese Funktion zu nutzen, aktiviere sie unter",
"Site breadcrumbs" => "Site Breadcrumbs",
"Site search bar" => "Balken für Site Suche",
"Site logo" => "Site-Logo",
"Site logo source" => "Site Logo Quelle",
"Site ads and banners" => "Site Werbung und Banner",
"Site Menu" => "Site Menü",
"Note: This feature also requires phplayers to be turned on in Admin->Features" => "Hinweis: Um dieses Feature verwenden zu können, müssen PHPLayer unter Admin->Funkionen",
"Manage attachment preferences" => "Einstellungen für Anhänge verwalten",
"HTML in Wiki Pages" => "HTML in Wiki Seiten",
"Wiki syntax used when a page contains HTML" => "Wiki Syntax benutzen wenn Seite HTML enthält",
"full" => "voll",
"partial" => "teilweise",
"Enable Feature" => "Funktion einschalten",
"loc" => "Ort",
"participants" => "Teilnehmer",
"cat" => "Kateg.",
"lang" => "Sprache",
"prio" => "Prio",
"subscription" => "Abonnement",
"permissions" => "Berechtigungen",
"admin categories" => "Kategorien verwalten",
"create new" => "erstelle neu",
"edit chart" => "Hitliste bearbeiten",
"update" => "aktualisieren",
"admin content templates" => "Inhaltsvorlagen verwalten",
"use in cms" => "Im CMS benutzen",
"use in wiki" => "In Wikis benutzen",
"use in newsletters" => "In Rundbrief benutzen",
"use in HTML pages" => "In HTML-Seiten benutzen",
"last modif" => "letzte Änderung",
"sections" => "Bereiche",
"admin FortuneCookie" => "Sprüche verwalten",
"upload" => "Hochladen",
"dsn" => "DSN",
"Edit existing forums" => "Vorhandene Foren bearbeiten",
"topics" => "Themen",
"coms" => "Kommentare",
"age" => "Alter",
"ppd" => "PPT",
"last post" => "Neuester Eintrag",
"admin hotwords" => "Hotwords verwalten",
"list repositories" => "Repositories auflisten",
"new repository" => "Neues Repository",
"view repository" => "Repository anschauen",
"view this repository" => "Repository ansehen",
"new rule" => "neue Regeln",
"admin featured links" => "Linktips verwalten",
"position" => "Position",
"admin Webmail" => "Webmail verwalten",
"section" => "Bereich",
"sorted section" => "Sortierter Bereich",
"options" => "Optionen",
"admin modules" => "Module verwalten",
"assign module" => "Modul zuweisen",
"left modules" => "Module links",
"right modules" => "Module rechts",
"edit/create" => "hinzufügen/bearbeiten",
"clear cache" => "Cache leeren",
"assign" => "zuweisen",
"left" => "links",
"right" => "rechts",
"order" => "Reihenfolge",
"parameters" => "Parameter",
"create/edit" => "hinzufügen/bearbeiten",
"use poll" => "Abstimmung benutzen",
"use gallery" => "Galerie benutzen",
"use dynamic  content" => "Dynamischen Inhaltsblock benutzen",
"use rss module" => "RSS-Modul benutzen",
"use menu" => "Menü benutzen",
"use phplayermenu" => "PHP Layermenü benutzen",
"use banner zone" => "Bannerzone benutzen",
"list newsletters" => "Rundbriefe auflisten",
"admin newsletters" => "Rundbriefe verwalten",
"send newsletters" => "Rundbrief versenden",
"editions" => "Ausgaben",
"last sent" => "zuletzt gesendet",
"send newsletter" => "Rundbrief versenden",
"admin Email Notifications" => "Emailbenachrichtigungen verwalten",
"use admin email" => "Admin Email benutzen",
"event" => "Termin",
"admin polls" => "Abstimmungen verwalten",
"admin QuickTags" => "QuickTags verwalten",
"label" => "Beschriftung",
"admin RSS Modules" => "RSS-Module verwalten",
"admin shoutbox words" => "Shoutbox Words verwalten",
"export pages" => "Seiten exportieren",
"dump tree" => "Baum ausgeben",
"create webhelp" => "Web-Hilfe erstellen",
"tree" => "Baum",
"create new structure" => "neue Struktur anlegen",
"survey stats" => "Umfragenstatistik",
"edit this survey" => "Diese Umfrage bearbeiten",
"admin surveys" => "Umfragen verwalten",
"list surveys" => "Umfragen auflisten",
"questions" => "Fragen",
"files" => "Dateien",
"advanced feature" => "Fortgeschrittene Funktion",
"Edit fields for tracker" => "Felder bearbeiten von Tracker",
"The tracker needs a text field named Subject" => "Der Tracker muß ein Eingabefeld 'Subject' besitzen (auch für RSS Feed nötig)",
"admin groups" => "Gruppen verwalten",
"assign permissions" => "Berechtigungen vergeben",
"admin users" => "Benutzer verwalten",
"more criteria" => "Erweiterte Suchoptionen",
"assign to groups" => "zu Gruppen hinzufügen",
"Assign user" => "Benutzer zuweisen",
"Available groups" => "Verfügbare Gruppen",
"assign perms to this group" => "dieser Gruppe Rechte zuweisen",
"admin backups" => "Backups verwalten",
"List of available backups" => "Liste der verfügbaren Backups",
"Restoring a backup" => "Einen Backup wiederherstellen",
"Warning!" => "Warnung!",
"Restoring a backup destoys all the data in your Tiki database. All your tables will be replaced with the information in the backup." => "Das Wiederherstellen eines Backups zertört alle bisherigen Daten in Deiner Tiki Datenbank. Die Information in allen Tabellen wird durch das Backup ersetzt.",
"Click here to confirm restoring" => "Hier klicken, um den Start der Wiederherstellung zu bestätigen",
"Create new backup" => "Neues Backup anlegen",
"Creating backups may take a long time. If the process is not completed you will see a blank screen. If so you need to increment the maximum script execution time from your php.ini file" => "Das Erstellen von Backups kann lange Zeit dauern. Falls der Prozess nicht abgeschlossen werden kann, wirst Du einen blanken Bildschirm sehen. Falls dies der Fall ist, musst Du den Parameter 'maximum script execution time' in Deiner php.ini Datei erhöhen",
"If any of your forums have attachments stored in the directory you will need to backup these using FTP or SCP." => "Sollten Anhänge aus dem Forum im Verzeichnis gespeichert sein, müssen diese per FTP oder SCP gesichert werden.",
"Upload a backup" => "Ein Backup hochladen",
"Upload backup" => "Backup hochladen",
"remove file extension from image name" => "Dateiendung im Namensfeld entfernen",
"convert sub directories to sub galleries" => "Unterverzeichnisse in Untergalerien konvertieren",
"eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named screenshots will be created" => "z.B. wird bei \"misc/screenshots/digicam0001.jpg\" das Bild in die Galerie screenshots gesteckt",
"use sub directory names as description" => "Namen von Unterverzeichnissen als Beschreibung verwenden",
"eg. from \"misc/screenshots/digicam0001.jpg\" a description misc/screenshots will be created" => "z.B. wird von \"misc/screenshots/digicam0001.jpg\" der Text misc/screenshots als Beschreibung benutzt",
"admin category" => "Kategorien verwalten",
"list galleries" => "Galerien auflisten",
"edit gallery" => "Galerie bearbeiten",
"rebuild thumbnails" => "Thumbnails neu erzeugen",
"upload image" => "Bild hochladen",
"list gallery" => "Galerie als Liste zeigen",
"hit" => "Treffer",
"original size" => "Originalgröße",
"return to gallery" => "zurück zur Galerie",
"edit image" => "Bild bearbeiten",
"smaller" => "kleiner",
"bigger" => "größer",
"prev image" => "vorh. Bild",
"popup window" => "Popup-Fenster",
"next image" => "näch. Bild",
"slideshow forward" => "Diaschau vorwärts",
"stop" => "Anhalten",
"imagescale" => "Bildskalierung",
"add item" => "Eintrag hinzufügen",
"Subscription List" => "Empfängerliste",
"or create a new category" => "oder neue Kategorie anlegen",
"or create a new location" => "oder neuen Ort eintragen",
"comma separated usernames" => "Benutzernamen durch Komma getrennt",
"comma separated username:role" => "Komma getrennte Liste 'Teilnehmer:Rolle'",
"with roles" => "mit den Rollen",
"Chair" => "Leiter",
"save_to" => "in",
"permission" => "Berechtigung",
"remove from this category &amp; all its children" => "von dieser und allen Unterkategorien entfernen",
"remove from this category only" => "nur von dieser Kategorie entfernen",
"remove page" => "Seite entf.",
"browse" => "im Verzeichnis stöbern",
"related" => "verwandt",
"validate" => "überprüfen",
"add a site" => "Link hinzufügen",
"add a category" => "Kategorie hinzufügen",
"search" => "Suche",
"list articles" => "Beiträge auflisten",
"view articles" => "Beiträge ansehen",
"create zone" => "Zone hinzufügen",
"save the banner" => "das Banner speichern",
"Allow trackback pings" => "Trackback-Pings erlauben",
"try" => "ausprobieren",
"display" => "anzeigen",
"admin quicktags" => "Quicktags verwalten",
"create new block" => "Neuen Block erzeugen",
"list quizzes" => "Quiz auflisten",
"quiz stats" => "Quizstatistik",
"edit this quiz" => "Dieses Quiz bearbeiten",
"admin quizzes" => "Quiz verwalten",
"results" => "Ergebnisse",
"create page" => "Seite erstellen",
"list submissions" => "Einreichungen auflisten",
"save only in the theme:" => "Nur für diesen Style speichern:",
"add to the set" => "zur Liste hinzufügen",
"Search " => "Suche",
"replace" => "ersetzen",
"Admin ephemerides" => "Terminkalender verwalten",
"All ephemerides" => "Alle Termine",
"new question" => "Neue Frage",
"approve" => "akzeptieren",
"configure listing" => "Liste konfigurieren",
"create new file gallery" => "neues Dateiarchiv anlegen",
"topic" => "Thema",
"save and approve" => "speichern und freigeben",
"new topic" => "neues Thema",
"accept" => "akzeptieren",
"refuse" => "ablehnen",
"add new" => "Neu hinzufügen",
"add role" => "Rolle hinzufügen",
"admin processes" => "Prozesse verwalten",
"admin activities" => "Aktivitäten verwalten",
"admin roles" => "Rollen verwalten",
"edit this process" => "Prozess bearbeiten",
"monitor" => "Überwachen",
"create new gallery" => "neue Galerie anlegen",
"result" => "Ergebnis",
"reload" => "Aktualisieren",
"edit repository" => "Repository bearbeiten",
"source" => "Quellcode",
"edit new article" => "neuen Artikel erstellen",
"admin Banners" => "Banner verwalten",
"create new blog" => "Neuen Blog anlegen",
"admin cache" => "Cache verwalten",
"upload file" => "Datei hochladen",
"Edit a file using this form" => "Datei über dieses Formular bearbeiten",
"delete selected files" => "markierte Dateien löschen",
"browse gallery" => "Galerie anzeigen",
"Flash binary (.sqf or .dcr)" => "Flash Binary (.sqf oder .dcr)",
"edit blog" => "Blog bearbeiten",
"edit new submission" => "neue Einreichung bearbeiten",
"actions" => "Aktionen",
"set as operator" => "Als Operator hinzufügen",
"add topic" => "Thema hinzufügen",
"install" => "installieren",
"back" => "zurück",
"Assign permissions to page" => "Berechtigungen für Seite vergeben",
"These permissions override any global permissions affecting this object. To edit global permissions " => "Diese Berechtigungen überschreiben alle globalen Berechtigungen, die auf dieses Objekt wirken. Zum Ändern der globalen Berechtigungen ",
"Current permissions for this page" => "Aktuelle Berechtigungen für diese Seite",
"remove from this page" => "aus dieser Seite entfernen",
"remove from this structure" => "aus dieser Struktur entfernen",
"No individual permissions; category or global permissions apply" => "Keine individuellen Berechtigungen; Kategorie oder globale Berechtigungen vergeben",
"this page" => "diese Seite",
"this structure" => "diese Struktur",
"Current permissions for categories that this page belongs to" => "Diese Seite gehört zu den Kategorien mit folgenden Berechtigungen",
"Send email notifications when this page changes to" => "Emailbenachrichtigung bei Seitenänderung verschicken an",
"add email" => "Email hinzufügen",
"Notifications" => "Benachrichtigungen",
"clear stats" => "Statistiken zurücksetzen",
"Edit received page" => "Empfangene Seite bearbeiten",
"last" => "letzte",
"send me my password" => "Mein Passwort senden",
"searched" => "gesucht",
"galleries" => "Galerien",
"blog posts" => "Blog-Einträge",
"wiki pages" => "Wiki-Seiten",
"site" => "Site",
"clear" => "zurücksetzen",
"add article" => "Artikel hinzufügen",
"admin Tiki Shoutbox" => "Tiki-Shoutbox verwalten",
"list view" => "Listenansicht",
"send answers" => "Antworten senden",
"move to right column" => "in die rechte Spalte verschieben",
"unassign" => "Zuordnung aufheben",
"move to left column" => "in die linke Spalte verschieben",
"remove folder" => "Ordner löschen",
"refresh cache" => "Cache aktualisieren",
"use google map locator" => "Google Map Locator benutzen",
"admin mode" => "Verwaltungsmodus",
"trash" => "in Papierkorb",
"empty trash" => "Papierkorb löschen",
"remove from trash" => "aus dem Papierkorb",
"use start date and time" => "Startdatum/-zeit benutzen",
"use end date and time" => "Enddatum/-zeit benutzen",
"no comments" => "keine Kommentare",
"edit items" => "Einträge bearbeiten",
"list charts" => "Hitlisten anzeigen",
"last chart" => "neueste Hitliste",
"view faq" => "FAQ anzeigen",
"add suggestion" => "Vorschlag hinzufügen",
"monitor this forum" => "Dieses Forum beobachten",
"stop monitoring this forum" => "Beobachten dieses Forums beenden",
"delete selected topics" => "Ausgewählte Themen löschen",
"stop monitoring this topic" => "Beobachtung dieses Themas beenden",
"Comments below your current threshold" => "Kommentar unterhalb Deines aktuellen Schwellenwerts",
"list attachments" => "Anhänge auflisten",
"add contacts" => "Kontakte hinzufügen",
"DATE-of" => "im",
"You cannot edit this page because it is a user personal page" => "Du kannst diese Seite nicht bearbeiten, da es sich um eine persönliche Benutzerseite handelt.",
"Permission denied you cannot assign permissions for this page" => "Zugriff verweigert. Du kannst dieser Seite keine Berechtigungen zuweisen",
"You do not have permission to edit messages" => "Du hast keine Berechtigung, diese Nachrichten zu bearbeiten",
"Cannot read file" => "Kann Datei nicht lesen",
"Permission denied you cannot upload files" => "Berechtigung zum Hochladen von Dateien nicht vorhanden",
"cannot process upload" => "Kann Upload nicht verarbeiten",
"Your email address has been removed from the list of addresses monitoring this tracker" => "Deine Emailadresse wurde von der Liste der Adressen, die diesen Tracker überwachen entfernt",
"Your email address has been added to the list of addresses monitoring this tracker" => "Deine Emailadresse wurde zu der Liste der Adressen, die diesen Tracker überwachen hinzugefügt",
"Cancel monitoring" => "Überwachung beenden",
"Your email address has been removed from the list of addresses monitoring this item" => "Deine Emailadresse wurde aus der Liste derer entfernt, die diesen Eintrag beobachten",
"Your email address has been added to the list of addresses monitoring this item" => "Deine Emailadresse wurde zu denen hinzugefügt, die diesen Eintrag beobachten",
"new image uploaded by" => "neue Bilder hochgeladen von",
"new subscriptions" => "neue Abonnenten",
"new item in tracker" => "Neuer Eintrag im Tracker",
"show" => "zeigen",
"hide" => "verstecken",
"message" => "Nachricht",
"Include an article" => "Artikel einbinden",
"select all" => "alle auswählen",
"no such file" => "Datei nicht gefunden",
"downloads" => "Downloads",
"attach" => "anhängen",
"monitor this blog" => "diesen Blog beobachten",
"hide categories" => "Kategorien verbergen",
"Admin categories" => "Kategorien verwalten",
"browse category" => "Kategorien durchstöbern",
"reply" => "antworten",
"monitor this topic" => "Thema beobachten",
"with checked" => "markierte",
"move selected files" => "markierte Dateien verschieben",
"Thank you for you registration." => "Vielen Dank für die Registrierung.",
"compare" => "vergleichen",
"diff" => "Diff",
"sender" => "Absender",
"subject" => "Betreff",
"date" => "Datum",
"flagged" => "gekennzeichnet",
"mark" => "setzen",
"find replied message" => "suche beantwortete Nachricht",
"Click the :: options in the Menu for more options." => "Klicke die :: Optionen im Menü für weitere Optionen.",
"Please, also see" => "Bitte auch",
"for more setup details." => "für weitere Konfigurationsdetails anschauen.",
"Note 1:" => "Hinweis 1:",
"You can remove this module in" => "Entfernen dieses Moduls über",
"as well as assign or edit many others." => "wo auch andere Module zugewiesen oder erstellt werden können.",
"Note 2:" => "Hinweis 2:",
"The menu module installed by default is named" => "Das Modul mit den Standard Menüs heißt",
"it is a \"custom module\" which includes menu ID " => "es ist ein \"benutzerdefiniertes Modul\", es enthält das Menü mit der ID ",
"That menu is stored in database and it can be edited from " => "Das Menü ist in der Datenbank gespeichert und kann geändert werden über ",
"Do not mix this with the original <em>application_menu</em> module" => "Bitte nicht verwechseln mit dem <em>application_menu</em> Modul",
"That one can be heavily customized to match style used but it can be currently done only by editing mod-application_menu.tpl file \"manually\"" => "Letzteres kann an eigene Styles etc. angepaßt werden, dafür muss aber die Datei mod-application_menu.tpl von Hand geändert werden.",
"del" => "löschen",
"Create pdf" => "PDF erstellen",
"pdf" => "PDF",
"1 file attached" => "1 angehängte Datei",
"Click" => "Klick",
"categories" => "Kategorien",
"List pages where I am a creator" => "Seiten auflisten, die ich erstellt habe",
"by creator" => "nach Ersteller",
"by modificator" => "nach Bearbeiter",
"at tracker" => "Bei Tracker",
"posted by" => "eingetragen von",
"email this post" => "Diesen Beitrag verschicken",
"calendar view" => "Kalenderansicht",
"check / uncheck all" => "alle (ent)markieren",
"Mandatory category in the category tree" => "Pflichtkategorie im Kategorieverzeichnis",
"Tiki sections and features" => "Tiki-Bereiche und Funktionen",
"tiki.org help" => "tiki.org Hilfe",
"Site Logo and Identity" => "Site-Logo und Identität",
"Use Quote plugin rather than &ldquo;>&rdquo; for quoting" => "Quote PlugIn statt festes &ldquo;>&rdquo; beim Quoten verwenden",
"Storing files in a directory" => "Speichern von Dateien in einem Verzeichnis",
"please read" => "Bitte lesen! (klick mich)",
"yes" => "ja",
"Click here for more details." => "Für weitere Details hier klicken.",
"Best Language" => "Beste Sprache",
"Tiki preferences value field in db is set to be max. 250 characters long by default until now. That applies for the custom code content too. Check this field if you want to update your preferences database table to support more than 250 chars (although it was tested and works fine with mysql, it's recommended to backup your data manually before any database update)" => "Die Tiki Einstellungen beschränken die max. Zeichenlänge standardmäßig auf 250. Dies trifft auch auf angepassten Code zu. Um mehr Zeichen zuzulassen, setze hier den Haken (Erstelle  vorher ein Backup Deiner Datenbank!).",
"Users &amp; groups" => "Benutzer &amp; Gruppen",
"<b>Item</b>" => "<b>Eintrag</b>",
"<b>Value</b>" => "<b>Wert</b>",
"This page is to configure settings of RSS feeds generated/exported by Tiki. To read/import RSS feeds, look for \"RSS Modules\" on the application menu, or" => "Auf dieser Seite werden die RSS Feeds konfiguriert, die von Tiki erstellt und exportiert werden. Zum Einlesen/Importieren von RSS Feeds \"RSS Module\" im Menü wählen oder",
"<b>Feed</b>" => "<strong>Feed</strong>",
"<b>enable/disable</b>" => "<strong>ein/aus</strong>",
"<b>Max number of items</b>" => "<strong>Max. Anzahl<br>Einträge</strong>",
"Feed for Articles" => "Feed für Artikel",
"Feed for Weblogs" => "Feed für Blogs",
"Feed for Image Galleries" => "Feed für Bildergalerien",
"Feed for File Galleries" => "Feed für Dateiarchive",
"Feed for the Wiki" => "Feed für Wiki-Seiten",
"Feed for individual Image Galleries" => "Feed für einzelne Bildergalerie",
"Feed for individual File Galleries" => "Feed für einzelnes Dateiarchiv",
"Feed for individual weblogs" => "Feed für einzelnen Blog",
"Feed for individual forums" => "Feed für einzelnes Forum",
"Feed for mapfiles" => "Feed für Kartendateien",
"Feed for individual tracker items" => "Feed für einzelne Tracker-Einträge",
"Feed for tracker items" => "Feed für Tracker-Einträge",
"Feed for upcoming calendar events" => "Feed für zukünftige Events",
"Caching time :" => "RSS Daten im Cache halten",
"Only enable caching if all syndicated content is public (visible to everyone) or private documents might leak out. Cache ignores existing permissions." => "Caching sollte nur für Inhalte aktiviert werden, die vollständig freigegeben sind, es könnten sonst private Dokumente verteilt werden. Bei Nutzung des Cache greifen die Rechteabfragen nicht.",
"Prefix breadcrumbs with 'Location:' label?" => "Präfixe Breadcrumbs mit 'Position:'?",
"Site Search" => "Site Suche",
"Change style only" => "nur Style ändern",
"Tag name" => "Tag Name",
"Anonymous editors must input anti-bot code" => "Anonyme Autoren müssen Anti-Robot Code eingeben",
"PDF generation" => "PDF-Erstellung",
"Show page title" => "Seitentitel anzeigen",
"Show page ID" => "Seiten-ID anzeigen",
"Users can lock pages (if perm)" => "Benutzer kann Seiten sperren (falls berechtigt)",
"Use WikiWords" => "WikiWords benutzen",
"Use Wiki paragraph formatting" => "Wiki Absatzformatierung benutzen",
"Use external link icons" => "Symbole für externe Links benutzen",
"User's Page" => "Benutzerseite 'UserPageNAME'",
"When viewing a page, if it doesn't exist and has one like page, automatic redirection to this like page" => "Beim betrachten einer Seite, welche nicht existiert aber eine ähnliche existiert, automatisch dahin umleiten",
"Show/hide heading icon displayed before the heading" => "Zeige/Verberge Überschriftssymbole vor der Überschrift",
"Print Page" => "Seite ausdrucken",
"Maximum number of versions for history" => "Maximale Anzahl der Versionen in Historie",
"Never delete versions younger than days" => "Niemals löschen: Versionen jünger als",
"IP not displayed in history" => "IP nicht in der History anzeigen",
"Diff style" => "Vergleichs-Typ",
"Statistic" => "Statistik",
"Use in CMS" => "Im CMS benutzen",
"Use in Wiki" => "In Wikis benutzen",
"Use in newsletters" => "In Rundbriefen benutzen",
"Use in HTML pages" => "In HTML-Seiten benutzen",
"Edit Existing Forums" => "Vorhandene Foren bearbeiten",
"Refresh rate (if dynamic) [secs]" => "Aktualisierungsrate (falls dynamisch) [Sek.]",
"configure repositories" => "Repositories konfigurieren",
"configure this repository" => "dieses Repository konfigurieren",
"copy rules" => "Regeln kopieren",
"Create/edit newsletters" => "Rundbriefe hinzufügen/bearbeiten",
"subscriptions" => "Abonnements",
"archives" => "Archive",
"Use Admin Email" => "Admin Email benutzen",
"Edit or add poll options" => "Abstimmungsoptionen hinzufügen/bearbeiten",
"Create/edit Polls" => "Abstimmungen hinzufügen/bearbeiten",
"Rss channels" => "RSS Kanäle",
"show pubdate" => "Datum anzeigen",
"activate" => "Aktivieren",
"Admin tracker" => "Tracker verwalten",
"Edit this tracker" => "Diesen Tracker bearbeiten",
"View this tracker items" => "Einträge dieses Trackers ansehen",
"Edit tracker fields" => "Tracker-Felder bearbeiten",
"Import/export trackers fields" => "Tracker-Felder importieren/exportieren",
"Create trackers" => "Tracker anlegen",
"Import/export" => "Import/Export",
"fields" => "Felder",
"Create/edit trackers" => "Tracker hinzufügen/bearbeiten",
"filename" => "Dateiname",
"filesize" => "Dateigröße",
"filetype" => "Dateityp",
"longdesc" => "Beschreibung",
"Add a new group" => "Eine neue Gruppe hinzufügen",
"Edit item" => "Punkt bearbeiten",
"List all members" => "Alle Mitglieder auflisten",
"Add a new user" => "Neuen Benutzer hinzufügen",
"manage group assignments" => "Gruppenzuordnungen bearbeiten",
"set default groups" => "Standardgruppen setzen",
"watch only this category" => "Nur diese Kategorie beobachten",
"watch this category and their descendants" => "Diese Kategorien und deren Nachfolger beobachten",
"stop watching only this category" => "Nur diese Kategorie nicht mehr beobachten",
"stop watching this category and their descendants" => "Diese Kategorie und deren Nachfolger nicht mehr beobachten",
"Popup Window" => "Popup-Fenster",
"details" => "Details",
"zoom" => "Zoomen",
"change focus" => "hierher wechseln",
"quarter" => "Vierteljahr",
"semester" => "Halbjahr",
"No individual permissions global permissions apply" => "Keine individuellen Berechtigungen, globale Berechtigungen gelten",
"Welcome to the Tiki Chat Rooms" => "Willkommen bei den Tiki Chaträumen",
"Please select a chat channel" => "Bitte einen Chatraum auswählen",
"enter chat room" => "Chatraum betreten",
"There are no channels setup, please contact a site admin" => "Es sind keine Chaträume eingerichtet, bitte den Admin kontaktieren.",
"Chatroom" => "Chatraum",
"Active Channels" => "Aktive ",
"Users in this channel" => "Benutzer in diesem Kanal",
"Channel Information" => "Channel-Informationen",
"Use :nickname:message for private messages" => "Benutze :nickname:Nachricht für private Nachrichten",
"Use [URL|description] or [URL] for links" => "Benutze [URL|Beschreibung] oder [URL] für Links",
"Use (:smileyname:) for smileys" => "Benutze (:smileyname:) für Smileys",
"Create PDF" => "PDF erstellen",
"PDF Settings" => "PDF Einstellungen",
"Keep screen pixel/point ratio" => "Pixel und Punkt Verhältnis nicht ändern",
"Render images" => "Bilder rendern",
"Render hyperlinks" => "Hyperlinks rendern",
"Left Margin (mm)" => "Linker Abstand (mm)",
"Right Margin (mm)" => "Rechter Abstand (mm)",
"Top Margin (mm)" => "Oberer Abstand (mm)",
"Bottom Margin (mm)" => "Unterer Abstand (mm)",
"Show page border" => "Seitenrand anzeigen",
"PDF compatilbility level" => "PDF Kompatibilität",
"Select Wiki Pages" => "Wiki-Seiten auswählen",
"click here to send us an email" => "Hier klicken um uns eine Email zu schicken",
"Add or edit a site" => "Link hinzufügen/bearbeiten",
"sites" => "Links",
"cool sites" => "Coole Links",
"Use ...page... to separate pages in a multi-page article" => "Benutze ...page... um Seiten in einen mehrseitigen Artikel aufzuteilen",
"Create Zone" => "Zone hinzufügen",
"browse image" => "Bild betrachten",
"translate" => "übersetzen",
"Create or edit content" => "Inhalt hinzufügen/bearbeiten",
"this quiz stats" => "Statistik für dieses Quiz",
"answer" => "Antwort",
"Edit Translation:" => "Übersetzungs-Einstellungen:",
"Set of Translations" => "Vorhandene Übersetzungen",
"Select the article for which the current article is the translation." => "Artikel auswählen, vom dem dieser hier die Übersetzung ist",
"Translation of:" => "Übersetzung von:",
"Add to the Set" => "Zur Liste hinzufügen",
"graph" => "Graph",
"Edit FAQ questions" => "FAQ-Fragen bearbeiten",
"Edit this file gallery:" => "Dieses Dateiarchiv bearbeiten:",
"icon" => "Symbol",
"Other users can upload files to this gallery" => "Andere Benutzer können Dateien hochladen",
"Available File Galleries" => "Verfügbare Dateiarchive",
"start" => "Beginn",
"end" => "Ende",
"roles" => "Rollen",
"Add role" => "Rolle hinzufügen",
"active process" => "aktiver Prozess",
"invalid" => "ungültig",
"invalid process" => "ungültiger Prozess",
"valid process" => "gültiger Prozess",
"activities" => "Aktivitäten",
"aborted" => "abgebrochen",
"value" => "Wert",
"proc" => "Prozesse",
"exceptions" => "Fehler",
"rollback" => "Rollback",
"Create or edit content block" => "Inhaltsblock hinzufügen/bearbeiten",
"Old vers" => "Alte Version",
"Listing Gallery" => "Liste Galerie auf",
"Gallery Files" => "Archiv-Dateien",
"Last ver" => "letzte Ver.",
"Com" => "Kommentar",
"Vers" => "Ver.",
"Add or edit event" => "Termin hinzufügen/bearbeiten",
"Subscribe to newsletter" => "Rundbrief abonnieren",
"Add or edit a news server" => "Newsserver hinzufügen/bearbeiten",
"merge selected notes into" => "Notizen verschmelzen mit",
"Print Wiki Pages" => "Wiki-Seiten drucken",
"add page" => "Seite hinzufügen",
"entire site" => "Ganze Site",
"click to navigate" => "zum Navigieren anklicken",
"Total threads" => "Threads gesamt",
"Average threads per topic" => "Durchschn. Threads pro Thema",
"Faq Stats" => "FAQ-Statistik",
"clean" => "löschen",
"You can include the file in an HTML/Tiki page using" => "Du kannst die Datei in eine HTML-/Tiki-Seite einfügen mit",
"Now enter the file URL" => "Nun Datei-URL eingeben",
" or upload a local file from your disk" => " oder Datei von lokaler Disk hochladen",
"Add or edit folder" => "Ordner hinzufügen/bearbeiten",
"Add or edit a URL" => "URL hinzufügen/bearbeiten",
"received" => "erhalten",
"submitted" => "zugewiesen",
"shared" => "geteilt",
"move into trash" => "in den Papierkorb",
"waiting / not started" => "wartend / noch nicht begonnen",
"waiting" => "wartend",
"shared for group" => "wird geteilt von Gruppe",
"accepted by user" => "akzeptiert von Benutzer",
"no / rejected" => "nein / zurückgewiesen",
"accepted by creator" => "vom Ersteller akzeptiert",
"priority" => "Priorität",
"select one" => "Status",
"undo trash" => "aus Papierkorb",
"show:" => "anzeigen:",
"all shared tasks" => "alle geteilten Aufgaben",
"previous chart" => "vorherige Hitliste",
"next chart" => "nächste Hitliste",
"pos" => "Position",
"pre" => "letzte",
"avg" => "Durchschnitt",
"post new comment" => "Neuen Kommentar posten",
"Post New Comment" => "Neuen Kommentar posten",
"HTML tags are not allowed inside comments" => "HTML-Tags innerhalb von Kommentaren nicht erlaubt",
"moderator actions" => "Moderator-Aktionen",
"move selected topics" => "Ausgewählte Themen verschieben",
"unlock selected topics" => "Ausgewählte Themen entsperren",
"lock selected topics" => "Ausgewählte Themen sperren",
"merge" => "zusammenführen",
"merge selected topics" => "Ausgewählte Themen zusammenführen",
"reported messages:" => "Gemeldete Nachrichten:",
"queued messages:" => "Aufgelaufene Nachrichten:",
"emot" => "Stimmung",
"Edit fields" => "Felder bearbeiten",
"View item" => "Eintrag ansehen",
"Add a comment" => "Kommentar hinzufügen",
"settings" => "Einstellungen",
"mailbox" => "Mailbox",
"compose" => "Erstellen",
"contacts" => "Kontakte",
"account" => "Konto",
"pop" => "POP",
"back to mailbox" => "Zurück zum Briefkasten",
"full headers" => "Alle Header",
"normal headers" => "Normale Header",
"reply all" => "allen antworten",
"forward" => "weiterleiten",
"select from address book" => "Aus Adressbuch auswählen",
"cc" => "CC",
"Projects" => "Projekte",
"Projects configuration" => "Projekte Einstellungen",
"Site Identity features" => "Site-Identitätsfunktionen",
"Click here to delete this category" => "Zum Löschen der Kategorie hier klicken",
"Group doesnt exist" => "Gruppe existiert nicht",
"User doesnt exist" => "Benutzer existiert nicht",
"Event without Name" => "Ereignis ohne Name",
"No channel indicated" => "Kein Kanal angegeben",
"No nickname indicated" => "Kein Nickname angegeben",
"No permission to view the page" => "Keine Berechtigung zum Betrachten dieser Seite",
"Please create a directory named \$map_path to hold your map files." => "Bitte ein Verzeichnis \$map_path für die Kartendaten anlegen.",
"Permision denied" => "Zugriff verweigert",
"Technology" => "Technologie",
"Content Related" => "Inhaltsbezogen",
"Feature documentation links" => "Doku-Links zu Komponenten",
"Help System (Feature documentation links)" => "Hilfesystem (Doku-Links zu Komponenten)",
"Technical Features" => "Technischer Funktionen",
"Checkbox options: put 1 if you need that next field is on the same row." => "Auswahlfeld-Optionen: 1 eintragen, falls das nächste Feld in derselben Spalte sein soll",
"new sites" => "Neue Links",
"Paramaters" => "Parameter",
"database queries used" => "durchgeführte Datenbankabfragen",
"{\$atts_cnt} files attached" => "{\$atts_cnt} angehängte Dateien",
"pass" => "Passwort",
"Page generated in" => "Seite erzeugt in",
"sent" => "Gesendet",
"Homework" => "Hausaufgaben",
"Assignments" => "Aufgaben",
"Favorites" => "Favoriten",
"Member list" => "Mitgliederliste",
"Back to Homepage" => "Zurück zur Startseite",
"Edit Summary" => "Zusammenfassung bearbeiten",
"Minor" => "geringfügig",
"Content Features" => "Inhaltseinstellungen",
"Contact Us (Anonymous)" => "Kontaktiere uns (anonym)",
"Prevent automatic/robot registration" => "Batch-Registrierung (z.B. per Skript) unterbinden",
"Create/edit Calendars" => "Kalender hinzufügen/bearbeiten",
"charts" => "Hitlisten",
"Chat Administration" => "Chat-Verwaltung",
"Chat Admin" => "Chat verwalten",
"Create/edit channel" => "Chatraum hinzufügen/bearbeiten",
"Half a second" => "halbe Sekunde",
"Chat channels" => "Chaträume",
"Admin Featured Links" => "Linktips verwalten",
"Admin Webmail" => "Webmail verwalten",
"Assign Module" => "Modul zuweisen",
"subscribed" => "abonniert",
"Score System" => "Bewertungssystem",
"Edit survey questions" => "Umfrage bearbeiten",
"Admin Tracker" => "Tracker verwalten",
"Again" => "Wiederholung",
"Assign permissions to group" => "Gruppenberechtigungen vergeben",
"Browsing Gallery" => "Galerie ansehen",
"Admin Directory Related" => "Verwandte Kategorien verwalten",
"Admin Directory Sites" => "Links verwalten",
"Validate Sites" => "Links überprüfen",
"Edit Article" => "Artikel erstellen/bearbeiten",
"Show Plugins Help" => "Zeige Plugin Hilfe",
"Show Text Formatting Rules" => "Zeige Textformatierungsregeln",
"Program dynamic content for block" => "Dynamischen Inhalt für den Block programmieren",
"Admin quizzes" => "Quiz verwalten",
"EditTemplates" => "Vorlagen bearbeiten",
"Message queue for" => "Nachrichtenliste für",
"back to forum" => "zur&uum;ck zum Forum",
"Reported messages for" => "Gemeldete Beiträge für",
"Admin Cache" => "Cache verwalten",
"back to admin" => "zurück zur Verwaltung",
"Subscribe to This Newsletter" => "Rundbrief abonnieren",
"Stats for quiz" => "Statistik für das Quiz",
"Received Articles" => "Erhaltene Artikel",
"Rename page" => "Seite umbenennen",
"to_version" => "zu_Version",
"Stats for survey" => "Statistik für Umfrage",
"Theme Control Center: categories" => "Theme Kontrollcenter: Kategorien",
"ThemeControl" => "Theme-Konfiguration",
"ThemeControl Objects" => "Objekte Theme-Konfiguration",
"Theme Control Center: sections" => "Theme Kontrollcenter: Bereiche",
"Upload big files (e.g. PodCast files) here:" => "Große Dateien (z.B. PodCasts) hier hochladen:",
"File Title" => "Dateititel",
"User Assigned Modules" => "Vom Benutzer zugewiesene Module",
"IRC log" => "IRC Log",
"Add new mail account" => "Neues Emailkonto hinzufügen",
"User accounts" => "Benutzerkonten",
"View All" => "Alle ansehen",
"Msg" => "Nachricht",
"Can't parse remote HTML page" => "Kann externe HTML-Seite nicht verarbeiten",
"Permission denied you cannot remove pages" => "Berechtigung zum Entfernen von Seiten nicht vorhanden",
"Cannot write to this file" => "Kann diese Datei nicht schreiben",
"Missing title or body when trying to post a comment" => "Fehlender Titel oder Textkörper beim Posten eines Kommentars",
"\\n for rows" => "\\n für Spalten",
"Consider we are in always in HTTPS, but do not check" => "Gehe von HTTPS aus, aber prüfe nicht nach",
"Newsletter subscription information at " => "Rundbrief-Abonnement Infos auf ",
"Changes" => "Änderungen",
"Hold down CTRL to select multiple categories" => "Zum Markieren mehrerer Kategorien STRG gedrückt halten",
"categorize this object" => "Dieses Objekt kategorisieren",
"Uncheck the above checkbox to uncategorize this page/object" => "Die Checkboxmarkierung löschen um die Kategorien von dieser Seite/diesem Objekt zu entfernen",
"Your account request have been stored and will be activated by the admin as soon as possible." => "Die Anfrage wurde gespeichert und wird vom Administrator schnellst möglich bearbeitet.",
"New article post: {\$mail_title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Neuer Artikel erschienen: {\$mail_title} von {\$mail_user} am {\$mail_date|tiki_short_datetime}",
"Syntax highlighting" => "Syntax-Hervorhebung",
"MyTiki Home" => "Meine Tiki-Startseite",
"My Files" => "Meine Dateien",
"Mini calendar" => "Minikalender",
"User list" => "Benutzerliste",
"Send Pages" => "Seiten verschicken",
"Received pages" => "Erhaltene Seiten",
"New Article" => "Neuer Artikel",
"Admin Posts" => "Einträge verwalten",
"Submit a New Link" => "Neuen Link eintragen",
"Browse directory" => "Verzeichnis durchstöbern",
"Admin Directory" => "Linkverzeichnis verwalten",
"Layer Management" => "Layer Management",
"List quizzes" => "Quiz auflisten",
"List trackers" => "Tracker auflisten",
"Ephemerides Admin" => "Terminkalender verwalten",
"Charts Admin" => "Hitlisten verwalten",
"Debugger console" => "Debug-Konsole",
"I forgot my pass" => "Ich habe mein Passwort vergessen",
"Send trackback pings to:" => "Trackback pings senden an:",
"(comma separated list of URIs)" => "(kommagetrennte URI-Liste)",
"This is" => "Dies ist",
"by the" => "von der",
"Tiki community" => "Tiki Community",
"User identity features" => "Benutzeridentitäts-Einstellungen",
"Tikiwiki version" => "Tikiwiki Version",
"Use URI as Home Page" => "URI als Home-Seite benutzen",
"OS" => "Betriebssystem",
"Enable Smarty Security (e.g. do not allow php code in smarty templates)" => "Smarty Sicherheit aktivieren (z.B. keinen PHP-Code in Smarty Templates erlauben)",
"Log Mail in Tiki Logs:" => "Emails im Log protokollieren:",
"Log SQL:" => "SQL protokollieren:",
"Default charset for sending mail:" => "Standardkodierung ausgehender Emails:",
"Mail end of line:" => "Zeilenende in Emails:",
"Disallow access to the site (except for those with permission)" => "Zugriff auf den Server verbieten (außer für Personen mit Berechtigung)",
"Message to display when site is closed" => "Angezeigte Meldung, wenn der Server geschlossen ist",
"Disallow access when load is above the threshold (except for those with permission)" => "Zugriff auf den Server bei Überschreiben der eingestellten Maximallast verbieten (außer für Personen mit Berechtigung)",
"Max average server load threshold in the last minute" => "Höchste Durchschnittslast in der letzten Minute",
"Message to display when server is too busy" => "Angezeigte Meldung, wenn der Server überlastet ist",
"Use cache for external images" => "Cache für externe Bilder benutzen",
"Use gzipped output" => "Ausgabe durch gzip",
"output compression is active." => "Ausgabekomprimierung ist aktiv.",
"compression is handled by" => "Komprimierung erfolgt durch",
"Sender Email" => "Emailabsender",
"Allow anonymous users to \"Contact Us\"" => "\"Kontaktiere uns\" Feature für Anonym erlauben",
"contact feature disabled" => "Kontaktfunktion deaktiviert",
"Session lifetime in minutes" => "Session-Lebenszeit in Minuten",
"Proxy Host" => "Proxy Server",
"Please expect not found help-pages with the default-URL." => "Teilweise fehlen die Hilfeseiten noch.",
"Any help with the documentation is welcome." => "Hilfe bei der Dokumentation ist willkommen.",
"Release check" => "Auf neue Version prüfen",
"Release checks are made when you browse admin main page only" => "Die Überprüfung wird beim Aufruf der Admin-Hauptseite durchgeführt",
"Force immediate check" => "Jetzt prüfen",
"When possible, show the real user name instead of login:" => "Zeige vollen Namen statt Benutzerkennen (sofern vorhanden):",
"Locations separator" => "Trennzeichen zwischen Locations",
"Choices separator" => "Auswahl Abgrenzer",
"User registration and login" => "Benutzerregistrierung und -login",
"Use WebServer authentication for Tiki" => "Webserver-Authentifizierung für Tiki benutzen",
"... but need admin validation" => "... benötigen aber Bestätigung durch den Admin",
"Create a group for each user <br />(with the same name as the user)" => "Für jeden Benutzer eine eigene<br />Gruppe anlegen (Gruppenname = Benutzername)",
"Use tracker for more user information" => "Tracker für weitere Benutzer-Informationen benutzen",
"Use tracker for more group information" => "Tracker für weitere Gruppen-Informationen benutzen",
"Request passcode to register" => "Passcode zur Registrierung abfragen",
"Php GD library required" => "Php GD Bibliothek erforderlich",
"Use login as email" => "Login als Emailadresse benutzen",
"Validate users by email" => "Benutzer per Email validieren",
"Validate user email server" => "Mailserver des Benutzers validieren",
"Remind passwords by email (if \"Store plaintext passwords\" is activated.) Else, Reset passwords by email" => "Passworterinnerungen per Email (wenn \"Passwörter im Klartext speichern\" aktiviert ist.) Sonst, Passwörter per Email zurücksetzen",
"Store plaintext passwords" => "Speichere Klartext-Passwörter",
"Crypt passwords method" => "Passwort-Verschlüsselung",
"Reg users can change password" => "Reg. Benutzer können Passwort ändern",
"Reg users can change language" => "Reg. Benutzer können Sprache ändern",
"Restrict available languages" => "Verfügbare Sprachen einschränken",
"Available languages:" => "Verfügbare Sprachen:",
"Minimum username length" => "Minimallänge Benutzername",
"Maximum username length" => "Maximallänge Benutzername",
"Force lowercase username" => "Nur Kleinbuchstaben im Benutzernamen",
"Force to use chars and nums in passwords" => "Erzwinge Benutzung von Buchstaben und Zahlen in Passwörtern",
"Minimum password length" => "Minimale Passwortlänge",
"Password invalid after days" => "Tage bis zur Ungültigkeit des Passwortes",
"-1 for never" => "-1 für niemals",
"Re-validate user by email after days" => "Tage bis der Benutzer erneut per Email validiert wird",
"Re-validate user by email after unsuccessful logins" => "Fehlgeschlagene Anmeldungen, nach denen der Benutzer erneut per Email validiert wird",
"Generate a password option" => "Option zum automatischen Passwort-Erstellen anzeigen",
"Remember me feature" => "Erkenne mich-Funktion",
"Remember me name" => "Erkenne mich-Name",
"Remember me domain" => "Erkenne mich-Domain",
"Remember me path" => "Erkenne mich-Pfad",
"Protect against CSRF with a confirmation step" => "Durch Bestätigungs-Schritt gegen CSRF schützen",
"Highlight Group" => "Gruppe hervorheben",
"User can choose beyond these groups at registration time" => "Benutzer kann beim Registrieren zwischen diesen Gruppen wählen",
"Specify the fields that will be asked in admin->groups" => "Definiere die zusätzlicen Felder in Verwalten->Gruppen",
"Displays user's contribution in the user information page" => "Zeigt die Nutzeraktivität auf der Benutzerinfoseite an",
"Displays UserTracker information in user information page. Format: trackerId, fieldId1, fieldId2, …" => "Zeige diese UserTracker-Infos auf der Benutzerseite an. Format: trackerId, fieldId1, fieldId2, ...",
"Deactivate login autocomplete (do not remember login and password)" => "Automatisches Vervollständigen beim Login abschalten (Kennung und Passwort nicht merken)",
"On permission denied, display login box for anonymous:" => "Bei Zugriffsfehlermeldung für anonyme Benutzer die Loginbox anzeigen:",
"On permission denied, send to this url:" => "Bei Zugriffsfehlermeldung auf diese Seite springen:",
"Create user if not in Tiki?" => "Benutzer anlegen falls im Tiki nicht vorhanden?",
"Create user if not in Auth?" => "Benutzer anlegen falls in Auth nicht vorhanden?",
"Just use Tiki auth for admin?" => "Nur Tiki-Authentifizierung für Administrator?",
"LDAP URL<br />(if set, this will override the Host and Port below)" => "LDAP URL<br />(wenn gesetzt werden Host und Port (s.u.) nicht benutzt)",
"LDAP User DN" => "LDAP Benutzer DN",
"LDAP User Attribute" => "LDAP Benutzer Attribut",
"LDAP User OC" => "LDAP Benutzer OC",
"LDAP Group DN" => "LDAP Gruppen DN",
"LDAP Group Attribute" => "LDAP Gruppen Attribut",
"LDAP Group OC" => "LDAP Gruppen OC",
"LDAP Member Attribute" => "LDAP Member Attribut",
"LDAP Admin User" => "LDAP Admin Benutzername",
"LDAP Admin Pwd" => "LDAP Admin Passwort",
"CAS server hostname" => "CAS Server Hostname",
"CAS server port" => "CAS Server Port",
"CAS server path" => "CAS Server Pfad",
"Change CAS preferences" => "Einstellungen übernehmen",
"Valid Affiliations (separated by commas)" => "Gültige Zugehörigkeiten (kommagetrennt)",
"Create with default group?" => "Standardgruppe erstellen?",
"Default group: " => "Standardgruppe",
"Change Shibboleth preferences" => "Einstellungen übernehmen",
"Users Defaults" => "Standardeinstellungen der Benutzer",
"Change users defaults" => "Einstellungen übernehmen",
"Meta Keywords" => "Schlüsselwörter",
"Meta Description" => "Beschreibung",
"Meta Author" => "Autor",
"meta robots" => "Meta Robots",
"revisit after" => "erneut besuchen nach",
"Allow Smileys" => "Smileys erlauben",
"Use File Galleries for images inclusion" => "Bildergalerien für Bildeinbindung in Seiten erlauben",
"Hotwords in New Windows" => "Hotwords in neuem Fenster",
"Trackers attachments preferences" => "Einstellungen für Tracker Anhänge",
"Trackers attachments" => "Tracker Anhänge",
"To add/edit wiki pages easily, add the module quick_edit via \"Modules\" on the application menu, or" => "Zum einfachen Erstellen/Bearbeiten von Wikiseiten das Modul quick_edit hinzufügen über Menüpunkt \"Module\" im Seitenbalken oder",
"Create a Tag for the Current Wiki" => "Tag für die aktuelle Wikiseite erstellen",
"Restore the Wiki" => "Wikiseiter wiederherstellen",
"restore" => "wiederherstellen",
"Remove a Tag" => "Tag entfernen",
"Wiki Comments Settings" => "Einstellungen für Wiki-Kommentare",
"Wiki Home Page" => "Wiki-Home-Page",
"Wiki Discussion" => "Wiki Diskussion",
"Wiki Link Format" => "Wiki Link Erkennung",
"Controls recognition of Wiki links using the two parenthesis Wiki link syntax <i>((page name))</i>." => "Definiert, welche <i>((Strings))</i> in Wiki Links umgewandelt werden",
"Wiki Page List Configuration" => "Einstellungen für Wikiliste",
"Wiki Features" => "Wiki-Funktionen",
"Print Page:" => "Seite drucken:",
"Show page version:" => "Seitenversion anzeigen:",
"Regex search and replace:" => "Regex Suchen und Ersetzen:",
"Wiki History" => "Wiki Historie",
"Wiki Watch" => "Wiki Beobachtung",
"Enable watches on comments:" => "Beobachtungspunkte auf Kommentaren aktivieren:",
"Watch minor:" => "Geringfügige Änderungen beobachten:",
"More Links" => "Weitere Links",
"Admin Charts" => "Hitlisten verwalten",
"Add new rule" => "Neue Regel hinzufügen",
"EMail notifications" => "Emailbenachrichtigungen",
"Edit this RSS module:" => "Dieses RSS-Modul bearbeiten:",
"Create new RSS module" => "Neues RSS-Modul erstellen",
"Tikiwiki settings" => "Tiki Einstellungen",
"Create/edit questions for survey" => "Fragen für Umfrage erstellen/bearbeiten",
"Active?" => "Aktiv?",
"Create Trackers" => "Tracker anlegen",
"Create/Edit Trackers" => "Tracker hinzufügen/bearbeiten",
"Assign to Groups" => "Zu Gruppen hinzufügen",
"show help" => "Hilfe zeigen",
"Delete this type" => "Diesen Typ löschen (nur wenn keine Artikel dieses Typs vorhanden sind)",
"level configuration" => "Level-Konfiguration",
"Browse gallery" => "Galerie durchsehen",
"Upload from disk" => "Hochladen von Disk",
"Browse file gallery" => "Dateiarchiv durchsehen",
"Directory batch" => "Aus Verzeichnis einlesen",
"Browsing Image" => "Bild ansehen",
"Again please" => "Bitte nochmal",
"Admin category relationships" => "Beziehungen zwischen Kategorien verwalten",
"Validate links" => "Links überprüfen",
"File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model." => "Dateien mit angehängtem -{\$user} sind veränderbar, andere sind schreibgeschützt, aber als Vorlage verwendbar.",
"Im- Export Languages" => "Sprachen im/exportieren",
"Create a file gallery" => "Dateiarchiv anlegen",
"Support tickets" => "Support-Ticket",
"Return to HomePage" => "Zurück zur Hauptseite",
"Stats for this survey Questions " => "Statistik für diese Umfrage-Frage ",
"1 suggestion" => "1 Vorschlag",
"suggestions" => "Vorschläge",
"Minor Edit" => "geringfügig",
"The \"Snarf Wikiplugin\" is installed. It can be used by wiki editors to include pages from the local network and via regex replacement create any html." => "Das \"Snarf Wikiplugin\" ist installiert. Es kann verwendet werden um Seiten aus dem lokalen Netzwerk via RegEx in HTML ausdrücken.",
"The \"Regex Wikiplugin\" is installed. It can be used by wiki editors to create any html via regex replacement." => "Das \"Regex Wikiplugin\" ist installiert. Es kann verwendet werden um HTML Code durch RegEx zu ersetzen.",
"You can not download files" => "Du darfst keine Dateien herunterladen",
"Please wait 2 minutes between posts" => "Bitte zwei Minuten zwischen Posts warten",
"The text in RED is" => "Der Text in ROT ist",
"Show Categories" => "Kategorien zeigen",
"Hide Categories" => "Kategorien verbergen",
"Wiki page %s changed" => "Die Wiki Seite %s wurde geändert",
"Blog features" => "Blog-Funktionen",
"Blog level comments" => "Kommentare auf Blog-Ebene",
"Post level comments" => "Kommentare auf Blogeintrag-Ebene",
"Post level trackback pings" => "Trackback Pings auf Blogeintrag-Ebene",
"Spellchecking" => "Rechtschreibprüfung",
"Default ordering for blog listing" => "Standardsortierung für Blog-Listen",
"Blog listing configuration (when listing available blogs)" => "Einstellungen Blog-Liste (für Liste der verfügbaren Blogs)",
"Last modification time" => "Änderungszeit",
"Blog comments settings" => "Blog-Kommentareinstellungen",
"Group calendar sticky popup" => "Sticky PopUp für Gruppenkalender",
"Group calendar item view tab" => "Elementanzeigespalte für Gruppenkalender",
"Calendar manual selection of time/date" => "manuelle Auswahl von Zeit/Datum im Kalender",
"Show Category Path" => "Kategoriepfad zeigen",
"Show Category Objects" => "Kategorieobjekte anzeigen",
"CMS features" => "Artikelfunktionen",
"Use templates" => "Vorlagen benutzen",
"Print article" => "Artikel drucken",
"Settings for page articles home" => "Einstellungen für die Artikel-Startseite",
"Maximum number of articles in home" => "Maximale Anzahl von Artikeln auf der Artikel-Startseite",
"Article comments settings" => "Artikelkommentareinstellungen",
"Fields to display on page" => "Folgende Felder anzeigen auf der Seite",
"Expire Date" => "Ablaufdatum",
"License Page" => "Lizenzseite",
"Submit Notice" => "Nachricht einstellen",
"To add/remove file galleries, go to \"File Galleries\" on the application menu, or" => "Dateiarchive hinzufügen/löschen über Menüpunkt 'Dateiarchive' im Menü im Seitenbalken oder",
"Uploaded filenames cannot match regex" => "Hochgeladene Dateinamen dürfen diesem regulären Ausdruck (regex) nicht entsprechen",
"File galleries comments settings" => "Dateiarchiv-Kommentareinstellungen",
"File galleries search indexing" => "Dateiarchiv Suchindex",
"Leave command blank to delete handler" => "'Systembefehl' leer lassen, damit keine Aktion ausgeführt wird.",
"Use %1 for where internal file name should be substituted (example: \"strings %1\" to convert the document to text using the unix strings command)" => "Platzhalter %1 benutzen, wo der Dateiname eingesetzt werden soll (Beispiel: 'strings %1' benutzen um das Dokument über den Unix-Befehl strings in reinen Text zu konvertieren.)",
"Enable auto indexing on file upload or change" => "Indizierung bei Dateiupload oder Änderung automatisch aktivieren",
"System command" => "Systembefehl",
"Home Forum" => "Hauptforum",
"Forums features" => "Foreneinstellungen",
"Forum quick jumps" => "Foren Schnellsprünge",
"Ordering for forums in the forum listing" => "Sortierung der Foren in Forenliste",
"Forum listing configuration" => "Konfiguration Forenliste",
"I18n setup" => "I18n Konfiguration (Mehrsprachigkeit)",
"Show Babelfish Translation URLs" => "Babelfish Übersetzungslink zeigen",
"Show Babelfish Translation Logo" => "Babelfish Übersetzungs-Logo zeigen",
"Show Module Controls" => "Modul-Verschiebebuttons zeigen",
"Users can Configure Modules" => "Benutzer können Module konfigurieren",
"Users can Shade Modules" => "Benutzer kann Module minimieren",
"module decides" => "Modul entscheidet",
"Allow Anonymous Poll Voting" => "Anonyme Teilnehmer bei Umfragen erlauben",
"seconds (0 = cache inactive)" => "Sekunden (0 = Cache deaktiviert)",
"Performance issues" => "Performance-Einstellungen",
"Search features" => "Suche Einstellungen",
"SearchStats" => "Suchstatistik",
"Settings for searching content" => "Einstellung für die Suche in Inhalten",
"Search refresh rate" => "Aktualisierungsrate der Suche",
"0 for no refresh" => "0 für nicht aktualisieren",
"this survey stats" => "Statistik dieser Umfrage",
"bold" => "fett",
"italic" => "kursiv",
"underline" => "unterstreichen",
"unread private messages" => "ungelesene persönliche Nachrichten",
"you or someone registered this email address at" => "Du oder jemand anderes hat diese Emailadresse bei",
"Your Tiki information registration" => "Deine Tiki Registrierungsinformationen",
"Your registration" => "Deine Tiki Registrierungsinformationen",
"left/right" => "links/rechts",
"Unassign module" => "Modul entfernen",
"home" => "Hauptseite",
"chat" => "Chat",
"contact us" => "Kontaktiere uns",
"debugger console" => "Debugkonsole",
"MyMenu" => "Mein Menü",
"User menu" => "Benutzer-Menü",
"dump" => "Datenbankabzug",
"rankings" => "Bewertungen",
"orphan pages" => "verwaiste Seiten",
"sandbox" => "Sandbox",
"received pages" => "empfangene Seiten",
"structures" => "Strukturen",
"Articles Home" => "Artikelhauptseite",
"Send articles" => "Artikel senden",
"Create/Edit Blog" => "Blog hinzufügen/bearbeiten",
"Browse Directory" => "Verzeichnis durchstöbern",
"Admin FAQs" => "FAQs verwalten",
"Edit mapfiles" => "Kartendateien bearbeiten",
"Admin quiz" => "Quiz verwalten",
"Admin trackers" => "Tracker verwalten",
"Send newsletters" => "Rundbrief versenden",
"Ephemerides" => "Terminkalender",
"Admin home" => "Verwaltung Hauptseite",
"External wikis" => "Externe Wikis",
"Mods Admin" => "MODs verwalten",
"UsrMenu" => "Benutzermenü",
"Click here to manage your personal menu" => "Klicke hier hier zum Ädern Deines persönlichen Menüs",
"Quick edit a Wiki page" => "Schnellbearbeitung einer Wiki-Seite",
"Language: " => "Sprache: ",
"Sort posts by:" => "Einträge sortieren nach:",
"read more" => "mehr lesen",
"Pass" => "Passwort",
"HTTPS login" => "HTTPS-Login",
"System Admin" => "System Verwaltung",
"some text" => "Ein Text",
"Creates a box with the data" => "Erzeugt eine Box mit den Daten",
"creates a title bar" => "erzeugt einen Titelbalken",
"creates a table" => "erzeugt eine Tabelle",
"makes a horizontal rule" => "erzeugt einen horizontalen Balken",
"page|desc" => "Seite|Beschr.",
"displays an image" => "zeigt ein Bild an",
"Non cacheable images" => "Ungecachte Bilder",
"height width desc link and align are optional" => "height width desc link und align sind optional",
"Wiki File Attachments" => "Wiki Dateianhänge",
"displays rss feed with id=n maximum=m items" => "RSS-Feed mit id=n maximum=m Einträgen",
"Will be replaced by the actual value of the dynamic content block with id=n" => "Wird mit dem tatsächlichen Wert des dynamischen Inhaltsblocks mit id=n ersetzt",
"Misc" => "Verschiedenes",
"If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "Bevor Du Deine Tikiinstallation aktualisierst, lies bitte die <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">Upgradeanweisungen</a>",
"any file" => "beliebige Dateien",
"podcast (audio)" => "PodCast (Audio)",
"podcast (video)" => "PodCast (Video)",
"Listing configuration" => "Listenkonfiguration",
"Number of columns per page when listing categories" => "Spalten pro Seite in Kategorienliste",
"No tabs" => "Tabs abschalten",
"Global Features" => "Übergreifende Einstellungen",
"More Functionality" => "Aktivierung weiterer Komponenten",
"UI Enhancements" => "Darstellungsoptimierungen",
"Member of the default group of creator can modify items?" => "Mitglieder aus der Standardgruppe des Erstellers dürfen Einträge ändern?",
"Parent category" => "Übergeordnete Kategorie",
"Most visited sub-categories" => "Meistbesuchte Unterkategorien",
"Category description" => "Kategoriebeschreibung",
"Random sub-categories" => "Zufällige Unterkategorien",
"Allow sites in this category" => "Links in dieser Kategorie erlauben",
"Show number of sites in this category" => "Anzahl der Links in dieser Kategorie anzeigen",
"Subcategories" => "Unterkategorien",
"Admin related categories" => "Verwandte Kategorien verwalten",
"Add a related category" => "Verwandte Kategorie hinzufügen",
"Related categories" => "Verwandte Kategorien",
"Add a Category" => "Kategorie hinzufügen",
"in current category" => "in der ausgewählten Kategorie",
"Total categories" => "Alle Kategorien",
"Click to Navigate" => "Zum Navigieren anklicken",
"Focus:" => "Fokus:",
"Note: Maximum image size is limited to" => "Hinweis: Die Hochladegröße ist beschränkt auf",
"Daily report from" => "Tägliche Zusammenfassung vom",
"Monthly report from" => "Monatliche Zusammenfassung vom",
"Weekly report from" => "Wöchentliche Zusammenfassung vom",
"added the file" => "fügte die Datei",
"added the image" => "fügte das Bild",
"added the article" => "fügte den Artikel",
"added the wiki page" => "fügte die Wikiseite",
"to the category" => "zur folgenden Kategorie hinzu:",
"removed the image" => "entfernte das Bild",
"removed the wiki page" => "entfernte die Wikiseite",
"from the category" => "von der Kategorie",
"Importer log" => "Importer-Log",
"Welcome to the Tiki installation and upgrade script" => "Willkommen zur Tiki Installations- und Upgrade-Seite",
"Select your language" => "Wähle Deine Sprache",
"Tiki is software distributed under the LGPL license" => "Tiki Software wird unter der LGPL Lizenz vertriebenen",
"This installer will perform some basic checks automatically" => "Dieser Installer wird einige Prüfungen automatisch ausführen",
"Tiki has not detected your PHP memory_limit" => "Tiki hat Dein PHP memory_limit nicht erkannt",
"This probably means you have no set limit (all is well)" => "Das heißt wahrscheinlich, dass Du überhaupt kein Limit gesetzt hast (dann ist alles in Ordnung)",
"Tiki has detected your PHP memory limit at" => "Tiki hat Deine PHP Speichergrenze erkannt",
"Tiki has detected your PHP memory_limit at" => "Tiki hat Deine PHP Speichergrenze erkannt",
"Test email" => "Testemail",
"Email address to send test to" => "Emailadresse, an die die Testemail gesandt wird",
"Review your mail log for details" => "Prüfe Dein Emaillog für Details",
"Tiki detected" => "Tiki erkannte",
"Tiki was not able to detect the GD library" => "Tiki konnte die GD Bibliothek finden",
"This is normal for a new installation" => "Dies ist normal für eine neue Installation",
"Database type" => "Datenbanktyp",
"Database name" => "Datenbankname",
"For Oracle" => "Für Oracle",
"Admin email" => "Adminemail",
"Adding a new host" => "Einen neuen Host hinzufügen",
"/" => "/",
"Fatal error: cannot execute automatic activity \$activityId" => "Fataler Fehler: Kann automatische Aktivitä \$activityId nicht ausführen",
"Fatal error: setting next activity to an unexisting activity" => "Fataler Fehler: Folgeaktivität wurde auf einen ungültigen Eintrag gesetzt",
"Fatal error: trying to send an instance to an activity but no transition found" => "Fataler Fehler: Versuch, eine Instanz an eine Aktivität zu schicken, jedoch ist kein Übergang definiert",
"Process does not have a start activity" => "Prozess besitzt keine Startaktivität",
"Process does not have exactly one end activity" => "Prozess besitzt nicht genau eine Endaktivität",
"End activity is not reachable from start activity" => "Endaktivitä von der Startaktivität aus nicht erreichbar",
"is interactive but has no role assigned" => "ist interaktiv, besitzt aber keine zugeordnete Rolle",
"is standalone but has transitions" => "ist alleinstehend, besitzt aber Übergänge",
"Role" => "Rolle",
"Process %d has been activated" => "Prozess %d wurde aktiviert",
"Process %d has been deactivated" => "Prozess %d wurde deaktiviert",
"Process %s %s imported" => "Prozess %s %s importiert",
"Process %s removed" => "Prozess %s entfernt",
"Process %s has been updated" => "Prozess %s wurde aktualisiert",
"Process %s has been created" => "Prozess %s wurde erstellt",
"Any 2 versions" => "zwei beliebige Versionen",
"english" => "englisch",
"1 day" => "1 Tag",
"1 week" => "1 Woche",
"1 month" => "1 Monat",
"Just Tiki" => "Nur über Tiki",
"Tiki and PEAR::Auth" => "Tiki und PEAR::Auth",
"choose a group ..." => "Gruppe auswählen ...",
"%s enabled" => "%s aktiviert",
"%s disabled" => "%s deaktiviert",
"Charts" => "Hitlisten",
"Forums last topics" => "Neueste Forenthemen",
"games" => "Spiele",
"drawing not found" => "Zeichnung nicht gefunden",
"heads and cells separated by ~|~" => "Kopfzellen und sonstige Felder werden getrennt durch ~|~",
"Quicktags" => "Schnelltags",
"best regards" => "Gruss",
"your Tikiwiki" => "Dein Tiki",
"Tiki User Registration Request" => "Anfrage Tiki Benutzerregistrierung",
"Tiki email notification" => "Tiki Emailbenachrichtigung",
"Your Tiki account information for %s" => "Deine Tikikontoinformationen für %s",
"TikiWiki Assistant" => "Tiki Assistent",
"Recently visited pages" => "Zuletzt besuchte Seiten",
"Last `\$module_rows` Sites" => "Die letzten `\$module_rows` Links",
"Last Sites" => "Neueste Links",
"Directory Stats" => "Verzeichnisstatistik",
"Sites to validate" => "Zu überprüfende Links",
"Visited links" => "Besuchte Links",
"Top \$module_rows Sites" => "Die \$module_rows Top-Links",
"Top Sites" => "Beliebteste Links",
"file galleries" => "Dateiarchive",
"Last `\$module_rows` forum posts" => "`\$module_rows` neueste Forenbeiträge",
"Last `\$module_rows` forum topics" => "Die letzten `\$module_rows` Forenthemen",
"Last `\$module_rows` actions" => "Letzte `\$module_rows` Aktionen",
"Last `\$module_rows` articles" => "Die letzten `\$module_rows` Artikel",
"Last articles" => "Neueste Beiträge",
"Last `\$module_rows` blog posts" => "Die letzten `\$module_rows` Blog-Einträge",
"Last `\$module_rows` Created blogs" => "Die letzten `\$module_rows` angelegten Blogs",
"Last `\$module_rows` Created FAQs" => "Die letzten `\$module_rows` angelegten FAQs",
"Last `\$module_rows` Created Quizzes" => "Die letzten `\$module_rows` angelegte Quiz",
"Last `\$module_rows` modified file galleries" => "Die letzten `\$module_rows` geänderten Dateiarchive",
"Last `\$module_rows` Files" => "Die letzten `\$module_rows` Dateien",
"Last `\$module_rows` galleries" => "Die letzten `\$module_rows` Galerien",
"Last galleries" => "Neueste Galerien",
"Last `\$module_rows` changes" => "Die letzten `\$module_rows` Änderungen",
"Last `\$module_rows` Modified Items" => "Die letzten `\$module_rows` geänderten Einträge",
"Last `\$module_rows` Modified blogs" => "Die letzten `\$module_rows` geänderten Blogs",
"Last `\$module_rows` submissions" => "Die letzten `\$module_rows` Einreichungen",
"Last `\$module_rows` Items" => "Die letzten `\$module_rows` Einträge",
"Menu" => "Menü",
"New Messages" => "Neue Nachrichten",
"New Message" => "Neue Nachricht",
"Top `\$module_rows` articles" => "Die `\$module_rows` Top-Artikel",
"Top `\$module_rows` File Galleries" => "Die `\$module_rows` Top-Dateiarchive",
"Top `\$module_rows` files" => "Die `\$module_rows` Top-Dateien",
"Top `\$module_rows` games" => "Die `\$module_rows` Top-Spiele",
"Top games" => "Top-Spiele",
"Top `\$module_rows` galleries" => "Die `\$module_rows` Top-Galerien",
"Top `\$module_rows` Images" => "Die `\$module_rows` Top-Bilder",
"Top `\$module_rows` Pages" => "Die `\$module_rows` Top-Seiten",
"Top `\$module_rows` Quizzes" => "Die `\$module_rows` Top-Quiz",
"Most `\$module_rows` visited blogs" => "Die `\$module_rows` meistbesuchten Blogs",
"Top `\$module_rows` Visited FAQs" => "Die `\$module_rows` meistbesuchten FAQs",
"Translations that need improvement" => "Verbesserungswürdige Übersetzungen",
"Whats related" => "Verwandte Objekte",
"Last `\$module_rows` wiki comments" => "Die letzten `\$module_rows` Wiki-Kommentare",
"show structures" => "Strukturen anzeigen",
"hide structures" => "Strukturen ausblenden",
"My workflow" => "Mein Workflow",
"enable cool sites" => "'Coole Links' aktivieren",
"Main Features" => "Hauptkomponenten",
"Action log setting" => "Aktionslogeinstellungen",
"Copyright System" => "Copyrightsystem",
"Copyright system" => "Copyrightsystem",
"User interface enhancement features" => "Darstellungsoptimierungen",
"JavaScript popup date selector" => "JavaScript-Aufwahlbox für Datum",
"PhpLayers Dynamic menus" => "Dynamische PHPLayer Menüs",
"Allow users to activate fullscreen mode" => "Benutzer darf Fullscreen-Anzeige aktivieren",
"Experimental Features" => "Experimentelle Funktionen",
"HTML Purifier (Content is cleaned to XHTML 1.1 Strict on each save)" => "HTML Purifier (Inhalte werden beim Speichern auf XHTML 1.1 gesäubert)",
"Drawings" => "Zeichnungen",
"Friendship" => "Freundschaft",
"Games" => "Spiele",
"Administration Features" => "Administrative Einstellungen",
"Banning System" => "Benutzersperrsystem",
"Tiki action calendar" => "Tiki-Aktionskalender",
"User Features" => "Benutzereinstellungen",
"Workflow engine" => "Workflow Engine",
"Unknown/Other" => "unbekannt/anderes",
"(some Unix MTA)" => "(Unix)",
"Tikiwiki.org help" => "Tikiwiki.org Hilfe",
"Store session data in database" => "Session-Daten in Datenbank speichern",
"Default timezone" => "Standardzeitzone",
"New password" => "Neues Passwort",
"Reg users can change theme" => "Reg. Benutzer können Theme ändern",
"Slideshows theme" => "Diaschau-Theme",
"Site logo background color" => "Logo-Hintergrundfarbe",
"Site logo title (on mouse over)" => "Mouseover-Titel des Logos",
"at top of page" => "am Seitenanfang",
"at top of center column" => "am Anfang der Mittelspalte",
"entire location" => "komplette Position",
"page name" => "Seitenname",
"installed" => "installiert",
"hits" => "Zugriffe",
"Individual cache" => "Individuelle Cache",
"Assign permissions automatically" => "Berechtigungen automatisch vergeben",
"recommended for best performance" => "empfohlen für beste Performance",
"image gal" => "Bildergalerie",
"file gal" => "Dateiarchiv",
"Admin chart items" => "Einträge in Hitlisten verwalten",
"Edit Chart" => "Hitliste bearbeiten",
"Chart items" => "Einträge in Hitlisten",
"No items defined yet" => "Noch keine Einträge vorhanden",
"Add or edit a chart" => "Hitliste hinzufügen/bearbeiten",
"Users can vote for only one item from this chart per period" => "Benutzer können nur für einen Eintrag pro Abstimmungszeitraum stimmen",
"Prevent users from voting for the same item more than once" => "Benutzer können nur einmal überhaupt pro Hitliste abstimmen",
"Users can suggest new items" => "Benutzer können neue Einträge vorschlagen",
"Auto validate user suggestions" => "Vorschläge der Benutzer automatisch validieren",
"Ranking shows" => "Rangliste zeigt",
"All items" => "Alle Einträge",
"Top 10 items" => "Top 10 Einträge",
"Top 20 items" => "Top 20 Einträge",
"Top 40 items" => "Top 40 Einträge",
"Top 50 items" => "Top 50 Einträge",
"Top 100 items" => "Top 100 Einträge",
"Top 250 items" => "Top 250 Einträge",
"Voting system" => "Wahlsystem",
"Vote items" => "Einträge wählen",
"Rank 1..5" => "Rang 1..5 vergeben",
"Rank 1..10" => "Rang 1..10 vergeben",
"Ranking frequency" => "Wahlhäufigkeit",
"Realtime" => "Echtzeit",
"Each 5 minutes" => "alle 5 Minuten",
"Show Average" => "Zeige Durchschnitt",
"Show Votes" => "Zeige Stimmen",
"Use Cookies for unregistered users" => "Bei nicht angemeldeten Benutzern Cookies verwenden",
"Users can vote again after" => "Benutzer können erneut abstimmen nach",
"Anytime" => "jederzeit",
"Ranks" => "Ränge",
"No charts defined yet" => "Noch keine Hitlisten definiert",
"Admin drawings" => "Zeichnungen verwalten",
"Available drawings" => "Verfügbare Zeichnungen",
"no display" => "keine Anzeige",
"Available polls" => "Verfügbare Abstimmungen",
"Random image from" => "Zufälliges Bild aus",
"Dynamic content blocks" => "Dynamische Inhaltsblöcke",
"phpLayersMenus" => "phpLayerMenüs",
"Banner zones" => "Bannerzonen",
"Admin Quicktags" => "Quicktags verwalten",
"Create/Edit QuickTags" => "QuickTags hinzufügen/bearbeiten",
"Insert (use 'text' for figuring the selection)" => "Einfügen ('text' um die Auswahl zu markieren)",
"Path to the tag icon" => "Symbol-Pfad",
"Admin RSS Modules" => "RSS-Module verwalten",
"This page is to configure settings of RSS feeds read/imported by Tiki. To generate/export RSS feeds, look for \"RSS feeds\" on the admin panel, or" => "Auf dieser Seite werden die RSS Feeds konfiguriert, die von Tiki gelesen und importiert werden. Zum generieren/exportieren von RSS Feeds \"RSS Feeds\" im Menü wählen oder",
"show feed title" => "Feed-Titel anzeigen",
"show publish date" => "Veröffentlichungsdatum anzeigen",
"Note: You have to import security data via installation process (<a href=\"tiki-install.php\">tiki-install.php</a>). Import the *secdb* update files in your database." => "Bemerkung: Sicherheitsdaten werden nur über den Installationsvorgang importiert (<a href=\"tiki-install.php\">tiki-install.php</a>). Importiere die *secdb* Update Dateien in Deine Datenbank.",
"Templates compiler" => "Templatecompiler",
"Compile" => "Kompilieren",
"Members List" => "Mitgliederliste",
"Rejected users" => "Abgelehnte Benutzer",
"Set the default group of the selected users to" => "Setzt die Standardgruppe der markierten Benutzer auf",
"available files" => "verfügbare Dateien",
"Old password" => "Altes Passwort",
"creates the editable drawing foo" => "erzeugt die bearbeitbare Zeichnung foo",
"table" => "Tabelle",
"external link" => "externen Verweis",
"heading1" => "Überschrift1",
"title bar" => "Titelbalken",
"box" => "Box",
"rss feed" => "RSS-Feed",
"dynamic content" => "Dynamischer Inhalt",
"tagline" => "Tagline",
"center text" => "Text zentrieren",
"colored text" => "Farbiger Text",
"dynamic variable" => "dynamische Variable",
"special chars" => "Sonderzeichen",
"special characters" => "Sonderzeichen",
"Questions per page" => "Fragen pro Seite",
"Activity completed" => "Aktivität erfolgreich beendet",
"Admin process activities" => "Prozessaktivitäten verwalten",
"Add or edit an activity" => "Aktivität hinzufügen/bearbeiten",
"activity" => "Aktivität",
"interactive" => "interaktiv",
"Years" => "Jahre",
"Months" => "Monate",
"Add transitions" => "Übergänge hinzufügen",
"Add transition from:" => "Übergang hinzufügen von:",
"Add transition to:" => "Übergang hinzufügen nach:",
"No roles associated to this activity" => "Keine Rollen mit dieser Aktivität verbunden",
"Add Role" => "Rolle hinzufügen",
"Add New" => "Neu hinzufügen",
"Process activities" => "Prozessaktivitäten",
"Interactive" => "Interaktiv",
"Automatic" => "Automatisch",
"Manual" => "Manuell",
"inter" => "Interaktiv",
"(no roles)" => "(keine Rollen)",
"No activities defined yet" => "Noch keine Aktivitäten definiert",
"Process Transitions" => "Prozessübergänge",
"List of transitions" => "Übergangsliste",
"No transitions defined yet" => "Keine Übergänge definiert",
"Add a transition" => "Übergang hinzufügen",
"This process is invalid" => "Dieser Prozess ist ungültig",
"List of processes" => "Prozessliste",
"Inactive" => "inaktiv",
"val" => "aktiv",
"Active Process" => "Aktiver Prozess",
"Invalid Process" => "Ungültiger Prozess",
"Valid Process" => "Gültiger Prozess",
"Activities" => "Aktivitäten",
"No processes defined yet" => "Noch keine Prozesse definiert.",
"Admin instance" => "Instanzen verwalten",
"Process:" => "Prozess:",
"Instance" => "Instanz",
"exception" => "Fehler",
"completed" => "erledigt",
"Don't move" => "Nicht verschieben",
"Act status" => "Act Status",
"Ended" => "Beendet",
"Property" => "Eigenschaft",
"run instance" => "Instanz starten",
"Admin processes" => "Prozesse verwalten",
"Add or edit a process" => "Prozess hinzufügen/bearbeiten",
"Process Name" => "Prozessname",
"ver:" => "Version:",
"is active?" => "ist aktiv?",
"Or upload a process using this form" => "Oder Prozess über dieses Formular hochladen",
"Admin process roles" => "Prozessrollen verwalten",
"Add or edit a role" => "Rolle hinzufügen/bearbeiten",
"Process roles" => "Prozessrollen",
"No roles defined yet" => "Keine Rollen definiert",
"Map users to roles" => "User zu Rollen zuordnen",
"map" => "zuordnen",
"Map groups to roles" => "Gruppen zu Rollen zuordnen",
"No roles are defined yet so no roles can be mapped" => "Keine Rollen definiert, daher keine Zuordnungen möglich",
"List of mappings" => "Zuordnungen",
"No mappings defined yet" => "Keine Zuordnungen definiert",
"Admin process sources" => "Prozessquellcode verwalten",
"select source" => "Quellcode auswählen",
"Set next user" => "Setze nächsten Benutzer",
"Map process roles" => "Prozessrollen zuordnen",
"Admin Processes" => "Prozesse verwalten",
"Admin Activities" => "Aktivitäten verwalten",
"Admin Roles" => "Rollen verwalten",
"Edit this Process" => "Prozess bearbeiten",
"Monitor Activities" => "Aktivitäten überwachen",
"List of activities" => "Aktivitätsliste",
"Proc" => "Prozesse",
"auto" => "Automatisch",
"int" => "Interaktiv",
"routing" => "Routing",
"Instances" => "Instanzen",
"run" => "starten",
"run activity" => "Aktivität starten",
"monitor processes" => "Prozesse überwachen",
"monitor activities" => "Aktivitäten überwachen",
"monitor instances" => "Instanzen überwachen",
"monitor workitems" => "Workitems überwachen",
"Monitor Instances" => "Instanzen überwachen",
"List of instances" => "Instanzliste",
"No instances created yet" => "noch keine Instanzen erstellt",
"Monitor Processes" => "Prozesse überwachen",
"processes" => "Prozesse",
"being run" => "ausgeführt",
"Exceptions" => "Fehler",
"instance" => "Instanz",
"My activities" => "Meine Aktivitäten",
"Current Activity" => "Aktuelle Aktivität",
"Assigned To" => "Zugewiesen zu Benutzer",
"abort instance" => "Instanz abbrechen",
"release instance" => "Instanz freigeben",
"No activities found" => "Keine Aktivitäten gefunden",
"My instances" => "Meine Instanzen",
"No instances found" => "Keine Instanzen gefunden",
"User Activities" => "Benutzeraktivitäten",
"process" => "Prozess",
"user processes" => "Benutzerprozesse",
"user activities" => "Benutzeraktivitäten",
"user instances" => "Benutzerinstanzen",
"User Instances" => "Benutzerinstanzen",
"No instances defined yet" => "Noch keine Instanzen definiert.",
"User Processes" => "Benutzerprozesse",
"Install &amp; Update Profile" => "Installiere &amp; Update Profil",
"Bare-bones default install" => "Schlanke Standard-Installation",
"Personal Blog and Profile" => "Persönliches Blog und Profil",
"Company Intranet" => "Firmenintranet",
"Use cache for external pages" => "Cache für externe Seiten benutzen",
"All games are from" => "Alle Spiele von",
"visit the site for more games and fun" => "Besuche die Site für weitere Spiele und Unterhaltung.",
"Upload a game" => "Ein Spiel hochladen",
"Upload a new game" => "Ein neues Spiel hochladen",
"Flash binary (.swf or .dcr)" => "Flash-Binary (.swf oder .dcr)",
"Thumbnail (if the game is foo.swf the thumbnail must be named foo.swf.gif or foo.swf.png or foo.swf.jpg)" => "Thumbnail (Wenn das Spiel foo.swf heißt, muss der Thumbnail foo.swf.gif, foo.swf.png oder foo.swf.jpg heißen)",
"Edit game" => "Spiel bearbeiten",
"Played" => "Gespielt",
"If you can't see the game then you need a flash plugin for your browser" => "Wenn Du das Spiel nicht sehen kannst, benötigst Du ein Flash-Plugin für Deinen Browser.",
"Accepted requests" => "Bearbeitete Anfragen",
"since" => "seit",
"Assigned items" => "Zugewiesene Einträge",
"Select news group" => "Newsgroup auswählen",
"Back to servers" => "Zurück zur Serverübersicht",
"Msgs" => "Nachrichten",
"Back to groups" => "Zurück zu Gruppen",
"Save position" => "Position speichern",
"Reading article from" => "Artikel lesen aus",
"Back to list of articles" => "Zurück zur Artikelübersicht",
"Configure news servers" => "Newsserverkonfiguration",
"Configure Newsreader" => "Newsreader konfigurieren",
"Select a news server to browse" => "Auswahl des Newsservers",
"server" => "Server",
"News server" => "Newsserver",
"Current permissions for this object" => "Aktuelle Berechtigungen für dieses Objekt",
"No category permissions; global permissions apply" => "Keine Kategorieberechtigungen vergeben; Globale Berechtigungen greifen",
"Tiki Shoutbox" => "Tiki-Shoutbox",
"big grin" => "grinsend",
"cry" => "weinend",
"eek" => "erschrocken",
"evil" => "böse",
"lol" => "lachend",
"smile" => "lächelnd",
"surprised" => "überrascht",
"arrow" => "Pfeil",
"Current folder" => "Aktueller Ordner",
"This user is your friend" => "Dieser Benutzer ist Dein Freund",
"Your personal Wiki Page" => "Deine persönliche Wiki-Seite",
"Confirm new password" => "Passwort bestätigen",
"Current password (required)" => "aktuelles Passwort (erforderlich)",
"Edit Items" => "Einträge bearbeiten",
"List Charts" => "Hitlisten anzeigen",
"Last Chart" => "Neueste Hitliste",
"Previous Chart" => "Vorherige Hitliste",
"Chart created" => "Hitliste erstellt",
"Next Chart" => "Nächste Hitliste",
"chg" => "Änderung",
"Avg" => "Durchschnitt",
"Next chart will be generated on" => "Nächste Hitliste wird erstellt am",
"View or vote items not listed in the chart" => "Einträge anzeigen oder für welche stimmen, die nicht in dieser Hitliste vorhanden sind",
"Select something to vote on" => "Etwas auswählen, für das Du abstimmen willst",
"Item information" => "Info über Eintrag",
"Dif" => "Diff",
"Best Position" => "Beste Position",
"Vote this item" => "Für diesen Eintrag stimmen",
"Highest" => "Höchste",
"RSS settings" => "RSS-Feed Einstellungen",
"No chart indicated" => "Keine Hitliste angegeben",
"No category indicated" => "Keine Kategorie angegeben",
"No process indicated" => "Kein Prozess angegeben",
"Activity name already exists" => "Aktivität mit diesem Namen existiert bereits",
"indicates if the process is active. Invalid processes cant be active" => "zeigt an ob der Prozess aktiv ist. Ungültige Prozesse können nicht aktiviert werden",
"No instance indicated" => "Keine Instanz angegeben",
"No activity indicated" => "Keine Aktivität angegeben",
"The process name already exists" => "Dieser Prozessname ist bereits vergeben",
"Process already exists" => "Dieser Prozess existiert schon",
"You cant execute this activity" => "Du kannst diese Aktivität nicht ausführen",
"No title indicated" => "Kein Titel angegeben",
"No comment indicated" => "Kein Kommentar angegeben",
"No date indicated" => "Kein Datum angegeben",
"The thumbnail name must be" => "Der Thumbnail-Name muss sein",
"No server indicated" => "Kein Server angegeben",
"Cannot connect to" => "Konnte Verbindung nicht herstellen zu",
"Missing information to read news (server,port,username,password,group) required" => "Zum Lesen von News fehlen Daten (Server,Port,Username,Passwort,Gruppe)",
"Cannot get messages" => "Kann keine Nachrichten abholen",
"A password and your IP address reminder email has been sent " => "Eine Erinnerungsnachricht mit dem Passwort (und Deiner IP Adresse) wurde verschickt ",
"Select the installation profile to use. This profile will populate the database." => "Wähle ein Installationsprofil. Das Profil definiert, wie die Datenbank bestückt wird.",
"Profiles can be used to pre-configure your site with specific features and settings." => "Je nach Profil wird Tiki unterschiedlich, mit mehr oder weniger aktivieren Funktionen installiert.",
"Visit <a href=\"http://profiles.tiki.org\" target=\"_blank\">http://profiles.tiki.org</a> for more information." => "Weitere Informationen dazu finden sich auf <a href=\"http://profiles.tiki.org\" target=\"_blank\">http://profiles.tiki.org</a>.",
"Validate and Continue" => "Prüfen und weiter",
"Create a new database (clean install) with profile:" => "Neue Datenbank über Profil anlegen (nur bei Neuinstallation):",
"See the documentation for <a target=\"_blank\" href=\"http://profiles.tiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Description of available profiles.\">descriptions of the available profiles." => "Siehe auch Dokumentation unter <a target=\"_blank\" href=\"http://profiles.tiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Beschreibung der Profile\">Beschreibung der Profile.",
"Tiki Calendar" => "Tikikalender",
"Admin Menu" => "Menü verwalten",
"RSS Modules" => "RSS-Module",
"Import PHPWiki Dump" => "PHPWiki Dump importieren",
"Current events" => "Aktuelle Termine",
"User informations" => "Benutzerinfos",
"Group informations" => "Gruppeninfos",
"Email This Post" => "Diesen Beitrag verschicken",
"RSS feeds" => "RSS-Feeds",
"Use titles in blog posts" => "Überschriften in Blog-Einträgen verwenden",
"Send blog post" => "Sende Blog-Eintrag",
"A link to this post was sent to the following addresses:" => "Ein Link auf diesen Eintrag wurde an folgende Adressen verschickt:",
"Send post to this addresses" => "Eintrag an diese Adressen verschicken",
"List of email addresses separated by commas" => "Liste der Emailadressen (kommagetrennt)",
"Compose Message" => "Nachricht erstellen",
"%s <b>%s</b> successfully deleted." => "%s <b>%s</b> erfolgreich gelöscht.",
"database queries used in" => "Datenbankaufrufe in",
"Dynamic content" => "Dynamische Inhalte",
"View submissions" => "Einreichungen ansehen",
"Tiki version" => "Tiki-Version",
"List Forums" => "Foren auflisten",
"Submit a new link" => "Neuen Link einreichen",
"preference name" => "Einstellungsname",
"Your preferred language" => "Meine bevorzugte Sprache",
"Annoncieren" => "Ankündigung",
"Description text is wiki-parsed" => "Wiki-Parser auch für Beschreibung benutzen",
"Prevent flooding" => "Flooding verhindern",
"Minimum time between posts" => "Minimale Zeit zwischen zwei Beiträgen",
"Moderator user" => "Moderator",
"Moderator group" => "Moderatorengruppe",
"Only allow replies to the first message (flat forum)" => "Nur Anworten auf den ersten Beitrag erlauben (flaches Forum)",
"Send this forums posts to this email" => "Beiträge in diesem Forum an Emailadresse weiterleiten",
"Prune unreplied messages after" => "Nicht beantwortete Nachrichten löschen nach",
"Prune old messages after" => "Alte Nachrichten löschen nach",
"POP3 server" => "POP3 Server",
"Max attachment size (bytes)" => "Maximale Größe (Bytes)",
"Default ordering for topics" => "Standardsortierung für Themen",
"Topics per page" => "Themen pro Seite",
"Default ordering for threads" => "Standardsortierung für Threads",
"Permission denied. You cannot view pages" => "Zugriff verweigert. Du kannst keine Seiten ansehen",
"The copyright management feature is not enabled." => "Das Copyright Management ist nicht aktiviert.",
"Chinese" => "Chinesisch",
"Users can opt-out internal messages" => "Benutzer können Empfang interne Nachrichten deaktivieren",
"Local" => "Lokal",
"Wiki top articles" => "Meistgelesene Artikel",
"Wrong registration code" => "Falscher Registrierungscode",
"Username cannot contain whitespace" => "Benutzername darf keine Leerzeichen enthalten",
"Invalid email address. You must enter a valid email address" => "Emailadresse ungültig. Eine gültige Adresse ist zwingend",
"More info about \$other_user" => "Mehr Info über \$other_user",
"(idle for \$idletime seconds)" => "(nicht am Rechner seit \$idletime Sekunden)",
"complete" => "vollständig",
"articles" => "Artikel",
"Picture" => "Bild",
"Message will be sent to: " => "Die Nachricht wird versandt an: ",
"lib spellcheck" => "Bibliotheks-Rechtschreibprüfung",
"wiki spellcheck" => "Wiki Rechtschreibprüfung",
"blog spellcheck" => "Blog Rechtschreibprüfung",
"theme" => "Theme",
"Please login" => "Bitte anmelden",
"Logged in as" => "Angemeldet als",
"Login as admin" => "Als Admin anmelden",
"Login as" => "Anmelden als",
"Stay in SSL mode" => "In SSL-Modus bleiben",
"Search Wiki PageName" => "Suche Wiki-Seitennamen",
"avatar" => "Avatar",
"Use TikiWiki feature as homepage:" => "Dieses Tiki-Feature als Startseite nutzen:",
"Change password" => "Passwort ändern",
"Tiki and HTTP Auth" => "Tiki und HTTP Auth",
"Duration:" => "Dauer:",
"You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/." => "<a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> muss zuvor nach lib/phpcas/ installiert werden.",
"Available styles:" => "Verfügbare Styles:",
"logged as" => "angemeldet",
"always" => "immer",
"user decides" => "Benutzer entscheidet",
"Use page description:" => "Seitenbeschreibung benutzen:",
"Favicon icon file name:" => "Favicon Dateiname:",
"Favicon icon MIME type:" => "Favicon MIME-Type:",
"Feed for forums" => "Feed für Foren",
"Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting" => "Quote-PlugIn statt &ldquo;&gt;&rdquo; Zitierung verwenden",
"Maximum size" => "Maximale Größe",
"Fix UTF-8 Errors in Tables" => "UTF-8 Fehler in Tabellen korrigieren",
"Warning: Make a backup of your Database before using this function!" => "Warnung: Erstelle ein Datenbankbackup bevor Du diese Funktion benutzt!",
"Warning: If you try to convert large tables, raise the maximum execution time in your php.ini!" => "Warnung: Wenn Du grosse Tabellen konvertieren willst, erhöhe die \"maximum execution time\" in Deiner php.ini!",
"This function converts ISO-8859-1 encoded strings in your tables to UTF-8" => "Diese Funktion konvertiert ISO-8859-1 codierte Strings in UTF-8",
"This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1" => "Notwendig, wenn Du mit Tiki &lt; v1.8.4 und ISO-8859-1 Codierung gearbeitet hast.",
"Investigate" => "Untersuchen",
"Fix it" => "Korrigieren",
"Includes" => "Beinhaltet",
"List of types" => "Liste vorhandener Typen",
"Assign Perms to this Group" => "Dieser Gruppe Rechte zuweisen",
"If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. " => "Falls Du Bilder benutzen möchtest, speicher bitte den Beitrag und hänge dann erst Bilder an. Benutze das &lt;img&gt; Schnipsel um hochgeladene Bilder einzubinden oder benutze die Bilder-URL im WYSIWYG-Editor. ",
"Save and Exit" => "Speichern und verlassen",
"Watch Only This Category" => "Nur diese Kategorie beobachten",
"Watch This Category and Their Descendants" => "Diese Kategorie und deren Nachfolger beobachten",
"Stop Watching Only This Category" => "Diese Kategorie nicht mehr beobachten",
"Stop Watching This Category and Their Descendants" => "Diese Kategorie und deren Nachfolger nicht mehr beobachten",
"Assign permissions to category" => "Berechtigungen für Kategorie zuweisen",
"Current permissions for this category" => "Aktuelle Berechtigungen für diese Kategorie",
"Remove from this Category Only" => "Nur von dieser Kategorie entfernen",
"Remove from this Category &amp; all its Children" => "Von dieser und allen Unterkategorien entfernen",
"Assign permissions" => "Berechtigungen vergeben",
"to group" => "zu Gruppe",
"this category &amp; all its children" => "diese und alle Unterkategorien",
"this category only" => "nur für diese Kategorie",
"Assigning permissions for <b>all children</b> is recommended for best performance." => "für beste Performance werden Berechtigungen für <b>diese und alle Unterkategorien</b> empfohlen",
"Allow other user to post in this blog" => "Anderer Benutzer darf in dieses Blog eintragen",
"Upload picture" => "Bild hochladen",
"Regex search " => "Suche mit regulären Ausdrücken ",
"Replace with" => "Ersetzen durch",
"Import page" => "Seite importieren",
"License" => "Lizenz",
"Important" => "Wichtig",
"My Footnotes" => "Fußnoten",
"Use rating" => "Bewertung erlauben",
"Install Profile" => "Profil installieren",
"Your registration code:" => "Dein Registrierungscode:",
"Registration code" => "Registrierungscode",
"Repeat password" => "Passwort wiederholen",
"Remove page" => "Seite entfernen",
"Change administrative info" => "Einstellungen übernehmen",
"Editing" => "Bearbeiten",
"Editing posts" => "Beiträge bearbeiten",
"Merge into topic" => "Zusammenführen mit Thema",
"Your admin password has been changed" => "Das AdministratorPasswort wurde geändert",
"No Errors detected" => "Keine Fehler gefunden",
"Permission denied you can not view this section" => "Zugriff verweigert. Du kannst diesen Bereich nicht betrachten",
"This feature has been disabled" => "Diese Funktion wurde deaktiviert",
"You do not have permissions to edit banners" => "Du hast keine Berechtigung, Banner zu bearbeiten",
"Permission denied you cannot create or edit blogs" => "Zugriff verweigert. Du kannst weder Blogs erstellen noch bearbeiten",
"Permission denied you cannot edit images" => "Zugriff verweigert. Du kannst keine Bilder bearbeiten",
"Permission denied you cannot send submissions" => "Zugriff verweigert. Du kannst keine Einreichungen senden",
"Permission denied. You cannot view pages like this page" => "Zugriff verweigert. Du kannst Seiten wie diese nicht ansehen",
"You cannot admin blogs" => "Du kannst Blogs nicht verwalten",
"Permission denied you cannot remove submissions" => "Zugriff verweigert. Du kannst Einreichungen nicht entfernen",
"Permission denied you cannot approve submissions" => "Zugriff verweigert. Du kannst Einreichungen nicht freigeben",
"You do not have permissions to view the layers" => "Keine Berechtigung zum Betrachten der Layer",
"You do not have permissions to delete a file" => "Keine Berechtigung zum Löschen einer Datei",
"You do not have permissions to create a directory" => "Keine Berechtigung zum Erstellen eines Verzeichnisses",
"You do not have permissions to delete a directory" => "Keine Berechtigung zum Löschen eines Verzeichnisses",
"You do not have permissions to create an index file" => "Keine Berechtigung zum Anlegen einer Indexdatei",
"Must be logged to use this feature" => "Für diese Funktion musst Du angemeldet sein",
"Permission denied you cannot browse this page history" => "Zugriff verweigert. Du kannst diese Seitenhistorie nicht ansehen",
"Permission denied you cannot remove versions from this page" => "Zugriff verweigert. Du kannst Versionen dieser Seite nicht entfernen",
"Permission denied you cannot rollback this page" => "Zugriff verweigert. Rollback für diese Seite nicht erlaubt.",
"You are not logged in and no user indicated" => "Du bist nicht eingeloggt und es wurde auch kein Benutzer angegeben",
"Permission denied you cannot remove the post" => "Zugriff verweigert. Du kannst den Eintrag nicht entfernen",
"Wiki page name to include" => "Wikiseite für Einbindung",
"Name of the quoted person" => "Name der zitierten Person",
"wrote" => "schrieb",
"separated by " => "getrennt durch ",
"Comments found" => "Kommentare gefunden",
"Content of the field" => "Inhalt des Feldes",
"Display the user\\'s real name instead of login name" => "Anzeige des richtigen Namens statt des Loginnamens",
"Allow full screen" => "Vollbild erlauben",
"Number of characters for username and password input fields" => "Anzahl Zeichen für Benutzername und Passwort",
"Site logo, title and subtitle" => "Logo, Titel und Untertitel der Seite",
"Displays a Wiki page" => "Anzeige einer Wiki-Seite",
"Add existing page as a translation of this page" => "Eine vorhandene Seite zu den Übersetzungen hinzufügen.",
"Select from available options.." => "Wähle aus den verfügbaren Optionen.",
"No language is assigned to this page" => "Keine Sprache für diese Seite festgelegt",
"Please select a language before performing translation" => "Bitte lege eine Sprache für die Seite fest, bevor Du die Übersetzung beginnst",
"Preview your changes in a separate window" => "Vorschau Deiner Änderungen in einem extra Fenster",
"Preview your changes" => "Vorschau Deiner Änderungen",
"Save the page" => "Seite speichern",
"Cancel the edit, you will lose your changes" => "Bearbeitung abbrechen, Deine Änderungen werden verworfen",
"<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer" => "<strong>Vorschau</strong> oder <strong>Speichern</strong> startet die Zeit für die Bearbeitung neu",
"instead" => "stattdessen",
"Translate from" => "Übersetzen aus",
"Translate to" => "Übersetzen auf",
"Monitor this page" => "Diese Seite beobachten",
"Translation request" => "Anfrage Übersetzung",
"Page saved (version %d)" => "Seite gespeichert (Version %d)",
"Creation date (desc)" => "Erstellungsdatum (absteigend)",
"Use different URL as home page" => "Andere URL als Startseite benutzen",
"Create new file gallery" => "Neues Dateiarchiv anlegen",
"duplicate" => "Kopie",
"Edit blog" => "Blog bearbeiten",
"preference" => "Einstellung",
"Contact us" => "Kontaktiere uns",
"Create new forum" => "Neues Forum anlegen",
"Duplicate forum" => "Forum duplizieren",
"CSS file" => "CSS-Datei",
"Create blog" => "Blog erstellen",
"Create new structure" => "Neue Struktur anlegen",
"name (desc)" => "Name (absteigend)",
"name (asc)" => "Name (aufsteigend)",
"hits (desc)" => "Zugriffen (absteigend)",
"hits (asc)" => "Zugriffen (aufsteigend)",
"creation date (desc)" => "Erstelldatum (absteigend)",
"creation date (asc)" => "Erstelldatum (aufsteigend)",
"last updated (desc)" => "letzte Änderung (absteigend)",
"last updated (asc)" => "letzte Änderung (aufsteigend)",
"Max impressions" => "Max. Aufrufe",
"Show the banner only between these dates" => "Banner nur während dieser Tage zeigen",
"From date" => "Von Datum",
"To date" => "Bis Datum",
"Show the banner only in this hours" => "Banner nur während dieser Stunden zeigen",
"Show the banner only on" => "Zeige das Banner nur auf",
"Mon" => "Mo",
"Tue" => "Di",
"Wed" => "Mi",
"Thu" => "Do",
"Fri" => "Fr",
"Sat" => "Sa",
"Sun" => "So",
"Dynamic content system" => "Dynamischer Inhalt",
"Create page" => "Seite erstellen",
"Edit task" => "Aufgabe bearbeiten",
"No arguments indicated" => "Es wurden keine Argumente angegeben",
"preview" => "Vorschau",
"Passcode to register (not your user password)" => "Passcode zum Registrieren (nicht Dein Benutzerpasswort)",
"Started" => "Gestartet",
"Days online" => "Tage online",
"Best day" => "Bester Tag",
"Worst day" => "Schlechtester Tag",
"Database search" => "Datenbanksuche",
"Activity=" => "Aktivität=",
"List Movies" => "Filme auflisten",
"Choose a movie" => "Film auswählen",
"recorded" => "gespeichert",
"viewed" => "angesehen",
"Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki-Aktionen außer 'hat angesehen' werden immer gespeichert, gehen aber nicht in Berichte ein",
"Interval in witch you want to get the reports" => "Intervall in dem Dir Berichte gesendet werden sollen",
"... and is displayed by default" => "... und wird standardmäßig angezeigt",
"Powered by TikiWiki" => "Powered by TikiWiki",
"find" => "Suchen",
"prev" => "vorh.",
"next" => "nächstes",
"TikiWiki will check for updates when you access the main Administration page" => "TikiWiki prüft auf neue Version, wenn Du die Admin Hauptseite aufrufst",
"Default RDF version" => "Welchs Protokoll benutzen",
"No pages links to" => "Keine Seitenverweise auf",
"Anti-Bot verification code" => "Anti-Bot Prüfcode",
"Random Image" => "Zufallsbild",
"Comment on the selected post" => "Diesen Beitrag kommentieren",
"Enter your name" => "Gib Deinen Namen ein",
"Hi {\$mail_user} has sent you this link:" => "Hallo, {\$mail_user} hat Dir diesen Link zugesandt:",
"A new article was submitted by {\$mail_user} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "Es wurde ein neuer Artikel von {\$mail_user} auf {\$mail_site} um {\$mail_date|tiki_short_datetime} erstellt",
"The page {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Die Seite {\$mail_page} wurde von {\$mail_user} um {\$mail_date|tiki_short_datetime} geändert",
"referenced by" => "Referenzen",
"references" => "Verweise",
"View Comments" => "Kommentare ansehen",
"Blog name" => "Blog Name",
"Enlarge area height" => "Höhe vergrößern",
"Reduce area height" => "Höhe verringern",
"Date and Time Formats" => "Datums- und Zeitformate",
"Trackers with mirror tables" => "Tracker mit Mirror Tabellen",
"Use trackers with mirror tables" => "Tracker mit Mirror Tabellen benutzen",
"Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki" => "Die Werte für jeden Tracker werden in der separaten Tabelle gespeichert, diese können ausserhalb von Tiki angepasst werden.",
"Validate choice" => "Auswahl überprüfen",
"Custom Categories" => "Persönliche Kategorien",
"Use wysiwyg editor" => "WYSIWYG Editor benutzen",
"Use normal editor" => "Standardeditor benutzen",
"Admin external wikis" => "Externe Wikis verwalten",
"There are individual permissions set for this forum" => "Für dieses Forum sind individuelle Rechte gesetzt",
"Add a subscription newsletters" => "Abo für Rundbrief hinzufügen",
"Articles (subs)" => "Artikel (eingereicht)",
"Tbl vis" => "in Liste",
"isMain" => "Hauptfeld",
"Upload image for this post" => "Bild für diesen Beitrag hochladen",
"Spellcheck" => "Rechtschreibprüfung",
"You can include the image in a tiki page using one of these lines" => "Das Bild kann mit den folgenden Zeilen in eine Wikiseite eingebunden werden",
"Current heading" => "Aktueller Kopfbereich",
"Number of posts to show" => "Anzahl der anzuzeigenden Einträge",
"You can include the image in an HTML page using one of these lines" => "Das Bild kann wie folgt in eine HTML-Seite eingebunden werden",
"Edit or ex/import Languages" => "Sprachen erstellen oder im/exportieren",
"Edit and create Languages" => "Sprachen erstellen/bearbeiten",
"Edit and create languages" => "Sprachen erstellen/bearbeiten",
"Create Language" => "Sprache erstellen",
"Shortname" => "Kurzname",
"Longname" => "Voller Name",
"View object" => "Objekt betrachten",
"Case Insensitivity" => "Groß- und Kleinschreibung nicht beachten",
"Im- Export languages" => "Sprachen im/exportieren",
"Select the language to Import" => "Sprache für Import wählen",
"Modify String in Source Language" => "Ändere String in Quellsprache",
"Original String" => "Originaler String",
"New String" => "Neuer String",
"has been updated" => "wurde aktualisiert",
"Close this window" => "Dieses Fenster schließen",
"Special" => "Spezial",
"Tikiwiki Mods" => "Tiki Mods",
"on:" => "Am:",
"On:" => "Am:",
"Viewing blog post" => "Betrachte Blog-Eintrag",
"Return to blog" => "Zurück zum Blog",
"Register this site at tiki.org" => "Diese Site auf tiki.org registrieren",
"On this page you can make your tiki site known to tiki.org. It will get shown there in a list of known tiki sites." => "Hier kannst Du Deine Site bei tiki.org bekanntmachen. Dort wird sie in die Liste der bekannten Tiki-Sites eingetragen.",
"public" => "öffentlich",
"Check this box if you really want to delete your account" => "Hier auswählen, wenn Dein Konto wirklich gelöscht werden soll",
"Reports are disabled, only standard reporting is available" => "Berichte sind ausgeschaltet, nur Standart-Reporting ist verfügbar",
"Sites you are watching" => "Seiten, die Du beobachtest",
"This page is being edited by" => "Diese Seite wird gerade bearbeitet von",
"Proceed at your own peril" => "Weiter auf eigene Gefahr",
"Permission denied you cannot post" => "Zugriff verweigert. Du kannst nicht posten",
"Tiki RSS feed for blog: " => "Tiki RSS Feed von Weblog: ",
"Shortname must be 2 Characters" => "Kurzname muß zwei Zeichen lang sein",
"You must provide a longname" => "Langer Name muß angegeben werden",
"Language created" => "Sprache erstellt",
"Access Denied" => "Zugriff verweigert",
"Cannot rename page maybe new page already exists" => "Kann die Seite nicht umbenennen, evtl. existiert der Name schon",
"A SheetId is required." => "Eine SheetId muß angegeben werden.",
"No Additionnal Sort" => "Keine weitere Sortierung",
"Development Notice" => "Hinweis Entwicklung",
"Developers mailing list" => "Developer Mailing Liste",
"External Feeds" => "Externe Feeds",
"feature loadbalancer deaktiviert" => "Eigenschaft Lastregler deaktiviert",
"List Entries" => "Einträge auflisten",
"Magyar" => "Ungarisch",
"Modify the look &amp; feel (logo, theme, etc.)" => "Passe das Look & Feel an (Logo, Theme, etc.)",
"Portuguese" => "Portugiesisch",
"Show interactive translation settings" => "Zeige die Einstellungen zur interaktiven Übersetzung",
"Upload Media" => "Medien hochladen",
"You could use your server name for this. e.g. i18n.tiki.org" => "Du könntest Deinen Servernamen hierfür benutzen, z.B.: i18n.tiki.org",
"Url to go to when clicking on a username" => "URL wenn man auf einen Benutzernamen klickt",
"Url a user is redirected to after account validation" => "URL auf die ein Benutzer weitergeleitet wird, nachdem sein Konto validiert wurde",
"Url an anonymous is redirected when page not found" => "URL auf die ein anonymer Benutzer weitergeleitet wird, wenn die Seite nicht gefunden wird",
"Administrator, can manage users groups and permissions, Hotwords and all the weblog features" => "Administrator, kann Benutzergruppen und Rechte verwalten, Hotwords und alle Weblog Funktionen",
"Can add objects in the category" => "Kann Objekte einer Kategorie zuweisen",
"Can admin shoutbox (Edit/remove msgs)" => "Kann Shoutbox verwalten (Bearbeiten/Entfernen von Nachrichten)",
"Can admin the cms" => "Kann das CMS verwalten",
"Can administrate group webmail accounts" => "Kann Gruppenwebmail-Konten verwalten",
"Can administrate personal webmail accounts" => "Kann persönliche Webmail Accounts verwalten",
"Can change the categories on the object" => "Kann die Kategorien eines Objektes ändern",
"Can change tracker closed items" => "Kann geschlossene Trackereinträge ändern",
"Can change tracker pending items" => "Kann snstehende Trackereinträge ändern",
"Can delete his own account" => "Kann sein eigenes Konto löschen",
"Can invit users by email, and include them in groups" => "Kann Benutzer per Email einladen und sie zu Gruppen hinzufügen",
"Can promote a page (email, twitter, facebook)" => "Kann eine Seite bewerben (Email, Twitter, Facebook)",
"Can report msgs to moderator" => "Kann Nachrichten dem Moderator melden",
"Can save a CSV backup of entire trackers" => "Kann ein CSV Backup von allen Trackern erstellen",
"Can use the Tiki Importer" => "Kann den Tiki Importer benutzen",
"Can validate submited links" => "Kann eingereichte Links bestätigen/zulassen",
"Can view Tikiwiki tools calendar" => "Kann den Tikiwiki Werkzeuge Kalender einsehen",
"Can view trackers closed items" => "Kann geschlossene Trackereinträge einsehen",
"Can view trackers pending items" => "Kann noch anstehende Trackereinträge ansehen",
"Submited articles automatically approved" => "Eingereichte Artikel werden automatisch bestätigt",
"Submited links are valid" => "Eingereichte Links werden automatisch bestätigt",
"User can Administer Modules" => "Benutzer kann Module verwalten",
"User Levels" => "Benutzerlevel",
"Custom code" => "Angepasster Code",
"Disable javascript" => "Schalte javascript ab",
"Allow users to define icons for menus entries" => "Benutzer dürfen eigene Symbole für Menüeinträge definieren",
"Automatically creates a link to the appropriate SourceForge object" => "Erstellt automatisch einen Link zum passenden SourceForge Objekt",
"Filter on the group" => "Filter auf die Gruppe",
"4 comments" => "4 Kommentare bis jetzt",
"egyéb dolgok" => "egyéb dolgok - das war Ungarisch",
"Groups watching this blog:" => "Gruppen, die diesen Blog beobachten:",
"i18n stuff" => "i18n Zeugs",
"In Progress" => "In Bearbeitung",
"komment 2" => "Kommentar 2",
"Includes an article's content within the page." => "Fügt den Inhalt eines Artikels in eine Seite ein.",
"Mass Search and Replace" => "Massensuchen und Ersetzen",
"Minimum 5 characters long" => "Mindestens 5 Zeichen lang",
"Nicht heruntergealden seit" => "Nicht heruntergeladen seit",
"Show pages in user's preferred language" => "Zeige Seiten in der vom Benutzer präferierten Sprache",
"Show user's real name instead of login (when possible)" => "Zeige anstelle des Loginnamens den Echtnamen des Benutzers an (wenn möglich)",
"Tracker Item Statuses" => "Status von Trackereinträgen",
"Tracker Item Statuses::In Progress" => "Trackereinträge: In Arbeit",
"Tracker Item Statuses::New" => "Trackereinträge: Neu",
"Tracker Item Statuses::Open" => "Trackereinträge: Offen",
"\n\t\t\t\t\t\t\t\t\t seconds (0 = no auto refresh)\n\t\t\t\t\t\t\t\t" => "Sekunden",
"\n\t\t\t\t\t\t\t\t\tArticle\n\t\t\t\t\t\t\t\t\tReview\n\t\t\t\t\t\t\t\t\tEvent\n\t\t\t\t\t\t\t\t\tClassified\n\t\t\t\t\t\t\t" => "Artikel Rezension Ereignis Vertraulich",
"\n            \t      Simple\n\t    \t      Advanced\n\t              " => "Einfach Fortgeschritten",
"Action Calendar" => "Aktionenkalendar",
"Add a directory category now" => "Füge jetzt eine Verzeichniskategorie hinzu",
"Administrator and accounts managers." => "Administrator und Kontenverwalter.",
"Assign User BarthJ to Groups" => "Weise Benutzer BarthJ einer Gruppe zu",
"b" => "B",
"Benutzer-Information" => "Benutzerinformation",
"Català" => "Katalan",
"Dansk" => "Dänisch",
"Display image informations in a mouseover box" => "Zeige Bildinformationen in einer Mouseoverbox",
"editors</span>" => "Editoren</span>",
"Español" => "Spanisch",
"feature" => "Funktion",
"file" => "Datei",
"Français" => "Französisch",
"Group watches for this category" => "Gruppenüberwachung für diese Kategorie hinzufügen",
"i18n status" => "i18n Status",
"If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image." => "Wenn eingetragen, wird ein Bild mit der angegebenen Größe (in Pixeln) zu jedem Artikel angezeigt (wenn zutreffend). Das eigene Bild des Artikels wird benutzt, mit Rückgriff auf das Bild des Artikelthemas.",
"Include a page's content." => "Den Inhalt einer Seite einbeziehen",
"info" => "Info",
"Italiano" => "Italienisch",
"Kb" => "kB",
"Must be in tikiroot/ or tikiroot/img/wiki_up" => "Datei muss daher in tikiroot/ oder tikiroot/img/wiki_up sein",
"Nederlands" => "Niederlande",
"Nicht heruntergeladen seit" => "nicht heruntergeladen seit",
"Português Brasileiro" => "Brazilianisches Portugiesisch",
"Public users not logged" => "Öffentliche Benutzer, die nicht eingeloggt sind.",
"registered</span>" => "registriert</span>",
"Shoutbox Words Verwaltung" => "Verwaltung Shoutboxwörter",
"Show user's real name instead of login in autocomplete selector in messaging feature" => "Zeige den Echtnamen des Benutzers anstelle seines Loginnamen im Autovervollständigenfeld in der Nachrichtenfunktion",
"Show user's real name instead of login in autocomplete selector in trackers feature" => "Zeige bei Trackern in Autovervollständigenfeldern den Echtnamen des Benutzers anstelle seines Logins an",
"Suchmaschinen-freundliche URLs" => "Suchmaschinenfreundliche URLs",
"Svenska" => "Schwedisch",
"Techbereiche" => "Textbereiche",
"trackeritem" => "Trackereintrag",
"user can register this site with socialnetworks" => "Benutzer kann die Site bei sozialen Netzwerken registrieren",
"Users logged into the system" => "Benutzer die eingeloggt sind",
"Watch all categories" => "Beobachte alle Kategorien",
"Watch this category and its descendants" => "Beobachte diese Kategorie und alle Unterkategorien",
"Webservice Registration" => "Webdienstregistrierung",
"You can only use one payment Paypal or Cclite or Tiki User Credits" => "Du kannst nur ein Bezahlsystem wählen, Paypal, Cclite oder Tiki User Credits",
"User name" => "Benutzername",
"Color codes parts of the page like 'Track changes' in Office programs." => "Färbt Bereiche in einer Seite farblich ein; wie etwa \"Änderungen verfolgen\" in Office Programmen.",
"Displays a link that allows to go back in the browser history" => "Zeigt einen Link an, der es erlaubt in der Browserhistorie zurück zu gehen.",
"Includes the list of events from a calendar in the page." => "Erzeugt eine Liste von Ereignissen von einem Kalender.",
"Displays a link to a file (either from the file gallery or an attachment to a wiki page) and can display an image attachment. For more than one file from file galleries, or more optional information shown from the file/s, use the plugin FILES instead" => "Zeigt einen Link auf eine Datei (entweder aus dem Dateiarchiv oder einem Anhang einer Wikiseite) und kann einen Bildanhang anzeigen. Für mehr als eine Datei oder mehr zusätzliche Informationen von der/den Datei/en, benutze das Plugin DATEIEN",
"List of groups including a group" => "Liste der Gruppen, die eine Gruppe beeinhalten",
"groups" => "Gruppen",
"name" => "Name",
"Allow to send mail to groups or user or email directly" => "Erlaube eine Email an Gruppen oder Benutzer oder direkt an eine Emailadresse zu senden",
"fancy" => "ausgefallen",
"Reply to" => "Antwort an",
"Added last hour" => "neu in letzter Stunde",
"Added last 24 hours" => "neu in den letzten 24 Stunden",
"Added since the beginning of the day" => "neues von Heute",
"Added last 7 days" => "neu in den letzten 7 Tagen",
"Added last month" => "neu im letzten Monat",
"Tabset name" => "Tabset-Name",
"Tab titles" => "Tab-Titel",
"A new version of Tiki, <b>6.1beta1</b>, is available. You are currently running <b>6.1alpha1</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>." => "Es ist eine neue Tiki Version <b>6.1beta1</b>, verfügbar. Aktuell benutzt Du <b>6.1alpha1</b>. Bitte besuche <a href=\"http://tiki.org/Download\">tiki.org/Download</a>.",
"Can admin attachments to wiki pages" => "Kann Anhänge an Wiki-Seiten verwalten",
"Allow HTML in menu items (INSECURE)" => "Erlaube HTML in Menüeinträgen (UNSICHER)",
"Block Quote" => "Blocksatz",
"Show only these categories and the immediate child categories of these. Example values: 3,5,6." => "Zeige nur diese Kategorien und deren unmittelbare Kinderkategorieren. Beispielswerte; 3,5,6.",
"Create/edit dsn" => "DSN hinzufügen/bearbeiten",
"Included group, group users and emails will be refreshed at each newsletter sending" => "Beinhaltene Gruppen, Gruppenmitglieder und Emails werden bei jedem gesendeten Rundbrief aktualisiert",
"Allow posting of comments as Anonymous" => "Unbekannte Benutzer dürfen kommentieren",
"Add or edit a rule" => "Regel hinzufügen/bearbeiten",
"AuthorName" => "Autor",
"Header Rows" => "Kopfzeilen",
"Footer Rows" => "Fußzeilen",
"Wiki Parse Values" => "Wiki Parser Werte",
// ### end of unused words

// ### start of untranslated words
// ### uncomment value pairs as you translate
// "This forum is flat and doesn't allow replies to other replies" => "This forum is flat and doesn't allow replies to other replies",
// "Tiki was unable to retrieve login data from the database " => "Tiki was unable to retrieve login data from the database ",
// "The following error message was returned" => "The following error message was returned",
// "Things to check" => "Things to check",
// "Are your database login credentials correct" => "Are your database login credentials correct",
// "Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Did you complete the <a href='tiki-install.php' >Tiki Installer",
// "Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information" => "Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information",
// "ID" => "ID",
// "Name" => "Name",
// "Backlinks" => "Backlinks",
// "Explorer" => "Explorer",
// "Slideshow" => "Slideshow",
// "Afghanistan" => "Afghanistan",
// "Aland Islands" => "Aland Islands",
// "Aland_Islands" => "Aland_Islands",
// "Albania" => "Albania",
// "Algeria" => "Algeria",
// "American Samoa" => "American Samoa",
// "American_Samoa" => "American_Samoa",
// "Andorra" => "Andorra",
// "Angola" => "Angola",
// "Anguilla" => "Anguilla",
// "Antigua" => "Antigua",
// "Argentina" => "Argentina",
// "Armenia" => "Armenia",
// "Aruba" => "Aruba",
// "Australia" => "Australia",
// "Austria" => "Austria",
// "Azerbaijan" => "Azerbaijan",
// "Bahamas" => "Bahamas",
// "Bahrain" => "Bahrain",
// "Bangladesh" => "Bangladesh",
// "Barbados" => "Barbados",
// "Belarus" => "Belarus",
// "Belgium" => "Belgium",
// "Belize" => "Belize",
// "Benin" => "Benin",
// "Bermuda" => "Bermuda",
// "Bhutan" => "Bhutan",
// "Bolivia" => "Bolivia",
// "Bosnia and Herzegovina" => "Bosnia and Herzegovina",
// "Bosnia_and_Herzegovina" => "Bosnia_and_Herzegovina",
// "Botswana" => "Botswana",
// "Bouvet Island" => "Bouvet Island",
// "Bouvet_Island" => "Bouvet_Island",
// "Brazil" => "Brazil",
// "British Indian Ocean Territory" => "British Indian Ocean Territory",
// "British Virgin Islands" => "British Virgin Islands",
// "British_Indian_Ocean_Territory" => "British_Indian_Ocean_Territory",
// "British_Virgin_Islands" => "British_Virgin_Islands",
// "Brunei" => "Brunei",
// "Bulgaria" => "Bulgaria",
// "Burkina Faso" => "Burkina Faso",
// "Burkina_Faso" => "Burkina_Faso",
// "Burundi" => "Burundi",
// "Cambodia" => "Cambodia",
// "Cameroon" => "Cameroon",
// "Canada" => "Canada",
// "Cape Verde" => "Cape Verde",
// "Cape_Verde" => "Cape_Verde",
// "Catalan Countries" => "Catalan Countries",
// "Catalan_Countries" => "Catalan_Countries",
// "Cayman Islands" => "Cayman Islands",
// "Cayman_Islands" => "Cayman_Islands",
// "Central African Republic" => "Central African Republic",
// "Central_African_Republic" => "Central_African_Republic",
// "Chad" => "Chad",
// "Chile" => "Chile",
// "China" => "China",
// "Christmas Island" => "Christmas Island",
// "Christmas_Island" => "Christmas_Island",
// "Cocos Islands" => "Cocos Islands",
// "Cocos_Islands" => "Cocos_Islands",
// "Colombia" => "Colombia",
// "Comoros" => "Comoros",
// "Congo Democratic" => "Congo Democratic",
// "Congo" => "Congo",
// "Congo_Democratic" => "Congo_Democratic",
// "Cook Islands" => "Cook Islands",
// "Cook_Islands" => "Cook_Islands",
// "Costa Rica" => "Costa Rica",
// "Costa_Rica" => "Costa_Rica",
// "Croatia" => "Croatia",
// "Cuba" => "Cuba",
// "Cyprus" => "Cyprus",
// "Czech Republic" => "Czech Republic",
// "Czech_Republic" => "Czech_Republic",
// "Denmark" => "Denmark",
// "Djibouti" => "Djibouti",
// "Dominica" => "Dominica",
// "Dominican Republic" => "Dominican Republic",
// "Dominican_Republic" => "Dominican_Republic",
// "Ecuador" => "Ecuador",
// "Egypt" => "Egypt",
// "El Salvador" => "El Salvador",
// "El_Salvador" => "El_Salvador",
// "Equatorial Guinea" => "Equatorial Guinea",
// "Equatorial_Guinea" => "Equatorial_Guinea",
// "Eritrea" => "Eritrea",
// "Estonia" => "Estonia",
// "Ethiopia" => "Ethiopia",
// "Europe" => "Europe",
// "Falkland Islands" => "Falkland Islands",
// "Falkland_Islands" => "Falkland_Islands",
// "Faroe Islands" => "Faroe Islands",
// "Faroe_Islands" => "Faroe_Islands",
// "Federated States of Micronesia" => "Federated States of Micronesia",
// "Federated_States_of_Micronesia" => "Federated_States_of_Micronesia",
// "Fiji" => "Fiji",
// "Finland" => "Finland",
// "France" => "France",
// "French Guiana" => "French Guiana",
// "French Polynesia" => "French Polynesia",
// "French Southern Territories" => "French Southern Territories",
// "French_Guiana" => "French_Guiana",
// "French_Polynesia" => "French_Polynesia",
// "French_Southern_Territories" => "French_Southern_Territories",
// "Gabon" => "Gabon",
// "Gambia" => "Gambia",
// "Georgia" => "Georgia",
// "Ghana" => "Ghana",
// "Gibraltar" => "Gibraltar",
// "Greece" => "Greece",
// "Greenland" => "Greenland",
// "Grenada" => "Grenada",
// "Guadeloupe" => "Guadeloupe",
// "Guam" => "Guam",
// "Guatemala" => "Guatemala",
// "Guernsey" => "Guernsey",
// "Guinea Bissau" => "Guinea Bissau",
// "Guinea" => "Guinea",
// "Guinea_Bissau" => "Guinea_Bissau",
// "Guyana" => "Guyana",
// "Haiti" => "Haiti",
// "Heard Island and McDonald Islands" => "Heard Island and McDonald Islands",
// "Heard_Island_and_McDonald_Islands" => "Heard_Island_and_McDonald_Islands",
// "Honduras" => "Honduras",
// "Hong Kong" => "Hong Kong",
// "Hong_Kong" => "Hong_Kong",
// "Hungary" => "Hungary",
// "Iceland" => "Iceland",
// "India" => "India",
// "Indonesia" => "Indonesia",
// "Iran" => "Iran",
// "Iraq" => "Iraq",
// "Ireland" => "Ireland",
// "Isle of Man" => "Isle of Man",
// "Israel" => "Israel",
// "Italy" => "Italy",
// "Ivory Coast" => "Ivory Coast",
// "Ivory_Coast" => "Ivory_Coast",
// "Jamaica" => "Jamaica",
// "Japan" => "Japan",
// "Jersey" => "Jersey",
// "Jordan" => "Jordan",
// "Kazakstan" => "Kazakstan",
// "Kenya" => "Kenya",
// "Kiribati" => "Kiribati",
// "Kuwait" => "Kuwait",
// "Kyrgyzstan" => "Kyrgyzstan",
// "Laos" => "Laos",
// "Latvia" => "Latvia",
// "Lebanon" => "Lebanon",
// "Lesotho" => "Lesotho",
// "Liberia" => "Liberia",
// "Libya" => "Libya",
// "Liechtenstein" => "Liechtenstein",
// "Lithuania" => "Lithuania",
// "Luxemburg" => "Luxemburg",
// "Macao" => "Macao",
// "Macedonia" => "Macedonia",
// "Madagascar" => "Madagascar",
// "Malawi" => "Malawi",
// "Malaysia" => "Malaysia",
// "Maldives" => "Maldives",
// "Mali" => "Mali",
// "Malta" => "Malta",
// "Marshall Islands" => "Marshall Islands",
// "Marshall_Islands" => "Marshall_Islands",
// "Martinique" => "Martinique",
// "Mauritania" => "Mauritania",
// "Mauritius" => "Mauritius",
// "Mayotte" => "Mayotte",
// "Mexico" => "Mexico",
// "Moldova" => "Moldova",
// "Monaco" => "Monaco",
// "Mongolia" => "Mongolia",
// "Montenegro" => "Montenegro",
// "Montserrat" => "Montserrat",
// "Morocco" => "Morocco",
// "Mozambique" => "Mozambique",
// "Myanmar" => "Myanmar",
// "Namibia" => "Namibia",
// "Nauru" => "Nauru",
// "Nepal" => "Nepal",
// "Netherlands Antilles" => "Netherlands Antilles",
// "Netherlands" => "Netherlands",
// "Netherlands_Antilles" => "Netherlands_Antilles",
// "New Caledonia" => "New Caledonia",
// "New Zealand" => "New Zealand",
// "New_Caledonia" => "New_Caledonia",
// "New_Zealand" => "New_Zealand",
// "Nicaragua" => "Nicaragua",
// "Niger" => "Niger",
// "Nigeria" => "Nigeria",
// "Niue" => "Niue",
// "Norfolk Island" => "Norfolk Island",
// "Norfolk_Island" => "Norfolk_Island",
// "North Korea" => "North Korea",
// "North_Korea" => "North_Korea",
// "Northern Mariana Islands" => "Northern Mariana Islands",
// "Northern_Mariana_Islands" => "Northern_Mariana_Islands",
// "Norway" => "Norway",
// "Oman" => "Oman",
// "Pakistan" => "Pakistan",
// "Palau" => "Palau",
// "Palestine" => "Palestine",
// "Panama" => "Panama",
// "Papua New Guinea" => "Papua New Guinea",
// "Papua_New_Guinea" => "Papua_New_Guinea",
// "Paraguay" => "Paraguay",
// "Peru" => "Peru",
// "Philippines" => "Philippines",
// "Pitcairn" => "Pitcairn",
// "Poland" => "Poland",
// "Portugal" => "Portugal",
// "Puerto Rico" => "Puerto Rico",
// "Puerto_Rico" => "Puerto_Rico",
// "Quatar" => "Quatar",
// "Republic of Macedonia" => "Republic of Macedonia",
// "Republic_of_Macedonia" => "Republic_of_Macedonia",
// "Reunion" => "Reunion",
// "Romania" => "Romania",
// "Russia" => "Russia",
// "Russian Federation" => "Russian Federation",
// "Russian_Federation" => "Russian_Federation",
// "Rwanda" => "Rwanda",
// "Saint Helena" => "Saint Helena",
// "Saint Kitts and Nevis" => "Saint Kitts and Nevis",
// "Saint Lucia" => "Saint Lucia",
// "Saint Pierre and Miquelon" => "Saint Pierre and Miquelon",
// "Saint_Helena" => "Saint_Helena",
// "Saint_Kitts_and_Nevis" => "Saint_Kitts_and_Nevis",
// "Saint_Lucia" => "Saint_Lucia",
// "Saint_Pierre_and_Miquelon" => "Saint_Pierre_and_Miquelon",
// "Samoa" => "Samoa",
// "San Marino" => "San Marino",
// "San_Marino" => "San_Marino",
// "Sao Tome and Principe" => "Sao Tome and Principe",
// "Sao_Tome_and_Principe" => "Sao_Tome_and_Principe",
// "Saudi Arabia" => "Saudi Arabia",
// "Saudi_Arabia" => "Saudi_Arabia",
// "Senegal" => "Senegal",
// "Serbia" => "Serbia",
// "Seychelles" => "Seychelles",
// "Sierra Leone" => "Sierra Leone",
// "Sierra_Leone" => "Sierra_Leone",
// "Singapore" => "Singapore",
// "Slovakia" => "Slovakia",
// "Slovenia" => "Slovenia",
// "Solomon Islands" => "Solomon Islands",
// "Solomon_Islands" => "Solomon_Islands",
// "Somalia" => "Somalia",
// "South Africa" => "South Africa",
// "South Georgia and South Sandwich Islands" => "South Georgia and South Sandwich Islands",
// "South Korea" => "South Korea",
// "South_Africa" => "South_Africa",
// "South_Georgia_and_South_Sandwich_Islands" => "South_Georgia_and_South_Sandwich_Islands",
// "South_Korea" => "South_Korea",
// "Spain" => "Spain",
// "Sri Lanka" => "Sri Lanka",
// "Sri_Lanka" => "Sri_Lanka",
// "St Vincent Grenadines" => "St Vincent Grenadines",
// "St_Vincent_Grenadines" => "St_Vincent_Grenadines",
// "Sudan" => "Sudan",
// "Surinam" => "Surinam",
// "Svalbard and Jan Mayen" => "Svalbard and Jan Mayen",
// "Svalbard_and_Jan_Mayen" => "Svalbard_and_Jan_Mayen",
// "Swaziland" => "Swaziland",
// "Sweden" => "Sweden",
// "Switzerland" => "Switzerland",
// "Syria" => "Syria",
// "Taiwan" => "Taiwan",
// "Tajikistan" => "Tajikistan",
// "Tanzania" => "Tanzania",
// "Thailand" => "Thailand",
// "Timor-Leste" => "Timor-Leste",
// "Togo" => "Togo",
// "Tokelau" => "Tokelau",
// "Tonga" => "Tonga",
// "Trinidad Tobago" => "Trinidad Tobago",
// "Trinidad_Tobago" => "Trinidad_Tobago",
// "Tunisia" => "Tunisia",
// "Turkey" => "Turkey",
// "Turkmenistan" => "Turkmenistan",
// "Turks and Caicos Islands" => "Turks and Caicos Islands",
// "Turks_and_Caicos_Islands" => "Turks_and_Caicos_Islands",
// "Tuvalu" => "Tuvalu",
// "US Virgin Islands" => "US Virgin Islands",
// "US_Virgin_Islands" => "US_Virgin_Islands",
// "Uganda" => "Uganda",
// "Ukraine" => "Ukraine",
// "United Arab Emirates" => "United Arab Emirates",
// "United Kingdom" => "United Kingdom",
// "United Nations Organization" => "United Nations Organization",
// "United States Minor Outlying Islands" => "United States Minor Outlying Islands",
// "United States" => "United States",
// "United_Arab_Emirates" => "United_Arab_Emirates",
// "United_Kingdom" => "United_Kingdom",
// "United_Kingdom_-_England_and_Wales" => "United_Kingdom_-_England_and_Wales",
// "United_Kingdom_-_Northern_Ireland" => "United_Kingdom_-_Northern_Ireland",
// "United_Kingdom_-_Scotland" => "United_Kingdom_-_Scotland",
// "United_Nations_Organization" => "United_Nations_Organization",
// "United_States" => "United_States",
// "United_States_Minor_Outlying_Islands" => "United_States_Minor_Outlying_Islands",
// "Uruguay" => "Uruguay",
// "Uzbekistan" => "Uzbekistan",
// "Vanuatu" => "Vanuatu",
// "Vatican" => "Vatican",
// "Venezuela" => "Venezuela",
// "Viet Nam" => "Viet Nam",
// "Viet_Nam" => "Viet_Nam",
// "Wales" => "Wales",
// "Wallis and Futuna" => "Wallis and Futuna",
// "Wallis_and_Futuna" => "Wallis_and_Futuna",
// "Western Sahara" => "Western Sahara",
// "Western_Sahara" => "Western_Sahara",
// "World" => "World",
// "Yemen" => "Yemen",
// "Yugoslavia" => "Yugoslavia",
// "Zambia" => "Zambia",
// "Zimbabwe" => "Zimbabwe",
// "the former Yugoslav Republic of Macedonia" => "the former Yugoslav Republic of Macedonia",
// "the_former_Yugoslav_Republic_of_Macedonia" => "the_former_Yugoslav_Republic_of_Macedonia",
// "Tiki Installer" => "Tiki Installer",
// "MySQL Improved (mysqli)" => "MySQL Improved (mysqli)",
// "MySQL classic (mysql)" => "MySQL classic (mysql)",
// "Email address not valid, test mail not sent" => "Email address not valid, test mail not sent",
// "Email address empty and \"copy\" checkbox not set, test mail not sent" => "Email address empty and \"copy\" checkbox not set, test mail not sent",
// "Test mail from Tiki installer " => "Test mail from Tiki installer ",
// "PHP version" => "PHP version",
// "Server" => "Server",
// "No database name specified" => "No database name specified",
// "Congratulations!\n\nYour server can send emails.\n\n" => "Congratulations!\n\nYour server can send emails.\n\n",
// "Inuktitut" => "Inuktitut",
// "Norwegian Nynorsk" => "Norwegian Nynorsk",
// "Pijin Solomon" => "Pijin Solomon",
// "Sinhala" => "Sinhala",
// "Error line: %d" => "Error line: %d",
// "anonymous" => "anonymous",
// "Blog cannot be found" => "Blog cannot be found",
// "Su" => "Su",
// "Mo" => "Mo",
// "Tu" => "Tu",
// "We" => "We",
// "Th" => "Th",
// "Fr" => "Fr",
// "Sa" => "Sa",
// "in" => "in",
// "Blogs" => "Blogs",
// "FAQs" => "FAQs",
// "Empty captcha value" => "Empty captcha value",
// "You have mistyped the anti-bot verification code. Please try again" => "You have mistyped the anti-bot verification code. Please try again",
// "Failed to validate captcha" => "Failed to validate captcha",
// "Captcha ID field is missing" => "Captcha ID field is missing",
// "Get a visual challenge" => "Get a visual challenge",
// "Get an audio challenge" => "Get an audio challenge",
// "Get a new challenge" => "Get a new challenge",
// "Type the two words" => "Type the two words",
// "Type what you hear" => "Type what you hear",
// "Play sound again" => "Play sound again",
// "Download sound as MP3" => "Download sound as MP3",
// "Incorrect. Try again" => "Incorrect. Try again",
// "survey" => "survey",
// "Please wait %d seconds between posts" => "Please wait %d seconds between posts",
// "Invalid Email" => "Invalid Email",
// "Your message has been queued for approval and will be posted after a moderator approves it" => "Your message has been queued for approval and will be posted after a moderator approves it",
// "This forum is locked" => "This forum is locked",
// "This thread is locked" => "This thread is locked",
// "Those comments are locked" => "Those comments are locked",
// "Expecting \"(\"" => "Expecting \"(\"",
// "Unexpected \"%0\"" => "Unexpected \"%0\"",
// "Expecting \")\"" => "Expecting \")\"",
// "%0 near \"%1\"" => "%0 near \"%1\"",
// "No formula provided" => "No formula provided",
// "Variable not found \"%0\"" => "Variable not found \"%0\"",
// "Unknown operation \"%0\"" => "Unknown operation \"%0\"",
// "Internal error" => "Internal error",
// "User error" => "User error",
// "Plugin argument(s) missing" => "Plugin argument(s) missing",
// "WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: line count mismatch: %s != %s",
// "WikiDiff::_check: failed" => "WikiDiff::_check: failed",
// "WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: edit sequence is non-optimal",
// "WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
// "Cannot open this file" => "Cannot open this file",
// "The upload has not been done" => "The upload has not been done",
// "Reason: The global quota has been reached" => "Reason: The global quota has been reached",
// "Reason: The quota has been reached in \"%s\"" => "Reason: The quota has been reached in \"%s\"",
// "Number of files transferred to the database" => "Number of files transferred to the database",
// "Number of files transferred to the file system" => "Number of files transferred to the file system",
// "Cannot read to this file" => "Cannot read to this file",
// "Old File deleted" => "Old File deleted",
// "This is an approximation based on your server memory limit" => "This is an approximation based on your server memory limit",
// "This is the value of your server's PHP '%s' setting" => "This is the value of your server's PHP '%s' setting",
// "You are alerted by the server " => "You are alerted by the server ",
// "You can check the modifications at : " => "You can check the modifications at : ",
// "You are alerted of a change on " => "You are alerted of a change on ",
// "Blog" => "Blog",
// "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
// "unlink failed" => "unlink failed",
// "The uploaded file exceeds the upload_max_filesize directive in php.ini" => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
// "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
// "The uploaded file was only partially uploaded. Please try again" => "The uploaded file was only partially uploaded. Please try again",
// "No file was uploaded" => "No file was uploaded",
// "Missing a temporary folder" => "Missing a temporary folder",
// "Failed to write file to disk" => "Failed to write file to disk",
// "File upload stopped by extension" => "File upload stopped by extension",
// "Number of page revisions to import (0 for all revisions)" => "Number of page revisions to import (0 for all revisions)",
// "What to do with page names that already exists in TikiWiki" => "What to do with page names that already exists in TikiWiki",
// "Do not import" => "Do not import",
// "Override" => "Override",
// "Append software name as prefix to the page name" => "Append software name as prefix to the page name",
// "<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "<a href=\"tiki-importer.php\">Click here</a> to finish the import process",
// "\$countParsedData pages parsed. Starting to insert those pages into Tiki" => "\$countParsedData pages parsed. Starting to insert those pages into Tiki",
// "Page \${page['name']} sucessfully imported" => "Page \${page['name']} sucessfully imported",
// "Page \${page['name']} NOT imported (there was already a page with the same name)" => "Page \${page['name']} NOT imported (there was already a page with the same name)",
// "Import images and attachments (see documentation for more information)" => "Import images and attachments (see documentation for more information)",
// "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php",
// "Invalid file mime type" => "Invalid file mime type",
// "XML file does not validate against the Mediawiki XML schema" => "XML file does not validate against the Mediawiki XML schema",
// "Mediawiki XML file version \$xmlVersion is not supported" => "Mediawiki XML file version \$xmlVersion is not supported",
// "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments",
// "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) does no exist. Fix the problem or try to import without the attachments" => "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) does no exist. Fix the problem or try to import without the attachments",
// "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) is not writable. Fix the problem or try to import without attachments" => "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) is not writable. Fix the problem or try to import without attachments",
// "Parsing pages" => "Parsing pages",
// "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment" => "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment",
// "Importing attachments" => "Importing attachments",
// "NOT importing file \$fileName as there is already a file with the same name in the destination directory (\$this->attachmentsDestDir)" => "NOT importing file \$fileName as there is already a file with the same name in the destination directory (\$this->attachmentsDestDir)",
// "File \$fileName successfully imported" => "File \$fileName successfully imported",
// "Unable to download file \$fileName. File not found" => "Unable to download file \$fileName. File not found",
// "Error while parsing revision \$i of the page \"\${data['name']}\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)" => "Error while parsing revision \$i of the page \"\${data['name']}\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)",
// "Page \"\${data['name']}\" successfully parsed with \$countRevisions revisions (from a total of \$totalRevisions revisions)" => "Page \"\${data['name']}\" successfully parsed with \$countRevisions revisions (from a total of \$totalRevisions revisions)",
// "Page \"\${data['name']}\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "Page \"\${data['name']}\" is NOT going to be imported. It was not possible to parse any of the page revisions",
// "Admin ' . \$str));\n\n\n\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-list" => "Admin ' . \$str));\n\n\n\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-list",
// "List ' . \$str));\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-view" => "List ' . \$str));\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-view",
// "View ' . \$str));\n\n\n\t\t\t\t} else { // still not set? guess...\n\t\t\t\t\t\$str = str_replace(array('tiki-" => "View ' . \$str));\n\n\n\t\t\t\t} else { // still not set? guess...\n\t\t\t\t\t\$str = str_replace(array('tiki-",
// "ERROR: unable to write to lang/%s/language.php" => "ERROR: unable to write to lang/%s/language.php",
// "The file lang/\$this->lang/language.php is not well formated. Run get_strings.php?lang=\$this->lang and then try to export the translations again" => "The file lang/\$this->lang/language.php is not well formated. Run get_strings.php?lang=\$this->lang and then try to export the translations again",
// "Query point" => "Query point",
// "layer" => "layer",
// "Record" => "Record",
// "No valid ogr2ogr executable" => "No valid ogr2ogr executable",
// "Could not create \$tdo.mif in data directory" => "Could not create \$tdo.mif in data directory",
// "Could not create \$tdo.mid in data directory" => "Could not create \$tdo.mid in data directory",
// "User Map Generated in" => "User Map Generated in",
// "Image Map Generated in" => "Image Map Generated in",
// "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it" => "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it",
// "menu" => "menu",
// "Invalid \"from\" date received" => "Invalid \"from\" date received",
// "Invalid \"to\" date received" => "Invalid \"to\" date received",
// "Sorry, \"from\" date must precede \"to\" date" => "Sorry, \"from\" date must precede \"to\" date",
// "Sorry, no data available for the future" => "Sorry, no data available for the future",
// "for month of" => "for month of",
// "for week of" => "for week of",
// "Integer (i)" => "Integer (i)",
// "Percentage (%)" => "Percentage (%)",
// "Float (f)" => "Float (f)",
// "List (L)" => "List (L)",
// "Daily (+)" => "Daily (+)",
// "Monthly and weekly (@)" => "Monthly and weekly (@)",
// "Weekly (-)" => "Weekly (-)",
// "File %s not found" => "File %s not found",
// "File %s is not a valid archive" => "File %s is not a valid archive",
// "Impossible to open %s : %s" => "Impossible to open %s : %s",
// "The content retrieved at %s is not a list of mods" => "The content retrieved at %s is not a list of mods",
// "Can't chdir to '%s'" => "Can't chdir to '%s'",
// "Description not available" => "Description not available",
// "Theme" => "Theme",
// "Flip" => "Flip",
// "Newsletter subscription information at" => "Newsletter subscription information at",
// "invalid email" => "invalid email",
// "Sending to" => "Sending to",
// "section edit" => "section edit",
// "Payment sent but verification not currently available. (Work in progress)" => "Payment sent but verification not currently available. (Work in progress)",
// "Product" => "Product",
// "Quantity" => "Quantity",
// "Unit Price" => "Unit Price",
// "Cart Check-Out" => "Cart Check-Out",
// "Cclite error" => "Cclite error",
// "No registries specified in admin/payment/cclite" => "No registries specified in admin/payment/cclite",
// "Cclite payment initiated on %0" => "Cclite payment initiated on %0",
// "Connection to cclite server %0 failed for %1<br />\"%2\"" => "Connection to cclite server %0 failed for %1<br />\"%2\"",
// "Tiki credits payment done on %0 for \$amount (using \$creditType)" => "Tiki credits payment done on %0 for \$amount (using \$creditType)",
// "Ajax Xajax" => "Ajax Xajax",
// "Use \"xajax\" library to \"ajaxify\" most Tiki pages" => "Use \"xajax\" library to \"ajaxify\" most Tiki pages",
// "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing" => "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing",
// "Default sort mode for the articles on the article listing" => "Default sort mode for the articles on the article listing",
// "Id" => "Id",
// "Between heading and body" => "Between heading and body",
// "Requires a smaller image for list view" => "Requires a smaller image for list view",
// "Divide articles into multiple pages with pagebreak markers" => "Divide articles into multiple pages with pagebreak markers",
// "Allows users to rate the articles" => "Allows users to rate the articles",
// "List of options available for the rating of articles" => "List of options available for the rating of articles",
// "Allow additional custom fields for article types" => "Allow additional custom fields for article types",
// "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database" => "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database",
// "Tiki" => "Tiki",
// "CAS (Central Authentication Service)" => "CAS (Central Authentication Service)",
// "Shibboleth" => "Shibboleth",
// "phpBB" => "phpBB",
// "Token Access" => "Token Access",
// "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service" => "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service",
// "Token Access Max Timeout" => "Token Access Max Timeout",
// "The maximum duration for which the generated tokens will be valid" => "The maximum duration for which the generated tokens will be valid",
// "Token Access Max Hits" => "Token Access Max Hits",
// "The maximum amount of times a token can be used before it expires" => "The maximum amount of times a token can be used before it expires",
// "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site",
// "Allow users to share their access rights on the current page with a friend when sending the link by email/twitter/facebook. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email/twitter/facebook. Lifespan of the links is defined by the site",
// "phpBB Version" => "phpBB Version",
// "3" => "3",
// "Host" => "Host",
// "Port" => "Port",
// "Write LDAP debug Information in Tiki Logs" => "Write LDAP debug Information in Tiki Logs",
// "Use SSL (ldaps)" => "Use SSL (ldaps)",
// "Use TLS" => "Use TLS",
// "LDAP Bind Type" => "LDAP Bind Type",
// "Default: Anonymous Bind" => "Default: Anonymous Bind",
// "Full: userattr=username,UserDN,BaseDN" => "Full: userattr=username,UserDN,BaseDN",
// "OpenLDAP: cn=username,BaseDN" => "OpenLDAP: cn=username,BaseDN",
// "Active Directory (username@domain)" => "Active Directory (username@domain)",
// "Plain Username" => "Plain Username",
// "Search scope" => "Search scope",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "LDAP version" => "LDAP version",
// "Base DN" => "Base DN",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Group DN" => "Group DN",
// "Group attribute" => "Group attribute",
// "Group description attribute" => "Group description attribute",
// "Group OC" => "Group OC",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "Group attribute in group entry" => "Group attribute in group entry",
// "(Leave this empty if the group name is already given in the user attribute)" => "(Leave this empty if the group name is already given in the user attribute)",
// "Admin user" => "Admin user",
// "Admin password" => "Admin password",
// "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset" => "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset",
// "BigBlueButton" => "BigBlueButton",
// "Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "Integration with the BigBlueButton collaboration server for web conference and screen sharing",
// "Full URL to the BigBlueButton installation" => "Full URL to the BigBlueButton installation",
// "http://host.example.com/" => "http://host.example.com/",
// "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic" => "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic",
// "Custom Site Footer Content" => "Custom Site Footer Content",
// "Module (box) shadow start" => "Module (box) shadow start",
// "Module (box) shadow end" => "Module (box) shadow end",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
// "First year in the dropdown" => "First year in the dropdown",
// "Enter a year or use +/- N to specify a year relative to the current year" => "Enter a year or use +/- N to specify a year relative to the current year",
// "Last year in the dropdown" => "Last year in the dropdown",
// "Choose a smaller number for less noise and easier reading" => "Choose a smaller number for less noise and easier reading",
// "Use LDAP information when creating user in Tiki" => "Use LDAP information when creating user in Tiki",
// "Try automatically to connect SSO" => "Try automatically to connect SSO",
// "Force CAS logout when the user logout from tiki" => "Force CAS logout when the user logout from tiki",
// "Show Alternate Login Method in Header" => "Show Alternate Login Method in Header",
// "Version 1.0" => "Version 1.0",
// "Version 2.0" => "Version 2.0",
// "Hostname" => "Hostname",
// "Hostname of the CAS server" => "Hostname of the CAS server",
// "Port of the CAS server" => "Port of the CAS server",
// "Path for the CAS server" => "Path for the CAS server",
// "CAS Extra Parameter" => "CAS Extra Parameter",
// "Extra Parameter to pass to the CAS Server" => "Extra Parameter to pass to the CAS Server",
// "CAS Authentication Verification Timeout" => "CAS Authentication Verification Timeout",
// "Verify authentication with the CAS server every N seconds. Null value means never reverify" => "Verify authentication with the CAS server every N seconds. Null value means never reverify",
// "2 minutes" => "2 minutes",
// "1 hour" => "1 hour",
// "Permits to show alternate content depending on category of current object" => "Permits to show alternate content depending on category of current object",
// "Limits the visibility of objects to those in these categories. Used mainly for creating workspaces from perspectives" => "Limits the visibility of objects to those in these categories. Used mainly for creating workspaces from perspectives",
// "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default" => "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default",
// "Make sure that the categories on the translations are synchronized when modified on any version" => "Make sure that the categories on the translations are synchronized when modified on any version",
// "Synchronized categories" => "Synchronized categories",
// "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)" => "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)",
// "Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "Automatically geocode items based on category name when categorized in the sub-categories of this category ID",
// "When automatically geocoding items based on category name, replace existing geocode if any" => "When automatically geocoding items based on category name, replace existing geocode if any",
// "When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "When automatically geocoding items based on category name, use randomly approximated location instead of precise location",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
// "Allow users to change the language of the menus and labels" => "Allow users to change the language of the menus and labels",
// "Hide the title field on comments and their replies" => "Hide the title field on comments and their replies",
// "Email field for comments (only for anonymous users)" => "Email field for comments (only for anonymous users)",
// "Website field for comments (only for anonymous users)" => "Website field for comments (only for anonymous users)",
// "Use vote system for comments" => "Use vote system for comments",
// "Allows users with permission tiki_p_vote_comments to vote comments" => "Allows users with permission tiki_p_vote_comments to vote comments",
// "Domain" => "Domain",
// "Include pageviews by the Admin when reporting stats" => "Include pageviews by the Admin when reporting stats",
// "Enable daily reports for new users" => "Enable daily reports for new users",
// "utf-8" => "utf-8",
// "iso-8859-1" => "iso-8859-1",
// "HTML diff" => "HTML diff",
// "Forum" => "Forum",
// "Show the country flag" => "Show the country flag",
// "1" => "1",
// "2" => "2",
// "4" => "4",
// "5" => "5",
// "6" => "6",
// "PHP errors visible to admin only" => "PHP errors visible to admin only",
// "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators" => "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators",
// "Level from which errors should be reported" => "Level from which errors should be reported",
// "Faqs" => "Faqs",
// "Collaboratively authored documents with history of changes" => "Collaboratively authored documents with history of changes",
// "Online diaries or journals" => "Online diaries or journals",
// "Collections of graphic images for viewing or downloading (photo album)" => "Collections of graphic images for viewing or downloading (photo album)",
// "You can use file galleries instead" => "You can use file galleries instead",
// "Uses Google Translate to translate the content of wiki pages to other languages" => "Uses Google Translate to translate the content of wiki pages to other languages",
// "Experimental. This feature is still under development" => "Experimental. This feature is still under development",
// "Database & form generator" => "Database & form generator",
// "Online discussions on a variety of topics. Threaded or flat" => "Online discussions on a variety of topics. Threaded or flat",
// "Computer files, videos or software for downloading. With check-in & check-out (lock)" => "Computer files, videos or software for downloading. With check-in & check-out (lock)",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
// "Brief list of votable options; appears in module (left or right column)" => "Brief list of votable options; appears in module (left or right column)",
// "Content mailed to registered users" => "Content mailed to registered users",
// "Events calendar with public, private and group channels" => "Events calendar with public, private and group channels",
// "Insert, track, and manage advertising banners" => "Insert, track, and manage advertising banners",
// "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions" => "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions",
// "Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score is a game to motivate participants to increase their contribution by comparing to other users",
// "Tiki-indexed Search" => "Tiki-indexed Search",
// "Enables searching for content on the website, using Tiki-managed index" => "Enables searching for content on the website, using Tiki-managed index",
// "Unless you have a reason to, you should use MySQL Full-Text Search feature instead" => "Unless you have a reason to, you should use MySQL Full-Text Search feature instead",
// "Freetags" => "Freetags",
// "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns" => "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns",
// "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis" => "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis",
// "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports" => "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports",
// "Enables internationalization features and multilingual support for then entire site" => "Enables internationalization features and multilingual support for then entire site",
// "FAQ" => "FAQ",
// "Frequently asked questions and answers" => "Frequently asked questions and answers",
// "You can use wiki pages instead" => "You can use wiki pages instead",
// "Questionnaire with multiple choice or open ended question" => "Questionnaire with multiple choice or open ended question",
// "User-submitted Web links" => "User-submitted Web links",
// "Timed questionnaire with recorded scores" => "Timed questionnaire with recorded scores",
// "Simple menu system which can optionally add an external web page in an iframe" => "Simple menu system which can optionally add an external web page in an iframe",
// "Copyright" => "Copyright",
// "The Copyright Management System (or ©MS) is a way of licensing your content" => "The Copyright Management System (or ©MS) is a way of licensing your content",
// "Shoutbox" => "Shoutbox",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
// "Navigable, interactive maps with user-selectable layers" => "Navigable, interactive maps with user-selectable layers",
// "Requires mapserver" => "Requires mapserver",
// "Google Maps" => "Google Maps",
// "Interactive use of Google Maps" => "Interactive use of Google Maps",
// "One-on-one chatting with customer" => "One-on-one chatting with customer",
// "Add a link \"Email this page\" in all the pages" => "Add a link \"Email this page\" in all the pages",
// "Share" => "Share",
// "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums" => "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums",
// "be careful when allowing to anonymous to activate the antibot feature" => "be careful when allowing to anonymous to activate the antibot feature",
// "Static and dynamic HTML content" => "Static and dynamic HTML content",
// "HTML can be used in wiki pages. This is a separate feature" => "HTML can be used in wiki pages. This is a separate feature",
// "Basic form from visitor to admin" => "Basic form from visitor to admin",
// "Minichat" => "Minichat",
// "Real-time group text chatting" => "Real-time group text chatting",
// "An admin must validate a comment before it is visible" => "An admin must validate a comment before it is visible",
// "Comments can be closed (no new comments)" => "Comments can be closed (no new comments)",
// "Allow logged in users to pretend to be anonymous when posting a commment" => "Allow logged in users to pretend to be anonymous when posting a commment",
// "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally" => "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally",
// "Display page description" => "Display page description",
// "Display the page description below the heading when viewing the page" => "Display the page description below the heading when viewing the page",
// "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header" => "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header",
// "Display page ID" => "Display page ID",
// "Display the internal page ID when viewing the page" => "Display the internal page ID when viewing the page",
// "Individual wiki cache" => "Individual wiki cache",
// "Allow users to change the duration of the cache on a per-page basis" => "Allow users to change the duration of the cache on a per-page basis",
// "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled" => "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled",
// "PHPLayers" => "PHPLayers",
// "Will eventually be removed from Tiki. Use CSS menus instead" => "Will eventually be removed from Tiki. Use CSS menus instead",
// "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS" => "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS",
// "CSS Menus (suckerfish)" => "CSS Menus (suckerfish)",
// "Shadowbox / ColorBox" => "Shadowbox / ColorBox",
// "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>" => "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>",
// "Quickperms allow to define classes of privileges and grant them to roles on objects" => "Quickperms allow to define classes of privileges and grant them to roles on objects",
// "Ajax" => "Ajax",
// "Outputs a WAP and VoiceXML version" => "Outputs a WAP and VoiceXML version",
// "Visualize relationships between wiki pages, in a 3D applet" => "Visualize relationships between wiki pages, in a 3D applet",
// "Webmail" => "Webmail",
// "Intertiki" => "Intertiki",
// "Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "Allows several Tiki sites (slaves) to get authentication from a master Tiki site",
// "Mail-in" => "Mail-in",
// "Populate wiki pages and articles by email" => "Populate wiki pages and articles by email",
// "Mindmap" => "Mindmap",
// "Print Indexed" => "Print Indexed",
// "Datasheets with calculations and charts" => "Datasheets with calculations and charts",
// "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor" => "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor",
// "Experimental (Requires AJAX)" => "Experimental (Requires AJAX)",
// "Kaltura" => "Kaltura",
// "Collaborative video editing" => "Collaborative video editing",
// "Users can identify other users as their friends" => "Users can identify other users as their friends",
// "Neglected feature" => "Neglected feature",
// "Deny access to specific users based on username, IP, and date/time range" => "Deny access to specific users based on username, IP, and date/time range",
// "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)",
// "Record domain name of sites that send visitors to this Tiki" => "Record domain name of sites that send visitors to this Tiki",
// "On error, goto the HomePage as configured in Admin->General" => "On error, goto the HomePage as configured in Admin->General",
// "Send/receive wiki pages and articles between Tiki-powered sites" => "Send/receive wiki pages and articles between Tiki-powered sites",
// "Watch language-specific changes within a category" => "Watch language-specific changes within a category",
// "Menu User Levels" => "Menu User Levels",
// "Allows to control the menu options that can be seen by a user" => "Allows to control the menu options that can be seen by a user",
// "Integrator" => "Integrator",
// "TikiTests" => "TikiTests",
// "Permits recording and playback of functional tests" => "Permits recording and playback of functional tests",
// "Tiki will check for updates when you access the main Administration page" => "Tiki will check for updates when you access the main Administration page",
// "Use PEAR::Date library" => "Use PEAR::Date library",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
// "Lookup the user\\'s preferred language through browser preferences" => "Lookup the user\\'s preferred language through browser preferences",
// "Show pages in user\\'s preferred language" => "Show pages in user\\'s preferred language",
// "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page" => "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page",
// "Track translation operations between pages" => "Track translation operations between pages",
// "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users" => "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users",
// "Use the site language as a master language and prevent translations from sending critical updates" => "Use the site language as a master language and prevent translations from sending critical updates",
// "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete" => "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete",
// "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures" => "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures",
// "List all languages as a language option in the page language drop list to see all languages at once" => "List all languages as a language option in the page language drop list to see all languages at once",
// "GZip output" => "GZip output",
// "Compress your pages on-the-fly, if the requesting browser supports this" => "Compress your pages on-the-fly, if the requesting browser supports this",
// "Show clickable URLs to translate the page to another language using Babel Fish website" => "Show clickable URLs to translate the page to another language using Babel Fish website",
// "Show clickable icons to translate the page to another language using Babelfish website" => "Show clickable icons to translate the page to another language using Babelfish website",
// "Also known as emoticons" => "Also known as emoticons",
// "Bloc of content which can be reused and programmed (timed)" => "Bloc of content which can be reused and programmed (timed)",
// "If disabled, pictures will be stored in ../img/wiki_up/.. instead" => "If disabled, pictures will be stored in ../img/wiki_up/.. instead",
// "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon" => "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon",
// "Going beyond Backlinks, allows to define some semantic relationships between wiki pages" => "Going beyond Backlinks, allows to define some semantic relationships between wiki pages",
// "Web Services" => "Web Services",
// "Can consume webservices in JSON or YAML" => "Can consume webservices in JSON or YAML",
// "Breadcrumbs" => "Breadcrumbs",
// "Attempts to show you where you are" => "Attempts to show you where you are",
// "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)",
// "If you are using Apache, you can rename _htaccess to .htaccess to get Short URLs" => "If you are using Apache, you can rename _htaccess to .htaccess to get Short URLs",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "This redirection uses the wiki prefix alias feature" => "This redirection uses the wiki prefix alias feature",
// "Show module controls" => "Show module controls",
// "Permits to override preferences" => "Permits to override preferences",
// "Permits find and replace of content in the edit box" => "Permits find and replace of content in the edit box",
// "Pre-defined content for a wiki page" => "Pre-defined content for a wiki page",
// "Show category tree, above wiki pages" => "Show category tree, above wiki pages",
// "Show objects sharing the same category, below wiki pages" => "Show objects sharing the same category, below wiki pages",
// "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated" => "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated",
// "Object filter" => "Object filter",
// "Pertinence" => "Pertinence",
// "Last modified date" => "Last modified date",
// "Publish dates can be modified" => "Publish dates can be modified",
// "Quick jumps" => "Quick jumps",
// "Forum name search" => "Forum name search",
// "When listing forums" => "When listing forums",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Tiki-indexed search" => "Tiki-indexed search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Store password as plain text" => "Store password as plain text",
// "Assign different themes to different sections, categories, and objects" => "Assign different themes to different sections, categories, and objects",
// "Use custom !DOCTYPE" => "Use custom !DOCTYPE",
// "Custom Doctype Content" => "Custom Doctype Content",
// "Use to generate the Tiki layout with custom &lt;!DOCTYPE&gt; specified" => "Use to generate the Tiki layout with custom &lt;!DOCTYPE&gt; specified",
// "Custom HTML <head> Content" => "Custom HTML <head> Content",
// "Use to include custom &lt;meta&gt; or &lt;link&gt; tags" => "Use to include custom &lt;meta&gt; or &lt;link&gt; tags",
// "The &lt;base&gt; tag specifies a default address for all links on a page" => "The &lt;base&gt; tag specifies a default address for all links on a page",
// "Login Bar" => "Login Bar",
// "Top Bar Custom Code" => "Top Bar Custom Code",
// "Site menu custom code" => "Site menu custom code",
// "Secondary site menu custom code" => "Secondary site menu custom code",
// "Menu ID" => "Menu ID",
// "Needs either CSS Menus or PHPLayers" => "Needs either CSS Menus or PHPLayers",
// "Top Bar" => "Top Bar",
// "side bar" => "side bar",
// "Right Column" => "Right Column",
// "Prefix breadcrumbs with \"Location : \"" => "Prefix breadcrumbs with \"Location : \"",
// "Top of page" => "Top of page",
// "Top of center column" => "Top of center column",
// "Entire location" => "Entire location",
// "Custom End of <body> Code" => "Custom End of <body> Code",
// "Indicate various debug-related information in the footer of the site (Execution time, Memory usage, etc.)" => "Indicate various debug-related information in the footer of the site (Execution time, Memory usage, etc.)",
// "Bottom bar (RSS)" => "Bottom bar (RSS)",
// "Webmaster Email" => "Webmaster Email",
// "Add a link at the bottom if set, otherwise add a link at the top" => "Add a link at the bottom if set, otherwise add a link at the top",
// "Shadow layer" => "Shadow layer",
// "Tooltips" => "Tooltips",
// "Make tooltips such as this appear in a custom style. Use CSS to change their appearance" => "Make tooltips such as this appear in a custom style. Use CSS to change their appearance",
// "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc" => "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc",
// "Superfish" => "Superfish",
// "Adds animation effects to CSS \"Suckerfish\" menus" => "Adds animation effects to CSS \"Suckerfish\" menus",
// "Allows images to have a reflection effect below them. See the admin icons above for an example" => "Allows images to have a reflection effect below them. See the admin icons above for an example",
// "JQuery UI" => "JQuery UI",
// "Include jQuery UI library. Enables many user interface features" => "Include jQuery UI library. Enables many user interface features",
// "JQuery UI Theme" => "JQuery UI Theme",
// "jQuery UI Theme. Used in spreadsheet, for example" => "jQuery UI Theme. Used in spreadsheet, for example",
// "Provides various validation possibilities like in Trackers" => "Provides various validation possibilities like in Trackers",
// "JQuery JQS5" => "JQuery JQS5",
// "jQuery Simple Standards-Based Slide Show System" => "jQuery Simple Standards-Based Slide Show System",
// "Image \"carousel\" plugin (coming soon)" => "Image \"carousel\" plugin (coming soon)",
// "Sort in fancytable plugin" => "Sort in fancytable plugin",
// "JQuery Media" => "JQuery Media",
// "Media player" => "Media player",
// "Tiki will warn users who attempt to edit a page that another user is currenly editing" => "Tiki will warn users who attempt to edit a page that another user is currenly editing",
// "Create private notes for a page that are visible only by the author" => "Create private notes for a page that are visible only by the author",
// "Sandbox" => "Sandbox",
// "A special wiki page for testing. Users can edit, but not save the Sandbox" => "A special wiki page for testing. Users can edit, but not save the Sandbox",
// "Allow users (with permission) to post threaded comments to a page" => "Allow users (with permission) to post threaded comments to a page",
// "Allow users to upload images (pictures) to a page" => "Allow users to upload images (pictures) to a page",
// "Automatically convert words with UpPeR and LoWeR-case letters into wiki links" => "Automatically convert words with UpPeR and LoWeR-case letters into wiki links",
// "Visualize the contributions of different authors made to a wiki page" => "Visualize the contributions of different authors made to a wiki page",
// "Include a link on each page to a forum topic" => "Include a link on each page to a forum topic",
// "A personal page for the user to manage" => "A personal page for the user to manage",
// "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty" => "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty",
// "This feature is experimental" => "This feature is experimental",
// "Allows wiki pages to be staged (drafted) before they are approved (published)" => "Allows wiki pages to be staged (drafted) before they are approved (published)",
// "Allow users to upload (attach) files to a page" => "Allow users to upload (attach) files to a page",
// "Metrics Dashboard" => "Metrics Dashboard",
// "Generate automated statistics from configured database queries" => "Generate automated statistics from configured database queries",
// "Wiki argument variables" => "Wiki argument variables",
// "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}",
// "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines" => "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
// "Tiki will automatically convert http:// and email addresses into links" => "Tiki will automatically convert http:// and email addresses into links",
// "Hotwords" => "Hotwords",
// "Allow to access File Galleries with WebDAV" => "Allow to access File Galleries with WebDAV",
// "Constrains the site display to 990px wide" => "Constrains the site display to 990px wide",
// "You can modify at styles/layout/layout.css - selector #fixedwidth" => "You can modify at styles/layout/layout.css - selector #fixedwidth",
// "Integration with different social networks like Twitter or Facebook" => "Integration with different social networks like Twitter or Facebook",
// "Group Transition" => "Group Transition",
// "Enables transitions for users between different groups. Transitions will create a user approval workflow" => "Enables transitions for users between different groups. Transitions will create a user approval workflow",
// "Enables transitions on objects between different categories. Transitions will create a document workflow" => "Enables transitions on objects between different categories. Transitions will create a document workflow",
// "Ustream Watershed" => "Ustream Watershed",
// "Integration to Ustream Watershed live video streaming" => "Integration to Ustream Watershed live video streaming",
// "Tiki User Credits" => "Tiki User Credits",
// "Allow users to invite new users by mail to register on this tiki" => "Allow users to invite new users by mail to register on this tiki",
// "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server" => "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server",
// "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications" => "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications",
// "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'" => "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'",
// "If a requested page doesn't exist, redirect to a similarly named page" => "If a requested page doesn't exist, redirect to a similarly named page",
// "ATOM 1.0" => "ATOM 1.0",
// "RSS 2.0" => "RSS 2.0",
// "Feed editor email" => "Feed editor email",
// "Email address for person responsible for editorial content" => "Email address for person responsible for editorial content",
// "Feed webmaster email" => "Feed webmaster email",
// "Email address for person responsible for technical issues relating to channel" => "Email address for person responsible for technical issues relating to channel",
// "Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "Specifies a GIF, JPEG or PNG image that can be displayed with the feed",
// "Propose basic http authentication if the user has no permission to see the feed" => "Propose basic http authentication if the user has no permission to see the feed",
// "RSS feeds for articles" => "RSS feeds for articles",
// "RSS feeds for blogs" => "RSS feeds for blogs",
// "RSS feed for individual blogs" => "RSS feed for individual blogs",
// "RSS feed for image galleries" => "RSS feed for image galleries",
// "RSS feed for individual image galleries" => "RSS feed for individual image galleries",
// "RSS feed for file galleries" => "RSS feed for file galleries",
// "RSS feed for individual file galleries" => "RSS feed for individual file galleries",
// "RSS feed for wiki" => "RSS feed for wiki",
// "RSS feed for forums" => "RSS feed for forums",
// "RSS feed for individual forums" => "RSS feed for individual forums",
// "RSS feed for trackers" => "RSS feed for trackers",
// "RSS feed for individual trackers items" => "RSS feed for individual trackers items",
// "RSS feed for calendar events" => "RSS feed for calendar events",
// "RSS feed for directories" => "RSS feed for directories",
// "RSS feed for maps" => "RSS feed for maps",
// "RSS feed for shoutbox" => "RSS feed for shoutbox",
// "Maximum number of items to display" => "Maximum number of items to display",
// "Show Author" => "Show Author",
// "Homepage URL" => "Homepage URL",
// "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used",
// "Article RSS Description" => "Article RSS Description",
// "Description to be published as part of the RSS feed for articles" => "Description to be published as part of the RSS feed for articles",
// "Blogs RSS Description" => "Blogs RSS Description",
// "Description to be published as part of the RSS feed for blogs" => "Description to be published as part of the RSS feed for blogs",
// "Blog RSS Description" => "Blog RSS Description",
// "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used" => "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used",
// "Image galleries RSS Description" => "Image galleries RSS Description",
// "Description to be published as part of the RSS feed for image galleries" => "Description to be published as part of the RSS feed for image galleries",
// "Individual image galleries RSS Description" => "Individual image galleries RSS Description",
// "Description to be published as part of the RSS feed for individual image galleries" => "Description to be published as part of the RSS feed for individual image galleries",
// "File galleries RSS Description" => "File galleries RSS Description",
// "Description to be published as part of the RSS feed for file galleries" => "Description to be published as part of the RSS feed for file galleries",
// "Individual file galleries RSS Description" => "Individual file galleries RSS Description",
// "Description to be published as part of the RSS feed for individual file galleries" => "Description to be published as part of the RSS feed for individual file galleries",
// "Wiki pages RSS Description" => "Wiki pages RSS Description",
// "Description to be published as part of the RSS feed for wiki pages" => "Description to be published as part of the RSS feed for wiki pages",
// "Forums RSS Description" => "Forums RSS Description",
// "Description to be published as part of the RSS feed for forums" => "Description to be published as part of the RSS feed for forums",
// "Individual forums RSS Description" => "Individual forums RSS Description",
// "Description to be published as part of the RSS feed for individual forums" => "Description to be published as part of the RSS feed for individual forums",
// "Trackers RSS Description" => "Trackers RSS Description",
// "Description to be published as part of the RSS feed for trackers" => "Description to be published as part of the RSS feed for trackers",
// "Individual trackers RSS Description" => "Individual trackers RSS Description",
// "Description to be published as part of the RSS feed for individual trackers" => "Description to be published as part of the RSS feed for individual trackers",
// "Calendar events RSS Description" => "Calendar events RSS Description",
// "Description to be published as part of the RSS feed for calendar events" => "Description to be published as part of the RSS feed for calendar events",
// "Directories RSS Description" => "Directories RSS Description",
// "Description to be published as part of the RSS feed for directories" => "Description to be published as part of the RSS feed for directories",
// "Maps RSS Description" => "Maps RSS Description",
// "Description to be published as part of the RSS feed for maps" => "Description to be published as part of the RSS feed for maps",
// "Shoutbox RSS Description" => "Shoutbox RSS Description",
// "Description to be published as part of the RSS feed for shoutbox messages" => "Description to be published as part of the RSS feed for shoutbox messages",
// "Must match" => "Must match",
// "Cannot match" => "Cannot match",
// "Include the search box on the current gallery files just after the find div" => "Include the search box on the current gallery files just after the find div",
// "Include a search box on file galleries" => "Include a search box on file galleries",
// "The user will have an option when uploading a file to specify the time after which the file is deleted" => "The user will have an option when uploading a file to specify the time after which the file is deleted",
// "These emails will receive a copy of each deleted file. Emails are separated with comma" => "These emails will receive a copy of each deleted file. Emails are separated with comma",
// "Keep fileId for archives" => "Keep fileId for archives",
// "Keep always the same fileId when replacing a file with archive" => "Keep always the same fileId when replacing a file with archive",
// "Show thumbnail actions" => "Show thumbnail actions",
// "Show the checkbox and wrench icon for file actions menu when not displaying details" => "Show the checkbox and wrench icon for file actions menu when not displaying details",
// "Max thumbnail size" => "Max thumbnail size",
// "Maximum width or height for image thumbnails" => "Maximum width or height for image thumbnails",
// "In pixels" => "In pixels",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "Display thread configuration bar only when number of posts exceed" => "Display thread configuration bar only when number of posts exceed",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Default style" => "Default style",
// "Threaded" => "Threaded",
// "Default sort mode" => "Default sort mode",
// "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display" => "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display",
// "Permits translation management of tags" => "Permits translation management of tags",
// "3D autoload" => "3D autoload",
// "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes" => "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes",
// "Label visible in the browser\\'s title bar on all pages. Also appears in search engines" => "Label visible in the browser\\'s title bar on all pages. Also appears in search engines",
// "Upon registration, the new user will receive an email containing a link to confirm validity" => "Upon registration, the new user will receive an email containing a link to confirm validity",
// "Landing page used for the wiki when no page is specified. The page will be created if it does not exist" => "Landing page used for the wiki when no page is specified. The page will be created if it does not exist",
// "Users can be sent to different pages upon login, depending on their default group" => "Users can be sent to different pages upon login, depending on their default group",
// "Site language used when no other language is specified by the user" => "Site language used when no other language is specified by the user",
// "Tiki requires full read and write access to this directory" => "Tiki requires full read and write access to this directory",
// "The default help system may not be complete. You can help with the Tiki documentation" => "The default help system may not be complete. You can help with the Tiki documentation",
// "Map Zone" => "Map Zone",
// "[-180 180]" => "[-180 180]",
// "[0 360]" => "[0 360]",
// "Hide anonymous-only modules from Admins" => "Hide anonymous-only modules from Admins",
// "Test" => "Test",
// "Use %user% for login name and %userId% for userId)" => "Use %user% for login name and %userId% for userId)",
// "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user" => "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user",
// "If passwords <em>are stored</em> as plain text, the password will be emailed to the user" => "If passwords <em>are stored</em> as plain text, the password will be emailed to the user",
// "Custom Site Header Content" => "Custom Site Header Content",
// "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "The administrator will receive an email for each new user registration, and must validate the user before the user can login" => "The administrator will receive an email for each new user registration, and must validate the user before the user can login",
// "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only" => "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only",
// "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user" => "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user",
// "Use a Tiki feature homepage or another homepage" => "Use a Tiki feature homepage or another homepage",
// "Select the Tiki feature to use as the site homepage. Only enabled features are listed" => "Select the Tiki feature to use as the site homepage. Only enabled features are listed",
// "Disable JavaScript for testing purpose even if the browser allows it" => "Disable JavaScript for testing purpose even if the browser allows it",
// "Partner ID" => "Partner ID",
// "Kaltura Partner ID" => "Kaltura Partner ID",
// "Kaltura partner setting user secret" => "Kaltura partner setting user secret",
// "Kaltura partner setting admin secret" => "Kaltura partner setting admin secret",
// "KDP UI Configuration ID" => "KDP UI Configuration ID",
// "Kaltura Dynamic Player (KDP) user interface configuration ID" => "Kaltura Dynamic Player (KDP) user interface configuration ID",
// "KDP Widget ID" => "KDP Widget ID",
// "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account" => "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account",
// "Kaltura Configuration Wizard (KCW) user interface configuration ID" => "Kaltura Configuration Wizard (KCW) user interface configuration ID",
// "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries" => "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries",
// "Kaltura Service URL" => "Kaltura Service URL",
// "e.g. http://www.kaltura.com/" => "e.g. http://www.kaltura.com/",
// "You could use your server name for this. e.g. \$url_host" => "You could use your server name for this. e.g. \$url_host",
// "Google Maps API Key" => "Google Maps API Key",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
// "Includes a custom block of CSS inline in all pages" => "Includes a custom block of CSS inline in all pages",
// "Includes a custom block of inline JavaScript in all pages" => "Includes a custom block of inline JavaScript in all pages",
// "No image gallery available (create one first)" => "No image gallery available (create one first)",
// "No file gallery available (create one first)" => "No file gallery available (create one first)",
// "No forum available (create one first)" => "No forum available (create one first)",
// "No blog available (create one first)" => "No blog available (create one first)",
// "Use HTTPS when building user-specific links" => "Use HTTPS when building user-specific links",
// "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
// "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server" => "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server",
// "CSS selectors to be fixed" => "CSS selectors to be fixed",
// "Separate multiple elements with a comma (,)" => "Separate multiple elements with a comma (,)",
// "HTMLDomElements to be fixed" => "HTMLDomElements to be fixed",
// "Obtain jQuery and jQuery UI libraries through a content delivery network" => "Obtain jQuery and jQuery UI libraries through a content delivery network",
// "Google" => "Google",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Use the database to store the translated strings and allow using interactive translation" => "Use the database to store the translated strings and allow using interactive translation",
// "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages",
// "Add HTML comment at start and end of each Smarty template (TPL)" => "Add HTML comment at start and end of each Smarty template (TPL)",
// "You need to clear your Tiki template cache for this change to take effect" => "You need to clear your Tiki template cache for this change to take effect",
// "Log SQL queries" => "Log SQL queries",
// "This may impact performance" => "This may impact performance",
// "Instead of creating new usernames, use the user\\'s email address for authentication" => "Instead of creating new usernames, use the user\\'s email address for authentication",
// "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead" => "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead",
// "%H:%M:%S %Z" => "%H:%M:%S %Z",
// "%A %d of %B, %Y %H:%M:%S %Z" => "%A %d of %B, %Y %H:%M:%S %Z",
// "CRLF (standard)" => "CRLF (standard)",
// "LF (some Unix MTA)" => "LF (some Unix MTA)",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
// "Enable connection to memcached servers to store temporary information" => "Enable connection to memcached servers to store temporary information",
// "Enable compression for memcache storage" => "Enable compression for memcache storage",
// "Memcache servers" => "Memcache servers",
// "Server list which may be accessed. For each server, the address, port and weight must be specified" => "Server list which may be accessed. For each server, the address, port and weight must be specified",
// "One per line. address:port (weight)" => "One per line. address:port (weight)",
// "Memcache key prefix" => "Memcache key prefix",
// "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts" => "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts",
// "Memcache expiration" => "Memcache expiration",
// "Duration for which the data will be kept" => "Duration for which the data will be kept",
// "Cache wiki data in memcache" => "Cache wiki data in memcache",
// "Cache wiki output in memcache" => "Cache wiki output in memcache",
// "Cache forum output in memcache" => "Cache forum output in memcache",
// "Allows to define icons for menu entries" => "Allows to define icons for menu entries",
// "Allow HTML in link text and do not escape the url in menu items (Please note: this might be insecure if you allow more people to edit menus)" => "Allow HTML in link text and do not escape the url in menu items (Please note: this might be insecure if you allow more people to edit menus)",
// "If enabled, menu item names treated as HTML item content and they are not escaped (do not replace HTML special characters), this allows the use of HTML in menu items to insert images for example, and menu item urls are not escaped which allows the use of permissable href tags. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing" => "If enabled, menu item names treated as HTML item content and they are not escaped (do not replace HTML special characters), this allows the use of HTML in menu items to insert images for example, and menu item urls are not escaped which allows the use of permissable href tags. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing",
// "Keywords" => "Keywords",
// "Include freetags" => "Include freetags",
// "Use thread title instead" => "Use thread title instead",
// "Use image title instead" => "Use image title instead",
// "Use individual page description for Wiki pages instead" => "Use individual page description for Wiki pages instead",
// "Meta robots" => "Meta robots",
// "Revisit after" => "Revisit after",
// "Show past metrics results" => "Show past metrics results",
// "In the metrics dashboard, identify if the previously collected metrics should be displayed" => "In the metrics dashboard, identify if the previously collected metrics should be displayed",
// "Past metrics count" => "Past metrics count",
// "Amount of past results to display" => "Amount of past results to display",
// "No metric trend value" => "No metric trend value",
// "Value to display when no trend is available for the metric" => "Value to display when no trend is available for the metric",
// "Metric trend prefix" => "Metric trend prefix",
// "Portion of text to display before the metric trend value" => "Portion of text to display before the metric trend value",
// "Metric trend suffix" => "Metric trend suffix",
// "Portion of text to display after the metric trend value" => "Portion of text to display after the metric trend value",
// "Metric name length" => "Metric name length",
// "Metric tab name length" => "Metric tab name length",
// "Cache metrics output" => "Cache metrics output",
// "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended" => "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
// "7" => "7",
// "8" => "8",
// "9" => "9",
// "10" => "10",
// "Multi-domain" => "Multi-domain",
// "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance" => "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance",
// "Comma-separated values mapping the domain name to the perspective ID" => "Comma-separated values mapping the domain name to the perspective ID",
// "Page description, icons, backlinks, .." => "Page description, icons, backlinks, ..",
// "Top " => "Top ",
// "For improved security, require users to include a mix of characters and numerals in passwords" => "For improved security, require users to include a mix of characters and numerals in passwords",
// "Feature to manage and track payment requests" => "Feature to manage and track payment requests",
// "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits",
// "PayPal" => "PayPal",
// "Cclite" => "Cclite",
// "Paypal Business ID" => "Paypal Business ID",
// "Enable payments through paypal" => "Enable payments through paypal",
// "Used to switch between the paypal sandbox, used for testing and development and the live environment" => "Used to switch between the paypal sandbox, used for testing and development and the live environment",
// "Paypal Instant Payment Notification (IPN)" => "Paypal Instant Payment Notification (IPN)",
// "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server" => "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server",
// "Currency used when entering payments" => "Currency used when entering payments",
// "Amount of days before the payment requests becomes overdue. This can be changed per payment request" => "Amount of days before the payment requests becomes overdue. This can be changed per payment request",
// "Cclite Registries" => "Cclite Registries",
// "Registries in Cclite. Use comma to separate. e.g. \"dogtown, chelsea, dalston, etc\"" => "Registries in Cclite. Use comma to separate. e.g. \"dogtown, chelsea, dalston, etc\"",
// "Registry names in Cclite" => "Registry names in Cclite",
// "Cclite Registry Currencies" => "Cclite Registry Currencies",
// "Currencies in Cclite. Use comma to separate. e.g. \"woof, ducket, ducket, etc\"" => "Currencies in Cclite. Use comma to separate. e.g. \"woof, ducket, ducket, etc\"",
// "Each registry in Cclite can have it\\'s own currency. Must be one per registry. (case sensitive)" => "Each registry in Cclite can have it\\'s own currency. Must be one per registry. (case sensitive)",
// "Cclite Server URL" => "Cclite Server URL",
// "Full URL of the repository" => "Full URL of the repository",
// "e.g. https://cclite.yourdomain.org/cclite/" => "e.g. https://cclite.yourdomain.org/cclite/",
// "Cclite Merchant Key" => "Cclite Merchant Key",
// "Corresponds with Merchant Key setting in Cclite" => "Corresponds with Merchant Key setting in Cclite",
// "Cclite Merchant User" => "Cclite Merchant User",
// "User name in Cclite representing \"the management\". Defaults to \"manager\"" => "User name in Cclite representing \"the management\". Defaults to \"manager\"",
// "Cclite Enable Payments" => "Cclite Enable Payments",
// "Test or Live operation" => "Test or Live operation",
// "Live" => "Live",
// "Hashing Algorithm" => "Hashing Algorithm",
// "Encryption type" => "Encryption type",
// "SHA1" => "SHA1",
// "SHA256" => "SHA256",
// "SHA512" => "SHA512",
// "Cclite Payment Notification" => "Cclite Payment Notification",
// "TODO" => "TODO",
// "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice" => "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice",
// "Types of credit to use" => "Types of credit to use",
// "This is a list of the types of Tiki user credits to accept to pay with, separated by " => "This is a list of the types of Tiki user credits to accept to pay with, separated by ",
// "Exchange rate for types of credit to use" => "Exchange rate for types of credit to use",
// "This is a corresponding list of amount of credits equivalent to 1 of the payment currency, separated by " => "This is a corresponding list of amount of credits equivalent to 1 of the payment currency, separated by ",
// "When used with the rating features, allow multiple polls to be attached to a single object" => "When used with the rating features, allow multiple polls to be attached to a single object",
// "Using extenal tools, generate PDF document from web URLs" => "Using extenal tools, generate PDF document from web URLs",
// "Webkit (wkhtmltopdf)" => "Webkit (wkhtmltopdf)",
// "Webservice" => "Webservice",
// "Webservice URL" => "Webservice URL",
// "URL to a service taking a URL as the query string and returns a PDF document" => "URL to a service taking a URL as the query string and returns a PDF document",
// "Webkit path" => "Webkit path",
// "Full path to the wkhtmltopdf executable to generate the PDF document with" => "Full path to the wkhtmltopdf executable to generate the PDF document with",
// "Proxy host - without http:// or similar, just the host name" => "Proxy host - without http:// or similar, just the host name",
// "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page" => "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page",
// "Rating system allowing for options and calculation method to be configured" => "Rating system allowing for options and calculation method to be configured",
// "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time" => "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time",
// "Recalculation odds (1 in X)" => "Recalculation odds (1 in X)",
// "Dice roll performed on every request. When successful, will recalculate a certain number of votes" => "Dice roll performed on every request. When successful, will recalculate a certain number of votes",
// "How many ratings should be recalculated when odds strike" => "How many ratings should be recalculated when odds strike",
// "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA" => "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA",
// "You will need to register at [http://www.google.com/recaptcha]" => "You will need to register at [http://www.google.com/recaptcha]",
// "Public Key" => "Public Key",
// "ReCaptcha public key" => "ReCaptcha public key",
// "Private Key" => "Private Key",
// "ReCaptcha private key" => "ReCaptcha private key",
// "Keep track of the unsuccessful attemps to translate strings" => "Keep track of the unsuccessful attemps to translate strings",
// "Limit the languages made available on the site" => "Limit the languages made available on the site",
// "Refresh mode" => "Refresh mode",
// "Random" => "Random",
// "Use 0 for no refresh" => "Use 0 for no refresh",
// "Parse the results" => "Parse the results",
// "Default where" => "Default where",
// "When object filter is not on, limit to search one type of object" => "When object filter is not on, limit to search one type of object",
// "Entire site" => "Entire site",
// "If enabled, only search content in the interface language, by default" => "If enabled, only search content in the interface language, by default",
// "Autocomplete on page names" => "Autocomplete on page names",
// "Email address that will be used as the sender for outgoing emails" => "Email address that will be used as the sender for outgoing emails",
// "Indicates the default time zone to use for the server" => "Indicates the default time zone to use for the server",
// "Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Select where the session information should be stored. Memcache sessions require memcache to be configured",
// "Silent session" => "Silent session",
// "Do not automatically start sessions" => "Do not automatically start sessions",
// "Session cookie name" => "Session cookie name",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
// "Protect all sessions" => "Protect all sessions",
// "Always redirect to HTTPS to prevent session hijack through network sniffing" => "Always redirect to HTTPS to prevent session hijack through network sniffing",
// "Default group" => "Default group",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)",
// "FedEx API" => "FedEx API",
// "Enable shipping rate calculation through FedEx APIs" => "Enable shipping rate calculation through FedEx APIs",
// "FedEx Key" => "FedEx Key",
// "Developer Key" => "Developer Key",
// "FedEx Password" => "FedEx Password",
// "FedEx Meter Number" => "FedEx Meter Number",
// "FedEx Account Number" => "FedEx Account Number",
// "UPS API" => "UPS API",
// "Enable shipping rate calculation using the UPS carrier" => "Enable shipping rate calculation using the UPS carrier",
// "UPS Username" => "UPS Username",
// "UPS credentials" => "UPS credentials",
// "UPS Password" => "UPS Password",
// "UPS Access Key" => "UPS Access Key",
// "%Y-%m-%d" => "%Y-%m-%d",
// "%H:%M" => "%H:%M",
// "%Y-%m-%d %H:%M" => "%Y-%m-%d %H:%M",
// "Location of the site title in the browser title bar relative to the current page\\'s descriptor" => "Location of the site title in the browser title bar relative to the current page\\'s descriptor",
// "When breadcrumbs are used, method in which the browser title should be displayed" => "When breadcrumbs are used, method in which the browser title should be displayed",
// "image/png" => "image/png",
// "image/bmp" => "image/bmp",
// "image/x-icon" => "image/x-icon",
// "Center" => "Center",
// "Include smarty notices in PHP error report" => "Include smarty notices in PHP error report",
// "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur" => "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "You should leave this on unless you know what you are doing" => "You should leave this on unless you know what you are doing",
// "Smarty Compilation" => "Smarty Compilation",
// "Indicates when the template cache should be refreshed" => "Indicates when the template cache should be refreshed",
// "Consumer key" => "Consumer key",
// "Consumer key generated by registering your site as application at twitter" => "Consumer key generated by registering your site as application at twitter",
// "Consumer secret" => "Consumer secret",
// "Consumer secret generated by registering your site as an application at twitter" => "Consumer secret generated by registering your site as an application at twitter",
// "API key" => "API key",
// "API key generated by registering your site as application at facebook" => "API key generated by registering your site as application at facebook",
// "Application secret" => "Application secret",
// "Application secret generated by registering your site as an application at facebook" => "Application secret generated by registering your site as an application at facebook",
// "Application ID" => "Application ID",
// "Application id generated by registering your site as an application at facebook" => "Application id generated by registering your site as an application at facebook",
// "bit.ly Login" => "bit.ly Login",
// "Site wide login (username) for bit.ly" => "Site wide login (username) for bit.ly",
// "bit.ly Key" => "bit.ly Key",
// "Site wide API key for bit.ly" => "Site wide API key for bit.ly",
// "Use site-wide account" => "Use site-wide account",
// "When setting this option to yes, only the site wide account will be used for all users" => "When setting this option to yes, only the site wide account will be used for all users",
// "Style options" => "Style options",
// "Minify JavaScript" => "Minify JavaScript",
// "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS" => "Minify CSS",
// "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS into a single file" => "Minify CSS into a single file",
// "In addition to reducing the size of the CSS, reduce the number of included files" => "In addition to reducing the size of the CSS, reduce the number of included files",
// "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"" => "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"",
// "When displaying short date and time, skip date for today. Only time will be displayed" => "When displaying short date and time, skip date for today. Only time will be displayed",
// "Cache-Control header" => "Cache-Control header",
// "Custom HTTP header to use when a session is active" => "Custom HTTP header to use when a session is active",
// "Example: no-cache, pre-check=0, post-check=0" => "Example: no-cache, pre-check=0, post-check=0",
// "Cache-Control header (no session)" => "Cache-Control header (no session)",
// "Custom HTTP header to use when no session is active" => "Custom HTTP header to use when no session is active",
// "Content Delivery Network" => "Content Delivery Network",
// "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance" => "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance",
// "Prefix to include before the static files, for example: http://cdn.example.com" => "Prefix to include before the static files, for example: http://cdn.example.com",
// "Content Delivery Network (in SSL)" => "Content Delivery Network (in SSL)",
// "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode" => "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode",
// "Prefix to include before the static files, for example: https://cdn.example.com" => "Prefix to include before the static files, for example: https://cdn.example.com",
// "Strip or automatically add the www. prefix on domain names to unify URLs" => "Strip or automatically add the www. prefix on domain names to unify URLs",
// "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org" => "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org",
// "Show user\\'s real name instead of login (when possible)" => "Show user\\'s real name instead of login (when possible)",
// "Users can configure modules" => "Users can configure modules",
// "Users can shade modules" => "Users can shade modules",
// "Allows users to hide/show modules" => "Allows users to hide/show modules",
// "Module decides" => "Module decides",
// "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit",
// "You will need to activate tracking of views for various items in the action log for this to work" => "You will need to activate tracking of views for various items in the action log for this to work",
// "Number of days before current time to consider when showing who viewed my stuff" => "Number of days before current time to consider when showing who viewed my stuff",
// "Show to others who viewed my stuff on the user information page. Admins can always see this information" => "Show to others who viewed my stuff on the user information page. Admins can always see this information",
// "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box" => "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box",
// "Use wiki page name or template file with .tpl extension" => "Use wiki page name or template file with .tpl extension",
// "User tracker IDs to sync prefs from" => "User tracker IDs to sync prefs from",
// "Enter the IDs separated by commas of trackers to sync user prefs from" => "Enter the IDs separated by commas of trackers to sync user prefs from",
// "Tracker field IDs to sync Real Name pref from" => "Tracker field IDs to sync Real Name pref from",
// "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4" => "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4",
// "Synchronize user geolocation prefs to main google maps field" => "Synchronize user geolocation prefs to main google maps field",
// "Synchronize categories of user tracker item to user groups" => "Synchronize categories of user tracker item to user groups",
// "Will add the user tracker item to the category of the same name as the user groups and vice versa" => "Will add the user tracker item to the category of the same name as the user groups and vice versa",
// "Show user\\'s real name instead of login in autocomplete selector in trackers feature" => "Show user\\'s real name instead of login in autocomplete selector in trackers feature",
// "Use user\\'s real name instead of login in autocomplete selector in trackers feature" => "Use user\\'s real name instead of login in autocomplete selector in trackers feature",
// "Show user\\'s real name instead of login in autocomplete selector in messaging feature" => "Show user\\'s real name instead of login in autocomplete selector in messaging feature",
// "Use user\\'s real name instead of login in autocomplete selector in messaging feature" => "Use user\\'s real name instead of login in autocomplete selector in messaging feature",
// "Serve avatar images statically" => "Serve avatar images statically",
// "When enabled, feature checks and permission checks will be skipped" => "When enabled, feature checks and permission checks will be skipped",
// "Use new diff any version interface" => "Use new diff any version interface",
// "20" => "20",
// "30" => "30",
// "40" => "40",
// "50" => "50",
// "60" => "60",
// "15" => "15",
// "Errors will be logged to the Tiki log" => "Errors will be logged to the Tiki log",
// "Tracker ID of Channel tracker" => "Tracker ID of Channel tracker",
// "There must be a tracker to store info of each channel you create" => "There must be a tracker to store info of each channel you create",
// "Field ID of BrandId" => "Field ID of BrandId",
// "The Channel tracker must have a text field for the Watershed BrandId" => "The Channel tracker must have a text field for the Watershed BrandId",
// "Field ID of ChannelCode" => "Field ID of ChannelCode",
// "The Channel tracker must have a text field for the Watershed ChannelCode" => "The Channel tracker must have a text field for the Watershed ChannelCode",
// "Tracker ID of Archive tracker" => "Tracker ID of Archive tracker",
// "There must be a tracker to store Archive info" => "There must be a tracker to store Archive info",
// "Field ID of videoId" => "Field ID of videoId",
// "The Archive tracker must have a text field for the videoId of each archive" => "The Archive tracker must have a text field for the videoId of each archive",
// "Field ID of BrandId for Archive" => "Field ID of BrandId for Archive",
// "The Archive tracker must have a text field for the BrandId of each archive" => "The Archive tracker must have a text field for the BrandId of each archive",
// "Field ID of ChannelCode for Archive" => "Field ID of ChannelCode for Archive",
// "The Archive tracker must have a text field for the ChannelCode of each archive" => "The Archive tracker must have a text field for the ChannelCode of each archive",
// "Field ID of rtmpURL for Archive (url field type)" => "Field ID of rtmpURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the RTMP URL to access the archive" => "The Archive tracker must have a url field for storing the RTMP URL to access the archive",
// "Field ID of flvURL for Archive (url field type)" => "Field ID of flvURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the FLV URL to access the archive" => "The Archive tracker must have a url field for storing the FLV URL to access the archive",
// "Field ID of Date string for Archive" => "Field ID of Date string for Archive",
// "The Archive tracker can have a text field for storing the time the recording completed" => "The Archive tracker can have a text field for storing the time the recording completed",
// "Field ID of Duration for Archive" => "Field ID of Duration for Archive",
// "The Archive tracker can have a text field for storing the duration of the recording" => "The Archive tracker can have a text field for storing the duration of the recording",
// "Field ID of Filesize for Archive" => "Field ID of Filesize for Archive",
// "The Archive tracker can have a text field for storing the filesize of the recording" => "The Archive tracker can have a text field for storing the filesize of the recording",
// "Field ID of Title for Archive" => "Field ID of Title for Archive",
// "The Archive tracker could have a text field for storing the title of the recording" => "The Archive tracker could have a text field for storing the title of the recording",
// "Field ID of Description for Archive (textarea field type)" => "Field ID of Description for Archive (textarea field type)",
// "The Archive tracker could have a textarea field for storing the description of the recording" => "The Archive tracker could have a textarea field for storing the description of the recording",
// "Field ID of Tags for Archive (freetags field type)" => "Field ID of Tags for Archive (freetags field type)",
// "The Archive tracker could have a freetags field for storing the tags of the recording" => "The Archive tracker could have a freetags field for storing the tags of the recording",
// "Shared key for authenticating Flash Media Encoder" => "Shared key for authenticating Flash Media Encoder",
// "LastModif" => "LastModif",
// "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))" => "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))",
// "Relaxed" => "Relaxed",
// "Strict" => "Strict",
// "Display page version" => "Display page version",
// "Display the page version information when viewing the page" => "Display the page version information when viewing the page",
// "Display page name above page instead of inside page" => "Display page name above page instead of inside page",
// "Page name display stripper" => "Page name display stripper",
// "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed" => "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed",
// "Wiki author list style" => "Wiki author list style",
// "Changes the list format used to display the authors of the page" => "Changes the list format used to display the authors of the page",
// "Specify wiki author list style per page" => "Specify wiki author list style per page",
// "Allows to modify the style in which the author list is displayed on a per-page basis" => "Allows to modify the style in which the author list is displayed on a per-page basis",
// "Buttons: Save, Preview, Cancel, .." => "Buttons: Save, Preview, Cancel, ..",
// "When using the ...page... page break wiki syntax" => "When using the ...page... page break wiki syntax",
// "Enable page cache globally for wiki pages" => "Enable page cache globally for wiki pages",
// "Enable control for comments on wiki pages individually" => "Enable control for comments on wiki pages individually",
// "Permits editing of a plugin, via a popup form, without needing to edit the whole page" => "Permits editing of a plugin, via a popup form, without needing to edit the whole page",
// "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters" => "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters",
// "Page ranking reload probability" => "Page ranking reload probability",
// "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking" => "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking",
// "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register" => "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register",
// "Provide a JavaScript alert before the user\\'s lock on a page times out" => "Provide a JavaScript alert before the user\\'s lock on a page times out",
// "Global snippets of text that can be included in wiki pages and edited in place" => "Global snippets of text that can be included in wiki pages and edited in place",
// "Single (%varname%)" => "Single (%varname%)",
// "Double (%%varname%%)" => "Double (%%varname%%)",
// "Make dynamic variable content language specific" => "Make dynamic variable content language specific",
// "Status" => "Status",
// "Links" => "Links",
// "Allow to manage keywords on a per-page basis" => "Allow to manage keywords on a per-page basis",
// "When listing similar pages, such as in missing page 404, only display pages in the same language as the request" => "When listing similar pages, such as in missing page 404, only display pages in the same language as the request",
// "Reject save attempts not providing an edit summary to describe the changes made" => "Reject save attempts not providing an edit summary to describe the changes made",
// "Displays Next/Back buttons, breadcrumbs, and form to add a new page" => "Displays Next/Back buttons, breadcrumbs, and form to add a new page",
// "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation" => "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation",
// "Enable users to rate articles based on a simple numeric scale" => "Enable users to rate articles based on a simple numeric scale",
// "List of options available for the rating of wiki pages" => "List of options available for the rating of wiki pages",
// "Comma separated list of prefixes of which pages will be redirected to page with semantic link" => "Comma separated list of prefixes of which pages will be redirected to page with semantic link",
// "Force bounce of editing of approved pages to staging" => "Force bounce of editing of approved pages to staging",
// "Delete staging pages at approval" => "Delete staging pages at approval",
// "Unique page name prefix to indicate staging copy" => "Unique page name prefix to indicate staging copy",
// "Hide page name prefix" => "Hide page name prefix",
// "Categorize approved pages with categories of staging copy on approval" => "Categorize approved pages with categories of staging copy on approval",
// "Replace freetags with that of staging pages, on approval" => "Replace freetags with that of staging pages, on approval",
// "Add new freetags of approved copy (into tags field) when editing staging pages" => "Add new freetags of approved copy (into tags field) when editing staging pages",
// "Approved" => "Approved",
// "(mandatory for feature to work)" => "(mandatory for feature to work)",
// "Out-of-sync" => "Out-of-sync",
// "If not in the group, edit is always redirected to the staging page edit" => "If not in the group, edit is always redirected to the staging page edit",
// "Global cache time for the plugin snarf in seconds" => "Global cache time for the plugin snarf in seconds",
// "Default cache time for the plugin snarf" => "Default cache time for the plugin snarf",
// "0 for no cache" => "0 for no cache",
// "Inline plugin %0" => "Inline plugin %0",
// "This allows a mixture of wiki and html. All wiki syntax is parsed" => "This allows a mixture of wiki and html. All wiki syntax is parsed",
// "This also allows a mixture of wiki and html. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)" => "This also allows a mixture of wiki and html. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)",
// "Kama (Default)" => "Kama (Default)",
// "Office 2003" => "Office 2003",
// "V2 (FCKEditor appearance)" => "V2 (FCKEditor appearance)",
// "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead " => "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead ",
// "List of font names separated by" => "List of font names separated by",
// "SMTP Server" => "SMTP Server",
// "SSL" => "SSL",
// "TLS" => "TLS",
// "Sendmail" => "Sendmail",
// "SMTP" => "SMTP",
// "Mail server authentication" => "Mail server authentication",
// "LOGIN" => "LOGIN",
// "PLAIN" => "PLAIN",
// "CRAM-MD5" => "CRAM-MD5",
// "Nothing was changed, please check profile for errors" => "Nothing was changed, please check profile for errors",
// "An error occurred: " => "An error occurred: ",
// "Applying profile" => "Applying profile",
// "Added (or modified)" => "Added (or modified)",
// "Preference set" => "Preference set",
// "Group changed (or modified)" => "Group changed (or modified)",
// "Modified permission %s for %s" => "Modified permission %s for %s",
// "Modified permission %s on %s/%s for %s" => "Modified permission %s on %s/%s for %s",
// "User %0 was added to %1" => "User %0 was added to %1",
// "Created by profile installer" => "Created by profile installer",
// "Page updated by profile installer" => "Page updated by profile installer",
// "File gallery does not exist" => "File gallery does not exist",
// "File gallery already exists" => "File gallery already exists",
// "Calendar does not exist" => "Calendar does not exist",
// "Calendar already exists" => "Calendar already exists",
// "Syntax error: " => "Syntax error: ",
// "Circular reference" => "Circular reference",
// "No name" => "No name",
// "Bad object" => "Bad object",
// "Permissions' object must have a field 'type' and 'id'" => "Permissions' object must have a field 'type' and 'id'",
// "Needs a 'type' and 'data' field" => "Needs a 'type' and 'data' field",
// "Forums last posts" => "Forums last posts",
// "Downloads" => "Downloads",
// "Expecting three arguments for article-info" => "Expecting three arguments for article-info",
// "Unsupported property. Supported properties are: ' . implode( " => "Unsupported property. Supported properties are: ' . implode( ",
// "Articles feature not enabled" => "Articles feature not enabled",
// "Unexpected values: %0" => "Unexpected values: %0",
// "Invalid property" => "Invalid property",
// "Object must be provided and contain two arguments: type and object" => "Object must be provided and contain two arguments: type and object",
// "Invalid range" => "Invalid range",
// "Invalid revote period" => "Invalid revote period",
// "Expecting \"keep\" to be \"latest\" or \"oldest\"" => "Expecting \"keep\" to be \"latest\" or \"oldest\"",
// "Unknown variables referenced: %0" => "Unknown variables referenced: %0",
// "You must choose a group" => "You must choose a group",
// "Username is required" => "Username is required",
// "Username cannot contain uppercase letters" => "Username cannot contain uppercase letters",
// "Username must be at least" => "Username must be at least",
// "Username cannot contain more than" => "Username cannot contain more than",
// "characters" => "characters",
// "This invitation does not exist or is deprecated or wrong email" => "This invitation does not exist or is deprecated or wrong email",
// "Yesterday" => "Yesterday",
// "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category" => "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category",
// "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category" => "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category",
// "The fields title and description are mandatory to generate a feed" => "The fields title and description are mandatory to generate a feed",
// "To fix this error go to Admin -> Feeds" => "To fix this error go to Admin -> Feeds",
// "Please contact the site administrator and ask him to fix this error" => "Please contact the site administrator and ask him to fix this error",
// "If you set feed author email or url you have to set feed author name" => "If you set feed author email or url you have to set feed author name",
// "Feed logo" => "Feed logo",
// "Wiki Comment" => "Wiki Comment",
// "Calendar item" => "Calendar item",
// "Tracker item" => "Tracker item",
// "Tracker" => "Tracker",
// "Trackeritem" => "Trackeritem",
// "You must choose an option" => "You must choose an option",
// "For you to vote, cookies must be allowed" => "For you to vote, cookies must be allowed",
// "This poll is closed" => "This poll is closed",
// "Tiki RSS feed for calendars" => "Tiki RSS feed for calendars",
// "Last files uploaded to this file gallery. " => "Last files uploaded to this file gallery. ",
// "Last posts to this forum. " => "Last posts to this forum. ",
// "Last images uploaded to the image galleries" => "Last images uploaded to the image galleries",
// "Last images uploaded to this image gallery. " => "Last images uploaded to this image gallery. ",
// "Last shoutbox messages" => "Last shoutbox messages",
// "Tiki RSS feed for shoutbox messages" => "Tiki RSS feed for shoutbox messages",
// "Last items published on this tracker" => "Last items published on this tracker",
// "_HOMEPAGE_CONTENT_" => "_HOMEPAGE_CONTENT_",
// "Saved" => "Saved",
// "Save failed" => "Save failed",
// "UPS_CODE_' . \$xp->query( 'Service/Code" => "UPS_CODE_' . \$xp->query( 'Service/Code",
// "Link" => "Link",
// "You are not in group of friends to have the content of this block displayed for you" => "You are not in group of friends to have the content of this block displayed for you",
// "Smarty block.display.php: Missing error param" => "Smarty block.display.php: Missing error param",
// "<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin inactive: feature_jquery off -->",
// "Fast Next" => "Fast Next",
// "Fast Prev" => "Fast Prev",
// "First {\$params['itemname']}" => "First {\$params['itemname']}",
// "Last {\$params['itemname']}" => "Last {\$params['itemname']}",
// "Next {\$params['itemname']}" => "Next {\$params['itemname']}",
// "Prev {\$params['itemname']}" => "Prev {\$params['itemname']}",
// "confirm" => "confirm",
// "information" => "information",
// "Tip" => "Tip",
// "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer" => "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer",
// "There is an autosaved version of this content, to use it instead of this saved one" => "There is an autosaved version of this content, to use it instead of this saved one",
// "If you want the saved version instead of this autosaved draft" => "If you want the saved version instead of this autosaved draft",
// "AutoSave" => "AutoSave",
// "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this" => "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this",
// "Your edit session has expired" => "Your edit session has expired",
// "Your edit session will expire in" => "Your edit session will expire in",
// "You must PREVIEW or SAVE your work now, to avoid losing your edits" => "You must PREVIEW or SAVE your work now, to avoid losing your edits",
// "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page",
// "Help page" => "Help page",
// "View tpl" => "View tpl",
// "Edit Template" => "Edit Template",
// "Admin page" => "Admin page",
// "Plugin name not specified" => "Plugin name not specified",
// "Minute" => "Minute",
// "Once checked, click on any string to translate it" => "Once checked, click on any string to translate it",
// "Click here to go to Edit Languages" => "Click here to go to Edit Languages",
// "Save translations" => "Save translations",
// "Changes will be applied on next page load only" => "Changes will be applied on next page load only",
// "The text is" => "The text is",
// "Date Selector" => "Date Selector",
// "Month beginning" => "Month beginning",
// "Week beginning" => "Week beginning",
// "Data (change %)" => "Data (change %)",
// "No object information provided" => "No object information provided",
// "No rules to display object %1 of type %0" => "No rules to display object %1 of type %0",
// "Relation not found" => "Relation not found",
// "Currency in payment (%0) does not match the currency for that registry (%1)" => "Currency in payment (%0) does not match the currency for that registry (%1)",
// "This invoice does not exist or is in limited access" => "This invoice does not exist or is in limited access",
// "PHPLayersMenus are not enabled on this site" => "PHPLayersMenus are not enabled on this site",
// "Preference name not specified" => "Preference name not specified",
// "(not found in an admin panel)" => "(not found in an admin panel)",
// "Preference %0 is not defined" => "Preference %0 is not defined",
// "No object information provided for rating" => "No object information provided for rating",
// "An error occured" => "An error occured",
// "No rows found" => "No rows found",
// "Number of items in _checkboxColumnIndex doesn not match items in _checkbox" => "Number of items in _checkboxColumnIndex doesn not match items in _checkbox",
// "Number of items in _checkboxTitles doesn not match items in _checkbox" => "Number of items in _checkboxTitles doesn not match items in _checkbox",
// "years" => "years",
// "weeks" => "weeks",
// "Text cut here" => "Text cut here",
// "km" => "km",
// "More info about %0 (idle for %1)" => "More info about %0 (idle for %1)",
// " seconds" => " seconds",
// "Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission denied: the specified wiki page cannot be used as Smarty template resource",
// "Days with the most pageviews" => "Days with the most pageviews",
// "Day with the most pageviews" => "Day with the most pageviews",
// "Days with the least pageviews" => "Days with the least pageviews",
// "Day with the least pageviews" => "Day with the least pageviews",
// "No pageviews yet" => "No pageviews yet",
// "n/a" => "n/a",
// "You have to make %d choice(s) for the question" => "You have to make %d choice(s) for the question",
// "You have to make at least %d choice(s) for the question" => "You have to make at least %d choice(s) for the question",
// "You have to make less than %d choice(s) for the question" => "You have to make less than %d choice(s) for the question",
// "You have to choose at least %d choice(s) for the question" => "You have to choose at least %d choice(s) for the question",
// "Unknown conversion" => "Unknown conversion",
// "Foo" => "Foo",
// "Sample plugin" => "Sample plugin",
// "Face" => "Face",
// "Font family to use" => "Font family to use",
// "As defined by CSS" => "As defined by CSS",
// "Sea Surfing (CSRF) detected. Operation blocked" => "Sea Surfing (CSRF) detected. Operation blocked",
// "Page '%0' cannot be found" => "Page '%0' cannot be found",
// "For the security of your password direct access to the feed is only available via https" => "For the security of your password direct access to the feed is only available via https",
// "Help link" => "Help link",
// "Edit Plugin" => "Edit Plugin",
// "Plugin <strong>%0</strong> does not exist" => "Plugin <strong>%0</strong> does not exist",
// "(external link)" => "(external link)",
// "index" => "index",
// "smiling" => "smiling",
// "grinning" => "grinning",
// "cool" => "cool",
// "crying" => "crying",
// "frightened" => "frightened",
// "evil stuff" => "evil stuff",
// "exclamation mark " => "exclamation mark ",
// "frowning" => "frowning",
// "light bulb" => "light bulb",
// "idea " => "idea ",
// "LOL" => "LOL",
// "laughing out loud " => "laughing out loud ",
// "mr. green laughing" => "mr. green laughing",
// "The file was uploaded with success" => "The file was uploaded with success",
// "The file you are trying upload was only partially uploaded" => "The file you are trying upload was only partially uploaded",
// "No file was uploaded. Was a file selected " => "No file was uploaded. Was a file selected ",
// "A temporary folder is missing" => "A temporary folder is missing",
// "Unknown error" => "Unknown error",
// "Flash player not available" => "Flash player not available",
// "pics/icons/text_bold.png" => "pics/icons/text_bold.png",
// "pics/icons/text_italic.png" => "pics/icons/text_italic.png",
// "pics/icons/text_underline.png" => "pics/icons/text_underline.png",
// "pics/icons/text_strikethrough.png" => "pics/icons/text_strikethrough.png",
// "pics/icons/noparse.png" => "pics/icons/noparse.png",
// "pics/icons/text_align_center.png" => "pics/icons/text_align_center.png",
// "Horizontal Bar" => "Horizontal Bar",
// "pics/icons/page.png" => "pics/icons/page.png",
// "pics/icons/page_break.png" => "pics/icons/page_break.png",
// "Box" => "Box",
// "pics/icons/box.png" => "pics/icons/box.png",
// "pics/icons/email.png" => "pics/icons/email.png",
// "pics/icons/book.png" => "pics/icons/book.png",
// "pics/icons/text_list_bullets.png" => "pics/icons/text_list_bullets.png",
// "pics/icons/text_list_numbers.png" => "pics/icons/text_list_numbers.png",
// "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif" => "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif",
// "img/smiles/icon_smile.gif" => "img/smiles/icon_smile.gif",
// "pics/icons/palette.png" => "pics/icons/palette.png",
// "Background Color" => "Background Color",
// "pics/icons/palette_bg.png" => "pics/icons/palette_bg.png",
// "Wiki Link" => "Wiki Link",
// "pics/icons/page_link.png" => "pics/icons/page_link.png",
// "pics/icons/world_link.png" => "pics/icons/world_link.png",
// "pics/icons/table.png" => "pics/icons/table.png",
// "pics/icons/find.png" => "pics/icons/find.png",
// "pics/icons/text_replace.png" => "pics/icons/text_replace.png",
// "pics/icons/pictures.png" => "pics/icons/pictures.png",
// "Switch Editor (wiki or WYSIWYG)" => "Switch Editor (wiki or WYSIWYG)",
// "pics/icons/pencil_go.png" => "pics/icons/pencil_go.png",
// "Save Sheet" => "Save Sheet",
// "pics/icons/disk.png" => "pics/icons/disk.png",
// "Add Row After Selection Or To End If No Selection" => "Add Row After Selection Or To End If No Selection",
// "pics/icons/sheet_row_add.png" => "pics/icons/sheet_row_add.png",
// "Add Multiple Rows After Selection Or To End If No Selection" => "Add Multiple Rows After Selection Or To End If No Selection",
// "pics/icons/sheet_row_add_multi.png" => "pics/icons/sheet_row_add_multi.png",
// "Add Row Before Selection Or To End If No Selection" => "Add Row Before Selection Or To End If No Selection",
// "Delete Selected Row" => "Delete Selected Row",
// "pics/icons/sheet_row_delete.png" => "pics/icons/sheet_row_delete.png",
// "Add Column After Selection Or To End If No Selection" => "Add Column After Selection Or To End If No Selection",
// "pics/icons/sheet_col_add.png" => "pics/icons/sheet_col_add.png",
// "Delete Selected Column" => "Delete Selected Column",
// "pics/icons/sheet_col_delete.png" => "pics/icons/sheet_col_delete.png",
// "Add Multiple Columns After Selection Or To End If No Selection" => "Add Multiple Columns After Selection Or To End If No Selection",
// "pics/icons/sheet_col_add_multi.png" => "pics/icons/sheet_col_add_multi.png",
// "Add Column Before Selection Or To End If No Selection" => "Add Column Before Selection Or To End If No Selection",
// "Get Cell Range" => "Get Cell Range",
// "pics/icons/sheet_get_range.png" => "pics/icons/sheet_get_range.png",
// "Refresh Calculations" => "Refresh Calculations",
// "pics/icons/arrow_refresh.png" => "pics/icons/arrow_refresh.png",
// "Finish Editing" => "Finish Editing",
// "pics/icons/close.png" => "pics/icons/close.png",
// "Item Modification" => "Item Modification",
// "Item creation" => "Item creation",
// "View the tracker item at" => "View the tracker item at",
// "Field is not numeric" => "Field is not numeric",
// "half column" => "half column",
// "prepend" => "prepend",
// "append" => "append",
// "max" => "max",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax,distinct</strong>\n\t\t\t\t<dt>Example: 0,80,5,200,30\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd><strong>[distinct]</strong> is y or n. y = all values of the field must be different\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax,distinct</strong>\n\t\t\t\t<dt>Example: 0,80,5,200,30\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd><strong>[distinct]</strong> is y or n. y = all values of the field must be different\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,decimals,dec_point,thousands</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[decimals]</strong> sets the number of decimal places;\n\t\t\t\t<dd><strong>[dec_point]</strong> sets the separator for the decimal point (decimals must also be set). Use c for comma and s for space;\n\t\t\t\t<dd><strong>[thousands]</strong> sets the thousands separator. Use c for comma and s for space. Setting only commas will result in no decimals \n\t\t\t\t\t\t\t\t\t\t\t\t\tand commas as the thousands seprator;<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,decimals,dec_point,thousands</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[decimals]</strong> sets the number of decimal places;\n\t\t\t\t<dd><strong>[dec_point]</strong> sets the separator for the decimal point (decimals must also be set). Use c for comma and s for space;\n\t\t\t\t<dd><strong>[thousands]</strong> sets the thousands separator. Use c for comma and s for space. Setting only commas will result in no decimals \n\t\t\t\t\t\t\t\t\t\t\t\t\tand commas as the thousands seprator;<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "currency amount" => "currency amount",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,locale,symbol,first</strong>\n\t\t\t\t<dt>Example: 0,60,,per item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[locale]</strong> set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1 (default=en_US);\n\t\t\t\t<dd><strong>[currency]</strong> The 3-letter ISO 4217 currency code indicating the currency to use (default=USD);\n\t\t\t\t<dd><strong>[symbol]</strong> i for international symbol, n for local (default=n);\n\t\t\t\t<dd><strong>[all_symbol]</strong> set to 1 to show symbol for every item (default only shows currency symbol on first item in a list) ;\n\t\t\t\t<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,locale,symbol,first</strong>\n\t\t\t\t<dt>Example: 0,60,,per item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[locale]</strong> set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1 (default=en_US);\n\t\t\t\t<dd><strong>[currency]</strong> The 3-letter ISO 4217 currency code indicating the currency to use (default=USD);\n\t\t\t\t<dd><strong>[symbol]</strong> i for international symbol, n for local (default=n);\n\t\t\t\t<dd><strong>[all_symbol]</strong> set to 1 to show symbol for every item (default only shows currency symbol on first item in a list) ;\n\t\t\t\t<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "radio buttons" => "radio buttons",
// "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriage return\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriage return\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>",
// "IP selector" => "IP selector",
// "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>",
// "page selector" => "page selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong> will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd><strong>[link]</strong> will not display the link to the page if equals to n \n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong> will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd><strong>[link]</strong> will not display the link to the page if equals to n \n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "country selector" => "country selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>when set to \"empty\" will allow selection of empty date but default to current date\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>when set to \"empty\" will allow selection of empty date but default to current date\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: will display the field name as a html header h2;\n\t\t\t\t<dt>Usage: <strong>level</strong>\n\t\t\t\t<dt>Example: 2\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[level]</strong> level of the html header (default 2)\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: will display the field name as a html header h2;\n\t\t\t\t<dt>Usage: <strong>level</strong>\n\t\t\t\t<dt>Example: 2\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[level]</strong> level of the html header (default 2)\n\t\t\t\t</dl>",
// "static text" => "static text",
// "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall,descendants</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd><strong>[descendants]</strong> All descendant categories (not just first level children) will be included if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall,descendants</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd><strong>[descendants]</strong> All descendant categories (not just first level children) will be included if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "item link" => "item link",
// "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,0,6|8,opc,PageName\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd><strong>[linkPage]</strong> is the name of the wiki page to link to with trackerlist plugin in it; \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,0,6|8,opc,PageName\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd><strong>[linkPage]</strong> is the name of the wiki page to link to with trackerlist plugin in it; \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "dynamic items list" => "dynamic items list",
// "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>",
// "auto-increment" => "auto-increment",
// "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "user subscription" => "user subscription",
// "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t<dt>Usage: <strong>use_as_item_location,bubble_fieldId,icon</strong>\n\t\t\t\t<dt>Example: y,23|24,img/icons2/icn_members.gif\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[use_as_item_location]</strong> if set to y, this google map field will be used as item location and object geo attributes are set when field value is changed.\n\t\t\t\t<dd><strong>[bubble_fieldid]</strong> is the fieldId(s) (separated by |) that contains the text that will be displayed in the bubble of the map marker. The first field will be used as the link.\n\t\t\t\t<dd><strong>[icon]</strong> is the url of the default icon to use for markers of items on the map.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t<dt>Usage: <strong>use_as_item_location,bubble_fieldId,icon</strong>\n\t\t\t\t<dt>Example: y,23|24,img/icons2/icn_members.gif\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[use_as_item_location]</strong> if set to y, this google map field will be used as item location and object geo attributes are set when field value is changed.\n\t\t\t\t<dd><strong>[bubble_fieldid]</strong> is the fieldId(s) (separated by |) that contains the text that will be displayed in the bubble of the map marker. The first field will be used as the link.\n\t\t\t\t<dd><strong>[icon]</strong> is the url of the default icon to use for markers of items on the map.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>",
// "computed field" => "computed field",
// "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>",
// "user preference" => "user preference",
// "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email, other values possible: language;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email, other values possible: language;\n\t\t\t\t</dl>",
// "user groups" => "user groups",
// "<dl>\n\t\t\t\t<dt>Function: Allows to display the user groups.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows to display the user groups.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows freetags to be shown or added for tracker item\n\t\t\t\t<dt>Usage: <strong>size</strong>\n\t\t\t\t<dt>Example: 80,n,n\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[hidehelp]</strong> if y, do not show help text when entering tags;\n\t\t\t\t<dd><strong>[hidesuggest]</strong> if y, do not show suggested tags when entering tags;  \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows freetags to be shown or added for tracker item\n\t\t\t\t<dt>Usage: <strong>size</strong>\n\t\t\t\t<dt>Example: 80,n,n\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[hidehelp]</strong> if y, do not show help text when entering tags;\n\t\t\t\t<dd><strong>[hidesuggest]</strong> if y, do not show suggested tags when entering tags;  \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "in group" => "in group",
// "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Display stars\n\t\t\t\t<dt>Usage: <strong>list options (positive increasing numbers</strong>\n\t\t\t\t<dt>Example: 1,2,3,4\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Like the rating\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Display stars\n\t\t\t\t<dt>Usage: <strong>list options (positive increasing numbers</strong>\n\t\t\t\t<dt>Example: 1,2,3,4\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Like the rating\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "No extra information for that attached file. " => "No extra information for that attached file. ",
// "(AT)" => "(AT)",
// "(DOT)" => "(DOT)",
// "The administrator has not yet validated your account. Please wait" => "The administrator has not yet validated your account. Please wait",
// "You must validate your account first. An email has been sent to you" => "You must validate your account first. An email has been sent to you",
// "The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "The registration mail can't be sent because there is no server email address set, and this feature is disabled",
// "The user email confirmation can't be sent. Contact the administrator" => "The user email confirmation can't be sent. Contact the administrator",
// "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)",
// "Edit field: (Incorrect validation parameter)" => "Edit field: (Incorrect validation parameter)",
// "Invalid character combination for username" => "Invalid character combination for username",
// "Could not establish Kaltura session. Try again" => "Could not establish Kaltura session. Try again",
// "Successfully stored archive in tracker" => "Successfully stored archive in tracker",
// "Failed to stored archive in tracker" => "Failed to stored archive in tracker",
// "Cannot connect with web service" => "Cannot connect with web service",
// "No permission to broadcast to channel" => "No permission to broadcast to channel",
// "Broadcaster successfully authenticated" => "Broadcaster successfully authenticated",
// "No permission to broadcast to any channel" => "No permission to broadcast to any channel",
// "Successfully logged in mobile broadcaster" => "Successfully logged in mobile broadcaster",
// "No viewable channels available for mobile" => "No viewable channels available for mobile",
// "Failed to log in mobile broadcaster" => "Failed to log in mobile broadcaster",
// "Successfully logged in FME" => "Successfully logged in FME",
// "Failed to log in FME" => "Failed to log in FME",
// "No permission to view channel" => "No permission to view channel",
// "Viewer successfully authenticated" => "Viewer successfully authenticated",
// "No permission to view any channel" => "No permission to view any channel",
// "Mailbox uninitialised??" => "Mailbox uninitialised??",
// "No mail body found" => "No mail body found",
// "PluginAddToCart" => "PluginAddToCart",
// "Product code" => "Product code",
// "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in",
// "Label for the product in the cart" => "Label for the product in the cart",
// "Price" => "Price",
// "The price to charge for the item" => "The price to charge for the item",
// "URL of the product\\'s information. The URL may be relative or absolute (begin with http://)" => "URL of the product\\'s information. The URL may be relative or absolute (begin with http://)",
// "Text for the submit button. default: \"Add to cart\"" => "Text for the submit button. default: \"Add to cart\"",
// "A session must be active to use the cart" => "A session must be active to use the cart",
// "%0 (%1) was added to your cart" => "%0 (%1) was added to your cart",
// "Create an icon for a user to add an event to Google Calendar" => "Create an icon for a user to add an event to Google Calendar",
// "PluginAddToGoogleCal" => "PluginAddToGoogleCal",
// "Calendar item ID" => "Calendar item ID",
// "The item ID of the calendar to add to Google calendar" => "The item ID of the calendar to add to Google calendar",
// "A calendar item ID number" => "A calendar item ID number",
// "Icon Style" => "Icon Style",
// "Choose the icon style" => "Choose the icon style",
// "Either 1, 2 or 3" => "Either 1, 2 or 3",
// "Two" => "Two",
// "Three" => "Three",
// "User Agent Info" => "User Agent Info",
// "PluginAgentinfo" => "PluginAgentinfo",
// "Display\\'s the visitor\\'s IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "Display\\'s the visitor\\'s IP address (IP or default), browser information (BROWSER), or server software (SVRSW)",
// "IP address" => "IP address",
// "Server software" => "Server software",
// "Browser" => "Browser",
// "Displays browser client info" => "Displays browser client info",
// "PluginAlink" => "PluginAlink",
// "Anchor link label" => "Anchor link label",
// "The anchor name as defined in the ANAME plugin" => "The anchor name as defined in the ANAME plugin",
// "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used",
// "Creates a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which specifies the location and name of the anchor" => "Creates a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which specifies the location and name of the anchor",
// "PluginAname" => "PluginAname",
// "The name of the anchor" => "The name of the anchor",
// "Creates an anchor in a wiki page. Use in conjunction with the ALINK plugin, which specifies a link to the anchor" => "Creates an anchor in a wiki page. Use in conjunction with the ALINK plugin, which specifies a link to the anchor",
// "PluginAnnotation" => "PluginAnnotation",
// "Autogenerated content. Leave blank initially" => "Autogenerated content. Leave blank initially",
// "Absolute URL to the image or relative path from tiki root" => "Absolute URL to the image or relative path from tiki root",
// "Width" => "Width",
// "Image width in pixels" => "Image width in pixels",
// "Height" => "Height",
// "Image height in pixels" => "Image height in pixels",
// "Alignment" => "Alignment",
// "Image alignment. Possible values: left, right, center. Default is left" => "Image alignment. Possible values: left, right, center. Default is left",
// "Save changes to annotations" => "Save changes to annotations",
// "Image annotations changed" => "Image annotations changed",
// "PluginArchiveBuilder" => "PluginArchiveBuilder",
// "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435",
// "Archive Name" => "Archive Name",
// "Upon download, the name of the file that will be provided" => "Upon download, the name of the file that will be provided",
// "Missing extension zip" => "Missing extension zip",
// "Incorrect parameter" => "Incorrect parameter",
// "Download archive" => "Download archive",
// "PluginArticle" => "PluginArticle",
// "Includes an article\\'s content within the page" => "Includes an article\\'s content within the page",
// "The article field to display. Default field is Heading" => "The article field to display. Default field is Heading",
// "Article ID" => "Article ID",
// "The article to display. If no value is provided, most recent article will be used" => "The article to display. If no value is provided, most recent article will be used",
// "Includes an article" => "Includes an article",
// "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~" => "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~",
// "Id is optional. If not given, last article is used. Default field is heading" => "Id is optional. If not given, last article is used. Default field is heading",
// "PluginArticles" => "PluginArticles",
// "Use Pagination" => "Use Pagination",
// "Activate pagination when articles listing are long. Default is n" => "Activate pagination when articles listing are long. Default is n",
// "Maximum Displayed" => "Maximum Displayed",
// "The number of articles to display in the list (no max set by default)" => "The number of articles to display in the list (no max set by default)",
// "If Pagination is set to y (Yes), this will determine the amount of artilces per page" => "If Pagination is set to y (Yes), this will determine the amount of artilces per page",
// "Topic Name Filter" => "Topic Name Filter",
// "Filter the list of aricles by their topic. Example: " => "Filter the list of aricles by their topic. Example: ",
// "Topic ID Filter" => "Topic ID Filter",
// "Filter the list of aricles by their topic ID. Example: " => "Filter the list of aricles by their topic ID. Example: ",
// "Type Filter" => "Type Filter",
// "Filter the list of aricles by their types. Example: " => "Filter the list of aricles by their types. Example: ",
// "Category ID" => "Category ID",
// "The ID of the category that articles need to be in to be listed" => "The ID of the category that articles need to be in to be listed",
// "List only articles in this language" => "List only articles in this language",
// "Sort order" => "Sort order",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Use random to have random items" => "Use random to have random items",
// "Quiet" => "Quiet",
// "Whether to not report when there are no articles (no reporting by default)" => "Whether to not report when there are no articles (no reporting by default)",
// "Title Only" => "Title Only",
// "Whether to only show the title of the articles (not set to title only by default)" => "Whether to only show the title of the articles (not set to title only by default)",
// "Body Only" => "Body Only",
// "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)" => "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)",
// "Starting Article" => "Starting Article",
// "The article number that the list should start with (starts with first article by default)" => "The article number that the list should start with (starts with first article by default)",
// "This will not work if Pagination is used" => "This will not work if Pagination is used",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// "End date" => "End date",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Override Dates" => "Override Dates",
// "Whether to obey article type\\'s \"show before publish\" and \"show after expiry\" settings (not obeyed by default)" => "Whether to obey article type\\'s \"show before publish\" and \"show after expiry\" settings (not obeyed by default)",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "Large First Image" => "Large First Image",
// "If set to y (Yes), the first image will be displayed with the dimension used to view of the article" => "If set to y (Yes), the first image will be displayed with the dimension used to view of the article",
// "Additional URL Param to the link to read article" => "Additional URL Param to the link to read article",
// "Show actions (buttons and links)" => "Show actions (buttons and links)",
// "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do",
// "Includes articles listing into a wiki page" => "Includes articles listing into a wiki page",
// "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~",
// "PluginAttach" => "PluginAttach",
// "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment",
// "Same as name" => "Same as name",
// "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page",
// "Show Description" => "Show Description",
// "Shows the description as the link text instead of the file name (not used by default)" => "Shows the description as the link text instead of the file name (not used by default)",
// "Bullets" => "Bullets",
// "Makes the list of attachments a bulleted list (not set by default)" => "Makes the list of attachments a bulleted list (not set by default)",
// "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)",
// "Custom Label" => "Custom Label",
// "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed" => "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)",
// "Order Number" => "Order Number",
// "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. \n\t\t\t\t\t\t\t\t\t\tEither name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. \n\t\t\t\t\t\t\t\t\t\tEither name, file, id or num can be used to identify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment",
// "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)",
// "File Type Icon" => "File Type Icon",
// "A file type icon is displayed in front of the attachment link when this is set to 1" => "A file type icon is displayed in front of the attachment link when this is set to 1",
// "No such attachment on this page" => "No such attachment on this page",
// "Gives the name of the attached file to link to" => "Gives the name of the attached file to link to",
// "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages" => "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages",
// "Shows the description as the link text instead of the file name" => "Shows the description as the link text instead of the file name",
// "Makes the list of attachments a bulleted list" => "Makes the list of attachments a bulleted list",
// "Says that this file is an image, and should be displayed inline using the img tag" => "Says that this file is an image, and should be displayed inline using the img tag",
// "Makes the text between the {ATTACH} tags the link text instead of the file name or description" => "Makes the text between the {ATTACH} tags the link text instead of the file name or description",
// "Shows all attachments from the whole wiki" => "Shows all attachments from the whole wiki",
// "Gives the number, in the list of attachments, of the attachment to link to" => "Gives the number, in the list of attachments, of the attachment to link to",
// "Gives the actual id of the attachment to link in. You probably should never use this" => "Gives the actual id of the attachment to link in. You probably should never use this",
// "Puts the number of downloads in the alt comment" => "Puts the number of downloads in the alt comment",
// "Shows a file icon" => "Shows a file icon",
// "PluginAttributes" => "PluginAttributes",
// "PluginAuthor" => "PluginAuthor",
// "Color codes parts of the page like \\'Track changes\\' in Office programs" => "Color codes parts of the page like \\'Track changes\\' in Office programs",
// "User Name" => "User Name",
// "User name of the user who wrote the text" => "User name of the user who wrote the text",
// "Deleted by User" => "Deleted by User",
// "User name of the user who deleted the text" => "User name of the user who deleted the text",
// "Make Visible" => "Make Visible",
// "Show popup with author/deleted by" => "Show popup with author/deleted by",
// "Generate a popup with names of author(s) (default: no)" => "Generate a popup with names of author(s) (default: no)",
// "deleted by" => "deleted by",
// "Shows which author created/deleted which text" => "Shows which author created/deleted which text",
// "Should this author's contribution be visible (default: no)" => "Should this author's contribution be visible (default: no)",
// "Avatar" => "Avatar",
// "PluginAvatar" => "PluginAvatar",
// "The wiki page the avatar will link to. If empty and the user\\'s information is public, \n\t\t\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user\\'s user information page" => "The wiki page the avatar will link to. If empty and the user\\'s information is public, \n\t\t\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user\\'s user information page",
// "Float" => "Float",
// "Align the avatar on the page" => "Align the avatar on the page",
// "PluginBack" => "PluginBack",
// "Displays a link that goes back one page in the browser history" => "Displays a link that goes back one page in the browser history",
// "Insert back link on wiki page" => "Insert back link on wiki page",
// "PluginBacklinks" => "PluginBacklinks",
// "The page links will point to. Default value is the current page" => "The page links will point to. Default value is the current page",
// "Displayed Information" => "Displayed Information",
// "Pipe separated list of fields to display. ex: hits|user" => "Pipe separated list of fields to display. ex: hits|user",
// "Excluded pages" => "Excluded pages",
// "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox",
// "Include Self" => "Include Self",
// "With or without self-link (default is without)" => "With or without self-link (default is without)",
// "Header" => "Header",
// "With or without header (default is with header)" => "With or without header (default is with header)",
// "With header" => "With header",
// "Without header" => "Without header",
// "List all pages that link to specific pages" => "List all pages that link to specific pages",
// "No pages link to" => "No pages link to",
// "Banner" => "Banner",
// "PluginBanner" => "PluginBanner",
// "Name of the zone created in Admin > Banners" => "Name of the zone created in Admin > Banners",
// "Target" => "Target",
// "Determines the browser behavior once the banner is clicked" => "Determines the browser behavior once the banner is clicked",
// "Blank" => "Blank",
// "missing parameter" => "missing parameter",
// "PluginBigBlueButton" => "PluginBigBlueButton",
// "Meeting" => "Meeting",
// "MeetingID provided by BigBlueButton" => "MeetingID provided by BigBlueButton",
// "Anonymous prefix" => "Anonymous prefix",
// "Unregistered users will get this token prepended to their name" => "Unregistered users will get this token prepended to their name",
// "Welcome Message" => "Welcome Message",
// "A message to be provided when someone enters the room" => "A message to be provided when someone enters the room",
// "Dial Number" => "Dial Number",
// "The phone-in support number to join from traditional phones" => "The phone-in support number to join from traditional phones",
// "Voice Bridge" => "Voice Bridge",
// "Code to enter for phone attendees to join the room" => "Code to enter for phone attendees to join the room",
// "Logout URL" => "Logout URL",
// "URL to which the user will be redirected when logging out from BigBlueButton" => "URL to which the user will be redirected when logging out from BigBlueButton",
// "Maximum Participants" => "Maximum Participants",
// "Limit to the amount of simultaneous participants in the room. Support for this parameter depends on the BigBlueButton server" => "Limit to the amount of simultaneous participants in the room. Support for this parameter depends on the BigBlueButton server",
// "Bliptv" => "Bliptv",
// "PluginBliptv" => "PluginBliptv",
// "Display a Blip.tv video" => "Display a Blip.tv video",
// "URL" => "URL",
// "Blip.tv embed URL. Please note that this url needs to be the src param in the EMBED code, and not the video URL as in other equivalent video plugins. Example: http://blip.tv/play/AYGd_GAC (instead of http://blip.tv/file/2568201/) " => "Blip.tv embed URL. Please note that this url needs to be the src param in the EMBED code, and not the video URL as in other equivalent video plugins. Example: http://blip.tv/play/AYGd_GAC (instead of http://blip.tv/file/2568201/) ",
// "Width in pixels (default is 425" => "Width in pixels (default is 425",
// "Height in pixels (default is 350)" => "Height in pixels (default is 350)",
// "PluginBlogList" => "PluginBlogList",
// "Blog ID" => "Blog ID",
// "The ID number of the blog on the site you wish to list posts from" => "The ID number of the blog on the site you wish to list posts from",
// "Maximum Items" => "Maximum Items",
// "Maximum number of entries to list (no maximum set by default)" => "Maximum number of entries to list (no maximum set by default)",
// "Only display posts created by this user (all posts listed by default)" => "Only display posts created by this user (all posts listed by default)",
// "Simple List" => "Simple List",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
// "End Date" => "End Date",
// "Latest date to select posts from" => "Latest date to select posts from",
// "Container Class" => "Container Class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "Use BLOGLIST to include posts from a blog. Syntax is" => "Use BLOGLIST to include posts from a blog. Syntax is",
// "where Id is the blog Id and Items is the max number of posts to display" => "where Id is the blog Id and Items is the max number of posts to display",
// "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~" => "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~",
// "PluginBox" => "PluginBox",
// "Box title" => "Box title",
// "Displayed above the content" => "Displayed above the content",
// "Background color" => "Background color",
// "As defined by CSS, name or Hex code" => "As defined by CSS, name or Hex code",
// "Box width" => "Box width",
// "In pixels or percentage. Default value is 100%" => "In pixels or percentage. Default value is 100%",
// "Text Alignment" => "Text Alignment",
// "Aligns the text within the box (left aligned by default)" => "Aligns the text within the box (left aligned by default)",
// "Float Position" => "Float Position",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
// "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)" => "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)",
// "CSS Class" => "CSS Class",
// "Apply custom CSS class to the box" => "Apply custom CSS class to the box",
// "PluginButton" => "PluginButton",
// "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it" => "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it",
// "Label for the button" => "Label for the button",
// "Incorrect param" => "Incorrect param",
// "lib/smarty_tiki/function.button.php is missing or unreadable" => "lib/smarty_tiki/function.button.php is missing or unreadable",
// "PluginCalendar" => "PluginCalendar",
// "Calendar IDs" => "Calendar IDs",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")",
// "View Type" => "View Type",
// "\"table\" shows events in a calendar" => "\"table\" shows events in a calendar",
// "View Time Span" => "View Time Span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar",
// "Default is month" => "Default is month",
// "Navigation Bar" => "Navigation Bar",
// "Decide or not to show the navigation bar (not shown by default)" => "Decide or not to show the navigation bar (not shown by default)",
// "PluginCategory" => "PluginCategory",
// "Category IDs" => "Category IDs",
// "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page",
// "Types" => "Types",
// "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img" => "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img",
// "Sort ascending or descending based on various attributes (sorted ascending by name by default)" => "Sort ascending or descending based on various attributes (sorted ascending by name by default)",
// "'), 'value' => '" => "'), 'value' => '",
// "Created Ascending" => "Created Ascending",
// "Created Descending" => "Created Descending",
// "Hits Ascending" => "Hits Ascending",
// "Hits Descending" => "Hits Descending",
// "Item ID Ascending" => "Item ID Ascending",
// "Item ID Descending" => "Item ID Descending",
// "Name Ascending" => "Name Ascending",
// "Name Descending" => "Name Descending",
// "Type Ascending" => "Type Ascending",
// "Type Descending" => "Type Descending",
// "Split" => "Split",
// "Whether multiple categories will be listed on different lines (default is to split them)" => "Whether multiple categories will be listed on different lines (default is to split them)",
// "And" => "And",
// "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)" => "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)",
// "With Sub-categories" => "With Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list sub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list sub-category objects)",
// "Show descriptions (not shown by default)" => "Show descriptions (not shown by default)",
// "Show Name" => "Show Name",
// "Show object names (shown by default)" => "Show object names (shown by default)",
// "Show type" => "Show type",
// "Show type (shown by default)" => "Show type (shown by default)",
// "One Per Line" => "One Per Line",
// "Show one object per line (multiple per line shown by default)" => "Show one object per line (multiple per line shown by default)",
// "Show Child Links" => "Show Child Links",
// "Show children category links (shown by default)" => "Show children category links (shown by default)",
// "Show Top Link" => "Show Top Link",
// "Show top category link (shown by default)" => "Show top category link (shown by default)",
// "Max Records" => "Max Records",
// "Maximum number of objects to list (default is 50)" => "Maximum number of objects to list (default is 50)",
// "Show Title" => "Show Title",
// "Show title text above category object lists (shown by default)" => "Show title text above category object lists (shown by default)",
// "PluginCatOrphans" => "PluginCatOrphans",
// "Display wiki pages that have not been categorized" => "Display wiki pages that have not been categorized",
// "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)" => "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)",
// "Max" => "Max",
// "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records" => "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start (default is no offset)" => "Result number at which the listing should start (default is no offset)",
// "PluginCatPath" => "PluginCatPath",
// "String used to separate the categories in the path. Default character is >" => "String used to separate the categories in the path. Default character is >",
// "Display Top Category" => "Display Top Category",
// "Show the top category as part of the path name (not shown by default)" => "Show the top category as part of the path name (not shown by default)",
// "PluginCclite" => "PluginCclite",
// "General purpose cclite utility plugin" => "General purpose cclite utility plugin",
// "Mode of operation - summary or recent. Default: summary" => "Mode of operation - summary or recent. Default: summary",
// "Account summary" => "Account summary",
// "Recent transactions" => "Recent transactions",
// "Registry" => "Registry",
// "Registry to query. Default: site preference (or first in list when more than one)" => "Registry to query. Default: site preference (or first in list when more than one)",
// "You need to be logged in to view this information" => "You need to be logged in to view this information",
// "PluginCenter" => "PluginCenter",
// "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool" => "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool",
// "Chart caption" => "Chart caption",
// "Sheet ID" => "Sheet ID",
// "Data sheet ID" => "Data sheet ID",
// "Chart Type" => "Chart Type",
// "BarStackGraphic | MultibarGraphic | MultilineGraphic | PieChartGraphic" => "BarStackGraphic | MultibarGraphic | MultilineGraphic | PieChartGraphic",
// "Chart Width" => "Chart Width",
// "Width in pixels" => "Width in pixels",
// "Chart Height" => "Chart Height",
// "Height in pixels" => "Height in pixels",
// "Value series" => "Value series",
// "Required for pie charts" => "Required for pie charts",
// "Independant series" => "Independant series",
// "Required for types other than pie chart" => "Required for types other than pie chart",
// "Dependant series" => "Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors" => "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors",
// "List of colors to use" => "List of colors to use",
// "Styles" => "Styles",
// "List of styles to use" => "List of styles to use",
// "Labels" => "Labels",
// "Labels for the series or values in the legend" => "Labels for the series or values in the legend",
// "Chart as PDF" => "Chart as PDF",
// "Chart as PostScript" => "Chart as PostScript",
// "PluginCode" => "PluginCode",
// "Caption" => "Caption",
// "Code snippet label" => "Code snippet label",
// "Word Wrap" => "Word Wrap",
// "Enable word wrapping on the code to avoid breaking the layout. May not be used with line numbers if Geshi version 1.0.8.9+" => "Enable word wrapping on the code to avoid breaking the layout. May not be used with line numbers if Geshi version 1.0.8.9+",
// "Colors" => "Colors",
// "Syntax highlighting to use. GeSHi - Generic Syntax Highlighter must be installed for languages other than php. Without GeSHi, the php tag must be included at the \n\t\t\t\t\t\t\t\t\tbeginning of the displayed code for the highlighting to work. May not be used with line numbers if Geshi version < 1.0.8.9. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Syntax highlighting to use. GeSHi - Generic Syntax Highlighter must be installed for languages other than php. Without GeSHi, the php tag must be included at the \n\t\t\t\t\t\t\t\t\tbeginning of the displayed code for the highlighting to work. May not be used with line numbers if Geshi version < 1.0.8.9. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "Line Numbers" => "Line Numbers",
// "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed" => "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed",
// "Wiki Syntax" => "Wiki Syntax",
// "Parse wiki syntax within the code snippet (not parsed by default)" => "Parse wiki syntax within the code snippet (not parsed by default)",
// "Right to Left" => "Right to Left",
// "Switch the text display from left to right to right to left  (left to right by default)" => "Switch the text display from left to right to right to left  (left to right by default)",
// "Content is HTML" => "Content is HTML",
// "When set to 1 (Yes), HTML will still be processed (presented as is by default)" => "When set to 1 (Yes), HTML will still be processed (presented as is by default)",
// "Show HTML" => "Show HTML",
// "Interpret HTML" => "Interpret HTML",
// "Copy To Clipboard" => "Copy To Clipboard",
// "Copy the contents of the code box to the clipboard  (not copied to clipboard by default)" => "Copy the contents of the code box to the clipboard  (not copied to clipboard by default)",
// "note: colors and ln are exclusive" => "note: colors and ln are exclusive",
// "colorbox" => "colorbox",
// "PluginColorBox" => "PluginColorBox",
// "Display all the images of a file gallery in a colorbox popup" => "Display all the images of a file gallery in a colorbox popup",
// "File Gallery ID" => "File Gallery ID",
// "ID number of the file gallery that contains the images to be displayed" => "ID number of the file gallery that contains the images to be displayed",
// "Image Gallery ID" => "Image Gallery ID",
// "ID number of the image gallery that contains the images to be displayed" => "ID number of the image gallery that contains the images to be displayed",
// "File ID Filter" => "File ID Filter",
// "Filter on fileIds in a file gallery to only show those images. Separate each fileId with \\':\\'" => "Filter on fileIds in a file gallery to only show those images. Separate each fileId with \\':\\'",
// "Thumb" => "Thumb",
// "Display as a thumbnail (y) or full size (n)" => "Display as a thumbnail (y) or full size (n)",
// "Sort Mode" => "Sort Mode",
// "Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc" => "Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc",
// "Show File Title" => "Show File Title",
// "Show file title" => "Show file title",
// "Show File Name" => "Show File Name",
// "Show file name" => "Show file name",
// "Show All Thumbs" => "Show All Thumbs",
// "Show thumbnails of all the images in the gallery" => "Show thumbnails of all the images in the gallery",
// "Parse Descriptions" => "Parse Descriptions",
// "Wiki parse the file descriptions" => "Wiki parse the file descriptions",
// "PluginContent" => "PluginContent",
// "Includes content from the dynamic content system" => "Includes content from the dynamic content system",
// "Content ID" => "Content ID",
// "Dynamic content ID. The value can be obtained in the listing" => "Dynamic content ID. The value can be obtained in the listing",
// "Content Label" => "Content Label",
// "Label of the dynamic content to display" => "Label of the dynamic content to display",
// "Cookie" => "Cookie",
// "PluginCookie" => "PluginCookie",
// "Display a rotating set of taglines or quotes (also known as fortune cookies)" => "Display a rotating set of taglines or quotes (also known as fortune cookies)",
// "PluginCopyright" => "PluginCopyright",
// "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~",
// "Countdown" => "Countdown",
// "PluginCountdown" => "PluginCountdown",
// "Displays a countdown from now until the specified date" => "Displays a countdown from now until the specified date",
// "Text to append to the countdown" => "Text to append to the countdown",
// "Target date. Multiple formats accepted" => "Target date. Multiple formats accepted",
// "Locate Time" => "Locate Time",
// "Set to off to only show days, otherwise hours, minutes and seconds are also shown (all are shown by default)" => "Set to off to only show days, otherwise hours, minutes and seconds are also shown (all are shown by default)",
// "Off" => "Off",
// "Items to Show" => "Items to Show",
// "Select: d=days, h=hours, m=minutes, s=seconds. Enter multiple values as: dhms. If blank, all items are shown" => "Select: d=days, h=hours, m=minutes, s=seconds. Enter multiple values as: dhms. If blank, all items are shown",
// "Days & Hours" => "Days & Hours",
// "Days, Hours & Minutes" => "Days, Hours & Minutes",
// "Days, Hours, Minutes & Seconds" => "Days, Hours, Minutes & Seconds",
// "Hours & Minutes" => "Hours & Minutes",
// "Hours, Minutes & Seconds" => "Hours, Minutes & Seconds",
// "Minutes & Seconds" => "Minutes & Seconds",
// "Seconds" => "Seconds",
// "Show time since event" => "Show time since event",
// "If y, will display amount of time since the event (default). If n will simply display that the event is over" => "If y, will display amount of time since the event (default). If n will simply display that the event is over",
// "since " => "since ",
// "until " => "until ",
// " is over" => " is over",
// "Data Channel" => "Data Channel",
// "PluginDataChannel" => "PluginDataChannel",
// "Displays a form to trigger data channels" => "Displays a form to trigger data channels",
// "List of fields to display. One field per line. Comma delimited: fieldname,label" => "List of fields to display. One field per line. Comma delimited: fieldname,label",
// "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"" => "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"",
// "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel" => "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel",
// "Channel Name" => "Channel Name",
// "Name of the channel as registered by the administrator" => "Name of the channel as registered by the administrator",
// "Return URL" => "Return URL",
// "URL to go to after data channel has run. Defaults to current page" => "URL to go to after data channel has run. Defaults to current page",
// "Do not use returnURI but instead return true quietly" => "Do not use returnURI but instead return true quietly",
// "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context" => "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context",
// "Button Label" => "Button Label",
// "Label for the submit button. Default: \"Go\"" => "Label for the submit button. Default: \"Go\"",
// "Class" => "Class",
// "CSS class for this form" => "CSS class for this form",
// "Empty Caches" => "Empty Caches",
// "Which caches to empty. Default \"Clear all Tiki caches\"" => "Which caches to empty. Default \"Clear all Tiki caches\"",
// "./templates_c/" => "./templates_c/",
// "./modules/cache/" => "./modules/cache/",
// "./temp/cache/" => "./temp/cache/",
// "./temp/public/" => "./temp/public/",
// "All user prefs sessions" => "All user prefs sessions",
// "Price to execute the datachannel (%0)" => "Price to execute the datachannel (%0)",
// "Payment Label" => "Payment Label",
// "Debug" => "Debug",
// "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)",
// "Multiple Values" => "Multiple Values",
// "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)",
// "Datachannel" => "Datachannel",
// "DBReport" => "DBReport",
// "PluginDBReport" => "PluginDBReport",
// "Run a database report. This plugin only works with adodb. It does not work with PDO" => "Run a database report. This plugin only works with adodb. It does not work with PDO",
// "report definition" => "report definition",
// "Full DSN" => "Full DSN",
// "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database",
// "Wiki DSN Name" => "Wiki DSN Name",
// "The name of a DSN connection defined by the Wiki administrator" => "The name of a DSN connection defined by the Wiki administrator",
// "Parse wiki syntax within the report (not parsed by default)" => "Parse wiki syntax within the report (not parsed by default)",
// "Display the parsed report definition (not displayed by default)" => "Display the parsed report definition (not displayed by default)",
// "Missing db or dsn parameter" => "Missing db or dsn parameter",
// "No DSN connection string found" => "No DSN connection string found",
// "Run a database report" => "Run a database report",
// "Div" => "Div",
// "PluginDiv" => "PluginDiv",
// "Insert a division block, span, blockquote or other text formatting on wiki page" => "Insert a division block, span, blockquote or other text formatting on wiki page",
// "Indicate the type of HTML tag to use (default is div)" => "Indicate the type of HTML tag to use (default is div)",
// "Span" => "Span",
// "Teletype" => "Teletype",
// "Paragraph" => "Paragraph",
// "Block quote" => "Block quote",
// "In pixels or percentage. Default is original size" => "In pixels or percentage. Default is original size",
// "Aligns the text within the element" => "Aligns the text within the element",
// "Justify" => "Justify",
// "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
// "Items are not allowed to wrap around the side(s) this parameter is set to" => "Items are not allowed to wrap around the side(s) this parameter is set to",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "HTML ID" => "HTML ID",
// "Sets the div\\'s id attribute, as defined by HTML" => "Sets the div\\'s id attribute, as defined by HTML",
// "PluginDL" => "PluginDL",
// "One entry per line. Each line is in \"Term: Definition\" format" => "One entry per line. Each line is in \"Term: Definition\" format",
// "PluginEquation" => "PluginEquation",
// "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large" => "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large",
// "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size" => "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size",
// "PluginEvents" => "PluginEvents",
// "Display upcoming events from calendars" => "Display upcoming events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)" => "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)",
// "Maximum Days" => "Maximum Days",
// "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days" => "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days",
// "Maximum Events" => "Maximum Events",
// "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)" => "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)",
// "Show Time" => "Show Time",
// "Show the time along with the date (shown by default)" => "Show the time along with the date (shown by default)",
// "Show the description of the event (shown by default)" => "Show the description of the event (shown by default)",
// "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage",
// "PluginFade" => "PluginFade",
// "Displays a label. On click, the block of content will fade in and fade out" => "Displays a label. On click, the block of content will fade in and fade out",
// "Wiki syntax containing the text to display" => "Wiki syntax containing the text to display",
// "Label to display on first display" => "Label to display on first display",
// "Unspecified label" => "Unspecified label",
// "PluginFancyList" => "PluginFancyList",
// "One item per line starting with anything followed by \")\"" => "One item per line starting with anything followed by \")\"",
// "Use Div" => "Use Div",
// "Use the HTML tag div instead of the HTML tag for lists (ol)" => "Use the HTML tag div instead of the HTML tag for lists (ol)",
// "CSS class for the fancylist" => "CSS class for the fancylist",
// "num" => "num",
// "item text" => "item text",
// "one item per line" => "one item per line",
// "PluginFancyTable" => "PluginFancyTable",
// "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases" => "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases",
// "Heading Row" => "Heading Row",
// "Header rows of the table. Use >> to separate multiple rows" => "Header rows of the table. Use >> to separate multiple rows",
// "Heading CSS Class" => "Heading CSS Class",
// "CSS class to apply to the heading row" => "CSS class to apply to the heading row",
// "Header Horizontal Align" => "Header Horizontal Align",
// "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify" => "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify",
// "Header Vertical Align" => "Header Vertical Align",
// "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline" => "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline",
// "Column Sort" => "Column Sort",
// "Indicate whether columns are sortable or not (not sortable by default)" => "Indicate whether columns are sortable or not (not sortable by default)",
// "Pre-sorted Columns" => "Pre-sorted Columns",
// "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]" => "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]",
// "Column Widths" => "Column Widths",
// "Column widths followed by px for pixels or % for percentages. Each column separated by |" => "Column widths followed by px for pixels or % for percentages. Each column separated by |",
// "Cell Horizontal Align" => "Cell Horizontal Align",
// "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify" => "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify",
// "Cell Vertical Align" => "Cell Vertical Align",
// "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline" => "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline",
// "The feature must be activated" => "The feature must be activated",
// "heads and cells separated by |" => "heads and cells separated by |",
// "PluginFile" => "PluginFile",
// "Displays a link to a file (either from the file gallery or an attachment to a wiki page) and can display an image attachment. For more than one file from file galleries, or more optional information shown from the files, use the plugin FILES instead" => "Displays a link to a file (either from the file gallery or an attachment to a wiki page) and can display an image attachment. For more than one file from file galleries, or more optional information shown from the files, use the plugin FILES instead",
// "Label for the link to the file" => "Label for the link to the file",
// "Indicate whether the file is in a file gallery or is a wiki page attachment" => "Indicate whether the file is in a file gallery or is a wiki page attachment",
// "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used" => "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used",
// "Custom Description" => "Custom Description",
// "Custom text that will be used for the link instead of the file name or file description" => "Custom text that will be used for the link instead of the file name or file description",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty",
// "Attachment Description" => "Attachment Description",
// "Show the attachment description as the link label instead of the attachment file name" => "Show the attachment description as the link label instead of the attachment file name",
// "Indicates that this attachment is an image, and should be displayed inline using the img tag" => "Indicates that this attachment is an image, and should be displayed inline using the img tag",
// "File ID" => "File ID",
// "File ID of a file in a file gallery or an archive" => "File ID of a file in a file gallery or an archive",
// "For an archive file, the archive created just before this date will be linked to" => "For an archive file, the archive created just before this date will be linked to",
// "Show Icon" => "Show Icon",
// "Show an icon version of the file or file type with the link to the file" => "Show an icon version of the file or file type with the link to the file",
// "File Gallery File/Archive" => "File Gallery File/Archive",
// "Wiki Page Attachment" => "Wiki Page Attachment",
// "The date has not been set" => "The date has not been set",
// "Incorrect date format" => "Incorrect date format",
// "No such file" => "No such file",
// "Wiki attachments are disabled" => "Wiki attachments are disabled",
// "PluginFiles" => "PluginFiles",
// "Displays a list of files from a file gallery" => "Displays a list of files from a file gallery",
// "To list only files contained in this file gallery" => "To list only files contained in this file gallery",
// "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon",
// "To list only specified files, enter their file IDs separated by colon" => "To list only specified files, enter their file IDs separated by colon",
// "Order ascending or descending based on any field in the file gallery table. Default is name_asc" => "Order ascending or descending based on any field in the file gallery table. Default is name_asc",
// "Show Action" => "Show Action",
// "Show a column with icons for the various actions the user can take with each file (not shown by default)" => "Show a column with icons for the various actions the user can take with each file (not shown by default)",
// "Show Find" => "Show Find",
// "Show a search box above the list (not shown by default)" => "Show a search box above the list (not shown by default)",
// "Show the title of the file gallery (shown by default)" => "Show the title of the file gallery (shown by default)",
// "Show ID" => "Show ID",
// "Show the ID number of each file (shown by default)" => "Show the ID number of each file (shown by default)",
// "Show an icon for each file depicting the file type" => "Show an icon for each file depicting the file type",
// "Show the name given to the file upon upload into the file gallery (shown by default)" => "Show the name given to the file upon upload into the file gallery (shown by default)",
// "Show Filename" => "Show Filename",
// "Show each file\\'s filename (shown by default)" => "Show each file\\'s filename (shown by default)",
// "Show Size" => "Show Size",
// "Show the size of each file in kilobytes (shown by default)" => "Show the size of each file in kilobytes (shown by default)",
// "Show the description of the file given upon upload into the file gallery (shown by default)" => "Show the description of the file given upon upload into the file gallery (shown by default)",
// "Show Creation Date" => "Show Creation Date",
// "Show the date each file was created (not shown by default)" => "Show the date each file was created (not shown by default)",
// "Show Last Modification Date" => "Show Last Modification Date",
// "Show the date each file was last modified (shown by default)" => "Show the date each file was last modified (shown by default)",
// "Show Hits" => "Show Hits",
// "Show the number of hits each file has received (not shown by default)" => "Show the number of hits each file has received (not shown by default)",
// "Show Locked By" => "Show Locked By",
// "For locked files, show the user name of the user who locked it (not shown by default)" => "For locked files, show the user name of the user who locked it (not shown by default)",
// "Show the user name of the user who is the author of the file (not shown by default)" => "Show the user name of the user who is the author of the file (not shown by default)",
// "Show Creator" => "Show Creator",
// "Show the user name of the user who is the creator of the file (not shown by default)" => "Show the user name of the user who is the creator of the file (not shown by default)",
// "Show Parent Gallery Name" => "Show Parent Gallery Name",
// "Show the name of the parent gallery" => "Show the name of the parent gallery",
// "Show File Count" => "Show File Count",
// "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)",
// "Show Slideshow" => "Show Slideshow",
// "Show a link that produces a pop-up slide show when clicked (not set by default)" => "Show a link that produces a pop-up slide show when clicked (not set by default)",
// "Show Comment" => "Show Comment",
// "Show comments for each file (not shown by default)" => "Show comments for each file (not shown by default)",
// "Show Last Editor" => "Show Last Editor",
// "Show the user name of the user who last modified the file (shown by default)" => "Show the user name of the user who last modified the file (shown by default)",
// "Show only files created by this user" => "Show only files created by this user",
// "Show Upload" => "Show Upload",
// "Show a simple upload form to the gallery (not shown by default)" => "Show a simple upload form to the gallery (not shown by default)",
// "List files in a file gallery (with a category) or in a category or a file gallery od this category" => "List files in a file gallery (with a category) or in a category or a file gallery od this category",
// "PluginFlash" => "PluginFlash",
// "Displays a Flash (.swf) file in the wiki page" => "Displays a Flash (.swf) file in the wiki page",
// "Flash Type" => "Flash Type",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo",
// "Select an option" => "Select an option",
// "Blip.tv" => "Blip.tv",
// "File Gallery Podcast" => "File Gallery Podcast",
// "Movie URL" => "Movie URL",
// "Vimeo" => "Vimeo",
// "Youtube" => "Youtube",
// "Complete URL to the movie to include. e.g. files/test.swf" => "Complete URL to the movie to include. e.g. files/test.swf",
// "File Gallery Podcast ID" => "File Gallery Podcast ID",
// "Id of a file from a podcast gallery - will work only with podcast gallery" => "Id of a file from a podcast gallery - will work only with podcast gallery",
// "Youtube URL" => "Youtube URL",
// "Entire URL to the YouTube video. Example: http://www.youtube.com/watch?v=1i2ZnU4iR24" => "Entire URL to the YouTube video. Example: http://www.youtube.com/watch?v=1i2ZnU4iR24",
// "Vimeo URL" => "Vimeo URL",
// "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966" => "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966",
// "Blip.tv URL" => "Blip.tv URL",
// "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC" => "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC",
// "Width of movie in pixels (default is 425)" => "Width of movie in pixels (default is 425)",
// "Height of movie in pixels (default is 350)" => "Height of movie in pixels (default is 350)",
// "Quality" => "Quality",
// "Flash video quality. Default value: high" => "Flash video quality. Default value: high",
// "Medium" => "Medium",
// "Invalid URL" => "Invalid URL",
// "Missing parameter movie to the plugin flash" => "Missing parameter movie to the plugin flash",
// "Inserts a superscripted footnote number next to text and takes in footnote as parameter" => "Inserts a superscripted footnote number next to text and takes in footnote as parameter",
// "Footnote" => "Footnote",
// "PluginFootnote" => "PluginFootnote",
// "The footnote" => "The footnote",
// "Sameas" => "Sameas",
// "Tag to existing footnote" => "Tag to existing footnote",
// "CheckDuplicate" => "CheckDuplicate",
// "Check for duplicate footnotes" => "Check for duplicate footnotes",
// "Footnotearea" => "Footnotearea",
// "PluginFootnoteArea" => "PluginFootnoteArea",
// "Inserts a section for collected footnotes in the wiki page" => "Inserts a section for collected footnotes in the wiki page",
// "Freetagged" => "Freetagged",
// "PluginFreetagged" => "PluginFreetagged",
// "Find similarly tagged objects" => "Find similarly tagged objects",
// "Tags to find similar to" => "Tags to find similar to",
// "Leave blank to use the object\\'s own tags" => "Leave blank to use the object\\'s own tags",
// "Type of objects to extract. Set to All to find all types" => "Type of objects to extract. Set to All to find all types",
// "Same" => "Same",
// "Start record" => "Start record",
// "Default -1 (all)" => "Default -1 (all)",
// "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)" => "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)",
// "Comments Locked Ascending" => "Comments Locked Ascending",
// "Comments Locked Descending" => "Comments Locked Descending",
// "Description Ascending" => "Description Ascending",
// "Description Descending" => "Description Descending",
// "Href Ascending" => "Href Ascending",
// "Href Descending" => "Href Descending",
// "Object ID Ascending" => "Object ID Ascending",
// "Object ID Descending" => "Object ID Descending",
// "Show objects with names or descriptions similar to the text entered here" => "Show objects with names or descriptions similar to the text entered here",
// "Broaden" => "Broaden",
// "n|y" => "n|y",
// "Header Level" => "Header Level",
// "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags" => "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags",
// "Show Titles Only" => "Show Titles Only",
// "Choose whether to show titles only (not shown by default)" => "Choose whether to show titles only (not shown by default)",
// "Maximum Image Size" => "Maximum Image Size",
// "Height or width in pixels. Default = 0 (no maximum)" => "Height or width in pixels. Default = 0 (no maximum)",
// "Download box for a file on ftp server" => "Download box for a file on ftp server",
// "FTP" => "FTP",
// "PluginFTP" => "PluginFTP",
// "Download box for a file on an FTP server" => "Download box for a file on an FTP server",
// "file name" => "file name",
// "Server Name" => "Server Name",
// "Name of the server where the FTP account is housed. Example: " => "Name of the server where the FTP account is housed. Example: ",
// "User name needed to access the FTP account" => "User name needed to access the FTP account",
// "Password needed to access the FTP account" => "Password needed to access the FTP account",
// "Download Button Label" => "Download Button Label",
// "Label for the FTP download button" => "Label for the FTP download button",
// "Connection failed" => "Connection failed",
// "Gauge" => "Gauge",
// "PluginGauge" => "PluginGauge",
// "Displays a graphical gauge" => "Displays a graphical gauge",
// "Current value to be represented by the gauge" => "Current value to be represented by the gauge",
// "Maximum Value" => "Maximum Value",
// "Maximum possible value. Default: 100" => "Maximum possible value. Default: 100",
// "Label displayed on the left side of the gauge" => "Label displayed on the left side of the gauge",
// "Color" => "Color",
// "Main color of the gauge. Use HTML color codes or names" => "Main color of the gauge. Use HTML color codes or names",
// "Background color of the gauge. Use HTML color codes or names" => "Background color of the gauge. Use HTML color codes or names",
// "Bar width in pixels" => "Bar width in pixels",
// "Label Width" => "Label Width",
// "Width in pixels allocated to the label" => "Width in pixels allocated to the label",
// "Display Percentage" => "Display Percentage",
// "Set to true (Yes) to display a percentage of the maximum" => "Set to true (Yes) to display a percentage of the maximum",
// "Display Value" => "Display Value",
// "Set to false (No) to hide the numeric value (shown by default)" => "Set to false (No) to hide the numeric value (shown by default)",
// "Bar height in pixels" => "Bar height in pixels",
// "Displays a graphical GAUGE" => "Displays a graphical GAUGE",
// "Google Analytics" => "Google Analytics",
// "PluginGoogleAnalytics" => "PluginGoogleAnalytics",
// "Add the tracking code for Google Analytics" => "Add the tracking code for Google Analytics",
// "Account Number" => "Account Number",
// "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY" => "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY",
// "Missing parameter" => "Missing parameter",
// "Google Doc" => "Google Doc",
// "PluginGoogleDoc" => "PluginGoogleDoc",
// "Displays a Google document" => "Displays a Google document",
// "Leave this empty" => "Leave this empty",
// "Type of Google document" => "Type of Google document",
// "Document" => "Document",
// "Presentation" => "Presentation",
// "key" => "key",
// "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI" => "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI",
// "Name of iframe. Default is \"Frame\" + the key" => "Name of iframe. Default is \"Frame\" + the key",
// "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly",
// "Small" => "Small",
// "Large" => "Large",
// "Width in pixels or %" => "Width in pixels or %",
// "Height in pixels or %" => "Height in pixels or %",
// "Middle" => "Middle",
// "Choose whether to show a border around the iframe" => "Choose whether to show a border around the iframe",
// "Margin Height" => "Margin Height",
// "Margin height in pixels" => "Margin height in pixels",
// "Margin Width" => "Margin Width",
// "Margin width in pixels" => "Margin width in pixels",
// "Scrolling" => "Scrolling",
// "Choose whether to add a scroll bar" => "Choose whether to add a scroll bar",
// "Auto" => "Auto",
// "Edit Link" => "Edit Link",
// "Choose whether to show an edit link and set its location" => "Choose whether to show an edit link and set its location",
// "Required parameter \"type\" missing" => "Required parameter \"type\" missing",
// "Required parameter \"key\" missing" => "Required parameter \"key\" missing",
// "googledoc" => "googledoc",
// "googlemap" => "googlemap",
// "PluginGoogleMap" => "PluginGoogleMap",
// "Displays a Google map" => "Displays a Google map",
// "Type of items to show on google map" => "Type of items to show on google map",
// "Locator" => "Locator",
// "Object List" => "Object List",
// "Tracker Field" => "Tracker Field",
// "Display Mode" => "Display Mode",
// "Map display mode" => "Map display mode",
// "Satellite" => "Satellite",
// "Hybrid" => "Hybrid",
// "API Key" => "API Key",
// "Google maps key, if not set in user preferences" => "Google maps key, if not set in user preferences",
// "Map ID" => "Map ID",
// "Id suffix of Google map div to avoid conflicts with other maps on same page" => "Id suffix of Google map div to avoid conflicts with other maps on same page",
// "Show Border" => "Show Border",
// "Choose whether to show a frame border around the map (no border shown by default)" => "Choose whether to show a frame border around the map (no border shown by default)",
// "Default Center Longitude" => "Default Center Longitude",
// "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature" => "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature",
// "Default Center Latitude" => "Default Center Latitude",
// "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature" => "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature",
// "Default Zoom" => "Default Zoom",
// "Use an integer between 0 and 19 to set a default zoom level for the map. Default is the default set in the Gmap feature" => "Use an integer between 0 and 19 to set a default zoom level for the map. Default is the default set in the Gmap feature",
// "Save View" => "Save View",
// "Allow user to set current map view as default view for himself only" => "Allow user to set current map view as default view for himself only",
// "Item Type" => "Item Type",
// "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified" => "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified",
// "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified" => "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified",
// "Hide If No Markers" => "Hide If No Markers",
// "Hide map if there are no markers to be shown. Default is to show the map" => "Hide map if there are no markers to be shown. Default is to show the map",
// "Visibility Toggle" => "Visibility Toggle",
// "Add ability to toggle visibility. No toggle by default" => "Add ability to toggle visibility. No toggle by default",
// "Start Hidden" => "Start Hidden",
// "Choose whether to keep the map hidden initially. Default is to show the map initially" => "Choose whether to keep the map hidden initially. Default is to show the map initially",
// "Auto Zoom" => "Auto Zoom",
// "Use an integer between 0 and 19 to auto zoom to this level on address find" => "Use an integer between 0 and 19 to auto zoom to this level on address find",
// "Show Controls" => "Show Controls",
// "Show map controls (shown by default)" => "Show map controls (shown by default)",
// "Tracker Field ID" => "Tracker Field ID",
// "Field ID of tracker field if type is trackerfield or locator and locateitemtype is trackeritem" => "Field ID of tracker field if type is trackerfield or locator and locateitemtype is trackeritem",
// "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms" => "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms",
// "In Form" => "In Form",
// "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML" => "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML",
// "No such user" => "No such user",
// "No such object" => "No such object",
// "Not logged in" => "Not logged in",
// "Error: Invalid Lon. and Lat. values" => "Error: Invalid Lon. and Lat. values",
// "Map view saved as default for " => "Map view saved as default for ",
// "You can only set your own location" => "You can only set your own location",
// "Please select a point to set both Lon. and Lat" => "Please select a point to set both Lon. and Lat",
// "User location saved for " => "User location saved for ",
// "You cannot edit this object or no such object" => "You cannot edit this object or no such object",
// "Location saved for object" => "Location saved for object",
// "Error saving location" => "Error saving location",
// "PluginGroup" => "PluginGroup",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition",
// "Allowed User Friends" => "Allowed User Friends",
// "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo" => "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo",
// "Allowed Groups" => "Allowed Groups",
// "Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "Pipe separated list of groups allowed to view the block. ex: Admins|Developers",
// "Denied Groups" => "Denied Groups",
// "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers",
// "Display wiki text if user is in one of listed groups or group of friends" => "Display wiki text if user is in one of listed groups or group of friends",
// "PluginGroupList" => "PluginGroupList",
// "List all groups or just groups that include a certain group" => "List all groups or just groups that include a certain group",
// "Group Name" => "Group Name",
// "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed",
// "Group Home Page" => "Group Home Page",
// "Link the group name to the group home page, if there is one (not linked by default)" => "Link the group name to the group home page, if there is one (not linked by default)",
// "Recursively List Groups" => "Recursively List Groups",
// "Recurse on the included groups (default is not to recurse)" => "Recurse on the included groups (default is not to recurse)",
// "GroupMailCore" => "GroupMailCore",
// "PluginGroupMailCore" => "PluginGroupMailCore",
// "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile" => "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile",
// "From Email" => "From Email",
// "Email address to report" => "Email address to report",
// "Tracker Id" => "Tracker Id",
// "Id of GroupMail Logs tracker (set up in alias by profile)" => "Id of GroupMail Logs tracker (set up in alias by profile)",
// "From Field Id" => "From Field Id",
// "Id of GroupMail Logs tracker field (usually set up in alias by profile)" => "Id of GroupMail Logs tracker field (usually set up in alias by profile)",
// "Operator Field Id" => "Operator Field Id",
// "Subject Field Id" => "Subject Field Id",
// "Message Field Id" => "Message Field Id",
// "Content Field Id" => "Content Field Id",
// "Account Field Id" => "Account Field Id",
// "Datetime Field Id" => "Datetime Field Id",
// "Displays GroupMail functions on a wiki page" => "Displays GroupMail functions on a wiki page",
// "PluginGroupStat" => "PluginGroupStat",
// "Displays the percentage of total users that are members of groups" => "Displays the percentage of total users that are members of groups",
// "Groups separated by :. If empty, all groups will be listed" => "Groups separated by :. If empty, all groups will be listed",
// "Show Percentage" => "Show Percentage",
// "Show the percentage of total users that are members of each group (percentages are shown by default)" => "Show the percentage of total users that are members of each group (percentages are shown by default)",
// "Show Bar" => "Show Bar",
// "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)",
// "HTML" => "HTML",
// "PluginHTML" => "PluginHTML",
// "Parse wiki syntax within the html code" => "Parse wiki syntax within the html code",
// "Iframe" => "Iframe",
// "PluginIframe" => "PluginIframe",
// "Displays an iframe" => "Displays an iframe",
// "Frame title" => "Frame title",
// "Pixels or %" => "Pixels or %",
// "Align the ifram on the page" => "Align the ifram on the page",
// "Frame Border" => "Frame Border",
// "iframe" => "iframe",
// "PluginImg" => "PluginImg",
// "Image source" => "Image source",
// "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required" => "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required",
// "Numeric ID of an image in an Image Gallery (or list separated by commas or |)" => "Numeric ID of an image in an Image Gallery (or list separated by commas or |)",
// "Numeric ID of an image in a File Gallery (or list separated by commas or |)" => "Numeric ID of an image in a File Gallery (or list separated by commas or |)",
// "Gallery ID" => "Gallery ID",
// "Numeric ID of a File Gallery. Displays a random image from that gallery" => "Numeric ID of a File Gallery. Displays a random image from that gallery",
// "Attachment ID" => "Attachment ID",
// "Numeric ID of an image attached to a wiki page (or list separated by commas or |)" => "Numeric ID of an image attached to a wiki page (or list separated by commas or |)",
// "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments",
// "Full size image appears when thumbnail is clicked" => "Full size image appears when thumbnail is clicked",
// "Mouseover" => "Mouseover",
// "Full size image will pop up while cursor is over the thumbnail (and disappear when not)" => "Full size image will pop up while cursor is over the thumbnail (and disappear when not)",
// "Mouseover (Sticky)" => "Mouseover (Sticky)",
// "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup" => "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup",
// "Popup" => "Popup",
// "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked" => "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked",
// "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery",
// "Browse Popup" => "Browse Popup",
// "Same as \"browse\" except that the page opens in a new window or tab" => "Same as \"browse\" except that the page opens in a new window or tab",
// "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked" => "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked",
// "Enlarge button" => "Enlarge button",
// "Button for enlarging image" => "Button for enlarging image",
// "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting" => "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting",
// "Link relation" => "Link relation",
// "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation" => "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation",
// "Image map" => "Image map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
// "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
// "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
// "Maximum image size" => "Maximum image size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings",
// "Align image" => "Align image",
// "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box" => "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box",
// "Image style" => "Image style",
// "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects",
// "Align image block" => "Align image block",
// "Aligns the box containing the image" => "Aligns the box containing the image",
// "Image block style" => "Image block style",
// "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects",
// "Description style" => "Description style",
// "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects" => "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects",
// "Wrapping control" => "Wrapping control",
// "Control how other items wrap around the image" => "Control how other items wrap around the image",
// "CSS class to apply to the image" => "CSS class to apply to the image",
// "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description" => "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description",
// "Link title" => "Link title",
// "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title" => "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title",
// "Alternate text" => "Alternate text",
// "Alternate text that displays when image does not load. Set to \"Image\" by default" => "Alternate text that displays when image does not load. Set to \"Image\" by default",
// "Default config settings" => "Default config settings",
// "Default configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "Mandatory admin setting" => "Mandatory admin setting",
// "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "File is not an image" => "File is not an image",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "Enlarge" => "Enlarge",
// "''No image specified. Either the fileId, randomGalleryId, attId, id, or src parameter must be specified.''" => "''No image specified. Either the fileId, randomGalleryId, attId, id, or src parameter must be specified.''",
// "''Use one and only one of the following parameters: fileId, randomGalleryId, attId, id, or src.''" => "''Use one and only one of the following parameters: fileId, randomGalleryId, attId, id, or src.''",
// "PluginInclude" => "PluginInclude",
// "Include a page\\'s content" => "Include a page\\'s content",
// "Start" => "Start",
// "When only a portion of the page should be included, specify the marker from which inclusion should start" => "When only a portion of the page should be included, specify the marker from which inclusion should start",
// "When only a portion of the page should be included, specify the marker at which inclusion should end" => "When only a portion of the page should be included, specify the marker at which inclusion should end",
// "Nopage Text" => "Nopage Text",
// "Text to show when no page is found" => "Text to show when no page is found",
// "Page Denied Text" => "Page Denied Text",
// "Text to show when the page exists but is denied to the user" => "Text to show when the page exists but is denied to the user",
// "PluginInvite" => "PluginInvite",
// "Invite an email in groups" => "Invite an email in groups",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Including Group" => "Including Group",
// "Will list only the groups that include this group" => "Will list only the groups that include this group",
// "Dropdown list will show this group by default" => "Dropdown list will show this group by default",
// "Dropdown list will show the group related to this item ID (in group selector or creator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or creator field) by default",
// "Following mandatory fields are missing" => "Following mandatory fields are missing",
// "Jabber" => "Jabber",
// "PluginJabber" => "PluginJabber",
// "Runs a Java applet to access a local Jabber service" => "Runs a Java applet to access a local Jabber service",
// "Applet height in pixels" => "Applet height in pixels",
// "Applet width in pixels" => "Applet width in pixels",
// "XML Host Name" => "XML Host Name",
// "Web site where XML is hosted. Default is jabber.org" => "Web site where XML is hosted. Default is jabber.org",
// "Default Color" => "Default Color",
// "Set default color. Default is 255,255,255" => "Set default color. Default is 255,255,255",
// "jQuery" => "jQuery",
// "PluginJQ" => "PluginJQ",
// "Inserts JavaScript code. By default this is only executed after jQuery determines that the DOM is fully loaded" => "Inserts JavaScript code. By default this is only executed after jQuery determines that the DOM is fully loaded",
// "JavaScript code" => "JavaScript code",
// "Not On Ready" => "Not On Ready",
// "No JavaScript" => "No JavaScript",
// "Optional markup for when JavaScript is off" => "Optional markup for when JavaScript is off",
// "Insert JQuery javascript code" => "Insert JQuery javascript code",
// "jquery code e.g. \$(\"img\\" => "jquery code e.g. \$(\"img\\",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "Javascript" => "Javascript",
// "PluginJS" => "PluginJS",
// "Insert a javascript file and/or some javascript code" => "Insert a javascript file and/or some javascript code",
// "javascript code" => "javascript code",
// "Javascript filename" => "Javascript filename",
// "Insert a javascript file or/and some javascript code" => "Insert a javascript file or/and some javascript code",
// "Kaltura video" => "Kaltura video",
// "PluginKaltura" => "PluginKaltura",
// "Displays a KALTURA video on the wiki page" => "Displays a KALTURA video on the wiki page",
// "Kaltura Entry ID" => "Kaltura Entry ID",
// "Kaltura entry ID of the video to be displayed" => "Kaltura entry ID of the video to be displayed",
// "PluginLang" => "PluginLang",
// "Displays the text only if the language matches" => "Displays the text only if the language matches",
// "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Displays the text only if the language matchs" => "Displays the text only if the language matchs",
// "PluginLastMod" => "PluginLastMod",
// "The Last Mod plugin displays the last modification time of the named wiki page, or the current page if no name given" => "The Last Mod plugin displays the last modification time of the named wiki page, or the current page if no name given",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given" => "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given",
// "PluginListpages" => "PluginListpages",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Limit number of items displayed in the list. Default is to display all" => "Limit number of items displayed in the list. Default is to display all",
// "Initial" => "Initial",
// "txt" => "txt",
// "Show Name Only" => "Show Name Only",
// "Show only the page names" => "Show only the page names",
// "If set to a category identifier, restrict the pages displayed to those in the specified category" => "If set to a category identifier, restrict the pages displayed to those in the specified category",
// "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories" => "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories",
// "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories" => "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories",
// "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories" => "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories",
// "Structure Head" => "Structure Head",
// "Filter by structure head" => "Filter by structure head",
// "Show Page Alias" => "Show Page Alias",
// "Show page alias in the list" => "Show page alias in the list",
// "Only pages with names similar the text entered for this parameter will be listed" => "Only pages with names similar the text entered for this parameter will be listed",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Exact Match" => "Exact Match",
// "Page name and text entered for the filter parameter must match exactly to be listed" => "Page name and text entered for the filter parameter must match exactly to be listed",
// "Only Orphan Pages" => "Only Orphan Pages",
// "Only list orphan pages" => "Only list orphan pages",
// "For List Pages" => "For List Pages",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: " => "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: ",
// "Length" => "Length",
// "Number of characters to display" => "Number of characters to display",
// "List Directory" => "List Directory",
// "PluginLsDir" => "PluginLsDir",
// "Full path to the server-local directory. Default is the document root" => "Full path to the server-local directory. Default is the document root",
// "URL Prefix" => "URL Prefix",
// "Make the file name a link to the file by adding the url path preceding the file name. Example: http://yoursite.com/tiki/" => "Make the file name a link to the file by adding the url path preceding the file name. Example: http://yoursite.com/tiki/",
// "Set the sort order of the file list" => "Set the sort order of the file list",
// "File Name" => "File Name",
// "File Size" => "File Size",
// "Last Access" => "Last Access",
// "Last Metadata Change" => "Last Metadata Change",
// "Only list files with filenames that contain this filter. Example: \".jpg\"" => "Only list files with filenames that contain this filter. Example: \".jpg\"",
// "Limit" => "Limit",
// "Maximum amount of files to display. Default is no limit" => "Maximum amount of files to display. Default is no limit",
// "could not be opened because it doesn't exist or permission was denied" => "could not be opened because it doesn't exist or permission was denied",
// "Mail" => "Mail",
// "PluginMail" => "PluginMail",
// "Directly mail other users or groups" => "Directly mail other users or groups",
// "Limit the group to the groups including this group" => "Limit the group to the groups including this group",
// "Show Group Dropdown" => "Show Group Dropdown",
// "Show a dropdown list of groups (not shown by default)" => "Show a dropdown list of groups (not shown by default)",
// "Show User Dropdown" => "Show User Dropdown",
// "Show a dropdown list of users (not shown by default)" => "Show a dropdown list of users (not shown by default)",
// "User Autocomplete" => "User Autocomplete",
// "Show an autocomplete box on user name" => "Show an autocomplete box on user name",
// "Real Name Dropdown" => "Real Name Dropdown",
// "Show a dropdown list of user real names (not shown by default)" => "Show a dropdown list of user real names (not shown by default)",
// "PluginMap" => "PluginMap",
// "Map File" => "Map File",
// "Map file identifier" => "Map file identifier",
// "Extents" => "Extents",
// "Size of the map" => "Size of the map",
// "Width of the map" => "Width of the map",
// "Height of the map" => "Height of the map",
// "Mayan Calendars Info" => "Mayan Calendars Info",
// "PluginMCalendarInfo" => "PluginMCalendarInfo",
// "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count" => "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count",
// "You must use the variable substitution" => "You must use the variable substitution",
// "LongCount: " => "LongCount: ",
// "Tzolkin: " => "Tzolkin: ",
// "Haab: " => "Haab: ",
// "Misc: " => "Misc: ",
// "Example: template " => "Example: template ",
// "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
// "Default template: " => "Default template: ",
// "Gregorian date" => "Gregorian date",
// "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date" => "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date",
// "Mayan Calendars" => "Mayan Calendars",
// " is not a valid date format. should be dd.mm.yyyy" => " is not a valid date format. should be dd.mm.yyyy",
// "Inline Flash mp3 and flv Player" => "Inline Flash mp3 and flv Player",
// "Mediaplayer" => "Mediaplayer",
// "PluginMediaplayer" => "PluginMediaplayer",
// "Simple mp3 or flv Player" => "Simple mp3 or flv Player",
// "Allow Fullscreen" => "Allow Fullscreen",
// "Allow fullscreen mode" => "Allow fullscreen mode",
// "MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "Complete URL to the media to include" => "Complete URL to the media to include",
// "One of" => "One of",
// "Flash Window Mode" => "Flash Window Mode",
// "Sets the Window Mode property of the Flash movie. Transparent lets what\\'s behind the movie show through and allows the movie to be covered \n\t\t\t\t\t\t\t\t\t\t Opaque hides what\\'s behind the movie and Window plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what\\'s behind the movie show through and allows the movie to be covered \n\t\t\t\t\t\t\t\t\t\t Opaque hides what\\'s behind the movie and Window plays the movie in its own window. Default value: ",
// "Transparent" => "Transparent",
// "Opaque" => "Opaque",
// "Window" => "Window",
// "Member List" => "Member List",
// "PluginMemberList" => "PluginMemberList",
// "Lists the members of selected groups and allows to add or remove members if permissions are granted" => "Lists the members of selected groups and allows to add or remove members if permissions are granted",
// "List of groups to handle through the interface. Colon separated" => "List of groups to handle through the interface. Colon separated",
// "Member Payment" => "Member Payment",
// "PluginMemberPayment" => "PluginMemberPayment",
// "Receive payments from a member and extend the length of the membership to a group" => "Receive payments from a member and extend the length of the membership to a group",
// "Name of the group for which the subscription should be added or extended" => "Name of the group for which the subscription should be added or extended",
// "Price per period (%0)" => "Price per period (%0)",
// "Current User Member" => "Current User Member",
// "Membership only for the current user" => "Membership only for the current user",
// "Input Title" => "Input Title",
// "Title of the input form" => "Title of the input form",
// "Use %0 for the group name" => "Use %0 for the group name",
// "Supports wiki syntax" => "Supports wiki syntax",
// "How Title" => "How Title",
// "Use %0 for the group name, %4 for the number of days or %5 for the number of years" => "Use %0 for the group name, %4 for the number of days or %5 for the number of years",
// "Membership to %0 for %1 (x%2)" => "Membership to %0 for %1 (x%2)",
// "Membership to %0 for %1 users (x%2)" => "Membership to %0 for %1 users (x%2)",
// "The group " => "The group ",
// " does not have a membership term" => " does not have a membership term",
// " Go to " => " Go to ",
// "Admin > Groups" => "Admin > Groups",
// " to specify a term for this group by automatically unassigning users after a certain number of days" => " to specify a term for this group by automatically unassigning users after a certain number of days",
// " does not exist" => " does not exist",
// "Mini Quiz" => "Mini Quiz",
// "PluginMiniQuiz" => "PluginMiniQuiz",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Tracker ID" => "Tracker ID",
// "Numeric value representing the miniquiz tracker ID" => "Numeric value representing the miniquiz tracker ID",
// "PluginModule" => "PluginModule",
// "Displays a module inline in a wiki page. More parameters can be added, not supported by User Interface" => "Displays a module inline in a wiki page. More parameters can be added, not supported by User Interface",
// "Module name as known in Tiki" => "Module name as known in Tiki",
// "Align the module to the left or right on the page allowing other elements to align against it" => "Align the module to the left or right on the page allowing other elements to align against it",
// "Show box decorations (default is to show them)" => "Show box decorations (default is to show them)",
// "Add ability to show/hide the content of the module (default is the site admin setting for modules)" => "Add ability to show/hide the content of the module (default is the site admin setting for modules)",
// "Parse" => "Parse",
// "Parse wiki syntax (default is to parse)" => "Parse wiki syntax (default is to parse)",
// "Show/hide module title (default is to show the title)" => "Show/hide module title (default is to show the title)",
// "Show title" => "Show title",
// "Hide title" => "Hide title",
// "Monospace" => "Monospace",
// "PluginMono" => "PluginMono",
// "Font" => "Font",
// "Font name as known in browsers" => "Font name as known in browsers",
// "PluginMouseover" => "PluginMouseover",
// "Mouseover text if param label exists. Page text if text param exists" => "Mouseover text if param label exists. Page text if text param exists",
// "Text displayed on the page. The body is the mouseover content" => "Text displayed on the page. The body is the mouseover content",
// "Destination link when mouseover text is clicked. Use http:// for external links" => "Destination link when mouseover text is clicked. Use http:// for external links",
// "Text" => "Text",
// "DEPRECATED" => "DEPRECATED",
// "Text displayed on the mouseover. The body contains the text of the page" => "Text displayed on the mouseover. The body contains the text of the page",
// "Mouseover box width. Default: 400px" => "Mouseover box width. Default: 400px",
// "Mouseover box height. Default: 200px" => "Mouseover box height. Default: 200px",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5" => "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5",
// "Offset Y" => "Offset Y",
// "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0" => "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0",
// "Parse Body" => "Parse Body",
// "Parse the body of the plugin as wiki content (parsed by default)" => "Parse the body of the plugin as wiki content (parsed by default)",
// "Parse Label" => "Parse Label",
// "Parse the label as wiki content (parsed by default)" => "Parse the label as wiki content (parsed by default)",
// "CSS class to apply" => "CSS class to apply",
// "Background color to apply to the popup" => "Background color to apply to the popup",
// "Text Color" => "Text Color",
// "Color to apply to the text in the popup" => "Color to apply to the text in the popup",
// "When enabled, popup stays visible until it is clicked" => "When enabled, popup stays visible until it is clicked",
// "Padding" => "Padding",
// "Padding size in pixels" => "Padding size in pixels",
// "Effect" => "Effect",
// "Set the type of show/hide animation that will be used" => "Set the type of show/hide animation that will be used",
// "Effect Speed" => "Effect Speed",
// "Set the speed of the animation" => "Set the speed of the animation",
// "Close Delay" => "Close Delay",
// "Number of seconds before popup closes" => "Number of seconds before popup closes",
// "No label specified" => "No label specified",
// "MWTable" => "MWTable",
// "PluginMWTable" => "PluginMWTable",
// "Displays a table using MediaWiki syntax (experimental - may change in future versions)" => "Displays a table using MediaWiki syntax (experimental - may change in future versions)",
// "Fancy" => "Fancy",
// "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)" => "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)",
// "True" => "True",
// "False" => "False",
// "Wiki Classes" => "Wiki Classes",
// "Determines whether wiki style classes will be used for the table and cells (used by default)" => "Determines whether wiki style classes will be used for the table and cells (used by default)",
// "Displays the data using (sort of) MediaWiki syntax" => "Displays the data using (sort of) MediaWiki syntax",
// "MySpace" => "MySpace",
// "PluginMySpace" => "PluginMySpace",
// "Displays a MySpace Flash mp3 playlist in the wiki page" => "Displays a MySpace Flash mp3 playlist in the wiki page",
// "MySpace Page" => "MySpace Page",
// "MySpace page name" => "MySpace page name",
// "Object Hits" => "Object Hits",
// "PluginObjectHits" => "PluginObjectHits",
// "Displays object hit info by object and days" => "Displays object hit info by object and days",
// "For a wiki page, the page name, for other object types: ID number + ? + object title" => "For a wiki page, the page name, for other object types: ID number + ? + object title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"" => "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"",
// "Show the number of hits over the past number of days indicated. Default is to show all hits" => "Show the number of hits over the past number of days indicated. Default is to show all hits",
// "Display a payment request\\'s details based on the user\\'s privileges and the state of the payment. The payment details may include the payment options" => "Display a payment request\\'s details based on the user\\'s privileges and the state of the payment. The payment details may include the payment options",
// "Payment Request Number" => "Payment Request Number",
// "Unique identifier of the payment request" => "Unique identifier of the payment request",
// "PluginPerm" => "PluginPerm",
// "Display wiki text if and only if the user has at least one of a set of permissions (or none, if using notperms)" => "Display wiki text if and only if the user has at least one of a set of permissions (or none, if using notperms)",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met",
// "Possible Permissions" => "Possible Permissions",
// "Pipe separated list of permissions, one of which is needed to view the default text" => "Pipe separated list of permissions, one of which is needed to view the default text",
// "Forbidden Permissions" => "Forbidden Permissions",
// "Pipe separated list of permissions, any of which will cause the default text not to show" => "Pipe separated list of permissions, any of which will cause the default text not to show",
// "Display wiki text if user has one of listed permissions" => "Display wiki text if user has one of listed permissions",
// "Displays a list of plugins available in this wiki" => "Displays a list of plugins available in this wiki",
// "The module or plugin parameter must be set, but not both" => "The module or plugin parameter must be set, but not both",
// "^Plugin Manager error: " => "^Plugin Manager error: ",
// " not found" => " not found",
// "Plugin manager error: " => "Plugin manager error: ",
// "Introduced in Tiki version" => "Introduced in Tiki version",
// "Accepted Values" => "Accepted Values",
// "any string except for HTML and PHP tags" => "any string except for HTML and PHP tags",
// "Since" => "Since",
// "no parameters" => "no parameters",
// "Preferences required" => "Preferences required",
// "Required parameters are in</em> <b>bold</b>" => "Required parameters are in</em> <b>bold</b>",
// "Plugin Manager" => "Plugin Manager",
// "PluginPluginManager" => "PluginPluginManager",
// "Displays a list of plugins or modules available in this wiki" => "Displays a list of plugins or modules available in this wiki",
// "Information" => "Information",
// "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none" => "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none",
// "One or more of: description | parameters | paraminfo" => "One or more of: description | parameters | paraminfo",
// "Description & Parameters" => "Description & Parameters",
// "Description & Parameter Info" => "Description & Parameter Info",
// "Parameters & Parameter Info" => "Parameters & Parameter Info",
// "Plugin" => "Plugin",
// "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter" => "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter",
// "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter" => "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter",
// "Single Title" => "Single Title",
// "Set placement of plugin name and description when displaying information for only one plugin" => "Set placement of plugin name and description when displaying information for only one plugin",
// "Title Heading" => "Title Heading",
// "Sets the heading size for the title, e.g., h2" => "Sets the heading size for the title, e.g., h2",
// "Start with this plugin record number (must be an integer 1 or greater)" => "Start with this plugin record number (must be an integer 1 or greater)",
// "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater",
// "PluginPoll" => "PluginPoll",
// "Displays the output of a poll, fields are indicated with numeric ids" => "Displays the output of a poll, fields are indicated with numeric ids",
// "Numeric value representing the poll ID" => "Numeric value representing the poll ID",
// "Show poll title (shown by default)" => "Show poll title (shown by default)",
// "missing poll ID for plugin POLL" => "missing poll ID for plugin POLL",
// "Profile application" => "Profile application",
// "Adds controls required to apply a profile" => "Adds controls required to apply a profile",
// "PluginProfile" => "PluginProfile",
// "Profile repository domain. Default value is profiles.tiki.org" => "Profile repository domain. Default value is profiles.tiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile to be applied" => "Name of the profile to be applied",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "Proposal" => "Proposal",
// "PluginProposal" => "PluginProposal",
// "Provides a widget for users to vote on a proposal and view the current decision" => "Provides a widget for users to vote on a proposal and view the current decision",
// "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username",
// "Short description of the proposal to vote on. Will be displayed above the result table" => "Short description of the proposal to vote on. Will be displayed above the result table",
// "Accept proposal" => "Accept proposal",
// "Still undecided" => "Still undecided",
// "Reject proposal" => "Reject proposal",
// "PluginQuote" => "PluginQuote",
// "Reply To" => "Reply To",
// "RandomInclude" => "RandomInclude",
// "PluginRandomInclude" => "PluginRandomInclude",
// "Include a random page\\'s content" => "Include a random page\\'s content",
// "Include a random page" => "Include a random page",
// "PluginRcontent" => "PluginRcontent",
// "Includes random content from the dynamic content system" => "Includes random content from the dynamic content system",
// "Numeric value representing the content ID" => "Numeric value representing the content ID",
// "User List (showing Real Name)" => "User List (showing Real Name)",
// "PluginRealNameList" => "PluginRealNameList",
// " (experimental, should be merged with UserList in Tiki5)" => " (experimental, should be merged with UserList in Tiki5)",
// "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included",
// "String to use between elements of the list if table layout is not used" => "String to use between elements of the list if table layout is not used",
// "Maximum" => "Maximum",
// "Set to sort in ascending or descending order (unsorted by default" => "Set to sort in ascending or descending order (unsorted by default",
// "Layout" => "Layout",
// "Set to table to show results in a table (not shown in a table by default)" => "Set to table to show results in a table (not shown in a table by default)",
// "Make the listed names links to various types of user information" => "Make the listed names links to various types of user information",
// "User Page" => "User Page",
// "Exclude certain test or admin names from the list" => "Exclude certain test or admin names from the list",
// "admin-test" => "admin-test",
// "test" => "test",
// "test-admin" => "test-admin",
// "Displays a list of users showing their real name" => "Displays a list of users showing their real name",
// "Displays a list of registered users showing their Real Names" => "Displays a list of registered users showing their Real Names",
// "Redirect" => "Redirect",
// "PluginRedirect" => "PluginRedirect",
// "Redirect the user to a wiki page or generic URL" => "Redirect the user to a wiki page or generic URL",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "Redirects you to another wiki page" => "Redirects you to another wiki page",
// "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page",
// "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. ",
// "REDIRECT plugin: redirect loop detected" => "REDIRECT plugin: redirect loop detected",
// "Regular Expression" => "Regular Expression",
// "PluginRegex" => "PluginRegex",
// "Takes regex expressions and parses the content between REGEX tags and replaces the text" => "Takes regex expressions and parses the content between REGEX tags and replaces the text",
// "Each line of content is evaluated separately" => "Each line of content is evaluated separately",
// "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text" => "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text",
// "Takes regex expressions and parses the content between the REGEX tags and replaces the text" => "Takes regex expressions and parses the content between the REGEX tags and replaces the text",
// "Displays a comment, tip, note or warning box" => "Displays a comment, tip, note or warning box",
// "remarks text" => "remarks text",
// "PluginRemarksBox" => "PluginRemarksBox",
// "Select type of remarksbox, which determines what icon and style will be displayed" => "Select type of remarksbox, which determines what icon and style will be displayed",
// "Confirm" => "Confirm",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Highlight" => "Highlight",
// "Use the highlight class for formatting (not used by default)" => "Use the highlight class for formatting (not used by default)",
// "Custom Icon" => "Custom Icon",
// "Enter a Tiki icon file name (with or without extension) or path to display a custom icon" => "Enter a Tiki icon file name (with or without extension) or path to display a custom icon",
// "Show a close button (not shown by default)" => "Show a close button (not shown by default)",
// "Width (e.g. 100% or 250px - default \"\")" => "Width (e.g. 100% or 250px - default \"\")",
// "RSS Feed" => "RSS Feed",
// "PluginRSS" => "PluginRSS",
// "Inserts an RSS feed output" => "Inserts an RSS feed output",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: feedId:feedId2" => "List of feed IDs separated by colons. ex: feedId:feedId2",
// "Result Count" => "Result Count",
// "Number of results displayed" => "Number of results displayed",
// "Show date of each item (not shown by default)" => "Show date of each item (not shown by default)",
// "Show feed descriptions (not shown by default)" => "Show feed descriptions (not shown by default)",
// "Show authors (not shown by default)" => "Show authors (not shown by default)",
// "Url to a favicon to put before each entry" => "Url to a favicon to put before each entry",
// "Show the title of the feed (shown by default)" => "Show the title of the feed (shown by default)",
// "Scroll" => "Scroll",
// "PluginScroll" => "PluginScroll",
// "'),\n\t\t'prefs' => array('wikiplugin_scroll" => "'),\n\t\t'prefs' => array('wikiplugin_scroll",
// "Width in pixels. Example: 600px" => "Width in pixels. Example: 600px",
// "Number of pixels followed by \"px\". Example: 600px" => "Number of pixels followed by \"px\". Example: 600px",
// "Height in pixels. Example: 450px" => "Height in pixels. Example: 450px",
// "Number of pixels followed by \"px\". Example: 450px" => "Number of pixels followed by \"px\". Example: 450px",
// "Scroll speed in number of seconds (default is 8 seconds)" => "Scroll speed in number of seconds (default is 8 seconds)",
// "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests" => "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests",
// "SourceForge" => "SourceForge",
// "PluginSF" => "PluginSF",
// "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests) with the title of the item as the link text" => "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests) with the title of the item as the link text",
// "Group ID" => "Group ID",
// "SourceForge project ID (shows as group_id in the url of a tracker item" => "SourceForge project ID (shows as group_id in the url of a tracker item",
// "SourceForge tracker ID (shows as atid in the url of a tracker item" => "SourceForge tracker ID (shows as atid in the url of a tracker item",
// "SourceForge item ID (shows as aid in the url of a tracker item" => "SourceForge item ID (shows as aid in the url of a tracker item",
// "First part of link tooltip identifying the type of tracker item (bog, feature request, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bog, feature request, patch or support request)",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
// "Sharethis" => "Sharethis",
// "Display a social networking tool" => "Display a social networking tool",
// "Send Services" => "Send Services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "Aim" => "Aim",
// "Aim \$ Email" => "Aim \$ Email",
// "Aim \$ Sms" => "Aim \$ Sms",
// "Email \$ Sms" => "Email \$ Sms",
// "Button Style" => "Button Style",
// "Set button style: horizontal, vertical or rotate" => "Set button style: horizontal, vertical or rotate",
// "Rotate" => "Rotate",
// "Rotate Image" => "Rotate Image",
// "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Multiple Icons" => "Multiple Icons",
// "Enter list: email | facebook | twitter | sharethis, depending on which icons you\\'d like" => "Enter list: email | facebook | twitter | sharethis, depending on which icons you\\'d like",
// "First Services Shown" => "First Services Shown",
// "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Button Text" => "Button Text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header Title" => "Header Title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header Background" => "Header Background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header Text Color" => "Header Text Color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
// "Pop-up" => "Pop-up",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded Elements" => "Embedded Elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Display data from a TikiSheet" => "Display data from a TikiSheet",
// "Sheet Heading" => "Sheet Heading",
// "Internal ID of the TikiSheet.  Either id or url MUST be used" => "Internal ID of the TikiSheet.  Either id or url MUST be used",
// "Sheet Url Location" => "Sheet Url Location",
// "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used" => "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used",
// "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)" => "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)",
// "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"" => "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"",
// "Height in pixels or percentage. Default value is complete spreadsheet height" => "Height in pixels or percentage. Default value is complete spreadsheet height",
// "Editable" => "Editable",
// "Show edit button. Default \\'y\\' depending on user\\'s permissions" => "Show edit button. Default \\'y\\' depending on user\\'s permissions",
// "Show subsheets" => "Show subsheets",
// "y/n. Show multi-sheets. Default \\'y\\'" => "y/n. Show multi-sheets. Default \\'y\\'",
// "Range" => "Range",
// "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"" => "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"",
// "Apply custom CSS class to the containing div" => "Apply custom CSS class to the containing div",
// "New sheet in page: " => "New sheet in page: ",
// "Incomplete call to plugin: No target sheet" => "Incomplete call to plugin: No target sheet",
// "Create New Sheet" => "Create New Sheet",
// "PluginShowPages" => "PluginShowPages",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "Display page name and/or description. Both displayed by default" => "Display page name and/or description. Both displayed by default",
// "Name & Description" => "Name & Description",
// "Skype" => "Skype",
// "PluginSkype" => "PluginSkype",
// "Clickable Skype link" => "Clickable Skype link",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Set whether to call or chat. Default is chat" => "Set whether to call or chat. Default is chat",
// "Call" => "Call",
// "Chat" => "Chat",
// "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles" => "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles",
// "Slideshow notes - Separate with \"/////\"" => "Slideshow notes - Separate with \"/////\"",
// "The side on which you would like to display text if there are images that are resized or present" => "The side on which you would like to display text if there are images that are resized or present",
// "Tiki jQuery UI Theme" => "Tiki jQuery UI Theme",
// "Background Url Location" => "Background Url Location",
// "URL of the background image to use in your slideshow, overrides backgroundcolor" => "URL of the background image to use in your slideshow, overrides backgroundcolor",
// "Valid url" => "Valid url",
// "Background color to use in your slideshow, default " => "Background color to use in your slideshow, default ",
// "Any valid CSS class" => "Any valid CSS class",
// "Header font color" => "Header font color",
// "Apply a color to the headers of your slideshow" => "Apply a color to the headers of your slideshow",
// "Any html color" => "Any html color",
// "Header background color" => "Header background color",
// "Slide font color" => "Slide font color",
// "Apply a color to the slides of your slideshow" => "Apply a color to the slides of your slideshow",
// "Line Item highlight color" => "Line Item highlight color",
// "Apply a color to the line item when mouse over" => "Apply a color to the line item when mouse over",
// "Slide Seconds" => "Slide Seconds",
// "How many seconds a slide will be open while playing" => "How many seconds a slide will be open while playing",
// "Second count" => "Second count",
// "Text Side" => "Text Side",
// "Smarty function" => "Smarty function",
// "PluginSmarty" => "PluginSmarty",
// "Provides access to the tiki smarty functions like button" => "Provides access to the tiki smarty functions like button",
// "Smarty Function" => "Smarty Function",
// "The name of the smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php" => "The name of the smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php",
// "Snarf" => "Snarf",
// "PluginSnarf" => "PluginSnarf",
// "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified" => "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified",
// "Full URL to the page to include" => "Full URL to the page to include",
// "Regular Expression Pattern" => "Regular Expression Pattern",
// "PCRE-compliant regular expression pattern to find the parts you want changed" => "PCRE-compliant regular expression pattern to find the parts you want changed",
// "Regular Expression Replacement" => "Regular Expression Replacement",
// "PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "PCRE-compliant regular expression replacement syntax showing what the content should be changed to",
// "Enable/disable word wrapping of snippets of code (enabled by default)" => "Enable/disable word wrapping of snippets of code (enabled by default)",
// "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)" => "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)",
// "Switch the text display from left to right to right to left" => "Switch the text display from left to right to right to left",
// "HTML Content" => "HTML Content",
// "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)" => "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)",
// "Cache Url" => "Cache Url",
// "Cache time in minutes. Default is to use site preference, Set to 0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to 0 for no cache",
// "Text to click on to fetch the url via ajax" => "Text to click on to fetch the url via ajax",
// "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace" => "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace",
// "This data is put in a CODE caption" => "This data is put in a CODE caption",
// "PluginSort" => "PluginSort",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
// "Set the sort order of lines of content (default is ascending)" => "Set the sort order of lines of content (default is ascending)",
// "Reverse" => "Reverse",
// "Shuffle" => "Shuffle",
// "PluginSplit" => "PluginSplit",
// "Join Columns" => "Join Columns",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute for the columns" => "Generate the width attribute for the columns",
// "Column Sizes" => "Column Sizes",
// "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)" => "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
// "Display edit icon for each section" => "Display edit icon for each section",
// "Custom Class" => "Custom Class",
// "Add a class to customize the design" => "Add a class to customize the design",
// "SQL" => "SQL",
// "PluginSQL" => "PluginSQL",
// "Run an SQL query on a database" => "Run an SQL query on a database",
// "The SQL query goes in the body. Example: SELECT column1, column2 FROM table" => "The SQL query goes in the body. Example: SELECT column1, column2 FROM table",
// "DSN Name" => "DSN Name",
// "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php" => "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php",
// "Could not obtain valid DSN connection" => "Could not obtain valid DSN connection",
// "Stat" => "Stat",
// "PluginStat" => "PluginStat",
// "Displays statistics for articles, wiki pages and tracker items" => "Displays statistics for articles, wiki pages and tracker items",
// "Object Type" => "Object Type",
// "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons" => "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons",
// "Article & Tracker Item" => "Article & Tracker Item",
// "Article & Tracker Item & Wiki" => "Article & Tracker Item & Wiki",
// "Article & Wiki" => "Article & Wiki",
// "Article & Wiki & Tracker Item" => "Article & Wiki & Tracker Item",
// "Tracker Item & Article" => "Tracker Item & Article",
// "Tracker Item & Article & Wiki" => "Tracker Item & Article & Wiki",
// "Tracker Item & Wiki" => "Tracker Item & Wiki",
// "Tracker Item & Wiki & Article" => "Tracker Item & Wiki & Article",
// "Wiki & Article" => "Wiki & Article",
// "Wiki & Article & Tracker Item" => "Wiki & Article & Tracker Item",
// "Wiki & Tracker Item" => "Wiki & Tracker Item",
// "Wiki & Tracker Item & Article" => "Wiki & Tracker Item & Article",
// "Parent ID" => "Parent ID",
// "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)",
// "Last 24 Hours" => "Last 24 Hours",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Added and Viewed" => "Added and Viewed",
// "Viewed & Added" => "Viewed & Added",
// "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last 7 Days" => "Last 7 Days",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Week" => "This Week",
// "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Month" => "Last Month",
// "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Month" => "This Month",
// "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Year" => "Last Year",
// "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Year" => "This Year",
// "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Incorrect parameter: " => "Incorrect parameter: ",
// "PluginSub" => "PluginSub",
// "Subscribe or unsubscribe to a group" => "Subscribe or unsubscribe to a group",
// "Subscribe Group" => "Subscribe Group",
// "PluginSubscribeGroup" => "PluginSubscribeGroup",
// "text displyed before the button" => "text displyed before the button",
// "Group name to subscribe to or unsubscribe from" => "Group name to subscribe to or unsubscribe from",
// "Subscribe Text" => "Subscribe Text",
// "Subscribe text, containing %s as the placeholder for the group name" => "Subscribe text, containing %s as the placeholder for the group name",
// "Unsubscribe Text" => "Unsubscribe Text",
// "Unsubscribe text, containing %s as the placeholder for the group name" => "Unsubscribe text, containing %s as the placeholder for the group name",
// "Unsubscribe" => "Unsubscribe",
// "Subscribe Action" => "Subscribe Action",
// "Subscribe button label, containing %s as the placeholder for the group name" => "Subscribe button label, containing %s as the placeholder for the group name",
// "Unsubscribe Action" => "Unsubscribe Action",
// "Unsubscribe button label, containing %s as the placeholder for the group name" => "Unsubscribe button label, containing %s as the placeholder for the group name",
// "Subscribe Groups" => "Subscribe Groups",
// "PluginSubscribeGroups" => "PluginSubscribeGroups",
// "Text shown in the dropdown box. Default: \"Subscribe to a group\"" => "Text shown in the dropdown box. Default: \"Subscribe to a group\"",
// "Show Subscribe Box" => "Show Subscribe Box",
// "Show the subscribe drop down box (shown by default). Will not show if there are no other groups the user may register for" => "Show the subscribe drop down box (shown by default). Will not show if there are no other groups the user may register for",
// "Show Default" => "Show Default",
// "Shows which group is the user\\'s default group (if any) and allows the user to change his default group" => "Shows which group is the user\\'s default group (if any) and allows the user to change his default group",
// "Group Description" => "Group Description",
// "Show the description of the group (not shown by default)" => "Show the description of the group (not shown by default)",
// "Colon separated list of groups. By default the list of groups available to the user" => "Colon separated list of groups. By default the list of groups available to the user",
// "All groups including this group will be listed" => "All groups including this group will be listed",
// "Default URL" => "Default URL",
// "Page user will be directed to after clicking on icon to change default group" => "Page user will be directed to after clicking on icon to change default group",
// "You do not have permission to subscribe to groups" => "You do not have permission to subscribe to groups",
// "Subscribe newsletter" => "Subscribe newsletter",
// "PluginSubscribeNewsletter" => "PluginSubscribeNewsletter",
// "A button to subscribe to a newsletter available for a user if not already in" => "A button to subscribe to a newsletter available for a user if not already in",
// "Invitation message" => "Invitation message",
// "Newsletter ID" => "Newsletter ID",
// "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to" => "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to",
// "Confirmation Message" => "Confirmation Message",
// "Confirmation message after posting form. The plugin body is then the button label" => "Confirmation message after posting form. The plugin body is then the button label",
// "Button label. The plugin body is then the confirmation message" => "Button label. The plugin body is then the confirmation message",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
// "Already subscribed" => "Already subscribed",
// "PluginSup" => "PluginSup",
// "Displays text in superscript" => "Displays text in superscript",
// "PluginSurvey" => "PluginSurvey",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Tabs" => "Tabs",
// "PluginTabs" => "PluginTabs",
// "Display page content in a set of tabs" => "Display page content in a set of tabs",
// "Tabs content separated by /////" => "Tabs content separated by /////",
// "Tabset Name" => "Tabset Name",
// "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs" => "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs",
// "Tab Titles" => "Tab Titles",
// "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3" => "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3",
// "Displays a set of tabs" => "Displays a set of tabs",
// "No tab title specified. At least one has to be set to make the tabs appear" => "No tab title specified. At least one has to be set to make the tabs appear",
// "Tag" => "Tag",
// "PluginTag" => "PluginTag",
// "Displays the text between an html tag" => "Displays the text between an html tag",
// "Tag Name" => "Tag Name",
// "Any valid HTML tag, span by default" => "Any valid HTML tag, span by default",
// "CSS Style" => "CSS Style",
// "Equivalent to the style attribute of an HTML tag" => "Equivalent to the style attribute of an HTML tag",
// "Displays text between HTML tags" => "Displays text between HTML tags",
// "Title Search" => "Title Search",
// "PluginTitleSearch" => "PluginTitleSearch",
// "Search wiki page titles" => "Search wiki page titles",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "Also show page hits or user" => "Also show page hits or user",
// "Pipe-separated list of page names to exclude from results" => "Pipe-separated list of page names to exclude from results",
// "No Header" => "No Header",
// "Set to 1 (Yes) to have no header for the search results" => "Set to 1 (Yes) to have no header for the search results",
// "PluginTOC" => "PluginTOC",
// "Displays the table of contents for the current structure\\'s subtree as part of the page content" => "Displays the table of contents for the current structure\\'s subtree as part of the page content",
// "Maximum Depth" => "Maximum Depth",
// "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)" => "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)",
// "By default, structure for the current page will be displayed. Alternate structure may be provided" => "By default, structure for the current page will be displayed. Alternate structure may be provided",
// "Order items in ascending or descending order (deafult is ascending)" => "Order items in ascending or descending order (deafult is ascending)",
// "Show the page description instead of the page name" => "Show the page description instead of the page name",
// "Show Numbering" => "Show Numbering",
// "Display the section numbers or not" => "Display the section numbers or not",
// "Apply the \"plain\" or \"fancy\" style" => "Apply the \"plain\" or \"fancy\" style",
// "By default, the table of contents for the current page will be displayed. Alternate page may be provided" => "By default, the table of contents for the current page will be displayed. Alternate page may be provided",
// "PluginTopFriends" => "PluginTopFriends",
// "List top-scoring users" => "List top-scoring users",
// "Maximum result count" => "Maximum result count",
// "Set whether public or not" => "Set whether public or not",
// "PluginTR" => "PluginTR",
// "Translate a string using Tiki translation table" => "Translate a string using Tiki translation table",
// "Translate a string" => "Translate a string",
// "PluginTracker" => "PluginTracker",
// "Numeric value representing the tracker ID" => "Numeric value representing the tracker ID",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5",
// "Label on the submit button. Default is \"Save\"" => "Label on the submit button. Default is \"Save\"",
// "Display the title of the tracker (not shown by default)" => "Display the title of the tracker (not shown by default)",
// "Show the tracker\\'s description (not shown by default)" => "Show the tracker\\'s description (not shown by default)",
// "Mark Mandatory" => "Mark Mandatory",
// "Indicate mandatory fields with an asterisk (shown by default)" => "Indicate mandatory fields with an asterisk (shown by default)",
// "Show Status" => "Show Status",
// "Show the status of the items (not shown by default)" => "Show the status of the items (not shown by default)",
// "Embedded" => "Embedded",
// "To send an email once the tracker item has been created. Format: from" => "To send an email once the tracker item has been created. Format: from",
// "Email format" => "Email format",
// "Text or html setting" => "Text or html setting",
// "URL the user is sent to after the form is submitted" => "URL the user is sent to after the form is submitted",
// "Url Target" => "Url Target",
// "Set the target parameter for the url (determines whether target will open in a new pge, etc" => "Set the target parameter for the url (determines whether target will open in a new pge, etc",
// "Self" => "Self",
// "Values" => "Values",
// "Colon-separated list of default values.for the fields. First value corresponds to first field, second value to second field, etc" => "Colon-separated list of default values.for the fields. First value corresponds to first field, second value to second field, etc",
// "Overwrite current field values of the item with the input values" => "Overwrite current field values of the item with the input values",
// "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default" => "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default",
// "Label for the preview button. Default" => "Label for the preview button. Default",
// "Label for the reset button, to return all fields to their default values" => "Label for the reset button, to return all fields to their default values",
// "Status of the item used in combination with" => "Status of the item used in combination with",
// "ItemId" => "ItemId",
// "ItemId allowing for editing an item" => "ItemId allowing for editing an item",
// "Ignore ItemId" => "Ignore ItemId",
// "Do not filter on the parameter itemId if in the url" => "Do not filter on the parameter itemId if in the url",
// "Template File" => "Template File",
// "Name of the template used to display the tracker items" => "Name of the template used to display the tracker items",
// "Name of the wiki page containing the template to display the tracker items" => "Name of the wiki page containing the template to display the tracker items",
// "New Status" => "New Status",
// "Default status applied to newly created items" => "Default status applied to newly created items",
// "Pending" => "Pending",
// "Specify the width in pixels or percentage of the first column (the labels) in the tracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the tracker form",
// "Autosave fields" => "Autosave fields",
// "Colon-separated list of field IDs to be automatically filled with values" => "Colon-separated list of field IDs to be automatically filled with values",
// "Autosavevalue" => "Autosavevalue",
// "Colon-separated values corresponding to autosavefields" => "Colon-separated values corresponding to autosavefields",
// "Registration Fields" => "Registration Fields",
// "Add registration fields such as Username and Password" => "Add registration fields such as Username and Password",
// "Output To Wiki" => "Output To Wiki",
// "Output result to a new wiki page with the name taken from the input for the specified fieldId" => "Output result to a new wiki page with the name taken from the input for the specified fieldId",
// "Discard After Output" => "Discard After Output",
// "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created" => "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created",
// "Template Page" => "Template Page",
// "Name of the wiki page containing the template to format the output to wiki page" => "Name of the wiki page containing the template to format the output to wiki page",
// "Embed the tracker in a form tag" => "Embed the tracker in a form tag",
// "If set to Yes, the tracker is contained in a <form> tag and has action buttons" => "If set to Yes, the tracker is contained in a <form> tag and has action buttons",
// "The page to output the results to already exists. Try another name" => "The page to output the results to already exists. Try another name",
// "Incorrect fieldId" => "Incorrect fieldId",
// "Displays an input form for tracker submit" => "Displays an input form for tracker submit",
// "You do not have permission to insert an item" => "You do not have permission to insert an item",
// "You do not have permission to modify an item" => "You do not have permission to modify an item",
// "The page to output the results to contains the following prohibited characters: \$page_badchars_display. Try another name" => "The page to output the results to contains the following prohibited characters: \$page_badchars_display. Try another name",
// "Invalid email" => "Invalid email",
// "Passwords do not match" => "Passwords do not match",
// "Displays the number of tracker comments" => "Displays the number of tracker comments",
// "Item Count" => "Item Count",
// "Determines whether the number of items will be shown (not shown by default)" => "Determines whether the number of items will be shown (not shown by default)",
// "Enter a user name to select the items of the current user" => "Enter a user name to select the items of the current user",
// "a user name" => "a user name",
// "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / \n\t\t\t\t\t\t\t\t and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown;\n\t\t\t\t\t\t\t\t c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= -\n\t\t\t\t\t\t\t\t greater than, less than, greater than or equal, less than or equal. Example" => "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / \n\t\t\t\t\t\t\t\t and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown;\n\t\t\t\t\t\t\t\t c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= -\n\t\t\t\t\t\t\t\t greater than, less than, greater than or equal, less than or equal. Example",
// "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)" => "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)",
// "Show the full list (before filtering) initially (filtered list shown by default)" => "Show the full list (before filtering) initially (filtered list shown by default)",
// "Displays all the filters on the same line (not shown on same line by default)" => "Displays all the filters on the same line (not shown on same line by default)",
// "No Toggle" => "No Toggle",
// "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle" => "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle",
// "Export CSV" => "Export CSV",
// "Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "Label for an export button. Leave blank to show the usual \"Filter\" button instead",
// "Google Map Buttons" => "Google Map Buttons",
// "Display Mapview and Listview buttons" => "Display Mapview and Listview buttons",
// "PluginTrackerFilter" => "PluginTrackerFilter",
// "Filters the items of a tracker, fields are indicated with numeric ids" => "Filters the items of a tracker, fields are indicated with numeric ids",
// "tracker field type not processed yet" => "tracker field type not processed yet",
// "PluginTrackerItemField" => "PluginTrackerItemField",
// "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)" => "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)",
// "Wiki text containing an {ELSE} marker" => "Wiki text containing an {ELSE} marker",
// "Numeric value representing the item ID. Default is the user tracker item for the current user" => "Numeric value representing the item ID. Default is the user tracker item for the current user",
// "Numeric value representing the field ID displayed or tested" => "Numeric value representing the field ID displayed or tested",
// "Colon separated list of field IDs. Default is all fields" => "Colon separated list of field IDs. Default is all fields",
// "Status of the tracker item" => "Status of the tracker item",
// "Open & Pending" => "Open & Pending",
// "Open & Closed" => "Open & Closed",
// "Pending & Closed" => "Pending & Closed",
// "Open, Pending & Closed" => "Open, Pending & Closed",
// "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter" => "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter",
// "Value to compare against" => "Value to compare against",
// "PluginTrackerList" => "PluginTrackerList",
// "Displays the output of a tracker content, fields are indicated with numeric ids" => "Displays the output of a tracker content, fields are indicated with numeric ids",
// "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5",
// "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7" => "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7",
// "Sticky Popup" => "Sticky Popup",
// "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)",
// "Show Links" => "Show Links",
// "Show links to each tracker item (not shown by default)" => "Show links to each tracker item (not shown by default)",
// "Show Item Count" => "Show Item Count",
// "Show the number of items found (not shown by default)" => "Show the number of items found (not shown by default)",
// "Show Initials" => "Show Initials",
// "Show an alphabetical index by first letter to assist in navigation (not shown by default)" => "Show an alphabetical index by first letter to assist in navigation (not shown by default)",
// "Creation date display is based on tracker settings unless overriden here" => "Creation date display is based on tracker settings unless overriden here",
// "Last Modification Date" => "Last Modification Date",
// "Last modification date display is based on tracker settings unless overriden here" => "Last modification date display is based on tracker settings unless overriden here",
// "Show Field Name" => "Show Field Name",
// "Use the field names as column titles (used by default)" => "Use the field names as column titles (used by default)",
// "Show Item Rank" => "Show Item Rank",
// "Show item ranks (not shown by default)" => "Show item ranks (not shown by default)",
// "Status Filter" => "Status Filter",
// "Only show items matching certain status filters (only items with open status shown by default)" => "Only show items matching certain status filters (only items with open status shown by default)",
// "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: " => "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: ",
// "(replacing fieldId with the field ID number)" => "(replacing fieldId with the field ID number)",
// "Sort Choice" => "Sort Choice",
// "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first" => "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first",
// "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set" => "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set",
// "Offset of first item. Default is no offset" => "Offset of first item. Default is no offset",
// "Show Pagination" => "Show Pagination",
// "Determines whether pagination will be shown (shown by default)" => "Determines whether pagination will be shown (shown by default)",
// "Colon separated list of fields to allow filtering on" => "Colon separated list of fields to allow filtering on",
// "Filter value of the filterfield. For better performance, use exactvalue instead" => "Filter value of the filterfield. For better performance, use exactvalue instead",
// "Exact value of the filter" => "Exact value of the filter",
// "Checkbox" => "Checkbox",
// "Adds a checkbox on each line to be able to do an action" => "Adds a checkbox on each line to be able to do an action",
// "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown" => "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown",
// "goIfOne" => "goIfOne",
// "Go directly to tiki-view_tracker_item.php if only one item is found" => "Go directly to tiki-view_tracker_item.php if only one item is found",
// "Show a \\'more\\' button that links to tiki-view_tracker.php (not shown by default)" => "Show a \\'more\\' button that links to tiki-view_tracker.php (not shown by default)",
// "More URL" => "More URL",
// "More link pointing to specified URL instead of default tracker item link" => "More link pointing to specified URL instead of default tracker item link",
// "Display only the items of the current user or the current page name" => "Display only the items of the current user or the current page name",
// "Use content of the tpl file as template to display the item" => "Use content of the tpl file as template to display the item",
// "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "Template file in a Wiki page" => "Template file in a Wiki page",
// "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "View User" => "View User",
// "Will display the items of the specified user" => "Will display the items of the specified user",
// "Item ID separated with " => "Item ID separated with ",
// "To restrict the list to these item IDs" => "To restrict the list to these item IDs",
// "Ignore the itemId url parameter when filtering list (not ignored by default)" => "Ignore the itemId url parameter when filtering list (not ignored by default)",
// "The link that will be on each main field" => "The link that will be on each main field",
// "Left Deliminator" => "Left Deliminator",
// "Smarty left delimiter for Latex generation" => "Smarty left delimiter for Latex generation",
// "Right Deliminator" => "Right Deliminator",
// "Smarty right delimiter for Latex generation" => "Smarty right delimiter for Latex generation",
// "List Mode" => "List Mode",
// "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outpits without any HTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outpits without any HTML formatting",
// "Comma Separated Values" => "Comma Separated Values",
// "Export Button" => "Export Button",
// "Show an export button (not shown by default)" => "Show an export button (not shown by default)",
// "Compute" => "Compute",
// "Sum or average all the values of a field and displays it at the bottom of the table" => "Sum or average all the values of a field and displays it at the bottom of the table",
// "fieldId" => "fieldId",
// "Silent" => "Silent",
// "Show nothing if no items found (the table header and a \\'No records found\\' message is shown by default)" => "Show nothing if no items found (the table header and a \\'No records found\\' message is shown by default)",
// "Show Delete" => "Show Delete",
// "Show a delete option (not shown by default)" => "Show a delete option (not shown by default)",
// "Show Watch Button" => "Show Watch Button",
// "Show a watch button (not shown by default)" => "Show a watch button (not shown by default)",
// "Show Feed Button" => "Show Feed Button",
// "Show an RSS feed button (not shown by default)" => "Show an RSS feed button (not shown by default)",
// "Show Google Map" => "Show Google Map",
// "Show Google Map of results (not shown by default)" => "Show Google Map of results (not shown by default)",
// "Google Map Icon" => "Google Map Icon",
// "Url of default icon to use for markers on the map" => "Url of default icon to use for markers on the map",
// "Calendar Field IDs" => "Calendar Field IDs",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end",
// "Calendar View Mode" => "Calendar View Mode",
// "Calendar view type time span (default is month)" => "Calendar view type time span (default is month)",
// "Bimester" => "Bimester",
// "Trimester" => "Trimester",
// "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default" => "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default",
// "Beginning of Month" => "Beginning of Month",
// "Set whether calendar will begin at the beginning of the month (does by default)" => "Set whether calendar will begin at the beginning of the month (does by default)",
// "Show calendar navigation bar (shown by default)" => "Show calendar navigation bar (shown by default)",
// "Partial" => "Partial",
// "Calendar Title" => "Calendar Title",
// "Enter a title to display a calendar title (not set by default)" => "Enter a title to display a calendar title (not set by default)",
// "Calendar Delta" => "Calendar Delta",
// "Set the calendar delta that will be shown (not set by default)" => "Set the calendar delta that will be shown (not set by default)",
// "Plus Month" => "Plus Month",
// "Minus Month" => "Minus Month",
// "Plus Bimester" => "Plus Bimester",
// "Minus Bimester" => "Minus Bimester",
// "Display Spreadsheet" => "Display Spreadsheet",
// "Display tracker as a spreadsheet (not used by default)" => "Display tracker as a spreadsheet (not used by default)",
// "Force Compile" => "Force Compile",
// "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)",
// "Period quantity" => "Period quantity",
// "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)" => "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)",
// "Period unit" => "Period unit",
// "Time unit used with \"Period quantity\"" => "Time unit used with \"Period quantity\"",
// "incorrect filterfield" => "incorrect filterfield",
// "Error in tracker ID" => "Error in tracker ID",
// "Tracker Prefill" => "Tracker Prefill",
// "PluginTrackerPrefill" => "PluginTrackerPrefill",
// "Tracker Page Name" => "Tracker Page Name",
// "URL Parameters" => "URL Parameters",
// "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q" => "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q",
// "Field ID for the first field" => "Field ID for the first field",
// "Content that should be used to prefill the field" => "Content that should be used to prefill the field",
// "Field ID for the second field" => "Field ID for the second field",
// "Field ID for the third field" => "Field ID for the third field",
// "Field ID for the fourth field" => "Field ID for the fourth field",
// "Field ID for the fifth field" => "Field ID for the fifth field",
// "PluginTrackerStat" => "PluginTrackerStat",
// "Displays some stat of a tracker content, fields are indicated with numeric ids" => "Displays some stat of a tracker content, fields are indicated with numeric ids",
// "Choose whether to show the percentage of the vote each option received (not shown by default)" => "Choose whether to show the percentage of the vote each option received (not shown by default)",
// "Choose whether to show a bar representing the number of votes each option received (not shown by default)" => "Choose whether to show a bar representing the number of votes each option received (not shown by default)",
// "Only show items matching certain status filters" => "Only show items matching certain status filters",
// "Show Link" => "Show Link",
// "Show link to tiki-view_tracker" => "Show link to tiki-view_tracker",
// "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)" => "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)",
// "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"" => "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"",
// "invalid status" => "invalid status",
// "Tracker Timeline" => "Tracker Timeline",
// "PluginTrackerTimeline" => "PluginTrackerTimeline",
// "Timeline view of a tracker, can be used to display event schedules or gantt charts" => "Timeline view of a tracker, can be used to display event schedules or gantt charts",
// "Tracker Field ID containing the item title" => "Tracker Field ID containing the item title",
// "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Primary Scale Unit" => "Primary Scale Unit",
// "Unit of time to use for the primary scale (default to hour)" => "Unit of time to use for the primary scale (default to hour)",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "Unit of time to use for the secondary scale (default to empty)" => "Unit of time to use for the secondary scale (default to empty)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link" => "Convert the group name to a link",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Trade" => "Trade",
// "PluginTrade" => "PluginTrade",
// "Send or receive payments from one member to another. (for cclite only so far, experimental)" => "Send or receive payments from one member to another. (for cclite only so far, experimental)",
// "Currency depends on the selected registry" => "Currency depends on the selected registry",
// "Registry to trade in. Default: site preference (or first in list when more than one)" => "Registry to trade in. Default: site preference (or first in list when more than one)",
// "Currency to trade in. Default: Cclite currency preference for registry set above" => "Currency to trade in. Default: Cclite currency preference for registry set above",
// "Other User" => "Other User",
// "Name of the user to recieve or send the payment" => "Name of the user to recieve or send the payment",
// "Leave empty to display an input box" => "Leave empty to display an input box",
// "Offered or wanted item" => "Offered or wanted item",
// "Offered" => "Offered",
// "Wanted" => "Wanted",
// "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted",
// "Please log in" => "Please log in",
// "The user " => "The user ",
// " needs to validate their account" => " needs to validate their account",
// "Transclusion" => "Transclusion",
// "PluginTransclusion" => "PluginTransclusion",
// "Includes the content of a wiki page and replaces values in the body of the included page. All additional parameters will be replaced. For example %%%title%%% will be replaced with the parameter title in the plugin" => "Includes the content of a wiki page and replaces values in the body of the included page. All additional parameters will be replaced. For example %%%title%%% will be replaced with the parameter title in the plugin",
// "Name of the wiki page to use as a template for the values" => "Name of the wiki page to use as a template for the values",
// "Permission Denied" => "Permission Denied",
// "Attempt to include a page that cannot be viewed" => "Attempt to include a page that cannot be viewed",
// "Page named \"%0\" does not exist at this time" => "Page named \"%0\" does not exist at this time",
// "PluginTranslated" => "PluginTranslated",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, ex: fr" => "Two letter language code of the language, ex: fr",
// "Country name, ex: France" => "Country name, ex: France",
// "User Count" => "User Count",
// "PluginUserCount" => "PluginUserCount",
// "Displays the number of users that are registered or within a group" => "Displays the number of users that are registered or within a group",
// "PluginUserlink" => "PluginUserlink",
// "User account name" => "User account name",
// "User account name (which can be an email address)" => "User account name (which can be an email address)",
// "Display a list of registered users" => "Display a list of registered users",
// "Login Filter" => "Login Filter",
// "Separator to use between users in the list. Default: comma" => "Separator to use between users in the list. Default: comma",
// "User info" => "User info",
// "User page" => "User page",
// "User pref" => "User pref",
// "Display the user\\'s real name (when available) instead of login name" => "Display the user\\'s real name (when available) instead of login name",
// "Filter on a group" => "Filter on a group",
// "Display wiki text if user has a pref set to a value" => "Display wiki text if user has a pref set to a value",
// "Split the text in parts visible only under some conditions" => "Split the text in parts visible only under some conditions",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
// "Navigation" => "Navigation",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default" => "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default",
// "Default Label" => "Default Label",
// "Specifies version label to show when displaying the page for the first time. Default label is \\'Default\\'" => "Specifies version label to show when displaying the page for the first time. Default label is \\'Default\\'",
// "This is the default text" => "This is the default text",
// "(version 3)" => "(version 3)",
// "This is version 3 info" => "This is version 3 info",
// "(version 2)" => "(version 2)",
// "This is version 2 info" => "This is version 2 info",
// "(version 1)" => "(version 1)",
// "This is version 1 info" => "This is version 1 info",
// "Display a Vimeo video" => "Display a Vimeo video",
// "Quality of the video" => "Quality of the video",
// "Full screen" => "Full screen",
// "Expand to full screen" => "Expand to full screen",
// "PluginVote" => "PluginVote",
// "Show Stats" => "Show Stats",
// "Choose whether to show the voting results (shown by default)" => "Choose whether to show the voting results (shown by default)",
// "Show Stats After" => "Show Stats After",
// "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not shown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not shown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set by default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set by default)",
// "Wanted Pages" => "Wanted Pages",
// "Lists \\'\\'wanted\\'\\' wiki pages" => "Lists \\'\\'wanted\\'\\' wiki pages",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)",
// "Ignore" => "Ignore",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "Split By" => "Split By",
// "The character by which ignored patterns are separated" => "The character by which ignored patterns are separated",
// "Skip Extension" => "Skip Extension",
// "Whether to include external wikis in the list (not included by default)" => "Whether to include external wikis in the list (not included by default)",
// "Collect" => "Collect",
// "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column",
// "Switch on debug output with details about the items (debug not on by default)" => "Switch on debug output with details about the items (debug not on by default)",
// "Memory Saver" => "Memory Saver",
// "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell",
// "Comma" => "Comma",
// "Separate Row" => "Separate Row",
// "Level" => "Level",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site\\'s __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site\\'s __current__ page_regex",
// "Custom" => "Custom",
// "Full" => "Full",
// "non-valid custom regex" => "non-valid custom regex",
// ", " => ", ",
// "not in level" => "not in level",
// "End of debug output" => "End of debug output",
// "Referenced By Page" => "Referenced By Page",
// "Lists ''wanted'' Wiki pages: " => "Lists ''wanted'' Wiki pages: ",
// "Page-Pattern" => "Page-Pattern",
// "Custom-Level-Regex" => "Custom-Level-Regex",
// "^Parameters: key=>value,...\n" => "^Parameters: key=>value,...\n",
// "A wildcard pattern of originating pages to be ignored" => "A wildcard pattern of originating pages to be ignored",
// "(refer to PHP function fnmatch() for details)\n" => "(refer to PHP function fnmatch() for details)\n",
// "The character, by which ignored patterns are separated" => "The character, by which ignored patterns are separated",
// "possible values: characters\n" => "possible values: characters\n",
// "Whether to include external wikis in the list" => "Whether to include external wikis in the list",
// "possible values: " => "possible values: ",
// "Collect either originating or wanted pages in a cell and display them in the second column" => "Collect either originating or wanted pages in a cell and display them in the second column",
// "Switch-on debug output with details about the items" => "Switch-on debug output with details about the items",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex",
// "A custom filter for wanted pages to be listed (only used when level=>custom)" => "A custom filter for wanted pages to be listed (only used when level=>custom)",
// "Watershed" => "Watershed",
// "Viewer for UStream Watershed Embed" => "Viewer for UStream Watershed Embed",
// "Specify archive, broadcaster, chat or viewer" => "Specify archive, broadcaster, chat or viewer",
// "Broadcaster" => "Broadcaster",
// "Viewer" => "Viewer",
// "Channel code" => "Channel code",
// "Specify the channel code to search in the tracker for a channel to use" => "Specify the channel code to search in the tracker for a channel to use",
// "Brand ID" => "Brand ID",
// "Specify the brand id to search in the tracker for a channel to use" => "Specify the brand id to search in the tracker for a channel to use",
// "Brand prefix" => "Brand prefix",
// "Copy the prefix from the chat embed, e.g. Name-of-Brand-" => "Copy the prefix from the chat embed, e.g. Name-of-Brand-",
// "Video ID" => "Video ID",
// "Video ID of archive which can be found in the tracker" => "Video ID of archive which can be found in the tracker",
// "Locale" => "Locale",
// "Locale specified in viewer embed, default is en_US" => "Locale specified in viewer embed, default is en_US",
// "More than one channel found for specified criteria. Please be more specific" => "More than one channel found for specified criteria. Please be more specific",
// "No videoId specified for archive" => "No videoId specified for archive",
// "Web Service" => "Web Service",
// "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface" => "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "Service Name" => "Service Name",
// "Registered service name" => "Registered service name",
// "Template Name" => "Template Name",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Unknown Template" => "Unknown Template",
// "Unknown Service" => "Unknown Service",
// "Missing parameters" => "Missing parameters",
// "Movie" => "Movie",
// "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)" => "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)",
// "Quality of the video. Default is high" => "Quality of the video. Default is high",
// "Show related videos (shown by default)" => "Show related videos (shown by default)",
// "Background" => "Background",
// "Toolbar background color. Use an HTML color code. Example: ffffff" => "Toolbar background color. Use an HTML color code. Example: ffffff",
// "HTML color code, e.g. ffffff" => "HTML color code, e.g. ffffff",
// "Borders" => "Borders",
// "Toolbar border colors. Use an HTML color code. Example: ffffff" => "Toolbar border colors. Use an HTML color code. Example: ffffff",
// "Plugin YouTube error: the movie parameter is empty" => "Plugin YouTube error: the movie parameter is empty",
// "Missing parameter movie to the Youtube plugin" => "Missing parameter movie to the Youtube plugin",
// "Cannot create aliased page" => "Cannot create aliased page",
// "You attempted to create the following page" => "You attempted to create the following page",
// "That page is an alias for the following pages" => "That page is an alias for the following pages",
// "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this" => "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
// "rollback version " => "rollback version ",
// "Changed actual version to \$version" => "Changed actual version to \$version",
// "Plugin " => "Plugin ",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
// "User %s does not have the permission" => "User %s does not have the permission",
// "The message has been sent to" => "The message has been sent to",
// "The message will be sent to" => "The message will be sent to",
// "User %s does not want to receive messages" => "User %s does not want to receive messages",
// "ERROR: Invalid tab_id received. Numeric format expected, got \$tab_id" => "ERROR: Invalid tab_id received. Numeric format expected, got \$tab_id",
// "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page",
// "Find similar content based on FreeTags" => "Find similar content based on FreeTags",
// "Display only similar content of type specified" => "Display only similar content of type specified",
// "Default: \"All Content Type\"" => "Default: \"All Content Type\"",
// "Options: \"article, wiki page, blog post\"" => "Options: \"article, wiki page, blog post\"",
// "Broaden FreeTag Search" => "Broaden FreeTag Search",
// "Find similar content that contains one of the Tags or All of the Tags" => "Find similar content that contains one of the Tags or All of the Tags",
// "Default: \"n - needs to contain all of the Tags\"" => "Default: \"n - needs to contain all of the Tags\"",
// "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"",
// "Google AdSense" => "Google AdSense",
// "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code",
// "Shows links to the published articles for each month" => "Shows links to the published articles for each month",
// "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values: 13, !13, 1+3, !1+5+7" => "Example values: 13, !13, 1+3, !1+5+7",
// "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered",
// "Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Example values: Event, !Event, Event+Review, !Event+Classified+Article",
// "If set to a language code, only consider the articles in the specified language" => "If set to a language code, only consider the articles in the specified language",
// "Lists all article topics with links to their articles" => "Lists all article topics with links to their articles",
// "Lists the specified number of published articles in the specified order" => "Lists the specified number of published articles in the specified order",
// "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image" => "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image",
// "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed",
// "If set to a language code, only lists the articles in the specified language" => "If set to a language code, only lists the articles in the specified language",
// "Specifies how the articles should be sorted" => "Specifies how the articles should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date",
// "Absolute URL" => "Absolute URL",
// "Displays an assistant to guide new Tiki admins" => "Displays an assistant to guide new Tiki admins",
// "Displays the specified number of the blog post comments most recently added" => "Displays the specified number of the blog post comments most recently added",
// "If set to \"y\", the date of comments is not displayed in the module box" => "If set to \"y\", the date of comments is not displayed in the module box",
// "Verbose tooltips" => "Verbose tooltips",
// "If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "If set to \"y\", blog post title is only visible as a tooltip and not displayed",
// "Options: \"y,n\"" => "Options: \"y,n\"",
// "Displays the last Wiki pages visited by the user" => "Displays the last Wiki pages visited by the user",
// "Includes a calendar or a list of calendar events" => "Includes a calendar or a list of calendar events",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")",
// "Show action" => "Show action",
// "Displays the content of the cart, allows to modify quantities and proceed to payment" => "Displays the content of the cart, allows to modify quantities and proceed to payment",
// "The quantities in your cart were updated" => "The quantities in your cart were updated",
// "The order was recorded and is now awaiting payment. Reference number is %0" => "The order was recorded and is now awaiting payment. Reference number is %0",
// "Displays links to categories as a tree" => "Displays links to categories as a tree",
// "Object type filter to apply when accessing a linked category. Example values" => "Object type filter to apply when accessing a linked category. Example values",
// "PHP Layers menu style" => "PHP Layers menu style",
// "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree" => "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree",
// "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)" => "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)",
// "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6",
// "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules" => "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules",
// "Enables to categorize an object" => "Enables to categorize an object",
// "Category identifier" => "Category identifier",
// "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier",
// "Note that the root category is not displayed" => "Note that the root category is not displayed",
// "Defaults to 0 (root)" => "Defaults to 0 (root)",
// "No top" => "No top",
// "In non-detailed view, disallow uncategorizing. Example value: 1" => "In non-detailed view, disallow uncategorizing. Example value: 1",
// "Display path" => "Display path",
// "Instead of category names, diplay their path in the category tree starting from the category root defined" => "Instead of category names, diplay their path in the category tree starting from the category root defined",
// "Example value: 1" => "Example value: 1",
// "Multiple categories" => "Multiple categories",
// "If set to \"n\", only allows categorizing in one category (from those displayed)" => "If set to \"n\", only allows categorizing in one category (from those displayed)",
// "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize",
// "Shy" => "Shy",
// "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default" => "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default",
// "Detailed" => "Detailed",
// "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list",
// "If set to \"n\", the detailed list of categories will not offer to unassign a category" => "If set to \"n\", the detailed list of categories will not offer to unassign a category",
// "If set to \"y\", allow to assign new categories" => "If set to \"y\", allow to assign new categories",
// "Example values: y, n" => "Example values: y, n",
// "Default value: y" => "Default value: y",
// "Default value: n" => "Default value: n",
// "Image URL not in category" => "Image URL not in category",
// "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category",
// "Image URL in category" => "Image URL in category",
// "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category",
// "Categorize %s" => "Categorize %s",
// "Categorize %s in %s" => "Categorize %s in %s",
// "Displays the number of pages received (via Communications)" => "Displays the number of pages received (via Communications)",
// "Shows the credits a user has" => "Shows the credits a user has",
// "Displays the specified number of the directory sites most recently added" => "Displays the specified number of the directory sites most recently added",
// "Directory category identifier" => "Directory category identifier",
// "If set to a directory category identifier, only displays the sites in the specified directory category" => "If set to a directory category identifier, only displays the sites in the specified directory category",
// "If set to \"y\", displays a button labelled \"More\" that links to the directory" => "If set to \"y\", displays a button labelled \"More\" that links to the directory",
// "If set to \"y\", the description of the directory site appears" => "If set to \"y\", the description of the directory site appears",
// "Maximum length of description" => "Maximum length of description",
// "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)",
// "Default: blank" => "Default: blank",
// "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links",
// "Displays the specified number of the directory sites from most visited to least visited" => "Displays the specified number of the directory sites from most visited to least visited",
// "Displays the site\\'s first featured links" => "Displays the site\\'s first featured links",
// "Displays links to file galleries" => "Displays links to file galleries",
// "Displays the specified number of the forum topics with the best ratings" => "Displays the specified number of the forum topics with the best ratings",
// "Displays the latest forum posts" => "Displays the latest forum posts",
// "If set to \"y\", only displays topics" => "If set to \"y\", only displays topics",
// "List of forum IDs" => "List of forum IDs",
// "Post only from this forum" => "Post only from this forum",
// "Displays the specified number of the forums with the most comments" => "Displays the specified number of the forums with the most comments",
// "Displays the specified number of the forum topics with the most reads" => "Displays the specified number of the forum topics with the most reads",
// "Displays the specified number of the forums with the most visits" => "Displays the specified number of the forums with the most visits",
// "Shows current freetags and enables to add and remove some if permissions allow" => "Shows current freetags and enables to add and remove some if permissions allow",
// "Freetags Wiki" => "Freetags Wiki",
// "Displays current freetags on wiki pages and enables to add tags if permissions allow" => "Displays current freetags on wiki pages and enables to add tags if permissions allow",
// "Shows content with multiple freetags in common" => "Shows content with multiple freetags in common",
// "Similar pages" => "Similar pages",
// "Shows the most popular freetags. More popularity is indicated by a larger font" => "Shows the most popular freetags. More popularity is indicated by a larger font",
// "Display type" => "Display type",
// "If set to \"cloud\", links are displayed as a cloud" => "If set to \"cloud\", links are displayed as a cloud",
// "Default: \"list\"" => "Default: \"list\"",
// "Maximum elements" => "Maximum elements",
// "If set to a number, limits the number of tags displayed" => "If set to a number, limits the number of tags displayed",
// "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font" => "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font",
// "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site",
// "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site" => "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site",
// "Displays the specified number of last actions" => "Displays the specified number of last actions",
// "If set to \"y\", user names are displayed in the module box" => "If set to \"y\", user names are displayed in the module box",
// "If set to \"y\", action dates are displayed in the module box" => "If set to \"y\", action dates are displayed in the module box",
// "Maximum number of characters in action descriptions before truncating" => "Maximum number of characters in action descriptions before truncating",
// "Lists the specified number of blogs posts from newest to oldest" => "Lists the specified number of blogs posts from newest to oldest",
// "If set to \"y\", the date of posts is not displayed in the module box" => "If set to \"y\", the date of posts is not displayed in the module box",
// "Blog identifier" => "Blog identifier",
// "If set to a blog identifier, restricts the blog posts to those in the identified blog" => "If set to a blog identifier, restricts the blog posts to those in the identified blog",
// "Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Lists the specified number of objects of the given type in the given category, starting from the most recently created",
// "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed",
// "Maximum number of characters in object names allowed before truncating" => "Maximum number of characters in object names allowed before truncating",
// "Type of the objects to list. Example values" => "Type of the objects to list. Example values",
// "no object here yet" => "no object here yet",
// "Displays the specified number of blogs from newest to oldest" => "Displays the specified number of blogs from newest to oldest",
// "Displays the specified number of FAQs from newest to oldest" => "Displays the specified number of FAQs from newest to oldest",
// "Displays the specified number of quizzes from newest to oldest" => "Displays the specified number of quizzes from newest to oldest",
// "Displays the specified number of file galleries, starting from the most recently modified" => "Displays the specified number of file galleries, starting from the most recently modified",
// "List the specified number of files, starting from the most recently added" => "List the specified number of files, starting from the most recently added",
// "Gallery identifiers" => "Gallery identifiers",
// "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers",
// "Example value: 13, 2:13, 1:2:3:5:6" => "Example value: 13, 2:13, 1:2:3:5:6",
// "Displays the specified number of image galleries, starting from the most recently modified" => "Displays the specified number of image galleries, starting from the most recently modified",
// "List the specified number of images, starting from the most recently added" => "List the specified number of images, starting from the most recently added",
// "Gallery identifier" => "Gallery identifier",
// "If set to an image gallery identifier, restricts the images to those in the identified gallery" => "If set to an image gallery identifier, restricts the images to those in the identified gallery",
// "Link content" => "Link content",
// "Display the links as image names or thumbnails" => "Display the links as image names or thumbnails",
// "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"",
// "Displays the specified number of calendar events, starting from the most recently modified" => "Displays the specified number of calendar events, starting from the most recently modified",
// "Calendar identifier" => "Calendar identifier",
// "If set to a calendar identifier, restricts the events to those in the identified calendar" => "If set to a calendar identifier, restricts the events to those in the identified calendar",
// "Maximum number of characters in event names allowed before truncating" => "Maximum number of characters in event names allowed before truncating",
// "If set to \"y\", it will hide date" => "If set to \"y\", it will hide date",
// "Don't show date" => "Don't show date",
// "Lists the specified number of pages, starting from the most recently modified" => "Lists the specified number of pages, starting from the most recently modified",
// "Displays the specified number of blogs, starting from the most recently modified" => "Displays the specified number of blogs, starting from the most recently modified",
// "Displays Podcasts" => "Displays Podcasts",
// "File galleries IDs" => "File galleries IDs",
// "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned",
// "Width of mediaplayer in pixels. Default is 190" => "Width of mediaplayer in pixels. Default is 190",
// "Height of mediaplayer in pixels. Default is 20" => "Height of mediaplayer in pixels. Default is 20",
// "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)",
// "Bottom Link URL" => "Bottom Link URL",
// "URL for a link at bottom of module" => "URL for a link at bottom of module",
// "Bottom Link URL Text" => "Bottom Link URL Text",
// "Text for link if Bottom Link URL is set. Default is \"More Podcasts\"" => "Text for link if Bottom Link URL is set. Default is \"More Podcasts\"",
// "Verbose" => "Verbose",
// "Display description of podcast below player if \"y\", and on title mouseover if \"n\". Default is \"y\"" => "Display description of podcast below player if \"y\", and on title mouseover if \"n\". Default is \"y\"",
// "Lists the specified number of article submissions from newest to oldest" => "Lists the specified number of article submissions from newest to oldest",
// "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted",
// "Tracker identifier" => "Tracker identifier",
// "If set to a tracker identifier, only displays the comments on the given tracker" => "If set to a tracker identifier, only displays the comments on the given tracker",
// "Item identifier" => "Item identifier",
// "If set to an item identifier, only displays the comments on the given item" => "If set to an item identifier, only displays the comments on the given item",
// "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required",
// "Identifier of the tracker from which items are listed" => "Identifier of the tracker from which items are listed",
// "Field identifier" => "Field identifier",
// "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored",
// "Field name" => "Field name",
// "Name of the field from which values are listed" => "Name of the field from which values are listed",
// "Example value: age" => "Example value: age",
// "Specifies how the items should be sorted" => "Specifies how the items should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date",
// "Status filter" => "Status filter",
// "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values",
// "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set",
// "You do not have permission to view this tracker" => "You do not have permission to view this tracker",
// "Displays the specified number of validated questions FAQs from newest to oldest" => "Displays the specified number of validated questions FAQs from newest to oldest",
// "Faq identifier" => "Faq identifier",
// "If set to a faq identifier, restricts the chosen questions to those in the identified faq" => "If set to a faq identifier, restricts the chosen questions to those in the identified faq",
// "Displays information about the specified number of users in decreasing order of last login time" => "Displays information about the specified number of users in decreasing order of last login time",
// "Show avatars" => "Show avatars",
// "If set to \"y\", show user avatars" => "If set to \"y\", show user avatars",
// "Maximum number of characters in user names allowed before truncating" => "Maximum number of characters in user names allowed before truncating",
// "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console",
// "Logo" => "Logo",
// "Page to display in the menu. Example value: HomePage" => "Page to display in the menu. Example value: HomePage",
// "Menu structure" => "Menu structure",
// "Displays a structure" => "Displays a structure",
// "Structure to display in the menu" => "Structure to display in the menu",
// "Displays to users their number of new inter-user messages and a link to their message box" => "Displays to users their number of new inter-user messages and a link to their message box",
// "Show If Empty" => "Show If Empty",
// "Show the module when there are no messages waiting. y|n " => "Show the module when there are no messages waiting. y|n ",
// "Default=y" => "Default=y",
// "Small live chat box" => "Small live chat box",
// "Links to the objects of a given type for the current month and those preceding it" => "Links to the objects of a given type for the current month and those preceding it",
// "Type of objects to link to" => "Type of objects to link to",
// "\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" for blog posts, \"cms\" for published articles",
// "Object identifier" => "Object identifier",
// "Identifier of an object with children to link to" => "Identifier of an object with children to link to",
// "This is required for the blog Object type" => "This is required for the blog Object type",
// "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3",
// "List by month" => "List by month",
// "Displays the most commented objects of a certain type" => "Displays the most commented objects of a certain type",
// "Type of objects to consider" => "Type of objects to consider",
// "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)",
// "Object language filter" => "Object language filter",
// "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language",
// "Displays the number of article submissions waiting examination and a link to the list" => "Displays the number of article submissions waiting examination and a link to the list",
// "Displays the specified number of old articles (which do not show on articles home page anymore)" => "Displays the specified number of old articles (which do not show on articles home page anymore)",
// "Enables to change current perspective" => "Enables to change current perspective",
// "Enables to quickly create or edit Wiki pages" => "Enables to quickly create or edit Wiki pages",
// "Template identifier" => "Template identifier",
// "If set to a template identifier, the specified template is used for creating new Wiki pages" => "If set to a template identifier, the specified template is used for creating new Wiki pages",
// "If set, send the form to the given location (relative to Tiki\\'s root) for processing" => "If set, send the form to the given location (relative to Tiki\\'s root) for processing",
// "SUBMIT label" => "SUBMIT label",
// "The label on the button to submit the form" => "The label on the button to submit the form",
// "INPUT SIZE" => "INPUT SIZE",
// "Size attribute (horizontal, in characters) of the text input fields for page names and description. The size of the other fields is relative to the module width" => "Size attribute (horizontal, in characters) of the text input fields for page names and description. The size of the other fields is relative to the module width",
// "Optional heading to display at the top of the module\\'s content" => "Optional heading to display at the top of the module\\'s content",
// "If set to a category identifier, pages created through the module are automatically categorized only in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized only in the specified category",
// "Category to preselect" => "Category to preselect",
// "If set, pages created through the module have this category prechecked to be categorized in" => "If set, pages created through the module have this category prechecked to be categorized in",
// "Tip to be shown" => "Tip to be shown",
// "Custom text to be shown as a tip at the top of the edit page" => "Custom text to be shown as a tip at the top of the edit page",
// "Title of tip to be shown" => "Title of tip to be shown",
// "Custom title to be shown for the tip at the top of the edit page" => "Custom title to be shown for the tip at the top of the edit page",
// "Custom header template" => "Custom header template",
// "Wiki page to be used as a template to show content on top of edit page" => "Wiki page to be used as a template to show content on top of edit page",
// "input field for copy/paste" => "input field for copy/paste",
// "If set to 1 , a text area for copy/paste page content is shown" => "If set to 1 , a text area for copy/paste page content is shown",
// "show description field" => "show description field",
// "If set to 1, a text field to enter the page description is shown (requires feature_wiki_description)" => "If set to 1, a text field to enter the page description is shown (requires feature_wiki_description)",
// "choose category" => "choose category",
// "If set to 1, this allows the user to choose a category instead of preselecting one" => "If set to 1, this allows the user to choose a category instead of preselecting one",
// "Displays a random image" => "Displays a random image",
// "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery",
// "Show link" => "Show link",
// "If set to \"n\", the image thumbnail does not link to the image" => "If set to \"n\", the image thumbnail does not link to the image",
// "If set to \"y\", the name of the image is displayed" => "If set to \"y\", the name of the image is displayed",
// "If set to \"y\", the description of the image is displayed" => "If set to \"y\", the description of the image is displayed",
// "Displays the specified number of random wiki pages" => "Displays the specified number of random wiki pages",
// "New user registrationmore tiki-re" => "New user registrationmore tiki-re",
// "List of feeds available on this site" => "List of feeds available on this site",
// "Multi-purpose search module (go or edit page by name and/or search site)" => "Multi-purpose search module (go or edit page by name and/or search site)",
// "Legacy Mode" => "Legacy Mode",
// "Setting to emulate previous behaviour" => "Setting to emulate previous behaviour",
// " (\"search\"=search_box, \"page\"=search_wiki_page, \"quick\"=quick_edit)" => " (\"search\"=search_box, \"page\"=search_wiki_page, \"quick\"=quick_edit)",
// "If set to \"y\" the search performed is a \"Tiki search\"" => "If set to \"y\" the search performed is a \"Tiki search\"",
// " (full text search)" => " (full text search)",
// "Show Search Filter" => "Show Search Filter",
// "If set to \"y\" shows a dropdown of sections to search" => "If set to \"y\" shows a dropdown of sections to search",
// " (no object filter)" => " (no object filter)",
// "Use autocomplete" => "Use autocomplete",
// "If set to \"y\" input uses autocomplete for pagenames if applicable" => "If set to \"y\" input uses autocomplete for pagenames if applicable",
// " (use autocomplete)" => " (use autocomplete)",
// "Advanced search" => "Advanced search",
// "Use advanced (boolean) search (full text search only)" => "Use advanced (boolean) search (full text search only)",
// " (use advanced search)" => " (use advanced search)",
// "Advanced search checkbox" => "Advanced search checkbox",
// "Show advanced search checkbox (full text search only)" => "Show advanced search checkbox (full text search only)",
// " (advanced search checkbox off)" => " (advanced search checkbox off)",
// "Advanced search help" => "Advanced search help",
// "Show advanced search help icon (full text search only)" => "Show advanced search help icon (full text search only)",
// " (advanced search help off)" => " (advanced search help off)",
// "Show Search Button" => "Show Search Button",
// "Show search button" => "Show search button",
// " (do show search button)" => " (do show search button)",
// "Show Go Button" => "Show Go Button",
// "Show go to page button" => "Show go to page button",
// " (do show go button)" => " (do show go button)",
// "Show Edit Button" => "Show Edit Button",
// "Show edit button" => "Show edit button",
// " (do show edit button)" => " (do show edit button)",
// "Default Button" => "Default Button",
// "Action to perform on entering <return>" => "Action to perform on entering <return>",
// " (search|go|edit)" => " (search|go|edit)",
// "Edit Submit Label" => "Edit Submit Label",
// "Size attribute (horizontal, in characters) of the text input field" => "Size attribute (horizontal, in characters) of the text input field",
// "Size of the Search Filter dropdown list" => "Size of the Search Filter dropdown list",
// "Edit Template identifier" => "Edit Template identifier",
// "If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized in the specified category",
// "Search is disabled" => "Search is disabled",
// "If set, send the form to the given location (relative to Tiki's root) for processing" => "If set, send the form to the given location (relative to Tiki's root) for processing",
// "Optional heading to display at the top of the module's content" => "Optional heading to display at the top of the module's content",
// "Titles" => "Titles",
// "Small search form (for wiki, articles, blogs, etc.)" => "Small search form (for wiki, articles, blogs, etc.)",
// "Search for a wiki page by name" => "Search for a wiki page by name",
// "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages" => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages",
// "Tooltip" => "Tooltip",
// "Wait label" => "Wait label",
// "Label on the button to post a message when the message is being posted if AJAX is enabled" => "Label on the button to post a message when the message is being posted if AJAX is enabled",
// "Tweet" => "Tweet",
// "Facebook" => "Facebook",
// "Please wait.." => "Please wait..",
// "Displays to logged in users the number of new or updated objects since their last login date and time" => "Displays to logged in users the number of new or updated objects since their last login date and time",
// "Displays to logged in users new or updated objects since a point in time, by default their last login date and time" => "Displays to logged in users new or updated objects since a point in time, by default their last login date and time",
// "Show trackers" => "Show trackers",
// "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar",
// "Use Jquery presentation" => "Use Jquery presentation",
// "If set to \"y\", it will use jquery to show the result" => "If set to \"y\", it will use jquery to show the result",
// " (archived)" => " (archived)",
// "new posts" => "new posts",
// "new FAQs" => "new FAQs",
// "new image galleries" => "new image galleries",
// "new polls" => "new polls",
// "new tracker items" => "new tracker items",
// "updated tracker items" => "updated tracker items",
// "Displays a language picker to change the language of the site" => "Displays a language picker to change the language of the site",
// "Display mode" => "Display mode",
// "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist",
// "Changes the default displayed prefix from \\\"Site Language:\\\"" => "Changes the default displayed prefix from \\\"Site Language:\\\"",
// "Enables to quickly change the theme" => "Enables to quickly change the theme",
// "Support for multilingual terminology" => "Support for multilingual terminology",
// "All terms will automatically be put in that category. " => "All terms will automatically be put in that category. ",
// "Note that the category must already exist. " => "Note that the category must already exist. ",
// "Defaults to \\'Term\\'" => "Defaults to \\'Term\\'",
// "Tiki Tests" => "Tiki Tests",
// "Tiki test suite helper" => "Tiki test suite helper",
// "Displays the specified number of blogs with links to them, from the most active one to the least" => "Displays the specified number of blogs with links to them, from the most active one to the least",
// "Blog activity measurement can be more or less accurate" => "Blog activity measurement can be more or less accurate",
// "Lists the specified number of articles with links to them, from the most visited one to the least" => "Lists the specified number of articles with links to them, from the most visited one to the least",
// "Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Displays the specified number of file galleries with links to them, starting with the one with most hits",
// "Displays the specified number of files with links to them, starting with the one with most hits" => "Displays the specified number of files with links to them, starting with the one with most hits",
// "Displays the specified number of users who posted to forums, starting with the one having most posts" => "Displays the specified number of users who posted to forums, starting with the one having most posts",
// "Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Displays the specified number of image galleries with links to them, starting with the one with most hits",
// "Displays the specified number of images with links to them, from the most visited one to the least" => "Displays the specified number of images with links to them, from the most visited one to the least",
// "Displays the specified number of objects, starting with the one having the most hits" => "Displays the specified number of objects, starting with the one having the most hits",
// "Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Displays the specified number of wiki pages with links to them, starting with the one having the most hits",
// "Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Displays the specified number of quizzes with links to them, starting with the one having the most hits",
// "Displays the specified number of blogs with links to them, from the most visited one to the least" => "Displays the specified number of blogs with links to them, from the most visited one to the least",
// "Show Last Post" => "Show Last Post",
// "Displays the specified number of FAQs with links to them, from the most visited one to the least" => "Displays the specified number of FAQs with links to them, from the most visited one to the least",
// "Display the fieldId of a tracker" => "Display the fieldId of a tracker",
// "Textarea rows" => "Textarea rows",
// "Textarea cols" => "Textarea cols",
// "Max fields" => "Max fields",
// "Tracker Help" => "Tracker Help",
// "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed",
// "Lists the specified number of calendar events, ordered by their start date" => "Lists the specified number of calendar events, ordered by their start date",
// "Maximum distance to event start dates in days (looking forward)" => "Maximum distance to event start dates in days (looking forward)",
// "Maximum days in the past" => "Maximum days in the past",
// "Maximum distance to event end dates in days (looking backward)" => "Maximum distance to event end dates in days (looking backward)",
// "cellpadding" => "cellpadding",
// "cellspacing" => "cellspacing",
// "If set to \"y\", event descriptions are displayed" => "If set to \"y\", event descriptions are displayed",
// "Show end date and time" => "Show end date and time",
// "If set to \"y\", event end dates and times are displayed, when appropriate" => "If set to \"y\", event end dates and times are displayed, when appropriate",
// "Use custom calendar background colors" => "Use custom calendar background colors",
// "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)" => "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)",
// "Show information in tooltips" => "Show information in tooltips",
// "If set to \"n\", event tooltips will not display event information" => "If set to \"n\", event tooltips will not display event information",
// "Date format" => "Date format",
// "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
// "site preference for short date format followed by site preference for short time format" => "site preference for short date format followed by site preference for short time format",
// "If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "If set to an integer, event names are allowed that number of characters as a maximum before being truncated",
// "Displays to registered users their blogs" => "Displays to registered users their blogs",
// "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed",
// "Displays to registered users their image galleries" => "Displays to registered users their image galleries",
// "Displays to registered users the specified number of wiki pages which they were the last to edit" => "Displays to registered users the specified number of wiki pages which they were the last to edit",
// "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations",
// "The task title must have at least 3 characters" => "The task title must have at least 3 characters",
// "Lists the public user tasks of a chosen group, with links to tasks" => "Lists the public user tasks of a chosen group, with links to tasks",
// "User and Group tracker links" => "User and Group tracker links",
// "Displays the specified number of users and their score, starting from the one with the highest score" => "Displays the specified number of users and their score, starting from the one with the highest score",
// "Webmail Inbox" => "Webmail Inbox",
// "Displays Webmail Inbox" => "Displays Webmail Inbox",
// "Account Id" => "Account Id",
// "Webmail account identifier (if not set uses user\\'s current account)" => "Webmail account identifier (if not set uses user\\'s current account)",
// "GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Group (e.g. \"Help Team\")",
// "GroupMail: Tracker Id (to store GroupMail activity)" => "GroupMail: Tracker Id (to store GroupMail activity)",
// "GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: From Field (Id of field in tracker to store email From header)",
// "GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id of field in tracker to store email Subject header)",
// "GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Message Field (Id of field in tracker to store email message identifier)",
// "GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Content Field (Id of field in tracker to store email message body content)",
// "GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: Account Field (Id of field in tracker to store Webmail account name)",
// "DateTime Field Id" => "DateTime Field Id",
// "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)",
// "GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Operator Field (Id of field in tracker to store operator name (username))",
// "Maximum number of characters in subjects allowed before truncating" => "Maximum number of characters in subjects allowed before truncating",
// "Webmail error" => "Webmail error",
// "No accounts set up (or no current account set)" => "No accounts set up (or no current account set)",
// "Lists objects which share a category with the viewed object" => "Lists objects which share a category with the viewed object",
// "Displays information about users currently logged in" => "Displays information about users currently logged in",
// "Lists the specified number of comments starting from the most recently posted" => "Lists the specified number of comments starting from the most recently posted",
// "More in tooltips" => "More in tooltips",
// "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip" => "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip",
// "Type of the objects from which comments will be listed. Possible values" => "Type of the objects from which comments will be listed. Possible values",
// "Last article comments" => "Last article comments",
// "Displays YouTube videos and/or a link to a YouTube user\\'s page" => "Displays YouTube videos and/or a link to a YouTube user\\'s page",
// "Video identifiers" => "Video identifiers",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
// "YouTube user identifier" => "YouTube user identifier",
// "If set to a YouTube user identifier, display a link to the videos of this user" => "If set to a YouTube user identifier, display a link to the videos of this user",
// "Width of each video in pixels" => "Width of each video in pixels",
// "Height of each video in pixels" => "Height of each video in pixels",
// "Videos on YouTube" => "Videos on YouTube",
// "No Playlist found" => "No Playlist found",
// "Invalid server key" => "Invalid server key",
// "Cookie not found" => "Cookie not found",
// "Can view Tiki tools calendar" => "Can view Tiki tools calendar",
// "Can admin the articles" => "Can admin the articles",
// "Submitted articles automatically approved" => "Submitted articles automatically approved",
// "Can admin directory sites" => "Can admin directory sites",
// "Submitted links are valid" => "Submitted links are valid",
// "Can validate submitted links" => "Can validate submitted links",
// "Administrator, can manage users groups and permissions, and all features" => "Administrator, can manage users groups and permissions, and all features",
// "Can admin integrator repositories and rules" => "Can admin integrator repositories and rules",
// "Can create new css suffixed with -user" => "Can create new css suffixed with -user",
// "Can view referrer stats" => "Can view referrer stats",
// "Can view in module and feed the blog posts" => "Can view in module and feed the blog posts",
// "Can view in module and feed the blog" => "Can view in module and feed the blog",
// "Can report posts to moderator" => "Can report posts to moderator",
// "Can subscribe any email to newsletters" => "Can subscribe any email to newsletters",
// "Can admin shoutbox (Edit/remove messages)" => "Can admin shoutbox (Edit/remove messages)",
// "Can change pending tracker items" => "Can change pending tracker items",
// "Can change closed tracker items" => "Can change closed tracker items",
// "Can view closed trackers items" => "Can view closed trackers items",
// "Can view pending trackers items" => "Can view pending trackers items",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
// "Can view in module and feed the wiki pages reference" => "Can view in module and feed the wiki pages reference",
// "Can admin attachments on wiki pages" => "Can admin attachments on wiki pages",
// "Can add and change ratings on wiki pages" => "Can add and change ratings on wiki pages",
// "Can view rating of wiki pages" => "Can view rating of wiki pages",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay the TikiTests" => "Can replay the TikiTests",
// "Can cache user bookmarks" => "Can cache user bookmarks",
// "Can configure modules" => "Can configure modules",
// "Can use the mini event calendar" => "Can use the mini event calendar",
// "Can create items in personal menu" => "Can create items in personal menu",
// "Can admin content templates" => "Can admin content templates",
// "Can edit content templates" => "Can edit content templates",
// "Can use content templates" => "Can use content templates",
// "Can admin group webmail accounts" => "Can admin group webmail accounts",
// "Can admin personal webmail accounts" => "Can admin personal webmail accounts",
// "Can delete his/her own account" => "Can delete his/her own account",
// "Can use the importer" => "Can use the importer",
// "Can change the categories of the object" => "Can change the categories of the object",
// "Can add objects to the category" => "Can add objects to the category",
// "Can trigger the transition between two states" => "Can trigger the transition between two states",
// "Can execute arbitrary queries on a given DSN" => "Can execute arbitrary queries on a given DSN",
// "User can administer modules" => "User can administer modules",
// "Can save a .CSV backup of entire trackers" => "Can save a .CSV backup of entire trackers",
// "user can register this site with social networks" => "user can register this site with social networks",
// "Can invite users by email, and include them in groups" => "Can invite users by email, and include them in groups",
// "tiki release" => "tiki release",
// "feature version checks" => "feature version checks",
// "tiki needs upgrade" => "tiki needs upgrade",
// "tiki version last check" => "tiki version last check",
// "tiki version check frequency" => "tiki version check frequency",
// "lastUpdatePrefs" => "lastUpdatePrefs",
// "tiki domain prefix" => "tiki domain prefix",
// "tiki domain redirects" => "tiki domain redirects",
// "feature print indexed" => "feature print indexed",
// "groups are emulated" => "groups are emulated",
// "feature webdav" => "feature webdav",
// "feature wiki" => "feature wiki",
// "default wiki diff style" => "default wiki diff style",
// "feature backlinks" => "feature backlinks",
// "backlinks name len" => "backlinks name len",
// "feature dump" => "feature dump",
// "feature history" => "feature history",
// "feature page contribution" => "feature page contribution",
// "feature lastChanges" => "feature lastChanges",
// "feature likePages" => "feature likePages",
// "feature listPages" => "feature listPages",
// "feature listorphanPages" => "feature listorphanPages",
// "feature listorphanStructure" => "feature listorphanStructure",
// "feature page title" => "feature page title",
// "wiki page name above" => "wiki page name above",
// "feature sandbox" => "feature sandbox",
// "feature warn on edit" => "feature warn on edit",
// "feature wiki 1like redirection" => "feature wiki 1like redirection",
// "feature wiki allowhtml" => "feature wiki allowhtml",
// "feature wiki argvariable" => "feature wiki argvariable",
// "feature wiki attachments" => "feature wiki attachments",
// "feature wiki comments" => "feature wiki comments",
// "feature wiki description" => "feature wiki description",
// "feature wiki discuss" => "feature wiki discuss",
// "feature wiki export" => "feature wiki export",
// "feature wiki structure" => "feature wiki structure",
// "feature wiki import page" => "feature wiki import page",
// "feature wiki footnotes" => "feature wiki footnotes",
// "feature wiki icache" => "feature wiki icache",
// "feature wiki import html" => "feature wiki import html",
// "feature wiki mindmap" => "feature wiki mindmap",
// "feature wiki monosp" => "feature wiki monosp",
// "feature wiki multiprint" => "feature wiki multiprint",
// "feature wiki notepad" => "feature wiki notepad",
// "feature wiki make structure" => "feature wiki make structure",
// "feature wiki open as structure" => "feature wiki open as structure",
// "feature wiki pageid" => "feature wiki pageid",
// "feature wiki paragraph formatting" => "feature wiki paragraph formatting",
// "feature wiki paragraph formatting add br" => "feature wiki paragraph formatting add br",
// "feature wiki pictures" => "feature wiki pictures",
// "feature wiki plurals" => "feature wiki plurals",
// "feature wiki print" => "feature wiki print",
// "feature wiki protect email" => "feature wiki protect email",
// "feature wiki rankings" => "feature wiki rankings",
// "feature wiki ratings" => "feature wiki ratings",
// "wiki simple ratings" => "wiki simple ratings",
// "wiki simple ratings options" => "wiki simple ratings options",
// "feature wiki replace" => "feature wiki replace",
// "feature wiki show hide before" => "feature wiki show hide before",
// "feature wiki tables" => "feature wiki tables",
// "feature wiki templates" => "feature wiki templates",
// "feature wiki undo" => "feature wiki undo",
// "feature wiki userpage" => "feature wiki userpage",
// "feature wiki userpage prefix" => "feature wiki userpage prefix",
// "feature wiki usrlock" => "feature wiki usrlock",
// "feature wiki feedback polls" => "feature wiki feedback polls",
// "feature wiki save draft" => "feature wiki save draft",
// "feature wikiwords" => "feature wikiwords",
// "feature wikiwords usedash" => "feature wikiwords usedash",
// "feature wiki pagealias" => "feature wiki pagealias",
// "mailin autocheck" => "mailin autocheck",
// "mailin autocheckFreq" => "mailin autocheckFreq",
// "mailin autocheckLast" => "mailin autocheckLast",
// "page bar position" => "page bar position",
// "warn on edit time" => "warn on edit time",
// "wikiHomePage" => "wikiHomePage",
// "wikiLicensePage" => "wikiLicensePage",
// "wikiSubmitNotice" => "wikiSubmitNotice",
// "wiki authors style" => "wiki authors style",
// "wiki authors style by page" => "wiki authors style by page",
// "wiki show version" => "wiki show version",
// "wiki bot bar" => "wiki bot bar",
// "wiki cache" => "wiki cache",
// "wiki comments default ordering" => "wiki comments default ordering",
// "wiki comments displayed default" => "wiki comments displayed default",
// "wiki comments per page" => "wiki comments per page",
// "wiki comments allow per page" => "wiki comments allow per page",
// "wiki creator admin" => "wiki creator admin",
// "wiki feature copyrights" => "wiki feature copyrights",
// "wiki forum id" => "wiki forum id",
// "wiki left column" => "wiki left column",
// "wiki list backlinks" => "wiki list backlinks",
// "wiki list comment" => "wiki list comment",
// "wiki list comment len" => "wiki list comment len",
// "wiki list description" => "wiki list description",
// "wiki list description len" => "wiki list description len",
// "wiki list creator" => "wiki list creator",
// "wiki list hits" => "wiki list hits",
// "wiki list lastmodif" => "wiki list lastmodif",
// "wiki list lastver" => "wiki list lastver",
// "wiki list links" => "wiki list links",
// "wiki list name" => "wiki list name",
// "wiki list name len" => "wiki list name len",
// "wiki list size" => "wiki list size",
// "wiki list status" => "wiki list status",
// "wiki list user" => "wiki list user",
// "wiki list versions" => "wiki list versions",
// "wiki list language" => "wiki list language",
// "wiki list categories" => "wiki list categories",
// "wiki list categories path" => "wiki list categories path",
// "wiki list id" => "wiki list id",
// "wiki list sortorder" => "wiki list sortorder",
// "wiki list sortdirection" => "wiki list sortdirection",
// "wiki pagealias tokens" => "wiki pagealias tokens",
// "wiki prefixalias tokens" => "wiki prefixalias tokens",
// "wiki page regex" => "wiki page regex",
// "wiki page separator" => "wiki page separator",
// "wiki page navigation bar" => "wiki page navigation bar",
// "wiki actions bar" => "wiki actions bar",
// "wiki pagename strip" => "wiki pagename strip",
// "wiki right column" => "wiki right column",
// "wiki structure bar position" => "wiki structure bar position",
// "wiki top bar" => "wiki top bar",
// "wiki topline position" => "wiki topline position",
// "wiki uses slides" => "wiki uses slides",
// "wiki watch author" => "wiki watch author",
// "wiki watch comments" => "wiki watch comments",
// "wiki watch editor" => "wiki watch editor",
// "wiki watch minor" => "wiki watch minor",
// "feature wiki history full" => "feature wiki history full",
// "feature wiki categorize structure" => "feature wiki categorize structure",
// "feature wiki watch structure" => "feature wiki watch structure",
// "feature wikiapproval" => "feature wikiapproval",
// "wikiapproval prefix" => "wikiapproval prefix",
// "wikiapproval hideprefix" => "wikiapproval hideprefix",
// "wikiapproval delete staging" => "wikiapproval delete staging",
// "wikiapproval master group" => "wikiapproval master group",
// "wikiapproval staging category" => "wikiapproval staging category",
// "wikiapproval approved category" => "wikiapproval approved category",
// "wikiapproval outofsync category" => "wikiapproval outofsync category",
// "wikiapproval block editapproved" => "wikiapproval block editapproved",
// "wikiapproval sync categories" => "wikiapproval sync categories",
// "wikiapproval update freetags" => "wikiapproval update freetags",
// "wikiapproval combine freetags" => "wikiapproval combine freetags",
// "wiki edit section" => "wiki edit section",
// "wiki edit section level" => "wiki edit section level",
// "wiki edit icons toggle" => "wiki edit icons toggle",
// "wiki edit plugin" => "wiki edit plugin",
// "wiki validate plugin" => "wiki validate plugin",
// "wiki edit minor" => "wiki edit minor",
// "wiki badchar prevent" => "wiki badchar prevent",
// "wiki backlinks name len" => "wiki backlinks name len",
// "wiki ranking reload probability" => "wiki ranking reload probability",
// "wiki encourage contribution" => "wiki encourage contribution",
// "wiki timeout warning" => "wiki timeout warning",
// "wiki dynvar style" => "wiki dynvar style",
// "wiki dynvar multilingual" => "wiki dynvar multilingual",
// "wiki keywords" => "wiki keywords",
// "wiki likepages samelang only" => "wiki likepages samelang only",
// "wiki mandatory edit summary" => "wiki mandatory edit summary",
// "wikiplugin addtocart" => "wikiplugin addtocart",
// "wikiplugin addtogooglecal" => "wikiplugin addtogooglecal",
// "wikiplugin agentinfo" => "wikiplugin agentinfo",
// "wikiplugin alink" => "wikiplugin alink",
// "wikiplugin aname" => "wikiplugin aname",
// "wikiplugin annotation" => "wikiplugin annotation",
// "wikiplugin archivebuilder" => "wikiplugin archivebuilder",
// "wikiplugin article" => "wikiplugin article",
// "wikiplugin articles" => "wikiplugin articles",
// "wikiplugin attach" => "wikiplugin attach",
// "wikiplugin attributes" => "wikiplugin attributes",
// "wikiplugin author" => "wikiplugin author",
// "wikiplugin avatar" => "wikiplugin avatar",
// "wikiplugin back" => "wikiplugin back",
// "wikiplugin backlinks" => "wikiplugin backlinks",
// "wikiplugin banner" => "wikiplugin banner",
// "wikiplugin bigbluebutton" => "wikiplugin bigbluebutton",
// "wikiplugin bliptv" => "wikiplugin bliptv",
// "wikiplugin bloglist" => "wikiplugin bloglist",
// "wikiplugin box" => "wikiplugin box",
// "wikiplugin button" => "wikiplugin button",
// "wikiplugin calendar" => "wikiplugin calendar",
// "wikiplugin category" => "wikiplugin category",
// "wikiplugin catorphans" => "wikiplugin catorphans",
// "wikiplugin cclite" => "wikiplugin cclite",
// "wikiplugin catpath" => "wikiplugin catpath",
// "wikiplugin center" => "wikiplugin center",
// "wikiplugin chart" => "wikiplugin chart",
// "wikiplugin code" => "wikiplugin code",
// "wikiplugin colorbox" => "wikiplugin colorbox",
// "wikiplugin content" => "wikiplugin content",
// "wikiplugin cookie" => "wikiplugin cookie",
// "wikiplugin copyright" => "wikiplugin copyright",
// "wikiplugin countdown" => "wikiplugin countdown",
// "wikiplugin datachannel" => "wikiplugin datachannel",
// "wikiplugin dbreport" => "wikiplugin dbreport",
// "wikiplugin div" => "wikiplugin div",
// "wikiplugin dl" => "wikiplugin dl",
// "wikiplugin draw" => "wikiplugin draw",
// "wikiplugin equation" => "wikiplugin equation",
// "wikiplugin events" => "wikiplugin events",
// "wikiplugin fade" => "wikiplugin fade",
// "wikiplugin fancylist" => "wikiplugin fancylist",
// "wikiplugin fancytable" => "wikiplugin fancytable",
// "wikiplugin file" => "wikiplugin file",
// "wikiplugin files" => "wikiplugin files",
// "wikiplugin flash" => "wikiplugin flash",
// "wikiplugin footnote" => "wikiplugin footnote",
// "wikiplugin footnotearea" => "wikiplugin footnotearea",
// "wikiplugin freetagged" => "wikiplugin freetagged",
// "wikiplugin ftp" => "wikiplugin ftp",
// "wikiplugin gauge" => "wikiplugin gauge",
// "wikiplugin googleanalytics" => "wikiplugin googleanalytics",
// "wikiplugin googledoc" => "wikiplugin googledoc",
// "wikiplugin googlemap" => "wikiplugin googlemap",
// "wikiplugin group" => "wikiplugin group",
// "wikiplugin grouplist" => "wikiplugin grouplist",
// "wikiplugin groupmailcore" => "wikiplugin groupmailcore",
// "wikiplugin groupstat" => "wikiplugin groupstat",
// "wikiplugin html" => "wikiplugin html",
// "wikiplugin iframe" => "wikiplugin iframe",
// "wikiplugin img" => "wikiplugin img",
// "wikiplugin image" => "wikiplugin image",
// "wikiplugin include" => "wikiplugin include",
// "wikiplugin randominclude" => "wikiplugin randominclude",
// "wikiplugin invite" => "wikiplugin invite",
// "wikiplugin jabber" => "wikiplugin jabber",
// "wikiplugin js" => "wikiplugin js",
// "wikiplugin jq" => "wikiplugin jq",
// "wikiplugin lang" => "wikiplugin lang",
// "wikiplugin lastmod" => "wikiplugin lastmod",
// "wikiplugin listpages" => "wikiplugin listpages",
// "wikiplugin lsdir" => "wikiplugin lsdir",
// "wikiplugin mail" => "wikiplugin mail",
// "wikiplugin map" => "wikiplugin map",
// "wikiplugin mcalendar" => "wikiplugin mcalendar",
// "wikiplugin mediaplayer" => "wikiplugin mediaplayer",
// "wikiplugin memberlist" => "wikiplugin memberlist",
// "wikiplugin memberpayment" => "wikiplugin memberpayment",
// "wikiplugin miniquiz" => "wikiplugin miniquiz",
// "wikiplugin module" => "wikiplugin module",
// "wikiplugin mono" => "wikiplugin mono",
// "wikiplugin mouseover" => "wikiplugin mouseover",
// "wikiplugin mwtable" => "wikiplugin mwtable",
// "wikiplugin myspace" => "wikiplugin myspace",
// "wikiplugin objecthits" => "wikiplugin objecthits",
// "wikiplugin payment" => "wikiplugin payment",
// "wikiplugin perm" => "wikiplugin perm",
// "wikiplugin picture" => "wikiplugin picture",
// "wikiplugin pluginmanager" => "wikiplugin pluginmanager",
// "wikiplugin poll" => "wikiplugin poll",
// "wikiplugin profile" => "wikiplugin profile",
// "wikiplugin proposal" => "wikiplugin proposal",
// "wikiplugin quote" => "wikiplugin quote",
// "wikiplugin rcontent" => "wikiplugin rcontent",
// "wikiplugin realnamelist" => "wikiplugin realnamelist",
// "wikiplugin redirect" => "wikiplugin redirect",
// "wikiplugin regex" => "wikiplugin regex",
// "wikiplugin remarksbox" => "wikiplugin remarksbox",
// "wikiplugin rss" => "wikiplugin rss",
// "wikiplugin scroll" => "wikiplugin scroll",
// "wikiplugin sf" => "wikiplugin sf",
// "wikiplugin share" => "wikiplugin share",
// "wikiplugin sharethis" => "wikiplugin sharethis",
// "wikiplugin sheet" => "wikiplugin sheet",
// "wikiplugin showpages" => "wikiplugin showpages",
// "wikiplugin skype" => "wikiplugin skype",
// "wikiplugin smarty" => "wikiplugin smarty",
// "wikiplugin snarf" => "wikiplugin snarf",
// "wikiplugin snarf cache" => "wikiplugin snarf cache",
// "wikiplugin sort" => "wikiplugin sort",
// "wikiplugin split" => "wikiplugin split",
// "wikiplugin sql" => "wikiplugin sql",
// "wikiplugin stat" => "wikiplugin stat",
// "wikiplugin sub" => "wikiplugin sub",
// "wikiplugin subscribegroup" => "wikiplugin subscribegroup",
// "wikiplugin subscribegroups" => "wikiplugin subscribegroups",
// "wikiplugin subscribenewsletter" => "wikiplugin subscribenewsletter",
// "wikiplugin sup" => "wikiplugin sup",
// "wikiplugin survey" => "wikiplugin survey",
// "wikiplugin tag" => "wikiplugin tag",
// "wikiplugin tabs" => "wikiplugin tabs",
// "wikiplugin thumb" => "wikiplugin thumb",
// "wikiplugin titlesearch" => "wikiplugin titlesearch",
// "wikiplugin toc" => "wikiplugin toc",
// "wikiplugin topfriends" => "wikiplugin topfriends",
// "wikiplugin trackercomments" => "wikiplugin trackercomments",
// "wikiplugin trackerfilter" => "wikiplugin trackerfilter",
// "wikiplugin trackeritemfield" => "wikiplugin trackeritemfield",
// "wikiplugin trackerlist" => "wikiplugin trackerlist",
// "wikiplugin trackertimeline" => "wikiplugin trackertimeline",
// "wikiplugin tracker" => "wikiplugin tracker",
// "wikiplugin trackerprefill" => "wikiplugin trackerprefill",
// "wikiplugin trackerstat" => "wikiplugin trackerstat",
// "wikiplugin trade" => "wikiplugin trade",
// "wikiplugin transclude" => "wikiplugin transclude",
// "wikiplugin translated" => "wikiplugin translated",
// "wikiplugin tr" => "wikiplugin tr",
// "wikiplugin usercount" => "wikiplugin usercount",
// "wikiplugin userlink" => "wikiplugin userlink",
// "wikiplugin userlist" => "wikiplugin userlist",
// "wikiplugin userpref" => "wikiplugin userpref",
// "wikiplugin versions" => "wikiplugin versions",
// "wikiplugin vimeo" => "wikiplugin vimeo",
// "wikiplugin vote" => "wikiplugin vote",
// "wikiplugin watershed" => "wikiplugin watershed",
// "wikiplugin wantedpages" => "wikiplugin wantedpages",
// "wikiplugin webservice" => "wikiplugin webservice",
// "wikiplugin youtube" => "wikiplugin youtube",
// "wikiplugininline addtocart" => "wikiplugininline addtocart",
// "wikiplugininline addtogooglecal" => "wikiplugininline addtogooglecal",
// "wikiplugininline agentinfo" => "wikiplugininline agentinfo",
// "wikiplugininline alink" => "wikiplugininline alink",
// "wikiplugininline aname" => "wikiplugininline aname",
// "wikiplugininline annotation" => "wikiplugininline annotation",
// "wikiplugininline archivebuilder" => "wikiplugininline archivebuilder",
// "wikiplugininline article" => "wikiplugininline article",
// "wikiplugininline articles" => "wikiplugininline articles",
// "wikiplugininline attach" => "wikiplugininline attach",
// "wikiplugininline attributes" => "wikiplugininline attributes",
// "wikiplugininline avatar" => "wikiplugininline avatar",
// "wikiplugininline back" => "wikiplugininline back",
// "wikiplugininline backlinks" => "wikiplugininline backlinks",
// "wikiplugininline banner" => "wikiplugininline banner",
// "wikiplugininline bigbluebutton" => "wikiplugininline bigbluebutton",
// "wikiplugininline bliptv" => "wikiplugininline bliptv",
// "wikiplugininline bloglist" => "wikiplugininline bloglist",
// "wikiplugininline box" => "wikiplugininline box",
// "wikiplugininline button" => "wikiplugininline button",
// "wikiplugininline calendar" => "wikiplugininline calendar",
// "wikiplugininline category" => "wikiplugininline category",
// "wikiplugininline catorphans" => "wikiplugininline catorphans",
// "wikiplugininline catpath" => "wikiplugininline catpath",
// "wikiplugininline cclite" => "wikiplugininline cclite",
// "wikiplugininline center" => "wikiplugininline center",
// "wikiplugininline chart" => "wikiplugininline chart",
// "wikiplugininline code" => "wikiplugininline code",
// "wikiplugininline colorbox" => "wikiplugininline colorbox",
// "wikiplugininline content" => "wikiplugininline content",
// "wikiplugininline cookie" => "wikiplugininline cookie",
// "wikiplugininline copyright" => "wikiplugininline copyright",
// "wikiplugininline countdown" => "wikiplugininline countdown",
// "wikiplugininline datachannel" => "wikiplugininline datachannel",
// "wikiplugininline dbreport" => "wikiplugininline dbreport",
// "wikiplugininline div" => "wikiplugininline div",
// "wikiplugininline dl" => "wikiplugininline dl",
// "wikiplugininline draw" => "wikiplugininline draw",
// "wikiplugininline equation" => "wikiplugininline equation",
// "wikiplugininline events" => "wikiplugininline events",
// "wikiplugininline fade" => "wikiplugininline fade",
// "wikiplugininline fancylist" => "wikiplugininline fancylist",
// "wikiplugininline fancytable" => "wikiplugininline fancytable",
// "wikiplugininline file" => "wikiplugininline file",
// "wikiplugininline files" => "wikiplugininline files",
// "wikiplugininline flash" => "wikiplugininline flash",
// "wikiplugininline footnote" => "wikiplugininline footnote",
// "wikiplugininline footnotearea" => "wikiplugininline footnotearea",
// "wikiplugininline freetagged" => "wikiplugininline freetagged",
// "wikiplugininline ftp" => "wikiplugininline ftp",
// "wikiplugininline gauge" => "wikiplugininline gauge",
// "wikiplugininline googleanalytics" => "wikiplugininline googleanalytics",
// "wikiplugininline googledoc" => "wikiplugininline googledoc",
// "wikiplugininline googlemap" => "wikiplugininline googlemap",
// "wikiplugininline group" => "wikiplugininline group",
// "wikiplugininline grouplist" => "wikiplugininline grouplist",
// "wikiplugininline groupmailcore" => "wikiplugininline groupmailcore",
// "wikiplugininline groupstat" => "wikiplugininline groupstat",
// "wikiplugininline html" => "wikiplugininline html",
// "wikiplugininline iframe" => "wikiplugininline iframe",
// "wikiplugininline img" => "wikiplugininline img",
// "wikiplugininline image" => "wikiplugininline image",
// "wikiplugininline include" => "wikiplugininline include",
// "wikiplugininline invite" => "wikiplugininline invite",
// "wikiplugininline jabber" => "wikiplugininline jabber",
// "wikiplugininline js" => "wikiplugininline js",
// "wikiplugininline jq" => "wikiplugininline jq",
// "wikiplugininline lang" => "wikiplugininline lang",
// "wikiplugininline lastmod" => "wikiplugininline lastmod",
// "wikiplugininline listpages" => "wikiplugininline listpages",
// "wikiplugininline lsdir" => "wikiplugininline lsdir",
// "wikiplugininline mail" => "wikiplugininline mail",
// "wikiplugininline map" => "wikiplugininline map",
// "wikiplugininline mcalendar" => "wikiplugininline mcalendar",
// "wikiplugininline mediaplayer" => "wikiplugininline mediaplayer",
// "wikiplugininline memberlist" => "wikiplugininline memberlist",
// "wikiplugininline memberpayment" => "wikiplugininline memberpayment",
// "wikiplugininline miniquiz" => "wikiplugininline miniquiz",
// "wikiplugininline module" => "wikiplugininline module",
// "wikiplugininline mono" => "wikiplugininline mono",
// "wikiplugininline mouseover" => "wikiplugininline mouseover",
// "wikiplugininline mwtable" => "wikiplugininline mwtable",
// "wikiplugininline myspace" => "wikiplugininline myspace",
// "wikiplugininline objecthits" => "wikiplugininline objecthits",
// "wikiplugininline payment" => "wikiplugininline payment",
// "wikiplugininline perm" => "wikiplugininline perm",
// "wikiplugininline picture" => "wikiplugininline picture",
// "wikiplugininline pluginmanager" => "wikiplugininline pluginmanager",
// "wikiplugininline poll" => "wikiplugininline poll",
// "wikiplugininline profile" => "wikiplugininline profile",
// "wikiplugininline proposal" => "wikiplugininline proposal",
// "wikiplugininline quote" => "wikiplugininline quote",
// "wikiplugininline rcontent" => "wikiplugininline rcontent",
// "wikiplugininline randominclude" => "wikiplugininline randominclude",
// "wikiplugininline realnamelist" => "wikiplugininline realnamelist",
// "wikiplugininline redirect" => "wikiplugininline redirect",
// "wikiplugininline regex" => "wikiplugininline regex",
// "wikiplugininline remarksbox" => "wikiplugininline remarksbox",
// "wikiplugininline rss" => "wikiplugininline rss",
// "wikiplugininline scroll" => "wikiplugininline scroll",
// "wikiplugininline sf" => "wikiplugininline sf",
// "wikiplugininline share" => "wikiplugininline share",
// "wikiplugininline sharethis" => "wikiplugininline sharethis",
// "wikiplugininline sheet" => "wikiplugininline sheet",
// "wikiplugininline showpages" => "wikiplugininline showpages",
// "wikiplugininline skype" => "wikiplugininline skype",
// "wikiplugininline smarty" => "wikiplugininline smarty",
// "wikiplugininline snarf" => "wikiplugininline snarf",
// "wikiplugininline sort" => "wikiplugininline sort",
// "wikiplugininline split" => "wikiplugininline split",
// "wikiplugininline sql" => "wikiplugininline sql",
// "wikiplugininline stat" => "wikiplugininline stat",
// "wikiplugininline sub" => "wikiplugininline sub",
// "wikiplugininline subscribegroup" => "wikiplugininline subscribegroup",
// "wikiplugininline subscribegroups" => "wikiplugininline subscribegroups",
// "wikiplugininline subscribenewsletter" => "wikiplugininline subscribenewsletter",
// "wikiplugininline sup" => "wikiplugininline sup",
// "wikiplugininline survey" => "wikiplugininline survey",
// "wikiplugininline tag" => "wikiplugininline tag",
// "wikiplugininline tabs" => "wikiplugininline tabs",
// "wikiplugininline thumb" => "wikiplugininline thumb",
// "wikiplugininline titlesearch" => "wikiplugininline titlesearch",
// "wikiplugininline toc" => "wikiplugininline toc",
// "wikiplugininline topfriends" => "wikiplugininline topfriends",
// "wikiplugininline trackercomments" => "wikiplugininline trackercomments",
// "wikiplugininline trackerfilter" => "wikiplugininline trackerfilter",
// "wikiplugininline trackeritemfield" => "wikiplugininline trackeritemfield",
// "wikiplugininline trackerlist" => "wikiplugininline trackerlist",
// "wikiplugininline trackertimeline" => "wikiplugininline trackertimeline",
// "wikiplugininline tracker" => "wikiplugininline tracker",
// "wikiplugininline trackerprefill" => "wikiplugininline trackerprefill",
// "wikiplugininline trackerstat" => "wikiplugininline trackerstat",
// "wikiplugininline trade" => "wikiplugininline trade",
// "wikiplugininline transclude" => "wikiplugininline transclude",
// "wikiplugininline translated" => "wikiplugininline translated",
// "wikiplugininline tr" => "wikiplugininline tr",
// "wikiplugininline usercount" => "wikiplugininline usercount",
// "wikiplugininline userlink" => "wikiplugininline userlink",
// "wikiplugininline userlist" => "wikiplugininline userlist",
// "wikiplugininline userpref" => "wikiplugininline userpref",
// "wikiplugininline versions" => "wikiplugininline versions",
// "wikiplugininline vimeo" => "wikiplugininline vimeo",
// "wikiplugininline vote" => "wikiplugininline vote",
// "wikiplugininline watershed" => "wikiplugininline watershed",
// "wikiplugininline wantedpages" => "wikiplugininline wantedpages",
// "wikiplugininline webservice" => "wikiplugininline webservice",
// "wikiplugininline youtube" => "wikiplugininline youtube",
// "wikiplugininline author" => "wikiplugininline author",
// "webservice consume defaultcache" => "webservice consume defaultcache",
// "feature webservices" => "feature webservices",
// "feature semantic" => "feature semantic",
// "feature wysiwyg" => "feature wysiwyg",
// "wysiwyg optional" => "wysiwyg optional",
// "wysiwyg default" => "wysiwyg default",
// "wysiwyg memo" => "wysiwyg memo",
// "wysiwyg wiki parsed" => "wysiwyg wiki parsed",
// "wysiwyg wiki semi parsed" => "wysiwyg wiki semi parsed",
// "wysiwyg toolbar skin" => "wysiwyg toolbar skin",
// "wysiwyg htmltowiki" => "wysiwyg htmltowiki",
// "wysiwyg fonts" => "wysiwyg fonts",
// "wiki feature 3d" => "wiki feature 3d",
// "wiki 3d width" => "wiki 3d width",
// "wiki 3d height" => "wiki 3d height",
// "wiki 3d navigation depth" => "wiki 3d navigation depth",
// "wiki 3d feed animation interval" => "wiki 3d feed animation interval",
// "wiki 3d existing page color" => "wiki 3d existing page color",
// "wiki 3d missing page color" => "wiki 3d missing page color",
// "feature blogs" => "feature blogs",
// "blog list order" => "blog list order",
// "home blog" => "home blog",
// "feature blog rankings" => "feature blog rankings",
// "blog comments default ordering" => "blog comments default ordering",
// "blog comments per page" => "blog comments per page",
// "feature blogposts comments" => "feature blogposts comments",
// "blog list user" => "blog list user",
// "blog list title" => "blog list title",
// "blog list title len" => "blog list title len",
// "blog list description" => "blog list description",
// "blog list created" => "blog list created",
// "blog list lastmodif" => "blog list lastmodif",
// "blog list posts" => "blog list posts",
// "blog list visits" => "blog list visits",
// "blog list activity" => "blog list activity",
// "feature blog mandatory category" => "feature blog mandatory category",
// "feature blog heading" => "feature blog heading",
// "feature blog edit publish date" => "feature blog edit publish date",
// "feature blog sharethis" => "feature blog sharethis",
// "blog sharethis publisher" => "blog sharethis publisher",
// "feature file galleries" => "feature file galleries",
// "home file gallery" => "home file gallery",
// "fgal root id" => "fgal root id",
// "fgal use db" => "fgal use db",
// "fgal batch dir" => "fgal batch dir",
// "fgal match regex" => "fgal match regex",
// "fgal nmatch regex" => "fgal nmatch regex",
// "fgal use dir" => "fgal use dir",
// "fgal podcast dir" => "fgal podcast dir",
// "feature file galleries comments" => "feature file galleries comments",
// "file galleries comments default ordering" => "file galleries comments default ordering",
// "file galleries comments per page" => "file galleries comments per page",
// "feature file galleries batch" => "feature file galleries batch",
// "feature file galleries rankings" => "feature file galleries rankings",
// "fgal enable auto indexing" => "fgal enable auto indexing",
// "fgal asynchronous indexing" => "fgal asynchronous indexing",
// "fgal allow duplicates" => "fgal allow duplicates",
// "fgal sort mode" => "fgal sort mode",
// "feature file galleries author" => "feature file galleries author",
// "fgal list id" => "fgal list id",
// "fgal list type" => "fgal list type",
// "fgal list name" => "fgal list name",
// "fgal list description" => "fgal list description",
// "fgal list size" => "fgal list size",
// "fgal list created" => "fgal list created",
// "fgal list lastModif" => "fgal list lastModif",
// "fgal list creator" => "fgal list creator",
// "fgal list author" => "fgal list author",
// "fgal list last user" => "fgal list last user",
// "fgal list comment" => "fgal list comment",
// "fgal list files" => "fgal list files",
// "fgal list hits" => "fgal list hits",
// "fgal list lastDownload" => "fgal list lastDownload",
// "fgal list lockedby" => "fgal list lockedby",
// "fgal show path" => "fgal show path",
// "fgal show explorer" => "fgal show explorer",
// "fgal show slideshow" => "fgal show slideshow",
// "fgal default view" => "fgal default view",
// "fgal limit hits per file" => "fgal limit hits per file",
// "fgal prevent negative score" => "fgal prevent negative score",
// "fgal quota" => "fgal quota",
// "fgal quota per fgal" => "fgal quota per fgal",
// "fgal quota default" => "fgal quota default",
// "fgal quota show" => "fgal quota show",
// "fgal list backlinks" => "fgal list backlinks",
// "fgal search in content" => "fgal search in content",
// "fgal search" => "fgal search",
// "fgal delete after" => "fgal delete after",
// "fgal delete after email" => "fgal delete after email",
// "fgal list id admin" => "fgal list id admin",
// "fgal list type admin" => "fgal list type admin",
// "fgal list name admin" => "fgal list name admin",
// "fgal list description admin" => "fgal list description admin",
// "fgal list size admin" => "fgal list size admin",
// "fgal list created admin" => "fgal list created admin",
// "fgal list lastModif admin" => "fgal list lastModif admin",
// "fgal list creator admin" => "fgal list creator admin",
// "fgal list author admin" => "fgal list author admin",
// "fgal list last user admin" => "fgal list last user admin",
// "fgal list comment admin" => "fgal list comment admin",
// "fgal list files admin" => "fgal list files admin",
// "fgal list hits admin" => "fgal list hits admin",
// "fgal list lastDownload admin" => "fgal list lastDownload admin",
// "fgal list lockedby admin" => "fgal list lockedby admin",
// "fgal list backlinks admin" => "fgal list backlinks admin",
// "fgal keep fileId" => "fgal keep fileId",
// "fgal show thumbactions" => "fgal show thumbactions",
// "fgal thumb max size" => "fgal thumb max size",
// "feature galleries" => "feature galleries",
// "feature gal batch" => "feature gal batch",
// "feature gal slideshow" => "feature gal slideshow",
// "home gallery" => "home gallery",
// "gal use db" => "gal use db",
// "gal use lib" => "gal use lib",
// "gal match regex" => "gal match regex",
// "gal nmatch regex" => "gal nmatch regex",
// "gal use dir" => "gal use dir",
// "gal batch dir" => "gal batch dir",
// "feature gal rankings" => "feature gal rankings",
// "feature image galleries comments" => "feature image galleries comments",
// "image galleries comments default order" => "image galleries comments default order",
// "image galleries comments per page" => "image galleries comments per page",
// "gal list name" => "gal list name",
// "gal list parent" => "gal list parent",
// "gal list description" => "gal list description",
// "gal list created" => "gal list created",
// "gal list lastmodif" => "gal list lastmodif",
// "gal list user" => "gal list user",
// "gal list imgs" => "gal list imgs",
// "gal list visits" => "gal list visits",
// "feature image gallery mandatory category" => "feature image gallery mandatory category",
// "preset galleries info" => "preset galleries info",
// "gal image mouseover" => "gal image mouseover",
// "feature forums" => "feature forums",
// "home forum" => "home forum",
// "feature forum rankings" => "feature forum rankings",
// "feature forum parse" => "feature forum parse",
// "feature forum topics archiving" => "feature forum topics archiving",
// "feature forum replyempty" => "feature forum replyempty",
// "feature forum quickjump" => "feature forum quickjump",
// "feature forums allow thread titles" => "feature forums allow thread titles",
// "feature forum content search" => "feature forum content search",
// "feature forums name search" => "feature forums name search",
// "forums ordering" => "forums ordering",
// "forum list topics" => "forum list topics",
// "forum list posts" => "forum list posts",
// "forum list ppd" => "forum list ppd",
// "forum list lastpost" => "forum list lastpost",
// "forum list visits" => "forum list visits",
// "forum list desc" => "forum list desc",
// "forum list description len" => "forum list description len",
// "feature forum local search" => "feature forum local search",
// "feature forum local tiki search" => "feature forum local tiki search",
// "forum thread defaults by forum" => "forum thread defaults by forum",
// "forum thread user settings" => "forum thread user settings",
// "forum thread user settings threshold" => "forum thread user settings threshold",
// "forum thread user settings keep" => "forum thread user settings keep",
// "forum comments per page" => "forum comments per page",
// "forum comments no title prefix" => "forum comments no title prefix",
// "forum thread style" => "forum thread style",
// "forum thread sort mode" => "forum thread sort mode",
// "forum match regex" => "forum match regex",
// "forum reply notitle" => "forum reply notitle",
// "feature articles" => "feature articles",
// "feature submissions" => "feature submissions",
// "feature cms rankings" => "feature cms rankings",
// "feature cms print" => "feature cms print",
// "feature cms emails" => "feature cms emails",
// "feature cms sharethis" => "feature cms sharethis",
// "art sort mode" => "art sort mode",
// "art list title" => "art list title",
// "art list title len" => "art list title len",
// "art list id" => "art list id",
// "art list topic" => "art list topic",
// "art list date" => "art list date",
// "art list author" => "art list author",
// "art list rating" => "art list rating",
// "art list reads" => "art list reads",
// "art list size" => "art list size",
// "art list expire" => "art list expire",
// "art list img" => "art list img",
// "art list type" => "art list type",
// "art list visible" => "art list visible",
// "art view type" => "art view type",
// "art view title" => "art view title",
// "art view topic" => "art view topic",
// "art view date" => "art view date",
// "art view author" => "art view author",
// "art view reads" => "art view reads",
// "art view size" => "art view size",
// "art view img" => "art view img",
// "art list lang" => "art list lang",
// "art trailer pos" => "art trailer pos",
// "art header text pos" => "art header text pos",
// "feature article comments" => "feature article comments",
// "article comments default ordering" => "article comments default ordering",
// "article comments per page" => "article comments per page",
// "article paginate" => "article paginate",
// "article user rating" => "article user rating",
// "article user rating options" => "article user rating options",
// "article image size x" => "article image size x",
// "article image size y" => "article image size y",
// "article custom attributes" => "article custom attributes",
// "article sharethis publisher" => "article sharethis publisher",
// "feature cms templates" => "feature cms templates",
// "cms bot bar" => "cms bot bar",
// "cms left column" => "cms left column",
// "cms right column" => "cms right column",
// "cms top bar" => "cms top bar",
// "art home title" => "art home title",
// "feature trackers" => "feature trackers",
// "t use db" => "t use db",
// "t use dir" => "t use dir",
// "groupTracker" => "groupTracker",
// "userTracker" => "userTracker",
// "trackerCreatorGroupName" => "trackerCreatorGroupName",
// "user selector threshold" => "user selector threshold",
// "user selector realnames tracker" => "user selector realnames tracker",
// "user selector realnames messu" => "user selector realnames messu",
// "feature userlevels" => "feature userlevels",
// "userlevels" => "userlevels",
// "userbreadCrumb" => "userbreadCrumb",
// "user assigned modules" => "user assigned modules",
// "user flip modules" => "user flip modules",
// "user show realnames" => "user show realnames",
// "user store file gallery picture" => "user store file gallery picture",
// "user picture gallery id" => "user picture gallery id",
// "user who viewed my stuff" => "user who viewed my stuff",
// "user who viewed my stuff days" => "user who viewed my stuff days",
// "user who viewed my stuff show others" => "user who viewed my stuff show others",
// "user register prettytracker" => "user register prettytracker",
// "user register prettytracker tpl" => "user register prettytracker tpl",
// "user trackersync trackers" => "user trackersync trackers",
// "user trackersync realname" => "user trackersync realname",
// "user trackersync geo" => "user trackersync geo",
// "user trackersync groups" => "user trackersync groups",
// "user trackersync parentgroup" => "user trackersync parentgroup",
// "feature mytiki" => "feature mytiki",
// "feature userPreferences" => "feature userPreferences",
// "feature user bookmarks" => "feature user bookmarks",
// "feature tasks" => "feature tasks",
// "w use db" => "w use db",
// "w use dir" => "w use dir",
// "w displayed default" => "w displayed default",
// "uf use db" => "uf use db",
// "uf use dir" => "uf use dir",
// "userfiles quota" => "userfiles quota",
// "feature usermenu" => "feature usermenu",
// "feature minical" => "feature minical",
// "feature notepad" => "feature notepad",
// "feature userfiles" => "feature userfiles",
// "feature community gender" => "feature community gender",
// "feature community mouseover" => "feature community mouseover",
// "feature community mouseover name" => "feature community mouseover name",
// "feature community mouseover gender" => "feature community mouseover gender",
// "feature community mouseover picture" => "feature community mouseover picture",
// "feature community mouseover friends" => "feature community mouseover friends",
// "feature community mouseover score" => "feature community mouseover score",
// "feature community mouseover country" => "feature community mouseover country",
// "feature community mouseover email" => "feature community mouseover email",
// "feature community mouseover lastlogin" => "feature community mouseover lastlogin",
// "feature community mouseover distance" => "feature community mouseover distance",
// "feature community list name" => "feature community list name",
// "feature community list score" => "feature community list score",
// "feature community list country" => "feature community list country",
// "feature community list distance" => "feature community list distance",
// "feature community friends permission" => "feature community friends permission",
// "feature community friends permission dep" => "feature community friends permission dep",
// "change language" => "change language",
// "change theme" => "change theme",
// "login is email" => "login is email",
// "login is email obscure" => "login is email obscure",
// "validateUsers" => "validateUsers",
// "validateEmail" => "validateEmail",
// "forgotPass" => "forgotPass",
// "change password" => "change password",
// "available languages" => "available languages",
// "available styles" => "available styles",
// "lowercase username" => "lowercase username",
// "username pattern" => "username pattern",
// "max username length" => "max username length",
// "min username length" => "min username length",
// "users serve avatar static" => "users serve avatar static",
// "users prefs allowMsgs" => "users prefs allowMsgs",
// "users prefs country" => "users prefs country",
// "users prefs diff versions" => "users prefs diff versions",
// "users prefs display timezone" => "users prefs display timezone",
// "users prefs email is public" => "users prefs email is public",
// "users prefs homePage" => "users prefs homePage",
// "users prefs lat" => "users prefs lat",
// "users prefs lon" => "users prefs lon",
// "users prefs mess archiveAfter" => "users prefs mess archiveAfter",
// "users prefs mess maxRecords" => "users prefs mess maxRecords",
// "users prefs mess sendReadStatus" => "users prefs mess sendReadStatus",
// "users prefs minPrio" => "users prefs minPrio",
// "users prefs mytiki blogs" => "users prefs mytiki blogs",
// "users prefs mytiki articles" => "users prefs mytiki articles",
// "users prefs mytiki gals" => "users prefs mytiki gals",
// "users prefs mytiki items" => "users prefs mytiki items",
// "users prefs mytiki msgs" => "users prefs mytiki msgs",
// "users prefs mytiki pages" => "users prefs mytiki pages",
// "users prefs mytiki tasks" => "users prefs mytiki tasks",
// "users prefs mytiki forum topics" => "users prefs mytiki forum topics",
// "users prefs mytiki forum replies" => "users prefs mytiki forum replies",
// "users prefs realName" => "users prefs realName",
// "users prefs gender" => "users prefs gender",
// "users prefs show mouseover user info" => "users prefs show mouseover user info",
// "users prefs tasks maxRecords" => "users prefs tasks maxRecords",
// "users prefs user dbl" => "users prefs user dbl",
// "users prefs user information" => "users prefs user information",
// "users prefs userbreadCrumb" => "users prefs userbreadCrumb",
// "users prefs mailCharset" => "users prefs mailCharset",
// "users prefs mailCurrentAccount" => "users prefs mailCurrentAccount",
// "validateRegistration" => "validateRegistration",
// "validator emails" => "validator emails",
// "url after validation" => "url after validation",
// "urlOnUsername" => "urlOnUsername",
// "feature messages" => "feature messages",
// "messu mailbox size" => "messu mailbox size",
// "messu archive size" => "messu archive size",
// "messu sent size" => "messu sent size",
// "allowmsg by default" => "allowmsg by default",
// "allowmsg is optional" => "allowmsg is optional",
// "feature freetags" => "feature freetags",
// "freetags browse show cloud" => "freetags browse show cloud",
// "freetags cloud colors" => "freetags cloud colors",
// "freetags preload random search" => "freetags preload random search",
// "freetags browse amount tags in cloud" => "freetags browse amount tags in cloud",
// "freetags browse amount tags suggestion" => "freetags browse amount tags suggestion",
// "freetags normalized valid chars" => "freetags normalized valid chars",
// "freetags lowercase only" => "freetags lowercase only",
// "freetags feature 3d" => "freetags feature 3d",
// "freetags 3d width" => "freetags 3d width",
// "freetags 3d height" => "freetags 3d height",
// "freetags 3d navigation depth" => "freetags 3d navigation depth",
// "freetags 3d feed animation interval" => "freetags 3d feed animation interval",
// "freetags 3d existing page color" => "freetags 3d existing page color",
// "freetags 3d missing page color" => "freetags 3d missing page color",
// "freetags 3d autoload" => "freetags 3d autoload",
// "freetags 3d camera distance" => "freetags 3d camera distance",
// "freetags 3d elastic constant" => "freetags 3d elastic constant",
// "freetags 3d eletrostatic constant" => "freetags 3d eletrostatic constant",
// "freetags 3d fov" => "freetags 3d fov",
// "freetags 3d friction constant" => "freetags 3d friction constant",
// "freetags 3d node charge" => "freetags 3d node charge",
// "freetags 3d node mass" => "freetags 3d node mass",
// "freetags 3d node size" => "freetags 3d node size",
// "freetags 3d spring size" => "freetags 3d spring size",
// "freetags 3d text size" => "freetags 3d text size",
// "freetags 3d adjust camera" => "freetags 3d adjust camera",
// "freetags multilingual" => "freetags multilingual",
// "morelikethis algorithm" => "morelikethis algorithm",
// "morelikethis basic mincommon" => "morelikethis basic mincommon",
// "freetags show middle" => "freetags show middle",
// "feature search stats" => "feature search stats",
// "feature search" => "feature search",
// "feature search fulltext" => "feature search fulltext",
// "feature search show forbidden obj" => "feature search show forbidden obj",
// "feature search show forbidden cat" => "feature search show forbidden cat",
// "feature search show object filter" => "feature search show object filter",
// "feature search show search box" => "feature search show search box",
// "feature search show visit count" => "feature search show visit count",
// "feature search show pertinence" => "feature search show pertinence",
// "feature search show object type" => "feature search show object type",
// "feature search show last modification" => "feature search show last modification",
// "search refresh index mode" => "search refresh index mode",
// "search parsed snippet" => "search parsed snippet",
// "search default where" => "search default where",
// "search default interface language" => "search default interface language",
// "search autocomplete" => "search autocomplete",
// "feature webmail" => "feature webmail",
// "webmail max attachment" => "webmail max attachment",
// "webmail view html" => "webmail view html",
// "webmail quick flags" => "webmail quick flags",
// "feature contacts" => "feature contacts",
// "feature faqs" => "feature faqs",
// "feature faq comments" => "feature faq comments",
// "faq comments per page" => "faq comments per page",
// "faq comments default ordering" => "faq comments default ordering",
// "faq prefix" => "faq prefix",
// "feature quizzes" => "feature quizzes",
// "feature polls" => "feature polls",
// "feature poll comments" => "feature poll comments",
// "feature poll anonymous" => "feature poll anonymous",
// "poll comments default ordering" => "poll comments default ordering",
// "poll comments per page" => "poll comments per page",
// "poll list categories" => "poll list categories",
// "poll list objects" => "poll list objects",
// "poll multiple per object" => "poll multiple per object",
// "feature poll revote" => "feature poll revote",
// "feature surveys" => "feature surveys",
// "feature featuredLinks" => "feature featuredLinks",
// "feature directory" => "feature directory",
// "directory columns" => "directory columns",
// "directory links per page" => "directory links per page",
// "directory open links" => "directory open links",
// "directory validate urls" => "directory validate urls",
// "directory cool sites" => "directory cool sites",
// "directory country flag" => "directory country flag",
// "feature calendar" => "feature calendar",
// "feature default calendars" => "feature default calendars",
// "calendar sticky popup" => "calendar sticky popup",
// "default calendars" => "default calendars",
// "calendar view mode" => "calendar view mode",
// "calendar view tab" => "calendar view tab",
// "calendar firstDayofWeek" => "calendar firstDayofWeek",
// "calendar timespan" => "calendar timespan",
// "feature jscalendar" => "feature jscalendar",
// "feature action calendar" => "feature action calendar",
// "calendar start year" => "calendar start year",
// "calendar end year" => "calendar end year",
// "calendar list begins focus" => "calendar list begins focus",
// "feature cal manual time" => "feature cal manual time",
// "calendar view days" => "calendar view days",
// "calendar addtogooglecal" => "calendar addtogooglecal",
// "server timezone" => "server timezone",
// "long date format" => "long date format",
// "long time format" => "long time format",
// "short date format" => "short date format",
// "short time format" => "short time format",
// "display field order" => "display field order",
// "tiki same day time only" => "tiki same day time only",
// "feed basic auth" => "feed basic auth",
// "feed cache time" => "feed cache time",
// "feed default version" => "feed default version",
// "feed atom author name" => "feed atom author name",
// "feed atom author email" => "feed atom author email",
// "feed atom author url" => "feed atom author url",
// "feed img" => "feed img",
// "feed rss editor email" => "feed rss editor email",
// "feed rss webmaster email" => "feed rss webmaster email",
// "feed language" => "feed language",
// "feed articles" => "feed articles",
// "feed articles desc" => "feed articles desc",
// "feed articles homepage" => "feed articles homepage",
// "feed articles max" => "feed articles max",
// "feed articles showAuthor" => "feed articles showAuthor",
// "feed articles title" => "feed articles title",
// "feed blog" => "feed blog",
// "feed blog desc" => "feed blog desc",
// "feed blog homepage" => "feed blog homepage",
// "feed blog max" => "feed blog max",
// "feed blog showAuthor" => "feed blog showAuthor",
// "feed blog title" => "feed blog title",
// "feed blogs" => "feed blogs",
// "feed blogs desc" => "feed blogs desc",
// "feed blogs homepage" => "feed blogs homepage",
// "feed blogs max" => "feed blogs max",
// "feed blogs showAuthor" => "feed blogs showAuthor",
// "feed blogs title" => "feed blogs title",
// "feed calendar" => "feed calendar",
// "feed calendar desc" => "feed calendar desc",
// "feed calendar homepage" => "feed calendar homepage",
// "feed calendar max" => "feed calendar max",
// "feed calendar showAuthor" => "feed calendar showAuthor",
// "feed calendar title" => "feed calendar title",
// "feed directories" => "feed directories",
// "feed directories desc" => "feed directories desc",
// "feed directories homepage" => "feed directories homepage",
// "feed directories max" => "feed directories max",
// "feed directories showAuthor" => "feed directories showAuthor",
// "feed directories title" => "feed directories title",
// "feed file galleries" => "feed file galleries",
// "feed file galleries desc" => "feed file galleries desc",
// "feed file galleries homepage" => "feed file galleries homepage",
// "feed file galleries max" => "feed file galleries max",
// "feed file galleries showAuthor" => "feed file galleries showAuthor",
// "feed file galleries title" => "feed file galleries title",
// "feed file gallery" => "feed file gallery",
// "feed file gallery desc" => "feed file gallery desc",
// "feed file gallery homepage" => "feed file gallery homepage",
// "feed file gallery max" => "feed file gallery max",
// "feed file gallery showAuthor" => "feed file gallery showAuthor",
// "feed file gallery title" => "feed file gallery title",
// "feed forum" => "feed forum",
// "feed forum desc" => "feed forum desc",
// "feed forum homepage" => "feed forum homepage",
// "feed forum max" => "feed forum max",
// "feed forum showAuthor" => "feed forum showAuthor",
// "feed forum title" => "feed forum title",
// "feed forums max" => "feed forums max",
// "feed forums" => "feed forums",
// "feed forums desc" => "feed forums desc",
// "feed forums showAuthor" => "feed forums showAuthor",
// "feed forums title" => "feed forums title",
// "feed image galleries" => "feed image galleries",
// "feed image galleries desc" => "feed image galleries desc",
// "feed image galleries homepage" => "feed image galleries homepage",
// "feed image galleries max" => "feed image galleries max",
// "feed image galleries showAuthor" => "feed image galleries showAuthor",
// "feed image galleries title" => "feed image galleries title",
// "feed image gallery" => "feed image gallery",
// "feed image gallery desc" => "feed image gallery desc",
// "feed image gallery homepage" => "feed image gallery homepage",
// "feed image gallery max" => "feed image gallery max",
// "feed image gallery showAuthor" => "feed image gallery showAuthor",
// "feed image gallery title" => "feed image gallery title",
// "feed maps" => "feed maps",
// "feed maps desc" => "feed maps desc",
// "feed maps homepage" => "feed maps homepage",
// "feed maps max" => "feed maps max",
// "feed maps showAuthor" => "feed maps showAuthor",
// "feed maps title" => "feed maps title",
// "feed shoutbox" => "feed shoutbox",
// "feed shoutbox desc" => "feed shoutbox desc",
// "feed shoutbox homepage" => "feed shoutbox homepage",
// "feed shoutbox max" => "feed shoutbox max",
// "feed shoutbox showAuthor" => "feed shoutbox showAuthor",
// "feed shoutbox title" => "feed shoutbox title",
// "feed tracker" => "feed tracker",
// "feed tracker desc" => "feed tracker desc",
// "feed tracker homepage" => "feed tracker homepage",
// "feed tracker max" => "feed tracker max",
// "feed tracker showAuthor" => "feed tracker showAuthor",
// "feed tracker title" => "feed tracker title",
// "feed trackers" => "feed trackers",
// "feed trackers desc" => "feed trackers desc",
// "feed trackers homepage" => "feed trackers homepage",
// "feed trackers max" => "feed trackers max",
// "feed trackers showAuthor" => "feed trackers showAuthor",
// "feed trackers title" => "feed trackers title",
// "feed wiki" => "feed wiki",
// "feed wiki desc" => "feed wiki desc",
// "feed wiki homepage" => "feed wiki homepage",
// "feed wiki max" => "feed wiki max",
// "feed wiki showAuthor" => "feed wiki showAuthor",
// "feed wiki title" => "feed wiki title",
// "max rss mapfiles" => "max rss mapfiles",
// "rss mapfiles" => "rss mapfiles",
// "title rss mapfiles" => "title rss mapfiles",
// "feature maps" => "feature maps",
// "map path" => "map path",
// "default map" => "default map",
// "map help" => "map help",
// "map comments" => "map comments",
// "gdaltindex" => "gdaltindex",
// "ogr2ogr" => "ogr2ogr",
// "mapzone" => "mapzone",
// "feature gmap" => "feature gmap",
// "gmap defaultx" => "gmap defaultx",
// "gmap defaulty" => "gmap defaulty",
// "gmap defaultz" => "gmap defaultz",
// "gmap key" => "gmap key",
// "gmap article list" => "gmap article list",
// "gmap page list" => "gmap page list",
// "allowRegister" => "allowRegister",
// "eponymousGroups" => "eponymousGroups",
// "useRegisterPasscode" => "useRegisterPasscode",
// "registerPasscode" => "registerPasscode",
// "rememberme" => "rememberme",
// "remembertime" => "remembertime",
// "feature clear passwords" => "feature clear passwords",
// "feature crypt passwords" => "feature crypt passwords",
// "feature challenge" => "feature challenge",
// "min user length" => "min user length",
// "min pass length" => "min pass length",
// "pass chr num" => "pass chr num",
// "pass due" => "pass due",
// "email due" => "email due",
// "unsuccessful logins" => "unsuccessful logins",
// "generate password" => "generate password",
// "auth method" => "auth method",
// "auth pear" => "auth pear",
// "auth ldap url" => "auth ldap url",
// "auth pear host" => "auth pear host",
// "auth pear port" => "auth pear port",
// "auth ldap scope" => "auth ldap scope",
// "auth ldap basedn" => "auth ldap basedn",
// "auth ldap userdn" => "auth ldap userdn",
// "auth ldap userattr" => "auth ldap userattr",
// "auth ldap useroc" => "auth ldap useroc",
// "auth ldap groupdn" => "auth ldap groupdn",
// "auth ldap groupattr" => "auth ldap groupattr",
// "auth ldap groupnameatr" => "auth ldap groupnameatr",
// "auth ldap groupdescatr" => "auth ldap groupdescatr",
// "auth ldap usergroupattr" => "auth ldap usergroupattr",
// "auth ldap groupgroupattr" => "auth ldap groupgroupattr",
// "auth ldap groupoc" => "auth ldap groupoc",
// "auth ldap memberattr" => "auth ldap memberattr",
// "auth ldap memberisdn" => "auth ldap memberisdn",
// "auth ldap adminuser" => "auth ldap adminuser",
// "auth ldap adminpass" => "auth ldap adminpass",
// "auth ldap version" => "auth ldap version",
// "auth ldap nameattr" => "auth ldap nameattr",
// "auth ldap countryattr" => "auth ldap countryattr",
// "auth ldap emailattr" => "auth ldap emailattr",
// "ldap create user tiki" => "ldap create user tiki",
// "ldap create user ldap" => "ldap create user ldap",
// "ldap skip admin" => "ldap skip admin",
// "auth ldap permit tiki users" => "auth ldap permit tiki users",
// "auth ldap debug" => "auth ldap debug",
// "auth ldap ssl" => "auth ldap ssl",
// "auth ldap starttls" => "auth ldap starttls",
// "auth ldap type" => "auth ldap type",
// "auth ldap syncuserattr" => "auth ldap syncuserattr",
// "auth ldap syncgroupattr" => "auth ldap syncgroupattr",
// "auth phpbb version" => "auth phpbb version",
// "auth phpbb skip admin" => "auth phpbb skip admin",
// "auth phpbb create tiki" => "auth phpbb create tiki",
// "auth phpbb dbhost" => "auth phpbb dbhost",
// "auth phpbb dbport" => "auth phpbb dbport",
// "auth phpbb disable tikionly" => "auth phpbb disable tikionly",
// "auth phpbb dbuser" => "auth phpbb dbuser",
// "auth phpbb dbpasswd" => "auth phpbb dbpasswd",
// "auth phpbb dbname" => "auth phpbb dbname",
// "auth phpbb dbtype" => "auth phpbb dbtype",
// "auth phpbb table prefix" => "auth phpbb table prefix",
// "auth ws create tiki" => "auth ws create tiki",
// "https login" => "https login",
// "https external links for users" => "https external links for users",
// "feature show stay in ssl mode" => "feature show stay in ssl mode",
// "feature switch ssl mode" => "feature switch ssl mode",
// "https port" => "https port",
// "http port" => "http port",
// "login url" => "login url",
// "login scr" => "login scr",
// "register url" => "register url",
// "error url" => "error url",
// "highlight group" => "highlight group",
// "cookie path" => "cookie path",
// "cookie domain" => "cookie domain",
// "cookie name" => "cookie name",
// "user tracker infos" => "user tracker infos",
// "desactive login autocomplete" => "desactive login autocomplete",
// "permission denied login box" => "permission denied login box",
// "permission denied url" => "permission denied url",
// "feature loadbalancer" => "feature loadbalancer",
// "feature intertiki" => "feature intertiki",
// "feature intertiki server" => "feature intertiki server",
// "feature intertiki slavemode" => "feature intertiki slavemode",
// "interlist" => "interlist",
// "feature intertiki mymaster" => "feature intertiki mymaster",
// "feature intertiki import preferences" => "feature intertiki import preferences",
// "feature intertiki import groups" => "feature intertiki import groups",
// "known hosts" => "known hosts",
// "tiki key" => "tiki key",
// "intertiki logfile" => "intertiki logfile",
// "intertiki errfile" => "intertiki errfile",
// "feature intertiki sharedcookie" => "feature intertiki sharedcookie",
// "search lru length" => "search lru length",
// "search lru purge rate" => "search lru purge rate",
// "search max syllwords" => "search max syllwords",
// "search min wordlength" => "search min wordlength",
// "search refresh rate" => "search refresh rate",
// "search syll age" => "search syll age",
// "feature categories" => "feature categories",
// "feature categoryobjects" => "feature categoryobjects",
// "feature categorypath" => "feature categorypath",
// "feature category use phplayers" => "feature category use phplayers",
// "categorypath excluded" => "categorypath excluded",
// "categories used in tpl" => "categories used in tpl",
// "category jail" => "category jail",
// "category defaults" => "category defaults",
// "category i18n sync" => "category i18n sync",
// "category i18n synced" => "category i18n synced",
// "category i18n unsynced" => "category i18n unsynced",
// "category autogeocode within" => "category autogeocode within",
// "category autogeocode replace" => "category autogeocode replace",
// "category autogeocode fudge" => "category autogeocode fudge",
// "expanded category jail" => "expanded category jail",
// "expanded category jail key" => "expanded category jail key",
// "ws container" => "ws container",
// "feature html pages" => "feature html pages",
// "feature filegals manager" => "feature filegals manager",
// "feature contact" => "feature contact",
// "contact user" => "contact user",
// "contact anon" => "contact anon",
// "mail crlf" => "mail crlf",
// "feature detect language" => "feature detect language",
// "feature homePage if bl missing" => "feature homePage if bl missing",
// "record untranslated" => "record untranslated",
// "feature best language" => "feature best language",
// "feature translation" => "feature translation",
// "feature urgent translation" => "feature urgent translation",
// "feature urgent translation master only" => "feature urgent translation master only",
// "feature translation incomplete notice" => "feature translation incomplete notice",
// "lang use db" => "lang use db",
// "language" => "language",
// "restrict language" => "restrict language",
// "feature babelfish" => "feature babelfish",
// "feature babelfish logo" => "feature babelfish logo",
// "quantify changes" => "quantify changes",
// "feature sync language" => "feature sync language",
// "show available translations" => "show available translations",
// "language inclusion threshold" => "language inclusion threshold",
// "metatag keywords" => "metatag keywords",
// "metatag threadtitle" => "metatag threadtitle",
// "metatag imagetitle" => "metatag imagetitle",
// "metatag freetags" => "metatag freetags",
// "metatag description" => "metatag description",
// "metatag pagedesc" => "metatag pagedesc",
// "metatag author" => "metatag author",
// "metatag geoposition" => "metatag geoposition",
// "metatag georegion" => "metatag georegion",
// "metatag geoplacename" => "metatag geoplacename",
// "metatag robots" => "metatag robots",
// "metatag revisitafter" => "metatag revisitafter",
// "head extra js" => "head extra js",
// "keep versions" => "keep versions",
// "feature custom home" => "feature custom home",
// "site crumb seper" => "site crumb seper",
// "site nav seper" => "site nav seper",
// "feature sitemycode" => "feature sitemycode",
// "sitemycode" => "sitemycode",
// "sitemycode publish" => "sitemycode publish",
// "feature sitelogo" => "feature sitelogo",
// "sitelogo bgcolor" => "sitelogo bgcolor",
// "sitelogo bgstyle" => "sitelogo bgstyle",
// "sitelogo align" => "sitelogo align",
// "sitelogo title" => "sitelogo title",
// "sitelogo src" => "sitelogo src",
// "sitelogo alt" => "sitelogo alt",
// "feature siteloc" => "feature siteloc",
// "feature sitenav" => "feature sitenav",
// "sitenav" => "sitenav",
// "feature sitead" => "feature sitead",
// "sitead" => "sitead",
// "sitead publish" => "sitead publish",
// "feature breadcrumbs" => "feature breadcrumbs",
// "feature siteloclabel" => "feature siteloclabel",
// "feature sitesearch" => "feature sitesearch",
// "feature site login" => "feature site login",
// "feature sitemenu" => "feature sitemenu",
// "feature sitemenu custom code" => "feature sitemenu custom code",
// "feature secondary sitemenu custom code" => "feature secondary sitemenu custom code",
// "feature topbar version" => "feature topbar version",
// "feature topbar id menu" => "feature topbar id menu",
// "feature topbar custom code" => "feature topbar custom code",
// "feature sitetitle" => "feature sitetitle",
// "feature sitedesc" => "feature sitedesc",
// "feature bot logo" => "feature bot logo",
// "feature endbody code" => "feature endbody code",
// "feature custom doctype" => "feature custom doctype",
// "feature custom doctype content" => "feature custom doctype content",
// "feature custom html head content" => "feature custom html head content",
// "feature fixed width" => "feature fixed width",
// "feature html head base tag" => "feature html head base tag",
// "feature left column" => "feature left column",
// "feature right column" => "feature right column",
// "feature top bar" => "feature top bar",
// "feature bot bar" => "feature bot bar",
// "feature bot bar icons" => "feature bot bar icons",
// "feature bot bar debug" => "feature bot bar debug",
// "feature bot bar rss" => "feature bot bar rss",
// "feature bot bar power by tw" => "feature bot bar power by tw",
// "maxRecords" => "maxRecords",
// "maxArticles" => "maxArticles",
// "maxVersions" => "maxVersions",
// "feature view tpl" => "feature view tpl",
// "slide style" => "slide style",
// "site favicon" => "site favicon",
// "site favicon type" => "site favicon type",
// "style" => "style",
// "style option" => "style option",
// "use context menu icon" => "use context menu icon",
// "use context menu text" => "use context menu text",
// "feature site report" => "feature site report",
// "feature site send link" => "feature site send link",
// "feature layoutshadows" => "feature layoutshadows",
// "main shadow start" => "main shadow start",
// "main shadow end" => "main shadow end",
// "header shadow start" => "header shadow start",
// "header shadow end" => "header shadow end",
// "middle shadow start" => "middle shadow start",
// "middle shadow end" => "middle shadow end",
// "center shadow start" => "center shadow start",
// "center shadow end" => "center shadow end",
// "footer shadow start" => "footer shadow start",
// "footer shadow end" => "footer shadow end",
// "box shadow start" => "box shadow start",
// "box shadow end" => "box shadow end",
// "feature custom center column header" => "feature custom center column header",
// "header custom css" => "header custom css",
// "header custom js" => "header custom js",
// "feature mods provider" => "feature mods provider",
// "mods dir" => "mods dir",
// "mods server" => "mods server",
// "feature experimental" => "feature experimental",
// "feature actionlog" => "feature actionlog",
// "feature actionlog bytes" => "feature actionlog bytes",
// "browsertitle" => "browsertitle",
// "site title location" => "site title location",
// "site title breadcrumb" => "site title breadcrumb",
// "tmpDir" => "tmpDir",
// "feature tell a friend" => "feature tell a friend",
// "feature share" => "feature share",
// "feature copyright" => "feature copyright",
// "feature smileys" => "feature smileys",
// "popupLinks" => "popupLinks",
// "feature autolinks" => "feature autolinks",
// "default rows textarea wiki" => "default rows textarea wiki",
// "default rows textarea comment" => "default rows textarea comment",
// "default rows textarea forum" => "default rows textarea forum",
// "default rows textarea forumthread" => "default rows textarea forumthread",
// "section comments parse" => "section comments parse",
// "toolbar global" => "toolbar global",
// "toolbar global comments" => "toolbar global comments",
// "toolbar sheet" => "toolbar sheet",
// "direct pagination" => "direct pagination",
// "nextprev pagination" => "nextprev pagination",
// "pagination firstlast" => "pagination firstlast",
// "pagination hide if one page" => "pagination hide if one page",
// "pagination icons" => "pagination icons",
// "pagination fastmove links" => "pagination fastmove links",
// "direct pagination max middle links" => "direct pagination max middle links",
// "direct pagination max ending links" => "direct pagination max ending links",
// "feature kaltura" => "feature kaltura",
// "wikiplugin kaltura" => "wikiplugin kaltura",
// "wikiplugininline kaltura" => "wikiplugininline kaltura",
// "default kaltura editor" => "default kaltura editor",
// "partnerId" => "partnerId",
// "secret" => "secret",
// "adminSecret" => "adminSecret",
// "kdpUIConf" => "kdpUIConf",
// "kdpWidget" => "kdpWidget",
// "kcwUIConf" => "kcwUIConf",
// "kseUIConf" => "kseUIConf",
// "kaeUIConf" => "kaeUIConf",
// "kuser" => "kuser",
// "kServiceUrl" => "kServiceUrl",
// "bigbluebutton feature" => "bigbluebutton feature",
// "bigbluebutton server location" => "bigbluebutton server location",
// "bigbluebutton server salt" => "bigbluebutton server salt",
// "shipping service" => "shipping service",
// "shipping fedex enable" => "shipping fedex enable",
// "shipping fedex key" => "shipping fedex key",
// "shipping fedex password" => "shipping fedex password",
// "shipping fedex meter" => "shipping fedex meter",
// "shipping fedex account" => "shipping fedex account",
// "shipping ups enable" => "shipping ups enable",
// "shipping ups username" => "shipping ups username",
// "shipping ups password" => "shipping ups password",
// "shipping ups license" => "shipping ups license",
// "recaptcha enabled" => "recaptcha enabled",
// "recaptcha pubkey" => "recaptcha pubkey",
// "recaptcha privkey" => "recaptcha privkey",
// "captcha wordLen" => "captcha wordLen",
// "captcha width" => "captcha width",
// "captcha noise" => "captcha noise",
// "anonCanEdit" => "anonCanEdit",
// "cacheimages" => "cacheimages",
// "cachepages" => "cachepages",
// "count admin pvs" => "count admin pvs",
// "default mail charset" => "default mail charset",
// "error reporting adminonly" => "error reporting adminonly",
// "error reporting level" => "error reporting level",
// "smarty security" => "smarty security",
// "smarty compilation" => "smarty compilation",
// "feature htmlpurifier output" => "feature htmlpurifier output",
// "feature ajax" => "feature ajax",
// "ajax autosave" => "ajax autosave",
// "ajax xajax" => "ajax xajax",
// "feature antibot" => "feature antibot",
// "feature banners" => "feature banners",
// "feature banning" => "feature banning",
// "feature comm" => "feature comm",
// "feature contribution" => "feature contribution",
// "feature contribution display in comment" => "feature contribution display in comment",
// "feature contribution mandatory" => "feature contribution mandatory",
// "feature contribution mandatory blog" => "feature contribution mandatory blog",
// "feature contribution mandatory comment" => "feature contribution mandatory comment",
// "feature contribution mandatory forum" => "feature contribution mandatory forum",
// "feature credits" => "feature credits",
// "feature debug console" => "feature debug console",
// "feature debugger console" => "feature debugger console",
// "feature display my to others" => "feature display my to others",
// "feature dynamic content" => "feature dynamic content",
// "feature edit templates" => "feature edit templates",
// "feature editcss" => "feature editcss",
// "feature events" => "feature events",
// "feature friends" => "feature friends",
// "feature fullscreen" => "feature fullscreen",
// "feature help" => "feature help",
// "feature hotwords" => "feature hotwords",
// "feature hotwords nw" => "feature hotwords nw",
// "feature integrator" => "feature integrator",
// "feature live support" => "feature live support",
// "feature mailin" => "feature mailin",
// "feature menusfolderstyle" => "feature menusfolderstyle",
// "feature mobile" => "feature mobile",
// "feature modulecontrols" => "feature modulecontrols",
// "feature morcego" => "feature morcego",
// "feature multilingual" => "feature multilingual",
// "feature multilingual one page" => "feature multilingual one page",
// "feature multilingual structures" => "feature multilingual structures",
// "feature machine translation" => "feature machine translation",
// "feature newsletters" => "feature newsletters",
// "feature obzip" => "feature obzip",
// "feature perspective" => "feature perspective",
// "feature phplayers" => "feature phplayers",
// "feature cssmenus" => "feature cssmenus",
// "menus item names raw" => "menus item names raw",
// "feature projects" => "feature projects",
// "feature ranking" => "feature ranking",
// "feature redirect on error" => "feature redirect on error",
// "url anonymous page not found" => "url anonymous page not found",
// "feature referer highlight" => "feature referer highlight",
// "feature referer stats" => "feature referer stats",
// "feature score" => "feature score",
// "feature sheet" => "feature sheet",
// "feature shoutbox" => "feature shoutbox",
// "feature source" => "feature source",
// "feature stats" => "feature stats",
// "feature tabs" => "feature tabs",
// "feature theme control" => "feature theme control",
// "feature ticketlib" => "feature ticketlib",
// "feature ticketlib2" => "feature ticketlib2",
// "feature top banner" => "feature top banner",
// "feature usability" => "feature usability",
// "feature use quoteplugin" => "feature use quoteplugin",
// "feature use three colon centertag" => "feature use three colon centertag",
// "feature user watches" => "feature user watches",
// "feature group watches" => "feature group watches",
// "feature user watches translations" => "feature user watches translations",
// "feature user watches languages" => "feature user watches languages",
// "feature daily report watches" => "feature daily report watches",
// "feature quick object perms" => "feature quick object perms",
// "feature xmlrpc" => "feature xmlrpc",
// "feature watershed" => "feature watershed",
// "helpurl" => "helpurl",
// "layout section" => "layout section",
// "limitedGoGroupHome" => "limitedGoGroupHome",
// "minical reminders" => "minical reminders",
// "modallgroups" => "modallgroups",
// "modseparateanon" => "modseparateanon",
// "modhideanonadmin" => "modhideanonadmin",
// "php docroot" => "php docroot",
// "proxy host" => "proxy host",
// "proxy port" => "proxy port",
// "ip can be checked" => "ip can be checked",
// "sender email" => "sender email",
// "feature site report email" => "feature site report email",
// "session storage" => "session storage",
// "session lifetime" => "session lifetime",
// "session silent" => "session silent",
// "session cookie name" => "session cookie name",
// "session protected" => "session protected",
// "shoutbox autolink" => "shoutbox autolink",
// "show comzone" => "show comzone",
// "tikiIndex" => "tikiIndex",
// "urlIndex" => "urlIndex",
// "useGroupHome" => "useGroupHome",
// "useGroupTheme" => "useGroupTheme",
// "useUrlIndex" => "useUrlIndex",
// "use proxy" => "use proxy",
// "user list order" => "user list order",
// "webserverauth" => "webserverauth",
// "feature purifier" => "feature purifier",
// "feature shadowbox" => "feature shadowbox",
// "log sql" => "log sql",
// "log sql perf min" => "log sql perf min",
// "log mail" => "log mail",
// "log tpl" => "log tpl",
// "disableJavascript" => "disableJavascript",
// "feature socialnetworks" => "feature socialnetworks",
// "socialnetworks twitter consumer key" => "socialnetworks twitter consumer key",
// "socialnetworks twitter consumer secret" => "socialnetworks twitter consumer secret",
// "socialnetworks facebook api key" => "socialnetworks facebook api key",
// "socialnetworks facebook application secr" => "socialnetworks facebook application secr",
// "socialnetworks facebook application id" => "socialnetworks facebook application id",
// "socialnetworks bitly login" => "socialnetworks bitly login",
// "socialnetworks bitly key" => "socialnetworks bitly key",
// "socialnetworks bitly sitewide" => "socialnetworks bitly sitewide",
// "case patched" => "case patched",
// "site closed" => "site closed",
// "site closed msg" => "site closed msg",
// "use load threshold" => "use load threshold",
// "load threshold" => "load threshold",
// "site busy msg" => "site busy msg",
// "bot logo code" => "bot logo code",
// "feature create webhelp" => "feature create webhelp",
// "page n times in a structure" => "page n times in a structure",
// "feature forums search" => "feature forums search",
// "feature wiki ext icon" => "feature wiki ext icon",
// "feature wiki ext rel nofollow" => "feature wiki ext rel nofollow",
// "feature wiki mandatory category" => "feature wiki mandatory category",
// "feature intertiki imported groups" => "feature intertiki imported groups",
// "feature wiki history ip" => "feature wiki history ip",
// "pam create user tiki" => "pam create user tiki",
// "pam service" => "pam service",
// "pam skip admin" => "pam skip admin",
// "shib affiliation" => "shib affiliation",
// "shib create user tiki" => "shib create user tiki",
// "shib group" => "shib group",
// "shib skip admin" => "shib skip admin",
// "shib usegroup" => "shib usegroup",
// "wiki 3d camera distance" => "wiki 3d camera distance",
// "wiki 3d elastic constant" => "wiki 3d elastic constant",
// "wiki 3d eletrostatic constant" => "wiki 3d eletrostatic constant",
// "wiki 3d fov" => "wiki 3d fov",
// "wiki 3d friction constant" => "wiki 3d friction constant",
// "wiki 3d node charge" => "wiki 3d node charge",
// "wiki 3d node mass" => "wiki 3d node mass",
// "wiki 3d node size" => "wiki 3d node size",
// "wiki 3d spring size" => "wiki 3d spring size",
// "wiki 3d text size" => "wiki 3d text size",
// "articles feature copyrights" => "articles feature copyrights",
// "blogues feature copyrights" => "blogues feature copyrights",
// "faqs feature copyrights" => "faqs feature copyrights",
// "feature contributor wiki" => "feature contributor wiki",
// "https login required" => "https login required",
// "maxRowsGalleries" => "maxRowsGalleries",
// "replimaster" => "replimaster",
// "rowImagesGalleries" => "rowImagesGalleries",
// "scaleSizeGalleries" => "scaleSizeGalleries",
// "thumbSizeXGalleries" => "thumbSizeXGalleries",
// "thumbSizeYGalleries" => "thumbSizeYGalleries",
// "wiki 3d adjust camera" => "wiki 3d adjust camera",
// "wiki 3d autoload" => "wiki 3d autoload",
// "javascript enabled" => "javascript enabled",
// "javascript cdn" => "javascript cdn",
// "feature template zoom" => "feature template zoom",
// "menus items icons" => "menus items icons",
// "menus items icons path" => "menus items icons path",
// "feature iepngfix" => "feature iepngfix",
// "iepngfix selectors" => "iepngfix selectors",
// "iepngfix elements" => "iepngfix elements",
// "feature invite" => "feature invite",
// "feature jquery" => "feature jquery",
// "jquery effect" => "jquery effect",
// "jquery effect direction" => "jquery effect direction",
// "jquery effect speed" => "jquery effect speed",
// "jquery effect tabs" => "jquery effect tabs",
// "jquery effect tabs direction" => "jquery effect tabs direction",
// "jquery effect tabs speed" => "jquery effect tabs speed",
// "feature jquery ui" => "feature jquery ui",
// "feature jquery ui theme" => "feature jquery ui theme",
// "feature jquery tooltips" => "feature jquery tooltips",
// "feature jquery autocomplete" => "feature jquery autocomplete",
// "feature jquery superfish" => "feature jquery superfish",
// "feature jquery reflection" => "feature jquery reflection",
// "feature jquery jqs5" => "feature jquery jqs5",
// "feature jquery tablesorter" => "feature jquery tablesorter",
// "feature jquery carousel" => "feature jquery carousel",
// "feature jquery validation" => "feature jquery validation",
// "feature jquery media" => "feature jquery media",
// "feature sefurl" => "feature sefurl",
// "feature sefurl filter" => "feature sefurl filter",
// "feature sefurl paths" => "feature sefurl paths",
// "feature sefurl title article" => "feature sefurl title article",
// "feature sefurl title blog" => "feature sefurl title blog",
// "feature sefurl tracker prefixalias" => "feature sefurl tracker prefixalias",
// "feature tikitests" => "feature tikitests",
// "profile sources" => "profile sources",
// "profile channels" => "profile channels",
// "feature minichat" => "feature minichat",
// "memcache enabled" => "memcache enabled",
// "memcache compress" => "memcache compress",
// "memcache servers" => "memcache servers",
// "memcache expiration" => "memcache expiration",
// "memcache prefix" => "memcache prefix",
// "memcache wiki data" => "memcache wiki data",
// "memcache wiki output" => "memcache wiki output",
// "memcache forum output" => "memcache forum output",
// "feature pear date" => "feature pear date",
// "feature bidi" => "feature bidi",
// "feature lastup" => "feature lastup",
// "feature groupalert" => "feature groupalert",
// "zend mail handler" => "zend mail handler",
// "zend mail smtp server" => "zend mail smtp server",
// "zend mail smtp auth" => "zend mail smtp auth",
// "zend mail smtp user" => "zend mail smtp user",
// "zend mail smtp pass" => "zend mail smtp pass",
// "zend mail smtp port" => "zend mail smtp port",
// "zend mail smtp security" => "zend mail smtp security",
// "feature group transition" => "feature group transition",
// "feature category transition" => "feature category transition",
// "terminology profile installed" => "terminology profile installed",
// "multidomain active" => "multidomain active",
// "multidomain config" => "multidomain config",
// "tiki minify javascript" => "tiki minify javascript",
// "tiki minify css" => "tiki minify css",
// "tiki minify css single file" => "tiki minify css single file",
// "tiki cachecontrol session" => "tiki cachecontrol session",
// "tiki cachecontrol nosession" => "tiki cachecontrol nosession",
// "tiki cdn" => "tiki cdn",
// "tiki cdn ssl" => "tiki cdn ssl",
// "auth token access" => "auth token access",
// "auth token access maxtimeout" => "auth token access maxtimeout",
// "auth token access maxhits" => "auth token access maxhits",
// "auth token tellafriend" => "auth token tellafriend",
// "auth token share" => "auth token share",
// "print pdf from url" => "print pdf from url",
// "print pdf webkit path" => "print pdf webkit path",
// "print pdf webservice url" => "print pdf webservice url",
// "feature metrics dashboard" => "feature metrics dashboard",
// "metrics trend prefix" => "metrics trend prefix",
// "metrics trend suffix" => "metrics trend suffix",
// "metrics trend novalue" => "metrics trend novalue",
// "metrics pastresults count" => "metrics pastresults count",
// "metrics metric name length" => "metrics metric name length",
// "metrics tab name length" => "metrics tab name length",
// "metrics cache output" => "metrics cache output",
// "payment feature" => "payment feature",
// "payment system" => "payment system",
// "payment currency" => "payment currency",
// "payment default delay" => "payment default delay",
// "payment paypal business" => "payment paypal business",
// "payment paypal environment" => "payment paypal environment",
// "payment paypal ipn" => "payment paypal ipn",
// "payment cclite registries" => "payment cclite registries",
// "payment cclite currencies" => "payment cclite currencies",
// "payment cclite gateway" => "payment cclite gateway",
// "payment cclite merchant key" => "payment cclite merchant key",
// "payment cclite merchant user" => "payment cclite merchant user",
// "payment cclite mode" => "payment cclite mode",
// "payment cclite notify" => "payment cclite notify",
// "payment cclite hashing algorithm" => "payment cclite hashing algorithm",
// "payment manual" => "payment manual",
// "payment invoice prefix" => "payment invoice prefix",
// "rating advanced" => "rating advanced",
// "rating recalculation" => "rating recalculation",
// "rating recalculation odd" => "rating recalculation odd",
// "rating recalculation count" => "rating recalculation count",
// "cas create user tiki" => "cas create user tiki",
// "cas create user tiki ldap" => "cas create user tiki ldap",
// "cas autologin" => "cas autologin",
// "cas skip admin" => "cas skip admin",
// "cas show alternate login" => "cas show alternate login",
// "cas version" => "cas version",
// "cas hostname" => "cas hostname",
// "cas port" => "cas port",
// "cas path" => "cas path",
// "cas extra param" => "cas extra param",
// "cas authentication timeout" => "cas authentication timeout",
// "cas force logout" => "cas force logout",
// "feature comments post as anonymous" => "feature comments post as anonymous",
// "feature comments moderation" => "feature comments moderation",
// "feature comments locking" => "feature comments locking",
// "comments notitle" => "comments notitle",
// "comments field email" => "comments field email",
// "comments field website" => "comments field website",
// "comments vote" => "comments vote",
// "lat" => "lat",
// "lon" => "lon",
// "mess archiveAfter" => "mess archiveAfter",
// "mess maxRecords" => "mess maxRecords",
// "mess sendReadStatus" => "mess sendReadStatus",
// "minPrio" => "minPrio",
// "mytiki blogs" => "mytiki blogs",
// "mytiki articles" => "mytiki articles",
// "mytiki gals" => "mytiki gals",
// "mytiki items" => "mytiki items",
// "mytiki msgs" => "mytiki msgs",
// "mytiki pages" => "mytiki pages",
// "mytiki tasks" => "mytiki tasks",
// "mytiki forum topics" => "mytiki forum topics",
// "mytiki forum replies" => "mytiki forum replies",
// "tasks maxRecords" => "tasks maxRecords",
// "user dbl" => "user dbl",
// "user information" => "user information",
// "mailCharset" => "mailCharset",
// "mailCurrentAccount" => "mailCurrentAccount",
// "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. ",
// "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value" => "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value",
// "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results",
// "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms" => "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms",
// "Anti-Bot verification code image" => "Anti-Bot verification code image",
// "Try another code" => "Try another code",
// "Share page" => "Share page",
// "Share This" => "Share This",
// "Previous post" => "Previous post",
// "Next post" => "Next post",
// "Read more" => "Read more",
// "Related content" => "Related content",
// "Permalink" => "Permalink",
// "Leave a comment" => "Leave a comment",
// "Parent Gallery" => "Parent Gallery",
// "Click Here to Insert in Wiki Syntax" => "Click Here to Insert in Wiki Syntax",
// "{\$comments_cant} comment" => "{\$comments_cant} comment",
// "{\$comments_cant} comments" => "{\$comments_cant} comments",
// "Reply to the selected comment" => "Reply to the selected comment",
// "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address",
// "(your email address will not be published)" => "(your email address will not be published)",
// "Website" => "Website",
// "Rate this Article (10=best, 0=worse)" => "Rate this Article (10=best, 0=worse)",
// "Please note that the preview does not keep the attached file which you will have to choose before posting" => "Please note that the preview does not keep the attached file which you will have to choose before posting",
// "Your comment will have to be approved by the moderator before it is displayed" => "Your comment will have to be approved by the moderator before it is displayed",
// "System error" => "System error",
// "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue",
// "The query was" => "The query was",
// "The built query was likely" => "The built query was likely",
// "Stacktrace" => "Stacktrace",
// "Tiki is unable to connect to the database" => "Tiki is unable to connect to the database",
// "An error occured while performing the request" => "An error occured while performing the request",
// "File gallery" => "File gallery",
// "Duplicate permissions" => "Duplicate permissions",
// "View inserted gallery" => "View inserted gallery",
// "Required for podcasts" => "Required for podcasts",
// "System" => "System",
// "Any file" => "Any file",
// "Podcast (audio)" => "Podcast (audio)",
// "Podcast (video)" => "Podcast (video)",
// "Gallery is visible to non-admin users" => "Gallery is visible to non-admin users",
// "Gallery is public" => "Gallery is public",
// "Any user with permission (not only the gallery owner) can upload files" => "Any user with permission (not only the gallery owner) can upload files",
// "Perms of the backlinks are checked to view a file" => "Perms of the backlinks are checked to view a file",
// "Files can be locked at download" => "Files can be locked at download",
// "Maximum number of archives for each file" => "Maximum number of archives for each file",
// "Min" => "Min",
// "Group of users alerted when file gallery is modified" => "Group of users alerted when file gallery is modified",
// "Maximum width for images in gallery" => "Maximum width for images in gallery",
// "If an image is wider than this, it will be resized" => "If an image is wider than this, it will be resized",
// "Attention: In this case, the original image will be lost" => "Attention: In this case, the original image will be lost",
// "Maximum height for images in gallery" => "Maximum height for images in gallery",
// "If an image is higher than this, it will be resized" => "If an image is higher than this, it will be resized",
// "Wiki markup to enter when image selected from \"file gallery manager\"" => "Wiki markup to enter when image selected from \"file gallery manager\"",
// "The default is " => "The default is ",
// "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%",
// "Display Properties" => "Display Properties",
// "Max rows per page" => "Max rows per page",
// "Select which items to display when listing galleries" => "Select which items to display when listing galleries",
// "Perhaps you are looking for" => "Perhaps you are looking for",
// "There are no wiki pages similar to '{\$page}'" => "There are no wiki pages similar to '{\$page}'",
// "Go to Log in Page" => "Go to Log in Page",
// "Close Window" => "Close Window",
// "Go to" => "Go to",
// "Private Gallery" => "Private Gallery",
// "Open as WebFolder" => "Open as WebFolder",
// "Upload New Version" => "Upload New Version",
// "Download and lock" => "Download and lock",
// "Open in WebDAV" => "Open in WebDAV",
// "Share a link to this file" => "Share a link to this file",
// "Email a link to this file" => "Email a link to this file",
// "The checkbox is disabled because this preference is disabled globally" => "The checkbox is disabled because this preference is disabled globally",
// "Please, enable the preference globally first" => "Please, enable the preference globally first",
// "You can ask your site Admin to enable the preference" => "You can ask your site Admin to enable the preference",
// "Start the Slideshow" => "Start the Slideshow",
// "Pause the Slideshow" => "Pause the Slideshow",
// "Folksonomy Tags" => "Folksonomy Tags",
// "Folksonomy Language" => "Folksonomy Language",
// "Tags" => "Tags",
// "Untag" => "Untag",
// "Translate tags" => "Translate tags",
// "Images Galleries" => "Images Galleries",
// "RSS Wiki" => "RSS Wiki",
// "RSS Blogs" => "RSS Blogs",
// "RSS Articles" => "RSS Articles",
// "RSS Image Galleries" => "RSS Image Galleries",
// "RSS File Galleries" => "RSS File Galleries",
// "RSS Forums" => "RSS Forums",
// "RSS Maps" => "RSS Maps",
// "RSS Directories" => "RSS Directories",
// "RSS Calendars" => "RSS Calendars",
// "Show Tree" => "Show Tree",
// "Hide Tree" => "Hide Tree",
// "Are you sure you want to delete the selected files" => "Are you sure you want to delete the selected files",
// "Are you sure you want to reset the default gallery list table settings" => "Are you sure you want to reset the default gallery list table settings",
// "No Additional Sort" => "No Additional Sort",
// "Hi {\$mail_user|username} has sent you this link" => "Hi {\$mail_user|username} has sent you this link",
// "To validate your account and login to the site, please click on the following link" => "To validate your account and login to the site, please click on the following link",
// "The administrator approved your account" => "The administrator approved your account",
// "Confirm your email at %s" => "Confirm your email at %s",
// "Remove file" => "Remove file",
// "GalleryId" => "GalleryId",
// "FileId" => "FileId",
// "New topic" => "New topic",
// "An anonymous user" => "An anonymous user",
// "has posted a reply to a thread you're watching. \nYou can view the thread and reply at the following URL" => "has posted a reply to a thread you're watching. \nYou can view the thread and reply at the following URL",
// "You are invited by" => "You are invited by",
// "You join this group" => "You join this group",
// "Join me on %s" => "Join me on %s",
// "You sent a request with the subject" => "You sent a request with the subject",
// "Use the subject to indicate the operation to apply" => "Use the subject to indicate the operation to apply",
// "GET:WikiName to get a wiki page" => "GET:WikiName to get a wiki page",
// "PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:WikiName to update/create a wiki page (use the body for the page data)",
// "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)",
// "PREPEND:WikiName to append the data at the top" => "PREPEND:WikiName to append the data at the top",
// "Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
// "New message arrived from %s" => "New message arrived from %s",
// "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now",
// "To login with your username and password, please follow this link" => "To login with your username and password, please follow this link",
// "User Account Activated" => "User Account Activated",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first",
// "Assign to a group" => "Assign to a group",
// "View user's data" => "View user's data",
// "Best regards" => "Best regards",
// "User Tracker" => "User Tracker",
// "Go to your friendship network to accept or refuse this request" => "Go to your friendship network to accept or refuse this request",
// "You're invited to join my network of friends" => "You're invited to join my network of friends",
// "Welcome to %s at %s" => "Welcome to %s at %s",
// "Reply notification" => "Reply notification",
// "Someone" => "Someone",
// "requested a reminder of the password for your account" => "requested a reminder of the password for your account",
// "requested password reset for your account" => "requested password reset for your account",
// "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else",
// "Important: Username & password are CaSe SenSitiVe" => "Important: Username & password are CaSe SenSitiVe",
// "Important: The old password remains active if you don't click the link above" => "Important: The old password remains active if you don't click the link above",
// "Look at this link" => "Look at this link",
// "A friend sends you a link from: " => "A friend sends you a link from: ",
// "A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime}",
// "ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}",
// "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}" => "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}",
// "Download the file at" => "Download the file at",
// "was modified at" => "was modified at",
// "Please visit this link before login again" => "Please visit this link before login again",
// "Last attempt" => "Last attempt",
// "IP" => "IP",
// "Confirm your account at %s" => "Confirm your account at %s",
// "An administrator of the site below has added you as a new user" => "An administrator of the site below has added you as a new user",
// "If you want to confirm your membership in this site, click on the following link to login for the first time" => "If you want to confirm your membership in this site, click on the following link to login for the first time",
// "Your authentication credentials are" => "Your authentication credentials are",
// "Welcome on the site" => "Welcome on the site",
// "Your personal access to" => "Your personal access to",
// "You'll receive email notification once your account is activated" => "You'll receive email notification once your account is activated",
// "Please do not attempt to login until you receive the email notification" => "Please do not attempt to login until you receive the email notification",
// "{\$mail_action} article post" => "{\$mail_action} article post",
// "{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} by {\$mail_user|username} at",
// "New article post" => "New article post",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
// "{\$mail_action} article post at" => "{\$mail_action} article post at",
// "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "New blog post at %s" => "New blog post at %s",
// "View item calendar at" => "View item calendar at",
// "Modified calendar item" => "Modified calendar item",
// "New calendar item" => "New calendar item",
// "changed" => "changed",
// "removed" => "removed",
// "Old" => "Old",
// "updated" => "updated",
// "A file was removed from the file gallery" => "A file was removed from the file gallery",
// "A new file was posted to file gallery" => "A new file was posted to file gallery",
// "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "Image Gallery {\$galleryName} changed" => "Image Gallery {\$galleryName} changed",
// "A new file was posted to image gallery" => "A new file was posted to image gallery",
// "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "You can view the updated map following this link" => "You can view the updated map following this link",
// "You can edit the map following this link" => "You can edit the map following this link",
// "A page has been added to your watched sub-structure" => "A page has been added to your watched sub-structure",
// "A page has been removed from your watched sub-structure" => "A page has been removed from your watched sub-structure",
// "A page has been promoted out your watched sub-structure" => "A page has been promoted out your watched sub-structure",
// "A page has been demoted to your watched structure" => "A page has been demoted to your watched structure",
// "Structure modified" => "Structure modified",
// "A new file have been attached to page" => "A new file have been attached to page",
// "File name" => "File name",
// "New attachment on %s, page" => "New attachment on %s, page",
// "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "A file was attached to {\$mail_page}" => "A file was attached to {\$mail_page}",
// "The page {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "The page {\$mail_page} was deleted but used to be here" => "The page {\$mail_page} was deleted but used to be here",
// "The old page content follows below" => "The old page content follows below",
// "Wiki page %s created by {\$mail_user|username}" => "Wiki page %s created by {\$mail_user|username}",
// "Wiki page %s deleted by {\$mail_user|username}" => "Wiki page %s deleted by {\$mail_user|username}",
// "A file was attached to %s" => "A file was attached to %s",
// "Wiki page %s changed by {\$mail_user|username}" => "Wiki page %s changed by {\$mail_user|username}",
// "The page {\$mail_page} was commented by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was commented by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "Wiki page %s was commented on by" => "Wiki page %s was commented on by",
// "an anonymous user" => "an anonymous user",
// "Wiki page renamed" => "Wiki page renamed",
// "Old name" => "Old name",
// "Thank you for your registration" => "Thank you for your registration",
// "click on the map to zoom or pan, do not drag" => "click on the map to zoom or pan, do not drag",
// "Query Results" => "Query Results",
// "Querying" => "Querying",
// "Scroll Up" => "Scroll Up",
// "Scroll Down" => "Scroll Down",
// "Zoom out" => "Zoom out",
// "Pan" => "Pan",
// "Zoom in" => "Zoom in",
// "select zoom/pan/query and image size" => "select zoom/pan/query and image size",
// "View the Map Only" => "View the Map Only",
// "Reset Map" => "Reset Map",
// "Layer" => "Layer",
// "This layer has been set by the maps administrator to not be downloadable" => "This layer has been set by the maps administrator to not be downloadable",
// "from the mapfile" => "from the mapfile",
// "hits last 7 days" => "hits last 7 days",
// "Zoom out x2" => "Zoom out x2",
// "Zoom in x2" => "Zoom in x2",
// "Mapfile History" => "Mapfile History",
// "c=compare" => "c=compare",
// "d=diff" => "d=diff",
// "Older Version" => "Older Version",
// "back to" => "back to",
// "Confirmation" => "Confirmation",
// "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences" => "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences",
// "ERROR" => "ERROR",
// "Multiple addresses can be separated with semicolons (\\\";\\\")" => "Multiple addresses can be separated with semicolons (\\\";\\\")",
// "or commas (\\\",\\\")" => "or commas (\\\",\\\")",
// "CC" => "CC",
// "BCC" => "BCC",
// "The user will be able to reply to you directly via email" => "The user will be able to reply to you directly via email",
// "You will be sent a copy of this email" => "You will be sent a copy of this email",
// "No messages to download" => "No messages to download",
// "Unflag" => "Unflag",
// "Cc" => "Cc",
// "'name' parameter for tikimodule missed" => "'name' parameter for tikimodule missed",
// "opp side" => "opp side",
// "Unassign this module" => "Unassign this module",
// "Are you sure you want to unassign this module" => "Are you sure you want to unassign this module",
// "Toggle module contents" => "Toggle module contents",
// "Toggle Vertically" => "Toggle Vertically",
// "Display type unknown, you have to enter the banner type" => "Display type unknown, you have to enter the banner type",
// "To configure your Tiki" => "To configure your Tiki",
// "Admin Home" => "Admin Home",
// "from the menu" => "from the menu",
// "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>",
// "Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies",
// "To remove this module" => "To remove this module",
// "and remove the assistant module" => "and remove the assistant module",
// "You can also add other modules" => "You can also add other modules",
// "To customize the menu" => "To customize the menu",
// "and edit menu ID 42" => "and edit menu ID 42",
// "Or, create your own menu and add it to a module" => "Or, create your own menu and add it to a module",
// "To begin configuring Tiki, please" => "To begin configuring Tiki, please",
// "as admin" => "as admin",
// "The Tikiwiki Community" => "The Tikiwiki Community",
// "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tiki.org</a>" => "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tiki.org</a>",
// "Tikiwiki Documentation" => "Tikiwiki Documentation",
// "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>",
// "Published on" => "Published on",
// "on blogpost" => "on blogpost",
// "Untitled" => "Untitled",
// "Unit cost" => "Unit cost",
// "Qty" => "Qty",
// "Check-out" => "Check-out",
// "Missing %0 of the following categories" => "Missing %0 of the following categories",
// "%0 extra of the following categories" => "%0 extra of the following categories",
// "Unknown comparison" => "Unknown comparison",
// "Impossible condition, %0 of" => "Impossible condition, %0 of",
// "Assign into category" => "Assign into category",
// "Unassign category" => "Unassign category",
// "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes",
// "Add tags" => "Add tags",
// "List everything tagged" => "List everything tagged",
// "Emulated Groups" => "Emulated Groups",
// "insert original" => "insert original",
// "insert thumbnail" => "insert thumbnail",
// "Last `\$module_rows` Podcasts" => "Last `\$module_rows` Podcasts",
// "This is likely not a podcast file" => "This is likely not a podcast file",
// "The path to a podcast player is required" => "The path to a podcast player is required",
// "No avatar" => "No avatar",
// "Log in" => "Log in",
// "Enter user name and click 'Switch'.<br />Useful for testing permissions" => "Enter user name and click 'Switch'.<br />Useful for testing permissions",
// "Log in through CAS" => "Log in through CAS",
// "Log in as admin" => "Log in as admin",
// "Log in through Shibboleth" => "Log in through Shibboleth",
// "Log in as" => "Log in as",
// "Invalid password" => "Invalid password",
// "CapsLock is on" => "CapsLock is on",
// "Click here to register" => "Click here to register",
// "Click here if you've forgotten your password" => "Click here if you've forgotten your password",
// "Click here to login using the default security protocol" => "Click here to login using the default security protocol",
// "Click here to login using a secure protocol" => "Click here to login using a secure protocol",
// "local account" => "local account",
// "OpenID Log in" => "OpenID Log in",
// "What is OpenID" => "What is OpenID",
// "Stay on this page" => "Stay on this page",
// "Edit perspectives" => "Edit perspectives",
// "Description (used for metatags)" => "Description (used for metatags)",
// "Paste content here" => "Paste content here",
// "Wiki feed" => "Wiki feed",
// "Feed" => "Feed",
// "Blogs feed" => "Blogs feed",
// "Articles feed" => "Articles feed",
// "Image Galleries feed" => "Image Galleries feed",
// "File Galleries feed" => "File Galleries feed",
// "Forums feed" => "Forums feed",
// "Maps feed" => "Maps feed",
// "Search Help" => "Search Help",
// "Search for text throughout the site" => "Search for text throughout the site",
// "Go directly to a page, or search in page titles if exact match is not found" => "Go directly to a page, or search in page titles if exact match is not found",
// "Edit existing page or create a new one" => "Edit existing page or create a new one",
// "Page Relations" => "Page Relations",
// "Are you sure you want to delete this shout" => "Are you sure you want to delete this shout",
// "Tweet with twitter" => "Tweet with twitter",
// "Post on my facebook wall" => "Post on my facebook wall",
// "Shout date" => "Shout date",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
// "New Tracker Items" => "New Tracker Items",
// "New Calendar Events" => "New Calendar Events",
// "including" => "including",
// "`\$module_params.prefix`" => "`\$module_params.prefix`",
// "Posted to" => "Posted to",
// "(Read More)" => "(Read More)",
// "Tracker name" => "Tracker name",
// "There are no translations of this page" => "There are no translations of this page",
// "Up-to-date-ness" => "Up-to-date-ness",
// "To <strong>continue translating</strong>, select the language to translate from" => "To <strong>continue translating</strong>, select the language to translate from",
// "update from it" => "update from it",
// "update it" => "update it",
// "click to view" => "click to view",
// "Cache" => "Cache",
// "Group information" => "Group information",
// "Webmail inbox" => "Webmail inbox",
// "Refresh (non-ajax)" => "Refresh (non-ajax)",
// "TAKE" => "TAKE",
// "View contact" => "View contact",
// "on host" => "on host",
// "User does not accept messages" => "User does not accept messages",
// "Send a message" => "Send a message",
// "More Videos" => "More Videos",
// "No individual permissions, category permissions apply" => "No individual permissions, category permissions apply",
// "Old Session" => "Old Session",
// "Old Version" => "Old Version",
// "New Session" => "New Session",
// "New Version" => "New Version",
// "[-]" => "[-]",
// "{\$customfields[ir].label}" => "{\$customfields[ir].label}",
// "Use your email as login" => "Use your email as login",
// "Minimum {\$prefs.min_username_length} characters long" => "Minimum {\$prefs.min_username_length} characters long",
// "Lowercase only" => "Lowercase only",
// "Minimum {\$prefs.min_pass_length} characters long" => "Minimum {\$prefs.min_pass_length} characters long",
// "Passcode to register" => "Passcode to register",
// "Not your password" => "Not your password",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "Download Log File" => "Download Log File",
// "absE" => "absE",
// "Design by" => "Design by",
// "Jump to Content" => "Jump to Content",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Show/Hide Left Menus" => "Show/Hide Left Menus",
// "Show/Hide Right Menus" => "Show/Hide Right Menus",
// "Module errors" => "Module errors",
// "The following modules could not be loaded" => "The following modules could not be loaded",
// "Preference was not set" => "Preference was not set",
// "Report to Webmaster" => "Report to Webmaster",
// "Powered by" => "Powered by",
// "Wiki RSS" => "Wiki RSS",
// "Blogs RSS" => "Blogs RSS",
// "The Tiki Community" => "The Tiki Community",
// "Login through CAS" => "Login through CAS",
// "Login through Shibboleth" => "Login through Shibboleth",
// "Designed originally by" => "Designed originally by",
// "Group by item" => "Group by item",
// "Note: The search index needs rebuilding, this will take a few minutes" => "Note: The search index needs rebuilding, this will take a few minutes",
// "Search error" => "Search error",
// "Preferences Search Results" => "Preferences Search Results",
// "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>" => "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>",
// "Changed" => "Changed",
// "TikiCache/System" => "TikiCache/System",
// "Mods" => "Mods",
// "Cookies" => "Cookies",
// "DSN" => "DSN",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "See Statistics" => "See Statistics",
// "Pagination" => "Pagination",
// "contributor" => "contributor",
// "Edit Action" => "Edit Action",
// "Save Action" => "Save Action",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volumen per category" => "Volumen per category",
// "Volumn per category and per user" => "Volumn per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Total number of users" => "Total number of users",
// "Number of actions per object" => "Number of actions per object",
// "Total number of objects" => "Total number of objects",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volume per the users'group and per contribution" => "Volume per the users'group and per contribution",
// "Volume per group and per contribution" => "Volume per group and per contribution",
// "Volume per user and per contribution" => "Volume per user and per contribution",
// "Volume per users' contribution and time" => "Volume per users' contribution and time",
// "Volumn per contribution and time" => "Volumn per contribution and time",
// "Recorded" => "Recorded",
// "Reported" => "Reported",
// "Add or edit rules" => "Add or edit rules",
// "Multiple IP regex matching" => "Multiple IP regex matching",
// "Perso" => "Perso",
// "Custom Classifications" => "Custom Classifications",
// "Green" => "Green",
// "Blue" => "Blue",
// "Purple" => "Purple",
// "Red" => "Red",
// "Orange" => "Orange",
// "Yellow" => "Yellow",
// "Browse the category system" => "Browse the category system",
// "Remove from this Category" => "Remove from this Category",
// "File gal" => "File gal",
// "Use the Administration page of each enabled feature to allow the use of content templates" => "Use the Administration page of each enabled feature to allow the use of content templates",
// "Name field is mandatory" => "Name field is mandatory",
// "Use in" => "Use in",
// "No features are configured to use templates" => "No features are configured to use templates",
// "Template Type" => "Template Type",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
// "Edit the contribution" => "Edit the contribution",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
// "Manage Credits" => "Manage Credits",
// "(YYYY-MM-DD HH:MM:SS)" => "(YYYY-MM-DD HH:MM:SS)",
// "Used" => "Used",
// "(level credits always 0)" => "(level credits always 0)",
// "Delete Checked" => "Delete Checked",
// "User Credits Expiry Summary (Plans)" => "User Credits Expiry Summary (Plans)",
// "User Plan" => "User Plan",
// "Start of Latest Plan" => "Start of Latest Plan",
// "Start of Next Plan" => "Start of Next Plan",
// "Expiry" => "Expiry",
// "Use User Credits" => "Use User Credits",
// "Amount" => "Amount",
// "Restore User Level Credits" => "Restore User Level Credits",
// "Restore" => "Restore",
// "Historical Usage Report" => "Historical Usage Report",
// "Usage Date" => "Usage Date",
// "Amount Used" => "Amount Used",
// "Manage Credit Types" => "Manage Credit Types",
// "Display Text" => "Display Text",
// "Unit Text" => "Unit Text",
// "Is Static Level Credit" => "Is Static Level Credit",
// "Display Bar Length Scaling Divisor" => "Display Bar Length Scaling Divisor",
// "Purge Expired and Used Credits (All Users)" => "Purge Expired and Used Credits (All Users)",
// "Purge" => "Purge",
// "Use Admin DSN to define the database to be used by the SQL plugin" => "Use Admin DSN to define the database to be used by the SQL plugin",
// "Create/edit DSN" => "Create/edit DSN",
// "Local (Tiki database)" => "Local (Tiki database)",
// "See db/local.php" => "See db/local.php",
// "Admin External Wikis" => "Admin External Wikis",
// "ExtWiki" => "ExtWiki",
// ".." => "..",
// "Online" => "Online",
// "Set thread preferences" => "Set thread preferences",
// "Show threads preferences" => "Show threads preferences",
// "hide threads preferences" => "hide threads preferences",
// "Default style for threads" => "Default style for threads",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
// "Admin dynamic zones" => "Admin dynamic zones",
// "Global site configuration, date formats, admin password etc" => "Global site configuration, date formats, admin password etc",
// "Switches for major features" => "Switches for major features",
// "User registration, remember me cookie settings and authentication methods" => "User registration, remember me cookie settings and authentication methods",
// "User specific features and settings" => "User specific features and settings",
// "Repository configuration, browse and apply profiles" => "Repository configuration, browse and apply profiles",
// "Theme selection, layout settings and UI effect controls" => "Theme selection, layout settings and UI effect controls",
// "i18n" => "i18n",
// "Internationalization and localization - mulitlingual features" => "Internationalization and localization - mulitlingual features",
// "Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Text editing settings applicable to many areas. Plugin activation and plugin alias management",
// "Module appearance settings" => "Module appearance settings",
// "Information to include in the header of each page" => "Information to include in the header of each page",
// "Performance" => "Performance",
// "Server performance settings" => "Server performance settings",
// "Site security settings" => "Site security settings",
// "Comments settings" => "Comments settings",
// "Feeds" => "Feeds",
// "Web feeds" => "Web feeds",
// "Defaults and configuration for file galleries" => "Defaults and configuration for file galleries",
// "Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Defaults and configuration for image galleries (will be phased out in favour of file galleries)",
// "Values of actions for users rank score" => "Values of actions for users rank score",
// "Defaults and API key for Google Maps" => "Defaults and API key for Google Maps",
// "Site-wide copyright information" => "Site-wide copyright information",
// "Options for WYSIWYG editor" => "Options for WYSIWYG editor",
// "?" => "?",
// "InterTiki" => "InterTiki",
// "Set up links between Tiki servers" => "Set up links between Tiki servers",
// "Manage semantic wiki links" => "Manage semantic wiki links",
// "Webservices" => "Webservices",
// "Register and manage web services" => "Register and manage web services",
// "Sef URL" => "Sef URL",
// "Search Engine Friendly URLs" => "Search Engine Friendly URLs",
// "Video" => "Video",
// "Video integration configuration" => "Video integration configuration",
// "Configure social networks integration" => "Configure social networks integration",
// "Create calendar" => "Create calendar",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
// "Plugins" => "Plugins",
// "Inline comments" => "Inline comments",
// "The feature below must be activated for this feature to work" => "The feature below must be activated for this feature to work",
// "User messages" => "User messages",
// "Help Tiki spread" => "Help Tiki spread",
// "Additional" => "Additional",
// "Interface" => "Interface",
// "AJAX" => "AJAX",
// "Score is disabled" => "Score is disabled",
// "Enable now" => "Enable now",
// "Upload Regex" => "Upload Regex",
// "Threads" => "Threads",
// "Display image information in a mouseover box" => "Display image information in a mouseover box",
// "yes, and don't display that information under the image" => "yes, and don't display that information under the image",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
// "Pixels Default" => "Pixels Default",
// "Default scale size" => "Default scale size",
// "Exterminator" => "Exterminator",
// "Move images from database storage to filesystem storage" => "Move images from database storage to filesystem storage",
// "Move images from old filesystem store to new directory" => "Move images from old filesystem store to new directory",
// "Moved" => "Moved",
// "These values will be stored in plain text in the database" => "These values will be stored in plain text in the database",
// "Syntax error" => "Syntax error",
// "Cannot open/write this file" => "Cannot open/write this file",
// "Custom translation will not be saved. Ask your administration to change the permission" => "Custom translation will not be saved. Ask your administration to change the permission",
// "The file has been saved" => "The file has been saved",
// "Import user preferences" => "Import user preferences",
// "Import user groups" => "Import user groups",
// "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
// "InterTiki Server" => "InterTiki Server",
// "host" => "host",
// "Errors Log file" => "Errors Log file",
// "Look & Feel" => "Look & Feel",
// "Wysiwyg" => "Wysiwyg",
// "Video streaming integration" => "Video streaming integration",
// "Social Networks" => "Social Networks",
// "Requires PHP GD library" => "Requires PHP GD library",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Assign users to group function of email pattern" => "Assign users to group function of email pattern",
// "LDAP" => "LDAP",
// "LDAP Bind settings" => "LDAP Bind settings",
// "LDAP User" => "LDAP User",
// "LDAP Group" => "LDAP Group",
// "LDAP Group Member - if group membership can be found in group attributes" => "LDAP Group Member - if group membership can be found in group attributes",
// "LDAP User Group - if group membership can be found in user attributes" => "LDAP User Group - if group membership can be found in user attributes",
// "LDAP Admin" => "LDAP Admin",
// "PAM" => "PAM",
// "Shibboleth Authentication " => "Shibboleth Authentication ",
// "CAS" => "CAS",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "CAS Server" => "CAS Server",
// "CAS Server Name" => "CAS Server Name",
// "CAS Server Port" => "CAS Server Port",
// "CAS Server Path" => "CAS Server Path",
// "phpBB User Database Authentication " => "phpBB User Database Authentication ",
// "Web Server Authentication " => "Web Server Authentication ",
// "The \"users can change theme\" feature will override the theme displayed" => "The \"users can change theme\" feature will override the theme displayed",
// "Theme not saved yet - click \"Apply\"" => "Theme not saved yet - click \"Apply\"",
// "Theme Screenshot" => "Theme Screenshot",
// "View Templates" => "View Templates",
// "Site Report Bar" => "Site Report Bar",
// "Favicon" => "Favicon",
// "Meta tags" => "Meta tags",
// "Geo URL" => "Geo URL",
// "Robots" => "Robots",
// "Configure metrics" => "Configure metrics",
// "Show past results" => "Show past results",
// "Past results count" => "Past results count",
// "Hint: If you lose your login module, use tiki-login_scr.php to be able to login" => "Hint: If you lose your login module, use tiki-login_scr.php to be able to login",
// "You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "You can use only one payment method: PayPal or Cclite or Tiki User Credits",
// "sourceforge.net" => "sourceforge.net",
// "Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite is for creating and managing alternative or complementary trading currencies and groups",
// "Work in progress for Tiki 6" => "Work in progress for Tiki 6",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "Bytecode Cache" => "Bytecode Cache",
// "Using <strong>%0</strong>.These stats affect all PHP applications running on the server" => "Using <strong>%0</strong>.These stats affect all PHP applications running on the server",
// "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache",
// "Available" => "Available",
// "Miss" => "Miss",
// "Cache Hits" => "Cache Hits",
// "Few hits recorded. Statistics may not be representative" => "Few hits recorded. Statistics may not be representative",
// "Low hit ratio. %0 may be misconfigured and not used" => "Low hit ratio. %0 may be misconfigured and not used",
// "Little memory available. Thrashing likely to occur" => "Little memory available. Thrashing likely to occur",
// "Small amount of memory allocated to %0. Verify the configuration" => "Small amount of memory allocated to %0. Verify the configuration",
// "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates" => "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates",
// "<em>%0</em> should not be disabled due to authentication on XCache" => "<em>%0</em> should not be disabled due to authentication on XCache",
// "Bytecode cache is not used. Using a bytecode cache (APC, XCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (APC, XCache) is highly recommended for production environments",
// "Major slow down" => "Major slow down",
// "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>",
// "Sessions" => "Sessions",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Loading profile" => "Loading profile",
// "Are you sure you want to apply the profile" => "Are you sure you want to apply the profile",
// "Are you sure you want to re-apply the profile" => "Are you sure you want to re-apply the profile",
// "Sending" => "Sending",
// "Tiki Profiles" => "Tiki Profiles",
// "A Friendly Warning" => "A Friendly Warning",
// "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles",
// "Option 1: Quick Filter" => "Option 1: Quick Filter",
// "Option 2: Manual Filter" => "Option 2: Manual Filter",
// "Filter the list of profiles" => "Filter the list of profiles",
// "Profile" => "Profile",
// "Repository" => "Repository",
// "applied" => "applied",
// "Profile repository" => "Profile repository",
// "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again" => "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again",
// "Repositories" => "Repositories",
// "Repository URLs" => "Repository URLs",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data Channels" => "Data Channels",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. " => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. ",
// "More information" => "More information",
// "Profile tester" => "Profile tester",
// "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below",
// "This will run the profile and make potentially unrecoverable changes in your database" => "This will run the profile and make potentially unrecoverable changes in your database",
// "Test Profile Name" => "Test Profile Name",
// "Cache duration" => "Cache duration",
// "Feed for articles" => "Feed for articles",
// "Feed for blogs" => "Feed for blogs",
// "Feed for individual blogs" => "Feed for individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Feed for individual image galleries" => "Feed for individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Feed for maps" => "Feed for maps",
// "Feed for shoutbox" => "Feed for shoutbox",
// "can be seen on page" => "can be seen on page",
// "in Admin menu" => "in Admin menu",
// "Search type" => "Search type",
// "Specify the Tiki search settings" => "Specify the Tiki search settings",
// "The Tiki search indexes must be refreshed if you turn the Tiki search on" => "The Tiki search indexes must be refreshed if you turn the Tiki search on",
// "Refresh all search index now" => "Refresh all search index now",
// "Refresh trackers search index now" => "Refresh trackers search index now",
// "Refresh tracker search index now" => "Refresh tracker search index now",
// "Refresh files search index now" => "Refresh files search index now",
// "Enabling these options will improve performance, but may show forbidden results" => "Enabling these options will improve performance, but may show forbidden results",
// "Search Results" => "Search Results",
// "Select the items to display on the search results page" => "Select the items to display on the search results page",
// "Select the information to display for each result" => "Select the information to display for each result",
// "General Security" => "General Security",
// "Please also see" => "Please also see",
// "HTTPS (SSL) and other login preferences" => "HTTPS (SSL) and other login preferences",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "Captcha" => "Captcha",
// "Tokens" => "Tokens",
// "Clipperz online password management" => "Clipperz online password management",
// "Tiki doesn't offer a built-in password management feature" => "Tiki doesn't offer a built-in password management feature",
// "Learn more about Clipperz" => "Learn more about Clipperz",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Known Types" => "Known Types",
// "Token" => "Token",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "New Types" => "New Types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "Twitter Settings" => "Twitter Settings",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL",
// "Facebook Settings" => "Facebook Settings",
// "To use Facebook integration, you must register this site as an application at" => "To use Facebook integration, you must register this site as an application at",
// "and allow extended access for the application" => "and allow extended access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain",
// "bit.ly Settings" => "bit.ly Settings",
// "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics",
// "to sign up for an account" => "to sign up for an account",
// "to retrieve the API key" => "to retrieve the API key",
// "Disabled used plugins" => "Disabled used plugins",
// "Plugin Aliases" => "Plugin Aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Available Alias" => "Available Alias",
// "Enable Plugins" => "Enable Plugins",
// "Delete Plugins" => "Delete Plugins",
// "Click on the plugin name to edit it" => "Click on the plugin name to edit it",
// "Click on the + icon to add a new one" => "Click on the + icon to add a new one",
// "Plugin Name" => "Plugin Name",
// "Inline (No Plugin Edit UI)" => "Inline (No Plugin Edit UI)",
// "Simple Plugin Arguments" => "Simple Plugin Arguments",
// "Argument" => "Argument",
// "New Argument" => "New Argument",
// "Safe" => "Safe",
// "Plugin Body" => "Plugin Body",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Default Value" => "Default Value",
// "Composed Plugin Arguments" => "Composed Plugin Arguments",
// "Pattern" => "Pattern",
// "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"" => "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"",
// "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)" => "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)",
// "Flash Media Encoder" => "Flash Media Encoder",
// "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication" => "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Register Template" => "Register Template",
// "If you change storage, it is better to move all the files for easy backup.." => "If you change storage, it is better to move all the files for easy backup..",
// "Wiki watch" => "Wiki watch",
// "Freetags are disabled" => "Freetags are disabled",
// "Human-readable repository name" => "Human-readable repository name",
// "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')",
// "File name of start page" => "File name of start page",
// "CSS file to load when browse this repository" => "CSS file to load when browse this repository",
// "Is repository visible to users" => "Is repository visible to users",
// "Can files from repository be cached" => "Can files from repository be cached",
// "Are files from repository can be cached" => "Are files from repository can be cached",
// "Clear all cached pages of this repository" => "Clear all cached pages of this repository",
// "Seconds count 'till cached page will be expired" => "Seconds count 'till cached page will be expired",
// "Human-readable text description of repository" => "Human-readable text description of repository",
// "view/hide copy rules dialog" => "view/hide copy rules dialog",
// "Source repository" => "Source repository",
// "According this order rules will be applied ('0' or empty = auto)" => "According this order rules will be applied ('0' or empty = auto)",
// "Is this regular expression or simple search/replacer" => "Is this regular expression or simple search/replacer",
// "Regex" => "Regex",
// "Is case sensitive (for simple replacer)" => "Is case sensitive (for simple replacer)",
// "subset of chars: imsxeADSXUu, which is regex modifiers" => "subset of chars: imsxeADSXUu, which is regex modifiers",
// "Regex modifiers" => "Regex modifiers",
// "Human-readable text description of rule" => "Human-readable text description of rule",
// "Check to enable this rule" => "Check to enable this rule",
// "Apply all rules or just this to generate preview" => "Apply all rules or just this to generate preview",
// "View source code after rules applied" => "View source code after rules applied",
// "Test file from repository to generate preview for (empty = configured start page)" => "Test file from repository to generate preview for (empty = configured start page)",
// "Case" => "Case",
// "Admin keywords" => "Admin keywords",
// "Keywords have been updated" => "Keywords have been updated",
// "Updating keywords has failed. Page probably doesn't exist" => "Updating keywords has failed. Page probably doesn't exist",
// "Edit page keywords" => "Edit page keywords",
// "Current Page Keywords" => "Current Page Keywords",
// "Search by page" => "Search by page",
// "results found" => "results found",
// "Position" => "Position",
// "Account" => "Account",
// "article-put" => "article-put",
// "wiki-get" => "wiki-get",
// "wiki-put" => "wiki-put",
// "wiki-append" => "wiki-append",
// "Discard to the end from" => "Discard to the end from",
// "mn" => "mn",
// "Manage menu" => "Manage menu",
// "For wiki page, use ((PageName))" => "For wiki page, use ((PageName))",
// "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed",
// "section level 0" => "section level 0",
// "section level 1" => "section level 1",
// "section level 2" => "section level 2",
// "section level 3" => "section level 3",
// "sorted section level 0" => "sorted section level 0",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "Import/export menu" => "Import/export menu",
// "Export CSV data" => "Export CSV data",
// "Import CSV data" => "Import CSV data",
// "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'",
// "Active Permissions" => "Active Permissions",
// "Icons" => "Icons",
// "Configure icons for menu entries" => "Configure icons for menu entries",
// "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu",
// "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes" => "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes",
// "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tiki.org\">themes</a>" => "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tiki.org\">themes</a>",
// "Admin Metrics" => "Admin Metrics",
// "Admin Metrics Template" => "Admin Metrics Template",
// "Metrics" => "Metrics",
// "Assign Metrics" => "Assign Metrics",
// "Assigned Metrics" => "Assigned Metrics",
// "Edit/Create Metrics" => "Edit/Create Metrics",
// "Edit/Create Tab" => "Edit/Create Tab",
// "Data Type" => "Data Type",
// "Weight" => "Weight",
// "Metric Name" => "Metric Name",
// "Tab Name" => "Tab Name",
// "Assign metric" => "Assign metric",
// "Edit this assigned metric" => "Edit this assigned metric",
// "Tab for metric" => "Tab for metric",
// "Create new metric" => "Create new metric",
// "Edit this metric" => "Edit this metric",
// "Hints" => "Hints",
// "For list-based metrics, include the \"LIMIT #\" in your query" => "For list-based metrics, include the \"LIMIT #\" in your query",
// "Name (must be unique)" => "Name (must be unique)",
// "Create new tab" => "Create new tab",
// "Edit this tab" => "Edit this tab",
// "Weight (must be integer)" => "Weight (must be integer)",
// "Move Up" => "Move Up",
// "Move Down" => "Move Down",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "The" => "The",
// "Display Modules to All Groups" => "Display Modules to All Groups",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
// "Use CSS menu" => "Use CSS menu",
// "PHP Layers menus" => "PHP Layers menus",
// "Use Wiki Structure" => "Use Wiki Structure",
// "To use a <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">PHP Layers menu</a>, use one of these syntaxes (Note: PHP Layers menus are being replaced by CSS menus and may have only basic styling in newer themes.)" => "To use a <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">PHP Layers menu</a>, use one of these syntaxes (Note: PHP Layers menus are being replaced by CSS menus and may have only basic styling in newer themes.)",
// "Edit Newsletter" => "Edit Newsletter",
// "Wiki Page Name" => "Wiki Page Name",
// "Validate Addresses" => "Validate Addresses",
// "Add To List" => "Add To List",
// "Unsubscribed" => "Unsubscribed",
// "Including group, group users and emails will be refreshed at each newsletter sending" => "Including group, group users and emails will be refreshed at each newsletter sending",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
// "Alert" => "Alert",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
// "Option" => "Option",
// "Edit poll" => "Edit poll",
// "Tips" => "Tips",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
// "Use Article Submission System" => "Use Article Submission System",
// "Edit this feed" => "Edit this feed",
// "owner" => "owner",
// "special" => "special",
// "other" => "other",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
// "XML Zip Import" => "XML Zip Import",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict",
// "The following pages have automatically been categorized with the same categories as the structure" => "The following pages have automatically been categorized with the same categories as the structure",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent",
// "Edit structure" => "Edit structure",
// "PDF" => "PDF",
// "Create WebHelp" => "Create WebHelp",
// "View WebHelp" => "View WebHelp",
// "Alias" => "Alias",
// "This survey stats" => "This survey stats",
// "Edit Survey Question" => "Edit Survey Question",
// "Multiple choices of thumbnails from a file gallery" => "Multiple choices of thumbnails from a file gallery",
// "Wiki textarea" => "Wiki textarea",
// "Answer is mandatory" => "Answer is mandatory",
// "Number of required answers (for multiple choices)" => "Number of required answers (for multiple choices)",
// "For a rate, you can give the maximum value" => "For a rate, you can give the maximum value",
// "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4",
// "For the 'wiki textarea' type, options are: rows,columns. Example: 10,60" => "For the 'wiki textarea' type, options are: rows,columns. Example: 10,60",
// "Tiki Cache/System Admin" => "Tiki Cache/System Admin",
// "Directory to exterminate" => "Directory to exterminate",
// "A zip has been written to {\$zipPath}" => "A zip has been written to {\$zipPath}",
// "Directory is not writeable" => "Directory is not writeable",
// "Reset to Global" => "Reset to Global",
// "Reset to defaults" => "Reset to defaults",
// "Edit tool" => "Edit tool",
// "Wysiwyg Token" => "Wysiwyg Token",
// "Plugin name" => "Plugin name",
// "Add a new custom tool" => "Add a new custom tool",
// "Position of field in list" => "Position of field in list",
// "Is mandatory/required" => "Is mandatory/required",
// "Req" => "Req",
// "Multi-lingual" => "Multi-lingual",
// "Is column searchable" => "Is column searchable",
// "Field is public? (viewed in trackerlist plugin)" => "Field is public? (viewed in trackerlist plugin)",
// "Descr" => "Descr",
// "Select list items that will be displayed" => "Select list items that will be displayed",
// "Validation parameter" => "Validation parameter",
// "Validation error message" => "Validation error message",
// "Important note" => "Important note",
// "The first field in the tracker to have column links to edit/view item (i.e. isMain) will be what is shown as the name of the item in category and search listings" => "The first field in the tracker to have column links to edit/view item (i.e. isMain) will be what is shown as the name of the item in category and search listings",
// "Multilingual content" => "Multilingual content",
// "Field is hidden" => "Field is hidden",
// "editable by admin only" => "editable by admin only",
// "visible by creator &amp; admin only" => "visible by creator &amp; admin only",
// "The option creator needs a field of type user selector and option 1" => "The option creator needs a field of type user selector and option 1",
// "Visible by" => "Visible by",
// "Editable by" => "Editable by",
// "Error message" => "Error message",
// "Export fieldId also" => "Export fieldId also",
// "Check the box to re-import in this tracker and change the fields" => "Check the box to re-import in this tracker and change the fields",
// "Uncheck the box to import in another database" => "Uncheck the box to import in another database",
// "Edit Tracker" => "Edit Tracker",
// "Create a group for each item" => "Create a group for each item",
// "Groups will include" => "Groups will include",
// "Creator is assigned to the group" => "Creator is assigned to the group",
// "and it becomes his default group" => "and it becomes his default group",
// "and it becomes the new item group creator" => "and it becomes the new item group creator",
// "But copy the default group in this fiedlId before updating the group" => "But copy the default group in this fiedlId before updating the group",
// "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender",
// "Format if not the default short one" => "Format if not the default short one",
// "Identify creation user in tracker item" => "Identify creation user in tracker item",
// "Identify lastModif user in tracker item" => "Identify lastModif user in tracker item",
// "and display last comment user/date" => "and display last comment user/date",
// "Status changes list" => "Status changes list",
// "Delay" => "Delay",
// "Delete todo" => "Delete todo",
// "Date Format" => "Date Format",
// "timestamp" => "timestamp",
// "UTF-8" => "UTF-8",
// "ISO-8859-1" => "ISO-8859-1",
// "Add as new items" => "Add as new items",
// "The order of the fields does not matter, but you need to add a header with the field names" => "The order of the fields does not matter, but you need to add a header with the field names",
// "Add \" -- \" to the end of the fields in the header that you would like to import" => "Add \" -- \" to the end of the fields in the header that you would like to import",
// "Auto-incremented itemid fields shall be included with no matter what values" => "Auto-incremented itemid fields shall be included with no matter what values",
// "Subset Selection" => "Subset Selection",
// "Category Selection" => "Category Selection",
// "Group Selection" => "Group Selection",
// "Type in a group name and click \"enter\"" => "Type in a group name and click \"enter\"",
// "Once you have selected at least two, click" => "Once you have selected at least two, click",
// "and then, click the \"New/Edit\" tab which will appear above" => "and then, click the \"New/Edit\" tab which will appear above",
// "Draw Transition Diagram" => "Draw Transition Diagram",
// "Guards" => "Guards",
// "preserved" => "preserved",
// "Assign permissions for transition" => "Assign permissions for transition",
// "No transitions" => "No transitions",
// "New / Edit" => "New / Edit",
// "Edit <em>%0</em>" => "Edit <em>%0</em>",
// "New transition" => "New transition",
// "Upon trigger, preserve the initial state" => "Upon trigger, preserve the initial state",
// "Count" => "Count",
// "No guards on this transition" => "No guards on this transition",
// "New Guard" => "New Guard",
// "Exactly" => "Exactly",
// "At Least" => "At Least",
// "At Most" => "At Most",
// "States" => "States",
// "Invitation List" => "Invitation List",
// "Homepage" => "Homepage",
// "User Choice" => "User Choice",
// "Group Homepage or Url" => "Group Homepage or Url",
// "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)" => "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)",
// "Group Theme" => "Group Theme",
// "Use site default" => "Use site default",
// "Group Information Tracker" => "Group Information Tracker",
// "choose a group tracker .." => "choose a group tracker ..",
// "choose a field .." => "choose a field ..",
// "Users Information Tracker" => "Users Information Tracker",
// "choose a users tracker .." => "choose a users tracker ..",
// "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)",
// "Group tracker item : {\$groupitemid}" => "Group tracker item : {\$groupitemid}",
// "Group tracker item not found" => "Group tracker item not found",
// "Create Item" => "Create Item",
// "Choose a field .." => "Choose a field ..",
// "Remove from Group" => "Remove from Group",
// "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login",
// "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login",
// "Updated users" => "Updated users",
// "OpenID" => "OpenID",
// "N" => "N",
// "ago" => "ago",
// "Need to validate email" => "Need to validate email",
// "Assign to group" => "Assign to group",
// "Edit Included Group" => "Edit Included Group",
// "Edit Group" => "Edit Group",
// "Validate user" => "Validate user",
// "Confirm user email" => "Confirm user email",
// "Remove Users and their Userpages" => "Remove Users and their Userpages",
// "Send a wiki page by Email" => "Send a wiki page by Email",
// "Template wiki page" => "Template wiki page",
// "Use the email as username" => "Use the email as username",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "No password is required" => "No password is required",
// "Tikiwiki is configured to delegate the password managment to LDAP" => "Tikiwiki is configured to delegate the password managment to LDAP",
// "User tracker item : {\$usersitemid}" => "User tracker item : {\$usersitemid}",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "CSV file layout" => "CSV file layout",
// "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\"group1,group2\",group1" => "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\"group1,group2\",group1",
// "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
// "Loading.." => "Loading..",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
// "Approve page changes in staging" => "Approve page changes in staging",
// "Page has been approved" => "Page has been approved",
// "New attachments" => "New attachments",
// "Old attachments" => "Old attachments",
// "Changes from the following versions under staging have been merged into the approved version" => "Changes from the following versions under staging have been merged into the approved version",
// "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems" => "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems",
// "Click this button to try it now" => "Click this button to try it now",
// "Global object permissions" => "Global object permissions",
// "Level configuration" => "Level configuration",
// "Assign User {\$assign_user|escape} to Groups" => "Assign User {\$assign_user|escape} to Groups",
// "Assign User to Group" => "Assign User to Group",
// "backlinks to" => "backlinks to",
// "No backlinks to this page" => "No backlinks to this page",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Excerpt" => "Excerpt",
// "Tiki Wiki CMS Groupware" => "Tiki Wiki CMS Groupware",
// "Admin the Category System" => "Admin the Category System",
// "Upper level" => "Upper level",
// "Network of Tags related to" => "Network of Tags related to",
// "No result found" => "No result found",
// "result found" => "result found",
// "All Images" => "All Images",
// "RSS" => "RSS",
// "Stop Monitoring this Gallery" => "Stop Monitoring this Gallery",
// "Details" => "Details",
// "You can view this gallery's configured image (first, random, etc.) in your browser using" => "You can view this gallery's configured image (first, random, etc.) in your browser using",
// "You can include the gallery's image in an HTML page using" => "You can include the gallery's image in an HTML page using",
// "You can include the image in a tiki page using" => "You can include the image in a tiki page using",
// "Cyclic" => "Cyclic",
// "Click to zoom" => "Click to zoom",
// "Include the image in a tiki page using the following syntax" => "Include the image in a tiki page using the following syntax",
// "To include the image in an HTML page" => "To include the image in an HTML page",
// "To link to this page from another tiki page" => "To link to this page from another tiki page",
// "Export event" => "Export event",
// "Edit event" => "Edit event",
// "Delete event" => "Delete event",
// "View event" => "View event",
// "Classification" => "Classification",
// "View this Week" => "View this Week",
// "+" => "+",
// "o" => "o",
// "New event" => "New event",
// "Edit/Delete event" => "Edit/Delete event",
// "This event is not recurrent" => "This event is not recurrent",
// "April" => "April",
// "August" => "August",
// "September" => "September",
// "November" => "November",
// "Starting on" => "Starting on",
// "ending by" => "ending by",
// "ending after" => "ending after",
// "events" => "events",
// "Event is repeated" => "Event is repeated",
// "every" => "every",
// "of every month" => "of every month",
// "on each" => "on each",
// "Date and time of end" => "Date and time of end",
// "Events cannot end before they start" => "Events cannot end before they start",
// "No description" => "No description",
// "or new" => "or new",
// "Choose users to alert" => "Choose users to alert",
// "Withdraw me from the list of participants" => "Withdraw me from the list of participants",
// "Add me to the list of participants" => "Add me to the list of participants",
// "Format" => "Format",
// "Participant names separated by comma" => "Participant names separated by comma",
// "chair" => "chair",
// "default role" => "default role",
// "required participant" => "required participant",
// "optional participant" => "optional participant",
// "non participant" => "non participant",
// "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in" => "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
// "Update this event only" => "Update this event only",
// "Update every unchanged events of this recurrence rule" => "Update every unchanged events of this recurrence rule",
// "Update every events of this recurrence rule" => "Update every events of this recurrence rule",
// "Delete Recurrent events" => "Delete Recurrent events",
// "Column names on the first line" => "Column names on the first line",
// "%0 column name can be used instead of %1" => "%0 column name can be used instead of %1",
// "See" => "See",
// "D" => "D",
// "W" => "W",
// "M" => "M",
// "%d/%m" => "%d/%m",
// "Your account has been validated" => "Your account has been validated",
// "You have to choose a password to use this account" => "You have to choose a password to use this account",
// "Send another message" => "Send another message",
// "Publish this contact to groups" => "Publish this contact to groups",
// "Nickname" => "Nickname",
// "Quick Create Multilanguage Pages" => "Quick Create Multilanguage Pages",
// "Following pages were created, as translations of each other" => "Following pages were created, as translations of each other",
// "Following pages were not created" => "Following pages were not created",
// "page already exists" => "page already exists",
// "Enter the names of a new page page in various languages" => "Enter the names of a new page page in various languages",
// "Preferred languages" => "Preferred languages",
// "Other languages" => "Other languages",
// "Create pages" => "Create pages",
// "View generated WebHelp" => "View generated WebHelp",
// "No structure" => "No structure",
// "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>",
// "Edit a site" => "Edit a site",
// "relate" => "relate",
// "Perform action with selected" => "Perform action with selected",
// "in current directory category" => "in current directory category",
// "Discounts" => "Discounts",
// "Max time the discount can be used in the first phase of payment" => "Max time the discount can be used in the first phase of payment",
// "-1 for illimited" => "-1 for illimited",
// "To add <strong>new content</strong> to the page" => "To add <strong>new content</strong> to the page",
// "use the editor" => "use the editor",
// "One of the email addresses you typed is invalid" => "One of the email addresses you typed is invalid",
// "If not the topic image" => "If not the topic image",
// "If different than the uploaded image" => "If different than the uploaded image",
// "If different than in view mode" => "If different than in view mode",
// "If not the topic name" => "If not the topic name",
// "-1 for unlimited" => "-1 for unlimited",
// "Max impressions for a user" => "Max impressions for a user",
// "Max clicks" => "Max clicks",
// "Or, create a new zone" => "Or, create a new zone",
// "Use Flash" => "Use Flash",
// "Movie Size" => "Movie Size",
// "Pixels" => "Pixels",
// "FlashPlugin min version" => "FlashPlugin min version",
// "ex" => "ex",
// "Remove Zones (you lose entered info for the banner)" => "Remove Zones (you lose entered info for the banner)",
// "The checkbox is disabled because feature_freetags is disabled globally" => "The checkbox is disabled because feature_freetags is disabled globally",
// "The file will be saved in" => "The file will be saved in",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "The syntax system used for creating pages in Tiki" => "The syntax system used for creating pages in Tiki",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "page|#anchor" => "page|#anchor",
// "page|#anchor|desc" => "page|#anchor|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
// "col" => "col",
// "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that" => "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that",
// "numeric between ~ for html numeric characters entity" => "numeric between ~ for html numeric characters entity",
// "Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki plugins extend the function of wiki syntax with more specialized commands",
// "Activate/deactivate plugins" => "Activate/deactivate plugins",
// "Spreadsheet Help" => "Spreadsheet Help",
// "jQuery.sheet spreadsheets" => "jQuery.sheet spreadsheets",
// "What is jQuery.sheet" => "What is jQuery.sheet",
// "jQuery.sheet gives you all sorts of possibilities when it comes to giving your web application a spreadsheet style interface with MS Excel style calculations" => "jQuery.sheet gives you all sorts of possibilities when it comes to giving your web application a spreadsheet style interface with MS Excel style calculations",
// "jQuery.sheet manages the sheet creation, viewing, and editing processes.  It can even be used like a datagrid, without calculations.\nFor a complete list of all the MS Excel style functions that jQuery.sheet supports, see below" => "jQuery.sheet manages the sheet creation, viewing, and editing processes.  It can even be used like a datagrid, without calculations.\nFor a complete list of all the MS Excel style functions that jQuery.sheet supports, see below",
// "Wysiwyg Editor" => "Wysiwyg Editor",
// "More help on wysiwyg editing" => "More help on wysiwyg editing",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar",
// "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin",
// "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred" => "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred",
// "Upload from disk to change the image" => "Upload from disk to change the image",
// "Save and Go Next" => "Save and Go Next",
// "Toggle interactive translation on" => "Toggle interactive translation on",
// "Original" => "Original",
// "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory" => "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory",
// "Return to default perspective" => "Return to default perspective",
// "Switch to" => "Switch to",
// "Configurations" => "Configurations",
// "Hint" => "Hint",
// "Search for configurations below and drag them in to the configuration section above" => "Search for configurations below and drag them in to the configuration section above",
// "Edit question options" => "Edit question options",
// "Quiz" => "Quiz",
// "%" => "%",
// "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character" => "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character",
// "Edit quiz results" => "Edit quiz results",
// "You will remove" => "You will remove",
// "and its subpages from the structure, now you have two options" => "and its subpages from the structure, now you have two options",
// "and its subpages from the structure" => "and its subpages from the structure",
// "The page already exists. The page that has been added to the structure is the existing one" => "The page already exists. The page that has been added to the structure is the existing one",
// "The following pages added have automatically been categorized with the same categories as the structure" => "The following pages added have automatically been categorized with the same categories as the structure",
// "Promote" => "Promote",
// "Demote" => "Demote",
// "Categorize all pages in structure together" => "Categorize all pages in structure together",
// "Remove existing categories from ALL pages before recategorizing" => "Remove existing categories from ALL pages before recategorizing",
// "<b>*</b>=optional" => "<b>*</b>=optional",
// "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering" => "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering",
// "This would cause you problems (e.g. menus can stop collapsing/expanding)" => "This would cause you problems (e.g. menus can stop collapsing/expanding)",
// "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)" => "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)",
// "Maybe You just want to modify the top of your Tiki site" => "Maybe You just want to modify the top of your Tiki site",
// "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface" => "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface",
// "Delete the copy in the theme" => "Delete the copy in the theme",
// "Add Notification Email" => "Add Notification Email",
// "Admin notifications" => "Admin notifications",
// "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"",
// "\"The page already exists. It was selected in the list below.\"" => "\"The page already exists. It was selected in the list below.\"",
// "Attach or detach existing translations of this article" => "Attach or detach existing translations of this article",
// "Mark existing article as a translation of this one" => "Mark existing article as a translation of this one",
// "Update '{\$page|escape}'" => "Update '{\$page|escape}'",
// "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval" => "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval",
// "This is a new staging page that has not been approved before" => "This is a new staging page that has not been approved before",
// "The current staging copy may contain changes that have yet to be approved" => "The current staging copy may contain changes that have yet to be approved",
// "View changes since last approval" => "View changes since last approval",
// "You are editing the approved copy of this page" => "You are editing the approved copy of this page",
// "There are currently changes in the staging copy that have yet to be approved" => "There are currently changes in the staging copy that have yet to be approved",
// "Are you sure you do not want to edit" => "Are you sure you do not want to edit",
// "the staging copy" => "the staging copy",
// "Draft written on" => "Draft written on",
// "Warning: new versions of this page have been made after this draft" => "Warning: new versions of this page have been made after this draft",
// "An edit summary is mandatory" => "An edit summary is mandatory",
// "Changes that need to be translated are highlighted below" => "Changes that need to be translated are highlighted below",
// "Select the style used to display differences to be translated" => "Select the style used to display differences to be translated",
// "html" => "html",
// "text full" => "text full",
// "Change the style used to display differences to be translated" => "Change the style used to display differences to be translated",
// "Change diff styles" => "Change diff styles",
// "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>",
// "Reproduce the changes highlighted on the left using the editor below" => "Reproduce the changes highlighted on the left using the editor below",
// "Edit comment: Enter some text to describe the changes you are currently making" => "Edit comment: Enter some text to describe the changes you are currently making",
// "Categorization has been preset for this edit" => "Categorization has been preset for this edit",
// "Categories will be inherited from the structure top page" => "Categories will be inherited from the structure top page",
// "Allow comments on this page" => "Allow comments on this page",
// "Authors' style" => "Authors' style",
// "Send urgent translation request" => "Send urgent translation request",
// "Export to file" => "Export to file",
// "Autodetect" => "Autodetect",
// "itemId" => "itemId",
// "These fields" => "These fields",
// "Number of records" => "Number of records",
// "Zip export with attachments" => "Zip export with attachments",
// "Zip Export" => "Zip Export",
// "Dump All Tracker Items" => "Dump All Tracker Items",
// "Edit FAQ question" => "Edit FAQ question",
// "Add FAQ question" => "Add FAQ question",
// "File Archive" => "File Archive",
// "File Galleries tpl" => "File Galleries tpl",
// "Be careful to set the right permissions on the files you link to" => "Be careful to set the right permissions on the files you link to",
// "Size (width x height)" => "Size (width x height)",
// "Forum Importer" => "Forum Importer",
// "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred",
// "Proceed" => "Proceed",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into" => "Which Forum Do You Wish to Import this Into",
// "Message queue for forum" => "Message queue for forum",
// "Back to forum" => "Back to forum",
// "neutral" => "neutral",
// "Search in content" => "Search in content",
// "Configure Forum" => "Configure Forum",
// "Reported messages for forum" => "Reported messages for forum",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Tag translation" => "Tag translation",
// "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag" => "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag",
// "Until then, they cannot be translated" => "Until then, they cannot be translated",
// "Show checkboxes to clear language information on tags" => "Show checkboxes to clear language information on tags",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
// "Set language" => "Set language",
// "Universal" => "Universal",
// "Show the following languages" => "Show the following languages",
// "Pending requests" => "Pending requests",
// "Cancel friendship request" => "Cancel friendship request",
// "break friendship" => "break friendship",
// "Global default" => "Global default",
// "Bounding box" => "Bounding box",
// "default scale" => "default scale",
// "Make Map" => "Make Map",
// "Google Map Locator" => "Google Map Locator",
// "enter address" => "enter address",
// "Select Graphic Type" => "Select Graphic Type",
// "Pie Chart" => "Pie Chart",
// "Multiline" => "Multiline",
// "Multibar" => "Multibar",
// "Bar Stack" => "Bar Stack",
// "Clone" => "Clone",
// "Toggle Full Screen" => "Toggle Full Screen",
// "Date Selection" => "Date Selection",
// "Edit Date" => "Edit Date",
// "View Spreadsheet" => "View Spreadsheet",
// "Clone Spreadsheet" => "Clone Spreadsheet",
// "Roll Back Spreadsheet" => "Roll Back Spreadsheet",
// "Roll-Back" => "Roll-Back",
// "Or" => "Or",
// "Name of the zip file on the server" => "Name of the zip file on the server",
// "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode",
// "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button",
// "Congratulations! You have successful imported your data to Tikiwiki" => "Congratulations! You have successful imported your data to Tikiwiki",
// "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution",
// "Allocating too little memory will cause Tiki to display blank pages" => "Allocating too little memory will cause Tiki to display blank pages",
// "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver" => "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver",
// "Tiki was not able to send a test message" => "Tiki was not able to send a test message",
// "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)",
// "If your host requires SMTP authentication, additional configuration may be necessary" => "If your host requires SMTP authentication, additional configuration may be necessary",
// "Tiki can create images" => "Tiki can create images",
// "Tiki was not able to create a sample image. Please check your GD library configuration" => "Tiki was not able to create a sample image. Please check your GD library configuration",
// "Tiki found an existing database connection in your local.php file" => "Tiki found an existing database connection in your local.php file",
// "Modify database connection" => "Modify database connection",
// "Select the type of database to use with Tiki" => "Select the type of database to use with Tiki",
// "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension" => "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension",
// "Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Use <strong>localhost</strong> if the database is running on the same machine as Tiki",
// "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names" => "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names",
// "Character set" => "Character set",
// "Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box",
// "Always force connection to use UTF-8" => "Always force connection to use UTF-8",
// "Install &amp; Upgrade" => "Install &amp; Upgrade",
// "Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page",
// "This install will populate (or upgrade) the database" => "This install will populate (or upgrade) the database",
// "A new install will populate the database" => "A new install will populate the database",
// "Encoding Issue" => "Encoding Issue",
// "<p>Your database encoding is <strong>not</strong> in UTF-8.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8</em>.</p>" => "<p>Your database encoding is <strong>not</strong> in UTF-8.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8</em>.</p>",
// "Character Set Conversion" => "Character Set Conversion",
// "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database",
// "Convert database and tables to UTF-8" => "Convert database and tables to UTF-8",
// "This will destroy your current database" => "This will destroy your current database",
// "Reinstall" => "Reinstall",
// "Warning: Category Permissions Will Not Be Upgraded" => "Warning: Category Permissions Will Not Be Upgraded",
// "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them",
// "Automatically upgrade your existing database to v" => "Automatically upgrade your existing database to v",
// "This site has an admin account configured" => "This site has an admin account configured",
// "Please log in with your admin password to continue" => "Please log in with your admin password to continue",
// "Review the Upgrade" => "Review the Upgrade",
// "Upgrade complete" => "Upgrade complete",
// "Installation complete" => "Installation complete",
// "Your database has been configured and Tiki is ready to run" => "Your database has been configured and Tiki is ready to run",
// "If this is your first install, your admin password is <strong>admin</strong>" => "If this is your first install, your admin password is <strong>admin</strong>",
// "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application",
// "Upgrade operations executed successfully" => "Upgrade operations executed successfully",
// "Installation operations executed successfully" => "Installation operations executed successfully",
// "SQL queries" => "SQL queries",
// "Database was left unchanged" => "Database was left unchanged",
// "Failed" => "Failed",
// "Operations failed" => "Operations failed",
// "Display details" => "Display details",
// "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages",
// ".htaccess File" => ".htaccess File",
// "We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "We recommend enabling the <strong>.htaccess</strong> file for your Tiki",
// "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security",
// "Complete these fields to configure common, general settings for your site" => "Complete these fields to configure common, general settings for your site",
// "The information you enter here can be changed later" => "The information you enter here can be changed later",
// "Refer to the <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Refer to the <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings",
// "This will appear in the browser title bar" => "This will appear in the browser title bar",
// "Email sent by your site will use this address" => "Email sent by your site will use this address",
// "Secure Log in" => "Secure Log in",
// "Visible to Admin only" => "Visible to Admin only",
// "This is the email address for your administrator account" => "This is the email address for your administrator account",
// "Upgrade fix" => "Upgrade fix",
// "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will" => "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will",
// "Create the <em>Admins</em> group, if missing" => "Create the <em>Admins</em> group, if missing",
// "Grant <em>tiki_p_admin</em> to the group, if missing" => "Grant <em>tiki_p_admin</em> to the group, if missing",
// "Add the administrator account to the group, if missing" => "Add the administrator account to the group, if missing",
// "To do so enter the name of the main admin account in the field below" => "To do so enter the name of the main admin account in the field below",
// "Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "Check this box if you have a lot of disabled accounts after an upgrade to tiki4",
// "List of accounts that will be enabled" => "List of accounts that will be enabled",
// "The installation is complete" => "The installation is complete",
// "Tiki is an open source project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki is an open source project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>",
// "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu",
// "Enter Tiki and Lock Installer" => "Enter Tiki and Lock Installer",
// "Recommended" => "Recommended",
// "Enter Tiki Without Locking Installer" => "Enter Tiki Without Locking Installer",
// "You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker",
// "Are you sure you want to attempt to fix the encoding of your entire database" => "Are you sure you want to attempt to fix the encoding of your entire database",
// "Upgrading and running into encoding issues" => "Upgrading and running into encoding issues",
// "We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>",
// "Previous table encoding" => "Previous table encoding",
// "Please select" => "Please select",
// "Dangerous: Fix double encoding" => "Dangerous: Fix double encoding",
// "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue",
// "MultiTiki Setup" => "MultiTiki Setup",
// "Default Installation" => "Default Installation",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
// "Are you upgrading an existing Tiki site" => "Are you upgrading an existing Tiki site",
// "Go directly to the <strong>Install/Upgrade</strong> step" => "Go directly to the <strong>Install/Upgrade</strong> step",
// "Install/Upgrade" => "Install/Upgrade",
// "Restart the installer" => "Restart the installer",
// "Reset the Database Connection" => "Reset the Database Connection",
// "Tiki Project Web Site" => "Tiki Project Web Site",
// "Powered by Tiki Wiki CMS Groupware" => "Powered by Tiki Wiki CMS Groupware",
// "Invitation" => "Invitation",
// "Invitations list" => "Invitations list",
// "The mail has been sent to: " => "The mail has been sent to: ",
// "You are about to send an invitation to theses people, please confirm" => "You are about to send an invitation to theses people, please confirm",
// "Fill this box with the list of e-mails you want to invite " => "Fill this box with the list of e-mails you want to invite ",
// "Format of the list above " => "Format of the list above ",
// "CSV Style: One line per invitation, with the format: lastname,firstname,email" => "CSV Style: One line per invitation, with the format: lastname,firstname,email",
// "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)",
// "Type here the e-mail subject you'll want to be sent to them " => "Type here the e-mail subject you'll want to be sent to them ",
// "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) ",
// "Type here the content that the user will see when he'll click on the link from the mail " => "Type here the content that the user will see when he'll click on the link from the mail ",
// "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special " => "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special ",
// "Upload to Kaltura" => "Upload to Kaltura",
// "Upload Successful" => "Upload Successful",
// "You have successfully added {\$count} new entry/entries" => "You have successfully added {\$count} new entry/entries",
// "Add more media" => "Add more media",
// "Change Details" => "Change Details",
// "Remix" => "Remix",
// "Kaltura Video" => "Kaltura Video",
// "Media Entries" => "Media Entries",
// "Advanced Editor" => "Advanced Editor",
// "Simple Editor" => "Simple Editor",
// "Video Title" => "Video Title",
// "Editor" => "Editor",
// "Embed code" => "Embed code",
// "Views" => "Views",
// "Plays" => "Plays",
// "No action specified" => "No action specified",
// "Select Duplicates" => "Select Duplicates",
// "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone" => "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone",
// "The cache is used by" => "The cache is used by",
// "Approval" => "Approval",
// "Ban" => "Ban",
// "Delete & Ban" => "Delete & Ban",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block",
// "Keep gallery window open" => "Keep gallery window open",
// "Modifications" => "Modifications",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "Inviter" => "Inviter",
// "Only successful invitations" => "Only successful invitations",
// "Only pending invitations" => "Only pending invitations",
// "Number of invitations" => "Number of invitations",
// "Kaltura Remix Entries" => "Kaltura Remix Entries",
// "Kaltura Media Entries" => "Kaltura Media Entries",
// "Loads" => "Loads",
// "List Remixes" => "List Remixes",
// "Browse Media Entries" => "Browse Media Entries",
// "Browse Remixes" => "Browse Remixes",
// "Create Remix" => "Create Remix",
// "Please select some media entries to use" => "Please select some media entries to use",
// "Remix Video" => "Remix Video",
// "Additional Info" => "Additional Info",
// "Media Id" => "Media Id",
// "Wiki plugin code" => "Wiki plugin code",
// "Media Type" => "Media Type",
// "More Information" => "More Information",
// "No entries" => "No entries",
// "No media entries found" => "No media entries found",
// "Click here" => "Click here",
// "to upload" => "to upload",
// "Modified By" => "Modified By",
// "No mix entries found" => "No mix entries found",
// "to create a new mix" => "to create a new mix",
// "Mix Entries" => "Mix Entries",
// "Playlist Type" => "Playlist Type",
// "No playlists found. " => "No playlists found. ",
// "Click here " => "Click here ",
// "to create a playlist" => "to create a playlist",
// "\$type" => "\$type",
// "{\$special.reason|escape}: {\$special.objectName}" => "{\$special.reason|escape}: {\$special.objectName}",
// "Blog: %0" => "Blog: %0",
// "Post Title" => "Post Title",
// "Page aliases found" => "Page aliases found",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
// "Backl" => "Backl",
// " {if \$find ne ''}and {/if}starting with" => " {if \$find ne ''}and {/if}starting with",
// "However, some page aliases fitting the query were found (see Aliases section above)" => "However, some page aliases fitting the query were found (see Aliases section above)",
// "Xml Zip" => "Xml Zip",
// "Operator" => "Operator",
// "For security purposes we must periodically validate your email address to allow continued access to this site" => "For security purposes we must periodically validate your email address to allow continued access to this site",
// "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site" => "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site",
// "Thank you" => "Thank you",
// "Mail-in feature" => "Mail-in feature",
// "You do not have any mailin accounts set up" => "You do not have any mailin accounts set up",
// "Click here to go to mailin admin" => "Click here to go to mailin admin",
// "Change to" => "Change to",
// "Week containing" => "Week containing",
// "Month containing" => "Month containing",
// "h" => "h",
// "Edit Event" => "Edit Event",
// "Tiki Mods" => "Tiki Mods",
// "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>" => "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification",
// "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more",
// "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)",
// "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")",
// "for version" => "for version",
// "All versions" => "All versions",
// "or later" => "or later",
// "No mods found" => "No mods found",
// "Display only this type" => "Display only this type",
// "Unpublish" => "Unpublish",
// "Republish" => "Republish",
// "licence" => "licence",
// "Mods Install/uninstall" => "Mods Install/uninstall",
// "Package Config" => "Package Config",
// "User Articles" => "User Articles",
// "User forum topics" => "User forum topics",
// "User forum replies" => "User forum replies",
// "To display the objects you created or contributed to" => "To display the objects you created or contributed to",
// "Sent Edition" => "Sent Edition",
// "HTML version" => "HTML version",
// "Text version" => "Text version",
// "Delete errors" => "Delete errors",
// "Not sent" => "Not sent",
// "Removal of your email address failed" => "Removal of your email address failed",
// "Subscription failed" => "Subscription failed",
// "Wiki Create" => "Wiki Create",
// "Wiki Overwrite" => "Wiki Overwrite",
// "Object Watches" => "Object Watches",
// "Changes to groups watching this {\$objectType}" => "Changes to groups watching this {\$objectType}",
// "These changes to group watches" => "These changes to group watches",
// "were made to these descendants" => "were made to these descendants",
// "Groups watching this {\$objectType}" => "Groups watching this {\$objectType}",
// "This Category" => "This Category",
// "All Descendants" => "All Descendants",
// "Edit Permissions" => "Edit Permissions",
// "This category's direct permissions override any global permissions affecting objects in it" => "This category's direct permissions override any global permissions affecting objects in it",
// "No permissions yet applied to this object but category permissions affect this object and are displayed below" => "No permissions yet applied to this object but category permissions affect this object and are displayed below",
// "To edit category permissions" => "To edit category permissions",
// "Assign permissions to this category" => "Assign permissions to this category",
// "Delete category permissions" => "Delete category permissions",
// "Reset Perms" => "Reset Perms",
// "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions",
// "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions",
// "Permissions Clipboard" => "Permissions Clipboard",
// "Copy the permissions set here" => "Copy the permissions set here",
// "Paste" => "Paste",
// "Paste copied permissions from " => "Paste copied permissions from ",
// "Assign or remove permissions on <em>all</em> child categories" => "Assign or remove permissions on <em>all</em> child categories",
// "Are you sure you want to effect all child categories?\\nThere is no undo" => "Are you sure you want to effect all child categories?\\nThere is no undo",
// "Assign or remove permissions on all pages of the sub-structure" => "Assign or remove permissions on all pages of the sub-structure",
// "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo" => "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo",
// "You must select at least one feature" => "You must select at least one feature",
// "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for",
// "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for",
// "Feature name" => "Feature name",
// "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)" => "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)",
// "Your OpenID identity is valid" => "Your OpenID identity is valid",
// "Your identity gives you access to multiple user accounts" => "Your identity gives you access to multiple user accounts",
// "Select account" => "Select account",
// "Contributions by author" => "Contributions by author",
// "Contributions to" => "Contributions to",
// "current version" => "current version",
// "Words" => "Words",
// "Whitespaces" => "Whitespaces",
// "Characters" => "Characters",
// "Printable characters" => "Printable characters",
// "Deleted" => "Deleted",
// "Page changes" => "Page changes",
// "Original wiki text" => "Original wiki text",
// "Parsed Text (HTML)" => "Parsed Text (HTML)",
// "Output text only (No HTML tags)" => "Output text only (No HTML tags)",
// "Show statistics" => "Show statistics",
// "Visualize page changes" => "Visualize page changes",
// "Show popups" => "Show popups",
// "Escape HTML / Wiki syntax in page changes" => "Escape HTML / Wiki syntax in page changes",
// "Show contributions" => "Show contributions",
// "Preview of version" => "Preview of version",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "Hide translation history" => "Hide translation history",
// "Payment Date" => "Payment Date",
// "Payment Type" => "Payment Type",
// "Payer" => "Payer",
// "View payment info" => "View payment info",
// "Invoice" => "Invoice",
// "Assign permissions for payments" => "Assign permissions for payments",
// "Cancel this payment request" => "Cancel this payment request",
// "Request Date" => "Request Date",
// "View payment request" => "View payment request",
// "Paypal" => "Paypal",
// "Transaction ID" => "Transaction ID",
// "Payment made by <em>%0, %1</em> (%2)" => "Payment made by <em>%0, %1</em> (%2)",
// "{\$wp_member_title}" => "{\$wp_member_title}",
// "Paid amount" => "Paid amount",
// "Initial amount" => "Initial amount",
// "Amount remaining" => "Amount remaining",
// "Payment request was sent on %0 and is due by %1" => "Payment request was sent on %0 and is due by %1",
// "Pay with Paypal" => "Pay with Paypal",
// "Refresh page" => "Refresh page",
// "Payment info" => "Payment info",
// "Trade with Cclite" => "Trade with Cclite",
// "Payment problem" => "Payment problem",
// "Pay with Tiki User Credits" => "Pay with Tiki User Credits",
// "Credit type" => "Credit type",
// "Credits left" => "Credits left",
// "Amount to pay" => "Amount to pay",
// "Pay using" => "Pay using",
// "Manual payment entry" => "Manual payment entry",
// "Enter payment" => "Enter payment",
// "using" => "using",
// "Payment information" => "Payment information",
// "Outstanding" => "Outstanding",
// "Overdue" => "Overdue",
// "Past" => "Past",
// "Request" => "Request",
// "Detail" => "Detail",
// "Payable within" => "Payable within",
// "File (only .gif, .jpg and .png images)" => "File (only .gif, .jpg and .png images)",
// "Plugin execution was denied" => "Plugin execution was denied",
// "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected",
// "This plugin does not contain any arguments" => "This plugin does not contain any arguments",
// "This plugin's body is empty" => "This plugin's body is empty",
// "Plugin Approval" => "Plugin Approval",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "When you upgrade from an old version, you may need to reparse all the pages" => "When you upgrade from an old version, you may need to reparse all the pages",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "Vote poll" => "Vote poll",
// "Poll Results" => "Poll Results",
// "Top Voted Polls" => "Top Voted Polls",
// "Edit Poll" => "Edit Poll",
// "Find the poll" => "Find the poll",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Vote range displayed" => "Vote range displayed",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
// "List Votes" => "List Votes",
// "Popup preview" => "Popup preview",
// "Close preview" => "Close preview",
// "You do not have permission to read complete articles" => "You do not have permission to read complete articles",
// "Selected Structures" => "Selected Structures",
// "Add Structure" => "Add Structure",
// "No structures" => "No structures",
// "Available Pages" => "Available Pages",
// "No pages" => "No pages",
// "All pages selected" => "All pages selected",
// "Selected Pages" => "Selected Pages",
// "No pages selected" => "No pages selected",
// "Add Pages from Structures" => "Add Pages from Structures",
// "Edit quiz" => "Edit quiz",
// "Current Version" => "Current Version",
// "General Options" => "General Options",
// "Publication Date" => "Publication Date",
// "at " => "at ",
// "Use " => "Use ",
// "randomly selected questions" => "randomly selected questions",
// "Test-time Options" => "Test-time Options",
// "Limit questions displayed per page to " => "Limit questions displayed per page to ",
// "&nbsp question(s)" => "&nbsp question(s)",
// "Impose a time limit of " => "Impose a time limit of ",
// "Allow students to store partial results and return to quiz" => "Allow students to store partial results and return to quiz",
// "Allow students to retake this quiz " => "Allow students to retake this quiz ",
// "Grading and Feedback" => "Grading and Feedback",
// "Grading method " => "Grading method ",
// "Show students their score " => "Show students their score ",
// "Show students the correct answers " => "Show students the correct answers ",
// "Publish statistics " => "Publish statistics ",
// "Extra Options" => "Extra Options",
// "Solicit additional questions from students" => "Solicit additional questions from students",
// "Link quiz to forum named: " => "Link quiz to forum named: ",
// "Prologue" => "Prologue",
// "Epilogue" => "Epilogue",
// "time taken" => "time taken",
// "P/F" => "P/F",
// "Passed" => "Passed",
// "Top 10" => "Top 10",
// "Top 20" => "Top 20",
// "Top 50" => "Top 50",
// "Top 100" => "Top 100",
// "Rank" => "Rank",
// "This Article is currently not published and only visible by Editors" => "This Article is currently not published and only visible by Editors",
// "star" => "star",
// "half star" => "half star",
// "List all articles of this same topic" => "List all articles of this same topic",
// "Edit Received Page" => "Edit Received Page",
// "The highlight pages already exist" => "The highlight pages already exist",
// "Please, change the name if you want the page to be uploaded" => "Please, change the name if you want the page to be uploaded",
// "Prefix the checked" => "Prefix the checked",
// "Postfix the checked" => "Postfix the checked",
// "However, no account is associated to the OpenID identifier" => "However, no account is associated to the OpenID identifier",
// "Your email could not be validated; make sure you email is correct and click register below" => "Your email could not be validated; make sure you email is correct and click register below",
// "If you use an email filter, be sure to add %0 to your accepted list" => "If you use an email filter, be sure to add %0 to your accepted list",
// "Associate OpenID with an existing Tikiwiki account" => "Associate OpenID with an existing Tikiwiki account",
// "Please register" => "Please register",
// "Register this site at Tiki.org" => "Register this site at Tiki.org",
// "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites",
// "tiki.org" => "tiki.org",
// "Enter your username or email" => "Enter your username or email",
// "Enter your email" => "Enter your email",
// "Request Password Reset" => "Request Password Reset",
// "Use this name anyway" => "Use this name anyway",
// "to version" => "to version",
// "Replace selected" => "Replace selected",
// "Calendar Items" => "Calendar Items",
// "{\$where|escape}" => "{\$where|escape}",
// "Recipients" => "Recipients",
// "Validated" => "Validated",
// "Is user" => "Is user",
// "Sending Newsletter" => "Sending Newsletter",
// "Apply content template" => "Apply content template",
// "Data HTML" => "Data HTML",
// "Data Txt" => "Data Txt",
// "Clip Now" => "Clip Now",
// "Clip Articles" => "Clip Articles",
// "octets" => "octets",
// "Sender email not set" => "Sender email not set",
// "Save your changes" => "Save your changes",
// "Save any changes and send to all subscribers" => "Save any changes and send to all subscribers",
// "Send a structure" => "Send a structure",
// "Report this page" => "Report this page",
// "Page shared" => "Page shared",
// "The link was sent via e-Mail to the following addresses" => "The link was sent via e-Mail to the following addresses",
// "The link was sent via Twitter" => "The link was sent via Twitter",
// "The link was posted on your facebook wall" => "The link was posted on your facebook wall",
// "The link was sent as message to" => "The link was sent as message to",
// "The link was published in a" => "The link was published in a",
// "Short link" => "Short link",
// "Have a look at this page" => "Have a look at this page",
// "Your message" => "Your message",
// "e-Mail" => "e-Mail",
// "Send via e-Mail" => "Send via e-Mail",
// "Recipient(s)" => "Recipient(s)",
// "Tweet via Twitter" => "Tweet via Twitter",
// "Authorize with twitter first" => "Authorize with twitter first",
// "Have a look at " => "Have a look at ",
// "Put on my facebook wall" => "Put on my facebook wall",
// "Authorize with facebook first" => "Authorize with facebook first",
// "Link text" => "Link text",
// "This will be the title for the URL" => "This will be the title for the URL",
// "Like this post" => "Like this post",
// "You do not have the permission to send messages or you did not allow other users to send you messages" => "You do not have the permission to send messages or you did not allow other users to send you messages",
// "Separate multiple recipients with a comma" => "Separate multiple recipients with a comma",
// "Post on forum" => "Post on forum",
// "There is no forum where you can post a message" => "There is no forum where you can post a message",
// "password-protected" => "password-protected",
// "Share access rights" => "Share access rights",
// "Configure this sheet" => "Configure this sheet",
// "There are individual permissions set for this sheet" => "There are individual permissions set for this sheet",
// "Class Name" => "Class Name",
// "Join with Spreadsheet" => "Join with Spreadsheet",
// "You can access the sheet using the following URL" => "You can access the sheet using the following URL",
// "Location : " => "Location : ",
// "Content may be out of date" => "Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages",
// "page: %0/%1" => "page: %0/%1",
// "This text was automatically translated by Google Translate from the following page: " => "This text was automatically translated by Google Translate from the following page: ",
// "Last edited by" => "Last edited by",
// "based on work by" => "based on work by",
// "First Slide" => "First Slide",
// "Previous Slide" => "Previous Slide",
// "Previous Point" => "Previous Point",
// "Next Point" => "Next Point",
// "Next Slide" => "Next Slide",
// "Last Slide" => "Last Slide",
// "Jump To Slide" => "Jump To Slide",
// "Play" => "Play",
// "Pause" => "Pause",
// "Toggle Loop" => "Toggle Loop",
// "Exit" => "Exit",
// "Change Theme" => "Change Theme",
// "Accounts" => "Accounts",
// "twitter authorisation" => "twitter authorisation",
// "to manage your authorisations at twitter" => "to manage your authorisations at twitter",
// "this site with twitter.com to use twitter integration of this site" => "this site with twitter.com to use twitter integration of this site",
// "facebook authorisation" => "facebook authorisation",
// "to manage your authorisations at facebook" => "to manage your authorisations at facebook",
// "this site with facebook.com to use twitter integration of this site" => "this site with facebook.com to use twitter integration of this site",
// "The site admin has set up a global account which will be used for this site" => "The site admin has set up a global account which will be used for this site",
// "You will not see the latest queries" => "You will not see the latest queries",
// "Params" => "Params",
// "Date of first pageview" => "Date of first pageview",
// "Days since first pageview" => "Days since first pageview",
// "Total replies" => "Total replies",
// "Average number of replies per topic" => "Average number of replies per topic",
// "FAQ Stats" => "FAQ Stats",
// "Most viewed objects in period" => "Most viewed objects in period",
// "Tiki Logs" => "Tiki Logs",
// "Export through Action Log" => "Export through Action Log",
// "The link was sent to the following addresses" => "The link was sent to the following addresses",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Log out" => "Use Current Session/Log out",
// "Recorded Links" => "Recorded Links",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "Delete this link" => "Delete this link",
// "TikiTests List" => "TikiTests List",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
// "Tracker Item History" => "Tracker Item History",
// "View Tracker Item" => "View Tracker Item",
// "Advanced mode" => "Advanced mode",
// "Simple mode" => "Simple mode",
// "Retry" => "Retry",
// "The following files have been successfully uploaded" => "The following files have been successfully uploaded",
// "You can link to the file from a Wiki page using" => "You can link to the file from a Wiki page using",
// "You can display an image in a Wiki page using" => "You can display an image in a Wiki page using",
// "Or using as a thumbnail with ShadowBox" => "Or using as a thumbnail with ShadowBox",
// "You can link to the file from an HTML page using" => "You can link to the file from an HTML page using",
// "You locked the file" => "You locked the file",
// "The file is locked by {\$fileInfo.lockedby}" => "The file is locked by {\$fileInfo.lockedby}",
// "File title" => "File title",
// "File description" => "File description",
// "Unzip zip files" => "Unzip zip files",
// "File can be deleted after" => "File can be deleted after",
// "Creator of file, if different from the 'Uploaded by' user" => "Creator of file, if different from the 'Uploaded by' user",
// "Maximum number of downloads" => "Maximum number of downloads",
// "Add File" => "Add File",
// "Uploading file.." => "Uploading file..",
// "No File to Upload.." => "No File to Upload..",
// " Syntax tips" => " Syntax tips",
// "Link to file from a Wiki page" => "Link to file from a Wiki page",
// "In addition, for image files" => "In addition, for image files",
// "To display in a Wiki page" => "To display in a Wiki page",
// "Display thumbnail that enlarges" => "Display thumbnail that enlarges",
// "Image ID thumb" => "Image ID thumb",
// "You can include the image in an Wiki page using" => "You can include the image in an Wiki page using",
// "No gallery available" => "No gallery available",
// "You have to create a gallery first" => "You have to create a gallery first",
// "The column is disabled" => "The column is disabled",
// "#" => "#",
// "{if \$prefs.menus_item_names_raw eq 'n'}{\$chdata.name|escape}{else}{\$chdata.name}{/if}" => "{if \$prefs.menus_item_names_raw eq 'n'}{\$chdata.name|escape}{else}{\$chdata.name}{/if}",
// "User Icon" => "User Icon",
// "This user is your friend " => "This user is your friend ",
// "The user requested friendship with you" => "The user requested friendship with you",
// "Accept friendship from this user" => "Accept friendship from this user",
// "Refuse friendship from this user" => "Refuse friendship from this user",
// "Currently waiting for user approval" => "Currently waiting for user approval",
// "Cancel friendship request towards this user" => "Cancel friendship request towards this user",
// "Additional Information" => "Additional Information",
// "has not contributed to any content yet" => "has not contributed to any content yet",
// "Who Looks At His Stuff" => "Who Looks At His Stuff",
// "Toggle" => "Toggle",
// "Toggle options" => "Toggle options",
// "User's personal tracker information" => "User's personal tracker information",
// "View extra information" => "View extra information",
// "Your personal tracker information" => "Your personal tracker information",
// "Are you really sure you want to delete the account %0" => "Are you really sure you want to delete the account %0",
// "Accepted by Task User and Creator" => "Accepted by Task User and Creator",
// "Accepted User and Creator" => "Accepted User and Creator",
// "Not Accepted by One User" => "Not Accepted by One User",
// "Not Accepted User" => "Not Accepted User",
// "Waiting for Me" => "Waiting for Me",
// "Waiting for Other User" => "Waiting for Other User",
// "NOT accept" => "NOT accept",
// "This message will be send to users if you are makeing changes of assigned tasks" => "This message will be send to users if you are makeing changes of assigned tasks",
// "Marked as deleted" => "Marked as deleted",
// "You can only view this task" => "You can only view this task",
// "Public for group" => "Public for group",
// "You need to set your email to receive email notifications" => "You need to set your email to receive email notifications",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
// "Watch new items by clicking the {icon _id=eye} button on specific pages" => "Watch new items by clicking the {icon _id=eye} button on specific pages",
// "A user edited an article" => "A user edited an article",
// "A user deleted an article" => "A user deleted an article",
// "A user posts a forum thread" => "A user posts a forum thread",
// "A user posts a forum topic" => "A user posts a forum topic",
// "A user created a wiki page in a language" => "A user created a wiki page in a language",
// "no limit for admin" => "no limit for admin",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
// "Manage Message Queue" => "Manage Message Queue",
// "Manage Reported Messages" => "Manage Reported Messages",
// "Stop Monitoring Topics of this Forum" => "Stop Monitoring Topics of this Forum",
// "Stop Monitoring Topics and Threads of this Forum" => "Stop Monitoring Topics and Threads of this Forum",
// "Atts" => "Atts",
// "Forum Lock" => "Forum Lock",
// "Unarchive" => "Unarchive",
// "Show archived posts" => "Show archived posts",
// "normal" => "normal",
// "Archived" => "Archived",
// "The post has been reported and will be reviewed by a moderator" => "The post has been reported and will be reviewed by a moderator",
// "Print this page only" => "Print this page only",
// "Print all pages" => "Print all pages",
// "Tiki Sheet" => "Tiki Sheet",
// "Save current spreadsheet" => "Save current spreadsheet",
// "Cancel editing current spreadsheet" => "Cancel editing current spreadsheet",
// "List Spreadsheets" => "List Spreadsheets",
// "Already being edited by" => "Already being edited by",
// "No parse" => "No parse",
// "What would you like to add" => "What would you like to add",
// "New spreadsheet" => "New spreadsheet",
// "Existing spreadsheet" => "Existing spreadsheet",
// "Tracker as a spreadsheet" => "Tracker as a spreadsheet",
// "Spreadsheet from file gallery" => "Spreadsheet from file gallery",
// "Stop Monitor" => "Stop Monitor",
// "Move to another tracker" => "Move to another tracker",
// "Back to Items List" => "Back to Items List",
// "Special Operations" => "Special Operations",
// "Open Tiki WebDAV as WebFolder" => "Open Tiki WebDAV as WebFolder",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "This is the active account" => "This is the active account",
// "IMAP" => "IMAP",
// "Mbox" => "Mbox",
// "Maildir" => "Maildir",
// "POP3" => "POP3",
// "Group e-mail accounts" => "Group e-mail accounts",
// "IMAP server" => "IMAP server",
// "Use SSL" => "Use SSL",
// "No email set" => "No email set",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Auto refresh set for every \$autoRefresh seconds" => "Auto refresh set for every \$autoRefresh seconds",
// "Refresh now" => "Refresh now",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
// "Clip" => "Clip",
// "Part" => "Part",
// "This is the staging copy of" => "This is the staging copy of",
// "the approved version of this page" => "the approved version of this page",
// "Viewing of changes since last approval is possible only after first approval" => "Viewing of changes since last approval is possible only after first approval",
// "Approve changes" => "Approve changes",
// "Latest changes will be synchronized after approval" => "Latest changes will be synchronized after approval",
// "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time" => "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time",
// "There is a staging page (not yet approved) for this page" => "There is a staging page (not yet approved) for this page",
// "TOC" => "TOC",
// "Parent page" => "Parent page",
// "Group Monitor on Structure" => "Group Monitor on Structure",
// "Following fields are incorrect" => "Following fields are incorrect",
// "Hold \"Ctrl\" in order to select multiple values" => "Hold \"Ctrl\" in order to select multiple values",
// "Remove Image" => "Remove Image",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Character Limit Exceeded" => "Character Limit Exceeded",
// "Character Count" => "Character Count",
// "Word Count" => "Word Count",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19",
// "You can use" => "You can use",
// "Number of votes" => "Number of votes",
// "Your rating" => "Your rating",
// "You did not vote yet" => "You did not vote yet",
// "My rating" => "My rating",
// "Click to vote for this value" => "Click to vote for this value",
// "Clik to delete your vote" => "Clik to delete your vote",
// "You have ever subscribed" => "You have ever subscribed",
// "You have not yet subscribed" => "You have not yet subscribed",
// "friends" => "friends",
// "Latitude" => "Latitude",
// "Longitude" => "Longitude",
// "Google Maps is not enabled" => "Google Maps is not enabled",
// "Freetags is not enabled" => "Freetags is not enabled",
// "The main text of this page is available in the following languages" => "The main text of this page is available in the following languages",
// "Human Translations" => "Human Translations",
// "Machine Translations" => "Machine Translations",
// "Use this thread to discuss the page" => "Use this thread to discuss the page",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
// "Current attendees" => "Current attendees",
// "No attendees at this time" => "No attendees at this time",
// "Last time we checked, the room you requested did not exist" => "Last time we checked, the room you requested did not exist",
// "list" => "list",
// "Toggle location map" => "Toggle location map",
// "Lon" => "Lon",
// "Lat" => "Lat",
// "saving.." => "saving..",
// "Save current map view as user default" => "Save current map view as user default",
// "Save as user location" => "Save as user location",
// "Save as object location" => "Save as object location",
// "Email address the person you want to invite" => "Email address the person you want to invite",
// "Set in these groups" => "Set in these groups",
// "Email sent to" => "Email sent to",
// "Send to users" => "Send to users",
// "Send to" => "Send to",
// "Email separated by comma" => "Email separated by comma",
// "Send to groups" => "Send to groups",
// "Send Mail" => "Send Mail",
// "Check to remove" => "Check to remove",
// "Join myself" => "Join myself",
// "Leave myself" => "Leave myself",
// "Period" => "Period",
// "%0 year" => "%0 year",
// "%0 years" => "%0 years",
// "%0 days" => "%0 days",
// "Cost for one period" => "Cost for one period",
// "Membership to %0 for %1 year at %2&nbsp;%3" => "Membership to %0 for %1 year at %2&nbsp;%3",
// "Membership to %0 for %1 years at %2&nbsp;%3" => "Membership to %0 for %1 years at %2&nbsp;%3",
// "Membership to %0 for %1 days at %2&nbsp;%3" => "Membership to %0 for %1 days at %2&nbsp;%3",
// "separated by |" => "separated by |",
// "Number of periods" => "Number of periods",
// "Re-Apply" => "Re-Apply",
// "Undecided" => "Undecided",
// "Last Day" => "Last Day",
// "Last Week" => "Last Week",
// "Your default group" => "Your default group",
// "Change default group" => "Change default group",
// "Subscribe to a group" => "Subscribe to a group",
// "Subscribe to the newsletter" => "Subscribe to the newsletter",
// "Any" => "Any",
// "Please login first" => "Please login first",
// "Toggle display" => "Toggle display",
// "Created by %0" => "Created by %0",
// "Creator &amp; Last Editor" => "Creator &amp; Last Editor",
// "Save the page as a partial translation" => "Save the page as a partial translation",
// "Partial Translation" => "Partial Translation",
// "Save the page as a completed translation" => "Save the page as a completed translation",
// "Complete Translation" => "Complete Translation",
// "Save the page, but do not count it as new content to be translated" => "Save the page, but do not count it as new content to be translated",
// "Save the page, but do not send notifications and do not count it as new content to be translated" => "Save the page, but do not send notifications and do not count it as new content to be translated",
// "Save the page as a draft" => "Save the page as a draft",
// "Save Draft" => "Save Draft",
// "%0 set" => "%0 set",
// "%0 unset" => "%0 unset",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "Current version is up to date : <b>%0</b>" => "Current version is up to date : <b>%0</b>",
// "A new %0 major release branch is available" => "A new %0 major release branch is available",
// "Wiki Attachments" => "Wiki Attachments",
// "Feeds settings" => "Feeds settings",
// "Intertiki settings" => "Intertiki settings",
// "Freetags settings" => "Freetags settings",
// "Customize look and feel of your Tiki" => "Customize look and feel of your Tiki",
// "Configure Site Ads and Banners" => "Configure Site Ads and Banners",
// "Settings for video streaming integration" => "Settings for video streaming integration",
// "Help on \$admintitle Config" => "Help on \$admintitle Config",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "silver" => "silver",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Multiple IP Banning" => "Multiple IP Banning",
// "Access from your localization was forbidden due to excessive spamming" => "Access from your localization was forbidden due to excessive spamming",
// "Delete comments then set banning rules" => "Delete comments then set banning rules",
// "Are you sure you want to unassign the objects of this category: " => "Are you sure you want to unassign the objects of this category: ",
// "Click here to delete the category" => "Click here to delete the category",
// "You can not create a category with a name already existing at this level" => "You can not create a category with a name already existing at this level",
// "The file does not have the required header" => "The file does not have the required header",
// "Category can`t be parent of itself" => "Category can`t be parent of itself",
// "You have to provide a hotword and a URL" => "You have to provide a hotword and a URL",
// "You must specify a directory" => "You must specify a directory",
// "moved %d images, %d errors occured" => "moved %d images, %d errors occured",
// "a timeout occured. Hit the reload button to move the rest" => "a timeout occured. Hit the reload button to move the rest",
// "Test Image" => "Test Image",
// "Tiki Email Test" => "Tiki Email Test",
// "Tiki Test email from" => "Tiki Test email from",
// "Unable to send mail" => "Unable to send mail",
// "Test mail sent to" => "Test mail sent to",
// "%d user-group assignments" => "%d user-group assignments",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
// "No valid gdaltindex executable" => "No valid gdaltindex executable",
// "New configuration created (id %0)" => "New configuration created (id %0)",
// "Configuration updated" => "Configuration updated",
// "Requested action is not supported on repository" => "Requested action is not supported on repository",
// "Requested action in not supported on repository" => "Requested action in not supported on repository",
// "Frequency should be a positive integer" => "Frequency should be a positive integer",
// "Mail-in accounts set to be checked every %s minutes" => "Mail-in accounts set to be checked every %s minutes",
// "Automatic Mail-in accounts checking disabled" => "Automatic Mail-in accounts checking disabled",
// "Are you sure you want to modify this menu" => "Are you sure you want to modify this menu",
// "Are you sure you want to create a new menu" => "Are you sure you want to create a new menu",
// "metric_remove must be a numeric value" => "metric_remove must be a numeric value",
// "tab_remove must be a numeric value" => "tab_remove must be a numeric value",
// "assign_remove must be a numeric value" => "assign_remove must be a numeric value",
// "metric_edit must be a numeric value" => "metric_edit must be a numeric value",
// "tab_edit must be a numeric value" => "tab_edit must be a numeric value",
// "Memcache is disabled for metrics" => "Memcache is disabled for metrics",
// "tab_clearcache must be a numeric value" => "tab_clearcache must be a numeric value",
// "assign_metric must be a numeric value" => "assign_metric must be a numeric value",
// "assign_metric_edit must be a numeric value" => "assign_metric_edit must be a numeric value",
// "Assign: Invalid metric value" => "Assign: Invalid metric value",
// "Assign: Invalid tab value" => "Assign: Invalid tab value",
// "Cannot create or update metric: You need to specify a name for the metric" => "Cannot create or update metric: You need to specify a name for the metric",
// "Cannot create or update metric: Metric name must be under \" . \$prefs['metrics_metric_name_length'] . \" characters in length" => "Cannot create or update metric: Metric name must be under \" . \$prefs['metrics_metric_name_length'] . \" characters in length",
// "Cannot create or update metric: You need to specify a range for the metric" => "Cannot create or update metric: You need to specify a range for the metric",
// "Cannot create or update metric: You need to specify a data type for the metric" => "Cannot create or update metric: You need to specify a data type for the metric",
// "Cannot create or update metric: You need to specify a query for the metric" => "Cannot create or update metric: You need to specify a query for the metric",
// "Cannot create or update tab: You need to specify a name for the tab" => "Cannot create or update tab: You need to specify a name for the tab",
// "Cannot create or update tab: Tab name must be under \" . \$prefs['metrics_tab_name_length'] . \" characters in length" => "Cannot create or update tab: Tab name must be under \" . \$prefs['metrics_tab_name_length'] . \" characters in length",
// "Cannot create or update tab: You need to specify an integer range for the tab order" => "Cannot create or update tab: You need to specify an integer range for the tab order",
// "Cannot create or update tab: Tab content cannot be empty" => "Cannot create or update tab: Tab content cannot be empty",
// "Cannot create or update module: You need to specify a name to the module" => "Cannot create or update module: You need to specify a name to the module",
// "Cannot create or update module: You cannot leave the data field empty" => "Cannot create or update module: You cannot leave the data field empty",
// "Newsletter does not exist" => "Newsletter does not exist",
// "Error importing from wiki page: " => "Error importing from wiki page: ",
// "Error opening uploaded file" => "Error opening uploaded file",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "off" => "off",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Path disclosure" => "Path disclosure",
// "Path disclosure through error message" => "Path disclosure through error message",
// "SQL injection" => "SQL injection",
// "SQL injection by authenticated user" => "SQL injection by authenticated user",
// "SQL injection by authenticated user with special privileges" => "SQL injection by authenticated user with special privileges",
// "SQL injection without authentication" => "SQL injection without authentication",
// "PHP command injection" => "PHP command injection",
// "PHP command injection by authenticated user" => "PHP command injection by authenticated user",
// "PHP command injection by authenticated user with special privileges" => "PHP command injection by authenticated user with special privileges",
// "PHP command injection without authentication" => "PHP command injection without authentication",
// "File upload" => "File upload",
// "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous" => "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous",
// "This is a modified File. Cannot check version. Check if it is dangerous" => "This is a modified File. Cannot check version. Check if it is dangerous",
// "This file is from another Tikiwiki version: " => "This file is from another Tikiwiki version: ",
// "Global" => "Global",
// "Are you sure you want to delete all your custom tools" => "Are you sure you want to delete all your custom tools",
// "Are you sure you want to delete this custom tool" => "Are you sure you want to delete this custom tool",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Are you sure you want to remove this topic AND all the articles related" => "Are you sure you want to remove this topic AND all the articles related",
// "Tracker does not allow attachments" => "Tracker does not allow attachments",
// "Are you sure you want to create a new group" => "Are you sure you want to create a new group",
// "Are you sure you want to add this user?" => "Are you sure you want to add this user?",
// "Remove group: " => "Remove group: ",
// "Group name can not be empty" => "Group name can not be empty",
// "Are you sure you want to delete this user" => "Are you sure you want to delete this user",
// "Are you sure you want to remove this user from this group" => "Are you sure you want to remove this user from this group",
// "Are you sure you want to reset email due for this user" => "Are you sure you want to reset email due for this user",
// "Are you sure you want to delete these users" => "Are you sure you want to delete these users",
// "Are you sure you want to add this user to these groups" => "Are you sure you want to add this user to these groups",
// "Are you sure you want to remove this user from these groups" => "Are you sure you want to remove this user from these groups",
// "Are you sure you want to set the default groups for these users" => "Are you sure you want to set the default groups for these users",
// "Are you sure you want to send a wiki page as an email to these users" => "Are you sure you want to send a wiki page as an email to these users",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
// "Invalid or unknown email" => "Invalid or unknown email",
// "Could not create user" => "Could not create user",
// "User login or email is required" => "User login or email is required",
// "User does not exist on master" => "User does not exist on master",
// "Email validation requested but email address not set" => "Email validation requested but email address not set",
// "Password not set" => "Password not set",
// "User login contains invalid characters" => "User login contains invalid characters",
// "Impossible to create new %s with %s %s" => "Impossible to create new %s with %s %s",
// "Deleted account %s" => "Deleted account %s",
// "%s %s assigned to %s %s" => "%s %s assigned to %s %s",
// "group %s set as the default group of user %s" => "group %s set as the default group of user %s",
// "Are you sure you want to modify this user's data" => "Are you sure you want to modify this user's data",
// "Login contains invalid characters" => "Login contains invalid characters",
// "approved by " => "approved by ",
// "This function is only for staging pages" => "This function is only for staging pages",
// "You do not have permission to approve staging pages" => "You do not have permission to approve staging pages",
// "Staging page cannot be found" => "Staging page cannot be found",
// "Approved page was last saved after most recent staging edit" => "Approved page was last saved after most recent staging edit",
// "Failed to add attribute" => "Failed to add attribute",
// "Unassign perm %s from group %s" => "Unassign perm %s from group %s",
// "You have to indicate a group" => "You have to indicate a group",
// "This group is invalid" => "This group is invalid",
// "Image %s upload failed" => "Image %s upload failed",
// "Image %s uploaded successfully" => "Image %s uploaded successfully",
// "Image %s removed from Batch directory" => "Image %s removed from Batch directory",
// "Impossible to remove image %s from Batch directory" => "Impossible to remove image %s from Batch directory",
// "Please contact the website administrator" => "Please contact the website administrator",
// "Upload was successful" => "Upload was successful",
// "TOP" => "TOP",
// "Stop watching this category" => "Stop watching this category",
// "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>" => "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>",
// "There\\'s no such date as" => "There\\'s no such date as",
// "Calendar event : " => "Calendar event : ",
// "%H:%M %Z" => "%H:%M %Z",
// "Invalid username or activation code. Maybe this code has already been used" => "Invalid username or activation code. Maybe this code has already been used",
// "Your email could not be validated; make sure you email is correct" => "Your email could not be validated; make sure you email is correct",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "Problem. Try to log in again to receive new confirmation instructions" => "Problem. Try to log in again to receive new confirmation instructions",
// "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field" => "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field",
// "TikiHelp WebHelp generation engine. Generating WebHelp using" => "TikiHelp WebHelp generation engine. Generating WebHelp using",
// "Eliminating previous files" => "Eliminating previous files",
// "Index: <strong>\$name</strong>" => "Index: <strong>\$name</strong>",
// "Directory: <strong>\$dir</strong>" => "Directory: <strong>\$dir</strong>",
// "You need to change chmod 'whelp' manually to 777" => "You need to change chmod 'whelp' manually to 777",
// "Creating directory structure in <strong>\$base</strong>" => "Creating directory structure in <strong>\$base</strong>",
// "No parent specified" => "No parent specified",
// "Last sites of directory \" . \$rc[\"name\"] . \" " => "Last sites of directory \" . \$rc[\"name\"] . \" ",
// "Discount code already exists" => "Discount code already exists",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Error : The file %s doesn't exist" => "Error : The file %s doesn't exist",
// "The language can't be changed as its set of translations has already this language" => "The language can't be changed as its set of translations has already this language",
// "Wrote %d new strings and updated %d to lang/%s/language.php" => "Wrote %d new strings and updated %d to lang/%s/language.php",
// "Imported" => "Imported",
// "Edit Perspectives" => "Edit Perspectives",
// "Invalid structure_id or page_ref_id" => "Invalid structure_id or page_ref_id",
// "You do not have permission to write the template" => "You do not have permission to write the template",
// "Page is a staging copy. Translation must begin from the approved copy" => "Page is a staging copy. Translation must begin from the approved copy",
// "Override lock and carry on with edit" => "Override lock and carry on with edit",
// "Page is currently being edited" => "Page is currently being edited",
// "This page is being edited by " => "This page is being edited by ",
// "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. " => "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. ",
// "Page already exists. Go back and choose a different name" => "Page already exists. Go back and choose a different name",
// "Page name is" => "Page name is",
// "The translation set already contains a page in this language" => "The translation set already contains a page in this language",
// "Can not open the file" => "Can not open the file",
// "Problem zip initialisation" => "Problem zip initialisation",
// "Problem zip" => "Problem zip",
// "Another user is currently exporting that tracker, please try again later" => "Another user is currently exporting that tracker, please try again later",
// "No questions group indicated" => "No questions group indicated",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
// "Last replied forum topics" => "Last replied forum topics",
// "Not supported yet" => "Not supported yet",
// "Refused friendship request from %s" => "Refused friendship request from %s",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
// "Broke friendship with %s" => "Broke friendship with %s",
// "I have broken our friendship" => "I have broken our friendship",
// "Friendship request sent to %s" => "Friendship request sent to %s",
// "You're already friend of %s" => "You're already friend of %s",
// "I have accepted your friendship request" => "I have accepted your friendship request",
// "I have refused your friendship request" => "I have refused your friendship request",
// "I have canceled my friendship request" => "I have canceled my friendship request",
// "You do not have permission to make the map of this gallery" => "You do not have permission to make the map of this gallery",
// "Back to item" => "Back to item",
// "No valid renderer found. GD or PDFLib required" => "No valid renderer found. GD or PDFLib required",
// "No sheet specified" => "No sheet specified",
// "You must select a renderer" => "You must select a renderer",
// "Invalid Series for current graphic" => "Invalid Series for current graphic",
// "updated from structured text import" => "updated from structured text import",
// "created from structured text import" => "created from structured text import",
// "Operations executed successfully" => "Operations executed successfully",
// "Invalid software name" => "Invalid software name",
// "There is more than one item in the tracker with this title" => "There is more than one item in the tracker with this title",
// "There are no items in the tracker with this title" => "There are no items in the tracker with this title",
// "You have requested that this page be machine translated" => "You have requested that this page be machine translated",
// "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it",
// "This invitation does not exist or is deprecated" => "This invitation does not exist or is deprecated",
// "Congratulations! You are now part of this invitation group(s)" => "Congratulations! You are now part of this invitation group(s)",
// "Kaltura Upload" => "Kaltura Upload",
// "Communication error" => "Communication error",
// "Invalid response provided by the Kaltura server. Please retry" => "Invalid response provided by the Kaltura server. Please retry",
// "Are you sure you want to permanently remove article id %0" => "Are you sure you want to permanently remove article id %0",
// "Are you sure you want to permanently remove %0 articles" => "Are you sure you want to permanently remove %0 articles",
// "You do not have permission to view the comments for this blog" => "You do not have permission to view the comments for this blog",
// "Approved Status" => "Approved Status",
// "Queued" => "Queued",
// "This blog has no posts" => "This blog has no posts",
// "The file is already locked by %s" => "The file is already locked by %s",
// "WARNING: The file is used in" => "WARNING: The file is used in",
// "Quota too big" => "Quota too big",
// "Quota too small" => "Quota too small",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload your file" => "Please re-upload your file",
// "Cannot read the file" => "Cannot read the file",
// "Error importing" => "Error importing",
// "Error converting" => "Error converting",
// "Importing" => "Importing",
// "Processing" => "Processing",
// "Ready" => "Ready",
// "Pending moderation" => "Pending moderation",
// "Blocked" => "Blocked",
// "Invalid action" => "Invalid action",
// "Are you sure you want to permanently remove submited article id %0" => "Are you sure you want to permanently remove submited article id %0",
// "Are you sure you want to permanently remove %0 submited articles" => "Are you sure you want to permanently remove %0 submited articles",
// "Are you sure you want to approve %0 submited articles" => "Are you sure you want to approve %0 submited articles",
// "Are you sure you want to remove the %0 selected pages" => "Are you sure you want to remove the %0 selected pages",
// "Are you sure you want to print the %0 selected pages" => "Are you sure you want to print the %0 selected pages",
// "Are you sure you want to unlock the %0 selected pages" => "Are you sure you want to unlock the %0 selected pages",
// "Are you sure you want to lock the %0 selected pages" => "Are you sure you want to lock the %0 selected pages",
// "Are you sure you want to download a zip of the %0 selected pages" => "Are you sure you want to download a zip of the %0 selected pages",
// "Username field cannot be empty. Please go back and try again" => "Username field cannot be empty. Please go back and try again",
// "Unable to contact remote server" => "Unable to contact remote server",
// "XMLRPC Error: " => "XMLRPC Error: ",
// "Unable to create login" => "Unable to create login",
// "More than %d unsuccessful login attempts have been made" => "More than %d unsuccessful login attempts have been made",
// "An email has been sent to you with the instructions to follow" => "An email has been sent to you with the instructions to follow",
// "Resend" => "Resend",
// "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email",
// "Your default nickname is already in use. A new one has to be selected" => "Your default nickname is already in use. A new one has to be selected",
// "Verification cancelled" => "Verification cancelled",
// "The selected account is not associated with your identity" => "The selected account is not associated with your identity",
// "unknown action" => "unknown action",
// "Authentication method is not OpenID" => "Authentication method is not OpenID",
// "Authentication error; probably not a valid OpenID" => "Authentication error; probably not a valid OpenID",
// "Could not redirect to server: " => "Could not redirect to server: ",
// "OpenID authentication failed: " => "OpenID authentication failed: ",
// "Account disabled" => "Account disabled",
// "You must use the right case for your user name" => "You must use the right case for your user name",
// "invalid mapfile name" => "invalid mapfile name",
// "An error as occured with the mapfile" => "An error as occured with the mapfile",
// "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files" => "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files",
// "Maps feature is not correctly setup : Maps path is missing" => "Maps feature is not correctly setup : Maps path is missing",
// "map edit" => "map edit",
// "I do not know where is gdaltindex. Set correctly the Map feature" => "I do not know where is gdaltindex. Set correctly the Map feature",
// " to " => " to ",
// "No page provided" => "No page provided",
// "This Tiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more" => "This Tiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more",
// "You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site" => "You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site",
// "tiki-mobile.php" => "tiki-mobile.php",
// "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody",
// "merged note" => "merged note",
// "Are you sure you want to delete this note" => "Are you sure you want to delete this note",
// "Note not found" => "Note not found",
// "Are you sure you want to remove the direct permissions from this object" => "Are you sure you want to remove the direct permissions from this object",
// "You do not have permission to assign permissions for this object" => "You do not have permission to assign permissions for this object",
// "Manual payment entered" => "Manual payment entered",
// "You do not have permission to enter payment" => "You do not have permission to enter payment",
// "New payment requested" => "New payment requested",
// "Cancel payment %0" => "Cancel payment %0",
// "Payment canceled" => "Payment canceled",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (' . \$code . " => "Index (' . \$code . ",
// "Pageviews" => "Pageviews",
// "You are already logged in" => "You are already logged in",
// "This is not a valid mail adress" => "This is not a valid mail adress",
// "Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Please enter a valid %s.  No spaces, more than %d characters and contain %s",
// "Missing User Name" => "Missing User Name",
// "User Already Exists" => "User Already Exists",
// "Valid User Name" => "Valid User Name",
// "Missing Email" => "Missing Email",
// "Valid Email" => "Valid Email",
// "Unable to send mail. User has not configured email" => "Unable to send mail. User has not configured email",
// "Please provide a username or email" => "Please provide a username or email",
// "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password",
// "The mail can't be sent. Contact the administrator" => "The mail can't be sent. Contact the administrator",
// "A password reminder email has been sent " => "A password reminder email has been sent ",
// "An email with a link to reset your password has been sent " => "An email with a link to reset your password has been sent ",
// "to the email" => "to the email",
// "You cannot rename staging pages. Please rename the approved page instead" => "You cannot rename staging pages. Please rename the approved page instead",
// "Cannot rename page because the new name begins with reserved prefix" => "Cannot rename page because the new name begins with reserved prefix",
// "Cannot rename page because maybe new staging page name already exists" => "Cannot rename page because maybe new staging page name already exists",
// "Error Message" => "Error Message",
// "This match was not case sensitive" => "This match was not case sensitive",
// "No items selected" => "No items selected",
// "Page cannot be found: " => "Page cannot be found: ",
// "Page has changed since preview: " => "Page has changed since preview: ",
// "Page not updated due to error in replacing: " => "Page not updated due to error in replacing: ",
// "Page updated: " => "Page updated: ",
// "A problem occured during file uploading" => "A problem occured during file uploading",
// "File which was causing trouble was at rank" => "File which was causing trouble was at rank",
// "The error was" => "The error was",
// "Error: You can\\'t send the same newsletter by refreshing this frame content" => "Error: You can\\'t send the same newsletter by refreshing this frame content",
// "Newsletter successfully sent to %s users" => "Newsletter successfully sent to %s users",
// "There was %s errors" => "There was %s errors",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
// "Notice: invalid variable value" => "Notice: invalid variable value",
// "Report to the webmaster" => "Report to the webmaster",
// "Your link was sent" => "Your link was sent",
// "Your email is mandatory" => "Your email is mandatory",
// "Permission to post in forum denied" => "Permission to post in forum denied",
// "No text given for tweet" => "No text given for tweet",
// "Error sending tweet" => "Error sending tweet",
// "Error sending mail to" => "Error sending mail to",
// "Spreadsheet - " => "Spreadsheet - ",
// "Are you sure you want to delete this spreadsheet" => "Are you sure you want to delete this spreadsheet",
// "Permission denied. You cannot view this page" => "Permission denied. You cannot view this page",
// "Clean the sql logs" => "Clean the sql logs",
// "Send a link to a friend " => "Send a link to a friend ",
// "No trackerId specified" => "No trackerId specified",
// "You must lock the file before editing it" => "You must lock the file before editing it",
// "Batch file processed" => "Batch file processed",
// "Cannot resize the file" => "Cannot resize the file",
// "Cannot write the file" => "Cannot write the file",
// "Image was reduced: %s x %s -> %s x %s" => "Image was reduced: %s x %s -> %s x %s",
// "Check that these paths exist and are writable by the web server" => "Check that these paths exist and are writable by the web server",
// "Incorrect file extension" => "Incorrect file extension",
// "Password has been changed" => "Password has been changed",
// "Invalid password. Your current password is required to change administrative information" => "Invalid password. Your current password is required to change administrative information",
// "If you really want to delete you're account, you must check the checkbox" => "If you really want to delete you're account, you must check the checkbox",
// "This script can only be called by the server" => "This script can only be called by the server",
// "was moved into trash" => "was moved into trash",
// "trashed by" => "trashed by",
// "Rights by creator" => "Rights by creator",
// "END" => "END",
// "Percentage" => "Percentage",
// "Task accepted by creator" => "Task accepted by creator",
// "Task accepted by task user" => "Task accepted by task user",
// "Task NOT accepted by creator" => "Task NOT accepted by creator",
// "Task NOT accepted by task user" => "Task NOT accepted by task user",
// "Sorry this task does not exist or you have no rights to view this task" => "Sorry this task does not exist or you have no rights to view this task",
// "Task entries" => "Task entries",
// "Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks" => "Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks",
// "You've to start your work at least on" => "You've to start your work at least on",
// "You've to finish your work on" => "You've to finish your work on",
// "Login and click the link below" => "Login and click the link below",
// "Please read the task and work on it" => "Please read the task and work on it",
// "Sorry, there was an error while trying to write data into the database" => "Sorry, there was an error while trying to write data into the database",
// "Remove the notification email" => "Remove the notification email",
// "Language watch" => "Language watch",
// "Category watch: %0, Language: %1" => "Category watch: %0, Language: %1",
// "Post not found" => "Post not found",
// "You do not have permission to view this blog post while it is marked as private" => "You do not have permission to view this blog post while it is marked as private",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
// "Incorrect thread" => "Incorrect thread",
// "Spreadsheet truncated" => "Spreadsheet truncated",
// "Files are read only at this time" => "Files are read only at this time",
// "Are you sure you want to clone this spreadsheet" => "Are you sure you want to clone this spreadsheet",
// "Clone Error" => "Clone Error",
// "Are you sure you want to rollback this spreadsheet" => "Are you sure you want to rollback this spreadsheet",
// "Rollback Error" => "Rollback Error",
// "Create tracker item" => "Create tracker item",
// "You don't have a personal tracker item yet. Click here to make one" => "You don't have a personal tracker item yet. Click here to make one",
// "That tracker don't use extras" => "That tracker don't use extras",
// "Tiki WebDAV access" => "Tiki WebDAV access",
// "There was a problem connecting to that account" => "There was a problem connecting to that account",
// "There was a problem deleting that mail" => "There was a problem deleting that mail",
// "Mail ID" => "Mail ID",
// "There was a problem while trying to delete these mails" => "There was a problem while trying to delete these mails",
// "There was a problem while trying to delete that mail" => "There was a problem while trying to delete that mail",
// "Are you sure you want to delete this account" => "Are you sure you want to delete this account",
// "Taking" => "Taking",
// "Putting back" => "Putting back",
// "Checking" => "Checking",
// "Plugin modified by editor" => "Plugin modified by editor",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "You are about to delete a TikiTest file, do you want to continue " => "You are about to delete a TikiTest file, do you want to continue ",
// "Error deleting the file" => "Error deleting the file",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// "The page is empty" => "The page is empty",
// ### end of untranslated words
// ###

// ###
// ### start of possibly untranslated words
// ###

"OK" => "OK",
"Smileys" => "Smileys",
"Version" => "Version",
"Copyrights" => "Copyrights",
"Syntax" => "Syntax",
"Standard" => "Standard",
"Prio" => "Prio",
"XML Zip" => "XML Zip",
"Portrait" => "Portrait",
"Upgrade" => "Upgrade",
"Administrator" => "Administrator",
"Installation" => "Installation",
"DB OK" => "DB OK",
"MultiTiki" => "MultiTiki",
"Ok" => "Ok",
"v" => "v",
"SlideShow" => "SlideShow",
"optional" => "optional",
"offline" => "offline",
// ###
// ### end of possibly untranslated words
// ###

"Re:" => "Aw:",
"This script cannot be called directly" => "Dieses Script kann nicht direkt aufgerufen werden",
"Copyright management" => "Copyrightverwaltung",
"No page indicated" => "Keine Seite angegeben",
"You must supply all the information, including title and year." => "Du musst alle Daten angeben, inkl. Titel und Jahr.",
"You do not have permission to use this feature" => "Keine Berechtigung zur Nutzung dieser Funktion",
"This feature is for admins only" => "Zugriff nur für Admin möglich",
"Type" => "Typ",
"Description" => "Beschreibung",
"Size" => "Größe",
"Created" => "Erstellt",
"Uploaded" => "Hochgeladen",
"Last Modified" => "Zuletzt modifiziert",
"Uploaded by" => "Hochgeladen von",
"Creator" => "Ersteller",
"Last Modified by" => "Zuletzt verändert von",
"Comment" => "Kommentar",
"Files" => "Dateien",
"Hits" => "Zugriffe",
"Last download" => "Letzter Download",
"Locked by" => "Gesperrt von",
"Path" => "Pfad",
"Default View" => "Standardansicht",
"Register" => "Registrieren",
"Germany" => "Deutschland",
"None" => "Keine",
"Other" => "Sonstige",
"Welsh" => "Walisisch",
"Slovene" => "Slovenisch",
"Arabic" => "Arabisch",
"Catalan" => "Katalanisch",
"Simplified Chinese" => "Vereinfachtes Chinesisch",
"Czech" => "Tschechisch",
"Danish" => "Dänisch",
"German" => "Deutsch",
"English" => "Englisch en",
"English British" => "Englisch en-uk",
"Spanish" => "Spanisch",
"Greek" => "Griechisch",
"Farsi" => "Persisch",
"Finnish" => "Finnisch",
"Fijian" => "Fiji",
"French" => "Französisch",
"Frisian Netherlands" => "Friesisch NL",
"Galician" => "Galizisch",
"Hebrew" => "Hebräisch",
"Croatian" => "Kroatisch",
"Indonesian" => "Indonesisch",
"Icelandic" => "Isländisch",
"Italian" => "Italienisch",
"Japanese" => "Japanisch",
"Korean" => "Koreanisch",
"Hungarian" => "Ungarisch",
"Lithuanian" => "Lithauisch",
"Dutch" => "Holländisch NL",
"Norwegian" => "Norwegisch",
"Polish" => "Polnisch",
"Português" => "Portugiesisch",
"Brazilian Portuguese" => "Brazilianisches Portugiesisch",
"Romanian" => "Rumänisch",
"Romansh" => "Romanssh",
"Russian" => "Russisch",
"Slovak" => "Slovakisch",
"Albanian" => "Albanisch",
"Serbian Latin" => "Serbisch (Latin)",
"Swedish" => "Schwedisch",
"Tuvaluan" => "Tuvaluisch",
"Turkish" => "Türkisch",
"Traditional Chinese" => "Traditionelles Chinesisch",
"Ukrainian" => "Ukrainisch",
"Vietnamese" => "Vietnamesisch",
"Permission denied" => "Zugriff verweigert",
"Template %s not registered" => "Vorlage %s nicht registriert",
"The file is not a CSV file or has not a correct syntax" => "Diese Datei ist keine CSV Datei oder hat nicht die erforderliche Syntax",
"locked" => "gesperrt",
"locked by" => "gesperrt von",
"All day" => "den ganzen Tag",
"First day of week: Sunday (its ID is 0) - translators you need to localize this string!" => "1",
"Sunday" => "Sonntag",
"Monday" => "Montag",
"Tuesday" => "Dienstag",
"Wednesday" => "Mittwoch",
"Thursday" => "Donnerstag",
"Friday" => "Freitag",
"Saturday" => "Samstag",
"continued" => "weiter",
"New Image Uploaded by" => "Neue Bilder hochgeladen von",
"New Subscriptions" => "Neue Abonnenten",
"New Item in Tracker" => "Neuer Eintrag im Tracker",
"tracker" => "Tracker",
"by" => "von",
"Wiki" => "Wiki Seite",
"Image Gallery" => "Bildergalerie",
"Articles" => "Artikel",
"Forums" => "Foren",
"Directory" => "Linkverzeichnis",
"File Gallery" => "Dateiarchiv",
"Quizzes" => "Quiz",
"Trackers" => "Tracker",
"Survey" => "Umfrage",
"Newsletter" => "Rundbrief",
"Help" => "Hilfe",
"article" => "Artikel",
"blog" => "Blog",
"directory" => "Linkverzeichnis",
"faq" => "FAQ",
"file gallery" => "Dateiarchiv",
"forum" => "Forum",
"image gallery" => "Bildergalerie",
"newsletter" => "Rundbrief",
"poll" => "Abstimmung",
"quiz" => "Quiz",
"wiki page" => "Wiki-Seite",
"image" => "Bild",
"calendar" => "Kalender",
"Invalid filename (using filters for filenames)" => "Ungültiger Dateiname (verwende Filter)",
"Cannot upload this file - maximum upload size exceeded" => "Datei überschreitet maximale Größ für das Hochladen",
"(not registered)" => "(nicht registriert)",
"Anonymous" => "Unbekannt",
"Wrong password. Cannot post comment" => "Falsches Passwort. Kommentar kann nicht gespeichert werden",
"A contribution is mandatory" => "Die Art der Beteiligung muß angegeben werden",
"You have to enter a title and text" => "Du musst Titel und Text eingeben",
"Create page:" => "Seite erstellen:",
"Plugin <strong>%0</strong> cannot be executed." => "Plugin <strong>%0</strong> kann nicht ausgeführt werden.",
"Set" => "Ok",
"Plugin disabled" => "Plugin deaktiviert",
"Line:" => "Zeile:",
"Lines:" => "Zeilen:",
"File Galleries" => "Dateiarchive",
"File gallery quota exceeded" => "Speicherkontigent für Dateiarchiv überschritten",
"Wiki Home" => "Wiki-Home",
"Home" => "Startseite",
"previous page" => "vorherige Seite",
"next page" => "nächste Seite",
"posted on" => "aufgegeben am",
"Continue" => "Weiter",
"By:" => "Von:",
"Read" => "Lesen",
"List articles" => "Artikel auflisten",
"Last post" => "Neuester Eintrag",
"Invalid imagename (using filters for filenames)" => "Ungültiger Dateiname (using filters for filenames)",
"Errors detected" => "Fehler entdeckt",
"Upload was not successful" => "Hochladen war nicht erfolgreich",
"No image yet, sorry." => "Leider noch keine Bilder vorhanden.",
"Contributions" => "Beiträge",
"This feature is disabled" => "Diese Funktion ist deaktiviert",
"unknown" => "unbekannt",
"NONE" => "KEINES",
"for" => "für",
"%s impossible to remove" => "%s kann nicht gelöscht werden",
"Module Title" => "Modultitel",
"Title to display at the top of the box." => "Titel der am oberen Rand der Modulbox angezeigt wird.",
"No box" => "Keine Box",
"Show only the content" => "Zeige nur den Inhalt an",
"Decorations" => "Dekorationen",
"Show module decorations" => "Zeige Moduldekorationen",
"No title" => "Ohne Titel",
"Show module title" => "Zeige den Modultitel",
"Perspective" => "Perspektive",
"Only display the module if in one of the listed perspective IDs. Semi-colon separated." => "Zeige das Modul nur innerhalb einer der angegebenen Perspektiven-IDs. Verschiedene IDs werden durch Semikolon getrennt.",
"Language" => "Sprache",
"Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons." => "Das Modul nur innerhalb einer spezifischen Sprache verfügbar machen. Sprachen werden über den Sprachcode (zwei Zeichen) ausgewählt. Verschiedene Werte werden duch Semikolon getrennt.",
"Section" => "Bereich",
"Module only applicable for the specified sections. Multiple values can be separated by semi-colons." => "Modul steht nur in bestimmten Bereichen zur Verfügung. Verschiedene Bereiche werden durch Semikolon getrennt.",
"Page filter" => "Seitenfilter",
"Module only applicable on the specified page names. Multiple values can be separated by semi-colons." => "Modul steht nur auf bestimmten Seiten zur Verfügung. Verschiedene Seitennamen werden durch Semikolon getrennt.",
"No Page" => "Seitenausschluß",
"Module not applicable on the specified page names. Multiple values can be separated by semi-colons." => "Modul steht auf den angegebenen Seiten nicht zur Verfügung. Verschiedene Seitennamen werden durch Semikolon getrennt.",
"Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons." => "Modul steht/steht nicht in Abhängigkeit zum Namen des Theme (z.B. \"thenews.css\") zur Verfügung. Die angegebenen Themes können ein- oder ausgeschlossen werden. Themenamen mit dem Präfix \\\"!\\\" werden ausgeschlossen. Verschiedene Werte werden durch Semikolon getrennt.",
"Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module." => "Modul steht in Abhängigkeit des Benutzers mit der Wikiseite zur Verfügung. Entweder können nur Ersteller der Seite (Eintrag: y) oder Nichtersteller (Eintrag: n) das Modul sehen.",
"Contributor" => "Beitragende",
"Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module." => "Modul steht in Abhängigkeit des Benutzers mit der Wikiseite zur Verfügung. Entweder können nur zur Seite Beitragende (Eingabe: y) oder nur nicht zur Seite Beitragende (Eingabe: n) das Modul sehen.",
"Users can shade module." => "Benutzer kann das Modul ausblenden.",
"No numbers" => "Keine Nummern",
"If set to \"y\", the module will not number list items." => "Wenn \"y\" eingetragen wird, nummeriert das Modul die Listeneinträge nicht.",
"Rows" => "Zeilen",
"Number of rows, or items, to display." => "Anzahl von anzuzeigenden Zeilen oder Einträgen.",
"Default: 10." => "Standard: 10.",
"Error" => "Fehler",
"Ajax auto-save" => "Ajax automatisches Speichern",
"Users accept internal messages by default" => "Standardmässig interne Nachrichten empfangen",
"Users can opt-out of internal messages" => "Benutzer kann sich für interne Nachrichten abmelden (opt-out)",
"Newest first" => "Neueste zuerst",
"ascending" => "aufsteigend",
"descending" => "absteigend",
"Article ordering" => "Artikelsortierung",
"Title of articles home page" => "Titel der Artikelhauptseite",
"Topic" => "Thema",
"Title" => "Titel",
"Title length" => "Titellänge",
"Publication date" => "Veröffentlichungsdatum",
"Expiration date" => "Verfallsdatum",
"Visible" => "Sichtbar",
"User" => "Benutzer",
"Author" => "Autor",
"Author Rating" => "Autorbewertung",
"Reads" => "Zugriffe",
"Images" => "Bilder",
"Trailer position" => "Position des Aufmachers",
"Top" => "Oben",
"Header text position" => "Textposition des Titels",
"Next image" => "Neben dem Bild",
"Below image" => "Unter dem Bild",
"Oldest first" => "Älteste zuerst",
"Points" => "Punkte",
"Default number per page" => "Standardanzahl pro Seite",
"Default Ordering" => "Standardsortierung",
"Paginate articles" => "Paginiere Artikel",
"User ratings on articles" => "Benutzerbewertungen bei Artikeln",
"Article rating options" => "Bewertungsoptionen für Artikel",
"Default article image width" => "Standardbreite für Artikelbild",
"0 for original image size" => "0 für Originalgröße",
"Default article image height" => "Standardhöhe für Artikelbild",
"Custom attributes for article types" => "Benutzerdefinierte Felder für Artikel",
"Your ShareThis publisher identifier (optional)" => "Deine \"ShareThis\" Indentifikation (optional)",
"Authentication method" => "Authentifizierungsmethode",
"Tiki and OpenID" => "Tiki und OpenID",
"Tiki and PAM" => "Tiki und PAM",
"Tiki and LDAP" => "Tiki und LDAP",
"Web Server" => "Webserver",
"Share access rights with friends when using Tell a friend" => "Gleiche Rechte für einen Freund, wenn \"Zeige das einem Freund\" benutzt wird",
"Share access rights with friends when using Share" => "Gleiche Rechte für einen Freund, wenn \"send a link\" benutzt wird",
"Create user if not in Tiki" => "Erstelle Benutzer, wenn nicht in Tiki",
"Use Tiki authentication for Admin login" => "Benutze Tiki Authentifizierung für Administratorlogin",
"phpBB Database Hostname" => "phpBB Datenbank Hostname",
"phpBB Database Username" => "phpBB Datenbank Benutzername",
"phpBB Database Password" => "phpBB Datenbank Passwort",
"phpBB Database Name" => "phpBB Datenbank Name",
"phpBB Table Prefix" => "phpBB Tabellenpräfix",
"Use Tiki authentication for users created in tiki" => "Benutze Tiki Authentifizierung für Benutzer, die in Tiki erstellt wurden",
"Disable Tiki users who doesn't have a phpBB login. (They could have been deleted)." => "Deaktiviere Tikibenutzer, die kein phpBB Login haben (sie könnten gelöscht sein).",
"All" => "Alle",
"Available languages" => "Verfügbare Sprachen",
"Available styles" => "Verfügbare Styles",
"BigBlueButton server location" => "BigBlueButton Server Adresse",
"BigBlueButton server salt" => "BigBlueButton Server Salt",
"Default ordering" => "Standardsortierung",
"Creation Date (desc)" => "Erstellungsdatum (absteigend)",
"Last modification date (desc)" => "Datum letzte Änderung (absteigend)",
"Blog title (asc)" => "Blog-Titel (aufsteigend)",
"Number of posts (desc)" => "Anzahl Posts (absteigend)",
"Visits (desc)" => "Besuchszahlen (absteigend)",
"Activity (desc)" => "Aktivität (absteigend)",
"Creation date" => "Erstelldatum",
"Last modified" => "Zuletzt modifiziert",
"Disabled" => "deaktiviert",
"Plain text" => "Nur Text",
"Link to user information" => "Link auf Benutzerinformationen",
"User avatar" => "Benutzer Avatar",
"Posts" => "Einträge",
"Visits" => "Besuche",
"Activity" => "Aktivität",
"Blogues" => "Blogs",
"Example:" => "Beispiel:",
"Days to display in the Calendar" => "Tage, die im Kalender angezeigt werden",
"Default view mode" => "Standardansicht",
"Day" => "Tag",
"Week" => "Woche",
"Month" => "Monat",
"Quarter" => "Quartal",
"Semester" => "Halbjahr",
"Year" => "Jahr",
"First day of the week" => "Erster Tag der Woche",
"Depends user language" => "hängt von der Benutzersprache ab",
"Split hours in periods of" => "Teile Stunden in Abschnitte von",
"1 minute" => "1 Minute",
"5 minutes" => "5 Minuten",
"10 minutes" => "10 Minuten",
"15 minutes" => "15 Minuten",
"30 minutes" => "30 Minuten",
"Sticky popup" => "Sticky Popup",
"Item view tab" => "Tab 'Eintrag ansehen'",
"Show Add to Google Calendar icon" => "Zeige ein \"Zu Googlekalender hinzufügen\"-Symbol",
"Word length of the captcha image" => "Wortlänge des Captchabildes",
"Default:" => "Voreingestellt:",
"Width of the captcha image in pixels" => "Breite des Captchabildes in Pixeln",
"Level of noise of the captcha image" => "Störungslevel des Captchabildes",
"CAS server version" => "CAS Serverversion",
"none" => "keine",
"Never" => "Nie",
"Categories used in templates (TPL)" => "In Vorlagen benutzte Kategorien (TPL)",
"Category Jail" => "Kategoriegefängnis",
"Category Defaults" => "Voreingestellte Kategorien",
"One per line. ex:1,4,6,7/4" => "Eine pro Zeile. Z.B.: 1,4,6,7/4",
"Synchronize multilingual categories" => "synchronisiere mehrsprachige Kategorien",
"Only those specified" => "Nur die angegebenen",
"All but those specified" => "Alle außer den angegebenen",
"Automatically geocode items when categorized in" => "Objekte automatisch geokodieren, wenn sie kategorisiert werden",
"Replace existing geocode if any" => "Ersetze bestehenden Geocode",
"Use approximate geocode location" => "Benutze ungefähre geokodierte Position",
"Exclude these categories" => "Schließe diese Kategorien aus",
"Separate category IDs with a comma (,)" => "Trenne verschiedene Kategorien mit einem Komma (,)",
"Users can change site language" => "Benutzer können Sprache ändern",
"Users can change theme" => "Registrierte Benutzer können Theme ändern",
"Users can change their password" => "Benutzer können ihr Passwort ändern",
"Disable title for comments" => "Titel für Kommentare abschalten",
"Email field" => "Emailfeld",
"Website field" => "Webseitenfeld",
"Allow anonymous visitors to use the \"Contact Us\" feature." => "Erlaube es anonymen Benutzer die \"Kontaktiere uns\"-Funktion zu nutzen.",
"Contact user" => "Kontaktperson",
"Cookie name" => "Cookie Name",
"Count admin pageviews" => "Seitenaufrufe durch Admin mitzählen",
"Default charset for sending mail" => "Zeichensatz in Emails",
"default mapfile" => "Standard-Kartendatei",
"Default diff style" => "Voreingestellter Vergleichsstil",
"Only with last version" => "Nur mit letzter Version",
"Side-by-side diff" => "Seite-an-Seite-Vergleich",
"Side-by-side diff by characters" => "Seite-an-Seite-Vergleich nach Zeichen",
"Inline diff" => "Zeilenvergleich",
"Inline diff by characters" => "Zeilenvergleich nach Zeichen",
"Full side-by-side diff" => "Kompletter Seite-an-Seite-Vergleich",
"Full side-by-side diff by characters" => "Kompletter Seite-an-Seite-Vergleich nach Zeichen",
"Full inline diff" => "Kompletter Zeilenvergleich",
"Full inline diff by characters" => "Kompletter Zeilenvergleich nach Zeichen",
"Unified diff" => "Einheitlicher Vergleich",
"Side-by-side view" => "Seite-an-Seite-Ansicht",
"rows" => "Zeilen",
"Default number of rows for comment box" => "Standardanzahl Reihen für eine Kommentarbox",
"Forum reply" => "Forumantwort",
"Default Editor" => "Standardeditor",
"Simple" => "Einfach",
"Advanced" => "Fortgeschritten",
"Disable browser's autocomplete feature for username and password fields" => "Deaktiviere die Autovervollständigenfunktion des Browsers für Benutzername und Passwort Felder",
"Use direct pagination links" => "Seitennavigation über Seitenzahlen",
"Max. number of links around the current item" => "Maximimale Zahl von Links um das aktuelle Objekt",
"Max. number of links after the first or before the last item" => "Maximimale Zahl von Links nach dem ersten oder vor dem letzten Objekt",
"Show Country Flag" => "Zeige Landesflagge",
"Enable cool sites" => "Coole Links aktivieren",
"Validate URLs" => "URLs überprüfen",
"Number of columns per page when listing directory categories" => "Anzahl von Spalten, wenn die Verzeichniskategorien aufgelistet werden",
"Links per page" => "Links pro Seite",
"Method to Open Directory Links" => "Wie werden Links geöffnet?",
"Method to open directory links" => "Art und Weise Links zu öffnen",
"replace current window" => "Aktuelles Fenster ersetzen",
"new window" => "neues Fenster",
"inline frame" => "Frame innerhalb der Seite",
"Fields display order" => "Darstellungsreihenfolge der Felder",
"Re-validate user by email after" => "Re-validiere Benutzer per Email nach",
"days" => "Tage",
"Use \"-1\" for never" => "Benutze \"-1\" für niemals",
"PHP Error reporting level" => "PHP Fehler berichten",
"No error reporting" => "Keine Fehlerausgabe",
"Report all PHP errors except strict" => "Alle PHP-Fehler außer STRICT ausgeben",
"Report all PHP errors" => "Alle PHP Fehler ausgeben",
"Report all PHP errors except notices" => "Alle PHP-Fehler außer Hinweisen (NOTICES) ausgeben",
"According to PHP configuration" => "Entsprechend der PHP Einstellungen",
"Default number of comments per page" => "Standardanzahl von Kommentaren pro Seite",
"Comments default ordering" => "Standardsortierung für Kommentare",
"Question and Answer prefix on Answers" => "Frage und Antwort Präfix bei Antworten",
"Q and A" => "Frage & Antwort",
"Question ID" => "Frage ID",
"Force and limit categorization to within subtree of" => "Erzwinge und beschränke Kategorisierung auf diejenigen, die im Unterbaum enthalten sind",
"Machine Translation (by Google Translate)" => "Automatisierte Übersetzung (durch Google Translate)",
"Polls" => "Abstimmungen",
"Newsletters" => "Rundbriefe",
"Calendar" => "Kalender",
"Banners" => "Banner",
"Category" => "Kategorie",
"Score" => "Bewertung",
"Action Log" => "Aktionslog",
"Contribution" => "Beitrag",
"Multilingual" => "mehrsprachig",
"Surveys" => "Umfragen",
"Featured links" => "Linktips",
"Maps" => "Karten",
"Live support system" => "Onlinesupport-System",
"Tell a Friend" => "Erzähle dies weiter",
"HTML pages" => "HTML-Seiten",
"Contact Us" => "Kontaktiere uns",
"Comments Moderation" => "Kommentarmoderation",
"Comments Locking" => "Sperren von Kommentaren",
"Display page name as page title" => "Zeigen den Seitennamen als Seitentitel",
"JS Calendar" => "JS Kalender",
"Output should be HTML Purified" => "Ausgabe soll HTML-gereinigt sein",
"Full Screen" => "Vollbild",
"CSS Menus" => "CSS Menüs",
"Quick Permission Assignment" => "Schnell Rechte zuweisen",
"HTML Purifier" => "HTML Reiniger",
"If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature." => "Wenn Du HTML in Deinen Seiten benutzt und es wird ausgefiltert, solltest Du prüfen, ob es sich um gültigen HTML-Code handelt. Alternativ kann diese Funktion deaktiviert werden.",
"Mobile" => "Tiki Mobil",
"Morcego 3D browser" => "Morcego-3D-Browser",
"SpreadSheet" => "Tabellenkalkulation",
"Wysiwyg editor" => "WYSIWYG Editor",
"Save draft" => "Entwurf speichern",
"Friendship Network" => "Freundschaftsnetzwerk",
"Banning system" => "Benutzersperrsystem",
"Stats" => "Statistiken",
"Action calendar" => "Aktionenkalendar",
"Referer Stats" => "Referer-Statistik",
"Redirect On Error" => "Bei Fehler wieder verbinden",
"Communications (send/receive objects)" => "Kommunikation (Objekte senden/empfangen)",
"Custom Home" => "Angepasstes Home",
"Mini Calendar" => "Minikalender",
"User Preferences Screen" => "Benutzereinstellungsseite",
"User Notepad" => "Benutzernotizblock",
"User Bookmarks" => "Benutzer-Lesezeichen",
"User Contacts" => "Benutzerkontakte",
"User Watches" => "Benutzerbeobachtungspunkte",
"Group Watches" => "Gruppenbeobachtungspunkte",
"Daily Reports for User Watches" => "Tägliche Berichte für Benutzerbeobachtungspunkte",
"User Watches Translations" => "Beobachtungspunkte beobachten auch Übersetzungen",
"User Watches Languages" => "Benutzer beobachtet Sprachen",
"User Menu" => "Benutzermenü",
"User Tasks" => "Benutzeraufgaben",
"User Messages" => "Benutzernachrichten",
"User Files" => "Benutzerdateien",
"Group Alert" => "Gruppen Benachrichtigungen",
"XMLRPC API" => "XMLRPC-API",
"Debugger Console" => "Debug-Konsole",
"Check for updates automatically" => "Automatisch nach neuer Version suchen",
"Protect against CSRF with a ticket" => "Durch Ticket gegen CSRF schützen",
"Detect browser language" => "Sprache des Clients abfragen",
"Changing the page language also changes the site language" => "Die Änderungen der Seitensprache ändert auch die Site-Sprache",
"Translation assistant" => "Übersetzungsassistent",
"Urgent translation notifications" => "Dringende Übersetzungsnachricht",
"Only allow urgent translation from site language" => "Erlaube dringende Übersetzungen nur von der Site-Sprache",
"Incomplete translation notice" => "Nachricht bei unvollständiger Übersetzung",
"Multilingual structures" => "Mehrsprachige Strukturen",
"Display all languages in a single page" => "Zeige alle Übersetzungen in einer einzelnen Seite",
"Help System" => "Hilfesystem",
"Translation URLs" => "Übersetzungs-URL",
"Translation icons" => "Übersetzungs-Symbole",
"Dynamic Content System" => "Dynamischer Inhalt",
"Use File Galleries to store pictures" => "Benutze Dateiarchive um Bilder zu speichern",
"External link icon" => "Symbole für externe Links",
"Add \"rel=nofollow\" on external links" => "Füge bei externen Links \"rel=nofollow\" hinzu",
"Semantic links" => "Semantische Links",
"Display menus as folders" => "Menüs als Ordner darstellen",
"Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonyme Editoren müssen Anti-Robot Code (CAPTCHA) eingeben",
"Protect email against spam" => "Emailadressen vor Spam schützen",
"Activate" => "Aktivieren",
"Anonymous voting" => "Anonymes Abstimmen",
"Allow re-voting" => "Nochmaliges Abstimmen zulassen",
"Comments for polls" => "Kommentare für Abstimmungen",
"Comments for FAQs" => "Kommentare für FAQs",
"Search engine friendly url" => "Suchmaschinenfreundliche URLs",
"Display article title in the sefurl" => "Zeige den Artikeltitel in der suchemaschinenfreundlichen URL",
"Display blog title in the sefurl" => "Zeige den Blogtitel in der suchemaschinenfreundlichen URL",
"Redirect tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "Leite tiki-view_tracker.php?itemId=yyy auf Prefixyyy-Seite weiter",
"Perspectives" => "Perspektiven",
"Search and replace" => "Suchen und ersetzen",
"Submissions" => "Einreichungen",
"Rankings" => "Bewertungen",
"Comments for articles" => "Kommentare für Artikel",
"Content Templates" => "Inhaltsvorlagen",
"Print" => "Drucken",
"Specify notification emails when creating articles" => "Spezifiziere Benachrictigungsemails, wenn Artikel erstellt werden",
"ShareThis buttons" => "ShareThis-Schaltfläche",
"Insert a ShareThis button from www.sharethis.com." => "Füge eine \"ShareThis\"-Schaltfläche von www.sharethis.com ein.",
"Category Path" => "Kategoriepfad",
"Show category objects" => "Zeige Kategorieobjekte",
"Use PHPLayers for category browser" => "Benutze PHPLayers für den Kategoriebrowser",
"Ignore category viewing restrictions" => "Kategorie-Sichteinschränkungen ignorieren",
"Will improve performance, but may show forbidden results" => "Verbessert die Leistung. Zeigt jedoch möglicherweise verbotenen Ergebnisse",
"List pages" => "Seiten auflisten",
"Last changes" => "Neueste Änderungen",
"Orphan pages" => "Verwaiste Seiten",
"MySQL Full-Text Search" => "MySQL Volltextsuche",
"Referer Search Highlighting" => "Hervorhebung der Suchbegriffe auf den gefundenen Seiten",
"Search stats" => "Suchstatistik",
"Ignore individual object permissions" => "Individuelle Objektberechtigungen ignorieren",
"Search box" => "Suchbox",
"Object type" => "Objekttyp",
"Custom blog headings" => "Benutzerdefinierte Blogüberschriften",
"Comments on blog posts" => "Kommentare für Blogs",
"File Gallery Comments" => "Kommentare zu Dateiarchiven",
"Batch uploading" => "Stapelhochladen (batch upload)",
"Accept wiki syntax" => "Wiki-Syntax erlauben",
"Topic archiving" => "Themenarchivierung",
"Replies are empty" => "Antworten sind leer",
"If disabled, replies will quote the original post" => "Wenn die Funktion ausgeschaltet ist, werden in den Antworten die Originalposts zitiert",
"First post of a thread can have an empty body" => "Der erste Post eines Threads darf keinen leeren Text haben",
"Will be a thread title" => "Dies wird dann der Threadtitel sein.",
"Encryption method" => "Verschlüsselungsmethode",
"tikihash (old)" => "tikihash (alt)",
"Edit CSS" => "CSS bearbeiten",
"Theme Control" => "Themekonfiguration",
"Tiki Template Viewing" => "Tiki Vorlagen-Betrachtung",
"Edit Templates" => "Vorlagen bearbeiten",
"Custom Doctype" => "Benutzerdefinierter Doctype",
"Add BASE tag in the page HEAD" => "Füge ein BASE-tag im Kopfbereich (HEAD) der Seite ein ",
"Custom Site Header" => "Benutzerdefinierter Site-Kopf (Header)",
"Site Logo and Title" => "Site Logo und Titel",
"Search Bar" => "Such-Bar",
"Display current Tiki version" => "Zeige aktuelle Tikiversion",
"Site menu bar" => "Balken für Site Menü",
"Custom Center Column Header" => "Benutzerdefinierter Kopf für die Mittelspalte (Center column)",
"Left column" => "linke Spalte",
"Controls visibility of the left column of modules" => "Einstellung zur Sichtbarkeit der linken Modulspalte",
"Only if module" => "Nur wenn Module",
"Always" => "Immer",
"User Decides" => "Benutzer wählt",
"Controls visibility of the right column of modules" => "Einstellung zur Sichtbarkeit der rechten Modulspalte",
"Site location bar" => "Position des Breadcrumb Balkens",
"Larger font for" => "Größere Schrift für",
"Page name" => "Seitenname",
"Use page description" => "Seitenbeschreibung benutzen",
"Custom Site Footer" => "Benutzerdefinierte Fußzeile (Footer)",
"Bottom bar" => "Unterer Balken",
"Bottom bar icons" => "Symbole im unteren Balken anzeigen",
"Bottom bar debug" => "Server-Info im unteren Balken anzeigen",
"Webmaster Report" => "Webmaster Bericht",
"Leave blank to use the default sender email" => "Freilassen, um die standard Absenderemail zu verwenden",
"Email this page" => "Diese Seite verschicken",
"Additional layers for shadows, rounded corners or other decorative styling" => "Zusätzliche Schichten für Schatten, abgerundete Ecken oder andere dekorative Veränderungen",
"Autocomplete" => "Autovervollständigen",
"Reflection" => "Reflektion",
"Validation" => "Validierung",
"JQuery Infinite Carousel" => "JQuery unendliches Karusell",
"JQuery Sortable Tables" => "JQuery sortierbare Tabellen",
"Use Tabs" => "Tabs benutzen",
"Correct PNG images alpha transparency in IE6 (experimental)" => "Korrigiere Alphatransparenz bei PNG-Bildern beim IE6 (experimentell)",
"Content templates" => "Inhaltsvorlagen",
"Warn on edit conflict" => "Bei Bearbeitenkonflikt warnen",
"Undo" => "Rückgängig",
"Footnotes" => "Fußnoten",
"Allow HTML" => "HTML erlauben",
"Log bytes changes (+/-) in action logs" => "Logge Byte-Änderungen (+/-) in Action Logs",
"May impact performance" => "Könnte die Performance beeinträchtigen",
"Comments below wiki pages" => "Kommentare unter Wikiseiten",
"Pictures" => "Bilder",
"Export" => "Exportieren",
"WikiWords" => "WikiWorte",
"Link plural WikiWords to their singular forms" => "Mehrzahl-WikiWords auf ihre Einzahl-Variante verlinken",
"Accept dashes and underscores in WikiWords" => "Binde- und Unterstriche in WikiWords erlauben",
"History" => "Historie",
"Display IP address" => "Zeige IP Adresse",
"History all instead of only page data, description, and change comment" => "Nimm alles anstatt nur Seiten Daten, Beschreibung und geänderte Kommentare in die Historie auf",
"View page contributions by author" => "Zeige Seitenmitwirkung nach Autor",
"Discuss pages on forums" => "Seiten im Forum diskutieren",
"View source" => "Quelltext ansehen",
"Rating" => "Bewertung",
"Similar (like pages)" => "Ähnlich (wie Seiten)",
"Structures" => "Strukturen",
"Open page as structure" => "Seite als Struktur öffnen",
"Make structure from page" => "Struktur aus einer Seite entnehmen",
"Categorize structure pages together" => "Kategoriesiere Strukturseiten zusammen",
"Create webhelp from structure" => "Erzeuge Webhilfe aus einer Struktur",
"Import HTML" => "HTML importieren",
"Import pages" => "Importiere Seiten",
"UserPage prefix" => "Präfix für Benutzerseiten",
"Users can lock pages" => "Benutzer können ihre Seiten schliessen",
"MultiPrint" => "Mehrfachdruck",
"Use wiki page staging and approval" => "Benutze bei Wikiseiten \"Entwurf & Bestätigen\"",
"Pages not in structure" => "Seite die in keiner Struktur sind",
"Attachments" => "Anhänge",
"Dumps" => "Datenbankabzüge (Dumps)",
"Display show/hide icon displayed before headings" => "Zeige einblenden/ausblenden Symbol vor Überschriften",
"Use challenge/response authentication" => "Benutze Challenge-/Response-Authentifizierung",
"Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Bestätige, dass das Administratorkonto eine gültige Emailadresse hat. Andernfalls wird der Login versagt",
"Users can choose to stay in SSL mode after an HTTPS login" => "Benutzer darf nach HTTPS Login wahlweise mit SSL fortfahren",
"Users can switch between secured or standard mode at login" => "Benutzer darf zwischen HTTPS und normalem Login wählen",
"Wiki paragraph formatting" => "Wiki Absatzformatierung",
"...but still create line breaks within paragraphs" => "...erzeuge aber immer Zeilenumbrüche innerhalb der Absätze",
"Automonospaced text" => "Blockschrift durch Einrücken",
"Tables syntax" => "Tabellensyntax",
"|| for rows" => "|| für Spalten",
"<return> for rows" => "\\n für Spalten",
"AutoLinks" => "URLs in Links verwandeln",
"Open Hotwords in new window" => "Öffne Hotwords in einem neuen Fenster",
"Use Quote plugin rather than \">\" for quoting" => "Benutze Zitatplugin anstelle von \">\" für Zitierungen",
"Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator." => "Benutze drei anstelle von zwei Apostrophen für zentrierten Text. Hierdurch wrden Konflikte mit C++ resolution scope operator vermieden.",
"Users can choose to show their gender" => "Benutzer kann auswählen, sein Geschlecht zu zeigen",
"Real name" => "Echtname",
"Gender" => "Geschlecht",
"Picture (avatar)" => "Bild (avatar)",
"Number of friends" => "Anzahl der Freunde",
"Country" => "Land",
"E-mail" => "Email",
"Last login" => "Letzte Anmeldung",
"Distance" => "Entfernung",
"Manual selection of time/date" => "Manuelle Auswahl von Zeit/Datum",
"WebDAV access to Tiki" => "WebDAV Zugang zu Tiki",
"use tiki-webdav.php as the URI of the WebDAV repository" => "benutze tiki-webdav.php als URL des WebDAV Repositoriums",
"Fixed width" => "Feste Breite",
"Social networks" => "Soziale Netzwerke",
"Category Transition" => "Kategorieüberleitung",
"Invite users" => "Lade Benutzer ein",
"Load Balancer" => "Last Regler",
"Display 'MyTiki' in the application menu" => "'MeinTiki' im Anwendungsmenü anzeigen",
"Show user's contribution on the user information page" => "Zeige die Beiträge des Benutzers auf der Benutzerinformationseite an",
"Require file author's name for anonymous uploads" => "Name des Autors der Datei für anonymes Hochladen erforderlich",
"Add a Powered by Tiki link on your site's footer" => "Füge ein \"Powered by Tiki\"-Link in der Fußzeile hinzu",
"Redirect to similar wiki page" => "Weiterleiten auf eine ähnliche Wikiseite",
"User's page" => "Benutzerseite",
"Show user's information on mouseover" => "Zeige Benutzerinformationen bei Mouseover",
"Requires user's information to be public" => "Erfordert, dass die Benutzerinformationen öffentlich sind",
"Default feed format" => "Standardfeedformat",
"Feed author name" => "Name Feedautor",
"This field is mandatory unless both feed author email and homepage are empty." => "Dieses Feld ist zwingend, es sei denn, die Felder Feedautor und Homepage bleiben leer.",
"Feeed author email" => "Email des Feedauthor",
"Feed author homepage" => "Homepage des Feedauthor",
"Image path" => "Bildpfad",
"RSS basic Authentication" => "RSS Basisauthentifizierung",
"Caching time" => "Cachezeit",
"seconds" => "Sekunden",
"Use 0 for no caching" => "Benutze 0 für kein caching",
"Individual Blogs" => "Individuelle Blogs",
"Image galleries" => "Bildergalerien",
"Individual Image galleries" => "Individuelle Bildergalerien",
"File galleries" => "Dateiarchive",
"Individual file galleries" => "Individuelle Dateiarchive",
"Individual Forums" => "Individuelle Foren",
"Individual trackers items" => "Individuelle Trackereinträge",
"Calendar events" => "Individuelle Kalendereinträge",
"Directories" => "Verzeichnisse",
"Podcast directory" => "Podcastverzeichnis",
"The server must be able to read/write the directory." => "Der Server muss in das Verzeichnis schreiben und von dort lesen können.",
"Required for podcasts." => "Erforderlich für Podcasts.",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "Wenn Du Stapelhochladen in ein Verzeichnis aktivierst, musst Du ein weblesbares Verzeichnis verwenden (ausserhalb des Webspace wäre besser). Dann finde einen Weg die Dateien mittels scp, ftp oder eines anderen Protokolls dorthin hochzuladen.",
"The server must be able to read the directory." => "Der Server muss das Verzeichnis lesen zu können.",
"The directory can be outside the web space." => "Das Verzeichnis kann ausserhalb des Webspace liegen.",
"Prevent download if score becomes negative" => "Downloads bei negativer Bewertung verbieten",
"Allow download limit per file" => "Dateiweise Downloadbegrenzung erlauben",
"Allow same file to be uploaded more than once" => "Selbe Datei darf mehrfach hochgeladen werden",
"Yes, even in the same gallery" => "Ja, sogar in das gleiche Dateiarchiv",
"Only in different galleries" => "Nur in verschiedenen Dateiarchive",
"Quota for all the files and archives" => "Speicherkontingent für allen Dateien und Archive",
"Mb" => "MB",
"(0 for unlimited)" => "(0 für unbeschränkt)",
"Quota can be defined for each file gallery" => "Das Speicherkontingent kann für jedes Dateiarchiv individuell festgelegt werden",
"Default quota for each new gallery" => "Standardkontigent für jedes neues Dateiarchiv",
"Show quota bar in the list page" => "Zeige Speicherkontigentnutzung bei der Auflistung",
"Storage" => "Speicher",
"Store in database" => "Speichern in der Datenbank",
"Store in directory" => "Speichern im Verzeichnis",
"Automatic deletion of old files" => "Automatisch veraltete Dateien löschen",
"Deletion emails notification" => "Benachrichtigung per Email von der Löschung an",
"Uploaded filenames must match regex" => "Hochgeladene Dateinamen müssen diese RegEx erfüllen",
"Plain" => "flach",
"Headers Only" => "nur Köpfe",
"Title (desc)" => "Titel (absteigend)",
"Title (asc)" => "Titel (aufsteigend)",
"Topics" => "Themen",
"Posts per day" => "Einträge pro Tag",
"Description length" => "Länge der Beschreibung",
"Hide titles for forum threads" => "Verstecke Titel für Forumthreads",
"Do not prefix messages titles by 'Re: '" => "Entferne Präfix 'Re: ' bzw. 'Aw:' von Nachrichtentiteln",
"Creation Date (asc)" => "Erstellungsdatum (aufsteigend)",
"Topics (desc)" => "Themen (absteigend)",
"Threads (desc)" => "Threads (absteigend)",
"Last post (desc)" => "Neueste Einträge (absteigend)",
"Name (desc)" => "Name (absteigend)",
"Name (asc)" => "Name (aufsteigend)",
"Multilingual tags" => "Mehrsprachige Tags",
"Show tag cloud" => "Zeige Tag-Wolke",
"Maximum number of tags in cloud" => "Maximale Anzahl von Tags in der Wolke",
"Show freetags in middle column" => "Zeige Freetags in der mittleren Spalte",
"Preload freetag random tag" => "Lade automatisch einen zufälligen Tag",
"Number of Tags to show in Tag Suggestions" => "Anzahl von Tags im Tag-Vorschlag",
"Valid characters pattern" => "Muster für gültige Zeichen",
"Lowercase tags only" => "Tags nur in Kleinbuchstaben",
"Enable freetags 3D browser" => "Aktiviere den Freetag 3D Browser",
"Browser width" => "Browser-Höhe",
"Browser height" => "Browser-Breite",
"Navigation depth" => "Navigationstiefe",
"Node size" => "Knotengröße",
"Text size" => "Textgröße",
"Spring (connection) size" => "Quellengröße (Verbindung)",
"Existing page node color" => "Farbe existierender Knoten",
"Missing page node color" => "Farbe fehlender Knoten",
"Camera distance adjusted relative to nearest node" => "Kameraentfernung einstellen, relativ zum nahsten Knoten",
"Camera distance" => "Kameraentfernung",
"Field of view" => "Sichtbares Feld",
"Feed animation interval (milisecs)" => "Feed Animationsintervall (Millisekunden)",
"Friction constant" => "Reibungskostante",
"Elastic constant" => "Elastizitätskonstante",
"Eletrostatic constant" => "Elektrostatische Konstante",
"Node mass" => "Knotengewicht",
"Node charge" => "Knotenladung",
"Include \"Generate Password\" option on registration form" => "\"Passwort Generator \" als Option bei Registrierung anbieten",
"Browser title" => "Browsertitel",
"Validate new user registrations by email" => "Validiere neue Benutzer per Email",
"Home page" => "Startseite",
"Use group homepages" => "Gruppen-Homepages benutzen",
"Go to group homepage only if login from default homepage" => "Sprung zur Gruppen-Homepage nur bei Login über die Default-Homepage",
"Default language" => "Standard-Sprache",
"Cache external pages" => "Cache externe Seiten",
"Cache external images" => "Cache externe Bilder",
"Temporary directory" => "Temporäres Verzeichnis",
"Help URL" => "Hilfe URL",
"Open external links in new window" => "Externe Links in neuem Fenster öffnen",
"License page" => "Lizenzseite",
"Submit notice" => "Einreichungsnachricht",
"Full path to gdaltindex" => "Kompletter Pfad zu gdaltindex",
"Full path to ogr2ogr" => "Kompletter Pfad zu ogr2ogr",
"Display modules to all groups always" => "Module immer in allen Gruppen anzeigen",
"Hide anonymous-only modules from registered users" => "Module für Anonym bei registrierten Benutzern verstecken",
"Maximum number of articles on articles home page" => "Maximale Anzahl der Artikel auf der Artikelhauptseite",
"Site Ads and Banners Content" => "Site-Werbung und Bannerinhalt",
"URL to go to when clicking on a username" => "Angesteuerte URL, wenn Benutzername geklickt wird",
"Default" => "Standard",
"Remind/forgot password" => "Passwort vergessen",
"Each group can have its theme" => "Jede Gruppe kann ihr eigenes Theme benutzen",
"Site title" => "Site-Titel",
"Subtitle" => "Untertitel",
"Maximum number of records in listings" => "Maximale Anzahl von Einträgen in Listen",
"Maximum number of versions:" => "Maximale Anzahl von Versionen:",
"0 for unlimited versions" => "0 for unbegrenzte Anzahl an Versionen",
"Users can register" => "Benutzer können sich registrieren",
"Require validation by Admin" => "Erfordert Validierung durch einen Admin",
"Require passcode to register" => "Benötigt Code zur Registrierung",
"Passcode" => "Code",
"Alphanumeric code requierd to complete the registration" => "Alphanumerischer Code um die Registrierung abzuschließen",
"Use tracker to collect more user information" => "Benutze Tracker um mehr Informationen über Benutzer zu erhalten",
"Use the \"Admin Groups\" page to select which tracker and fields to display" => "Benutze \"Gruppenverwaltung\" um Tracker und Felder auszuwählen",
"Use tracker to collect more group information" => "Benutze Tracker um mehr Gruppeninformationen zu erhalten",
"Create a new group for each user" => "Erzeuge eine neue Benutzergruppe für jeden Benutzer",
"Remember me" => "Merken",
"Duration" => "Dauer",
"minutes" => "Minuten",
"hour" => "Stunde",
"hours" => "Stunden",
"day" => "Tag",
"week" => "Woche",
"month" => "Monat",
"year" => "Jahr",
"Use different URL as homepage" => "Benutze eine andere URL als Startseite",
"Use URL Index" => "Benutze URL Index",
"Use Tiki feature as homepage" => "Benutze diese Funktion als Startseite",
"Disable JavaScript" => "JavaScript ausschalten",
"User secret" => "Benutzergeheimnis",
"Admin secret" => "Administratorgeheimnis",
"KCW UI Configuration ID" => "KCW UI Konfigurations ID",
"Kaltura Simple Editor UI Configuration ID" => "Kaltura einfacher Editor UI Konfigurations ID",
"Kaltura Advanced Editor UI Configuration ID" => "Kaltura fortgeschrittener Editor UI Konfigurations ID",
"Kaltura \"User\"" => "Kaltura \"Benutzer\"",
"Set blogs homepage first" => "Zuerst sind Blogs einzustellen",
"Set Image gal homepage first" => "Zuerst sind Bildergalerien einzustellen",
"Image Gallery:" => "Bildergalerie:",
"File Gallery:" => "Dateiarchiv:",
"Set Forum homepage first" => "Zuerst ist die Forumseite einzustellen",
"Custom home" => "Angepasstes Home",
"Validate user's email server" => "Validiere Email Server des Benutzers",
"The group will be named identical to the user's username" => "The Benutzergruppe erhält den Namen des neuen Benutzers",
"User's choice" => "Benutzerwahl",
"If you don't know better, use '_yourPartnerID'" => "wenn Du es nicht besser weisst, nimm '_yourPartnerID'",
"Default x for map center" => "Standard X-Koordinate für die Kartenmitte",
"Default y for map center" => "Standard Y-Koordinate für die Kartenmitte",
"Default zoom level" => "Standard Zoomlevel",
"whole earth" => "Gesamte Erde",
"country size" => "Ländergröße",
"city size" => "Stadtgröße",
"village size" => "Dorfgröße",
"max zoom" => "maximaler Zoom",
"Show map mode buttons in articles list" => "Zeige eine Kartenmodusschaltfläche in der Artikelliste",
"Show map mode buttons in page list" => "Zeige eine Kartenmodusschaltfläche in der Seitenliste",
"Custom CSS" => "Benutzerdef. CSS",
"Custom JavaScript" => "Benutzerdef. JavaScript",
"Highlight group" => "Gruppe hervorheben",
"Home Blog (main blog)" => "Home-Blog (Haupt-Blog)",
"Home Forum (main forum)" => "Home-Forum (Hauptforum)",
"Home File Gallery (main file gallery)" => "Hauptverzeichnisgalerie",
"Home Gallery (main gallery)" => "Home-Galerie (Hauptgalerie)",
"HTTP port" => "HTTP-Port",
"HTTPS port" => "HTTPS-Port",
"Use HTTPS login" => "Benutze HTTPS Login",
"Allow secure (https) login" => "Erlaube sicheren Login (https)",
"Encourage secure (https) login" => "Schlage sicheren Login (https) vor",
"Consider we are always in HTTPS, but do not check" => "Gehe von HTTPS aus, aber prüfe nicht nach",
"Require secure (https) login" => "Sicherer Login (https) notwendig",
"Use CDN for JavaScript" => "Benutze CDN für JavaScript",
"Slide" => "Gleiten",
"Fade" => "Ausblenden",
"Drop (UI)" => "Fallen (UI)",
"Explode (UI)" => "Explodieren (UI)",
"Fold (UI)" => "Falten (UI)",
"Slide (UI)" => "Gleiten (UI)",
"Effect for modules" => "Effekte für Module",
"Effect for tabs" => "Effekte für Tabs",
"Speed" => "Geschwindigkeit",
"Fast" => "Schnell",
"Normal" => "normal",
"Slow" => "Langsam",
"Direction" => "Bewegungsrichtung",
"Vertical" => "vertikal",
"Horizontal" => "horizontal",
"Left" => "Linker Rand",
"Right" => "Rechter Rand",
"Up" => "aufwärts",
"Down" => "abwärts",
"Never delete versions younger than" => "Lösche nie Versionen jünger als",
"Use database for translation" => "für Übersetzung Datenbank benutzen",
"Language inclusion threshold" => "Schwelle für Einbeziehung von Sprachen",
"Layout per section" => "Layout pro Bereich",
"Create user if not in LDAP" => "Erstelle Benutzer, wenn nicht in LDAP",
"Maximum average server load threshold in the last minute" => "Maximale durchschnittliche Serverlast-Schwelle in der letzten Minute",
"Log mail in Tiki logs" => "Mails in Tiki Logs protokollieren",
"Smarty Template usage indicator" => "Smarty Vorlage Nutzungs-Anzeige",
"Use only for development, not in production because these warnings are added to emails as well, and visible to the users" => "Nur zur Entwicklung zu benutzen, nicht für den Produktiveinsatz, weil diese Warnungen sowohl in Emails eingefügt werden, als auch für andere Benutzer sichtbar sind.",
"Log SQL" => "SQL-Abfragen protkollieren",
"Log queries using more than (seconds)" => "Protokolliere Abfragen, die mehr als ... Sekunden benötigen",
"Use email as username" => "Benutze Email als Benutzername",
"Obscure email when using email as username if possible (coverage will not be complete)" => "Verdecke Emailadresse, wenn der Benutzername gleich der Emailadresse ist (wenn möglich). Die Verdeckung ist ggf. nicht vollständig",
"Long date format" => "Langes Datumsformat",
"Long time format" => "Langes Zeitformat",
"%A %d of %B, %Y" => "%A, %d. %B %Y",
"Force lowercase" => "Erzwinge Kleinbuchstaben",
"Mail end of line" => "Zeilenumbruch in Emails",
"full path to mapfiles" => "Kompletter Pfad zu Kartendateien",
"Wiki Page for Help" => "Wikiseite für Hilfe",
"Wiki Page for Comments" => "Wikiseite für Kommentare",
"Maximum length" => "Maximale Länge",
"Memcache" => "Speichercaching",
"Requires the PHP memcache extension." => "Erfordert die PHP memcache Erweiterung",
"Memcache compression" => "Memcachekompression",
"Menu icons" => "Menü-Symbole",
"Default path for the icons" => "Standardpfad für Smboldateien",
"Maximum mailbox size (messages, 0=unlimited)" => "Mailbox-Größe (in Nachrichten, 0=unbegrenzt)",
"Maximum mail archive size (messages, 0=unlimited)" => "Mailboxarchiv-Größe (in Nachrichten, 0=unbegrenzt)",
"Maximum sent box size (messages, 0=unlimited)" => "Ausgangsordner-Größe (in Nachrichten, 0=unbegrenzt)",
"geo.position" => "Geo Position",
"geo.region" => "Geo Region",
"geo.placename" => "Geo Ort",
"Minimum length" => "Minimale Länge",
"\"More Like This\" algorithm" => "Algorithmus für \"Ähnliches\"",
"Basic" => "Basis",
"Weighted" => "gewichtet",
"Minimum amount of tags in common" => "Minimale Anzahl von Tags im Allgemeinen",
"Multi-domain Configuration" => "Multi-domain Konfiguration",
"One domain per line. Comma separated with perspective ID. Ex.: tiki.org,1" => "Eine Domain pro Zeile. Perspektiven werden durch Komme getrennt. Bsp.: tiki.org,1",
"Use relative (next / previous) pagination links" => "Benutze relative Paginierungslinks (nächstes/vorheriges Objekt)",
"Wiki buttons" => "Wiki Schaltflächen",
"Bottom" => "Unten",
"Neither" => "Weder noch",
"A page can occur multiple times in a structure" => "Eine Seite kann innerhalb einer Struktur mehrfach auftreten",
"Display fast move links (by 10 percent of the total number of pages) " => "Zeige Links zum schnellen Navigieren (10 Prozent der Gesamtzahl der Seiten) ",
"Hide pagination when there is only one page" => "Verberge Paginierungslinks, wenn es nur eine Seite gibt",
"Use Icons" => "Benutze Symbole",
"Display 'First' and 'Last' links" => "Zeige Links für 'erstes' und 'letztes' Objekt",
"PAM service" => "PAM Dienst",
"Currently unused" => "momentan unbenutzt",
"Require characters and numerals" => "Erfordert Buchstaben und Ziffern",
"Password expires after" => "Passwort läuft ab nach",
"Payment" => "Bezahlung",
"Payment System" => "Bezahlsystem",
"PayPal: see PayPal.com - Cclite: Community currency" => "PayPal: siehe PayPal.com - Cclite: Gemeinschaftswährung",
"Email address" => "Emailadresse",
"Paypal Environment" => "Paypalumgebung",
"Production" => "Produktion",
"Currency" => "Währung",
"Default acceptable payment delay" => "Standard für akzeptierbare Zahlungsverzögerung",
"Wiki page containing the instruction to send manual payment like check" => "Wiki Seite, die Anwendungen bezüglich anderer Bezahlmethoden (z.B. Scheck) enthält",
"Wiki page" => "Wiki Seite",
"Prefix to the invoice" => "Präfix für die Rechnung",
"Send to URL" => "Leite auf folgende URL weiter",
"On permission denied, display login module (for Anonymous)" => "Wenn keine Rechte vorhanden sind, zeige das Loginmodul (für anonymen Benutzer)",
"Show categories" => "Kategorien anzeigen",
"Show objects" => "Zeige Objekte",
"Multiple polls per object" => "Multiple Abstimmungen pro Objekt",
"PDF from URL" => "PDF von einer URL",
"Host name" => "Hostname",
"Proxy port" => "Proxy Port",
"Quantify change size" => "Quantifiziere Veränderungsgröße",
"Advanced Rating" => "Fortgeschrittene Bewertung",
"Rating recalculation mode" => "Methode zur Neuberechnung der Bewertung",
"Recalculate on vote" => "Neuberechnung beim Bewerten",
"Randomly recalculate oldest ratings (on load)" => "Zufälliges Neuberechnen älterer Bewertungen (beim Laden)",
"Randomly recalculate oldest ratings (on vote)" => "Zufälliges Neuberechnen älterer Bewertungen (beim Bewerten)",
"Cron job (must be set manually)" => "Cron job (muss manuell eingestellt werden)",
"Recalculation count" => "Neuberechnungszähler",
"Use ReCaptcha" => "Benutze ReCaptcha",
"Record untranslated strings" => "Eintrag nicht übersetzt",
"Restrict supported languages" => "Beschränke unterstützte Sprachen",
"Refresh rate" => "Aktualisierungsrate",
"Minimum length of search word" => "Mindestlänge des Suchwortes",
"Max. number of words containing a syllable" => "Maximalzahl einsilbiger Wörter",
"Max. age in hours of syllable search cache" => "Maximales Alter in Stunden im Cache für Silbensuche",
"LRU list purging rate" => "Löschrate der LRU Liste",
"LRU list length" => "Länge der LRU Liste",
"Wiki Pages" => "Wikiseiten",
"Restrict search language by default" => "Beschränke standardmäßig die Suchsprache",
"Parse wiki syntax in comments in all sections apart from Forums" => "Parse den Wikisyntax in Kommentaren in allen Abschnitten (außer Foren)",
"Use \"Accept wiki syntax\" for forums in admin forums page" => "Benutze \"Akzeptiere Wikisyntax\" für Foren auf der Seite Admin Forum",
"Sender email" => "Emailabsender",
"Timezone" => "Zeitzone",
"Session storage location" => "Speicherort für Sitzungsdaten",
"Default (from php.ini)" => "Standard (aus php.ini)",
"Database" => "Datenbank",
"Session lifetime" => "Lebenszeit von Sitzungdaten",
"Value provided in minutes" => "Wert ist in Minuten anzugeben",
"Create with default group" => "Erstelle mit Standardgruppe",
"Shipping Service" => "Transportservice",
"Short date format" => "Kurzes Datumsformat",
"Short time format" => "Kurzes Zeitformat",
"Display available translations" => "Zeige verfügbare Übersetzungen",
"Close site (except for those with permission)" => "Site schließen (außer für diejenigen mit Rechten)",
"Message to display" => "Anzuzeigende Nachricht",
"Locations (breadcrumbs)" => "Positionszeichen (Brotkrumen, breadcrumbs)",
"Choices" => "Auswahlen",
"Site title location" => "Anordnung des Site-Titels",
"After" => "nach",
"Before" => "vor",
"Browser title display mode" => "Browser-Titel Anzeigemodus",
"Most specific first" => "Genauestes Element zuerst",
"Least specific first (site)" => "Allgemeinstes Element zuerst",
"Current only" => "Nur aktuelles Element",
"Favicon icon file name" => "Favicon Dateiname des Symbols",
"Favicon icon MIME type" => "Favicon MIME-Typ des Symbols",
"Publish" => "veröffentlichen",
"Logo source (image path)" => "Logo Quelle (Bildpfad)",
"Logo background color" => "Logo Hintergrundfarbe",
"Examples:" => "Beispiele:",
"Logo background style" => "Logo Hintergrundstyle",
"Logo alignment" => "Logoausrichtung",
"Logo title (on mouse over)" => "Logotitel bei Mouseover",
"Alt. description (e.g. for text browsers)" => "Logo Alternativer Text (ALT)",
"Slideshow theme" => "Diashowtheme",
"Smarty Security" => "Smarty Sicherheit",
"Modified" => "Geändert",
"Never check (performance)" => "Nie prüfen (performant)",
"Always (development, slow)" => "Immer (Entwicklung, langsam)",
"Theme options" => "Themeoptionen",
"Check frequency" => "Prüfhäufigkeit",
"Each day" => "täglich",
"Each week" => "wöchentlich",
"Each month" => "monatlich",
"Skip date for same day" => "Datum bei Anzeige für den heutigen Tag weglassen",
"Domain prefix handling" => "Behandlung des Domain Präfix",
"Leave as-is" => "Lass es wie es ist",
"Remove the www" => "Entferne das WWW",
"Add the www" => "Füge WWW hinzu",
"Domain redirects" => "Domainweiterleitungen",
"One entry per line. Comma separated list: old, new" => "Ein Eintrag pro Zeile. Einträge sind mit Komma zu trennen: alte Domain, neue Domain",
"unsuccessful login attempts" => "erfolglosen Login Versuchen",
"URL a user is redirected to after account validation" => "URL auf die ein Benutzer nach Validierung seines Kontos weitergeleitet wird",
"Account validated successfully." => "Konto erfolgreich bestätigt.",
"URL an anonymous is redirected when page not found" => "URL auf die ein anonymer Benutzer weitergeleitet wird, wenn die Seite nicht gefunden wird",
"Close site when server load is above the threshold  (except for those with permission)" => "Site schließen wenn der die Serverlast über der Schwelle liegt (außer für diejenigen mit Rechten)",
"Use proxy" => "Proxy benutzen",
"Use context menus for actions (icons)" => "Benutze Kontextmenüs für Aktionen (Symbole)",
"Use context menus for actions (text)" => "Benutze Kontextmenüs für Aktionen (Text)",
"Display UserTracker information on the user information page" => "Zeige Benutzertrackerinformationen auf der Benutzerinformationseite",
"Use the format: trackerId, fieldId1, fieldId2, ..." => "Benutzer folgendes Format: trackerId, fieldId1, fieldId2, ...",
"Store full-size copy of avatar in file gallery" => "Speichere Kopie des Avatar in voller Größe in den Dateiarchiven",
"File gallery to store full-size copy of avatar in" => "Dateiarchiv benutzen um eine Kopie des Avatars in voller Größe zu speichern",
"Display who viewed my stuff on the user information page" => "Zeige an, wer meine Sachen auf der Benutzerinformationseite angesehen hat",
"Number of days to consider who viewed my stuff" => "Anzahl Tage, um zu überdenken, wer meine Sachen angesehen hat",
"Show to others who viewed my stuff on the user information page" => "Zeige anderen auf der Benutzerinformationseite, wer meine Sachen angesehen hat",
"Sort Order" => "Sortierungsreihenfolge",
"Maximum number of users to show in drop down lists" => "Maximale Anzahl Benutzer, die in einer Dropdown-Liste angezeigt werden",
"Use pretty trackers for registration form" => "Benutze schöne Tracker für das Registrierungsformular",
"Registration pretty tracker template" => "Vorlage für schönen Registrierungstracker",
"Synchronize long/lat/zoom to google maps field" => "Synchronisiere Längen-/Breitengrad/Zoom mit Googlemaps Feld",
"Put user in group only if categorized within" => "Weise Benutzer einer Gruppe zu, wenn in einer der folgenden Kategorien",
"Score ascending" => "Punkte aufsteigend",
"Score descending" => "Punkte absteigend",
"Name ascending" => "Name aufsteigend",
"Name descending" => "Name absteigend",
"Login ascending" => "Login aufsteigend",
"Login descending" => "Login absteigend",
"Username pattern" => "Muster für Benutzernamen",
"Displayed time zone" => "Angezeigte Zeitzone",
"Use site default to show times" => "Benutze Site Standardeinstellungen für die Zeitanzeige",
"Detect user timezone (if browser allows). Otherwise use site default." => "Benutzer die Zeitzone des Benutzers (wenn der Browser dies erlaubt). Sonst Standardzeitzone der Site benutzen.",
"Number of visited pages to remember" => "Anzahl besuchter Seiten zum Vorhalten",
"User information" => "Benutzerangaben",
"Private" => "privat",
"Public" => "öffentlich",
"Use double-click to edit pages" => "Doppelklick zum Ändern von Seiten benutzen",
"Tasks per page" => "Aufgaben pro Seite",
"Messages per page" => "Nachrichten pro Seite",
"Allow messages from other users" => "Nachrichten von anderen Anwendern erlauben",
"Notify sender when reading mail" => "Absender benachrichtigen, wenn Email gelesen wird",
"Send me an email for messages with priority equal or greater than" => "Schicke mir eine Email beim Eintreffen von Nachrichten mit Priorität größer gleich",
"Auto-archive read messages after" => "Autoarchiviere gelesene Nachrichten nach",
"My pages" => "Meine Seiten",
"My blogs" => "Meine Blogs",
"My galleries" => "Meine Galerien",
"My messages" => "Meine Nachrichten",
"My tasks" => "Meine Aufgaben",
"My forum topics" => "Meine Foren-Themen",
"My forum replies" => "Meine Foren-Antworten",
"My items" => "Meine Einträge",
"Character set for mail" => "Emailzeichensatz",
"Show user's info on mouseover" => "Benutzer-Info bei Mouseover anzeigen",
"Validator emails (separated by comma) if different than the sender email" => "Email des/der Validierer (durch Komma getrennt) wenn von Absenderemail abweichend",
"Display by default" => "Standardmäßig anzeigen",
"Path (if stored in directory)" => "Pfadangabe (wenn in einem Verzeichnis gespeichert wird)",
"Edit idle timeout" => "Bearbeiten Idle-Timeout",
"Log errors to Tiki log" => "Logge Fehler im Tiki Log",
"Flash Media Encoder shared secret" => "Flash Media Encoder geteiltes Geheimnis",
"Allow viewing HTML mails?" => "Anzeigen von HTML Mails erlauben?",
"Maximum size for each attachment" => "Maximale Größe pro Anlage",
"500Kb" => "500 kB",
"1Mb" => "1 MB",
"1.5Mb" => "1.5 MB",
"2Mb" => "2 MB",
"2.5Mb" => "2.5 MB",
"3Mb" => "3 MB",
"Unlimited" => "unbegrenzt",
"Include a flag by each e-mail to quickly flag/un-flag them?" => "Soll eine Flagge zu jeder Email hinzugefügt werden um sie schnell zu markieren/entmarkieren?",
"Last editor" => "Letzter Bearbeiter",
"Wiki link format" => "Wikilink-Format",
"Strict will only be basic characters like a-z and 0-9. If you have accented or special characters in page names, you should not use strict." => "Strict erlaubt nur Basiszeichen (wie a-z und 0-9). Wenn in Seitennamen besondere Zeichen (Akzente, Sonderzeichen, Umlaute) benutzt werden, sollte Strict nicht benutzt werden.",
"Complete" => "Komplett",
"Display page name above page" => "Zeige den Seitennamen oberhalb der Seite",
"Creator & Author" => "Ersteller & Autor",
"Business style" => "Geschäftlich",
"Collaborative style" => "Kollaborativ",
"Page last modified on" => "Seite zuletzt geändert am",
"none (disabled)" => "Keine (abgeschaltet)",
"Wiki action bar location" => "Anordnung Wiki Aktionenzeile",
"Both" => "Beides",
"Wiki navigation bar location" => "Anordnung Wiki Navigationszeile",
"Wiki top line location" => "Anordnung Wiki Topzeile",
"Cache wiki pages (global)" => "Wikiseiten cachen (global)",
"no cache" => "kein Cache",
"minute" => "Minute",
"Allow comments per wiki page" => "Erlaube Kommentare pro Wikiseite",
"Disable" => "Ausschalten",
"Enable (default On)" => "Anschalten (Standarf: an)",
"Enable (default Off)" => "Anschalten (Standarf: aus)",
"Enable edit plugin icons" => "Aktiviere Symbole zum Bearbeiten von Plugins",
"Requires JavaScript" => "Erfordert JavaScript",
"Prevent special characters in page names" => "Vermeide Sonderzeichen in Seitennamen",
"Encourage contribution to wiki pages by anonymous" => "Animiere zu Beiträgen zu Wikiseiten durch anonyme Benutzer",
"Warn before page lock timeout" => "Warne bevor die Seite mit Timeout schliesst",
"Dynamic variables" => "Dynamische Variablen",
"Multilingual dynamic variables" => "Mehrsprachige dynamische Variablen",
"Edit section" => "Bearbeitungsbereich",
"Edit section level" => "Bearbeitungsbereich Stufe",
"Toggle display of section and plugin edit icons" => "Schalte die Anzeige des Bereichs und der Plugin-Bearbeitungssymbole um",
"Allow minor edits" => "Erlaube geringfügige Änderungen",
"Slideshows" => "Diashows",
"Page creators are admin of their pages" => "Ersteller sind auch Verwalter ihrer Seiten",
"Create watch for author on page creation" => "Beobachtungspunkt für Seite beim Erstellen setzen",
"Enable watches on comments" => "Beobachtungspunkte auf Kommentare aktivieren",
"Enable watch events when I am the editor" => "Beobachtungspunkt für Seite beim Ändern setzen",
"Watch minor edits" => "Beobachte untergeordnete Änderungen",
"Page ID" => "Seiten ID",
"Name length" => "Namenlänge",
"Last modification date" => "Datum der letzten Veränderung",
"Last modified by" => "Zuletzt bearbeitet von",
"Edit comments" => "Kommentare bearbeiten",
"Edit Comment length" => "Länge des Bearbeitungskommentars",
"Versions" => "Versionen",
"Categories" => "Kategorien",
"Categories path" => "Kategoriepfade",
"Default sort order" => "Standard-Sortierreihenfolge",
"Sort Direction" => "Sortierreihenfolge",
"Descending" => "Absteigend",
"Ascending" => "Aufsteigend",
"Enable wiki 3D browser" => "Wiki 3D Browser aktivieren",
"Load page on navigation" => "Seite beim Navigieren laden",
"Forum for discussion" => "Forum für Diskussion",
"Similar pages only listed in same language" => "Ähnliche Seiten nur in der gleichen Sprache auflisten",
"Mandatory edit summary on wiki pages" => "Vorschreiben einer Zusammenfassung bei Bearbeitung von Wikiseiten",
"Structure navigation bar location" => "Anordnung der Navigationsleiste für Strukturen",
"Simple wiki ratings" => "Einfache Wiki Bewertungen",
"Wiki rating options" => "Wiki Bewertungsoptionen",
"Redirect pages using these prefix alias semantic links" => "Weiterleiten pages using these prefix alias semantic links",
"Staging" => "Entwurf",
"Plugin %0" => "Plugin Zitat",
"Wysiwyg Editor is optional" => "Wysiwyg Editor ist optional",
"Wysiwyg Editor is displayed by default" => "Wysiwyg Editor wird standardmäßig angezeigt",
"Reopen with the same editor" => "Wieder-Öffnen einer Seite mit dem gleichen Editor",
"Content is parsed like wiki page" => "Der Inhalt wird wie eine Wikiseite geparsed ",
"Content is partially wiki parsed" => "Der Inhalt wird partiell wikigeparsed",
"Wysiwyg editor skin" => "Wysiwyg Editor Oberfläche",
"Use Wiki syntax in WYSIWYG" => "Benutze den Wikisyntax in WYSIWYG",
"Font names" => "Schriftarten",
"Username" => "Benutzername",
"Password" => "Passwort",
"Security" => "Sicherheit",
"Mail Sender" => "Mailversand über",
"Authentication" => "Authentifizierung",
"Page cannot be found" => "Seite nicht gefunden",
"Wiki top pages" => "Wiki-Top-Seiten",
"Most relevant pages" => "Relevanteste Seiten",
"Relevance" => "Relevanz",
"Wiki last pages" => "Neueste Wiki-Seiten",
"Topic date" => "Themendatum",
"Forums most read topics" => "Foren mit den meistgelesenen Themen",
"Forums best topics" => "Foren mit den beliebtesten Themen",
"Forums most visited forums" => "Meistbesuchte Foren",
"Forums with most posts" => "Foren mit den meisten Beiträgen",
"Wiki top galleries" => "Wiki Top Galerien",
"Wiki top file galleries" => "Wiki Top Dateiarchive",
"Wiki top images" => "Wiki Top Bilder",
"Wiki top files" => "Wiki Top Dateien",
"Wiki last images" => "Wiki neueste Bilder",
"Upload date" => "Hochlade-Datum",
"Wiki last files" => "Wiki neueste Dateien",
"Top articles" => "Top Artikel",
"Most visited blogs" => "Meistbesuchte Blogs",
"Most active blogs" => "Aktivste Blogs",
"Blogs last posts" => "Neueste Blog-Einträge",
"Post date" => "Eintragsdatum",
"Wiki top authors" => "Wiki Top Autoren",
"Pages" => "Seiten",
"Top article authors" => "Top Artikel-Autoren",
"Registered" => "Registriert",
"You will receive an email with information to login for the first time into this site" => "Du erhälst in Kürze eine Email, die Informationen enthält, wie Du Dich zum ersten mal anmelden kannst.",
"Password is required" => "Passwort ist erforderlich",
"The passwords don't match" => "Die Passwörter stimmen nicht überein",
"User already exists" => "Benutzer existiert bereits",
"Invalid username" => "Benutzername ungültig",
"Username is too long" => "Benutzername zu lang",
"characters long" => "Zeichen lang sein",
"Wrong passcode. You need to know the passcode to register at this site" => "Falsches Passwort. Du musst Dein Passwort kennen, um Dich an dieser Site zu registrieren",
"uploaded the file" => "lud die Datei",
"change" => "Änderung",
"changes" => "Änderungen",
"No changes" => "Keine Änderungen",
"Today" => "Heute",
"and" => "und",
"more changes of the same type..." => "weitere Aenderungen der selben Art...",
"changed the picture gallery" => "aenderte die Bildergalerie",
"uploaded the picture" => "lud das Bild",
"onto" => "nach",
"removed the picture" => "entfernte das Bild",
"from" => "von",
"edited the wikipage" => "änderte die Seite",
"this history" => "diese Änderung",
"all history" => "alle Änderungen",
"edited the file gallery" => "änderte das Dateiarchiv",
"removed the file" => "entfernte die Datei",
"created the subcategory" => "erstellte die Unterkategorie",
"removed the subcategory" => "entfernte die Unterkategorie",
"edited the category" => "änderte die Kategorie",
"removed the article" => "löschte den Artikel",
"created the article" => "erstellte den Artikel",
"edited the article" => "änderte den Artikel",
"replied to the blog" => "antwortete auf den Blog",
"created the topic" => "erstellte das Thema",
"at forum" => "im Forum",
"replied" => "antwortete",
"to the topic" => "auf das Thema",
"Nothing has happened." => "Es wurde nichts gändert",
"Login" => "Anmeldung",
"See other users' profiles" => "Profil eines anderen Benutzers ansehen",
"Have your profile seen" => "Benutzer sieht sich Ihr Profil an",
"Make friends" => "Freundschaft schließen",
"Receive message" => "Nachricht empfangen",
"Send message" => "Nachricht schicken",
"Read an article" => "Artikel lesen",
"Publish an article" => "Artikel veröffentlichen",
"Have your article read" => "Benutzer liest Deinen Artikel",
"Create New File Gallery" => "Neues Dateiarchiv anlegen",
"Upload new file to gallery" => "Datei in Archiv hochladen",
"Download other user's file" => "Datei eines anderen Benutzers herunterladen",
"Have your file downloaded" => "Benutzer läd eine Deiner Dateien herunter",
"Create a new image gallery" => "Neue Bildgalerie anlegen",
"Upload new image to gallery" => "Bild in Galerie hochladen",
"See other users' galleries" => "Galerie eines anderen Benutzers anschauen",
"See other users' images" => "Bild eines anderen Benutzers betrachten",
"Have your gallery seen by other users" => "Benutzer betrachtet Deine Galerie",
"Have your image seen" => "Benutzer betrachtet eines Deiner Bilder",
"Create new blog" => "Neuen Blog erstellen",
"Post in a blog" => "Eintrag in Blog vornehmen",
"Read other users' blogs" => "Blog eines anderen Benutzers lesen",
"Have your blog read" => "Benutzer liest Deinen Blog",
"Create a new wiki page" => "Neue Wiki-Seite erstellen",
"Edit an existing page" => "Vorhandene Wiki-Seite bearbeiten",
"Attach file" => "Datei anhängen",
"Gallery" => "Galerie",
"Image" => "Bild",
"Article" => "Artikel",
"Blog post" => "Blog-Eintrag",
"Unknown" => "Unbekannt",
"Directory category" => "Verzeichniskategorie",
"Last articles." => "Neueste Artikel.",
"Tiki RSS feed for articles" => "Tiki RSS Artikel Feed",
"Last posts to weblogs." => "Neueste Weblog-Einträge.",
"Tiki RSS feed for weblogs" => "Tiki RSS Weblog Feed",
"Last sites." => "Neueste Sites.",
"Tiki RSS feed for directory sites" => "Tiki RSS Feed von Linkverzeichnis",
"Last files uploaded to the file galleries." => "Neueste Dateien in den Dateiarchiven.",
"Tiki RSS feed for file galleries" => "Tiki RSS Dateiarchiv Feed",
"Tiki RSS feed for the file gallery: " => "Tiki RSS Feed von Dateiarchiv: ",
"Tiki RSS feed for forum: " => "Tiki RSS Feed von Forum: ",
"Last topics in forums." => "Neueste Forenthemen.",
"Tiki RSS feed for forums" => "Tiki RSS Foren Feed",
"Tiki RSS feed for image galleries" => "Tiki RSS Feed von Bildergalerien",
"Tiki RSS feed for the image gallery: " => "Tiki RSS Feed von Bildergalerie: ",
"Tiki RSS feed for individual trackers: " => "Tiki RSS Feed von Tracker: ",
"Last modifications to the Wiki." => "Zuletzt geänderte Wikiseiten.",
"Tiki RSS feed for the wiki pages" => "Tiki RSS Wiki Feed",
"new" => "neu",
"sheet" => "Tiki Tabellen",
"Click for Help" => "Hilfe!",
"No records to display" => "Keine anzuzeigenden Einträge",
"Prev" => "vorherige",
"Next" => "nächste",
"tip" => "Tip",
"comment" => "Kommentar",
"warning" => "Warnung",
"note" => "Hinweis",
"errors" => "Fehler",
"Tab View" => "mit Tabs",
"No Tabs" => "ohne Tabs",
"This edit session will expire in" => "Die Bearbeitungszeit läuft ab in",
"click here" => "klicke hier",
"<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />" => "<strong>Danke, dass Du die neue CKEditor-Einbindung in Tiki 6 probierst</strong><br /><br />",
"Ckeditor Development Notice" => "CKEditor Entwicklungsnachricht",
"Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile:" => "Einige Deiner Einstellungen sollten anders sein, damit diese Funktion am besten läuft. Hier hier um das empfohlene Profil anzuwenden:",
"Admin Feature" => "Funktion verwalten",
"Hide" => "Verbergen",
"help" => "Hilfe",
"Hour" => "Stunde",
"Interactive Translation" => "Interaktive Übersetzung",
"Cancel" => "Abbrechen",
"character(s) too long - please edit it." => "Zeichen zu lang. Bitte anpassen.",
"Filter:" => "Filtern:",
" (found in " => " (gefunden in ",
"Select All" => "Alle auswählen",
"Invert Sort" => "Sortierungsreihenfolge ändern",
"Toggle sections" => "Auswahl umschalten",
"Show only selected" => "Zeige nur Ausgewählte",
"You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "Du solltest ggf. auch das Recht tiki_p_modify_object_categories im Abschnitt Tiki setzen",
"second" => "Sekunde",
"months" => "Monate",
"done" => "fertig",
"Task" => "Aufgabe",
"Priority" => "Priorität",
"Start date:" => "Anfangsdatum",
"End date:" => "Enddatum",
"Friend" => "Freund",
"Last seen on" => "Zuletzt online am",
"(idle for %s seconds)" => "(untätig für %s Sekunden)",
"User information - Click for more info" => "Benutzer Information. Klicke auf den Namen für weitere Details",
"Yes" => "Ja",
"No" => "Nein",
"pvs" => "Besuche",
"Use this tree to copy the structure" => "Diesen Baum benutzen zum Erstellen der Struktur",
"created from structure" => "aus Struktur erstellt",
"Table of contents" => "Inhaltsverzeichnis",
"text" => "Text",
"Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator." => "Erforderliche Funktion: <b>%0</b>. Wenn Du nicht die erforderlichen Rechte hast, diese Funktion zu aktivieren, frage den Siteadministrator.",
"unknown error" => "Unbekannter Fehler",
"You are not logged in" => "Du bist nicht angemeldet",
"You do not have permission to view this section" => "Zugriff verweigert. Du kannst diesen Bereich nicht betrachten",
"You are banned from" => "Du wurdest verbannt von",
"wiki" => "Wiki",
"img-g" => "Bildergalerien",
"file-g" => "Dateiarchive",
"faqs" => "FAQs",
"quizzes" => "Quiz",
"arts" => "Artikel",
"blogs" => "Blogs",
"forums" => "Foren",
"Plugin execution pending approval" => "Pluginausführung wartet auf Bestätigung",
"Click to edit dynamic variable" => "Klicken zum Bearbeiten der dynamischen Variable",
"Update variables" => "Variablen aktualisieren",
"Edit Section" => "Bearbeite Abschnitt",
"Show" => "Zeigen",
"sad" => "traurig",
"confused" => "verwirrt",
"mad" => "sauer",
"%d points" => "%d Punkte",
"Removed" => "Gelöscht",
"at" => "um",
"Unknown language" => "unbekannte Sprache",
"Click here to confirm your action" => "Hier klicken zum Bestätigen",
"Bold" => "Fett",
"Italic" => "Kursiv",
"Underline" => "Unterstrichen",
"Strikethrough" => "durchgestrichen",
"Non-parsed (Wiki syntax does not apply)" => "Non-parsed (Wikisyntax gilt hier nicht)",
"Align Center" => "zentrieren",
"Page Break" => "Seitenumbruch",
"Email" => "eMail",
"Heading" => "Überschrift",
"Title bar" => "Titelbalken",
"Unordered List" => "Unsortierte Auflistung",
"Ordered List" => "Numerierte Liste",
"Special Characters" => "Spezielle Zeichen",
"Foreground color" => "Vordergrundfarbe",
"External Link" => "Externer Link",
"Table Builder" => "Table erstellen",
"Find Text" => "Text finden",
"Text Replace" => "Text ersetzen",
"Full Screen Edit" => "in Vollbild bearbeiten",
"Wiki Help" => "Wiki Hilfe",
"Wysiwyg Help" => "Wysiwyg Hilfe",
"Choose or upload images" => "Wähle Bilder oder lade hoch",
"Find" => "Suchen",
"Admin Toolbars" => "Verwalte Toolbars",
"Item" => "Eintrag",
"Subject" => "Betreff",
"Tracker was modified at " => "Tracker wurde verändert auf ",
"text field" => "Eingabefeld",
"size" => "Größe",
"textarea" => "Textbereich",
"checkbox" => "Schalter",
"numeric field" => "Zahl",
"drop down" => "Auswahlliste",
"drop down with other textfield" => "Listenfeld mit einem Textfeld verknüpft",
"user selector" => "Nutzerauswahl",
"group selector" => "Gruppenauswahl",
"date and time" => "Datum und Zeit",
"jscalendar" => "JS Kalender",
"action" => "Aktion",
"header" => "Überschrift einfügen",
"category" => "Kategorie",
"items list" => "Objektliste",
"email" => "Email",
"url" => "URL",
"system" => "System",
"attachment" => "Anhang",
"freetags" => "Freetags",
"stars" => "Sterne",
"open" => "offen",
"pending" => "anstehend",
"closed" => "geschlossen",
"Message" => "Nachricht",
"child categories" => "Unterkategorien",
"objects in category" => "Objekte in Kategorie",
"Password should be at least" => "Passwort sollte mindestens",
"Password must contain both letters and numbers" => "Passwort muss sowohl Buchstaben als auch Zahlen enthalten",
"The registration mail can't be sent. Contact the administrator" => "Die Registrierungs-Mail konnte nicht gesendet werden. Benachrichtige bitte den Administrator.",
"here" => "hier",
"You need to set your Kaltura account details: " => "Du musst Deine Kaltura Kontodaten eintragen: ",
"Personal Phone" => "privates Telefon",
"Personal Mobile" => "privates Mobiltelefon",
"Personal Fax" => "privates Fax",
"Work Phone" => "Telefon Arbeit",
"Work Mobile" => "Mobiltelefon Arbeit",
"Work Fax" => "Fax Arbeit",
"Company" => "Firma",
"Organization" => "Organisation",
"Department" => "Abteilung",
"Division" => "Branche",
"Job Title" => "Beruf",
"Street Address" => "Straße",
"City" => "Stadt",
"State" => "Status",
"Zip Code" => "PLZ",
"No subject" => "Kein Betreff vorhanden",
"Add to cart" => "Zum Warenkorb hinzufügen",
"Adds a product to the virtual cart. The cart can be manipulated using the cart module." => "Fügt ein Produkt zum Warenkorb hinzu. Der Warenkorb kann durch das Warenkorbmodul konfiguriert werden.",
"Location" => "Ort",
"Button label" => "Bezeichnung Schaltfläche",
"Add Event to Google Calendar" => "Füge Ereignis zum Googlekalender hinzu",
"Creates an icon for a user to add an event to a Google Calendar" => "Erzeugt ein Symbol für einen Benutzer um ein Ereignis zu einem Googlekalender hinzuzufügen",
"One" => "Eine",
"Displays various information about the client." => "Zeigt verschiedene Informationen über den Client.",
"Info" => "Information",
"Anchor Link" => "Ankerlink",
"Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin." => "Erzeugt einen Ankerlink innerhalb einer Seite. Anker können mit dem ANAME Plugin erzeugt werden.",
"Anchor Name" => "Ankername",
"Page Name" => "Seitenname",
"linktext" => "Link-Beschriftung",
"Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin." => "Fügt einen Anker in eine Wikiseite ein. Anker können mithilfe des ALINK Plugins verlinkt werden.",
"Image Annotation" => "Bildkommentierung",
"Displays an image and enables users to define zones to highlight information on the image." => "Zeigt ein Bild an und erlaubt es den Benutzern, Zonen auf dem Bild zu markieren, um Informationen hervorzuheben.",
"Archive Builder" => "Archiv erzeugen",
"Builds a zip archive containing the specified data from tikiwiki." => "Erzeugt ein Zip-Archiv, welches spezifische Daten der Tikiwiki enthält.",
"Field" => "Feld",
"Article List" => "Artikelliste",
"Inserts a list of articles in the page." => "Fügt eine Liste von Artikeln in eine Seite ein.",
"Start Date" => "Startdatum",
"Attachment" => "Anhang",
"Displays an attachment or a list of them" => "Zeigt einen Anhang oder eine Liste davon an.",
"File" => "Datei",
"Page" => "Seite",
"Page \"%0\" does not exist" => "Seite \"%0\" nicht vorhanden",
"Attributes" => "Attribute",
"Allows for generic attributes to be assigned to the current object. Attributes are provided as parameters. For tiki.geo.lat, {attributes tiki_geo_lat=...}. Removing the plugin or values in it will not remove the attributes." => "Erlaubt es, benutzerdefinierte Attribute zum einem Objekt hinzuzufügen. Attribute werden wie Parameter zur Verfügung gestellt. Für tiki.geo.lat, {attributes tiki_geo_lat=...}. Entfernt man das Plugin, werden die Attribute nicht entfernt.",
"Displays the user Avatar" => "Zeigt den Benutzer-Avatar an.",
"username" => "Benutzername",
"Back" => "Zurück",
"List all pages linking to the specified page." => "Listet alle Seiten auf, die eine spezifische Seite verlinken.",
"One page links to" => "Ein Seitenverweis auf",
"pages link to" => "Seitenverweise auf",
"Insert a banner" => "Fügt ein Banner hinzu.",
"Zone" => "Bereich",
"Display" => "Anzeigen",
"Allows to join a BigBlueButton meeting." => "Erlaubt es an einem BigBlueButton Meeting teilzunehmen.",
"Blog List" => "Blogliste",
"Use BLOGLIST to include posts from a blog." => "Benutze BLOGLIST um Einträge aus einem Blog einzufügen.",
"Insert theme-styled box on wiki page" => "Box im Theme-Layout in Wiki-Seite einfügen",
"Clear" => "Zurücksetzen",
"Button" => "Schaltfläche",
"Produces a link with the shape of a button, reusing the button smarty function and requiring no validation of that plugin" => "Erzeugt einen Link mit der gestalt einer Schaltfläche indem die entsprechende Smartyfunktion benutzt wird. Eine Validierung dieses Plugins ist nicht erforderlich.",
"Url" => "URL",
"Label" => "Beschriftung",
"Includes a calendar and/or a list of calendar events." => "Fügt einen Kalender und/oder eine Liste von Kalendereignissen ein.",
"Example values:" => "Beispielwerte:",
"Not set by default." => "Standardmäßig nicht eingetragen.",
"Determines how to show events." => "Legt fest, wie Ereignisse angezeigt werden.",
"Possible values:" => "Mögliche Werte:",
"Default value:" => "Standardwert:",
"List" => "Liste",
"Table" => "Tabelle",
"Insert list of items with the current/given category in the wiki page" => "Alle Einträge der aktuellen/angegebenen Kategorie in die Wiki-Seite einfügen",
"Categories are disabled" => "Kategorien sind nicht aktiviert",
"Category Orphans" => "Kategoriewaisen",
"Object" => "Objekt",
"Display Tiki objects that have not been categorized" => "Noch nicht kategorisierte Tiki-Objekte anzeigen",
"Insert the full category path for each category that this wiki page belongs to" => "Fügt den Kategorienbaum für jede Kategorie an, zu der diese Seite gehört",
"Separator" => "Trennzeichen",
"Mode" => "Modus",
"Centers the plugin content in the wiki page" => "Zentriert den PlugIn-Inhalt innerhalb der Wiki-Seite.",
"Chart" => "Diagramm",
"title" => "Titel",
"Code" => "Quellcode",
"Displays a snippet of code" => "Zeigt einen Quellcode-Ausschnitt an",
"code" => "Quellcode",
"Dynamic Content" => "Dynamischer Inhalt",
"Insert copyright notices" => "Fügt Copyright-Notizen ein.",
"On" => "Am",
"Days" => "Tag(en)",
"Hours" => "Stunden",
"Minutes" => "Minuten",
"Example" => "Beispiel",
"Clear all Tiki caches" => "Lösche alle Tiki Caches",
"Pre" => "Letzte",
"Definition List" => "Definitionsliste",
"Creates a definition list" => "Legt eine Definitionsliste an",
"term" => "Term",
"definition" => "Definition",
"one definition per line" => "eine Definition pro Zeile",
"Equation" => "Gleichung",
"Renders an equation written in LaTeX syntax as an image." => "Macht aus einer im LaTeX-Syntax geschriebenen Gleichung ein Bild.",
"equation" => "Gleichung",
"Events" => "Ereignisse",
"Upcoming events" => "nächste Termine",
"Fancy List" => "ausgefallene Liste",
"Creates a fancy-looking list" => "Erstelle eine ausgefallen aussehende Liste",
"Fancy Table" => "ausgefallene Tabelle",
"Displays the data using the Tikiwiki odd/even table style" => "Daten im Tiki gerade/ungerade Stil anzeigen",
"cells" => "Zellen",
"Example value:" => "Beispielswert:",
"Date" => "Datum",
"Flash video" => "Flashvideo",
"High" => "hoch",
"Low" => "niedrig",
"Blog Posts" => "Blogeinträge",
"Offset" => "Abstand (Offset)",
"all" => "alle",
"Search the titles of all pages in this wiki" => "Suche die Titel aller Seiten in diesem Wiki",
"missing parameters" => "fehlende Parameter",
"failed" => "fehlgeschlagen",
"description" => "Beschreibung",
"Value" => "Wert",
"Spreadsheet" => "Tabellen",
"Item ID" => "Eintrag-Id",
"Google Maps API key not set" => "Google Maps API Schlüssel ist noch nicht eingetragen",
"The user has chosen to make his information private" => "Der Benutzer hat diese Information als privat deklariert",
"Group" => "Gruppe",
"Display wiki text if user is in one of listed groups" => "Zeige den Wikitext an, wenn ein Benutzer Mitglied in einer der aufgelisteten Gruppen ist",
"Group List" => "Gruppenliste",
"Group Stats" => "Gruppenstatistik",
"Groups" => "Gruppen",
"Include literal HTML in a Wiki page" => "Beinhaltet? \"literal HTML\" in einer Wiki Seite",
"HTML code" => "HTML-Code",
"Wiki syntax" => "Wikisyntax",
"Display images" => "Bilder anzeigen",
"Image ID" => "Bild-ID",
"Thumbnail" => "Vorschau",
"Browse" => "Ansehen",
"Download" => "Herunterladen",
"Image height" => "Bildhöhe",
"Image width" => "Bildbreite",
"Include" => "Einbinden",
"Stop" => "Anhalten",
"Include a page" => "Eine Seite einbinden",
"Invite" => "einladen",
"Default Group" => "Standardgruppe",
"Last Modification" => "Letzte Änderung",
"List Pages" => "Seiten auflisten",
"List wiki pages." => "Wiki-Seiten auflisten.",
"Category filter" => "Kategorienfilter",
"Sort" => "Sortieren",
"or" => "oder",
"Lists files in a directory" => "Dateien im Verzeichnis auflisten",
"Filter" => "Filtern",
"Map" => "Karte",
"Displays a map" => "Zeigt eine Karte an",
"Feature disabled" => "Funktion deaktiviert",
"Template" => "Vorlage",
"Style" => "Stil",
"Displays a miniquiz" => "Zeigt ein Miniquiz an",
"Insert Module" => "Modul einfügen",
"Module Name" => "Modulname",
"Decoration" => "Dekoration",
"Please choose a module" => "Bitte ein Modul wählen",
"to be used as argument" => "als Argument zu verwenden",
"Displays a module inline in a wiki page" => "Zeigt ein Modul innerhalb einer Wiki-Seite an.",
"Sorry, no such module" => "Kein solches Modul vorhanden",
"Displays the data using a monospace font" => "Zeigt den PlugIn-Inhalt in einer MonoSpace-Schrift an",
"Create a mouseover feature on some text" => "Erstelle einen Mouseovereffekt auf einem Text",
"Sticky" => "sticky",
"data" => "Daten",
"Permissions" => "Berechtigungen",
"Module" => "Modul",
"Poll" => "Abstimmung",
"Quote" => "Zitat",
"Quoted text" => "zitierter Text",
"Quote text by surrounding the text with a box, like the [QUOTE] BBCode" => "Zitiere Text, indem Du ihn mit einer Box umgibst, so wie der Befehl [QUOTE] in BBCode",
"Random Dynamic Content" => "zufälliger dynamischer Inhalt",
"Result limit" => "Ergebnis Limit",
"User Information" => "Benutzerinformationen",
"User Preferences" => "Benutzer-Einstellungen",
"Exclude" => "Ausschliessen",
"admin" => "Verwalten",
"Preferences" => "Einstellungen",
"one data per line" => "ein Eintrag pro Zeile",
"Remarks Box" => "Bemerkungsbox",
"Errors" => "Fehler",
"Note" => "Hinweis",
"Warning" => "Warnung",
"Close" => "Schließen",
"Icon" => "Symbol",
"Sheet" => "Tabelle",
"Edit Sheet" => "Sheet bearbeiten",
"Show Pages" => "Seite anzeigen",
"List wiki pages" => "Wiki-Seiten auflisten",
"Search criteria" => "Suchkriterium",
"Action" => "Aktion",
"Sorts the plugin content in the wiki page" => "Sortiert den PlugIn-Inhalt innerhalb einer Wiki-Seite",
"Order" => "Reihenfolge",
"Split a page into rows and columns" => "Seite in Spalten und Zeilen aufteilen",
"First" => "erste",
"Column" => "Spalte",
"Line" => "Linie",
"Edit" => "Bearbeiten",
"Missing db param" => "Datenbank-Parameter fehlt",
"Run a sql query" => "SQL-Abfrage ausführen",
"sql query" => "SQL-Abfrage",
"Tracker Item" => "Trackereintrag",
"Added" => "Hinzugefügt",
"Viewed" => "Angesehen",
"Subscript" => "tiefgestellt",
"Displays text in subscript." => "Zeigt Text tiefergestellt",
"Subscribe" => "Abonnieren",
"Superscript" => "hochgestellt",
"Displays text in superscript (exponent)." => "Zeigt Text hochgestellt",
"Displays a survey" => "Zeigt eine Umfrage an",
"No pages found for title search" => "Titelsuche hat keine Seiten gefunden",
"One page found for title search" => "Titelsuche hat eine Seite gefunden",
"pages found for title search" => "Seiten bei Titelsuche gefunden",
"Table of Contents (Structure)" => "Inhaltsverzeichnis (Struktur)",
"Structure ID" => "Struktur-ID",
"Top Friends" => "Top Freunde",
"Translate" => "Übersetzen",
"string" => "String",
"Fields" => "Felder",
"to" => "bis",
"template" => "Vorlage",
"Parent" => "Oberkategorie",
"Overwrite" => "Überschreiben",
"Preview" => "Vorschau",
"Reset" => "Zurücksetzen",
"reset" => "zurücksetzen",
"View" => "Betrachten",
"Open" => "Offen",
"Closed" => "Geschlossen",
"Fields marked with a * are mandatory." => "Mit * markierte Felder sind zwingend.",
"Tracker Comments" => "Trackerkommentare",
"Filters" => "Filter",
"Display List" => "Anzeigeliste",
"Tracker Filter" => "Trackerfilter",
"notice" => "Hinweis",
"Wiki text" => "Wikitext",
"Tracker Item Field" => "Tracker Eintrag-Feld",
"Field ID" => "Feld-Id",
"Tracker List" => "Trackerliste",
"Notice" => "Nachricht",
"Filter Field" => "Filter Feld",
"Filter Value" => "Filter Wert",
"Exact Value" => "genauer Wert",
"More" => "Mehr",
"Wiki Page" => "Wiki Seite",
"No field indicated" => "Kein Feld angegeben",
"Displays a button to link to a page with a tracker plugin with prefilled tracker fields." => "Zeige eine Schaltfläche um zu einer Seite mit Trackerplugin mit vorausgefüllten Trackerfeldern zu verlinken",
"Field 1" => "Feld 1",
"Value 1" => "Wert 1",
"Field 2" => "Feld 2",
"Value 2" => "Wert 2",
"Field 3" => "Feld 3",
"Value 3" => "Wert 3",
"Field 4" => "Feld 4",
"Value 4" => "Wert 4",
"Field 5" => "Feld 5",
"Value 5" => "Wert 5",
"Tracker Stats" => "Tracker Statistik",
"incorrect fieldId" => "falsche Feld-Id",
"Title Field" => "Titlelfeld",
"Summary Field" => "Summenfeld",
"Page not found" => "Seite wurde nicht gefunden",
"Translated" => "übersetzt",
"Links to a translated content" => "Verweist auf einen übersetzten Inhalt",
"Flag" => "Flagge",
"Group name" => "Gruppenname",
"Displays the number of registered users" => "Zeigt die Anzahl der registrierten Benutzer",
"Userlink function" => "Benutzerlinkfunktion",
"Makes a link to the user information page" => "Erstellt einen Link auf die Benutzerinforamtionsseite",
"User List" => "Benutzerliste",
"Real Name" => "Tatsächlicher Name",
"users" => "Benutzer",
"Displays a list of registered users" => "Liste der registrierten Benutzer anzeigen",
"Userpref" => "Benutzereinstellungen",
"Vote" => "Abstimmung",
"From" => "Von",
"To" => "An",
"Line break" => "Zeilenumbruch",
"ignored" => "ignorierten",
"External Wiki" => "Externes Wiki",
"dash-WikiWord" => "dash-WikiWort",
"WikiWord" => "Wiki-Wort",
"valid" => "gültig",
"Wanted Page" => "gesuchte Seiten",
"__key__ | __default__ | __comments__\n" => "__Schlüssel__ | __Vorgabe__ | __Kommentar__\n",
"empty string" => "leere Zeichenfolge",
"Archive" => "Archivieren",
"Display youtube video" => "Youtubevideo anzeigen",
"Related" => "Verwandt",
"Removed version \$version" => "gelöschte Version \$version",
"No version indicated" => "Keine Version angegeben",
"Page locked" => "Seite sperren",
"Page unlocked" => "Seite entsperren",
"Removed last version" => "Löschte letzte Version",
"ERROR: Either the subject or body must be non-empty" => "FEHLER: Text und Betreff dürfen nicht leer sein.",
"ERROR: No valid users to send the message" => "FEHLER: Keine gültigen Benutzer zum Verschicken der Nachricht.",
"Invalid user" => "Ungueltiger Benutzer",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "Ausgangsordner ist voll. Bitte ein paar verschickte Nachrichten archivieren oder löschen, damit weitere verschickt werden können.",
"An error occurred, please check your mail settings and try again" => "Ein Fehler ist aufgetreten. Prüfe bitte Deine Emaileinstellungen und versuche es nochmal",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Zum Versenden von Nachrichten musst Du auch Antwort empfangen können. Bitte aktiviere 'Nachrichten von anderen Anwendern erlauben' in den Benutzereinstellungen.",
"User %s can not receive messages, mailbox is full" => "Benutzer %s kann keine Nachrichten empfangen, Briefkasten ist voll.",
"User %s can not receive messages" => "Benutzer %s kann keine Nachrichten empfangen.",
"Invalid user: %s" => "Ungültiger Benutzer: %s.",
"Message has been sent to: " => "Nachricht wurde versandt an: ",
"Archive is full. Delete some messages from archive first." => "Archiv ist voll! Bitte erst ein paar Nachrichten aus dem Archiv löschen.",
"No more messages" => "Keine weiteren Nachrichten",
"ERROR: " => "FEHLER: ",
"Item types filter" => "Typfilter",
"If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes." => "Wenn Typen eingetragen werden, wird die Anzeige auf die eingetragenen Typen beschränkt. Einzelne Typen sind durch Kommas zu separieren.",
"Possible item type values:" => "Mögliche Typeneinträge:",
"Similar Content" => "Ähnlicher Inhalt",
"Similar Content Filter" => "Filter für ähnlichen Inhalt",
"Advertisement channel, as optionally provided by Google." => "Werbekanal, wie optional von Google bereitgestellt.",
"As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "Wie von Google bereitgestellt. Format: \"pub-xxxxxxxxxxxxxxxx\"",
"Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Globales Banner-Format, wie optional von Google bereitgestellt. Z.B.: \"display=468*60_as\"",
"Background color, as optionally provided by Google." => "Hintergrundfarbe, wie optional von Google bereitgestellt.",
"Border color, as optionally provided by Google." => "Rahmenfarbe, wie optional von Google bereitgestellt.",
"Link color, as optionally provided by Google." => "Linkfarbe, wie optional von Google bereitgestellt.",
"Text color, as optionally provided by Google." => "Textfarbe, wie optional von Google bereitgestellt.",
"URL color, as optionally provided by Google." => "URL Farbe, wie optional von Google bereitgestellt.",
"Article archives" => "Artikelarchive",
"If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles." => "Wenn \"y\" eingetragen wird, erhält man eine Schaltfläche \"mehr\", die zur einer paginierten Ansicht der gewählten Artikel führt.",
"Default: \"n\"." => "Standard: \"n\".",
"If set to a category identifier, only consider the articles in the specified category." => "Wenn ein Kategorieidentifikator eingetragen wird, werden nur die Artikel in der angegebenen Kategorie berücksichtigt.",
"Example value: 13." => "Beispielswert: 13.",
"Topic filter (by names)" => "Themenfilter (nach Namen)",
"Topic filter (by identifiers)" => "Themenfilter (nach Identifikator)",
"Types filter" => "Typenfilter",
"Language filter" => "Sprachenfilter",
"Article Topics" => "Artikelthemen",
"Show publication time" => "Zeige Veröffentlichungsdatum",
"If set to \"y\", article publication times are shown." => "Wenn \"Y\" eingetragen wird, wird das Veröffentlichkeitsdatum angezeigt.",
"Show creation time" => "Zeige Erstellungsdatum",
"If set to \"y\", article creation times are shown." => "Wenn \"Y\" eingetragen wird, wird das Erstellungsdatum angezeigt.",
"Show rating selector" => "Zeige Bewertungsauswahl",
"If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating." => "Wenn \"Y\" eingetragen wird, kann der Benutzer die Artikel nach minimalen und maximalen Bewertungen filtern ",
"If set to a category identifier, only lists the articles in the specified category." => "Wenn eine Kategorie angegeben wird, werden nur Artikel in dieser Kategorie aufgelistet.",
"If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed." => "Wenn eine Liste von Artikelthemen, getrennt durch Pluszeichen, eingetragen wird, werden nur die Artikel gelistet mit den angegebenen Themen. Wird ein Ausrufezeichen \"!\" vorangestellt, wird der Effekt umgekehrt, d.h. Artikel mit den angegebenen Themen werden nicht gelistet.",
"If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead." => "Wenn eine ganze Zahl eingetragen wird, wird die Artikelliste um den eingetragenen Wert versetzt. Z.B. wenn das Modul so konfiguriert wurde, dass die 10 jüngsten Artikel gelistet werden, führt ein offset von 10 zu einer Auflistung der Artikel 11 bis 20 in absteigender Sortierung des Veröffentlichungsdatums.",
"If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles." => "Wenn \"Y\" eingetragen wird, wird eine Schaltfläche \"mehr\" angezeigt, die zu einer paginierten Ansicht der ausgewählten Artikel führt.",
"If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example." => "Wenn \"y\" eingestellt wird, benutzen Links absolute URL anstelle von Relativen. Damit kann man defekte Links vermeiden, wenn das Modul in einem Newsletter versandt wird.",
"TikiWiki assistant" => "TikiWiki Assistent",
"Last blog post comments" => "Neueste Blog Kommentare",
"No date" => "kein Datum",
"Default: \"n\"" => "Standard: \"n\".",
"Last visited pages" => "Zuletzt besuchte Seiten",
"Maximum number of characters in page names allowed before truncating." => "Maximale Anzahl von Zeichen einer Seite, bevor diese abgeschnitten wird.",
"Calendars filter" => "Kalenderfilter",
"Displayed month (relative)" => "Angezeigter Monat (relativ)",
"Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span." => "Abstand in Monaten zum angezeigten Monat. Ein Abstand von -1 zeigt den Vormonat an. Diese Einstellung setzt voraus, dass eine Kalenderansicht mit Monatsspanne gewählt wird.",
"View type" => "Anzeigetyp",
"Calendar view type time span" => "Zeitspanne für Kalenderansicht",
"Viewmode when clicking on a day" => "Anzeigemodus, wenn auf einen tag geklickt wird.",
"Put a link on all the days , not only those with event" => "Setze einen Link auf alle Tage, nicht nur diejenigen mit Ereignis",
"View navigation bar" => "Zeige Navigations-Bar an",
"Cart" => "Warenkorb",
"Object type filter" => "Objekttypfilter",
"Deep" => "Tiefe",
"Show subcategories objects when accessing a linked category. Possible values: on (default), off." => "Zeige Objekte aus Unterkategorien, wenn auf eine verlinkte Kategorie zugegriffen wird. Mögliche Werte: on (Standard), off",
"Show these categories and their children" => "Zeige diese Kategorien und deren Kinder",
"Category Transitions" => "Kategorienüberleitungen",
"Change Category" => "Kategorien ändern",
"Categorize" => "Kategorisieren",
"Unassign" => "Zuordnung aufheben",
"Assign" => "Zuweisen",
"Received objects" => "Empfangene Objekte",
"Last directory sites" => "Neueste Links",
"Show description" => "Beschreibung zeigen",
"Directory statistics" => "Linkverzeichnisstatistik",
"Top directory sites" => "Top Linkeinträge",
"Best rated topics" => "Höchstbewertete Themen",
"Last forum posts" => "Neueste Forenbeiträge",
"Topics only" => "nur Themen",
"Most commented forums" => "Meistkommentierte Foren",
"Most read topics" => "Meistgelesene Themen",
"Most visited forums" => "Meistbesuchte Foren",
"Freetags editor" => "Freetags Editor",
"Freetags similar content" => "Freetags mit ähnlichem Inhalt",
"Type of objects to extract." => "Objekttypen zum extrahieren.",
"Most popular tags" => "Populärste Tags",
"User preferred tags" => "Benutzerpräferierte Tags",
"My preferred tags" => "Meine bevorzugten Tags",
"Google Search" => "Google-Suche",
"Groups emulation" => "Gruppen Emulation",
"Emulate Groups" => "Gruppen emulieren",
"Last actions" => "Letzte Aktionen",
"Show user" => "Zeige Benutzer",
"Show date" => "Datum anzeigen",
"Last blog posts" => "Neueste Blog-Einträge",
"Last category objects" => "Neueste Kategorien",
"Last Created blogs" => "Neueste Blogs",
"Last Created FAQs" => "Neueste FAQs",
"Last Created Quizzes" => "Neueste Quiz",
"Last modified file galleries" => "Zuletzt modifizierte Dateiarchive",
"Last Files" => "Neueste Dateien",
"Last modified image galleries" => "Zuletzt modifizierte Bildergallerien",
"Last Images" => "Neueste Bilder",
"Last modified events" => "Neueste Termine",
"Link target" => "Linkziel",
"Target URL of the \"...more\" link at the bottom of the module." => "Ziel-URL des \"mehr\"-Link am Ende des Moduls.",
"Last Modified blogs" => "Zuletzt geänderte Blogs",
"Last Podcasts" => "Neueste Podcasts",
"width" => "Breite",
"height" => "Höhe",
"mediaplayer" => "Mediaplayer",
"Last submissions" => "Neueste Einreichungen",
"Last tracker comments" => "Neueste Tracker Kommentare",
"Last tracker items" => "Neueste Trackereinträge",
"Last Items" => "Neueste Einträge",
"Last Modified Items" => "Zuletzt geänderte Einträge",
"Last Validated FAQs Questions" => "Letzte bestätigte FAQs Fragen",
"Last Visitors" => "Letzte Besucher",
"Live support" => "Onlinesupport",
"Login box" => "Anmelde-Box",
"Input size" => "Eingabegröße",
"Menu page" => "Menüseite",
"Structure" => "Struktur",
"Unread inter-user messages" => "Ungelesene Intertiki Nachrichten",
"Messages" => "Nachrichten",
"Channels" => "Kanäle",
"List of chat channels. Channel names are separated by a comma (\",\")." => "Liste der Chatkanäle. Einzelne Kanalnamen werden durch Komma getrennt (\",\")",
"By default, a single channel named \"default\" exists." => "Standardmäßig existiert ein einzelner Kanal mit Namen \"default\"",
"Months links" => "Links des Monats",
"Most commented" => "Am häufigsten kommentiert",
"Waiting Submissions" => "Wartende Einreichungen",
"Old articles" => "Alte Artikel",
"Quick Edit" => "Schnellbearbeitung",
"Create/Edit" => "Hinzufügen/bearbeiten",
"Quick Edit a Wiki Page" => "Schnellbearbeitung einer Wiki-Seite",
"Random image" => "Zufallsbild",
"Default: \"y\"" => "Vorgabe: \"y\"",
"Show name" => "Name anzeigen",
"Random Pages" => "Zufällige Seiten",
"New user registration" => "Neue Benutzeranmeldung",
"Feeds List" => "Feeds-Liste",
"Search" => "Suche",
"Go" => "Los",
"Search Wiki Page" => "Suche auf der Wiki Seite",
"If set to \"y\", the search performed is a \"Tiki search\"." => "Wenn \"Y\" eingetragen wird, wird die Suche als \"Tikisuche\" durchgeführt.",
"If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content." => "Wenn \"1\" eingetragen wird, werden Postdaten und -uhrzeiten als Tooltips anstelle direkt im Modul angezeigt.",
"Label on the button to post a message." => "Bezeichnung der Schaltfläche um einen Nachricht zusenden.",
"Maximum messages shown" => "Maximale Anzahl von Nachrichten, die angezeigt werden",
"Number of messages to display." => "Anzahl von anzuzeigenden Nachrichten.",
"If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via twitter." => "Wenn \"1\" eingetragen wird und der Benutzer uns zum twittern autorisiert hat, kann der Benutzer entscheiden, ob er twittern will.",
"If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his facebook wall." => "Wenn \"1\" eingetragen wird und der Benutzer bei Facebook angemeldet ist, kann der Benutzer entscheiden, ob er den Eintrag an seine Facebook Pinnwand schreiben will.",
"Post" => "Eintrag",
"Since last visit (simple)" => "Seit letzten Besuch (einfach)",
"Since your last visit" => "Was ist neu?",
"Since last visit" => "Seit letzten Besuch",
"Show users" => "Zeige Benutzer",
"If set to \"n\", do not show new users." => "Wenn \"n\" eingestellt wird, werden keinen neuen Benutzer angezeigt.",
"If set to \"n\", do not show tracker changes." => "Wenn \"n\" eingestellt wird, werden keine Trackeränderungen angezeigt.",
"Calendar focus" => "Kalenderfokus",
"Show date as a calendar link" => "Zeige Datum als Kalenderlink",
"If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)" => "Wenn \"n\" eingestellt wird, wird kein Kalenderlink im Datum im Kopfbereich des Modul angezeigt (auch nicht wenn die Kalenderfunktion aktiviert ist)",
"Fold sections by default" => "Abschnitte standardmäßig einklappen",
"If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "Wenn \"y\" eingestellt wird, werden Abschnitte automatisch eingeklappt und es wird nur der Titel angezeigt (Benutzer müssen auf jeden Abschnitt klicken, um die Details der Änderungen zu sehen)",
"Changes since" => "Änderungen seit",
"Since your last visit..." => "Seit Deinem letzten Besuch",
"new comments" => "Neue Kommentare",
"wiki pages changed" => "Wiki-Seiten geändert",
"new articles" => "neue Artikel",
"new blogs" => "Neue Blogs",
"new blog posts" => "Neue Blog Veröffentlichungen",
"new images" => "Neue Bilder",
"new file galleries" => "neue Dateiarchieve",
"new files" => "Neue Dateien",
"new users" => "Neue Benutzer",
"Switch Language" => "Sprache umstellen",
"Prefix" => "Präfix",
"Switch theme" => "Theme ändern",
"Terminology" => "Terminologie",
"Root category" => "Hauptkategorie",
"Most Active blogs" => "Aktivste Blogs",
"Top File Galleries" => "Top Dateiarchive",
"Top files" => "Top Dateien",
"Top Forum Posters" => "Top Forum Poster",
"Top image galleries" => "Top Bildergalerien",
"Top Images" => "Top Bilder",
"Top Objects" => "Top Objekte",
"Top Pages" => "Top Seiten",
"Top Quizzes" => "Top Quiz",
"Top Visited FAQs" => "Meistbesuchte FAQs",
"Trackerhelp" => "Trackerhilfe",
"Translate Updates" => "Übersetzungsaktualisierungen",
"Reference language" => "Referenzsprache",
"If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed." => "Wenn ein Sprachcode angegeben wird, werden die auf der Referenzseite angezeigten Seiten eingeschränkt; es sei denn, die Seite wird angezeigt.",
"Show language" => "Zeige Sprache",
"If \"y\" the page language will be shown instead of the page name." => "Wenn \"y\", dann wird die Seitensprache anstelle des Seitennamen angezeigt",
"Default = \"y\"." => "Standard = \"y\".",
"Maximum days in the future" => "Maximale Tage in der Zukunft",
"User Blogs" => "Benutzer-Blogs",
"User bookmarks" => "Benutzer-Lesezeichen",
"User image galleries" => "Benutzer Bildergalerien",
"User Pages" => "Benutzerseiten",
"My Pages" => "Meine Seiten",
"User tasks" => "Benutzer-Aufgaben",
"Public tasks" => "Öffentliche Aufgaben",
"User-Group Tracker" => "Benutzer-/Gruppen Tracker",
"Top users" => "Top Benutzer",
"What is related" => "Was ist zugeordnet",
"Online users" => "Benutzer online",
"Content to display" => "Anzuzeigender Inhalt",
"Display the number of users logged in, the list of users logged in, or both." => "Zeige die Anzahl der angemeldeten Benutzer (count), die Liste der angemeldeten Benutzer (list) oder beides (both).",
"Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Mögliche Werte: \"count\", \"list\" oder \"both\". Standardwert: \"both\"",
"Cluster mode" => "Cluster-Modus",
"If set to \"1\", separate users based on which host/server they logged on." => "Wenn \"1\" eingetragen wird, werden die Benutzer danach getrennt, auf welchem host/server sie angemeldet sind.",
"Last comments" => "Neueste Kommentare",
"Last wiki comments" => "Die letzten Wiki-Kommentare",
"YouTube" => "Youtube",
"No Playlist ID was provided" => "Es wurde keine Playlist ID angegeben",
"Invalid username or password" => "Ungültiger Benutzername oder Passwort",
"Can create/admin calendars" => "Kann einen Kalender erstellen/verwalten",
"Can add events in the calendar" => "Kann Ereignisse in den Kalender eintragen",
"Can change events in the calendar" => "Kann Ereignisse im Kalender verändern",
"Can browse the calendar" => "Kann den Kalender durchstöbern",
"Can view events details" => "Kann Ereignisdetails einsehen",
"Can add own user to the participants" => "Kann eigene Benutzer zu den Teilnehmern hinzufügen",
"Can add guest to the participants" => "Kann Gäste zu den Teilnehmern einladen",
"Administrator, can create channels remove channels etc" => "Administrator, kann Channels erstellen bzw. entfernen etc.",
"Can use the chat system" => "Kann das Chatsystem benutzen",
"Can approve submissions" => "Kann Einreichungen bestätigen",
"Can admin article topics" => "Kann Artikelthemen verwalten",
"Can admin article types" => "Kann Artikeltypen verwalten",
"Can read article headings" => "Kann Artikelüberschriften lesen",
"Can edit articles" => "Kann Artikel bearbeiten",
"Can edit submissions" => "Kann Einreichungen bearbeiten",
"Can read articles" => "Kann Artikel lesen",
"Can remove articles" => "Kann Artikel löschen",
"Can remove submissions" => "Kann Einreichungen löschen",
"Can submit articles" => "Kann Artikel einreichen",
"Can rate articles" => "Kann Artikel bewerten",
"Can read a topic (Applies only to individual topic perms)" => "Kann Thema lesen (nur auf individuelle Themenrechte anwendbar)",
"Can admin contributions" => "Kann Einreichungen verwalten",
"Can admin the directory" => "Kann das Linkverzeichnis verwalten",
"Can admin directory categories" => "Kann Verzeichniskategorien verwalten",
"Can submit sites to the directory" => "Kann Sites zum Linkverzeichnis hinzufügen",
"Can use the directory" => "Kann das Linkverzeichnis benutzen",
"Can admin faqs" => "Kann FAQs verwalten",
"Can suggest faq questions" => "Kann eine Frage zu einem FAQ vorschlagen",
"Can view faqs" => "Kann FAQs einsehen",
"Can admin users" => "Kann Benutzer verwalten",
"Can access site when closed" => "Kann auf Site zugreifen, wenn diese geschlossen ist",
"Administrator, can admin banners" => "Administrator, kann Banner verwalten",
"Can ban users or ips" => "Kann Benutzer oder IPS verbannen",
"Can admin the dynamic content system" => "Kann dynamische Inhalte verwalten",
"Can admin mail-in accounts" => "Kann Mail-in-Konten verwalten",
"Can edit object permissions" => "Kann Objektberechtigungen ändern",
"Can admin external feeds" => "Kann externe Feeds verwalten",
"Can clean cache" => "Kann den Cache löschen",
"Can remove association between two pages in a translation set" => "Kann die Verknüpfung zwischen zwei Seiten in einem Übersetzungsset löschen",
"Can admin cookies" => "Kann Cookies verwalten",
"Can edit translations and create new languages" => "Kann Übersetzungen bearbeiten und neue Sprachen anlegen",
"Can edit menu" => "Kann Menüs bearbeiten",
"Can edit menu option" => "Kann Menüoptionen bearbeiten",
"Can edit site templates" => "Kann Site-Vorlagen bearbeiten",
"Can search" => "Kann suchen",
"Can report a link to the webmaster" => "Kann einen Link dem Webmaster berichten",
"Can subscribe to groups" => "Kann sich Gruppen zuordnen",
"Can send a link to a friend" => "Kann einem Freund einen Link senden",
"Can share a page (email, twitter, facebook, message, forums)" => "Kann die Seite mit anderen teilen (Email,Ttwitter, Facebook, Nachrichten, Forums)",
"Can use HTML in pages" => "Kann HTML-Seiten benutzen",
"Can view action log" => "Kann das Aktionslog einsehen",
"Can view action log for users of his own groups" => "Kann das Aktionslog für Gruppenmitglieder seiner Gruppe einsehen",
"Can view integrated repositories" => "Kann integriertes Depot (repository) einsehen",
"Can view site stats" => "Kann Sitestatistiken einsehen",
"Can view site templates" => "Kann Sitevorlagen einsehen",
"Can admin blogs" => "Kann Blogs verwalten",
"Can assign perms to blog" => "Kann einem Blog Rechte zuweisen",
"Can post to a blog" => "Kann einen Blogeintrag posten",
"Can create a blog" => "Kann einen Blog erstellen",
"Can read blogs" => "Kann Blogs lesen",
"Can admin file galleries" => "Kann Dateiarchive verwalten",
"Can assign perms to file gallery" => "Kann Rechte zum Dateiarchiv zuweisen",
"Can use Directory Batch Load" => "Kann den Verzeichnis Batchupload nutzen",
"Can upload zip files with files" => "Kann zip-Dateien mit Dateien hochladen",
"Can create file galleries" => "Kann Dateiarchive erstellen",
"Can download files" => "Kann Dateien herunterladen",
"Can edit a gallery file" => "Kann Dateiarchive editieren",
"Can list file galleries" => "Kann Dateiarchive auflisten",
"Can upload files" => "Kann Dateien hochladen",
"Can view file galleries explorer" => "Kann den Dateiarchivbrowser einsehen",
"Can view file galleries path" => "Kann den Dateiarchivpfad einsehen",
"Can view file galleries" => "Kann Dateiarchive einsehen",
"Can admin forums" => "Kann Foren verwalten",
"Can attach to forum posts" => "Kann an Forumposts anhängen",
"Auto approve forum posts" => "Forumposts werden automatisch bestätigt",
"Can edit own forum posts" => "Kann eigene Forumposts ändern",
"Can post in forums" => "Kann in Foren posten",
"Can start threads in forums" => "Kann ein Thema im Forum starten",
"Can read forums" => "Kann Foren lesen",
"Can vote comments in forums" => "Kann Kommentare in Foren bewerten",
"Can admin freetags" => "Kann Freetags verwalten",
"Can admin Image Galleries" => "Kann Bildergalerien verwalten",
"Can assign perms to image gallery" => "Kann Rechte zu einer Bildergalerie zuweisen",
"Can upload zip files with images" => "Kann zip-Dateien mit Bildern hochladen",
"Can create image galleries" => "Kann  Bildergalerien erstellen",
"Can tag objects" => "Kann Tags zu einem Objekt zuweisen",
"Can list image galleries" => "Kann Bildergalerien auflisten",
"Can unassign tags from an object" => "Kann Tags von einem Objekt entfernen",
"Can upload images" => "Kann Bilder hochladen",
"Can browse freetags" => "Kann Freetags durchstöbern",
"Can view image galleries" => "Kann Bildergalerien einsehen",
"Can admin newsletters" => "Kann Newsletter verwalten",
"Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Kann viele Emails auf einmal abonnieren (erfordert tiki_p_subscribe email)",
"Can send newsletters" => "Kann Newsletter versenden",
"Can subscribe to newsletters" => "Kann Newsletter abonnieren",
"Can view the archive of a newsletters" => "Kann ein Newsletterarchiv einsehen",
"Can list newsletters" => "Kann Newsletter auflisten",
"Can admin polls" => "Kann Abstimmung verwalten",
"Can view poll results" => "Kann Abstimmungsergebnisse einsehen",
"Can vote polls" => "Kann Abstimmungen bewerten",
"Can view poll voters" => "Kann Bewerter von Abstimmung einsehen",
"Can admin toolbars" => "Kann Toolbars verwalten",
"Can admin quizzes" => "Kann Quiz verwalten",
"Can take quizzes" => "Kann an einem Quiz teilnehmen",
"Can view quiz stats" => "Kann Quizstatistiken einsehen",
"Can view user quiz results" => "Kann Quizergebnisse von Benutzern einsehen",
"Can admin sheet" => "Kann Tabellen verwalten",
"Can create and edit sheets" => "Kann Tabellen erstellen und editieren",
"Can view sheet" => "Kann Tabelle einsehen",
"Can view sheet history" => "Kann Tabellenhistorie einsehen",
"Can post messages in shoutbox" => "Kann Nachrichten in der Shoutbox posten",
"Can view shoutbox" => "Kann Shoutbox einsehen",
"Can admin surveys" => "Kann Umfragen verwalten",
"Can take surveys" => "Kann an Umfragen teilnehmen",
"Can view survey stats" => "Kann Umfrageergebnisse einsehen",
"Can admin trackers" => "Kann Tracker verwalten",
"Can attach files to tracker items" => "Kann Dateien an Trackereinträge anhängen",
"Can insert comments for tracker items" => "Kann Kommentare zur Trackerelementen hinzufügen",
"Can view tracker items comments" => "Kann Kommentare zu Trackereinträgen einsehen",
"Can create new items for trackers" => "Kann neues Trackerelement hinzufügen",
"Can list trackers" => "Kann Tracker auflisten",
"Can change tracker items" => "Kann Trackereinträge ändern",
"Can view rating result for tracker items" => "Kann Bewertungsergebnis für Trackereinträge einsehen",
"Can vote a rating for tracker items" => "Kann einen Trackereintrag bewerten",
"Can re-vote a rating for tracker items" => "Kann nochmal bei Trackereinträgen abstimmen",
"Can view trackers" => "Kann Tracker einsehen",
"Can watch tracker" => "Kann Tracker beobachten",
"Can export tracker items" => "Kann Trackerelemente exportieren",
"Can admin the wiki" => "Kann die Wiki verwalten",
"Can assign perms to wiki pages" => "Kann Rechte zu Wikiseiten zuweisen",
"Can edit pages" => "Kann Seiten editieren",
"Can edit copyright notices" => "Kann Copyrighthinweis ändern",
"Can edit dynamic variables" => "Kann dynamische Variablen editieren",
"Can create and edit structures" => "Kann Strukturen erstellen und editieren",
"Can lock pages" => "Kann Seiten sperren",
"Can save as minor edit" => "Kann Seite als geringfügige Änderung speichern",
"Can remove" => "Kann entfernen",
"Can rename pages" => "Kann Seiten umbenennen",
"Can rollback pages" => "Kann Seiten zurückrollen",
"Can upload pictures to wiki pages" => "Kann Bilder zu Wikiseiten hochladen",
"Can use the page as a tracker template" => "Kann eine Seite als Trackevorlage verwenden",
"Can view page/pages" => "Kann eine Seite/Seiten einsehen",
"Can watch structure" => "Kann Strukturen beobachten",
"Can attach files to wiki pages" => "Kann Dateien an Wiki-Seiten anhängen",
"Can view wiki attachments and download" => "Kann Wiki Anhänge ansehen und herunterladen",
"Can view wiki comments" => "Kann Wiki Kommentare ansehen",
"Can view wiki history" => "Kann Wiki Historie einsehen",
"Can view source of wiki pages" => "Kann Quelltext von Wikiseiten einsehen",
"Can view similar wiki pages" => "Kann ähnliche Wikiseiten einsehen",
"Can admin received articles" => "Kann empfangene Artikel verwalten",
"Can admin received pages" => "Kann empfangene Seiten verwalten",
"Can send articles to other sites" => "Kann Artikel zu anderen Sites schicken",
"Can send articles to this site" => "Kann Artikel zu dieser Site schicken",
"Can send pages to this site" => "Kann Seiten zu dieser Site schicken",
"Can send pages to other sites" => "Kann Seiten zu anderen Sites schicken",
"Can create user bookmarks" => "Kann Benutzerbookmarks erstellen",
"Can use the notepad" => "Kann Notizblock benutzen",
"Can admin public tasks" => "Kann öffentliche Aufträge verwalten",
"Can use tasks" => "Kann Aufgaben benutzen",
"Can receive tasks from other users" => "Kann Aufträge von anderen Benutzern erhalten",
"Can send tasks to other users" => "Kann Aufträge an andere Benutzern senden",
"Can upload personal files" => "Kann eigene Dateien hochladen",
"Can broadcast messages to all user" => "Kann eine Nachricht zu allen Benutzern senden",
"Can broadcast messages to groups" => "Kann eine Nachricht zur Gruppe senden",
"Can use the messaging system" => "Kann das Nachrichtensystem nutzen",
"Can admin comments" => "Kann Kommentare administrieren",
"Can edit all comments" => "Kann alle Kommentare editieren",
"Can post new comments" => "Kann neue Kommentare posten",
"Can read comments" => "Kann Kommentare lesen",
"Can delete comments" => "Kann Kommentare löschen",
"Can vote comments" => "Kann für Kommentare abstimmen",
"Can edit HTML pages" => "Kann HTML Seiten editieren",
"Can view HTML pages" => "Kann HTML Seiten einsehen",
"Can list registered users" => "Kann registrierte Benutzer auflisten",
"Admin live support system" => "Kann Livesupportsystem verwalten",
"Can use live support system" => "Kann Livesupportsystem benutzen",
"Can create new mapfile" => "Kann eine neue Kartendatei erstellen",
"Can delete mapfiles" => "Kann Kartendateien löschen",
"Can edit mapfiles" => "Kann Kartendateien ändern",
"Can view mapfiles" => "Kann Kartendateien einsehen",
"Can view contents of mapfiles" => "Kann Inhalt von Kartendateien einsehen",
"Can use webmail" => "Kann Webmail benutzen",
"Can use group webmail" => "Kann Gruppenwebmail benutzen",
"Can use personal webmail accounts" => "Kann persönliche Webmail Accounts benutzen",
"Can view unapproved plugin details" => "Kann unbestätigte Plugindetails einsehen",
"Can execute unapproved plugin" => "Kann unbestätigte Plugins ausführen",
"Can approve plugin execution" => "Kann Pluginausführung bestätigen",
"Trust all user inputs including plugins (no security checks)" => "Vertraue allen Benutzereingaben einschließlich Plugins (keine Sicherheitsprüfung)",
"View page backlinks" => "Kann Backlinks einsehen",
"Can admin mail notifications" => "Kann Mailbenachrichtigungen verwalten",
"Can invite user to my groups" => "Kann Benutzer zu meiner Gruppen einladen",
"Can admin categories" => "Kann Kategorien verwalten",
"Can see the category in a listing" => "Kann die Kategorie in einer Auflistung einsehen",
"Can remove objects from the category" => "Kann Objekte von einer Kategorie löschen",
"Can create new categories" => "Kann neue Kategoriern erstellen",
"Can view the perspective" => "Kann Perspektiven einsehen",
"Can edit the perspective" => "Kann eine Perspektive bearbeiten",
"Can create a perspective" => "Kann eine Perspektive erstellen",
"Can admin perspectives" => "Kann Perspektiven verwalten",
"Can view the group" => "Kann die Gruppe einsehen",
"Can view the group members" => "Kann Gruppenmitglieder einsehen",
"Can add group members" => "Kann Mitglieder zu einer Gruppe hinzufügen",
"Can remove group members" => "Kann Gruppenmitglieder entfernen",
"Can join or leave the group" => "Kann einer Gruppe beitreten/sie verlassen",
"Can admin kaltura feature" => "Kann eine Kalturafunktion verwalten",
"Can upload video on kaltura server" => "Kann ein Video auf den Kalturaserver hochladen",
"Can edit information of kaltura entry" => "Kann Informationen zu einem Kalturaeintrag editieren",
"Can create kaltura remix video" => "Kann ein Kalturaremixvideo erstellen",
"Can delete kaltura entry" => "Kann einen Kalturaeintrag löschen",
"Can download kaltura entry" => "Kann einen Kalturaeintrag herunterladen",
"Can list kaltura entries" => "Kann Kalturaeinträge auflisten",
"Can view kaltura entry" => "Kann einen Kalturaeintrag einsehen",
"Can administer payments" => "Kann Zahlungen verwalten",
"Can view payment requests and details" => "Kann Zahlungsanfragen und -details einsehen",
"Can enter manual payments" => "Kann eine manuelle Bezahlung eingeben",
"Can request a payment" => "Kann eine Bezahlung anfordern",
"Can join a meeting" => "Kann einem Meeting beitreten",
"Can moderate a meeting" => "Kann ein Meeting moderieren",
"Can create a meeting" => "Kann ein Meeting starten",
"user can use social network integration" => "Benutzer kann die Integration von sozialen Netzwerken nutzen",
"Can view contributions to a page" => "Kann Beiträge zu Wikiseiten einsehen",
"smarty notice reporting" => "Smarty 'notice' Berichterstattung",
"allowMsgs" => "Nachrichten erlauben",
"country" => "Land",
"diff versions" => "Versionen vergleichen",
"display timezone" => "Zeitzone zeigen",
"email is public" => "eMail ist öffentlich",
"homePage" => "Startseite",
"realName" => "realer Name",
"gender" => "Geschlecht",
"show mouseover user info" => "zeige mouseover Benutzer-Infos",
"Non Advanced Search or Natural Search" => "Nicht erweiterte Suche oder natürliche Suche",
"Advanced Search or Boolean Search" => "Erweiterte oder Boolesche Suche",
"Default search behavior" => "Standard Suchverhalten",
"By default, all search terms are <em>optional</em>." => "Standardmäßig sind alle Suchbegriffe <em>optional</em>.",
"It behaves like an OR logic." => "Dieses Verhalten entspricht der ODER-Logik.",
"Objects that contain the more terms are rated higher in the results and will appear first in their type." => "Objekte die mehrere Begriffe (oder diese mehrfach) enthalten, werden in der Ergebnisliste höher bewertet und erscheinen in deren Typen zuerst.",
"For example, <strong>wiki forum</strong> will find:" => "Zum Beispiel, <strong>Wiki Forum</strong> wird finden:",
"objects that include both terms" => "Objekte, die beide Ausdrücke enthalten",
"objects that include the term <strong>wiki</strong>" => "Objekte, die den Ausdruck <strong>Wiki</strong> enthalten",
"objects that include the term <strong>forum</strong>" => "Objekte, die den Ausdruck <strong>Forum</strong> enthalten",
"Requiring terms" => "Zwingende Begriffe",
"Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results." => "Füge ein Pluszeichen ( + ) vor einem Begriff ein, um anzuzeigen, dass der Begriff im Suchergebnis enthalten sein <em>muss</em>.",
"Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first." => "Beispiel: <strong>+Wiki Forum</strong> findet Objekte, die mindestens <strong>Wiki</strong> enthalten. Objekte, die beide Begriffe und ggf. diese auch mehrfach entahlten, werden zuerst erscheinen.",
"Excluding terms" => "Begriffe ausschließen",
"Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results." => "Füge ein Minuszeichen ( - ) vor einen Suchbegriff ein, damit der Suchbegriff <em>nicht</em> in den gefundenen Ergebnissen enthalten ist.",
"Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "Beispiel: <strong>-Wiki Forum</strong> wird Objekte finden, die nicht <strong>Wiki</strong> aber <strong>Forum</strong> enthalten",
"Grouping terms" => "Begriffe gruppieren",
"Use parenthesis ( ) to group terms into subexpressions." => "Benutze Klammern ( ) um Begriffe in Unterausdrücke zu gruppieren.",
"Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order." => "Beispiel: <strong>+Wiki +(Forum Blog)</strong> findet Objekte, die <strong>Wiki</strong> und <strong>Forum</strong> enthalten oder Objekte, die <strong>Wiki</strong> und <strong>Blog</strong> in irgendeiner Reihenfolge enthalten.",
"Finding phrases" => "Phrasen finden",
"Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed." => "Benutze Anführungszeichen ( \" \" ) um einen Ausdruck exakt so zu suchen, wie er eingegeben wurde.",
"Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "Beispiel: <strong>\"Alex Bell\"</strong> findet nicht <strong>Bell Alex</strong> oder <strong>Alex G. Bell</strong>.",
"Using wildcards" => "Platzhalter benutzen",
"Add an asterisk ( * ) after a term to find objects that include the root word." => "Füge einen Stern ( * ) nach einem Begriff ein um Objekte zu finden, die den Wortteil vor de, Stern enthalten",
"For example, <strong>run*</strong> will find:" => "Zum Beispiel findet der Begriff, <strong>run*</strong>:",
"objects that include the term <strong>run</strong>" => "Objekte, die den Begriff <strong>run</strong> enthalten",
"objects that include the term <strong>runner</strong>" => "Objekte, die den Begriff <strong>runner</strong> enthalten",
"objects that include the term <strong>running</strong>" => "Objekte, die den Begriff <strong>running</strong> entahlten",
"Reducing a term's value" => "Die Bedeutung eines Suchbegriffs reduzieren",
"Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>." => "Beispiel: <strong>+Wiki ~Forum</strong> bewertet ein Objekt höher, wenn es nur den Begriff <strong>Wiki</strong> enthält, als wenn sowohl die Begriffe <strong>Wiki</strong> als auch <strong>Forum</strong> enthalten sind.",
"Changing relevance value" => "Änderung des Relevanzwertes",
"Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object." => "Füge ein kleiner-als- ( < ) oder größer-als- ( > ) Zeichen vor einen Begriff ein, um den Beitrag des Suchbegriffs zur Gesamtrelevanz eines Objektes zu ändern.",
"Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher." => "Beispiel: <strong>+Wiki +(>Forum < Blog)</strong> findet Objekte, die <strong>Wiki</strong> und <strong>Forum</strong> oder <strong>Wiki</strong> und <strong>Blog</strong> in irgendeiner Reihenfolge enthalten. <strong>Wiki Forum</strong> wird höher bewertet.",
"Enter the code you see above" => "Gib den Code ein, den Du oben siehst",
"bytes" => "Bytes",
"Share this page" => "Diese Seite einem Freund mitteilen",
"ShareThis via AIM, social bookmarking and networking sites, etc." => "ShareThis via AIM, Soziale Bookmarks und Networkingseiten, etc.",
"Send a link" => "Sende einen Link",
"Translation" => "Übersetzung",
"Remove" => "Entfernen",
"List of attached files" => "Liste aller angehängten Dateien",
"desc" => "Beschreibung",
"uploaded" => "hochgeladen",
"Delete" => "Löschen",
"Upload file" => "Datei hochladen",
"Attach" => "Anhängen",
"Attach a file to this item" => "Datei an diesen Eintrag anhängen",
"more info" => "mehr Infos",
"No attachments for this item" => "Keine Anhänge für diesen Eintrag",
"debug" => "Debug",
"Fatal error" => "Fataler Fehler",
"Save to notepad" => "Im Notizblock speichern",
"Published " => "veröffentlicht",
"on" => "am",
"More..." => "Mehr...",
"pages" => "Seiten",
"First page" => "Erste Seite",
"Previous page" => "Vorherige Seite",
"page" => "Seite",
"Next page" => "Nächste Seite",
"Last page" => "Letzte Seite",
"comments" => "Kommentare",
"Actions" => "Aktionen",
"Properties" => "Eigenschaften",
"No records found" => "Keine Datensätze gefunden",
"Select Categories" => "Kategorien auswählen",
"Admin Categories" => "Kategorien verwalten",
"Select/deselect all categories" => "Auswahl/Abwahl aller Kategorien",
"No categories defined" => "Keine Kategorien definiert",
"Browse Category" => "Kategorien durchstöbern",
"Posted by" => "Gepostet von",
"User Level" => "Benutzerlevel",
"private message" => "private Nachricht",
"Send eMail to User" => "Email an Benutzer schicken",
"user online" => "Benutzer online",
"user offline" => "Benutzer offline",
"top of page" => "Anfang der Seite",
"Reply" => "Antwort",
"Approve" => "freigeben",
"Reject" => "ablehnen",
"Report this post" => "Diesen Beitrag melden",
"Monitor this Topic" => "Thema beobachten",
"Stop Monitoring this Topic" => "Beobachtung dieses Themas beenden",
"Group Monitor" => "Mit Gruppe beobachten",
"Watched by categories" => "Beobachtet durch die Kategorien",
"Moderator actions" => "Moderator-Aktionen",
"reported:" => "gemeldet:",
"queued:" => "aufgelaufen:",
"Move to topic:" => "Verschiebe zu Thema:",
"Move" => "Verschieben",
"Delete Selected" => "Markierte löschen",
"Comments Locked" => "Beiträge gesperrt",
"Unlock" => "Entsperren",
"Lock" => "Sperren",
"Threshold" => "Schwellenwert",
"Replies" => "Antworten",
"below your current threshold" => "unterhalb Deines aktuellen Schwellenwerts",
"Comments are locked" => "Kommentare sind geschlossen",
"New Reply" => "Neue Antwort",
"Editing reply" => "Antwort bearbeiten",
"Reply to the selected post" => "Auf den ausgewählten Beitrag antworten",
"Post new message" => "Neuen Beitrag erstellen",
"Editing comment" => "Bearbeitungskommentar",
"Post new comment" => "Neuen Kommentar posten",
"Add Comment" => "Kommentieren",
"Send me an e-mail when someone replies" => "Sende mir eine Email, wenn jemand antwortet",
"Reply to parent post" => "Auf Vaterpost antworten",
"Post new reply" => "Neue Anwort schreiben",
"Post as Anonymous" => "Anonym posten",
"Posting replies" => "Post-Antworten",
"Posting comments" => "Posting-Kommentare",
"1 comment" => "1 Kommentar",
"Comments" => "Kommentare",
"Go back" => "Zurück",
"Return to home page" => "Zur Home-Seite zurückkehren",
"Type of contribution:" => "Art der Beteiligung:",
"Contributors" => "Beitragende",
"Authors" => "Autoren",
"Add" => "Hinzufügen",
"If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation:" => "Wenn Du Shell (SSH) Zugang hast, kannst Du auch folgendes aus dem Rootverzeichnis deiner Tikiinstallation in der Kommandozeile nutzen:",
"Tiki Debugger Console" => "Tiki Debug-Konsole",
"Current URL" => "Aktuelle URL",
"Command" => "Befehle",
"exec" => "Ausführen",
"Type <code>help</code> to get list of available commands" => "<code>help</code> für eine Befehlsübersicht eingeben",
"Page generation debugging log" => "Debug-Log der Seitengenerierung",
"Features state" => "Status der Funktion",
"Total" => "Gesamt",
"features matched" => "Features gefunden",
"Watchlist" => "Beobachtungsliste",
"Duplicate File Gallery" => "Dateiarchiv duplizieren",
"Duplicate categories" => "Kategorien duplizieren",
"Duplicate" => "Kopiere",
"There are individual permissions set for this file gallery" => "Für dieses Dateiarchiv sind individuelle Berechtigungen gesetzt",
"Save" => "Speichern",
"Use" => "Benutze",
"unlimited" => "unbegrenzt",
"Parent gallery" => "Mutter-Galerie",
"Owner of the gallery" => "Besitzer der Galerie",
"Quota" => "Kontingent",
"Used:" => "Benutzt:",
"Allows to select each user for small groups" => "Bei kleinen Gruppen können alle Mitglieder ausgewählt werden",
"Max description display size" => "Maximale Anzeigebreite der Beschreibung",
"Change them here" => "Ändere sie hier",
"Create this page" => "Diese Seite anlegen",
"(page will be orphaned)" => "(Seite wird verwaist sein)",
"Active Perms" => "Active Rechte",
"Perms" => "Berechtigungen",
"Archives" => "Archiv",
"Replace" => "Ersetzen",
"Name-filename" => "Name - Dateiname",
"Filename only" => "Nur Dateiname",
"Show as a column" => "Zeige als Spalte",
"Show in popup box" => "Zeige in Popupbox",
"Show an icon in a column" => "Zeige ein Symbol in einer Spalte",
"Exact&nbsp;match" => "nur&nbsp;genaue&nbsp;Treffer",
"and all the sub-objects" => "und alle Unterobjekte",
"any type" => "jeder Typ",
"all topic" => "jedes Thema",
"any language" => "jede beliebige Sprache",
"not in" => "aber nicht in",
"any category" => "jede Kategorie",
"Multiple select" => "Mehrfachauswahl",
"Orphans" => "Waisen",
"Number of displayed rows" => "Angezeigte Zeilenanzahl",
"Clear Filter" => "Sucheingaben löschen",
"List View" => "Listenansicht",
"Map View" => "Kartenansicht",
"Show php error messages" => "PHP Fehlermeldungen zeigen",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes." => "Schreibe die Tags durch Leerzeichen getrennt. Für Tags, die aus mehr als einem Wort bestehen, benutze keine Leerzeichen sondern schreibe die Worte zusammen, oder setze sie in \"Anführungszeichen\".",
"Perform action with checked:" => "Aktion auf alle markierten Elemente ausführen",
"Move Selected Files" => "Markierte Dateien verschieben",
"Reset to default gallery list table settings" => "Auf Standardeinstellungen zurücksetzen",
"Download the zip" => "zip-komprimiert herunterladen",
"Assign Permissions" => "Berechtigungen vergeben",
"Move to" => "Verschieben nach",
"Filename" => "Dateiname",
"Other Sorts" => "Andere Sortierungen",
"No information" => "Keine Information",
"Blog post:" => "Blog-Eintrag:",
"at:" => "auf:",
"Somebody or you tried to subscribe this email address at our site:" => "Du oder jemand anders hat versucht, diese Emailadresse einzutragen bei:",
"To the newsletter:" => "Zum Rundbrief:",
"Description:" => "Beschreibung:",
"In order to confirm your subscription you must access the following URL:" => "Zur Bestätigung des Rundbrief-Abonnements musst Du diesem Link folgen:",
"User:" => "Benutzer:",
"A new message was posted to forum" => "Ein neuer Beitrag wurde gepostet ins Forum",
"Tiki mail-in instructions" => "Tiki Mail-in Anweisungen",
"Page not found:" => "Seite nicht gefunden:",
"Hi," => "Hallo,",
"A new message was posted to you at {\$mail_machine}" => "Eine neue Nachricht für Dich auf {\$mail_machine}",
"Hi" => "Hallo",
"Enjoy the site!" => "Viel Spass auf der Site!",
"has requested an account on" => "hat einen Zugang beantragt für",
"Group:" => "Gruppe",
"To validate that account, please follow the link:" => "Zum Bestätigen des Kontos den folgenden Link klicken:",
"User Registration Request" => "Anfrage Tiki Benutzerregistrierung",
"The user" => "Der Benutzer",
"registered at your site" => "hat sich auf Deiner Tiki-Site registriert",
"Bye bye!" => "Auf Wiedersehen!",
"This email address has been removed to the list of subscriptors of:" => "Diese Emailadresse wurde aus die Liste der Adressaten gelöscht von:",
"Bye bye from %s at %s" => "Auf Wiedersehen von %s an %s",
"You can unsubscribe from this newsletter following this link" => "Abbestellen dieses Rundbriefs durch Klick auf den Link möglich",
"Welcome to our newsletter!" => "Willkommen zu diesem Rundbrief!",
"This email address has been added to the list of subscriptors of:" => "Diese Emailadresse wurde in die Liste der Adressaten aufgenommen von:",
"You can always cancel your subscription using:" => "Du kannst das Rundbrief-Abonnement jederzeit rückgängig machen über:",
"Email notification" => "Tiki Email-Benachrichtigung",
"Since this is your registered email address we inform that the password for this account is" => "Da dies Deine registrierte Emailadresse ist, informieren wir Dich darüber, dass das Passwort für dieses Konto wie folgt lautet:",
"Your account information for %s" => "Deine Tikikontoinformationen für %s",
"Report for" => "Bericht für",
"Last Report sent on" => "Letzter Bericht verschickt am",
"Changes in detail:" => "Änderungen im Detail:",
"You can edit the submission following this link:" => "Du kannst diesen Beitrag bearbeiten, wenn Du hier klickst:",
"Title:" => "Titel:",
"Heading:" => "Kopfbereich:",
"Body:" => "Hauptteil:",
"New article submitted at %s" => "Neuer Artikel eingereicht am %s",
"item" => "Eintrag",
"You or someone registered this email address at" => "Du oder jemand anderes hat Deine Emailadresse bei",
"If you want to be a registered user in this site you will have to use the following link to login for the first time:" => "Falls Du Dich für diese Site registrieren möchtest, musst Du Dich für das erste Login über diesen Link anmelden:",
"Your registration confirmation" => "Deine Tiki Registrierungsinformationen",
"Your account request has been stored and will be activated by the admin as soon as possible." => "Die Anfrage wurde gespeichert und wird vom Administrator schnellst möglich bearbeitet.",
"View the article at:" => "Klicke hier um zu dem Artikel zu gelangen:",
"If you don't want to receive these notifications follow this link:" => "Falls Du diese Benachrichtigungen nicht mehr bekommen möchtest, klicke hier:",
"View the blog at:" => "Zeige den Blog auf:",
"A new category was created in" => "Eine neue Kategorie wurde erstellt in",
"Created by" => "Erstellt von",
"created" => "erstellt",
"A category was removed in" => "Eine Kategorie wurde gelöscht in",
"Removed by" => "Gelöscht von",
"A category was updated" => "Eine Kategorie wurde aktualisiert",
"Updated by" => "Aktualisiert von",
"New" => "Neu",
"File Gallery %s changed" => "Dateiverzeichnis %s geändert",
"File Description" => "Dateibeschreibung",
"An object was added to category" => "Ein Objekt wurde hinzugefügt zur Kategorie",
"Added by" => "Hinzugefügt durch",
"An object was removed from category" => "Ein Objekt wurde entfernt aus der Kategorie",
"Comment:" => "Kommentar:",
"You can view the page by following this link:" => "Du kannst die Seite betrachten indem Du diesem Link folgst:",
"You can view a diff back to the previous version by following this link:" => "Du kannst einen Blick auf die vorherige Version werfen, indem Du diesem Link folgst:",
"The changes in this version follow below, followed after by the current full page text." => "Die Änderungen dieser Version folgen unten, gefolgt von dem aktuellen komplette Seiteninhalt.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Zeilen: {\$oldd} geändert zu +Zeilen: {\$newd}",
"The new page content follows below." => "Der neue Seiteninhalt folgt unten.",
"New name" => "Neuer Name",
"You may log in now." => "Du kannst Dich jetzt anmelden.",
"Scale" => "Skalieren",
"Query" => "Abfrage",
"Redraw" => "Neu zeichnen",
"Click on the map or click redraw" => "Karte oder 'Neu zeichnen' anklicken",
"Overview" => "Übersicht",
"Legend" => "Legende",
"Layer Manager" => "Layer-Manager",
"Download Layer" => "Layer herunterladen",
"you have requested to download the layer:" => "Du hast das Herunterladen des Layers angefordert:",
"Here are the files to download, do not forget to rename them:" => "Hier sind die herunterladbaren Dateien, bitte nicht vergessen, sie umzubenennen:",
"Mapfiles" => "Kartendateien",
"Mapfile" => "Kartendatei",
"Available mapfiles" => "Verfügbare Kartendateien",
"monitor this map" => "diese Karte beobachten",
"Stop Monitoring this Map" => "Diese Karte nicht mehr beobachten",
"Create a new mapfile" => "Neue Kartendatei anlegen",
"Create" => "Erstellen",
"Mapfile listing" => "Liste Kartendateien",
"Reload" => "Aktualisieren",
"You can view this map in your browser using" => "Du kannst diese Karte in Deinem Browser betrachten",
"of" => ".",
"Compare" => "Vergleichen",
"Comparing version {\$old.version} with version {\$new.version}" => "Vergleiche Version {\$old.version} mit Version {\$new.version}",
"Current" => "Aktuell",
"Versions are identical" => "Versionen sind identisch",
"Legend:" => "Legende:",
"v=view" => "v=betrachten",
"Ip" => "IP",
"Diff" => "Unterschiede",
"Upload From Disk:" => "Von Platte hochladen:",
"Upload Files" => "Dateien hochladen",
"Bytes maximum" => "Bytes maximal",
"Create Directory:" => "Verzeichnis anlegen:",
"index file (.shp):" => "Index-Datei (.shp):",
"files to index (regexp):" => "zu indizierende Dateien (regexp):",
"Message Archive" => "Nachrichtenarchiv",
"messages" => "Nachrichten",
"Archive is full!" => "Archiv ist voll!",
"Unread" => "Ungelesen",
"Flagged" => "Gekennzeichnet",
"Unflagged" => "Nicht gekennzeichnet",
"Containing" => "die enthalten",
"Sender" => "Absender",
"No messages to display" => "Keine Nachrichten anzuzeigen",
"Broadcast message" => "Nachricht an Verteiler",
"Please Confirm" => "Bitte bestätigen",
"All users" => "Alle Benutzer",
"Lowest" => "sehr niedrig",
"Very High" => "sehr hoch",
"Send" => "Verschicken",
"Compose message" => "Nachricht erstellen",
"Invalid" => "Ungültig",
"Reply-to my email" => "Antwort auf meine Emailadresse",
"Send me a copy" => "Sende mir eine Kopie",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "Mailbox ist voll! Bitte ein paar Nachrichten archivieren oder löschen, damit weitere empfangen werden können.",
"is reply to" => "ist Antwort auf",
"Find replied message" => "suche beantwortete Nachricht",
"Mark as read" => "Markiere als gelesen",
"Mark as unread" => "Markiere als ungelesen",
"Mark as flagged" => "Markiere als gekennzeichnet",
"Mark as unflagged" => "Markiere als ungekennzeichnet",
"Mark" => "Markieren",
"Mailbox" => "Briefkasten",
"Compose" => "Erstellen",
"Broadcast" => "Verteiler",
"Sent" => "Ausgang",
"Auto-archive age for read messages:" => "Mindestalter gelesener Nachrichten für Auto-Archivierung:",
"Read message" => "Nachricht lesen",
"Return to mailbox" => "zurück zum Briefkasten",
"replyall" => "allen antworten",
"Flag this message" => "Nachricht kennzeichnen",
"From:" => "Von:",
"Return to archive" => "Zurück zum Archiv",
"Return to outbox" => "Zurück zum Ausgang",
"Sent Messages" => "Gesendete Nachrichten",
"Replied" => "Beantwortet",
"Not replied" => "Nicht beantwortet",
"move to archive" => "archivieren",
"receiver" => "Empfänger",
"Move module up" => "Modul nach oben verschieben",
"Move module down" => "Modul nach unten verschieben",
"Move module to opposite side" => "Modul zur anderen Seite verschieben",
"toggle" => "Menü ein-/ausblenden",
"You forgot your Google ad_client number !" => "Es wurde keine Google ad_client Nummer angegeben!",
"Thank you for installing Tikiwiki" => "Vielen Dank für die Nutzung von Tiki",
"Select" => "Auswählen",
"Admin" => "Verwalten",
"Admin Modules" => "Module verwalten",
"Modules" => "Module",
"Admin Menus" => "Menüs verwalten",
"Menus" => "Menüs",
"login" => "Anmeldung",
"private" => "privat",
"Add event" => "Ereignis hinzufügen",
"Update" => "Aktualisieren",
"Your cart is empty" => "Dein Warenkorb ist leer",
"Apply" => "Übernehmen",
"Pages:" => "Seiten:",
"empty" => "leer",
"low" => "niedrig",
"Categories:" => "Kategorien:",
"All Groups" => "Alle Gruppen",
"Your Groups" => "Deine Gruppen",
"Switch to Groups" => "Zu Gruppen umschalten",
"Simulate" => "Simuliere",
"more" => "mehr",
"You" => "Du",
"Open operator console" => "Operatorkonsole öffnen",
"Log out" => "Abmelden",
"Switch User" => "Benutzer wechseln",
"Switch" => "Wechseln",
"Switch user" => "Benutzer wechseln",
"Email:" => "E-Mail:",
"I forgot my password" => "Ich habe mein Passwort vergessen",
"Secure" => "Sicher",
"You have" => "Du hast",
"new messages" => "neue Nachrichten",
"new message" => "neue Nachricht",
"You have 0 new messages" => "Du hast keine neuen Nachrichten",
"We have" => "Wir haben",
"submissions waiting to be examined" => "Einreichungen, die auf Sichtung warten",
"Image Galleries" => "Bildergalerien",
"Calendars" => "Kalender",
"Entire Site" => "Ganze Site",
"Image Gals" => "Bildergalerien",
"Advanced search:" => "Erweiterte Suche:",
"Read More" => "Weiterlesen",
"Since your last visit on" => "Letzter Besuch",
"New Images" => "Neue Bilder",
"Wiki Pages Changed" => "Wiki-Seiten geändert",
"New Files" => "Neue Dateien",
"New Comments" => "Neue Kommentare",
"New Users" => "Neue Benutzer",
"click to edit" => "Bearbeiten mit Klick",
"Nothing has changed" => "Keine Änderungen",
"Users" => "Benutzer",
"Multiple" => "mehrfach",
"Site Language:" => "Site-Sprache:",
"Site default" => "Site-Default",
"Find term:" => "Suche Ausdruck:",
"If not found, you will be given a chance to create it." => "Wenn nichts gefunden wird, erhälst Du die Möglichkeit ihn zu erstellen.",
"TikiTests Menu" => "TikiTests Menü",
"List Tests" => "Tests auflisten",
"Create Test" => "Test erstellen",
"Top galleries" => "Top Galerien",
"Incoming" => "Eingehend",
"None match your" => "Keine Übereinstimmung Deiner",
"Set your preferred languages." => "Bevorzugte Sprachen einstellen.",
"preferred languages" => "bevorzugte Sprache(n)",
"view" => "betrachten",
"Outgoing" => "Ausgehend",
"Add Event" => "Termin hinzufügen",
"Bookmarks" => "Lesezeichen",
"Done" => "fertig",
"Del" => "Löschen",
"select" => "wähle",
"Logout" => "Abmelden",
"You need to activate user and/or group trackers." => "Du musst Benutzer- und/oder Gruppen-Tracker aktivieren.",
"Refresh" => "Aktualisieren",
"online users" => "Benutzer (alle) online",
"online user" => "Benutzer online",
"Send a message to" => "Schicke eine Nachricht an",
"There are individual permissions set for this tracker" => "Für diesen Tracker sind individuelle Berechtigungen gesetzt",
"No individual permissions. Global permissions apply." => "Keine individuellen Berechtigungen, globale Berechtigungen gelten",
"Session" => "Sitzungsdaten",
"vote" => "Abstimmen",
"Use Ctrl+Click to select multiple options" => "Benutze Strg+Klick um mehrere Optionen auszuwählen",
"Requires" => "setzt voraus: ",
"You need to set" => "Du musst folgende Funktion einstellen:",
"Reset to default" => "Auf Standardeinstellungen zurücksetzen",
"Rate" => "Bewerten",
"A valid email is mandatory to register" => "Zum Registrieren ist eine gültige Emailadresse nötig.",
"Generate a password" => "Passwort vorschlagen",
"Send Newsletter" => "Rundbrief versenden",
"To edit the copyright notices" => "Zum Bearbeiten der Copyright-Hinweise",
"Click Here" => "hier klicken",
"The content on this page is licensed under the terms of the" => "Der Inhalt dieser Seite unterliegt folgenden Lizenzbestimmungen:",
"Fullscreen" => "Vollbild",
"Made with" => "Erstellt mit",
"powered by" => "Powered by",
"RSS feed" => "RSS Feed",
"Articles RSS" => "Artikel RSS",
"Image Galleries RSS" => "Bilder-Galerien RSS",
"File Galleries RSS" => "Datei-Archive RSS",
"Forums RSS" => "Foren RSS",
"Maps RSS" => "Karten RSS",
"Last update from SVN" => "Letztes Update von SVN",
"Execution time" => "Ausführungszeit",
"secs" => "Sekunden",
"Memory usage" => "Speicherverbrauch",
"database queries used in " => "Datenbankaufrufe ausgeführt in",
"Server load" => "Serverlast",
"Show/Hide Left Column" => "Linke Menüs an/aus",
"Show/Hide Right Column" => "Rechte Menüs an/aus",
"Do not group by item" => "Nicht nach Objekt gruppieren",
"Calendar View" => "Kalenderansicht",
"Tiki Action Calendar" => "Tiki Aktionenkalender",
"Tools Calendars" => "Kalendereinträge",
"Check / Uncheck All" => "Alle (ent)markieren",
"Configuration search" => "Einstellungen suchen",
"Change" => "Ändern",
"No results" => "Keine Ergebnisse",
"No preferences were found for your search query." => "Es wurden keine Einstellungen gefunden, die Deinen Suchbegriff enthalten.",
"Database Version Problem" => "Datenbank Versionsproblem",
"Your database requires an update to match the current Tiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors." => "Deine Datenbank benötigt ein Update, um mit der aktuellen Tiki Version zusammenzupassen. Bitte fahre mit <a href=\"tiki-install.php\">dem Installer</a> fort. Tiki mit einer falschen Datenbankversion zu benutzen  verursacht Fehler.",
"The following list of changes has been applied:" => "Folgende Änderungen wurden übernommen:",
"Enabled" => "Aktiviert",
"Preference" => "Einstellung",
"Preference name:" => "Einstellungsname:",
"Crosslinks to other features and settings" => "Querverweise zu anderen Einstellungen",
"Other sections" => "Andere Bereiche",
"Shoutbox Words" => "Shoutboxwörter",
"Live Support" => "Online-Support",
"Administration features" => "Grundlegende Konfiguration",
"SysLogs" => "Systemlogs",
"phpinfo" => "PHPInfo",
"Banning" => "Benutzer aussperren",
"Edit Languages" => "Bearbeite Sprachen",
"Transitions" => "Transitionen",
"Transversal features" => "Übergeordnete Einstellungen",
"which apply to more than one section" => "die sich auf mehr als einen Bereich auswirken",
"Mail Notifications" => "Email-Benachrichtigungen",
"Navigation features" => "Navigation",
"Look & feel" => "Look & Feel",
"themes" => "Themes",
"Text area features" => "Einstellungen für Inhalte",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "Einstellungen, die für Wikiseiten, Blogs, Artikeln, Foren etc. gelten",
"External Pages Cache" => "Cache für externe Seiten",
"Toolbars" => "Werkzeug Symbole",
"External Wikis" => "Externe Wiki-Seiten",
"Stats &amp; banners" => "Statistiken & Banner",
"Search Stats" => "Suchstatistik",
"Report" => "Bericht",
"Please select some actions to be reported." => "Bitte wähle Aktionen aus, die berichtet werden sollen.",
"Users and Groups" => "Benutzer und Gruppen",
"Category:" => "Kategorie",
"Units" => "Einheiten",
"kb" => "kB",
"Contibution Time" => "Beitragszeit",
"Graph Contributions" => "Zeige Grafik",
"Records:" => "Gespeichert:",
"contribution" => "Mitwirkung",
"Statistics" => "Statistiken",
"Weeks" => "Wochen",
"Settings" => "Einstellungen",
"Setting" => "Einstellung",
"How" => "Wie es geht",
"You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occured since the action type has been set to recorded." => "Du musst das Feld 'aufgezeichnet' für jeden Aktionstyp daraufhin prüfen, ob Du hierüber später einen Bericht haben willst. Um einen Bericht von einigen Aktionstypen zu erhalten klicke das 'berichtet'-Feld dieser Aktionstypen, gehe auf den Tab Bericht und wähle zusätzliche Filter. Der Bericht wird nur die Aktionen beinhalten, die entstanden sind, nachdem der Aktionstyp auf 'aufgezeichnet' gesetzt wurde.",
"Wiki page actions except viewed will always be recorded but can be not reported." => "Wiki-Aktionen außer 'hat angesehen' werden immer gespeichert, gehen aber nicht in Berichte ein.",
"Rule title" => "Regelbezeichnung",
"Username regex matching" => "Benutzername-basiert (regex)",
"IP regex matching" => "IP-basiert (regex)",
"Banned from sections" => "Aus diesen Bereichen bannen",
"Rule activated by dates" => "Sperrung über Zeitraum",
"Rule active from" => "Regel gültig von",
"Rule active until" => "Regel gültig bis",
"Custom message to the user" => "Spezielle Nachricht für den Benutzer",
"Rules" => "Regeln",
"x" => "X",
"User/IP" => "Benutzername/IP",
"Sections" => "Bereiche",
"Admin Calendars" => "Kalender verwalten",
"Create Calendar" => "Erstelle Kalender",
"View Calendars" => "Kalender ansehen",
"Import" => "Importieren",
"List of Calendars" => "Liste der Kalender",
"Loc" => "Ort",
"Participants" => "Teilnehmer",
"Cat" => "Kateg.",
"Lang" => "Sprache",
"Subscription" => "Abonnement",
"View Calendar" => "Kalender ansehen",
"Create / Edit Calendar" => "Erstelle / bearbeite Kalender",
"Create/Edit Calendars" => "Erstelle / bearbeite Kalender",
"Custom Locations" => "Persönliche Örtlichkeiten",
"Custom Participants" => "Persönliche Teinehmer",
"Custom Languages" => "Persönliche Sprache",
"Custom URL" => "Benutzerdefinierte URL",
"Custom Subscription List" => "Persönliche Abo-Liste",
"Custom Priorities" => "Persönliche Prioritäten",
"Personal Calendar" => "Persönlicher Kalender",
"Start of day" => "Start des Tages",
"End of day" => "Ende des Tages",
"Days to display" => "Anzuzeigende Tage",
"Standard Colors" => "Standardfarben",
"Let me select my own colors" => "Lass' mich meine eigenen Farben wählen",
"Custom foreground color" => "Standardvordergrundfabe",
"Ex:" => "Beispiel:",
"Custom background color" => "Standardhintergrundfarbe",
"Default event status" => "Standarfstatus für Ereignis",
"Show in calendar view" => "Zeige in Kalenderansicht",
"Group of users alerted when calendar event is modified" => "Benutzergruppe die benachrichtigt wird, wenn ein Kalendereintrag verändert wird",
"Delete events older than:" => "Lösche Ereignisse, die älter sind als",
"Current category" => "Aktuelle Kategorie",
"Current Category ID:" => "Aktuelle Kategorie-ID:",
"Child categories" => "Unterkategorien",
"Edit permissions for this category" => "Berechtigungen dieser Kategorie ändern",
"Create/Edit category" => "Erstelle/bearbeite Kategorie",
"Edit this category:" => "Diese Kategorie bearbeiten:",
"Create New" => "Erstelle neu",
"Add new category" => "Neue Kategorie hinzufügen",
"Batch upload" => "Stapelhochladen",
"Batch upload (CSV file)" => "Stapelhochladen (CSV-Datei)",
"Objects in category" => "Objekte in Kategorie",
"No records found." => "Keine Einträge gefunden.",
"Moving objects between categories" => "Objekte zwischen Kategorien verschieben",
"Unassign all objects from this category" => "Entferne alle Objekte von dieser Kategorie",
"Move all the objects from this category to this one" => "Verschiebe alle Objekte von dieser Kategorie zu dieser",
"Assign all objects of this category to this one" => "Weise alle Objekte dieser Kategorie dieser zu",
"Add objects to category" => "Objekte zu Kategorie hinzufügen",
"Admin templates" => "Vorlagen verwalten",
"Edit this template:" => "Dieses Template bearbeiten:",
"Create new template" => "Neue Vorlage erstellen",
"CMS" => "Artikel",
"HTML Pages" => "HTML-Seiten",
"Text area" => "Textbereiche",
"Templates" => "Vorlagen",
"Admin Contributions" => "Beteiligungslisten verwalten",
"Contributions are mandatory in wiki pages" => "Angabe bei Wikiseiten zwingend",
"Contributions are mandatory in forums" => "Angabe bei Foreneinträgen zwingend",
"Contributions are mandatory in comments" => "Angabe bei Kommentaren zwingend",
"Contributions are mandatory in blogs" => "Angabe bei Blogeinträgen zwingend",
"Contributions are displayed in the comment/post" => "Beteiligung wird in Kommentar/Beitrag angezeigt",
"Create a new contribution" => "Neue Beteiligungsliste erstellen",
"List of contributions" => "Übersicht der Beteiligungslisten",
"Admin cookies" => "Cookies verwalten",
"Create/edit cookies" => "Cookies hinzufügen/bearbeiten",
"Upload Cookies from textfile" => "Cookies aus Textdatei hochladen",
"Upload from disk:" => "Hochladen von Festplatte:",
"Upload" => "Hochladen",
"Remove all cookies" => "Alle Cookies löschen",
"cookie" => "Cookie",
"Creation Date" => "Erstellungsdatum",
"Expiration Date" => "Ablaufdatum",
"all types" => "alle Typen",
"filter" => "Filtern",
"Admin DSN" => "DSN verwalten",
"Create/Edit External Wiki" => "Externes Wiki erstellen/bearbeiten",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (\$page benutzen und mit dem Wiki Seitennamen ersetzen, z.B.: http://qum74.mms-dresden.telekom.de/tiki/tiki-index.php?page=\$page)",
"Admin Forums" => "Foren verwalten",
"Create New Forum" => "Neues Forum erstellen",
"Duplicate Forum" => "Forum kopieren",
"View this forum" => "Forum ansehen",
"Import forums" => "Foren importieren",
"List forums" => "Foren auflisten",
"Coms" => "Kommentare",
"Age" => "Alter",
"PPD" => "PPT",
"Create/Edit Forums" => "Foren hinzufügen/bearbeiten",
"Edit this Forum:" => "Dieses Forum bearbeiten:",
"Create new" => "Erstelle neu",
"Password protected" => "mit Passwort gesichert",
"Forum password" => "Foren-Passwort",
"Topic list configuration" => "Einstellungen Themenliste",
"Last post title" => "Titel letzter Eintrag",
"Last post avatar" => "Avatar letzter Eintrag",
"Author avatar" => "Autor Avatar",
"Posts can be rated" => "Einträge dürfen bewertet werden",
"Display last post titles" => "Neueste Beitragstitel anzeigen",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Nachrichten in dieses Forum an die angegebene Emailadresse weiterleiten in einem Format, das Rückantworten ins Forum erlaubt",
"Send mails even when the post is generated by inbound mail" => "Nachrichten auch schicken, wenn das Posting per Email getätigt wurde",
"Append a reply link to outbound mails" => "Antwort-Link an ausgehende Nachrichten anhängen",
"Originating e-mail address for mails from this forum" => "Absenderadresse für Nachrichten aus diesem Forum",
"Add messages from this email to the forum" => "Nachrichten von dieser Emailadresse in das Forum weiterleiten",
"Use topic smileys" => "Smilies für Themen benutzen",
"Show topic summary" => "Themenzusammenfassung anzeigen",
"User information display" => "Benutzer-Informationen anzeigen",
"eMail" => "Email",
"Approval type" => "Bestätigung nötig für",
"Store attachments in:" => "Anhänge speichern in:",
"Shows number of attachments of the all thread in forum list" => "Zeige Anzahl der Anhänge aller Threads in der Forenliste",
"Set topics preferences" => "Themen-Einstellungen festlegen",
"Show topics preferences" => "Themen-Einstellungen anzeigen",
"hide topics preferences" => "Themen-Einstellungen verbergen",
"Duplicate perms" => "Berechtigungen duplizieren",
"Admin Hotwords" => "Hotwords verwalten",
"Add Hotword" => "Hotword hinzufügen",
"Word" => "Wort",
"Admin HTML pages" => "HTML-Seiten verwalten",
"Edit this page" => "Ändere diese Seite",
"View page" => "Seite anzeigen",
"Edit zone" => "Bereiche bearbeiten",
"Content" => "Inhalt",
"Dynamic zones" => "Dynamische Bereiche",
"zone" => "Bereich",
"content" => "Inhalt",
"Mass update" => "Massenaktualisierung",
"Create new HTML page" => "Neue HTML-Seite erstellen",
"Edit this HTML page:" => "Diese HTML-Seite bearbeiten:",
"Apply template" => "Vorlage anwenden",
"Dynamic" => "Dynamisch",
"Static" => "Statisch",
"Last Modif" => "Letzte Änderung",
"Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones." => "Wähle <a href=\"tiki-list_banners.php\" title=\"Banners\">Verwalten > Banners</a> aus dem Hauptmenü, um eine Bannerzone zu erstellen/bearbeiten.",
"Cancel Edit" => "Bearbeitung verwerfen",
"Change preferences" => "Einstellungen übernehmen",
"Site Ads and Banners" => "Site Werbung und Banner",
"<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users." => "<strong>Aktivieren</strong> zeigt den Inhalt nur Administratoren. Wähle <strong>veröffentlichen</strong> um den Inhalt allen Benutzer anzuzeigen.",
"General" => "Allgemein",
"Features" => "Funktionen",
"Community" => "Gemeinschaft",
"Profiles" => "Profile",
"Look &amp; Feel" => "Erscheinungsbild",
"Editing and Plugins" => "Bearbeiten und PlugIns",
"Meta Tags" => "Meta-Tags",
"Connect" => "Verbinden",
"Wiki page settings and features" => "Wiki-Seiten Einstellungen und Funktionen",
"Settings for blogs" => "Einstellungen für Blogs",
"Settings and features for articles" => "Einstellungen und Funktionen für Artikel",
"Settings and features for forums" => "Einstellungen und Funktionen für Foren",
"Settings and features for trackers" => "Einstellungen und Funktionen für Trackers",
"Settings and features for polls" => "Einstellungen und Funktionen für Umfragen",
"Settings and features for calendars" => "Einstellungen und Funktionen für Kalender",
"Settings and features for categories" => "Einstellungen und Funktionen für Kategorien",
"Settings and features for freetags" => "Einstellungen und Funktionen für Freetags",
"Search configuration" => "Suche konfigurieren",
"Settings and features for FAQs" => "Einstellungen und Funktionen für FAQs",
"Settings and features for directory of links" => "Einstellungen und Funktionen für Linkverzeichnisse",
"Settings and features for maps" => "Einstellungen und Funktionen für Karten",
"Message settings" => "Einstellungen Nachrichten",
"User files" => "Benutzerdateien",
"User files settings" => "Einstellungen Benutzerdateien",
"Webmail settings" => "Einstellungen Webmail",
"To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "Blogs hinzufügen/löschen über Menüpunkt 'Blogs' im Menü im Seitenbalken oder",
"General Settings" => "Generelle Einstellungen",
"Sharing on social networks" => "Sharing in sozialen Netzwerken",
"Blogs Listings" => "Blogauflistungen",
"Select which items to display when listing blogs" => "Wähle, welche Dinge bei der Auflistung der Blogs angezeigt werden sollen",
"To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "Um Kalender hinzuzufügen/zu entfernen, siehe im Hauptmenü unter Kalender nach, oder ",
"Change settings" => "Einstellungen übernehmen",
"General settings" => "Allgemeine Einstellungen",
"Default calendars to display" => "Standardmäßig werden folgende Kalender angezeigt",
"All calendars" => "Alle Kalender",
"A subset of available calendars" => "Ein Teil der verfügbaren Kalender",
"JS calendar" => "JS Kalender",
"Browse categories" => "Kategorien ansehen",
"Administer categories" => "Kategorien verwalten",
"With PHPlayers, watch icons are only visible for the top category" => "Bei der Nutzung von PHPLayers sind Beobachten-Symbole nur für die Topkategorie sichtbar",
"Look under \"Articles\" on the application menu for links to" => "Im Hauptmenü unter 'Artikel' kann man",
"Admin topics" => "Themen verwalten",
"Admin types" => "Typen verwalten",
"Article properties" => "Artikeleingenschaften",
"Give only one value (width or height) to keep the image proportions" => "Gib nur einen Wert (Höhe oder Breite) an, um die Bildproportionen zu erhalten",
"Import CSV file" => "CSV-Datei importieren",
"File format: title,authorName,heading,body,lang,user" => "Dateiformat: Titel,Autorname,Überschrift (Kopf),Text (Body),Sprache,Benutzer",
"Articles Listing" => "Artikel auflisten",
"List Articles" => "Artikel auflisten",
"Select which items to display when listing articles" => "Wähle, welche Dinge bei der Auflistung der Artikel angezeigt werden sollen",
"Article View" => "Artikelansicht",
"List comments" => "Kommentare auflisten",
"General Preferences" => "Verschiedene Einstellungen",
"Site-wide features" => "Site-weite Funktionen",
"Display options" => "Anzeigeoptionen",
"Permission" => "Berechtigung",
"Using comments in various features" => "Kommentarbenutzung in verschiedenen Funktionen",
"Admin Groups" => "Gruppen verwalten",
"Admin Users" => "Benutzer verwalten",
"User features" => "Benutzerfunktionen",
"Default user preferences" => "Standardbenutzereinstellungen",
"Users Default Preferences" => "Benutzer-Standardeinstellungen",
"My Tiki" => "Mein Tiki",
"Select which items to display when listing users" => "Wähle, welche Dinge bei der Auflistung der Benutzer angezeigt werden sollen",
"Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU." => "Tiki Wiki CMS Groupware ist frei und Open Source Software (FOSS). Sie ist ein Gemeinschaftsgelenktes Projekt, welches nur durch die Teilnahme von einzelnen Benutzer - so wie DU - existiert und verbessert wird.",
"Join the community!" => "Schließ Dich der Gemeinschaft an!",
"Promote your site" => "Bewerbe Deine Site",
"To submit your site to Tiki.org:" => "Um Deine Site zu Tiki.org zu senden:",
"Submit site" => "klicke hier",
"Help improve Tiki" => "Helfe Tiki zu verbessern",
"To submit a feature request or to report a bug:" => "Um eine Funktionsanfrage zu stellen oder einen Bug zu berichten",
"Click here to go to our development site" => "klicke hier um auf unsere Entwicklersite zu gelangen",
"Copyright allows to determine a copyright for all the objects of tikiwiki" => "Das Copyright erlaubt ein Copyright für alle Tikiobjekte festzulegen",
"Enable copyright management for" => "Aktiviere Copyrightmanagement für",
"To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "Linkverzeichnisse können im Hauptmenü unter \"Linksverzeichnisse\" > \"Linkverzeichnisse verwalten\" konfiguriert werden. Alternativ",
"To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "FAQs hinzufügen/löschen über Menüpunkt 'FAQs auflisten' unter 'FAQs' im Hauptmenü oder",
"Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site." => "Bitte beachte die <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>Beschreibung der Funktionen</a> auf der Tiki Dokumentationsseite.",
"Global features" => "Globale Funktionen",
"Main feature" => "Hauptfunktionen",
"Watches" => "Beobachtungspunkte",
"jQuery plugins and add-ons" => "jQuery Plugins und Add-ons",
"Experimental" => "Experimentell",
"Programmer" => "Entwickler",
"Logging and Reporting" => "Protokollierung und Benachrichtigung",
"Visible to admin only" => "Nur für Admin sichtbar",
"Include Smarty notices" => "auch Smarty Hinweise anzeigen",
"Custom Code" => "Angepasster Code",
"These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application" => "Diese Funktionen sind relativ neu, oder wurden kürzlich umfassend überarbeitet. Du solltest Dich auf Schwierigkeiten bei der Benutzung und möglicherweise eine fehlende oder nicht aktuelle Dokumentation erwarten. In etwa wie bei einer ersten Programmversion oder einer Betaversion.",
"Getting there..." => "Auf dem Weg ...",
"Most of these features are hoped to make it into the \"new\" section for Tiki 6." => "Die meisten dieser Funktionen sollten es noch in den Bereich \"Neu\" von Tiki 6 schaffen",
"Fresh out of the oven" => "Frisch aus dem Ofen",
"Seem ok but..." => "Scheint ok, aber...",
"These features are not reported to be broken, but they are not actively developed and/or widely used." => "Diese Funktionen funktionieren. Aber sie werden derzeit nicht aktiv weiterentwickelt und/oder genutzt.",
"Will be phased out" => "Wird eingestellt",
"These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology." => "Diese Funktionen funktionieren, werden aber voraussichtlich in Zukunft eingestellt, von anderen Funktionen verdrängt oder sie sind aufgrund der Weiterentwicklung der Webtechnik überholt.",
"Feedback" => "Rückmeldung",
"To create or remove file galleries, select" => "Um ein Dateiarchiv zu erstellen oder zu entfernen, wähle",
"from the application menu" => "aus dem Anwendungsmenü",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Wenn Dateien in einem Verzeichnis (statt in der Datenbank) gespeichert werden sollen, sollte das Verzeichnis nicht direkt zugreifbar sein.",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Dafür gibt es zwei Möglichkeiten:<br /><ul><li>Das Verzeichnis liegt außerhalb des Document-Roots. Achtung: evtl. muß es dann noch für PHP lesbar gemacht werden.</li><li>Das Verzeichnis liegt im Document-Root. Achtung: es sollte dann über eine .htaccess Datei geschützt werden.</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Das Verzeichnis sollte in Unix-Notation angegeben werden, z.B. files/ oder c:/foo/files oder /www/files/",
"Move files from database to directory" => "Verschiebe Dateien von der Datenbank in ein Verzeichnis",
"Move files from directory to database" => "Verschiebe Dateien aus einem Verzeichnis in die Datenbank ",
"Manage comment settings" => "Verwalte Kommentareinstellungen",
"A cron job must be set up in order to delete the files." => "Ein Cronjob muss konfiguriert werden, um die Dateien zu löschen.",
"Gallery Listings" => "Auflistung",
"Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Veränderungen beeinflussen bestehende Dateiarchive <em>nicht</em>. Diese Änderungen betreffend <em>nur</em> neue Dateiarchive",
"Select which items to display when listing galleries: " => "Zeige Felder an, die bei der Auflistung von Verzeichniskategorien erscheinen sollen:",
"Admin Gallery Listings" => "Verzeichnislisten verwalten",
"Select which items to display when admin galleries: " => "Zeige Felder an, die in den Verzeichniskategorien erscheinen sollen:",
"Search Indexing" => "Indexierung",
"Automatically index files on upload or change" => "Automatisch Dateien beim Hochladen oder nach Änderungen indexieren",
"Handlers" => "Handler",
"Add custom handlers to make your files &quot;searchable&quot; content" => "Füge einen benutzerdefinierten Handler hinzu um den Inhalt Deiner Dateien \"durchsuchbar\" zu machen",
"Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Benutze <strong>%1</strong> für den internen Dateinamen. Zum Beispiel, benutze <strong>strings %1</strong> um ein Dokument mit dem Unixbefehl <strong>strings</strong> in Text umzuwandeln.",
"To delete a handler, leave the <strong>System Command</strong> field blank" => "Um einen Handler zu löschen, lass das Feld <strong>Systembefehl</strong> leer",
"Missing Handlers" => "Fehlende Handler",
"MIME Type" => "MIME-Typ",
"System Command" => "Systembefehl",
"Reindex all files for search" => "Dateien für Suche neu indizieren",
"To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "Foren hinzufügen/löschen über Menüpunkt 'Foren verwalten' im Menü im Seitenbalken oder",
"Searches" => "Suchanfragen",
"Forums Listing" => "Foren auflisten",
"Select which items to display when listing forums" => "Wähle welche Elemente anzuzeigen sind, wenn Foren aufgelistet werden",
"When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "Wenn man auf die <a href=\"tiki-browse_freetags.php\">Freetag Suchseite</a> kommt",
"Random tag cloud colors" => "Farben für zufällige Tags",
"Separate colors with a comma (,)" => "Trenne Farben mit Kommata (,)",
"Alphanumeric ASCII characters only" => "Nur alphanummerische ASCII-Zeichen",
"No accents or special characters" => "Keine Akzente oder Sonderzeichen",
"Accept all characters" => "Akzeptiere alle Zeichen",
"Tag Management" => "Tag-Verwaltung",
"Cleanup unused tags" => "Lösche unbenutzte Tags",
"3D Tag Browser Configuration" => "3D Tag Browser Konfiguration",
"Graph appearance" => "Grafische Erscheinung",
"Camera settings" => "Kameraeinstellungen",
"Physics engine" => "Physik-Engine",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Bildgalerien hinzufügen/löschen über Menüpunkt 'Bildgalerien' im Menü im Seitenbalken oder",
"You can upload images of a size of " => "Maximale Größe zum uploaden von Bildern: ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Ändere in der php.ini die Parameter file_uploads, upload_max_filesize, post_max_size und die Datenbankparameter (max_allowed_packet für MySQL) um diesen Größe zu ändern",
"Home Gallery" => "Hauptarchiv",
"Galleries features" => "Galerieeigenschaften",
"Uses Slideshow" => "Diaschau verwenden",
"Use database to store images" => "Datanbank zum Speichern von Bildern benutzen",
"Use a directory to store images" => "Ein Verzeichnis zum Speichern von Bildern benutzen",
"Directory path" => "Verzeichnis",
"Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below." => "Hinweis: wenn das Verzeichnis geändert wird, muß auch der Inhalt im Filesystem entsprechend manuell verschoben werden. Oder Du kannst die Dateien in die Datenbank verlagern (s.u.)",
"Library to use for processing images" => "Bibliothek zur Bildbearbeitung",
"Uploaded image names must match regex" => "Hochgeladene Bildnamen müssen diese RegEx erfüllen",
"Uploaded image names cannot match regex" => "Hochgeladene Bildnamen dürfen dieser RegEx nicht entsprechen",
"Directory Batch Loading" => "Aus Verzeichnis einlesen",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "Wenn 'Batch-Upload aus Verzeichnis' aktiviert wird muß ein vom Webserver lesbares Verzeichnis benutzt werden (am besten außerhalb des Webspace). Dorthin müssen die Bilder dann mit scp, ftp o.ä. übertragen werden.",
"Enable directory batch loading" => "Batch-Upload aus Verzeichnis erlauben",
"Batch loading directory" => "Batch-Upload Verzeichnis",
"Max Rows per page" => "Max. Zeilen pro Seite",
"Images per row" => "Bilder pro Zeile",
"Thumbnails size X" => "Thumbnails Breite",
"Thumbnails size Y" => "Thumbnails Höhe",
"pixels" => "Pixel",
"Set features" => "Einstellungen übernehmen",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Bilder aus der Systemgalerie entfernen, die nicht auf Wiki-Seiten, in Artikeln oder Blog-Einträgen genutzt werden",
"Mover" => "Dateien verlagern",
"Move images from filesystem storage to database storage" => "Verschiebe alle Bilder aus dem Dateisystem in die Datenbank",
"All galleries" => "Alle Galerien",
"System Gallery" => "Systemgalerie",
"Gallery listing configuration" => "Einstellungen Galerie-Liste",
"Change configuration" => "Einstellungen übernehmen",
"Image galleries comments settings" => "Bildergalerie-Kommentareinstellungen",
"Release Check" => "Suchen nach neuer Version",
"Reset or upgrade your database" => "Datenbank neu aufsetzen oder aktualisieren",
"Check for updates now" => "Jetzt nach neuer Version suchen",
"Site Identity" => "Site-Identität",
"Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences" => "Im Abschnitt <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> können weitere Einstellungen zur Anpassung des Layouts u.ä, vorgenommen werden.",
"Email to send a test mail" => "Emailadresse für die Testmail",
"Contact" => "Kontakt",
"Miscellaneous" => "Verschiedenes",
"Create and edit menus " => "Menüs erstellen und bearbeiten: ",
"Home Page" => "Startseite",
"Redirects" => "Weiterleitungen",
"Site Access" => "Zugriff auf die Site",
"Date and Time" => "Datum und Zeit",
"Sample:" => "Beispiel:",
"Date and Time Format Help" => "Hilfe zum Datums- und Zeitformat",
"Change admin password" => "Admin-Passwort ändern",
"Change the <strong>Admin</strong> password:" => "Ändere das <strong>Admin</strong> Passwort:",
"User administration" => "Benutzer Verwaltung",
"To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details." => "Um Google Maps nutzen zu können, musst Du einen Google Maps API Key für Deine Site erzeugen lassen. Siehe hierzu <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> für weitere Details.",
"Defaults" => "Standards",
"Map mode in listings" => "Kartenmodus in Listen",
"Internationalization" => "Internationalisierung",
"Edit or export/import Languages" => "Sprachen bearbeiten oder exportieren/importieren",
"Babelfish links" => "Babelfish Links",
"Customized String Translation" => "Benutzerdefinierte Übersetzung",
"ok" => "OK",
"Intertiki client" => "Intertiki Client",
"Tiki Unique key" => "Eindeutiger Tiki Schlüssel",
"InterTiki Slave mode" => "InterTiki Slave Modus",
"Warning: overrides manually registered local users" => "Warnung: Überschreibt Nutzer die sich manuell registriert haben",
"as master" => "als Master",
"port" => "Port",
"Add new server" => "Neuen Server hinzufügen",
"Intertiki server" => "Intertiki Server",
"Intertiki Server enabled" => "Intertiki Server aktiviert",
"Access Log file" => "Verbindungs-Log-Datei",
"Known hosts" => "Bekannte Hosts",
"Key" => "Schlüssel",
"Enable/disable Tiki features in " => "Tiki-Funktionen ein/ausschalten unter ",
", but configure them elsewhere" => ", konfiguriert werden sie dann an anderen Stellen.",
"Registration" => "Registrierung",
"Users can select a group to join at registration:" => "Benutzer können eine Benutzergruppe bei ihrer ersten Registrierung wählen",
"By default, new users automatically join the Registered group" => "Standardmäßig werden neue Benutzer automatisch in die Gruppe \"Registered\" einsortiert",
"You must change the Authentication Method to LDAP for these changes to take effect" => "Du musst die Authentifizierung auf LDAP umstellen, damit diese Einstellungen funktionieren",
"You must change the Authentication Method to PAM for these changes to take effect" => "Du musst die Authentifizierung auf PAM umstellen, damit diese Einstellungen funktionieren",
"You must change the Authentication Method to Shibboleth for these changes to take effect" => "Du musst die Authentifizierung auf Shibboleth umstellen, damit diese Einstellungen funktionieren",
"You must change the Authentication Method to phpBB for these changes to take effect" => "Du musst die Authentifizierung auf phpBB umstellen, damit diese Einstellungen funktionieren",
"You must turn Users can register off for phpBB Authentication to function properly" => "Du musst \"Benutzer können sich registrieren\" ausschalten, damit phpBB Authentifizierung funktioniert",
"MySql only (for now)" => "nur MySql (vorerst)",
"You must change the Authentication Method to Web Server for these changes to take effect" => "Du musst die Authentifizierung auf Webserver umstellen, damit diese Einstellungen funktionieren",
"Restrict available themes" => "Verfügbare Themes einschränken",
"General Layout options" => "Allgemeine Layout-Einstellungen",
"The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for <em>all</em> users." => "Der benutzerdefinierte Site-Kopf (Header) wird nur dem Administrator angezeigt. Wähle <strong>\"Veröffentlichen\"</strong> um den Inhalt <em>allen</em> Benutzern anzuzeigen.",
"Pagination links" => "Paginierungslinks",
"UI Effects" => "UI Effekte",
"Standard UI effects" => "Standard UI Effekte",
"Tab UI effects" => "Tab UI Effekte",
"Experimental: CSS assistant (work in progress - click the x to remove)" => "Experimentell: CSS Assistent (in Arbeit - klicke X zum Entfernen)",
"Admin layout per section" => "Layout pro Bereich verwalten",
"Context Menus" => "Kontektmenüs",
"Currently used in File Galleries only" => "Gegenwärtig nur in Dateiarchivenbenutzt",
"Separators" => "Trennzeichen",
"Examples" => "Beispiele",
"Generate User Map" => "Benutzerkarte erstellen",
"&quot;Modules&quot; are the boxes of content in the right &amp; left columns" => "\"Module\" sind Boxen mit Inhalten, die auf der linken oder rechten Spalte plaziert werden können",
"Admin &gt; Modules" => "Verwalten > Module",
"from the menu to create and edit modules" => "vom Menü um Module zu erstellen oder zu bearbeiten",
"Payments" => "Bezahlungen",
"Choose payment system" => "Wähle das Bezahlsystem",
"PayPal is working at the moment. See PayPal.com" => "PayPal funktioniert derzeit. Siehe auch PayPal.com",
"Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite:Gemeinschatfswährungbuchhaltung für lokale Austauschhandelssystem (local exchange trading systems = LETS). Siehe ",
"Tiki User Credits: Requires this other feature to be configured" => "Tiki User Credits: erfordert, dass diese Funktion konfiguriert wird",
"Shipping" => "Transport",
"Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site." => "Siehe Dir auch die <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performanceseite</a> auf der Entwicklersite an.",
"Memory" => "Speicher",
"Hit" => "Treffer",
"Changing this feature will immediately log you out when you save this preference." => "Ändern und Speichern dieses Werts hat eine umgehende Abmeldung zur Folge.",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Umfragen hinzufügen/löschen über Menüpunkt 'Abstimmungen' unter 'Verwalten' im Hauptmenü oder",
"Waiting" => "Wartend",
"Apply Profiles" => "Profile anwenden",
"Last update" => "Letzte Aktualisierung",
"Global configuration" => "Globale Einstellungen",
"Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or" => "Benutze diese Seite um die Feeds einzustellen, die von Tiki erzeugt werden. Um Feeds zu erfassen, die von anderen Sites stammen, benutze die Funktion <strong>Verwalten</strong> > <strong>Externe Feeds</strong>, oder",
"External feeds" => "Externe Feeds",
"Specification" => "Spezifikation",
"Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public." => "Aktivieren des Cache überschreibt die bestehenden Rechte - der gesamte Inhalt wird öffentlich. Aktiviere diese Option <strong>nur</strong>, wenn der Inhalt öffentlich gemacht werden soll.",
"Feed for directories" => "Feed für Verzeichnisse",
"You can see users rank by score in the module users_rank, for that go to" => "Den Benutzerrang nach Bewertung kann man dem Modul user_rank entnehmen, einschaltbar unter",
"Admin modules" => "Module",
"Expiration" => "Verfallszeit",
"Refresh wiki search index now" => "Wiki Suchindex jetzt aktualisieren",
"Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site." => "Lies auch die <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Sicherheitsseite</a> auf der Tikientwicklersite.",
"See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "Siehe auch <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Verwalten > Sicherheit</strong></a> für zusätzliche Sicherheitseinstellungen",
"CSRF Security" => "CSRF Sicherheit",
"Spam protection" => "Spam Schutz",
"Search results" => "Suchergebnisse",
"SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file." => "Suchmaschienenfreundliche URLs (SEFURL) werden nicht funktionieren, bis nicht die tikispezifischen Direktiven in die .htaccess Datei aufgenommen wurden.",
"To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>." => "Um diese Datei zu aktivieren, benenne einfach die <strong>_htaccess</strong> Datei (im Hauptverzeichnis der Tiki Installation) in <strong>.htaccess</strong> um.",
"If you need to keep an existing (non Tiki) .htaccess file, just add Tiki directives to it." => "Wenn es notwendig ist, eine bestehende (nicht Tiki) .htaccess Datei zu behalten, füge in diese Datei die Tiki-Direktiven ein.",
"When you upgrade (ex.: from Tiki4 to Tiki5), make sure to use the new _htaccess file." => "Wenn Du Tiki Upgradest (z.B.: von from Tiki 4 auf Tiki 5), stelle sicher, die neue _htaccess-Datei zu benutzen.",
"Activate the feature" => "Funktion aktivieren",
"To use Twitter integration, you must register this site as an application at" => "Um die Twitterintegration zu nutzen, muss der Siteadministrator diese Site bei Twitter als eine Anwendung registrieren und zwar unter",
"and allow write access for the application" => "und der Anwendung Schreibrechte einräumen",
"Text area (that apply throughout many features)" => "Textbereiche (hat Auswirkungen auf viele Funktionen)",
"Default size" => "Standardgröße",
"External links and images" => "Externe Links und Bilder",
"External links will be identified with" => "Externe Links werden identifiziert durch",
"About plugins" => "Über Plugins",
"Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below." => "Durch Tiki-Plugins werden zusätzliche Funktionen zu Wikiseiten, Artikeln, Blogs, etc. hinzugefügt. Du kannst unten Plugins an- und abschalten.",
"You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>." => "Du kannst Plugins zur Benutzung unter <a href=\"tiki-plugins.php\">tiki-plugins.php</a> freigeben.",
"The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below." => "Durch das \"Bearbeite Plugin-Symbol\" kann man auf Wikiseiten einfach die Parameter eines Plugins ändern. Diese Funktion kann für jedes Plugin einzeln deaktiviert werden",
"Check disabled plugins used in wiki pages" => "Prüfe auf deaktivierte Plugins in den Wikiseiten",
"Edit plugin icons" => "Symbol zur Pluginbearbeitung",
"Enable" => "Aktivieren",
"Disable edit plugin icon (make plugin inline)" => "Deaktiviere das Symbol zum Bearbeiten des Plugins (make plugin inline)",
"About plugin aliases" => "Über Plugin-Alias",
"General Information" => "Generelle Informationen",
"Base Plugin" => "Basisplugin",
"Body Label" => "Bezeichnung",
"Dependencies" => "Abhängigkeiten",
"Plugin Parameter Documentation" => "Dokumentation Pluginparameter",
"Required" => "Erforderlich",
"Ignore User Input" => "Ignoriere Benutzereingaben",
"Default Content" => "Standardinhalt",
"Parameters" => "Parameter",
"Encoding" => "Formatierung",
"To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or" => "Tracker konfigurieren über Menüpunkt 'Tracker verwalten' unter 'Tracker' im Hauptmenü oder",
"Tracker attachment preferences" => "Einstellungen Trackeranhänge",
"Use database to store files" => "Datenbank zum Speichern von Dateien benutzen",
"Use a directory to store files" => "Ein Verzeichnis zur Dateiablage benutzen",
"Tracker attachments" => "Trackeranhänge",
"dls" => "DLs",
"Switch storage" => "Speicherort wechseln",
"No records" => "Keine Einträge",
"Change all to db" => "Alle auf Datenbank umstellen",
"Change all to file" => "Alle auf Datei umstellen",
"Quota (Mb)" => "Speicherkontingent (MB)",
"Use database to store userfiles" => "Benutzer-Dateien in Datenbank speichern",
"Use a directory to store userfiles" => "Benutzer-Daten in Verzeichnis ablegen",
"Kaltura Registration" => "Kaltura Registrierung",
"To get a Kaltura Partner ID:" => "Um eine Kaltura Partner ID zu bekommen:",
"Setup your own instance of Kaltura Community Edition (CE)" => "Richte Deine eigene Instanz der Kaltura Community Edition (CE) ein",
"get an account via Kaltura.com" => "registriere Dich auf Kaltura.com",
"List Media Entries" => "Liste der Medieneinträge",
"List Remix Entries" => "Liste der Remixeinträge",
"Add New Media" => "Füge neue Medien hinzu",
"Kaltura / Tiki config" => "Kaltura / Tiki konfigurieren",
"Kaltura Partner Settings" => "Kaltura Partner Einstellungen",
"Kaltura Dynamic Player" => "Kaltura Dynamischer Player",
"Kaltura Contribution Wizard" => "Kaltura Mitwirkungsassistent",
"Kaltura Remix Editors" => "Kaltura Remix Editoren",
"Ustream Watershed Registration" => "Ustream Watershed Registrierung",
"If you don't have a Watershed account, " => "Wenn Du kein Watershed Konto hast,",
"you can find out more about it here" => "kannst Du hier mehr hierüber erfahren",
"Configuration within Watershed" => "Konfiguration innerhalb Watershed",
"Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock." => "Richte den Webdienst so ein, dass er auf tiki-watershed_service.php auf deiner Website verweist, und schalte Deinen \"Authentication Lock\" ein.",
"Watershed Wiki plugins" => "Watershed Wikiplugins",
"Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat." => "Benutze die Wikiplugins WatershedBroadcaster, WatershedViewer und WatershedChat um Deinen Broadcaster, Betrachter oder Chat einzubetten.",
"Basic tracker settings" => "Grundlegende Tracker Einstellungen",
"Archive settings" => "Archiveinstellungen",
"Archive settings (optional)" => "Optionale Archiv Einstellungen",
"Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used." => "Trage die URL eines Webservices ein, der Daten im JSON oder YAML-Format bereitstellt. Parameter können durch Prozentzeichen eingeschlossen angegeben werden. Z.B. %name%. %service% und %template% sind reservierte Schlüsselwörter und können nicht verwendet werden.",
"Lookup" => "Nachschlagen",
"Output" => "Ausgabe",
"Use the 'Quick Edit' module to easily create or edit wiki pages." => "Benutze das 'Schnellerstellen' Modul um Wikiseiten vereinfacht zu erstellen",
"Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules." => "Wähle <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Verwalten > Module</a> um dieses oder andere Module hinzuzufügen.",
"Page display" => "Seitenanzeige",
"Page version" => "Seitenversion",
"List authors" => "Autoren aufzählen",
"Allow override per page" => "Erlaube pro Seite zu überschreiben",
"Minor edits do not flag new content for translation and do not send watch notifications (unless \"Watch minor edits\" is enabled)." => "Geringfügige Änderungen markieren neue Inhalte nicht für notwendige Übersetzungen und senden auch keine Beobachten-Benachrichtigungen (es sei denn die Funktion \"Beobachte geringfügige Änderungen\" ist markiert).",
"Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled." => "Nur Benutzer die Rechte für tiki_p_minor permission (und Administratoren) haben, sind in der Lage geringfügige Änderungen zu speichern, wenn die Funktion aktiviert wurde.",
"Manage attachments" => "Anhänge verwalten",
"Tag for current wiki" => "Tag für die aktuelle Wiki",
"Restore wiki to tag" => "Tiki zu einem Tag wiederherstellen",
"Remove a tag" => "Tag entfernen",
"Generate dump" => "Datenbankabzug erstellen",
"Download last dump" => "Letzten Datenbankabzug herunterladen",
"Remove unused pictures" => "Entferne unbenutzte Bilder",
"Export Wiki Pages" => "Exportiere Wiki-Seiten",
"Staging &amp; Approval" => "Entwurf & Bestätigen",
"Page Listings" => "Seiten auflisten",
"Configuration" => "Konfiguration",
"Select which items to display when listing pages" => "Wähle anzuzeigende Punkte aus, die in Auflistungen erscheinen sollen",
"Wiki 3D Browser Configuration" => "Wiki 3D Browser Konfiguration",
"Tools" => "Werkzeuge",
"Mass search and replace" => "Massensuchen und Ersetzen",
"Wiki attachments" => "Wiki-Anhänge",
"WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG steht für What You See Is What You Get (Was Du siehst, ist was Du bekommst) und wird in Tiki vom <a href=\"http://ckeditor.com/\">CKEditor</a> ermöglicht",
"Page links" => "Seitenlinks",
"Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature." => "Beachte, dass es bei Benutzung der Funktion\"suchmaschienenfreundliche URL\" dazu kommen kann, dass Links, die mit WYSIWYG erstellt wurden, bei einer Umbenennung der Seiten nicht aktualisiert werden. Es ist geplant, dies in Zukunft durch die Funktion \"Benutze den Wikisyntax in WYSIWYG\" sicherzustellen.",
"Wysiwyg Editor Features" => "Wysiwyg Editor Funktionen",
"Related features" => "Verknüpfte Funktionen",
"An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature." => "Mit der Funktion <a class=\"rbox-link\" href=\"tiki-admin_links.php\">Linktips</a> lassen sich Inhalte von fremden Seiten über IFRAME-Links leichter integrieren.",
"Edit Repository:" => "Repository bearbeiten:",
"Create New Repository" => "Neues Repository erstellen",
"List Repositories" => "Repositories auflisten",
"New Repository" => "Neues Repository",
"View Repository" => "Repository anschauen",
"Start page" => "Startseite",
"CSS File" => "CSS-Datei",
"Cacheable" => "cachebar",
"Clear cache" => "Cache leeren",
"Cache expiration" => "Cache Verfallszeit",
"Available Repositories" => "Vorhandene Repositories",
"Edit rules" => "Regeln bearbeiten",
"Edit Rules for Repository:" => "Regeln ändern für Repository:",
"Configure Repositories" => "Repositories konfigurieren",
"Configure this Repository" => "Dieses Repository konfigurieren",
"View this Repository" => "Repository ansehen",
"New Rule" => "Neue Regeln",
"Copy Rules" => "Regeln kopieren",
"Copy" => "Kopieren",
"Rule order" => "Reihenfolge der Regeln",
"Text to search for" => "Zu suchender Text",
"Text to replace" => "Zu ersetzender Text",
"Case sensitive" => "Groß-/Kleinschreibung beachten",
"Preview options" => "Vorschau-Einstellungen",
"Apply all rules" => "Alle Regeln anwenden",
"Code preview" => "Code-Vorschau",
"Generate HTML preview" => "HTML-Vorschau erstellen",
"HTML preview" => "HTML-Vorschau",
"Preview Results" => "Vorschau der Ergebnisse",
"Rules List" => "Regelliste",
"Configure/Options" => "konfigurieren/Optionen",
"No pages found" => "Keine Seiten gefunden",
"Admin layout" => "Layout verwalten",
"Theme control" => "Theme-Konfiguration",
"layout options" => "Layout Optionen",
"Right column" => "Rechte Spalte",
"Top bar" => "Oberer Balken",
"To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>." => "Um diese Links benutzen zu können, musst Du das <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Modul</a> Linktips zuweisen.",
"Generate positions by hits" => "Positionen nach Zugriffen vergeben",
"List of featured links" => "Liste vorhandener Linktips",
"Add Featured Link" => "Linktip hinzufügen",
"Edit this Featured Link:" => "Diesen Linktip bearbeiten:",
"Create new Featured Link" => "Neuen Linktip anlegen",
"disables the link" => "deaktiviert den Link",
"Link type" => "Linktyp",
"replace current page" => "Aktuelle Seite ersetzen",
"framed" => "umrahmt",
"open new window" => "Neues Fenster öffnen",
"Mail-in accounts" => "Mail-in-Konten",
"Add new Mail-in account" => "Neues Mail-in-Konto erstellen",
"Edit Mail-in account" => "Mail-in Konto bearbeiten",
"Account name" => "Kontoname",
"POP server" => "POP-Server",
"SMTP server" => "SMTP-Server",
"SMTP requires authentication" => "SMTP benötigt Authentifizierung",
"Article Topic" => "Artikel-Thema",
"Admin Topics" => "Themen verwalten",
"Article Type" => "Artikel-Typ",
"Admin Types" => "Typen verwalten",
"Active" => "Aktiv",
"Allow anonymous access" => "Anonymen Zugriff erlauben",
"Allow attachments" => "Anhänge erlauben",
"Check Mail-in accounts" => "Mail-in-Konten prüfen",
"Check automatically" => "Automatisch überprüfen",
"Frequency" => "Frequenz",
"List menus" => "Menüs auflisten",
"Edit this menu" => "Dieses Menü bearbeiten",
"Edit menu options" => "Menüoptionen bearbeiten",
"Show Quick Urls" => "Quick URLs anzeigen",
"Some useful URLs" => "Einige nützliche URLs",
"Hide Quick Urls" => "Quick URLs verstecken",
"option" => "Option",
"separator" => "Trennlinie",
"Choose" => "Auswählen",
"Home Blog" => "Home-Blog",
"Home Image Gal" => "Home-BilderGal",
"Home Image Gallery" => "Home-Bildergalerie",
"Home File Gal" => "Home-Dateiarchiv",
"Home File Gallery" => "Home-Dateiarchiv",
"User preferences" => "Benutzereinstellungen",
"User prefs" => "Benutzereinstellungen",
"List galleries" => "Galerien auflisten",
"List image galleries" => "Bildergalerien auflisten",
"Upload image" => "Bild hochladen",
"Gallery Rankings" => "Galerie-Bewertungen",
"Browse a gallery" => "Galerie ansehen",
"Articles home" => "Artikel-Home",
"All articles" => "Alle Artikel",
"Submit" => "Abschicken",
"List Blogs" => "Blogs auflisten",
"Create Blog" => "Blog erstellen",
"View a forum" => "Forum ansehen",
"View a thread" => "Thread ansehen",
"View a FAQ" => "Eine FAQ ansehen",
"Take a quiz" => "Ein Quiz durchführen",
"Quiz stats" => "Quizstatistik",
"Stats for a Quiz" => "Statistik für ein Quiz",
"Preview menu" => "Vorschau des Menüs",
"Menu options" => "Menüoptionen",
"Options" => "Optionen",
"Create/Edit Menu" => "Menü erstellen/bearbeiten",
"Edit this Menu:" => "Dieses Menü bearbeiten:",
"Create new Menu" => "Neues Menü erstellen",
"dynamic collapsed" => "Dynamisch eingeklappt",
"dynamic extended" => "Dynamisch ausgeklappt",
"fixed" => "fest",
"Folder Icon" => "Ordnersymbol",
"Path and filename of closed folder icon" => "Pfad und Dateiname für das Symbol für den geschlossenen Ordner",
"To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder." => "Um benutzerdefinierte Ordnersymbole im Menu zu benutzen, bitte den Pfad zum Symbol für den <strong>geschlossenen</strong> Ordner angeben.",
"In the same directory, include an icon for the opened folder." => "Im selben Verzeichnis ist ein Symbol für den geöffneten Ordner zu hinterlegen.",
"The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>." => "Der Name des Symbols \"geöffneter Ordner\" muss mit dem Namen des Symbols für \"geschlossenen Ordner\" identisch sein. Ersterer (geöffneter Ordner) muss das Präfix <strong>o</strong> haben.",
"For example, the default icon is: pics/icons/folder.png" => "Z.B. ist das Standardsymbol: pics/icons/folder.png",
"The name of the \"open folder\" icon is: pics/icons/ofolder.png" => "Der Name/Pfad des Symbols für den \"geöffneten Ordner\" lautet: pics/icons/ofolder.png",
"To use a menu in a tiki format:" => "Um ein Menü im Tiki-Format zu nutzen:",
"To use menu in a css/suckerfish format:" => "Um das Menü im CSS/suckerfish Format zu nutzen:",
"To customize the menu's CSS id (#):" => "Um die CSS-ID des Menü anzupassen (#):",
"View template" => "Vorlage betrachten",
"Clear Cache" => "Cache leeren",
"The following required parameters are missing:" => "Es fehlenden die nachfolgend genannten notwendigen Parameter:",
"Assign/Edit modules" => "Module zuweisen/ändern",
"Assigned Modules" => "Zugewiesene Module",
"Left Modules" => "Module links",
"Move to Right Column" => "In die rechte Spalte verschieben",
"Right Modules" => "Module rechts",
"Move to Left Column" => "In die linke Spalte verschieben",
"Assign new module" => "Neues Modul hinzufügen",
"Edit this assigned module:" => "Dieses zugewiesene Modul bearbeiten:",
"Cache Time" => "Cache-Zeit",
"required" => "erforderlich",
"Visibility" => "Sichtbarkeit",
"Displayed now for all eligible users even with personal assigned modules" => "Sichtbar für alle Benutzer, auch die mit persönlicher Modul-Konfiguration",
"Displayed for the eligible users with no personal assigned modules" => "Sichtbar für Benutzer ohne persönliche Modul-Konfiguration",
"Displayed now, can't be unassigned" => "Immer anzeigen, kann nicht wegkonfiguriert werden",
"Not displayed until a user chooses it" => "Nicht anzeigen bis der Benutzer es hinzukonfiguriert",
"Module Options" => "Moduloptionen",
"User Modules" => "Benutzermodule",
"Create new user module" => "Neues Benutzer-Modul erstellen",
"Edit this user module:" => "Dieses Benutzer-Modul bearbeiten:",
"Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site." => "Erstelle hier Dein eigenes Benutzermodul. Vergewissere Dich über die Vorschau, dass alles OK ist, bevor Du das Modul <a href=\"#assign\">zuweist</a>. HTML-Code kann benutzt werden. Aber wenn Du falschen Wikisyntax oder ungültigen Smartycode benutzt, kannst Du Dich aus der Tiki aussperren.",
"Must be wiki parsed" => "Wiki Parser anwenden",
"Objects that can be included" => "Objekte, die eingebunden werden können",
"Random active poll" => "Zufällige aktive Umfrage",
"Random current poll" => "Zufällige aktuelle Umfrage",
"Use Poll" => "Abstimmung benutzen",
"Random image from:" => "Zufälliges Bild aus:",
"Use Gallery" => "Galerie benutzen",
"Use Dynamic Content" => "Dynamischen Inhaltsblock benutzen",
"Use RSS Module" => "RSS-Modul benutzen",
"Default Tiki menus:" => "Standardtikimenüs:",
"Use Menu" => "Menü benutzen",
"CSS menus:" => "CSS-Menüs:",
"Use phplayermenu" => "PHPLayerMenü benutzen",
"Use Banner Zone" => "Bannerzone benutzen",
"Structures:" => "Strukturen:",
"To use a default Tiki menu:" => "Um ein standard Tikimenü zu benutzen:",
"To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes:" => "Um ein <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) Menü</a> zu benutzen, verwende einen der folgenden Syntaxe:",
"Data" => "Daten",
"Admin newsletter subscriptions" => "Rundbrief-Abonnenten verwalten",
"List Newsletters" => "Rundbriefe auflisten",
"Admin Newsletters" => "Rundbriefe verwalten",
"Send Newsletters" => "Rundbriefe versenden",
"Subscriptions" => "Registrierungen",
"Valid" => "Gültig",
"Subscribed" => "abonniert",
"Add subscribers" => "Abonnenten hinzufügen",
"You can add several email addresses by separating them with commas." => "Es können durch Komma getrennt mehrere Emailaddressen angegeben werden.",
"Add email:" => "Email hinzufügen:",
"Add user:" => "Benutzer hinzufügen:",
"Users from group:" => "Benutzer einer Gruppe:",
"Group subscription also subscribes included groups" => "Gruppenabonnement abonniert ebenso enthaltene Gruppen",
"Don't send confirmation mail" => "Sende keine Bestätigungsmail",
"The user email will be refreshed at each newsletter sending" => "Die Benutzer Email wird bei jedem gesendeten Rundbrief aktualisiert",
"Import emails from file" => "Importiere Emails aus einer Datei",
"txt file, one e-mail per line" => "txt Datei, eine Email je Zeile",
"Don't send confirmation mails" => "Sende keine Bestätigungsmails",
"Import emails from wiki page" => "Importiere Emails von einer Wiki Seite",
"Wiki page, one e-mail per line" => "Wiki Seite, eine Email je Zeile",
"Subscribe group" => "Abonniere Gruppe",
"Use subscribers of another newsletter" => "Benutze Abonnenten eines anderen Rundbriefs",
"Use emails from wiki page" => "Benutze Email von einer Wiki Seite",
"Emails on a wiki page which will be added at each newsletter sending, one e-mail per line" => "Emails auf einer Wiki Seite die zu jeder Rundbriefsendung beigefügt wird, Eine Email je Zeile",
"Don't subscribe emails" => "abonniere nicht Emails",
"Export Subscriber Emails" => "Abonnenten Emails exportieren",
"Admin newsletters" => "Rundbriefe verwalten",
"Create Newsletter" => "Rundbrief hinzufügen",
"Editions" => "Ausgaben",
"Drafts" => "Entwürfe",
"Last Sent" => "Zuletzt gesendet",
"Create/Edit Newsletters" => "Rundbrief hinzufügen/bearbeiten",
"There are individual permissions set for this newsletter" => "Es existieren individuelle Berechtigungen für diesen Rundbrief",
"Users can subscribe/unsubscribe to this list" => "Benutzer können sich für diese Liste an-/abmelden",
"Users can subscribe any email address" => "Benutzer können beliebige Emailadressen eintragen",
"Add unsubscribe instructions to each newsletter" => "Hinweise zur Abmeldung von der Liste an jeden Rundbrief anhängen",
"Validate email addresses" => "Emailadressen überprüfen",
"Allow customized text message to be sent with the html version" => "Angepaßte Textversion mit der HTML-Version verschicken",
"Allow clipping of articles into newsletter" => "Erlaube Artikelausschnitte in Newslettern",
"Automatically clip articles into newsletter" => "Automatisch Artikelausschnitte in Newsletter einfügen",
"Clip articles published in the past number of days" => "Artikelausschnitte der letzten Zahl von Tagen einfügen",
"Article types to clip" => "Artikeltypen aus den Ausschnitte eingefügt werden",
"Mail notifications" => "Email-Benachrichtigungen",
"Add notification" => "Benachrichtigung hinzufügen",
"Preload Admin Account" => "Emaildaten des Administrators eintragen",
"Event" => "Ereignis",
"User / Group" => "Benutzer/Gruppe",
"List polls" => "Abstimmungen auflisten",
"Edit this poll" => "Diese Abstimmung bearbeiten",
"Preview poll" => "Vorschau der Abstimmung",
"Poll options" => "Abstimmungs-Optionen",
"Votes" => "Stimmen",
"Admin Polls" => "Abstimmungen verwalten",
"Set last poll as current" => "Letzte Abstimmung als aktuelle Abstimmung setzen",
"Close all polls but last" => "Alle bis auf die letzte Abstimmung schließen",
"Activate all polls" => "Alle Abstimmungen aktivieren",
"Create poll" => "Erstelle Abstimmung",
"active" => "aktiv",
"current" => "aktuell",
"object" => "Objekt",
"Toggle Quick Options" => "Schnell-Optionen ein-/ausblenden",
"Add Option" => "Füge Option hinzu",
"Leave box empty for deleting an option." => "Lasse die Box leer, um eine Option zu löschen",
"PublishDate" => "Veröffentlichungsdatum",
"Votes older than these days are no more considered" => "Stimmen, die älter als soviele Tage sind, werden nicht mehr berücksichtigt",
"0 for no limit" => "0 für unbegrenzt",
"Objects" => "Objekte",
"Results" => "Ergebnisse",
"Add poll to pages" => "Füge Abstimmung zu Seite hinzu",
"This menu shows only Polls with 'status': \"template\"" => "Dieses Menü zeigt nur Abstimmungen mit 'Status': \"Template\"",
"Wiki pages" => "Wiki-Seiten",
"Lock the pages" => "Sperre die Seiten",
"Admin External Feeds" => "Externe Feeds verwalten",
"This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "Hier können externe Feeds konfiguriert werden, damit diese von Tiki eingelesen werden können. Um Feeds aus Inhalten von Tiki zu generieren, benutze die Einstellung \"Feed\" auf der Adminseite, oder",
"Content for the feed" => "Inhalt für den Feed",
"Article Generator" => "Artikelgenerator",
"The article generator will create a new article for every item read in the RSS feed." => "Der Artikelgenerator erzeugt pro Eintrag im RSS-Feed einen eigenen neuen Artikel",
"Publish in the future" => "In der Zukunft veröffentlichen",
"-1 to use original publishing date from the feed" => "-1 um die Orginalveröffentlichungszeit des Feed zu benutzen",
"Configure" => "Konfigurieren",
"Create new external feed" => "Erzeuge einen neuen externen Feed",
"Refresh rate:" => "Aktualisierungsintervall:",
"show feed title:" => "Feed-Titel anzeigen:",
"show publish date:" => "Veröffentlichungsdatum anzeigen:",
"Show Title?" => "Titel anzeigen?",
"Show Date?" => "Datum anzeigen?",
"View feed" => "Feed ansehen",
"Security Admin" => "Sicherheit",
"To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>." => "Alle <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">Sicherheitsbelange hier berichten</a>.",
"PHP settings" => "PHP Einstellungen",
"PHP variable" => "PHP Variable",
"Risk Factor" => "Risikofaktor",
"Explanation" => "Erklärung",
"PHP functions" => "PHP Funktionen",
"Function" => "Funktion",
"To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini" => "Um eine Funktiion zu deaktivieren, füge ein \"disable_functions=exec,passthru\" beispielsweise in Deiner php.ini ein",
"Tiki settings" => "Tikieinstellungen",
"Tiki variable" => "Tiki Variable",
"About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors." => "Über Wikiplugins und Sicherheit: Stelle sicher, dass die Berechtigung \"tiki_p_plugin_approve\" nur vertrauenswürdigen Editoren gegeben wird.",
"You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)." => "Du kannst riskante Plugins unter (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>) deaktivieren.",
"Security checks" => "Sicherheitsüberprüfungen",
"Check all tiki files" => "Alle Tiki-Dateien überprüfen",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Achtung, dies kann viel Zeit in Anspruch nehmen. Der Parameter max_execution_time setting in der php.ini sollte entsprechend hoch sein, damit das Script nicht abbricht.",
"File checks" => "Datei-Checks",
"Check file permissions" => "Prüfe Dateiberechtigungen",
"This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments." => "Diese Überprüfung versucht Dateien mit problemtischen Berechtigungen zu finden. Manche Dateiberechtigungen, die als problematisch angezeigt werden, sind es aber möglicherweise nicht oder sie sind sogar für machen Funktionen unvermeidlich.",
"See end of table for detailed explanations." => "Siehe das Ende der Tabelle für detaillierte Informationen.",
"type" => "Typ",
"user" => "Benutzer",
"group" => "Gruppe",
"sticky" => "festgeheftet",
"Admin Shoutbox Words" => "Verwaltung Shoutboxwörter",
"Add Banned Word" => "Füge verbotenes Wort hinzu",
"Are you sure you want to delete this word?" => "Soll das Wort wirklich gelöscht werden?",
"The structure" => "Die Struktur",
"has just been created." => "wurde soeben erstellt..",
"You will remove structure" => "Du entfernst die Struktur",
"Destroy the structure leaving the wiki pages" => "Nur Struktur (ohne Seiten) entfernen",
"Destroy the structure and remove the pages" => "Struktur und Seiten entfernen",
"View structure" => "Struktur ansehen",
"Export Pages" => "Seiten exportieren",
"Dump Tree" => "Baum ausgeben",
"Perform action with checked" => "Aktion auf markierte Objekte anwenden",
"Delete with the pages" => "Mit den Seiten löschen",
"Create New structure" => "Neue Struktur erstellen",
"Tree" => "Baum",
"Use single spaces to indent structure levels" => "Strukturelevel durch Einrücken (einzelne Leerzeichen) definieren",
"Create New Structure" => "Neue Struktur anlegen",
"Add a New Question" => "Füge eine neue Frage hinzu",
"List surveys" => "Umfragen auflisten",
"Survey Stats" => "Umfragen-Statistik",
"Edit this Survey" => "Diese Umfrage bearbeiten",
"Admin Surveys" => "Umfragen verwalten",
"Add a New Question to this survey" => "Eine neue Frage zur Umfrage hinzufügen",
"Question" => "Frage",
"One choice" => "Eine Auswahl",
"Multiple choices" => "Multiple Auswahlen",
"Short text" => "Kurzbeschreibung",
"Rate (1..5)" => "Bewerte (1..5)",
"Rate (1..10)" => "Bewerte (1..10)",
"For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "Bei Fragen mit mehreren möglichen Antworten diese im folgenden Feld kommagetrennt eingeben",
"Options (if apply)" => "Optionen (falls nötig)",
"Questions" => "Fragen",
"Admin surveys" => "Umfragen verwalten",
"List Surveys" => "Umfragen auflisten",
"Create Survey" => "Umfrage erstellen",
"Create/Edit Surveys" => "Umfragen hinzufügen/bearbeiten",
"Edit this Survey:" => "Diese Umfrage bearbeiten:",
"Create New Survey" => "Neue Unfrage erstellen",
"There are individual permissions set for this survey" => "Für diese Umfrage sind individuelle Berechtigungen gesetzt",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "Wenn sich Dein Tiki seltsam verhält, versuche zuerst den Cache zu leeren. Wichtig, auch nach einer Aktualisierung den Cache leeren (per FTP / SSH, wenn nötig).",
"Exterminator of cached content" => "löschen der zwischengespeicherten Inhalte",
"Empty" => "Leeren",
"Directories to save" => "Zu sichernde Verzeichnisse",
"Full Path to the Zip File:" => "Vollständiger Pfad für die zip-Datei:",
"Generate a zip of those directories" => "Erstellen einer komprimierten (zip) Datei dieser Verzeichnisse",
"View mode" => "Ansichtsmodus",
"Wiki and WYSIWYG" => "Wiki und WYSIWYG",
"Wiki only" => "Nur Wiki",
"WYSIWYG only" => "Nur WYSIWYG",
"Load" => "Laden",
"Auto Reloading" => "Auto Neuladen ",
"Row" => "Reihe",
"Formatting Tools:" => "Formatierungstools:",
"Plugin Tools:" => "Plugintools:",
"Custom Tools:" => "Benutzerdefinierte Tools:",
"To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save." => "Um die Toolbars in den verschiedenen Bereichen, in denen Text bearbeitet werden kann, zu verändern, wähle zuerst den Bereich und ggf. auch den Bereich Kommentare. Einzelne Symbole können von den Listen in die Toolbars gezogen werden (drag & drop).<br /> Um ein Incon von den Toolbars wieder zu entfernen, muss man es nur in dei Liste zurückziehen.<br /> Icons mit <strong>fetter</strong> Bezeichnung sind für Wiki Textbereiche. <em>Kursive</em> sind für den WYSIWYG Editor und diejenigen, die sowohl <strong><em>fett und kursiv</em></strong> sind, sind für beide Bereiche.<br /> Zum Abspeichern der Toolbars wähle den Ansichtsmodus (oben), klicke auf Kommentare (wenn gewünscht) und klicke auf Speichern.",
"If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools:" => "Wenn Du Probleme mit dieser Seite hast, nachdem Du von Tiki 4 ein Upgrade durchgeführt hast, klicke auf diesen Link um alle veränderten Tools zurückzusetzen:",
"Delete all custom tools" => "Lösche alle benutzerdefinierten Tools",
"Warning: There is no undo!" => "Wanung: es gibt kein Rückgängigmachen!",
"Create a new topic" => "Neues Thema erstellen",
"Topic Name" => "Themenname",
"Upload Image" => "Bild hochladen",
"List of topics" => "Themenliste",
"topic image" => "Themenlogo",
"Inactive - Click to Activate" => "Inaktiv - hier klicken zum Aktivieren",
"Deactivate" => "Deaktivieren",
"Active - Click to Deactivate" => "Aktiv - hier klicken zum Deaktivieren",
"Remove with articles" => "Typ und zugehörige Artikel löschen",
"List Trackers" => "Tracker auflisten",
"Admin Trackers" => "Tracker verwalten",
"Edit This Tracker" => "Diesen Tracker bearbeiten",
"View This Tracker's Items" => "Einträge dieses Trackers ansehen",
"Tracker fields" => "Tracker-Felder",
"Pos" => "Position",
"Is column visible when listing tracker items?" => "Ist Spalte beim Auflisten von Tracker-Einträgen sichtbar?",
"Column links to edit/view item?" => "Links in Spalten zum Bearbeiten/Betrachten von Einträgen?",
"Main" => "Aktivierung der Hauptkomponenten",
"Hidden" => "versteckt",
"Mandatory" => "Pflicht",
"Searchable" => "Durchsuchbar",
"New tracker field" => "Neues Trackerfeld",
"Edit tracker field" => "Tracker-Felder bearbeiten",
"Field is mandatory?" => "Pflichtfeld?",
"Column is searchable?" => "Spalte durchsuchbar?",
"not hidden" => "nicht verstecken",
"visible to admin only" => "fur für Administratoren sichtbar",
"Import/Export Trackers Fields" => "Tracker-Felder importieren/exportieren",
"Edit This Tracker's Fields" => "Felder des Trackers bearbeiten",
"Found" => "Fand",
"trackers" => "Tracker",
"Items" => "Einträge",
"with" => "weite",
"Create Tracker" => "Tracker anlegen",
"Create/Edit Tracker" => "Tracker hinzufügen/bearbeiten",
"Auto create corresponding categories" => "Automatisch passende Kategorien anlegen",
"Show status" => "Zeige Status",
"Default status displayed in list mode" => "Status, die in der Listenanzeige ausgegeben werden sollen",
"Show status to tracker admin only" => "Status nur dem Tracker-Admin zeigen",
"Send copies of all activity in this tracker to this e-mail address" => "Kopien aller Aktivitäten dieses Trackers an diese Emailadresse schicken",
"Use simplified e-mail format" => "Vereinfachtes Emailformat benutzen",
"New items are created with status" => "Status neuer Einträge",
"Authoritative status for modified items" => "Authoritiver Status des Trackers wird beim Ändern des Trackers gesetzt auf",
"No change" => "keine Änderung",
"Item creator can modify his items?" => "Ersteller kann Einträge ändern",
"The tracker needs a user field with the option 1" => "Der Tracker muß ein Benutzerfeld mit der Option 1 besitzen",
"User can take ownership of item created by anonymous" => "Benutzer kann Objekt-Besitz von 'Anonymous' übernehmen",
"Only one item per user or IP" => "Nur ein Eintrag pro Benutzer oder IP-Adresse",
"The tracker needs a user or IP field with the option 1" => "Der Tracker muß ein Benutzer- oder IP-Feldmit der Option 1 besitzen",
"Member of the creator group can modify items?" => "Mitglied der Erstellergruppe kann Einträge ändern",
"The tracker needs a group field with the option 1" => "Der Tracker muß ein Gruppenfeld mit der Option 1 besitzen",
"Show creation date when listing tracker items?" => "Erstellungsdatum beim Auflisten von Tracker-Einträgen anzeigen",
"Show creation date when viewing tracker item?" => "Erstellungsdatum beim Betrachten von Einträgen anzeigen",
"Show lastModif date when listing tracker items?" => "Änderungsdatum beim Auflisten von Tracker-Einträgen anzeigen",
"Show lastModif date when viewing tracker item?" => "Änderungsdatum beim Betrachten von Einträgen anzeigen",
"What field is used for default sort?" => "Standardfeld für Sortierung",
"What is default sort order in list?" => "Standardsortierung",
"Tracker items allow ratings?" => "Bewertung von Tracker-Einträgen erlauben",
"with values" => "mit den Werten",
"and display rating results in listing?" => "und Bewertungsergebnisse in Liste anzeigen",
"Tracker items allow comments?" => "Kommentare zu Tracker-Einträgen zulassen",
"and display comments in listing?" => "und Kommentare in Liste anzeigen",
"Tracker items allow attachments?" => "Anlagen zu Tracker-Einträgen zulassen",
"and display attachments in listing?" => "und Anhänge in Liste anzeigen",
"Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)" => "Darstellungsoptionen für Anhänge (Nummern zur Sortierung eintragen, 0 versteckt Felder, bei negativen Einträgen erscheinen Popups)",
"Filesize" => "Dateigröße",
"Filetype" => "Dateityp",
"LongDesc" => "Beschreibung",
"Items can be created only during a certain time" => "Einträge sind nur in einem bestimmten Zeitraum möglich",
"Do not show empty fields in item view?" => "Leere Felder beim Betrachten von Einträgen ausblenden",
"Show these fields (ID comma separated) in a popup on item link when listing tracker items?" => "Diese Felder (kommagetrennte IDs) als Popup auf Eintragslinks in der Listenansicht anzeigen",
"Group of users alerted when tracker is modified" => "Gruppe von Benutzern bei Tracker-Änderung benachrichtigen",
"Wiki page to display an item" => "Wiki Seite zum Anzeigen eines Objekts",
"wiki:pageName for a wiki page or tpl:tplName for a template" => "Wiki: Seitename für eine Wikiseite tpl: tpl-Name für eine Vorlage",
"Notification" => "Benachrichtigung",
"Status changes" => "Statusänderungen",
"After creation" => "nach Erstellung",
"After last modification" => "nach letzter Änderung",
"Warn creator of an upcoming status change" => "Warne Ersteller vor einem bevorstehenden Statuswechsel ",
"before" => "vorher",
"Mail subject text" => "Emailbetreff ",
"Mail body ressource" => "Emailtext ",
"wiki:pageName for a wiki page or tplName.tpl for a template" => "Wiki: Seitename für eine Wikiseite tpl: tpl-Name für eine Vorlage",
"Import/Export" => "Importieren/Exportieren",
"Import/export trackers" => "Tracker im-/exportieren",
"Charset encoding" => "Zeichensatz",
"Duplicate Tracker" => "Tracker duplizieren",
"Members" => "Mitglieder",
"Admin groups" => "Gruppen verwalten",
"Admin users" => "Benutzer verwalten",
"Add new group" => "Neue Gruppe hinzufügen",
"Manage permissions" => "Rechte verwalten",
"List of existing groups" => "Liste vorhandener Gruppen",
"Inherits Permissions from" => "Erbt Rechte von",
"Group Homepage" => "Gruppenhomepage",
"Edit group" => "Bearbeite Gruppe",
"Add a New Group" => "Eine neue Gruppe hinzufügen",
"Inherit permissions directly from following groups." => "Erbt Rechte direkt von den folgenden Gruppen.",
"Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)." => "Außerdem werden Rechte von den folgenden Gruppen vererbt (indirekte Rechteerbschaft durch die oben gewählten Gruppen).",
"Use wiki page name or full URL" => "Wiki-Seitennamen oder volle URL benutzen",
"Default category assigned to uncategorized objects edited by a user with this default group:" => "Standardmäßig zugewiesene Kategorie für unkategorisierte Objekte, die ein Benutzer dieser Gruppe erstellt hat:",
"User can assign to the group himself" => "Benutzer kann sich selbst zu einer Gruppe hinzufügen",
"Users are automatically unassigned from the group after" => "Benutzer werden automatisch von dieser Gruppen entfernt. Nach",
"0 or empty for never" => "0 oder freilassen für niemals",
"Users are automatically assigned at registration in the group if their emails match the pattern" => "Benutzer werden automatisch bei Registrierung zu dieser Gruppe hinzugefügt, wenn ihre Email dem folgenden Muster entspricht",
"Example: " => "Beispiel: ",
"Assign group <em>management</em> permissions:" => "Weise der Gruppe <em>Verwaltungsrechtemanagement</em> zu:",
"Edit Item" => "Punkt bearbeiten",
"Expire" => "Ablauf",
"users in group" => "Benutzer in der Gruppe",
"Add to group" => "Zur Gruppe hinzufügen",
"Download CSV export" => "Download CSV-Export",
"Charset encoding:" => "Zeichensatzkodierung:",
"Assign users to group:" => "Benutzer einer Gruppe zuordnen:",
"Each user in the file must already exist." => "Jeder Benutzer in der Datei muss bereits existieren.",
"To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "Um einen Benutzer anzulegen und/oder ihn einer Gruppe zuzuweisen gehe zu <a href=\"tiki-adminusers.php\">Verwalten->Benutzer</a>",
"CSV File" => "CSV Datei",
"Add a New User" => "Neuen Benutzer hinzufügen",
"Reason" => "Grund",
"More Criteria" => "Erweiterte Suchoptionen",
"Group (direct)" => "Gruppe (direkt)",
"Edit Account Settings:" => "Kontodaten bearbeiten",
"to groups" => "zu Gruppen",
"default" => "standard",
"Manage Group Assignments" => "Gruppenzuordnungen bearbeiten",
"Set Default Groups" => "Standardgruppen setzen",
"Assign selected to" => "Markierte hinzufügen zu",
"Remove selected from" => "Markierte löschen aus",
"the following groups:" => "den folgenden Gruppen:",
"bcc" => "BCC",
"Edit user" => "Benutzerdaten bearbeiten",
"Assign user to Groups" => "Weise Benutzer einer Gruppe zu",
"Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)" => "Warnung: die Änderung des Benutzernamens kann dazu führen, dass der Benutzer sein Passwort ändern muss (für Benutzer die sich unter einer alten tikiwiki&lt;=1.8 registriert haben)",
"Repeat Password:" => "Passwort wiederholen:",
"User must change password at next login" => "Benutzer muss sein Passwort beim nächsten Login ädnern",
"Send an email to the user in order to allow him to validate his account." => "Sende dem Benutzer eine Email, damit sein Konto validiert werden kann.",
"You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "Die <a href=\"tiki-admin.php?page=general\">Sendeadresse</a> muß gesetzt sein",
"Registered:" => "Registriert:",
"Last Login:" => "Letzter Login:",
"Overwrite but keep the previous login if the login exists in another case" => "Überschreibe, aber behalte den vorhergehenden Login wenn der Login in anderer Schreibweise bereits existiert",
"Don't overwrite" => "Nicht überschreiben",
"Overwrite groups:" => "Gruppen überschreiben:",
"Create groups:" => "Erzeuge Gruppe:",
"User must change password at first login:" => "Benutzer muss sein Passwort nach dem ersten Login ändern:",
"You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "Du kannst Benutzer einer Gruppe unter <a href=\"tiki-admingroups.php\">Verwalten->Gruppe</a> exportieren",
"Source" => "Quelle",
"Admin Article Types" => "Artikeltypen verwalten",
"Show Help" => "Hilfe anzeigen",
"Article type" => "Artikeltyp",
"Shows up in the drop down list of article types" => "In der Auswahlliste der Typen anzeigen",
"Allow ratings by the author" => "Bewertungen des Autors erlauben",
"Show before publish date" => "Vor Veröffentlichungsdatum anzeigen",
"non-admins can view before the publish date" => "Nicht-Admins sehen den Artikel vor dem Veröffentlichungsdatum",
"Show after expire date" => "Nach Verfallsdatum anzeigen",
"non-admins can view after the expire date" => "Nicht-Admins sehen den Artikel nach dem Ablaufdatum",
"Heading only" => "nur Kopfteil",
"No article body, heading only" => "Nur den Header ohne den Artikelbody anzeigen",
"Allow comments for this type" => "Kommentare für diesen Typ erlauben",
"Comment Can Rate Article" => "Kommentar darf Artikel bewerten",
"Allow comments to include a rating value" => "Kommentare inklusive Bewertung erlauben",
"Show image" => "Zeige Bild",
"Show topic or own image" => "Thema oder eigenes Bild anzeigen",
"Show avatar" => "Zeige Avatar",
"Show author's avatar" => "Avatar des Autors anzeigen",
"Show author" => "Zeige Autor",
"Show author name" => "Namen des Autors anzeigen",
"Show publish date" => "Zeige Veröffentlichungsdatum",
"Show expire date" => "Zeige Verfallsdatum",
"Show reads" => "Zeige Zugriffe",
"Show the number of times the article was read" => "Anzeigen wie oft der Artikel gelesen wurde",
"Show size" => "Zeige Größe",
"Show the size of the article" => "Größe des Artikels anzeigen",
"Show topline" => "Aufmacher anzeigen",
"Show a small title over the title" => "Kleine Introzeile über der Überschrift anzeigen",
"Show subtitle" => "Untertitel anzeigen",
"Show the subtitle" => "Untertitel anzeigen",
"Show source" => "Zeige Quelle",
"Show link to source after article body" => "Zeige Link zur Quelle nach dem Artikelhauptteil",
"Show Image Caption" => "Bildbeschreibung anzeigen",
"Show a legend under the image" => "Legende unter dem Bild anzeigen",
"Show Language" => "Sprache anzeigen",
"Show the language" => "Sprache anzeigen",
"Creator can edit" => "Ersteller kann bearbeiten",
"The person who submits an article of this type can edit it" => "Einreicher dieses Artikeltyps dürfen diese Artikel ändern",
"Actions on this article type" => "Aktionen zu diesem Artikeltyp",
"List of article types" => "Liste der Artikeltypen",
"view articles with this type" => "Betrachte Artikel dieses Typs",
"Review" => "Rezension",
"Classified" => "vertraulich",
"Show lang" => "Sprache anzeigen",
"Custom attribute" => "Angepasste Attribute",
"Create a new type" => "Neuen Typ anlegen",
"Group Information" => "Gruppeninformationen",
"Desc" => "Beschreibung",
"level" => "Stufe",
"inherited from" => "geeerbt von",
"inherited" => "geerbt",
"Advanced feature" => "Funktion für Fortgeschrittene",
"Create level" => "Neue Berechtigungsstufe",
"all permissions in level" => "alle Rechte auf Stufe",
"Directory batch upload" => "Aus Verzeichnis einlesen",
"Browse Gallery" => "Dateiarchiv anzeigen",
"Upload From Disk" => "Hochladen von Disk",
"available images" => "Bilder vorhanden",
"Remove File Extension from Image Name" => "Dateiendung im Namensfeld entfernen",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "z.B. wird von \"digicam0001.jpg\" der Name digicam0001 im Namensfeld benutzt",
"Select a Gallery" => "Ziel-Galerie auswählen",
"Process" => "Prozess",
"Browse File Gallery" => "Dateiarchiv durchsehen",
"Please do not use this feature to upload data into the database." => "Mit dieser Funktion bitte keine Daten in die Datenbank laden.",
"Available Files" => "verfügbare Dateien",
"Select a File Gallery" => "Dateiarchiv auswählen",
"Process files" => "Dateien verarbeiten",
"Edit Post" => "Eintrag bearbeiten",
"New Post" => "Neue Veröffentlichung",
"View post" => "Eintrag ansehen",
"View Blog" => "Blog betrachten",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Hinweis: Dies ist nur eine Vorschau und wurde noch nicht gespeichert!",
"Trash" => "Müll",
"Mark entry as private:" => "Eintrag als privat kennzeichnen:",
"Publish Date" => "Veröffentlichungsdatum",
"Admin Category" => "Kategorien verwalten",
"Browse in" => "Stöbern in",
"Trackers Items" => "Trackereinträge",
"Sheets" => "Tabellen",
"Find:" => "Suche:",
"in the current category - and its subcategories: " => "in der aktuellen Kategorie - und in allen Unterkategorien: ",
"Hide subcategories objects" => "Einträge von Unterkategorien verstecken",
"Show subcategories objects" => "Einträge von Unterkategorien anzeigen",
"Browse related tags" => "Ähnliche Tags durchstöbern",
"With all selected tags" => "Mit allen gewählten Tags",
"With one selected tag" => "Mit einem gewählten Tag",
"With last selected tag" => "Mit dem zuletzt gewählten Tag",
"More Popular Tags" => "Beliebtere Tags",
"Alphabetically" => "Alphabetisch",
"By Size" => "Nach Größe",
"Cloud" => "Wolke",
"List Galleries" => "Dateiarchive auflisten",
"Edit Gallery" => "Galerie bearbeiten",
"Rebuild Thumbnails" => "Thumbnails neu erzeugen",
"Directory Batch" => "Aus Verzeichnis einlesen",
"List Gallery" => "Galerie als Liste zeigen",
"Monitor this Gallery" => "Beobachte diese Galerie",
"Sort Images by" => "Bilder sortieren nach",
"subgallery" => "Unter-Galerie",
"Subgallery" => "Unter-Galerie",
"Original Size" => "Originalgröße",
"rotate right" => "rechts drehen",
"rotate" => "drehen",
"popup" => "Popup",
"Return to Gallery" => "Zurück zur Galerie",
"Edit Image" => "Bild bearbeiten",
"First Image" => "Erstes Bild",
"Prev Image" => "Vorh. Bild",
"Smaller" => "Kleiner",
"Bigger" => "Größer",
"Popup window" => "Popup-Fenser",
"Next Image" => "Näch. Bild",
"Slideshow Forward" => "Diaschau vorwärts",
"Last Image" => "Neuestes Bild",
"Image Name" => "Bildname",
"Image size" => "Bildgröße",
"Image Scale" => "Bildskalierung",
"Latitude (WGS84/decimal degrees)" => "Breitengrad (WGS84/Grad)",
"Longitude (WGS84/decimal degrees)" => "Längengrad (WGS84/Grad)",
"Move image" => "Bild verschieben",
"Stop Monitoring this Page" => "Diese Seite nicht mehr beobachten",
"Monitor this Page" => "Diese Seite beobachten",
"Edit Calendar" => "Kalender bearbeiten",
"Export Calendars" => "Kalender exportieren",
"Click to export calendars" => "Klicke um Kalender zu exportieren",
"Visible Calendars" => "Sichtbare Kalender",
"Click to select visible calendars" => "Anklicken um sichtbaren Kalender auszuwählen",
"Group Calendars" => "Gruppenkalender",
"Export calendars" => "Kalender exportieren",
"advanced parameters" => "erweiterte Parameter",
"Export as iCal" => "Exportiere als iCal",
"Export as CSV" => "Exportiere als CSV",
"Tentative" => "Unter Vorbehalt",
"Confirmed" => "Zugesagt",
"Cancelled" => "Abgelehnt",
"Change Focus" => "Hierher wechseln",
"View this Day" => "Diesen Tag ansehen",
"Calendar Item" => "Kalendereintrag",
"Edit Calendar Item" => "Kalendereintrag bearbeiten",
"New Calendar Item" => "Neuer Kalender-Eintrag",
"Recurrence" => "Wiederholung",
"This event depends on a recurrence rule" => "Dieses Ereignis hängt von einer Wiederholungsregel ab",
"On a weekly basis" => "wöchentlich",
"Each" => "jeden",
"of the week" => "der Woche",
"On a monthly basis" => "monatlich",
"of the month" => "des Monats",
"On a yearly basis" => "jährlich",
"January" => "Januar",
"February" => "Februar",
"March" => "März",
"May" => "Mai",
"June" => "Juni",
"July" => "Juli",
"October" => "Oktober",
"December" => "Dezember",
"Start period" => "Startperiode",
"End after" => "Endet nach",
"occurrences" => "Ereignis(sen)",
"End before" => "Endet vor",
"times" => "mal",
"End" => "Ende",
"Organized by" => "Organisiert von",
"Roles" => "Rollen",
"Calendar import" => "Kalender importieren",
"Calendar has been updated" => "Kalender wurde aktualisiert",
"import" => "Import",
"%m/%d" => "%d.%m.",
"Advanced parameters for iCal export" => "Erweiterte Parameter für iCal-Export",
"Calendars to be exported" => "Zu exportierende Kalender",
"Export calendars iCal" => "Exportiere Kalender als iCal",
"Export calendars CSV" => "Esportiere Kalender als CSV",
"Change password enforced" => "Passwortwechsel erzwungen",
"Change your password" => "Ändere Dein Passwort",
"Please choose the language for this page:" => "Wähle bitte eine Sprache für diese Seite:",
"Choose language" => "Wähle Sprache",
"Send a message to us" => "Schick uns eine Nachricht",
"Contact us by email" => "Kontaktiere uns per Email",
"Click here to send us an email" => "Hier klicken um uns eine Email zu schicken",
"Contacts" => "Kontakte",
"Group View" => "Gruppenansicht",
"Create/edit contacts" => "Kontakte hinzufügen/bearbeiten",
"First Name" => "Vorname",
"Last Name" => "Nachname",
"Top page" => "Top-Seite",
"Add a new site" => "Füge neuen Link hinzu",
"You cannot add sites until Directory Categories are setup." => "Links können erst hinzugefügt werden, wenn Kategorien dafür eingerichtet wurden.",
"Please contact the Site Administrator" => "Bitte kontaktieren sie den Administrator der Site.",
"Site added" => "Link hinzugefügt",
"The following site was added, but may require validation by the admin before appearing on the lists." => "Der folgende Link wurde hinzugefügt, muss aber ggf. durch einen Admin geprüft werden, bevor er in der Liste erscheint.",
"Add a Site" => "Link hinzufügen",
"Directory Administration" => "Linkverzeichnis verwalten",
"There are" => "Es gibt",
"invalid sites" => "ungültige Links",
"valid sites" => "gültige Links",
"Directory Categories" => "Verzeichniskategorien",
"Users have visited" => "Benutzer besuchten",
"sites from the directory" => "Links aus dem Verzeichnis",
"Users have searched" => "Benutzer suchten",
"times from the directory" => "mal im Linkverzeichnis",
"Sites" => "Links",
"Validate" => "überprüfen",
"Admin directory categories" => "Verzeichniskategorien verwalten",
"Parent directory category" => "Übergeordnete Verzeichniskategorie",
"Add a directory category" => "Verzeichniskategorie hinzufügen",
"Edit this directory category" => "Diese Verzeichniskategorie bearbeiten",
"Add a Directory Category" => "Verzeichniskategorie hinzufügen",
"Children type" => "Kind-Typ",
"Most visited directory sub-categories" => "Am häufigsten besuchte Verzeichnisunterkategorien",
"Directory Category description" => "Verzeichniskategorie Erklärung",
"Random directory sub-categories" => "zufällig gewählte Verzeichnisunterkategorien",
"Maximum number of children to show" => "Maximalzahl der angezeigten Kinder",
"Allow sites in this directory category" => "Sites in dieser Verzeichniskategorie erlauben",
"Show number of sites in this directory category" => "Anzahl der Sites in dieser Verzeichniskategorie zeigen",
"Editor group" => "Editor-Gruppe",
"Directory Subcategories" => "Verzeichnis-Unterkategorien",
"cType" => "Kindtyp",
"allow" => "Sites erlaubt",
"count" => "Anzahl",
"editor" => "Ersteller",
"Admin related directory categories" => "Verwandte Verzeichniskategorien verwalten",
"Add a related directory category" => "Eine verwandte Verzeichniskategorie hinzufügen",
"Directory Category" => "Verzeichniskategorie",
"Mutual" => "gegenseitig",
"Related directory categories" => "Verwandte Verzeichniskategorien",
"Admin sites" => "Links verwalten",
"Is valid" => "Ist gültig",
"New Sites" => "Neue Links",
"Cool Sites" => "Coole Links",
"any" => "irgendeines",
"in entire directory" => "im gesamten Linkverzeichnis",
"Sort by" => "Sortiere nach",
"Hits (desc)" => "Treffer/Zugriffe (absteigend)",
"Hits (asc)" => "Treffer/Zugriffe (aufsteigend)",
"Last updated (desc)" => "Letzes Update (absteigend)",
"Last updated (asc)" => "Letzes Update (aufsteigend)",
"sort" => "sortieren",
"Last updated" => "Zuletzt aktualisiert",
"Total directory categories" => "Verzeichniskategorien gesamt",
"Total links" => "Links gesamt",
"Links to validate" => "Zu überprüfende Links",
"Searches performed" => "Durchgeführte Suchaufträge",
"Total links visited" => "Besuchte Links gesamt",
"Directory ranking" => "Rang im Verzeichnis",
"Validate sites" => "Links überprüfen",
"Translation of this page is incomplete." => "Die Übersetzung der Seite ist unvollständig.",
"Edit article" => "Artikel erstellen/bearbeiten",
"View Articles" => "Beiträge ansehen",
"Topline" => "Introzeile",
"Author Name" => "Autor",
"Own Image" => "Eigenes Bild",
"Article image" => "Artikellogo",
"Use own image" => "Eigenes Bild benutzen",
"Float text around image" => "Text fließt um Bilder herum",
"List mode" => "Listenmodus",
"Image caption" => "Bildbeschreibung",
"Allow full HTML" => "Erlaube volles HTML",
"for this edit session" => "für diese Sitzung",
"Emails to be notified (separated with commas)" => "Emailbenachrichtigung an (mehrere per Komma getrennt)",
"Published" => "Veröffentlicht",
"Edit or create banners" => "Banner hinzufügen/bearbeiten",
"List banners" => "Banner anzeigen",
"URL to link the banner" => "URL, die mit dem Banner verknüpft wird",
"Use dates" => "Datum benutzen",
"Select ONE method for the banner" => "EINE Methode für das Banner auswählen",
"Use HTML" => "HTML benutzen",
"Use image" => "Bild benutzen",
"Image:" => "Bild:",
"Current Image" => "Aktuelles Bild",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "Bild benutzen, das durch die URL erzeugt wird (das Bild wird bei jedem Aufruf der URL angefordert)",
"Use text" => "Text benutzen",
"Save the Banner" => "Das Banner speichern",
"A category is mandatory" => "Eine Kategorie ist obligatorisch",
"There are individual permissions set for this blog" => "Es gibt individuelle Berechtigungen für dieses Blog",
"Allow other users to post in this blog" => "Erlaube anderen Benutzern in diesen Blog zu schreiben",
"If others post to blog, Author should always be Owner" => "Wenn Andere in den Blog schreiben, soll der Autor immer Besitzer sein",
"Allow search" => "Suchen erlauben",
"Allow comments" => "Kommentare erlauben",
"Display Options" => "Anzeigeoptionen",
"Number of posts to show per page" => "Anzuzeigende Anzahl der Einträge je Seite",
"Display blog title in posts list page" => "Zeige den Blog Titel in der Listenansicht",
"Display blog title in post page" => "Zeige den Blog Titel auf der Eingabeseite",
"Display blog description" => "Zeige die Blogbeschreibung",
"Display breadcrumbs" => "Zeige die Breadcrumbs",
"Display author in blog posts" => "Zeige den Autor im Blogeintrag an",
"Display published date in blog posts" => "Zeige das Publizierungsdatum in den Blogeinträgen an",
"Show user avatar" => "Zeige den Benutzer-Avatar an",
"Show post related content" => "Zeige zum Eintrag \"verbundene\" Inhalte",
"Maximum number of related posts to display" => "Maximal anzuzeigende Anzahl \"verbundener\" Einträge",
"Use post excerpt" => "Benutze Eintrags-Exzerpt",
"Blog heading" => "Blog Kopfbereich",
"Heading preview" => "Überschrift Vorschau",
"Blog post heading" => "Blogeintrag Kopfbereich",
"Edit Style Sheet" => "Stylesheet bearbeiten",
"Style Sheet" => "Stylesheet",
"choose a stylesheet" => "Stylesheet auswählen",
"Try" => "Ausprobieren",
"For more information, please see" => "Für weitere Informationen siehe auch",
"Wiki Page Editor" => "Wiki Seiteneditor",
"Bold text" => "Fetter Text",
"Italic text" => "Kursiver Text",
"single quotes" => "einzelne Anführungszeichen",
"Underlined text" => "unterstrichener Text",
"Colored text" => "Farbiger Text",
"Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background." => "Zeigt die indizierte HTML Farbe oder den Farbnamen an. Der Farbname kann zwei Farben durch ein Komma getrennt enthalten. In diesem Fall stellt die erste Farbe den vordergrund un die zweite Farbe den Hintergund dar.",
"Deleted text" => "gelöschter Text",
"2 dashes" => "2 Bindestriche",
"Headings" => "Überschriften",
"Show/Hide" => "Ein-/Ausblenden",
"show/hide heading section. + (shown) or - (hidden) by default" => "zeige/verberge Kopfbereich - standartmässig + (angezeigt) oder - (verborgen)",
"Autonumbered Headings" => "Automatisch nummerierte Überschriften",
"Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename." => "Übliche optionale Parameter für maketoc sind: title|maxdepth|levels|nums - und für toc sind es: order|showdesc|shownum|structId|maxdepth|pagename.",
"Horizontal rule" => "Horizontale Linie",
"Text box" => "Textbox",
"Box content" => "Box-Inhalt",
"Centered text" => "Zentrierter Text",
"Inserts an editable variable" => "Fügt eine bearbeitbare Variable ein.",
"External links" => "Externe Links",
"use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)." => "Benutze eckige Klammern für externe Links: [URL], [URL|Link_Beschreibung],[URL|Link_Beschreibung|Relation] or [URL|Link_Beschreibung|Relation|nocache] (Das Letzte verhindert das Cachen der gelinkten Seite durch das lokale Wiki; Relation kann benutzt werden, um relative Attribute für den Link einzufügen - nützlich zum Beispiel für Shadowbox).",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Für ein externes Wiki benutze: ExternalWikiName:PageName oder ((External Wiki Name: Page Name))",
"Square Brackets" => "Eckige Klammern",
"Use [[foo] to show [foo]." => "[[foo] benutzen, damit [foo] ausgegeben wird.",
"Wiki References" => "Wiki-Referenzen",
"JoinCapitalizedWords or use" => "ZusammenGrossKleinSchreibung oder benutze",
"page|description" => "Seite|Beschr.",
"for wiki references" => "für Wiki-Referenzen",
"SomeName" => "EinName",
"prevents referencing" => "verhindert Referenzierung",
"Lists" => "Listen",
"for bullet lists" => "für einfache Listen",
"for numbered lists" => "für numerierte Listen",
"for definiton lists" => "für Definitionslisten",
"Indentation" => "Einrückung",
"Creates an indentation for each plus (useful in list to continue at the same level)" => "erstellt eine Einrückung für jedes Pluszeichen (nützlich in Listen, um in der gleichen Eben fortzusetzen)",
"Tables" => "Tabellen",
"row" => "Reihe",
"Monospace font" => "Nichtproportionale Schrift",
"Code sample" => "Code Beispiel",
"(very useful especially in tables)" => "(sehr nützlich, vor allem in Tabellen)",
"Multi-page pages" => "Mehrseitige Seiten",
"to separate pages" => "und Seiten in mehrere zu trennen",
"Non parsed sections" => "Nicht geparste Bereiche",
"Prevents wiki parsing of the enclosed data." => "Verhindert das parsen von Wikisyntax der eingeschlossenen Daten",
"Preformated sections" => "Vorformatierte Bereiche",
"~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text." => "~pp~ Text ~/pp~ Zeigt vorformatierten Text/Code; es findet keine Wikibearbeitung des Textes mehr statt (so wie np). Auch Abstände sind fixiert (es findet kein Zeilenumbruch statt).  ~pre~ Text ~/pre~ macht das Gleiche wie ~pp Text ~/pp; nur wird der Text Wikibearbeitet.",
"~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar." => "~tc~ Text ~/tc~ erstellt einen Tikikommentar.  Dieser ist nicht sichtbar, wird aber zusammen mit der Datei zu künftigen Nachweisen abgespeichert.  ~hc~ Text ~/hc~ fügt einen HTML-Kommentar ein.  Er wird als Kommentar im HTML-Output eingefügt und kann dann vom Browser über die Quelltextanzeige angezeigt werden.",
"Block Preformatting" => "Block Vorformatierung",
"Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew." => "Fügt ein DIV für die Textschreibrichtung recht-nach-links bzw. links-nach-rechts-ein. Außerdem eine Kennzeichnung für die Sprache als Arabisch und Herbräisch.",
"Special characters" => "Sonderzeichen",
"hard space" => "untrennbares Leerzeichen",
"Plugin Help" => "Pluginhilfe",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;" => "Beachte, dass Pluginargumente in Anführungszeichen eingeschlossen werden können (\"); dies erlaubt ihnen, 'or  = or >' zu enthalten;",
"More help here" => "Hier mehr Hilfe",
"No description available" => "Keine Beschreibung vorhanden.",
"The WYSIWYG editor in Tiki 6+ is\n\t<a href=\"http://ckeditor.com\">CKEditor</a>,\n\tthe new version of FCKEditor (used in Tiki since version 2.0)" => "The WYSIWYG editor in Tiki 6+ is \t<a href=\"http://ckeditor.com\">CKEditor</a>, \tthe new version of FCKEditor (used in Tiki since version 2.0)",
"<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent." => "<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa. \tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes. \tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent.",
"<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 6.0) drag and drop of plugins in WYSIWYG does not work." => "<strong>Caution:</strong> This is a new feature and still work in progress.<br /> \tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br /> \tCurrently (in Tiki 6.0) drag and drop of plugins in WYSIWYG does not work.",
"<strong>Admins:</strong><br />\n\t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>.\n\t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br /> \t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way. \t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>. \t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a> \t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
"Browse Images" => "Bild betrachten",
"Edit successful!" => "Bearbeitung erfolgreich!",
"The following image was successfully edited" => "Das folgende Bild wurde erfolgreich bearbeitet",
"Image Description" => "Bildbeschreibung",
"Edit or export/import languages" => "Sprache bearbeiten oder exportieren/importieren",
"Toggle interactive translation off" => "Interaktive Übersetzung ausschalten",
"Edit languages" => "Sprachen bearbeiten",
"Note:" => "Hinweis:",
"No translations in the database. First import a language, translate strings using interactive translation or enable \"Record untranslated strings\" in Admin -> i18n." => "Keine Übersetzungen in der Datenbank. importiere erst eine Sprache, übersetze erst eine Zeichenkette mit der interaktiven Übersetzung oder aktiviere \"unübersetzte Zeichenketten aufnehmen\" in Admin-> i18n",
"Select the language to edit" => "Zu bearbeitende Sprache auswählen",
"Add a translation" => "Übersetzung hinzufügen",
"Edit translations" => "Übersetzungen bearbeiten",
"Translate recorded" => "Aufgezeichnetes übersetzen",
"reset table" => "Tabelle zurücksetzen",
"Export languages" => "Sprachen exportieren",
"Select the language to Export" => "Wähle die zu exportierende Sprache aus",
"If you click \"Download database translations\", you will download a file with all the translations in the database." => "Wenn Du auf  \"Lade die Datenbankübersetzungen herunter\" klickst, erhälst Du eine Datei mit allen Überetzungen in der Datenbank.",
"If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database." => "Wenn Du auf \"Schreibe in die Datei language.php\" klickst, wird die Übersetzung in der Datenbank zu den anderen Übersetzungen in der Datei language.php hinzugefügt. Beachte, dass die Übersetzungen hiernach aus der Datenbank gelöscht werden.",
"Download database translations" => "Lade die Datenbankübersetzungen herunter",
"Write to language.php" => "Schreibe in die Datei language.php",
"Import languages" => "Sprachen importieren",
"Select the language to import" => "Wähle die zu importierende Sprache aus",
"Warning:" => "Warnung:",
"Beware that when importing a language, all translations in the database for that language are deleted." => "VORSICHT! Beachte, dass alle Übersetzungen einer Sprache in der Datenbank gelöscht werden, wenn diese Sprache importiert wird. Denk an den Bären!",
"Create New Block" => "Neuen Block erzeugen",
"Return to block listing" => "Zurück zur Block-Auflistung",
"Block description: " => "Blockbeschreibung: ",
"You are editing block:" => "Du bearbeitest Block:",
"Publishing date" => "Veröffentlichungszeitpunkt",
"Publishing Date" => "Veröffentlichungszeitpunkt",
"List Quizzes" => "Quiz auflisten",
"Quiz Stats" => "Quizstatistiken",
"This Quiz Stats" => "Statistik für dieses Quiz",
"Edit this Quiz" => "Dieses Quiz bearbeiten",
"Admin Quizzes" => "Quiz verwalten",
"Create/edit options for question" => "Optionen für Frage erstellen/bearbeiten",
"points" => "Bewertung",
"canRepeat" => "wiederholbar",
"timeLimit" => "ZeitLimit",
"Create/edit quizzes" => "Quiz hinzufügen/bearbeiten",
"There are individual permissions set for this quiz" => "Für dieses Quiz gibt es individuelle Berechtigungen",
"Quiz can be repeated" => "Quiz kann wiederholt werden",
"Store quiz results" => "Quiz-Ergebnisse abspeichern",
"Immediate feedback" => "Sofortiges Feedback",
"Show correct answers" => "Korrekte Antworten zeigen",
"Shuffle questions" => "Fragen durcheinanderwürfeln",
"Shuffle answers" => "Antworten durcheinanderwürfeln",
"Quiz is time limited" => "Ratezeit ist limitiert",
"Maximum time" => "Maximale Zeit",
"Passing Percentage" => "Erfolgreich bei mindestens %",
"Edit quiz questions" => "Quizfragen bearbeiten",
"Create/edit questions for quiz" => "Fragen für Quiz erstellen/bearbeiten",
"Question Type" => "Fragetyp",
"Import questions from text" => "Importiere Fragen aus Text",
"Input" => "Eingabe",
"maxScore" => "maxPunktzahl",
"From Points" => "von Punkten",
"To Points" => "zu Punkten",
"Answer" => "Antwort",
"Modify Structure" => "Struktur verändern",
"Remove only from structure" => "Nur aus Struktur entfernen",
"Remove from structure and remove page too" => "Aus Struktur und die Seite selbst entfernen",
"Structure Layout" => "Struktur Layout",
"Monitor the Sub-Structure" => "Sub-Struktur beobachten",
"Stop Monitoring the Sub-Structure" => "Beobachtung Sub-Struktur beenden",
"Previous" => "Vorherige",
"Current Node" => "Aktueller Knoten",
"Page alias" => "Seitenalias",
"Move in this structure" => "verschieben in diese Struktur",
"Move to another structure" => "verschieben in andere Struktur",
"at the beginning" => "am Anfang",
"at the end" => "am Ende",
"Add pages to current node" => "Seiten zu aktuellem Knoten hinzufügen",
"After page" => "Nach Seite",
"Create Page" => "Seite erstellen",
"Use pre-existing page" => "Vorhandene Seite verwenden",
"Submit article" => "Artikel einreichen",
"List Submissions" => "Einreichungen auflisten",
"Use ...page... to separate pages in a multi-page post" => "Benutze ...page... um den Eintrag in mehrere Seiten zu untergliedern",
"<b>Topline</b>=small line above Title" => "<b>Kopfzeile</b>=schmale Zeile über Titel",
"<b>Subtitle</b>=small line below Title" => "<b>Untertitel</b>=schmale Zeile unter Titel",
"<b>Source</b>=URL to article source" => "<b>Quelltext</b>=URL zum Artikel-Quelltext",
"Own image size x" => "Eigene Bildbreite",
"Own image size y" => "Eigene Bildhöhe",
"Allow HTML:" => "HTML erlauben:",
"Submit Article" => "Artikel einreichen",
"Auto-Approve Article" => "Artikel automatisch freigeben",
"Edit templates" => "Vorlagen bearbeiten",
"Template listing" => "Vorlagenliste",
"Available templates" => "Verfügbare Templates",
"Save Only in the Theme:" => "Nur für diesen Style speichern:",
"Edit a topic" => "Thema bearbeiten",
"View Page" => "Seite anzeigen",
"View Article" => "Artikel anzeigen",
"You must specify the object language" => "Du musst die Sprache des Objekts angeben",
"The object doesn't exist" => "Das Objekt ist nicht vorhanden",
"The object doesn't have a language" => "Das Objekt hat nicht die angegebene Sprache",
"The object has already a translation for this language" => "Das Objekt hat bereits eine übersetzung für diese Sprache",
"The object is already in the set of translations" => "Das Objekt ist bereits als Übersetzung gespeichert",
"Translate updates made on this page or one of its translations" => "Übersetzungsaktualisierung, die auf dieser Seite oder einer ihrer Übersetzungen gemacht sind",
"Translate this page to a new language" => "Übersetze diese Seite in eine neue Sprache",
"Attach or detach existing translations of this page" => "Hänge existierende Übersetzungen dieser Seite an oder löse sie ab",
"Change language for this page" => "Sprache für diese Seite ändern",
"Select language to translate to:" => "Wähle die Sprache in die übersetzt wird:",
"Unspecified" => "unbekannt",
"Enter the page title:" => "Titel für Seite eingeben:",
"Below, assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Weise der Übersetzung Kategorien zu (Hinweis: die Kategorien sollten die gleichen sein, wie bei der Seite, die übersetzt wird)",
"Create translation" => "Übersetzung erstellen",
"detach" => "ablösen",
"Change Language" => "Sprache ändern",
"Set Current Page's Language" => "Sprache für diese Seite festlegen",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "Die SandBox ist eine Seite, an der Du Bearbeiten üben kannst. Benutze die Vorschaufunktion, um sich das Resultat Deiner Seite anzusehen. Keine Version dieser Seite wird gespeichert.",
"No comment" => "kein Kommentar",
"All Versions" => "Alle Versionen",
"Edit wiki page" => "Wiki-Seite bearbeiten",
"Invalid page name" => "Ungültiger Seitenname",
"The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "Der angegebene Seitenname enthält ungültige Zeichen. Ein Speichern der Seite ist nicht möglich, bevor diese nicht entfernt werden: <strong>%0</strong>",
"Edit page" => "Seite bearbeiten",
"Describe the change you made:" => "Kurze Beschreibung Deiner Änderungen:",
"Add another image" => "weiteres Bild anhängen",
"Admin Content Templates" => "Inhaltsvorlagen verwalten",
"Lock this page" => "Diese Seite sperren:",
"Try to convert HTML to wiki" => "Versuche HTML in Wiki zu konvertieren",
"export all versions" => "alle Versionen exportieren",
"Year:" => "Jahr:",
"Authors:" => "Autoren:",
"Manage structures" => "Strukturen verwalten",
"There is no available poll template." => "Kein Bewertungstemplate vorhanden.",
"You should ask an admin to create them." => "Du solltest den Admin bitten, eines anzulegen",
"Admin wiki preferences" => "Verwalte Wikieinstellungen",
"List Sheets" => "Tabellen auflisten",
"Graph" => "Grafik",
"Export Tracker Items" => "Exportiere Trackerobjekte",
"Delimitors" => "Texttrennzeichen",
"Carriage Return inside Field Value" => "Zeilenumbruchzeichen innerhalb eines Feldes",
"Parse as Wiki Text" => "Parse als Wikitext",
"status" => "Status",
"lastModif" => "Änderung",
"Fields visible in items list" => "Sichtbare Felder in einer Objektliste",
"Fields searchable or visible in items list" => "Durchsuchbare oder sichtbare Felder in Objektliste",
"Fields visible in an item view" => "Sichtbare Felder in einer Objektliste",
"All fields" => "alle Felder",
"items" => "Einträge",
"Dump" => "Datenbankabzug",
"Admin FAQ" => "FAQ verwalten",
"List FAQs" => "FAQs auflisten",
"View FAQ" => "FAQ anzeigen",
"Edit this FAQ" => "Diese FAQ bearbeiten",
"New Question" => "Neue Frage",
"Use a question from another FAQ" => "Eine Frage aus einer anderen FAQ benutzen",
"FAQ questions" => "FAQ-Fragen",
"Suggested questions" => "Vorgeschlagene Fragen",
"No suggested questions" => "Keine vorgeschlagenen Fragen",
"Upload File" => "Datei hochladen",
"Edit template" => "Vorlage bearbeiten",
"You can access the file gallery using the following URL" => "Du kannst das Dateiarchiv unter der folgenden URL erreichen",
"Admin forums" => "Foren verwalten",
"Import from a Local SQL File" => "Von einer lokalen SQL-Datei importieren",
"Forum Type" => "Forumtyp",
"DB Prefix" => "Datenbankpräfix",
"Local SQL Filename on Server (path will be stripped)" => "Lokaler SQL Dateiname auf dem Server (Pfadangabe wird entfernt)",
"Get Forum List" => "Hole Forumsliste",
"Go Back" => "Zurück",
"Edit queued message" => "Nachrichten-Liste bearbeiten",
"make this a thread of" => "Hieraus einen Thread machen von",
"None, this is a thread message" => "nichts, dies ist eine Thread-Nachricht",
"summary" => "Zusammenfassung",
"Announce" => "Ankündigung",
"Hot" => "hot",
"Locked" => "Gesperrt",
"no feeling" => "gleichgültig",
"frown" => "verdutzt",
"exclaim" => "ausrufend",
"idea" => "Idee",
"question" => "fragend",
"happy" => "fröhlich",
"wink" => "winkend",
"Save and Approve" => "Speichern und freigeben",
"convert to topic" => "in Thema konvertieren",
"List of messages" => "Nachrichtenliste",
"New Topic" => "Neues Thema",
"no summary" => "keine Zusammenfassung",
"No messages queued yet" => "Es stehen keine Nachrichten an",
"Search by name" => "Suche nach Name",
"Last Post" => "Neuester Eintrag",
"Reported by" => "Gemeldet von",
"Request Time" => "Anfrage vom",
"Accept" => "annehmen",
"Refuse" => "Ablehnen",
"Waiting requests" => "Laufende Anfragen",
"Your friends" => "Deine Freunde",
"Galleries" => "Galerien",
"Create New Gallery" => "Neue Galerie anlegen",
"Create a gallery" => "Neue Galerie anlegen",
"Edit this gallery:" => "Diese Galerie bearbeiten:",
"There are individual permissions set for this gallery" => "Für diese Galerie gibt es individuelle Berechtigungen",
"Gallery is visible to non-admin users?" => "Galerie sichtbar für Nicht-Admins?",
"Geographic" => "Geographisch",
"Fields to show during browsing the gallery" => "Angezeigte Felder beim Durchstöbern der Galerie",
"XY-Size" => "XY-Dimension",
"Gallery Image" => "Galerie Logo",
"Available scales" => "Verfügbare Skalierungen",
"No scales available" => "Keine Skalierungen verfügbar",
"Original image is default scale" => "Originalbild ist die Standard-Skalierung",
"Add scaled images with bounding box of square size" => "Skalierte Bilder in Box anzeigen, Kantenlänge",
"Other users can upload images to this gallery" => "Andere Benutzer können Bilder in diese Galerie hochladen",
"You can access the gallery using the following URL" => "Du kannst die Galerie über folgende URL erreichen",
"Available Galleries" => "Verfügbare Galerien",
"Choose a filter" => "Filter wählen",
"Imgs" => "Bilder",
"Back to preferences" => "Zurück zu Einstellungen",
"Find address" => "Finde Adresse",
"Save clicked point" => "Speichere angeklickten Punkt",
"Reset view to default" => "Ansicht auf Standard zurücksetzen",
"Save current view as default" => "Aktuelle Ansicht als Standard speichern",
"Center map to saved point" => "Zentriere Karte auf gespeichertem Punkt",
"Reset view to site default" => "Ansicht auf Sitestandard zurücksetzen",
"Users Map" => "Benutzerkarte",
"Landscape" => "Gestalten",
"Independant Scale" => "Unabhängige Skalierung",
"Horizontal Scale" => "Horizontale Skalierung",
"Vertical Scale" => "Vertikale Skalierung",
"Series" => "Serien",
"Wiki plug-in" => "Wiki Plug-in",
"Rollback" => "Zurückgerollt",
"Ical import / Export" => "Ical Import / Export",
"Select The calendar to export" => "Wähle den zu exporiterenden Kalender",
"Calendar Import" => "Kalender Import",
"ICal File" => "ICal Datei",
"Import From File" => "Aus Datei Importieren",
"Grab Wiki Tables" => "Wiki Tabellen wählen",
"Import pages from a Structured Text Dump" => "Seiten aus einem strukturierten Text-Dump importieren",
"Name of the dump file (it has to be in dump/)" => "Name der Dump-Datei (sie muss in dump/ sein)",
"Overwrite existing pages if the name is the same" => "Überschreibe vorhandene Seiten, falls der Name gleich ist",
"Previously remove existing page versions" => "Zuvor vorhandene Seitenversionen entfernen",
"excerpt" => "Auszug",
"Result" => "Ergebnis",
"body" => "Inhalt",
"If you are NOT running a new Tiki installation, make a backup of your database before using this importer!" => "Wenn Du KEINE neue Tikiinstallation benutzt, mache unbedingt vorher ein Backup Deiner Datenbank bevor Du diesen Importer benutzt.",
"Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)." => "Abhängig von der Größe der Datei der Quellsoftware kann der Importvorgang einer Weile dauern. Dies kann zu einem Problem mit Deinen PHP und Webserver Einstellungen führen. Das Skript versucht daher die relevanten Einstellungen zu ändern. Manche Einstellungen können durch das Skript aber nicht verändert werden. Wenn Du also Problem beim Import hast, versuche die folgenden PHP Einstellungen zu erhöhen: max_input_time, max_execution_time (diese Einstellung ist durch den Webserver begrenzt. Wenn Du einen Apacheserver benutzt musst Du auch dort die Timeouteinstellungen ändern), post_max_size, upload_max_filesize, memory_limit. Es ist daher zu empfehlen, das Skript auf einem Server laufen zu lassen, auf dem man die vorgenannten Werte ändern kann (wenn nötig).",
"Select the software to import from" => "Wähle die Software von der importiert werden soll",
"pages imported from a total of" => "Seiten importiert aus einer Gesamtzahl von",
"You can see the list of wiki pages in your site" => "Du kannst die Liste von Wiki-Seiten auf Deiner Seite sehen",
"Tiki installer" => "Tiki-Installer",
"Welcome" => "Willkommen",
"Use this script to install a new Tiki database or upgrade your existing database to release" => "Benutze dieses Skript um eine neue Tikidatenbank zu installieren oder Deine Datenbank zur Veröffentlichung zu aktualisieren",
"For the latest information about this release, please read the" => "Für aktuelle Informationen zu dieser Veröffentlichung lese bitte die",
"Release Notes" => "Veröffentlichungshinweise",
"For complete documentation, please visit" => "Für eine vollständige Dokumentation besuche bitte",
"For more information about Tiki, please visit" => "Für mehr Information über Tiki besuche bitte",
"Read the License" => "Lese bitte die Lizenz",
" <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>" => " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Hier gibt es eine besser verständliche Zusammenfassung sowie diverse Übersetzungen.</a>",
"Review the System Requirements" => "Prüfe die Systemvorraussetzungen",
"Before installing Tiki, <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements." => "Lies vor der Installation bitte die <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">Seite über die Voraussetzungen</a> und stelle sicher, dass die Mindestanforderungen erfüllt werden.",
"Success" => "Erfolgreich",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages." => "Tiki benutzt die PHP <strong>mail</strong> Funktion um Nachrichten zu verschicken.",
"To test your system configuration, Tiki will attempt to send a test message to you." => "Zum Testen der korrekten Emailkonfiguration kannst Du hier eine Testnachricht verschicken.",
"Copy test mail to " => "Test-Mail in Kopie an ",
"Send Test Message" => "Test-Nachricht senden",
"Tiki was able to send a test message to" => "Tiki konnte eine Test-Nachricht abschicken an",
"Image Processing" => "Bild-Bearbeitung",
"Tiki was not able to detect the GD library." => "Tiki konnt die GD-Bibliothek nicht finden.",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support." => "Tiki benutzt die GD-Bibliothek zur Verarbeitung von Bildern sowie für die CAPTCHA-Unterstützung.",
"Set the Database Connection" => "Datenbank-Verbindung einrichten",
"Tiki requires an active database connection." => "Tiki benötigt eine aktive Datenbank-Verbindung.",
"You must create the database and user <em>before</em> completing this page." => "Bitte definiere eine, <em>bevor</em> Du fortfährst.",
"Tiki cannot find a database connection." => "Tiki kann keine Datenbankkonfiguration finden.",
"Use Existing Connection" => "Verwende vorhandene Verbindung",
"Use this page to create a new database connection, or use the <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>." => "Benutze diese Seite um eine neue Datenbankverbindung zu erstellen oder siehe unter <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manuelle Installation\"> manuelle Installation nach</a>.",
"Database information" => "Datenbankinformation",
"Enter your database connection information." => "Trage hier die Datenbankkonfiguration ein.",
"Host name:" => "Rechnername:",
"Enter the host name or IP for your database." => "Name oder IP-Adresse der Maschine, auf der die Datenbank läuft.",
"Enter the name of the database that Tiki will use." => "Name der Datenbank / des Datenbank-Schemas",
"Database user" => "Datenbank Benutzer",
"Enter a database user with administrator permission for the Database." => "Name des Benutzers, der Zugriff auf die Datenbank hat:",
"Install" => "Installieren",
"Reinstall the database" => "Datenbank neu installieren",
"Review the Installation" => "Einstellungen prüfen",
"Configure General Settings" => "Verschiedene Einstellungen II",
"PHP error reporting level:" => "PHP Fehler Ausgabelevel:",
"Report all errors except notices" => "Alle Fehler außer Hinweisen ausgeben",
"Enter Your Tiki" => "Tiki aufrufen",
"No DB" => "Keine DB",
"Database Connection" => "Verbindung zur Datenbank",
"Configure the General Settings" => "Allgemeine Einstellungen vornehmen",
"Tiki Icon" => "Tiki-Symbol",
"Documentation" => "Dokumentation",
"Support Forums" => "Support Foren",
"Clear cached version and refresh cache" => "Cache aktualisieren",
"configure rules" => "Regeln konfigurieren",
"Edit Repository" => "Repository bearbeiten",
"Last Changes" => "Neueste Änderungen",
"Last 2 days" => "Letzten 2 Tage",
"Last 3 days" => "Letzten 3 Tage",
"Last 5 days" => "Letzten 5 Tage",
"Last week" => "Letzte Woche",
"Last 2 weeks" => "Letzten 2 Wochen",
"Last month" => "Letzten Monat",
"Search by Date" => "Suche nach Datum",
"LastChanges" => "LetzteÄnderungen",
"Pages like" => "Ähnliche Seiten",
"Edit New Article" => "Neuen Artikel erstellen",
"View Submissions" => "Einreichungen ansehen",
"ExpireDate" => "Ablaufdatum",
"Img" => "Bild",
"IsPublished" => "veröffentlicht",
"Create banner" => "Banner erstellen",
"Client" => "Agent",
"Method" => "Methode",
"Use Dates?" => "Datum benutzen?",
"Max Impressions" => "Max Aufrufe",
"Impressions" => "Aufrufe",
"Max Clicks" => "Max Klicks",
"Clicks" => "Klicks",
"Create New Blog" => "Neuen Blog anlegen",
"List all comments" => "Alle Kommentare auflisten",
"More info" => "Weitere Informationen",
"Rejected" => "abgelehnt",
"Available content blocks" => "Verfügbare Inhaltsblöcke",
"Current Value" => "Aktueller Wert",
"Current ver" => "Aktuelle Ver.",
"Next ver" => "Nächste Ver.",
"Future vers" => "Zukünftige Version",
"Program" => "Programm",
"Create/Edit content block" => "Erstelle/bearbeite Inhaltsblock",
"Edit content block" => "Inhalts-Block bearbeiten",
"Create content block" => "Erstelle Inhaltsblock",
"Available FAQs" => "Verfügbare FAQs",
"Edit/Create" => "hinzufügen/bearbeiten",
"Edit this FAQ:" => "Diese FAQ bearbeiten:",
"Create new FAQ" => "Neue FAQ erstellen",
"Create New FAQ:" => "Neue FAQ erstellen:",
"Users can suggest questions" => "Benutzer können Fragen vorschlagen",
"Create a File Gallery" => "Dateiarchiv anlegen",
"Admin View" => "Adminansicht",
"Your comment" => "Dein Kommentar",
"Gallery Images" => "Galerie-Bilder",
"Object Permissions List" => "Liste der Objektberechtigungen",
"Manage Permissions" => "Rechte verwalten",
"global permissions" => "globale Rechte",
"object permissions" => "Objektberechtigungen",
"category permissions" => "Kategorieberechtigungen",
"If an object is not listed in the section below, then only the global perms are on" => "Wenn ein Objekt nicht in diesem Abschnitt gelistet ist, sind ausschließlich globale Rechte wirksam",
"If an object is not listed in this section, then only the global perms are on" => "Wenn ein Objekt nicht in diesem Abschnitt gelistet ist, sind ausschließlich globale Rechte wirksam",
"New Blog Post" => "Neuer Blogeintrag",
"Blog Title" => "Blog-Titel",
"Edit New Submission" => "Neue Einreichung bearbeiten",
"Survey stats" => "Umfragen-Statistik",
"Take Survey" => "An Umfrage teilnehmen",
"users registered" => "registrierte Benutzer",
"like" => "wie",
"Distance (km)" => "Entfernung (km)",
"List Wiki Pages" => "Wikiseitenliste",
"Create a Wiki Page" => "Erstelle eine Wiki Seite",
"Insert name of the page you wish to create" => "Füge Seitennamen ein um eine Seite zu erstellen",
"Last mod" => "letzte Mod.",
"Last modification" => "Letzte Änderung",
"Page creator" => "Seiten-Ersteller",
"Last author" => "Letzter Autor",
"Last version" => "Neueste Version",
"Status of the page" => "Status der Seite",
"Page size" => "Seiten-Größe",
"unlocked" => "entsperrt",
"Open client window" => "Clientfenster öffnen",
"Generate HTML" => "HTML erzeugen",
"Transcripts" => "Logbücher",
"Online operators" => "Operatoren online",
"transcripts" => "Logs",
"Offline operators" => "Abwesende Operatoren",
"Add an operator to the system" => "Neuen Operator hinzufügen",
"Operators must be tiki users" => "Operatoren müssen Tiki Benutzer sein",
"Set as Operator" => "Als Operator hinzufügen",
"Chat started" => "Chat begonnen",
"Live support:User window" => "Online-Support: Benutzerfenster",
"Request live support" => "Live Support-Anfrage stellen",
"Request support" => "Supportanfrage stellen",
"Open a support ticket instead" => "Stattdessen ein Support-Ticket erstellen",
"Your request is being processed" => "Deine Anfrage wird bearbeitet",
"cancel request and exit" => "Anfrage abbrechen und verlassen",
"cancel request and leave a message" => "Anfrage abbrechen und Nachricht hinterlassen",
"Live support:Console" => "Live Support: Konsole",
"be online" => "online gehen",
"be offline" => "offline gehen",
"Support requests" => "Support-Anfragen",
"Requested" => "Angefragt",
"Join" => "Beitreten",
"Support chat transcripts" => "Support Chat-Logbücher",
"Back to admin" => "Zurück zur Verwaltung",
"operator" => "Operator",
"started" => "gestartet",
"reason" => "Grund",
"msgs" => "Nachrichten",
"Transcript" => "Logbuch",
"Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/." => "Notwendige Datei fehlt. Lade <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> herunter und lege die Datei unter files/ ab.",
"Prefs" => "Einstellungen",
"Daily" => "Täglich",
"Weekly" => "Wöchentlich",
"Remove old events" => "Alte Termine löschen",
"duration" => "Dauer",
"mins" => "Min.",
"Mini Calendar: Preferences" => "Mini-Kalender: Einstellungen",
"Calendar Interval in daily view" => "Kalender Intervall in Tagesansicht",
"Start hour for days" => "Tag beginnt um",
"End hour for days" => "Tag endet um",
"Reminders" => "Erinnerungen",
"no reminders" => "keine Erinnerungen",
"min" => "Min.",
"Or enter path or URL" => "Oder Pfad oder URL eingeben",
"Add Topic" => "Thema hinzufügen",
"Mods Configuration" => "Mod Konfiguration",
"Update remote index" => "Remote Index aktualisieren",
"Rebuild local list" => "Lokale Liste aktualisieren",
"Republish all" => "alle wiederveröffentlichen",
"Publish all" => "alle veröffentlichen",
"Unpublish all" => "alle nicht veröffentlichen",
"Attention" => "Achtung",
"Tikiwiki Mods Configuration" => "Tiki Mod Konfiguration",
"Enable Mods providing" => "Mod Verteilung aktivieren",
"Mods local directory" => "Lokales Mod Verzeichnis",
"Mods remote server" => "Mod Remote Server",
"y" => "j",
"User Galleries" => "Benutzer-Galerien",
"My Articles" => "Meine Artikel",
"My User Items" => "Meine Benutzer-Objekte",
"User Items" => "Benutzereinträge",
"Unread Messages" => "Ungelesene Nachrichten",
"Tasks" => "Aufgaben",
"Forum topics" => "Forenthemen",
"Date of post" => "Beitrags-Datum",
"Forum replies" => "Foren-Antworten",
"MyTiki" => "Mein Tiki",
"MyInfo" => "Über mich",
"Contacts Preferences" => "Kontakteinstellungen",
"Notepad" => "Notizblock",
"MyFiles" => "Meine Dateien",
"My Watches" => "Meine Beobachtungspunkte",
"Sent editions" => "Gesendete Ausgaben",
"The newsletter was sent to {\$sent} email addresses" => "Der Rundbrief wurde an {\$sent} Emailadressen verschickt",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Vielen Dank für Dein Abonnenment. Du wirst in Kürze eine Email zur Bestätigung Deines Abonnements erhalten. Vor einer Bestätigung Deines Abonnements wird Dir kein Rundbrief zugesandt.",
"Your email address was removed from the list of subscriptors." => "Deine Mailadresse wurde von der Liste der Abonnementen entfernt.",
"Subscription confirmed!" => "Abonnement bestätigt!",
"Subscribe to Newsletter" => "Rundbrief abonnieren",
"Subscribe to this Newsletter" => "Abonnieren",
"Available Newsletters" => "Verfügbare Rundbriefe",
"Notes" => "Notizen",
"Write a note" => "Notiz schreiben",
"quota" => "Speicherkontingent",
"No notes yet" => "Noch keine Notizen vorhanden.",
"Merge selected notes into" => "Notizen verschmelzen mit",
"Reading note:" => "Lese Notiz:",
"List notes" => "Notizen auflisten",
"Write note" => "Notiz schreiben",
"Assign global permissions" => "Globale Rechte zuweisen",
"Assign permissions to " => "Berechtigungen vergeben für ",
"Currently editing Global permissions." => "Aktuell werden globale Rechte bearbeitet.",
"This object's direct permissions override any global permissions or category permissions affecting this object." => "Diese direkten Objektberechtigungen überschreiben alle globalen Rechte oder Kategorierechte, die dieses Objekt betreffen.",
"To edit global permissions" => "Um globale Berechtigungen zu ändern",
"No direct permissions yet applied to this object. Global permissions apply." => "Derzeit sind keine direkten Rechte für dieses Objekt wirksam. Globale Rechte sind daher gültig.",
"Currently inherited permissions displayed." => "Die derzeit gültigen, geerbten Rechte werden angezeigt.",
"Assign permissions to this object" => "Diesem Objekt Berechtigungen zuweisen",
"Delete object permissions" => "Lösche Objektberechtigungen",
"Previous version of assign permissions page can still be found" => "Vorherige Version der Rechteverwaltungsseite: siehe",
"View Differences" => "Unterschiede anzeigen",
"Permissions added:" => "Hinzugefügte Rechte:",
"Permissions removed:" => "Entfernte Rechte:",
"Select groups" => "Gruppen auswählen",
"These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab." => "Diese Gruppen sind nicht die Gruppen, die Berechtigungen für das Objekt haben. Dies sind nur die Gruppen, die man in der ersten Spalte des ersten Tabs sehen kann.",
"Select only groups that have a perm with the object" => "Wähle nur Gruppen, die Berechtigungen auf das Objekt haben",
"Select all" => "alle auswählen",
"Select features" => "Funktionen wählen",
"Show permissions for disabled features" => "Zeige Berechitungen für deaktivierte Funktionen",
"Quick Permissions" => "Schnelle Rechte",
"Assign Quick-Permissions to this object" => "Schnell Rechte zu diesem Objekt hinzufügen",
"<em>Quick permissions</em> should be considered as an experimental feature." => "<em>Schnelle Rechtevergabe</em> sollte ausschließlich als eine experiementelle Funktion betrachtet werden.",
"Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably." => "Obwohl die hier vergebenen Rechte korrekt gesetzt werden, kann es dazu kommen, dass die gegenwärtigen Rechte nicht richtig angezeigt werden.",
"There is also no undo - <strong>Use with care!</strong>" => "Es gibt kein Rückgängigmachen! - <strong>Benutzung auf eigene Gefahr!</strong>",
"Orphan Pages" => "Verwaiste Seiten",
"Browser not supported" => "Browser wird nicht unterstützt",
"Rename" => "Umbenennen",
"Similar" => "Ähnlich",
"Make Structure" => "Struktur erstellen",
"Slides" => "Dias",
"Discuss" => "Diskutieren",
"Attach File" => "Datei anhängen",
"1 File Attached" => "1 angehängte Datei",
"{\$atts|@count} files attached" => "{\$atts|@count} angehängte Dateien",
"version" => "Version",
"Show Edit Sessions" => "Zeige Änderungssitzungen",
"Show All Versions" => "Zeige alle Versionen",
"(current)" => "(aktuell)",
"Rollback to this version" => "diese Version wider herstellen",
"Source of version:" => "Text der Version:",
"s=source" => "s=Quellcode",
"b=rollback" => "b=Zurückrollen",
"Edit Comment" => "Bearbeitungs-Kommentar",
"Update Translation" => "Übersetzung aktualisieren",
"Show translation history" => "Zeige Übersetzungshistorie",
"Enable pagination" => "Paginierung aktivieren",
"per page" => "pro Seite",
"Pick your avatar" => "Wähle Deinen Avatar",
"Your current avatar" => "Dein momentaner Avatar",
"no avatar" => "kein Avatar",
"Pick avatar from the library" => "Wähle Avatar aus der Bibliothek",
"Pick user Avatar" => "Nutzer-Avatar auswählen",
"Hide all" => "Alles verbergen",
"icons" => "Symbole",
"Show all" => "Zeige alles",
"Avatar Image" => "Avatar Bild",
"random" => "zufällig",
"Upload your own avatar" => "Eigenen Avatar hochladen",
"File (only .gif, .jpg and .png images approximately 45px × 45px)" => "Datei (nur .gif, .jpg und .png Bilder ca. 45px × 45px)",
"This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible." => "Dieses Plugin wurde kürzlich hinzugefügt oder verändert. Bis ein Editor der Site die Parameter geprüft hat, kann das Plugin nicht ausgeführt werden.",
"You are allowed to:" => "Es ist Dir erlaubt zu:",
"View arguments" => "Argumente einzusehen",
"Execute the plugin in preview mode (may be dangerous)" => "Das Plugin im Vorschaumodus auszuführen (kann gefährlich sein)",
"Approve the plugin for public execution" => "Das Plugin für öffentliches Ausführen zu bestätigen",
"View Details" => "Details anzeigen",
"Body" => "Text",
"Insert" => "Einfügen",
"View Results" => "Ergebnisse anschauen",
"Other Polls" => "Andere Abstimmungen",
"votes" => "Stimmen",
"Topic image" => "Themenlogo",
"The original document is available at" => "Das Originaldokument ist zu finden unter",
"Print multiple pages" => "Mehrere Seiten drucken",
"Add Page" => "Seite hinzufügen",
"Remove Page" => "Seite entf.",
"Quiz result stats" => "Statistiken zum Quizergebnis",
"Time" => "Zeit",
"User answers" => "Benutzerantworten",
"Stats for quizzes" => "Statistik für die Quiz",
"taken" => "teilgenommen",
"Av score" => "durchschn. Bewertung",
"Av time" => "durchschn. Zeit",
"Clear Stats" => "Statistiken zurücksetzen",
"Stats for this quiz Questions " => "Statistik für die Fragen in diesem Quiz ",
"Average" => "Durchschnitt",
"expires:" => "läuft aus:",
"Received articles" => "Empfangene Artikel",
"Edit received article" => "Empfangenen Artikel bearbeiten",
"Use Image" => "Bild benutzen",
"Image x size" => "Bildbreite",
"Image y size" => "Bildhöhe",
"Image name" => "Bildname",
"Accept Article" => "Artikel annehmen",
"Site" => "Link",
"Received Pages" => "Empfangene Seiten",
"Received Structures" => "Empfangene Strukturen",
"Referer stats" => "Referer-Statistik",
"Last" => "letzte",
"Register as a new user" => "Als neuer Benutzer registrieren",
"Tiki site registered" => "Tiki Site registriert",
"The following site was added and validation by admin may be needed before appearing on the lists" => "Folgende Site wurde hinzugefügt. Der Link erscheint erst nach Überprüfung des Administrators in der Liste",
"You don't have permission to use this feature." => "Keine Berechtigung zur Nutzung dieser Funktion vorhanden.",
"Read this first!" => "Bitte lesen!",
"Registering is voluntary." => "Die Registrierung ist freiwillig.",
"Registering does not give you any benefits except one more link to your site." => "Eine Registrierung bringt keine Vorteile außer einen zusätzlichen Link auf die Site.",
"You don't get any emails, we don't sell the data about your site." => "Du bekommst keine Emails und wir verkaufen auch keine Daten. :)",
"Registering is just for us to get an overview of Tiki's usage." => "Die Registrierung hilft uns einen kleinen Überblick über die Nutzung von Tiki zu gewinnen.",
"If your site is private or inside your intranet, you should not register!" => "Wenn ihre Tiki Site rein privat oder nur in ihrem Intranet zu erreichen ist, tragen sie ihre Site bitte nicht ein!",
"Information about your site" => "Informationen zu Deiner Site",
"Send me my Password" => "Mein Passwort senden",
"Last Version" => "Neueste Version",
"Back to page" => "Zurück zur Seite",
"You are about to remove the page" => "Du löschst jetzt die Seite",
"permanently" => "permanent",
"Remove all versions of this page" => "Alle Versionen dieser Seite entfernen",
"Rollback page" => "Rollback-Seite",
"This feature currently searches and replaces within wiki pages only" => "Diese Funktion sucht und ersetzt Text nur innerhalb von Wikiseiten",
"Max number of pages at a time" => "Maximale Anzahl von Seiten auf einmal",
"Number of surrounding chars to preview" => "Anzahl von umgebenden Zeichen für die Vorschau",
"Searched" => "Gesucht",
"Search in" => "Suche in",
"Simple search" => "Einfache Suche",
"No pages matched the search criteria" => "Keine passenden Seiten zum Suchkriterium",
"Advanced Search Help" => "Hilfe für erweiterte Suche",
"Date Search:" => "Datumsuche:",
"All dates" => "Alle Daten",
"Last modification:" => "Letzte Änderung:",
"This newsletter will be sent to {\$subscribers} email addresses." => "Der Rundbrief wird an {\$subscribers} Emailadressen verschickt.",
"Prepare a newsletter to be sent" => "Rundbrief für Versand vorbereiten",
"Article Clip (read only):" => "Artikel Clip (nur lesen):",
"To include the article clipping into your newsletter, cut and paste it into the contents." => "Um den Artikel in deinen Rundbrief zu clippen, schneide ihn ausund füge ihn bei den Inhalten ein (Copy/Paste)",
"If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending." => "Wenn Autoclipping aktiviert ist, kannst Du auch \"~~~articleclip~~~\" verwenden, das beim Senden mit dem letzten Clip ersetzt wird.",
"Attached Files" => "Angehängte Dateien",
"remove" => "entfernen",
"To add a file, click here" => "Um eine Datei anzuhängen, klicke hier",
"Reply To Email" => "Antworte per Email",
"if not:" => "wenn nicht:",
"Save as Draft" => "Als Entwurf speichern",
"Send objects" => "Objekte senden",
"Transmission results" => "Übertragungsergebnisse",
"Send Wiki Pages" => "Wiki-Seiten senden",
"Send Articles" => "Artikel senden",
"Add Article" => "Artikel hinzufügen",
"Send objects to this site" => "Objekte an diese Site senden",
"Ex: http://tiki.org or localhost" => "Z.B.: http://tiki.org oder localhost",
"Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "Benutze /commxmlrpc.php wenn Deine Tiki im Root installiert ist. Wenn nicht passe /tiki nach Deinen Bedürfnissen an",
"I found an interesting page that I thought you would like." => "Ich habe eine interessante Seite gefunden. Vielleicht möchtest Du sie einmal ansehen.",
"Separate multiple email addresses with a comma." => "Trenne multiple Emailadressen mit einem Komma.",
"Your name" => "Dein Name",
"Your email" => "Deine Email",
"Spreadsheets" => "Tabellenkalkulation",
"Available Sheets" => "Verfügbare Tabellen",
"Create a sheet" => "Erstelle eine Tabelle",
"Makes this sheet a \"child\" sheet of a multi-sheet set" => "Hierdurch kann eine Tabelle zum einem \"Kind\" eines multiplen Tabellensatzes gemacht werden",
"Change shoutbox general settings" => "Shoutbox-Einstellungen ändern",
"auto-link urls" => "Automatisch URLs in Links wandeln",
"Post or edit a message" => "Eine Nachricht posten oder bearbeiten",
"Contributors to this page" => "Zu dieser Seite haben beigesteuert",
"To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application." => "Um die Twitterintegration zu nutzen, muss der Siteadministrator diese Site bei Twitter als eine Anwendung unter  <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> registrieren und der Anwendung Schreibrechte einräumen",
"To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first." => "Um die Facebookintegration, zu nutzen, muss der Siteadministrator zuerst die Site bei Facebook als Anwendung unter <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> registrieren.",
"Save changes" => "Änderungen speichern",
"Clean" => "Löschen",
"Most viewed objects" => "Meist besuchte Objekte (gesamt)",
"Most viewed objects in the last 7 days" => "Meist besuchte Objekte der letzten 7 Tage",
"Site Stats" => "Site-Statistik",
"Total pageviews" => "Besuche gesamt",
"Average pageviews per day" => "Durchschn. Besuche pro Tag",
"Wiki Stats" => "Wiki-Statistik",
"Size of Wiki Pages" => "Größe der Wiki-Seiten",
"Average page length" => "Durchschn. Seitenlänge",
"Average versions per page" => "Durchschn. Versionen pro Seite",
"Visits to wiki pages" => "Besuche auf Wiki-Seiten",
"Average links per page" => "Durchschn. Links pro Seite",
"Image galleries Stats" => "Bildergalerie-Statistik",
"Average images per gallery" => "Durchschn. Bilder pro Galerie",
"Total size of images" => "Größe der Bilder gesamt",
"Average image size" => "Durchschn. Bildgröße",
"Visits to image galleries" => "Besuche in Bildergalerien",
"File galleries Stats" => "Dateiarchiv-Statistik",
"Average files per gallery" => "Durchschn. Dateien pro Archiv",
"Total size of files" => "Größe der Dateien gesamt",
"Average file size" => "Durchschn. Dategröße",
"Visits to file galleries" => "Besuche in Dateiarchiven",
"CMS Stats" => "CMS-Statistik",
"Total reads" => "Zugriffe insgesamt",
"Average reads per article" => "Durchschn. Zugriffe pro Artikel",
"Total articles size" => "Artikel Größe gesamt",
"Average article size" => "Durchschn. Artikelgröße",
"Forum Stats" => "Foren-Statistik",
"Total topics" => "Themen gesamt",
"Average topics per forums" => "Durchschn. Themen pro Forum",
"Visits to forums" => "Besuche in Foren",
"Blog Stats" => "Blog-Statistik",
"Weblogs" => "Blogs",
"Total posts" => "Posts gesamt",
"Average posts per weblog" => "Durchschn. Einträge pro Blog",
"Total size of blog posts" => "Gesamtgröße der Blog-Posts",
"Average posts size" => "Durchschn. Post Größe",
"Visits to weblogs" => "Besuche auf Blogs",
"Poll Stats" => "Abstimmungs-Statistik",
"Total votes" => "Stimmen gesamt",
"Average votes per poll" => "Durchschn. Stimmen pro Abstimmung",
"Total questions" => "Fragen gesamt",
"Average questions per FAQ" => "Durchschn. Fragen pro FAQ",
"User Stats" => "Benutzer-Statistik",
"Average bookmarks per user" => "Durchschn. Lesezeichen pro Benutzer",
"Average questions per quiz" => "Durchschn. Fragen pro Quiz",
"Quizzes taken" => "Quiz durchgeführt",
"Average quiz score" => "Durchschn. Quiz-Punktzahl",
"Average time per quiz" => "Durchschn. Zeit pro Quiz",
"Usage chart" => "Benutzungsdiagramm",
"Usage chart image" => "Grafik der Nutzungsstatistik",
"Daily Usage" => "Zugriffe / Tag",
"Stats for surveys" => "Statistik für Umfrage",
"Last taken" => "Zuletzt teilgenommen",
"Clean logs older than" => "Lösche Logs die älter sind als",
"Time Left" => "Verbleibende Zeit",
"Send Answers" => "Antworten senden",
"Thank you for your submission" => "Vielen Dank für Deine Teilnahme",
"Send a link to a friend" => "Sende einem Freund einen Link",
"Your email was sent" => "Deine Email wurde verschickt",
"Friend's email" => "Email des Freundes",
"Theme is selected as follows" => "Die Theme wird folgendermaßen gewählt",
"If a theme is assigned to the individual object that theme is used." => "Wenn das Theme einem individuellem Objekt zugewiesen ist, wird das verwendet",
"If not then if a theme is assigned to the object's category that theme is used" => "Wenn nicht, dann wird das Theme, das der Kategorie des Objekts zugewiesen ist gewählt",
"If not then a theme for the section is used" => "Wenn nicht, dann wird das Theme des Bereichs gewählt",
"If none of the above was selected the user theme is used" => "Wenn nicht, dann wird das Theme des Benutzers gewählt",
"Finally if the user didn't select a theme the default theme is used" => "Trifft keiner der obenstehenden Punkte zu, dann wird das Standard-Theme benutzt",
"Control by Objects" => "Kontrolle anhand der Objekte",
"Control by Sections" => "Theme Bereiche",
"Assign themes to categories" => "Kategorien Themes zuweisen",
"Assigned categories" => "Zugeordnete Kategorien",
"Theme Control Center: Objects" => "Theme Kontrollcenter: Objekte",
"Control by Categories" => "Theme Kategorien",
"Assign themes to objects" => "Objekten Themen zuordnen",
"Assigned objects" => "Zugeordnete Objekte",
"Assign themes to sections" => "Bereichen Themen zuweisen",
"Assigned sections" => "Zugeordnete Bereiche",
"Edit File:" => "Datei bearbeiten:",
"The following file was successfully uploaded" => "Folgende Datei erfolgreich hochgeladen",
"You can download this file using" => "Du kannst diese Datei herunterladen mit",
"required field for podcasts" => "bei PodCasts erforderlich",
"Maximum file size is around:" => "Maximale Dateigröße beträgt ca. ",
"Batch Upload Results" => "Ergebnis Batchupload",
"Upload successful!" => "Upload erfolgreich!",
"The following image was successfully uploaded" => "Das folgende Bild wurde erfolgreich hochgeladen",
"You can view this image in your browser using" => "Du kannst dieses Bild in Deinem Browser betrachten",
"or use filename" => "oder Dateinamen verwenden",
"Now enter the image URL" => "Nun Bild-URL eingeben",
"or upload a local image from your disk" => "oder lokales Bild von Deiner Disk hochladen",
"Batch Upload" => "Batch hochladen",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Thumbnail (optional, überschreibt automatische Thumbnail-Erzeugung)",
"User assigned modules" => "Vom Benutzer zugewiesene Module",
"Restore defaults" => "Standardeinstellungen wiederherstellen",
"act" => "Aktion",
"Assign module" => "Modul zuweisen",
"top" => "Top",
"Folders" => "Ordner",
"Folder in" => "Ordner in",
"Remove Folder" => "Ordner löschen",
"Refresh Cache" => "Cache aktualisieren",
"Admin folders and bookmarks" => "Ordner und Lesezeichen verwalten",
"a folder" => "eines Ordners",
"a bookmark" => "eines Bookmarks",
"User Contacts Preferences" => "Einstellungen Benutzerkontakte",
"Manage Fields" => "Felder verwalten",
"Send me a message" => "Schick mir eine Nachricht",
"Basic Data" => "Allgemeine Daten",
"Assign Group" => "Gruppe zuweisen",
"Change user preferences" => "Ändere Benutzereinstellungen",
"(non public)" => "(nicht öffentlich)",
"Users HomePage" => "Benutzer Homepage",
"Personal Wiki Page" => "Private Wiki-Seite",
"Request friendship from this user" => "Diesen Benutzer um Freundschaft bitten",
"User Contribution" => "Benutzerbeiträge",
"has contributed to the following content" => "hat folgende Inhalte beigetragen",
"Forum comments" => "Forenkommentare",
"Who Looks At Stuff?" => "Wer sieht meine Beiträge an?",
"Who Looks At Your Stuff?" => "Wer sieht meine Beiträge an?",
"Send Me A Message" => "Eine Nachricht schicken",
"Send me a message !" => "Schick' mir eine Nachricht!",
"The following message will be sent to user" => "Die nachfolgende Nachricht wird geschickt an",
"Message Body" => "Nachricht",
"Personal Information" => "Persönliche Informationen",
"Male" => "männlich",
"Female" => "weiblich",
"Use Google Map locator" => "Google Map Locator benutzen",
"Is email public? (uses scrambling to prevent spam)" => "Emailadresse öffentlich? (es wird Verschlüsselung gegen Spam benutzt)",
"Unavailable - please set your e-mail below" => "Nicht verfügbar - bitte zuerst Emailadresse eingeben",
"Does your mail reader need a special charset" => "Benötigt der Mailreader einen speziellen Zeichensatz?",
"Preferred language:" => "Bevorzugte Sprache:",
"Can you read more languages?" => "Verstehst Du auch andere Sprachen?",
"Other languages you can read (select on the left to add to the list on the right):" => "Andere Sprachen, die Du lesen kannst (Selektiere aus der linken Liste, füge sie der rechten Liste hinzu):",
"Select language..." => "Wähle Sprache...",
"Detect user timezone if browser allows, otherwise site default" => "Versuche Zeitzone zu erkennen, ansonsten Site-Default benutzen",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "Bei MouseOver über Benutzername: Infofenster zu Benutzer anzeigen (sofern dieser das erlaubt)",
"Longitude:" => "Längengrad:",
"Latitude:" => "Breitengrad:",
"Map zoom:" => "Kartenzoom:",
"Notify sender when reading his mail" => "Lesebestätigung an den Autor einer Nachricht übermitteln",
"Auto-archive read messages after x days" => "Gelesene Nachrichten nach x Tagen automatisch archivieren",
"never" => "niemals",
"My user items" => "Meine Benutzer-Objekte",
"My level" => "Mein Level",
"Account Information" => "Kontoinformationen",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Felder \"Neues Passwort\" und \"Passwort bestätigen\" frei lassen um das alte Passwort zu behalten",
"Account Deletion" => "Konto löschen",
"Check this box if you really want to delete the account" => "Setze den Haken, wenn Du Dein Konto wirklich löschen willst",
"Delete the account:" => "Lösche das Konto:",
"Delete my account" => "Mein Konto löschen",
"New task" => "Neue Aufgabe",
"Task list" => "Aufgabenübersicht",
"Admin mode off" => "Verwaltungsmodus aus",
"Admin mode on" => "Verwaltungsmodus an",
"Task help" => "Hilfe",
"Empty Trash" => "Papierkorb löschen",
"Received task" => "Empfangene Aufgaben",
"You received this task, please read and execute it" => "Du hast diese Aufgabe erhalten. Bitte lese sie und führe sie aus",
"Send task" => "Sende Aufgaben",
"You send this task to a other user" => "Du hast die Aufgabe zu einem anderen Benutzer geschickt",
"Shared task" => "Geteilte Aufgaben",
"This task is public to a special group" => "Diese Aufgabe ist für eine spezielle Gruppe öffentlich",
"Task is accepted by user and creator" => "Die Aufgabe ist von einem anderen Benutzer und Ersteller akzeptiert",
"Task is rejected by one user" => "Die Aufgabe wurde von einem Benutzer abgelehnt",
"Task is not accepted by you, read the task and accept or reject it" => "Die Aufgabe wurde von Dir noch nicht akzeptiert. Lese die Aufgabe und akzeptiere ohne lehne ab",
"Task is not accepted/rejected by other user" => "Die Aufgabe wurde vom anderen Benutzer nicht akzeptiert/abgelehnt",
"Admin Mode" => "Verwaltungsmodus",
"Edit Task" => "Aufgabe bearbeiten",
"Remove from Trash" => "Aus dem Papierkorb",
"Move into Trash" => "In den Papierkorb",
"Task saved" => "Aufgabe gespeichert",
"View Task" => "Aufgabe ansehen",
"Open a new task" => "Neue Aufgabe hinzufügen",
"taskId" => "Aufgaben-Nummer",
"Task user" => "ist zu bearbeiten von",
"Only the creator can delete this task" => "Nur Ersteller kann die Aufgabe löschen",
"Use start date and time" => "Startdatum/-zeit benutzen",
"Use end date and time" => "Endedatum/-zeit benutzen",
"Open / In Process" => "Offen / in Bearbeitung",
"Waiting / Not Started" => "Wartend / noch nicht begonnen",
"Percentage completed" => "Prozent erledigt",
"Shared for Group" => "Wird geteilt von Gruppe",
"Accepted by User" => "Akzeptiert von Benutzer",
"No / Rejected" => "Nein / zurückgewiesen",
"Accepted by Creator" => "Vom Ersteller akzeptiert",
"Send message with changes" => "Nachricht mit Änderungen verschicken",
"Modified by" => "Geändert von",
"Inform task user by email" => "Bearbeiter per Email informieren",
"Completed" => "Erledigt",
"%m/%d/%Y [%H:%M]" => "%d.%m.%Y [%H:%M]",
"No tasks entered" => "Keine Aufgaben vorhanden",
"Select One" => "Status",
"Undo Trash" => "Aus Papierkorb",
"Show:" => "Anzeigen:",
"Received" => "Erhalten",
"Submitted" => "Zugewiesen",
"Shared" => "Geteilt",
"All Shared Tasks" => "Alle geteilten Aufgaben",
"completed (100%)" => "erledigt (100%)",
"User Watches and preferences" => "Benutzer-Beobachtungspunkte und Einstellungen",
"Report Preferences" => "Berichte Einstellungen",
"Use reports to summarise notifications about objects you are watching." => "Nutze Berichte um Benachrichtigungen in einer Email zusammenzufassen.",
"Use reports" => "Berichte nutzen",
"Interval in which you want to get the reports" => "Intervall in dem Du Berichte erhalten möchtest",
"Monthly" => "monatlich",
"Short report" => "Kurzer Bericht",
"Detailed report" => "Detaillierter Bericht",
"HTML-Email" => "HTML Email",
"Send me an email also if nothing happened" => "Schicke mir eine Email, auch wenn nichts passiert ist",
"My watches" => "Meine Beobachtungspunkte",
"Use \"watches\" to monitor wiki pages or other objects." => "Benutze \"Beobachtungspunkte\" um Wikiseiten oder andere Objekte zu überwachen.",
"Add Watch" => "Beobachtungspunkt hinzufügen",
"Select event type" => "Ereignis auswählen",
"All watched events" => "Alle beobachteten Ereignisse",
"A user submits an article" => "Ein Benutzer reicht einen Artikel ein",
"A user submits a blog post" => "Ein Benutzer reicht einen Blogeintrag ein",
"A user edited a wiki page" => "Jemand hat eine Wikiseite bearbeitet",
"A user edits an article" => "Benutzer bearbeitet einen Artikel",
"A user deletes an article" => "Benutzer löscht einen Artikel",
"Category change in a language" => "Kategorieänderung in einer Sprache",
"Used space:" => "Benutzter Speicher:",
"up to" => "bis zu",
"May need to refresh twice to see changes" => "Evtl. zweimal Refresh nötig, damit die Änderungen sichtbar werden",
"Add top level bookmarks to menu" => "Lesezeichen der obersten Ebene ins Menü übernehmen",
"Add or edit an item" => "Eintrag hinzufügen/bearbeiten",
"New Window" => "Neues Fenster",
"replace window" => "Fenster ersetzen",
"User_versions_for" => "Benutzer_Versionen_für",
"No articles yet." => "Noch keine Artikel.",
"Add an article" => "Artikel hinzufügen",
"Banner stats" => "Banner-Statistik",
"Create new banner" => "Neues Banner erzeugen",
"Banner Information" => "Banner-Information",
"Click ratio" => "Click-Ratio",
"Weekdays" => "Wochentage",
"mon" => "Mo",
"tue" => "Di",
"wed" => "Mi",
"thu" => "Do",
"fri" => "Fr",
"sat" => "Sa",
"sun" => "So",
"Banner raw data" => "Banner Rohdaten",
"Edit Blog" => "Blog bearbeiten",
"Monitor this Blog" => "Diesen Blog beobachten",
"Stop Monitoring this Blog" => "Diesen Blog nicht mehr beobachten",
"Cached" => "gecached",
"This is a cached version of the page." => "Dies ist eine gecachte Version der Seite.",
"Click here to view the Google cache of the page instead." => "Zum Betrachten der Seite im Google-Cache hier klicken.",
"Answers" => "Antworten",
"Add Suggestion" => "Vorschlag hinzufügen",
"Forum List" => "Forenliste",
"Edit Forum" => "Forum bearbeiten",
"Monitor Topics of this Forum" => "Themen dieses Forums beobachten",
"Monitor Topics and Threads of this Forum" => "Themen und Threads dieses Forums beobachten",
"Group Monitor Topics of this Forum" => "Gruppenbeobachtung für Themen dieses Forums",
"Group Monitor Topics and Threads of this Forum" => "Gruppenbeobachtung für Themen und Threads dieses Forums",
"Post New" => "Neuen Beitrag erstellen",
"Summary" => "Zusammenfassung",
"Watch for replies" => "Antworten beobachten",
"Send me an e-mail when someone replies to my topic" => "Antworten per Email an mich verschicken",
"Don't send me any e-mails" => "keine Emails an mich verschicken",
"for links" => "für Links",
"HTML tags are not allowed inside posts" => "HTML-Tags sind in Posts nicht erlaubt",
"Moderator Actions" => "Moderator-Aktionen",
"Move Selected Topics" => "Ausgewählte Themen verschieben",
"Unlock Selected Topics" => "Ausgewählte Themen entsperren",
"Lock Selected Topics" => "Ausgewählte Themen sperren",
"Delete Selected Topics" => "Ausgewählte Themen löschen",
"Merge" => "Zusammenführen",
"Merge Selected Topics" => "Ausgewählte Themen zusammenführen",
"Reported Messages:" => "Gemeldete Nachrichten:",
"Queued Messages:" => "Aufgelaufene Nachrichten:",
"Emot" => "Stimmung",
"pts" => "Punkte",
"No topics yet" => "Noch keine Themen",
"posts in this forum" => "Beiträge in diesem Forum",
"Filter Posts" => "Beiträge filtern",
"Posts Filtering" => "Beitrags-Filter",
"Last post date" => "Beitrags-Alter",
"All posts" => "alle Beiträge",
"Last hour" => "Letzte Stunde",
"Last 24 hours" => "Letzte 24 Stunden",
"Last 48 hours" => "Letzte 48 Stunden",
"Containing posts by" => "Beiträge von",
"Me" => "meine Beiträge",
"announce" => "Ankündigung",
"hot" => "heißes Thema",
"Posts with no replies" => "ohne Antworten",
"Topic List" => "Themenliste",
"prev topic" => "vorheriges Thema",
"next topic" => "nächstes Thema",
"Show posts" => "Zeige Beiträge",
"Jump to forum" => "Sprung in Forum",
"Monitor" => "Überwachen",
"Insert New Item" => "Neuen Eintrag hinzufügen",
"Edit Fields" => "Felder bearbeiten",
"Tracker Items" => "Trackerobjekte",
"Items found:" => "Gefundene Objekte: ",
"atts" => "Anhänge",
"List Attachments" => "Anhänge auflisten",
"View inserted item" => "eingefügten Eintrag anschauen",
"Insert new item" => "Neuen Eintrag hinzufügen",
"View Item" => "Eintrag ansehen",
"Filter Tracker Items" => "Tracker-Einträge filtern",
"Add a Comment" => "Kommentar hinzufügen",
"Edit/Delete" => "bearbeiten/löschen",
"Back to Items list" => "zurück zur Liste",
"close" => "schließ",
"Incoming servers (used in this order)" => "Posteingangsserver (in dieser Reihenfolge benutzt)",
"Mbox filepath" => "Mbox Dateipfad",
"Maildir mail directory" => "Maildir Nachrichten Verzeichnis",
"Outgoing server" => "Postausgangsserver",
"From email" => "Von Email",
"Uses current in preferences if empty" => "Benutzt aktuelle Eingangs Einstellungen, falls leer",
"Account details" => "Kontodetails",
"Group (shared mail inbox) or private" => "Gruppe (gemeinsamer Breifkasten) oder privat",
"Auto-refresh page time" => "Aktualisierung",
"Show All" => "Zeige alle",
"Show Unread" => "Zeige Ungelesene",
"Show Flagged" => "Zeige Gekennzeichnete",
"Back To Mailbox" => "Zurück zum Briefkasten",
"Full Headers" => "Alle Header",
"Normal Headers" => "Normale Header",
"Reply To All" => "allen antworten",
"Forward" => "weiterleiten",
"Select from address book" => "Aus Adressbuch auswählen",
"Use HTML mail" => "HTML-Mail verwenden",
"The following addresses are not in your address book" => "Die folgenden Adressen sind nicht in Deinem Adressbuch",
"Add Contacts" => "Kontakte hinzufügen",
"Attachment 1" => "Anlage 1",
"Attachment 2" => "Anlage 2",
"Attachment 3" => "Anlage 3",
"Address book" => "Adressbuch",
"Child" => "neue Unterseite",
"page id" => "Seiten-ID",
"View edit icons" => "Bearbeiten Symbole sichtbar",
"3d browser" => "3D-Browser",
"Page is NOT being monitored. Click icon to START monitoring." => "Diese Seite wird NICHT beobachtet. Klicke auf das Symbol um die Beobachtung zu STARTEN.",
"Page IS being monitored. Click icon to STOP monitoring." => "Diese Seite WIRD beobachtet. Klicke auf das Symbol um dies zu STOPPEN.",
"Zoom" => "Zoomen",
"Message sent to" => "Nachricht gesandt an",
"Page last modified on %0 by %1" => "Seite zuletzt geändert: am %0 von <span class='link'><span class='link'>%1</span></span>",
"Last Modification: %0 by %1" => "Letzte Änderung: %0 by %1",
"as Creator &amp; Last Editor" => "als Ersteller &amp; letzter Bearbeiter",
"no (disabled)" => "keine (deaktiviert)",
"Save Minor Edit" => "Änderung als geringfügig speichern",
"%0 enabled" => "%0 aktiviert",
"%0 disabled" => "%0 deaktiviert",
"Administration" => "Verwaltung",
"Enable/disable Tiki features here, but configure them elsewhere" => "Tiki-Features hier ein/ausschalten, konfiguriert werden sie dann an anderen Stellen.",
"General preferences and settings" => "Allgemeine Einstellungen",
"User registration, login and authentication" => "Benutzer-Registrierung, Login und Authentifizierung",
"Wiki settings" => "Wiki-Einstellungen",
"Article/CMS settings" => "Artikel Konfiguration",
"Poll comments settings" => "Einstellungen Abstimmungskommentare",
"Configuration options for all blogs on your site" => "Globale Blog-Einstellungen",
"Forums settings" => "Foreneinstellungen",
"FAQ comments settings" => "FAQ Kommentar-Einstellungen",
"Trackers settings" => "Tracker Konfiguration",
"Directory settings" => "Linkverzeichnis Konfiguration",
"Maps configuration" => "Karten Konfiguration",
"Meta Tags settings" => "Meta-Tag Konfiguration",
"Search settings" => "Suche-Einstellungen",
"Score settings" => "Bewertung Konfiguration",
"Community settings" => "Community Einstellungen",
"Calendar settings" => "Kalender Einstellungen",
"Upload failed" => "Hochladen fehlgeschlagen",
"All posted" => "keine Nachricht",
"Queue anonymous posts" => "anonyme Nachrichten",
"Queue all posts" => "alle Nachrichten",
"No attachments" => "keine Anhänge",
"Everybody can attach" => "jeder darf Dateien anhängen",
"Only users with attach permission" => "nur Benutzer mit Anhangserlaubnis",
"Moderators and admin can attach" => "nur Moderatoren und Admins",
"No display" => "keine",
"Date (desc)" => "Datum (absteigend)",
"Date (asc)" => "Datum (aufsteigend)",
"Score (desc)" => "Bewertung (absteigend)",
"Replies (desc)" => "Antworten (absteigend)",
"Reads (desc)" => "Zugriffe (absteigend)",
"Owner" => "Besitzer",
"Detected, Version:" => "Gefunden, Version:",
"Not detected." => "Nicht gefunden.",
"All Fields except gdaltindex must be filled" => "Alle Felder außer gdaltindex müssen ausgefüllt werden",
"Tag already exists" => "Marke existiert bereits",
"Tag not found" => "Marke nicht gefunden",
"Repository name can't be an empty" => "Repository-Name muß angegeben werden",
"No repository" => "Kein Repository",
"Search is mandatory field" => "Suche ist ein erforderliches Feld",
"File not found " => "Datei nicht gefunden ",
"Non-existent link" => "Nicht existierender Link",
"Mail-in account %s incorrect" => "Mail-in Konto %s fehlerhaft",
"Mail-in account %s saved" => "Mail-in Konto %s gespeichert",
"No menu indicated" => "Kein Menü angegeben",
"No newsletter indicated" => "Kein Rundbrief angegeben",
"A user registers" => "Ein Benutzer registriert sich",
"Any wiki page is changed" => "Eine Wiki-Seite hat sich geändert",
"Any wiki page is changed, even minor changes" => "Eine Wiki-Seite hat sich geändert, auch kleine Änderungen",
"A comment in a wiki page is posted or edited" => "Kommentar zu einer Wikiseite wird erstellt oder geändert",
"PHP error" => "PHP Fehler",
"No poll indicated" => "Keine Abstimmung angegeben",
"unsafe" => "unsicher",
"register_globals should be off by default. See the php manual for details." => "register_globals sollte ausgeschaltet sein. Details bitte der PHP Anleitung entnehmen.",
"safe" => "sicher",
"risky" => "gefährlich",
"session.use_trans_sid should be off by default. See the php manual for details." => "session.use_trans_sid sollte ausgeschaltet sein. Details bitte der PHP Anleitung entnehmen.",
"upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir liegt vermutlich innerhalb des Tiki Verzeichnisses. Es besteht das Risiko, dass jemand dorthin Dateien läd und versucht, sie dort auszuführen.",
"cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config." => "Kann nicht überprüfen, ob upload_tmp_dir per Browser lesbar ist. Bitte die Webservereinstellungen überprüfen.",
"setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them" => "Setzen der xbithack Option ist unsicher. Abhängig vom Dateihandling des Webservers und der Tiki-Einstellungen ist es unter Umständen möglich, dass jemand Scripte ins Dateiarchiv hochläd und dort ausführt.",
"allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off." => "allow_url_fopen kann benutzt werden, um schadhafte Skripts hoch zu laden. Wenn Du die Blog Funktion nicht benutzt, kann es deaktiviert werden.",
"The Path to store files in the filegallery should be outside the tiki root directory" => "Der Pfad des Dateiarchivs sollte außerhalb des Tiki-Verzeichnisses liegen.",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "Der Pfad der Bildergalerien sollte außerhalb des Tiki-Verzeichnisses liegen.",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "Die Funktion \"Vorlagen bearbeiten\" ist aktiviert. Du solltest niemandem erlauben, diese Funktion zu nutzen, dem Du nicht traust. Sie kann verwendet werden um schadhaften Code einzuschleusen.",
"The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)." => "Das \"Modul Wikiplugin\" ist aktiviert. Es kann von Wikieditoren genutzt werden um Module hinzuzufügen, die Zugriff auf Informationen erlauben (siehe Modulliste)",
"File is not readable. Unable to check." => "Diese Datei ist lesegeschützt und konnte nicht überprüft werden.",
"You have to provide a word" => "Es muß ein Wort angegeben werden",
"You do not have permission to view this page." => "Zugriff verweigert. Du kannst diese Seite nicht betrachten.",
"You do not have permission to edit this page." => "Zugriff verweigert. Du kannst diese Seite nicht bearbeiten",
"You must specify a page name, it will be created if it doesn't exist." => "Ein Seitenname muß angegeben werden. Die Seite wird neu angelegt, wenn sie noch nicht vorhanden ist",
"page not added (Exists)" => "Seite nicht hinzugefügt (existiert schon)",
"No survey indicated" => "Keine Umfrage angegeben",
"No tracker indicated" => "Kein Tracker angegeben",
"You don't have permission to use this feature" => "Keine Berechtigung zur Nutzung dieses Features",
"Group already exists" => "Gruppe existiert bereits",
"User doesn't exist" => "Benutzer existiert nicht",
"Are you sure you want to add this new user?" => "Bist Du sicher, dass der neue Benutzer hinzugefügt werden soll?",
"No records were found. Check the file please!" => "Keine Einträge gefunden. Bitte die Datei überprüfen!",
"User login is required" => "Benutzerlogin ist erforderlich",
"Email is required" => "Email ist erforderlich",
"User is duplicated" => "Benutzer ist erforderlich",
"Created account %s <%s>" => "Konto %s <%s> angelegt",
"Assigned %s in group %s" => "%s zu Gruppe %s hinzugefügt",
"The passwords do not match" => "Die Passwörter stimmen nicht überein",
"User %s already exists" => "Benutzer %s schon vorhanden",
"New %s created with %s %s." => "%s neu erstellt mit %s %s.",
"%s %s successfully deleted." => "%s %s erfolgreich gelöscht.",
"%s %s removed from %s %s." => "%s %s wurde aus %s %s entfernt.",
"%s changed from %s to %s" => "%s geändert von %s auf %s",
"Impossible to change %s from %s to %s" => "Nicht möglich zu ändern %s von %s zu %s",
"%s modified successfully." => "%s erfolgreich geändert.",
"password" => "Passwort",
"%s modification failed." => "%s Änderung fehlgeschlagen.",
"Please go back and try again" => "Bitte gehe zurück und versuche es erneut",
"rss feed disabled" => "RSS Feed nicht aktiv",
"Unknown group" => "Unbekannte Gruppe",
"Group doesn't exist" => "Gruppe existiert nicht",
"The page cannot be found" => "Die Seite kann nicht gefunden werden",
"Image Galleries Admin Panel" => "Bildergalerien-Adminseite",
"Could not read image %s." => "Konnte Bilddatei %s nicht lesen.",
"Incorrect directory chosen for batch upload of images." => "Kein gültiges Bilder-Uploadverzeichnis ausgewählt.",
"Please setup that dir on " => "Bitte dieses Verzeichnis einstellen auf der ",
"Invalid directory name" => "Ungültiger Verzeichnisname",
"File Galleries Admin Panel" => "Dateiarchiv-Adminseite",
"Could not read file %s." => "Konnte Datei %s nicht lesen.",
"Could not write to file %s." => "Konnte die Datei %s nicht schreiben.",
"File %s upload failed." => "Hochladen der Datei %s fehlgeschalgen.",
"File %s removed from Batch directory." => "Datei %s wurde aus dem Batchupload-Verzeichnis gelöscht.",
"Impossible to remove file %s from Batch directory." => "Konnt Datei %s nicht aus dem Batchupload-Verzeichnis löschen.",
"Incorrect directory chosen for batch upload of files." => "Kein gültiges Datei-Uploadverzeichnis ausgewählt.",
"It isn't possible to post in any blog. You may need to create a blog first." => "Du kannst in keinen Blog posten. Möglicherweise musst Du zuerst ein Blog anlegen.",
"You do not have permission to edit this post" => "Zugriff verweigert. Du kannst diesen Eintrag nicht bearbeiten",
"Top visited blogs" => "Meistbesuchte Blogs",
"Last posts" => "neueste Beiträge",
"Top active blogs" => "aktivste Blogs",
"No blogId specified" => "Keine blogId angegeben",
"Watch this category" => "Beobachte diese Kategorie",
"Nothing tagged yet" => "Noch nichts getagged",
"You must clear your browser cache." => "Du musst Deinen Browser-Cache leeren.",
"You do not have permission to access this gallery" => "Zugriff verweigert. Du kannst auf diese Galerie nicht zugreifen.",
"No gallery indicated" => "Keine Galerie angegeben",
"You do not have permission to remove images from this gallery" => "Zugriff verweigert. Du kannst keine Bilder aus dieser Galerie entfernen",
"You do not have permission to rebuild thumbnails in this gallery" => "Neuerstellung der Thumbnails in dieser Galerie nicht gestattet",
"You do not have permission to rotate images in this gallery" => "Rotation der Bilder in dieser Galerie nicht gestattet",
"No image indicated" => "Kein Bild angegeben",
"picture not found" => "Bild nicht gefunden",
"You do not have permission to move images from this gallery" => "Zugriff verweigert. Du kannst keine Bilder aus dieser Galerie verschieben",
"You do not have permission to view the calendar" => "Berechtigung für den Zugriff auf den Kalender nicht vorhanden",
"event without name" => "Ereignis ohne Name",
"You do not have permission to view this page" => "Du hast nicht die notwendigen Rechte um diese Seite anzuzeigen",
"You can not use the same password again" => "Dasselbe Passwort noch einmal ist nicht erlaubt",
"Invalid old password" => "Ungültiges altes Passwort",
"Top authors" => "Top Autoren",
"Must enter a name to add a site. " => "Ein Seitenname muß angegeben werden. ",
"Must enter a url to add a site. " => "Eine URL muß angegeben werden. ",
"URL already added to the directory. Duplicate site? " => "URL schon im Verzeichnis vorhanden. Doppelter Eintrag? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "Auf die URL kann nicht zugegriffen werden: fehlerhafte URL oder die Site ist nicht verfügbar und kann daher nicht zum Linkverzeichnis hinzugefügt werden. ",
"Must select a category. " => "Eine Kategorie muß ausgewählt werden. ",
"Must enter a name to add a site" => "Zum Hinzufügen mu&szlig der Name der Site angegeben werden",
"Must enter a url to add a site" => "Die URL der Site muß angegeben werden",
"URL already added to the directory. Duplicate site?" => "URL im Verzeichnis schon vorhanden. Doppelter Eintrag?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "Auf die URL kann nicht zugegriffen werden: fehlerhafte URL oder die Site ist nicht verfügbar und kann daher nicht zum Linkverzeichnis hinzugefügt werden",
"Must select a category" => "Eine Kategorie muß ausgewählt werden",
"No site indicated" => "Kein Site angegeben",
"Article not found" => "Artikel nicht gefunden",
"You do not have permission to edit this article" => "Zugriff verweigert. Du kannst diesen Artikel nicht bearbeiten",
"Banner not found" => "Banner nicht gefunden",
"You do not have permission to edit this banner" => "Du hast keine Berechtigung dieses Banner zu bearbeiten",
"You do not have permission to edit this blog" => "Zugriff verweigert.Du kannst diesen Blog nicht bearbeiten",
"You do not have permission to write the style sheet" => "Berechtigung zum Verändern des Stylesheets nicht vorhanden",
"Invalid request to edit an image" => "Ungültige Anforderung zur Bearbeitung eines Bildes",
"You have permission to edit images but not in this gallery" => "Zugriff verweigert. Du kannst Bilder bearbeiten, jedoch nicht in dieser Galerie",
"Failed to edit the image" => "Bearbeitung des Bildes fehlgeschlagen",
"No content id indicated" => "Keine Inhalts-ID angegeben",
"No question indicated" => "Keine Frage angegeben",
"No quiz indicated" => "Kein Quiz angegeben",
"No structure indicated" => "Keine Struktur angegeben",
"You do not have permission to edit submissions" => "Zugriff verweigert. Du kannst Einreichungen nicht bearbeiten",
"You have to create a topic first" => "Du musst zuerst ein Thema erstellen",
"You do not have permission to do that" => "Du hast nicht die Berechtigung, das zu tun",
"You do not have permission to read the template" => "Du hast keine Berechtigung, die Vorlage zu lesen",
"No topic id specified" => "Keine Themen-ID angegeben",
"Invalid topic id specified" => "Ungültige Themen-ID angegeben",
"No object indicated" => "Kein Objekt angegeben",
"No type indicated" => "Kein Typ angegeben",
"page imported" => "Seite importiert",
"created from import" => "aus Import erstellt",
"Describe the change you made" => "Kurze Beschreibung Deiner Änderungen",
"Can't import remote HTML page" => "Kann externe HTML-Seite nicht importieren",
"The SandBox is disabled" => "Die SandBox ist deaktiviert",
"Cannot edit page because it is locked" => "Seite kann wegen Sperrung nicht bearbeitet werden",
"You do not have permission to edit this file" => "Berechtigung zum Bearbeiten dieser Datei nicht vorhanden",
"You do not have permission to remove files from this gallery" => "Zugriff Verweigert. Du kannst keine Dateien aus dieser Galerie entfernen",
"Top visited file galleries" => "Meistbesuchte Dateiarchive",
"Most downloaded files" => "Häufigste Downloads",
"Last files" => "Neueste Dateien",
"No galleryId specified" => "Keine galleryId angegeben.",
"No forum indicated" => "Kein Forum angegeben",
"Last forum topics" => "Neueste Forenthemen",
"Top topics" => "Top Themen",
"Forum posts" => "Zahl der Einträge",
"No forumId specified" => "Keine forumId angegeben",
"Accepted friendship request from %s" => "akzeptiert Bitte zur Freundschaft von %s",
"id" => "ID",
"first uploaded image" => "erstes hochgeladenes Bild",
"last uploaded image" => "neustes Bild",
"first image" => "erstes Bild",
"last image" => "neuestes Bild",
"random image" => "zufälliges Bild",
"You do not have permission to create galleries and so you cannot edit them" => "Zugriff verweigert. Du kannst Galerien nicht erzeugen, also auch nicht bearbeiten",
"You do not have permission to edit this gallery" => "Zugriff verweigert. Du kannst diese Galerie nicht bearbeiten",
"You do not have permission to remove this gallery" => "Zugriff verweigert. Du kannst diese Galerie nicht löschen",
"Top images" => "Top Bilder",
"Last images" => "Neueste Bilder",
"overwriting old page" => "überschreibe alte Seite",
"page created" => "Seite erstellt",
"No name indicated for wiki page" => "Kein Name für die Wiki-Seite angegeben",
"No repository given" => "Kein Repository angegeben",
"You do not have permission to remove articles" => "Zugriff verweigert. Du kannst Artikel nicht entfernen",
"You do not have permission to remove banners" => "Zugriff verweigert. Du kannst keine Banner entfernen",
"You do not have permission to remove this blog" => "Zugriff verweigert. Du kannst diesen Blog nicht entfernen",
"Delete comments" => "Kommentare löschen",
"Non-existent gallery" => "Nicht existierende Galerie",
"Remove file: " => "Datei löschen:",
"You have permission to upload files but not to this file gallery" => "Zugriff verweigert. Du kannst Dateien hochladen, jedoch nicht in dieses Archiv",
"Could not upload the file" => "Konntr Datei nicht hochladen",
"Could not find the file requested" => "Konnte die angegebene Datei nicht finden",
"Upload was not successful. Duplicate file content" => "Hochladen war nicht erfolgreich. Doppelter Dateiinhalt",
"File update was successful" => "Datei erfolgreich aktualisiert",
"Not modified since" => "Nicht verändert seit",
"Not downloaded since" => "nicht heruntergeladen seit",
"You do not have permission to upload files so you cannot edit them" => "Berechtigung zum Hochladen und damit auch zum Ändern nicht vorhanden",
"This gallery does not exist" => "Diese Galerie ist nicht vorhanden",
"You have to enable cookies to be able to login to this site" => "Aktiviere 'Cookies akzeptieren' um Dich einloggen zu können",
"Sorry, you can't use this feature." => "Keine Berechtigung zur Nutzung dieser Funktion",
"You must first setup MapServer" => "Du musst zuerst den MapServer konfigurieren",
"edit" => "bearbeiten",
"mapfile name incorrect" => "Name der Kartendatei nicht korrekt",
"This mapfile already exists" => "Diese Kartendatei existiert schon",
"You do not have permission to write to the mapfile" => "Keine Berechtigung zum Schreiben von Kartendateien",
"You do not have permission to delete the mapfile" => "Keine Berechtigung zum Löschen der Kartendatei",
"I could not make a copy" => "Es konnte keine Kopie erstellt werden",
"You do not have permission to read the mapfile" => "Keine Berechtigung zum Lesen der Kartendatei",
"You dont have permission to do that" => "Keine Berechtigung vorhanden",
"Tiki RSS feed for maps" => "Tiki RSS Karten Feed",
"List of maps available." => "Neueste Karten.",
"File not found" => "Datei nicht gefunden",
"The Directory is not empty" => "Das Verzeichnis ist nicht leer",
"Invalid file name" => "Ungültiger Dateiname",
"Invalid files to index" => "Üngültige Seiten, die indiziert werden sollen",
"I could not create the index file" => "Indexdatei konnte nicht angelegt werden",
"Welcome at Hawiki" => "Willkommen bei Hawiki",
"About" => "Über",
"Your PHP installation does not have zlib enabled." => "Die PHP Installation enthält keine zlib Bibliothek.",
"You must log in to use this feature" => "Du musst Dich anmelden, um diese Funktion zu nutzen",
"You do not have permission to view other users data" => "Du hast keine Berechtigung, die Daten anderer Benutzer einzusehen",
"You must be logged in to subscribe to newsletters" => "Du musst eingeloggt sein, um Rundbriefe abonnieren zu können",
"No note indicated" => "Keine Notiz angegeben",
"File is too big" => "Datei ist zu groß",
"No item indicated" => "Kein Objekt angegeben",
"created from notepad" => "Aus dem Notitzblock erstellt",
"Page already exists" => "Seite existiert schon",
"Not enough information to display this page" => "Nicht genug Informationen, um diese Seite anzuzeigen",
"Object Permissions" => "Objektberechtigungen",
"No article indicated" => "Kein Artikel angegeben",
"Article is not published yet" => "Artikel ist noch nicht veröffentlicht",
"No post indicated" => "Kein Posting angegeben",
"Blog not found" => "Blog nicht gefunden",
"No pages indicated" => "Keine Seiten angegeben",
"No result indicated" => "Kein Ergebnis angegeben",
"Invalid or unknown username" => "Ungültiger oder unbekannter Benutzername",
"to the registered email address for" => "an die registrierte Emailadresse für",
"last version" => "neueste Version",
"Non-existent version" => "Nicht existierende Version",
"Tiki RSS Feed Error Message: \$errmsg" => "Tiki RSS Feed Fehlermeldung: \$errmsg",
"No newsletters available." => "Keine Rundbriefe vorhanden.",
"successfully sent" => "erfolgreich verschickt",
"not sent" => "nicht verschickt",
"Error: " => "Fehler: ",
"You do not have permission to edit messages \$owner" => "Du hast keine Berechtigung, diese Nachrichten zu bearbeiten \$owner",
"Page must be defined inside a structure to use this feature" => "Für diese Funktion muss die Seite innerhalb einer Struktur angelegt werden",
"You cannot take this quiz twice" => "Du kannst dieses Quiz nicht zweimal durchführen",
"Quiz time limit exceeded quiz cannot be computed" => "Quizzeit überschritten. Quiz kann nicht gewertet werden",
"You cannot take this survey twice" => "Du kannst nicht zweimal an dieser Umfrage teilnehmen",
"Please create a category first" => "Bitte erst eine Kategorie anlegen",
"No permission to upload zipped file packages" => "Berechtigung zum Hochladen gepackter Dateien nicht vorhanden",
"Error processing zipped image package" => "Fehler beim Verarbeiten der gepackten Bilddateien",
"No permission to upload zipped image packages" => "Berechtigung zum Hochladen gepackter Bildarchive nicht vorhanden",
"The uploaded file ist not recognized as a image" => "Die hochgeladene Datei konnte nicht als Bild identifiziert werden",
"You do not have permission to upload images" => "Zugriff verweigert. Du kannst keine Bilder hochladen",
"You have permission to upload images but not to this gallery" => "Zugriff verweigert. Du kannst Bilder hochladen, aber nicht in diese Galerie",
"Cannot get image from URL" => "Kann Bild nicht von URL beziehen",
"That is not an image (or you have php < 4.0.5)" => "Dies ist kein Bild (oder die PHP Version ist kleiner als 4.0.5)",
"Usage" => "Zugriffe",
"No url indicated" => "Keine URL angegeben",
"Unknown user" => "Unbekannter Benutzer",
"Email is set to %s" => "Emailadresse ist jetzt %s",
"The passwords did not match" => "Die Passwörter stimmen nicht überein",
"no" => "nein",
"unicode" => "Unicode",
"open / in process" => "offen / in Bearbeitung",
"Changes:" => "Änderungen:",
"Info message" => "Benachrichtigung",
"NEW Task" => "Neue Aufgabe",
"Changes on Task" => "Änderungen an Aufgabe",
"You received a new task" => "Neue Aufgabe erhalten",
"The priority is" => "Die Priorität ist",
"very low" => "sehr niedrig",
"high" => "hoch",
"very high" => "sehr hoch",
"A new page is created in a language" => "Eine neue Seite (Übersetzung) wird erstellt",
"Cannot upload this file not enough quota" => "Hochladen würde Kontingent überschreiten",
"No user indicated" => "Kein Benutzer angegeben",
"Non-existent user" => "Nicht existierender Benutzer",
"No banner indicated" => "Kein Banner angegeben",
"No blog indicated" => "Kein Blog angegeben",
"No cache information available" => "Keine Cache-Informationen verfügbar",
"No faq indicated" => "Keine FAQ angegeben",
"You are not permitted to remove someone else\\'s post!" => "Keine Erlaubnis zum Löschen von Beiträgen anderer Benutzer!",
"No thread indicated" => "Kein Thread angegeben",
"Aborted" => "Abgebrochen",
"Top pages" => "Top-Seiten",
"Last pages" => "Letzte Seiten",
"You do not have permissions to view the maps" => "Keine Berechtigung zum Betrachten von Karten",
"###end###"=>"###end###");
