<?php // -*- coding:utf-8 -*-
// (c) Copyright 2002-2010 by authors of the Tiki Wiki/CMS/Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.
// $Id: get_strings.php 43650 2012-10-24 16:09:26Z changi67 $
// Parameters:

// lang=xx    : only translates language 'xx',
//              if not given all languages are translated

// comments   : generate all comments (equal to close&module)

// close      : look for similar strings that are already translated and
//              generate a comment if a 'match' is made

// module     : generate comments that describe in which .php and/or .tpl
//              module(s) a certain string was found (useful for checking
//              translations in context)

// patch      : looks for the file 'language.patch' in the same directory
//              as the corresponding language.php and overrides any strings
//              in language.php - good if a user does not agree with
//              some translations or if only changes are sent to the maintainer

// spelling   : generates a file 'spellcheck_me.txt' that contains the
//              words used in the translation. It is then easy to check this
//              file for spelling errors (corrections must be done in
//              'language.php, however)

// groupwrite : Sets the generated files permissions to allow the generated
//              language.php also be group writable. This is good for
//              translators if they do not have root access to tiki but
//              are in the same group as the webserver. Please remember
//              to have write access removed when translation is finished
//              for security reasons. (Run script again without this
//              parameter)

// Examples:
// http://www.neonchart.com/get_strings.php?lang=sv
// Will translate language 'sv' and (almost) avoiding comment generation

// http://www.neonchart.com/get_strings.php?lang=sv&comments
// Will translate language 'sv' and generate all possible comments.
// This is the most usefull mode when working on a translation.

// http://www.neonchart.com/get_strings.php?lang=sv&nohelp&nosections
// These options will only provide the minimal amout of comments.
// Usefull mode when preparing a translation for distribution.

// http://www.neonchart.com/get_strings.php?nohelp&nosections
// Prepare all languages for release


// ### Note for translators about translation of text ending with punctuation
// ###
// ### The current list of concerned punctuation can be found in 'lib/init/tra.php'
// ### On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// ### For clarity, we explain here only for colons: ':' but it is the same for the rest
// ###
// ### Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// ###
// ### Technical justification:
// ### If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// ### then Tiki tries to translate 'Login' and ':' separately.
// ### This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// ### and it still allows to translate ":" as "&nbsp;:" for languages that
// ### need it (like french)

$lang=Array(
// ### Start of unused words
// ### Please remove manually!
// ### N.B. Legitimate strings may be marked// ### as unused!
// ### Please see http://tiki.org/UnusedWords for further info
"+1d" => "+1n",
"+1m" => "+1p",
"+7d" => "+7n",
"Add all your site users to this newsletter (broadcast)" => "Összes felhasználó hozzáadása a hírlevél előfizetéshez (broadcast)",
"Add or edit a task" => "Feladat hozzáadása/szerkesztése",
"Add scaled images size X x Y" => "X x Y méretű, méretarányos képek hozzáadása",
"All tasks" => "Minden feladat",
"assgn" => "csatol",
"ExtWikis" => "Külső Wikik",
"File gals" => "Fájlgalériák",
"forum topic" => "fórum téma",
"Image gals" => "Képgalériák",
"Import pages from a PHPWiki Dump" => "Lapok importálása a PHPWiki Dump-ból",
"mark as done" => "elvégzettként megjelöl",
"open tasks" => "feladatok megnyitása",
"Packages" => "Csomagok",
"Ranking" => "Rangsor",
"To create a new translation of a page that has never been translated before, create an initial version of the translation, select the translation language above, enter the page name of the original page below, and hit \"go\"." => "Ha egy új oldalt fordítok le, akkor először létrehozom a lefordított oldalt az eredeti alapján, beállítom a fordítás nyelvét az új oldalon, majd itt ezen az oldalon egymáshoz illesztem az az eredetit és az úja(ka)t egy fordítási halmazba",
"today" => "ma",
"v=view, b=rollback, c=compare with current, d=diff to current, s=source" => "v=megtekintés, b=visszatérés korábbihoz, c=összehasonlítás jelenlegivel, d=különbség a jelenlegihez képest, s=forrás",
"You do not have permission to use this feature." => "Nincs elegendő jogosultság a funkció használatához",
"no description" => "Nincs leírás",
"Updated" => "Frissítve",
"Tip: hold down CTRL to select multiple categories" => "Javaslat: a CTRL gomb megnyomásával egyszerre több kategória is kiválasztható",
"Click the :: option on the menu for more options." => "Kattints a menüpontok bal oldalán található szimbólumra, hogy lásd a további opciókat!",
"Please also see" => "Továbbá ajánljuk tekintsd meg a ",
"Admin->Modules" => "Admin->Modulok menüpontban",
"Jukebox" => "Zeneláda",
"Blog settings" => "Blog beállítások",
"FAQs settings" => "Gyakori kérdések beállításai",
"FAQ comments" => "Gyakori kérdések kommentjei",
"Remind passwords by email" => "Jelszóemlékeztető küldése E-mailben",
"Poll settings" => "Szavazás beállítások",
"Like pages" => "Hasonló oldalak",
"Added users" => "Hozzáadott felhasználók",
"search category" => "Kategória keresése",
"deep" => "mélyen",
"For more information, please see <a href=\"{\$helpurl}WikiSyntax\">WikiSyntax</a>" => "Bővebb leírásért lásd: <a href=\"{\$helpurl}WikiSyntax\">Wiki formázás</a>",
"Emphasis" => "Hangsúly",
"italics" => "dőlt",
"both" => "mindkettő",
"use ...page... to separate pages" => "egy oldalon belül különböző oldalak elválasztáshoz használjuk ezt:  ...page...",
"underlines text" => "aláhúzott szöveg",
"Wiki quick help" => "formázási tanácsok",
"Quicklinks" => "Gyorslinkek",
"Comparing versions" => "Verziók összehasonlítása",
"Actual_version" => "Jelenlegi verzió",
"Diff to version" => "Különbségek ehhez a verzióhoz képest",
"The passwords dont match" => "A megadott jelszavak nem egyeznek",
"You do not have permission to write the template" => "A sablon szerkesztéséhez több jogosultságra van szükség",
"Error: This page is being edited by another user." => "Hiba: az oldalt épp most szerkeszti egy másik felhasználó",
"Tiki RSS Feed Error Message" => "Tiki RSS feed hibaüzenet",
"Edit information" => "Információ szerkesztése",
"uploaded by" => "Feltöltötte:",
"not specified" => "nincs meghatározva",
"delete" => "törlöm",
"post" => "elküldöm",
"posts" => "üzenetek",
"visits" => "látogatások",
"show categories" => "kategóriák megjelenítése",
"author" => "szerző",
"user level" => "felhasználói szint",
"send email to user" => "E-mail küldése felhasználónak",
"score" => "pontszám",
"delete selected" => "kijelöltek törlése",
"move" => "mozgatás",
"Posted messages" => "Elküldött üzenetek",
"set" => "beállítás",
"replies" => "válasz",
"cancel" => "visszavonás",
"up" => "fel",
"down" => "le",
"add" => "hozzáadás",
"create" => "létrehozás",
"save" => "mentés",
"send" => "küldés",
"register" => "regisztráció",
"secure" => "biztonságos",
"stay in ssl mode" => "maradjon az SSL mód",
"go" => "indítás",
"cache" => "gyorsítótár",
"refresh" => "frissítés",
"print" => "nyomtatás",
"create pdf" => "pdf készítés",
"monitor this page" => "oldal figyelése",
"stop monitoring this page" => "oldal figyelésének felfüggesztése",
"backlinks" => "hivatkozások",
"rename" => "átnevezés",
"unlock" => "feloldás",
"lock" => "zárolás",
"perms" => "jogok",
"history" => "előzmények",
"similar" => "hasonló",
"undo" => "visszaállítás (undo)",
"slides" => "bemutató",
"export" => "exportálás",
"discuss" => "megbeszélés",
"add comment" => "komment hozzáfűzése",
"attach file" => "fájl csatolása",
"translation" => "fordítás",
"last modification" => "utolsó módosítás",
"attachments" => "mellékletek",
"stats" => "statisztika",
"last changes" => "legutóbbi változások",
"list pages" => "lapok listázása",
"cancel edit" => "szerkesztés visszavonása",
"view blog" => "blog megtekintése",
"list blogs" => "blogok listázása",
"save and exit" => "Mentés és kilépés",
"reads" => "olvasás",
"wiki help" => "wiki súgó",
"General preferences" => "általános beállításaim",
"Other preferences" => "További preferenciák",
"HomePage" => "Kezdőlap",
"images" => "képek",
"Server name (for absolute URIs)" => "Szerver név (Az abszolút URI-hoz)",
"Wiki_Tiki_Title" => "Wiki_Tiki_Név",
"path" => "útvonal",
"Require HTTP Basic authentication" => "Alapvető HTTP azonosítás igénylése",
"HTTP server name" => "HTTP szerver neve",
"HTTP URL prefix" => "HTTP URL előtag",
"HTTPS server name" => "HTTPS szerver neve",
"HTTPS URL prefix" => "HTTPS URL előtag",
"Only for users" => "Csak felhasználóknak",
"Users and admins" => "Felhasználók és adminisztrátorok",
"Full Text Search" => "Teljes szövegkeresés",
"Enable Feature" => "Funkció bekapcsolása",
"admin banning tpl" => "kitiltás sablon adminisztrálása",
"loc" => "hely",
"cat" => "kat",
"lang" => "nyelv",
"prio" => "font",
"permissions" => "jogosultságok",
"create new" => "új létrehozása",
"edit chart" => "slágerlista szerkesztése",
"update" => "frissítés",
"use in cms" => "használat cms-ben",
"use in wiki" => "használat wiki-ben",
"use in newsletters" => "használat hírlevélben",
"use in HTML pages" => "használat HTML oldalakon",
"last modif" => "utolsó módosítás",
"sections" => "szekciók",
"upload" => "feltöltés",
"topics" => "témák",
"age" => "kor",
"last post" => "legutóbbi poszt",
"position" => "helye",
"admin Webmail" => "Webmail adminisztrálása",
"section" => "szakasz",
"options" => "opciók",
"assign module" => "modul hozzárendelése",
"left modules" => "bal modulok",
"right modules" => "jobb modulok",
"edit/create" => "szerkesztés/létrehozás",
"clear cache" => "gyorsítótár törlése",
"assign" => "hozzárendelés",
"left" => "bal",
"right" => "jobb",
"order" => "sorrend",
"create/edit" => "létrehozás/szerkesztés",
"use poll" => "szavazás használata",
"use gallery" => "galéria használata",
"use dynamic  content" => "dinamikus tartalom használata",
"use rss module" => "rss modul használata",
"use menu" => "menü használata",
"use banner zone" => "banner zónák használata",
"list newsletters" => "hírlevél lista",
"admin newsletters" => "hírlevél karbantartás",
"send newsletters" => "hírlevelek küldése",
"editions" => "kiadások",
"last sent" => "utoljára elküldve",
"admin Email Notifications" => "E-mailes értesítések adminisztrálása",
"use admin email" => "adminisztrátori E-mail használata",
"event" => "esemény",
"admin polls" => "szavazások adminisztrálása",
"admin polls template" => "szavazások sablonjának adminisztrálása",
"export pages" => "oldalak exportálása",
"dump tree" => "oldalak fastruktúrájának lementése",
"create webhelp" => "webes súgó létrehozása",
"view webhelp" => "webes súgó megtekintése",
"tree" => "fa",
"create new structure" => "új struktúra létrehozása",
"survey stats" => "kérdőív statisztika",
"edit this survey" => "kérdőív szerkesztése",
"admin surveys" => "kérdőív adminisztrálása",
"list surveys" => "kérdőívek listázása",
"questions" => "kérdések",
"files" => "fájl",
"Assign user" => "Felhasználó csatolása",
"Warning!" => "Figyelem!",
"Create new backup" => "Új biztonsági mentés készítése",
"Upload a backup" => "Egy biztonsági mentés feltöltése",
"Upload backup" => "Biztonsági mentés feltöltése",
"admin category" => "kategória adminisztrálása",
"edit gallery" => "galéria szerkesztése",
"rebuild thumbnails" => "előnézeti képek újraépítése",
"upload image" => "kép feltöltése",
"list gallery" => "galéria listázása",
"original size" => "eredeti méret",
"return to gallery" => "vissza a galériához",
"edit image" => "kép szerkesztése",
"smaller" => "kisebb",
"bigger" => "nagyobb",
"prev image" => "előző kép",
"popup window" => "előugró ablak",
"next image" => "következő kép",
"permission" => "jogosultság",
"remove page" => "oldal eltávolítása",
"browse" => "tallóz",
"related" => "kapcsolódó",
"add a site" => "weblap hozzáadása",
"edit template" => "sablon szerkesztése",
"list articles" => "cikkek listázása",
"view articles" => "cikkek megtekintése",
"edit blog tpl" => "blog sablon szerkesztése",
"admin quicktags" => "gyors elérések beállítása",
"results" => "eredmények",
"create page" => "oldal létrehozása",
"list submissions" => "beküldött cikkek listázása",
"edit translations" => "fordítások szerkesztése",
"edit translations template" => "nyelvi fordítások sablonjának szerkesztése",
"add to the set" => "hozzáadás a fordítások halmazához",
"topic" => "téma",
"new topic" => "új téma",
"accept" => "elfogadás",
"refuse" => "visszautasítás",
"create new gallery" => "új galéria létrehozása",
"result" => "eredmény",
"source" => "forrás",
"edit new article" => "új cikk szerkesztése",
"create new blog" => "új blog létrehozása",
"upload file" => "fájl feltöltése",
"delete selected files" => "kijelölt fájlok törlése",
"browse gallery" => "galéria böngészése",
"edit blog" => "blog szerkesztése",
"add topic" => "téma hozzáadása",
"wiki create" => "wiki készítése",
"wiki overwrite" => "wiki felülírása",
"back" => "vissza",
"Assign permissions to page" => "Jogosultságok kiosztása az oldalhoz",
"Current permissions for this page" => "Meglévő jogosultságok ezen oldalhoz",
"clear stats" => "statisztika törlése",
"last" => "utolsó",
"send me my password" => "küldd el a jelszavam",
"galleries" => "galériák",
"blog posts" => "blog posztok",
"add article" => "cikk hozzáadása",
"remove folder" => "mappa eltávolítása",
"refresh cache" => "cache frissítése",
"no comments" => "nincs komment",
"delete selected topics" => "Kiválasztott témák törlése",
"stop monitoring this topic" => "téma figyelésének felfüggesztése",
"Comments below your current threshold" => "Küszöbérték alatti kommentek",
"DATE-of" => "DATE-",
"You cannot edit this page because it is a user personal page" => "Ez egy felhasználó személyes oldala, csak ő szerkesztheti",
"You do not have permission to edit messages" => "Nincs elegendő jogosultság üzenetek szerkesztéséhez",
"new image uploaded by" => "Az új képet feltöltötte:",
"message" => "üzenet",
"select all" => "összes kijelölése",
"attach" => "csatolás",
"hide categories" => "Kategóriák elrejtése",
"Admin categories" => "Kategóriák adminisztrálása",
"browse category" => "Kategóriák böngészése",
"reply" => "válasz",
"monitor this topic" => "téma figyelése",
"with checked" => "a kijelöltek",
"move selected files" => "a kijelölt fájlok mozgatása",
"compare" => "összehasonlítás",
"diff" => "eltérés",
"for more setup details." => "részt mert segítséget nyújt az oldal beállításához.",
"You can remove this module in" => "Ez a modult eltávolítható itt",
"del" => "törlés",
"Create pdf" => "Pdf készítés",
"categories" => "kategóriák",
"at tracker" => "űrlapon",
"check / uncheck all" => "megjelöli / nem jelöli mindet",
"Tiki sections and features" => "Tikiwiki szekciók és funkciók",
"please read" => "kérem olvassa",
"yes" => "igen",
"<b>enable/disable</b>" => "<b>bekapcsolás/kikapcsolás</b>",
"<b>Max number of items</b>" => "<b>Tételek maximális száma</b>",
"PDF generation" => "PDF készítés",
"Use in CMS" => "Használat cms-ben",
"Use in Wiki" => "Használat wiki-ben",
"Use in newsletters" => "Használat hírlevelekben",
"Use in HTML pages" => "Használat HTML oldalakon",
"Refresh rate (if dynamic) [secs]" => "Frissítési ráta (ha dinamikus) [másodperc]",
"Create/edit newsletters" => "Hírlevél létrehozása/szerkesztése",
"subscriptions" => "előfizetések",
"Use Admin Email" => "Adminisztrátori E-mail használata",
"Edit or add poll options" => "Szavazási opciók hozzáadása/szerkesztése",
"Create/edit Polls" => "Szavazás létrehozása/szerkesztése",
"Rss channels" => "RSS csatornák",
"fields" => "mezők",
"Create/edit trackers" => "Űrlap létrehozása/módosítása",
"Add a new user" => "Új felhasználó hozzáadása",
"Popup Window" => "Előugró ablak",
"No individual permissions global permissions apply" => "Nincsenek egyéni jogosultságok beállítva így a globális jogosultságok érvényesek",
"Welcome to the Tiki Chat Rooms" => "Üdv a Tiki Chat szobákban",
"Please select a chat channel" => "Chat szoba kiválasztása",
"enter chat room" => "chatszoba megadása",
"Chatroom" => "Chatszoba",
"Active Channels" => "Aktív szobák",
"Users in this channel" => "Felhasználók ebben a szobában",
"Create PDF" => "PDF készítése",
"Add or edit a site" => "Weblap hozzáadása/szerkesztése",
"sites" => "weblapok",
"answer" => "válasz",
"Edit Translation:" => "Fordítás szerkesztése:",
"Use this section to set the language of the version you are currently working on." => "Itt is beállítható az oldal jelenleg szerkesztett változatának nyelve",
"Set of Translations" => "Fordítások halmazai",
"Add to the Set" => "Hozzáadás a fordítások halmazához",
"Available File Galleries" => "Rendelkezésre álló fájlgalériák",
"rollback" => "visszagörgetés",
"Last ver" => "összes változat",
"Com" => "Komment",
"Vers" => "Verzió",
"Add or edit a news server" => "Hírszerver hozzáadása/szerkesztése",
"add page" => "oldal hozzáadása",
"Total threads" => "Fórumtémák száma",
"Average threads per topic" => "Fórumtémák átlagos száma témánként",
"Now enter the file URL" => "Fájl URL-jének megadása",
" or upload a local file from your disk" => " vagy egy lokális fájl feltöltése merevlemezről",
"Add or edit folder" => "Mappa hozzáadása/szerkesztése",
"Add or edit a URL" => "URL hozzáadása/szerkesztése",
"priority" => "fontosság",
"post new comment" => "Új komment hozzáfűzése",
"Post New Comment" => "Új komment hozzáfűzése",
"HTML tags are not allowed inside comments" => "HTML tag-ek használata nem megengedett a kommentekben",
"moderator actions" => "moderátori akciók",
"move selected topics" => "kiválasztott témák mozgatása",
"unlock selected topics" => "kiválasztott témák feloldása",
"lock selected topics" => "kiválasztott témák zárolása",
"merge selected topics" => "kiválasztott témák egyesitése",
"queued messages:" => "sorbanálló üzenetek:",
"account" => "fiók",
"Group doesnt exist" => "A csoport nem létezik",
"User doesnt exist" => "A felhasználó nem létezik",
"Permision denied" => "Hozzáférés megtagadva...",
"subject" => "tárgy",
"date" => "dátum",
"mark" => "jelöl",
"posted by" => "szerző",
"Show page title" => "Oldalcímeket megjelenítem",
"Users can lock pages (if perm)" => "Felhasználók zárolhatják a lapokat (engedéllyel)",
"Use WikiWords" => "WikiWords használata",
"Maximum number of versions for history" => "A történelemben max nyilvántortott verziók száma",
"Never delete versions younger than days" => "Soha ne törölj olyan verziót ami fiatalabb ennyi napnál",
"Old vers" => "Régi verzió",
"Add or edit event" => "Esemény hozzáadása/szerkesztése",
"merge selected notes into" => "kiválasztott jegyzetek egyesítése ebbe:",
"Missing title or body when trying to post a comment" => "Hiányzó cím vagy szöveg komment küldése közben",
"PortuguÁªs" => "portugál",
"Show Categories" => "Kategóriák megjelenítése",
"Hide Categories" => "Kategóriák elrejtése",
"categorize this object" => "az objektum kategorizálása",
"Critical" => "Kritikus",
"Planning" => "Tervezés",
"Conducted" => "Megtartva",
"Ongoing" => "Folyamatban",
"Scheduled" => "Ütemezve",
"Planning in progress" => "Tervezés alatt",
"tiki-admin_dsn tpl" => "tiki-admin_dsn tpl",
"Mini calendar" => "Mini naptár",
"Send pages" => "Oldalak küldése",
"Received pages" => "Oldalak fogadása",
"Create/Edit blog" => "Blog létrehozása/szerkesztése",
"Browse directory" => "Könyvtár böngészése",
"List quizzes" => "Kvízek listázása",
"List trackers" => "Űrlapok listázása",
"Ephemerides Admin" => "Napi idézetek adminisztrálása",
"Charts Admin" => "Slágerek adminisztrálása",
"I forgot my pass" => "Elfelejtettem a jelszót",
"pass" => "jelszó",
"Page generated in" => "A lap elkészült",
"Homework" => "Házifeladat",
"Assignments" => "Feladatok",
"Favorites" => "Kedvencek",
"Minor" => "Kisebb",
"This is" => "Ez a",
"by the" => "fejleszti a",
"Tiki community" => "Tiki közösség",
"Blog level comments" => "Blog szint kommentek",
"Post level comments" => "Poszt szint megjegyzések",
"Spellchecking" => "Helyesírás ellenőrzése",
"Default ordering for blog listing" => "Bloglista alapértelmezett sorrendje",
"Blog listing configuration (when listing available blogs)" => "Rendelkezésre álló blogok listázásának beállítása",
"Blog comments settings" => "Blogok kommentjeinek beállítása",
"CMS features" => "CMS tulajdonságok",
"Use templates" => "Sablon használata",
"Maximum number of articles in home" => "A cikkek maximális száma a főoldalon",
"Article comments settings" => "Cikkek kommentjeinek beállítása",
"Copyright Management" => "Szerzői jogok kezelése",
"License Page" => "Licensz lap",
"Submit Notice" => "Megjegyzés küldése",
"Content Features" => "Tartalomszerkesztési funkciók",
"Uploaded filenames cannot match regex" => "A feltöltött fájl neve nem egyezhet a kifejezéssel",
"File galleries comments settings" => "Fájlgalériák kommentjeinek beállítása",
"Forum quick jumps" => "Fórum gyors ugrások",
"Ordering for forums in the forum listing" => "Fórumok listázásának beállítása",
"Forum listing configuration" => "Fórumok listázásának tulajdonságai",
"Use URI as Home Page" => "URI használata kezdőlapként",
"Use cache for external images" => "Cache használata a külső képekhez",
"Use gzipped output" => "Gzippelt kimenet használata",
"Sender Email" => "Küldési E-mail cím",
"contact feature disabled" => "kapcsolattartás kikapcsolva",
"User registration and login" => "Felhasználói bejelentkezés és regisztráció",
"Use WebServer authentication for Tiki" => "Webszerver azonosítás használata a Tiki-hez",
"Request passcode to register" => "Ezen kód kérése regisztrációnál",
"Prevent automatic/robot registration" => "Automata/robot regisztráció megelőzése",
"Validate users by email" => "Felhasználók validálása E-mailben",
"Store plaintext passwords" => "Jelszó tárolása sima szövegként",
"Reg users can change language" => "Regisztrált felhasználók megváltoztathatják a nyelvet",
"Available languages:" => "Jelenlegi nyelvek:",
"Force to use chars and nums in passwords" => "Betűk és számok is kötelezőek a jelszóban",
"Minimum password length" => "Jelszó minimális hossza",
"Password invalid after days" => "Jelszó elévülési ideje",
"Remember me feature" => "Emlékezz rám szolgáltatás",
"Create user if not in Tiki?" => "Felhasználó létrehozása, ha nincs Tikiben?",
"Create user if not in Auth?" => "Felhasználó létrehozása ha nincs az Auth-ban?",
"Just use Tiki auth for admin?" => "Csak Tiki azonosítást használjunk az adminisztrátornak?",
"restore" => "visszaállítás",
"Wiki Features" => "Wiki szolgáltatások",
"Admin banning tpl" => "Kitiltások ",
"Create/edit Calendars" => "Naptárak létrehozása/szerkesztése",
"charts" => "slágerlisták",
"Chat Administration" => "Csevegés adminisztrálása",
"Create/edit channel" => "Csatorna létrehozása/szerkesztése",
"Chat channels" => "Chat csatornák",
"Admin Webmail" => "Webmail adminisztrálása",
"Assign Module" => "Modul hozzárendelése",
"subscribed" => "előfizetve",
"EMail notifications" => "E-mailes értesítések",
"Admin Polls Template" => "Szavazás sablon szerkesztése",
"Admin RSS modules" => "RSS modulok adminisztrálása",
"Edit this RSS module:" => "Ezen RSS modul szerkesztése:",
"Create new RSS module" => "Új RSS modul készítése",
"Score System" => "Pontozási rendszer",
"Edit survey questions" => "Kérdőív kérdések szerkesztése",
"this survey stats" => "ennek a kérdőívnek a statisztikáa",
"Create/edit questions for survey" => "Kérdőív kérdések létrehozása/szerkesztése",
"system admin" => "rendszer adminisztrátor",
"Active?" => "Aktív?",
"Create/Edit Trackers" => "Űrlapok létrehozása/szerkesztése",
"Again" => "Mégegyszer",
"Assign permissions to group" => "Jogosultságok megadása csoportnak",
"Browse gallery" => "Galéria böngészése",
"Upload from disk" => "Feltöltés lemezről",
"Browsing Gallery" => "Galériák böngészése",
"Browsing Image" => "Képek böngészése",
"Again please" => "Mégegyszer",
"Edit Article" => "Cikk szerkesztése",
"Edit Blog Tpl" => "Blog sablon szerkesztése",
"bold" => "félkövér",
"Edit Translations" => "Fordítások szerkesztése",
"Edit Translations Template" => "Fordítási sablon szerkesztése",
"back to forum" => "vissza a fórumba",
"hist" => "előzmények",
"Subscribe to This Newsletter" => "Előfizetés erre a hírlevélre",
"Received Articles" => "Fogadott cikkek",
"Return to HomePage" => "Vissza a főoldara",
"Rename page" => "Oldal átnevezése",
" or upload a local image from your disk" => " vagy egy helyi kép feltöltése a merevlemezről",
"Add new mail account" => "Új postaláda hozzáadása",
"User accounts" => "Felhasználói fiókok",
"Minor Edit" => "Kisebb módosítás",
"You can not download files" => "Magasabb szintű jogosultágra van szükség fájlok letöltéséhez",
" successfully sent" => " sikeresen elküldve",
" not sent" => " nem lett elküldve",
"Please wait 2 minutes between posts" => "Posztok feladása között legalább 2 percnek el kell telnie!",
"I18n setup" => "i18n beállításai",
"Default Language" => "Alapértelmezett nyelv",
"Available languages (Ctrl+Click to select multiple languages):" => "Rendelkezésre álló nyelvek (CTRL lenyomva tartásával több nyelv is kiválasztható)",
"Show Babelfish Translation URLs" => "Babelfish fordítás URL megjelenítése",
"Show Babelfish Translation Logo" => "Babelfish fordítás logó megjelenítése",
"More Links" => "További linkek",
"Stats &amp;amp; banners" => "Statisztikák &amp; bannerek",
"Im- Export Languages" => "Nyelvek exportálása/importálása",
"To learn more, visit: &lt;a href=\"http://www.tiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\"&gt;http://www.tiki.org&lt;/a&gt;" => "Minden a TikiWikirol itt: http://www.tiki.org",
"%a %d sorrendje %b, %Y %H:%M %Z" => "%a %d %b, %Y %H:%M %Z ",
"%a %d sorrendje %b, %Y" => "%a %d %b, %Y",
"Hold down CTRL to select multiple categories" => "CTRL lenyomva tartásával több kategória is kiválasztható",
"Show Plugins Help" => "Plugin súgó megjelenítése",
"PortuguÃªs" => "portugál",
"%a %d %b, %Y %H:%M %Z" => "%a %d %b, %Y %H:%M %Z ",
"%a %d %b, %Y" => "%a %d %b, %Y",
"Portugus" => "portugál",
"Wiki Comments Settings" => "Wiki komment beállítása",
"List displayed by default" => "Lista megjelenítésre kerül alapértelmezés szerint",
"Use database to store files:" => "Fájlok tárolása adatbázisban:",
"Use a directory to store files:" => "Fájlok tárolása könytárban:",
"Wiki Administration" => "Wiki adminisztráció",
"No articles." => "Nincsenek cikkek",
"(like en)" => "(pld: hu)",
"(like English)" => "(pld: Magyar)",
"Edit Summary" => "Összefoglaló szerkesztése",
"Sandbox:" => "Homokozó:",
"Anonymous editors must input anti-bot code:" => "Anonim szerkesztőknek anti-bot kódot kell megadniuk:",
"Last changes:" => "Legutóbbi változások:",
"Export:" => "Exportálás:",
"View source:" => "Forrás megtekintése:",
"List pages:" => "Oldalak listázása:",
"Backlinks:" => "Ide mutató linkek:",
"Similar:" => "Hasonló:",
"Rankings:" => "Rangsor:",
"Save Draft:" => "Piszkozat mentése:",
"Wiki Home Page" => "Wiki kezdőlap",
"Edit section:" => "Szekció szerkesztése:",
"Print Page:" => "Oldal nyomtatása:",
"Wiki History" => "Wiki története:",
"Wiki attachments:" => "Wiki mellékletek:",
"Pictures:" => "Képek:",
"Footnotes:" => "Lábjegyzet:",
"Users can lock pages (if perm):" => "Felhasználók zárolhatják az oldalakat (megfelelő jogosultsággal)",
"Individual cache:" => "Egyedi cache:",
"Comment length:" => "Komment hossza:",
"Send link to" => "Link küldése",
"User list" => "Felhasználók listáa",
"Workspaces" => "Munkaterületek",
"Admin Workspaces" => "Munkaterületek adminisztrálása",
"Workspace Types" => "Munkaterület típusok",
"Multiple Print" => "Tömeges nyomtatás",
"New article" => "Új cikk",
"Shortname must be 2 characters" => "A rövid név 2 karakter hosszÚ legyen (pld \"hu\")",
"like en" => "pld: hu",
"like English" => "pld: Magyar",
"(optional)" => "(opcionális)",
"Exact&amp;nbsp;match" => "Pontosan egyezzen",
"Undo:" => "Visszaállítás (undo):",
"Tag name:" => "Címke neve:",
"Restore the Wiki" => "Wiki visszaállítása",
"Remove a Tag" => "Címke eltávolítása",
"Create a Tag for the Current Wiki" => "Címke létrehozása a jelenlegi Wiki számára",
"Spellchecking:" => "Helyesírás ellenőrzése:",
"Use templates:" => "Sablonok használata:",
"Warn on edit conflict:" => "Figyelmeztetés szekesztési ütközés esetén:",
"Show page title:" => "Oldal nevének megjelenítése:",
"Show page ID:" => "Oldal azonosítójának megjelenítése:",
"Use WikiWords:" => "WikiWord használata:",
"Accept dashes and underscores in WikiWords:" => "Kötőjel és alulvonás elfogadása WikiWord-ben:",
"Link plural WikiWords to their singular forms:" => "WikiWord többesszámú formátumának az egyesszámúhoz kötése:",
"Use Wiki paragraph formatting:" => "Wiki bekezdésformázás használata:",
"To add/edit wiki pages easily, add the module quick_edit via \"Modules\" on the application menu, or" => "Wiki oldalok gyors szerkesztéséhez használjuk a quick_edit modult mely elérhető a \"Modulok\" menüpont alatt az alkalmazás fő menüjében, vagy",
"But still create line breaks within paragraphs:" => "De hozzon létre sortörést bekezdéseken belül:",
"Automonospaced text:" => "Automonospace szöveg:",
"Tables syntax:" => "Tábla szintaxis:",
"\\n for rows" => "\\n sorokhoz",
"Uses Slideshow:" => "Bemutató használata:",
"Open page as structure:" => "Oldal megnyitása struktúraként:",
"Make structure from page:" => "Struktúra készítése oldalból:",
"Categorize structure pages together:" => "Struktúra oldalainak összekategorizálása:",
"Show page version:" => "Oldal verziójának megjelenítése:",
"Maximum number of versions for history:" => "Verziók maximális száma az előzményeknél:",
"Never delete versions younger than days:" => "Ennyi napnál frissebb oldalak törlése nem lehetséges:",
"IP address displayed in history:" => "IP cím megjelenítése az előzményekben:",
"Diff style:" => "Eltérés stílusa:",
"History only for data, description, comment change" => "Csak adat, leírás és komment változásainak története",
"Wiki Watch" => "Wiki figyelése",
"Create watch for author on page creation:" => "Oldal létrehozója automatikusan figyeli az oldalt:",
"Enable watch events when I am the editor:" => "Események figyelése ha én vagyok a szerkesztő:",
"Enable watches on comments:" => "Kommentek figyelése:",
"Wiki Page List Configuration" => "Wiki oldalak listázásának beállítása",
"Import Page:" => "Oldal importálása:",
"Page creators are admin of their pages:" => "Oldalak létrehozói saját oldalaik adminisztrátorai:",
"Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"./fixperms fix\" for example)." => "Az Apache-nak írási joga van a fájlstruktúrához mely lehetővé teszi a csomagok telepítését, eltávolítását és frissítését. Ha befejeztük a műveleteket akkor tegyük ismét biztonságossá ezeket a jogosultságokat (pld a \"./fixperms fix\" használatával).",
"To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"./fixperms.sh open\" to set it up). After installation you need to remove that permission (using \"./fixperms fix\")." => "Csomagok telepítéséhez, eltávolításához vagy frissítéséhez az Apache számára írási jogosultságot kell adni a webes fájlstrultúrához (használhatjuk a \"./fixperms.sh open\" szkriptet). Telepítés után el kell távolítani a jogosultságot (használjuk a \"./fixperms fix\" szkriptet).",
"my tiki tpl" => "my tiki tpl",
"Admin mods" => "Mods adminisztráció",
"will have all the permissions of the included groups." => "a tartalmazott csoportok összes jogosultságát meg fogja kapni",
"the included groups" => "a tartalmazott csoportok összes jogosultságát meg fogja kapni",
"Enable now." => "Bekapcsolás most",
"User must change his password at first login" => "A felhasználónak meg kell változtatnia a jelszavát az első bejelentkezéskor",
"Browse..." => "Tallózás...",
"Browse.." => "Tallózás..",
"Browse." => "Tallózás.",
"Browse ..." => "Tallózás...",
" Browse ..." => "Tallózás...",
"More criteria" => "További kritériumok",
"SysLog" => "Rendszerlog",
"Directories to save:" => "Mentendő könyvtárak",
"(Hide)" => "(Elrejtés)",
"security admin" => "biztonsági beállítások",
"security admin tpl" => "security admin tpl",
"Tikiwiki settings" => "Tikiwiki beállítások",
"Theme Control Center: categories" => "Stílusvezérlés: kategóriák",
"ThemeControl" => "Stílusvezérlés",
"ThemeControl tpl" => "ThemeControl tpl",
"To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tiki.org\">themes</a>." => "Stílustémákról bővebben itt: <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tiki.org\">Stílusok</a>.",
"ThemeControl Objects" => "Stílusvezérlés objektumokon",
"theme control objects tpl" => "theme control objects tpl",
"Theme Control Center: sections" => "Stílusvezérlés: szekciók",
"theme control sections tpl" => "theme control sections tpl",
"html page" => "html oldal",
"mytiki" => "myOiT",
"tiki admin quicktags template" => "tiki admin quicktags template",
"Show Text Formatting Rules" => "Szövegformázási szabályok megjelenítése",
"italic" => "dőlt",
"underline" => "aláhúzás",
"heading2" => "címsor 2",
"heading3" => "címsor 3",
"hr" => "táblasor",
"list numbers" => "számozott lista",
"list bullets" => "felsorolásos lista",
"Email Address" => "E-mail cím",
"Label:" => "Címke:",
"newsletters" => "hírlevelek",
"maps" => "térképek",
"Admin RSSmodules Template" => "RSS modul sablon adminisztrálása",
"Exact match" => "Pontos egyezés",
"Exact match " => "Pontos egyezés",
"Allow Smileys" => "Smiley-k engedélyezése",
"Show quicktags over textareas (instead on left side)" => "Quicktag-ek megjelenítése szöveges területek felett (és nem a bal oldalon)",
"Default number of rows (wiki)" => "Sorok alapértelmezett száma (wiki)",
"Default number of rows (comments)" => "Sorok alapértelmezett száma (kommentek)",
"Default number of rows (forum)" => "Sorok alapértelmezett száma (fórum)",
"Default number of rows (forum replies)" => "Sorok alapértelmezett száma (fórum válaszok)",
"Use File Galleries for images inclusion" => "Fájlgaléria használata képek felhasználásakor",
"Hotwords in New Windows" => "Hotword új ablakban",
"Help on Text area Config" => "Szöveges terület súgó",
"Right &amp; left boxes" => "Modulok a jobb &amp; bal oldalon megjelenő különféle dobozok",
"Administer modules" => "Modulok adminisztrálása",
"Show Module Controls" => "Modul kontrollok megjelenítése",
"Users can Configure Modules" => "Felhasználók konfigurálhatják a modulokat",
"Users can Shade Modules" => "Felhasználók elrejthetik a modul tartalmát",
"module decides" => "modul dönt",
"Use this page to configure the RSS feeds generated by Tiki. To syndicate RSS feeds from other sites, use the <strong>Admin</strong> &gt; <strong>RSS modules</strong> menu option, or" => "Ezen az oldalon lehet a Tiki által generált RSS feed-eket beállítani. RSS feed-ek szindikálására más weblapokról használjuk az <strong>Adminisztráció</strong> &gt; <strong>RSS modulok</strong> menüpontot, vagy",
"Help on RSS feeds Config" => "Súgó az RSS feed-ek beállításához",
"seconds (0 = cache inactive)" => "másodperc (0 = cache inaktív)",
"Parse the result (can be slow)" => "Eredmény elemzése (lassú lehet)",
"Database Search using MySQL 'Full-Text' Feature" => "Adatbázis keresése a MySQL 'Full-Text' funkció használatával",
"Activate MySQL Full-Text feature" => "MySQL Full-Text funkció aktiválása",
"Activate MySQL 'Full-Text' feature" => "MySQL 'Full-Text' funkció aktiválása",
"Performance issues" => "Teljesítmény tényezők",
"Database Independent Full Text Search or Tiki Search" => "Adatbázisfüggetlen teljes szöveg keresés vagy másnéven Tiki keresés",
"This is activated by default if MySQL 'Full-Text' feature is not activated above" => "Ez automatikusan aktiválásra kerül ha a MySQL 'Full-Text' funkció nincs aktiválva",
"Search features" => "Keresési funkciók",
"SearchStats" => "Keresési statisztika",
"Settings for searching content" => "Tartalom keresésének beállításai",
"Search refresh mode" => "Keresés frissítésének módja",
"Search refresh rate" => "Keresés frissítésének gyakorisága",
"0 for no refresh" => "0 a frissítés mellőzéséhez",
"User identity features" => "Funkciók felhasználó azonosításához",
"Users sort order" => "Felhasználók rendezésének sorrendje",
"Meta Keywords" => "Meta kulcsszavak",
"Insert freetags in keyword list" => "Freetag-ek (címkék) beszúrása kulcsszólistába",
"Use the thread title in Forum pages instead" => "A fórumtéma címének használata a fórumoldalakon",
"Use the image title in Image gallery pages instead" => "Kép címének használata a képgaléria oldalakon",
"Meta Description" => "Meta leírás",
"Meta Author" => "Meta szerzője",
"Geourl" => "Geourl",
"meta robots" => "meta robotok",
"revisit after" => "újralátogatás ennyi után",
"... but need admin validation" => "... de adminisztrátori validálás szükséges",
"Create a group for each user <br />(with the same name as the user)" => "Csoport létrehozása minden egyes felhasználóhoz <br />(a felhasználói névvel megegyező néven)",
"Use tracker for more user information" => "Űrlap használata további felhasználói információk gyűjtéséhez",
"Use tracker for more group information" => "Űrlap használata további csoportinformációk gyűjtéséhez",
" - Php GD library required" => " - Php GD könyvtár szükséges",
"Use login as email" => "Bejelentkezési név használata E-mailként",
"Validate user email server" => "Felhasználói E-mail szerver validálása",
"Remind passwords by email (if \"Store plaintext passwords\" is activated.) Else, Reset passwords by email" => "Jelszóemlékeztető E-mailben (ha a \"sima szöveges jelszó\" aktiválásra került) - egyébként E-mailen keresztüli jelszóváltoztatás",
"Crypt passwords method" => "Jelszótitkosítás módszere",
"Reg users can change password" => "Regisztrált felhasználók megváltoztathatják a jelszavukat",
"Restrict available languages" => "Rendelkezésre álló nyelvek korlátozása",
"Minimum username length" => "Felhasználói név minimális hossza",
"Maximum username length" => "Felhasználói név maximális hossza",
"Force lowercase username" => "Kisbetűs felhasználói nevek erőltetése",
"-1 for never" => "ha soha akkor: -1 ",
"Re-validate user by email after days" => "Felhasználó újravalidálása E-mailen ennyi nap után",
"Re-validate user by email after unsuccessful logins" => "Felhasználó újravalidálása E-mailen ennyi sikertelen bejelentkezés után",
"Generate a password option" => "Jelszógenerálás lehetősége",
"Consider we are in always in HTTPS, but do not check" => "Vegye úgy hogy mindig https-ben vagyunk de ne ellenőrizze",
"Remember me name" => "Emlékezz rám Név",
"Remember me domain" => "Emlékezz rám Domain",
"Remember me path" => "Emlékezz rám Útvonal",
"Protect against CSRF with a confirmation step" => "CSRF elleni védekezés megerősítési lépéssel",
"Highlight Group" => "Csoport kiemelése",
"User can choose beyond these groups at registration time" => "A felhasználó ezen csoportok közül választhat regisztrációkor",
"Specify the fields that will be asked in admin->groups" => "Meg kell határozni azon mezőket amelyek szükségesek az admin->csoportoknál",
"Displays user's contribution in the user information page" => "Felhasználó hozzájárulásainak megjelenítése a felhasználó információs oldalán",
"Displays UserTracker information in user information page. Format: trackerId, fieldId1, fieldId2, …" => "Felhasználói űrlap információk megjelenítése a felhasználói oldalon. Formátum: trackerId, fieldId1, fieldId2, …",
"Deactivate login autocomplete (do not remember login and password)" => "Bejelentkezés automatikus kiegészítésének deaktiválása (ne emlékezzen bejelentkezési névre és jelszóra)",
"On permission denied, display login box for anonymous:" => "Elegendő jogosultság hiánya esetén bejelentkezési ablak megjelenítése az anonim látogatóknak:",
"On permission denied, send to this url:" => "Elegendő jogosultság hiánya esetén elküldés erre az URL-re:",
"LDAP URL<br />(if set, this will override the Host and Port below)" => "LDAP URL<br />(ha beállítjuk akkor felülbírálja az alábbi Host-ot és Port-ot)",
"LDAP Host" => "LDAP Host",
"LDAP Port" => "LDAP Port",
"LDAP Scope" => "LDAP Scope",
"LDAP Base DN" => "LDAP Base DN",
"LDAP User DN" => "LDAP User DN",
"LDAP User Attribute" => "LDAP User Attribute",
"LDAP User OC" => "LDAP User OC",
"LDAP Group DN" => "LDAP Group DN",
"LDAP Group Attribute" => "LDAP Group Attribute",
"LDAP Group OC" => "LDAP Group OC",
"LDAP Member Attribute" => "LDAP Member Attribute",
"LDAP Member Is DN" => "LDAP Member Is DN",
"LDAP Admin User" => "LDAP Admin felhasználó",
"LDAP Admin Pwd" => "LDAP Admin jelszó",
"LDAP Version" => "LDAP verzió",
"LDAP Realname Attribute" => "LDAP Realname Attribute",
"CAS server hostname" => "CAS szerver hostname",
"CAS server port" => "CAS szerver port",
"CAS server path" => "CAS szerver útvonal",
"Change CAS preferences" => "CAS preferenciák megváltoztatása",
"Valid Affiliations (separated by commas)" => "Valid belépések (vesszokkel elválasztva)",
"Create with default group?" => "Létrehozás alapértelmezett csoporttal?",
"Default group: " => "Alapértelmezett csoport: ",
"Change Shibboleth preferences" => "Shibboleth preferenciák megváltoztatása",
"Users Defaults" => "Felhasználói alapértelmezések",
"Detect user timezőne if browser allows, otherwise site default" => "Felhasználói időzóna felismerése ha a böngésző megengedi, egyébként a weblap alapértelmezettje",
"Change users defaults" => "Felhasználói alapértelmezések megváltoztatása",
"Technology" => "Technológia",
"Extra Stuff &amp; Fun" => "Extra cucc &amp; móka",
"Content Related" => "Tartalomhoz kapcsolódó",
"Feature documentation links" => "Funkció dokumentáció link",
"Help System (Feature documentation links)" => "Súgó rendszer (Funkció dokumentáció linkek)",
"Technical Features" => "Technikai funkciók",
"Swffix" => "Swffix",
"Contact Us (Anonymous)" => "Kapcsolatfelvétel (anonim)",
"Tikiwiki version" => "Tikiwiki verzió",
"OS" => "OS",
"Log Mail in Tiki Logs:" => "Levél loggolása Tikiben:",
"Log SQL:" => "SQL loggolása:",
"Default charset for sending mail:" => "Levélküldés alapértelmezett karakterkészlete:",
"Mail end of line:" => "Levél Mail end of line:",
"Disallow access to the site (except for those with permission)" => "Weblaphoz történő hozzáférés letiltása (kivéve a jogosultsággal rendelkezőket)",
"Message to display when site is closed" => "Mikor a weblap le van zárva ez az üzenet jelenik meg",
"Disallow access when load is above the threshold (except for those with permission)" => "Weblap elérésének letiltása ha a szerver terheltsége a küszöbétrék felett van (kivéve a jogosultsággal rendelkezőket)",
"Max average server load threshold in the last minute" => "Maximum átlagos szerverterheltségi küszöb az elmúlt percben",
"Message to display when server is too busy" => "Szerver túlterhelése esetén megjelenítendő üzenet",
"output compression is active." => "a kimeneti tömörítés aktív",
"compression is handled by" => "a tömörítés kezelője",
"Allow anonymous users to \"Contact Us\"" => "Anonim felhasználók számára engedélyezett a \"kapcsolatfelvétel\"",
"Session lifetime in minutes" => "Munkamenet élettartama percekben",
"Proxy Host" => "Proxy Host",
"Please expect not found help-pages with the default-URL." => "A nem talált súgó oldalak az alapértelmezett URL-re mutatnak",
"Any help with the documentation is welcome." => "Minden dokumentációs segítségnek örülünk :)",
"Release check" => "Release ellenőrzése",
"Release checks are made when you browse admin main page only" => "Release ellenőrzése csak a fő adminisztrációs oldal böngészésekor történik",
"Force immediate check" => "Azonnali ellenőrzés erőltetése",
"When possible, show the real user name instead of login:" => "Amikor csak lehetséges mutassuk az igazi nevet a felhasználói név helyett:",
"Locations separator" => "Lokációk szeparátora",
"Choices separator" => "Választási lehetőségek szeparátora",
"Preference syntax" => "Preferencia szintakszis",
"Login as..." => "Bejelentkezés mint...",
"Home Forum" => "Kezdőfórum",
"Forums features" => "Fórum funkciók",
"Enable topics archiving" => "Téma arhíválás aktiválása",
"Allow first posts of a thread to have an empty body (will be a thread title)" => "Fórumtéma első hozzászólása lehet üres (így ez lesz a fórumtéma neve)",
"Reply posts are empty" => "Válasz hozzászólások üresek",
"Search some forums by name (on \"forum list\")" => "Fórumok keresése név alapján (a \"fórum listán\")",
"Search some forums by content on \"forum list\" (needs feature_search activated)" => "Fórumok keresése tartalom alapján a \"fórum listán\" (szükséges a feature_search aktiválása)",
"Search in topics content on forum page (needs feature_search activated)" => "Keresés témák tartalmában a fórum oldalon (szükséges a feature_search aktiválása)",
"Search method when searching in content: Tiki search local to a forum" => "Keresési módszer tartalom keresésekor: Tiki keresés lokálisan fórumhoz",
"Search method when searching in content: Non-Tiki search local to a forum" => "Keresési módszer tartalom keresésekor: Nem-Tiki keresés lokálisan fórumhoz",
"Threads default preferences" => "Fórumtémák alapértelmezett beállítása",
"Allow to manage thread defaults in each forum configuration" => "Fórumtémák alapértelmezésének kezelése fórumonként",
"Display thread configuration bar to override defaults" => "Fórumtéma konfigurációs sor megjelenítése az alaéprtelmezések felülírásához",
"Configuration bar settings are kept for all forums during the user session:" => "A konfigurációs sor beállításai megmaradnak az összes fórumnál a felhasználó munkamenete alatt:",
"Default thread style" => "Alapértelmezett fórumtéma stílus",
"Default thread sort mode" => "Alapértelmezett fórumtéma rendezési mód",
"only queries using more than seconds" => "csak az ennyi másodpercnél hosszabb lekérdezések esetén",
"%s - Version %d of this page has been saved by %s." => "%s - Oldal verzió: %d - Mentette: %s",
"Use categories to regroup various Tiki objects" => "Kategóriák segítségével lehet a különböző Tiki objektumokat csoportosítani",
"Link to" => "Link:",
"Show Category Path" => "Kategória útvonalának megjelenítése",
"Exclude These Category IDs from Path (comma delimited)" => "Ezeb kategória azonosítók kizárása az útvonalból (vesszővel elválasztva)",
"Show Category Objects" => "Kategória objektumainak megjelenítése",
"Search may show forbidden results. Much better performance though." => "A keresés tiltott eredményeket is megmutathat (viszont sokkal pontosabb)",
"Categories browse uses PhpLayers" => "Kategóriák tallózásához PhpLayers használata",
"The feature must be activated" => "A funkciót aktiválni kell",
"Use the Administration page of each enabled feature to allow the use of content templates" => "A bekapcsolt funkciók saját adminisztrációs oldalán lehet engedélyezni a sablonok használatát",
"Admin Content Templates Template" => "Tartalomsablonok sablonjának adminisztrálása",
"Image Gallery tpl" => "Képgaléria sablon (Image Gallery tpl)",
"Vew inserted gallery" => "Beillesztett galéria megtekintése",
"Create a file gallery" => "Fájlgaléria létrehozása",
"To add/remove file galleries, go to \"File Galleries\" on the application menu, or" => "Fájlgalériák hozzáadásához /eltávolításához lásd a \"Fájlgalériák\" menüpontot az alkalmazás fő menüjében, vagy",
"File author" => "Fájl szerzője",
"For not registered author" => "Nem regisztrált szerző",
"PodCast directory (must be web accessible):" => "PodCast könyvtár (weben keresztül elérhetőnek kell lennie):",
"File galleries search indexing" => "Fájlgalériák keresési indexelése",
"Leave command blank to delete handler" => "Hagyjuk a parancsot üresen a kezelő törléséhez",
"Use %1 for where internal file name should be substituted (example: \"strings %1\" to convert the document to text using the unix strings command)" => "Használjuk a %1 formulát ott ahol belső fájlnevet kell kicserélni (például: \"strings %1\" megadásával konvertálhatjuk a dokumentum szövegét a unix-os 'strings' parancs segítségével)",
"Enable auto indexing on file upload or change" => "Automatikus indexálás bekapcsolása fájlfeltöltés vagy változtatás esetén",
"System command" => "Rendszer parancs",
"Freetag Browsing" => "Címkék böngészése",
"Uncheck the above checkbox to uncategorize this page/object" => "Az objektum kategóriá(k)ból történő eltávolításához vegyük ki a pipát a fenti jelölőnégyzetből",
"Removed version" => "Verzió eltávolítva",
"(Only .gif images, and aproximately 45px x 45px)" => "(csak .gif képek, kb 45px x 45px méretben)",
"page last modified on" => "Oldal legutóbbi módosítása:",
"User Watches tpl" => "Felhasználó figyelései tpl",
"watched events" => "figyelemmel követett esemény",
"Watch language wiki page creations" => "Adott nyelvű wiki oldalak létrehozásának figyelése",
"Add watch" => "Figyelés hozzáadása",
"Admin Directory tpl" => "Könyvtár admin (admin directory) tpl",
"Admin category relationships" => "Kategória kapcsolatok adminisztrálása",
"Validate links" => "Linkek validálása",
"Admin Directory Categories tpl" => "Admin Directory Categories tpl",
"Admin Directory Related " => "Kapcsolódó könyvtár adminisztrálása",
"directory admin related tpl" => "directory admin related tpl",
"Admin Directory Sites" => "Könyvtári weblapok adminisztrálása",
"Admin Directory Sites tpl" => "Admin Directory Sites tpl",
"Validate Sites" => "Weblapok validálása",
"directory validate sites tpl" => "directory validate sites tpl",
" on " => " Dátum: ",
"Global post-level comments is disabled" => "Globális poszt szintű kommentelés jelenleg nincs aktiválva",
"Global post-level comments is disabled." => "Globális poszt szintű kommentelés jelenleg nincs aktiválva",
"Watch minor" => "Kisebb változások figyelése",
"Enable Feature for Wiki" => "Funkció aktiválása wikihez",
"Enable Feature for Articles" => "Funkció aktiválása cikkekhez",
"Enable Feature for Blogues" => "Funkció aktiválása blogokhoz",
"Enable Feature for Bloges" => "Funkció aktiválása blogokhoz",
"Enable Feature for Faqs" => "Funkció aktiválása GYIK-ekhez",
"Jan" => "Jan.",
"Feb" => "Febr.",
"Mar" => "Márc.",
"Apr" => "Ápr.",
"Jun" => "Jún",
"Jul" => "Júl.",
"Aug" => "Aug.",
"Sep" => "Szept.",
"Oct" => "Okt.",
"Nov" => "Nov.",
"Dec" => "Dec.",
"Enable Smarty Security (e.g. do not allow php code in smarty templates):" => "Smarty biztonság bekapcsolása (pld nem enged php kódot smarty sablonban):",
"Enable Smarty Security (e.g. do not allow php code in smarty templates)" => "Smarty biztonság bekapcsolása (pld nem enged php kódot smarty sablonban)",
"Use @version:x.x specified in theme css or 1.8 if not specified" => "Használja a téma css-ben megadott @verzió:x.x-t vagy az 1.8-at ha nincs semmi megadva",
"Required for all the following features" => "Az összes alábbi funkcióhoz szükséges",
"Site Logo" => "Weblap logója",
"Note: This feature also requires PHPLayers to be turned on in " => "Megjegyzés: a funkció használatához be kell kapcsolni a PHPlayers funkciót",
"Prefix breadcrumbs with 'Location : ' " => "Útmutató kenyérmorzsák elé tegye oda hogy 'Lokáció: '",
"Use context menus for actions (icons) (only in file galleries yet)" => "Kontextusmenük használata akciókhoz (ikon) (egyelőre még csak fájlgalériáknál)",
"Use context menus for actions (text) (only in file galleries yet)" => "Kontextusmenük használata akciókhoz (szöveg) (egyelőre még csak fájlgalériáknál)",
"Required for many of the general layout features" => "Szükséges a legtöbb általános stílus funkcióhoz",
"Faq Stats" => "Gyik statisztika",
"Print article" => "Cikk nyomtatása",
"Can specify notification emails when creating an article" => "Értesítési E-mail cím megadásának lehetősége cikk létrehozásakor",
"Settings for page articles home" => "Cikkek kezdőlapjának beállításai",
"Fields to display on page" => "Megjelenítendő mezők ezen az oldalon:",
"Expire Date" => "Lejárat dátuma",
"Title length:" => "Cím hossza",
"Article Types tpl" => "Article Types tpl",
"show help" => "Súgó megjelenítése",
"Delete this type" => "Ezen típus törlése",
"Will display using the indicated HTML color or color name" => "A megadott HTML színkódnak vagy színnévnek megfelelő színben jeleníti meg a szöveget",
"~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc)}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>témanév, topicId=>témaid, type=>típus, categId=>kategória,  lang=>en, sort=>oszlopnév_növekvő|oszlopnév_csökkenő)}{ARTICLES}~/np~",
"Formula" => "Képlet",
"No formula specified." => "Nincs képlet megadva",
"Impossible to render the graphic." => "Lehetetlen renderelni a grafikát",
"View graphic" => "Grafika megtekintése",
"blogId is mandatory" => "A blogId kötelező",
"Includes blog posts listing into a wiki page" => "Blogposztokat listáz a wiki oldalon",
"~np~{POSTS(max=>5, blogId=>id)}{POSTS}~/np~" => "~np~{POSTS(max=>5, blogId=>id)}{POSTS}~/np~",
" wrote:" => " írta:",
" pages found for title search" => " oldal felelt meg a címkeresési feltételnek",
"pagename is optional; if it is not present, links into the current file." => "Az oldalnév opcionális; ha nincs akkor a jelenlegi fájlra mutat",
"Create Trackers" => "Űrlap létrehozása",
"tracker name must be unique, field names must be unique \nfor a tracker and they must be valid in SQL" => "Űrlap nevánek egyedinek kell lennie, a mezőneveknek egyedinek kell lenniük\negy adott űrlap kapcsán és validnak kell lenniük SQL-ben",
"Tracker Items for" => "Űrlaptételek: ",
"Text options: 1,size,prepend,append,max with size in chars, prepend will be displayed before the field append will be displayed just after, max is the maximum number of characters that can be saved, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Szöveg opciók: '1,size,prepend,append,max (karakter)' ahol 'size' a méretet mutatja karakterek számában kifejezve, 'prepend' hatására a szöveg a mező előtt lesz megjelenítve, 'append' hatására utána, 'max' a menthető karkterek maximális számát korlátozza, '1' hatására a következő mező vagy jelölőnégyzet ugyanabban a sorban fog szerepelni. Ha csak '1'-et adunk meg akkor az azt jelenti hogy a következő mező ugyanabban a sorban fog szerepelni.",
"Textarea options: quicktags,width,height,max,listmax,wordmax - Use Quicktags is 1 or 0, width is indicated in chars, height is indicated in lines, max is the maximum number of characters that can be saved, listmax is the maximum number of characters that are displayed in list mode, wordmax>0 alert if word count exceeded, wordmax<0 display word count." => "Szöveges terület opciók: 'quicktags,width,height,max,listmax,wordmax' ahol 'quicktags' jelöli hogy használjunk-e quicktag-eket a területnél, értéke lehet 1 vagy 0, 'width' a szélességet jelöli karakterek számában kifejezve, 'height' a magasságot sorok számában kifejezve, 'max' a menthető karakterek maximális száma, 'listmax' a listázási módban megjelenített karakterek maximális számát korlátozza, 'wordmax>0' figyelmeztet ha a szavak száma meghaladja a határt, 'wordmax<0' megjeleníti a szavak számát.",
"Checkbox options: put 1 if you need that next field is on the same row." => "Jelölőnégyzet opciók: tegyünk egy 1-est ha szeretnénk hogy a következő mező is ugyanabban a sorban szerepeljen",
"Numeric options: 1,size,prepend,append with size in chars, prepend will be displayed before the field append will be displayed just after, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Numerikus opciók: '1,size,prepend,append, ahol 'size' a méretet adja meg karakterek számában kifejezve, 'prepend' hatására a jelőlőnégyzet a mező előtt, 'append' hatására a mező után lesz megjelenítve, valamint ha az elején megadjuk az '1'-et akkor a következő szöveges mező vagy jelölőnégyzet ugyanabban a sorban szerepel majd. Ha csak az '1'-et adjuk meg akkor a következő mező is ugyanabban a sorban lesz",
"Dropdown options: list of items separated with commas." => "legördülő opciók: tételek listája vesszővel elválasztva.",
"Default value is specified by having the value indicated twice consecutively" => " Alapértelmezett értéket úgy lehet megadni hogy az értéket egymásután kétszer adjuk meg",
"Radio buttons options: list of items separated with commas." => "Választókapcsoló opciók: tételek listája vesszővel elválasztva.",
"User Selector options: automatic field feeding,email - feeding=1 for author login or feeding=2 for modificator login - email=1 to send an email to the user if the tracker is modified" => "Felhasználóválasztás opciói: 'automatic field feeding,email', ahol ha 'feeding=1' akkor a szerző bejelentkezési neve lesz automatikusan kitöltve, ha 'feeding=2' akkor a módosító bejelentkezési neve, 'email=1' hatására E-mail kerül kiküldésre a felhasználónak ha az űrlapot módosították",
"Group Selector: use options for automatic field feeding : you can use 1 for group of creation and 2 for group where modification come from. The default group has to be set, or the first group that come is chosen for a user, or the default group is Registered." => "Csoportválasztás opciói: automatikus mezőkitöltéshez használjuk '1'-et a létrehozó csoportjának, '2'-őt a módosító csoportjának megjelenítéséhez. Meg kell adni az alapértelmezett csoportot vagy a felhasználóhoz kapcsolódó első sorbaeső csoport lesz kiválasztva vagy az alapértelmezett 'Registered' csoport",
"IP Selector: use options for automatic field feeding : you can use 1 for author IP or 2 for modificator IP." => "IP kiválasztás opciói: automatikus mezőkitöltéshez használjuk '1'-est a szerző IP-jének,'2'-est a változtató felhasználó IP-jének megjelenítésére",
"Country Selector options: name/flag, sortorder - name/flag is 0,1 or 2 where 1 shows only country name, 2 shows only country flag, 0 shows both (default). sortorder is 0 or 1 where 0 sorts according to translated text (default) and 1 sorts according to english country names even if country names are translated" => "Országválasztás opciói: 'name/flag, sortorder', ahol 'name/flag' értéke lehet 0,1 vagy 2 ('1' csak az országnevet mutatja, '2' csak a zászlót mutatja, '0' mindkettőt - ez utóbbi az alapértelmezett beállítás), 'sortorder' értéke lehet '0' vagy '1' ('0' hatására a lefordított szövegnek megfelelően rendez - ez az alapértelemett beállítás -, '1' hatására az angol országneveknek  megfelelően rendez még ha az országnevek le is vannak fordítva",
"Date Time options: date_time,year0,year1 where date_time=d|dt(default), d displays only date, year0 is the first year, year1 the last" => "Dátum és idő opciók: 'date_time,year0,year1', ahol 'date_time=d|dt(alapértelmezett)' - 'd' csak dátumot jelenít meg, 'dt' dátumot és időt, 'year0' az első év, 'year1' az utolsó",
"Jscalendar options: date_time where date_time=d|dt(default), d displays only date" => "Jscalendar opciók: 'date_time',  ahol  'date_time=d|dt(alapértelmezett)' - 'd' csak dátumot jelenít meg, 'dt' dátumot és időt",
"Image options: xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale indicated in pixels." => "Kép opciók: xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale pixelekben kifejezve",
"Action options: Label,post,tiki-index.php,page:fieldname,highlight=test" => "Akció opciók: 'Label,post,tiki-index.php,page:fieldname,highlight=test'",
"Static text options: Wikisyntax,listmax - Use Wikisyntax is 1 or 0, listmax is the maximum number of characters that are displayed in list mode." => "Statikus szöveg opciók: 'Wikisyntax,listmax' ahol 'Wikisyntax' értéke lehet 1 vagy 0, 'listmax' a listázási módban megjelenített karakterek maximális számát jelenti",
"Category options: parentId,d|m|radio|checkbox(default),1|0(default) to have a select all button, d for dropdown, m for multiple drop down" => "Kategória opciók: 'parentId,d|m|radio|checkbox(alapértelmezett érték),1|0(alapértelmezett érték)' összes gomb kiválasztásához, 'd' legördülő menühöz, 'm' többszörös legördülőhöz",
"Item Link options: trackerId,fieldId,linkToItem,displayedfieldslist links to item from trackerId which fieldId matches the content of that field. linkToItem 1|0 to create a link to the item in view mode and listing.  Display displayedfieldslist(separate with |) instead of the target item" => "Tétel link opciók: 'trackerId,fieldId,linkToItem,displayedfieldslist' linkel a 'trackerId'-ből (űrlapazonosítóból) a 'fieldId' (mezőazonosító) mely egyezik azon mező tartalmával. 'linkToItem 1|0' opcióval linket hozunk létre az űrlaptételhez sima vagy listanézet megjelenítésben. A 'displayedfieldslist' segítségével mezőket lehet listázni (|-al elválasztva) a teljes céltétel helyett",
"Items list options: trackerId,fieldIdThere, fieldIdHere, displayFieldIdThere, linkToItems displays the list of displayFieldIdThere from item in tracker trackerId where fieldIdThere matches fieldIdHere. linkToItems 1|0 to create a link to items in view mode and listing" => "Tétel listázási opciók: trackerId,fieldIdThere, fieldIdHere, displayFieldIdThere, linkToItems megjeleníti a displayFieldIdThere mezők trackerId űrlap alatti tételekben szereplő listáját ahol fieldIdThere egyezik fieldIdHere értékével. linkToItems 1|0 opcióval linket lehet létrehozni megjelenítési és listázási módban",
"dynamic items list options: trackerId, filterFieldIdThere, filterFieldIdHere, listFieldIdThere, statusThere insert the list of listFieldIdThere from item in tracker trackerId where filterFieldIdThere matches filterFieldIdHere where status is statusThere." => "dinamikus tételek listázási opciói: trackerId, filterFieldIdThere, filterFieldIdHere, listFieldIdThere, statusThere beilleszti a listFieldIdThere listáját a trackerId űrlap tételéből ahol filterFieldIdThere egyezik a filterFieldIdHere értékével és ahol a státusz statusThere.",
"Email address options: 0|1|2 where 0 puts the address as plain text, 1 does a hex encoded mailto link (more difficult for web spiders to pick it up and spam) and 2 does the normal href mailto." => "E-mail cím opciók: 0|1|2 ahol 0 esetén a címet egyszerű szövegként, 1 esetén hex kódolt mailto link formájában (megnehezítve így hogy spammerek kiszedjék az oldalból) és végül 2 esetén a normál href mailto formájában kerül megjelenítésre.",
" 0|1|2|3|4|5 0,xsize,ysize. First record :0 for URL in file gal of MP3 only, 1 for URL of FLV in file gal video only , 2 for URL of MP3 or Video in file gal, 3 donwload MP3 only, 4 donwload FLV video only, 5 download FLV or MP3 (default is 0). Second record : X size of flash applet(default is 200) , Y size of flash applet (default is 100) " => "Multimédia opciók: '0|1|2|3|4|5 0,xsize,ysize' Első rekord:0 csak fájlgalériában szereplő mp3-akra mutató URL-hez, '1' csak fájlgalériában szereplő FLV-kre (flash videó) mutató URL-hez, '2' az előző kettő vagy-vagy kapcsolata, '3' csak MP3 letöltés, '4' csak FLV videó letöltése, '5' előző vagy-vagy kapcsolata (az alapértelmezett érték 0). Második rész: 'xsize' a flash applet X mérete (az alapértelmezett érték 200) , 'ysize' a flash applet Y mérete (az alapértelmezett érték 100)",
"Sequential auto-increment number:initial_value,prepend,append,itemId: initial_value default is 1, prepend will be displayed before the field, append will be displayed just after, itemId will use the item Id" => "Szekvenicális automatikus sorszámozás opciók: 'initial_value,prepend,append,itemId' ahol 'initial_value' alapértelmezett értéke 1, 'prepend' hatására a mező előtt kerül megjelenítésre, 'append' hatására utána, 'itemId' a tétel azonosítóját fogja használni",
"Allow registered user to subscribe to an item. They can add a number of friends." => "Regisztrált felhasználók előfizethetnek egy tételre. Hozzáadhatnak barátokat is.",
"Use Google Maps." => "Google térképek használata",
"Formula for computation, using # for indicating fields and +,*,/,- and parenthesis for operations." => "Formula számításokhoz, a '#' mezőket jelez, a '+,*,/,-' jeleket műveletekhez használhatjuk",
"listview=nst, n to see name/t to see type/s to see type/u to see user in list mode" => "listanézet=nst, 'n' a név megtekintéséhez, 't' a típus megtekintéséhez, 's' típus megtekintéséhez, 'u' felhasználó megtekintéséhez listázási nézetben",
"Import/Export Trackers" => "Űrlapok importálása/exportálása",
"List FAQs Tpl" => "GYIK tpl listázása",
"Admin Tracker" => "Űrlap adminisztrálása",
"password|email" => "jelszó|E-mail",
"If you want to use images please save the post first and you will be able to edit/post images. Use the <img> snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor." => "Ha képeket is szeretnénk a poszthoz fűzni akkor először mentsük a posztot. Mentés után lesz lehetőség képek hozzáadására / szerkesztésére. Használjuk az <img> tag-et feltöltött képek szövegterületben való megjelenítéséhez. Másik lehetőség a WYSIWYG szerkesztő kép URL lehetőségének alkalmazása.",
"If you want to use images please save the post first and you will be able to edit/post images. Use the <img> snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor" => "Ha képeket is szeretnénk a poszthoz fűzni akkor először mentsük a posztot. Mentés után lesz lehetőség képek hozzáadására / szerkesztésére. Használjuk az <img> tag-et feltöltött képek szövegterületben való megjelenítéséhez. Másik lehetőség a WYSIWYG szerkesztő kép URL lehetőségének alkalmazása",
"Mark entry as private" => "Privát bejegyzés",
"To add/remove blogs, go to \"Create/Edit blog\" under \"Blogs\" on the application menu, or" => "Blogok hozzáadásához/eltávolításához lásd a \"Blog létrehozása/szerkesztése\" menüpontot a \"Blogok\" menü alatt az alkalmazás fő menüjében, vagy",
"Blog features" => "Blog funkciók",
"Trackbacks Pings" => "Visszakövetési pingek (trackbacks pings)",
"Post level trackback pings" => "Poszt szintű trackback pings",
"Blogs have a custom heading" => "Blogok saját fejléccel rendelkeznek",
"Last modification time" => "Utolsó módosítás",
"Admin Html Pages" => "HTML oldalak adminisztrálása",
"Admin Html Pages Template" => "HTML oldalah sablonjának adminisztrálása",
"Admin quizzes" => "Kvízek adminisztrálása",
"Admin Quizzes tpl" => "Kvíz sablon adminisztrálása",
"Stats for quiz" => "Kvíz statisztika",
"An error as occured with the mapfile: " => "Hiba lépett fel a mapfile kapcsán: ",
"Layer management" => "Rétegek kezelése",
"File Title" => "Fájl neve",
"Unzip all zip files" => "Összes ZIP fájl kicsomagolása",
"Note: Maximum file size is limited to" => "Megjegyzés: a fájlméret maximuma",
"Note: Maximum file size is limited to:" => "Megjegyzés: a fájlméret maximuma:",
"Edit User Contacts Preferences" => "Felhasználói kontaktok beállításának szerkesztése",
"User Tasks tpl" => "Felhasználói feladatok tpl",
"Flash Lenght" => "Flash hossza",
"Video Lenght" => "Video hossza",
"To configure your directory, find \"Admin directory\" under \"Directory\" on the application menu, or" => "Könyvtár beállításához lásd a \"Könyvtár adminisztrálása\" menüpontot a \"Könyvtár\" menü alatt az alkalmazás menüjében, vagy",
"Freetags rock!" => "Freetags rock!",
"Show Tag Cloud" => "Címkefelhő mutatása",
"Random tag cloud colors (separated by comma)" => "Véletlenszerű címkefelhő színek (vesszővel elválasztva)",
"Preload freetag random search when arriving on <a href=\"tiki-browse_freetags.php\">freetag search grid</a>" => "Címke véletlenszerű előtöltése a <a href=\"tiki-browse_freetags.php\">címkekeresőre</a> történő megérkezéskor",
"Number of Tags to show in Cloud" => "Felhőben megjelenítendő címkék száma",
"Only accept alphanumeric ASCII freetags (no accents or special chars)" => "Csak alfanumerikus ASCII címkék elfogadása (idézőjelek és más speciális karakterek kizárása)",
"Accept all" => "Összes elfogadása",
"Only accept lowercase freetags" => "Csak kisbetűs címkék elfogadása",
"Handle multilingual freetags" => "Többnyelvű címkék kezelése",
"cleanup" => "Eltávolítás",
"More Like This/Get Similar Module" => "Több hasonló/Hasonlók beszerzése modul",
"More Like This algorithm" => "Több hasonló algoritmus",
"Basic algorithm - Minimum amount of tags in common" => "Alapalgoritmus - közös címkék minimális száma",
"Group calendar sticky popup" => "Csoportnaptár ragadós felugró ablak",
"Group calendar item view tab" => "Csoportnaptár tétel nézet fül",
"Calendar manual selection of time/date" => "Naptár manuális idő/dátum választás",
"First year in the dropdown, either year number, or relative to current year (+/- N)" => "Első év a legördülő menüben, vagy évszám vagy relatív az idei évhez (+/- N)",
"if no jscalendar" => "ha nincs jscalendar",
"Last year in the dropdown, either year number, or relative to current year (+/- N)" => "Utolsó év a legördülő menüben, vagy évszám vagy relatív az idei évhez (+/- N)",
"Allow Anonymous Poll Voting" => "Anonim szavazás engedélyezése",
"Trackers attachments preferences" => "Űrlapmellékletek beállításai",
"Trackers attachments" => "Űrlapmellékletek",
"Wiki Discussion" => "Wiki megbeszélése",
"Wiki Link Format" => "Wiki link formátum",
"Controls recognition of Wiki links using the two parenthesis Wiki link syntax <i>((page name))</i>." => "Wiki linkek felismerésének ellenőrzése a kettős kerek zárójel wiki link szintakszis használatával <i>((oldalnév))</i>.",
"Page name display stripper: choose a character that will be used as a delimiter to strip a final part of the page name (only concerns display)" => "Oldalnév lerövidítése a kiválasztott határoló karakter által (csak a megjelenítést érinti)",
"Wiki Page Staging and Approval" => "Wiki oldal jóváhagyás",
"Use wiki page staging and approval:" => "Wiki oldal jóváhagyás használata:",
"Hide page name prefix:" => "Oldalelőtag elrejtése:",
"Category for staging pages:" => "Jóváhagyás alatt lévő oldalak kategóriája:",
"Category for approved pages:" => "Jóváhagyott oldalak kategóriája:",
"Category for pages out of sync:" => "Szinkronból kicsúszott oldalak kategóriája:",
"Force bounce of editing of approved pages to staging:" => "Jóváhagyott oldalak szerkesztésének jóváhagyásra küldése:",
"Categorize approved pages with categories of staging copy on approval:" => "Jóváhagyott oldalak kategorizálása a jóváhagyási változat kategóriáira jóváhagyáskor:",
"Replace freetags with that of staging pages on approval:" => "Címkék kicserélése a jóváhagyási oldalváltozatokéra jóváhagyáskor:",
"Add new freetags of approved copy (into tags field) when editing staging pages:" => "Új címkék hozzáadása a jóváhagyott változathoz (a címkemezőbe) a jóváhagyás alatti oldalak szerkesztésekor:",
"Delete staging pages at approval:" => "Jóváhagyás alatti oldalváltozat törlése jóváhagyáskor:",
"Use external link icons:" => "Külső link ikonok használata:",
"User's Page:" => "Felhasználói oldal:",
"Wiki authors style by page settings:" => "Wiki szerzők stílusa oldalankénti beállítása",
"Protect email against spam:" => "E-mail cím védése spamek ellen:",
"When viewing a page, if it doesn't exist and has one like page, automatic redirection to this like page:" => "Automatikus átirányítás a hasonló oldalra oldal megtekintésekor ha létezik hasonló oldal:",
"Show/hide heading icon displayed before the heading:" => "Megjelenítés/elrejtés ikon megjelenítése a címsor előtt:",
"Page navigation bar position (displayed when page break '...page...' are used):" => "Oldalnavigációs sor pozíciója ('...page...' oldaltörés használata esetén kerül megjelenítésre):",
"Wiki actions bar position (e.g. Save, Preview, Cancel, ...):" => "Wiki akció sor pozíciója (pld Mentés, Előnézet, Mégse, ...):",
"Regex search and replace:" => "Regex keresés és kicserélés:",
"Log bytes changes (+/-) in Action Logs (slows each page modifications)" => "Byteméret változásának (+/-) loggolása az akció logban (lassítja az oldalak módosítását)",
"Support tickets" => "Támogatási jegyek",
"back to admin" => "vissza adminisztrátornak",
"Renamed" => "Átnevezés",
"Posted" => "Elküldés",
"Downloaded" => "Letöltés",
"Created wiki page" => "Létrehozott wiki oldal",
"Total number of users:" => "Felhasználók teljes száma",
"Total number of objects:" => "Objektumok teljes száma",
"file_galleries" => "fájlgalériák",
"html_pages" => "HTML oldalak",
"newsreader" => "hírolvasó",
"contacts" => "kontaktok",
"Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme'). Separator between params:'&'. E.g. maxlen=15&nonums=y." => "Paraméterek: specifikus paraméterek a modulhoz és/vagy általános paramétek a következők: ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme'). Paraméterek közi szeparátor:'&'. Pld: maxlen=15&nonums=y.",
"Path to the folder icon for close sections" => "Útvonal a zárt szekciók mappaikonjához",
"Provide also a folder icon for open sections with the same name with the letter 'o' before in the same directory (ex: folder.png and ofolder.png)" => "Adjunk meg mappaikont a nyitott szekciókhoz ugyanazzal a névvel 'o' előtaggal ugyanazon könyvtárban (pld: folder.png és ofolder.png)",
"Invalid password.  Your current password is required to change administrative information" => "Érvénytelen jelszó. Meg kell adni a jelenlegi jelszót az adminisztratív információk megváltoztatásához.",
"Reset view to site-wide default" => "Nézet visszaállítás a weblap alapértelmezésére",
"Regex search" => "Regex keresés",
"new submissions" => "beküldött új cikkek",
"new sites" => "új oldal",
"new calendar events" => "új naptári esemény",
"filesize" => "fájlméret",
"Select list items that will be displayed" => "Megjelenítésre kerülő listatételek kiválasztása",
"fields marked with a * are mandatory" => "a *-gal jelölt mezők kötelezőek",
"{\$atts_cnt} files attached" => "{\$atts_cnt} csatolt fájl",
"Antarctica" => "Antarktisz",
"Document repository" => "Dokumentumtár",
"News" => "Hírek",
"Knowledge base" => "Tudásbázis",
"successfully deleted" => "sikeresen törölve",
"successfully deleted." => "sikeresen törölve",
"Contributors to this page:" => "Hozzájárulók az oldal szerkesztéséhez",
"Config Calendars" => "Naptárak konfigurálása",
"Duplicate to" => "Duplikálás ide",
"... continued ..." => "... bővebben ...",
"Wiki page %s changed" => "A következő Wiki oldal megváltozott: %s",
"Upload big files (e.g. PodCast files) here:" => "Nagy méretű fájlokat ide töltsünk fel (pld FTP-n keresztül)",
"disable" => "kikapcsolás",
"Full Path to the Zip File" => "Zip fájl teljes útvonala",
"Add file" => "Fájl hozzáadása",
"Folder" => "Mappa",
"Note: To be managed with tiki , your flash banner link should be" => "Megjegyzés: ahhoz hogy a tiki jól kezelje, a flash banner linkje ilyen legyen",
"Note: To be managed with tiki, your flash banner link should be:" => "Megjegyzés: ahhoz hogy a tiki jól kezelje, a flash banner linkje ilyen legyen:",
"About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "WikiPluginok és biztonság: Csak a  \"tiki_p_plugin_approve\" jogosultságot adjuk meg azoknak a szerkesztőknek akikben megbízunk",
"You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "Kockázatos pluginokat itt deaktiválhatjuk: (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
"Allow anonymous accesss" => "Anonymus hozzáférés engedélyezése",
"To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "Saját ikonok használatához menükben adjuk meg az útvonalat az <strong>összezárt</strong> mappa ikonjához",
"In the same directory, include an icon for the opened folder" => "Ugyanabban a könyvtárban adjunk meg egy ikont a kinyitott mappához",
"The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "A \"kinyitott mappa\" ikon nevének meg kell egyeznie az \"összezárt\" ikon nevével, előtte az <strong>o</strong> előtaggal",
"For wiki page, use ((PageName))" => "Wiki oldalhoz használjuk az ((OldalNév)) szintakszist",
"Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Több szekció esetén: a szekciókat vesszővel ( , ) válasszuk el AND (ÉS) jellegű logikai kapcsolathoz, OR (VAGY) jellegű logikai kapcsolathoz pedig használjunk függőleges elválasztót ( | )",
"Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Több jogosultság esetén: a jogosultságokat vesszővel ( , ) válasszuk el AND (ÉS) jellegű logikai kapcsolathoz, OR (VAGY) jellegű logikai kapcsolathoz pedig használjunk függőleges elválasztót ( | )",
"Choose ..." => "Kiválasztás...",
"Groups monitor" => "Csoport figyelés",
"Ex" => "Pld",
"Send another message." => "Másik üzenet küldése",
"Send Pages" => "Oldal küldése",
"Prefix the checked" => "Kijelöltek kiegészítése ezen előtaggal",
"Postfix the checked" => "Kijelöltek kiegészítése ezen utótaggal",
"MyTiki Home" => "MyTiki kezdőlap",
"My Files" => "Fájljaim",
"Add a new mail account" => "Új postafiók hozzáadása",
"No newsletters available" => "Nincs elérhető hírlevél",
"Admin Directory" => "Linktár karbantartás",
"Admin Posts" => "Posztok adminisztrálása",
"New Article" => "Új cikk",
"Switch to WYSIWYG editor" => "Átváltás WYSIWYG szerkesztőre",
"Edit Comment:" => "Szerkesztési komment",
"Page saved (version %d)" => "Oldal elmentve (verzió %d)",
"Buttons: Save, Preview, Cancel, .." => "Gombok: Mentés, Előnézet, Visszavonás, ..",
"Page description, icons, backlinks, .." => "Oldal leírása, ikonok, backlinkek, ..",
"Buttons: Edit, Source, Remove, .." => "Gombok: Szerkesztés, Forrás, Eltávolítás, stb ..",
"Minor edits do not flag new content for translation and do not send watch notifications" => "Kisebb szerkesztések nem számítanak lefordítandó tartalomváltozásnak és a figyelési funkció értesítései sem kerülnek kiküldésre ",
"Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled" => "Csak a tiki_p_minor jogosultsággal rendelkező csoportok és az adminisztrátorok végezhetnek kisebb mentéseket a funkció bekapcsolásakor",
"Your edit session will expire in 1 minute. You must PREVIEW or SAVE your work now, to avoid losing your edits" => "A szerkesztési munkamenet 1 perc múlva lejár. Az ELŐNÉZET vagy a MENTÉS gomb lenyomásával megelőzhető a változtatások elvesztése",
"Create a Forum" => "Fórum létrehozása",
"When viewing a page, if it doesn't exist automatically redirect to a similarly named page" => "Oldal megtekintésekor ha az oldal nem létezik akkor automatikusan átirányít egy hasonló nevű oldalra",
"Maximum number of versions" => "Verziók maximális száma",
"Insert Smileys" => "Smiley beszúrása",
"No occurences found" => "Nem található előfordulás",
"Manage semantic tokens used throughout the wiki" => "Szemantikus tokenek kezelése a teljes wikiben",
"Webservice Registration" => "Webes szolgáltatás (webservice) regisztrálása",
"Discover and register web services to allow direct use in wiki pages" => "Közvetlenül wiki oldalakon használható webes szolgáltatások felderítése és regisztrálása.",
"Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "JSON-t vagy YAML-t visszaadó webes szolgáltatás URL-jét kell megadni. Paramétereket százalékjel közé zárva lehet megadni, de például: %name%. %service% és %template% foglalt kulcsszavak és nem szabad használni őket",
"Create shortcut syntaxes to plugins" => "Gyorshivatkozási szintakszisok létrehozása pluginokhoz",
"arguments" => "argumentumok",
"Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Kattintsunk a <a href=\"tiki-list_banners.php\" title=\"Banners\">Adminisztráció &gt; Bannerek</a> menüpontra banner zónák létrehozásához és szerkesztéséhez",
"<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Aktiválás</strong> bejelölésével a tartalom csak az adminisztrátorok számára jelenik meg. A <strong>Publikálás</strong> bejelölésével lesz elérhető az összes felhasználó számára",
"Include a flag by each e-mail to quickly flag/un-flag them" => "Minden E-mail megjelőlése gyors be/kijelölés céljából",
"The following list of changes has been applied" => "Az alábbi változások kerültek beállításra",
"preference name" => "preferencia neve",
"Use Tiki (database-independent) search" => "Tiki (adatbázis független) keresés használata",
"Use database (full-text) search" => "Adatbázis (full-text) keresés",
"The \"users can change theme\" feature will override the theme displayed" => "A \"Felhasználók változtathatják a stílust\" funkció felülírja a megjelenített stílust",
"Activate will only show content for admin. Check Publish to use content for all users" => "Aktiválás gombbal a tartalom csak az adminisztrátorok számára lesz látható. Publikálás bejelölésével az összes felhasználó láthatja.",
"Edit Comments length" => "Kommentek hosszának szerkesztése",
"Detect user timezone (if browser allows). Otherwise use site default" => "Felhasználó időzónájának felismerése (ha a böngésző megengedi). Ellenkező esetben weblap alapértelmezésének használata.",
"Output compression is active" => "Kimeneti tömörítés aktív",
"The \"Contact Us\" feature is disabled" => "A \"Kapcsolatfelvétel\" funkció ki van kapcsolva",
"Help page" => "Súgó oldal",
"You must select a file" => "Ki kell választani egy fájlt",
"Flash player not available" => "Flash lejátszó nem elérhető",
"(unchanged)" => "(változatlan)",
"Remaining" => "Maradék",
"Add email" => "E-mail hozzáadása",
"Add user" => "Felhasználó hozzáadása",
"Loading.." => "Betöltés..",
"The cache is used by" => "A cache-t használja:",
"Object Watches" => "Objektum figyelések",
"Watching Groups" => "Figyelő csoportok",
"Prologue" => "Prológus",
"Epilogue" => "Epilógus",
"The highlight pages already exist" => "A kiemelt oldalak már léteznek",
"Please register" => "Regisztráció szükséges",
"Enter your email" => "E-mail cím megadása",
"Date Search" => "Dátum keresés",
"Displays an miniquiz" => "Megjelenít egy minikvízt",
"Clear all Categories" => "Kijelölések eltávolítása",
"Plugin aliases" => "Plugin álnevek",
"Description text is tiki-parsed:" => "Leírás szövege tiki által elemzett:",
"For more information, please see <a href=\"{\$prefs.helpurl}Wiki Page Editor\">Wiki Page Editor</a>" => "További információkért lásd: <a href=\"{\$prefs.helpurl}Wiki oldal szerkesztése\">Wiki oldal szerkesztése</a>",
"Pass" => "Jelszó",
"HTTPS login" => "HTTPS bejelentkezés",
"Faq" => "GYIK",
"Includes an article's content within the page" => "Egy cikk tartalmát jeleníti meg egy oldalon belül",
"Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using TikiWiki with an incorrect database version usually causes errors" => "A weblap adatbázisa frissítésre szorul hogy megfeleljen a TikiWiki jelenlegi verziójának. Használjuk a <a href=\"tiki-install.php\">az installáló szkriptet</a>. Figyelem: a TikiWiki használata inkorrekt adatbázissal hibákat eredményezhet",
"Module name as known in Tikiwiki" => "Modul Tikiwikiben ismert neve",
"Name of the quoted person" => "Az idézett személy neve",
"wrote" => "írta",
"Create Directory" => "Könyvtár létrehozása",
"Archive is full" => "Az archívum megtelt",
"Mailbox is full! Delete or archive some messages if you want to receive more messages" => "A postafiók megtelt! Törölni vagy archiválni kéne hogy legyen hely új üzeneteknek",
"A new version of Tikiwiki, <b>{\$tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">http://tiki.org/Download</a>" => "Elérhető a Tikiwiki verziója (<b>{\$tiki_release}</b>). A weblap jelenleg a következő verzión fut: <b>{\$tiki_version}</b>. Látogassunk el ide a legújabb verzióért: <a href=\"http://tiki.org/Download\">http://tiki.org/Download</a>",
"Edit successful" => "Sikeres szerkesztés",
"Welcome to the Tiki installation and upgrade script" => "Üdvözlet a Tiki telepítő és frissítő szkriptjében",
"Select your language" => "Nyelv kiválasztása",
"Tiki is software distributed under the LGPL license" => "A Tiki szoftver LGPL licensz alatt fut",
"Before installing Tiki, <a href=\"http://doc.tiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "A Tiki telepítése előtt <a href=\"http://doc.tiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">olvassuk el a dokumentációt</a> és győződjünk meg róla hogy rendelkezésre állnak a minimális rendszerkövetelmények",
"This installer will perform some basic checks automatically" => "A telepítő automatikusan végrehajtott pár ellenőrzést melyek eredménye alább található",
"Tiki has not detected your PHP memory_limit" => "A Tiki nem tudta megállapítani a PHP memory_limit értékét",
"This probably means you have no set limit (all is well)" => "Ez valószínűleg azt jelenti hogy nincs határ beállítva (vagyis minden rendben)",
"Tiki has detected your PHP memory limit at" => "A Tiki a következő PHP memory_limit értéket találta",
"Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "A Tikinek <strong>legalább</strong> 32MB PHP memoriára van szüksége a szkriptek végrehajtásához",
"Allocating too little memory will cause Tiki to display blank pages" => "Túl kevés memória allokálása esetén a Tiki üres oldalak fog megjeleníteni",
"To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver" => "A memória limit értékének megváltoztatásához használjuk a <strong>memory_limit</strong> kulcsot a <strong>php.ini </strong> fájlban (például: memory_limit = 32M) majd indítsuk újra a webszervert",
"Tiki has detected your PHP memory_limit at" => "A Tiki a következő PHP memory_limit értéket találta",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "A Tiki a PHP <strong>mail</strong> funkciót használja E-mail értesítések és üzenetek kiküldésére",
"To test your system configuration, Tiki will attempt to send a test message to you" => "A rendszerbeállítások tesztelésére a Tiki megpróbál tesztüzenetet küldeni",
"Test email" => "Teszt E-mail",
"Email address to send test to" => "E-mail üzenet címzettje",
"Tiki was not able to send a test message" => "A Tiki nem tudta kiküldeni a tesztüzenetet",
"Review your mail log for details" => "Nézzük meg a levelezési log-ot további részletekért",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Tekintsük át a <strong>php.ini</strong> fájlban található mail beállításokat (például nézzük meg hogy a <strong>sendmail_path</strong> helyesen van-e beállítva)",
"If your host requires SMTP authentication, additional configuration may be necessary" => "Ha a hoszt SMTP azonosítást igényel akkor további konfiguráció is szükséges lehet",
"Tiki detected" => "A Tiki felismerte a következőt",
"Tiki was not able to detect the GD library" => "A Tiki nem tudta felismerni a GD könyvtárat",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "A Tiki a GD könyvtárat használja képek feldolgozásához és a CAPTCHA támogatáshoz",
"Tiki requires an active database connection" => "A Tiki aktív adatbázis kapcsolatot igényel",
"You must create the database and user <em>before</em> completing this page" => "Létre kell hozni az adatbázist és az adatbázishoz tartozó felhasználó nevet az alábbi adatok megadása <em>előtt</em>",
"Tiki cannot find a database connection" => "A Tiki nem talált adatbázis kapcsolatot",
"This is normal for a new installation" => "Ez így van rendjén új telepítés esetén",
"Tiki found an existing database connection in your local.php file" => "A Tiki talált egy létező adatbázis kapcsolatot a local.php fájlban",
"Use this page to create a new database connection, or use the <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Használjuk ezt az oldalt új kapcsolat létrehozására, vagy használjuk a <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manuális telepítés\">manuális telepítés folyamatot</a>",
"Enter your database connection information" => "Adatbázis kapcsolat megadása",
"Database type" => "Adatbázis típusa",
"Select the type of database to use with Tiki" => "Tikihez használandó adatbázis kiválasztása",
"Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension" => "Csak a PHP telepítés által támogatott adatbázisok láthatóak itt. Ha a kívánt adatbázis nem szerepel a listában akkor telepíteni kell a szükséges PHP kiterjesztést",
"Enter the host name or IP for your database" => "Adatbázis hoszt nevének vagy IP címének megadása",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Használjuk a <strong>localhost</strong> kifejezést ha az adatbázis ugyanazon a gépen fut ahol a Tiki",
"For SQLite, enter the path and filename to your database file" => "SQLite-hoz adjuk meg az útvonalat és a fájlnevet az adatbázis fájlhoz",
"Database name" => "Adatbázis neve",
"Enter the name of the database that Tiki will use" => "A Tiki által használandó adatbázis nevének megadása",
"The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names" => "Az adatbázisnak már léteznie kell. Létrehozhatjuk az adatbázist mysqladmin, PHPMyAdmin, cPanel vagy a hoszting szolgáltatónk segítségével. Általában a Tiki tábla nevei nem ütköznek más termékek táblaneveivel",
"For Oracle" => "Oracle-hez",
"Enter your TNS Name here and leave Host empty" => "Adjuk meg itt a TNS nevet és hagyjuk a hoszt mezőt üresen",
"Override tnsnames.ora and put your SID here and enter your hostname:port in the Host field" => "Tnsnames.ora felülbírálása és az SID megadása, majd a hostname:port információ rögzítése a 'Hoszt' mezőben",
"Enter a database user with administrator permission for the Database" => "Az adatbázishoz adminisztrátori jogokkal rendelkező adatbázis felhasználó nevének megadása",
"Select the installation (or upgrade) profile to use. This profile will populate (or upgrade) the database" => "Válasszuk ki a használandó telepítési (vagy frissítési) profilt. A kiválasztott profil alapján kerül feltöltésre (vagy frissítésre) az adatbázis",
"Select the installation profile to use. This profile will populate the database" => "Válasszuk ki a használandó telepítési profilt. A kiválasztott profil alapján kerül feltöltésre az adatbázis",
"Profiles can be used to pre-configure your site with specific features and settings" => "Profilok segítségével előkonfigurálhatjuk a weblapot bizonyos funkciókkal és beállításokkal",
"Visit <a href=\"http://profiles.tiki.org\" target=\"_blank\">http://profiles.tiki.org</a> for more information" => "További információkért lásd <a href=\"http://profiles.tiki.org\" target=\"_blank\">http://profiles.tiki.org</a>",
"This will destroy your current database" => "Ez megsemmisíti a jelenlegi adatbázist",
"Create a new database (clean install) with profile" => "Új adatbázis létrehozása profil segítségével",
"See the documentation for <a target=\"_blank\" href=\"http://profiles.tiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Description of available profiles.\">descriptions of the available profiles" => "További információkért lásd a <a target=\"_blank\" href=\"http://profiles.tiki.org/Profiles_in_30_installer\" class=\"link\" title=\"profil dokumentáció\">profil dokumentációt",
"The installer could not connect to the Profiles repository" => "A telepítő nem tudta elérni a profilokat",
"The default installation profile will be used" => "Az alapértelmezett telepíŧési profil kerül felhasználásra",
"This site has an admin account configured" => "Ez a weblap már rendelkezik egy adminisztrátori fiókkal",
"Please login with your admin password to continue" => "A folytatáshoz be kell jelentkezni az adminisztrátori jelszóval",
"Your database has been configured and Tiki is ready to run" => "Az adatbázis konfigurálásra került és használatra kész",
"If this is your first install, your admin password is <strong>admin</strong>" => "Ha ez az első telepítés volt akkor az adminisztrátori jelszó <strong>admin</strong>",
"You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "Be lehet jelentkezni a Tikibe <strong>admin</strong> felhasználó névvel és el lehet kezdeni az alkalmazás konfigurálását",
"Upgrade operations executed successfully" => "A frissítési műveletek sikeresen lefutottak",
"Installation operations executed successfully" => "A telepítési műveletek sikeresen lefutottak",
"SQL queries" => "SQL lekérdezés",
"Database was left unchanged" => "Az adatbázis nem változott",
"Operations failed" => "Sikertelen műveletek",
"Display details" => "Részletek megjelenítése",
"During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "Frissítés során normális ha <strong>Table already exists</strong> SQL hibaüzeneteket kapunk ",
"Complete these fields to configure common, general settings for your site" => "Ezen mezők kitöltésével az oldalra vonatkozó általános beállítások adhatóak meg",
"The information you enter here can be changed later" => "Az itt megadott adatok később megváltoztathatóak",
"Refer to the <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Bővebb információ a beállításokról <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">itt</a>",
"This will appear in the browser title bar" => "Ez jelenik majd meg a böngésző címsorában",
"Email sent by your site will use this address" => "A weblap által küldött E-mailek ezen címet fogják használni",
"Admin email" => "Adminisztrátor E-mail",
"This is the email address for your administrator account" => "Ez az adminisztrátori fiók E-mail címe",
"The installation is complete" => "A telepítés véget ért",
"Tiki is an opensource project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>develop Tiki</a>" => "A Tiki egy opensource (nyílt forráskódú) projekt, <em>bárki</em> <a href='http://info.tiki.org/Join+the+Community' target='_blank'>csatlakozhat a közösséghez</a> és segíthet <a href='http://info.tiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>a Tiki továbbfejlesztésében</a>",
"If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "Ha ez egy első telepítés akkor konfiguráljuk a Tiki-t a <strong>tiki-admin.php</strong> oldal segítségével bejelentkezés után",
"If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "Ha egy meglévő telepítést frissítettünk akkor vagy manuálisan ürítsük ki a cache-t (a <strong>templates_c</strong> könyvtárat) vagy használjuk a <strong>Cache/rendszer</strong> menüpontot az Adminszitráció menüben",
"Adding a new host" => "Új hoszt hozzáadása",
"Are you upgrading an existing Tiki site" => "Már létező Tiki weblap frissítéséről van szó",
"Go directly to the <strong>Install/Upgrade</strong> step" => "Ebben az esetben ugorjunk a <strong>Telepítés/Frissítés</strong> lépésre",
"Restart the installer" => "Telepítő újraindítása",
"Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Hiányzó előfeltétel, szerezzük be a <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> fájlt és töltsük fel a files/ könyvtárba",
"Subscription failed" => "Feliratkozás nem sikerült",
"Your identity gives you access to multiple user accounts" => "Az azonosító hozzáférést biztosít több felhasználói fiókhoz",
"No plugin pending approval" => "Nincs jóváhagyásra váró plugin",
"Edit this sheet" => "Ezen ív szerkesztése",
"Use the &quot;Quick Edit&quot; module to easily create or edit wiki pages. Select" => "Használjuk a &quot;Wiki oldal szerkesztése&quot; modult wiki oldalak gyors létrehozásához/szerkesztéséhez. Válasszuk",
"Support" => "Támogatás",
"__WARNING__: Plugin disabled \$plugin" => "__FIGYELEM__: Plugin ki van kapcsolva: \$plugin",
"__WARNING__: No such module \$plugin" => "__FIGYELEM__: Nincs ilyen modul: \$plugin",
"Sea Surfing (CSRF) detected. Operation blocked" => "CSRF tevékenység, a művelet átmenetileg bokkolva",
"The name of the anchor" => "A horgony neve",
"Autogenerated content. Leave blank initially" => "Automatikusan generált tartalom. Először hagyjuk üresen",
"Image alignment. Possible values: left, right, center" => "Kép igazítás. Lehetséges értékek: left, right, center",
"The article field to display. Default field is Heading" => "A megjelenítendő cikk mező. Alapértelmezett mező a cikk fejléce",
"The article to display. If no value is provided, most recent article will be used" => "A megjelenítendő cikk azonosítója. Ha nincs érték megadva akkor a legutóbbi cikkek kerülnek listázásra",
"The number of articles to display in the list" => "A listában megjelenítendő cikkek száma",
"The ID of the category to list from" => "Ezen kategória azonosítóhoz (ID-hoz) tartozó cikkek kerülnek megjelenítésre",
"The article language to list" => "Listázandó cikkek nyelve",
"The column and order of the sort in columnName_asc or columnName_desc format" => "Az oszlop és a rendezés módja columnName_asc vagy columnName_desc formátumban",
"Whether to not report when there are no articles" => "Jelentse-e ha nincs cikk",
"Whether to only show the title of the articles" => "Csak a cikkek címét jeleníti meg",
"The wiki page the avatar will link to" => "A wiki oldal melyre az avatár mutat",
"As defined by CSS, name or Hex code" => "CSS, név vagy Hex kód által definiálva",
"In pixels or percentage. Default value is 100%" => "Pixelszámban vagy százalékban kifejezve. Az alapértelmezett érték 100%",
"for box with width less than 100%, make text wrap around the box" => "100%-nál kisebb szélességű dobozoknál a szöveg a doboz köré kerül rendezésre",
"Apply custom CSS class to the box" => "Saját CSS osztály alkalmazása a dobozhoz",
"List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "Kategótia ID-k listája + jellel elválasztva. Pld: 1+2+3. Alapértelmezés az adott oldal kategóriája",
"String used to separate the categories in the path. Default character is >" => "Kategóriák elválasztásához használt sztring az útvonalban. Alapértelmezett karakter: >",
"Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool" => "Megjelenít egy Tikiíven alapuló ábrát. A plugint a Tikiív ábrageneráló eszköze generálja",
"Chart caption" => "Ábra felirata",
"List of colors to use" => "Használandó színek listája",
"List of styles to use" => "Használandó stílusok listája",
"Labels for the series or values in the legend" => "Jelmagyarázat feliratai sorozatokhoz vagy értékekhez",
"Code snippet label" => "Kódrészlet felirata",
"0|1, Enable word wrapping on the code to avoid breaking the layout" => "0|1, Szövegtörés bekapcsolásával elkerülhető a kinézet szétesése",
"Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Használandó szintakszis kiemelés. Nem használjuk 'Sorok száma' használata esetén. Lehetőségek: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
"0|1, may not be used with colors" => "0|1, ne használjuk 'Színek' használata esetén",
"0|1, parse wiki syntax within the code snippet" => "0|1, kódrészlet elemzése wiki szintakszissal",
"Includes content from the dynamic content system" => "Dinamikus tartalomkezelő tartalmát jeleníti",
"Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Minta a szerzői jog megjelenítéséhez. Lehetőségek: ~title~, ~year~ és ~authors~",
"Displays a countdown from now until the specified date" => "Jelen pillanattól egy adott dátumig tartó visszaszámlálást jelenít meg",
"Text to append to the countdown" => "Visszaszámláláshoz tartozó szöveg",
"Target date. Multiple formats accepted" => "Cél dátum. Többféle fomrátum is elfogadott",
"The name of a DSN connection defined by the Wiki administrator" => "A Wiki adminisztrátora által definiált DSN kapcsolat",
"0|1, parse wiki syntax within the report" => "0|1, riport wiki szintakszis általi elemzése",
"0|1, display the parsed report definition" => "0|1, megjeleníti az elemzett riport definíciót",
"No DSN connection string found" => "Nem található DSN kapcsolat sztring",
"left|right, for box with width less than 100%, make text wrap around the box" => "left|right, 100%-nál kisebb szélességű dobozoknál a szöveg a doboz köré kerül rendezésre",
"One entry per line. Each line is in \"Term: Definition\" format" => "Egy bejegyzés soronként. Minden sor ebben a formátumban legyen: \"Term: Definition\"",
"Name of the drawing to display" => "Megjelenítendő rajz neve",
"Renders an equation written in LaTeX syntax as an image" => "LaTeX szintakszisban írt egyenletet renderel képpé",
"Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large" => "Normál méretről való növelés százalékban kifejezve. 100 adja meg az alapértelmezett méretet. 200 duplájára növeli a képet",
"Includes the list of events from a calendar in the page" => "Egy naptár eseményeit listázza az oldalon",
"Displays a label. On click, the block of content will fade in and fade out" => "Megjelenít egy feliratot. A feliratra történő kattintásra megjelenik a felirathoz tartozó tartalom. Újabb kattintásra eltűnik a tartalom és ismét csak a felirat látszik",
"Wiki syntax containing the text to display" => "Wiki szintakszisban írt szöveg",
"One item per line starting with anything followed by \")\"" => "Egy tétel soronként, kezdődhet bármivel \")\" után",
"One row per line, cells separated by ~|~" => "Egy sor soronként, cellákat ezzel válasszuk el: ~|~ ",
"Heading row of the table, same format as the body section" => "Tábla fejléc sora, ugyanolyan formátumú mint a törzs",
"CSS class to apply to the heading row" => "Fejléc soron alkalmazandó CSS osztály",
"Displays a file attachment or a list of them" => "Csatolt fájlt vagy csatolt fájlok listáját jeleníti meg",
"Displays a list of files" => "Fájlok listáját mutatja",
"Complete URL to the movie to include" => "Teljes URL a mozihoz",
"Bar width in pixels" => "Sor szélessége pixelben",
"true|false, if true then a percentage of the maximum is displayed" => "true|false, ha true ('igaz') akkor a maximum százaléka kerül megjelenítésre",
"Add the tracking code for Google Analytics" => "Google Analytics nyomonkövetési kódjának hozzáadása",
"The account number for the site" => "Az oldal számla (fiók) száma",
"Leave this empty" => "Hagyjuk üresen",
"Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large" => "Keret mérete, használjuk width (szélesség) és height (magasság) helyett. Segíŧségéel a Google anyagok mérete pontosa illeszkedni fog. Lehetőségek: small|medium|large",
"Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "A feltételek esetén megjelenítendő wiki szöveg. A szövegtörzs tartalmazhat {ELSE}-t. A marker utáni szöveg csak azon felhasználóknak kerül megjeleníŧésre akik nem felelnek meg a feltételnek",
"0|1, parse wiki syntax within the html code" => "0|1, wiki szintakszis elemzése a HTML kódon belül",
"Alias: lnk. Location the image should point to" => "Alias: lnk. Lokáció melyre a kép mutat",
"\"rel\" attribute to add to the link" => "Linkehz hozzáadandó \"rel\" attribútum",
"Title text" => "Cím szöveg",
"Alternate text to display if impossible to load the image" => "Ha a kép betöltése vlamiért nem lehetséges akkor ez az alternatív felirat jelenik meg",
"Image description to display on the page" => "Oldalon megjelenítendő kép leírása",
"Name of the image map to use for the image" => "A kép térkép neve mely a képhez használva lesz",
"Display an image" => "Egy kép megjelenítése",
"Displays an image" => "Egy kép megjelenítése",
"Full URL to the image to display" => "A megjelenítendő kép teljes URL-je",
"Height of the image to display" => "A megjelenítendő kép magassága",
"Width of the image to display" => "A megjelenítendő kép szélessége",
"Image alignment in the page. (left, right, center) Uses HTML IMG tag" => "Kép igazítása az oldalon. (left, right, center) HTML IMG tag-et használja",
"Image alignment in the flow of the document. (left, right, none) Uses CSS float property" => "Kép igazítása a dokumentumban. (left, right, none) CSS float property-t használja",
"Style to apply to the image" => "A képen alkalmazandó stílus",
"Include a page's content" => "Egy másik oldal tartalmát jeleníti meg",
"Wiki page name to include" => "A wikioldal neve amely megjelenítésre kerül",
"When only a portion of the page should be included, specify the marker from which inclusion should start" => "Ha az oldalnak csak egy részét szeretnénk megjeleníteni akkor meg kell adni a kezdés helyét",
"When only a portion of the page should be included, specify the marker at which inclusion should end" => "Ha az oldalnak csak egy részét szeretnénk megjeleníteni akkor meg kell adni a befejezés helyét",
"List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "Nyelvek listája melyeken a blokk megjelenik. Kétbetűs nyelvkódot használjunk (pld: hu, en, fr, es, ...). Több nyelvet plusz jellel elválasztva lehet megadni",
"List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "Nyelvek listája melyeken a blokk nem jelenik meg. Kétbetűs nyelvkódot használjunk (pld: hu, en, fr, es, ...). Több nyelvet plusz jellel elválasztva lehet megadni",
"Number of results displayed in the list" => "A listában megjelenítendő eredmények száma",
"Displays a module inline in a wiki page. More parameters can be added, not supported by UI" => "Modult jelenít meg az oldalba illesztve. Több paramétert is meg lehet adni (nem minden paraméter jelenik meg a felületen)",
"Font name as known in browsers" => "Betű böngészők által ismert neve",
"Text displayed on the mouseover. The body contains the text of the page" => "Egér szöveg felé mozgatásakot megjelenítendő felirat. A törzs az oldal szövegét tartalmazza",
"Wiki page name to redirect to" => "Átirányítás erre a wiki oldalra",
"Complete URL, internal or external" => "Teljes URL, internal vagy external",
"Label displayed above the remark" => "Megjegyzés felett megjelenő címke",
"Icon ID" => "Ikon ID",
"Inserts an RSS feed output" => "RSS feed kimenetet illeszt be",
"Number of results displayed" => "Megjelenítendő eredmények száma",
"share" => "megosztás",
"Displays the content of a spreadsheet in the page" => "Egy ív (tiki táblázat) tartalmának megjelenítése egy oldalon",
"Internal ID of the TikiSheet" => "Tikiív belső ID-ja",
"Incomplete call to plugin: No target sheet" => "Nem elegendő információ: nincs cél ív",
"Maximum amount of results displayed" => "Megjelenítendő eredmények maximális száma",
"Data to sort, one entry per line" => "Rendezendő adatok, egy tétel soronként",
"Subscribe text, containing %s as the placeholder for the group name" => "Feliratkozás szövege (%s a csoport nevének használatához)",
"Unsubscribe text, containing %s as the placeholder for the group name" => "Leiratkozás szövege (%s a csoport nevének használatához)",
"Subscribe button label, containing %s as the placeholder for the group name" => "Feliratkozási gomb felirata (%s a csoport nevének használatához)",
"Unsubscribe button label, containing %s as the placeholder for the group name" => "Leiratkozási gomb felirata (%s a csoport nevének használatához)",
"Colon separated list of groups" => "Csoportok listája kettősponttal elválasztva",
"Displays text in superscript (exponent)" => "Felső indexben jelenít meg szöveget",
"Any valid HTML tag, span by default" => "Bármilyen valid HTML tag, alapértelemezé: span",
"Equivalent to the style attribute of an HTML tag" => "Megegyezik a HTML tag stílus attribútumával",
"File ID from the file gallery" => "Fájl ID a fájlgalériából",
"Image ID from the image gallery" => "Kép ID a képgalériából",
"URL to the image" => "Képre mutató URL",
"Maximum width or height for the image" => "Kép maximális szélessége és magassága",
"Link target of the image" => "A képhez tartozó link célja",
"File is not an image" => "A fájl nem kép",
"Server does not support image manipulation" => "Szerver nem támogatja a képek manipulálását",
"No image specified" => "Nincs kép megadva",
"Search wiki page titles" => "Wiki oldalak nevei között keres",
"Portion of a page name" => "Oldanév egy része",
"Pipe-separated list of page names to exclude from results" => "Az eredményekbők kizárandó oldalak listája függőleges vonallal elválasztva",
"Displays the table of contents for the current structure's subtree as part of the page content" => "Megjeleníti a jelenlegi struktúrához tartozó tartalomjegyzéket az oldalon",
"Maximum number of levels to display. On very large structures, this should be limited" => "A megjelenítendő struktúra maximális mélysége. Kirejedt struktúráknál hasznos lehet",
"By default, structure for the current page will be displayed. Alternate structure may be provided" => "Alapértelmezéskénz az adott oldalhoz tartozó struktúra kerül megjelenítésre de meg lehet adni más struktúrát is",
"Colon-separated list of values" => "Értékek kettősponttal elválasztott listája",
"Name of the template used to display the tracker items" => "Űralptételek megjelenítésekor használandó sablon neve",
"Name of the wiki page containing the template to display the tracker items" => "Az űrlaptételek megjelenítésére használandó sablont tartalmazó oldal neve",
"Default status applied to newly created items" => "Újonnan létrehozott tételek alapértelmezett státusza",
"Specify the width in pixels or percentage of the first column in the tracker form" => "Az űrlap első oszlopának pixelben vagy százalékban kifejeztt szélessége",
"Wiki text containing an {ELSE} marker" => "{ELSE} markert tartalmazó wiki szöveg",
"Colon separated list of field IDs" => "Mező ID-k listája kettősponttal elválasztva",
"Value to compare against" => "Ezzel az értékkel kell összehasonlítani",
"Which item status to list. o = open, p = pending, c = closed" => "Milyen státuszú tételek kerüljenek listázásra. o = open (nyitva lévő), p = pending (függő), c = closed (lezárt)",
"Colon separated list of fields to allow filtering on" => "Szűrőként használható mezők listája kettősponttal elválasztva",
"Item ID separated with " => "Tétel ID ezzel elválasztva",
"Sum or average all the values of a field  and displays it at the bottom of the table" => "Egy mező összes értékének összege vagy átlaga a tábla alján megjelenítve",
"Content of the field" => "Mező tartalma",
"Timeline view of a tracker, can be used to display event schedules or gantt charts" => "Űrlap időinformációinak megtekintésére szolgál. Megjelenítheti események idejét vagy akár GANTT ábrákat is",
"Tracker Field ID containing the item title" => "Azon űrlap mező ID mely a tétel nevét tartalmazza",
"Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Azon űrlap mező ID-ja melyben a tétel leírása található. Ez a leíró mező jelenik meg mikor a tételre fókuszálunk",
"Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Azon űrlap mező ID-ja mely az elem kezdési dátumát tartalmazza. A mezőnek datetime/jscalendar mezőnek kell lennie",
"Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Azon űrlap mező ID-ja mely az elem befejezési dátumát tartalmazza. A mezőnek datetime/jscalendar mezőnek kell lennie",
"Tracker Field ID containing the element's group. Elements of a same group are displayed on the same row" => "Azon űrlap mező ID-ja mely az elem csoportját tartalmazza. Egy csoportba tartozó elemek ugyanabban a sorban jelennek meg",
"Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "A dátum melytől kezdve az elemek megjelenítésre kerülnek. A dátumot a következő formátumban kell megadni: YYYY-MM-DD HH:mm:ss",
"Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "A dátum ameddig az elemek megjelenítésre kerülnek. A dátumot a következő formátumban kell megadni: YYYY-MM-DD HH:mm:ss",
"Tracker Field ID containing the page name for item details" => "Azon űrlap mező ID-ja mely a tétel részleteit leíró oldal nevét tartalmazza",
"Start date after end date" => "Kezdési dátuma a befejezési dátum után van",
"String to use between elements of the list" => "A lista elemei között használandó sztring",
"Registered service name" => "Solgáltatás regisztrált neve",
"Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "A megadott HTML színkódnak vagy színnévnek megfelelő színben jeleníti meg a szöveget. Szín neve két színt is tartalmazhat vesszővel elválasztva. Ebben az esetben az első szín adja meg a karakter színét, a második a háttérszínt",
"Note: Remember that this is only a preview, and has not yet been saved" => "Figyelem: Ez csak előnézet, még nem történt mentés",
"left/right" => "bal/jobb",
"home" => "főoldal",
"chat" => "csevegés",
"contact us" => "kapcsolat teremtés",
"MyMenu" => "Saját menü",
"MyTiki home" => "MyOiT főoldal",
"My files" => "Fájljaim",
"User menu" => "Menüim",
"Monitor processes" => "Folyamatok figyelése",
"Monitor activities" => "Tevékenységek figyelése",
"Monitor instances" => "Példányok figyelése",
"User processes" => "Felhasználói folyamatok",
"User activities" => "Felhasználói tevékenységek",
"User instances" => "Felhasználói példányok",
"rankings" => "rangok",
"orphan pages" => "árva lapok",
"sandbox" => "homokozó",
"received pages" => "érkezett lapok",
"structures" => "struktúrák",
"System gallery" => "Rendszergaléria",
"Articles Home" => "Cikk főoldal",
"View submissions" => "Beküldések megtekintése",
"Send articles" => "Cikkek küldése",
"List blogs" => "Blogok listázása",
"Create/Edit Blog" => "Blog létrehozása",
"Admin posts" => "Posztok adminisztrálása",
"Submit a new link" => "Új link beküldése",
"Browse Directory" => "Linktár böngészés",
"Admin directory" => "Könyvtár adminisztrálása",
"Admin FAQs" => "GYIK karbantartás",
"Admin quiz" => "Kvízek adminisztrálása",
"Admin trackers" => "Űrlapok adminisztrálása",
"Send newsletters" => "Hírlevél kiküldése",
"Ephemerides" => "Napi idézetek",
"Admin home" => "Adminisztrációs főoldal",
"RSS modules" => "RSS modulok",
"Backups" => "Adatmentések",
"Dynamic content" => "Dinamikus tartalom",
"External wikis" => "Külső wikik",
"System Admin" => "Cache/rendszer adminisztrálása",
"Click here to manage your personal menu" => "Innen szerkeszthetem a saját menüm",
"Quick edit a Wiki page" => "Wiki oldal szerkesztése",
"Language: " => "Nyelv: ",
"read more" => "Bővebben",
"Edit plugin icon" => "Plugin szerkesztés ikon",
"underscores" => "aláhúzás",
"colons" => "kettőspont",
"some text" => "tetszőleges szöveg",
"equals" => "egyenlőségjel",
"One carat" => "Egy háztető",
"Creates a box with the data" => "Dobozt hoz létre az adatok köré",
"creates a title bar" => "Címlécet hoz létre",
"make headings" => "címsorokat hoz létre",
"make autonumbered headings" => "automatikusan számozott címsorokat hoz létre",
"creates a table" => "táblát hoz létre",
"makes a horizontal rule" => "vízszintes vonalat húz",
"page|desc" => "oldalnév|megjelenő leírás",
"displays an image" => "megjelenít egy képet",
"imalign, height, width, desc, link, rel, title, usemap, class and align are optional" => "imalign, height, width, desc, link, rel, title, usemap, class és align paraméterek opcinálisak",
"Non cacheable images" => "Nem cache-elhető képek",
"height width desc link and align are optional" => "a height width desc link és align paraméterek opcionálisak",
"Wiki File Attachments" => "Wiki fájlmellékletek",
"Creates a link to the named file.  If page is not given, the file must be attached to the current page.  If desc is not given, the file name is used for the link text, unless showdesc is used, which makes the file description be used for the link text.  If image=1 is given, the attachment is treated as an image and is displayed directly on the page; no link is generated." => "Linket hoz létre a megnevezett fájlhoz. Ha az oldal nincs megadva akkor a fájlt csatolni kell a jelenlegi oldalhoz. Ha nincs megadva leírás akkor a fájl neve kerül felhasználásra link szövegeként, hacsak a showdesc beállítás nincs használva, ebben az esetben ugyanis a fájl leírása kerül felhasználásra a link szövegeként. Ha image=1 megadásra került akkor a melléklet képként lesz kezelve és közvetlenül az oldalon jelenik meg, link nem kerül generálásra.",
"displays rss feed with id=n maximum=m items" => "rss feed-eket jelenít meg a következő paraméterekkel: id=n maximum=m tétel",
"Will be replaced by the actual value of the dynamic content block with id=n" => "Az id=n dinamikus tartalom blokk aktuális értékével lesz kitöltve",
"\"~pp~ data ~/pp~\" Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  \"~pre~ data ~/pre~\" also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text." => "\"~pp~ data ~/pp~\" Megjeleníti az előformázott szöveget/kódot; a szekción belül nincs Wiki feldolgozás (úgy mint np-nél), az elválasztás rögzített (nincs szótörés).  \"~pre~ data ~/pre~\" megjelenít előformázott szöveget rögzített elválasztással de wiki feldolgozás is történik a szövegen.",
"\"~tc~ Tiki Comment ~/tc~\" makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  \"~hc~ HTML Comment ~/hc~\" makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar." => "\"~tc~ Tiki komment ~/tc~\" tiki kommentet csinál. Nem kerül megjelenítésre de eltárolódik a fájlban.  \"~hc~ HTML komment ~/hc~\" HTML kommentet csinál. Kommentként kerül beillesztésre a HTML fájlba; ezek általában nem jelenítődnek meg a böngészőkben de láthatóak pld a forráskód megtekintésekor.",
"\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" - tartalomjegyzéket hoz létre az oldal struktúrájából (toc) vagy !címsorokból (maketoc)",
"Misc" => "Különleges",
"latin" => "latin",
"#FFFFFF" => "#FFFFFF",
"podcast (audio)" => "podcast (audio)",
"podcast (video)" => "podcast (video)",
"JsCalendar" => "JsCalendar",
"Mootools" => "Mootools",
"SEFURL" => "SEFURL",
"Neglected" => "Neglected",
"Unix" => "Unix",
"Windows" => "Windows",
"(standard)" => "(standard)",
"PEAR::Auth" => "PEAR::Auth",
"JQuery Superfish" => "JQuery Superfish",
"wiki link'" => "wiki link'",
"rss feed" => "rss feed",
"tagline" => "tagline",
"flash" => "flash",
"{\$label}" => "{\$label}",
"Replicate" => "Replicate",
"on left side" => "bal oldalon",
"on center" => "középen",
"on right side" => "jobb oldalon",
"english" => "angol",
"1 day" => "1 nap",
"1 week" => "1 hét",
"1 month" => "1 hónap",
"Just Tiki" => "Csak Tiki",
"Tiki and PEAR::Auth" => "Tiki és PEAR::Auth",
"OpenID and Tiki" => "OpenID és Tiki",
"choose a group ..." => "csoport kiválasztása ...",
"Never use transition css" => "Sose használjon tranzíciós css-t",
"Use @version:x.x specified in theme css or none if not specified" => "Használja a téma css-ben megadott @verzió:x.x-t vagy semmit ha nincs megadva",
"Use @version:x.x specified in theme css or 1.9 if not specified" => "Használja a téma css-ben megadott @verzió:x.x-t vagy az 1.9-et ha nincs semmi megadva",
"No forums" => "Nincsenek fórumok",
"%s enabled" => "%s bekapcsolva",
"%s disabled" => "%s kikapcsolva",
"Charts" => "Slágerek",
"Forums last topics" => "Legutóbbi fórum témák:",
"An error occured in a database query!" => "Hiba lépett fel az adatbázis lekérdezése közben!",
"games" => "játékok",
"Altering database table failed" => "Adatbázis megváltoztatása nem sikerült",
"Insert a division block on wiki page" => "DIV blokkot illeszt a wikioldalra",
"Draw" => "Rajz",
"Displays drawings in the wiki page" => "Rajzot jelenít meg a wiki oldalban",
"drawing not found" => "a rajz nem található",
"Name parameter missing" => "Név paraméter hiányzik",
"heads and cells separated by ~|~" => "fejlécek és cellák ~|~-al kerülnek elválasztásra",
"Alternate Text" => "Alternatív szöveg",
"Link Title" => "Link címe",
"Float Alignment" => "Lebegés igazítása",
"Color of the inside popup" => "A popup belsejének színe",
"Default: #F5F5F5" => "Alapértelmezés: #F5F5F5",
"Text popup color" => "Szöveg popup szín",
"Quicktags" => "Quicktag-ek",
"any file" => "bármely fájl",
"This Gallery is Public" => "A galéria publikus",
"Users with perms and not only the owner of the gallery can upload in it" => "A galéria tulajdonosán kívűl a megfelelő jogosultságokkal rendelkező felhasználók is feltölthetnek a galériába",
"The files can be locked at download:" => "A fájlok zárolásra kerülhetnek letöltéskor:",
"Listing configuration" => "Listázás beállítása",
"Perhaps you were looking for:" => "Hasonló nevű oldalak:",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together." => "A címkéket (tag-eket) szóközzel válasszuk el. Több szóból álló címkéknél írjuk egybe a szavakat a szóközök elhagyásával.",
"You are about to leave this page. If you have made any changes without Saving, your changes will be lost.  Are you sure you want to exit this page?" => "Az oldal elhagyásakor a mentetlen változások elvesznek.",
"Tiki email notification" => "Tiki E-mail értesítés",
"QuickTags" => "Quicktag-ek",
"TikiWiki Assistant" => "Tikiwiki Asszisztens",
"Recently visited pages" => "Mostanában látogatott lapok",
"Last Sites" => "Utolsó helyek",
"Directory Stats" => "Könyvtár statisztika",
"Sites to validate" => "Érvényesítendő oldalcímek",
"Visited links" => "Látogatott linkek",
"Top Sites" => "Top helyek",
"More Like This" => "Több hasonló",
"Last articles" => "Legutóbbi cikkek",
"Last galleries" => "Legutóbbi galériák",
"Menu" => "Menü",
"New Messages" => "Új üzenetek",
"New Message" => "Új üzenet",
"Top games" => "Legjobb játékok",
"Up-to-date-ness" => "Naprakészség",
"Better translations" => "Naprakészebb fordítások",
"Equivalent translations" => "Megegyező fordítások",
"Translations that need improvement" => "Frissítésre szoruló fordítások",
"show structures" => "Struktúrák megjelenítése",
"hide structures" => "Struktúrák elrejtése",
"Semantic wiki links" => "Szemantikus wiki linkek",
"Group calendars" => "Csoport naptárak",
"PHPLayers is disabled" => "PHPLayers ki van kapcsolva",
"My workflow" => "Munkafolyamatom",
"Feature" => "Funkció",
"Number of columns per page when listing categories" => "A laponkénti oszlopok száma a kategóriák megtekintésénél",
"enable cool sites" => "Népszerű oldalak számontartásának engedélyezése",
"No tabs" => "Fülek nélkül",
"Global Features" => "Globális funkciók",
"More Functionality" => "További hasznos funkciók",
"UI Enhancements" => "Felhasználói felület",
"Main Features" => "Fő funkciók",
"Site Global Features" => "Weblap globális funkciói",
"Action log setting" => "Akció log beállítás",
"Additional Features" => "További funkciók",
"Featured Help" => "Featured súgó",
"Copyright System" => "Szerzői jogok rendszere",
"Copyright system" => "Szerzői jog rendszer",
"User interface enhancement features" => "Felhasználói felületet kiterjesztő funkciók",
"JavaScript popup date selector" => "JavaScript felugró dátumválasztó",
"PhpLayers Dynamic menus" => "PhpLayers dinamikus menük",
"Allow users to activate fullscreen mode" => "Felhasználók aktiválhatják a teljesképernyős módot",
"Css Menus (suckerfish)" => "Css menük (suckerfish)",
"Mootools or JQuery" => "Mootools vagy JQuery",
"Experimental Features" => "Kísérleti funkciók",
"Seem ok" => "Jól működik",
"HTML Purifier (Content is cleaned to XHTML 1.1 Strict on each save)" => "HTML tisztító (a tartalom XHTML 1.1-es tisztításra kerül szigorúan minden mentésnél)",
"JQuery: JavaScript UI effects" => "JQuery: JavaScript UI effektusok",
"Features that need admin help and user patience to work well" => "Ezen funkciók működnek de adminisztrátori segítség és türelem kell hozzájuk",
"Malfunctioning" => "Hibásan működik",
"These features have critical faults - not recommended" => "Ezen funkciók kritikus hibákkal rendelkeznek - nem ajánlott",
"Magic Admin Panel" => "Magic adminisztrációs panel",
"Old features no longer maintained" => "Nem karbantartott régi funkciók",
"Drawings" => "Rajzok",
"Friendship" => "Barátság",
"Games" => "Játékok",
"Administration Features" => "Adminisztrációs eszközök",
"Banning System" => "Kitiltási rendszer",
"Action Calendar" => "Akció naptár",
"Tiki action calendar" => "Tiki akció naptár",
"User Features" => "Felhasználói eszközök",
"Newsreader" => "Hírolvasó",
"Workflow" => "Munkafolyamatok",
"Workflow engine" => "Munkafolyamatok",
"Gallery Listing" => "Galériák listázása",
"Search is disabled" => "Keresés ki van kapcsolva",
"Multilingual freetags" => "Többnyelvű freetag-ek",
"Multiligual disabled" => "Többnyelvűség kikapcsolva",
"Admin Password" => "Adminisztrátori jelszó",
"Server OS" => "Szerver OS",
"Unknown/Other" => "Ismeretlen/Egyéb",
"(some Unix MTA)" => "(valami Unix MTA)",
"Tikiwiki.org help" => "doc.tiki.org felhasználói kézikönyv",
"Store session data in database" => "Munkamenet információinak tárolása az adatbázisban",
"Allow anonymous visitors to use the \"Contact Us\"" => "Engedélyezi anonim látogatók számára a \"Kapcsolatfelvétel\" használatát",
"Default timezone" => "Alapértelmezett időzóna",
"Sample" => "Minta",
"New password" => "Új jelszó",
"Google Map setup" => "Google térkép beállítása",
"You need to request a Google Maps Key for this web site. You can easily generate a key for your domain at :" => "Kérni kell egy Google térképkulcsot a weboldal számára. Ezen a címen lehet ezt könnyedén megtenni :",
"Google Map Key" => "Google térképkulcs",
"Show pages in user's preferred language" => "Oldal mutatása a felhasználó által preferált nyelven",
"Use Ctrl+Click to select multiple languages" => "Ctrl+kattintás segítségével több nyelv is kiválasztható",
"Changing page language will also change the site language" => "Oldal nyelvének változtatása változtatja a weblap nyelvét",
"Intertiki exchange feature" => "Intertiki exchange funkció",
"Text Area" => "Szöveges terület",
"General Layout" => "Általános kinézet",
"Reg users can change theme" => "Regisztrált felhasználók megváltoztathatják a stílust",
"Slideshows theme" => "Bemutató stílusa",
"Use transition style sheet from version" => "Tranzíciós stílusok használata verziótól",
"Template Viewing" => "Sablon megtekintés",
"Enable additional general layout layers for shadows, rounded corners or other decorative styling" => "További általános kinézeti rétegek (árnyékok, lekerekített sarkok vagy egyéb dekoratív stílusok) bekapcsolása",
"Site logo source (image path)" => "Weblaplogó forrása (kép útvonala)",
"Site logo background color" => "Weblaplogó háttérszíne",
"Site logo background style" => "Weblaplogó háttér stílusa",
"Site logo alignment" => "Weblaplogó helye",
"Site logo title (on mouse over)" => "Weblaplogó neve (egér felémozgatásakor)",
"Site subtitle" => "Weblap alcíme",
"Site Search Bar" => "Weblap keresés sor",
"Site Login Bar" => "Weblap bejelentkezési sor",
"Note: Needs feature PHPLayers on(default), or feature CSS Menu on  " => "Megjegyzés: PHPLayers funkciót (alapértelmezés) vagy a CSS Menu funkciót be kell kapcsolni",
"Site Breadcrumbs" => "Weblap kenyérmorzsák",
"at top of page" => "oldal tetején",
"at top of center column" => "középső oszlop tetején",
"Prefix breadcrumbs with 'Location : '" => "Kenyérmorzsák előtagja 'Location : '",
"entire location" => "teljes kiterjedés",
"page name" => "oldalnév",
"Left blank to use the default sender email" => "Hagyjuk üresen az alapértelmezett küldési E-mail használatához",
"JQuery Tooltips" => "JQuery tippek",
"Effect for modules etc" => "Effektus modulokhoz, stb",
"Effect direction" => "Effektus iránya",
"Effect speed for tabs" => "Effektus sebessége fülekhez",
"Effect direction for tabs" => "Effektus iránya fülekhez",
"Other options" => "Egyéb opciók",
"Change Preferences" => "Preferenciák megváltoztatása",
"Categories disabled" => "Kategóriák ki vannak kapcsolva",
"Filter the list of profiles" => "Profilok listájának szűrése",
"installed" => "installálva",
"Repository URLs" => "Gyűjtemény URLek",
"Use this page to configure the RSS feeds generated by Tiki. To syndicate RSS feeds from other sites, use the <strong>Admin</strong> &gt; <strong>RSS Modules</strong> menu option, or" => "Ezen az oldalon lehet konfigurálni a Tiki által generált RSS feedeket. RSS feedek szindikálásához más weblapokról használjuk az <strong>Adminisztráció</strong> &gt; <strong>RSS Modulok</strong> menüpontok, vagy",
"Image Path" => "Kép útvonala",
"This database-independent search is always enabled" => "Ez az adatbázis független keresés mindig be van kapcsolva",
"When the Database search is enabled, you must manually refresh the Tiki search indexes" => "Ha az Adatbázis keresés be van kapcsolva akkor a Tiki indexeket manuálisan kell frissíteni",
"hits" => "találat",
"Show quicktags above textareas" => "Quicktagek megjelenítése szöveges területek felett",
"If disabled, quicktags will be shown to the left of textareas" => "Ha ki van kapcsolva akkor a quicktagek a szöveges területek bal oldalán jelennek meg",
"If the page does not exist, Tiki will create it" => "Ha az oldal még nem létezik akkor létre lesz hozva",
"Select the characters that can be used with Wiki link syntax: ((page name))" => "Válasszuk ki a karaktereket melyek a Wiki link szintakszisban használhatóak: ((page name))",
"Enter a character to use as the delimiter when displaying page names. All characters after the delimiter will be stripped when displaying the page name.</em>" => "Adjunk meg egy karaktert ami elválasztóként szolgál oldalnevek megjeleníŧésekor. Az elválasztó után szereplő összes karakter leválasztásra kerül az oldalnév megjelenítésekor.</em>",
"Wiki action bar" => "Wiki akció sor",
"Page navigation bar location" => "Oldal navigációs sor helye",
"Wiki top line" => "Wiki felső sor",
"Cache wiki pages (global):" => "Wiki oldalak cache-lése (globális):",
"Individual cache" => "Egyedi cache",
"Requires AJAX" => "AJAX-ot igényel",
"experimental" => "kísérleti",
"Regex search and replace" => "Regex keresés és kicserélés",
"Orphan page" => "Árva oldal",
"Toolbar content" => "Eszköztár tartalom",
"Assign permissions automatically" => "A rendszer automatikusan osszon jogosultságokat",
"recommended for best performance" => "ajánlott a legjobb teljesítményhez",
"image gal" => "képgaléria",
"file gal" => "fájlgaléria",
"Admin chart items" => "Slágerlista elemeinek adminisztrálása",
"Edit Chart" => "Slágerlista szerkesztése",
"Chart items" => "Slágerlista elemek",
"No items defined yet" => "Nincsenek elemek definiálva",
"Admin charts" => "Slágertémák adminisztrálása",
"Add or edit a chart" => "Sláger téma hozzáadása/szerkesztése",
"Users can vote for only one item from this chart per period" => "Időszakonként a felhasználók csak egy elemre szavazhatnak",
"Prevent users from voting for the same item more than once" => "Alkalmanként a felhasználók ugyanarra az elemre csak egyszer adhatják le szavazatukat",
"Users can suggest new items" => "A felhasználók javasolhatnak új slágereket",
"Auto validate user suggestions" => "Automatikusan jóváhagyja a felhasználói javaslatokat",
"Ranking shows" => "Rang mutatása",
"All items" => "Minden elem",
"Top 10 items" => "Top 10 elem",
"Top 20 items" => "Top 20 elem",
"Top 40 items" => "Top 40 elem",
"Top 50 items" => "Top 50 elem",
"Top 100 items" => "Top 100 elem",
"Top 250 items" => "Top 250 elem",
"Voting system" => "Szavazási rendszer",
"Vote items" => "Elemre szavazás",
"Rank 1..5" => "Rang 1..5",
"Rank 1..10" => "Rang 1..10",
"Ranking frequency" => "Időszak",
"Realtime" => "Valós idő",
"Each 5 minutes" => "Minden 5 percben",
"Show Average" => "Átlag mutatása",
"Show Votes" => "Szavazatok mutatása",
"Use Cookies for unregistered users" => "Cookie használata a nem regisztrált felhasználóknál",
"Users can vote again after" => "Ennyi idő múlva lehet megint szavazni:",
"Anytime" => "Bármikor",
"Ranks" => "Rangok",
"No charts defined yet" => "Nincsenek még sláger témák",
"Admin drawings" => "Rajzok adminisztrálása",
"Available drawings" => "Rendelkezésre álló rajzok",
"Ver" => "Verzió",
"no display" => "nincs megjelenítés",
"List Forums" => "Fórum lista",
"To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=siteid\">Site identity</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu." => "Menük használatához egy <a href=\"tiki-admin_modules.php\">modulban</a>, <a href=\"tiki-admin.php?page=siteid\">weblap identitásban</a> vagy sablonban használjuk ezt a szintakszist: {literal}{menu id=x}{/literal}, ahol x a menü ID-ja",
"Available polls" => "Rendelkezésre álló szavazások",
"Random image from" => "Véletlenszerű kép innen",
"Dynamic content blocks" => "Dinamikus tartalmú rész",
"Banner zones" => "Banner zónák",
"Group users" => "Felhasználói csoport",
"Admin Quicktags" => "Quicktag-ek beállítása",
"Create/Edit QuickTags" => "Quicktag létrehozása/szerkesztése",
"Quicktags category filter" => "Quicktag kategória szűrő",
"Insert (use 'text' for figuring the selection)" => "Beszúrás (használjuk a 'text' szót a szövegrész megjelölésére)",
"Path to the tag icon" => "Útvonal a címke ikonjához",
"Admin RSS Modules" => "RSS modulok adminisztrálása",
"This page is to configure settings of RSS feeds read/imported by Tiki. To generate/export RSS feeds, look for \"RSS feeds\" on the admin panel, or" => "Ezen az oldalon lehet a Tiki által beolvasott/importált RSS feed-eket konfigurálni. RSS feed generálásához/exportálához használjuk a központi adminisztráció felületet vagy",
"To use RSS feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the RSS feed." => "RSS feed-ek használatához szöveges területen (Wiki oldal, stb), <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">modulban</a> vagy sablonban használjuk a következőt: {literal}{rss id=x}{/literal}, ahol x az RSS feed azonosítója",
"Create new RSS Module" => "Új RSS modul létrehozása",
"show feed title" => "feed címének megjelenítése",
"show publish date" => "publikálás dátumának megjelenítése",
"RSS channels" => "RSS csatornák",
"Note: You have to import security data via installation process (<a href=\"tiki-install.php\">tiki-install.php</a>). Import the *secdb* update files in your database." => "Megjegyzés: A biztonsági adatokat a telepítési folyamaton keresztül kell importálni (<a href=\"tiki-install.php\">tiki-install.php</a>). Importáljuk a *secdb* frissítő fájlokat az adatbázisba.",
"Templates compiler" => "Sablonok fordítása",
"Compile" => "Fordítás",
"Member of the default group of creator can modify items?" => "A létrehozó alapértelmezett csoportjának tagja módosíthatja a tételeket",
"Default category assigned to uncategorized objects edited by a user with this default group" => "Alapértelmezett kategória melybe a nem kategorizált objektumok kerülnek melyeket az itt megadott alapértelmezett csoport egy felhasználója szerkesztett",
"Group Theme" => "Csoport stílusa",
"Rejected users" => "Elutasított felhasználók",
"Edit Account Settings" => "Fiókadatok szerkesztése",
"Repeat Password" => "Jelszó újra",
"Must Change Password" => "Jelszót kell változtatni",
"Last Login" => "Legutolsó bejelentkezés",
"Assign User {\$assign_user} to Groups" => "{\$assign_user} nevű felhasználó hozzárendelése csoportokhoz",
"Avanced parameters for iCal export" => "iCal exportálás további paraméterei",
"Old password" => "Régi jelszó",
"<a href=\"tiki-directory_admin_categories.php\">Add a category now</a>." => "<a href=\"tiki-directory_admin_catSelect which items to display when listing galleries:egories.php\">Kategória hozzáadása most</a>.",
"Use Ctrl+Click to select multiple categories." => "Ctrl+kattintás alkalmazásával több kategória is kiválasztható",
"Parent category" => "Felettes (szülő) kategória",
"Most visited sub-categories" => "Leglátogatottabb alkategóriák",
"Category description" => "Kategória leírása",
"Random sub-categories" => "Véletlenszerű alkategóriák",
"Allow sites in this category" => "Weblapok enegedélyezése ebben a kategóriában",
"Show number of sites in this category" => "A kategóriában található weblapok számának megjelenítése",
"Subcategories" => "Alkategóriák",
"Admin related categories" => "Kapcsolódó kategóriák adminisztrálása",
"Add a related category" => "Kapcsolódó kategória hozzáadása",
"Related categories" => "Kapcsolódó kategóriák",
"Add a Category" => "Kategória hozzáadása",
"in current category" => "jelen kategóriában",
"Total categories" => "Összes kategória",
"Creates an indentation for each plus(useful in list to continue at the same level)" => "Minden + jellel eggyel beljebb húzza (hasznos listázások ugyanazon szinten történő folytatására)",
"creates the editable drawing foo" => "létrehozza a szerkeszthető 'foo' rajzot",
"text, bold" => "szöveg, félkövér",
"text, italic" => "szöveg, dőlt",
"text, underline" => "szöveg, aláhúzás",
"table" => "tábla",
"table new" => "új tábla",
"external link" => "külső link",
"heading1" => "címsor 1",
"title bar" => "címléc",
"box" => "doboz",
"dynamic content" => "dinamikus tartalom",
"center text" => "szöveg középre igazítása",
"colored text" => "szöveg színe",
"dynamic variable" => "dinamikus változó",
"New Query" => "Új lekérdezés",
"New Layer" => "Új réteg",
"New Label" => "Új címke",
"New Reference" => "Új hivatkozás",
"New Legend" => "Új felirat",
"quote" => "idézet",
"Add Image from File Gallery" => "Kép hozzáadása fájlgalériából",
"special chars" => "különleges karakterek",
"special characters" => "különleges karakterek",
"Fullscreen Edit" => "Teljes képernyős szerkesztés",
"Questions per page" => "Kérdések oldalanként",
"Language of newly translated page" => "Újonnan fordított oldal nyelve",
"Name of newly translated page" => "Újonnan fordított oldal neve",
"Add existing page as a translation of this page" => "Létező oldal hozzáadása fordításként",
"This edit session will expire in {\$edittimeout} minutes" => "A szerkesztési munkamenet {\$edittimeout} perc múlva lejár",
"Activity completed" => "Tevékenység befejeződött",
"activity" => "aktivitás",
"Expiration Time" => "Lejárat ideje",
"Years" => "Évek",
"Months" => "Hónapok",
"Automatic" => "Automatikus",
"Manual" => "Manuális",
"Origin" => "Eredet",
"Edit Tpl" => "Tpl szerkesztése",
"completed" => "befejezve",
"Admin processes" => "Folyamatok beállítása",
"Admin Roles" => "Szerepek adminisztrálása",
"User Activities" => "Felhasználói tevékenységek",
"Install &amp; Update Profile" => "Profil telepítése &amp; frissítése",
"Bare-bones default install" => "Alapértelmezett minimális telepítés",
"Personal Blog and Profile" => "Személyes blog és profil",
"Small Organization Web Presence" => "Kisvállalat webes megjelenése",
"Company Intranet" => "Vállalati intranet",
"Collaborative community" => "Kollaboratív közösség",
"Use cache for external pages" => "Cache használata a külső lapokhoz",
"All games are from" => "A játékok származási helye",
"visit the site for more games and fun" => "látogasd meg több játékért és szórakozásért",
"Upload a game" => "Játék feltöltése",
"Upload a new game" => "Új játék feltöltése",
"Accepted requests" => "Elfogadott kérések",
"since" => "óta",
"This is an experimental feature" => "Ez egy kísérleti jellegű funkció",
"Not Enabled" => "Nincs bekapcsolva",
"My Contacts" => "Kontaktjaim",
"My Wiki Pages" => "Wiki oldalaim",
"My Galleries" => "Galériáim",
"My Tracker Items" => "Űrlapjaim",
"Assigned items" => "Hozzárendelt elemek",
"My Messages" => "Üzeneteim",
"My Tasks" => "Felhasználói feladatok",
"Select news group" => "Hírcsoport választása",
"Back to servers" => "Vissza a szerverekhez",
"Msgs" => "üzenetek",
"News from" => "Hírek feladója",
"Back to groups" => "Vissza a csoportokhoz",
"Save position" => "Pozíció mentése",
"Back to list of articles" => "Vissza a cikkek listájához",
"Newsgroup" => "Hírcsoport",
"Configure news servers" => "Hírszerver konfigurálása",
"Configure Newsreader" => "Hírolvasó beállítása",
"configure newsreader server tpl" => "Hírolvasó szerver beállítás tpl",
"Select a news server to browse" => "Egy hírszerver választása böngészésre:",
"server" => "szerver",
"Read the news" => "Hírek olvasása",
"Add a news server" => "Hírszerver hozzáadása",
"Edit news server" => "Hírszerver frissítése",
"News server" => "Hírszerver",
"Watch" => "Figyelés",
"View Permissions" => "Jogosultságok megtekintése",
"To edit global permissions <a class=\"rbox-link\" href=\"tiki-admingroups.php\">click here</a>." => "Globális jogosultságok szerkesztéséhez <a class=\"rbox-link\" href=\"tiki-admingroups.php\">katt ide</a>.",
"Current permissions for this object" => "Az objektum jelenlegi jogosultságai",
"Current permissions for categories that this object belongs to" => "Azon kategóriák jogosultságai melyekbe az objektum tartozik",
"These permissions do not apply. Special permissions apply." => "Ezek a jogosultságok nem alkalmazhatóak. Egyedi jogosultságok érvényesek",
"No category permissions; global permissions apply" => "Nincsenek kategória-jogosultságok beállítva; a globális jogosultságok érvényesek",
"No category permissions; special permissions apply" => "Nincsenek kategória-jogosultságok beállítva; egyedi jogosultságok érvényesek",
"and also to all pages of the sub-structure:" => "és az alárendeltekhez tartozó összes oldalra vonatkozóan is:",
"Perms Help" => "Jogosultság súgó",
"Preview of version" => "Verzió előnézete",
"Source of version" => "Verzió forrása",
"Last seen in wiki page <a href=\"%0\">%1</a>" => "Legutóbb észlelve ebben a wiki oldalban: <a href=\"%0\">%1</a>",
"Blogs Post" => "Blog posztok",
"Data HTML" => "Adat HTML",
"Data Txt" => "Adat Txt",
"Tiki Shoutbox" => "Tiki üzenőfal",
"Click to Navigate" => "Kattintás navigáláshoz",
"Focus:" => "Fókusz:",
"cry" => "sírás",
"evil" => "gonosz",
"smile" => "mosoly",
"arrow" => "nyíl",
"Author if not the file creator:" => "Szerző neve (ha nem egyezik meg a létrehozóval):",
"Maximum file size is limited to:" => "Maximális fájlméret:",
"Note: Maximum image size is limited to" => "Megjegyzés: kép maximális mérete",
"Current folder" => "Jelenlegi mappa",
"a URL" => ": URL",
"Your personal Wiki Page" => "Személyes Wiki oldalam",
"Your personal tracker information" => "Személyes űrlap adataim",
"Your preferred language" => "Preferált nyelvem",
"Other languages you can read (select on the left to add to the list on the right)" => "További olyan nyelvek megadása amiket tudok olvasni (bal oldalon kiválasztás, jobb oldalon a lista)",
"Confirm new password" => "Új jelszó megerősítése",
"Current password (required)" => "Jelenlegi jelszó (szükséges)",
"Item information" => "Tétel információ",
"Best Position" => "Legjobb pozíció",
"Vote this item" => "Szavazás erre a tételre",
"Highest" => "Legmagasabb",
"No chart indicated" => "Nincs megjeleníthető sláger",
"Translation in progress." => "Fordítás folyamatban",
"Please create a directory named '.\$prefs['map_path'].' to hold your map files." => "Létre kell hozni egy könyvtárat a térképfájlok részére a következő néven '.\$prefs['map_path'].'",
"No server indicated" => "Nincs szerver feltüntetve",
"Cannot connect to" => "Nem tudok ide csatlakozni:",
"Cannot get messages" => "Nem tudom letölteni az üzeneteket",
"Tiki Calendar" => "Tiki Naptár",
"Admin Menu" => "Menü adminisztrálása",
"RSS Modules" => "RSS modulok",
"Tiki Cache/Sys Admin" => "Cache/rendszer",
"RSS Feeds" => "RSS feed-ek",
"RSS feeds" => "RSS feed-ek",
"Use titles in blog posts" => "Címek használata blogposztoknál",
"Send blog post" => "Blog poszt küldése",
"Prevent flooding" => "Flood megakadályozása",
"Minimum time between posts" => "Hozzászólások közti minimum idő",
"Moderator user" => "Moderátor felhasználó",
"Moderator group" => "Moderátor csoport",
"Only allow replies to the first message (flat forum)" => "Csak az első üzenetre küldhető válasz (lapos fórum)",
"Send this forums posts to this email" => "Fórum hozzászólásainak elküldése az alábbi E-mail címre",
"Prune unreplied messages after" => "Válasz nélküli üzenetek eltávolítása ennyi idő után",
"Prune old messages after" => "Régi üzenetek eltávolítása ennyi idő után",
"POP3 server" => "POP3 szerver",
"Max attachment size (bytes)" => "Melléklet maximális mérete (bájt)",
"Default ordering for topics" => "Témák rendezésének alapbeállítása",
"Topics per page" => "Témák száma laponként",
"Default ordering for threads" => "A szálak alap rendezési beállítása",
"theme" => "stílus",
"Go to Login Page" => "Ugrás a bejelentkezési oldalra",
"Login as" => "Bejelentkezés mint",
"You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/." => "Külön fel kell tölteni a <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS könyvtárat</a> ide: lib/phpcas/",
"Available styles:" => "Rendelkezésre álló stílusok:",
"logged as" => "bejelentkezve mint:",
"always" => "mindig",
"user decides" => "felhasználó dönt",
"Users can Flip Columns" => "Felhasználók Users can Flip Columns",
"Use page description:" => "Oldalleírás használata:",
"Max. number of links around the current item:" => "Linkek maximális száma a jelenlegi tétel körül:",
"Max. number of links after the first or before the last item:" => "Linkek maximális száma az első tétel után vagy az utolsó tétel előtt:",
"JQuery UI: More JQuery functionality" => "JQuery UI: További JQuery funkcionalitás",
"JQuery Cycle (slideshow)" => "JQuery ciklus (bemutató)",
"JQuery Spreadsheet" => "JQuery táblázat",
"Main JQuery effect" => "Fő JQuery effektus",
"JQuery effect for tabs" => "JQuery effektus fülekhez",
"Favicon icon file name:" => "Favicon ikon fájlnév:",
"Favicon icon MIME type:" => "Favicon ikon MIME típus:",
"This search uses the MySQL Full-Text feature" => "Ez a keresési módszer a MySQL Full-Text funkciót használja",
"Use <strong>0</strong> for no refresh" => "<strong>0</strong> ha nincs frissítés",
"Not Installed" => "Nincs installálva",
"Edit idle timeout:" => "Nem tevékeny szerkesztés időkorlátja:",
"Force and limit categorization to within subtree of:" => "Kategorizálás erőltetése és korlátozása ezen alkategóriákra:",
"Use File Galleries to store pictures " => "Fájlgalériák használata képek tárolására",
"History includes only page data, description, and change comment" => "Előzmények csak oldaladatokat, leírást és változási kommentet tartalmaz",
"Forums are disabled." => "Fórum funkció ki van kapcsolva",
"like pages" => "hasonló oldalak",
"Create webhelp from structure:" => "Websúgó létrehozása struktúrából:",
"UserPage prefix:" => "Felhasználói oldal előtagja:",
"Unique page name prefix to indicate staging copy:" => "Egyedi oldalnév előtag használata a jóváhagyás alatt lévő oldalmásolatok megkülönböztetésére:",
"Default sort order:" => "Alapértelmezett rendezési sorrend:",
"Name length:" => "Név hossza:",
"Description length:" => "Leírás hossza:",
"Includes" => "Tartalmazza",
"Only directly included" => "Csak közvetlenül belefoglalva",
"will have all the permissions of the included groups" => "a tartalmazott csoportok összes jogosultságát meg fogja kapni",
"Assign Perms to this Group" => "Jogosultságok hozzárendelése ehhez a csoporthoz",
"Secure Login" => "Biztonságos bejelentkezés",
"Change administrative info" => "Fiók adatainak mentése",
"ERROR: you must include a subject or a message at least" => "Hiba: meg kell adni legalább egy üzenetet vagy tárgyát",
"Shadowbox" => "Shadowbox",
"Latin" => "Latin",
"Permission denied. You cannot view pages" => "Oldalak megtekintéséhez magasabb szintű jogosultágra van szükség",
"The copyright management feature is not enabled." => "A szerzői jogok kezelése funkció nincs bekapcsolva",
"Chinese" => "kínai",
"Serbian" => "szerb",
"Users can opt-out internal messages" => "Belső üzenetek kizárásának lehetősége",
"Multimedia" => "Multimédia",
"Local" => "Helyi",
"multimedia" => "multimédia",
"You do not have permission to use this DSN" => "Nincs elegendő jogosultság ezen DSN használatához",
"Calendar ID" => "Naptár ID",
"Image Source" => "Kép forrása",
"Link Relation" => "Link kapcsolat",
"Image alt text" => "Kép alt. szöveg",
"Image Map" => "Térkép kép",
"Default configuration" => "Alapértelmezett konfiguráció",
"Mandatory configuration" => "Kötelező konfiguráció",
"complete" => "teljes",
"articles" => "cikkek",
"Picture" => "Kép",
"Search for images uploaded by users" => "Felhasználók által feltöltött képek keresése",
"You need to specify a RSS Id" => "Meg kell adni egy RDD ID-t",
"RSS Id incorrect:" => "RSS Id inkorrekt:",
"~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} RSS feed tartalmát jeleníti meg wiki oldalon",
"row1col1" => "sor1oszlop1",
"row1col2" => "sor1oszlop2",
"row2col1" => "sor2oszlop1",
"row2col2" => "sor2oszlop2",
"Displays the thumbnail for an image" => "Megjeleníti egy kép előnézeti képét",
"Maximum Size" => "Maximális méret",
"Floating" => "Lebegés",
"Colon-separated list of fields to display on click. Example: 6:7" => "Kattintásra megjelenítendő mezők listája kettősponttal elválasztva. Például: 6:7",
"Select automatically the item of the current user or the page" => "A jelenlegi felhasználóhoz vagy az oldalhoz tartozó tétel kiválasztása",
"Message will be sent to: " => "Az üzenet címzettje: ",
"Page translation" => "Oldal fordításai",
"Logged in as" => "Bejelentkezve mint",
"Stay in SSL mode" => "Maradok titkosított módban",
"Search Wiki PageName" => "Wiki oldal nevének keresése",
"Requires User Preferences feature" => "Felhasználói preferenciák funkció szükséges hozzá",
"avatar" => "avatár",
"Feature is disabled" => "A funkció ki van kapcsolva",
"&quot;More Like This&quot; algorithm" => "&quot;Több hasonló&quot; algoritmus",
"basic" => "alap",
"weighted" => "súlyozott",
"3D Tag Browser" => "3D címke böngészés",
"Morcego 3D browser disabled" => "Morcego 3D böngésző kikapcsolva",
"Node color" => "Csomópont szín",
"Camera settinsg" => "Kamera beállítások",
"Change password" => "Jelszó megváltoztatása",
"Tiki and HTTP Auth" => "Tiki és HTTP Auth",
"Duration:" => "Időtartam:",
"For future use" => "Jövőbeli használatra",
"It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item" => "Ez a funkció fájlgalériáknál, wiki oldalaknál (plugin segítségével) és multimédiás űrlaptételeknél működik",
"ProgressBarPlay Color" => "Folyamatcsík lejátszás színe",
"ProgressBarLoad Color" => "Folyamatcsík töltés színe",
"ProgressBarButton Color" => "Folyamatcsík gomb színe",
"ProgressBar Color" => "Folyamatcsík színe",
"Volume On Color" => "Hangerő bekapcsolás színe",
"Volume Off Color" => "Hangerő kikapcsolás színe",
"Volume Button Color" => "Hangerő gomb színe",
"Button Color" => "Gomb szín",
"Button Pressed Color" => "Lenyomott gomb színe",
"Button Over Color" => "Gomb színe egér felémozgatásakor",
"Button Info Color" => "Gombinformáció szín",
"Button Info Pressed Color" => "Lenyomott gombinformáció színe",
"Button Info Over Color" => "Gombinformáció színe egér felémozgatásakor",
"Button Info Text Color" => "Gombinformáció szöveg szín",
"ID3 Tag Color" => "ID3 címke szín",
"Play Time Color" => "Lejátszási idő színe",
"Total Time Color" => "Teljes idő színe",
"Panel Display Color" => "Panel kijelzés színe",
"Alert Message Color" => "Figyelmeztetőüzenet színe",
"Flash Length" => "Flash hossza",
"Flash Heigth" => "Flash magassága",
"Video Length" => "Video hossza",
"Video Heigth" => "Video magassága",
"Preload Delay" => "Előtöltés késleltetése",
"Max Play time" => "Max lejátszási idő",
"URL Append" => "Hozzáfűzött URL",
"Message after limited time" => "Üzenet meghatározott idő után",
"ID of System File Galleries to upload multimedia files" => "A fájlgaléria azonosítója ahova a multimédiás fájlok feltöltésre kerülnek",
"Feature is disabled." => "A funkció ki van kapcsolva",
"Individual blogs" => "Egyedi blogok",
"Individual image galleries" => "Egyedi képgalériák",
"Individual forums" => "Egyedi fórumok",
"Map files" => "Térképfájlok",
"Caching time:" => "Cache-elési idő:",
"&lt;return&gt; for rows" => "&lt;enter&gt; új sorhoz",
"Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting" => "Idézet (Quote) plugin használata &ldquo;&gt;&rdquo; helyett idézetekhez",
"Forum for discussion:" => "Megbeszélésre használt fórum:",
"If not in the group, edit is always redirected to the staging page edit:" => "Ha nincs a csoportban akkor a szerkesztés mindig átirányításra kerül a jóváhagyási oldalváltozat szerkesztésre:",
"Maximum size" => "Maximális méret",
"Use Ctrl+Click to select multiple groups." => "Ctrl+kattintás alkalmazásával több csoport is kiválasztható",
"Fix UTF-8 Errors in Tables" => "UTF-8 hibák fixálása táblákban",
"Warning: Make a backup of your Database before using this function!" => "Figyelmeztetés: a funkció használata előtt ajánlott biztonsági mentés készíteni az adatbázisról!",
"Warning: If you try to convert large tables, raise the maximum execution time in your php.ini!" => "Figyelmeztetés: nagy táblák konvertálásakor érdemes megemelni a php.ini maximális végrehajtási időkeretét!",
"This function converts ISO-8859-1 encoded strings in your tables to UTF-8" => "A funkció az ISO-8859-1-ben kódolt sztringeket átalakítja UTF-8-ra a táblákban",
"This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1" => "Minderre akkor lehet szükség ha Tiki &lt; 1.8.4-el készült tartalom van és az Apache alapértelmezett karakterkészlete ISO-8859-1",
"UTF-8 Errors fixed" => "UTF-8 hibák fixálva",
"Investigate" => "Vizsgálat",
"Fix it" => "Fixálás",
"Tip: Hold down CTRL to select multiple" => "Tipp: CTRL lenyomva tartásával többet is ki lehet választani",
"List of types" => "Típusok listája",
"Save and Exit" => "Mentés és kilépés",
"Watch Only This Category" => "Csak ezen kategória figyelése",
"Watch This Category and Their Descendants" => "Ezen kategória és alárendeltjei figyelése",
"Stop Watching Only This Category" => "Ezen kategória figyelésének felfüggesztése",
"Stop Watching This Category and Their Descendants" => "Ezen kategória és alárendeltjei figyelésének felfüggesztése",
"Assign permissions to category" => "Jogosultság kiosztása kategóriához",
"Categories checking is not done in the database search." => "A kategóriák nincsenek ellenőrizve az adatbázisban",
"Current permissions for this category" => "Ezen kategóriához tartozó jelenlegi jogosultságok",
"Remove from this Category Only" => "Eltávolítás csak ebből a kategóriából",
"Remove from this Category &amp; all its Children" => "Eltávolítás ebből a kategóriából &amp; és összes alárendeltjéből",
"Assign permissions" => "Jogosultságok kiosztása",
"to group" => "csoporthoz",
"this category &amp; all its children" => "ezen kategória &amp; összes alárendeltje",
"this category only" => "csak ezen kategória",
"Assigning permissions for <b>all children</b> is recommended for best performance." => "Jogosultságokat <b>összes alárendelthez</b> érdemes megadni a legjobb teljesítmény eléréséhez",
"Allow other user to post in this blog" => "Más felhasználó is posztolhat a blogba",
"Manage existing translations of this page" => "Oldal létező fordításainak kezelése",
"Monitor this page" => "Oldal figyelése",
"Upload picture" => "Kép feltöltése",
"Regex search " => "Regex keresés",
"Replace with" => "Kicserélés erre",
"Import page" => "Lap importálása",
"License" => "Licensz",
"Important" => "Fontos",
"My Footnotes" => "Lábjegyzeteim",
"Use rating" => "Értékelés használata",
"Translation request" => "Fordítási kérés",
"Install Profile" => "Profil telepítése",
"Your registration code:" => "Regisztrációs kód:",
"Registration code" => "Regisztrációs kód",
"Add Pages" => "Oldalak hozzáadása",
"Use Ctrl+Click to select multiple pages" => "Ctrl+Kattintás segítségével több oldal is kiválasztható",
"Repeat password" => "Jelszó ismét",
"Remove page" => "Oldal eltávolítása",
"Editing" => "Szerkesztés",
"Editing posts" => "Posztok szerkesztése",
"Add a new" => "Új hozzáadása",
"Permission denied you cannot view the Tiki calendar" => "Nincs elegendő jogosultság a Tiki naptár megtekintéséhez",
"Permission denied you can not view this section" => "Magasabb szintű jogosultágra van szükség a szekció megtekintéséhez",
"This feature has been disabled" => "Ez a funkció ki van kapcsolva",
"You do not have permissions to edit banners" => "Nincs Elegendő a jogosultság bannerek szerkesztéséhez",
"Permission denied you cannot create or edit blogs" => "Magasabb szintű jogosultágra van szükség blogok létrehozásához és szerkesztéséhez",
"Permission denied you cannot edit images" => "Magasabb szintű jogosultágra van szükség a képek szerkesztéséhez",
"You must be logged in to use this feature" => "Először <a href=\"tiki-login_scr.php\" alt=\"Login\">be kell jelentkezni</a> a funkció használatához",
"You cannot admin blogs" => "Magasabb szintű jogosultágra van szükség a blogok adminisztrálásához",
"You do not have permissions to view the layers" => "Nincs elegendő jogosultság a rétegek megtekintéséhez",
"You do not have permissions to delete a file" => "Nincs elegendő jogosultság a fájl törléséhez",
"You do not have permissions to create a directory" => "Nincs elegendő jogosultság könyvtár létrehozásához",
"You do not have permissions to delete a directory" => "Nincs elegendő jogosultság könyvtár törléséhez",
"You do not have permissions to create an index file" => "Nincs elegendő jogosultság index fájl létrehozásához",
"Must be logged to use this feature" => "Be kell jelentkezni a funkció használatához",
"Permission denied you cannot remove versions from this page" => "Magasabb szintű jogosultágra van szükség az oldal verzióinak eltávolításához",
"Permission denied you cannot remove the post" => "Magasabb szintű jogosultágra van szükség a poszt törléséhez",
"Creation date (desc)" => "Létrehozás dátuma (csökk)",
"Category path" => "Kategória útvonal",
"Create new file gallery" => "Új fájlgaléria létrehozása",
"Create new sheet" => "Új ív létrehozása",
"link url" => "Link url",
"Edit blog" => "Blog szerkesztése",
"Create a Gallery" => "Galéria létrehozása",
"Create a forum" => "Fórum létrehozása",
"Default y from map center" => "Alapértelmezett y koordináta a térkép közepéhez",
"disabled" => "kikapcsolva",
"enabled" => "bekapcsolva",
"preference" => "preferencia",
"Contact us" => "Kapcsolatfelvétel",
"Create new forum" => "Új fórum létrehozása",
"Duplicate forum" => "Fórum duplikálása",
"CSS file" => "CSS fájl",
"Create blog" => "Blog létrehozása",
"Create new structure" => "Új struktúra létrehozása",
"Add a site" => "Weblap hozzáadása",
"name (desc)" => "név (csökk)",
"name (asc)" => "név (növ)",
"hits (desc)" => "látogatások (csökk)",
"hits (asc)" => "látogatások (növ)",
"creation date (desc)" => "létrehozás dátuma (csökk)",
"creation date (asc)" => "létrehozás dátuma (növ)",
"last updated (desc)" => "legutóbbi frissítés (csökk)",
"last updated (asc)" => "legutóbbi frissítés (növ)",
"Max impressions" => "Max impresszió",
"Max clicks" => "Max kattintás",
"Or, create a new zone" => "Vagy új zóna létrehozása",
"Show the banner only between these dates" => "Banner megjelenítése csak ezen dátumok között",
"From date" => "Kezdés dátuma",
"To date" => "Befejezés dátuma",
"Show the banner only in this hours" => "Banner megjelenítése csak ezen órák között",
"Show the banner only on" => "Banner megjelenítése csak ekkor",
"Mon" => "Hétfő",
"Tue" => "Kedd",
"Wed" => "Szerda",
"Thu" => "Csütörtök",
"Fri" => "Péntek",
"Sat" => "Szombat",
"Sun" => "Vasárnap",
"Movie Size" => "Film mérete",
"FlashPlugin min version" => "FlashPlugin min verzió",
"ex" => "pld",
"Select from available options..." => "Választási lehetőségek...",
"Dynamic content system" => "Dinamikus tartalom rendszer",
"Add Structure Pages" => "Struktúra oldalainak hozzáadása",
"Create new Sheet" => "Új ív hozzáadása",
"Default view" => "Alapértelmezett nézet",
"Edit task" => "Feladat szerkesztése",
"wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker" => "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker",
"BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic" => "BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic",
"Permission to all (not just any) of an object's categories is required for access" => "Objektum kategóriáihoz tartozó összes jogosultság szükséges a hozzáféréshez",
"List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img" => "Objektumtípusok listája + jellel elválasztva. Pld: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img",
"No arguments indicated" => "Nincs argumentum megadva",
"preview" => "előnézet",
"These permissions override any global permissions or category permissions affecting this object." => "Ezek a jogosultságok erősebbek mint az objektumra vonatkozó globális jogosultságok vagy kategóriajogosultságok",
"Passcode to register (not your user password)" => "Regisztrációs továbbmenőkód(nem jelszó)",
"Started" => "Elindítva",
"Days online" => "Működési napok száma",
"Best day" => "Leglátogatottabb nap",
"Worst day" => "Legkevésbé látogatott nap",
"Database search" => "Adatbázis keresés",
"Activity=" => "Aktivitás=",
"TikiWiki Profiles" => "TikiWiki profilok",
"Tiki search" => "Tiki keresés",
"TikiWiki Project Web Site" => "TikiWiki projekt weboldala",
"Please select some actions to view." => "Válasszuk ki a megjelenítendő akciókat",
"recorded" => "rögzítve",
"viewed" => "megtekintve",
"Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki oldal akciók - a megtekintés kivételével - mindig rögzítésre kerülnek de nem riportálhatóak",
"np" => "np",
"Powered by TikiWiki" => "Powered by TikiWiki",
"Tikiwiki Mods" => "Tikiwiki Mods",
"find" => "keresés",
"prev" => "előző",
"next" => "következő",
"Requires a separate download" => "Külön letöltést igényel",
"Spell checking" => "Helyesírás ellenőrzése",
"Comments " => "Kommentek",
"JQuery Sheet" => "JQuery ív",
"Default RDF version" => "Alapértelmezett RDF verzió",
"Webmaster" => "Webmester",
"... and is displayed by default" => "... és alapértelmezésben megjelenítve",
"Content is partially parsed" => "Tartalom részlegesen elemzett",
"Toolbar skin" => "Eszköztár felület",
"Your edit session will expire in" => "A szerkesztési munkamenet lejár ennyi perc múlva:",
"sec" => "msp",
"Creates an annotation block for an image." => "Annotációs blokkot hoz létre egy képhez",
"No pages links to" => "Nincs ide mutató oldal",
"Shows ID" => "ID megjelenítése",
"Shows Icon" => "Ikon megjelenítése",
"Shows Name" => "Név megjelenítése",
"Shows Filename" => "Fájlnév megjelenítése",
"Shows Size" => "Méret megjelenítése",
"Shows Description" => "Leírás megjelenítése",
"Shows Creation Date" => "Létrehozás dátumának megjelenítése",
"Shows Hits" => "Találatok megjelenítése",
"Shows Locked by" => "Zároló megjelenítése",
"Shows Modification Date" => "Módosítás dátumának megjelenítése",
"Shows Author" => "Szerző megjelenítése",
"Shows Creator" => "Létrehozó megjelenítése",
"Shows Parent Gallery Name" => "Szülő galéria megjelenítése",
"Shows Number of Files" => "Fájlok megjelenítése",
"Shows the slideshow of a gallery" => "Galéria bemutató megjelenítése",
"Include literal HTML" => "Szó szerinti HTML belefoglalása",
"notitle" => "Nincs cím",
"Displays a proposal acceptance widget" => "Előterjesztés elfogadására szolgáló widget megjelenítése",
"Insert an image" => "Kép beszúrása",
"Switch to normal (wiki) editor" => "Átváltás normál (wiki) szerkesztőre",
"Enlarge area height" => "Terület magasságának növelése",
"Reduce area height" => "Terület magasságának csökkentése",
"Need polish" => "Csiszolandó",
"Date and Time Formats" => "Dátum és idő formátumok",
"Change the <strong>Admin</strong> password" => "<strong>Adminisztrátori</strong> jelszó megváltoztatása",
"JQuery plugins and add-ons" => "JQuery pluginok és kiegészítők",
"Requires jquery feature" => "JQuery funkciót igényel",
"Trackers with mirror tables" => "Űrlapok tükörtáblákkal",
"Use trackers with mirror tables" => "Űrlapok használata tükörtáblákkal",
"Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki" => "Az értékek külön tárolódnak az egyes űrlapok számára dedikált táblákban, így könnyű változtatni őket Tikiwikin kívűl is",
"WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely" => "FIGYELEM: Régi és új űrlapok nem létehetnek együtt. Új könyvtárban készített űrlapok nem fognak működni a régi könyvtárral és fordítva",
"Validate choice" => "Választás érvényesítése",
"Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>" => "A Wysiwyg (What You See Is What You Get rövidítve) szerkesztő lehetővé teszi a könnyed szövegszerkesztést és szövegformázást. Tikiwiki a <a href=\"http://fckeditor.net\">FCKeditor</a> megoldást használja",
"Custom Categories" => "Egyedi kategória",
"Use wysiwyg editor" => "Wysiwyg szerkesztő használata",
"Use normal editor" => "Normál szerkesztő használata",
"Admin external wikis" => "Külső wiki-k adminisztrálása",
"There are individual permissions set for this forum" => "Egyéni jogosultságok vannak ehhez a fórumhoz",
"Add a subscription newsletters" => "Hírlevél előfizetés hozzáadása",
"Batch e-mail subscribe" => "Kötegelt E-mail feliratkozás",
"Add subscribers of another newsletter" => "Egy másik hírlevél előfizetőinek hozzáadása",
"TikiWiki settings" => "TikWiki beállítások",
"Articles (subs)" => "Cikkek (beküldések)",
"Tbl vis" => "Táblában látható",
"isMain" => "Fő",
"Use \"explicit\" names in the mirror table" => "\"explicit\" nevek használata a tükörtáblában",
"User must change password at first login" => "A felhasználónak meg kell változtatnia a jelszavát első bejelentkezéskor",
"Spellcheck" => "Helyesírás ellenőrzése",
"Current heading" => "Jelenlegi fejléc",
"Number of posts to show" => "Megjelenítendő posztok száma",
"The syntax system used for creating pages in TikiWiki" => "Oldalak létrehozásához használt szintakszis rendszer TikiWikiben",
"Edit or ex/import Languages" => "Nyelvek szerkesztése vagy exportálása/importálása",
"Edit and create Languages" => "Nyelvek létrehozása és szerkesztése",
"Im-Export Languages" => "Nyelvek importálása/exportálása",
"Edit and create languages" => "Nyelvek létrehozása és szerkesztése",
"Create Language" => "Nyelv létrehozása",
"Shortname" => "Rövid név",
"Longname" => "Teljes név",
"<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer." => "Az <strong>Előnézet</strong> vagy <strong>Mentés</strong> gomb lenyomásával a szerkesztési munkamenet időkerete  újraindul.",
"Case Insensitivity" => "Kis/nagybetű érzékeny",
"Im- Export languages" => "Nyelvek importálása/exportálása",
"Select the language to Import" => "Importálandó nyelv kiválasztása",
"Modify String in Source Language" => "Sztring (karakterlánc) módosítása a forrás nyelvben",
"Original String" => "Eredeti sztring",
"New String" => "Új sztring",
"TikiWiki CMS/Groupware Project" => "TikiWiki CMS/Groupware projekt",
"Interactive translator" => "Interaktív fordítás",
"has been updated" => "frissítésre került",
"Close this window" => "Ablak bezárása",
"Clicking 'Close this window' will reload the main window from where it was opened" => "Az Ablak bezárása linkre való kattintás hatására újra betöltésre kerül a fő ablak (ahonnan az Interaktív fordítás ablak megnyitásra került)",
"public" => "publikus",
"This page is being edited by" => "Ezt az oldalt most szerkeszti",
"Proceed at your own peril" => "Csak saját felelősségre...",
"Items list" => "a tételek listájához",
"Permission denied you cannot post" => "Magasabb szintű jogosultágra van szükség a posztoláshoz",
"Language created" => "Az új nyelv létre lett hozva",
"Cannot rename page maybe new page already exists" => "Oldal átnevezése nem sikerült, lehet már létezik oldal ezen a néven",
"Adminisztráció" => "Adminisztráció",
"Modify the look &amp; feel (logo, theme, etc.)" => "Stílus módosítása (logó, stílus témák, stb)",
"Once checked, click on any string to translate it. " => "Bejelölés után rá kell kattintani a lefordítandó szövegre",
"Show interactive translation settings" => "Interaktív fordítás beállításai",
"Displays a link to download a file from a file gallery." => "Fájlgalériában található fájl letöltését lehetővé tevő linket jelenít meg",
"Displays the table of contents for the current structure's subtree as part of the page content." => "Megjeleníti a jelenlegi struktúrához tartozó tartalomjegyzéket az oldalon.",
"External Feeds" => "Külső feed-ek",
"File link" => "Fájl link",
"Include a page's content." => "Egy másik oldal tartalmát jeleníti meg.",
"Includes an article's content within the page." => "Egy cikk tartalmát jeleníti meg egy oldalon belül.",
"Quick Admin" => "Adminisztráció",
"Show user's real name instead of login (when possible)" => "Felhasználó valódi nevének megjelenítése (ahol lehetséges)",
"Tiki Importer" => "Tiki importáló",
"Share access rights with friends" => "Hozzáférési jogok megosztása barátokkal",
"Field names will be replaced when enclosed in % chars. e.g. %fileId%, %src%, %title%, %description%" => "A % karakter közé beírt mezőnevek kicserélésre kerülnek. Például: %fileId%, %src%, %title%, %description%",
"Using comments below wiki pages" => "Komment használata wiki oldal alatt",
"Development Notice" => "Fejlesztői megjegyzés",
"Administrator and accounts managers." => "Adminisztrátorok és fiók menedzserek",
"Can invite user in groups" => "Meghívhat felhasználókat csoportokhoz",
"Català" => "katalán",
"Česky" => "cseh",
"Cikktípusok adminisztrálása" => "Cikk típusok adminisztrálása",
"Dansk" => "dán",
"Deutsch" => "német",
"Español" => "spanyol",
"Français" => "francia",
"Hrvatski" => "horvát",
"Magyar" => "magyar",
"Minimum 5 characters long" => "Minimum 5 karakter hosszú",
"Nederlands" => "holland",
"Portuguese" => "portugál",
"Public users not logged" => "Nem loggolt nyilvános felhasználók",
"Published by" => "Publikálta:",
"Slovenčina" => "szlovén",
"Srpski" => "szerb",
"Svenska" => "svéd",
"user can register this site with socialnetworks" => "Regisztrálhatja az oldalt közösségi hálózatokon",
"Users logged into the system" => "Rendszerbe bejelentkezett felhasználók",
"user_registers" => "felhasználói regisztráció",
"wiki_page_changed" => "wiki oldal változása",
"Your preferred language:" => "Preferált nyelvem:",
"Group watches for this category" => "Kategória csoportok általi figyelése",
"Groups watching this category:" => "Kategóriát figyelő csoportok száma:",
"List Entries" => "Tételek listája",
"Upload Media" => "Média feltöltése",
"Watch this category and its descendants" => "Kategória és hozzá tartozó alkategóriák figyelése",
"Log in as…" => "Bejelentkezés",
"Passwords don't match" => "A jelszavak nem egyeznek",
"Passwords match" => "A jelszavak egyeznek",
"JQuery" => "JQuery",
"NoJQuery" => "NoJQuery",
"o|p|c|op|oc|pc|opc" => "o|p|c|op|oc|pc|opc",
"Css Menus" => "Css menük",
"User Levels" => "Felhasználói szintek",
"Custom code" => "Saját kód",
"Disable javascript" => "Javascript kikapcsolása",
"Use CDN for Javascript" => "CDN használata Javascript-hez",
"Minify javascript" => "Javascript kicsinyítés",
"Requires javascript" => "Javascript-et igényel",
"JQuery Code" => "JQuery kód",
"Automatically creates a link to the appropriate SourceForge object" => "Automatikus linket hoz létre a megfelelő SourceForge objektumhoz",
"shownbitems" => "Tételek számának megjelenítése",
"Show Last Modification" => "Legutóbbi módosítás megjelenítése",
"List of items Ids" => "Tétel ID-k listája",
"If y, value will be truncated" => "Ha igen ('y') akkor az érték le lesz csapva (trunc)",
"Tracker page name" => "Űrlap oldal név",
"hour, day, week, month or year (default to hour)" => "óra, nap, hét, hónap vagy év (értékek: hour, day, week, month or year (alapértelmezés: hour)",
"hour, day, week, month, year or empty (default to empty)" => "óra, nap, hét, hónap vagy év (értékek: hour, day, week, month or year (alapértelmezés: hour)",
"Convert the group name to a link. (y|n)" => "Csoport nevének linkké alakítása (y|n)",
"Lists ''wanted'' wiki pages" => "'Wanted'' wiki oldalak listázása",
"Display youtube video in a wiki page" => "Youtube videót jelenít meg wiki oldalon",
"URL to the Youtube video" => "A Youtube videóra mutató URL",
"Missing parameter movie to the youtube plugin" => "Hiányzik a film paraméter",
"Administrator, can manage users groups and permissions, Hotwords and all the weblog features" => "Adminsiztrátor, menedzselheti a felhasználókat, csoportokat, jogosutlságokat, forró szavakat és az összes blog funkciót",
"Can change the categories on the object" => "Megváltozhathatja egy objektum kategorizálását",
"Can delete his own account" => "Törölheti saját fiókját",
"Can promote a page (email, twitter, facebook)" => "Promótálhat oldalt (E-mail, Twitter, Facebook)",
"Can report msgs to moderator" => "Jelenthet üzeneteket a moderátor részére",
"Can use the Tiki Importer" => "Használhatja a Tiki importert",
"Can view referer stats" => "Megnézheti a hivatkozási statisztikákat",
"User can Administer Modules" => "Adminisztrálhat modulokat",
"category or object permissions" => "kategória vagy objektum jogosultságok",
"2 comments" => "2 komment",
"Displays a link to a file (either from the file gallery or an attachment to a wiki page) and can display an image attachment." => "Fájlra mutató linket jelenít meg (fájlgaléria vagy wiki oldal melléklete), valamint meg tud jeleníteni képformátumú mellékletet.",
"on|off" => "on|off",
"left|right|center|justify" => "left|right|center|justify",
"0|1" => "0|1",
"name_asc" => "name_asc",
"ftp" => "ftp",
"1|0" => "1|0",
"255,255,255" => "255,255,255",
"NotOnReady" => "NotOnReady",
"true|false" => "true|false",
"name|desc" => "name|desc",
"asc|desc|shuffle" => "asc|desc|shuffle",
"ADODB DNS" => "ADODB DNS",
"hits|user" => "hits|user",
"asc|desc" => "asc|desc",
"plain|fancy" => "plain|fancy",
"user|page" => "user|page",
"Articles displayed" => "Megjelenített cikkek",
"Topics expression" => "Témák kifejezés",
"Topic ID expression" => "Téma ID kifejezés",
"Type expression" => "Típus kifejezés",
"Title only" => "Csak cím",
"Start date" => "Kezdés dátuma",
"Number" => "Szám",
"Show icon" => "Ikon megjelenítése",
"User name" => "Felhasználói név",
"Color codes parts of the page like 'Track changes' in Office programs." => "Színkódok az oldal részeként mint például a 'Változások nyomonkövetése' a Microsoft Office-ban",
"left|right" => "bal|jobb",
"Numeric value" => "Numerikus érték",
"fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle" => "fieldName_asc|fieldName_desc, valid mezők: type, created, name, hits, shuffle",
"Display top category" => "Legfelső kategória megjelenítése",
"yes|no, default to no" => "yes|no (alapértelmezés: no)",
"Line numbers" => "Sorok száma",
"Right to left" => "Jobbról balra",
"Also known as fortune cookies or taglines" => "Más néven szerencssüti vagy címkesor",
"Wiki DSN name" => "Wiki DSN név",
"Includes the list of events from a calendar in the page." => "Egy naptár eseményeit listázza az oldalon.",
"Numeric" => "Numerikus",
"Maximum days" => "Maximum napok",
"Maximum Rows" => "Maximum sorok",
"Datetime" => "Dátum idő",
"Use div" => "Div használata",
"Use div instead of ol" => "Div használata rendezett lista formátum helyett",
"Heading row" => "Fejléc sor",
"Displays a list of files from the File Gallery" => "Fájlgalériában található fájlok listáját jeleníti meg",
"Default width: 425" => "Alapértelmezett szélesség: 425",
"Default height: 350" => "Alapértelmezett magasság: 350",
"Ftp Server Name" => "Ftp szerver név",
"Ftp User name" => "Ftp felhasználó név",
"Ftp password" => "Ftp jelszó",
"Download button label" => "Letöltési gomb felirata",
"current value (REQUIRED)" => "jelenlegi érték (SZÜKSÉGES)",
"Account number" => "Számla szám",
"Name of iframe" => "Iframe neve",
"List of groups including a group" => "Csoportot magába foglaló csoportok listázása",
"groups" => "csoportok",
"Displays some stat about group belonging" => "Statisztikát jelenít meg csoporttagságról",
"name" => "név",
"Maximum amount of files to display" => "Megjelenítendő fájlok maximális száma",
"Allow to send mail to groups or user or email directly" => "Lehetővé teszi E-mail küldését csoport vagy adott felhasználó vagy adott E-mail cím részére.",
"Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5px" => "Eltolja a feliratot jobbra a kurzorhoz képest a megadott pixelszámmal. Alapértelmezés: 5px",
"Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0px" => "Eltolja a feliratot balra a kurzorhoz képest a megadott pixelszámmal. Alapértelmezés: 0px",
"y|n, parse the body of the plugin as wiki content. (Default to y)" => "y|n, wiki tartalomként elemzi a plugin törzsét (Alapértelmezés: y)",
"Effect speed" => "Effektus sebessége",
"fancy" => "puccos",
"Displays a table using MediaWiki syntax" => "Táblázatot jelenít meg MediaWiki szintakszissal",
"Object ID" => "Objektum ID",
"Displays a list of plugins available in this wiki." => "Megjeleníti ezen wiki pluginjainak listáját",
"Poll ID" => "Szavazás ID",
"Reply to" => "Válasz",
"0|1, switch the text display from left to right to right to left" => "0|1, a szöveg megjelenítését jobbról balra irányra állítja át",
"0|1, display the content as is instead of escaping HTML special chars" => "0|1, tartalom megjelenítése úgy ahogy van ahelyett hogy átugraná a speciális HTML karaktereket",
"Generate the width attribute on the columns" => "A width (szélesség) attribútumot generálja az oszlopokhoz",
"Column Size" => "Oszlop méret",
"Custom class" => "Saját osztály (custom class)",
"add a class to customize the design" => "Osztály hozzáadása a design testreszabásához",
"DNS Name" => "DNS név",
"As known in Tikiwiki" => "Tikiwikiben használt név",
"Provides tabs built using the smarty tabset block." => "Smarty fülkészlet blokk funkción alapuló fülek",
"0|1, show the page description instead of the page name" => "0|1, az oldal leírását mutatja az oldal neve helyett (1)",
"0|1, display the section numbers or not" => "0|1, szekció számok megjelenítése (1) vagy nem (0)",
"Translate a string using Tikiwiki translation table." => "Szövegdarab lefordítása a Tiki fordítói adatbázisa segíségével",
"Label on the submit button" => "A Küldés gombon megjelenő felirat",
"Show Mandatory" => "Kötelező megjelenítése",
"URL used for the field links" => "Mező linkekhez használt URL",
"itemId if you want to edit an item" => "Tétel ID a tétel szerkesztéséhez",
"Width of first column " => "Első oszlop szélessége",
"\n\t\t\tExact match\n\t\t\n\t" => "Pontos egyezés",
"missing translations" => "hiányzó fordítások",
"Magnifier" => "Nagyító",
"Tracker Item:" => "Űrlaptétel:",
"Create/edit dsn" => "DSN létrehozása/szerkesztése",
"Included group, group users and emails will be refreshed at each newsletter sending" => "A tartalmazott csoport, csoportban lévő felhasználók és E-mail címek az egyes kiküldések alkalmával kerülnek frissítésre",
"Allow posting of comments as Anonymous" => "Anonim komment feladás engedélyezése",
"Displays the content of a spreadsheet in the page." => "Egy ív (tiki táblázat) tartalmának megjelenítése egy oldalon.",
"TikiSheet" => "Tikiív",
"Add or edit a rule" => "Szabály hozzáadása vagy szerkesztése",
"AuthorName" => "Szerző neve",
"Edit this sheet:" => "Táblázat fül szerkesztése:",
"Class Name" => "Osztály neve",
"Header Rows" => "Fejléc sorok",
"Footer Rows" => "Lábléc sorok",
"Wiki Parse Values" => "Wiki értékek elemzése",
"Parent SheetId" => "Szülő táblázat",
// ### end of unused words

// ### start of untranslated words
// ### uncomment value pairs as you translate
// "Re" => "Re",
// "This forum is flat and doesn't allow replies to other replies" => "This forum is flat and doesn't allow replies to other replies",
// "This script cannot be called directly" => "This script cannot be called directly",
// "Tiki was unable to retrieve login data from the database " => "Tiki was unable to retrieve login data from the database ",
// "The following error message was returned" => "The following error message was returned",
// "Things to check" => "Things to check",
// "Are your database login credentials correct" => "Are your database login credentials correct",
// "Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Did you complete the <a href='tiki-install.php' >Tiki Installer",
// "Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information" => "Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information",
// "This feature is for admins only" => "This feature is for admins only",
// "ID" => "ID",
// "Uploaded by" => "Uploaded by",
// "Last Modified by" => "Last Modified by",
// "Aland_Islands" => "Aland_Islands",
// "American_Samoa" => "American_Samoa",
// "Bosnia_and_Herzegovina" => "Bosnia_and_Herzegovina",
// "Bouvet_Island" => "Bouvet_Island",
// "British Indian Ocean Territory" => "British Indian Ocean Territory",
// "British Virgin Islands" => "British Virgin Islands",
// "British_Indian_Ocean_Territory" => "British_Indian_Ocean_Territory",
// "British_Virgin_Islands" => "British_Virgin_Islands",
// "Burkina_Faso" => "Burkina_Faso",
// "Cape_Verde" => "Cape_Verde",
// "Catalan Countries" => "Catalan Countries",
// "Catalan_Countries" => "Catalan_Countries",
// "Cayman_Islands" => "Cayman_Islands",
// "Central African Republic" => "Central African Republic",
// "Central_African_Republic" => "Central_African_Republic",
// "Christmas_Island" => "Christmas_Island",
// "Cocos Islands" => "Cocos Islands",
// "Cocos_Islands" => "Cocos_Islands",
// "Comoros" => "Comoros",
// "Congo Democratic" => "Congo Democratic",
// "Congo_Democratic" => "Congo_Democratic",
// "Cook Islands" => "Cook Islands",
// "Cook_Islands" => "Cook_Islands",
// "Costa_Rica" => "Costa_Rica",
// "Czech_Republic" => "Czech_Republic",
// "Djibouti" => "Djibouti",
// "Dominican_Republic" => "Dominican_Republic",
// "El_Salvador" => "El_Salvador",
// "Equatorial_Guinea" => "Equatorial_Guinea",
// "Falkland_Islands" => "Falkland_Islands",
// "Faroe_Islands" => "Faroe_Islands",
// "Federated States of Micronesia" => "Federated States of Micronesia",
// "Federated_States_of_Micronesia" => "Federated_States_of_Micronesia",
// "French Southern Territories" => "French Southern Territories",
// "French_Guiana" => "French_Guiana",
// "French_Polynesia" => "French_Polynesia",
// "French_Southern_Territories" => "French_Southern_Territories",
// "Georgia" => "Georgia",
// "Guadeloupe" => "Guadeloupe",
// "Guam" => "Guam",
// "Guernsey" => "Guernsey",
// "Guinea Bissau" => "Guinea Bissau",
// "Guinea_Bissau" => "Guinea_Bissau",
// "Guyana" => "Guyana",
// "Heard Island and McDonald Islands" => "Heard Island and McDonald Islands",
// "Heard_Island_and_McDonald_Islands" => "Heard_Island_and_McDonald_Islands",
// "Hong_Kong" => "Hong_Kong",
// "Isle of Man" => "Isle of Man",
// "Ivory Coast" => "Ivory Coast",
// "Ivory_Coast" => "Ivory_Coast",
// "Jersey" => "Jersey",
// "Lesotho" => "Lesotho",
// "Marshall Islands" => "Marshall Islands",
// "Marshall_Islands" => "Marshall_Islands",
// "Martinique" => "Martinique",
// "Mauritius" => "Mauritius",
// "Mayotte" => "Mayotte",
// "Montserrat" => "Montserrat",
// "Netherlands_Antilles" => "Netherlands_Antilles",
// "New_Caledonia" => "New_Caledonia",
// "New_Zealand" => "New_Zealand",
// "Norfolk_Island" => "Norfolk_Island",
// "North_Korea" => "North_Korea",
// "Northern Mariana Islands" => "Northern Mariana Islands",
// "Northern_Mariana_Islands" => "Northern_Mariana_Islands",
// "Papua_New_Guinea" => "Papua_New_Guinea",
// "Paraguay" => "Paraguay",
// "Peru" => "Peru",
// "Philippines" => "Philippines",
// "Pitcairn" => "Pitcairn",
// "Poland" => "Poland",
// "Puerto Rico" => "Puerto Rico",
// "Puerto_Rico" => "Puerto_Rico",
// "Quatar" => "Quatar",
// "Republic of Macedonia" => "Republic of Macedonia",
// "Republic_of_Macedonia" => "Republic_of_Macedonia",
// "Reunion" => "Reunion",
// "Romania" => "Romania",
// "Russia" => "Russia",
// "Russian Federation" => "Russian Federation",
// "Russian_Federation" => "Russian_Federation",
// "Rwanda" => "Rwanda",
// "Saint Helena" => "Saint Helena",
// "Saint Kitts and Nevis" => "Saint Kitts and Nevis",
// "Saint Lucia" => "Saint Lucia",
// "Saint Pierre and Miquelon" => "Saint Pierre and Miquelon",
// "Saint_Helena" => "Saint_Helena",
// "Saint_Kitts_and_Nevis" => "Saint_Kitts_and_Nevis",
// "Saint_Lucia" => "Saint_Lucia",
// "Saint_Pierre_and_Miquelon" => "Saint_Pierre_and_Miquelon",
// "Samoa" => "Samoa",
// "San Marino" => "San Marino",
// "San_Marino" => "San_Marino",
// "Sao Tome and Principe" => "Sao Tome and Principe",
// "Sao_Tome_and_Principe" => "Sao_Tome_and_Principe",
// "Saudi Arabia" => "Saudi Arabia",
// "Saudi_Arabia" => "Saudi_Arabia",
// "Senegal" => "Senegal",
// "Serbia" => "Serbia",
// "Seychelles" => "Seychelles",
// "Sierra Leone" => "Sierra Leone",
// "Sierra_Leone" => "Sierra_Leone",
// "Singapore" => "Singapore",
// "Solomon Islands" => "Solomon Islands",
// "Solomon_Islands" => "Solomon_Islands",
// "Somalia" => "Somalia",
// "South Africa" => "South Africa",
// "South_Africa" => "South_Africa",
// "South_Georgia_and_South_Sandwich_Islands" => "South_Georgia_and_South_Sandwich_Islands",
// "South_Korea" => "South_Korea",
// "Sri Lanka" => "Sri Lanka",
// "Sri_Lanka" => "Sri_Lanka",
// "St Vincent Grenadines" => "St Vincent Grenadines",
// "St_Vincent_Grenadines" => "St_Vincent_Grenadines",
// "Surinam" => "Surinam",
// "Svalbard and Jan Mayen" => "Svalbard and Jan Mayen",
// "Svalbard_and_Jan_Mayen" => "Svalbard_and_Jan_Mayen",
// "Swaziland" => "Swaziland",
// "Taiwan" => "Taiwan",
// "Timor-Leste" => "Timor-Leste",
// "Togo" => "Togo",
// "Tokelau" => "Tokelau",
// "Tonga" => "Tonga",
// "Trinidad Tobago" => "Trinidad Tobago",
// "Trinidad_Tobago" => "Trinidad_Tobago",
// "Turkey" => "Turkey",
// "Turks and Caicos Islands" => "Turks and Caicos Islands",
// "Turks_and_Caicos_Islands" => "Turks_and_Caicos_Islands",
// "Tuvalu" => "Tuvalu",
// "US Virgin Islands" => "US Virgin Islands",
// "US_Virgin_Islands" => "US_Virgin_Islands",
// "Uganda" => "Uganda",
// "Ukraine" => "Ukraine",
// "United Arab Emirates" => "United Arab Emirates",
// "United Nations Organization" => "United Nations Organization",
// "United States Minor Outlying Islands" => "United States Minor Outlying Islands",
// "United States" => "United States",
// "United_Arab_Emirates" => "United_Arab_Emirates",
// "United_Kingdom" => "United_Kingdom",
// "United_Kingdom_-_England_and_Wales" => "United_Kingdom_-_England_and_Wales",
// "United_Kingdom_-_Northern_Ireland" => "United_Kingdom_-_Northern_Ireland",
// "United_Kingdom_-_Scotland" => "United_Kingdom_-_Scotland",
// "United_Nations_Organization" => "United_Nations_Organization",
// "United_States" => "United_States",
// "United_States_Minor_Outlying_Islands" => "United_States_Minor_Outlying_Islands",
// "Uruguay" => "Uruguay",
// "Vanuatu" => "Vanuatu",
// "Vatican" => "Vatican",
// "Venezuela" => "Venezuela",
// "Viet_Nam" => "Viet_Nam",
// "Wales" => "Wales",
// "Wallis and Futuna" => "Wallis and Futuna",
// "Wallis_and_Futuna" => "Wallis_and_Futuna",
// "Western Sahara" => "Western Sahara",
// "Western_Sahara" => "Western_Sahara",
// "Yemen" => "Yemen",
// "Zambia" => "Zambia",
// "Zimbabwe" => "Zimbabwe",
// "the_former_Yugoslav_Republic_of_Macedonia" => "the_former_Yugoslav_Republic_of_Macedonia",
// "Tiki Installer" => "Tiki Installer",
// "MySQL Improved (mysqli)" => "MySQL Improved (mysqli)",
// "MySQL classic (mysql)" => "MySQL classic (mysql)",
// "Email address not valid, test mail not sent" => "Email address not valid, test mail not sent",
// "Email address empty and \"copy\" checkbox not set, test mail not sent" => "Email address empty and \"copy\" checkbox not set, test mail not sent",
// "Test mail from Tiki installer " => "Test mail from Tiki installer ",
// "Tiki version" => "Tiki version",
// "PHP version" => "PHP version",
// "No database name specified" => "No database name specified",
// "Congratulations!\n\nYour server can send emails.\n\n" => "Congratulations!\n\nYour server can send emails.\n\n",
// "Fijian" => "Fijian",
// "Norwegian Nynorsk" => "Norwegian Nynorsk",
// "Romansh" => "Romansh",
// "Template %s not registered" => "Template %s not registered",
// "Error line: %d" => "Error line: %d",
// "anonymous" => "anonymous",
// "Blog cannot be found" => "Blog cannot be found",
// "All day" => "All day",
// "First day of week: Sunday (its ID is 0) - translators you need to localize this string" => "First day of week: Sunday (its ID is 0) - translators you need to localize this string",
// "Su" => "Su",
// "Th" => "Th",
// "Sa" => "Sa",
// "New Subscriptions" => "New Subscriptions",
// "New Item in Tracker" => "New Item in Tracker",
// "Wiki" => "Wiki",
// "Empty captcha value" => "Empty captcha value",
// "You have mistyped the anti-bot verification code. Please try again" => "You have mistyped the anti-bot verification code. Please try again",
// "Failed to validate captcha" => "Failed to validate captcha",
// "Captcha ID field is missing" => "Captcha ID field is missing",
// "Get a visual challenge" => "Get a visual challenge",
// "Get an audio challenge" => "Get an audio challenge",
// "Get a new challenge" => "Get a new challenge",
// "Type the two words" => "Type the two words",
// "Type what you hear" => "Type what you hear",
// "Play sound again" => "Play sound again",
// "Download sound as MP3" => "Download sound as MP3",
// "Incorrect. Try again" => "Incorrect. Try again",
// "newsletter" => "newsletter",
// "Invalid filename (using filters for filenames)" => "Invalid filename (using filters for filenames)",
// "(not registered)" => "(not registered)",
// "Anonymous" => "Anonymous",
// "Please wait %d seconds between posts" => "Please wait %d seconds between posts",
// "A contribution is mandatory" => "A contribution is mandatory",
// "You have to enter a title and text" => "You have to enter a title and text",
// "Invalid Email" => "Invalid Email",
// "Your message has been queued for approval and will be posted after a moderator approves it" => "Your message has been queued for approval and will be posted after a moderator approves it",
// "This forum is locked" => "This forum is locked",
// "This thread is locked" => "This thread is locked",
// "Those comments are locked" => "Those comments are locked",
// "Expecting \"(\"" => "Expecting \"(\"",
// "Unexpected \"%0\"" => "Unexpected \"%0\"",
// "Expecting \")\"" => "Expecting \")\"",
// "%0 near \"%1\"" => "%0 near \"%1\"",
// "No formula provided" => "No formula provided",
// "Variable not found \"%0\"" => "Variable not found \"%0\"",
// "Unknown operation \"%0\"" => "Unknown operation \"%0\"",
// "Internal error" => "Internal error",
// "User error" => "User error",
// "Plugin argument(s) missing" => "Plugin argument(s) missing",
// "Plugin <strong>%0</strong> cannot be executed" => "Plugin <strong>%0</strong> cannot be executed",
// "WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: line count mismatch: %s != %s",
// "WikiDiff::_check: failed" => "WikiDiff::_check: failed",
// "WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: edit sequence is non-optimal",
// "WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
// "Line" => "Line",
// "Lines" => "Lines",
// "Cannot open this file" => "Cannot open this file",
// "The upload has not been done" => "The upload has not been done",
// "Reason: The global quota has been reached" => "Reason: The global quota has been reached",
// "Reason: The quota has been reached in \"%s\"" => "Reason: The quota has been reached in \"%s\"",
// "Number of files transferred to the database" => "Number of files transferred to the database",
// "Number of files transferred to the file system" => "Number of files transferred to the file system",
// "Cannot read to this file" => "Cannot read to this file",
// "Old File deleted" => "Old File deleted",
// "This is an approximation based on your server memory limit" => "This is an approximation based on your server memory limit",
// "This is the value of your server's PHP '%s' setting" => "This is the value of your server's PHP '%s' setting",
// "You are alerted by the server " => "You are alerted by the server ",
// "You can check the modifications at : " => "You can check the modifications at : ",
// "You are alerted of a change on " => "You are alerted of a change on ",
// "Invalid imagename (using filters for filenames)" => "Invalid imagename (using filters for filenames)",
// "Upload was not successful" => "Upload was not successful",
// "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
// "unlink failed" => "unlink failed",
// "The uploaded file exceeds the upload_max_filesize directive in php.ini" => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
// "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
// "The uploaded file was only partially uploaded. Please try again" => "The uploaded file was only partially uploaded. Please try again",
// "No file was uploaded" => "No file was uploaded",
// "Missing a temporary folder" => "Missing a temporary folder",
// "Failed to write file to disk" => "Failed to write file to disk",
// "File upload stopped by extension" => "File upload stopped by extension",
// "Number of page revisions to import (0 for all revisions)" => "Number of page revisions to import (0 for all revisions)",
// "What to do with page names that already exists in TikiWiki" => "What to do with page names that already exists in TikiWiki",
// "Do not import" => "Do not import",
// "Override" => "Override",
// "Append software name as prefix to the page name" => "Append software name as prefix to the page name",
// "<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "<a href=\"tiki-importer.php\">Click here</a> to finish the import process",
// "\$countParsedData pages parsed. Starting to insert those pages into Tiki" => "\$countParsedData pages parsed. Starting to insert those pages into Tiki",
// "Page \${page['name']} sucessfully imported" => "Page \${page['name']} sucessfully imported",
// "Page \${page['name']} NOT imported (there was already a page with the same name)" => "Page \${page['name']} NOT imported (there was already a page with the same name)",
// "Import images and attachments (see documentation for more information)" => "Import images and attachments (see documentation for more information)",
// "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php",
// "Invalid file mime type" => "Invalid file mime type",
// "XML file does not validate against the Mediawiki XML schema" => "XML file does not validate against the Mediawiki XML schema",
// "Mediawiki XML file version \$xmlVersion is not supported" => "Mediawiki XML file version \$xmlVersion is not supported",
// "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments",
// "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) does no exist. Fix the problem or try to import without the attachments" => "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) does no exist. Fix the problem or try to import without the attachments",
// "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) is not writable. Fix the problem or try to import without attachments" => "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) is not writable. Fix the problem or try to import without attachments",
// "Parsing pages" => "Parsing pages",
// "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment" => "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment",
// "Importing attachments" => "Importing attachments",
// "NOT importing file \$fileName as there is already a file with the same name in the destination directory (\$this->attachmentsDestDir)" => "NOT importing file \$fileName as there is already a file with the same name in the destination directory (\$this->attachmentsDestDir)",
// "File \$fileName successfully imported" => "File \$fileName successfully imported",
// "Unable to download file \$fileName. File not found" => "Unable to download file \$fileName. File not found",
// "Error while parsing revision \$i of the page \"\${data['name']}\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)" => "Error while parsing revision \$i of the page \"\${data['name']}\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)",
// "Page \"\${data['name']}\" successfully parsed with \$countRevisions revisions (from a total of \$totalRevisions revisions)" => "Page \"\${data['name']}\" successfully parsed with \$countRevisions revisions (from a total of \$totalRevisions revisions)",
// "Page \"\${data['name']}\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "Page \"\${data['name']}\" is NOT going to be imported. It was not possible to parse any of the page revisions",
// "Admin ' . \$str));\n\n\n\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-list" => "Admin ' . \$str));\n\n\n\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-list",
// "List ' . \$str));\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-view" => "List ' . \$str));\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-view",
// "View ' . \$str));\n\n\n\t\t\t\t} else { // still not set? guess...\n\t\t\t\t\t\$str = str_replace(array('tiki-" => "View ' . \$str));\n\n\n\t\t\t\t} else { // still not set? guess...\n\t\t\t\t\t\$str = str_replace(array('tiki-",
// "ERROR: unable to write to lang/%s/language.php" => "ERROR: unable to write to lang/%s/language.php",
// "The file lang/\$this->lang/language.php is not well formated. Run get_strings.php?lang=\$this->lang and then try to export the translations again" => "The file lang/\$this->lang/language.php is not well formated. Run get_strings.php?lang=\$this->lang and then try to export the translations again",
// "Query point" => "Query point",
// "layer" => "layer",
// "Record" => "Record",
// "No valid ogr2ogr executable" => "No valid ogr2ogr executable",
// "Could not create \$tdo.mif in data directory" => "Could not create \$tdo.mif in data directory",
// "Could not create \$tdo.mid in data directory" => "Could not create \$tdo.mid in data directory",
// "User Map Generated in" => "User Map Generated in",
// "Image Map Generated in" => "Image Map Generated in",
// "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it" => "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it",
// "menu" => "menu",
// "NONE" => "NONE",
// "Invalid \"from\" date received" => "Invalid \"from\" date received",
// "Invalid \"to\" date received" => "Invalid \"to\" date received",
// "Sorry, \"from\" date must precede \"to\" date" => "Sorry, \"from\" date must precede \"to\" date",
// "Sorry, no data available for the future" => "Sorry, no data available for the future",
// "for month of" => "for month of",
// "for week of" => "for week of",
// "Integer (i)" => "Integer (i)",
// "Percentage (%)" => "Percentage (%)",
// "Float (f)" => "Float (f)",
// "List (L)" => "List (L)",
// "Daily (+)" => "Daily (+)",
// "Monthly and weekly (@)" => "Monthly and weekly (@)",
// "Weekly (-)" => "Weekly (-)",
// "File %s not found" => "File %s not found",
// "File %s is not a valid archive" => "File %s is not a valid archive",
// "Impossible to open %s : %s" => "Impossible to open %s : %s",
// "The content retrieved at %s is not a list of mods" => "The content retrieved at %s is not a list of mods",
// "Can't chdir to '%s'" => "Can't chdir to '%s'",
// "%s impossible to remove" => "%s impossible to remove",
// "Description not available" => "Description not available",
// "Module Title" => "Module Title",
// "Title to display at the top of the box" => "Title to display at the top of the box",
// "No box" => "No box",
// "Show only the content" => "Show only the content",
// "Decorations" => "Decorations",
// "Show module decorations" => "Show module decorations",
// "No title" => "No title",
// "Show module title" => "Show module title",
// "Only display the module if in one of the listed perspective IDs. Semi-colon separated" => "Only display the module if in one of the listed perspective IDs. Semi-colon separated",
// "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons",
// "Module only applicable for the specified sections. Multiple values can be separated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be separated by semi-colons",
// "Page filter" => "Page filter",
// "Module only applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be separated by semi-colons",
// "No Page" => "No Page",
// "Module not applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be separated by semi-colons",
// "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module",
// "Contributor" => "Contributor",
// "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module",
// "Users can shade module" => "Users can shade module",
// "No numbers" => "No numbers",
// "If set to \"y\", the module will not number list items" => "If set to \"y\", the module will not number list items",
// "Number of rows, or items, to display" => "Number of rows, or items, to display",
// "Default: 10" => "Default: 10",
// "Newsletter subscription information at" => "Newsletter subscription information at",
// "invalid email" => "invalid email",
// "Sending to" => "Sending to",
// "section edit" => "section edit",
// "Payment sent but verification not currently available. (Work in progress)" => "Payment sent but verification not currently available. (Work in progress)",
// "Product" => "Product",
// "Quantity" => "Quantity",
// "Unit Price" => "Unit Price",
// "Cart Check-Out" => "Cart Check-Out",
// "Cclite error" => "Cclite error",
// "No registries specified in admin/payment/cclite" => "No registries specified in admin/payment/cclite",
// "Cclite payment initiated on %0" => "Cclite payment initiated on %0",
// "Connection to cclite server %0 failed for %1<br />\"%2\"" => "Connection to cclite server %0 failed for %1<br />\"%2\"",
// "Tiki credits payment done on %0 for \$amount (using \$creditType)" => "Tiki credits payment done on %0 for \$amount (using \$creditType)",
// "Ajax Xajax" => "Ajax Xajax",
// "Use \"xajax\" library to \"ajaxify\" most Tiki pages" => "Use \"xajax\" library to \"ajaxify\" most Tiki pages",
// "Ajax auto-save" => "Ajax auto-save",
// "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing" => "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing",
// "Users can opt-out of internal messages" => "Users can opt-out of internal messages",
// "Article ordering" => "Article ordering",
// "Default sort mode for the articles on the article listing" => "Default sort mode for the articles on the article listing",
// "Trailer position" => "Trailer position",
// "Between heading and body" => "Between heading and body",
// "Header text position" => "Header text position",
// "Requires a smaller image for list view" => "Requires a smaller image for list view",
// "Next image" => "Next image",
// "Below image" => "Below image",
// "Paginate articles" => "Paginate articles",
// "Divide articles into multiple pages with pagebreak markers" => "Divide articles into multiple pages with pagebreak markers",
// "User ratings on articles" => "User ratings on articles",
// "Allows users to rate the articles" => "Allows users to rate the articles",
// "Article rating options" => "Article rating options",
// "List of options available for the rating of articles" => "List of options available for the rating of articles",
// "Default article image width" => "Default article image width",
// "0 for original image size" => "0 for original image size",
// "Default article image height" => "Default article image height",
// "Custom attributes for article types" => "Custom attributes for article types",
// "Allow additional custom fields for article types" => "Allow additional custom fields for article types",
// "Your ShareThis publisher identifier (optional)" => "Your ShareThis publisher identifier (optional)",
// "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database" => "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database",
// "Tiki" => "Tiki",
// "Tiki and OpenID" => "Tiki and OpenID",
// "Tiki and LDAP" => "Tiki and LDAP",
// "phpBB" => "phpBB",
// "Token Access" => "Token Access",
// "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service" => "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service",
// "Token Access Max Timeout" => "Token Access Max Timeout",
// "The maximum duration for which the generated tokens will be valid" => "The maximum duration for which the generated tokens will be valid",
// "Token Access Max Hits" => "Token Access Max Hits",
// "The maximum amount of times a token can be used before it expires" => "The maximum amount of times a token can be used before it expires",
// "Share access rights with friends when using Tell a friend" => "Share access rights with friends when using Tell a friend",
// "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site",
// "Share access rights with friends when using Share" => "Share access rights with friends when using Share",
// "Allow users to share their access rights on the current page with a friend when sending the link by email/twitter/facebook. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email/twitter/facebook. Lifespan of the links is defined by the site",
// "Create user if not in Tiki" => "Create user if not in Tiki",
// "Use Tiki authentication for Admin login" => "Use Tiki authentication for Admin login",
// "phpBB Database Hostname" => "phpBB Database Hostname",
// "phpBB Database Username" => "phpBB Database Username",
// "phpBB Database Password" => "phpBB Database Password",
// "phpBB Database Name" => "phpBB Database Name",
// "phpBB Table Prefix" => "phpBB Table Prefix",
// "Use Tiki authentication for users created in tiki" => "Use Tiki authentication for users created in tiki",
// "Write LDAP debug Information in Tiki Logs" => "Write LDAP debug Information in Tiki Logs",
// "Use SSL (ldaps)" => "Use SSL (ldaps)",
// "LDAP Bind Type" => "LDAP Bind Type",
// "Default: Anonymous Bind" => "Default: Anonymous Bind",
// "Full: userattr=username,UserDN,BaseDN" => "Full: userattr=username,UserDN,BaseDN",
// "OpenLDAP: cn=username,BaseDN" => "OpenLDAP: cn=username,BaseDN",
// "Active Directory (username@domain)" => "Active Directory (username@domain)",
// "Plain Username" => "Plain Username",
// "Base DN" => "Base DN",
// "User DN" => "User DN",
// "User OC" => "User OC",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Group DN" => "Group DN",
// "Group attribute" => "Group attribute",
// "Group description attribute" => "Group description attribute",
// "Group OC" => "Group OC",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "Group attribute in group entry" => "Group attribute in group entry",
// "(Leave this empty if the group name is already given in the user attribute)" => "(Leave this empty if the group name is already given in the user attribute)",
// "Disable Tiki users who doesn't have a phpBB login. (They could have been deleted)" => "Disable Tiki users who doesn't have a phpBB login. (They could have been deleted)",
// "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset" => "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset",
// "Available styles" => "Available styles",
// "BigBlueButton" => "BigBlueButton",
// "Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "Integration with the BigBlueButton collaboration server for web conference and screen sharing",
// "BigBlueButton server location" => "BigBlueButton server location",
// "Full URL to the BigBlueButton installation" => "Full URL to the BigBlueButton installation",
// "http://host.example.com/" => "http://host.example.com/",
// "BigBlueButton server salt" => "BigBlueButton server salt",
// "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic" => "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic",
// "Blogues" => "Blogues",
// "Custom Site Footer Content" => "Custom Site Footer Content",
// "Module (box) shadow end" => "Module (box) shadow end",
// "Days to display in the Calendar" => "Days to display in the Calendar",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
// "Enter a year or use +/- N to specify a year relative to the current year" => "Enter a year or use +/- N to specify a year relative to the current year",
// "Show Add to Google Calendar icon" => "Show Add to Google Calendar icon",
// "Word length of the captcha image" => "Word length of the captcha image",
// "Width of the captcha image in pixels" => "Width of the captcha image in pixels",
// "Level of noise of the captcha image" => "Level of noise of the captcha image",
// "Choose a smaller number for less noise and easier reading" => "Choose a smaller number for less noise and easier reading",
// "Use LDAP information when creating user in Tiki" => "Use LDAP information when creating user in Tiki",
// "Try automatically to connect SSO" => "Try automatically to connect SSO",
// "Force CAS logout when the user logout from tiki" => "Force CAS logout when the user logout from tiki",
// "Show Alternate Login Method in Header" => "Show Alternate Login Method in Header",
// "Hostname of the CAS server" => "Hostname of the CAS server",
// "Port of the CAS server" => "Port of the CAS server",
// "Path for the CAS server" => "Path for the CAS server",
// "CAS Extra Parameter" => "CAS Extra Parameter",
// "Extra Parameter to pass to the CAS Server" => "Extra Parameter to pass to the CAS Server",
// "CAS Authentication Verification Timeout" => "CAS Authentication Verification Timeout",
// "Verify authentication with the CAS server every N seconds. Null value means never reverify" => "Verify authentication with the CAS server every N seconds. Null value means never reverify",
// "2 minutes" => "2 minutes",
// "1 hour" => "1 hour",
// "Permits to show alternate content depending on category of current object" => "Permits to show alternate content depending on category of current object",
// "Category Jail" => "Category Jail",
// "Limits the visibility of objects to those in these categories. Used mainly for creating workspaces from perspectives" => "Limits the visibility of objects to those in these categories. Used mainly for creating workspaces from perspectives",
// "Category Defaults" => "Category Defaults",
// "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default" => "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default",
// "One per line. ex:1,4,6,7/4" => "One per line. ex:1,4,6,7/4",
// "Make sure that the categories on the translations are synchronized when modified on any version" => "Make sure that the categories on the translations are synchronized when modified on any version",
// "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)" => "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)",
// "Automatically geocode items when categorized in" => "Automatically geocode items when categorized in",
// "Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "Automatically geocode items based on category name when categorized in the sub-categories of this category ID",
// "Replace existing geocode if any" => "Replace existing geocode if any",
// "When automatically geocoding items based on category name, replace existing geocode if any" => "When automatically geocoding items based on category name, replace existing geocode if any",
// "Use approximate geocode location" => "Use approximate geocode location",
// "When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "When automatically geocoding items based on category name, use randomly approximated location instead of precise location",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
// "Allow users to change the language of the menus and labels" => "Allow users to change the language of the menus and labels",
// "Users can change their password" => "Users can change their password",
// "Hide the title field on comments and their replies" => "Hide the title field on comments and their replies",
// "Email field for comments (only for anonymous users)" => "Email field for comments (only for anonymous users)",
// "Website field for comments (only for anonymous users)" => "Website field for comments (only for anonymous users)",
// "Allows users with permission tiki_p_vote_comments to vote comments" => "Allows users with permission tiki_p_vote_comments to vote comments",
// "Domain" => "Domain",
// "Include pageviews by the Admin when reporting stats" => "Include pageviews by the Admin when reporting stats",
// "Enable daily reports for new users" => "Enable daily reports for new users",
// "utf-8" => "utf-8",
// "iso-8859-1" => "iso-8859-1",
// "Full inline diff by characters" => "Full inline diff by characters",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
// "Max. number of links around the current item" => "Max. number of links around the current item",
// "Max. number of links after the first or before the last item" => "Max. number of links after the first or before the last item",
// "Show the country flag" => "Show the country flag",
// "Enable cool sites" => "Enable cool sites",
// "Number of columns per page when listing directory categories" => "Number of columns per page when listing directory categories",
// "6" => "6",
// "Method to Open Directory Links" => "Method to Open Directory Links",
// "Re-validate user by email after" => "Re-validate user by email after",
// "Use \"-1\" for never" => "Use \"-1\" for never",
// "PHP errors visible to admin only" => "PHP errors visible to admin only",
// "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators" => "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators",
// "Level from which errors should be reported" => "Level from which errors should be reported",
// "Report all PHP errors except strict" => "Report all PHP errors except strict",
// "Report all PHP errors except notices" => "Report all PHP errors except notices",
// "Collaboratively authored documents with history of changes" => "Collaboratively authored documents with history of changes",
// "Online diaries or journals" => "Online diaries or journals",
// "Collections of graphic images for viewing or downloading (photo album)" => "Collections of graphic images for viewing or downloading (photo album)",
// "You can use file galleries instead" => "You can use file galleries instead",
// "Uses Google Translate to translate the content of wiki pages to other languages" => "Uses Google Translate to translate the content of wiki pages to other languages",
// "Experimental. This feature is still under development" => "Experimental. This feature is still under development",
// "Database & form generator" => "Database & form generator",
// "Online discussions on a variety of topics. Threaded or flat" => "Online discussions on a variety of topics. Threaded or flat",
// "Computer files, videos or software for downloading. With check-in & check-out (lock)" => "Computer files, videos or software for downloading. With check-in & check-out (lock)",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
// "Brief list of votable options; appears in module (left or right column)" => "Brief list of votable options; appears in module (left or right column)",
// "Content mailed to registered users" => "Content mailed to registered users",
// "Events calendar with public, private and group channels" => "Events calendar with public, private and group channels",
// "Insert, track, and manage advertising banners" => "Insert, track, and manage advertising banners",
// "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions" => "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions",
// "Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score is a game to motivate participants to increase their contribution by comparing to other users",
// "Tiki-indexed Search" => "Tiki-indexed Search",
// "Enables searching for content on the website, using Tiki-managed index" => "Enables searching for content on the website, using Tiki-managed index",
// "Unless you have a reason to, you should use MySQL Full-Text Search feature instead" => "Unless you have a reason to, you should use MySQL Full-Text Search feature instead",
// "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns" => "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns",
// "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis" => "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis",
// "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports" => "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports",
// "Enables internationalization features and multilingual support for then entire site" => "Enables internationalization features and multilingual support for then entire site",
// "Frequently asked questions and answers" => "Frequently asked questions and answers",
// "You can use wiki pages instead" => "You can use wiki pages instead",
// "Questionnaire with multiple choice or open ended question" => "Questionnaire with multiple choice or open ended question",
// "User-submitted Web links" => "User-submitted Web links",
// "Timed questionnaire with recorded scores" => "Timed questionnaire with recorded scores",
// "Simple menu system which can optionally add an external web page in an iframe" => "Simple menu system which can optionally add an external web page in an iframe",
// "The Copyright Management System (or ©MS) is a way of licensing your content" => "The Copyright Management System (or ©MS) is a way of licensing your content",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
// "Navigable, interactive maps with user-selectable layers" => "Navigable, interactive maps with user-selectable layers",
// "Requires mapserver" => "Requires mapserver",
// "Interactive use of Google Maps" => "Interactive use of Google Maps",
// "One-on-one chatting with customer" => "One-on-one chatting with customer",
// "Add a link \"Email this page\" in all the pages" => "Add a link \"Email this page\" in all the pages",
// "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums" => "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums",
// "be careful when allowing to anonymous to activate the antibot feature" => "be careful when allowing to anonymous to activate the antibot feature",
// "Static and dynamic HTML content" => "Static and dynamic HTML content",
// "HTML can be used in wiki pages. This is a separate feature" => "HTML can be used in wiki pages. This is a separate feature",
// "Basic form from visitor to admin" => "Basic form from visitor to admin",
// "Real-time group text chatting" => "Real-time group text chatting",
// "An admin must validate a comment before it is visible" => "An admin must validate a comment before it is visible",
// "Comments can be closed (no new comments)" => "Comments can be closed (no new comments)",
// "Allow logged in users to pretend to be anonymous when posting a commment" => "Allow logged in users to pretend to be anonymous when posting a commment",
// "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally" => "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally",
// "Display page description" => "Display page description",
// "Display the page description below the heading when viewing the page" => "Display the page description below the heading when viewing the page",
// "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header" => "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header",
// "Display page ID" => "Display page ID",
// "Display the internal page ID when viewing the page" => "Display the internal page ID when viewing the page",
// "Allow users to change the duration of the cache on a per-page basis" => "Allow users to change the duration of the cache on a per-page basis",
// "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled" => "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled",
// "Will eventually be removed from Tiki. Use CSS menus instead" => "Will eventually be removed from Tiki. Use CSS menus instead",
// "Output should be HTML Purified" => "Output should be HTML Purified",
// "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS" => "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS",
// "Full Screen" => "Full Screen",
// "CSS Menus" => "CSS Menus",
// "CSS Menus (suckerfish)" => "CSS Menus (suckerfish)",
// "Shadowbox / ColorBox" => "Shadowbox / ColorBox",
// "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>" => "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>",
// "Quick Permission Assignment" => "Quick Permission Assignment",
// "Quickperms allow to define classes of privileges and grant them to roles on objects" => "Quickperms allow to define classes of privileges and grant them to roles on objects",
// "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature" => "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature",
// "Outputs a WAP and VoiceXML version" => "Outputs a WAP and VoiceXML version",
// "Visualize relationships between wiki pages, in a 3D applet" => "Visualize relationships between wiki pages, in a 3D applet",
// "Intertiki" => "Intertiki",
// "Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "Allows several Tiki sites (slaves) to get authentication from a master Tiki site",
// "Populate wiki pages and articles by email" => "Populate wiki pages and articles by email",
// "Print Indexed" => "Print Indexed",
// "SpreadSheet" => "SpreadSheet",
// "Datasheets with calculations and charts" => "Datasheets with calculations and charts",
// "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor" => "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor",
// "Experimental (Requires AJAX)" => "Experimental (Requires AJAX)",
// "Kaltura" => "Kaltura",
// "Collaborative video editing" => "Collaborative video editing",
// "Users can identify other users as their friends" => "Users can identify other users as their friends",
// "Neglected feature" => "Neglected feature",
// "Deny access to specific users based on username, IP, and date/time range" => "Deny access to specific users based on username, IP, and date/time range",
// "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)",
// "Record domain name of sites that send visitors to this Tiki" => "Record domain name of sites that send visitors to this Tiki",
// "On error, goto the HomePage as configured in Admin->General" => "On error, goto the HomePage as configured in Admin->General",
// "Send/receive wiki pages and articles between Tiki-powered sites" => "Send/receive wiki pages and articles between Tiki-powered sites",
// "User Watches Languages" => "User Watches Languages",
// "Watch language-specific changes within a category" => "Watch language-specific changes within a category",
// "Menu User Levels" => "Menu User Levels",
// "Allows to control the menu options that can be seen by a user" => "Allows to control the menu options that can be seen by a user",
// "Permits recording and playback of functional tests" => "Permits recording and playback of functional tests",
// "Tiki will check for updates when you access the main Administration page" => "Tiki will check for updates when you access the main Administration page",
// "Use PEAR::Date library" => "Use PEAR::Date library",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
// "Lookup the user\\'s preferred language through browser preferences" => "Lookup the user\\'s preferred language through browser preferences",
// "Show pages in user\\'s preferred language" => "Show pages in user\\'s preferred language",
// "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page" => "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page",
// "Track translation operations between pages" => "Track translation operations between pages",
// "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users" => "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users",
// "Use the site language as a master language and prevent translations from sending critical updates" => "Use the site language as a master language and prevent translations from sending critical updates",
// "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete" => "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete",
// "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures" => "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures",
// "List all languages as a language option in the page language drop list to see all languages at once" => "List all languages as a language option in the page language drop list to see all languages at once",
// "Compress your pages on-the-fly, if the requesting browser supports this" => "Compress your pages on-the-fly, if the requesting browser supports this",
// "Show clickable URLs to translate the page to another language using Babel Fish website" => "Show clickable URLs to translate the page to another language using Babel Fish website",
// "Show clickable icons to translate the page to another language using Babelfish website" => "Show clickable icons to translate the page to another language using Babelfish website",
// "Also known as emoticons" => "Also known as emoticons",
// "Bloc of content which can be reused and programmed (timed)" => "Bloc of content which can be reused and programmed (timed)",
// "If disabled, pictures will be stored in ../img/wiki_up/.. instead" => "If disabled, pictures will be stored in ../img/wiki_up/.. instead",
// "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon" => "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon",
// "Add \"rel=nofollow\" on external links" => "Add \"rel=nofollow\" on external links",
// "Going beyond Backlinks, allows to define some semantic relationships between wiki pages" => "Going beyond Backlinks, allows to define some semantic relationships between wiki pages",
// "Web Services" => "Web Services",
// "Can consume webservices in JSON or YAML" => "Can consume webservices in JSON or YAML",
// "Breadcrumbs" => "Breadcrumbs",
// "Attempts to show you where you are" => "Attempts to show you where you are",
// "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)",
// "If you are using Apache, you can rename _htaccess to .htaccess to get Short URLs" => "If you are using Apache, you can rename _htaccess to .htaccess to get Short URLs",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the sefurl" => "Display blog title in the sefurl",
// "Redirect tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "Redirect tiki-view_tracker.php?itemId=yyy to Prefixyyy page",
// "This redirection uses the wiki prefix alias feature" => "This redirection uses the wiki prefix alias feature",
// "Permits to override preferences" => "Permits to override preferences",
// "Permits find and replace of content in the edit box" => "Permits find and replace of content in the edit box",
// "Pre-defined content for a wiki page" => "Pre-defined content for a wiki page",
// "ShareThis buttons" => "ShareThis buttons",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
// "Show category tree, above wiki pages" => "Show category tree, above wiki pages",
// "Show objects sharing the same category, below wiki pages" => "Show objects sharing the same category, below wiki pages",
// "MySQL Full-Text Search" => "MySQL Full-Text Search",
// "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated" => "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated",
// "Custom blog headings" => "Custom blog headings",
// "Publish dates can be modified" => "Publish dates can be modified",
// "Tiki-indexed search" => "Tiki-indexed search",
// "Store password as plain text" => "Store password as plain text",
// "Encryption method" => "Encryption method",
// "Assign different themes to different sections, categories, and objects" => "Assign different themes to different sections, categories, and objects",
// "Custom Doctype" => "Custom Doctype",
// "Use custom !DOCTYPE" => "Use custom !DOCTYPE",
// "Custom Doctype Content" => "Custom Doctype Content",
// "Use to generate the Tiki layout with custom &lt;!DOCTYPE&gt; specified" => "Use to generate the Tiki layout with custom &lt;!DOCTYPE&gt; specified",
// "Use to include custom &lt;meta&gt; or &lt;link&gt; tags" => "Use to include custom &lt;meta&gt; or &lt;link&gt; tags",
// "Add BASE tag in the page HEAD" => "Add BASE tag in the page HEAD",
// "The &lt;base&gt; tag specifies a default address for all links on a page" => "The &lt;base&gt; tag specifies a default address for all links on a page",
// "Top Bar Custom Code" => "Top Bar Custom Code",
// "Site menu custom code" => "Site menu custom code",
// "Secondary site menu custom code" => "Secondary site menu custom code",
// "Custom Center Column Header" => "Custom Center Column Header",
// "Controls visibility of the left column of modules" => "Controls visibility of the left column of modules",
// "side bar" => "side bar",
// "Only if module" => "Only if module",
// "Right Column" => "Right Column",
// "Controls visibility of the right column of modules" => "Controls visibility of the right column of modules",
// "Prefix breadcrumbs with \"Location : \"" => "Prefix breadcrumbs with \"Location : \"",
// "Top of center column" => "Top of center column",
// "Entire location" => "Entire location",
// "Custom End of <body> Code" => "Custom End of <body> Code",
// "Indicate various debug-related information in the footer of the site (Execution time, Memory usage, etc.)" => "Indicate various debug-related information in the footer of the site (Execution time, Memory usage, etc.)",
// "Add a link at the bottom if set, otherwise add a link at the top" => "Add a link at the bottom if set, otherwise add a link at the top",
// "Shadow layer" => "Shadow layer",
// "Additional layers for shadows, rounded corners or other decorative styling" => "Additional layers for shadows, rounded corners or other decorative styling",
// "Tooltips" => "Tooltips",
// "Make tooltips such as this appear in a custom style. Use CSS to change their appearance" => "Make tooltips such as this appear in a custom style. Use CSS to change their appearance",
// "Autocomplete" => "Autocomplete",
// "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc" => "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc",
// "Superfish" => "Superfish",
// "Adds animation effects to CSS \"Suckerfish\" menus" => "Adds animation effects to CSS \"Suckerfish\" menus",
// "Reflection" => "Reflection",
// "Allows images to have a reflection effect below them. See the admin icons above for an example" => "Allows images to have a reflection effect below them. See the admin icons above for an example",
// "Include jQuery UI library. Enables many user interface features" => "Include jQuery UI library. Enables many user interface features",
// "JQuery UI Theme" => "JQuery UI Theme",
// "jQuery UI Theme. Used in spreadsheet, for example" => "jQuery UI Theme. Used in spreadsheet, for example",
// "Provides various validation possibilities like in Trackers" => "Provides various validation possibilities like in Trackers",
// "JQuery JQS5" => "JQuery JQS5",
// "jQuery Simple Standards-Based Slide Show System" => "jQuery Simple Standards-Based Slide Show System",
// "JQuery Infinite Carousel" => "JQuery Infinite Carousel",
// "Image \"carousel\" plugin (coming soon)" => "Image \"carousel\" plugin (coming soon)",
// "Sort in fancytable plugin" => "Sort in fancytable plugin",
// "JQuery Media" => "JQuery Media",
// "Media player" => "Media player",
// "Tiki will warn users who attempt to edit a page that another user is currenly editing" => "Tiki will warn users who attempt to edit a page that another user is currenly editing",
// "Create private notes for a page that are visible only by the author" => "Create private notes for a page that are visible only by the author",
// "A special wiki page for testing. Users can edit, but not save the Sandbox" => "A special wiki page for testing. Users can edit, but not save the Sandbox",
// "Allow users (with permission) to post threaded comments to a page" => "Allow users (with permission) to post threaded comments to a page",
// "Allow users to upload images (pictures) to a page" => "Allow users to upload images (pictures) to a page",
// "Automatically convert words with UpPeR and LoWeR-case letters into wiki links" => "Automatically convert words with UpPeR and LoWeR-case letters into wiki links",
// "Visualize the contributions of different authors made to a wiki page" => "Visualize the contributions of different authors made to a wiki page",
// "Include a link on each page to a forum topic" => "Include a link on each page to a forum topic",
// "A personal page for the user to manage" => "A personal page for the user to manage",
// "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty" => "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty",
// "This feature is experimental" => "This feature is experimental",
// "Allows wiki pages to be staged (drafted) before they are approved (published)" => "Allows wiki pages to be staged (drafted) before they are approved (published)",
// "Allow users to upload (attach) files to a page" => "Allow users to upload (attach) files to a page",
// "Generate automated statistics from configured database queries" => "Generate automated statistics from configured database queries",
// "Wiki argument variables" => "Wiki argument variables",
// "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}",
// "Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirm that the Admin account has a valid email address or you will not be permitted to login",
// "Tiki will automatically convert http:// and email addresses into links" => "Tiki will automatically convert http:// and email addresses into links",
// "Use Quote plugin rather than \">\" for quoting" => "Use Quote plugin rather than \">\" for quoting",
// "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator" => "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator",
// "E-mail" => "E-mail",
// "WebDAV access to Tiki" => "WebDAV access to Tiki",
// "Allow to access File Galleries with WebDAV" => "Allow to access File Galleries with WebDAV",
// "use tiki-webdav.php as the URI of the WebDAV repository" => "use tiki-webdav.php as the URI of the WebDAV repository",
// "Constrains the site display to 990px wide" => "Constrains the site display to 990px wide",
// "You can modify at styles/layout/layout.css - selector #fixedwidth" => "You can modify at styles/layout/layout.css - selector #fixedwidth",
// "Integration with different social networks like Twitter or Facebook" => "Integration with different social networks like Twitter or Facebook",
// "Enables transitions for users between different groups. Transitions will create a user approval workflow" => "Enables transitions for users between different groups. Transitions will create a user approval workflow",
// "Category Transition" => "Category Transition",
// "Enables transitions on objects between different categories. Transitions will create a document workflow" => "Enables transitions on objects between different categories. Transitions will create a document workflow",
// "Ustream Watershed" => "Ustream Watershed",
// "Integration to Ustream Watershed live video streaming" => "Integration to Ustream Watershed live video streaming",
// "Invite users" => "Invite users",
// "Allow users to invite new users by mail to register on this tiki" => "Allow users to invite new users by mail to register on this tiki",
// "Load Balancer" => "Load Balancer",
// "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server" => "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server",
// "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications" => "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications",
// "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'" => "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'",
// "Add a Powered by Tiki link on your site's footer" => "Add a Powered by Tiki link on your site's footer",
// "If a requested page doesn't exist, redirect to a similarly named page" => "If a requested page doesn't exist, redirect to a similarly named page",
// "ATOM 1.0" => "ATOM 1.0",
// "RSS 2.0" => "RSS 2.0",
// "Email address for person responsible for editorial content" => "Email address for person responsible for editorial content",
// "Email address for person responsible for technical issues relating to channel" => "Email address for person responsible for technical issues relating to channel",
// "Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "Specifies a GIF, JPEG or PNG image that can be displayed with the feed",
// "Propose basic http authentication if the user has no permission to see the feed" => "Propose basic http authentication if the user has no permission to see the feed",
// "RSS feeds for articles" => "RSS feeds for articles",
// "RSS feeds for blogs" => "RSS feeds for blogs",
// "RSS feed for individual blogs" => "RSS feed for individual blogs",
// "RSS feed for image galleries" => "RSS feed for image galleries",
// "RSS feed for individual image galleries" => "RSS feed for individual image galleries",
// "RSS feed for file galleries" => "RSS feed for file galleries",
// "RSS feed for individual file galleries" => "RSS feed for individual file galleries",
// "RSS feed for wiki" => "RSS feed for wiki",
// "RSS feed for forums" => "RSS feed for forums",
// "RSS feed for individual forums" => "RSS feed for individual forums",
// "RSS feed for trackers" => "RSS feed for trackers",
// "RSS feed for individual trackers items" => "RSS feed for individual trackers items",
// "RSS feed for calendar events" => "RSS feed for calendar events",
// "RSS feed for directories" => "RSS feed for directories",
// "RSS feed for maps" => "RSS feed for maps",
// "RSS feed for shoutbox" => "RSS feed for shoutbox",
// "Homepage URL" => "Homepage URL",
// "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used",
// "Description to be published as part of the RSS feed for articles" => "Description to be published as part of the RSS feed for articles",
// "Description to be published as part of the RSS feed for blogs" => "Description to be published as part of the RSS feed for blogs",
// "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used" => "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used",
// "Description to be published as part of the RSS feed for image galleries" => "Description to be published as part of the RSS feed for image galleries",
// "Description to be published as part of the RSS feed for individual image galleries" => "Description to be published as part of the RSS feed for individual image galleries",
// "Description to be published as part of the RSS feed for file galleries" => "Description to be published as part of the RSS feed for file galleries",
// "Description to be published as part of the RSS feed for individual file galleries" => "Description to be published as part of the RSS feed for individual file galleries",
// "Description to be published as part of the RSS feed for wiki pages" => "Description to be published as part of the RSS feed for wiki pages",
// "Description to be published as part of the RSS feed for forums" => "Description to be published as part of the RSS feed for forums",
// "Description to be published as part of the RSS feed for individual forums" => "Description to be published as part of the RSS feed for individual forums",
// "Description to be published as part of the RSS feed for trackers" => "Description to be published as part of the RSS feed for trackers",
// "Description to be published as part of the RSS feed for individual trackers" => "Description to be published as part of the RSS feed for individual trackers",
// "Description to be published as part of the RSS feed for calendar events" => "Description to be published as part of the RSS feed for calendar events",
// "Description to be published as part of the RSS feed for directories" => "Description to be published as part of the RSS feed for directories",
// "Description to be published as part of the RSS feed for maps" => "Description to be published as part of the RSS feed for maps",
// "Description to be published as part of the RSS feed for shoutbox messages" => "Description to be published as part of the RSS feed for shoutbox messages",
// "Quota for all the files and archives" => "Quota for all the files and archives",
// "(0 for unlimited)" => "(0 for unlimited)",
// "Quota can be defined for each file gallery" => "Quota can be defined for each file gallery",
// "Default quota for each new gallery" => "Default quota for each new gallery",
// "Show quota bar in the list page" => "Show quota bar in the list page",
// "Include the search box on the current gallery files just after the find div" => "Include the search box on the current gallery files just after the find div",
// "Include a search box on file galleries" => "Include a search box on file galleries",
// "Automatic deletion of old files" => "Automatic deletion of old files",
// "The user will have an option when uploading a file to specify the time after which the file is deleted" => "The user will have an option when uploading a file to specify the time after which the file is deleted",
// "Deletion emails notification" => "Deletion emails notification",
// "These emails will receive a copy of each deleted file. Emails are separated with comma" => "These emails will receive a copy of each deleted file. Emails are separated with comma",
// "Keep fileId for archives" => "Keep fileId for archives",
// "Keep always the same fileId when replacing a file with archive" => "Keep always the same fileId when replacing a file with archive",
// "Show thumbnail actions" => "Show thumbnail actions",
// "Show the checkbox and wrench icon for file actions menu when not displaying details" => "Show the checkbox and wrench icon for file actions menu when not displaying details",
// "Max thumbnail size" => "Max thumbnail size",
// "Maximum width or height for image thumbnails" => "Maximum width or height for image thumbnails",
// "In pixels" => "In pixels",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Display thread configuration bar only when number of posts exceed" => "Display thread configuration bar only when number of posts exceed",
// "Hide titles for forum threads" => "Hide titles for forum threads",
// "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display" => "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display",
// "Permits translation management of tags" => "Permits translation management of tags",
// "3D autoload" => "3D autoload",
// "Spring (connection) size" => "Spring (connection) size",
// "Existing page node color" => "Existing page node color",
// "Missing page node color" => "Missing page node color",
// "Feed animation interval (milisecs)" => "Feed animation interval (milisecs)",
// "Friction constant" => "Friction constant",
// "Node mass" => "Node mass",
// "Node charge" => "Node charge",
// "Include \"Generate Password\" option on registration form" => "Include \"Generate Password\" option on registration form",
// "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes" => "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes",
// "Label visible in the browser\\'s title bar on all pages. Also appears in search engines" => "Label visible in the browser\\'s title bar on all pages. Also appears in search engines",
// "Validate new user registrations by email" => "Validate new user registrations by email",
// "Upon registration, the new user will receive an email containing a link to confirm validity" => "Upon registration, the new user will receive an email containing a link to confirm validity",
// "Landing page used for the wiki when no page is specified. The page will be created if it does not exist" => "Landing page used for the wiki when no page is specified. The page will be created if it does not exist",
// "Users can be sent to different pages upon login, depending on their default group" => "Users can be sent to different pages upon login, depending on their default group",
// "Site language used when no other language is specified by the user" => "Site language used when no other language is specified by the user",
// "Tiki requires full read and write access to this directory" => "Tiki requires full read and write access to this directory",
// "The default help system may not be complete. You can help with the Tiki documentation" => "The default help system may not be complete. You can help with the Tiki documentation",
// "[-180 180]" => "[-180 180]",
// "[0 360]" => "[0 360]",
// "Hide anonymous-only modules from Admins" => "Hide anonymous-only modules from Admins",
// "Site Ads and Banners Content" => "Site Ads and Banners Content",
// "URL to go to when clicking on a username" => "URL to go to when clicking on a username",
// "Use %user% for login name and %userId% for userId)" => "Use %user% for login name and %userId% for userId)",
// "Remind/forgot password" => "Remind/forgot password",
// "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user" => "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user",
// "If passwords <em>are stored</em> as plain text, the password will be emailed to the user" => "If passwords <em>are stored</em> as plain text, the password will be emailed to the user",
// "Custom Site Header Content" => "Custom Site Header Content",
// "0 for unlimited versions" => "0 for unlimited versions",
// "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "Require validation by Admin" => "Require validation by Admin",
// "The administrator will receive an email for each new user registration, and must validate the user before the user can login" => "The administrator will receive an email for each new user registration, and must validate the user before the user can login",
// "Require passcode to register" => "Require passcode to register",
// "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only" => "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only",
// "Alphanumeric code requierd to complete the registration" => "Alphanumeric code requierd to complete the registration",
// "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user" => "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user",
// "Use the \"Admin Groups\" page to select which tracker and fields to display" => "Use the \"Admin Groups\" page to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Create a new group for each user" => "Create a new group for each user",
// "Use URL Index" => "Use URL Index",
// "Use a Tiki feature homepage or another homepage" => "Use a Tiki feature homepage or another homepage",
// "Select the Tiki feature to use as the site homepage. Only enabled features are listed" => "Select the Tiki feature to use as the site homepage. Only enabled features are listed",
// "Disable JavaScript" => "Disable JavaScript",
// "Disable JavaScript for testing purpose even if the browser allows it" => "Disable JavaScript for testing purpose even if the browser allows it",
// "Partner ID" => "Partner ID",
// "Kaltura Partner ID" => "Kaltura Partner ID",
// "Kaltura partner setting user secret" => "Kaltura partner setting user secret",
// "Kaltura partner setting admin secret" => "Kaltura partner setting admin secret",
// "Kaltura Dynamic Player (KDP) user interface configuration ID" => "Kaltura Dynamic Player (KDP) user interface configuration ID",
// "KDP Widget ID" => "KDP Widget ID",
// "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account" => "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account",
// "Kaltura Configuration Wizard (KCW) user interface configuration ID" => "Kaltura Configuration Wizard (KCW) user interface configuration ID",
// "Kaltura Simple Editor UI Configuration ID" => "Kaltura Simple Editor UI Configuration ID",
// "Kaltura Advanced Editor UI Configuration ID" => "Kaltura Advanced Editor UI Configuration ID",
// "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries" => "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries",
// "e.g. http://www.kaltura.com/" => "e.g. http://www.kaltura.com/",
// "Set blogs homepage first" => "Set blogs homepage first",
// "Set Image gal homepage first" => "Set Image gal homepage first",
// "Set Forum homepage first" => "Set Forum homepage first",
// "Validate user's email server" => "Validate user's email server",
// "The group will be named identical to the user's username" => "The group will be named identical to the user's username",
// "If you don't know better, use '_yourPartnerID'" => "If you don't know better, use '_yourPartnerID'",
// "You could use your server name for this. e.g. \$url_host" => "You could use your server name for this. e.g. \$url_host",
// "Google Maps API Key" => "Google Maps API Key",
// "Default y for map center" => "Default y for map center",
// "village size" => "village size",
// "Show map mode buttons in articles list" => "Show map mode buttons in articles list",
// "Show map mode buttons in page list" => "Show map mode buttons in page list",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
// "Includes a custom block of CSS inline in all pages" => "Includes a custom block of CSS inline in all pages",
// "Custom JavaScript" => "Custom JavaScript",
// "Includes a custom block of inline JavaScript in all pages" => "Includes a custom block of inline JavaScript in all pages",
// "Home File Gallery (main file gallery)" => "Home File Gallery (main file gallery)",
// "No image gallery available (create one first)" => "No image gallery available (create one first)",
// "No file gallery available (create one first)" => "No file gallery available (create one first)",
// "No forum available (create one first)" => "No forum available (create one first)",
// "No blog available (create one first)" => "No blog available (create one first)",
// "Use HTTPS when building user-specific links" => "Use HTTPS when building user-specific links",
// "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
// "Use HTTPS login" => "Use HTTPS login",
// "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server" => "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server",
// "Consider we are always in HTTPS, but do not check" => "Consider we are always in HTTPS, but do not check",
// "CSS selectors to be fixed" => "CSS selectors to be fixed",
// "Separate multiple elements with a comma (,)" => "Separate multiple elements with a comma (,)",
// "Use CDN for JavaScript" => "Use CDN for JavaScript",
// "Obtain jQuery and jQuery UI libraries through a content delivery network" => "Obtain jQuery and jQuery UI libraries through a content delivery network",
// "Google" => "Google",
// "Slide" => "Slide",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Effect for modules" => "Effect for modules",
// "Use the database to store the translated strings and allow using interactive translation" => "Use the database to store the translated strings and allow using interactive translation",
// "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages",
// "Create user if not in LDAP" => "Create user if not in LDAP",
// "Add HTML comment at start and end of each Smarty template (TPL)" => "Add HTML comment at start and end of each Smarty template (TPL)",
// "Use only for development, not in production because these warnings are added to emails as well, and visible to the users" => "Use only for development, not in production because these warnings are added to emails as well, and visible to the users",
// "You need to clear your Tiki template cache for this change to take effect" => "You need to clear your Tiki template cache for this change to take effect",
// "Log SQL queries" => "Log SQL queries",
// "Log queries using more than (seconds)" => "Log queries using more than (seconds)",
// "Use email as username" => "Use email as username",
// "Instead of creating new usernames, use the user\\'s email address for authentication" => "Instead of creating new usernames, use the user\\'s email address for authentication",
// "Obscure email when using email as username if possible (coverage will not be complete)" => "Obscure email when using email as username if possible (coverage will not be complete)",
// "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead" => "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead",
// "%A %d of %B, %Y" => "%A %d of %B, %Y",
// "%H:%M:%S %Z" => "%H:%M:%S %Z",
// "%A %d of %B, %Y %H:%M:%S %Z" => "%A %d of %B, %Y %H:%M:%S %Z",
// "Force lowercase" => "Force lowercase",
// "CRLF (standard)" => "CRLF (standard)",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
// "Memcache" => "Memcache",
// "Enable connection to memcached servers to store temporary information" => "Enable connection to memcached servers to store temporary information",
// "Requires the PHP memcache extension" => "Requires the PHP memcache extension",
// "Enable compression for memcache storage" => "Enable compression for memcache storage",
// "Server list which may be accessed. For each server, the address, port and weight must be specified" => "Server list which may be accessed. For each server, the address, port and weight must be specified",
// "One per line. address:port (weight)" => "One per line. address:port (weight)",
// "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts" => "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts",
// "Duration for which the data will be kept" => "Duration for which the data will be kept",
// "Cache wiki data in memcache" => "Cache wiki data in memcache",
// "Cache wiki output in memcache" => "Cache wiki output in memcache",
// "Cache forum output in memcache" => "Cache forum output in memcache",
// "Menu icons" => "Menu icons",
// "Allows to define icons for menu entries" => "Allows to define icons for menu entries",
// "Allow HTML in link text and do not escape the url in menu items (Please note: this might be insecure if you allow more people to edit menus)" => "Allow HTML in link text and do not escape the url in menu items (Please note: this might be insecure if you allow more people to edit menus)",
// "If enabled, menu item names treated as HTML item content and they are not escaped (do not replace HTML special characters), this allows the use of HTML in menu items to insert images for example, and menu item urls are not escaped which allows the use of permissable href tags. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing" => "If enabled, menu item names treated as HTML item content and they are not escaped (do not replace HTML special characters), this allows the use of HTML in menu items to insert images for example, and menu item urls are not escaped which allows the use of permissable href tags. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing",
// "Show past metrics results" => "Show past metrics results",
// "In the metrics dashboard, identify if the previously collected metrics should be displayed" => "In the metrics dashboard, identify if the previously collected metrics should be displayed",
// "Past metrics count" => "Past metrics count",
// "Amount of past results to display" => "Amount of past results to display",
// "No metric trend value" => "No metric trend value",
// "Value to display when no trend is available for the metric" => "Value to display when no trend is available for the metric",
// "Metric trend prefix" => "Metric trend prefix",
// "Portion of text to display before the metric trend value" => "Portion of text to display before the metric trend value",
// "Metric trend suffix" => "Metric trend suffix",
// "Portion of text to display after the metric trend value" => "Portion of text to display after the metric trend value",
// "Metric name length" => "Metric name length",
// "Metric tab name length" => "Metric tab name length",
// "Cache metrics output" => "Cache metrics output",
// "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended" => "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
// "\"More Like This\" algorithm" => "\"More Like This\" algorithm",
// "Basic" => "Basic",
// "Weighted" => "Weighted",
// "7" => "7",
// "8" => "8",
// "9" => "9",
// "10" => "10",
// "Multi-domain" => "Multi-domain",
// "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance" => "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance",
// "Comma-separated values mapping the domain name to the perspective ID" => "Comma-separated values mapping the domain name to the perspective ID",
// "Require characters and numerals" => "Require characters and numerals",
// "For improved security, require users to include a mix of characters and numerals in passwords" => "For improved security, require users to include a mix of characters and numerals in passwords",
// "Password expires after" => "Password expires after",
// "Feature to manage and track payment requests" => "Feature to manage and track payment requests",
// "Payment System" => "Payment System",
// "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits",
// "PayPal: see PayPal.com - Cclite: Community currency" => "PayPal: see PayPal.com - Cclite: Community currency",
// "PayPal" => "PayPal",
// "Cclite" => "Cclite",
// "Paypal Business ID" => "Paypal Business ID",
// "Enable payments through paypal" => "Enable payments through paypal",
// "Paypal Environment" => "Paypal Environment",
// "Used to switch between the paypal sandbox, used for testing and development and the live environment" => "Used to switch between the paypal sandbox, used for testing and development and the live environment",
// "Production" => "Production",
// "Paypal Instant Payment Notification (IPN)" => "Paypal Instant Payment Notification (IPN)",
// "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server" => "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server",
// "Currency" => "Currency",
// "Currency used when entering payments" => "Currency used when entering payments",
// "Default acceptable payment delay" => "Default acceptable payment delay",
// "Amount of days before the payment requests becomes overdue. This can be changed per payment request" => "Amount of days before the payment requests becomes overdue. This can be changed per payment request",
// "Cclite Registries" => "Cclite Registries",
// "Registries in Cclite. Use comma to separate. e.g. \"dogtown, chelsea, dalston, etc\"" => "Registries in Cclite. Use comma to separate. e.g. \"dogtown, chelsea, dalston, etc\"",
// "Registry names in Cclite" => "Registry names in Cclite",
// "Cclite Registry Currencies" => "Cclite Registry Currencies",
// "Currencies in Cclite. Use comma to separate. e.g. \"woof, ducket, ducket, etc\"" => "Currencies in Cclite. Use comma to separate. e.g. \"woof, ducket, ducket, etc\"",
// "Each registry in Cclite can have it\\'s own currency. Must be one per registry. (case sensitive)" => "Each registry in Cclite can have it\\'s own currency. Must be one per registry. (case sensitive)",
// "Cclite Server URL" => "Cclite Server URL",
// "Full URL of the repository" => "Full URL of the repository",
// "e.g. https://cclite.yourdomain.org/cclite/" => "e.g. https://cclite.yourdomain.org/cclite/",
// "Cclite Merchant Key" => "Cclite Merchant Key",
// "Corresponds with Merchant Key setting in Cclite" => "Corresponds with Merchant Key setting in Cclite",
// "Cclite Merchant User" => "Cclite Merchant User",
// "User name in Cclite representing \"the management\". Defaults to \"manager\"" => "User name in Cclite representing \"the management\". Defaults to \"manager\"",
// "Cclite Enable Payments" => "Cclite Enable Payments",
// "Test or Live operation" => "Test or Live operation",
// "Live" => "Live",
// "Hashing Algorithm" => "Hashing Algorithm",
// "Encryption type" => "Encryption type",
// "SHA1" => "SHA1",
// "SHA256" => "SHA256",
// "SHA512" => "SHA512",
// "Cclite Payment Notification" => "Cclite Payment Notification",
// "TODO" => "TODO",
// "Wiki page containing the instruction to send manual payment like check" => "Wiki page containing the instruction to send manual payment like check",
// "Prefix to the invoice" => "Prefix to the invoice",
// "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice" => "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice",
// "Types of credit to use" => "Types of credit to use",
// "This is a list of the types of Tiki user credits to accept to pay with, separated by " => "This is a list of the types of Tiki user credits to accept to pay with, separated by ",
// "Exchange rate for types of credit to use" => "Exchange rate for types of credit to use",
// "This is a corresponding list of amount of credits equivalent to 1 of the payment currency, separated by " => "This is a corresponding list of amount of credits equivalent to 1 of the payment currency, separated by ",
// "Multiple polls per object" => "Multiple polls per object",
// "When used with the rating features, allow multiple polls to be attached to a single object" => "When used with the rating features, allow multiple polls to be attached to a single object",
// "PDF from URL" => "PDF from URL",
// "Using extenal tools, generate PDF document from web URLs" => "Using extenal tools, generate PDF document from web URLs",
// "Webkit (wkhtmltopdf)" => "Webkit (wkhtmltopdf)",
// "Webservice" => "Webservice",
// "Webservice URL" => "Webservice URL",
// "URL to a service taking a URL as the query string and returns a PDF document" => "URL to a service taking a URL as the query string and returns a PDF document",
// "Full path to the wkhtmltopdf executable to generate the PDF document with" => "Full path to the wkhtmltopdf executable to generate the PDF document with",
// "Proxy host - without http:// or similar, just the host name" => "Proxy host - without http:// or similar, just the host name",
// "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page" => "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page",
// "Rating system allowing for options and calculation method to be configured" => "Rating system allowing for options and calculation method to be configured",
// "Rating recalculation mode" => "Rating recalculation mode",
// "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time" => "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time",
// "Recalculate on vote" => "Recalculate on vote",
// "Randomly recalculate oldest ratings (on load)" => "Randomly recalculate oldest ratings (on load)",
// "Randomly recalculate oldest ratings (on vote)" => "Randomly recalculate oldest ratings (on vote)",
// "Cron job (must be set manually)" => "Cron job (must be set manually)",
// "Recalculation odds (1 in X)" => "Recalculation odds (1 in X)",
// "Dice roll performed on every request. When successful, will recalculate a certain number of votes" => "Dice roll performed on every request. When successful, will recalculate a certain number of votes",
// "Recalculation count" => "Recalculation count",
// "How many ratings should be recalculated when odds strike" => "How many ratings should be recalculated when odds strike",
// "Use ReCaptcha" => "Use ReCaptcha",
// "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA" => "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA",
// "You will need to register at [http://www.google.com/recaptcha]" => "You will need to register at [http://www.google.com/recaptcha]",
// "Public Key" => "Public Key",
// "ReCaptcha public key" => "ReCaptcha public key",
// "Private Key" => "Private Key",
// "ReCaptcha private key" => "ReCaptcha private key",
// "Keep track of the unsuccessful attemps to translate strings" => "Keep track of the unsuccessful attemps to translate strings",
// "Limit the languages made available on the site" => "Limit the languages made available on the site",
// "Random" => "Random",
// "Use 0 for no refresh" => "Use 0 for no refresh",
// "Default where" => "Default where",
// "When object filter is not on, limit to search one type of object" => "When object filter is not on, limit to search one type of object",
// "Entire site" => "Entire site",
// "If enabled, only search content in the interface language, by default" => "If enabled, only search content in the interface language, by default",
// "Autocomplete on page names" => "Autocomplete on page names",
// "Parse wiki syntax in comments in all sections apart from Forums" => "Parse wiki syntax in comments in all sections apart from Forums",
// "Use \"Accept wiki syntax\" for forums in admin forums page" => "Use \"Accept wiki syntax\" for forums in admin forums page",
// "Email address that will be used as the sender for outgoing emails" => "Email address that will be used as the sender for outgoing emails",
// "Indicates the default time zone to use for the server" => "Indicates the default time zone to use for the server",
// "Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Select where the session information should be stored. Memcache sessions require memcache to be configured",
// "Do not automatically start sessions" => "Do not automatically start sessions",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
// "Protect all sessions" => "Protect all sessions",
// "Always redirect to HTTPS to prevent session hijack through network sniffing" => "Always redirect to HTTPS to prevent session hijack through network sniffing",
// "Create with default group" => "Create with default group",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Shipping Service" => "Shipping Service",
// "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)",
// "FedEx API" => "FedEx API",
// "Enable shipping rate calculation through FedEx APIs" => "Enable shipping rate calculation through FedEx APIs",
// "FedEx Key" => "FedEx Key",
// "Developer Key" => "Developer Key",
// "FedEx Password" => "FedEx Password",
// "FedEx Meter Number" => "FedEx Meter Number",
// "FedEx Account Number" => "FedEx Account Number",
// "UPS API" => "UPS API",
// "Enable shipping rate calculation using the UPS carrier" => "Enable shipping rate calculation using the UPS carrier",
// "UPS Username" => "UPS Username",
// "UPS credentials" => "UPS credentials",
// "UPS Password" => "UPS Password",
// "UPS Access Key" => "UPS Access Key",
// "%Y-%m-%d" => "%Y-%m-%d",
// "%H:%M" => "%H:%M",
// "%Y-%m-%d %H:%M" => "%Y-%m-%d %H:%M",
// "Close site (except for those with permission)" => "Close site (except for those with permission)",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Location of the site title in the browser title bar relative to the current page\\'s descriptor" => "Location of the site title in the browser title bar relative to the current page\\'s descriptor",
// "Before" => "Before",
// "When breadcrumbs are used, method in which the browser title should be displayed" => "When breadcrumbs are used, method in which the browser title should be displayed",
// "Current only" => "Current only",
// "Favicon icon file name" => "Favicon icon file name",
// "Favicon icon MIME type" => "Favicon icon MIME type",
// "Logo source (image path)" => "Logo source (image path)",
// "Logo background color" => "Logo background color",
// "Logo background style" => "Logo background style",
// "Logo alignment" => "Logo alignment",
// "Slideshow theme" => "Slideshow theme",
// "Include smarty notices in PHP error report" => "Include smarty notices in PHP error report",
// "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur" => "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "You should leave this on unless you know what you are doing" => "You should leave this on unless you know what you are doing",
// "Indicates when the template cache should be refreshed" => "Indicates when the template cache should be refreshed",
// "Consumer key" => "Consumer key",
// "Consumer key generated by registering your site as application at twitter" => "Consumer key generated by registering your site as application at twitter",
// "Consumer secret" => "Consumer secret",
// "Consumer secret generated by registering your site as an application at twitter" => "Consumer secret generated by registering your site as an application at twitter",
// "API key" => "API key",
// "API key generated by registering your site as application at facebook" => "API key generated by registering your site as application at facebook",
// "Application secret" => "Application secret",
// "Application secret generated by registering your site as an application at facebook" => "Application secret generated by registering your site as an application at facebook",
// "Application ID" => "Application ID",
// "Application id generated by registering your site as an application at facebook" => "Application id generated by registering your site as an application at facebook",
// "bit.ly Login" => "bit.ly Login",
// "Site wide login (username) for bit.ly" => "Site wide login (username) for bit.ly",
// "bit.ly Key" => "bit.ly Key",
// "Site wide API key for bit.ly" => "Site wide API key for bit.ly",
// "Use site-wide account" => "Use site-wide account",
// "When setting this option to yes, only the site wide account will be used for all users" => "When setting this option to yes, only the site wide account will be used for all users",
// "Style options" => "Style options",
// "Minify JavaScript" => "Minify JavaScript",
// "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS" => "Minify CSS",
// "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS into a single file" => "Minify CSS into a single file",
// "In addition to reducing the size of the CSS, reduce the number of included files" => "In addition to reducing the size of the CSS, reduce the number of included files",
// "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"" => "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"",
// "When displaying short date and time, skip date for today. Only time will be displayed" => "When displaying short date and time, skip date for today. Only time will be displayed",
// "Custom HTTP header to use when a session is active" => "Custom HTTP header to use when a session is active",
// "Example: no-cache, pre-check=0, post-check=0" => "Example: no-cache, pre-check=0, post-check=0",
// "Cache-Control header (no session)" => "Cache-Control header (no session)",
// "Custom HTTP header to use when no session is active" => "Custom HTTP header to use when no session is active",
// "Content Delivery Network" => "Content Delivery Network",
// "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance" => "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance",
// "Prefix to include before the static files, for example: http://cdn.example.com" => "Prefix to include before the static files, for example: http://cdn.example.com",
// "Content Delivery Network (in SSL)" => "Content Delivery Network (in SSL)",
// "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode" => "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode",
// "Prefix to include before the static files, for example: https://cdn.example.com" => "Prefix to include before the static files, for example: https://cdn.example.com",
// "Domain prefix handling" => "Domain prefix handling",
// "Strip or automatically add the www. prefix on domain names to unify URLs" => "Strip or automatically add the www. prefix on domain names to unify URLs",
// "Leave as-is" => "Leave as-is",
// "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org" => "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org",
// "One entry per line. Comma separated list: old, new" => "One entry per line. Comma separated list: old, new",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "URL a user is redirected to after account validation" => "URL a user is redirected to after account validation",
// "URL an anonymous is redirected when page not found" => "URL an anonymous is redirected when page not found",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Show user\\'s real name instead of login (when possible)" => "Show user\\'s real name instead of login (when possible)",
// "Allows users to hide/show modules" => "Allows users to hide/show modules",
// "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit",
// "You will need to activate tracking of views for various items in the action log for this to work" => "You will need to activate tracking of views for various items in the action log for this to work",
// "Number of days before current time to consider when showing who viewed my stuff" => "Number of days before current time to consider when showing who viewed my stuff",
// "Show to others who viewed my stuff on the user information page. Admins can always see this information" => "Show to others who viewed my stuff on the user information page. Admins can always see this information",
// "Maximum number of users to show in drop down lists" => "Maximum number of users to show in drop down lists",
// "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box" => "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box",
// "Use pretty trackers for registration form" => "Use pretty trackers for registration form",
// "Registration pretty tracker template" => "Registration pretty tracker template",
// "Use wiki page name or template file with .tpl extension" => "Use wiki page name or template file with .tpl extension",
// "User tracker IDs to sync prefs from" => "User tracker IDs to sync prefs from",
// "Enter the IDs separated by commas of trackers to sync user prefs from" => "Enter the IDs separated by commas of trackers to sync user prefs from",
// "Tracker field IDs to sync Real Name pref from" => "Tracker field IDs to sync Real Name pref from",
// "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4" => "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4",
// "Synchronize long/lat/zoom to google maps field" => "Synchronize long/lat/zoom to google maps field",
// "Synchronize user geolocation prefs to main google maps field" => "Synchronize user geolocation prefs to main google maps field",
// "Synchronize categories of user tracker item to user groups" => "Synchronize categories of user tracker item to user groups",
// "Will add the user tracker item to the category of the same name as the user groups and vice versa" => "Will add the user tracker item to the category of the same name as the user groups and vice versa",
// "Put user in group only if categorized within" => "Put user in group only if categorized within",
// "Show user\\'s real name instead of login in autocomplete selector in trackers feature" => "Show user\\'s real name instead of login in autocomplete selector in trackers feature",
// "Use user\\'s real name instead of login in autocomplete selector in trackers feature" => "Use user\\'s real name instead of login in autocomplete selector in trackers feature",
// "Show user\\'s real name instead of login in autocomplete selector in messaging feature" => "Show user\\'s real name instead of login in autocomplete selector in messaging feature",
// "Use user\\'s real name instead of login in autocomplete selector in messaging feature" => "Use user\\'s real name instead of login in autocomplete selector in messaging feature",
// "Username pattern" => "Username pattern",
// "Serve avatar images statically" => "Serve avatar images statically",
// "When enabled, feature checks and permission checks will be skipped" => "When enabled, feature checks and permission checks will be skipped",
// "Use new diff any version interface" => "Use new diff any version interface",
// "20" => "20",
// "30" => "30",
// "40" => "40",
// "50" => "50",
// "60" => "60",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
// "15" => "15",
// "Errors will be logged to the Tiki log" => "Errors will be logged to the Tiki log",
// "Tracker ID of Channel tracker" => "Tracker ID of Channel tracker",
// "There must be a tracker to store info of each channel you create" => "There must be a tracker to store info of each channel you create",
// "The Channel tracker must have a text field for the Watershed BrandId" => "The Channel tracker must have a text field for the Watershed BrandId",
// "Field ID of ChannelCode" => "Field ID of ChannelCode",
// "The Channel tracker must have a text field for the Watershed ChannelCode" => "The Channel tracker must have a text field for the Watershed ChannelCode",
// "Tracker ID of Archive tracker" => "Tracker ID of Archive tracker",
// "There must be a tracker to store Archive info" => "There must be a tracker to store Archive info",
// "The Archive tracker must have a text field for the videoId of each archive" => "The Archive tracker must have a text field for the videoId of each archive",
// "Field ID of BrandId for Archive" => "Field ID of BrandId for Archive",
// "The Archive tracker must have a text field for the BrandId of each archive" => "The Archive tracker must have a text field for the BrandId of each archive",
// "Field ID of ChannelCode for Archive" => "Field ID of ChannelCode for Archive",
// "The Archive tracker must have a text field for the ChannelCode of each archive" => "The Archive tracker must have a text field for the ChannelCode of each archive",
// "Field ID of rtmpURL for Archive (url field type)" => "Field ID of rtmpURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the RTMP URL to access the archive" => "The Archive tracker must have a url field for storing the RTMP URL to access the archive",
// "Field ID of flvURL for Archive (url field type)" => "Field ID of flvURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the FLV URL to access the archive" => "The Archive tracker must have a url field for storing the FLV URL to access the archive",
// "Field ID of Date string for Archive" => "Field ID of Date string for Archive",
// "The Archive tracker can have a text field for storing the time the recording completed" => "The Archive tracker can have a text field for storing the time the recording completed",
// "Field ID of Duration for Archive" => "Field ID of Duration for Archive",
// "The Archive tracker can have a text field for storing the duration of the recording" => "The Archive tracker can have a text field for storing the duration of the recording",
// "Field ID of Filesize for Archive" => "Field ID of Filesize for Archive",
// "The Archive tracker can have a text field for storing the filesize of the recording" => "The Archive tracker can have a text field for storing the filesize of the recording",
// "Field ID of Title for Archive" => "Field ID of Title for Archive",
// "The Archive tracker could have a text field for storing the title of the recording" => "The Archive tracker could have a text field for storing the title of the recording",
// "Field ID of Description for Archive (textarea field type)" => "Field ID of Description for Archive (textarea field type)",
// "The Archive tracker could have a textarea field for storing the description of the recording" => "The Archive tracker could have a textarea field for storing the description of the recording",
// "Field ID of Tags for Archive (freetags field type)" => "Field ID of Tags for Archive (freetags field type)",
// "The Archive tracker could have a freetags field for storing the tags of the recording" => "The Archive tracker could have a freetags field for storing the tags of the recording",
// "Flash Media Encoder shared secret" => "Flash Media Encoder shared secret",
// "Shared key for authenticating Flash Media Encoder" => "Shared key for authenticating Flash Media Encoder",
// "500Kb" => "500Kb",
// "1Mb" => "1Mb",
// "1.5Mb" => "1.5Mb",
// "2Mb" => "2Mb",
// "2.5Mb" => "2.5Mb",
// "3Mb" => "3Mb",
// "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))" => "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))",
// "Display page version" => "Display page version",
// "Display the page version information when viewing the page" => "Display the page version information when viewing the page",
// "Display page name above page instead of inside page" => "Display page name above page instead of inside page",
// "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed" => "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed",
// "Wiki author list style" => "Wiki author list style",
// "Changes the list format used to display the authors of the page" => "Changes the list format used to display the authors of the page",
// "Specify wiki author list style per page" => "Specify wiki author list style per page",
// "Allows to modify the style in which the author list is displayed on a per-page basis" => "Allows to modify the style in which the author list is displayed on a per-page basis",
// "Wiki action bar location" => "Wiki action bar location",
// "Wiki navigation bar location" => "Wiki navigation bar location",
// "Enable page cache globally for wiki pages" => "Enable page cache globally for wiki pages",
// "Enable control for comments on wiki pages individually" => "Enable control for comments on wiki pages individually",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "Permits editing of a plugin, via a popup form, without needing to edit the whole page" => "Permits editing of a plugin, via a popup form, without needing to edit the whole page",
// "Requires JavaScript" => "Requires JavaScript",
// "Prevent special characters in page names" => "Prevent special characters in page names",
// "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters" => "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters",
// "Page ranking reload probability" => "Page ranking reload probability",
// "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking" => "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking",
// "Encourage contribution to wiki pages by anonymous" => "Encourage contribution to wiki pages by anonymous",
// "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register" => "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register",
// "Warn before page lock timeout" => "Warn before page lock timeout",
// "Provide a JavaScript alert before the user\\'s lock on a page times out" => "Provide a JavaScript alert before the user\\'s lock on a page times out",
// "Global snippets of text that can be included in wiki pages and edited in place" => "Global snippets of text that can be included in wiki pages and edited in place",
// "Make dynamic variable content language specific" => "Make dynamic variable content language specific",
// "Enable wiki 3D browser" => "Enable wiki 3D browser",
// "Load page on navigation" => "Load page on navigation",
// "Allow to manage keywords on a per-page basis" => "Allow to manage keywords on a per-page basis",
// "When listing similar pages, such as in missing page 404, only display pages in the same language as the request" => "When listing similar pages, such as in missing page 404, only display pages in the same language as the request",
// "Reject save attempts not providing an edit summary to describe the changes made" => "Reject save attempts not providing an edit summary to describe the changes made",
// "Displays Next/Back buttons, breadcrumbs, and form to add a new page" => "Displays Next/Back buttons, breadcrumbs, and form to add a new page",
// "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation" => "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation",
// "Enable users to rate articles based on a simple numeric scale" => "Enable users to rate articles based on a simple numeric scale",
// "List of options available for the rating of wiki pages" => "List of options available for the rating of wiki pages",
// "Redirect pages using these prefix alias semantic links" => "Redirect pages using these prefix alias semantic links",
// "Comma separated list of prefixes of which pages will be redirected to page with semantic link" => "Comma separated list of prefixes of which pages will be redirected to page with semantic link",
// "Force bounce of editing of approved pages to staging" => "Force bounce of editing of approved pages to staging",
// "Unique page name prefix to indicate staging copy" => "Unique page name prefix to indicate staging copy",
// "Categorize approved pages with categories of staging copy on approval" => "Categorize approved pages with categories of staging copy on approval",
// "Replace freetags with that of staging pages, on approval" => "Replace freetags with that of staging pages, on approval",
// "Global cache time for the plugin snarf in seconds" => "Global cache time for the plugin snarf in seconds",
// "Default cache time for the plugin snarf" => "Default cache time for the plugin snarf",
// "0 for no cache" => "0 for no cache",
// "Inline plugin %0" => "Inline plugin %0",
// "Wysiwyg Editor is displayed by default" => "Wysiwyg Editor is displayed by default",
// "This allows a mixture of wiki and html. All wiki syntax is parsed" => "This allows a mixture of wiki and html. All wiki syntax is parsed",
// "Content is partially wiki parsed" => "Content is partially wiki parsed",
// "This also allows a mixture of wiki and html. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)" => "This also allows a mixture of wiki and html. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)",
// "Wysiwyg editor skin" => "Wysiwyg editor skin",
// "Kama (Default)" => "Kama (Default)",
// "Office 2003" => "Office 2003",
// "V2 (FCKEditor appearance)" => "V2 (FCKEditor appearance)",
// "Use Wiki syntax in WYSIWYG" => "Use Wiki syntax in WYSIWYG",
// "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead " => "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead ",
// "Font names" => "Font names",
// "List of font names separated by" => "List of font names separated by",
// "SSL" => "SSL",
// "TLS" => "TLS",
// "SMTP" => "SMTP",
// "Authentication" => "Authentication",
// "Mail server authentication" => "Mail server authentication",
// "LOGIN" => "LOGIN",
// "PLAIN" => "PLAIN",
// "CRAM-MD5" => "CRAM-MD5",
// "Nothing was changed, please check profile for errors" => "Nothing was changed, please check profile for errors",
// "An error occurred: " => "An error occurred: ",
// "Applying profile" => "Applying profile",
// "Added (or modified)" => "Added (or modified)",
// "Preference set" => "Preference set",
// "Group changed (or modified)" => "Group changed (or modified)",
// "Modified permission %s for %s" => "Modified permission %s for %s",
// "Modified permission %s on %s/%s for %s" => "Modified permission %s on %s/%s for %s",
// "User %0 was added to %1" => "User %0 was added to %1",
// "Created by profile installer" => "Created by profile installer",
// "Page updated by profile installer" => "Page updated by profile installer",
// "File gallery does not exist" => "File gallery does not exist",
// "File gallery already exists" => "File gallery already exists",
// "Calendar does not exist" => "Calendar does not exist",
// "Calendar already exists" => "Calendar already exists",
// "Syntax error: " => "Syntax error: ",
// "Circular reference" => "Circular reference",
// "No name" => "No name",
// "Bad object" => "Bad object",
// "Permissions' object must have a field 'type' and 'id'" => "Permissions' object must have a field 'type' and 'id'",
// "Needs a 'type' and 'data' field" => "Needs a 'type' and 'data' field",
// "Forums last posts" => "Forums last posts",
// "Wiki last files" => "Wiki last files",
// "Most active blogs" => "Most active blogs",
// "Blogs last posts" => "Blogs last posts",
// "Top article authors" => "Top article authors",
// "Expecting three arguments for article-info" => "Expecting three arguments for article-info",
// "Unsupported property. Supported properties are: ' . implode( " => "Unsupported property. Supported properties are: ' . implode( ",
// "Articles feature not enabled" => "Articles feature not enabled",
// "Unexpected values: %0" => "Unexpected values: %0",
// "Invalid property" => "Invalid property",
// "Object must be provided and contain two arguments: type and object" => "Object must be provided and contain two arguments: type and object",
// "Invalid range" => "Invalid range",
// "Invalid revote period" => "Invalid revote period",
// "Expecting \"keep\" to be \"latest\" or \"oldest\"" => "Expecting \"keep\" to be \"latest\" or \"oldest\"",
// "Unknown variables referenced: %0" => "Unknown variables referenced: %0",
// "You must choose a group" => "You must choose a group",
// "You will receive an email with information to login for the first time into this site" => "You will receive an email with information to login for the first time into this site",
// "Username is required" => "Username is required",
// "Invalid username" => "Invalid username",
// "Username is too long" => "Username is too long",
// "Username cannot contain uppercase letters" => "Username cannot contain uppercase letters",
// "Username must be at least" => "Username must be at least",
// "Username cannot contain more than" => "Username cannot contain more than",
// "characters" => "characters",
// "Wrong passcode. You need to know the passcode to register at this site" => "Wrong passcode. You need to know the passcode to register at this site",
// "This invitation does not exist or is deprecated or wrong email" => "This invitation does not exist or is deprecated or wrong email",
// "uploaded the file" => "uploaded the file",
// "changes" => "changes",
// "No changes" => "No changes",
// "Yesterday" => "Yesterday",
// "more changes of the same type.." => "more changes of the same type..",
// "changed the picture gallery" => "changed the picture gallery",
// "uploaded the picture" => "uploaded the picture",
// "onto" => "onto",
// "removed the picture" => "removed the picture",
// "edited the wikipage" => "edited the wikipage",
// "this history" => "this history",
// "all history" => "all history",
// "edited the file gallery" => "edited the file gallery",
// "removed the file" => "removed the file",
// "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category" => "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category",
// "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category" => "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category",
// "created the subcategory" => "created the subcategory",
// "removed the subcategory" => "removed the subcategory",
// "edited the category" => "edited the category",
// "removed the article" => "removed the article",
// "created the article" => "created the article",
// "edited the article" => "edited the article",
// "replied to the blog" => "replied to the blog",
// "created the topic" => "created the topic",
// "at forum" => "at forum",
// "replied" => "replied",
// "to the topic" => "to the topic",
// "Nothing has happened" => "Nothing has happened",
// "The fields title and description are mandatory to generate a feed" => "The fields title and description are mandatory to generate a feed",
// "To fix this error go to Admin -> Feeds" => "To fix this error go to Admin -> Feeds",
// "Please contact the site administrator and ask him to fix this error" => "Please contact the site administrator and ask him to fix this error",
// "If you set feed author email or url you have to set feed author name" => "If you set feed author email or url you have to set feed author name",
// "Feed logo" => "Feed logo",
// "Directory category" => "Directory category",
// "You must choose an option" => "You must choose an option",
// "For you to vote, cookies must be allowed" => "For you to vote, cookies must be allowed",
// "This poll is closed" => "This poll is closed",
// "Tiki RSS feed for articles" => "Tiki RSS feed for articles",
// "Last posts to weblogs" => "Last posts to weblogs",
// "Tiki RSS feed for weblogs" => "Tiki RSS feed for weblogs",
// "Tiki RSS feed for calendars" => "Tiki RSS feed for calendars",
// "Last sites" => "Last sites",
// "Tiki RSS feed for directory sites" => "Tiki RSS feed for directory sites",
// "Last files uploaded to the file galleries" => "Last files uploaded to the file galleries",
// "Tiki RSS feed for file galleries" => "Tiki RSS feed for file galleries",
// "Last files uploaded to this file gallery. " => "Last files uploaded to this file gallery. ",
// "Tiki RSS feed for the file gallery: " => "Tiki RSS feed for the file gallery: ",
// "Last posts to this forum. " => "Last posts to this forum. ",
// "Tiki RSS feed for forum: " => "Tiki RSS feed for forum: ",
// "Last topics in forums" => "Last topics in forums",
// "Tiki RSS feed for forums" => "Tiki RSS feed for forums",
// "Last images uploaded to the image galleries" => "Last images uploaded to the image galleries",
// "Tiki RSS feed for image galleries" => "Tiki RSS feed for image galleries",
// "Last images uploaded to this image gallery. " => "Last images uploaded to this image gallery. ",
// "Tiki RSS feed for the image gallery: " => "Tiki RSS feed for the image gallery: ",
// "Last shoutbox messages" => "Last shoutbox messages",
// "Tiki RSS feed for shoutbox messages" => "Tiki RSS feed for shoutbox messages",
// "Last items published on this tracker" => "Last items published on this tracker",
// "Tiki RSS feed for individual trackers: " => "Tiki RSS feed for individual trackers: ",
// "Last modifications to the Wiki" => "Last modifications to the Wiki",
// "Tiki RSS feed for the wiki pages" => "Tiki RSS feed for the wiki pages",
// "_HOMEPAGE_CONTENT_" => "_HOMEPAGE_CONTENT_",
// "Saved" => "Saved",
// "Save failed" => "Save failed",
// "UPS_CODE_' . \$xp->query( 'Service/Code" => "UPS_CODE_' . \$xp->query( 'Service/Code",
// "Link" => "Link",
// "You are not in group of friends to have the content of this block displayed for you" => "You are not in group of friends to have the content of this block displayed for you",
// "Smarty block.display.php: Missing error param" => "Smarty block.display.php: Missing error param",
// "<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin inactive: feature_jquery off -->",
// "No records to display" => "No records to display",
// "Fast Next" => "Fast Next",
// "Fast Prev" => "Fast Prev",
// "First {\$params['itemname']}" => "First {\$params['itemname']}",
// "Last {\$params['itemname']}" => "Last {\$params['itemname']}",
// "Next {\$params['itemname']}" => "Next {\$params['itemname']}",
// "Prev {\$params['itemname']}" => "Prev {\$params['itemname']}",
// "warning" => "warning",
// "confirm" => "confirm",
// "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer" => "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer",
// "There is an autosaved version of this content, to use it instead of this saved one" => "There is an autosaved version of this content, to use it instead of this saved one",
// "If you want the saved version instead of this autosaved draft" => "If you want the saved version instead of this autosaved draft",
// "AutoSave" => "AutoSave",
// "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />" => "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />",
// "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this" => "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this",
// "Ckeditor Development Notice" => "Ckeditor Development Notice",
// "Your edit session has expired" => "Your edit session has expired",
// "You must PREVIEW or SAVE your work now, to avoid losing your edits" => "You must PREVIEW or SAVE your work now, to avoid losing your edits",
// "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page",
// "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile" => "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile",
// "Admin page" => "Admin page",
// "Plugin name not specified" => "Plugin name not specified",
// "Hour" => "Hour",
// "Minute" => "Minute",
// "Click here to go to Edit Languages" => "Click here to go to Edit Languages",
// "The text is" => "The text is",
// "character(s) too long - please edit it" => "character(s) too long - please edit it",
// "Month beginning" => "Month beginning",
// "Week beginning" => "Week beginning",
// "Data (change %)" => "Data (change %)",
// "No object information provided" => "No object information provided",
// "No rules to display object %1 of type %0" => "No rules to display object %1 of type %0",
// "Relation not found" => "Relation not found",
// "Currency in payment (%0) does not match the currency for that registry (%1)" => "Currency in payment (%0) does not match the currency for that registry (%1)",
// "This invoice does not exist or is in limited access" => "This invoice does not exist or is in limited access",
// "PHPLayersMenus are not enabled on this site" => "PHPLayersMenus are not enabled on this site",
// "Preference name not specified" => "Preference name not specified",
// " (found in " => " (found in ",
// "(not found in an admin panel)" => "(not found in an admin panel)",
// "No object information provided for rating" => "No object information provided for rating",
// "An error occured" => "An error occured",
// "Invert Sort" => "Invert Sort",
// "No rows found" => "No rows found",
// "Number of items in _checkboxColumnIndex doesn not match items in _checkbox" => "Number of items in _checkboxColumnIndex doesn not match items in _checkbox",
// "Number of items in _checkboxTitles doesn not match items in _checkbox" => "Number of items in _checkboxTitles doesn not match items in _checkbox",
// "You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "You might want to also set the tiki_p_modify_object_categories permission under the tiki section",
// "years" => "years",
// "Text cut here" => "Text cut here",
// "(idle for %s seconds)" => "(idle for %s seconds)",
// "More info about %0 (idle for %1)" => "More info about %0 (idle for %1)",
// " seconds" => " seconds",
// "Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission denied: the specified wiki page cannot be used as Smarty template resource",
// "Days with the most pageviews" => "Days with the most pageviews",
// "Day with the most pageviews" => "Day with the most pageviews",
// "Days with the least pageviews" => "Days with the least pageviews",
// "Day with the least pageviews" => "Day with the least pageviews",
// "No pageviews yet" => "No pageviews yet",
// "n/a" => "n/a",
// "Use this tree to copy the structure" => "Use this tree to copy the structure",
// "created from structure" => "created from structure",
// "You have to make %d choice(s) for the question" => "You have to make %d choice(s) for the question",
// "You have to make at least %d choice(s) for the question" => "You have to make at least %d choice(s) for the question",
// "You have to make less than %d choice(s) for the question" => "You have to make less than %d choice(s) for the question",
// "You have to choose at least %d choice(s) for the question" => "You have to choose at least %d choice(s) for the question",
// "Unknown conversion" => "Unknown conversion",
// "Foo" => "Foo",
// "Sample plugin" => "Sample plugin",
// "Face" => "Face",
// "Font family to use" => "Font family to use",
// "As defined by CSS" => "As defined by CSS",
// "Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator" => "Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator",
// "Page '%0' cannot be found" => "Page '%0' cannot be found",
// "For the security of your password direct access to the feed is only available via https" => "For the security of your password direct access to the feed is only available via https",
// "img-g" => "img-g",
// "file-g" => "file-g",
// "arts" => "arts",
// "Plugin execution pending approval" => "Plugin execution pending approval",
// "Plugin <strong>%0</strong> does not exist" => "Plugin <strong>%0</strong> does not exist",
// "(external link)" => "(external link)",
// "Click to edit dynamic variable" => "Click to edit dynamic variable",
// "smiling" => "smiling",
// "grinning" => "grinning",
// "confused" => "confused",
// "crying" => "crying",
// "frightened" => "frightened",
// "evil stuff" => "evil stuff",
// "exclamation mark " => "exclamation mark ",
// "frowning" => "frowning",
// "light bulb" => "light bulb",
// "idea " => "idea ",
// "LOL" => "LOL",
// "laughing out loud " => "laughing out loud ",
// "mr. green laughing" => "mr. green laughing",
// "The file was uploaded with success" => "The file was uploaded with success",
// "The file you are trying upload was only partially uploaded" => "The file you are trying upload was only partially uploaded",
// "No file was uploaded. Was a file selected " => "No file was uploaded. Was a file selected ",
// "A temporary folder is missing" => "A temporary folder is missing",
// "Unknown error" => "Unknown error",
// "%d points" => "%d points",
// "pics/icons/text_bold.png" => "pics/icons/text_bold.png",
// "pics/icons/text_italic.png" => "pics/icons/text_italic.png",
// "pics/icons/text_underline.png" => "pics/icons/text_underline.png",
// "pics/icons/text_strikethrough.png" => "pics/icons/text_strikethrough.png",
// "pics/icons/noparse.png" => "pics/icons/noparse.png",
// "pics/icons/text_align_center.png" => "pics/icons/text_align_center.png",
// "pics/icons/page.png" => "pics/icons/page.png",
// "pics/icons/page_break.png" => "pics/icons/page_break.png",
// "pics/icons/box.png" => "pics/icons/box.png",
// "pics/icons/email.png" => "pics/icons/email.png",
// "pics/icons/book.png" => "pics/icons/book.png",
// "pics/icons/text_list_bullets.png" => "pics/icons/text_list_bullets.png",
// "pics/icons/text_list_numbers.png" => "pics/icons/text_list_numbers.png",
// "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif" => "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif",
// "img/smiles/icon_smile.gif" => "img/smiles/icon_smile.gif",
// "pics/icons/palette.png" => "pics/icons/palette.png",
// "pics/icons/palette_bg.png" => "pics/icons/palette_bg.png",
// "pics/icons/page_link.png" => "pics/icons/page_link.png",
// "pics/icons/world_link.png" => "pics/icons/world_link.png",
// "pics/icons/table.png" => "pics/icons/table.png",
// "pics/icons/find.png" => "pics/icons/find.png",
// "pics/icons/text_replace.png" => "pics/icons/text_replace.png",
// "pics/icons/pictures.png" => "pics/icons/pictures.png",
// "pics/icons/pencil_go.png" => "pics/icons/pencil_go.png",
// "Save Sheet" => "Save Sheet",
// "pics/icons/disk.png" => "pics/icons/disk.png",
// "Add Row After Selection Or To End If No Selection" => "Add Row After Selection Or To End If No Selection",
// "pics/icons/sheet_row_add.png" => "pics/icons/sheet_row_add.png",
// "Add Multiple Rows After Selection Or To End If No Selection" => "Add Multiple Rows After Selection Or To End If No Selection",
// "pics/icons/sheet_row_add_multi.png" => "pics/icons/sheet_row_add_multi.png",
// "Add Row Before Selection Or To End If No Selection" => "Add Row Before Selection Or To End If No Selection",
// "Delete Selected Row" => "Delete Selected Row",
// "pics/icons/sheet_row_delete.png" => "pics/icons/sheet_row_delete.png",
// "Add Column After Selection Or To End If No Selection" => "Add Column After Selection Or To End If No Selection",
// "pics/icons/sheet_col_add.png" => "pics/icons/sheet_col_add.png",
// "Delete Selected Column" => "Delete Selected Column",
// "pics/icons/sheet_col_delete.png" => "pics/icons/sheet_col_delete.png",
// "Add Multiple Columns After Selection Or To End If No Selection" => "Add Multiple Columns After Selection Or To End If No Selection",
// "pics/icons/sheet_col_add_multi.png" => "pics/icons/sheet_col_add_multi.png",
// "Add Column Before Selection Or To End If No Selection" => "Add Column Before Selection Or To End If No Selection",
// "pics/icons/sheet_get_range.png" => "pics/icons/sheet_get_range.png",
// "pics/icons/arrow_refresh.png" => "pics/icons/arrow_refresh.png",
// "Finish Editing" => "Finish Editing",
// "pics/icons/close.png" => "pics/icons/close.png",
// "Tracker was modified at " => "Tracker was modified at ",
// "View the tracker item at" => "View the tracker item at",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax,distinct</strong>\n\t\t\t\t<dt>Example: 0,80,5,200,30\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd><strong>[distinct]</strong> is y or n. y = all values of the field must be different\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax,distinct</strong>\n\t\t\t\t<dt>Example: 0,80,5,200,30\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd><strong>[distinct]</strong> is y or n. y = all values of the field must be different\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,decimals,dec_point,thousands</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[decimals]</strong> sets the number of decimal places;\n\t\t\t\t<dd><strong>[dec_point]</strong> sets the separator for the decimal point (decimals must also be set). Use c for comma and s for space;\n\t\t\t\t<dd><strong>[thousands]</strong> sets the thousands separator. Use c for comma and s for space. Setting only commas will result in no decimals \n\t\t\t\t\t\t\t\t\t\t\t\t\tand commas as the thousands seprator;<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,decimals,dec_point,thousands</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[decimals]</strong> sets the number of decimal places;\n\t\t\t\t<dd><strong>[dec_point]</strong> sets the separator for the decimal point (decimals must also be set). Use c for comma and s for space;\n\t\t\t\t<dd><strong>[thousands]</strong> sets the thousands separator. Use c for comma and s for space. Setting only commas will result in no decimals \n\t\t\t\t\t\t\t\t\t\t\t\t\tand commas as the thousands seprator;<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "currency amount" => "currency amount",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,locale,symbol,first</strong>\n\t\t\t\t<dt>Example: 0,60,,per item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[locale]</strong> set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1 (default=en_US);\n\t\t\t\t<dd><strong>[currency]</strong> The 3-letter ISO 4217 currency code indicating the currency to use (default=USD);\n\t\t\t\t<dd><strong>[symbol]</strong> i for international symbol, n for local (default=n);\n\t\t\t\t<dd><strong>[all_symbol]</strong> set to 1 to show symbol for every item (default only shows currency symbol on first item in a list) ;\n\t\t\t\t<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,locale,symbol,first</strong>\n\t\t\t\t<dt>Example: 0,60,,per item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[locale]</strong> set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1 (default=en_US);\n\t\t\t\t<dd><strong>[currency]</strong> The 3-letter ISO 4217 currency code indicating the currency to use (default=USD);\n\t\t\t\t<dd><strong>[symbol]</strong> i for international symbol, n for local (default=n);\n\t\t\t\t<dd><strong>[all_symbol]</strong> set to 1 to show symbol for every item (default only shows currency symbol on first item in a list) ;\n\t\t\t\t<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriage return\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriage return\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>",
// "page selector" => "page selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong> will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd><strong>[link]</strong> will not display the link to the page if equals to n \n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong> will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd><strong>[link]</strong> will not display the link to the page if equals to n \n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>when set to \"empty\" will allow selection of empty date but default to current date\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>when set to \"empty\" will allow selection of empty date but default to current date\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: will display the field name as a html header h2;\n\t\t\t\t<dt>Usage: <strong>level</strong>\n\t\t\t\t<dt>Example: 2\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[level]</strong> level of the html header (default 2)\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: will display the field name as a html header h2;\n\t\t\t\t<dt>Usage: <strong>level</strong>\n\t\t\t\t<dt>Example: 2\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[level]</strong> level of the html header (default 2)\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall,descendants</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd><strong>[descendants]</strong> All descendant categories (not just first level children) will be included if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall,descendants</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd><strong>[descendants]</strong> All descendant categories (not just first level children) will be included if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,0,6|8,opc,PageName\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd><strong>[linkPage]</strong> is the name of the wiki page to link to with trackerlist plugin in it; \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,0,6|8,opc,PageName\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd><strong>[linkPage]</strong> is the name of the wiki page to link to with trackerlist plugin in it; \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "url" => "url",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t<dt>Usage: <strong>use_as_item_location,bubble_fieldId,icon</strong>\n\t\t\t\t<dt>Example: y,23|24,img/icons2/icn_members.gif\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[use_as_item_location]</strong> if set to y, this google map field will be used as item location and object geo attributes are set when field value is changed.\n\t\t\t\t<dd><strong>[bubble_fieldid]</strong> is the fieldId(s) (separated by |) that contains the text that will be displayed in the bubble of the map marker. The first field will be used as the link.\n\t\t\t\t<dd><strong>[icon]</strong> is the url of the default icon to use for markers of items on the map.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t<dt>Usage: <strong>use_as_item_location,bubble_fieldId,icon</strong>\n\t\t\t\t<dt>Example: y,23|24,img/icons2/icn_members.gif\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[use_as_item_location]</strong> if set to y, this google map field will be used as item location and object geo attributes are set when field value is changed.\n\t\t\t\t<dd><strong>[bubble_fieldid]</strong> is the fieldId(s) (separated by |) that contains the text that will be displayed in the bubble of the map marker. The first field will be used as the link.\n\t\t\t\t<dd><strong>[icon]</strong> is the url of the default icon to use for markers of items on the map.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email, other values possible: language;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email, other values possible: language;\n\t\t\t\t</dl>",
// "user groups" => "user groups",
// "<dl>\n\t\t\t\t<dt>Function: Allows to display the user groups.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows to display the user groups.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "freetags" => "freetags",
// "<dl>\n\t\t\t\t<dt>Function: Allows freetags to be shown or added for tracker item\n\t\t\t\t<dt>Usage: <strong>size</strong>\n\t\t\t\t<dt>Example: 80,n,n\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[hidehelp]</strong> if y, do not show help text when entering tags;\n\t\t\t\t<dd><strong>[hidesuggest]</strong> if y, do not show suggested tags when entering tags;  \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows freetags to be shown or added for tracker item\n\t\t\t\t<dt>Usage: <strong>size</strong>\n\t\t\t\t<dt>Example: 80,n,n\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[hidehelp]</strong> if y, do not show help text when entering tags;\n\t\t\t\t<dd><strong>[hidesuggest]</strong> if y, do not show suggested tags when entering tags;  \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "in group" => "in group",
// "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Display stars\n\t\t\t\t<dt>Usage: <strong>list options (positive increasing numbers</strong>\n\t\t\t\t<dt>Example: 1,2,3,4\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Like the rating\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Display stars\n\t\t\t\t<dt>Usage: <strong>list options (positive increasing numbers</strong>\n\t\t\t\t<dt>Example: 1,2,3,4\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Like the rating\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "No extra information for that attached file. " => "No extra information for that attached file. ",
// "(AT)" => "(AT)",
// "(DOT)" => "(DOT)",
// "The administrator has not yet validated your account. Please wait" => "The administrator has not yet validated your account. Please wait",
// "You must validate your account first. An email has been sent to you" => "You must validate your account first. An email has been sent to you",
// "The registration mail can't be sent. Contact the administrator" => "The registration mail can't be sent. Contact the administrator",
// "The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "The registration mail can't be sent because there is no server email address set, and this feature is disabled",
// "The user email confirmation can't be sent. Contact the administrator" => "The user email confirmation can't be sent. Contact the administrator",
// "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)",
// "Edit field: (Incorrect validation parameter)" => "Edit field: (Incorrect validation parameter)",
// "Invalid character combination for username" => "Invalid character combination for username",
// "Could not establish Kaltura session. Try again" => "Could not establish Kaltura session. Try again",
// "Successfully stored archive in tracker" => "Successfully stored archive in tracker",
// "Failed to stored archive in tracker" => "Failed to stored archive in tracker",
// "Cannot connect with web service" => "Cannot connect with web service",
// "No permission to broadcast to channel" => "No permission to broadcast to channel",
// "Broadcaster successfully authenticated" => "Broadcaster successfully authenticated",
// "No permission to broadcast to any channel" => "No permission to broadcast to any channel",
// "Successfully logged in mobile broadcaster" => "Successfully logged in mobile broadcaster",
// "No viewable channels available for mobile" => "No viewable channels available for mobile",
// "Failed to log in mobile broadcaster" => "Failed to log in mobile broadcaster",
// "Successfully logged in FME" => "Successfully logged in FME",
// "Failed to log in FME" => "Failed to log in FME",
// "No permission to view channel" => "No permission to view channel",
// "Viewer successfully authenticated" => "Viewer successfully authenticated",
// "No permission to view any channel" => "No permission to view any channel",
// "Mailbox uninitialised??" => "Mailbox uninitialised??",
// "No subject" => "No subject",
// "No mail body found" => "No mail body found",
// "PluginAddToCart" => "PluginAddToCart",
// "Adds a product to the virtual cart. The cart can be manipulated using the cart module" => "Adds a product to the virtual cart. The cart can be manipulated using the cart module",
// "Product code" => "Product code",
// "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in",
// "Label for the product in the cart" => "Label for the product in the cart",
// "Price" => "Price",
// "The price to charge for the item" => "The price to charge for the item",
// "URL of the product\\'s information. The URL may be relative or absolute (begin with http://)" => "URL of the product\\'s information. The URL may be relative or absolute (begin with http://)",
// "Text for the submit button. default: \"Add to cart\"" => "Text for the submit button. default: \"Add to cart\"",
// "A session must be active to use the cart" => "A session must be active to use the cart",
// "%0 (%1) was added to your cart" => "%0 (%1) was added to your cart",
// "Create an icon for a user to add an event to Google Calendar" => "Create an icon for a user to add an event to Google Calendar",
// "PluginAddToGoogleCal" => "PluginAddToGoogleCal",
// "Creates an icon for a user to add an event to a Google Calendar" => "Creates an icon for a user to add an event to a Google Calendar",
// "Calendar item ID" => "Calendar item ID",
// "The item ID of the calendar to add to Google calendar" => "The item ID of the calendar to add to Google calendar",
// "A calendar item ID number" => "A calendar item ID number",
// "Icon Style" => "Icon Style",
// "Choose the icon style" => "Choose the icon style",
// "Either 1, 2 or 3" => "Either 1, 2 or 3",
// "One" => "One",
// "Two" => "Two",
// "Three" => "Three",
// "User Agent Info" => "User Agent Info",
// "PluginAgentinfo" => "PluginAgentinfo",
// "Info" => "Info",
// "Display\\'s the visitor\\'s IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "Display\\'s the visitor\\'s IP address (IP or default), browser information (BROWSER), or server software (SVRSW)",
// "IP address" => "IP address",
// "Server software" => "Server software",
// "Browser" => "Browser",
// "PluginAlink" => "PluginAlink",
// "Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin" => "Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin",
// "Anchor link label" => "Anchor link label",
// "The anchor name as defined in the ANAME plugin" => "The anchor name as defined in the ANAME plugin",
// "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used",
// "linktext" => "linktext",
// "PluginAname" => "PluginAname",
// "Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin" => "Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin",
// "PluginAnnotation" => "PluginAnnotation",
// "Displays an image and enables users to define zones to highlight information on the image" => "Displays an image and enables users to define zones to highlight information on the image",
// "Absolute URL to the image or relative path from tiki root" => "Absolute URL to the image or relative path from tiki root",
// "Image width in pixels" => "Image width in pixels",
// "Image height in pixels" => "Image height in pixels",
// "Image alignment. Possible values: left, right, center. Default is left" => "Image alignment. Possible values: left, right, center. Default is left",
// "Image annotations changed" => "Image annotations changed",
// "PluginArchiveBuilder" => "PluginArchiveBuilder",
// "Builds a zip archive containing the specified data from tikiwiki" => "Builds a zip archive containing the specified data from tikiwiki",
// "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435",
// "Archive Name" => "Archive Name",
// "Upon download, the name of the file that will be provided" => "Upon download, the name of the file that will be provided",
// "Missing extension zip" => "Missing extension zip",
// "Incorrect parameter" => "Incorrect parameter",
// "Download archive" => "Download archive",
// "PluginArticle" => "PluginArticle",
// "Includes an article\\'s content within the page" => "Includes an article\\'s content within the page",
// "PluginArticles" => "PluginArticles",
// "Use Pagination" => "Use Pagination",
// "Activate pagination when articles listing are long. Default is n" => "Activate pagination when articles listing are long. Default is n",
// "Maximum Displayed" => "Maximum Displayed",
// "The number of articles to display in the list (no max set by default)" => "The number of articles to display in the list (no max set by default)",
// "If Pagination is set to y (Yes), this will determine the amount of artilces per page" => "If Pagination is set to y (Yes), this will determine the amount of artilces per page",
// "Topic Name Filter" => "Topic Name Filter",
// "Filter the list of aricles by their topic. Example: " => "Filter the list of aricles by their topic. Example: ",
// "Topic ID Filter" => "Topic ID Filter",
// "Filter the list of aricles by their topic ID. Example: " => "Filter the list of aricles by their topic ID. Example: ",
// "Type Filter" => "Type Filter",
// "Filter the list of aricles by their types. Example: " => "Filter the list of aricles by their types. Example: ",
// "The ID of the category that articles need to be in to be listed" => "The ID of the category that articles need to be in to be listed",
// "List only articles in this language" => "List only articles in this language",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Use random to have random items" => "Use random to have random items",
// "Whether to not report when there are no articles (no reporting by default)" => "Whether to not report when there are no articles (no reporting by default)",
// "Title Only" => "Title Only",
// "Whether to only show the title of the articles (not set to title only by default)" => "Whether to only show the title of the articles (not set to title only by default)",
// "Body Only" => "Body Only",
// "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)" => "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)",
// "Starting Article" => "Starting Article",
// "The article number that the list should start with (starts with first article by default)" => "The article number that the list should start with (starts with first article by default)",
// "This will not work if Pagination is used" => "This will not work if Pagination is used",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Override Dates" => "Override Dates",
// "Whether to obey article type\\'s \"show before publish\" and \"show after expiry\" settings (not obeyed by default)" => "Whether to obey article type\\'s \"show before publish\" and \"show after expiry\" settings (not obeyed by default)",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "Large First Image" => "Large First Image",
// "If set to y (Yes), the first image will be displayed with the dimension used to view of the article" => "If set to y (Yes), the first image will be displayed with the dimension used to view of the article",
// "Additional URL Param to the link to read article" => "Additional URL Param to the link to read article",
// "Show actions (buttons and links)" => "Show actions (buttons and links)",
// "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do",
// "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~",
// "PluginAttach" => "PluginAttach",
// "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment",
// "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page",
// "Shows the description as the link text instead of the file name (not used by default)" => "Shows the description as the link text instead of the file name (not used by default)",
// "Bullets" => "Bullets",
// "Makes the list of attachments a bulleted list (not set by default)" => "Makes the list of attachments a bulleted list (not set by default)",
// "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)",
// "Custom Label" => "Custom Label",
// "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed" => "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)",
// "Order Number" => "Order Number",
// "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. \n\t\t\t\t\t\t\t\t\t\tEither name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. \n\t\t\t\t\t\t\t\t\t\tEither name, file, id or num can be used to identify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment",
// "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)",
// "File Type Icon" => "File Type Icon",
// "A file type icon is displayed in front of the attachment link when this is set to 1" => "A file type icon is displayed in front of the attachment link when this is set to 1",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
// "PluginAttributes" => "PluginAttributes",
// "Allows for generic attributes to be assigned to the current object. Attributes are provided as parameters. For tiki.geo.lat, {attributes tiki_geo_lat=...}. Removing the plugin or values in it will not remove the attributes" => "Allows for generic attributes to be assigned to the current object. Attributes are provided as parameters. For tiki.geo.lat, {attributes tiki_geo_lat=...}. Removing the plugin or values in it will not remove the attributes",
// "PluginAuthor" => "PluginAuthor",
// "Color codes parts of the page like \\'Track changes\\' in Office programs" => "Color codes parts of the page like \\'Track changes\\' in Office programs",
// "User Name" => "User Name",
// "User name of the user who wrote the text" => "User name of the user who wrote the text",
// "Deleted by User" => "Deleted by User",
// "User name of the user who deleted the text" => "User name of the user who deleted the text",
// "Make Visible" => "Make Visible",
// "Show popup with author/deleted by" => "Show popup with author/deleted by",
// "Generate a popup with names of author(s) (default: no)" => "Generate a popup with names of author(s) (default: no)",
// "deleted by" => "deleted by",
// "Shows which author created/deleted which text" => "Shows which author created/deleted which text",
// "Should this author's contribution be visible (default: no)" => "Should this author's contribution be visible (default: no)",
// "PluginAvatar" => "PluginAvatar",
// "The wiki page the avatar will link to. If empty and the user\\'s information is public, \n\t\t\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user\\'s user information page" => "The wiki page the avatar will link to. If empty and the user\\'s information is public, \n\t\t\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user\\'s user information page",
// "Align the avatar on the page" => "Align the avatar on the page",
// "PluginBack" => "PluginBack",
// "Displays a link that goes back one page in the browser history" => "Displays a link that goes back one page in the browser history",
// "Insert back link on wiki page" => "Insert back link on wiki page",
// "PluginBacklinks" => "PluginBacklinks",
// "List all pages linking to the specified page" => "List all pages linking to the specified page",
// "The page links will point to. Default value is the current page" => "The page links will point to. Default value is the current page",
// "Displayed Information" => "Displayed Information",
// "Pipe separated list of fields to display. ex: hits|user" => "Pipe separated list of fields to display. ex: hits|user",
// "Excluded pages" => "Excluded pages",
// "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox",
// "Include Self" => "Include Self",
// "With or without self-link (default is without)" => "With or without self-link (default is without)",
// "Header" => "Header",
// "With or without header (default is with header)" => "With or without header (default is with header)",
// "With header" => "With header",
// "Without header" => "Without header",
// "No pages link to" => "No pages link to",
// "PluginBanner" => "PluginBanner",
// "Name of the zone created in Admin > Banners" => "Name of the zone created in Admin > Banners",
// "Determines the browser behavior once the banner is clicked" => "Determines the browser behavior once the banner is clicked",
// "Blank" => "Blank",
// "PluginBigBlueButton" => "PluginBigBlueButton",
// "Meeting" => "Meeting",
// "MeetingID provided by BigBlueButton" => "MeetingID provided by BigBlueButton",
// "Anonymous prefix" => "Anonymous prefix",
// "Unregistered users will get this token prepended to their name" => "Unregistered users will get this token prepended to their name",
// "Welcome Message" => "Welcome Message",
// "A message to be provided when someone enters the room" => "A message to be provided when someone enters the room",
// "Dial Number" => "Dial Number",
// "The phone-in support number to join from traditional phones" => "The phone-in support number to join from traditional phones",
// "Voice Bridge" => "Voice Bridge",
// "Code to enter for phone attendees to join the room" => "Code to enter for phone attendees to join the room",
// "Logout URL" => "Logout URL",
// "URL to which the user will be redirected when logging out from BigBlueButton" => "URL to which the user will be redirected when logging out from BigBlueButton",
// "Maximum Participants" => "Maximum Participants",
// "Limit to the amount of simultaneous participants in the room. Support for this parameter depends on the BigBlueButton server" => "Limit to the amount of simultaneous participants in the room. Support for this parameter depends on the BigBlueButton server",
// "Bliptv" => "Bliptv",
// "PluginBliptv" => "PluginBliptv",
// "Blip.tv embed URL. Please note that this url needs to be the src param in the EMBED code, and not the video URL as in other equivalent video plugins. Example: http://blip.tv/play/AYGd_GAC (instead of http://blip.tv/file/2568201/) " => "Blip.tv embed URL. Please note that this url needs to be the src param in the EMBED code, and not the video URL as in other equivalent video plugins. Example: http://blip.tv/play/AYGd_GAC (instead of http://blip.tv/file/2568201/) ",
// "Width in pixels (default is 425" => "Width in pixels (default is 425",
// "Height in pixels (default is 350)" => "Height in pixels (default is 350)",
// "PluginBlogList" => "PluginBlogList",
// "Use BLOGLIST to include posts from a blog" => "Use BLOGLIST to include posts from a blog",
// "The ID number of the blog on the site you wish to list posts from" => "The ID number of the blog on the site you wish to list posts from",
// "Maximum Items" => "Maximum Items",
// "Maximum number of entries to list (no maximum set by default)" => "Maximum number of entries to list (no maximum set by default)",
// "Only display posts created by this user (all posts listed by default)" => "Only display posts created by this user (all posts listed by default)",
// "Simple List" => "Simple List",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
// "Latest date to select posts from" => "Latest date to select posts from",
// "Container Class" => "Container Class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "Use BLOGLIST to include posts from a blog. Syntax is" => "Use BLOGLIST to include posts from a blog. Syntax is",
// "where Id is the blog Id and Items is the max number of posts to display" => "where Id is the blog Id and Items is the max number of posts to display",
// "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~" => "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~",
// "PluginBox" => "PluginBox",
// "Aligns the text within the box (left aligned by default)" => "Aligns the text within the box (left aligned by default)",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
// "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)" => "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)",
// "PluginButton" => "PluginButton",
// "Produces a link with the shape of a button, reusing the button smarty function and requiring no validation of that plugin" => "Produces a link with the shape of a button, reusing the button smarty function and requiring no validation of that plugin",
// "Url" => "Url",
// "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it" => "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it",
// "Label for the button" => "Label for the button",
// "lib/smarty_tiki/function.button.php is missing or unreadable" => "lib/smarty_tiki/function.button.php is missing or unreadable",
// "PluginCalendar" => "PluginCalendar",
// "Calendar IDs" => "Calendar IDs",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")",
// "Example values" => "Example values",
// "Not set by default" => "Not set by default",
// "View Type" => "View Type",
// "Determines how to show events" => "Determines how to show events",
// "Possible values" => "Possible values",
// "\"table\" shows events in a calendar" => "\"table\" shows events in a calendar",
// "Default value" => "Default value",
// "View Time Span" => "View Time Span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar",
// "Default is month" => "Default is month",
// "Navigation Bar" => "Navigation Bar",
// "Decide or not to show the navigation bar (not shown by default)" => "Decide or not to show the navigation bar (not shown by default)",
// "PluginCategory" => "PluginCategory",
// "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img" => "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img",
// "Sort ascending or descending based on various attributes (sorted ascending by name by default)" => "Sort ascending or descending based on various attributes (sorted ascending by name by default)",
// "'), 'value' => '" => "'), 'value' => '",
// "Created Ascending" => "Created Ascending",
// "Created Descending" => "Created Descending",
// "Hits Ascending" => "Hits Ascending",
// "Hits Descending" => "Hits Descending",
// "Item ID Ascending" => "Item ID Ascending",
// "Item ID Descending" => "Item ID Descending",
// "Name Ascending" => "Name Ascending",
// "Name Descending" => "Name Descending",
// "Type Ascending" => "Type Ascending",
// "Type Descending" => "Type Descending",
// "Whether multiple categories will be listed on different lines (default is to split them)" => "Whether multiple categories will be listed on different lines (default is to split them)",
// "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)" => "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)",
// "With Sub-categories" => "With Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list sub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list sub-category objects)",
// "Show descriptions (not shown by default)" => "Show descriptions (not shown by default)",
// "Show Name" => "Show Name",
// "Show object names (shown by default)" => "Show object names (shown by default)",
// "Show type" => "Show type",
// "Show type (shown by default)" => "Show type (shown by default)",
// "One Per Line" => "One Per Line",
// "Show one object per line (multiple per line shown by default)" => "Show one object per line (multiple per line shown by default)",
// "Show Child Links" => "Show Child Links",
// "Show children category links (shown by default)" => "Show children category links (shown by default)",
// "Show Top Link" => "Show Top Link",
// "Show top category link (shown by default)" => "Show top category link (shown by default)",
// "Max Records" => "Max Records",
// "Maximum number of objects to list (default is 50)" => "Maximum number of objects to list (default is 50)",
// "Show title text above category object lists (shown by default)" => "Show title text above category object lists (shown by default)",
// "PluginCatOrphans" => "PluginCatOrphans",
// "Display wiki pages that have not been categorized" => "Display wiki pages that have not been categorized",
// "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)" => "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)",
// "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records" => "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start (default is no offset)" => "Result number at which the listing should start (default is no offset)",
// "PluginCatPath" => "PluginCatPath",
// "Display Top Category" => "Display Top Category",
// "Show the top category as part of the path name (not shown by default)" => "Show the top category as part of the path name (not shown by default)",
// "PluginCclite" => "PluginCclite",
// "General purpose cclite utility plugin" => "General purpose cclite utility plugin",
// "Mode of operation - summary or recent. Default: summary" => "Mode of operation - summary or recent. Default: summary",
// "Account summary" => "Account summary",
// "Recent transactions" => "Recent transactions",
// "Registry" => "Registry",
// "Registry to query. Default: site preference (or first in list when more than one)" => "Registry to query. Default: site preference (or first in list when more than one)",
// "You need to be logged in to view this information" => "You need to be logged in to view this information",
// "PluginCenter" => "PluginCenter",
// "BarStackGraphic | MultibarGraphic | MultilineGraphic | PieChartGraphic" => "BarStackGraphic | MultibarGraphic | MultilineGraphic | PieChartGraphic",
// "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors" => "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors",
// "PluginCode" => "PluginCode",
// "Enable word wrapping on the code to avoid breaking the layout. May not be used with line numbers if Geshi version 1.0.8.9+" => "Enable word wrapping on the code to avoid breaking the layout. May not be used with line numbers if Geshi version 1.0.8.9+",
// "Syntax highlighting to use. GeSHi - Generic Syntax Highlighter must be installed for languages other than php. Without GeSHi, the php tag must be included at the \n\t\t\t\t\t\t\t\t\tbeginning of the displayed code for the highlighting to work. May not be used with line numbers if Geshi version < 1.0.8.9. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Syntax highlighting to use. GeSHi - Generic Syntax Highlighter must be installed for languages other than php. Without GeSHi, the php tag must be included at the \n\t\t\t\t\t\t\t\t\tbeginning of the displayed code for the highlighting to work. May not be used with line numbers if Geshi version < 1.0.8.9. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "Line Numbers" => "Line Numbers",
// "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed" => "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed",
// "Parse wiki syntax within the code snippet (not parsed by default)" => "Parse wiki syntax within the code snippet (not parsed by default)",
// "Right to Left" => "Right to Left",
// "Switch the text display from left to right to right to left  (left to right by default)" => "Switch the text display from left to right to right to left  (left to right by default)",
// "When set to 1 (Yes), HTML will still be processed (presented as is by default)" => "When set to 1 (Yes), HTML will still be processed (presented as is by default)",
// "Show HTML" => "Show HTML",
// "Interpret HTML" => "Interpret HTML",
// "Copy To Clipboard" => "Copy To Clipboard",
// "Copy the contents of the code box to the clipboard  (not copied to clipboard by default)" => "Copy the contents of the code box to the clipboard  (not copied to clipboard by default)",
// "colorbox" => "colorbox",
// "PluginColorBox" => "PluginColorBox",
// "Display all the images of a file gallery in a colorbox popup" => "Display all the images of a file gallery in a colorbox popup",
// "File Gallery ID" => "File Gallery ID",
// "ID number of the file gallery that contains the images to be displayed" => "ID number of the file gallery that contains the images to be displayed",
// "Image Gallery ID" => "Image Gallery ID",
// "ID number of the image gallery that contains the images to be displayed" => "ID number of the image gallery that contains the images to be displayed",
// "File ID Filter" => "File ID Filter",
// "Filter on fileIds in a file gallery to only show those images. Separate each fileId with \\':\\'" => "Filter on fileIds in a file gallery to only show those images. Separate each fileId with \\':\\'",
// "Thumb" => "Thumb",
// "Display as a thumbnail (y) or full size (n)" => "Display as a thumbnail (y) or full size (n)",
// "Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc" => "Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc",
// "Show File Title" => "Show File Title",
// "Show file title" => "Show file title",
// "Show File Name" => "Show File Name",
// "Show file name" => "Show file name",
// "Show All Thumbs" => "Show All Thumbs",
// "Show thumbnails of all the images in the gallery" => "Show thumbnails of all the images in the gallery",
// "Parse Descriptions" => "Parse Descriptions",
// "Wiki parse the file descriptions" => "Wiki parse the file descriptions",
// "PluginContent" => "PluginContent",
// "Dynamic content ID. The value can be obtained in the listing" => "Dynamic content ID. The value can be obtained in the listing",
// "Content Label" => "Content Label",
// "Label of the dynamic content to display" => "Label of the dynamic content to display",
// "PluginCookie" => "PluginCookie",
// "Display a rotating set of taglines or quotes (also known as fortune cookies)" => "Display a rotating set of taglines or quotes (also known as fortune cookies)",
// "PluginCopyright" => "PluginCopyright",
// "PluginCountdown" => "PluginCountdown",
// "Set to off to only show days, otherwise hours, minutes and seconds are also shown (all are shown by default)" => "Set to off to only show days, otherwise hours, minutes and seconds are also shown (all are shown by default)",
// "On" => "On",
// "Off" => "Off",
// "Items to Show" => "Items to Show",
// "Select: d=days, h=hours, m=minutes, s=seconds. Enter multiple values as: dhms. If blank, all items are shown" => "Select: d=days, h=hours, m=minutes, s=seconds. Enter multiple values as: dhms. If blank, all items are shown",
// "Days & Hours" => "Days & Hours",
// "Days, Hours & Minutes" => "Days, Hours & Minutes",
// "Days, Hours, Minutes & Seconds" => "Days, Hours, Minutes & Seconds",
// "Hours & Minutes" => "Hours & Minutes",
// "Hours, Minutes & Seconds" => "Hours, Minutes & Seconds",
// "Minutes & Seconds" => "Minutes & Seconds",
// "Seconds" => "Seconds",
// "Show time since event" => "Show time since event",
// "If y, will display amount of time since the event (default). If n will simply display that the event is over" => "If y, will display amount of time since the event (default). If n will simply display that the event is over",
// "since " => "since ",
// "until " => "until ",
// " is over" => " is over",
// "PluginDataChannel" => "PluginDataChannel",
// "Displays a form to trigger data channels" => "Displays a form to trigger data channels",
// "List of fields to display. One field per line. Comma delimited: fieldname,label" => "List of fields to display. One field per line. Comma delimited: fieldname,label",
// "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"" => "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"",
// "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel" => "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel",
// "Channel Name" => "Channel Name",
// "Name of the channel as registered by the administrator" => "Name of the channel as registered by the administrator",
// "Return URL" => "Return URL",
// "URL to go to after data channel has run. Defaults to current page" => "URL to go to after data channel has run. Defaults to current page",
// "Do not use returnURI but instead return true quietly" => "Do not use returnURI but instead return true quietly",
// "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context" => "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context",
// "Button Label" => "Button Label",
// "Label for the submit button. Default: \"Go\"" => "Label for the submit button. Default: \"Go\"",
// "CSS class for this form" => "CSS class for this form",
// "Empty Caches" => "Empty Caches",
// "Which caches to empty. Default \"Clear all Tiki caches\"" => "Which caches to empty. Default \"Clear all Tiki caches\"",
// "./templates_c/" => "./templates_c/",
// "./modules/cache/" => "./modules/cache/",
// "./temp/cache/" => "./temp/cache/",
// "./temp/public/" => "./temp/public/",
// "Price to execute the datachannel (%0)" => "Price to execute the datachannel (%0)",
// "Payment Label" => "Payment Label",
// "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)",
// "Multiple Values" => "Multiple Values",
// "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)",
// "Datachannel" => "Datachannel",
// "PluginDBReport" => "PluginDBReport",
// "Run a database report. This plugin only works with adodb. It does not work with PDO" => "Run a database report. This plugin only works with adodb. It does not work with PDO",
// "Wiki DSN Name" => "Wiki DSN Name",
// "Parse wiki syntax within the report (not parsed by default)" => "Parse wiki syntax within the report (not parsed by default)",
// "Display the parsed report definition (not displayed by default)" => "Display the parsed report definition (not displayed by default)",
// "PluginDiv" => "PluginDiv",
// "Indicate the type of HTML tag to use (default is div)" => "Indicate the type of HTML tag to use (default is div)",
// "Span" => "Span",
// "Pre" => "Pre",
// "Teletype" => "Teletype",
// "Paragraph" => "Paragraph",
// "Block quote" => "Block quote",
// "In pixels or percentage. Default is original size" => "In pixels or percentage. Default is original size",
// "Aligns the text within the element" => "Aligns the text within the element",
// "Justify" => "Justify",
// "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
// "Items are not allowed to wrap around the side(s) this parameter is set to" => "Items are not allowed to wrap around the side(s) this parameter is set to",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "HTML ID" => "HTML ID",
// "Sets the div\\'s id attribute, as defined by HTML" => "Sets the div\\'s id attribute, as defined by HTML",
// "PluginDL" => "PluginDL",
// "PluginEquation" => "PluginEquation",
// "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large" => "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large",
// "PluginEvents" => "PluginEvents",
// "Display upcoming events from calendars" => "Display upcoming events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)" => "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)",
// "Maximum Days" => "Maximum Days",
// "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days" => "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days",
// "Maximum Events" => "Maximum Events",
// "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)" => "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)",
// "Show Time" => "Show Time",
// "Show the time along with the date (shown by default)" => "Show the time along with the date (shown by default)",
// "Show the description of the event (shown by default)" => "Show the description of the event (shown by default)",
// "PluginFade" => "PluginFade",
// "PluginFancyList" => "PluginFancyList",
// "Use Div" => "Use Div",
// "Use the HTML tag div instead of the HTML tag for lists (ol)" => "Use the HTML tag div instead of the HTML tag for lists (ol)",
// "PluginFancyTable" => "PluginFancyTable",
// "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases" => "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases",
// "Heading Row" => "Heading Row",
// "Header rows of the table. Use >> to separate multiple rows" => "Header rows of the table. Use >> to separate multiple rows",
// "Header Horizontal Align" => "Header Horizontal Align",
// "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify" => "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify",
// "Header Vertical Align" => "Header Vertical Align",
// "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline" => "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline",
// "Column Sort" => "Column Sort",
// "Indicate whether columns are sortable or not (not sortable by default)" => "Indicate whether columns are sortable or not (not sortable by default)",
// "Pre-sorted Columns" => "Pre-sorted Columns",
// "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]" => "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]",
// "Column Widths" => "Column Widths",
// "Column widths followed by px for pixels or % for percentages. Each column separated by |" => "Column widths followed by px for pixels or % for percentages. Each column separated by |",
// "Cell Horizontal Align" => "Cell Horizontal Align",
// "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify" => "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify",
// "Cell Vertical Align" => "Cell Vertical Align",
// "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline" => "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline",
// "heads and cells separated by |" => "heads and cells separated by |",
// "PluginFile" => "PluginFile",
// "Displays a link to a file (either from the file gallery or an attachment to a wiki page) and can display an image attachment. For more than one file from file galleries, or more optional information shown from the files, use the plugin FILES instead" => "Displays a link to a file (either from the file gallery or an attachment to a wiki page) and can display an image attachment. For more than one file from file galleries, or more optional information shown from the files, use the plugin FILES instead",
// "Label for the link to the file" => "Label for the link to the file",
// "Indicate whether the file is in a file gallery or is a wiki page attachment" => "Indicate whether the file is in a file gallery or is a wiki page attachment",
// "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used" => "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used",
// "Custom Description" => "Custom Description",
// "Custom text that will be used for the link instead of the file name or file description" => "Custom text that will be used for the link instead of the file name or file description",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty",
// "Attachment Description" => "Attachment Description",
// "Show the attachment description as the link label instead of the attachment file name" => "Show the attachment description as the link label instead of the attachment file name",
// "Indicates that this attachment is an image, and should be displayed inline using the img tag" => "Indicates that this attachment is an image, and should be displayed inline using the img tag",
// "File ID of a file in a file gallery or an archive" => "File ID of a file in a file gallery or an archive",
// "Example value" => "Example value",
// "For an archive file, the archive created just before this date will be linked to" => "For an archive file, the archive created just before this date will be linked to",
// "Show Icon" => "Show Icon",
// "Show an icon version of the file or file type with the link to the file" => "Show an icon version of the file or file type with the link to the file",
// "File Gallery File/Archive" => "File Gallery File/Archive",
// "Wiki Page Attachment" => "Wiki Page Attachment",
// "The date has not been set" => "The date has not been set",
// "Incorrect date format" => "Incorrect date format",
// "No such file" => "No such file",
// "Wiki attachments are disabled" => "Wiki attachments are disabled",
// "PluginFiles" => "PluginFiles",
// "Displays a list of files from a file gallery" => "Displays a list of files from a file gallery",
// "To list only files contained in this file gallery" => "To list only files contained in this file gallery",
// "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon",
// "To list only specified files, enter their file IDs separated by colon" => "To list only specified files, enter their file IDs separated by colon",
// "Order ascending or descending based on any field in the file gallery table. Default is name_asc" => "Order ascending or descending based on any field in the file gallery table. Default is name_asc",
// "Show Action" => "Show Action",
// "Show a column with icons for the various actions the user can take with each file (not shown by default)" => "Show a column with icons for the various actions the user can take with each file (not shown by default)",
// "Show Find" => "Show Find",
// "Show a search box above the list (not shown by default)" => "Show a search box above the list (not shown by default)",
// "Show the title of the file gallery (shown by default)" => "Show the title of the file gallery (shown by default)",
// "Show ID" => "Show ID",
// "Show the ID number of each file (shown by default)" => "Show the ID number of each file (shown by default)",
// "Show an icon for each file depicting the file type" => "Show an icon for each file depicting the file type",
// "Show the name given to the file upon upload into the file gallery (shown by default)" => "Show the name given to the file upon upload into the file gallery (shown by default)",
// "Show Filename" => "Show Filename",
// "Show each file\\'s filename (shown by default)" => "Show each file\\'s filename (shown by default)",
// "Show Size" => "Show Size",
// "Show the size of each file in kilobytes (shown by default)" => "Show the size of each file in kilobytes (shown by default)",
// "Show the description of the file given upon upload into the file gallery (shown by default)" => "Show the description of the file given upon upload into the file gallery (shown by default)",
// "Show the date each file was created (not shown by default)" => "Show the date each file was created (not shown by default)",
// "Show Last Modification Date" => "Show Last Modification Date",
// "Show the date each file was last modified (shown by default)" => "Show the date each file was last modified (shown by default)",
// "Show Hits" => "Show Hits",
// "Show the number of hits each file has received (not shown by default)" => "Show the number of hits each file has received (not shown by default)",
// "Show Locked By" => "Show Locked By",
// "For locked files, show the user name of the user who locked it (not shown by default)" => "For locked files, show the user name of the user who locked it (not shown by default)",
// "Show the user name of the user who is the author of the file (not shown by default)" => "Show the user name of the user who is the author of the file (not shown by default)",
// "Show the user name of the user who is the creator of the file (not shown by default)" => "Show the user name of the user who is the creator of the file (not shown by default)",
// "Show Parent Gallery Name" => "Show Parent Gallery Name",
// "Show the name of the parent gallery" => "Show the name of the parent gallery",
// "Show File Count" => "Show File Count",
// "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)",
// "Show Slideshow" => "Show Slideshow",
// "Show a link that produces a pop-up slide show when clicked (not set by default)" => "Show a link that produces a pop-up slide show when clicked (not set by default)",
// "Show Comment" => "Show Comment",
// "Show comments for each file (not shown by default)" => "Show comments for each file (not shown by default)",
// "Show Last Editor" => "Show Last Editor",
// "Show the user name of the user who last modified the file (shown by default)" => "Show the user name of the user who last modified the file (shown by default)",
// "Show only files created by this user" => "Show only files created by this user",
// "Show Upload" => "Show Upload",
// "Show a simple upload form to the gallery (not shown by default)" => "Show a simple upload form to the gallery (not shown by default)",
// "List files in a file gallery (with a category) or in a category or a file gallery od this category" => "List files in a file gallery (with a category) or in a category or a file gallery od this category",
// "PluginFlash" => "PluginFlash",
// "Flash Type" => "Flash Type",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo",
// "Select an option" => "Select an option",
// "Blip.tv" => "Blip.tv",
// "File Gallery Podcast" => "File Gallery Podcast",
// "Vimeo" => "Vimeo",
// "Complete URL to the movie to include. e.g. files/test.swf" => "Complete URL to the movie to include. e.g. files/test.swf",
// "File Gallery Podcast ID" => "File Gallery Podcast ID",
// "Id of a file from a podcast gallery - will work only with podcast gallery" => "Id of a file from a podcast gallery - will work only with podcast gallery",
// "Youtube URL" => "Youtube URL",
// "Entire URL to the YouTube video. Example: http://www.youtube.com/watch?v=1i2ZnU4iR24" => "Entire URL to the YouTube video. Example: http://www.youtube.com/watch?v=1i2ZnU4iR24",
// "Vimeo URL" => "Vimeo URL",
// "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966" => "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966",
// "Blip.tv URL" => "Blip.tv URL",
// "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC" => "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC",
// "Width of movie in pixels (default is 425)" => "Width of movie in pixels (default is 425)",
// "Height of movie in pixels (default is 350)" => "Height of movie in pixels (default is 350)",
// "Invalid URL" => "Invalid URL",
// "Inserts a superscripted footnote number next to text and takes in footnote as parameter" => "Inserts a superscripted footnote number next to text and takes in footnote as parameter",
// "PluginFootnote" => "PluginFootnote",
// "Sameas" => "Sameas",
// "Tag to existing footnote" => "Tag to existing footnote",
// "CheckDuplicate" => "CheckDuplicate",
// "Check for duplicate footnotes" => "Check for duplicate footnotes",
// "PluginFootnoteArea" => "PluginFootnoteArea",
// "Inserts a section for collected footnotes in the wiki page" => "Inserts a section for collected footnotes in the wiki page",
// "PluginFreetagged" => "PluginFreetagged",
// "Find similarly tagged objects" => "Find similarly tagged objects",
// "Tags to find similar to" => "Tags to find similar to",
// "Leave blank to use the object\\'s own tags" => "Leave blank to use the object\\'s own tags",
// "Type of objects to extract. Set to All to find all types" => "Type of objects to extract. Set to All to find all types",
// "Same" => "Same",
// "Offset" => "Offset",
// "Start record" => "Start record",
// "Default -1 (all)" => "Default -1 (all)",
// "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)" => "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)",
// "Comments Locked Ascending" => "Comments Locked Ascending",
// "Comments Locked Descending" => "Comments Locked Descending",
// "Description Ascending" => "Description Ascending",
// "Description Descending" => "Description Descending",
// "Href Ascending" => "Href Ascending",
// "Href Descending" => "Href Descending",
// "Object ID Ascending" => "Object ID Ascending",
// "Object ID Descending" => "Object ID Descending",
// "Show objects with names or descriptions similar to the text entered here" => "Show objects with names or descriptions similar to the text entered here",
// "Broaden" => "Broaden",
// "n|y" => "n|y",
// "Header Level" => "Header Level",
// "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags" => "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags",
// "Show Titles Only" => "Show Titles Only",
// "Choose whether to show titles only (not shown by default)" => "Choose whether to show titles only (not shown by default)",
// "Maximum Image Size" => "Maximum Image Size",
// "Height or width in pixels. Default = 0 (no maximum)" => "Height or width in pixels. Default = 0 (no maximum)",
// "FTP" => "FTP",
// "PluginFTP" => "PluginFTP",
// "Download box for a file on an FTP server" => "Download box for a file on an FTP server",
// "Server Name" => "Server Name",
// "Name of the server where the FTP account is housed. Example: " => "Name of the server where the FTP account is housed. Example: ",
// "User name needed to access the FTP account" => "User name needed to access the FTP account",
// "Password needed to access the FTP account" => "Password needed to access the FTP account",
// "Download Button Label" => "Download Button Label",
// "Label for the FTP download button" => "Label for the FTP download button",
// "Gauge" => "Gauge",
// "PluginGauge" => "PluginGauge",
// "Displays a graphical gauge" => "Displays a graphical gauge",
// "Current value to be represented by the gauge" => "Current value to be represented by the gauge",
// "Label displayed on the left side of the gauge" => "Label displayed on the left side of the gauge",
// "Main color of the gauge. Use HTML color codes or names" => "Main color of the gauge. Use HTML color codes or names",
// "Background color of the gauge. Use HTML color codes or names" => "Background color of the gauge. Use HTML color codes or names",
// "Width in pixels allocated to the label" => "Width in pixels allocated to the label",
// "Set to true (Yes) to display a percentage of the maximum" => "Set to true (Yes) to display a percentage of the maximum",
// "Set to false (No) to hide the numeric value (shown by default)" => "Set to false (No) to hide the numeric value (shown by default)",
// "Bar height in pixels" => "Bar height in pixels",
// "PluginGoogleAnalytics" => "PluginGoogleAnalytics",
// "Account Number" => "Account Number",
// "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY" => "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY",
// "Google Doc" => "Google Doc",
// "PluginGoogleDoc" => "PluginGoogleDoc",
// "Document" => "Document",
// "Presentation" => "Presentation",
// "Name of iframe. Default is \"Frame\" + the key" => "Name of iframe. Default is \"Frame\" + the key",
// "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly",
// "Small" => "Small",
// "Large" => "Large",
// "Width in pixels or %" => "Width in pixels or %",
// "Height in pixels or %" => "Height in pixels or %",
// "Middle" => "Middle",
// "Choose whether to show a border around the iframe" => "Choose whether to show a border around the iframe",
// "Margin height in pixels" => "Margin height in pixels",
// "Margin width in pixels" => "Margin width in pixels",
// "Choose whether to add a scroll bar" => "Choose whether to add a scroll bar",
// "Auto" => "Auto",
// "Edit Link" => "Edit Link",
// "Choose whether to show an edit link and set its location" => "Choose whether to show an edit link and set its location",
// "Required parameter \"type\" missing" => "Required parameter \"type\" missing",
// "Required parameter \"key\" missing" => "Required parameter \"key\" missing",
// "googlemap" => "googlemap",
// "PluginGoogleMap" => "PluginGoogleMap",
// "Type of items to show on google map" => "Type of items to show on google map",
// "Locator" => "Locator",
// "Object List" => "Object List",
// "Tracker Field" => "Tracker Field",
// "Display Mode" => "Display Mode",
// "Map display mode" => "Map display mode",
// "Satellite" => "Satellite",
// "Hybrid" => "Hybrid",
// "API Key" => "API Key",
// "Google maps key, if not set in user preferences" => "Google maps key, if not set in user preferences",
// "Map ID" => "Map ID",
// "Id suffix of Google map div to avoid conflicts with other maps on same page" => "Id suffix of Google map div to avoid conflicts with other maps on same page",
// "Show Border" => "Show Border",
// "Choose whether to show a frame border around the map (no border shown by default)" => "Choose whether to show a frame border around the map (no border shown by default)",
// "Default Center Longitude" => "Default Center Longitude",
// "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature" => "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature",
// "Default Center Latitude" => "Default Center Latitude",
// "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature" => "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature",
// "Default Zoom" => "Default Zoom",
// "Use an integer between 0 and 19 to set a default zoom level for the map. Default is the default set in the Gmap feature" => "Use an integer between 0 and 19 to set a default zoom level for the map. Default is the default set in the Gmap feature",
// "Save View" => "Save View",
// "Allow user to set current map view as default view for himself only" => "Allow user to set current map view as default view for himself only",
// "Item Type" => "Item Type",
// "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified" => "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified",
// "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified" => "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified",
// "Hide If No Markers" => "Hide If No Markers",
// "Hide map if there are no markers to be shown. Default is to show the map" => "Hide map if there are no markers to be shown. Default is to show the map",
// "Visibility Toggle" => "Visibility Toggle",
// "Add ability to toggle visibility. No toggle by default" => "Add ability to toggle visibility. No toggle by default",
// "Start Hidden" => "Start Hidden",
// "Choose whether to keep the map hidden initially. Default is to show the map initially" => "Choose whether to keep the map hidden initially. Default is to show the map initially",
// "Auto Zoom" => "Auto Zoom",
// "Use an integer between 0 and 19 to auto zoom to this level on address find" => "Use an integer between 0 and 19 to auto zoom to this level on address find",
// "Show Controls" => "Show Controls",
// "Show map controls (shown by default)" => "Show map controls (shown by default)",
// "Tracker Field ID" => "Tracker Field ID",
// "Field ID of tracker field if type is trackerfield or locator and locateitemtype is trackeritem" => "Field ID of tracker field if type is trackerfield or locator and locateitemtype is trackeritem",
// "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms" => "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms",
// "In Form" => "In Form",
// "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML" => "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML",
// "No such user" => "No such user",
// "The user has chosen to make his information private" => "The user has chosen to make his information private",
// "No such object" => "No such object",
// "Not logged in" => "Not logged in",
// "Error: Invalid Lon. and Lat. values" => "Error: Invalid Lon. and Lat. values",
// "Map view saved as default for " => "Map view saved as default for ",
// "You can only set your own location" => "You can only set your own location",
// "Please select a point to set both Lon. and Lat" => "Please select a point to set both Lon. and Lat",
// "User location saved for " => "User location saved for ",
// "You cannot edit this object or no such object" => "You cannot edit this object or no such object",
// "Location saved for object" => "Location saved for object",
// "Error saving location" => "Error saving location",
// "PluginGroup" => "PluginGroup",
// "Allowed User Friends" => "Allowed User Friends",
// "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo" => "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo",
// "Display wiki text if user is in one of listed groups or group of friends" => "Display wiki text if user is in one of listed groups or group of friends",
// "PluginGroupList" => "PluginGroupList",
// "List all groups or just groups that include a certain group" => "List all groups or just groups that include a certain group",
// "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed",
// "Group Home Page" => "Group Home Page",
// "Link the group name to the group home page, if there is one (not linked by default)" => "Link the group name to the group home page, if there is one (not linked by default)",
// "Recursively List Groups" => "Recursively List Groups",
// "Recurse on the included groups (default is not to recurse)" => "Recurse on the included groups (default is not to recurse)",
// "GroupMailCore" => "GroupMailCore",
// "PluginGroupMailCore" => "PluginGroupMailCore",
// "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile" => "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile",
// "From Email" => "From Email",
// "Email address to report" => "Email address to report",
// "Tracker Id" => "Tracker Id",
// "Id of GroupMail Logs tracker (set up in alias by profile)" => "Id of GroupMail Logs tracker (set up in alias by profile)",
// "From Field Id" => "From Field Id",
// "Id of GroupMail Logs tracker field (usually set up in alias by profile)" => "Id of GroupMail Logs tracker field (usually set up in alias by profile)",
// "Operator Field Id" => "Operator Field Id",
// "Subject Field Id" => "Subject Field Id",
// "Message Field Id" => "Message Field Id",
// "Content Field Id" => "Content Field Id",
// "Account Field Id" => "Account Field Id",
// "Datetime Field Id" => "Datetime Field Id",
// "Displays GroupMail functions on a wiki page" => "Displays GroupMail functions on a wiki page",
// "PluginGroupStat" => "PluginGroupStat",
// "Displays the percentage of total users that are members of groups" => "Displays the percentage of total users that are members of groups",
// "Groups separated by :. If empty, all groups will be listed" => "Groups separated by :. If empty, all groups will be listed",
// "Show the percentage of total users that are members of each group (percentages are shown by default)" => "Show the percentage of total users that are members of each group (percentages are shown by default)",
// "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)",
// "PluginHTML" => "PluginHTML",
// "Parse wiki syntax within the html code" => "Parse wiki syntax within the html code",
// "PluginIframe" => "PluginIframe",
// "Frame title" => "Frame title",
// "Align the ifram on the page" => "Align the ifram on the page",
// "Frame Border" => "Frame Border",
// "PluginImg" => "PluginImg",
// "Image source" => "Image source",
// "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required" => "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required",
// "Numeric ID of an image in an Image Gallery (or list separated by commas or |)" => "Numeric ID of an image in an Image Gallery (or list separated by commas or |)",
// "Numeric ID of an image in a File Gallery (or list separated by commas or |)" => "Numeric ID of an image in a File Gallery (or list separated by commas or |)",
// "Numeric ID of a File Gallery. Displays a random image from that gallery" => "Numeric ID of a File Gallery. Displays a random image from that gallery",
// "Attachment ID" => "Attachment ID",
// "Numeric ID of an image attached to a wiki page (or list separated by commas or |)" => "Numeric ID of an image attached to a wiki page (or list separated by commas or |)",
// "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments",
// "Full size image appears when thumbnail is clicked" => "Full size image appears when thumbnail is clicked",
// "Full size image will pop up while cursor is over the thumbnail (and disappear when not)" => "Full size image will pop up while cursor is over the thumbnail (and disappear when not)",
// "Mouseover (Sticky)" => "Mouseover (Sticky)",
// "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup" => "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup",
// "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked" => "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked",
// "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery",
// "Browse Popup" => "Browse Popup",
// "Same as \"browse\" except that the page opens in a new window or tab" => "Same as \"browse\" except that the page opens in a new window or tab",
// "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked" => "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked",
// "Enlarge button" => "Enlarge button",
// "Button for enlarging image" => "Button for enlarging image",
// "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting" => "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting",
// "Link relation" => "Link relation",
// "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation" => "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation",
// "Image map" => "Image map",
// "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
// "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
// "Maximum image size" => "Maximum image size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings",
// "Align image" => "Align image",
// "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box" => "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box",
// "Image style" => "Image style",
// "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects",
// "Align image block" => "Align image block",
// "Aligns the box containing the image" => "Aligns the box containing the image",
// "Image block style" => "Image block style",
// "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects",
// "Description style" => "Description style",
// "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects" => "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects",
// "Wrapping control" => "Wrapping control",
// "Control how other items wrap around the image" => "Control how other items wrap around the image",
// "CSS class to apply to the image" => "CSS class to apply to the image",
// "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description" => "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description",
// "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title" => "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title",
// "Alternate text" => "Alternate text",
// "Alternate text that displays when image does not load. Set to \"Image\" by default" => "Alternate text that displays when image does not load. Set to \"Image\" by default",
// "Default config settings" => "Default config settings",
// "Default configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "Mandatory admin setting" => "Mandatory admin setting",
// "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "Enlarge" => "Enlarge",
// "''No image specified. Either the fileId, randomGalleryId, attId, id, or src parameter must be specified.''" => "''No image specified. Either the fileId, randomGalleryId, attId, id, or src parameter must be specified.''",
// "''Use one and only one of the following parameters: fileId, randomGalleryId, attId, id, or src.''" => "''Use one and only one of the following parameters: fileId, randomGalleryId, attId, id, or src.''",
// "PluginInclude" => "PluginInclude",
// "Include a page\\'s content" => "Include a page\\'s content",
// "Nopage Text" => "Nopage Text",
// "Text to show when no page is found" => "Text to show when no page is found",
// "Page Denied Text" => "Page Denied Text",
// "Text to show when the page exists but is denied to the user" => "Text to show when the page exists but is denied to the user",
// "PluginInvite" => "PluginInvite",
// "Including Group" => "Including Group",
// "Will list only the groups that include this group" => "Will list only the groups that include this group",
// "Dropdown list will show this group by default" => "Dropdown list will show this group by default",
// "Dropdown list will show the group related to this item ID (in group selector or creator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or creator field) by default",
// "PluginJabber" => "PluginJabber",
// "Applet width in pixels" => "Applet width in pixels",
// "XML Host Name" => "XML Host Name",
// "Web site where XML is hosted. Default is jabber.org" => "Web site where XML is hosted. Default is jabber.org",
// "Set default color. Default is 255,255,255" => "Set default color. Default is 255,255,255",
// "jQuery" => "jQuery",
// "PluginJQ" => "PluginJQ",
// "Inserts JavaScript code. By default this is only executed after jQuery determines that the DOM is fully loaded" => "Inserts JavaScript code. By default this is only executed after jQuery determines that the DOM is fully loaded",
// "JavaScript code" => "JavaScript code",
// "Not On Ready" => "Not On Ready",
// "No JavaScript" => "No JavaScript",
// "Optional markup for when JavaScript is off" => "Optional markup for when JavaScript is off",
// "Insert JQuery javascript code" => "Insert JQuery javascript code",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "PluginJS" => "PluginJS",
// "Insert a javascript file and/or some javascript code" => "Insert a javascript file and/or some javascript code",
// "Insert a javascript file or/and some javascript code" => "Insert a javascript file or/and some javascript code",
// "PluginKaltura" => "PluginKaltura",
// "Kaltura Entry ID" => "Kaltura Entry ID",
// "Kaltura entry ID of the video to be displayed" => "Kaltura entry ID of the video to be displayed",
// "PluginLang" => "PluginLang",
// "Displays the text only if the language matches" => "Displays the text only if the language matches",
// "PluginLastMod" => "PluginLastMod",
// "The Last Mod plugin displays the last modification time of the named wiki page, or the current page if no name given" => "The Last Mod plugin displays the last modification time of the named wiki page, or the current page if no name given",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "PluginListpages" => "PluginListpages",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Limit number of items displayed in the list. Default is to display all" => "Limit number of items displayed in the list. Default is to display all",
// "Initial" => "Initial",
// "txt" => "txt",
// "Show only the page names" => "Show only the page names",
// "Category filter" => "Category filter",
// "If set to a category identifier, restrict the pages displayed to those in the specified category" => "If set to a category identifier, restrict the pages displayed to those in the specified category",
// "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories" => "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories",
// "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories" => "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories",
// "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories" => "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories",
// "Structure Head" => "Structure Head",
// "Filter by structure head" => "Filter by structure head",
// "Show page alias in the list" => "Show page alias in the list",
// "Only pages with names similar the text entered for this parameter will be listed" => "Only pages with names similar the text entered for this parameter will be listed",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Page name and text entered for the filter parameter must match exactly to be listed" => "Page name and text entered for the filter parameter must match exactly to be listed",
// "Only list orphan pages" => "Only list orphan pages",
// "For List Pages" => "For List Pages",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: " => "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: ",
// "Length" => "Length",
// "Number of characters to display" => "Number of characters to display",
// "PluginLsDir" => "PluginLsDir",
// "Full path to the server-local directory. Default is the document root" => "Full path to the server-local directory. Default is the document root",
// "Make the file name a link to the file by adding the url path preceding the file name. Example: http://yoursite.com/tiki/" => "Make the file name a link to the file by adding the url path preceding the file name. Example: http://yoursite.com/tiki/",
// "Set the sort order of the file list" => "Set the sort order of the file list",
// "File Size" => "File Size",
// "Last Access" => "Last Access",
// "Last Metadata Change" => "Last Metadata Change",
// "Only list files with filenames that contain this filter. Example: \".jpg\"" => "Only list files with filenames that contain this filter. Example: \".jpg\"",
// "Maximum amount of files to display. Default is no limit" => "Maximum amount of files to display. Default is no limit",
// "could not be opened because it doesn't exist or permission was denied" => "could not be opened because it doesn't exist or permission was denied",
// "PluginMail" => "PluginMail",
// "Directly mail other users or groups" => "Directly mail other users or groups",
// "Limit the group to the groups including this group" => "Limit the group to the groups including this group",
// "Show Group Dropdown" => "Show Group Dropdown",
// "Show a dropdown list of groups (not shown by default)" => "Show a dropdown list of groups (not shown by default)",
// "Show User Dropdown" => "Show User Dropdown",
// "Show a dropdown list of users (not shown by default)" => "Show a dropdown list of users (not shown by default)",
// "User Autocomplete" => "User Autocomplete",
// "Show an autocomplete box on user name" => "Show an autocomplete box on user name",
// "Real Name Dropdown" => "Real Name Dropdown",
// "Show a dropdown list of user real names (not shown by default)" => "Show a dropdown list of user real names (not shown by default)",
// "PluginMap" => "PluginMap",
// "Map file identifier" => "Map file identifier",
// "Extents" => "Extents",
// "Size of the map" => "Size of the map",
// "Width of the map" => "Width of the map",
// "Height of the map" => "Height of the map",
// "PluginMCalendarInfo" => "PluginMCalendarInfo",
// "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count" => "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count",
// "You must use the variable substitution" => "You must use the variable substitution",
// "LongCount: " => "LongCount: ",
// "Tzolkin: " => "Tzolkin: ",
// "Haab: " => "Haab: ",
// "Misc: " => "Misc: ",
// "Example: template " => "Example: template ",
// "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
// "Default template: " => "Default template: ",
// "Gregorian date" => "Gregorian date",
// "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date" => "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date",
// "Mayan Calendars" => "Mayan Calendars",
// " is not a valid date format. should be dd.mm.yyyy" => " is not a valid date format. should be dd.mm.yyyy",
// "Inline Flash mp3 and flv Player" => "Inline Flash mp3 and flv Player",
// "PluginMediaplayer" => "PluginMediaplayer",
// "Simple mp3 or flv Player" => "Simple mp3 or flv Player",
// "Allow Fullscreen" => "Allow Fullscreen",
// "Allow fullscreen mode" => "Allow fullscreen mode",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "Complete URL to the media to include" => "Complete URL to the media to include",
// "One of" => "One of",
// "Flash Window Mode" => "Flash Window Mode",
// "Sets the Window Mode property of the Flash movie. Transparent lets what\\'s behind the movie show through and allows the movie to be covered \n\t\t\t\t\t\t\t\t\t\t Opaque hides what\\'s behind the movie and Window plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what\\'s behind the movie show through and allows the movie to be covered \n\t\t\t\t\t\t\t\t\t\t Opaque hides what\\'s behind the movie and Window plays the movie in its own window. Default value: ",
// "Transparent" => "Transparent",
// "Opaque" => "Opaque",
// "Window" => "Window",
// "PluginMemberList" => "PluginMemberList",
// "Lists the members of selected groups and allows to add or remove members if permissions are granted" => "Lists the members of selected groups and allows to add or remove members if permissions are granted",
// "List of groups to handle through the interface. Colon separated" => "List of groups to handle through the interface. Colon separated",
// "PluginMemberPayment" => "PluginMemberPayment",
// "Receive payments from a member and extend the length of the membership to a group" => "Receive payments from a member and extend the length of the membership to a group",
// "Name of the group for which the subscription should be added or extended" => "Name of the group for which the subscription should be added or extended",
// "Price per period (%0)" => "Price per period (%0)",
// "Current User Member" => "Current User Member",
// "Membership only for the current user" => "Membership only for the current user",
// "Input Title" => "Input Title",
// "Title of the input form" => "Title of the input form",
// "Use %0 for the group name" => "Use %0 for the group name",
// "Supports wiki syntax" => "Supports wiki syntax",
// "How Title" => "How Title",
// "Use %0 for the group name, %4 for the number of days or %5 for the number of years" => "Use %0 for the group name, %4 for the number of days or %5 for the number of years",
// "Membership to %0 for %1 (x%2)" => "Membership to %0 for %1 (x%2)",
// "Membership to %0 for %1 users (x%2)" => "Membership to %0 for %1 users (x%2)",
// "The group " => "The group ",
// " does not have a membership term" => " does not have a membership term",
// " Go to " => " Go to ",
// "Admin > Groups" => "Admin > Groups",
// " to specify a term for this group by automatically unassigning users after a certain number of days" => " to specify a term for this group by automatically unassigning users after a certain number of days",
// " does not exist" => " does not exist",
// "PluginMiniQuiz" => "PluginMiniQuiz",
// "Numeric value representing the miniquiz tracker ID" => "Numeric value representing the miniquiz tracker ID",
// "PluginModule" => "PluginModule",
// "Module name as known in Tiki" => "Module name as known in Tiki",
// "Align the module to the left or right on the page allowing other elements to align against it" => "Align the module to the left or right on the page allowing other elements to align against it",
// "Show box decorations (default is to show them)" => "Show box decorations (default is to show them)",
// "Add ability to show/hide the content of the module (default is the site admin setting for modules)" => "Add ability to show/hide the content of the module (default is the site admin setting for modules)",
// "Parse wiki syntax (default is to parse)" => "Parse wiki syntax (default is to parse)",
// "Show/hide module title (default is to show the title)" => "Show/hide module title (default is to show the title)",
// "Show title" => "Show title",
// "Hide title" => "Hide title",
// "PluginMono" => "PluginMono",
// "PluginMouseover" => "PluginMouseover",
// "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5" => "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5",
// "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0" => "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0",
// "Parse the body of the plugin as wiki content (parsed by default)" => "Parse the body of the plugin as wiki content (parsed by default)",
// "Parse Label" => "Parse Label",
// "Parse the label as wiki content (parsed by default)" => "Parse the label as wiki content (parsed by default)",
// "CSS class to apply" => "CSS class to apply",
// "Background color to apply to the popup" => "Background color to apply to the popup",
// "Text Color" => "Text Color",
// "Color to apply to the text in the popup" => "Color to apply to the text in the popup",
// "When enabled, popup stays visible until it is clicked" => "When enabled, popup stays visible until it is clicked",
// "Padding" => "Padding",
// "Padding size in pixels" => "Padding size in pixels",
// "Effect" => "Effect",
// "Set the type of show/hide animation that will be used" => "Set the type of show/hide animation that will be used",
// "Effect Speed" => "Effect Speed",
// "Set the speed of the animation" => "Set the speed of the animation",
// "Close Delay" => "Close Delay",
// "Number of seconds before popup closes" => "Number of seconds before popup closes",
// "MWTable" => "MWTable",
// "PluginMWTable" => "PluginMWTable",
// "Displays a table using MediaWiki syntax (experimental - may change in future versions)" => "Displays a table using MediaWiki syntax (experimental - may change in future versions)",
// "Fancy" => "Fancy",
// "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)" => "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)",
// "True" => "True",
// "False" => "False",
// "Wiki Classes" => "Wiki Classes",
// "Determines whether wiki style classes will be used for the table and cells (used by default)" => "Determines whether wiki style classes will be used for the table and cells (used by default)",
// "PluginMySpace" => "PluginMySpace",
// "MySpace page name" => "MySpace page name",
// "PluginObjectHits" => "PluginObjectHits",
// "For a wiki page, the page name, for other object types: ID number + ? + object title" => "For a wiki page, the page name, for other object types: ID number + ? + object title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"" => "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"",
// "Show the number of hits over the past number of days indicated. Default is to show all hits" => "Show the number of hits over the past number of days indicated. Default is to show all hits",
// "Display a payment request\\'s details based on the user\\'s privileges and the state of the payment. The payment details may include the payment options" => "Display a payment request\\'s details based on the user\\'s privileges and the state of the payment. The payment details may include the payment options",
// "Payment Request Number" => "Payment Request Number",
// "Unique identifier of the payment request" => "Unique identifier of the payment request",
// "PluginPerm" => "PluginPerm",
// "Display wiki text if and only if the user has at least one of a set of permissions (or none, if using notperms)" => "Display wiki text if and only if the user has at least one of a set of permissions (or none, if using notperms)",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met",
// "Possible Permissions" => "Possible Permissions",
// "Pipe separated list of permissions, one of which is needed to view the default text" => "Pipe separated list of permissions, one of which is needed to view the default text",
// "Forbidden Permissions" => "Forbidden Permissions",
// "Pipe separated list of permissions, any of which will cause the default text not to show" => "Pipe separated list of permissions, any of which will cause the default text not to show",
// "Display wiki text if user has one of listed permissions" => "Display wiki text if user has one of listed permissions",
// "Displays a list of plugins available in this wiki" => "Displays a list of plugins available in this wiki",
// "The module or plugin parameter must be set, but not both" => "The module or plugin parameter must be set, but not both",
// "^Plugin Manager error: " => "^Plugin Manager error: ",
// " not found" => " not found",
// "Plugin manager error: " => "Plugin manager error: ",
// "Introduced in Tiki version" => "Introduced in Tiki version",
// "Accepted Values" => "Accepted Values",
// "any string except for HTML and PHP tags" => "any string except for HTML and PHP tags",
// "Since" => "Since",
// "no parameters" => "no parameters",
// "Preferences required" => "Preferences required",
// "Required parameters are in</em> <b>bold</b>" => "Required parameters are in</em> <b>bold</b>",
// "PluginPluginManager" => "PluginPluginManager",
// "Displays a list of plugins or modules available in this wiki" => "Displays a list of plugins or modules available in this wiki",
// "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none" => "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none",
// "One or more of: description | parameters | paraminfo" => "One or more of: description | parameters | paraminfo",
// "Description & Parameters" => "Description & Parameters",
// "Description & Parameter Info" => "Description & Parameter Info",
// "Parameters & Parameter Info" => "Parameters & Parameter Info",
// "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter" => "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter",
// "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter" => "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter",
// "Single Title" => "Single Title",
// "Set placement of plugin name and description when displaying information for only one plugin" => "Set placement of plugin name and description when displaying information for only one plugin",
// "Title Heading" => "Title Heading",
// "Sets the heading size for the title, e.g., h2" => "Sets the heading size for the title, e.g., h2",
// "Start with this plugin record number (must be an integer 1 or greater)" => "Start with this plugin record number (must be an integer 1 or greater)",
// "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater",
// "PluginPoll" => "PluginPoll",
// "Numeric value representing the poll ID" => "Numeric value representing the poll ID",
// "Show poll title (shown by default)" => "Show poll title (shown by default)",
// "Adds controls required to apply a profile" => "Adds controls required to apply a profile",
// "PluginProfile" => "PluginProfile",
// "Profile repository domain. Default value is profiles.tiki.org" => "Profile repository domain. Default value is profiles.tiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile to be applied" => "Name of the profile to be applied",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "PluginProposal" => "PluginProposal",
// "Provides a widget for users to vote on a proposal and view the current decision" => "Provides a widget for users to vote on a proposal and view the current decision",
// "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username",
// "Short description of the proposal to vote on. Will be displayed above the result table" => "Short description of the proposal to vote on. Will be displayed above the result table",
// "PluginQuote" => "PluginQuote",
// "Reply To" => "Reply To",
// "RandomInclude" => "RandomInclude",
// "PluginRandomInclude" => "PluginRandomInclude",
// "Include a random page\\'s content" => "Include a random page\\'s content",
// "Include a random page" => "Include a random page",
// "PluginRcontent" => "PluginRcontent",
// "Numeric value representing the content ID" => "Numeric value representing the content ID",
// "User List (showing Real Name)" => "User List (showing Real Name)",
// "PluginRealNameList" => "PluginRealNameList",
// " (experimental, should be merged with UserList in Tiki5)" => " (experimental, should be merged with UserList in Tiki5)",
// "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included",
// "String to use between elements of the list if table layout is not used" => "String to use between elements of the list if table layout is not used",
// "Set to sort in ascending or descending order (unsorted by default" => "Set to sort in ascending or descending order (unsorted by default",
// "Set to table to show results in a table (not shown in a table by default)" => "Set to table to show results in a table (not shown in a table by default)",
// "Make the listed names links to various types of user information" => "Make the listed names links to various types of user information",
// "User Page" => "User Page",
// "Exclude certain test or admin names from the list" => "Exclude certain test or admin names from the list",
// "admin" => "admin",
// "admin-test" => "admin-test",
// "test" => "test",
// "test-admin" => "test-admin",
// "Displays a list of users showing their real name" => "Displays a list of users showing their real name",
// "Displays a list of registered users showing their Real Names" => "Displays a list of registered users showing their Real Names",
// "PluginRedirect" => "PluginRedirect",
// "Redirect the user to a wiki page or generic URL" => "Redirect the user to a wiki page or generic URL",
// "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page",
// "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. ",
// "REDIRECT plugin: redirect loop detected" => "REDIRECT plugin: redirect loop detected",
// "Regular Expression" => "Regular Expression",
// "PluginRegex" => "PluginRegex",
// "Takes regex expressions and parses the content between REGEX tags and replaces the text" => "Takes regex expressions and parses the content between REGEX tags and replaces the text",
// "Each line of content is evaluated separately" => "Each line of content is evaluated separately",
// "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text" => "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text",
// "Takes regex expressions and parses the content between the REGEX tags and replaces the text" => "Takes regex expressions and parses the content between the REGEX tags and replaces the text",
// "PluginRemarksBox" => "PluginRemarksBox",
// "Select type of remarksbox, which determines what icon and style will be displayed" => "Select type of remarksbox, which determines what icon and style will be displayed",
// "Confirm" => "Confirm",
// "Use the highlight class for formatting (not used by default)" => "Use the highlight class for formatting (not used by default)",
// "Custom Icon" => "Custom Icon",
// "Enter a Tiki icon file name (with or without extension) or path to display a custom icon" => "Enter a Tiki icon file name (with or without extension) or path to display a custom icon",
// "Show a close button (not shown by default)" => "Show a close button (not shown by default)",
// "Width (e.g. 100% or 250px - default \"\")" => "Width (e.g. 100% or 250px - default \"\")",
// "PluginRSS" => "PluginRSS",
// "Show date of each item (not shown by default)" => "Show date of each item (not shown by default)",
// "Show feed descriptions (not shown by default)" => "Show feed descriptions (not shown by default)",
// "Show authors (not shown by default)" => "Show authors (not shown by default)",
// "Url to a favicon to put before each entry" => "Url to a favicon to put before each entry",
// "Show the title of the feed (shown by default)" => "Show the title of the feed (shown by default)",
// "PluginScroll" => "PluginScroll",
// "'),\n\t\t'prefs' => array('wikiplugin_scroll" => "'),\n\t\t'prefs' => array('wikiplugin_scroll",
// "Width in pixels. Example: 600px" => "Width in pixels. Example: 600px",
// "Number of pixels followed by \"px\". Example: 600px" => "Number of pixels followed by \"px\". Example: 600px",
// "Height in pixels. Example: 450px" => "Height in pixels. Example: 450px",
// "Number of pixels followed by \"px\". Example: 450px" => "Number of pixels followed by \"px\". Example: 450px",
// "Scroll speed in number of seconds (default is 8 seconds)" => "Scroll speed in number of seconds (default is 8 seconds)",
// "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests" => "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests",
// "PluginSF" => "PluginSF",
// "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests) with the title of the item as the link text" => "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests) with the title of the item as the link text",
// "Group ID" => "Group ID",
// "SourceForge project ID (shows as group_id in the url of a tracker item" => "SourceForge project ID (shows as group_id in the url of a tracker item",
// "SourceForge tracker ID (shows as atid in the url of a tracker item" => "SourceForge tracker ID (shows as atid in the url of a tracker item",
// "SourceForge item ID (shows as aid in the url of a tracker item" => "SourceForge item ID (shows as aid in the url of a tracker item",
// "First part of link tooltip identifying the type of tracker item (bog, feature request, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bog, feature request, patch or support request)",
// "Sharethis" => "Sharethis",
// "Display a social networking tool" => "Display a social networking tool",
// "Send Services" => "Send Services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "Aim" => "Aim",
// "Aim \$ Email" => "Aim \$ Email",
// "Aim \$ Sms" => "Aim \$ Sms",
// "Email \$ Sms" => "Email \$ Sms",
// "Button Style" => "Button Style",
// "Set button style: horizontal, vertical or rotate" => "Set button style: horizontal, vertical or rotate",
// "Rotate" => "Rotate",
// "Rotate Image" => "Rotate Image",
// "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Multiple Icons" => "Multiple Icons",
// "Enter list: email | facebook | twitter | sharethis, depending on which icons you\\'d like" => "Enter list: email | facebook | twitter | sharethis, depending on which icons you\\'d like",
// "First Services Shown" => "First Services Shown",
// "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Button Text" => "Button Text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header Title" => "Header Title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header Background" => "Header Background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header Text Color" => "Header Text Color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded Elements" => "Embedded Elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Display data from a TikiSheet" => "Display data from a TikiSheet",
// "Internal ID of the TikiSheet.  Either id or url MUST be used" => "Internal ID of the TikiSheet.  Either id or url MUST be used",
// "Sheet Url Location" => "Sheet Url Location",
// "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used" => "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used",
// "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)" => "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)",
// "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"" => "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"",
// "Height in pixels or percentage. Default value is complete spreadsheet height" => "Height in pixels or percentage. Default value is complete spreadsheet height",
// "Show edit button. Default \\'y\\' depending on user\\'s permissions" => "Show edit button. Default \\'y\\' depending on user\\'s permissions",
// "Show subsheets" => "Show subsheets",
// "y/n. Show multi-sheets. Default \\'y\\'" => "y/n. Show multi-sheets. Default \\'y\\'",
// "Range" => "Range",
// "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"" => "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"",
// "Apply custom CSS class to the containing div" => "Apply custom CSS class to the containing div",
// "PluginShowPages" => "PluginShowPages",
// "Display page name and/or description. Both displayed by default" => "Display page name and/or description. Both displayed by default",
// "Name & Description" => "Name & Description",
// "PluginSkype" => "PluginSkype",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Set whether to call or chat. Default is chat" => "Set whether to call or chat. Default is chat",
// "Call" => "Call",
// "Chat" => "Chat",
// "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles" => "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles",
// "Slideshow notes - Separate with \"/////\"" => "Slideshow notes - Separate with \"/////\"",
// "The side on which you would like to display text if there are images that are resized or present" => "The side on which you would like to display text if there are images that are resized or present",
// "Tiki jQuery UI Theme" => "Tiki jQuery UI Theme",
// "Background Url Location" => "Background Url Location",
// "URL of the background image to use in your slideshow, overrides backgroundcolor" => "URL of the background image to use in your slideshow, overrides backgroundcolor",
// "Valid url" => "Valid url",
// "Background color to use in your slideshow, default " => "Background color to use in your slideshow, default ",
// "Any valid CSS class" => "Any valid CSS class",
// "Header font color" => "Header font color",
// "Apply a color to the headers of your slideshow" => "Apply a color to the headers of your slideshow",
// "Any html color" => "Any html color",
// "Header background color" => "Header background color",
// "Slide font color" => "Slide font color",
// "Apply a color to the slides of your slideshow" => "Apply a color to the slides of your slideshow",
// "Line Item highlight color" => "Line Item highlight color",
// "Apply a color to the line item when mouse over" => "Apply a color to the line item when mouse over",
// "Slide Seconds" => "Slide Seconds",
// "How many seconds a slide will be open while playing" => "How many seconds a slide will be open while playing",
// "Second count" => "Second count",
// "Text Side" => "Text Side",
// "PluginSmarty" => "PluginSmarty",
// "Provides access to the tiki smarty functions like button" => "Provides access to the tiki smarty functions like button",
// "Smarty Function" => "Smarty Function",
// "The name of the smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php" => "The name of the smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php",
// "Snarf" => "Snarf",
// "PluginSnarf" => "PluginSnarf",
// "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified" => "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified",
// "Full URL to the page to include" => "Full URL to the page to include",
// "Regular Expression Pattern" => "Regular Expression Pattern",
// "PCRE-compliant regular expression pattern to find the parts you want changed" => "PCRE-compliant regular expression pattern to find the parts you want changed",
// "Regular Expression Replacement" => "Regular Expression Replacement",
// "PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "PCRE-compliant regular expression replacement syntax showing what the content should be changed to",
// "Enable/disable word wrapping of snippets of code (enabled by default)" => "Enable/disable word wrapping of snippets of code (enabled by default)",
// "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)" => "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)",
// "Switch the text display from left to right to right to left" => "Switch the text display from left to right to right to left",
// "HTML Content" => "HTML Content",
// "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)" => "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)",
// "Cache Url" => "Cache Url",
// "Cache time in minutes. Default is to use site preference, Set to 0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to 0 for no cache",
// "Text to click on to fetch the url via ajax" => "Text to click on to fetch the url via ajax",
// "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace" => "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace",
// "This data is put in a CODE caption" => "This data is put in a CODE caption",
// "PluginSort" => "PluginSort",
// "Set the sort order of lines of content (default is ascending)" => "Set the sort order of lines of content (default is ascending)",
// "Reverse" => "Reverse",
// "Shuffle" => "Shuffle",
// "PluginSplit" => "PluginSplit",
// "Generate the width attribute for the columns" => "Generate the width attribute for the columns",
// "Column Sizes" => "Column Sizes",
// "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)" => "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
// "Column" => "Column",
// "Custom Class" => "Custom Class",
// "Add a class to customize the design" => "Add a class to customize the design",
// "PluginSQL" => "PluginSQL",
// "Run an SQL query on a database" => "Run an SQL query on a database",
// "The SQL query goes in the body. Example: SELECT column1, column2 FROM table" => "The SQL query goes in the body. Example: SELECT column1, column2 FROM table",
// "DSN Name" => "DSN Name",
// "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php" => "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php",
// "Could not obtain valid DSN connection" => "Could not obtain valid DSN connection",
// "Stat" => "Stat",
// "PluginStat" => "PluginStat",
// "Displays statistics for articles, wiki pages and tracker items" => "Displays statistics for articles, wiki pages and tracker items",
// "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons" => "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons",
// "Article & Tracker Item" => "Article & Tracker Item",
// "Article & Tracker Item & Wiki" => "Article & Tracker Item & Wiki",
// "Article & Wiki" => "Article & Wiki",
// "Article & Wiki & Tracker Item" => "Article & Wiki & Tracker Item",
// "Tracker Item" => "Tracker Item",
// "Tracker Item & Article" => "Tracker Item & Article",
// "Tracker Item & Article & Wiki" => "Tracker Item & Article & Wiki",
// "Tracker Item & Wiki" => "Tracker Item & Wiki",
// "Tracker Item & Wiki & Article" => "Tracker Item & Wiki & Article",
// "Wiki & Article" => "Wiki & Article",
// "Wiki & Article & Tracker Item" => "Wiki & Article & Tracker Item",
// "Wiki & Tracker Item" => "Wiki & Tracker Item",
// "Wiki & Tracker Item & Article" => "Wiki & Tracker Item & Article",
// "Parent ID" => "Parent ID",
// "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)",
// "Last 24 Hours" => "Last 24 Hours",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Added and Viewed" => "Added and Viewed",
// "Viewed & Added" => "Viewed & Added",
// "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last 7 Days" => "Last 7 Days",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Week" => "This Week",
// "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Month" => "Last Month",
// "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Month" => "This Month",
// "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Year" => "Last Year",
// "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Year" => "This Year",
// "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Incorrect parameter: " => "Incorrect parameter: ",
// "PluginSub" => "PluginSub",
// "PluginSubscribeGroup" => "PluginSubscribeGroup",
// "text displyed before the button" => "text displyed before the button",
// "Group name to subscribe to or unsubscribe from" => "Group name to subscribe to or unsubscribe from",
// "Unsubscribe" => "Unsubscribe",
// "PluginSubscribeGroups" => "PluginSubscribeGroups",
// "Text shown in the dropdown box. Default: \"Subscribe to a group\"" => "Text shown in the dropdown box. Default: \"Subscribe to a group\"",
// "Show Subscribe Box" => "Show Subscribe Box",
// "Show the subscribe drop down box (shown by default). Will not show if there are no other groups the user may register for" => "Show the subscribe drop down box (shown by default). Will not show if there are no other groups the user may register for",
// "Show Default" => "Show Default",
// "Shows which group is the user\\'s default group (if any) and allows the user to change his default group" => "Shows which group is the user\\'s default group (if any) and allows the user to change his default group",
// "Group Description" => "Group Description",
// "Show the description of the group (not shown by default)" => "Show the description of the group (not shown by default)",
// "Colon separated list of groups. By default the list of groups available to the user" => "Colon separated list of groups. By default the list of groups available to the user",
// "All groups including this group will be listed" => "All groups including this group will be listed",
// "Default URL" => "Default URL",
// "Page user will be directed to after clicking on icon to change default group" => "Page user will be directed to after clicking on icon to change default group",
// "You do not have permission to subscribe to groups" => "You do not have permission to subscribe to groups",
// "PluginSubscribeNewsletter" => "PluginSubscribeNewsletter",
// "A button to subscribe to a newsletter available for a user if not already in" => "A button to subscribe to a newsletter available for a user if not already in",
// "Invitation message" => "Invitation message",
// "Newsletter ID" => "Newsletter ID",
// "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to" => "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to",
// "Confirmation Message" => "Confirmation Message",
// "Confirmation message after posting form. The plugin body is then the button label" => "Confirmation message after posting form. The plugin body is then the button label",
// "Button label. The plugin body is then the confirmation message" => "Button label. The plugin body is then the confirmation message",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
// "Already subscribed" => "Already subscribed",
// "PluginSup" => "PluginSup",
// "PluginSurvey" => "PluginSurvey",
// "PluginTabs" => "PluginTabs",
// "Display page content in a set of tabs" => "Display page content in a set of tabs",
// "Tabs content separated by /////" => "Tabs content separated by /////",
// "Tabset Name" => "Tabset Name",
// "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs" => "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs",
// "Tab Titles" => "Tab Titles",
// "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3" => "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3",
// "Displays a set of tabs" => "Displays a set of tabs",
// "No tab title specified. At least one has to be set to make the tabs appear" => "No tab title specified. At least one has to be set to make the tabs appear",
// "PluginTag" => "PluginTag",
// "PluginTitleSearch" => "PluginTitleSearch",
// "Also show page hits or user" => "Also show page hits or user",
// "Set to 1 (Yes) to have no header for the search results" => "Set to 1 (Yes) to have no header for the search results",
// "PluginTOC" => "PluginTOC",
// "Displays the table of contents for the current structure\\'s subtree as part of the page content" => "Displays the table of contents for the current structure\\'s subtree as part of the page content",
// "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)" => "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)",
// "Order items in ascending or descending order (deafult is ascending)" => "Order items in ascending or descending order (deafult is ascending)",
// "Show the page description instead of the page name" => "Show the page description instead of the page name",
// "Display the section numbers or not" => "Display the section numbers or not",
// "Apply the \"plain\" or \"fancy\" style" => "Apply the \"plain\" or \"fancy\" style",
// "By default, the table of contents for the current page will be displayed. Alternate page may be provided" => "By default, the table of contents for the current page will be displayed. Alternate page may be provided",
// "PluginTopFriends" => "PluginTopFriends",
// "Maximum result count" => "Maximum result count",
// "Set whether public or not" => "Set whether public or not",
// "PluginTR" => "PluginTR",
// "Translate a string using Tiki translation table" => "Translate a string using Tiki translation table",
// "PluginTracker" => "PluginTracker",
// "Numeric value representing the tracker ID" => "Numeric value representing the tracker ID",
// "Label on the submit button. Default is \"Save\"" => "Label on the submit button. Default is \"Save\"",
// "Display the title of the tracker (not shown by default)" => "Display the title of the tracker (not shown by default)",
// "Show the tracker\\'s description (not shown by default)" => "Show the tracker\\'s description (not shown by default)",
// "Mark Mandatory" => "Mark Mandatory",
// "Indicate mandatory fields with an asterisk (shown by default)" => "Indicate mandatory fields with an asterisk (shown by default)",
// "Show the status of the items (not shown by default)" => "Show the status of the items (not shown by default)",
// "To send an email once the tracker item has been created. Format: from" => "To send an email once the tracker item has been created. Format: from",
// "Email format" => "Email format",
// "Text or html setting" => "Text or html setting",
// "URL the user is sent to after the form is submitted" => "URL the user is sent to after the form is submitted",
// "Url Target" => "Url Target",
// "Set the target parameter for the url (determines whether target will open in a new pge, etc" => "Set the target parameter for the url (determines whether target will open in a new pge, etc",
// "Colon-separated list of default values.for the fields. First value corresponds to first field, second value to second field, etc" => "Colon-separated list of default values.for the fields. First value corresponds to first field, second value to second field, etc",
// "Overwrite current field values of the item with the input values" => "Overwrite current field values of the item with the input values",
// "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default" => "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default",
// "Label for the preview button. Default" => "Label for the preview button. Default",
// "Label for the reset button, to return all fields to their default values" => "Label for the reset button, to return all fields to their default values",
// "reset" => "reset",
// "Status of the item used in combination with" => "Status of the item used in combination with",
// "ItemId allowing for editing an item" => "ItemId allowing for editing an item",
// "Ignore ItemId" => "Ignore ItemId",
// "Do not filter on the parameter itemId if in the url" => "Do not filter on the parameter itemId if in the url",
// "Specify the width in pixels or percentage of the first column (the labels) in the tracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the tracker form",
// "Autosave fields" => "Autosave fields",
// "Colon-separated list of field IDs to be automatically filled with values" => "Colon-separated list of field IDs to be automatically filled with values",
// "Autosavevalue" => "Autosavevalue",
// "Colon-separated values corresponding to autosavefields" => "Colon-separated values corresponding to autosavefields",
// "Registration Fields" => "Registration Fields",
// "Add registration fields such as Username and Password" => "Add registration fields such as Username and Password",
// "Output To Wiki" => "Output To Wiki",
// "Output result to a new wiki page with the name taken from the input for the specified fieldId" => "Output result to a new wiki page with the name taken from the input for the specified fieldId",
// "Discard After Output" => "Discard After Output",
// "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created" => "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created",
// "Template Page" => "Template Page",
// "Name of the wiki page containing the template to format the output to wiki page" => "Name of the wiki page containing the template to format the output to wiki page",
// "Embed the tracker in a form tag" => "Embed the tracker in a form tag",
// "If set to Yes, the tracker is contained in a <form> tag and has action buttons" => "If set to Yes, the tracker is contained in a <form> tag and has action buttons",
// "The page to output the results to already exists. Try another name" => "The page to output the results to already exists. Try another name",
// "The page to output the results to contains the following prohibited characters: \$page_badchars_display. Try another name" => "The page to output the results to contains the following prohibited characters: \$page_badchars_display. Try another name",
// "Passwords do not match" => "Passwords do not match",
// "Item Count" => "Item Count",
// "Determines whether the number of items will be shown (not shown by default)" => "Determines whether the number of items will be shown (not shown by default)",
// "Enter a user name to select the items of the current user" => "Enter a user name to select the items of the current user",
// "a user name" => "a user name",
// "Comments found" => "Comments found",
// "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / \n\t\t\t\t\t\t\t\t and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown;\n\t\t\t\t\t\t\t\t c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= -\n\t\t\t\t\t\t\t\t greater than, less than, greater than or equal, less than or equal. Example" => "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / \n\t\t\t\t\t\t\t\t and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown;\n\t\t\t\t\t\t\t\t c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= -\n\t\t\t\t\t\t\t\t greater than, less than, greater than or equal, less than or equal. Example",
// "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)" => "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)",
// "Show the full list (before filtering) initially (filtered list shown by default)" => "Show the full list (before filtering) initially (filtered list shown by default)",
// "Displays all the filters on the same line (not shown on same line by default)" => "Displays all the filters on the same line (not shown on same line by default)",
// "No Toggle" => "No Toggle",
// "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle" => "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle",
// "Export CSV" => "Export CSV",
// "Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "Label for an export button. Leave blank to show the usual \"Filter\" button instead",
// "Google Map Buttons" => "Google Map Buttons",
// "Display Mapview and Listview buttons" => "Display Mapview and Listview buttons",
// "PluginTrackerFilter" => "PluginTrackerFilter",
// "PluginTrackerItemField" => "PluginTrackerItemField",
// "Numeric value representing the item ID. Default is the user tracker item for the current user" => "Numeric value representing the item ID. Default is the user tracker item for the current user",
// "Numeric value representing the field ID displayed or tested" => "Numeric value representing the field ID displayed or tested",
// "Colon separated list of field IDs. Default is all fields" => "Colon separated list of field IDs. Default is all fields",
// "Status of the tracker item" => "Status of the tracker item",
// "Open & Pending" => "Open & Pending",
// "Open & Closed" => "Open & Closed",
// "Pending & Closed" => "Pending & Closed",
// "Open, Pending & Closed" => "Open, Pending & Closed",
// "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter" => "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter",
// "PluginTrackerList" => "PluginTrackerList",
// "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5",
// "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7" => "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7",
// "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)",
// "Show links to each tracker item (not shown by default)" => "Show links to each tracker item (not shown by default)",
// "Show Item Count" => "Show Item Count",
// "Show the number of items found (not shown by default)" => "Show the number of items found (not shown by default)",
// "Show an alphabetical index by first letter to assist in navigation (not shown by default)" => "Show an alphabetical index by first letter to assist in navigation (not shown by default)",
// "Creation date display is based on tracker settings unless overriden here" => "Creation date display is based on tracker settings unless overriden here",
// "Last Modification Date" => "Last Modification Date",
// "Last modification date display is based on tracker settings unless overriden here" => "Last modification date display is based on tracker settings unless overriden here",
// "Use the field names as column titles (used by default)" => "Use the field names as column titles (used by default)",
// "Show Item Rank" => "Show Item Rank",
// "Show item ranks (not shown by default)" => "Show item ranks (not shown by default)",
// "Only show items matching certain status filters (only items with open status shown by default)" => "Only show items matching certain status filters (only items with open status shown by default)",
// "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: " => "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: ",
// "(replacing fieldId with the field ID number)" => "(replacing fieldId with the field ID number)",
// "Sort Choice" => "Sort Choice",
// "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first" => "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first",
// "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set" => "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set",
// "Offset of first item. Default is no offset" => "Offset of first item. Default is no offset",
// "Show Pagination" => "Show Pagination",
// "Determines whether pagination will be shown (shown by default)" => "Determines whether pagination will be shown (shown by default)",
// "Filter value of the filterfield. For better performance, use exactvalue instead" => "Filter value of the filterfield. For better performance, use exactvalue instead",
// "Exact value of the filter" => "Exact value of the filter",
// "Adds a checkbox on each line to be able to do an action" => "Adds a checkbox on each line to be able to do an action",
// "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown" => "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown",
// "Go directly to tiki-view_tracker_item.php if only one item is found" => "Go directly to tiki-view_tracker_item.php if only one item is found",
// "Show a \\'more\\' button that links to tiki-view_tracker.php (not shown by default)" => "Show a \\'more\\' button that links to tiki-view_tracker.php (not shown by default)",
// "More link pointing to specified URL instead of default tracker item link" => "More link pointing to specified URL instead of default tracker item link",
// "Display only the items of the current user or the current page name" => "Display only the items of the current user or the current page name",
// "Use content of the tpl file as template to display the item" => "Use content of the tpl file as template to display the item",
// "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "Template file in a Wiki page" => "Template file in a Wiki page",
// "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "Will display the items of the specified user" => "Will display the items of the specified user",
// "To restrict the list to these item IDs" => "To restrict the list to these item IDs",
// "Ignore the itemId url parameter when filtering list (not ignored by default)" => "Ignore the itemId url parameter when filtering list (not ignored by default)",
// "The link that will be on each main field" => "The link that will be on each main field",
// "Smarty left delimiter for Latex generation" => "Smarty left delimiter for Latex generation",
// "Smarty right delimiter for Latex generation" => "Smarty right delimiter for Latex generation",
// "List Mode" => "List Mode",
// "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outpits without any HTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outpits without any HTML formatting",
// "Comma Separated Values" => "Comma Separated Values",
// "Show an export button (not shown by default)" => "Show an export button (not shown by default)",
// "Sum or average all the values of a field and displays it at the bottom of the table" => "Sum or average all the values of a field and displays it at the bottom of the table",
// "Silent" => "Silent",
// "Show nothing if no items found (the table header and a \\'No records found\\' message is shown by default)" => "Show nothing if no items found (the table header and a \\'No records found\\' message is shown by default)",
// "Show Delete" => "Show Delete",
// "Show a delete option (not shown by default)" => "Show a delete option (not shown by default)",
// "Show Watch Button" => "Show Watch Button",
// "Show a watch button (not shown by default)" => "Show a watch button (not shown by default)",
// "Show Feed Button" => "Show Feed Button",
// "Show an RSS feed button (not shown by default)" => "Show an RSS feed button (not shown by default)",
// "Show Google Map" => "Show Google Map",
// "Show Google Map of results (not shown by default)" => "Show Google Map of results (not shown by default)",
// "Google Map Icon" => "Google Map Icon",
// "Url of default icon to use for markers on the map" => "Url of default icon to use for markers on the map",
// "Calendar Field IDs" => "Calendar Field IDs",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end",
// "Calendar View Mode" => "Calendar View Mode",
// "Calendar view type time span (default is month)" => "Calendar view type time span (default is month)",
// "Bimester" => "Bimester",
// "Trimester" => "Trimester",
// "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default" => "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default",
// "Beginning of Month" => "Beginning of Month",
// "Set whether calendar will begin at the beginning of the month (does by default)" => "Set whether calendar will begin at the beginning of the month (does by default)",
// "Show calendar navigation bar (shown by default)" => "Show calendar navigation bar (shown by default)",
// "Partial" => "Partial",
// "Calendar Title" => "Calendar Title",
// "Enter a title to display a calendar title (not set by default)" => "Enter a title to display a calendar title (not set by default)",
// "Calendar Delta" => "Calendar Delta",
// "Set the calendar delta that will be shown (not set by default)" => "Set the calendar delta that will be shown (not set by default)",
// "Plus Month" => "Plus Month",
// "Minus Month" => "Minus Month",
// "Plus Bimester" => "Plus Bimester",
// "Minus Bimester" => "Minus Bimester",
// "Display Spreadsheet" => "Display Spreadsheet",
// "Display tracker as a spreadsheet (not used by default)" => "Display tracker as a spreadsheet (not used by default)",
// "Force Compile" => "Force Compile",
// "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)",
// "Period quantity" => "Period quantity",
// "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)" => "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)",
// "Period unit" => "Period unit",
// "Time unit used with \"Period quantity\"" => "Time unit used with \"Period quantity\"",
// "PluginTrackerPrefill" => "PluginTrackerPrefill",
// "Tracker Page Name" => "Tracker Page Name",
// "URL Parameters" => "URL Parameters",
// "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q" => "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q",
// "Field ID for the first field" => "Field ID for the first field",
// "Content that should be used to prefill the field" => "Content that should be used to prefill the field",
// "Field ID for the second field" => "Field ID for the second field",
// "Field ID for the third field" => "Field ID for the third field",
// "Field ID for the fourth field" => "Field ID for the fourth field",
// "Field ID for the fifth field" => "Field ID for the fifth field",
// "PluginTrackerStat" => "PluginTrackerStat",
// "Choose whether to show the percentage of the vote each option received (not shown by default)" => "Choose whether to show the percentage of the vote each option received (not shown by default)",
// "Choose whether to show a bar representing the number of votes each option received (not shown by default)" => "Choose whether to show a bar representing the number of votes each option received (not shown by default)",
// "Only show items matching certain status filters" => "Only show items matching certain status filters",
// "Show Link" => "Show Link",
// "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)" => "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)",
// "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"" => "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"",
// "invalid status" => "invalid status",
// "PluginTrackerTimeline" => "PluginTrackerTimeline",
// "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row",
// "Unit of time to use for the primary scale (default to hour)" => "Unit of time to use for the primary scale (default to hour)",
// "Unit of time to use for the secondary scale (default to empty)" => "Unit of time to use for the secondary scale (default to empty)",
// "Convert the group name to a link" => "Convert the group name to a link",
// "PluginTrade" => "PluginTrade",
// "Send or receive payments from one member to another. (for cclite only so far, experimental)" => "Send or receive payments from one member to another. (for cclite only so far, experimental)",
// "Currency depends on the selected registry" => "Currency depends on the selected registry",
// "Registry to trade in. Default: site preference (or first in list when more than one)" => "Registry to trade in. Default: site preference (or first in list when more than one)",
// "Currency to trade in. Default: Cclite currency preference for registry set above" => "Currency to trade in. Default: Cclite currency preference for registry set above",
// "Other User" => "Other User",
// "Name of the user to recieve or send the payment" => "Name of the user to recieve or send the payment",
// "Leave empty to display an input box" => "Leave empty to display an input box",
// "Offered or wanted item" => "Offered or wanted item",
// "Offered" => "Offered",
// "Wanted" => "Wanted",
// "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted",
// "Please log in" => "Please log in",
// "The user " => "The user ",
// " needs to validate their account" => " needs to validate their account",
// "Transclusion" => "Transclusion",
// "PluginTransclusion" => "PluginTransclusion",
// "Includes the content of a wiki page and replaces values in the body of the included page. All additional parameters will be replaced. For example %%%title%%% will be replaced with the parameter title in the plugin" => "Includes the content of a wiki page and replaces values in the body of the included page. All additional parameters will be replaced. For example %%%title%%% will be replaced with the parameter title in the plugin",
// "Name of the wiki page to use as a template for the values" => "Name of the wiki page to use as a template for the values",
// "Permission Denied" => "Permission Denied",
// "Attempt to include a page that cannot be viewed" => "Attempt to include a page that cannot be viewed",
// "Page named \"%0\" does not exist at this time" => "Page named \"%0\" does not exist at this time",
// "PluginTranslated" => "PluginTranslated",
// "PluginUserCount" => "PluginUserCount",
// "Displays the number of users that are registered or within a group" => "Displays the number of users that are registered or within a group",
// "PluginUserlink" => "PluginUserlink",
// "User account name" => "User account name",
// "User account name (which can be an email address)" => "User account name (which can be an email address)",
// "Display a list of registered users" => "Display a list of registered users",
// "Separator to use between users in the list. Default: comma" => "Separator to use between users in the list. Default: comma",
// "User info" => "User info",
// "User page" => "User page",
// "User pref" => "User pref",
// "Display the user\\'s real name (when available) instead of login name" => "Display the user\\'s real name (when available) instead of login name",
// "Filter on a group" => "Filter on a group",
// "Userpref" => "Userpref",
// "Display wiki text if user has a pref set to a value" => "Display wiki text if user has a pref set to a value",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default" => "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default",
// "Default Label" => "Default Label",
// "Specifies version label to show when displaying the page for the first time. Default label is \\'Default\\'" => "Specifies version label to show when displaying the page for the first time. Default label is \\'Default\\'",
// "Display a Vimeo video" => "Display a Vimeo video",
// "Quality of the video" => "Quality of the video",
// "Full screen" => "Full screen",
// "Expand to full screen" => "Expand to full screen",
// "PluginVote" => "PluginVote",
// "Choose whether to show the voting results (shown by default)" => "Choose whether to show the voting results (shown by default)",
// "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not shown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not shown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set by default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set by default)",
// "Lists \\'\\'wanted\\'\\' wiki pages" => "Lists \\'\\'wanted\\'\\' wiki pages",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)",
// "Ignore" => "Ignore",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "Split By" => "Split By",
// "The character by which ignored patterns are separated" => "The character by which ignored patterns are separated",
// "Skip Extension" => "Skip Extension",
// "Whether to include external wikis in the list (not included by default)" => "Whether to include external wikis in the list (not included by default)",
// "Collect" => "Collect",
// "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column",
// "Switch on debug output with details about the items (debug not on by default)" => "Switch on debug output with details about the items (debug not on by default)",
// "Memory Saver" => "Memory Saver",
// "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell",
// "Comma" => "Comma",
// "Separate Row" => "Separate Row",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site\\'s __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site\\'s __current__ page_regex",
// "Custom" => "Custom",
// "Full" => "Full",
// ", " => ", ",
// "A wildcard pattern of originating pages to be ignored" => "A wildcard pattern of originating pages to be ignored",
// "Watershed" => "Watershed",
// "Viewer for UStream Watershed Embed" => "Viewer for UStream Watershed Embed",
// "Specify archive, broadcaster, chat or viewer" => "Specify archive, broadcaster, chat or viewer",
// "Broadcaster" => "Broadcaster",
// "Viewer" => "Viewer",
// "Channel code" => "Channel code",
// "Specify the channel code to search in the tracker for a channel to use" => "Specify the channel code to search in the tracker for a channel to use",
// "Brand ID" => "Brand ID",
// "Specify the brand id to search in the tracker for a channel to use" => "Specify the brand id to search in the tracker for a channel to use",
// "Brand prefix" => "Brand prefix",
// "Copy the prefix from the chat embed, e.g. Name-of-Brand-" => "Copy the prefix from the chat embed, e.g. Name-of-Brand-",
// "Video ID" => "Video ID",
// "Video ID of archive which can be found in the tracker" => "Video ID of archive which can be found in the tracker",
// "Locale" => "Locale",
// "Locale specified in viewer embed, default is en_US" => "Locale specified in viewer embed, default is en_US",
// "More than one channel found for specified criteria. Please be more specific" => "More than one channel found for specified criteria. Please be more specific",
// "No videoId specified for archive" => "No videoId specified for archive",
// "Web Service" => "Web Service",
// "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface" => "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Display youtube video" => "Display youtube video",
// "Movie" => "Movie",
// "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)" => "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)",
// "Quality of the video. Default is high" => "Quality of the video. Default is high",
// "Show related videos (shown by default)" => "Show related videos (shown by default)",
// "Background" => "Background",
// "Toolbar background color. Use an HTML color code. Example: ffffff" => "Toolbar background color. Use an HTML color code. Example: ffffff",
// "HTML color code, e.g. ffffff" => "HTML color code, e.g. ffffff",
// "Borders" => "Borders",
// "Toolbar border colors. Use an HTML color code. Example: ffffff" => "Toolbar border colors. Use an HTML color code. Example: ffffff",
// "Plugin YouTube error: the movie parameter is empty" => "Plugin YouTube error: the movie parameter is empty",
// "Missing parameter movie to the Youtube plugin" => "Missing parameter movie to the Youtube plugin",
// "Cannot create aliased page" => "Cannot create aliased page",
// "You attempted to create the following page" => "You attempted to create the following page",
// "That page is an alias for the following pages" => "That page is an alias for the following pages",
// "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this" => "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
// "Changed actual version to \$version" => "Changed actual version to \$version",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
// "User %s does not have the permission" => "User %s does not have the permission",
// "The message has been sent to" => "The message has been sent to",
// "The message will be sent to" => "The message will be sent to",
// "User %s does not want to receive messages" => "User %s does not want to receive messages",
// "An error occurred, please check your mail settings and try again" => "An error occurred, please check your mail settings and try again",
// "Message has been sent to: " => "Message has been sent to: ",
// "ERROR: " => "ERROR: ",
// "ERROR: Invalid tab_id received. Numeric format expected, got \$tab_id" => "ERROR: Invalid tab_id received. Numeric format expected, got \$tab_id",
// "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page",
// "Item types filter" => "Item types filter",
// "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes",
// "Possible item type values" => "Possible item type values",
// "Find similar content based on FreeTags" => "Find similar content based on FreeTags",
// "Similar Content Filter" => "Similar Content Filter",
// "Display only similar content of type specified" => "Display only similar content of type specified",
// "Default: \"All Content Type\"" => "Default: \"All Content Type\"",
// "Options: \"article, wiki page, blog post\"" => "Options: \"article, wiki page, blog post\"",
// "Broaden FreeTag Search" => "Broaden FreeTag Search",
// "Find similar content that contains one of the Tags or All of the Tags" => "Find similar content that contains one of the Tags or All of the Tags",
// "Default: \"n - needs to contain all of the Tags\"" => "Default: \"n - needs to contain all of the Tags\"",
// "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"",
// "Google AdSense" => "Google AdSense",
// "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code",
// "Advertisement channel, as optionally provided by Google" => "Advertisement channel, as optionally provided by Google",
// "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
// "Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Global banner format as provided by Google. For example: \"display=468*60_as\"",
// "Background color, as optionally provided by Google" => "Background color, as optionally provided by Google",
// "Border color, as optionally provided by Google" => "Border color, as optionally provided by Google",
// "Link color, as optionally provided by Google" => "Link color, as optionally provided by Google",
// "Text color, as optionally provided by Google" => "Text color, as optionally provided by Google",
// "URL color, as optionally provided by Google" => "URL color, as optionally provided by Google",
// "Shows links to the published articles for each month" => "Shows links to the published articles for each month",
// "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles",
// "Default: \"n\"" => "Default: \"n\"",
// "If set to a category identifier, only consider the articles in the specified category" => "If set to a category identifier, only consider the articles in the specified category",
// "Example value: 13" => "Example value: 13",
// "Topic filter (by names)" => "Topic filter (by names)",
// "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Topic filter (by identifiers)" => "Topic filter (by identifiers)",
// "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values: 13, !13, 1+3, !1+5+7" => "Example values: 13, !13, 1+3, !1+5+7",
// "Types filter" => "Types filter",
// "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered",
// "Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Example values: Event, !Event, Event+Review, !Event+Classified+Article",
// "Language filter" => "Language filter",
// "If set to a language code, only consider the articles in the specified language" => "If set to a language code, only consider the articles in the specified language",
// "Lists all article topics with links to their articles" => "Lists all article topics with links to their articles",
// "Lists the specified number of published articles in the specified order" => "Lists the specified number of published articles in the specified order",
// "Show publication time" => "Show publication time",
// "If set to \"y\", article publication times are shown" => "If set to \"y\", article publication times are shown",
// "Show creation time" => "Show creation time",
// "If set to \"y\", article creation times are shown" => "If set to \"y\", article creation times are shown",
// "Show rating selector" => "Show rating selector",
// "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating",
// "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image" => "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image",
// "If set to a category identifier, only lists the articles in the specified category" => "If set to a category identifier, only lists the articles in the specified category",
// "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed",
// "If set to a language code, only lists the articles in the specified language" => "If set to a language code, only lists the articles in the specified language",
// "Specifies how the articles should be sorted" => "Specifies how the articles should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date",
// "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead",
// "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles",
// "Absolute URL" => "Absolute URL",
// "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example",
// "Displays an assistant to guide new Tiki admins" => "Displays an assistant to guide new Tiki admins",
// "Displays the specified number of the blog post comments most recently added" => "Displays the specified number of the blog post comments most recently added",
// "No date" => "No date",
// "If set to \"y\", the date of comments is not displayed in the module box" => "If set to \"y\", the date of comments is not displayed in the module box",
// "Verbose tooltips" => "Verbose tooltips",
// "If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "If set to \"y\", blog post title is only visible as a tooltip and not displayed",
// "Options: \"y,n\"" => "Options: \"y,n\"",
// "Displays the last Wiki pages visited by the user" => "Displays the last Wiki pages visited by the user",
// "Maximum number of characters in page names allowed before truncating" => "Maximum number of characters in page names allowed before truncating",
// "Includes a calendar or a list of calendar events" => "Includes a calendar or a list of calendar events",
// "Calendars filter" => "Calendars filter",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")",
// "Displayed month (relative)" => "Displayed month (relative)",
// "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span" => "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span",
// "View type" => "View type",
// "Calendar view type time span" => "Calendar view type time span",
// "Show action" => "Show action",
// "Viewmode when clicking on a day" => "Viewmode when clicking on a day",
// "Put a link on all the days , not only those with event" => "Put a link on all the days , not only those with event",
// "View navigation bar" => "View navigation bar",
// "Displays the content of the cart, allows to modify quantities and proceed to payment" => "Displays the content of the cart, allows to modify quantities and proceed to payment",
// "The quantities in your cart were updated" => "The quantities in your cart were updated",
// "The order was recorded and is now awaiting payment. Reference number is %0" => "The order was recorded and is now awaiting payment. Reference number is %0",
// "Displays links to categories as a tree" => "Displays links to categories as a tree",
// "Object type filter" => "Object type filter",
// "Object type filter to apply when accessing a linked category. Example values" => "Object type filter to apply when accessing a linked category. Example values",
// "Deep" => "Deep",
// "Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Show subcategories objects when accessing a linked category. Possible values: on (default), off",
// "PHP Layers menu style" => "PHP Layers menu style",
// "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree" => "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree",
// "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)" => "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)",
// "Show these categories and their children" => "Show these categories and their children",
// "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6",
// "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules" => "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules",
// "Enables to categorize an object" => "Enables to categorize an object",
// "Category identifier" => "Category identifier",
// "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier",
// "Note that the root category is not displayed" => "Note that the root category is not displayed",
// "Defaults to 0 (root)" => "Defaults to 0 (root)",
// "No top" => "No top",
// "In non-detailed view, disallow uncategorizing. Example value: 1" => "In non-detailed view, disallow uncategorizing. Example value: 1",
// "Display path" => "Display path",
// "Instead of category names, diplay their path in the category tree starting from the category root defined" => "Instead of category names, diplay their path in the category tree starting from the category root defined",
// "Example value: 1" => "Example value: 1",
// "Multiple categories" => "Multiple categories",
// "If set to \"n\", only allows categorizing in one category (from those displayed)" => "If set to \"n\", only allows categorizing in one category (from those displayed)",
// "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize",
// "Shy" => "Shy",
// "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default" => "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default",
// "Detailed" => "Detailed",
// "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list",
// "Unassign" => "Unassign",
// "If set to \"n\", the detailed list of categories will not offer to unassign a category" => "If set to \"n\", the detailed list of categories will not offer to unassign a category",
// "If set to \"y\", allow to assign new categories" => "If set to \"y\", allow to assign new categories",
// "Example values: y, n" => "Example values: y, n",
// "Default value: y" => "Default value: y",
// "Default value: n" => "Default value: n",
// "Image URL not in category" => "Image URL not in category",
// "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category",
// "Image URL in category" => "Image URL in category",
// "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category",
// "Categorize %s" => "Categorize %s",
// "Categorize %s in %s" => "Categorize %s in %s",
// "Displays the number of pages received (via Communications)" => "Displays the number of pages received (via Communications)",
// "Shows the credits a user has" => "Shows the credits a user has",
// "Displays the specified number of the directory sites most recently added" => "Displays the specified number of the directory sites most recently added",
// "Directory category identifier" => "Directory category identifier",
// "If set to a directory category identifier, only displays the sites in the specified directory category" => "If set to a directory category identifier, only displays the sites in the specified directory category",
// "If set to \"y\", displays a button labelled \"More\" that links to the directory" => "If set to \"y\", displays a button labelled \"More\" that links to the directory",
// "If set to \"y\", the description of the directory site appears" => "If set to \"y\", the description of the directory site appears",
// "Maximum length of description" => "Maximum length of description",
// "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)",
// "Default: blank" => "Default: blank",
// "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links",
// "Displays the specified number of the directory sites from most visited to least visited" => "Displays the specified number of the directory sites from most visited to least visited",
// "Displays the site\\'s first featured links" => "Displays the site\\'s first featured links",
// "Displays links to file galleries" => "Displays links to file galleries",
// "Displays the specified number of the forum topics with the best ratings" => "Displays the specified number of the forum topics with the best ratings",
// "Displays the latest forum posts" => "Displays the latest forum posts",
// "If set to \"y\", only displays topics" => "If set to \"y\", only displays topics",
// "List of forum IDs" => "List of forum IDs",
// "Post only from this forum" => "Post only from this forum",
// "Displays the specified number of the forums with the most comments" => "Displays the specified number of the forums with the most comments",
// "Displays the specified number of the forum topics with the most reads" => "Displays the specified number of the forum topics with the most reads",
// "Displays the specified number of the forums with the most visits" => "Displays the specified number of the forums with the most visits",
// "Shows current freetags and enables to add and remove some if permissions allow" => "Shows current freetags and enables to add and remove some if permissions allow",
// "Displays current freetags on wiki pages and enables to add tags if permissions allow" => "Displays current freetags on wiki pages and enables to add tags if permissions allow",
// "Shows content with multiple freetags in common" => "Shows content with multiple freetags in common",
// "Type of objects to extract" => "Type of objects to extract",
// "Similar pages" => "Similar pages",
// "Shows the most popular freetags. More popularity is indicated by a larger font" => "Shows the most popular freetags. More popularity is indicated by a larger font",
// "Display type" => "Display type",
// "If set to \"cloud\", links are displayed as a cloud" => "If set to \"cloud\", links are displayed as a cloud",
// "Default: \"list\"" => "Default: \"list\"",
// "Maximum elements" => "Maximum elements",
// "If set to a number, limits the number of tags displayed" => "If set to a number, limits the number of tags displayed",
// "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font" => "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font",
// "My preferred tags" => "My preferred tags",
// "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site",
// "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site" => "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site",
// "Emulate Groups" => "Emulate Groups",
// "Displays the specified number of last actions" => "Displays the specified number of last actions",
// "Show user" => "Show user",
// "If set to \"y\", user names are displayed in the module box" => "If set to \"y\", user names are displayed in the module box",
// "Show date" => "Show date",
// "If set to \"y\", action dates are displayed in the module box" => "If set to \"y\", action dates are displayed in the module box",
// "Maximum number of characters in action descriptions before truncating" => "Maximum number of characters in action descriptions before truncating",
// "Lists the specified number of blogs posts from newest to oldest" => "Lists the specified number of blogs posts from newest to oldest",
// "If set to \"y\", the date of posts is not displayed in the module box" => "If set to \"y\", the date of posts is not displayed in the module box",
// "Blog identifier" => "Blog identifier",
// "If set to a blog identifier, restricts the blog posts to those in the identified blog" => "If set to a blog identifier, restricts the blog posts to those in the identified blog",
// "Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Lists the specified number of objects of the given type in the given category, starting from the most recently created",
// "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed",
// "Maximum number of characters in object names allowed before truncating" => "Maximum number of characters in object names allowed before truncating",
// "Type of the objects to list. Example values" => "Type of the objects to list. Example values",
// "no object here yet" => "no object here yet",
// "Displays the specified number of blogs from newest to oldest" => "Displays the specified number of blogs from newest to oldest",
// "Displays the specified number of FAQs from newest to oldest" => "Displays the specified number of FAQs from newest to oldest",
// "Displays the specified number of quizzes from newest to oldest" => "Displays the specified number of quizzes from newest to oldest",
// "Displays the specified number of file galleries, starting from the most recently modified" => "Displays the specified number of file galleries, starting from the most recently modified",
// "List the specified number of files, starting from the most recently added" => "List the specified number of files, starting from the most recently added",
// "Gallery identifiers" => "Gallery identifiers",
// "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers",
// "Example value: 13, 2:13, 1:2:3:5:6" => "Example value: 13, 2:13, 1:2:3:5:6",
// "Displays the specified number of image galleries, starting from the most recently modified" => "Displays the specified number of image galleries, starting from the most recently modified",
// "List the specified number of images, starting from the most recently added" => "List the specified number of images, starting from the most recently added",
// "Gallery identifier" => "Gallery identifier",
// "If set to an image gallery identifier, restricts the images to those in the identified gallery" => "If set to an image gallery identifier, restricts the images to those in the identified gallery",
// "Link content" => "Link content",
// "Display the links as image names or thumbnails" => "Display the links as image names or thumbnails",
// "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"",
// "Displays the specified number of calendar events, starting from the most recently modified" => "Displays the specified number of calendar events, starting from the most recently modified",
// "Calendar identifier" => "Calendar identifier",
// "If set to a calendar identifier, restricts the events to those in the identified calendar" => "If set to a calendar identifier, restricts the events to those in the identified calendar",
// "Maximum number of characters in event names allowed before truncating" => "Maximum number of characters in event names allowed before truncating",
// "If set to \"y\", it will hide date" => "If set to \"y\", it will hide date",
// "Don't show date" => "Don't show date",
// "Lists the specified number of pages, starting from the most recently modified" => "Lists the specified number of pages, starting from the most recently modified",
// "Link target" => "Link target",
// "Target URL of the \"...more\" link at the bottom of the module" => "Target URL of the \"...more\" link at the bottom of the module",
// "Displays the specified number of blogs, starting from the most recently modified" => "Displays the specified number of blogs, starting from the most recently modified",
// "Displays Podcasts" => "Displays Podcasts",
// "File galleries IDs" => "File galleries IDs",
// "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned",
// "Width of mediaplayer in pixels. Default is 190" => "Width of mediaplayer in pixels. Default is 190",
// "height" => "height",
// "Height of mediaplayer in pixels. Default is 20" => "Height of mediaplayer in pixels. Default is 20",
// "mediaplayer" => "mediaplayer",
// "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)",
// "Bottom Link URL" => "Bottom Link URL",
// "URL for a link at bottom of module" => "URL for a link at bottom of module",
// "Bottom Link URL Text" => "Bottom Link URL Text",
// "Text for link if Bottom Link URL is set. Default is \"More Podcasts\"" => "Text for link if Bottom Link URL is set. Default is \"More Podcasts\"",
// "Verbose" => "Verbose",
// "Display description of podcast below player if \"y\", and on title mouseover if \"n\". Default is \"y\"" => "Display description of podcast below player if \"y\", and on title mouseover if \"n\". Default is \"y\"",
// "Lists the specified number of article submissions from newest to oldest" => "Lists the specified number of article submissions from newest to oldest",
// "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted",
// "Tracker identifier" => "Tracker identifier",
// "If set to a tracker identifier, only displays the comments on the given tracker" => "If set to a tracker identifier, only displays the comments on the given tracker",
// "Item identifier" => "Item identifier",
// "If set to an item identifier, only displays the comments on the given item" => "If set to an item identifier, only displays the comments on the given item",
// "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required",
// "Identifier of the tracker from which items are listed" => "Identifier of the tracker from which items are listed",
// "Field identifier" => "Field identifier",
// "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored",
// "Field name" => "Field name",
// "Name of the field from which values are listed" => "Name of the field from which values are listed",
// "Example value: age" => "Example value: age",
// "Specifies how the items should be sorted" => "Specifies how the items should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date",
// "Status filter" => "Status filter",
// "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values",
// "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set",
// "You do not have permission to view this tracker" => "You do not have permission to view this tracker",
// "Displays the specified number of validated questions FAQs from newest to oldest" => "Displays the specified number of validated questions FAQs from newest to oldest",
// "Faq identifier" => "Faq identifier",
// "If set to a faq identifier, restricts the chosen questions to those in the identified faq" => "If set to a faq identifier, restricts the chosen questions to those in the identified faq",
// "Displays information about the specified number of users in decreasing order of last login time" => "Displays information about the specified number of users in decreasing order of last login time",
// "Show avatars" => "Show avatars",
// "If set to \"y\", show user avatars" => "If set to \"y\", show user avatars",
// "Maximum number of characters in user names allowed before truncating" => "Maximum number of characters in user names allowed before truncating",
// "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console",
// "Login box" => "Login box",
// "Input size" => "Input size",
// "Number of characters for username and password input fields" => "Number of characters for username and password input fields",
// "Site logo, title and subtitle" => "Site logo, title and subtitle",
// "Displays a Wiki page" => "Displays a Wiki page",
// "Page to display in the menu. Example value: HomePage" => "Page to display in the menu. Example value: HomePage",
// "Menu structure" => "Menu structure",
// "Displays a structure" => "Displays a structure",
// "Structure to display in the menu" => "Structure to display in the menu",
// "Displays to users their number of new inter-user messages and a link to their message box" => "Displays to users their number of new inter-user messages and a link to their message box",
// "Show If Empty" => "Show If Empty",
// "Show the module when there are no messages waiting. y|n " => "Show the module when there are no messages waiting. y|n ",
// "Default=y" => "Default=y",
// "Small live chat box" => "Small live chat box",
// "Channels" => "Channels",
// "List of chat channels. Channel names are separated by a comma (\",\")" => "List of chat channels. Channel names are separated by a comma (\",\")",
// "By default, a single channel named \"default\" exists" => "By default, a single channel named \"default\" exists",
// "Links to the objects of a given type for the current month and those preceding it" => "Links to the objects of a given type for the current month and those preceding it",
// "Type of objects to link to" => "Type of objects to link to",
// "\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" for blog posts, \"cms\" for published articles",
// "Object identifier" => "Object identifier",
// "Identifier of an object with children to link to" => "Identifier of an object with children to link to",
// "This is required for the blog Object type" => "This is required for the blog Object type",
// "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3",
// "List by month" => "List by month",
// "Displays the most commented objects of a certain type" => "Displays the most commented objects of a certain type",
// "Type of objects to consider" => "Type of objects to consider",
// "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)",
// "Object language filter" => "Object language filter",
// "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language",
// "Displays the number of article submissions waiting examination and a link to the list" => "Displays the number of article submissions waiting examination and a link to the list",
// "Displays the specified number of old articles (which do not show on articles home page anymore)" => "Displays the specified number of old articles (which do not show on articles home page anymore)",
// "Enables to change current perspective" => "Enables to change current perspective",
// "Enables to quickly create or edit Wiki pages" => "Enables to quickly create or edit Wiki pages",
// "Template identifier" => "Template identifier",
// "If set to a template identifier, the specified template is used for creating new Wiki pages" => "If set to a template identifier, the specified template is used for creating new Wiki pages",
// "If set, send the form to the given location (relative to Tiki\\'s root) for processing" => "If set, send the form to the given location (relative to Tiki\\'s root) for processing",
// "SUBMIT label" => "SUBMIT label",
// "The label on the button to submit the form" => "The label on the button to submit the form",
// "INPUT SIZE" => "INPUT SIZE",
// "Size attribute (horizontal, in characters) of the text input fields for page names and description. The size of the other fields is relative to the module width" => "Size attribute (horizontal, in characters) of the text input fields for page names and description. The size of the other fields is relative to the module width",
// "Optional heading to display at the top of the module\\'s content" => "Optional heading to display at the top of the module\\'s content",
// "If set to a category identifier, pages created through the module are automatically categorized only in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized only in the specified category",
// "Category to preselect" => "Category to preselect",
// "If set, pages created through the module have this category prechecked to be categorized in" => "If set, pages created through the module have this category prechecked to be categorized in",
// "Tip to be shown" => "Tip to be shown",
// "Custom text to be shown as a tip at the top of the edit page" => "Custom text to be shown as a tip at the top of the edit page",
// "Title of tip to be shown" => "Title of tip to be shown",
// "Custom title to be shown for the tip at the top of the edit page" => "Custom title to be shown for the tip at the top of the edit page",
// "Custom header template" => "Custom header template",
// "Wiki page to be used as a template to show content on top of edit page" => "Wiki page to be used as a template to show content on top of edit page",
// "input field for copy/paste" => "input field for copy/paste",
// "If set to 1 , a text area for copy/paste page content is shown" => "If set to 1 , a text area for copy/paste page content is shown",
// "show description field" => "show description field",
// "If set to 1, a text field to enter the page description is shown (requires feature_wiki_description)" => "If set to 1, a text field to enter the page description is shown (requires feature_wiki_description)",
// "choose category" => "choose category",
// "If set to 1, this allows the user to choose a category instead of preselecting one" => "If set to 1, this allows the user to choose a category instead of preselecting one",
// "Displays a random image" => "Displays a random image",
// "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery",
// "Show link" => "Show link",
// "If set to \"n\", the image thumbnail does not link to the image" => "If set to \"n\", the image thumbnail does not link to the image",
// "Default: \"y\"" => "Default: \"y\"",
// "Show name" => "Show name",
// "If set to \"y\", the name of the image is displayed" => "If set to \"y\", the name of the image is displayed",
// "If set to \"y\", the description of the image is displayed" => "If set to \"y\", the description of the image is displayed",
// "Displays the specified number of random wiki pages" => "Displays the specified number of random wiki pages",
// "New user registrationmore tiki-re" => "New user registrationmore tiki-re",
// "List of feeds available on this site" => "List of feeds available on this site",
// "Multi-purpose search module (go or edit page by name and/or search site)" => "Multi-purpose search module (go or edit page by name and/or search site)",
// "Legacy Mode" => "Legacy Mode",
// "Setting to emulate previous behaviour" => "Setting to emulate previous behaviour",
// " (\"search\"=search_box, \"page\"=search_wiki_page, \"quick\"=quick_edit)" => " (\"search\"=search_box, \"page\"=search_wiki_page, \"quick\"=quick_edit)",
// "If set to \"y\" the search performed is a \"Tiki search\"" => "If set to \"y\" the search performed is a \"Tiki search\"",
// " (full text search)" => " (full text search)",
// "Show Search Filter" => "Show Search Filter",
// "If set to \"y\" shows a dropdown of sections to search" => "If set to \"y\" shows a dropdown of sections to search",
// " (no object filter)" => " (no object filter)",
// "Use autocomplete" => "Use autocomplete",
// "If set to \"y\" input uses autocomplete for pagenames if applicable" => "If set to \"y\" input uses autocomplete for pagenames if applicable",
// " (use autocomplete)" => " (use autocomplete)",
// "Use advanced (boolean) search (full text search only)" => "Use advanced (boolean) search (full text search only)",
// " (use advanced search)" => " (use advanced search)",
// "Advanced search checkbox" => "Advanced search checkbox",
// "Show advanced search checkbox (full text search only)" => "Show advanced search checkbox (full text search only)",
// " (advanced search checkbox off)" => " (advanced search checkbox off)",
// "Advanced search help" => "Advanced search help",
// "Show advanced search help icon (full text search only)" => "Show advanced search help icon (full text search only)",
// " (advanced search help off)" => " (advanced search help off)",
// "Show Search Button" => "Show Search Button",
// "Show search button" => "Show search button",
// " (do show search button)" => " (do show search button)",
// "Show Go Button" => "Show Go Button",
// "Show go to page button" => "Show go to page button",
// " (do show go button)" => " (do show go button)",
// "Show Edit Button" => "Show Edit Button",
// "Show edit button" => "Show edit button",
// " (do show edit button)" => " (do show edit button)",
// "Default Button" => "Default Button",
// "Action to perform on entering <return>" => "Action to perform on entering <return>",
// " (search|go|edit)" => " (search|go|edit)",
// "Edit Submit Label" => "Edit Submit Label",
// "Size attribute (horizontal, in characters) of the text input field" => "Size attribute (horizontal, in characters) of the text input field",
// "Size of the Search Filter dropdown list" => "Size of the Search Filter dropdown list",
// "Edit Template identifier" => "Edit Template identifier",
// "If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized in the specified category",
// "If set, send the form to the given location (relative to Tiki's root) for processing" => "If set, send the form to the given location (relative to Tiki's root) for processing",
// "Optional heading to display at the top of the module's content" => "Optional heading to display at the top of the module's content",
// "Titles" => "Titles",
// "Small search form (for wiki, articles, blogs, etc.)" => "Small search form (for wiki, articles, blogs, etc.)",
// "If set to \"y\", the search performed is a \"Tiki search\"" => "If set to \"y\", the search performed is a \"Tiki search\"",
// "Search for a wiki page by name" => "Search for a wiki page by name",
// "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages" => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages",
// "Tooltip" => "Tooltip",
// "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content",
// "Label on the button to post a message" => "Label on the button to post a message",
// "Wait label" => "Wait label",
// "Label on the button to post a message when the message is being posted if AJAX is enabled" => "Label on the button to post a message when the message is being posted if AJAX is enabled",
// "Maximum messages shown" => "Maximum messages shown",
// "Number of messages to display" => "Number of messages to display",
// "Tweet" => "Tweet",
// "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via twitter" => "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via twitter",
// "Facebook" => "Facebook",
// "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his facebook wall" => "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his facebook wall",
// "Please wait.." => "Please wait..",
// "Displays to logged in users the number of new or updated objects since their last login date and time" => "Displays to logged in users the number of new or updated objects since their last login date and time",
// "Displays to logged in users new or updated objects since a point in time, by default their last login date and time" => "Displays to logged in users new or updated objects since a point in time, by default their last login date and time",
// "Show users" => "Show users",
// "If set to \"n\", do not show new users" => "If set to \"n\", do not show new users",
// "Show trackers" => "Show trackers",
// "If set to \"n\", do not show tracker changes" => "If set to \"n\", do not show tracker changes",
// "Calendar focus" => "Calendar focus",
// "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar",
// "Show date as a calendar link" => "Show date as a calendar link",
// "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)" => "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)",
// "Fold sections by default" => "Fold sections by default",
// "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)",
// "Use Jquery presentation" => "Use Jquery presentation",
// "If set to \"y\", it will use jquery to show the result" => "If set to \"y\", it will use jquery to show the result",
// " (archived)" => " (archived)",
// "Displays a language picker to change the language of the site" => "Displays a language picker to change the language of the site",
// "Display mode" => "Display mode",
// "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist",
// "Prefix" => "Prefix",
// "Changes the default displayed prefix from \\\"Site Language:\\\"" => "Changes the default displayed prefix from \\\"Site Language:\\\"",
// "Enables to quickly change the theme" => "Enables to quickly change the theme",
// "Support for multilingual terminology" => "Support for multilingual terminology",
// "Root category" => "Root category",
// "All terms will automatically be put in that category. " => "All terms will automatically be put in that category. ",
// "Note that the category must already exist. " => "Note that the category must already exist. ",
// "Defaults to \\'Term\\'" => "Defaults to \\'Term\\'",
// "Tiki test suite helper" => "Tiki test suite helper",
// "Displays the specified number of blogs with links to them, from the most active one to the least" => "Displays the specified number of blogs with links to them, from the most active one to the least",
// "Blog activity measurement can be more or less accurate" => "Blog activity measurement can be more or less accurate",
// "Lists the specified number of articles with links to them, from the most visited one to the least" => "Lists the specified number of articles with links to them, from the most visited one to the least",
// "Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Displays the specified number of file galleries with links to them, starting with the one with most hits",
// "Displays the specified number of files with links to them, starting with the one with most hits" => "Displays the specified number of files with links to them, starting with the one with most hits",
// "Displays the specified number of users who posted to forums, starting with the one having most posts" => "Displays the specified number of users who posted to forums, starting with the one having most posts",
// "Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Displays the specified number of image galleries with links to them, starting with the one with most hits",
// "Displays the specified number of images with links to them, from the most visited one to the least" => "Displays the specified number of images with links to them, from the most visited one to the least",
// "Displays the specified number of objects, starting with the one having the most hits" => "Displays the specified number of objects, starting with the one having the most hits",
// "Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Displays the specified number of wiki pages with links to them, starting with the one having the most hits",
// "Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Displays the specified number of quizzes with links to them, starting with the one having the most hits",
// "Displays the specified number of blogs with links to them, from the most visited one to the least" => "Displays the specified number of blogs with links to them, from the most visited one to the least",
// "Show Last Post" => "Show Last Post",
// "Displays the specified number of FAQs with links to them, from the most visited one to the least" => "Displays the specified number of FAQs with links to them, from the most visited one to the least",
// "Display the fieldId of a tracker" => "Display the fieldId of a tracker",
// "Textarea rows" => "Textarea rows",
// "Textarea cols" => "Textarea cols",
// "Max fields" => "Max fields",
// "Tracker Help" => "Tracker Help",
// "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed",
// "Reference language" => "Reference language",
// "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed",
// "Show language" => "Show language",
// "If \"y\" the page language will be shown instead of the page name" => "If \"y\" the page language will be shown instead of the page name",
// "Default = \"y\"" => "Default = \"y\"",
// "Lists the specified number of calendar events, ordered by their start date" => "Lists the specified number of calendar events, ordered by their start date",
// "Maximum days in the future" => "Maximum days in the future",
// "Maximum distance to event start dates in days (looking forward)" => "Maximum distance to event start dates in days (looking forward)",
// "Maximum days in the past" => "Maximum days in the past",
// "Maximum distance to event end dates in days (looking backward)" => "Maximum distance to event end dates in days (looking backward)",
// "cellpadding" => "cellpadding",
// "cellspacing" => "cellspacing",
// "If set to \"y\", event descriptions are displayed" => "If set to \"y\", event descriptions are displayed",
// "Show end date and time" => "Show end date and time",
// "If set to \"y\", event end dates and times are displayed, when appropriate" => "If set to \"y\", event end dates and times are displayed, when appropriate",
// "Use custom calendar background colors" => "Use custom calendar background colors",
// "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)" => "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)",
// "Show information in tooltips" => "Show information in tooltips",
// "If set to \"n\", event tooltips will not display event information" => "If set to \"n\", event tooltips will not display event information",
// "Date format" => "Date format",
// "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
// "site preference for short date format followed by site preference for short time format" => "site preference for short date format followed by site preference for short time format",
// "If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "If set to an integer, event names are allowed that number of characters as a maximum before being truncated",
// "Displays to registered users their blogs" => "Displays to registered users their blogs",
// "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed",
// "Displays to registered users their image galleries" => "Displays to registered users their image galleries",
// "Displays to registered users the specified number of wiki pages which they were the last to edit" => "Displays to registered users the specified number of wiki pages which they were the last to edit",
// "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations",
// "The task title must have at least 3 characters" => "The task title must have at least 3 characters",
// "Lists the public user tasks of a chosen group, with links to tasks" => "Lists the public user tasks of a chosen group, with links to tasks",
// "User and Group tracker links" => "User and Group tracker links",
// "Displays the specified number of users and their score, starting from the one with the highest score" => "Displays the specified number of users and their score, starting from the one with the highest score",
// "Webmail Inbox" => "Webmail Inbox",
// "Displays Webmail Inbox" => "Displays Webmail Inbox",
// "Account Id" => "Account Id",
// "Webmail account identifier (if not set uses user\\'s current account)" => "Webmail account identifier (if not set uses user\\'s current account)",
// "GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Group (e.g. \"Help Team\")",
// "GroupMail: Tracker Id (to store GroupMail activity)" => "GroupMail: Tracker Id (to store GroupMail activity)",
// "GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: From Field (Id of field in tracker to store email From header)",
// "GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id of field in tracker to store email Subject header)",
// "GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Message Field (Id of field in tracker to store email message identifier)",
// "GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Content Field (Id of field in tracker to store email message body content)",
// "GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: Account Field (Id of field in tracker to store Webmail account name)",
// "DateTime Field Id" => "DateTime Field Id",
// "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)",
// "GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Operator Field (Id of field in tracker to store operator name (username))",
// "Maximum number of characters in subjects allowed before truncating" => "Maximum number of characters in subjects allowed before truncating",
// "Webmail error" => "Webmail error",
// "No accounts set up (or no current account set)" => "No accounts set up (or no current account set)",
// "Lists objects which share a category with the viewed object" => "Lists objects which share a category with the viewed object",
// "Displays information about users currently logged in" => "Displays information about users currently logged in",
// "Content to display" => "Content to display",
// "Display the number of users logged in, the list of users logged in, or both" => "Display the number of users logged in, the list of users logged in, or both",
// "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"",
// "Cluster mode" => "Cluster mode",
// "If set to \"1\", separate users based on which host/server they logged on" => "If set to \"1\", separate users based on which host/server they logged on",
// "Lists the specified number of comments starting from the most recently posted" => "Lists the specified number of comments starting from the most recently posted",
// "More in tooltips" => "More in tooltips",
// "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip" => "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip",
// "Type of the objects from which comments will be listed. Possible values" => "Type of the objects from which comments will be listed. Possible values",
// "Last article comments" => "Last article comments",
// "Last wiki comments" => "Last wiki comments",
// "YouTube" => "YouTube",
// "Displays YouTube videos and/or a link to a YouTube user\\'s page" => "Displays YouTube videos and/or a link to a YouTube user\\'s page",
// "Video identifiers" => "Video identifiers",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
// "YouTube user identifier" => "YouTube user identifier",
// "If set to a YouTube user identifier, display a link to the videos of this user" => "If set to a YouTube user identifier, display a link to the videos of this user",
// "Width of each video in pixels" => "Width of each video in pixels",
// "Height of each video in pixels" => "Height of each video in pixels",
// "Videos on YouTube" => "Videos on YouTube",
// "No Playlist found" => "No Playlist found",
// "No Playlist ID was provided" => "No Playlist ID was provided",
// "Invalid server key" => "Invalid server key",
// "Cookie not found" => "Cookie not found",
// "Can create/admin calendars" => "Can create/admin calendars",
// "Can add events in the calendar" => "Can add events in the calendar",
// "Can change events in the calendar" => "Can change events in the calendar",
// "Can browse the calendar" => "Can browse the calendar",
// "Can view events details" => "Can view events details",
// "Can add own user to the participants" => "Can add own user to the participants",
// "Can add guest to the participants" => "Can add guest to the participants",
// "Can view Tiki tools calendar" => "Can view Tiki tools calendar",
// "Administrator, can create channels remove channels etc" => "Administrator, can create channels remove channels etc",
// "Can use the chat system" => "Can use the chat system",
// "Can admin the articles" => "Can admin the articles",
// "Can approve submissions" => "Can approve submissions",
// "Can admin article topics" => "Can admin article topics",
// "Can admin article types" => "Can admin article types",
// "Can read article headings" => "Can read article headings",
// "Submitted articles automatically approved" => "Submitted articles automatically approved",
// "Can edit articles" => "Can edit articles",
// "Can edit submissions" => "Can edit submissions",
// "Can read articles" => "Can read articles",
// "Can remove submissions" => "Can remove submissions",
// "Can rate articles" => "Can rate articles",
// "Can read a topic (Applies only to individual topic perms)" => "Can read a topic (Applies only to individual topic perms)",
// "Can admin contributions" => "Can admin contributions",
// "Can admin the directory" => "Can admin the directory",
// "Can admin directory categories" => "Can admin directory categories",
// "Can admin directory sites" => "Can admin directory sites",
// "Submitted links are valid" => "Submitted links are valid",
// "Can submit sites to the directory" => "Can submit sites to the directory",
// "Can validate submitted links" => "Can validate submitted links",
// "Can suggest faq questions" => "Can suggest faq questions",
// "Administrator, can manage users groups and permissions, and all features" => "Administrator, can manage users groups and permissions, and all features",
// "Can view referrer stats" => "Can view referrer stats",
// "Can admin blogs" => "Can admin blogs",
// "Can assign perms to blog" => "Can assign perms to blog",
// "Can post to a blog" => "Can post to a blog",
// "Can create a blog" => "Can create a blog",
// "Can view in module and feed the blog posts" => "Can view in module and feed the blog posts",
// "Can view in module and feed the blog" => "Can view in module and feed the blog",
// "Can report posts to moderator" => "Can report posts to moderator",
// "Can admin freetags" => "Can admin freetags",
// "Can admin Image Galleries" => "Can admin Image Galleries",
// "Can assign perms to image gallery" => "Can assign perms to image gallery",
// "Can upload zip files with images" => "Can upload zip files with images",
// "Can create image galleries" => "Can create image galleries",
// "Can tag objects" => "Can tag objects",
// "Can list image galleries" => "Can list image galleries",
// "Can unassign tags from an object" => "Can unassign tags from an object",
// "Can upload images" => "Can upload images",
// "Can view image galleries" => "Can view image galleries",
// "Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Can subscribe many e-mails at once (requires tiki_p_subscribe email)",
// "Can subscribe any email to newsletters" => "Can subscribe any email to newsletters",
// "Can subscribe to newsletters" => "Can subscribe to newsletters",
// "Can view the archive of a newsletters" => "Can view the archive of a newsletters",
// "Can admin polls" => "Can admin polls",
// "Can view poll results" => "Can view poll results",
// "Can admin quizzes" => "Can admin quizzes",
// "Can take quizzes" => "Can take quizzes",
// "Can view quiz stats" => "Can view quiz stats",
// "Can view user quiz results" => "Can view user quiz results",
// "Can admin sheet" => "Can admin sheet",
// "Can create and edit sheets" => "Can create and edit sheets",
// "Can view sheet history" => "Can view sheet history",
// "Can admin shoutbox (Edit/remove messages)" => "Can admin shoutbox (Edit/remove messages)",
// "Can post messages in shoutbox" => "Can post messages in shoutbox",
// "Can view shoutbox" => "Can view shoutbox",
// "Can admin surveys" => "Can admin surveys",
// "Can take surveys" => "Can take surveys",
// "Can view survey stats" => "Can view survey stats",
// "Can attach files to tracker items" => "Can attach files to tracker items",
// "Can insert comments for tracker items" => "Can insert comments for tracker items",
// "Can view tracker items comments" => "Can view tracker items comments",
// "Can create new items for trackers" => "Can create new items for trackers",
// "Can list trackers" => "Can list trackers",
// "Can change tracker items" => "Can change tracker items",
// "Can change pending tracker items" => "Can change pending tracker items",
// "Can change closed tracker items" => "Can change closed tracker items",
// "Can view rating result for tracker items" => "Can view rating result for tracker items",
// "Can vote a rating for tracker items" => "Can vote a rating for tracker items",
// "Can re-vote a rating for tracker items" => "Can re-vote a rating for tracker items",
// "Can view trackers" => "Can view trackers",
// "Can view closed trackers items" => "Can view closed trackers items",
// "Can view pending trackers items" => "Can view pending trackers items",
// "Can watch tracker" => "Can watch tracker",
// "Can export tracker items" => "Can export tracker items",
// "Can edit copyright notices" => "Can edit copyright notices",
// "Can create and edit structures" => "Can create and edit structures",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
// "Can admin attachments on wiki pages" => "Can admin attachments on wiki pages",
// "Can add and change ratings on wiki pages" => "Can add and change ratings on wiki pages",
// "Can attach files to wiki pages" => "Can attach files to wiki pages",
// "Can view wiki attachments and download" => "Can view wiki attachments and download",
// "Can view rating of wiki pages" => "Can view rating of wiki pages",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
// "Can admin received articles" => "Can admin received articles",
// "Can admin received pages" => "Can admin received pages",
// "Can send articles to other sites" => "Can send articles to other sites",
// "Can send articles to this site" => "Can send articles to this site",
// "Can send pages to this site" => "Can send pages to this site",
// "Can send pages to other sites" => "Can send pages to other sites",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay the TikiTests" => "Can replay the TikiTests",
// "Can configure modules" => "Can configure modules",
// "Can use the mini event calendar" => "Can use the mini event calendar",
// "Can use the notepad" => "Can use the notepad",
// "Can admin public tasks" => "Can admin public tasks",
// "Can receive tasks from other users" => "Can receive tasks from other users",
// "Can send tasks to other users" => "Can send tasks to other users",
// "Can upload personal files" => "Can upload personal files",
// "Can create items in personal menu" => "Can create items in personal menu",
// "Can admin content templates" => "Can admin content templates",
// "Can edit content templates" => "Can edit content templates",
// "Can use content templates" => "Can use content templates",
// "Can edit HTML pages" => "Can edit HTML pages",
// "Can view HTML pages" => "Can view HTML pages",
// "Can list registered users" => "Can list registered users",
// "Admin live support system" => "Admin live support system",
// "Can use live support system" => "Can use live support system",
// "Can create new mapfile" => "Can create new mapfile",
// "Can edit mapfiles" => "Can edit mapfiles",
// "Can view mapfiles" => "Can view mapfiles",
// "Can view contents of mapfiles" => "Can view contents of mapfiles",
// "Can use webmail" => "Can use webmail",
// "Can use group webmail" => "Can use group webmail",
// "Can admin group webmail accounts" => "Can admin group webmail accounts",
// "Can use personal webmail accounts" => "Can use personal webmail accounts",
// "Can admin personal webmail accounts" => "Can admin personal webmail accounts",
// "Can invite user to my groups" => "Can invite user to my groups",
// "Can delete his/her own account" => "Can delete his/her own account",
// "Can use the importer" => "Can use the importer",
// "Can see the category in a listing" => "Can see the category in a listing",
// "Can change the categories of the object" => "Can change the categories of the object",
// "Can add objects to the category" => "Can add objects to the category",
// "Can remove objects from the category" => "Can remove objects from the category",
// "Can create new categories" => "Can create new categories",
// "Can view the perspective" => "Can view the perspective",
// "Can edit the perspective" => "Can edit the perspective",
// "Can create a perspective" => "Can create a perspective",
// "Can trigger the transition between two states" => "Can trigger the transition between two states",
// "Can admin kaltura feature" => "Can admin kaltura feature",
// "Can upload video on kaltura server" => "Can upload video on kaltura server",
// "Can edit information of kaltura entry" => "Can edit information of kaltura entry",
// "Can create kaltura remix video" => "Can create kaltura remix video",
// "Can delete kaltura entry" => "Can delete kaltura entry",
// "Can download kaltura entry" => "Can download kaltura entry",
// "Can list kaltura entries" => "Can list kaltura entries",
// "Can view kaltura entry" => "Can view kaltura entry",
// "Can administer payments" => "Can administer payments",
// "Can view payment requests and details" => "Can view payment requests and details",
// "Can enter manual payments" => "Can enter manual payments",
// "Can request a payment" => "Can request a payment",
// "User can administer modules" => "User can administer modules",
// "Can save a .CSV backup of entire trackers" => "Can save a .CSV backup of entire trackers",
// "Can join a meeting" => "Can join a meeting",
// "Can moderate a meeting" => "Can moderate a meeting",
// "Can create a meeting" => "Can create a meeting",
// "user can register this site with social networks" => "user can register this site with social networks",
// "Can invite users by email, and include them in groups" => "Can invite users by email, and include them in groups",
// "tiki release" => "tiki release",
// "feature version checks" => "feature version checks",
// "tiki needs upgrade" => "tiki needs upgrade",
// "tiki version last check" => "tiki version last check",
// "tiki version check frequency" => "tiki version check frequency",
// "lastUpdatePrefs" => "lastUpdatePrefs",
// "tiki domain prefix" => "tiki domain prefix",
// "tiki domain redirects" => "tiki domain redirects",
// "feature print indexed" => "feature print indexed",
// "groups are emulated" => "groups are emulated",
// "feature webdav" => "feature webdav",
// "feature wiki" => "feature wiki",
// "default wiki diff style" => "default wiki diff style",
// "feature backlinks" => "feature backlinks",
// "backlinks name len" => "backlinks name len",
// "feature dump" => "feature dump",
// "feature history" => "feature history",
// "feature page contribution" => "feature page contribution",
// "feature lastChanges" => "feature lastChanges",
// "feature likePages" => "feature likePages",
// "feature listPages" => "feature listPages",
// "feature listorphanPages" => "feature listorphanPages",
// "feature listorphanStructure" => "feature listorphanStructure",
// "feature page title" => "feature page title",
// "wiki page name above" => "wiki page name above",
// "feature sandbox" => "feature sandbox",
// "feature warn on edit" => "feature warn on edit",
// "feature wiki 1like redirection" => "feature wiki 1like redirection",
// "feature wiki allowhtml" => "feature wiki allowhtml",
// "feature wiki argvariable" => "feature wiki argvariable",
// "feature wiki attachments" => "feature wiki attachments",
// "feature wiki comments" => "feature wiki comments",
// "feature wiki description" => "feature wiki description",
// "feature wiki discuss" => "feature wiki discuss",
// "feature wiki export" => "feature wiki export",
// "feature wiki structure" => "feature wiki structure",
// "feature wiki import page" => "feature wiki import page",
// "feature wiki footnotes" => "feature wiki footnotes",
// "feature wiki icache" => "feature wiki icache",
// "feature wiki import html" => "feature wiki import html",
// "feature wiki mindmap" => "feature wiki mindmap",
// "feature wiki monosp" => "feature wiki monosp",
// "feature wiki multiprint" => "feature wiki multiprint",
// "feature wiki notepad" => "feature wiki notepad",
// "feature wiki make structure" => "feature wiki make structure",
// "feature wiki open as structure" => "feature wiki open as structure",
// "feature wiki pageid" => "feature wiki pageid",
// "feature wiki paragraph formatting" => "feature wiki paragraph formatting",
// "feature wiki paragraph formatting add br" => "feature wiki paragraph formatting add br",
// "feature wiki pictures" => "feature wiki pictures",
// "feature wiki plurals" => "feature wiki plurals",
// "feature wiki print" => "feature wiki print",
// "feature wiki protect email" => "feature wiki protect email",
// "feature wiki rankings" => "feature wiki rankings",
// "feature wiki ratings" => "feature wiki ratings",
// "wiki simple ratings" => "wiki simple ratings",
// "wiki simple ratings options" => "wiki simple ratings options",
// "feature wiki replace" => "feature wiki replace",
// "feature wiki show hide before" => "feature wiki show hide before",
// "feature wiki tables" => "feature wiki tables",
// "feature wiki templates" => "feature wiki templates",
// "feature wiki undo" => "feature wiki undo",
// "feature wiki userpage" => "feature wiki userpage",
// "feature wiki userpage prefix" => "feature wiki userpage prefix",
// "feature wiki usrlock" => "feature wiki usrlock",
// "feature wiki feedback polls" => "feature wiki feedback polls",
// "feature wiki save draft" => "feature wiki save draft",
// "feature wikiwords" => "feature wikiwords",
// "feature wikiwords usedash" => "feature wikiwords usedash",
// "feature wiki pagealias" => "feature wiki pagealias",
// "mailin autocheck" => "mailin autocheck",
// "mailin autocheckFreq" => "mailin autocheckFreq",
// "mailin autocheckLast" => "mailin autocheckLast",
// "page bar position" => "page bar position",
// "warn on edit time" => "warn on edit time",
// "wikiHomePage" => "wikiHomePage",
// "wikiLicensePage" => "wikiLicensePage",
// "wikiSubmitNotice" => "wikiSubmitNotice",
// "wiki authors style" => "wiki authors style",
// "wiki authors style by page" => "wiki authors style by page",
// "wiki show version" => "wiki show version",
// "wiki bot bar" => "wiki bot bar",
// "wiki cache" => "wiki cache",
// "wiki comments default ordering" => "wiki comments default ordering",
// "wiki comments displayed default" => "wiki comments displayed default",
// "wiki comments per page" => "wiki comments per page",
// "wiki comments allow per page" => "wiki comments allow per page",
// "wiki creator admin" => "wiki creator admin",
// "wiki feature copyrights" => "wiki feature copyrights",
// "wiki forum id" => "wiki forum id",
// "wiki left column" => "wiki left column",
// "wiki list backlinks" => "wiki list backlinks",
// "wiki list comment" => "wiki list comment",
// "wiki list comment len" => "wiki list comment len",
// "wiki list description" => "wiki list description",
// "wiki list description len" => "wiki list description len",
// "wiki list creator" => "wiki list creator",
// "wiki list hits" => "wiki list hits",
// "wiki list lastmodif" => "wiki list lastmodif",
// "wiki list lastver" => "wiki list lastver",
// "wiki list links" => "wiki list links",
// "wiki list name" => "wiki list name",
// "wiki list name len" => "wiki list name len",
// "wiki list size" => "wiki list size",
// "wiki list status" => "wiki list status",
// "wiki list user" => "wiki list user",
// "wiki list versions" => "wiki list versions",
// "wiki list language" => "wiki list language",
// "wiki list categories" => "wiki list categories",
// "wiki list categories path" => "wiki list categories path",
// "wiki list id" => "wiki list id",
// "wiki list sortorder" => "wiki list sortorder",
// "wiki list sortdirection" => "wiki list sortdirection",
// "wiki pagealias tokens" => "wiki pagealias tokens",
// "wiki prefixalias tokens" => "wiki prefixalias tokens",
// "wiki page regex" => "wiki page regex",
// "wiki page separator" => "wiki page separator",
// "wiki page navigation bar" => "wiki page navigation bar",
// "wiki actions bar" => "wiki actions bar",
// "wiki pagename strip" => "wiki pagename strip",
// "wiki right column" => "wiki right column",
// "wiki structure bar position" => "wiki structure bar position",
// "wiki top bar" => "wiki top bar",
// "wiki topline position" => "wiki topline position",
// "wiki uses slides" => "wiki uses slides",
// "wiki watch author" => "wiki watch author",
// "wiki watch comments" => "wiki watch comments",
// "wiki watch editor" => "wiki watch editor",
// "wiki watch minor" => "wiki watch minor",
// "feature wiki history full" => "feature wiki history full",
// "feature wiki categorize structure" => "feature wiki categorize structure",
// "feature wiki watch structure" => "feature wiki watch structure",
// "feature wikiapproval" => "feature wikiapproval",
// "wikiapproval prefix" => "wikiapproval prefix",
// "wikiapproval hideprefix" => "wikiapproval hideprefix",
// "wikiapproval delete staging" => "wikiapproval delete staging",
// "wikiapproval master group" => "wikiapproval master group",
// "wikiapproval staging category" => "wikiapproval staging category",
// "wikiapproval approved category" => "wikiapproval approved category",
// "wikiapproval outofsync category" => "wikiapproval outofsync category",
// "wikiapproval block editapproved" => "wikiapproval block editapproved",
// "wikiapproval sync categories" => "wikiapproval sync categories",
// "wikiapproval update freetags" => "wikiapproval update freetags",
// "wikiapproval combine freetags" => "wikiapproval combine freetags",
// "wiki edit section" => "wiki edit section",
// "wiki edit section level" => "wiki edit section level",
// "wiki edit icons toggle" => "wiki edit icons toggle",
// "wiki edit plugin" => "wiki edit plugin",
// "wiki validate plugin" => "wiki validate plugin",
// "wiki edit minor" => "wiki edit minor",
// "wiki badchar prevent" => "wiki badchar prevent",
// "wiki backlinks name len" => "wiki backlinks name len",
// "wiki ranking reload probability" => "wiki ranking reload probability",
// "wiki encourage contribution" => "wiki encourage contribution",
// "wiki timeout warning" => "wiki timeout warning",
// "wiki dynvar style" => "wiki dynvar style",
// "wiki dynvar multilingual" => "wiki dynvar multilingual",
// "wiki keywords" => "wiki keywords",
// "wiki likepages samelang only" => "wiki likepages samelang only",
// "wiki mandatory edit summary" => "wiki mandatory edit summary",
// "wikiplugin addtocart" => "wikiplugin addtocart",
// "wikiplugin addtogooglecal" => "wikiplugin addtogooglecal",
// "wikiplugin agentinfo" => "wikiplugin agentinfo",
// "wikiplugin alink" => "wikiplugin alink",
// "wikiplugin aname" => "wikiplugin aname",
// "wikiplugin annotation" => "wikiplugin annotation",
// "wikiplugin archivebuilder" => "wikiplugin archivebuilder",
// "wikiplugin article" => "wikiplugin article",
// "wikiplugin articles" => "wikiplugin articles",
// "wikiplugin attach" => "wikiplugin attach",
// "wikiplugin attributes" => "wikiplugin attributes",
// "wikiplugin author" => "wikiplugin author",
// "wikiplugin avatar" => "wikiplugin avatar",
// "wikiplugin back" => "wikiplugin back",
// "wikiplugin backlinks" => "wikiplugin backlinks",
// "wikiplugin banner" => "wikiplugin banner",
// "wikiplugin bigbluebutton" => "wikiplugin bigbluebutton",
// "wikiplugin bliptv" => "wikiplugin bliptv",
// "wikiplugin bloglist" => "wikiplugin bloglist",
// "wikiplugin box" => "wikiplugin box",
// "wikiplugin button" => "wikiplugin button",
// "wikiplugin calendar" => "wikiplugin calendar",
// "wikiplugin category" => "wikiplugin category",
// "wikiplugin catorphans" => "wikiplugin catorphans",
// "wikiplugin cclite" => "wikiplugin cclite",
// "wikiplugin catpath" => "wikiplugin catpath",
// "wikiplugin center" => "wikiplugin center",
// "wikiplugin chart" => "wikiplugin chart",
// "wikiplugin code" => "wikiplugin code",
// "wikiplugin colorbox" => "wikiplugin colorbox",
// "wikiplugin content" => "wikiplugin content",
// "wikiplugin cookie" => "wikiplugin cookie",
// "wikiplugin copyright" => "wikiplugin copyright",
// "wikiplugin countdown" => "wikiplugin countdown",
// "wikiplugin datachannel" => "wikiplugin datachannel",
// "wikiplugin dbreport" => "wikiplugin dbreport",
// "wikiplugin div" => "wikiplugin div",
// "wikiplugin dl" => "wikiplugin dl",
// "wikiplugin draw" => "wikiplugin draw",
// "wikiplugin equation" => "wikiplugin equation",
// "wikiplugin events" => "wikiplugin events",
// "wikiplugin fade" => "wikiplugin fade",
// "wikiplugin fancylist" => "wikiplugin fancylist",
// "wikiplugin fancytable" => "wikiplugin fancytable",
// "wikiplugin file" => "wikiplugin file",
// "wikiplugin files" => "wikiplugin files",
// "wikiplugin flash" => "wikiplugin flash",
// "wikiplugin footnote" => "wikiplugin footnote",
// "wikiplugin footnotearea" => "wikiplugin footnotearea",
// "wikiplugin freetagged" => "wikiplugin freetagged",
// "wikiplugin ftp" => "wikiplugin ftp",
// "wikiplugin gauge" => "wikiplugin gauge",
// "wikiplugin googleanalytics" => "wikiplugin googleanalytics",
// "wikiplugin googledoc" => "wikiplugin googledoc",
// "wikiplugin googlemap" => "wikiplugin googlemap",
// "wikiplugin group" => "wikiplugin group",
// "wikiplugin grouplist" => "wikiplugin grouplist",
// "wikiplugin groupmailcore" => "wikiplugin groupmailcore",
// "wikiplugin groupstat" => "wikiplugin groupstat",
// "wikiplugin html" => "wikiplugin html",
// "wikiplugin iframe" => "wikiplugin iframe",
// "wikiplugin img" => "wikiplugin img",
// "wikiplugin image" => "wikiplugin image",
// "wikiplugin include" => "wikiplugin include",
// "wikiplugin randominclude" => "wikiplugin randominclude",
// "wikiplugin invite" => "wikiplugin invite",
// "wikiplugin jabber" => "wikiplugin jabber",
// "wikiplugin js" => "wikiplugin js",
// "wikiplugin jq" => "wikiplugin jq",
// "wikiplugin lang" => "wikiplugin lang",
// "wikiplugin lastmod" => "wikiplugin lastmod",
// "wikiplugin listpages" => "wikiplugin listpages",
// "wikiplugin lsdir" => "wikiplugin lsdir",
// "wikiplugin mail" => "wikiplugin mail",
// "wikiplugin map" => "wikiplugin map",
// "wikiplugin mcalendar" => "wikiplugin mcalendar",
// "wikiplugin mediaplayer" => "wikiplugin mediaplayer",
// "wikiplugin memberlist" => "wikiplugin memberlist",
// "wikiplugin memberpayment" => "wikiplugin memberpayment",
// "wikiplugin miniquiz" => "wikiplugin miniquiz",
// "wikiplugin module" => "wikiplugin module",
// "wikiplugin mono" => "wikiplugin mono",
// "wikiplugin mouseover" => "wikiplugin mouseover",
// "wikiplugin mwtable" => "wikiplugin mwtable",
// "wikiplugin myspace" => "wikiplugin myspace",
// "wikiplugin objecthits" => "wikiplugin objecthits",
// "wikiplugin payment" => "wikiplugin payment",
// "wikiplugin perm" => "wikiplugin perm",
// "wikiplugin picture" => "wikiplugin picture",
// "wikiplugin pluginmanager" => "wikiplugin pluginmanager",
// "wikiplugin poll" => "wikiplugin poll",
// "wikiplugin profile" => "wikiplugin profile",
// "wikiplugin proposal" => "wikiplugin proposal",
// "wikiplugin quote" => "wikiplugin quote",
// "wikiplugin rcontent" => "wikiplugin rcontent",
// "wikiplugin realnamelist" => "wikiplugin realnamelist",
// "wikiplugin redirect" => "wikiplugin redirect",
// "wikiplugin regex" => "wikiplugin regex",
// "wikiplugin remarksbox" => "wikiplugin remarksbox",
// "wikiplugin rss" => "wikiplugin rss",
// "wikiplugin scroll" => "wikiplugin scroll",
// "wikiplugin sf" => "wikiplugin sf",
// "wikiplugin share" => "wikiplugin share",
// "wikiplugin sharethis" => "wikiplugin sharethis",
// "wikiplugin sheet" => "wikiplugin sheet",
// "wikiplugin showpages" => "wikiplugin showpages",
// "wikiplugin skype" => "wikiplugin skype",
// "wikiplugin smarty" => "wikiplugin smarty",
// "wikiplugin snarf" => "wikiplugin snarf",
// "wikiplugin snarf cache" => "wikiplugin snarf cache",
// "wikiplugin sort" => "wikiplugin sort",
// "wikiplugin split" => "wikiplugin split",
// "wikiplugin sql" => "wikiplugin sql",
// "wikiplugin stat" => "wikiplugin stat",
// "wikiplugin sub" => "wikiplugin sub",
// "wikiplugin subscribegroup" => "wikiplugin subscribegroup",
// "wikiplugin subscribegroups" => "wikiplugin subscribegroups",
// "wikiplugin subscribenewsletter" => "wikiplugin subscribenewsletter",
// "wikiplugin sup" => "wikiplugin sup",
// "wikiplugin survey" => "wikiplugin survey",
// "wikiplugin tag" => "wikiplugin tag",
// "wikiplugin tabs" => "wikiplugin tabs",
// "wikiplugin thumb" => "wikiplugin thumb",
// "wikiplugin titlesearch" => "wikiplugin titlesearch",
// "wikiplugin toc" => "wikiplugin toc",
// "wikiplugin topfriends" => "wikiplugin topfriends",
// "wikiplugin trackercomments" => "wikiplugin trackercomments",
// "wikiplugin trackerfilter" => "wikiplugin trackerfilter",
// "wikiplugin trackeritemfield" => "wikiplugin trackeritemfield",
// "wikiplugin trackerlist" => "wikiplugin trackerlist",
// "wikiplugin trackertimeline" => "wikiplugin trackertimeline",
// "wikiplugin tracker" => "wikiplugin tracker",
// "wikiplugin trackerprefill" => "wikiplugin trackerprefill",
// "wikiplugin trackerstat" => "wikiplugin trackerstat",
// "wikiplugin trade" => "wikiplugin trade",
// "wikiplugin transclude" => "wikiplugin transclude",
// "wikiplugin translated" => "wikiplugin translated",
// "wikiplugin tr" => "wikiplugin tr",
// "wikiplugin usercount" => "wikiplugin usercount",
// "wikiplugin userlink" => "wikiplugin userlink",
// "wikiplugin userlist" => "wikiplugin userlist",
// "wikiplugin userpref" => "wikiplugin userpref",
// "wikiplugin versions" => "wikiplugin versions",
// "wikiplugin vimeo" => "wikiplugin vimeo",
// "wikiplugin vote" => "wikiplugin vote",
// "wikiplugin watershed" => "wikiplugin watershed",
// "wikiplugin wantedpages" => "wikiplugin wantedpages",
// "wikiplugin webservice" => "wikiplugin webservice",
// "wikiplugin youtube" => "wikiplugin youtube",
// "wikiplugininline addtocart" => "wikiplugininline addtocart",
// "wikiplugininline addtogooglecal" => "wikiplugininline addtogooglecal",
// "wikiplugininline agentinfo" => "wikiplugininline agentinfo",
// "wikiplugininline alink" => "wikiplugininline alink",
// "wikiplugininline aname" => "wikiplugininline aname",
// "wikiplugininline annotation" => "wikiplugininline annotation",
// "wikiplugininline archivebuilder" => "wikiplugininline archivebuilder",
// "wikiplugininline article" => "wikiplugininline article",
// "wikiplugininline articles" => "wikiplugininline articles",
// "wikiplugininline attach" => "wikiplugininline attach",
// "wikiplugininline attributes" => "wikiplugininline attributes",
// "wikiplugininline avatar" => "wikiplugininline avatar",
// "wikiplugininline back" => "wikiplugininline back",
// "wikiplugininline backlinks" => "wikiplugininline backlinks",
// "wikiplugininline banner" => "wikiplugininline banner",
// "wikiplugininline bigbluebutton" => "wikiplugininline bigbluebutton",
// "wikiplugininline bliptv" => "wikiplugininline bliptv",
// "wikiplugininline bloglist" => "wikiplugininline bloglist",
// "wikiplugininline box" => "wikiplugininline box",
// "wikiplugininline button" => "wikiplugininline button",
// "wikiplugininline calendar" => "wikiplugininline calendar",
// "wikiplugininline category" => "wikiplugininline category",
// "wikiplugininline catorphans" => "wikiplugininline catorphans",
// "wikiplugininline catpath" => "wikiplugininline catpath",
// "wikiplugininline cclite" => "wikiplugininline cclite",
// "wikiplugininline center" => "wikiplugininline center",
// "wikiplugininline chart" => "wikiplugininline chart",
// "wikiplugininline code" => "wikiplugininline code",
// "wikiplugininline colorbox" => "wikiplugininline colorbox",
// "wikiplugininline content" => "wikiplugininline content",
// "wikiplugininline cookie" => "wikiplugininline cookie",
// "wikiplugininline copyright" => "wikiplugininline copyright",
// "wikiplugininline countdown" => "wikiplugininline countdown",
// "wikiplugininline datachannel" => "wikiplugininline datachannel",
// "wikiplugininline dbreport" => "wikiplugininline dbreport",
// "wikiplugininline div" => "wikiplugininline div",
// "wikiplugininline dl" => "wikiplugininline dl",
// "wikiplugininline draw" => "wikiplugininline draw",
// "wikiplugininline equation" => "wikiplugininline equation",
// "wikiplugininline events" => "wikiplugininline events",
// "wikiplugininline fade" => "wikiplugininline fade",
// "wikiplugininline fancylist" => "wikiplugininline fancylist",
// "wikiplugininline fancytable" => "wikiplugininline fancytable",
// "wikiplugininline file" => "wikiplugininline file",
// "wikiplugininline files" => "wikiplugininline files",
// "wikiplugininline flash" => "wikiplugininline flash",
// "wikiplugininline footnote" => "wikiplugininline footnote",
// "wikiplugininline footnotearea" => "wikiplugininline footnotearea",
// "wikiplugininline freetagged" => "wikiplugininline freetagged",
// "wikiplugininline ftp" => "wikiplugininline ftp",
// "wikiplugininline gauge" => "wikiplugininline gauge",
// "wikiplugininline googleanalytics" => "wikiplugininline googleanalytics",
// "wikiplugininline googledoc" => "wikiplugininline googledoc",
// "wikiplugininline googlemap" => "wikiplugininline googlemap",
// "wikiplugininline group" => "wikiplugininline group",
// "wikiplugininline grouplist" => "wikiplugininline grouplist",
// "wikiplugininline groupmailcore" => "wikiplugininline groupmailcore",
// "wikiplugininline groupstat" => "wikiplugininline groupstat",
// "wikiplugininline html" => "wikiplugininline html",
// "wikiplugininline iframe" => "wikiplugininline iframe",
// "wikiplugininline img" => "wikiplugininline img",
// "wikiplugininline image" => "wikiplugininline image",
// "wikiplugininline include" => "wikiplugininline include",
// "wikiplugininline invite" => "wikiplugininline invite",
// "wikiplugininline jabber" => "wikiplugininline jabber",
// "wikiplugininline js" => "wikiplugininline js",
// "wikiplugininline jq" => "wikiplugininline jq",
// "wikiplugininline lang" => "wikiplugininline lang",
// "wikiplugininline lastmod" => "wikiplugininline lastmod",
// "wikiplugininline listpages" => "wikiplugininline listpages",
// "wikiplugininline lsdir" => "wikiplugininline lsdir",
// "wikiplugininline mail" => "wikiplugininline mail",
// "wikiplugininline map" => "wikiplugininline map",
// "wikiplugininline mcalendar" => "wikiplugininline mcalendar",
// "wikiplugininline mediaplayer" => "wikiplugininline mediaplayer",
// "wikiplugininline memberlist" => "wikiplugininline memberlist",
// "wikiplugininline memberpayment" => "wikiplugininline memberpayment",
// "wikiplugininline miniquiz" => "wikiplugininline miniquiz",
// "wikiplugininline module" => "wikiplugininline module",
// "wikiplugininline mono" => "wikiplugininline mono",
// "wikiplugininline mouseover" => "wikiplugininline mouseover",
// "wikiplugininline mwtable" => "wikiplugininline mwtable",
// "wikiplugininline myspace" => "wikiplugininline myspace",
// "wikiplugininline objecthits" => "wikiplugininline objecthits",
// "wikiplugininline payment" => "wikiplugininline payment",
// "wikiplugininline perm" => "wikiplugininline perm",
// "wikiplugininline picture" => "wikiplugininline picture",
// "wikiplugininline pluginmanager" => "wikiplugininline pluginmanager",
// "wikiplugininline poll" => "wikiplugininline poll",
// "wikiplugininline profile" => "wikiplugininline profile",
// "wikiplugininline proposal" => "wikiplugininline proposal",
// "wikiplugininline quote" => "wikiplugininline quote",
// "wikiplugininline rcontent" => "wikiplugininline rcontent",
// "wikiplugininline randominclude" => "wikiplugininline randominclude",
// "wikiplugininline realnamelist" => "wikiplugininline realnamelist",
// "wikiplugininline redirect" => "wikiplugininline redirect",
// "wikiplugininline regex" => "wikiplugininline regex",
// "wikiplugininline remarksbox" => "wikiplugininline remarksbox",
// "wikiplugininline rss" => "wikiplugininline rss",
// "wikiplugininline scroll" => "wikiplugininline scroll",
// "wikiplugininline sf" => "wikiplugininline sf",
// "wikiplugininline share" => "wikiplugininline share",
// "wikiplugininline sharethis" => "wikiplugininline sharethis",
// "wikiplugininline sheet" => "wikiplugininline sheet",
// "wikiplugininline showpages" => "wikiplugininline showpages",
// "wikiplugininline skype" => "wikiplugininline skype",
// "wikiplugininline smarty" => "wikiplugininline smarty",
// "wikiplugininline snarf" => "wikiplugininline snarf",
// "wikiplugininline sort" => "wikiplugininline sort",
// "wikiplugininline split" => "wikiplugininline split",
// "wikiplugininline sql" => "wikiplugininline sql",
// "wikiplugininline stat" => "wikiplugininline stat",
// "wikiplugininline sub" => "wikiplugininline sub",
// "wikiplugininline subscribegroup" => "wikiplugininline subscribegroup",
// "wikiplugininline subscribegroups" => "wikiplugininline subscribegroups",
// "wikiplugininline subscribenewsletter" => "wikiplugininline subscribenewsletter",
// "wikiplugininline sup" => "wikiplugininline sup",
// "wikiplugininline survey" => "wikiplugininline survey",
// "wikiplugininline tag" => "wikiplugininline tag",
// "wikiplugininline tabs" => "wikiplugininline tabs",
// "wikiplugininline thumb" => "wikiplugininline thumb",
// "wikiplugininline titlesearch" => "wikiplugininline titlesearch",
// "wikiplugininline toc" => "wikiplugininline toc",
// "wikiplugininline topfriends" => "wikiplugininline topfriends",
// "wikiplugininline trackercomments" => "wikiplugininline trackercomments",
// "wikiplugininline trackerfilter" => "wikiplugininline trackerfilter",
// "wikiplugininline trackeritemfield" => "wikiplugininline trackeritemfield",
// "wikiplugininline trackerlist" => "wikiplugininline trackerlist",
// "wikiplugininline trackertimeline" => "wikiplugininline trackertimeline",
// "wikiplugininline tracker" => "wikiplugininline tracker",
// "wikiplugininline trackerprefill" => "wikiplugininline trackerprefill",
// "wikiplugininline trackerstat" => "wikiplugininline trackerstat",
// "wikiplugininline trade" => "wikiplugininline trade",
// "wikiplugininline transclude" => "wikiplugininline transclude",
// "wikiplugininline translated" => "wikiplugininline translated",
// "wikiplugininline tr" => "wikiplugininline tr",
// "wikiplugininline usercount" => "wikiplugininline usercount",
// "wikiplugininline userlink" => "wikiplugininline userlink",
// "wikiplugininline userlist" => "wikiplugininline userlist",
// "wikiplugininline userpref" => "wikiplugininline userpref",
// "wikiplugininline versions" => "wikiplugininline versions",
// "wikiplugininline vimeo" => "wikiplugininline vimeo",
// "wikiplugininline vote" => "wikiplugininline vote",
// "wikiplugininline watershed" => "wikiplugininline watershed",
// "wikiplugininline wantedpages" => "wikiplugininline wantedpages",
// "wikiplugininline webservice" => "wikiplugininline webservice",
// "wikiplugininline youtube" => "wikiplugininline youtube",
// "wikiplugininline author" => "wikiplugininline author",
// "webservice consume defaultcache" => "webservice consume defaultcache",
// "feature webservices" => "feature webservices",
// "feature semantic" => "feature semantic",
// "feature wysiwyg" => "feature wysiwyg",
// "wysiwyg optional" => "wysiwyg optional",
// "wysiwyg default" => "wysiwyg default",
// "wysiwyg memo" => "wysiwyg memo",
// "wysiwyg wiki parsed" => "wysiwyg wiki parsed",
// "wysiwyg wiki semi parsed" => "wysiwyg wiki semi parsed",
// "wysiwyg toolbar skin" => "wysiwyg toolbar skin",
// "wysiwyg htmltowiki" => "wysiwyg htmltowiki",
// "wysiwyg fonts" => "wysiwyg fonts",
// "wiki feature 3d" => "wiki feature 3d",
// "wiki 3d width" => "wiki 3d width",
// "wiki 3d height" => "wiki 3d height",
// "wiki 3d navigation depth" => "wiki 3d navigation depth",
// "wiki 3d feed animation interval" => "wiki 3d feed animation interval",
// "wiki 3d existing page color" => "wiki 3d existing page color",
// "wiki 3d missing page color" => "wiki 3d missing page color",
// "feature blogs" => "feature blogs",
// "blog list order" => "blog list order",
// "home blog" => "home blog",
// "feature blog rankings" => "feature blog rankings",
// "blog comments default ordering" => "blog comments default ordering",
// "blog comments per page" => "blog comments per page",
// "feature blogposts comments" => "feature blogposts comments",
// "blog list user" => "blog list user",
// "blog list title" => "blog list title",
// "blog list title len" => "blog list title len",
// "blog list description" => "blog list description",
// "blog list created" => "blog list created",
// "blog list lastmodif" => "blog list lastmodif",
// "blog list posts" => "blog list posts",
// "blog list visits" => "blog list visits",
// "blog list activity" => "blog list activity",
// "feature blog mandatory category" => "feature blog mandatory category",
// "feature blog heading" => "feature blog heading",
// "feature blog edit publish date" => "feature blog edit publish date",
// "feature blog sharethis" => "feature blog sharethis",
// "blog sharethis publisher" => "blog sharethis publisher",
// "feature file galleries" => "feature file galleries",
// "home file gallery" => "home file gallery",
// "fgal root id" => "fgal root id",
// "fgal use db" => "fgal use db",
// "fgal batch dir" => "fgal batch dir",
// "fgal match regex" => "fgal match regex",
// "fgal nmatch regex" => "fgal nmatch regex",
// "fgal use dir" => "fgal use dir",
// "fgal podcast dir" => "fgal podcast dir",
// "feature file galleries comments" => "feature file galleries comments",
// "file galleries comments default ordering" => "file galleries comments default ordering",
// "file galleries comments per page" => "file galleries comments per page",
// "feature file galleries batch" => "feature file galleries batch",
// "feature file galleries rankings" => "feature file galleries rankings",
// "fgal enable auto indexing" => "fgal enable auto indexing",
// "fgal asynchronous indexing" => "fgal asynchronous indexing",
// "fgal allow duplicates" => "fgal allow duplicates",
// "fgal sort mode" => "fgal sort mode",
// "feature file galleries author" => "feature file galleries author",
// "fgal list id" => "fgal list id",
// "fgal list type" => "fgal list type",
// "fgal list name" => "fgal list name",
// "fgal list description" => "fgal list description",
// "fgal list size" => "fgal list size",
// "fgal list created" => "fgal list created",
// "fgal list lastModif" => "fgal list lastModif",
// "fgal list creator" => "fgal list creator",
// "fgal list author" => "fgal list author",
// "fgal list last user" => "fgal list last user",
// "fgal list comment" => "fgal list comment",
// "fgal list files" => "fgal list files",
// "fgal list hits" => "fgal list hits",
// "fgal list lastDownload" => "fgal list lastDownload",
// "fgal list lockedby" => "fgal list lockedby",
// "fgal show path" => "fgal show path",
// "fgal show explorer" => "fgal show explorer",
// "fgal show slideshow" => "fgal show slideshow",
// "fgal default view" => "fgal default view",
// "fgal limit hits per file" => "fgal limit hits per file",
// "fgal prevent negative score" => "fgal prevent negative score",
// "fgal quota" => "fgal quota",
// "fgal quota per fgal" => "fgal quota per fgal",
// "fgal quota default" => "fgal quota default",
// "fgal quota show" => "fgal quota show",
// "fgal list backlinks" => "fgal list backlinks",
// "fgal search in content" => "fgal search in content",
// "fgal search" => "fgal search",
// "fgal delete after" => "fgal delete after",
// "fgal delete after email" => "fgal delete after email",
// "fgal list id admin" => "fgal list id admin",
// "fgal list type admin" => "fgal list type admin",
// "fgal list name admin" => "fgal list name admin",
// "fgal list description admin" => "fgal list description admin",
// "fgal list size admin" => "fgal list size admin",
// "fgal list created admin" => "fgal list created admin",
// "fgal list lastModif admin" => "fgal list lastModif admin",
// "fgal list creator admin" => "fgal list creator admin",
// "fgal list author admin" => "fgal list author admin",
// "fgal list last user admin" => "fgal list last user admin",
// "fgal list comment admin" => "fgal list comment admin",
// "fgal list files admin" => "fgal list files admin",
// "fgal list hits admin" => "fgal list hits admin",
// "fgal list lastDownload admin" => "fgal list lastDownload admin",
// "fgal list lockedby admin" => "fgal list lockedby admin",
// "fgal list backlinks admin" => "fgal list backlinks admin",
// "fgal keep fileId" => "fgal keep fileId",
// "fgal show thumbactions" => "fgal show thumbactions",
// "fgal thumb max size" => "fgal thumb max size",
// "feature galleries" => "feature galleries",
// "feature gal batch" => "feature gal batch",
// "feature gal slideshow" => "feature gal slideshow",
// "home gallery" => "home gallery",
// "gal use db" => "gal use db",
// "gal use lib" => "gal use lib",
// "gal match regex" => "gal match regex",
// "gal nmatch regex" => "gal nmatch regex",
// "gal use dir" => "gal use dir",
// "gal batch dir" => "gal batch dir",
// "feature gal rankings" => "feature gal rankings",
// "feature image galleries comments" => "feature image galleries comments",
// "image galleries comments default order" => "image galleries comments default order",
// "image galleries comments per page" => "image galleries comments per page",
// "gal list name" => "gal list name",
// "gal list parent" => "gal list parent",
// "gal list description" => "gal list description",
// "gal list created" => "gal list created",
// "gal list lastmodif" => "gal list lastmodif",
// "gal list user" => "gal list user",
// "gal list imgs" => "gal list imgs",
// "gal list visits" => "gal list visits",
// "feature image gallery mandatory category" => "feature image gallery mandatory category",
// "preset galleries info" => "preset galleries info",
// "gal image mouseover" => "gal image mouseover",
// "feature forums" => "feature forums",
// "home forum" => "home forum",
// "feature forum rankings" => "feature forum rankings",
// "feature forum parse" => "feature forum parse",
// "feature forum topics archiving" => "feature forum topics archiving",
// "feature forum replyempty" => "feature forum replyempty",
// "feature forum quickjump" => "feature forum quickjump",
// "feature forums allow thread titles" => "feature forums allow thread titles",
// "feature forum content search" => "feature forum content search",
// "feature forums name search" => "feature forums name search",
// "forums ordering" => "forums ordering",
// "forum list topics" => "forum list topics",
// "forum list posts" => "forum list posts",
// "forum list ppd" => "forum list ppd",
// "forum list lastpost" => "forum list lastpost",
// "forum list visits" => "forum list visits",
// "forum list desc" => "forum list desc",
// "forum list description len" => "forum list description len",
// "feature forum local search" => "feature forum local search",
// "feature forum local tiki search" => "feature forum local tiki search",
// "forum thread defaults by forum" => "forum thread defaults by forum",
// "forum thread user settings" => "forum thread user settings",
// "forum thread user settings threshold" => "forum thread user settings threshold",
// "forum thread user settings keep" => "forum thread user settings keep",
// "forum comments per page" => "forum comments per page",
// "forum comments no title prefix" => "forum comments no title prefix",
// "forum thread style" => "forum thread style",
// "forum thread sort mode" => "forum thread sort mode",
// "forum match regex" => "forum match regex",
// "forum reply notitle" => "forum reply notitle",
// "feature articles" => "feature articles",
// "feature submissions" => "feature submissions",
// "feature cms rankings" => "feature cms rankings",
// "feature cms print" => "feature cms print",
// "feature cms emails" => "feature cms emails",
// "feature cms sharethis" => "feature cms sharethis",
// "art sort mode" => "art sort mode",
// "art list title" => "art list title",
// "art list title len" => "art list title len",
// "art list id" => "art list id",
// "art list topic" => "art list topic",
// "art list date" => "art list date",
// "art list author" => "art list author",
// "art list rating" => "art list rating",
// "art list reads" => "art list reads",
// "art list size" => "art list size",
// "art list expire" => "art list expire",
// "art list img" => "art list img",
// "art list type" => "art list type",
// "art list visible" => "art list visible",
// "art view type" => "art view type",
// "art view title" => "art view title",
// "art view topic" => "art view topic",
// "art view date" => "art view date",
// "art view author" => "art view author",
// "art view reads" => "art view reads",
// "art view size" => "art view size",
// "art view img" => "art view img",
// "art list lang" => "art list lang",
// "art trailer pos" => "art trailer pos",
// "art header text pos" => "art header text pos",
// "feature article comments" => "feature article comments",
// "article comments default ordering" => "article comments default ordering",
// "article comments per page" => "article comments per page",
// "article paginate" => "article paginate",
// "article user rating" => "article user rating",
// "article user rating options" => "article user rating options",
// "article image size x" => "article image size x",
// "article image size y" => "article image size y",
// "article custom attributes" => "article custom attributes",
// "article sharethis publisher" => "article sharethis publisher",
// "feature cms templates" => "feature cms templates",
// "cms bot bar" => "cms bot bar",
// "cms left column" => "cms left column",
// "cms right column" => "cms right column",
// "cms top bar" => "cms top bar",
// "art home title" => "art home title",
// "feature trackers" => "feature trackers",
// "t use db" => "t use db",
// "t use dir" => "t use dir",
// "groupTracker" => "groupTracker",
// "userTracker" => "userTracker",
// "trackerCreatorGroupName" => "trackerCreatorGroupName",
// "user selector threshold" => "user selector threshold",
// "user selector realnames tracker" => "user selector realnames tracker",
// "user selector realnames messu" => "user selector realnames messu",
// "feature userlevels" => "feature userlevels",
// "userlevels" => "userlevels",
// "userbreadCrumb" => "userbreadCrumb",
// "user assigned modules" => "user assigned modules",
// "user flip modules" => "user flip modules",
// "user show realnames" => "user show realnames",
// "user store file gallery picture" => "user store file gallery picture",
// "user picture gallery id" => "user picture gallery id",
// "user who viewed my stuff" => "user who viewed my stuff",
// "user who viewed my stuff days" => "user who viewed my stuff days",
// "user who viewed my stuff show others" => "user who viewed my stuff show others",
// "user register prettytracker" => "user register prettytracker",
// "user register prettytracker tpl" => "user register prettytracker tpl",
// "user trackersync trackers" => "user trackersync trackers",
// "user trackersync realname" => "user trackersync realname",
// "user trackersync geo" => "user trackersync geo",
// "user trackersync groups" => "user trackersync groups",
// "user trackersync parentgroup" => "user trackersync parentgroup",
// "feature mytiki" => "feature mytiki",
// "feature userPreferences" => "feature userPreferences",
// "feature user bookmarks" => "feature user bookmarks",
// "feature tasks" => "feature tasks",
// "w use db" => "w use db",
// "w use dir" => "w use dir",
// "w displayed default" => "w displayed default",
// "uf use db" => "uf use db",
// "uf use dir" => "uf use dir",
// "userfiles quota" => "userfiles quota",
// "feature usermenu" => "feature usermenu",
// "feature minical" => "feature minical",
// "feature notepad" => "feature notepad",
// "feature userfiles" => "feature userfiles",
// "feature community gender" => "feature community gender",
// "feature community mouseover" => "feature community mouseover",
// "feature community mouseover name" => "feature community mouseover name",
// "feature community mouseover gender" => "feature community mouseover gender",
// "feature community mouseover picture" => "feature community mouseover picture",
// "feature community mouseover friends" => "feature community mouseover friends",
// "feature community mouseover score" => "feature community mouseover score",
// "feature community mouseover country" => "feature community mouseover country",
// "feature community mouseover email" => "feature community mouseover email",
// "feature community mouseover lastlogin" => "feature community mouseover lastlogin",
// "feature community mouseover distance" => "feature community mouseover distance",
// "feature community list name" => "feature community list name",
// "feature community list score" => "feature community list score",
// "feature community list country" => "feature community list country",
// "feature community list distance" => "feature community list distance",
// "feature community friends permission" => "feature community friends permission",
// "feature community friends permission dep" => "feature community friends permission dep",
// "change language" => "change language",
// "login is email" => "login is email",
// "login is email obscure" => "login is email obscure",
// "validateUsers" => "validateUsers",
// "validateEmail" => "validateEmail",
// "forgotPass" => "forgotPass",
// "change password" => "change password",
// "available languages" => "available languages",
// "available styles" => "available styles",
// "lowercase username" => "lowercase username",
// "username pattern" => "username pattern",
// "max username length" => "max username length",
// "min username length" => "min username length",
// "users serve avatar static" => "users serve avatar static",
// "users prefs allowMsgs" => "users prefs allowMsgs",
// "users prefs country" => "users prefs country",
// "users prefs diff versions" => "users prefs diff versions",
// "users prefs display timezone" => "users prefs display timezone",
// "users prefs email is public" => "users prefs email is public",
// "users prefs homePage" => "users prefs homePage",
// "users prefs lat" => "users prefs lat",
// "users prefs lon" => "users prefs lon",
// "users prefs mess archiveAfter" => "users prefs mess archiveAfter",
// "users prefs mess maxRecords" => "users prefs mess maxRecords",
// "users prefs mess sendReadStatus" => "users prefs mess sendReadStatus",
// "users prefs minPrio" => "users prefs minPrio",
// "users prefs mytiki blogs" => "users prefs mytiki blogs",
// "users prefs mytiki articles" => "users prefs mytiki articles",
// "users prefs mytiki gals" => "users prefs mytiki gals",
// "users prefs mytiki items" => "users prefs mytiki items",
// "users prefs mytiki msgs" => "users prefs mytiki msgs",
// "users prefs mytiki pages" => "users prefs mytiki pages",
// "users prefs mytiki tasks" => "users prefs mytiki tasks",
// "users prefs mytiki forum topics" => "users prefs mytiki forum topics",
// "users prefs mytiki forum replies" => "users prefs mytiki forum replies",
// "users prefs realName" => "users prefs realName",
// "users prefs gender" => "users prefs gender",
// "users prefs show mouseover user info" => "users prefs show mouseover user info",
// "users prefs tasks maxRecords" => "users prefs tasks maxRecords",
// "users prefs user dbl" => "users prefs user dbl",
// "users prefs user information" => "users prefs user information",
// "users prefs userbreadCrumb" => "users prefs userbreadCrumb",
// "users prefs mailCharset" => "users prefs mailCharset",
// "users prefs mailCurrentAccount" => "users prefs mailCurrentAccount",
// "validateRegistration" => "validateRegistration",
// "validator emails" => "validator emails",
// "url after validation" => "url after validation",
// "urlOnUsername" => "urlOnUsername",
// "feature messages" => "feature messages",
// "messu mailbox size" => "messu mailbox size",
// "messu archive size" => "messu archive size",
// "messu sent size" => "messu sent size",
// "allowmsg by default" => "allowmsg by default",
// "allowmsg is optional" => "allowmsg is optional",
// "feature freetags" => "feature freetags",
// "freetags browse show cloud" => "freetags browse show cloud",
// "freetags cloud colors" => "freetags cloud colors",
// "freetags preload random search" => "freetags preload random search",
// "freetags browse amount tags in cloud" => "freetags browse amount tags in cloud",
// "freetags browse amount tags suggestion" => "freetags browse amount tags suggestion",
// "freetags normalized valid chars" => "freetags normalized valid chars",
// "freetags lowercase only" => "freetags lowercase only",
// "freetags feature 3d" => "freetags feature 3d",
// "freetags 3d width" => "freetags 3d width",
// "freetags 3d height" => "freetags 3d height",
// "freetags 3d navigation depth" => "freetags 3d navigation depth",
// "freetags 3d feed animation interval" => "freetags 3d feed animation interval",
// "freetags 3d existing page color" => "freetags 3d existing page color",
// "freetags 3d missing page color" => "freetags 3d missing page color",
// "freetags 3d autoload" => "freetags 3d autoload",
// "freetags 3d camera distance" => "freetags 3d camera distance",
// "freetags 3d elastic constant" => "freetags 3d elastic constant",
// "freetags 3d eletrostatic constant" => "freetags 3d eletrostatic constant",
// "freetags 3d fov" => "freetags 3d fov",
// "freetags 3d friction constant" => "freetags 3d friction constant",
// "freetags 3d node charge" => "freetags 3d node charge",
// "freetags 3d node mass" => "freetags 3d node mass",
// "freetags 3d node size" => "freetags 3d node size",
// "freetags 3d spring size" => "freetags 3d spring size",
// "freetags 3d text size" => "freetags 3d text size",
// "freetags 3d adjust camera" => "freetags 3d adjust camera",
// "freetags multilingual" => "freetags multilingual",
// "morelikethis algorithm" => "morelikethis algorithm",
// "morelikethis basic mincommon" => "morelikethis basic mincommon",
// "freetags show middle" => "freetags show middle",
// "feature search stats" => "feature search stats",
// "feature search" => "feature search",
// "feature search fulltext" => "feature search fulltext",
// "feature search show forbidden obj" => "feature search show forbidden obj",
// "feature search show forbidden cat" => "feature search show forbidden cat",
// "feature search show object filter" => "feature search show object filter",
// "feature search show search box" => "feature search show search box",
// "feature search show visit count" => "feature search show visit count",
// "feature search show pertinence" => "feature search show pertinence",
// "feature search show object type" => "feature search show object type",
// "feature search show last modification" => "feature search show last modification",
// "search refresh index mode" => "search refresh index mode",
// "search parsed snippet" => "search parsed snippet",
// "search default where" => "search default where",
// "search default interface language" => "search default interface language",
// "search autocomplete" => "search autocomplete",
// "feature webmail" => "feature webmail",
// "webmail max attachment" => "webmail max attachment",
// "webmail view html" => "webmail view html",
// "webmail quick flags" => "webmail quick flags",
// "feature contacts" => "feature contacts",
// "feature faqs" => "feature faqs",
// "feature faq comments" => "feature faq comments",
// "faq comments per page" => "faq comments per page",
// "faq comments default ordering" => "faq comments default ordering",
// "faq prefix" => "faq prefix",
// "feature quizzes" => "feature quizzes",
// "feature polls" => "feature polls",
// "feature poll comments" => "feature poll comments",
// "feature poll anonymous" => "feature poll anonymous",
// "poll comments default ordering" => "poll comments default ordering",
// "poll comments per page" => "poll comments per page",
// "poll list categories" => "poll list categories",
// "poll list objects" => "poll list objects",
// "poll multiple per object" => "poll multiple per object",
// "feature poll revote" => "feature poll revote",
// "feature surveys" => "feature surveys",
// "feature featuredLinks" => "feature featuredLinks",
// "feature directory" => "feature directory",
// "directory columns" => "directory columns",
// "directory links per page" => "directory links per page",
// "directory open links" => "directory open links",
// "directory validate urls" => "directory validate urls",
// "directory cool sites" => "directory cool sites",
// "directory country flag" => "directory country flag",
// "feature calendar" => "feature calendar",
// "feature default calendars" => "feature default calendars",
// "calendar sticky popup" => "calendar sticky popup",
// "calendar view mode" => "calendar view mode",
// "calendar view tab" => "calendar view tab",
// "calendar firstDayofWeek" => "calendar firstDayofWeek",
// "calendar timespan" => "calendar timespan",
// "feature jscalendar" => "feature jscalendar",
// "feature action calendar" => "feature action calendar",
// "calendar start year" => "calendar start year",
// "calendar end year" => "calendar end year",
// "calendar list begins focus" => "calendar list begins focus",
// "feature cal manual time" => "feature cal manual time",
// "calendar view days" => "calendar view days",
// "calendar addtogooglecal" => "calendar addtogooglecal",
// "server timezone" => "server timezone",
// "long date format" => "long date format",
// "long time format" => "long time format",
// "short date format" => "short date format",
// "short time format" => "short time format",
// "display field order" => "display field order",
// "tiki same day time only" => "tiki same day time only",
// "feed basic auth" => "feed basic auth",
// "feed cache time" => "feed cache time",
// "feed default version" => "feed default version",
// "feed atom author name" => "feed atom author name",
// "feed atom author email" => "feed atom author email",
// "feed atom author url" => "feed atom author url",
// "feed img" => "feed img",
// "feed rss editor email" => "feed rss editor email",
// "feed rss webmaster email" => "feed rss webmaster email",
// "feed language" => "feed language",
// "feed articles" => "feed articles",
// "feed articles desc" => "feed articles desc",
// "feed articles homepage" => "feed articles homepage",
// "feed articles max" => "feed articles max",
// "feed articles showAuthor" => "feed articles showAuthor",
// "feed articles title" => "feed articles title",
// "feed blog" => "feed blog",
// "feed blog desc" => "feed blog desc",
// "feed blog homepage" => "feed blog homepage",
// "feed blog max" => "feed blog max",
// "feed blog showAuthor" => "feed blog showAuthor",
// "feed blog title" => "feed blog title",
// "feed blogs" => "feed blogs",
// "feed blogs desc" => "feed blogs desc",
// "feed blogs homepage" => "feed blogs homepage",
// "feed blogs max" => "feed blogs max",
// "feed blogs showAuthor" => "feed blogs showAuthor",
// "feed blogs title" => "feed blogs title",
// "feed calendar" => "feed calendar",
// "feed calendar desc" => "feed calendar desc",
// "feed calendar homepage" => "feed calendar homepage",
// "feed calendar max" => "feed calendar max",
// "feed calendar showAuthor" => "feed calendar showAuthor",
// "feed calendar title" => "feed calendar title",
// "feed directories" => "feed directories",
// "feed directories desc" => "feed directories desc",
// "feed directories homepage" => "feed directories homepage",
// "feed directories max" => "feed directories max",
// "feed directories showAuthor" => "feed directories showAuthor",
// "feed directories title" => "feed directories title",
// "feed file galleries" => "feed file galleries",
// "feed file galleries desc" => "feed file galleries desc",
// "feed file galleries homepage" => "feed file galleries homepage",
// "feed file galleries max" => "feed file galleries max",
// "feed file galleries showAuthor" => "feed file galleries showAuthor",
// "feed file galleries title" => "feed file galleries title",
// "feed file gallery" => "feed file gallery",
// "feed file gallery desc" => "feed file gallery desc",
// "feed file gallery homepage" => "feed file gallery homepage",
// "feed file gallery max" => "feed file gallery max",
// "feed file gallery showAuthor" => "feed file gallery showAuthor",
// "feed file gallery title" => "feed file gallery title",
// "feed forum" => "feed forum",
// "feed forum desc" => "feed forum desc",
// "feed forum homepage" => "feed forum homepage",
// "feed forum max" => "feed forum max",
// "feed forum showAuthor" => "feed forum showAuthor",
// "feed forum title" => "feed forum title",
// "feed forums max" => "feed forums max",
// "feed forums" => "feed forums",
// "feed forums desc" => "feed forums desc",
// "feed forums showAuthor" => "feed forums showAuthor",
// "feed forums title" => "feed forums title",
// "feed image galleries" => "feed image galleries",
// "feed image galleries desc" => "feed image galleries desc",
// "feed image galleries homepage" => "feed image galleries homepage",
// "feed image galleries max" => "feed image galleries max",
// "feed image galleries showAuthor" => "feed image galleries showAuthor",
// "feed image galleries title" => "feed image galleries title",
// "feed image gallery" => "feed image gallery",
// "feed image gallery desc" => "feed image gallery desc",
// "feed image gallery homepage" => "feed image gallery homepage",
// "feed image gallery max" => "feed image gallery max",
// "feed image gallery showAuthor" => "feed image gallery showAuthor",
// "feed image gallery title" => "feed image gallery title",
// "feed maps" => "feed maps",
// "feed maps desc" => "feed maps desc",
// "feed maps homepage" => "feed maps homepage",
// "feed maps max" => "feed maps max",
// "feed maps showAuthor" => "feed maps showAuthor",
// "feed maps title" => "feed maps title",
// "feed shoutbox" => "feed shoutbox",
// "feed shoutbox desc" => "feed shoutbox desc",
// "feed shoutbox homepage" => "feed shoutbox homepage",
// "feed shoutbox max" => "feed shoutbox max",
// "feed shoutbox showAuthor" => "feed shoutbox showAuthor",
// "feed shoutbox title" => "feed shoutbox title",
// "feed tracker" => "feed tracker",
// "feed tracker desc" => "feed tracker desc",
// "feed tracker homepage" => "feed tracker homepage",
// "feed tracker max" => "feed tracker max",
// "feed tracker showAuthor" => "feed tracker showAuthor",
// "feed tracker title" => "feed tracker title",
// "feed trackers" => "feed trackers",
// "feed trackers desc" => "feed trackers desc",
// "feed trackers homepage" => "feed trackers homepage",
// "feed trackers max" => "feed trackers max",
// "feed trackers showAuthor" => "feed trackers showAuthor",
// "feed trackers title" => "feed trackers title",
// "feed wiki" => "feed wiki",
// "feed wiki desc" => "feed wiki desc",
// "feed wiki homepage" => "feed wiki homepage",
// "feed wiki max" => "feed wiki max",
// "feed wiki showAuthor" => "feed wiki showAuthor",
// "feed wiki title" => "feed wiki title",
// "max rss mapfiles" => "max rss mapfiles",
// "rss mapfiles" => "rss mapfiles",
// "title rss mapfiles" => "title rss mapfiles",
// "feature maps" => "feature maps",
// "map path" => "map path",
// "default map" => "default map",
// "map help" => "map help",
// "map comments" => "map comments",
// "gdaltindex" => "gdaltindex",
// "ogr2ogr" => "ogr2ogr",
// "mapzone" => "mapzone",
// "feature gmap" => "feature gmap",
// "gmap defaultx" => "gmap defaultx",
// "gmap defaulty" => "gmap defaulty",
// "gmap defaultz" => "gmap defaultz",
// "gmap key" => "gmap key",
// "gmap article list" => "gmap article list",
// "gmap page list" => "gmap page list",
// "allowRegister" => "allowRegister",
// "eponymousGroups" => "eponymousGroups",
// "useRegisterPasscode" => "useRegisterPasscode",
// "registerPasscode" => "registerPasscode",
// "rememberme" => "rememberme",
// "remembertime" => "remembertime",
// "feature clear passwords" => "feature clear passwords",
// "feature crypt passwords" => "feature crypt passwords",
// "feature challenge" => "feature challenge",
// "min user length" => "min user length",
// "min pass length" => "min pass length",
// "pass chr num" => "pass chr num",
// "pass due" => "pass due",
// "email due" => "email due",
// "unsuccessful logins" => "unsuccessful logins",
// "generate password" => "generate password",
// "auth method" => "auth method",
// "auth pear" => "auth pear",
// "auth ldap url" => "auth ldap url",
// "auth pear host" => "auth pear host",
// "auth pear port" => "auth pear port",
// "auth ldap scope" => "auth ldap scope",
// "auth ldap basedn" => "auth ldap basedn",
// "auth ldap userdn" => "auth ldap userdn",
// "auth ldap userattr" => "auth ldap userattr",
// "auth ldap useroc" => "auth ldap useroc",
// "auth ldap groupdn" => "auth ldap groupdn",
// "auth ldap groupattr" => "auth ldap groupattr",
// "auth ldap groupnameatr" => "auth ldap groupnameatr",
// "auth ldap groupdescatr" => "auth ldap groupdescatr",
// "auth ldap usergroupattr" => "auth ldap usergroupattr",
// "auth ldap groupgroupattr" => "auth ldap groupgroupattr",
// "auth ldap groupoc" => "auth ldap groupoc",
// "auth ldap memberattr" => "auth ldap memberattr",
// "auth ldap memberisdn" => "auth ldap memberisdn",
// "auth ldap adminuser" => "auth ldap adminuser",
// "auth ldap adminpass" => "auth ldap adminpass",
// "auth ldap version" => "auth ldap version",
// "auth ldap nameattr" => "auth ldap nameattr",
// "auth ldap countryattr" => "auth ldap countryattr",
// "auth ldap emailattr" => "auth ldap emailattr",
// "ldap create user tiki" => "ldap create user tiki",
// "ldap create user ldap" => "ldap create user ldap",
// "ldap skip admin" => "ldap skip admin",
// "auth ldap permit tiki users" => "auth ldap permit tiki users",
// "auth ldap debug" => "auth ldap debug",
// "auth ldap ssl" => "auth ldap ssl",
// "auth ldap starttls" => "auth ldap starttls",
// "auth ldap type" => "auth ldap type",
// "auth ldap syncuserattr" => "auth ldap syncuserattr",
// "auth ldap syncgroupattr" => "auth ldap syncgroupattr",
// "auth phpbb version" => "auth phpbb version",
// "auth phpbb skip admin" => "auth phpbb skip admin",
// "auth phpbb create tiki" => "auth phpbb create tiki",
// "auth phpbb dbhost" => "auth phpbb dbhost",
// "auth phpbb dbport" => "auth phpbb dbport",
// "auth phpbb disable tikionly" => "auth phpbb disable tikionly",
// "auth phpbb dbuser" => "auth phpbb dbuser",
// "auth phpbb dbpasswd" => "auth phpbb dbpasswd",
// "auth phpbb dbname" => "auth phpbb dbname",
// "auth phpbb dbtype" => "auth phpbb dbtype",
// "auth phpbb table prefix" => "auth phpbb table prefix",
// "auth ws create tiki" => "auth ws create tiki",
// "https login" => "https login",
// "https external links for users" => "https external links for users",
// "feature show stay in ssl mode" => "feature show stay in ssl mode",
// "feature switch ssl mode" => "feature switch ssl mode",
// "https port" => "https port",
// "http port" => "http port",
// "login url" => "login url",
// "login scr" => "login scr",
// "register url" => "register url",
// "error url" => "error url",
// "highlight group" => "highlight group",
// "cookie path" => "cookie path",
// "cookie domain" => "cookie domain",
// "cookie name" => "cookie name",
// "user tracker infos" => "user tracker infos",
// "desactive login autocomplete" => "desactive login autocomplete",
// "permission denied login box" => "permission denied login box",
// "permission denied url" => "permission denied url",
// "feature loadbalancer" => "feature loadbalancer",
// "feature intertiki" => "feature intertiki",
// "feature intertiki server" => "feature intertiki server",
// "feature intertiki slavemode" => "feature intertiki slavemode",
// "interlist" => "interlist",
// "feature intertiki mymaster" => "feature intertiki mymaster",
// "feature intertiki import preferences" => "feature intertiki import preferences",
// "feature intertiki import groups" => "feature intertiki import groups",
// "known hosts" => "known hosts",
// "tiki key" => "tiki key",
// "intertiki logfile" => "intertiki logfile",
// "intertiki errfile" => "intertiki errfile",
// "feature intertiki sharedcookie" => "feature intertiki sharedcookie",
// "search lru length" => "search lru length",
// "search lru purge rate" => "search lru purge rate",
// "search max syllwords" => "search max syllwords",
// "search min wordlength" => "search min wordlength",
// "search refresh rate" => "search refresh rate",
// "search syll age" => "search syll age",
// "feature categories" => "feature categories",
// "feature categoryobjects" => "feature categoryobjects",
// "feature categorypath" => "feature categorypath",
// "feature category use phplayers" => "feature category use phplayers",
// "categorypath excluded" => "categorypath excluded",
// "categories used in tpl" => "categories used in tpl",
// "category jail" => "category jail",
// "category defaults" => "category defaults",
// "category i18n sync" => "category i18n sync",
// "category i18n synced" => "category i18n synced",
// "category i18n unsynced" => "category i18n unsynced",
// "category autogeocode within" => "category autogeocode within",
// "category autogeocode replace" => "category autogeocode replace",
// "category autogeocode fudge" => "category autogeocode fudge",
// "expanded category jail" => "expanded category jail",
// "expanded category jail key" => "expanded category jail key",
// "ws container" => "ws container",
// "feature html pages" => "feature html pages",
// "feature filegals manager" => "feature filegals manager",
// "feature contact" => "feature contact",
// "contact user" => "contact user",
// "contact anon" => "contact anon",
// "mail crlf" => "mail crlf",
// "feature detect language" => "feature detect language",
// "feature homePage if bl missing" => "feature homePage if bl missing",
// "record untranslated" => "record untranslated",
// "feature best language" => "feature best language",
// "feature translation" => "feature translation",
// "feature urgent translation" => "feature urgent translation",
// "feature urgent translation master only" => "feature urgent translation master only",
// "feature translation incomplete notice" => "feature translation incomplete notice",
// "lang use db" => "lang use db",
// "language" => "language",
// "restrict language" => "restrict language",
// "feature babelfish" => "feature babelfish",
// "feature babelfish logo" => "feature babelfish logo",
// "quantify changes" => "quantify changes",
// "feature sync language" => "feature sync language",
// "show available translations" => "show available translations",
// "language inclusion threshold" => "language inclusion threshold",
// "metatag keywords" => "metatag keywords",
// "metatag threadtitle" => "metatag threadtitle",
// "metatag imagetitle" => "metatag imagetitle",
// "metatag freetags" => "metatag freetags",
// "metatag description" => "metatag description",
// "metatag pagedesc" => "metatag pagedesc",
// "metatag author" => "metatag author",
// "metatag geoposition" => "metatag geoposition",
// "metatag georegion" => "metatag georegion",
// "metatag geoplacename" => "metatag geoplacename",
// "metatag robots" => "metatag robots",
// "metatag revisitafter" => "metatag revisitafter",
// "head extra js" => "head extra js",
// "keep versions" => "keep versions",
// "feature custom home" => "feature custom home",
// "site crumb seper" => "site crumb seper",
// "site nav seper" => "site nav seper",
// "feature sitemycode" => "feature sitemycode",
// "sitemycode" => "sitemycode",
// "sitemycode publish" => "sitemycode publish",
// "feature sitelogo" => "feature sitelogo",
// "sitelogo bgcolor" => "sitelogo bgcolor",
// "sitelogo bgstyle" => "sitelogo bgstyle",
// "sitelogo align" => "sitelogo align",
// "sitelogo title" => "sitelogo title",
// "sitelogo src" => "sitelogo src",
// "sitelogo alt" => "sitelogo alt",
// "feature siteloc" => "feature siteloc",
// "feature sitenav" => "feature sitenav",
// "sitenav" => "sitenav",
// "feature sitead" => "feature sitead",
// "sitead" => "sitead",
// "sitead publish" => "sitead publish",
// "feature breadcrumbs" => "feature breadcrumbs",
// "feature siteloclabel" => "feature siteloclabel",
// "feature sitesearch" => "feature sitesearch",
// "feature site login" => "feature site login",
// "feature sitemenu" => "feature sitemenu",
// "feature sitemenu custom code" => "feature sitemenu custom code",
// "feature secondary sitemenu custom code" => "feature secondary sitemenu custom code",
// "feature topbar version" => "feature topbar version",
// "feature topbar id menu" => "feature topbar id menu",
// "feature topbar custom code" => "feature topbar custom code",
// "feature sitetitle" => "feature sitetitle",
// "feature sitedesc" => "feature sitedesc",
// "feature bot logo" => "feature bot logo",
// "feature endbody code" => "feature endbody code",
// "feature custom doctype" => "feature custom doctype",
// "feature custom doctype content" => "feature custom doctype content",
// "feature custom html head content" => "feature custom html head content",
// "feature fixed width" => "feature fixed width",
// "feature html head base tag" => "feature html head base tag",
// "feature left column" => "feature left column",
// "feature right column" => "feature right column",
// "feature top bar" => "feature top bar",
// "feature bot bar" => "feature bot bar",
// "feature bot bar icons" => "feature bot bar icons",
// "feature bot bar debug" => "feature bot bar debug",
// "feature bot bar rss" => "feature bot bar rss",
// "feature bot bar power by tw" => "feature bot bar power by tw",
// "maxRecords" => "maxRecords",
// "maxArticles" => "maxArticles",
// "maxVersions" => "maxVersions",
// "feature view tpl" => "feature view tpl",
// "slide style" => "slide style",
// "site favicon" => "site favicon",
// "site favicon type" => "site favicon type",
// "style option" => "style option",
// "use context menu icon" => "use context menu icon",
// "use context menu text" => "use context menu text",
// "feature site report" => "feature site report",
// "feature site send link" => "feature site send link",
// "feature layoutshadows" => "feature layoutshadows",
// "main shadow start" => "main shadow start",
// "main shadow end" => "main shadow end",
// "header shadow start" => "header shadow start",
// "header shadow end" => "header shadow end",
// "middle shadow start" => "middle shadow start",
// "middle shadow end" => "middle shadow end",
// "center shadow start" => "center shadow start",
// "center shadow end" => "center shadow end",
// "footer shadow start" => "footer shadow start",
// "footer shadow end" => "footer shadow end",
// "box shadow start" => "box shadow start",
// "box shadow end" => "box shadow end",
// "feature custom center column header" => "feature custom center column header",
// "header custom css" => "header custom css",
// "header custom js" => "header custom js",
// "feature mods provider" => "feature mods provider",
// "mods dir" => "mods dir",
// "mods server" => "mods server",
// "feature experimental" => "feature experimental",
// "feature actionlog" => "feature actionlog",
// "feature actionlog bytes" => "feature actionlog bytes",
// "browsertitle" => "browsertitle",
// "site title location" => "site title location",
// "site title breadcrumb" => "site title breadcrumb",
// "tmpDir" => "tmpDir",
// "feature tell a friend" => "feature tell a friend",
// "feature share" => "feature share",
// "feature copyright" => "feature copyright",
// "feature smileys" => "feature smileys",
// "popupLinks" => "popupLinks",
// "feature autolinks" => "feature autolinks",
// "default rows textarea wiki" => "default rows textarea wiki",
// "default rows textarea comment" => "default rows textarea comment",
// "default rows textarea forum" => "default rows textarea forum",
// "default rows textarea forumthread" => "default rows textarea forumthread",
// "section comments parse" => "section comments parse",
// "toolbar global" => "toolbar global",
// "toolbar global comments" => "toolbar global comments",
// "toolbar sheet" => "toolbar sheet",
// "direct pagination" => "direct pagination",
// "nextprev pagination" => "nextprev pagination",
// "pagination firstlast" => "pagination firstlast",
// "pagination hide if one page" => "pagination hide if one page",
// "pagination icons" => "pagination icons",
// "pagination fastmove links" => "pagination fastmove links",
// "direct pagination max middle links" => "direct pagination max middle links",
// "direct pagination max ending links" => "direct pagination max ending links",
// "feature kaltura" => "feature kaltura",
// "wikiplugin kaltura" => "wikiplugin kaltura",
// "wikiplugininline kaltura" => "wikiplugininline kaltura",
// "default kaltura editor" => "default kaltura editor",
// "partnerId" => "partnerId",
// "secret" => "secret",
// "adminSecret" => "adminSecret",
// "kdpUIConf" => "kdpUIConf",
// "kdpWidget" => "kdpWidget",
// "kcwUIConf" => "kcwUIConf",
// "kseUIConf" => "kseUIConf",
// "kaeUIConf" => "kaeUIConf",
// "kuser" => "kuser",
// "kServiceUrl" => "kServiceUrl",
// "bigbluebutton feature" => "bigbluebutton feature",
// "bigbluebutton server location" => "bigbluebutton server location",
// "bigbluebutton server salt" => "bigbluebutton server salt",
// "shipping service" => "shipping service",
// "shipping fedex enable" => "shipping fedex enable",
// "shipping fedex key" => "shipping fedex key",
// "shipping fedex password" => "shipping fedex password",
// "shipping fedex meter" => "shipping fedex meter",
// "shipping fedex account" => "shipping fedex account",
// "shipping ups enable" => "shipping ups enable",
// "shipping ups username" => "shipping ups username",
// "shipping ups password" => "shipping ups password",
// "shipping ups license" => "shipping ups license",
// "recaptcha enabled" => "recaptcha enabled",
// "recaptcha pubkey" => "recaptcha pubkey",
// "recaptcha privkey" => "recaptcha privkey",
// "captcha wordLen" => "captcha wordLen",
// "captcha width" => "captcha width",
// "captcha noise" => "captcha noise",
// "anonCanEdit" => "anonCanEdit",
// "cacheimages" => "cacheimages",
// "cachepages" => "cachepages",
// "count admin pvs" => "count admin pvs",
// "default mail charset" => "default mail charset",
// "error reporting adminonly" => "error reporting adminonly",
// "error reporting level" => "error reporting level",
// "smarty security" => "smarty security",
// "smarty compilation" => "smarty compilation",
// "feature htmlpurifier output" => "feature htmlpurifier output",
// "feature ajax" => "feature ajax",
// "ajax autosave" => "ajax autosave",
// "ajax xajax" => "ajax xajax",
// "feature antibot" => "feature antibot",
// "feature banners" => "feature banners",
// "feature banning" => "feature banning",
// "feature comm" => "feature comm",
// "feature contribution" => "feature contribution",
// "feature contribution display in comment" => "feature contribution display in comment",
// "feature contribution mandatory" => "feature contribution mandatory",
// "feature contribution mandatory blog" => "feature contribution mandatory blog",
// "feature contribution mandatory comment" => "feature contribution mandatory comment",
// "feature contribution mandatory forum" => "feature contribution mandatory forum",
// "feature credits" => "feature credits",
// "feature debug console" => "feature debug console",
// "feature debugger console" => "feature debugger console",
// "feature display my to others" => "feature display my to others",
// "feature dynamic content" => "feature dynamic content",
// "feature edit templates" => "feature edit templates",
// "feature editcss" => "feature editcss",
// "feature events" => "feature events",
// "feature friends" => "feature friends",
// "feature fullscreen" => "feature fullscreen",
// "feature help" => "feature help",
// "feature hotwords" => "feature hotwords",
// "feature hotwords nw" => "feature hotwords nw",
// "feature integrator" => "feature integrator",
// "feature live support" => "feature live support",
// "feature mailin" => "feature mailin",
// "feature menusfolderstyle" => "feature menusfolderstyle",
// "feature mobile" => "feature mobile",
// "feature modulecontrols" => "feature modulecontrols",
// "feature morcego" => "feature morcego",
// "feature multilingual" => "feature multilingual",
// "feature multilingual one page" => "feature multilingual one page",
// "feature multilingual structures" => "feature multilingual structures",
// "feature machine translation" => "feature machine translation",
// "feature newsletters" => "feature newsletters",
// "feature obzip" => "feature obzip",
// "feature perspective" => "feature perspective",
// "feature phplayers" => "feature phplayers",
// "feature cssmenus" => "feature cssmenus",
// "menus item names raw" => "menus item names raw",
// "feature projects" => "feature projects",
// "feature ranking" => "feature ranking",
// "feature redirect on error" => "feature redirect on error",
// "url anonymous page not found" => "url anonymous page not found",
// "feature referer highlight" => "feature referer highlight",
// "feature referer stats" => "feature referer stats",
// "feature score" => "feature score",
// "feature sheet" => "feature sheet",
// "feature shoutbox" => "feature shoutbox",
// "feature source" => "feature source",
// "feature stats" => "feature stats",
// "feature tabs" => "feature tabs",
// "feature theme control" => "feature theme control",
// "feature ticketlib" => "feature ticketlib",
// "feature ticketlib2" => "feature ticketlib2",
// "feature top banner" => "feature top banner",
// "feature usability" => "feature usability",
// "feature use quoteplugin" => "feature use quoteplugin",
// "feature use three colon centertag" => "feature use three colon centertag",
// "feature user watches" => "feature user watches",
// "feature group watches" => "feature group watches",
// "feature user watches translations" => "feature user watches translations",
// "feature user watches languages" => "feature user watches languages",
// "feature daily report watches" => "feature daily report watches",
// "feature quick object perms" => "feature quick object perms",
// "feature xmlrpc" => "feature xmlrpc",
// "feature watershed" => "feature watershed",
// "helpurl" => "helpurl",
// "layout section" => "layout section",
// "limitedGoGroupHome" => "limitedGoGroupHome",
// "minical reminders" => "minical reminders",
// "modallgroups" => "modallgroups",
// "modseparateanon" => "modseparateanon",
// "modhideanonadmin" => "modhideanonadmin",
// "php docroot" => "php docroot",
// "proxy host" => "proxy host",
// "proxy port" => "proxy port",
// "ip can be checked" => "ip can be checked",
// "sender email" => "sender email",
// "feature site report email" => "feature site report email",
// "session storage" => "session storage",
// "session lifetime" => "session lifetime",
// "session silent" => "session silent",
// "session cookie name" => "session cookie name",
// "session protected" => "session protected",
// "shoutbox autolink" => "shoutbox autolink",
// "show comzone" => "show comzone",
// "tikiIndex" => "tikiIndex",
// "urlIndex" => "urlIndex",
// "useGroupHome" => "useGroupHome",
// "useGroupTheme" => "useGroupTheme",
// "useUrlIndex" => "useUrlIndex",
// "use proxy" => "use proxy",
// "user list order" => "user list order",
// "webserverauth" => "webserverauth",
// "feature purifier" => "feature purifier",
// "feature shadowbox" => "feature shadowbox",
// "log sql" => "log sql",
// "log sql perf min" => "log sql perf min",
// "log mail" => "log mail",
// "log tpl" => "log tpl",
// "disableJavascript" => "disableJavascript",
// "feature socialnetworks" => "feature socialnetworks",
// "socialnetworks twitter consumer key" => "socialnetworks twitter consumer key",
// "socialnetworks twitter consumer secret" => "socialnetworks twitter consumer secret",
// "socialnetworks facebook api key" => "socialnetworks facebook api key",
// "socialnetworks facebook application secr" => "socialnetworks facebook application secr",
// "socialnetworks facebook application id" => "socialnetworks facebook application id",
// "socialnetworks bitly login" => "socialnetworks bitly login",
// "socialnetworks bitly key" => "socialnetworks bitly key",
// "socialnetworks bitly sitewide" => "socialnetworks bitly sitewide",
// "case patched" => "case patched",
// "site closed" => "site closed",
// "site closed msg" => "site closed msg",
// "use load threshold" => "use load threshold",
// "load threshold" => "load threshold",
// "site busy msg" => "site busy msg",
// "bot logo code" => "bot logo code",
// "feature create webhelp" => "feature create webhelp",
// "page n times in a structure" => "page n times in a structure",
// "feature forums search" => "feature forums search",
// "feature wiki ext icon" => "feature wiki ext icon",
// "feature wiki ext rel nofollow" => "feature wiki ext rel nofollow",
// "feature wiki mandatory category" => "feature wiki mandatory category",
// "feature intertiki imported groups" => "feature intertiki imported groups",
// "feature wiki history ip" => "feature wiki history ip",
// "pam create user tiki" => "pam create user tiki",
// "pam service" => "pam service",
// "pam skip admin" => "pam skip admin",
// "shib affiliation" => "shib affiliation",
// "shib create user tiki" => "shib create user tiki",
// "shib group" => "shib group",
// "shib skip admin" => "shib skip admin",
// "shib usegroup" => "shib usegroup",
// "wiki 3d camera distance" => "wiki 3d camera distance",
// "wiki 3d elastic constant" => "wiki 3d elastic constant",
// "wiki 3d eletrostatic constant" => "wiki 3d eletrostatic constant",
// "wiki 3d fov" => "wiki 3d fov",
// "wiki 3d friction constant" => "wiki 3d friction constant",
// "wiki 3d node charge" => "wiki 3d node charge",
// "wiki 3d node mass" => "wiki 3d node mass",
// "wiki 3d node size" => "wiki 3d node size",
// "wiki 3d spring size" => "wiki 3d spring size",
// "wiki 3d text size" => "wiki 3d text size",
// "articles feature copyrights" => "articles feature copyrights",
// "blogues feature copyrights" => "blogues feature copyrights",
// "faqs feature copyrights" => "faqs feature copyrights",
// "feature contributor wiki" => "feature contributor wiki",
// "https login required" => "https login required",
// "maxRowsGalleries" => "maxRowsGalleries",
// "replimaster" => "replimaster",
// "rowImagesGalleries" => "rowImagesGalleries",
// "scaleSizeGalleries" => "scaleSizeGalleries",
// "thumbSizeXGalleries" => "thumbSizeXGalleries",
// "thumbSizeYGalleries" => "thumbSizeYGalleries",
// "wiki 3d adjust camera" => "wiki 3d adjust camera",
// "wiki 3d autoload" => "wiki 3d autoload",
// "javascript enabled" => "javascript enabled",
// "javascript cdn" => "javascript cdn",
// "feature template zoom" => "feature template zoom",
// "menus items icons" => "menus items icons",
// "menus items icons path" => "menus items icons path",
// "feature iepngfix" => "feature iepngfix",
// "iepngfix selectors" => "iepngfix selectors",
// "iepngfix elements" => "iepngfix elements",
// "feature invite" => "feature invite",
// "feature jquery" => "feature jquery",
// "jquery effect" => "jquery effect",
// "jquery effect direction" => "jquery effect direction",
// "jquery effect speed" => "jquery effect speed",
// "jquery effect tabs" => "jquery effect tabs",
// "jquery effect tabs direction" => "jquery effect tabs direction",
// "jquery effect tabs speed" => "jquery effect tabs speed",
// "feature jquery ui" => "feature jquery ui",
// "feature jquery ui theme" => "feature jquery ui theme",
// "feature jquery tooltips" => "feature jquery tooltips",
// "feature jquery autocomplete" => "feature jquery autocomplete",
// "feature jquery superfish" => "feature jquery superfish",
// "feature jquery reflection" => "feature jquery reflection",
// "feature jquery jqs5" => "feature jquery jqs5",
// "feature jquery tablesorter" => "feature jquery tablesorter",
// "feature jquery carousel" => "feature jquery carousel",
// "feature jquery validation" => "feature jquery validation",
// "feature jquery media" => "feature jquery media",
// "feature sefurl" => "feature sefurl",
// "feature sefurl filter" => "feature sefurl filter",
// "feature sefurl paths" => "feature sefurl paths",
// "feature sefurl title article" => "feature sefurl title article",
// "feature sefurl title blog" => "feature sefurl title blog",
// "feature sefurl tracker prefixalias" => "feature sefurl tracker prefixalias",
// "feature tikitests" => "feature tikitests",
// "profile sources" => "profile sources",
// "profile channels" => "profile channels",
// "feature minichat" => "feature minichat",
// "memcache enabled" => "memcache enabled",
// "memcache compress" => "memcache compress",
// "memcache servers" => "memcache servers",
// "memcache expiration" => "memcache expiration",
// "memcache prefix" => "memcache prefix",
// "memcache wiki data" => "memcache wiki data",
// "memcache wiki output" => "memcache wiki output",
// "memcache forum output" => "memcache forum output",
// "feature pear date" => "feature pear date",
// "feature bidi" => "feature bidi",
// "feature lastup" => "feature lastup",
// "feature groupalert" => "feature groupalert",
// "zend mail handler" => "zend mail handler",
// "zend mail smtp server" => "zend mail smtp server",
// "zend mail smtp auth" => "zend mail smtp auth",
// "zend mail smtp user" => "zend mail smtp user",
// "zend mail smtp pass" => "zend mail smtp pass",
// "zend mail smtp port" => "zend mail smtp port",
// "zend mail smtp security" => "zend mail smtp security",
// "feature group transition" => "feature group transition",
// "feature category transition" => "feature category transition",
// "terminology profile installed" => "terminology profile installed",
// "multidomain active" => "multidomain active",
// "multidomain config" => "multidomain config",
// "tiki minify javascript" => "tiki minify javascript",
// "tiki minify css" => "tiki minify css",
// "tiki minify css single file" => "tiki minify css single file",
// "tiki cachecontrol session" => "tiki cachecontrol session",
// "tiki cachecontrol nosession" => "tiki cachecontrol nosession",
// "tiki cdn" => "tiki cdn",
// "tiki cdn ssl" => "tiki cdn ssl",
// "auth token access" => "auth token access",
// "auth token access maxtimeout" => "auth token access maxtimeout",
// "auth token access maxhits" => "auth token access maxhits",
// "auth token tellafriend" => "auth token tellafriend",
// "auth token share" => "auth token share",
// "print pdf from url" => "print pdf from url",
// "print pdf webkit path" => "print pdf webkit path",
// "print pdf webservice url" => "print pdf webservice url",
// "feature metrics dashboard" => "feature metrics dashboard",
// "metrics trend prefix" => "metrics trend prefix",
// "metrics trend suffix" => "metrics trend suffix",
// "metrics trend novalue" => "metrics trend novalue",
// "metrics pastresults count" => "metrics pastresults count",
// "metrics metric name length" => "metrics metric name length",
// "metrics tab name length" => "metrics tab name length",
// "metrics cache output" => "metrics cache output",
// "payment feature" => "payment feature",
// "payment system" => "payment system",
// "payment currency" => "payment currency",
// "payment default delay" => "payment default delay",
// "payment paypal business" => "payment paypal business",
// "payment paypal environment" => "payment paypal environment",
// "payment paypal ipn" => "payment paypal ipn",
// "payment cclite registries" => "payment cclite registries",
// "payment cclite currencies" => "payment cclite currencies",
// "payment cclite gateway" => "payment cclite gateway",
// "payment cclite merchant key" => "payment cclite merchant key",
// "payment cclite merchant user" => "payment cclite merchant user",
// "payment cclite mode" => "payment cclite mode",
// "payment cclite notify" => "payment cclite notify",
// "payment cclite hashing algorithm" => "payment cclite hashing algorithm",
// "payment manual" => "payment manual",
// "payment invoice prefix" => "payment invoice prefix",
// "rating advanced" => "rating advanced",
// "rating recalculation" => "rating recalculation",
// "rating recalculation odd" => "rating recalculation odd",
// "rating recalculation count" => "rating recalculation count",
// "cas create user tiki" => "cas create user tiki",
// "cas create user tiki ldap" => "cas create user tiki ldap",
// "cas autologin" => "cas autologin",
// "cas skip admin" => "cas skip admin",
// "cas show alternate login" => "cas show alternate login",
// "cas version" => "cas version",
// "cas hostname" => "cas hostname",
// "cas port" => "cas port",
// "cas path" => "cas path",
// "cas extra param" => "cas extra param",
// "cas authentication timeout" => "cas authentication timeout",
// "cas force logout" => "cas force logout",
// "feature comments post as anonymous" => "feature comments post as anonymous",
// "feature comments moderation" => "feature comments moderation",
// "feature comments locking" => "feature comments locking",
// "comments notitle" => "comments notitle",
// "comments field email" => "comments field email",
// "comments field website" => "comments field website",
// "comments vote" => "comments vote",
// "allowMsgs" => "allowMsgs",
// "country" => "country",
// "diff versions" => "diff versions",
// "display timezone" => "display timezone",
// "email is public" => "email is public",
// "homePage" => "homePage",
// "lat" => "lat",
// "lon" => "lon",
// "mess archiveAfter" => "mess archiveAfter",
// "mess maxRecords" => "mess maxRecords",
// "mess sendReadStatus" => "mess sendReadStatus",
// "minPrio" => "minPrio",
// "mytiki blogs" => "mytiki blogs",
// "mytiki articles" => "mytiki articles",
// "mytiki gals" => "mytiki gals",
// "mytiki items" => "mytiki items",
// "mytiki msgs" => "mytiki msgs",
// "mytiki pages" => "mytiki pages",
// "mytiki tasks" => "mytiki tasks",
// "mytiki forum topics" => "mytiki forum topics",
// "mytiki forum replies" => "mytiki forum replies",
// "realName" => "realName",
// "gender" => "gender",
// "show mouseover user info" => "show mouseover user info",
// "tasks maxRecords" => "tasks maxRecords",
// "user dbl" => "user dbl",
// "user information" => "user information",
// "mailCharset" => "mailCharset",
// "mailCurrentAccount" => "mailCurrentAccount",
// "Non Advanced Search or Natural Search" => "Non Advanced Search or Natural Search",
// "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. ",
// "Advanced Search or Boolean Search" => "Advanced Search or Boolean Search",
// "Default search behavior" => "Default search behavior",
// "By default, all search terms are <em>optional</em>" => "By default, all search terms are <em>optional</em>",
// "It behaves like an OR logic" => "It behaves like an OR logic",
// "Objects that contain the more terms are rated higher in the results and will appear first in their type" => "Objects that contain the more terms are rated higher in the results and will appear first in their type",
// "For example, <strong>wiki forum</strong> will find" => "For example, <strong>wiki forum</strong> will find",
// "objects that include both terms" => "objects that include both terms",
// "objects that include the term <strong>wiki</strong>" => "objects that include the term <strong>wiki</strong>",
// "objects that include the term <strong>forum</strong>" => "objects that include the term <strong>forum</strong>",
// "Requiring terms" => "Requiring terms",
// "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results" => "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results",
// "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first" => "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first",
// "Excluding terms" => "Excluding terms",
// "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results" => "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results",
// "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value" => "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value",
// "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>",
// "Grouping terms" => "Grouping terms",
// "Use parenthesis ( ) to group terms into subexpressions" => "Use parenthesis ( ) to group terms into subexpressions",
// "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
// "Finding phrases" => "Finding phrases",
// "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed" => "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed",
// "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. ",
// "Using wildcards" => "Using wildcards",
// "Add an asterisk ( * ) after a term to find objects that include the root word" => "Add an asterisk ( * ) after a term to find objects that include the root word",
// "For example, <strong>run*</strong> will find" => "For example, <strong>run*</strong> will find",
// "objects that include the term <strong>run</strong>" => "objects that include the term <strong>run</strong>",
// "objects that include the term <strong>runner</strong>" => "objects that include the term <strong>runner</strong>",
// "objects that include the term <strong>running</strong>" => "objects that include the term <strong>running</strong>",
// "Reducing a term's value" => "Reducing a term's value",
// "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results",
// "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms" => "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms",
// "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>" => "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>",
// "Changing relevance value" => "Changing relevance value",
// "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object" => "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object",
// "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher" => "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher",
// "Anti-Bot verification code image" => "Anti-Bot verification code image",
// "Share page" => "Share page",
// "Share This" => "Share This",
// "ShareThis via AIM, social bookmarking and networking sites, etc" => "ShareThis via AIM, social bookmarking and networking sites, etc",
// "Read more" => "Read more",
// "Related content" => "Related content",
// "Permalink" => "Permalink",
// "Parent Gallery" => "Parent Gallery",
// "Click Here to Insert in Wiki Syntax" => "Click Here to Insert in Wiki Syntax",
// "top of page" => "top of page",
// "Report this post" => "Report this post",
// "Watched by categories" => "Watched by categories",
// "{\$comments_cant} comment" => "{\$comments_cant} comment",
// "{\$comments_cant} comments" => "{\$comments_cant} comments",
// "Comments are locked" => "Comments are locked",
// "Reply to the selected post" => "Reply to the selected post",
// "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address",
// "(your email address will not be published)" => "(your email address will not be published)",
// "Website" => "Website",
// "Rate this Article (10=best, 0=worse)" => "Rate this Article (10=best, 0=worse)",
// "Send me an e-mail when someone replies" => "Send me an e-mail when someone replies",
// "Reply to parent post" => "Reply to parent post",
// "Post as Anonymous" => "Post as Anonymous",
// "Please note that the preview does not keep the attached file which you will have to choose before posting" => "Please note that the preview does not keep the attached file which you will have to choose before posting",
// "Your comment will have to be approved by the moderator before it is displayed" => "Your comment will have to be approved by the moderator before it is displayed",
// "System error" => "System error",
// "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue",
// "The query was" => "The query was",
// "The built query was likely" => "The built query was likely",
// "Stacktrace" => "Stacktrace",
// "Tiki is unable to connect to the database" => "Tiki is unable to connect to the database",
// "An error occured while performing the request" => "An error occured while performing the request",
// "Tiki Debugger Console" => "Tiki Debugger Console",
// "exec" => "exec",
// "Syntax" => "Syntax",
// "Page generation debugging log" => "Page generation debugging log",
// "Features state" => "Features state",
// "features matched" => "features matched",
// "Watchlist" => "Watchlist",
// "Duplicate permissions" => "Duplicate permissions",
// "There are individual permissions set for this file gallery" => "There are individual permissions set for this file gallery",
// "Podcast (audio)" => "Podcast (audio)",
// "Quota" => "Quota",
// "Used" => "Used",
// "Min" => "Min",
// "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%",
// "Change them here" => "Change them here",
// "Active Perms" => "Active Perms",
// "Upload New Version" => "Upload New Version",
// "Download and lock" => "Download and lock",
// "Open in WebDAV" => "Open in WebDAV",
// "Share a link to this file" => "Share a link to this file",
// "Email a link to this file" => "Email a link to this file",
// "You can ask your site Admin to enable the preference" => "You can ask your site Admin to enable the preference",
// "Start the Slideshow" => "Start the Slideshow",
// "Pause the Slideshow" => "Pause the Slideshow",
// "Exact&nbsp;match" => "Exact&nbsp;match",
// "Orphans" => "Orphans",
// "Clear Filter" => "Clear Filter",
// "Show php error messages" => "Show php error messages",
// "Folksonomy Language" => "Folksonomy Language",
// "Untag" => "Untag",
// "Translate tags" => "Translate tags",
// "Images Galleries" => "Images Galleries",
// "RSS Wiki" => "RSS Wiki",
// "RSS Blogs" => "RSS Blogs",
// "RSS Articles" => "RSS Articles",
// "RSS Image Galleries" => "RSS Image Galleries",
// "RSS File Galleries" => "RSS File Galleries",
// "RSS Forums" => "RSS Forums",
// "RSS Maps" => "RSS Maps",
// "RSS Directories" => "RSS Directories",
// "RSS Calendars" => "RSS Calendars",
// "Are you sure you want to delete the selected files" => "Are you sure you want to delete the selected files",
// "Are you sure you want to reset the default gallery list table settings" => "Are you sure you want to reset the default gallery list table settings",
// "Reset to default gallery list table settings" => "Reset to default gallery list table settings",
// "No Additional Sort" => "No Additional Sort",
// "Hi {\$mail_user|username} has sent you this link" => "Hi {\$mail_user|username} has sent you this link",
// "Somebody or you tried to subscribe this email address at our site" => "Somebody or you tried to subscribe this email address at our site",
// "To the newsletter" => "To the newsletter",
// "In order to confirm your subscription you must access the following URL" => "In order to confirm your subscription you must access the following URL",
// "To validate your account and login to the site, please click on the following link" => "To validate your account and login to the site, please click on the following link",
// "The administrator approved your account" => "The administrator approved your account",
// "Confirm your email at %s" => "Confirm your email at %s",
// "Remove file" => "Remove file",
// "GalleryId" => "GalleryId",
// "FileId" => "FileId",
// "A new message was posted to forum" => "A new message was posted to forum",
// "An anonymous user" => "An anonymous user",
// "has posted a reply to a thread you're watching. \nYou can view the thread and reply at the following URL" => "has posted a reply to a thread you're watching. \nYou can view the thread and reply at the following URL",
// "You are invited by" => "You are invited by",
// "You join this group" => "You join this group",
// "Join me on %s" => "Join me on %s",
// "You sent a request with the subject" => "You sent a request with the subject",
// "Use the subject to indicate the operation to apply" => "Use the subject to indicate the operation to apply",
// "GET:WikiName to get a wiki page" => "GET:WikiName to get a wiki page",
// "PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:WikiName to update/create a wiki page (use the body for the page data)",
// "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)",
// "PREPEND:WikiName to append the data at the top" => "PREPEND:WikiName to append the data at the top",
// "Tiki mail-in instructions" => "Tiki mail-in instructions",
// "Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
// "Hi" => "Hi",
// "A new message was posted to you at {\$mail_machine}" => "A new message was posted to you at {\$mail_machine}",
// "New message arrived from %s" => "New message arrived from %s",
// "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now",
// "To login with your username and password, please follow this link" => "To login with your username and password, please follow this link",
// "Enjoy the site" => "Enjoy the site",
// "User Account Activated" => "User Account Activated",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first",
// "has requested an account on" => "has requested an account on",
// "To validate that account, please follow the link" => "To validate that account, please follow the link",
// "Assign to a group" => "Assign to a group",
// "View user's data" => "View user's data",
// "Best regards" => "Best regards",
// "User Tracker" => "User Tracker",
// "User Registration Request" => "User Registration Request",
// "Go to your friendship network to accept or refuse this request" => "Go to your friendship network to accept or refuse this request",
// "You're invited to join my network of friends" => "You're invited to join my network of friends",
// "The user" => "The user",
// "registered at your site" => "registered at your site",
// "Bye bye" => "Bye bye",
// "This email address has been removed to the list of subscriptors of" => "This email address has been removed to the list of subscriptors of",
// "Bye bye from %s at %s" => "Bye bye from %s at %s",
// "You can unsubscribe from this newsletter following this link" => "You can unsubscribe from this newsletter following this link",
// "Welcome to our newsletter" => "Welcome to our newsletter",
// "This email address has been added to the list of subscriptors of" => "This email address has been added to the list of subscriptors of",
// "You can always cancel your subscription using" => "You can always cancel your subscription using",
// "Welcome to %s at %s" => "Welcome to %s at %s",
// "Reply notification" => "Reply notification",
// "Someone" => "Someone",
// "requested a reminder of the password for your account" => "requested a reminder of the password for your account",
// "requested password reset for your account" => "requested password reset for your account",
// "Since this is your registered email address we inform that the password for this account is" => "Since this is your registered email address we inform that the password for this account is",
// "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else",
// "Important: Username & password are CaSe SenSitiVe" => "Important: Username & password are CaSe SenSitiVe",
// "Important: The old password remains active if you don't click the link above" => "Important: The old password remains active if you don't click the link above",
// "Your account information for %s" => "Your account information for %s",
// "Report for" => "Report for",
// "Last Report sent on" => "Last Report sent on",
// "Changes in detail" => "Changes in detail",
// "Look at this link" => "Look at this link",
// "A friend sends you a link from: " => "A friend sends you a link from: ",
// "A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime}",
// "You can edit the submission following this link" => "You can edit the submission following this link",
// "New article submitted at %s" => "New article submitted at %s",
// "ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}",
// "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}" => "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}",
// "Download the file at" => "Download the file at",
// "item" => "item",
// "was modified at" => "was modified at",
// "Please visit this link before login again" => "Please visit this link before login again",
// "Last attempt" => "Last attempt",
// "Confirm your account at %s" => "Confirm your account at %s",
// "An administrator of the site below has added you as a new user" => "An administrator of the site below has added you as a new user",
// "If you want to confirm your membership in this site, click on the following link to login for the first time" => "If you want to confirm your membership in this site, click on the following link to login for the first time",
// "Your authentication credentials are" => "Your authentication credentials are",
// "Welcome on the site" => "Welcome on the site",
// "Your personal access to" => "Your personal access to",
// "You or someone registered this email address at" => "You or someone registered this email address at",
// "If you want to be a registered user in this site you will have to use the following link to login for the first time" => "If you want to be a registered user in this site you will have to use the following link to login for the first time",
// "Your registration confirmation" => "Your registration confirmation",
// "Your account request has been stored and will be activated by the admin as soon as possible" => "Your account request has been stored and will be activated by the admin as soon as possible",
// "You'll receive email notification once your account is activated" => "You'll receive email notification once your account is activated",
// "Please do not attempt to login until you receive the email notification" => "Please do not attempt to login until you receive the email notification",
// "{\$mail_action} article post" => "{\$mail_action} article post",
// "{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} by {\$mail_user|username} at",
// "New article post" => "New article post",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
// "View the article at" => "View the article at",
// "If you don't want to receive these notifications follow this link" => "If you don't want to receive these notifications follow this link",
// "{\$mail_action} article post at" => "{\$mail_action} article post at",
// "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "View the blog at" => "View the blog at",
// "New blog post at %s" => "New blog post at %s",
// "View item calendar at" => "View item calendar at",
// "Modified calendar item" => "Modified calendar item",
// "New calendar item" => "New calendar item",
// "changed" => "changed",
// "A new category was created in" => "A new category was created in",
// "A category was removed in" => "A category was removed in",
// "Removed by" => "Removed by",
// "removed" => "removed",
// "A category was updated" => "A category was updated",
// "Updated by" => "Updated by",
// "updated" => "updated",
// "File Gallery %s changed" => "File Gallery %s changed",
// "A file was removed from the file gallery" => "A file was removed from the file gallery",
// "A new file was posted to file gallery" => "A new file was posted to file gallery",
// "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "Image Gallery {\$galleryName} changed" => "Image Gallery {\$galleryName} changed",
// "A new file was posted to image gallery" => "A new file was posted to image gallery",
// "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "You can view the updated map following this link" => "You can view the updated map following this link",
// "You can edit the map following this link" => "You can edit the map following this link",
// "A page has been added to your watched sub-structure" => "A page has been added to your watched sub-structure",
// "A page has been removed from your watched sub-structure" => "A page has been removed from your watched sub-structure",
// "A page has been promoted out your watched sub-structure" => "A page has been promoted out your watched sub-structure",
// "A page has been demoted to your watched structure" => "A page has been demoted to your watched structure",
// "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "A file was attached to {\$mail_page}" => "A file was attached to {\$mail_page}",
// "The page {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "The page {\$mail_page} was deleted but used to be here" => "The page {\$mail_page} was deleted but used to be here",
// "You can view the page by following this link" => "You can view the page by following this link",
// "You can view a diff back to the previous version by following this link" => "You can view a diff back to the previous version by following this link",
// "The changes in this version follow below, followed after by the current full page text" => "The changes in this version follow below, followed after by the current full page text",
// "-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Lines: {\$oldd} changed to +Lines: {\$newd}",
// "The old page content follows below" => "The old page content follows below",
// "Wiki page %s created by {\$mail_user|username}" => "Wiki page %s created by {\$mail_user|username}",
// "Wiki page %s deleted by {\$mail_user|username}" => "Wiki page %s deleted by {\$mail_user|username}",
// "A file was attached to %s" => "A file was attached to %s",
// "Wiki page %s changed by {\$mail_user|username}" => "Wiki page %s changed by {\$mail_user|username}",
// "The page {\$mail_page} was commented by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was commented by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "click on the map to zoom or pan, do not drag" => "click on the map to zoom or pan, do not drag",
// "Query Results" => "Query Results",
// "Querying" => "Querying",
// "Scroll Up" => "Scroll Up",
// "Scroll Down" => "Scroll Down",
// "Scale" => "Scale",
// "Zoom out" => "Zoom out",
// "Query" => "Query",
// "Pan" => "Pan",
// "Zoom in" => "Zoom in",
// "Redraw" => "Redraw",
// "select zoom/pan/query and image size" => "select zoom/pan/query and image size",
// "View the Map Only" => "View the Map Only",
// "Reset Map" => "Reset Map",
// "Click on the map or click redraw" => "Click on the map or click redraw",
// "Overview" => "Overview",
// "Layer Manager" => "Layer Manager",
// "Layer" => "Layer",
// "Download Layer" => "Download Layer",
// "This layer has been set by the maps administrator to not be downloadable" => "This layer has been set by the maps administrator to not be downloadable",
// "you have requested to download the layer" => "you have requested to download the layer",
// "from the mapfile" => "from the mapfile",
// "Here are the files to download, do not forget to rename them" => "Here are the files to download, do not forget to rename them",
// "Mapfile" => "Mapfile",
// "hits last 7 days" => "hits last 7 days",
// "monitor this map" => "monitor this map",
// "Stop Monitoring this Map" => "Stop Monitoring this Map",
// "Create a new mapfile" => "Create a new mapfile",
// "Mapfile listing" => "Mapfile listing",
// "You can view this map in your browser using" => "You can view this map in your browser using",
// "Zoom out x2" => "Zoom out x2",
// "Zoom in x2" => "Zoom in x2",
// "Mapfile History" => "Mapfile History",
// "Comparing version {\$old.version} with version {\$new.version}" => "Comparing version {\$old.version} with version {\$new.version}",
// "back to" => "back to",
// "Bytes maximum" => "Bytes maximum",
// "index file (.shp)" => "index file (.shp)",
// "files to index (regexp)" => "files to index (regexp)",
// "Message Archive" => "Message Archive",
// "Confirmation" => "Confirmation",
// "Please Confirm" => "Please Confirm",
// "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences" => "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences",
// "Multiple addresses can be separated with semicolons (\\\";\\\")" => "Multiple addresses can be separated with semicolons (\\\";\\\")",
// "or commas (\\\",\\\")" => "or commas (\\\",\\\")",
// "The user will be able to reply to you directly via email" => "The user will be able to reply to you directly via email",
// "You will be sent a copy of this email" => "You will be sent a copy of this email",
// "is reply to" => "is reply to",
// "Find replied message" => "Find replied message",
// "Auto-archive age for read messages" => "Auto-archive age for read messages",
// "Return to mailbox" => "Return to mailbox",
// "Unflag" => "Unflag",
// "Cc" => "Cc",
// "Return to archive" => "Return to archive",
// "Return to outbox" => "Return to outbox",
// "Sent Messages" => "Sent Messages",
// "Not replied" => "Not replied",
// "move to archive" => "move to archive",
// "receiver" => "receiver",
// "'name' parameter for tikimodule missed" => "'name' parameter for tikimodule missed",
// "Move module up" => "Move module up",
// "Move module down" => "Move module down",
// "Move module to opposite side" => "Move module to opposite side",
// "opp side" => "opp side",
// "Unassign this module" => "Unassign this module",
// "Are you sure you want to unassign this module" => "Are you sure you want to unassign this module",
// "Toggle module contents" => "Toggle module contents",
// "Toggle Vertically" => "Toggle Vertically",
// "Display type unknown, you have to enter the banner type" => "Display type unknown, you have to enter the banner type",
// "You forgot your Google ad_client number " => "You forgot your Google ad_client number ",
// "To configure your Tiki" => "To configure your Tiki",
// "from the menu" => "from the menu",
// "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>",
// "Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies",
// "To remove this module" => "To remove this module",
// "and remove the assistant module" => "and remove the assistant module",
// "You can also add other modules" => "You can also add other modules",
// "To customize the menu" => "To customize the menu",
// "and edit menu ID 42" => "and edit menu ID 42",
// "Or, create your own menu and add it to a module" => "Or, create your own menu and add it to a module",
// "To begin configuring Tiki, please" => "To begin configuring Tiki, please",
// "as admin" => "as admin",
// "The Tikiwiki Community" => "The Tikiwiki Community",
// "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tiki.org</a>" => "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tiki.org</a>",
// "Tikiwiki Documentation" => "Tikiwiki Documentation",
// "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>",
// "Published on" => "Published on",
// "on blogpost" => "on blogpost",
// "Untitled" => "Untitled",
// "Unit cost" => "Unit cost",
// "Qty" => "Qty",
// "Check-out" => "Check-out",
// "Your cart is empty" => "Your cart is empty",
// "Missing %0 of the following categories" => "Missing %0 of the following categories",
// "%0 extra of the following categories" => "%0 extra of the following categories",
// "Unknown comparison" => "Unknown comparison",
// "Impossible condition, %0 of" => "Impossible condition, %0 of",
// "Assign into category" => "Assign into category",
// "Unassign category" => "Unassign category",
// "low" => "low",
// "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes",
// "All Groups" => "All Groups",
// "Your Groups" => "Your Groups",
// "Emulated Groups" => "Emulated Groups",
// "Switch to Groups" => "Switch to Groups",
// "Simulate" => "Simulate",
// "Last `\$module_rows` Podcasts" => "Last `\$module_rows` Podcasts",
// "This is likely not a podcast file" => "This is likely not a podcast file",
// "The path to a podcast player is required" => "The path to a podcast player is required",
// "You" => "You",
// "Enter user name and click 'Switch'.<br />Useful for testing permissions" => "Enter user name and click 'Switch'.<br />Useful for testing permissions",
// "Log in through CAS" => "Log in through CAS",
// "Log in as admin" => "Log in as admin",
// "Log in through Shibboleth" => "Log in through Shibboleth",
// "CapsLock is on" => "CapsLock is on",
// "Click here to register" => "Click here to register",
// "Click here if you've forgotten your password" => "Click here if you've forgotten your password",
// "Click here to login using the default security protocol" => "Click here to login using the default security protocol",
// "Standard" => "Standard",
// "Click here to login using a secure protocol" => "Click here to login using a secure protocol",
// "local account" => "local account",
// "OpenID Log in" => "OpenID Log in",
// "What is OpenID" => "What is OpenID",
// "Stay on this page" => "Stay on this page",
// "Edit perspectives" => "Edit perspectives",
// "Description (used for metatags)" => "Description (used for metatags)",
// "Paste content here" => "Paste content here",
// "Wiki feed" => "Wiki feed",
// "Feed" => "Feed",
// "Blogs feed" => "Blogs feed",
// "Articles feed" => "Articles feed",
// "Image Galleries feed" => "Image Galleries feed",
// "File Galleries feed" => "File Galleries feed",
// "Forums feed" => "Forums feed",
// "Maps feed" => "Maps feed",
// "Search Help" => "Search Help",
// "Search for text throughout the site" => "Search for text throughout the site",
// "Go directly to a page, or search in page titles if exact match is not found" => "Go directly to a page, or search in page titles if exact match is not found",
// "Edit existing page or create a new one" => "Edit existing page or create a new one",
// "Page Relations" => "Page Relations",
// "Are you sure you want to delete this shout" => "Are you sure you want to delete this shout",
// "Tweet with twitter" => "Tweet with twitter",
// "Post on my facebook wall" => "Post on my facebook wall",
// "Shout date" => "Shout date",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
// "New Tracker Items" => "New Tracker Items",
// "New Calendar Events" => "New Calendar Events",
// "`\$module_params.prefix`" => "`\$module_params.prefix`",
// "Find term" => "Find term",
// "If not found, you will be given a chance to create it" => "If not found, you will be given a chance to create it",
// "TikiTests Menu" => "TikiTests Menu",
// "List Tests" => "List Tests",
// "Create Test" => "Create Test",
// "Posted to" => "Posted to",
// "(Read More)" => "(Read More)",
// "Tracker name" => "Tracker name",
// "To <strong>continue translating</strong>, select the language to translate from" => "To <strong>continue translating</strong>, select the language to translate from",
// "click to view" => "click to view",
// "Done" => "Done",
// "select" => "select",
// "Group information" => "Group information",
// "You need to activate user and/or group trackers" => "You need to activate user and/or group trackers",
// "Webmail inbox" => "Webmail inbox",
// "Refresh (non-ajax)" => "Refresh (non-ajax)",
// "TAKE" => "TAKE",
// "View contact" => "View contact",
// "on host" => "on host",
// "User does not accept messages" => "User does not accept messages",
// "Send a message" => "Send a message",
// "More Videos" => "More Videos",
// "Old Session" => "Old Session",
// "Old Version" => "Old Version",
// "New Session" => "New Session",
// "New Version" => "New Version",
// "[-]" => "[-]",
// "Reset to default" => "Reset to default",
// "{\$customfields[ir].label}" => "{\$customfields[ir].label}",
// "Minimum {\$prefs.min_username_length} characters long" => "Minimum {\$prefs.min_username_length} characters long",
// "Lowercase only" => "Lowercase only",
// "Minimum {\$prefs.min_pass_length} characters long" => "Minimum {\$prefs.min_pass_length} characters long",
// "Passcode to register" => "Passcode to register",
// "Not your password" => "Not your password",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "Download Log File" => "Download Log File",
// "To edit the copyright notices" => "To edit the copyright notices",
// "The content on this page is licensed under the terms of the" => "The content on this page is licensed under the terms of the",
// "absE" => "absE",
// "Design by" => "Design by",
// "Jump to Content" => "Jump to Content",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Show/Hide Left Menus" => "Show/Hide Left Menus",
// "Show/Hide Right Menus" => "Show/Hide Right Menus",
// "Module errors" => "Module errors",
// "The following modules could not be loaded" => "The following modules could not be loaded",
// "Preference was not set" => "Preference was not set",
// "Report to Webmaster" => "Report to Webmaster",
// "Wiki RSS" => "Wiki RSS",
// "RSS feed" => "RSS feed",
// "Articles RSS" => "Articles RSS",
// "Image Galleries RSS" => "Image Galleries RSS",
// "File Galleries RSS" => "File Galleries RSS",
// "The Tiki Community" => "The Tiki Community",
// "Execution time" => "Execution time",
// "Memory usage" => "Memory usage",
// "database queries used in " => "database queries used in ",
// "Server load" => "Server load",
// "Login through CAS" => "Login through CAS",
// "Login through Shibboleth" => "Login through Shibboleth",
// "Designed originally by" => "Designed originally by",
// "Note: The search index needs rebuilding, this will take a few minutes" => "Note: The search index needs rebuilding, this will take a few minutes",
// "Search error" => "Search error",
// "Preferences Search Results" => "Preferences Search Results",
// "No results" => "No results",
// "No preferences were found for your search query" => "No preferences were found for your search query",
// "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>" => "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>",
// "Enabled" => "Enabled",
// "Changed" => "Changed",
// "Preference name" => "Preference name",
// "phpinfo" => "phpinfo",
// "DSN" => "DSN",
// "Search Stats" => "Search Stats",
// "Please select some actions to be reported" => "Please select some actions to be reported",
// "Users and Groups" => "Users and Groups",
// "Units" => "Units",
// "kb" => "kb",
// "Contibution Time" => "Contibution Time",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "See Statistics" => "See Statistics",
// "Pagination" => "Pagination",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volumen per category" => "Volumen per category",
// "Volumn per category and per user" => "Volumn per category and per user",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volume per the users'group and per contribution" => "Volume per the users'group and per contribution",
// "Volume per group and per contribution" => "Volume per group and per contribution",
// "Volume per user and per contribution" => "Volume per user and per contribution",
// "Volume per users' contribution and time" => "Volume per users' contribution and time",
// "How" => "How",
// "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occured since the action type has been set to recorded" => "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occured since the action type has been set to recorded",
// "Recorded" => "Recorded",
// "Reported" => "Reported",
// "Add or edit rules" => "Add or edit rules",
// "Multiple IP regex matching" => "Multiple IP regex matching",
// "Name field is mandatory" => "Name field is mandatory",
// "Template Type" => "Template Type",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
// "cookie" => "cookie",
// "Manage Credits" => "Manage Credits",
// "(YYYY-MM-DD HH:MM:SS)" => "(YYYY-MM-DD HH:MM:SS)",
// "(level credits always 0)" => "(level credits always 0)",
// "Delete Checked" => "Delete Checked",
// "User Credits Expiry Summary (Plans)" => "User Credits Expiry Summary (Plans)",
// "User Plan" => "User Plan",
// "Start of Latest Plan" => "Start of Latest Plan",
// "Start of Next Plan" => "Start of Next Plan",
// "Expiry" => "Expiry",
// "Use User Credits" => "Use User Credits",
// "Amount" => "Amount",
// "Restore User Level Credits" => "Restore User Level Credits",
// "Historical Usage Report" => "Historical Usage Report",
// "Usage Date" => "Usage Date",
// "Amount Used" => "Amount Used",
// "Manage Credit Types" => "Manage Credit Types",
// "Display Text" => "Display Text",
// "Unit Text" => "Unit Text",
// "Is Static Level Credit" => "Is Static Level Credit",
// "Display Bar Length Scaling Divisor" => "Display Bar Length Scaling Divisor",
// "Purge Expired and Used Credits (All Users)" => "Purge Expired and Used Credits (All Users)",
// "Purge" => "Purge",
// "Create/edit DSN" => "Create/edit DSN",
// "Local (Tiki database)" => "Local (Tiki database)",
// "See db/local.php" => "See db/local.php",
// "Admin External Wikis" => "Admin External Wikis",
// "Create/Edit External Wiki" => "Create/Edit External Wiki",
// "ExtWiki" => "ExtWiki",
// "PPD" => "PPD",
// ".." => "..",
// "Online" => "Online",
// "Set thread preferences" => "Set thread preferences",
// "Show threads preferences" => "Show threads preferences",
// "hide threads preferences" => "hide threads preferences",
// "Default style for threads" => "Default style for threads",
// "Global site configuration, date formats, admin password etc" => "Global site configuration, date formats, admin password etc",
// "Switches for major features" => "Switches for major features",
// "User registration, remember me cookie settings and authentication methods" => "User registration, remember me cookie settings and authentication methods",
// "User specific features and settings" => "User specific features and settings",
// "Repository configuration, browse and apply profiles" => "Repository configuration, browse and apply profiles",
// "Theme selection, layout settings and UI effect controls" => "Theme selection, layout settings and UI effect controls",
// "i18n" => "i18n",
// "Internationalization and localization - mulitlingual features" => "Internationalization and localization - mulitlingual features",
// "Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Text editing settings applicable to many areas. Plugin activation and plugin alias management",
// "Module appearance settings" => "Module appearance settings",
// "Information to include in the header of each page" => "Information to include in the header of each page",
// "Server performance settings" => "Server performance settings",
// "Site security settings" => "Site security settings",
// "Comments settings" => "Comments settings",
// "Web feeds" => "Web feeds",
// "Wiki page settings and features" => "Wiki page settings and features",
// "Defaults and configuration for file galleries" => "Defaults and configuration for file galleries",
// "Settings for blogs" => "Settings for blogs",
// "Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Defaults and configuration for image galleries (will be phased out in favour of file galleries)",
// "Settings and features for articles" => "Settings and features for articles",
// "Settings and features for forums" => "Settings and features for forums",
// "Settings and features for trackers" => "Settings and features for trackers",
// "Settings and features for polls" => "Settings and features for polls",
// "Settings and features for calendars" => "Settings and features for calendars",
// "Settings and features for categories" => "Settings and features for categories",
// "Values of actions for users rank score" => "Values of actions for users rank score",
// "Settings and features for freetags" => "Settings and features for freetags",
// "Search configuration" => "Search configuration",
// "Settings and features for FAQs" => "Settings and features for FAQs",
// "Settings and features for directory of links" => "Settings and features for directory of links",
// "Settings and features for maps" => "Settings and features for maps",
// "Defaults and API key for Google Maps" => "Defaults and API key for Google Maps",
// "Site-wide copyright information" => "Site-wide copyright information",
// "Message settings" => "Message settings",
// "User files settings" => "User files settings",
// "Webmail settings" => "Webmail settings",
// "Options for WYSIWYG editor" => "Options for WYSIWYG editor",
// "?" => "?",
// "InterTiki" => "InterTiki",
// "Set up links between Tiki servers" => "Set up links between Tiki servers",
// "Manage semantic wiki links" => "Manage semantic wiki links",
// "Register and manage web services" => "Register and manage web services",
// "Sef URL" => "Sef URL",
// "Search Engine Friendly URLs" => "Search Engine Friendly URLs",
// "Video integration configuration" => "Video integration configuration",
// "Configure social networks integration" => "Configure social networks integration",
// "To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or",
// "Sharing on social networks" => "Sharing on social networks",
// "Blogs Listings" => "Blogs Listings",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
// "All calendars" => "All calendars",
// "A subset of available calendars" => "A subset of available calendars",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
// "With PHPlayers, watch icons are only visible for the top category" => "With PHPlayers, watch icons are only visible for the top category",
// "Article properties" => "Article properties",
// "Give only one value (width or height) to keep the image proportions" => "Give only one value (width or height) to keep the image proportions",
// "Article View" => "Article View",
// "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU",
// "Join the community" => "Join the community",
// "Promote your site" => "Promote your site",
// "To submit your site to Tiki.org" => "To submit your site to Tiki.org",
// "Submit site" => "Submit site",
// "Help Tiki spread" => "Help Tiki spread",
// "Help improve Tiki" => "Help improve Tiki",
// "To submit a feature request or to report a bug" => "To submit a feature request or to report a bug",
// "Click here to go to our development site" => "Click here to go to our development site",
// "Global features" => "Global features",
// "Main feature" => "Main feature",
// "Additional" => "Additional",
// "Interface" => "Interface",
// "AJAX" => "AJAX",
// "jQuery plugins and add-ons" => "jQuery plugins and add-ons",
// "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application" => "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application",
// "Getting there.." => "Getting there..",
// "Most of these features are hoped to make it into the \"new\" section for Tiki 6" => "Most of these features are hoped to make it into the \"new\" section for Tiki 6",
// "Fresh out of the oven" => "Fresh out of the oven",
// "Seem ok but.." => "Seem ok but..",
// "These features are not reported to be broken, but they are not actively developed and/or widely used" => "These features are not reported to be broken, but they are not actively developed and/or widely used",
// "Will be phased out" => "Will be phased out",
// "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology" => "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology",
// "Feedback" => "Feedback",
// "To create or remove file galleries, select" => "To create or remove file galleries, select",
// "from the application menu" => "from the application menu",
// "Move files from database to directory" => "Move files from database to directory",
// "Move files from directory to database" => "Move files from directory to database",
// "Manage comment settings" => "Manage comment settings",
// "Score is disabled" => "Score is disabled",
// "A cron job must be set up in order to delete the files" => "A cron job must be set up in order to delete the files",
// "Admin Gallery Listings" => "Admin Gallery Listings",
// "Select which items to display when admin galleries: " => "Select which items to display when admin galleries: ",
// "Automatically index files on upload or change" => "Automatically index files on upload or change",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "Missing Handlers" => "Missing Handlers",
// "System Command" => "System Command",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all characters" => "Accept all characters",
// "3D Tag Browser Configuration" => "3D Tag Browser Configuration",
// "Camera settings" => "Camera settings",
// "Pixels Default" => "Pixels Default",
// "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences" => "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences",
// "Redirects" => "Redirects",
// "Date and Time" => "Date and Time",
// "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details" => "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details",
// "Map mode in listings" => "Map mode in listings",
// "Syntax error" => "Syntax error",
// "Cannot open/write this file" => "Cannot open/write this file",
// "Custom translation will not be saved. Ask your administration to change the permission" => "Custom translation will not be saved. Ask your administration to change the permission",
// "ok" => "ok",
// "The file has been saved" => "The file has been saved",
// "Wysiwyg" => "Wysiwyg",
// "Video streaming integration" => "Video streaming integration",
// "Social Networks" => "Social Networks",
// "Requires PHP GD library" => "Requires PHP GD library",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Assign users to group function of email pattern" => "Assign users to group function of email pattern",
// "You must change the Authentication Method to LDAP for these changes to take effect" => "You must change the Authentication Method to LDAP for these changes to take effect",
// "LDAP Bind settings" => "LDAP Bind settings",
// "LDAP User" => "LDAP User",
// "LDAP Group" => "LDAP Group",
// "LDAP Group Member - if group membership can be found in group attributes" => "LDAP Group Member - if group membership can be found in group attributes",
// "LDAP User Group - if group membership can be found in user attributes" => "LDAP User Group - if group membership can be found in user attributes",
// "LDAP Admin" => "LDAP Admin",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "CAS" => "CAS",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "CAS Server" => "CAS Server",
// "CAS Server Name" => "CAS Server Name",
// "CAS Server Port" => "CAS Server Port",
// "CAS Server Path" => "CAS Server Path",
// "phpBB User Database Authentication " => "phpBB User Database Authentication ",
// "You must change the Authentication Method to phpBB for these changes to take effect" => "You must change the Authentication Method to phpBB for these changes to take effect",
// "You must turn Users can register off for phpBB Authentication to function properly" => "You must turn Users can register off for phpBB Authentication to function properly",
// "MySql only (for now)" => "MySql only (for now)",
// "Web Server Authentication " => "Web Server Authentication ",
// "You must change the Authentication Method to Web Server for these changes to take effect" => "You must change the Authentication Method to Web Server for these changes to take effect",
// "Theme Screenshot" => "Theme Screenshot",
// "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for <em>all</em> users" => "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for <em>all</em> users",
// "Experimental: CSS assistant (work in progress - click the x to remove)" => "Experimental: CSS assistant (work in progress - click the x to remove)",
// "Favicon" => "Favicon",
// "Context Menus" => "Context Menus",
// "Configure metrics" => "Configure metrics",
// "Show past results" => "Show past results",
// "Past results count" => "Past results count",
// "Hint: If you lose your login module, use tiki-login_scr.php to be able to login" => "Hint: If you lose your login module, use tiki-login_scr.php to be able to login",
// "Payments" => "Payments",
// "Choose payment system" => "Choose payment system",
// "You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "You can use only one payment method: PayPal or Cclite or Tiki User Credits",
// "PayPal is working at the moment. See PayPal.com" => "PayPal is working at the moment. See PayPal.com",
// "Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite: Community currency accounting for local exchange trading systems (LETS). See ",
// "sourceforge.net" => "sourceforge.net",
// "Tiki User Credits: Requires this other feature to be configured" => "Tiki User Credits: Requires this other feature to be configured",
// "Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite is for creating and managing alternative or complementary trading currencies and groups",
// "Work in progress for Tiki 6" => "Work in progress for Tiki 6",
// "Shipping" => "Shipping",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site",
// "Bytecode Cache" => "Bytecode Cache",
// "Using <strong>%0</strong>.These stats affect all PHP applications running on the server" => "Using <strong>%0</strong>.These stats affect all PHP applications running on the server",
// "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache",
// "Available" => "Available",
// "Hit" => "Hit",
// "Miss" => "Miss",
// "Cache Hits" => "Cache Hits",
// "Few hits recorded. Statistics may not be representative" => "Few hits recorded. Statistics may not be representative",
// "Little memory available. Thrashing likely to occur" => "Little memory available. Thrashing likely to occur",
// "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates" => "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates",
// "<em>%0</em> should not be disabled due to authentication on XCache" => "<em>%0</em> should not be disabled due to authentication on XCache",
// "Bytecode cache is not used. Using a bytecode cache (APC, XCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (APC, XCache) is highly recommended for production environments",
// "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Changing this feature will immediately log you out when you save this preference" => "Changing this feature will immediately log you out when you save this preference",
// "Loading profile" => "Loading profile",
// "Are you sure you want to apply the profile" => "Are you sure you want to apply the profile",
// "Are you sure you want to re-apply the profile" => "Are you sure you want to re-apply the profile",
// "Sending" => "Sending",
// "Tiki Profiles" => "Tiki Profiles",
// "Apply Profiles" => "Apply Profiles",
// "A Friendly Warning" => "A Friendly Warning",
// "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles",
// "Option 1: Quick Filter" => "Option 1: Quick Filter",
// "Option 2: Manual Filter" => "Option 2: Manual Filter",
// "applied" => "applied",
// "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again" => "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again",
// "Profile tester" => "Profile tester",
// "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below",
// "This will run the profile and make potentially unrecoverable changes in your database" => "This will run the profile and make potentially unrecoverable changes in your database",
// "Test Profile Name" => "Test Profile Name",
// "Global configuration" => "Global configuration",
// "Cache duration" => "Cache duration",
// "Feed for articles" => "Feed for articles",
// "Feed for blogs" => "Feed for blogs",
// "Feed for individual blogs" => "Feed for individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Feed for individual image galleries" => "Feed for individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Feed for directories" => "Feed for directories",
// "Feed for maps" => "Feed for maps",
// "Feed for shoutbox" => "Feed for shoutbox",
// "Admin modules" => "Admin modules",
// "The Tiki search indexes must be refreshed if you turn the Tiki search on" => "The Tiki search indexes must be refreshed if you turn the Tiki search on",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "General Security" => "General Security",
// "HTTPS (SSL) and other login preferences" => "HTTPS (SSL) and other login preferences",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "Spam protection" => "Spam protection",
// "Captcha" => "Captcha",
// "Tokens" => "Tokens",
// "Clipperz online password management" => "Clipperz online password management",
// "Tiki doesn't offer a built-in password management feature" => "Tiki doesn't offer a built-in password management feature",
// "Learn more about Clipperz" => "Learn more about Clipperz",
// "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file" => "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file",
// "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>" => "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>",
// "If you need to keep an existing (non Tiki) .htaccess file, just add Tiki directives to it" => "If you need to keep an existing (non Tiki) .htaccess file, just add Tiki directives to it",
// "When you upgrade (ex.: from Tiki4 to Tiki5), make sure to use the new _htaccess file" => "When you upgrade (ex.: from Tiki4 to Tiki5), make sure to use the new _htaccess file",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Twitter Settings" => "Twitter Settings",
// "To use Twitter integration, you must register this site as an application at" => "To use Twitter integration, you must register this site as an application at",
// "and allow write access for the application" => "and allow write access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL",
// "Facebook Settings" => "Facebook Settings",
// "To use Facebook integration, you must register this site as an application at" => "To use Facebook integration, you must register this site as an application at",
// "and allow extended access for the application" => "and allow extended access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain",
// "bit.ly Settings" => "bit.ly Settings",
// "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics",
// "to sign up for an account" => "to sign up for an account",
// "to retrieve the API key" => "to retrieve the API key",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Check disabled plugins used in wiki pages" => "Check disabled plugins used in wiki pages",
// "Disabled used plugins" => "Disabled used plugins",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Delete Plugins" => "Delete Plugins",
// "Click on the plugin name to edit it" => "Click on the plugin name to edit it",
// "Click on the + icon to add a new one" => "Click on the + icon to add a new one",
// "Argument" => "Argument",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Switch storage" => "Switch storage",
// "To get a Kaltura Partner ID" => "To get a Kaltura Partner ID",
// "Setup your own instance of Kaltura Community Edition (CE)" => "Setup your own instance of Kaltura Community Edition (CE)",
// "get an account via Kaltura.com" => "get an account via Kaltura.com",
// "Kaltura Partner Settings" => "Kaltura Partner Settings",
// "Kaltura Contribution Wizard" => "Kaltura Contribution Wizard",
// "Ustream Watershed Registration" => "Ustream Watershed Registration",
// "If you don't have a Watershed account, " => "If you don't have a Watershed account, ",
// "you can find out more about it here" => "you can find out more about it here",
// "Configuration within Watershed" => "Configuration within Watershed",
// "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock" => "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock",
// "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat" => "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat",
// "Basic tracker settings" => "Basic tracker settings",
// "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"" => "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"",
// "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)" => "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)",
// "Archive settings (optional)" => "Archive settings (optional)",
// "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication" => "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Engine" => "Engine",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
// "If you change storage, it is better to move all the files for easy backup.." => "If you change storage, it is better to move all the files for easy backup..",
// "Wiki 3D Browser Configuration" => "Wiki 3D Browser Configuration",
// "Mass search and replace" => "Mass search and replace",
// "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>",
// "Page links" => "Page links",
// "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature" => "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature",
// "Related features" => "Related features",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
// "Edit Repository" => "Edit Repository",
// "Create New Repository" => "Create New Repository",
// "List Repositories" => "List Repositories",
// "New Repository" => "New Repository",
// "View Repository" => "View Repository",
// "Human-readable repository name" => "Human-readable repository name",
// "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')",
// "File name of start page" => "File name of start page",
// "CSS file to load when browse this repository" => "CSS file to load when browse this repository",
// "Is repository visible to users" => "Is repository visible to users",
// "Can files from repository be cached" => "Can files from repository be cached",
// "Cacheable" => "Cacheable",
// "Are files from repository can be cached" => "Are files from repository can be cached",
// "Clear all cached pages of this repository" => "Clear all cached pages of this repository",
// "Seconds count 'till cached page will be expired" => "Seconds count 'till cached page will be expired",
// "Cache expiration" => "Cache expiration",
// "Human-readable text description of repository" => "Human-readable text description of repository",
// "Available Repositories" => "Available Repositories",
// "Edit rules" => "Edit rules",
// "Edit Rules for Repository" => "Edit Rules for Repository",
// "Configure Repositories" => "Configure Repositories",
// "Configure this Repository" => "Configure this Repository",
// "View this Repository" => "View this Repository",
// "view/hide copy rules dialog" => "view/hide copy rules dialog",
// "Source repository" => "Source repository",
// "According this order rules will be applied ('0' or empty = auto)" => "According this order rules will be applied ('0' or empty = auto)",
// "Rule order" => "Rule order",
// "Text to search for" => "Text to search for",
// "Text to replace" => "Text to replace",
// "Is this regular expression or simple search/replacer" => "Is this regular expression or simple search/replacer",
// "Regex" => "Regex",
// "Is case sensitive (for simple replacer)" => "Is case sensitive (for simple replacer)",
// "Case sensitive" => "Case sensitive",
// "subset of chars: imsxeADSXUu, which is regex modifiers" => "subset of chars: imsxeADSXUu, which is regex modifiers",
// "Regex modifiers" => "Regex modifiers",
// "Human-readable text description of rule" => "Human-readable text description of rule",
// "Check to enable this rule" => "Check to enable this rule",
// "Preview options" => "Preview options",
// "Apply all rules or just this to generate preview" => "Apply all rules or just this to generate preview",
// "Apply all rules" => "Apply all rules",
// "View source code after rules applied" => "View source code after rules applied",
// "Code preview" => "Code preview",
// "Generate HTML preview" => "Generate HTML preview",
// "HTML preview" => "HTML preview",
// "Test file from repository to generate preview for (empty = configured start page)" => "Test file from repository to generate preview for (empty = configured start page)",
// "Preview Results" => "Preview Results",
// "Rules List" => "Rules List",
// "Case" => "Case",
// "Admin keywords" => "Admin keywords",
// "Keywords have been updated" => "Keywords have been updated",
// "Updating keywords has failed. Page probably doesn't exist" => "Updating keywords has failed. Page probably doesn't exist",
// "Edit page keywords" => "Edit page keywords",
// "Current Page Keywords" => "Current Page Keywords",
// "Search by page" => "Search by page",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
// "Discard to the end from" => "Discard to the end from",
// "mn" => "mn",
// "Manage menu" => "Manage menu",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "Import/export menu" => "Import/export menu",
// "Active Permissions" => "Active Permissions",
// "Configure icons for menu entries" => "Configure icons for menu entries",
// "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu",
// "Admin Metrics" => "Admin Metrics",
// "Admin Metrics Template" => "Admin Metrics Template",
// "Metrics" => "Metrics",
// "Assign Metrics" => "Assign Metrics",
// "Assigned Metrics" => "Assigned Metrics",
// "Edit/Create Metrics" => "Edit/Create Metrics",
// "Edit/Create Tab" => "Edit/Create Tab",
// "Data Type" => "Data Type",
// "Weight" => "Weight",
// "Metric Name" => "Metric Name",
// "Tab Name" => "Tab Name",
// "Assign metric" => "Assign metric",
// "Edit this assigned metric" => "Edit this assigned metric",
// "Tab for metric" => "Tab for metric",
// "Create new metric" => "Create new metric",
// "Edit this metric" => "Edit this metric",
// "Hints" => "Hints",
// "For list-based metrics, include the \"LIMIT #\" in your query" => "For list-based metrics, include the \"LIMIT #\" in your query",
// "Name (must be unique)" => "Name (must be unique)",
// "Create new tab" => "Create new tab",
// "Edit this tab" => "Edit this tab",
// "Weight (must be integer)" => "Weight (must be integer)",
// "The following required parameters are missing" => "The following required parameters are missing",
// "Move Up" => "Move Up",
// "Move Down" => "Move Down",
// "Move to Right Column" => "Move to Right Column",
// "Move to Left Column" => "Move to Left Column",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "The" => "The",
// "Display Modules to All Groups" => "Display Modules to All Groups",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
// "Visibility" => "Visibility",
// "Displayed now for all eligible users even with personal assigned modules" => "Displayed now for all eligible users even with personal assigned modules",
// "Displayed for the eligible users with no personal assigned modules" => "Displayed for the eligible users with no personal assigned modules",
// "Displayed now, can't be unassigned" => "Displayed now, can't be unassigned",
// "Not displayed until a user chooses it" => "Not displayed until a user chooses it",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
// "Random active poll" => "Random active poll",
// "Random current poll" => "Random current poll",
// "Use CSS menu" => "Use CSS menu",
// "PHP Layers menus" => "PHP Layers menus",
// "Use phplayermenu" => "Use phplayermenu",
// "Use Wiki Structure" => "Use Wiki Structure",
// "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes" => "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes",
// "To use a <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">PHP Layers menu</a>, use one of these syntaxes (Note: PHP Layers menus are being replaced by CSS menus and may have only basic styling in newer themes.)" => "To use a <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">PHP Layers menu</a>, use one of these syntaxes (Note: PHP Layers menus are being replaced by CSS menus and may have only basic styling in newer themes.)",
// "Edit Newsletter" => "Edit Newsletter",
// "Wiki Page Name" => "Wiki Page Name",
// "Validate Addresses" => "Validate Addresses",
// "Add To List" => "Add To List",
// "Unsubscribed" => "Unsubscribed",
// "Add subscribers" => "Add subscribers",
// "Users from group" => "Users from group",
// "Import emails from file" => "Import emails from file",
// "Don't send confirmation mails" => "Don't send confirmation mails",
// "Import emails from wiki page" => "Import emails from wiki page",
// "Wiki page, one e-mail per line" => "Wiki page, one e-mail per line",
// "Including group, group users and emails will be refreshed at each newsletter sending" => "Including group, group users and emails will be refreshed at each newsletter sending",
// "Use subscribers of another newsletter" => "Use subscribers of another newsletter",
// "Use emails from wiki page" => "Use emails from wiki page",
// "Emails on a wiki page which will be added at each newsletter sending, one e-mail per line" => "Emails on a wiki page which will be added at each newsletter sending, one e-mail per line",
// "Don't subscribe emails" => "Don't subscribe emails",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Leave box empty for deleting an option" => "Leave box empty for deleting an option",
// "Votes older than these days are no more considered" => "Votes older than these days are no more considered",
// "This menu shows only Polls with 'status': \"template\"" => "This menu shows only Polls with 'status': \"template\"",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
// "The article generator will create a new article for every item read in the RSS feed" => "The article generator will create a new article for every item read in the RSS feed",
// "Use Article Submission System" => "Use Article Submission System",
// "Publish in the future" => "Publish in the future",
// "-1 to use original publishing date from the feed" => "-1 to use original publishing date from the feed",
// "Configure" => "Configure",
// "Edit this feed" => "Edit this feed",
// "PHP functions" => "PHP functions",
// "Function" => "Function",
// "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini" => "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini",
// "Tiki settings" => "Tiki settings",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
// "Are you sure you want to delete this word" => "Are you sure you want to delete this word",
// "XML Zip Import" => "XML Zip Import",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict",
// "The following pages have automatically been categorized with the same categories as the structure" => "The following pages have automatically been categorized with the same categories as the structure",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent",
// "Delete with the pages" => "Delete with the pages",
// "Create New structure" => "Create New structure",
// "Edit Survey Question" => "Edit Survey Question",
// "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots",
// "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4",
// "Reset to Global" => "Reset to Global",
// "Reset to defaults" => "Reset to defaults",
// "Edit tool" => "Edit tool",
// "Wysiwyg Token" => "Wysiwyg Token",
// "Plugin name" => "Plugin name",
// "Add a new custom tool" => "Add a new custom tool",
// "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools" => "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools",
// "Position of field in list" => "Position of field in list",
// "Is mandatory/required" => "Is mandatory/required",
// "Req" => "Req",
// "Multi-lingual" => "Multi-lingual",
// "Is column searchable" => "Is column searchable",
// "Descr" => "Descr",
// "Validation parameter" => "Validation parameter",
// "Validation error message" => "Validation error message",
// "Important note" => "Important note",
// "The first field in the tracker to have column links to edit/view item (i.e. isMain) will be what is shown as the name of the item in category and search listings" => "The first field in the tracker to have column links to edit/view item (i.e. isMain) will be what is shown as the name of the item in category and search listings",
// "Description text is wiki-parsed" => "Description text is wiki-parsed",
// "Check the box to re-import in this tracker and change the fields" => "Check the box to re-import in this tracker and change the fields",
// "Uncheck the box to import in another database" => "Uncheck the box to import in another database",
// "with" => "with",
// "Create a group for each item" => "Create a group for each item",
// "Groups will include" => "Groups will include",
// "Creator is assigned to the group" => "Creator is assigned to the group",
// "and it becomes his default group" => "and it becomes his default group",
// "and it becomes the new item group creator" => "and it becomes the new item group creator",
// "But copy the default group in this fiedlId before updating the group" => "But copy the default group in this fiedlId before updating the group",
// "User can take ownership of item created by anonymous" => "User can take ownership of item created by anonymous",
// "Member of the creator group can modify items" => "Member of the creator group can modify items",
// "Identify creation user in tracker item" => "Identify creation user in tracker item",
// "Identify lastModif user in tracker item" => "Identify lastModif user in tracker item",
// "and display last comment user/date" => "and display last comment user/date",
// "Wiki page to display an item" => "Wiki page to display an item",
// "wiki:pageName for a wiki page or tpl:tplName for a template" => "wiki:pageName for a wiki page or tpl:tplName for a template",
// "Status changes list" => "Status changes list",
// "Delay" => "Delay",
// "Notification" => "Notification",
// "Delete todo" => "Delete todo",
// "Status changes" => "Status changes",
// "After creation" => "After creation",
// "After last modification" => "After last modification",
// "Warn creator of an upcoming status change" => "Warn creator of an upcoming status change",
// "before" => "before",
// "Mail subject text" => "Mail subject text",
// "Mail body ressource" => "Mail body ressource",
// "wiki:pageName for a wiki page or tplName.tpl for a template" => "wiki:pageName for a wiki page or tplName.tpl for a template",
// "Date Format" => "Date Format",
// "timestamp" => "timestamp",
// "UTF-8" => "UTF-8",
// "ISO-8859-1" => "ISO-8859-1",
// "Add as new items" => "Add as new items",
// "The order of the fields does not matter, but you need to add a header with the field names" => "The order of the fields does not matter, but you need to add a header with the field names",
// "Add \" -- \" to the end of the fields in the header that you would like to import" => "Add \" -- \" to the end of the fields in the header that you would like to import",
// "Auto-incremented itemid fields shall be included with no matter what values" => "Auto-incremented itemid fields shall be included with no matter what values",
// "Subset Selection" => "Subset Selection",
// "Category Selection" => "Category Selection",
// "Group Selection" => "Group Selection",
// "Type in a group name and click \"enter\"" => "Type in a group name and click \"enter\"",
// "Once you have selected at least two, click" => "Once you have selected at least two, click",
// "and then, click the \"New/Edit\" tab which will appear above" => "and then, click the \"New/Edit\" tab which will appear above",
// "Draw Transition Diagram" => "Draw Transition Diagram",
// "Guards" => "Guards",
// "preserved" => "preserved",
// "Assign permissions for transition" => "Assign permissions for transition",
// "No transitions" => "No transitions",
// "New / Edit" => "New / Edit",
// "Edit <em>%0</em>" => "Edit <em>%0</em>",
// "New transition" => "New transition",
// "Upon trigger, preserve the initial state" => "Upon trigger, preserve the initial state",
// "Count" => "Count",
// "No guards on this transition" => "No guards on this transition",
// "New Guard" => "New Guard",
// "Exactly" => "Exactly",
// "At Least" => "At Least",
// "At Most" => "At Most",
// "States" => "States",
// "Invitation List" => "Invitation List",
// "Homepage" => "Homepage",
// "Group Homepage or Url" => "Group Homepage or Url",
// "Use site default" => "Use site default",
// "Group Information Tracker" => "Group Information Tracker",
// "choose a field .." => "choose a field ..",
// "Users Information Tracker" => "Users Information Tracker",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
// "Group tracker item : {\$groupitemid}" => "Group tracker item : {\$groupitemid}",
// "Group tracker item not found" => "Group tracker item not found",
// "Create Item" => "Create Item",
// "Choose a field .." => "Choose a field ..",
// "Members List" => "Members List",
// "Expire" => "Expire",
// "Remove from Group" => "Remove from Group",
// "users in group" => "users in group",
// "Add to group" => "Add to group",
// "Download CSV export" => "Download CSV export",
// "Assign users to group" => "Assign users to group",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
// "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login",
// "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login",
// "Updated users" => "Updated users",
// "OpenID" => "OpenID",
// "N" => "N",
// "Need to validate email" => "Need to validate email",
// "Assign to group" => "Assign to group",
// "Edit Included Group" => "Edit Included Group",
// "Edit Group" => "Edit Group",
// "Validate user" => "Validate user",
// "Confirm user email" => "Confirm user email",
// "Set the default group of the selected users to" => "Set the default group of the selected users to",
// "Template wiki page" => "Template wiki page",
// "bcc" => "bcc",
// "Edit user" => "Edit user",
// "Assign user to Groups" => "Assign user to Groups",
// "Use the email as username" => "Use the email as username",
// "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)" => "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "No password is required" => "No password is required",
// "Tikiwiki is configured to delegate the password managment to LDAP" => "Tikiwiki is configured to delegate the password managment to LDAP",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "CSV file layout" => "CSV file layout",
// "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\"group1,group2\",group1" => "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\"group1,group2\",group1",
// "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
// "Approve page changes in staging" => "Approve page changes in staging",
// "Page has been approved" => "Page has been approved",
// "Changes from the following versions under staging have been merged into the approved version" => "Changes from the following versions under staging have been merged into the approved version",
// "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems" => "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems",
// "Click this button to try it now" => "Click this button to try it now",
// "Global object permissions" => "Global object permissions",
// "Assign User {\$assign_user|escape} to Groups" => "Assign User {\$assign_user|escape} to Groups",
// "Directory batch upload" => "Directory batch upload",
// "Remove File Extension from Image Name" => "Remove File Extension from Image Name",
// "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Select a Gallery" => "Select a Gallery",
// "Process" => "Process",
// "Browse File Gallery" => "Browse File Gallery",
// "Please do not use this feature to upload data into the database" => "Please do not use this feature to upload data into the database",
// "Available Files" => "Available Files",
// "Select a File Gallery" => "Select a File Gallery",
// "Process files" => "Process files",
// "View post" => "View post",
// "Tiki Wiki CMS Groupware" => "Tiki Wiki CMS Groupware",
// "Upper level" => "Upper level",
// "No result found" => "No result found",
// "result found" => "result found",
// "Directory Batch" => "Directory Batch",
// "RSS" => "RSS",
// "You can view this gallery's configured image (first, random, etc.) in your browser using" => "You can view this gallery's configured image (first, random, etc.) in your browser using",
// "You can include the gallery's image in an HTML page using" => "You can include the gallery's image in an HTML page using",
// "You can include the image in a tiki page using" => "You can include the image in a tiki page using",
// "Edit Image" => "Edit Image",
// "Slideshow Forward" => "Slideshow Forward",
// "Cyclic" => "Cyclic",
// "Click to zoom" => "Click to zoom",
// "Image Scale" => "Image Scale",
// "Include the image in a tiki page using the following syntax" => "Include the image in a tiki page using the following syntax",
// "To include the image in an HTML page" => "To include the image in an HTML page",
// "To link to this page from another tiki page" => "To link to this page from another tiki page",
// "Click to export calendars" => "Click to export calendars",
// "Click to select visible calendars" => "Click to select visible calendars",
// "Export event" => "Export event",
// "Delete event" => "Delete event",
// "Classification" => "Classification",
// "View this Week" => "View this Week",
// "Change Focus" => "Change Focus",
// "+" => "+",
// "o" => "o",
// "Edit/Delete event" => "Edit/Delete event",
// "New Calendar Item" => "New Calendar Item",
// "Recurrence" => "Recurrence",
// "This event depends on a recurrence rule" => "This event depends on a recurrence rule",
// "This event is not recurrent" => "This event is not recurrent",
// "On a weekly basis" => "On a weekly basis",
// "Each" => "Each",
// "of the week" => "of the week",
// "On a monthly basis" => "On a monthly basis",
// "of the month" => "of the month",
// "On a yearly basis" => "On a yearly basis",
// "Starting on" => "Starting on",
// "ending by" => "ending by",
// "ending after" => "ending after",
// "events" => "events",
// "Start period" => "Start period",
// "End after" => "End after",
// "occurrences" => "occurrences",
// "End before" => "End before",
// "Event is repeated" => "Event is repeated",
// "times" => "times",
// "every" => "every",
// "of every month" => "of every month",
// "on each" => "on each",
// "Date and time of end" => "Date and time of end",
// "Events cannot end before they start" => "Events cannot end before they start",
// "Choose users to alert" => "Choose users to alert",
// "Withdraw me from the list of participants" => "Withdraw me from the list of participants",
// "Add me to the list of participants" => "Add me to the list of participants",
// "Participant names separated by comma" => "Participant names separated by comma",
// "Roles" => "Roles",
// "chair" => "chair",
// "default role" => "default role",
// "required participant" => "required participant",
// "optional participant" => "optional participant",
// "non participant" => "non participant",
// "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in" => "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
// "Column names on the first line" => "Column names on the first line",
// "%0 column name can be used instead of %1" => "%0 column name can be used instead of %1",
// "See" => "See",
// "%d/%m" => "%d/%m",
// "%m/%d" => "%m/%d",
// "Your account has been validated" => "Your account has been validated",
// "You have to choose a password to use this account" => "You have to choose a password to use this account",
// "Change your password" => "Change your password",
// "Please choose the language for this page" => "Please choose the language for this page",
// "Choose language" => "Choose language",
// "Quick Create Multilanguage Pages" => "Quick Create Multilanguage Pages",
// "Following pages were created, as translations of each other" => "Following pages were created, as translations of each other",
// "Following pages were not created" => "Following pages were not created",
// "page already exists" => "page already exists",
// "Enter the names of a new page page in various languages" => "Enter the names of a new page page in various languages",
// "Preferred languages" => "Preferred languages",
// "Other languages" => "Other languages",
// "Create pages" => "Create pages",
// "View generated WebHelp" => "View generated WebHelp",
// "No structure" => "No structure",
// "Top page" => "Top page",
// "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>",
// "Directory Categories" => "Directory Categories",
// "Parent directory category" => "Parent directory category",
// "Most visited directory sub-categories" => "Most visited directory sub-categories",
// "Directory Category description" => "Directory Category description",
// "Random directory sub-categories" => "Random directory sub-categories",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
// "Directory Subcategories" => "Directory Subcategories",
// "Admin related directory categories" => "Admin related directory categories",
// "Add a related directory category" => "Add a related directory category",
// "Directory Category" => "Directory Category",
// "Related directory categories" => "Related directory categories",
// "in current directory category" => "in current directory category",
// "Hits (desc)" => "Hits (desc)",
// "Hits (asc)" => "Hits (asc)",
// "Last updated (desc)" => "Last updated (desc)",
// "Last updated (asc)" => "Last updated (asc)",
// "Discounts" => "Discounts",
// "Max time the discount can be used in the first phase of payment" => "Max time the discount can be used in the first phase of payment",
// "-1 for illimited" => "-1 for illimited",
// "To add <strong>new content</strong> to the page" => "To add <strong>new content</strong> to the page",
// "use the editor" => "use the editor",
// "One of the email addresses you typed is invalid" => "One of the email addresses you typed is invalid",
// "Topline" => "Topline",
// "If not the topic image" => "If not the topic image",
// "Article image" => "Article image",
// "If different than the uploaded image" => "If different than the uploaded image",
// "If different than in view mode" => "If different than in view mode",
// "If not the topic name" => "If not the topic name",
// "Max impressions for a user" => "Max impressions for a user",
// "A category is mandatory" => "A category is mandatory",
// "The checkbox is disabled because feature_freetags is disabled globally" => "The checkbox is disabled because feature_freetags is disabled globally",
// "Edit Style Sheet" => "Edit Style Sheet",
// "Style Sheet" => "Style Sheet",
// "The file will be saved in" => "The file will be saved in",
// "choose a stylesheet" => "choose a stylesheet",
// "Try" => "Try",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "The syntax system used for creating pages in Tiki" => "The syntax system used for creating pages in Tiki",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text",
// "Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki plugins extend the function of wiki syntax with more specialized commands",
// "Spreadsheet Help" => "Spreadsheet Help",
// "jQuery.sheet spreadsheets" => "jQuery.sheet spreadsheets",
// "What is jQuery.sheet" => "What is jQuery.sheet",
// "jQuery.sheet gives you all sorts of possibilities when it comes to giving your web application a spreadsheet style interface with MS Excel style calculations" => "jQuery.sheet gives you all sorts of possibilities when it comes to giving your web application a spreadsheet style interface with MS Excel style calculations",
// "jQuery.sheet manages the sheet creation, viewing, and editing processes.  It can even be used like a datagrid, without calculations.\nFor a complete list of all the MS Excel style functions that jQuery.sheet supports, see below" => "jQuery.sheet manages the sheet creation, viewing, and editing processes.  It can even be used like a datagrid, without calculations.\nFor a complete list of all the MS Excel style functions that jQuery.sheet supports, see below",
// "More help on wysiwyg editing" => "More help on wysiwyg editing",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar",
// "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin",
// "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred" => "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred",
// "The following image was successfully edited" => "The following image was successfully edited",
// "Upload from disk to change the image" => "Upload from disk to change the image",
// "Save and Go Next" => "Save and Go Next",
// "No translations in the database. First import a language, translate strings using interactive translation or enable \"Record untranslated strings\" in Admin -> i18n" => "No translations in the database. First import a language, translate strings using interactive translation or enable \"Record untranslated strings\" in Admin -> i18n",
// "reset table" => "reset table",
// "If you click \"Download database translations\", you will download a file with all the translations in the database" => "If you click \"Download database translations\", you will download a file with all the translations in the database",
// "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database" => "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database",
// "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory" => "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory",
// "Return to default perspective" => "Return to default perspective",
// "Switch to" => "Switch to",
// "Configurations" => "Configurations",
// "Hint" => "Hint",
// "Search for configurations below and drag them in to the configuration section above" => "Search for configurations below and drag them in to the configuration section above",
// "Program dynamic content for block" => "Program dynamic content for block",
// "Return to block listing" => "Return to block listing",
// "Block description: " => "Block description: ",
// "You are editing block" => "You are editing block",
// "Publishing date" => "Publishing date",
// "Publishing Date" => "Publishing Date",
// "Edit question options" => "Edit question options",
// "canRepeat" => "canRepeat",
// "%" => "%",
// "Edit quiz questions" => "Edit quiz questions",
// "Create/edit questions for quiz" => "Create/edit questions for quiz",
// "Question Type" => "Question Type",
// "Import questions from text" => "Import questions from text",
// "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character" => "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character",
// "Input" => "Input",
// "maxScore" => "maxScore",
// "Edit quiz results" => "Edit quiz results",
// "From Points" => "From Points",
// "To Points" => "To Points",
// "Answer" => "Answer",
// "The page already exists. The page that has been added to the structure is the existing one" => "The page already exists. The page that has been added to the structure is the existing one",
// "<b>Topline</b>=small line above Title" => "<b>Topline</b>=small line above Title",
// "<b>Subtitle</b>=small line below Title" => "<b>Subtitle</b>=small line below Title",
// "<b>Source</b>=URL to article source" => "<b>Source</b>=URL to article source",
// "Template listing" => "Template listing",
// "Available templates" => "Available templates",
// "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering" => "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering",
// "This would cause you problems (e.g. menus can stop collapsing/expanding)" => "This would cause you problems (e.g. menus can stop collapsing/expanding)",
// "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)" => "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)",
// "Maybe You just want to modify the top of your Tiki site" => "Maybe You just want to modify the top of your Tiki site",
// "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface" => "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface",
// "Save Only in the Theme" => "Save Only in the Theme",
// "Delete the copy in the theme" => "Delete the copy in the theme",
// "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"",
// "\"The page already exists. It was selected in the list below.\"" => "\"The page already exists. It was selected in the list below.\"",
// "Update '{\$page|escape}'" => "Update '{\$page|escape}'",
// "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval" => "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval",
// "This is a new staging page that has not been approved before" => "This is a new staging page that has not been approved before",
// "The current staging copy may contain changes that have yet to be approved" => "The current staging copy may contain changes that have yet to be approved",
// "View changes since last approval" => "View changes since last approval",
// "You are editing the approved copy of this page" => "You are editing the approved copy of this page",
// "There are currently changes in the staging copy that have yet to be approved" => "There are currently changes in the staging copy that have yet to be approved",
// "Are you sure you do not want to edit" => "Are you sure you do not want to edit",
// "the staging copy" => "the staging copy",
// "instead" => "instead",
// "Draft written on" => "Draft written on",
// "Warning: new versions of this page have been made after this draft" => "Warning: new versions of this page have been made after this draft",
// "An edit summary is mandatory" => "An edit summary is mandatory",
// "Translate from" => "Translate from",
// "Changes that need to be translated are highlighted below" => "Changes that need to be translated are highlighted below",
// "No comment" => "No comment",
// "Select the style used to display differences to be translated" => "Select the style used to display differences to be translated",
// "html" => "html",
// "text full" => "text full",
// "Change the style used to display differences to be translated" => "Change the style used to display differences to be translated",
// "Change diff styles" => "Change diff styles",
// "Invalid page name" => "Invalid page name",
// "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>",
// "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>",
// "Translate to" => "Translate to",
// "Reproduce the changes highlighted on the left using the editor below" => "Reproduce the changes highlighted on the left using the editor below",
// "Edit comment: Enter some text to describe the changes you are currently making" => "Edit comment: Enter some text to describe the changes you are currently making",
// "Categorization has been preset for this edit" => "Categorization has been preset for this edit",
// "Allow comments on this page" => "Allow comments on this page",
// "Authors' style" => "Authors' style",
// "You should ask an admin to create them" => "You should ask an admin to create them",
// "Export to file" => "Export to file",
// "Autodetect" => "Autodetect",
// "Delimitors" => "Delimitors",
// "Carriage Return inside Field Value" => "Carriage Return inside Field Value",
// "Parse as Wiki Text" => "Parse as Wiki Text",
// "Fields visible in items list" => "Fields visible in items list",
// "Fields searchable or visible in items list" => "Fields searchable or visible in items list",
// "Fields visible in an item view" => "Fields visible in an item view",
// "All fields" => "All fields",
// "These fields" => "These fields",
// "Number of records" => "Number of records",
// "Zip export with attachments" => "Zip export with attachments",
// "Zip Export" => "Zip Export",
// "Dump All Tracker Items" => "Dump All Tracker Items",
// "Dump" => "Dump",
// "View FAQ" => "View FAQ",
// "Edit this FAQ" => "Edit this FAQ",
// "New Question" => "New Question",
// "Edit FAQ question" => "Edit FAQ question",
// "Add FAQ question" => "Add FAQ question",
// "Use a question from another FAQ" => "Use a question from another FAQ",
// "FAQ questions" => "FAQ questions",
// "Suggested questions" => "Suggested questions",
// "No suggested questions" => "No suggested questions",
// "File Archive" => "File Archive",
// "File Galleries tpl" => "File Galleries tpl",
// "Size (width x height)" => "Size (width x height)",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred",
// "Proceed" => "Proceed",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into" => "Which Forum Do You Wish to Import this Into",
// "Edit queued message" => "Edit queued message",
// "make this a thread of" => "make this a thread of",
// "None, this is a thread message" => "None, this is a thread message",
// "Reported messages for forum" => "Reported messages for forum",
// "Reported by" => "Reported by",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag" => "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag",
// "Until then, they cannot be translated" => "Until then, they cannot be translated",
// "Show checkboxes to clear language information on tags" => "Show checkboxes to clear language information on tags",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
// "Universal" => "Universal",
// "Show the following languages" => "Show the following languages",
// "Pending requests" => "Pending requests",
// "Request Time" => "Request Time",
// "Cancel friendship request" => "Cancel friendship request",
// "Geographic" => "Geographic",
// "Make Map" => "Make Map",
// "enter address" => "enter address",
// "Find address" => "Find address",
// "Reset view to default" => "Reset view to default",
// "Reset view to site default" => "Reset view to site default",
// "Select Graphic Type" => "Select Graphic Type",
// "Pie Chart" => "Pie Chart",
// "Multiline" => "Multiline",
// "Multibar" => "Multibar",
// "Bar Stack" => "Bar Stack",
// "Landscape" => "Landscape",
// "Portrait" => "Portrait",
// "Independant Scale" => "Independant Scale",
// "Horizontal Scale" => "Horizontal Scale",
// "Vertical Scale" => "Vertical Scale",
// "Series" => "Series",
// "Wiki plug-in" => "Wiki plug-in",
// "Clone" => "Clone",
// "Toggle Full Screen" => "Toggle Full Screen",
// "Date Selection" => "Date Selection",
// "Edit Date" => "Edit Date",
// "View Spreadsheet" => "View Spreadsheet",
// "Clone Spreadsheet" => "Clone Spreadsheet",
// "Roll Back Spreadsheet" => "Roll Back Spreadsheet",
// "Roll-Back" => "Roll-Back",
// "Ical import / Export" => "Ical import / Export",
// "Select The calendar to export" => "Select The calendar to export",
// "Calendar Import" => "Calendar Import",
// "ICal File" => "ICal File",
// "Import From File" => "Import From File",
// "Grab Wiki Tables" => "Grab Wiki Tables",
// "Import pages from a Structured Text Dump" => "Import pages from a Structured Text Dump",
// "Name of the dump file (it has to be in dump/)" => "Name of the dump file (it has to be in dump/)",
// "Overwrite existing pages if the name is the same" => "Overwrite existing pages if the name is the same",
// "Previously remove existing page versions" => "Previously remove existing page versions",
// "excerpt" => "excerpt",
// "Name of the zip file on the server" => "Name of the zip file on the server",
// "If you are NOT running a new Tiki installation, make a backup of your database before using this importer" => "If you are NOT running a new Tiki installation, make a backup of your database before using this importer",
// "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode",
// "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)" => "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)",
// "Select the software to import from" => "Select the software to import from",
// "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button",
// "Congratulations! You have successful imported your data to Tikiwiki" => "Congratulations! You have successful imported your data to Tikiwiki",
// "pages imported from a total of" => "pages imported from a total of",
// "You can see the list of wiki pages in your site" => "You can see the list of wiki pages in your site",
// "Importer log" => "Importer log",
// "Before installing Tiki, <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Before installing Tiki, <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements",
// "Tiki can create images" => "Tiki can create images",
// "Tiki was not able to create a sample image. Please check your GD library configuration" => "Tiki was not able to create a sample image. Please check your GD library configuration",
// "Modify database connection" => "Modify database connection",
// "Character set" => "Character set",
// "Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box",
// "Always force connection to use UTF-8" => "Always force connection to use UTF-8",
// "Install &amp; Upgrade" => "Install &amp; Upgrade",
// "Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page",
// "This install will populate (or upgrade) the database" => "This install will populate (or upgrade) the database",
// "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>",
// "A new install will populate the database" => "A new install will populate the database",
// "Encoding Issue" => "Encoding Issue",
// "<p>Your database encoding is <strong>not</strong> in UTF-8.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8</em>.</p>" => "<p>Your database encoding is <strong>not</strong> in UTF-8.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8</em>.</p>",
// "Character Set Conversion" => "Character Set Conversion",
// "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database",
// "Convert database and tables to UTF-8" => "Convert database and tables to UTF-8",
// "Reinstall" => "Reinstall",
// "Warning: Category Permissions Will Not Be Upgraded" => "Warning: Category Permissions Will Not Be Upgraded",
// "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them",
// "Please log in with your admin password to continue" => "Please log in with your admin password to continue",
// "We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "We recommend enabling the <strong>.htaccess</strong> file for your Tiki",
// "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security",
// "Secure Log in" => "Secure Log in",
// "Upgrade fix" => "Upgrade fix",
// "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will" => "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will",
// "Create the <em>Admins</em> group, if missing" => "Create the <em>Admins</em> group, if missing",
// "Grant <em>tiki_p_admin</em> to the group, if missing" => "Grant <em>tiki_p_admin</em> to the group, if missing",
// "Add the administrator account to the group, if missing" => "Add the administrator account to the group, if missing",
// "To do so enter the name of the main admin account in the field below" => "To do so enter the name of the main admin account in the field below",
// "Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "Check this box if you have a lot of disabled accounts after an upgrade to tiki4",
// "List of accounts that will be enabled" => "List of accounts that will be enabled",
// "Tiki is an open source project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki is an open source project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>",
// "You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker",
// "Are you sure you want to attempt to fix the encoding of your entire database" => "Are you sure you want to attempt to fix the encoding of your entire database",
// "Upgrading and running into encoding issues" => "Upgrading and running into encoding issues",
// "We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>",
// "Previous table encoding" => "Previous table encoding",
// "Please select" => "Please select",
// "Dangerous: Fix double encoding" => "Dangerous: Fix double encoding",
// "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
// "Tiki Project Web Site" => "Tiki Project Web Site",
// "Powered by Tiki Wiki CMS Groupware" => "Powered by Tiki Wiki CMS Groupware",
// "Invitation" => "Invitation",
// "Invitations list" => "Invitations list",
// "The mail has been sent to: " => "The mail has been sent to: ",
// "You are about to send an invitation to theses people, please confirm" => "You are about to send an invitation to theses people, please confirm",
// "Ok" => "Ok",
// "Fill this box with the list of e-mails you want to invite " => "Fill this box with the list of e-mails you want to invite ",
// "Format of the list above " => "Format of the list above ",
// "CSV Style: One line per invitation, with the format: lastname,firstname,email" => "CSV Style: One line per invitation, with the format: lastname,firstname,email",
// "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)",
// "Type here the e-mail subject you'll want to be sent to them " => "Type here the e-mail subject you'll want to be sent to them ",
// "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) ",
// "Type here the content that the user will see when he'll click on the link from the mail " => "Type here the content that the user will see when he'll click on the link from the mail ",
// "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special " => "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special ",
// "Upload to Kaltura" => "Upload to Kaltura",
// "Upload Successful" => "Upload Successful",
// "You have successfully added {\$count} new entry/entries" => "You have successfully added {\$count} new entry/entries",
// "Add more media" => "Add more media",
// "Change Details" => "Change Details",
// "Remix" => "Remix",
// "Media Entries" => "Media Entries",
// "Advanced Editor" => "Advanced Editor",
// "Simple Editor" => "Simple Editor",
// "Video Title" => "Video Title",
// "Embed code" => "Embed code",
// "Views" => "Views",
// "Plays" => "Plays",
// "No action specified" => "No action specified",
// "v" => "v",
// "Select Duplicates" => "Select Duplicates",
// "More info" => "More info",
// "Ban" => "Ban",
// "Delete & Ban" => "Delete & Ban",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block",
// "Create/Edit content block" => "Create/Edit content block",
// "Inviter" => "Inviter",
// "Only successful invitations" => "Only successful invitations",
// "Only pending invitations" => "Only pending invitations",
// "Number of invitations" => "Number of invitations",
// "Kaltura Remix Entries" => "Kaltura Remix Entries",
// "Kaltura Media Entries" => "Kaltura Media Entries",
// "Loads" => "Loads",
// "List Remixes" => "List Remixes",
// "Browse Media Entries" => "Browse Media Entries",
// "Browse Remixes" => "Browse Remixes",
// "Create Remix" => "Create Remix",
// "Please select some media entries to use" => "Please select some media entries to use",
// "Remix Video" => "Remix Video",
// "Media Id" => "Media Id",
// "Wiki plugin code" => "Wiki plugin code",
// "Media Type" => "Media Type",
// "More Information" => "More Information",
// "No entries" => "No entries",
// "No media entries found" => "No media entries found",
// "Click here" => "Click here",
// "to upload" => "to upload",
// "Modified By" => "Modified By",
// "No mix entries found" => "No mix entries found",
// "to create a new mix" => "to create a new mix",
// "Mix Entries" => "Mix Entries",
// "Playlist Type" => "Playlist Type",
// "No playlists found. " => "No playlists found. ",
// "Click here " => "Click here ",
// "to create a playlist" => "to create a playlist",
// "\$type" => "\$type",
// "object permissions" => "object permissions",
// "category permissions" => "category permissions",
// "{\$special.reason|escape}: {\$special.objectName}" => "{\$special.reason|escape}: {\$special.objectName}",
// "Blog: %0" => "Blog: %0",
// "Edit New Submission" => "Edit New Submission",
// "users registered" => "users registered",
// "Distance (km)" => "Distance (km)",
// "Page aliases found" => "Page aliases found",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
// " {if \$find ne ''}and {/if}starting with" => " {if \$find ne ''}and {/if}starting with",
// "However, some page aliases fitting the query were found (see Aliases section above)" => "However, some page aliases fitting the query were found (see Aliases section above)",
// "Back to admin" => "Back to admin",
// "You do not have any mailin accounts set up" => "You do not have any mailin accounts set up",
// "Click here to go to mailin admin" => "Click here to go to mailin admin",
// "Change to" => "Change to",
// "Week containing" => "Week containing",
// "Month containing" => "Month containing",
// "Edit Event" => "Edit Event",
// "Tiki Mods" => "Tiki Mods",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification",
// "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more",
// "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)",
// "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")",
// "for version" => "for version",
// "All versions" => "All versions",
// "or later" => "or later",
// "No mods found" => "No mods found",
// "To display the objects you created or contributed to" => "To display the objects you created or contributed to",
// "The newsletter was sent to {\$sent} email addresses" => "The newsletter was sent to {\$sent} email addresses",
// "Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed" => "Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed",
// "Your email address was removed from the list of subscriptors" => "Your email address was removed from the list of subscriptors",
// "Removal of your email address failed" => "Removal of your email address failed",
// "Subscription confirmed" => "Subscription confirmed",
// "Changes to groups watching this {\$objectType}" => "Changes to groups watching this {\$objectType}",
// "These changes to group watches" => "These changes to group watches",
// "were made to these descendants" => "were made to these descendants",
// "Groups watching this {\$objectType}" => "Groups watching this {\$objectType}",
// "This Category" => "This Category",
// "All Descendants" => "All Descendants",
// "This object's direct permissions override any global permissions or category permissions affecting this object" => "This object's direct permissions override any global permissions or category permissions affecting this object",
// "This category's direct permissions override any global permissions affecting objects in it" => "This category's direct permissions override any global permissions affecting objects in it",
// "No permissions yet applied to this object but category permissions affect this object and are displayed below" => "No permissions yet applied to this object but category permissions affect this object and are displayed below",
// "To edit category permissions" => "To edit category permissions",
// "No direct permissions yet applied to this object. Global permissions apply" => "No direct permissions yet applied to this object. Global permissions apply",
// "Currently inherited permissions displayed" => "Currently inherited permissions displayed",
// "Delete category permissions" => "Delete category permissions",
// "Delete object permissions" => "Delete object permissions",
// "Reset Perms" => "Reset Perms",
// "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions",
// "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions",
// "Permissions Clipboard" => "Permissions Clipboard",
// "Copy the permissions set here" => "Copy the permissions set here",
// "Paste copied permissions from " => "Paste copied permissions from ",
// "Are you sure you want to effect all child categories?\\nThere is no undo" => "Are you sure you want to effect all child categories?\\nThere is no undo",
// "Assign or remove permissions on all pages of the sub-structure" => "Assign or remove permissions on all pages of the sub-structure",
// "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo" => "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo",
// "You must select at least one feature" => "You must select at least one feature",
// "View Differences" => "View Differences",
// "Permissions added" => "Permissions added",
// "Permissions removed" => "Permissions removed",
// "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for",
// "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for",
// "Assign Quick-Permissions to this object" => "Assign Quick-Permissions to this object",
// "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)" => "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)",
// "<em>Quick permissions</em> should be considered as an experimental feature" => "<em>Quick permissions</em> should be considered as an experimental feature",
// "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably" => "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably",
// "There is also no undo - <strong>Use with care!</strong>" => "There is also no undo - <strong>Use with care!</strong>",
// "Contributions by author" => "Contributions by author",
// "Contributions to" => "Contributions to",
// "current version" => "current version",
// "version" => "version",
// "Words" => "Words",
// "Whitespaces" => "Whitespaces",
// "Characters" => "Characters",
// "Printable characters" => "Printable characters",
// "Deleted" => "Deleted",
// "Page changes" => "Page changes",
// "Original wiki text" => "Original wiki text",
// "Parsed Text (HTML)" => "Parsed Text (HTML)",
// "Output text only (No HTML tags)" => "Output text only (No HTML tags)",
// "Show statistics" => "Show statistics",
// "Visualize page changes" => "Visualize page changes",
// "Show popups" => "Show popups",
// "Escape HTML / Wiki syntax in page changes" => "Escape HTML / Wiki syntax in page changes",
// "Show contributions" => "Show contributions",
// "Show All Versions" => "Show All Versions",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "Enable pagination" => "Enable pagination",
// "per page" => "per page",
// "Payment Date" => "Payment Date",
// "Payment Type" => "Payment Type",
// "Payer" => "Payer",
// "View payment info" => "View payment info",
// "Invoice" => "Invoice",
// "Assign permissions for payments" => "Assign permissions for payments",
// "Cancel this payment request" => "Cancel this payment request",
// "Request Date" => "Request Date",
// "View payment request" => "View payment request",
// "Paypal" => "Paypal",
// "Transaction ID" => "Transaction ID",
// "Payment made by <em>%0, %1</em> (%2)" => "Payment made by <em>%0, %1</em> (%2)",
// "{\$wp_member_title}" => "{\$wp_member_title}",
// "Paid amount" => "Paid amount",
// "Initial amount" => "Initial amount",
// "Amount remaining" => "Amount remaining",
// "Payment request was sent on %0 and is due by %1" => "Payment request was sent on %0 and is due by %1",
// "Pay with Paypal" => "Pay with Paypal",
// "Refresh page" => "Refresh page",
// "Payment info" => "Payment info",
// "Trade with Cclite" => "Trade with Cclite",
// "Payment problem" => "Payment problem",
// "Pay with Tiki User Credits" => "Pay with Tiki User Credits",
// "Credit type" => "Credit type",
// "Credits left" => "Credits left",
// "Amount to pay" => "Amount to pay",
// "Pay using" => "Pay using",
// "Manual payment entry" => "Manual payment entry",
// "Enter payment" => "Enter payment",
// "using" => "using",
// "Payment information" => "Payment information",
// "Outstanding" => "Outstanding",
// "Overdue" => "Overdue",
// "Past" => "Past",
// "Detail" => "Detail",
// "Payable within" => "Payable within",
// "File (only .gif, .jpg and .png images)" => "File (only .gif, .jpg and .png images)",
// "Plugin execution was denied" => "Plugin execution was denied",
// "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected",
// "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible",
// "You are allowed to" => "You are allowed to",
// "View arguments" => "View arguments",
// "Execute the plugin in preview mode (may be dangerous)" => "Execute the plugin in preview mode (may be dangerous)",
// "Approve the plugin for public execution" => "Approve the plugin for public execution",
// "View Details" => "View Details",
// "This plugin does not contain any arguments" => "This plugin does not contain any arguments",
// "This plugin's body is empty" => "This plugin's body is empty",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "When you upgrade from an old version, you may need to reparse all the pages" => "When you upgrade from an old version, you may need to reparse all the pages",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "Poll Results" => "Poll Results",
// "Top Voted Polls" => "Top Voted Polls",
// "Edit Poll" => "Edit Poll",
// "Find the poll" => "Find the poll",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Vote range displayed" => "Vote range displayed",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
// "List Votes" => "List Votes",
// "Popup preview" => "Popup preview",
// "Close preview" => "Close preview",
// "You do not have permission to read complete articles" => "You do not have permission to read complete articles",
// "Available Pages" => "Available Pages",
// "All pages selected" => "All pages selected",
// "Edit quiz" => "Edit quiz",
// "at " => "at ",
// "Use " => "Use ",
// "randomly selected questions" => "randomly selected questions",
// "Test-time Options" => "Test-time Options",
// "Limit questions displayed per page to " => "Limit questions displayed per page to ",
// "&nbsp question(s)" => "&nbsp question(s)",
// "Impose a time limit of " => "Impose a time limit of ",
// "Allow students to store partial results and return to quiz" => "Allow students to store partial results and return to quiz",
// "Allow students to retake this quiz " => "Allow students to retake this quiz ",
// "Grading and Feedback" => "Grading and Feedback",
// "Show students their score " => "Show students their score ",
// "Show students the correct answers " => "Show students the correct answers ",
// "Solicit additional questions from students" => "Solicit additional questions from students",
// "Link quiz to forum named: " => "Link quiz to forum named: ",
// "P/F" => "P/F",
// "Passed" => "Passed",
// "Stats for this quiz Questions " => "Stats for this quiz Questions ",
// "This Article is currently not published and only visible by Editors" => "This Article is currently not published and only visible by Editors",
// "List all articles of this same topic" => "List all articles of this same topic",
// "Please, change the name if you want the page to be uploaded" => "Please, change the name if you want the page to be uploaded",
// "However, no account is associated to the OpenID identifier" => "However, no account is associated to the OpenID identifier",
// "Your email could not be validated; make sure you email is correct and click register below" => "Your email could not be validated; make sure you email is correct and click register below",
// "If you use an email filter, be sure to add %0 to your accepted list" => "If you use an email filter, be sure to add %0 to your accepted list",
// "Tiki site registered" => "Tiki site registered",
// "The following site was added and validation by admin may be needed before appearing on the lists" => "The following site was added and validation by admin may be needed before appearing on the lists",
// "Register this site at Tiki.org" => "Register this site at Tiki.org",
// "Read this first" => "Read this first",
// "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites",
// "Registering is voluntary" => "Registering is voluntary",
// "Registering does not give you any benefits except one more link to your site" => "Registering does not give you any benefits except one more link to your site",
// "You don't get any emails, we don't sell the data about your site" => "You don't get any emails, we don't sell the data about your site",
// "Registering is just for us to get an overview of Tiki's usage" => "Registering is just for us to get an overview of Tiki's usage",
// "If your site is private or inside your intranet, you should not register" => "If your site is private or inside your intranet, you should not register",
// "Information about your site" => "Information about your site",
// "Enter your username or email" => "Enter your username or email",
// "Use this name anyway" => "Use this name anyway",
// "Rollback page" => "Rollback page",
// "This feature currently searches and replaces within wiki pages only" => "This feature currently searches and replaces within wiki pages only",
// "Max number of pages at a time" => "Max number of pages at a time",
// "Number of surrounding chars to preview" => "Number of surrounding chars to preview",
// "Replace selected" => "Replace selected",
// "{\$where|escape}" => "{\$where|escape}",
// "This newsletter will be sent to {\$subscribers} email addresses" => "This newsletter will be sent to {\$subscribers} email addresses",
// "Recipients" => "Recipients",
// "Validated" => "Validated",
// "Is user" => "Is user",
// "Sending Newsletter" => "Sending Newsletter",
// "Apply content template" => "Apply content template",
// "Clip Articles" => "Clip Articles",
// "octets" => "octets",
// "Sender email not set" => "Sender email not set",
// "Save your changes" => "Save your changes",
// "Save any changes and send to all subscribers" => "Save any changes and send to all subscribers",
// "Ex: http://tiki.org or localhost" => "Ex: http://tiki.org or localhost",
// "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need",
// "Report this page" => "Report this page",
// "Page shared" => "Page shared",
// "The link was sent via e-Mail to the following addresses" => "The link was sent via e-Mail to the following addresses",
// "The link was sent via Twitter" => "The link was sent via Twitter",
// "The link was posted on your facebook wall" => "The link was posted on your facebook wall",
// "The link was sent as message to" => "The link was sent as message to",
// "The link was published in a" => "The link was published in a",
// "Have a look at this page" => "Have a look at this page",
// "e-Mail" => "e-Mail",
// "Tweet via Twitter" => "Tweet via Twitter",
// "Authorize with twitter first" => "Authorize with twitter first",
// "Have a look at " => "Have a look at ",
// "Put on my facebook wall" => "Put on my facebook wall",
// "Authorize with facebook first" => "Authorize with facebook first",
// "Link text" => "Link text",
// "This will be the title for the URL" => "This will be the title for the URL",
// "Like this post" => "Like this post",
// "You do not have the permission to send messages or you did not allow other users to send you messages" => "You do not have the permission to send messages or you did not allow other users to send you messages",
// "Post on forum" => "Post on forum",
// "There is no forum where you can post a message" => "There is no forum where you can post a message",
// "password-protected" => "password-protected",
// "Configure this sheet" => "Configure this sheet",
// "There are individual permissions set for this sheet" => "There are individual permissions set for this sheet",
// "Join with Spreadsheet" => "Join with Spreadsheet",
// "You can access the sheet using the following URL" => "You can access the sheet using the following URL",
// "Content may be out of date" => "Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages",
// "This text was automatically translated by Google Translate from the following page: " => "This text was automatically translated by Google Translate from the following page: ",
// "First Slide" => "First Slide",
// "Previous Slide" => "Previous Slide",
// "Previous Point" => "Previous Point",
// "Next Point" => "Next Point",
// "Next Slide" => "Next Slide",
// "Last Slide" => "Last Slide",
// "Jump To Slide" => "Jump To Slide",
// "Play" => "Play",
// "Pause" => "Pause",
// "Toggle Loop" => "Toggle Loop",
// "Exit" => "Exit",
// "Change Theme" => "Change Theme",
// "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application" => "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application",
// "twitter authorisation" => "twitter authorisation",
// "to manage your authorisations at twitter" => "to manage your authorisations at twitter",
// "this site with twitter.com to use twitter integration of this site" => "this site with twitter.com to use twitter integration of this site",
// "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first" => "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first",
// "facebook authorisation" => "facebook authorisation",
// "to manage your authorisations at facebook" => "to manage your authorisations at facebook",
// "this site with facebook.com to use twitter integration of this site" => "this site with facebook.com to use twitter integration of this site",
// "The site admin has set up a global account which will be used for this site" => "The site admin has set up a global account which will be used for this site",
// "You will not see the latest queries" => "You will not see the latest queries",
// "Params" => "Params",
// "Date of first pageview" => "Date of first pageview",
// "Days since first pageview" => "Days since first pageview",
// "Most viewed objects in period" => "Most viewed objects in period",
// "Stats for surveys" => "Stats for surveys",
// "Last taken" => "Last taken",
// "Stats for survey" => "Stats for survey",
// "Export through Action Log" => "Export through Action Log",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Log out" => "Use Current Session/Log out",
// "Recorded Links" => "Recorded Links",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "TikiTests List" => "TikiTests List",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
// "Tracker Item History" => "Tracker Item History",
// "View Tracker Item" => "View Tracker Item",
// "Edit File" => "Edit File",
// "Advanced mode" => "Advanced mode",
// "Retry" => "Retry",
// "Or using as a thumbnail with ShadowBox" => "Or using as a thumbnail with ShadowBox",
// "The file is locked by {\$fileInfo.lockedby}" => "The file is locked by {\$fileInfo.lockedby}",
// "File can be deleted after" => "File can be deleted after",
// "Creator of file, if different from the 'Uploaded by' user" => "Creator of file, if different from the 'Uploaded by' user",
// "Maximum number of downloads" => "Maximum number of downloads",
// "Uploading file.." => "Uploading file..",
// "No File to Upload.." => "No File to Upload..",
// " Syntax tips" => " Syntax tips",
// "Link to file from a Wiki page" => "Link to file from a Wiki page",
// "In addition, for image files" => "In addition, for image files",
// "To display in a Wiki page" => "To display in a Wiki page",
// "Display thumbnail that enlarges" => "Display thumbnail that enlarges",
// "Image ID thumb" => "Image ID thumb",
// "You can include the image in an Wiki page using" => "You can include the image in an Wiki page using",
// "or upload a local image from your disk" => "or upload a local image from your disk",
// "Batch Upload" => "Batch Upload",
// "User assigned modules" => "User assigned modules",
// "The column is disabled" => "The column is disabled",
// "#" => "#",
// "act" => "act",
// "Assign module" => "Assign module",
// "Folder in" => "Folder in",
// "{if \$prefs.menus_item_names_raw eq 'n'}{\$chdata.name|escape}{else}{\$chdata.name}{/if}" => "{if \$prefs.menus_item_names_raw eq 'n'}{\$chdata.name|escape}{else}{\$chdata.name}{/if}",
// "User Icon" => "User Icon",
// "Users HomePage" => "Users HomePage",
// "This user is your friend " => "This user is your friend ",
// "The user requested friendship with you" => "The user requested friendship with you",
// "Accept friendship from this user" => "Accept friendship from this user",
// "Refuse friendship from this user" => "Refuse friendship from this user",
// "Currently waiting for user approval" => "Currently waiting for user approval",
// "Cancel friendship request towards this user" => "Cancel friendship request towards this user",
// "Request friendship from this user" => "Request friendship from this user",
// "Additional Information" => "Additional Information",
// "has not contributed to any content yet" => "has not contributed to any content yet",
// "Who Looks At Stuff" => "Who Looks At Stuff",
// "Who Looks At Your Stuff" => "Who Looks At Your Stuff",
// "Who Looks At His Stuff" => "Who Looks At His Stuff",
// "Toggle" => "Toggle",
// "Toggle options" => "Toggle options",
// "User's personal tracker information" => "User's personal tracker information",
// "View extra information" => "View extra information",
// "Preferred language" => "Preferred language",
// "Longitude" => "Longitude",
// "Latitude" => "Latitude",
// "Map zoom" => "Map zoom",
// "Are you really sure you want to delete the account %0" => "Are you really sure you want to delete the account %0",
// "Delete my account" => "Delete my account",
// "Not Accepted User" => "Not Accepted User",
// "User Watches and preferences" => "User Watches and preferences",
// "You need to set your email to receive email notifications" => "You need to set your email to receive email notifications",
// "Report Preferences" => "Report Preferences",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
// "Use reports to summarise notifications about objects you are watching" => "Use reports to summarise notifications about objects you are watching",
// "Use reports" => "Use reports",
// "Interval in which you want to get the reports" => "Interval in which you want to get the reports",
// "Short report" => "Short report",
// "Detailed report" => "Detailed report",
// "HTML-Email" => "HTML-Email",
// "Send me an email also if nothing happened" => "Send me an email also if nothing happened",
// "A user edited an article" => "A user edited an article",
// "A user deleted an article" => "A user deleted an article",
// "Category change in a language" => "Category change in a language",
// "User_versions_for" => "User_versions_for",
// "Banner stats" => "Banner stats",
// "Create new banner" => "Create new banner",
// "Banner Information" => "Banner Information",
// "Click ratio" => "Click ratio",
// "Banner raw data" => "Banner raw data",
// "Cached" => "Cached",
// "This is a cached version of the page" => "This is a cached version of the page",
// "Click here to view the Google cache of the page instead" => "Click here to view the Google cache of the page instead",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
// "Add Suggestion" => "Add Suggestion",
// "Manage Message Queue" => "Manage Message Queue",
// "Manage Reported Messages" => "Manage Reported Messages",
// "Monitor Topics of this Forum" => "Monitor Topics of this Forum",
// "Stop Monitoring Topics of this Forum" => "Stop Monitoring Topics of this Forum",
// "Monitor Topics and Threads of this Forum" => "Monitor Topics and Threads of this Forum",
// "Stop Monitoring Topics and Threads of this Forum" => "Stop Monitoring Topics and Threads of this Forum",
// "Group Monitor Topics of this Forum" => "Group Monitor Topics of this Forum",
// "Group Monitor Topics and Threads of this Forum" => "Group Monitor Topics and Threads of this Forum",
// "Watch for replies" => "Watch for replies",
// "Send me an e-mail when someone replies to my topic" => "Send me an e-mail when someone replies to my topic",
// "Don't send me any e-mails" => "Don't send me any e-mails",
// "Enter your name" => "Enter your name",
// "Reported Messages" => "Reported Messages",
// "Merge into topic" => "Merge into topic",
// "Emot" => "Emot",
// "pts" => "pts",
// "Atts" => "Atts",
// "Unarchive" => "Unarchive",
// "posts in this forum" => "posts in this forum",
// "Show archived posts" => "Show archived posts",
// "Me" => "Me",
// "Archived" => "Archived",
// "The post has been reported and will be reviewed by a moderator" => "The post has been reported and will be reviewed by a moderator",
// "Save current spreadsheet" => "Save current spreadsheet",
// "Cancel editing current spreadsheet" => "Cancel editing current spreadsheet",
// "List Spreadsheets" => "List Spreadsheets",
// "Already being edited by" => "Already being edited by",
// "What would you like to add" => "What would you like to add",
// "New spreadsheet" => "New spreadsheet",
// "Existing spreadsheet" => "Existing spreadsheet",
// "Tracker as a spreadsheet" => "Tracker as a spreadsheet",
// "Spreadsheet from file gallery" => "Spreadsheet from file gallery",
// "Monitor" => "Monitor",
// "Insert new item" => "Insert new item",
// "Filter Tracker Items" => "Filter Tracker Items",
// "Add a Comment" => "Add a Comment",
// "Move to another tracker" => "Move to another tracker",
// "Back to Items list" => "Back to Items list",
// "Back to Items List" => "Back to Items List",
// "Special Operations" => "Special Operations",
// "Open Tiki WebDAV as WebFolder" => "Open Tiki WebDAV as WebFolder",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "This is the active account" => "This is the active account",
// "IMAP" => "IMAP",
// "Mbox" => "Mbox",
// "Maildir" => "Maildir",
// "POP3" => "POP3",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Incoming servers (used in this order)" => "Incoming servers (used in this order)",
// "IMAP server" => "IMAP server",
// "Mbox filepath" => "Mbox filepath",
// "Maildir mail directory" => "Maildir mail directory",
// "Use SSL" => "Use SSL",
// "Outgoing server" => "Outgoing server",
// "From email" => "From email",
// "Uses current in preferences if empty" => "Uses current in preferences if empty",
// "No email set" => "No email set",
// "Account details" => "Account details",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Show Unread" => "Show Unread",
// "Show Flagged" => "Show Flagged",
// "Auto refresh set for every \$autoRefresh seconds" => "Auto refresh set for every \$autoRefresh seconds",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
// "Clip" => "Clip",
// "Back To Mailbox" => "Back To Mailbox",
// "Full Headers" => "Full Headers",
// "Normal Headers" => "Normal Headers",
// "Reply To All" => "Reply To All",
// "Forward" => "Forward",
// "Part" => "Part",
// "Select from address book" => "Select from address book",
// "Use HTML mail" => "Use HTML mail",
// "The following addresses are not in your address book" => "The following addresses are not in your address book",
// "Add Contacts" => "Add Contacts",
// "Attachment 1" => "Attachment 1",
// "Attachment 2" => "Attachment 2",
// "Attachment 3" => "Attachment 3",
// "Address book" => "Address book",
// "the approved version of this page" => "the approved version of this page",
// "Viewing of changes since last approval is possible only after first approval" => "Viewing of changes since last approval is possible only after first approval",
// "Latest changes will be synchronized after approval" => "Latest changes will be synchronized after approval",
// "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time" => "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time",
// "There is a staging page (not yet approved) for this page" => "There is a staging page (not yet approved) for this page",
// "page id" => "page id",
// "Group Monitor on Structure" => "Group Monitor on Structure",
// "Hold \"Ctrl\" in order to select multiple values" => "Hold \"Ctrl\" in order to select multiple values",
// "Remove Image" => "Remove Image",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Character Limit Exceeded" => "Character Limit Exceeded",
// "Character Count" => "Character Count",
// "Word Count" => "Word Count",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19",
// "You can use" => "You can use",
// "Number of votes" => "Number of votes",
// "Your rating" => "Your rating",
// "You did not vote yet" => "You did not vote yet",
// "My rating" => "My rating",
// "Click to vote for this value" => "Click to vote for this value",
// "Clik to delete your vote" => "Clik to delete your vote",
// "You have ever subscribed" => "You have ever subscribed",
// "You have not yet subscribed" => "You have not yet subscribed",
// "friends" => "friends",
// "Google Maps is not enabled" => "Google Maps is not enabled",
// "Freetags is not enabled" => "Freetags is not enabled",
// "The main text of this page is available in the following languages" => "The main text of this page is available in the following languages",
// "Use this thread to discuss the page" => "Use this thread to discuss the page",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
// "Current attendees" => "Current attendees",
// "No attendees at this time" => "No attendees at this time",
// "Last time we checked, the room you requested did not exist" => "Last time we checked, the room you requested did not exist",
// "list" => "list",
// "Toggle location map" => "Toggle location map",
// "Lon" => "Lon",
// "Lat" => "Lat",
// "Zoom" => "Zoom",
// "saving.." => "saving..",
// "Save current map view as user default" => "Save current map view as user default",
// "Save as user location" => "Save as user location",
// "Save as object location" => "Save as object location",
// "Email address the person you want to invite" => "Email address the person you want to invite",
// "Set in these groups" => "Set in these groups",
// "Email sent to" => "Email sent to",
// "Send to users" => "Send to users",
// "Send to" => "Send to",
// "Email separated by comma" => "Email separated by comma",
// "Send to groups" => "Send to groups",
// "Send Mail" => "Send Mail",
// "Check to remove" => "Check to remove",
// "Join myself" => "Join myself",
// "Leave myself" => "Leave myself",
// "Period" => "Period",
// "%0 year" => "%0 year",
// "%0 years" => "%0 years",
// "%0 days" => "%0 days",
// "Cost for one period" => "Cost for one period",
// "Membership to %0 for %1 year at %2&nbsp;%3" => "Membership to %0 for %1 year at %2&nbsp;%3",
// "Membership to %0 for %1 years at %2&nbsp;%3" => "Membership to %0 for %1 years at %2&nbsp;%3",
// "Membership to %0 for %1 days at %2&nbsp;%3" => "Membership to %0 for %1 days at %2&nbsp;%3",
// "separated by |" => "separated by |",
// "Number of periods" => "Number of periods",
// "Re-Apply" => "Re-Apply",
// "Undecided" => "Undecided",
// "Last Day" => "Last Day",
// "Last Week" => "Last Week",
// "Your default group" => "Your default group",
// "Change default group" => "Change default group",
// "Subscribe to a group" => "Subscribe to a group",
// "Subscribe to the newsletter" => "Subscribe to the newsletter",
// "Any" => "Any",
// "Please login first" => "Please login first",
// "Toggle display" => "Toggle display",
// "Creator &amp; Last Editor" => "Creator &amp; Last Editor",
// "Save the page as a draft" => "Save the page as a draft",
// "%0 enabled" => "%0 enabled",
// "%0 disabled" => "%0 disabled",
// "%0 set" => "%0 set",
// "%0 unset" => "%0 unset",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "Current version is up to date : <b>%0</b>" => "Current version is up to date : <b>%0</b>",
// "A new %0 major release branch is available" => "A new %0 major release branch is available",
// "Wiki Attachments" => "Wiki Attachments",
// "Feeds settings" => "Feeds settings",
// "Maps configuration" => "Maps configuration",
// "Settings for video streaming integration" => "Settings for video streaming integration",
// "Help on \$admintitle Config" => "Help on \$admintitle Config",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Multiple IP Banning" => "Multiple IP Banning",
// "Access from your localization was forbidden due to excessive spamming" => "Access from your localization was forbidden due to excessive spamming",
// "Delete comments then set banning rules" => "Delete comments then set banning rules",
// "Are you sure you want to unassign the objects of this category: " => "Are you sure you want to unassign the objects of this category: ",
// "You can not create a category with a name already existing at this level" => "You can not create a category with a name already existing at this level",
// "The file does not have the required header" => "The file does not have the required header",
// "Category can`t be parent of itself" => "Category can`t be parent of itself",
// "You have to provide a hotword and a URL" => "You have to provide a hotword and a URL",
// "You must specify a directory" => "You must specify a directory",
// "moved %d images, %d errors occured" => "moved %d images, %d errors occured",
// "a timeout occured. Hit the reload button to move the rest" => "a timeout occured. Hit the reload button to move the rest",
// "Test Image" => "Test Image",
// "Tiki Email Test" => "Tiki Email Test",
// "Tiki Test email from" => "Tiki Test email from",
// "Unable to send mail" => "Unable to send mail",
// "Test mail sent to" => "Test mail sent to",
// "%d user-group assignments" => "%d user-group assignments",
// "All Fields except gdaltindex must be filled" => "All Fields except gdaltindex must be filled",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
// "No valid gdaltindex executable" => "No valid gdaltindex executable",
// "New configuration created (id %0)" => "New configuration created (id %0)",
// "Configuration updated" => "Configuration updated",
// "Repository name can't be an empty" => "Repository name can't be an empty",
// "Requested action is not supported on repository" => "Requested action is not supported on repository",
// "No repository" => "No repository",
// "Search is mandatory field" => "Search is mandatory field",
// "File not found " => "File not found ",
// "Requested action in not supported on repository" => "Requested action in not supported on repository",
// "Non-existent link" => "Non-existent link",
// "Mail-in account %s incorrect" => "Mail-in account %s incorrect",
// "Mail-in account %s saved" => "Mail-in account %s saved",
// "Frequency should be a positive integer" => "Frequency should be a positive integer",
// "Mail-in accounts set to be checked every %s minutes" => "Mail-in accounts set to be checked every %s minutes",
// "Automatic Mail-in accounts checking disabled" => "Automatic Mail-in accounts checking disabled",
// "Are you sure you want to modify this menu" => "Are you sure you want to modify this menu",
// "Are you sure you want to create a new menu" => "Are you sure you want to create a new menu",
// "metric_remove must be a numeric value" => "metric_remove must be a numeric value",
// "tab_remove must be a numeric value" => "tab_remove must be a numeric value",
// "assign_remove must be a numeric value" => "assign_remove must be a numeric value",
// "metric_edit must be a numeric value" => "metric_edit must be a numeric value",
// "tab_edit must be a numeric value" => "tab_edit must be a numeric value",
// "Memcache is disabled for metrics" => "Memcache is disabled for metrics",
// "tab_clearcache must be a numeric value" => "tab_clearcache must be a numeric value",
// "assign_metric must be a numeric value" => "assign_metric must be a numeric value",
// "assign_metric_edit must be a numeric value" => "assign_metric_edit must be a numeric value",
// "Assign: Invalid metric value" => "Assign: Invalid metric value",
// "Assign: Invalid tab value" => "Assign: Invalid tab value",
// "Cannot create or update metric: You need to specify a name for the metric" => "Cannot create or update metric: You need to specify a name for the metric",
// "Cannot create or update metric: Metric name must be under \" . \$prefs['metrics_metric_name_length'] . \" characters in length" => "Cannot create or update metric: Metric name must be under \" . \$prefs['metrics_metric_name_length'] . \" characters in length",
// "Cannot create or update metric: You need to specify a range for the metric" => "Cannot create or update metric: You need to specify a range for the metric",
// "Cannot create or update metric: You need to specify a data type for the metric" => "Cannot create or update metric: You need to specify a data type for the metric",
// "Cannot create or update metric: You need to specify a query for the metric" => "Cannot create or update metric: You need to specify a query for the metric",
// "Cannot create or update tab: You need to specify a name for the tab" => "Cannot create or update tab: You need to specify a name for the tab",
// "Cannot create or update tab: Tab name must be under \" . \$prefs['metrics_tab_name_length'] . \" characters in length" => "Cannot create or update tab: Tab name must be under \" . \$prefs['metrics_tab_name_length'] . \" characters in length",
// "Cannot create or update tab: You need to specify an integer range for the tab order" => "Cannot create or update tab: You need to specify an integer range for the tab order",
// "Cannot create or update tab: Tab content cannot be empty" => "Cannot create or update tab: Tab content cannot be empty",
// "Cannot create or update module: You need to specify a name to the module" => "Cannot create or update module: You need to specify a name to the module",
// "Cannot create or update module: You cannot leave the data field empty" => "Cannot create or update module: You cannot leave the data field empty",
// "Newsletter does not exist" => "Newsletter does not exist",
// "Error importing from wiki page: " => "Error importing from wiki page: ",
// "Error opening uploaded file" => "Error opening uploaded file",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "unsafe" => "unsafe",
// "register_globals should be off by default. See the php manual for details" => "register_globals should be off by default. See the php manual for details",
// "off" => "off",
// "session.use_trans_sid should be off by default. See the php manual for details" => "session.use_trans_sid should be off by default. See the php manual for details",
// "upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser",
// "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them",
// "The Path to store files in the filegallery should be outside the tiki root directory" => "The Path to store files in the filegallery should be outside the tiki root directory",
// "The Path to store files in the imagegallery should be outside the tiki root directory" => "The Path to store files in the imagegallery should be outside the tiki root directory",
// "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code" => "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Path disclosure" => "Path disclosure",
// "Path disclosure through error message" => "Path disclosure through error message",
// "SQL injection" => "SQL injection",
// "SQL injection by authenticated user" => "SQL injection by authenticated user",
// "SQL injection by authenticated user with special privileges" => "SQL injection by authenticated user with special privileges",
// "SQL injection without authentication" => "SQL injection without authentication",
// "PHP command injection" => "PHP command injection",
// "PHP command injection by authenticated user" => "PHP command injection by authenticated user",
// "PHP command injection by authenticated user with special privileges" => "PHP command injection by authenticated user with special privileges",
// "PHP command injection without authentication" => "PHP command injection without authentication",
// "File upload" => "File upload",
// "File is not readable. Unable to check" => "File is not readable. Unable to check",
// "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous" => "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous",
// "This is a modified File. Cannot check version. Check if it is dangerous" => "This is a modified File. Cannot check version. Check if it is dangerous",
// "This file is from another Tikiwiki version: " => "This file is from another Tikiwiki version: ",
// "You have to provide a word" => "You have to provide a word",
// "Global" => "Global",
// "Are you sure you want to delete all your custom tools" => "Are you sure you want to delete all your custom tools",
// "Are you sure you want to delete this custom tool" => "Are you sure you want to delete this custom tool",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Tracker does not allow attachments" => "Tracker does not allow attachments",
// "Are you sure you want to create a new group" => "Are you sure you want to create a new group",
// "Are you sure you want to add this user?" => "Are you sure you want to add this user?",
// "Remove group: " => "Remove group: ",
// "Group name can not be empty" => "Group name can not be empty",
// "Are you sure you want to add this new user" => "Are you sure you want to add this new user",
// "Are you sure you want to delete this user" => "Are you sure you want to delete this user",
// "Are you sure you want to remove this user from this group" => "Are you sure you want to remove this user from this group",
// "Are you sure you want to reset email due for this user" => "Are you sure you want to reset email due for this user",
// "Are you sure you want to delete these users" => "Are you sure you want to delete these users",
// "Are you sure you want to add this user to these groups" => "Are you sure you want to add this user to these groups",
// "Are you sure you want to remove this user from these groups" => "Are you sure you want to remove this user from these groups",
// "Are you sure you want to set the default groups for these users" => "Are you sure you want to set the default groups for these users",
// "Are you sure you want to send a wiki page as an email to these users" => "Are you sure you want to send a wiki page as an email to these users",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
// "Invalid or unknown email" => "Invalid or unknown email",
// "Could not create user" => "Could not create user",
// "User login or email is required" => "User login or email is required",
// "User does not exist on master" => "User does not exist on master",
// "Created account %s <%s>" => "Created account %s <%s>",
// "Assigned %s in group %s" => "Assigned %s in group %s",
// "Email validation requested but email address not set" => "Email validation requested but email address not set",
// "The passwords do not match" => "The passwords do not match",
// "Password not set" => "Password not set",
// "User %s already exists" => "User %s already exists",
// "User login contains invalid characters" => "User login contains invalid characters",
// "%s %s successfully deleted" => "%s %s successfully deleted",
// "Deleted account %s" => "Deleted account %s",
// "%s %s removed from %s %s" => "%s %s removed from %s %s",
// "%s %s assigned to %s %s" => "%s %s assigned to %s %s",
// "group %s set as the default group of user %s" => "group %s set as the default group of user %s",
// "Are you sure you want to modify this user's data" => "Are you sure you want to modify this user's data",
// "Login contains invalid characters" => "Login contains invalid characters",
// "%s changed from %s to %s" => "%s changed from %s to %s",
// "Impossible to change %s from %s to %s" => "Impossible to change %s from %s to %s",
// "%s modified successfully" => "%s modified successfully",
// "%s modification failed" => "%s modification failed",
// "Please go back and try again" => "Please go back and try again",
// "approved by " => "approved by ",
// "This function is only for staging pages" => "This function is only for staging pages",
// "You do not have permission to approve staging pages" => "You do not have permission to approve staging pages",
// "Staging page cannot be found" => "Staging page cannot be found",
// "Approved page was last saved after most recent staging edit" => "Approved page was last saved after most recent staging edit",
// "Failed to add attribute" => "Failed to add attribute",
// "Unassign perm %s from group %s" => "Unassign perm %s from group %s",
// "You have to indicate a group" => "You have to indicate a group",
// "This group is invalid" => "This group is invalid",
// "Image Galleries Admin Panel" => "Image Galleries Admin Panel",
// "Could not read image %s" => "Could not read image %s",
// "Image %s upload failed" => "Image %s upload failed",
// "Image %s uploaded successfully" => "Image %s uploaded successfully",
// "Image %s removed from Batch directory" => "Image %s removed from Batch directory",
// "Impossible to remove image %s from Batch directory" => "Impossible to remove image %s from Batch directory",
// "Incorrect directory chosen for batch upload of images" => "Incorrect directory chosen for batch upload of images",
// "Please setup that dir on " => "Please setup that dir on ",
// "Please contact the website administrator" => "Please contact the website administrator",
// "Invalid directory name" => "Invalid directory name",
// "File Galleries Admin Panel" => "File Galleries Admin Panel",
// "Could not read file %s" => "Could not read file %s",
// "Could not write to file %s" => "Could not write to file %s",
// "File %s upload failed" => "File %s upload failed",
// "Upload was successful" => "Upload was successful",
// "File %s removed from Batch directory" => "File %s removed from Batch directory",
// "Impossible to remove file %s from Batch directory" => "Impossible to remove file %s from Batch directory",
// "Incorrect directory chosen for batch upload of files" => "Incorrect directory chosen for batch upload of files",
// "No blogId specified" => "No blogId specified",
// "Stop watching this category" => "Stop watching this category",
// "You must clear your browser cache" => "You must clear your browser cache",
// "No gallery indicated" => "No gallery indicated",
// "You do not have permission to view the calendar" => "You do not have permission to view the calendar",
// "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>" => "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>",
// "There\\'s no such date as" => "There\\'s no such date as",
// "Calendar event : " => "Calendar event : ",
// "event without name" => "event without name",
// "You do not have permission to view this page" => "You do not have permission to view this page",
// "%H:%M %Z" => "%H:%M %Z",
// "Invalid username or activation code. Maybe this code has already been used" => "Invalid username or activation code. Maybe this code has already been used",
// "Your email could not be validated; make sure you email is correct" => "Your email could not be validated; make sure you email is correct",
// "You can not use the same password again" => "You can not use the same password again",
// "Invalid old password" => "Invalid old password",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "Problem. Try to log in again to receive new confirmation instructions" => "Problem. Try to log in again to receive new confirmation instructions",
// "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field" => "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field",
// "TikiHelp WebHelp generation engine. Generating WebHelp using" => "TikiHelp WebHelp generation engine. Generating WebHelp using",
// "Eliminating previous files" => "Eliminating previous files",
// "Index: <strong>\$name</strong>" => "Index: <strong>\$name</strong>",
// "Directory: <strong>\$dir</strong>" => "Directory: <strong>\$dir</strong>",
// "You need to change chmod 'whelp' manually to 777" => "You need to change chmod 'whelp' manually to 777",
// "Creating directory structure in <strong>\$base</strong>" => "Creating directory structure in <strong>\$base</strong>",
// "Must enter a name to add a site. " => "Must enter a name to add a site. ",
// "Must enter a url to add a site. " => "Must enter a url to add a site. ",
// "URL already added to the directory. Duplicate site? " => "URL already added to the directory. Duplicate site? ",
// "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. ",
// "Must select a category. " => "Must select a category. ",
// "URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory",
// "No site indicated" => "No site indicated",
// "No parent specified" => "No parent specified",
// "Last sites of directory \" . \$rc[\"name\"] . \" " => "Last sites of directory \" . \$rc[\"name\"] . \" ",
// "Discount code already exists" => "Discount code already exists",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Error : The file %s doesn't exist" => "Error : The file %s doesn't exist",
// "The language can't be changed as its set of translations has already this language" => "The language can't be changed as its set of translations has already this language",
// "You do not have permission to write the style sheet" => "You do not have permission to write the style sheet",
// "Wrote %d new strings and updated %d to lang/%s/language.php" => "Wrote %d new strings and updated %d to lang/%s/language.php",
// "Imported" => "Imported",
// "Edit Perspectives" => "Edit Perspectives",
// "No content id indicated" => "No content id indicated",
// "No quiz indicated" => "No quiz indicated",
// "No structure indicated" => "No structure indicated",
// "Invalid structure_id or page_ref_id" => "Invalid structure_id or page_ref_id",
// "You do not have permission to edit submissions" => "You do not have permission to edit submissions",
// "No topic id specified" => "No topic id specified",
// "Invalid topic id specified" => "Invalid topic id specified",
// "No object indicated" => "No object indicated",
// "Page is a staging copy. Translation must begin from the approved copy" => "Page is a staging copy. Translation must begin from the approved copy",
// "No type indicated" => "No type indicated",
// "Override lock and carry on with edit" => "Override lock and carry on with edit",
// "Page is currently being edited" => "Page is currently being edited",
// "page imported" => "page imported",
// "created from import" => "created from import",
// "Describe the change you made" => "Describe the change you made",
// "This page is being edited by " => "This page is being edited by ",
// "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. " => "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. ",
// "Can't import remote HTML page" => "Can't import remote HTML page",
// "Page name is" => "Page name is",
// "Can not open the file" => "Can not open the file",
// "Problem zip initialisation" => "Problem zip initialisation",
// "Problem zip" => "Problem zip",
// "Another user is currently exporting that tracker, please try again later" => "Another user is currently exporting that tracker, please try again later",
// "No questions group indicated" => "No questions group indicated",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
// "You do not have permission to edit this file" => "You do not have permission to edit this file",
// "You do not have permission to remove files from this gallery" => "You do not have permission to remove files from this gallery",
// "Last files" => "Last files",
// "No galleryId specified" => "No galleryId specified",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
// "Last replied forum topics" => "Last replied forum topics",
// "No forumId specified" => "No forumId specified",
// "Not supported yet" => "Not supported yet",
// "Accepted friendship request from %s" => "Accepted friendship request from %s",
// "Refused friendship request from %s" => "Refused friendship request from %s",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
// "Broke friendship with %s" => "Broke friendship with %s",
// "I have broken our friendship" => "I have broken our friendship",
// "Friendship request sent to %s" => "Friendship request sent to %s",
// "You're already friend of %s" => "You're already friend of %s",
// "I have accepted your friendship request" => "I have accepted your friendship request",
// "I have refused your friendship request" => "I have refused your friendship request",
// "I have canceled my friendship request" => "I have canceled my friendship request",
// "You do not have permission to make the map of this gallery" => "You do not have permission to make the map of this gallery",
// "Back to item" => "Back to item",
// "No valid renderer found. GD or PDFLib required" => "No valid renderer found. GD or PDFLib required",
// "No sheet specified" => "No sheet specified",
// "You must select a renderer" => "You must select a renderer",
// "Invalid Series for current graphic" => "Invalid Series for current graphic",
// "updated from structured text import" => "updated from structured text import",
// "page created" => "page created",
// "created from structured text import" => "created from structured text import",
// "Operations executed successfully" => "Operations executed successfully",
// "Invalid software name" => "Invalid software name",
// "No name indicated for wiki page" => "No name indicated for wiki page",
// "There is more than one item in the tracker with this title" => "There is more than one item in the tracker with this title",
// "There are no items in the tracker with this title" => "There are no items in the tracker with this title",
// "You have requested that this page be machine translated" => "You have requested that this page be machine translated",
// "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it",
// "No repository given" => "No repository given",
// "This invitation does not exist or is deprecated" => "This invitation does not exist or is deprecated",
// "Congratulations! You are now part of this invitation group(s)" => "Congratulations! You are now part of this invitation group(s)",
// "Kaltura Upload" => "Kaltura Upload",
// "Communication error" => "Communication error",
// "Invalid response provided by the Kaltura server. Please retry" => "Invalid response provided by the Kaltura server. Please retry",
// "Are you sure you want to permanently remove article id %0" => "Are you sure you want to permanently remove article id %0",
// "Are you sure you want to permanently remove %0 articles" => "Are you sure you want to permanently remove %0 articles",
// "You do not have permission to view the comments for this blog" => "You do not have permission to view the comments for this blog",
// "This blog has no posts" => "This blog has no posts",
// "WARNING: The file is used in" => "WARNING: The file is used in",
// "Quota too big" => "Quota too big",
// "Quota too small" => "Quota too small",
// "You have permission to upload files but not to this file gallery" => "You have permission to upload files but not to this file gallery",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload your file" => "Please re-upload your file",
// "Could not upload the file" => "Could not upload the file",
// "Could not find the file requested" => "Could not find the file requested",
// "Cannot read the file" => "Cannot read the file",
// "Upload was not successful. Duplicate file content" => "Upload was not successful. Duplicate file content",
// "File update was successful" => "File update was successful",
// "Not modified since" => "Not modified since",
// "Not downloaded since" => "Not downloaded since",
// "You do not have permission to upload files so you cannot edit them" => "You do not have permission to upload files so you cannot edit them",
// "This gallery does not exist" => "This gallery does not exist",
// "Error importing" => "Error importing",
// "Error converting" => "Error converting",
// "Importing" => "Importing",
// "Processing" => "Processing",
// "Ready" => "Ready",
// "Pending moderation" => "Pending moderation",
// "Blocked" => "Blocked",
// "Invalid action" => "Invalid action",
// "Are you sure you want to permanently remove submited article id %0" => "Are you sure you want to permanently remove submited article id %0",
// "Are you sure you want to permanently remove %0 submited articles" => "Are you sure you want to permanently remove %0 submited articles",
// "Are you sure you want to approve %0 submited articles" => "Are you sure you want to approve %0 submited articles",
// "Are you sure you want to remove the %0 selected pages" => "Are you sure you want to remove the %0 selected pages",
// "Are you sure you want to print the %0 selected pages" => "Are you sure you want to print the %0 selected pages",
// "Are you sure you want to unlock the %0 selected pages" => "Are you sure you want to unlock the %0 selected pages",
// "Are you sure you want to lock the %0 selected pages" => "Are you sure you want to lock the %0 selected pages",
// "Are you sure you want to download a zip of the %0 selected pages" => "Are you sure you want to download a zip of the %0 selected pages",
// "Username field cannot be empty. Please go back and try again" => "Username field cannot be empty. Please go back and try again",
// "Unable to contact remote server" => "Unable to contact remote server",
// "XMLRPC Error: " => "XMLRPC Error: ",
// "Unable to create login" => "Unable to create login",
// "More than %d unsuccessful login attempts have been made" => "More than %d unsuccessful login attempts have been made",
// "An email has been sent to you with the instructions to follow" => "An email has been sent to you with the instructions to follow",
// "Resend" => "Resend",
// "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email",
// "Your default nickname is already in use. A new one has to be selected" => "Your default nickname is already in use. A new one has to be selected",
// "Verification cancelled" => "Verification cancelled",
// "The selected account is not associated with your identity" => "The selected account is not associated with your identity",
// "unknown action" => "unknown action",
// "Authentication method is not OpenID" => "Authentication method is not OpenID",
// "Authentication error; probably not a valid OpenID" => "Authentication error; probably not a valid OpenID",
// "Could not redirect to server: " => "Could not redirect to server: ",
// "OpenID authentication failed: " => "OpenID authentication failed: ",
// "Account disabled" => "Account disabled",
// "You must use the right case for your user name" => "You must use the right case for your user name",
// "Sorry, you can't use this feature" => "Sorry, you can't use this feature",
// "An error as occured with the mapfile" => "An error as occured with the mapfile",
// "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files" => "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files",
// " to " => " to ",
// "No page provided" => "No page provided",
// "Welcome at Hawiki" => "Welcome at Hawiki",
// "This Tiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more" => "This Tiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more",
// "You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site" => "You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site",
// "tiki-mobile.php" => "tiki-mobile.php",
// "About" => "About",
// "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody",
// "Your PHP installation does not have zlib enabled" => "Your PHP installation does not have zlib enabled",
// "No note indicated" => "No note indicated",
// "merged note" => "merged note",
// "No item indicated" => "No item indicated",
// "Are you sure you want to delete this note" => "Are you sure you want to delete this note",
// "created from notepad" => "created from notepad",
// "Note not found" => "Note not found",
// "Page already exists" => "Page already exists",
// "Not enough information to display this page" => "Not enough information to display this page",
// "Object Permissions" => "Object Permissions",
// "Are you sure you want to remove the direct permissions from this object" => "Are you sure you want to remove the direct permissions from this object",
// "You do not have permission to assign permissions for this object" => "You do not have permission to assign permissions for this object",
// "Manual payment entered" => "Manual payment entered",
// "You do not have permission to enter payment" => "You do not have permission to enter payment",
// "New payment requested" => "New payment requested",
// "Cancel payment %0" => "Cancel payment %0",
// "Payment canceled" => "Payment canceled",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (' . \$code . " => "Index (' . \$code . ",
// "Pageviews" => "Pageviews",
// "No result indicated" => "No result indicated",
// "Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Please enter a valid %s.  No spaces, more than %d characters and contain %s",
// "Missing User Name" => "Missing User Name",
// "User Already Exists" => "User Already Exists",
// "Invalid or unknown username" => "Invalid or unknown username",
// "Unable to send mail. User has not configured email" => "Unable to send mail. User has not configured email",
// "Please provide a username or email" => "Please provide a username or email",
// "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password",
// "The mail can't be sent. Contact the administrator" => "The mail can't be sent. Contact the administrator",
// "A password reminder email has been sent " => "A password reminder email has been sent ",
// "An email with a link to reset your password has been sent " => "An email with a link to reset your password has been sent ",
// "to the email" => "to the email",
// "to the registered email address for" => "to the registered email address for",
// "You cannot rename staging pages. Please rename the approved page instead" => "You cannot rename staging pages. Please rename the approved page instead",
// "Cannot rename page because the new name begins with reserved prefix" => "Cannot rename page because the new name begins with reserved prefix",
// "Cannot rename page because maybe new staging page name already exists" => "Cannot rename page because maybe new staging page name already exists",
// "Non-existent version" => "Non-existent version",
// "Tiki RSS Feed Error Message: \$errmsg" => "Tiki RSS Feed Error Message: \$errmsg",
// "This match was not case sensitive" => "This match was not case sensitive",
// "No items selected" => "No items selected",
// "Page cannot be found: " => "Page cannot be found: ",
// "Page has changed since preview: " => "Page has changed since preview: ",
// "Page not updated due to error in replacing: " => "Page not updated due to error in replacing: ",
// "Page updated: " => "Page updated: ",
// "A problem occured during file uploading" => "A problem occured during file uploading",
// "File which was causing trouble was at rank" => "File which was causing trouble was at rank",
// "The error was" => "The error was",
// "Error: You can\\'t send the same newsletter by refreshing this frame content" => "Error: You can\\'t send the same newsletter by refreshing this frame content",
// "Newsletter successfully sent to %s users" => "Newsletter successfully sent to %s users",
// "There was %s errors" => "There was %s errors",
// "successfully sent" => "successfully sent",
// "not sent" => "not sent",
// "Error: " => "Error: ",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
// "Notice: invalid variable value" => "Notice: invalid variable value",
// "Report to the webmaster" => "Report to the webmaster",
// "Your link was sent" => "Your link was sent",
// "Your email is mandatory" => "Your email is mandatory",
// "Permission to post in forum denied" => "Permission to post in forum denied",
// "No text given for tweet" => "No text given for tweet",
// "Error sending tweet" => "Error sending tweet",
// "Error sending mail to" => "Error sending mail to",
// "Spreadsheet - " => "Spreadsheet - ",
// "Are you sure you want to delete this spreadsheet" => "Are you sure you want to delete this spreadsheet",
// "You do not have permission to edit messages \$owner" => "You do not have permission to edit messages \$owner",
// "Permission denied. You cannot view this page" => "Permission denied. You cannot view this page",
// "Clean the sql logs" => "Clean the sql logs",
// "Quiz time limit exceeded quiz cannot be computed" => "Quiz time limit exceeded quiz cannot be computed",
// "You cannot take this survey twice" => "You cannot take this survey twice",
// "Send a link to a friend " => "Send a link to a friend ",
// "No trackerId specified" => "No trackerId specified",
// "You must lock the file before editing it" => "You must lock the file before editing it",
// "Batch file processed" => "Batch file processed",
// "No permission to upload zipped file packages" => "No permission to upload zipped file packages",
// "Cannot resize the file" => "Cannot resize the file",
// "Cannot write the file" => "Cannot write the file",
// "Image was reduced: %s x %s -> %s x %s" => "Image was reduced: %s x %s -> %s x %s",
// "Check that these paths exist and are writable by the web server" => "Check that these paths exist and are writable by the web server",
// "Incorrect file extension" => "Incorrect file extension",
// "Error processing zipped image package" => "Error processing zipped image package",
// "No permission to upload zipped image packages" => "No permission to upload zipped image packages",
// "The uploaded file ist not recognized as a image" => "The uploaded file ist not recognized as a image",
// "You do not have permission to upload images" => "You do not have permission to upload images",
// "You have permission to upload images but not to this gallery" => "You have permission to upload images but not to this gallery",
// "Cannot get image from URL" => "Cannot get image from URL",
// "That is not an image (or you have php < 4.0.5)" => "That is not an image (or you have php < 4.0.5)",
// "Usage" => "Usage",
// "No url indicated" => "No url indicated",
// "Invalid password. Your current password is required to change administrative information" => "Invalid password. Your current password is required to change administrative information",
// "If you really want to delete you're account, you must check the checkbox" => "If you really want to delete you're account, you must check the checkbox",
// "unicode" => "unicode",
// "This script can only be called by the server" => "This script can only be called by the server",
// "was moved into trash" => "was moved into trash",
// "trashed by" => "trashed by",
// "open / in process" => "open / in process",
// "Rights by creator" => "Rights by creator",
// "END" => "END",
// "Percentage" => "Percentage",
// "Task accepted by creator" => "Task accepted by creator",
// "Task accepted by task user" => "Task accepted by task user",
// "Task NOT accepted by creator" => "Task NOT accepted by creator",
// "Task NOT accepted by task user" => "Task NOT accepted by task user",
// "Sorry this task does not exist or you have no rights to view this task" => "Sorry this task does not exist or you have no rights to view this task",
// "Task entries" => "Task entries",
// "Changes" => "Changes",
// "Info message" => "Info message",
// "NEW Task" => "NEW Task",
// "Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks" => "Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks",
// "Changes on Task" => "Changes on Task",
// "You received a new task" => "You received a new task",
// "The priority is" => "The priority is",
// "very low" => "very low",
// "high" => "high",
// "very high" => "very high",
// "You've to start your work at least on" => "You've to start your work at least on",
// "You've to finish your work on" => "You've to finish your work on",
// "Login and click the link below" => "Login and click the link below",
// "Please read the task and work on it" => "Please read the task and work on it",
// "Sorry, there was an error while trying to write data into the database" => "Sorry, there was an error while trying to write data into the database",
// "Remove the notification email" => "Remove the notification email",
// "Language watch" => "Language watch",
// "Category watch: %0, Language: %1" => "Category watch: %0, Language: %1",
// "Cannot upload this file not enough quota" => "Cannot upload this file not enough quota",
// "Non-existent user" => "Non-existent user",
// "No banner indicated" => "No banner indicated",
// "Post not found" => "Post not found",
// "You do not have permission to view this blog post while it is marked as private" => "You do not have permission to view this blog post while it is marked as private",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
// "No faq indicated" => "No faq indicated",
// "You are not permitted to remove someone else\\'s post" => "You are not permitted to remove someone else\\'s post",
// "Incorrect thread" => "Incorrect thread",
// "Spreadsheet truncated" => "Spreadsheet truncated",
// "Files are read only at this time" => "Files are read only at this time",
// "Are you sure you want to clone this spreadsheet" => "Are you sure you want to clone this spreadsheet",
// "Clone Error" => "Clone Error",
// "Are you sure you want to rollback this spreadsheet" => "Are you sure you want to rollback this spreadsheet",
// "Rollback Error" => "Rollback Error",
// "Create tracker item" => "Create tracker item",
// "You don't have a personal tracker item yet. Click here to make one" => "You don't have a personal tracker item yet. Click here to make one",
// "That tracker don't use extras" => "That tracker don't use extras",
// "Tiki WebDAV access" => "Tiki WebDAV access",
// "There was a problem connecting to that account" => "There was a problem connecting to that account",
// "There was a problem deleting that mail" => "There was a problem deleting that mail",
// "Mail ID" => "Mail ID",
// "There was a problem while trying to delete these mails" => "There was a problem while trying to delete these mails",
// "There was a problem while trying to delete that mail" => "There was a problem while trying to delete that mail",
// "Are you sure you want to delete this account" => "Are you sure you want to delete this account",
// "Taking" => "Taking",
// "Putting back" => "Putting back",
// "Checking" => "Checking",
// "Aborted" => "Aborted",
// "Plugin modified by editor" => "Plugin modified by editor",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "You are about to delete a TikiTest file, do you want to continue " => "You are about to delete a TikiTest file, do you want to continue ",
// "Error deleting the file" => "Error deleting the file",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// "The page is empty" => "The page is empty",
// ### end of untranslated words
// ###

// ###
// ### start of possibly untranslated words
// ###

"Andorra" => "Andorra",
"Angola" => "Angola",
"Anguilla" => "Anguilla",
"Antigua" => "Antigua",
"Aruba" => "Aruba",
"Belgium" => "Belgium",
"Belize" => "Belize",
"Benin" => "Benin",
"Bermuda" => "Bermuda",
"Bhutan" => "Bhutan",
"Brunei" => "Brunei",
"Burkina Faso" => "Burkina Faso",
"Burundi" => "Burundi",
"Chile" => "Chile",
"Costa Rica" => "Costa Rica",
"Ecuador" => "Ecuador",
"El Salvador" => "El Salvador",
"Eritrea" => "Eritrea",
"Gabon" => "Gabon",
"Gambia" => "Gambia",
"Grenada" => "Grenada",
"Guatemala" => "Guatemala",
"Guinea" => "Guinea",
"Haiti" => "Haiti",
"Honduras" => "Honduras",
"Hong Kong" => "Hong Kong",
"India" => "India",
"Kenya" => "Kenya",
"Kiribati" => "Kiribati",
"Kuwait" => "Kuwait",
"Liechtenstein" => "Liechtenstein",
"Luxemburg" => "Luxemburg",
"Malawi" => "Malawi",
"Mali" => "Mali",
"Moldova" => "Moldova",
"Monaco" => "Monaco",
"Montenegro" => "Montenegro",
"Nauru" => "Nauru",
"Nicaragua" => "Nicaragua",
"Niger" => "Niger",
"Niue" => "Niue",
"Oman" => "Oman",
"Palau" => "Palau",
"Panama" => "Panama",
"blog" => "blog",
"Blog" => "Blog",
"Flip" => "Flip",
"OK" => "OK",
"CAS (Central Authentication Service)" => "CAS (Central Authentication Service)",
"Shibboleth" => "Shibboleth",
"3" => "3",
"Port" => "Port",
"1" => "1",
"2" => "2",
"4" => "4",
"5" => "5",
"Minichat" => "Minichat",
"PHPLayers" => "PHPLayers",
"Ajax" => "Ajax",
"Mindmap" => "Mindmap",
"XMLRPC API" => "XMLRPC API",
"JQuery UI" => "JQuery UI",
"Mb" => "Mb",
"HTTP port" => "HTTP port",
"HTTPS port" => "HTTPS port",
"geo.position" => "geo.position",
"geo.region" => "geo.region",
"geo.placename" => "geo.placename",
"km" => "km",
"wiki" => "wiki",
"index" => "index",
"max" => "max",
"jscalendar" => "jscalendar",
"~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~" => "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~",
"Banner" => "Banner",
"URL" => "URL",
"Blog ID" => "Blog ID",
"Max" => "Max",
"DBReport" => "DBReport",
"Div" => "Div",
"Youtube" => "Youtube",
"googledoc" => "googledoc",
"HTML" => "HTML",
"Iframe" => "Iframe",
"iframe" => "iframe",
"Popup" => "Popup",
"Stop" => "Stop",
"Jabber" => "Jabber",
"Javascript" => "Javascript",
"Limit" => "Limit",
"Mediaplayer" => "Mediaplayer",
"MP3 URL" => "MP3 URL",
"FLV URL" => "FLV URL",
"Instructions::Feedback" => "Instructions::Feedback",
"Monospace" => "Monospace",
"MySpace" => "MySpace",
"Plugin" => "Plugin",
"Maximum" => "Maximum",
"SourceForge" => "SourceForge",
"Pop-up" => "Pop-up",
"Skype" => "Skype",
"SQL" => "SQL",
"Self" => "Self",
"Checkbox" => "Checkbox",
"goIfOne" => "goIfOne",
"fieldId" => "fieldId",
"External Wiki" => "External Wiki",
"WikiWord" => "WikiWord",
"__key__ | __default__ | __comments__\n" => "__key__ | __default__ | __comments__\n",
"Plugin " => "Plugin ",
"Invalid" => "Invalid",
"CC" => "CC",
"BCC" => "BCC",
"Powered by" => "Powered by",
"powered by" => "powered by",
"IP" => "IP",
"port" => "port",
"LDAP" => "LDAP",
"PAM" => "PAM",
"Geo URL" => "Geo URL",
"Token" => "Token",
"Invert" => "Invert",
"URL:" => "URL:",
"Valid" => "Valid",
"PDF" => "PDF",
"XML Zip" => "XML Zip",
"November" => "November",
"December" => "December",
"MultiTiki" => "MultiTiki",
"Program" => "Program",
"Xml Zip" => "Xml Zip",
"MyTiki" => "MyTiki",
"tiki.org" => "tiki.org",
"%m/%d/%Y [%H:%M]" => "%m/%d/%Y [%H:%M]",
"TOC" => "TOC",
"id" => "id",
// ###
// ### end of possibly untranslated words
// ###

"Copyright management" => "Szerzői jogok kezelése",
"No page indicated" => "Nincs megadva oldal",
"You must supply all the information, including title and year." => "Minden információt meg kell adni (különösen címet és az évet)",
"You do not have permission to use this feature" => "Magasabb csoportszintű jogosultágra van szükséged, hogy ezt a funkciót használhasd",
"Type" => "Típus",
"Name" => "Név",
"Description" => "Leírás",
"Size" => "Méret",
"Created" => "Létrehozás",
"Uploaded" => "Feltöltés",
"Last Modified" => "Utolsó módosítás",
"Creator" => "Létrehozó",
"Comment" => "Komment",
"Files" => "Fájlok",
"Hits" => "Megtekintések",
"Last download" => "Legutóbbi letöltés",
"Locked by" => "Zárolta",
"Backlinks" => "Hivatkozások",
"Explorer" => "Böngésző",
"Path" => "Útvonal",
"Slideshow" => "Vetítés",
"Default View" => "Alapértelmezett nézet",
"Register" => "Regisztráció",
"Afghanistan" => "Afganisztán",
"Aland Islands" => "Aland Szigetek",
"Albania" => "Albánia",
"Algeria" => "Algéria",
"American Samoa" => "Amerikai Samoa",
"Argentina" => "Argentína",
"Armenia" => "Örményország",
"Australia" => "Ausztrália",
"Austria" => "Ausztria",
"Azerbaijan" => "Azerbajdzsán",
"Bahamas" => "Bahamák",
"Bahrain" => "Bahrein",
"Bangladesh" => "Banglades",
"Barbados" => "Barbadosz",
"Belarus" => "Fehéroroszország",
"Bolivia" => "Bolívia",
"Bosnia and Herzegovina" => "Bosznia Hercegovina",
"Botswana" => "Botswána",
"Bouvet Island" => "Bouvet Sziget",
"Brazil" => "Brazilia",
"Bulgaria" => "Bulgária",
"Cambodia" => "Kambodzsa",
"Cameroon" => "Kamerum",
"Canada" => "Kanada",
"Cape Verde" => "Zöld-foki Köztársaság",
"Cayman Islands" => "Kajmán-szigetek",
"Chad" => "Csád",
"China" => "Kína",
"Christmas Island" => "Karácsony-sziget",
"Colombia" => "Kolumbia",
"Congo" => "Kongó",
"Croatia" => "Horvátország",
"Cuba" => "Kuba",
"Cyprus" => "Ciprus",
"Czech Republic" => "Csehország",
"Denmark" => "Dánia",
"Dominica" => "Dominika",
"Dominican Republic" => "Dominikai Köztársaság",
"Egypt" => "Egyiptom",
"Equatorial Guinea" => "Egyenlítői Guinea",
"Estonia" => "Észtország",
"Ethiopia" => "Etiópia",
"Europe" => "Európa",
"Falkland Islands" => "Falkland-szigetek",
"Faroe Islands" => "Faröe-szigetek",
"Fiji" => "Fidzsi",
"Finland" => "Finnország",
"France" => "Franciaország",
"French Guiana" => "Francia Guayana",
"French Polynesia" => "Francia Polinézia",
"Germany" => "Németország",
"Ghana" => "Ghána",
"Gibraltar" => "Gibraltár",
"Greece" => "Görögország",
"Greenland" => "Grönland",
"Hungary" => "Magyarország",
"Iceland" => "Izland",
"Indonesia" => "Indonézia",
"Iran" => "Irán",
"Iraq" => "Irák",
"Ireland" => "Írország",
"Israel" => "Izrael",
"Italy" => "Olaszország",
"Jamaica" => "Jamaika",
"Japan" => "Japán",
"Jordan" => "Jordánia",
"Kazakstan" => "Kazaksztán",
"Kyrgyzstan" => "Kirgizisztán",
"Laos" => "Laosz",
"Latvia" => "Lettország",
"Lebanon" => "Libanon",
"Liberia" => "Libéria",
"Libya" => "Líbia",
"Lithuania" => "Litvánia",
"Macao" => "Makao",
"Macedonia" => "Macedónia",
"Madagascar" => "Madagaszkár",
"Malaysia" => "Malázia",
"Maldives" => "Maldív-szigetek",
"Malta" => "Málta",
"Mauritania" => "Mauritánia",
"Mexico" => "Mexikó",
"Mongolia" => "Mongólia",
"Morocco" => "Marokkó",
"Mozambique" => "Mozambik",
"Myanmar" => "Burma (Myanmar)",
"Namibia" => "Namíbia",
"Nepal" => "Nepál",
"Netherlands Antilles" => "Holland Antillák",
"Netherlands" => "Hollandia",
"New Caledonia" => "Új Kaledónia",
"New Zealand" => "Új-Zéland",
"Nigeria" => "Nigéria",
"None" => "Nincs",
"Norfolk Island" => "Norfolk-szigetek",
"North Korea" => "Észak Korea",
"Norway" => "Norvégia",
"Other" => "Egyéb",
"Pakistan" => "Pakisztán",
"Palestine" => "Palesztina",
"Papua New Guinea" => "Papua Új Guinea",
"Portugal" => "Portugália",
"Slovakia" => "Szlovákia",
"Slovenia" => "Szlovénia",
"South Georgia and South Sandwich Islands" => "South Georgia és South Sandwich Szigetek",
"South Korea" => "Dél Korea",
"Spain" => "Spanyolország",
"Sudan" => "Szudán",
"Sweden" => "Svédország",
"Switzerland" => "Svájc",
"Syria" => "Szíria",
"Tajikistan" => "Tadzsikisztán",
"Tanzania" => "Tanzánia",
"Thailand" => "Thaiföld",
"Tunisia" => "Tunézia",
"Turkmenistan" => "Türkmenisztán",
"United Kingdom" => "Egyesült Királyság",
"Uzbekistan" => "Üzbegisztán",
"Viet Nam" => "Vietnám",
"World" => "Világ",
"Yugoslavia" => "Jugoszlávia",
"the former Yugoslav Republic of Macedonia" => "a korábbi Macedón Jugoszláv Köztársaság",
"Welsh" => "walesi",
"Slovene" => "szlovén",
"Arabic" => "arab",
"Catalan" => "katalán",
"Simplified Chinese" => "kínai (egyszerűsített)",
"Czech" => "cseh",
"Danish" => "dán",
"German" => "német",
"English" => "angol",
"English British" => "angol (Brit)",
"Spanish" => "spanyol",
"Greek" => "görög",
"Farsi" => "farszi",
"Finnish" => "finn",
"French" => "francia",
"Frisian Netherlands" => "holland (fríz)",
"Galician" => "galíciai",
"Hebrew" => "jiddis",
"Croatian" => "horvát",
"Indonesian" => "indonéz",
"Icelandic" => "izlandi",
"Italian" => "olasz",
"Inuktitut" => "inuktitut",
"Japanese" => "japán",
"Korean" => "koreai",
"Hungarian" => "magyar",
"Lithuanian" => "litván",
"Dutch" => "holland",
"Norwegian" => "norvég",
"Polish" => "lengyel",
"Português" => "portugál",
"Brazilian Portuguese" => "portugál (brazil)",
"Romanian" => "román",
"Russian" => "orosz",
"Pijin Solomon" => "pijin solomon",
"Sinhala" => "sinhala",
"Slovak" => "szlovák",
"Albanian" => "albán",
"Serbian Latin" => "szerb (latin)",
"Swedish" => "svéd",
"Tuvaluan" => "tuvaluan",
"Turkish" => "török",
"Traditional Chinese" => "kínai (hagyományos)",
"Ukrainian" => "ukrán",
"Vietnamese" => "vietnámi",
"Permission denied" => "Hozzáférés megtagadva, magasabb szintű jogosultságra van szükség",
"The file is not a CSV file or has not a correct syntax" => "Ez vagy nem egy vesszővel elválasztott (CSV) fájl, vagy rossz a fájl belső formátuma",
"locked" => "zárolva",
"locked by" => "zárolta",
"Administration:" => "Adminisztráció:",
"Sunday" => "Vasárnap",
"Monday" => "Hétfő",
"Tuesday" => "Kedd",
"Wednesday" => "Szerda",
"Thursday" => "Csütörtök",
"Friday" => "Péntek",
"Saturday" => "Szombat",
"Mo" => "Hétfő",
"Tu" => "Kedd",
"We" => "Szerda",
"Fr" => "Péntek",
"in" => "itt",
"continued" => "bővebben",
"New Image Uploaded by" => "Az új képet feltöltötte:",
"tracker" => "űrlap",
"by" => " ",
"Image Gallery" => "Képgaléria",
"Articles" => "Cikkek",
"Blogs" => "Blogok",
"Forums" => "Fórumok",
"Directory" => "Linktár",
"File Gallery" => "Fájlgaléria",
"FAQs" => "GYIK-ek",
"Quizzes" => "Kvízek",
"Trackers" => "Űrlapok",
"Survey" => "Kérdőív",
"Newsletter" => "Hírlevél",
"Help" => "Súgó",
"article" => "cikk",
"directory" => "könytár",
"faq" => "gyik",
"file gallery" => "fájlgaléria",
"forum" => "fórum",
"image gallery" => "képgaléria",
"poll" => "szavazás",
"quiz" => "kvíz",
"survey" => "kérdőív",
"wiki page" => "wiki oldal",
"image" => "kép",
"calendar" => "naptár",
"Cannot upload this file - maximum upload size exceeded" => "Túl nagy a fájl, nem tudom feltölteni",
"Cannot write to this file:" => "Nem tudok írni ebbe a fájlba:",
"Wrong password. Cannot post comment" => "Rossz jelszó! A komment nem lett elküldve.",
"Create page:" => "Oldal létrehozása:",
"Set" => "Beállítás",
"Plugin disabled" => "Plugin kikapcsolva",
"File Galleries" => "Fájlgalériák",
"File gallery quota exceeded" => "Fájlgaléria kvóta túllépése",
"Wiki Home" => "Wiki főoldal",
"Home" => "Főoldal",
"previous page" => "előző oldal",
"next page" => "következő oldal",
"posted on" => "beküldés időpontja:",
"Continue" => "Tovább",
"By:" => "Szerző:",
"Read" => "Olvasás",
"List articles" => "Cikkek listázása",
"Last post" => "Legutóbbi poszt",
"Errors detected" => "Hiba lépett fel",
"No image yet, sorry." => "Még nincs kép",
"Contributions" => "Hozzájárulások",
"This feature is disabled" => "Ez a funkció most nincs bekapcsolva",
"unknown" => "ismeretlen",
"for" => "",
"Perspective" => "Perspektíva",
"Language" => "Nyelv",
"Section" => "Szekció",
"Theme" => "Stílus",
"Rows" => "Sor",
"Error" => "Hiba",
"Users accept internal messages by default" => "Alapértelmezés szerint a felhasználók fogadhatnak üzeneteket",
"Newest first" => "Időben csökkenő",
"ascending" => "növekvő",
"descending" => "csökkenő",
"Title of articles home page" => "Cikkek kezdőlapja",
"Topic" => "Téma",
"Title" => "Cím",
"Title length" => "Cím hossza",
"Publication date" => "Publikálás dátuma",
"Expiration date" => "Lejárat dátuma",
"Visible" => "Látható",
"User" => "Felhasználó",
"Author" => "Szerző",
"Author Rating" => "Szerző értékelése",
"Reads" => "Olvasás",
"Images" => "Képek",
"Id" => "ID",
"Top" => "Legfelső szint",
"Oldest first" => "Időben növekvő",
"Points" => "Pontok",
"Default number per page" => "Alapértelmezett szám oldalanként",
"Default Ordering" => "Alapértelmezett rendezés",
"Authentication method" => "Azonosítási módszer",
"Tiki and PAM" => "Tiki és PAM",
"Web Server" => "Webszerver",
"phpBB Version" => "phpBB verzió",
"Host" => "Hoszt",
"Use TLS" => "TLS használata",
"Search scope" => "Keresési kör",
"Subtree" => "Alárendelt fa",
"One level" => "Egy szint",
"Base object" => "Alap objektum",
"LDAP version" => "LDAP verzió",
"User attribute" => "Felhasználói atrribútum",
"Admin user" => "Adminisztrátor felhasználó",
"Admin password" => "Adminisztrátori jelszó",
"All" => "Összes",
"Available languages" => "Rendelkezésre álló nyelvek",
"Default ordering" => "Alapértelmezett rendezés",
"Creation Date (desc)" => "Keletkezés dátuma (csökk)",
"Last modification date (desc)" => "Utolsó módositás dátuma (csökk)",
"Blog title (asc)" => "Blog címe (növ)",
"Number of posts (desc)" => "Posztok száma (csökk)",
"Visits (desc)" => "Látogatottság (csökk)",
"Activity (desc)" => "Aktivitás (csökk)",
"Creation date" => "Létrehozás dátuma",
"Last modified" => "Utolsó módositás",
"Disabled" => "Letiltva",
"Plain text" => "Egyszerű szöveg",
"Link to user information" => "Link a felhasználói információkhoz",
"User avatar" => "Felhasználói avatár",
"Posts" => "Hozzászólások",
"Visits" => "Látogatások",
"Activity" => "Aktivitás",
"Example:" => "Például:",
"Module (box) shadow start" => "Modul (doboz) árnyék kezdete",
"Default view mode" => "Alapértelmezett megjelenítési mód",
"Day" => "Nap",
"Week" => "Hét",
"Month" => "Hónap",
"Quarter" => "Negyedév",
"Semester" => "Félév",
"Year" => "Év",
"First day of the week" => "Hét első napja",
"Depends user language" => "Felhasználó nyelvétől függ",
"Split hours in periods of" => "Óra felosztása a következő periódusokra",
"1 minute" => "1 perc",
"5 minutes" => "5 perc",
"10 minutes" => "10 perc",
"15 minutes" => "15 perc",
"30 minutes" => "30 perc",
"First year in the dropdown" => "Első év a legördülő menüben",
"Last year in the dropdown" => "Utolsó év a legördülő menüben",
"Sticky popup" => "'Ragadós' felugró ablak",
"Item view tab" => "Tétel nézet fül",
"Default:" => "Alapértelmezett:",
"CAS server version" => "CAS szerver verzió",
"none" => "nincs",
"Version 1.0" => "Verzió 1.0",
"Version 2.0" => "Verzió 2.0",
"Hostname" => "Hoszt neve",
"Never" => "Soha",
"Categories used in templates (TPL)" => "Sablonokban (TPL) használt kategóriák",
"Synchronize multilingual categories" => "Többnyelvű kategóriák szinkronizálása",
"Only those specified" => "Csak a kiválasztottak",
"All but those specified" => "Minden a kiválasztottakon kívűl",
"Synchronized categories" => "Szinkronizált kategóriák",
"Exclude these categories" => "Ezen kategóriák kizárása",
"Separate category IDs with a comma (,)" => "kategória ID-k vesszővel elválasztva (,)",
"Users can change site language" => "Felhasználól változtathatják a weblap nyelvét",
"Users can change theme" => "Regisztrált felhasználók megváltoztathatják a stílust",
"Disable title for comments" => "Kommentek címének kikapcsolása",
"Email field" => "E-mail mező",
"Website field" => "Weboldal mező",
"Use vote system for comments" => "Szavazási rendszer használata kommentekhez",
"Allow anonymous visitors to use the \"Contact Us\" feature." => "Anonim látogatók használhatják a Kapcsolatfelvétel funkciót",
"Contact user" => "Kapcsolattartó felhasználó",
"Cookie name" => "Cookie név",
"Count admin pageviews" => "Adminisztrátori lapnézések számolása",
"Default charset for sending mail" => "Levélküldés alapértelmezett karakterkészlete",
"default mapfile" => "Alapértelmezett térképfájl",
"Default diff style" => "Eltérés alapértelmezett stílusa",
"Only with last version" => "Csak a legutóbbi verzióval",
"HTML diff" => "HTML formátumú eltérés",
"Side-by-side diff" => "Egymás melletti diff",
"Side-by-side diff by characters" => "Karakterenkénti eltérés egymás mellett",
"Inline diff" => "Tartalmon belüli eltérés",
"Inline diff by characters" => "Tartalmon belüli eltérés karakterenként",
"Full side-by-side diff" => "Teljes egymás melletti diff",
"Full side-by-side diff by characters" => "Eltérések teljes összehasonlítása egymás mellett",
"Full inline diff" => "Teljes diff (szövegben)",
"Unified diff" => "Egységes diff",
"Side-by-side view" => "Egymás melletti nézet",
"rows" => "sor",
"Default number of rows for comment box" => "Sorok alapértelmezett száma a komment dobozhoz",
"Forum" => "Fórum",
"Forum reply" => "Fórum válasz",
"Default Editor" => "Alapértelmezett szerkesztő",
"Simple" => "Egyszerű",
"Advanced" => "Haladó",
"Use direct pagination links" => "Direkt oldalléptetési linkek használata",
"Show Country Flag" => "Országzászló mutatása",
"Validate URLs" => "URL-ek hitelesítése",
"Links per page" => "Laponkénti hivatkozások (linkek)",
"Method to open directory links" => "Könyvtárban szereplő linkek megnyitásának módja",
"replace current window" => "jelenlegi ablak kicserélése",
"new window" => "új ablak",
"inline frame" => "belső keret",
"Fields display order" => "Mezők megjelenítési sorrendje",
"days" => "nap",
"PHP Error reporting level" => "PHP hiba jelentési szint",
"No error reporting" => "Nincs hibajelentés",
"Report all PHP errors" => "Minden PHP hiba jelentése",
"According to PHP configuration" => "PHP konfigurációnak megfelelően",
"Default number of comments per page" => "Kommentek alapértelmezett száma oldalanként",
"Comments default ordering" => "Kommentek alapértelmezett rendezési elve",
"Question and Answer prefix on Answers" => "Kérdés és Válasz előtag válaszoknál",
"Q and A" => "K & V",
"Question ID" => "Kérdés azonosító",
"Faqs" => "GYIK-ek",
"Force and limit categorization to within subtree of" => "Kategorizálás kényszerítése és korlátozása ezen kategóriaág alá",
"Machine Translation (by Google Translate)" => "Gépi fordítás  (Google Translate)",
"Polls" => "Szavazások",
"Newsletters" => "Hírlevelek",
"Calendar" => "Naptár",
"Banners" => "Bannerek",
"Category" => "Kategória",
"Score" => "Pontszám",
"Freetags" => "Címkék",
"Action Log" => "Akció log",
"Contribution" => "Hozzájárulás",
"Multilingual" => "Többnyelvű",
"FAQ" => "GYIK",
"Surveys" => "Kérdőívek",
"Featured links" => "Kiemelt linkek",
"Copyright" => "Szerzői jogok",
"Shoutbox" => "Üzenőfal",
"Maps" => "Térképek",
"Google Maps" => "Google térképek",
"Live support system" => "Élő támogatási rendszer",
"Tell a Friend" => "Szólj egy barátodnak",
"Share" => "Megosztás",
"HTML pages" => "HTML oldalak",
"Contact Us" => "Kapcsolatfelvétel",
"Comments Moderation" => "Kommentek moderálása",
"Comments Locking" => "Kommentek zárolása",
"Display page name as page title" => "Oldal nevének megjelenítése oldal címeként",
"Individual wiki cache" => "Egyedi wiki cache",
"JS Calendar" => "JS naptár",
"HTML Purifier" => "HTML tisztító",
"Mobile" => "Mobil",
"Morcego 3D browser" => "Morcego 3D böngésző",
"Webmail" => "Webes levelezés",
"Mail-in" => "Bejövő levelezés",
"Wysiwyg editor" => "WYSIWYG szerkesztő",
"Save draft" => "Piszkozat mentése",
"Friendship Network" => "Baráti körök",
"Banning system" => "Kitiltási rendszer",
"Stats" => "Statisztika",
"Action calendar" => "Akció naptár",
"Referer Stats" => "Hivatkozási statisztika",
"Redirect On Error" => "Átirányítás hiba esetén",
"Communications (send/receive objects)" => "Kommunikáció (objektum küldése/fogadás)",
"Custom Home" => "Saját kezdőlap",
"Mini Calendar" => "Mini Naptár",
"User Preferences Screen" => "Felhasználói preferenciák képernyő",
"User Notepad" => "Felhasználói jegyzettömb",
"User Bookmarks" => "Felhasználói könyvjelzők",
"User Contacts" => "Felhasználó kapcsolatai",
"User Watches" => "Felhasználói figyelések",
"Group Watches" => "Csoport figyelések",
"Daily Reports for User Watches" => "Napi felhasználói figyelések riport",
"User Watches Translations" => "Felhasználó figyeli a fordításokat",
"User Menu" => "Felhasználói menü",
"User Tasks" => "Felhasználói feladatok",
"User Messages" => "Felhasználói üzenetek",
"User Files" => "Felhasználói fájlok",
"Group Alert" => "Csoport figyelmeztetés",
"Integrator" => "Integrátor",
"Debugger Console" => "Debug konzol",
"TikiTests" => "TikiTest",
"Check for updates automatically" => "Frissítések automatikus ellenőrzése",
"Protect against CSRF with a ticket" => "CSRF elleni védekezés jeggyel",
"Detect browser language" => "Böngésző nyelvének felismerése",
"Changing the page language also changes the site language" => "Oldal nyelvének változtatása változtassa a weblap nyelvét is",
"Translation assistant" => "Fordítási asszisztens",
"Urgent translation notifications" => "Sürgős fordítási figyelmeztetések",
"Only allow urgent translation from site language" => "Csak sürgős fordítások elfogadása a weblap nyelvéről",
"Incomplete translation notice" => "Figyelmeztetés be nem fejezett fordításokról",
"Multilingual structures" => "Többnyelvű struktúrák",
"Display all languages in a single page" => "Összes nyelv megjelenítése egy oldalon",
"GZip output" => "GZip kimenet",
"Help System" => "Segítségnyújtás",
"Translation URLs" => "Fordítási URL-ek",
"Translation icons" => "Fordítás ikonok",
"Smileys" => "Mosolyok",
"Dynamic Content System" => "Dinamikus tartalomkezelő rendszer",
"Use File Galleries to store pictures" => "Képek tárolása fájlgalériában",
"External link icon" => "Külső link ikon",
"Semantic links" => "Szemantikus linkek",
"Display menus as folders" => "A menüket megjelenítése mappaként",
"Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonim szerkesztőknek anti-bot kódot (CAPTCHA) kell megadniuk",
"Protect email against spam" => "E-mail védése spam ellen",
"Activate" => "Aktiválás",
"Anonymous voting" => "Anonim szavazás",
"Allow re-voting" => "Újboli szavazás megengedése",
"Comments for polls" => "Szavazás kommentek",
"Comments for FAQs" => "GYIK kommentek",
"Search engine friendly url" => "Keresőmotor-barát URL",
"Show module controls" => "Modul vezérlők megjelenítése",
"Perspectives" => "Perspektívák",
"Search and replace" => "Keresés és kicserélés",
"Submissions" => "Beküldések",
"Rankings" => "Rangsor",
"Comments for articles" => "Cikk kommentek",
"Content Templates" => "Tartalom sablonok",
"Print" => "Nyomtatás",
"Specify notification emails when creating articles" => "Értesítési E-mail címek megadása cikk létrehozásakor",
"Category Path" => "Kategória útvonal",
"Show category objects" => "Kategória objektumok megjelenítése",
"Use PHPLayers for category browser" => "PHPLayers használata a kategóriák böngészéséhez",
"Ignore category viewing restrictions" => "Kategória megtekintési korlátozások figyelmen kívűl hagyása",
"Will improve performance, but may show forbidden results" => "Javítja a teljesítményt de megjeleníthet tiltott (jogosultság nélküli) eredményeket",
"List pages" => "Oldalak listázása",
"Last changes" => "Legutóbbi változások",
"Orphan pages" => "Forrás oldalak",
"Referer Search Highlighting" => "Hivatkozott keresés kiemelése",
"Search stats" => "Keresési statisztika",
"Ignore individual object permissions" => "Egyedi objektumjogosultságok ignorálása",
"Object filter" => "Objektum szűrő",
"Search box" => "Keresődoboz",
"Pertinence" => "Helyesség (relevancia)",
"Object type" => "Objektum típusa",
"Last modified date" => "Utolsó módosítás dátuma",
"Comments on blog posts" => "Blog poszt kommentek",
"File Gallery Comments" => "Fájlgaléria kommentek",
"Batch uploading" => "Kötegelt feltöltés",
"Accept wiki syntax" => "Wiki szintakszis elfogadása",
"Topic archiving" => "Téma archiválás",
"Quick jumps" => "Gyors ugrások",
"Replies are empty" => "Válaszok üresek",
"If disabled, replies will quote the original post" => "Ha ki van kapcsolva akkor a válaszok idézik az eredeti posztot",
"First post of a thread can have an empty body" => "Egy thread első posztjának törzse lehet üres",
"Will be a thread title" => "Thread cím lesz",
"Forum name search" => "Fórum név keresés",
"When listing forums" => "Fórumok listázásakor",
"Forum content search" => "Fórum tartalom keresés",
"Topic content search" => "Téma tartalom keresés",
"tikihash (old)" => "tikihash (régi)",
"Edit CSS" => "CSS szerkesztése",
"Theme Control" => "Stílus kontroll",
"Tiki Template Viewing" => "Tiki sablon megtekintés",
"Edit Templates" => "Sablonok szerkesztése",
"Custom HTML <head> Content" => "Saját HTML <head> tartalom",
"Custom Site Header" => "Weblap fejléc testreszabása",
"Site Logo and Title" => "Weblap logó és cím",
"Search Bar" => "Kereső sor",
"Login Bar" => "Bejelentkezési sor",
"Display current Tiki version" => "Jelenlegi Tiki verzió megjelenítése",
"Site menu bar" => "Weblap menü sor",
"Menu ID" => "Menü ID",
"Needs either CSS Menus or PHPLayers" => "CSS menü vagy PHPLayers szükséges",
"Top Bar" => "Legfelső sor",
"Left column" => "Bal oszlop",
"Always" => "Mindig",
"User Decides" => "Felhasználó dönt",
"Site location bar" => "Weblap lokáció sor",
"Top of page" => "Oldal teteje",
"Larger font for" => "Nagyobb betűméret itt",
"Page name" => "Lap neve",
"Use page description" => "Oldalak leírásának felhasználása",
"Custom Site Footer" => "Testreszabott weblap lábléc",
"Bottom bar" => "Alsó sáv",
"Bottom bar icons" => "Alsó sor ikonjai",
"Bottom bar debug" => "Hibakereső az alsó soron",
"Bottom bar (RSS)" => "Alsó sor (RSS)",
"Webmaster Report" => "Webmester riport",
"Webmaster Email" => "Webmester E-mail",
"Leave blank to use the default sender email" => "Üresen kell hagyni az alapértelmezett küldési cím használatához",
"Email this page" => "Oldal küldése E-mailben",
"Validation" => "Validálás",
"JQuery Sortable Tables" => "JQuery rendezhető táblák",
"Use Tabs" => "Fülek használata",
"Correct PNG images alpha transparency in IE6 (experimental)" => "PNG képek alfa transparenciájának javítása IE6-ban (kísérleti)",
"Content templates" => "Tartalom sablonok",
"Warn on edit conflict" => "Figyelmeztessen szerkesztési konfliktusnál",
"Undo" => "Visszaállítás (undo)",
"Footnotes" => "Lábjegyzetek",
"Allow HTML" => "HTML engedélyezése",
"Log bytes changes (+/-) in action logs" => "Bájt változások (+/-) az akció logban",
"May impact performance" => "Hatással lehet a teljesítményre",
"Sandbox" => "Homokozó",
"Comments below wiki pages" => "Komment wiki oldalak alatt",
"Pictures" => "Képek",
"Export" => "Exportálás",
"WikiWords" => "WikiSzavak",
"Link plural WikiWords to their singular forms" => "Többesszámú WikiWord hozzákötése az egyes számú formához (angolul)",
"Accept dashes and underscores in WikiWords" => "Kötőjelek és aláhúzások elfogadás WikiWordben",
"History" => "Előzmények",
"Display IP address" => "IP cím megjelenítése",
"History all instead of only page data, description, and change comment" => "Összes előzmény (nem csak az oldal adatai, leírása és a változások összefoglalói)",
"View page contributions by author" => "Oldalhoz történt hozzájárulások szerzőnként",
"Discuss pages on forums" => "Oldalak megbeszélése fórumokban",
"View source" => "Forrás megtekintése",
"Rating" => "Értékelés",
"Similar (like pages)" => "Hasonló oldalak",
"Structures" => "Struktúrák",
"Open page as structure" => "Oldal megnyitása struktúraként",
"Make structure from page" => "Struktúra készítése oldalból",
"Categorize structure pages together" => "Struktúra oldalainak közös kategóriába helyezése",
"Create webhelp from structure" => "Websúgó készítése struktúrából",
"Import HTML" => "HTML importálása",
"Import pages" => "Oldalak importálása",
"UserPage prefix" => "Felhasználói oldal prefix",
"Users can lock pages" => "Felhasználók zárolhatják az oldalakat",
"MultiPrint" => "Tömeges nyomtatás",
"Use wiki page staging and approval" => "Wiki oldal előkészítés és jóváhagyás használata",
"Pages not in structure" => "Nem Struktúrában nem szereplő oldalak",
"Attachments" => "Mellékletek",
"Dumps" => "Dump-ok",
"Display show/hide icon displayed before headings" => "Megjelenítés/elrejtés ikon megjelenítése címsorok előtt",
"Metrics Dashboard" => "Mérőszámok",
"Use challenge/response authentication" => "Kérdés/válasz azonosítás használata",
"Users can choose to stay in SSL mode after an HTTPS login" => "Felhasználók választhatnak hogy SSL módban maradnak HTTPS bejelentkezés után",
"Users can switch between secured or standard mode at login" => "Felhasználók választhatnak standard és biztonságos mód között bejelentkezéskor",
"Wiki paragraph formatting" => "Wiki bekezdés formázás",
"Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines." => "Mivel a Wiki bekezdés formázás be van kapcsolva ezért a nem üres sorok összes csoportja bekezdésbe van összegyűjtve. A sorok bármilyen hosszúságúak lehetnek és egybe lesznek tördelve a következő sorral. A bekezdéseket üres sorok választják el.",
"Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "Mivel a Wiki bekezdés formázás ki van kapcsolva ezért minden sor úgy jelenik meg ahogy írjuk. Ez azt jelenti hogy ha szeretnénk hogy a sorok rendesen legyenek tördelve akkor a teljes bekezdés egy sorból álljon.",
"...but still create line breaks within paragraphs" => "...de mégis hozzon létre sortöréseket bekezdéseken belül",
"Automonospaced text" => "Automonospaced szöveg",
"Tables syntax" => "Táblázat szintaxis",
"|| for rows" => "|| sorokhoz",
"<return> for rows" => "<return> sorokhoz",
"AutoLinks" => "Automatikus linkek (AutoLink-ek)",
"Hotwords" => "Kulcsszavak",
"Open Hotwords in new window" => "Hotword megnyitása új ablakban",
"Users can choose to show their gender" => "Felhasználók megmutathatják nemüket",
"Real name" => "Valódi név",
"Gender" => "Nem",
"Picture (avatar)" => "Kép (avatár)",
"Number of friends" => "Barátok száma",
"Country" => "Ország",
"Last login" => "Legutóbbi bejelentkezés",
"Distance" => "Távolság",
"Manual selection of time/date" => "Idő/dátum manuális kiválasztása",
"Fixed width" => "Fix szélesség",
"Social networks" => "Közösségi hálózatok",
"Group Transition" => "Csoport tranzíció",
"Tiki User Credits" => "Tiki felhasználói kreditek",
"Display 'MyTiki' in the application menu" => "MyTiki megjelenítése az alkalmazás fő menüjében",
"Show user's contribution on the user information page" => "Felhasználó hozzájárulásainak megjelenítése a felhasználó információs oldalán",
"Require file author's name for anonymous uploads" => "Fájl szerzőjének megadása kötelező anonim feltöltéskor",
"Redirect to similar wiki page" => "Átirányítás hasonló wiki oldalra",
"User's page" => "Felhasználói oldal",
"Show user's information on mouseover" => "Felhasználói információk megjelenítése egér felhasználói név felé mozgatásakor",
"Requires user's information to be public" => "A felhasználói információknak publikusnak kell lennie",
"Default feed format" => "Alapértelmezett feed formátum",
"Feed author name" => "Feed szerző neve",
"This field is mandatory unless both feed author email and homepage are empty." => "Ez a mező kötelező, kivéve ha a feed szerző e-mail és honlap mezők üresek",
"Feeed author email" => "Feed szerző e-mail",
"Feed author homepage" => "Feed szerző honlapja",
"Feed editor email" => "Feed szerkesztő  e-mail",
"Feed webmaster email" => "Feed webmester e-mail",
"Image path" => "Kép útvonal",
"RSS basic Authentication" => "RSS azonosítás",
"Caching time" => "Cache-elés ideje",
"seconds" => "másodperc",
"Use 0 for no caching" => "0 esetén nincs cache",
"Individual Blogs" => "Egyedi blogok",
"Image galleries" => "Képgalériák",
"Individual Image galleries" => "Egyedi képgalériák",
"File galleries" => "Fájlgalériák",
"Individual file galleries" => "Egyedi fájlgalériák",
"Individual Forums" => "Egyedi fórumok",
"Individual trackers items" => "Egyedi űrlap tételek",
"Calendar events" => "Naptári események",
"Directories" => "Könyvtárak",
"Maximum number of items to display" => "Megjelenítendő tételek maximális száma",
"Show Author" => "Szerző megjelenítése",
"Article RSS Description" => "Cikk RSS leírása",
"Blogs RSS Description" => "Blogok RSS leírása",
"Blog RSS Description" => "Blog RSS leírás",
"Image galleries RSS Description" => "Képgalériák RSS leírása",
"Individual image galleries RSS Description" => "Egyedi képgalériák RSS leírása",
"File galleries RSS Description" => "Fájlgalériák RSS leírása",
"Individual file galleries RSS Description" => "Egyedi fájlgalériák RSS leírása",
"Wiki pages RSS Description" => "Wiki oldalak RSS leírása",
"Forums RSS Description" => "Fórumok RSS leírása",
"Individual forums RSS Description" => "Egyedi fórumok RSS leírása",
"Trackers RSS Description" => "Űrlapok RSS leírása",
"Individual trackers RSS Description" => "Egyedi űrlapok RSS leírása",
"Calendar events RSS Description" => "Naptári események RSS leírása",
"Directories RSS Description" => "Linktárak RSS leírása",
"Maps RSS Description" => "Térképek RSS leírása",
"Shoutbox RSS Description" => "Üzenőfal RSS leírása",
"Podcast directory" => "Podcast könyvtár",
"The server must be able to read/write the directory." => "A szervernek tudnia kell olvasni/írni a könyvtárat",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "Ha bekapcsoljuk a Kötegelt könyvtár feltöltést akkor létre kell hoznunk egy weben keresztül olvasható könyvtárat, lehetőleg a webes könyvtárterületen kívűl. Ezután hozzunk létre egy módszert a feltöltés végrehajtására (scp, ftp vagy más protokoll)",
"The server must be able to read the directory." => "A szervernek tudnia kell olvasni könyvtárat",
"The directory can be outside the web space." => "A könyvtár lehet a webes területen kívűl",
"Prevent download if score becomes negative" => "Letöltés tiltása ha a pontszám negatív",
"Allow download limit per file" => "Fájlonkénti letöltési limit engedélyezése",
"Allow same file to be uploaded more than once" => "Egyazon fájl többszöri feltöltésének engedélyezése",
"Yes, even in the same gallery" => "Igen, még ugyanabba a galériába is",
"Only in different galleries" => "Csak más galériákba",
"Must match" => "Egyeznie kell",
"Cannot match" => "Nem egyezhet",
"Storage" => "Tárolás",
"Store in database" => "Tárolás adatbázisban",
"Store in directory" => "Tárolás könyvtárban",
"Uploaded filenames must match regex" => "A feltöltött fájl nevének egyeznie kell a kifejezéssel",
"Allows users to override the defaults" => "Felhasználók felülírhatják az alapértelmezéseket",
"Keep settings for all forums during the user session" => "Beállítások megtartása az összes fórumban a felhasználói munkamenet alatt",
"Default style" => "Alapértelmezett stílus",
"Plain" => "Normál",
"Threaded" => "Témák",
"Headers Only" => "Csak a fejlécek látszanak",
"Default sort mode" => "Alapértelmezett rendezési mód",
"Title (desc)" => "Cím (csökk)",
"Title (asc)" => "Cím (növ)",
"Topics" => "Témák",
"Posts per day" => "Napi posztok száma",
"Description length" => "Leírás hossza",
"Do not prefix messages titles by 'Re: '" => "Az üzenetek ne kapjanak 'Re:' előtagot",
"Creation Date (asc)" => "Létrehozás dátuma (növ.)",
"Topics (desc)" => "Témák (csökk)",
"Threads (desc)" => "Fórumtémák (csökk)",
"Last post (desc)" => "Legutóbbi poszt (csökk)",
"Name (desc)" => "Név (csökk)",
"Name (asc)" => "Név (növ)",
"Multilingual tags" => "Többnyelvű címkék",
"Show tag cloud" => "Címke felhő megjelenítése",
"Maximum number of tags in cloud" => "Címkék maximális száma a felhőben",
"Show freetags in middle column" => "Szabad címkék (freetagek) megjelenítése a középső oszlopban",
"Preload freetag random tag" => "Véletlenszerű freetag előtöltése",
"Number of Tags to show in Tag Suggestions" => "Címke javaslatok között megjelenítendő címkék száma",
"Valid characters pattern" => "Érvényes kartakterek mintája",
"Lowercase tags only" => "Csak kisbetűs címkék",
"Enable freetags 3D browser" => "3D címkeböngésző bekapcsolása",
"Browser width" => "Böngésző szélessége",
"Browser height" => "Böngésző magassága",
"Navigation depth" => "Navigáció mélysége",
"Node size" => "Csopont méret",
"Text size" => "Szöveg méret",
"Camera distance adjusted relative to nearest node" => "Kamera távolság hozzáigazítva a legközelebbi csomóponthoz",
"Camera distance" => "Kamera távolság",
"Field of view" => "Nézet mező",
"Elastic constant" => "Elasztikai konstans",
"Eletrostatic constant" => "Elektrostatikus konstans",
"Browser title" => "Böngésző címsora",
"Home page" => "Kezdőlap",
"Use group homepages" => "Csoportkezdőlapok használata",
"Go to group homepage only if login from default homepage" => "Csak akkor menjen a csoportkezdőlapra ha a bejelentkezés az alapértelmezett kezdőlapról történt",
"Default language" => "Alapértelmezett nyelv",
"Cache external pages" => "Külső oldalak cache-elése",
"Cache external images" => "Külső képek cache-elése",
"Temporary directory" => "Ideiglenes könyvtár",
"Help URL" => "Súgó URL",
"Open external links in new window" => "Külső linkek megnyitása új ablakban",
"License page" => "Licensz lap",
"Submit notice" => "Megjegyzés küldése",
"Full path to gdaltindex" => "Teljes útvonal a gdaltindex-hez",
"Full path to ogr2ogr" => "Teljes útvonal az ogr2ogr-hoz",
"Map Zone" => "Térkép zóna",
"Display modules to all groups always" => "Minden modult mindig mutasson minden csoportnak",
"Hide anonymous-only modules from registered users" => "A csak anonim látogatók számára megjelenítésre kerülő modulok elrejtése a regisztrált felhasználók elől",
"Maximum number of articles on articles home page" => "Cikkek maximális száma a cikkek kezdőlapján",
"Test" => "Teszt",
"Default" => "Alapértelmezés",
"Each group can have its theme" => "Minden csoportnak saját stílusa lehet",
"Site title" => "Weblap címe",
"Subtitle" => "Alcím",
"Maximum number of records in listings" => "A rekordok maximum száma listázásnál",
"Maximum number of versions:" => "Verziók maximális száma:",
"Users can register" => "A felhasználók regisztrálhatnak",
"Passcode" => "Belépési kód",
"Use tracker to collect more user information" => "Űrlap használata további felhasználói információk gyűjtéséhez",
"Remember me" => "Emlékezz rám",
"Duration" => "Időtartam",
"minutes" => "perc",
"hour" => "óra",
"hours" => "óra",
"day" => "nap",
"week" => "hét",
"month" => "hónap",
"year" => "év",
"Use different URL as homepage" => "Más URL használata kezdőlapként",
"Use Tiki feature as homepage" => "Tiki funkció használata kezdőlapként",
"User secret" => "Felhasználói titok",
"Admin secret" => "Adminisztrátori titok",
"KDP UI Configuration ID" => "KDP UI konfiguráció ID",
"KCW UI Configuration ID" => "KCW UI konfiguráció ID",
"Kaltura \"User\"" => "Kaltura \"Felhasználó\"",
"Kaltura Service URL" => "Kaltura szolgáltatás URL",
"File Gallery:" => "Fájlgaléria:",
"Forum:" => "Fórum:",
"Custom home" => "Egyedi kezdőlap",
"User's choice" => "Felhasználó választása",
"Default x for map center" => "Alapértelmezett x koordináta a térkép közepéhez",
"Default zoom level" => "Alapértelmezett zoom szint",
"whole earth" => "teljes Föld",
"country size" => "ország méret",
"city size" => "város méret",
"max zoom" => "maximális zoom",
"Custom CSS" => "CSS testreszabása",
"Highlight group" => "Csoport kiemelése",
"Home Blog (main blog)" => "Kezdőblog (fő blog)",
"Home Forum (main forum)" => "Kezdő fórum (fő fórum)",
"Home Gallery (main gallery)" => "Kezdőgaléria (fő galéria)",
"Allow secure (https) login" => "Biztonságos (https) bejelentkezés engedélyezése",
"Encourage secure (https) login" => "Biztonságos (https) bejelentkezés bátorítása",
"Require secure (https) login" => "Biztonságos (https) bejelentkezés szükséges",
"HTMLDomElements to be fixed" => "Fixálandó HTMLDomElements",
"Fade" => "Előtűnés",
"Effect for tabs" => "Effektus fülekhez",
"Speed" => "Sebesség",
"Fast" => "Gyors",
"Normal" => "Normál",
"Slow" => "Lassú",
"Direction" => "Irány",
"Vertical" => "Vertikális",
"Horizontal" => "Horizontális",
"Left" => "Bal",
"Right" => "Jobb",
"Up" => "Fel",
"Down" => "Le",
"Never delete versions younger than" => "Ennél fiatalabb verziók nem törölhetőek",
"Use database for translation" => "Adatbázis használata fordításhoz",
"Language inclusion threshold" => "Nyelv küszöb",
"Layout per section" => "Szekciónkénti kinézet",
"Maximum average server load threshold in the last minute" => "Maximális átlagos szerver terheltség a legutóbbi percben",
"Log mail in Tiki logs" => "Levelek naplózása a Tiki logban",
"Smarty Template usage indicator" => "Smarty Template használat kijelzése",
"Log SQL" => "SQL naplózása",
"This may impact performance" => "Ez hatással lehet a teljesítményre",
"Long date format" => "Hosszú dátum formátum",
"Long time format" => "Hosszú időformátum",
"Mail end of line" => "Levél sor vég",
"LF (some Unix MTA)" => "LF (Unix MTA féle)",
"full path to mapfiles" => "Teljes útvonal a térképfájlokhoz",
"Wiki Page for Help" => "Súgó wikioldal",
"Wiki Page for Comments" => "Kommentek wikioldala",
"Maximum length" => "Maximum hossz",
"Memcache compression" => "Memcache tömörítés",
"Memcache servers" => "Memcache szerverek",
"Memcache key prefix" => "Memcache kulcs prefix",
"Memcache expiration" => "Memcache lejárat",
"Default path for the icons" => "Ikonok alapértelmezett útvonala",
"Maximum mailbox size (messages, 0=unlimited)" => "Levelezőfiók maximális mérete (üzenetek, 0=nincs határ)",
"Maximum mail archive size (messages, 0=unlimited)" => "Levél arhívum maximális mérete (üzenetek, 0=nincs határ)",
"Maximum sent box size (messages, 0=unlimited)" => "Elküldött levelek mappa maximális mérete (üzenetek, 0=nincs határ)",
"Keywords" => "Kulcsszavak",
"Include freetags" => "Freetag-ek belefoglalása",
"Use thread title instead" => "Thread használata inkább",
"Use image title instead" => "Kép címének használat inkább",
"Use individual page description for Wiki pages instead" => "Wiki oldalakhoz inkább az egyes oldalak leírását használja",
"Meta robots" => "Meta robotok",
"Revisit after" => "Újralátogatás ennyi után",
"Minimum length" => "Minimum hossz",
"Minimum amount of tags in common" => "Közös címkék miniális száma",
"Multi-domain Configuration" => "Multi-domain konfiguráció",
"One domain per line. Comma separated with perspective ID. Ex.: tiki.org,1" => "Egy domain soronként vesszővel elválasztva perspektíva ID-val. Példa: tiki.org,1",
"Use relative (next / previous) pagination links" => "Relatív (következő/előző) oldalléptetési linkek használata",
"Wiki buttons" => "Wiki gombok",
"Top " => "Fent",
"Bottom" => "Lent",
"Neither" => "Egyik sem",
"A page can occur multiple times in a structure" => "Egy oldal többször is előfordulhat egy struktúrában",
"Display fast move links (by 10 percent of the total number of pages) " => "Gyorsugrási linkek megjelnítése (az oldalak teljes számának 10%-ánál) ",
"Hide pagination when there is only one page" => "Oldalléptetés elrejtése ha csak egy oldal van",
"Use Icons" => "Ikonok használata",
"Display 'First' and 'Last' links" => "'Első' és 'Utolsó' linkek megjelenítése",
"PAM service" => "PAM szolgáltatás",
"Currently unused" => "Jelenleg nem használt",
"Payment" => "Fizetés",
"Email address" => "E-mail cím",
"Wiki page" => "Wiki lap",
"Send to URL" => "Küldés erre az URL-re",
"On permission denied, display login module (for Anonymous)" => "Jogosultság hiány esetén a bejelentkezési  modul megjelenítése anonim felhasználóknak",
"Show categories" => "Kategóriák megjelenítése",
"Show objects" => "Objektumok megjelenítése",
"Webkit path" => "Webkit útvonal",
"Host name" => "Hoszt neve",
"Proxy port" => "Proxy Port",
"Quantify change size" => "Méret változásának számszerűsítése",
"Advanced Rating" => "Értékelés",
"Record untranslated strings" => "Nem lefordítottak rögzítése",
"Restrict supported languages" => "Támogatott nyelvek korlátozása",
"Refresh mode" => "Frissítés módja",
"Refresh rate" => "Frissítési idő",
"Minimum length of search word" => "Keresett szó minimális hossza",
"Max. number of words containing a syllable" => "Egy szótagot tartalmazó szavak maximális száma",
"Max. age in hours of syllable search cache" => "Szótagkeresés cache maximális kora órákban",
"LRU list purging rate" => "LRU lista tisztításának gyakorisága",
"LRU list length" => "LRU lista hossza",
"Parse the results" => "Eredmények elemzése",
"Wiki Pages" => "Wiki oldalak",
"Restrict search language by default" => "Keresési nyelv korlátozása alapértelmezésben",
"Sender email" => "Levélküldési E-mail cím",
"Timezone" => "Időzóna",
"Session storage location" => "Munkamenet tárolásának helye",
"Default (from php.ini)" => "Alapértelmezés (php.ini-ből)",
"Database" => "Adatbázis",
"Session lifetime" => "Munkamenet ideje",
"Value provided in minutes" => "Érték (perc)",
"Silent session" => "Csendes munkamenet",
"Session cookie name" => "Munkamenet cookie név",
"Default group" => "Alapértelmezett csoport",
"Short date format" => "Rövid dátum formátum",
"Short time format" => "Rövid időformátum",
"Display available translations" => "Rendelkezésre álló fordítások megjelenítése",
"Message to display" => "Megjelenítendő üzenet",
"Choices" => "Választási lehetőségek",
"Site title location" => "Weblap nevének elhelyezkedése",
"After" => "Után",
"Browser title display mode" => "Böngésző címsor megjelenítési módja",
"Most specific first" => "Először a legspecifikusabb",
"Least specific first (site)" => "Legkevésbé specifikus először (oldal)",
"image/png" => "kép/png",
"image/bmp" => "kép/bmp",
"image/x-icon" => "kép/x-icon",
"Publish" => "Publikálás",
"Examples:" => "Példák:",
"Center" => "Középre",
"Logo title (on mouse over)" => "Logó neve (egér rámozgatására jelenik meg)",
"Alt. description (e.g. for text browsers)" => "Képleírás (pld szöveges böngészés számára)",
"Smarty Security" => "Smarty biztonság",
"Smarty Compilation" => "Smarty forgatás",
"Modified" => "Módosítva",
"Never check (performance)" => "Sose ellenőrizze (teljesítmény)",
"Always (development, slow)" => "Mindig (fejlesztés, lassú)",
"Theme options" => "Stílus opciók",
"Check frequency" => "Ellenőrzés gyakorisága",
"Each day" => "Minden nap",
"Each week" => "Minden héten",
"Each month" => "Minden hónapban",
"Skip date for same day" => "Dátum kihagyása ugyanazon nap esetén",
"Cache-Control header" => "Cache-Control fejléc",
"Remove the www" => "www eltávolítása",
"Add the www" => "www hozzáadása",
"Domain redirects" => "Domain átirányítások",
"Account validated successfully." => "A felhasználói fiók sikeresen validálásra került.",
"Close site when server load is above the threshold  (except for those with permission)" => "Weblap lezárása ha a szerver leterheltsége a küszöb felett van (a megfelelő jogosultsággal rendelkezők továbbra is beléphetnek)",
"Use proxy" => "Proxy használata",
"Display UserTracker information on the user information page" => "Felhasználói űrlap információinak megjelenítése a felhasználó információs oldalán",
"Use the format: trackerId, fieldId1, fieldId2, ..." => "Használandó formátum: trackerId, fieldId1, fieldId2, ...",
"Users can configure modules" => "Felhasználók konfigurálhatják a modulokat",
"Users can shade modules" => "Felhasználók elrejthetik a modulokat",
"Module decides" => "Modultól függ",
"Store full-size copy of avatar in file gallery" => "Teljes méretű avatár tárolása fájlgalériában",
"File gallery to store full-size copy of avatar in" => "Teljes méretű avatar tárolása ebben a fájlgalériában",
"Display who viewed my stuff on the user information page" => "Annak megjelenítése hogy ki nézte meg a dolgaimat a felhasználó információs oldalán",
"Number of days to consider who viewed my stuff" => "A megtekintéseknél figyelembe veendő napok száma",
"Show to others who viewed my stuff on the user information page" => "Mások láthatják hogy ki nézte meg a dolgaimat a felhasználói információs oldalon",
"Sort Order" => "Rendezési sorrend",
"Score ascending" => "Pontszám alapján emelkedő",
"Score descending" => "Pontszám alapján csökkenő",
"Name ascending" => "Név alapján emelkedő",
"Name descending" => "Név alapján csökkenő",
"Login ascending" => "Bejelentkezési név alapján emelkedő",
"Login descending" => "Bejelentkezési név alapján  csökkenő",
"Displayed time zone" => "Használt időzóna",
"Use site default to show times" => "Weblap alapértelmezésének használata idők megjelenítésére",
"Detect user timezone (if browser allows). Otherwise use site default." => "Felhasználó időzónájának felismerése (ha a böngésző megengedi). Ellenkező esetben weblap alapértelmezésének használata..",
"Number of visited pages to remember" => "A nyilvántartott látogatott lapok száma",
"User information" => "Felhasználói információ",
"Private" => "privát",
"Public" => "Publikus",
"Use double-click to edit pages" => "Oldal szerkesztése duplakattintással",
"Tasks per page" => "Laponkénti feladatok",
"Messages per page" => "Üzenetek száma oldalanként",
"Allow messages from other users" => "Más felhasználók üzenhetnek nekem",
"Notify sender when reading mail" => "Küldő értesítése a levél elolvasásáról",
"Send me an email for messages with priority equal or greater than" => "E-mail küldése azokról az üzenetekről melyek prioritása legalább:",
"Auto-archive read messages after" => "Olvasott üzenetek automatikus archiválása",
"My pages" => "Lapjaim",
"My blogs" => "Blogjaim",
"My galleries" => "Galériáim",
"My messages" => "Üzeneteim",
"My tasks" => "Feladataim",
"My forum topics" => "Fórum témáim",
"My forum replies" => "Fórum válaszaim",
"My items" => "Tételeim",
"Character set for mail" => "Levelezés karakter készlete",
"Show user's info on mouseover" => "Felhasználói információk mutatása egér felhasználói név felé mozgatásakor",
"Display by default" => "Alapértelmezésben megjelenítve",
"Path (if stored in directory)" => "Útvonal (ha merevlemezen kerül tárolásra)",
"Edit idle timeout" => "Nem tevékeny szerkesztés időkorlátja",
"Log errors to Tiki log" => "Hibák loggolása Tiki log-ba",
"Field ID of BrandId" => "Brand ID-hoz tartozó Field ID",
"Field ID of videoId" => "Video ID-hoz tartotó Field ID",
"Allow viewing HTML mails?" => "HTML levelek megtekintésének engedélyezése?",
"Maximum size for each attachment" => "Csatolt állomány maximum mérete",
"Unlimited" => "Nincs korlát",
"LastModif" => "Utolsó módosítás",
"Last editor" => "Legutóbbi szerkesztő",
"Wiki link format" => "Wiki link formátum",
"Strict will only be basic characters like a-z and 0-9. If you have accented or special characters in page names, you should not use strict." => "Szigorú esetén csak a-z és 0-9 karakterek engedélyezettek, amennyiben ékezetes vagy speciális karakterekre is szükség van az oldalak nevében, akkor ne használjuk.",
"Complete" => "Teljes",
"Relaxed" => "Laza",
"Strict" => "Szigorú",
"Display page name above page" => "Oldal nevének megjelenítése az oldal felett",
"Page name display stripper" => "Oldalnév stripper",
"Creator & Author" => "Létrehozó & Szerző",
"Business style" => "Üzleti stílus",
"Collaborative style" => "Kollaboratív stílus",
"Page last modified on" => "Oldal legutóbbi módosítása:",
"none (disabled)" => "nincs (kikapcsolva)",
"Both" => "Mindkettő",
"When using the ...page... page break wiki syntax" => "A '...page...' oldaltörési wiki szintakszis használata esetén",
"Wiki top line location" => "Wiki felső sor helye",
"Cache wiki pages (global)" => "Wiki oldalak cache-elése (globális)",
"no cache" => "nincs cache",
"minute" => "perc",
"Allow comments per wiki page" => "Kommentek engedélyezése wiki oldalanként",
"Disable" => "Kikapcsolás",
"Enable (default On)" => "Bekapcsolás (alapértelmezésben bekapcsolva)",
"Enable (default Off)" => "Bekapcsolás (alapértelemésben kikapcsolva)",
"Dynamic variables" => "Dinamikus változók",
"Single (%varname%)" => "Egyedi (%varname%)",
"Double (%%varname%%)" => "Dupla (%%varname%%)",
"Multilingual dynamic variables" => "Többnyelvű dinamikus változók",
"Edit section" => "Szekció szerkesztése",
"Edit section level" => "Szekció szint szerkesztése",
"Toggle display of section and plugin edit icons" => "Szekció és plugin szerkesztési ikonok megjelenítése",
"Allow minor edits" => "Kisebb szerkesztések engedélyezése",
"Slideshows" => "Bemutatók",
"Page creators are admin of their pages" => "A lap készítője saját lapjának adminisztrátora",
"Create watch for author on page creation" => "Figyelés bekapcsolása az oldal létrehozójának az oldal létrehozásakor",
"Enable watches on comments" => "Kommentek figyelése",
"Enable watch events when I am the editor" => "Figyelés bekapcsolása a szerkesztőnek",
"Watch minor edits" => "Kisebb szerkesztések figyelése",
"Page ID" => "Oldal ID (azonosító)",
"Name length" => "Név hossza",
"Last modification date" => "Utolsó módosítás dátuma",
"Last modified by" => "Utoljára módosította",
"Version" => "Verzió",
"Edit comments" => "Kommentek szerkesztése",
"Edit Comment length" => "Szerkesztési megjegyzés hossza",
"Status" => "Státusz",
"Versions" => "Verziók",
"Links" => "Linkek",
"Categories" => "Kategóriák",
"Categories path" => "Kategória útvonala",
"Default sort order" => "Alapértelmezett rendezési sorrend",
"Sort Direction" => "Rendezés iránya",
"Descending" => "Csökkenő",
"Ascending" => "Növekvő",
"Forum for discussion" => "Kapcsolódó fórum",
"Similar pages only listed in same language" => "Hasonló oldalak listázása csak ugyanazon a nyelven",
"Mandatory edit summary on wiki pages" => "Kötelező összefoglalót írni a változásokról",
"Structure navigation bar location" => "Struktúra navigációs sor elhelyezkedése",
"Simple wiki ratings" => "Egyszerű wiki értékelések",
"Wiki rating options" => "Wiki értékelés beállításai",
"Delete staging pages at approval" => "Előkészítési verzió törlése jóváhagyáskor",
"Hide page name prefix" => "Oldal előtag elrejtése",
"Add new freetags of approved copy (into tags field) when editing staging pages" => "Új címkék hozzáadása a jóváhagyott másolatba",
"Staging" => "Előkészítés",
"Approved" => "Jóváhagyva",
"(mandatory for feature to work)" => "(kötelező a funkció működéséhez)",
"Out-of-sync" => "Nincs szinkronban",
"If not in the group, edit is always redirected to the staging page edit" => "Ha nincs ebben a csoportban akkor a változás mindig az előkészítési változatba kerül",
"Plugin %0" => "Snarf plugin",
"Wysiwyg Editor is optional" => "WYSIWYG szerkesztő opcionális",
"Reopen with the same editor" => "Újranyitás ugyanazzal a szerkesztővel",
"Content is parsed like wiki page" => "Tartalom wiki oldalként elemzett",
"SMTP Server" => "SMTP szerver",
"Username" => "Felhasználónév",
"Password" => "Jelszó",
"Security" => "Biztonság",
"Mail Sender" => "Levél küldő",
"Sendmail" => "Levélküldés",
"Page cannot be found" => "Ez az oldal nem található!",
"Wiki top pages" => "Leglátogatottabb wiki oldalak",
"Most relevant pages" => "Legrelevánsabb oldalak",
"Relevance" => "Relevancia",
"Wiki last pages" => "Legutóbbi wiki oldalak",
"Topic date" => "Téma dátuma",
"Forums most read topics" => "A legolvasottabb fórum topic-ok",
"Forums best topics" => "A legjobb topic-ok",
"Forums most visited forums" => "Leglátogatottabb fórumok",
"Forums with most posts" => "A legtöbb üzenettel rendelkező fórumok",
"Wiki top galleries" => "Wiki leglátogatottabb galériái",
"Wiki top file galleries" => "Wiki leglátogatottabb fájlgalériái",
"Wiki top images" => "Wiki legjobb képek",
"Wiki top files" => "Wiki legjobb fájlok",
"Downloads" => "Letöltések",
"Wiki last images" => "Wiki utóbbi képek",
"Upload date" => "Feltöltés dátuma",
"Top articles" => "Legolvasottabb cikkek",
"Most visited blogs" => "Legtöbbet látogatott blogok",
"Post date" => "Beküldés időpontja:",
"Wiki top authors" => "A wiki oldalak kiemelkedő szerzői",
"Pages" => "Oldalak",
"Registered" => "Regisztrált",
"Password is required" => "Szükséges a jelszó megadása",
"The passwords don't match" => "Figyelem, hogy egyezzenenek a megadott jelszavak!",
"User already exists" => "Ez felhasználónév már létezik ebben a rendszerben",
"characters long" => "karakter hosszúnak kell lennie",
"change" => "változtatás",
"Today" => "Ma",
"and" => "és",
"from" => "tól",
"Login" => "Bejelentkezés",
"See other users' profiles" => "Más felhasználó profijának megtekintése",
"Have your profile seen" => "Más felhasználó megtekinti a profilomat",
"Make friends" => "Barátságkötés",
"Receive message" => "Üzenet fogadása",
"Send message" => "Üzenet küldése",
"Read an article" => "Cikk olvasása",
"Publish an article" => "Cikk publikálása",
"Have your article read" => "Más felhasználó olvassa egy cikkemet",
"Create New File Gallery" => "Új fájlgaléria létrehozása",
"Upload new file to gallery" => "Új fájl feltöltése galériába",
"Download other user's file" => "Más felhasználó fájljának letöltése",
"Have your file downloaded" => "Más felhasználó letölti egy fájlomat",
"Create a new image gallery" => "Új képgaléria létrehozása",
"Upload new image to gallery" => "Új kép feltöltése galériába",
"See other users' galleries" => "Más felhasználó galériájának megtekintése",
"See other users' images" => "Más felhasználó képének megtekintése",
"Have your gallery seen by other users" => "Más felhasználó megtekinti egy galériámat",
"Have your image seen" => "Más felhasználó megnézi egy képemet",
"Create new blog" => "Új blog létrehozása",
"Post in a blog" => "Posztolás egy blogba",
"Read other users' blogs" => "Más felhasználó blogjának olvasása",
"Have your blog read" => "Más felhasználó olvassa egy blogomat",
"Create a new wiki page" => "Új wikioldal létrehozása",
"Edit an existing page" => "Létező oldal szerkesztése",
"Attach file" => "Mellékletek",
"Wiki Comment" => "Wiki komment",
"Calendar item" => "Naptár tétel",
"Gallery" => "Galéria",
"Image" => "Kép",
"Article" => "Cikk",
"Blog post" => "Blog poszt",
"Tracker item" => "Űrlap tétel",
"Tracker" => "Űrlap",
"Unknown" => "Ismeretlen",
"Trackeritem" => "Űrlap tétel",
"new" => "új",
"sheet" => "ív",
"Click for Help" => "Súgó",
"Prev" => "Előző",
"Next" => "Következő",
"tip" => "tipp",
"comment" => "komment",
"note" => "megjegyzés",
"errors" => "hiba",
"information" => "információ",
"Tab View" => "Füles nézet",
"No Tabs" => "Fülek nélkül",
"Tip" => "Tipp",
"This edit session will expire in" => "A szerkesztési munkamenet ennyi idő múlva jár le:",
"click here" => "klikk ide",
"Edit Template" => "Sablon szerkesztése",
"Admin Feature" => "Funkció adminisztrálása",
"Hide" => "Elrejtés",
"help" => "súgó",
"Interactive Translation" => "Interaktív fordítás",
"Once checked, click on any string to translate it." => "Bejelölés után kattintani kell a kiszemelt szövegdarabra",
"Save translations" => "Fordítás mentése",
"Changes will be applied on next page load only." => "A változások csak az oldal újboli betöltése után lesznek láthatóak.",
"Cancel" => "Visszavonás",
"Date Selector" => "Dátum kiválasztó",
"Filter:" => "Szűrő:",
"Preference %0 is not defined." => "Preferencia nincs beállítva: feed_forums_homepage",
"Select All" => "Összes kijelölése",
"Toggle sections" => "Szekciók megjelenítése",
"Show only selected" => "Kijelöltek mutatása",
"second" => "másodperc",
"months" => "hónap",
"weeks" => "hét",
"done" => "kész",
"Task" => "Feladat",
"Priority" => "Prioritás",
"Friend" => "Barát",
"Gender:" => "Nem:",
"Last seen on" => "Legutóbbi bejelentkezés",
"User information - Click for more info" => "Felhasználói adatok - Kattintás további információkért",
"Yes" => "Igen",
"No" => "Nem",
"pvs" => "oldalmegtekintés",
"Table of contents" => "Tartalomjegyzék",
"text" => "szöveg",
"unknown error" => "ismeretlen hiba",
"You are not logged in" => "Először <a href=\"tiki-login_scr.php\">be kell jelentkezni</a> ehhez!",
"You do not have permission to view this section" => "Magasabb szintű jogosultágra van szükség a szekció megtekintéséhez",
"Help link" => "Súgó",
"You are banned from" => "Kitiltottak innen:",
"faqs" => "gyakran intézett kérdések",
"quizzes" => "kvízek",
"blogs" => "blogok",
"forums" => "fórumok",
"Edit Plugin" => "Plugin szerkesztése",
"Update variables" => "Változók frissítése",
"Edit Section" => "Szekció szerkesztése",
"Show" => "Megjelenítés",
"sad" => "szomorú",
"cool" => "király",
"mad" => "mérges",
"Removed" => "Eltávolítva",
"at" => "ekkor",
"Unknown language" => "Ismeretlen nyelv",
"Click here to confirm your action" => "Akció megerősítése",
"Bold" => "Félkövér",
"Italic" => "Dőlt",
"Underline" => "Aláhúzás",
"Strikethrough" => "Áthúzás",
"Non-parsed (Wiki syntax does not apply)" => "Nem elemzett (a Wiki szintakszis nem érvenyesül)",
"Align Center" => "Középre igazít",
"Horizontal Bar" => "Horizontális eszköztár",
"Page Break" => "Oldaltörés",
"Box" => "Doboz",
"Email" => "E-mail",
"Heading" => "Fejléc",
"Title bar" => "Címléc",
"Unordered List" => "Rendezetlen lista",
"Ordered List" => "Rendezett lista",
"Special Characters" => "Speciális karakterek",
"Foreground color" => "Előtér szín",
"Background Color" => "Háttérszín",
"Wiki Link" => "Wiki link",
"External Link" => "Külső link",
"Table Builder" => "Táblázat",
"Find Text" => "Szöveg keresés",
"Text Replace" => "Szöveg kicserélés",
"Full Screen Edit" => "Teljes képernyő",
"Wiki Help" => "Wiki súgó",
"Wysiwyg Help" => "Wysiwyg súgó",
"Choose or upload images" => "Kép kiválasztása vagy feltöltése",
"Switch Editor (wiki or WYSIWYG)" => "Szerkesztő váltása (wiki vagy WYSIWYG)",
"Get Cell Range" => "Mező határ",
"Find" => "Keresés",
"Refresh Calculations" => "Számítások frissítése",
"Admin Toolbars" => "Eszköztárak szerkesztése",
"Item Modification" => "Tétel módosítása",
"Item" => "Tétel",
"Item creation" => "Tétel létrehozása",
"Subject" => "Tárgy",
"Field is not numeric" => "A mező nem numerikus",
"text field" => "szöveges mező",
"half column" => "fél oszlop",
"size" => "méret",
"prepend" => "előtte",
"append" => "utána",
"textarea" => "szöveges terület",
"checkbox" => "jelölőnégyzet",
"numeric field" => "numerikus mező",
"drop down" => "legördülő",
"drop down with other textfield" => "legördülő egyéb szöveges mezővel",
"radio buttons" => "választó kapcsoló",
"user selector" => "felhasználó kiválasztása",
"group selector" => "csoport kiválasztása",
"IP selector" => "IP kiválasztása",
"country selector" => "ország kiválasztása",
"date and time" => "dátum és idő",
"action" => "akció",
"header" => "fejléc",
"static text" => "statikus szöveg",
"category" => "kategória",
"item link" => "tétel link",
"items list" => "tételek listája",
"dynamic items list" => "dinamikus tétellista",
"email" => "E-mail",
"auto-increment" => "automatikus számozás",
"user subscription" => "felhasználói előfizetés",
"system" => "rendszer",
"computed field" => "számított mező",
"user preference" => "felhasználói preferencia",
"attachment" => "melléklet",
"stars" => "csillagok",
"open" => "nyitva",
"pending" => "függőben",
"closed" => "lezárva",
"Message" => "Üzenet",
"child categories" => "gyermek kategóriák",
"objects in category" => "elemek ebben a kategóriában",
"Password should be at least" => "A jelszónak legalább",
"Password must contain both letters and numbers" => "A jelszónak betűket és számjegyeket is tartalmaznia kell!",
"here" => "itt",
"You need to set your Kaltura account details: " => "Be kell állítani a Kaltura fiókot, lásd: ",
"Personal Phone" => "Személyes telefon",
"Personal Mobile" => "Személyes mobil",
"Personal Fax" => "Személyes fax",
"Work Phone" => "Munkahelyi telefon",
"Work Mobile" => "Munkahelyi mobil",
"Work Fax" => "Munkahelyi fax",
"Company" => "Vállalat",
"Organization" => "Szervezet",
"Department" => "Részleg",
"Division" => "Divízió",
"Job Title" => "Munkakör",
"Street Address" => "Utca cím",
"City" => "Város",
"State" => "Régió",
"Zip Code" => "irányítószám",
"Add to cart" => "Kosárba tesz",
"Location" => "Lokáció",
"Button label" => "Gomb felirat",
"Add Event to Google Calendar" => "Esemény hozzáadása Google naptárhoz",
"Displays various information about the client." => "Klienshez kapcsolódó információkat jelenít meg",
"Displays browser client info" => "Megjeleníti a böngésző kliens információit",
"Anchor Link" => "Horgony link",
"Anchor Name" => "Horgony név",
"Page Name" => "Oldal neve",
"Creates a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which specifies the location and name of the anchor" => "Linket helyez el egy wiki oldal egy horgonyához. Együtt kell használni a horgony helyét és nevét megadó ANAME pluginnal",
"Creates an anchor in a wiki page. Use in conjunction with the ALINK plugin, which specifies a link to the anchor" => "Horgonyt helyez el egy wiki oldalon. Együtt kell használni a horgonyra mutató linket létrehozó ALINK pluginnal",
"Image Annotation" => "Kép annotáció",
"Width" => "Szélesség",
"Height" => "Magasság",
"Alignment" => "Igazítás",
"Save changes to annotations" => "Menti az annotációk válozásait",
"Archive Builder" => "Arhív készítő",
"Field" => "Mező",
"Article ID" => "Cikk ID",
"Includes an article" => "Cikket illeszt be",
"Id is optional. If not given, last article is used. Default field is heading." => "Id megadása opcionális. Ha nincs megadva akkor a legutolsó cikk kerül megjelenítésre. Az alapértelmezett mező a fejléc.",
"Article List" => "Cikk lista",
"Inserts a list of articles in the page." => "Cikkek listáját jeleníti meg az oldalon",
"Category ID" => "Kategória ID",
"Sort order" => "Rendezés módja",
"Quiet" => "Csendes",
"Start Date" => "Kezdés dátuma",
"End date" => "Befejezés dátuma",
"Includes articles listing into a wiki page" => "Cikkek listáját jeleníti meg egy wiki oldalon",
"Attachment" => "Melléklet",
"Displays an attachment or a list of them" => "Megjelenít egy mellékletet vagy a mellékletek listáját",
"File" => "Fájl",
"Same as name" => "Ugyanaz mint a név",
"Page" => "Oldal",
"Show Description" => "Leírás megjelenítése",
"No such attachment on this page" => "Nincs ilyen melléklet ezen az oldalon",
"Gives the name of the attached file to link to" => "Megadja link céljául szolgáló melléklet nevét",
"Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages" => "Megadja a másik oldal nevét ",
"Shows the description as the link text instead of the file name" => "Nem a fájlnevet hanem a leírást jeleníti meg a link szövegeként",
"Makes the list of attachments a bulleted list" => "Listázza a mellékleteket",
"Says that this file is an image, and should be displayed inline using the img tag" => "Jelzi hogy a fájl egy kép és sorban kell megjeleníteni az img tag használatával",
"Makes the text between the {ATTACH} tags the link text instead of the file name or description" => "Beteszi az adott dolgot az {ATTACH} tag-ek közé link szövegeként a fájlnév vagy a leírás helyett",
"Shows all attachments from the whole wiki" => "Megmutatja a teljes wiki összes mellékletét",
"Gives the number, in the list of attachments, of the attachment to link to" => "Megadja a mellékletek listájában a melléklet számát melyre a link mutat",
"Gives the actual id of the attachment to link in. You probably should never use this" => "Megadja a melléklet tényleges Id-ját melyre a link mutat. Ezt valószínűleg sosenem fogja bárki is használni :)",
"Puts the number of downloads in the alt comment" => "Megjeleníti a letöltések számát",
"Shows a file icon" => "Fájl ikonját jeleníti meg",
"Attributes" => "Attribútumok",
"Avatar" => "Avatár",
"Displays the user Avatar" => "Megjeleníti a felhasználó avatárját",
"username" => "felhasználónév",
"Float" => "Lebegés",
"Back" => "Vissza",
"List all pages that link to specific pages" => "Listázza az adott oldara mutató összes oldalt",
"One page links to" => "Egy oldal mutat ide",
"pages link to" => "idemutató oldal",
"Insert a banner" => "Banner beillesztése",
"Zone" => "Zóna",
"Target" => "Cél",
"Display" => "Leírás",
"missing parameter" => "hiányzó paraméter",
"Allows to join a BigBlueButton meeting." => "Lehetővé tesz a csatalakozást egy BigBlueButton meetinghez",
"Display a Blip.tv video" => "Blip.tv videó megjelenítése",
"Blog List" => "Blog lista",
"End Date" => "Befejezés dátuma",
"Insert theme-styled box on wiki page" => "Stílus szerint mintázott dobozt jelenít meg a wikioldalon",
"Box title" => "Doboz címe",
"Displayed above the content" => "A tartalom felett kerül megjelenítésre",
"Background color" => "Háttérszín",
"Box width" => "Doboz szélesség",
"Text Alignment" => "Szöveg igazítása",
"Float Position" => "Lebegő pozíció",
"Clear" => "Kiürítés",
"CSS Class" => "CSS osztály",
"Button" => "Gomb",
"Label" => "Címke",
"Incorrect param" => "Hibás paraméter",
"Includes a calendar and/or a list of calendar events." => "Naptárat vagy naptári események listáját tartalmazza",
"List" => "Lista",
"Table" => "Tábla",
"Insert list of items with the current/given category in the wiki page" => "Beilleszti az adott kategória tételeit a wikioldalba",
"Category IDs" => "Kategória azonosítók (ID-k)",
"Types" => "Típusok",
"Split" => "Felosztás",
"And" => "És",
"Show Title" => "Cím megjelenítése",
"Categories are disabled" => "Kategória funkció nincs aktiválva",
"Category Orphans" => "Kategória nélküliek",
"Object" => "Objektum",
"Display Tiki objects that have not been categorized" => "Megjeleníti a nem kategorizált tiki objektumokat",
"Insert the full category path for each category that this wiki page belongs to" => "Beilleszti a kategória teljes útvonalát minden egyes kategóriához melybe az oldal beletartozik",
"Separator" => "Szeparátor",
"Mode" => "Mód",
"Centers the plugin content in the wiki page" => "A plugin a tartalmat a wiki oldal közepére teszi",
"Chart" => "Grafikon",
"Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool." => "Megjelenít egy Tikiíven alapuló ábrát. A plugint a Tikiív ábrageneráló eszköze generálja.",
"Sheet ID" => "Ív ID",
"Data sheet ID" => "Adatív ID",
"Chart Type" => "Ábta típus",
"Chart Width" => "Ábra szélesség",
"Chart Height" => "Ábra magasság",
"Value series" => "Érték sorozat",
"Required for pie charts" => "Torta ábrához szükséges",
"Independant series" => "Független sorozat",
"Required for types other than pie chart" => "Nem torta ábrákhoz szükséges",
"Dependant series" => "Függő sorozatok",
"Styles" => "Stílusok",
"Labels" => "Feliratok",
"title" => "cím",
"Chart as PDF" => "Grafikon PDF-ként",
"Chart as PostScript" => "Grafikon PostScript-ként",
"Code" => "Kód",
"Displays a snippet of code" => "Megjelenít egy kódrészletet",
"Caption" => "Képfelirat",
"Word Wrap" => "Szövegtörés",
"Colors" => "Színek",
"Wiki Syntax" => "Wiki szintakszis",
"Content is HTML" => "A tartalom HTML",
"code" => "kód",
"note: colors and ln are exclusive" => "figyelem: a színek és az ln exkluzívak (kizárják egymást)",
"Sort Mode" => "Rendezés módja",
"Dynamic Content" => "Dinamikus tartalom",
"Includes content from the dynamic content system." => "Dinamikus tartalomkezelő tartalmát jeleníti.",
"Content ID" => "Tartalom ID",
"Cookie" => "Süti",
"Insert copyright notices" => "Szerzői jogi információt szúr be",
"Countdown" => "Visszaszámlálás",
"Displays a countdown from now until the specified date." => "Jelen pillanattól egy adott dátumig tartó visszaszámlálást jelenít meg.",
"Locate Time" => "Helyi idő",
"Days" => "Nap",
"Hours" => "Órák",
"Minutes" => "Percek",
"Example" => "Például",
"Data Channel" => "Adatcsatorna",
"Class" => "Osztály",
"Clear all Tiki caches" => "Összes Tiki cache kiürítése",
"All user prefs sessions" => "Összes felhasználói preferencia munkamenet",
"Debug" => "Hibakeresés",
"report definition" => "riport definíció",
"Full DSN" => "Teljes DSN",
"A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "Teljes DSN (Data Source Name) kapcsolódási sztring. Pld: mysql://user:pass@server/database",
"Missing db or dsn parameter" => "Hiányzó db vagy dsn paraméter",
"Run a database report" => "Adatbázis riportot futtat",
"Insert a division block, span, blockquote or other text formatting on wiki page." => "Div blokkot, span-t, blockquote-ot vagy hasonló szövegformázást hoz létre a wiki oldalon",
"Definition List" => "Definíciós lista",
"Creates a definition list" => "Definíciós listát készít",
"term" => "fogalom",
"definition" => "definíció",
"one definition per line" => "soronként egy definíció",
"Equation" => "Egyenlet",
"Renders an equation written in LaTeX syntax as an image." => "LaTeX szintakszisban írt egyenletet renderel képpé.",
"equation" => "egyenlet",
"Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size" => "LaTeX szintakszisban írt egyenletet renderel png kiterjesztésű képpé. Opcionális paraméterek a size (méret) mely alapértelmezett értéke 100 és a normál méret százaléka,  például size=200 jelzi hogy az egyenlet a normál méret kétszerese",
"Events" => "Események",
"~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} RSS feed-et illeszt be egy wiki oldalba",
"Upcoming events" => "Jövőbeli események",
"Displays a label. On click, the block of content will fade in and fade out." => "Megjelenít egy feliratot. A feliratra történő kattintásra megjelenik a felirathoz tartozó tartalom. Újabb kattintásra eltűnik a tartalom és ismét csak a felirat látszik.",
"Label to display on first display" => "Első megjelenéskor mutatandó felirat",
"Unspecified label" => "Nincs felirat megadva",
"Fancy List" => "Puccos lista",
"Creates a fancy-looking list" => "Puccos kinézetű listát hoz létre",
"CSS class for the fancylist" => "CSS osztály a puccos listához",
"num" => "szám",
"item text" => "tétel szöveg",
"one item per line" => "egy tétel soronként",
"Fancy Table" => "Puccos tábla",
"Displays the data using the Tikiwiki odd/even table style" => "Az adatot a TikiWiki páros/páratlan táblastílusban jeleníti meg",
"Heading CSS Class" => "Fejléc CSS osztály",
"cells" => "cellák",
"File ID" => "Fájl ID",
"Date" => "Dátum",
"Show Creation Date" => "Létrehozás dátumának megjelenítése",
"Show Creator" => "Létrehozó megjelenítése",
"Flash video" => "Flash videó",
"Displays a Flash (.swf) file in the wiki page" => "SWF-et jelenít meg a wiki oldalon",
"Movie URL" => "Film URL",
"Quality" => "Minőség",
"Flash video quality. Default value: high" => "Flash video minőség. Alapértelmezett érték: 'high'",
"High" => "Magas",
"Medium" => "Közepes",
"Low" => "Alacsony",
"Missing parameter movie to the plugin flash" => "Hiányzó film paraméter a flash pluginhez",
"Footnote" => "Lábjegyzet",
"The footnote" => "A lábjegyzet",
"Footnotearea" => "Lábjegyzet terület",
"Freetagged" => "Felcímkézett",
"Blog Posts" => "Blogposztok",
"all" => "összes",
"Search the titles of all pages in this wiki" => "Összes oldalcím keresése a teljes wikiben",
"Download box for a file on ftp server." => "Letöltési doboz FTP szerveren található fájlhoz",
"file name" => "fájl név",
"missing parameters" => "hiányzó paraméterek",
"Connection failed" => "Sikertelen kapcsolat",
"failed" => "sikertelen",
"description" => "leírás",
"Value" => "Érték",
"Maximum Value" => "Maximális érték",
"Maximum possible value. Default: 100" => "Maximális lehetséges érték. Alapértelmezés: 100",
"Color" => "Szín",
"Label Width" => "Címke szélesség",
"Display Percentage" => "Százalék megjelenítése",
"Display Value" => "Érték megjelenítése",
"Displays a graphical GAUGE" => "Grafikus mérőt mutat",
"Google Analytics" => "Google analitika",
"Add the tracking code for Google Analytics." => "Google Analytics nyomonkövetési kódjának hozzáadása.",
"Missing parameter" => "Hiányzó paraméter",
"Displays a Google document" => "Google dokumentumot jelenít meg",
"Type of Google document" => "Google dokumentum típus",
"Spreadsheet" => "Táblázat",
"key" => "kulcs",
"Google doc key - for example: pXsHENf1bGGY92X1iEeJJI" => "Google dokumentum kulcs - például pXsHENf1bGGY92X1iEeJJI",
"Margin Height" => "Margó magasság",
"Margin Width" => "Margó szélesség",
"Scrolling" => "Görgetés",
"Displays a Google map" => "Google térképet jelenít meg",
"Item ID" => "Tétel ID",
"Google Maps API key not set" => "Google Maps API kulcs nincs beállítva",
"Group" => "Csoport",
"Display wiki text if user is in one of listed groups" => "Megjeleníti a wiki szöveget ha a felhasználó a listázott csoportok egyikének tagja",
"Allowed Groups" => "Engedélyzett csoportok",
"Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "A blokkot megtekinthető csoportok listája függőleges vonallal elválasztva. Pld: Admins|Developers",
"Denied Groups" => "Tiltott csoportok",
"Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "A blokk megtekintésétől tiltott csoportok listája függőleges vonallal elválasztva. Pld: Anonymous|Managers",
"Group List" => "Csoport lista",
"Group Name" => "Csoport neve",
"Group Stats" => "Csoport statisztika",
"Groups" => "Csoportok",
"Show Percentage" => "Százalék megjelenítése",
"Show Bar" => "Sáv megjelenítése",
"Include literal HTML in a Wiki page" => "Szó szerinti HTML Wiki oldalban",
"HTML code" => "HTML kód",
"Wiki syntax" => "Wiki szintakszis",
"Displays an iframe" => "iframe-et jelenít meg",
"Pixels or %" => "Pixel vagy %",
"Display images" => "Képek megjelenítése",
"Image ID" => "Kép ID",
"Gallery ID" => "Galéria ID",
"Thumbnail" => "Előnézet",
"Mouseover" => "Egérmozgatás felirata",
"Browse" => "Tallózás",
"Download" => "Letöltés",
"Image height" => "Kép magasság",
"Image width" => "Kép szélesség",
"Link title" => "Link címe",
"Include" => "Tartalmazza",
"Start" => "Kezdés",
"Include a page" => "Oldal magába folgalása",
"Invite" => "Meghívás",
"Invite an email in groups." => "Csoportokban lévő E-mail meghívása",
"Confirmation message after posting form" => "Űrlap elküldése után megjelenő üzenet",
"Default Group" => "Alapértelmezett csoport",
"Following mandatory fields are missing" => "A következő kötelező mezők hiányoznak",
"Runs a Java applet to access a local Jabber service" => "Java appletet futtat a lokális Jabber szolgáltatás eléréséhez",
"Applet height in pixels" => "Applet magassága pixelben",
"Default Color" => "Alapértelmezett szín",
"jquery code e.g. \$(\"img\\" => "jquery kód, pld: \$(\"img\\",
"javascript code" => "javascript kód",
"Javascript filename" => "Javascript fájlnév",
"Kaltura video" => "Kaltura videó",
"Displays a KALTURA video on the wiki page" => "KALTURA videót jelenít meg wiki oldalon",
"Not Language" => "Nyelv kizárása",
"Displays the text only if the language matchs" => "Csak akkor jeleníti meg a szöveget ha a nyelv megegyezik",
"Last Modification" => "Utolsó módosítás",
"The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given" => "A last_mod_plugin kicseréli saját magát a megnevezett wiki oldal legutolsó módosítási dátumával - vagy a jelenlegi oldaléval ha nem lett oldal megadva",
"List Pages" => "Oldal lista",
"List wiki pages." => "Wiki oldalakat listáz",
"Show Name Only" => "Csak név megjelenítése",
"Show Page Alias" => "Oldal álnév megjelenítése",
"Orphan Language" => "Árva nyelv",
"Exact Match" => "Pontos egyezés",
"Only Orphan Pages" => "Csak árva oldalak",
"Sort" => "Rendezés",
"or" => "vagy",
"List Directory" => "Könyvtár listázása",
"Lists files in a directory" => "Könyvtárban lévő fájlok listája",
"URL Prefix" => "URL előtag",
"File Name" => "Fájl név",
"Filter" => "Szűrő",
"Mail" => "Levelezés",
"Map" => "Térkép",
"Displays a map" => "Megjelenít egy térképet",
"Map File" => "Térkép fájl",
"Feature disabled" => "A szolgáltatás ki van kapcsolva",
"Mayan Calendars Info" => "Maya naptár info",
"Template" => "Sablon",
"Style" => "Stílus",
"Member List" => "Tagok listája",
"Member Payment" => "Tag fizetés",
"Mini Quiz" => "Minikvíz",
"Displays a miniquiz" => "Minikvízt jelenít meg",
"Tracker ID" => "Űrlap ID",
"Insert Module" => "Modul beszúrása",
"Displays a module inline in a wiki page. More parameters can be added, not supported by User Interface." => "Modult jelenít meg a wiki oldalon. További paraméterek hozzáadása lehetséges, de jelenleg nem támogatott a felhasználói felületről.",
"Module Name" => "Modul neve",
"Decoration" => "Dekoráció",
"Parse" => "Wiki elemzés",
"Please choose a module" => "Kérem válasszon egy modult",
"to be used as argument" => "amit használni fog paraméterként",
"Displays a module inline in a wiki page" => "A modult a lapon belül jeleníti meg",
"Sorry, no such module" => "Sajnálom, nincs ilyen modul",
"Displays the data using a monospace font" => "Az adatot monospace betűtípus használatával jeleníti meg",
"Font" => "Betűtípus",
"Create a mouseover feature on some text" => "Egér szöveg felé mozgatásakor megjelenő szöveget hoz létre",
"Mouseover text if param label exists. Page text if text param exists" => "Egérmozgatási felirat ha a felirat paraméter létezik. Oldal szövege ha a szöveg paraméter létezik",
"Text displayed on the page. The body is the mouseover content" => "Oldalon megjelenített szöveg. A törzs lesz az egérmozgatáskor megjelenő tartalom",
"Destination link when mouseover text is clicked. Use http:// for external links" => "Egérmozgatási szövegre való kattintáskor megjelenő cél link. Használjuk a http:// kezdést külső linkekhez",
"Text" => "Szöveg",
"DEPRECATED" => "NEM MŰKÖDIK",
"Mouseover box width. Default: 400px" => "Egérdoboz szélessége. Alapértelmezés: 400px",
"Mouseover box height. Default: 200px" => "Egérdoboz magassága. Alapértelmezés: 200px",
"Offset X" => "Eltolás X",
"Offset Y" => "Eltolás Y",
"Parse Body" => "Törzs elemzése",
"Sticky" => "Ragadós",
"No label specified" => "Nincs felirat megadva",
"Displays the data using (sort of) MediaWiki syntax" => "Az adatot MediaWiki szintakszissal jeleníti meg",
"data" => "adat",
"Displays a MySpace Flash mp3 playlist in the wiki page" => "Megjelenít egy SWF myspace mp3 playlistet a wikioldalon",
"MySpace Page" => "MySpace oldal",
"Object Hits" => "Objektum találatok",
"Displays object hit info by object and days" => "Objektum látogatottságát mutatja objektumonként és naponként",
"Permissions" => "Jogosultságok",
"Plugin Manager" => "Pluginok kezelése",
"Information" => "Információ",
"Module" => "Modul",
"Poll" => "Szavazás",
"Displays the output of a poll, fields are indicated with numeric ids." => "Megjeleníti egy kérdőív eredményét, a mezőket numerikus azonosítók jelölik",
"missing poll ID for plugin POLL" => "hiányzik a kérdőív ID a POLL pluginhez",
"Profile application" => "Profil alkalmazása",
"Proposal" => "Ajánlat",
"Accept proposal" => "Ajánlat elfogadása",
"Still undecided" => "Még nincs eldöntve",
"Reject proposal" => "Ajánlat elutasítása",
"Quote" => "Idézet",
"Quoted text" => "Idézett szöveg",
"Quote:" => "Idézet:",
"Quote text by surrounding the text with a box, like the [QUOTE] BBCode" => "Idézett szöveget dobozba foglalja úgy mint a [QUOTE] BBCode",
"Random Dynamic Content" => "Véletlenszerű dinamikus tartalom",
"Includes random content from the dynamic content system." => "Véletlenszerű tartalmat jelenít meg a dinamikus tartalomkezelő rendszerből.",
"Result limit" => "Eredmény limit",
"Layout" => "Kinézet",
"User Information" => "Felhasználói információk",
"User Preferences" => "Felhasználói beállítások",
"Exclude" => "Kizárás",
"Preferences" => "Beállítások",
"Redirect" => "Átirányítás",
"Redirects you to another wiki page" => "Átirányítás más wiki oldalra",
"one data per line" => "egy adat soronként",
"Displays a comment, tip, note or warning box" => "Megjelenít egy kommentet, tippet, megjegyzést vagy figyelmeztető dobozt",
"remarks text" => "megjegyzés szövege",
"Remarks Box" => "Megjegyzés doboz",
"Errors" => "Hibák",
"Note" => "Megjegyzés",
"Warning" => "Figyelmeztetés",
"Highlight" => "Kiemelés",
"Close" => "Bezárás",
"RSS Feed" => "RSS feed",
"Inserts an RSS feed output." => "RSS feed kimenetet illeszt be.",
"IDs" => "ID-k",
"List of feed IDs separated by colons. ex: feedId:feedId2" => "Feed ID-k kettőspont által elválasztott listája. Pld: feedId:feedId2",
"Result Count" => "Eredmények száma",
"Icon" => "Ikon",
"Scroll" => "Görgetés",
"Sheet" => "Tiki táblázat",
"Sheet Heading" => "Ív címsor",
"Editable" => "Szerkeszthető",
"New sheet in page: " => "Új ív ezen az oldalon: ",
"Create New Sheet" => "Új ív létrehozása",
"Edit Sheet" => "Ív szerkesztése",
"Show Pages" => "Oldalak megjelnítése",
"List wiki pages" => "Wikioldalak listázása",
"Search criteria" => "Keresési kritérium",
"Clickable Skype link" => "Klikkelhető Skype link",
"Action" => "Akció",
"Smarty function" => "Smarty funkció",
"Sorts the plugin content in the wiki page" => "A plugin tartalmát rendezi a wiki oldalon",
"Order" => "Sorrend",
"Split a page into rows and columns" => "Feloszt egy oldalt sorokra és oszlopokra",
"Join Columns" => "Oszlopok egyesítése",
"Generate the colspan attribute if columns are missing" => "Generálja a colspan attribútumot ha hiányoznak oszlopok",
"Fixed Size" => "Rögzített méret",
"First" => "Első",
"Display edit icon for each section" => "Szerkesztési ikon megjelenítése minden egyes szekciónál",
"Edit" => "Szerkesztés",
"Missing db param" => "Hiányzó db paraméter",
"Run a sql query" => "SQL lekérdezést futtat",
"sql query" => "SQL lekérdezés",
"Object Type" => "Objektum típusa",
"Added" => "Hozzáadva",
"Viewed" => "Megtekintés",
"Subscript" => "Alsó index",
"Displays text in subscript." => "Alsó indexben jelenít meg szöveget",
"Subscribe or unsubscribe to a group" => "Csoportra történő fel/leiratkozás",
"Subscribe Group" => "Feliratkozás csoportra",
"Subscribe Text" => "Feliratkozás szövege",
"Subscribe" => "Feliratkozás",
"Unsubscribe Text" => "Leiratkozás szövege",
"Subscribe Action" => "Felirtakozási akció",
"Unsubscribe Action" => "Leiratkozási akció",
"Subscribe Groups" => "Feliratkozás csoportokra",
"Subscribe newsletter" => "Feliratkozás hírlevélre",
"Superscript" => "Felső index",
"Displays text in superscript (exponent)." => "Felső indexben jelenít meg szöveget.",
"Displays text in superscript." => "Felső indexben jelenít meg szöveget",
"Displays a survey" => "Kérdőívet jelenít meg",
"Wiki Page to redirect the user after his vote" => "Wiki oldal neve melyre a felhasználó átirányításra kerül a szavazata leadása utána",
"Tabs" => "Fülek",
"Tag" => "HTML tag",
"Displays the text between an html tag" => "Szöveget jelenít meg HTML tagek között",
"Tag Name" => "Tag neve",
"CSS Style" => "CSS stílus",
"Displays text between HTML tags" => "Megjelenít HTML tag közti szöveget",
"Title Search" => "Cím keresése",
"Search wiki page titles." => "Wiki oldalak nevei között keres.",
"Search Criteria" => "Keresési kritérium",
"No Header" => "Nincs fejléc",
"No pages found for title search" => "Nem található a kritériumoknak megfelelő oldal",
"One page found for title search" => "A keresés egy találatot adott",
"pages found for title search" => "oldal felelt meg a keresési kritériumoknak",
"Table of Contents (Structure)" => "Tartalomjegyzék (Struktúra)",
"Maximum Depth" => "Maximális mélység",
"Structure ID" => "Struktúra neve",
"Show Numbering" => "Számozás megjelenítése",
"Top Friends" => "Top barátok",
"List top-scoring users." => "Legtöbb pontot szerző felhasználók listázása.",
"List top-scoring users" => "Legtöbb pontot szerző felhasználók listázása",
"Translate" => "Fordítás",
"string" => "sztring",
"Translate a string" => "Sztring lefordítása",
"Fields" => "Mezők",
"Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Megjelenítendő mező ID-k kettősponttal elválasztott listája. Például: 2:4:5",
"Show Status" => "Státusz megjelenítése",
"Embedded" => "Beépített",
"to" => "ig",
"template" => "sablon",
"Parent" => "Szülő",
"Values" => "Értékek",
"Overwrite" => "Felülírás",
"Preview" => "Előnézet",
"Reset" => "Visszaállítás",
"View" => "Megtekintés",
"ItemId" => "Tétel ID",
"Template File" => "Sablon fájl",
"New Status" => "Új státusz",
"Open" => "Nyitva",
"Pending" => "Függő",
"Closed" => "Lezárva",
"Incorrect fieldId:" => "Hibás mezőID:",
"Displays an input form for tracker submit" => "Beviteli űrlapot jelenít meg űrlap felviteléhez",
"You do not have permission to insert an item" => "Nincs elegendő jogosultság tétel beszúrásához",
"You do not have permission to modify an item" => "Nincs elegendő jogosultság tétel megváltoztatásához",
"Invalid email" => "Érvénytelen E-mail",
"Fields marked with a * are mandatory." => "A *-gal jelölt mezőket kötelező kitölteni",
"Tracker Comments" => "Űrlap kommentek",
"Displays the number of tracker comments" => "Űrlap tétel kommentjeit jeleníti meg",
"Filters" => "Szűrők",
"Display List" => "Lista megjelenítése",
"Tracker Filter" => "Űrlap szűrő",
"Filters the items of a tracker, fields are indicated with numeric ids." => "Szűri az űrlap tételeit, a mezőket numerikus azonosítók (ID-k) jelzik",
"notice" => "megjegyzés",
"tracker field type not processed yet" => "űrlap mező típusa még nem került feldolgozásra",
"Wiki text" => "Wiki szöveg",
"Tracker Item Field" => "Űrlap tétel mező",
"Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)." => "Megjeleníti egy űrlapmező értékét vagy a wiki szöveget ha a mező értéke beállításra került vagy értéke van (ha itemId nincs megadva akkor használjuk az URL itemId-ját vagy felhasználói űrlapot)",
"Field ID" => "Mező ID",
"Tracker List" => "Űrlap lista",
"Displays the output of a tracker content, fields are indicated with numeric ids." => "Megjeleníti egy űrlap tartalmát, a mezőket numerikus azonosítók (ID-k) jelzik",
"Notice" => "Megjegyzés",
"Sticky Popup" => "Ragadós popup",
"Show Links" => "Linkek megjelenítése",
"Show Initials" => "Kezdőbetűk megjelenítése",
"Show Field Name" => "Mezőnév megjelenítése",
"Status Filter" => "Státusz szűrő",
"Filter Field" => "Szűrő mező",
"Filter Value" => "Szűrő érték",
"Exact Value" => "Pontos érték",
"More" => "Több",
"More URL" => "Több URL",
"Wiki Page" => "Wiki oldal",
"View User" => "Felhasználó megtekintése",
"Left Deliminator" => "Bal deliminator",
"Right Deliminator" => "Jobb deliminator",
"Export Button" => "Export gomb",
"Compute" => "Számítás",
"incorrect filterfield" => "hibás szűrőmező",
"Error in tracker ID" => "Hiba az űrlap ID-ban",
"No field indicated" => "Nincs mező megadva",
"Displays a button to link to a page with a tracker plugin with prefilled tracker fields." => "Megjelenít egy gombot mely hivatkozik egy űrlap plugint használó oldalra ahol előre kitöltött űrlapmezők találhatók",
"Tracker Prefill" => "Űrlap előzetes kitöltése",
"Field 1" => "Mező 1",
"Value 1" => "Érték 1",
"Field 2" => "Mező 2",
"Value 2" => "Érték 2",
"Field 3" => "Mező 3",
"Value 3" => "Érték 3",
"Field 4" => "Mező 4",
"Value 4" => "Érték 4",
"Field 5" => "Mező 5",
"Value 5" => "Érték 5",
"Tracker Stats" => "Űrlap statisztika",
"Displays some stat of a tracker content, fields are indicated with numeric ids." => "Űrlap tartalmának statisztikáját mutatja, a mezőket numerikus azonosítók (ID-k) jelzik",
"Show link to tiki-view_tracker" => "Link mutatása a tiki-view_tracker-hez",
"incorrect fieldId" => "hibás mezőID",
"Tracker Timeline" => "Űrlap idő",
"Timeline view of a tracker, can be used to display event schedules or gantt charts." => "Űrlap időinformációinak megtekintésére szolgál. Megjelenítheti események idejét vagy akár GANTT ábrákat is.",
"Title Field" => "Név mező",
"Summary Field" => "Összegző mező",
"Element Group" => "Elem csoport",
"Lower Bound" => "Alsó határ",
"Upper Bound" => "Felső határ",
"Primary Scale Unit" => "Elsődleges mérési egység",
"Secondary Scale Unit" => "Másodlagos mérési egység",
"Link Group Name" => "Csoportnév link",
"Page Link Field" => "Oldallink mező",
"Missing parameter: %0" => "Hiányzó paraméter: %0",
"Trade" => "Kereskedés",
"Page not found" => "Az oldal nem található",
"Translated" => "Fordítás",
"Links to a translated content" => "Lefordított tartalomra mutat",
"[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] vagy ((wikiname)) vagy ((inter:interwiki)) (wiki szintakszist használ)",
"Two letter language code of the language, ex: fr" => "A nyelv két betűs kódja, pld: hu",
"Flag" => "Zászló",
"Country name, ex: France" => "Ország neve, pld: Franciaország",
"User Count" => "Felhasználók száma",
"Group name" => "Csoport neve",
"Displays the number of registered users" => "Megjeleníti a regisztrált felhasználók számát",
"Userlink function" => "Userlink funkció",
"Makes a link to the user information page" => "Linket készít a felhasználó információs lapjára",
"User List" => "Felhasználók listája",
"Login Filter" => "Felhasználói név szűrő",
"Real Name" => "Valódi név",
"users" => "felhasználók",
"Displays a list of registered users" => "Regisztrált felhasználók számát mutatja",
"Split the text in parts visible only under some conditions" => "Felosztja a szöveget olyan részekre melyek csak bizonyos feltételek esetén kerülnek megjelenítésre",
"Navigation" => "Navigáció",
"This is the default text" => "Ez az alapértelmezett szöveg",
"(version 3)" => "(verzió 3)",
"This is version 3 info" => "Ez verzió 3 információ",
"(version 2)" => "(verzió 2)",
"This is version 2 info" => "Ez verzió 2 információ",
"(version 1)" => "(verzió 1)",
"This is version 1 info" => "Ez verzió 1 információ",
"Width in pixels" => "Szélesség pixelben",
"Height in pixels" => "Magasság pixelben",
"Vote" => "Szavazás",
"Show Stats" => "Statisztika megjelenítése",
"Show Stats After" => "Statisztika megjelenítése utána",
"Wanted Pages" => "Wanted oldalak",
"a valid regex-expression (PCRE)" => "egy valid regex-expression (PCRE)",
"From" => "Feladó",
"To" => "Címzett",
"Line break" => "Sortörés",
"Level" => "Szint",
"non-valid custom regex" => "nem valid custom regex",
"ignored" => "ignorálva",
"dash-WikiWord" => "elválasztás-WikiWord",
"not in level" => "nincs szintben",
"valid" => "érvényes",
"End of debug output." => "Hibakeresési adatok vége",
"Wanted Page" => "Wanted oldal",
"Referenced By Page" => "Oldal által hivatkozva",
"Lists ''wanted'' Wiki pages: " => "''wanted'' wiki oldalakat listázza: ",
"Page-Pattern" => "Oldal-minta",
"Custom-Level-Regex" => "Saját szintű regex",
"^Parameters: key=>value,...\n" => "^Paraméterek: key=>value,...\n",
"empty string" => "üres sztring",
"(refer to PHP function fnmatch() for details)\n" => "(részletekért lásd az fnmatch() PHP függvényt)\n",
"The character, by which ignored patterns are separated." => "A karakter mely által a figyelmen kívűl hagyott minták elválasztásra kerülnek",
"possible values: characters\n" => "lehetséged értékek: karakterek\n",
"Whether to include external wikis in the list." => "Megadja hogy tartalmazzon-e vagy sem külső wikiket a lista",
"possible values: " => "lehetséges értékek: ",
"Collect either originating or wanted pages in a cell and display them in the second column." => "Forrás vagy keresett oldalak összegyűjtése egy cellában és meggjelenítése a második oszlopban",
"Switch-on debug output with details about the items." => "Tételek részleteit tartalmazó hibakeresés bekapcsolása",
"Multiple collected items are separated in distinct table rows, or by comma or line break in one cell." => "Több összegyűjtött tétel külön táblasorban vagy vesszővel vagy egy cellában sortöréssel kerül elkönítésre",
"Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex." => "Keresett oldalak listájának szűrése page_regex vagy saját szűrő alapján. Az alapértelmezett érték a weblaphoz tartozó __current__ page_regex",
"A custom filter for wanted pages to be listed (only used when level=>custom)." => "Saját szűrő listázandó wanted oldalakhoz (csak ha level=>custom).",
"Archive" => "Archívum",
"Service Name" => "Szolgáltatás neve",
"Template Name" => "Sablon neve",
"Unknown Template" => "Ismeretlen sablon",
"Unknown Service" => "Ismeretlen szolgáltatás",
"Missing parameters" => "Hiányzó paraméterek",
"Related" => "Kapcsolódó",
"Removed version \$version" => "Eltávolított verzió \$version",
"rollback version " => "verzió visszaállítása",
"No version indicated" => "Nincs verzió feltüntetve",
"Page locked" => "Oldal zárolva",
"Page unlocked" => "Oldal feloldva",
"Removed last version" => "Legutóbbi verzió eltávolítva",
"ERROR: Either the subject or body must be non-empty" => "Az üzenet tárgya vagy az üzenet törzse nem lehet üres!",
"ERROR: No valid users to send the message" => "HIBA: Nincs érvényes felhasználó akinek el lehetne küldeni az üzenetet",
"Invalid user" => "Érvénytelen felhasználó",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "Kimenő üzenetek fiókja betelt. Levélküldés előtt törölni vagy archíválni kellene pár üzenetet.",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Üzenetek küldéséhez előbb lehetővé kell tenni üzenetek fogadását. Ezt a lehetőséget a felhasználói preferenciák között a 'Más felhasználók üzenhetnek nekem' opció bekapcsolásával lehet aktiválni",
"User %s can not receive messages, mailbox is full" => "%s felhasználó nem tud üzeneteket fogadni mert betelt a postafiókja",
"User %s can not receive messages" => "%s felhasználó nem tud üzeneteket fogadni",
"Invalid user: %s" => "Érvénytelen felhasználó: %s",
"Archive is full. Delete some messages from archive first." => "Az archívum megtelt. Először törölni kell néhány üzenetet az archívumból.",
"No more messages" => "Nincs több üzenet",
"Similar Content" => "Hasonló tartalom",
"Article archives" => "Cikk arhívum",
"Article Topics" => "Cikk témák",
"TikiWiki assistant" => "Tiki asszisztens",
"Last blog post comments" => "Legutóbbi blog kommentek",
"Last visited pages" => "Legutóbb látogatott oldalak",
"Cart" => "Bevásárló kocsi",
"Category Transitions" => "Kategória tranzíciók",
"Change Category" => "Kategória változtatása",
"Categorize" => "Kategorizálás",
"Assign" => "Hozzárendelés",
"Received objects" => "Fogadott objektumok",
"Last directory sites" => "Legutóbbi oldalak a könyvtárban",
"Show description" => "Leírás megjelenítése",
"Directory statistics" => "Könyvtár statisztikák",
"Top directory sites" => "Top könyvtári oldalak",
"Best rated topics" => "Legjobbra értékelt témák",
"Last forum posts" => "Legutóbbi fórum posztok",
"Topics only" => "Csak témák",
"Most commented forums" => "Legtöbbet kommentált fórumok",
"Most read topics" => "Legtöbbet olvasott témák",
"Most visited forums" => "Leglátogatottabb fórumok",
"Freetags editor" => "Címkék szerkesztése",
"Freetags Wiki" => "Wiki címkék",
"Freetags similar content" => "Hasonló tartalom (címkék)",
"Most popular tags" => "Legnépszerűbb címkék",
"User preferred tags" => "Felhasználó által preferált címkék",
"Google Search" => "Google keresés",
"Groups emulation" => "Csoportok emulációja",
"Last actions" => "Legutóbbi akciók",
"Last blog posts" => "Legutóbbi blogposztok",
"Last category objects" => "Legutóbbi kategorizált objektumok",
"Last Created blogs" => "Legutóbb létrehozott blogok",
"Last Created FAQs" => "Legutóbbi Gyakori kérdések",
"Last Created Quizzes" => "Legutóbb készült kvízek",
"Last modified file galleries" => "Legutóbb módosított fájlgalériák",
"Last Files" => "Legutóbbi fájlok",
"Last modified image galleries" => "Legutóbb módosított képgalériák",
"Last Images" => "Legutóbbi képek",
"Last modified events" => "Legutóbb módosított események",
"Last Modified blogs" => "Legutóbb módosított blogok",
"Last Podcasts" => "Legutóbbi Podcast-ok",
"width" => "szélesség",
"Last submissions" => "Legutóbbi hozzászólások",
"Last tracker comments" => "Legutóbbi űrlap kommentek",
"Last tracker items" => "Legutóbbi űrlaptételek",
"Last Items" => "Legutóbbi elemek",
"Last Modified Items" => "Legutóbbi módosított elemek",
"Last Validated FAQs Questions" => "Legutóbb validált Gyakori Kérdések",
"Last Visitors" => "Legutóbbi látogatók",
"Live support" => "Élő támogatás",
"Logo" => "Logó",
"Menu page" => "Menü oldal",
"Structure" => "Struktúra",
"Unread inter-user messages" => "Olvasatlan felhasználók közötti üzenetek",
"Messages" => "Üzenetek",
"Months links" => "Havi linkek",
"Most commented" => "Legtöbbet kommentált",
"Waiting Submissions" => "Várakozó beküldések",
"Old articles" => "Régi cikkek",
"Quick Edit" => "Gyors szerkesztés",
"Create/Edit" => "Létrehozás/szerkesztés",
"Quick Edit a Wiki Page" => "Wiki oldal szerkesztése",
"Random image" => "Véletlenszerű kép",
"Random Pages" => "Véletlenszerű lapok",
"New user registration" => "Új felhasználói regisztrációk",
"Feeds List" => "Feed-ek listája",
"Search" => "Keresés",
"Advanced search" => "Részletes keresés",
"Go" => "Indítás",
"Search Wiki Page" => "Wiki oldal keresése",
"Post" => "Poszt",
"Since last visit (simple)" => "Legutóbbi látogatás óta (egyszerű)",
"Since your last visit" => "Utolsó látogatás óta",
"Since last visit" => "Legutóbbi látogatás óta",
"Changes since" => "Változások",
"Since your last visit..." => "Legutóbbi látogatás óta",
"new comments" => "új komment",
"new posts" => "új poszt",
"wiki pages changed" => "módosított wiki lap",
"new articles" => "új cikk",
"new FAQs" => "új GYIK",
"new blogs" => "új blog",
"new blog posts" => "új blogposzt",
"new image galleries" => "új képgaléris",
"new images" => "új kép",
"new file galleries" => "új fájlgaléria",
"new files" => "új fájl",
"new polls" => "új szavazás",
"new users" => "új felhasználó",
"new tracker items" => "új űrlaptétel",
"updated tracker items" => "frissített űrlap tétel",
"Switch Language" => "Nyelv váltása",
"Switch theme" => "Téma váltása",
"Terminology" => "Terminológia",
"Tiki Tests" => "Tiki tesztek",
"Most Active blogs" => "Legaktívabb blogok",
"Top File Galleries" => "Top fájlgalériák",
"Top files" => "Top fájlok",
"Top Forum Posters" => "Top fórum posztolók",
"Top image galleries" => "Top képgalériák",
"Top Images" => "Top képek",
"Top Objects" => "Top objektumok",
"Top Pages" => "Top lapok",
"Top Quizzes" => "Top kvízek",
"Top Visited FAQs" => "Legtöbbet látogatott Gyakori kérdések",
"Trackerhelp" => "Űrlap súgó",
"Translate Updates" => "Frissítések lefordítása",
"User Blogs" => "Felhasználói blogok",
"User bookmarks" => "Felhasználói könyvjelzők",
"User image galleries" => "Felhasználói képgalériák",
"User Pages" => "Felhasználói lapok",
"My Pages" => "Oldalaim",
"User tasks" => "Felhasználói feladatok",
"Public tasks" => "Nyilvános feladatok",
"User-Group Tracker" => "Felhasználó-Csoport űrlap",
"Top users" => "Top felhasználók",
"What is related" => "Kapcsolódó tartalom",
"Online users" => "Online felhasználók",
"Last comments" => "Legutóbbi kommentek",
"Invalid username or password" => "Nem megfelelő felhasználónév vagy jelszó",
"Can remove articles" => "Eltávolíthat cikket",
"Can submit articles" => "Beküldhet cikket",
"Can use the directory" => "Használhatja a linktárat",
"Can admin faqs" => "Adminisztrálhat GYIKet",
"Can view faqs" => "Megtekinthet GYIK-et",
"Can admin users" => "Adminisztrálhat felhasználókat",
"Can access site when closed" => "Beléphet a lezárt weblapra",
"Administrator, can admin banners" => "Adminisztrálhat bannereket",
"Can ban users or ips" => "Letilthat felhasználókat és IP címeket",
"Can admin the dynamic content system" => "Adminisztrálhatja a dinamikus tartalmakat",
"Can admin integrator repositories and rules" => "Adminisztrálhat integrálási lerakatokat és szabályokat",
"Can admin mail-in accounts" => "Adminisztrálhat bejövő E-mail címeket",
"Can edit object permissions" => "Adminisztrálhat objektum jogosultságokat",
"Can admin external feeds" => "Adminisztrálhat külső feed-eket",
"Can clean cache" => "Cache-t üríthet",
"Can create new css suffixed with -user" => "Létrehozhat új CSS-t -user suffix-szel",
"Can remove association between two pages in a translation set" => "Eltávolíthat kapcsolatot két oldal között egy fordítási készletben",
"Can admin cookies" => "Adminisztrálhat cookie-kat",
"Can edit translations and create new languages" => "Szerkesztheti a fordításokat és létrehozhat új nyelveket",
"Can edit menu" => "Szerkeszthet menüt",
"Can edit menu option" => "Adminisztrálhat menü opciókat",
"Can edit site templates" => "Szerkeszthet oldal sablonkat",
"Can search" => "Kereshet",
"Can report a link to the webmaster" => "Jelenthet linket a webmesternek",
"Can subscribe to groups" => "Feliratkozhat csoportokra",
"Can send a link to a friend" => "Linket küldhet barát részére",
"Can share a page (email, twitter, facebook, message, forums)" => "Megoszthat egy oldalt (E-mail, Twitter, Facebook, üzenet, fórumok)",
"Can use HTML in pages" => "Használhat  HTML-t a wiki oldalakon",
"Can view action log" => "Megtekintheti az akció logot",
"Can view action log for users of his own groups" => "Megtekintheti a saját csoportjába tartozó felhasználó akció naplóját",
"Can view integrated repositories" => "Megtekinthet integrált lerakatokat",
"Can view site stats" => "Megtekinthet oldal statisztikákat",
"Can view site templates" => "Megtekinthet oldal sablonokat",
"Can read blogs" => "Olvashat blogot",
"Can admin file galleries" => "Adminisztrálhat fájlgalériákat",
"Can assign perms to file gallery" => "Oszthat  jogosultságokat fájlgalériához",
"Can use Directory Batch Load" => "Használhatja a tömeges fájlfeltöltést",
"Can upload zip files with files" => "Feltölthet ZIP fájlt",
"Can create file galleries" => "Létrehozhat fájlgalériákat",
"Can download files" => "Letölthet fájlokat",
"Can edit a gallery file" => "Szerkeszthet fájlgalériákat",
"Can list file galleries" => "Listázhat fájlgalériákat",
"Can upload files" => "Feltölthet fájlt",
"Can view file galleries explorer" => "Megtekintheti a fájlgaléria böngészőt",
"Can view file galleries path" => "Megtekintheti fájlgalériák útvonalát",
"Can view file galleries" => "Megtekinthet fájlgalériákat",
"Can admin forums" => "Adminisztrálhat fórumokat",
"Can attach to forum posts" => "Csatolhat fórum posztokhoz",
"Auto approve forum posts" => "Automatikusan jóváhagyhat fórum posztokat",
"Can edit own forum posts" => "Szerkesztheti saját fórum posztjait",
"Can post in forums" => "Posztolhat fórumba",
"Can start threads in forums" => "Témákat nyithat a fórumokban",
"Can read forums" => "Olvashat fórumokat",
"Can vote comments in forums" => "Szavazhat kommentekre a fórumokban",
"Can browse freetags" => "Böngészhet a címkéket",
"Can admin newsletters" => "Karbantarthat hírlevelet",
"Can send newsletters" => "Kiküldhet hírlevelet",
"Can list newsletters" => "Listázhat hírlevelet",
"Can vote polls" => "Szavazhat kérdőíveken",
"Can view poll voters" => "Megnézheti szavazás szavazóit",
"Can admin toolbars" => "Szerkeszthet eszközsorokat",
"Can view sheet" => "Megtekinthet Tiki táblázatot",
"Can admin trackers" => "Karbantarthat űrlapot",
"Can admin the wiki" => "Adminisztrálhatja a wikit",
"Can assign perms to wiki pages" => "Jogosultságokat oszthat wiki oldalakhoz",
"Can edit pages" => "Szerkeszthet oldalakat",
"Can edit dynamic variables" => "Szerkeszthet dinamikus változókat",
"Can lock pages" => "Zárolhat oldalakat",
"Can save as minor edit" => "Végezhet kis módosítást",
"Can remove" => "Eltávolíthat",
"Can rename pages" => "Átnevezhet oldalt",
"Can rollback pages" => "Visszaállíthat oldalakat",
"Can upload pictures to wiki pages" => "Képeket tölthet fel wiki oldalakhoz",
"Can use the page as a tracker template" => "Használhatja az oldalt űrlap sablonként",
"Can view page/pages" => "Megtekinthet oldalakat",
"Can view in module and feed the wiki pages reference" => "Megtekintheti modulban és feed-elheti a wiki oldalak hivatkozását",
"Can watch structure" => "Figyelhet struktúrát",
"Can view wiki comments" => "Megtekinthet wiki kommentet",
"Can view wiki history" => "Megtekintheti az előzményeket",
"Can view source of wiki pages" => "Megtekintheti wiki oldalak forrását",
"Can view similar wiki pages" => "Megtekinthet hasonló wiki oldalakat",
"Can cache user bookmarks" => "Cache-elhet felhasználói könyvjelzőket",
"Can create user bookmarks" => "Létrehozhat felhasználói kedvenceket",
"Can use tasks" => "Használhat feladatokat",
"Can broadcast messages to all user" => "Üzenetet küldhet az összes felhasználó részére",
"Can broadcast messages to groups" => "Üzeneteket küldhet csoportoknak",
"Can use the messaging system" => "Használhatja az üzenőrendszert",
"Can admin comments" => "Adminisztrálhat kommentket",
"Can edit all comments" => "Szerkesztheti az összes kommentet",
"Can post new comments" => "Posztolhat új kommenteket",
"Can read comments" => "Olvashat oldalakat",
"Can delete comments" => "Törölhet kommentet",
"Can vote comments" => "Szavazhat kommentekről",
"Can delete mapfiles" => "Törölhet térkép fájlt",
"Can view unapproved plugin details" => "Megtekintheti a nem jóváhagyott plugin-ok részleteit",
"Can execute unapproved plugin" => "Végrehajthat nem jóváhagyott plugin-okat",
"Can approve plugin execution" => "Jóváhagyhat plugin végrehajtást",
"Trust all user inputs including plugins (no security checks)" => "Megbízhat az összes felhasználói inputban beleértve a pluginokat. (nincs biztonsági ellenőrzés)",
"View page backlinks" => "Megtekinthet oldal visszahivatkozásokat",
"Can admin mail notifications" => "Adminisztrálhatja az E-mailes értesítéseket",
"Can admin categories" => "Karbantarthat kategóriát",
"Can admin perspectives" => "Karbantarthat perspektívát",
"Can view the group" => "Megtekinthet csoportokat",
"Can view the group members" => "Megtekintheti csoportok tagjait",
"Can add group members" => "Hozzáadhat csoporttagokat",
"Can remove group members" => "Eltávolíthat csoporttagokat",
"Can join or leave the group" => "Csatlakozhat vagy elhagyhat csoportokat",
"Can execute arbitrary queries on a given DSN" => "Végrehajthat lekérdezéseket bizonyos DSN-eken",
"user can use social network integration" => "Használhatja a közösségi hálózat integrációt",
"Can view contributions to a page" => "Megtekintheti egy oldalhoz tartozó hozzájárulásokat",
"change theme" => "stílus megváltoztatása",
"default calendars" => "alapértelmezett naptárak",
"style" => "stílus",
"smarty notice reporting" => "smarty üzenetek riportálása",
"Enter the code you see above" => "Képen látható kód megadása",
"Try another code" => "Új kód kérése",
"bytes" => "bájt",
"Share this page" => "Oldal megosztása",
"Send a link" => "Link küldése",
"Translation" => "Fordítás",
"Remove" => "Eltávolítás",
"List of attached files" => "Mellékletek listája",
"desc" => "Leírás",
"uploaded" => "Feltöltés ideje",
"Delete" => "Törlés",
"Upload file" => "Fájl feltöltése",
"Attach" => "Csatolás",
"Attach a file to this item" => "Fájl csatolása az űrlaptételhez",
"more info" => "további információ",
"No attachments for this item" => "Nincsenek mellékletek csatolva ehhez a tételhez",
"debug" => "hibakereső",
"Fatal error" => "Hiba",
"Save to notepad" => "Mentés jegyzettömbbe",
"Published " => "Publikálta",
"on" => "Dátum",
"Previous post" => "Előző poszt",
"Next post" => "Következő poszt",
"More..." => "Több...",
"pages" => "oldal",
"First page" => "Első oldal",
"Previous page" => "Előző oldal",
"page" => "oldal",
"Next page" => "Következő oldal",
"Last page" => "Utolsó oldal",
"Leave a comment" => "Komment",
"comments" => "komment",
"Actions" => "Akciók",
"Properties" => "Tulajdonságok",
"No records found" => "Nincs megjeleníthető rekord",
"Select Categories" => "Kategóriák kiválasztása",
"Admin Categories" => "Kategóriák beállítása",
"Select/deselect all categories" => "Összes kategória be/kijelölése",
"No categories defined" => "Nincsenek még létrehozva kategóriák",
"Browse Category" => "Kategóriák böngészése",
"Posted by" => "Szerző",
"posts:" => "posztok száma:",
"User Level" => "Felhasználói szint",
"private message" => "privát üzenet",
"Send eMail to User" => "E-mail küldése felhasználónak",
"user online" => "felhasználó online",
"user offline" => "felhasználó offline",
"Reply" => "Válasz",
"Approve" => "Jóváhagyás",
"Reject" => "Elutasítás",
"Monitor this Topic" => "Téma figyelése",
"Stop Monitoring this Topic" => "Téma figyelésének felfüggesztése",
"Group Monitor" => "Csoport figyelés",
"Moderator actions" => "Moderátori akciók",
"reported:" => "jelentve:",
"queued:" => "sorban áll:",
"Move to topic:" => "Mozgatás ebbe a témába:",
"Move" => "Mozgatás",
"Delete Selected" => "Kijelöltek törlése",
"Comments Locked" => "Kommentek zárolva",
"Unlock" => "Feloldás",
"Lock" => "Zárolás",
"Threshold" => "Küszöb",
"Replies" => "Válaszok",
"below your current threshold" => "küszöbérték alatt van",
"New Reply" => "Új válasz",
"Editing reply" => "Válasz szerkesztése",
"Post new message" => "Új üzenet küldése",
"Editing comment" => "Komment szerkesztése",
"Reply to the selected comment" => "Válasz a kiválasztott kommentre",
"Post new comment" => "Új komment küldése",
"Add Comment" => "Kommentek",
"Post new reply" => "Új válasz küldése",
"Posting replies" => " Általános tudnivalók",
"Posting comments" => "Kommentek küldése",
"1 comment" => "1 komment",
"Comments" => "Komment",
"Go back" => "Vissza",
"Return to home page" => "Vissza a kezdőlaphoz",
"Type of contribution:" => "Hozzájárulás típusa:",
"Contributors" => "Hozzájárulók",
"Copyrights" => "Szerzői jogok",
"Authors" => "Szerzők",
"Add" => "Hozzáadás",
"If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation:" => "Ha van Shell (SSH) hozzáférés, akkor lehet használni az alábbiakat is a parancssorból a Tiki telepítés root könyvtárából:",
"Current URL" => "Jelenlegi URL",
"Command" => "Parancs",
"Type <code>help</code> to get list of available commands" => "Írd be <code>help</code> a rendelkezésre álló parancsok listázásához",
"Total" => "Összesen",
"Duplicate File Gallery" => "Fájlgaléria duplikálása",
"File gallery" => "Fájlgaléria",
"Duplicate categories" => "Kategóriák duplikálása",
"Duplicate" => "Duplikálás",
"Save" => "Mentés",
"View inserted gallery" => "Létrehozott galéria megtekintése",
"Required for podcasts" => "Podcastokhoz szükséges",
"System" => "Rendszer",
"Any file" => "Bármilyen fájl",
"Podcast (video)" => "Podcast (videó)",
"Gallery is visible to non-admin users" => "Galériát láthatják nem adminisztrátor felhasználók is",
"Gallery is public" => "A galéria publikus",
"Any user with permission (not only the gallery owner) can upload files" => "A megfelelő jogosultságokkal rendelkező bármely felhasználó tölthet fel fájlokat (tehát nem csak a galéria adminisztrátora)",
"Perms of the backlinks are checked to view a file" => "Visszahivatkozási linkekhez tartozó jogosultságok ellenőrzése fájl megtekintéséhez",
"Files can be locked at download" => "Fájlokat zárolni lehet letöltéskor",
"Maximum number of archives for each file" => "Archívumok maximális száma fájlonként",
"Use" => "Használat",
"unlimited" => "nincs korlát",
"Parent gallery" => "Szülő (felettes) galéria",
"Owner of the gallery" => "Galéria tulajdonosa",
"Group of users alerted when file gallery is modified" => "Galéria módosításakor értesítendő felhasználói csoport",
"Allows to select each user for small groups" => "Kisebb csoportok esetén az egyes felhasználók kiválasztása",
"Maximum width for images in gallery" => "Képek maximális szélessége",
"If an image is wider than this, it will be resized." => "Ha egy kép ennél az értéknél szélesebb, akkor átméretezésre kerül",
"Attention: In this case, the original image will be lost." => "Figyelem: ebben az esetben a kép  eredeti tulajdonságai elvesznek",
"Maximum height for images in gallery" => "Képek maximális magassága",
"If an image is higher than this, it will be resized." => "Ha egy kép ennél az értéknél magasabb, akkor átméretezésre kerül",
"Wiki markup to enter when image selected from \"file gallery manager\"" => "Megadandó Wiki mark-up kép fájlgaléria menedzser funkción keresztüli kiválasztásakor",
"The default is " => "Alapértelmezés: ",
"Display Properties" => "Tulajdonságok megjelenítése",
"Max description display size" => "Leírás megjelenítésének maximális hossza",
"Max rows per page" => "Sorok maximális száma oldalanként",
"Select which items to display when listing galleries" => "Fájlgaléria elemeinek listázásakor megjelenítendő adatok",
"Perhaps you are looking for:" => "Hasonló oldalak:",
"There are no wiki pages similar to '{\$page}'" => "Nincsenek ehhez hasonló nevű oldalak:'{\$page}'",
"You are not logged in." => "Be kell jelentkezni",
"Go to Log in Page" => "Ugrás a bejelentkezési oldalra",
"Create this page" => "Oldal létrehozása",
"(page will be orphaned)" => "(árva oldalként)",
"Close Window" => "Ablak bezárása",
"Go to" => "Ugrás",
"Private Gallery" => "Privát galéria",
"Perms" => "Jogosultságok",
"Open as WebFolder" => "Megnyitás Webmappaként",
"Archives" => "Archivumok",
"Replace" => "Kicserélés",
"The checkbox is disabled because this preference is disabled globally." => "A jelölőnégyzet nincs bekapcsolva mivel a ez a preferencia globálisan ki van kapcsolva",
"Please, enable the preference globally first." => "Először a globális preferenciát kell bekapcsolni",
"Name-filename" => "Név-fájlnév",
"Filename only" => "Csak fájlnév",
"Show as a column" => "Megjelenítés oszlopként",
"Show in popup box" => "Megjelenítés felugró dobozban",
"Show an icon in a column" => "Ikon megjelenítése oszlopban",
"and all the sub-objects" => "és az összes al-objektum",
"any type" => "bármely típus",
"all topic" => "összes téma",
"any language" => "bármely nyelv",
"not in" => "de nem",
"any category" => "bármely kategória",
"Multiple select" => "Többszörös kijelölés",
"in:" => "itt:",
"Number of displayed rows" => "Megjelenített sorok száma",
"List View" => "Lista nézet",
"Map View" => "Térkép nézet",
"Folksonomy Tags" => "Címkézés",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes." => "A címkéket szóköz elválasztással kell megadni. A több szóból álló címkéket szóköz nélkül egybeírva vagy idézőjelbe (\") kell rakni.",
"Tags" => "Címkék",
"Show Tree" => "Fastruktúra megjelenítése",
"Hide Tree" => "Fastruktúra elrejtése",
"Perform action with checked:" => "Akció végrehajtása a kijelöltekkel:",
"Move Selected Files" => "A kijelölt fájlok mozgatása",
"Download the zip" => "Zip fájl letöltése",
"Assign Permissions" => "Jogosultságok kiosztása",
"Move to" => "Mozgatás ide",
"Filename" => "Fájlnév",
"Other Sorts" => "Egyéb rendezések",
"No information" => "Nincs információ",
"Description:" => "Leírás:",
"Name:" => "Név:",
"Creator:" => "Létrehozó:",
"File gallery:" => "Fájlgaléria:",
"User:" => "Felhasználó:",
"New topic:" => "Új téma:",
"Group:" => "Csoport:",
"Newsletter:" => "Hírlevél:",
"Email notification" => "Tiki E-mail értesítés",
"Title:" => "Cím:",
"Heading:" => "Fejléc:",
"Body:" => "Törzs:",
"Password:" => "Jelszó:",
"Created by" => "Létrehozó",
"created" => "létrehozva",
"Old" => "Régi",
"New" => "Új",
"File Description" => "Fájl leírása",
"An object was added to category" => "Egy objektum hozzáadásra került a kategóriához",
"Added by" => "Hozzáadta:",
"An object was removed from category" => "Egy objektum eltávolításra került a kategóriából",
"Structure modified" => "Struktúraváltozás",
"A new file have been attached to page" => "Új fájl lett csatolva az oldalhoz",
"File name" => "Fájlnév",
"New attachment on %s, page" => "Új melléklet, %s, oldal:",
"Comment:" => "Komment:",
"The new page content follows below." => "Az oldal új tartalma az alábbiakban található:",
"Wiki page %s was commented on by" => "Wiki oldalhoz %s kommentet fűzött",
"an anonymous user" => "egy anonim felhasználó",
"Wiki page renamed" => "Wiki oldal átnevezve",
"Old name" => "Régi név",
"New name" => "Új név",
"Thank you for your registration." => "Köszönjük a regisztrálást.",
"You may log in now." => "Mostmár be lehet jelentkezni.",
"Legend" => "Rövidítések értelmezése",
"Mapfiles" => "Térkép fájlok",
"Available mapfiles" => "Jelenlegi térképfájlok",
"Create" => "Létrehozás",
"Reload" => "Újratöltés",
"of" => " ",
"Compare" => "Összehasonlítás",
"Current" => "Jelenlegi",
"Versions are identical" => "A verziók megegyeznek!",
"v=view" => "v=view (megtekintés)",
"c=compare" => "c=compare (összehasonlítás)",
"d=diff" => "d=diff (eltérés)",
"Ip" => "IP",
"Diff" => "Eltérések",
"Older Version" => "Régebbi verzió",
"Upload Files" => "Fájlok feltöltése",
"messages" => "üzenetek",
"Unread" => "Nem olvasott",
"Flagged" => "Jelölt",
"Unflagged" => "Nem jelölt",
"Containing" => "Tartalmazza",
"Sender" => "Feladó",
"No messages to display" => "Nincs megjeleníthető üzenet",
"Broadcast message" => "Körüzenet",
"All users" => "Összes felhasználó",
"Lowest" => "Legalacsonyabb",
"Very High" => "Legmagasabb",
"Send" => "Küldés",
"Compose message" => "Üzenet írása",
"ERROR" => "HIBA",
"Subject:" => "Tárgy:",
"Reply-to my email" => "Válasz E-mail",
"Send me a copy" => "Küldj nekem másolatot",
"No messages to download" => "Nincs letölthető üzenet",
"Mark as read" => "Olvasottként jelöl",
"Mark as unread" => "Olvasatlanként jelöl",
"Mark as flagged" => "Flagged-ként jelöl",
"Mark as unflagged" => "Unflagged-ként jelöl",
"Mark" => "Megjelöl",
"Mailbox" => "Postaláda",
"Compose" => "Levélírás",
"Broadcast" => "Körüzenet",
"Sent" => "Elküldve",
"Read message" => "Üzenet olvasása",
"replyall" => "válasz mindenkinek",
"Flag this message" => "Üzenet megjelölése",
"Replied" => "Megválaszolás",
"toggle" => "előhívás",
"Thank you for installing Tikiwiki" => "Köszönjük hogy a Tikiwiki-t választottad!",
"Select" => "Kiválasztás",
"Admin Home" => "Adminisztrációs központ",
"Admin" => "Adminisztráció",
"Admin Modules" => "Modulok adminisztrálása",
"Modules" => "Modulok",
"Admin Menus" => "Menü karbantartás",
"Menus" => "Menük",
"login" => "bejelentkezés",
"private" => "privát",
"Add event" => "Esemény hozzáadása",
"Update" => "Frissítés",
"Apply" => "Alkalmazás",
"Pages:" => "Lapok:",
"empty" => "üres",
"Categories:" => "Kategóriák:",
"Add tags" => "Címkék hozzáadása",
"List everything tagged" => "Összes felcímkézett listázása",
"insert original" => "eredeti beszúrása",
"insert thumbnail" => "előnézeti kép beszúrása",
"more" => "több",
"No avatar" => "Nincs avatár",
"Open operator console" => "Operátor konzol megnyitása",
"Log in" => "Bejelentkezés",
"Log out" => "Kijelentkezés",
"Switch User" => "Felhasználó váltása",
"Switch" => "Csere",
"Switch user" => "Felhasználó váltása",
"Log in as" => "Bejelentkezés",
"Invalid password" => "Érvénytelen jelszó",
"Email:" => "E-mail:",
"I forgot my password" => "Jelszó emlékeztető",
"Secure" => "Biztonságos",
"You have" => "",
"new messages" => "új üzenetek",
"new message" => "új üzenet",
"You have 0 new messages" => "Nincs új üzenet",
"We have" => "Itt van",
"submissions waiting to be examined" => "megvizsgálásra váró beadványok",
"Image Galleries" => "Képgalériák",
"Calendars" => "Naptárak",
"Entire Site" => "Teljes weblap",
"Image Gals" => "Képgalériák",
"Read More" => "Bővebben",
"Since your last visit on" => "Utolsó látogatás óta a",
"New Images" => "új kép",
"Wiki Pages Changed" => "Módosított wiki lapok",
"New Files" => "Új fájl",
"New Comments" => "Új komment",
"New Users" => "Új felhasználó",
"click to edit" => "Kattintás a szerkesztéshez",
"Nothing has changed" => "Nincs változás",
"Users" => "Felhasználók",
"Multiple" => "Több",
"including" => "belefoglalva",
"Site Language:" => "Weblap nyelve:",
"Site default" => "Weblap alapértelmezettje",
"Top galleries" => "Leglátogatottabb galériák",
"There are no translations of this page." => "Ennek az oldalnak nincsenek fordításai",
"Incoming" => "Bejövő",
"update from it" => "oldal frissítése ebből",
"None match your" => "Egyik sem egyezik a",
"Set your preferred languages." => "Preferált nyelvek beállítása",
"preferred languages" => "preferált nyelvekkel",
"view" => "megtekintés",
"Outgoing" => "Kimenő",
"update it" => "frissítés",
"Add Event" => "Esemény hozzáadása",
"Bookmarks" => "Könyvjelzők",
"Cache" => "Gyorsítótár",
"Del" => "Törlés",
"Logout" => "Kijelentkezés",
"User information:" => "Felhasználói információ:",
"Refresh" => "Frissítés",
"online users" => "online felhasználó",
"online user" => "online felhasználó",
"Send a message to" => "Üzenet küldése:",
"No individual permissions, category permissions apply" => "Nincsenek egyedi jogosultságok, a kategóriajogosultságok érvényesek",
"There are individual permissions set for this tracker" => "Egyedi jogosultságok vannak rendelve ehhez az űrlaphoz",
"No individual permissions. Global permissions apply." => "Nincsenek egyéni jogosultságok megadva ezért a globális jogosultságok érvényesek",
"Session" => "Munkamenet",
"vote" => "szavazás",
"Use Ctrl+Click to select multiple options" => "Ctrl+kattintásra több lehetőség is kiválasztható",
"Requires" => "Szükséges hozzá",
"You need to set" => "Szükséges:",
"Rate" => "Értékelés",
"A valid email is mandatory to register" => "A regisztrációhoz szükséges egy valid E-mail cím megadása",
"Use your email as login" => "E-mail cím használata felhasználónévként",
"Generate a password" => "Jelszó generálása",
"Send Newsletter" => "Hírlevelek küldése",
"Click Here" => "Klikk ide",
"Fullscreen" => "Teljes képernyő",
"Made with" => "Készült",
"Blogs RSS" => "Blogok RSS",
"Forums RSS" => "Fórumok RSS",
"Maps RSS" => "Térképek RSS",
"Last update from SVN" => "Legutóbbi frissítés SVN-ből",
"secs" => "másodperc",
"Show/Hide Left Column" => "Baloldali menü +/-",
"Show/Hide Right Column" => "Jobboldali menü +/-",
"Do not group by item" => "Ne csoportosítson tételenként",
"Group by item" => "Csoportosítás tételenként",
"Calendar View" => "Naptár nézet",
"Tiki Action Calendar" => "Tiki akció naptár",
"Tools Calendars" => "Naptár eszközök",
"Check / Uncheck All" => "Összes kijelölése / kijelölés eltávolítása",
"Configuration search" => "Konfiguráció keresés",
"Change" => "Változás",
"Database Version Problem" => "Adatbázis verzió probléma",
"Your database requires an update to match the current Tiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors." => "Az adatbázis frissítésre szorul hogy megegyezzen a használt Tiki verzió elvárásaival. Futtatni kell a <a href=\"tiki-install.php\">telepítőt</a>! Az adott Tiki verzióhoz nem illő adatbázis struktúra hibákhoz fog vezetni a mindennapi használat során.",
"Preference" => "Preferencia",
"Crosslinks to other features and settings" => "Linkek más funkciókhoz és beállításokhoz",
"Other sections" => "Egyéb szekciók",
"Shoutbox Words" => "Üzenőfal szóhasználata",
"Live Support" => "Élő támogatás",
"Administration features" => "Funkciók adminisztrálása",
"TikiCache/System" => "Tiki Cache/Rendszer",
"SysLogs" => "Rendszernaplók",
"Mods" => "Mod-ok",
"Banning" => "Kitiltások",
"Edit Languages" => "Nyelvek szerkesztése",
"Transitions" => "Tranzíciók",
"Transversal features" => "Átfogó funkciók",
"which apply to more than one section" => "több mint egy szekcióra vonatkoznak",
"Mail Notifications" => "E-mailes értesítések",
"Navigation features" => "Navigációs funkciók",
"Look & feel" => "Kinézet & stílus",
"themes" => "stílusok",
"Text area features" => "Szövegmezővel kapcsolatos funkciók",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "ezeket a funkciókat lehet használni az összes szöveges területen, mint például wiki oldalak, blogok, cikkek, fórumok, stb",
"Cookies" => "Cookie-k",
"External Pages Cache" => "Cache külső oldalakhoz",
"Toolbars" => "Quicktag-ek",
"External Wikis" => "Külső wikik",
"Stats &amp; banners" => "Statisztikák & bannerek",
"Report" => "Riport",
"Graph Contributions" => "Hozzájárulások grafikon",
"Records:" => "Rekordok száma:",
"contribution" => "hozzájárulás",
"contributor" => "hozzájáruló",
"Edit Action" => "Akció szerkesztése",
"Save Action" => "Akció mentése",
"Statistics" => "Statisztika",
"Volumes are equally distributed on each contributors/author" => "A mennyiségek egyenletesen kerülnek elosztásra minden egyes szerzőre/hozzájárulóra",
"Number of actions per user" => "Akciók száma felhasználónként",
"Total number of users" => "Felhasználók teljes száma",
"Number of actions per object" => "Akciók száma objektumonként",
"Total number of objects" => "Objektumok teljes száma",
"Volumn per contribution and time" => "Mennyiség hozzájárulás és idő alapján",
"Weeks" => "Hét",
"Settings" => "Beállítások",
"Setting" => "Beállítások",
"Rule title" => "Szabály neve",
"Username regex matching" => "Felhasználói név egyezik a kifejezéssel",
"IP regex matching" => "IP egyezik a kifejezéssel",
"Banned from sections" => "Az alábbi szekciókból van kitiltva",
"Rule activated by dates" => "A szabályt dátumok aktiválják",
"Rule active from" => "Érvényesség kezdete",
"Rule active until" => "Érvényesség vége",
"Custom message to the user" => "Egyedi üzenet a felhasználónak",
"Rules" => "Szabályok",
"x" => "törlés",
"User/IP" => "Felhasználó/IP",
"Sections" => "Szekciók",
"Admin Calendars" => "Naptár karbantartás",
"Create Calendar" => "Naptár létrehozása",
"View Calendars" => "Naptárak megtekintése",
"Import" => "Importálás",
"List of Calendars" => "Naptár lista",
"Loc" => "Hely",
"Participants" => "Résztvevők",
"Cat" => "Kat",
"Lang" => "Nyelv",
"Prio" => "Prioritás",
"Subscription" => "Előfizetés",
"Perso" => "Személy",
"View Calendar" => "Naptár megtekintése",
"Create / Edit Calendar" => "Naptár létrehozása/szerkesztése",
"Create/Edit Calendars" => "Naptárak létrehozása/szerkesztése",
"Custom Locations" => "Egyedi hely",
"Custom Participants" => "Saját résztvevők",
"Custom Classifications" => "Saját besorolások",
"Custom Languages" => "Egyedi nyelv",
"Custom URL" => "Saját URL",
"Custom Subscription List" => "Saját feliratkozási lista",
"Custom Priorities" => "Egyedi prioritás",
"Personal Calendar" => "Személyes naptár",
"Start of day" => "Nap kezdete",
"End of day" => "Nap vége",
"Days to display" => "Megjelenítendő napok",
"Standard Colors" => "Alap színek",
"Green" => "Zöld",
"Blue" => "Kék",
"Purple" => "Lila",
"Red" => "Piros",
"Orange" => "Narancs",
"Yellow" => "Sárga",
"Let me select my own colors" => "Saját szín",
"Custom foreground color" => "Saját szín",
"Ex:" => "Pld:",
"Custom background color" => "Saját háttérszín",
"Default event status" => "Esemény alapértelmezett státusza",
"Show in calendar view" => "Megjelenítés naptár nézetben",
"Group of users alerted when calendar event is modified" => "Naptári esemény módosításakor értesítendő felhasználói csoport",
"Delete events older than:" => "Ennél régebbi események törlése:",
"Browse the category system" => "Kategóriarendszer böngészése",
"Current category" => "Jelenlegi kategória",
"Current Category ID:" => "Jelenlegi kategória azonosítója:",
"Child categories" => "kategória fa levelei",
"Edit permissions for this category" => "Kategóriához tartozó jogosultságok szerkesztése",
"Create/Edit category" => "Kategória karbantartás",
"Edit this category:" => "Ezen kategória szerkesztése",
"Create New" => "új létrehozása",
"Add new category" => "Új kategória hozzáadása",
"Batch upload" => "Tömeges feltöltés",
"Batch upload (CSV file)" => "Tömeges feltöltés (CSV fájl)",
"Objects in category" => "Kategória objektumai",
"Objects in category:" => "Objektumok ebben a kategóriában:",
"Remove from this Category" => "Eltávolítás ebből a kategóriából",
"No records found." => "Nincs rekord",
"Moving objects between categories" => "Objektumok mozgatása kategóriák között",
"Unassign all objects from this category" => "Összes objektum eltávolítása ebből a kategóriából",
"Move all the objects from this category to this one" => "Összes objektum mozgatása ebből a kategóriából ebbe a kategóriába",
"Assign all objects of this category to this one" => "Kategória összes objektumának hozzárendelése ehhez a kategóriához",
"Add objects to category" => "Elemek hozzáadása a kategóriához",
"Add objects to category:" => "Elemek hozzáadása a kategóriához:",
"Page:" => "Oldal:",
"File gal:" => "Fájlgaléria:",
"Tracker:" => "Űrlap:",
"Admin templates" => "Sablonok adminisztrálása",
"Use the Administration page of each enabled feature to allow the use of content templates." => "A bekapcsolt funkciók saját adminisztrációs oldalán lehet engedélyezni a sablonok használatát",
"Edit this template:" => "Ezen sablon szerkesztése:",
"Create new template" => "Új sablon létrehozása",
"Use in" => "Használat itt",
"CMS" => "Hírek",
"HTML Pages" => "HTML oldalak",
"No features are configured to use templates." => "Egy funkcióhoz sincs beállítva a sablonok használata",
"Text area" => "Szöveges terület",
"Templates" => "Sablonok",
"Admin Contributions" => "Hozzájárulások adminisztrálása",
"Edit the contribution:" => "Hozzájárulás szerkesztése:",
"Contributions are mandatory in wiki pages" => "Hozzájárulások kötelezőek wiki oldalakon",
"Contributions are mandatory in forums" => "Hozzájárulások kötelezőek fórumokban",
"Contributions are mandatory in comments" => "Hozzájárulások kötelezőek kommentekben",
"Contributions are mandatory in blogs" => "Hozzájárulások kötelezőek blogokban",
"Contributions are displayed in the comment/post" => "Hozzájárulások megjelenítésre kerülnek a kommentben/posztban",
"Create a new contribution" => "Új hozzájárulás létrehozása",
"List of contributions" => "Hozzájárulások listája",
"Admin cookies" => "Cookiek adminisztrálása",
"Create/edit cookies" => "Cookie létrehozása/szerkesztése",
"Upload Cookies from textfile" => "Cookie feltöltése szöveges fájlból",
"Upload from disk:" => "Feltöltés lemezről",
"Upload" => "Feltöltés",
"Remove all cookies" => "Minden cookie eltávolítása",
"Creation Date" => "Létrehozás dátuma",
"Expiration Date" => "Lejárat dátuma",
"Restore" => "Visszaállítás",
"all types" => "összes típus",
"filter" => "szűrés",
"Admin DSN" => "DSN adatbáziskapcsolatok beállítása",
"Use Admin DSN to define the database to be used by the SQL plugin." => "DSN (Data Source Name - Adatforrás neve) adatbáziskapcsolatok megadásával lehet megadni az SQL plugin által használt adatbázisokat",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (használjon \$lap kifejezést a lap nevével, mint az alábbi példában: http://www.example.com/tiki-index.php?page=\$page)",
"Admin Forums" => "Fórum karbantartás",
"Create New Forum" => "Új fórum létrehozása",
"Duplicate Forum" => "Fórum duplikálás",
"View this forum" => "Fórum megtekintése",
"Import forums" => "Fórum importálás",
"List forums" => "Fórum lista",
"Coms" => "Kommentek",
"Age" => "Életkor",
"Create/Edit Forums" => "Fórum létrehozása/módosítása",
"Edit this Forum:" => "Fórum szerkesztése:",
"Show description:" => "Leírás megjelenítése:",
"Prevent flooding:" => "Flood megakadályozása:",
"Minimum time between posts:" => "Hozzászólások közti minimum idő:",
"Section:" => "Szekció:",
"Create new" => "Új készítése",
"Moderator user:" => "Moderátor felhasználó:",
"Moderator group:" => "Moderátor csoport:",
"Password protected" => "Jelszóval védett",
"Forum password" => "Fórum jelszó",
"Only allow replies to the first message (flat forum):" => "Csak az első üzenetre küldhető válasz (lapos fórum):",
"Send this forums posts to this email:" => "Fórum hozzászólásainak elküldése az alábbi E-mail címre:",
"Prune unreplied messages after:" => "Válasz nélküli üzenetek eltávolítása ennyi idő után:",
"Prune old messages after:" => "Régi üzenetek eltávolítása ennyi idő után:",
"Topic list configuration" => "Témalista beállítása",
"Last post title" => "Legutóbbi poszt címe",
"Last post avatar" => "Legutóbbi poszt avatárja",
"Author avatar" => "Szerző avatárja",
"Posts can be rated" => "A hozzászólások pontozhatóak",
"Display last post titles" => "Legutóbbi posztok címeinek megjelenítése",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Üzenetek továbbítása erre e fórumra erre az E-mail címre olyan formátumban mely felhasználható visszaküldésre a beérkező fórum E-mail címre",
"Send mails even when the post is generated by inbound mail" => "Levelek küldése ha a hozzászólást beérkező levél generálta",
"Append a reply link to outbound mails" => "Válaszlink hozzáadása a kimenő levelekhez",
"Originating e-mail address for mails from this forum" => "Ezen fórum leveleihez tartozó forrás E-mail cím",
"Add messages from this email to the forum" => "Alábbi E-mail üzeneteket hozzáadása a fórumhoz",
"POP3 server:" => "POP3 szerver:",
"Use topic smileys" => "Mosolyok használata a témákban is legyen engedélyezett",
"Show topic summary" => "Témaösszesítő",
"User information display" => "Felhasználói információs képernyő",
"eMail" => "E-mail",
"Approval type" => "Jóváhagyás típusa",
"Store attachments in:" => "Mellékletek tárolása itt:",
"Path:" => "Útvonal:",
"Max attachment size (bytes):" => "Melléklet maximális mérete (bájt):",
"Shows number of attachments of the all thread in forum list" => "Mellékletek számának megjelenítése a fórum összes témájában",
"Set topics preferences" => "Témapreferenciák beállítása",
"Show topics preferences" => "Témapreferenciák megjelenítése",
"hide topics preferences" => "Témapreferenciák elrejtése",
"Default ordering for topics:" => "Témák rendezésének alapbeállítása:",
"Topics per page:" => "Témák száma laponként:",
"Default number of comments per page:" => "Kommentek alapértelmezett száma oldalanként:",
"Duplicate perms" => "Jogosultságok duplikálása",
"Admin Hotwords" => "Hotword adminisztráció",
"Add Hotword" => "Hotword hozzáadása",
"Word" => "Szó",
"Admin HTML Page Dynamic Zones" => "HTML oldalak dinamikus zónáinak adminisztrálása",
"Admin HTML pages" => "HTML oldalak adminisztrálása",
"Edit this page" => "Szerkesztés",
"View page" => "Oldal megtekintése",
"Edit zone" => "Zóna szerkesztése",
"Content" => "Tartalom",
"Dynamic zones" => "Dinamikus zónák",
"zone" => "zóna",
"content" => "tartalom",
"Mass update" => "Tömeges frissítés",
"Create new HTML page" => "Új HTML oldal létrehozása",
"Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Használjuk a {literal}{ed id=name}{/literal} vagy {literal}{ted id=name}{/literal} formulát dinamikus zónák beszúrásához",
"Edit this HTML page:" => "Ezen HTML oldal szerkesztése:",
"Apply template" => "Sablon alkalmazása",
"Dynamic" => "Dinamikus",
"Static" => "Statikus",
"Refresh rate (if dynamic)" => "Frissítési ráta (ha dinamikus)",
"Last Modif" => "Utolsó módosítás",
"Admin dynamic zones" => "Dinamikus zónák adminisztrálása",
"Cancel Edit" => "Mégse",
"Change preferences" => "Beállítások megváltoztatása",
"Site Ads and Banners" => "Hirdetések és bannerek",
"General" => "Általános",
"Features" => "Funkciók",
"Community" => "Társaság",
"Profiles" => "Profilok",
"Look &amp; Feel" => "Look & Feel",
"Editing and Plugins" => "Szerkesztés és Plugin-ek",
"Meta Tags" => "Meta címkék",
"Performance" => "Teljesítmény",
"Feeds" => "Feed-ek",
"Connect" => "Kapcsolódás",
"User files" => "Felhasználói fájlok",
"Webservices" => "Webes szolgáltatások",
"Video" => "Videó",
"General Settings" => "Általános beállítások",
"To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "Naptárak hozzáadásához/eltávolításához lásd a \"Naptár\" menüpontot az \"Adminisztráció\" menü alatt az alkalmazás menüjében, vagy",
"Change settings" => "Beállítások megváltoztatása",
"General settings" => "Általános beállítások",
"Default calendars to display" => "Alapértelmezésben megjelenített naptárak",
"Create calendar" => "Naptár létrehozása",
"JS calendar" => "JS naptár",
"Browse categories" => "Kategóriák böngészése",
"Administer categories" => "Kategóriák adminisztrálása",
"Plugins" => "Plugin-ok",
"Look under \"Articles\" on the application menu for links to" => "Lásd a \"Cikkek\" menüpontot az alkalmazás fő menüjében, link:",
"Admin topics" => "Témák beállítása",
"Admin types" => "Típusok beállítása",
"Import CSV file" => "CSV fájl importálása",
"File format: title,authorName,heading,body,lang,user" => "Fájlformátum: cím,szerző neve,fejléc,törzs,nyelv,felhasználó,stb",
"Articles Listing" => "Cikkek listázása",
"List Articles" => "Cikk lista",
"Select which items to display when listing articles" => "Cikkek listázásakor megjelenítendő tételek",
"List comments" => "Kommentek listázása",
"General Preferences" => "Általános beállítások",
"Site-wide features" => "Weblap szintű funkciók",
"Display options" => "Opciók megjelenítése",
"Permission" => "Jogosultság",
"Inline comments" => "Szövegbe foglalt kommentek",
"The feature below must be activated for this feature to work." => "alábbi funkciókat be kell kapcsolni hogy ez a funkció működjön",
"Using comments in various features" => "Kommentek használata különböző funkciókban",
"Admin Groups" => "Csoportok adminisztrálása",
"Admin Users" => "Felhasználók adminisztrálása",
"User features" => "Felhasználói funkciók",
"Default user preferences" => "Alapértelmezett felhasználói preferenciák",
"Users Default Preferences" => "Alapértelmezett felhasználói preferenciák",
"User messages" => "Felhasználói üzenetek",
"My Tiki" => "Saját Tikim",
"Select which items to display when listing users" => "Felhasználók listázásakor megjelenítendő tételek kiválasztása",
"Copyright allows to determine a copyright for all the objects of tikiwiki" => "A Szerzői jogok segítségével szerzői jogi megjegyzést lehet fűzni a tikiwiki egyes objektumaihoz",
"Enable copyright management for" => "Szerzői jogok kezelésének bekapcsolása",
"To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "Könyvtár beállításához lásd a \"Könyvtár adminisztrálása\" menüpontot a \"Könyvtár\" menü alatt az alkalmazás menüjében, vagy",
"To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "GYIK-ek hozzáadásához/eltávolításához lásd\"Gyakori kérdések adminisztrálása\" menüpontot a \"Gyakori kérdések\" menü alatt az alkalmazás menüjében, vagy",
"Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site." => "Az <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>egyes funkciók értékelése</a> megtalálható a Tiki fejlesztői weblapján",
"Watches" => "Figyelések",
"Experimental" => "Kísérleti",
"Programmer" => "Programozás",
"Logging and Reporting" => "Loggolás és riportolás",
"Visible to admin only" => "Csak adminisztrátor láthatja",
"Include Smarty notices" => "Tartalmazzon Smarty megjegyzéseket",
"Custom Code" => "Saját kód",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Ha úgy döntünk hogy a fájlokat könyvtárban tároljuk akkor biztosítsuk hogy a felhasználók közvetlenül nem érhetik el az adott könyvtárat",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Ennek megoldására két lehetőség van:<br /><ul><li>Használjunk a dokumentum gyökéren kívűli könyvtárat és biztosítsuk hogy a php szkript olvashatja és írhatja könyvtárat</li><li>Használjunk a dokumentum gyökerén belüli könyvtárat és használjuk .htaccess fájlt annak megakadályozására hogy a felhasználók listázhassák a könyvtár tartalmát</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "A könyvtár útvonalának konfigurálásához használjunk UNIX jellegű útvonalat, például: files/ vagy c:/foo/files vagy /www/files/",
"Enable now" => "Bekapcsolás most",
"Upload Regex" => "Feltöltési Regex",
"Gallery Listings" => "Galéria listázás",
"Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Ezen beállítások megváltoztatása  <em>nincs</em> hatással a létező fájlgalériákra. Ezen változások <em>csak</em> az új galériákra lesznek hatással",
"Select which items to display when listing galleries: " => "Galériák listázásakor megjelenítendő tételek",
"Search Indexing" => "Keresés indexelése",
"MIME Type" => "MIME típus",
"Reindex all files for search" => "Összes fájl újraindexelése kereséshez",
"To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "Fórumok hozzáadásához/eltávolításához lásd a \"Fórumok adminisztrálása\" menüpontot a \"Fórumok\" menüben vagy",
"Threads" => "Threadek",
"Searches" => "Keresések",
"Forums Listing" => "Fórumok listázása",
"Select which items to display when listing forums" => "Fórumok listázásakor megjelenítendő tételek",
"Random tag cloud colors" => "Véletlenszerű címkefelhő színek",
"Separate colors with a comma (,)" => "Színek elválasztása vesszővel (,)",
"Tag Management" => "Címkék kezelése",
"Cleanup unused tags" => "Nem használt címkék kitakarítása",
"Graph appearance" => "Grafika megjelenése",
"Physics engine" => "Fizikai engine",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Képgalériák hozzáadásához /eltávolításához lásd a \"Képgalériák\" menüpontot az alkalmazás fő menüjében, vagy",
"You can upload images of a size of " => "A feltölthető képek maximális mérete ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Ezen érték megváltoztatásához módosítsuk a php.ini-ben található file_uploads, upload_max_filesize, post_max_size és adatbázi változókat (max_allowed_packet mysql esetén)",
"Home Gallery" => "Kezdőgaléria",
"Galleries features" => "Galériák beállításai",
"Uses Slideshow" => "Bemutató használata",
"Use database to store images" => "Adatbázisban tárolja a képeket",
"Use a directory to store images" => "Könyvtárban tárolja a képeket",
"Directory path" => "Könyvtár útvonala",
"Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below." => "Megjegyzés: ha megváltoztatjuk ezt a könyvtárat akkor a tartalmat át kell mozgatni az új könyvtárba. Ehhez használhatjuk a lentebb található 'Mozgató'-t is.",
"Library to use for processing images" => "A képek átalakitásához használt programkönyvtár",
"Uploaded image names must match regex" => "A feltöltött kép nevének egyezni kell a kifejezéssel",
"Uploaded image names cannot match regex" => "A feltöltött kép neve nem egyezhet a kifejezéssel",
"Directory Batch Loading" => "Kötegelt könyvtár feltöltés",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "Ha bekapcsoljuk a Kötegelt könyvtár feltöltést akkor létre kell hoznunk egy weben keresztül olvasható könyvtárat, lehetőleg a webes könyvtárterületen kívűl. Ezután hozzunk létre egy módszert a feltöltés végrehajtására (scp, ftp vagy más protokoll)",
"Enable directory batch loading" => "Kötegelt könyvtár feltöltés engedélyzése",
"Batch loading directory" => "Köteg feltöltési könyvtára",
"Display image information in a mouseover box" => "Képinformációk megjelenítése dobozban mikor az egér a kép felett van",
"yes, and don't display that information under the image" => "Igen, és ezen információk ne a kép alatt jelenjenek meg",
"Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Alapértelmezett maximális sor, képek soronként, előnézet méret és arány használata minden galériánál (értékek beállítása lentebb)",
"Max Rows per page" => "Sorok max száma oldalanként",
"Images per row" => "Soronkénti képek",
"Thumbnails size X" => "Előnézet X mérete",
"Thumbnails size Y" => "Előnézet Y mérete",
"Default scale size" => "Alapértelmezett arány mérete",
"pixels" => "pixel",
"Set features" => "Tulajdonságok beállítása",
"Exterminator" => "Exterminátor",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Wiki oldalak, blog posztok, cikkek által nem használt képek eltávolitása a rendszergalériából",
"Mover" => "Mozgató",
"Move images from database storage to filesystem storage" => "Képek mozgatása adatbázisból fájlrendszerbe",
"Move images from filesystem storage to database storage" => "Képek mozgatása fájlrendszerből adatbázisba",
"All galleries" => "Összes galéria",
"System Gallery" => "Rendszergaléria",
"Move images from old filesystem store to new directory" => "Képek mozgatása régi fájlrendszerbeli helyről új fájlrendszerbeli helyre",
"Moved" => "Mozgatásra került",
"Gallery listing configuration" => "Galériák listázásának beállítása",
"Change configuration" => "Beállítások megváltoztatása",
"Image galleries comments settings" => "Képgalériák kommentjeinek beállítása",
"Release Check" => "Kiadási verzió ellenőrzése",
"Reset or upgrade your database" => "Adatbázis visszaállítása vagy frissítése",
"Check for updates now" => "Frissítések keresése most",
"Site Identity" => "Weblap identitás",
"These values will be stored in plain text in the database." => "Ezen értékek sima szövegként kerülnek letárolásra az adatbázisba",
"Email to send a test mail" => "Teszt E-mail küldése",
"Server" => "Szerver",
"Contact" => "Kontakt",
"Miscellaneous" => "Egyéb",
"Create and edit menus " => "Menük létrehozása és szerkesztése",
"Home Page" => "Főoldal",
"Site Access" => "Weblap hozzáférés",
"Sample:" => "Minta:",
"Date and Time Format Help" => "Dátum és idő formátum segítség",
"Change admin password" => "Admin jelszó megváltoztatása",
"User administration" => "Felhasználók adminisztrálása",
"Defaults" => "Alapértelmezések",
"Internationalization" => "i18n",
"Edit or export/import Languages" => "Nyelvek szerkesztése/exportálása/importálása",
"Babelfish links" => "Babelfish linkek",
"Customized String Translation" => "Egyéni fordítások",
"Intertiki client" => "Intertiki kliens",
"Tiki Unique key" => "Tiki egyedi kulcs",
"InterTiki Slave mode" => "InterTiki Slave mód",
"Warning: overrides manually registered local users" => "Figyelmeztetés: felülírja a manuálisan regisztrált felhasználókat",
"as master" => "master-ként",
"Import user preferences" => "Felhasználói preferenciák importálása",
"Import user groups" => "Felhasználói csoportok importálása",
"Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Csoport importálás szűkítése (vesszővel elválasztott lista az importált csoportokról, hagyjuk üresen ha nem akarunk szűkíteni)",
"Intertiki shared cookie for sliding auth under same domain" => "Intertiki megosztott cookie azonosítás átengedéséhez ugyanazon domain alatt",
"InterTiki Server" => "InterTiki szerver",
"host" => "hoszt",
"Add new server" => "Új szerver hozzáadása",
"Intertiki server" => "Intertiki szerver",
"Intertiki Server enabled" => "Intertiki szerver bekapcsolva",
"Access Log file" => "Hozzáférés log fájl",
"Errors Log file" => "Hiba log fájl",
"Known hosts" => "Ismert hosztok",
"Key" => "Kulcs",
"Enable/disable Tiki features in " => "Tiki funkciók bekapcsolása/kikapcsolása itt végezhető el:",
", but configure them elsewhere" => " (az egyes funkciók konfigurálását máshol kell elvégezni)",
"Look & Feel" => "Stílus",
"Registration" => "Regisztráció",
"Shibboleth Authentication " => "Shibboleth autentikáció",
"Theme not saved yet - click \"Apply\"" => "A stílus még nincs elmentve - kattintani kell az \"Alkalmazás\" gombra",
"Restrict available themes" => "Rendelkezésre álló stílusok korlátozása",
"View Templates" => "Sablonok megtekintése",
"General Layout options" => "Általános szerkezet beállításai",
"Site Report Bar" => "Weblap riport sor",
"Pagination links" => "Oldalléptetési linkek",
"UI Effects" => "UI effektusok",
"Standard UI effects" => "Sztenderd UI effektusok",
"Tab UI effects" => "Fülek UI effektusai",
"Admin layout per section" => "Kinézet adminisztrálása szekciónként",
"Currently used in File Galleries only" => "Jelenleg csak Fájlgalériákban használt",
"Separators" => "Szeparátorok",
"Examples" => "Példák",
"Generate User Map" => "Felhasználói térkép generálása",
"Meta tags" => "Meta címkék",
"Robots" => "Robotok",
"&quot;Modules&quot; are the boxes of content in the right &amp; left columns" => "&quot;Modulok&quot; a bal &amp; jobb oldali oszlopokban látható, különböző tartalmat megjelenítő dobozok",
"Admin &gt; Modules" => "Adminisztráció &gt; Modulok",
"from the menu to create and edit modules" => "menüt modulok létrehozására és szerkesztésére",
"Compression is handled by" => "Tömörítés kezelője",
"Memory" => "Memória",
"Low hit ratio. %0 may be misconfigured and not used." => "Low hit ratio. APC may be misconfigured and not used.",
"Small amount of memory allocated to %0. Verify the configuration." => "Small amount of memory allocated to APC. Verify the configuration.",
"Major slow down" => "Jelentős lassulás",
"Sessions" => "Munkamenetek",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Szavazások hozzáadásához/eltávolításához lásd a \"Szavazások\" menüpontot az \"Adminisztráció\" menü alatt az alkalmazás menüjében, vagy",
"Waiting" => "Várakozó",
"Profile" => "Profil",
"Repository" => "Gyűjtemény",
"Profile repository" => "Profil gyűjtemény",
"Last update" => "Legutóbbi frissítés",
"Repositories" => "Gyűjtemények",
"Enter multiple repository URLs, one per line" => "Több gyűjtemény URL megadása, soronként egy",
"Data Channels" => "Adat csatornák",
"Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. " => "Adatcsatornák nevesített csatornát hoznak létre profilok futtatásához a felhasználói felületről. Egy csatornát adjunk meg soronként. Minden sor vesszővel elválasztott és tartalmazza a következőket: <strong>csatorna neve, domain, profil, engedélyezett csoportok</strong>. ",
"More information" => "További információ",
"Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or" => "Ezen az oldalon a Tiki által generált feed-ek beállítása végezhető el. Más oldalakról származó feed-ek szindikálásához lásd az  <strong>Adminisztráció</strong> > <strong>Külső feed-ek</strong> menüpontot, vagy",
"External feeds" => "Külső feed-ek",
"Specification" => "Specifikáció",
"Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public." => "Cache-elés engedélyezése felülírja a meglévő jogosultságokat - az összes tartalom publikus lesz.  <strong>Csak</strong> akkor aktiváljuk ezt az opciót ha szeretnénk hogy a szindikált tartalom publikus legyen.",
"You can see users rank by score in the module users_rank, for that go to" => "A felhasználók pontszámon alapuló rangsorát a users_rank modulban lehet megtekinteni itt",
"Expiration" => "Lejárat",
"can be seen on page" => "megtekinthető a",
"in Admin menu" => "menüpont alatt az Adminisztráció menüben",
"Search type" => "Keresés típusa",
"Specify the Tiki search settings" => "Tiki keresés beállításainak megadása",
"Refresh all search index now" => "Összes keresési index frissítése most",
"Refresh wiki search index now" => "Wiki keresési index frissítése most",
"Refresh trackers search index now" => "Űrlap keresési index frissítése most",
"Refresh tracker search index now" => "Űrlap keresési index frissítése most",
"Refresh files search index now" => "Fájl keresési index frissítése most",
"Enabling these options will improve performance, but may show forbidden results" => "Ezen opciók bekapcsolása javítja a teljesítményt de mutathat tiltott (jogosultságot figylembe nem vevő) eredményeket is",
"Search Results" => "Keresési eredmények",
"Select the items to display on the search results page" => "Találatokat soroló oldalakon megjelenítendő tételek kiválasztása",
"Select the information to display for each result" => "Minden egyes találatnál megjelenítendő információk kiválasztása",
"CSRF Security" => "CSRF biztonság",
"Search results" => "Keresés eredménye",
"Known Types" => "Ismert típusok",
"Show Usage" => "Használat megjelenítése",
"Delete &amp; Unreference" => "Törlés &amp; Hivatkozás visszavonása",
"Invert Relation" => "Kapcsolat megfordítása",
"New Types" => "Új típusok",
"Fix" => "Javítás",
"Activate the feature" => "Funkció bekapcsolása",
"Text area (that apply throughout many features)" => "Szöveges terület beállításait több funkció is használja",
"Default size" => "Alapértelmezett nézet",
"External links and images" => "Külső linkek és képek",
"External links will be identified with" => "Külső linkek azonosítója",
"Edit plugin icons" => "Plugin szerkesztés ikonok",
"Enable" => "Bekapcsolás",
"Plugin Aliases" => "Plugin álnevek",
"About plugin aliases" => "Plugin álnevekről",
"Available Alias" => "Rendelkezésre álló alias",
"Enable Plugins" => "Pluginok bekapcsolása",
"General Information" => "Általános információ",
"Plugin Name" => "Plugin neve",
"Base Plugin" => "Alap plugin",
"Body Label" => "Törzs címke",
"Dependencies" => "Függőségek",
"Inline (No Plugin Edit UI)" => "Szövegben (nincs plugin szerkesztési felület)",
"Simple Plugin Arguments" => "Egyszerű plugin argumentumok",
"New Argument" => "Új argumentum",
"Plugin Parameter Documentation" => "Plugin paraméter dokumentáció",
"Required" => "Szükséges",
"Safe" => "Biztonságos",
"Plugin Body" => "Plugin törzs",
"Ignore User Input" => "Felhasználói bevitel ignorálása",
"Default Content" => "Alapértelmezett tartalom",
"Parameters" => "Paraméterek",
"Encoding" => "Kódolás",
"Default Value" => "Alapértelmezett érték",
"Composed Plugin Arguments" => "Szerkesztett plugin argumentumok",
"Pattern" => "Minta",
"To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or" => "Űrlapok beállításához lásd az \"Űrlapok adminisztrálása\" menüpontot az \"Űrlapok\" menü alatt az alkalmazás fő menüjében, vagy",
"Tracker attachment preferences" => "Űrlap mellékletek beállítása",
"Use database to store files" => "Adatbázis használata a fájlok tárolásához",
"Use a directory to store files" => "Könyvtár használata a fájlok tárolásához",
"Tracker attachments" => "Űrlap mellékletek",
"dls" => "Letöltések",
"No records" => "Nincsenek rekordok",
"Change all to db" => "Összes átváltása adatbázisba",
"Change all to file" => "Összes átváltása fájlba",
"Quota (Mb)" => "Limit (Mb)",
"Use database to store userfiles" => "Adatbázis használata a felhasználói fájlok tárolásához",
"Use a directory to store userfiles" => "Könyvtár használata a felhasználói fájlok tárolásához",
"Kaltura Registration" => "Kaltura regisztráció",
"List Media Entries" => "Média tételek listája",
"List Remix Entries" => "Remix tételek listája",
"Add New Media" => "Új média hozzáadása",
"Kaltura / Tiki config" => "Kaltura / Tiki configuráció",
"Kaltura Dynamic Player" => "Kaltura Dinamikus lejátszó",
"Kaltura Remix Editors" => "Kaltura Remix szerkesztők",
"Watershed Wiki plugins" => "Watershed Wiki pluginok",
"Archive settings" => "Archívum beállításai",
"Flash Media Encoder" => "Flash Média Encoder",
"Lookup" => "Keresés",
"Register Service" => "Szolgáltatás regisztrálása",
"Registered Templates" => "Regisztrált sablonok",
"Output" => "Kimenet",
"Register Template" => "Sablon regisztrálása",
"Page display" => "Oldal megjelenítés",
"Page version" => "Oldal verzió",
"List authors" => "Szerzők listázása",
"Allow override per page" => "Oldalanként változtatható",
"Minor edits do not flag new content for translation and do not send watch notifications (unless \"Watch minor edits\" is enabled)." => "Kisebb szerkesztések nem számítanak lefordítandó új tartalomnak és értesítés sem kerül kiküldésre (kivéve ha az erre vonatkozó preferencia be van állítva)",
"Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled." => "Csak a tiki_p_minor jogosultsággal rendelkező csoportok és az adminisztrátorok végezhetnek kisebb mentéseket a funkció bekapcsolásakor.",
"Manage attachments" => "Mellékletek kezelése",
"Tag for current wiki" => "Címke a jelenlegi wikihez",
"Restore wiki to tag" => "Wiki címke visszaállítása",
"Remove a tag" => "Címke eltávolítása",
"Generate dump" => "Dump generálása",
"Download last dump" => "Legutóbbi dump letöltése",
"Remove unused pictures" => "Nem használt képek eltávolítása",
"Export Wiki Pages" => "Wiki oldalak exportálása",
"Wiki watch" => "Wiki figyelés",
"Staging &amp; Approval" => "Előkészítés & Jóváhagyás",
"Freetags are disabled." => "Címke funkció ki van kapcsolva",
"Page Listings" => "Oldalak listázása",
"Configuration" => "Konfiguráció",
"Select which items to display when listing pages" => "Oldalak listázásakor megjelenítendő tételek kiválasztása",
"Tools" => "Eszközök",
"Wiki attachments" => "Wiki mellékletek",
"Wysiwyg Editor Features" => "WYSIWYG szerkesztő funkciói",
"Start page" => "Kezdő oldal",
"CSS File" => "CSS fájl",
"Clear cache" => "Cache ürítése",
"New Rule" => "Új szabály",
"Copy Rules" => "Szabályok másolása",
"Copy" => "Másolás",
"Configure/Options" => "Konfigurálás",
"No pages found" => "Nincs megfelelő lap",
"Admin layout" => "Kinézet adminisztrálása",
"Theme control" => "Stílusvezérlés",
"layout options" => "kinézet beállítások",
"Right column" => "Jobb oszlop",
"Top bar" => "Felső sáv",
"Generate positions by hits" => "A helyeket a találatok alapján alakítsa ki",
"List of featured links" => "Kiemelt linkek listáa",
"Position" => "Pozíció",
"Add Featured Link" => "Kiemelt link hozzáadása",
"Edit this Featured Link:" => "Ezen kiemelt link szerkesztése:",
"Create new Featured Link" => "Új kiemelt link készítése",
"disables the link" => "link letiltása",
"Link type" => "Link típusa",
"replace current page" => "A jelenlegi lap lecserélése",
"framed" => "frame-ben",
"open new window" => "új ablak nyitása",
"Mail-in accounts" => "Bejövő levelezési fiókok",
"Account" => "Fiók",
"Add new Mail-in account" => "Bejövő levelezési fiók hozzáadása",
"Edit Mail-in account" => "Bejövő levelezési fiók szerkesztése",
"Account name" => "Postaláda neve",
"POP server" => "POP szerver",
"SMTP server" => "SMTP szerver",
"SMTP requires authentication" => "SMTP felhasználóazonosítást igényel",
"article-put" => "cikk-put",
"wiki-get" => "wiki-leszed",
"wiki-put" => "wiki-felrak",
"wiki-append" => "wiki-hozzáfűz",
"Article Topic" => "Cikk téma",
"Admin Topics" => "Témák beállítása",
"Article Type" => "Cikk típus",
"Admin Types" => "Típusok beállítása",
"Active" => "Aktív",
"Allow anonymous access" => "Anonymus hozzáférés engedélyezése",
"Allow attachments" => "Mellékletek engedélyezése",
"Check Mail-in accounts" => "Bejövő levelezési fiókok ellenőrzése",
"Check automatically" => "Automatikus ellenőrzés",
"Frequency" => "Gyakoriság",
"Admin Menu:" => "Menü adminisztrálása:",
"List menus" => "Menük listája",
"Edit this menu" => "Szerkesztés",
"Edit menu options" => "Menü beállításainak szerkesztése",
"Show Quick Urls" => "Gyors URL-ek megjelenítése",
"Some useful URLs" => "Néhány hasznos URL",
"Hide Quick Urls" => "Gyors URL-ek elrejtése",
"For wiki page, use ((PageName))." => "Wiki oldalhoz használjuk az ((OldalNév)) szintakszist.",
"Sections:" => "Szekciók:",
"Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR." => "Több szekció esetén: a szekciókat vesszővel ( , ) válasszuk el AND (ÉS) jellegű logikai kapcsolathoz, OR (VAGY) jellegű logikai kapcsolathoz pedig használjunk függőleges elválasztót ( | ).",
"Permissions:" => "Jogosultságok:",
"Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR." => "Több jogosultság esetén: a jogosultságokat vesszővel ( , ) válasszuk el AND (ÉS) jellegű logikai kapcsolathoz, OR (VAGY) jellegű logikai kapcsolathoz pedig használjunk függőleges elválasztót ( | ).",
"Type:" => "Típus:",
"option" => "opció",
"section level 0" => "szekció szint 0",
"section level 1" => "szekció szint 1",
"section level 2" => "szekció szint 2",
"section level 3" => "szekció szint 3",
"sorted section level 0" => "rendezett szekció, szint 0",
"separator" => "szeparátor",
"Position:" => "Pozíció:",
"Icon:" => "Ikon",
"Home:" => "Főoldal:",
"Choose" => "Kiválasztás",
"Home Blog" => "Kezdőblog",
"Home Image Gal" => "Fő képgaléria",
"Home Image Gallery" => "Fő képgaléria",
"Home File Gal" => "Fő fájlgaléria",
"Home File Gallery" => "Fő fájlgaléria",
"General:" => "Általános:",
"User preferences" => "Felhasználói beállítások",
"User prefs" => "Felhasználói beáll.",
"List galleries" => "Galériák listázása",
"List image galleries" => "Képgalériák listázása",
"Upload image" => "Kép feltöltése",
"Gallery Rankings" => "Galéria rangok",
"Browse a gallery" => "Galéria böngészése",
"Articles home" => "Cikkek főoldala",
"All articles" => "összes cikk",
"Submit" => "Elküld",
"List Blogs" => "Blog lista",
"Create Blog" => "Blog létrehozása",
"Files:" => "Fájlok:",
"View a forum" => "Fórum megtekintése",
"View a thread" => "Egy fórumtéma megtekintése",
"View a FAQ" => "Gyakori kérdések megtekintése",
"Take a quiz" => "Kvíz kitöltése",
"Quiz stats" => "Kvízek statisztikái",
"Stats for a Quiz" => "Statisztikák a kvízekhez",
"Preview menu" => "Menü előnézet",
"Menu options" => "Menü opciók",
"Groups:" => "Csoportok:",
"Export CSV data" => "CSV adat exportálása",
"Import CSV data" => "CSV adat importálása",
"To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'." => "Új menüopció hozzáadásához az optionId mezőt 0-ra kell állítani. Opció eltávolításához a mező eltávolítása mezőnek 'y' értéket kell adni.",
"File:" => "Fájl:",
"Options" => "Opciók",
"Create/Edit Menu" => "Menü létrehozása/szerkesztése",
"Edit this Menu:" => "Ezen menü szerkesztése:",
"Create new Menu" => "Új menü készítése",
"dynamic collapsed" => "dinamikus összezárt",
"dynamic extended" => "dinamikus nyitott",
"fixed" => "rögzített",
"Icons:" => "Ikonok:",
"Folder Icon" => "Mappa ikon",
"Path and filename of closed folder icon" => "A bezárt mappa ikonjának útvonala és fájlneve",
"In the same directory, include an icon for the opened folder." => "Ugyanabban a könyvtárban adjunk meg egy ikont a kinyitott mappához.",
"For example, the default icon is: pics/icons/folder.png" => "Például ha az alapértelmezett ikon: pics/icons/folder.png",
"The name of the \"open folder\" icon is: pics/icons/ofolder.png" => "Akkor a \"kinyitott mappa\" ikonja: pics/icons/ofolder.png",
"To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes:" => "<a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">Phplayersmenu</a> használatához az alábbi három szintakszis egyikét lehet használni:",
"This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tiki.org\">themes</a>" => "Ez a kiválasztott stílustól függően jól vagy kevésbé jól fog működni. Stílusokról bővebben <a target=\"tikihelp\" href=\"http://themes.tiki.org\">itt</a>",
"To use a menu in a tiki format:" => "Menü használata tiki formátumban:",
"To use menu in a css/suckerfish format:" => "Menü használata css/suckerfish formátumban: ",
"To customize the menu's CSS id (#):" => "Menü CSS id-jának testreszabása:",
"View template" => "Sablon megtekintése",
"Clear Cache" => "Gyorsítótár kiürítése",
"Assign/Edit modules" => "Modul karbantartás",
"Assigned Modules" => "Hozzárendelt modulok",
"Left Modules" => "Bal modulok",
"Right Modules" => "Jobb modulok",
"Assign new module" => "Új modul hozzárendelése",
"Edit this assigned module:" => "Ezen hozzárendelt modult szerkesztése:",
"Cache Time" => "Gyorsítótár idő",
"required" => "szükséges",
"Module Options" => "Modul opciók",
"User Modules" => "Felhasználói modulok",
"Create new user module" => "Új felhasználói modul készítése",
"Edit this user module:" => "Ezen felhasználói modul szerkesztése:",
"Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site." => "Saját modult itt hozhatunk létre. Tekintsük meg előnézetben és bizonyosodjunk meg arról hogy nincs benne hiba mielőtt <a href=\"#assign\">hozzárendelnénk</a>. HTML-t használva elkerülhetőek a problémák, de wiki szintakszis vagy Smarty kód helytelen használata során akár még az oldalról is kizárhatjuk magunkat (ilyenkor 'hátulról', azaz az adatbázis közvetlen módosításán keresztül lehet csak visszajutni.) Szóval csak óvatosan.",
"Must be wiki parsed" => "Wiki által elemzettnek kell lennie",
"Objects that can be included" => "Felhasználható objektumok",
"Use Poll" => "Szavazás használata",
"Use Gallery" => "Galéria használata",
"Use Dynamic Content" => "Dinamikus tartalom használata",
"Use RSS Module" => "Rss modul használata",
"Default Tiki menus:" => "Alapértelmezett Tiki menük:",
"Use Menu" => "Menü használata",
"CSS menus:" => "CSS menük:",
"Use Banner Zone" => "Banner zónák használata",
"Structures:" => "Struktúrák:",
"To use a default Tiki menu:" => "Alapértelmezett Tiki menü használatához:",
"Data" => "Adat",
"Admin newsletter subscriptions" => "Hírlevél előfizetések adminisztrálása",
"List Newsletters" => "Hírlevél lista",
"Admin Newsletters" => "Hírlevél karbantartás",
"Send Newsletters" => "Hírlevél küldés",
"Subscriptions" => "Előfizetések",
"Subscribed" => "Feliratkozva",
"You can add several email addresses by separating them with commas." => "Több E-mail cím is megadható vesszővel elválasztva",
"Group subscription also subscribes included groups" => "Csoportos előfizetés a kiválasztott csoportokat is tartalmazza",
"Don't send confirmation mail" => "Ne küldjön megerősítési E-mailt",
"The user email will be refreshed at each newsletter sending" => "A felhasználói E-mail az egyes kiküldések alkalmával kerül frissítésre",
"txt file, one e-mail per line" => "txt fájl, egy E-mail soronként",
"Subscribe group" => "Csoport feliratkozása",
"Export Subscriber Emails" => "Feliratkozók E-mail címének exportálása",
"Admin newsletters" => "Hírlevél karbantartás",
"Create Newsletter" => "Hírlevél létrehozás",
"Editions" => "Kiadások",
"Drafts" => "Piszkozatok",
"Last Sent" => "Legutóbbi küldés",
"Create/Edit Newsletters" => "Hírlevél létrehozás/szerkesztés",
"There are individual permissions set for this newsletter" => "Ennél a hírlevélnél egyéni jogosultságok vannak beállítva",
"Users can subscribe/unsubscribe to this list" => "A listára a felhasználók fel/leiratkozhatnak",
"Users can subscribe any email address" => "A felhasználók bármely E-mail címre feliratkozhatnak",
"Add unsubscribe instructions to each newsletter" => "Leiratkozási instrukciók hozzáadása minden egyes hírlevélhez",
"Validate email addresses" => "E-mail címek validálása",
"Allow customized text message to be sent with the html version" => "Testreszabott szöveges üzenet küldésének engedélyezése a HTML verzióval",
"Allow clipping of articles into newsletter" => "Cikkek beillesztésének engedélyezése hírlevélbe",
"Automatically clip articles into newsletter" => "Cikkek automatikus beillesztése hírlevélbe",
"Clip articles published in the past number of days" => "Az elmúlt napokban publikált cikkek beillesztése",
"Article types to clip" => "Csatolandó cikk típusok",
"Mail notifications" => "E-mailes értesítések",
"You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications." => "Be kell állítani a <a href=\"tiki-admin.php?page=general\">Küldési E-mail címet</a> az E-mailes értesítések létrehozása előtt",
"Add notification" => "Értesítés hozzáadása",
"Alert" => "Riasztás",
"Event:" => "Esemény:",
"Preload Admin Account" => "Adminisztrátori fiók betöltése",
"Event" => "Esemény",
"User / Group" => "Felhasználó / Csoport",
"List polls" => "Szavazások listázása",
"Edit this poll" => "Ezen szavazást szerkesztése",
"Preview poll" => "Szavazás előnézet",
"Poll options" => "Szavazás opciók",
"Votes" => "szavazatok",
"Admin Polls" => "Szavazások adminisztrálása",
"Set last poll as current" => "Az utolsó szavazás jelenlegivé tétele",
"Close all polls but last" => "Minden szavazás bezárása az utolsó kivételével",
"Activate all polls" => "Minden szavazás aktiválása",
"Create poll" => "Kérdőív létrehozása",
"Edit poll" => "Kérdőív szerkesztése",
"active" => "aktív",
"current" => "jelenlegi",
"object" => "objektum",
"Add Option" => "Opció hozzáadása",
"PublishDate" => "Publikálás dátuma",
"0 for no limit" => "0 ha nincs szükség határra",
"Objects" => "Objektumok",
"Results" => "Eredmények",
"Add poll to pages" => "Kérdőív hozzáadása oldalakhoz",
"Wiki pages" => "Wiki oldalak",
"Lock the pages" => "Oldalak zárolása",
"Admin External Feeds" => "Külső feed-ek adminisztrálása",
"Tips" => "Tippek",
"This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "Ezen az oldalon a Tiki által beolvasott/importált külső feed-ek beállítását lehet elvégezni. Feed-ek generálása/exportálása az Adminisztrációs Központ oldalán található Feed-ek pont alatt végezhető el, gyors linkhez",
"Content for the feed" => "Az adatfolyam tartalma",
"Article Generator" => "Cikk generátor",
"Create new external feed" => "Új külső feed létrehozása",
"Refresh rate:" => "Frissítés gyakorisága:",
"show feed title:" => "Feed címének megjelenítése:",
"show publish date:" => "Publikálás dátumának megjelenítése:",
"Show Title?" => "Cím megjelenítése?",
"Show Date?" => "Dátum megjelenítése?",
"View feed" => "Feed megtekintése",
"Security Admin" => "Biztonsági beállítások",
"To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>." => "<a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">Biztonsággal kapcsolatos események jelentése itt</a>",
"PHP settings" => "PHP beállítások",
"PHP variable" => "PHP változó",
"Risk Factor" => "Kockázati faktor",
"Explanation" => "Magyarázat",
"Tiki variable" => "Tiki változó",
"Security checks" => "Biztonsági ellenőrzések",
"Check all tiki files" => "Összes tiki fájl ellenőrzése",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Ez a művelet nagyon sokáig eltarthat, érdemes előtte ellenőrizni a max_execution_time beállítást a php.ini-ben",
"File checks" => "Fájlok ellenőrzése",
"Check file permissions" => "Fájl jogosultságok ellenőrzése",
"This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments." => "Ez az ellenőrzés igyekszik megtalálni a problematikusnak tűno jogosultsági beállításokkal rendelkező fájlokat. Megeshet hogy az itt problematikusnak feltüntetett fájlhoz kötodő jogosultságok bizonyos környezetekben nem számítanak problematikusnak vagy éppen elkerülhetetlenek (mivel abban a környezetben nem változtathatóak).",
"See end of table for detailed explanations." => "A tábla végén részletes magyarázat található",
"type" => "típus",
"owner" => "tulajdonos",
"special" => "speciális",
"user" => "felhasználó",
"group" => "csoport",
"other" => "egyéb",
"sticky" => "ragadós",
"Admin Shoutbox Words" => "Az üzenőfal szóhasználatának beállításai",
"Add Banned Word" => "Tiltott szó hozzáadása",
"The structure" => "A struktúra",
"has just been created." => "létrejött",
"You will remove structure" => "A struktúra eltávolításra kerül",
"Destroy the structure leaving the wiki pages" => "A struktúra megsemmisítése meghagyva a wiki lapokat",
"Destroy the structure and remove the pages" => "A struktúra megsemmisítése és a lapok eltávolítása",
"Edit structure" => "Struktúra szerkesztése",
"View structure" => "Struktúra megtekintése",
"Export Pages" => "Oldalak exportálása",
"Dump Tree" => "Struktúra kimentése",
"Create WebHelp" => "Websúgó létrehozása",
"View WebHelp" => "Websúgó megjelenítése",
"Perform action with checked" => "Akció végrehajtása a kijelöltekkel",
"Alias" => "Megjelenített neve",
"Tree" => "Fa",
"Use single spaces to indent structure levels" => "Szóköz használatával lehetséges a struktúra szintjeinek megadása",
"Create New Structure" => "Új struktúra létrehozása",
"Edit survey questions:" => "Kérdőív kérdések szerkesztése:",
"Add a New Question" => "Új kérdés hozzáadása",
"List surveys" => "Kérdőív lista",
"Survey Stats" => "Kérdőív statisztika",
"This survey stats" => "Ezen kérdőív statisztikája",
"Edit this Survey" => "Kérdőív szerkesztése",
"Admin Surveys" => "Kérdőív karbantartás",
"Add a New Question to this survey" => "Kérdés hozzáadása a kérdőívhez",
"Question" => "Kérdés",
"One choice" => "Egy válasz",
"Multiple choices" => "Több válasz",
"Multiple choices of thumbnails from a file gallery" => "Több előnézeti kép kiválasztása fájlgalériából",
"Short text" => "Rövid szöveg",
"Wiki textarea" => "Wiki szöveges terület",
"Rate (1..5)" => "Súlyozás (1..5)",
"Rate (1..10)" => "Súlyozás (1..10)",
"Answer is mandatory:" => "Kötelező válasz",
"Number of required answers (for multiple choices):" => "Szükséges válaszok száma (többszörös választás esetén):",
"For a rate, you can give the maximum value." => "Értékelés maximális értéke",
"For the 'wiki textarea' type, options are: rows,columns. Example: 10,60" => "A 'wiki szövegterület' típushoz, opciók: sor, oszlop. Például: 10,60",
"Options (if apply)" => "Beállítások (ha szükséges)",
"Questions" => "Kérdések",
"Admin surveys" => "Kérdőívek adminisztrálása",
"List Surveys" => "Kérdőív lista",
"Create Survey" => "Kérdőív létrehozása",
"Create/Edit Surveys" => "Kérdőív létrehozása / szerkesztése",
"Edit this Survey:" => "Ezt a kérdőívet szerkeszd:",
"Create New Survey" => "Új kérdőív létrehozása",
"There are individual permissions set for this survey" => "Ehhez a kérdőívhez egyéni jogosultságok vannak beállítva",
"Tiki Cache/System Admin" => "Cache/rendszer",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "Ürítsük ki a cache-t ha a Tiki furcsán kezd viselkedni. Nagyon fontos a cache törlése (ha kell FTP/SSH segítségével) rendszerfrissítés (upgrade) után is",
"Exterminator of cached content" => "Cache ürítése",
"Directory to exterminate" => "Kiürítendő könyvtárak",
"Empty" => "Kiürítés",
"Directories to save" => "Mentendő könyvtárak",
"Generate a zip of those directories" => "Zip fájl generálása könyvtárakból",
"A zip has been written to {\$zipPath}" => "A zip fájl kiírásra került ide: {\$zipPath}",
"Directory is not writeable" => "A könyvtár nem írható",
"View mode" => "Megtekintési mód",
"Wiki and WYSIWYG" => "Wiki és WYSIWYG",
"Wiki only" => "Csak Wiki",
"WYSIWYG only" => "Csak WYSIWYG",
"Load" => "Betöltés",
"Auto Reloading" => "Automatikus újratöltés",
"Row" => "Sor",
"Formatting Tools:" => "Formázó eszközök:",
"Plugin Tools:" => "Plugin eszközök:",
"Custom Tools:" => "Saját eszközök:",
"To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save." => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br /> Drag icons back from the toolbar rows onto the full list to remove them.<br /> Icons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br /> To save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save.",
"Delete all custom tools" => "Összes saját eszköz törlése",
"Warning: There is no undo!" => "Figyelem: Nem lehet visszaállítani!",
"Create a new topic" => "Új téma létrehozása",
"Topic Name" => "Téma neve",
"Upload Image" => "Kép feltöltése",
"List of topics" => "Témák listája",
"topic image" => "téma kép",
"Inactive - Click to Activate" => "Inaktív - Klikk az aktiváláshoz",
"Deactivate" => "Deaktiválás",
"Active - Click to Deactivate" => "Aktív - Klikk a deaktiváláshoz",
"Remove with articles" => "Eltávolítás cikkekkel együtt",
"List Trackers" => "Űrlap lista",
"Admin Trackers" => "Űrlap karbantartás",
"Edit This Tracker" => "Ezen űrlap szerkesztése",
"View This Tracker's Items" => "Ezen űrlap tételeinek megtekintése",
"Tracker fields" => "Űrlapmezők",
"Pos" => "Pozíció",
"Is column visible when listing tracker items?" => "Oszlop látható űrlaptételek listázásakor?",
"Column links to edit/view item?" => "Oszlop linkel a tétel szerkesztéséhez/megtekintéséhez?",
"Main" => "Fő funkciók",
"Field is public? (viewed in trackerlist plugin)" => "Mező publikus? (űrlaplistázó plugin megtekintésekor)",
"Hidden" => "Rejtett",
"Mandatory" => "Kötelező",
"Searchable" => "Kereshető",
"New tracker field" => "Új űrlap mező",
"Edit tracker field" => "Űrlapmező szerkesztése",
"Field is mandatory?" => "Mező kötelező?",
"Multilingual content" => "Többnyelvű tartalom",
"Column is searchable?" => "Kereshető oszlop?",
"Field is hidden?" => "Mező rejtett?",
"not hidden" => "nem rejtett",
"visible to admin only" => "csak adminisztrátor számára látható",
"editable by admin only" => "csak adminisztrátor szerkesztheti",
"visible by creator &amp; admin only" => "létrehozó &amp; adminisztrátor láthatja csak",
"The option creator needs a field of type user selector and option 1" => "A opció létrehozásánál kell hogy legyen egy 'felhasználó kiválasztása' típus 1-es opcióval",
"Visible by:" => "Láthatja:",
"Editable by:" => "Szerkesztheti:",
"Error message:" => "Hibaüzenet:",
"Import/Export Trackers Fields" => "Űrlapmezők importálása/exportálása",
"Export fieldId also" => "Mező ID-t is exportálja",
"Edit This Tracker's Fields" => "Ezen űrlap mezőinek szerkesztése",
"Found" => "Találat",
"trackers" => "űrlapok",
"Items" => "Tétel",
"Edit Tracker" => "Űrlap szerkesztése",
"Create Tracker" => "Űrlap létrehozása",
"Create/Edit Tracker" => "Űrlap létrehozása/szerkesztése",
"Auto create corresponding categories" => "Vonatkozó kategóriák automatikus létrehozása",
"Show status" => "Státusz megjelenítése",
"Default status displayed in list mode" => "Alapértelmezett státusz megjelenítése listázási nézetben",
"Show status to tracker admin only" => "Státusz megjelenítése csak az űrlap adminisztrátora számára",
"Send copies of all activity in this tracker to this e-mail address" => "Az űrlappal kapcsolatos összes tevékenység másolatának elküldése erre az E-mail címre",
"Use simplified e-mail format" => "Egyszerűsített E-mail formátum használata",
"The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "Az űrlap a Tárgy mező tartalmát fogja használni a tárgy megadásához, valamint a felhasználó E-mail címét vagy anonim küldő esetén az E-mail mező tartalmát a küldő megadásához",
"New items are created with status" => "Új tételek ebben a státuszban jöjjenek létre:",
"Authoritative status for modified items" => "Módosított tételek jóváhagyási státusza",
"No change" => "Nincs változás",
"Item creator can modify his items?" => "Tétel létrehozója módosíthatja saját tételeit?",
"The tracker needs a user field with the option 1" => "Az űrlaphoz szükséges egy felhasználói mező 1-es opcióval",
"Only one item per user or IP" => "Felhasználónként vagy IP-nként egy tétel lehetséges",
"The tracker needs a user or IP field with the option 1" => "Az űrlaphoz szükséges egy felhasználói vagy IP mező 1-es opcióval",
"The tracker needs a group field with the option 1" => "Az űrlapnál meg kell adni egy csoport mezőt 1-es opcióval",
"Show creation date when listing tracker items?" => "Létrehozás idejének megjelenítése űrlaptételek listázásakor",
"Format if not the default short one:" => "Formátum (ha nem az alapértelmezett rövid formátum):",
"Show creation date when viewing tracker item?" => "Létrehozás idejének megjelenítése űrlaptétel megtekintésekor",
"Show lastModif date when listing tracker items?" => "Utolsó módosítás idejének megjelenítése űrlaptételek listázásakor",
"Show lastModif date when viewing tracker item?" => "Utolsó módosítás idejének megjelenítése űrlaptétel megtekintésekor",
"What field is used for default sort?" => "Melyik mező szerint legyen az alapértelmezett felsorolás?",
"What is default sort order in list?" => "Felsorolás listázásának alapértelmezett rendezési elve",
"Tracker items allow ratings?" => "Űrlaptételeket lehet értékelni?",
"with values" => "ezen értékekkel",
"and display rating results in listing?" => "és szerepeljenek az értékek listázáskor?",
"Tracker items allow comments?" => "Űrlaptételeket lehet kommentálni?",
"and display comments in listing?" => "és szerepeljenek a kommentek listázáskor?",
"Tracker items allow attachments?" => "Űrlaptételekhez lehet mellékletet csatolni?",
"and display attachments in listing?" => "és megjelenjenek a mellékletek listázáskor?",
"Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)" => "Melléklet megjelenítésének lehetőségei (Számokkal lehet a tételeket sorba rendezni, 0-ásak nem kerülnek listázásra, negatív értékek felugró dobozban jelennek meg)",
"Filesize" => "Fájlméret",
"Filetype" => "Fájltípus",
"LongDesc" => "Hosszú leírás",
"Items can be created only during a certain time" => "Tételeket csak egy meghatározott időszak alatt lehet létrehozni",
"After:" => "Kezdés:",
"Before:" => "Befejezés:",
"Do not show empty fields in item view?" => "Üres mezők elrejtése tétel megtekintésekor",
"Show these fields (ID comma separated) in a popup on item link when listing tracker items?" => "Ezen mezők megjelenítése (mező ID-k vesszővel elválasztva) felugró dobozban a tétel linkjén űrlaptételek listázásakor",
"Group of users alerted when tracker is modified" => "Űrlap módosításakor értesítendő felhasználói csoport",
"Import/Export" => "Importálás/Exportálás",
"Import/export trackers" => "Űrlapok importálása/exportálása",
"Charset encoding" => "Karakterkódolás",
"Duplicate Tracker" => "Űrlap duplikálása",
"Members" => "Tagok",
"Admin groups" => "Csoportok adminisztrálása",
"Admin users" => "Felhasználók adminisztrálása",
"Add new group" => "Új csoport hozzáadása",
"Manage permissions" => "Jogosultságok kezelése",
"List of existing groups" => "Létező csoportok listája",
"Inherits Permissions from" => "Jogosultságokat örök innen:",
"User Choice" => "Felhasználó kiválasztása",
"Group Homepage" => "Csoport kezdőlapja",
"Edit group" => "Csoport szerkesztése",
"Add a New Group" => "Új csoport hozzáadása",
"Inherit permissions directly from following groups." => "Jogosultságok közvetlen öröklése a következő csoportoktól",
"Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)." => "Jogosultságok öröklése az alábbi csoportoktól (indirekt öröklés a fentebb kiválasztott  csoportok alapján)",
"Use wiki page name or full URL" => "Egy Wiki oldal nevét vagy teljes elérési utat (URL-t) kell használni",
"For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)." => "Más Tiki funkciókhoz relatív linkeket kell használni (pld: <em>http:tiki-forums.php</em>)",
"Group Theme:" => "Csoport stílusa",
"choose a group tracker ..." => "csoportűrlap kiválasztása...",
"choose a users tracker ..." => "felhasználói űrlap kiválasztása...",
"Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Regisztrációkor kért felhasználói űrlap mezők <br />(mezőId-k elválasztója :)",
"User can assign to the group himself" => "Felhasználó felveheti magát a csoportba",
"Users are automatically unassigned from the group after" => "A felhasználók automatikusan kikerülnek a csoportból ennyi idő után:",
"0 or empty for never" => "0 vagy üresen hagyni (=soha)",
"Users are automatically assigned at registration in the group if their emails match the pattern" => "A mintának megfelelő E-mail címmel rendelkező felhasználók a regisztráció során automatikusan bekerülnek a csoportba",
"Example: " => "Például:",
"Edit Item" => "Tétel szerkesztése",
"CSV File" => "CSV fájl",
"Add a New User" => "Új felhasználó hozzáadása",
"Reason" => "Ok",
"More Criteria" => "További kritériumok",
"Group (direct)" => "Csoport (közvetlen)",
"ago" => "ezelőtt",
"to groups" => "csoportokhoz",
"default" => "alapértelmezett",
"Remove Users and their Userpages" => "Felhasználók és felhasználói oldalaik eltávolítása",
"Manage Group Assignments" => "Csoporthozzárendelések kezelése",
"Set Default Groups" => "Alapértelmezett csoportok megadása",
"Send a wiki page by Email" => "Wiki oldal küldése E-mailben",
"Assign selected to" => "Kiválasztottak hozzárendelése",
"Remove selected from" => "Kiválasztottak eltávolítása",
"the following groups:" => "a következő csoportokhoz/csoportokból:",
"Repeat Password:" => "Jelszó újra:",
"User must change password at next login" => "A felhasználónak meg kell változtatnia a jelszavát a legközelebbi bejelentkezéskor",
"Send an email to the user in order to allow him to validate his account." => "E-mail küldése a felhasználó részére hogy validálhassa fiókját",
"You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "Be kell állítani a <a href=\"tiki-admin.php?page=general\">Küldési E-mail cím</a>et",
"User tracker item : {\$usersitemid}" => "Felhasználói űrlap tétel : {\$usersitemid}",
"Batch upload (CSV file):" => "Tömeges feltöltés (CSV fájlból)",
"Overwrite but keep the previous login if the login exists in another case" => "Felülírás de a korábbi bejelentkezési név megtartása ha a név már létezik",
"Don't overwrite" => "Ne írja felül",
"Overwrite groups:" => "Csoportok felülírása:",
"Create groups:" => "Csoportok létrehozása:",
"User must change password at first login:" => "A felhasználónak meg kell változtatnia a jelszavát első bejelentkezéskor:",
"You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "Egy adott csoportba tartozó felhasználókat itt lehet exportálni <a href=\"tiki-admingroups.php\">Adminisztráció->Csoportok->a_group</a>",
"New attachments" => "Új mellékletek",
"Old attachments" => "Régi mellékletek",
"Source" => "Forrás",
"Admin Article Types" => "Cikk típusok adminisztrálása",
"Show Help" => "Súgó megjelenítése",
"Article type" => "Cikk típus",
"Shows up in the drop down list of article types" => "Megjelenik a cikkek listáját tartalmazó legördülő listában",
"Allow ratings by the author" => "Szerző általi értékelés engedélyezése",
"Show before publish date" => "Megjelenítés a publikálás dátuma előtt",
"non-admins can view before the publish date" => "nem adminisztrátor felhasználók megtekinthetik publikálás dátuma előtt",
"Show after expire date" => "Megjelenítés lejárat dátuma után",
"non-admins can view after the expire date" => "nem adminisztrátor felhasználók megtekinthetik a lejárati dátum után",
"Heading only" => "Csak fejléc",
"No article body, heading only" => "Nincs törzs, csak fejléc",
"Allow comments for this type" => "Kommentek engedélyezése ezen típusnál",
"Comment Can Rate Article" => "Komment értékelheti a cikket",
"Allow comments to include a rating value" => "A kommentek tartalmazhatnak értékelési értéket",
"Show image" => "Kép megjelenítése",
"Show topic or own image" => "Téma vagy saját kép megjelenítése",
"Show avatar" => "Avatár megjelenítése",
"Show author's avatar" => "Szerző avatárjának megjelenítése",
"Show author" => "Szerző megjelenítése",
"Show author name" => "Szerző nevének megjelenítése",
"Show publish date" => "Publikálás dátumának megjelenítése",
"Show expire date" => "Lejárati dátum megjelenítése",
"Show reads" => "Olvasások megjelenítése",
"Show the number of times the article was read" => "Megjeleníti hogy a cikket hányszor olvasták el",
"Show size" => "Méret megjelenítése",
"Show the size of the article" => "Cikk méretének megjelenítése",
"Show topline" => "Felső vonal megjelenítése",
"Show a small title over the title" => "Kis címet jelenít meg a cím felett",
"Show subtitle" => "Felirat megjelenítése",
"Show the subtitle" => "Felirat megjelenítése",
"Show source" => "Forrás megjelenítése",
"Show link to source after article body" => "Forrásra mutató link megjelenítése a cikk törzse után",
"Show Image Caption" => "Képfelirat megjelenítése",
"Show a legend under the image" => "Képfelirat megjelenítése",
"Show Language" => "Nyelv megjelenítése",
"Show the language" => "Nyelv megjelenítése",
"Creator can edit" => "Létrehozó szerkesztheti",
"The person who submits an article of this type can edit it" => "A személy, aki beküld egy ilyen típusú cikket szerkesztheti is",
"Actions on this article type" => "Akciók ezen cikk típussal kapcsolatban",
"List of article types" => "Cikk típus lista",
"view articles with this type" => "ezen típusú cikkek megjelenítése",
"Review" => "Átnézés",
"Classified" => "Titkos",
"Show lang" => "Nyelv megjelenítése",
"Custom attribute" => "Saját attribútum",
"Create a new type" => "Új típus létrehozása",
"Group Information" => "Csoport információ",
"Desc" => "Leírás",
"level" => "szint",
"inherited from" => "örökölve ettől:",
"inherited" => "öröklött",
"Advanced feature" => "Extra funkció",
"Level configuration" => "Szint konfiguráció",
"Create level" => "Szint készítése",
"all permissions in level" => "minden jogosultságot e szinten",
"Assign User to Group" => "Felhasználó hozzárendelése csoporthoz",
"backlinks to" => "hivatkozások a",
"No backlinks to this page" => "Erre az oldalra nem hivatkozik másik oldal",
"Browse Gallery" => "Galéria böngészése",
"Upload From Disk" => "Feltöltés lemezről",
"available images" => "rendelkezésre álló képek",
"Edit Post" => "Poszt szerkesztése",
"New Post" => "Új poszt",
"View Blog" => "Blog megtekintése",
"Excerpt:" => "Kivonat:",
"Trash" => "Lomtár",
"Mark entry as private:" => "Privát bejegyzés",
"Publish Date" => "Publikálás dátuma",
"Admin Category" => "Kategóriák beállítása",
"Admin the Category System" => "Kategória rendszer adminisztrálása",
"Browse in" => "Böngészés",
"Trackers Items" => "Űrlap tételek",
"Sheets" => "Táblázatok",
"Find:" => "Keresés:",
"in the current category - and its subcategories: " => "a jelenlegi kategóriában - és annak alkategóriáiban:",
"Hide subcategories objects" => "Alkategóriák objektumainak elrejtése",
"Show subcategories objects" => "Alkategóriák objektumainak megjelenítése",
"Browse related tags" => "Címkék böngészése",
"Network of Tags related to" => "Kapcsolódó címkék",
"With all selected tags" => "Összes kiválasztott címke",
"With one selected tag" => "Egyik kiválasztott címke",
"With last selected tag" => "Legutolsó kiválasztott címke",
"More Popular Tags" => "További népszerű címkék",
"Sort:" => "Rendezési elv:",
"Alphabetically" => "Abc sorrend",
"By Size" => "Méret",
"Cloud" => "Felhő",
"results found" => "találat",
"List Galleries" => "Galéria lista",
"Edit Gallery" => "Galéria szerkesztése",
"Rebuild Thumbnails" => "Előnézeti képek újraépítése",
"List Gallery" => "Galéria listázása",
"All Images" => "Összes kép",
"Monitor this Gallery" => "Galéria figyelése",
"Stop Monitoring this Gallery" => "Galéria figyelésének felfüggesztése",
"Sort Images by" => "A képek rendezése",
"subgallery" => "algaléria",
"Subgallery" => "Algaléria",
"Original Size" => "Eredeti méret",
"rotate right" => "jobbra forgatás",
"rotate" => "forgatás",
"Details" => "Részletek",
"popup" => "előugró",
"Return to Gallery" => "Vissza a galériához",
"First Image" => "Első kép",
"Prev Image" => "Előző kép",
"Smaller" => "Kisebb",
"Bigger" => "Nagyobb",
"Popup window" => "Előugró ablak",
"Next Image" => "Következő kép",
"Last Image" => "Utolsó kép",
"Image Name" => "Kép neve",
"Image size" => "Kép méret",
"Latitude (WGS84/decimal degrees)" => "Szélességi fok (WGS84/decimális fokokban kifejezve)",
"Longitude (WGS84/decimal degrees)" => "Hosszúsági fok (WGS84/decimális fokokban kifejezve)",
"Move image" => "Kép mozgatása",
"Stop Monitoring this Page" => "Oldal figyelésének felfüggesztése",
"Monitor this Page" => "Oldal figyelése",
"Edit Calendar" => "Naptár szerkesztése",
"Export Calendars" => "Naptárak exportálása",
"Visible Calendars" => "Látható naptárak",
"Group Calendars" => "Csoport naptárak",
"Export calendars" => "Naptárak exportálása",
"advanced parameters" => "További paraméterek",
"Export as iCal" => "iCal export",
"Export as CSV" => "CSV export",
"Edit event" => "Esemény szerkesztése",
"View event" => "Esemény megtekintése",
"Tentative" => "Függő",
"Confirmed" => "Megerősítve",
"Cancelled" => "Visszavonva",
"View this Day" => "Ezen nap megtekintése",
"Calendar Item" => "Naptári tétel",
"New event" => "Új esemény",
"Edit Calendar Item" => "Naptár tétel szerkesztése",
"January" => "Január",
"February" => "Február",
"March" => "Március",
"April" => "Április",
"May" => "Május",
"June" => "Június",
"July" => "Július",
"August" => "Augusztus",
"September" => "Szeptember",
"October" => "Október",
"End" => "Befejezés",
"No description" => "Nincs leírás",
"or new" => "vagy új",
"Organized by" => "Szervező",
"Format" => "Formátum",
"Update this event only" => "Csak ezen esemény frissítése",
"Update every unchanged events of this recurrence rule" => "Az ismétlődési szabály összes változatlan eseményének frissítése",
"Update every events of this recurrence rule" => "Ezen ismétlődési szabály összes eseményének frissítése",
"Delete Recurrent events" => "Ismétlődő események törlése",
"Calendar import" => "Naptár importálása",
"Calendar has been updated" => "Naptár frissítésre került",
"import" => "importálás",
"D" => "N",
"W" => "H",
"M" => "Hó",
"Advanced parameters for iCal export" => "iCal exportálás további paraméterei",
"Calendars to be exported" => "Exportálásra kerülő naptárak",
"Export calendars iCal" => "Exportálás iCal formátumban",
"Export calendars CSV" => "Exportálás CSV formátumban",
"Change password enforced" => "Jelszócsere kötelező",
"New password:" => "Új jelszó:",
"Send a message to us" => "Üzenet küldése nekünk",
"Contact us by email" => "Kapcsolatfelvétel E-mail-en keresztül",
"Click here to send us an email" => "E-mail küldéshez klikk az E-mail címre",
"Send another message" => "Másik üzenet küldése",
"Contacts" => "Kontaktok",
"Group View" => "Csoport nézet",
"Create/edit contacts" => "Kontaktok létrehozása/szerkesztése",
"First Name" => "Keresztnév",
"Publish this contact to groups" => "Kontakt publikálása csoportok felé",
"Last Name" => "Vezetéknév",
"Nickname" => "Becenév",
"Add a new site" => "Új weblap hozzáadása",
"You cannot add sites until Directory Categories are setup." => "Weblapok hozzáadása nem lehetséges amíg a könyvtár kategóriák nicsenek beállítva",
"Please contact the Site Administrator" => "Kapcsolatfelvétel az oldal adminisztrátorával",
"Site added" => "Weblap hozzáadva",
"The following site was added, but may require validation by the admin before appearing on the lists." => "A weblap hozzáadásra került de lehet hogy még adminisztrátori validálásra szorul mielőtt megjelenne a listákban",
"Edit a site" => "Weblap szerkesztése",
"Add a Site" => "Weblap hozzáadása",
"Directory Administration" => "Könyvtár adminisztrálása",
"There are" => "Összesen",
"invalid sites" => "érvénytelen weblap van",
"valid sites" => "érvényes weblap van",
"Users have visited" => "A felhasználók",
"sites from the directory" => "könyvtári weblapot látogattak meg",
"Users have searched" => "A felhasználók",
"times from the directory" => "alkalommal kerestek a könyvtárban",
"Sites" => "Weblapok",
"Validate" => "Validálás",
"Admin directory categories" => "Könyvtári kategóriák adminisztrálása",
"Add a directory category" => "Könyvtári kategória hozzáadása",
"Edit this directory category" => "Könyvtárkategória szerkesztése",
"Add a Directory Category" => "Linktár kategória hozzáadása",
"Children type" => "Gyerekek típusa",
"Maximum number of children to show" => "Megjelenítendő alkategóriák száma",
"Editor group" => "Szerkesztő csoport",
"cType" => "Kategória típusa",
"allow" => "engedélyezés",
"count" => "számosság",
"editor" => "szerkesztő",
"relate" => "kapcsolás",
"Mutual" => "Kölcsönös",
"Admin sites" => "Weblapok adminisztrálása",
"Is valid" => "Valid",
"Perform action with selected:" => "Akció végrehajtása a kijelöltekkel:",
"New Sites" => "Új weblapok",
"Cool Sites" => "Népszerű weblapok",
"any" => "bármely",
"in entire directory" => "teljes könyvtárban",
"Sort by" => "Rendezési elv",
"sort" => "rendezés",
"Last updated" => "Legutóbbi frissítés",
"No records." => "Nincsenek rekordok",
"Total directory categories" => "Linktár kategóriák összesen",
"Total links" => "Összes link",
"Links to validate" => "Validálásra váró linkek",
"Searches performed" => "Végrehajtott keresések",
"Total links visited" => "Összes látogatott link",
"Directory ranking" => "Linktár rangsor",
"Validate sites" => "Weblapok validálása",
"Translation of this page is incomplete." => "Az oldal fordítása nem teljes",
"Edit article" => "Cikk szerkesztése",
"View Articles" => "Cikk megtekintés",
"Author Name" => "Szerző neve",
"Own Image" => "Saját kép",
"Use own image" => "Saját kép használata",
"Float text around image" => "Szöveg körbefolyatása a kép körül",
"List mode" => "Listázási mód",
"Image caption" => "Képfelirat",
"Allow full HTML" => "Teljes HTML engedélyezés",
"for this edit session" => "ezen szerkesztési munkamenethez",
"Emails to be notified (separated with commas)" => "Értesítés küldése (E-mail címek vesszővel elválasztva)",
"Published" => "Publikálva",
"Cancel the edit, you will lose your changes." => "Szerkesztés visszavonása (a változások elvesznek)",
"Edit or create banners" => "Banner létrehozása és szerkesztése",
"List banners" => "Banner lista",
"URL to link the banner" => "URL melyre a banner mutat",
"-1 for unlimited" => "-1 esetén nincs határ",
"Use dates" => "Dátumok használata",
"Select ONE method for the banner" => "EGY módszer kiválasztása a bannerhez",
"Use HTML" => "HTML használata",
"Use image" => "Kép használata",
"Image:" => "Kép:",
"Current Image" => "Jelenlegi kép",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "URL által generált kép használata (a kép minden egyes impressziónál kérésre kerül az URL-ről)",
"Use Flash" => "Flash használata",
"Pixels" => "Pixel",
"Use text" => "Szöveg használata",
"Save the Banner" => "Banner mentése",
"Remove Zones (you lose entered info for the banner)" => "Zónák eltávolítása (a bannerbe bevitt információ elveszik)",
"There are individual permissions set for this blog" => "Ehhez a bloghoz egyedi jogosultságok vannak beálllítva",
"Allow other users to post in this blog" => "Más felhasználók is posztolhatnak ebbe a blogba",
"If others post to blog, Author should always be Owner" => "Ha mások is posztolhatnak a blogba, akkor a Szerző mindig a blog tulajdonosa legyen",
"Allow search" => "Keresés engedélyezése",
"Allow comments" => "Kommentek engedélyezése",
"Display Options" => "Megjelenítési beállítások",
"Number of posts to show per page" => "Posztok száma oldalanként",
"Display blog title in posts list page" => "Blog címének megjelenítése a posztokat listázó oldalon",
"Display blog title in post page" => "Blog címének megjelenítése a poszt oldalon",
"Display blog description" => "Blog leírásának megjelenítése",
"Display breadcrumbs" => "Breadcrumb megjelenítése",
"Display author in blog posts" => "Szerző megjelenítése blog posztokban",
"Display published date in blog posts" => "Publikálás dátumának megjelenítése blog posztokban",
"Show user avatar" => "Felhasználó avatárjának megjelenítése",
"Show post related content" => "Poszthoz kapcsolódó tartalom megjelenítése",
"Maximum number of related posts to display" => "Megjelenítendő kapcsolódó posztok maximális száma",
"Use post excerpt" => "Poszt kivonat használata",
"Blog heading" => "Blog fejléc",
"Heading preview" => "Fejléc előnézet",
"Blog post heading" => "Blog poszt fejléc",
"For more information, please see" => "További információkért lásd",
"Wiki Page Editor" => "Wiki oldal szerkesztése",
"Bold text" => "Félkövér szöveg",
"Italic text" => "Dőlt szöveg",
"single quotes" => "idézőjel",
"Underlined text" => "Aláhúzott szöveg",
"Colored text" => "Színezett szöveg",
"Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background." => "A megadott HTML színkódnak vagy színnévnek megfelelő színben jeleníti meg a szöveget. Szín neve két színt is tartalmazhat vesszővel elválasztva. Ebben az esetben az első szín adja meg a karakter színét, a második a háttérszínt.",
"Deleted text" => "Törölt szöveg",
"2 dashes" => "2 kötőjel",
"Headings" => "Címsorok",
"Show/Hide" => "Megjelenítés/Elrejtés",
"show/hide heading section. + (shown) or - (hidden) by default" => "felsorolási szekció megjelenítése/elrejtése. + (megjelenítve) vagy - (elrejtve) alapértelmezés szerint",
"Autonumbered Headings" => "Automatikusan számozott címsorok",
"Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename." => "Általános, opcionális MAKETOC paraméterek: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename.",
"Horizontal rule" => "Vízszintes vonal",
"Text box" => "Szöveges doboz",
"Box content" => "Doboz tartalma",
"Centered text" => "Középre rendezett szöveg",
"Inserts an editable variable" => "Beilleszt egy szerkeszthető változót",
"External links" => "Külső linkek",
"use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)." => "Használjunk szögletes zárójeleket külső linkhez: [URL], [URL|link_leírás],[URL|link_leírás|reláció] vagy [URL|leírás|reláció|nocache] (ez utóbbi megakadályozza hogy a helyi wiki cache-elje a linkelt oldalt; reláció a rel attribútum használatát teszi lehetővé a link számára - hasznos lehet pld. shadowbox funkció számára).",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Külső Wikihez használjuk a KülsőWikiNeve:Oldalnév vagy ((Külső Wiki Neve: Oldal Neve)) szintakszist",
"Square Brackets" => "Szögletes zárójelek",
"Use [[foo] to show [foo]." => "Használjuk a [[foo] formátumot hogy ez jelenjen meg: [foo]",
"Wiki References" => "Wiki hivatkozások",
"JoinCapitalizedWords or use" => "NagybetűsSzavakEgyesítése vagy használjuk az",
"page|description" => "oldalnév|megjelenő leírás",
"for wiki references" => "formátumot wiki hivatkozásokhoz",
"page|#anchor" => "oldal|#horgony",
"page|#anchor|desc" => "oldal|#horgony|leírás",
"for wiki heading/anchor references" => "címsor/horgony hivatkozásokhoz",
"SomeName" => "Valamilyen név",
"prevents referencing" => "megakadályozza a hivatkozást",
"Lists" => "Listák",
"for bullet lists" => "felsorolásos listákhoz",
"for numbered lists" => "számozott listákhoz",
"for definiton lists" => "defincíciós listákhoz",
"Indentation" => "Behúzás",
"Creates an indentation for each plus (useful in list to continue at the same level)" => "Minden + jellel eggyel beljebb húzza (hasznos listázások ugyanazon szinten történő folytatására)",
"Tables" => "Táblák",
"row" => "sor",
"col" => "oszlop",
"Monospace font" => "Monospace betű",
"Code sample" => "Kód minta",
"(very useful especially in tables)" => "(nagyon hasznos például táblázatok esetén)",
"Multi-page pages" => "Többoldalas oldalak",
"to separate pages" => "szintakszist az oldalak elválasztásához",
"Non parsed sections" => "Nem elemzett szekciók",
"Prevents wiki parsing of the enclosed data." => "Megakadályozza a belefoglalt adatok wiki általi elemzését",
"Preformated sections" => "Előformázott szekciók",
"~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar." => "~tc~ Tiki komment ~/tc~ Tiki kommentet készít. Nem kerül megjelenítésre, de mentésre kerül a fájlba a visszakereshetőség kedvéért.  ~hc~ HTML komment ~/hc~ HTML kommentet készít, mely megjelenik kommentként a végleges HTML-ben. Általában ezek nem kerülnek megjelenítésre a böngészőkben de a például a \"Forrás megtekintése\" vagy hasonló funkció által láthatóvá válnak.",
"Block Preformatting" => "Blokk előformázása",
"Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that." => "Lehetőséget nyújt tetszőleges számú szóközt tartalmazó szöveg bekezdéssel indítására és átformálására monospaced blokká úgy, hogy az továbbra is kövesse a Wiki formázási utasításokat. Amennyi szóközt használtunk annyival lesz behúzva. Vegyük figyelembe hogy ez a módszer nem őrzi meg a pontos szóközöléseket és sortöréseket ; ehhez használjuk a ~pp~...~/pp~ szintakszist",
"Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew." => "Jobbról-balra illetbe balról-jobbra írás lehetőségét teremti meg DIV beszúrásával a szöveg végéig, valamint jelzéseket rak be arab, héber és hasonló nyelveknél",
"Special characters" => "Speciális karakterek",
"hard space" => "kemény szóköz",
"numeric between ~ for html numeric characters entity" => "numerikus ~ között html numerikus entitásokhoz",
"Plugin Help" => "Plugin súgó",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;" => "Plugin argumentumok dupla idézőjel közé tehetők (\"); lehetővé téve így hogy = vagy > operandusokat tartalmazzanak",
"More help here" => "További súgó",
"Activate/deactivate plugins" => "Pluginok be/kikapcsolása",
"No description available" => "Nincs elérhető leírás",
"Wysiwyg Editor" => "WYSIWYG szerkesztő",
"The WYSIWYG editor in Tiki 6+ is\n\t<a href=\"http://ckeditor.com\">CKEditor</a>,\n\tthe new version of FCKEditor (used in Tiki since version 2.0)" => "The WYSIWYG editor in Tiki 6+ is \t<a href=\"http://ckeditor.com\">CKEditor</a>, \tthe new version of FCKEditor (used in Tiki since version 2.0)",
"<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent." => "<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa. \tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes. \tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent.",
"<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 6.0) drag and drop of plugins in WYSIWYG does not work." => "<strong>Caution:</strong> This is a new feature and still work in progress.<br /> \tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br /> \tCurrently (in Tiki 6.0) drag and drop of plugins in WYSIWYG does not work.",
"<strong>Admins:</strong><br />\n\t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>.\n\t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br /> \t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way. \t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>. \t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a> \t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
"Browse Images" => "Képek böngészése",
"Image Description" => "Kép leírása",
"Edit or export/import languages" => "Nyelvek szerkesztése/exportálása/importálása",
"Toggle interactive translation off" => "Interaktív fordítás kikapcsolása",
"Toggle interactive translation on" => "Interaktív fordítás bekapcsolása",
"Edit languages" => "Nyelvek szerkesztése",
"Note:" => "Megjegyzés:",
"Select the language to edit" => "Szerkesztendő nyelv kiválasztása",
"Add a translation" => "Fordítás hozzáadása",
"Edit translations" => "Fordítások szerkesztése",
"Translate recorded" => "Rögzítettek lefordítása",
"Original" => "Eredeti",
"Export languages" => "Nyelvek exportálása",
"Select the language to Export" => "Exportálandó nyelv kiválasztása",
"Download database translations" => "Adatbázisban lévő fordítások letöltése",
"Write to language.php" => "Kiírás language.php fájlba",
"Import languages" => "Nyelvek importálása",
"Select the language to import" => "Importálandó nyelv kiválasztása",
"Warning:" => "Figyelmeztetés:",
"Beware that when importing a language, all translations in the database for that language are deleted." => "Figyelem! Nyelv importálásakor a nyelvre vonatkozó összes fordítás törlésre kerül az adatbázisból!",
"Create New Block" => "Új blokk létrehozása",
"List Quizzes" => "Kvíz lista",
"Quiz Stats" => "Kvíz statisztika",
"This Quiz Stats" => "Ezen kvíz statisztikája",
"Edit this Quiz" => "Ezen kvíz szerkesztése",
"Admin Quizzes" => "Kvíz karbantartás",
"Create/edit options for question" => "Opciók létrehozása / szerkesztése a kérdéshez",
"Option" => "Opció",
"points" => "pontok",
"Quiz" => "Kvíz",
"timeLimit" => "Időkorlát",
"Create/edit quizzes" => "Kvíz létrehozása/szerkesztése",
"There are individual permissions set for this quiz" => "Ezen kvízhez egyedi jogosultságok tartoznak",
"Quiz can be repeated" => "Kvízt meg lehet ismételni",
"Store quiz results" => "Kvíz eredményeinek tárolása",
"Immediate feedback" => "Azonnali visszajelzés",
"Show correct answers" => "Helyes válaszok megjelenítése",
"Shuffle questions" => "Kérdések véletlenszerű sorrendje",
"Shuffle answers" => "Válaszok véletlenszerű sorrendje",
"Quiz is time limited" => "Kvíz idő korlátozása",
"Maximum time" => "Maximális idő",
"Passing Percentage" => "Megfelelés százaléka",
"Modify Structure" => "Struktúra szerkesztése",
"You will remove" => "Eltávolításra kerül a(z)",
"and its subpages from the structure, now you have two options:" => "oldalt és aloldalait e struktúrából, 2 opció áll rendelkezésre:",
"and its subpages from the structure" => "és aloldalait a struktúrából",
"Remove only from structure" => "Eltávolítás csak a struktúrából",
"Remove from structure and remove page too" => "Eltávolítás a struktúrából majd az oldal eltávolítása",
"The following pages added have automatically been categorized with the same categories as the structure:" => "A következő hozzáadott oldalak a struktúra kategóriabeállításainak megfelelően automatikusan kategorizálásra kerültek",
"Structure Layout" => "Struktúra felépítése",
"Monitor the Sub-Structure" => "Alstruktúra figyelése",
"Stop Monitoring the Sub-Structure" => "Alstruktúra figyelésének felfüggesztése",
"Promote" => "Szinttel feljebb",
"Demote" => "Szinttel lejjebb",
"Previous" => "Előző",
"Current Node" => "Jelenlegi ág",
"Page alias" => "Megjelenített neve:",
"Move in this structure" => "Mozgatás ebben a struktúrában",
"Move to another structure" => "Átmozgatás másik struktúrába",
"at the beginning" => "elejére",
"at the end" => "végére",
"Add pages to current node" => "Oldalak hozzáadása az ághoz",
"After page" => "Oldal után",
"Create Page" => "Oldal létrehozása",
"Use pre-existing page" => "Meglévő oldal használata",
"Categorize all pages in structure together" => "Struktúra összes oldalának egy kategóriába rendezése",
"Remove existing categories from ALL pages before recategorizing" => "Eltávolítás az összes kategóriából az újrakategorizálás előtt",
"Submit article" => "Cikk beküldése",
"List Submissions" => "Beküldött hírek listázása",
"Use ...page... to separate pages in a multi-page post" => "Használjuk a '...page...' szintaxist oldalak elválasztásához többoldalas posztok esetén",
"<b>*</b>=optional" => "<b>*</b>=opcionális",
"Own image size x" => "Saját kép mérete x",
"Own image size y" => "Saját kép mérete y",
"Allow HTML:" => "HTML engedélyezése:",
"Submit Article" => "Cikk beküldése",
"Auto-Approve Article" => "Cikk automatikus jóváhagyása",
"Edit templates" => "Sablonok szerkesztése",
"Edit a topic" => "Téma szerkesztése",
"Add Notification Email" => "Tájékoztató E-mail hozzáadása",
"Admin notifications" => "Értesítések adminisztrálása",
"Translate:" => "Fordítás:",
"View Page" => "Oldal megtekintése",
"View Article" => "Cikk megtekintése",
"You must specify the object language" => "Meg kell adni az objektum nyelvét",
"The object doesn't exist" => "Az objektum nem létezik",
"The object doesn't have a language" => "Az objektumhoz nincs nyelv rendelve",
"The object has already a translation for this language" => "Az objektumhoz már létezik fordítás ezen a nyelven",
"The object is already in the set of translations" => "Az objektum már szerepel a fordítások között",
"Translate updates made on this page or one of its translations" => "Az oldal vagy egy fordítás frissített tartalmának lefordítása",
"Translate this page to a new language" => "Oldal lefordítása új nyelvre",
"Attach or detach existing translations of this page" => "Oldal létező fordításainak hozzácsatolása vagy leválasztása",
"Change language for this page" => "Oldal nyelvének megváltoztatása",
"Select language to translate to:" => "Fordítás nyelve:",
"Unspecified" => "Nem meghatározott",
"Enter the page title:" => "Oldal címe:",
"Below, assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Alább lehetséges az új fordítás kategóriákba rendezése (Megjegyzés: valószínűleg megegyezik a forrás oldal beállításaival)",
"Create translation" => "Fordítás létrehozása",
"Attach or detach existing translations of this article" => "Cikk fordításainak hozzáadása/leválasztása",
"detach" => "lecsatolás",
"Mark existing article as a translation of this one:" => "Létező cikk fordításként való hozzákötése:",
"Change Language" => "Nyelv megváltoztatása",
"No language is assigned to this page." => "Ehhez az oldalhoz nincs nyelv rendelve",
"Please select a language before performing translation." => "Fordítás elvégzése előtt ki kell választani egy nyelvet",
"Set Current Page's Language" => "Jelen oldal nyelvének megadása",
"Preview your changes." => "Változások előnézete",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "A Homokozó egy oldal ahol gyakorolni lehet az oldalszerkesztést. Az előnézet gombbal megtekinthető a szerkesztési munka eredménye. A Homokozónak nincsenek tárolt verziói.",
"All Versions" => "Összes verzió",
"Edit wiki page" => "Wiki oldal szerkesztése",
"Edit page" => "Oldal szerkesztése",
"Describe the change you made:" => "Változások rövid összefoglalása:",
"Monitor this page:" => "Oldal figyelése",
"Add another image" => "További kép hozzáadása",
"Categories will be inherited from the structure top page" => "Kategorizálás a struktúra legfelső oldalának kategóriái alapján történik",
"Admin Content Templates" => "Tartalomsablonok adminisztrálása",
"Lock this page" => "Oldal zárolása",
"Import HTML:" => "HTML importálása:",
"Try to convert HTML to wiki" => "Próbálja átkonvertálni a HTML kódot wikivé",
"export all versions" => "összes verzió exportálása",
"Year:" => "Év:",
"Authors:" => "Szerzők:",
"Manage structures" => "Struktúrák kezelése",
"There is no available poll template." => "Nincs elérhető kérdőív sablon",
"Language:" => "Nyelv:",
"Send urgent translation request." => "Fordítási kérés küldése",
"Admin wiki preferences" => "Wiki preferenciák adminisztrálása",
"List Sheets" => "Táblázat lista",
"Graph" => "Grafikon",
"Export Tracker Items" => "Űrlaptételek exportálása",
"itemId" => "Tétel azonosító (ID)",
"status" => "státusz",
"lastModif" => "Legutóbbi módosítás",
"items" => "elem",
"Admin FAQ" => "Gyakori kérdések beállításai",
"List FAQs" => "GYIK lista",
"Upload File" => "Fájl feltöltése",
"View tpl" => "Tpl megtekintése",
"Edit template" => "Sablon szerkesztése",
"Be careful to set the right permissions on the files you link to" => "Győződjünk meg róla hogy jól lettek beállítva a jogosultságok a fájlhoz melyre a link mutat",
"You can access the file gallery using the following URL" => "A fájlgaléria a következő URL-lel érhető el",
"Forum Importer" => "Fórumok importálása",
"Admin forums" => "Fórum karbantartás",
"Import from a Local SQL File" => "Importálás lokális SQL fájlból",
"Forum Type" => "Fórum típusa",
"DB Prefix" => "Adatbázis előtag",
"Local SQL Filename on Server (path will be stripped)" => "Lokális SQL fájlnév a szerveren (az útvonalat le lesz csupaszítva)",
"Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Helye a tiki gyökérkönyvtár /{\$tmpdir} vagy tiki gyökérkönyvtár/img/wiki_up",
"Get Forum List" => "Fórumlista importálása",
"Go Back" => "Vissza",
"Message queue for forum" => "Fórum sorbanálló posztjai",
"Back to forum" => "Vissza a fórumhoz",
"summary" => "összefoglaló",
"Announce" => "Hirdetmény",
"Hot" => "Forró",
"Locked" => "Zárolva",
"no feeling" => "nincs érzelem",
"frown" => "haragos",
"exclaim" => "felkiáltás",
"idea" => "ötlet",
"neutral" => "semleges",
"question" => "kérdés",
"happy" => "boldog",
"wink" => "kacsintás",
"Save and Approve" => "Mentés és jóváhagyás",
"convert to topic" => "témává konvertálás",
"List of messages" => "Üzenetek listája",
"Topic:" => "Téma:",
"New Topic" => "Új téma",
"no summary" => "nincs összefoglaló",
"No messages queued yet" => "Nincsenek sorbanálló posztok",
"Search by name" => "Keresés név szerint",
"Search in content" => "Keresés a tartalomban",
"Last Post" => "Legutóbbi poszt",
"Configure Forum" => "Fórum konfigurálása",
"Tag translation" => "Címke fordítása",
"Set language" => "Nyelv beállítása",
"Accept" => "Elfogadás",
"Refuse" => "Visszautasítás",
"Waiting requests" => "Függő kérések",
"Your friends" => "Barátaim",
"break friendship" => "megszakítom a barátságot vele",
"Galleries" => "Galériák",
"Create New Gallery" => "Új galéria létrehozása",
"Create a gallery" => "Galéria létrehozása",
"Edit this gallery:" => "Ezen galéria szerkesztése:",
"There are individual permissions set for this gallery" => "Ehhez a galériához egyéni jogosultságok vannak beállítva",
"Gallery is visible to non-admin users?" => "A galéria látható a nem admin felhasználók számára?",
"Fields to show during browsing the gallery" => "Galéria böngészésekor megjelenítendő mezők",
"XY-Size" => "XY-méret",
"Gallery Image" => "Galéria képe",
"Available scales" => "Elérhető méretarányok",
"Global default" => "Globális alapértelmezés",
"Bounding box" => "Határoló doboz",
"default scale" => "alapértelmezett arány",
"No scales available" => "Nincs elérhető méretarány",
"Original image is default scale" => "Eredeti kép az alapértelmezett arány",
"Add scaled images with bounding box of square size" => "Arányosított képek hozzáadása négyzetes határoló dobozzal",
"Other users can upload images to this gallery" => "Más felhasználók is tölthetnek fel képet ebbe a galériába",
"You can access the gallery using the following URL" => "A galéria a következő URL-en érhető el:",
"Available Galleries" => "Rendelkezésre álló galériák",
"Choose a filter" => "Szűrő kiválasztása",
"Imgs" => "Képek",
"Google Map Locator" => "Google Map lokátor",
"Back to preferences" => "Vissza a beállításokhoz",
"Save clicked point" => "Klikkelt pont mentése",
"Save current view as default" => "Jelen nézet mentése alapértelmezettként",
"Center map to saved point" => "Térkép beállítása a mentett pontra",
"Users Map" => "Felhasználói térkép",
"Rollback" => "Visszagörgetés",
"Result" => "Eredmény",
"body" => "törzs",
"Or" => "Vagy",
"Tiki installer" => "Tiki telepítő",
"Welcome" => "Üdvözlet",
"Use this script to install a new Tiki database or upgrade your existing database to release" => "Ezt a szkriptet új Tiki adatbázis telepítéséhez vagy egy létező adatbázis ezen legújabb kiadásra történő frissítéséhez használjuk:",
"For the latest information about this release, please read the" => "Pour les dernières informations concernant cette version, veuillez consulter les ",
"Release Notes" => "Kiadási megjegyzések",
"For complete documentation, please visit" => "Teljes dokumentációt lásd itt:",
"For more information about Tiki, please visit" => "További információk a TikiWikiről itt:",
"Read the License" => "Licensz elolvasása",
" <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>" => " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Ide kattintva elolvasható a licensz bárki által könnyen áttekinthető és értelmezhető rövid kivonata több nyelven.</a>",
"Review the System Requirements" => "Rendszerkövetelmények áttekintése",
"Success" => "Sikeres",
"Copy test mail to " => "Másolat küldése a teszt E-mailről ide:",
"Send Test Message" => "Tesztüzenet küldése",
"Tiki was able to send a test message to" => "A Tiki sikeresen kiküldte a tesztüzenetet erre a címre:",
"Image Processing" => "Képek feldolgozása",
"Set the Database Connection" => "Adatbázis kapcsolat megadása",
"Use Existing Connection" => "Létező kapcsolat használata",
"Database information" => "Adatbázis információ",
"Database user" => "Adatbázis felhasználó",
"Install" => "Telepítés",
"Reinstall the database" => "Az adatbázis újratelepítése",
"Upgrade" => "Frissítés",
"Automatically upgrade your existing database to v" => "Létező adatbázis frissítése erre a verzióra:",
"Review the Upgrade" => "Frissítés áttekintése",
"Review the Installation" => "Telepítés áttekintése",
"Upgrade complete" => "Frissítés befejezve",
"Installation complete" => "Telepítés befejezve",
"Failed" => "Nem sikerült",
".htaccess File" => ".htaccess fájl",
"Configure General Settings" => "Általános beállítások megadása",
"PHP error reporting level:" => "PHP hibajelentés szinje:",
"Report all errors except notices" => "Figyelemeztetéseken kívűl minden hiba jelentése",
"Visible to Admin only" => "Csak adminisztrátor számára látható",
"Administrator" => "Adminisztrátor",
"Enter Your Tiki" => "Belépés a Tiki-be",
"Installation" => "Telepítés",
"Enter Tiki and Lock Installer" => "Belépés a Tikibe és a telepítő zárolása",
"Recommended" => "Ajánlott",
"Enter Tiki Without Locking Installer" => "Belépés a Tikibe a telepítő zárolása nélkül",
"MultiTiki Setup" => "MultiTiki beállítás",
"Default Installation" => "Alapértelmezett telepítés",
"DB OK" => "Adatbátis OK",
"No DB" => "Nincs adatbázis",
"Install/Upgrade" => "Telepítés/Frissítés",
"Database Connection" => "Adatbázis kapcsolat",
"Reset the Database Connection" => "Adatbázis kapcsolat beállítása",
"Configure the General Settings" => "Általános beállítások",
"Tiki Icon" => "Tiki ikon",
"Documentation" => "Dokumentáció",
"Support Forums" => "Támogató fórumok",
"Clear cached version and refresh cache" => "Cache-elt verzió kiürítése és cache frissítése",
"configure rules" => "szabályok konfigurálása",
"Kaltura Video" => "Kaltura Videó",
"Editor" => "Szerkesztő",
"Last Changes" => "Legutóbbi változások",
"Last 2 days" => "Elmúlt 2 nap",
"Last 3 days" => "Elmúlt 3 nap",
"Last 5 days" => "Elmúlt 5 nap",
"Last week" => "Múlt hét",
"Last 2 weeks" => "Elmúlt 2 hét",
"Last month" => "Múlt hónap",
"Search by Date" => "Keresés dátum szerint",
"LastChanges" => "Legutóbbi változások",
"Pages like" => "Hasonló nevű oldalak",
"Edit New Article" => "Új cikk szerkesztése",
"View Submissions" => "Beküldések megtekintése",
"ExpireDate" => "Lejárat dátuma",
"Img" => "Kép",
"IsPublished" => "Publikálva",
"To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone." => "Banner használatához egy <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">modulban</a> vagy egy sablonban alkalmazzuk a  {literal}{banner zone=ABC}{/literal} formulát, ahol ABC a zóna neve",
"Create banner" => "Banner készítése",
"Client" => "Kliens",
"Method" => "Metódus",
"Use Dates?" => "Dátumok használata?",
"Max Impressions" => "Max nézőszám",
"Impressions" => "Nézőszám",
"Max Clicks" => "Max Klikkek",
"Clicks" => "Kattintások",
"Create New Blog" => "Blog létrehozása",
"List all comments" => "Komment lista",
"Approval" => "Jóváhagyás",
"Rejected" => "Elutasítva",
"Available content blocks" => "Elérhető tartalom blokkok",
"Current Value" => "Jelenlegi érték",
"Current ver" => "Jelenlegi verzió",
"Next ver" => "Következő verzió",
"Future vers" => "Jövőbeli verzió",
"Edit content block" => "Tartalom blokk szerkesztése",
"Create content block" => "Tartalom blokk létrehozása",
"Available FAQs" => "Jelenlegi GYIK-ek",
"Edit/Create" => "Létrehozás/szerkesztés",
"Edit this FAQ:" => "GYIK szerkesztése:",
"Create new FAQ" => "Új GYIK létrehozása",
"Create New FAQ:" => "Új GYIK létrehozása",
"Users can suggest questions" => "Felhasználók javasolhatnak kérdéseket",
"Create a File Gallery" => "Fájlgaléria létrehozása",
"Admin View" => "Adminsztrátori nézet",
"SlideShow" => "Bemutató",
"Keep gallery window open" => "Galériaablak nyitva tartása",
"Your comment" => "Megjegyzés",
"optional" => "opcionális",
"Modifications" => "Módosítások",
"Property <b>{\$fgp_name}</b> Changed" => "Megváltoztatott tulajdonság: <b>{\$fgp_name}</b>",
"Gallery Images" => "Galéria képek",
"Additional Info" => "További információ",
"Object Permissions List" => "Objektum jogosultságok listája",
"Manage Permissions" => "Jogosultságok kezelése",
"global permissions" => "globális jogosultságok",
"If an object is not listed in the section below, then only the global perms are on" => "Ha egy objektum nem található az alábbi listában, akkor a globális jogosultságok be vannak kapcsolva",
"If an object is not listed in this section, then only the global perms are on" => "Ha egy objektum nem található az alábbi listában, akkor a globális jogosultságok be vannak kapcsolva",
"New Blog Post" => "Új blog poszt",
"Post Title" => "Poszt címe",
"Blog Title" => "Blog neve",
"Survey stats" => "Kérdőív statisztika",
"Take Survey" => "Kérdőív kitöltése",
"like" => "hasonló",
"List Wiki Pages" => "Wiki oldalak listája",
"Create a Wiki Page" => "Oldal létrehozása",
"Insert name of the page you wish to create" => "Létrehozandó oldal neve",
"Last mod" => "Utolsó módosítás",
"Last modification" => "Utolsó módosítás",
"Page creator" => "Oldal létrehozója",
"Last author" => "Utolsó szerző",
"Last version" => "Legutóbbi verzió",
"Status of the page" => "Oldal státusza",
"Vers." => "Verzió.",
"Backl." => "Visszahiv.",
"Page size" => "Oldal mérete",
"unlocked" => "feloldva",
"Open client window" => "Kliens ablak megnyitása",
"Generate HTML" => "HTML generálása",
"Transcripts" => "Leíratok",
"Online operators" => "Elérhető operátorok",
"Operator" => "Operátor",
"transcripts" => "leiratok",
"offline" => "nem elérhető",
"Offline operators" => "Nem elérhető operátorok",
"Add an operator to the system" => "Operátor hozzáadása a rendszerhez",
"Operators must be tiki users" => "Csak Tiki felhasználók lehetnek operátorok",
"Set as Operator" => "Beállítás operátorként",
"Chat started" => "Csevegés elindítva",
"Operator:" => "Operátor:",
"Live support:User window" => "Élő támogatás:Felhasználói ablak",
"Request live support" => "Élő támogatás kérése",
"Request support" => "Támogatás kérése",
"Open a support ticket instead" => "Inkább egy támogatási jegy megnyitása",
"Your request is being processed" => "A kérés feldolgozás alatt",
"cancel request and exit" => "kérés visszavonása és kilépés",
"cancel request and leave a message" => "kérés visszavonása és üzenet hagyása",
"Live support:Console" => "Élő támogatás:Konzol",
"be online" => "elérhetővé válás",
"be offline" => "elérhetetlenné válás",
"Support requests" => "Támogatási kérések",
"Requested" => "Kérve",
"Join" => "Csatlakozás",
"Support chat transcripts" => "Támogatási csevegés leiratok",
"operator" => "operátor",
"started" => "kezdve",
"reason" => "ok",
"msgs" => "üzenetek",
"Transcript" => "Leirat",
"For security purposes we must periodically validate your email address to allow continued access to this site." => "Biztonsági okokból időszakosan validálnunk kell az E-mail címet hogy továbbrais elérhető maradjon az oldal",
"A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site." => "A validálási E-mail elküldésre került. A megadott címen megtekinthető a levél tartalma és a benne található információkat követve az oldal újra elérhetővé válik.",
"Thank you" => "Köszönöm",
"Mail-in feature" => "Mail-in funkció",
"Prefs" => "Beállítások",
"Daily" => "Napi",
"Weekly" => "Heti",
"Remove old events" => "Régi események eltávolítása",
"duration" => "időtartam",
"h" => "ó",
"mins" => "perc",
"Mini Calendar: Preferences" => "Mini Naptár: Beállítások",
"Calendar Interval in daily view" => "Naptár intervallum napi nézetben",
"Start hour for days" => "A nap kezdőóráa",
"End hour for days" => "A nap utolsó óráa",
"Reminders" => "Emlékeztető",
"no reminders" => "nincs emlékeztető",
"min" => "perc",
"Or enter path or URL" => "vagy útvonal / URL megadása",
"Add Topic" => "Téma hozzáadása",
"Mods Configuration" => "Mods konfiguráció",
"Update remote index" => "Távoli index frissítése",
"Rebuild local list" => "Lokális lista újraépítése",
"Republish all" => "Összes újrapublikálása",
"Publish all" => "Összes publikálása",
"Unpublish all" => "Összes publikálásának visszavonása",
"Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>." => "Tiki \"mods\" kiegészítő funkciókat tartalmaz melyek nem beépített részei a hivatalos csomagnak. Több információ róluk itt: <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>.",
"Attention" => "Figyelem",
"Display only this type" => "Csak ezen típus megjelenítése",
"Unpublish" => "Publikálás visszavonása",
"Republish" => "Újrapublikálás",
"licence" => "licensz",
"Tikiwiki Mods Configuration" => "Tikiwiki Mods konfiguráció",
"Mods Install/uninstall" => "Mods telepítés/eltávolítás",
"Enable Mods providing" => "Mods nyújtás aktiválása",
"Mods local directory" => "Mods helyi könyvtár",
"Mods remote server" => "Mods távoli szerver",
"Package Config" => "Csomag beállítás",
"y" => "i",
"User Galleries" => "Felhasználói galériák",
"My Articles" => "Cikkeim",
"User Articles" => "Felhasználói cikkek",
"My User Items" => "Tételeim",
"User Items" => "Felhasználói tételek",
"Comments:" => "Kommentek:",
"Unread Messages" => "Olvasatlan üzenetek",
"Tasks" => "Feladatok",
"User forum topics" => "Felhasználó fórum témái",
"Forum topics" => "Fórum témák",
"Date of post" => "Hozzászólás ideje",
"User forum replies" => "Felhasználó fórum válaszai",
"Forum replies" => "Fórum válaszok",
"MyInfo" => "Személyes információim",
"Contacts Preferences" => "Kontakt preferenciák",
"Notepad" => "Jegyzettömb",
"MyFiles" => "Fájljaim",
"My Watches" => "Figyeléseim",
"Sent editions" => "Kiküldött változatok",
"Sent Edition" => "Küldött szerkesztés",
"HTML version" => "HTML verzió",
"Text version" => "Szöveges verzió",
"Delete errors" => "Hibák törlése",
"Not sent" => "Nem került elküldésre",
"Subscribe to Newsletter" => "Feliratkozás Hírlevélre",
"Subscribe to this Newsletter" => "Feliratkozás erre a hírlevélre",
"Available Newsletters" => "Elérhető hírlevelek",
"Notes" => "Jegyzetek",
"Write a note" => "Jegyzet írása",
"quota" => "Kvóta",
"No notes yet" => "Nincsenek még jegyzeteim",
"Merge selected notes into" => "A kiválasztott jegyzeteket egyesítésem ebben:",
"Reading note:" => "Jegyzet olvasása:",
"List notes" => "Jegyzetek listázása",
"Write note" => "Jegyzet írása",
"Wiki Create" => "Wiki létrehozása",
"Wiki Overwrite" => "Wiki felülírása",
"Object Watches:" => "Objektum figyelések:",
"Assign global permissions" => "Globális jogosultságok kiosztása",
"Assign permissions to " => "Jogosultságok megadása: ",
"Edit Permissions" => "Jogosultságok szerkesztése",
"Currently editing Global permissions." => "Globális jogosultságok szerkesztése folyamatban",
"To edit global permissions" => "Globális jogosultságok szerkesztéséhez",
"Assign permissions to this category" => "Jogosultságok kiosztása a kategóriában",
"Assign permissions to this object" => "Jogosultságok hozzárendelése ehhez az objektumhoz",
"Paste" => "Beillesztés",
"Assign or remove permissions on <em>all</em> child categories" => "Jogosutlságok hozzárendelése/eltávolítása az <em>összes</em> alárendelt kategóriában",
"Previous version of assign permissions page can still be found" => "Megtalálható a jogosultság osztó oldal egy korábbi változata",
"Select groups" => "Csoportok kiválasztása",
"These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab." => "Ezen csoportoknak nincs jogosultságok az objektumhoz, ezek mindössze azon csoportok melyek az első fülön is láthatóak",
"Select only groups that have a perm with the object" => "Az objektumhoz jogosultsággal rendelkező csoportok kiválasztása",
"Select all" => "Összes kiválasztása",
"Select features" => "Funkciók kiválasztása",
"Show permissions for disabled features" => "Kikapcsolt funkciók jogosultságainak megjelenítése",
"Feature name" => "Funkció neve",
"Quick Permissions" => "Gyors jogosultág kiosztás",
"Your OpenID identity is valid" => "Az OpenID identitás valid",
"Select account" => "Fiók kiválasztása",
"Orphan Pages" => "Árva oldalak",
"Browser not supported" => "Nem támogatott böngésző",
"Rename" => "Átnevezés",
"Similar" => "Hasonló",
"Make Structure" => "Struktúra létrehozása",
"Slides" => "Bemutató",
"Discuss" => "Megbeszélés",
"Attach File" => "Mellékletek",
"1 File Attached" => "1 csatolt fájl",
"{\$atts|@count} files attached" => "{\$atts|@count} melléklet",
"History:" => "Előzmények:",
"Show Edit Sessions" => "Szerkesztési munkamenetek megjelenítése",
"(current)" => "(jelenlegi)",
"Rollback to this version" => "Visszaállítás erre a verzióra",
"s=source" => "s=source (forrás)",
"b=rollback" => "b=rollback (visszaállítás)",
"Edit Comment" => "Szerkesztési megjegyzés",
"Update Translation" => "Fordítás frissítése",
"Hide translation history" => "Fordítási változások elrejtése",
"Show translation history" => "Fordítási változások megjelenítése",
"Request" => "Kérés",
"Avatar:" => "Avatár:",
"Pick your avatar" => "Avatar kiválasztása",
"Your current avatar" => "Jelenlegi avatárom",
"no avatar" => "Nincs avatár",
"Pick avatar from the library" => "Avatár kiválasztása könyvtárból",
"Pick user Avatar" => "Felhasználói avatár kiválasztása",
"Hide all" => "Összes elrejtése",
"icons" => "ikon",
"Show all" => "Összes mutatása",
"Avatar Image" => "Avatár kép",
"random" => "véletlenszerű",
"Upload your own avatar" => "Saját avatár feltöltése",
"File (only .gif, .jpg and .png images approximately 45px × 45px)" => "Fájl (csak .gif, .jpg és .png kitejesztésű képek kb 45px × 45px méretben)",
"Body" => "Törzs",
"Insert" => "Beszúrás",
"Plugin Approval" => "Plugin jóváhagyása",
"View Results" => "Eredmények megtekintése",
"Vote poll" => "Szavazás",
"Other Polls" => "Egyéb szavazások",
"votes" => "szavazat",
"Rating:" => "Értékelés:",
"Topic image" => "Téma kép",
"The original document is available at" => "Az eredeti dokumentum itt érhető el:",
"Print multiple pages" => "Oldalak tömeges nyomtatása",
"Selected Structures" => "Kiválasztott struktúrák",
"Add Structure" => "Struktúra hozzáadása",
"No structures" => "Nincsenek struktúrák",
"No pages" => "Nincsnek oldalak",
"Add Page" => "Oldal hozzáadása",
"Remove Page" => "Oldal eltávolítása",
"Selected Pages" => "Kiválaszott oldalak",
"No pages selected." => "Nincsenek oldalak kiválasztva",
"Add Pages from Structures" => "Oldalak hozzáadása struktúrákból",
"Current Version" => "Jelen verzió",
"General Options" => "Általános beállítások",
"Publication Date" => "Publikálás dátuma",
"Grading method " => "Osztályozási módszer",
"Publish statistics " => "Statisztikák publikálása",
"Extra Options" => "Extra opciók",
"Quiz result stats" => "Kvíz eredményeinek statisztikája",
"Time" => "Idő",
"User answers" => "Felhasználói válaszok",
"Stats for quizzes" => "Kvízek statisztikája",
"taken" => "kitöltött kvíz",
"Av score" => "Átlagos eredmény",
"Av time" => "Átlagos idő",
"Clear Stats" => "Statisztika törlése",
"time taken" => "eltöltött idő",
"Average" => "Átlag",
"Top 10" => "Első 10",
"Top 20" => "Első 20",
"Top 50" => "Első 50",
"Top 100" => "Első 100",
"Rank" => "Rang",
"expires:" => "elévül:",
"star" => "csillag",
"half star" => "fél csillag",
"Received articles" => "Fogadott cikkek",
"Edit received article" => "Beérkezett cikk szerkesztése",
"Use Image" => "Kép használata",
"Image x size" => "Kép x méret",
"Image y size" => "Kép y méret",
"Image name" => "Kép neve",
"Accept Article" => "Cikk elfogadása",
"Site" => "Oldal",
"Received Pages" => "Oldal fogadása",
"Edit Received Page" => "Beérkezett oldal szerkesztése",
"Received Structures" => "Beérkezett struktúrák",
"Referer stats" => "Hivatkozási statisztika",
"Last" => "Utolsó",
"Register as a new user" => "Regisztrálás új felhasználóként",
"Associate OpenID with an existing Tikiwiki account" => "OpenID hozzákapcsolása létező Tikiwiki fiókhoz",
"Send me my Password" => "Küldd el a jelszóm",
"Request Password Reset" => "Jelszóváltoztatás kérése",
"Last Version" => "Legutóbbi verzió",
"Back to page" => "Vissza az oldalra",
"You are about to remove the page" => "Ezzel eltávolításra kerül a lap",
"permanently" => "oldalt",
"Remove all versions of this page" => "Az oldal összes verziójának eltávolítása",
"to version" => "verzióra",
"Searched" => "Keresések száma",
"Search in" => "Keresés itt",
"Simple search" => "Egyszerű keresés",
"No pages matched the search criteria" => "Nincs a keresési kritériumoknak megfelelő oldal",
"Advanced Search Help" => "Részletes keresés súgó",
"All dates" => "Összes dátum",
"Calendar Items" => "Naptár tételek",
"Prepare a newsletter to be sent" => "Kiküldendő hírlevél szerkesztése",
"Data HTML:" => "Adat HTML:",
"Must be wiki parsed:" => "Wiki által elemzettnek kell lennie:",
"Data Txt:" => "Adat Txt:",
"Article Clip (read only):" => "Cikk csatolás (csak olvasható):",
"Clip Now" => "Csatolás most",
"To include the article clipping into your newsletter, cut and paste it into the contents." => "Cikkek beillesztésének lehetőségéhez ki kell vágni és be kell illeszteni a tartalomba.",
"If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending." => "Amennyiben az automatikus cikk csatolás be van kapcsolva akkor elég megadni ezt a formulát: \"~~~articleclip~~~\" (kiküldés során automatikusan beillesztésre kerül a legutóbbi tartalom)",
"Attached Files" => "Mellékelt fájlok",
"remove" => "eltávolítás",
"To add a file, click here" => "Kattintás ide fájl hozzáadásához",
"Reply To Email" => "Válasz E-mail cím",
"if not:" => "egyébként",
"Save as Draft" => "Mentés piszkozatként",
"Send objects" => "Objektumok küldése",
"Transmission results" => "Átvitel eredménye",
"Send Wiki Pages" => "Wiki oldalak küldése",
"Send a structure" => "Struktúra küldése",
"Send Articles" => "Cikkek küldése",
"Add Article" => "Cikk hozzáadása",
"Send objects to this site" => "Objektumok küldése erre az oldalra",
"Short link" => "Rövid link",
"Your message" => "Üzenet szövege",
"I found an interesting page that I thought you would like." => "Találtam itt egy oldalt ami szerintem érdekelni fog, ha van időd, nézz rá, üdv,",
"Send via e-Mail" => "Küldés E-mailben ",
"Recipient(s)" => "Címzett(ek)",
"Separate multiple email addresses with a comma." => "Több E-mail cím is megadható vesszőkkel elválasztva",
"Your name" => "Küldő neve",
"Your email" => "Küldő E-mail címe",
"Separate multiple recipients with a comma." => "Több címzettet vesszővel elválasztva kell megadni",
"Share access rights" => "Hozzáférési jogok megosztása",
"Spreadsheets" => "Táblázatok",
"Available Sheets" => "Táblázatok listája",
"Create a sheet" => "Táblázat létrehozása",
"Makes this sheet a \"child\" sheet of a multi-sheet set" => "Táblázat gyűjtemény \"gyermek\" táblázatává teszi ezt a táblázatot",
"Change shoutbox general settings" => "Az üzenőfal általános beállításai",
"auto-link urls" => "URL-ek automatikus linkelése",
"Post or edit a message" => "Üzenet szerkesztése vagy elküldése",
"Location : " => "Hely : ",
"page: %0/%1" => "oldal: %0/%1",
"Last edited by" => "Utoljára szerkesztette:",
"based on work by" => "a következő felhasználó munkája alapján:",
"Contributors to this page" => "Hozzájárulók az oldal szerkesztéséhez",
"Accounts" => "Fiókok",
"Save changes" => "Változások mentése",
"Clean" => "Törlés",
"Most viewed objects" => "Leglátogatottabb objektumok",
"Most viewed objects in the last 7 days" => "Leglátogatottabb objektumok az elmúlt 7 napban",
"Site Stats" => "Általános weblap statisztika",
"Total pageviews" => "Összesen ennyiszer tekintették meg az oldalakat",
"Average pageviews per day" => "Naponta átlagosan ennyiszer tekintették meg az oldalakat",
"Wiki Stats" => "Wiki oldal statisztika",
"Size of Wiki Pages" => "Wiki oldalak mérete",
"Average page length" => "Wiki oldalak átlagos mérete (forrásban)",
"Average versions per page" => "Az oldalaknak átlagosan ennyi verziójuk van",
"Visits to wiki pages" => "Látogatások a Wiki oldalakban",
"Average links per page" => "Wiki oldalak átlagos hivatkozásainak száma",
"Image galleries Stats" => "Képgaléria statisztika",
"Average images per gallery" => "Képek átlagos száma galériánként",
"Total size of images" => "Képek összes mérete",
"Average image size" => "Egy kép átlagos mérete",
"Visits to image galleries" => "Látogatások a képgalériákban",
"File galleries Stats" => "Fájlgaléria statisztika",
"Average files per gallery" => "Fájlok átlagos száma galériánként",
"Total size of files" => "Fájlok összes mérete",
"Average file size" => "Egy fájl átlagos mérete",
"Visits to file galleries" => "Látogatások a fájlgalériákban",
"CMS Stats" => "CMS statisztika",
"Total reads" => "Összes olvasás",
"Average reads per article" => "Cikkek átlagos olvasottsága",
"Total articles size" => "Cikkek teljes mérete",
"Average article size" => "Cikkek átlagos mérete",
"Forum Stats" => "Fórum statisztika",
"Total topics" => "Összes téma",
"Average topics per forums" => "Átlagos témák száma fórumonként",
"Total replies" => "Összes válasz",
"Average number of replies per topic" => "Válaszok átlagos száma témánként",
"Visits to forums" => "Látogatások a Fórumokon",
"Blog Stats" => "Blog statisztika",
"Weblogs" => "Webblogok",
"Total posts" => "Összes poszt",
"Average posts per weblog" => "Posztok átlagos száma blogonként",
"Total size of blog posts" => "Blogposztok teljes mérete",
"Average posts size" => "Posztok átlagos mérete",
"Visits to weblogs" => "Webblogok látogatottsága",
"Poll Stats" => "Szavazás statisztika",
"Total votes" => "Összes szavazat",
"Average votes per poll" => "Szavazatok átlagos száma szavazásonként",
"FAQ Stats" => "Gyik statisztika",
"Total questions" => "Összes kérdés",
"Average questions per FAQ" => "Kérdések átlagos száma témánként",
"User Stats" => "Felhasználó statisztika",
"Average bookmarks per user" => "Könyvjelzők átlagos száma felhasználónként",
"Average questions per quiz" => " Kérdések átlagos száma kvízenként",
"Quizzes taken" => "Kitöltött kvízek száma",
"Average quiz score" => "Kvízek átlagos eredménye",
"Average time per quiz" => "Átlagos idő kvízenként",
"Usage chart" => "Használati diagram",
"Usage chart image" => "Használati diagram kép",
"Daily Usage" => "Napi használat",
"Tiki Logs" => "Tiki logok",
"Clean logs older than" => "Összes olyan log törlése mely idősebb mint",
"Time Left" => "Hátralévő idő",
"Send Answers" => "Kérések küldése",
"Thank you for your submission" => "Köszönjük a beküldést",
"Send a link to a friend" => "Link küldése ismerősnek",
"Your email was sent" => "Az E-mail elküldésre került",
"The link was sent to the following addresses:" => "A link a következp címekre került elküldésre:",
"Friend's email" => "Ismerős E-mail címe",
"Show Page Differences" => "Oldaleltérések megjelenítése",
"Delete this link" => "Ezen link törlése",
"Theme is selected as follows" => "A stílus a következo sorrendben kerül kiválasztásra",
"If a theme is assigned to the individual object that theme is used." => "Ha az adott objektumhoz stílus van megadva, akkor az lesz használva",
"If not then if a theme is assigned to the object's category that theme is used" => "Ha nincs megadva, akkor az objektum kategóriájához rendelt,",
"If not then a theme for the section is used" => "Ha az sincs, akkor a szekció stílusa, ",
"If none of the above was selected the user theme is used" => "Ha az sincs akkor a felhasználó általi preferált stílus,",
"Finally if the user didn't select a theme the default theme is used" => "és végül ha az sincs megadva akkor az oldal alapértelmezett stílusa kerül felhasználásra",
"Control by Objects" => "Objektumonkénti vezérlés",
"Control by Sections" => "Szekciónkénti vezérlés",
"Assign themes to categories" => "Stílusok hozzárendelése kategóriákhoz",
"Assigned categories" => "Hozzárendelt kategóriák",
"Theme Control Center: Objects" => "Stílusvezérlés: Objektumok",
"Control by Categories" => "Kategóriánkénti vezérlés",
"Assign themes to objects" => "Stílus hozzárendelése objektumokhoz",
"Assigned objects" => "Hozzárendelt objektumok",
"Assign themes to sections" => "Stílus hozzárendelése szekciókhoz",
"Assigned sections" => "Hozzárendelt szekciók",
"Simple mode" => "Egyszerű mód",
"The following file was successfully uploaded" => "A következő fájl sikeresen feltöltésre került",
"The following files have been successfully uploaded" => "A következő fájlok sikeresen feltöltésre kerültek",
"You can download this file using" => "Link a fájl letöltéséhez",
"You can link to the file from a Wiki page using" => "Link a fájlhoz Wiki oldalról",
"You can display an image in a Wiki page using" => "Kép megjelenítéséhez Wiki oldalon",
"You can link to the file from an HTML page using" => "Link a fájlhoz HTML oldalról",
"You locked the file" => "A fájl zárolásra került",
"File title:" => "Fájl neve:",
"required field for podcasts" => "podcast-okhoz szükséges",
"File description:" => "Fájl leírása:",
"Unzip zip files" => "Zip fájlok kitömörítése",
"Add File" => "Fájl hozzáadása",
"Maximum file size is around:" => "Maximális fájlméret (körülbelül):",
"Batch Upload Results" => "Tömeges (kötegelt) feltöltés eredménye",
"Upload successful!" => "A feltöltés sikeres!",
"The following image was successfully uploaded" => "Az alábbi kép sikeresen feltöltésre került",
"You can view this image in your browser using" => "Ezt a képet meg lehet nézni a böngészőből ennek használatával",
"or use filename" => "vagy fájlnév használata",
"Now enter the image URL" => "A kép URL-jének beírása",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Előnézeti kép (opcionális, felülírja az automatikusan generáltat)",
"No gallery available." => "Nincs elérhető galéria.",
"You have to create a gallery first!" => "Először létre kell hozni egy galériát!",
"Restore defaults" => "Alapértékek visszaállítása",
"top" => "felülre",
"Folders" => "Mappák",
"Remove Folder" => "Mappa eltávolítása",
"Refresh Cache" => "Cache frissítése",
"Admin folders and bookmarks" => "Mappák és könyvjelzők beállítása",
"a folder" => "(mappa)",
"a bookmark" => "(könyvjelző)",
"User Contacts Preferences" => "Felhasználói kontaktok beállításai",
"Manage Fields" => "Mezők kezelése",
"Send me a message" => "Üzenj nekem!",
"Basic Data" => "Alapadatok",
"Assign Group" => "Csoport hozzárendelése",
"Change user preferences" => "Felhasználói preferenciák megváltoztatása",
"(non public)" => "(nem publikus)",
"Personal Wiki Page" => "Személyes Wiki oldal",
"User Contribution" => "Felhasználói hozzájárulások",
"has contributed to the following content" => "a következőket hozta létre",
"Forum comments" => "Fórum kommentek",
"Send Me A Message" => "Üzenj nekem",
"Send me a message !" => "Üzenj nekem !",
"The following message will be sent to user" => "Az alábbi üzenet kerül elküldésre a felhasználóhoz",
"Message Body" => "Üzenet szövege",
"Personal Information" => "Személyes adatok",
"Real Name:" => "Valódi név:",
"Male" => "Férfi",
"Female" => "Nő",
"Country:" => "Ország:",
"Use Google Map locator" => "Google Map lokátor használata",
"Last login:" => "Legutóbbi bejelentkezés:",
"Is email public? (uses scrambling to prevent spam)" => "E-mail nyilvános? (van spamvédelem)",
"Unavailable - please set your e-mail below" => "Nem elérhető - be kell állítani az E-mail címet lentebb",
"Does your mail reader need a special charset" => "Levelezőkliens speciális karakterkészlete:",
"Can you read more languages?" => "További nyelvek amiket értek",
"Other languages you can read (select on the left to add to the list on the right):" => "További olyan nyelvek megadása amiket tudok olvasni (bal oldalon kiválasztás, jobb oldalon a lista):",
"Select language..." => "Nyelv kiválasztása..",
"Number of visited pages to remember:" => "A nyilvántartott látogatott lapok száma:",
"Displayed time zone:" => "Megjelenített időzóna:",
"Detect user timezone if browser allows, otherwise site default" => "Felhasználói időzóna felismerése (ha a böngésző lehetővé teszi), egyébként az oldal alapértelmezettje",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "Felhasználói információk megjelenítése egér felhasználói név felé mozgatásakor minden olyan felhasználónál aki publikussá teszi adatait",
"Use double-click to edit pages:" => "Oldal szerkesztése duplakattintással:",
"Notify sender when reading his mail" => "Szerző értesítése levél olvasásakor",
"Send me an email for messages with priority equal or greater than:" => "E-mail küldése azokról az üzenetekről melyek prioritása legalább::",
"Auto-archive read messages after x days" => "Olvasott üzenetek automatikus arhíválása X nap után",
"never" => "soha",
"My user items" => "Felhasználói tételeim",
"My level" => "Szintem",
"Account Information" => "Felhasználói fiók információ",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "A jelenlegi jelszó megtartásához az \"Új jelszó\" és az \"Új jelszó megerősítése\" mezőket üresen kell hagyni",
"Email address:" => "E-mail cím:",
"Confirm new password:" => "Új jelszó megerősítése:",
"Current password (required):" => "Jelenlegi jelszó (kötelező):",
"Account Deletion" => "Fiók törlése",
"Check this box if you really want to delete the account" => "Be kell jelölni ha tényleg törölni szeretnénk a fiókot",
"Delete the account:" => "Fiók törlése:",
"New task" => "Új feladat",
"Task list" => "Feladat lista",
"Admin mode off" => "Adminisztrátor mód ki",
"Admin mode on" => "Adminisztrátor mód be",
"Task help" => "Feladat súgó",
"Empty Trash" => "Lomtár ürítése",
"Received task" => "Kapott feladatok",
"You received this task, please read and execute it" => "Ez a feladat kiosztásra került, olvasás után kérünk hajtsd végre",
"Send task" => "Feladat küldése",
"You send this task to a other user" => "A feladat más felhasználóra lett kiosztva",
"Shared task" => "Megosztott feladat",
"This task is public to a special group" => "Ez a feladat egy adott csoport számára lett kiosztva",
"Accepted by Task User and Creator" => "Elfogadva a feladat felhasználója és létrehozója által",
"Accepted User and Creator" => "Elfogadó felhasználó és létrehozó",
"Task is accepted by user and creator" => "Feladat elfogadva felhasználó és létrehozó által",
"Not Accepted by One User" => "Egy felhasználó nem fogadta el",
"Task is rejected by one user" => "A feladatot egy felhasználó elutasította",
"Waiting for Me" => "Rám vár",
"Task is not accepted by you, read the task and accept or reject it" => "A feladatot még nem fogadtad el, kérünk olvasd el és fogadd vagy utasítsd el",
"Waiting for Other User" => "Másik felhasználóra vár",
"Task is not accepted/rejected by other user" => "Más felhasználó nem fogadta / utasította el a feladatot",
"Admin Mode" => "Adminisztrátor mód",
"Edit Task" => "Feladat szerkesztése",
"NOT accept" => "Visszautasítás",
"Remove from Trash" => "Eltávolítás lomtárból",
"Move into Trash" => "Lomtárba helyezés",
"Task saved" => "Feladat elmentve",
"View Task" => "Feladat megtekintése",
"Open a new task" => "Új feladat megnyitása",
"taskId" => "feladat azonosítója",
"Task user" => "Feladat felhasználója",
"Only the creator can delete this task" => "Csak a feladat létrehozója törölheti a feladatot",
"Use start date and time" => "Kezdési dátum és idő használata",
"Use end date and time" => "Befejezési dátum és idő használata",
"Open / In Process" => "Nyitva / Folyamatban",
"Waiting / Not Started" => "Várakozó / Nincs elkezdve",
"Percentage completed" => "Kész (százalékban)",
"Shared for Group" => "Megosztva csoport részére",
"Accepted by User" => "Felhasználó által elfogadva",
"No / Rejected" => "Nem / Elutasítva",
"Accepted by Creator" => "Létrehozó által elfogadva",
"This message will be send to users if you are makeing changes of assigned tasks" => "Ez az üzenet kerül kiküldésre a felhasználók felé ha módosítjuk a kiosztott feladatokat",
"Send message with changes" => "Üzenet küldése a változásokkal együtt",
"Modified by" => "Módosította",
"Marked as deleted" => "Megjelölve töröltként",
"Inform task user by email" => "Feladat felhasználójának tájékoztatása E-mailben",
"You can only view this task" => "Csak a feladat megtekintéséhez elegendő a jogosultság",
"Completed" => "Befejezve",
"No tasks entered" => "Nincs bevitt feladat",
"Select One" => "Egy kiválasztása",
"Undo Trash" => "Lomtár visszaállítása",
"Show:" => "Megjelenítés:",
"Received" => "Fogadott",
"Submitted" => "Elküldött",
"Shared" => "Megosztott",
"All Shared Tasks" => "Összes megosztott feladat",
"completed (100%)" => "kész (100%)",
"Monthly" => "Havi",
"My watches" => "Figyelések",
"Use \"watches\" to monitor wiki pages or other objects." => "Használjuk a \"Figyelés\" funkciót wiki oldalak vagy más objektumok monitorozására.",
"Watch new items by clicking the {icon _id=eye} button on specific pages." => "Új figyelendő tételeket a {icon _id=eye} ikonra kattintva vehetünk fel a meghatározott oldalakon",
"Add Watch" => "Figyelés hozzáadása",
"Select event type" => "Esemény típus kiválasztása",
"All watched events" => "Összes figyelt esemény",
"A user submits an article" => "Felhasználó cikket küld",
"A user submits a blog post" => "Felhasználó blogot küld be",
"A user posts a forum thread" => "Felhasználó fórumtémát (thread) nyit",
"A user posts a forum topic" => "Felhasználó fórumtémát (topic) nyit",
"A user edited a wiki page" => "Felhasználó wiki oldalt szerkeszt",
"A user created a wiki page in a language" => "Felhasználó wiki oldalt hoz létre egy nyelven",
"A user edits an article" => "Egy felhasználó cikket szerkeszt",
"A user deletes an article" => "Egy felhasználó cikket töröl",
"Used space:" => "Felhasznált terület:",
"up to" => "határ",
"no limit for admin" => "adminisztrátor számára nincs határ",
"May need to refresh twice to see changes" => "Lehet, hogy kétszer is frissíteni kell az oldalt a változások láthatóvá tételéhez",
"Add top level bookmarks to menu" => "Felsőszintű könyvjelzők hozzáadása menühöz",
"Add or edit an item" => "Elem hozzáadása/szerkesztése",
"New Window" => "Új ablak",
"replace window" => "ablak lecserélése",
"No articles yet." => "Nincsenek még létrehozva cikkek.",
"Add an article" => "Cikk létrehozása",
"Weekdays" => "Hétköznapok",
"mon" => "hétfő",
"tue" => "kedd",
"wed" => "szerda",
"thu" => "csütörtök",
"fri" => "péntek",
"sat" => "szombat",
"sun" => "vasárnap",
"Edit Blog" => "Blog szerkesztése",
"Monitor this Blog" => "Blog figyelése",
"Stop Monitoring this Blog" => "Blog figyelésének felfüggesztése",
"Answers" => "Válaszok",
"Forum List" => "Fórum lista",
"Edit Forum" => "Fórum szerkesztése",
"Editing:" => "Szerkesztés:",
"Post New" => "Új feladása",
"Summary" => "Összefoglalás",
"Editing posts:" => "Posztok szerkesztése",
"for links" => "formátumot linkek megadásához",
"HTML tags are not allowed inside posts" => "HTML tag-ek nem szerepelhetnek a posztokban",
"Moderator Actions" => "Moderátori akciók",
"Move Selected Topics" => "Kiválasztott témák mozgatása",
"Unlock Selected Topics" => "Kiválasztott témák feloldása",
"Lock Selected Topics" => "Kiválasztott témák zárolása",
"Delete Selected Topics" => "Kiválasztott témák törlése",
"Merge" => "Összeolvasztás",
"Merge Selected Topics" => "Kiválasztott témák egyesitése",
"Queued Messages:" => "Sorbanálló hozzászólások:",
"Forum Lock" => "Fórum zárolása",
"No topics yet" => "Még nincsenek témák",
"Filter Posts" => "Posztok szűrése",
"Posts Filtering" => "Posztok szűrése",
"Last post date" => "Legutóbbi poszt dátuma",
"All posts" => "Minden üzenet",
"Last hour" => "Utóbbi óra",
"Last 24 hours" => "Utóbbi 24 óra",
"Last 48 hours" => "Utóbbi 48 óra",
"Containing posts by" => "Posztoló",
"normal" => "normál",
"announce" => "kihirdetés",
"hot" => "forró",
"Posts with no replies" => "Válasz nélküli posztok",
"Topic List" => "Téma lista",
"prev topic" => "előző téma",
"next topic" => "következő téma",
"Print this page only" => "Csak ezen oldal nyomtatása",
"Print all pages" => "Összes oldal nyomtatása",
"Show posts" => "Bejegyzések megjelenítése",
"Jump to forum" => "Ugorj a fórumra",
"Tiki Sheet" => "Tiki ív",
"No parse" => "Nincs wiki elemzés",
"Stop Monitor" => "Figyelés felfüggesztése",
"Insert New Item" => "Új tétel hozzáadása",
"Edit Fields" => "Mezők szerkesztése",
"Tracker Items" => "Űrlap tételek",
"Items found:" => "Talált tételek:",
"atts" => "mellékletek",
"List Attachments" => "Mellékletek listázása",
"View inserted item" => "Hozzáadott tétel megtekintése",
"View Item" => "Tétel megtekintése",
"Edit/Delete" => "Szerkesztés / Törlés",
"close" => "bezárás",
"Show All" => "Összes megjelenítése",
"Refresh now" => "Frissítés most",
"This is the staging copy of" => "Ez egy előkészítési példánya ennek az oldalnak:",
"Approve changes" => "Változások jóváhagyása",
"Parent page" => "Felettes oldal",
"Child" => "Alárendelt oldal",
"View edit icons" => "Szerkesztési ikonok megtekintése",
"3d browser" => "3D böngésző",
"Page is NOT being monitored. Click icon to START monitoring." => "Oldal figyelése kikapcsolva, indításhoz katt az ikonra",
"Page IS being monitored. Click icon to STOP monitoring." => "Figyelés bekapcsolva, leállításhoz katt az ikonra",
"Following fields are incorrect" => "A következő mezők hibásak",
"Other:" => "Egyéb:",
"Human Translations" => "Ember általi fordítások",
"Machine Translations" => "Gépi fordítások",
"Message sent to" => "Az üzeneted elküldve. Címzettje:",
"Page last modified on %0 by %1" => "Oldal legutóbbi módosítása: %0 %1 által",
"Created by %0" => "Létrehozta %0",
"Last Modification: %0 by %1" => "Legutóbbi módosítás: %0 %1 által",
"List authors:" => "Szerzők listázása:",
"as Creator &amp; Last Editor" => "Létrehozó &amp; Legutóbbi szerkesztő",
"no (disabled)" => "nincs (kikapcsolva)",
"Save the page as a partial translation." => "Oldal mentése részleges fordításként",
"Partial Translation" => "Részleges fordítás",
"Save the page as a completed translation." => "Oldal mentése teljes fordításként",
"Complete Translation" => "Teljes fordítás",
"Save the page, but do not count it as new content to be translated." => "Menti az oldal változásait, de azok nem számítanak lefordítandó új tartalomnak",
"Save the page, but do not send notifications and do not count it as new content to be translated." => "Oldal mentése, de a kapcsolódó üzenetek nem kerülnek kiküldésre és nem számít lefordítandó tartalomnak",
"Save Minor Edit" => "Kis mentés",
"Save the page." => "Az oldal mentése",
"Save Draft" => "Piszkozat mentése",
"Administration" => "Adminisztráció",
"Enable/disable Tiki features here, but configure them elsewhere" => "Különböző funkciók aktiválása vagy deaktiválása (a konfigurálásukat máshol kell elvégezni)",
"General preferences and settings" => "Általános tulajdonságok és beállítások",
"User registration, login and authentication" => "Felhasználói regisztráció, bejelentkezés és azonosítás",
"Wiki settings" => "Wiki beállítások",
"Article/CMS settings" => "Cikk/CMS beállítások",
"Poll comments settings" => "Szavazás kommentjeinek beállítása",
"Configuration options for all blogs on your site" => "Beállítási lehetőségek a weblap összes blogja számára",
"Forums settings" => "Fórumok beállítása",
"FAQ comments settings" => "GYIK kommentek beállítása",
"Trackers settings" => "Űrlapok beállítása",
"Directory settings" => "Könyvtár beállítása",
"Meta Tags settings" => "Meta címkék beállítása",
"Search settings" => "Keresés beállításai",
"Score settings" => "Pontszámozás beállítása",
"Community settings" => "Közösség beállításai",
"Calendar settings" => "Naptár beállítása",
"Intertiki settings" => "Intertiki beállítások",
"Freetags settings" => "Címkék beállítása",
"Customize look and feel of your Tiki" => "Tiki stílusának testreszabása",
"Configure Site Ads and Banners" => "Hirdetések és bannerek konfigurálása",
"silver" => "ezüst",
"Click here to delete the category:" => "Kategória törlésének megerősítése:",
"Upload failed" => "Sikertelen feltöltés",
"All posted" => "Minden elküldött",
"Queue anonymous posts" => "Névtelen hozzászólások sorbaállítása",
"Queue all posts" => "Összes hozzászólás sorbaállítása",
"No attachments" => "Nincsenek mellékletek",
"Everybody can attach" => "Bárki csatolhat",
"Only users with attach permission" => "Csak csatolási jogosultsággal rendelkezők csatolhatnak",
"Moderators and admin can attach" => "Moderátorok és adminisztrátorok csatolhatnak",
"No display" => "Nincs megjelenítés",
"Date (desc)" => "Dátum (csökk)",
"Date (asc)" => "Dátum (növ)",
"Score (desc)" => "Pontszám (csökk)",
"Replies (desc)" => "Válaszok (csökk)",
"Reads (desc)" => "Olvasottság (csökk)",
"Owner" => "Tulajdonos",
"Detected, Version:" => "Felismerve, Verzió:",
"Not detected." => "Nem található",
"Tag already exists" => "A tag már létezik ",
"Tag not found" => "nem találom a tag-ot",
"No menu indicated" => "Nincs megjeleníthető menü",
"No newsletter indicated" => "Nincs megjeleníthető hírlevél",
"A user registers" => "Egy felhasználó regisztrál",
"Any wiki page is changed" => "Bármely wiki oldal megváltozik",
"Any wiki page is changed, even minor changes" => "Bármely wiki oldal megváltozik, kisebb változások is",
"A comment in a wiki page is posted or edited" => "Wiki oldal komment létrehozásakor vagy szerkesztésekor",
"PHP error" => "PHP hiba",
"No poll indicated" => "Nincs megjeleníthető szavazás",
"safe" => "biztonságos",
"risky" => "kockázatos",
"cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config." => "Nem sikerült annak ellenőrzése hogy az upload_tmp_dir elérheto-e webböngészőn keresztül. A biztonság kedvéért ajánlott a webszerver beállításainak ellenőrzése",
"allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off." => "Az allow_url_fopen használható távoli adatok vagy szkriptek feltöltésére. Ha nem használjuk a blog funkciót akkor inkább kapcsoljuk ki",
"You do not have permission to view this page." => "Magasabb szintű jogosultágra van szükség az oldal megtekintéséhez",
"You do not have permission to edit this page." => "Magasabb szintű jogosultágra van szükség az oldal szerkesztéséhez",
"You must specify a page name, it will be created if it doesn't exist." => "Meg kell adni egy oldalnevet. Ha nincs még ilyen nevű oldal akkor új oldal lesz létrehozva ezen a néven.",
"page not added (Exists)" => "a lap nincs hozzáadva (létezik)",
"No survey indicated" => "Nincs megjeleníthető kérdoív",
"Are you sure you want to remove this topic AND all the articles related?" => "Törlésre kerüljön a téma ÉS az összes kapcsolódó cikk?",
"No tracker indicated" => "Nincs megjeleníthető űrlap",
"You don't have permission to use this feature" => "A funkció használatához magasabb szintű jogosultágra van szükség",
"Group already exists" => "A csoport már létezik",
"User doesn't exist" => "A felhasználó nem létezik",
"No records were found. Check the file please!" => "Nincsenek rekordok. Ellenőrizzük a fájlt!",
"User login is required" => "Ehhez be kell jelentkezni",
"Email is required" => "Szükséges az E-mail cím megadása",
"User is duplicated" => "A felhasználó többször létezik",
"New %s created with %s %s." => "Új %s létrehozva, a hozzátartozó %s : %s",
"Impossible to create new %s with %s %s." => "Nem lehetséges létrehozni %s ezzel: %s %s.",
"password" => "jelszó",
"rss feed disabled" => "az rss adagoló ki van kapcsolva",
"Unknown group" => "Ismeretlen csoport",
"Group doesn't exist" => "A csoport nem létezik",
"The page cannot be found" => "A lap nem található",
"It isn't possible to post in any blog. You may need to create a blog first." => "Új blogot kell készíteni a posztoláshoz!",
"You do not have permission to edit this post" => "Magasabb szintű jogosultágra van szükség a poszt szerkesztéséhez",
"Top visited blogs" => "Leglátogatottabb blogok",
"Last posts" => "Legutóbbi posztok",
"Top active blogs" => "Legaktívabb blogok",
"TOP" => "Forrás",
"Watch this category" => "Kategória figyelése",
"Nothing tagged yet" => "Még nincs felcímkézett tartalom",
"You do not have permission to access this gallery" => "Magasabb szintű jogosultágra van szükség a galériához való hozzáféréshez",
"You do not have permission to remove images from this gallery" => "Magasabb szintű jogosultágra van szükség képek eltávolításához ebbol a galériából",
"You do not have permission to rebuild thumbnails in this gallery" => "Magasabb szintű jogosultágra van szükség az elonézetek Újraépítéséhez",
"You do not have permission to rotate images in this gallery" => "Magasabb szintű jogosultágra van szükség a képek forgatásához ebben a galériában",
"No image indicated" => "Nincs kép feltüntetve",
"picture not found" => "a kép nem található",
"You do not have permission to move images from this gallery" => "Magasabb szintű jogosultágra van szükség képek mozgatásához ebbol a galériából",
"Top authors" => "Remeklo szerzők",
"Must enter a name to add a site" => "Meg kell adni egy nevet új weblap hozzáadásához",
"Must enter a url to add a site" => "Meg kell adni egy URL-t új weblap hozzáadásához",
"URL already added to the directory. Duplicate site?" => "Ez az URL már egyszer fel lett véve! Szerepeljen mégegyszer?",
"Must select a category" => "Ki kell választani egy kategóriát",
"Article not found" => "Cikk nem található",
"You do not have permission to edit this article" => "Magasabb szintű jogosultágra van szükség a cikk szerkesztéséhez",
"Banner not found" => "Banner nem található",
"You do not have permission to edit this banner" => "Nincs Elegendő a jogosultság a banner szerkesztéséhez",
"You do not have permission to edit this blog" => "Magasabb szintű jogosultágra van szükség a blog szerkesztéséhez",
"Invalid request to edit an image" => "A kép szerkesztéséhez érvénytelen kérés érkezett",
"You have permission to edit images but not in this gallery" => "A jogosultság általában elég képek szerkesztéséhez de ebben a galériában sajnos nem",
"Failed to edit the image" => "A kép módosítási kísérlete sikertelen",
"No question indicated" => "Nincs kérdés feltüntetve",
"You have to create a topic first" => "Először témát kell létrehoznod",
"You do not have permission to do that" => "Ehhez több jogosultságra van szükség",
"You do not have permission to read the template" => "A sablonok megtekintéséhez több jogosultságra van szükség",
"The SandBox is disabled" => "A Homokozó ki van kapcsolva",
"Cannot edit page because it is locked" => "Ezt az oldalt nem lehet szerkeszteni mivel zárolva van",
"Page already exists. Go back and choose a different name." => "Ilyen nevű oldal már létezik ezért más nevet kell választani",
"The translation set already contains a page in this language." => "A fordítási készlet már tartalmaz egy oldalt ezen a nyelven.",
"Top visited file galleries" => "Leglátogatottabb fájlgalériák",
"Most downloaded files" => "Legtöbbször letöltött fájlok",
"No forum indicated" => "Nincs fórum feltüntetve",
"Last forum topics" => "Legutóbbi fórum témák",
"Top topics" => "Top témák",
"Forum posts" => "Fórum hozzászólások",
"first uploaded image" => "először feltöltött kép",
"last uploaded image" => "utoljára feltöltött kép",
"first image" => "első kép",
"last image" => "utolsó kép",
"random image" => "véletlenszerű kép",
"You do not have permission to create galleries and so you cannot edit them" => "Magasabb szintű jogosultágra van szükség galéria létrehozásához és szerkesztéséhez",
"You do not have permission to edit this gallery" => "Magasabb szintű jogosultágra van szükség a galéria szerkesztéséhez",
"You do not have permission to remove this gallery" => "Magasabb szintű jogosultágra van szükség a galéria eltávolításához",
"Top images" => "Legjobb képek",
"Last images" => "Új képek",
"overwriting old page" => "régi lap felülírása",
"You do not have permission to remove articles" => "Magasabb szintű jogosultágra van szükség a cikkek eltávolításához",
"You do not have permission to remove banners" => "Nem távolíthatsz el banner-eket! Hozzáférés megtagadva...",
"You do not have permission to remove this blog" => "Magasabb szintű jogosultágra van szükség a blog törléséhez",
"Delete comments" => "Kommentek letöltése",
"Approved Status" => "Jóváhagyási státusz",
"Queued" => "Sorban áll",
"Non-existent gallery" => "Nem létező galéria",
"The file is already locked by %s" => "A fájlt már zárolta: %s",
"Remove file: " => "Fájl eltávolítása: ",
"You have to enable cookies to be able to login to this site" => "Engedélyezni kell a sütiket az oldal használatához",
"You must first setup MapServer" => "Először be kell állítani a Térképszervert",
"invalid mapfile name" => "érvénytelen mapfile név",
"edit" => "szerkesztés",
"Maps feature is not correctly setup : Maps path is missing." => "Térkép funkció nincs megfelelően beállítva, hiányzik az útvonal",
"mapfile name incorrect" => "mapfile név nem megfelelő",
"This mapfile already exists" => "Ez a mapfile már létezik",
"You do not have permission to write to the mapfile" => "Nincs elegendő jogosultság a mapfile írásához",
"You do not have permission to delete the mapfile" => "Nincs elegendő jogosultság a mapfile törléséhez",
"I could not make a copy" => "Másolat létrehozása nem sikerült",
"You do not have permission to read the mapfile" => "Nincs elegendő jogosultság a mapfile olvasásához",
"map edit" => "térkép szerkesztése",
"You dont have permission to do that" => "Nincs elegendő jogosultság ehhez az akcióhoz",
"Tiki RSS feed for maps" => "Tiki RSS feed térképek számára",
"List of maps available." => "Rendelkezésre álló térképek listája",
"File not found" => "Fájl nem található",
"The Directory is not empty" => "A könyvtár nem üres",
"Invalid file name" => "Érvénytelen fájlnév",
"Invalid files to index" => "Érvénytelen indexelendő fájlok",
"I do not know where is gdaltindex. Set correctly the Map feature" => "Gdaltindex nem található. Állítsuk be helyesen a Térkép funkciót",
"I could not create the index file" => "Az index fájl létrehozása nem sikerült",
"You must log in to use this feature" => "Először <a href=\"tiki-login_scr.php\">be kell jelentkezni</a> ehhez!",
"You do not have permission to view other users data" => "Nincs Elegendő jogosultság más felhasználók adatainak a megtekintéséhez",
"You must be logged in to subscribe to newsletters" => "Először <a href=\"tiki-login_scr.php\" alt=\"Login\">be kell jelentkezni</a> hírlevelekre való feliratkozáshoz",
"File is too big" => "A megadott fájl túl nagy!",
"No article indicated" => "Nincs ilyen cikk",
"Article is not published yet" => "A cikk még nincs publikálva",
"No post indicated" => "Nincs hozzászólás feltüntetve",
"Blog not found" => "Nincs találat",
"No pages indicated" => "Nincs oldal feltüntetve",
"You are already logged in" => "Már be van jelentkezve",
"This is not a valid mail adress" => "A megadott E-mail cím nem valid",
"Valid User Name" => "Valid felhasználónév",
"Missing Email" => "Hiányzik az E-mail cím!",
"Valid Email" => "Valid E-mail cím",
"last version" => "legutóbbi verzió",
"Error Message" => "Hibaüzenet",
"Page must be defined inside a structure to use this feature" => "Az oldalt egy struktúrán belül kell elhelyezni ahhoz hogy ezt a funkció használni lehessen",
"You cannot take this quiz twice" => "Ezt a kvízt nem lehet kétszer kitölteni!",
"Please create a category first" => "Előbb létre kell hozni egy kategóriát",
"Unknown user" => "Ismeretlen felhasználó",
"Password has been changed" => "A jelszó megváltoztatásra került",
"Email is set to %s" => "E-mail beállítva: %s",
"The passwords did not match" => "A jelszavak nem egyeznek",
"no" => "nem",
"Public for group" => "Publikus csoport részére",
"A new page is created in a language" => "Új oldal jött létre egy adott nyelven",
"No user indicated" => "Nincs felhasználó feltüntetve",
"No blog indicated" => "Nincs blog feltüntetve",
"No cache information available" => "Nincs cache-információ",
"No thread indicated" => "Nincs fórumtéma feltüntetve",
"Top pages" => "Leglátogatottabb oldalak",
"Last pages" => "Legutóbbi oldalak",
"You do not have permissions to view the maps" => "Nincs elegendő jogosultság a térképek megtekintéséhez",
"###end###"=>"###end###");
