<?php // -*- coding:utf-8 -*-
// (c) Copyright 2002-2010 by authors of the Tiki Wiki/CMS/Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.
// $Id: get_strings.php 43650 2012-10-24 16:09:26Z changi67 $
// Parameters:

// lang=xx    : only translates language 'xx',
//              if not given all languages are translated

// comments   : generate all comments (equal to close&module)

// close      : look for similar strings that are already translated and
//              generate a comment if a 'match' is made

// module     : generate comments that describe in which .php and/or .tpl
//              module(s) a certain string was found (useful for checking
//              translations in context)

// patch      : looks for the file 'language.patch' in the same directory
//              as the corresponding language.php and overrides any strings
//              in language.php - good if a user does not agree with
//              some translations or if only changes are sent to the maintainer

// spelling   : generates a file 'spellcheck_me.txt' that contains the
//              words used in the translation. It is then easy to check this
//              file for spelling errors (corrections must be done in
//              'language.php, however)

// groupwrite : Sets the generated files permissions to allow the generated
//              language.php also be group writable. This is good for
//              translators if they do not have root access to tiki but
//              are in the same group as the webserver. Please remember
//              to have write access removed when translation is finished
//              for security reasons. (Run script again without this
//              parameter)

// Examples:
// http://www.neonchart.com/get_strings.php?lang=sv
// Will translate language 'sv' and (almost) avoiding comment generation

// http://www.neonchart.com/get_strings.php?lang=sv&comments
// Will translate language 'sv' and generate all possible comments.
// This is the most usefull mode when working on a translation.

// http://www.neonchart.com/get_strings.php?lang=sv&nohelp&nosections
// These options will only provide the minimal amout of comments.
// Usefull mode when preparing a translation for distribution.

// http://www.neonchart.com/get_strings.php?nohelp&nosections
// Prepare all languages for release


// ### Note for translators about translation of text ending with punctuation
// ###
// ### The current list of concerned punctuation can be found in 'lib/init/tra.php'
// ### On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// ### For clarity, we explain here only for colons: ':' but it is the same for the rest
// ###
// ### Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// ###
// ### Technical justification:
// ### If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// ### then Tiki tries to translate 'Login' and ':' separately.
// ### This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// ### and it still allows to translate ":" as "&nbsp;:" for languages that
// ### need it (like french)

$lang=Array(
// ### Start of unused words
// ### Please remove manually!
// ### N.B. Legitimate strings may be marked// ### as unused!
// ### Please see http://tiki.org/UnusedWords for further info
"Links/Commands" => "Ссылки/Команды",
"create tag" => "создать метку",
"Anonymous users can edit pages" => "Гостям можно редактировать страницы",
"User versions" => "Пользовательские версии",
"TextFormattingRules" => "ПравилаФорматированияТекста",
"References" => "Ссылки",
"JoinCapitalizedWords" => "СлепитьСловаСЗаглавнойБуквы",
"or use square brackets for an" => "или используйте квадратные скобки для",
"link_description" => "описание_ссылки",
"Title_bar" => "Заголовок",
"img" => "img",
"printable" => "для печати",
"History of" => "История для",
"current_version" => "текущая_версия",
"All pages" => "Все страницы",
"Rollback_page" => "Страницы_отката",
"last_login" => "последний_вход",
"assign group" => "назначить группу",
"Create or edit a gallery using this form" => "Создайте или измените галерею с помощью этой формы",
"versions" => "версии",
"Perm" => "Права",
"No individual permissions global permissions to all pages apply" => "Нет индивидуальных прав доступа. На всех страницах имеют силу общие права доступа.",
"Assign permissions to this page" => "Назначить права доступа к этой странице",
"ranking" => "Рейтинг",
"list_pages" => "Список_страниц",
"my galleries" => "Мои галереи",
"You can include the image in an HTML/Tiki page using" => "Вы можете включить изображение в HTML/Tiki страницу с помощью",
"modules" => "модули",
"links" => "ссылки",
"system gallery" => "системная галерея",
"Anonymous users cannot edit pages" => "Анонимные посетители не имеют права редактировать страницы",
"You do not have permission to browse this gallery" => "У Вас недостаточно прав для просмотра этой галереи",
"view info" => "просмотр инфо",
"HasImg" => "HasImg",
"UseImg" => "UseImg",
"User preferences screen" => "Экран пользовательских настроек",
"The SandBox is a page where you can practice your editing skills, use the preview feature\nto preview the appearance of the page, no versions are stored for this page." => "Песочница - это страница,\nгде Вы можете попрактиковаться в создании реальных страниц. Для Песочницы не сохраняются версии и не\nконтролируются права доступа.",
"Configure this page" => "Настроить эту страницу",
"hotwords" => "горячие слова",
"user preferences" => "личные настройки",
"No image uploaded" => "Изображение не загружено",
"Current version" => "Текущая версия",
"Next version" => "Следующая версия",
"Programmed versions" => "Запрограммированные версии",
"Old versions" => "Старые версии",
"Edit desc" => "Правка описания",
"Index page" => "Страница индекса",
"Set prefs" => "Установка параметров",
">Remove Zones (you lose entered info for the banner)" => ">Удалить Области (будет потеряна введённая информация о баннере)",
">Block description: " => ">Описание блока: ",
"Admin content" => "Админ. содержимое",
"Warn on edit" => "Предупреждать при редактировании",
"Show comments" => "Показать комментарии",
"Hide comments" => "Скрыть комментарии",
"reply to this" => "ответить на это",
"Create or edit a file gallery using this form" => "Создайте или измените файловую галерею используя эту форму",
"Top Files" => "Лучшие файлы",
"Cannot get file from URL" => "Не удалось получить файл по URL",
"You cant download files" => "У Вас недостаточно прав для скачивания файлов",
"No file" => "Файл не существует",
"Create/edit Forums" => "Создание/правка Форумов",
"Moderator" => "Модератор",
"Cms" => "Cms",
"There are inddividual permissions set for this gallery" => "Для этой галереи заданы индивидуальные права доступа",
" modified" => " изменено",
"Show Post Form" => "Показать форму отправки сообщения",
"Hide Post Form" => "Скрыть форму отправки сообщения",
"smileys" => "смайлики",
"Edit or add category" => "Добавить/изменить категорию",
"sub categories" => "подкатегории",
"There are inddividual permissions set for this blog" => "Для этого блога заданы индивидуальные права доступа",
"Layout options" => "Расположение на странице",
"polls" => "опросы",
"features" => "возможности",
"cms" => "управление контентом",
"CMS settings" => "Настройки CMS",
"image galleries" => "фотогалереи",
"general" => "общие",
"Set home forum" => "Задать главный форум",
"file galleries" => "файловые галереи",
"rss" => "rss",
"Set feeds" => "Установить потоки",
"There are inddividual permissions set for this file gallery" => "Для этой файловой галереи были заданы индивидуальные права доступа",
"half a second" => "пол-секунды",
"Create/edit RSS module" => "Создать/изменить RSS модуль",
"Create/edit Menus" => "Создать/изменить меню",
"Admin chat" => "Управлять чатом",
"Permission denied you cant view this section" => "У Вас недостаточно прав для просмотра этой секции",
"use square brackets for an" => "используйте квадратные скобки для",
"Allowed HTML:" => "Позволено HTML:",
"Configure modules" => "Параметры модулей",
"to insert a random tagline" => "для вставки случайной приписки",
"Use (:name:) for smileys" => "Используйте (:название:) для смайликов",
"Restoring a backup destoys all the data in your Tiki database.\nAll your tables will be replaced with the information in the backup." => "Восстановление из резервной копии уничтожит все данные в Вашей базе.\nВсе таблицы будут заменены информацией из резервной копии",
"Creating backups may take a long time. If the process is not completed you will\nsee a blank screen. If so you need to increment the maximum script execution time\nfrom your php.ini file" => "Создание резервной копии займет некоторое время. Если процесс не будет успешно завершён, вы увидите\nпустой экран. В таком случае вам потребуется увеличить максимальное время исполнения скрипта\nв вашем php.ini файле",
"Click here to create a new backup" => "Нажмите здесь для создания новой резервной копии",
"Create/edit Faq" => "Создать/редактировать ЧаВо",
"FAQ Questions" => "Вопросы ЧаВо",
"FAQ Answers" => "Ответы ЧаВо",
">I forgot my password" => ">Я забыл пароль",
"column" => "колонка",
"Show chart for the last " => "Показать график за последние ",
"days (0=all)" => "дней (0=показать все)",
"dispay" => "показать",
"Average posts pero weblog" => "В среднем сообщений на 1 блог",
"user bookmarks" => "закладки",
"Admin Cookies" => "Настройка Cookies",
"content templates" => "шаблоны содержимого",
"shoutbox" => "кричалка",
"drawings" => "рисунки",
"assigned" => "назначено",
"Hotwords in new window" => "Ключевые слова в новом окне",
"Allow smileys" => "Позволить смайлики",
"Reuse question" => "Использовать вопрос повторно",
"suggested" => "предложенный",
"wiki link" => "wiki ссылка",
"heading2" => "заголовок 2",
"heading3" => "заголовок 3",
"Show suggested questions/suggest a question" => "Показать предложенные вопросы/продложить вопрос",
"Hide suggested questions" => "Скрыть предложенные вопросы",
"Create/edit templates" => "Создавать/редактировать шаблоны",
"categorize" => "задать категорию",
"Create/edit HTML pages" => "Создать/редактировать HTML страницы",
"Admin HTML page dynamic zones" => "Управлять динамическими зонами HTML страницы",
"Edit this HTML page" => "Редактировать HTML страницу",
"Wiki Import dump" => "Дамп импорта Wiki",
"trckrs" => "трекеры",
"frms" => "форумы",
"gral" => "общ",
"feat" => "возм",
"Server time zone" => "Часовая зона сервера",
"Wiki Page Names" => "Имена страниц Wiki",
"strict" => "строгие",
"file gls" => "файл.гал.",
"img gls" => "фотогал.",
"webmail" => "вебпочта",
"Allow viwing HTML mails?" => "Позволить просмотр HTML писем?",
"Add users" => "Добавить пользователей",
"Users can subscribe any email addresss" => "Пользователи могут подписывать любой адрес",
"Create/edit surveys" => "Создать/изменить анкеты",
"Options (separated by commas used in dropdowns only)" => "Опции (через запятую, только для выпадающих списков)",
"There are inddividual permissions set for this tracker" => "Для этого трекера заданы особые права доступа",
"Show status when listing tracker items?" => "Показывать статус при выводе элементов трекера?",
"Prevents parsing data" => "Запрещает разбор анализатором Ваших данных",
"b" => "b",
"i" => "i",
"ul" => "ul",
"tbl" => "tbl",
"a" => "a",
"h1" => "h1",
"h2" => "h2",
"h3" => "h3",
"dcs" => "dcs",
"center" => "center",
"img nc" => "img nc",
"chars" => "симв.",
"In parent page" => "На родительской странице",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appeareance of the page, no versions are stored for this page." => "Песочница - это страница, где Вы можете попрактиковаться в создании достойных страниц. Для Песочницы не сохраняются версии и не контролируются права доступа.",
"Path to where the dumped files are" => "Путь, куда свалить дамп",
"Thanks for your subscription. You will receive an email soon to confirm your subscription.\nNo newsletters will be sent to you until the subscription is confirmed." => "Спасибо, что подписались на рассылку. Вы должны получить email с просьбой подтвердить подписку.\nВы не получите ни одной рассылки, пока не подтвердите своё желание в ней участвовать.",
"checked" => "отмеченные",
"unchecked" => "неотмеченные",
"Mark as Flagged" => "Отметить флажками",
"Add or edit a category" => "Добавить/редактировать категорию",
"You cant use the same password again" => "Вы не можете использовать тот же пароль, его следует сейчас сменить",
"You have to provide a name to the file" => "Следует указать имя файла",
"parent" => "родитель",
"userfiles" => "файлы пользователя",
"Cache wiki pages" => "Кешировать страницы Wiki",
"Users can save pages to notepad" => "Пользователи могут сохранять страницы в блокнот",
"\n for rows" => "\n для строк",
"Forum settings" => "Настройки форума",
"Allow wiki markup" => "Включить разметку wiki",
"Describe topics in listing" => "Описывать темы в перечне",
"Allow viewing HTML mails" => "Включить просмотр HTML писем",
"subs" => "subs",
"objs" => "объекты",
"Admin content templates" => "Управлять шаблонами содержимого",
"Edit drawings &amp; pictures" => "Редактировать рисунки и изображения",
"Edit/Create user module" => "Создать/редактировать пользовательский модуль",
"assign_perms" => "дать права",
"rotate left" => "сдвинуть влево",
"Klick to enlarge" => "Нажмите чтобы увеличить",
"use filename" => "использовать имя файла",
"Use dbl click to edit pages" => "Двойное нажатие на страницу переходит в редактор",
"Mailin accounts" => "Учётные записи по приёму почты",
"Return to messages" => "Вернуться к сообщениям",
"Unflagg" => "Снять флажок",
"Newss from" => "Новости из",
"Control by Object" => "Управление по объектам",
"Control by category" => "Управлять по категории",
"Create/edit extwiki" => "Создать/редактировать внешние Wiki",
"URL (use  to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=)" => "URL (Используйте  чтобы заменить именем страницы URL пример: http://www.example.com/tiki-index.php?page=)",
"Admin (click!)" => "Админ (нажми!)",
"Mus enter a name to add a site" => "Следует ввести название, чтобы добавить сайт",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory" => "URL недоступен - неверный URL или сайт не подключен к интернету - проверьте опечатки и попробуйте позже",
"Users can vote only one item from this chart per period" => "Пользователи могут голосовать только один раз за период",
"Prevent users from voting same item more than one time" => "Не позволять пользователем голосовать больше одного раза по одному и тому же пункту",
"You will receive an email with your password soon" => "Скоро вы получите письмо с вашим паролем",
"Displays a snippet of code.\nSet optional paramater -+ln+- to 1 if you need line numbering feature." => "Отображает участок кода.\nУстановите необязательный параметр -+ln+- в 1 для отображения номеров строк.",
"Renders a graph" => "Сформировать график",
"PluginsHelp" => "Помощь по плагинам",
"create new empty structure" => "создать новую пустую структуру",
"Create structure from tree" => "создать структуру из дерева",
"Admin structures" => "Административная структура",
"Click twice if once is not enough !" => "Кликните дважды если одного раза недостаточно !",
"Toggle display of comment zone" => "Включить отображение комментариев",
"In blog listing show user as" => "В блогах показывать пользователя как",
"creation date" => "дата создания",
"last modification time" => "время последнего изменения",
"Articles listing configuration" => "Настройка списка статей",
"Edit css" => "Редактировать css",
"Use PHPOpenTracker" => "Использовать PHPOpenTracker",
"User watches" => "Пользовательские метки",
"PDF Export" => "PDF экспорт",
"Edit drawings" => "Редактировать рисунок",
"Threads can be voted" => "Голосование за ветвь обсуждения",
"Forward messages to this forum to this email" => "Перенаправлять сообщения в форуме на этот email",
"Directory (include trailing slash)" => "Directory (include trailing slash)",
"stat" => "стат.",
"Calendars Panel" => "Панель календарей",
"Navigation Panel" => "Панель навигации",
"Hide Panels" => "Прятать панели",
"hide from display" => "прятать с экрана",
"Tiki Calendars" => "Календари Tiki",
"browse by" => "просмотреть за",
"If you change the calendar selection, please refresh to get the appropriated list in Category, Location and people (if applicable to the calendar you choose)." => "If you change the calendar selection, please refresh to get the appropriated list in Category, Location and people (if applicable to the calendar you choose).",
"from the list" => "из списка",
"choose" => "выберите",
"You should first ask that a calendar is created, so you can create events attached to it." => "Прежде чем можно будет создавать в нем события, убедитесь, что календарь создан.",
"save a custom copy" => "сохранить свою копию",
"heading" => "заголовок",
"horizontal ruler" => "горизонтальная линия",
"acvtivate" => "активировать",
"op" => "оп",
"remove bookmark" => "удалить закладку",
"Tiki forums" => "Форумы Tiki",
"mot" => "mot",
"this post was reported" => "this post was reported",
"report this post" => "report this post",
"someone from" => "кто-то с",
"since this is our registered email address we inform that the" => "т.к. этот адрес зарегистрирован у нас, мы высылаем на него уведомление о том, что",
"If you want to be a registered user in this site you will have to use" => "Если вы желаете зарегистрироваться на этом сайте, используйте",
"the following link to login for the first time" => "следующую ссылку для входа в систему в первый раз",
"More info about" => "Подробнее о",
"idle" => "idle",
"MyTiki (click!)" => "MyTiki (click!)",
"blog_ranking_top_blogs" => "blog_ranking_top_blogs",
"blog_ranking_last_posts" => "blog_ranking_last_posts",
"blog_ranking_top_active_blogs" => "blog_ranking_top_active_blogs",
"filegal_ranking_top_galleries" => "filegal_ranking_top_galleries",
"filegal_ranking_top_files" => "filegal_ranking_top_files",
"filegal_ranking_last_files" => "filegal_ranking_last_files",
"gal_ranking_top_galleries" => "gal_ranking_top_galleries",
"gal_ranking_top_images" => "gal_ranking_top_images",
"gal_ranking_last_images" => "gal_ranking_last_images",
"Your Tiki account information for" => "Ваша информация об аккаунте Tiki",
"A new password has been sent " => "Новый пароль был отправлен ",
" new topic:" => " новая тема:",
"topic:" => "тема:",
"Current page:" => "Текущая страница:",
"version %s" => "версия %s",
"last modified on %s" => "последнее изменение %s",
"by %s" => "%s",
"Archived page:" => "Архивная страница:",
"Diff of %s." => "Diff of %s.",
"New article submitted at " => "Новая статья на ",
"Welcome to " => "Добро пожаловать в ",
" at " => " на ",
"Bye bye from " => "Bye bye from ",
"There is an error in the plugin data" => "Ошибка в данных расширения",
"Change your email" => "Сменить email",
"Could not create user.mif in data directory" => "Невозможно создать user.mif в директории данных",
"Could not create user.mid in data directory" => "Невозможно создать user.mid в директории данных",
"ExtWikis" => "ExtWikis",
"forum topic" => "тема форума",
"updated by the phpwiki import process" => "обновлено процедурой импорта phpwiki",
"created from phpwiki import" => "создано при помощи phpwiki импорта",
"File gals" => "Файл.галереи",
"Image gals" => "Фотогалереи",
"Comm" => "Комментарии",
"comm" => "комментарии",
"assgn" => "назнач.",
"Ranking" => "Рейтинг",
"Add scaled images size X x Y" => "Добавить отмасштабированные изображения размером X x Y",
"Import pages from a PHPWiki Dump" => "Импортировать страницы из дампа PHPWiki",
"Path to where the dumped files are (relative to tiki basedir with trailing slash ex: dump/)" => "Путь к файлам дампа (относительно базовой папки Tiki обязательно со слешем в конце, например dump/)",
"ver" => "Версия",
"+1d" => "+1d",
"+7d" => "+7d",
"+1m" => "+1m",
"running" => "running",
"today" => "сегодня",
"act status" => "статус акт",
"All tasks" => "Все задачи",
"mark as done" => "отметить как выполненные",
"open tasks" => "открыть задачи",
"Add or edit a task" => "Добавить или изменить задачу",
"Calendrier" => "Calendrier",
"Height of top Heading" => "Height of top Heading",
"Height of mid Heading" => "Height of mid Heading",
"Height of inner Heading" => "Height of inner Heading",
"tbheight" => "tbheight",
"Ins" => "Ins",
"perm" => "perm",
"You do not have permission to use this feature." => "У вас недостаточно прав для использования этой возможности.",
" line " => " строка ",
"Error: No" => "Ошибка: Нет",
"permission." => "разрешения.",
"Error: Invalid" => "Ошибка: Необоснованный",
"Error: Call to hw_page_fetch_by_id failed!" => "Ошибка: Вызов к hw_page_fetch_by_id не удался!",
"no description" => "без описания",
"Updated" => "Обновленно",
"requested a reminder of the password for the" => "попросил напомнить пароль на",
"password for this account is" => "текущий пароль для аккаунта",
"Blog settings" => "Настройки блога",
"FAQs settings" => "Настройки ЧаВо",
"FAQ comments" => "Комментарии в ЧаВо",
"Remind passwords by email" => "Напоминать пароли по email",
"Poll settings" => "Настройки опросов",
"Create a tag for the current wiki" => "Дать метку текущему wiki",
"Restore the wiki" => "Восстановить wiki",
"Wiki comments settings" => "Настройки комментирования Wiki",
"Wiki page list configuration" => "Настройка списков страниц Wiki",
"Like pages" => "Подобные страницы",
"Use {literal}{{/literal}ed id=name} or {literal}{{/literal}ted id=name} to insert dynamic zones" => "Использовать {literal}{{/literal}ed id=name} или {literal}{{/literal}ted id=name} для внесения динамических зон",
"Added users" => "Добавленные пользователи",
"search category" => "Поиск по категории",
"deep" => "рекурсивно",
"Emphasis" => "Ударение",
"italics" => "курсив",
"both" => "оба",
"use ...page... to separate pages" => "используйте ...page... для разделения страниц",
"make_headings" => "создать_заголовки",
"underlines text" => "подчёркивает текст",
"Simple box" => "Простой прямоугольник",
"Will display using the indicated HTML color" => "Выведет текст используя указанный HTML цвет",
"Will display the text centered" => "Изобразит текст по центру строки",
"Activs" => "Активн",
"time" => "время",
"Wiki quick help" => "Быстрая помощь по Wiki",
"Quicklinks" => "Быстрые ссылки",
"Comparing versions" => "Сравнение версий",
"Actual_version" => "Фактическая_версия",
"Diff to version" => "Отличия от версии",
"Editing tracker item" => "Редактирование элемента трекера",
"The passwords dont match" => "Пароли не совпадают",
"The passwords didn't match" => "Пароли не совпали",
"You do not have permission to write the template" => "У Вас недостаточно прав для записи шаблона",
"specified." => "определения.",
"You have to provide a name to the image" => "Следует дать имя изображению",
"The file you are trying to upload is too big." => "The file you are trying to upload is too big.",
"switch" => "switch",
"ppd" => "ppd",
"add role" => "add role",
"new minor" => "new minor",
"new major" => "new major",
"send instance" => "send instance",
"uploaded by" => "закачано",
"not specified" => "не указано",
"There was a problem with your upload." => "Проблема с трансфером.",
"The file you are trying to upload was only partially uploaded." => "Файл, который вы пытаетесь отправить, был отправлен только частично.",
"You must select a file for upload." => "Вы должны выбрать файл для отправки.",
"delete" => "удалить",
"post" => "Новое сообщение",
"stop monitoring this blog" => "прекратить наблюдение",
"posts" => "сообщений",
"visits" => "посещений",
"show categories" => "вывести категории",
"author" => "автор",
"user level" => "уровень пользователя",
"send email to user" => "отослать e-mail пользователю",
"score" => "рейтинг",
"delete selected" => "удалить выбранные",
"move" => "переместить",
"set" => "запомнить",
"replies" => "ответы",
"cancel" => "отмена",
"up" => "выше",
"down" => "ниже",
"add" => "добавить",
"create" => "создать",
"save" => "сохранить",
"send" => "отослать",
"register" => "регистрация",
"standard" => "обычный",
"secure" => "безопасный",
"stay in ssl mode" => "оставаться в безопасном ssl режиме",
"go" => "перейти",
"cache" => "кеш",
"use" => "использовать",
"refresh" => "обновить",
"print" => "печать",
"create pdf" => "создать pdf",
"monitor this page" => "наблюдать за страницей",
"stop monitoring this page" => "остановить наблюдение",
"backlinks" => "обратные ссылки",
"rename" => "переименовать",
"unlock" => "убрать блок",
"lock" => "блокировать",
"perms" => "права",
"history" => "история",
"similar" => "подобные",
"undo" => "откат",
"slides" => "слайды",
"export" => "экспорт",
"discuss" => "обсудить",
"last modification" => "последнее изменение",
"attachments" => "вложения",
"stats" => "стат",
"last changes" => "Последние правки",
"list pages" => "Список страниц",
"cancel edit" => "отменить правку",
"No attachments for this page" => "К данной странице файлы не приложены",
"view blog" => "просмотр блога",
"list blogs" => "список блогов",
"save and exit" => "сохранить и выйти",
"reads" => "прочтений",
"view comments" => "комментарии",
"flag" => "флаг",
"HomePage" => "Домашняя Страница",
"images" => "изображениях",
"Server name (for absolute URIs)" => "Имя сервера (для абсолютных ссылок)",
"Wiki_Tiki_Title" => "Описание Wiki Tiki",
"Require HTTP Basic authentication" => "Требовать HTTP Basic авторизацию",
"HTTP server name" => "Имя веб сервера",
"HTTP URL prefix" => "HTTP приставка к URL",
"HTTPS server name" => "Имя HTTPS сервера",
"HTTPS URL prefix" => "HTTPS приставка к URL",
"Only for users" => "Только для пользователей",
"Users and admins" => "Для пользователей и админов",
"Full Text Search" => "Полнотекстовый поиск",
"full" => "полные",
"Enable Feature" => "Разрешить свойство",
"loc" => "разм.",
"cat" => "кат.",
"lang" => "язык",
"prio" => "приор.",
"permissions" => "права",
"edit chart" => "редактировать чарт",
"update" => "обновить",
"use in cms" => "использовать в cms",
"use in wiki" => "использовать в wiki",
"use in newsletters" => "использовать в рассылке",
"use in HTML pages" => "использовать в HTML страницах",
"last modif" => "посл. правка",
"sections" => "секции",
"upload" => "закачать",
"dsn" => "DSN",
"extwiki" => "внеш.wiki",
"online" => "онлайн",
"topics" => "темы",
"coms" => "комментариев",
"age" => "возраст",
"last post" => "посл. сообщ.",
"position" => "позиция",
"section" => "секция",
"options" => "параметры",
"assign module" => "назначить модуль",
"left modules" => "модули слева",
"right modules" => "модули справа",
"edit/create" => "правка/создание",
"clear cache" => "очистить кеш",
"\n<b>Note 1</b>: if you allow your users to configure modules then assigned\nmodules won't be reflected in the screen until you configure them\nfrom MyTiki->modules.<br />\n<b>Note 2</b>: If you assign modules to groups make sure that you\nhave turned off the option 'display modules to all groups always'\nfrom Admin->General\n" => "\n<b>Примечание 1</b>: если Вы позволяете пользователям настраивать модули то\nназначенные модули не будут отображены на экране, пока Вы не настроите их\nиз меню MyTiki->Модули.<br />\n<b>Примечание 2</b>: Если Вы назначаете модули для групп, убедитесь, что Вы выключили опцию 'показывать модули для всех групп всегда' в меню\nАдмин->Общие",
"assign" => "назначение",
"left" => "слева",
"right" => "справа",
"order" => "порядок",
"create/edit" => "создание/правка",
"use poll" => "использовать опрос",
"use gallery" => "использовать галерею",
"use dynamic  content" => "использовать динам. содержимое",
"use rss module" => "использовать модуль rss",
"use menu" => "использовать меню",
"use banner zone" => "использовать область",
"list newsletters" => "Список рассылок",
"send newsletters" => "Отослать письма",
"editions" => "редакций",
"last sent" => "последняя отправка",
"use admin email" => "использовать адрес администратора",
"event" => "событие",
"survey stats" => "статистика анкетирования",
"edit this survey" => "правка анкеты",
"admin surveys" => "настройки анкет",
"list surveys" => "список анкет",
"questions" => "вопросов",
"files" => "файлы",
"Assign user" => "Назначить пользователя",
"List of available backups" => "Список доступных резервных копий",
"Restoring a backup" => "Восстановление резервной копии",
"Warning!" => "Внимание!",
"Restoring a backup destoys all the data in your Tiki database. All your tables will be replaced with the information in the backup." => "Востановление из резервной копии разрушит все данные в Вашей базе данных. Все Ваши таблицы будут заменены данными из резервной копии.",
"Click here to confirm restoring" => "Нажмите здесь для подтверждения восстановления",
"Create new backup" => "Создать новую резервную копию",
"Creating backups may take a long time. If the process is not completed you will see a blank screen. If so you need to increment the maximum script execution time from your php.ini file" => "Создание резервной копии может занять продолжительное время. Пока процесс сохранения не завершился, Вы будете видеть чистый экран. Если резервное сохранение прерывается автоматически, Вам может потребоваться увеличить максимальное время работы скрипта в файле php.ini",
"Upload a backup" => "Загрузить резерв",
"Upload backup" => "Загрузить резерв",
"edit gallery" => "правка галереи",
"rebuild thumbnails" => "перестроить иконки",
"upload image" => "Закачать изображение",
"list gallery" => "содержимое галереи",
"original size" => "оригинальный размер",
"return to gallery" => "вернуться в галерею",
"edit image" => "редактировать изображение",
"smaller" => "меньше",
"bigger" => "больше",
"prev image" => "пред. картинка",
"popup window" => "всплывающее окно",
"next image" => "след. картинка",
"stop" => "остановить",
"or create a new category" => "или создайте новую категорию",
"or create a new location" => "или создайте новое расположение",
"comma separated usernames" => "имена пользователей, разделенные запятыми",
"comma separated username:role" => "имя пользователя:статус, разделенные запятыми",
"with roles" => "со статусом",
"Chair" => "Председатель",
"Optional" => "Опционально",
"permission" => "доступ",
"browse" => "просмотр",
"related" => "по теме",
"validate" => "проверить",
"add a site" => "добавить сайт",
"search" => "поиск",
"list articles" => "перечень статей",
"view articles" => "Просмотр статей",
"create zone" => "создать область",
"save the banner" => "сохранить баннер",
"display" => "вывести",
"create new block" => "создать новый блок",
"list quizzes" => "список тестов",
"quiz stats" => "статистика теста",
"edit this quiz" => "редактировать тест",
"admin quizzes" => "Управлять тестами",
"results" => "результаты",
"list submissions" => "Список поступлений",
"new question" => "новый вопрос",
"approve" => "утвердить",
"configure listing" => "настройка списка",
"topic" => "тема",
"save and approve" => "одобрить и сохранить",
"new topic" => "новая тема",
"reject" => "отклонить",
"accept" => "принять",
"add new" => "добавить новую",
"admin processes" => "настройка процессов",
"admin activities" => "настройка активностей",
"admin roles" => "настройка ролей",
"edit this process" => "изменить процесс",
"monitor" => "мониторинг",
"create new gallery" => "создать новую галерею",
"result" => "результат",
"source" => "исходный текст",
"create new blog" => "создать новый блог",
"upload file" => "закачать файл",
"Edit a file using this form" => "Редактировать файл используя форму",
"delete selected files" => "удалить выбранные файлы",
"browse gallery" => "просмотр галереи",
"Flash binary (.sqf or .dcr)" => "Shockwave Flash двоичный (.swf или .dcr)",
"edit blog" => "редактировать блог",
"edit new submission" => "Редактировать новое поступление",
"adm" => "адм",
"set as operator" => "назначить оператором",
"add topic" => "добавить тему",
"wiki create" => "создать wiki",
"wiki overwrite" => "обновить wiki",
"back" => "назад",
"Assign permissions to page" => "Назначить права доступа к странице",
"Current permissions for this page" => "Текущие права доступа к странице",
"Send email notifications when this page changes to" => "Если эта страница изменится, отослать уведомление на адрес",
"add email" => "добавить адрес",
"Notifications" => "Уведомления",
"clear stats" => "очистить статистику",
"Edit received page" => "Редактировать полученную страницу",
"last" => "последн.",
"send me my password" => "отправьте мне мой пароль",
"searched" => "произведён поиск",
"galleries" => "галереях",
"blog posts" => "сообщениях блогов",
"wiki pages" => "wiki страницы",
"clear" => "очистить",
"send answers" => "отослать ответы",
"move to right column" => "переместить в правую колонку",
"unassign" => "снять назначение",
"move to left column" => "переместить в левую колонку",
"remove folder" => "удалить папку",
"refresh cache" => "обновить кеш",
"edit items" => "изменить содержимое",
"list charts" => "список чартов",
"last chart" => "последний чарт",
"monitor this forum" => "наблюдать за этим форумом",
"stop monitoring this forum" => "прекратить наблюдение за форумом",
"delete selected topics" => "удалить отмеченные темы",
"stop monitoring this topic" => "прекратить наблюдение",
"Comments below your current threshold" => "Комментарии ниже Вашего порога видимости",
"add contacts" => "добавить контакты",
"DATE-of" => "/",
"You cannot edit this page because it is a user personal page" => "Нельзя редактировать эту страницу - это личная страница пользователя",
"Permission denied you cannot assign permissions for this page" => "У Вас недостаточно прав для назначения прав доступа к этой странице",
"You do not have permission to edit messages" => "У Вас недостаточно прав для редактирования сообщения",
"Cannot read file" => "Невозможно прочитать файл",
"Permission denied you cannot upload files" => "Отказано в доступе, Вы не можете закачивать файлы",
"cannot process upload" => "не могу обработать загрузку данных",
"Your email address has been removed from the list of addresses monitoring this tracker" => "Ваш email был удален из списка адресов наблюдения за этим трекером",
"Your email address has been added to the list of addresses monitoring this tracker" => "Ваш email был добавлен в список адресов наблюдения за этим трекером",
"Cancel monitoring" => "Отменить наблюдение",
"Your email address has been removed from the list of addresses monitoring this item" => "Ваш email был удален из списка адресов наблюдения за этим объектом",
"Your email address has been added to the list of addresses monitoring this item" => "Ваш email был добавлен в список адресов наблюдения за этим объектом",
"pdf" => "pdf",
"icon" => "icon",
"proc" => "proc",
"Com" => "Com",
"Vers" => "Верс.",
"pre" => "pre",
"queued messages:" => "сообщений в очереди:",
"pop" => "pop",
"new image uploaded by" => "новое изображение закачано",
"new subscriptions" => "новые подписки",
"new item in tracker" => "новый объект в трекере",
"message" => "сообщение",
"no such file" => "нет такого файла",
"downloads" => "загрузки",
"attach" => "вложение",
"monitor this blog" => "наблюдать за блогом",
"hide categories" => "скрыть категории",
"Admin categories" => "Управлять категориями",
"reply" => "ответить",
"monitor this topic" => "наблюдать за этой темой",
"with checked" => "с отмеченными",
"Dls" => "Скачано",
"move selected files" => "переместить выбранные файлы",
"Thank you for you registration." => "Спасибо за регистрацию.",
"compare" => "сравнить",
"diff" => "разница",
"del" => "удалить",
"Create pdf" => "Создать pdf",
"categories" => "категории",
"at tracker" => "в трекере",
"check / uncheck all" => "отметить / очистить все",
"Tiki sections and features" => "Разделы и возможности Tiki",
"please read" => "пожалуйста прочитайте",
"yes" => "да",
"<b>Feed</b>" => "<b>Поток</b>",
"<b>enable/disable</b>" => "<b>разрешить/запретить</b>",
"<b>Max number of items</b>" => "<b>Максимальное число элементов</b>",
"Feed for Articles" => "Поток статей",
"Feed for Weblogs" => "Поток веблогов",
"Feed for Image Galleries" => "Поток фотогалерей",
"Feed for File Galleries" => "Поток файловых галерей",
"Feed for the Wiki" => "Поток для Wiki",
"Feed for individual Image Galleries" => "Поток личных фотогалерей",
"Feed for individual File Galleries" => "Поток личных файловых галерей",
"Feed for individual weblogs" => "Поток личных веблогов",
"Feed for individual forums" => "Поток данных для личных форумов",
"PDF generation" => "Создание PDF",
"Use in CMS" => "Использовать в cms",
"Use in Wiki" => "Использовать в wiki",
"Use in newsletters" => "Использовать в рассылке",
"Use in HTML pages" => "Использовать в HTML страницах",
"Refresh rate (if dynamic) [secs]" => "Частота обновления (если динамическая) [сек]",
"Create/edit newsletters" => "Создать/редактировать рассылки",
"subscriptions" => "подписки",
"Use Admin Email" => "Использовать адрес администратора",
"Edit or add poll options" => "Добавить/изменить параметры опроса",
"Create/edit Polls" => "Создать/изменить опрос",
"Rss channels" => "Rss каналы",
"activate" => "активировать",
"Admin tracker" => "Управлять трекером",
"Edit this tracker" => "Редактировать этот трекер",
"View this tracker items" => "Показать содержимое трекера",
"Edit tracker fields" => "Редактировать поля трекера",
"fields" => "поля",
"Create/edit trackers" => "Создать/редактировать трекеры",
"Add a new group" => "Добавить новую группу",
"Edit item" => "Редактировать",
"Add a new user" => "Добавить пользователя",
"Popup Window" => "Всплывающее окно",
"details" => "подробнее",
"No individual permissions global permissions apply" => "Никаких индивидуальных прав доступа, здесь только глобальные",
"Welcome to the Tiki Chat Rooms" => "Добро пожаловать в Чат-комнаты Tiki",
"Please select a chat channel" => "Пожалуйста, выберите канал",
"enter chat room" => "войти в комнату чата",
"Chatroom" => "Комната",
"Active Channels" => "Активные каналы",
"Users in this channel" => "Пользователи на этом канале",
"Channel Information" => "Информация о канале",
"Channel" => "Канал",
"Ratio" => "Соотношение",
"Use :nickname:message for private messages" => "Используйте :имя:текст для личных сообщений",
"Use [URL|description] or [URL] for links" => "Используйте [URL|описание] или [URL] для создания ссылок",
"Add or edit a site" => "Добавить или редактировать сайт",
"sites" => "сайты",
"cool sites" => "классные сайты",
"Use ...page... to separate pages in a multi-page article" => "Используйте ...page... для разделения страниц в многостраничной статье",
"Create Zone" => "создать область",
"translate" => "перевести",
"Create or edit content" => "Создать или изменить содержимое",
"this quiz stats" => "статистика по этому тесту",
"answer" => "ответ",
"graph" => "граф",
"Edit FAQ questions" => "Редактировать вопросы",
"Other users can upload files to this gallery" => "Другие пользователи могут пополнять галерею",
"Available File Galleries" => "Доступные файловые галереи",
"start" => "начать",
"end" => "конец",
"roles" => "роли",
"Add role" => "Добавить роль",
"active process" => "активный процесс",
"invalid" => "неверно",
"invalid process" => "неверный процесс",
"valid process" => "корректный процесс",
"activities" => "активности",
"aborted" => "отменённые",
"value" => "значение",
"exceptions" => "исключения",
"rollback" => "откат",
"Create or edit content block" => "Создать или редактировать блок содержимого",
"Listing Gallery" => "Содержимое Галереи",
"Gallery Files" => "Галерея Файлов",
"Last ver" => "Последняя версия",
"Subscribe to newsletter" => "Подписаться на рассылку",
"Add or edit a news server" => "Добавить/редактировать сервер новостей",
"Print Wiki Pages" => "Печать страниц Wiki",
"add page" => "добавить страница",
"Total threads" => "Всего веток обсуждения",
"Average threads per topic" => "Среднее число веток на 1 тему",
"You can include the file in an HTML/Tiki page using" => "Вы можете включить этот файл в HTML/Tiki страницу, используя",
"Now enter the file URL" => "Теперь введите URL файла",
" or upload a local file from your disk" => " или закачайте локальный файл с Вашего диска",
"Add or edit folder" => "Добавить или редактировать папку",
"Add or edit a URL" => "Добавить или редактировать URL",
"priority" => "приоритет",
"previous chart" => "предыдущий чарт",
"next chart" => "следующий чарт",
"pos" => "поз",
"avg" => "средне",
"post new comment" => "комментировать",
"Post New Comment" => "комментировать",
"HTML tags are not allowed inside comments" => "HTML теги не позволяются внутри комментариев",
"moderator actions" => "действия модератора",
"move selected topics" => "переместить отмеченные темы",
"unlock selected topics" => "разблокировать отмеченные темы",
"lock selected topics" => "заблокировать отмеченные темы",
"merge" => "объединить",
"merge selected topics" => "объединить отмеченные темы",
"View item" => "Просмотр",
"Add a comment" => "Добавить комментарий",
"account" => "учётная запись",
"Group doesnt exist" => "Группа не существует",
"User doesnt exist" => "Пользователь не существует",
"Event without Name" => "событие без имени",
"No channel indicated" => "Канал не указан",
"No nickname indicated" => "Имя не указано",
"Permision denied" => "Доступ запрещён",
"sender" => "отправитель",
"subject" => "тема",
"date" => "дата",
"mark" => "пометка",
"posted by" => "создано",
"email this post" => "отправить по эл.почте",
"Show page title" => "Показывать заголовок страницы",
"Users can lock pages (if perm)" => "Пользователи могут блокировать страницы (согл. прав доступа)",
"Maximum number of versions for history" => "Хранить версий в истории не более",
"Never delete versions younger than days" => "Никогда не удалять версии моложе дней",
"Old vers" => "Старые версии",
"Add or edit event" => "Добавить или редактировать событие",
"merge selected notes into" => "объединить выбранные заметки в",
"Faq Stats" => "Статистика ЧаВо",
"settings" => "настройки",
"mailbox" => "почтовый ящик",
"compose" => "создать",
"contacts" => "контакты",
"back to mailbox" => "вернуться в почтовый ящик",
"full headers" => "полные заголовки",
"normal headers" => "обычный вид",
"reply all" => "ответить всем",
"forward" => "переслать",
"select from address book" => "выбрать из адр.книги",
"cc" => "копия (cc)",
"Message queue for" => "Message queue for",
"Reported messages for" => "Reported messages for",
"new sites" => "новые сайты",
"pass" => "пароль",
"Page generated in" => "Страница создана за",
"sent" => "отправлено",
"Minor" => "Мелочь",
"Prevent automatic/robot registration" => "Предотвращать автоматическую регистрацию",
"Create/edit Calendars" => "Создать/редактировать календари",
"Chat Administration" => "Управление чатом",
"Create/edit channel" => "Создать/изменить канал",
"Chat channels" => "Каналы чата",
"Assign Module" => "назначить модуль",
"Edit survey questions" => "Редактировать вопросы анкеты",
"Admin Tracker" => "Управлять трекером",
"Again" => "Снова",
"Assign permissions to group" => "Назначить права для группы",
"Browsing Gallery" => "Просмотр Галереи",
"Program dynamic content for block" => "Программировать динамическое содержимое блока",
"Admin quizzes" => "Настройка тестов",
"back to forum" => "вернуться в форум",
"hist" => "история",
"back to admin" => "назад в управление",
"Subscribe to This Newsletter" => "Подписаться",
"Stats for quiz" => "Статистика теста",
"Rename page" => "Переименовать страницу",
"to_version" => "к_версии",
"Theme Control Center: categories" => "Центр управления темами: категории",
"Theme Control Center: sections" => "Центр управления темами: Секции",
"File Title" => "Название файла",
"IRC log" => "IRC лог",
"Add new mail account" => "Новая учётная запись почты",
"User accounts" => "Учётные записи",
"View All" => "Показать все",
"Msg" => "Сообщ",
"Permission denied you cannot remove pages" => "Отказано в доступе, Вы не можете удалять страницы",
"Send trackback pings to:" => "Send trackback pings to:",
"LDAP Scope" => "LDAP Scope",
"LDAP Base DN" => "LDAP Base DN",
"LDAP User DN" => "LDAP User DN",
"LDAP User OC" => "LDAP User OC",
"LDAP Group DN" => "LDAP Group DN",
"LDAP Group OC" => "LDAP Group OC",
"LDAP Member Attribute" => "LDAP Member Attribute",
"LDAP Member Is DN" => "LDAP Member Is DN",
"LDAP Admin User" => "LDAP Admin User",
"LDAP Admin Pwd" => "LDAP Admin Pwd",
"File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model." => "File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model.",
"Cannot write to this file" => "Запись в этот файл невозможна",
"Missing title or body when trying to post a comment" => "Вы забыли ввести заголовок или текст комментария",
"Newsletter subscription information at " => "Информация о подписке на ",
"categorize this object" => "задать категорию объекта",
"Syntax highlighting" => "Подсветка синтаксиса",
"My Files" => "Файлы",
"Mini calendar" => "Мини-календарь",
"Received pages" => "Полученные страницы",
"Admin Posts" => "Управлять сообщениями",
"Submit a New Link" => "Предложить новую ссылку",
"Submit a new link" => "Предложить новую ссылку",
"Admin Directory" => "Управлять каталогом",
"List trackers" => "Список трекеров",
"I forgot my pass" => "Я забыл пароль",
"(comma separated list of URIs)" => "(URIs разделенные запятыми)",
"This is" => "Это",
"by the" => "автор",
"Use URI as Home Page" => "Использовать URI как домашнюю страницу",
"OS" => "Операционная система",
"Use cache for external images" => "Кешировать внешние изображения",
"Use gzipped output" => "Использовать сжатый вывод страниц",
"Sender Email" => "Эл.адрес отправителя",
"contact feature disabled" => "возможность связи отключена",
"User registration and login" => "Регистрация и вход",
"Use WebServer authentication for Tiki" => "Исплользовать WebServer аутентификацию для Tiki",
"Request passcode to register" => "Требовать секретный код для регистрации",
"Validate users by email" => "Проверять пользователей через email",
"Store plaintext passwords" => "Хранить пароли незашифрованные",
"Reg users can change language" => "Пользователи могут выбирать язык",
"Force to use chars and nums in passwords" => "Заставить использовать буквы с цифрами в паролях",
"Minimum password length" => "Пароль не должен быть короче",
"Password invalid after days" => "Пароль устареет через, дней",
"Remember me feature" => "Возможность Запомни меня",
"Create user if not in Tiki?" => "Создать пользователя, если он не в Tiki?",
"Create user if not in Auth?" => "Создать пользователя, если он не в  Auth?",
"Just use Tiki auth for admin?" => "Использовать только аутентификацию Tiki для админа?",
"LDAP Host" => "LDAP Хост",
"LDAP Port" => "LDAP Порт",
"LDAP User Attribute" => "LDAP Пользовательские Аттрибуты",
"LDAP Group Attribute" => "LDAP Групповые Аттрибуты",
"restore" => "восстановить",
"Wiki Home Page" => "Домашняя страница Wiki",
"Wiki Discussion" => "Обсуждение Wiki",
"Wiki Features" => "Возможности Wiki",
"Wiki History" => "История Wiki",
"Admin Charts" => "Настройка чартов",
"Create/edit questions for survey" => "Создать/изменить вопросы анкеты",
"Active?" => "Активно?",
"Create/Edit Trackers" => "Создать/редактировать трекеры",
"Browse gallery" => "Просмотр галереи",
"Upload from disk" => "Закачать с диска",
"Browsing Image" => "Просмотр изображения",
"Again please" => "Ещё раз пожалуйста",
"Admin category relationships" => "Управлять отношениями в категориях",
"Validate links" => "Проверить ссылки",
"Im- Export Languages" => "Испорт/экспорт языков",
"Support tickets" => "Квитанции поддержки",
"Return to HomePage" => "Вернуться на домашнюю страницу",
"Minor Edit" => "Мелочь",
"You can not download files" => "Вы не можете скачивать файлы",
"Please wait 2 minutes between posts" => "Пожалуйста подождите 2 минуты между сообщениями",
"italic" => "italic",
"Show Categories" => "вывести категории",
"Hide Categories" => "скрыть категории",
"Blog features" => "Возможности блога",
"Blog level comments" => "Комментарии к блогу",
"Post level comments" => "Комментарии к сообщению",
"Spellchecking" => "Правописание",
"Default ordering for blog listing" => "Сортировка блога по умолчанию",
"Blog listing configuration (when listing available blogs)" => "Настройка списка блогов (при просмотре доступных блогов)",
"Blog comments settings" => "Комментарии в блогах",
"CMS features" => "Возможности CMS",
"Use templates" => "Использовать шаблоны",
"Maximum number of articles in home" => "Максимальное число статей в домашней папке",
"Article comments settings" => "Комментарии статей",
"Copyright Management" => "Управление авторскими правами",
"License Page" => "Лицензионное соглашение",
"Submit Notice" => "Комментарий при отправке",
"Uploaded filenames cannot match regex" => "Имена файлов НЕ должны совпадать с regex",
"File galleries comments settings" => "Комментарии в файловых галереях",
"Forum quick jumps" => "Быстрое перемещение по форуму",
"Ordering for forums in the forum listing" => "Упорядочивание форумов в списке",
"Forum listing configuration" => "Настройка списка форума",
"this survey stats" => "статистика этой анкеты",
"bold" => "жирный",
"underline" => "подчеркнуть",
"hr" => "разделитель",
"unread private messages" => "непрочтённые личные сообщения",
"you or someone registered this email address at" => "Вы или кто-то другой зарегистрировал этот адрес на",
"Your Tiki information registration" => "Ваша регистрационная информация Tiki",
"home" => "в начало",
"chat" => "чат",
"contact us" => "свяжитесь с нами",
"User menu" => "Меню пользователя",
"dump" => "Дамп",
"rankings" => "Рейтинги",
"orphan pages" => "Страницы-сироты",
"sandbox" => "песочница",
"received pages" => "Полученные страницы",
"structures" => "структуры",
"Articles Home" => "Главная статья",
"Send articles" => "Отправить статьи",
"Create/Edit Blog" => "Создать/Изменить Блог",
"Browse Directory" => "Просмотр каталога",
"Admin FAQs" => "Управление ЧаВо",
"Admin quiz" => "Управлять тестом",
"Admin trackers" => "Управлять трекерами",
"Send newsletters" => "Отослать письма",
"Ephemerides" => "События",
"Backups" => "Резервные копии",
"External wikis" => "Внешние wikis",
"Quick edit a Wiki page" => "Редактировать страницу",
"Sort posts by:" => "Сортировать сообщения по:",
"read more" => "подробнее",
"Pass" => "Пароль",
"some text" => "какой-то текст",
"Creates a box with the data" => "Создаёт прямоугольник с содержимым",
"creates a title bar" => "создаёт полосу заголовка",
"creates a table" => "создаёт таблицу",
"makes a horizontal rule" => "создаёт горизонтальный разделитель",
"page|desc" => "стр.|описание",
"displays an image" => "показывает изображение",
"Non cacheable images" => "Некешируемые изображения",
"height width desc link and align are optional" => "высота ширина описание ссылка и выравнивание не обязательны",
"displays rss feed with id=n maximum=m items" => "выводит rss раздачу от другого сервера с id=n не более=m элементов",
"Will be replaced by the actual value of the dynamic content block with id=n" => "Будет заменено настоящим значением блока динамического содержимого с id=n",
"Misc" => "Разное",
"Tiki is unable to connect to the database " => "Tiki не может подключиться к базе данных ",
"Tiki was unable to retrieve login data from the database " => "Tiki не смог получить регистрационные данные из базы данных ",
"The following error message was returned" => "Получено следующее сообщение об ошибке",
"Things to check" => "Что необходимо проверить",
"Is your database up and running" => "Работает ли ваша база данных",
"Are your database login credentials correct" => "Корректны ли ваши регистрационные данные",
"Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Завершена ли <a href='tiki-install.php' >Инсталляция Tiki ",
"Please see <a href=\"http://doc.tiki.org/\">the documentation</a> for more information" => "Пожалуйста, см. <a href=\"http://doc.tiki.org/\">документацию</a> для получения дополнительной информации",
"Text_Wiki libraries need to be installed. Please see http://dev.tiki.org/MediaWiki+to+TikiWiki+converter" => "Должна быть установлена библиотека Text_Wiki. Детали смотрите на http://dev.tiki.org/MediaWiki+to+TikiWiki+converter",
"PostgeSQL 7.2+" => "PostgeSQL 7.2+",
"Oracle" => "Oracle",
"Sybase" => "Sybase",
"SQLLite" => "SQLLite",
"MSSQL" => "MSSQL",
"Tiki version" => "Tiki версия",
"PHP version" => "PHP версия",
"on left side" => "слева",
"on center" => "по центру",
"on right side" => "справа",
"Any 2 versions" => "Любые 2 версии",
"latin" => "латинский",
"english" => "английский",
"2 hours" => "2 час",
"10 hours" => "10 часов",
"20 hours" => "20 часов",
"1 year" => "1 год",
"crypt-md5" => "crypt-md5",
"crypt-des" => "crypt-des",
"OpenID and Tiki" => "OpenID и Tiki",
"choose a group .." => "выберите группу ..",
"Admins" => "Администраторы",
"No forums" => "Нет форумов",
"%s enabled" => "%s включено",
"\$feature is turned on" => "\$feature включено",
"%s disabled" => "%s отключено",
"\$feature is turned off" => "\$feature выключено",
"You have mistyped the anti-bot verification code; please try again" => "Ошибка в коде верификации; пожалуйста, повторите попытку",
"Your message has been queued for approval and will be posted after a moderator approves it" => "Ваше сообщение помещено в очередь на утверждение. Сообщение будет добавлено после подтверждения модератором",
"Sample plugin" => "Пример плагина",
"Font family to use" => "Семейство шрифтов",
"As defined by CSS" => "Как указано в CSS",
"Lines" => "Линии",
"Select a Wiki page to link to" => "Выберите Wiki страницу для создания ссылки",
"Cannot open this file" => "Не удается открыть этот файл",
"This is an approximation based on your server memory limit" => "Это приблизительная оценка с учетом объема памяти на вашем сервере",
"layer" => "уровень",
"Record" => "Запись",
"This poll is closed" => "Этот опрос закрыт",
"You need either JQuery or MooTools enabled for this feature" => "Чтобы использовать эту возможность, Вам необходимо включить JQuery или MooTools",
"Help page" => "Помощь",
"Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using TikiWiki with an incorrect database version usually causes errors" => "Ваша база требует обновления в соответствии с текущей версией TikiWiki. Пожалуйста, перейдите на <a href=\"tiki-install.php\"> страницу установки </a>. Использование Tiki с неверной версией базы данных, как правило, приводит к ошибкам",
"You are not allowed to upload this type of file" => "Вам не разрешено загружать данный тип файлов",
"The file you are trying upload was only partially uploaded" => "Файл был загружен частично",
"You must select a file" => "Выберите файл",
"Flash player not available" => "Flash player не доступен",
"Altering database table failed" => "Изменение таблицы базы данных не удалось",
"__WARNING__: Plugin disabled \$plugin" => "__ВНИМАНИЕ____: Плагин отключен \$plugin",
"The administrator has not yet validated your account. Please wait" => "Администратор еще не проверил Вашу учетную запись.  Подождите",
"Displays various information about the client" => "Отображает различную информацию о клиенте",
"Image alignment. Possible values: left, right, center" => "Выравнивание изображения. Возможные значения: left, right, center",
"Image annotations changed" => "Аннотация к изображению изменена",
"Creates an annotation block for an image" => "Создает аннотационный блок для изображения",
"Displays an image and enables users to define zones to highlight information on the image" => "Отображает изображения и позволяет пользователям определять зоны для выделения информации об изображении",
"List of colors to use" => "Список цветов",
"List of styles to use" => "Список стилей",
"Code snippet label" => "Заголовок для фрагмента кода",
"0|1, Enable word wrapping on the code to avoid breaking the layout" => "0|1, Разрешить перенос слов в коде для соблюдения разметки страницы",
"Includes content from the dynamic content system" => "Добавить динамическое содержимое",
"Label displayed on the left side of the gauge" => "Label displayed on the left side of the gauge",
"One of" => "Один из",
"Default: #F5F5F5" => "По умолчанию: #F5F5F5",
"Includes random content from the dynamic content system" => "Добавить случайное динамическое содержимое",
"File is not an image" => "Файл не является изображением",
"Content of the field" => "Содержимое поля",
"Please wait.." => "Подождите..",
"Since your last visit.." => "Пока вас не было..",
"New Article" => "Новая статья",
"Autovalidate suggestions" => "Автоматическая проверка предложений",
"Can abort a process instance" => "Остановить процесс",
"Can admin charts" => "Управление графиками",
"Can admin drawings" => "Управление чертежами",
"Can admin games" => "Управление играми",
"Can admin quicktags" => "Управление панелью инструментов",
"Can admin workflow processes" => "Управление системой бизнес процессов",
"Can declare an instance as exception" => "Объявление экземпляра в качестве исключения",
"Can edit drawings" => "Редактирование чертежей",
"Can execute workflow activities" => "Запускать бизнес процессы",
"Can rate wiki pages" => "Принимать участие в рейтинге wiki страниц",
"Can play games" => "Играть в игры",
"Can suggest items" => "Предлагать записи",
"Can use dsn " => "Использование dsn ",
"Can use the newsreader" => "Использовать систему чтения новостей",
"Can view categories" => "Просмотр категорий",
"Can view categorized items" => "Просмотр объектов в категории",
"Can view charts" => "Просмотр графиков",
"Can vote" => "Разрешить голосовать",
"Quicktags" => "Панель инструментов",
"Please note that the preview does not keep the attached file which you will have to choose before posting" => "Обращаем внимание, что режим предпросмотра не сохраняет файл, который вы выбрали для вложения в сообщение",
"Your comment will have to be approved by the moderator before it is displayed" => "Ваш комментарий должен быть одобрен модератором, прежде чем он отобразиться",
"Type of contribution" => "Вид взноса",
"any file" => "любой файл",
"podcast (audio)" => "подкаст (звук)",
"podcast (video)" => "подкаст (видео)",
"This Gallery is Public" => "Публичная галерея",
"Perhaps you were looking for" => "Возможно вы ищете",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together" => "Пишите метки разделяя их пробелом. Метку из нескольких слов пишите слитно.",
"You are about to leave this page. If you have made any changes without Saving, your changes will be lost.  Are you sure you want to exit this page" => "Вы собираетесь покинуть эту страницу. Если вы сделали какие-либо изменения без сохранения, изменения будут потеряны. Вы уверены, что хотите выйти",
"Loading" => "Идет загрузка",
"Are you sure you want to delete the selected files" => "Вы уверены что хотите удалить выбранные файлы",
"New topic" => "Новая тема",
"successfully" => "успешно",
"deleted" => "удален(о)",
"QuickTags" => "Панель инструментов",
"quicktags" => "панель инструментов",
"More.." => "Еще..",
"Tikiwiki Assistant" => "Помощник Tikiwiki",
"Last `\$module_rows` blog comments" => "`\$module_rows` последних комментариев в блоге",
"Last blog comments" => "Последние комментарии в блоге",
"Last `\$module_rows` Sites" => "`\$module_rows` последних сайтов",
"Top \$module_rows Sites" => "\$module_rows популярных сайтов",
"Top `\$module_rows` topics" => "`\$module_rows` популярных тем",
"Last `\$module_rows` forum posts" => "`\$module_rows` последних ответов на форуме",
"Last `\$module_rows` forum topics" => "`\$module_rows` последних тем на форуме",
"More Like This" => "Показать похожие",
"My prefered tags" => "Мои любимые тэги",
"Last `\$module_rows` actions" => "`\$module_rows` действий",
"Last `\$module_rows` articles" => "`\$module_rows` статей",
"Last articles" => "Последние статьи",
"Last `\$module_rows` blog posts" => "`\$module_rows` записей в блогах",
"Last `\$module_rows` Created blogs" => "`\$module_rows` созданных блогов",
"Last `\$module_rows` Created FAQs" => "`\$module_rows` созданных ЧаВо",
"Last `\$module_rows` Created Quizzes" => "`\$module_rows` созданных опросов",
"Last `\$module_rows` modified file galleries" => "`\$module_rows` измененных файловых галерей",
"Last `\$module_rows` Files" => "`\$module_rows` файлов",
"Last `\$module_rows` galleries" => "`\$module_rows` галерей",
"Last `\$module_rows` Images" => "`\$module_rows` изображений",
"Last `\$module_rows` modified events" => "`\$module_rows` измененных событий",
"Last modifed events" => "Последние измененные события",
"Last `\$module_rows` changes" => "`\$module_rows` изменений",
"Last `\$module_rows` Modified Items" => "`\$module_rows` измененных объектов",
"Last `\$module_rows` Modified blogs" => "`\$module_rows` измененных блогов",
"Last `\$module_rows` submissions" => "`\$module_rows` представлений",
"Last `\$module_rows` Modified Comments" => "`\$module_rows` измененных комментариев",
"Last Modified Comments" => "Последние измененные комментарии",
"Last `\$module_rows` Items" => "`\$module_rows` объектов",
"CapsLock is on" => "CapsLock включен",
"What is OpenID" => "Что такое OpenID",
"Random Images" => "Случайные изображения",
"Your email could not be validated; make sure you email is correct and click register below" => "Ваш электронный адрес не прошел проверку; убедитесь в корректости написания адреса и пройтите регистрацию ниже",
"maps" => "Карты",
"Are you sure you want to delete this shout" => "Вы уверены, что хотите удалить эту запись",
"Site Language" => "Язык системы",
"Top `\$module_rows` articles" => "`\$module_rows` популярных статей",
"Top `\$module_rows` File Galleries" => "`\$module_rows` популярных файловых галерей",
"Top `\$module_rows` files" => "`\$module_rows` популярных файлов",
"Top `\$module_rows` Forum Posters" => "`\$module_rows` популярных писателей на форуме",
"Top `\$module_rows` games" => "`\$module_rows` популярных игр",
"Top `\$module_rows` galleries" => "`\$module_rows` популярных галерей",
"Top `\$module_rows` Images" => "`\$module_rows` популярных изображений",
"Top `\$module_rows` Objects" => "`\$module_rows` популярных объектов",
"Top `\$module_rows` Pages" => "`\$module_rows` популярных страниц",
"Top `\$module_rows` Quizzes" => "`\$module_rows` популярных опросов",
"Most `\$module_rows` visited blogs" => "`\$module_rows` наиболее посещяемых блогов",
"Top `\$module_rows` Visited FAQs" => "`\$module_rows` наиболее посещяемых ЧаВо",
"There are no translations of this page" => "Для данной страницы перевод отсутствует",
"Up-to-date-ness" => "Up-to-date-ness",
"Better translations" => "Лучшие переводы",
"Set your preferred languages" => "Укажите Ваши языковые предпочтения",
"Equivalent translations" => "Одинаковые переводы",
"Translations that need improvement" => "Переводы, нуждающиеся в улучшении",
"Upcoming `\$module_rows` events" => "`\$module_rows` грядущих событий",
"The Next Event" => "Следующее событие",
"No Upcoming Events" => "Нет грядущих событий",
"Last `\$module_rows` wiki comments" => "`\$module_rows` последних wiki комментариев",
"on page" => "на странице",
"show structures" => "показать структуры",
"hide structures" => "спрятать структуры",
"community" => "сообщество",
"Blogs Listing" => "Список блогов",
"Users Listing" => "Список пользователей",
"My workflow" => "Мой бизнес-процесс",
"Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site" => "Подробное описание cмотрите в <a class='rbox-link' target='tikihelp' href='http://doc.tiki.org/Features'>документации по функциям</a> на сайте Tiki",
"No tabs" => "Убрать закладки",
"Global Features" => "Глобальные настройки",
"More Functionality" => "Дополнительный функционал",
"UI Enhancements" => "Усовершенствования UI",
"Main Features" => "Основные настройки",
"Site Global Features" => "Настройки сайта",
"Action log setting" => "Настройки протокола",
"Additional Features" => "Дополнительные возможности",
"Featured Help" => "Настройка справки",
"html pages" => "страницы html",
"User interface enhancement features" => "Расширенные возможности UI",
"JavaScript popup date selector" => "Всплывающий выбор даты на JavaScript",
"Allow users to activate fullscreen mode" => "Разрешить пользователям включать полноэкранный режим",
"Floating help aka the Big Blue Help Icon" => "Помощь в виде плавающего синего знака вопроса",
"Experimental Features" => "Экспериментальные возможности",
"Seem ok" => "Должны работать",
"Malfunctioning" => "Несрабатывание",
"These features have critical faults - not recommended" => "Функции имеют критические замечания - не рекомендуются",
"Magic Admin Panel" => "Панель администратора",
"Neglected" => "Не развиваются",
"Old features no longer maintained" => "Не поддерживаемые старые функции",
"Friendship" => "Дружба",
"Used to embed Flash content in wiki pages, banners etc" => "Используется для встраивания Flash содержимого в вики-страницы, баннеров и т.д.",
"Administration Features" => "Административные возможности",
"Banning System" => "Система запретов и блокировок",
"Action Calendar" => "Календарь событий",
"Tiki action calendar" => "Календарь событий Tiki",
"User Features" => "Возможности пользователя",
"Programmer Features" => "Особенности для программиста",
"tikitests" => "tiki тесты",
"requires PHP5 or more" => "необходим PHP5 или выше",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory" => "Если вы решили хранить файлы в директории, необходимо убедиться, что пользователь не может получить доступ непосредственно к каталогу",
"Gallery Listing" => "Список галерей",
"The server must be able to read/write the directory" => "Сервер должен иметь возможность чтения / записи в каталог",
"The directory can be outside the web space" => "Каталог может быть за пределами сайта",
"Pixels Default" => "Пиксели по умолчанию",
"Admin Password" => "Пароль администратора",
"Server OS" => "Серверная ОС",
"(standard)" => "(стандарт)",
"(some Unix MTA)" => "(некоторые Unix MTA)",
"Default timezone" => "Временная зона по умолчанию",
"Sample" => "Пример",
"Use Ctrl+Click to select multiple languages" => "Используйте Ctrl+Click для выбора нескольких языков",
"page name" => "имя страницы",
"The following list of changes has been applied" => "Были выполнены следующие изменения",
"preference name" => "имя параметра",
"Kb" => "Кб",
"Ex" => "Пример",
"Delete events older than" => "Удалять события старше",
"Current Category ID" => "ID выбранной категории",
"Edit this category" => "Редактировать категорию",
"Perms inherited from closest parent if possible or from global perms" => "Права унаследуются от ближайшей родительской категории или из глобальных настроек",
"Assign permissions automatically" => "Назначить доступ автоматически",
"recommended for best performance" => "рекомендуется для лучшего быстродействия",
"Edit this template" => "Редактировать шаблон",
"Use the Administration page of each enabled feature to allow the use of content templates" => "Возможность использования шаблонов включается в каждой отдельной секции на странице \"Адмнистрирование системы\"",
"No features are configured to use templates" => "Ни в одной секции не разрешено использование шаблонов",
"Edit this Forum" => "Редактировать форум",
"no display" => "не показывать",
"List Forums" => "Список форумов",
".." => "..",
"Use Ctrl+Click to select multiple groups" => "Используйте Ctrl+Click для выбора нескольких групп",
"setting will override your selection of specific groups" => "отменит Вашу настройку на определенные группы",
"Edit this user module" => "Изменить этот пользовательский модуль",
"You can add several email addresses by separating them with commas" => "Вы можете указать несколько эл.адресов через запятую",
"Add email" => "Добавить эл.адрес",
"Add user" => "Добавить пользователя",
"mail notifications" => "почтовые уведомления",
"Admin Quicktags" => "Администрирование Панели инструментов",
"Create/Edit QuickTags" => "Создать/Редактировать кнопку",
"Answer is mandatory" => "Ответ является обязательным",
"Number of required answers (for multiple choices)" => "Кол-во обязательных ответов (для множественного выбора)",
"Min" => "Мин",
"For a rate, you can give the maximum value" => "Для оценки, Вы можете задать максимальное значение",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)" => "Если ваш Tiki ведет себя странно, первым делом очистите кеш. Это необходимо делать и после каждого обновления",
"Full Path to the Zip File" => "Полный путь к архивному файлу",
"Templates compiler" => "Компилятор шаблонов",
"Compile" => "Компилировать",
"Warning: Make a backup of your Database before using this function" => "Внимание: Создайте резервную копию вашей базы данных перед тем как использовать эту функцию",
"Warning: If you try to convert large tables, raise the maximum execution time in your php.ini" => "Внимание: Если вы хотите  конвертировать большие таблицы, необходимо увеличить время исполнения в php.ini (секция Resource Limits, параметр max_execution_time)",
"Select list items that will be displayed" => "Выберите пункты из списка для отображения",
"Column is searchable" => "Поиск по столбцу",
"Field is hidden" => "Скрытое поле",
"Field is mandatory" => "Обязательное поле",
"Description text is wiki-parsed" => "Описание в стиле wiki",
"Error message" => "Сообщение об ошибке",
"Item creator can modify his items" => "Создатель может вносить изенения в свои записи",
"Member of the default group of creator can modify items" => "Члены одной группы могут вносить изменения в свои записи",
"Format if not the default short one" => "Указать особенный формат даты",
"Show creation date when viewing tracker item" => "Показывать дату создания",
"Show lastModif date when viewing tracker item" => "Показывать дату последнего изменения",
"What field is used for default sort" => "По умолчанию сортировать по полю",
"What is default sort order in list" => "Направление сортировки по умолчанию",
"Tracker items allow ratings" => "Включить рейтинг для записей",
"and display rating results in listing" => "показывать рейтинг в списке",
"and display comments in listing" => "показывать комментарии в списке",
"and display last comment user/date" => "показывать автора и дату последнего комментария",
"and display attachments in listing" => "показывать вложения в списке",
"Do not show empty fields in item view" => "Не показать пустые поля в просмотре",
"Show these fields (ID comma separated) in a popup on item link when listing tracker items" => "Показать эти поля (ID разделенные запятой) во всплывающем окне при просмотре списка трекера",
"Edit Account Settings" => "Редактировать настройки учетной записи",
"Edit Group" => "Редактировать Группу",
"Validate user" => "Проверить пользователя",
"Repeat Password" => "Пароль повторно",
"Must Change Password" => "Запросить сменить пароль",
"Last Login" => "Последний вход",
"Overwrite groups" => "Перезаписать группы",
"Loading.." => "Загрузка..",
"Approve page changes in staging" => "Утвердить изменения страницы в постановке",
"Assign User {\$assign_user} to Groups" => "Назначить пользователя {\$assign_user} в Группы",
"available files" => "доступные файлы",
"Mark entry as private" => "Отметить как личное",
"Assigning permissions for <b>all children</b> is recommended for best performance" => "Назначение прав на <b>все вложенные</b> рекомендуется для быстродействия",
"You cannot add sites until Directory Categories are setup" => "Вы не можете добавить ссылку. Ведутся работы по настройке каталога ссылок",
"<a href=\"tiki-directory_admin_categories.php\">Add a category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Добавить категорию</a>",
"The following site was added, but may require validation by the admin before appearing on the lists" => "Предложенные сайты добавлены, но они еще должны пройти проверку администратором",
"Use Ctrl+Click to select multiple categories" => "Используйте Ctrl+Click для выбора нескольких категорий",
"Perform action with selected" => "Выполнить над выделенными",
"Add a Category" => "Добавить категорию",
"Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "Будет отображаться с использованием указанного HTML номера или имени цвета. Можно использовать два имени цвета через запятую. В этом случае первый цвет - цвет текста, второй - цвет фона",
"Use [[foo] to show [foo]" => "Пишите [[foo] для отображения [foo]",
"and its subpages from the structure, now you have two options" => "и все ее подкатегории, выберите что необходимо сделать",
"Preview your changes" => "Предпросмотр ваших изменений",
"Save the page" => "Сохранить страницу",
"Cancel the edit, you will lose your changes" => "Отмена редактирования с потерей выполненных изменений",
"Perhaps you are looking for" => "Похожие сраницы по названию",
"This edit session will expire in {\$edittimeout} minutes" => "Сессия закончится через {\$edittimeout} минут",
"<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer" => "Выполните <strong>Предпросмотр</strong> или <strong>Сохранить</strong> для обновления сессии",
"Switch to WYSIWYG editor" => "Использовать WYSIWYG редактор",
"There is no available poll template" => "Нет доступных шаблонов опроса",
"You should ask an admin to create them" => "Попросите администратора создать их",
"Send urgent translation request" => "Отправить срочный запрос на перевод",
"List TikiSheets" => "Список эл.таблиц Tiki",
"Use Ctrl+Click to select multiple fields" => "Используйте Ctrl+Click для выбора нескольких полей",
"Years" => "Года",
"Months" => "Месяцы",
"Edit Tpl" => "Редактировать шаблон (Tpl)",
"Not Defined" => "Не определено",
"Not Interactive" => "Не интерактивно",
"Not Ended" => "Не завершено",
"Executed" => "Запущено",
"erase" => "стереть",
"Edit this gallery" => "Редактировать эту галерею",
"Create New FAQ" => "Создать новый ЧаВо",
"My Contacts" => "Мои контакты",
"My Wiki Pages" => "Мои Wiki страницы",
"My Galleries" => "Мои галереи",
"My Tracker Items" => "Мои трекер-записи",
"My Messages" => "Мои сообщения",
"My Tasks" => "Мои задания",
"View Permissions" => "Просмотр прав доступа",
"These permissions override any global permissions or category permissions affecting this object" => "Указанные права доступа перекрывают любые глобальные права или права доступа от категории объекта",
"To edit global permissions <a class=\"rbox-link\" href=\"tiki-admingroups.php\">click here</a>" => "Для установки глобальных прав доступа <a class=\"rbox-link\" href=\"tiki-admingroups.php\">нажмите здесь</a>",
"Current permissions for categories that this object belongs to" => "Текущие права доступа от категории объекта",
"These permissions do not apply. Special permissions apply" => "Эти права доступа не применяются. Только специальные права",
"No category permissions; global permissions apply" => "У категории нет особых прав доступа; применяются глобальные права",
"No category permissions; special permissions apply" => "У категории нет особых прав доступа; применяются специальные права",
"and also to all pages of the sub-structure" => "и для всех страниц дочерней стуктуры",
"Perms Help" => "Помощь по правам доступа",
"Preview of version" => "Посмотреть версию",
"Source of version" => "Источник версии",
"Note: Remember that this is only a preview, and has not yet been saved" => "Внимание: вы находитесь в режиме предпросмотра, страница не сохранена",
"Prologue" => "Пролог",
"Epilogue" => "Эпилог",
"Send Pages" => "Отправленные страницы",
"The highlight pages already exist" => "Выделенные страницы уже существуют",
"Please, change the name if you want the page to be uploaded" => "Измените имя если хотите загрузить страницу",
"Enter your username or email" => "Введите ваше имя и эл.адрес",
"Enter your email" => "Введите ваш эл.адрес",
"Data HTML" => "Содержимое в HTML",
"Data Txt" => "Содержимое обычным текстом",
"You will not see the latest queries" => "Вы не увидите последние запросы",
"Stats for survey" => "Статистика анкеты",
"Maximum amount of downloads" => "Максимальное количество загрузок",
"Maximum file size is limited to" => "Максимальный размер файла не более",
"No gallery available" => "Нет доступной галереи",
"Uploading file.." => "Загрузка файла..",
"No File to Upload.." => "Нет файла для загрузки..",
"Note: Maximum image size is limited to" => "Примечание: Максимальный размер файла",
"a URL" => "закладку",
"This user is your friend" => "Это пользователь ваш друг",
"Your personal tracker information" => "Ваша личная информация трекера",
"Your preferred language" => "Ваш язык",
"Can you read more languages" => "Вы можете читать и на других языках",
"Other languages you can read (select on the left to add to the list on the right)" => "Другие языки (выберите слева, чтобы добавить в список справа)",
"Select language.." => "Выбор языка..",
"Confirm new password" => "Подтвердите новый пароль",
"Current password (required)" => "Текущий пароль (обязательно)",
"Use \"watches\" to monitor wiki pages or other objects" => "Используйте \"Наблюдения\" чтобы следить за изменением страниц или других объектов системы",
"Watch new items by clicking the {icon _id=eye} button on specific pages" => "Чтобы начать наблюдение за объектом достаточно нажать {icon _id=eye} на его странице",
"Used space" => "Использованное пространство",
"expires" => "истекает",
"No articles yet" => "Статей пока нет",
"Click here to view the Google cache of the page instead" => "Нажмите здесь, чтобы посмотреть страницу в кеше Google",
"There are no questions in this FAQ" => "Пока в этом ЧаВо вопросов нет",
"The post has been reported and will be reviewed by a moderator" => "Ответ отправлен на рассмотрение модератору",
"Save the page, but do not send notifications and do not count it as new content to be translated" => "Сохранить страницу, но не отправлять уведомления об изменении и не считать как новую версию для перевода",
"Save the page as a draft" => "Сохранить страницу как черновик",
"Unassign module" => "Убрать модуль",
"%s modified successfully" => "%s изменили успешно",
"%s modification failed" => "%s не изменили",
"Page saved (version %d)" => "Страница сохранена (версия %d)",
"Account validated successfully" => "Учетная запись подтверждена",
"Are you sure you want to delete this note" => "Действительно ли Вы хотите удалить эту заметку?",
"Changes" => "Изменения",
"Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks" => "Вы не можете назначать задания другим, или этот пользователь отказался их принимать",
"Please read the task and work on it" => "Прочитайте задачу и примите решение по ней",
"Workflow" => "Процессы",
"workflow" => "процессы",
"Unix" => "Unix",
"Windows" => "Windows",
"PEAR::Auth" => "PEAR::Auth",
"auto routed" => "auto routed",
"Auto routed" => "Auto routed",
"Origin" => "Origin",
"Instance" => "Instance",
"Workitems" => "Workitems",
"run instance" => "run instance",
"ver:" => "ver:",
"Admin process sources" => "Admin process sources",
"select source" => "select source",
"Shared code" => "Shared code",
"Set next user" => "Set next user",
"If:SetNextact" => "If:SetNextact",
"Switch construct" => "Switch construct",
"auto" => "auto",
"int" => "int",
"routing" => "routing",
"Instances" => "Instances",
"monitor instances" => "monitor instances",
"monitor workitems" => "monitor workitems",
"Monitor Instances" => "Monitor Instances",
"List of instances" => "List of instances",
"No instances created yet" => "No instances created yet",
"Monitor workitems" => "Monitor workitems",
"List of workitems" => "List of workitems",
"instance" => "instance",
"exception instance" => "exception instance",
"exceptions instance" => "exceptions instance",
"abort instance" => "abort instance",
"grab instance" => "grab instance",
"release instance" => "release instance",
"user instances" => "user instances",
"User Instances" => "User Instances",
"Inst Status" => "Inst Status",
"No instances defined yet" => "No instances defined yet",
"Browsing Workitem" => "Browsing Workitem",
"Workitem information" => "Workitem information",
"since" => "since",
"Permanency" => "Permanency",
"chg" => "chg",
"No chart indicated" => "No chart indicated",
"No instance indicated" => "No instance indicated",
"Role" => "Роль",
"1 day" => "1 день",
"1 week" => "1 неделя",
"1 month" => "1 месяц",
"Just Tiki" => "Только Tiki",
"Tiki and PEAR::Auth" => "Tiki и PEAR::Auth",
"Charts" => "Графики",
"charts" => "графики",
"Forums last topics" => "Последние темы в форуме",
"Faq" => "ЧаВо",
"An error occured in a database query!" => "Произошла ошибка в запросе к базе данных!",
"games" => "игры",
"Dynamic content" => "Динамическое содержимое",
"drawing not found" => "рисунок не найден",
"Listing configuration" => "Настройка листинга",
"Tiki email notification" => "Уведомление Tiki по эл.почте",
"menus" => "меню",
"Recently visited pages" => "Последние посещённые страницы",
"Feb" => "Февр",
"Apr" => "Апр",
"Jun" => "Июнь",
"Jul" => "Июль",
"Aug" => "Авг",
"Sep" => "Сент",
"Oct" => "Окт",
"Nov" => "Ноя",
"Dec" => "Дек",
"Last Sites" => "Последние сайты",
"Directory Stats" => "Статистика по каталогу",
"Sites to validate" => "Сайты на проверку",
"Visited links" => "Посещённые ссылки",
"Top Sites" => "Лучшие сайты",
"Last galleries" => "Последние галереи",
"Menu" => "Меню",
"New Messages" => "Новые сообщения",
"New Message" => "Новое сообщение",
"Top games" => "Лучшие игры",
"Number of columns per page when listing categories" => "Число колонок на странице при выводе категорий",
"newsletters" => "рассылки",
"Support" => "Поддержка",
"support" => "поддержка",
"surveys" => "анкетирование",
"Drawings" => "Рисунки",
"Games" => "Игры",
"Newsreader" => "Чтение новостей",
"Workflow engine" => "Механизм выполнения",
"Unknown/Other" => "Не знаю/другая",
"New password" => "Новый пароль",
"Reg users can change theme" => "Пользователи могут менять цветовую тему",
"Slideshows theme" => "Тема для слайд-шоу",
"hits" => "просмотры",
"image gal" => "фотогал",
"file gal" => "файл.гал",
"Edit Chart" => "редактировать чарт",
"Add or edit a chart" => "Добавление/редактирование чарта",
"Users can suggest new items" => "Пользователи могут предлагать новые пункты",
"Auto validate user suggestions" => "Автоматом проверять предложения пользователей",
"Ranking shows" => "Показ рейтинга",
"All items" => "Все пункты",
"Top 10 items" => "Лучшие 10",
"Top 20 items" => "Лучшие 20",
"Top 40 items" => "Лучшие 40",
"Top 50 items" => "Лучшие 50",
"Top 100 items" => "Лучшие 100",
"Top 250 items" => "Лучшие 250",
"Voting system" => "Система голосования",
"Vote items" => "Пункты голосования",
"Rank 1..5" => "Рейтинг 1..5",
"Rank 1..10" => "Рейтинг 1..10",
"Ranking frequency" => "Обновление рейтинга",
"Realtime" => "Реальное время",
"Each 5 minutes" => "Каждые 5 минут",
"Show Average" => "Показать среднее",
"Show Votes" => "Показать гослосования",
"Use Cookies for unregistered users" => "Использовать cookies для незарегистрированных пользователей",
"Users can vote again after" => "Пользователи могут голосовать снова после",
"Anytime" => "В любое время",
"Ranks" => "Рейтинг",
"No charts defined yet" => "Чарты еще не определены",
"Admin drawings" => "Управлять рисунками",
"Available drawings" => "Доступные рисунки",
"Ver" => "Вер.",
"Available polls" => "Доступные опросы",
"Random image from" => "Случайное изображение из",
"Dynamic content blocks" => "Блоки динамического содержимого",
"Banner zones" => "Области для баннеров",
"Admin RSS Modules" => "Управлять RSS модулями",
"Rejected users" => "Пропущенные пользователи",
"Old password" => "Старый пароль",
"Parent category" => "Родительская категория",
"Subcategories" => "Подкатегории",
"Admin related categories" => "Управлять родственными категориями",
"Add a related category" => "Добавить родственную категорию",
"Related categories" => "Родственные категории",
"in current category" => "в текущей категории",
"Total categories" => "Всего категорий",
"creates the editable drawing foo" => "создаёт редактируемый рисунок Х",
"table" => "таблица",
"external link" => "внешних ссылок",
"heading1" => "заголовок 1",
"title bar" => "строка заглавия",
"box" => "рамка",
"rss feed" => "rss поток",
"dynamic content" => "динамическое содержимое",
"tagline" => "подпись",
"center text" => "центрировать текст",
"colored text" => "цветной текст",
"quote" => "цитировать",
"special chars" => "другие символы",
"special characters" => "специальные символы",
"Questions per page" => "Число вопросов на лист",
"Activity completed" => "Активность выполнена",
"Admin process activities" => "Управление активностью",
"Add or edit an activity" => "Добавить/изменить активность",
"activity" => "активность",
"split" => "разделение",
"join" => "объединение",
"standalone" => "независимая",
"interactive" => "интерактивная",
"Add transitions" => "Добавить переход",
"Add transition from:" => "Добавить переход из:",
"Add transition to:" => "Добавить переход к:",
"No roles associated to this activity" => "Нет ролей для данной активности",
"Add Role" => "Добавить роль",
"Add New" => "Добавить новую",
"Process activities" => "Активности процесса",
"Int" => "Инт",
"Routing" => "Маршрутизация",
"Interactive" => "Интерактивные",
"Automatic" => "Автоматические",
"Manual" => "Вручную",
"inter" => "интер",
"route" => "маршрут",
"(no roles)" => "(нет ролей)",
"No activities defined yet" => "Активности ещё не назначены",
"Process Transitions" => "Переход процесса",
"List of transitions" => "Список переходов",
"No transitions defined yet" => "Переходы ещё не определены",
"Add a transition" => "Добавить переход",
"This process is invalid" => "Этот процесс неверный",
"List of processes" => "Список процессов",
"Inactive" => "Неактивно",
"val" => "знач",
"Active Process" => "активный процесс",
"Invalid Process" => "неверный процесс",
"Valid Process" => "корректный процесс",
"Activities" => "Активности",
"New Minor" => "new minor",
"New Major" => "new major",
"No processes defined yet" => "Процессы ещё не определены",
"Admin instance" => "Настроить instance",
"Process:" => "Процесс:",
"exception" => "исключение",
"completed" => "выполнено",
"Send all to" => "Отправить все в",
"Don't move" => "Не перемещать",
"Act status" => "Статус акт",
"Property" => "Свойство",
"Add property" => "Добавить свойство",
"Admin processes" => "Настроить процессы",
"Add or edit a process" => "Добавить/изменить процесс",
"Process Name" => "Имя процесса",
"is active?" => "активен?",
"Or upload a process using this form" => "Или закачать процесс через форму",
"Admin process roles" => "Настроить роли процесса",
"Add or edit a role" => "Добавить/изменить роль",
"Process roles" => "Роли процесса",
"No roles defined yet" => "Роли не определены",
"Map users to roles" => "Присвоить роли пользователям",
"map" => "присвоить",
"Map groups to roles" => "Присвоить роли группам",
"Operation" => "Операция",
"No roles are defined yet so no roles can be mapped" => "Роли ещё не определены, поэтому не могут быть назначены",
"List of mappings" => "Список назначений",
"No mappings defined yet" => "Роли ещё не присвоены",
"Get property" => "Прочитать свойство",
"Set property" => "Установить свойство",
"Process form" => "Форма процесса",
"Set Next act" => "Установить след. акт",
"Map process roles" => "Назначить роли процеса",
"Admin Processes" => "Настройка процессов",
"Admin Activities" => "Настройка активностей",
"Admin Roles" => "Настройка ролей",
"Edit this Process" => "Изменить процесс",
"Monitor Activities" => "Мониторинг активности",
"List of activities" => "Перечень активностей",
"Proc" => "Proc",
"run" => "запуск",
"run activity" => "запуск активности",
"monitor processes" => "мониторинг процессов",
"monitor activities" => "мониторинг активности",
"Monitor Processes" => "Мониторинг процессов",
"processes" => "процессы",
"being run" => "работающие",
"Exceptions" => "Исключения",
"User Activities" => "Активности пользователей",
"user processes" => "процессы пользователей",
"user activities" => "активности пользователей",
"User Processes" => "Процессы пользователей",
"Use cache for external pages" => "Кешировать внешние страницы",
"All games are from" => "Все игры взяты с",
"visit the site for more games and fun" => "посетите сайт для остальных игр",
"Upload a game" => "Залить игру",
"Upload a new game" => "Залить новую игру",
"Thumbnail (if the game is foo.swf the thumbnail must be named foo.swf.gif or foo.swf.png or foo.swf.jpg)" => "Иконка (если игра называется foo.swf иконка должна иметь имя файла foo.swf.gif или foo.swf.png или foo.swf.jpg)",
"Edit game" => "Редактировать игру",
"Played" => "Посетители сыграли",
"If you can't see the game then you need a flash plugin for your browser" => "Если Вы не видите игры, Вам, возможно, понадобится Flash-плагин для Вашего браузера",
"Accepted requests" => "Принятые запросы",
"Assigned items" => "Назначенные объекты",
"Select news group" => "Выберите группу новостей",
"Back to servers" => "Вернуться к серверам",
"Msgs" => "Сообщ",
"Back to groups" => "Вернуться к группам",
"Reading article from" => "Читаем статью из",
"Back to list of articles" => "Вернуться к списку статей",
"Newsgroup" => "Группа новостей",
"Configure news servers" => "Настроить сервера новостей",
"Select a news server to browse" => "Выберите сервер новостей для просмотра",
"server" => "сервер",
"News server" => "Сервер новостей",
"Current permissions for this object" => "Текущие права доступа для объекта",
"Tiki Shoutbox" => "Tiki Кричалка",
"Current folder" => "Текущая папка",
"Your personal Wiki Page" => "Ваша Личная Wiki Страница",
"Edit Items" => "изменить содержимое",
"List Charts" => "список чартов",
"Last Chart" => "последний чарт",
"Previous Chart" => "предыдущий чарт",
"Chart created" => "Чарт создан",
"Next Chart" => "следующий чарт",
"Avg" => "средне",
"info/vote" => "инфо/голос",
"Next chart will be generated on" => "Следующий чарт будет сгенерирован",
"View or vote items not listed in the chart" => "Смотреть или голосовать за пункты, не указанные в чарте",
"Select something to vote on" => "Выберите предмет голосования",
"Item information" => "Информация о пункте",
"Dif" => "Разн.",
"Best Position" => "Лучшая Позиция",
"Vote this item" => "Голосовать за пункт",
"Highest" => "Высший",
"Q" => "В",
"A" => "О",
"No process indicated" => "Нет процессов для отображения",
"Activity name already exists" => "Название активности уже существует",
"indicates if the process is active. Invalid processes cant be active" => "показывает активен ли процесс. Неверные процессы не могут быть активны",
"No activity indicated" => "Нет активностей для отображения",
"The process name already exists" => "Название процесса уже существует",
"Process already exists" => "Процесс уже существует",
"You cant execute this activity" => "Вы не можете запустить эту активность",
"The thumbnail name must be" => "Имя иконки должно быть",
"No server indicated" => "Сервер не указан",
"Cannot connect to" => "Не могу подключиться к",
"Missing information to read news (server,port,username,password,group) required" => "Недостаточно информации для чтения новостей, требуется (сервер,порт,имя пользователя,пароль,группа)",
"Cannot get messages" => "Невозможно получить сообщения",
"Tiki Calendar" => "Календарь Tiki",
"Admin Menu" => "Управлять меню",
"RSS Modules" => "Модули RSS",
"Tiki Cache/Sys Admin" => "Кеш Tiki",
"Current events" => "Текущие события",
"Last `\$module_rows` visitors" => "`\$module_rows` посетителей",
"Tiki Logo" => "Tiki логотип",
"RSS Feeds" => "RSS Каналы",
"User informations" => "Информация пользователя",
"Group informations" => "Информация группы",
"Email This Post" => "Отправить по эл.почте",
"RSS feeds" => "RSS раздачи",
"Use titles in blog posts" => "Использовать заголовки в записях блогов",
"Send blog post" => "Отослать ссылку на заметку",
"A link to this post was sent to the following addresses:" => "Ссылка на эту заметку блога была отправлена следующим адресатам:",
"Send post to this addresses" => "Отправить заметку по этим адресам",
"List of email addresses separated by commas" => "Список e-mail адресов, разделённых запятыми",
"Post recommendation at" => "Отправить рекомендацию на",
"Prevent flooding" => "Защита от наплыва сообщений",
"Minimum time between posts" => "Минимальное время между сообщениями",
"Moderator user" => "Модератор",
"Moderator group" => "Группа модератора",
"Only allow replies to the first message (flat forum)" => "Разрешить ответы только на первое сообщение (плоский форум)",
"Send this forums posts to this email" => "Копировать сообщения форума на email",
"Prune unreplied messages after" => "Удалять неотвеченные после",
"Prune old messages after" => "Удалять старые сообщения после",
"POP3 server" => "POP3 сервер",
"Max attachment size (bytes)" => "Максимальный размер вложения (в байтах)",
"Default ordering for topics" => "Сортировка тем по умолчанию",
"Topics per page" => "Число тем на страницу",
"Default ordering for threads" => "Сортировка потоков по умолчанию",
"Default style for threads" => "Настройки ответов по умолчанию",
"Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Подсветка синтаксиса. Не работает при включенной нумерации строк. Например: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
"0|1, may not be used with colors" => "0|1, не работает при указании подсветки синтаксиса",
"0|1, parse wiki syntax within the code snippet" => "0|1, проверять wiki синтаксис внутри кода",
"changed '%s' from '%s' to '%s'" => "'%s' изменен с '%s' на '%s'",
"theme" => "тема",
"Please login" => "Пройдите регистрацию",
"Go to Login Page" => "Перейти к странице регистрации",
"Login as" => "Войти как",
"OpenID Login" => "OpenID Вход",
"logged as" => "Вы вошли как",
"always" => "всегда",
"Not Installed" => "Не установлено",
"like pages" => "подобные страницы",
"Includes" => "Добавления",
"Only directly included" => "Только включенные напрямую",
"Assign Perms to this Group" => "Назначить права этой Группе",
"or use" => "или используйте",
"an existing poll" => "существующий опрос",
"Change administrative info" => "Изменение учетной информации",
"MySQL Improved (mysqli). Requires MySQL 4.1+" => "MySQL Improved (mysqli). Requires MySQL 4.1+",
"Permission denied. You cannot view pages" => "У Вас недостаточно прав для просмотра страниц",
"The copyright management feature is not enabled." => "Возможность управления авторскими правами не включена.",
"Chinese" => "Китайский",
"Serbian" => "Сербский",
"Multimedia" => "Мультимедиа",
"Shadowbox" => "Отбрасывать тень",
"Wiki top articles" => "Лучшие статьи Wiki",
"Wrong registration code" => "Неверный код регистрации",
"Username cannot contain whitespace" => "Логин не должен содержать пробел",
"Invalid email address. You must enter a valid email address" => "Неверный адрес email. Пожалуйста введите настоящий работающий адрес email.",
"More info about \$other_user" => "Дополнительная информация о пользователе \$other_user",
"(idle for \$idletime seconds)" => "(простой \$idletime секунд)",
"__WARNING__: No such module \$plugin!" => "__ВНИМАНИЕ__: Модуль \$plugin! не существует!",
"Default configuration" => "Конфигурация по умолчанию",
"complete" => "завершен(о)",
"articles" => "статьях",
"row1col1" => "строка1столбец1",
"row1col2" => "строка1столбец2",
"row2col1" => "строка2столбец1",
"row2col2" => "строка2столбец2",
"Maximum Size" => "Максимальный размер",
"Message will be sent to: " => "Сообщение будет отправлено: ",
"Page translation" => "Перевод страницы",
"Can edit items in categories" => "Редактирование элементов в категориях",
"Logged in as" => "Вошли как",
"Stay in SSL mode" => "Оставаться в безопасном ssl режиме",
"Search Wiki PageName" => "Найти страницу",
"Login as admin" => "Войти как админ",
"Create a blog" => "Создать блог",
"avatar" => "аватара",
"Feature is disabled" => "Функция отключена",
"Tiki and HTTP Auth" => "Tiki и HTTP Auth",
"Duration:" => "Длительность:",
"Feed for forums" => "Поток данных для форумов",
"Maximum size" => "Максимальный размер",
"Fix UTF-8 Errors in Tables" => "Корректировка ошибок в кодировке UTF-8",
"This function converts ISO-8859-1 encoded strings in your tables to UTF-8" => "Эта функция приведет к смене кодировки строк в таблицах из ISO-8859-1 в UTF-8",
"UTF-8 Errors fixed" => "Ошибки UTF-8 исправлены",
"Fix it" => "Исправить",
"List of types" => "Список типов",
"Save and Exit" => "Сохранить и выйти",
"Watch Only This Category" => "Просмотр только этой категории",
"Watch This Category and Their Descendants" => "Смотреть эту категорию и ее потомков",
"Stop Watching Only This Category" => "Прекратить просмотр этой категории",
"Stop Watching This Category and Their Descendants" => "Прекратить просмотр этой категории и ее потомков",
"Admin Calendar" => "Администрирование календаря",
"Assign permissions to category" => "Назначить права на категорию",
"Current permissions for this category" => "Установленные права для этой категории",
"Remove from this Category Only" => "Удалить только из этой категории",
"Remove from this Category &amp; all its Children" => "Удалить из этой категории &amp; все вложенные",
"Assign permissions" => "Назначить права",
"to group" => "в группу",
"this category &amp; all its children" => "эта категория &amp; все вложенные",
"this category only" => "только эта категория",
"Allow other user to post in this blog" => "Позволить другим размещать сообщения",
"Monitor this page" => "Наблюдать за страницей",
"Upload picture" => "Закачать картинку",
"Replace with" => "Заменить на",
"Import page" => "Импорт страницы",
"License" => "Лицензия",
"Important" => "Важно",
"My Footnotes" => "Мои сноски",
"Use rating" => "Использовать рейтинг",
"Translation request" => "Запрос на перевод",
"Your registration code:" => "Ваш код регистрации:",
"Registration code" => "Код регистрации",
"Add Pages" => "Добавить страницы",
"Use Ctrl+Click to select multiple pages" => "Используйте Ctrl+Click для выбора нескольких страниц",
"Repeat password" => "Снова",
"Remove page" => "Удалить страницу",
"Editing" => "Редактирование",
"Editing posts" => "Редактирование ответов",
"Merge into topic" => "Объединить в тему",
"Add a new" => "Добавить новый",
"Permission denied you cannot view backlinks for this page" => "Доступ запрещён. Вы не имеета прав для просмотра обратных ссылок на эту страницу",
"Permission denied you can not view this section" => "Доступ закрыт, Вы не можете просматривать эту секцию",
"This feature has been disabled" => "Эта возможность была запрещена",
"You do not have permissions to edit banners" => "У Вас недостаточно прав для редактирования баннеров",
"Permission denied you cannot create or edit blogs" => "У Вас недостаточно прав для создания или изменения блогов",
"Permission denied you cannot edit images" => "У Вас недостаточно прав для редактирования изображений",
"Permission denied you cannot send submissions" => "У Вас недостаточно прав для отправки новых поступлений",
"Permission denied. You cannot view pages like this page" => "У Вас недостаточно прав для просмотра этой страниц, подобных этой",
"You cannot admin blogs" => "Вы не можете управлять блогами",
"Permission denied you cannot remove submissions" => "У Вас недостаточно прав для удаления поступлений",
"Permission denied you cannot approve submissions" => "У Вас недостаточно прав для приёмки поступивших данных",
"Must be logged to use this feature" => "Вам следует войти под своим логином для использования этой возможности",
"Permission denied you cannot browse this page history" => "У Вас недостаточно прав для просмотра истории этой страницы",
"Permission denied you cannot remove versions from this page" => "У Вас недостаточно прав для удаления версий этой страницы",
"Permission denied you cannot rename this page" => "Доступ запрещён. Вы не можете переименовать эту страницу",
"Permission denied you cannot rollback this page" => "У Вас недостаточно прав для отката изменений этой страницы",
"You are not logged in and no user indicated" => "Вы не вошли под своим логином, пользователь не указан",
"Permission denied you cannot remove the post" => "У Вас недостаточно прав для удаления сообщения",
"Category path" => "Category path",
"\$feature_label" => "\$feature_label",
"Creation date (desc)" => "Дата создания (убывание)",
"Use different URL as home page" => "Указать вручную URL для домашней страницы",
"Create new file gallery" => "Создать новую файловую галерею",
"Create new sheet" => "Создать новую эл.таблицу",
"duplicate" => "дубликат",
"Edit blog" => "Редактировать блог",
"Create a Gallery" => "Создать галерею",
"disabled" => "отключено",
"enabled" => "включено",
"preference" => "параметр",
"Contact us" => "Свяжитесь с нами",
"Create new forum" => "Создать новый форум",
"Duplicate forum" => "Создать копию форума",
"CSS file" => "CSS файл",
"Create blog" => "Создать блог",
"Create new structure" => "Создать новую структуру",
"Add a site" => "Добавить сайт",
"name (desc)" => "по имени (по убыванию)",
"name (asc)" => "по имени (по возрастанию)",
"hits (desc)" => "число хитов (по убыванию)",
"hits (asc)" => "число хитов (по возрастанию)",
"creation date (desc)" => "дата создания (по убыванию)",
"creation date (asc)" => "дата создания (по возрастанию)",
"last updated (desc)" => "последние изменения (по убыванию)",
"last updated (asc)" => "последние изменения (по возрастанию)",
"Max impressions" => "Максимум показов",
"Show the banner only between these dates" => "Показывать баннер только в промежутке времени",
"From date" => "От даты",
"To date" => "До даты",
"Show the banner only in this hours" => "Показывать баннер только в указанные часы",
"Show the banner only on" => "Показывать баннер только в",
"Mon" => "Пн",
"Tue" => "Вт",
"Wed" => "Ср",
"Thu" => "Чт",
"Fri" => "Пт",
"Sat" => "Сб",
"Sun" => "Вс",
"Dynamic content system" => "Система динамического содержимого",
"Default view" => "Вид по умолчанию",
"Create page" => "Создать страницу",
"Edit task" => "Редактировать задачу",
"preview" => "предпросмотр",
"Passcode to register (not your user password)" => "Секретный код для регистрации (не Ваш личный пароль!)",
"Started" => "Запущено",
"Days online" => "Дней в онлайне",
"Best day" => "Лучший день",
"Worst day" => "Худший день",
"Activity=" => "Активность=",
"viewed" => "просмотров",
"Trackback pings" => "Trackback pings",
"URI" => "URI",
"Tbl vis" => "Tbl vis",
"isMain" => "isMain",
"Tiki Link - Insert internal link" => "Tiki ссылка - Вставка внутренней ссылки",
"find" => "найти",
"prev" => "пред.",
"next" => "след.",
"Requires a separate download" => "Требует отдельного скачивания",
"Spell checking" => "Проверка правописания",
"Comments " => "Комментарии ",
"TikiWiki will check for updates when you access the main Administration page" => "TikiWiki будет проверять наличие обновлений при входе на страницу Адмнистрирования системы",
"Use TikiWiki feature as homepage" => "Установить домашней страницей",
"Default RDF version" => "RDF версия по умолчанию",
"Webmaster" => "Вебмастер",
"phplayers are not available on this site" => "phplayers не доступны на этом сайте",
"sec" => "сек",
"User-Agent Info" => "User-Agent информация",
"Shows ID" => "Показывает ID",
"Shows Icon" => "Показывает иконку",
"Shows Name" => "Показывает имя",
"Shows Filename" => "Показывает имя файла",
"Shows Size" => "Показывает размер",
"Shows Description" => "Показывает описание",
"Shows Creation Date" => "Показывает дату создания",
"Shows Modification Date" => "Показывает дату изменения",
"Shows Author" => "Показывает автора",
"Shows Creator" => "Показывает создателя",
"Comment on the selected post" => "Комментировать выбранное сообщение",
"Enter your name" => "Введите ваше имя",
"The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Страница {\$mail_page} создана {\$mail_user} {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Страница {\$mail_page} удалена {\$mail_user} {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Страница {\$mail_page} изменена {\$mail_user} {\$mail_date|tiki_short_datetime}",
"Wiki page %s created by {\$mail_user}" => "Страница %s создана {\$mail_user}",
"Wiki page %s deleted by {\$mail_user}" => "Страница %s удалена {\$mail_user}",
"Wiki page %s changed by {\$mail_user}" => "Страница %s отредактирована {\$mail_user}",
"The page {\$mail_page} was commented by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "На страницу {\$mail_page} {\$mail_date|tiki_short_datetime} был добавлен комментарий от {\$mail_user}",
"Switch to normal (wiki) editor" => "Использовать простой (wiki) редактор",
"referenced by" => "упоминается",
"references" => "ссылается на",
"View Comments" => "комментарии",
"Blog name" => "Название блога",
"Enlarge area height" => "Увеличить высоту области",
"Reduce area height" => "Уменьшить высоту области",
"Date and Time Formats" => "Формат даты и времени",
"Custom Categories" => "Свои категории",
"Use wysiwyg editor" => "Использовать редактор типа wysiwyg",
"Use normal editor" => "Использовать нормальный редактор",
"Admin external wikis" => "Управлять внешними Wiki",
"There are individual permissions set for this forum" => "Нет индивидуального набора прав доступа для этого форума",
"Add a subscription newsletters" => "Добавить подписку на рассылки",
"Batch e-mail subscribe" => "Пакетная подписка эл.адресов",
"Add subscribers of another newsletter" => "Добавить подписчиков из другой рассылки",
"Articles (subs)" => "Статьи (subs)",
"User must change password at first login" => "Пользователь должен сменить пароль при первом входе",
"Upload image for this post" => "Закачать изображение",
"Spellcheck" => "Правописание",
"You can include the gallery's image in an HTML page using one of these lines" => "Для доступа к изображениям галереи в HTML страницах используйте такую ссылку",
"You can include the image in a tiki page using one of these lines" => "Для доступа к галереи на Tiki страницах используйте короткую ссылку",
"Current heading" => "Текущий заголовок",
"Number of posts to show" => "Число сообщений для показа",
"The syntax system used for creating pages in TikiWiki" => "Используйте систему синтаксиса TikiWiki для создания страниц",
"Edit or ex/import Languages" => "Редактировать или экс/импортировать языки",
"Edit and create Languages" => "Редактировать и создавать языки",
"Edit and create languages" => "Редактировать и создавать языки",
"Create Language" => "Создать язык",
"Shortname" => "Короткое имя",
"Longname" => "Длинное имя",
"Case Insensitivity" => "Любой размер букв",
"Im- Export languages" => "Импорт/экспорт языков",
"Select the language to Import" => "Выберите язык для импорта",
"Close this window" => "Закрыть это окно",
"on:" => "в:",
"On:" => "в:",
"Viewing blog post" => "Просмотр сообщения в блоге",
"Return to blog" => "Вернуться в блог",
"public" => "общедоступная",
"This page is being edited by" => "Эта страница в настоящее время под редакцией",
"Proceed at your own peril" => "Продолжайте на свой страх и риск",
"Insert Row" => "Вставить строку",
"Insert Column" => "Вставить столбец",
"Remove Row" => "Убрать строку",
"Remove Column" => "Убрать столбец",
"Merge Cells" => "Объединить ячейки",
"Restore Cells" => "Восстановить ячейки",
"Copy Calculation" => "Копировать расчет",
"Format Cell" => "Формат ячейки",
"Permission denied you cannot post" => "У Вас недостаточно прав для размещения своего сообщения",
"Shortname must be 2 Characters" => "Короткое имя должно быть 2 символа",
"You must provide a longname" => "Вы должны указать длинное имя",
"Language created" => "Язык создан",
"Cannot rename page maybe new page already exists" => "Не удаётся переименовать страницу, возможно, новая странице уже существует",
"By" => "Автор",
"No Additionnal Sort" => "Нет дополнительных сортировок",
"User Levels" => "Уровни пользователя",
"JQuery Code" => "Код JQuery",
"Lists ''wanted'' wiki pages" => "Список ''требуемых'' wiki страниц",
"Display youtube video in a wiki page" => "Добавление видео от youtube на wiki страницу",
"URL to the Youtube video" => "URL к видео на Youtube",
"Administrator, can manage users groups and permissions, Hotwords and all the weblog features" => "Администратор может управлять группами пользователей и правами доступа, горячими словами и всеми возможностями протоколов",
"Can admin attachments to wiki pages" => "Управление вложениями на страницах wiki",
"Can admin rss modules" => "Управление модулями rss",
"Can admin shoutbox (Edit/remove msgs)" => "Управление кричалкой (редактировать/удалять сообщения)",
"Can admin the cms" => "Управление cms",
"Can administrate group webmail accounts" => "Управление групповыми учетными записями в web-почте",
"Can administrate personal webmail accounts" => "Управление персональныим учетными записями в web-почте",
"Can report msgs to moderator" => "Отправка сообщений модератору",
"Can search on objects of this category" => "Поиск объектов в категории",
"Can validate submited links" => "Подтверждать предложенные ссылки",
"Can view referer stats" => "Просмотр статистики реферала",
"Can view trackers closed items" => "Просмотр закрытых записей в трекере",
"Can view trackers pending items" => "Просмотр записей на рассмотрении в трекере",
"Submited articles automatically approved" => "Размещенные статьи подтверждаются автоматически",
"Submited links are valid" => "Размещенные ссылки считать корректными",
"Trust all user inputs (no security checks)" => "Доверять вводимой пользователем информации (отменить проверки безопасности)",
"Start date" => "Дата начала",
"Line numbers" => "Номера строк",
"Right to left" => "Справа налево",
"on|off" => "вкл|выкл",
"Default width: 425" => "Стандартная ширина: 425",
"Default height: 350" => "Стандартная высота: 350",
"Ftp Server Name" => "Имя Ftp сервера",
"Ftp User name" => "Имя пользователя Ftp",
"Ftp password" => "Пароль Ftp",
"current value (REQUIRED)" => "Текущее значение (ОБЯЗАТЕЛЬНО)",
"groups" => "группы",
"name" => "имя",
"0|1, switch the text display from left to right to right to left" => "0|1, показать текст слева направо или справа налево",
"0|1, display the content as is instead of escaping HTML special chars" => "0|1, отображать содержимое как есть вместо того, чтобы экранировать спец.символы HTML",
"user|page" => "пользователь|страница",
"Create/edit dsn" => "Создать/редактировать DSN",
"TikiSheet" => "Эл.таблица Tiki",
"Add or edit a rule" => "Добавить или редактировать правило",
// ### end of unused words

// ### start of untranslated words
// ### uncomment value pairs as you translate
// "Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information" => "Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information",
// "Uploaded by" => "Uploaded by",
// "Last Modified by" => "Last Modified by",
// "Last download" => "Last download",
// "Aland_Islands" => "Aland_Islands",
// "American_Samoa" => "American_Samoa",
// "Bosnia_and_Herzegovina" => "Bosnia_and_Herzegovina",
// "Bouvet_Island" => "Bouvet_Island",
// "British_Indian_Ocean_Territory" => "British_Indian_Ocean_Territory",
// "British_Virgin_Islands" => "British_Virgin_Islands",
// "Burkina_Faso" => "Burkina_Faso",
// "Cape_Verde" => "Cape_Verde",
// "Catalan_Countries" => "Catalan_Countries",
// "Cayman_Islands" => "Cayman_Islands",
// "Central_African_Republic" => "Central_African_Republic",
// "Christmas_Island" => "Christmas_Island",
// "Cocos_Islands" => "Cocos_Islands",
// "Congo_Democratic" => "Congo_Democratic",
// "Cook_Islands" => "Cook_Islands",
// "Costa_Rica" => "Costa_Rica",
// "Czech_Republic" => "Czech_Republic",
// "Dominican_Republic" => "Dominican_Republic",
// "El_Salvador" => "El_Salvador",
// "Equatorial_Guinea" => "Equatorial_Guinea",
// "Falkland_Islands" => "Falkland_Islands",
// "Faroe_Islands" => "Faroe_Islands",
// "Federated_States_of_Micronesia" => "Federated_States_of_Micronesia",
// "French_Guiana" => "French_Guiana",
// "French_Polynesia" => "French_Polynesia",
// "French_Southern_Territories" => "French_Southern_Territories",
// "Guinea_Bissau" => "Guinea_Bissau",
// "Heard_Island_and_McDonald_Islands" => "Heard_Island_and_McDonald_Islands",
// "Hong_Kong" => "Hong_Kong",
// "Ivory_Coast" => "Ivory_Coast",
// "Marshall_Islands" => "Marshall_Islands",
// "Netherlands_Antilles" => "Netherlands_Antilles",
// "New_Caledonia" => "New_Caledonia",
// "New_Zealand" => "New_Zealand",
// "Norfolk_Island" => "Norfolk_Island",
// "North_Korea" => "North_Korea",
// "Northern_Mariana_Islands" => "Northern_Mariana_Islands",
// "Papua_New_Guinea" => "Papua_New_Guinea",
// "Puerto_Rico" => "Puerto_Rico",
// "Republic_of_Macedonia" => "Republic_of_Macedonia",
// "Russian Federation" => "Russian Federation",
// "Russian_Federation" => "Russian_Federation",
// "Saint_Helena" => "Saint_Helena",
// "Saint_Kitts_and_Nevis" => "Saint_Kitts_and_Nevis",
// "Saint_Lucia" => "Saint_Lucia",
// "Saint_Pierre_and_Miquelon" => "Saint_Pierre_and_Miquelon",
// "San_Marino" => "San_Marino",
// "Sao_Tome_and_Principe" => "Sao_Tome_and_Principe",
// "Saudi_Arabia" => "Saudi_Arabia",
// "Sierra_Leone" => "Sierra_Leone",
// "Solomon_Islands" => "Solomon_Islands",
// "South_Africa" => "South_Africa",
// "South_Georgia_and_South_Sandwich_Islands" => "South_Georgia_and_South_Sandwich_Islands",
// "South_Korea" => "South_Korea",
// "Sri_Lanka" => "Sri_Lanka",
// "St_Vincent_Grenadines" => "St_Vincent_Grenadines",
// "Svalbard_and_Jan_Mayen" => "Svalbard_and_Jan_Mayen",
// "Trinidad_Tobago" => "Trinidad_Tobago",
// "Turks_and_Caicos_Islands" => "Turks_and_Caicos_Islands",
// "US_Virgin_Islands" => "US_Virgin_Islands",
// "United_Arab_Emirates" => "United_Arab_Emirates",
// "United_Kingdom" => "United_Kingdom",
// "United_Kingdom_-_England_and_Wales" => "United_Kingdom_-_England_and_Wales",
// "United_Kingdom_-_Northern_Ireland" => "United_Kingdom_-_Northern_Ireland",
// "United_Kingdom_-_Scotland" => "United_Kingdom_-_Scotland",
// "United_Nations_Organization" => "United_Nations_Organization",
// "United_States" => "United_States",
// "United_States_Minor_Outlying_Islands" => "United_States_Minor_Outlying_Islands",
// "Viet_Nam" => "Viet_Nam",
// "Wallis_and_Futuna" => "Wallis_and_Futuna",
// "Western_Sahara" => "Western_Sahara",
// "the former Yugoslav Republic of Macedonia" => "the former Yugoslav Republic of Macedonia",
// "the_former_Yugoslav_Republic_of_Macedonia" => "the_former_Yugoslav_Republic_of_Macedonia",
// "Tiki Installer" => "Tiki Installer",
// "MySQL Improved (mysqli)" => "MySQL Improved (mysqli)",
// "No database name specified" => "No database name specified",
// "Welsh" => "Welsh",
// "Slovene" => "Slovene",
// "Frisian Netherlands" => "Frisian Netherlands",
// "Indonesian" => "Indonesian",
// "Icelandic" => "Icelandic",
// "Inuktitut" => "Inuktitut",
// "Lithuanian" => "Lithuanian",
// "Norwegian Nynorsk" => "Norwegian Nynorsk",
// "Romanian" => "Romanian",
// "Romansh" => "Romansh",
// "Pijin Solomon" => "Pijin Solomon",
// "Sinhala" => "Sinhala",
// "Albanian" => "Albanian",
// "Turkish" => "Turkish",
// "Vietnamese" => "Vietnamese",
// "anonymous" => "anonymous",
// "Blog cannot be found" => "Blog cannot be found",
// "First day of week: Sunday (its ID is 0) - translators you need to localize this string" => "First day of week: Sunday (its ID is 0) - translators you need to localize this string",
// "Su" => "Su",
// "Mo" => "Mo",
// "Tu" => "Tu",
// "We" => "We",
// "Th" => "Th",
// "Fr" => "Fr",
// "Sa" => "Sa",
// "Empty captcha value" => "Empty captcha value",
// "You have mistyped the anti-bot verification code. Please try again" => "You have mistyped the anti-bot verification code. Please try again",
// "Failed to validate captcha" => "Failed to validate captcha",
// "Captcha ID field is missing" => "Captcha ID field is missing",
// "Get a visual challenge" => "Get a visual challenge",
// "Get an audio challenge" => "Get an audio challenge",
// "Get a new challenge" => "Get a new challenge",
// "Type the two words" => "Type the two words",
// "Type what you hear" => "Type what you hear",
// "Play sound again" => "Play sound again",
// "Download sound as MP3" => "Download sound as MP3",
// "Incorrect. Try again" => "Incorrect. Try again",
// "Expecting \"(\"" => "Expecting \"(\"",
// "Unexpected \"%0\"" => "Unexpected \"%0\"",
// "Expecting \")\"" => "Expecting \")\"",
// "%0 near \"%1\"" => "%0 near \"%1\"",
// "No formula provided" => "No formula provided",
// "Variable not found \"%0\"" => "Variable not found \"%0\"",
// "Unknown operation \"%0\"" => "Unknown operation \"%0\"",
// "Internal error" => "Internal error",
// "User error" => "User error",
// "Plugin argument(s) missing" => "Plugin argument(s) missing",
// "Plugin <strong>%0</strong> cannot be executed" => "Plugin <strong>%0</strong> cannot be executed",
// "Plugin disabled" => "Plugin disabled",
// "The upload has not been done" => "The upload has not been done",
// "Reason: The global quota has been reached" => "Reason: The global quota has been reached",
// "Reason: The quota has been reached in \"%s\"" => "Reason: The quota has been reached in \"%s\"",
// "File gallery quota exceeded" => "File gallery quota exceeded",
// "Number of files transferred to the database" => "Number of files transferred to the database",
// "Number of files transferred to the file system" => "Number of files transferred to the file system",
// "Cannot read to this file" => "Cannot read to this file",
// "Old File deleted" => "Old File deleted",
// "The uploaded file exceeds the upload_max_filesize directive in php.ini" => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
// "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
// "The uploaded file was only partially uploaded. Please try again" => "The uploaded file was only partially uploaded. Please try again",
// "No file was uploaded" => "No file was uploaded",
// "Missing a temporary folder" => "Missing a temporary folder",
// "Failed to write file to disk" => "Failed to write file to disk",
// "File upload stopped by extension" => "File upload stopped by extension",
// "Number of page revisions to import (0 for all revisions)" => "Number of page revisions to import (0 for all revisions)",
// "What to do with page names that already exists in TikiWiki" => "What to do with page names that already exists in TikiWiki",
// "Do not import" => "Do not import",
// "Override" => "Override",
// "Append software name as prefix to the page name" => "Append software name as prefix to the page name",
// "<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "<a href=\"tiki-importer.php\">Click here</a> to finish the import process",
// "\$countParsedData pages parsed. Starting to insert those pages into Tiki" => "\$countParsedData pages parsed. Starting to insert those pages into Tiki",
// "Page \${page['name']} sucessfully imported" => "Page \${page['name']} sucessfully imported",
// "Page \${page['name']} NOT imported (there was already a page with the same name)" => "Page \${page['name']} NOT imported (there was already a page with the same name)",
// "Import images and attachments (see documentation for more information)" => "Import images and attachments (see documentation for more information)",
// "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php",
// "Invalid file mime type" => "Invalid file mime type",
// "XML file does not validate against the Mediawiki XML schema" => "XML file does not validate against the Mediawiki XML schema",
// "Mediawiki XML file version \$xmlVersion is not supported" => "Mediawiki XML file version \$xmlVersion is not supported",
// "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "ABORTING: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments",
// "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) does no exist. Fix the problem or try to import without the attachments" => "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) does no exist. Fix the problem or try to import without the attachments",
// "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) is not writable. Fix the problem or try to import without attachments" => "ABORTING: destination directory for attachments (\$this->attachmentsDestDir) is not writable. Fix the problem or try to import without attachments",
// "Parsing pages" => "Parsing pages",
// "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment" => "No attachments found to import! Make sure you have created your XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachment",
// "Importing attachments" => "Importing attachments",
// "NOT importing file \$fileName as there is already a file with the same name in the destination directory (\$this->attachmentsDestDir)" => "NOT importing file \$fileName as there is already a file with the same name in the destination directory (\$this->attachmentsDestDir)",
// "File \$fileName successfully imported" => "File \$fileName successfully imported",
// "Unable to download file \$fileName. File not found" => "Unable to download file \$fileName. File not found",
// "Error while parsing revision \$i of the page \"\${data['name']}\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)" => "Error while parsing revision \$i of the page \"\${data['name']}\". Or there is a problem on the page syntax or on the Text_Wiki parser (the parser used by the importer)",
// "Page \"\${data['name']}\" successfully parsed with \$countRevisions revisions (from a total of \$totalRevisions revisions)" => "Page \"\${data['name']}\" successfully parsed with \$countRevisions revisions (from a total of \$totalRevisions revisions)",
// "Page \"\${data['name']}\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "Page \"\${data['name']}\" is NOT going to be imported. It was not possible to parse any of the page revisions",
// "Admin ' . \$str));\n\n\n\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-list" => "Admin ' . \$str));\n\n\n\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-list",
// "List ' . \$str));\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-view" => "List ' . \$str));\n\n\n\n\t\t\t\t} else if (strpos(\$script_name, 'tiki-view",
// "View ' . \$str));\n\n\n\t\t\t\t} else { // still not set? guess...\n\t\t\t\t\t\$str = str_replace(array('tiki-" => "View ' . \$str));\n\n\n\t\t\t\t} else { // still not set? guess...\n\t\t\t\t\t\$str = str_replace(array('tiki-",
// "ERROR: unable to write to lang/%s/language.php" => "ERROR: unable to write to lang/%s/language.php",
// "The file lang/\$this->lang/language.php is not well formated. Run get_strings.php?lang=\$this->lang and then try to export the translations again" => "The file lang/\$this->lang/language.php is not well formated. Run get_strings.php?lang=\$this->lang and then try to export the translations again",
// "Query point" => "Query point",
// "No valid ogr2ogr executable" => "No valid ogr2ogr executable",
// "Could not create \$tdo.mif in data directory" => "Could not create \$tdo.mif in data directory",
// "Could not create \$tdo.mid in data directory" => "Could not create \$tdo.mid in data directory",
// "unknown" => "unknown",
// "User Map Generated in" => "User Map Generated in",
// "Image Map Generated in" => "Image Map Generated in",
// "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it" => "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it",
// "Invalid \"from\" date received" => "Invalid \"from\" date received",
// "Invalid \"to\" date received" => "Invalid \"to\" date received",
// "Sorry, \"from\" date must precede \"to\" date" => "Sorry, \"from\" date must precede \"to\" date",
// "Sorry, no data available for the future" => "Sorry, no data available for the future",
// "for month of" => "for month of",
// "for week of" => "for week of",
// "Integer (i)" => "Integer (i)",
// "Percentage (%)" => "Percentage (%)",
// "Float (f)" => "Float (f)",
// "List (L)" => "List (L)",
// "Daily (+)" => "Daily (+)",
// "Monthly and weekly (@)" => "Monthly and weekly (@)",
// "Weekly (-)" => "Weekly (-)",
// "The content retrieved at %s is not a list of mods" => "The content retrieved at %s is not a list of mods",
// "Description not available" => "Description not available",
// "Module Title" => "Module Title",
// "Title to display at the top of the box" => "Title to display at the top of the box",
// "No box" => "No box",
// "Show only the content" => "Show only the content",
// "Decorations" => "Decorations",
// "Show module decorations" => "Show module decorations",
// "No title" => "No title",
// "Show module title" => "Show module title",
// "Perspective" => "Perspective",
// "Only display the module if in one of the listed perspective IDs. Semi-colon separated" => "Only display the module if in one of the listed perspective IDs. Semi-colon separated",
// "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons",
// "Module only applicable for the specified sections. Multiple values can be separated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be separated by semi-colons",
// "Page filter" => "Page filter",
// "Module only applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be separated by semi-colons",
// "No Page" => "No Page",
// "Module not applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be separated by semi-colons",
// "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme file name (e.g. \"thenews.css\"). Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module",
// "Contributor" => "Contributor",
// "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module",
// "Flip" => "Flip",
// "Users can shade module" => "Users can shade module",
// "No numbers" => "No numbers",
// "If set to \"y\", the module will not number list items" => "If set to \"y\", the module will not number list items",
// "Number of rows, or items, to display" => "Number of rows, or items, to display",
// "Default: 10" => "Default: 10",
// "Sending to" => "Sending to",
// "section edit" => "section edit",
// "Payment sent but verification not currently available. (Work in progress)" => "Payment sent but verification not currently available. (Work in progress)",
// "Product" => "Product",
// "Quantity" => "Quantity",
// "Unit Price" => "Unit Price",
// "Cart Check-Out" => "Cart Check-Out",
// "Cclite error" => "Cclite error",
// "No registries specified in admin/payment/cclite" => "No registries specified in admin/payment/cclite",
// "Cclite payment initiated on %0" => "Cclite payment initiated on %0",
// "Connection to cclite server %0 failed for %1<br />\"%2\"" => "Connection to cclite server %0 failed for %1<br />\"%2\"",
// "Tiki credits payment done on %0 for \$amount (using \$creditType)" => "Tiki credits payment done on %0 for \$amount (using \$creditType)",
// "Ajax Xajax" => "Ajax Xajax",
// "Use \"xajax\" library to \"ajaxify\" most Tiki pages" => "Use \"xajax\" library to \"ajaxify\" most Tiki pages",
// "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing" => "Saves your edits as you go along enabling you to recover your work after an \"interruption\". Also enables \"Live\" preview and is required for wysiwyg plugin processing",
// "Users accept internal messages by default" => "Users accept internal messages by default",
// "Users can opt-out of internal messages" => "Users can opt-out of internal messages",
// "Article ordering" => "Article ordering",
// "Default sort mode for the articles on the article listing" => "Default sort mode for the articles on the article listing",
// "Title of articles home page" => "Title of articles home page",
// "Title length" => "Title length",
// "Publication date" => "Publication date",
// "Expiration date" => "Expiration date",
// "Visible" => "Visible",
// "Author Rating" => "Author Rating",
// "Trailer position" => "Trailer position",
// "Between heading and body" => "Between heading and body",
// "Header text position" => "Header text position",
// "Requires a smaller image for list view" => "Requires a smaller image for list view",
// "Next image" => "Next image",
// "Below image" => "Below image",
// "Paginate articles" => "Paginate articles",
// "Divide articles into multiple pages with pagebreak markers" => "Divide articles into multiple pages with pagebreak markers",
// "User ratings on articles" => "User ratings on articles",
// "Allows users to rate the articles" => "Allows users to rate the articles",
// "Article rating options" => "Article rating options",
// "List of options available for the rating of articles" => "List of options available for the rating of articles",
// "Default article image width" => "Default article image width",
// "0 for original image size" => "0 for original image size",
// "Default article image height" => "Default article image height",
// "Custom attributes for article types" => "Custom attributes for article types",
// "Allow additional custom fields for article types" => "Allow additional custom fields for article types",
// "Your ShareThis publisher identifier (optional)" => "Your ShareThis publisher identifier (optional)",
// "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database" => "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database",
// "Tiki" => "Tiki",
// "Tiki and OpenID" => "Tiki and OpenID",
// "Tiki and LDAP" => "Tiki and LDAP",
// "Shibboleth" => "Shibboleth",
// "phpBB" => "phpBB",
// "Token Access" => "Token Access",
// "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service" => "Allow to access the content with superior rights with the presentation of a token. The primary use of this authentication method is to grant temporary access to content to an external service",
// "Token Access Max Timeout" => "Token Access Max Timeout",
// "The maximum duration for which the generated tokens will be valid" => "The maximum duration for which the generated tokens will be valid",
// "Token Access Max Hits" => "Token Access Max Hits",
// "The maximum amount of times a token can be used before it expires" => "The maximum amount of times a token can be used before it expires",
// "Share access rights with friends when using Tell a friend" => "Share access rights with friends when using Tell a friend",
// "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email. Lifespan of the links is defined by the site",
// "Share access rights with friends when using Share" => "Share access rights with friends when using Share",
// "Allow users to share their access rights on the current page with a friend when sending the link by email/twitter/facebook. Lifespan of the links is defined by the site" => "Allow users to share their access rights on the current page with a friend when sending the link by email/twitter/facebook. Lifespan of the links is defined by the site",
// "Create user if not in Tiki" => "Create user if not in Tiki",
// "Use Tiki authentication for Admin login" => "Use Tiki authentication for Admin login",
// "phpBB Version" => "phpBB Version",
// "phpBB Database Hostname" => "phpBB Database Hostname",
// "phpBB Database Username" => "phpBB Database Username",
// "phpBB Database Password" => "phpBB Database Password",
// "phpBB Database Name" => "phpBB Database Name",
// "phpBB Table Prefix" => "phpBB Table Prefix",
// "Use Tiki authentication for users created in tiki" => "Use Tiki authentication for users created in tiki",
// "Host" => "Host",
// "Write LDAP debug Information in Tiki Logs" => "Write LDAP debug Information in Tiki Logs",
// "Use SSL (ldaps)" => "Use SSL (ldaps)",
// "Use TLS" => "Use TLS",
// "LDAP Bind Type" => "LDAP Bind Type",
// "Default: Anonymous Bind" => "Default: Anonymous Bind",
// "Full: userattr=username,UserDN,BaseDN" => "Full: userattr=username,UserDN,BaseDN",
// "OpenLDAP: cn=username,BaseDN" => "OpenLDAP: cn=username,BaseDN",
// "Active Directory (username@domain)" => "Active Directory (username@domain)",
// "Plain Username" => "Plain Username",
// "Search scope" => "Search scope",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "LDAP version" => "LDAP version",
// "Base DN" => "Base DN",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Group DN" => "Group DN",
// "Group attribute" => "Group attribute",
// "Group description attribute" => "Group description attribute",
// "Group OC" => "Group OC",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "Group attribute in group entry" => "Group attribute in group entry",
// "(Leave this empty if the group name is already given in the user attribute)" => "(Leave this empty if the group name is already given in the user attribute)",
// "Admin user" => "Admin user",
// "Admin password" => "Admin password",
// "Disable Tiki users who doesn't have a phpBB login. (They could have been deleted)" => "Disable Tiki users who doesn't have a phpBB login. (They could have been deleted)",
// "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset" => "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset",
// "BigBlueButton" => "BigBlueButton",
// "Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "Integration with the BigBlueButton collaboration server for web conference and screen sharing",
// "BigBlueButton server location" => "BigBlueButton server location",
// "Full URL to the BigBlueButton installation" => "Full URL to the BigBlueButton installation",
// "http://host.example.com/" => "http://host.example.com/",
// "BigBlueButton server salt" => "BigBlueButton server salt",
// "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic" => "A salt key used to generate checksums for the BigBlueButton server to know the requests are authentic",
// "Blogues" => "Blogues",
// "Custom Site Footer Content" => "Custom Site Footer Content",
// "Module (box) shadow start" => "Module (box) shadow start",
// "Module (box) shadow end" => "Module (box) shadow end",
// "Days to display in the Calendar" => "Days to display in the Calendar",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
// "Split hours in periods of" => "Split hours in periods of",
// "First year in the dropdown" => "First year in the dropdown",
// "Enter a year or use +/- N to specify a year relative to the current year" => "Enter a year or use +/- N to specify a year relative to the current year",
// "Last year in the dropdown" => "Last year in the dropdown",
// "Sticky popup" => "Sticky popup",
// "Item view tab" => "Item view tab",
// "Show Add to Google Calendar icon" => "Show Add to Google Calendar icon",
// "Word length of the captcha image" => "Word length of the captcha image",
// "Width of the captcha image in pixels" => "Width of the captcha image in pixels",
// "Level of noise of the captcha image" => "Level of noise of the captcha image",
// "Choose a smaller number for less noise and easier reading" => "Choose a smaller number for less noise and easier reading",
// "Use LDAP information when creating user in Tiki" => "Use LDAP information when creating user in Tiki",
// "Try automatically to connect SSO" => "Try automatically to connect SSO",
// "Force CAS logout when the user logout from tiki" => "Force CAS logout when the user logout from tiki",
// "Show Alternate Login Method in Header" => "Show Alternate Login Method in Header",
// "CAS server version" => "CAS server version",
// "Version 1.0" => "Version 1.0",
// "Version 2.0" => "Version 2.0",
// "Hostname" => "Hostname",
// "Hostname of the CAS server" => "Hostname of the CAS server",
// "Port of the CAS server" => "Port of the CAS server",
// "Path for the CAS server" => "Path for the CAS server",
// "CAS Extra Parameter" => "CAS Extra Parameter",
// "Extra Parameter to pass to the CAS Server" => "Extra Parameter to pass to the CAS Server",
// "CAS Authentication Verification Timeout" => "CAS Authentication Verification Timeout",
// "Verify authentication with the CAS server every N seconds. Null value means never reverify" => "Verify authentication with the CAS server every N seconds. Null value means never reverify",
// "2 minutes" => "2 minutes",
// "Categories used in templates (TPL)" => "Categories used in templates (TPL)",
// "Permits to show alternate content depending on category of current object" => "Permits to show alternate content depending on category of current object",
// "Category Jail" => "Category Jail",
// "Limits the visibility of objects to those in these categories. Used mainly for creating workspaces from perspectives" => "Limits the visibility of objects to those in these categories. Used mainly for creating workspaces from perspectives",
// "Category Defaults" => "Category Defaults",
// "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default" => "Force certain categories to be present. If none of the categories in a given set are provided, assign a category by default",
// "One per line. ex:1,4,6,7/4" => "One per line. ex:1,4,6,7/4",
// "Synchronize multilingual categories" => "Synchronize multilingual categories",
// "Make sure that the categories on the translations are synchronized when modified on any version" => "Make sure that the categories on the translations are synchronized when modified on any version",
// "Only those specified" => "Only those specified",
// "All but those specified" => "All but those specified",
// "Synchronized categories" => "Synchronized categories",
// "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)" => "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (only categories allows) or as a black list (all except thoses specified)",
// "Automatically geocode items when categorized in" => "Automatically geocode items when categorized in",
// "Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "Automatically geocode items based on category name when categorized in the sub-categories of this category ID",
// "Replace existing geocode if any" => "Replace existing geocode if any",
// "When automatically geocoding items based on category name, replace existing geocode if any" => "When automatically geocoding items based on category name, replace existing geocode if any",
// "Use approximate geocode location" => "Use approximate geocode location",
// "When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "When automatically geocoding items based on category name, use randomly approximated location instead of precise location",
// "Exclude these categories" => "Exclude these categories",
// "Separate category IDs with a comma (,)" => "Separate category IDs with a comma (,)",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
// "Users can change site language" => "Users can change site language",
// "Allow users to change the language of the menus and labels" => "Allow users to change the language of the menus and labels",
// "Users can change theme" => "Users can change theme",
// "Users can change their password" => "Users can change their password",
// "Disable title for comments" => "Disable title for comments",
// "Hide the title field on comments and their replies" => "Hide the title field on comments and their replies",
// "Email field" => "Email field",
// "Email field for comments (only for anonymous users)" => "Email field for comments (only for anonymous users)",
// "Website field" => "Website field",
// "Website field for comments (only for anonymous users)" => "Website field for comments (only for anonymous users)",
// "Use vote system for comments" => "Use vote system for comments",
// "Allows users with permission tiki_p_vote_comments to vote comments" => "Allows users with permission tiki_p_vote_comments to vote comments",
// "Allow anonymous visitors to use the \"Contact Us\" feature" => "Allow anonymous visitors to use the \"Contact Us\" feature",
// "Cookie name" => "Cookie name",
// "Domain" => "Domain",
// "Include pageviews by the Admin when reporting stats" => "Include pageviews by the Admin when reporting stats",
// "Enable daily reports for new users" => "Enable daily reports for new users",
// "default mapfile" => "default mapfile",
// "Default diff style" => "Default diff style",
// "HTML diff" => "HTML diff",
// "Side-by-side diff" => "Side-by-side diff",
// "Side-by-side diff by characters" => "Side-by-side diff by characters",
// "Inline diff" => "Inline diff",
// "Inline diff by characters" => "Inline diff by characters",
// "Full side-by-side diff" => "Full side-by-side diff",
// "Full side-by-side diff by characters" => "Full side-by-side diff by characters",
// "Full inline diff" => "Full inline diff",
// "Full inline diff by characters" => "Full inline diff by characters",
// "Unified diff" => "Unified diff",
// "Side-by-side view" => "Side-by-side view",
// "Default number of rows for comment box" => "Default number of rows for comment box",
// "Forum reply" => "Forum reply",
// "Default Editor" => "Default Editor",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
// "Max. number of links around the current item" => "Max. number of links around the current item",
// "Max. number of links after the first or before the last item" => "Max. number of links after the first or before the last item",
// "Show the country flag" => "Show the country flag",
// "Enable cool sites" => "Enable cool sites",
// "Number of columns per page when listing directory categories" => "Number of columns per page when listing directory categories",
// "6" => "6",
// "Method to Open Directory Links" => "Method to Open Directory Links",
// "Re-validate user by email after" => "Re-validate user by email after",
// "Use \"-1\" for never" => "Use \"-1\" for never",
// "PHP errors visible to admin only" => "PHP errors visible to admin only",
// "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators" => "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators",
// "PHP Error reporting level" => "PHP Error reporting level",
// "Level from which errors should be reported" => "Level from which errors should be reported",
// "Report all PHP errors except strict" => "Report all PHP errors except strict",
// "Report all PHP errors except notices" => "Report all PHP errors except notices",
// "According to PHP configuration" => "According to PHP configuration",
// "Question and Answer prefix on Answers" => "Question and Answer prefix on Answers",
// "Faqs" => "Faqs",
// "Force and limit categorization to within subtree of" => "Force and limit categorization to within subtree of",
// "Collaboratively authored documents with history of changes" => "Collaboratively authored documents with history of changes",
// "Online diaries or journals" => "Online diaries or journals",
// "Collections of graphic images for viewing or downloading (photo album)" => "Collections of graphic images for viewing or downloading (photo album)",
// "You can use file galleries instead" => "You can use file galleries instead",
// "Machine Translation (by Google Translate)" => "Machine Translation (by Google Translate)",
// "Uses Google Translate to translate the content of wiki pages to other languages" => "Uses Google Translate to translate the content of wiki pages to other languages",
// "Experimental. This feature is still under development" => "Experimental. This feature is still under development",
// "Database & form generator" => "Database & form generator",
// "Online discussions on a variety of topics. Threaded or flat" => "Online discussions on a variety of topics. Threaded or flat",
// "Computer files, videos or software for downloading. With check-in & check-out (lock)" => "Computer files, videos or software for downloading. With check-in & check-out (lock)",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
// "Brief list of votable options; appears in module (left or right column)" => "Brief list of votable options; appears in module (left or right column)",
// "Content mailed to registered users" => "Content mailed to registered users",
// "Events calendar with public, private and group channels" => "Events calendar with public, private and group channels",
// "Insert, track, and manage advertising banners" => "Insert, track, and manage advertising banners",
// "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions" => "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions",
// "Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score is a game to motivate participants to increase their contribution by comparing to other users",
// "Tiki-indexed Search" => "Tiki-indexed Search",
// "Enables searching for content on the website, using Tiki-managed index" => "Enables searching for content on the website, using Tiki-managed index",
// "Unless you have a reason to, you should use MySQL Full-Text Search feature instead" => "Unless you have a reason to, you should use MySQL Full-Text Search feature instead",
// "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns" => "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns",
// "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis" => "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis",
// "Contribution" => "Contribution",
// "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports" => "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports",
// "Enables internationalization features and multilingual support for then entire site" => "Enables internationalization features and multilingual support for then entire site",
// "Frequently asked questions and answers" => "Frequently asked questions and answers",
// "You can use wiki pages instead" => "You can use wiki pages instead",
// "Questionnaire with multiple choice or open ended question" => "Questionnaire with multiple choice or open ended question",
// "User-submitted Web links" => "User-submitted Web links",
// "Timed questionnaire with recorded scores" => "Timed questionnaire with recorded scores",
// "Simple menu system which can optionally add an external web page in an iframe" => "Simple menu system which can optionally add an external web page in an iframe",
// "The Copyright Management System (or ©MS) is a way of licensing your content" => "The Copyright Management System (or ©MS) is a way of licensing your content",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
// "Navigable, interactive maps with user-selectable layers" => "Navigable, interactive maps with user-selectable layers",
// "Requires mapserver" => "Requires mapserver",
// "Google Maps" => "Google Maps",
// "Interactive use of Google Maps" => "Interactive use of Google Maps",
// "One-on-one chatting with customer" => "One-on-one chatting with customer",
// "Add a link \"Email this page\" in all the pages" => "Add a link \"Email this page\" in all the pages",
// "Share" => "Share",
// "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums" => "Add a \"Share\" link in all pages to send it via e-mail, Twitter, Facebook, message or forums",
// "be careful when allowing to anonymous to activate the antibot feature" => "be careful when allowing to anonymous to activate the antibot feature",
// "Static and dynamic HTML content" => "Static and dynamic HTML content",
// "HTML can be used in wiki pages. This is a separate feature" => "HTML can be used in wiki pages. This is a separate feature",
// "Basic form from visitor to admin" => "Basic form from visitor to admin",
// "Real-time group text chatting" => "Real-time group text chatting",
// "An admin must validate a comment before it is visible" => "An admin must validate a comment before it is visible",
// "Comments can be closed (no new comments)" => "Comments can be closed (no new comments)",
// "Allow logged in users to pretend to be anonymous when posting a commment" => "Allow logged in users to pretend to be anonymous when posting a commment",
// "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally" => "This can be used to encourage honest feedback with the opportunity to voice an opinion anonymously. Like in a forum where you ask feedback on what is done wrong or should be improved internally",
// "Display page description" => "Display page description",
// "Display the page description below the heading when viewing the page" => "Display the page description below the heading when viewing the page",
// "Display page name as page title" => "Display page name as page title",
// "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header" => "Display the page name at the top of each page as page title. If not enabled, the page content should be structured to contain a header",
// "Display page ID" => "Display page ID",
// "Display the internal page ID when viewing the page" => "Display the internal page ID when viewing the page",
// "Individual wiki cache" => "Individual wiki cache",
// "Allow users to change the duration of the cache on a per-page basis" => "Allow users to change the duration of the cache on a per-page basis",
// "JS Calendar" => "JS Calendar",
// "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled" => "JavaScript popup date selector. Will use jQuery UI DatePicker if enabled",
// "PHPLayers" => "PHPLayers",
// "PhpLayers Dynamic menus" => "PhpLayers Dynamic menus",
// "Will eventually be removed from Tiki. Use CSS menus instead" => "Will eventually be removed from Tiki. Use CSS menus instead",
// "Output should be HTML Purified" => "Output should be HTML Purified",
// "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS" => "This enables HTML Purifier on outputs to filter potential remaining security problems like XSS",
// "Full Screen" => "Full Screen",
// "CSS Menus" => "CSS Menus",
// "CSS Menus (suckerfish)" => "CSS Menus (suckerfish)",
// "Shadowbox / ColorBox" => "Shadowbox / ColorBox",
// "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>" => "\"Displaying content with Eye Candy\". <br />Uses jQuery plugin \"ColorBox\". e.g. <code>{img fileId=\"42\" thumb=\"y\" alt=\"\" rel=\"box[g]\"}</code>",
// "Quick Permission Assignment" => "Quick Permission Assignment",
// "Quickperms allow to define classes of privileges and grant them to roles on objects" => "Quickperms allow to define classes of privileges and grant them to roles on objects",
// "HTML Purifier" => "HTML Purifier",
// "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature" => "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature",
// "Ajax" => "Ajax",
// "Mobile" => "Mobile",
// "Outputs a WAP and VoiceXML version" => "Outputs a WAP and VoiceXML version",
// "Morcego 3D browser" => "Morcego 3D browser",
// "Visualize relationships between wiki pages, in a 3D applet" => "Visualize relationships between wiki pages, in a 3D applet",
// "Intertiki" => "Intertiki",
// "Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "Allows several Tiki sites (slaves) to get authentication from a master Tiki site",
// "Populate wiki pages and articles by email" => "Populate wiki pages and articles by email",
// "Mindmap" => "Mindmap",
// "Print Indexed" => "Print Indexed",
// "SpreadSheet" => "SpreadSheet",
// "Datasheets with calculations and charts" => "Datasheets with calculations and charts",
// "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor" => "WYSIWYG is an acronym for What You See Is What You Get. Uses CKEditor",
// "Save draft" => "Save draft",
// "Experimental (Requires AJAX)" => "Experimental (Requires AJAX)",
// "Kaltura" => "Kaltura",
// "Collaborative video editing" => "Collaborative video editing",
// "Users can identify other users as their friends" => "Users can identify other users as their friends",
// "Neglected feature" => "Neglected feature",
// "Deny access to specific users based on username, IP, and date/time range" => "Deny access to specific users based on username, IP, and date/time range",
// "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)",
// "Action calendar" => "Action calendar",
// "Record domain name of sites that send visitors to this Tiki" => "Record domain name of sites that send visitors to this Tiki",
// "On error, goto the HomePage as configured in Admin->General" => "On error, goto the HomePage as configured in Admin->General",
// "Send/receive wiki pages and articles between Tiki-powered sites" => "Send/receive wiki pages and articles between Tiki-powered sites",
// "Daily Reports for User Watches" => "Daily Reports for User Watches",
// "User Watches Translations" => "User Watches Translations",
// "User Watches Languages" => "User Watches Languages",
// "Watch language-specific changes within a category" => "Watch language-specific changes within a category",
// "Menu User Levels" => "Menu User Levels",
// "Allows to control the menu options that can be seen by a user" => "Allows to control the menu options that can be seen by a user",
// "Permits recording and playback of functional tests" => "Permits recording and playback of functional tests",
// "Tiki will check for updates when you access the main Administration page" => "Tiki will check for updates when you access the main Administration page",
// "Use PEAR::Date library" => "Use PEAR::Date library",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
// "Protect against CSRF with a ticket" => "Protect against CSRF with a ticket",
// "Lookup the user\\'s preferred language through browser preferences" => "Lookup the user\\'s preferred language through browser preferences",
// "Show pages in user\\'s preferred language" => "Show pages in user\\'s preferred language",
// "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page" => "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page",
// "Changing the page language also changes the site language" => "Changing the page language also changes the site language",
// "Translation assistant" => "Translation assistant",
// "Track translation operations between pages" => "Track translation operations between pages",
// "Urgent translation notifications" => "Urgent translation notifications",
// "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users" => "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users",
// "Only allow urgent translation from site language" => "Only allow urgent translation from site language",
// "Use the site language as a master language and prevent translations from sending critical updates" => "Use the site language as a master language and prevent translations from sending critical updates",
// "Incomplete translation notice" => "Incomplete translation notice",
// "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete" => "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete",
// "Multilingual structures" => "Multilingual structures",
// "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures" => "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures",
// "Display all languages in a single page" => "Display all languages in a single page",
// "List all languages as a language option in the page language drop list to see all languages at once" => "List all languages as a language option in the page language drop list to see all languages at once",
// "GZip output" => "GZip output",
// "Compress your pages on-the-fly, if the requesting browser supports this" => "Compress your pages on-the-fly, if the requesting browser supports this",
// "Help System" => "Help System",
// "Translation URLs" => "Translation URLs",
// "Show clickable URLs to translate the page to another language using Babel Fish website" => "Show clickable URLs to translate the page to another language using Babel Fish website",
// "Translation icons" => "Translation icons",
// "Show clickable icons to translate the page to another language using Babelfish website" => "Show clickable icons to translate the page to another language using Babelfish website",
// "Also known as emoticons" => "Also known as emoticons",
// "Bloc of content which can be reused and programmed (timed)" => "Bloc of content which can be reused and programmed (timed)",
// "Use File Galleries to store pictures" => "Use File Galleries to store pictures",
// "If disabled, pictures will be stored in ../img/wiki_up/.. instead" => "If disabled, pictures will be stored in ../img/wiki_up/.. instead",
// "External link icon" => "External link icon",
// "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon" => "External links will be identifed with an icon. Use the ../img/icons/external_link.gif image to customize the icon",
// "Add \"rel=nofollow\" on external links" => "Add \"rel=nofollow\" on external links",
// "Semantic links" => "Semantic links",
// "Going beyond Backlinks, allows to define some semantic relationships between wiki pages" => "Going beyond Backlinks, allows to define some semantic relationships between wiki pages",
// "Web Services" => "Web Services",
// "Can consume webservices in JSON or YAML" => "Can consume webservices in JSON or YAML",
// "Breadcrumbs" => "Breadcrumbs",
// "Attempts to show you where you are" => "Attempts to show you where you are",
// "Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonymous editors must enter anti-bot code (CAPTCHA)",
// "Protect email against spam" => "Protect email against spam",
// "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)",
// "Comments for polls" => "Comments for polls",
// "Comments for FAQs" => "Comments for FAQs",
// "Search engine friendly url" => "Search engine friendly url",
// "If you are using Apache, you can rename _htaccess to .htaccess to get Short URLs" => "If you are using Apache, you can rename _htaccess to .htaccess to get Short URLs",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the sefurl" => "Display blog title in the sefurl",
// "Redirect tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "Redirect tiki-view_tracker.php?itemId=yyy to Prefixyyy page",
// "This redirection uses the wiki prefix alias feature" => "This redirection uses the wiki prefix alias feature",
// "Show module controls" => "Show module controls",
// "Perspectives" => "Perspectives",
// "Permits to override preferences" => "Permits to override preferences",
// "Search and replace" => "Search and replace",
// "Permits find and replace of content in the edit box" => "Permits find and replace of content in the edit box",
// "Comments for articles" => "Comments for articles",
// "Pre-defined content for a wiki page" => "Pre-defined content for a wiki page",
// "Specify notification emails when creating articles" => "Specify notification emails when creating articles",
// "ShareThis buttons" => "ShareThis buttons",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
// "Category Path" => "Category Path",
// "Show category tree, above wiki pages" => "Show category tree, above wiki pages",
// "Show category objects" => "Show category objects",
// "Show objects sharing the same category, below wiki pages" => "Show objects sharing the same category, below wiki pages",
// "Use PHPLayers for category browser" => "Use PHPLayers for category browser",
// "Ignore category viewing restrictions" => "Ignore category viewing restrictions",
// "Will improve performance, but may show forbidden results" => "Will improve performance, but may show forbidden results",
// "MySQL Full-Text Search" => "MySQL Full-Text Search",
// "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated" => "This search uses the MySQL Full-Text Search feature. The indexation is continuously updated",
// "Referer Search Highlighting" => "Referer Search Highlighting",
// "Ignore individual object permissions" => "Ignore individual object permissions",
// "Object filter" => "Object filter",
// "Search box" => "Search box",
// "Pertinence" => "Pertinence",
// "Object type" => "Object type",
// "Last modified date" => "Last modified date",
// "Custom blog headings" => "Custom blog headings",
// "Publish dates can be modified" => "Publish dates can be modified",
// "Comments on blog posts" => "Comments on blog posts",
// "File Gallery Comments" => "File Gallery Comments",
// "Topic archiving" => "Topic archiving",
// "Quick jumps" => "Quick jumps",
// "Replies are empty" => "Replies are empty",
// "If disabled, replies will quote the original post" => "If disabled, replies will quote the original post",
// "First post of a thread can have an empty body" => "First post of a thread can have an empty body",
// "Will be a thread title" => "Will be a thread title",
// "Forum name search" => "Forum name search",
// "When listing forums" => "When listing forums",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Tiki-indexed search" => "Tiki-indexed search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Store password as plain text" => "Store password as plain text",
// "Encryption method" => "Encryption method",
// "Assign different themes to different sections, categories, and objects" => "Assign different themes to different sections, categories, and objects",
// "Tiki Template Viewing" => "Tiki Template Viewing",
// "Custom Doctype" => "Custom Doctype",
// "Use custom !DOCTYPE" => "Use custom !DOCTYPE",
// "Custom Doctype Content" => "Custom Doctype Content",
// "Use to generate the Tiki layout with custom &lt;!DOCTYPE&gt; specified" => "Use to generate the Tiki layout with custom &lt;!DOCTYPE&gt; specified",
// "Custom HTML <head> Content" => "Custom HTML <head> Content",
// "Use to include custom &lt;meta&gt; or &lt;link&gt; tags" => "Use to include custom &lt;meta&gt; or &lt;link&gt; tags",
// "Add BASE tag in the page HEAD" => "Add BASE tag in the page HEAD",
// "The &lt;base&gt; tag specifies a default address for all links on a page" => "The &lt;base&gt; tag specifies a default address for all links on a page",
// "Custom Site Header" => "Custom Site Header",
// "Site Logo and Title" => "Site Logo and Title",
// "Search Bar" => "Search Bar",
// "Login Bar" => "Login Bar",
// "Top Bar Custom Code" => "Top Bar Custom Code",
// "Display current Tiki version" => "Display current Tiki version",
// "Site menu bar" => "Site menu bar",
// "Site menu custom code" => "Site menu custom code",
// "Secondary site menu custom code" => "Secondary site menu custom code",
// "Menu ID" => "Menu ID",
// "Needs either CSS Menus or PHPLayers" => "Needs either CSS Menus or PHPLayers",
// "Top Bar" => "Top Bar",
// "Custom Center Column Header" => "Custom Center Column Header",
// "Controls visibility of the left column of modules" => "Controls visibility of the left column of modules",
// "side bar" => "side bar",
// "Only if module" => "Only if module",
// "Always" => "Always",
// "User Decides" => "User Decides",
// "Right Column" => "Right Column",
// "Controls visibility of the right column of modules" => "Controls visibility of the right column of modules",
// "Prefix breadcrumbs with \"Location : \"" => "Prefix breadcrumbs with \"Location : \"",
// "Site location bar" => "Site location bar",
// "Top of page" => "Top of page",
// "Top of center column" => "Top of center column",
// "Larger font for" => "Larger font for",
// "Entire location" => "Entire location",
// "Custom Site Footer" => "Custom Site Footer",
// "Custom End of <body> Code" => "Custom End of <body> Code",
// "Bottom bar icons" => "Bottom bar icons",
// "Bottom bar debug" => "Bottom bar debug",
// "Indicate various debug-related information in the footer of the site (Execution time, Memory usage, etc.)" => "Indicate various debug-related information in the footer of the site (Execution time, Memory usage, etc.)",
// "Bottom bar (RSS)" => "Bottom bar (RSS)",
// "Webmaster Report" => "Webmaster Report",
// "Webmaster Email" => "Webmaster Email",
// "Leave blank to use the default sender email" => "Leave blank to use the default sender email",
// "Add a link at the bottom if set, otherwise add a link at the top" => "Add a link at the bottom if set, otherwise add a link at the top",
// "Shadow layer" => "Shadow layer",
// "Additional layers for shadows, rounded corners or other decorative styling" => "Additional layers for shadows, rounded corners or other decorative styling",
// "Tooltips" => "Tooltips",
// "Make tooltips such as this appear in a custom style. Use CSS to change their appearance" => "Make tooltips such as this appear in a custom style. Use CSS to change their appearance",
// "Autocomplete" => "Autocomplete",
// "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc" => "Provides various drop-down menus on many text input boxes for page names, user names, groups, tags etc",
// "Superfish" => "Superfish",
// "Adds animation effects to CSS \"Suckerfish\" menus" => "Adds animation effects to CSS \"Suckerfish\" menus",
// "Reflection" => "Reflection",
// "Allows images to have a reflection effect below them. See the admin icons above for an example" => "Allows images to have a reflection effect below them. See the admin icons above for an example",
// "JQuery UI" => "JQuery UI",
// "Include jQuery UI library. Enables many user interface features" => "Include jQuery UI library. Enables many user interface features",
// "JQuery UI Theme" => "JQuery UI Theme",
// "jQuery UI Theme. Used in spreadsheet, for example" => "jQuery UI Theme. Used in spreadsheet, for example",
// "Validation" => "Validation",
// "Provides various validation possibilities like in Trackers" => "Provides various validation possibilities like in Trackers",
// "JQuery JQS5" => "JQuery JQS5",
// "jQuery Simple Standards-Based Slide Show System" => "jQuery Simple Standards-Based Slide Show System",
// "JQuery Infinite Carousel" => "JQuery Infinite Carousel",
// "Image \"carousel\" plugin (coming soon)" => "Image \"carousel\" plugin (coming soon)",
// "JQuery Sortable Tables" => "JQuery Sortable Tables",
// "Sort in fancytable plugin" => "Sort in fancytable plugin",
// "JQuery Media" => "JQuery Media",
// "Media player" => "Media player",
// "Use Tabs" => "Use Tabs",
// "Correct PNG images alpha transparency in IE6 (experimental)" => "Correct PNG images alpha transparency in IE6 (experimental)",
// "Warn on edit conflict" => "Warn on edit conflict",
// "Tiki will warn users who attempt to edit a page that another user is currenly editing" => "Tiki will warn users who attempt to edit a page that another user is currenly editing",
// "Create private notes for a page that are visible only by the author" => "Create private notes for a page that are visible only by the author",
// "Log bytes changes (+/-) in action logs" => "Log bytes changes (+/-) in action logs",
// "May impact performance" => "May impact performance",
// "A special wiki page for testing. Users can edit, but not save the Sandbox" => "A special wiki page for testing. Users can edit, but not save the Sandbox",
// "Comments below wiki pages" => "Comments below wiki pages",
// "Allow users (with permission) to post threaded comments to a page" => "Allow users (with permission) to post threaded comments to a page",
// "Allow users to upload images (pictures) to a page" => "Allow users to upload images (pictures) to a page",
// "WikiWords" => "WikiWords",
// "Automatically convert words with UpPeR and LoWeR-case letters into wiki links" => "Automatically convert words with UpPeR and LoWeR-case letters into wiki links",
// "Link plural WikiWords to their singular forms" => "Link plural WikiWords to their singular forms",
// "Accept dashes and underscores in WikiWords" => "Accept dashes and underscores in WikiWords",
// "Display IP address" => "Display IP address",
// "History all instead of only page data, description, and change comment" => "History all instead of only page data, description, and change comment",
// "View page contributions by author" => "View page contributions by author",
// "Visualize the contributions of different authors made to a wiki page" => "Visualize the contributions of different authors made to a wiki page",
// "Include a link on each page to a forum topic" => "Include a link on each page to a forum topic",
// "Similar (like pages)" => "Similar (like pages)",
// "Open page as structure" => "Open page as structure",
// "Make structure from page" => "Make structure from page",
// "Categorize structure pages together" => "Categorize structure pages together",
// "Create webhelp from structure" => "Create webhelp from structure",
// "A personal page for the user to manage" => "A personal page for the user to manage",
// "UserPage prefix" => "UserPage prefix",
// "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty" => "All user pages share a common prefix. The concatenation of the prefix and the username will generate the page name. The prefix cannot be empty",
// "Users can lock pages" => "Users can lock pages",
// "Use wiki page staging and approval" => "Use wiki page staging and approval",
// "This feature is experimental" => "This feature is experimental",
// "Allows wiki pages to be staged (drafted) before they are approved (published)" => "Allows wiki pages to be staged (drafted) before they are approved (published)",
// "Pages not in structure" => "Pages not in structure",
// "Allow users to upload (attach) files to a page" => "Allow users to upload (attach) files to a page",
// "Display show/hide icon displayed before headings" => "Display show/hide icon displayed before headings",
// "Metrics Dashboard" => "Metrics Dashboard",
// "Generate automated statistics from configured database queries" => "Generate automated statistics from configured database queries",
// "Wiki argument variables" => "Wiki argument variables",
// "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "Allow to write request variables inside wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}",
// "Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirm that the Admin account has a valid email address or you will not be permitted to login",
// "Users can choose to stay in SSL mode after an HTTPS login" => "Users can choose to stay in SSL mode after an HTTPS login",
// "Users can switch between secured or standard mode at login" => "Users can switch between secured or standard mode at login",
// "Wiki paragraph formatting" => "Wiki paragraph formatting",
// "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines" => "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
// "...but still create line breaks within paragraphs" => "...but still create line breaks within paragraphs",
// "AutoLinks" => "AutoLinks",
// "Tiki will automatically convert http:// and email addresses into links" => "Tiki will automatically convert http:// and email addresses into links",
// "Open Hotwords in new window" => "Open Hotwords in new window",
// "Use Quote plugin rather than \">\" for quoting" => "Use Quote plugin rather than \">\" for quoting",
// "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator" => "Use three colons instead of two to center text. Avoids conflict with C++ resolution scope operator",
// "Users can choose to show their gender" => "Users can choose to show their gender",
// "Picture (avatar)" => "Picture (avatar)",
// "WebDAV access to Tiki" => "WebDAV access to Tiki",
// "Allow to access File Galleries with WebDAV" => "Allow to access File Galleries with WebDAV",
// "use tiki-webdav.php as the URI of the WebDAV repository" => "use tiki-webdav.php as the URI of the WebDAV repository",
// "Fixed width" => "Fixed width",
// "Constrains the site display to 990px wide" => "Constrains the site display to 990px wide",
// "You can modify at styles/layout/layout.css - selector #fixedwidth" => "You can modify at styles/layout/layout.css - selector #fixedwidth",
// "Social networks" => "Social networks",
// "Integration with different social networks like Twitter or Facebook" => "Integration with different social networks like Twitter or Facebook",
// "Group Transition" => "Group Transition",
// "Enables transitions for users between different groups. Transitions will create a user approval workflow" => "Enables transitions for users between different groups. Transitions will create a user approval workflow",
// "Category Transition" => "Category Transition",
// "Enables transitions on objects between different categories. Transitions will create a document workflow" => "Enables transitions on objects between different categories. Transitions will create a document workflow",
// "Ustream Watershed" => "Ustream Watershed",
// "Integration to Ustream Watershed live video streaming" => "Integration to Ustream Watershed live video streaming",
// "Tiki User Credits" => "Tiki User Credits",
// "Invite users" => "Invite users",
// "Allow users to invite new users by mail to register on this tiki" => "Allow users to invite new users by mail to register on this tiki",
// "Load Balancer" => "Load Balancer",
// "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server" => "Enable this only if the server is behind a load balancer (or reverse proxy), this allow tiki to log the IP of the user, instead of the IP of the proxy server",
// "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications" => "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also make sure your documents are standards compliant, something only achievable with a comprehensive knowledge of W3C's specifications",
// "Show user's contribution on the user information page" => "Show user's contribution on the user information page",
// "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'" => "nofollow is used to instruct some search engines that links should not influence search engines. It can reduce search engine spam and prevent 'spamdexing'",
// "Require file author's name for anonymous uploads" => "Require file author's name for anonymous uploads",
// "Add a Powered by Tiki link on your site's footer" => "Add a Powered by Tiki link on your site's footer",
// "Redirect to similar wiki page" => "Redirect to similar wiki page",
// "If a requested page doesn't exist, redirect to a similarly named page" => "If a requested page doesn't exist, redirect to a similarly named page",
// "User's page" => "User's page",
// "Default feed format" => "Default feed format",
// "ATOM 1.0" => "ATOM 1.0",
// "RSS 2.0" => "RSS 2.0",
// "Feed author name" => "Feed author name",
// "This field is mandatory unless both feed author email and homepage are empty" => "This field is mandatory unless both feed author email and homepage are empty",
// "Feeed author email" => "Feeed author email",
// "Feed author homepage" => "Feed author homepage",
// "Feed editor email" => "Feed editor email",
// "Email address for person responsible for editorial content" => "Email address for person responsible for editorial content",
// "Feed webmaster email" => "Feed webmaster email",
// "Email address for person responsible for technical issues relating to channel" => "Email address for person responsible for technical issues relating to channel",
// "Image path" => "Image path",
// "Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "Specifies a GIF, JPEG or PNG image that can be displayed with the feed",
// "RSS basic Authentication" => "RSS basic Authentication",
// "Propose basic http authentication if the user has no permission to see the feed" => "Propose basic http authentication if the user has no permission to see the feed",
// "Caching time" => "Caching time",
// "Use 0 for no caching" => "Use 0 for no caching",
// "RSS feeds for articles" => "RSS feeds for articles",
// "RSS feeds for blogs" => "RSS feeds for blogs",
// "Individual Blogs" => "Individual Blogs",
// "RSS feed for individual blogs" => "RSS feed for individual blogs",
// "RSS feed for image galleries" => "RSS feed for image galleries",
// "Individual Image galleries" => "Individual Image galleries",
// "RSS feed for individual image galleries" => "RSS feed for individual image galleries",
// "RSS feed for file galleries" => "RSS feed for file galleries",
// "Individual file galleries" => "Individual file galleries",
// "RSS feed for individual file galleries" => "RSS feed for individual file galleries",
// "RSS feed for wiki" => "RSS feed for wiki",
// "RSS feed for forums" => "RSS feed for forums",
// "Individual Forums" => "Individual Forums",
// "RSS feed for individual forums" => "RSS feed for individual forums",
// "RSS feed for trackers" => "RSS feed for trackers",
// "Individual trackers items" => "Individual trackers items",
// "RSS feed for individual trackers items" => "RSS feed for individual trackers items",
// "Calendar events" => "Calendar events",
// "RSS feed for calendar events" => "RSS feed for calendar events",
// "Directories" => "Directories",
// "RSS feed for directories" => "RSS feed for directories",
// "RSS feed for maps" => "RSS feed for maps",
// "RSS feed for shoutbox" => "RSS feed for shoutbox",
// "Maximum number of items to display" => "Maximum number of items to display",
// "Show Author" => "Show Author",
// "Homepage URL" => "Homepage URL",
// "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used",
// "Article RSS Description" => "Article RSS Description",
// "Description to be published as part of the RSS feed for articles" => "Description to be published as part of the RSS feed for articles",
// "Blogs RSS Description" => "Blogs RSS Description",
// "Description to be published as part of the RSS feed for blogs" => "Description to be published as part of the RSS feed for blogs",
// "Blog RSS Description" => "Blog RSS Description",
// "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used" => "Description to be prepended to the blog description and published as part of the RSS feed for individual blogs. If this field is empty only the blog description will be used",
// "Image galleries RSS Description" => "Image galleries RSS Description",
// "Description to be published as part of the RSS feed for image galleries" => "Description to be published as part of the RSS feed for image galleries",
// "Individual image galleries RSS Description" => "Individual image galleries RSS Description",
// "Description to be published as part of the RSS feed for individual image galleries" => "Description to be published as part of the RSS feed for individual image galleries",
// "File galleries RSS Description" => "File galleries RSS Description",
// "Description to be published as part of the RSS feed for file galleries" => "Description to be published as part of the RSS feed for file galleries",
// "Individual file galleries RSS Description" => "Individual file galleries RSS Description",
// "Description to be published as part of the RSS feed for individual file galleries" => "Description to be published as part of the RSS feed for individual file galleries",
// "Wiki pages RSS Description" => "Wiki pages RSS Description",
// "Description to be published as part of the RSS feed for wiki pages" => "Description to be published as part of the RSS feed for wiki pages",
// "Forums RSS Description" => "Forums RSS Description",
// "Description to be published as part of the RSS feed for forums" => "Description to be published as part of the RSS feed for forums",
// "Individual forums RSS Description" => "Individual forums RSS Description",
// "Description to be published as part of the RSS feed for individual forums" => "Description to be published as part of the RSS feed for individual forums",
// "Trackers RSS Description" => "Trackers RSS Description",
// "Description to be published as part of the RSS feed for trackers" => "Description to be published as part of the RSS feed for trackers",
// "Individual trackers RSS Description" => "Individual trackers RSS Description",
// "Description to be published as part of the RSS feed for individual trackers" => "Description to be published as part of the RSS feed for individual trackers",
// "Calendar events RSS Description" => "Calendar events RSS Description",
// "Description to be published as part of the RSS feed for calendar events" => "Description to be published as part of the RSS feed for calendar events",
// "Directories RSS Description" => "Directories RSS Description",
// "Description to be published as part of the RSS feed for directories" => "Description to be published as part of the RSS feed for directories",
// "Maps RSS Description" => "Maps RSS Description",
// "Description to be published as part of the RSS feed for maps" => "Description to be published as part of the RSS feed for maps",
// "Shoutbox RSS Description" => "Shoutbox RSS Description",
// "Description to be published as part of the RSS feed for shoutbox messages" => "Description to be published as part of the RSS feed for shoutbox messages",
// "The server must be able to read the directory" => "The server must be able to read the directory",
// "Must match" => "Must match",
// "Cannot match" => "Cannot match",
// "Quota for all the files and archives" => "Quota for all the files and archives",
// "(0 for unlimited)" => "(0 for unlimited)",
// "Quota can be defined for each file gallery" => "Quota can be defined for each file gallery",
// "Default quota for each new gallery" => "Default quota for each new gallery",
// "Show quota bar in the list page" => "Show quota bar in the list page",
// "Storage" => "Storage",
// "Include the search box on the current gallery files just after the find div" => "Include the search box on the current gallery files just after the find div",
// "Include a search box on file galleries" => "Include a search box on file galleries",
// "Automatic deletion of old files" => "Automatic deletion of old files",
// "The user will have an option when uploading a file to specify the time after which the file is deleted" => "The user will have an option when uploading a file to specify the time after which the file is deleted",
// "Deletion emails notification" => "Deletion emails notification",
// "These emails will receive a copy of each deleted file. Emails are separated with comma" => "These emails will receive a copy of each deleted file. Emails are separated with comma",
// "Keep fileId for archives" => "Keep fileId for archives",
// "Keep always the same fileId when replacing a file with archive" => "Keep always the same fileId when replacing a file with archive",
// "Show thumbnail actions" => "Show thumbnail actions",
// "Show the checkbox and wrench icon for file actions menu when not displaying details" => "Show the checkbox and wrench icon for file actions menu when not displaying details",
// "Max thumbnail size" => "Max thumbnail size",
// "Maximum width or height for image thumbnails" => "Maximum width or height for image thumbnails",
// "In pixels" => "In pixels",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "Display thread configuration bar only when number of posts exceed" => "Display thread configuration bar only when number of posts exceed",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Description length" => "Description length",
// "Hide titles for forum threads" => "Hide titles for forum threads",
// "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display" => "Most titles are left untouched because they are a direct reply to the parent thread. This feature hides the title altogether from the forms and display",
// "Do not prefix messages titles by 'Re: '" => "Do not prefix messages titles by 'Re: '",
// "Multilingual tags" => "Multilingual tags",
// "Permits translation management of tags" => "Permits translation management of tags",
// "Show tag cloud" => "Show tag cloud",
// "Maximum number of tags in cloud" => "Maximum number of tags in cloud",
// "Show freetags in middle column" => "Show freetags in middle column",
// "Preload freetag random tag" => "Preload freetag random tag",
// "Number of Tags to show in Tag Suggestions" => "Number of Tags to show in Tag Suggestions",
// "Valid characters pattern" => "Valid characters pattern",
// "Lowercase tags only" => "Lowercase tags only",
// "Enable freetags 3D browser" => "Enable freetags 3D browser",
// "3D autoload" => "3D autoload",
// "Browser width" => "Browser width",
// "Browser height" => "Browser height",
// "Navigation depth" => "Navigation depth",
// "Node size" => "Node size",
// "Text size" => "Text size",
// "Spring (connection) size" => "Spring (connection) size",
// "Existing page node color" => "Existing page node color",
// "Missing page node color" => "Missing page node color",
// "Camera distance adjusted relative to nearest node" => "Camera distance adjusted relative to nearest node",
// "Camera distance" => "Camera distance",
// "Field of view" => "Field of view",
// "Feed animation interval (milisecs)" => "Feed animation interval (milisecs)",
// "Friction constant" => "Friction constant",
// "Elastic constant" => "Elastic constant",
// "Eletrostatic constant" => "Eletrostatic constant",
// "Node mass" => "Node mass",
// "Node charge" => "Node charge",
// "Include \"Generate Password\" option on registration form" => "Include \"Generate Password\" option on registration form",
// "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes" => "Style of the site, sometimes called a skin or CSS. See http://themes.tiki.org for more Tiki themes",
// "Label visible in the browser\\'s title bar on all pages. Also appears in search engines" => "Label visible in the browser\\'s title bar on all pages. Also appears in search engines",
// "Validate new user registrations by email" => "Validate new user registrations by email",
// "Upon registration, the new user will receive an email containing a link to confirm validity" => "Upon registration, the new user will receive an email containing a link to confirm validity",
// "Landing page used for the wiki when no page is specified. The page will be created if it does not exist" => "Landing page used for the wiki when no page is specified. The page will be created if it does not exist",
// "Users can be sent to different pages upon login, depending on their default group" => "Users can be sent to different pages upon login, depending on their default group",
// "Site language used when no other language is specified by the user" => "Site language used when no other language is specified by the user",
// "Cache external pages" => "Cache external pages",
// "Cache external images" => "Cache external images",
// "Tiki requires full read and write access to this directory" => "Tiki requires full read and write access to this directory",
// "Help URL" => "Help URL",
// "The default help system may not be complete. You can help with the Tiki documentation" => "The default help system may not be complete. You can help with the Tiki documentation",
// "Full path to gdaltindex" => "Full path to gdaltindex",
// "Full path to ogr2ogr" => "Full path to ogr2ogr",
// "Map Zone" => "Map Zone",
// "[-180 180]" => "[-180 180]",
// "[0 360]" => "[0 360]",
// "Hide anonymous-only modules from registered users" => "Hide anonymous-only modules from registered users",
// "Hide anonymous-only modules from Admins" => "Hide anonymous-only modules from Admins",
// "Maximum number of articles on articles home page" => "Maximum number of articles on articles home page",
// "Site Ads and Banners Content" => "Site Ads and Banners Content",
// "URL to go to when clicking on a username" => "URL to go to when clicking on a username",
// "Use %user% for login name and %userId% for userId)" => "Use %user% for login name and %userId% for userId)",
// "Remind/forgot password" => "Remind/forgot password",
// "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user" => "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user",
// "If passwords <em>are stored</em> as plain text, the password will be emailed to the user" => "If passwords <em>are stored</em> as plain text, the password will be emailed to the user",
// "Each group can have its theme" => "Each group can have its theme",
// "Custom Site Header Content" => "Custom Site Header Content",
// "Site title" => "Site title",
// "Subtitle" => "Subtitle",
// "Maximum number of versions" => "Maximum number of versions",
// "0 for unlimited versions" => "0 for unlimited versions",
// "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "Require validation by Admin" => "Require validation by Admin",
// "The administrator will receive an email for each new user registration, and must validate the user before the user can login" => "The administrator will receive an email for each new user registration, and must validate the user before the user can login",
// "Require passcode to register" => "Require passcode to register",
// "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only" => "Users must enter a code to register.  You must inform users of this code. Use to restrict registration to invited users only",
// "Passcode" => "Passcode",
// "Alphanumeric code requierd to complete the registration" => "Alphanumeric code requierd to complete the registration",
// "Use tracker to collect more user information" => "Use tracker to collect more user information",
// "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user" => "Display a tracker (form) for the user to complete, as part of the registration process. Use this tracker to store additional information about each user",
// "Use the \"Admin Groups\" page to select which tracker and fields to display" => "Use the \"Admin Groups\" page to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Create a new group for each user" => "Create a new group for each user",
// "Use different URL as homepage" => "Use different URL as homepage",
// "Use URL Index" => "Use URL Index",
// "Use a Tiki feature homepage or another homepage" => "Use a Tiki feature homepage or another homepage",
// "Use Tiki feature as homepage" => "Use Tiki feature as homepage",
// "Select the Tiki feature to use as the site homepage. Only enabled features are listed" => "Select the Tiki feature to use as the site homepage. Only enabled features are listed",
// "Disable JavaScript" => "Disable JavaScript",
// "Disable JavaScript for testing purpose even if the browser allows it" => "Disable JavaScript for testing purpose even if the browser allows it",
// "Partner ID" => "Partner ID",
// "Kaltura Partner ID" => "Kaltura Partner ID",
// "User secret" => "User secret",
// "Kaltura partner setting user secret" => "Kaltura partner setting user secret",
// "Admin secret" => "Admin secret",
// "Kaltura partner setting admin secret" => "Kaltura partner setting admin secret",
// "KDP UI Configuration ID" => "KDP UI Configuration ID",
// "Kaltura Dynamic Player (KDP) user interface configuration ID" => "Kaltura Dynamic Player (KDP) user interface configuration ID",
// "KDP Widget ID" => "KDP Widget ID",
// "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account" => "Kaltura Dynamic Player (KDP) Widget ID. This configuration is specific to your account",
// "KCW UI Configuration ID" => "KCW UI Configuration ID",
// "Kaltura Configuration Wizard (KCW) user interface configuration ID" => "Kaltura Configuration Wizard (KCW) user interface configuration ID",
// "Kaltura Simple Editor UI Configuration ID" => "Kaltura Simple Editor UI Configuration ID",
// "Kaltura Advanced Editor UI Configuration ID" => "Kaltura Advanced Editor UI Configuration ID",
// "Kaltura \"User\"" => "Kaltura \"User\"",
// "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries" => "Owner of content shared by all Tiki users on this site. If empty then each Tiki user can only see their own media entries",
// "Kaltura Service URL" => "Kaltura Service URL",
// "e.g. http://www.kaltura.com/" => "e.g. http://www.kaltura.com/",
// "Set blogs homepage first" => "Set blogs homepage first",
// "Set Image gal homepage first" => "Set Image gal homepage first",
// "Set Forum homepage first" => "Set Forum homepage first",
// "Validate user's email server" => "Validate user's email server",
// "The group will be named identical to the user's username" => "The group will be named identical to the user's username",
// "User's choice" => "User's choice",
// "If you don't know better, use '_yourPartnerID'" => "If you don't know better, use '_yourPartnerID'",
// "You could use your server name for this. e.g. \$url_host" => "You could use your server name for this. e.g. \$url_host",
// "Google Maps API Key" => "Google Maps API Key",
// "Default x for map center" => "Default x for map center",
// "Default y for map center" => "Default y for map center",
// "Default zoom level" => "Default zoom level",
// "whole earth" => "whole earth",
// "country size" => "country size",
// "city size" => "city size",
// "village size" => "village size",
// "max zoom" => "max zoom",
// "Show map mode buttons in articles list" => "Show map mode buttons in articles list",
// "Show map mode buttons in page list" => "Show map mode buttons in page list",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
// "Custom CSS" => "Custom CSS",
// "Includes a custom block of CSS inline in all pages" => "Includes a custom block of CSS inline in all pages",
// "Custom JavaScript" => "Custom JavaScript",
// "Includes a custom block of inline JavaScript in all pages" => "Includes a custom block of inline JavaScript in all pages",
// "Highlight group" => "Highlight group",
// "Home File Gallery (main file gallery)" => "Home File Gallery (main file gallery)",
// "No image gallery available (create one first)" => "No image gallery available (create one first)",
// "No file gallery available (create one first)" => "No file gallery available (create one first)",
// "No forum available (create one first)" => "No forum available (create one first)",
// "No blog available (create one first)" => "No blog available (create one first)",
// "Use HTTPS when building user-specific links" => "Use HTTPS when building user-specific links",
// "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
// "Use HTTPS login" => "Use HTTPS login",
// "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server" => "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server",
// "CSS selectors to be fixed" => "CSS selectors to be fixed",
// "Separate multiple elements with a comma (,)" => "Separate multiple elements with a comma (,)",
// "HTMLDomElements to be fixed" => "HTMLDomElements to be fixed",
// "Use CDN for JavaScript" => "Use CDN for JavaScript",
// "Obtain jQuery and jQuery UI libraries through a content delivery network" => "Obtain jQuery and jQuery UI libraries through a content delivery network",
// "Google" => "Google",
// "Slide" => "Slide",
// "Fade" => "Fade",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Effect for modules" => "Effect for modules",
// "Effect for tabs" => "Effect for tabs",
// "Speed" => "Speed",
// "Fast" => "Fast",
// "Slow" => "Slow",
// "Direction" => "Direction",
// "Vertical" => "Vertical",
// "Horizontal" => "Horizontal",
// "Left" => "Left",
// "Right" => "Right",
// "Never delete versions younger than" => "Never delete versions younger than",
// "Use the database to store the translated strings and allow using interactive translation" => "Use the database to store the translated strings and allow using interactive translation",
// "Language inclusion threshold" => "Language inclusion threshold",
// "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages",
// "Create user if not in LDAP" => "Create user if not in LDAP",
// "Maximum average server load threshold in the last minute" => "Maximum average server load threshold in the last minute",
// "Log mail in Tiki logs" => "Log mail in Tiki logs",
// "Smarty Template usage indicator" => "Smarty Template usage indicator",
// "Add HTML comment at start and end of each Smarty template (TPL)" => "Add HTML comment at start and end of each Smarty template (TPL)",
// "Use only for development, not in production because these warnings are added to emails as well, and visible to the users" => "Use only for development, not in production because these warnings are added to emails as well, and visible to the users",
// "You need to clear your Tiki template cache for this change to take effect" => "You need to clear your Tiki template cache for this change to take effect",
// "Log SQL queries" => "Log SQL queries",
// "Log queries using more than (seconds)" => "Log queries using more than (seconds)",
// "This may impact performance" => "This may impact performance",
// "Use email as username" => "Use email as username",
// "Instead of creating new usernames, use the user\\'s email address for authentication" => "Instead of creating new usernames, use the user\\'s email address for authentication",
// "Obscure email when using email as username if possible (coverage will not be complete)" => "Obscure email when using email as username if possible (coverage will not be complete)",
// "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead" => "This will attempt as much as possible to hide the email, showing the realname or the truncated email instead",
// "%A %d of %B, %Y" => "%A %d of %B, %Y",
// "%A %d of %B, %Y %H:%M:%S %Z" => "%A %d of %B, %Y %H:%M:%S %Z",
// "Force lowercase" => "Force lowercase",
// "Mail end of line" => "Mail end of line",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
// "full path to mapfiles" => "full path to mapfiles",
// "Wiki Page for Help" => "Wiki Page for Help",
// "Wiki Page for Comments" => "Wiki Page for Comments",
// "Maximum length" => "Maximum length",
// "Memcache" => "Memcache",
// "Enable connection to memcached servers to store temporary information" => "Enable connection to memcached servers to store temporary information",
// "Requires the PHP memcache extension" => "Requires the PHP memcache extension",
// "Memcache compression" => "Memcache compression",
// "Enable compression for memcache storage" => "Enable compression for memcache storage",
// "Memcache servers" => "Memcache servers",
// "Server list which may be accessed. For each server, the address, port and weight must be specified" => "Server list which may be accessed. For each server, the address, port and weight must be specified",
// "One per line. address:port (weight)" => "One per line. address:port (weight)",
// "Memcache key prefix" => "Memcache key prefix",
// "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts" => "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts",
// "Memcache expiration" => "Memcache expiration",
// "Duration for which the data will be kept" => "Duration for which the data will be kept",
// "Cache wiki data in memcache" => "Cache wiki data in memcache",
// "Cache wiki output in memcache" => "Cache wiki output in memcache",
// "Cache forum output in memcache" => "Cache forum output in memcache",
// "Menu icons" => "Menu icons",
// "Allows to define icons for menu entries" => "Allows to define icons for menu entries",
// "Default path for the icons" => "Default path for the icons",
// "Allow HTML in link text and do not escape the url in menu items (Please note: this might be insecure if you allow more people to edit menus)" => "Allow HTML in link text and do not escape the url in menu items (Please note: this might be insecure if you allow more people to edit menus)",
// "If enabled, menu item names treated as HTML item content and they are not escaped (do not replace HTML special characters), this allows the use of HTML in menu items to insert images for example, and menu item urls are not escaped which allows the use of permissable href tags. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing" => "If enabled, menu item names treated as HTML item content and they are not escaped (do not replace HTML special characters), this allows the use of HTML in menu items to insert images for example, and menu item urls are not escaped which allows the use of permissable href tags. Code must be valid. This allows menu item editors to put arbitrary HTML; only enable if you know what you are doing",
// "Maximum mailbox size (messages, 0=unlimited)" => "Maximum mailbox size (messages, 0=unlimited)",
// "Maximum mail archive size (messages, 0=unlimited)" => "Maximum mail archive size (messages, 0=unlimited)",
// "Maximum sent box size (messages, 0=unlimited)" => "Maximum sent box size (messages, 0=unlimited)",
// "Keywords" => "Keywords",
// "Include freetags" => "Include freetags",
// "Use thread title instead" => "Use thread title instead",
// "Use image title instead" => "Use image title instead",
// "Use individual page description for Wiki pages instead" => "Use individual page description for Wiki pages instead",
// "geo.position" => "geo.position",
// "geo.region" => "geo.region",
// "geo.placename" => "geo.placename",
// "Meta robots" => "Meta robots",
// "Revisit after" => "Revisit after",
// "Show past metrics results" => "Show past metrics results",
// "In the metrics dashboard, identify if the previously collected metrics should be displayed" => "In the metrics dashboard, identify if the previously collected metrics should be displayed",
// "Past metrics count" => "Past metrics count",
// "Amount of past results to display" => "Amount of past results to display",
// "No metric trend value" => "No metric trend value",
// "Value to display when no trend is available for the metric" => "Value to display when no trend is available for the metric",
// "Metric trend prefix" => "Metric trend prefix",
// "Portion of text to display before the metric trend value" => "Portion of text to display before the metric trend value",
// "Metric trend suffix" => "Metric trend suffix",
// "Portion of text to display after the metric trend value" => "Portion of text to display after the metric trend value",
// "Metric name length" => "Metric name length",
// "Metric tab name length" => "Metric tab name length",
// "Cache metrics output" => "Cache metrics output",
// "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended" => "Most metrics are expensive to generate. Because they tend to evolve slowly, some delay between update and generation can be tolerated. Disabling cache is not recommended",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
// "Minimum length" => "Minimum length",
// "\"More Like This\" algorithm" => "\"More Like This\" algorithm",
// "Basic" => "Basic",
// "Weighted" => "Weighted",
// "Minimum amount of tags in common" => "Minimum amount of tags in common",
// "7" => "7",
// "8" => "8",
// "9" => "9",
// "10" => "10",
// "Multi-domain" => "Multi-domain",
// "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance" => "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance",
// "Multi-domain Configuration" => "Multi-domain Configuration",
// "Comma-separated values mapping the domain name to the perspective ID" => "Comma-separated values mapping the domain name to the perspective ID",
// "One domain per line. Comma separated with perspective ID. Ex.: tiki.org,1" => "One domain per line. Comma separated with perspective ID. Ex.: tiki.org,1",
// "Use relative (next / previous) pagination links" => "Use relative (next / previous) pagination links",
// "Wiki buttons" => "Wiki buttons",
// "Page description, icons, backlinks, .." => "Page description, icons, backlinks, ..",
// "Top " => "Top ",
// "Bottom" => "Bottom",
// "Neither" => "Neither",
// "A page can occur multiple times in a structure" => "A page can occur multiple times in a structure",
// "Display fast move links (by 10 percent of the total number of pages) " => "Display fast move links (by 10 percent of the total number of pages) ",
// "Hide pagination when there is only one page" => "Hide pagination when there is only one page",
// "Use Icons" => "Use Icons",
// "Display 'First' and 'Last' links" => "Display 'First' and 'Last' links",
// "PAM service" => "PAM service",
// "Currently unused" => "Currently unused",
// "Require characters and numerals" => "Require characters and numerals",
// "For improved security, require users to include a mix of characters and numerals in passwords" => "For improved security, require users to include a mix of characters and numerals in passwords",
// "Password expires after" => "Password expires after",
// "Payment" => "Payment",
// "Feature to manage and track payment requests" => "Feature to manage and track payment requests",
// "Payment System" => "Payment System",
// "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits",
// "PayPal: see PayPal.com - Cclite: Community currency" => "PayPal: see PayPal.com - Cclite: Community currency",
// "PayPal" => "PayPal",
// "Cclite" => "Cclite",
// "Paypal Business ID" => "Paypal Business ID",
// "Enable payments through paypal" => "Enable payments through paypal",
// "Paypal Environment" => "Paypal Environment",
// "Used to switch between the paypal sandbox, used for testing and development and the live environment" => "Used to switch between the paypal sandbox, used for testing and development and the live environment",
// "Production" => "Production",
// "Paypal Instant Payment Notification (IPN)" => "Paypal Instant Payment Notification (IPN)",
// "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server" => "Enable IPN for automatic payment completion. When enabled, Paypal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the server is not on a public server",
// "Currency" => "Currency",
// "Currency used when entering payments" => "Currency used when entering payments",
// "Default acceptable payment delay" => "Default acceptable payment delay",
// "Amount of days before the payment requests becomes overdue. This can be changed per payment request" => "Amount of days before the payment requests becomes overdue. This can be changed per payment request",
// "Cclite Registries" => "Cclite Registries",
// "Registries in Cclite. Use comma to separate. e.g. \"dogtown, chelsea, dalston, etc\"" => "Registries in Cclite. Use comma to separate. e.g. \"dogtown, chelsea, dalston, etc\"",
// "Registry names in Cclite" => "Registry names in Cclite",
// "Cclite Registry Currencies" => "Cclite Registry Currencies",
// "Currencies in Cclite. Use comma to separate. e.g. \"woof, ducket, ducket, etc\"" => "Currencies in Cclite. Use comma to separate. e.g. \"woof, ducket, ducket, etc\"",
// "Each registry in Cclite can have it\\'s own currency. Must be one per registry. (case sensitive)" => "Each registry in Cclite can have it\\'s own currency. Must be one per registry. (case sensitive)",
// "Cclite Server URL" => "Cclite Server URL",
// "Full URL of the repository" => "Full URL of the repository",
// "e.g. https://cclite.yourdomain.org/cclite/" => "e.g. https://cclite.yourdomain.org/cclite/",
// "Cclite Merchant Key" => "Cclite Merchant Key",
// "Corresponds with Merchant Key setting in Cclite" => "Corresponds with Merchant Key setting in Cclite",
// "Cclite Merchant User" => "Cclite Merchant User",
// "User name in Cclite representing \"the management\". Defaults to \"manager\"" => "User name in Cclite representing \"the management\". Defaults to \"manager\"",
// "Cclite Enable Payments" => "Cclite Enable Payments",
// "Test or Live operation" => "Test or Live operation",
// "Live" => "Live",
// "Hashing Algorithm" => "Hashing Algorithm",
// "Encryption type" => "Encryption type",
// "SHA1" => "SHA1",
// "SHA256" => "SHA256",
// "SHA512" => "SHA512",
// "Cclite Payment Notification" => "Cclite Payment Notification",
// "TODO" => "TODO",
// "Wiki page containing the instruction to send manual payment like check" => "Wiki page containing the instruction to send manual payment like check",
// "Prefix to the invoice" => "Prefix to the invoice",
// "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice" => "Prefix must be set and unique if the same paypal account is used for different tiki sites as paypal checks that the invoice is not paid twice",
// "Types of credit to use" => "Types of credit to use",
// "This is a list of the types of Tiki user credits to accept to pay with, separated by " => "This is a list of the types of Tiki user credits to accept to pay with, separated by ",
// "Exchange rate for types of credit to use" => "Exchange rate for types of credit to use",
// "This is a corresponding list of amount of credits equivalent to 1 of the payment currency, separated by " => "This is a corresponding list of amount of credits equivalent to 1 of the payment currency, separated by ",
// "Send to URL" => "Send to URL",
// "On permission denied, display login module (for Anonymous)" => "On permission denied, display login module (for Anonymous)",
// "Multiple polls per object" => "Multiple polls per object",
// "When used with the rating features, allow multiple polls to be attached to a single object" => "When used with the rating features, allow multiple polls to be attached to a single object",
// "PDF from URL" => "PDF from URL",
// "Using extenal tools, generate PDF document from web URLs" => "Using extenal tools, generate PDF document from web URLs",
// "Webkit (wkhtmltopdf)" => "Webkit (wkhtmltopdf)",
// "Webservice" => "Webservice",
// "Webservice URL" => "Webservice URL",
// "URL to a service taking a URL as the query string and returns a PDF document" => "URL to a service taking a URL as the query string and returns a PDF document",
// "Webkit path" => "Webkit path",
// "Full path to the wkhtmltopdf executable to generate the PDF document with" => "Full path to the wkhtmltopdf executable to generate the PDF document with",
// "Host name" => "Host name",
// "Proxy host - without http:// or similar, just the host name" => "Proxy host - without http:// or similar, just the host name",
// "Proxy port" => "Proxy port",
// "Quantify change size" => "Quantify change size",
// "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page" => "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page",
// "Advanced Rating" => "Advanced Rating",
// "Rating system allowing for options and calculation method to be configured" => "Rating system allowing for options and calculation method to be configured",
// "Rating recalculation mode" => "Rating recalculation mode",
// "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time" => "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large volume sites, it should be done as a cron job. On vote recalculation may be inaccurate if rating calculation depends time",
// "Recalculate on vote" => "Recalculate on vote",
// "Randomly recalculate oldest ratings (on load)" => "Randomly recalculate oldest ratings (on load)",
// "Randomly recalculate oldest ratings (on vote)" => "Randomly recalculate oldest ratings (on vote)",
// "Cron job (must be set manually)" => "Cron job (must be set manually)",
// "Recalculation odds (1 in X)" => "Recalculation odds (1 in X)",
// "Dice roll performed on every request. When successful, will recalculate a certain number of votes" => "Dice roll performed on every request. When successful, will recalculate a certain number of votes",
// "Recalculation count" => "Recalculation count",
// "How many ratings should be recalculated when odds strike" => "How many ratings should be recalculated when odds strike",
// "Use ReCaptcha" => "Use ReCaptcha",
// "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA" => "Use ReCaptcha, a specialized captcha service, instead of default CAPTCHA",
// "You will need to register at [http://www.google.com/recaptcha]" => "You will need to register at [http://www.google.com/recaptcha]",
// "Public Key" => "Public Key",
// "ReCaptcha public key" => "ReCaptcha public key",
// "Private Key" => "Private Key",
// "ReCaptcha private key" => "ReCaptcha private key",
// "Keep track of the unsuccessful attemps to translate strings" => "Keep track of the unsuccessful attemps to translate strings",
// "Restrict supported languages" => "Restrict supported languages",
// "Limit the languages made available on the site" => "Limit the languages made available on the site",
// "Refresh mode" => "Refresh mode",
// "Random" => "Random",
// "Use 0 for no refresh" => "Use 0 for no refresh",
// "Minimum length of search word" => "Minimum length of search word",
// "Max. number of words containing a syllable" => "Max. number of words containing a syllable",
// "Max. age in hours of syllable search cache" => "Max. age in hours of syllable search cache",
// "LRU list purging rate" => "LRU list purging rate",
// "LRU list length" => "LRU list length",
// "Parse the results" => "Parse the results",
// "Default where" => "Default where",
// "When object filter is not on, limit to search one type of object" => "When object filter is not on, limit to search one type of object",
// "Restrict search language by default" => "Restrict search language by default",
// "If enabled, only search content in the interface language, by default" => "If enabled, only search content in the interface language, by default",
// "Autocomplete on page names" => "Autocomplete on page names",
// "Parse wiki syntax in comments in all sections apart from Forums" => "Parse wiki syntax in comments in all sections apart from Forums",
// "Use \"Accept wiki syntax\" for forums in admin forums page" => "Use \"Accept wiki syntax\" for forums in admin forums page",
// "Email address that will be used as the sender for outgoing emails" => "Email address that will be used as the sender for outgoing emails",
// "Timezone" => "Timezone",
// "Indicates the default time zone to use for the server" => "Indicates the default time zone to use for the server",
// "Session storage location" => "Session storage location",
// "Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Select where the session information should be stored. Memcache sessions require memcache to be configured",
// "Default (from php.ini)" => "Default (from php.ini)",
// "Session lifetime" => "Session lifetime",
// "Value provided in minutes" => "Value provided in minutes",
// "Silent session" => "Silent session",
// "Do not automatically start sessions" => "Do not automatically start sessions",
// "Session cookie name" => "Session cookie name",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
// "Protect all sessions" => "Protect all sessions",
// "Always redirect to HTTPS to prevent session hijack through network sniffing" => "Always redirect to HTTPS to prevent session hijack through network sniffing",
// "Create with default group" => "Create with default group",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Shipping Service" => "Shipping Service",
// "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)",
// "FedEx API" => "FedEx API",
// "Enable shipping rate calculation through FedEx APIs" => "Enable shipping rate calculation through FedEx APIs",
// "FedEx Key" => "FedEx Key",
// "Developer Key" => "Developer Key",
// "FedEx Password" => "FedEx Password",
// "FedEx Meter Number" => "FedEx Meter Number",
// "FedEx Account Number" => "FedEx Account Number",
// "UPS API" => "UPS API",
// "Enable shipping rate calculation using the UPS carrier" => "Enable shipping rate calculation using the UPS carrier",
// "UPS Username" => "UPS Username",
// "UPS credentials" => "UPS credentials",
// "UPS Password" => "UPS Password",
// "UPS Access Key" => "UPS Access Key",
// "%Y-%m-%d" => "%Y-%m-%d",
// "%H:%M" => "%H:%M",
// "%Y-%m-%d %H:%M" => "%Y-%m-%d %H:%M",
// "Display available translations" => "Display available translations",
// "Close site (except for those with permission)" => "Close site (except for those with permission)",
// "Message to display" => "Message to display",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Choices" => "Choices",
// "Site title location" => "Site title location",
// "Location of the site title in the browser title bar relative to the current page\\'s descriptor" => "Location of the site title in the browser title bar relative to the current page\\'s descriptor",
// "Browser title display mode" => "Browser title display mode",
// "When breadcrumbs are used, method in which the browser title should be displayed" => "When breadcrumbs are used, method in which the browser title should be displayed",
// "Most specific first" => "Most specific first",
// "Least specific first (site)" => "Least specific first (site)",
// "Current only" => "Current only",
// "Favicon icon file name" => "Favicon icon file name",
// "Favicon icon MIME type" => "Favicon icon MIME type",
// "image/png" => "image/png",
// "image/bmp" => "image/bmp",
// "image/x-icon" => "image/x-icon",
// "Logo source (image path)" => "Logo source (image path)",
// "Logo background color" => "Logo background color",
// "Examples" => "Examples",
// "Logo background style" => "Logo background style",
// "Logo alignment" => "Logo alignment",
// "Logo title (on mouse over)" => "Logo title (on mouse over)",
// "Alt. description (e.g. for text browsers)" => "Alt. description (e.g. for text browsers)",
// "Slideshow theme" => "Slideshow theme",
// "Include smarty notices in PHP error report" => "Include smarty notices in PHP error report",
// "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur" => "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur",
// "Smarty Security" => "Smarty Security",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "You should leave this on unless you know what you are doing" => "You should leave this on unless you know what you are doing",
// "Smarty Compilation" => "Smarty Compilation",
// "Indicates when the template cache should be refreshed" => "Indicates when the template cache should be refreshed",
// "Never check (performance)" => "Never check (performance)",
// "Always (development, slow)" => "Always (development, slow)",
// "Consumer key" => "Consumer key",
// "Consumer key generated by registering your site as application at twitter" => "Consumer key generated by registering your site as application at twitter",
// "Consumer secret" => "Consumer secret",
// "Consumer secret generated by registering your site as an application at twitter" => "Consumer secret generated by registering your site as an application at twitter",
// "API key" => "API key",
// "API key generated by registering your site as application at facebook" => "API key generated by registering your site as application at facebook",
// "Application secret" => "Application secret",
// "Application secret generated by registering your site as an application at facebook" => "Application secret generated by registering your site as an application at facebook",
// "Application ID" => "Application ID",
// "Application id generated by registering your site as an application at facebook" => "Application id generated by registering your site as an application at facebook",
// "bit.ly Login" => "bit.ly Login",
// "Site wide login (username) for bit.ly" => "Site wide login (username) for bit.ly",
// "bit.ly Key" => "bit.ly Key",
// "Site wide API key for bit.ly" => "Site wide API key for bit.ly",
// "Use site-wide account" => "Use site-wide account",
// "When setting this option to yes, only the site wide account will be used for all users" => "When setting this option to yes, only the site wide account will be used for all users",
// "Theme options" => "Theme options",
// "Style options" => "Style options",
// "Minify JavaScript" => "Minify JavaScript",
// "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS" => "Minify CSS",
// "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress CSS files by removing additional spaces and grouping multiple files into one. Changes to CSS files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify CSS into a single file" => "Minify CSS into a single file",
// "In addition to reducing the size of the CSS, reduce the number of included files" => "In addition to reducing the size of the CSS, reduce the number of included files",
// "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"" => "This setting may not work out of the box for all styles. import needs to use @import url(\"...\") and not @import \"...\"",
// "Skip date for same day" => "Skip date for same day",
// "When displaying short date and time, skip date for today. Only time will be displayed" => "When displaying short date and time, skip date for today. Only time will be displayed",
// "Cache-Control header" => "Cache-Control header",
// "Custom HTTP header to use when a session is active" => "Custom HTTP header to use when a session is active",
// "Example: no-cache, pre-check=0, post-check=0" => "Example: no-cache, pre-check=0, post-check=0",
// "Cache-Control header (no session)" => "Cache-Control header (no session)",
// "Custom HTTP header to use when no session is active" => "Custom HTTP header to use when no session is active",
// "Content Delivery Network" => "Content Delivery Network",
// "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance" => "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance",
// "Prefix to include before the static files, for example: http://cdn.example.com" => "Prefix to include before the static files, for example: http://cdn.example.com",
// "Content Delivery Network (in SSL)" => "Content Delivery Network (in SSL)",
// "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode" => "Use an alternate domain name to serve static files from tikiwiki to avoid sending cookies, improve local caching and generally improve user experience performance. Leave empty to disable CDN in SSL mode",
// "Prefix to include before the static files, for example: https://cdn.example.com" => "Prefix to include before the static files, for example: https://cdn.example.com",
// "Domain prefix handling" => "Domain prefix handling",
// "Strip or automatically add the www. prefix on domain names to unify URLs" => "Strip or automatically add the www. prefix on domain names to unify URLs",
// "Leave as-is" => "Leave as-is",
// "Remove the www" => "Remove the www",
// "Add the www" => "Add the www",
// "Domain redirects" => "Domain redirects",
// "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org" => "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org",
// "One entry per line. Comma separated list: old, new" => "One entry per line. Comma separated list: old, new",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "URL a user is redirected to after account validation" => "URL a user is redirected to after account validation",
// "URL an anonymous is redirected when page not found" => "URL an anonymous is redirected when page not found",
// "Close site when server load is above the threshold  (except for those with permission)" => "Close site when server load is above the threshold  (except for those with permission)",
// "Use proxy" => "Use proxy",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Show user\\'s real name instead of login (when possible)" => "Show user\\'s real name instead of login (when possible)",
// "Display UserTracker information on the user information page" => "Display UserTracker information on the user information page",
// "Use the format: trackerId, fieldId1, fieldId2, .." => "Use the format: trackerId, fieldId1, fieldId2, ..",
// "Users can shade modules" => "Users can shade modules",
// "Allows users to hide/show modules" => "Allows users to hide/show modules",
// "Module decides" => "Module decides",
// "Store full-size copy of avatar in file gallery" => "Store full-size copy of avatar in file gallery",
// "File gallery to store full-size copy of avatar in" => "File gallery to store full-size copy of avatar in",
// "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "Enter the gallery id here. Please create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit",
// "Display who viewed my stuff on the user information page" => "Display who viewed my stuff on the user information page",
// "You will need to activate tracking of views for various items in the action log for this to work" => "You will need to activate tracking of views for various items in the action log for this to work",
// "Number of days to consider who viewed my stuff" => "Number of days to consider who viewed my stuff",
// "Number of days before current time to consider when showing who viewed my stuff" => "Number of days before current time to consider when showing who viewed my stuff",
// "Show to others who viewed my stuff on the user information page" => "Show to others who viewed my stuff on the user information page",
// "Show to others who viewed my stuff on the user information page. Admins can always see this information" => "Show to others who viewed my stuff on the user information page. Admins can always see this information",
// "Sort Order" => "Sort Order",
// "Maximum number of users to show in drop down lists" => "Maximum number of users to show in drop down lists",
// "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box" => "Prevents out of memory and performance issues when user list is very large by using a jQuery autocomplete text input box",
// "Use pretty trackers for registration form" => "Use pretty trackers for registration form",
// "Registration pretty tracker template" => "Registration pretty tracker template",
// "Use wiki page name or template file with .tpl extension" => "Use wiki page name or template file with .tpl extension",
// "User tracker IDs to sync prefs from" => "User tracker IDs to sync prefs from",
// "Enter the IDs separated by commas of trackers to sync user prefs from" => "Enter the IDs separated by commas of trackers to sync user prefs from",
// "Tracker field IDs to sync Real Name pref from" => "Tracker field IDs to sync Real Name pref from",
// "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4" => "Enter the IDs separated by commas in priority of being chosen, each item can concatenate multiple fields using +, e.g. 2+3,4",
// "Synchronize long/lat/zoom to google maps field" => "Synchronize long/lat/zoom to google maps field",
// "Synchronize user geolocation prefs to main google maps field" => "Synchronize user geolocation prefs to main google maps field",
// "Synchronize categories of user tracker item to user groups" => "Synchronize categories of user tracker item to user groups",
// "Will add the user tracker item to the category of the same name as the user groups and vice versa" => "Will add the user tracker item to the category of the same name as the user groups and vice versa",
// "Put user in group only if categorized within" => "Put user in group only if categorized within",
// "Show user\\'s real name instead of login in autocomplete selector in trackers feature" => "Show user\\'s real name instead of login in autocomplete selector in trackers feature",
// "Use user\\'s real name instead of login in autocomplete selector in trackers feature" => "Use user\\'s real name instead of login in autocomplete selector in trackers feature",
// "Show user\\'s real name instead of login in autocomplete selector in messaging feature" => "Show user\\'s real name instead of login in autocomplete selector in messaging feature",
// "Use user\\'s real name instead of login in autocomplete selector in messaging feature" => "Use user\\'s real name instead of login in autocomplete selector in messaging feature",
// "Username pattern" => "Username pattern",
// "Serve avatar images statically" => "Serve avatar images statically",
// "When enabled, feature checks and permission checks will be skipped" => "When enabled, feature checks and permission checks will be skipped",
// "Use site default to show times" => "Use site default to show times",
// "Detect user timezone (if browser allows). Otherwise use site default" => "Detect user timezone (if browser allows). Otherwise use site default",
// "Use new diff any version interface" => "Use new diff any version interface",
// "20" => "20",
// "30" => "30",
// "40" => "40",
// "50" => "50",
// "Auto-archive read messages after" => "Auto-archive read messages after",
// "60" => "60",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
// "Display by default" => "Display by default",
// "Path (if stored in directory)" => "Path (if stored in directory)",
// "Edit idle timeout" => "Edit idle timeout",
// "15" => "15",
// "Log errors to Tiki log" => "Log errors to Tiki log",
// "Errors will be logged to the Tiki log" => "Errors will be logged to the Tiki log",
// "Tracker ID of Channel tracker" => "Tracker ID of Channel tracker",
// "There must be a tracker to store info of each channel you create" => "There must be a tracker to store info of each channel you create",
// "Field ID of BrandId" => "Field ID of BrandId",
// "The Channel tracker must have a text field for the Watershed BrandId" => "The Channel tracker must have a text field for the Watershed BrandId",
// "Field ID of ChannelCode" => "Field ID of ChannelCode",
// "The Channel tracker must have a text field for the Watershed ChannelCode" => "The Channel tracker must have a text field for the Watershed ChannelCode",
// "Tracker ID of Archive tracker" => "Tracker ID of Archive tracker",
// "There must be a tracker to store Archive info" => "There must be a tracker to store Archive info",
// "Field ID of videoId" => "Field ID of videoId",
// "The Archive tracker must have a text field for the videoId of each archive" => "The Archive tracker must have a text field for the videoId of each archive",
// "Field ID of BrandId for Archive" => "Field ID of BrandId for Archive",
// "The Archive tracker must have a text field for the BrandId of each archive" => "The Archive tracker must have a text field for the BrandId of each archive",
// "Field ID of ChannelCode for Archive" => "Field ID of ChannelCode for Archive",
// "The Archive tracker must have a text field for the ChannelCode of each archive" => "The Archive tracker must have a text field for the ChannelCode of each archive",
// "Field ID of rtmpURL for Archive (url field type)" => "Field ID of rtmpURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the RTMP URL to access the archive" => "The Archive tracker must have a url field for storing the RTMP URL to access the archive",
// "Field ID of flvURL for Archive (url field type)" => "Field ID of flvURL for Archive (url field type)",
// "The Archive tracker must have a url field for storing the FLV URL to access the archive" => "The Archive tracker must have a url field for storing the FLV URL to access the archive",
// "Field ID of Date string for Archive" => "Field ID of Date string for Archive",
// "The Archive tracker can have a text field for storing the time the recording completed" => "The Archive tracker can have a text field for storing the time the recording completed",
// "Field ID of Duration for Archive" => "Field ID of Duration for Archive",
// "The Archive tracker can have a text field for storing the duration of the recording" => "The Archive tracker can have a text field for storing the duration of the recording",
// "Field ID of Filesize for Archive" => "Field ID of Filesize for Archive",
// "The Archive tracker can have a text field for storing the filesize of the recording" => "The Archive tracker can have a text field for storing the filesize of the recording",
// "Field ID of Title for Archive" => "Field ID of Title for Archive",
// "The Archive tracker could have a text field for storing the title of the recording" => "The Archive tracker could have a text field for storing the title of the recording",
// "Field ID of Description for Archive (textarea field type)" => "Field ID of Description for Archive (textarea field type)",
// "The Archive tracker could have a textarea field for storing the description of the recording" => "The Archive tracker could have a textarea field for storing the description of the recording",
// "Field ID of Tags for Archive (freetags field type)" => "Field ID of Tags for Archive (freetags field type)",
// "The Archive tracker could have a freetags field for storing the tags of the recording" => "The Archive tracker could have a freetags field for storing the tags of the recording",
// "Flash Media Encoder shared secret" => "Flash Media Encoder shared secret",
// "Shared key for authenticating Flash Media Encoder" => "Shared key for authenticating Flash Media Encoder",
// "Maximum size for each attachment" => "Maximum size for each attachment",
// "500Kb" => "500Kb",
// "1Mb" => "1Mb",
// "1.5Mb" => "1.5Mb",
// "2Mb" => "2Mb",
// "2.5Mb" => "2.5Mb",
// "3Mb" => "3Mb",
// "Include a flag by each e-mail to quickly flag/un-flag them" => "Include a flag by each e-mail to quickly flag/un-flag them",
// "Wiki link format" => "Wiki link format",
// "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))" => "What level of special characters are accepted as wiki links for page names. Ex.: ((Page &eacute;&agrave;&icirc;))",
// "Strict will only be basic characters like a-z and 0-9. If you have accented or special characters in page names, you should not use strict" => "Strict will only be basic characters like a-z and 0-9. If you have accented or special characters in page names, you should not use strict",
// "Relaxed" => "Relaxed",
// "Strict" => "Strict",
// "Display page version" => "Display page version",
// "Display the page version information when viewing the page" => "Display the page version information when viewing the page",
// "Display page name above page" => "Display page name above page",
// "Display page name above page instead of inside page" => "Display page name above page instead of inside page",
// "Page name display stripper" => "Page name display stripper",
// "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed" => "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed",
// "Wiki author list style" => "Wiki author list style",
// "Changes the list format used to display the authors of the page" => "Changes the list format used to display the authors of the page",
// "Creator & Author" => "Creator & Author",
// "none (disabled)" => "none (disabled)",
// "Specify wiki author list style per page" => "Specify wiki author list style per page",
// "Allows to modify the style in which the author list is displayed on a per-page basis" => "Allows to modify the style in which the author list is displayed on a per-page basis",
// "Wiki action bar location" => "Wiki action bar location",
// "Buttons: Save, Preview, Cancel, .." => "Buttons: Save, Preview, Cancel, ..",
// "Wiki navigation bar location" => "Wiki navigation bar location",
// "Wiki top line location" => "Wiki top line location",
// "Cache wiki pages (global)" => "Cache wiki pages (global)",
// "Enable page cache globally for wiki pages" => "Enable page cache globally for wiki pages",
// "Allow comments per wiki page" => "Allow comments per wiki page",
// "Enable control for comments on wiki pages individually" => "Enable control for comments on wiki pages individually",
// "Enable (default On)" => "Enable (default On)",
// "Enable (default Off)" => "Enable (default Off)",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "Permits editing of a plugin, via a popup form, without needing to edit the whole page" => "Permits editing of a plugin, via a popup form, without needing to edit the whole page",
// "Requires JavaScript" => "Requires JavaScript",
// "Prevent special characters in page names" => "Prevent special characters in page names",
// "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters" => "Some characters may prevent the pages from being easily accessible from the URL or through wiki links. This option prevents from creating pages with such characters",
// "Page ranking reload probability" => "Page ranking reload probability",
// "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking" => "Calculation of page rankings is an expensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the amount of faces on the dice. Larger numbers lead to less load, but less accurate ranking",
// "Encourage contribution to wiki pages by anonymous" => "Encourage contribution to wiki pages by anonymous",
// "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register" => "When a page is not editable and the user is anonymous, display the edit links anyway. The visitor will be prompted with a login screen and be encouraged to register",
// "Warn before page lock timeout" => "Warn before page lock timeout",
// "Provide a JavaScript alert before the user\\'s lock on a page times out" => "Provide a JavaScript alert before the user\\'s lock on a page times out",
// "Global snippets of text that can be included in wiki pages and edited in place" => "Global snippets of text that can be included in wiki pages and edited in place",
// "Single (%varname%)" => "Single (%varname%)",
// "Double (%%varname%%)" => "Double (%%varname%%)",
// "Multilingual dynamic variables" => "Multilingual dynamic variables",
// "Make dynamic variable content language specific" => "Make dynamic variable content language specific",
// "Edit section" => "Edit section",
// "Edit section level" => "Edit section level",
// "Toggle display of section and plugin edit icons" => "Toggle display of section and plugin edit icons",
// "Allow minor edits" => "Allow minor edits",
// "Slideshows" => "Slideshows",
// "Create watch for author on page creation" => "Create watch for author on page creation",
// "Enable watches on comments" => "Enable watches on comments",
// "Enable watch events when I am the editor" => "Enable watch events when I am the editor",
// "Watch minor edits" => "Watch minor edits",
// "Name length" => "Name length",
// "Edit comments" => "Edit comments",
// "Edit Comment length" => "Edit Comment length",
// "Categories path" => "Categories path",
// "Sort Direction" => "Sort Direction",
// "Enable wiki 3D browser" => "Enable wiki 3D browser",
// "Load page on navigation" => "Load page on navigation",
// "Forum for discussion" => "Forum for discussion",
// "Allow to manage keywords on a per-page basis" => "Allow to manage keywords on a per-page basis",
// "Similar pages only listed in same language" => "Similar pages only listed in same language",
// "When listing similar pages, such as in missing page 404, only display pages in the same language as the request" => "When listing similar pages, such as in missing page 404, only display pages in the same language as the request",
// "Mandatory edit summary on wiki pages" => "Mandatory edit summary on wiki pages",
// "Reject save attempts not providing an edit summary to describe the changes made" => "Reject save attempts not providing an edit summary to describe the changes made",
// "Structure navigation bar location" => "Structure navigation bar location",
// "Displays Next/Back buttons, breadcrumbs, and form to add a new page" => "Displays Next/Back buttons, breadcrumbs, and form to add a new page",
// "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation" => "Maximum length (characters) to display/truncate for backlink page names. Use \"0\" for no truncation",
// "Simple wiki ratings" => "Simple wiki ratings",
// "Enable users to rate articles based on a simple numeric scale" => "Enable users to rate articles based on a simple numeric scale",
// "Wiki rating options" => "Wiki rating options",
// "List of options available for the rating of wiki pages" => "List of options available for the rating of wiki pages",
// "Redirect pages using these prefix alias semantic links" => "Redirect pages using these prefix alias semantic links",
// "Comma separated list of prefixes of which pages will be redirected to page with semantic link" => "Comma separated list of prefixes of which pages will be redirected to page with semantic link",
// "Force bounce of editing of approved pages to staging" => "Force bounce of editing of approved pages to staging",
// "Delete staging pages at approval" => "Delete staging pages at approval",
// "Unique page name prefix to indicate staging copy" => "Unique page name prefix to indicate staging copy",
// "Hide page name prefix" => "Hide page name prefix",
// "Categorize approved pages with categories of staging copy on approval" => "Categorize approved pages with categories of staging copy on approval",
// "Replace freetags with that of staging pages, on approval" => "Replace freetags with that of staging pages, on approval",
// "Add new freetags of approved copy (into tags field) when editing staging pages" => "Add new freetags of approved copy (into tags field) when editing staging pages",
// "Staging" => "Staging",
// "Approved" => "Approved",
// "(mandatory for feature to work)" => "(mandatory for feature to work)",
// "Out-of-sync" => "Out-of-sync",
// "If not in the group, edit is always redirected to the staging page edit" => "If not in the group, edit is always redirected to the staging page edit",
// "Plugin %0" => "Plugin %0",
// "Global cache time for the plugin snarf in seconds" => "Global cache time for the plugin snarf in seconds",
// "Default cache time for the plugin snarf" => "Default cache time for the plugin snarf",
// "0 for no cache" => "0 for no cache",
// "Inline plugin %0" => "Inline plugin %0",
// "Wysiwyg Editor is optional" => "Wysiwyg Editor is optional",
// "Wysiwyg Editor is displayed by default" => "Wysiwyg Editor is displayed by default",
// "Reopen with the same editor" => "Reopen with the same editor",
// "Content is parsed like wiki page" => "Content is parsed like wiki page",
// "This allows a mixture of wiki and html. All wiki syntax is parsed" => "This allows a mixture of wiki and html. All wiki syntax is parsed",
// "Content is partially wiki parsed" => "Content is partially wiki parsed",
// "This also allows a mixture of wiki and html. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)" => "This also allows a mixture of wiki and html. Only some wiki syntax is parsed, such as plugins (not inline character styles etc)",
// "Wysiwyg editor skin" => "Wysiwyg editor skin",
// "Kama (Default)" => "Kama (Default)",
// "Office 2003" => "Office 2003",
// "V2 (FCKEditor appearance)" => "V2 (FCKEditor appearance)",
// "Use Wiki syntax in WYSIWYG" => "Use Wiki syntax in WYSIWYG",
// "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead " => "Experimental, new : Allow to keep the wiki syntax with the WYSIWYG editor. WARNING: plugin edit is not working in that case in WYSIWYG mode, use the Source mode instead ",
// "Font names" => "Font names",
// "List of font names separated by" => "List of font names separated by",
// "SMTP Server" => "SMTP Server",
// "SSL" => "SSL",
// "TLS" => "TLS",
// "Mail Sender" => "Mail Sender",
// "Sendmail" => "Sendmail",
// "SMTP" => "SMTP",
// "Authentication" => "Authentication",
// "Mail server authentication" => "Mail server authentication",
// "LOGIN" => "LOGIN",
// "PLAIN" => "PLAIN",
// "CRAM-MD5" => "CRAM-MD5",
// "Nothing was changed, please check profile for errors" => "Nothing was changed, please check profile for errors",
// "An error occurred: " => "An error occurred: ",
// "Applying profile" => "Applying profile",
// "Added (or modified)" => "Added (or modified)",
// "Preference set" => "Preference set",
// "Group changed (or modified)" => "Group changed (or modified)",
// "Modified permission %s for %s" => "Modified permission %s for %s",
// "Modified permission %s on %s/%s for %s" => "Modified permission %s on %s/%s for %s",
// "User %0 was added to %1" => "User %0 was added to %1",
// "File gallery does not exist" => "File gallery does not exist",
// "File gallery already exists" => "File gallery already exists",
// "Calendar does not exist" => "Calendar does not exist",
// "Calendar already exists" => "Calendar already exists",
// "Syntax error: " => "Syntax error: ",
// "Circular reference" => "Circular reference",
// "No name" => "No name",
// "Bad object" => "Bad object",
// "Permissions' object must have a field 'type' and 'id'" => "Permissions' object must have a field 'type' and 'id'",
// "Needs a 'type' and 'data' field" => "Needs a 'type' and 'data' field",
// "Expecting three arguments for article-info" => "Expecting three arguments for article-info",
// "Unsupported property. Supported properties are: ' . implode( " => "Unsupported property. Supported properties are: ' . implode( ",
// "Articles feature not enabled" => "Articles feature not enabled",
// "Unexpected values: %0" => "Unexpected values: %0",
// "Invalid property" => "Invalid property",
// "Object must be provided and contain two arguments: type and object" => "Object must be provided and contain two arguments: type and object",
// "Invalid range" => "Invalid range",
// "Invalid revote period" => "Invalid revote period",
// "Expecting \"keep\" to be \"latest\" or \"oldest\"" => "Expecting \"keep\" to be \"latest\" or \"oldest\"",
// "Unknown variables referenced: %0" => "Unknown variables referenced: %0",
// "You must choose a group" => "You must choose a group",
// "Username is required" => "Username is required",
// "The passwords don't match" => "The passwords don't match",
// "Username cannot contain uppercase letters" => "Username cannot contain uppercase letters",
// "Username must be at least" => "Username must be at least",
// "Username cannot contain more than" => "Username cannot contain more than",
// "characters" => "characters",
// "This invitation does not exist or is deprecated or wrong email" => "This invitation does not exist or is deprecated or wrong email",
// "uploaded the file" => "uploaded the file",
// "changes" => "changes",
// "No changes" => "No changes",
// "Yesterday" => "Yesterday",
// "more changes of the same type.." => "more changes of the same type..",
// "changed the picture gallery" => "changed the picture gallery",
// "uploaded the picture" => "uploaded the picture",
// "onto" => "onto",
// "removed the picture" => "removed the picture",
// "edited the wikipage" => "edited the wikipage",
// "this history" => "this history",
// "all history" => "all history",
// "edited the file gallery" => "edited the file gallery",
// "removed the file" => "removed the file",
// "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category" => "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category",
// "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category" => "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category",
// "created the subcategory" => "created the subcategory",
// "removed the subcategory" => "removed the subcategory",
// "edited the category" => "edited the category",
// "removed the article" => "removed the article",
// "created the article" => "created the article",
// "edited the article" => "edited the article",
// "replied to the blog" => "replied to the blog",
// "created the topic" => "created the topic",
// "at forum" => "at forum",
// "replied" => "replied",
// "to the topic" => "to the topic",
// "Nothing has happened" => "Nothing has happened",
// "The fields title and description are mandatory to generate a feed" => "The fields title and description are mandatory to generate a feed",
// "To fix this error go to Admin -> Feeds" => "To fix this error go to Admin -> Feeds",
// "Please contact the site administrator and ask him to fix this error" => "Please contact the site administrator and ask him to fix this error",
// "If you set feed author email or url you have to set feed author name" => "If you set feed author email or url you have to set feed author name",
// "Feed logo" => "Feed logo",
// "Have your profile seen" => "Have your profile seen",
// "Create New File Gallery" => "Create New File Gallery",
// "You must choose an option" => "You must choose an option",
// "Tiki RSS feed for articles" => "Tiki RSS feed for articles",
// "Last posts to weblogs" => "Last posts to weblogs",
// "Tiki RSS feed for weblogs" => "Tiki RSS feed for weblogs",
// "Tiki RSS feed for calendars" => "Tiki RSS feed for calendars",
// "Last sites" => "Last sites",
// "Tiki RSS feed for directory sites" => "Tiki RSS feed for directory sites",
// "Last files uploaded to the file galleries" => "Last files uploaded to the file galleries",
// "Tiki RSS feed for file galleries" => "Tiki RSS feed for file galleries",
// "Last files uploaded to this file gallery. " => "Last files uploaded to this file gallery. ",
// "Tiki RSS feed for the file gallery: " => "Tiki RSS feed for the file gallery: ",
// "Last posts to this forum. " => "Last posts to this forum. ",
// "Tiki RSS feed for forum: " => "Tiki RSS feed for forum: ",
// "Last topics in forums" => "Last topics in forums",
// "Tiki RSS feed for forums" => "Tiki RSS feed for forums",
// "Last images uploaded to the image galleries" => "Last images uploaded to the image galleries",
// "Tiki RSS feed for image galleries" => "Tiki RSS feed for image galleries",
// "Last images uploaded to this image gallery. " => "Last images uploaded to this image gallery. ",
// "Tiki RSS feed for the image gallery: " => "Tiki RSS feed for the image gallery: ",
// "Last shoutbox messages" => "Last shoutbox messages",
// "Tiki RSS feed for shoutbox messages" => "Tiki RSS feed for shoutbox messages",
// "Last items published on this tracker" => "Last items published on this tracker",
// "Tiki RSS feed for individual trackers: " => "Tiki RSS feed for individual trackers: ",
// "Last modifications to the Wiki" => "Last modifications to the Wiki",
// "Tiki RSS feed for the wiki pages" => "Tiki RSS feed for the wiki pages",
// "Saved" => "Saved",
// "Save failed" => "Save failed",
// "UPS_CODE_' . \$xp->query( 'Service/Code" => "UPS_CODE_' . \$xp->query( 'Service/Code",
// "Click for Help" => "Click for Help",
// "You are not in group of friends to have the content of this block displayed for you" => "You are not in group of friends to have the content of this block displayed for you",
// "Smarty block.display.php: Missing error param" => "Smarty block.display.php: Missing error param",
// "No records to display" => "No records to display",
// "Fast Next" => "Fast Next",
// "Fast Prev" => "Fast Prev",
// "tip" => "tip",
// "warning" => "warning",
// "confirm" => "confirm",
// "note" => "note",
// "errors" => "errors",
// "Tab View" => "Tab View",
// "No Tabs" => "No Tabs",
// "This edit session will expire in" => "This edit session will expire in",
// "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer" => "<strong>Preview</strong> (if available) or <strong>Save</strong> your work to restart the edit session timer",
// "There is an autosaved version of this content, to use it instead of this saved one" => "There is an autosaved version of this content, to use it instead of this saved one",
// "If you want the saved version instead of this autosaved draft" => "If you want the saved version instead of this autosaved draft",
// "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />" => "<strong>Thank you for trying the new ckeditor implementation for Tiki 6</strong><br /><br />",
// "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this" => "Some of the settings at this site should be set differently for this to work best. Please ask the administrator to try this",
// "Ckeditor Development Notice" => "Ckeditor Development Notice",
// "Your edit session has expired" => "Your edit session has expired",
// "Your edit session will expire in" => "Your edit session will expire in",
// "You must PREVIEW or SAVE your work now, to avoid losing your edits" => "You must PREVIEW or SAVE your work now, to avoid losing your edits",
// "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page",
// "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile" => "Some of your preferences should be set differently for this to work at it's best. Please click this to apply the recommended profile",
// "Admin page" => "Admin page",
// "Plugin name not specified" => "Plugin name not specified",
// "Hour" => "Hour",
// "Minute" => "Minute",
// "Interactive Translation" => "Interactive Translation",
// "Once checked, click on any string to translate it" => "Once checked, click on any string to translate it",
// "Click here to go to Edit Languages" => "Click here to go to Edit Languages",
// "Save translations" => "Save translations",
// "Changes will be applied on next page load only" => "Changes will be applied on next page load only",
// "Month beginning" => "Month beginning",
// "Week beginning" => "Week beginning",
// "Data (change %)" => "Data (change %)",
// "No object information provided" => "No object information provided",
// "No rules to display object %1 of type %0" => "No rules to display object %1 of type %0",
// "Relation not found" => "Relation not found",
// "Currency in payment (%0) does not match the currency for that registry (%1)" => "Currency in payment (%0) does not match the currency for that registry (%1)",
// "This invoice does not exist or is in limited access" => "This invoice does not exist or is in limited access",
// "PHPLayersMenus are not enabled on this site" => "PHPLayersMenus are not enabled on this site",
// "Preference name not specified" => "Preference name not specified",
// " (found in " => " (found in ",
// "(not found in an admin panel)" => "(not found in an admin panel)",
// "Preference %0 is not defined" => "Preference %0 is not defined",
// "No object information provided for rating" => "No object information provided for rating",
// "An error occured" => "An error occured",
// "No rows found" => "No rows found",
// "Number of items in _checkboxColumnIndex doesn not match items in _checkbox" => "Number of items in _checkboxColumnIndex doesn not match items in _checkbox",
// "Number of items in _checkboxTitles doesn not match items in _checkbox" => "Number of items in _checkboxTitles doesn not match items in _checkbox",
// "Toggle sections" => "Toggle sections",
// "Show only selected" => "Show only selected",
// "You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "You might want to also set the tiki_p_modify_object_categories permission under the tiki section",
// "years" => "years",
// "weeks" => "weeks",
// "More info about %0 (idle for %1)" => "More info about %0 (idle for %1)",
// " seconds" => " seconds",
// "Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission denied: the specified wiki page cannot be used as Smarty template resource",
// "Days with the most pageviews" => "Days with the most pageviews",
// "Day with the most pageviews" => "Day with the most pageviews",
// "Days with the least pageviews" => "Days with the least pageviews",
// "Day with the least pageviews" => "Day with the least pageviews",
// "No pageviews yet" => "No pageviews yet",
// "n/a" => "n/a",
// "Unknown conversion" => "Unknown conversion",
// "Face" => "Face",
// "Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator" => "Required features: <b>%0</b>. If you do not have the privileges to activate these features, ask the site administrator",
// "Sea Surfing (CSRF) detected. Operation blocked" => "Sea Surfing (CSRF) detected. Operation blocked",
// "img-g" => "img-g",
// "file-g" => "file-g",
// "arts" => "arts",
// "Plugin execution pending approval" => "Plugin execution pending approval",
// "Plugin <strong>%0</strong> does not exist" => "Plugin <strong>%0</strong> does not exist",
// "(external link)" => "(external link)",
// "smiling" => "smiling",
// "grinning" => "grinning",
// "confused" => "confused",
// "crying" => "crying",
// "frightened" => "frightened",
// "evil stuff" => "evil stuff",
// "exclamation mark " => "exclamation mark ",
// "frowning" => "frowning",
// "light bulb" => "light bulb",
// "idea " => "idea ",
// "LOL" => "LOL",
// "laughing out loud " => "laughing out loud ",
// "mr. green laughing" => "mr. green laughing",
// "The file was uploaded with success" => "The file was uploaded with success",
// "No file was uploaded. Was a file selected " => "No file was uploaded. Was a file selected ",
// "A temporary folder is missing" => "A temporary folder is missing",
// "Unknown error" => "Unknown error",
// "Bold" => "Bold",
// "pics/icons/text_bold.png" => "pics/icons/text_bold.png",
// "Italic" => "Italic",
// "pics/icons/text_italic.png" => "pics/icons/text_italic.png",
// "Underline" => "Underline",
// "pics/icons/text_underline.png" => "pics/icons/text_underline.png",
// "Strikethrough" => "Strikethrough",
// "pics/icons/text_strikethrough.png" => "pics/icons/text_strikethrough.png",
// "Non-parsed (Wiki syntax does not apply)" => "Non-parsed (Wiki syntax does not apply)",
// "pics/icons/noparse.png" => "pics/icons/noparse.png",
// "Align Center" => "Align Center",
// "pics/icons/text_align_center.png" => "pics/icons/text_align_center.png",
// "Horizontal Bar" => "Horizontal Bar",
// "pics/icons/page.png" => "pics/icons/page.png",
// "Page Break" => "Page Break",
// "pics/icons/page_break.png" => "pics/icons/page_break.png",
// "Box" => "Box",
// "pics/icons/box.png" => "pics/icons/box.png",
// "pics/icons/email.png" => "pics/icons/email.png",
// "pics/icons/book.png" => "pics/icons/book.png",
// "Unordered List" => "Unordered List",
// "pics/icons/text_list_bullets.png" => "pics/icons/text_list_bullets.png",
// "Ordered List" => "Ordered List",
// "pics/icons/text_list_numbers.png" => "pics/icons/text_list_numbers.png",
// "Special Characters" => "Special Characters",
// "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif" => "lib/ckeditor_tiki/ckeditor-icons/specialchar.gif",
// "img/smiles/icon_smile.gif" => "img/smiles/icon_smile.gif",
// "Foreground color" => "Foreground color",
// "pics/icons/palette.png" => "pics/icons/palette.png",
// "pics/icons/palette_bg.png" => "pics/icons/palette_bg.png",
// "Wiki Link" => "Wiki Link",
// "pics/icons/page_link.png" => "pics/icons/page_link.png",
// "External Link" => "External Link",
// "pics/icons/world_link.png" => "pics/icons/world_link.png",
// "pics/icons/table.png" => "pics/icons/table.png",
// "Table Builder" => "Table Builder",
// "pics/icons/find.png" => "pics/icons/find.png",
// "Find Text" => "Find Text",
// "pics/icons/text_replace.png" => "pics/icons/text_replace.png",
// "Text Replace" => "Text Replace",
// "Full Screen Edit" => "Full Screen Edit",
// "Wysiwyg Help" => "Wysiwyg Help",
// "Choose or upload images" => "Choose or upload images",
// "pics/icons/pictures.png" => "pics/icons/pictures.png",
// "Switch Editor (wiki or WYSIWYG)" => "Switch Editor (wiki or WYSIWYG)",
// "pics/icons/pencil_go.png" => "pics/icons/pencil_go.png",
// "Save Sheet" => "Save Sheet",
// "pics/icons/disk.png" => "pics/icons/disk.png",
// "Add Row After Selection Or To End If No Selection" => "Add Row After Selection Or To End If No Selection",
// "pics/icons/sheet_row_add.png" => "pics/icons/sheet_row_add.png",
// "Add Multiple Rows After Selection Or To End If No Selection" => "Add Multiple Rows After Selection Or To End If No Selection",
// "pics/icons/sheet_row_add_multi.png" => "pics/icons/sheet_row_add_multi.png",
// "Add Row Before Selection Or To End If No Selection" => "Add Row Before Selection Or To End If No Selection",
// "Delete Selected Row" => "Delete Selected Row",
// "pics/icons/sheet_row_delete.png" => "pics/icons/sheet_row_delete.png",
// "Add Column After Selection Or To End If No Selection" => "Add Column After Selection Or To End If No Selection",
// "pics/icons/sheet_col_add.png" => "pics/icons/sheet_col_add.png",
// "Delete Selected Column" => "Delete Selected Column",
// "pics/icons/sheet_col_delete.png" => "pics/icons/sheet_col_delete.png",
// "Add Multiple Columns After Selection Or To End If No Selection" => "Add Multiple Columns After Selection Or To End If No Selection",
// "pics/icons/sheet_col_add_multi.png" => "pics/icons/sheet_col_add_multi.png",
// "Add Column Before Selection Or To End If No Selection" => "Add Column Before Selection Or To End If No Selection",
// "Get Cell Range" => "Get Cell Range",
// "pics/icons/sheet_get_range.png" => "pics/icons/sheet_get_range.png",
// "Refresh Calculations" => "Refresh Calculations",
// "pics/icons/arrow_refresh.png" => "pics/icons/arrow_refresh.png",
// "Finish Editing" => "Finish Editing",
// "pics/icons/close.png" => "pics/icons/close.png",
// "Admin Toolbars" => "Admin Toolbars",
// "Item Modification" => "Item Modification",
// "Item creation" => "Item creation",
// "View the tracker item at" => "View the tracker item at",
// "Field is not numeric" => "Field is not numeric",
// "half column" => "half column",
// "prepend" => "prepend",
// "append" => "append",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax,distinct</strong>\n\t\t\t\t<dt>Example: 0,80,5,200,30\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd><strong>[distinct]</strong> is y or n. y = all values of the field must be different\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax,distinct</strong>\n\t\t\t\t<dt>Example: 0,80,5,200,30\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd><strong>[distinct]</strong> is y or n. y = all values of the field must be different\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>",
// "numeric field" => "numeric field",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,decimals,dec_point,thousands</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[decimals]</strong> sets the number of decimal places;\n\t\t\t\t<dd><strong>[dec_point]</strong> sets the separator for the decimal point (decimals must also be set). Use c for comma and s for space;\n\t\t\t\t<dd><strong>[thousands]</strong> sets the thousands separator. Use c for comma and s for space. Setting only commas will result in no decimals \n\t\t\t\t\t\t\t\t\t\t\t\t\tand commas as the thousands seprator;<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,decimals,dec_point,thousands</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[decimals]</strong> sets the number of decimal places;\n\t\t\t\t<dd><strong>[dec_point]</strong> sets the separator for the decimal point (decimals must also be set). Use c for comma and s for space;\n\t\t\t\t<dd><strong>[thousands]</strong> sets the thousands separator. Use c for comma and s for space. Setting only commas will result in no decimals \n\t\t\t\t\t\t\t\t\t\t\t\t\tand commas as the thousands seprator;<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "currency amount" => "currency amount",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,locale,symbol,first</strong>\n\t\t\t\t<dt>Example: 0,60,,per item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[locale]</strong> set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1 (default=en_US);\n\t\t\t\t<dd><strong>[currency]</strong> The 3-letter ISO 4217 currency code indicating the currency to use (default=USD);\n\t\t\t\t<dd><strong>[symbol]</strong> i for international symbol, n for local (default=n);\n\t\t\t\t<dd><strong>[all_symbol]</strong> set to 1 to show symbol for every item (default only shows currency symbol on first item in a list) ;\n\t\t\t\t<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,locale,symbol,first</strong>\n\t\t\t\t<dt>Example: 0,60,,per item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[locale]</strong> set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1 (default=en_US);\n\t\t\t\t<dd><strong>[currency]</strong> The 3-letter ISO 4217 currency code indicating the currency to use (default=USD);\n\t\t\t\t<dd><strong>[symbol]</strong> i for international symbol, n for local (default=n);\n\t\t\t\t<dd><strong>[all_symbol]</strong> set to 1 to show symbol for every item (default only shows currency symbol on first item in a list) ;\n\t\t\t\t<br/><br/>\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "drop down with other textfield" => "drop down with other textfield",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "radio buttons" => "radio buttons",
// "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriage return\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriage return\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>",
// "IP selector" => "IP selector",
// "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>",
// "page selector" => "page selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong> will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd><strong>[link]</strong> will not display the link to the page if equals to n \n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong> will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd><strong>[link]</strong> will not display the link to the page if equals to n \n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "country selector" => "country selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>when set to \"empty\" will allow selection of empty date but default to current date\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>when set to \"empty\" will allow selection of empty date but default to current date\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>",
// "jscalendar" => "jscalendar",
// "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "header" => "header",
// "<dl>\n\t\t\t\t<dt>Function: will display the field name as a html header h2;\n\t\t\t\t<dt>Usage: <strong>level</strong>\n\t\t\t\t<dt>Example: 2\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[level]</strong> level of the html header (default 2)\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: will display the field name as a html header h2;\n\t\t\t\t<dt>Usage: <strong>level</strong>\n\t\t\t\t<dt>Example: 2\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[level]</strong> level of the html header (default 2)\n\t\t\t\t</dl>",
// "static text" => "static text",
// "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall,descendants</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd><strong>[descendants]</strong> All descendant categories (not just first level children) will be included if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall,descendants</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd><strong>[descendants]</strong> All descendant categories (not just first level children) will be included if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "item link" => "item link",
// "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,0,6|8,opc,PageName\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd><strong>[linkPage]</strong> is the name of the wiki page to link to with trackerlist plugin in it; \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,0,6|8,opc,PageName\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd><strong>[linkPage]</strong> is the name of the wiki page to link to with trackerlist plugin in it; \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "items list" => "items list",
// "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd><strong>[status]</strong> filter on status (o, p, c, op, oc, pc or opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "dynamic items list" => "dynamic items list",
// "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>",
// "auto-increment" => "auto-increment",
// "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "user subscription" => "user subscription",
// "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t<dt>Usage: <strong>use_as_item_location,bubble_fieldId,icon</strong>\n\t\t\t\t<dt>Example: y,23|24,img/icons2/icn_members.gif\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[use_as_item_location]</strong> if set to y, this google map field will be used as item location and object geo attributes are set when field value is changed.\n\t\t\t\t<dd><strong>[bubble_fieldid]</strong> is the fieldId(s) (separated by |) that contains the text that will be displayed in the bubble of the map marker. The first field will be used as the link.\n\t\t\t\t<dd><strong>[icon]</strong> is the url of the default icon to use for markers of items on the map.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t<dt>Usage: <strong>use_as_item_location,bubble_fieldId,icon</strong>\n\t\t\t\t<dt>Example: y,23|24,img/icons2/icn_members.gif\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[use_as_item_location]</strong> if set to y, this google map field will be used as item location and object geo attributes are set when field value is changed.\n\t\t\t\t<dd><strong>[bubble_fieldid]</strong> is the fieldId(s) (separated by |) that contains the text that will be displayed in the bubble of the map marker. The first field will be used as the link.\n\t\t\t\t<dd><strong>[icon]</strong> is the url of the default icon to use for markers of items on the map.\n\t\t\t\t</dl>",
// "system" => "system",
// "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>",
// "computed field" => "computed field",
// "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>",
// "user preference" => "user preference",
// "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email, other values possible: language;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email, other values possible: language;\n\t\t\t\t</dl>",
// "user groups" => "user groups",
// "<dl>\n\t\t\t\t<dt>Function: Allows to display the user groups.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows to display the user groups.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows freetags to be shown or added for tracker item\n\t\t\t\t<dt>Usage: <strong>size</strong>\n\t\t\t\t<dt>Example: 80,n,n\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[hidehelp]</strong> if y, do not show help text when entering tags;\n\t\t\t\t<dd><strong>[hidesuggest]</strong> if y, do not show suggested tags when entering tags;  \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows freetags to be shown or added for tracker item\n\t\t\t\t<dt>Usage: <strong>size</strong>\n\t\t\t\t<dt>Example: 80,n,n\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[hidehelp]</strong> if y, do not show help text when entering tags;\n\t\t\t\t<dd><strong>[hidesuggest]</strong> if y, do not show suggested tags when entering tags;  \n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "in group" => "in group",
// "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Display stars\n\t\t\t\t<dt>Usage: <strong>list options (positive increasing numbers</strong>\n\t\t\t\t<dt>Example: 1,2,3,4\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Like the rating\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Display stars\n\t\t\t\t<dt>Usage: <strong>list options (positive increasing numbers</strong>\n\t\t\t\t<dt>Example: 1,2,3,4\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Like the rating\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "No extra information for that attached file. " => "No extra information for that attached file. ",
// "The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "The registration mail can't be sent because there is no server email address set, and this feature is disabled",
// "The user email confirmation can't be sent. Contact the administrator" => "The user email confirmation can't be sent. Contact the administrator",
// "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fileId=YY' or be empty to use the current field)",
// "Edit field: (Incorrect validation parameter)" => "Edit field: (Incorrect validation parameter)",
// "Invalid character combination for username" => "Invalid character combination for username",
// "here" => "here",
// "Could not establish Kaltura session. Try again" => "Could not establish Kaltura session. Try again",
// "You need to set your Kaltura account details: " => "You need to set your Kaltura account details: ",
// "Successfully stored archive in tracker" => "Successfully stored archive in tracker",
// "Failed to stored archive in tracker" => "Failed to stored archive in tracker",
// "Cannot connect with web service" => "Cannot connect with web service",
// "No permission to broadcast to channel" => "No permission to broadcast to channel",
// "Broadcaster successfully authenticated" => "Broadcaster successfully authenticated",
// "No permission to broadcast to any channel" => "No permission to broadcast to any channel",
// "Successfully logged in mobile broadcaster" => "Successfully logged in mobile broadcaster",
// "No viewable channels available for mobile" => "No viewable channels available for mobile",
// "Failed to log in mobile broadcaster" => "Failed to log in mobile broadcaster",
// "Successfully logged in FME" => "Successfully logged in FME",
// "Failed to log in FME" => "Failed to log in FME",
// "No permission to view channel" => "No permission to view channel",
// "Viewer successfully authenticated" => "Viewer successfully authenticated",
// "No permission to view any channel" => "No permission to view any channel",
// "Mailbox uninitialised??" => "Mailbox uninitialised??",
// "No mail body found" => "No mail body found",
// "Add to cart" => "Add to cart",
// "PluginAddToCart" => "PluginAddToCart",
// "Adds a product to the virtual cart. The cart can be manipulated using the cart module" => "Adds a product to the virtual cart. The cart can be manipulated using the cart module",
// "Product code" => "Product code",
// "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in",
// "Label for the product in the cart" => "Label for the product in the cart",
// "Price" => "Price",
// "The price to charge for the item" => "The price to charge for the item",
// "URL of the product\\'s information. The URL may be relative or absolute (begin with http://)" => "URL of the product\\'s information. The URL may be relative or absolute (begin with http://)",
// "Button label" => "Button label",
// "Text for the submit button. default: \"Add to cart\"" => "Text for the submit button. default: \"Add to cart\"",
// "A session must be active to use the cart" => "A session must be active to use the cart",
// "%0 (%1) was added to your cart" => "%0 (%1) was added to your cart",
// "Create an icon for a user to add an event to Google Calendar" => "Create an icon for a user to add an event to Google Calendar",
// "Add Event to Google Calendar" => "Add Event to Google Calendar",
// "PluginAddToGoogleCal" => "PluginAddToGoogleCal",
// "Creates an icon for a user to add an event to a Google Calendar" => "Creates an icon for a user to add an event to a Google Calendar",
// "Calendar item ID" => "Calendar item ID",
// "The item ID of the calendar to add to Google calendar" => "The item ID of the calendar to add to Google calendar",
// "A calendar item ID number" => "A calendar item ID number",
// "Icon Style" => "Icon Style",
// "Choose the icon style" => "Choose the icon style",
// "Either 1, 2 or 3" => "Either 1, 2 or 3",
// "One" => "One",
// "Two" => "Two",
// "Three" => "Three",
// "User Agent Info" => "User Agent Info",
// "PluginAgentinfo" => "PluginAgentinfo",
// "Display\\'s the visitor\\'s IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "Display\\'s the visitor\\'s IP address (IP or default), browser information (BROWSER), or server software (SVRSW)",
// "IP address" => "IP address",
// "Server software" => "Server software",
// "Browser" => "Browser",
// "Displays browser client info" => "Displays browser client info",
// "Anchor Link" => "Anchor Link",
// "PluginAlink" => "PluginAlink",
// "Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin" => "Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin",
// "Anchor link label" => "Anchor link label",
// "Anchor Name" => "Anchor Name",
// "The anchor name as defined in the ANAME plugin" => "The anchor name as defined in the ANAME plugin",
// "Page Name" => "Page Name",
// "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used",
// "Creates a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which specifies the location and name of the anchor" => "Creates a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which specifies the location and name of the anchor",
// "linktext" => "linktext",
// "PluginAname" => "PluginAname",
// "Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin" => "Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin",
// "The name of the anchor" => "The name of the anchor",
// "Creates an anchor in a wiki page. Use in conjunction with the ALINK plugin, which specifies a link to the anchor" => "Creates an anchor in a wiki page. Use in conjunction with the ALINK plugin, which specifies a link to the anchor",
// "PluginAnnotation" => "PluginAnnotation",
// "Autogenerated content. Leave blank initially" => "Autogenerated content. Leave blank initially",
// "Absolute URL to the image or relative path from tiki root" => "Absolute URL to the image or relative path from tiki root",
// "Image width in pixels" => "Image width in pixels",
// "Image height in pixels" => "Image height in pixels",
// "Image alignment. Possible values: left, right, center. Default is left" => "Image alignment. Possible values: left, right, center. Default is left",
// "Archive Builder" => "Archive Builder",
// "PluginArchiveBuilder" => "PluginArchiveBuilder",
// "Builds a zip archive containing the specified data from tikiwiki" => "Builds a zip archive containing the specified data from tikiwiki",
// "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435",
// "Archive Name" => "Archive Name",
// "Upon download, the name of the file that will be provided" => "Upon download, the name of the file that will be provided",
// "Missing extension zip" => "Missing extension zip",
// "Incorrect parameter" => "Incorrect parameter",
// "Download archive" => "Download archive",
// "PluginArticle" => "PluginArticle",
// "Includes an article\\'s content within the page" => "Includes an article\\'s content within the page",
// "Field" => "Field",
// "The article field to display. Default field is Heading" => "The article field to display. Default field is Heading",
// "Article ID" => "Article ID",
// "The article to display. If no value is provided, most recent article will be used" => "The article to display. If no value is provided, most recent article will be used",
// "Includes an article" => "Includes an article",
// "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~" => "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~",
// "Id is optional. If not given, last article is used. Default field is heading" => "Id is optional. If not given, last article is used. Default field is heading",
// "Article List" => "Article List",
// "PluginArticles" => "PluginArticles",
// "Inserts a list of articles in the page" => "Inserts a list of articles in the page",
// "Use Pagination" => "Use Pagination",
// "Activate pagination when articles listing are long. Default is n" => "Activate pagination when articles listing are long. Default is n",
// "Maximum Displayed" => "Maximum Displayed",
// "The number of articles to display in the list (no max set by default)" => "The number of articles to display in the list (no max set by default)",
// "If Pagination is set to y (Yes), this will determine the amount of artilces per page" => "If Pagination is set to y (Yes), this will determine the amount of artilces per page",
// "Topic Name Filter" => "Topic Name Filter",
// "Filter the list of aricles by their topic. Example: " => "Filter the list of aricles by their topic. Example: ",
// "Topic ID Filter" => "Topic ID Filter",
// "Filter the list of aricles by their topic ID. Example: " => "Filter the list of aricles by their topic ID. Example: ",
// "Type Filter" => "Type Filter",
// "Filter the list of aricles by their types. Example: " => "Filter the list of aricles by their types. Example: ",
// "Category ID" => "Category ID",
// "The ID of the category that articles need to be in to be listed" => "The ID of the category that articles need to be in to be listed",
// "List only articles in this language" => "List only articles in this language",
// "Sort order" => "Sort order",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Use random to have random items" => "Use random to have random items",
// "Quiet" => "Quiet",
// "Whether to not report when there are no articles (no reporting by default)" => "Whether to not report when there are no articles (no reporting by default)",
// "Title Only" => "Title Only",
// "Whether to only show the title of the articles (not set to title only by default)" => "Whether to only show the title of the articles (not set to title only by default)",
// "Body Only" => "Body Only",
// "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)" => "Whether to only show the body of the articles or just the heading and title. (not set to body only by default)",
// "Starting Article" => "Starting Article",
// "The article number that the list should start with (starts with first article by default)" => "The article number that the list should start with (starts with first article by default)",
// "This will not work if Pagination is used" => "This will not work if Pagination is used",
// "Start Date" => "Start Date",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Override Dates" => "Override Dates",
// "Whether to obey article type\\'s \"show before publish\" and \"show after expiry\" settings (not obeyed by default)" => "Whether to obey article type\\'s \"show before publish\" and \"show after expiry\" settings (not obeyed by default)",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "Large First Image" => "Large First Image",
// "If set to y (Yes), the first image will be displayed with the dimension used to view of the article" => "If set to y (Yes), the first image will be displayed with the dimension used to view of the article",
// "Additional URL Param to the link to read article" => "Additional URL Param to the link to read article",
// "Show actions (buttons and links)" => "Show actions (buttons and links)",
// "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the actions you have permission to do",
// "Includes articles listing into a wiki page" => "Includes articles listing into a wiki page",
// "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~",
// "PluginAttach" => "PluginAttach",
// "Displays an attachment or a list of them" => "Displays an attachment or a list of them",
// "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be used to identify a single attachment",
// "Same as name" => "Same as name",
// "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is used on a wiki page, this defaults to that wiki page",
// "Show Description" => "Show Description",
// "Shows the description as the link text instead of the file name (not used by default)" => "Shows the description as the link text instead of the file name (not used by default)",
// "Bullets" => "Bullets",
// "Makes the list of attachments a bulleted list (not set by default)" => "Makes the list of attachments a bulleted list (not set by default)",
// "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the img tag (not set by default)",
// "Custom Label" => "Custom Label",
// "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed" => "Makes the text between the {ATTACH} tags the link text instead of the file name or description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they are attached to when set to 1 (Yes)",
// "Order Number" => "Order Number",
// "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. \n\t\t\t\t\t\t\t\t\t\tEither name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list of attachments to a page instead of by file name or ID. \n\t\t\t\t\t\t\t\t\t\tEither name, file, id or num can be used to identify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order number. Either name, file, id or num can be used to identify a single attachment",
// "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the attachment at the end when set to 1 (Yes)",
// "File Type Icon" => "File Type Icon",
// "A file type icon is displayed in front of the attachment link when this is set to 1" => "A file type icon is displayed in front of the attachment link when this is set to 1",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
// "Gives the name of the attached file to link to" => "Gives the name of the attached file to link to",
// "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages" => "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages",
// "Shows the description as the link text instead of the file name" => "Shows the description as the link text instead of the file name",
// "Makes the list of attachments a bulleted list" => "Makes the list of attachments a bulleted list",
// "Says that this file is an image, and should be displayed inline using the img tag" => "Says that this file is an image, and should be displayed inline using the img tag",
// "Makes the text between the {ATTACH} tags the link text instead of the file name or description" => "Makes the text between the {ATTACH} tags the link text instead of the file name or description",
// "Shows all attachments from the whole wiki" => "Shows all attachments from the whole wiki",
// "Gives the number, in the list of attachments, of the attachment to link to" => "Gives the number, in the list of attachments, of the attachment to link to",
// "Gives the actual id of the attachment to link in. You probably should never use this" => "Gives the actual id of the attachment to link in. You probably should never use this",
// "Puts the number of downloads in the alt comment" => "Puts the number of downloads in the alt comment",
// "Shows a file icon" => "Shows a file icon",
// "Attributes" => "Attributes",
// "PluginAttributes" => "PluginAttributes",
// "Allows for generic attributes to be assigned to the current object. Attributes are provided as parameters. For tiki.geo.lat, {attributes tiki_geo_lat=...}. Removing the plugin or values in it will not remove the attributes" => "Allows for generic attributes to be assigned to the current object. Attributes are provided as parameters. For tiki.geo.lat, {attributes tiki_geo_lat=...}. Removing the plugin or values in it will not remove the attributes",
// "PluginAuthor" => "PluginAuthor",
// "Color codes parts of the page like \\'Track changes\\' in Office programs" => "Color codes parts of the page like \\'Track changes\\' in Office programs",
// "User Name" => "User Name",
// "User name of the user who wrote the text" => "User name of the user who wrote the text",
// "Deleted by User" => "Deleted by User",
// "User name of the user who deleted the text" => "User name of the user who deleted the text",
// "Make Visible" => "Make Visible",
// "Show popup with author/deleted by" => "Show popup with author/deleted by",
// "Generate a popup with names of author(s) (default: no)" => "Generate a popup with names of author(s) (default: no)",
// "deleted by" => "deleted by",
// "Shows which author created/deleted which text" => "Shows which author created/deleted which text",
// "Should this author's contribution be visible (default: no)" => "Should this author's contribution be visible (default: no)",
// "PluginAvatar" => "PluginAvatar",
// "The wiki page the avatar will link to. If empty and the user\\'s information is public, \n\t\t\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user\\'s user information page" => "The wiki page the avatar will link to. If empty and the user\\'s information is public, \n\t\t\t\t\t\t\t\t\t\tthen the avatar will link automatically the that user\\'s user information page",
// "Float" => "Float",
// "Align the avatar on the page" => "Align the avatar on the page",
// "PluginBack" => "PluginBack",
// "Displays a link that goes back one page in the browser history" => "Displays a link that goes back one page in the browser history",
// "Insert back link on wiki page" => "Insert back link on wiki page",
// "PluginBacklinks" => "PluginBacklinks",
// "List all pages linking to the specified page" => "List all pages linking to the specified page",
// "The page links will point to. Default value is the current page" => "The page links will point to. Default value is the current page",
// "Displayed Information" => "Displayed Information",
// "Pipe separated list of fields to display. ex: hits|user" => "Pipe separated list of fields to display. ex: hits|user",
// "Excluded pages" => "Excluded pages",
// "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox",
// "Include Self" => "Include Self",
// "With or without self-link (default is without)" => "With or without self-link (default is without)",
// "Header" => "Header",
// "With or without header (default is with header)" => "With or without header (default is with header)",
// "With header" => "With header",
// "Without header" => "Without header",
// "List all pages that link to specific pages" => "List all pages that link to specific pages",
// "No pages link to" => "No pages link to",
// "One page links to" => "One page links to",
// "pages link to" => "pages link to",
// "Banner" => "Banner",
// "PluginBanner" => "PluginBanner",
// "Insert a banner" => "Insert a banner",
// "Name of the zone created in Admin > Banners" => "Name of the zone created in Admin > Banners",
// "Target" => "Target",
// "Determines the browser behavior once the banner is clicked" => "Determines the browser behavior once the banner is clicked",
// "Blank" => "Blank",
// "Display" => "Display",
// "missing parameter" => "missing parameter",
// "PluginBigBlueButton" => "PluginBigBlueButton",
// "Allows to join a BigBlueButton meeting" => "Allows to join a BigBlueButton meeting",
// "Meeting" => "Meeting",
// "MeetingID provided by BigBlueButton" => "MeetingID provided by BigBlueButton",
// "Anonymous prefix" => "Anonymous prefix",
// "Unregistered users will get this token prepended to their name" => "Unregistered users will get this token prepended to their name",
// "Welcome Message" => "Welcome Message",
// "A message to be provided when someone enters the room" => "A message to be provided when someone enters the room",
// "Dial Number" => "Dial Number",
// "The phone-in support number to join from traditional phones" => "The phone-in support number to join from traditional phones",
// "Voice Bridge" => "Voice Bridge",
// "Code to enter for phone attendees to join the room" => "Code to enter for phone attendees to join the room",
// "Logout URL" => "Logout URL",
// "URL to which the user will be redirected when logging out from BigBlueButton" => "URL to which the user will be redirected when logging out from BigBlueButton",
// "Maximum Participants" => "Maximum Participants",
// "Limit to the amount of simultaneous participants in the room. Support for this parameter depends on the BigBlueButton server" => "Limit to the amount of simultaneous participants in the room. Support for this parameter depends on the BigBlueButton server",
// "Bliptv" => "Bliptv",
// "PluginBliptv" => "PluginBliptv",
// "Display a Blip.tv video" => "Display a Blip.tv video",
// "Blip.tv embed URL. Please note that this url needs to be the src param in the EMBED code, and not the video URL as in other equivalent video plugins. Example: http://blip.tv/play/AYGd_GAC (instead of http://blip.tv/file/2568201/) " => "Blip.tv embed URL. Please note that this url needs to be the src param in the EMBED code, and not the video URL as in other equivalent video plugins. Example: http://blip.tv/play/AYGd_GAC (instead of http://blip.tv/file/2568201/) ",
// "Width in pixels (default is 425" => "Width in pixels (default is 425",
// "Height in pixels (default is 350)" => "Height in pixels (default is 350)",
// "Blog List" => "Blog List",
// "PluginBlogList" => "PluginBlogList",
// "Use BLOGLIST to include posts from a blog" => "Use BLOGLIST to include posts from a blog",
// "Blog ID" => "Blog ID",
// "The ID number of the blog on the site you wish to list posts from" => "The ID number of the blog on the site you wish to list posts from",
// "Maximum Items" => "Maximum Items",
// "Maximum number of entries to list (no maximum set by default)" => "Maximum number of entries to list (no maximum set by default)",
// "Only display posts created by this user (all posts listed by default)" => "Only display posts created by this user (all posts listed by default)",
// "Simple List" => "Simple List",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
// "End Date" => "End Date",
// "Latest date to select posts from" => "Latest date to select posts from",
// "Container Class" => "Container Class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "Use BLOGLIST to include posts from a blog. Syntax is" => "Use BLOGLIST to include posts from a blog. Syntax is",
// "where Id is the blog Id and Items is the max number of posts to display" => "where Id is the blog Id and Items is the max number of posts to display",
// "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~" => "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~",
// "PluginBox" => "PluginBox",
// "Box title" => "Box title",
// "Displayed above the content" => "Displayed above the content",
// "Background color" => "Background color",
// "As defined by CSS, name or Hex code" => "As defined by CSS, name or Hex code",
// "Box width" => "Box width",
// "In pixels or percentage. Default value is 100%" => "In pixels or percentage. Default value is 100%",
// "Text Alignment" => "Text Alignment",
// "Aligns the text within the box (left aligned by default)" => "Aligns the text within the box (left aligned by default)",
// "Float Position" => "Float Position",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
// "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)" => "Items are not allowed to wrap around the box if this parameter is set to.1 (Yes)",
// "CSS Class" => "CSS Class",
// "Apply custom CSS class to the box" => "Apply custom CSS class to the box",
// "Button" => "Button",
// "PluginButton" => "PluginButton",
// "Produces a link with the shape of a button, reusing the button smarty function and requiring no validation of that plugin" => "Produces a link with the shape of a button, reusing the button smarty function and requiring no validation of that plugin",
// "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it" => "URL to be produced by the button. You can use wiki argument variables like {{itemId}} in it",
// "Label" => "Label",
// "Label for the button" => "Label for the button",
// "lib/smarty_tiki/function.button.php is missing or unreadable" => "lib/smarty_tiki/function.button.php is missing or unreadable",
// "PluginCalendar" => "PluginCalendar",
// "Includes a calendar and/or a list of calendar events" => "Includes a calendar and/or a list of calendar events",
// "Calendar IDs" => "Calendar IDs",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by commas (\",\")",
// "Example values" => "Example values",
// "Not set by default" => "Not set by default",
// "View Type" => "View Type",
// "Determines how to show events" => "Determines how to show events",
// "Possible values" => "Possible values",
// "\"table\" shows events in a calendar" => "\"table\" shows events in a calendar",
// "Default value" => "Default value",
// "View Time Span" => "View Time Span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar",
// "Default is month" => "Default is month",
// "Navigation Bar" => "Navigation Bar",
// "Decide or not to show the navigation bar (not shown by default)" => "Decide or not to show the navigation bar (not shown by default)",
// "PluginCategory" => "PluginCategory",
// "Insert list of items with the current/given category in the wiki page" => "Insert list of items with the current/given category in the wiki page",
// "Category IDs" => "Category IDs",
// "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page",
// "Types" => "Types",
// "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img" => "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal<br />+forum+igal+newsletter<br />+event+poll+quiz+survey<br />+tracker+wiki+img",
// "Sort ascending or descending based on various attributes (sorted ascending by name by default)" => "Sort ascending or descending based on various attributes (sorted ascending by name by default)",
// "'), 'value' => '" => "'), 'value' => '",
// "Created Ascending" => "Created Ascending",
// "Created Descending" => "Created Descending",
// "Hits Ascending" => "Hits Ascending",
// "Hits Descending" => "Hits Descending",
// "Item ID Ascending" => "Item ID Ascending",
// "Item ID Descending" => "Item ID Descending",
// "Name Ascending" => "Name Ascending",
// "Name Descending" => "Name Descending",
// "Type Ascending" => "Type Ascending",
// "Type Descending" => "Type Descending",
// "Split" => "Split",
// "Whether multiple categories will be listed on different lines (default is to split them)" => "Whether multiple categories will be listed on different lines (default is to split them)",
// "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)" => "If set to y (Yes), only objects in all of the categories will be shown (default is to show objects in any of the categories)",
// "With Sub-categories" => "With Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list sub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list sub-category objects)",
// "Show descriptions (not shown by default)" => "Show descriptions (not shown by default)",
// "Show Name" => "Show Name",
// "Show object names (shown by default)" => "Show object names (shown by default)",
// "Show type" => "Show type",
// "Show type (shown by default)" => "Show type (shown by default)",
// "One Per Line" => "One Per Line",
// "Show one object per line (multiple per line shown by default)" => "Show one object per line (multiple per line shown by default)",
// "Show Child Links" => "Show Child Links",
// "Show children category links (shown by default)" => "Show children category links (shown by default)",
// "Show Top Link" => "Show Top Link",
// "Show top category link (shown by default)" => "Show top category link (shown by default)",
// "Max Records" => "Max Records",
// "Maximum number of objects to list (default is 50)" => "Maximum number of objects to list (default is 50)",
// "Show Title" => "Show Title",
// "Show title text above category object lists (shown by default)" => "Show title text above category object lists (shown by default)",
// "Categories are disabled" => "Categories are disabled",
// "Category Orphans" => "Category Orphans",
// "PluginCatOrphans" => "PluginCatOrphans",
// "Display wiki pages that have not been categorized" => "Display wiki pages that have not been categorized",
// "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)" => "Currently, only works with wiki pages (set to wiki (Wiki Pages) by default)",
// "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records" => "Maximum number of items. Use -1 for unlimited. Default is the site admin setting for maximum records",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start (default is no offset)" => "Result number at which the listing should start (default is no offset)",
// "Display Tiki objects that have not been categorized" => "Display Tiki objects that have not been categorized",
// "PluginCatPath" => "PluginCatPath",
// "Insert the full category path for each category that this wiki page belongs to" => "Insert the full category path for each category that this wiki page belongs to",
// "Separator" => "Separator",
// "String used to separate the categories in the path. Default character is >" => "String used to separate the categories in the path. Default character is >",
// "Display Top Category" => "Display Top Category",
// "Show the top category as part of the path name (not shown by default)" => "Show the top category as part of the path name (not shown by default)",
// "PluginCclite" => "PluginCclite",
// "General purpose cclite utility plugin" => "General purpose cclite utility plugin",
// "Mode of operation - summary or recent. Default: summary" => "Mode of operation - summary or recent. Default: summary",
// "Account summary" => "Account summary",
// "Recent transactions" => "Recent transactions",
// "Registry" => "Registry",
// "Registry to query. Default: site preference (or first in list when more than one)" => "Registry to query. Default: site preference (or first in list when more than one)",
// "You need to be logged in to view this information" => "You need to be logged in to view this information",
// "PluginCenter" => "PluginCenter",
// "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool" => "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool",
// "Chart caption" => "Chart caption",
// "Sheet ID" => "Sheet ID",
// "Data sheet ID" => "Data sheet ID",
// "Chart Type" => "Chart Type",
// "BarStackGraphic | MultibarGraphic | MultilineGraphic | PieChartGraphic" => "BarStackGraphic | MultibarGraphic | MultilineGraphic | PieChartGraphic",
// "Chart Width" => "Chart Width",
// "Width in pixels" => "Width in pixels",
// "Chart Height" => "Chart Height",
// "Height in pixels" => "Height in pixels",
// "Value series" => "Value series",
// "Required for pie charts" => "Required for pie charts",
// "Independant series" => "Independant series",
// "Required for types other than pie chart" => "Required for types other than pie chart",
// "Dependant series" => "Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors" => "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors",
// "Labels for the series or values in the legend" => "Labels for the series or values in the legend",
// "PluginCode" => "PluginCode",
// "Enable word wrapping on the code to avoid breaking the layout. May not be used with line numbers if Geshi version 1.0.8.9+" => "Enable word wrapping on the code to avoid breaking the layout. May not be used with line numbers if Geshi version 1.0.8.9+",
// "Syntax highlighting to use. GeSHi - Generic Syntax Highlighter must be installed for languages other than php. Without GeSHi, the php tag must be included at the \n\t\t\t\t\t\t\t\t\tbeginning of the displayed code for the highlighting to work. May not be used with line numbers if Geshi version < 1.0.8.9. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Syntax highlighting to use. GeSHi - Generic Syntax Highlighter must be installed for languages other than php. Without GeSHi, the php tag must be included at the \n\t\t\t\t\t\t\t\t\tbeginning of the displayed code for the highlighting to work. May not be used with line numbers if Geshi version < 1.0.8.9. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "Line Numbers" => "Line Numbers",
// "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed" => "Show line numbers for each line of code. May not be used with colors unless GeSHI is installed",
// "Parse wiki syntax within the code snippet (not parsed by default)" => "Parse wiki syntax within the code snippet (not parsed by default)",
// "Right to Left" => "Right to Left",
// "Switch the text display from left to right to right to left  (left to right by default)" => "Switch the text display from left to right to right to left  (left to right by default)",
// "When set to 1 (Yes), HTML will still be processed (presented as is by default)" => "When set to 1 (Yes), HTML will still be processed (presented as is by default)",
// "Show HTML" => "Show HTML",
// "Interpret HTML" => "Interpret HTML",
// "Copy To Clipboard" => "Copy To Clipboard",
// "Copy the contents of the code box to the clipboard  (not copied to clipboard by default)" => "Copy the contents of the code box to the clipboard  (not copied to clipboard by default)",
// "colorbox" => "colorbox",
// "PluginColorBox" => "PluginColorBox",
// "Display all the images of a file gallery in a colorbox popup" => "Display all the images of a file gallery in a colorbox popup",
// "File Gallery ID" => "File Gallery ID",
// "ID number of the file gallery that contains the images to be displayed" => "ID number of the file gallery that contains the images to be displayed",
// "Image Gallery ID" => "Image Gallery ID",
// "ID number of the image gallery that contains the images to be displayed" => "ID number of the image gallery that contains the images to be displayed",
// "File ID Filter" => "File ID Filter",
// "Filter on fileIds in a file gallery to only show those images. Separate each fileId with \\':\\'" => "Filter on fileIds in a file gallery to only show those images. Separate each fileId with \\':\\'",
// "Thumb" => "Thumb",
// "Display as a thumbnail (y) or full size (n)" => "Display as a thumbnail (y) or full size (n)",
// "Sort Mode" => "Sort Mode",
// "Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc" => "Sort by database table field name, ascending or descending. Examples: fileId_asc or name_desc",
// "Show File Title" => "Show File Title",
// "Show file title" => "Show file title",
// "Show File Name" => "Show File Name",
// "Show file name" => "Show file name",
// "Show All Thumbs" => "Show All Thumbs",
// "Show thumbnails of all the images in the gallery" => "Show thumbnails of all the images in the gallery",
// "Parse Descriptions" => "Parse Descriptions",
// "Wiki parse the file descriptions" => "Wiki parse the file descriptions",
// "PluginContent" => "PluginContent",
// "Dynamic content ID. The value can be obtained in the listing" => "Dynamic content ID. The value can be obtained in the listing",
// "Content Label" => "Content Label",
// "Label of the dynamic content to display" => "Label of the dynamic content to display",
// "PluginCookie" => "PluginCookie",
// "Display a rotating set of taglines or quotes (also known as fortune cookies)" => "Display a rotating set of taglines or quotes (also known as fortune cookies)",
// "PluginCopyright" => "PluginCopyright",
// "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~",
// "Countdown" => "Countdown",
// "PluginCountdown" => "PluginCountdown",
// "Displays a countdown from now until the specified date" => "Displays a countdown from now until the specified date",
// "Text to append to the countdown" => "Text to append to the countdown",
// "Target date. Multiple formats accepted" => "Target date. Multiple formats accepted",
// "Locate Time" => "Locate Time",
// "Set to off to only show days, otherwise hours, minutes and seconds are also shown (all are shown by default)" => "Set to off to only show days, otherwise hours, minutes and seconds are also shown (all are shown by default)",
// "On" => "On",
// "Off" => "Off",
// "Items to Show" => "Items to Show",
// "Select: d=days, h=hours, m=minutes, s=seconds. Enter multiple values as: dhms. If blank, all items are shown" => "Select: d=days, h=hours, m=minutes, s=seconds. Enter multiple values as: dhms. If blank, all items are shown",
// "Days & Hours" => "Days & Hours",
// "Days, Hours & Minutes" => "Days, Hours & Minutes",
// "Days, Hours, Minutes & Seconds" => "Days, Hours, Minutes & Seconds",
// "Hours & Minutes" => "Hours & Minutes",
// "Hours, Minutes & Seconds" => "Hours, Minutes & Seconds",
// "Minutes & Seconds" => "Minutes & Seconds",
// "Seconds" => "Seconds",
// "Show time since event" => "Show time since event",
// "If y, will display amount of time since the event (default). If n will simply display that the event is over" => "If y, will display amount of time since the event (default). If n will simply display that the event is over",
// "since " => "since ",
// "until " => "until ",
// " is over" => " is over",
// "Data Channel" => "Data Channel",
// "PluginDataChannel" => "PluginDataChannel",
// "Displays a form to trigger data channels" => "Displays a form to trigger data channels",
// "List of fields to display. One field per line. Comma delimited: fieldname,label" => "List of fields to display. One field per line. Comma delimited: fieldname,label",
// "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"" => "To use values from other forms on the same page as parameters for the data-channel use \"fieldname, external=fieldid\"",
// "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel" => "Where \"fieldid\" is the id (important) of the external input to use, and \"fieldname\" is the name of the parameter in the data-channel",
// "Channel Name" => "Channel Name",
// "Name of the channel as registered by the administrator" => "Name of the channel as registered by the administrator",
// "Return URL" => "Return URL",
// "URL to go to after data channel has run. Defaults to current page" => "URL to go to after data channel has run. Defaults to current page",
// "Do not use returnURI but instead return true quietly" => "Do not use returnURI but instead return true quietly",
// "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context" => "If set to y, will return quietly after data channel has run which would be needed if plugin is used in non-wiki page context",
// "Button Label" => "Button Label",
// "Label for the submit button. Default: \"Go\"" => "Label for the submit button. Default: \"Go\"",
// "Class" => "Class",
// "CSS class for this form" => "CSS class for this form",
// "Empty Caches" => "Empty Caches",
// "Which caches to empty. Default \"Clear all Tiki caches\"" => "Which caches to empty. Default \"Clear all Tiki caches\"",
// "./templates_c/" => "./templates_c/",
// "./modules/cache/" => "./modules/cache/",
// "./temp/cache/" => "./temp/cache/",
// "./temp/public/" => "./temp/public/",
// "Price to execute the datachannel (%0)" => "Price to execute the datachannel (%0)",
// "Payment Label" => "Payment Label",
// "Debug" => "Debug",
// "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules can be obsolete (not on by default)",
// "Multiple Values" => "Multiple Values",
// "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. itemId[]=42&itemId=43 etc. (multiple values not accepted by default)",
// "Datachannel" => "Datachannel",
// "DBReport" => "DBReport",
// "PluginDBReport" => "PluginDBReport",
// "Run a database report. This plugin only works with adodb. It does not work with PDO" => "Run a database report. This plugin only works with adodb. It does not work with PDO",
// "report definition" => "report definition",
// "Full DSN" => "Full DSN",
// "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database",
// "Wiki DSN Name" => "Wiki DSN Name",
// "The name of a DSN connection defined by the Wiki administrator" => "The name of a DSN connection defined by the Wiki administrator",
// "Parse wiki syntax within the report (not parsed by default)" => "Parse wiki syntax within the report (not parsed by default)",
// "Display the parsed report definition (not displayed by default)" => "Display the parsed report definition (not displayed by default)",
// "Missing db or dsn parameter" => "Missing db or dsn parameter",
// "No DSN connection string found" => "No DSN connection string found",
// "Run a database report" => "Run a database report",
// "Div" => "Div",
// "PluginDiv" => "PluginDiv",
// "Insert a division block, span, blockquote or other text formatting on wiki page" => "Insert a division block, span, blockquote or other text formatting on wiki page",
// "Indicate the type of HTML tag to use (default is div)" => "Indicate the type of HTML tag to use (default is div)",
// "Span" => "Span",
// "Teletype" => "Teletype",
// "Paragraph" => "Paragraph",
// "Block quote" => "Block quote",
// "In pixels or percentage. Default is original size" => "In pixels or percentage. Default is original size",
// "Aligns the text within the element" => "Aligns the text within the element",
// "Justify" => "Justify",
// "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)" => "Set the alignment for the entire element. For elements with a width of less than 100%, other elements will wrap around it \n\t\t\t\t\t\t\t\t\t\tunless the clear parameter is appropriately set.)",
// "Items are not allowed to wrap around the side(s) this parameter is set to" => "Items are not allowed to wrap around the side(s) this parameter is set to",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "HTML ID" => "HTML ID",
// "Sets the div\\'s id attribute, as defined by HTML" => "Sets the div\\'s id attribute, as defined by HTML",
// "Definition List" => "Definition List",
// "PluginDL" => "PluginDL",
// "Creates a definition list" => "Creates a definition list",
// "One entry per line. Each line is in \"Term: Definition\" format" => "One entry per line. Each line is in \"Term: Definition\" format",
// "one definition per line" => "one definition per line",
// "Equation" => "Equation",
// "PluginEquation" => "PluginEquation",
// "Renders an equation written in LaTeX syntax as an image" => "Renders an equation written in LaTeX syntax as an image",
// "equation" => "equation",
// "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large" => "Size expressed as a percentage of the normal size. 100 produces the default size. 200 produces an image twice as large",
// "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size" => "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size",
// "Events" => "Events",
// "PluginEvents" => "PluginEvents",
// "Display upcoming events from calendars" => "Display upcoming events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)" => "ID numbers for the site calendars whose events are to be displayed, separated by vertical bars (|)",
// "Maximum Days" => "Maximum Days",
// "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days" => "Events occurring within this number of days in the future from today will be included in the list (unless limited by other parameter settings). Default is 365 days",
// "Maximum Events" => "Maximum Events",
// "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)" => "Maximum number of events to display. Default is 10. Set to 0 to display all (unless limited by other parameter settings)",
// "Show Time" => "Show Time",
// "Show the time along with the date (shown by default)" => "Show the time along with the date (shown by default)",
// "Show the description of the event (shown by default)" => "Show the description of the event (shown by default)",
// "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage",
// "PluginFade" => "PluginFade",
// "Displays a label. On click, the block of content will fade in and fade out" => "Displays a label. On click, the block of content will fade in and fade out",
// "Wiki syntax containing the text to display" => "Wiki syntax containing the text to display",
// "Label to display on first display" => "Label to display on first display",
// "Unspecified label" => "Unspecified label",
// "Fancy List" => "Fancy List",
// "PluginFancyList" => "PluginFancyList",
// "Creates a fancy-looking list" => "Creates a fancy-looking list",
// "One item per line starting with anything followed by \")\"" => "One item per line starting with anything followed by \")\"",
// "Use Div" => "Use Div",
// "Use the HTML tag div instead of the HTML tag for lists (ol)" => "Use the HTML tag div instead of the HTML tag for lists (ol)",
// "CSS class for the fancylist" => "CSS class for the fancylist",
// "num" => "num",
// "item text" => "item text",
// "one item per line" => "one item per line",
// "Fancy Table" => "Fancy Table",
// "PluginFancyTable" => "PluginFancyTable",
// "Displays the data using the Tikiwiki odd/even table style" => "Displays the data using the Tikiwiki odd/even table style",
// "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases" => "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases",
// "Heading Row" => "Heading Row",
// "Header rows of the table. Use >> to separate multiple rows" => "Header rows of the table. Use >> to separate multiple rows",
// "Heading CSS Class" => "Heading CSS Class",
// "CSS class to apply to the heading row" => "CSS class to apply to the heading row",
// "Header Horizontal Align" => "Header Horizontal Align",
// "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify" => "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify",
// "Header Vertical Align" => "Header Vertical Align",
// "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline" => "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline",
// "Column Sort" => "Column Sort",
// "Indicate whether columns are sortable or not (not sortable by default)" => "Indicate whether columns are sortable or not (not sortable by default)",
// "Pre-sorted Columns" => "Pre-sorted Columns",
// "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]" => "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]",
// "Column Widths" => "Column Widths",
// "Column widths followed by px for pixels or % for percentages. Each column separated by |" => "Column widths followed by px for pixels or % for percentages. Each column separated by |",
// "Cell Horizontal Align" => "Cell Horizontal Align",
// "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify" => "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify",
// "Cell Vertical Align" => "Cell Vertical Align",
// "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline" => "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline",
// "The feature must be activated" => "The feature must be activated",
// "cells" => "cells",
// "heads and cells separated by |" => "heads and cells separated by |",
// "PluginFile" => "PluginFile",
// "Displays a link to a file (either from the file gallery or an attachment to a wiki page) and can display an image attachment. For more than one file from file galleries, or more optional information shown from the files, use the plugin FILES instead" => "Displays a link to a file (either from the file gallery or an attachment to a wiki page) and can display an image attachment. For more than one file from file galleries, or more optional information shown from the files, use the plugin FILES instead",
// "Label for the link to the file" => "Label for the link to the file",
// "Indicate whether the file is in a file gallery or is a wiki page attachment" => "Indicate whether the file is in a file gallery or is a wiki page attachment",
// "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used" => "Identify an attachment by entering its file name, which will show as a link to the file.\n\t\t\t\t\t\t\t\t\t\t If the page parameter is empty, it must be a file name of an attachment to the page where the plugin is used",
// "Custom Description" => "Custom Description",
// "Custom text that will be used for the link instead of the file name or file description" => "Custom text that will be used for the link instead of the file name or file description",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the plugin is used if empty",
// "Attachment Description" => "Attachment Description",
// "Show the attachment description as the link label instead of the attachment file name" => "Show the attachment description as the link label instead of the attachment file name",
// "Indicates that this attachment is an image, and should be displayed inline using the img tag" => "Indicates that this attachment is an image, and should be displayed inline using the img tag",
// "File ID" => "File ID",
// "File ID of a file in a file gallery or an archive" => "File ID of a file in a file gallery or an archive",
// "Example value" => "Example value",
// "For an archive file, the archive created just before this date will be linked to" => "For an archive file, the archive created just before this date will be linked to",
// "Show Icon" => "Show Icon",
// "Show an icon version of the file or file type with the link to the file" => "Show an icon version of the file or file type with the link to the file",
// "File Gallery File/Archive" => "File Gallery File/Archive",
// "Wiki Page Attachment" => "Wiki Page Attachment",
// "The date has not been set" => "The date has not been set",
// "Incorrect date format" => "Incorrect date format",
// "No such file" => "No such file",
// "Wiki attachments are disabled" => "Wiki attachments are disabled",
// "PluginFiles" => "PluginFiles",
// "Displays a list of files from a file gallery" => "Displays a list of files from a file gallery",
// "To list only files contained in this file gallery" => "To list only files contained in this file gallery",
// "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a single category or ID or list of them separated by colon",
// "To list only specified files, enter their file IDs separated by colon" => "To list only specified files, enter their file IDs separated by colon",
// "Order ascending or descending based on any field in the file gallery table. Default is name_asc" => "Order ascending or descending based on any field in the file gallery table. Default is name_asc",
// "Show Action" => "Show Action",
// "Show a column with icons for the various actions the user can take with each file (not shown by default)" => "Show a column with icons for the various actions the user can take with each file (not shown by default)",
// "Show Find" => "Show Find",
// "Show a search box above the list (not shown by default)" => "Show a search box above the list (not shown by default)",
// "Show the title of the file gallery (shown by default)" => "Show the title of the file gallery (shown by default)",
// "Show ID" => "Show ID",
// "Show the ID number of each file (shown by default)" => "Show the ID number of each file (shown by default)",
// "Show an icon for each file depicting the file type" => "Show an icon for each file depicting the file type",
// "Show the name given to the file upon upload into the file gallery (shown by default)" => "Show the name given to the file upon upload into the file gallery (shown by default)",
// "Show Filename" => "Show Filename",
// "Show each file\\'s filename (shown by default)" => "Show each file\\'s filename (shown by default)",
// "Show Size" => "Show Size",
// "Show the size of each file in kilobytes (shown by default)" => "Show the size of each file in kilobytes (shown by default)",
// "Show the description of the file given upon upload into the file gallery (shown by default)" => "Show the description of the file given upon upload into the file gallery (shown by default)",
// "Show the date each file was created (not shown by default)" => "Show the date each file was created (not shown by default)",
// "Show Last Modification Date" => "Show Last Modification Date",
// "Show the date each file was last modified (shown by default)" => "Show the date each file was last modified (shown by default)",
// "Show Hits" => "Show Hits",
// "Show the number of hits each file has received (not shown by default)" => "Show the number of hits each file has received (not shown by default)",
// "Show Locked By" => "Show Locked By",
// "For locked files, show the user name of the user who locked it (not shown by default)" => "For locked files, show the user name of the user who locked it (not shown by default)",
// "Show the user name of the user who is the author of the file (not shown by default)" => "Show the user name of the user who is the author of the file (not shown by default)",
// "Show the user name of the user who is the creator of the file (not shown by default)" => "Show the user name of the user who is the creator of the file (not shown by default)",
// "Show Parent Gallery Name" => "Show Parent Gallery Name",
// "Show the name of the parent gallery" => "Show the name of the parent gallery",
// "Show File Count" => "Show File Count",
// "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other galleries), show the number of files in each of those galleries (not shown by default)",
// "Show Slideshow" => "Show Slideshow",
// "Show a link that produces a pop-up slide show when clicked (not set by default)" => "Show a link that produces a pop-up slide show when clicked (not set by default)",
// "Show Comment" => "Show Comment",
// "Show comments for each file (not shown by default)" => "Show comments for each file (not shown by default)",
// "Show Last Editor" => "Show Last Editor",
// "Show the user name of the user who last modified the file (shown by default)" => "Show the user name of the user who last modified the file (shown by default)",
// "Show only files created by this user" => "Show only files created by this user",
// "Show Upload" => "Show Upload",
// "Show a simple upload form to the gallery (not shown by default)" => "Show a simple upload form to the gallery (not shown by default)",
// "List files in a file gallery (with a category) or in a category or a file gallery od this category" => "List files in a file gallery (with a category) or in a category or a file gallery od this category",
// "Flash video" => "Flash video",
// "PluginFlash" => "PluginFlash",
// "Displays a Flash (.swf) file in the wiki page" => "Displays a Flash (.swf) file in the wiki page",
// "Flash Type" => "Flash Type",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file gallery or a link to a specific service like Youtube or Vimeo",
// "Select an option" => "Select an option",
// "Blip.tv" => "Blip.tv",
// "File Gallery Podcast" => "File Gallery Podcast",
// "Movie URL" => "Movie URL",
// "Vimeo" => "Vimeo",
// "Youtube" => "Youtube",
// "Complete URL to the movie to include. e.g. files/test.swf" => "Complete URL to the movie to include. e.g. files/test.swf",
// "File Gallery Podcast ID" => "File Gallery Podcast ID",
// "Id of a file from a podcast gallery - will work only with podcast gallery" => "Id of a file from a podcast gallery - will work only with podcast gallery",
// "Youtube URL" => "Youtube URL",
// "Entire URL to the YouTube video. Example: http://www.youtube.com/watch?v=1i2ZnU4iR24" => "Entire URL to the YouTube video. Example: http://www.youtube.com/watch?v=1i2ZnU4iR24",
// "Vimeo URL" => "Vimeo URL",
// "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966" => "Entire URL to the Vimeo video. Example: http://vimeo.com/3319966",
// "Blip.tv URL" => "Blip.tv URL",
// "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC" => "Blip.tv embed URL. Example: http://blip.tv/play/AYGd_GAC",
// "Width of movie in pixels (default is 425)" => "Width of movie in pixels (default is 425)",
// "Height of movie in pixels (default is 350)" => "Height of movie in pixels (default is 350)",
// "Flash video quality. Default value: high" => "Flash video quality. Default value: high",
// "Medium" => "Medium",
// "Invalid URL" => "Invalid URL",
// "Missing parameter movie to the plugin flash" => "Missing parameter movie to the plugin flash",
// "Inserts a superscripted footnote number next to text and takes in footnote as parameter" => "Inserts a superscripted footnote number next to text and takes in footnote as parameter",
// "Footnote" => "Footnote",
// "PluginFootnote" => "PluginFootnote",
// "The footnote" => "The footnote",
// "Sameas" => "Sameas",
// "Tag to existing footnote" => "Tag to existing footnote",
// "CheckDuplicate" => "CheckDuplicate",
// "Check for duplicate footnotes" => "Check for duplicate footnotes",
// "Footnotearea" => "Footnotearea",
// "PluginFootnoteArea" => "PluginFootnoteArea",
// "Inserts a section for collected footnotes in the wiki page" => "Inserts a section for collected footnotes in the wiki page",
// "Freetagged" => "Freetagged",
// "PluginFreetagged" => "PluginFreetagged",
// "Find similarly tagged objects" => "Find similarly tagged objects",
// "Tags to find similar to" => "Tags to find similar to",
// "Leave blank to use the object\\'s own tags" => "Leave blank to use the object\\'s own tags",
// "Type of objects to extract. Set to All to find all types" => "Type of objects to extract. Set to All to find all types",
// "Same" => "Same",
// "Offset" => "Offset",
// "Start record" => "Start record",
// "Default -1 (all)" => "Default -1 (all)",
// "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)" => "Choose from:  objectId, type, itemId, description, created, name, href, hits, comments_locked (Default: created_desc)",
// "Comments Locked Ascending" => "Comments Locked Ascending",
// "Comments Locked Descending" => "Comments Locked Descending",
// "Description Ascending" => "Description Ascending",
// "Description Descending" => "Description Descending",
// "Href Ascending" => "Href Ascending",
// "Href Descending" => "Href Descending",
// "Object ID Ascending" => "Object ID Ascending",
// "Object ID Descending" => "Object ID Descending",
// "Show objects with names or descriptions similar to the text entered here" => "Show objects with names or descriptions similar to the text entered here",
// "Broaden" => "Broaden",
// "n|y" => "n|y",
// "Header Level" => "Header Level",
// "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags" => "Choose the header level for formatting. Default is 3 (for header level h3). Set to -1 for no header tags",
// "Show Titles Only" => "Show Titles Only",
// "Choose whether to show titles only (not shown by default)" => "Choose whether to show titles only (not shown by default)",
// "Maximum Image Size" => "Maximum Image Size",
// "Height or width in pixels. Default = 0 (no maximum)" => "Height or width in pixels. Default = 0 (no maximum)",
// "Search the titles of all pages in this wiki" => "Search the titles of all pages in this wiki",
// "Download box for a file on ftp server" => "Download box for a file on ftp server",
// "FTP" => "FTP",
// "PluginFTP" => "PluginFTP",
// "Download box for a file on an FTP server" => "Download box for a file on an FTP server",
// "Server Name" => "Server Name",
// "Name of the server where the FTP account is housed. Example: " => "Name of the server where the FTP account is housed. Example: ",
// "User name needed to access the FTP account" => "User name needed to access the FTP account",
// "Password needed to access the FTP account" => "Password needed to access the FTP account",
// "Download Button Label" => "Download Button Label",
// "Label for the FTP download button" => "Label for the FTP download button",
// "Gauge" => "Gauge",
// "PluginGauge" => "PluginGauge",
// "Displays a graphical gauge" => "Displays a graphical gauge",
// "Current value to be represented by the gauge" => "Current value to be represented by the gauge",
// "Main color of the gauge. Use HTML color codes or names" => "Main color of the gauge. Use HTML color codes or names",
// "Background color of the gauge. Use HTML color codes or names" => "Background color of the gauge. Use HTML color codes or names",
// "Bar width in pixels" => "Bar width in pixels",
// "Label Width" => "Label Width",
// "Width in pixels allocated to the label" => "Width in pixels allocated to the label",
// "Display Percentage" => "Display Percentage",
// "Set to true (Yes) to display a percentage of the maximum" => "Set to true (Yes) to display a percentage of the maximum",
// "Display Value" => "Display Value",
// "Set to false (No) to hide the numeric value (shown by default)" => "Set to false (No) to hide the numeric value (shown by default)",
// "Bar height in pixels" => "Bar height in pixels",
// "Google Analytics" => "Google Analytics",
// "PluginGoogleAnalytics" => "PluginGoogleAnalytics",
// "Add the tracking code for Google Analytics" => "Add the tracking code for Google Analytics",
// "Account Number" => "Account Number",
// "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY" => "The account number for the site. Your account number from google looks like UA-XXXXXXX-YY. All you need to enter is XXXXXXX-YY",
// "Missing parameter" => "Missing parameter",
// "Google Doc" => "Google Doc",
// "PluginGoogleDoc" => "PluginGoogleDoc",
// "Displays a Google document" => "Displays a Google document",
// "Leave this empty" => "Leave this empty",
// "Type of Google document" => "Type of Google document",
// "Document" => "Document",
// "Presentation" => "Presentation",
// "key" => "key",
// "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI" => "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI",
// "Name of iframe. Default is \"Frame\" + the key" => "Name of iframe. Default is \"Frame\" + the key",
// "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google presentations sizes exactly",
// "Small" => "Small",
// "Large" => "Large",
// "Width in pixels or %" => "Width in pixels or %",
// "Height in pixels or %" => "Height in pixels or %",
// "Middle" => "Middle",
// "Choose whether to show a border around the iframe" => "Choose whether to show a border around the iframe",
// "Margin Height" => "Margin Height",
// "Margin height in pixels" => "Margin height in pixels",
// "Margin Width" => "Margin Width",
// "Margin width in pixels" => "Margin width in pixels",
// "Scrolling" => "Scrolling",
// "Choose whether to add a scroll bar" => "Choose whether to add a scroll bar",
// "Auto" => "Auto",
// "Edit Link" => "Edit Link",
// "Choose whether to show an edit link and set its location" => "Choose whether to show an edit link and set its location",
// "Required parameter \"type\" missing" => "Required parameter \"type\" missing",
// "Required parameter \"key\" missing" => "Required parameter \"key\" missing",
// "googledoc" => "googledoc",
// "googlemap" => "googlemap",
// "PluginGoogleMap" => "PluginGoogleMap",
// "Displays a Google map" => "Displays a Google map",
// "Type of items to show on google map" => "Type of items to show on google map",
// "Locator" => "Locator",
// "Object List" => "Object List",
// "Tracker Field" => "Tracker Field",
// "Display Mode" => "Display Mode",
// "Map display mode" => "Map display mode",
// "Satellite" => "Satellite",
// "Hybrid" => "Hybrid",
// "API Key" => "API Key",
// "Google maps key, if not set in user preferences" => "Google maps key, if not set in user preferences",
// "Map ID" => "Map ID",
// "Id suffix of Google map div to avoid conflicts with other maps on same page" => "Id suffix of Google map div to avoid conflicts with other maps on same page",
// "Show Border" => "Show Border",
// "Choose whether to show a frame border around the map (no border shown by default)" => "Choose whether to show a frame border around the map (no border shown by default)",
// "Default Center Longitude" => "Default Center Longitude",
// "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature" => "Default longitude value used to center the map, e.g. -79.39. Default is the default set in the Gmap feature",
// "Default Center Latitude" => "Default Center Latitude",
// "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature" => "Default latitude value used to center the map, e.g. 43.7. Default is the default set in the Gmap feature",
// "Default Zoom" => "Default Zoom",
// "Use an integer between 0 and 19 to set a default zoom level for the map. Default is the default set in the Gmap feature" => "Use an integer between 0 and 19 to set a default zoom level for the map. Default is the default set in the Gmap feature",
// "Save View" => "Save View",
// "Allow user to set current map view as default view for himself only" => "Allow user to set current map view as default view for himself only",
// "Item Type" => "Item Type",
// "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified" => "Type of item being geotagged (user, wiki page, blog, etc). Will attempt to use current object if not specified",
// "Item ID" => "Item ID",
// "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified" => "ID of item being geotagged (name of page, blog ID, etc). Will attempt to use current object if not specified",
// "Hide If No Markers" => "Hide If No Markers",
// "Hide map if there are no markers to be shown. Default is to show the map" => "Hide map if there are no markers to be shown. Default is to show the map",
// "Visibility Toggle" => "Visibility Toggle",
// "Add ability to toggle visibility. No toggle by default" => "Add ability to toggle visibility. No toggle by default",
// "Start Hidden" => "Start Hidden",
// "Choose whether to keep the map hidden initially. Default is to show the map initially" => "Choose whether to keep the map hidden initially. Default is to show the map initially",
// "Auto Zoom" => "Auto Zoom",
// "Use an integer between 0 and 19 to auto zoom to this level on address find" => "Use an integer between 0 and 19 to auto zoom to this level on address find",
// "Show Controls" => "Show Controls",
// "Show map controls (shown by default)" => "Show map controls (shown by default)",
// "Tracker Field ID" => "Tracker Field ID",
// "Field ID of tracker field if type is trackerfield or locator and locateitemtype is trackeritem" => "Field ID of tracker field if type is trackerfield or locator and locateitemtype is trackeritem",
// "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms" => "HTML ID of tracker field input box where value is copied to by Javascript. Auto set if used as part of entry forms",
// "In Form" => "In Form",
// "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML" => "Set to 1 (Yes) if this is embedded inside a form. Needed to prevent nested forms which is not allowed in HTML",
// "Google Maps API key not set" => "Google Maps API key not set",
// "No such user" => "No such user",
// "No such object" => "No such object",
// "Not logged in" => "Not logged in",
// "Error: Invalid Lon. and Lat. values" => "Error: Invalid Lon. and Lat. values",
// "Map view saved as default for " => "Map view saved as default for ",
// "You can only set your own location" => "You can only set your own location",
// "Please select a point to set both Lon. and Lat" => "Please select a point to set both Lon. and Lat",
// "User location saved for " => "User location saved for ",
// "You cannot edit this object or no such object" => "You cannot edit this object or no such object",
// "Location saved for object" => "Location saved for object",
// "Error saving location" => "Error saving location",
// "PluginGroup" => "PluginGroup",
// "Display wiki text if user is in one of listed groups" => "Display wiki text if user is in one of listed groups",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition",
// "Allowed User Friends" => "Allowed User Friends",
// "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo" => "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo",
// "Allowed Groups" => "Allowed Groups",
// "Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "Pipe separated list of groups allowed to view the block. ex: Admins|Developers",
// "Denied Groups" => "Denied Groups",
// "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers",
// "Display wiki text if user is in one of listed groups or group of friends" => "Display wiki text if user is in one of listed groups or group of friends",
// "Group List" => "Group List",
// "PluginGroupList" => "PluginGroupList",
// "List all groups or just groups that include a certain group" => "List all groups or just groups that include a certain group",
// "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups that include this group to be listed",
// "Group Home Page" => "Group Home Page",
// "Link the group name to the group home page, if there is one (not linked by default)" => "Link the group name to the group home page, if there is one (not linked by default)",
// "Recursively List Groups" => "Recursively List Groups",
// "Recurse on the included groups (default is not to recurse)" => "Recurse on the included groups (default is not to recurse)",
// "GroupMailCore" => "GroupMailCore",
// "PluginGroupMailCore" => "PluginGroupMailCore",
// "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile" => "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile",
// "From Email" => "From Email",
// "Email address to report" => "Email address to report",
// "Tracker Id" => "Tracker Id",
// "Id of GroupMail Logs tracker (set up in alias by profile)" => "Id of GroupMail Logs tracker (set up in alias by profile)",
// "From Field Id" => "From Field Id",
// "Id of GroupMail Logs tracker field (usually set up in alias by profile)" => "Id of GroupMail Logs tracker field (usually set up in alias by profile)",
// "Operator Field Id" => "Operator Field Id",
// "Subject Field Id" => "Subject Field Id",
// "Message Field Id" => "Message Field Id",
// "Content Field Id" => "Content Field Id",
// "Account Field Id" => "Account Field Id",
// "Datetime Field Id" => "Datetime Field Id",
// "Displays GroupMail functions on a wiki page" => "Displays GroupMail functions on a wiki page",
// "Group Stats" => "Group Stats",
// "PluginGroupStat" => "PluginGroupStat",
// "Displays the percentage of total users that are members of groups" => "Displays the percentage of total users that are members of groups",
// "Groups separated by :. If empty, all groups will be listed" => "Groups separated by :. If empty, all groups will be listed",
// "Show Percentage" => "Show Percentage",
// "Show the percentage of total users that are members of each group (percentages are shown by default)" => "Show the percentage of total users that are members of each group (percentages are shown by default)",
// "Show Bar" => "Show Bar",
// "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar graph (default is not to show the bar graph)",
// "HTML" => "HTML",
// "PluginHTML" => "PluginHTML",
// "Include literal HTML in a Wiki page" => "Include literal HTML in a Wiki page",
// "Parse wiki syntax within the html code" => "Parse wiki syntax within the html code",
// "Iframe" => "Iframe",
// "PluginIframe" => "PluginIframe",
// "Displays an iframe" => "Displays an iframe",
// "Frame title" => "Frame title",
// "Pixels or %" => "Pixels or %",
// "Align the ifram on the page" => "Align the ifram on the page",
// "Frame Border" => "Frame Border",
// "iframe" => "iframe",
// "PluginImg" => "PluginImg",
// "Display images" => "Display images",
// "Image source" => "Image source",
// "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required" => "Full URL to the image to display. \"src\", id\", \"fileId\", \"attId\" or \"randomGalleryId\" required",
// "Image ID" => "Image ID",
// "Numeric ID of an image in an Image Gallery (or list separated by commas or |)" => "Numeric ID of an image in an Image Gallery (or list separated by commas or |)",
// "Numeric ID of an image in a File Gallery (or list separated by commas or |)" => "Numeric ID of an image in a File Gallery (or list separated by commas or |)",
// "Gallery ID" => "Gallery ID",
// "Numeric ID of a File Gallery. Displays a random image from that gallery" => "Numeric ID of a File Gallery. Displays a random image from that gallery",
// "Attachment ID" => "Attachment ID",
// "Numeric ID of an image attached to a wiki page (or list separated by commas or |)" => "Numeric ID of an image attached to a wiki page (or list separated by commas or |)",
// "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments",
// "Full size image appears when thumbnail is clicked" => "Full size image appears when thumbnail is clicked",
// "Mouseover" => "Mouseover",
// "Full size image will pop up while cursor is over the thumbnail (and disappear when not)" => "Full size image will pop up while cursor is over the thumbnail (and disappear when not)",
// "Mouseover (Sticky)" => "Mouseover (Sticky)",
// "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup" => "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup",
// "Popup" => "Popup",
// "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked" => "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked",
// "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery",
// "Browse Popup" => "Browse Popup",
// "Same as \"browse\" except that the page opens in a new window or tab" => "Same as \"browse\" except that the page opens in a new window or tab",
// "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked" => "Download dialog box will appear for file gallery and attachment images when thumbnail is clicked",
// "Enlarge button" => "Enlarge button",
// "Button for enlarging image" => "Button for enlarging image",
// "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting" => "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting",
// "Link relation" => "Link relation",
// "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation" => "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation",
// "Image map" => "Image map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
// "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Height in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
// "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent" => "Width in pixels or percent. Syntax: \"100\" or \"100px\" means 100 pixels; \"50%\" means 50 percent",
// "Maximum image size" => "Maximum image size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings",
// "Align image" => "Align image",
// "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box" => "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box",
// "Image style" => "Image style",
// "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects",
// "Align image block" => "Align image block",
// "Aligns the box containing the image" => "Aligns the box containing the image",
// "Image block style" => "Image block style",
// "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects",
// "Description style" => "Description style",
// "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects" => "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects",
// "Wrapping control" => "Wrapping control",
// "Control how other items wrap around the image" => "Control how other items wrap around the image",
// "CSS class to apply to the image" => "CSS class to apply to the image",
// "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description" => "Image caption. \"desc\" or \"name\" or \"namedesc\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description",
// "Link title" => "Link title",
// "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title" => "Title text. \"desc\" or \"name\" or \"namedesc\", otherwise enter your own title",
// "Alternate text" => "Alternate text",
// "Alternate text that displays when image does not load. Set to \"Image\" by default" => "Alternate text that displays when image does not load. Set to \"Image\" by default",
// "Default config settings" => "Default config settings",
// "Default configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "Mandatory admin setting" => "Mandatory admin setting",
// "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or through Plugin Alias)",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "Enlarge" => "Enlarge",
// "''No image specified. Either the fileId, randomGalleryId, attId, id, or src parameter must be specified.''" => "''No image specified. Either the fileId, randomGalleryId, attId, id, or src parameter must be specified.''",
// "''Use one and only one of the following parameters: fileId, randomGalleryId, attId, id, or src.''" => "''Use one and only one of the following parameters: fileId, randomGalleryId, attId, id, or src.''",
// "PluginInclude" => "PluginInclude",
// "Include a page\\'s content" => "Include a page\\'s content",
// "Wiki page name to include" => "Wiki page name to include",
// "When only a portion of the page should be included, specify the marker from which inclusion should start" => "When only a portion of the page should be included, specify the marker from which inclusion should start",
// "When only a portion of the page should be included, specify the marker at which inclusion should end" => "When only a portion of the page should be included, specify the marker at which inclusion should end",
// "Nopage Text" => "Nopage Text",
// "Text to show when no page is found" => "Text to show when no page is found",
// "Page Denied Text" => "Page Denied Text",
// "Text to show when the page exists but is denied to the user" => "Text to show when the page exists but is denied to the user",
// "Include a page" => "Include a page",
// "Invite" => "Invite",
// "PluginInvite" => "PluginInvite",
// "Invite an email in groups" => "Invite an email in groups",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Including Group" => "Including Group",
// "Will list only the groups that include this group" => "Will list only the groups that include this group",
// "Dropdown list will show this group by default" => "Dropdown list will show this group by default",
// "Dropdown list will show the group related to this item ID (in group selector or creator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or creator field) by default",
// "Following mandatory fields are missing" => "Following mandatory fields are missing",
// "Jabber" => "Jabber",
// "PluginJabber" => "PluginJabber",
// "Runs a Java applet to access a local Jabber service" => "Runs a Java applet to access a local Jabber service",
// "Applet height in pixels" => "Applet height in pixels",
// "Applet width in pixels" => "Applet width in pixels",
// "XML Host Name" => "XML Host Name",
// "Web site where XML is hosted. Default is jabber.org" => "Web site where XML is hosted. Default is jabber.org",
// "Set default color. Default is 255,255,255" => "Set default color. Default is 255,255,255",
// "jQuery" => "jQuery",
// "PluginJQ" => "PluginJQ",
// "Inserts JavaScript code. By default this is only executed after jQuery determines that the DOM is fully loaded" => "Inserts JavaScript code. By default this is only executed after jQuery determines that the DOM is fully loaded",
// "JavaScript code" => "JavaScript code",
// "Not On Ready" => "Not On Ready",
// "No JavaScript" => "No JavaScript",
// "Optional markup for when JavaScript is off" => "Optional markup for when JavaScript is off",
// "Insert JQuery javascript code" => "Insert JQuery javascript code",
// "jquery code e.g. \$(\"img\\" => "jquery code e.g. \$(\"img\\",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "Javascript" => "Javascript",
// "PluginJS" => "PluginJS",
// "Insert a javascript file and/or some javascript code" => "Insert a javascript file and/or some javascript code",
// "javascript code" => "javascript code",
// "Javascript filename" => "Javascript filename",
// "Insert a javascript file or/and some javascript code" => "Insert a javascript file or/and some javascript code",
// "Kaltura video" => "Kaltura video",
// "PluginKaltura" => "PluginKaltura",
// "Displays a KALTURA video on the wiki page" => "Displays a KALTURA video on the wiki page",
// "Kaltura Entry ID" => "Kaltura Entry ID",
// "Kaltura entry ID of the video to be displayed" => "Kaltura entry ID of the video to be displayed",
// "PluginLang" => "PluginLang",
// "Displays the text only if the language matches" => "Displays the text only if the language matches",
// "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Displays the text only if the language matchs" => "Displays the text only if the language matchs",
// "PluginLastMod" => "PluginLastMod",
// "The Last Mod plugin displays the last modification time of the named wiki page, or the current page if no name given" => "The Last Mod plugin displays the last modification time of the named wiki page, or the current page if no name given",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given" => "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given",
// "PluginListpages" => "PluginListpages",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Limit number of items displayed in the list. Default is to display all" => "Limit number of items displayed in the list. Default is to display all",
// "Initial" => "Initial",
// "txt" => "txt",
// "Show only the page names" => "Show only the page names",
// "Category filter" => "Category filter",
// "If set to a category identifier, restrict the pages displayed to those in the specified category" => "If set to a category identifier, restrict the pages displayed to those in the specified category",
// "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories" => "If set to a list of category identifiers separated by colons (:), restrict the pages to those in any of the specified categories",
// "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories" => "If set to a list of category identifiers separated by plus signs (+), only display a page if it is in all of the specified categories",
// "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories" => "If set to a list of category identifiers separated by minus signs (-), only display a page if it is in the first specified category and not in any of the following categories",
// "Structure Head" => "Structure Head",
// "Filter by structure head" => "Filter by structure head",
// "Show Page Alias" => "Show Page Alias",
// "Show page alias in the list" => "Show page alias in the list",
// "Only pages with names similar the text entered for this parameter will be listed" => "Only pages with names similar the text entered for this parameter will be listed",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "User or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Page name and text entered for the filter parameter must match exactly to be listed" => "Page name and text entered for the filter parameter must match exactly to be listed",
// "Only Orphan Pages" => "Only Orphan Pages",
// "Only list orphan pages" => "Only list orphan pages",
// "For List Pages" => "For List Pages",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: " => "Sort ascending or descending on any field in the tiki_pages table. Syntax is field name followed by _asc or _desc. Example: ",
// "Length" => "Length",
// "Number of characters to display" => "Number of characters to display",
// "List Directory" => "List Directory",
// "PluginLsDir" => "PluginLsDir",
// "Lists files in a directory" => "Lists files in a directory",
// "Full path to the server-local directory. Default is the document root" => "Full path to the server-local directory. Default is the document root",
// "URL Prefix" => "URL Prefix",
// "Make the file name a link to the file by adding the url path preceding the file name. Example: http://yoursite.com/tiki/" => "Make the file name a link to the file by adding the url path preceding the file name. Example: http://yoursite.com/tiki/",
// "Set the sort order of the file list" => "Set the sort order of the file list",
// "File Name" => "File Name",
// "File Size" => "File Size",
// "Last Access" => "Last Access",
// "Last Metadata Change" => "Last Metadata Change",
// "Only list files with filenames that contain this filter. Example: \".jpg\"" => "Only list files with filenames that contain this filter. Example: \".jpg\"",
// "Limit" => "Limit",
// "Maximum amount of files to display. Default is no limit" => "Maximum amount of files to display. Default is no limit",
// "could not be opened because it doesn't exist or permission was denied" => "could not be opened because it doesn't exist or permission was denied",
// "Mail" => "Mail",
// "PluginMail" => "PluginMail",
// "Directly mail other users or groups" => "Directly mail other users or groups",
// "Limit the group to the groups including this group" => "Limit the group to the groups including this group",
// "Show Group Dropdown" => "Show Group Dropdown",
// "Show a dropdown list of groups (not shown by default)" => "Show a dropdown list of groups (not shown by default)",
// "Show User Dropdown" => "Show User Dropdown",
// "Show a dropdown list of users (not shown by default)" => "Show a dropdown list of users (not shown by default)",
// "User Autocomplete" => "User Autocomplete",
// "Show an autocomplete box on user name" => "Show an autocomplete box on user name",
// "Real Name Dropdown" => "Real Name Dropdown",
// "Show a dropdown list of user real names (not shown by default)" => "Show a dropdown list of user real names (not shown by default)",
// "PluginMap" => "PluginMap",
// "Displays a map" => "Displays a map",
// "Map File" => "Map File",
// "Map file identifier" => "Map file identifier",
// "Extents" => "Extents",
// "Size of the map" => "Size of the map",
// "Width of the map" => "Width of the map",
// "Height of the map" => "Height of the map",
// "Mayan Calendars Info" => "Mayan Calendars Info",
// "PluginMCalendarInfo" => "PluginMCalendarInfo",
// "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count" => "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count",
// "You must use the variable substitution" => "You must use the variable substitution",
// "LongCount: " => "LongCount: ",
// "Tzolkin: " => "Tzolkin: ",
// "Haab: " => "Haab: ",
// "Misc: " => "Misc: ",
// "Example: template " => "Example: template ",
// "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
// "Default template: " => "Default template: ",
// "Gregorian date" => "Gregorian date",
// "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date" => "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date",
// "Mayan Calendars" => "Mayan Calendars",
// " is not a valid date format. should be dd.mm.yyyy" => " is not a valid date format. should be dd.mm.yyyy",
// "Inline Flash mp3 and flv Player" => "Inline Flash mp3 and flv Player",
// "Mediaplayer" => "Mediaplayer",
// "PluginMediaplayer" => "PluginMediaplayer",
// "Simple mp3 or flv Player" => "Simple mp3 or flv Player",
// "Allow Fullscreen" => "Allow Fullscreen",
// "Allow fullscreen mode" => "Allow fullscreen mode",
// "MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "Complete URL to the media to include" => "Complete URL to the media to include",
// "Flash Window Mode" => "Flash Window Mode",
// "Sets the Window Mode property of the Flash movie. Transparent lets what\\'s behind the movie show through and allows the movie to be covered \n\t\t\t\t\t\t\t\t\t\t Opaque hides what\\'s behind the movie and Window plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what\\'s behind the movie show through and allows the movie to be covered \n\t\t\t\t\t\t\t\t\t\t Opaque hides what\\'s behind the movie and Window plays the movie in its own window. Default value: ",
// "Transparent" => "Transparent",
// "Opaque" => "Opaque",
// "Window" => "Window",
// "Member List" => "Member List",
// "PluginMemberList" => "PluginMemberList",
// "Lists the members of selected groups and allows to add or remove members if permissions are granted" => "Lists the members of selected groups and allows to add or remove members if permissions are granted",
// "List of groups to handle through the interface. Colon separated" => "List of groups to handle through the interface. Colon separated",
// "Member Payment" => "Member Payment",
// "PluginMemberPayment" => "PluginMemberPayment",
// "Receive payments from a member and extend the length of the membership to a group" => "Receive payments from a member and extend the length of the membership to a group",
// "Name of the group for which the subscription should be added or extended" => "Name of the group for which the subscription should be added or extended",
// "Price per period (%0)" => "Price per period (%0)",
// "Current User Member" => "Current User Member",
// "Membership only for the current user" => "Membership only for the current user",
// "Input Title" => "Input Title",
// "Title of the input form" => "Title of the input form",
// "Use %0 for the group name" => "Use %0 for the group name",
// "Supports wiki syntax" => "Supports wiki syntax",
// "How Title" => "How Title",
// "Use %0 for the group name, %4 for the number of days or %5 for the number of years" => "Use %0 for the group name, %4 for the number of days or %5 for the number of years",
// "Membership to %0 for %1 (x%2)" => "Membership to %0 for %1 (x%2)",
// "Membership to %0 for %1 users (x%2)" => "Membership to %0 for %1 users (x%2)",
// "The group " => "The group ",
// " does not have a membership term" => " does not have a membership term",
// " Go to " => " Go to ",
// "Admin > Groups" => "Admin > Groups",
// " to specify a term for this group by automatically unassigning users after a certain number of days" => " to specify a term for this group by automatically unassigning users after a certain number of days",
// " does not exist" => " does not exist",
// "Mini Quiz" => "Mini Quiz",
// "PluginMiniQuiz" => "PluginMiniQuiz",
// "Displays a miniquiz" => "Displays a miniquiz",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Numeric value representing the miniquiz tracker ID" => "Numeric value representing the miniquiz tracker ID",
// "Insert Module" => "Insert Module",
// "PluginModule" => "PluginModule",
// "Displays a module inline in a wiki page. More parameters can be added, not supported by User Interface" => "Displays a module inline in a wiki page. More parameters can be added, not supported by User Interface",
// "Module name as known in Tiki" => "Module name as known in Tiki",
// "Align the module to the left or right on the page allowing other elements to align against it" => "Align the module to the left or right on the page allowing other elements to align against it",
// "Decoration" => "Decoration",
// "Show box decorations (default is to show them)" => "Show box decorations (default is to show them)",
// "Add ability to show/hide the content of the module (default is the site admin setting for modules)" => "Add ability to show/hide the content of the module (default is the site admin setting for modules)",
// "Parse" => "Parse",
// "Parse wiki syntax (default is to parse)" => "Parse wiki syntax (default is to parse)",
// "Show/hide module title (default is to show the title)" => "Show/hide module title (default is to show the title)",
// "Show title" => "Show title",
// "Hide title" => "Hide title",
// "Monospace" => "Monospace",
// "PluginMono" => "PluginMono",
// "Displays the data using a monospace font" => "Displays the data using a monospace font",
// "Font" => "Font",
// "Font name as known in browsers" => "Font name as known in browsers",
// "PluginMouseover" => "PluginMouseover",
// "Create a mouseover feature on some text" => "Create a mouseover feature on some text",
// "Mouseover text if param label exists. Page text if text param exists" => "Mouseover text if param label exists. Page text if text param exists",
// "Text displayed on the page. The body is the mouseover content" => "Text displayed on the page. The body is the mouseover content",
// "Destination link when mouseover text is clicked. Use http:// for external links" => "Destination link when mouseover text is clicked. Use http:// for external links",
// "DEPRECATED" => "DEPRECATED",
// "Text displayed on the mouseover. The body contains the text of the page" => "Text displayed on the mouseover. The body contains the text of the page",
// "Mouseover box width. Default: 400px" => "Mouseover box width. Default: 400px",
// "Mouseover box height. Default: 200px" => "Mouseover box height. Default: 200px",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5" => "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5",
// "Offset Y" => "Offset Y",
// "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0" => "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0",
// "Parse Body" => "Parse Body",
// "Parse the body of the plugin as wiki content (parsed by default)" => "Parse the body of the plugin as wiki content (parsed by default)",
// "Parse Label" => "Parse Label",
// "Parse the label as wiki content (parsed by default)" => "Parse the label as wiki content (parsed by default)",
// "CSS class to apply" => "CSS class to apply",
// "Background color to apply to the popup" => "Background color to apply to the popup",
// "Text Color" => "Text Color",
// "Color to apply to the text in the popup" => "Color to apply to the text in the popup",
// "When enabled, popup stays visible until it is clicked" => "When enabled, popup stays visible until it is clicked",
// "Padding" => "Padding",
// "Padding size in pixels" => "Padding size in pixels",
// "Effect" => "Effect",
// "Set the type of show/hide animation that will be used" => "Set the type of show/hide animation that will be used",
// "Effect Speed" => "Effect Speed",
// "Set the speed of the animation" => "Set the speed of the animation",
// "Close Delay" => "Close Delay",
// "Number of seconds before popup closes" => "Number of seconds before popup closes",
// "No label specified" => "No label specified",
// "MWTable" => "MWTable",
// "PluginMWTable" => "PluginMWTable",
// "Displays a table using MediaWiki syntax (experimental - may change in future versions)" => "Displays a table using MediaWiki syntax (experimental - may change in future versions)",
// "Fancy" => "Fancy",
// "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)" => "Set to true to apply additional formatting to the table (header style, odd/even rows, etc.)",
// "True" => "True",
// "False" => "False",
// "Wiki Classes" => "Wiki Classes",
// "Determines whether wiki style classes will be used for the table and cells (used by default)" => "Determines whether wiki style classes will be used for the table and cells (used by default)",
// "Displays the data using (sort of) MediaWiki syntax" => "Displays the data using (sort of) MediaWiki syntax",
// "MySpace" => "MySpace",
// "PluginMySpace" => "PluginMySpace",
// "Displays a MySpace Flash mp3 playlist in the wiki page" => "Displays a MySpace Flash mp3 playlist in the wiki page",
// "MySpace Page" => "MySpace Page",
// "MySpace page name" => "MySpace page name",
// "Object Hits" => "Object Hits",
// "PluginObjectHits" => "PluginObjectHits",
// "Displays object hit info by object and days" => "Displays object hit info by object and days",
// "For a wiki page, the page name, for other object types: ID number + ? + object title" => "For a wiki page, the page name, for other object types: ID number + ? + object title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"" => "Object type, such as wiki, file gallery, file, article, etc. Default is \"wiki\"",
// "Show the number of hits over the past number of days indicated. Default is to show all hits" => "Show the number of hits over the past number of days indicated. Default is to show all hits",
// "Display a payment request\\'s details based on the user\\'s privileges and the state of the payment. The payment details may include the payment options" => "Display a payment request\\'s details based on the user\\'s privileges and the state of the payment. The payment details may include the payment options",
// "Payment Request Number" => "Payment Request Number",
// "Unique identifier of the payment request" => "Unique identifier of the payment request",
// "PluginPerm" => "PluginPerm",
// "Display wiki text if and only if the user has at least one of a set of permissions (or none, if using notperms)" => "Display wiki text if and only if the user has at least one of a set of permissions (or none, if using notperms)",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed if conditions are not met",
// "Possible Permissions" => "Possible Permissions",
// "Pipe separated list of permissions, one of which is needed to view the default text" => "Pipe separated list of permissions, one of which is needed to view the default text",
// "Forbidden Permissions" => "Forbidden Permissions",
// "Pipe separated list of permissions, any of which will cause the default text not to show" => "Pipe separated list of permissions, any of which will cause the default text not to show",
// "Display wiki text if user has one of listed permissions" => "Display wiki text if user has one of listed permissions",
// "Displays a list of plugins available in this wiki" => "Displays a list of plugins available in this wiki",
// "The module or plugin parameter must be set, but not both" => "The module or plugin parameter must be set, but not both",
// "^Plugin Manager error: " => "^Plugin Manager error: ",
// " not found" => " not found",
// "Plugin manager error: " => "Plugin manager error: ",
// "Introduced in Tiki version" => "Introduced in Tiki version",
// "Accepted Values" => "Accepted Values",
// "any string except for HTML and PHP tags" => "any string except for HTML and PHP tags",
// "Since" => "Since",
// "no parameters" => "no parameters",
// "Preferences required" => "Preferences required",
// "Required parameters are in</em> <b>bold</b>" => "Required parameters are in</em> <b>bold</b>",
// "Plugin Manager" => "Plugin Manager",
// "PluginPluginManager" => "PluginPluginManager",
// "Displays a list of plugins or modules available in this wiki" => "Displays a list of plugins or modules available in this wiki",
// "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none" => "Determines what information is shown. Values separated with | . Ignored when singletitle is set to top or none",
// "One or more of: description | parameters | paraminfo" => "One or more of: description | parameters | paraminfo",
// "Description & Parameters" => "Description & Parameters",
// "Description & Parameter Info" => "Description & Parameter Info",
// "Parameters & Parameter Info" => "Parameters & Parameter Info",
// "Plugin" => "Plugin",
// "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter" => "Name of a plugin (e.g., backlinks), or list separated by |, or range separated by \"-\". Single plugin can be used with limit parameter",
// "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter" => "Name of a module (e.g., calendar_new), or list separated by |, or range separated by \"-\". Single module can be used with limit parameter",
// "Single Title" => "Single Title",
// "Set placement of plugin name and description when displaying information for only one plugin" => "Set placement of plugin name and description when displaying information for only one plugin",
// "Title Heading" => "Title Heading",
// "Sets the heading size for the title, e.g., h2" => "Sets the heading size for the title, e.g., h2",
// "Start with this plugin record number (must be an integer 1 or greater)" => "Start with this plugin record number (must be an integer 1 or greater)",
// "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting point. Must be an integer 1 or greater",
// "PluginPoll" => "PluginPoll",
// "Displays the output of a poll, fields are indicated with numeric ids" => "Displays the output of a poll, fields are indicated with numeric ids",
// "Numeric value representing the poll ID" => "Numeric value representing the poll ID",
// "Show poll title (shown by default)" => "Show poll title (shown by default)",
// "missing poll ID for plugin POLL" => "missing poll ID for plugin POLL",
// "Profile application" => "Profile application",
// "Adds controls required to apply a profile" => "Adds controls required to apply a profile",
// "PluginProfile" => "PluginProfile",
// "Profile repository domain. Default value is profiles.tiki.org" => "Profile repository domain. Default value is profiles.tiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile to be applied" => "Name of the profile to be applied",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "Proposal" => "Proposal",
// "PluginProposal" => "PluginProposal",
// "Provides a widget for users to vote on a proposal and view the current decision" => "Provides a widget for users to vote on a proposal and view the current decision",
// "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username",
// "Short description of the proposal to vote on. Will be displayed above the result table" => "Short description of the proposal to vote on. Will be displayed above the result table",
// "Accept proposal" => "Accept proposal",
// "Still undecided" => "Still undecided",
// "Reject proposal" => "Reject proposal",
// "Quote" => "Quote",
// "PluginQuote" => "PluginQuote",
// "Quoted text" => "Quoted text",
// "Reply To" => "Reply To",
// "Name of the quoted person" => "Name of the quoted person",
// "wrote" => "wrote",
// "Quote text by surrounding the text with a box, like the [QUOTE] BBCode" => "Quote text by surrounding the text with a box, like the [QUOTE] BBCode",
// "RandomInclude" => "RandomInclude",
// "PluginRandomInclude" => "PluginRandomInclude",
// "Include a random page\\'s content" => "Include a random page\\'s content",
// "Include a random page" => "Include a random page",
// "PluginRcontent" => "PluginRcontent",
// "Numeric value representing the content ID" => "Numeric value representing the content ID",
// "User List (showing Real Name)" => "User List (showing Real Name)",
// "PluginRealNameList" => "PluginRealNameList",
// " (experimental, should be merged with UserList in Tiki5)" => " (experimental, should be merged with UserList in Tiki5)",
// "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text will be included in the list. If empty all site users will be included",
// "String to use between elements of the list if table layout is not used" => "String to use between elements of the list if table layout is not used",
// "Result limit" => "Result limit",
// "Set to sort in ascending or descending order (unsorted by default" => "Set to sort in ascending or descending order (unsorted by default",
// "Layout" => "Layout",
// "Set to table to show results in a table (not shown in a table by default)" => "Set to table to show results in a table (not shown in a table by default)",
// "Make the listed names links to various types of user information" => "Make the listed names links to various types of user information",
// "User Page" => "User Page",
// "Exclude" => "Exclude",
// "Exclude certain test or admin names from the list" => "Exclude certain test or admin names from the list",
// "admin-test" => "admin-test",
// "test" => "test",
// "test-admin" => "test-admin",
// "Displays a list of users showing their real name" => "Displays a list of users showing their real name",
// "Displays a list of registered users showing their Real Names" => "Displays a list of registered users showing their Real Names",
// "PluginRedirect" => "PluginRedirect",
// "Redirect the user to a wiki page or generic URL" => "Redirect the user to a wiki page or generic URL",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "Redirects you to another wiki page" => "Redirects you to another wiki page",
// "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page",
// "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. ",
// "REDIRECT plugin: redirect loop detected" => "REDIRECT plugin: redirect loop detected",
// "Regular Expression" => "Regular Expression",
// "PluginRegex" => "PluginRegex",
// "Takes regex expressions and parses the content between REGEX tags and replaces the text" => "Takes regex expressions and parses the content between REGEX tags and replaces the text",
// "Each line of content is evaluated separately" => "Each line of content is evaluated separately",
// "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text" => "Name of page containing search and replace expressions separated by two colons. Example of syntax on that page: /search pattern/::replacement text",
// "Takes regex expressions and parses the content between the REGEX tags and replaces the text" => "Takes regex expressions and parses the content between the REGEX tags and replaces the text",
// "one data per line" => "one data per line",
// "Displays a comment, tip, note or warning box" => "Displays a comment, tip, note or warning box",
// "remarks text" => "remarks text",
// "Remarks Box" => "Remarks Box",
// "PluginRemarksBox" => "PluginRemarksBox",
// "Select type of remarksbox, which determines what icon and style will be displayed" => "Select type of remarksbox, which determines what icon and style will be displayed",
// "Confirm" => "Confirm",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Highlight" => "Highlight",
// "Use the highlight class for formatting (not used by default)" => "Use the highlight class for formatting (not used by default)",
// "Custom Icon" => "Custom Icon",
// "Enter a Tiki icon file name (with or without extension) or path to display a custom icon" => "Enter a Tiki icon file name (with or without extension) or path to display a custom icon",
// "Show a close button (not shown by default)" => "Show a close button (not shown by default)",
// "Width (e.g. 100% or 250px - default \"\")" => "Width (e.g. 100% or 250px - default \"\")",
// "RSS Feed" => "RSS Feed",
// "PluginRSS" => "PluginRSS",
// "Inserts an RSS feed output" => "Inserts an RSS feed output",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: feedId:feedId2" => "List of feed IDs separated by colons. ex: feedId:feedId2",
// "Result Count" => "Result Count",
// "Number of results displayed" => "Number of results displayed",
// "Show date of each item (not shown by default)" => "Show date of each item (not shown by default)",
// "Show feed descriptions (not shown by default)" => "Show feed descriptions (not shown by default)",
// "Show authors (not shown by default)" => "Show authors (not shown by default)",
// "Icon" => "Icon",
// "Url to a favicon to put before each entry" => "Url to a favicon to put before each entry",
// "Show the title of the feed (shown by default)" => "Show the title of the feed (shown by default)",
// "Scroll" => "Scroll",
// "PluginScroll" => "PluginScroll",
// "'),\n\t\t'prefs' => array('wikiplugin_scroll" => "'),\n\t\t'prefs' => array('wikiplugin_scroll",
// "Width in pixels. Example: 600px" => "Width in pixels. Example: 600px",
// "Number of pixels followed by \"px\". Example: 600px" => "Number of pixels followed by \"px\". Example: 600px",
// "Height in pixels. Example: 450px" => "Height in pixels. Example: 450px",
// "Number of pixels followed by \"px\". Example: 450px" => "Number of pixels followed by \"px\". Example: 450px",
// "Scroll speed in number of seconds (default is 8 seconds)" => "Scroll speed in number of seconds (default is 8 seconds)",
// "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests" => "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests",
// "SourceForge" => "SourceForge",
// "PluginSF" => "PluginSF",
// "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests) with the title of the item as the link text" => "Creates a link to SourceForge tracker items (bugs, fetaure requests, patches and support requests) with the title of the item as the link text",
// "Group ID" => "Group ID",
// "SourceForge project ID (shows as group_id in the url of a tracker item" => "SourceForge project ID (shows as group_id in the url of a tracker item",
// "SourceForge tracker ID (shows as atid in the url of a tracker item" => "SourceForge tracker ID (shows as atid in the url of a tracker item",
// "SourceForge item ID (shows as aid in the url of a tracker item" => "SourceForge item ID (shows as aid in the url of a tracker item",
// "First part of link tooltip identifying the type of tracker item (bog, feature request, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bog, feature request, patch or support request)",
// "Sharethis" => "Sharethis",
// "Display a social networking tool" => "Display a social networking tool",
// "Send Services" => "Send Services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "Aim" => "Aim",
// "Aim \$ Email" => "Aim \$ Email",
// "Aim \$ Sms" => "Aim \$ Sms",
// "Email \$ Sms" => "Email \$ Sms",
// "Button Style" => "Button Style",
// "Set button style: horizontal, vertical or rotate" => "Set button style: horizontal, vertical or rotate",
// "Rotate" => "Rotate",
// "Rotate Image" => "Rotate Image",
// "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y (Yes) will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Multiple Icons" => "Multiple Icons",
// "Enter list: email | facebook | twitter | sharethis, depending on which icons you\\'d like" => "Enter list: email | facebook | twitter | sharethis, depending on which icons you\\'d like",
// "First Services Shown" => "First Services Shown",
// "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Button Text" => "Button Text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header Title" => "Header Title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header Background" => "Header Background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header Text Color" => "Header Text Color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
// "Pop-up" => "Pop-up",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded Elements" => "Embedded Elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Display data from a TikiSheet" => "Display data from a TikiSheet",
// "Sheet Heading" => "Sheet Heading",
// "Internal ID of the TikiSheet.  Either id or url MUST be used" => "Internal ID of the TikiSheet.  Either id or url MUST be used",
// "Sheet Url Location" => "Sheet Url Location",
// "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used" => "Internal URL of the Table to use as a spreadsheet.  Either id or url MUST be used",
// "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)" => "Simple table view y/n (Default: n = jquery.sheet view if feature enabled)",
// "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"" => "Width in pixels or percentage. Default value is page width. e.g. \"200px\" or \"100%\"",
// "Height in pixels or percentage. Default value is complete spreadsheet height" => "Height in pixels or percentage. Default value is complete spreadsheet height",
// "Editable" => "Editable",
// "Show edit button. Default \\'y\\' depending on user\\'s permissions" => "Show edit button. Default \\'y\\' depending on user\\'s permissions",
// "Show subsheets" => "Show subsheets",
// "y/n. Show multi-sheets. Default \\'y\\'" => "y/n. Show multi-sheets. Default \\'y\\'",
// "Range" => "Range",
// "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"" => "Show a range of cells (or single cell). Default shows all. e.g. \"D1:F3\" or \"e14:e14\"",
// "Apply custom CSS class to the containing div" => "Apply custom CSS class to the containing div",
// "New sheet in page: " => "New sheet in page: ",
// "Incomplete call to plugin: No target sheet" => "Incomplete call to plugin: No target sheet",
// "Create New Sheet" => "Create New Sheet",
// "PluginShowPages" => "PluginShowPages",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "Display page name and/or description. Both displayed by default" => "Display page name and/or description. Both displayed by default",
// "Name & Description" => "Name & Description",
// "Skype" => "Skype",
// "PluginSkype" => "PluginSkype",
// "Clickable Skype link" => "Clickable Skype link",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Set whether to call or chat. Default is chat" => "Set whether to call or chat. Default is chat",
// "Call" => "Call",
// "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles" => "Configure a slideshow. Extends the existing wiki page slideshow with notes & styles",
// "Slideshow notes - Separate with \"/////\"" => "Slideshow notes - Separate with \"/////\"",
// "The side on which you would like to display text if there are images that are resized or present" => "The side on which you would like to display text if there are images that are resized or present",
// "Tiki jQuery UI Theme" => "Tiki jQuery UI Theme",
// "Background Url Location" => "Background Url Location",
// "URL of the background image to use in your slideshow, overrides backgroundcolor" => "URL of the background image to use in your slideshow, overrides backgroundcolor",
// "Valid url" => "Valid url",
// "Background color to use in your slideshow, default " => "Background color to use in your slideshow, default ",
// "Any valid CSS class" => "Any valid CSS class",
// "Header font color" => "Header font color",
// "Apply a color to the headers of your slideshow" => "Apply a color to the headers of your slideshow",
// "Any html color" => "Any html color",
// "Header background color" => "Header background color",
// "Slide font color" => "Slide font color",
// "Apply a color to the slides of your slideshow" => "Apply a color to the slides of your slideshow",
// "Line Item highlight color" => "Line Item highlight color",
// "Apply a color to the line item when mouse over" => "Apply a color to the line item when mouse over",
// "Slide Seconds" => "Slide Seconds",
// "How many seconds a slide will be open while playing" => "How many seconds a slide will be open while playing",
// "Second count" => "Second count",
// "Text Side" => "Text Side",
// "Smarty function" => "Smarty function",
// "PluginSmarty" => "PluginSmarty",
// "Provides access to the tiki smarty functions like button" => "Provides access to the tiki smarty functions like button",
// "Smarty Function" => "Smarty Function",
// "The name of the smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php" => "The name of the smarty function that the button will activate. Available functions are: lib/smarty/libs/plugins/function.[name].php",
// "Snarf" => "Snarf",
// "PluginSnarf" => "PluginSnarf",
// "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified" => "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified",
// "Full URL to the page to include" => "Full URL to the page to include",
// "Regular Expression Pattern" => "Regular Expression Pattern",
// "PCRE-compliant regular expression pattern to find the parts you want changed" => "PCRE-compliant regular expression pattern to find the parts you want changed",
// "Regular Expression Replacement" => "Regular Expression Replacement",
// "PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "PCRE-compliant regular expression replacement syntax showing what the content should be changed to",
// "Enable/disable word wrapping of snippets of code (enabled by default)" => "Enable/disable word wrapping of snippets of code (enabled by default)",
// "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use for code snippets. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)" => "Set to 1 (Yes) to add line numbers to code snippets (not shown by default)",
// "Switch the text display from left to right to right to left" => "Switch the text display from left to right to right to left",
// "HTML Content" => "HTML Content",
// "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)" => "Set to 1 (Yes) to display the content as is instead of escaping HTML special chars (not set by default)",
// "Cache Url" => "Cache Url",
// "Cache time in minutes. Default is to use site preference, Set to 0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to 0 for no cache",
// "Text to click on to fetch the url via ajax" => "Text to click on to fetch the url via ajax",
// "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace" => "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace",
// "This data is put in a CODE caption" => "This data is put in a CODE caption",
// "PluginSort" => "PluginSort",
// "Sorts the plugin content in the wiki page" => "Sorts the plugin content in the wiki page",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
// "Set the sort order of lines of content (default is ascending)" => "Set the sort order of lines of content (default is ascending)",
// "Reverse" => "Reverse",
// "Shuffle" => "Shuffle",
// "PluginSplit" => "PluginSplit",
// "Split a page into rows and columns" => "Split a page into rows and columns",
// "Join Columns" => "Join Columns",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute for the columns" => "Generate the width attribute for the columns",
// "Column Sizes" => "Column Sizes",
// "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)" => "Specify all column widths in number of pixels or percent, separating each width by a pipe (|)",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
// "Display edit icon for each section" => "Display edit icon for each section",
// "Custom Class" => "Custom Class",
// "Add a class to customize the design" => "Add a class to customize the design",
// "PluginSQL" => "PluginSQL",
// "Run an SQL query on a database" => "Run an SQL query on a database",
// "The SQL query goes in the body. Example: SELECT column1, column2 FROM table" => "The SQL query goes in the body. Example: SELECT column1, column2 FROM table",
// "DSN Name" => "DSN Name",
// "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php" => "DSN name of the database being queried. The DSN name needs to first be defined at tiki-admin_dsn.php",
// "Could not obtain valid DSN connection" => "Could not obtain valid DSN connection",
// "Stat" => "Stat",
// "PluginStat" => "PluginStat",
// "Displays statistics for articles, wiki pages and tracker items" => "Displays statistics for articles, wiki pages and tracker items",
// "Object Type" => "Object Type",
// "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons" => "Object type to show stats for. Choices are article, trackeritem or wiki, or a combination of these separated by colons",
// "Article & Tracker Item" => "Article & Tracker Item",
// "Article & Tracker Item & Wiki" => "Article & Tracker Item & Wiki",
// "Article & Wiki" => "Article & Wiki",
// "Article & Wiki & Tracker Item" => "Article & Wiki & Tracker Item",
// "Tracker Item & Article" => "Tracker Item & Article",
// "Tracker Item & Article & Wiki" => "Tracker Item & Article & Wiki",
// "Tracker Item & Wiki" => "Tracker Item & Wiki",
// "Tracker Item & Wiki & Article" => "Tracker Item & Wiki & Article",
// "Wiki & Article" => "Wiki & Article",
// "Wiki & Article & Tracker Item" => "Wiki & Article & Tracker Item",
// "Wiki & Tracker Item" => "Wiki & Tracker Item",
// "Wiki & Tracker Item & Article" => "Wiki & Tracker Item & Article",
// "Parent ID" => "Parent ID",
// "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)",
// "Last 24 Hours" => "Last 24 Hours",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Added and Viewed" => "Added and Viewed",
// "Viewed" => "Viewed",
// "Viewed & Added" => "Viewed & Added",
// "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last 7 Days" => "Last 7 Days",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Week" => "This Week",
// "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Month" => "Last Month",
// "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Month" => "This Month",
// "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Last Year" => "Last Year",
// "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "This Year" => "This Year",
// "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for tracker items whether a (added) or v (viewed) or both is set)",
// "Incorrect parameter: " => "Incorrect parameter: ",
// "Subscript" => "Subscript",
// "PluginSub" => "PluginSub",
// "Displays text in subscript" => "Displays text in subscript",
// "Subscribe or unsubscribe to a group" => "Subscribe or unsubscribe to a group",
// "PluginSubscribeGroup" => "PluginSubscribeGroup",
// "text displyed before the button" => "text displyed before the button",
// "Group name to subscribe to or unsubscribe from" => "Group name to subscribe to or unsubscribe from",
// "Subscribe Text" => "Subscribe Text",
// "Subscribe text, containing %s as the placeholder for the group name" => "Subscribe text, containing %s as the placeholder for the group name",
// "Unsubscribe Text" => "Unsubscribe Text",
// "Unsubscribe text, containing %s as the placeholder for the group name" => "Unsubscribe text, containing %s as the placeholder for the group name",
// "Unsubscribe" => "Unsubscribe",
// "Subscribe Action" => "Subscribe Action",
// "Subscribe button label, containing %s as the placeholder for the group name" => "Subscribe button label, containing %s as the placeholder for the group name",
// "Unsubscribe Action" => "Unsubscribe Action",
// "Unsubscribe button label, containing %s as the placeholder for the group name" => "Unsubscribe button label, containing %s as the placeholder for the group name",
// "Subscribe Groups" => "Subscribe Groups",
// "PluginSubscribeGroups" => "PluginSubscribeGroups",
// "Text shown in the dropdown box. Default: \"Subscribe to a group\"" => "Text shown in the dropdown box. Default: \"Subscribe to a group\"",
// "Show Subscribe Box" => "Show Subscribe Box",
// "Show the subscribe drop down box (shown by default). Will not show if there are no other groups the user may register for" => "Show the subscribe drop down box (shown by default). Will not show if there are no other groups the user may register for",
// "Show Default" => "Show Default",
// "Shows which group is the user\\'s default group (if any) and allows the user to change his default group" => "Shows which group is the user\\'s default group (if any) and allows the user to change his default group",
// "Group Description" => "Group Description",
// "Show the description of the group (not shown by default)" => "Show the description of the group (not shown by default)",
// "Colon separated list of groups. By default the list of groups available to the user" => "Colon separated list of groups. By default the list of groups available to the user",
// "All groups including this group will be listed" => "All groups including this group will be listed",
// "Default URL" => "Default URL",
// "Page user will be directed to after clicking on icon to change default group" => "Page user will be directed to after clicking on icon to change default group",
// "You do not have permission to subscribe to groups" => "You do not have permission to subscribe to groups",
// "Subscribe newsletter" => "Subscribe newsletter",
// "PluginSubscribeNewsletter" => "PluginSubscribeNewsletter",
// "A button to subscribe to a newsletter available for a user if not already in" => "A button to subscribe to a newsletter available for a user if not already in",
// "Invitation message" => "Invitation message",
// "Newsletter ID" => "Newsletter ID",
// "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to" => "Identification number (nlId) of the Newsletter that you want to allow the users to subscribe to",
// "Confirmation Message" => "Confirmation Message",
// "Confirmation message after posting form. The plugin body is then the button label" => "Confirmation message after posting form. The plugin body is then the button label",
// "Button label. The plugin body is then the confirmation message" => "Button label. The plugin body is then the confirmation message",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
// "Already subscribed" => "Already subscribed",
// "Superscript" => "Superscript",
// "PluginSup" => "PluginSup",
// "Displays text in superscript (exponent)" => "Displays text in superscript (exponent)",
// "Displays text in superscript" => "Displays text in superscript",
// "PluginSurvey" => "PluginSurvey",
// "Displays a survey" => "Displays a survey",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Tabs" => "Tabs",
// "PluginTabs" => "PluginTabs",
// "Display page content in a set of tabs" => "Display page content in a set of tabs",
// "Tabs content separated by /////" => "Tabs content separated by /////",
// "Tabset Name" => "Tabset Name",
// "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs" => "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs",
// "Tab Titles" => "Tab Titles",
// "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3" => "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3",
// "Displays a set of tabs" => "Displays a set of tabs",
// "No tab title specified. At least one has to be set to make the tabs appear" => "No tab title specified. At least one has to be set to make the tabs appear",
// "Tag" => "Tag",
// "PluginTag" => "PluginTag",
// "Displays the text between an html tag" => "Displays the text between an html tag",
// "Any valid HTML tag, span by default" => "Any valid HTML tag, span by default",
// "CSS Style" => "CSS Style",
// "Equivalent to the style attribute of an HTML tag" => "Equivalent to the style attribute of an HTML tag",
// "Displays text between HTML tags" => "Displays text between HTML tags",
// "Title Search" => "Title Search",
// "PluginTitleSearch" => "PluginTitleSearch",
// "Search wiki page titles" => "Search wiki page titles",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "Also show page hits or user" => "Also show page hits or user",
// "Pipe-separated list of page names to exclude from results" => "Pipe-separated list of page names to exclude from results",
// "No Header" => "No Header",
// "Set to 1 (Yes) to have no header for the search results" => "Set to 1 (Yes) to have no header for the search results",
// "No pages found for title search" => "No pages found for title search",
// "One page found for title search" => "One page found for title search",
// "pages found for title search" => "pages found for title search",
// "Table of Contents (Structure)" => "Table of Contents (Structure)",
// "PluginTOC" => "PluginTOC",
// "Displays the table of contents for the current structure\\'s subtree as part of the page content" => "Displays the table of contents for the current structure\\'s subtree as part of the page content",
// "Maximum Depth" => "Maximum Depth",
// "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)" => "Maximum number of levels to display. On very large structures, this should be limited. Zero means no limit (and is the default)",
// "By default, structure for the current page will be displayed. Alternate structure may be provided" => "By default, structure for the current page will be displayed. Alternate structure may be provided",
// "Order items in ascending or descending order (deafult is ascending)" => "Order items in ascending or descending order (deafult is ascending)",
// "Show the page description instead of the page name" => "Show the page description instead of the page name",
// "Show Numbering" => "Show Numbering",
// "Display the section numbers or not" => "Display the section numbers or not",
// "Apply the \"plain\" or \"fancy\" style" => "Apply the \"plain\" or \"fancy\" style",
// "By default, the table of contents for the current page will be displayed. Alternate page may be provided" => "By default, the table of contents for the current page will be displayed. Alternate page may be provided",
// "Top Friends" => "Top Friends",
// "PluginTopFriends" => "PluginTopFriends",
// "List top-scoring users" => "List top-scoring users",
// "Maximum result count" => "Maximum result count",
// "Set whether public or not" => "Set whether public or not",
// "PluginTR" => "PluginTR",
// "Translate a string using Tiki translation table" => "Translate a string using Tiki translation table",
// "string" => "string",
// "Translate a string" => "Translate a string",
// "PluginTracker" => "PluginTracker",
// "Numeric value representing the tracker ID" => "Numeric value representing the tracker ID",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5",
// "Label on the submit button. Default is \"Save\"" => "Label on the submit button. Default is \"Save\"",
// "Display the title of the tracker (not shown by default)" => "Display the title of the tracker (not shown by default)",
// "Show the tracker\\'s description (not shown by default)" => "Show the tracker\\'s description (not shown by default)",
// "Mark Mandatory" => "Mark Mandatory",
// "Indicate mandatory fields with an asterisk (shown by default)" => "Indicate mandatory fields with an asterisk (shown by default)",
// "Show Status" => "Show Status",
// "Show the status of the items (not shown by default)" => "Show the status of the items (not shown by default)",
// "Embedded" => "Embedded",
// "To send an email once the tracker item has been created. Format: from" => "To send an email once the tracker item has been created. Format: from",
// "Email format" => "Email format",
// "Text or html setting" => "Text or html setting",
// "URL the user is sent to after the form is submitted" => "URL the user is sent to after the form is submitted",
// "Url Target" => "Url Target",
// "Set the target parameter for the url (determines whether target will open in a new pge, etc" => "Set the target parameter for the url (determines whether target will open in a new pge, etc",
// "Self" => "Self",
// "Values" => "Values",
// "Colon-separated list of default values.for the fields. First value corresponds to first field, second value to second field, etc" => "Colon-separated list of default values.for the fields. First value corresponds to first field, second value to second field, etc",
// "Overwrite current field values of the item with the input values" => "Overwrite current field values of the item with the input values",
// "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default" => "Display columns in the order listed in the fields parameter instead of by field ID (field ID order is used by default",
// "Label for the preview button. Default" => "Label for the preview button. Default",
// "Label for the reset button, to return all fields to their default values" => "Label for the reset button, to return all fields to their default values",
// "reset" => "reset",
// "Status of the item used in combination with" => "Status of the item used in combination with",
// "ItemId allowing for editing an item" => "ItemId allowing for editing an item",
// "Ignore ItemId" => "Ignore ItemId",
// "Do not filter on the parameter itemId if in the url" => "Do not filter on the parameter itemId if in the url",
// "Template File" => "Template File",
// "Name of the template used to display the tracker items" => "Name of the template used to display the tracker items",
// "Name of the wiki page containing the template to display the tracker items" => "Name of the wiki page containing the template to display the tracker items",
// "Default status applied to newly created items" => "Default status applied to newly created items",
// "Specify the width in pixels or percentage of the first column (the labels) in the tracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the tracker form",
// "Autosave fields" => "Autosave fields",
// "Colon-separated list of field IDs to be automatically filled with values" => "Colon-separated list of field IDs to be automatically filled with values",
// "Autosavevalue" => "Autosavevalue",
// "Colon-separated values corresponding to autosavefields" => "Colon-separated values corresponding to autosavefields",
// "Registration Fields" => "Registration Fields",
// "Add registration fields such as Username and Password" => "Add registration fields such as Username and Password",
// "Output To Wiki" => "Output To Wiki",
// "Output result to a new wiki page with the name taken from the input for the specified fieldId" => "Output result to a new wiki page with the name taken from the input for the specified fieldId",
// "Discard After Output" => "Discard After Output",
// "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created" => "Used when results are output to a wiki page to discard the tracker item itself once the wiki page is created",
// "Template Page" => "Template Page",
// "Name of the wiki page containing the template to format the output to wiki page" => "Name of the wiki page containing the template to format the output to wiki page",
// "Embed the tracker in a form tag" => "Embed the tracker in a form tag",
// "If set to Yes, the tracker is contained in a <form> tag and has action buttons" => "If set to Yes, the tracker is contained in a <form> tag and has action buttons",
// "The page to output the results to already exists. Try another name" => "The page to output the results to already exists. Try another name",
// "Incorrect fieldId" => "Incorrect fieldId",
// "Displays an input form for tracker submit" => "Displays an input form for tracker submit",
// "You do not have permission to insert an item" => "You do not have permission to insert an item",
// "You do not have permission to modify an item" => "You do not have permission to modify an item",
// "The page to output the results to contains the following prohibited characters: \$page_badchars_display. Try another name" => "The page to output the results to contains the following prohibited characters: \$page_badchars_display. Try another name",
// "Invalid email" => "Invalid email",
// "Passwords do not match" => "Passwords do not match",
// "Fields marked with a * are mandatory" => "Fields marked with a * are mandatory",
// "Tracker Comments" => "Tracker Comments",
// "Displays the number of tracker comments" => "Displays the number of tracker comments",
// "Item Count" => "Item Count",
// "Determines whether the number of items will be shown (not shown by default)" => "Determines whether the number of items will be shown (not shown by default)",
// "Enter a user name to select the items of the current user" => "Enter a user name to select the items of the current user",
// "a user name" => "a user name",
// "Comments found" => "Comments found",
// "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / \n\t\t\t\t\t\t\t\t and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown;\n\t\t\t\t\t\t\t\t c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= -\n\t\t\t\t\t\t\t\t greater than, less than, greater than or equal, less than or equal. Example" => "The list of fields that can be used as filters along with their formats. The field number and format are separated by a / \n\t\t\t\t\t\t\t\t and multile fields are separated by \":\". Format choices are: d - dropdown; r - radio buttons; m - multiple choice dropdown;\n\t\t\t\t\t\t\t\t c - checkbox; t - text with wild characters; T - exact text match; i - initials; sqlsearch - advanced search; >, <, >=, <= -\n\t\t\t\t\t\t\t\t greater than, less than, greater than or equal, less than or equal. Example",
// "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)" => "Label on the submit button. Default: \"Filter\". Use a space character to omit the button (for use in datachannels etc)",
// "Display List" => "Display List",
// "Show the full list (before filtering) initially (filtered list shown by default)" => "Show the full list (before filtering) initially (filtered list shown by default)",
// "Displays all the filters on the same line (not shown on same line by default)" => "Displays all the filters on the same line (not shown on same line by default)",
// "No Toggle" => "No Toggle",
// "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle" => "The toggle button to show/hide filters will not be shown if set to y (Yes). Default is to show the toggle",
// "Export CSV" => "Export CSV",
// "Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "Label for an export button. Leave blank to show the usual \"Filter\" button instead",
// "Google Map Buttons" => "Google Map Buttons",
// "Display Mapview and Listview buttons" => "Display Mapview and Listview buttons",
// "Tracker Filter" => "Tracker Filter",
// "PluginTrackerFilter" => "PluginTrackerFilter",
// "Filters the items of a tracker, fields are indicated with numeric ids" => "Filters the items of a tracker, fields are indicated with numeric ids",
// "tracker field type not processed yet" => "tracker field type not processed yet",
// "Tracker Item Field" => "Tracker Item Field",
// "PluginTrackerItemField" => "PluginTrackerItemField",
// "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)" => "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)",
// "Wiki text containing an {ELSE} marker" => "Wiki text containing an {ELSE} marker",
// "Numeric value representing the item ID. Default is the user tracker item for the current user" => "Numeric value representing the item ID. Default is the user tracker item for the current user",
// "Field ID" => "Field ID",
// "Numeric value representing the field ID displayed or tested" => "Numeric value representing the field ID displayed or tested",
// "Colon separated list of field IDs. Default is all fields" => "Colon separated list of field IDs. Default is all fields",
// "Status of the tracker item" => "Status of the tracker item",
// "Open & Pending" => "Open & Pending",
// "Open & Closed" => "Open & Closed",
// "Pending & Closed" => "Pending & Closed",
// "Open, Pending & Closed" => "Open, Pending & Closed",
// "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter" => "Set to 1 (Yes) to test whether a field is empty (if value parameter is empty) or has a value the same as the value parameter",
// "Value to compare against" => "Value to compare against",
// "Tracker List" => "Tracker List",
// "PluginTrackerList" => "PluginTrackerList",
// "Displays the output of a tracker content, fields are indicated with numeric ids" => "Displays the output of a tracker content, fields are indicated with numeric ids",
// "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs for the fields to be displayed. Example: 2:4:5",
// "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7" => "Colon-separated list of fields which will display in a tooltip on mouse over. Example: 6:7",
// "Sticky Popup" => "Sticky Popup",
// "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the tooltip will stay displayed on mouse out (does not stay open by default)",
// "Show Links" => "Show Links",
// "Show links to each tracker item (not shown by default)" => "Show links to each tracker item (not shown by default)",
// "Show Item Count" => "Show Item Count",
// "Show the number of items found (not shown by default)" => "Show the number of items found (not shown by default)",
// "Show Initials" => "Show Initials",
// "Show an alphabetical index by first letter to assist in navigation (not shown by default)" => "Show an alphabetical index by first letter to assist in navigation (not shown by default)",
// "Creation date display is based on tracker settings unless overriden here" => "Creation date display is based on tracker settings unless overriden here",
// "Last Modification Date" => "Last Modification Date",
// "Last modification date display is based on tracker settings unless overriden here" => "Last modification date display is based on tracker settings unless overriden here",
// "Show Field Name" => "Show Field Name",
// "Use the field names as column titles (used by default)" => "Use the field names as column titles (used by default)",
// "Show Item Rank" => "Show Item Rank",
// "Show item ranks (not shown by default)" => "Show item ranks (not shown by default)",
// "Status Filter" => "Status Filter",
// "Only show items matching certain status filters (only items with open status shown by default)" => "Only show items matching certain status filters (only items with open status shown by default)",
// "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: " => "Sort rows in ascending or descending order based on field ID, date created or date last modified using these values: ",
// "(replacing fieldId with the field ID number)" => "(replacing fieldId with the field ID number)",
// "Sort Choice" => "Sort Choice",
// "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first" => "Add a dropdown of sorting choices. Example with two sorting choices: created_desc|Newest first: lastModif_desc|Last modified first",
// "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set" => "Maximum number of items to display or -1 for all values. Defaults to max records preference, if set",
// "Offset of first item. Default is no offset" => "Offset of first item. Default is no offset",
// "Show Pagination" => "Show Pagination",
// "Determines whether pagination will be shown (shown by default)" => "Determines whether pagination will be shown (shown by default)",
// "Filter Field" => "Filter Field",
// "Colon separated list of fields to allow filtering on" => "Colon separated list of fields to allow filtering on",
// "Filter Value" => "Filter Value",
// "Filter value of the filterfield. For better performance, use exactvalue instead" => "Filter value of the filterfield. For better performance, use exactvalue instead",
// "Exact Value" => "Exact Value",
// "Exact value of the filter" => "Exact value of the filter",
// "Checkbox" => "Checkbox",
// "Adds a checkbox on each line to be able to do an action" => "Adds a checkbox on each line to be able to do an action",
// "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown" => "e.g. fieldId/postName/Title/Submit/ActionUrl/tpl/radio|dropdown",
// "goIfOne" => "goIfOne",
// "Go directly to tiki-view_tracker_item.php if only one item is found" => "Go directly to tiki-view_tracker_item.php if only one item is found",
// "Show a \\'more\\' button that links to tiki-view_tracker.php (not shown by default)" => "Show a \\'more\\' button that links to tiki-view_tracker.php (not shown by default)",
// "More URL" => "More URL",
// "More link pointing to specified URL instead of default tracker item link" => "More link pointing to specified URL instead of default tracker item link",
// "Display only the items of the current user or the current page name" => "Display only the items of the current user or the current page name",
// "Use content of the tpl file as template to display the item" => "Use content of the tpl file as template to display the item",
// "Wiki Page" => "Wiki Page",
// "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "Template file in a Wiki page" => "Template file in a Wiki page",
// "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins" => "Use content of the wiki page as template to display the item but with as little parsing on the content as with a tpl on disk. The page should have the permission tiki_p_use_as_template set, and that page should be only open for edition to fully trusted users such as other site admins",
// "View User" => "View User",
// "Will display the items of the specified user" => "Will display the items of the specified user",
// "Item ID separated with " => "Item ID separated with ",
// "To restrict the list to these item IDs" => "To restrict the list to these item IDs",
// "Ignore the itemId url parameter when filtering list (not ignored by default)" => "Ignore the itemId url parameter when filtering list (not ignored by default)",
// "The link that will be on each main field" => "The link that will be on each main field",
// "Left Deliminator" => "Left Deliminator",
// "Smarty left delimiter for Latex generation" => "Smarty left delimiter for Latex generation",
// "Right Deliminator" => "Right Deliminator",
// "Smarty right delimiter for Latex generation" => "Smarty right delimiter for Latex generation",
// "List Mode" => "List Mode",
// "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outpits without any HTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values (default); \n\t\t\t\t\t\t\t\t\t\tNo (n) displays in tracker item view; Comma Separated Values (csv) outpits without any HTML formatting",
// "Comma Separated Values" => "Comma Separated Values",
// "Export Button" => "Export Button",
// "Show an export button (not shown by default)" => "Show an export button (not shown by default)",
// "Compute" => "Compute",
// "Sum or average all the values of a field and displays it at the bottom of the table" => "Sum or average all the values of a field and displays it at the bottom of the table",
// "fieldId" => "fieldId",
// "Silent" => "Silent",
// "Show nothing if no items found (the table header and a \\'No records found\\' message is shown by default)" => "Show nothing if no items found (the table header and a \\'No records found\\' message is shown by default)",
// "Show Delete" => "Show Delete",
// "Show a delete option (not shown by default)" => "Show a delete option (not shown by default)",
// "Show Watch Button" => "Show Watch Button",
// "Show a watch button (not shown by default)" => "Show a watch button (not shown by default)",
// "Show Feed Button" => "Show Feed Button",
// "Show an RSS feed button (not shown by default)" => "Show an RSS feed button (not shown by default)",
// "Show Google Map" => "Show Google Map",
// "Show Google Map of results (not shown by default)" => "Show Google Map of results (not shown by default)",
// "Google Map Icon" => "Google Map Icon",
// "Url of default icon to use for markers on the map" => "Url of default icon to use for markers on the map",
// "Calendar Field IDs" => "Calendar Field IDs",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds separated with : for start:end",
// "Calendar View Mode" => "Calendar View Mode",
// "Calendar view type time span (default is month)" => "Calendar view type time span (default is month)",
// "Bimester" => "Bimester",
// "Trimester" => "Trimester",
// "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default" => "Calendar item pop-ups will stay open if set to y (Yes). Set to n (No) by default",
// "Beginning of Month" => "Beginning of Month",
// "Set whether calendar will begin at the beginning of the month (does by default)" => "Set whether calendar will begin at the beginning of the month (does by default)",
// "Show calendar navigation bar (shown by default)" => "Show calendar navigation bar (shown by default)",
// "Partial" => "Partial",
// "Calendar Title" => "Calendar Title",
// "Enter a title to display a calendar title (not set by default)" => "Enter a title to display a calendar title (not set by default)",
// "Calendar Delta" => "Calendar Delta",
// "Set the calendar delta that will be shown (not set by default)" => "Set the calendar delta that will be shown (not set by default)",
// "Plus Month" => "Plus Month",
// "Minus Month" => "Minus Month",
// "Plus Bimester" => "Plus Bimester",
// "Minus Bimester" => "Minus Bimester",
// "Display Spreadsheet" => "Display Spreadsheet",
// "Display tracker as a spreadsheet (not used by default)" => "Display tracker as a spreadsheet (not used by default)",
// "Force Compile" => "Force Compile",
// "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a wiki page as a template. Default=n (best performance)",
// "Period quantity" => "Period quantity",
// "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)" => "Numeric value to display only last tracker items created within a user defined time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how many of those units are to be considered to define the time frame. Use in conjunction with \"max=-1\" to list all items (by default \"max\" is set to 10)",
// "Period unit" => "Period unit",
// "Time unit used with \"Period quantity\"" => "Time unit used with \"Period quantity\"",
// "incorrect filterfield" => "incorrect filterfield",
// "Error in tracker ID" => "Error in tracker ID",
// "No field indicated" => "No field indicated",
// "Displays a button to link to a page with a tracker plugin with prefilled tracker fields" => "Displays a button to link to a page with a tracker plugin with prefilled tracker fields",
// "Tracker Prefill" => "Tracker Prefill",
// "PluginTrackerPrefill" => "PluginTrackerPrefill",
// "Tracker Page Name" => "Tracker Page Name",
// "URL Parameters" => "URL Parameters",
// "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q" => "Parameters to pass in the url, e.g. &my_parameter1=123&my_parameter2=q",
// "Field ID for the first field" => "Field ID for the first field",
// "Content that should be used to prefill the field" => "Content that should be used to prefill the field",
// "Field ID for the second field" => "Field ID for the second field",
// "Field ID for the third field" => "Field ID for the third field",
// "Field ID for the fourth field" => "Field ID for the fourth field",
// "Field ID for the fifth field" => "Field ID for the fifth field",
// "Tracker Stats" => "Tracker Stats",
// "PluginTrackerStat" => "PluginTrackerStat",
// "Displays some stat of a tracker content, fields are indicated with numeric ids" => "Displays some stat of a tracker content, fields are indicated with numeric ids",
// "Choose whether to show the percentage of the vote each option received (not shown by default)" => "Choose whether to show the percentage of the vote each option received (not shown by default)",
// "Choose whether to show a bar representing the number of votes each option received (not shown by default)" => "Choose whether to show a bar representing the number of votes each option received (not shown by default)",
// "Only show items matching certain status filters" => "Only show items matching certain status filters",
// "Show Link" => "Show Link",
// "Show link to tiki-view_tracker" => "Show link to tiki-view_tracker",
// "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)" => "Show last modification date of a tracker. Set to y to use site setting or use PHP\\s format (www.php.net/strftime)",
// "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"" => "y to use the site setting for short date format. Otherwise, use PHP format (www.php.net/strftime), Example: \"%A %d of %B, %Y\"",
// "invalid status" => "invalid status",
// "incorrect fieldId" => "incorrect fieldId",
// "Tracker Timeline" => "Tracker Timeline",
// "PluginTrackerTimeline" => "PluginTrackerTimeline",
// "Timeline view of a tracker, can be used to display event schedules or gantt charts" => "Timeline view of a tracker, can be used to display event schedules or gantt charts",
// "Title Field" => "Title Field",
// "Tracker Field ID containing the item title" => "Tracker Field ID containing the item title",
// "Summary Field" => "Summary Field",
// "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Primary Scale Unit" => "Primary Scale Unit",
// "Unit of time to use for the primary scale (default to hour)" => "Unit of time to use for the primary scale (default to hour)",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "Unit of time to use for the secondary scale (default to empty)" => "Unit of time to use for the secondary scale (default to empty)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link" => "Convert the group name to a link",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Trade" => "Trade",
// "PluginTrade" => "PluginTrade",
// "Send or receive payments from one member to another. (for cclite only so far, experimental)" => "Send or receive payments from one member to another. (for cclite only so far, experimental)",
// "Currency depends on the selected registry" => "Currency depends on the selected registry",
// "Registry to trade in. Default: site preference (or first in list when more than one)" => "Registry to trade in. Default: site preference (or first in list when more than one)",
// "Currency to trade in. Default: Cclite currency preference for registry set above" => "Currency to trade in. Default: Cclite currency preference for registry set above",
// "Other User" => "Other User",
// "Name of the user to recieve or send the payment" => "Name of the user to recieve or send the payment",
// "Leave empty to display an input box" => "Leave empty to display an input box",
// "Offered or wanted item" => "Offered or wanted item",
// "Offered" => "Offered",
// "Wanted" => "Wanted",
// "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency, %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user %2 from %3\" for wanted",
// "Please log in" => "Please log in",
// "The user " => "The user ",
// " needs to validate their account" => " needs to validate their account",
// "Transclusion" => "Transclusion",
// "PluginTransclusion" => "PluginTransclusion",
// "Includes the content of a wiki page and replaces values in the body of the included page. All additional parameters will be replaced. For example %%%title%%% will be replaced with the parameter title in the plugin" => "Includes the content of a wiki page and replaces values in the body of the included page. All additional parameters will be replaced. For example %%%title%%% will be replaced with the parameter title in the plugin",
// "Name of the wiki page to use as a template for the values" => "Name of the wiki page to use as a template for the values",
// "Permission Denied" => "Permission Denied",
// "Attempt to include a page that cannot be viewed" => "Attempt to include a page that cannot be viewed",
// "Page not found" => "Page not found",
// "Page named \"%0\" does not exist at this time" => "Page named \"%0\" does not exist at this time",
// "Translated" => "Translated",
// "PluginTranslated" => "PluginTranslated",
// "Links to a translated content" => "Links to a translated content",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, ex: fr" => "Two letter language code of the language, ex: fr",
// "Country name, ex: France" => "Country name, ex: France",
// "PluginUserCount" => "PluginUserCount",
// "Displays the number of users that are registered or within a group" => "Displays the number of users that are registered or within a group",
// "Userlink function" => "Userlink function",
// "PluginUserlink" => "PluginUserlink",
// "Makes a link to the user information page" => "Makes a link to the user information page",
// "User account name" => "User account name",
// "User account name (which can be an email address)" => "User account name (which can be an email address)",
// "Display a list of registered users" => "Display a list of registered users",
// "Login Filter" => "Login Filter",
// "Separator to use between users in the list. Default: comma" => "Separator to use between users in the list. Default: comma",
// "User info" => "User info",
// "User page" => "User page",
// "User pref" => "User pref",
// "Display the user\\'s real name (when available) instead of login name" => "Display the user\\'s real name (when available) instead of login name",
// "Filter on a group" => "Filter on a group",
// "Userpref" => "Userpref",
// "Display wiki text if user has a pref set to a value" => "Display wiki text if user has a pref set to a value",
// "Split the text in parts visible only under some conditions" => "Split the text in parts visible only under some conditions",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
// "Navigation" => "Navigation",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default" => "Display the current version name as the title. No title shows when nav=>y; otherwise shows by default",
// "Default Label" => "Default Label",
// "Specifies version label to show when displaying the page for the first time. Default label is \\'Default\\'" => "Specifies version label to show when displaying the page for the first time. Default label is \\'Default\\'",
// "Display a Vimeo video" => "Display a Vimeo video",
// "Quality of the video" => "Quality of the video",
// "Full screen" => "Full screen",
// "Expand to full screen" => "Expand to full screen",
// "PluginVote" => "PluginVote",
// "Choose whether to show the voting results (shown by default)" => "Choose whether to show the voting results (shown by default)",
// "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the tracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not shown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not shown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set by default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set by default)",
// "Lists \\'\\'wanted\\'\\' wiki pages" => "Lists \\'\\'wanted\\'\\' wiki pages",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom). Possible values: a valid regex-expression (PCRE)",
// "Ignore" => "Ignore",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "Split By" => "Split By",
// "The character by which ignored patterns are separated" => "The character by which ignored patterns are separated",
// "Skip Extension" => "Skip Extension",
// "Whether to include external wikis in the list (not included by default)" => "Whether to include external wikis in the list (not included by default)",
// "Collect" => "Collect",
// "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them in the second column",
// "Switch on debug output with details about the items (debug not on by default)" => "Switch on debug output with details about the items (debug not on by default)",
// "Memory Saver" => "Memory Saver",
// "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by comma or line break in one cell",
// "Comma" => "Comma",
// "Separate Row" => "Separate Row",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site\\'s __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site\\'s __current__ page_regex",
// "Custom" => "Custom",
// "Full" => "Full",
// "non-valid custom regex" => "non-valid custom regex",
// ", " => ", ",
// "ignored" => "ignored",
// "dash-WikiWord" => "dash-WikiWord",
// "WikiWord" => "WikiWord",
// "not in level" => "not in level",
// "End of debug output" => "End of debug output",
// "Page-Pattern" => "Page-Pattern",
// "Custom-Level-Regex" => "Custom-Level-Regex",
// "^Parameters: key=>value,...\n" => "^Parameters: key=>value,...\n",
// "__key__ | __default__ | __comments__\n" => "__key__ | __default__ | __comments__\n",
// "empty string" => "empty string",
// "A wildcard pattern of originating pages to be ignored" => "A wildcard pattern of originating pages to be ignored",
// "(refer to PHP function fnmatch() for details)\n" => "(refer to PHP function fnmatch() for details)\n",
// "The character, by which ignored patterns are separated" => "The character, by which ignored patterns are separated",
// "possible values: characters\n" => "possible values: characters\n",
// "Whether to include external wikis in the list" => "Whether to include external wikis in the list",
// "possible values: " => "possible values: ",
// "Collect either originating or wanted pages in a cell and display them in the second column" => "Collect either originating or wanted pages in a cell and display them in the second column",
// "Switch-on debug output with details about the items" => "Switch-on debug output with details about the items",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex",
// "A custom filter for wanted pages to be listed (only used when level=>custom)" => "A custom filter for wanted pages to be listed (only used when level=>custom)",
// "Watershed" => "Watershed",
// "Viewer for UStream Watershed Embed" => "Viewer for UStream Watershed Embed",
// "Specify archive, broadcaster, chat or viewer" => "Specify archive, broadcaster, chat or viewer",
// "Broadcaster" => "Broadcaster",
// "Viewer" => "Viewer",
// "Channel code" => "Channel code",
// "Specify the channel code to search in the tracker for a channel to use" => "Specify the channel code to search in the tracker for a channel to use",
// "Brand ID" => "Brand ID",
// "Specify the brand id to search in the tracker for a channel to use" => "Specify the brand id to search in the tracker for a channel to use",
// "Brand prefix" => "Brand prefix",
// "Copy the prefix from the chat embed, e.g. Name-of-Brand-" => "Copy the prefix from the chat embed, e.g. Name-of-Brand-",
// "Video ID" => "Video ID",
// "Video ID of archive which can be found in the tracker" => "Video ID of archive which can be found in the tracker",
// "Locale" => "Locale",
// "Locale specified in viewer embed, default is en_US" => "Locale specified in viewer embed, default is en_US",
// "More than one channel found for specified criteria. Please be more specific" => "More than one channel found for specified criteria. Please be more specific",
// "No videoId specified for archive" => "No videoId specified for archive",
// "Web Service" => "Web Service",
// "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface" => "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "Service Name" => "Service Name",
// "Registered service name" => "Registered service name",
// "Template Name" => "Template Name",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Display youtube video" => "Display youtube video",
// "Movie" => "Movie",
// "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)" => "Entire URL to the YouTube video or last part (after www.youtube.com/v/ and before the first question mark)",
// "Quality of the video. Default is high" => "Quality of the video. Default is high",
// "Show related videos (shown by default)" => "Show related videos (shown by default)",
// "Background" => "Background",
// "Toolbar background color. Use an HTML color code. Example: ffffff" => "Toolbar background color. Use an HTML color code. Example: ffffff",
// "HTML color code, e.g. ffffff" => "HTML color code, e.g. ffffff",
// "Borders" => "Borders",
// "Toolbar border colors. Use an HTML color code. Example: ffffff" => "Toolbar border colors. Use an HTML color code. Example: ffffff",
// "Plugin YouTube error: the movie parameter is empty" => "Plugin YouTube error: the movie parameter is empty",
// "Missing parameter movie to the Youtube plugin" => "Missing parameter movie to the Youtube plugin",
// "Cannot create aliased page" => "Cannot create aliased page",
// "You attempted to create the following page" => "You attempted to create the following page",
// "That page is an alias for the following pages" => "That page is an alias for the following pages",
// "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this" => "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
// "Removed version \$version" => "Removed version \$version",
// "rollback version " => "rollback version ",
// "Changed actual version to \$version" => "Changed actual version to \$version",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
// "Removed last version" => "Removed last version",
// "User %s does not have the permission" => "User %s does not have the permission",
// "The message has been sent to" => "The message has been sent to",
// "The message will be sent to" => "The message will be sent to",
// "User %s does not want to receive messages" => "User %s does not want to receive messages",
// "Sent box is full. Archive or delete some sent messages first if you want to send more messages" => "Sent box is full. Archive or delete some sent messages first if you want to send more messages",
// "An error occurred, please check your mail settings and try again" => "An error occurred, please check your mail settings and try again",
// "You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'",
// "User %s can not receive messages, mailbox is full" => "User %s can not receive messages, mailbox is full",
// "User %s can not receive messages" => "User %s can not receive messages",
// "Invalid user: %s" => "Invalid user: %s",
// "Message has been sent to: " => "Message has been sent to: ",
// "Archive is full. Delete some messages from archive first" => "Archive is full. Delete some messages from archive first",
// "ERROR: " => "ERROR: ",
// "ERROR: Invalid tab_id received. Numeric format expected, got \$tab_id" => "ERROR: Invalid tab_id received. Numeric format expected, got \$tab_id",
// "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page",
// "Item types filter" => "Item types filter",
// "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes",
// "Possible item type values" => "Possible item type values",
// "Similar Content" => "Similar Content",
// "Find similar content based on FreeTags" => "Find similar content based on FreeTags",
// "Similar Content Filter" => "Similar Content Filter",
// "Display only similar content of type specified" => "Display only similar content of type specified",
// "Default: \"All Content Type\"" => "Default: \"All Content Type\"",
// "Options: \"article, wiki page, blog post\"" => "Options: \"article, wiki page, blog post\"",
// "Broaden FreeTag Search" => "Broaden FreeTag Search",
// "Find similar content that contains one of the Tags or All of the Tags" => "Find similar content that contains one of the Tags or All of the Tags",
// "Default: \"n - needs to contain all of the Tags\"" => "Default: \"n - needs to contain all of the Tags\"",
// "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"",
// "Google AdSense" => "Google AdSense",
// "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code",
// "Advertisement channel, as optionally provided by Google" => "Advertisement channel, as optionally provided by Google",
// "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
// "Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Global banner format as provided by Google. For example: \"display=468*60_as\"",
// "Background color, as optionally provided by Google" => "Background color, as optionally provided by Google",
// "Border color, as optionally provided by Google" => "Border color, as optionally provided by Google",
// "Link color, as optionally provided by Google" => "Link color, as optionally provided by Google",
// "Text color, as optionally provided by Google" => "Text color, as optionally provided by Google",
// "URL color, as optionally provided by Google" => "URL color, as optionally provided by Google",
// "Article archives" => "Article archives",
// "Shows links to the published articles for each month" => "Shows links to the published articles for each month",
// "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles",
// "Default: \"n\"" => "Default: \"n\"",
// "If set to a category identifier, only consider the articles in the specified category" => "If set to a category identifier, only consider the articles in the specified category",
// "Example value: 13" => "Example value: 13",
// "Topic filter (by names)" => "Topic filter (by names)",
// "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Topic filter (by identifiers)" => "Topic filter (by identifiers)",
// "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values: 13, !13, 1+3, !1+5+7" => "Example values: 13, !13, 1+3, !1+5+7",
// "Types filter" => "Types filter",
// "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered",
// "Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Example values: Event, !Event, Event+Review, !Event+Classified+Article",
// "Language filter" => "Language filter",
// "If set to a language code, only consider the articles in the specified language" => "If set to a language code, only consider the articles in the specified language",
// "Article Topics" => "Article Topics",
// "Lists all article topics with links to their articles" => "Lists all article topics with links to their articles",
// "Lists the specified number of published articles in the specified order" => "Lists the specified number of published articles in the specified order",
// "Show publication time" => "Show publication time",
// "If set to \"y\", article publication times are shown" => "If set to \"y\", article publication times are shown",
// "Show creation time" => "Show creation time",
// "If set to \"y\", article creation times are shown" => "If set to \"y\", article creation times are shown",
// "Show rating selector" => "Show rating selector",
// "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating",
// "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image" => "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image",
// "If set to a category identifier, only lists the articles in the specified category" => "If set to a category identifier, only lists the articles in the specified category",
// "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed",
// "If set to a language code, only lists the articles in the specified language" => "If set to a language code, only lists the articles in the specified language",
// "Specifies how the articles should be sorted" => "Specifies how the articles should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date",
// "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead",
// "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles",
// "Absolute URL" => "Absolute URL",
// "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example",
// "TikiWiki assistant" => "TikiWiki assistant",
// "Displays an assistant to guide new Tiki admins" => "Displays an assistant to guide new Tiki admins",
// "Last blog post comments" => "Last blog post comments",
// "Displays the specified number of the blog post comments most recently added" => "Displays the specified number of the blog post comments most recently added",
// "No date" => "No date",
// "If set to \"y\", the date of comments is not displayed in the module box" => "If set to \"y\", the date of comments is not displayed in the module box",
// "Verbose tooltips" => "Verbose tooltips",
// "If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "If set to \"y\", blog post title is only visible as a tooltip and not displayed",
// "Options: \"y,n\"" => "Options: \"y,n\"",
// "Last visited pages" => "Last visited pages",
// "Displays the last Wiki pages visited by the user" => "Displays the last Wiki pages visited by the user",
// "Maximum number of characters in page names allowed before truncating" => "Maximum number of characters in page names allowed before truncating",
// "Includes a calendar or a list of calendar events" => "Includes a calendar or a list of calendar events",
// "Calendars filter" => "Calendars filter",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")",
// "Displayed month (relative)" => "Displayed month (relative)",
// "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span" => "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span",
// "View type" => "View type",
// "Calendar view type time span" => "Calendar view type time span",
// "Show action" => "Show action",
// "Viewmode when clicking on a day" => "Viewmode when clicking on a day",
// "Put a link on all the days , not only those with event" => "Put a link on all the days , not only those with event",
// "View navigation bar" => "View navigation bar",
// "Cart" => "Cart",
// "Displays the content of the cart, allows to modify quantities and proceed to payment" => "Displays the content of the cart, allows to modify quantities and proceed to payment",
// "The quantities in your cart were updated" => "The quantities in your cart were updated",
// "The order was recorded and is now awaiting payment. Reference number is %0" => "The order was recorded and is now awaiting payment. Reference number is %0",
// "Displays links to categories as a tree" => "Displays links to categories as a tree",
// "Object type filter" => "Object type filter",
// "Object type filter to apply when accessing a linked category. Example values" => "Object type filter to apply when accessing a linked category. Example values",
// "Deep" => "Deep",
// "Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Show subcategories objects when accessing a linked category. Possible values: on (default), off",
// "PHP Layers menu style" => "PHP Layers menu style",
// "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree" => "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree",
// "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)" => "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)",
// "Show these categories and their children" => "Show these categories and their children",
// "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6",
// "Category Transitions" => "Category Transitions",
// "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules" => "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules",
// "Change Category" => "Change Category",
// "Enables to categorize an object" => "Enables to categorize an object",
// "Category identifier" => "Category identifier",
// "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier",
// "Note that the root category is not displayed" => "Note that the root category is not displayed",
// "Defaults to 0 (root)" => "Defaults to 0 (root)",
// "No top" => "No top",
// "In non-detailed view, disallow uncategorizing. Example value: 1" => "In non-detailed view, disallow uncategorizing. Example value: 1",
// "Display path" => "Display path",
// "Instead of category names, diplay their path in the category tree starting from the category root defined" => "Instead of category names, diplay their path in the category tree starting from the category root defined",
// "Example value: 1" => "Example value: 1",
// "Multiple categories" => "Multiple categories",
// "If set to \"n\", only allows categorizing in one category (from those displayed)" => "If set to \"n\", only allows categorizing in one category (from those displayed)",
// "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize",
// "Shy" => "Shy",
// "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default" => "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default",
// "Detailed" => "Detailed",
// "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list",
// "If set to \"n\", the detailed list of categories will not offer to unassign a category" => "If set to \"n\", the detailed list of categories will not offer to unassign a category",
// "If set to \"y\", allow to assign new categories" => "If set to \"y\", allow to assign new categories",
// "Example values: y, n" => "Example values: y, n",
// "Default value: y" => "Default value: y",
// "Default value: n" => "Default value: n",
// "Image URL not in category" => "Image URL not in category",
// "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category",
// "Image URL in category" => "Image URL in category",
// "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category",
// "Categorize %s" => "Categorize %s",
// "Categorize %s in %s" => "Categorize %s in %s",
// "Displays the number of pages received (via Communications)" => "Displays the number of pages received (via Communications)",
// "Shows the credits a user has" => "Shows the credits a user has",
// "Last directory sites" => "Last directory sites",
// "Displays the specified number of the directory sites most recently added" => "Displays the specified number of the directory sites most recently added",
// "Directory category identifier" => "Directory category identifier",
// "If set to a directory category identifier, only displays the sites in the specified directory category" => "If set to a directory category identifier, only displays the sites in the specified directory category",
// "If set to \"y\", displays a button labelled \"More\" that links to the directory" => "If set to \"y\", displays a button labelled \"More\" that links to the directory",
// "If set to \"y\", the description of the directory site appears" => "If set to \"y\", the description of the directory site appears",
// "Maximum length of description" => "Maximum length of description",
// "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)",
// "Default: blank" => "Default: blank",
// "Directory statistics" => "Directory statistics",
// "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links",
// "Top directory sites" => "Top directory sites",
// "Displays the specified number of the directory sites from most visited to least visited" => "Displays the specified number of the directory sites from most visited to least visited",
// "Displays the site\\'s first featured links" => "Displays the site\\'s first featured links",
// "Displays links to file galleries" => "Displays links to file galleries",
// "Best rated topics" => "Best rated topics",
// "Displays the specified number of the forum topics with the best ratings" => "Displays the specified number of the forum topics with the best ratings",
// "Displays the latest forum posts" => "Displays the latest forum posts",
// "If set to \"y\", only displays topics" => "If set to \"y\", only displays topics",
// "List of forum IDs" => "List of forum IDs",
// "Post only from this forum" => "Post only from this forum",
// "Displays the specified number of the forums with the most comments" => "Displays the specified number of the forums with the most comments",
// "Displays the specified number of the forum topics with the most reads" => "Displays the specified number of the forum topics with the most reads",
// "Displays the specified number of the forums with the most visits" => "Displays the specified number of the forums with the most visits",
// "Freetags editor" => "Freetags editor",
// "Shows current freetags and enables to add and remove some if permissions allow" => "Shows current freetags and enables to add and remove some if permissions allow",
// "Freetags Wiki" => "Freetags Wiki",
// "Displays current freetags on wiki pages and enables to add tags if permissions allow" => "Displays current freetags on wiki pages and enables to add tags if permissions allow",
// "Freetags similar content" => "Freetags similar content",
// "Shows content with multiple freetags in common" => "Shows content with multiple freetags in common",
// "Type of objects to extract" => "Type of objects to extract",
// "Similar pages" => "Similar pages",
// "Shows the most popular freetags. More popularity is indicated by a larger font" => "Shows the most popular freetags. More popularity is indicated by a larger font",
// "Display type" => "Display type",
// "If set to \"cloud\", links are displayed as a cloud" => "If set to \"cloud\", links are displayed as a cloud",
// "Default: \"list\"" => "Default: \"list\"",
// "Maximum elements" => "Maximum elements",
// "If set to a number, limits the number of tags displayed" => "If set to a number, limits the number of tags displayed",
// "User preferred tags" => "User preferred tags",
// "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font" => "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font",
// "My preferred tags" => "My preferred tags",
// "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site",
// "Groups emulation" => "Groups emulation",
// "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site" => "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site",
// "Emulate Groups" => "Emulate Groups",
// "Displays the specified number of last actions" => "Displays the specified number of last actions",
// "Show user" => "Show user",
// "If set to \"y\", user names are displayed in the module box" => "If set to \"y\", user names are displayed in the module box",
// "Show date" => "Show date",
// "If set to \"y\", action dates are displayed in the module box" => "If set to \"y\", action dates are displayed in the module box",
// "Maximum number of characters in action descriptions before truncating" => "Maximum number of characters in action descriptions before truncating",
// "Lists the specified number of blogs posts from newest to oldest" => "Lists the specified number of blogs posts from newest to oldest",
// "If set to \"y\", the date of posts is not displayed in the module box" => "If set to \"y\", the date of posts is not displayed in the module box",
// "Blog identifier" => "Blog identifier",
// "If set to a blog identifier, restricts the blog posts to those in the identified blog" => "If set to a blog identifier, restricts the blog posts to those in the identified blog",
// "Last category objects" => "Last category objects",
// "Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Lists the specified number of objects of the given type in the given category, starting from the most recently created",
// "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed",
// "Maximum number of characters in object names allowed before truncating" => "Maximum number of characters in object names allowed before truncating",
// "Type of the objects to list. Example values" => "Type of the objects to list. Example values",
// "Displays the specified number of blogs from newest to oldest" => "Displays the specified number of blogs from newest to oldest",
// "Displays the specified number of FAQs from newest to oldest" => "Displays the specified number of FAQs from newest to oldest",
// "Displays the specified number of quizzes from newest to oldest" => "Displays the specified number of quizzes from newest to oldest",
// "Displays the specified number of file galleries, starting from the most recently modified" => "Displays the specified number of file galleries, starting from the most recently modified",
// "List the specified number of files, starting from the most recently added" => "List the specified number of files, starting from the most recently added",
// "Gallery identifiers" => "Gallery identifiers",
// "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers",
// "Example value: 13, 2:13, 1:2:3:5:6" => "Example value: 13, 2:13, 1:2:3:5:6",
// "Last modified image galleries" => "Last modified image galleries",
// "Displays the specified number of image galleries, starting from the most recently modified" => "Displays the specified number of image galleries, starting from the most recently modified",
// "List the specified number of images, starting from the most recently added" => "List the specified number of images, starting from the most recently added",
// "Gallery identifier" => "Gallery identifier",
// "If set to an image gallery identifier, restricts the images to those in the identified gallery" => "If set to an image gallery identifier, restricts the images to those in the identified gallery",
// "Link content" => "Link content",
// "Display the links as image names or thumbnails" => "Display the links as image names or thumbnails",
// "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"",
// "Last modified events" => "Last modified events",
// "Displays the specified number of calendar events, starting from the most recently modified" => "Displays the specified number of calendar events, starting from the most recently modified",
// "Calendar identifier" => "Calendar identifier",
// "If set to a calendar identifier, restricts the events to those in the identified calendar" => "If set to a calendar identifier, restricts the events to those in the identified calendar",
// "Maximum number of characters in event names allowed before truncating" => "Maximum number of characters in event names allowed before truncating",
// "If set to \"y\", it will hide date" => "If set to \"y\", it will hide date",
// "Don't show date" => "Don't show date",
// "Lists the specified number of pages, starting from the most recently modified" => "Lists the specified number of pages, starting from the most recently modified",
// "Link target" => "Link target",
// "Target URL of the \"...more\" link at the bottom of the module" => "Target URL of the \"...more\" link at the bottom of the module",
// "Displays the specified number of blogs, starting from the most recently modified" => "Displays the specified number of blogs, starting from the most recently modified",
// "Last Podcasts" => "Last Podcasts",
// "Displays Podcasts" => "Displays Podcasts",
// "File galleries IDs" => "File galleries IDs",
// "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned",
// "width" => "width",
// "Width of mediaplayer in pixels. Default is 190" => "Width of mediaplayer in pixels. Default is 190",
// "height" => "height",
// "Height of mediaplayer in pixels. Default is 20" => "Height of mediaplayer in pixels. Default is 20",
// "mediaplayer" => "mediaplayer",
// "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)",
// "Bottom Link URL" => "Bottom Link URL",
// "URL for a link at bottom of module" => "URL for a link at bottom of module",
// "Bottom Link URL Text" => "Bottom Link URL Text",
// "Text for link if Bottom Link URL is set. Default is \"More Podcasts\"" => "Text for link if Bottom Link URL is set. Default is \"More Podcasts\"",
// "Verbose" => "Verbose",
// "Display description of podcast below player if \"y\", and on title mouseover if \"n\". Default is \"y\"" => "Display description of podcast below player if \"y\", and on title mouseover if \"n\". Default is \"y\"",
// "Lists the specified number of article submissions from newest to oldest" => "Lists the specified number of article submissions from newest to oldest",
// "Last tracker comments" => "Last tracker comments",
// "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted",
// "Tracker identifier" => "Tracker identifier",
// "If set to a tracker identifier, only displays the comments on the given tracker" => "If set to a tracker identifier, only displays the comments on the given tracker",
// "Item identifier" => "Item identifier",
// "If set to an item identifier, only displays the comments on the given item" => "If set to an item identifier, only displays the comments on the given item",
// "Last tracker items" => "Last tracker items",
// "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required",
// "Identifier of the tracker from which items are listed" => "Identifier of the tracker from which items are listed",
// "Field identifier" => "Field identifier",
// "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored",
// "Field name" => "Field name",
// "Name of the field from which values are listed" => "Name of the field from which values are listed",
// "Example value: age" => "Example value: age",
// "Specifies how the items should be sorted" => "Specifies how the items should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date",
// "Status filter" => "Status filter",
// "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values",
// "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set",
// "You do not have permission to view this tracker" => "You do not have permission to view this tracker",
// "Last Validated FAQs Questions" => "Last Validated FAQs Questions",
// "Displays the specified number of validated questions FAQs from newest to oldest" => "Displays the specified number of validated questions FAQs from newest to oldest",
// "Faq identifier" => "Faq identifier",
// "If set to a faq identifier, restricts the chosen questions to those in the identified faq" => "If set to a faq identifier, restricts the chosen questions to those in the identified faq",
// "Displays information about the specified number of users in decreasing order of last login time" => "Displays information about the specified number of users in decreasing order of last login time",
// "Show avatars" => "Show avatars",
// "If set to \"y\", show user avatars" => "If set to \"y\", show user avatars",
// "Maximum number of characters in user names allowed before truncating" => "Maximum number of characters in user names allowed before truncating",
// "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console",
// "Login box" => "Login box",
// "Input size" => "Input size",
// "Number of characters for username and password input fields" => "Number of characters for username and password input fields",
// "Logo" => "Logo",
// "Site logo, title and subtitle" => "Site logo, title and subtitle",
// "Menu page" => "Menu page",
// "Displays a Wiki page" => "Displays a Wiki page",
// "Page to display in the menu. Example value: HomePage" => "Page to display in the menu. Example value: HomePage",
// "Menu structure" => "Menu structure",
// "Displays a structure" => "Displays a structure",
// "Structure to display in the menu" => "Structure to display in the menu",
// "Unread inter-user messages" => "Unread inter-user messages",
// "Displays to users their number of new inter-user messages and a link to their message box" => "Displays to users their number of new inter-user messages and a link to their message box",
// "Show If Empty" => "Show If Empty",
// "Show the module when there are no messages waiting. y|n " => "Show the module when there are no messages waiting. y|n ",
// "Default=y" => "Default=y",
// "Small live chat box" => "Small live chat box",
// "Channels" => "Channels",
// "List of chat channels. Channel names are separated by a comma (\",\")" => "List of chat channels. Channel names are separated by a comma (\",\")",
// "By default, a single channel named \"default\" exists" => "By default, a single channel named \"default\" exists",
// "Months links" => "Months links",
// "Links to the objects of a given type for the current month and those preceding it" => "Links to the objects of a given type for the current month and those preceding it",
// "Type of objects to link to" => "Type of objects to link to",
// "\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" for blog posts, \"cms\" for published articles",
// "Object identifier" => "Object identifier",
// "Identifier of an object with children to link to" => "Identifier of an object with children to link to",
// "This is required for the blog Object type" => "This is required for the blog Object type",
// "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3",
// "Most commented" => "Most commented",
// "Displays the most commented objects of a certain type" => "Displays the most commented objects of a certain type",
// "Type of objects to consider" => "Type of objects to consider",
// "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)",
// "Object language filter" => "Object language filter",
// "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language",
// "Displays the number of article submissions waiting examination and a link to the list" => "Displays the number of article submissions waiting examination and a link to the list",
// "Displays the specified number of old articles (which do not show on articles home page anymore)" => "Displays the specified number of old articles (which do not show on articles home page anymore)",
// "Enables to change current perspective" => "Enables to change current perspective",
// "Quick Edit" => "Quick Edit",
// "Enables to quickly create or edit Wiki pages" => "Enables to quickly create or edit Wiki pages",
// "Template identifier" => "Template identifier",
// "If set to a template identifier, the specified template is used for creating new Wiki pages" => "If set to a template identifier, the specified template is used for creating new Wiki pages",
// "If set, send the form to the given location (relative to Tiki\\'s root) for processing" => "If set, send the form to the given location (relative to Tiki\\'s root) for processing",
// "SUBMIT label" => "SUBMIT label",
// "The label on the button to submit the form" => "The label on the button to submit the form",
// "INPUT SIZE" => "INPUT SIZE",
// "Size attribute (horizontal, in characters) of the text input fields for page names and description. The size of the other fields is relative to the module width" => "Size attribute (horizontal, in characters) of the text input fields for page names and description. The size of the other fields is relative to the module width",
// "Optional heading to display at the top of the module\\'s content" => "Optional heading to display at the top of the module\\'s content",
// "If set to a category identifier, pages created through the module are automatically categorized only in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized only in the specified category",
// "Category to preselect" => "Category to preselect",
// "If set, pages created through the module have this category prechecked to be categorized in" => "If set, pages created through the module have this category prechecked to be categorized in",
// "Tip to be shown" => "Tip to be shown",
// "Custom text to be shown as a tip at the top of the edit page" => "Custom text to be shown as a tip at the top of the edit page",
// "Title of tip to be shown" => "Title of tip to be shown",
// "Custom title to be shown for the tip at the top of the edit page" => "Custom title to be shown for the tip at the top of the edit page",
// "Custom header template" => "Custom header template",
// "Wiki page to be used as a template to show content on top of edit page" => "Wiki page to be used as a template to show content on top of edit page",
// "input field for copy/paste" => "input field for copy/paste",
// "If set to 1 , a text area for copy/paste page content is shown" => "If set to 1 , a text area for copy/paste page content is shown",
// "show description field" => "show description field",
// "If set to 1, a text field to enter the page description is shown (requires feature_wiki_description)" => "If set to 1, a text field to enter the page description is shown (requires feature_wiki_description)",
// "choose category" => "choose category",
// "If set to 1, this allows the user to choose a category instead of preselecting one" => "If set to 1, this allows the user to choose a category instead of preselecting one",
// "Random image" => "Random image",
// "Displays a random image" => "Displays a random image",
// "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery",
// "Show link" => "Show link",
// "If set to \"n\", the image thumbnail does not link to the image" => "If set to \"n\", the image thumbnail does not link to the image",
// "Default: \"y\"" => "Default: \"y\"",
// "Show name" => "Show name",
// "If set to \"y\", the name of the image is displayed" => "If set to \"y\", the name of the image is displayed",
// "If set to \"y\", the description of the image is displayed" => "If set to \"y\", the description of the image is displayed",
// "Displays the specified number of random wiki pages" => "Displays the specified number of random wiki pages",
// "New user registrationmore tiki-re" => "New user registrationmore tiki-re",
// "Feeds List" => "Feeds List",
// "List of feeds available on this site" => "List of feeds available on this site",
// "Multi-purpose search module (go or edit page by name and/or search site)" => "Multi-purpose search module (go or edit page by name and/or search site)",
// "Legacy Mode" => "Legacy Mode",
// "Setting to emulate previous behaviour" => "Setting to emulate previous behaviour",
// " (\"search\"=search_box, \"page\"=search_wiki_page, \"quick\"=quick_edit)" => " (\"search\"=search_box, \"page\"=search_wiki_page, \"quick\"=quick_edit)",
// "If set to \"y\" the search performed is a \"Tiki search\"" => "If set to \"y\" the search performed is a \"Tiki search\"",
// " (full text search)" => " (full text search)",
// "Show Search Filter" => "Show Search Filter",
// "If set to \"y\" shows a dropdown of sections to search" => "If set to \"y\" shows a dropdown of sections to search",
// " (no object filter)" => " (no object filter)",
// "Use autocomplete" => "Use autocomplete",
// "If set to \"y\" input uses autocomplete for pagenames if applicable" => "If set to \"y\" input uses autocomplete for pagenames if applicable",
// " (use autocomplete)" => " (use autocomplete)",
// "Advanced search" => "Advanced search",
// "Use advanced (boolean) search (full text search only)" => "Use advanced (boolean) search (full text search only)",
// " (use advanced search)" => " (use advanced search)",
// "Advanced search checkbox" => "Advanced search checkbox",
// "Show advanced search checkbox (full text search only)" => "Show advanced search checkbox (full text search only)",
// " (advanced search checkbox off)" => " (advanced search checkbox off)",
// "Advanced search help" => "Advanced search help",
// "Show advanced search help icon (full text search only)" => "Show advanced search help icon (full text search only)",
// " (advanced search help off)" => " (advanced search help off)",
// "Show Search Button" => "Show Search Button",
// "Show search button" => "Show search button",
// " (do show search button)" => " (do show search button)",
// "Show Go Button" => "Show Go Button",
// "Show go to page button" => "Show go to page button",
// " (do show go button)" => " (do show go button)",
// "Show Edit Button" => "Show Edit Button",
// "Show edit button" => "Show edit button",
// " (do show edit button)" => " (do show edit button)",
// "Default Button" => "Default Button",
// "Action to perform on entering <return>" => "Action to perform on entering <return>",
// " (search|go|edit)" => " (search|go|edit)",
// "Edit Submit Label" => "Edit Submit Label",
// "Size attribute (horizontal, in characters) of the text input field" => "Size attribute (horizontal, in characters) of the text input field",
// "Size of the Search Filter dropdown list" => "Size of the Search Filter dropdown list",
// "Edit Template identifier" => "Edit Template identifier",
// "If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized in the specified category",
// "Search is disabled" => "Search is disabled",
// "Search Wiki Page" => "Search Wiki Page",
// "If set, send the form to the given location (relative to Tiki's root) for processing" => "If set, send the form to the given location (relative to Tiki's root) for processing",
// "Optional heading to display at the top of the module's content" => "Optional heading to display at the top of the module's content",
// "Titles" => "Titles",
// "Small search form (for wiki, articles, blogs, etc.)" => "Small search form (for wiki, articles, blogs, etc.)",
// "If set to \"y\", the search performed is a \"Tiki search\"" => "If set to \"y\", the search performed is a \"Tiki search\"",
// "Search for a wiki page by name" => "Search for a wiki page by name",
// "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages" => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages",
// "Tooltip" => "Tooltip",
// "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content",
// "Label on the button to post a message" => "Label on the button to post a message",
// "Wait label" => "Wait label",
// "Label on the button to post a message when the message is being posted if AJAX is enabled" => "Label on the button to post a message when the message is being posted if AJAX is enabled",
// "Maximum messages shown" => "Maximum messages shown",
// "Number of messages to display" => "Number of messages to display",
// "Tweet" => "Tweet",
// "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via twitter" => "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via twitter",
// "Facebook" => "Facebook",
// "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his facebook wall" => "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his facebook wall",
// "Since last visit (simple)" => "Since last visit (simple)",
// "Displays to logged in users the number of new or updated objects since their last login date and time" => "Displays to logged in users the number of new or updated objects since their last login date and time",
// "Since last visit" => "Since last visit",
// "Displays to logged in users new or updated objects since a point in time, by default their last login date and time" => "Displays to logged in users new or updated objects since a point in time, by default their last login date and time",
// "Show users" => "Show users",
// "If set to \"n\", do not show new users" => "If set to \"n\", do not show new users",
// "Show trackers" => "Show trackers",
// "If set to \"n\", do not show tracker changes" => "If set to \"n\", do not show tracker changes",
// "Calendar focus" => "Calendar focus",
// "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar",
// "Show date as a calendar link" => "Show date as a calendar link",
// "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)" => "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)",
// "Fold sections by default" => "Fold sections by default",
// "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)",
// "Use Jquery presentation" => "Use Jquery presentation",
// "If set to \"y\", it will use jquery to show the result" => "If set to \"y\", it will use jquery to show the result",
// " (archived)" => " (archived)",
// "Switch Language" => "Switch Language",
// "Displays a language picker to change the language of the site" => "Displays a language picker to change the language of the site",
// "Display mode" => "Display mode",
// "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist",
// "Prefix" => "Prefix",
// "Changes the default displayed prefix from \\\"Site Language:\\\"" => "Changes the default displayed prefix from \\\"Site Language:\\\"",
// "Switch theme" => "Switch theme",
// "Enables to quickly change the theme" => "Enables to quickly change the theme",
// "Terminology" => "Terminology",
// "Support for multilingual terminology" => "Support for multilingual terminology",
// "Root category" => "Root category",
// "All terms will automatically be put in that category. " => "All terms will automatically be put in that category. ",
// "Note that the category must already exist. " => "Note that the category must already exist. ",
// "Defaults to \\'Term\\'" => "Defaults to \\'Term\\'",
// "Tiki Tests" => "Tiki Tests",
// "Tiki test suite helper" => "Tiki test suite helper",
// "Displays the specified number of blogs with links to them, from the most active one to the least" => "Displays the specified number of blogs with links to them, from the most active one to the least",
// "Blog activity measurement can be more or less accurate" => "Blog activity measurement can be more or less accurate",
// "Lists the specified number of articles with links to them, from the most visited one to the least" => "Lists the specified number of articles with links to them, from the most visited one to the least",
// "Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Displays the specified number of file galleries with links to them, starting with the one with most hits",
// "Displays the specified number of files with links to them, starting with the one with most hits" => "Displays the specified number of files with links to them, starting with the one with most hits",
// "Displays the specified number of users who posted to forums, starting with the one having most posts" => "Displays the specified number of users who posted to forums, starting with the one having most posts",
// "Top image galleries" => "Top image galleries",
// "Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Displays the specified number of image galleries with links to them, starting with the one with most hits",
// "Displays the specified number of images with links to them, from the most visited one to the least" => "Displays the specified number of images with links to them, from the most visited one to the least",
// "Displays the specified number of objects, starting with the one having the most hits" => "Displays the specified number of objects, starting with the one having the most hits",
// "Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Displays the specified number of wiki pages with links to them, starting with the one having the most hits",
// "Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Displays the specified number of quizzes with links to them, starting with the one having the most hits",
// "Displays the specified number of blogs with links to them, from the most visited one to the least" => "Displays the specified number of blogs with links to them, from the most visited one to the least",
// "Show Last Post" => "Show Last Post",
// "Displays the specified number of FAQs with links to them, from the most visited one to the least" => "Displays the specified number of FAQs with links to them, from the most visited one to the least",
// "Trackerhelp" => "Trackerhelp",
// "Display the fieldId of a tracker" => "Display the fieldId of a tracker",
// "Textarea rows" => "Textarea rows",
// "Textarea cols" => "Textarea cols",
// "Max fields" => "Max fields",
// "Tracker Help" => "Tracker Help",
// "Translate Updates" => "Translate Updates",
// "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed",
// "Reference language" => "Reference language",
// "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed",
// "Show language" => "Show language",
// "If \"y\" the page language will be shown instead of the page name" => "If \"y\" the page language will be shown instead of the page name",
// "Default = \"y\"" => "Default = \"y\"",
// "Lists the specified number of calendar events, ordered by their start date" => "Lists the specified number of calendar events, ordered by their start date",
// "Maximum days in the future" => "Maximum days in the future",
// "Maximum distance to event start dates in days (looking forward)" => "Maximum distance to event start dates in days (looking forward)",
// "Maximum days in the past" => "Maximum days in the past",
// "Maximum distance to event end dates in days (looking backward)" => "Maximum distance to event end dates in days (looking backward)",
// "cellpadding" => "cellpadding",
// "cellspacing" => "cellspacing",
// "If set to \"y\", event descriptions are displayed" => "If set to \"y\", event descriptions are displayed",
// "Show end date and time" => "Show end date and time",
// "If set to \"y\", event end dates and times are displayed, when appropriate" => "If set to \"y\", event end dates and times are displayed, when appropriate",
// "Use custom calendar background colors" => "Use custom calendar background colors",
// "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)" => "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)",
// "Show information in tooltips" => "Show information in tooltips",
// "If set to \"n\", event tooltips will not display event information" => "If set to \"n\", event tooltips will not display event information",
// "Date format" => "Date format",
// "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
// "site preference for short date format followed by site preference for short time format" => "site preference for short date format followed by site preference for short time format",
// "If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "If set to an integer, event names are allowed that number of characters as a maximum before being truncated",
// "Displays to registered users their blogs" => "Displays to registered users their blogs",
// "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed",
// "User image galleries" => "User image galleries",
// "Displays to registered users their image galleries" => "Displays to registered users their image galleries",
// "Displays to registered users the specified number of wiki pages which they were the last to edit" => "Displays to registered users the specified number of wiki pages which they were the last to edit",
// "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations",
// "Lists the public user tasks of a chosen group, with links to tasks" => "Lists the public user tasks of a chosen group, with links to tasks",
// "User-Group Tracker" => "User-Group Tracker",
// "User and Group tracker links" => "User and Group tracker links",
// "Displays the specified number of users and their score, starting from the one with the highest score" => "Displays the specified number of users and their score, starting from the one with the highest score",
// "Webmail Inbox" => "Webmail Inbox",
// "Displays Webmail Inbox" => "Displays Webmail Inbox",
// "Account Id" => "Account Id",
// "Webmail account identifier (if not set uses user\\'s current account)" => "Webmail account identifier (if not set uses user\\'s current account)",
// "GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Group (e.g. \"Help Team\")",
// "GroupMail: Tracker Id (to store GroupMail activity)" => "GroupMail: Tracker Id (to store GroupMail activity)",
// "GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: From Field (Id of field in tracker to store email From header)",
// "GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id of field in tracker to store email Subject header)",
// "GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Message Field (Id of field in tracker to store email message identifier)",
// "GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Content Field (Id of field in tracker to store email message body content)",
// "GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: Account Field (Id of field in tracker to store Webmail account name)",
// "DateTime Field Id" => "DateTime Field Id",
// "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)",
// "GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Operator Field (Id of field in tracker to store operator name (username))",
// "Maximum number of characters in subjects allowed before truncating" => "Maximum number of characters in subjects allowed before truncating",
// "Webmail error" => "Webmail error",
// "No accounts set up (or no current account set)" => "No accounts set up (or no current account set)",
// "What is related" => "What is related",
// "Lists objects which share a category with the viewed object" => "Lists objects which share a category with the viewed object",
// "Displays information about users currently logged in" => "Displays information about users currently logged in",
// "Content to display" => "Content to display",
// "Display the number of users logged in, the list of users logged in, or both" => "Display the number of users logged in, the list of users logged in, or both",
// "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"",
// "Cluster mode" => "Cluster mode",
// "If set to \"1\", separate users based on which host/server they logged on" => "If set to \"1\", separate users based on which host/server they logged on",
// "Last comments" => "Last comments",
// "Lists the specified number of comments starting from the most recently posted" => "Lists the specified number of comments starting from the most recently posted",
// "More in tooltips" => "More in tooltips",
// "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip" => "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip",
// "Type of the objects from which comments will be listed. Possible values" => "Type of the objects from which comments will be listed. Possible values",
// "Last article comments" => "Last article comments",
// "YouTube" => "YouTube",
// "Displays YouTube videos and/or a link to a YouTube user\\'s page" => "Displays YouTube videos and/or a link to a YouTube user\\'s page",
// "Video identifiers" => "Video identifiers",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
// "YouTube user identifier" => "YouTube user identifier",
// "If set to a YouTube user identifier, display a link to the videos of this user" => "If set to a YouTube user identifier, display a link to the videos of this user",
// "Width of each video in pixels" => "Width of each video in pixels",
// "Height of each video in pixels" => "Height of each video in pixels",
// "No Playlist found" => "No Playlist found",
// "No Playlist ID was provided" => "No Playlist ID was provided",
// "Can add own user to the participants" => "Can add own user to the participants",
// "Can add guest to the participants" => "Can add guest to the participants",
// "Can view Tiki tools calendar" => "Can view Tiki tools calendar",
// "Can admin the articles" => "Can admin the articles",
// "Submitted articles automatically approved" => "Submitted articles automatically approved",
// "Can rate articles" => "Can rate articles",
// "Submitted links are valid" => "Submitted links are valid",
// "Can validate submitted links" => "Can validate submitted links",
// "Administrator, can manage users groups and permissions, and all features" => "Administrator, can manage users groups and permissions, and all features",
// "Can admin external feeds" => "Can admin external feeds",
// "Can share a page (email, twitter, facebook, message, forums)" => "Can share a page (email, twitter, facebook, message, forums)",
// "Can view integrated repositories" => "Can view integrated repositories",
// "Can view referrer stats" => "Can view referrer stats",
// "Can view in module and feed the blog posts" => "Can view in module and feed the blog posts",
// "Can view in module and feed the blog" => "Can view in module and feed the blog",
// "Can report posts to moderator" => "Can report posts to moderator",
// "Can view the archive of a newsletters" => "Can view the archive of a newsletters",
// "Can list newsletters" => "Can list newsletters",
// "Can admin toolbars" => "Can admin toolbars",
// "Can admin shoutbox (Edit/remove messages)" => "Can admin shoutbox (Edit/remove messages)",
// "Can change pending tracker items" => "Can change pending tracker items",
// "Can change closed tracker items" => "Can change closed tracker items",
// "Can re-vote a rating for tracker items" => "Can re-vote a rating for tracker items",
// "Can view closed trackers items" => "Can view closed trackers items",
// "Can view pending trackers items" => "Can view pending trackers items",
// "Can view in module and feed the wiki pages reference" => "Can view in module and feed the wiki pages reference",
// "Can admin attachments on wiki pages" => "Can admin attachments on wiki pages",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
// "Can view similar wiki pages" => "Can view similar wiki pages",
// "Can admin group webmail accounts" => "Can admin group webmail accounts",
// "Can admin personal webmail accounts" => "Can admin personal webmail accounts",
// "Trust all user inputs including plugins (no security checks)" => "Trust all user inputs including plugins (no security checks)",
// "Can invite user to my groups" => "Can invite user to my groups",
// "Can delete his/her own account" => "Can delete his/her own account",
// "Can use the importer" => "Can use the importer",
// "Can see the category in a listing" => "Can see the category in a listing",
// "Can change the categories of the object" => "Can change the categories of the object",
// "Can add objects to the category" => "Can add objects to the category",
// "Can remove objects from the category" => "Can remove objects from the category",
// "Can create new categories" => "Can create new categories",
// "Can view the perspective" => "Can view the perspective",
// "Can edit the perspective" => "Can edit the perspective",
// "Can create a perspective" => "Can create a perspective",
// "Can admin perspectives" => "Can admin perspectives",
// "Can view the group" => "Can view the group",
// "Can view the group members" => "Can view the group members",
// "Can add group members" => "Can add group members",
// "Can remove group members" => "Can remove group members",
// "Can join or leave the group" => "Can join or leave the group",
// "Can trigger the transition between two states" => "Can trigger the transition between two states",
// "Can admin kaltura feature" => "Can admin kaltura feature",
// "Can upload video on kaltura server" => "Can upload video on kaltura server",
// "Can edit information of kaltura entry" => "Can edit information of kaltura entry",
// "Can create kaltura remix video" => "Can create kaltura remix video",
// "Can delete kaltura entry" => "Can delete kaltura entry",
// "Can download kaltura entry" => "Can download kaltura entry",
// "Can list kaltura entries" => "Can list kaltura entries",
// "Can view kaltura entry" => "Can view kaltura entry",
// "Can execute arbitrary queries on a given DSN" => "Can execute arbitrary queries on a given DSN",
// "Can administer payments" => "Can administer payments",
// "Can view payment requests and details" => "Can view payment requests and details",
// "Can enter manual payments" => "Can enter manual payments",
// "Can request a payment" => "Can request a payment",
// "User can administer modules" => "User can administer modules",
// "Can save a .CSV backup of entire trackers" => "Can save a .CSV backup of entire trackers",
// "Can join a meeting" => "Can join a meeting",
// "Can moderate a meeting" => "Can moderate a meeting",
// "Can create a meeting" => "Can create a meeting",
// "user can use social network integration" => "user can use social network integration",
// "user can register this site with social networks" => "user can register this site with social networks",
// "Can view contributions to a page" => "Can view contributions to a page",
// "Can invite users by email, and include them in groups" => "Can invite users by email, and include them in groups",
// "tiki release" => "tiki release",
// "feature version checks" => "feature version checks",
// "tiki needs upgrade" => "tiki needs upgrade",
// "tiki version last check" => "tiki version last check",
// "tiki version check frequency" => "tiki version check frequency",
// "lastUpdatePrefs" => "lastUpdatePrefs",
// "tiki domain prefix" => "tiki domain prefix",
// "tiki domain redirects" => "tiki domain redirects",
// "feature print indexed" => "feature print indexed",
// "groups are emulated" => "groups are emulated",
// "feature webdav" => "feature webdav",
// "feature wiki" => "feature wiki",
// "default wiki diff style" => "default wiki diff style",
// "feature backlinks" => "feature backlinks",
// "backlinks name len" => "backlinks name len",
// "feature dump" => "feature dump",
// "feature history" => "feature history",
// "feature page contribution" => "feature page contribution",
// "feature lastChanges" => "feature lastChanges",
// "feature likePages" => "feature likePages",
// "feature listPages" => "feature listPages",
// "feature listorphanPages" => "feature listorphanPages",
// "feature listorphanStructure" => "feature listorphanStructure",
// "feature page title" => "feature page title",
// "wiki page name above" => "wiki page name above",
// "feature sandbox" => "feature sandbox",
// "feature warn on edit" => "feature warn on edit",
// "feature wiki 1like redirection" => "feature wiki 1like redirection",
// "feature wiki allowhtml" => "feature wiki allowhtml",
// "feature wiki argvariable" => "feature wiki argvariable",
// "feature wiki attachments" => "feature wiki attachments",
// "feature wiki comments" => "feature wiki comments",
// "feature wiki description" => "feature wiki description",
// "feature wiki discuss" => "feature wiki discuss",
// "feature wiki export" => "feature wiki export",
// "feature wiki structure" => "feature wiki structure",
// "feature wiki import page" => "feature wiki import page",
// "feature wiki footnotes" => "feature wiki footnotes",
// "feature wiki icache" => "feature wiki icache",
// "feature wiki import html" => "feature wiki import html",
// "feature wiki mindmap" => "feature wiki mindmap",
// "feature wiki monosp" => "feature wiki monosp",
// "feature wiki multiprint" => "feature wiki multiprint",
// "feature wiki notepad" => "feature wiki notepad",
// "feature wiki make structure" => "feature wiki make structure",
// "feature wiki open as structure" => "feature wiki open as structure",
// "feature wiki pageid" => "feature wiki pageid",
// "feature wiki paragraph formatting" => "feature wiki paragraph formatting",
// "feature wiki paragraph formatting add br" => "feature wiki paragraph formatting add br",
// "feature wiki pictures" => "feature wiki pictures",
// "feature wiki plurals" => "feature wiki plurals",
// "feature wiki print" => "feature wiki print",
// "feature wiki protect email" => "feature wiki protect email",
// "feature wiki rankings" => "feature wiki rankings",
// "feature wiki ratings" => "feature wiki ratings",
// "wiki simple ratings" => "wiki simple ratings",
// "wiki simple ratings options" => "wiki simple ratings options",
// "feature wiki replace" => "feature wiki replace",
// "feature wiki show hide before" => "feature wiki show hide before",
// "feature wiki tables" => "feature wiki tables",
// "feature wiki templates" => "feature wiki templates",
// "feature wiki undo" => "feature wiki undo",
// "feature wiki userpage" => "feature wiki userpage",
// "feature wiki userpage prefix" => "feature wiki userpage prefix",
// "feature wiki usrlock" => "feature wiki usrlock",
// "feature wiki feedback polls" => "feature wiki feedback polls",
// "feature wiki save draft" => "feature wiki save draft",
// "feature wikiwords" => "feature wikiwords",
// "feature wikiwords usedash" => "feature wikiwords usedash",
// "feature wiki pagealias" => "feature wiki pagealias",
// "mailin autocheck" => "mailin autocheck",
// "mailin autocheckFreq" => "mailin autocheckFreq",
// "mailin autocheckLast" => "mailin autocheckLast",
// "page bar position" => "page bar position",
// "warn on edit time" => "warn on edit time",
// "wikiHomePage" => "wikiHomePage",
// "wikiLicensePage" => "wikiLicensePage",
// "wikiSubmitNotice" => "wikiSubmitNotice",
// "wiki authors style" => "wiki authors style",
// "wiki authors style by page" => "wiki authors style by page",
// "wiki show version" => "wiki show version",
// "wiki bot bar" => "wiki bot bar",
// "wiki cache" => "wiki cache",
// "wiki comments default ordering" => "wiki comments default ordering",
// "wiki comments displayed default" => "wiki comments displayed default",
// "wiki comments per page" => "wiki comments per page",
// "wiki comments allow per page" => "wiki comments allow per page",
// "wiki creator admin" => "wiki creator admin",
// "wiki feature copyrights" => "wiki feature copyrights",
// "wiki forum id" => "wiki forum id",
// "wiki left column" => "wiki left column",
// "wiki list backlinks" => "wiki list backlinks",
// "wiki list comment" => "wiki list comment",
// "wiki list comment len" => "wiki list comment len",
// "wiki list description" => "wiki list description",
// "wiki list description len" => "wiki list description len",
// "wiki list creator" => "wiki list creator",
// "wiki list hits" => "wiki list hits",
// "wiki list lastmodif" => "wiki list lastmodif",
// "wiki list lastver" => "wiki list lastver",
// "wiki list links" => "wiki list links",
// "wiki list name" => "wiki list name",
// "wiki list name len" => "wiki list name len",
// "wiki list size" => "wiki list size",
// "wiki list status" => "wiki list status",
// "wiki list user" => "wiki list user",
// "wiki list versions" => "wiki list versions",
// "wiki list language" => "wiki list language",
// "wiki list categories" => "wiki list categories",
// "wiki list categories path" => "wiki list categories path",
// "wiki list id" => "wiki list id",
// "wiki list sortorder" => "wiki list sortorder",
// "wiki list sortdirection" => "wiki list sortdirection",
// "wiki pagealias tokens" => "wiki pagealias tokens",
// "wiki prefixalias tokens" => "wiki prefixalias tokens",
// "wiki page regex" => "wiki page regex",
// "wiki page separator" => "wiki page separator",
// "wiki page navigation bar" => "wiki page navigation bar",
// "wiki actions bar" => "wiki actions bar",
// "wiki pagename strip" => "wiki pagename strip",
// "wiki right column" => "wiki right column",
// "wiki structure bar position" => "wiki structure bar position",
// "wiki top bar" => "wiki top bar",
// "wiki topline position" => "wiki topline position",
// "wiki uses slides" => "wiki uses slides",
// "wiki watch author" => "wiki watch author",
// "wiki watch comments" => "wiki watch comments",
// "wiki watch editor" => "wiki watch editor",
// "wiki watch minor" => "wiki watch minor",
// "feature wiki history full" => "feature wiki history full",
// "feature wiki categorize structure" => "feature wiki categorize structure",
// "feature wiki watch structure" => "feature wiki watch structure",
// "feature wikiapproval" => "feature wikiapproval",
// "wikiapproval prefix" => "wikiapproval prefix",
// "wikiapproval hideprefix" => "wikiapproval hideprefix",
// "wikiapproval delete staging" => "wikiapproval delete staging",
// "wikiapproval master group" => "wikiapproval master group",
// "wikiapproval staging category" => "wikiapproval staging category",
// "wikiapproval approved category" => "wikiapproval approved category",
// "wikiapproval outofsync category" => "wikiapproval outofsync category",
// "wikiapproval block editapproved" => "wikiapproval block editapproved",
// "wikiapproval sync categories" => "wikiapproval sync categories",
// "wikiapproval update freetags" => "wikiapproval update freetags",
// "wikiapproval combine freetags" => "wikiapproval combine freetags",
// "wiki edit section" => "wiki edit section",
// "wiki edit section level" => "wiki edit section level",
// "wiki edit icons toggle" => "wiki edit icons toggle",
// "wiki edit plugin" => "wiki edit plugin",
// "wiki validate plugin" => "wiki validate plugin",
// "wiki edit minor" => "wiki edit minor",
// "wiki badchar prevent" => "wiki badchar prevent",
// "wiki backlinks name len" => "wiki backlinks name len",
// "wiki ranking reload probability" => "wiki ranking reload probability",
// "wiki encourage contribution" => "wiki encourage contribution",
// "wiki timeout warning" => "wiki timeout warning",
// "wiki dynvar style" => "wiki dynvar style",
// "wiki dynvar multilingual" => "wiki dynvar multilingual",
// "wiki keywords" => "wiki keywords",
// "wiki likepages samelang only" => "wiki likepages samelang only",
// "wiki mandatory edit summary" => "wiki mandatory edit summary",
// "wikiplugin addtocart" => "wikiplugin addtocart",
// "wikiplugin addtogooglecal" => "wikiplugin addtogooglecal",
// "wikiplugin agentinfo" => "wikiplugin agentinfo",
// "wikiplugin alink" => "wikiplugin alink",
// "wikiplugin aname" => "wikiplugin aname",
// "wikiplugin annotation" => "wikiplugin annotation",
// "wikiplugin archivebuilder" => "wikiplugin archivebuilder",
// "wikiplugin article" => "wikiplugin article",
// "wikiplugin articles" => "wikiplugin articles",
// "wikiplugin attach" => "wikiplugin attach",
// "wikiplugin attributes" => "wikiplugin attributes",
// "wikiplugin author" => "wikiplugin author",
// "wikiplugin avatar" => "wikiplugin avatar",
// "wikiplugin back" => "wikiplugin back",
// "wikiplugin backlinks" => "wikiplugin backlinks",
// "wikiplugin banner" => "wikiplugin banner",
// "wikiplugin bigbluebutton" => "wikiplugin bigbluebutton",
// "wikiplugin bliptv" => "wikiplugin bliptv",
// "wikiplugin bloglist" => "wikiplugin bloglist",
// "wikiplugin box" => "wikiplugin box",
// "wikiplugin button" => "wikiplugin button",
// "wikiplugin calendar" => "wikiplugin calendar",
// "wikiplugin category" => "wikiplugin category",
// "wikiplugin catorphans" => "wikiplugin catorphans",
// "wikiplugin cclite" => "wikiplugin cclite",
// "wikiplugin catpath" => "wikiplugin catpath",
// "wikiplugin center" => "wikiplugin center",
// "wikiplugin chart" => "wikiplugin chart",
// "wikiplugin code" => "wikiplugin code",
// "wikiplugin colorbox" => "wikiplugin colorbox",
// "wikiplugin content" => "wikiplugin content",
// "wikiplugin cookie" => "wikiplugin cookie",
// "wikiplugin copyright" => "wikiplugin copyright",
// "wikiplugin countdown" => "wikiplugin countdown",
// "wikiplugin datachannel" => "wikiplugin datachannel",
// "wikiplugin dbreport" => "wikiplugin dbreport",
// "wikiplugin div" => "wikiplugin div",
// "wikiplugin dl" => "wikiplugin dl",
// "wikiplugin draw" => "wikiplugin draw",
// "wikiplugin equation" => "wikiplugin equation",
// "wikiplugin events" => "wikiplugin events",
// "wikiplugin fade" => "wikiplugin fade",
// "wikiplugin fancylist" => "wikiplugin fancylist",
// "wikiplugin fancytable" => "wikiplugin fancytable",
// "wikiplugin file" => "wikiplugin file",
// "wikiplugin files" => "wikiplugin files",
// "wikiplugin flash" => "wikiplugin flash",
// "wikiplugin footnote" => "wikiplugin footnote",
// "wikiplugin footnotearea" => "wikiplugin footnotearea",
// "wikiplugin freetagged" => "wikiplugin freetagged",
// "wikiplugin ftp" => "wikiplugin ftp",
// "wikiplugin gauge" => "wikiplugin gauge",
// "wikiplugin googleanalytics" => "wikiplugin googleanalytics",
// "wikiplugin googledoc" => "wikiplugin googledoc",
// "wikiplugin googlemap" => "wikiplugin googlemap",
// "wikiplugin group" => "wikiplugin group",
// "wikiplugin grouplist" => "wikiplugin grouplist",
// "wikiplugin groupmailcore" => "wikiplugin groupmailcore",
// "wikiplugin groupstat" => "wikiplugin groupstat",
// "wikiplugin html" => "wikiplugin html",
// "wikiplugin iframe" => "wikiplugin iframe",
// "wikiplugin img" => "wikiplugin img",
// "wikiplugin image" => "wikiplugin image",
// "wikiplugin include" => "wikiplugin include",
// "wikiplugin randominclude" => "wikiplugin randominclude",
// "wikiplugin invite" => "wikiplugin invite",
// "wikiplugin jabber" => "wikiplugin jabber",
// "wikiplugin js" => "wikiplugin js",
// "wikiplugin jq" => "wikiplugin jq",
// "wikiplugin lang" => "wikiplugin lang",
// "wikiplugin lastmod" => "wikiplugin lastmod",
// "wikiplugin listpages" => "wikiplugin listpages",
// "wikiplugin lsdir" => "wikiplugin lsdir",
// "wikiplugin mail" => "wikiplugin mail",
// "wikiplugin map" => "wikiplugin map",
// "wikiplugin mcalendar" => "wikiplugin mcalendar",
// "wikiplugin mediaplayer" => "wikiplugin mediaplayer",
// "wikiplugin memberlist" => "wikiplugin memberlist",
// "wikiplugin memberpayment" => "wikiplugin memberpayment",
// "wikiplugin miniquiz" => "wikiplugin miniquiz",
// "wikiplugin module" => "wikiplugin module",
// "wikiplugin mono" => "wikiplugin mono",
// "wikiplugin mouseover" => "wikiplugin mouseover",
// "wikiplugin mwtable" => "wikiplugin mwtable",
// "wikiplugin myspace" => "wikiplugin myspace",
// "wikiplugin objecthits" => "wikiplugin objecthits",
// "wikiplugin payment" => "wikiplugin payment",
// "wikiplugin perm" => "wikiplugin perm",
// "wikiplugin picture" => "wikiplugin picture",
// "wikiplugin pluginmanager" => "wikiplugin pluginmanager",
// "wikiplugin poll" => "wikiplugin poll",
// "wikiplugin profile" => "wikiplugin profile",
// "wikiplugin proposal" => "wikiplugin proposal",
// "wikiplugin quote" => "wikiplugin quote",
// "wikiplugin rcontent" => "wikiplugin rcontent",
// "wikiplugin realnamelist" => "wikiplugin realnamelist",
// "wikiplugin redirect" => "wikiplugin redirect",
// "wikiplugin regex" => "wikiplugin regex",
// "wikiplugin remarksbox" => "wikiplugin remarksbox",
// "wikiplugin rss" => "wikiplugin rss",
// "wikiplugin scroll" => "wikiplugin scroll",
// "wikiplugin sf" => "wikiplugin sf",
// "wikiplugin share" => "wikiplugin share",
// "wikiplugin sharethis" => "wikiplugin sharethis",
// "wikiplugin sheet" => "wikiplugin sheet",
// "wikiplugin showpages" => "wikiplugin showpages",
// "wikiplugin skype" => "wikiplugin skype",
// "wikiplugin smarty" => "wikiplugin smarty",
// "wikiplugin snarf" => "wikiplugin snarf",
// "wikiplugin snarf cache" => "wikiplugin snarf cache",
// "wikiplugin sort" => "wikiplugin sort",
// "wikiplugin split" => "wikiplugin split",
// "wikiplugin sql" => "wikiplugin sql",
// "wikiplugin stat" => "wikiplugin stat",
// "wikiplugin sub" => "wikiplugin sub",
// "wikiplugin subscribegroup" => "wikiplugin subscribegroup",
// "wikiplugin subscribegroups" => "wikiplugin subscribegroups",
// "wikiplugin subscribenewsletter" => "wikiplugin subscribenewsletter",
// "wikiplugin sup" => "wikiplugin sup",
// "wikiplugin survey" => "wikiplugin survey",
// "wikiplugin tag" => "wikiplugin tag",
// "wikiplugin tabs" => "wikiplugin tabs",
// "wikiplugin thumb" => "wikiplugin thumb",
// "wikiplugin titlesearch" => "wikiplugin titlesearch",
// "wikiplugin toc" => "wikiplugin toc",
// "wikiplugin topfriends" => "wikiplugin topfriends",
// "wikiplugin trackercomments" => "wikiplugin trackercomments",
// "wikiplugin trackerfilter" => "wikiplugin trackerfilter",
// "wikiplugin trackeritemfield" => "wikiplugin trackeritemfield",
// "wikiplugin trackerlist" => "wikiplugin trackerlist",
// "wikiplugin trackertimeline" => "wikiplugin trackertimeline",
// "wikiplugin tracker" => "wikiplugin tracker",
// "wikiplugin trackerprefill" => "wikiplugin trackerprefill",
// "wikiplugin trackerstat" => "wikiplugin trackerstat",
// "wikiplugin trade" => "wikiplugin trade",
// "wikiplugin transclude" => "wikiplugin transclude",
// "wikiplugin translated" => "wikiplugin translated",
// "wikiplugin tr" => "wikiplugin tr",
// "wikiplugin usercount" => "wikiplugin usercount",
// "wikiplugin userlink" => "wikiplugin userlink",
// "wikiplugin userlist" => "wikiplugin userlist",
// "wikiplugin userpref" => "wikiplugin userpref",
// "wikiplugin versions" => "wikiplugin versions",
// "wikiplugin vimeo" => "wikiplugin vimeo",
// "wikiplugin vote" => "wikiplugin vote",
// "wikiplugin watershed" => "wikiplugin watershed",
// "wikiplugin wantedpages" => "wikiplugin wantedpages",
// "wikiplugin webservice" => "wikiplugin webservice",
// "wikiplugin youtube" => "wikiplugin youtube",
// "wikiplugininline addtocart" => "wikiplugininline addtocart",
// "wikiplugininline addtogooglecal" => "wikiplugininline addtogooglecal",
// "wikiplugininline agentinfo" => "wikiplugininline agentinfo",
// "wikiplugininline alink" => "wikiplugininline alink",
// "wikiplugininline aname" => "wikiplugininline aname",
// "wikiplugininline annotation" => "wikiplugininline annotation",
// "wikiplugininline archivebuilder" => "wikiplugininline archivebuilder",
// "wikiplugininline article" => "wikiplugininline article",
// "wikiplugininline articles" => "wikiplugininline articles",
// "wikiplugininline attach" => "wikiplugininline attach",
// "wikiplugininline attributes" => "wikiplugininline attributes",
// "wikiplugininline avatar" => "wikiplugininline avatar",
// "wikiplugininline back" => "wikiplugininline back",
// "wikiplugininline backlinks" => "wikiplugininline backlinks",
// "wikiplugininline banner" => "wikiplugininline banner",
// "wikiplugininline bigbluebutton" => "wikiplugininline bigbluebutton",
// "wikiplugininline bliptv" => "wikiplugininline bliptv",
// "wikiplugininline bloglist" => "wikiplugininline bloglist",
// "wikiplugininline box" => "wikiplugininline box",
// "wikiplugininline button" => "wikiplugininline button",
// "wikiplugininline calendar" => "wikiplugininline calendar",
// "wikiplugininline category" => "wikiplugininline category",
// "wikiplugininline catorphans" => "wikiplugininline catorphans",
// "wikiplugininline catpath" => "wikiplugininline catpath",
// "wikiplugininline cclite" => "wikiplugininline cclite",
// "wikiplugininline center" => "wikiplugininline center",
// "wikiplugininline chart" => "wikiplugininline chart",
// "wikiplugininline code" => "wikiplugininline code",
// "wikiplugininline colorbox" => "wikiplugininline colorbox",
// "wikiplugininline content" => "wikiplugininline content",
// "wikiplugininline cookie" => "wikiplugininline cookie",
// "wikiplugininline copyright" => "wikiplugininline copyright",
// "wikiplugininline countdown" => "wikiplugininline countdown",
// "wikiplugininline datachannel" => "wikiplugininline datachannel",
// "wikiplugininline dbreport" => "wikiplugininline dbreport",
// "wikiplugininline div" => "wikiplugininline div",
// "wikiplugininline dl" => "wikiplugininline dl",
// "wikiplugininline draw" => "wikiplugininline draw",
// "wikiplugininline equation" => "wikiplugininline equation",
// "wikiplugininline events" => "wikiplugininline events",
// "wikiplugininline fade" => "wikiplugininline fade",
// "wikiplugininline fancylist" => "wikiplugininline fancylist",
// "wikiplugininline fancytable" => "wikiplugininline fancytable",
// "wikiplugininline file" => "wikiplugininline file",
// "wikiplugininline files" => "wikiplugininline files",
// "wikiplugininline flash" => "wikiplugininline flash",
// "wikiplugininline footnote" => "wikiplugininline footnote",
// "wikiplugininline footnotearea" => "wikiplugininline footnotearea",
// "wikiplugininline freetagged" => "wikiplugininline freetagged",
// "wikiplugininline ftp" => "wikiplugininline ftp",
// "wikiplugininline gauge" => "wikiplugininline gauge",
// "wikiplugininline googleanalytics" => "wikiplugininline googleanalytics",
// "wikiplugininline googledoc" => "wikiplugininline googledoc",
// "wikiplugininline googlemap" => "wikiplugininline googlemap",
// "wikiplugininline group" => "wikiplugininline group",
// "wikiplugininline grouplist" => "wikiplugininline grouplist",
// "wikiplugininline groupmailcore" => "wikiplugininline groupmailcore",
// "wikiplugininline groupstat" => "wikiplugininline groupstat",
// "wikiplugininline html" => "wikiplugininline html",
// "wikiplugininline iframe" => "wikiplugininline iframe",
// "wikiplugininline img" => "wikiplugininline img",
// "wikiplugininline image" => "wikiplugininline image",
// "wikiplugininline include" => "wikiplugininline include",
// "wikiplugininline invite" => "wikiplugininline invite",
// "wikiplugininline jabber" => "wikiplugininline jabber",
// "wikiplugininline js" => "wikiplugininline js",
// "wikiplugininline jq" => "wikiplugininline jq",
// "wikiplugininline lang" => "wikiplugininline lang",
// "wikiplugininline lastmod" => "wikiplugininline lastmod",
// "wikiplugininline listpages" => "wikiplugininline listpages",
// "wikiplugininline lsdir" => "wikiplugininline lsdir",
// "wikiplugininline mail" => "wikiplugininline mail",
// "wikiplugininline map" => "wikiplugininline map",
// "wikiplugininline mcalendar" => "wikiplugininline mcalendar",
// "wikiplugininline mediaplayer" => "wikiplugininline mediaplayer",
// "wikiplugininline memberlist" => "wikiplugininline memberlist",
// "wikiplugininline memberpayment" => "wikiplugininline memberpayment",
// "wikiplugininline miniquiz" => "wikiplugininline miniquiz",
// "wikiplugininline module" => "wikiplugininline module",
// "wikiplugininline mono" => "wikiplugininline mono",
// "wikiplugininline mouseover" => "wikiplugininline mouseover",
// "wikiplugininline mwtable" => "wikiplugininline mwtable",
// "wikiplugininline myspace" => "wikiplugininline myspace",
// "wikiplugininline objecthits" => "wikiplugininline objecthits",
// "wikiplugininline payment" => "wikiplugininline payment",
// "wikiplugininline perm" => "wikiplugininline perm",
// "wikiplugininline picture" => "wikiplugininline picture",
// "wikiplugininline pluginmanager" => "wikiplugininline pluginmanager",
// "wikiplugininline poll" => "wikiplugininline poll",
// "wikiplugininline profile" => "wikiplugininline profile",
// "wikiplugininline proposal" => "wikiplugininline proposal",
// "wikiplugininline quote" => "wikiplugininline quote",
// "wikiplugininline rcontent" => "wikiplugininline rcontent",
// "wikiplugininline randominclude" => "wikiplugininline randominclude",
// "wikiplugininline realnamelist" => "wikiplugininline realnamelist",
// "wikiplugininline redirect" => "wikiplugininline redirect",
// "wikiplugininline regex" => "wikiplugininline regex",
// "wikiplugininline remarksbox" => "wikiplugininline remarksbox",
// "wikiplugininline rss" => "wikiplugininline rss",
// "wikiplugininline scroll" => "wikiplugininline scroll",
// "wikiplugininline sf" => "wikiplugininline sf",
// "wikiplugininline share" => "wikiplugininline share",
// "wikiplugininline sharethis" => "wikiplugininline sharethis",
// "wikiplugininline sheet" => "wikiplugininline sheet",
// "wikiplugininline showpages" => "wikiplugininline showpages",
// "wikiplugininline skype" => "wikiplugininline skype",
// "wikiplugininline smarty" => "wikiplugininline smarty",
// "wikiplugininline snarf" => "wikiplugininline snarf",
// "wikiplugininline sort" => "wikiplugininline sort",
// "wikiplugininline split" => "wikiplugininline split",
// "wikiplugininline sql" => "wikiplugininline sql",
// "wikiplugininline stat" => "wikiplugininline stat",
// "wikiplugininline sub" => "wikiplugininline sub",
// "wikiplugininline subscribegroup" => "wikiplugininline subscribegroup",
// "wikiplugininline subscribegroups" => "wikiplugininline subscribegroups",
// "wikiplugininline subscribenewsletter" => "wikiplugininline subscribenewsletter",
// "wikiplugininline sup" => "wikiplugininline sup",
// "wikiplugininline survey" => "wikiplugininline survey",
// "wikiplugininline tag" => "wikiplugininline tag",
// "wikiplugininline tabs" => "wikiplugininline tabs",
// "wikiplugininline thumb" => "wikiplugininline thumb",
// "wikiplugininline titlesearch" => "wikiplugininline titlesearch",
// "wikiplugininline toc" => "wikiplugininline toc",
// "wikiplugininline topfriends" => "wikiplugininline topfriends",
// "wikiplugininline trackercomments" => "wikiplugininline trackercomments",
// "wikiplugininline trackerfilter" => "wikiplugininline trackerfilter",
// "wikiplugininline trackeritemfield" => "wikiplugininline trackeritemfield",
// "wikiplugininline trackerlist" => "wikiplugininline trackerlist",
// "wikiplugininline trackertimeline" => "wikiplugininline trackertimeline",
// "wikiplugininline tracker" => "wikiplugininline tracker",
// "wikiplugininline trackerprefill" => "wikiplugininline trackerprefill",
// "wikiplugininline trackerstat" => "wikiplugininline trackerstat",
// "wikiplugininline trade" => "wikiplugininline trade",
// "wikiplugininline transclude" => "wikiplugininline transclude",
// "wikiplugininline translated" => "wikiplugininline translated",
// "wikiplugininline tr" => "wikiplugininline tr",
// "wikiplugininline usercount" => "wikiplugininline usercount",
// "wikiplugininline userlink" => "wikiplugininline userlink",
// "wikiplugininline userlist" => "wikiplugininline userlist",
// "wikiplugininline userpref" => "wikiplugininline userpref",
// "wikiplugininline versions" => "wikiplugininline versions",
// "wikiplugininline vimeo" => "wikiplugininline vimeo",
// "wikiplugininline vote" => "wikiplugininline vote",
// "wikiplugininline watershed" => "wikiplugininline watershed",
// "wikiplugininline wantedpages" => "wikiplugininline wantedpages",
// "wikiplugininline webservice" => "wikiplugininline webservice",
// "wikiplugininline youtube" => "wikiplugininline youtube",
// "wikiplugininline author" => "wikiplugininline author",
// "webservice consume defaultcache" => "webservice consume defaultcache",
// "feature webservices" => "feature webservices",
// "feature semantic" => "feature semantic",
// "feature wysiwyg" => "feature wysiwyg",
// "wysiwyg optional" => "wysiwyg optional",
// "wysiwyg default" => "wysiwyg default",
// "wysiwyg memo" => "wysiwyg memo",
// "wysiwyg wiki parsed" => "wysiwyg wiki parsed",
// "wysiwyg wiki semi parsed" => "wysiwyg wiki semi parsed",
// "wysiwyg toolbar skin" => "wysiwyg toolbar skin",
// "wysiwyg htmltowiki" => "wysiwyg htmltowiki",
// "wysiwyg fonts" => "wysiwyg fonts",
// "wiki feature 3d" => "wiki feature 3d",
// "wiki 3d width" => "wiki 3d width",
// "wiki 3d height" => "wiki 3d height",
// "wiki 3d navigation depth" => "wiki 3d navigation depth",
// "wiki 3d feed animation interval" => "wiki 3d feed animation interval",
// "wiki 3d existing page color" => "wiki 3d existing page color",
// "wiki 3d missing page color" => "wiki 3d missing page color",
// "feature blogs" => "feature blogs",
// "blog list order" => "blog list order",
// "home blog" => "home blog",
// "feature blog rankings" => "feature blog rankings",
// "blog comments default ordering" => "blog comments default ordering",
// "blog comments per page" => "blog comments per page",
// "feature blogposts comments" => "feature blogposts comments",
// "blog list user" => "blog list user",
// "blog list title" => "blog list title",
// "blog list title len" => "blog list title len",
// "blog list description" => "blog list description",
// "blog list created" => "blog list created",
// "blog list lastmodif" => "blog list lastmodif",
// "blog list posts" => "blog list posts",
// "blog list visits" => "blog list visits",
// "blog list activity" => "blog list activity",
// "feature blog mandatory category" => "feature blog mandatory category",
// "feature blog heading" => "feature blog heading",
// "feature blog edit publish date" => "feature blog edit publish date",
// "feature blog sharethis" => "feature blog sharethis",
// "blog sharethis publisher" => "blog sharethis publisher",
// "feature file galleries" => "feature file galleries",
// "home file gallery" => "home file gallery",
// "fgal root id" => "fgal root id",
// "fgal use db" => "fgal use db",
// "fgal batch dir" => "fgal batch dir",
// "fgal match regex" => "fgal match regex",
// "fgal nmatch regex" => "fgal nmatch regex",
// "fgal use dir" => "fgal use dir",
// "fgal podcast dir" => "fgal podcast dir",
// "feature file galleries comments" => "feature file galleries comments",
// "file galleries comments default ordering" => "file galleries comments default ordering",
// "file galleries comments per page" => "file galleries comments per page",
// "feature file galleries batch" => "feature file galleries batch",
// "feature file galleries rankings" => "feature file galleries rankings",
// "fgal enable auto indexing" => "fgal enable auto indexing",
// "fgal asynchronous indexing" => "fgal asynchronous indexing",
// "fgal allow duplicates" => "fgal allow duplicates",
// "fgal sort mode" => "fgal sort mode",
// "feature file galleries author" => "feature file galleries author",
// "fgal list id" => "fgal list id",
// "fgal list type" => "fgal list type",
// "fgal list name" => "fgal list name",
// "fgal list description" => "fgal list description",
// "fgal list size" => "fgal list size",
// "fgal list created" => "fgal list created",
// "fgal list lastModif" => "fgal list lastModif",
// "fgal list creator" => "fgal list creator",
// "fgal list author" => "fgal list author",
// "fgal list last user" => "fgal list last user",
// "fgal list comment" => "fgal list comment",
// "fgal list files" => "fgal list files",
// "fgal list hits" => "fgal list hits",
// "fgal list lastDownload" => "fgal list lastDownload",
// "fgal list lockedby" => "fgal list lockedby",
// "fgal show path" => "fgal show path",
// "fgal show explorer" => "fgal show explorer",
// "fgal show slideshow" => "fgal show slideshow",
// "fgal default view" => "fgal default view",
// "fgal limit hits per file" => "fgal limit hits per file",
// "fgal prevent negative score" => "fgal prevent negative score",
// "fgal quota" => "fgal quota",
// "fgal quota per fgal" => "fgal quota per fgal",
// "fgal quota default" => "fgal quota default",
// "fgal quota show" => "fgal quota show",
// "fgal list backlinks" => "fgal list backlinks",
// "fgal search in content" => "fgal search in content",
// "fgal search" => "fgal search",
// "fgal delete after" => "fgal delete after",
// "fgal delete after email" => "fgal delete after email",
// "fgal list id admin" => "fgal list id admin",
// "fgal list type admin" => "fgal list type admin",
// "fgal list name admin" => "fgal list name admin",
// "fgal list description admin" => "fgal list description admin",
// "fgal list size admin" => "fgal list size admin",
// "fgal list created admin" => "fgal list created admin",
// "fgal list lastModif admin" => "fgal list lastModif admin",
// "fgal list creator admin" => "fgal list creator admin",
// "fgal list author admin" => "fgal list author admin",
// "fgal list last user admin" => "fgal list last user admin",
// "fgal list comment admin" => "fgal list comment admin",
// "fgal list files admin" => "fgal list files admin",
// "fgal list hits admin" => "fgal list hits admin",
// "fgal list lastDownload admin" => "fgal list lastDownload admin",
// "fgal list lockedby admin" => "fgal list lockedby admin",
// "fgal list backlinks admin" => "fgal list backlinks admin",
// "fgal keep fileId" => "fgal keep fileId",
// "fgal show thumbactions" => "fgal show thumbactions",
// "fgal thumb max size" => "fgal thumb max size",
// "feature galleries" => "feature galleries",
// "feature gal batch" => "feature gal batch",
// "feature gal slideshow" => "feature gal slideshow",
// "home gallery" => "home gallery",
// "gal use db" => "gal use db",
// "gal use lib" => "gal use lib",
// "gal match regex" => "gal match regex",
// "gal nmatch regex" => "gal nmatch regex",
// "gal use dir" => "gal use dir",
// "gal batch dir" => "gal batch dir",
// "feature gal rankings" => "feature gal rankings",
// "feature image galleries comments" => "feature image galleries comments",
// "image galleries comments default order" => "image galleries comments default order",
// "image galleries comments per page" => "image galleries comments per page",
// "gal list name" => "gal list name",
// "gal list parent" => "gal list parent",
// "gal list description" => "gal list description",
// "gal list created" => "gal list created",
// "gal list lastmodif" => "gal list lastmodif",
// "gal list user" => "gal list user",
// "gal list imgs" => "gal list imgs",
// "gal list visits" => "gal list visits",
// "feature image gallery mandatory category" => "feature image gallery mandatory category",
// "preset galleries info" => "preset galleries info",
// "gal image mouseover" => "gal image mouseover",
// "feature forums" => "feature forums",
// "home forum" => "home forum",
// "feature forum rankings" => "feature forum rankings",
// "feature forum parse" => "feature forum parse",
// "feature forum topics archiving" => "feature forum topics archiving",
// "feature forum replyempty" => "feature forum replyempty",
// "feature forum quickjump" => "feature forum quickjump",
// "feature forums allow thread titles" => "feature forums allow thread titles",
// "feature forum content search" => "feature forum content search",
// "feature forums name search" => "feature forums name search",
// "forums ordering" => "forums ordering",
// "forum list topics" => "forum list topics",
// "forum list posts" => "forum list posts",
// "forum list ppd" => "forum list ppd",
// "forum list lastpost" => "forum list lastpost",
// "forum list visits" => "forum list visits",
// "forum list desc" => "forum list desc",
// "forum list description len" => "forum list description len",
// "feature forum local search" => "feature forum local search",
// "feature forum local tiki search" => "feature forum local tiki search",
// "forum thread defaults by forum" => "forum thread defaults by forum",
// "forum thread user settings" => "forum thread user settings",
// "forum thread user settings threshold" => "forum thread user settings threshold",
// "forum thread user settings keep" => "forum thread user settings keep",
// "forum comments per page" => "forum comments per page",
// "forum comments no title prefix" => "forum comments no title prefix",
// "forum thread style" => "forum thread style",
// "forum thread sort mode" => "forum thread sort mode",
// "forum match regex" => "forum match regex",
// "forum reply notitle" => "forum reply notitle",
// "feature articles" => "feature articles",
// "feature submissions" => "feature submissions",
// "feature cms rankings" => "feature cms rankings",
// "feature cms print" => "feature cms print",
// "feature cms emails" => "feature cms emails",
// "feature cms sharethis" => "feature cms sharethis",
// "art sort mode" => "art sort mode",
// "art list title" => "art list title",
// "art list title len" => "art list title len",
// "art list id" => "art list id",
// "art list topic" => "art list topic",
// "art list date" => "art list date",
// "art list author" => "art list author",
// "art list rating" => "art list rating",
// "art list reads" => "art list reads",
// "art list size" => "art list size",
// "art list expire" => "art list expire",
// "art list img" => "art list img",
// "art list type" => "art list type",
// "art list visible" => "art list visible",
// "art view type" => "art view type",
// "art view title" => "art view title",
// "art view topic" => "art view topic",
// "art view date" => "art view date",
// "art view author" => "art view author",
// "art view reads" => "art view reads",
// "art view size" => "art view size",
// "art view img" => "art view img",
// "art list lang" => "art list lang",
// "art trailer pos" => "art trailer pos",
// "art header text pos" => "art header text pos",
// "feature article comments" => "feature article comments",
// "article comments default ordering" => "article comments default ordering",
// "article comments per page" => "article comments per page",
// "article paginate" => "article paginate",
// "article user rating" => "article user rating",
// "article user rating options" => "article user rating options",
// "article image size x" => "article image size x",
// "article image size y" => "article image size y",
// "article custom attributes" => "article custom attributes",
// "article sharethis publisher" => "article sharethis publisher",
// "feature cms templates" => "feature cms templates",
// "cms bot bar" => "cms bot bar",
// "cms left column" => "cms left column",
// "cms right column" => "cms right column",
// "cms top bar" => "cms top bar",
// "art home title" => "art home title",
// "feature trackers" => "feature trackers",
// "t use db" => "t use db",
// "t use dir" => "t use dir",
// "groupTracker" => "groupTracker",
// "userTracker" => "userTracker",
// "trackerCreatorGroupName" => "trackerCreatorGroupName",
// "user selector threshold" => "user selector threshold",
// "user selector realnames tracker" => "user selector realnames tracker",
// "user selector realnames messu" => "user selector realnames messu",
// "feature userlevels" => "feature userlevels",
// "userlevels" => "userlevels",
// "userbreadCrumb" => "userbreadCrumb",
// "user assigned modules" => "user assigned modules",
// "user flip modules" => "user flip modules",
// "user show realnames" => "user show realnames",
// "user store file gallery picture" => "user store file gallery picture",
// "user picture gallery id" => "user picture gallery id",
// "user who viewed my stuff" => "user who viewed my stuff",
// "user who viewed my stuff days" => "user who viewed my stuff days",
// "user who viewed my stuff show others" => "user who viewed my stuff show others",
// "user register prettytracker" => "user register prettytracker",
// "user register prettytracker tpl" => "user register prettytracker tpl",
// "user trackersync trackers" => "user trackersync trackers",
// "user trackersync realname" => "user trackersync realname",
// "user trackersync geo" => "user trackersync geo",
// "user trackersync groups" => "user trackersync groups",
// "user trackersync parentgroup" => "user trackersync parentgroup",
// "feature mytiki" => "feature mytiki",
// "feature userPreferences" => "feature userPreferences",
// "feature user bookmarks" => "feature user bookmarks",
// "feature tasks" => "feature tasks",
// "w use db" => "w use db",
// "w use dir" => "w use dir",
// "w displayed default" => "w displayed default",
// "uf use db" => "uf use db",
// "uf use dir" => "uf use dir",
// "userfiles quota" => "userfiles quota",
// "feature usermenu" => "feature usermenu",
// "feature minical" => "feature minical",
// "feature notepad" => "feature notepad",
// "feature userfiles" => "feature userfiles",
// "feature community gender" => "feature community gender",
// "feature community mouseover" => "feature community mouseover",
// "feature community mouseover name" => "feature community mouseover name",
// "feature community mouseover gender" => "feature community mouseover gender",
// "feature community mouseover picture" => "feature community mouseover picture",
// "feature community mouseover friends" => "feature community mouseover friends",
// "feature community mouseover score" => "feature community mouseover score",
// "feature community mouseover country" => "feature community mouseover country",
// "feature community mouseover email" => "feature community mouseover email",
// "feature community mouseover lastlogin" => "feature community mouseover lastlogin",
// "feature community mouseover distance" => "feature community mouseover distance",
// "feature community list name" => "feature community list name",
// "feature community list score" => "feature community list score",
// "feature community list country" => "feature community list country",
// "feature community list distance" => "feature community list distance",
// "feature community friends permission" => "feature community friends permission",
// "feature community friends permission dep" => "feature community friends permission dep",
// "change language" => "change language",
// "change theme" => "change theme",
// "login is email" => "login is email",
// "login is email obscure" => "login is email obscure",
// "validateUsers" => "validateUsers",
// "validateEmail" => "validateEmail",
// "forgotPass" => "forgotPass",
// "change password" => "change password",
// "available languages" => "available languages",
// "available styles" => "available styles",
// "lowercase username" => "lowercase username",
// "username pattern" => "username pattern",
// "max username length" => "max username length",
// "min username length" => "min username length",
// "users serve avatar static" => "users serve avatar static",
// "users prefs allowMsgs" => "users prefs allowMsgs",
// "users prefs country" => "users prefs country",
// "users prefs diff versions" => "users prefs diff versions",
// "users prefs display timezone" => "users prefs display timezone",
// "users prefs email is public" => "users prefs email is public",
// "users prefs homePage" => "users prefs homePage",
// "users prefs lat" => "users prefs lat",
// "users prefs lon" => "users prefs lon",
// "users prefs mess archiveAfter" => "users prefs mess archiveAfter",
// "users prefs mess maxRecords" => "users prefs mess maxRecords",
// "users prefs mess sendReadStatus" => "users prefs mess sendReadStatus",
// "users prefs minPrio" => "users prefs minPrio",
// "users prefs mytiki blogs" => "users prefs mytiki blogs",
// "users prefs mytiki articles" => "users prefs mytiki articles",
// "users prefs mytiki gals" => "users prefs mytiki gals",
// "users prefs mytiki items" => "users prefs mytiki items",
// "users prefs mytiki msgs" => "users prefs mytiki msgs",
// "users prefs mytiki pages" => "users prefs mytiki pages",
// "users prefs mytiki tasks" => "users prefs mytiki tasks",
// "users prefs mytiki forum topics" => "users prefs mytiki forum topics",
// "users prefs mytiki forum replies" => "users prefs mytiki forum replies",
// "users prefs realName" => "users prefs realName",
// "users prefs gender" => "users prefs gender",
// "users prefs show mouseover user info" => "users prefs show mouseover user info",
// "users prefs tasks maxRecords" => "users prefs tasks maxRecords",
// "users prefs user dbl" => "users prefs user dbl",
// "users prefs user information" => "users prefs user information",
// "users prefs userbreadCrumb" => "users prefs userbreadCrumb",
// "users prefs mailCharset" => "users prefs mailCharset",
// "users prefs mailCurrentAccount" => "users prefs mailCurrentAccount",
// "validateRegistration" => "validateRegistration",
// "validator emails" => "validator emails",
// "url after validation" => "url after validation",
// "urlOnUsername" => "urlOnUsername",
// "feature messages" => "feature messages",
// "messu mailbox size" => "messu mailbox size",
// "messu archive size" => "messu archive size",
// "messu sent size" => "messu sent size",
// "allowmsg by default" => "allowmsg by default",
// "allowmsg is optional" => "allowmsg is optional",
// "feature freetags" => "feature freetags",
// "freetags browse show cloud" => "freetags browse show cloud",
// "freetags cloud colors" => "freetags cloud colors",
// "freetags preload random search" => "freetags preload random search",
// "freetags browse amount tags in cloud" => "freetags browse amount tags in cloud",
// "freetags browse amount tags suggestion" => "freetags browse amount tags suggestion",
// "freetags normalized valid chars" => "freetags normalized valid chars",
// "freetags lowercase only" => "freetags lowercase only",
// "freetags feature 3d" => "freetags feature 3d",
// "freetags 3d width" => "freetags 3d width",
// "freetags 3d height" => "freetags 3d height",
// "freetags 3d navigation depth" => "freetags 3d navigation depth",
// "freetags 3d feed animation interval" => "freetags 3d feed animation interval",
// "freetags 3d existing page color" => "freetags 3d existing page color",
// "freetags 3d missing page color" => "freetags 3d missing page color",
// "freetags 3d autoload" => "freetags 3d autoload",
// "freetags 3d camera distance" => "freetags 3d camera distance",
// "freetags 3d elastic constant" => "freetags 3d elastic constant",
// "freetags 3d eletrostatic constant" => "freetags 3d eletrostatic constant",
// "freetags 3d fov" => "freetags 3d fov",
// "freetags 3d friction constant" => "freetags 3d friction constant",
// "freetags 3d node charge" => "freetags 3d node charge",
// "freetags 3d node mass" => "freetags 3d node mass",
// "freetags 3d node size" => "freetags 3d node size",
// "freetags 3d spring size" => "freetags 3d spring size",
// "freetags 3d text size" => "freetags 3d text size",
// "freetags 3d adjust camera" => "freetags 3d adjust camera",
// "freetags multilingual" => "freetags multilingual",
// "morelikethis algorithm" => "morelikethis algorithm",
// "morelikethis basic mincommon" => "morelikethis basic mincommon",
// "freetags show middle" => "freetags show middle",
// "feature search stats" => "feature search stats",
// "feature search" => "feature search",
// "feature search fulltext" => "feature search fulltext",
// "feature search show forbidden obj" => "feature search show forbidden obj",
// "feature search show forbidden cat" => "feature search show forbidden cat",
// "feature search show object filter" => "feature search show object filter",
// "feature search show search box" => "feature search show search box",
// "feature search show visit count" => "feature search show visit count",
// "feature search show pertinence" => "feature search show pertinence",
// "feature search show object type" => "feature search show object type",
// "feature search show last modification" => "feature search show last modification",
// "search refresh index mode" => "search refresh index mode",
// "search parsed snippet" => "search parsed snippet",
// "search default where" => "search default where",
// "search default interface language" => "search default interface language",
// "search autocomplete" => "search autocomplete",
// "feature webmail" => "feature webmail",
// "webmail max attachment" => "webmail max attachment",
// "webmail view html" => "webmail view html",
// "webmail quick flags" => "webmail quick flags",
// "feature contacts" => "feature contacts",
// "feature faqs" => "feature faqs",
// "feature faq comments" => "feature faq comments",
// "faq comments per page" => "faq comments per page",
// "faq comments default ordering" => "faq comments default ordering",
// "faq prefix" => "faq prefix",
// "feature quizzes" => "feature quizzes",
// "feature polls" => "feature polls",
// "feature poll comments" => "feature poll comments",
// "feature poll anonymous" => "feature poll anonymous",
// "poll comments default ordering" => "poll comments default ordering",
// "poll comments per page" => "poll comments per page",
// "poll list categories" => "poll list categories",
// "poll list objects" => "poll list objects",
// "poll multiple per object" => "poll multiple per object",
// "feature poll revote" => "feature poll revote",
// "feature surveys" => "feature surveys",
// "feature featuredLinks" => "feature featuredLinks",
// "feature directory" => "feature directory",
// "directory columns" => "directory columns",
// "directory links per page" => "directory links per page",
// "directory open links" => "directory open links",
// "directory validate urls" => "directory validate urls",
// "directory cool sites" => "directory cool sites",
// "directory country flag" => "directory country flag",
// "feature calendar" => "feature calendar",
// "feature default calendars" => "feature default calendars",
// "calendar sticky popup" => "calendar sticky popup",
// "default calendars" => "default calendars",
// "calendar view mode" => "calendar view mode",
// "calendar view tab" => "calendar view tab",
// "calendar firstDayofWeek" => "calendar firstDayofWeek",
// "calendar timespan" => "calendar timespan",
// "feature jscalendar" => "feature jscalendar",
// "feature action calendar" => "feature action calendar",
// "calendar start year" => "calendar start year",
// "calendar end year" => "calendar end year",
// "calendar list begins focus" => "calendar list begins focus",
// "feature cal manual time" => "feature cal manual time",
// "calendar view days" => "calendar view days",
// "calendar addtogooglecal" => "calendar addtogooglecal",
// "server timezone" => "server timezone",
// "long date format" => "long date format",
// "long time format" => "long time format",
// "short date format" => "short date format",
// "short time format" => "short time format",
// "display field order" => "display field order",
// "tiki same day time only" => "tiki same day time only",
// "feed basic auth" => "feed basic auth",
// "feed cache time" => "feed cache time",
// "feed default version" => "feed default version",
// "feed atom author name" => "feed atom author name",
// "feed atom author email" => "feed atom author email",
// "feed atom author url" => "feed atom author url",
// "feed img" => "feed img",
// "feed rss editor email" => "feed rss editor email",
// "feed rss webmaster email" => "feed rss webmaster email",
// "feed language" => "feed language",
// "feed articles" => "feed articles",
// "feed articles desc" => "feed articles desc",
// "feed articles homepage" => "feed articles homepage",
// "feed articles max" => "feed articles max",
// "feed articles showAuthor" => "feed articles showAuthor",
// "feed articles title" => "feed articles title",
// "feed blog" => "feed blog",
// "feed blog desc" => "feed blog desc",
// "feed blog homepage" => "feed blog homepage",
// "feed blog max" => "feed blog max",
// "feed blog showAuthor" => "feed blog showAuthor",
// "feed blog title" => "feed blog title",
// "feed blogs" => "feed blogs",
// "feed blogs desc" => "feed blogs desc",
// "feed blogs homepage" => "feed blogs homepage",
// "feed blogs max" => "feed blogs max",
// "feed blogs showAuthor" => "feed blogs showAuthor",
// "feed blogs title" => "feed blogs title",
// "feed calendar" => "feed calendar",
// "feed calendar desc" => "feed calendar desc",
// "feed calendar homepage" => "feed calendar homepage",
// "feed calendar max" => "feed calendar max",
// "feed calendar showAuthor" => "feed calendar showAuthor",
// "feed calendar title" => "feed calendar title",
// "feed directories" => "feed directories",
// "feed directories desc" => "feed directories desc",
// "feed directories homepage" => "feed directories homepage",
// "feed directories max" => "feed directories max",
// "feed directories showAuthor" => "feed directories showAuthor",
// "feed directories title" => "feed directories title",
// "feed file galleries" => "feed file galleries",
// "feed file galleries desc" => "feed file galleries desc",
// "feed file galleries homepage" => "feed file galleries homepage",
// "feed file galleries max" => "feed file galleries max",
// "feed file galleries showAuthor" => "feed file galleries showAuthor",
// "feed file galleries title" => "feed file galleries title",
// "feed file gallery" => "feed file gallery",
// "feed file gallery desc" => "feed file gallery desc",
// "feed file gallery homepage" => "feed file gallery homepage",
// "feed file gallery max" => "feed file gallery max",
// "feed file gallery showAuthor" => "feed file gallery showAuthor",
// "feed file gallery title" => "feed file gallery title",
// "feed forum" => "feed forum",
// "feed forum desc" => "feed forum desc",
// "feed forum homepage" => "feed forum homepage",
// "feed forum max" => "feed forum max",
// "feed forum showAuthor" => "feed forum showAuthor",
// "feed forum title" => "feed forum title",
// "feed forums max" => "feed forums max",
// "feed forums" => "feed forums",
// "feed forums desc" => "feed forums desc",
// "feed forums showAuthor" => "feed forums showAuthor",
// "feed forums title" => "feed forums title",
// "feed image galleries" => "feed image galleries",
// "feed image galleries desc" => "feed image galleries desc",
// "feed image galleries homepage" => "feed image galleries homepage",
// "feed image galleries max" => "feed image galleries max",
// "feed image galleries showAuthor" => "feed image galleries showAuthor",
// "feed image galleries title" => "feed image galleries title",
// "feed image gallery" => "feed image gallery",
// "feed image gallery desc" => "feed image gallery desc",
// "feed image gallery homepage" => "feed image gallery homepage",
// "feed image gallery max" => "feed image gallery max",
// "feed image gallery showAuthor" => "feed image gallery showAuthor",
// "feed image gallery title" => "feed image gallery title",
// "feed maps" => "feed maps",
// "feed maps desc" => "feed maps desc",
// "feed maps homepage" => "feed maps homepage",
// "feed maps max" => "feed maps max",
// "feed maps showAuthor" => "feed maps showAuthor",
// "feed maps title" => "feed maps title",
// "feed shoutbox" => "feed shoutbox",
// "feed shoutbox desc" => "feed shoutbox desc",
// "feed shoutbox homepage" => "feed shoutbox homepage",
// "feed shoutbox max" => "feed shoutbox max",
// "feed shoutbox showAuthor" => "feed shoutbox showAuthor",
// "feed shoutbox title" => "feed shoutbox title",
// "feed tracker" => "feed tracker",
// "feed tracker desc" => "feed tracker desc",
// "feed tracker homepage" => "feed tracker homepage",
// "feed tracker max" => "feed tracker max",
// "feed tracker showAuthor" => "feed tracker showAuthor",
// "feed tracker title" => "feed tracker title",
// "feed trackers" => "feed trackers",
// "feed trackers desc" => "feed trackers desc",
// "feed trackers homepage" => "feed trackers homepage",
// "feed trackers max" => "feed trackers max",
// "feed trackers showAuthor" => "feed trackers showAuthor",
// "feed trackers title" => "feed trackers title",
// "feed wiki" => "feed wiki",
// "feed wiki desc" => "feed wiki desc",
// "feed wiki homepage" => "feed wiki homepage",
// "feed wiki max" => "feed wiki max",
// "feed wiki showAuthor" => "feed wiki showAuthor",
// "feed wiki title" => "feed wiki title",
// "max rss mapfiles" => "max rss mapfiles",
// "rss mapfiles" => "rss mapfiles",
// "title rss mapfiles" => "title rss mapfiles",
// "feature maps" => "feature maps",
// "map path" => "map path",
// "default map" => "default map",
// "map help" => "map help",
// "map comments" => "map comments",
// "gdaltindex" => "gdaltindex",
// "ogr2ogr" => "ogr2ogr",
// "mapzone" => "mapzone",
// "feature gmap" => "feature gmap",
// "gmap defaultx" => "gmap defaultx",
// "gmap defaulty" => "gmap defaulty",
// "gmap defaultz" => "gmap defaultz",
// "gmap key" => "gmap key",
// "gmap article list" => "gmap article list",
// "gmap page list" => "gmap page list",
// "allowRegister" => "allowRegister",
// "eponymousGroups" => "eponymousGroups",
// "useRegisterPasscode" => "useRegisterPasscode",
// "registerPasscode" => "registerPasscode",
// "rememberme" => "rememberme",
// "remembertime" => "remembertime",
// "feature clear passwords" => "feature clear passwords",
// "feature crypt passwords" => "feature crypt passwords",
// "feature challenge" => "feature challenge",
// "min user length" => "min user length",
// "min pass length" => "min pass length",
// "pass chr num" => "pass chr num",
// "pass due" => "pass due",
// "email due" => "email due",
// "unsuccessful logins" => "unsuccessful logins",
// "generate password" => "generate password",
// "auth method" => "auth method",
// "auth pear" => "auth pear",
// "auth ldap url" => "auth ldap url",
// "auth pear host" => "auth pear host",
// "auth pear port" => "auth pear port",
// "auth ldap scope" => "auth ldap scope",
// "auth ldap basedn" => "auth ldap basedn",
// "auth ldap userdn" => "auth ldap userdn",
// "auth ldap userattr" => "auth ldap userattr",
// "auth ldap useroc" => "auth ldap useroc",
// "auth ldap groupdn" => "auth ldap groupdn",
// "auth ldap groupattr" => "auth ldap groupattr",
// "auth ldap groupnameatr" => "auth ldap groupnameatr",
// "auth ldap groupdescatr" => "auth ldap groupdescatr",
// "auth ldap usergroupattr" => "auth ldap usergroupattr",
// "auth ldap groupgroupattr" => "auth ldap groupgroupattr",
// "auth ldap groupoc" => "auth ldap groupoc",
// "auth ldap memberattr" => "auth ldap memberattr",
// "auth ldap memberisdn" => "auth ldap memberisdn",
// "auth ldap adminuser" => "auth ldap adminuser",
// "auth ldap adminpass" => "auth ldap adminpass",
// "auth ldap version" => "auth ldap version",
// "auth ldap nameattr" => "auth ldap nameattr",
// "auth ldap countryattr" => "auth ldap countryattr",
// "auth ldap emailattr" => "auth ldap emailattr",
// "ldap create user tiki" => "ldap create user tiki",
// "ldap create user ldap" => "ldap create user ldap",
// "ldap skip admin" => "ldap skip admin",
// "auth ldap permit tiki users" => "auth ldap permit tiki users",
// "auth ldap debug" => "auth ldap debug",
// "auth ldap ssl" => "auth ldap ssl",
// "auth ldap starttls" => "auth ldap starttls",
// "auth ldap type" => "auth ldap type",
// "auth ldap syncuserattr" => "auth ldap syncuserattr",
// "auth ldap syncgroupattr" => "auth ldap syncgroupattr",
// "auth phpbb version" => "auth phpbb version",
// "auth phpbb skip admin" => "auth phpbb skip admin",
// "auth phpbb create tiki" => "auth phpbb create tiki",
// "auth phpbb dbhost" => "auth phpbb dbhost",
// "auth phpbb dbport" => "auth phpbb dbport",
// "auth phpbb disable tikionly" => "auth phpbb disable tikionly",
// "auth phpbb dbuser" => "auth phpbb dbuser",
// "auth phpbb dbpasswd" => "auth phpbb dbpasswd",
// "auth phpbb dbname" => "auth phpbb dbname",
// "auth phpbb dbtype" => "auth phpbb dbtype",
// "auth phpbb table prefix" => "auth phpbb table prefix",
// "auth ws create tiki" => "auth ws create tiki",
// "https login" => "https login",
// "https external links for users" => "https external links for users",
// "feature show stay in ssl mode" => "feature show stay in ssl mode",
// "feature switch ssl mode" => "feature switch ssl mode",
// "https port" => "https port",
// "http port" => "http port",
// "login url" => "login url",
// "login scr" => "login scr",
// "register url" => "register url",
// "error url" => "error url",
// "highlight group" => "highlight group",
// "cookie path" => "cookie path",
// "cookie domain" => "cookie domain",
// "cookie name" => "cookie name",
// "user tracker infos" => "user tracker infos",
// "desactive login autocomplete" => "desactive login autocomplete",
// "permission denied login box" => "permission denied login box",
// "permission denied url" => "permission denied url",
// "feature loadbalancer" => "feature loadbalancer",
// "feature intertiki" => "feature intertiki",
// "feature intertiki server" => "feature intertiki server",
// "feature intertiki slavemode" => "feature intertiki slavemode",
// "interlist" => "interlist",
// "feature intertiki mymaster" => "feature intertiki mymaster",
// "feature intertiki import preferences" => "feature intertiki import preferences",
// "feature intertiki import groups" => "feature intertiki import groups",
// "known hosts" => "known hosts",
// "tiki key" => "tiki key",
// "intertiki logfile" => "intertiki logfile",
// "intertiki errfile" => "intertiki errfile",
// "feature intertiki sharedcookie" => "feature intertiki sharedcookie",
// "search lru length" => "search lru length",
// "search lru purge rate" => "search lru purge rate",
// "search max syllwords" => "search max syllwords",
// "search min wordlength" => "search min wordlength",
// "search refresh rate" => "search refresh rate",
// "search syll age" => "search syll age",
// "feature categories" => "feature categories",
// "feature categoryobjects" => "feature categoryobjects",
// "feature categorypath" => "feature categorypath",
// "feature category use phplayers" => "feature category use phplayers",
// "categorypath excluded" => "categorypath excluded",
// "categories used in tpl" => "categories used in tpl",
// "category jail" => "category jail",
// "category defaults" => "category defaults",
// "category i18n sync" => "category i18n sync",
// "category i18n synced" => "category i18n synced",
// "category i18n unsynced" => "category i18n unsynced",
// "category autogeocode within" => "category autogeocode within",
// "category autogeocode replace" => "category autogeocode replace",
// "category autogeocode fudge" => "category autogeocode fudge",
// "expanded category jail" => "expanded category jail",
// "expanded category jail key" => "expanded category jail key",
// "ws container" => "ws container",
// "feature html pages" => "feature html pages",
// "feature filegals manager" => "feature filegals manager",
// "feature contact" => "feature contact",
// "contact user" => "contact user",
// "contact anon" => "contact anon",
// "mail crlf" => "mail crlf",
// "feature detect language" => "feature detect language",
// "feature homePage if bl missing" => "feature homePage if bl missing",
// "record untranslated" => "record untranslated",
// "feature best language" => "feature best language",
// "feature translation" => "feature translation",
// "feature urgent translation" => "feature urgent translation",
// "feature urgent translation master only" => "feature urgent translation master only",
// "feature translation incomplete notice" => "feature translation incomplete notice",
// "lang use db" => "lang use db",
// "language" => "language",
// "restrict language" => "restrict language",
// "feature babelfish" => "feature babelfish",
// "feature babelfish logo" => "feature babelfish logo",
// "quantify changes" => "quantify changes",
// "feature sync language" => "feature sync language",
// "show available translations" => "show available translations",
// "language inclusion threshold" => "language inclusion threshold",
// "metatag keywords" => "metatag keywords",
// "metatag threadtitle" => "metatag threadtitle",
// "metatag imagetitle" => "metatag imagetitle",
// "metatag freetags" => "metatag freetags",
// "metatag description" => "metatag description",
// "metatag pagedesc" => "metatag pagedesc",
// "metatag author" => "metatag author",
// "metatag geoposition" => "metatag geoposition",
// "metatag georegion" => "metatag georegion",
// "metatag geoplacename" => "metatag geoplacename",
// "metatag robots" => "metatag robots",
// "metatag revisitafter" => "metatag revisitafter",
// "head extra js" => "head extra js",
// "keep versions" => "keep versions",
// "feature custom home" => "feature custom home",
// "site crumb seper" => "site crumb seper",
// "site nav seper" => "site nav seper",
// "feature sitemycode" => "feature sitemycode",
// "sitemycode" => "sitemycode",
// "sitemycode publish" => "sitemycode publish",
// "feature sitelogo" => "feature sitelogo",
// "sitelogo bgcolor" => "sitelogo bgcolor",
// "sitelogo bgstyle" => "sitelogo bgstyle",
// "sitelogo align" => "sitelogo align",
// "sitelogo title" => "sitelogo title",
// "sitelogo src" => "sitelogo src",
// "sitelogo alt" => "sitelogo alt",
// "feature siteloc" => "feature siteloc",
// "feature sitenav" => "feature sitenav",
// "sitenav" => "sitenav",
// "feature sitead" => "feature sitead",
// "sitead" => "sitead",
// "sitead publish" => "sitead publish",
// "feature breadcrumbs" => "feature breadcrumbs",
// "feature siteloclabel" => "feature siteloclabel",
// "feature sitesearch" => "feature sitesearch",
// "feature site login" => "feature site login",
// "feature sitemenu" => "feature sitemenu",
// "feature sitemenu custom code" => "feature sitemenu custom code",
// "feature secondary sitemenu custom code" => "feature secondary sitemenu custom code",
// "feature topbar version" => "feature topbar version",
// "feature topbar id menu" => "feature topbar id menu",
// "feature topbar custom code" => "feature topbar custom code",
// "feature sitetitle" => "feature sitetitle",
// "feature sitedesc" => "feature sitedesc",
// "feature bot logo" => "feature bot logo",
// "feature endbody code" => "feature endbody code",
// "feature custom doctype" => "feature custom doctype",
// "feature custom doctype content" => "feature custom doctype content",
// "feature custom html head content" => "feature custom html head content",
// "feature fixed width" => "feature fixed width",
// "feature html head base tag" => "feature html head base tag",
// "feature left column" => "feature left column",
// "feature right column" => "feature right column",
// "feature top bar" => "feature top bar",
// "feature bot bar" => "feature bot bar",
// "feature bot bar icons" => "feature bot bar icons",
// "feature bot bar debug" => "feature bot bar debug",
// "feature bot bar rss" => "feature bot bar rss",
// "feature bot bar power by tw" => "feature bot bar power by tw",
// "maxRecords" => "maxRecords",
// "maxArticles" => "maxArticles",
// "maxVersions" => "maxVersions",
// "feature view tpl" => "feature view tpl",
// "slide style" => "slide style",
// "site favicon" => "site favicon",
// "site favicon type" => "site favicon type",
// "style" => "style",
// "style option" => "style option",
// "use context menu icon" => "use context menu icon",
// "use context menu text" => "use context menu text",
// "feature site report" => "feature site report",
// "feature site send link" => "feature site send link",
// "feature layoutshadows" => "feature layoutshadows",
// "main shadow start" => "main shadow start",
// "main shadow end" => "main shadow end",
// "header shadow start" => "header shadow start",
// "header shadow end" => "header shadow end",
// "middle shadow start" => "middle shadow start",
// "middle shadow end" => "middle shadow end",
// "center shadow start" => "center shadow start",
// "center shadow end" => "center shadow end",
// "footer shadow start" => "footer shadow start",
// "footer shadow end" => "footer shadow end",
// "box shadow start" => "box shadow start",
// "box shadow end" => "box shadow end",
// "feature custom center column header" => "feature custom center column header",
// "header custom css" => "header custom css",
// "header custom js" => "header custom js",
// "feature mods provider" => "feature mods provider",
// "mods dir" => "mods dir",
// "mods server" => "mods server",
// "feature experimental" => "feature experimental",
// "feature actionlog" => "feature actionlog",
// "feature actionlog bytes" => "feature actionlog bytes",
// "browsertitle" => "browsertitle",
// "site title location" => "site title location",
// "site title breadcrumb" => "site title breadcrumb",
// "tmpDir" => "tmpDir",
// "feature tell a friend" => "feature tell a friend",
// "feature share" => "feature share",
// "feature copyright" => "feature copyright",
// "feature smileys" => "feature smileys",
// "popupLinks" => "popupLinks",
// "feature autolinks" => "feature autolinks",
// "default rows textarea wiki" => "default rows textarea wiki",
// "default rows textarea comment" => "default rows textarea comment",
// "default rows textarea forum" => "default rows textarea forum",
// "default rows textarea forumthread" => "default rows textarea forumthread",
// "section comments parse" => "section comments parse",
// "toolbar global" => "toolbar global",
// "toolbar global comments" => "toolbar global comments",
// "toolbar sheet" => "toolbar sheet",
// "direct pagination" => "direct pagination",
// "nextprev pagination" => "nextprev pagination",
// "pagination firstlast" => "pagination firstlast",
// "pagination hide if one page" => "pagination hide if one page",
// "pagination icons" => "pagination icons",
// "pagination fastmove links" => "pagination fastmove links",
// "direct pagination max middle links" => "direct pagination max middle links",
// "direct pagination max ending links" => "direct pagination max ending links",
// "feature kaltura" => "feature kaltura",
// "wikiplugin kaltura" => "wikiplugin kaltura",
// "wikiplugininline kaltura" => "wikiplugininline kaltura",
// "default kaltura editor" => "default kaltura editor",
// "partnerId" => "partnerId",
// "secret" => "secret",
// "adminSecret" => "adminSecret",
// "kdpUIConf" => "kdpUIConf",
// "kdpWidget" => "kdpWidget",
// "kcwUIConf" => "kcwUIConf",
// "kseUIConf" => "kseUIConf",
// "kaeUIConf" => "kaeUIConf",
// "kuser" => "kuser",
// "kServiceUrl" => "kServiceUrl",
// "bigbluebutton feature" => "bigbluebutton feature",
// "bigbluebutton server location" => "bigbluebutton server location",
// "bigbluebutton server salt" => "bigbluebutton server salt",
// "shipping service" => "shipping service",
// "shipping fedex enable" => "shipping fedex enable",
// "shipping fedex key" => "shipping fedex key",
// "shipping fedex password" => "shipping fedex password",
// "shipping fedex meter" => "shipping fedex meter",
// "shipping fedex account" => "shipping fedex account",
// "shipping ups enable" => "shipping ups enable",
// "shipping ups username" => "shipping ups username",
// "shipping ups password" => "shipping ups password",
// "shipping ups license" => "shipping ups license",
// "recaptcha enabled" => "recaptcha enabled",
// "recaptcha pubkey" => "recaptcha pubkey",
// "recaptcha privkey" => "recaptcha privkey",
// "captcha wordLen" => "captcha wordLen",
// "captcha width" => "captcha width",
// "captcha noise" => "captcha noise",
// "anonCanEdit" => "anonCanEdit",
// "cacheimages" => "cacheimages",
// "cachepages" => "cachepages",
// "count admin pvs" => "count admin pvs",
// "default mail charset" => "default mail charset",
// "error reporting adminonly" => "error reporting adminonly",
// "error reporting level" => "error reporting level",
// "smarty notice reporting" => "smarty notice reporting",
// "smarty security" => "smarty security",
// "smarty compilation" => "smarty compilation",
// "feature htmlpurifier output" => "feature htmlpurifier output",
// "feature ajax" => "feature ajax",
// "ajax autosave" => "ajax autosave",
// "ajax xajax" => "ajax xajax",
// "feature antibot" => "feature antibot",
// "feature banners" => "feature banners",
// "feature banning" => "feature banning",
// "feature comm" => "feature comm",
// "feature contribution" => "feature contribution",
// "feature contribution display in comment" => "feature contribution display in comment",
// "feature contribution mandatory" => "feature contribution mandatory",
// "feature contribution mandatory blog" => "feature contribution mandatory blog",
// "feature contribution mandatory comment" => "feature contribution mandatory comment",
// "feature contribution mandatory forum" => "feature contribution mandatory forum",
// "feature credits" => "feature credits",
// "feature debug console" => "feature debug console",
// "feature debugger console" => "feature debugger console",
// "feature display my to others" => "feature display my to others",
// "feature dynamic content" => "feature dynamic content",
// "feature edit templates" => "feature edit templates",
// "feature editcss" => "feature editcss",
// "feature events" => "feature events",
// "feature friends" => "feature friends",
// "feature fullscreen" => "feature fullscreen",
// "feature help" => "feature help",
// "feature hotwords" => "feature hotwords",
// "feature hotwords nw" => "feature hotwords nw",
// "feature integrator" => "feature integrator",
// "feature live support" => "feature live support",
// "feature mailin" => "feature mailin",
// "feature menusfolderstyle" => "feature menusfolderstyle",
// "feature mobile" => "feature mobile",
// "feature modulecontrols" => "feature modulecontrols",
// "feature morcego" => "feature morcego",
// "feature multilingual" => "feature multilingual",
// "feature multilingual one page" => "feature multilingual one page",
// "feature multilingual structures" => "feature multilingual structures",
// "feature machine translation" => "feature machine translation",
// "feature newsletters" => "feature newsletters",
// "feature obzip" => "feature obzip",
// "feature perspective" => "feature perspective",
// "feature phplayers" => "feature phplayers",
// "feature cssmenus" => "feature cssmenus",
// "menus item names raw" => "menus item names raw",
// "feature projects" => "feature projects",
// "feature ranking" => "feature ranking",
// "feature redirect on error" => "feature redirect on error",
// "url anonymous page not found" => "url anonymous page not found",
// "feature referer highlight" => "feature referer highlight",
// "feature referer stats" => "feature referer stats",
// "feature score" => "feature score",
// "feature sheet" => "feature sheet",
// "feature shoutbox" => "feature shoutbox",
// "feature source" => "feature source",
// "feature stats" => "feature stats",
// "feature tabs" => "feature tabs",
// "feature theme control" => "feature theme control",
// "feature ticketlib" => "feature ticketlib",
// "feature ticketlib2" => "feature ticketlib2",
// "feature top banner" => "feature top banner",
// "feature usability" => "feature usability",
// "feature use quoteplugin" => "feature use quoteplugin",
// "feature use three colon centertag" => "feature use three colon centertag",
// "feature user watches" => "feature user watches",
// "feature group watches" => "feature group watches",
// "feature user watches translations" => "feature user watches translations",
// "feature user watches languages" => "feature user watches languages",
// "feature daily report watches" => "feature daily report watches",
// "feature quick object perms" => "feature quick object perms",
// "feature xmlrpc" => "feature xmlrpc",
// "feature watershed" => "feature watershed",
// "helpurl" => "helpurl",
// "layout section" => "layout section",
// "limitedGoGroupHome" => "limitedGoGroupHome",
// "minical reminders" => "minical reminders",
// "modallgroups" => "modallgroups",
// "modseparateanon" => "modseparateanon",
// "modhideanonadmin" => "modhideanonadmin",
// "php docroot" => "php docroot",
// "proxy host" => "proxy host",
// "proxy port" => "proxy port",
// "ip can be checked" => "ip can be checked",
// "sender email" => "sender email",
// "feature site report email" => "feature site report email",
// "session storage" => "session storage",
// "session lifetime" => "session lifetime",
// "session silent" => "session silent",
// "session cookie name" => "session cookie name",
// "session protected" => "session protected",
// "shoutbox autolink" => "shoutbox autolink",
// "show comzone" => "show comzone",
// "tikiIndex" => "tikiIndex",
// "urlIndex" => "urlIndex",
// "useGroupHome" => "useGroupHome",
// "useGroupTheme" => "useGroupTheme",
// "useUrlIndex" => "useUrlIndex",
// "use proxy" => "use proxy",
// "user list order" => "user list order",
// "webserverauth" => "webserverauth",
// "feature purifier" => "feature purifier",
// "feature shadowbox" => "feature shadowbox",
// "log sql" => "log sql",
// "log sql perf min" => "log sql perf min",
// "log mail" => "log mail",
// "log tpl" => "log tpl",
// "disableJavascript" => "disableJavascript",
// "feature socialnetworks" => "feature socialnetworks",
// "socialnetworks twitter consumer key" => "socialnetworks twitter consumer key",
// "socialnetworks twitter consumer secret" => "socialnetworks twitter consumer secret",
// "socialnetworks facebook api key" => "socialnetworks facebook api key",
// "socialnetworks facebook application secr" => "socialnetworks facebook application secr",
// "socialnetworks facebook application id" => "socialnetworks facebook application id",
// "socialnetworks bitly login" => "socialnetworks bitly login",
// "socialnetworks bitly key" => "socialnetworks bitly key",
// "socialnetworks bitly sitewide" => "socialnetworks bitly sitewide",
// "case patched" => "case patched",
// "site closed" => "site closed",
// "site closed msg" => "site closed msg",
// "use load threshold" => "use load threshold",
// "load threshold" => "load threshold",
// "site busy msg" => "site busy msg",
// "bot logo code" => "bot logo code",
// "feature create webhelp" => "feature create webhelp",
// "page n times in a structure" => "page n times in a structure",
// "feature forums search" => "feature forums search",
// "feature wiki ext icon" => "feature wiki ext icon",
// "feature wiki ext rel nofollow" => "feature wiki ext rel nofollow",
// "feature wiki mandatory category" => "feature wiki mandatory category",
// "feature intertiki imported groups" => "feature intertiki imported groups",
// "feature wiki history ip" => "feature wiki history ip",
// "pam create user tiki" => "pam create user tiki",
// "pam service" => "pam service",
// "pam skip admin" => "pam skip admin",
// "shib affiliation" => "shib affiliation",
// "shib create user tiki" => "shib create user tiki",
// "shib group" => "shib group",
// "shib skip admin" => "shib skip admin",
// "shib usegroup" => "shib usegroup",
// "wiki 3d camera distance" => "wiki 3d camera distance",
// "wiki 3d elastic constant" => "wiki 3d elastic constant",
// "wiki 3d eletrostatic constant" => "wiki 3d eletrostatic constant",
// "wiki 3d fov" => "wiki 3d fov",
// "wiki 3d friction constant" => "wiki 3d friction constant",
// "wiki 3d node charge" => "wiki 3d node charge",
// "wiki 3d node mass" => "wiki 3d node mass",
// "wiki 3d node size" => "wiki 3d node size",
// "wiki 3d spring size" => "wiki 3d spring size",
// "wiki 3d text size" => "wiki 3d text size",
// "articles feature copyrights" => "articles feature copyrights",
// "blogues feature copyrights" => "blogues feature copyrights",
// "faqs feature copyrights" => "faqs feature copyrights",
// "feature contributor wiki" => "feature contributor wiki",
// "https login required" => "https login required",
// "maxRowsGalleries" => "maxRowsGalleries",
// "replimaster" => "replimaster",
// "rowImagesGalleries" => "rowImagesGalleries",
// "scaleSizeGalleries" => "scaleSizeGalleries",
// "thumbSizeXGalleries" => "thumbSizeXGalleries",
// "thumbSizeYGalleries" => "thumbSizeYGalleries",
// "wiki 3d adjust camera" => "wiki 3d adjust camera",
// "wiki 3d autoload" => "wiki 3d autoload",
// "javascript enabled" => "javascript enabled",
// "javascript cdn" => "javascript cdn",
// "feature template zoom" => "feature template zoom",
// "menus items icons" => "menus items icons",
// "menus items icons path" => "menus items icons path",
// "feature iepngfix" => "feature iepngfix",
// "iepngfix selectors" => "iepngfix selectors",
// "iepngfix elements" => "iepngfix elements",
// "feature invite" => "feature invite",
// "feature jquery" => "feature jquery",
// "jquery effect" => "jquery effect",
// "jquery effect direction" => "jquery effect direction",
// "jquery effect speed" => "jquery effect speed",
// "jquery effect tabs" => "jquery effect tabs",
// "jquery effect tabs direction" => "jquery effect tabs direction",
// "jquery effect tabs speed" => "jquery effect tabs speed",
// "feature jquery ui" => "feature jquery ui",
// "feature jquery ui theme" => "feature jquery ui theme",
// "feature jquery tooltips" => "feature jquery tooltips",
// "feature jquery autocomplete" => "feature jquery autocomplete",
// "feature jquery superfish" => "feature jquery superfish",
// "feature jquery reflection" => "feature jquery reflection",
// "feature jquery jqs5" => "feature jquery jqs5",
// "feature jquery tablesorter" => "feature jquery tablesorter",
// "feature jquery carousel" => "feature jquery carousel",
// "feature jquery validation" => "feature jquery validation",
// "feature jquery media" => "feature jquery media",
// "feature sefurl" => "feature sefurl",
// "feature sefurl filter" => "feature sefurl filter",
// "feature sefurl paths" => "feature sefurl paths",
// "feature sefurl title article" => "feature sefurl title article",
// "feature sefurl title blog" => "feature sefurl title blog",
// "feature sefurl tracker prefixalias" => "feature sefurl tracker prefixalias",
// "feature tikitests" => "feature tikitests",
// "profile sources" => "profile sources",
// "profile channels" => "profile channels",
// "feature minichat" => "feature minichat",
// "memcache enabled" => "memcache enabled",
// "memcache compress" => "memcache compress",
// "memcache servers" => "memcache servers",
// "memcache expiration" => "memcache expiration",
// "memcache prefix" => "memcache prefix",
// "memcache wiki data" => "memcache wiki data",
// "memcache wiki output" => "memcache wiki output",
// "memcache forum output" => "memcache forum output",
// "feature pear date" => "feature pear date",
// "feature bidi" => "feature bidi",
// "feature lastup" => "feature lastup",
// "feature groupalert" => "feature groupalert",
// "zend mail handler" => "zend mail handler",
// "zend mail smtp server" => "zend mail smtp server",
// "zend mail smtp auth" => "zend mail smtp auth",
// "zend mail smtp user" => "zend mail smtp user",
// "zend mail smtp pass" => "zend mail smtp pass",
// "zend mail smtp port" => "zend mail smtp port",
// "zend mail smtp security" => "zend mail smtp security",
// "feature group transition" => "feature group transition",
// "feature category transition" => "feature category transition",
// "terminology profile installed" => "terminology profile installed",
// "multidomain active" => "multidomain active",
// "multidomain config" => "multidomain config",
// "tiki minify javascript" => "tiki minify javascript",
// "tiki minify css" => "tiki minify css",
// "tiki minify css single file" => "tiki minify css single file",
// "tiki cachecontrol session" => "tiki cachecontrol session",
// "tiki cachecontrol nosession" => "tiki cachecontrol nosession",
// "tiki cdn" => "tiki cdn",
// "tiki cdn ssl" => "tiki cdn ssl",
// "auth token access" => "auth token access",
// "auth token access maxtimeout" => "auth token access maxtimeout",
// "auth token access maxhits" => "auth token access maxhits",
// "auth token tellafriend" => "auth token tellafriend",
// "auth token share" => "auth token share",
// "print pdf from url" => "print pdf from url",
// "print pdf webkit path" => "print pdf webkit path",
// "print pdf webservice url" => "print pdf webservice url",
// "feature metrics dashboard" => "feature metrics dashboard",
// "metrics trend prefix" => "metrics trend prefix",
// "metrics trend suffix" => "metrics trend suffix",
// "metrics trend novalue" => "metrics trend novalue",
// "metrics pastresults count" => "metrics pastresults count",
// "metrics metric name length" => "metrics metric name length",
// "metrics tab name length" => "metrics tab name length",
// "metrics cache output" => "metrics cache output",
// "payment feature" => "payment feature",
// "payment system" => "payment system",
// "payment currency" => "payment currency",
// "payment default delay" => "payment default delay",
// "payment paypal business" => "payment paypal business",
// "payment paypal environment" => "payment paypal environment",
// "payment paypal ipn" => "payment paypal ipn",
// "payment cclite registries" => "payment cclite registries",
// "payment cclite currencies" => "payment cclite currencies",
// "payment cclite gateway" => "payment cclite gateway",
// "payment cclite merchant key" => "payment cclite merchant key",
// "payment cclite merchant user" => "payment cclite merchant user",
// "payment cclite mode" => "payment cclite mode",
// "payment cclite notify" => "payment cclite notify",
// "payment cclite hashing algorithm" => "payment cclite hashing algorithm",
// "payment manual" => "payment manual",
// "payment invoice prefix" => "payment invoice prefix",
// "rating advanced" => "rating advanced",
// "rating recalculation" => "rating recalculation",
// "rating recalculation odd" => "rating recalculation odd",
// "rating recalculation count" => "rating recalculation count",
// "cas create user tiki" => "cas create user tiki",
// "cas create user tiki ldap" => "cas create user tiki ldap",
// "cas autologin" => "cas autologin",
// "cas skip admin" => "cas skip admin",
// "cas show alternate login" => "cas show alternate login",
// "cas version" => "cas version",
// "cas hostname" => "cas hostname",
// "cas port" => "cas port",
// "cas path" => "cas path",
// "cas extra param" => "cas extra param",
// "cas authentication timeout" => "cas authentication timeout",
// "cas force logout" => "cas force logout",
// "feature comments post as anonymous" => "feature comments post as anonymous",
// "feature comments moderation" => "feature comments moderation",
// "feature comments locking" => "feature comments locking",
// "comments notitle" => "comments notitle",
// "comments field email" => "comments field email",
// "comments field website" => "comments field website",
// "comments vote" => "comments vote",
// "allowMsgs" => "allowMsgs",
// "diff versions" => "diff versions",
// "display timezone" => "display timezone",
// "email is public" => "email is public",
// "homePage" => "homePage",
// "lat" => "lat",
// "lon" => "lon",
// "mess archiveAfter" => "mess archiveAfter",
// "mess maxRecords" => "mess maxRecords",
// "mess sendReadStatus" => "mess sendReadStatus",
// "minPrio" => "minPrio",
// "mytiki blogs" => "mytiki blogs",
// "mytiki articles" => "mytiki articles",
// "mytiki gals" => "mytiki gals",
// "mytiki items" => "mytiki items",
// "mytiki msgs" => "mytiki msgs",
// "mytiki pages" => "mytiki pages",
// "mytiki tasks" => "mytiki tasks",
// "mytiki forum topics" => "mytiki forum topics",
// "mytiki forum replies" => "mytiki forum replies",
// "realName" => "realName",
// "gender" => "gender",
// "show mouseover user info" => "show mouseover user info",
// "tasks maxRecords" => "tasks maxRecords",
// "user dbl" => "user dbl",
// "user information" => "user information",
// "mailCharset" => "mailCharset",
// "mailCurrentAccount" => "mailCurrentAccount",
// "Non Advanced Search or Natural Search" => "Non Advanced Search or Natural Search",
// "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. ",
// "Advanced Search or Boolean Search" => "Advanced Search or Boolean Search",
// "Default search behavior" => "Default search behavior",
// "By default, all search terms are <em>optional</em>" => "By default, all search terms are <em>optional</em>",
// "It behaves like an OR logic" => "It behaves like an OR logic",
// "Objects that contain the more terms are rated higher in the results and will appear first in their type" => "Objects that contain the more terms are rated higher in the results and will appear first in their type",
// "For example, <strong>wiki forum</strong> will find" => "For example, <strong>wiki forum</strong> will find",
// "objects that include both terms" => "objects that include both terms",
// "objects that include the term <strong>wiki</strong>" => "objects that include the term <strong>wiki</strong>",
// "objects that include the term <strong>forum</strong>" => "objects that include the term <strong>forum</strong>",
// "Requiring terms" => "Requiring terms",
// "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results" => "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results",
// "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first" => "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first",
// "Excluding terms" => "Excluding terms",
// "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results" => "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results",
// "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value" => "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"{tr}Reducing a term's value",
// "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>",
// "Grouping terms" => "Grouping terms",
// "Use parenthesis ( ) to group terms into subexpressions" => "Use parenthesis ( ) to group terms into subexpressions",
// "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
// "Finding phrases" => "Finding phrases",
// "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed" => "Use double quotes ( \" \" ) around a phrase to find terms in the exact order, exactly as typed",
// "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "Example: <strong>\"Alex Bell\"</strong> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. ",
// "Using wildcards" => "Using wildcards",
// "Add an asterisk ( * ) after a term to find objects that include the root word" => "Add an asterisk ( * ) after a term to find objects that include the root word",
// "For example, <strong>run*</strong> will find" => "For example, <strong>run*</strong> will find",
// "objects that include the term <strong>run</strong>" => "objects that include the term <strong>run</strong>",
// "objects that include the term <strong>runner</strong>" => "objects that include the term <strong>runner</strong>",
// "objects that include the term <strong>running</strong>" => "objects that include the term <strong>running</strong>",
// "Reducing a term's value" => "Reducing a term's value",
// "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results",
// "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms" => "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"{tr}Excluding terms",
// "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>" => "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and  <strong>forum</strong>",
// "Changing relevance value" => "Changing relevance value",
// "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object" => "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object",
// "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher" => "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher",
// "Anti-Bot verification code image" => "Anti-Bot verification code image",
// "Enter the code you see above" => "Enter the code you see above",
// "Try another code" => "Try another code",
// "Share page" => "Share page",
// "Share this page" => "Share this page",
// "Share This" => "Share This",
// "ShareThis via AIM, social bookmarking and networking sites, etc" => "ShareThis via AIM, social bookmarking and networking sites, etc",
// "debug" => "debug",
// "Published " => "Published ",
// "Previous post" => "Previous post",
// "Next post" => "Next post",
// "Related content" => "Related content",
// "Leave a comment" => "Leave a comment",
// "Parent Gallery" => "Parent Gallery",
// "Click Here to Insert in Wiki Syntax" => "Click Here to Insert in Wiki Syntax",
// "Posted by" => "Posted by",
// "Report this post" => "Report this post",
// "Group Monitor" => "Group Monitor",
// "Watched by categories" => "Watched by categories",
// "{\$comments_cant} comment" => "{\$comments_cant} comment",
// "{\$comments_cant} comments" => "{\$comments_cant} comments",
// "Reply to the selected comment" => "Reply to the selected comment",
// "(your email address will not be published)" => "(your email address will not be published)",
// "Website" => "Website",
// "Rate this Article (10=best, 0=worse)" => "Rate this Article (10=best, 0=worse)",
// "Send me an e-mail when someone replies" => "Send me an e-mail when someone replies",
// "System error" => "System error",
// "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue",
// "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation" => "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation",
// "The query was" => "The query was",
// "The built query was likely" => "The built query was likely",
// "Stacktrace" => "Stacktrace",
// "Tiki is unable to connect to the database" => "Tiki is unable to connect to the database",
// "An error occured while performing the request" => "An error occured while performing the request",
// "Tiki Debugger Console" => "Tiki Debugger Console",
// "Command" => "Command",
// "exec" => "exec",
// "Page generation debugging log" => "Page generation debugging log",
// "Features state" => "Features state",
// "features matched" => "features matched",
// "Watchlist" => "Watchlist",
// "File gallery" => "File gallery",
// "Duplicate permissions" => "Duplicate permissions",
// "View inserted gallery" => "View inserted gallery",
// "Any file" => "Any file",
// "Podcast (audio)" => "Podcast (audio)",
// "Podcast (video)" => "Podcast (video)",
// "Gallery is visible to non-admin users" => "Gallery is visible to non-admin users",
// "Gallery is public" => "Gallery is public",
// "Any user with permission (not only the gallery owner) can upload files" => "Any user with permission (not only the gallery owner) can upload files",
// "Perms of the backlinks are checked to view a file" => "Perms of the backlinks are checked to view a file",
// "Files can be locked at download" => "Files can be locked at download",
// "Maximum number of archives for each file" => "Maximum number of archives for each file",
// "unlimited" => "unlimited",
// "Owner of the gallery" => "Owner of the gallery",
// "Quota" => "Quota",
// "Used" => "Used",
// "Group of users alerted when file gallery is modified" => "Group of users alerted when file gallery is modified",
// "Allows to select each user for small groups" => "Allows to select each user for small groups",
// "Maximum width for images in gallery" => "Maximum width for images in gallery",
// "If an image is wider than this, it will be resized" => "If an image is wider than this, it will be resized",
// "Attention: In this case, the original image will be lost" => "Attention: In this case, the original image will be lost",
// "Maximum height for images in gallery" => "Maximum height for images in gallery",
// "If an image is higher than this, it will be resized" => "If an image is higher than this, it will be resized",
// "Wiki markup to enter when image selected from \"file gallery manager\"" => "Wiki markup to enter when image selected from \"file gallery manager\"",
// "The default is " => "The default is ",
// "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%",
// "Display Properties" => "Display Properties",
// "Max rows per page" => "Max rows per page",
// "Select which items to display when listing galleries" => "Select which items to display when listing galleries",
// "Go to Log in Page" => "Go to Log in Page",
// "Change them here" => "Change them here",
// "Open as WebFolder" => "Open as WebFolder",
// "Open in WebDAV" => "Open in WebDAV",
// "Share a link to this file" => "Share a link to this file",
// "Email a link to this file" => "Email a link to this file",
// "The checkbox is disabled because this preference is disabled globally" => "The checkbox is disabled because this preference is disabled globally",
// "Please, enable the preference globally first" => "Please, enable the preference globally first",
// "You can ask your site Admin to enable the preference" => "You can ask your site Admin to enable the preference",
// "Start the Slideshow" => "Start the Slideshow",
// "Pause the Slideshow" => "Pause the Slideshow",
// "and all the sub-objects" => "and all the sub-objects",
// "Multiple select" => "Multiple select",
// "Orphans" => "Orphans",
// "Map View" => "Map View",
// "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes",
// "Folksonomy Language" => "Folksonomy Language",
// "Untag" => "Untag",
// "Are you sure you want to reset the default gallery list table settings" => "Are you sure you want to reset the default gallery list table settings",
// "Reset to default gallery list table settings" => "Reset to default gallery list table settings",
// "No Additional Sort" => "No Additional Sort",
// "Hi {\$mail_user|username} has sent you this link" => "Hi {\$mail_user|username} has sent you this link",
// "To validate your account and login to the site, please click on the following link" => "To validate your account and login to the site, please click on the following link",
// "The administrator approved your account" => "The administrator approved your account",
// "Confirm your email at %s" => "Confirm your email at %s",
// "Remove file" => "Remove file",
// "GalleryId" => "GalleryId",
// "FileId" => "FileId",
// "An anonymous user" => "An anonymous user",
// "has posted a reply to a thread you're watching. \nYou can view the thread and reply at the following URL" => "has posted a reply to a thread you're watching. \nYou can view the thread and reply at the following URL",
// "You are invited by" => "You are invited by",
// "You join this group" => "You join this group",
// "Join me on %s" => "Join me on %s",
// "You sent a request with the subject" => "You sent a request with the subject",
// "Use the subject to indicate the operation to apply" => "Use the subject to indicate the operation to apply",
// "GET:WikiName to get a wiki page" => "GET:WikiName to get a wiki page",
// "PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:WikiName to update/create a wiki page (use the body for the page data)",
// "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)",
// "PREPEND:WikiName to append the data at the top" => "PREPEND:WikiName to append the data at the top",
// "Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
// "A new message was posted to you at {\$mail_machine}" => "A new message was posted to you at {\$mail_machine}",
// "New message arrived from %s" => "New message arrived from %s",
// "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now",
// "To login with your username and password, please follow this link" => "To login with your username and password, please follow this link",
// "User Account Activated" => "User Account Activated",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first",
// "has requested an account on" => "has requested an account on",
// "To validate that account, please follow the link" => "To validate that account, please follow the link",
// "Assign to a group" => "Assign to a group",
// "View user's data" => "View user's data",
// "Best regards" => "Best regards",
// "User Tracker" => "User Tracker",
// "User Registration Request" => "User Registration Request",
// "Go to your friendship network to accept or refuse this request" => "Go to your friendship network to accept or refuse this request",
// "You're invited to join my network of friends" => "You're invited to join my network of friends",
// "Bye bye from %s at %s" => "Bye bye from %s at %s",
// "Welcome to %s at %s" => "Welcome to %s at %s",
// "Reply notification" => "Reply notification",
// "Email notification" => "Email notification",
// "Someone" => "Someone",
// "requested a reminder of the password for your account" => "requested a reminder of the password for your account",
// "requested password reset for your account" => "requested password reset for your account",
// "Since this is your registered email address we inform that the password for this account is" => "Since this is your registered email address we inform that the password for this account is",
// "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else",
// "Important: Username & password are CaSe SenSitiVe" => "Important: Username & password are CaSe SenSitiVe",
// "Important: The old password remains active if you don't click the link above" => "Important: The old password remains active if you don't click the link above",
// "Your account information for %s" => "Your account information for %s",
// "Report for" => "Report for",
// "Last Report sent on" => "Last Report sent on",
// "Changes in detail" => "Changes in detail",
// "Look at this link" => "Look at this link",
// "A friend sends you a link from: " => "A friend sends you a link from: ",
// "A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "A new article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime}",
// "You can edit the submission following this link" => "You can edit the submission following this link",
// "New article submitted at %s" => "New article submitted at %s",
// "ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} {\$mail_item_desc} was deleted in the tracker {\$mail_trackerName}",
// "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}" => "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the tracker {\$mail_trackerName}",
// "Download the file at" => "Download the file at",
// "was modified at" => "was modified at",
// "Please visit this link before login again" => "Please visit this link before login again",
// "Last attempt" => "Last attempt",
// "IP" => "IP",
// "Confirm your account at %s" => "Confirm your account at %s",
// "An administrator of the site below has added you as a new user" => "An administrator of the site below has added you as a new user",
// "If you want to confirm your membership in this site, click on the following link to login for the first time" => "If you want to confirm your membership in this site, click on the following link to login for the first time",
// "Your authentication credentials are" => "Your authentication credentials are",
// "Welcome on the site" => "Welcome on the site",
// "Your personal access to" => "Your personal access to",
// "If you want to be a registered user in this site you will have to use the following link to login for the first time" => "If you want to be a registered user in this site you will have to use the following link to login for the first time",
// "Your account request has been stored and will be activated by the admin as soon as possible" => "Your account request has been stored and will be activated by the admin as soon as possible",
// "You'll receive email notification once your account is activated" => "You'll receive email notification once your account is activated",
// "Please do not attempt to login until you receive the email notification" => "Please do not attempt to login until you receive the email notification",
// "{\$mail_action} article post" => "{\$mail_action} article post",
// "{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} by {\$mail_user|username} at",
// "New article post" => "New article post",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
// "View the article at" => "View the article at",
// "If you don't want to receive these notifications follow this link" => "If you don't want to receive these notifications follow this link",
// "{\$mail_action} article post at" => "{\$mail_action} article post at",
// "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "View the blog at" => "View the blog at",
// "New blog post at %s" => "New blog post at %s",
// "View item calendar at" => "View item calendar at",
// "Modified calendar item" => "Modified calendar item",
// "New calendar item" => "New calendar item",
// "A new category was created in" => "A new category was created in",
// "A category was removed in" => "A category was removed in",
// "Removed by" => "Removed by",
// "removed" => "removed",
// "A category was updated" => "A category was updated",
// "Updated by" => "Updated by",
// "Old" => "Old",
// "updated" => "updated",
// "File Gallery %s changed" => "File Gallery %s changed",
// "A file was removed from the file gallery" => "A file was removed from the file gallery",
// "A new file was posted to file gallery" => "A new file was posted to file gallery",
// "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "Image Gallery {\$galleryName} changed" => "Image Gallery {\$galleryName} changed",
// "A new file was posted to image gallery" => "A new file was posted to image gallery",
// "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "You can view the updated map following this link" => "You can view the updated map following this link",
// "You can edit the map following this link" => "You can edit the map following this link",
// "An object was added to category" => "An object was added to category",
// "Added by" => "Added by",
// "An object was removed from category" => "An object was removed from category",
// "A page has been added to your watched sub-structure" => "A page has been added to your watched sub-structure",
// "A page has been removed from your watched sub-structure" => "A page has been removed from your watched sub-structure",
// "A page has been promoted out your watched sub-structure" => "A page has been promoted out your watched sub-structure",
// "A page has been demoted to your watched structure" => "A page has been demoted to your watched structure",
// "Structure modified" => "Structure modified",
// "A new file have been attached to page" => "A new file have been attached to page",
// "File name" => "File name",
// "New attachment on %s, page" => "New attachment on %s, page",
// "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "A file was attached to {\$mail_page}" => "A file was attached to {\$mail_page}",
// "The page {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "The page {\$mail_page} was deleted but used to be here" => "The page {\$mail_page} was deleted but used to be here",
// "You can view the page by following this link" => "You can view the page by following this link",
// "You can view a diff back to the previous version by following this link" => "You can view a diff back to the previous version by following this link",
// "The changes in this version follow below, followed after by the current full page text" => "The changes in this version follow below, followed after by the current full page text",
// "-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Lines: {\$oldd} changed to +Lines: {\$newd}",
// "The old page content follows below" => "The old page content follows below",
// "The new page content follows below" => "The new page content follows below",
// "Wiki page %s created by {\$mail_user|username}" => "Wiki page %s created by {\$mail_user|username}",
// "Wiki page %s deleted by {\$mail_user|username}" => "Wiki page %s deleted by {\$mail_user|username}",
// "A file was attached to %s" => "A file was attached to %s",
// "Wiki page %s changed by {\$mail_user|username}" => "Wiki page %s changed by {\$mail_user|username}",
// "The page {\$mail_page} was commented by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was commented by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "Thank you for your registration" => "Thank you for your registration",
// "click on the map to zoom or pan, do not drag" => "click on the map to zoom or pan, do not drag",
// "Query Results" => "Query Results",
// "Querying" => "Querying",
// "Scroll Up" => "Scroll Up",
// "Scroll Down" => "Scroll Down",
// "Scale" => "Scale",
// "Zoom out" => "Zoom out",
// "Pan" => "Pan",
// "Zoom in" => "Zoom in",
// "Redraw" => "Redraw",
// "select zoom/pan/query and image size" => "select zoom/pan/query and image size",
// "View the Map Only" => "View the Map Only",
// "Reset Map" => "Reset Map",
// "Click on the map or click redraw" => "Click on the map or click redraw",
// "Overview" => "Overview",
// "Legend" => "Legend",
// "Layer Manager" => "Layer Manager",
// "Layer" => "Layer",
// "Download Layer" => "Download Layer",
// "This layer has been set by the maps administrator to not be downloadable" => "This layer has been set by the maps administrator to not be downloadable",
// "you have requested to download the layer" => "you have requested to download the layer",
// "from the mapfile" => "from the mapfile",
// "Here are the files to download, do not forget to rename them" => "Here are the files to download, do not forget to rename them",
// "Mapfiles" => "Mapfiles",
// "Mapfile" => "Mapfile",
// "Available mapfiles" => "Available mapfiles",
// "hits last 7 days" => "hits last 7 days",
// "monitor this map" => "monitor this map",
// "Stop Monitoring this Map" => "Stop Monitoring this Map",
// "Create a new mapfile" => "Create a new mapfile",
// "Mapfile listing" => "Mapfile listing",
// "You can view this map in your browser using" => "You can view this map in your browser using",
// "Zoom out x2" => "Zoom out x2",
// "Zoom in x2" => "Zoom in x2",
// "Mapfile History" => "Mapfile History",
// "Comparing version {\$old.version} with version {\$new.version}" => "Comparing version {\$old.version} with version {\$new.version}",
// "v=view" => "v=view",
// "c=compare" => "c=compare",
// "d=diff" => "d=diff",
// "Older Version" => "Older Version",
// "back to" => "back to",
// "Bytes maximum" => "Bytes maximum",
// "Create Directory" => "Create Directory",
// "index file (.shp)" => "index file (.shp)",
// "files to index (regexp)" => "files to index (regexp)",
// "Message Archive" => "Message Archive",
// "messages" => "messages",
// "Archive is full" => "Archive is full",
// "Confirmation" => "Confirmation",
// "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences" => "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences",
// "ERROR" => "ERROR",
// "Multiple addresses can be separated with semicolons (\\\";\\\")" => "Multiple addresses can be separated with semicolons (\\\";\\\")",
// "or commas (\\\",\\\")" => "or commas (\\\",\\\")",
// "Reply-to my email" => "Reply-to my email",
// "The user will be able to reply to you directly via email" => "The user will be able to reply to you directly via email",
// "Send me a copy" => "Send me a copy",
// "You will be sent a copy of this email" => "You will be sent a copy of this email",
// "No messages to download" => "No messages to download",
// "Mailbox is full! Delete or archive some messages if you want to receive more messages" => "Mailbox is full! Delete or archive some messages if you want to receive more messages",
// "Find replied message" => "Find replied message",
// "Auto-archive age for read messages" => "Auto-archive age for read messages",
// "Unflag" => "Unflag",
// "'name' parameter for tikimodule missed" => "'name' parameter for tikimodule missed",
// "Move module up" => "Move module up",
// "Move module down" => "Move module down",
// "Move module to opposite side" => "Move module to opposite side",
// "opp side" => "opp side",
// "Unassign this module" => "Unassign this module",
// "Are you sure you want to unassign this module" => "Are you sure you want to unassign this module",
// "Toggle module contents" => "Toggle module contents",
// "Toggle Vertically" => "Toggle Vertically",
// "Display type unknown, you have to enter the banner type" => "Display type unknown, you have to enter the banner type",
// "You forgot your Google ad_client number " => "You forgot your Google ad_client number ",
// "from the menu" => "from the menu",
// "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>",
// "Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies",
// "To remove this module" => "To remove this module",
// "and remove the assistant module" => "and remove the assistant module",
// "You can also add other modules" => "You can also add other modules",
// "To customize the menu" => "To customize the menu",
// "and edit menu ID 42" => "and edit menu ID 42",
// "Or, create your own menu and add it to a module" => "Or, create your own menu and add it to a module",
// "To begin configuring Tiki, please" => "To begin configuring Tiki, please",
// "as admin" => "as admin",
// "The Tikiwiki Community" => "The Tikiwiki Community",
// "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tiki.org</a>" => "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tiki.org</a>",
// "Tikiwiki Documentation" => "Tikiwiki Documentation",
// "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>",
// "Published on" => "Published on",
// "on blogpost" => "on blogpost",
// "Untitled" => "Untitled",
// "Unit cost" => "Unit cost",
// "Qty" => "Qty",
// "Check-out" => "Check-out",
// "Your cart is empty" => "Your cart is empty",
// "Missing %0 of the following categories" => "Missing %0 of the following categories",
// "%0 extra of the following categories" => "%0 extra of the following categories",
// "Unknown comparison" => "Unknown comparison",
// "Impossible condition, %0 of" => "Impossible condition, %0 of",
// "Assign into category" => "Assign into category",
// "Unassign category" => "Unassign category",
// "empty" => "empty",
// "List everything tagged" => "List everything tagged",
// "All Groups" => "All Groups",
// "Your Groups" => "Your Groups",
// "Emulated Groups" => "Emulated Groups",
// "Switch to Groups" => "Switch to Groups",
// "Simulate" => "Simulate",
// "Last `\$module_rows` Podcasts" => "Last `\$module_rows` Podcasts",
// "This is likely not a podcast file" => "This is likely not a podcast file",
// "The path to a podcast player is required" => "The path to a podcast player is required",
// "Log in" => "Log in",
// "Log out" => "Log out",
// "Enter user name and click 'Switch'.<br />Useful for testing permissions" => "Enter user name and click 'Switch'.<br />Useful for testing permissions",
// "Log in through CAS" => "Log in through CAS",
// "Log in as admin" => "Log in as admin",
// "Log in through Shibboleth" => "Log in through Shibboleth",
// "Log in as" => "Log in as",
// "OpenID Log in" => "OpenID Log in",
// "Stay on this page" => "Stay on this page",
// "Edit perspectives" => "Edit perspectives",
// "Description (used for metatags)" => "Description (used for metatags)",
// "Paste content here" => "Paste content here",
// "Wiki feed" => "Wiki feed",
// "Feed" => "Feed",
// "Blogs feed" => "Blogs feed",
// "Articles feed" => "Articles feed",
// "Image Galleries feed" => "Image Galleries feed",
// "File Galleries feed" => "File Galleries feed",
// "Forums feed" => "Forums feed",
// "Maps feed" => "Maps feed",
// "Search Help" => "Search Help",
// "Search for text throughout the site" => "Search for text throughout the site",
// "Go directly to a page, or search in page titles if exact match is not found" => "Go directly to a page, or search in page titles if exact match is not found",
// "Edit existing page or create a new one" => "Edit existing page or create a new one",
// "Tweet with twitter" => "Tweet with twitter",
// "Post on my facebook wall" => "Post on my facebook wall",
// "Shout date" => "Shout date",
// "Multiple" => "Multiple",
// "including" => "including",
// "Find term" => "Find term",
// "If not found, you will be given a chance to create it" => "If not found, you will be given a chance to create it",
// "Posted to" => "Posted to",
// "(Read More)" => "(Read More)",
// "Tracker name" => "Tracker name",
// "Incoming" => "Incoming",
// "To <strong>continue translating</strong>, select the language to translate from" => "To <strong>continue translating</strong>, select the language to translate from",
// "None match your" => "None match your",
// "Outgoing" => "Outgoing",
// "Group information" => "Group information",
// "You need to activate user and/or group trackers" => "You need to activate user and/or group trackers",
// "Webmail inbox" => "Webmail inbox",
// "Refresh (non-ajax)" => "Refresh (non-ajax)",
// "TAKE" => "TAKE",
// "View contact" => "View contact",
// "User does not accept messages" => "User does not accept messages",
// "Session" => "Session",
// "Old Session" => "Old Session",
// "Old Version" => "Old Version",
// "New Session" => "New Session",
// "New Version" => "New Version",
// "[-]" => "[-]",
// "Use Ctrl+Click to select multiple options" => "Use Ctrl+Click to select multiple options",
// "Requires" => "Requires",
// "You need to set" => "You need to set",
// "Reset to default" => "Reset to default",
// "A valid email is mandatory to register" => "A valid email is mandatory to register",
// "{\$customfields[ir].label}" => "{\$customfields[ir].label}",
// "Minimum {\$prefs.min_username_length} characters long" => "Minimum {\$prefs.min_username_length} characters long",
// "Minimum {\$prefs.min_pass_length} characters long" => "Minimum {\$prefs.min_pass_length} characters long",
// "Passcode to register" => "Passcode to register",
// "Not your password" => "Not your password",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "Download Log File" => "Download Log File",
// "absE" => "absE",
// "Design by" => "Design by",
// "Jump to Content" => "Jump to Content",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Show/Hide Left Menus" => "Show/Hide Left Menus",
// "Show/Hide Right Menus" => "Show/Hide Right Menus",
// "Module errors" => "Module errors",
// "The following modules could not be loaded" => "The following modules could not be loaded",
// "Preference was not set" => "Preference was not set",
// "Powered by" => "Powered by",
// "Made with" => "Made with",
// "powered by" => "powered by",
// "The Tiki Community" => "The Tiki Community",
// "database queries used in " => "database queries used in ",
// "Designed originally by" => "Designed originally by",
// "Show/Hide Left Column" => "Show/Hide Left Column",
// "Show/Hide Right Column" => "Show/Hide Right Column",
// "Configuration search" => "Configuration search",
// "Note: The search index needs rebuilding, this will take a few minutes" => "Note: The search index needs rebuilding, this will take a few minutes",
// "Search error" => "Search error",
// "Preferences Search Results" => "Preferences Search Results",
// "Change" => "Change",
// "No results" => "No results",
// "No preferences were found for your search query" => "No preferences were found for your search query",
// "Database Version Problem" => "Database Version Problem",
// "Your database requires an update to match the current Tiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors" => "Your database requires an update to match the current Tiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors",
// "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>" => "A new version of Tiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tiki.org/Download\">tiki.org/Download</a>",
// "Enabled" => "Enabled",
// "Changed" => "Changed",
// "Preference" => "Preference",
// "Preference name" => "Preference name",
// "Shoutbox Words" => "Shoutbox Words",
// "Live Support" => "Live Support",
// "Transitions" => "Transitions",
// "External Pages Cache" => "External Pages Cache",
// "Toolbars" => "Toolbars",
// "Search Stats" => "Search Stats",
// "Please select some actions to be reported" => "Please select some actions to be reported",
// "Users and Groups" => "Users and Groups",
// "Units" => "Units",
// "Contibution Time" => "Contibution Time",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "See Statistics" => "See Statistics",
// "Pagination" => "Pagination",
// "Records" => "Records",
// "contribution" => "contribution",
// "contributor" => "contributor",
// "Edit Action" => "Edit Action",
// "Save Action" => "Save Action",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volumen per category" => "Volumen per category",
// "Volumn per category and per user" => "Volumn per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Total number of users" => "Total number of users",
// "Number of actions per object" => "Number of actions per object",
// "Total number of objects" => "Total number of objects",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volume per the users'group and per contribution" => "Volume per the users'group and per contribution",
// "Volume per group and per contribution" => "Volume per group and per contribution",
// "Volume per user and per contribution" => "Volume per user and per contribution",
// "Volume per users' contribution and time" => "Volume per users' contribution and time",
// "Volumn per contribution and time" => "Volumn per contribution and time",
// "How" => "How",
// "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occured since the action type has been set to recorded" => "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occured since the action type has been set to recorded",
// "Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki page actions except viewed will always be recorded but can be not reported",
// "Recorded" => "Recorded",
// "Reported" => "Reported",
// "Add or edit rules" => "Add or edit rules",
// "Multiple IP regex matching" => "Multiple IP regex matching",
// "Create / Edit Calendar" => "Create / Edit Calendar",
// "Custom Classifications" => "Custom Classifications",
// "Days to display" => "Days to display",
// "Create/Edit category" => "Create/Edit category",
// "Create New" => "Create New",
// "Moving objects between categories" => "Moving objects between categories",
// "Unassign all objects from this category" => "Unassign all objects from this category",
// "Move all the objects from this category to this one" => "Move all the objects from this category to this one",
// "Assign all objects of this category to this one" => "Assign all objects of this category to this one",
// "File gal" => "File gal",
// "Name field is mandatory" => "Name field is mandatory",
// "Template Type" => "Template Type",
// "Admin Contributions" => "Admin Contributions",
// "Edit the contribution" => "Edit the contribution",
// "Contributions are mandatory in wiki pages" => "Contributions are mandatory in wiki pages",
// "Contributions are mandatory in forums" => "Contributions are mandatory in forums",
// "Contributions are mandatory in comments" => "Contributions are mandatory in comments",
// "Contributions are mandatory in blogs" => "Contributions are mandatory in blogs",
// "Contributions are displayed in the comment/post" => "Contributions are displayed in the comment/post",
// "Create a new contribution" => "Create a new contribution",
// "List of contributions" => "List of contributions",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
// "Manage Credits" => "Manage Credits",
// "Creation Date" => "Creation Date",
// "(YYYY-MM-DD HH:MM:SS)" => "(YYYY-MM-DD HH:MM:SS)",
// "Expiration Date" => "Expiration Date",
// "(level credits always 0)" => "(level credits always 0)",
// "Delete Checked" => "Delete Checked",
// "User Credits Expiry Summary (Plans)" => "User Credits Expiry Summary (Plans)",
// "User Plan" => "User Plan",
// "Start of Latest Plan" => "Start of Latest Plan",
// "Start of Next Plan" => "Start of Next Plan",
// "Expiry" => "Expiry",
// "Use User Credits" => "Use User Credits",
// "Amount" => "Amount",
// "Restore User Level Credits" => "Restore User Level Credits",
// "Restore" => "Restore",
// "Historical Usage Report" => "Historical Usage Report",
// "all types" => "all types",
// "Usage Date" => "Usage Date",
// "Amount Used" => "Amount Used",
// "Manage Credit Types" => "Manage Credit Types",
// "Display Text" => "Display Text",
// "Unit Text" => "Unit Text",
// "Is Static Level Credit" => "Is Static Level Credit",
// "Display Bar Length Scaling Divisor" => "Display Bar Length Scaling Divisor",
// "Purge Expired and Used Credits (All Users)" => "Purge Expired and Used Credits (All Users)",
// "Purge" => "Purge",
// "Use Admin DSN to define the database to be used by the SQL plugin" => "Use Admin DSN to define the database to be used by the SQL plugin",
// "Create/edit DSN" => "Create/edit DSN",
// "Local (Tiki database)" => "Local (Tiki database)",
// "See db/local.php" => "See db/local.php",
// "Admin External Wikis" => "Admin External Wikis",
// "Create/Edit Forums" => "Create/Edit Forums",
// "Last post title" => "Last post title",
// "Last post avatar" => "Last post avatar",
// "Author avatar" => "Author avatar",
// "Shows number of attachments of the all thread in forum list" => "Shows number of attachments of the all thread in forum list",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
// "Edit zone" => "Edit zone",
// "Dynamic zones" => "Dynamic zones",
// "zone" => "zone",
// "Mass update" => "Mass update",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
// "Admin dynamic zones" => "Admin dynamic zones",
// "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones",
// "Site Ads and Banners" => "Site Ads and Banners",
// "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users",
// "Global site configuration, date formats, admin password etc" => "Global site configuration, date formats, admin password etc",
// "Switches for major features" => "Switches for major features",
// "User registration, remember me cookie settings and authentication methods" => "User registration, remember me cookie settings and authentication methods",
// "User specific features and settings" => "User specific features and settings",
// "Repository configuration, browse and apply profiles" => "Repository configuration, browse and apply profiles",
// "Look &amp; Feel" => "Look &amp; Feel",
// "Theme selection, layout settings and UI effect controls" => "Theme selection, layout settings and UI effect controls",
// "i18n" => "i18n",
// "Internationalization and localization - mulitlingual features" => "Internationalization and localization - mulitlingual features",
// "Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Text editing settings applicable to many areas. Plugin activation and plugin alias management",
// "Module appearance settings" => "Module appearance settings",
// "Information to include in the header of each page" => "Information to include in the header of each page",
// "Performance" => "Performance",
// "Server performance settings" => "Server performance settings",
// "Site security settings" => "Site security settings",
// "Comments settings" => "Comments settings",
// "Feeds" => "Feeds",
// "Web feeds" => "Web feeds",
// "Connect" => "Connect",
// "Wiki page settings and features" => "Wiki page settings and features",
// "Defaults and configuration for file galleries" => "Defaults and configuration for file galleries",
// "Settings for blogs" => "Settings for blogs",
// "Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Defaults and configuration for image galleries (will be phased out in favour of file galleries)",
// "Settings and features for articles" => "Settings and features for articles",
// "Settings and features for forums" => "Settings and features for forums",
// "Settings and features for trackers" => "Settings and features for trackers",
// "Settings and features for polls" => "Settings and features for polls",
// "Settings and features for calendars" => "Settings and features for calendars",
// "Settings and features for categories" => "Settings and features for categories",
// "Values of actions for users rank score" => "Values of actions for users rank score",
// "Settings and features for freetags" => "Settings and features for freetags",
// "Search configuration" => "Search configuration",
// "Settings and features for FAQs" => "Settings and features for FAQs",
// "Settings and features for directory of links" => "Settings and features for directory of links",
// "Settings and features for maps" => "Settings and features for maps",
// "Defaults and API key for Google Maps" => "Defaults and API key for Google Maps",
// "Site-wide copyright information" => "Site-wide copyright information",
// "Message settings" => "Message settings",
// "User files settings" => "User files settings",
// "Webmail settings" => "Webmail settings",
// "Options for WYSIWYG editor" => "Options for WYSIWYG editor",
// "?" => "?",
// "InterTiki" => "InterTiki",
// "Set up links between Tiki servers" => "Set up links between Tiki servers",
// "Manage semantic wiki links" => "Manage semantic wiki links",
// "Register and manage web services" => "Register and manage web services",
// "Sef URL" => "Sef URL",
// "Search Engine Friendly URLs" => "Search Engine Friendly URLs",
// "Video" => "Video",
// "Video integration configuration" => "Video integration configuration",
// "Configure social networks integration" => "Configure social networks integration",
// "Sharing on social networks" => "Sharing on social networks",
// "Blogs Listings" => "Blogs Listings",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
// "With PHPlayers, watch icons are only visible for the top category" => "With PHPlayers, watch icons are only visible for the top category",
// "Plugins" => "Plugins",
// "Look under \"Articles\" on the application menu for links to" => "Look under \"Articles\" on the application menu for links to",
// "Admin topics" => "Admin topics",
// "Article properties" => "Article properties",
// "Give only one value (width or height) to keep the image proportions" => "Give only one value (width or height) to keep the image proportions",
// "File format: title,authorName,heading,body,lang,user" => "File format: title,authorName,heading,body,lang,user",
// "Articles Listing" => "Articles Listing",
// "Select which items to display when listing articles" => "Select which items to display when listing articles",
// "Article View" => "Article View",
// "List comments" => "List comments",
// "Site-wide features" => "Site-wide features",
// "Display options" => "Display options",
// "Inline comments" => "Inline comments",
// "The feature below must be activated for this feature to work" => "The feature below must be activated for this feature to work",
// "Using comments in various features" => "Using comments in various features",
// "User features" => "User features",
// "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU",
// "Join the community" => "Join the community",
// "Promote your site" => "Promote your site",
// "To submit your site to Tiki.org" => "To submit your site to Tiki.org",
// "Submit site" => "Submit site",
// "Help Tiki spread" => "Help Tiki spread",
// "Help improve Tiki" => "Help improve Tiki",
// "To submit a feature request or to report a bug" => "To submit a feature request or to report a bug",
// "Click here to go to our development site" => "Click here to go to our development site",
// "To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or",
// "To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or",
// "Global features" => "Global features",
// "Main feature" => "Main feature",
// "Additional" => "Additional",
// "Interface" => "Interface",
// "AJAX" => "AJAX",
// "jQuery plugins and add-ons" => "jQuery plugins and add-ons",
// "Logging and Reporting" => "Logging and Reporting",
// "Visible to admin only" => "Visible to admin only",
// "Include Smarty notices" => "Include Smarty notices",
// "Custom Code" => "Custom Code",
// "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application" => "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application",
// "Getting there.." => "Getting there..",
// "Most of these features are hoped to make it into the \"new\" section for Tiki 6" => "Most of these features are hoped to make it into the \"new\" section for Tiki 6",
// "Fresh out of the oven" => "Fresh out of the oven",
// "Seem ok but.." => "Seem ok but..",
// "These features are not reported to be broken, but they are not actively developed and/or widely used" => "These features are not reported to be broken, but they are not actively developed and/or widely used",
// "Will be phased out" => "Will be phased out",
// "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology" => "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology",
// "Move files from database to directory" => "Move files from database to directory",
// "Move files from directory to database" => "Move files from directory to database",
// "Manage comment settings" => "Manage comment settings",
// "A cron job must be set up in order to delete the files" => "A cron job must be set up in order to delete the files",
// "Upload Regex" => "Upload Regex",
// "Gallery Listings" => "Gallery Listings",
// "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries",
// "Select which items to display when listing galleries: " => "Select which items to display when listing galleries: ",
// "Admin Gallery Listings" => "Admin Gallery Listings",
// "Select which items to display when admin galleries: " => "Select which items to display when admin galleries: ",
// "Automatically index files on upload or change" => "Automatically index files on upload or change",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "Missing Handlers" => "Missing Handlers",
// "MIME Type" => "MIME Type",
// "System Command" => "System Command",
// "Reindex all files for search" => "Reindex all files for search",
// "To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or",
// "Threads" => "Threads",
// "Forums Listing" => "Forums Listing",
// "Select which items to display when listing forums" => "Select which items to display when listing forums",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
// "Random tag cloud colors" => "Random tag cloud colors",
// "Separate colors with a comma (,)" => "Separate colors with a comma (,)",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all characters" => "Accept all characters",
// "Tag Management" => "Tag Management",
// "Cleanup unused tags" => "Cleanup unused tags",
// "3D Tag Browser Configuration" => "3D Tag Browser Configuration",
// "Graph appearance" => "Graph appearance",
// "Camera settings" => "Camera settings",
// "Physics engine" => "Physics engine",
// "To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "To add/remove image galleries, go to \"Image Galleries\" on the application menu, or",
// "You can upload images of a size of " => "You can upload images of a size of ",
// "Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value",
// "Home Gallery" => "Home Gallery",
// "Uses Slideshow" => "Uses Slideshow",
// "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below" => "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below",
// "Directory Batch Loading" => "Directory Batch Loading",
// "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols",
// "Enable directory batch loading" => "Enable directory batch loading",
// "Batch loading directory" => "Batch loading directory",
// "Display image information in a mouseover box" => "Display image information in a mouseover box",
// "yes, and don't display that information under the image" => "yes, and don't display that information under the image",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
// "Default scale size" => "Default scale size",
// "Exterminator" => "Exterminator",
// "Mover" => "Mover",
// "Move images from database storage to filesystem storage" => "Move images from database storage to filesystem storage",
// "Move images from filesystem storage to database storage" => "Move images from filesystem storage to database storage",
// "Move images from old filesystem store to new directory" => "Move images from old filesystem store to new directory",
// "Moved" => "Moved",
// "These values will be stored in plain text in the database" => "These values will be stored in plain text in the database",
// "Email to send a test mail" => "Email to send a test mail",
// "Create and edit menus " => "Create and edit menus ",
// "Redirects" => "Redirects",
// "Site Access" => "Site Access",
// "Date and Time" => "Date and Time",
// "Change the <strong>Admin</strong> password" => "Change the <strong>Admin</strong> password",
// "User administration" => "User administration",
// "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details" => "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://code.google.com/intl/fr/apis/maps/signup.html\">http://code.google.com/intl/fr/apis/maps/signup.html</a> for details",
// "Map mode in listings" => "Map mode in listings",
// "Edit or export/import Languages" => "Edit or export/import Languages",
// "Babelfish links" => "Babelfish links",
// "Customized String Translation" => "Customized String Translation",
// "Syntax error" => "Syntax error",
// "Cannot open/write this file" => "Cannot open/write this file",
// "Custom translation will not be saved. Ask your administration to change the permission" => "Custom translation will not be saved. Ask your administration to change the permission",
// "The file has been saved" => "The file has been saved",
// "Intertiki client" => "Intertiki client",
// "Tiki Unique key" => "Tiki Unique key",
// "InterTiki Slave mode" => "InterTiki Slave mode",
// "Warning: overrides manually registered local users" => "Warning: overrides manually registered local users",
// "as master" => "as master",
// "Import user preferences" => "Import user preferences",
// "Import user groups" => "Import user groups",
// "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
// "InterTiki Server" => "InterTiki Server",
// "host" => "host",
// "Add new server" => "Add new server",
// "Intertiki server" => "Intertiki server",
// "Intertiki Server enabled" => "Intertiki Server enabled",
// "Access Log file" => "Access Log file",
// "Errors Log file" => "Errors Log file",
// "Known hosts" => "Known hosts",
// "Key" => "Key",
// "Enable/disable Tiki features in " => "Enable/disable Tiki features in ",
// ", but configure them elsewhere" => ", but configure them elsewhere",
// "Wysiwyg" => "Wysiwyg",
// "Video streaming integration" => "Video streaming integration",
// "Social Networks" => "Social Networks",
// "Registration" => "Registration",
// "Requires PHP GD library" => "Requires PHP GD library",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Assign users to group function of email pattern" => "Assign users to group function of email pattern",
// "LDAP" => "LDAP",
// "You must change the Authentication Method to LDAP for these changes to take effect" => "You must change the Authentication Method to LDAP for these changes to take effect",
// "LDAP Bind settings" => "LDAP Bind settings",
// "LDAP User" => "LDAP User",
// "LDAP Group" => "LDAP Group",
// "LDAP Group Member - if group membership can be found in group attributes" => "LDAP Group Member - if group membership can be found in group attributes",
// "LDAP User Group - if group membership can be found in user attributes" => "LDAP User Group - if group membership can be found in user attributes",
// "LDAP Admin" => "LDAP Admin",
// "PAM" => "PAM",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "Shibboleth Authentication " => "Shibboleth Authentication ",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "CAS" => "CAS",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "CAS Server" => "CAS Server",
// "CAS Server Name" => "CAS Server Name",
// "CAS Server Port" => "CAS Server Port",
// "CAS Server Path" => "CAS Server Path",
// "phpBB User Database Authentication " => "phpBB User Database Authentication ",
// "You must change the Authentication Method to phpBB for these changes to take effect" => "You must change the Authentication Method to phpBB for these changes to take effect",
// "You must turn Users can register off for phpBB Authentication to function properly" => "You must turn Users can register off for phpBB Authentication to function properly",
// "MySql only (for now)" => "MySql only (for now)",
// "Web Server Authentication " => "Web Server Authentication ",
// "You must change the Authentication Method to Web Server for these changes to take effect" => "You must change the Authentication Method to Web Server for these changes to take effect",
// "The \"users can change theme\" feature will override the theme displayed" => "The \"users can change theme\" feature will override the theme displayed",
// "Theme not saved yet - click \"Apply\"" => "Theme not saved yet - click \"Apply\"",
// "Theme Screenshot" => "Theme Screenshot",
// "Restrict available themes" => "Restrict available themes",
// "View Templates" => "View Templates",
// "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for <em>all</em> users" => "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for <em>all</em> users",
// "Site Report Bar" => "Site Report Bar",
// "Pagination links" => "Pagination links",
// "UI Effects" => "UI Effects",
// "Standard UI effects" => "Standard UI effects",
// "Tab UI effects" => "Tab UI effects",
// "Experimental: CSS assistant (work in progress - click the x to remove)" => "Experimental: CSS assistant (work in progress - click the x to remove)",
// "Favicon" => "Favicon",
// "Context Menus" => "Context Menus",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
// "Separators" => "Separators",
// "Generate User Map" => "Generate User Map",
// "Meta tags" => "Meta tags",
// "Geo URL" => "Geo URL",
// "Robots" => "Robots",
// "Configure metrics" => "Configure metrics",
// "Show past results" => "Show past results",
// "Past results count" => "Past results count",
// "&quot;Modules&quot; are the boxes of content in the right &amp; left columns" => "&quot;Modules&quot; are the boxes of content in the right &amp; left columns",
// "Admin &gt; Modules" => "Admin &gt; Modules",
// "from the menu to create and edit modules" => "from the menu to create and edit modules",
// "Hint: If you lose your login module, use tiki-login_scr.php to be able to login" => "Hint: If you lose your login module, use tiki-login_scr.php to be able to login",
// "Payments" => "Payments",
// "Choose payment system" => "Choose payment system",
// "You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "You can use only one payment method: PayPal or Cclite or Tiki User Credits",
// "PayPal is working at the moment. See PayPal.com" => "PayPal is working at the moment. See PayPal.com",
// "Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite: Community currency accounting for local exchange trading systems (LETS). See ",
// "sourceforge.net" => "sourceforge.net",
// "Tiki User Credits: Requires this other feature to be configured" => "Tiki User Credits: Requires this other feature to be configured",
// "Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite is for creating and managing alternative or complementary trading currencies and groups",
// "Work in progress for Tiki 6" => "Work in progress for Tiki 6",
// "Shipping" => "Shipping",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "Bytecode Cache" => "Bytecode Cache",
// "Using <strong>%0</strong>.These stats affect all PHP applications running on the server" => "Using <strong>%0</strong>.These stats affect all PHP applications running on the server",
// "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache",
// "Available" => "Available",
// "Memory" => "Memory",
// "Hit" => "Hit",
// "Miss" => "Miss",
// "Cache Hits" => "Cache Hits",
// "Few hits recorded. Statistics may not be representative" => "Few hits recorded. Statistics may not be representative",
// "Low hit ratio. %0 may be misconfigured and not used" => "Low hit ratio. %0 may be misconfigured and not used",
// "Little memory available. Thrashing likely to occur" => "Little memory available. Thrashing likely to occur",
// "Small amount of memory allocated to %0. Verify the configuration" => "Small amount of memory allocated to %0. Verify the configuration",
// "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates" => "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates",
// "<em>%0</em> should not be disabled due to authentication on XCache" => "<em>%0</em> should not be disabled due to authentication on XCache",
// "Bytecode cache is not used. Using a bytecode cache (APC, XCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (APC, XCache) is highly recommended for production environments",
// "Major slow down" => "Major slow down",
// "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>",
// "Sessions" => "Sessions",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Changing this feature will immediately log you out when you save this preference" => "Changing this feature will immediately log you out when you save this preference",
// "Loading profile" => "Loading profile",
// "Are you sure you want to apply the profile" => "Are you sure you want to apply the profile",
// "Are you sure you want to re-apply the profile" => "Are you sure you want to re-apply the profile",
// "Sending" => "Sending",
// "Tiki Profiles" => "Tiki Profiles",
// "Apply Profiles" => "Apply Profiles",
// "A Friendly Warning" => "A Friendly Warning",
// "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles",
// "Option 1: Quick Filter" => "Option 1: Quick Filter",
// "Option 2: Manual Filter" => "Option 2: Manual Filter",
// "Filter the list of profiles" => "Filter the list of profiles",
// "Profile" => "Profile",
// "Repository" => "Repository",
// "applied" => "applied",
// "Profile repository" => "Profile repository",
// "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again" => "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again",
// "Repositories" => "Repositories",
// "Repository URLs" => "Repository URLs",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data Channels" => "Data Channels",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. " => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. ",
// "Profile tester" => "Profile tester",
// "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below",
// "This will run the profile and make potentially unrecoverable changes in your database" => "This will run the profile and make potentially unrecoverable changes in your database",
// "Test Profile Name" => "Test Profile Name",
// "Global configuration" => "Global configuration",
// "Cache duration" => "Cache duration",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or",
// "External feeds" => "External feeds",
// "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public" => "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public",
// "Feed for articles" => "Feed for articles",
// "Feed for blogs" => "Feed for blogs",
// "Feed for individual blogs" => "Feed for individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Feed for individual image galleries" => "Feed for individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Feed for directories" => "Feed for directories",
// "Feed for maps" => "Feed for maps",
// "Feed for shoutbox" => "Feed for shoutbox",
// "You can see users rank by score in the module users_rank, for that go to" => "You can see users rank by score in the module users_rank, for that go to",
// "Admin modules" => "Admin modules",
// "Expiration" => "Expiration",
// "can be seen on page" => "can be seen on page",
// "in Admin menu" => "in Admin menu",
// "Search type" => "Search type",
// "Specify the Tiki search settings" => "Specify the Tiki search settings",
// "The Tiki search indexes must be refreshed if you turn the Tiki search on" => "The Tiki search indexes must be refreshed if you turn the Tiki search on",
// "Refresh all search index now" => "Refresh all search index now",
// "Refresh wiki search index now" => "Refresh wiki search index now",
// "Refresh trackers search index now" => "Refresh trackers search index now",
// "Refresh tracker search index now" => "Refresh tracker search index now",
// "Refresh files search index now" => "Refresh files search index now",
// "Enabling these options will improve performance, but may show forbidden results" => "Enabling these options will improve performance, but may show forbidden results",
// "Search Results" => "Search Results",
// "Select the items to display on the search results page" => "Select the items to display on the search results page",
// "Select the information to display for each result" => "Select the information to display for each result",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "General Security" => "General Security",
// "Please also see" => "Please also see",
// "HTTPS (SSL) and other login preferences" => "HTTPS (SSL) and other login preferences",
// "CSRF Security" => "CSRF Security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "Spam protection" => "Spam protection",
// "Captcha" => "Captcha",
// "Tokens" => "Tokens",
// "Clipperz online password management" => "Clipperz online password management",
// "Tiki doesn't offer a built-in password management feature" => "Tiki doesn't offer a built-in password management feature",
// "Learn more about Clipperz" => "Learn more about Clipperz",
// "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file" => "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file",
// "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>" => "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>",
// "If you need to keep an existing (non Tiki) .htaccess file, just add Tiki directives to it" => "If you need to keep an existing (non Tiki) .htaccess file, just add Tiki directives to it",
// "When you upgrade (ex.: from Tiki4 to Tiki5), make sure to use the new _htaccess file" => "When you upgrade (ex.: from Tiki4 to Tiki5), make sure to use the new _htaccess file",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Known Types" => "Known Types",
// "Token" => "Token",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "New Types" => "New Types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "Activate the feature" => "Activate the feature",
// "Twitter Settings" => "Twitter Settings",
// "To use Twitter integration, you must register this site as an application at" => "To use Twitter integration, you must register this site as an application at",
// "and allow write access for the application" => "and allow write access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL",
// "Facebook Settings" => "Facebook Settings",
// "To use Facebook integration, you must register this site as an application at" => "To use Facebook integration, you must register this site as an application at",
// "and allow extended access for the application" => "and allow extended access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain",
// "bit.ly Settings" => "bit.ly Settings",
// "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics",
// "to sign up for an account" => "to sign up for an account",
// "to retrieve the API key" => "to retrieve the API key",
// "Text area (that apply throughout many features)" => "Text area (that apply throughout many features)",
// "External links and images" => "External links and images",
// "External links will be identified with" => "External links will be identified with",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Check disabled plugins used in wiki pages" => "Check disabled plugins used in wiki pages",
// "Disabled used plugins" => "Disabled used plugins",
// "Edit plugin icons" => "Edit plugin icons",
// "Enable" => "Enable",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
// "Plugin Aliases" => "Plugin Aliases",
// "About plugin aliases" => "About plugin aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Available Alias" => "Available Alias",
// "Enable Plugins" => "Enable Plugins",
// "Delete Plugins" => "Delete Plugins",
// "Click on the plugin name to edit it" => "Click on the plugin name to edit it",
// "Click on the + icon to add a new one" => "Click on the + icon to add a new one",
// "General Information" => "General Information",
// "Plugin Name" => "Plugin Name",
// "Base Plugin" => "Base Plugin",
// "Body Label" => "Body Label",
// "Dependencies" => "Dependencies",
// "Inline (No Plugin Edit UI)" => "Inline (No Plugin Edit UI)",
// "Simple Plugin Arguments" => "Simple Plugin Arguments",
// "Argument" => "Argument",
// "New Argument" => "New Argument",
// "Plugin Parameter Documentation" => "Plugin Parameter Documentation",
// "Safe" => "Safe",
// "Plugin Body" => "Plugin Body",
// "Ignore User Input" => "Ignore User Input",
// "Default Content" => "Default Content",
// "Encoding" => "Encoding",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Composed Plugin Arguments" => "Composed Plugin Arguments",
// "Pattern" => "Pattern",
// "To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or" => "To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or",
// "Tracker attachment preferences" => "Tracker attachment preferences",
// "Tracker attachments" => "Tracker attachments",
// "Switch storage" => "Switch storage",
// "Change all to db" => "Change all to db",
// "Change all to file" => "Change all to file",
// "Kaltura Registration" => "Kaltura Registration",
// "To get a Kaltura Partner ID" => "To get a Kaltura Partner ID",
// "Setup your own instance of Kaltura Community Edition (CE)" => "Setup your own instance of Kaltura Community Edition (CE)",
// "get an account via Kaltura.com" => "get an account via Kaltura.com",
// "List Media Entries" => "List Media Entries",
// "List Remix Entries" => "List Remix Entries",
// "Add New Media" => "Add New Media",
// "Kaltura / Tiki config" => "Kaltura / Tiki config",
// "Kaltura Partner Settings" => "Kaltura Partner Settings",
// "Kaltura Dynamic Player" => "Kaltura Dynamic Player",
// "Kaltura Contribution Wizard" => "Kaltura Contribution Wizard",
// "Kaltura Remix Editors" => "Kaltura Remix Editors",
// "Ustream Watershed Registration" => "Ustream Watershed Registration",
// "If you don't have a Watershed account, " => "If you don't have a Watershed account, ",
// "you can find out more about it here" => "you can find out more about it here",
// "Configuration within Watershed" => "Configuration within Watershed",
// "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock" => "Set the webservice to point to tiki-watershed_service.php on your site, and turn on Authentication Lock",
// "Watershed Wiki plugins" => "Watershed Wiki plugins",
// "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat" => "Use Wiki plugins WatershedBroadcaster, WatershedViewer and WatershedChat to embed your broadcaster, viewer or chat",
// "Basic tracker settings" => "Basic tracker settings",
// "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"" => "Information for each channel is stored in a tracker. Tracker item view/modify permissions will determine which channels users will be able to view or broadcast to respectively. You can find the Brand Id and Channel Code from the embed codes provided by Watershed, looking for the cid variable which will be \"brandId%2Fchannelcode\"",
// "Archive settings" => "Archive settings",
// "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)" => "Information on archived clips are stored in a tracker. Tracker item view permissions will determine which archives users will be able to view. Note that recordings set to private in the broadcaster are not added to Tiki. Also, there is a delay for information to be received which could be quite long (30 min)",
// "Archive settings (optional)" => "Archive settings (optional)",
// "Flash Media Encoder" => "Flash Media Encoder",
// "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication" => "This is only needed if you are using Flash Media Encoder for higher-quality broadcasting which support only shared secret authentication",
// "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used",
// "Lookup" => "Lookup",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Output" => "Output",
// "Register Template" => "Register Template",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
// "Page display" => "Page display",
// "List authors" => "List authors",
// "Allow override per page" => "Allow override per page",
// "Minor edits do not flag new content for translation and do not send watch notifications (unless \"Watch minor edits\" is enabled)" => "Minor edits do not flag new content for translation and do not send watch notifications (unless \"Watch minor edits\" is enabled)",
// "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled" => "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled",
// "Manage attachments" => "Manage attachments",
// "If you change storage, it is better to move all the files for easy backup.." => "If you change storage, it is better to move all the files for easy backup..",
// "Tag for current wiki" => "Tag for current wiki",
// "Restore wiki to tag" => "Restore wiki to tag",
// "Wiki watch" => "Wiki watch",
// "Staging &amp; Approval" => "Staging &amp; Approval",
// "Freetags are disabled" => "Freetags are disabled",
// "Page Listings" => "Page Listings",
// "Configuration" => "Configuration",
// "Select which items to display when listing pages" => "Select which items to display when listing pages",
// "Wiki 3D Browser Configuration" => "Wiki 3D Browser Configuration",
// "Tools" => "Tools",
// "Mass search and replace" => "Mass search and replace",
// "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a href=\"http://ckeditor.com/\">CKEditor</a>",
// "Page links" => "Page links",
// "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature" => "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is planned to be addressed through the future \"Use Wiki syntax in WYSIWYG\" feature",
// "Wysiwyg Editor Features" => "Wysiwyg Editor Features",
// "Related features" => "Related features",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
// "Edit Repository" => "Edit Repository",
// "Create New Repository" => "Create New Repository",
// "List Repositories" => "List Repositories",
// "New Repository" => "New Repository",
// "View Repository" => "View Repository",
// "Human-readable repository name" => "Human-readable repository name",
// "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')",
// "File name of start page" => "File name of start page",
// "CSS file to load when browse this repository" => "CSS file to load when browse this repository",
// "Is repository visible to users" => "Is repository visible to users",
// "Can files from repository be cached" => "Can files from repository be cached",
// "Cacheable" => "Cacheable",
// "Are files from repository can be cached" => "Are files from repository can be cached",
// "Clear all cached pages of this repository" => "Clear all cached pages of this repository",
// "Seconds count 'till cached page will be expired" => "Seconds count 'till cached page will be expired",
// "Cache expiration" => "Cache expiration",
// "Human-readable text description of repository" => "Human-readable text description of repository",
// "Available Repositories" => "Available Repositories",
// "Edit rules" => "Edit rules",
// "Edit Rules for Repository" => "Edit Rules for Repository",
// "Configure Repositories" => "Configure Repositories",
// "Configure this Repository" => "Configure this Repository",
// "View this Repository" => "View this Repository",
// "New Rule" => "New Rule",
// "Copy Rules" => "Copy Rules",
// "view/hide copy rules dialog" => "view/hide copy rules dialog",
// "Source repository" => "Source repository",
// "Copy" => "Copy",
// "According this order rules will be applied ('0' or empty = auto)" => "According this order rules will be applied ('0' or empty = auto)",
// "Rule order" => "Rule order",
// "Text to search for" => "Text to search for",
// "Text to replace" => "Text to replace",
// "Is this regular expression or simple search/replacer" => "Is this regular expression or simple search/replacer",
// "Regex" => "Regex",
// "Is case sensitive (for simple replacer)" => "Is case sensitive (for simple replacer)",
// "Case sensitive" => "Case sensitive",
// "subset of chars: imsxeADSXUu, which is regex modifiers" => "subset of chars: imsxeADSXUu, which is regex modifiers",
// "Regex modifiers" => "Regex modifiers",
// "Human-readable text description of rule" => "Human-readable text description of rule",
// "Check to enable this rule" => "Check to enable this rule",
// "Preview options" => "Preview options",
// "Apply all rules or just this to generate preview" => "Apply all rules or just this to generate preview",
// "Apply all rules" => "Apply all rules",
// "View source code after rules applied" => "View source code after rules applied",
// "Code preview" => "Code preview",
// "Generate HTML preview" => "Generate HTML preview",
// "HTML preview" => "HTML preview",
// "Test file from repository to generate preview for (empty = configured start page)" => "Test file from repository to generate preview for (empty = configured start page)",
// "Preview Results" => "Preview Results",
// "Rules List" => "Rules List",
// "Case" => "Case",
// "Configure/Options" => "Configure/Options",
// "Admin keywords" => "Admin keywords",
// "Keywords have been updated" => "Keywords have been updated",
// "Updating keywords has failed. Page probably doesn't exist" => "Updating keywords has failed. Page probably doesn't exist",
// "Edit page keywords" => "Edit page keywords",
// "Current Page Keywords" => "Current Page Keywords",
// "Search by page" => "Search by page",
// "Admin layout" => "Admin layout",
// "layout options" => "layout options",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
// "Edit this Featured Link" => "Edit this Featured Link",
// "Create new Featured Link" => "Create new Featured Link",
// "Mail-in accounts" => "Mail-in accounts",
// "Account" => "Account",
// "Add new Mail-in account" => "Add new Mail-in account",
// "Edit Mail-in account" => "Edit Mail-in account",
// "article-put" => "article-put",
// "Article Topic" => "Article Topic",
// "Article Type" => "Article Type",
// "Allow anonymous access" => "Allow anonymous access",
// "Allow attachments" => "Allow attachments",
// "Discard to the end from" => "Discard to the end from",
// "Check Mail-in accounts" => "Check Mail-in accounts",
// "Check automatically" => "Check automatically",
// "Frequency" => "Frequency",
// "mn" => "mn",
// "Manage menu" => "Manage menu",
// "Show Quick Urls" => "Show Quick Urls",
// "Hide Quick Urls" => "Hide Quick Urls",
// "For wiki page, use ((PageName))" => "For wiki page, use ((PageName))",
// "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed",
// "sorted section level 0" => "sorted section level 0",
// "Create Blog" => "Create Blog",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "Import/export menu" => "Import/export menu",
// "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'",
// "Create/Edit Menu" => "Create/Edit Menu",
// "Edit this Menu" => "Edit this Menu",
// "Create new Menu" => "Create new Menu",
// "Icons" => "Icons",
// "Folder Icon" => "Folder Icon",
// "Path and filename of closed folder icon" => "Path and filename of closed folder icon",
// "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder",
// "In the same directory, include an icon for the opened folder" => "In the same directory, include an icon for the opened folder",
// "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>",
// "For example, the default icon is: pics/icons/folder.png" => "For example, the default icon is: pics/icons/folder.png",
// "The name of the \"open folder\" icon is: pics/icons/ofolder.png" => "The name of the \"open folder\" icon is: pics/icons/ofolder.png",
// "Configure icons for menu entries" => "Configure icons for menu entries",
// "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu",
// "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes" => "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes",
// "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tiki.org\">themes</a>" => "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tiki.org\">themes</a>",
// "To use a menu in a tiki format" => "To use a menu in a tiki format",
// "To use menu in a css/suckerfish format" => "To use menu in a css/suckerfish format",
// "To customize the menu's CSS id (#)" => "To customize the menu's CSS id (#)",
// "Admin Metrics" => "Admin Metrics",
// "Admin Metrics Template" => "Admin Metrics Template",
// "Metrics" => "Metrics",
// "Assign Metrics" => "Assign Metrics",
// "Assigned Metrics" => "Assigned Metrics",
// "Edit/Create Metrics" => "Edit/Create Metrics",
// "Edit/Create Tab" => "Edit/Create Tab",
// "Data Type" => "Data Type",
// "Weight" => "Weight",
// "Metric Name" => "Metric Name",
// "Tab Name" => "Tab Name",
// "Assign metric" => "Assign metric",
// "Edit this assigned metric" => "Edit this assigned metric",
// "Tab for metric" => "Tab for metric",
// "Create new metric" => "Create new metric",
// "Edit this metric" => "Edit this metric",
// "Hints" => "Hints",
// "For list-based metrics, include the \"LIMIT #\" in your query" => "For list-based metrics, include the \"LIMIT #\" in your query",
// "Name (must be unique)" => "Name (must be unique)",
// "Create new tab" => "Create new tab",
// "Edit this tab" => "Edit this tab",
// "Weight (must be integer)" => "Weight (must be integer)",
// "The following required parameters are missing" => "The following required parameters are missing",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "Visibility" => "Visibility",
// "Displayed now for all eligible users even with personal assigned modules" => "Displayed now for all eligible users even with personal assigned modules",
// "Displayed for the eligible users with no personal assigned modules" => "Displayed for the eligible users with no personal assigned modules",
// "Displayed now, can't be unassigned" => "Displayed now, can't be unassigned",
// "Not displayed until a user chooses it" => "Not displayed until a user chooses it",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
// "Module Options" => "Module Options",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
// "Random active poll" => "Random active poll",
// "Random current poll" => "Random current poll",
// "Default Tiki menus" => "Default Tiki menus",
// "CSS menus" => "CSS menus",
// "Use CSS menu" => "Use CSS menu",
// "PHP Layers menus" => "PHP Layers menus",
// "Use phplayermenu" => "Use phplayermenu",
// "To use a default Tiki menu" => "To use a default Tiki menu",
// "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes" => "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\">CSS (Superfish) menu</a>, use one of these syntaxes",
// "To use a <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">PHP Layers menu</a>, use one of these syntaxes (Note: PHP Layers menus are being replaced by CSS menus and may have only basic styling in newer themes.)" => "To use a <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">PHP Layers menu</a>, use one of these syntaxes (Note: PHP Layers menus are being replaced by CSS menus and may have only basic styling in newer themes.)",
// "Edit Newsletter" => "Edit Newsletter",
// "Wiki Page Name" => "Wiki Page Name",
// "Validate Addresses" => "Validate Addresses",
// "Add To List" => "Add To List",
// "Unsubscribed" => "Unsubscribed",
// "Add subscribers" => "Add subscribers",
// "Users from group" => "Users from group",
// "Group subscription also subscribes included groups" => "Group subscription also subscribes included groups",
// "Don't send confirmation mail" => "Don't send confirmation mail",
// "The user email will be refreshed at each newsletter sending" => "The user email will be refreshed at each newsletter sending",
// "Import emails from file" => "Import emails from file",
// "Don't send confirmation mails" => "Don't send confirmation mails",
// "Import emails from wiki page" => "Import emails from wiki page",
// "Wiki page, one e-mail per line" => "Wiki page, one e-mail per line",
// "Including group, group users and emails will be refreshed at each newsletter sending" => "Including group, group users and emails will be refreshed at each newsletter sending",
// "Use subscribers of another newsletter" => "Use subscribers of another newsletter",
// "Use emails from wiki page" => "Use emails from wiki page",
// "Emails on a wiki page which will be added at each newsletter sending, one e-mail per line" => "Emails on a wiki page which will be added at each newsletter sending, one e-mail per line",
// "Don't subscribe emails" => "Don't subscribe emails",
// "Create Newsletter" => "Create Newsletter",
// "Allow clipping of articles into newsletter" => "Allow clipping of articles into newsletter",
// "Automatically clip articles into newsletter" => "Automatically clip articles into newsletter",
// "Clip articles published in the past number of days" => "Clip articles published in the past number of days",
// "Article types to clip" => "Article types to clip",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
// "Alert" => "Alert",
// "Preload Admin Account" => "Preload Admin Account",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Add Option" => "Add Option",
// "Leave box empty for deleting an option" => "Leave box empty for deleting an option",
// "This menu shows only Polls with 'status': \"template\"" => "This menu shows only Polls with 'status': \"template\"",
// "Admin External Feeds" => "Admin External Feeds",
// "Tips" => "Tips",
// "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
// "Article Generator" => "Article Generator",
// "The article generator will create a new article for every item read in the RSS feed" => "The article generator will create a new article for every item read in the RSS feed",
// "Use Article Submission System" => "Use Article Submission System",
// "Publish in the future" => "Publish in the future",
// "-1 to use original publishing date from the feed" => "-1 to use original publishing date from the feed",
// "Configure" => "Configure",
// "Edit this feed" => "Edit this feed",
// "Create new external feed" => "Create new external feed",
// "show feed title" => "show feed title",
// "show publish date" => "show publish date",
// "Show Date" => "Show Date",
// "View feed" => "View feed",
// "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>",
// "PHP settings" => "PHP settings",
// "PHP variable" => "PHP variable",
// "Risk Factor" => "Risk Factor",
// "Explanation" => "Explanation",
// "PHP functions" => "PHP functions",
// "Function" => "Function",
// "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini" => "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini",
// "Tiki settings" => "Tiki settings",
// "Tiki variable" => "Tiki variable",
// "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors",
// "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
// "Security checks" => "Security checks",
// "Check all tiki files" => "Check all tiki files",
// "Note, that this can take a very long time. You should check your max_execution_time setting in php.ini" => "Note, that this can take a very long time. You should check your max_execution_time setting in php.ini",
// "File checks" => "File checks",
// "Check file permissions" => "Check file permissions",
// "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments" => "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments",
// "See end of table for detailed explanations" => "See end of table for detailed explanations",
// "owner" => "owner",
// "special" => "special",
// "other" => "other",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
// "Admin Shoutbox Words" => "Admin Shoutbox Words",
// "Add Banned Word" => "Add Banned Word",
// "Are you sure you want to delete this word" => "Are you sure you want to delete this word",
// "XML Zip Import" => "XML Zip Import",
// "The structure" => "The structure",
// "has just been created" => "has just been created",
// "You will remove structure" => "You will remove structure",
// "Destroy the structure leaving the wiki pages" => "Destroy the structure leaving the wiki pages",
// "Destroy the structure and remove the pages" => "Destroy the structure and remove the pages",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict",
// "The following pages have automatically been categorized with the same categories as the structure" => "The following pages have automatically been categorized with the same categories as the structure",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent",
// "XML Zip" => "XML Zip",
// "Delete with the pages" => "Delete with the pages",
// "Create New structure" => "Create New structure",
// "For the 'wiki textarea' type, options are: rows,columns. Example: 10,60" => "For the 'wiki textarea' type, options are: rows,columns. Example: 10,60",
// "Create Survey" => "Create Survey",
// "Create/Edit Surveys" => "Create/Edit Surveys",
// "View mode" => "View mode",
// "Wiki and WYSIWYG" => "Wiki and WYSIWYG",
// "Wiki only" => "Wiki only",
// "WYSIWYG only" => "WYSIWYG only",
// "Load" => "Load",
// "Reset to Global" => "Reset to Global",
// "Reset to defaults" => "Reset to defaults",
// "Auto Reloading" => "Auto Reloading",
// "Row" => "Row",
// "Formatting Tools" => "Formatting Tools",
// "Plugin Tools" => "Plugin Tools",
// "Edit tool" => "Edit tool",
// "Wysiwyg Token" => "Wysiwyg Token",
// "Plugin name" => "Plugin name",
// "Custom Tools" => "Custom Tools",
// "Add a new custom tool" => "Add a new custom tool",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
// "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools" => "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools",
// "Delete all custom tools" => "Delete all custom tools",
// "Warning: There is no undo" => "Warning: There is no undo",
// "Position of field in list" => "Position of field in list",
// "Is mandatory/required" => "Is mandatory/required",
// "Req" => "Req",
// "Multi-lingual" => "Multi-lingual",
// "Is column searchable" => "Is column searchable",
// "Descr" => "Descr",
// "Validation parameter" => "Validation parameter",
// "Validation error message" => "Validation error message",
// "Important note" => "Important note",
// "The first field in the tracker to have column links to edit/view item (i.e. isMain) will be what is shown as the name of the item in category and search listings" => "The first field in the tracker to have column links to edit/view item (i.e. isMain) will be what is shown as the name of the item in category and search listings",
// "The option creator needs a field of type user selector and option 1" => "The option creator needs a field of type user selector and option 1",
// "Visible by" => "Visible by",
// "Editable by" => "Editable by",
// "Export fieldId also" => "Export fieldId also",
// "Check the box to re-import in this tracker and change the fields" => "Check the box to re-import in this tracker and change the fields",
// "Uncheck the box to import in another database" => "Uncheck the box to import in another database",
// "Groups will include" => "Groups will include",
// "Creator is assigned to the group" => "Creator is assigned to the group",
// "and it becomes his default group" => "and it becomes his default group",
// "and it becomes the new item group creator" => "and it becomes the new item group creator",
// "But copy the default group in this fiedlId before updating the group" => "But copy the default group in this fiedlId before updating the group",
// "User can take ownership of item created by anonymous" => "User can take ownership of item created by anonymous",
// "Member of the creator group can modify items" => "Member of the creator group can modify items",
// "Identify creation user in tracker item" => "Identify creation user in tracker item",
// "Identify lastModif user in tracker item" => "Identify lastModif user in tracker item",
// "Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)" => "Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)",
// "Wiki page to display an item" => "Wiki page to display an item",
// "wiki:pageName for a wiki page or tpl:tplName for a template" => "wiki:pageName for a wiki page or tpl:tplName for a template",
// "Status changes list" => "Status changes list",
// "Delay" => "Delay",
// "Notification" => "Notification",
// "Delete todo" => "Delete todo",
// "Status changes" => "Status changes",
// "After creation" => "After creation",
// "After last modification" => "After last modification",
// "Warn creator of an upcoming status change" => "Warn creator of an upcoming status change",
// "before" => "before",
// "Mail subject text" => "Mail subject text",
// "Mail body ressource" => "Mail body ressource",
// "wiki:pageName for a wiki page or tplName.tpl for a template" => "wiki:pageName for a wiki page or tplName.tpl for a template",
// "Add as new items" => "Add as new items",
// "The order of the fields does not matter, but you need to add a header with the field names" => "The order of the fields does not matter, but you need to add a header with the field names",
// "Add \" -- \" to the end of the fields in the header that you would like to import" => "Add \" -- \" to the end of the fields in the header that you would like to import",
// "Auto-incremented itemid fields shall be included with no matter what values" => "Auto-incremented itemid fields shall be included with no matter what values",
// "Subset Selection" => "Subset Selection",
// "Category Selection" => "Category Selection",
// "Group Selection" => "Group Selection",
// "Type in a group name and click \"enter\"" => "Type in a group name and click \"enter\"",
// "Once you have selected at least two, click" => "Once you have selected at least two, click",
// "and then, click the \"New/Edit\" tab which will appear above" => "and then, click the \"New/Edit\" tab which will appear above",
// "Draw Transition Diagram" => "Draw Transition Diagram",
// "Guards" => "Guards",
// "preserved" => "preserved",
// "Assign permissions for transition" => "Assign permissions for transition",
// "No transitions" => "No transitions",
// "New / Edit" => "New / Edit",
// "Edit <em>%0</em>" => "Edit <em>%0</em>",
// "New transition" => "New transition",
// "Upon trigger, preserve the initial state" => "Upon trigger, preserve the initial state",
// "Count" => "Count",
// "No guards on this transition" => "No guards on this transition",
// "New Guard" => "New Guard",
// "Exactly" => "Exactly",
// "At Least" => "At Least",
// "At Most" => "At Most",
// "States" => "States",
// "Manage permissions" => "Manage permissions",
// "Invitation List" => "Invitation List",
// "Inherits Permissions from" => "Inherits Permissions from",
// "Group Homepage" => "Group Homepage",
// "Inherit permissions directly from following groups" => "Inherit permissions directly from following groups",
// "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)" => "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)",
// "Group Homepage or Url" => "Group Homepage or Url",
// "Use wiki page name or full URL" => "Use wiki page name or full URL",
// "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)" => "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)",
// "Default category assigned to uncategorized objects edited by a user with this default group" => "Default category assigned to uncategorized objects edited by a user with this default group",
// "Group Theme" => "Group Theme",
// "Use site default" => "Use site default",
// "Group Information Tracker" => "Group Information Tracker",
// "choose a group tracker .." => "choose a group tracker ..",
// "choose a field .." => "choose a field ..",
// "Users Information Tracker" => "Users Information Tracker",
// "choose a users tracker .." => "choose a users tracker ..",
// "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)",
// "User can assign to the group himself" => "User can assign to the group himself",
// "Users are automatically unassigned from the group after" => "Users are automatically unassigned from the group after",
// "0 or empty for never" => "0 or empty for never",
// "Users are automatically assigned at registration in the group if their emails match the pattern" => "Users are automatically assigned at registration in the group if their emails match the pattern",
// "Example: " => "Example: ",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
// "Group tracker item : {\$groupitemid}" => "Group tracker item : {\$groupitemid}",
// "Group tracker item not found" => "Group tracker item not found",
// "Create Item" => "Create Item",
// "Choose a field .." => "Choose a field ..",
// "Members List" => "Members List",
// "Expire" => "Expire",
// "Remove from Group" => "Remove from Group",
// "users in group" => "users in group",
// "Add to group" => "Add to group",
// "Download CSV export" => "Download CSV export",
// "Assign users to group" => "Assign users to group",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
// "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login",
// "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login",
// "Updated users" => "Updated users",
// "Group (direct)" => "Group (direct)",
// "OpenID" => "OpenID",
// "N" => "N",
// "Edit Included Group" => "Edit Included Group",
// "Confirm user email" => "Confirm user email",
// "Manage Group Assignments" => "Manage Group Assignments",
// "Set Default Groups" => "Set Default Groups",
// "Send a wiki page by Email" => "Send a wiki page by Email",
// "Assign selected to" => "Assign selected to",
// "Remove selected from" => "Remove selected from",
// "the following groups" => "the following groups",
// "Set the default group of the selected users to" => "Set the default group of the selected users to",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "Tikiwiki is configured to delegate the password managment to LDAP" => "Tikiwiki is configured to delegate the password managment to LDAP",
// "User must change password at next login" => "User must change password at next login",
// "Send an email to the user in order to allow him to validate his account" => "Send an email to the user in order to allow him to validate his account",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "CSV file layout" => "CSV file layout",
// "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\"group1,group2\",group1" => "login,password,email,groups,default_group,realName<br />user1,pass1,email1,group1,group1<br />user2,pass2,email2,\"group1,group2\",group1",
// "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory.Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
// "Create groups" => "Create groups",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
// "Changes from the following versions under staging have been merged into the approved version" => "Changes from the following versions under staging have been merged into the approved version",
// "Shows up in the drop down list of article types" => "Shows up in the drop down list of article types",
// "Allow ratings by the author" => "Allow ratings by the author",
// "Show before publish date" => "Show before publish date",
// "non-admins can view before the publish date" => "non-admins can view before the publish date",
// "Show after expire date" => "Show after expire date",
// "non-admins can view after the expire date" => "non-admins can view after the expire date",
// "Heading only" => "Heading only",
// "No article body, heading only" => "No article body, heading only",
// "Allow comments for this type" => "Allow comments for this type",
// "Comment Can Rate Article" => "Comment Can Rate Article",
// "Allow comments to include a rating value" => "Allow comments to include a rating value",
// "Show a small title over the title" => "Show a small title over the title",
// "Show subtitle" => "Show subtitle",
// "Show the subtitle" => "Show the subtitle",
// "Show source" => "Show source",
// "Show link to source after article body" => "Show link to source after article body",
// "Show Image Caption" => "Show Image Caption",
// "Show a legend under the image" => "Show a legend under the image",
// "Creator can edit" => "Creator can edit",
// "The person who submits an article of this type can edit it" => "The person who submits an article of this type can edit it",
// "Actions on this article type" => "Actions on this article type",
// "List of article types" => "List of article types",
// "view articles with this type" => "view articles with this type",
// "Custom attribute" => "Custom attribute",
// "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems" => "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems",
// "Click this button to try it now" => "Click this button to try it now",
// "Global object permissions" => "Global object permissions",
// "Assign User {\$assign_user|escape} to Groups" => "Assign User {\$assign_user|escape} to Groups",
// "Directory batch upload" => "Directory batch upload",
// "Remove File Extension from Image Name" => "Remove File Extension from Image Name",
// "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Select a Gallery" => "Select a Gallery",
// "Browse File Gallery" => "Browse File Gallery",
// "Please do not use this feature to upload data into the database" => "Please do not use this feature to upload data into the database",
// "Available Files" => "Available Files",
// "Select a File Gallery" => "Select a File Gallery",
// "Process files" => "Process files",
// "New Post" => "New Post",
// "View post" => "View post",
// "Excerpt" => "Excerpt",
// "Tiki Wiki CMS Groupware" => "Tiki Wiki CMS Groupware",
// "Admin the Category System" => "Admin the Category System",
// "No result found" => "No result found",
// "result found" => "result found",
// "Directory Batch" => "Directory Batch",
// "You can include the gallery's image in an HTML page using" => "You can include the gallery's image in an HTML page using",
// "You can include the image in a tiki page using" => "You can include the image in a tiki page using",
// "Slideshow Forward" => "Slideshow Forward",
// "Cyclic" => "Cyclic",
// "Click to zoom" => "Click to zoom",
// "Image size" => "Image size",
// "Image Scale" => "Image Scale",
// "Latitude (WGS84/decimal degrees)" => "Latitude (WGS84/decimal degrees)",
// "Longitude (WGS84/decimal degrees)" => "Longitude (WGS84/decimal degrees)",
// "Include the image in a tiki page using the following syntax" => "Include the image in a tiki page using the following syntax",
// "To include the image in an HTML page" => "To include the image in an HTML page",
// "To link to this page from another tiki page" => "To link to this page from another tiki page",
// "Export as iCal" => "Export as iCal",
// "Export as CSV" => "Export as CSV",
// "Export event" => "Export event",
// "Classification" => "Classification",
// "Change Focus" => "Change Focus",
// "o" => "o",
// "Edit/Delete event" => "Edit/Delete event",
// "New Calendar Item" => "New Calendar Item",
// "Recurrence" => "Recurrence",
// "This event depends on a recurrence rule" => "This event depends on a recurrence rule",
// "This event is not recurrent" => "This event is not recurrent",
// "On a weekly basis" => "On a weekly basis",
// "Each" => "Each",
// "of the week" => "of the week",
// "On a monthly basis" => "On a monthly basis",
// "of the month" => "of the month",
// "On a yearly basis" => "On a yearly basis",
// "Starting on" => "Starting on",
// "ending by" => "ending by",
// "ending after" => "ending after",
// "events" => "events",
// "Start period" => "Start period",
// "End after" => "End after",
// "occurrences" => "occurrences",
// "End before" => "End before",
// "Event is repeated" => "Event is repeated",
// "every" => "every",
// "of every month" => "of every month",
// "on each" => "on each",
// "Date and time of end" => "Date and time of end",
// "Events cannot end before they start" => "Events cannot end before they start",
// "or new" => "or new",
// "Choose users to alert" => "Choose users to alert",
// "Withdraw me from the list of participants" => "Withdraw me from the list of participants",
// "Add me to the list of participants" => "Add me to the list of participants",
// "Participant names separated by comma" => "Participant names separated by comma",
// "chair" => "chair",
// "required participant" => "required participant",
// "optional participant" => "optional participant",
// "non participant" => "non participant",
// "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in" => "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
// "Update this event only" => "Update this event only",
// "Update every unchanged events of this recurrence rule" => "Update every unchanged events of this recurrence rule",
// "Update every events of this recurrence rule" => "Update every events of this recurrence rule",
// "Delete Recurrent events" => "Delete Recurrent events",
// "Calendar import" => "Calendar import",
// "Calendar has been updated" => "Calendar has been updated",
// "Column names on the first line" => "Column names on the first line",
// "%0 column name can be used instead of %1" => "%0 column name can be used instead of %1",
// "See" => "See",
// "D" => "D",
// "W" => "W",
// "M" => "M",
// "%d/%m" => "%d/%m",
// "%m/%d" => "%m/%d",
// "Advanced parameters for iCal export" => "Advanced parameters for iCal export",
// "Calendars to be exported" => "Calendars to be exported",
// "Export calendars iCal" => "Export calendars iCal",
// "Export calendars CSV" => "Export calendars CSV",
// "Your account has been validated" => "Your account has been validated",
// "You have to choose a password to use this account" => "You have to choose a password to use this account",
// "Please choose the language for this page" => "Please choose the language for this page",
// "Choose language" => "Choose language",
// "Group View" => "Group View",
// "Publish this contact to groups" => "Publish this contact to groups",
// "Quick Create Multilanguage Pages" => "Quick Create Multilanguage Pages",
// "Following pages were created, as translations of each other" => "Following pages were created, as translations of each other",
// "Following pages were not created" => "Following pages were not created",
// "page already exists" => "page already exists",
// "Enter the names of a new page page in various languages" => "Enter the names of a new page page in various languages",
// "Preferred languages" => "Preferred languages",
// "Other languages" => "Other languages",
// "Create pages" => "Create pages",
// "View generated WebHelp" => "View generated WebHelp",
// "No structure" => "No structure",
// "Top page" => "Top page",
// "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>",
// "Directory Categories" => "Directory Categories",
// "Parent directory category" => "Parent directory category",
// "Add a Directory Category" => "Add a Directory Category",
// "Most visited directory sub-categories" => "Most visited directory sub-categories",
// "Directory Category description" => "Directory Category description",
// "Random directory sub-categories" => "Random directory sub-categories",
// "Maximum number of children to show" => "Maximum number of children to show",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
// "Editor group" => "Editor group",
// "Directory Subcategories" => "Directory Subcategories",
// "cType" => "cType",
// "allow" => "allow",
// "count" => "count",
// "relate" => "relate",
// "Admin related directory categories" => "Admin related directory categories",
// "Add a related directory category" => "Add a related directory category",
// "Directory Category" => "Directory Category",
// "Related directory categories" => "Related directory categories",
// "in current directory category" => "in current directory category",
// "Hits (desc)" => "Hits (desc)",
// "Hits (asc)" => "Hits (asc)",
// "Last updated (desc)" => "Last updated (desc)",
// "Last updated (asc)" => "Last updated (asc)",
// "Total directory categories" => "Total directory categories",
// "Discounts" => "Discounts",
// "Max time the discount can be used in the first phase of payment" => "Max time the discount can be used in the first phase of payment",
// "-1 for illimited" => "-1 for illimited",
// "Translation of this page is incomplete" => "Translation of this page is incomplete",
// "To add <strong>new content</strong> to the page" => "To add <strong>new content</strong> to the page",
// "use the editor" => "use the editor",
// "Topline" => "Topline",
// "If not the topic image" => "If not the topic image",
// "Article image" => "Article image",
// "If different than the uploaded image" => "If different than the uploaded image",
// "List mode" => "List mode",
// "If different than in view mode" => "If different than in view mode",
// "Image caption" => "Image caption",
// "If not the topic name" => "If not the topic name",
// "Allow full HTML" => "Allow full HTML",
// "for this edit session" => "for this edit session",
// "Emails to be notified (separated with commas)" => "Emails to be notified (separated with commas)",
// "-1 for unlimited" => "-1 for unlimited",
// "Max impressions for a user" => "Max impressions for a user",
// "Max clicks" => "Max clicks",
// "Or, create a new zone" => "Or, create a new zone",
// "Use Flash" => "Use Flash",
// "Movie Size" => "Movie Size",
// "Pixels" => "Pixels",
// "FlashPlugin min version" => "FlashPlugin min version",
// "ex" => "ex",
// "Remove Zones (you lose entered info for the banner)" => "Remove Zones (you lose entered info for the banner)",
// "A category is mandatory" => "A category is mandatory",
// "Allow other users to post in this blog" => "Allow other users to post in this blog",
// "If others post to blog, Author should always be Owner" => "If others post to blog, Author should always be Owner",
// "Display Options" => "Display Options",
// "Number of posts to show per page" => "Number of posts to show per page",
// "Display blog title in posts list page" => "Display blog title in posts list page",
// "Display blog title in post page" => "Display blog title in post page",
// "Display blog description" => "Display blog description",
// "Display breadcrumbs" => "Display breadcrumbs",
// "Display author in blog posts" => "Display author in blog posts",
// "Display published date in blog posts" => "Display published date in blog posts",
// "Show user avatar" => "Show user avatar",
// "Show post related content" => "Show post related content",
// "The checkbox is disabled because feature_freetags is disabled globally" => "The checkbox is disabled because feature_freetags is disabled globally",
// "Maximum number of related posts to display" => "Maximum number of related posts to display",
// "Use post excerpt" => "Use post excerpt",
// "Heading preview" => "Heading preview",
// "Blog post heading" => "Blog post heading",
// "Edit Style Sheet" => "Edit Style Sheet",
// "Style Sheet" => "Style Sheet",
// "The file will be saved in" => "The file will be saved in",
// "choose a stylesheet" => "choose a stylesheet",
// "Try" => "Try",
// "For more information, please see" => "For more information, please see",
// "Wiki Page Editor" => "Wiki Page Editor",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "The syntax system used for creating pages in Tiki" => "The syntax system used for creating pages in Tiki",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename" => "Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename",
// "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)" => "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)",
// "For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))",
// "page|#anchor" => "page|#anchor",
// "page|#anchor|desc" => "page|#anchor|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
// "Indentation" => "Indentation",
// "Creates an indentation for each plus (useful in list to continue at the same level)" => "Creates an indentation for each plus (useful in list to continue at the same level)",
// "Prevents wiki parsing of the enclosed data" => "Prevents wiki parsing of the enclosed data",
// "Preformated sections" => "Preformated sections",
// "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text",
// "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar",
// "Block Preformatting" => "Block Preformatting",
// "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that" => "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that",
// "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew" => "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew",
// "Special characters" => "Special characters",
// "hard space" => "hard space",
// "numeric between ~ for html numeric characters entity" => "numeric between ~ for html numeric characters entity",
// "Plugin Help" => "Plugin Help",
// "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt" => "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt",
// "More help here" => "More help here",
// "Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki plugins extend the function of wiki syntax with more specialized commands",
// "Activate/deactivate plugins" => "Activate/deactivate plugins",
// "Spreadsheet Help" => "Spreadsheet Help",
// "jQuery.sheet spreadsheets" => "jQuery.sheet spreadsheets",
// "What is jQuery.sheet" => "What is jQuery.sheet",
// "jQuery.sheet gives you all sorts of possibilities when it comes to giving your web application a spreadsheet style interface with MS Excel style calculations" => "jQuery.sheet gives you all sorts of possibilities when it comes to giving your web application a spreadsheet style interface with MS Excel style calculations",
// "jQuery.sheet manages the sheet creation, viewing, and editing processes.  It can even be used like a datagrid, without calculations.\nFor a complete list of all the MS Excel style functions that jQuery.sheet supports, see below" => "jQuery.sheet manages the sheet creation, viewing, and editing processes.  It can even be used like a datagrid, without calculations.\nFor a complete list of all the MS Excel style functions that jQuery.sheet supports, see below",
// "Wysiwyg Editor" => "Wysiwyg Editor",
// "More help on wysiwyg editing" => "More help on wysiwyg editing",
// "The WYSIWYG editor in Tiki 6+ is\n\t<a href=\"http://ckeditor.com\">CKEditor</a>,\n\tthe new version of FCKEditor (used in Tiki since version 2.0)" => "The WYSIWYG editor in Tiki 6+ is\n\t<a href=\"http://ckeditor.com\">CKEditor</a>,\n\tthe new version of FCKEditor (used in Tiki since version 2.0)",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon _id=\"pencil_go\"} button on the toolbar",
// "<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent" => "<strong>N.B. </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent",
// "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br />\n\tHere is an example of the {ldelim}BOX{rdelim} plugin",
// "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred" => "This is the text in the box which is justified; the box has a cream background, takes 80% of the screen width and is centred",
// "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 6.0) drag and drop of plugins in WYSIWYG does not work" => "<strong>Caution:</strong> This is a new feature and still work in progress.<br />\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br />\n\tCurrently (in Tiki 6.0) drag and drop of plugins in WYSIWYG does not work",
// "<strong>Admins:</strong><br />\n\t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>.\n\t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br />\n\t\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">wysiwyg admin page</a>.\n\t\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
// "Upload from disk to change the image" => "Upload from disk to change the image",
// "Save and Go Next" => "Save and Go Next",
// "Edit or export/import languages" => "Edit or export/import languages",
// "Toggle interactive translation off" => "Toggle interactive translation off",
// "Toggle interactive translation on" => "Toggle interactive translation on",
// "No translations in the database. First import a language, translate strings using interactive translation or enable \"Record untranslated strings\" in Admin -> i18n" => "No translations in the database. First import a language, translate strings using interactive translation or enable \"Record untranslated strings\" in Admin -> i18n",
// "Export languages" => "Export languages",
// "If you click \"Download database translations\", you will download a file with all the translations in the database" => "If you click \"Download database translations\", you will download a file with all the translations in the database",
// "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database" => "If you click \"Write to language.php\", the translations in the database will be merged with the other translations in language.php. Note that after writing translations to language.php they are removed from the database",
// "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory" => "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory",
// "Download database translations" => "Download database translations",
// "Write to language.php" => "Write to language.php",
// "Import languages" => "Import languages",
// "Select the language to import" => "Select the language to import",
// "Beware that when importing a language, all translations in the database for that language are deleted" => "Beware that when importing a language, all translations in the database for that language are deleted",
// "Return to default perspective" => "Return to default perspective",
// "Switch to" => "Switch to",
// "Configurations" => "Configurations",
// "Hint" => "Hint",
// "Search for configurations below and drag them in to the configuration section above" => "Search for configurations below and drag them in to the configuration section above",
// "Immediate feedback" => "Immediate feedback",
// "Show correct answers" => "Show correct answers",
// "Shuffle questions" => "Shuffle questions",
// "Shuffle answers" => "Shuffle answers",
// "Passing Percentage" => "Passing Percentage",
// "%" => "%",
// "Edit quiz questions" => "Edit quiz questions",
// "Question Type" => "Question Type",
// "Import questions from text" => "Import questions from text",
// "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character" => "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character",
// "Input" => "Input",
// "Edit quiz results" => "Edit quiz results",
// "The page already exists. The page that has been added to the structure is the existing one" => "The page already exists. The page that has been added to the structure is the existing one",
// "The following pages added have automatically been categorized with the same categories as the structure" => "The following pages added have automatically been categorized with the same categories as the structure",
// "Monitor the Sub-Structure" => "Monitor the Sub-Structure",
// "Stop Monitoring the Sub-Structure" => "Stop Monitoring the Sub-Structure",
// "Categorize all pages in structure together" => "Categorize all pages in structure together",
// "Remove existing categories from ALL pages before recategorizing" => "Remove existing categories from ALL pages before recategorizing",
// "<b>*</b>=optional" => "<b>*</b>=optional",
// "<b>Topline</b>=small line above Title" => "<b>Topline</b>=small line above Title",
// "<b>Subtitle</b>=small line below Title" => "<b>Subtitle</b>=small line below Title",
// "<b>Source</b>=URL to article source" => "<b>Source</b>=URL to article source",
// "Auto-Approve Article" => "Auto-Approve Article",
// "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering" => "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering",
// "This would cause you problems (e.g. menus can stop collapsing/expanding)" => "This would cause you problems (e.g. menus can stop collapsing/expanding)",
// "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)" => "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)",
// "Maybe You just want to modify the top of your Tiki site" => "Maybe You just want to modify the top of your Tiki site",
// "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface" => "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface",
// "Save Only in the Theme" => "Save Only in the Theme",
// "Delete the copy in the theme" => "Delete the copy in the theme",
// "Edit a topic" => "Edit a topic",
// "Add Notification Email" => "Add Notification Email",
// "Admin notifications" => "Admin notifications",
// "View Page" => "View Page",
// "View Article" => "View Article",
// "You must specify the object language" => "You must specify the object language",
// "The object doesn't exist" => "The object doesn't exist",
// "The object doesn't have a language" => "The object doesn't have a language",
// "The object has already a translation for this language" => "The object has already a translation for this language",
// "The object is already in the set of translations" => "The object is already in the set of translations",
// "Translate updates made on this page or one of its translations" => "Translate updates made on this page or one of its translations",
// "Translate this page to a new language" => "Translate this page to a new language",
// "Attach or detach existing translations of this page" => "Attach or detach existing translations of this page",
// "Change language for this page" => "Change language for this page",
// "Select language to translate to" => "Select language to translate to",
// "Unspecified" => "Unspecified",
// "Enter the page title" => "Enter the page title",
// "Below, assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Below, assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)",
// "Create translation" => "Create translation",
// "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"",
// "\"The page already exists. It was selected in the list below.\"" => "\"The page already exists. It was selected in the list below.\"",
// "Attach or detach existing translations of this article" => "Attach or detach existing translations of this article",
// "detach" => "detach",
// "Mark existing article as a translation of this one" => "Mark existing article as a translation of this one",
// "Add existing page as a translation of this page" => "Add existing page as a translation of this page",
// "Change Language" => "Change Language",
// "No language is assigned to this page" => "No language is assigned to this page",
// "Please select a language before performing translation" => "Please select a language before performing translation",
// "Set Current Page's Language" => "Set Current Page's Language",
// "Update '{\$page|escape}'" => "Update '{\$page|escape}'",
// "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval" => "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval",
// "This is a new staging page that has not been approved before" => "This is a new staging page that has not been approved before",
// "The current staging copy may contain changes that have yet to be approved" => "The current staging copy may contain changes that have yet to be approved",
// "View changes since last approval" => "View changes since last approval",
// "You are editing the approved copy of this page" => "You are editing the approved copy of this page",
// "There are currently changes in the staging copy that have yet to be approved" => "There are currently changes in the staging copy that have yet to be approved",
// "Are you sure you do not want to edit" => "Are you sure you do not want to edit",
// "the staging copy" => "the staging copy",
// "instead" => "instead",
// "Draft written on" => "Draft written on",
// "Warning: new versions of this page have been made after this draft" => "Warning: new versions of this page have been made after this draft",
// "The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page" => "The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page",
// "An edit summary is mandatory" => "An edit summary is mandatory",
// "Translate from" => "Translate from",
// "Changes that need to be translated are highlighted below" => "Changes that need to be translated are highlighted below",
// "No comment" => "No comment",
// "All Versions" => "All Versions",
// "Edit wiki page" => "Edit wiki page",
// "Select the style used to display differences to be translated" => "Select the style used to display differences to be translated",
// "html" => "html",
// "text full" => "text full",
// "Change the style used to display differences to be translated" => "Change the style used to display differences to be translated",
// "Change diff styles" => "Change diff styles",
// "Invalid page name" => "Invalid page name",
// "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>",
// "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>",
// "Edit page" => "Edit page",
// "Translate to" => "Translate to",
// "Reproduce the changes highlighted on the left using the editor below" => "Reproduce the changes highlighted on the left using the editor below",
// "Describe the change you made" => "Describe the change you made",
// "Edit comment: Enter some text to describe the changes you are currently making" => "Edit comment: Enter some text to describe the changes you are currently making",
// "Categorization has been preset for this edit" => "Categorization has been preset for this edit",
// "Allow comments on this page" => "Allow comments on this page",
// "Authors' style" => "Authors' style",
// "Admin wiki preferences" => "Admin wiki preferences",
// "itemId" => "itemId",
// "Fields visible in items list" => "Fields visible in items list",
// "Fields searchable or visible in items list" => "Fields searchable or visible in items list",
// "Fields visible in an item view" => "Fields visible in an item view",
// "All fields" => "All fields",
// "These fields" => "These fields",
// "Number of records" => "Number of records",
// "Zip export with attachments" => "Zip export with attachments",
// "Zip Export" => "Zip Export",
// "Dump All Tracker Items" => "Dump All Tracker Items",
// "File Archive" => "File Archive",
// "File Galleries tpl" => "File Galleries tpl",
// "Size (width x height)" => "Size (width x height)",
// "Forum Importer" => "Forum Importer",
// "Import from a Local SQL File" => "Import from a Local SQL File",
// "Forum Type" => "Forum Type",
// "DB Prefix" => "DB Prefix",
// "Local SQL Filename on Server (path will be stripped)" => "Local SQL Filename on Server (path will be stripped)",
// "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up",
// "Get Forum List" => "Get Forum List",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred",
// "Proceed" => "Proceed",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into" => "Which Forum Do You Wish to Import this Into",
// "Message queue for forum" => "Message queue for forum",
// "Reported messages for forum" => "Reported messages for forum",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Tag translation" => "Tag translation",
// "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag" => "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag",
// "Until then, they cannot be translated" => "Until then, they cannot be translated",
// "Show checkboxes to clear language information on tags" => "Show checkboxes to clear language information on tags",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
// "Universal" => "Universal",
// "Show the following languages" => "Show the following languages",
// "Pending requests" => "Pending requests",
// "Request Time" => "Request Time",
// "Refuse" => "Refuse",
// "Waiting requests" => "Waiting requests",
// "Cancel friendship request" => "Cancel friendship request",
// "Your friends" => "Your friends",
// "break friendship" => "break friendship",
// "Geographic" => "Geographic",
// "Fields to show during browsing the gallery" => "Fields to show during browsing the gallery",
// "XY-Size" => "XY-Size",
// "Global default" => "Global default",
// "Bounding box" => "Bounding box",
// "Original image is default scale" => "Original image is default scale",
// "Add scaled images with bounding box of square size" => "Add scaled images with bounding box of square size",
// "Make Map" => "Make Map",
// "Google Map Locator" => "Google Map Locator",
// "Back to preferences" => "Back to preferences",
// "enter address" => "enter address",
// "Find address" => "Find address",
// "Save clicked point" => "Save clicked point",
// "Reset view to default" => "Reset view to default",
// "Save current view as default" => "Save current view as default",
// "Center map to saved point" => "Center map to saved point",
// "Reset view to site default" => "Reset view to site default",
// "Users Map" => "Users Map",
// "Select Graphic Type" => "Select Graphic Type",
// "Pie Chart" => "Pie Chart",
// "Multiline" => "Multiline",
// "Multibar" => "Multibar",
// "Bar Stack" => "Bar Stack",
// "Landscape" => "Landscape",
// "Portrait" => "Portrait",
// "Independant Scale" => "Independant Scale",
// "Horizontal Scale" => "Horizontal Scale",
// "Vertical Scale" => "Vertical Scale",
// "Series" => "Series",
// "Wiki plug-in" => "Wiki plug-in",
// "Clone" => "Clone",
// "Toggle Full Screen" => "Toggle Full Screen",
// "Date Selection" => "Date Selection",
// "Edit Date" => "Edit Date",
// "View Spreadsheet" => "View Spreadsheet",
// "Clone Spreadsheet" => "Clone Spreadsheet",
// "Roll Back Spreadsheet" => "Roll Back Spreadsheet",
// "Roll-Back" => "Roll-Back",
// "Ical import / Export" => "Ical import / Export",
// "Select The calendar to export" => "Select The calendar to export",
// "Calendar Import" => "Calendar Import",
// "ICal File" => "ICal File",
// "Import From File" => "Import From File",
// "Grab Wiki Tables" => "Grab Wiki Tables",
// "Import pages from a Structured Text Dump" => "Import pages from a Structured Text Dump",
// "Name of the dump file (it has to be in dump/)" => "Name of the dump file (it has to be in dump/)",
// "body" => "body",
// "Or" => "Or",
// "Name of the zip file on the server" => "Name of the zip file on the server",
// "If you are NOT running a new Tiki installation, make a backup of your database before using this importer" => "If you are NOT running a new Tiki installation, make a backup of your database before using this importer",
// "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode",
// "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)" => "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)",
// "Select the software to import from" => "Select the software to import from",
// "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button",
// "Congratulations! You have successful imported your data to Tikiwiki" => "Congratulations! You have successful imported your data to Tikiwiki",
// "pages imported from a total of" => "pages imported from a total of",
// "You can see the list of wiki pages in your site" => "You can see the list of wiki pages in your site",
// "Importer log" => "Importer log",
// "Tiki installer" => "Tiki installer",
// "Welcome" => "Welcome",
// "Welcome to the Tiki installation and upgrade script" => "Welcome to the Tiki installation and upgrade script",
// "Use this script to install a new Tiki database or upgrade your existing database to release" => "Use this script to install a new Tiki database or upgrade your existing database to release",
// "For the latest information about this release, please read the" => "For the latest information about this release, please read the",
// "Release Notes" => "Release Notes",
// "For complete documentation, please visit" => "For complete documentation, please visit",
// "For more information about Tiki, please visit" => "For more information about Tiki, please visit",
// "Select your language" => "Select your language",
// "Read the License" => "Read the License",
// "Tiki is software distributed under the LGPL license" => "Tiki is software distributed under the LGPL license",
// " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>" => " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>",
// "Review the System Requirements" => "Review the System Requirements",
// "Before installing Tiki, <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Before installing Tiki, <a href=\"http://doc.tiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements",
// "This installer will perform some basic checks automatically" => "This installer will perform some basic checks automatically",
// "Success" => "Success",
// "Tiki has not detected your PHP memory_limit" => "Tiki has not detected your PHP memory_limit",
// "This probably means you have no set limit (all is well)" => "This probably means you have no set limit (all is well)",
// "Tiki has detected your PHP memory limit at" => "Tiki has detected your PHP memory limit at",
// "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution",
// "Allocating too little memory will cause Tiki to display blank pages" => "Allocating too little memory will cause Tiki to display blank pages",
// "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver" => "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver",
// "Tiki has detected your PHP memory_limit at" => "Tiki has detected your PHP memory_limit at",
// "Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages",
// "To test your system configuration, Tiki will attempt to send a test message to you" => "To test your system configuration, Tiki will attempt to send a test message to you",
// "Test email" => "Test email",
// "Email address to send test to" => "Email address to send test to",
// "Copy test mail to " => "Copy test mail to ",
// "Send Test Message" => "Send Test Message",
// "Tiki was able to send a test message to" => "Tiki was able to send a test message to",
// "Tiki was not able to send a test message" => "Tiki was not able to send a test message",
// "Review your mail log for details" => "Review your mail log for details",
// "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)",
// "If your host requires SMTP authentication, additional configuration may be necessary" => "If your host requires SMTP authentication, additional configuration may be necessary",
// "Image Processing" => "Image Processing",
// "Tiki detected" => "Tiki detected",
// "Tiki can create images" => "Tiki can create images",
// "Tiki was not able to create a sample image. Please check your GD library configuration" => "Tiki was not able to create a sample image. Please check your GD library configuration",
// "Tiki was not able to detect the GD library" => "Tiki was not able to detect the GD library",
// "Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support",
// "Set the Database Connection" => "Set the Database Connection",
// "Tiki requires an active database connection" => "Tiki requires an active database connection",
// "You must create the database and user <em>before</em> completing this page" => "You must create the database and user <em>before</em> completing this page",
// "Tiki cannot find a database connection" => "Tiki cannot find a database connection",
// "This is normal for a new installation" => "This is normal for a new installation",
// "Tiki found an existing database connection in your local.php file" => "Tiki found an existing database connection in your local.php file",
// "Use Existing Connection" => "Use Existing Connection",
// "Modify database connection" => "Modify database connection",
// "Use this page to create a new database connection, or use the <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Use this page to create a new database connection, or use the <a href=\"http://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>",
// "Database information" => "Database information",
// "Enter your database connection information" => "Enter your database connection information",
// "Database type" => "Database type",
// "Select the type of database to use with Tiki" => "Select the type of database to use with Tiki",
// "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension" => "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension",
// "Enter the host name or IP for your database" => "Enter the host name or IP for your database",
// "Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Use <strong>localhost</strong> if the database is running on the same machine as Tiki",
// "Database name" => "Database name",
// "Enter the name of the database that Tiki will use" => "Enter the name of the database that Tiki will use",
// "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names" => "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names",
// "Database user" => "Database user",
// "Enter a database user with administrator permission for the Database" => "Enter a database user with administrator permission for the Database",
// "User name" => "User name",
// "Character set" => "Character set",
// "Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box",
// "Always force connection to use UTF-8" => "Always force connection to use UTF-8",
// "Install &amp; Upgrade" => "Install &amp; Upgrade",
// "Install" => "Install",
// "Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page",
// "This install will populate (or upgrade) the database" => "This install will populate (or upgrade) the database",
// "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>",
// "A new install will populate the database" => "A new install will populate the database",
// "Encoding Issue" => "Encoding Issue",
// "<p>Your database encoding is <strong>not</strong> in UTF-8.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8</em>.</p>" => "<p>Your database encoding is <strong>not</strong> in UTF-8.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8</em>.</p>",
// "Character Set Conversion" => "Character Set Conversion",
// "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database",
// "Convert database and tables to UTF-8" => "Convert database and tables to UTF-8",
// "This will destroy your current database" => "This will destroy your current database",
// "Reinstall the database" => "Reinstall the database",
// "Reinstall" => "Reinstall",
// "Upgrade" => "Upgrade",
// "Warning: Category Permissions Will Not Be Upgraded" => "Warning: Category Permissions Will Not Be Upgraded",
// "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them",
// "Automatically upgrade your existing database to v" => "Automatically upgrade your existing database to v",
// "This site has an admin account configured" => "This site has an admin account configured",
// "Please log in with your admin password to continue" => "Please log in with your admin password to continue",
// "Review the Upgrade" => "Review the Upgrade",
// "Review the Installation" => "Review the Installation",
// "Upgrade complete" => "Upgrade complete",
// "Installation complete" => "Installation complete",
// "Your database has been configured and Tiki is ready to run" => "Your database has been configured and Tiki is ready to run",
// "If this is your first install, your admin password is <strong>admin</strong>" => "If this is your first install, your admin password is <strong>admin</strong>",
// "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application",
// "Upgrade operations executed successfully" => "Upgrade operations executed successfully",
// "Installation operations executed successfully" => "Installation operations executed successfully",
// "SQL queries" => "SQL queries",
// "Database was left unchanged" => "Database was left unchanged",
// "Failed" => "Failed",
// "Operations failed" => "Operations failed",
// "Display details" => "Display details",
// "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages",
// ".htaccess File" => ".htaccess File",
// "We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "We recommend enabling the <strong>.htaccess</strong> file for your Tiki",
// "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security",
// "Configure General Settings" => "Configure General Settings",
// "Complete these fields to configure common, general settings for your site" => "Complete these fields to configure common, general settings for your site",
// "The information you enter here can be changed later" => "The information you enter here can be changed later",
// "Refer to the <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Refer to the <a href=\"http://doc.tiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings",
// "This will appear in the browser title bar" => "This will appear in the browser title bar",
// "Email sent by your site will use this address" => "Email sent by your site will use this address",
// "Secure Log in" => "Secure Log in",
// "HTTPS login" => "HTTPS login",
// "PHP error reporting level" => "PHP error reporting level",
// "Visible to Admin only" => "Visible to Admin only",
// "Administrator" => "Administrator",
// "Admin email" => "Admin email",
// "This is the email address for your administrator account" => "This is the email address for your administrator account",
// "Upgrade fix" => "Upgrade fix",
// "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will" => "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n\t\t\t<p>We can fix it! Doing so will",
// "Create the <em>Admins</em> group, if missing" => "Create the <em>Admins</em> group, if missing",
// "Grant <em>tiki_p_admin</em> to the group, if missing" => "Grant <em>tiki_p_admin</em> to the group, if missing",
// "Add the administrator account to the group, if missing" => "Add the administrator account to the group, if missing",
// "To do so enter the name of the main admin account in the field below" => "To do so enter the name of the main admin account in the field below",
// "Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "Check this box if you have a lot of disabled accounts after an upgrade to tiki4",
// "List of accounts that will be enabled" => "List of accounts that will be enabled",
// "Enter Your Tiki" => "Enter Your Tiki",
// "The installation is complete" => "The installation is complete",
// "Tiki is an open source project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki is an open source project, <em>you</em> can <a href='http://info.tiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>",
// "Installation" => "Installation",
// "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu",
// "Enter Tiki and Lock Installer" => "Enter Tiki and Lock Installer",
// "Recommended" => "Recommended",
// "Enter Tiki Without Locking Installer" => "Enter Tiki Without Locking Installer",
// "You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker",
// "Are you sure you want to attempt to fix the encoding of your entire database" => "Are you sure you want to attempt to fix the encoding of your entire database",
// "Upgrading and running into encoding issues" => "Upgrading and running into encoding issues",
// "We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>",
// "Previous table encoding" => "Previous table encoding",
// "Please select" => "Please select",
// "Dangerous: Fix double encoding" => "Dangerous: Fix double encoding",
// "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue",
// "MultiTiki Setup" => "MultiTiki Setup",
// "Default Installation" => "Default Installation",
// "DB OK" => "DB OK",
// "No DB" => "No DB",
// "Adding a new host" => "Adding a new host",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
// "MultiTiki" => "MultiTiki",
// "Are you upgrading an existing Tiki site" => "Are you upgrading an existing Tiki site",
// "Go directly to the <strong>Install/Upgrade</strong> step" => "Go directly to the <strong>Install/Upgrade</strong> step",
// "Install/Upgrade" => "Install/Upgrade",
// "Restart the installer" => "Restart the installer",
// "Database Connection" => "Database Connection",
// "Reset the Database Connection" => "Reset the Database Connection",
// "Configure the General Settings" => "Configure the General Settings",
// "Tiki Icon" => "Tiki Icon",
// "Tiki Project Web Site" => "Tiki Project Web Site",
// "Support Forums" => "Support Forums",
// "Powered by Tiki Wiki CMS Groupware" => "Powered by Tiki Wiki CMS Groupware",
// "Clear cached version and refresh cache" => "Clear cached version and refresh cache",
// "configure rules" => "configure rules",
// "Invitation" => "Invitation",
// "Invitations list" => "Invitations list",
// "The mail has been sent to: " => "The mail has been sent to: ",
// "You are about to send an invitation to theses people, please confirm" => "You are about to send an invitation to theses people, please confirm",
// "Ok" => "Ok",
// "Fill this box with the list of e-mails you want to invite " => "Fill this box with the list of e-mails you want to invite ",
// "Format of the list above " => "Format of the list above ",
// "CSV Style: One line per invitation, with the format: lastname,firstname,email" => "CSV Style: One line per invitation, with the format: lastname,firstname,email",
// "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)",
// "Type here the e-mail subject you'll want to be sent to them " => "Type here the e-mail subject you'll want to be sent to them ",
// "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "Type here the e-mail content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) ",
// "Type here the content that the user will see when he'll click on the link from the mail " => "Type here the content that the user will see when he'll click on the link from the mail ",
// "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special " => "Choose one or more group you want theses suscribtion to be in. Don't choose any if you don't want anything special ",
// "Upload to Kaltura" => "Upload to Kaltura",
// "Upload Successful" => "Upload Successful",
// "You have successfully added {\$count} new entry/entries" => "You have successfully added {\$count} new entry/entries",
// "Add more media" => "Add more media",
// "Change Details" => "Change Details",
// "Remix" => "Remix",
// "Kaltura Video" => "Kaltura Video",
// "Media Entries" => "Media Entries",
// "Advanced Editor" => "Advanced Editor",
// "Simple Editor" => "Simple Editor",
// "Video Title" => "Video Title",
// "Embed code" => "Embed code",
// "Views" => "Views",
// "Plays" => "Plays",
// "No action specified" => "No action specified",
// "v" => "v",
// "ExpireDate" => "ExpireDate",
// "IsPublished" => "IsPublished",
// "Select Duplicates" => "Select Duplicates",
// "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone" => "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone",
// "Max Clicks" => "Max Clicks",
// "List all comments" => "List all comments",
// "The cache is used by" => "The cache is used by",
// "More info" => "More info",
// "Ban" => "Ban",
// "Delete & Ban" => "Delete & Ban",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block",
// "Future vers" => "Future vers",
// "Create/Edit content block" => "Create/Edit content block",
// "Edit content block" => "Edit content block",
// "Create content block" => "Create content block",
// "Edit/Create" => "Edit/Create",
// "Admin View" => "Admin View",
// "SlideShow" => "SlideShow",
// "optional" => "optional",
// "Modifications" => "Modifications",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "Inviter" => "Inviter",
// "Only successful invitations" => "Only successful invitations",
// "Only pending invitations" => "Only pending invitations",
// "Number of invitations" => "Number of invitations",
// "Kaltura Remix Entries" => "Kaltura Remix Entries",
// "Kaltura Media Entries" => "Kaltura Media Entries",
// "Loads" => "Loads",
// "List Remixes" => "List Remixes",
// "Browse Media Entries" => "Browse Media Entries",
// "Browse Remixes" => "Browse Remixes",
// "Create Remix" => "Create Remix",
// "Please select some media entries to use" => "Please select some media entries to use",
// "Remix Video" => "Remix Video",
// "Additional Info" => "Additional Info",
// "Media Id" => "Media Id",
// "Wiki plugin code" => "Wiki plugin code",
// "Media Type" => "Media Type",
// "More Information" => "More Information",
// "No entries" => "No entries",
// "No media entries found" => "No media entries found",
// "Click here" => "Click here",
// "to upload" => "to upload",
// "Modified By" => "Modified By",
// "No mix entries found" => "No mix entries found",
// "to create a new mix" => "to create a new mix",
// "Mix Entries" => "Mix Entries",
// "Playlist Type" => "Playlist Type",
// "No playlists found. " => "No playlists found. ",
// "Click here " => "Click here ",
// "to create a playlist" => "to create a playlist",
// "Object Permissions List" => "Object Permissions List",
// "Manage Permissions" => "Manage Permissions",
// "global permissions" => "global permissions",
// "object permissions" => "object permissions",
// "category permissions" => "category permissions",
// "If an object is not listed in the section below, then only the global perms are on" => "If an object is not listed in the section below, then only the global perms are on",
// "If an object is not listed in this section, then only the global perms are on" => "If an object is not listed in this section, then only the global perms are on",
// "{\$special.reason|escape}: {\$special.objectName}" => "{\$special.reason|escape}: {\$special.objectName}",
// "Blog: %0" => "Blog: %0",
// "New Blog Post" => "New Blog Post",
// "Post Title" => "Post Title",
// "users registered" => "users registered",
// "Distance (km)" => "Distance (km)",
// "List Wiki Pages" => "List Wiki Pages",
// "Page aliases found" => "Page aliases found",
// "Create a Wiki Page" => "Create a Wiki Page",
// "Insert name of the page you wish to create" => "Insert name of the page you wish to create",
// "Last modification" => "Last modification",
// "Page creator" => "Page creator",
// "Status of the page" => "Status of the page",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
// "Backl" => "Backl",
// "Page size" => "Page size",
// " {if \$find ne ''}and {/if}starting with" => " {if \$find ne ''}and {/if}starting with",
// "However, some page aliases fitting the query were found (see Aliases section above)" => "However, some page aliases fitting the query were found (see Aliases section above)",
// "offline" => "offline",
// "Live support:User window" => "Live support:User window",
// "Back to admin" => "Back to admin",
// "operator" => "operator",
// "For security purposes we must periodically validate your email address to allow continued access to this site" => "For security purposes we must periodically validate your email address to allow continued access to this site",
// "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site" => "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site",
// "Mail-in feature" => "Mail-in feature",
// "You do not have any mailin accounts set up" => "You do not have any mailin accounts set up",
// "Click here to go to mailin admin" => "Click here to go to mailin admin",
// "Change to" => "Change to",
// "Week containing" => "Week containing",
// "Month containing" => "Month containing",
// "Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/",
// "Edit Event" => "Edit Event",
// "Tiki Mods" => "Tiki Mods",
// "Mods Configuration" => "Mods Configuration",
// "Update remote index" => "Update remote index",
// "Rebuild local list" => "Rebuild local list",
// "Republish all" => "Republish all",
// "Publish all" => "Publish all",
// "Unpublish all" => "Unpublish all",
// "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>" => "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tiki.org\">mods.tiki.org</a>",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification",
// "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tiki.org/Mods\">dev.tiki.org</a> to find out more",
// "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)",
// "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")",
// "for version" => "for version",
// "All versions" => "All versions",
// "or later" => "or later",
// "No mods found" => "No mods found",
// "Display only this type" => "Display only this type",
// "Unpublish" => "Unpublish",
// "Republish" => "Republish",
// "licence" => "licence",
// "Tikiwiki Mods Configuration" => "Tikiwiki Mods Configuration",
// "Mods Install/uninstall" => "Mods Install/uninstall",
// "Enable Mods providing" => "Enable Mods providing",
// "Mods local directory" => "Mods local directory",
// "Mods remote server" => "Mods remote server",
// "Package Config" => "Package Config",
// "y" => "y",
// "To display the objects you created or contributed to" => "To display the objects you created or contributed to",
// "Sent Edition" => "Sent Edition",
// "Not sent" => "Not sent",
// "Removal of your email address failed" => "Removal of your email address failed",
// "Subscription failed" => "Subscription failed",
// "Object Watches" => "Object Watches",
// "Changes to groups watching this {\$objectType}" => "Changes to groups watching this {\$objectType}",
// "These changes to group watches" => "These changes to group watches",
// "were made to these descendants" => "were made to these descendants",
// "Groups watching this {\$objectType}" => "Groups watching this {\$objectType}",
// "This Category" => "This Category",
// "All Descendants" => "All Descendants",
// "Assign global permissions" => "Assign global permissions",
// "Currently editing Global permissions" => "Currently editing Global permissions",
// "This object's direct permissions override any global permissions or category permissions affecting this object" => "This object's direct permissions override any global permissions or category permissions affecting this object",
// "This category's direct permissions override any global permissions affecting objects in it" => "This category's direct permissions override any global permissions affecting objects in it",
// "To edit global permissions" => "To edit global permissions",
// "No permissions yet applied to this object but category permissions affect this object and are displayed below" => "No permissions yet applied to this object but category permissions affect this object and are displayed below",
// "To edit category permissions" => "To edit category permissions",
// "No direct permissions yet applied to this object. Global permissions apply" => "No direct permissions yet applied to this object. Global permissions apply",
// "Currently inherited permissions displayed" => "Currently inherited permissions displayed",
// "Assign permissions to this category" => "Assign permissions to this category",
// "Delete category permissions" => "Delete category permissions",
// "Delete object permissions" => "Delete object permissions",
// "Reset Perms" => "Reset Perms",
// "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions",
// "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions",
// "Permissions Clipboard" => "Permissions Clipboard",
// "Copy the permissions set here" => "Copy the permissions set here",
// "Paste" => "Paste",
// "Paste copied permissions from " => "Paste copied permissions from ",
// "Assign or remove permissions on <em>all</em> child categories" => "Assign or remove permissions on <em>all</em> child categories",
// "Are you sure you want to effect all child categories?\\nThere is no undo" => "Are you sure you want to effect all child categories?\\nThere is no undo",
// "Assign or remove permissions on all pages of the sub-structure" => "Assign or remove permissions on all pages of the sub-structure",
// "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo" => "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo",
// "You must select at least one feature" => "You must select at least one feature",
// "Previous version of assign permissions page can still be found" => "Previous version of assign permissions page can still be found",
// "View Differences" => "View Differences",
// "Permissions added" => "Permissions added",
// "Permissions removed" => "Permissions removed",
// "Select groups" => "Select groups",
// "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for",
// "These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab" => "These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab",
// "Select only groups that have a perm with the object" => "Select only groups that have a perm with the object",
// "Select all" => "Select all",
// "Select features" => "Select features",
// "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for",
// "Show permissions for disabled features" => "Show permissions for disabled features",
// "Feature name" => "Feature name",
// "Quick Permissions" => "Quick Permissions",
// "Assign Quick-Permissions to this object" => "Assign Quick-Permissions to this object",
// "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)" => "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)",
// "<em>Quick permissions</em> should be considered as an experimental feature" => "<em>Quick permissions</em> should be considered as an experimental feature",
// "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably" => "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably",
// "There is also no undo - <strong>Use with care!</strong>" => "There is also no undo - <strong>Use with care!</strong>",
// "Your OpenID identity is valid" => "Your OpenID identity is valid",
// "Your identity gives you access to multiple user accounts" => "Your identity gives you access to multiple user accounts",
// "Select account" => "Select account",
// "Contributions by author" => "Contributions by author",
// "Make Structure" => "Make Structure",
// "Contributions to" => "Contributions to",
// "current version" => "current version",
// "Words" => "Words",
// "Whitespaces" => "Whitespaces",
// "Characters" => "Characters",
// "Printable characters" => "Printable characters",
// "Deleted" => "Deleted",
// "Page changes" => "Page changes",
// "Original wiki text" => "Original wiki text",
// "Parsed Text (HTML)" => "Parsed Text (HTML)",
// "Output text only (No HTML tags)" => "Output text only (No HTML tags)",
// "Show statistics" => "Show statistics",
// "Visualize page changes" => "Visualize page changes",
// "Show popups" => "Show popups",
// "Escape HTML / Wiki syntax in page changes" => "Escape HTML / Wiki syntax in page changes",
// "Show contributions" => "Show contributions",
// "Show Edit Sessions" => "Show Edit Sessions",
// "Show All Versions" => "Show All Versions",
// "(current)" => "(current)",
// "s=source" => "s=source",
// "b=rollback" => "b=rollback",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "Update Translation" => "Update Translation",
// "Hide translation history" => "Hide translation history",
// "Show translation history" => "Show translation history",
// "Enable pagination" => "Enable pagination",
// "per page" => "per page",
// "Payment Date" => "Payment Date",
// "Payment Type" => "Payment Type",
// "Payer" => "Payer",
// "View payment info" => "View payment info",
// "Invoice" => "Invoice",
// "Assign permissions for payments" => "Assign permissions for payments",
// "Cancel this payment request" => "Cancel this payment request",
// "Request Date" => "Request Date",
// "View payment request" => "View payment request",
// "Paypal" => "Paypal",
// "Transaction ID" => "Transaction ID",
// "Payment made by <em>%0, %1</em> (%2)" => "Payment made by <em>%0, %1</em> (%2)",
// "{\$wp_member_title}" => "{\$wp_member_title}",
// "Paid amount" => "Paid amount",
// "Initial amount" => "Initial amount",
// "Amount remaining" => "Amount remaining",
// "Payment request was sent on %0 and is due by %1" => "Payment request was sent on %0 and is due by %1",
// "Pay with Paypal" => "Pay with Paypal",
// "Refresh page" => "Refresh page",
// "Payment info" => "Payment info",
// "Trade with Cclite" => "Trade with Cclite",
// "Payment problem" => "Payment problem",
// "Pay with Tiki User Credits" => "Pay with Tiki User Credits",
// "Credit type" => "Credit type",
// "Credits left" => "Credits left",
// "Amount to pay" => "Amount to pay",
// "Pay using" => "Pay using",
// "Manual payment entry" => "Manual payment entry",
// "Enter payment" => "Enter payment",
// "using" => "using",
// "Payment information" => "Payment information",
// "Outstanding" => "Outstanding",
// "Overdue" => "Overdue",
// "Past" => "Past",
// "Request" => "Request",
// "Detail" => "Detail",
// "Payable within" => "Payable within",
// "no avatar" => "no avatar",
// "icons" => "icons",
// "Show all" => "Show all",
// "Avatar Image" => "Avatar Image",
// "random" => "random",
// "File (only .gif, .jpg and .png images approximately 45px × 45px)" => "File (only .gif, .jpg and .png images approximately 45px × 45px)",
// "File (only .gif, .jpg and .png images)" => "File (only .gif, .jpg and .png images)",
// "Plugin execution was denied" => "Plugin execution was denied",
// "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected",
// "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible",
// "You are allowed to" => "You are allowed to",
// "View arguments" => "View arguments",
// "Execute the plugin in preview mode (may be dangerous)" => "Execute the plugin in preview mode (may be dangerous)",
// "Approve the plugin for public execution" => "Approve the plugin for public execution",
// "View Details" => "View Details",
// "This plugin does not contain any arguments" => "This plugin does not contain any arguments",
// "This plugin's body is empty" => "This plugin's body is empty",
// "Insert" => "Insert",
// "Plugin Approval" => "Plugin Approval",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "When you upgrade from an old version, you may need to reparse all the pages" => "When you upgrade from an old version, you may need to reparse all the pages",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "View Results" => "View Results",
// "Poll Results" => "Poll Results",
// "Top Voted Polls" => "Top Voted Polls",
// "Edit Poll" => "Edit Poll",
// "Find the poll" => "Find the poll",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Vote range displayed" => "Vote range displayed",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
// "List Votes" => "List Votes",
// "Popup preview" => "Popup preview",
// "Close preview" => "Close preview",
// "Topic image" => "Topic image",
// "You do not have permission to read complete articles" => "You do not have permission to read complete articles",
// "The original document is available at" => "The original document is available at",
// "Selected Structures" => "Selected Structures",
// "Add Structure" => "Add Structure",
// "No structures" => "No structures",
// "Available Pages" => "Available Pages",
// "No pages" => "No pages",
// "All pages selected" => "All pages selected",
// "Remove Page" => "Remove Page",
// "Selected Pages" => "Selected Pages",
// "No pages selected" => "No pages selected",
// "Add Pages from Structures" => "Add Pages from Structures",
// "Edit quiz" => "Edit quiz",
// "Current Version" => "Current Version",
// "General Options" => "General Options",
// "Publication Date" => "Publication Date",
// "at " => "at ",
// "Use " => "Use ",
// "randomly selected questions" => "randomly selected questions",
// "Test-time Options" => "Test-time Options",
// "Limit questions displayed per page to " => "Limit questions displayed per page to ",
// "&nbsp question(s)" => "&nbsp question(s)",
// "Impose a time limit of " => "Impose a time limit of ",
// "Allow students to store partial results and return to quiz" => "Allow students to store partial results and return to quiz",
// "Allow students to retake this quiz " => "Allow students to retake this quiz ",
// "Grading and Feedback" => "Grading and Feedback",
// "Grading method " => "Grading method ",
// "Show students their score " => "Show students their score ",
// "Show students the correct answers " => "Show students the correct answers ",
// "Publish statistics " => "Publish statistics ",
// "Extra Options" => "Extra Options",
// "Solicit additional questions from students" => "Solicit additional questions from students",
// "Link quiz to forum named: " => "Link quiz to forum named: ",
// "This Article is currently not published and only visible by Editors" => "This Article is currently not published and only visible by Editors",
// "List all articles of this same topic" => "List all articles of this same topic",
// "Prefix the checked" => "Prefix the checked",
// "Postfix the checked" => "Postfix the checked",
// "However, no account is associated to the OpenID identifier" => "However, no account is associated to the OpenID identifier",
// "If you use an email filter, be sure to add %0 to your accepted list" => "If you use an email filter, be sure to add %0 to your accepted list",
// "Associate OpenID with an existing Tikiwiki account" => "Associate OpenID with an existing Tikiwiki account",
// "Tiki site registered" => "Tiki site registered",
// "You don't have permission to use this feature" => "You don't have permission to use this feature",
// "Please register" => "Please register",
// "Register this site at Tiki.org" => "Register this site at Tiki.org",
// "Read this first" => "Read this first",
// "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites",
// "Registering is voluntary" => "Registering is voluntary",
// "Registering does not give you any benefits except one more link to your site" => "Registering does not give you any benefits except one more link to your site",
// "You don't get any emails, we don't sell the data about your site" => "You don't get any emails, we don't sell the data about your site",
// "Registering is just for us to get an overview of Tiki's usage" => "Registering is just for us to get an overview of Tiki's usage",
// "If your site is private or inside your intranet, you should not register" => "If your site is private or inside your intranet, you should not register",
// "tiki.org" => "tiki.org",
// "Information about your site" => "Information about your site",
// "Use this name anyway" => "Use this name anyway",
// "to version" => "to version",
// "This feature currently searches and replaces within wiki pages only" => "This feature currently searches and replaces within wiki pages only",
// "Max number of pages at a time" => "Max number of pages at a time",
// "Number of surrounding chars to preview" => "Number of surrounding chars to preview",
// "Replace selected" => "Replace selected",
// "Simple search" => "Simple search",
// "Advanced Search Help" => "Advanced Search Help",
// "Date Search" => "Date Search",
// "Calendar Items" => "Calendar Items",
// "{\$where|escape}" => "{\$where|escape}",
// "Reply to" => "Reply to",
// "Recipients" => "Recipients",
// "Validated" => "Validated",
// "Is user" => "Is user",
// "Sending Newsletter" => "Sending Newsletter",
// "Article Clip (read only)" => "Article Clip (read only)",
// "Clip Now" => "Clip Now",
// "Clip Articles" => "Clip Articles",
// "To include the article clipping into your newsletter, cut and paste it into the contents" => "To include the article clipping into your newsletter, cut and paste it into the contents",
// "If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending" => "If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending",
// "octets" => "octets",
// "Reply To Email" => "Reply To Email",
// "if not" => "if not",
// "Sender email not set" => "Sender email not set",
// "Save your changes" => "Save your changes",
// "Save any changes and send to all subscribers" => "Save any changes and send to all subscribers",
// "Send objects" => "Send objects",
// "Transmission results" => "Transmission results",
// "Send Wiki Pages" => "Send Wiki Pages",
// "Send a structure" => "Send a structure",
// "Add Article" => "Add Article",
// "Send objects to this site" => "Send objects to this site",
// "Ex: http://tiki.org or localhost" => "Ex: http://tiki.org or localhost",
// "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need",
// "Report this page" => "Report this page",
// "Page shared" => "Page shared",
// "The link was sent via e-Mail to the following addresses" => "The link was sent via e-Mail to the following addresses",
// "The link was sent via Twitter" => "The link was sent via Twitter",
// "The link was posted on your facebook wall" => "The link was posted on your facebook wall",
// "The link was sent as message to" => "The link was sent as message to",
// "The link was published in a" => "The link was published in a",
// "Short link" => "Short link",
// "Have a look at this page" => "Have a look at this page",
// "Your message" => "Your message",
// "I found an interesting page that I thought you would like" => "I found an interesting page that I thought you would like",
// "e-Mail" => "e-Mail",
// "Send via e-Mail" => "Send via e-Mail",
// "Recipient(s)" => "Recipient(s)",
// "Separate multiple email addresses with a comma" => "Separate multiple email addresses with a comma",
// "Your name" => "Your name",
// "Your email" => "Your email",
// "Tweet via Twitter" => "Tweet via Twitter",
// "Authorize with twitter first" => "Authorize with twitter first",
// "Have a look at " => "Have a look at ",
// "Put on my facebook wall" => "Put on my facebook wall",
// "Authorize with facebook first" => "Authorize with facebook first",
// "Link text" => "Link text",
// "This will be the title for the URL" => "This will be the title for the URL",
// "Like this post" => "Like this post",
// "You do not have the permission to send messages or you did not allow other users to send you messages" => "You do not have the permission to send messages or you did not allow other users to send you messages",
// "Separate multiple recipients with a comma" => "Separate multiple recipients with a comma",
// "Post on forum" => "Post on forum",
// "There is no forum where you can post a message" => "There is no forum where you can post a message",
// "password-protected" => "password-protected",
// "Share access rights" => "Share access rights",
// "Spreadsheets" => "Spreadsheets",
// "Available Sheets" => "Available Sheets",
// "Create a sheet" => "Create a sheet",
// "Configure this sheet" => "Configure this sheet",
// "There are individual permissions set for this sheet" => "There are individual permissions set for this sheet",
// "Class Name" => "Class Name",
// "Header Rows" => "Header Rows",
// "Footer Rows" => "Footer Rows",
// "Wiki Parse Values" => "Wiki Parse Values",
// "Join with Spreadsheet" => "Join with Spreadsheet",
// "Makes this sheet a \"child\" sheet of a multi-sheet set" => "Makes this sheet a \"child\" sheet of a multi-sheet set",
// "You can access the sheet using the following URL" => "You can access the sheet using the following URL",
// "Change shoutbox general settings" => "Change shoutbox general settings",
// "auto-link urls" => "auto-link urls",
// "Content may be out of date" => "Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages",
// "This text was automatically translated by Google Translate from the following page: " => "This text was automatically translated by Google Translate from the following page: ",
// "based on work by" => "based on work by",
// "Contributors to this page" => "Contributors to this page",
// "First Slide" => "First Slide",
// "Previous Slide" => "Previous Slide",
// "Previous Point" => "Previous Point",
// "Next Point" => "Next Point",
// "Next Slide" => "Next Slide",
// "Last Slide" => "Last Slide",
// "Jump To Slide" => "Jump To Slide",
// "Play" => "Play",
// "Pause" => "Pause",
// "Toggle Loop" => "Toggle Loop",
// "Exit" => "Exit",
// "Change Theme" => "Change Theme",
// "Accounts" => "Accounts",
// "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application" => "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application",
// "twitter authorisation" => "twitter authorisation",
// "to manage your authorisations at twitter" => "to manage your authorisations at twitter",
// "this site with twitter.com to use twitter integration of this site" => "this site with twitter.com to use twitter integration of this site",
// "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first" => "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" target=\"_blank\">http://developers.facebook.com/setup/</a> first",
// "facebook authorisation" => "facebook authorisation",
// "to manage your authorisations at facebook" => "to manage your authorisations at facebook",
// "this site with facebook.com to use twitter integration of this site" => "this site with facebook.com to use twitter integration of this site",
// "The site admin has set up a global account which will be used for this site" => "The site admin has set up a global account which will be used for this site",
// "Save changes" => "Save changes",
// "Most viewed objects" => "Most viewed objects",
// "Most viewed objects in the last 7 days" => "Most viewed objects in the last 7 days",
// "Date of first pageview" => "Date of first pageview",
// "Days since first pageview" => "Days since first pageview",
// "Total replies" => "Total replies",
// "Average number of replies per topic" => "Average number of replies per topic",
// "Average posts per weblog" => "Average posts per weblog",
// "FAQ Stats" => "FAQ Stats",
// "Most viewed objects in period" => "Most viewed objects in period",
// "Usage chart image" => "Usage chart image",
// "Daily Usage" => "Daily Usage",
// "Export through Action Log" => "Export through Action Log",
// "Thank you for your submission" => "Thank you for your submission",
// "Send a link to a friend" => "Send a link to a friend",
// "The link was sent to the following addresses" => "The link was sent to the following addresses",
// "Friend's email" => "Friend's email",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Log out" => "Use Current Session/Log out",
// "Recorded Links" => "Recorded Links",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "Delete this link" => "Delete this link",
// "TikiTests List" => "TikiTests List",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
// "Control by Objects" => "Control by Objects",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
// "Tracker Item History" => "Tracker Item History",
// "View Tracker Item" => "View Tracker Item",
// "Edit File" => "Edit File",
// "Advanced mode" => "Advanced mode",
// "Simple mode" => "Simple mode",
// "Retry" => "Retry",
// "The following files have been successfully uploaded" => "The following files have been successfully uploaded",
// "You can link to the file from a Wiki page using" => "You can link to the file from a Wiki page using",
// "You can display an image in a Wiki page using" => "You can display an image in a Wiki page using",
// "Or using as a thumbnail with ShadowBox" => "Or using as a thumbnail with ShadowBox",
// "You can link to the file from an HTML page using" => "You can link to the file from an HTML page using",
// "You locked the file" => "You locked the file",
// "The file is locked by {\$fileInfo.lockedby}" => "The file is locked by {\$fileInfo.lockedby}",
// "File title" => "File title",
// "required field for podcasts" => "required field for podcasts",
// "File description" => "File description",
// "Unzip zip files" => "Unzip zip files",
// "File can be deleted after" => "File can be deleted after",
// "Creator of file, if different from the 'Uploaded by' user" => "Creator of file, if different from the 'Uploaded by' user",
// "Maximum number of downloads" => "Maximum number of downloads",
// "Maximum file size is around" => "Maximum file size is around",
// " Syntax tips" => " Syntax tips",
// "Link to file from a Wiki page" => "Link to file from a Wiki page",
// "In addition, for image files" => "In addition, for image files",
// "To display in a Wiki page" => "To display in a Wiki page",
// "Display thumbnail that enlarges" => "Display thumbnail that enlarges",
// "Image ID thumb" => "Image ID thumb",
// "Folder in" => "Folder in",
// "a bookmark" => "a bookmark",
// "User Contacts Preferences" => "User Contacts Preferences",
// "Manage Fields" => "Manage Fields",
// "{if \$prefs.menus_item_names_raw eq 'n'}{\$chdata.name|escape}{else}{\$chdata.name}{/if}" => "{if \$prefs.menus_item_names_raw eq 'n'}{\$chdata.name|escape}{else}{\$chdata.name}{/if}",
// "Basic Data" => "Basic Data",
// "User Icon" => "User Icon",
// "This user is your friend " => "This user is your friend ",
// "Additional Information" => "Additional Information",
// "User Contribution" => "User Contribution",
// "has contributed to the following content" => "has contributed to the following content",
// "has not contributed to any content yet" => "has not contributed to any content yet",
// "Who Looks At Stuff" => "Who Looks At Stuff",
// "Who Looks At Your Stuff" => "Who Looks At Your Stuff",
// "Who Looks At His Stuff" => "Who Looks At His Stuff",
// "Send Me A Message" => "Send Me A Message",
// "Send me a message " => "Send me a message ",
// "The following message will be sent to user" => "The following message will be sent to user",
// "Message Body" => "Message Body",
// "Toggle" => "Toggle",
// "Toggle options" => "Toggle options",
// "User's personal tracker information" => "User's personal tracker information",
// "Preferred language" => "Preferred language",
// "Longitude" => "Longitude",
// "Latitude" => "Latitude",
// "Map zoom" => "Map zoom",
// "Account Deletion" => "Account Deletion",
// "Are you really sure you want to delete the account %0" => "Are you really sure you want to delete the account %0",
// "Check this box if you really want to delete the account" => "Check this box if you really want to delete the account",
// "Delete the account" => "Delete the account",
// "Delete my account" => "Delete my account",
// "User Watches and preferences" => "User Watches and preferences",
// "You need to set your email to receive email notifications" => "You need to set your email to receive email notifications",
// "Report Preferences" => "Report Preferences",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
// "Use reports to summarise notifications about objects you are watching" => "Use reports to summarise notifications about objects you are watching",
// "Use reports" => "Use reports",
// "Interval in which you want to get the reports" => "Interval in which you want to get the reports",
// "Short report" => "Short report",
// "Detailed report" => "Detailed report",
// "HTML-Email" => "HTML-Email",
// "Send me an email also if nothing happened" => "Send me an email also if nothing happened",
// "My watches" => "My watches",
// "Category change in a language" => "Category change in a language",
// "Reported Messages" => "Reported Messages",
// "Atts" => "Atts",
// "Save current spreadsheet" => "Save current spreadsheet",
// "Cancel editing current spreadsheet" => "Cancel editing current spreadsheet",
// "List Spreadsheets" => "List Spreadsheets",
// "Already being edited by" => "Already being edited by",
// "No parse" => "No parse",
// "What would you like to add" => "What would you like to add",
// "New spreadsheet" => "New spreadsheet",
// "Existing spreadsheet" => "Existing spreadsheet",
// "Tracker as a spreadsheet" => "Tracker as a spreadsheet",
// "Spreadsheet from file gallery" => "Spreadsheet from file gallery",
// "Items found" => "Items found",
// "atts" => "atts",
// "List Attachments" => "List Attachments",
// "Filter Tracker Items" => "Filter Tracker Items",
// "Move to another tracker" => "Move to another tracker",
// "Back to Items list" => "Back to Items list",
// "Back to Items List" => "Back to Items List",
// "Open Tiki WebDAV as WebFolder" => "Open Tiki WebDAV as WebFolder",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "This is the active account" => "This is the active account",
// "IMAP" => "IMAP",
// "Mbox" => "Mbox",
// "Maildir" => "Maildir",
// "POP3" => "POP3",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Incoming servers (used in this order)" => "Incoming servers (used in this order)",
// "IMAP server" => "IMAP server",
// "Mbox filepath" => "Mbox filepath",
// "Maildir mail directory" => "Maildir mail directory",
// "Use SSL" => "Use SSL",
// "Outgoing server" => "Outgoing server",
// "From email" => "From email",
// "Uses current in preferences if empty" => "Uses current in preferences if empty",
// "No email set" => "No email set",
// "Account details" => "Account details",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Auto refresh set for every \$autoRefresh seconds" => "Auto refresh set for every \$autoRefresh seconds",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
// "Clip" => "Clip",
// "Part" => "Part",
// "This is the staging copy of" => "This is the staging copy of",
// "the approved version of this page" => "the approved version of this page",
// "Viewing of changes since last approval is possible only after first approval" => "Viewing of changes since last approval is possible only after first approval",
// "Approve changes" => "Approve changes",
// "Latest changes will be synchronized after approval" => "Latest changes will be synchronized after approval",
// "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time" => "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time",
// "There is a staging page (not yet approved) for this page" => "There is a staging page (not yet approved) for this page",
// "View edit icons" => "View edit icons",
// "3d browser" => "3d browser",
// "Page is NOT being monitored. Click icon to START monitoring" => "Page is NOT being monitored. Click icon to START monitoring",
// "Page IS being monitored. Click icon to STOP monitoring" => "Page IS being monitored. Click icon to STOP monitoring",
// "Group Monitor on Structure" => "Group Monitor on Structure",
// "Following fields are incorrect" => "Following fields are incorrect",
// "Hold \"Ctrl\" in order to select multiple values" => "Hold \"Ctrl\" in order to select multiple values",
// "Remove Image" => "Remove Image",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Character Limit Exceeded" => "Character Limit Exceeded",
// "Character Count" => "Character Count",
// "Word Count" => "Word Count",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19",
// "You can use" => "You can use",
// "Number of votes" => "Number of votes",
// "Your rating" => "Your rating",
// "You did not vote yet" => "You did not vote yet",
// "My rating" => "My rating",
// "Click to vote for this value" => "Click to vote for this value",
// "Clik to delete your vote" => "Clik to delete your vote",
// "You have ever subscribed" => "You have ever subscribed",
// "You have not yet subscribed" => "You have not yet subscribed",
// "friends" => "friends",
// "Google Maps is not enabled" => "Google Maps is not enabled",
// "Freetags is not enabled" => "Freetags is not enabled",
// "The main text of this page is available in the following languages" => "The main text of this page is available in the following languages",
// "Human Translations" => "Human Translations",
// "Machine Translations" => "Machine Translations",
// "Use this thread to discuss the page" => "Use this thread to discuss the page",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
// "Current attendees" => "Current attendees",
// "No attendees at this time" => "No attendees at this time",
// "Last time we checked, the room you requested did not exist" => "Last time we checked, the room you requested did not exist",
// "list" => "list",
// "Toggle location map" => "Toggle location map",
// "Lon" => "Lon",
// "Lat" => "Lat",
// "Zoom" => "Zoom",
// "saving.." => "saving..",
// "Save current map view as user default" => "Save current map view as user default",
// "Save as user location" => "Save as user location",
// "Save as object location" => "Save as object location",
// "Email address the person you want to invite" => "Email address the person you want to invite",
// "Set in these groups" => "Set in these groups",
// "Email sent to" => "Email sent to",
// "Send to users" => "Send to users",
// "Send to" => "Send to",
// "Email separated by comma" => "Email separated by comma",
// "Send to groups" => "Send to groups",
// "Send Mail" => "Send Mail",
// "Check to remove" => "Check to remove",
// "Join myself" => "Join myself",
// "Leave myself" => "Leave myself",
// "Period" => "Period",
// "%0 year" => "%0 year",
// "%0 years" => "%0 years",
// "%0 days" => "%0 days",
// "Cost for one period" => "Cost for one period",
// "Membership to %0 for %1 year at %2&nbsp;%3" => "Membership to %0 for %1 year at %2&nbsp;%3",
// "Membership to %0 for %1 years at %2&nbsp;%3" => "Membership to %0 for %1 years at %2&nbsp;%3",
// "Membership to %0 for %1 days at %2&nbsp;%3" => "Membership to %0 for %1 days at %2&nbsp;%3",
// "separated by |" => "separated by |",
// "Number of periods" => "Number of periods",
// "Re-Apply" => "Re-Apply",
// "Undecided" => "Undecided",
// "Last Day" => "Last Day",
// "Last Week" => "Last Week",
// "Your default group" => "Your default group",
// "Change default group" => "Change default group",
// "Subscribe to a group" => "Subscribe to a group",
// "Subscribe to the newsletter" => "Subscribe to the newsletter",
// "Any" => "Any",
// "Please login first" => "Please login first",
// "Toggle display" => "Toggle display",
// "Creator &amp; Last Editor" => "Creator &amp; Last Editor",
// "Save the page as a partial translation" => "Save the page as a partial translation",
// "Partial Translation" => "Partial Translation",
// "Save the page as a completed translation" => "Save the page as a completed translation",
// "Complete Translation" => "Complete Translation",
// "Save the page, but do not count it as new content to be translated" => "Save the page, but do not count it as new content to be translated",
// "%0 enabled" => "%0 enabled",
// "%0 disabled" => "%0 disabled",
// "%0 set" => "%0 set",
// "%0 unset" => "%0 unset",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "Current version is up to date : <b>%0</b>" => "Current version is up to date : <b>%0</b>",
// "A new %0 major release branch is available" => "A new %0 major release branch is available",
// "Wiki Attachments" => "Wiki Attachments",
// "Article/CMS settings" => "Article/CMS settings",
// "Configuration options for all blogs on your site" => "Configuration options for all blogs on your site",
// "FAQ comments settings" => "FAQ comments settings",
// "Trackers settings" => "Trackers settings",
// "Feeds settings" => "Feeds settings",
// "Directory settings" => "Directory settings",
// "Maps configuration" => "Maps configuration",
// "Meta Tags settings" => "Meta Tags settings",
// "Search settings" => "Search settings",
// "Score settings" => "Score settings",
// "Community settings" => "Community settings",
// "Calendar settings" => "Calendar settings",
// "Intertiki settings" => "Intertiki settings",
// "Freetags settings" => "Freetags settings",
// "Configure Site Ads and Banners" => "Configure Site Ads and Banners",
// "Settings for video streaming integration" => "Settings for video streaming integration",
// "Help on \$admintitle Config" => "Help on \$admintitle Config",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "silver" => "silver",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Multiple IP Banning" => "Multiple IP Banning",
// "Access from your localization was forbidden due to excessive spamming" => "Access from your localization was forbidden due to excessive spamming",
// "Delete comments then set banning rules" => "Delete comments then set banning rules",
// "Are you sure you want to unassign the objects of this category: " => "Are you sure you want to unassign the objects of this category: ",
// "Click here to delete the category" => "Click here to delete the category",
// "You can not create a category with a name already existing at this level" => "You can not create a category with a name already existing at this level",
// "The file does not have the required header" => "The file does not have the required header",
// "Category can`t be parent of itself" => "Category can`t be parent of itself",
// "No display" => "No display",
// "You have to provide a hotword and a URL" => "You have to provide a hotword and a URL",
// "You must specify a directory" => "You must specify a directory",
// "moved %d images, %d errors occured" => "moved %d images, %d errors occured",
// "a timeout occured. Hit the reload button to move the rest" => "a timeout occured. Hit the reload button to move the rest",
// "Detected, Version" => "Detected, Version",
// "Test Image" => "Test Image",
// "Not detected" => "Not detected",
// "Tiki Email Test" => "Tiki Email Test",
// "Tiki Test email from" => "Tiki Test email from",
// "Unable to send mail" => "Unable to send mail",
// "Test mail sent to" => "Test mail sent to",
// "%d user-group assignments" => "%d user-group assignments",
// "All Fields except gdaltindex must be filled" => "All Fields except gdaltindex must be filled",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
// "No valid gdaltindex executable" => "No valid gdaltindex executable",
// "New configuration created (id %0)" => "New configuration created (id %0)",
// "Configuration updated" => "Configuration updated",
// "Repository name can't be an empty" => "Repository name can't be an empty",
// "Requested action is not supported on repository" => "Requested action is not supported on repository",
// "No repository" => "No repository",
// "Search is mandatory field" => "Search is mandatory field",
// "File not found " => "File not found ",
// "Requested action in not supported on repository" => "Requested action in not supported on repository",
// "Mail-in account %s incorrect" => "Mail-in account %s incorrect",
// "Mail-in account %s saved" => "Mail-in account %s saved",
// "Frequency should be a positive integer" => "Frequency should be a positive integer",
// "Mail-in accounts set to be checked every %s minutes" => "Mail-in accounts set to be checked every %s minutes",
// "Automatic Mail-in accounts checking disabled" => "Automatic Mail-in accounts checking disabled",
// "Are you sure you want to modify this menu" => "Are you sure you want to modify this menu",
// "Are you sure you want to create a new menu" => "Are you sure you want to create a new menu",
// "metric_remove must be a numeric value" => "metric_remove must be a numeric value",
// "tab_remove must be a numeric value" => "tab_remove must be a numeric value",
// "assign_remove must be a numeric value" => "assign_remove must be a numeric value",
// "metric_edit must be a numeric value" => "metric_edit must be a numeric value",
// "tab_edit must be a numeric value" => "tab_edit must be a numeric value",
// "Memcache is disabled for metrics" => "Memcache is disabled for metrics",
// "tab_clearcache must be a numeric value" => "tab_clearcache must be a numeric value",
// "assign_metric must be a numeric value" => "assign_metric must be a numeric value",
// "assign_metric_edit must be a numeric value" => "assign_metric_edit must be a numeric value",
// "Assign: Invalid metric value" => "Assign: Invalid metric value",
// "Assign: Invalid tab value" => "Assign: Invalid tab value",
// "Cannot create or update metric: You need to specify a name for the metric" => "Cannot create or update metric: You need to specify a name for the metric",
// "Cannot create or update metric: Metric name must be under \" . \$prefs['metrics_metric_name_length'] . \" characters in length" => "Cannot create or update metric: Metric name must be under \" . \$prefs['metrics_metric_name_length'] . \" characters in length",
// "Cannot create or update metric: You need to specify a range for the metric" => "Cannot create or update metric: You need to specify a range for the metric",
// "Cannot create or update metric: You need to specify a data type for the metric" => "Cannot create or update metric: You need to specify a data type for the metric",
// "Cannot create or update metric: You need to specify a query for the metric" => "Cannot create or update metric: You need to specify a query for the metric",
// "Cannot create or update tab: You need to specify a name for the tab" => "Cannot create or update tab: You need to specify a name for the tab",
// "Cannot create or update tab: Tab name must be under \" . \$prefs['metrics_tab_name_length'] . \" characters in length" => "Cannot create or update tab: Tab name must be under \" . \$prefs['metrics_tab_name_length'] . \" characters in length",
// "Cannot create or update tab: You need to specify an integer range for the tab order" => "Cannot create or update tab: You need to specify an integer range for the tab order",
// "Cannot create or update tab: Tab content cannot be empty" => "Cannot create or update tab: Tab content cannot be empty",
// "Cannot create or update module: You need to specify a name to the module" => "Cannot create or update module: You need to specify a name to the module",
// "Cannot create or update module: You cannot leave the data field empty" => "Cannot create or update module: You cannot leave the data field empty",
// "Newsletter does not exist" => "Newsletter does not exist",
// "Error importing from wiki page: " => "Error importing from wiki page: ",
// "Error opening uploaded file" => "Error opening uploaded file",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "unsafe" => "unsafe",
// "register_globals should be off by default. See the php manual for details" => "register_globals should be off by default. See the php manual for details",
// "safe" => "safe",
// "risky" => "risky",
// "off" => "off",
// "session.use_trans_sid should be off by default. See the php manual for details" => "session.use_trans_sid should be off by default. See the php manual for details",
// "upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser",
// "cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config" => "cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config",
// "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them",
// "allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off" => "allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off",
// "The Path to store files in the filegallery should be outside the tiki root directory" => "The Path to store files in the filegallery should be outside the tiki root directory",
// "The Path to store files in the imagegallery should be outside the tiki root directory" => "The Path to store files in the imagegallery should be outside the tiki root directory",
// "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code" => "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Path disclosure" => "Path disclosure",
// "Path disclosure through error message" => "Path disclosure through error message",
// "SQL injection" => "SQL injection",
// "SQL injection by authenticated user" => "SQL injection by authenticated user",
// "SQL injection by authenticated user with special privileges" => "SQL injection by authenticated user with special privileges",
// "SQL injection without authentication" => "SQL injection without authentication",
// "PHP command injection" => "PHP command injection",
// "PHP command injection by authenticated user" => "PHP command injection by authenticated user",
// "PHP command injection by authenticated user with special privileges" => "PHP command injection by authenticated user with special privileges",
// "PHP command injection without authentication" => "PHP command injection without authentication",
// "File upload" => "File upload",
// "File is not readable. Unable to check" => "File is not readable. Unable to check",
// "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous" => "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous",
// "This is a modified File. Cannot check version. Check if it is dangerous" => "This is a modified File. Cannot check version. Check if it is dangerous",
// "This file is from another Tikiwiki version: " => "This file is from another Tikiwiki version: ",
// "You have to provide a word" => "You have to provide a word",
// "You must specify a page name, it will be created if it doesn't exist" => "You must specify a page name, it will be created if it doesn't exist",
// "Global" => "Global",
// "Are you sure you want to delete all your custom tools" => "Are you sure you want to delete all your custom tools",
// "Are you sure you want to delete this custom tool" => "Are you sure you want to delete this custom tool",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Are you sure you want to remove this topic AND all the articles related" => "Are you sure you want to remove this topic AND all the articles related",
// "Tracker does not allow attachments" => "Tracker does not allow attachments",
// "Are you sure you want to create a new group" => "Are you sure you want to create a new group",
// "Are you sure you want to add this user?" => "Are you sure you want to add this user?",
// "Remove group: " => "Remove group: ",
// "Group name can not be empty" => "Group name can not be empty",
// "Are you sure you want to add this new user" => "Are you sure you want to add this new user",
// "Are you sure you want to delete this user" => "Are you sure you want to delete this user",
// "Are you sure you want to remove this user from this group" => "Are you sure you want to remove this user from this group",
// "Are you sure you want to reset email due for this user" => "Are you sure you want to reset email due for this user",
// "Are you sure you want to delete these users" => "Are you sure you want to delete these users",
// "Are you sure you want to add this user to these groups" => "Are you sure you want to add this user to these groups",
// "Are you sure you want to remove this user from these groups" => "Are you sure you want to remove this user from these groups",
// "Are you sure you want to set the default groups for these users" => "Are you sure you want to set the default groups for these users",
// "Are you sure you want to send a wiki page as an email to these users" => "Are you sure you want to send a wiki page as an email to these users",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
// "Invalid or unknown email" => "Invalid or unknown email",
// "Could not create user" => "Could not create user",
// "User login or email is required" => "User login or email is required",
// "User does not exist on master" => "User does not exist on master",
// "Created account %s <%s>" => "Created account %s <%s>",
// "Assigned %s in group %s" => "Assigned %s in group %s",
// "Email validation requested but email address not set" => "Email validation requested but email address not set",
// "Password not set" => "Password not set",
// "User %s already exists" => "User %s already exists",
// "User login contains invalid characters" => "User login contains invalid characters",
// "New %s created with %s %s" => "New %s created with %s %s",
// "Impossible to create new %s with %s %s" => "Impossible to create new %s with %s %s",
// "%s %s successfully deleted" => "%s %s successfully deleted",
// "Deleted account %s" => "Deleted account %s",
// "%s %s removed from %s %s" => "%s %s removed from %s %s",
// "%s %s assigned to %s %s" => "%s %s assigned to %s %s",
// "group %s set as the default group of user %s" => "group %s set as the default group of user %s",
// "Are you sure you want to modify this user's data" => "Are you sure you want to modify this user's data",
// "Login contains invalid characters" => "Login contains invalid characters",
// "%s changed from %s to %s" => "%s changed from %s to %s",
// "Impossible to change %s from %s to %s" => "Impossible to change %s from %s to %s",
// "Please go back and try again" => "Please go back and try again",
// "approved by " => "approved by ",
// "This function is only for staging pages" => "This function is only for staging pages",
// "You do not have permission to approve staging pages" => "You do not have permission to approve staging pages",
// "Staging page cannot be found" => "Staging page cannot be found",
// "Approved page was last saved after most recent staging edit" => "Approved page was last saved after most recent staging edit",
// "Failed to add attribute" => "Failed to add attribute",
// "rss feed disabled" => "rss feed disabled",
// "Unassign perm %s from group %s" => "Unassign perm %s from group %s",
// "You have to indicate a group" => "You have to indicate a group",
// "This group is invalid" => "This group is invalid",
// "Image Galleries Admin Panel" => "Image Galleries Admin Panel",
// "Could not read image %s" => "Could not read image %s",
// "Image %s upload failed" => "Image %s upload failed",
// "Image %s uploaded successfully" => "Image %s uploaded successfully",
// "Image %s removed from Batch directory" => "Image %s removed from Batch directory",
// "Impossible to remove image %s from Batch directory" => "Impossible to remove image %s from Batch directory",
// "Incorrect directory chosen for batch upload of images" => "Incorrect directory chosen for batch upload of images",
// "Please setup that dir on " => "Please setup that dir on ",
// "Please contact the website administrator" => "Please contact the website administrator",
// "Invalid directory name" => "Invalid directory name",
// "File Galleries Admin Panel" => "File Galleries Admin Panel",
// "Could not read file %s" => "Could not read file %s",
// "Could not write to file %s" => "Could not write to file %s",
// "File %s upload failed" => "File %s upload failed",
// "Upload was successful" => "Upload was successful",
// "File %s removed from Batch directory" => "File %s removed from Batch directory",
// "Impossible to remove file %s from Batch directory" => "Impossible to remove file %s from Batch directory",
// "Incorrect directory chosen for batch upload of files" => "Incorrect directory chosen for batch upload of files",
// "No blogId specified" => "No blogId specified",
// "Stop watching this category" => "Stop watching this category",
// "Watch this category" => "Watch this category",
// "Nothing tagged yet" => "Nothing tagged yet",
// "You must clear your browser cache" => "You must clear your browser cache",
// "There\\'s no such date as" => "There\\'s no such date as",
// "Calendar event : " => "Calendar event : ",
// "You do not have permission to view this page" => "You do not have permission to view this page",
// "Invalid username or activation code. Maybe this code has already been used" => "Invalid username or activation code. Maybe this code has already been used",
// "Your email could not be validated; make sure you email is correct" => "Your email could not be validated; make sure you email is correct",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "Problem. Try to log in again to receive new confirmation instructions" => "Problem. Try to log in again to receive new confirmation instructions",
// "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field" => "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field",
// "TikiHelp WebHelp generation engine. Generating WebHelp using" => "TikiHelp WebHelp generation engine. Generating WebHelp using",
// "Eliminating previous files" => "Eliminating previous files",
// "Index: <strong>\$name</strong>" => "Index: <strong>\$name</strong>",
// "Directory: <strong>\$dir</strong>" => "Directory: <strong>\$dir</strong>",
// "You need to change chmod 'whelp' manually to 777" => "You need to change chmod 'whelp' manually to 777",
// "Creating directory structure in <strong>\$base</strong>" => "Creating directory structure in <strong>\$base</strong>",
// "Must enter a name to add a site. " => "Must enter a name to add a site. ",
// "Must enter a url to add a site. " => "Must enter a url to add a site. ",
// "URL already added to the directory. Duplicate site? " => "URL already added to the directory. Duplicate site? ",
// "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. ",
// "Must select a category. " => "Must select a category. ",
// "URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory",
// "No parent specified" => "No parent specified",
// "Last sites of directory \" . \$rc[\"name\"] . \" " => "Last sites of directory \" . \$rc[\"name\"] . \" ",
// "Discount code already exists" => "Discount code already exists",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Error : The file %s doesn't exist" => "Error : The file %s doesn't exist",
// "The language can't be changed as its set of translations has already this language" => "The language can't be changed as its set of translations has already this language",
// "Wrote %d new strings and updated %d to lang/%s/language.php" => "Wrote %d new strings and updated %d to lang/%s/language.php",
// "Imported" => "Imported",
// "Edit Perspectives" => "Edit Perspectives",
// "Invalid structure_id or page_ref_id" => "Invalid structure_id or page_ref_id",
// "No topic id specified" => "No topic id specified",
// "Invalid topic id specified" => "Invalid topic id specified",
// "No object indicated" => "No object indicated",
// "Page is a staging copy. Translation must begin from the approved copy" => "Page is a staging copy. Translation must begin from the approved copy",
// "No type indicated" => "No type indicated",
// "Override lock and carry on with edit" => "Override lock and carry on with edit",
// "Page is currently being edited" => "Page is currently being edited",
// "This page is being edited by " => "This page is being edited by ",
// "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. " => "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. ",
// "Can't import remote HTML page" => "Can't import remote HTML page",
// "Page already exists. Go back and choose a different name" => "Page already exists. Go back and choose a different name",
// "Page name is" => "Page name is",
// "The translation set already contains a page in this language" => "The translation set already contains a page in this language",
// "Can not open the file" => "Can not open the file",
// "Problem zip initialisation" => "Problem zip initialisation",
// "Problem zip" => "Problem zip",
// "Another user is currently exporting that tracker, please try again later" => "Another user is currently exporting that tracker, please try again later",
// "No questions group indicated" => "No questions group indicated",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
// "Top visited file galleries" => "Top visited file galleries",
// "Most downloaded files" => "Most downloaded files",
// "Last files" => "Last files",
// "No galleryId specified" => "No galleryId specified",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
// "Last replied forum topics" => "Last replied forum topics",
// "No forumId specified" => "No forumId specified",
// "Not supported yet" => "Not supported yet",
// "Accepted friendship request from %s" => "Accepted friendship request from %s",
// "Refused friendship request from %s" => "Refused friendship request from %s",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
// "Broke friendship with %s" => "Broke friendship with %s",
// "I have broken our friendship" => "I have broken our friendship",
// "Friendship request sent to %s" => "Friendship request sent to %s",
// "You're already friend of %s" => "You're already friend of %s",
// "I have accepted your friendship request" => "I have accepted your friendship request",
// "I have refused your friendship request" => "I have refused your friendship request",
// "I have canceled my friendship request" => "I have canceled my friendship request",
// "first uploaded image" => "first uploaded image",
// "last uploaded image" => "last uploaded image",
// "random image" => "random image",
// "You do not have permission to make the map of this gallery" => "You do not have permission to make the map of this gallery",
// "Top images" => "Top images",
// "Last images" => "Last images",
// "Back to item" => "Back to item",
// "No valid renderer found. GD or PDFLib required" => "No valid renderer found. GD or PDFLib required",
// "No sheet specified" => "No sheet specified",
// "You must select a renderer" => "You must select a renderer",
// "Invalid Series for current graphic" => "Invalid Series for current graphic",
// "updated from structured text import" => "updated from structured text import",
// "created from structured text import" => "created from structured text import",
// "Operations executed successfully" => "Operations executed successfully",
// "Invalid software name" => "Invalid software name",
// "There is more than one item in the tracker with this title" => "There is more than one item in the tracker with this title",
// "There are no items in the tracker with this title" => "There are no items in the tracker with this title",
// "You have requested that this page be machine translated" => "You have requested that this page be machine translated",
// "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it",
// "No repository given" => "No repository given",
// "This invitation does not exist or is deprecated" => "This invitation does not exist or is deprecated",
// "Congratulations! You are now part of this invitation group(s)" => "Congratulations! You are now part of this invitation group(s)",
// "Kaltura Upload" => "Kaltura Upload",
// "Communication error" => "Communication error",
// "Invalid response provided by the Kaltura server. Please retry" => "Invalid response provided by the Kaltura server. Please retry",
// "Are you sure you want to permanently remove article id %0" => "Are you sure you want to permanently remove article id %0",
// "Are you sure you want to permanently remove %0 articles" => "Are you sure you want to permanently remove %0 articles",
// "You do not have permission to view the comments for this blog" => "You do not have permission to view the comments for this blog",
// "Delete comments" => "Delete comments",
// "Approved Status" => "Approved Status",
// "Queued" => "Queued",
// "This blog has no posts" => "This blog has no posts",
// "The file is already locked by %s" => "The file is already locked by %s",
// "WARNING: The file is used in" => "WARNING: The file is used in",
// "Remove file: " => "Remove file: ",
// "Quota too big" => "Quota too big",
// "Quota too small" => "Quota too small",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload your file" => "Please re-upload your file",
// "Could not upload the file" => "Could not upload the file",
// "Could not find the file requested" => "Could not find the file requested",
// "Cannot read the file" => "Cannot read the file",
// "Upload was not successful. Duplicate file content" => "Upload was not successful. Duplicate file content",
// "File update was successful" => "File update was successful",
// "Not modified since" => "Not modified since",
// "Not downloaded since" => "Not downloaded since",
// "This gallery does not exist" => "This gallery does not exist",
// "Error importing" => "Error importing",
// "Error converting" => "Error converting",
// "Importing" => "Importing",
// "Processing" => "Processing",
// "Ready" => "Ready",
// "Pending moderation" => "Pending moderation",
// "Blocked" => "Blocked",
// "Invalid action" => "Invalid action",
// "Are you sure you want to permanently remove submited article id %0" => "Are you sure you want to permanently remove submited article id %0",
// "Are you sure you want to permanently remove %0 submited articles" => "Are you sure you want to permanently remove %0 submited articles",
// "Are you sure you want to approve %0 submited articles" => "Are you sure you want to approve %0 submited articles",
// "Are you sure you want to remove the %0 selected pages" => "Are you sure you want to remove the %0 selected pages",
// "Are you sure you want to print the %0 selected pages" => "Are you sure you want to print the %0 selected pages",
// "Are you sure you want to unlock the %0 selected pages" => "Are you sure you want to unlock the %0 selected pages",
// "Are you sure you want to lock the %0 selected pages" => "Are you sure you want to lock the %0 selected pages",
// "Are you sure you want to download a zip of the %0 selected pages" => "Are you sure you want to download a zip of the %0 selected pages",
// "You have to enable cookies to be able to login to this site" => "You have to enable cookies to be able to login to this site",
// "Username field cannot be empty. Please go back and try again" => "Username field cannot be empty. Please go back and try again",
// "Unable to contact remote server" => "Unable to contact remote server",
// "XMLRPC Error: " => "XMLRPC Error: ",
// "Unable to create login" => "Unable to create login",
// "More than %d unsuccessful login attempts have been made" => "More than %d unsuccessful login attempts have been made",
// "An email has been sent to you with the instructions to follow" => "An email has been sent to you with the instructions to follow",
// "Resend" => "Resend",
// "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email",
// "Your default nickname is already in use. A new one has to be selected" => "Your default nickname is already in use. A new one has to be selected",
// "Verification cancelled" => "Verification cancelled",
// "The selected account is not associated with your identity" => "The selected account is not associated with your identity",
// "unknown action" => "unknown action",
// "Authentication method is not OpenID" => "Authentication method is not OpenID",
// "Authentication error; probably not a valid OpenID" => "Authentication error; probably not a valid OpenID",
// "Could not redirect to server: " => "Could not redirect to server: ",
// "OpenID authentication failed: " => "OpenID authentication failed: ",
// "You must use the right case for your user name" => "You must use the right case for your user name",
// "Sorry, you can't use this feature" => "Sorry, you can't use this feature",
// "You must first setup MapServer" => "You must first setup MapServer",
// "invalid mapfile name" => "invalid mapfile name",
// "An error as occured with the mapfile" => "An error as occured with the mapfile",
// "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files" => "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files",
// "Maps feature is not correctly setup : Maps path is missing" => "Maps feature is not correctly setup : Maps path is missing",
// "mapfile name incorrect" => "mapfile name incorrect",
// "This mapfile already exists" => "This mapfile already exists",
// "You do not have permission to write to the mapfile" => "You do not have permission to write to the mapfile",
// "You do not have permission to delete the mapfile" => "You do not have permission to delete the mapfile",
// "I could not make a copy" => "I could not make a copy",
// "You do not have permission to read the mapfile" => "You do not have permission to read the mapfile",
// "map edit" => "map edit",
// "You dont have permission to do that" => "You dont have permission to do that",
// "Tiki RSS feed for maps" => "Tiki RSS feed for maps",
// "List of maps available" => "List of maps available",
// "The Directory is not empty" => "The Directory is not empty",
// "Invalid file name" => "Invalid file name",
// "Invalid files to index" => "Invalid files to index",
// "I do not know where is gdaltindex. Set correctly the Map feature" => "I do not know where is gdaltindex. Set correctly the Map feature",
// "I could not create the index file" => "I could not create the index file",
// " to " => " to ",
// "No page provided" => "No page provided",
// "Welcome at Hawiki" => "Welcome at Hawiki",
// "This Tiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more" => "This Tiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more",
// "You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site" => "You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site",
// "tiki-mobile.php" => "tiki-mobile.php",
// "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody",
// "Your PHP installation does not have zlib enabled" => "Your PHP installation does not have zlib enabled",
// "Note not found" => "Note not found",
// "Object Permissions" => "Object Permissions",
// "Are you sure you want to remove the direct permissions from this object" => "Are you sure you want to remove the direct permissions from this object",
// "You do not have permission to assign permissions for this object" => "You do not have permission to assign permissions for this object",
// "Manual payment entered" => "Manual payment entered",
// "You do not have permission to enter payment" => "You do not have permission to enter payment",
// "New payment requested" => "New payment requested",
// "Cancel payment %0" => "Cancel payment %0",
// "Payment canceled" => "Payment canceled",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (' . \$code . " => "Index (' . \$code . ",
// "Pageviews" => "Pageviews",
// "You are already logged in" => "You are already logged in",
// "This is not a valid mail adress" => "This is not a valid mail adress",
// "Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Please enter a valid %s.  No spaces, more than %d characters and contain %s",
// "Missing User Name" => "Missing User Name",
// "User Already Exists" => "User Already Exists",
// "Valid User Name" => "Valid User Name",
// "Missing Email" => "Missing Email",
// "Valid Email" => "Valid Email",
// "Unable to send mail. User has not configured email" => "Unable to send mail. User has not configured email",
// "Please provide a username or email" => "Please provide a username or email",
// "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password",
// "The mail can't be sent. Contact the administrator" => "The mail can't be sent. Contact the administrator",
// "An email with a link to reset your password has been sent " => "An email with a link to reset your password has been sent ",
// "You cannot rename staging pages. Please rename the approved page instead" => "You cannot rename staging pages. Please rename the approved page instead",
// "Cannot rename page because the new name begins with reserved prefix" => "Cannot rename page because the new name begins with reserved prefix",
// "Cannot rename page because maybe new staging page name already exists" => "Cannot rename page because maybe new staging page name already exists",
// "Tiki RSS Feed Error Message: \$errmsg" => "Tiki RSS Feed Error Message: \$errmsg",
// "This match was not case sensitive" => "This match was not case sensitive",
// "No items selected" => "No items selected",
// "Page cannot be found: " => "Page cannot be found: ",
// "Page has changed since preview: " => "Page has changed since preview: ",
// "Page not updated due to error in replacing: " => "Page not updated due to error in replacing: ",
// "Page updated: " => "Page updated: ",
// "A problem occured during file uploading" => "A problem occured during file uploading",
// "File which was causing trouble was at rank" => "File which was causing trouble was at rank",
// "The error was" => "The error was",
// "Error: You can\\'t send the same newsletter by refreshing this frame content" => "Error: You can\\'t send the same newsletter by refreshing this frame content",
// "Newsletter successfully sent to %s users" => "Newsletter successfully sent to %s users",
// "There was %s errors" => "There was %s errors",
// "No newsletters available" => "No newsletters available",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
// "Notice: invalid variable value" => "Notice: invalid variable value",
// "Report to the webmaster" => "Report to the webmaster",
// "Your link was sent" => "Your link was sent",
// "Your email is mandatory" => "Your email is mandatory",
// "Permission to post in forum denied" => "Permission to post in forum denied",
// "No text given for tweet" => "No text given for tweet",
// "Error sending tweet" => "Error sending tweet",
// "Error sending mail to" => "Error sending mail to",
// "Spreadsheet - " => "Spreadsheet - ",
// "Are you sure you want to delete this spreadsheet" => "Are you sure you want to delete this spreadsheet",
// "You do not have permission to edit messages \$owner" => "You do not have permission to edit messages \$owner",
// "Permission denied. You cannot view this page" => "Permission denied. You cannot view this page",
// "Send a link to a friend " => "Send a link to a friend ",
// "No trackerId specified" => "No trackerId specified",
// "You must lock the file before editing it" => "You must lock the file before editing it",
// "Batch file processed" => "Batch file processed",
// "Cannot resize the file" => "Cannot resize the file",
// "Cannot write the file" => "Cannot write the file",
// "Image was reduced: %s x %s -> %s x %s" => "Image was reduced: %s x %s -> %s x %s",
// "Check that these paths exist and are writable by the web server" => "Check that these paths exist and are writable by the web server",
// "Incorrect file extension" => "Incorrect file extension",
// "The uploaded file ist not recognized as a image" => "The uploaded file ist not recognized as a image",
// "That is not an image (or you have php < 4.0.5)" => "That is not an image (or you have php < 4.0.5)",
// "Usage" => "Usage",
// "Invalid password. Your current password is required to change administrative information" => "Invalid password. Your current password is required to change administrative information",
// "Email is set to %s" => "Email is set to %s",
// "If you really want to delete you're account, you must check the checkbox" => "If you really want to delete you're account, you must check the checkbox",
// "unicode" => "unicode",
// "This script can only be called by the server" => "This script can only be called by the server",
// "Rights by creator" => "Rights by creator",
// "Percentage" => "Percentage",
// "Task entries" => "Task entries",
// "Remove the notification email" => "Remove the notification email",
// "Language watch" => "Language watch",
// "Category watch: %0, Language: %1" => "Category watch: %0, Language: %1",
// "Post not found" => "Post not found",
// "You do not have permission to view this blog post while it is marked as private" => "You do not have permission to view this blog post while it is marked as private",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
// "You are not permitted to remove someone else\\'s post" => "You are not permitted to remove someone else\\'s post",
// "Incorrect thread" => "Incorrect thread",
// "Spreadsheet truncated" => "Spreadsheet truncated",
// "Files are read only at this time" => "Files are read only at this time",
// "Are you sure you want to clone this spreadsheet" => "Are you sure you want to clone this spreadsheet",
// "Clone Error" => "Clone Error",
// "Are you sure you want to rollback this spreadsheet" => "Are you sure you want to rollback this spreadsheet",
// "Rollback Error" => "Rollback Error",
// "Create tracker item" => "Create tracker item",
// "You don't have a personal tracker item yet. Click here to make one" => "You don't have a personal tracker item yet. Click here to make one",
// "That tracker don't use extras" => "That tracker don't use extras",
// "Tiki WebDAV access" => "Tiki WebDAV access",
// "There was a problem connecting to that account" => "There was a problem connecting to that account",
// "There was a problem deleting that mail" => "There was a problem deleting that mail",
// "Mail ID" => "Mail ID",
// "There was a problem while trying to delete these mails" => "There was a problem while trying to delete these mails",
// "There was a problem while trying to delete that mail" => "There was a problem while trying to delete that mail",
// "Are you sure you want to delete this account" => "Are you sure you want to delete this account",
// "Taking" => "Taking",
// "Putting back" => "Putting back",
// "Checking" => "Checking",
// "Plugin modified by editor" => "Plugin modified by editor",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "You are about to delete a TikiTest file, do you want to continue " => "You are about to delete a TikiTest file, do you want to continue ",
// "Error deleting the file" => "Error deleting the file",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// "You do not have permissions to view the maps" => "You do not have permissions to view the maps",
// ### end of untranslated words
// ###

// ###
// ### start of possibly untranslated words
// ###

"Re:" => "Re:",
"MySQL classic (mysql)" => "MySQL classic (mysql)",
"Wiki" => "Wiki",
"WikiDiff::_check: failed" => "WikiDiff::_check: failed",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: edit sequence is non-optimal",
"WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
"Id" => "Id",
"CAS (Central Authentication Service)" => "CAS (Central Authentication Service)",
"3" => "3",
"utf-8" => "utf-8",
"iso-8859-1" => "iso-8859-1",
"1" => "1",
"2" => "2",
"4" => "4",
"5" => "5",
"Mail-in" => "Mail-in",
"Banning system" => "Banning system",
"MultiPrint" => "MultiPrint",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
"_HOMEPAGE_CONTENT_" => "_HOMEPAGE_CONTENT_",
"You are banned from" => "You are banned from",
"wiki" => "wiki",
"user selector" => "user selector",
"url" => "url",
"(AT)" => "(AT)",
"(DOT)" => "(DOT)",
"Cookie" => "Cookie",
"SQL" => "SQL",
"reported:" => "reported:",
"queued:" => "queued:",
"RSS Wiki" => "RSS Wiki",
"Tiki mail-in instructions" => "Tiki mail-in instructions",
"item" => "item",
"`\$module_params.prefix`" => "`\$module_params.prefix`",
"Wiki RSS" => "Wiki RSS",
"RSS feed" => "RSS feed",
"Cookies" => "Cookies",
"DSN" => "DSN",
"x" => "x",
"CMS" => "CMS",
"cookie" => "cookie",
"wiki-get" => "wiki-get",
"wiki-put" => "wiki-put",
"wiki-append" => "wiki-append",
"Valid" => "Valid",
"PDF" => "PDF",
"LongDesc" => "LongDesc",
"timestamp" => "timestamp",
"UTF-8" => "UTF-8",
"ISO-8859-1" => "ISO-8859-1",
"RSS" => "RSS",
"popup" => "popup",
"Click to select visible calendars" => "Click to select visible calendars",
"+" => "+",
"Organized by" => "Organized by",
"Children type" => "Children type",
"Float text around image" => "Float text around image",
"col" => "col",
"canRepeat" => "canRepeat",
"timeLimit" => "timeLimit",
"maxScore" => "maxScore",
"Edit queued message" => "Edit queued message",
"exclaim" => "exclaim",
"wink" => "wink",
"No messages queued yet" => "No messages queued yet",
"Reported by" => "Reported by",
"LastChanges" => "LastChanges",
"\$type" => "\$type",
"Xml Zip" => "Xml Zip",
"#" => "#",
"Summary" => "Summary",
"Emot" => "Emot",
"%H:%M %Z" => "%H:%M %Z",
"id" => "id",
"No name indicated for wiki page" => "No name indicated for wiki page",
"merged note:" => "merged note:",
// ###
// ### end of possibly untranslated words
// ###

"This forum is flat and doesn't allow replies to other replies" => "Этот форум является плоским и не позволяет ответы на ответы",
"This script cannot be called directly" => "Этот сценарий не может быть вызван напрямую",
"Copyright management" => "Управление авторскими правами",
"No page indicated" => "Страница не указана",
"You must supply all the information, including title and year." => "Вы должны указать всю информацию, включая название и год.",
"You do not have permission to use this feature" => "У Вас недостаточно прав для использования этой возможности",
"This feature is for admins only" => "Эта возможность зарезервирована для администраторов",
"ID" => "Id",
"Type" => "Вид",
"Name" => "Имя",
"Description" => "Описание",
"Size" => "Размер",
"Created" => "Создано",
"Uploaded" => "Загружено",
"Last Modified" => "Последние Изменения",
"Creator" => "Создатель",
"Comment" => "Комментарий",
"Files" => "Файлы",
"Hits" => "Запросы",
"Locked by" => "заблокировано",
"Backlinks" => "Ссылки на данную страницу",
"Explorer" => "Проводник",
"Path" => "Путь",
"Slideshow" => "Слайд-шоу",
"Default View" => "Стандартный вид",
"Register" => "Регистрация",
"Afghanistan" => "Афганистан",
"Aland Islands" => "Аландские острова",
"Albania" => "Албания",
"Algeria" => "Алгерия",
"American Samoa" => "Американский Самоа",
"Andorra" => "Андорра",
"Angola" => "Ангола",
"Anguilla" => "Ангилья",
"Antigua" => "Антигуа",
"Argentina" => "Аргентина",
"Armenia" => "Армения",
"Aruba" => "Аруба",
"Australia" => "Австралия",
"Austria" => "Австрия",
"Azerbaijan" => "Азербайджан",
"Bahamas" => "Багамские острова",
"Bahrain" => "Бахрейн",
"Bangladesh" => "Бангладеш",
"Barbados" => "Барбадос",
"Belarus" => "Беларусь",
"Belgium" => "Бельгия",
"Belize" => "Белиз",
"Benin" => "Бенин",
"Bermuda" => "Бермудские острова",
"Bhutan" => "Бутан",
"Bolivia" => "Боливия",
"Bosnia and Herzegovina" => "Босния и Герцеговина",
"Botswana" => "Ботсвана",
"Bouvet Island" => "Остров Буве",
"Brazil" => "Бразилия",
"British Indian Ocean Territory" => "Британская территория в Индийском океане",
"British Virgin Islands" => "Британские Виргинские острова",
"Brunei" => "Бруней",
"Bulgaria" => "Болгария",
"Burkina Faso" => "Буркина-Фасо",
"Burundi" => "Бурунди",
"Cambodia" => "Камбодже",
"Cameroon" => "Камерун",
"Canada" => "Канада",
"Cape Verde" => "Кабо-Верде",
"Catalan Countries" => "Каталански Страны",
"Cayman Islands" => "Каймановы острова",
"Central African Republic" => "Центрально-Африканская Республика",
"Chad" => "Чад",
"Chile" => "Чили",
"China" => "Китай",
"Christmas Island" => "Остров Рождества",
"Cocos Islands" => "Кокосовые острова",
"Colombia" => "Колумбия",
"Comoros" => "Коморские острова",
"Congo Democratic" => "Конго Демократическая",
"Congo" => "Конго",
"Cook Islands" => "Острова Кука",
"Costa Rica" => "Коста-Рика",
"Croatia" => "Хорватию",
"Cuba" => "Куба",
"Cyprus" => "Кипр",
"Czech Republic" => "Чехия",
"Denmark" => "Дания",
"Djibouti" => "Джибути",
"Dominica" => "Доминик",
"Dominican Republic" => "Доминиканская Республика",
"Ecuador" => "Эквадор",
"Egypt" => "Египет",
"El Salvador" => "Сальвадор",
"Equatorial Guinea" => "Экваториальная Гвинея",
"Eritrea" => "Эритрея",
"Estonia" => "Эстония",
"Ethiopia" => "Эфиопия",
"Europe" => "Европа",
"Falkland Islands" => "Фолклендские острова",
"Faroe Islands" => "Фарерские острова",
"Federated States of Micronesia" => "Федеративные Штаты Микронезии",
"Fiji" => "Фиджи",
"Finland" => "Финляндия",
"France" => "Франция",
"French Guiana" => "Французская Гвиана",
"French Polynesia" => "Французская Полинезия",
"French Southern Territories" => "Французские Южные территории",
"Gabon" => "Габон",
"Gambia" => "Гамбия",
"Georgia" => "Грузия",
"Germany" => "Германия",
"Ghana" => "Гана",
"Gibraltar" => "Гибралтар",
"Greece" => "Греция",
"Greenland" => "Гренландия",
"Grenada" => "Гренада",
"Guadeloupe" => "Гваделупе",
"Guam" => "Гуам",
"Guatemala" => "Гватемале",
"Guernsey" => "Гернси",
"Guinea Bissau" => "Гвинея-Бисау",
"Guinea" => "Гвинея",
"Guyana" => "Гайана",
"Haiti" => "Гаити",
"Heard Island and McDonald Islands" => "Острова Херд и Макдональд",
"Honduras" => "Гондурас",
"Hong Kong" => "Гонконг",
"Hungary" => "Венгрия",
"Iceland" => "Исландия",
"India" => "Индия",
"Indonesia" => "Индонезия",
"Iran" => "Иран",
"Iraq" => "Ирак",
"Ireland" => "Ирландия",
"Isle of Man" => "Остров Мэн",
"Israel" => "Израиль",
"Italy" => "Италия",
"Ivory Coast" => "Берег Слоновой Кости",
"Jamaica" => "Ямайка",
"Japan" => "Япония",
"Jersey" => "Джерси",
"Jordan" => "Иордания",
"Kazakstan" => "Казахстан",
"Kenya" => "Кения",
"Kiribati" => "Кирибати",
"Kuwait" => "Кувейт",
"Kyrgyzstan" => "Кыргызстан",
"Laos" => "Лаос",
"Latvia" => "Латвия",
"Lebanon" => "Ливан",
"Lesotho" => "Лесото",
"Liberia" => "Либерия",
"Libya" => "Ливия",
"Liechtenstein" => "Лихтенштейн",
"Lithuania" => "Литва",
"Luxemburg" => "Люксембург",
"Macao" => "Макао",
"Macedonia" => "Македония",
"Madagascar" => "Мадагаскар",
"Malawi" => "Малави",
"Malaysia" => "Малайзия",
"Maldives" => "Мальдивы",
"Mali" => "Мали",
"Malta" => "Мальта",
"Marshall Islands" => "Маршалловы острова",
"Martinique" => "Мартиника",
"Mauritania" => "Мавритания",
"Mauritius" => "Маврикий",
"Mayotte" => "Майотта",
"Mexico" => "Мексика",
"Moldova" => "Молдова",
"Monaco" => "Монако",
"Mongolia" => "Монголия",
"Montenegro" => "Черногория",
"Montserrat" => "Монтсеррат",
"Morocco" => "Марокко",
"Mozambique" => "Мозамбик",
"Myanmar" => "Мьянма",
"Namibia" => "Намибия",
"Nauru" => "Науру",
"Nepal" => "Непал",
"Netherlands Antilles" => "Нидерландские Антильские острова",
"Netherlands" => "Нидерланды",
"New Caledonia" => "Новая Каледония",
"New Zealand" => "Новая Зеландия",
"Nicaragua" => "Никарагуа",
"Niger" => "Нигер",
"Nigeria" => "Нигерия",
"Niue" => "Ниуэ",
"None" => "Ничего",
"Norfolk Island" => "Норфолк",
"North Korea" => "Северная Корея",
"Northern Mariana Islands" => "Северные Марианские острова",
"Norway" => "Норвегия",
"Oman" => "Оман",
"Other" => "Другие",
"Pakistan" => "Пакистан",
"Palau" => "Палау",
"Palestine" => "Палестина",
"Panama" => "Панама",
"Papua New Guinea" => "Папуа-Новая Гвинея",
"Paraguay" => "Парагвай",
"Peru" => "Перу",
"Philippines" => "Филиппины",
"Pitcairn" => "Питкэрн",
"Poland" => "Польша",
"Portugal" => "Португалия",
"Puerto Rico" => "Пуэрто-Рико",
"Quatar" => "Катар",
"Republic of Macedonia" => "Республика Македония",
"Reunion" => "Воссоединение",
"Romania" => "Румыния",
"Russia" => "Россия",
"Rwanda" => "Руанда",
"Saint Helena" => "Святая Елена",
"Saint Kitts and Nevis" => "Сент-Китс и Невис",
"Saint Lucia" => "Сент-Люсии",
"Saint Pierre and Miquelon" => "Сен-Пьер и Микелон",
"Samoa" => "Самоа",
"San Marino" => "Сан-Марино",
"Sao Tome and Principe" => "Сан-Томе и Принсипи",
"Saudi Arabia" => "Саудовская Аравия",
"Senegal" => "Сенегал",
"Serbia" => "Сербия",
"Seychelles" => "Сейшельские острова",
"Sierra Leone" => "Сьерра-Леоне",
"Singapore" => "Сингапур",
"Slovakia" => "Словакия",
"Slovenia" => "Словения",
"Solomon Islands" => "Соломоновы острова",
"Somalia" => "Сомали",
"South Africa" => "Южная Африка",
"South Georgia and South Sandwich Islands" => "Южная Георгия и Южные Сандвичевы острова",
"South Korea" => "Южная Корея",
"Spain" => "Испания",
"Sri Lanka" => "Шри-Ланка",
"St Vincent Grenadines" => "Сент-Винсент Гренадин",
"Sudan" => "Судан",
"Surinam" => "Суринам",
"Svalbard and Jan Mayen" => "Шпицберген и Ян-Майен",
"Swaziland" => "Свазиленд",
"Sweden" => "Швеция",
"Switzerland" => "Швейцария",
"Syria" => "Сирия",
"Taiwan" => "Тайвань",
"Tajikistan" => "Таджикистан",
"Tanzania" => "Танзания",
"Thailand" => "Таиланд",
"Timor-Leste" => "Восточный Тимор",
"Togo" => "Того",
"Tokelau" => "Токелау",
"Tonga" => "Тонга",
"Trinidad Tobago" => "Тринидад Тобаго",
"Tunisia" => "Тунис",
"Turkey" => "Турция",
"Turkmenistan" => "Туркменистан",
"Turks and Caicos Islands" => "Острова Теркс и Кайкос",
"Tuvalu" => "Тувалу",
"US Virgin Islands" => "Американские Виргинские острова",
"Uganda" => "Уганда",
"Ukraine" => "Украина",
"United Arab Emirates" => "Объединенные Арабские Эмираты",
"United Kingdom" => "Великобритания",
"United Nations Organization" => "Организация Объединенных Наций",
"United States Minor Outlying Islands" => "Внешние малые острова",
"United States" => "США",
"Uruguay" => "Уругвай",
"Uzbekistan" => "Узбекистан",
"Vanuatu" => "Вануату/Фиджи",
"Vatican" => "Ватикан",
"Venezuela" => "Венесуэла",
"Viet Nam" => "Вьетнам",
"Wales" => "Уэльс",
"Wallis and Futuna" => "Уоллис и Футуна",
"Western Sahara" => "Западная Сахара",
"World" => "Мир",
"Yemen" => "Йемен",
"Yugoslavia" => "Югославия",
"Zambia" => "Замбия",
"Zimbabwe" => "Зимбабве",
"Email address not valid, test mail not sent" => "Эл.адрес не корректный, тестовое письмо не отправлено",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "Эл.адрес не задан и флаг \"копировать\" не установлен, тестовое письмо не отправлено",
"Test mail from Tiki installer " => "Тестовое письмо инсталляции Tiki",
"Congratulations!\n\nYour server can send emails.\n\n" => "Поздравляем!\n\nВаш сервер умеет рассылать письма.\n\n",
"Arabic" => "Арабский",
"Catalan" => "Каталонский",
"Simplified Chinese" => "Упрощенный китайский",
"Czech" => "Чешский",
"Danish" => "Датский",
"German" => "Немецкий",
"English" => "Английский",
"English British" => "Английский британский",
"Spanish" => "Испанский",
"Greek" => "Греческий",
"Farsi" => "Персидский",
"Finnish" => "Финский",
"Fijian" => "Фиджи",
"French" => "французский",
"Galician" => "Галицкий",
"Hebrew" => "Иврит",
"Croatian" => "Хорватский",
"Italian" => "Итальянский",
"Japanese" => "Японский",
"Korean" => "Корейский",
"Hungarian" => "Венгерский",
"Dutch" => "Голландский",
"Norwegian" => "Норвежский",
"Polish" => "Польский",
"Português" => "Португальский",
"Brazilian Portuguese" => "Бразильский португальский",
"Russian" => "Русский",
"Slovak" => "Словацкий",
"Serbian Latin" => "Сербский латиница",
"Swedish" => "Шведский",
"Tuvaluan" => "Тувалу",
"Traditional Chinese" => "Традиционный китайский",
"Ukrainian" => "Украинский",
"Permission denied" => "Доступ запрещён",
"Template %s not registered" => "Шаблон %s не зарегистрирован",
"The file is not a CSV file or has not a correct syntax" => "Файл не является CSV файлом или имеет неправильный синтаксис",
"Error line: %d" => "Ошибка в строке: %d",
"locked" => "закрыто",
"locked by" => "заблокировано",
"All day" => "Полный день",
"Sunday" => "Воскресенье",
"Monday" => "Понедельник",
"Tuesday" => "Вторник",
"Wednesday" => "Среда",
"Thursday" => "Четверг",
"Friday" => "Пятница",
"Saturday" => "Суббота",
"in" => "в",
"continued" => "продолжено",
"New Image Uploaded by" => "новое изображение закачано",
"New Subscriptions" => "новые подписки",
"New Item in Tracker" => "новый объект в трекере",
"tracker" => "трекер",
"by" => "автор",
"Image Gallery" => "Фотогалерея",
"Articles" => "Статьи",
"Blogs" => "Блоги",
"Forums" => "Форумы",
"Directory" => "Каталог ссылок",
"File Gallery" => "Файловая Галерея",
"FAQs" => "ЧаВо",
"Quizzes" => "Тесты",
"Trackers" => "Трекеры",
"Survey" => "Анкета",
"Newsletter" => "Рассылка",
"Help" => "Помощь",
"article" => "статья",
"blog" => "блог",
"directory" => "каталог",
"faq" => "чаво",
"file gallery" => "файловая галерея",
"forum" => "форум",
"image gallery" => "галерея изображений",
"newsletter" => "новости",
"poll" => "опрос",
"quiz" => "тест",
"survey" => "опрос",
"wiki page" => "wiki страница",
"image" => "изображение",
"calendar" => "календарь",
"Invalid filename (using filters for filenames)" => "Недействительное имя файла (с использованием фильтров для файлов)",
"Cannot upload this file - maximum upload size exceeded" => "Невозможно закачать файл, превышен допустимый размер",
"(not registered)" => "(не зарегистрирован)",
"Anonymous" => "Аноним",
"Please wait %d seconds between posts" => "Подождите %d секунд между сообщениями",
"Wrong password. Cannot post comment" => "Неверный пароль. Невозможно отправить комментарий",
"A contribution is mandatory" => "Вклад является обязательным",
"You have to enter a title and text" => "Необходимо ввести заголовок и текст",
"Invalid Email" => "Не корректный эл.адрес",
"This forum is locked" => "Этот форум заблокирован",
"This thread is locked" => "Эта нить заблокирована",
"Those comments are locked" => "Эти замечания заблокированы",
"Create page:" => "Создать страницу:",
"Set" => "Записать",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: количество строк различно: %s != %s",
"File Galleries" => "Файловые галереи",
"This is the value of your server's PHP '%s' setting" => "Это значение переменной '%s' в PHP на сервере",
"You are alerted by the server " => "Изменения на сервере: ",
"You can check the modifications at : " => "Вы можете проверить изменения: ",
"You are alerted of a change on " => "Кое что изменилось: ",
"Wiki Home" => "Начальная страница Wiki",
"Home" => "Начало",
"Blog" => "Блог",
"previous page" => "страница назад",
"next page" => "страница вперёд",
"posted on" => "размещено",
"Continue" => "Продолжить",
"By:" => "Кем:",
"Read" => "Читать",
"List articles" => "Список статей",
"Last post" => "Последнее сообщение",
"Invalid imagename (using filters for filenames)" => "Неверное имя изображения (используются фильтры для имен файлов)",
"Errors detected" => "Обнаружены ошибки",
"Upload was not successful" => "Закачка не прошла",
"No image yet, sorry." => "Изображений пока нет, извините.",
"unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "неизвестный каталог назначения. Проверьте настройки <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
"unlink failed" => "Не удалось удалить",
"Contributions" => "Взносы",
"This feature is disabled" => "Эта возможность заблокирована",
"menu" => "меню",
"NONE" => "НЕТ",
"for" => "для",
"File %s not found" => "Файл %s не найден",
"File %s is not a valid archive" => "Файл %s не является корректным архивом",
"Impossible to open %s : %s" => "Невозможно открыть %s : %s",
"Can't chdir to '%s'" => "Не могу перейти в '%s'",
"%s impossible to remove" => "%s невозможно удалить",
"Language" => "Язык",
"Section" => "Секция",
"Theme" => "Тема",
"Rows" => "Строки",
"Newsletter subscription information at" => "Информация о подписке на новости",
"OK" => "да",
"Error" => "Ошибка",
"invalid email" => "неверный эл.адрес",
"Ajax auto-save" => "Автосохранение Ajax",
"Newest first" => "Новые вперед",
"ascending" => "по возрастанию",
"descending" => "по убыванию",
"Topic" => "Тема",
"Title" => "Заголовок",
"User" => "Пользователь",
"Author" => "Автор",
"Reads" => "Прочтений",
"Images" => "Изображения",
"Top" => "Начало",
"Oldest first" => "Старые вперед",
"Points" => "Очки",
"Default number per page" => "Количество на странице",
"Default Ordering" => "Сортировка по умолчанию",
"Authentication method" => "Метод аутентификации",
"Tiki and PAM" => "Tiki и PAM",
"Web Server" => "Web Сервер",
"Port" => "Порт",
"All" => "Все",
"Available languages" => "Доступные языки",
"Available styles" => "Доступные стили",
"Default ordering" => "Сортировка",
"Creation Date (desc)" => "Дата создания (по убыванию)",
"Last modification date (desc)" => "Дата изменения (убывание)",
"Blog title (asc)" => "Заголовок блога (возрастание)",
"Number of posts (desc)" => "Число сообщений (убывание)",
"Visits (desc)" => "Посещения (по убыванию)",
"Activity (desc)" => "Активность (убывание)",
"Creation date" => "Дата создания",
"Last modified" => "Последние изменения",
"Disabled" => "Отключено",
"Plain text" => "Обыкновенный текст",
"Link to user information" => "Информация о пользователе",
"User avatar" => "Аватара пользователя",
"Posts" => "Сообщений",
"Visits" => "Посещений",
"Activity" => "Активность",
"Default view mode" => "Ркжим просмотра по умолчанию",
"Day" => "День",
"Week" => "Неделя",
"Month" => "Месяц",
"Quarter" => "Квартал",
"Semester" => "Семестр",
"Year" => "Год",
"First day of the week" => "Первый день недели",
"Depends user language" => "В зависимости от языка пользователя",
"1 minute" => "1 минута",
"5 minutes" => "5 минут",
"10 minutes" => "10 минут",
"15 minutes" => "15 минут",
"30 minutes" => "30 минут",
"none" => "нет",
"Never" => "Никогда",
"1 hour" => "1 час",
"Contact user" => "Связаться с пользователем",
"Count admin pageviews" => "Считать просмотры страниц админом",
"Default charset for sending mail" => "Кодировка по умолчанию для отправки эл.писем",
"Only with last version" => "Только с последней версией",
"rows" => "строки",
"Forum" => "Форум",
"Simple" => "Простой",
"Advanced" => "Продвинутый",
"Use direct pagination links" => "Использовать прямые ссылки на страницы",
"Show Country Flag" => "Показывать флаг страны",
"Validate URLs" => "Проверять URL",
"Links per page" => "Ссылок на странице",
"Method to open directory links" => "Способ открытия ссылок",
"replace current window" => "в текущем окне",
"new window" => "в новом окне",
"inline frame" => "во вложенном фрейме",
"Fields display order" => "Показывать в порядке",
"days" => "дней",
"No error reporting" => "Не выводить отчет об ошибках",
"Report all PHP errors" => "Выводить полный отчет об ошибках PHP",
"Default number of comments per page" => "Комментариев на странице",
"Comments default ordering" => "Сортировка комментариев",
"Q and A" => "Я и А",
"Question ID" => "ID вопроса",
"Polls" => "Опросы",
"Newsletters" => "Рассылки",
"Calendar" => "Календарь",
"Banners" => "Баннеры",
"Category" => "Категория",
"Score" => "Рейтинг",
"Freetags" => "Метки",
"Action Log" => "Протоколирование",
"Multilingual" => "Многоязычность",
"FAQ" => "ЧаВо",
"Surveys" => "Анкетирование",
"Featured links" => "Рекомендуемые ссылки",
"Copyright" => "Авторское право",
"Shoutbox" => "Кричалка",
"Maps" => "Карты",
"Live support system" => "Система быстрой поддержки",
"Tell a Friend" => "Расскажи другу",
"HTML pages" => "Страницы HTML",
"Contact Us" => "Связаться с нами",
"Minichat" => "Мини Чат",
"Comments Moderation" => "Модерация комментариев",
"Comments Locking" => "Блокировка комментариев",
"Webmail" => "Вебпочта",
"Wysiwyg editor" => "Визуальный (wysiwyg) редактор",
"Friendship Network" => "Дружеская сеть",
"Stats" => "Статистика",
"Referer Stats" => "Статистика по Referer",
"Redirect On Error" => "Перенаправление в случае ошибки",
"Communications (send/receive objects)" => "Связь (отправить/принять объекты)",
"Custom Home" => "Своя Домашняя Страница",
"Mini Calendar" => "Мини-календарь",
"User Preferences Screen" => "Страница настройки пользователя",
"User Notepad" => "Блокнот",
"User Bookmarks" => "Личные закладки",
"User Contacts" => "Контакты пользователя",
"User Watches" => "Наблюдения пользователя",
"Group Watches" => "Наблюдения группы",
"User Menu" => "Ваше меню",
"User Tasks" => "Задачи",
"User Messages" => "Сообщения пользователя",
"User Files" => "Ваши файлы",
"Group Alert" => "Групповое оповещение",
"Integrator" => "Интегратор",
"XMLRPC API" => "Доступ к системе через XMLRPC",
"Debugger Console" => "Консоль ошибок",
"TikiTests" => "Tiki Тесты",
"Check for updates automatically" => "Проверять наличие обновлений автоматически",
"Detect browser language" => "Определять язык браузера",
"Smileys" => "Смайлики",
"Dynamic Content System" => "Система управления динамическим содержимым",
"Display menus as folders" => "Отображать меню как папки",
"Activate" => "Активировать",
"Anonymous voting" => "Разрешить голосовать анонимно",
"Allow re-voting" => "Разрешить голосовать повторно",
"Submissions" => "Поступления",
"Rankings" => "Рейтинги",
"Content Templates" => "Шаблоны содержимого",
"Print" => "Печать",
"List pages" => "Список страниц",
"Last changes" => "Последние изменения",
"Orphan pages" => "Страницы-сироты",
"Search stats" => "Поиск по статистике",
"Batch uploading" => "Пакетная загрузка",
"Accept wiki syntax" => "Принять синтаксис wiki",
"tikihash (old)" => "tikihash (устаревшее)",
"Edit CSS" => "Редактировать CSS",
"Theme Control" => "Управление темами",
"Edit Templates" => "Правка шаблонов",
"Left column" => "Левая колонка",
"Page name" => "Название страницы",
"Use page description" => "Использовать описание страницы",
"Bottom bar" => "Нижняя полоса",
"Email this page" => "Отправить страницу почтой",
"Content templates" => "Шаблоны содержимого",
"Undo" => "Откат",
"Footnotes" => "Примечания",
"Allow HTML" => "Позволять HTML",
"Sandbox" => "Песочница",
"Pictures" => "Изображения",
"Export" => "Экспорт",
"History" => "История",
"Discuss pages on forums" => "Обсудить страницы на форуме",
"View source" => "Просмотр источника",
"Rating" => "Рейтинг",
"Structures" => "Структуры",
"Import HTML" => "Импорт HTML",
"Import pages" => "Импорт страниц",
"Attachments" => "Вложения",
"Dumps" => "Дампы",
"Use challenge/response authentication" => "Использовать авторизацию вопрос/ответ",
"Automonospaced text" => "Автомоноширинный текст",
"Tables syntax" => "Синтаксис таблиц",
"|| for rows" => "|| для строк",
"<return> for rows" => "\n для строк",
"Hotwords" => "Горячие слова",
"Real name" => "Настоящее имя",
"Gender" => "Пол",
"Number of friends" => "Кол-во друзей",
"Country" => "Страна",
"E-mail" => "Эл.адрес",
"Last login" => "Последний Вход",
"Distance" => "Расстояние",
"Manual selection of time/date" => "Выбор даты/времени вручную",
"Display 'MyTiki' in the application menu" => "Отображать меню 'Мой Tiki'",
"Show user's information on mouseover" => "Показывать информацию о пользователе при наведении указателя мышки",
"Requires user's information to be public" => "Требует публичности пользовательской информации",
"seconds" => "с.",
"Image galleries" => "Фотогалереи",
"File galleries" => "Файловые галереи",
"Podcast directory" => "Подкаст каталог",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "Если вы используете пакетную заугрузку, вам необходимо настроить доступный для чтения каталог (лучше если он будет вне сайта). И обеспечить возможность загрузки  файлов в этот каталог через scp, ftp, или любой другой протокол.",
"Prevent download if score becomes negative" => "Запрет на скачивание при отрицательной оценке",
"Allow download limit per file" => "Разрешить ограничения на загрузку файлов",
"Allow same file to be uploaded more than once" => "Разрешить загружать один и тот же файл несколько раз",
"Yes, even in the same gallery" => "Да, даже в той же галерее",
"Only in different galleries" => "Только в разных галереях",
"Mb" => "Мб",
"Store in database" => "Хранить в базе данных",
"Store in directory" => "Хранить в папке на диске",
"Uploaded filenames must match regex" => "Имена файлов должны совпадать с regex",
"Default style" => "Стиль по умолчанию",
"Plain" => "Плоский",
"Threaded" => "Нитевидный",
"Headers Only" => "Только заголовки",
"Default sort mode" => "Режим сортировки по умолчанию",
"Title (desc)" => "Название (по убыванию)",
"Title (asc)" => "Название (по возрастанию)",
"Topics" => "Темы",
"Posts per day" => "Сообщений в день",
"Creation Date (asc)" => "По дате создания (asc)",
"Topics (desc)" => "Число тем (по убыванию)",
"Threads (desc)" => "Число веток (по убыванию)",
"Last post (desc)" => "Последнее сообщение (по убыванию)",
"Name (desc)" => "Имя (по убыванию)",
"Name (asc)" => "Имя (по возрастанию)",
"Browser title" => "Заголовок браузера",
"Home page" => "Домашняя страница",
"Use group homepages" => "Домашняя страница для группы",
"Go to group homepage only if login from default homepage" => "Переход на страницу для группы только с главной домашней страницы",
"Default language" => "Язык по умолчанию",
"Temporary directory" => "Временная папка",
"Open external links in new window" => "Открывать внешние ссылки в новом окне",
"License page" => "Страница с лицензией",
"Submit notice" => "Отправить уведомление",
"Display modules to all groups always" => "Всегда показывать модули всем группам",
"Test" => "Тест",
"Default" => "По умолчанию",
"Maximum number of records in listings" => "Показывать записей в списках не более",
"Users can register" => "Можно регистрироваться",
"Remember me" => "Запомнить меня",
"Duration" => "Длительность",
"minutes" => "минут",
"hour" => "час",
"hours" => "часов",
"day" => "день",
"week" => "нед.",
"month" => "месяц",
"year" => "год",
"Custom home" => "Своя домашняя страница",
"Home Blog (main blog)" => "Начальный блог (основной)",
"Home Forum (main forum)" => "Главный Форум",
"Home Gallery (main gallery)" => "Начальная галерея (главная)",
"HTTP port" => "Порт веб сервера",
"HTTPS port" => "Порт HTTPS сервера",
"Allow secure (https) login" => "Позволять безопасный (https) вход",
"Encourage secure (https) login" => "Разрешить защищенный (https) вход",
"Consider we are always in HTTPS, but do not check" => "Считать соединение всегда защищенным (HTTPS), но не проверять",
"Require secure (https) login" => "Требовать безопасный (https) вход",
"Normal" => "Обычный",
"Up" => "Выше",
"Down" => "Ниже",
"Use database for translation" => "Использовать базу данных для перевода",
"Layout per section" => "Расположение по секции",
"Log SQL" => "Протокол SQL",
"Long date format" => "Длинный формат даты",
"Long time format" => "Длинный формат времени",
"CRLF (standard)" => "CRLF (стандарт)",
"LF (some Unix MTA)" => "LF (Unix системы)",
"Email address" => "Адрес эл.почты",
"Wiki page" => "Страница Wiki",
"Show categories" => "Показывать категории",
"Show objects" => "Показывать объекты",
"Record untranslated strings" => "Запись не переведена",
"Refresh rate" => "Частота обновления",
"Entire site" => "Весь сайт",
"Wiki Pages" => "Wiki страницы",
"Sender email" => "Эл.адрес отправителя",
"Database" => "База данных",
"Default group" => "Группа по умолчанию",
"Short date format" => "Короткий формат даты",
"Short time format" => "Короткий формат времени",
"After" => "После",
"Before" => "До",
"Publish" => "Публиковать",
"Center" => "По центру",
"Modified" => "Модифицировано",
"Check frequency" => "Проверять",
"Each day" => "Ежедневно",
"Each week" => "Еженедельно",
"Each month" => "Ежемесячно",
"Users can configure modules" => "Пользователи могут настраивать модули",
"Score ascending" => "По возрастанию оценки",
"Score descending" => "По убыванию оценки",
"Name ascending" => "По имени",
"Name descending" => "По имени в обратном порядке",
"Login ascending" => "По логину",
"Login descending" => "По логину в обратном порядке",
"Displayed time zone" => "Часовой пояс",
"Number of visited pages to remember" => "Число посещённых страниц для запоминания",
"User information" => "Информация о пользователе",
"Private" => "Личное",
"Public" => "Общие",
"Use double-click to edit pages" => "Использовать двойной клик для редактирования страниц",
"Tasks per page" => "Число заданий на лист",
"Messages per page" => "Число сообщений на лист",
"Allow messages from other users" => "Принимать сообщения от других пользователей",
"Notify sender when reading mail" => "Уведомить отправителя при прочтении письма",
"Send me an email for messages with priority equal or greater than" => "Выслать мне письмо для сообщений с приоритетом не менее",
"My pages" => "Мои страницы",
"My blogs" => "Мои блоги",
"My galleries" => "Мои галереи",
"My messages" => "Мои сообщения",
"My tasks" => "Мои задачи",
"My forum topics" => "Мои темы на форуме",
"My forum replies" => "Мои ответы на форуме",
"My items" => "Мои объекты",
"Character set for mail" => "Кодировка для писем",
"Show user's info on mouseover" => "Показывать информацию о пользователе при наведении указателя мышки",
"Unlimited" => "Неограничено",
"LastModif" => "Последняя модификация",
"Last editor" => "Последний редактор",
"Complete" => "Выполнено",
"Business style" => "Бизнес стиль",
"Collaborative style" => "Совместный стиль",
"Page last modified on" => "Последние изменения страницы ",
"Both" => "Оба",
"When using the ...page... page break wiki syntax" => "Использование ...page... для разделения страниц разрывает wiki синтаксис",
"no cache" => "нет кеша",
"minute" => "минута",
"Disable" => "Отключить",
"Dynamic variables" => "Динамические переменные",
"Page creators are admin of their pages" => "Создатели - администраторы своих страниц",
"Page ID" => "ID страницы",
"Last modification date" => "Время последней правки",
"Last modified by" => "Последнее изменение",
"Version" => "Версия",
"Status" => "Статус",
"Versions" => "Версии",
"Links" => "Ссылки",
"Categories" => "Категории",
"Default sort order" => "Сортировка по умолчанию",
"Descending" => "По убіванию",
"Ascending" => "По возрастанию",
"Username" => "Имя пользователя",
"Password" => "Пароль",
"Security" => "Безопасность",
"Created by profile installer" => "Создано автоматически при установке профиля",
"Page updated by profile installer" => "Страница обновлена автоматически при установке профиля",
"Page cannot be found" => "Страница не найдена",
"Wiki top pages" => "Лучшие страницы Wiki",
"Most relevant pages" => "Наиболее значимые страницы",
"Relevance" => "Отношение к теме",
"Wiki last pages" => "Последние страницы Wiki",
"Forums last posts" => "Последние сообщения на форумах",
"Topic date" => "Дата темы",
"Forums most read topics" => "Наиболее читаемые темы форумов",
"Forums best topics" => "Лучшие темы форума",
"Forums most visited forums" => "Наиболее посещаемые темы форумов",
"Forums with most posts" => "Форумы с наибольшим количеством сообщений",
"Wiki top galleries" => "Лучшие галереи Wiki",
"Wiki top file galleries" => "Лучшие галереи файлов Wiki",
"Wiki top images" => "Лучшие картинки Wiki",
"Wiki top files" => "Лучшие файлы Wiki",
"Downloads" => "Закачки",
"Wiki last images" => "Последние картинки Wiki",
"Upload date" => "Дата закачки",
"Wiki last files" => "Последние файлы Wiki",
"Top articles" => "Лучшие статьи",
"Most visited blogs" => "Самые посещаемые блоги",
"Most active blogs" => "Самые активные блоги",
"Blogs last posts" => "Последние обновления в блогах",
"Post date" => "Дата обновления",
"Wiki top authors" => "Лучшие авторы Wiki",
"Pages" => "Страницы",
"Top article authors" => "Лучшие авторы статей",
"Registered" => "Зарегистрированные",
"You will receive an email with information to login for the first time into this site" => "Вы получите письмо с информацией о том, как зайти на сайт под своим аккаунтом в первый раз",
"Password is required" => "Пароль обязателен",
"User already exists" => "Пользователь уже существует",
"Invalid username" => "Неверное имя пользователя",
"Username is too long" => "Логин слишком длинный",
"characters long" => "символов",
"Wrong passcode. You need to know the passcode to register at this site" => "Неверный секретный код. Для регистрации Вам нужно знать этот код.",
"change" => "изменить",
"Today" => "Сегодня",
"and" => "и",
"from" => "от",
"Login" => "Вход",
"See other users' profiles" => "См. другой пользовательский профиль",
"Make friends" => "Подружится",
"Receive message" => "Прием сообщений",
"Send message" => "Отправить сообщение",
"Read an article" => "Читать статью",
"Publish an article" => "Опубликовать статью",
"Have your article read" => "Читали ли вашу статью",
"Upload new file to gallery" => "Отправить новый файл в галерею",
"Download other user's file" => "Скачать файл другого пользователя",
"Have your file downloaded" => "Скачать свой файл",
"Create a new image gallery" => "Создать новую картинную галерею",
"Upload new image to gallery" => "Закачать новое фото в галерею",
"See other users' galleries" => "Просмотреть галерею другого пользователя",
"See other users' images" => "Просмотреть фото другого пользователя",
"Have your gallery seen by other users" => "Предложить другому пользователю просмотреть вашу галерею",
"Have your image seen" => "Предложить просмотр вашего фото",
"Create new blog" => "Создать блог",
"Post in a blog" => "Послать в блог",
"Read other users' blogs" => "Прочитать блог другого пользователя",
"Have your blog read" => "Предложить свой блог для чтения",
"Create a new wiki page" => "Создать новую wiki страницу",
"Edit an existing page" => "Отредактировать существующею страницу",
"Attach file" => "Добавить файл",
"Wiki Comment" => "Wiki комментарий",
"Calendar item" => "Запись календаря",
"Gallery" => "Галерея",
"Image" => "Изображение",
"Article" => "Статья",
"Blog post" => "Заметка блога",
"Tracker item" => "Запись трекера",
"Tracker" => "Трекер",
"Unknown" => "Неизвестный",
"Trackeritem" => "Запись трекера",
"Directory category" => "Категория каталога",
"For you to vote, cookies must be allowed" => "Для голосования должны быть разрешены Cookies",
"new" => "новый",
"sheet" => "эл.лист",
"Link" => "Линк",
"<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin не активен: feature_jquery отключен -->",
"Prev" => "Предыдущий",
"Next" => "Следующий",
"First {\$params['itemname']}" => "Первый {\$params['itemname']}",
"Last {\$params['itemname']}" => "Последний {\$params['itemname']}",
"Next {\$params['itemname']}" => "Следующий {\$params['itemname']}",
"Prev {\$params['itemname']}" => "Предыдущий {\$params['itemname']}",
"comment" => "комментарий",
"information" => "информация",
"Tip" => "Подсказка",
"click here" => "нажмите здесь",
"AutoSave" => "Автосохранение",
"Edit Template" => "Редактировать шаблон",
"Admin Feature" => "Функции администратора",
"Hide" => "Скрыть",
"help" => "помощь",
"Cancel" => "Отмена",
"The text is" => "Текст превышает предельный размер на",
"character(s) too long - please edit it." => "букв(у/ы) - пожалуйста, отредактируйте.",
"Date Selector" => "Выбор даты",
"Select All" => "Выбрать все",
"Invert Sort" => "Обратная сортировка",
"second" => "секунда",
"months" => "месяцев",
"done" => "готово",
"Text cut here" => "Вырежьте текст здесь",
"Task" => "Задача",
"Priority" => "Приоритет",
"Friend" => "Друг",
"km" => "км",
"Last seen on" => "Последнее посещение",
"(idle for %s seconds)" => "(простой %s секунд)",
"User information - Click for more info" => "Информация о пользователе - Подробности",
"Yes" => "Да",
"No" => "Нет",
"pvs" => "просмотров стр.",
"Use this tree to copy the structure" => "Используйте это дерево, чтобы скопировать структуру",
"created from structure" => "создано по структуре",
"Table of contents" => "Содержание",
"You have to make %d choice(s) for the question" => "Вы должны дать %d ответ(ов) на вопрос",
"You have to make at least %d choice(s) for the question" => "Вы должны дать не менее %d ответа(ов) на вопрос",
"You have to make less than %d choice(s) for the question" => "Вы должны дать меньше %d ответа(ов) на вопрос",
"You have to choose at least %d choice(s) for the question" => "Вы должны выбрать не менее %d ответа(ов) на вопрос",
"Foo" => "Некто",
"text" => "текст",
"unknown error" => "неизвестная ошибка",
"You are not logged in" => "Вы не вошли под своим логином",
"Page '%0' cannot be found" => "Страница '%0' не найдена",
"You do not have permission to view this section" => "У Вас недостаточно прав для просмотра этой секции",
"For the security of your password direct access to the feed is only available via https" => "Для безопасности вашего пароля прямой доступ на канал доступен только через HTTPS",
"Help link" => "Помощь",
"faqs" => "чаво",
"quizzes" => "тесты",
"blogs" => "блогах",
"forums" => "форумы",
"Edit Plugin" => "Редактировать плагин",
"Click to edit dynamic variable" => "Щёлкните, чтобы отредактировать динамическую переменную",
"Update variables" => "Обновить переменные",
"Edit Section" => "Редактировать раздел",
"index" => "индекс",
"Show" => "Показать",
"sad" => "печальный",
"cool" => "классно",
"mad" => "чокнутый",
"%d points" => "%d очков",
"Removed" => "Удаленно",
"at" => "в",
"Unknown language" => "Неизвестный язык",
"Click here to confirm your action" => "Нажмите сюда, чтобы подтвердить ваши действия",
"Email" => "Эл.адрес",
"Heading" => "Шапка",
"Title bar" => "Заголовок",
"Background Color" => "Цвет фона",
"Wiki Help" => "Помощь Wiki",
"Find" => "Найти",
"Item" => "Пункт",
"Subject" => "Тема",
"Tracker was modified at " => "Трекер был обновлен ",
"text field" => "текстовое поле",
"size" => "размер",
"max" => "макс",
"textarea" => "многострочный текст",
"checkbox" => "галочка",
"drop down" => "выпадающий список",
"group selector" => "выбор группы",
"date and time" => "дата и время",
"action" => "действие",
"category" => "категория",
"email" => "эл.адрес",
"attachment" => "вложение",
"freetags" => "метки",
"stars" => "звезды",
"open" => "открыт",
"pending" => "на рассмотрении",
"closed" => "закрыт",
"Message" => "Сообщение",
"child categories" => "дочерняя категория",
"objects in category" => "объекты в категории",
"You must validate your account first. An email has been sent to you" => "Вы должны подтвердить свою учетную запись. Вам было отправлено письмо",
"Password should be at least" => "Пароль должен быть не короче",
"Password must contain both letters and numbers" => "Пароль должен содержать буквы и цифры",
"The registration mail can't be sent. Contact the administrator" => "Письмо с регистрацией не может быть отправлено. Обратитесь к администратору",
"Personal Phone" => "Личный номер",
"Personal Mobile" => "Личный моб.номер",
"Personal Fax" => "Личный факс",
"Work Phone" => "Рабочий номер",
"Work Mobile" => "Рабочий моб.номер",
"Work Fax" => "Рабочий факс",
"Company" => "Компания",
"Organization" => "Организация",
"Department" => "Департамент",
"Division" => "Подразделение",
"Job Title" => "Должность",
"Street Address" => "Улица",
"City" => "Город",
"State" => "Штат",
"Zip Code" => "Код адреса",
"No subject" => "Нет темы",
"Location" => "Расположение",
"Info" => "Информация",
"Image Annotation" => "Аннотация к изображению",
"Width" => "Ширина",
"Height" => "Высота",
"Alignment" => "Выравнивание",
"Save changes to annotations" => "Сохранить изменения в аннотации",
"End date" => "Конечная дата",
"Attachment" => "Вложение",
"File" => "Файл",
"Page" => "Страница",
"No such attachment on this page" => "Не найден вложенный файл",
"Avatar" => "Аватара",
"Displays the user Avatar" => "Показать пользователя Avatar",
"username" => "логин",
"Back" => "Назад",
"Zone" => "Область",
"URL" => "Ссылка",
"Insert theme-styled box on wiki page" => "Вставить тематически-стилевой блок в страницу wiki",
"Clear" => "Очистить",
"Url" => "Ссылка",
"Incorrect param" => "Не корректный параметр",
"List" => "Список",
"Table" => "Таблица",
"And" => "И",
"Object" => "Объект",
"Max" => "Макс",
"Mode" => "Режим",
"Centers the plugin content in the wiki page" => "Центрировать содержимое плагина на странице wiki",
"Chart" => "Чарт",
"Styles" => "Стили",
"Labels" => "Метки",
"title" => "заголовок",
"Chart as PDF" => "Диаграмма в PDF",
"Chart as PostScript" => "Диаграмма в PostScript",
"Code" => "Код",
"Displays a snippet of code" => "Показывает фрагмент кода",
"Caption" => "Заголовок",
"Word Wrap" => "Перенос слов",
"Colors" => "Цвета",
"Wiki Syntax" => "Wiki синтаксис",
"Content is HTML" => "Содержимое является HTML",
"code" => "код",
"note: colors and ln are exclusive" => "заметка: подсветка синтаксиса и номера строк вместе не работают",
"Dynamic Content" => "Динамическое содержимое",
"Content ID" => "ID содержимого",
"Insert copyright notices" => "Вставить сообщение об авторских правах",
"Days" => "Дни",
"Hours" => "Часы",
"Minutes" => "Минуты",
"Example" => "Пример",
"Clear all Tiki caches" => "Очистить все кеши Tiki",
"All user prefs sessions" => "Все пользовательские настройки сессий",
"Pre" => "pre",
"term" => "термин",
"definition" => "определение",
"Upcoming events" => "Грядущие события",
"Date" => "Дата",
"Show Creation Date" => "Показать дату создания",
"Show Creator" => "Показать создателя",
"Quality" => "Качество",
"High" => "Высокий",
"Low" => "Низкий",
"Blog Posts" => "Сообщения в блоге",
"all" => "все",
"file name" => "имя файла",
"missing parameters" => "пропущены параметры",
"Connection failed" => "Соединение не удалось",
"failed" => "не удался",
"description" => "описание",
"Value" => "Значение",
"Maximum Value" => "Максимальное значение",
"Maximum possible value. Default: 100" => "Максимально возможное значение. По умолчанию: 100",
"Color" => "Цвет",
"Displays a graphical GAUGE" => "Показть графический GAUGE",
"Spreadsheet" => "Электронная таблица",
"The user has chosen to make his information private" => "Пользователь пожелал оставить свои данные личными",
"Group" => "Группа",
"Group Name" => "Название группы",
"Groups" => "Группы",
"HTML code" => "HTML код",
"Wiki syntax" => "Wiki синтаксис",
"Thumbnail" => "Иконка",
"Browse" => "Просмотр",
"Download" => "Скачать",
"Image height" => "Высота изображения",
"Image width" => "Ширина изображения",
"Include" => "Добавить",
"Start" => "Начало",
"Stop" => "Остановить",
"Default Group" => "Группа по умолчанию",
"Default Color" => "Цвет по умолчанию",
"Last Modification" => "последнее изменение",
"List Pages" => "Список страниц",
"Show Name Only" => "Показывать только имя",
"Exact Match" => "Точное соответствие",
"Sort" => "Сортировка",
"or" => "или",
"Filter" => "Фильтр",
"Map" => "Карта",
"Feature disabled" => "Возможность заблокирована",
"Template" => "Шаблон",
"Style" => "Стиль",
"Tracker ID" => "Id трекера",
"Module Name" => "Название Модуля",
"Please choose a module" => "Пожалуйста, выберите модуль",
"to be used as argument" => "будет использован как аргумент",
"Displays a module inline in a wiki page" => "Показывать module встроенный в страницу",
"Sorry, no such module" => "Извините, такого модуля нет",
"Text" => "Текст",
"Sticky" => "Закреплено",
"data" => "данные",
"Permissions" => "Права доступа",
"Information" => "Информация",
"Module" => "Модуль",
"Poll" => "Опрос",
"Random Dynamic Content" => "Случайное динамическое содержимое",
"Maximum" => "Максимум",
"User Information" => "Личная Информация",
"User Preferences" => "Личные Настройки",
"admin" => "админ",
"Preferences" => "Настройки",
"Redirect" => "Перенаправление",
"Errors" => "Ошибки",
"Note" => "Примечание",
"Warning" => "Внимание",
"Close" => "Закрыть",
"Sheet" => "Эл.лист",
"Edit Sheet" => "Редактировать эл.таблицу",
"Show Pages" => "Показать страницы",
"List wiki pages" => "Список wiki страниц",
"Search criteria" => "Условие поиска",
"Action" => "Действие",
"Chat" => "Чат",
"Order" => "Порядок",
"First" => "Первый лист",
"Column" => "Колонка",
"Line" => "Линия",
"Edit" => "Правка",
"Missing db param" => "Отсутствует параметр db",
"Run a sql query" => "Выполнить sql запрос",
"sql query" => "sql запрос",
"Tracker Item" => "Запись трекера",
"Added" => "Добавлено",
"Subscribe Group" => "Подписать группу",
"Subscribe" => "Подписаться",
"Tag Name" => "Метка",
"Structure ID" => "Id структуры",
"Translate" => "Перевести",
"Fields" => "Поля",
"to" => "до",
"template" => "шаблон",
"Parent" => "Родитель",
"Overwrite" => "Перезаписать",
"Preview" => "Предпросмотр",
"Reset" => "Сбросить",
"View" => "Смотреть",
"ItemId" => "Id записи",
"New Status" => "Новый статус",
"Open" => "Открыт",
"Pending" => "На рассмотрении",
"Closed" => "Закрыт",
"Filters" => "Фильтры",
"notice" => "заметка",
"Wiki text" => "Wiki текст",
"Notice" => "Заметка",
"More" => "Еще",
"Field 1" => "Поле 1",
"Value 1" => "Значение 1",
"Field 2" => "Поле 2",
"Value 2" => "Значение 2",
"Field 3" => "Поле 3",
"Value 3" => "Значение 3",
"Field 4" => "Поле 4",
"Value 4" => "Значение 4",
"Field 5" => "Поле 5",
"Value 5" => "Значение 5",
"Flag" => "Флаг",
"User Count" => "Количество пользователей",
"Group name" => "Имя группы",
"Displays the number of registered users" => "Показать количество зарегистрированных пользователей",
"User List" => "Список пользователей",
"Real Name" => "Настоящее Имя",
"users" => "пользователи",
"Displays a list of registered users" => "Показать список зарегистрированных пользователей",
"This is the default text" => "Это текст по умолчанию",
"(version 3)" => "(версия 3)",
"This is version 3 info" => "Это информация 3 версии",
"(version 2)" => "(версия 2)",
"This is version 2 info" => "Это информация 2 версии",
"(version 1)" => "(версия 1)",
"This is version 1 info" => "Это информация 1 версии",
"Vote" => "Голосование",
"Show Stats" => "Показать статистику",
"Show Stats After" => "Показать статистику после",
"Wanted Pages" => "Требуется описание страниц",
"From" => "От",
"To" => "Кому",
"Line break" => "Перевод строки",
"Level" => "Уровень",
"External Wiki" => "Внешний Wiki",
"valid" => "действителен",
"Wanted Page" => "Требуется описание страницы",
"Referenced By Page" => "Ссылка на странице",
"Lists ''wanted'' Wiki pages: " => "Список ''требуемых'' Wiki страниц: ",
"Archive" => "Архив",
"Unknown Template" => "Неизвестный шаблон",
"Unknown Service" => "Неизвестный сервис",
"Missing parameters" => "Пропущены параметры",
"Related" => "По теме",
"No version indicated" => "Версия не указана",
"Plugin " => "Дополнение ",
"Page locked" => "Страница заблокирована",
"Page unlocked" => "Страница разблокирована",
"ERROR: Either the subject or body must be non-empty" => "ОШИБКА: Тема либо тело сообщения должны быть заполнены",
"ERROR: No valid users to send the message" => "Ошибка: Нет пользователей для отправки сообщения",
"Invalid user" => "Пользователя не существует",
"No more messages" => "Сообщений больше нет",
"Categorize" => "Задать категорию",
"Unassign" => "снять назначение",
"Assign" => "Назначение",
"Received objects" => "Полученные объекты",
"Show description" => "Показать описание",
"Last forum posts" => "Последние ответы на форуме",
"Topics only" => "Только темы",
"Most commented forums" => "Самые комментируемые форумы",
"Most read topics" => "Самые читаемые темы",
"Most visited forums" => "Самые посещаемые форумы",
"Most popular tags" => "Облако тэгов",
"Google Search" => "Поиск по Google",
"Last actions" => "Последние действия",
"Last blog posts" => "Последние сообщения блога",
"no object here yet" => "здесь пока ничего нет",
"Last Created blogs" => "Последние созданные блоги",
"Last Created FAQs" => "Последние созданные ЧаВо",
"Last Created Quizzes" => "Последние созданные тесты",
"Last modified file galleries" => "Последние изменённые файловые галереи",
"Last Files" => "Последние файлы",
"Last Images" => "Последние изображения",
"Last Modified blogs" => "Последние изменённые блоги",
"Last submissions" => "Последние поступления",
"Last Items" => "Последние элементы",
"Last Modified Items" => "Последние изменённые элементы",
"Last Visitors" => "Последние посетители",
"Live support" => "Онлайн поддержка",
"Structure" => "Структура",
"Messages" => "Сообщения",
"List by month" => "Список по месяцам",
"Waiting Submissions" => "Ожидающие поступления",
"Old articles" => "Старые статьи",
"Create/Edit" => "Создание/Правка",
"Quick Edit a Wiki Page" => "Редактировать страницу",
"Random Pages" => "Случайные страницы",
"New user registration" => "Регистрация нового пользователя",
"Search" => "Поиск",
"Go" => "Вперед",
"Post" => "Сказать",
"Since your last visit" => "С Вашего последнего визита",
"Changes since" => "Изменения с момента",
"new comments" => "новые комментарии",
"new posts" => "новые записи",
"wiki pages changed" => "wiki страницы изменились",
"new articles" => "новые статьи",
"new FAQs" => "новые ЧаВо",
"new blogs" => "новые блоги",
"new blog posts" => "новые записи в блогах",
"new image galleries" => "новые галереи изображений",
"new images" => "новые изображения",
"new file galleries" => "новые файловые галереи",
"new files" => "новые файлы",
"new polls" => "новые опросы",
"new users" => "новые пользователи",
"new tracker items" => "новые записи в трекере",
"updated tracker items" => "обновленные записи в трекере",
"Most Active blogs" => "Самые активные блоги",
"Top File Galleries" => "Лучшие галереи",
"Top files" => "Популярные файлы",
"Top Forum Posters" => "Популярные писатели форума",
"Top Images" => "Лучшие изображения",
"Top Objects" => "Популярные объекты",
"Top Pages" => "Лучшие страницы",
"Top Quizzes" => "Лучшие тесты",
"Top Visited FAQs" => "Наиболее популярные ЧаВо",
"User Blogs" => "Ваши блоги",
"User bookmarks" => "Личные закладки",
"User Pages" => "Ваши страницы",
"My Pages" => "Мои страницы",
"User tasks" => "Мои задания",
"The task title must have at least 3 characters" => "Заголовок задачи должен быть длиннее 3 символов",
"Public tasks" => "Общедоступные задачи",
"Top users" => "Лучшие пользователи",
"Online users" => "Пользователи онлайн",
"Last wiki comments" => "Последние комментарии wiki",
"Videos on YouTube" => "Видео на YouTube",
"Invalid server key" => "Неверный ключ сервера",
"Invalid username or password" => "Неверное имя пользователя или пароль",
"Cookie not found" => "Cookie не найдены",
"Can create/admin calendars" => "Создание/управление календарями",
"Can add events in the calendar" => "Добавление событий в календарь",
"Can change events in the calendar" => "Изменение событий в календаре",
"Can browse the calendar" => "Просмотр календаря",
"Can view events details" => "Просмотр деталей события",
"Administrator, can create channels remove channels etc" => "Администратор может создать канал, удалить каналы и т.д.",
"Can use the chat system" => "Использовать систему чата",
"Can approve submissions" => "Подтверждение поступлений",
"Can admin article topics" => "Управление темами статей",
"Can admin article types" => "Управление типами статей",
"Can read article headings" => "Чтение заголовков статей",
"Can edit articles" => "Редактирование статей",
"Can edit submissions" => "Редактирование поступлений",
"Can read articles" => "Чтение статей",
"Can remove articles" => "Удаление статей",
"Can remove submissions" => "Удаление поступлений",
"Can submit articles" => "Отправлять статьи",
"Can read a topic (Applies only to individual topic perms)" => "Чтение темы (применяется только к индивидуальным правам на тему)",
"Can admin contributions" => "Управление взносами",
"Can admin the directory" => "Управление каталогом ссылок",
"Can admin directory categories" => "Управление категориями в каталоге ссылок",
"Can admin directory sites" => "Управление ссылками в каталоге ссылок",
"Can submit sites to the directory" => "Размещение ссылки в каталоге ссылок",
"Can use the directory" => "Использовать каталог ссылок",
"Can admin faqs" => "Управление ЧаВо",
"Can suggest faq questions" => "Предлагать вопрос в ЧаВо",
"Can view faqs" => "Просмотр ЧаВо",
"Can admin users" => "Управление пользователями",
"Can access site when closed" => "Доступ к сайту даже если он закрыт",
"Administrator, can admin banners" => "Администратор может управлять баннерами",
"Can ban users or ips" => "Запрет на пользователя или на IP адрес",
"Can admin the dynamic content system" => "Управление системой динамического содержимого",
"Can admin integrator repositories and rules" => "Управление интегратором хранилищ и правил",
"Can admin mail-in accounts" => "Управление учетными записями mail-in",
"Can edit object permissions" => "Редактирование прав доступа к объекту",
"Can clean cache" => "Очищение кэша",
"Can create new css suffixed with -user" => "Создание нового стиля с суфиксом -user",
"Can remove association between two pages in a translation set" => "Удаление ассоциации между страницами в разных переводах",
"Can admin cookies" => "Управление cookies",
"Can edit translations and create new languages" => "Редактирование переводов и создание новых",
"Can edit menu" => "Редактирование меню",
"Can edit menu option" => "Редактирование опции меню",
"Can edit site templates" => "Редактирование шаблонов сайта",
"Can search" => "Поиск",
"Can report a link to the webmaster" => "Отправка ссылки вебмастеру",
"Can subscribe to groups" => "Входить в группу",
"Can send a link to a friend" => "Отправка ссылки другу",
"Can use HTML in pages" => "Использовать HTML на страницах",
"Can view action log" => "Просмотр протокола событий",
"Can view action log for users of his own groups" => "Просмотр протокола событий группы для пользователя этой группы",
"Can view site stats" => "Просмотр статистики сайта",
"Can view site templates" => "Просмотр шаблона сайта",
"Can admin blogs" => "Управление блогами",
"Can assign perms to blog" => "Назначение прав на блог",
"Can post to a blog" => "Оставлять сообщения в блоге",
"Can create a blog" => "Создание блога",
"Can read blogs" => "Чтение блогов",
"Can admin file galleries" => "Управление файловыми галереями",
"Can assign perms to file gallery" => "Назначение прав на файловую галерею",
"Can use Directory Batch Load" => "Использовать пакетную загрузку в каталог ссылок",
"Can upload zip files with files" => "Загружать архивные файлы с файлами",
"Can create file galleries" => "Создание файловых галерей",
"Can download files" => "Скачивание файлов",
"Can edit a gallery file" => "Редактирование файла в галереи",
"Can list file galleries" => "Просмотр списка файловых галерей",
"Can upload files" => "Загружать файлы",
"Can view file galleries explorer" => "Просмотр проводника файловых галерей",
"Can view file galleries path" => "Просмотр пути файловых галерей",
"Can view file galleries" => "Просмотр файловых галерей",
"Can admin forums" => "Управление форумами",
"Can attach to forum posts" => "Присоединение к темам на форуме",
"Auto approve forum posts" => "Автоматическое подтверждение сообщений на форуме",
"Can edit own forum posts" => "Редактирование своих записей на форуме",
"Can post in forums" => "Оставлять сообщения на форумах",
"Can start threads in forums" => "Создавать обсуждения на форумах",
"Can read forums" => "Чтение форумов",
"Can vote comments in forums" => "Разрешить голосовать за комментарии на форумах",
"Can admin freetags" => "Управление метками",
"Can admin Image Galleries" => "Управление галереями изображений",
"Can assign perms to image gallery" => "Назначение прав на галерею изображений",
"Can upload zip files with images" => "Загружать архивные файлы с изображениями",
"Can create image galleries" => "Создание галерей изображений",
"Can tag objects" => "Устанавливать метки на объекты",
"Can list image galleries" => "Просмотр списка галерей изображений",
"Can unassign tags from an object" => "Убирать метки с объектов",
"Can upload images" => "Загружать изображения",
"Can browse freetags" => "Просмотр меток",
"Can view image galleries" => "Просмотр галерей изображений",
"Can admin newsletters" => "Управление рассылками новостей",
"Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Подписывать несколько эл.адресов сразу (необходимы права tiki_p_subscribe_email)",
"Can send newsletters" => "Отправка новостных рассылок",
"Can subscribe any email to newsletters" => "Подписывать любой эл.адрес на новостную рассылку",
"Can subscribe to newsletters" => "Подписаться на новостную рассылку",
"Can admin polls" => "Управление опросами",
"Can view poll results" => "Просмотр результатов опроса",
"Can vote polls" => "Разрешить голосовать за опросы",
"Can view poll voters" => "Просмотр участников опроса",
"Can admin quizzes" => "Управление тестами",
"Can take quizzes" => "Принимать участие в тестах",
"Can view quiz stats" => "Просмотр статистики теста",
"Can view user quiz results" => "Просмотр пользовательских результатов теста",
"Can admin sheet" => "Управление эл.таблицами",
"Can create and edit sheets" => "Создание и редактирование эл.таблиц",
"Can view sheet" => "Просмотр эл.таблицы",
"Can view sheet history" => "Просмотр истории эл.таблицы",
"Can post messages in shoutbox" => "Оставлять сообщения в кричалке",
"Can view shoutbox" => "Просмотр кричалки",
"Can admin surveys" => "Управление анкетами",
"Can take surveys" => "Принимать участие в опросах",
"Can view survey stats" => "Просмотр статистики опроса",
"Can admin trackers" => "Управление трекерами",
"Can attach files to tracker items" => "Присоединение файлов в трекерах",
"Can insert comments for tracker items" => "Добавлять комментарии в записях трекера",
"Can view tracker items comments" => "Просмотр комментариев в записи трекера",
"Can create new items for trackers" => "Создание новых объектов для трекеров",
"Can list trackers" => "Просмотр списка трекеров",
"Can change tracker items" => "Изменение записей в трекере",
"Can view rating result for tracker items" => "Просмотр рейтинга для записи в трекере",
"Can vote a rating for tracker items" => "Разрешить выставлять рейтинг записям в трекере",
"Can view trackers" => "Просмотр трекеров",
"Can watch tracker" => "Просмотр трекера",
"Can export tracker items" => "Экспортировать записи трекера",
"Can admin the wiki" => "Управление системой wiki",
"Can assign perms to wiki pages" => "Назначение прав на страницы wiki",
"Can edit pages" => "Редактирование страниц",
"Can edit copyright notices" => "Редактирование уведомлений об авторских правах",
"Can edit dynamic variables" => "Редактирование динамических переменных",
"Can create and edit structures" => "Создание и редактирование структур",
"Can export wiki pages using the export feature" => "Экспортировать wiki страницы через опцию экспорта",
"Can lock pages" => "Блокировка страниц",
"Can save as minor edit" => "Сохранять как мелочь",
"Can remove" => "Удаление",
"Can rename pages" => "Переименование страниц",
"Can rollback pages" => "Откат изменений на страницах",
"Can upload pictures to wiki pages" => "Загружать изображения на страницы wiki",
"Can use the page as a tracker template" => "Использовать страницу как шаблон для трекера",
"Can view page/pages" => "Просмотр страницы/страниц",
"Can watch structure" => "Просмотр структуры",
"Can add and change ratings on wiki pages" => "Добавление и правка рейтинга на странице wiki",
"Can attach files to wiki pages" => "Присоединение файлов на страницах wiki",
"Can view wiki attachments and download" => "Просмотр вложений и загрузок",
"Can view wiki comments" => "Просмотр wiki комментариев",
"Can view wiki history" => "Просмотр wiki истории",
"Can view rating of wiki pages" => "Просмотр рейтинга страницы wiki",
"Can view source of wiki pages" => "Просмотр источника страницы wiki",
"Can admin received articles" => "Управление полученными статьями",
"Can admin received pages" => "Управление полученными страницами",
"Can send articles to other sites" => "Отправка статей на другие сайты",
"Can send articles to this site" => "Отправка статей на этот сайт",
"Can send pages to this site" => "Отправлять страницы на этот сайт",
"Can send pages to other sites" => "Отправлять страницы на другие сайты",
"Can admin the TikiTests" => "Управление тестами Tiki",
"Can edit TikiTests" => "Редактирование тестов Tiki",
"Can replay the TikiTests" => "Повторное прохождение тестов Tiki",
"Can cache user bookmarks" => "Кэширование закладок пользователей",
"Can configure modules" => "Настройка модулей",
"Can create user bookmarks" => "Создание пользовательских закладок",
"Can use the mini event calendar" => "Использовать мини календарь событий",
"Can use the notepad" => "Использовать блокнот",
"Can admin public tasks" => "Управление общими задачами",
"Can use tasks" => "Использовать задачи",
"Can receive tasks from other users" => "Получение заданий от других пользователей",
"Can send tasks to other users" => "Назначать задания другим пользователям",
"Can upload personal files" => "Загружать персональные файлы",
"Can create items in personal menu" => "Создание пунктов в персональном меню",
"Can broadcast messages to all user" => "Отправлять сообщения на всех пользователей",
"Can broadcast messages to groups" => "Отправлять сообщения на все группы",
"Can use the messaging system" => "Использовать систему сообщений",
"Can admin comments" => "Управление комментариями",
"Can edit all comments" => "Редактирование всех комментариев",
"Can post new comments" => "Оставлять новые комментарии",
"Can read comments" => "Чтение комментариев",
"Can delete comments" => "Удаление комментарий",
"Can vote comments" => "Разрешить голосовать за комментарии",
"Can admin content templates" => "Управление шаблонами содержимого",
"Can edit content templates" => "Редактирование шаблонов содержимого",
"Can use content templates" => "Использовать шаблоны содержимого",
"Can edit HTML pages" => "Редактирование HTML страниц",
"Can view HTML pages" => "Просмотр HTML страниц",
"Can list registered users" => "Просмотр списка зарегистрированных пользователей",
"Admin live support system" => "Администрирование системы живой поддержки",
"Can use live support system" => "Использовать систему живой поддержки",
"Can create new mapfile" => "Создание нового файла-карты",
"Can delete mapfiles" => "Удаление файла-карты",
"Can edit mapfiles" => "Редактирование файла-карты",
"Can view mapfiles" => "Просмотр файлов-карт",
"Can view contents of mapfiles" => "Просмотр содержимого файлов-карт",
"Can use webmail" => "Использовать web-почту",
"Can use group webmail" => "Использовать групповые учетные записи в web-почте",
"Can use personal webmail accounts" => "Использовать персональные учетные записи в web-почте",
"Can view unapproved plugin details" => "Просмотр деталей не подтвержденных плагинов",
"Can execute unapproved plugin" => "Запускать не подтвержденные плагины",
"Can approve plugin execution" => "Подтверждение использования плагина",
"View page backlinks" => "Просмотр обрытных ссылок на страницу",
"Can admin mail notifications" => "Управление почтовыми уведомлениями",
"Can admin categories" => "Управление категориями",
"country" => "страна",
"bytes" => "байт",
"Send a link" => "Отправить ссылку",
"Translation" => "Перевод",
"Remove" => "Удалить",
"List of attached files" => "Список вложенных файлов",
"desc" => "описание",
"uploaded" => "закачано",
"Delete" => "Удалить",
"Upload file" => "Закачать файл",
"Attach" => "Вложение",
"Attach a file to this item" => "Приложить файл",
"more info" => "еще информация",
"No attachments for this item" => "К этому элементу файлы не приложены",
"Fatal error" => "Неисправимая ошибка",
"Save to notepad" => "Сохранить в блокноте",
"on" => "в",
"Read more" => "Читать дальше",
"pages" => "страницы",
"First page" => "Первая страница",
"Previous page" => "Предыдущая страница",
"page" => "стр.",
"Next page" => "Следующая страница",
"Last page" => "Последняя страница",
"Permalink" => "Постоянная ссылка",
"comments" => "коммент.",
"Actions" => "Действия",
"Properties" => "Свойства",
"No records found" => "Нет записей",
"Select Categories" => "Выбор категорий",
"Admin Categories" => "Редактировать категории",
"Select/deselect all categories" => "Отметить/снять все категории",
"No categories defined" => "Категории не определены",
"Browse Category" => "Просмотр категорий",
"User Level" => "Уровень пользователя",
"private message" => "личное сообщение",
"Send eMail to User" => "Отослать e-mail пользователю",
"user online" => "пользователь в сети",
"user offline" => "пользователь offline",
"top of page" => "наверх",
"Reply" => "Ответ",
"Approve" => "Подтвердить",
"Reject" => "Отклонить",
"Monitor this Topic" => "Наблюдать за этой темой",
"Stop Monitoring this Topic" => "Прекратить наблюдение",
"Moderator actions" => "Действия модератора",
"Move to topic:" => "Переместить в тему:",
"Move" => "Переместить",
"Delete Selected" => "Удалить выбранные",
"Comments Locked" => "Комментарии заблокированы",
"Unlock" => "Убрать блок",
"Lock" => "Блокировать",
"Threshold" => "Порог видимости комментариев",
"Replies" => "Ответы",
"below your current threshold" => "ниже текущего порога",
"Comments are locked" => "Комментарии заблокированы",
"New Reply" => "Новый ответ",
"Editing reply" => "Редактирование ответа",
"Reply to the selected post" => "Ответить на выбранное сообщение",
"Post new message" => "Написать новое сообщение",
"Editing comment" => "Правка комментария",
"Post new comment" => "Прокомментировать",
"If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "Если вы хотите получать уведомления о новых сообщениях в этой теме<br />оставьте нам свой электронный адрес",
"Add Comment" => "Добавить комментарий",
"Reply to parent post" => "Ответить на предыдущее сообщение",
"Post new reply" => "Отправить новый ответ",
"Post as Anonymous" => "Отправить ответ анонимно",
"Posting replies" => "Отправка ответов",
"Posting comments" => "Размещение комментариев",
"1 comment" => "1 комментарий",
"Comments" => "Комментарии",
"Go back" => "Назад",
"Return to home page" => "Вернуться на главную",
"Contributors" => "Авторы",
"Copyrights" => "Авторские права",
"Authors" => "Авторы",
"Add" => "Добавить",
"Current URL" => "Текущий URL",
"Type <code>help</code> to get list of available commands" => "Наберите <code>help</code> для получения списка возможных команд",
"Syntax" => "Синтаксис",
"Total" => "Всего",
"Duplicate File Gallery" => "Продублировать файловую галерею",
"Duplicate categories" => "Продублировать категории",
"Duplicate" => "Создать копию",
"There are individual permissions set for this file gallery" => "Для этой файловой галереи заданы индивидуальные права доступа",
"Save" => "Сохранить",
"Required for podcasts" => "Требуется для подкастов",
"System" => "Система",
"Use" => "Применить",
"Parent gallery" => "Родительская галерея",
"Max description display size" => "Максимальный размер описаний на экране",
"There are no wiki pages similar to '{\$page}'" => "Страниц похожих на '{\$page}' нет",
"Create this page" => "Создать эту страницу",
"(page will be orphaned)" => "(страница станет сиротой)",
"Close Window" => "Закрыть окно",
"Go to" => "Перейти",
"Private Gallery" => "Закрытая галерея",
"Active Perms" => "Активные права",
"Perms" => "Права",
"Archives" => "Архивы",
"Upload New Version" => "Загрузить новую версию",
"Replace" => "Замена",
"Download and lock" => "Скачать и заблокировать",
"Name-filename" => "Имя-Имя файла",
"Filename only" => "Только имя файла",
"Show as a column" => "Показать как столбец",
"Show in popup box" => "Показать во всплывающем окне",
"Show an icon in a column" => "Показывать значок в столбце",
"Exact&nbsp;match" => "Точное&nbsp;совпадение",
"any type" => "любой тип",
"all topic" => "все темы",
"any language" => "любой язык",
"not in" => "не включая",
"any category" => "любая категория",
"in:" => "в:",
"Number of displayed rows" => "Строк на странице",
"Clear Filter" => "Очистить фильтр",
"List View" => "Смотреть как список",
"Show php error messages" => "Показать ошибки php",
"Folksonomy Tags" => "Свободные метки",
"Tags" => "Метки",
"Translate tags" => "Перевести метки",
"Images Galleries" => "Галереи изображений",
"RSS Blogs" => "RSS блогов",
"RSS Articles" => "RSS статей",
"RSS Image Galleries" => "RSS галерей изображений",
"RSS File Galleries" => "RSS файловых галерей",
"RSS Forums" => "RSS форумов",
"RSS Maps" => "RSS карт",
"RSS Directories" => "RSS директорий",
"RSS Calendars" => "RSS календарей",
"Show Tree" => "Показать дерево",
"Hide Tree" => "Спрятать дерево",
"Move Selected Files" => "переместить выбранные файлы",
"Download the zip" => "Загрузить zip архив",
"Assign Permissions" => "Назначить права",
"Move to" => "Переместить в",
"Filename" => "Имя файла",
"Other Sorts" => "Другие виды сортировки",
"No information" => "Нет информации",
"Somebody or you tried to subscribe this email address at our site:" => "Кто-то либо Вы сами подали заявку на подписку с нашего сайта:",
"To the newsletter:" => "На список рассылки:",
"Description:" => "Описание:",
"In order to confirm your subscription you must access the following URL:" => "Для подверждения заявки Вам нужно посетить следующий URL:",
"User:" => "Пользователь:",
"A new message was posted to forum" => "Новое сообщение отослано на форум",
"Hi" => "Привет",
"Enjoy the site!" => "Наслаждайтесь сайтом!",
"The user" => "Пользователь",
"registered at your site" => "зарегистрировался на вашем сайте",
"Bye bye!" => "Пока пока!",
"This email address has been removed to the list of subscriptors of:" => "Этот почтовый адрес был удален из списка рассылки:",
"Newsletter:" => "Список рассылки:",
"You can unsubscribe from this newsletter following this link" => "Вы можете отписаться от новостей перейдя по этой ссылке",
"Welcome to our newsletter!" => "Добро пожаловать!",
"This email address has been added to the list of subscriptors of:" => "Этот почтовый адрес был добавлен в список рассылки:",
"You can always cancel your subscription using:" => "Вы всегда можете отменить подписку через:",
"You or someone registered this email address at" => "Вы или кто-то другой зарегистрировал этот адрес на",
"Your registration confirmation" => "Ваша регистрационная информация Tiki",
"changed" => "изменено",
"Created by" => "Создано",
"created" => "создано",
"New" => "Новый",
"File Description" => "Описание файла",
"Wiki page %s was commented on by" => "На страницу %s был добавлен комментарий от",
"an anonymous user" => "анонимный пользователь",
"Wiki page renamed" => "Страница переименована",
"Old name" => "Бывшее наименование",
"New name" => "Новое название",
"You may log in now." => "Теперь вы можете залогиниться.",
"Query" => "Запрос",
"Create" => "Создать",
"Reload" => "Обновить",
"of" => "/",
"Compare" => "Сравнить",
"Current" => "Текущий",
"Versions are identical" => "Версии совпадают",
"Ip" => "IP",
"Diff" => "Разница",
"Upload Files" => "Закачать файлы",
"Unread" => "Непрочитанные",
"Flagged" => "Отмеченные флажком",
"Unflagged" => "Без отметки флажком",
"Containing" => "Содержит",
"Sender" => "Отправитель",
"No messages to display" => "Нет сообщений для вывода",
"Broadcast message" => "Широковещательное сообщение",
"Please Confirm" => "Пожалуйста подтвердите",
"All users" => "Все пользователи",
"Lowest" => "Низший",
"Very High" => "Высший",
"Send" => "Отослать",
"Compose message" => "Создать сообщение",
"Invalid" => "Неправильный",
"CC" => "Копия (CC)",
"BCC" => "Скрытая копия (BCC)",
"is reply to" => "это ответ на",
"Mark as read" => "Отметить как прочтённые",
"Mark as unread" => "Как непрочтённые",
"Mark as flagged" => "Отметить флажком",
"Mark as unflagged" => "Снять отметку",
"Mark" => "Пометка",
"Mailbox" => "Почтовый ящик",
"Compose" => "Создать",
"Broadcast" => "Широковещание",
"Sent" => "Отправлено",
"Read message" => "Прочесть сообщение",
"Return to mailbox" => "Возврат в почтовый ящик",
"replyall" => "ответить всем",
"Flag this message" => "Отметить флажком",
"From:" => "От:",
"Return to archive" => "Возврат в архив",
"Return to outbox" => "Возврат в отправленные",
"Sent Messages" => "Отправленные",
"Replied" => "С ответом",
"Not replied" => "Без ответа",
"move to archive" => "перенести в архив",
"receiver" => "получатель",
"toggle" => "переключить",
"Thank you for installing Tikiwiki" => "Спасибо за использование Tikiwiki",
"To configure your Tiki" => "Настройка Tiki",
"Select" => "Выбрать",
"Admin Home" => "Администрирование системы",
"Admin" => "Админ",
"Admin Modules" => "Модули Администрирования",
"Modules" => "Модули",
"Admin Menus" => "Управлять меню",
"Menus" => "Меню",
"login" => "вход",
"private" => "личное",
"Add event" => "Добавить событие",
"Update" => "Обновить",
"Apply" => "Применить",
"Pages:" => "Страницы:",
"low" => "низкий",
"Add tags" => "Добавить тэги",
"insert original" => "вставить оригинал",
"insert thumbnail" => "вставить предпросмотр",
"more" => "еще",
"No avatar" => "Нет аватара",
"You" => "Вы",
"Open operator console" => "Открыть консоль оператора",
"Switch User" => "Сменить Пользователя",
"Switch" => "switch",
"Switch user" => "Сменить пользователя",
"Invalid password" => "Неправильный пароль",
"Email:" => "Ваш эл.адрес:",
"Click here to register" => "Нажмите здесь для регистрации",
"Click here if you've forgotten your password" => "Нажмите здесь если Вы забыли свой пароль",
"I forgot my password" => "Я забыл мой пароль",
"Click here to login using the default security protocol" => "Нажмите здесь для входа через протокол по умолчанию",
"Standard" => "Обычный",
"Click here to login using a secure protocol" => "Нажмите здесь для входа через защищенный протокол",
"Secure" => "Безопасный",
"local account" => "локальная учетная запись",
"You have" => "Вам",
"new messages" => "новые сообщения",
"new message" => "новое сообщение",
"You have 0 new messages" => "У Вас 0 новых сообщений",
"We have" => "",
"submissions waiting to be examined" => "поступлений, ожидающих оценки",
"Image Galleries" => "Галереи изображений",
"Calendars" => "Календари",
"Entire Site" => "Весь сайт",
"Image Gals" => "Фотогалереи",
"Page Relations" => "Зависимости страницы",
"Delete this shout" => "Удалить эту запись",
"Edit this shout" => "Редактировать эту запись",
"Read More" => "Читать ещё",
"Since your last visit on" => "С Вашего последнего визита",
"New Images" => "Новые изображения",
"Wiki Pages Changed" => "wiki страницы изменились",
"New Files" => "Новые файлы",
"New Comments" => "Новые комментарии",
"New Tracker Items" => "Новые записи в трекере",
"New Calendar Events" => "Новые события в календаре",
"New Users" => "Новые пользователи",
"click to edit" => "жми для правки",
"Nothing has changed" => "Ничего не изменилось",
"Users" => "Пользователи",
"Site default" => "Умолачение системы",
"TikiTests Menu" => "Меню TikiTests",
"List Tests" => "Список тестов",
"Create Test" => "Создать тест",
"Top galleries" => "Лучшие Галереи",
"update from it" => "обновить отсюда",
"preferred languages" => "языковые предпочтения",
"view" => "просмотр",
"update it" => "обновить здесь",
"click to view" => "нажмите для просмотра",
"Add Event" => "Добавить событие",
"Bookmarks" => "Закладки",
"Cache" => "Кеш",
"Done" => "Готово",
"Del" => "Удалить",
"select" => "выбор",
"Logout" => "Завершить работу",
"Refresh" => "Обновить",
"online users" => "народу онлайн",
"online user" => "пользователь в сети",
"on host" => "на сервере",
"Send a message to" => "Отправить сообщение для",
"Send a message" => "Отослать письмо",
"More Videos" => "Еще Видео",
"No individual permissions, category permissions apply" => "Индивидуальных прав доступа нет, применяются права доступа от категории",
"There are individual permissions set for this tracker" => "Для этого трекера заданы индивидуальные права доступа",
"No individual permissions. Global permissions apply." => "Никаких индивидуальных прав доступа, здесь только глобальные",
"vote" => "голос",
"Rate" => "Оценка",
"Use your email as login" => "Используйте свой эл.адрес как имя для входа",
"Lowercase only" => "Только в нижнем регистре",
"Generate a password" => "Создать пароль",
"Send Newsletter" => "Отправить новость",
"To edit the copyright notices" => "Для редактирования авторских прав",
"Click Here" => "Нажмите здесь",
"The content on this page is licensed under the terms of the" => "Содержимое этой страницы находится под защитой лицензии",
"Fullscreen" => "Во весь экран",
"Report to Webmaster" => "Написать вебмастеру",
"Blogs RSS" => "RSS Блогов",
"Articles RSS" => "RSS Статей",
"Image Galleries RSS" => "RSS галерей изображений",
"File Galleries RSS" => "RSS файловых галерей",
"Forums RSS" => "RSS Форумов",
"Maps RSS" => "RSS Карт",
"Last update from SVN" => "Последнее обновление из SVN",
"Execution time" => "Время выполнения",
"secs" => "сек",
"Memory usage" => "Загрузка памяти",
"Server load" => "Загрузка сервера",
"Login through CAS" => "Войти через CAS",
"Login through Shibboleth" => "Войти через Shibboleth",
"Do not group by item" => "Не группировать по типу",
"Group by item" => "Группировать по типу",
"Calendar View" => "Смотреть как календарь",
"Tiki Action Calendar" => "Календарь событий Tiki",
"Tools Calendars" => "Календари инструментов",
"Check / Uncheck All" => "отметить / очистить все",
"Crosslinks to other features and settings" => "Ссылки на другие функции и настройки",
"Other sections" => "Другие разделы",
"Administration features" => "Функции администрирования",
"TikiCache/System" => "Кеш Tiki",
"SysLogs" => "Протоколы системы",
"phpinfo" => "Настройки PHP",
"Mods" => "Модули",
"Banning" => "Блокировки",
"Edit Languages" => "Редактировать языки",
"Transversal features" => "Трансверсальные функции",
"which apply to more than one section" => "которые применяются в более чем одном разделе",
"Mail Notifications" => "Уведомления почтой",
"Navigation features" => "Навигационные функции",
"Look & feel" => "Внешний вид",
"themes" => "темы",
"Text area features" => "Текстовые функции",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "используются во всех полях для ввода текста. Например wiki страницы, блоги, статьи, форумы, и т.д.",
"External Wikis" => "Внешние Wiki",
"Stats &amp; banners" => "Статистика и баннеры",
"Report" => "Отчет",
"kb" => "кб",
"Statistics" => "Статистика",
"Weeks" => "Недели",
"Settings" => "Настройки",
"Setting" => "Установка",
"Rule title" => "Заголовок правила",
"Username regex matching" => "Regex на имя пользователя",
"IP regex matching" => "Regex на IP",
"Banned from sections" => "Закрыт доступ в разделы",
"Rule activated by dates" => "Правило активируется по датам",
"Rule active from" => "Правило активно от",
"Rule active until" => "Правило активно до",
"Custom message to the user" => "Индивидуальное сообщение пользователю",
"Rules" => "Правила",
"User/IP" => "Пользователь/IP",
"Sections" => "Секции",
"Admin Calendars" => "Настройка календарей",
"Create Calendar" => "Создать календарь",
"View Calendars" => "Просмотр календарей",
"Import" => "Импорт",
"List of Calendars" => "Список календарей",
"Loc" => "Разм.",
"Participants" => "Участники",
"Cat" => "Кат.",
"Lang" => "Язык",
"Prio" => "Приор.",
"Subscription" => "Подписка",
"Perso" => "Персон.",
"View Calendar" => "Просмотр календаря",
"Create/Edit Calendars" => "Создать/Изменить календари",
"Custom Locations" => "Свои места назначения",
"Custom Participants" => "Свои участники",
"Custom Languages" => "Свои языки",
"Custom URL" => "Свой URL",
"Custom Subscription List" => "Свои подписчики",
"Custom Priorities" => "Свои приоритеты",
"Personal Calendar" => "Персональный календарь",
"Start of day" => "Начало дня",
"End of day" => "Конец дня",
"Standard Colors" => "Стандартные цвета",
"Green" => "Зеленый",
"Blue" => "Синий",
"Purple" => "Розовый",
"Red" => "Красный",
"Orange" => "Оранжевый",
"Yellow" => "Желтый",
"Let me select my own colors" => "Выбор собственного цвета",
"Custom foreground color" => "Выбрать цвет",
"Custom background color" => "Выбрать цвет фона",
"Default event status" => "Статус события по умолчанию",
"Show in calendar view" => "Смотреть как календарь",
"Group of users alerted when calendar event is modified" => "Оповещать группу пользователей при изменении календаря",
"Browse the category system" => "Просмотр категорий",
"Current category" => "Текущая категория",
"Child categories" => "Подчинённые категории",
"Edit permissions for this category" => "Назначить права доступа к категории",
"Add new category" => "Добавить новую категорию",
"Batch upload" => "Пакетная закачка",
"Batch upload (CSV file)" => "Пакетная закачка (CSV файл)",
"Objects in category" => "Объекты в категории",
"Remove from this Category" => "Удалить из этой категории",
"Add objects to category" => "Добавить объекты в категорию",
"Admin templates" => "Управлять шаблонами",
"Create new template" => "Создать новый шаблон",
"Use in" => "Разрешено в секции",
"HTML Pages" => "HTML страницы",
"Text area" => "Текстовые области",
"Templates" => "Шаблоны",
"Visible in no sections" => "Скрыто в секциях",
"Remove section" => "Удалить секцию",
"Admin cookies" => "Настройка cookies",
"Create/edit cookies" => "Создание/правка cookies",
"Upload Cookies from textfile" => "Закачать Cookies из текстового файла",
"Upload from disk:" => "Выбрать и закачать с диска:",
"Upload" => "Закачать",
"Remove all cookies" => "Убрать все cookies",
"filter" => "фильтр",
"Admin DSN" => "Управлять DSN",
"Create/Edit External Wiki" => "Создать/Редактировать внешние Wiki",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (Используйте  чтобы заменить именем страницы URL пример: http://www.example.com/tiki-index.php?page=)",
"ExtWiki" => "внеш.wiki",
"Admin Forums" => "Управлять форумами",
"Create New Forum" => "Создать новый форум",
"Duplicate Forum" => "Создать копию форума",
"View this forum" => "Просмотр форума",
"Import forums" => "Импорт форумов",
"List forums" => "Список форумов",
"Coms" => "Комментариев",
"Age" => "Возраст",
"PPD" => "ppd",
"Create new" => "Создать новое",
"Password protected" => "Защищено паролем",
"Forum password" => "Пароль на форум",
"Topic list configuration" => "Конфигурация списка тем",
"Posts can be rated" => "Оценивать сообщения",
"Display last post titles" => "Показывать заголовки последних ответов",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Пересылать сообщения на этом форуме по этому адресу электронной почты, в формате, который может быть использован для отправки обратно",
"Send mails even when the post is generated by inbound mail" => "Отправлять почту даже если ответ был получен входящим письмом",
"Append a reply link to outbound mails" => "Добавить ссылку на ответ в исходящую почту",
"Originating e-mail address for mails from this forum" => "Отправитель электронной почты для писем с этого форума",
"Add messages from this email to the forum" => "Добавлять сообщения от этого email в форум",
"Use topic smileys" => "Использовать смайлики тем",
"Show topic summary" => "Показать сводку темы",
"User information display" => "Показывать информацию о пользователе",
"eMail" => "эл.адрес",
"Online" => "онлайн",
"Approval type" => "Тип подтверждения",
"Store attachments in:" => "Сохранять вложения:",
"Set topics preferences" => "Настройки тем",
"Show topics preferences" => "Показать настройки",
"hide topics preferences" => "Убрать настройки",
"Set thread preferences" => "Настройки ответов",
"Show threads preferences" => "Показать настройки",
"hide threads preferences" => "Убрать настройки",
"Duplicate perms" => "Продублировать права",
"Admin Hotwords" => "Поучения Администратора",
"Add Hotword" => "Новое ключевое слово",
"Word" => "Слово",
"Admin HTML pages" => "Управлять HTML страницами",
"Edit this page" => "Редактировать страницу",
"View page" => "Просмотр страницы",
"Content" => "Содержимое",
"content" => "содержимое",
"Create new HTML page" => "Создать новую HTML страницу",
"Apply template" => "Применить шаблон",
"Dynamic" => "Динамическая",
"Static" => "Статическая",
"Last Modif" => "Посл. правка",
"Cancel Edit" => "Отменить правку",
"Change preferences" => "Изменить настройки",
"General" => "Общие",
"Features" => "Возможности",
"Community" => "Сообщество",
"Profiles" => "Профили",
"Editing and Plugins" => "Редактирование и плагины",
"Meta Tags" => "Метатеги",
"User files" => "Файлы пользователя",
"Webservices" => "Web сервисы",
"To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "Чтобы добавить или удалить блоги, используйте \"Создать/Изменить Блог\" в меню \"Блоги\", или",
"General Settings" => "Общие настройки",
"To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "Чтобы добавить или удалить календари, используйте \"Календарь\" в меню \"Админ\", или",
"Change settings" => "Изменить параметры",
"General settings" => "Общие параметры",
"Default calendars to display" => "Календари для отображения по умолчанию",
"All calendars" => "Все календари",
"A subset of available calendars" => "Подмножество имеющихся календарей",
"Create calendar" => "Создать календарь",
"JS calendar" => "JS календарь",
"Browse categories" => "Просмотр категорий",
"Administer categories" => "Администрирование категорий",
"Admin types" => "Настройка типов",
"Import CSV file" => "Импортировать CSV файл",
"List Articles" => "Список статей",
"General Preferences" => "Основные настройки",
"Permission" => "Доступ",
"Admin Groups" => "Настройка групп",
"Admin Users" => "Настройка пользователей",
"Default user preferences" => "Настройки пользователя по умолчанию",
"Users Default Preferences" => "Предпочтения пользователей по умолчанию",
"User messages" => "Сообщения пользователя",
"My Tiki" => "Мой Tiki",
"Select which items to display when listing users" => "Выберите пункты для отображения при просмотре списка пользователей",
"Copyright allows to determine a copyright for all the objects of tikiwiki" => "Copyright позволяет определить авторские права для всех объектов TikiWiki",
"Enable copyright management for" => "Включить управление авторскими правами для",
"Watches" => "Наблюдения",
"Experimental" => "Экспериментальные возможности",
"Programmer" => "Для программиста",
"Feedback" => "Обратная связь",
"To create or remove file galleries, select" => "Для создания или удаления файловой галереи выберите",
"from the application menu" => "из меню приложения",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "У вас есть два варианта для достижения этой цели: <br /> <ul> <li> Использовать каталог за пределами вашего сайта, но при этом необходимо убедиться, что ваш PHP-скрипт может читать и записывать в этот каталог. </li> <li> Использование каталога внутри сайта с использованием ограничения доступа через файл .htaccess.</li></ ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "При настройки путей используйте UNIX стандарт записи. Например files/ или c:/foo/files или /www/files/",
"Score is disabled" => "Подсчет баллов отключен",
"Enable now" => "Включить",
"Search Indexing" => "Индексированный поиск",
"Searches" => "Поиски",
"Galleries features" => "Свойства галерей",
"Use database to store images" => "Хранить изображения в базе данных",
"Use a directory to store images" => "Хранить изображения в папке",
"Directory path" => "Путь к папке",
"Library to use for processing images" => "Библиотека для обработки изображений",
"Uploaded image names must match regex" => "Имена картинок должны совпадать с regex",
"Uploaded image names cannot match regex" => "Имена картинок НЕ должны совпадать с regex",
"Max Rows per page" => "Строк на странице не более",
"Images per row" => "Картинок в строке не более",
"Thumbnails size X" => "Размер иконок X",
"Thumbnails size Y" => "Размер иконок Y",
"pixels" => "пиксели",
"Set features" => "Задать свойства",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Удалить изображения в каталоге системы, которые не использованы в страницах Wiki, статьях или сообщениях блогов",
"All galleries" => "Все галереи",
"System Gallery" => "Системная галерея",
"Gallery listing configuration" => "Настройка списка галерей",
"Change configuration" => "Изменить конфигурацию",
"Image galleries comments settings" => "Комментарии в фотогалереях",
"Release Check" => "Проверка обновлений",
"Reset or upgrade your database" => "Сбросить или обновить базу данных",
"Check for updates now" => "Проверить обновления сейчас",
"Site Identity" => "Наименование сайта",
"Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences" => "На странице <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Внешний вид</strong></a> вы можете установить дополнительные настройки",
"Server" => "Сервер",
"Contact" => "Связаться",
"Miscellaneous" => "Разное",
"Home Page" => "Домашняя страница",
"Date and Time Format Help" => "Помощь по формату даты и времени",
"Change admin password" => "Пароль администратора",
"Defaults" => "Умолчания",
"Internationalization" => "Международные настройки",
"ok" => "да",
"port" => "порт",
"Look & Feel" => "Внешний вид",
"General Layout options" => "Параметры общего расположения",
"Admin layout per section" => "Управлять расположением в секции",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Чтобы добавить или удалить опросы, используйте \"Опросы\" в меню \"Админ\", или",
"Waiting" => "Ожидание",
"Last update" => "Последнее обновление",
"More information" => "Еще Информации",
"Specification" => "Спецификация",
"Search results" => "Результаты поиска",
"Default size" => "Размер по умолчанию",
"Required" => "Обязателен",
"Parameters" => "Параметры",
"Default Value" => "Значение по умолчанию",
"Use database to store files" => "Хранить файлы в базе данных",
"Use a directory to store files" => "Хранить файлы в папке",
"dls" => "скачано",
"No records" => "Нет записей",
"Quota (Mb)" => "Квота (Мбайт)",
"Use database to store userfiles" => "Хранить файлы пользователей в базе данных",
"Use a directory to store userfiles" => "Хранить файлы пользователей на диске",
"Page version" => "Версия страницы",
"Remove a tag" => "Удалить отметку",
"Generate dump" => "Создать дамп",
"Download last dump" => "Скачать последний дамп",
"Remove unused pictures" => "Удалить неиспользуемые изображения",
"Export Wiki Pages" => "Экспорт страниц Wiki",
"Wiki attachments" => "Приложение файлов к страницам Wiki",
"Start page" => "Стартовая страница",
"CSS File" => "CSS Файл",
"Clear cache" => "Очистить кеш",
"No pages found" => "Страницы не найдены",
"Theme control" => "Управление темами",
"Right column" => "Правая колонка",
"Top bar" => "Верхняя полоса",
"Generate positions by hits" => "Выстроить положение по количеству запросов",
"List of featured links" => "Список рекомендуемых ссылок",
"Position" => "Положение",
"Add Featured Link" => "Добавить рекомендуемую ссылку",
"disables the link" => "запрещает ссылку",
"Link type" => "Вид ссылки",
"replace current page" => "заменить эту страницу",
"framed" => "в рамке",
"open new window" => "новое окно",
"Account name" => "Название учётной записи",
"POP server" => "POP сервер для приёма почты",
"SMTP server" => "SMTP сервер для отправки почты",
"SMTP requires authentication" => "SMTP требует ввода пароля",
"Admin Topics" => "Администрирование тем",
"Admin Types" => "Настройка типов",
"Active" => "Активный",
"List menus" => "Список меню",
"Edit this menu" => "Редактировать это меню",
"Edit menu options" => "Параметры меню",
"Some useful URLs" => "Некоторые полезные URL",
"option" => "параметр",
"section level 0" => "раздел 0 уровня",
"section level 1" => "раздел 1 уровня",
"section level 2" => "раздел 2 уровня",
"section level 3" => "раздел 3 уровня",
"separator" => "разделитель",
"Choose" => "Выбор",
"Home Blog" => "Домашний блог",
"Home Image Gal" => "Домашняя фотогал.",
"Home Image Gallery" => "Домашняя фотогалерея",
"Home File Gal" => "Домашняя файл.галерея",
"Home File Gallery" => "Домашняя файловая галерея",
"User preferences" => "Личные настройки",
"User prefs" => "Личные настройки",
"List galleries" => "Список галерей",
"List image galleries" => "Список фотогалерей",
"Upload image" => "Закачать изображение",
"Gallery Rankings" => "Рейтинги галерей",
"Browse a gallery" => "Просмотреть галерею",
"Articles home" => "Заглавная",
"All articles" => "Все статьи",
"Submit" => "Отправить",
"List Blogs" => "Список блогов",
"View a forum" => "Просмотр форума",
"View a thread" => "Просмотр ветки обсуждения",
"View a FAQ" => "Просмотреть ЧаВо",
"Take a quiz" => "Пройти тест",
"Quiz stats" => "Статистика теста",
"Stats for a Quiz" => "Статистика для теста",
"Preview menu" => "Предосмотр меню",
"Menu options" => "Опции меню",
"Export CSV data" => "Экспорт данных в CSV",
"Import CSV data" => "Импорт данных в CSV",
"Options" => "Параметры",
"Active Permissions" => "Установленные права",
"dynamic collapsed" => "динамическое свёрнутое",
"dynamic extended" => "динамическое раскрытое",
"fixed" => "фиксированное",
"View template" => "Просмотр шаблона",
"Clear Cache" => "Очистить кеш",
"Assign/Edit modules" => "Назначить/Редактировать модули",
"Assigned Modules" => "Назначенные модули",
"Left Modules" => "Модули слева",
"Move Up" => "Вверх",
"Move Down" => "Вниз",
"Move to Right Column" => "переместить в правую колонку",
"Right Modules" => "Модули справа",
"Move to Left Column" => "переместить в левую колонку",
"Assign new module" => "Назначить новый модуль",
"Edit this assigned module:" => "Редактировать назначенный модуль:",
"Cache Time" => "Время кеширования",
"required" => "обязательный",
"The" => "Опция",
"Display Modules to All Groups" => "Показывать модули всем группам",
"User Modules" => "Пользовательские модули",
"Create new user module" => "Создать новый пользовательский модуль",
"Must be wiki parsed" => "Wiki синтаксис",
"Objects that can be included" => "Объекты, которые можно добавить",
"Use Poll" => "Использовать опрос",
"Use Gallery" => "Использовать галерею",
"Use Dynamic Content" => "Использовать динам. содержимое",
"Use RSS Module" => "Использовать модуль rss",
"Use Menu" => "Использовать меню",
"Use Banner Zone" => "Использовать область",
"Use Wiki Structure" => "Использовать Wiki структуру",
"Data" => "Данные",
"Admin newsletter subscriptions" => "Управлять подписками на рассылки",
"List Newsletters" => "Список рассылок",
"Admin Newsletters" => "Управлять рассылками",
"Send Newsletters" => "Отправить письма",
"Subscriptions" => "Подписки",
"Subscribed" => "Подписка",
"txt file, one e-mail per line" => "текстовый файл, один эл.адрес на строку",
"Subscribe group" => "Подписка группы",
"Export Subscriber Emails" => "Экспорт эл.адресов подписчиков",
"Admin newsletters" => "Управлять рассылкой",
"Editions" => "Редакций",
"Drafts" => "Черновики",
"Last Sent" => "Последняя отправка",
"Create/Edit Newsletters" => "Создать/редактировать рассылки",
"There are individual permissions set for this newsletter" => "Для этой рассылки заданы особые права доступа",
"Users can subscribe/unsubscribe to this list" => "Пользователи могут самостоятельно управлять подпиской",
"Users can subscribe any email address" => "Пользователи могу подписать любой адрес",
"Add unsubscribe instructions to each newsletter" => "Добавлять в письмо инструкцию по отказу от рассылки",
"Validate email addresses" => "Проверять адреса электронной почты",
"Allow customized text message to be sent with the html version" => "Разрешить настройку текстового сообщения, которое будет отправлено в HTML-версии",
"Mail notifications" => "Почтовые уведомления",
"Add notification" => "Добавить уведомление",
"Event" => "Событие",
"User / Group" => "Пользователь / Группа",
"List polls" => "Список опросов",
"Edit this poll" => "Редактировать опрос",
"Preview poll" => "Предосмотр опроса",
"Poll options" => "Параметры голосования",
"Votes" => "Голоса",
"Admin Polls" => "Управлять голосованиями",
"Set last poll as current" => "Установить последнее голосование текущим",
"Close all polls but last" => "Закрыть все голосования кроме последнего",
"Activate all polls" => "Открыть все голосования",
"Create poll" => "Создать опрос",
"Edit poll" => "Редактировать опрос",
"active" => "активный",
"current" => "текущий",
"object" => "объект",
"PublishDate" => "Опубликовано",
"Votes older than these days are no more considered" => "Лимит в днях, позже которого ответы не учитываются",
"0 for no limit" => "0 - без лимита",
"Objects" => "Объекты",
"Results" => "Результаты",
"Add poll to pages" => "Добавить опрос к страницам",
"Wiki pages" => "Wiki страницы",
"Lock the pages" => "Заблокировать страницы",
"Content for the feed" => "Содержимое для потока",
"Security Admin" => "Безопасность",
"type" => "вид",
"user" => "логин",
"group" => "группа",
"sticky" => "закреплено",
"Edit structure" => "Редактирование структуры",
"View structure" => "Просмотр структуры",
"Export Pages" => "Экспорт страниц",
"Dump Tree" => "Выгрузить дерево",
"Create WebHelp" => "Создать WebHelp",
"View WebHelp" => "Просмотр WebHelp",
"Perform action with checked" => "Выполнить операцию над выделенными",
"Alias" => "Псевдоним",
"Tree" => "Дерево",
"Use single spaces to indent structure levels" => "Используйте одинарный пробел для нового уровня в структуре",
"Create New Structure" => "Создать новую структуру",
"Add a New Question" => "Добавить новый вопрос",
"List surveys" => "Список анкет",
"Survey Stats" => "Статистика анкетирования",
"This survey stats" => "Статистика анкеты",
"Edit this Survey" => "Правка анкеты",
"Admin Surveys" => "Настройки",
"Edit Survey Question" => "Редактировать вопросы анкеты",
"Add a New Question to this survey" => "Добавить новый вопрос в анкету",
"Question" => "Вопрос",
"One choice" => "Один вариант",
"Multiple choices" => "Несколько вариантов",
"Multiple choices of thumbnails from a file gallery" => "Множественный выбор эскизов из файловой галереи",
"Short text" => "Короткий текст",
"Wiki textarea" => "Текстовая область Wiki",
"Rate (1..5)" => "Оценить (1..5)",
"Rate (1..10)" => "Оценить (1..10)",
"For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "Для множественного ответа на вопрос используйте запятую в качестве разделителя. Например: один,два,три,много",
"For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "Для множественного выбора эскизов из файловой галереи, необходимо указать ID галереи. Например: 4",
"Options (if apply)" => "Варианты (если есть смысл)",
"Questions" => "Вопросы",
"Admin surveys" => "Настройки",
"List Surveys" => "Список анкет",
"Create New Survey" => "Новое анкетирование",
"There are individual permissions set for this survey" => "Для данного опроса установлен индивидуальный доступ",
"Tiki Cache/System Admin" => "Кеш Tiki",
"Exterminator of cached content" => "Список кешей",
"Directory to exterminate" => "Каталоги кеша",
"Empty" => "Пусто",
"Directories to save" => "Каталоги для возможного сохранения",
"Generate a zip of those directories" => "Создать архив указанных каталогов",
"A zip has been written to {\$zipPath}" => "Архив записан в {\$zipPath}",
"Directory is not writeable" => "Каталог не доступен для записи",
"Create a new topic" => "Создать новую тему",
"Topic Name" => "Название темы",
"Upload Image" => "Закачать изображение",
"List of topics" => "Перечень тем",
"topic image" => "изображение для темы",
"Inactive - Click to Activate" => "Отключено - нажмите чтобы включить",
"Deactivate" => "Деактивировать",
"Active - Click to Deactivate" => "Включено - нажмите чтобы выключить",
"Remove with articles" => "Удалить эти статьи",
"List Trackers" => "Список трекеров",
"Admin Trackers" => "Управлять трекерами",
"Edit This Tracker" => "Редактировать этот трекер",
"View This Tracker's Items" => "Показать содержимое трекера",
"Tracker fields" => "Поля трекера",
"Pos" => "Позиция",
"Is column visible when listing tracker items?" => "Видно ли колонку в списке элементов трекера?",
"Column links to edit/view item?" => "Колонка ссылается на правку/просмотр элемента?",
"Main" => "Основные",
"Field is public? (viewed in trackerlist plugin)" => "Публичное поле? (возможен просмотр в trackerlist плагине)",
"Hidden" => "Скрыт",
"Mandatory" => "Обязательное",
"Searchable" => "Поиск",
"New tracker field" => "Новое поле",
"Edit tracker field" => "Редактировать поля трекера",
"Multilingual content" => "Многоязычное содержимое",
"not hidden" => "не скрытое",
"visible to admin only" => "видимость только администратору",
"editable by admin only" => "редактирование только администратором",
"visible by creator &amp; admin only" => "видимость только автору &amp; администратору",
"Import/Export Trackers Fields" => "Импорт/Экспорт полей трекера",
"Edit This Tracker's Fields" => "Редактировать поля трекера",
"Found" => "Найдено",
"trackers" => "трекеры",
"Items" => "Пункты",
"with" => "с",
"Edit Tracker" => "Редактировать трекер",
"Create Tracker" => "Создать трекер",
"Create/Edit Tracker" => "Создать/Редактировать трекер",
"Auto create corresponding categories" => "Автоматическое создание соответствующей категории",
"Create a group for each item" => "Создать группу для каждого пункта",
"Show status" => "Показывать статус",
"Default status displayed in list mode" => "Статус по умолчанию в режиме списка",
"Show status to tracker admin only" => "Показывать статус только администратору трекера",
"Send copies of all activity in this tracker to this e-mail address" => "Отправлять письма на указанный эл.адрес при любой активности в трекере",
"Use simplified e-mail format" => "Использовать простой формат эл.письма",
"The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "В письме будут заполнены только поля Тема и Отправитель",
"New items are created with status" => "Статус для новых записей",
"Authoritative status for modified items" => "Новый статус для обновленных записей",
"No change" => "Без изменений",
"The tracker needs a user field with the option 1" => "Необходимо наличие поля \"Пользователь\" с опцией 1",
"Only one item per user or IP" => "Один IP адрес - одна запись",
"The tracker needs a user or IP field with the option 1" => "Необходимо наличие поля \"Пользователь\" или поля \"IP\" с опцией 1",
"The tracker needs a group field with the option 1" => "Необходимо наличие поля \"Группа\" с опцией 1",
"Show creation date when listing tracker items?" => "Показывать дату создания при выводе элементов трекера?",
"Show lastModif date when listing tracker items?" => "Показывать дату правки при выводе элементов трекера?",
"with values" => "использовать значения",
"Tracker items allow comments?" => "Позволить комментировать элементы трекера?",
"Tracker items allow attachments?" => "Позволить добавлять файлы?",
"Filesize" => "Размер файла",
"Filetype" => "Тип файла",
"Items can be created only during a certain time" => "Ограничить создание новых записей по времени",
"Group of users alerted when tracker is modified" => "Уведомить группу о модификации трекера",
"Import/Export" => "Импорт/Экспорт",
"Import/export trackers" => "Импорт/Экспорт трекера",
"Date Format" => "Формат даты",
"Charset encoding" => "Кодировка",
"Duplicate Tracker" => "Создать копию трекера",
"Members" => "Участники",
"Admin groups" => "Управлять группами",
"Admin users" => "Управлять пользователями",
"Add new group" => "Добавить новую группу",
"List of existing groups" => "Список существующих групп",
"Homepage" => "Домашняя страница",
"User Choice" => "Выбор пользователя",
"Edit group" => "Изменить группу",
"Add a New Group" => "Добавить новую группу",
"Edit Item" => "Редактировать",
"CSV File" => "CSV Файл",
"Add a New User" => "Добавить пользователя",
"Reason" => "Причина",
"More Criteria" => "Больше условий фильтрации",
"ago" => "раньше",
"Need to validate email" => "Требуется проверка эл.адреса",
"Assign to group" => "Назначить в группу",
"to groups" => "в группы",
"default" => "по умолчанию",
"Remove Users and their Userpages" => "Удалить пользователей и их личные страницы",
"Template wiki page" => "Шаблон wiki страницы",
"bcc" => "скрытая копия (bcc)",
"Edit user" => "Редактировать пользователя",
"Assign user to Groups" => "Добавить пользователя в группы",
"Use the email as username" => "Использование электронной почты в качестве имени пользователя",
"Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)" => "Внимание: смена имени пользователя может потребовать смену пароля (для пользователей зарегистрированных в старом tikiwiki&lt;=1.8)",
"No password is required" => "Пароль не требуется",
"User tracker item : {\$usersitemid}" => "Пользовательская запись в трекере : {\$usersitemid}",
"Overwrite but keep the previous login if the login exists in another case" => "Перезаписать, но сохранить старый логин если такой уже существует",
"Don't overwrite" => "Не перезаписывать",
"You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "Вы можете выгрузить пользователей любой группы на странице <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>",
"Page has been approved" => "Страница была одобрена",
"New attachments" => "Новые вложения",
"Old attachments" => "Старые вложения",
"Source" => "Источник",
"Admin Article Types" => "Настройка типов статей",
"Show Help" => "Помощь",
"Article type" => "Тип статьи",
"Show image" => "Показывать картинки",
"Show topic or own image" => "Показать темы или их изображения",
"Show avatar" => "Показывать Аватар",
"Show author's avatar" => "Показывать Аватар автора",
"Show author" => "Показывать автора",
"Show author name" => "Показывать имя автора",
"Show publish date" => "Показывать дату публикации",
"Show expire date" => "Показывать дату окончания",
"Show reads" => "Количество прочтений",
"Show the number of times the article was read" => "Показывать сколько раз статья была прочитана",
"Show size" => "Показывать размер",
"Show the size of the article" => "Показывать размер статьи",
"Show topline" => "Показать Topline",
"Show Language" => "Язык",
"Show the language" => "Показывать язык",
"Review" => "Обзор",
"Classified" => "Объявления",
"Show lang" => "Язык",
"Create a new type" => "Создать новый тип",
"Group Information" => "Информация о группе",
"Desc" => "Описание",
"level" => "уровень",
"inherited from" => "унаследованы от",
"inherited" => "унаследованный",
"Advanced feature" => "Расширенные возможности",
"Level configuration" => "Уровень конфигурации",
"Create level" => "Создать уровень",
"all permissions in level" => "все права доступа на уровне",
"Assign User to Group" => "Назначить пользователя в группу",
"backlinks to" => "обратные ссылки на",
"No backlinks to this page" => "На эту страницу нет обратных ссылок",
"Browse Gallery" => "Просмотр галереи",
"Upload From Disk" => "Закачать с диска",
"available images" => "доступные изображения",
"Process" => "Процесс",
"Edit Post" => "Правка сказанного",
"View Blog" => "Просмотр блога",
"Trash" => "Корзина",
"Publish Date" => "Дата публикации",
"Admin Category" => "Администрирование Категорий",
"Browse in" => "Просмотр в объектах",
"Trackers Items" => "Записей в трекерах",
"Sheets" => "Эл.таблицы",
"Find:" => "Поиск:",
"in the current category - and its subcategories: " => "в текущей категории и в ее подкатегориях",
"Hide subcategories objects" => "Скрыть объекты из подкатегории",
"Show subcategories objects" => "Показать объекты из подкатегории",
"Upper level" => "Верхний уровень",
"Browse related tags" => "Обзор связанной метки",
"Network of Tags related to" => "Все объекты с меткой",
"With all selected tags" => "Все указанные метки",
"With one selected tag" => "С одной из указанных меток",
"With last selected tag" => "С последней указанной меткой",
"More Popular Tags" => "Популярные метки",
"Alphabetically" => "По алфавиту",
"By Size" => "По размеру",
"Cloud" => "Облако",
"results found" => "объекта(ов) наейдено",
"List Galleries" => "Список галерей",
"Edit Gallery" => "Правка галереи",
"Rebuild Thumbnails" => "Перестроить иконки",
"List Gallery" => "Содержимое галереи",
"All Images" => "Все изображения",
"Monitor this Gallery" => "Наблюдать за галереей",
"Stop Monitoring this Gallery" => "Прекратить наблюдение за галереей",
"Sort Images by" => "Сортировать изображения по",
"subgallery" => "подгалерея",
"Subgallery" => "Подгалерея",
"Original Size" => "Оригинальный размер",
"rotate right" => "сдвинуть вправо",
"rotate" => "повернуть",
"Details" => "Детали",
"You can view this gallery's configured image (first, random, etc.) in your browser using" => "Просмотреть галерею вы можете набрав прямую ссылку на нее",
"Return to Gallery" => "Вернуться в галерею",
"Edit Image" => "Редактировать изображение",
"First Image" => "Первая картинка",
"Prev Image" => "Пред. картинка",
"Smaller" => "Меньше",
"Bigger" => "Больше",
"Popup window" => "Всплывающее окно",
"Next Image" => "След. картинка",
"Last Image" => "Последняя картинка",
"Image Name" => "Название",
"Move image" => "Переместить изображение",
"Stop Monitoring this Page" => "Остановить наблюдение",
"Monitor this Page" => "Наблюдать за страницей",
"Edit Calendar" => "Редактировать календарь",
"Export Calendars" => "Экспорт Календарей",
"Click to export calendars" => "Нажмите для экспорта календарей",
"Visible Calendars" => "Видимые календари",
"Group Calendars" => "Группа календарей",
"Export calendars" => "Экспорт календарей",
"advanced parameters" => "дополнительные параметры",
"Edit event" => "Редактировать событие",
"Delete event" => "Удалить событие",
"View event" => "Просмотр события",
"Tentative" => "Проба",
"Confirmed" => "Подтверждено",
"Cancelled" => "Отменено",
"View this Week" => "Просмотр текущей недели",
"View this Day" => "Просмотр текущего дня",
"Calendar Item" => "Событие календаря",
"New event" => "Новое событие",
"Edit Calendar Item" => "Редактировать сообщение календаря",
"January" => "Январь",
"February" => "Февраль",
"March" => "Март",
"April" => "Апрель",
"May" => "Май",
"June" => "Июнь",
"July" => "Июль",
"August" => "Август",
"September" => "Сентябрь",
"October" => "Октябрь",
"November" => "Ноябрь",
"December" => "Декабрь",
"times" => "раз",
"End" => "Конец",
"No description" => "Без описания",
"Format" => "Формат",
"Roles" => "Роли",
"default role" => "роль по умолчанию",
"import" => "Импорт",
"Change password enforced" => "Требуется срочная смена пароля",
"Change your password" => "Сменить Ваш пароль",
"Send a message to us" => "Отправьте нам сообщение",
"Contact us by email" => "Свяжитесь с нами по почте",
"Click here to send us an email" => "Нажмите здесь чтобы отправить нам эл.письмо",
"Send another message" => "Еще отправить сообщение",
"Contacts" => "Контакты",
"Create/edit contacts" => "Создать/редактировать контакты",
"First Name" => "Имя",
"Last Name" => "Фамилия",
"Nickname" => "Ник",
"Add a new site" => "Добавить сайт",
"Please contact the Site Administrator" => "Обратитесь к Администратору",
"Site added" => "Сайт добавлен",
"Edit a site" => "Редактировать сайт",
"Add a Site" => "Добавить сайт",
"Directory Administration" => "Управление каталогом",
"There are" => "Есть в наличии",
"invalid sites" => "ошибочные сайты",
"valid sites" => "проверенных сайтов",
"Users have visited" => "Посетители прошли на",
"sites from the directory" => "сайтов из каталога",
"Users have searched" => "Посетители искали",
"times from the directory" => "раз по каталогу",
"Sites" => "Сайты",
"Validate" => "Проверить",
"Admin directory categories" => "Администрирование категорий",
"Add a directory category" => "Добавить категорию",
"Edit this directory category" => "Редактировать категорию",
"editor" => "редактор",
"Mutual" => "Взаимные",
"Admin sites" => "Управлять сайтами",
"Is valid" => "Проверено, работает",
"New Sites" => "Новые сайты",
"Cool Sites" => "Классные сайты",
"any" => "все",
"in entire directory" => "во всём каталоге",
"Sort by" => "Сортировка по",
"sort" => "сорт",
"Last updated" => "Последняя правка",
"Total links" => "Всего ссылок",
"Links to validate" => "Ссылки для проверки",
"Searches performed" => "Выполнено запросов на поиск",
"Total links visited" => "Число посещённых ссылок",
"Directory ranking" => "Рейтинг каталога",
"Validate sites" => "Проверить сайты",
"Edit article" => "Правка статьи",
"View Articles" => "Просмотр статей",
"One of the email addresses you typed is invalid" => "Один из адресов электронной почты который вы ввели недействительный",
"Author Name" => "Имя Автора",
"Own Image" => "Собственное изображение",
"Use own image" => "Использовать своё изображение",
"Published" => "Опубликовано",
"Edit or create banners" => "Создать или отредактировать баннер",
"List banners" => "Список баннеров",
"URL to link the banner" => "URL для ссылки от баннера",
"Use dates" => "Использовать даты",
"Select ONE method for the banner" => "Использовать ОДИН метод для баннера",
"Use HTML" => "Использовать HTML",
"Use image" => "Использовать изображение",
"Image:" => "Изображение:",
"Current Image" => "Текущее изображение",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "Использовать изображение, взятое с URL (изображение будет перечитано с URL при каждом показе)",
"Use text" => "Использовать текст",
"Save the Banner" => "сохранить баннер",
"There are individual permissions set for this blog" => "Для этого блога заданы индивидуальные права доступа",
"Allow search" => "Разрешить поиск",
"Allow comments" => "Разрешить комментарии",
"Blog heading" => "Название блога",
"Bold text" => "Жирный",
"Italic text" => "Курсив",
"single quotes" => "одинарные кавычки",
"Underlined text" => "Подчеркнутый",
"Colored text" => "Цветной текст",
"Deleted text" => "Удаленный",
"2 dashes" => "двойное тире",
"Headings" => "Заголовки",
"Show/Hide" => "Показать/Спрятать",
"show/hide heading section. + (shown) or - (hidden) by default" => "развернуть/свернуть секцию заголовка. + (развернутая) или - (свернутая) по умолчанию",
"Autonumbered Headings" => "Автонумерация заголовков",
"Horizontal rule" => "Горизонтальная полоса",
"Text box" => "Текстовое поле",
"Box content" => "Содержимое в прямоугольнике",
"Centered text" => "По центру",
"Inserts an editable variable" => "Вставить динамическую переменную",
"External links" => "Внешние ссылки",
"Square Brackets" => "Квадратные скобки",
"Wiki References" => "Ссылки Wiki",
"JoinCapitalizedWords or use" => "СоединяйтеСловаСБольшойБуквы или используйте",
"page|description" => "стр.|описание",
"for wiki references" => "для ссылок внутри Wiki",
"SomeName" => "ЧьёТоИмя",
"prevents referencing" => "запрещает создание ссылки",
"Lists" => "Списки",
"for bullet lists" => "для ненумерованных списков",
"for numbered lists" => "для нумерованных списков",
"for definiton lists" => "для списков определений",
"Tables" => "Таблицы",
"row" => "строка",
"Monospace font" => "Моноширинный шрифт",
"Code sample" => "Пример кода",
"(very useful especially in tables)" => "(особенно удобно в таблицах)",
"Multi-page pages" => "Комбинированные страницы",
"to separate pages" => "для разделения страниц",
"Non parsed sections" => "Не разбираемые анализатором области",
"No description available" => "Описание недоступно",
"Browse Images" => "Просмотр изображений",
"Edit successful!" => "Редактирование успешно!",
"The following image was successfully edited" => "Следующий файл успешно отредактирован",
"Image Description" => "Описание изображения",
"Edit languages" => "Редактировать языки",
"Select the language to edit" => "Выберите язык для редактирования",
"Add a translation" => "Добавить перевод",
"Edit translations" => "Редактировать переводы",
"Translate recorded" => "Перевод запомнен",
"Original" => "Оригинал",
"reset table" => "сбросить таблицу",
"Select the language to Export" => "Выберите язык для экспорта",
"Create New Block" => "создать новый блок",
"Return to block listing" => "Вернуться к списку блоков",
"Block description: " => "Описание блока: ",
"You are editing block:" => "Вы редактируете блок:",
"Publishing date" => "Дата публикации",
"Publishing Date" => "Дата Публикации",
"Edit question options" => "Изменить параметры вопроса",
"List Quizzes" => "Список тестов",
"Quiz Stats" => "Статискика теста",
"This Quiz Stats" => "статистика по этому тесту",
"Edit this Quiz" => "редактировать тест",
"Admin Quizzes" => "Управлять тестами",
"Create/edit options for question" => "Создать/редактировать ответы на вопрос",
"Option" => "Параметр",
"points" => "точки",
"Quiz" => "Тест",
"Create/edit quizzes" => "Создать/редактировать тесты",
"There are individual permissions set for this quiz" => "Для этого теста заданы индивидуальные права доступа",
"Quiz can be repeated" => "Тест может быть пройден повторно",
"Store quiz results" => "Хранить результаты теста",
"Quiz is time limited" => "Тест ограничен по времени",
"Maximum time" => "Время не более",
"Create/edit questions for quiz" => "Создать/редактировать вопросы для теста",
"From Points" => "От очков",
"To Points" => "До очков",
"Answer" => "Ответ",
"Modify Structure" => "Изменение структуры",
"You will remove" => "Вы хотите удалить",
"and its subpages from the structure" => "и все ее подкатегории из структуры",
"Remove only from structure" => "Удалить только из структуры",
"Remove from structure and remove page too" => "Удалить из структуры и удалить страницу",
"Structure Layout" => "Макет структуры",
"Promote" => "На уровень выше",
"Demote" => "На уровень ниже",
"Previous" => "Раньше",
"Current Node" => "Выбран узел",
"Page alias" => "Псевдоним страницы",
"Move in this structure" => "Переместить в структуру",
"Move to another structure" => "Перенести в другую структуру",
"at the beginning" => "в начале",
"at the end" => "в конце",
"Add pages to current node" => "Добавить страницу к текущему узлу",
"After page" => "После страницы",
"Create Page" => "Создать страницу",
"Use pre-existing page" => "Использовать существующую странцу",
"Submit article" => "Разместить статью",
"List Submissions" => "Список поступлений",
"Use ...page... to separate pages in a multi-page post" => "Используйте ...page... для создания нескольких страниц",
"Own image size x" => "Размер своего изображения x",
"Own image size y" => "Размер своего изображения y",
"Submit Article" => "Разместить статью",
"Edit templates" => "Правка шаблонов",
"Template listing" => "Список шаблонов",
"Available templates" => "Доступные шаблоны",
"Add another image" => "Добавить изображение",
"Categories will be inherited from the structure top page" => "Категории будут унаследованы от структуры наверх",
"Admin Content Templates" => "Управлять шаблонами содержимого",
"Lock this page" => "Заблокировать страницу",
"Try to convert HTML to wiki" => "Конвертировать HTML в wiki",
"export all versions" => "Экспорт всех версий",
"Manage structures" => "Управление структурами",
"List Sheets" => "Список эл.таблиц",
"Graph" => "График",
"Export to file" => "Экспорт в файл",
"Autodetect" => "Автоопределение",
"Export Tracker Items" => "Экспорт записей трекера",
"Delimitors" => "Разделители",
"Carriage Return inside Field Value" => "Перевод строки внутри поля",
"Parse as Wiki Text" => "Обрабатывать как текст Wiki",
"status" => "состояние",
"lastModif" => "посл.правка",
"items" => "элементы",
"Dump" => "Дамп",
"Admin FAQ" => "Настроить ЧаВо",
"List FAQs" => "Список ЧаВо",
"View FAQ" => "Просмотр ЧаВо",
"Edit this FAQ" => "Редактировать ЧаВо",
"New Question" => "Новый вопрос",
"Edit FAQ question" => "Редактировать вопрос",
"Add FAQ question" => "Добавить вопрос",
"Use a question from another FAQ" => "Взять вопрос из другого ЧаВо",
"FAQ questions" => "Вопросы ЧаВо",
"Suggested questions" => "Предложенные вопросы",
"No suggested questions" => "Нет предложеных вопросов",
"Upload File" => "Закачать файл",
"View tpl" => "Просмотр шаблона",
"Edit template" => "Редактирование шаблона",
"Be careful to set the right permissions on the files you link to" => "Обратите внимание на установленные права доступа к файлам",
"You can access the file gallery using the following URL" => "Доступ к галерее можно получить через следующий URL",
"Admin forums" => "Управлять форумами",
"Go Back" => "Возврат",
"Back to forum" => "Назад в форум",
"make this a thread of" => "начать отсюда ветвь",
"None, this is a thread message" => "Нет, сообщение в потоке",
"summary" => "обзор",
"Announce" => "Объявление",
"Hot" => "Горячая новость",
"Locked" => "Закрыто",
"no feeling" => "без чувств",
"frown" => "хмурый",
"idea" => "идея",
"neutral" => "спокойный",
"question" => "вопрос",
"happy" => "счастливый",
"Save and Approve" => "Одобрить и сохранить",
"convert to topic" => "превратить в тему",
"List of messages" => "Список сообщений",
"New Topic" => "Новая тема",
"no summary" => "нет обзора",
"Search by name" => "Поиск по названию",
"Search in content" => "Поиск по содержимому",
"Last Post" => "Посл. сообщ.",
"Configure Forum" => "Настроить форум",
"Set language" => "Установить язык",
"Accept" => "Принять",
"Galleries" => "Галереи",
"Create New Gallery" => "Создать новую галерею",
"Create a gallery" => "Создать галерею",
"There are individual permissions set for this gallery" => "Для этой галереи заданы индивидуальные права доступа",
"Gallery is visible to non-admin users?" => "Видят ли галерею не-администраторы?",
"Gallery Image" => "Изображение галереи",
"Available scales" => "Доступные масштабы",
"default scale" => "масштаб по умолчанию",
"No scales available" => "Масштабы недоступны",
"Other users can upload images to this gallery" => "Закачка изображений в галерею доступна и другим",
"You can access the gallery using the following URL" => "Вы можете получить доступ к галерее по следующему адресу",
"Available Galleries" => "Доступные Галереи",
"Choose a filter" => "Выберите фильтр",
"Imgs" => "Изображений",
"Rollback" => "Откат",
"Overwrite existing pages if the name is the same" => "Перезаписать существующий файл если имя такое же",
"Previously remove existing page versions" => "Заранее удалить существующие версии страницы",
"excerpt" => "цитата",
"Result" => "Результат",
"Report all errors except notices" => "Выводить полный отчет исключая предупреждения",
"Documentation" => "Документация",
"Editor" => "Редактор",
"Last Changes" => "Последние изменения",
"Last 2 days" => "За 2 дня",
"Last 3 days" => "За 3 дня",
"Last 5 days" => "За 5 ней",
"Last week" => "За неделю",
"Last 2 weeks" => "За 2 недели",
"Last month" => "За месяц",
"Search by Date" => "Поиск по дате",
"Pages like" => "Подобные страницы",
"Edit New Article" => "Редактировать новую статью",
"View Submissions" => "Просмотр поступлений",
"Img" => "Изобр.",
"Create banner" => "Создать баннер",
"Client" => "Клиент",
"Method" => "Метод",
"Use Dates?" => "Использовать даты?",
"Max Impressions" => "Максимальное число показов",
"Impressions" => "Показы",
"Clicks" => "Нажатия",
"Create New Blog" => "создать новый блог",
"Approval" => "Подтверждено",
"Rejected" => "Отказано",
"Available content blocks" => "Доступные блоки содержимого",
"Current Value" => "Текущее значение",
"Current ver" => "Текущая версия",
"Next ver" => "Следующая версия",
"Program" => "Программа",
"Available FAQs" => "Доступные ЧаВо",
"Create new FAQ" => "Создать новый ЧаВо",
"Users can suggest questions" => "Пользователи могут предлагать вопросы",
"Create a File Gallery" => "Создать файловую галерею",
"Keep gallery window open" => "Не закрывать окно с галереями",
"Your comment" => "Ваш комментарий",
"Gallery Images" => "Галерея Картинок",
"Blog Title" => "Заголовок Блога",
"Edit New Submission" => "Редактировать новое поступление",
"Survey stats" => "Статистика анкетирования",
"Take Survey" => "Ответить на анкету",
"like" => "как",
"Last mod" => "Последнее изменение",
"Last author" => "Последний автор",
"Last version" => "Последняя версия",
"unlocked" => "разблокировано",
"Open client window" => "Открыть окно поддержки",
"Generate HTML" => "Сгенерировать HTML",
"Transcripts" => "Расшифровка",
"Online operators" => "Online операторы",
"Operator" => "Оператор",
"transcripts" => "расшифровка",
"Offline operators" => "Offline операторы",
"Add an operator to the system" => "Добавить оператора в систему",
"Operators must be tiki users" => "Операторы должны быть пользователями tiki",
"Set as Operator" => "назначить оператором",
"Chat started" => "Чат запущен",
"Operator:" => "Оператор:",
"Request live support" => "Запрос online поддержки",
"Request support" => "Запросить поддержку",
"Open a support ticket instead" => "Получить квиток поддержки",
"Your request is being processed" => "Ваш запрос принят. Ждите.",
"cancel request and exit" => "отменить запрос и выйти",
"cancel request and leave a message" => "отменить запрос и оставить сообщение",
"Live support:Console" => "Live support:Консоль",
"be online" => "в онлайн",
"be offline" => "в оффлайн",
"Support requests" => "Запросы пользователей",
"Requested" => "Запрошено",
"Join" => "Войти",
"Support chat transcripts" => "Расшифровка чата поддержки",
"started" => "начало",
"reason" => "причина",
"msgs" => "сообщ",
"Transcript" => "Рашифровка",
"Thank you" => "Спасибо",
"Prefs" => "Опции",
"Daily" => "Ежедневно",
"Weekly" => "Еженедельно",
"Remove old events" => "Удалить старые события",
"duration" => "длительность",
"h" => "час",
"mins" => "мин.",
"Mini Calendar: Preferences" => "Мини-календарь: Настройки",
"Calendar Interval in daily view" => "Интервал календаря в просмотре по дням",
"Start hour for days" => "День начинается в",
"End hour for days" => "День заканчивается в",
"Reminders" => "Напоминания",
"no reminders" => "нет напоминаний",
"min" => "мин",
"Or enter path or URL" => "Или введите путь или URL",
"Add Topic" => "Добавить тему",
"Attention" => "Внимание",
"User Galleries" => "Ваши галереи",
"My Articles" => "Мои статьи",
"User Articles" => "Статьи пользователя",
"My User Items" => "Мои трекер записи",
"User Items" => "Объекты пользователя",
"Unread Messages" => "Непрочтённые сообщения",
"Tasks" => "Задачи",
"User forum topics" => "Темы пользователя на форуме",
"Forum topics" => "Темы форума",
"Date of post" => "Дата сообщения",
"User forum replies" => "Ответы пользователя на форуме",
"Forum replies" => "Ответы на форуме",
"MyTiki" => "Мой Tiki",
"MyInfo" => "Информация обо мне",
"Contacts Preferences" => "Настройки контактов",
"Notepad" => "Блокнот",
"MyFiles" => "Мои Файлы",
"My Watches" => "Наблюдения",
"Sent editions" => "Отправленные редакции",
"HTML version" => "HTML версия",
"Text version" => "Текстовая версия",
"The newsletter was sent to {\$sent} email addresses" => "Новость была отправлена на {\$sent} e-mail адреса",
"Delete errors" => "Удалить ошибки",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Спасибо, что подписались на рассылку. Вы должны получить email с просьбой подтвердить подписку. Вы не получите ни одной рассылки, пока не подтвердите своё желание в ней участвовать.",
"Your email address was removed from the list of subscriptors." => "Ваш адрес был удалён из списка подписчиков.",
"Subscription confirmed!" => "Подписка подтверждена!",
"Subscribe to Newsletter" => "Подписаться на рассылку",
"Subscribe to this Newsletter" => "Подписаться",
"Available Newsletters" => "Доступные рассылки",
"Notes" => "Примечания",
"Write a note" => "Написать записку",
"quota" => "лимит",
"No notes yet" => "Заметок нет",
"Merge selected notes into" => "Объединить выбранные заметки в",
"Reading note:" => "Читаем записку:",
"List notes" => "Перечень записок",
"Write note" => "Написать записку",
"Wiki Create" => "Создать wiki",
"Wiki Overwrite" => "Обновить wiki",
"Assign permissions to " => "Назначить права доступа для ",
"Edit Permissions" => "Редактирование прав доступа",
"Assign permissions to this object" => "Назначить права доступа к объекту",
"Orphan Pages" => "Страницы-сироты",
"Browser not supported" => "Браузер не поддерживается",
"Rename" => "Переименовать",
"Similar" => "Подобные",
"Slides" => "Слайды",
"Discuss" => "Обсудить",
"Attach File" => "Вложить файл",
"1 File Attached" => "1 файл во вложении",
"{\$atts|@count} files attached" => "{\$atts|@count} файлов во вложении",
"version" => "версия",
"Rollback to this version" => "Вернуться к версии",
"Edit Comment" => "Комментарий",
"Pick your avatar" => "Выберите аватару",
"Your current avatar" => "Ваша аватара",
"Pick avatar from the library" => "Выберите аватару из библиотеки",
"Pick user Avatar" => "Выберите аватару для пользователя",
"Hide all" => "Скрыть все",
"Upload your own avatar" => "Закачайте свою аватару на сервер",
"Body" => "Тело документа",
"Vote poll" => "Проголосовать",
"Other Polls" => "Другие опросы",
"votes" => "голоса",
"Print multiple pages" => "Печать нескольких страниц",
"Add Page" => "Добавить страницу",
"Quiz result stats" => "Статистика по результатам теста",
"Time" => "Время",
"User answers" => "Ответы пользователей",
"Stats for quizzes" => "Статистика для тестов",
"taken" => "пройден",
"Av score" => "Ср.очки",
"Av time" => "Ср.время",
"Clear Stats" => "Очистить статистику",
"time taken" => "потраченное время",
"P/F" => "П/Ф",
"Passed" => "Зачет",
"Stats for this quiz Questions " => "Статистика по вопросам этого теста ",
"Average" => "В среднем",
"Top 10" => "Лучшие 10",
"Top 20" => "Лучшие 20",
"Top 50" => "Лучшие 50",
"Top 100" => "Лучшие 100",
"Rank" => "Место",
"star" => "звезда",
"half star" => "полузвезда",
"Received articles" => "Полученные статьи",
"Edit received article" => "Редактировать полученную статью",
"Use Image" => "Использовать изображение",
"Image x size" => "Размер изображения по горизонтали",
"Image y size" => "Размер изображения по вертикали",
"Image name" => "Наименование изображения",
"Accept Article" => "Подтвердить статью",
"Site" => "Сайт",
"Received Pages" => "Полученные страницы",
"Edit Received Page" => "Редактировать полученную страницу",
"Received Structures" => "Полученные структуры",
"Referer stats" => "Статистика по Referer",
"Last" => "Последние",
"Register as a new user" => "Зарегистрироваться, как новый пользователь",
"The following site was added and validation by admin may be needed before appearing on the lists" => "Следующий сайт был добавлен и может потребоваться проверка админом перед тем, как ссылка появится в списках",
"Send me my Password" => "Отправьте мне мой пароль",
"Request Password Reset" => "Запрос пароля",
"Last Version" => "Последняя версия",
"Back to page" => "Вернуться к странице",
"You are about to remove the page" => "Вы собрались удалить страницу",
"permanently" => "навсегда",
"Remove all versions of this page" => "Удалить все версии этой страницы",
"Rollback page" => "Откат страницы",
"Searched" => "Произведён поиск",
"Search in" => "Искать в",
"No pages matched the search criteria" => "Ни одна страница не соответствует запросу",
"All dates" => "Все даты",
"This newsletter will be sent to {\$subscribers} email addresses." => "Новость будет отправлена на {\$subscribers} e-mail адреса.",
"Prepare a newsletter to be sent" => "Подготовьте письмо к отправке",
"Apply content template" => "Применить шаблон",
"Attached Files" => "Вложенные файлы",
"remove" => "удалить",
"To add a file, click here" => "Нажмите здесь для добавления файла",
"Save as Draft" => "Сохранить как черновик",
"Send Articles" => "Отправить статьи",
"Post or edit a message" => "Разместить или изменить сообщение",
"Location : " => "Расположение : ",
"page: %0/%1" => "страница: %0/%1",
"Last edited by" => "Отредактировано",
"Clean" => "Очистить",
"Params" => "Параметры",
"Site Stats" => "Статистика сайта",
"Total pageviews" => "Число просмотров",
"Average pageviews per day" => "В среднем за день просмотров",
"Wiki Stats" => "Статистика Wiki",
"Size of Wiki Pages" => "Размер страниц Wiki",
"Average page length" => "Средний размер страницы",
"Average versions per page" => "Среднее число версий на страницу",
"Visits to wiki pages" => "Посещения страниц Wiki",
"Average links per page" => "Среднее число ссылок на странице",
"Image galleries Stats" => "Статистика фотогалерей",
"Average images per gallery" => "Среднее число изображений на галерею",
"Total size of images" => "Общее число изображений",
"Average image size" => "Средний размер изображения",
"Visits to image galleries" => "Посещений в фотогалереях",
"File galleries Stats" => "Статистика файловых галерей",
"Average files per gallery" => "Среднее число файлов на галерею",
"Total size of files" => "Суммарный размер файлов",
"Average file size" => "Средний размер файла",
"Visits to file galleries" => "Число посещений галерей",
"CMS Stats" => "CMS статистика",
"Total reads" => "Общее число прочтений",
"Average reads per article" => "Среднее число прочтений на 1 статью",
"Total articles size" => "Суммарный размер статей",
"Average article size" => "Средний размер статьи",
"Forum Stats" => "Статистика форума",
"Total topics" => "Всего тем",
"Average topics per forums" => "Средне число тем на форуме",
"Visits to forums" => "Посещения форумов",
"Blog Stats" => "Статистика блогов",
"Weblogs" => "Веблоги",
"Total posts" => "Суммарное количество сообщений",
"Total size of blog posts" => "Суммарный размер всех сообщений",
"Average posts size" => "Средний размер сообщения",
"Visits to weblogs" => "Посещений веблогов",
"Poll Stats" => "Статистика опросов",
"Total votes" => "Всего отдано голосов",
"Average votes per poll" => "В среднем число голосов на опрос",
"Total questions" => "Всего вопросов",
"Average questions per FAQ" => "В среднем вопросов на 1 ЧаВо",
"User Stats" => "Статистика пользователей",
"Average bookmarks per user" => "Среднее число закладок на пользователя",
"Average questions per quiz" => "Среднее число вопросов на тест",
"Quizzes taken" => "Пройдено тестов",
"Average quiz score" => "Среднее число баллов на тест",
"Average time per quiz" => "Среднее время на прохождение теста",
"Usage chart" => "График использования",
"Stats for surveys" => "Статистика по анкетам",
"Last taken" => "Последний раз пройден",
"Tiki Logs" => "Протоколы Tiki",
"Clean logs older than" => "Удалить протоколы старше чем",
"Time Left" => "Времени осталось",
"Send Answers" => "отослать ответы",
"Your email was sent" => "Ваш email был отправлен",
"Theme is selected as follows" => "Тема выбирается по следующему принципу",
"If a theme is assigned to the individual object that theme is used." => "Используется тема, назначенная к конкретному объекту, если есть.",
"If not then if a theme is assigned to the object's category that theme is used" => "Если такой нет, то используется тема, назначенная категории объекта.",
"If not then a theme for the section is used" => "В противном случае берётся тема для секции.",
"If none of the above was selected the user theme is used" => "Если ни одна из выше перечисленных не найдена, используется тема заданная пользователем.",
"Finally if the user didn't select a theme the default theme is used" => "И, наконец, если пользователь не выбирал свою тему, используется тема сайта по умолчанию",
"Control by Sections" => "Управление по секциям",
"Assign themes to categories" => "Назначить темы для категорий",
"Assigned categories" => "Назначенные категории",
"Theme Control Center: Objects" => "Центр управления темами: Объекты",
"Control by Categories" => "Управлять по категории",
"Assign themes to objects" => "Назначить тема к объектам",
"Assigned objects" => "Назначенные объекты",
"Assign themes to sections" => "Назначить темы секциям",
"Assigned sections" => "Назначенные секции",
"The following file was successfully uploaded" => "Файл был успешно закачан",
"You can download this file using" => "Вы можете скачать файл, используя",
"Add File" => "Добавить файл",
"Batch Upload Results" => "Результат пакетной закачки",
"Upload successful!" => "Закачка завершена!",
"The following image was successfully uploaded" => "Следующее изображение было успешно закачено",
"You can view this image in your browser using" => "Вы сможете увидеть это изображение, используя",
"You can include the image in an Wiki page using" => "Ссылка для вставки изображения в Wiki страницах",
"or use filename" => "по имени файла",
"Now enter the image URL" => "Теперь введите URL изображения",
"or upload a local image from your disk" => "или закачайте изображение с Вашего диска",
"Batch Upload" => "Пакетная закачка",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Иконка (необязательная, заменяет автоматическую генерацию иконок)",
"You have to create a gallery first!" => "Сначала надо создать галерею!",
"User assigned modules" => "Назначенные пользователем модули",
"Restore defaults" => "Восстановить умолчания",
"The column is disabled" => "Столбец отключен",
"act" => "акт",
"Assign module" => "Назначить модуль",
"top" => "лучшие",
"Folders" => "Папки",
"Remove Folder" => "удалить папку",
"Refresh Cache" => "обновить кеш",
"Admin folders and bookmarks" => "Управление папками и закладками",
"a folder" => "папку",
"Send me a message" => "Написать письмо",
"Assign Group" => "Назначить группу",
"Change user preferences" => "Изменить предпочтения пользователя",
"(non public)" => "(приватный)",
"Users HomePage" => "Пользовательские домашние страницы",
"Personal Wiki Page" => "Персональная Wiki страница",
"The user requested friendship with you" => "Это пользователь хочет с вами дружить",
"Accept friendship from this user" => "Дружить с этим пользователем",
"Refuse friendship from this user" => "Отклонить приглашение в дружбе с этим пользователем",
"Currently waiting for user approval" => "Ожидаем подтверждения пользователя",
"Cancel friendship request towards this user" => "Запрос на отмену дружбы с этим пользователем",
"Request friendship from this user" => "Подружиться с этим пользователем",
"Forum comments" => "Комментарии на форуме",
"Personal Information" => "Личная информация",
"Male" => "Мужчина",
"Female" => "Женщина",
"Use Google Map locator" => "Используйте Google Map locator",
"View extra information" => "Просмотр дополнительной информации",
"Is email public? (uses scrambling to prevent spam)" => "Показывать e-mail? (используется скремблерование для защиты от спама)",
"Unavailable - please set your e-mail below" => "Недоступно - пожалуйста, введите адрес электронной почты ниже",
"Does your mail reader need a special charset" => "Установить специальную кодировку для писем",
"Detect user timezone if browser allows, otherwise site default" => "Определить автоматически. В противном случае взять установки сайта",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "Отображать публичную информацию пользователя в всплывающем окне при наведении указателя мышки на его имя",
"Notify sender when reading his mail" => "Уведомить автора при прочтении письма",
"Auto-archive read messages after x days" => "Архивировать прочитанные сообщения после x дней",
"never" => "никогда",
"My user items" => "Мои пользовательские записи",
"My level" => "Мой уровень",
"Account Information" => "Информация об учетной записи",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Чтобы сохранить старый пароль, остаьте поля \"Новый пароль\" и \"Подтвердите новый пароль\" пустыми",
"New task" => "Новая задача",
"Task list" => "Список задач",
"Admin mode off" => "Выкл.режим администратора",
"Admin mode on" => "Вкл.режим администратора",
"Task help" => "Помощь по задачам",
"Empty Trash" => "Очистить корзину",
"Received task" => "Внешняя задача",
"You received this task, please read and execute it" => "Вы получили эту задачу, пожалуйста, прочтите и выполните ее",
"Send task" => "Отправленная задача",
"You send this task to a other user" => "Вы отправили эту задачу другому пользователю",
"Shared task" => "Общая задача",
"This task is public to a special group" => "Эта задача является общей для специальной группы",
"Accepted by Task User and Creator" => "Принята участником и владельцем",
"Accepted User and Creator" => "Принята участником и владельцем",
"Task is accepted by user and creator" => "Задача принята участником и владельцем",
"Not Accepted by One User" => "Не принята одним из участников",
"Not Accepted User" => "Не принята участником",
"Task is rejected by one user" => "Задача не принята одним из участников",
"Waiting for Me" => "Ожидаем меня",
"Task is not accepted by you, read the task and accept or reject it" => "Задача не принята вами, прочтите и подтвердите или откажите ее",
"Waiting for Other User" => "Ожидаем другого участника",
"Task is not accepted/rejected by other user" => "Задача не принята или отвергнута другим участником",
"Admin Mode" => "Режим администратора",
"Edit Task" => "Редактировать Задачу",
"NOT accept" => "НЕ принято",
"Remove from Trash" => "Удалить из корзины",
"Move into Trash" => "Переместить в корзину",
"Task saved" => "Задача сохранена",
"View Task" => "Просмотр Задачи",
"Open a new task" => "Создать новую задачу",
"taskId" => "Id задачи",
"Task user" => "Участник задачи",
"Only the creator can delete this task" => "Только владелец может удалить эту задачу",
"Use start date and time" => "Установить дату и время начала",
"Use end date and time" => "Установить дату и время окончания",
"Open / In Process" => "Открыта / В процессе",
"Waiting / Not Started" => "Ожидание / Не начата",
"Percentage completed" => "Процент выполнения",
"Shared for Group" => "Общая для группы",
"Accepted by User" => "Принята участником",
"No / Rejected" => "Нет / Отказана",
"Accepted by Creator" => "Принята владельцем",
"This message will be send to users if you are makeing changes of assigned tasks" => "Это сообщение будет отправлено участникам если в задачи будут внесены изменения",
"Send message with changes" => "Отправлять сообщение с изменениями",
"Modified by" => "Изменено",
"Marked as deleted" => "Помечено к удалению",
"Inform task user by email" => "Уведомить участника по эл.почте",
"You can only view this task" => "Вы можете только просмотреть задачу",
"Completed" => "Завершено",
"%m/%d/%Y [%H:%M]" => "%d.%m.%Y [%H:%M]",
"No tasks entered" => "Задачи не определены",
"Select One" => "Сделайте выбор",
"Undo Trash" => "Вернуть из корзины",
"Received" => "Получено",
"Submitted" => "Подтверждено",
"Shared" => "Общее",
"All Shared Tasks" => "Все общие задачи",
"completed (100%)" => "выполнено (100%)",
"Monthly" => "Ежемесячно",
"Add Watch" => "Добавить наблюдение",
"Select event type" => "Тип события",
"All watched events" => "Все события",
"A user submits an article" => "Пользователь помещает статью",
"A user edited an article" => "Редактирование статьи",
"A user deleted an article" => "Удаление статьи",
"A user submits a blog post" => "Новая запись в блоге",
"A user posts a forum thread" => "Новый ответ в форуме",
"A user posts a forum topic" => "Новая тема в форуме",
"A user edited a wiki page" => "Редактирование страницы",
"A user created a wiki page in a language" => "Создание страницы на языке",
"A user edits an article" => "Пользователь редактирует статью",
"A user deletes an article" => "Пользователь удаляет статью",
"up to" => "до",
"no limit for admin" => "без ограничений для администратора",
"May need to refresh twice to see changes" => "Возможно потребуется обновить страницу дважды чтобы увидеть изменения",
"Add top level bookmarks to menu" => "Добавить закладки верхнего уровня в меню",
"Add or edit an item" => "Добавить или редактировать элемент",
"New Window" => "в новом окне",
"replace window" => "заменить окно",
"User_versions_for" => "Версия_пользователя_для",
"Add an article" => "Добавить статью",
"Banner stats" => "Баннер статистика",
"Create new banner" => "Создать новый баннер",
"Banner Information" => "Баннер информация",
"Click ratio" => "Процент нажатий",
"Weekdays" => "Дни недели",
"mon" => "пн",
"tue" => "вт",
"wed" => "ср",
"thu" => "чт",
"fri" => "пт",
"sat" => "сб",
"sun" => "вс",
"Banner raw data" => "Двоичные данные баннера",
"Edit Blog" => "Редактировать Блог",
"Monitor this Blog" => "наблюдать за блогом",
"Stop Monitoring this Blog" => "прекратить наблюдение",
"Cached" => "Кешируется",
"This is a cached version of the page." => "Это кешированная версия страницы.",
"Answers" => "Ответы",
"Add Suggestion" => "Добавить вопрос",
"Forum List" => "Список форумов",
"Edit Forum" => "Правка форума",
"Manage Message Queue" => "Управление очередью сообщений",
"Manage Reported Messages" => "Управление отмеченными сообщениями",
"Monitor Topics of this Forum" => "Следить за темами в этом форуме",
"Stop Monitoring Topics of this Forum" => "Отменить слежение за темами в этом форуме",
"Monitor Topics and Threads of this Forum" => "Следить за темами и обсуждениями в этом форуме",
"Stop Monitoring Topics and Threads of this Forum" => "Отменить слежение за темами и обсуждениями в этом форуме",
"Group Monitor Topics of this Forum" => "Групповое слежение за темами в этом форуме",
"Group Monitor Topics and Threads of this Forum" => "Групповое слежение за темами и обсуждениями в этом форуме",
"Post New" => "Создать новую",
"Watch for replies" => "Следить за ответами",
"Send me an e-mail when someone replies to my topic" => "Отправить сообщение по эл.почте",
"Don't send me any e-mails" => "Не отправлять сообщение по эл.почте",
"for links" => "для ссылок",
"HTML tags are not allowed inside posts" => "HTML-теги не допускаются внутри сообщений",
"Moderator Actions" => "Действия модератора",
"Move Selected Topics" => "Переместить отмеченные темы",
"Unlock Selected Topics" => "Разблокировать отмеченные темы",
"Lock Selected Topics" => "Заблокировать отмеченные темы",
"Delete Selected Topics" => "Удалить отмеченные темы",
"Merge" => "Объединить",
"Merge Selected Topics" => "Объединить отмеченные темы",
"Queued Messages:" => "Сообщений в очереди:",
"pts" => "очки",
"Forum Lock" => "Форум заблокирован",
"Unarchive" => "Разархивировать",
"No topics yet" => "Тем пока нет",
"posts in this forum" => "ответов на форуме",
"Filter Posts" => "Отфильтровать ответы",
"Posts Filtering" => "Фильтр для сообщений",
"Last post date" => "Время",
"All posts" => "Все сообщения",
"Last hour" => "Последний час",
"Last 24 hours" => "Последние 24 часа",
"Last 48 hours" => "Последние 48 часов",
"Show archived posts" => "Показать заархивированные сообщения",
"Containing posts by" => "Автор",
"Me" => "Мои",
"normal" => "обычный",
"announce" => "объявление",
"hot" => "горячая новость",
"Posts with no replies" => "Сообщения без ответов",
"Archived" => "Архив",
"Topic List" => "Список тем",
"prev topic" => "пред. тема",
"next topic" => "след. тема",
"Print this page only" => "Распечатать только эту страницу",
"Print all pages" => "Распечатать все страницы",
"Show posts" => "Показать сообщения",
"Jump to forum" => "Перейти в форум",
"Tiki Sheet" => "Tiki Лист",
"Monitor" => "Наблюдение",
"Stop Monitor" => "Остановить слежение",
"Insert New Item" => "Вставить новый элемент",
"Edit Fields" => "Редактировать поля",
"Tracker Items" => "Элементы Трекера",
"View inserted item" => "Просмотреть добавленную запись",
"Insert new item" => "Вставить новый элемент",
"View Item" => "Просмотр",
"Add a Comment" => "Добавить комментарий",
"Edit/Delete" => "Редактировать/Удалить",
"Special Operations" => "Специальные операции",
"close" => "закрыть",
"Show All" => "Показать все",
"Show Unread" => "Показать непрочтённые",
"Show Flagged" => "Показать отмеченные",
"Refresh now" => "Обновить сейчас",
"Back To Mailbox" => "Вернуться в почтовый ящик",
"Full Headers" => "Полные заголовки",
"Normal Headers" => "Обычный вид",
"Reply To All" => "Ответить всем",
"Forward" => "Переслать",
"Cc" => "Копия (СС)",
"Select from address book" => "Выбрать из адр.книги",
"Use HTML mail" => "Использовать HTML почту",
"The following addresses are not in your address book" => "Следующие адреса отсутствуют в вашей адресной книге",
"Add Contacts" => "добавить контакты",
"Attachment 1" => "Приложить файл 1",
"Attachment 2" => "Приложить файл 2",
"Attachment 3" => "Приложить файл 3",
"Address book" => "Адресная книга",
"TOC" => "Содержимое",
"Parent page" => "Родительская страница",
"Child" => "Потомок",
"page id" => "id страницы",
"Message sent to" => "Отправлено сообщение для",
"Page last modified on %0 by %1" => "Последнее изменение страницы %0 автор %1",
"Created by %0" => "Создано %0",
"Last Modification: %0 by %1" => "Последнее изменение: %0 автор %1",
"as Creator &amp; Last Editor" => "как Автор &amp; Последний Редактор",
"no (disabled)" => "нет (отключено)",
"Save Minor Edit" => "Мелочь",
"Save Draft" => "Созранить черновик",
"Administration" => "Администрирование",
"Enable/disable Tiki features here, but configure them elsewhere" => "Здесь только включение / выключение функций Tiki. Настройка производится в других разделах",
"General preferences and settings" => "Общие настройки и предпочтения",
"User registration, login and authentication" => "Регистрация пользователей, настройка параметров входа и метода аутентификации",
"Wiki settings" => "Настройки Wiki",
"Poll comments settings" => "Комментарии в опросах",
"Forums settings" => "Настройки форумов",
"Customize look and feel of your Tiki" => "Настройте внешний вид вашего Tiki",
"Upload failed" => "Закачка не удалась",
"All posted" => "Все опубликованные",
"Queue anonymous posts" => "Анонимные сообщения в очередь",
"Queue all posts" => "Все сообщения в очередь",
"No attachments" => "Нет вложений",
"Everybody can attach" => "Любой может сделать вложение",
"Only users with attach permission" => "Только пользователи с правами вложения",
"Moderators and admin can attach" => "Делать вложения могут модераторы и админы",
"Date (desc)" => "Дата (по убыванию)",
"Date (asc)" => "Дата (asc)",
"Score (desc)" => "Рейтинг (по убыванию)",
"Replies (desc)" => "Ответы (по убыванию)",
"Reads (desc)" => "Прочтено (по убыванию)",
"Owner" => "Владелец",
"Tag already exists" => "Метка уже существует",
"Tag not found" => "Метка не существует",
"Non-existent link" => "Ссылки не существует",
"No menu indicated" => "Меню не указано",
"No newsletter indicated" => "Не указано письмо рассылки",
"A user registers" => "Пользователь регистрируется",
"Any wiki page is changed" => "Изменение любой wiki страницы",
"Any wiki page is changed, even minor changes" => "Любые изменения любой wiki страницы",
"A comment in a wiki page is posted or edited" => "Добавление или изменение комментария на wiki странице",
"PHP error" => "ошибка PHP",
"No poll indicated" => "Опрос не указан",
"You do not have permission to view this page." => "У Вас недостаточно прав для просмотра этой страницы",
"You do not have permission to edit this page." => "У Вас недостаточно прав для редактирования данной страницы",
"page not added (Exists)" => "страница не добавлена (Существует)",
"No survey indicated" => "Не указана анкета",
"No tracker indicated" => "Трекер не указан",
"Group already exists" => "Группа уже существует",
"User doesn't exist" => "Пользователь не существует",
"No records were found. Check the file please!" => "Записей не найдено. Проверьте пожалуйста файл!",
"User login is required" => "Логин пользователя обязателен",
"Email is required" => "Эл.адрес обязателен",
"User is duplicated" => "Пользователь скопирован",
"The passwords do not match" => "Пароли не совпадают",
"password" => "пароль",
"Unknown group" => "Неизвестная группа",
"Group doesn't exist" => "Группа не существует",
"The page cannot be found" => "Страница не найдена",
"It isn't possible to post in any blog. You may need to create a blog first." => "Вы не можете размещать сообщения. Наверное, следует создать хотя бы один блог.",
"You do not have permission to edit this post" => "У Вас недостаточно прав для редактирования данного сообщения",
"Top visited blogs" => "Лучшие блоги",
"Last posts" => "Последние сообщения",
"Top active blogs" => "Последние активные блоги",
"TOP" => "Верхний уровень",
"You do not have permission to access this gallery" => "У Вас недостаточно прав для доступа к этой галерее",
"No gallery indicated" => "Галерея не указана",
"You do not have permission to remove images from this gallery" => "У Вас недостаточно прав для удаления изображений из этой галереи",
"You do not have permission to rebuild thumbnails in this gallery" => "У Вас недостаточно прав для перестройки иконок этой галереи",
"You do not have permission to rotate images in this gallery" => "У Вас недостаточно прав для прокручивания изображений этой галереи",
"No image indicated" => "Изображение не указано",
"picture not found" => "рисунок не найден",
"You do not have permission to move images from this gallery" => "У Вас недостаточно прав для перемещения изображений из этой галереи",
"You do not have permission to view the calendar" => "Доступ закрыт, вы не можете просмотреть календарь",
"You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>" => "Необходимо <a href=\"tiki-admin_calendars.php\">создать календарь</a>",
"event without name" => "событие без имени",
"You can not use the same password again" => "Не следует использовать один и тот же пароль дважды",
"Invalid old password" => "Старый пароль не подошёл",
"Top authors" => "Лучшие авторы",
"Must enter a name to add a site" => "Следует ввести название, чтобы добавить сайт",
"Must enter a url to add a site" => "Следует ввести ссылку, чтобы добавить сайт",
"URL already added to the directory. Duplicate site?" => "Ссылка уже добавлена в каталог. Вы вводите дубликат?",
"Must select a category" => "Следует выбрать категорию",
"No site indicated" => "Сайт не указан",
"Article not found" => "Статья не найдена",
"You do not have permission to edit this article" => "У Вас недостаточно прав для редактирования этой статьи",
"Banner not found" => "Баннер не найден",
"You do not have permission to edit this banner" => "У Вас недостаточно прав для редактирования этого баннера",
"You do not have permission to edit this blog" => "У Вас недостаточно прав для редактирования этого блога",
"You do not have permission to write the style sheet" => "У вас недостаточно прав для записи страницы стилей",
"Invalid request to edit an image" => "Неверный запрос на редактирование изображения",
"You have permission to edit images but not in this gallery" => "У Вас есть права на редактирование изображений, но, увы, не в этой галерее",
"Failed to edit the image" => "Не удалось отредактировать изображение",
"No content id indicated" => "Не указан id содержимого",
"No question indicated" => "Вопрос не указан",
"No quiz indicated" => "Тест не указан",
"No structure indicated" => "Структура не указана",
"You do not have permission to edit submissions" => "У Вас недостаточно прав для редактирования поступлений",
"You have to create a topic first" => "Сначала надо создать тему",
"You do not have permission to do that" => "У Вас недостаточно прав для этого действия",
"You do not have permission to read the template" => "У Вас недостаточно прав для чтения шаблона",
"page imported" => "страница импортирована",
"created from import" => "создано импортом",
"The SandBox is disabled" => "Пользование Песочницей запрещено",
"Cannot edit page because it is locked" => "Невозможно редактировать заблокированную страницу",
"You do not have permission to edit this file" => "Отказано в доступе, Вы не можете редактировать этот файл",
"You do not have permission to remove files from this gallery" => "У Вас недостаточно прав для удаления файлов из галереи",
"No forum indicated" => "Форум не указан",
"Last forum topics" => "Последние темы форума",
"Top topics" => "Лучшие темы",
"Forum posts" => "Число сообщений в форуме",
"first image" => "первая картинка",
"last image" => "последняя картинка",
"You do not have permission to create galleries and so you cannot edit them" => "У Вас недостаточно прав для создания галерей и Вы не можете редактировать их",
"You do not have permission to edit this gallery" => "У Вас недостаточно прав для редактирования этой галереи",
"You do not have permission to remove this gallery" => "У Вас недостаточно прав для удаления этой галереи",
"overwriting old page" => "запись поверх старой страницы",
"page created" => "страница создана",
"You do not have permission to remove articles" => "У Вас недостаточно прав для удаления статей",
"You do not have permission to remove banners" => "У Вас недостаточно прав для удаления баннеров",
"You do not have permission to remove this blog" => "У Вас недостаточно прав для удаления этого блога",
"Non-existent gallery" => "Галерея не существует",
"You have permission to upload files but not to this file gallery" => "Вам разрешено закачивать файлы, но, увы, не в эту галерею",
"You do not have permission to upload files so you cannot edit them" => "Отказано в доступе, Вы не можете закачивать файлы, поэтому не можете их редактировать",
"Account disabled" => "Учетная запись отключена",
"edit" => "правка",
"File not found" => "Файл не найден",
"About" => "О нас",
"You must log in to use this feature" => "Следует войти под своим логином для этой возможности",
"You do not have permission to view other users data" => "У Вас недостаточно прав для просмотра данных других пользователей",
"You must be logged in to subscribe to newsletters" => "Для подписки на новости Вам следует войти под Вашими логином и паролем",
"No note indicated" => "Заметка не указана",
"File is too big" => "Файл слишком велик",
"No item indicated" => "Элемент не указан",
"created from notepad" => "создано в блокноте",
"Page already exists" => "Страница уже существует",
"Not enough information to display this page" => "Недостаточно информации для отображения этой страницы",
"No article indicated" => "Статья не указана",
"Article is not published yet" => "Статья ещё не публиковалась",
"No post indicated" => "Сообщение не указано",
"Blog not found" => "Блог не найден",
"No pages indicated" => "Страницы не указаны",
"No result indicated" => "Результат не указан",
"Invalid or unknown username" => "Неизвестное или неверное имя пользователя",
"A password reminder email has been sent " => "Письмо с паролем было отправлено ",
"to the email" => "на эл.адрес",
"to the registered email address for" => "на зарегистрированный e-mail адрес для",
"last version" => "последняя версия",
"Non-existent version" => "Версия не существует",
"Error Message" => "Сообщение об ошибке",
"successfully sent" => "успешно отправлено",
"not sent" => "не отправлено",
"Error: " => "Ошибка: ",
"Page must be defined inside a structure to use this feature" => "Страница должна быть внутри структуры для использования этой возможности",
"Clean the sql logs" => "Очистка протоколов SQL запросов",
"You cannot take this quiz twice" => "Вы не можете пройти этот тест дважды",
"Quiz time limit exceeded quiz cannot be computed" => "Время прохождения теста истекло. Результаты рассчитываться не будут.",
"You cannot take this survey twice" => "Нельзя пройти этот опрос дважды",
"Please create a category first" => "Сначала надо создать категорию",
"No permission to upload zipped file packages" => "Нет прав для закачки zip пакетов с файлами",
"Error processing zipped image package" => "Ошибка обработки zip пакета изображений",
"No permission to upload zipped image packages" => "Нет прав для закачки zip пакетов с изображениями",
"You do not have permission to upload images" => "У Вас недостаточно прав для загрузки изображений",
"You have permission to upload images but not to this gallery" => "У Вас есть права на загрузку изображений, но, увы, не в эту галерею",
"Cannot get image from URL" => "Не получается извлечь изображение по указанному URL",
"No url indicated" => "URL не указан",
"Unknown user" => "Неизвестный пользователь",
"Password has been changed" => "Пароль был изменен",
"The passwords did not match" => "Пароли не совпали",
"no" => "нет",
"was moved into trash" => "был(а) направлен(а) в корзину",
"trashed by" => "удалено",
"open / in process" => "открыта / в процессе",
"Public for group" => "Общая для группы",
"END" => "КОНЕЦ",
"Task accepted by creator" => "Задача принята владельцем",
"Task accepted by task user" => "Задача принята участником",
"Task NOT accepted by creator" => "Задача НЕ принята владельцем",
"Task NOT accepted by task user" => "Задача НЕ принята участником",
"Sorry this task does not exist or you have no rights to view this task" => "Такой задачи не существует или у вас нет прав на участие в ней",
"Info message" => "Информационное сообщение",
"NEW Task" => "Новая задача",
"Changes on Task" => "Изменения в задаче",
"You received a new task" => "Вам поручили новую задачу",
"The priority is" => "Приоритет",
"very low" => "минимальный",
"high" => "высокий",
"very high" => "максимальный",
"You've to start your work at least on" => "Начало работ по задаче не позднее",
"You've to finish your work on" => "Окончание работ по задаче не позже",
"Login and click the link below" => "Войдите в систему и нажмите на ссылку",
"Sorry, there was an error while trying to write data into the database" => "Внимание, произошла ошибка при попытке записи в базу данных",
"A new page is created in a language" => "Создание перевода для страницы",
"Cannot upload this file not enough quota" => "Невозможно загрузить файл - превышена квота",
"No user indicated" => "Пользователь не указан",
"Non-existent user" => "Пользователь не существует",
"No banner indicated" => "Баннер не указан",
"No blog indicated" => "Блог не указан",
"No cache information available" => "Информация в кеше отсутствует",
"No faq indicated" => "ЧаВо не указан",
"No thread indicated" => "Ветка обсуждения не указана",
"Aborted" => "Отменённые",
"Top pages" => "Лучшие страницы",
"Last pages" => "Последние страницы",
"The page is empty" => "Страница пустая",
"###end###"=>"###end###");
